#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2373
#define LARGE_STATE_COUNT 649
#define SYMBOL_COUNT 402
#define ALIAS_COUNT 3
#define TOKEN_COUNT 199
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 41
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 145

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_subroutine = 42,
  anon_sym_invariant = 43,
  anon_sym_precise = 44,
  anon_sym_SEMI = 45,
  anon_sym_in = 46,
  anon_sym_out = 47,
  anon_sym_inout = 48,
  anon_sym_uniform = 49,
  anon_sym_shared = 50,
  anon_sym_attribute = 51,
  anon_sym_varying = 52,
  anon_sym_buffer = 53,
  anon_sym_coherent = 54,
  anon_sym_readonly = 55,
  anon_sym_writeonly = 56,
  anon_sym_precision = 57,
  anon_sym_highp = 58,
  anon_sym_mediump = 59,
  anon_sym_lowp = 60,
  anon_sym_centroid = 61,
  anon_sym_sample = 62,
  anon_sym_patch = 63,
  anon_sym_smooth = 64,
  anon_sym_flat = 65,
  anon_sym_noperspective = 66,
  anon_sym___extension__ = 67,
  anon_sym_typedef = 68,
  anon_sym_extern = 69,
  anon_sym___attribute__ = 70,
  anon_sym_COLON_COLON = 71,
  anon_sym_LBRACK_LBRACK = 72,
  anon_sym_RBRACK_RBRACK = 73,
  anon_sym___declspec = 74,
  anon_sym___based = 75,
  anon_sym___cdecl = 76,
  anon_sym___clrcall = 77,
  anon_sym___stdcall = 78,
  anon_sym___fastcall = 79,
  anon_sym___thiscall = 80,
  anon_sym___vectorcall = 81,
  sym_ms_restrict_modifier = 82,
  sym_ms_unsigned_ptr_modifier = 83,
  sym_ms_signed_ptr_modifier = 84,
  anon_sym__unaligned = 85,
  anon_sym___unaligned = 86,
  anon_sym_LBRACE = 87,
  anon_sym_RBRACE = 88,
  anon_sym_signed = 89,
  anon_sym_unsigned = 90,
  anon_sym_long = 91,
  anon_sym_short = 92,
  anon_sym_LBRACK = 93,
  anon_sym_static = 94,
  anon_sym_RBRACK = 95,
  anon_sym_EQ = 96,
  anon_sym_auto = 97,
  anon_sym_register = 98,
  anon_sym_inline = 99,
  anon_sym___inline = 100,
  anon_sym___inline__ = 101,
  anon_sym___forceinline = 102,
  anon_sym_thread_local = 103,
  anon_sym___thread = 104,
  anon_sym_const = 105,
  anon_sym_constexpr = 106,
  anon_sym_volatile = 107,
  anon_sym_restrict = 108,
  anon_sym___restrict__ = 109,
  anon_sym__Atomic = 110,
  anon_sym__Noreturn = 111,
  anon_sym_noreturn = 112,
  anon_sym_alignas = 113,
  anon_sym__Alignas = 114,
  sym_primitive_type = 115,
  anon_sym_enum = 116,
  anon_sym_COLON = 117,
  anon_sym_struct = 118,
  anon_sym_union = 119,
  anon_sym_if = 120,
  anon_sym_else = 121,
  anon_sym_switch = 122,
  anon_sym_case = 123,
  anon_sym_default = 124,
  anon_sym_while = 125,
  anon_sym_do = 126,
  anon_sym_for = 127,
  anon_sym_return = 128,
  anon_sym_break = 129,
  anon_sym_continue = 130,
  anon_sym_goto = 131,
  anon_sym___try = 132,
  anon_sym___except = 133,
  anon_sym___finally = 134,
  anon_sym___leave = 135,
  anon_sym_QMARK = 136,
  anon_sym_STAR_EQ = 137,
  anon_sym_SLASH_EQ = 138,
  anon_sym_PERCENT_EQ = 139,
  anon_sym_PLUS_EQ = 140,
  anon_sym_DASH_EQ = 141,
  anon_sym_LT_LT_EQ = 142,
  anon_sym_GT_GT_EQ = 143,
  anon_sym_AMP_EQ = 144,
  anon_sym_CARET_EQ = 145,
  anon_sym_PIPE_EQ = 146,
  anon_sym_DASH_DASH = 147,
  anon_sym_PLUS_PLUS = 148,
  anon_sym_sizeof = 149,
  anon_sym___alignof__ = 150,
  anon_sym___alignof = 151,
  anon_sym__alignof = 152,
  anon_sym_alignof = 153,
  anon_sym__Alignof = 154,
  anon_sym_offsetof = 155,
  anon_sym__Generic = 156,
  anon_sym_asm = 157,
  anon_sym___asm__ = 158,
  anon_sym_DOT = 159,
  anon_sym_DASH_GT = 160,
  sym_number_literal = 161,
  anon_sym_L_SQUOTE = 162,
  anon_sym_u_SQUOTE = 163,
  anon_sym_U_SQUOTE = 164,
  anon_sym_u8_SQUOTE = 165,
  anon_sym_SQUOTE = 166,
  aux_sym_char_literal_token1 = 167,
  anon_sym_L_DQUOTE = 168,
  anon_sym_u_DQUOTE = 169,
  anon_sym_U_DQUOTE = 170,
  anon_sym_u8_DQUOTE = 171,
  anon_sym_DQUOTE = 172,
  aux_sym_string_literal_token1 = 173,
  sym_escape_sequence = 174,
  sym_system_lib_string = 175,
  sym_true = 176,
  sym_false = 177,
  anon_sym_NULL = 178,
  anon_sym_nullptr = 179,
  sym_comment = 180,
  aux_sym_preproc_extension_token1 = 181,
  anon_sym_require = 182,
  anon_sym_enable = 183,
  anon_sym_warn = 184,
  anon_sym_disable = 185,
  anon_sym_rayPayloadEXT = 186,
  anon_sym_rayPayloadInEXT = 187,
  anon_sym_hitAttributeEXT = 188,
  anon_sym_callableDataEXT = 189,
  anon_sym_callableDataInEXT = 190,
  anon_sym_shaderRecordEXT = 191,
  anon_sym_rayPayloadNV = 192,
  anon_sym_rayPayloadInNV = 193,
  anon_sym_hitAttributeNV = 194,
  anon_sym_callableDataNV = 195,
  anon_sym_callableDataInNV = 196,
  anon_sym_shaderRecordNV = 197,
  anon_sym_layout = 198,
  sym_translation_unit = 199,
  sym__top_level_item = 200,
  sym__block_item = 201,
  sym_preproc_include = 202,
  sym_preproc_def = 203,
  sym_preproc_function_def = 204,
  sym_preproc_params = 205,
  sym_preproc_call = 206,
  sym_preproc_if = 207,
  sym_preproc_ifdef = 208,
  sym_preproc_else = 209,
  sym_preproc_elif = 210,
  sym_preproc_elifdef = 211,
  sym_preproc_if_in_field_declaration_list = 212,
  sym_preproc_ifdef_in_field_declaration_list = 213,
  sym_preproc_else_in_field_declaration_list = 214,
  sym_preproc_elif_in_field_declaration_list = 215,
  sym_preproc_elifdef_in_field_declaration_list = 216,
  sym_preproc_if_in_enumerator_list = 217,
  sym_preproc_ifdef_in_enumerator_list = 218,
  sym_preproc_else_in_enumerator_list = 219,
  sym_preproc_elif_in_enumerator_list = 220,
  sym_preproc_elifdef_in_enumerator_list = 221,
  sym_preproc_if_in_enumerator_list_no_comma = 222,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 223,
  sym_preproc_else_in_enumerator_list_no_comma = 224,
  sym_preproc_elif_in_enumerator_list_no_comma = 225,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 226,
  sym__preproc_expression = 227,
  sym_preproc_parenthesized_expression = 228,
  sym_preproc_defined = 229,
  sym_preproc_unary_expression = 230,
  sym_preproc_call_expression = 231,
  sym_preproc_argument_list = 232,
  sym_preproc_binary_expression = 233,
  sym_function_definition = 234,
  sym_declaration = 235,
  sym_type_definition = 236,
  sym__type_definition_type = 237,
  sym__type_definition_declarators = 238,
  sym__declaration_modifiers = 239,
  sym__declaration_specifiers = 240,
  sym_linkage_specification = 241,
  sym_attribute_specifier = 242,
  sym_attribute = 243,
  sym_attribute_declaration = 244,
  sym_ms_declspec_modifier = 245,
  sym_ms_based_modifier = 246,
  sym_ms_call_modifier = 247,
  sym_ms_unaligned_ptr_modifier = 248,
  sym_ms_pointer_modifier = 249,
  sym_declaration_list = 250,
  sym__declarator = 251,
  sym__declaration_declarator = 252,
  sym__field_declarator = 253,
  sym__type_declarator = 254,
  sym__abstract_declarator = 255,
  sym_parenthesized_declarator = 256,
  sym_parenthesized_field_declarator = 257,
  sym_parenthesized_type_declarator = 258,
  sym_abstract_parenthesized_declarator = 259,
  sym_attributed_declarator = 260,
  sym_attributed_field_declarator = 261,
  sym_attributed_type_declarator = 262,
  sym_pointer_declarator = 263,
  sym_pointer_field_declarator = 264,
  sym_pointer_type_declarator = 265,
  sym_abstract_pointer_declarator = 266,
  sym_function_declarator = 267,
  sym__function_declaration_declarator = 268,
  sym_function_field_declarator = 269,
  sym_function_type_declarator = 270,
  sym_abstract_function_declarator = 271,
  sym_array_declarator = 272,
  sym_array_field_declarator = 273,
  sym_array_type_declarator = 274,
  sym_abstract_array_declarator = 275,
  sym_init_declarator = 276,
  sym_compound_statement = 277,
  sym_storage_class_specifier = 278,
  sym_type_qualifier = 279,
  sym_alignas_qualifier = 280,
  sym_type_specifier = 281,
  sym_sized_type_specifier = 282,
  sym_enum_specifier = 283,
  sym_enumerator_list = 284,
  sym_struct_specifier = 285,
  sym_union_specifier = 286,
  sym_field_declaration_list = 287,
  sym__field_declaration_list_item = 288,
  sym_field_declaration = 289,
  sym__field_declaration_declarator = 290,
  sym_bitfield_clause = 291,
  sym_enumerator = 292,
  sym_variadic_parameter = 293,
  sym_parameter_list = 294,
  sym_parameter_declaration = 295,
  sym_attributed_statement = 296,
  sym_statement = 297,
  sym__top_level_statement = 298,
  sym_labeled_statement = 299,
  sym__top_level_expression_statement = 300,
  sym_expression_statement = 301,
  sym_if_statement = 302,
  sym_else_clause = 303,
  sym_switch_statement = 304,
  sym_case_statement = 305,
  sym_while_statement = 306,
  sym_do_statement = 307,
  sym_for_statement = 308,
  sym__for_statement_body = 309,
  sym_return_statement = 310,
  sym_break_statement = 311,
  sym_continue_statement = 312,
  sym_goto_statement = 313,
  sym_seh_try_statement = 314,
  sym_seh_except_clause = 315,
  sym_seh_finally_clause = 316,
  sym_seh_leave_statement = 317,
  sym_expression = 318,
  sym__string = 319,
  sym_comma_expression = 320,
  sym_conditional_expression = 321,
  sym_assignment_expression = 322,
  sym_pointer_expression = 323,
  sym_unary_expression = 324,
  sym_binary_expression = 325,
  sym_update_expression = 326,
  sym_cast_expression = 327,
  sym_type_descriptor = 328,
  sym_sizeof_expression = 329,
  sym_alignof_expression = 330,
  sym_offsetof_expression = 331,
  sym_generic_expression = 332,
  sym_subscript_expression = 333,
  sym_call_expression = 334,
  sym_gnu_asm_expression = 335,
  sym_gnu_asm_qualifier = 336,
  sym_gnu_asm_output_operand_list = 337,
  sym_gnu_asm_output_operand = 338,
  sym_gnu_asm_input_operand_list = 339,
  sym_gnu_asm_input_operand = 340,
  sym_gnu_asm_clobber_list = 341,
  sym_gnu_asm_goto_list = 342,
  sym_argument_list = 343,
  sym_field_expression = 344,
  sym_compound_literal_expression = 345,
  sym_parenthesized_expression = 346,
  sym_initializer_list = 347,
  sym_initializer_pair = 348,
  sym_subscript_designator = 349,
  sym_subscript_range_designator = 350,
  sym_field_designator = 351,
  sym_char_literal = 352,
  sym_concatenated_string = 353,
  sym_string_literal = 354,
  sym_null = 355,
  sym__empty_declaration = 356,
  sym_macro_type_specifier = 357,
  sym_preproc_extension = 358,
  sym_extension_behavior = 359,
  sym_extension_storage_class = 360,
  sym_layout_specification = 361,
  sym_layout_qualifiers = 362,
  sym_qualifier = 363,
  aux_sym_translation_unit_repeat1 = 364,
  aux_sym_preproc_params_repeat1 = 365,
  aux_sym_preproc_if_repeat1 = 366,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 367,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 368,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 369,
  aux_sym_preproc_argument_list_repeat1 = 370,
  aux_sym_function_definition_repeat1 = 371,
  aux_sym_declaration_repeat1 = 372,
  aux_sym_declaration_repeat2 = 373,
  aux_sym_type_definition_repeat1 = 374,
  aux_sym__type_definition_type_repeat1 = 375,
  aux_sym__type_definition_declarators_repeat1 = 376,
  aux_sym__declaration_specifiers_repeat1 = 377,
  aux_sym_attribute_declaration_repeat1 = 378,
  aux_sym_attributed_declarator_repeat1 = 379,
  aux_sym_pointer_declarator_repeat1 = 380,
  aux_sym_function_declarator_repeat1 = 381,
  aux_sym_array_declarator_repeat1 = 382,
  aux_sym_sized_type_specifier_repeat1 = 383,
  aux_sym_enumerator_list_repeat1 = 384,
  aux_sym__field_declaration_declarator_repeat1 = 385,
  aux_sym_parameter_list_repeat1 = 386,
  aux_sym_parameter_declaration_repeat1 = 387,
  aux_sym_case_statement_repeat1 = 388,
  aux_sym_generic_expression_repeat1 = 389,
  aux_sym_gnu_asm_expression_repeat1 = 390,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 391,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 392,
  aux_sym_gnu_asm_clobber_list_repeat1 = 393,
  aux_sym_gnu_asm_goto_list_repeat1 = 394,
  aux_sym_argument_list_repeat1 = 395,
  aux_sym_initializer_list_repeat1 = 396,
  aux_sym_initializer_pair_repeat1 = 397,
  aux_sym_char_literal_repeat1 = 398,
  aux_sym_concatenated_string_repeat1 = 399,
  aux_sym_string_literal_repeat1 = 400,
  aux_sym_layout_qualifiers_repeat1 = 401,
  alias_sym_field_identifier = 402,
  alias_sym_statement_identifier = 403,
  alias_sym_type_identifier = 404,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_subroutine] = "subroutine",
  [anon_sym_invariant] = "invariant",
  [anon_sym_precise] = "precise",
  [anon_sym_SEMI] = ";",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_inout] = "inout",
  [anon_sym_uniform] = "uniform",
  [anon_sym_shared] = "shared",
  [anon_sym_attribute] = "attribute",
  [anon_sym_varying] = "varying",
  [anon_sym_buffer] = "buffer",
  [anon_sym_coherent] = "coherent",
  [anon_sym_readonly] = "readonly",
  [anon_sym_writeonly] = "writeonly",
  [anon_sym_precision] = "precision",
  [anon_sym_highp] = "highp",
  [anon_sym_mediump] = "mediump",
  [anon_sym_lowp] = "lowp",
  [anon_sym_centroid] = "centroid",
  [anon_sym_sample] = "sample",
  [anon_sym_patch] = "patch",
  [anon_sym_smooth] = "smooth",
  [anon_sym_flat] = "flat",
  [anon_sym_noperspective] = "noperspective",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_auto] = "auto",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [aux_sym_preproc_extension_token1] = "preproc_extension_token1",
  [anon_sym_require] = "require",
  [anon_sym_enable] = "enable",
  [anon_sym_warn] = "warn",
  [anon_sym_disable] = "disable",
  [anon_sym_rayPayloadEXT] = "rayPayloadEXT",
  [anon_sym_rayPayloadInEXT] = "rayPayloadInEXT",
  [anon_sym_hitAttributeEXT] = "hitAttributeEXT",
  [anon_sym_callableDataEXT] = "callableDataEXT",
  [anon_sym_callableDataInEXT] = "callableDataInEXT",
  [anon_sym_shaderRecordEXT] = "shaderRecordEXT",
  [anon_sym_rayPayloadNV] = "rayPayloadNV",
  [anon_sym_rayPayloadInNV] = "rayPayloadInNV",
  [anon_sym_hitAttributeNV] = "hitAttributeNV",
  [anon_sym_callableDataNV] = "callableDataNV",
  [anon_sym_callableDataInNV] = "callableDataInNV",
  [anon_sym_shaderRecordNV] = "shaderRecordNV",
  [anon_sym_layout] = "layout",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__declaration_declarator] = "_declaration_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym__function_declaration_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym__field_declaration_declarator] = "_field_declaration_declarator",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_macro_type_specifier] = "macro_type_specifier",
  [sym_preproc_extension] = "preproc_extension",
  [sym_extension_behavior] = "extension_behavior",
  [sym_extension_storage_class] = "extension_storage_class",
  [sym_layout_specification] = "layout_specification",
  [sym_layout_qualifiers] = "layout_qualifiers",
  [sym_qualifier] = "qualifier",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_declaration_repeat2] = "declaration_repeat2",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_function_declarator_repeat1] = "function_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym__field_declaration_declarator_repeat1] = "_field_declaration_declarator_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_parameter_declaration_repeat1] = "parameter_declaration_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_layout_qualifiers_repeat1] = "layout_qualifiers_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_subroutine] = anon_sym_subroutine,
  [anon_sym_invariant] = anon_sym_invariant,
  [anon_sym_precise] = anon_sym_precise,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_inout] = anon_sym_inout,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_shared] = anon_sym_shared,
  [anon_sym_attribute] = anon_sym_attribute,
  [anon_sym_varying] = anon_sym_varying,
  [anon_sym_buffer] = anon_sym_buffer,
  [anon_sym_coherent] = anon_sym_coherent,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_writeonly] = anon_sym_writeonly,
  [anon_sym_precision] = anon_sym_precision,
  [anon_sym_highp] = anon_sym_highp,
  [anon_sym_mediump] = anon_sym_mediump,
  [anon_sym_lowp] = anon_sym_lowp,
  [anon_sym_centroid] = anon_sym_centroid,
  [anon_sym_sample] = anon_sym_sample,
  [anon_sym_patch] = anon_sym_patch,
  [anon_sym_smooth] = anon_sym_smooth,
  [anon_sym_flat] = anon_sym_flat,
  [anon_sym_noperspective] = anon_sym_noperspective,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_auto] = anon_sym_auto,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [aux_sym_preproc_extension_token1] = aux_sym_preproc_extension_token1,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_warn] = anon_sym_warn,
  [anon_sym_disable] = anon_sym_disable,
  [anon_sym_rayPayloadEXT] = anon_sym_rayPayloadEXT,
  [anon_sym_rayPayloadInEXT] = anon_sym_rayPayloadInEXT,
  [anon_sym_hitAttributeEXT] = anon_sym_hitAttributeEXT,
  [anon_sym_callableDataEXT] = anon_sym_callableDataEXT,
  [anon_sym_callableDataInEXT] = anon_sym_callableDataInEXT,
  [anon_sym_shaderRecordEXT] = anon_sym_shaderRecordEXT,
  [anon_sym_rayPayloadNV] = anon_sym_rayPayloadNV,
  [anon_sym_rayPayloadInNV] = anon_sym_rayPayloadInNV,
  [anon_sym_hitAttributeNV] = anon_sym_hitAttributeNV,
  [anon_sym_callableDataNV] = anon_sym_callableDataNV,
  [anon_sym_callableDataInNV] = anon_sym_callableDataInNV,
  [anon_sym_shaderRecordNV] = anon_sym_shaderRecordNV,
  [anon_sym_layout] = anon_sym_layout,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__declaration_declarator] = sym__declaration_declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym__function_declaration_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym__field_declaration_declarator] = sym__field_declaration_declarator,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_macro_type_specifier] = sym_macro_type_specifier,
  [sym_preproc_extension] = sym_preproc_extension,
  [sym_extension_behavior] = sym_extension_behavior,
  [sym_extension_storage_class] = sym_extension_storage_class,
  [sym_layout_specification] = sym_layout_specification,
  [sym_layout_qualifiers] = sym_layout_qualifiers,
  [sym_qualifier] = sym_qualifier,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_declaration_repeat2] = aux_sym_declaration_repeat2,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_function_declarator_repeat1] = aux_sym_function_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym__field_declaration_declarator_repeat1] = aux_sym__field_declaration_declarator_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_parameter_declaration_repeat1] = aux_sym_parameter_declaration_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_layout_qualifiers_repeat1] = aux_sym_layout_qualifiers_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subroutine] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invariant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varying] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_buffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coherent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_writeonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precision] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_highp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mediump] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lowp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_centroid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sample] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_patch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smooth] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_flat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noperspective] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_extension_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rayPayloadEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rayPayloadInEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hitAttributeEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callableDataEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callableDataInEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shaderRecordEXT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rayPayloadNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rayPayloadInNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hitAttributeNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callableDataNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callableDataInNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shaderRecordNV] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_layout] = {
    .visible = true,
    .named = false,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declaration_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_extension] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_behavior] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_storage_class] = {
    .visible = true,
    .named = true,
  },
  [sym_layout_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_layout_qualifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_declaration_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_layout_qualifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_behavior = 5,
  field_body = 6,
  field_clobbers = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constraint = 10,
  field_declarator = 11,
  field_designator = 12,
  field_directive = 13,
  field_end = 14,
  field_extension = 15,
  field_field = 16,
  field_filter = 17,
  field_function = 18,
  field_goto_labels = 19,
  field_index = 20,
  field_initializer = 21,
  field_input_operands = 22,
  field_label = 23,
  field_left = 24,
  field_member = 25,
  field_name = 26,
  field_operand = 27,
  field_operator = 28,
  field_output_operands = 29,
  field_parameters = 30,
  field_path = 31,
  field_prefix = 32,
  field_register = 33,
  field_right = 34,
  field_size = 35,
  field_start = 36,
  field_symbol = 37,
  field_type = 38,
  field_underlying_type = 39,
  field_update = 40,
  field_value = 41,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_behavior] = "behavior",
  [field_body] = "body",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_extension] = "extension",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_right] = "right",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_type] = "type",
  [field_underlying_type] = "underlying_type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 0, .length = 1},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 2},
  [12] = {.index = 12, .length = 2},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 14, .length = 1},
  [15] = {.index = 15, .length = 1},
  [16] = {.index = 5, .length = 1},
  [17] = {.index = 16, .length = 2},
  [18] = {.index = 18, .length = 2},
  [19] = {.index = 20, .length = 1},
  [21] = {.index = 21, .length = 1},
  [22] = {.index = 22, .length = 2},
  [23] = {.index = 24, .length = 2},
  [24] = {.index = 26, .length = 1},
  [25] = {.index = 27, .length = 1},
  [26] = {.index = 28, .length = 2},
  [27] = {.index = 30, .length = 2},
  [28] = {.index = 32, .length = 1},
  [29] = {.index = 33, .length = 3},
  [30] = {.index = 36, .length = 1},
  [31] = {.index = 37, .length = 1},
  [32] = {.index = 38, .length = 3},
  [33] = {.index = 41, .length = 2},
  [34] = {.index = 43, .length = 2},
  [35] = {.index = 45, .length = 3},
  [36] = {.index = 48, .length = 2},
  [37] = {.index = 50, .length = 2},
  [38] = {.index = 52, .length = 1},
  [39] = {.index = 53, .length = 2},
  [40] = {.index = 55, .length = 1},
  [41] = {.index = 56, .length = 2},
  [42] = {.index = 58, .length = 2},
  [43] = {.index = 60, .length = 2},
  [44] = {.index = 62, .length = 2},
  [45] = {.index = 64, .length = 3},
  [46] = {.index = 67, .length = 2},
  [47] = {.index = 69, .length = 2},
  [48] = {.index = 71, .length = 2},
  [49] = {.index = 73, .length = 2},
  [51] = {.index = 75, .length = 2},
  [52] = {.index = 77, .length = 1},
  [53] = {.index = 78, .length = 1},
  [54] = {.index = 79, .length = 3},
  [55] = {.index = 82, .length = 1},
  [56] = {.index = 83, .length = 1},
  [57] = {.index = 84, .length = 1},
  [58] = {.index = 85, .length = 2},
  [59] = {.index = 87, .length = 1},
  [60] = {.index = 88, .length = 3},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 2},
  [63] = {.index = 96, .length = 3},
  [64] = {.index = 99, .length = 2},
  [65] = {.index = 101, .length = 2},
  [66] = {.index = 103, .length = 2},
  [67] = {.index = 105, .length = 2},
  [68] = {.index = 107, .length = 3},
  [69] = {.index = 110, .length = 2},
  [70] = {.index = 112, .length = 2},
  [71] = {.index = 114, .length = 3},
  [72] = {.index = 117, .length = 1},
  [73] = {.index = 118, .length = 1},
  [74] = {.index = 119, .length = 2},
  [75] = {.index = 121, .length = 3},
  [76] = {.index = 124, .length = 3},
  [77] = {.index = 127, .length = 2},
  [78] = {.index = 129, .length = 2},
  [79] = {.index = 131, .length = 3},
  [80] = {.index = 134, .length = 2},
  [81] = {.index = 136, .length = 2},
  [82] = {.index = 138, .length = 2},
  [83] = {.index = 140, .length = 1},
  [84] = {.index = 141, .length = 2},
  [85] = {.index = 143, .length = 2},
  [86] = {.index = 145, .length = 4},
  [87] = {.index = 149, .length = 1},
  [88] = {.index = 150, .length = 2},
  [89] = {.index = 152, .length = 1},
  [90] = {.index = 153, .length = 1},
  [91] = {.index = 154, .length = 4},
  [92] = {.index = 158, .length = 4},
  [93] = {.index = 162, .length = 2},
  [94] = {.index = 164, .length = 2},
  [95] = {.index = 166, .length = 3},
  [96] = {.index = 169, .length = 3},
  [97] = {.index = 172, .length = 3},
  [98] = {.index = 175, .length = 2},
  [99] = {.index = 177, .length = 1},
  [101] = {.index = 178, .length = 3},
  [102] = {.index = 181, .length = 3},
  [103] = {.index = 184, .length = 2},
  [104] = {.index = 186, .length = 2},
  [105] = {.index = 188, .length = 2},
  [106] = {.index = 190, .length = 3},
  [107] = {.index = 193, .length = 2},
  [108] = {.index = 195, .length = 2},
  [109] = {.index = 197, .length = 2},
  [110] = {.index = 199, .length = 2},
  [111] = {.index = 201, .length = 3},
  [112] = {.index = 204, .length = 2},
  [113] = {.index = 206, .length = 1},
  [114] = {.index = 207, .length = 5},
  [115] = {.index = 212, .length = 2},
  [116] = {.index = 214, .length = 3},
  [117] = {.index = 217, .length = 4},
  [118] = {.index = 221, .length = 4},
  [119] = {.index = 225, .length = 2},
  [120] = {.index = 225, .length = 2},
  [121] = {.index = 227, .length = 3},
  [122] = {.index = 230, .length = 3},
  [123] = {.index = 233, .length = 3},
  [124] = {.index = 236, .length = 2},
  [125] = {.index = 238, .length = 1},
  [126] = {.index = 239, .length = 4},
  [127] = {.index = 243, .length = 3},
  [128] = {.index = 246, .length = 5},
  [129] = {.index = 251, .length = 3},
  [130] = {.index = 254, .length = 3},
  [131] = {.index = 257, .length = 2},
  [132] = {.index = 259, .length = 2},
  [133] = {.index = 32, .length = 1},
  [134] = {.index = 261, .length = 5},
  [135] = {.index = 266, .length = 4},
  [136] = {.index = 270, .length = 2},
  [137] = {.index = 272, .length = 3},
  [138] = {.index = 275, .length = 3},
  [139] = {.index = 278, .length = 2},
  [140] = {.index = 280, .length = 2},
  [141] = {.index = 282, .length = 5},
  [142] = {.index = 287, .length = 3},
  [143] = {.index = 290, .length = 2},
  [144] = {.index = 292, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_value, 1},
  [8] =
    {field_declarator, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [10] =
    {field_argument, 0},
    {field_operator, 1},
  [12] =
    {field_arguments, 1},
    {field_function, 0},
  [14] =
    {field_type, 1},
  [15] =
    {field_path, 1},
  [16] =
    {field_argument, 1},
    {field_directive, 0},
  [18] =
    {field_declarator, 1},
    {field_type, 0},
  [20] =
    {field_parameters, 0},
  [21] =
    {field_declarator, 0},
  [22] =
    {field_body, 2},
    {field_value, 1},
  [24] =
    {field_body, 2},
    {field_name, 1},
  [26] =
    {field_name, 2},
  [27] =
    {field_body, 2},
  [28] =
    {field_condition, 1},
    {field_consequence, 2},
  [30] =
    {field_body, 2},
    {field_condition, 1},
  [32] =
    {field_label, 1},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_label, 0},
  [37] =
    {field_declarator, 1},
  [38] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [41] =
    {field_declarator, 0},
    {field_parameters, 1},
  [43] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [45] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [48] =
    {field_name, 1},
    {field_value, 2},
  [50] =
    {field_name, 1},
    {field_parameters, 2},
  [52] =
    {field_condition, 1},
  [53] =
    {field_alternative, 2},
    {field_name, 1},
  [55] =
    {field_type, 0, .inherited = true},
  [56] =
    {field_declarator, 2},
    {field_type, 0},
  [58] =
    {field_left, 0},
    {field_right, 2},
  [60] =
    {field_type, 1},
    {field_value, 3},
  [62] =
    {field_declarator, 2},
    {field_type, 1},
  [64] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [67] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [69] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [71] =
    {field_name, 2},
    {field_prefix, 0},
  [73] =
    {field_name, 1},
    {field_underlying_type, 3},
  [75] =
    {field_body, 3},
    {field_name, 2},
  [77] =
    {field_name, 3},
  [78] =
    {field_body, 3},
  [79] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [82] =
    {field_initializer, 0},
  [83] =
    {field_type, 2},
  [84] =
    {field_assembly_code, 2},
  [85] =
    {field_name, 0},
    {field_type, 2},
  [87] =
    {field_declarator, 2},
  [88] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [91] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [94] =
    {field_declarator, 0},
    {field_value, 2},
  [96] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [99] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [101] =
    {field_argument, 0},
    {field_index, 2},
  [103] =
    {field_alternative, 3},
    {field_condition, 0},
  [105] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [107] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [110] =
    {field_alternative, 3},
    {field_condition, 1},
  [112] =
    {field_alternative, 3},
    {field_name, 1},
  [114] =
    {field_behavior, 3},
    {field_directive, 0},
    {field_extension, 1},
  [117] =
    {field_type, 1, .inherited = true},
  [118] =
    {field_size, 1},
  [119] =
    {field_declarator, 3},
    {field_type, 1},
  [121] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [124] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 2, .inherited = true},
  [127] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [129] =
    {field_name, 0},
    {field_value, 2},
  [131] =
    {field_body, 4},
    {field_name, 1},
    {field_underlying_type, 3},
  [134] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0, .inherited = true},
  [136] =
    {field_body, 4},
    {field_name, 3},
  [138] =
    {field_body, 1},
    {field_condition, 3},
  [140] =
    {field_update, 2},
  [141] =
    {field_initializer, 0},
    {field_update, 2},
  [143] =
    {field_condition, 1},
    {field_initializer, 0},
  [145] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [149] =
    {field_operand, 1},
  [150] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [152] =
    {field_assembly_code, 3},
  [153] =
    {field_declarator, 3},
  [154] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [158] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [162] =
    {field_declarator, 0},
    {field_size, 2},
  [164] =
    {field_declarator, 1},
    {field_declarator, 2},
  [166] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [169] =
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [172] =
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 1, .inherited = true},
  [175] =
    {field_alternative, 4},
    {field_condition, 1},
  [177] =
    {field_size, 2},
  [178] =
    {field_body, 5},
    {field_declarator, 4},
    {field_type, 3, .inherited = true},
  [181] =
    {field_body, 5},
    {field_declarator, 4},
    {field_type, 2, .inherited = true},
  [184] =
    {field_body, 2},
    {field_filter, 1},
  [186] =
    {field_declarator, 0},
    {field_declarator, 2, .inherited = true},
  [188] =
    {field_condition, 1},
    {field_update, 3},
  [190] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [193] =
    {field_initializer, 0},
    {field_update, 3},
  [195] =
    {field_condition, 2},
    {field_initializer, 0},
  [197] =
    {field_member, 4},
    {field_type, 2},
  [199] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [201] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [204] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [206] =
    {field_declarator, 4},
  [207] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [212] =
    {field_declarator, 0},
    {field_size, 3},
  [214] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [217] =
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4},
    {field_type, 1, .inherited = true},
  [221] =
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 1, .inherited = true},
  [225] =
    {field_designator, 0},
    {field_value, 2},
  [227] =
    {field_body, 6},
    {field_declarator, 5},
    {field_type, 3, .inherited = true},
  [230] =
    {field_body, 6},
    {field_declarator, 5},
    {field_type, 4, .inherited = true},
  [233] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [236] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [238] =
    {field_register, 1},
  [239] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [243] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [246] =
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4},
    {field_declarator, 5, .inherited = true},
    {field_type, 1, .inherited = true},
  [251] =
    {field_body, 7},
    {field_declarator, 6},
    {field_type, 4, .inherited = true},
  [254] =
    {field_body, 7},
    {field_declarator, 6},
    {field_type, 5, .inherited = true},
  [257] =
    {field_constraint, 0},
    {field_value, 2},
  [259] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [261] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [266] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [270] =
    {field_end, 3},
    {field_start, 1},
  [272] =
    {field_body, 8},
    {field_declarator, 7},
    {field_type, 5, .inherited = true},
  [275] =
    {field_body, 8},
    {field_declarator, 7},
    {field_type, 6, .inherited = true},
  [278] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [280] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [282] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [287] =
    {field_body, 9},
    {field_declarator, 8},
    {field_type, 6, .inherited = true},
  [290] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [292] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [1] = alias_sym_type_identifier,
  },
  [20] = {
    [0] = sym_primitive_type,
  },
  [23] = {
    [1] = alias_sym_type_identifier,
  },
  [24] = {
    [2] = alias_sym_type_identifier,
  },
  [28] = {
    [1] = alias_sym_statement_identifier,
  },
  [30] = {
    [0] = alias_sym_statement_identifier,
  },
  [35] = {
    [2] = alias_sym_field_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [0] = alias_sym_field_identifier,
  },
  [51] = {
    [2] = alias_sym_type_identifier,
  },
  [52] = {
    [3] = alias_sym_type_identifier,
  },
  [79] = {
    [1] = alias_sym_type_identifier,
  },
  [81] = {
    [3] = alias_sym_type_identifier,
  },
  [100] = {
    [1] = alias_sym_field_identifier,
  },
  [109] = {
    [4] = alias_sym_field_identifier,
  },
  [119] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 2,
  [6] = 6,
  [7] = 7,
  [8] = 4,
  [9] = 9,
  [10] = 4,
  [11] = 3,
  [12] = 12,
  [13] = 6,
  [14] = 3,
  [15] = 6,
  [16] = 2,
  [17] = 17,
  [18] = 3,
  [19] = 6,
  [20] = 4,
  [21] = 2,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 25,
  [27] = 23,
  [28] = 25,
  [29] = 29,
  [30] = 30,
  [31] = 23,
  [32] = 22,
  [33] = 29,
  [34] = 25,
  [35] = 24,
  [36] = 24,
  [37] = 23,
  [38] = 29,
  [39] = 29,
  [40] = 24,
  [41] = 22,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 45,
  [51] = 49,
  [52] = 46,
  [53] = 48,
  [54] = 48,
  [55] = 45,
  [56] = 49,
  [57] = 47,
  [58] = 48,
  [59] = 45,
  [60] = 46,
  [61] = 49,
  [62] = 47,
  [63] = 46,
  [64] = 47,
  [65] = 49,
  [66] = 45,
  [67] = 48,
  [68] = 46,
  [69] = 47,
  [70] = 70,
  [71] = 70,
  [72] = 70,
  [73] = 70,
  [74] = 70,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 105,
  [119] = 119,
  [120] = 113,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 75,
  [169] = 75,
  [170] = 75,
  [171] = 126,
  [172] = 88,
  [173] = 76,
  [174] = 122,
  [175] = 124,
  [176] = 77,
  [177] = 97,
  [178] = 124,
  [179] = 77,
  [180] = 122,
  [181] = 119,
  [182] = 105,
  [183] = 119,
  [184] = 117,
  [185] = 126,
  [186] = 95,
  [187] = 117,
  [188] = 125,
  [189] = 93,
  [190] = 97,
  [191] = 83,
  [192] = 97,
  [193] = 82,
  [194] = 80,
  [195] = 81,
  [196] = 89,
  [197] = 90,
  [198] = 80,
  [199] = 81,
  [200] = 91,
  [201] = 80,
  [202] = 81,
  [203] = 92,
  [204] = 94,
  [205] = 82,
  [206] = 83,
  [207] = 76,
  [208] = 85,
  [209] = 82,
  [210] = 96,
  [211] = 88,
  [212] = 123,
  [213] = 98,
  [214] = 89,
  [215] = 90,
  [216] = 91,
  [217] = 99,
  [218] = 92,
  [219] = 94,
  [220] = 83,
  [221] = 96,
  [222] = 98,
  [223] = 121,
  [224] = 99,
  [225] = 100,
  [226] = 101,
  [227] = 102,
  [228] = 104,
  [229] = 89,
  [230] = 107,
  [231] = 108,
  [232] = 90,
  [233] = 91,
  [234] = 100,
  [235] = 92,
  [236] = 94,
  [237] = 96,
  [238] = 103,
  [239] = 113,
  [240] = 114,
  [241] = 116,
  [242] = 101,
  [243] = 102,
  [244] = 117,
  [245] = 115,
  [246] = 105,
  [247] = 119,
  [248] = 106,
  [249] = 78,
  [250] = 122,
  [251] = 77,
  [252] = 124,
  [253] = 125,
  [254] = 98,
  [255] = 79,
  [256] = 126,
  [257] = 99,
  [258] = 116,
  [259] = 87,
  [260] = 123,
  [261] = 121,
  [262] = 113,
  [263] = 84,
  [264] = 114,
  [265] = 86,
  [266] = 115,
  [267] = 87,
  [268] = 112,
  [269] = 111,
  [270] = 110,
  [271] = 109,
  [272] = 78,
  [273] = 104,
  [274] = 79,
  [275] = 84,
  [276] = 123,
  [277] = 121,
  [278] = 86,
  [279] = 88,
  [280] = 87,
  [281] = 86,
  [282] = 107,
  [283] = 95,
  [284] = 112,
  [285] = 93,
  [286] = 85,
  [287] = 93,
  [288] = 108,
  [289] = 103,
  [290] = 106,
  [291] = 95,
  [292] = 125,
  [293] = 111,
  [294] = 110,
  [295] = 109,
  [296] = 84,
  [297] = 109,
  [298] = 106,
  [299] = 79,
  [300] = 108,
  [301] = 107,
  [302] = 78,
  [303] = 104,
  [304] = 102,
  [305] = 101,
  [306] = 100,
  [307] = 110,
  [308] = 111,
  [309] = 103,
  [310] = 115,
  [311] = 76,
  [312] = 85,
  [313] = 114,
  [314] = 116,
  [315] = 112,
  [316] = 155,
  [317] = 151,
  [318] = 154,
  [319] = 155,
  [320] = 165,
  [321] = 162,
  [322] = 159,
  [323] = 163,
  [324] = 144,
  [325] = 156,
  [326] = 157,
  [327] = 151,
  [328] = 134,
  [329] = 127,
  [330] = 149,
  [331] = 150,
  [332] = 148,
  [333] = 146,
  [334] = 152,
  [335] = 145,
  [336] = 132,
  [337] = 137,
  [338] = 131,
  [339] = 135,
  [340] = 141,
  [341] = 153,
  [342] = 143,
  [343] = 142,
  [344] = 140,
  [345] = 138,
  [346] = 128,
  [347] = 130,
  [348] = 164,
  [349] = 166,
  [350] = 160,
  [351] = 160,
  [352] = 153,
  [353] = 158,
  [354] = 154,
  [355] = 157,
  [356] = 139,
  [357] = 167,
  [358] = 158,
  [359] = 150,
  [360] = 166,
  [361] = 133,
  [362] = 129,
  [363] = 136,
  [364] = 147,
  [365] = 132,
  [366] = 164,
  [367] = 136,
  [368] = 138,
  [369] = 143,
  [370] = 146,
  [371] = 148,
  [372] = 149,
  [373] = 127,
  [374] = 161,
  [375] = 156,
  [376] = 142,
  [377] = 159,
  [378] = 162,
  [379] = 165,
  [380] = 167,
  [381] = 163,
  [382] = 144,
  [383] = 134,
  [384] = 152,
  [385] = 133,
  [386] = 145,
  [387] = 130,
  [388] = 129,
  [389] = 128,
  [390] = 139,
  [391] = 147,
  [392] = 137,
  [393] = 140,
  [394] = 131,
  [395] = 161,
  [396] = 135,
  [397] = 141,
  [398] = 140,
  [399] = 130,
  [400] = 167,
  [401] = 149,
  [402] = 129,
  [403] = 142,
  [404] = 141,
  [405] = 135,
  [406] = 131,
  [407] = 158,
  [408] = 408,
  [409] = 409,
  [410] = 159,
  [411] = 148,
  [412] = 146,
  [413] = 153,
  [414] = 154,
  [415] = 143,
  [416] = 138,
  [417] = 155,
  [418] = 136,
  [419] = 151,
  [420] = 150,
  [421] = 128,
  [422] = 147,
  [423] = 166,
  [424] = 133,
  [425] = 163,
  [426] = 127,
  [427] = 152,
  [428] = 162,
  [429] = 145,
  [430] = 156,
  [431] = 157,
  [432] = 139,
  [433] = 144,
  [434] = 134,
  [435] = 160,
  [436] = 165,
  [437] = 132,
  [438] = 137,
  [439] = 164,
  [440] = 75,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 442,
  [445] = 445,
  [446] = 441,
  [447] = 447,
  [448] = 447,
  [449] = 449,
  [450] = 450,
  [451] = 447,
  [452] = 441,
  [453] = 445,
  [454] = 445,
  [455] = 442,
  [456] = 456,
  [457] = 457,
  [458] = 457,
  [459] = 459,
  [460] = 460,
  [461] = 457,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 464,
  [466] = 464,
  [467] = 464,
  [468] = 468,
  [469] = 469,
  [470] = 469,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 471,
  [476] = 476,
  [477] = 477,
  [478] = 477,
  [479] = 479,
  [480] = 480,
  [481] = 473,
  [482] = 482,
  [483] = 473,
  [484] = 477,
  [485] = 480,
  [486] = 479,
  [487] = 477,
  [488] = 482,
  [489] = 472,
  [490] = 472,
  [491] = 476,
  [492] = 479,
  [493] = 480,
  [494] = 472,
  [495] = 479,
  [496] = 476,
  [497] = 479,
  [498] = 471,
  [499] = 474,
  [500] = 473,
  [501] = 474,
  [502] = 482,
  [503] = 474,
  [504] = 480,
  [505] = 476,
  [506] = 482,
  [507] = 471,
  [508] = 472,
  [509] = 476,
  [510] = 473,
  [511] = 480,
  [512] = 471,
  [513] = 477,
  [514] = 469,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 518,
  [520] = 517,
  [521] = 516,
  [522] = 516,
  [523] = 517,
  [524] = 516,
  [525] = 525,
  [526] = 525,
  [527] = 517,
  [528] = 525,
  [529] = 518,
  [530] = 518,
  [531] = 518,
  [532] = 517,
  [533] = 518,
  [534] = 516,
  [535] = 516,
  [536] = 536,
  [537] = 536,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 540,
  [542] = 469,
  [543] = 540,
  [544] = 540,
  [545] = 540,
  [546] = 540,
  [547] = 540,
  [548] = 540,
  [549] = 469,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 154,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 153,
  [561] = 561,
  [562] = 562,
  [563] = 130,
  [564] = 128,
  [565] = 140,
  [566] = 136,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 469,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 568,
  [579] = 553,
  [580] = 558,
  [581] = 154,
  [582] = 557,
  [583] = 556,
  [584] = 553,
  [585] = 559,
  [586] = 575,
  [587] = 558,
  [588] = 570,
  [589] = 557,
  [590] = 573,
  [591] = 136,
  [592] = 569,
  [593] = 568,
  [594] = 562,
  [595] = 567,
  [596] = 561,
  [597] = 556,
  [598] = 562,
  [599] = 130,
  [600] = 128,
  [601] = 569,
  [602] = 559,
  [603] = 567,
  [604] = 575,
  [605] = 570,
  [606] = 140,
  [607] = 136,
  [608] = 153,
  [609] = 572,
  [610] = 140,
  [611] = 128,
  [612] = 130,
  [613] = 572,
  [614] = 561,
  [615] = 571,
  [616] = 153,
  [617] = 571,
  [618] = 573,
  [619] = 154,
  [620] = 554,
  [621] = 554,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 636,
  [638] = 638,
  [639] = 636,
  [640] = 640,
  [641] = 636,
  [642] = 636,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 649,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 653,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 659,
  [663] = 663,
  [664] = 659,
  [665] = 659,
  [666] = 653,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 669,
  [671] = 671,
  [672] = 669,
  [673] = 653,
  [674] = 674,
  [675] = 659,
  [676] = 653,
  [677] = 653,
  [678] = 659,
  [679] = 679,
  [680] = 669,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 686,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 697,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 696,
  [705] = 698,
  [706] = 694,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 699,
  [712] = 697,
  [713] = 701,
  [714] = 701,
  [715] = 703,
  [716] = 702,
  [717] = 708,
  [718] = 718,
  [719] = 697,
  [720] = 699,
  [721] = 721,
  [722] = 722,
  [723] = 703,
  [724] = 724,
  [725] = 710,
  [726] = 726,
  [727] = 694,
  [728] = 710,
  [729] = 721,
  [730] = 730,
  [731] = 731,
  [732] = 696,
  [733] = 698,
  [734] = 702,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 730,
  [740] = 726,
  [741] = 741,
  [742] = 701,
  [743] = 731,
  [744] = 744,
  [745] = 745,
  [746] = 741,
  [747] = 701,
  [748] = 701,
  [749] = 710,
  [750] = 699,
  [751] = 745,
  [752] = 703,
  [753] = 721,
  [754] = 754,
  [755] = 708,
  [756] = 744,
  [757] = 708,
  [758] = 697,
  [759] = 738,
  [760] = 699,
  [761] = 726,
  [762] = 703,
  [763] = 731,
  [764] = 745,
  [765] = 737,
  [766] = 708,
  [767] = 737,
  [768] = 741,
  [769] = 738,
  [770] = 741,
  [771] = 771,
  [772] = 738,
  [773] = 731,
  [774] = 722,
  [775] = 721,
  [776] = 702,
  [777] = 731,
  [778] = 710,
  [779] = 721,
  [780] = 702,
  [781] = 698,
  [782] = 730,
  [783] = 703,
  [784] = 697,
  [785] = 698,
  [786] = 696,
  [787] = 738,
  [788] = 696,
  [789] = 741,
  [790] = 730,
  [791] = 726,
  [792] = 792,
  [793] = 694,
  [794] = 699,
  [795] = 726,
  [796] = 694,
  [797] = 708,
  [798] = 730,
  [799] = 799,
  [800] = 726,
  [801] = 694,
  [802] = 730,
  [803] = 696,
  [804] = 698,
  [805] = 702,
  [806] = 721,
  [807] = 741,
  [808] = 731,
  [809] = 738,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 816,
  [818] = 814,
  [819] = 816,
  [820] = 813,
  [821] = 814,
  [822] = 813,
  [823] = 814,
  [824] = 813,
  [825] = 816,
  [826] = 577,
  [827] = 576,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 638,
  [841] = 640,
  [842] = 635,
  [843] = 538,
  [844] = 844,
  [845] = 845,
  [846] = 845,
  [847] = 847,
  [848] = 539,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 868,
  [870] = 870,
  [871] = 871,
  [872] = 868,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 874,
  [879] = 879,
  [880] = 876,
  [881] = 874,
  [882] = 867,
  [883] = 879,
  [884] = 884,
  [885] = 885,
  [886] = 815,
  [887] = 879,
  [888] = 876,
  [889] = 867,
  [890] = 867,
  [891] = 879,
  [892] = 892,
  [893] = 874,
  [894] = 894,
  [895] = 868,
  [896] = 876,
  [897] = 897,
  [898] = 849,
  [899] = 899,
  [900] = 815,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 899,
  [905] = 901,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 538,
  [915] = 915,
  [916] = 916,
  [917] = 539,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 922,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 922,
  [929] = 922,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 922,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 815,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 965,
  [986] = 938,
  [987] = 943,
  [988] = 942,
  [989] = 989,
  [990] = 989,
  [991] = 989,
  [992] = 958,
  [993] = 941,
  [994] = 940,
  [995] = 939,
  [996] = 935,
  [997] = 855,
  [998] = 960,
  [999] = 952,
  [1000] = 989,
  [1001] = 944,
  [1002] = 855,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1007,
  [1009] = 1006,
  [1010] = 1007,
  [1011] = 1006,
  [1012] = 1012,
  [1013] = 1007,
  [1014] = 1006,
  [1015] = 1007,
  [1016] = 941,
  [1017] = 892,
  [1018] = 940,
  [1019] = 877,
  [1020] = 884,
  [1021] = 938,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 944,
  [1027] = 943,
  [1028] = 942,
  [1029] = 871,
  [1030] = 870,
  [1031] = 960,
  [1032] = 1023,
  [1033] = 939,
  [1034] = 952,
  [1035] = 897,
  [1036] = 935,
  [1037] = 1023,
  [1038] = 965,
  [1039] = 1023,
  [1040] = 958,
  [1041] = 1041,
  [1042] = 873,
  [1043] = 894,
  [1044] = 1044,
  [1045] = 855,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 885,
  [1049] = 875,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 96,
  [1053] = 87,
  [1054] = 103,
  [1055] = 106,
  [1056] = 89,
  [1057] = 90,
  [1058] = 83,
  [1059] = 125,
  [1060] = 91,
  [1061] = 92,
  [1062] = 1062,
  [1063] = 82,
  [1064] = 81,
  [1065] = 98,
  [1066] = 94,
  [1067] = 99,
  [1068] = 78,
  [1069] = 80,
  [1070] = 115,
  [1071] = 116,
  [1072] = 79,
  [1073] = 97,
  [1074] = 84,
  [1075] = 86,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1077,
  [1079] = 1077,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1077,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 935,
  [1086] = 941,
  [1087] = 952,
  [1088] = 942,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 958,
  [1092] = 1092,
  [1093] = 965,
  [1094] = 943,
  [1095] = 960,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 944,
  [1099] = 1099,
  [1100] = 938,
  [1101] = 940,
  [1102] = 1102,
  [1103] = 939,
  [1104] = 1104,
  [1105] = 965,
  [1106] = 943,
  [1107] = 935,
  [1108] = 1108,
  [1109] = 958,
  [1110] = 952,
  [1111] = 960,
  [1112] = 944,
  [1113] = 938,
  [1114] = 939,
  [1115] = 940,
  [1116] = 941,
  [1117] = 942,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1119,
  [1122] = 1122,
  [1123] = 1119,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1122,
  [1127] = 1119,
  [1128] = 1128,
  [1129] = 1122,
  [1130] = 1122,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1136,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1144,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1143,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1102,
  [1153] = 943,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 938,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 965,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 952,
  [1167] = 939,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 940,
  [1171] = 1159,
  [1172] = 1172,
  [1173] = 941,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1003,
  [1178] = 942,
  [1179] = 1162,
  [1180] = 1180,
  [1181] = 1159,
  [1182] = 1157,
  [1183] = 1159,
  [1184] = 935,
  [1185] = 1185,
  [1186] = 960,
  [1187] = 1187,
  [1188] = 1185,
  [1189] = 1157,
  [1190] = 1159,
  [1191] = 1185,
  [1192] = 1159,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1157,
  [1196] = 1012,
  [1197] = 1185,
  [1198] = 1198,
  [1199] = 958,
  [1200] = 1200,
  [1201] = 944,
  [1202] = 1202,
  [1203] = 1202,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1202,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1202,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1202,
  [1222] = 1215,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1025,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1022,
  [1231] = 1231,
  [1232] = 1024,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 954,
  [1242] = 975,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 949,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 936,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1253,
  [1256] = 961,
  [1257] = 1250,
  [1258] = 1253,
  [1259] = 945,
  [1260] = 1260,
  [1261] = 1260,
  [1262] = 1254,
  [1263] = 967,
  [1264] = 1254,
  [1265] = 978,
  [1266] = 982,
  [1267] = 1260,
  [1268] = 1254,
  [1269] = 954,
  [1270] = 1270,
  [1271] = 1253,
  [1272] = 1250,
  [1273] = 1251,
  [1274] = 979,
  [1275] = 1250,
  [1276] = 1250,
  [1277] = 1253,
  [1278] = 1251,
  [1279] = 975,
  [1280] = 1248,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1296,
  [1297] = 1297,
  [1298] = 1290,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1289,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1295,
  [1306] = 1297,
  [1307] = 1296,
  [1308] = 1287,
  [1309] = 1304,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1310,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1303,
  [1316] = 1301,
  [1317] = 1299,
  [1318] = 1294,
  [1319] = 851,
  [1320] = 1310,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1289,
  [1324] = 1293,
  [1325] = 1310,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1292,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1327,
  [1339] = 1339,
  [1340] = 1135,
  [1341] = 1322,
  [1342] = 1003,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1132,
  [1346] = 1339,
  [1347] = 1331,
  [1348] = 851,
  [1349] = 1344,
  [1350] = 1337,
  [1351] = 1282,
  [1352] = 1339,
  [1353] = 1131,
  [1354] = 1336,
  [1355] = 1339,
  [1356] = 1356,
  [1357] = 1139,
  [1358] = 1330,
  [1359] = 1344,
  [1360] = 1360,
  [1361] = 1284,
  [1362] = 1281,
  [1363] = 1363,
  [1364] = 1329,
  [1365] = 1332,
  [1366] = 1366,
  [1367] = 1300,
  [1368] = 1335,
  [1369] = 1369,
  [1370] = 1343,
  [1371] = 1334,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1376,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1380,
  [1383] = 1374,
  [1384] = 1377,
  [1385] = 1378,
  [1386] = 1386,
  [1387] = 1386,
  [1388] = 1375,
  [1389] = 1374,
  [1390] = 1378,
  [1391] = 1376,
  [1392] = 1381,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1375,
  [1397] = 1394,
  [1398] = 1380,
  [1399] = 1377,
  [1400] = 1378,
  [1401] = 1394,
  [1402] = 1374,
  [1403] = 1403,
  [1404] = 1386,
  [1405] = 1377,
  [1406] = 1394,
  [1407] = 1386,
  [1408] = 1375,
  [1409] = 1381,
  [1410] = 1380,
  [1411] = 1376,
  [1412] = 1381,
  [1413] = 1413,
  [1414] = 1413,
  [1415] = 1415,
  [1416] = 1413,
  [1417] = 1415,
  [1418] = 1415,
  [1419] = 1413,
  [1420] = 1415,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1428,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1428,
  [1435] = 1426,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1426,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1442,
  [1444] = 1444,
  [1445] = 1441,
  [1446] = 1441,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1441,
  [1451] = 1451,
  [1452] = 1441,
  [1453] = 1453,
  [1454] = 1447,
  [1455] = 1447,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1447,
  [1460] = 1460,
  [1461] = 1442,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1442,
  [1465] = 1447,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1466,
  [1471] = 1466,
  [1472] = 1467,
  [1473] = 1466,
  [1474] = 1467,
  [1475] = 1467,
  [1476] = 1466,
  [1477] = 1467,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1480,
  [1492] = 1492,
  [1493] = 1480,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1479,
  [1497] = 1479,
  [1498] = 1488,
  [1499] = 1483,
  [1500] = 1500,
  [1501] = 1500,
  [1502] = 1494,
  [1503] = 1492,
  [1504] = 1504,
  [1505] = 1483,
  [1506] = 1488,
  [1507] = 1507,
  [1508] = 1480,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1500,
  [1512] = 1483,
  [1513] = 1500,
  [1514] = 1514,
  [1515] = 1487,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1517,
  [1519] = 1519,
  [1520] = 1479,
  [1521] = 1521,
  [1522] = 1517,
  [1523] = 1517,
  [1524] = 1524,
  [1525] = 1494,
  [1526] = 1492,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1488,
  [1532] = 1532,
  [1533] = 1494,
  [1534] = 1492,
  [1535] = 1487,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1487,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1556,
  [1561] = 1556,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1559,
  [1565] = 1565,
  [1566] = 1556,
  [1567] = 1559,
  [1568] = 1559,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1571,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1580,
  [1583] = 1580,
  [1584] = 1575,
  [1585] = 1574,
  [1586] = 1586,
  [1587] = 1569,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1581,
  [1591] = 1591,
  [1592] = 1570,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1579,
  [1597] = 1589,
  [1598] = 1573,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1591,
  [1602] = 1570,
  [1603] = 1576,
  [1604] = 1575,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1600,
  [1609] = 1609,
  [1610] = 1574,
  [1611] = 1594,
  [1612] = 1594,
  [1613] = 1578,
  [1614] = 1571,
  [1615] = 1589,
  [1616] = 1609,
  [1617] = 1588,
  [1618] = 1618,
  [1619] = 1569,
  [1620] = 1595,
  [1621] = 1580,
  [1622] = 1588,
  [1623] = 1589,
  [1624] = 1581,
  [1625] = 1591,
  [1626] = 1578,
  [1627] = 1627,
  [1628] = 1593,
  [1629] = 1629,
  [1630] = 1595,
  [1631] = 1631,
  [1632] = 1588,
  [1633] = 1581,
  [1634] = 1593,
  [1635] = 1595,
  [1636] = 1593,
  [1637] = 1579,
  [1638] = 1575,
  [1639] = 1570,
  [1640] = 1571,
  [1641] = 1578,
  [1642] = 1569,
  [1643] = 1574,
  [1644] = 1594,
  [1645] = 1591,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1573,
  [1649] = 1649,
  [1650] = 1609,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1579,
  [1654] = 1654,
  [1655] = 1600,
  [1656] = 1573,
  [1657] = 1600,
  [1658] = 1609,
  [1659] = 1576,
  [1660] = 1576,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1686,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1685,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1686,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1694,
  [1704] = 1695,
  [1705] = 1695,
  [1706] = 1706,
  [1707] = 1694,
  [1708] = 1708,
  [1709] = 1685,
  [1710] = 1695,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1686,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1685,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1694,
  [1721] = 1721,
  [1722] = 1695,
  [1723] = 1686,
  [1724] = 1694,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1685,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1737,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1737,
  [1747] = 1737,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1759,
  [1763] = 1759,
  [1764] = 1758,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1759,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1758,
  [1773] = 1773,
  [1774] = 1765,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1773,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1761,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1777,
  [1788] = 1778,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1759,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1765,
  [1798] = 1773,
  [1799] = 1761,
  [1800] = 1780,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1759,
  [1804] = 1804,
  [1805] = 1758,
  [1806] = 1761,
  [1807] = 1790,
  [1808] = 1808,
  [1809] = 1760,
  [1810] = 1780,
  [1811] = 1765,
  [1812] = 1812,
  [1813] = 1778,
  [1814] = 1777,
  [1815] = 1815,
  [1816] = 1786,
  [1817] = 1773,
  [1818] = 1759,
  [1819] = 1789,
  [1820] = 1820,
  [1821] = 1786,
  [1822] = 1761,
  [1823] = 1786,
  [1824] = 1790,
  [1825] = 1790,
  [1826] = 1826,
  [1827] = 1760,
  [1828] = 1828,
  [1829] = 1780,
  [1830] = 1760,
  [1831] = 1789,
  [1832] = 1758,
  [1833] = 1765,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1837,
  [1843] = 1838,
  [1844] = 1840,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1837,
  [1852] = 1838,
  [1853] = 1840,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1859,
  [1872] = 1863,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1839,
  [1876] = 1860,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1835,
  [1885] = 1873,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1869,
  [1893] = 1850,
  [1894] = 1867,
  [1895] = 1868,
  [1896] = 1627,
  [1897] = 1848,
  [1898] = 1862,
  [1899] = 1899,
  [1900] = 1889,
  [1901] = 1849,
  [1902] = 1862,
  [1903] = 1888,
  [1904] = 1868,
  [1905] = 1869,
  [1906] = 1873,
  [1907] = 1907,
  [1908] = 1887,
  [1909] = 1909,
  [1910] = 1874,
  [1911] = 1911,
  [1912] = 1882,
  [1913] = 1913,
  [1914] = 1835,
  [1915] = 1915,
  [1916] = 1874,
  [1917] = 1917,
  [1918] = 1880,
  [1919] = 1881,
  [1920] = 1920,
  [1921] = 1881,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1882,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1880,
  [1928] = 1928,
  [1929] = 1839,
  [1930] = 1859,
  [1931] = 1931,
  [1932] = 1887,
  [1933] = 1933,
  [1934] = 1913,
  [1935] = 1880,
  [1936] = 1881,
  [1937] = 1847,
  [1938] = 1888,
  [1939] = 1846,
  [1940] = 1850,
  [1941] = 1889,
  [1942] = 1942,
  [1943] = 1845,
  [1944] = 1944,
  [1945] = 1890,
  [1946] = 1946,
  [1947] = 1882,
  [1948] = 1948,
  [1949] = 1926,
  [1950] = 1867,
  [1951] = 1886,
  [1952] = 1848,
  [1953] = 1847,
  [1954] = 1838,
  [1955] = 1955,
  [1956] = 1846,
  [1957] = 1957,
  [1958] = 1840,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1845,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1887,
  [1966] = 1888,
  [1967] = 1845,
  [1968] = 1968,
  [1969] = 1889,
  [1970] = 1837,
  [1971] = 1971,
  [1972] = 1867,
  [1973] = 1973,
  [1974] = 1846,
  [1975] = 1890,
  [1976] = 1849,
  [1977] = 1847,
  [1978] = 1835,
  [1979] = 1850,
  [1980] = 1886,
  [1981] = 1981,
  [1982] = 1862,
  [1983] = 1963,
  [1984] = 1868,
  [1985] = 1867,
  [1986] = 1869,
  [1987] = 1845,
  [1988] = 1846,
  [1989] = 1847,
  [1990] = 1873,
  [1991] = 1873,
  [1992] = 1992,
  [1993] = 1859,
  [1994] = 1863,
  [1995] = 1869,
  [1996] = 1996,
  [1997] = 1868,
  [1998] = 1862,
  [1999] = 1848,
  [2000] = 1860,
  [2001] = 1955,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 1858,
  [2005] = 1835,
  [2006] = 1880,
  [2007] = 1881,
  [2008] = 1882,
  [2009] = 1859,
  [2010] = 1889,
  [2011] = 1944,
  [2012] = 1887,
  [2013] = 1888,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2017,
  [2021] = 2021,
  [2022] = 2014,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2019,
  [2035] = 2035,
  [2036] = 2023,
  [2037] = 2016,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2023,
  [2042] = 2021,
  [2043] = 2016,
  [2044] = 2016,
  [2045] = 2045,
  [2046] = 2030,
  [2047] = 2023,
  [2048] = 2048,
  [2049] = 2031,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2026,
  [2053] = 2053,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2031,
  [2057] = 2015,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2031,
  [2061] = 2030,
  [2062] = 2026,
  [2063] = 2063,
  [2064] = 2023,
  [2065] = 2065,
  [2066] = 2019,
  [2067] = 2058,
  [2068] = 2019,
  [2069] = 2015,
  [2070] = 2058,
  [2071] = 2071,
  [2072] = 2031,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2030,
  [2076] = 2076,
  [2077] = 2017,
  [2078] = 2015,
  [2079] = 2015,
  [2080] = 2030,
  [2081] = 2030,
  [2082] = 2082,
  [2083] = 2014,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2014,
  [2087] = 2030,
  [2088] = 2018,
  [2089] = 2017,
  [2090] = 2021,
  [2091] = 2091,
  [2092] = 2014,
  [2093] = 2019,
  [2094] = 2021,
  [2095] = 2017,
  [2096] = 2058,
  [2097] = 2018,
  [2098] = 2076,
  [2099] = 2026,
  [2100] = 2100,
  [2101] = 2065,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2120,
  [2121] = 1139,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2103,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2119,
  [2134] = 1135,
  [2135] = 2135,
  [2136] = 1131,
  [2137] = 2132,
  [2138] = 2116,
  [2139] = 2119,
  [2140] = 2135,
  [2141] = 2127,
  [2142] = 2131,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2112,
  [2148] = 2148,
  [2149] = 2132,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2119,
  [2153] = 2131,
  [2154] = 2132,
  [2155] = 2119,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2135,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 2143,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2132,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2112,
  [2171] = 2171,
  [2172] = 2164,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2117,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2112,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2103,
  [2187] = 2126,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2177,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2130,
  [2196] = 2106,
  [2197] = 2160,
  [2198] = 2198,
  [2199] = 2184,
  [2200] = 2175,
  [2201] = 2132,
  [2202] = 2202,
  [2203] = 2169,
  [2204] = 2204,
  [2205] = 2174,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2113,
  [2210] = 2210,
  [2211] = 2131,
  [2212] = 2212,
  [2213] = 2116,
  [2214] = 2214,
  [2215] = 2158,
  [2216] = 2127,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2143,
  [2220] = 2119,
  [2221] = 2117,
  [2222] = 1132,
  [2223] = 2177,
  [2224] = 2224,
  [2225] = 2114,
  [2226] = 2192,
  [2227] = 2207,
  [2228] = 2228,
  [2229] = 2207,
  [2230] = 2217,
  [2231] = 2115,
  [2232] = 2232,
  [2233] = 2118,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2143,
  [2238] = 2126,
  [2239] = 2217,
  [2240] = 2158,
  [2241] = 2241,
  [2242] = 2113,
  [2243] = 2135,
  [2244] = 2106,
  [2245] = 576,
  [2246] = 2156,
  [2247] = 2247,
  [2248] = 2169,
  [2249] = 2113,
  [2250] = 2190,
  [2251] = 2171,
  [2252] = 2252,
  [2253] = 2173,
  [2254] = 2164,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2207,
  [2259] = 2117,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2177,
  [2267] = 2108,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2103,
  [2277] = 2171,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2189,
  [2282] = 2282,
  [2283] = 2174,
  [2284] = 2103,
  [2285] = 2103,
  [2286] = 2175,
  [2287] = 2158,
  [2288] = 2189,
  [2289] = 2289,
  [2290] = 2289,
  [2291] = 2184,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2113,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2298,
  [2300] = 2113,
  [2301] = 2135,
  [2302] = 2302,
  [2303] = 577,
  [2304] = 2135,
  [2305] = 2180,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2114,
  [2311] = 2311,
  [2312] = 2112,
  [2313] = 2194,
  [2314] = 2115,
  [2315] = 2192,
  [2316] = 2316,
  [2317] = 2118,
  [2318] = 2169,
  [2319] = 2319,
  [2320] = 2119,
  [2321] = 2293,
  [2322] = 2322,
  [2323] = 2189,
  [2324] = 2298,
  [2325] = 2289,
  [2326] = 2326,
  [2327] = 2180,
  [2328] = 2328,
  [2329] = 2193,
  [2330] = 2204,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2106,
  [2335] = 2190,
  [2336] = 2336,
  [2337] = 2173,
  [2338] = 2164,
  [2339] = 2293,
  [2340] = 2158,
  [2341] = 2298,
  [2342] = 2164,
  [2343] = 2193,
  [2344] = 2180,
  [2345] = 2194,
  [2346] = 2173,
  [2347] = 2193,
  [2348] = 2160,
  [2349] = 2132,
  [2350] = 2292,
  [2351] = 2351,
  [2352] = 2190,
  [2353] = 2353,
  [2354] = 2217,
  [2355] = 2293,
  [2356] = 2194,
  [2357] = 2112,
  [2358] = 2127,
  [2359] = 2192,
  [2360] = 2360,
  [2361] = 2126,
  [2362] = 2293,
  [2363] = 2131,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2131,
  [2367] = 2367,
  [2368] = 2103,
  [2369] = 2160,
  [2370] = 2127,
  [2371] = 2135,
  [2372] = 2295,
};

static TSCharacterRange sym_number_literal_character_set_13[] = {
  {'0', '9'}, {'B', 'B'}, {'D', 'D'}, {'F', 'F'}, {'L', 'L'}, {'U', 'U'}, {'W', 'W'}, {'b', 'b'},
  {'d', 'd'}, {'f', 'f'}, {'l', 'l'}, {'u', 'u'}, {'w', 'w'},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f},
  {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x1123e}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36},
  {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f},
  {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88},
  {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b},
  {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac},
  {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539},
  {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa},
  {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb},
  {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27},
  {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b},
  {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f},
  {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89},
  {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(124);
      ADVANCE_MAP(
        '!', 202,
        '"', 301,
        '#', 79,
        '%', 219,
        '&', 228,
        '\'', 292,
        '(', 128,
        ')', 131,
        '*', 215,
        '+', 210,
        ',', 130,
        '-', 205,
        '.', 268,
        '/', 217,
        '0', 274,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        'L', 313,
        'U', 315,
        '[', 248,
        '\\', 2,
        ']', 249,
        '^', 225,
        'u', 317,
        '{', 245,
        '|', 222,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(122);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(45);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(45);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(48);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(48);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(47);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(47);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(50);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(50);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(55);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(55);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(56);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(56);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(60);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(60);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(52);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(52);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(54);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(54);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(51);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(51);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(23);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(23);
      if (lookahead == '\r') SKIP(21);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '\n', 133,
        '!', 72,
        '%', 218,
        '&', 227,
        '(', 200,
        '*', 214,
        '+', 209,
        '-', 204,
        '/', 216,
        '<', 236,
        '=', 73,
        '>', 232,
      );
      if (lookahead == '\\') SKIP(22);
      if (lookahead == '^') ADVANCE(224);
      if (lookahead == '|') ADVANCE(223);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(59);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(59);
      if (lookahead == '\r') SKIP(24);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(57);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(57);
      if (lookahead == '\r') SKIP(26);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 28:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '(') ADVANCE(128);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(149);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 29:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '\r') ADVANCE(33);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(149);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 30:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '\r') ADVANCE(32);
      if (lookahead == '(') ADVANCE(200);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(62);
      END_STATE();
    case 31:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '\r') ADVANCE(34);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(151);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(70);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(326);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 32:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '(') ADVANCE(200);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62);
      END_STATE();
    case 33:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(149);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 34:
      if (lookahead == '\n') ADVANCE(126);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(151);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(326);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(58);
      if (lookahead == '"') ADVANCE(301);
      if (lookahead == '/') ADVANCE(302);
      if (lookahead == '\\') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(305);
      if (lookahead != 0) ADVANCE(306);
      END_STATE();
    case 36:
      if (lookahead == '\n') ADVANCE(308);
      if (lookahead == '\r') ADVANCE(307);
      if (lookahead == 'U') ADVANCE(120);
      if (lookahead == 'u') ADVANCE(112);
      if (lookahead == 'x') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(310);
      if (lookahead != 0) ADVANCE(307);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(61);
      if (lookahead == '\'') ADVANCE(292);
      if (lookahead == '/') ADVANCE(295);
      if (lookahead == '\\') ADVANCE(294);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(296);
      if (lookahead != 0) ADVANCE(293);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(62);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(62);
      if (lookahead == '\r') SKIP(38);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(46);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(46);
      if (lookahead == '\r') SKIP(40);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(53);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(53);
      if (lookahead == '\r') SKIP(42);
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 44:
      if (lookahead == '\r') ADVANCE(335);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead != 0) ADVANCE(334);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 202,
        '"', 301,
        '#', 79,
        '%', 219,
        '&', 228,
        '\'', 292,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 210,
        ',', 130,
        '-', 205,
        '.', 268,
        '/', 217,
        '0', 274,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        'L', 313,
        'U', 315,
        '[', 248,
        '\\', 2,
        ']', 249,
        '^', 225,
        'u', 317,
        '{', 245,
        '|', 222,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 202,
        '"', 301,
        '#', 87,
        '%', 219,
        '&', 228,
        '\'', 292,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 210,
        ',', 130,
        '-', 205,
        '.', 268,
        '/', 217,
        '0', 274,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        'L', 313,
        'U', 315,
        '[', 247,
        '\\', 41,
        ']', 249,
        '^', 225,
        'u', 317,
        '{', 245,
        '|', 222,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 201,
        '"', 301,
        '#', 79,
        '&', 226,
        '\'', 292,
        '(', 200,
        '*', 214,
        '+', 211,
        ',', 130,
        '-', 206,
        '.', 100,
        '/', 63,
        '0', 274,
        ':', 71,
        ';', 241,
        'L', 313,
        'U', 315,
        '[', 77,
        '\\', 6,
        ']', 78,
        'u', 317,
        '{', 245,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 201,
        '"', 301,
        '#', 83,
        '&', 226,
        '\'', 292,
        '(', 200,
        ')', 131,
        '*', 214,
        '+', 211,
        ',', 130,
        '-', 206,
        '.', 269,
        '/', 63,
        '0', 274,
        ':', 252,
        ';', 241,
        '=', 250,
        'L', 313,
        'U', 315,
        '[', 248,
        '\\', 4,
        ']', 249,
        'u', 317,
        '{', 245,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 201,
        '"', 301,
        '#', 81,
        '&', 226,
        '\'', 292,
        '(', 200,
        '*', 214,
        '+', 211,
        '-', 206,
        '.', 100,
        '/', 63,
        '0', 274,
        ':', 336,
        ';', 241,
        'L', 313,
        'U', 315,
        '[', 77,
        '\\', 8,
        'u', 317,
        '{', 245,
        '~', 203,
        '\t', 49,
        ' ', 49,
      );
      if (('\n' <= lookahead && lookahead <= '\r')) SKIP(50);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '!', 201,
        '"', 301,
        '#', 81,
        '&', 226,
        '\'', 292,
        '(', 200,
        '*', 214,
        '+', 211,
        '-', 206,
        '.', 100,
        '/', 63,
        '0', 274,
        ';', 241,
        'L', 313,
        'U', 315,
        '[', 77,
        '\\', 8,
        'u', 317,
        '{', 245,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 201,
        '\'', 292,
        '(', 200,
        ')', 131,
        '+', 213,
        '-', 208,
        '.', 100,
        '/', 63,
        '0', 274,
        'L', 321,
        'U', 322,
        '\\', 20,
        'u', 323,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 72,
        '"', 301,
        '#', 87,
        '%', 219,
        '&', 228,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 212,
        ',', 130,
        '-', 207,
        '.', 267,
        '/', 217,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        'L', 314,
        'U', 316,
        '[', 248,
        '\\', 16,
        ']', 249,
        '^', 225,
        'u', 318,
        '{', 245,
        '|', 222,
        '}', 246,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 72,
        '#', 87,
        '%', 219,
        '&', 228,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 212,
        ',', 130,
        '-', 207,
        '.', 267,
        '/', 217,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        '[', 248,
        '\\', 43,
        ']', 249,
        '^', 225,
        '{', 245,
        '|', 222,
        '}', 246,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '!', 72,
        '#', 87,
        '%', 219,
        '&', 228,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 212,
        ',', 130,
        '-', 207,
        '.', 266,
        '/', 217,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        '[', 247,
        '\\', 18,
        ']', 78,
        '^', 225,
        '|', 222,
        '}', 246,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '!', 72,
        '#', 80,
        '%', 219,
        '&', 228,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 212,
        ',', 130,
        '-', 207,
        '.', 267,
        '/', 217,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        '[', 248,
        '\\', 10,
        ']', 249,
        '^', 225,
        '{', 245,
        '|', 222,
        '}', 246,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '!', 72,
        '#', 82,
        '%', 218,
        '&', 227,
        '(', 200,
        ')', 131,
        '*', 214,
        '+', 209,
        ',', 130,
        '-', 204,
        '/', 216,
        ';', 241,
        '<', 236,
        '=', 251,
        '>', 232,
        '[', 248,
        '\\', 12,
        '^', 224,
        '{', 245,
        '|', 223,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 57:
      if (lookahead == '"') ADVANCE(301);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '<') ADVANCE(74);
      if (lookahead == 'L') ADVANCE(314);
      if (lookahead == 'U') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == 'u') ADVANCE(318);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 58:
      if (lookahead == '"') ADVANCE(301);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      END_STATE();
    case 59:
      if (lookahead == '#') ADVANCE(97);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead == '}') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 60:
      if (lookahead == '#') ADVANCE(84);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == '}') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(60);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 61:
      if (lookahead == '\'') ADVANCE(292);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(61);
      END_STATE();
    case 62:
      if (lookahead == '(') ADVANCE(200);
      if (lookahead == '/') ADVANCE(63);
      if (lookahead == '\\') SKIP(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(62);
      END_STATE();
    case 63:
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '/') ADVANCE(334);
      END_STATE();
    case 64:
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '/') ADVANCE(327);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == '*') ADVANCE(64);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '*') ADVANCE(64);
      if (lookahead != 0) ADVANCE(147);
      END_STATE();
    case 67:
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(272);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(273);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(282);
      END_STATE();
    case 68:
      if (lookahead == '.') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(149);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 70:
      if (lookahead == '/') ADVANCE(157);
      if (lookahead == '\\') ADVANCE(151);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(70);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(326);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 71:
      if (lookahead == ':') ADVANCE(242);
      END_STATE();
    case 72:
      if (lookahead == '=') ADVANCE(230);
      END_STATE();
    case 73:
      if (lookahead == '=') ADVANCE(229);
      END_STATE();
    case 74:
      if (lookahead == '>') ADVANCE(311);
      if (lookahead == '\\') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(74);
      END_STATE();
    case 75:
      if (lookahead == '>') ADVANCE(312);
      if (lookahead == '\\') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(74);
      END_STATE();
    case 76:
      if (lookahead == 'U') ADVANCE(119);
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 77:
      if (lookahead == '[') ADVANCE(243);
      END_STATE();
    case 78:
      if (lookahead == ']') ADVANCE(244);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'e') ADVANCE(194);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'e') ADVANCE(194);
      if (lookahead == 'i') ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 81:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'e') ADVANCE(196);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'e') ADVANCE(196);
      if (lookahead == 'i') ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 83:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 84:
      if (lookahead == 'd') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 85:
      if (lookahead == 'd') ADVANCE(96);
      END_STATE();
    case 86:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(98);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(87);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 91:
      if (lookahead == 'f') ADVANCE(140);
      END_STATE();
    case 92:
      if (lookahead == 'f') ADVANCE(134);
      END_STATE();
    case 93:
      if (lookahead == 'f') ADVANCE(142);
      END_STATE();
    case 94:
      if (lookahead == 'f') ADVANCE(144);
      END_STATE();
    case 95:
      if (lookahead == 'i') ADVANCE(91);
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 96:
      if (lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(183);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(282);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(325);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(279);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(282);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(277);
      END_STATE();
    case 106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(307);
      END_STATE();
    case 107:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(102);
      END_STATE();
    case 108:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 109:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(107);
      END_STATE();
    case 110:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 111:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(109);
      END_STATE();
    case 112:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(110);
      END_STATE();
    case 113:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(111);
      END_STATE();
    case 114:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(112);
      END_STATE();
    case 115:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(113);
      END_STATE();
    case 116:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(114);
      END_STATE();
    case 117:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(115);
      END_STATE();
    case 118:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(116);
      END_STATE();
    case 119:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(117);
      END_STATE();
    case 120:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(118);
      END_STATE();
    case 121:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(167);
      END_STATE();
    case 122:
      if (eof) ADVANCE(124);
      ADVANCE_MAP(
        '!', 202,
        '"', 301,
        '#', 79,
        '%', 219,
        '&', 228,
        '\'', 292,
        '(', 200,
        ')', 131,
        '*', 215,
        '+', 210,
        ',', 130,
        '-', 205,
        '.', 268,
        '/', 217,
        '0', 274,
        ':', 252,
        ';', 241,
        '<', 235,
        '=', 251,
        '>', 231,
        '?', 253,
        'L', 313,
        'U', 315,
        '[', 248,
        '\\', 2,
        ']', 249,
        '^', 225,
        'u', 317,
        '{', 245,
        '|', 222,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(122);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 123:
      if (eof) ADVANCE(124);
      ADVANCE_MAP(
        '!', 201,
        '"', 301,
        '#', 83,
        '&', 226,
        '\'', 292,
        '(', 200,
        ')', 131,
        '*', 214,
        '+', 211,
        ',', 130,
        '-', 206,
        '.', 269,
        '/', 63,
        '0', 274,
        ':', 252,
        ';', 241,
        '=', 250,
        'L', 313,
        'U', 315,
        '[', 248,
        '\\', 4,
        ']', 249,
        'u', 317,
        '{', 245,
        '}', 246,
        '~', 203,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(123);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(325);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(178);
      if (lookahead == 'n') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(89);
      if (lookahead == 'n') ADVANCE(86);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(180);
      if (lookahead == 'n') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '/') ADVANCE(327);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead != 0) ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(65);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead != 0) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(334);
      if (lookahead == '\r') ADVANCE(328);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(330);
      if (lookahead != 0) ADVANCE(332);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '\r') ADVANCE(150);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(69);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(70);
      if (lookahead == '\r') ADVANCE(152);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == 'U') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead == 'u') ADVANCE(162);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(70);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(168);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == 'U') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead == 'u') ADVANCE(162);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(168);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(158);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead != 0) ADVANCE(147);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(333);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(330);
      if (lookahead != 0) ADVANCE(332);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(147);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(146);
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(155);
      if (lookahead != 0) ADVANCE(147);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(154);
      if (lookahead != 0) ADVANCE(167);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(195);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(193);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(187);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(132);
      if (lookahead == 'n') ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(185);
      if (lookahead == 's') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(192);
      if (lookahead == 'n') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(230);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(264);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (lookahead == '=') ADVANCE(258);
      if (lookahead == '>') ADVANCE(270);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(264);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(264);
      if (lookahead == '=') ADVANCE(258);
      if (lookahead == '>') ADVANCE(270);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(265);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (lookahead == '=') ADVANCE(257);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(265);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(265);
      if (lookahead == '=') ADVANCE(257);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(274);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(254);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '/') ADVANCE(334);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '=') ADVANCE(255);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(256);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(263);
      if (lookahead == '|') ADVANCE(220);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(220);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(262);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(221);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(221);
      if (lookahead == '=') ADVANCE(261);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(233);
      if (lookahead == '>') ADVANCE(240);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(233);
      if (lookahead == '>') ADVANCE(239);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(238);
      if (lookahead == '=') ADVANCE(234);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(237);
      if (lookahead == '=') ADVANCE(234);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(259);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(260);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(243);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(229);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(68);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(100);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(271);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(287);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 101,
        '.', 285,
        'B', 281,
        'b', 281,
        'E', 280,
        'e', 280,
        'P', 284,
        'p', 284,
        'X', 104,
        'x', 104,
        'A', 282,
        'C', 282,
        'a', 282,
        'c', 282,
        'D', 282,
        'F', 282,
        'd', 282,
        'f', 282,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 101,
        '.', 285,
        'E', 280,
        'e', 280,
        'P', 284,
        'p', 284,
        'A', 282,
        'C', 282,
        'a', 282,
        'c', 282,
        'B', 282,
        'D', 282,
        'F', 282,
        'b', 282,
        'd', 282,
        'f', 282,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 99,
        '.', 285,
        'B', 283,
        'b', 283,
        'X', 67,
        'x', 67,
        'E', 284,
        'P', 284,
        'e', 284,
        'p', 284,
        'D', 287,
        'F', 287,
        'L', 287,
        'U', 287,
        'W', 287,
        'd', 287,
        'f', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 99,
        '.', 285,
        'B', 286,
        'b', 286,
        'X', 104,
        'x', 104,
        'E', 284,
        'P', 284,
        'e', 284,
        'p', 284,
        'D', 287,
        'F', 287,
        'L', 287,
        'U', 287,
        'W', 287,
        'd', 287,
        'f', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(276);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(99);
      if (lookahead == '.') ADVANCE(285);
      if (lookahead == 'E' ||
          lookahead == 'P' ||
          lookahead == 'e' ||
          lookahead == 'p') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(287);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 105,
        'B', 277,
        'D', 277,
        'F', 277,
        'b', 277,
        'd', 277,
        'f', 277,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(277);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 103,
        '+', 105,
        '-', 105,
        'E', 278,
        'e', 278,
        'P', 284,
        'p', 284,
        'B', 279,
        'D', 279,
        'F', 279,
        'b', 279,
        'd', 279,
        'f', 279,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(279);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 103,
        'E', 278,
        'e', 278,
        'P', 284,
        'p', 284,
        'B', 279,
        'D', 279,
        'F', 279,
        'b', 279,
        'd', 279,
        'f', 279,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 104,
        '.', 285,
        '+', 105,
        '-', 105,
        'E', 280,
        'e', 280,
        'P', 284,
        'p', 284,
        'B', 282,
        'D', 282,
        'F', 282,
        'b', 282,
        'd', 282,
        'f', 282,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(282);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 104,
        '.', 285,
        'E', 280,
        'e', 280,
        'P', 284,
        'p', 284,
        'A', 282,
        'C', 282,
        'a', 282,
        'c', 282,
        'B', 282,
        'D', 282,
        'F', 282,
        'b', 282,
        'd', 282,
        'f', 282,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(273);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 104,
        '.', 285,
        'E', 280,
        'e', 280,
        'P', 284,
        'p', 284,
        'B', 282,
        'D', 282,
        'F', 282,
        'b', 282,
        'd', 282,
        'f', 282,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(282);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '0') ADVANCE(275);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(287);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '+', 105,
        '-', 105,
        'B', 277,
        'D', 277,
        'F', 277,
        'b', 277,
        'd', 277,
        'f', 277,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'E') ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(277);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'E', 278,
        'e', 278,
        'P', 284,
        'p', 284,
        'B', 279,
        'D', 279,
        'F', 279,
        'b', 279,
        'd', 279,
        'f', 279,
        'L', 287,
        'U', 287,
        'W', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(279);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_number_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(276);
      if (set_contains(sym_number_literal_character_set_13, 13, lookahead)) ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 287,
        'D', 287,
        'F', 287,
        'L', 287,
        'U', 287,
        'W', 287,
        'b', 287,
        'd', 287,
        'f', 287,
        'l', 287,
        'u', 287,
        'w', 287,
      );
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(308);
      if (lookahead == '\r') ADVANCE(307);
      if (lookahead == 'U') ADVANCE(120);
      if (lookahead == 'u') ADVANCE(112);
      if (lookahead == 'x') ADVANCE(108);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(310);
      if (lookahead != 0) ADVANCE(307);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '/') ADVANCE(334);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(36);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(304);
      if (lookahead == '/') ADVANCE(306);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(306);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(303);
      if (lookahead == '/') ADVANCE(306);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(304);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(303);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(304);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(302);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(305);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(306);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(306);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(36);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(307);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(309);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(311);
      if (lookahead == '\\') ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(74);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(297);
      if (lookahead == '\'') ADVANCE(288);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(297);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(299);
      if (lookahead == '\'') ADVANCE(290);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(299);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(298);
      if (lookahead == '\'') ADVANCE(289);
      if (lookahead == '8') ADVANCE(319);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(298);
      if (lookahead == '8') ADVANCE(320);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(300);
      if (lookahead == '\'') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(300);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(288);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(290);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(289);
      if (lookahead == '8') ADVANCE(324);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(291);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(76);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(325);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(153);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(326);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(334);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead != 0) ADVANCE(332);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(335);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead != 0) ADVANCE(334);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(333);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(330);
      if (lookahead != 0) ADVANCE(332);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(332);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(332);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(331);
      if (lookahead == '\\') ADVANCE(156);
      if (lookahead != 0) ADVANCE(332);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(334);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(44);
      if (lookahead != 0) ADVANCE(334);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_preproc_extension_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(336);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4);
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'l') ADVANCE(15);
      if (lookahead == 'm') ADVANCE(16);
      if (lookahead == 'n') ADVANCE(17);
      if (lookahead == 'o') ADVANCE(18);
      if (lookahead == 'p') ADVANCE(19);
      if (lookahead == 'r') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(26);
      END_STATE();
    case 2:
      if (lookahead == 'U') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(29);
      END_STATE();
    case 5:
      if (lookahead == 'A') ADVANCE(30);
      if (lookahead == 'G') ADVANCE(31);
      if (lookahead == 'N') ADVANCE(32);
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 's') ADVANCE(37);
      if (lookahead == 't') ADVANCE(38);
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 'u') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'h') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(51);
      if (lookahead == 'x') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'l') ADVANCE(54);
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 'n') ADVANCE(59);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'u') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(68);
      if (lookahead == 'r') ADVANCE(69);
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(71);
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        'a', 73,
        'h', 74,
        'i', 75,
        'm', 76,
        's', 77,
        't', 78,
        'u', 79,
        'w', 80,
      );
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(81);
      if (lookahead == 'r') ADVANCE(82);
      if (lookahead == 'y') ADVANCE(83);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(84);
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(86);
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(88);
      if (lookahead == 'h') ADVANCE(89);
      if (lookahead == 'r') ADVANCE(90);
      END_STATE();
    case 26:
      if (lookahead == 'L') ADVANCE(91);
      END_STATE();
    case 27:
      if (lookahead == 'L') ADVANCE(92);
      END_STATE();
    case 28:
      if (lookahead == 'U') ADVANCE(93);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(94);
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        'a', 98,
        'b', 99,
        'c', 100,
        'd', 101,
        'e', 102,
        'f', 103,
        'i', 104,
        'l', 105,
        'r', 106,
        's', 107,
        't', 108,
        'u', 109,
        'v', 110,
      );
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(111);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 37:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(117);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 42:
      if (lookahead == 'f') ADVANCE(119);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(123);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(124);
      if (lookahead == 'n') ADVANCE(125);
      END_STATE();
    case 47:
      if (lookahead == 'f') ADVANCE(126);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(128);
      END_STATE();
    case 50:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(130);
      if (lookahead == 'u') ADVANCE(131);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(134);
      if (lookahead == 'o') ADVANCE(135);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 57:
      if (lookahead == 'g') ADVANCE(138);
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(141);
      if (lookahead == 't') ADVANCE(142);
      if (lookahead == 'v') ADVANCE(143);
      END_STATE();
    case 60:
      if (lookahead == 'y') ADVANCE(144);
      END_STATE();
    case 61:
      if (lookahead == 'n') ADVANCE(145);
      if (lookahead == 'w') ADVANCE(146);
      END_STATE();
    case 62:
      if (lookahead == 'x') ADVANCE(147);
      END_STATE();
    case 63:
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(149);
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 66:
      if (lookahead == 'f') ADVANCE(152);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 71:
      if (lookahead == 'y') ADVANCE(157);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(158);
      if (lookahead == 'g') ADVANCE(159);
      if (lookahead == 'q') ADVANCE(160);
      if (lookahead == 's') ADVANCE(161);
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 73:
      if (lookahead == 'm') ADVANCE(163);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(164);
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 75:
      if (lookahead == 'g') ADVANCE(166);
      if (lookahead == 'z') ADVANCE(167);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(170);
      if (lookahead == 'r') ADVANCE(171);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(172);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(173);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 83:
      if (lookahead == 'p') ADVANCE(176);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(177);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(178);
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(181);
      if (lookahead == 'l') ADVANCE(182);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 89:
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(185);
      END_STATE();
    case 91:
      if (lookahead == 'S') ADVANCE(186);
      END_STATE();
    case 92:
      if (lookahead == 'L') ADVANCE(187);
      END_STATE();
    case 93:
      if (lookahead == 'E') ADVANCE(188);
      END_STATE();
    case 94:
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 95:
      if (lookahead == 'o') ADVANCE(190);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(191);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(193);
      if (lookahead == 's') ADVANCE(194);
      if (lookahead == 't') ADVANCE(195);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 100:
      if (lookahead == 'd') ADVANCE(197);
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 102:
      if (lookahead == 'x') ADVANCE(200);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(201);
      if (lookahead == 'i') ADVANCE(202);
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 104:
      if (lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 107:
      if (lookahead == 'p') ADVANCE(207);
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 108:
      if (lookahead == 'h') ADVANCE(209);
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(211);
      if (lookahead == 'p') ADVANCE(212);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 111:
      if (lookahead == 'i') ADVANCE(214);
      END_STATE();
    case 112:
      if (lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 113:
      if (lookahead == 'g') ADVANCE(216);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 115:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(219);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(220);
      END_STATE();
    case 119:
      if (lookahead == 'f') ADVANCE(221);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 123:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 125:
      if (lookahead == 's') ADVANCE(227);
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 126:
      if (lookahead == 'a') ADVANCE(229);
      if (lookahead == 'i') ADVANCE(230);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(231);
      END_STATE();
    case 128:
      if (lookahead == 'b') ADVANCE(232);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(233);
      END_STATE();
    case 130:
      if (lookahead == 'b') ADVANCE(234);
      END_STATE();
    case 131:
      if (lookahead == 'm') ADVANCE(235);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(236);
      END_STATE();
    case 133:
      if (lookahead == 's') ADVANCE(237);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(238);
      END_STATE();
    case 135:
      if (lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 137:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 138:
      if (lookahead == 'h') ADVANCE(241);
      END_STATE();
    case 139:
      if (lookahead == 'A') ADVANCE(242);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(243);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(244);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(245);
      if (lookahead == '3') ADVANCE(246);
      if (lookahead == '6') ADVANCE(247);
      if (lookahead == '8') ADVANCE(248);
      if (lookahead == 'p') ADVANCE(249);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 144:
      if (lookahead == 'o') ADVANCE(251);
      END_STATE();
    case 145:
      if (lookahead == 'g') ADVANCE(252);
      END_STATE();
    case 146:
      if (lookahead == 'p') ADVANCE(253);
      END_STATE();
    case 147:
      if (lookahead == '_') ADVANCE(254);
      END_STATE();
    case 148:
      if (lookahead == 'i') ADVANCE(255);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 152:
      if (lookahead == 's') ADVANCE(259);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 154:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 155:
      if (lookahead == 'c') ADVANCE(261);
      END_STATE();
    case 156:
      if (lookahead == 'd') ADVANCE(262);
      END_STATE();
    case 157:
      if (lookahead == 'P') ADVANCE(263);
      END_STATE();
    case 158:
      if (lookahead == 'd') ADVANCE(264);
      END_STATE();
    case 159:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 160:
      if (lookahead == 'u') ADVANCE(266);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 162:
      if (lookahead == 'u') ADVANCE(268);
      END_STATE();
    case 163:
      if (lookahead == 'p') ADVANCE(269);
      END_STATE();
    case 164:
      if (lookahead == 'd') ADVANCE(270);
      if (lookahead == 'r') ADVANCE(271);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(272);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 167:
      if (lookahead == 'e') ADVANCE(274);
      END_STATE();
    case 168:
      if (lookahead == 'o') ADVANCE(275);
      END_STATE();
    case 169:
      if (lookahead == 'z') ADVANCE(276);
      END_STATE();
    case 170:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 171:
      if (lookahead == 'u') ADVANCE(278);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(281);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 177:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 178:
      if (lookahead == 'f') ADVANCE(284);
      if (lookahead == 'o') ADVANCE(285);
      END_STATE();
    case 179:
      if (lookahead == 'i') ADVANCE(286);
      END_STATE();
    case 180:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 181:
      if (lookahead == 'd') ADVANCE(219);
      END_STATE();
    case 182:
      if (lookahead == 'a') ADVANCE(288);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(290);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 186:
      if (lookahead == 'E') ADVANCE(292);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 189:
      if (lookahead == 'g') ADVANCE(293);
      END_STATE();
    case 190:
      if (lookahead == 'm') ADVANCE(294);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(295);
      END_STATE();
    case 192:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 193:
      if (lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 194:
      if (lookahead == 'm') ADVANCE(298);
      END_STATE();
    case 195:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 196:
      if (lookahead == 's') ADVANCE(300);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(302);
      END_STATE();
    case 199:
      if (lookahead == 'c') ADVANCE(303);
      END_STATE();
    case 200:
      if (lookahead == 'c') ADVANCE(304);
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 201:
      if (lookahead == 's') ADVANCE(306);
      END_STATE();
    case 202:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(308);
      END_STATE();
    case 204:
      if (lookahead == 'l') ADVANCE(309);
      END_STATE();
    case 205:
      if (lookahead == 'a') ADVANCE(310);
      END_STATE();
    case 206:
      if (lookahead == 's') ADVANCE(311);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 208:
      if (lookahead == 'd') ADVANCE(313);
      END_STATE();
    case 209:
      if (lookahead == 'i') ADVANCE(314);
      if (lookahead == 'r') ADVANCE(315);
      END_STATE();
    case 210:
      if (lookahead == 'y') ADVANCE(316);
      END_STATE();
    case 211:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(319);
      END_STATE();
    case 214:
      if (lookahead == 'g') ADVANCE(320);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(321);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(322);
      END_STATE();
    case 217:
      if (lookahead == 'i') ADVANCE(323);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_auto);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_primitive_type);
      END_STATE();
    case 220:
      if (lookahead == 'k') ADVANCE(324);
      END_STATE();
    case 221:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 222:
      if (lookahead == 'a') ADVANCE(326);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 224:
      if (lookahead == 'r') ADVANCE(327);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(328);
      if (lookahead == '3') ADVANCE(329);
      if (lookahead == '6') ADVANCE(330);
      if (lookahead == '8') ADVANCE(331);
      if (lookahead == 'p') ADVANCE(332);
      END_STATE();
    case 226:
      if (lookahead == 'r') ADVANCE(333);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(334);
      END_STATE();
    case 228:
      if (lookahead == 'i') ADVANCE(335);
      END_STATE();
    case 229:
      if (lookahead == 'u') ADVANCE(336);
      END_STATE();
    case 230:
      if (lookahead == 'n') ADVANCE(337);
      END_STATE();
    case 231:
      if (lookahead == 'b') ADVANCE(338);
      END_STATE();
    case 232:
      if (lookahead == 'l') ADVANCE(339);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 234:
      if (lookahead == 'l') ADVANCE(340);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 236:
      if (lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_flat);
      END_STATE();
    case 239:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 241:
      if (lookahead == 'p') ADVANCE(342);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(343);
      END_STATE();
    case 243:
      if (lookahead == 'n') ADVANCE(344);
      END_STATE();
    case 244:
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 245:
      if (lookahead == '6') ADVANCE(346);
      END_STATE();
    case 246:
      if (lookahead == '2') ADVANCE(347);
      END_STATE();
    case 247:
      if (lookahead == '4') ADVANCE(348);
      END_STATE();
    case 248:
      if (lookahead == '_') ADVANCE(349);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(350);
      END_STATE();
    case 250:
      if (lookahead == 'r') ADVANCE(351);
      END_STATE();
    case 251:
      if (lookahead == 'u') ADVANCE(352);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_lowp);
      END_STATE();
    case 254:
      if (lookahead == 'a') ADVANCE(353);
      END_STATE();
    case 255:
      if (lookahead == 'u') ADVANCE(354);
      END_STATE();
    case 256:
      if (lookahead == 'r') ADVANCE(355);
      END_STATE();
    case 257:
      if (lookahead == 't') ADVANCE(356);
      END_STATE();
    case 258:
      if (lookahead == 'p') ADVANCE(357);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 260:
      if (lookahead == 'h') ADVANCE(359);
      END_STATE();
    case 261:
      if (lookahead == 'i') ADVANCE(360);
      END_STATE();
    case 262:
      if (lookahead == 'i') ADVANCE(361);
      END_STATE();
    case 263:
      if (lookahead == 'a') ADVANCE(362);
      END_STATE();
    case 264:
      if (lookahead == 'o') ADVANCE(363);
      END_STATE();
    case 265:
      if (lookahead == 's') ADVANCE(364);
      END_STATE();
    case 266:
      if (lookahead == 'i') ADVANCE(365);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(366);
      END_STATE();
    case 268:
      if (lookahead == 'r') ADVANCE(367);
      END_STATE();
    case 269:
      if (lookahead == 'l') ADVANCE(368);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 271:
      if (lookahead == 'e') ADVANCE(370);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(371);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(372);
      END_STATE();
    case 274:
      if (lookahead == '_') ADVANCE(373);
      if (lookahead == 'o') ADVANCE(374);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(375);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(377);
      END_STATE();
    case 278:
      if (lookahead == 'c') ADVANCE(378);
      END_STATE();
    case 279:
      if (lookahead == 'o') ADVANCE(379);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(380);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(381);
      END_STATE();
    case 282:
      if (lookahead == 'd') ADVANCE(382);
      END_STATE();
    case 283:
      if (lookahead == '1') ADVANCE(383);
      if (lookahead == '3') ADVANCE(384);
      if (lookahead == '6') ADVANCE(385);
      if (lookahead == '8') ADVANCE(386);
      if (lookahead == 'p') ADVANCE(387);
      END_STATE();
    case 284:
      if (lookahead == 'o') ADVANCE(388);
      END_STATE();
    case 285:
      if (lookahead == 'n') ADVANCE(389);
      END_STATE();
    case 286:
      if (lookahead == 'g') ADVANCE(390);
      END_STATE();
    case 287:
      if (lookahead == 'i') ADVANCE(391);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(392);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_warn);
      END_STATE();
    case 290:
      if (lookahead == 'e') ADVANCE(393);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 293:
      if (lookahead == 'n') ADVANCE(395);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(396);
      END_STATE();
    case 295:
      if (lookahead == 'r') ADVANCE(397);
      END_STATE();
    case 296:
      if (lookahead == 't') ADVANCE(398);
      END_STATE();
    case 297:
      if (lookahead == 'g') ADVANCE(399);
      END_STATE();
    case 298:
      if (lookahead == '_') ADVANCE(400);
      END_STATE();
    case 299:
      if (lookahead == 'r') ADVANCE(401);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(402);
      END_STATE();
    case 301:
      if (lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 302:
      if (lookahead == 'c') ADVANCE(404);
      END_STATE();
    case 303:
      if (lookahead == 'l') ADVANCE(405);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(407);
      END_STATE();
    case 306:
      if (lookahead == 't') ADVANCE(408);
      END_STATE();
    case 307:
      if (lookahead == 'a') ADVANCE(409);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(410);
      END_STATE();
    case 309:
      if (lookahead == 'i') ADVANCE(411);
      END_STATE();
    case 310:
      if (lookahead == 'v') ADVANCE(412);
      END_STATE();
    case 311:
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 312:
      if (lookahead == 'r') ADVANCE(414);
      END_STATE();
    case 313:
      if (lookahead == 'c') ADVANCE(415);
      END_STATE();
    case 314:
      if (lookahead == 's') ADVANCE(416);
      END_STATE();
    case 315:
      if (lookahead == 'e') ADVANCE(417);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 317:
      if (lookahead == 'l') ADVANCE(418);
      END_STATE();
    case 318:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 319:
      if (lookahead == 't') ADVANCE(420);
      END_STATE();
    case 320:
      if (lookahead == 'n') ADVANCE(421);
      END_STATE();
    case 321:
      if (lookahead == 'i') ADVANCE(422);
      END_STATE();
    case 322:
      if (lookahead == 'a') ADVANCE(423);
      if (lookahead == 'o') ADVANCE(424);
      END_STATE();
    case 323:
      if (lookahead == 'b') ADVANCE(425);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 325:
      if (lookahead == 'r') ADVANCE(426);
      END_STATE();
    case 326:
      if (lookahead == 'b') ADVANCE(427);
      END_STATE();
    case 327:
      if (lookahead == 'o') ADVANCE(428);
      END_STATE();
    case 328:
      if (lookahead == '6') ADVANCE(429);
      END_STATE();
    case 329:
      if (lookahead == '2') ADVANCE(430);
      END_STATE();
    case 330:
      if (lookahead == '4') ADVANCE(431);
      END_STATE();
    case 331:
      if (lookahead == '_') ADVANCE(432);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(433);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 335:
      if (lookahead == 'n') ADVANCE(436);
      END_STATE();
    case 336:
      if (lookahead == 'l') ADVANCE(437);
      END_STATE();
    case 337:
      if (lookahead == 'e') ADVANCE(438);
      END_STATE();
    case 338:
      if (lookahead == 'l') ADVANCE(439);
      END_STATE();
    case 339:
      if (lookahead == 'e') ADVANCE(219);
      END_STATE();
    case 340:
      if (lookahead == 'e') ADVANCE(440);
      END_STATE();
    case 341:
      if (lookahead == 'n') ADVANCE(441);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_highp);
      END_STATE();
    case 343:
      if (lookahead == 't') ADVANCE(442);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_inout);
      END_STATE();
    case 346:
      if (lookahead == '_') ADVANCE(444);
      END_STATE();
    case 347:
      if (lookahead == '_') ADVANCE(445);
      END_STATE();
    case 348:
      if (lookahead == '_') ADVANCE(446);
      END_STATE();
    case 349:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 350:
      if (lookahead == 'r') ADVANCE(447);
      END_STATE();
    case 351:
      if (lookahead == 'i') ADVANCE(448);
      END_STATE();
    case 352:
      if (lookahead == 't') ADVANCE(449);
      END_STATE();
    case 353:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 354:
      if (lookahead == 'm') ADVANCE(451);
      END_STATE();
    case 355:
      if (lookahead == 's') ADVANCE(452);
      END_STATE();
    case 356:
      if (lookahead == 'u') ADVANCE(453);
      END_STATE();
    case 357:
      if (lookahead == 't') ADVANCE(454);
      END_STATE();
    case 358:
      if (lookahead == 't') ADVANCE(455);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_patch);
      END_STATE();
    case 360:
      if (lookahead == 's') ADVANCE(456);
      END_STATE();
    case 361:
      if (lookahead == 'f') ADVANCE(457);
      END_STATE();
    case 362:
      if (lookahead == 'y') ADVANCE(458);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(459);
      END_STATE();
    case 364:
      if (lookahead == 't') ADVANCE(460);
      END_STATE();
    case 365:
      if (lookahead == 'r') ADVANCE(461);
      END_STATE();
    case 366:
      if (lookahead == 'i') ADVANCE(462);
      END_STATE();
    case 367:
      if (lookahead == 'n') ADVANCE(463);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(464);
      END_STATE();
    case 369:
      if (lookahead == 'r') ADVANCE(465);
      END_STATE();
    case 370:
      if (lookahead == 'd') ADVANCE(466);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 372:
      if (lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 373:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 374:
      if (lookahead == 'f') ADVANCE(468);
      END_STATE();
    case 375:
      if (lookahead == 'h') ADVANCE(469);
      END_STATE();
    case 376:
      if (lookahead == '_') ADVANCE(470);
      END_STATE();
    case 377:
      if (lookahead == 'c') ADVANCE(471);
      END_STATE();
    case 378:
      if (lookahead == 't') ADVANCE(472);
      END_STATE();
    case 379:
      if (lookahead == 'u') ADVANCE(473);
      END_STATE();
    case 380:
      if (lookahead == 'h') ADVANCE(474);
      END_STATE();
    case 381:
      if (lookahead == 'd') ADVANCE(475);
      END_STATE();
    case 382:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 383:
      if (lookahead == '6') ADVANCE(477);
      END_STATE();
    case 384:
      if (lookahead == '2') ADVANCE(478);
      END_STATE();
    case 385:
      if (lookahead == '4') ADVANCE(479);
      END_STATE();
    case 386:
      if (lookahead == '_') ADVANCE(480);
      END_STATE();
    case 387:
      if (lookahead == 't') ADVANCE(481);
      END_STATE();
    case 388:
      if (lookahead == 'r') ADVANCE(482);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 390:
      if (lookahead == 'n') ADVANCE(483);
      END_STATE();
    case 391:
      if (lookahead == 'n') ADVANCE(484);
      END_STATE();
    case 392:
      if (lookahead == 'i') ADVANCE(485);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 394:
      if (lookahead == 'o') ADVANCE(486);
      END_STATE();
    case 395:
      if (lookahead == 'a') ADVANCE(487);
      if (lookahead == 'o') ADVANCE(488);
      END_STATE();
    case 396:
      if (lookahead == 'c') ADVANCE(489);
      END_STATE();
    case 397:
      if (lookahead == 'i') ADVANCE(490);
      END_STATE();
    case 398:
      if (lookahead == 'u') ADVANCE(491);
      END_STATE();
    case 399:
      if (lookahead == 'n') ADVANCE(492);
      END_STATE();
    case 400:
      if (lookahead == '_') ADVANCE(493);
      END_STATE();
    case 401:
      if (lookahead == 'i') ADVANCE(494);
      END_STATE();
    case 402:
      if (lookahead == 'd') ADVANCE(495);
      END_STATE();
    case 403:
      if (lookahead == 'l') ADVANCE(496);
      END_STATE();
    case 404:
      if (lookahead == 'a') ADVANCE(497);
      END_STATE();
    case 405:
      if (lookahead == 's') ADVANCE(498);
      END_STATE();
    case 406:
      if (lookahead == 'p') ADVANCE(499);
      END_STATE();
    case 407:
      if (lookahead == 'n') ADVANCE(500);
      END_STATE();
    case 408:
      if (lookahead == 'c') ADVANCE(501);
      END_STATE();
    case 409:
      if (lookahead == 'l') ADVANCE(502);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(503);
      END_STATE();
    case 411:
      if (lookahead == 'n') ADVANCE(504);
      END_STATE();
    case 412:
      if (lookahead == 'e') ADVANCE(505);
      END_STATE();
    case 413:
      if (lookahead == 'r') ADVANCE(506);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 415:
      if (lookahead == 'a') ADVANCE(507);
      END_STATE();
    case 416:
      if (lookahead == 'c') ADVANCE(508);
      END_STATE();
    case 417:
      if (lookahead == 'a') ADVANCE(509);
      END_STATE();
    case 418:
      if (lookahead == 'i') ADVANCE(510);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 420:
      if (lookahead == 'o') ADVANCE(511);
      END_STATE();
    case 421:
      if (lookahead == 'o') ADVANCE(512);
      END_STATE();
    case 422:
      if (lookahead == 'g') ADVANCE(513);
      END_STATE();
    case 423:
      if (lookahead == 's') ADVANCE(514);
      END_STATE();
    case 424:
      if (lookahead == 'f') ADVANCE(515);
      END_STATE();
    case 425:
      if (lookahead == 'u') ADVANCE(516);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_buffer);
      END_STATE();
    case 427:
      if (lookahead == 'l') ADVANCE(517);
      END_STATE();
    case 428:
      if (lookahead == 'i') ADVANCE(518);
      END_STATE();
    case 429:
      if (lookahead == '_') ADVANCE(519);
      END_STATE();
    case 430:
      if (lookahead == '_') ADVANCE(520);
      END_STATE();
    case 431:
      if (lookahead == '_') ADVANCE(521);
      END_STATE();
    case 432:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 433:
      if (lookahead == 'r') ADVANCE(522);
      END_STATE();
    case 434:
      if (lookahead == 'n') ADVANCE(523);
      END_STATE();
    case 435:
      if (lookahead == 'x') ADVANCE(524);
      END_STATE();
    case 436:
      if (lookahead == 'u') ADVANCE(525);
      END_STATE();
    case 437:
      if (lookahead == 't') ADVANCE(526);
      END_STATE();
    case 438:
      if (lookahead == 'd') ADVANCE(527);
      END_STATE();
    case 439:
      if (lookahead == 'e') ADVANCE(528);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 442:
      if (lookahead == 'r') ADVANCE(529);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 444:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 445:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 446:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 447:
      if (lookahead == '_') ADVANCE(530);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(531);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_layout);
      END_STATE();
    case 450:
      if (lookahead == 'i') ADVANCE(532);
      END_STATE();
    case 451:
      if (lookahead == 'p') ADVANCE(533);
      END_STATE();
    case 452:
      if (lookahead == 'p') ADVANCE(534);
      END_STATE();
    case 453:
      if (lookahead == 'r') ADVANCE(535);
      END_STATE();
    case 454:
      if (lookahead == 'r') ADVANCE(536);
      END_STATE();
    case 455:
      if (lookahead == 'o') ADVANCE(537);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(538);
      if (lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 457:
      if (lookahead == 'f') ADVANCE(540);
      END_STATE();
    case 458:
      if (lookahead == 'l') ADVANCE(541);
      END_STATE();
    case 459:
      if (lookahead == 'l') ADVANCE(542);
      END_STATE();
    case 460:
      if (lookahead == 'e') ADVANCE(543);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 462:
      if (lookahead == 'c') ADVANCE(545);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_sample);
      END_STATE();
    case 465:
      if (lookahead == 'R') ADVANCE(546);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_smooth);
      END_STATE();
    case 470:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 473:
      if (lookahead == 't') ADVANCE(547);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 475:
      if (lookahead == '_') ADVANCE(548);
      END_STATE();
    case 476:
      if (lookahead == 'f') ADVANCE(549);
      END_STATE();
    case 477:
      if (lookahead == '_') ADVANCE(550);
      END_STATE();
    case 478:
      if (lookahead == '_') ADVANCE(551);
      END_STATE();
    case 479:
      if (lookahead == '_') ADVANCE(552);
      END_STATE();
    case 480:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 481:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 482:
      if (lookahead == 'm') ADVANCE(554);
      END_STATE();
    case 483:
      if (lookahead == 'e') ADVANCE(555);
      END_STATE();
    case 484:
      if (lookahead == 'g') ADVANCE(556);
      END_STATE();
    case 485:
      if (lookahead == 'l') ADVANCE(557);
      END_STATE();
    case 486:
      if (lookahead == 'n') ADVANCE(558);
      END_STATE();
    case 487:
      if (lookahead == 's') ADVANCE(559);
      END_STATE();
    case 488:
      if (lookahead == 'f') ADVANCE(560);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 490:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 491:
      if (lookahead == 'r') ADVANCE(562);
      END_STATE();
    case 492:
      if (lookahead == 'o') ADVANCE(563);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 494:
      if (lookahead == 'b') ADVANCE(564);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 497:
      if (lookahead == 'l') ADVANCE(565);
      END_STATE();
    case 498:
      if (lookahead == 'p') ADVANCE(566);
      END_STATE();
    case 499:
      if (lookahead == 't') ADVANCE(567);
      END_STATE();
    case 500:
      if (lookahead == 's') ADVANCE(568);
      END_STATE();
    case 501:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 502:
      if (lookahead == 'l') ADVANCE(570);
      END_STATE();
    case 503:
      if (lookahead == 'i') ADVANCE(571);
      END_STATE();
    case 504:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 506:
      if (lookahead == 'i') ADVANCE(573);
      END_STATE();
    case 507:
      if (lookahead == 'l') ADVANCE(574);
      END_STATE();
    case 508:
      if (lookahead == 'a') ADVANCE(575);
      END_STATE();
    case 509:
      if (lookahead == 'd') ADVANCE(576);
      END_STATE();
    case 510:
      if (lookahead == 'g') ADVANCE(577);
      END_STATE();
    case 511:
      if (lookahead == 'r') ADVANCE(578);
      END_STATE();
    case 512:
      if (lookahead == 'f') ADVANCE(579);
      END_STATE();
    case 513:
      if (lookahead == 'n') ADVANCE(580);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 516:
      if (lookahead == 't') ADVANCE(581);
      END_STATE();
    case 517:
      if (lookahead == 'e') ADVANCE(582);
      END_STATE();
    case 518:
      if (lookahead == 'd') ADVANCE(583);
      END_STATE();
    case 519:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 520:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 521:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 522:
      if (lookahead == '_') ADVANCE(584);
      END_STATE();
    case 523:
      if (lookahead == 't') ADVANCE(585);
      END_STATE();
    case 524:
      if (lookahead == 'p') ADVANCE(586);
      END_STATE();
    case 525:
      if (lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_disable);
      END_STATE();
    case 529:
      if (lookahead == 'i') ADVANCE(588);
      END_STATE();
    case 530:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 531:
      if (lookahead == 'n') ADVANCE(589);
      END_STATE();
    case 532:
      if (lookahead == 'g') ADVANCE(590);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_mediump);
      END_STATE();
    case 534:
      if (lookahead == 'e') ADVANCE(591);
      END_STATE();
    case 535:
      if (lookahead == 'n') ADVANCE(592);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_nullptr);
      if (lookahead == '_') ADVANCE(593);
      END_STATE();
    case 537:
      if (lookahead == 'f') ADVANCE(594);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_precise);
      END_STATE();
    case 539:
      if (lookahead == 'o') ADVANCE(595);
      END_STATE();
    case 540:
      if (lookahead == '_') ADVANCE(596);
      END_STATE();
    case 541:
      if (lookahead == 'o') ADVANCE(597);
      END_STATE();
    case 542:
      if (lookahead == 'y') ADVANCE(598);
      END_STATE();
    case 543:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 545:
      if (lookahead == 't') ADVANCE(600);
      END_STATE();
    case 546:
      if (lookahead == 'e') ADVANCE(601);
      END_STATE();
    case 547:
      if (lookahead == 'i') ADVANCE(602);
      END_STATE();
    case 548:
      if (lookahead == 'l') ADVANCE(603);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 550:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 551:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 552:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 553:
      if (lookahead == '_') ADVANCE(604);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 555:
      if (lookahead == 'd') ADVANCE(605);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_varying);
      END_STATE();
    case 557:
      if (lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 558:
      if (lookahead == 'l') ADVANCE(607);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(608);
      END_STATE();
    case 563:
      if (lookahead == 'f') ADVANCE(609);
      END_STATE();
    case 564:
      if (lookahead == 'u') ADVANCE(610);
      END_STATE();
    case 565:
      if (lookahead == 'l') ADVANCE(611);
      END_STATE();
    case 566:
      if (lookahead == 'e') ADVANCE(612);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 568:
      if (lookahead == 'i') ADVANCE(613);
      END_STATE();
    case 569:
      if (lookahead == 'l') ADVANCE(614);
      END_STATE();
    case 570:
      if (lookahead == 'y') ADVANCE(615);
      END_STATE();
    case 571:
      if (lookahead == 'n') ADVANCE(616);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(617);
      END_STATE();
    case 573:
      if (lookahead == 'c') ADVANCE(618);
      END_STATE();
    case 574:
      if (lookahead == 'l') ADVANCE(619);
      END_STATE();
    case 575:
      if (lookahead == 'l') ADVANCE(620);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 577:
      if (lookahead == 'n') ADVANCE(621);
      END_STATE();
    case 578:
      if (lookahead == 'c') ADVANCE(622);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 580:
      if (lookahead == 'e') ADVANCE(623);
      END_STATE();
    case 581:
      if (lookahead == 'e') ADVANCE(624);
      END_STATE();
    case 582:
      if (lookahead == 'D') ADVANCE(625);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_centroid);
      END_STATE();
    case 584:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_coherent);
      END_STATE();
    case 586:
      if (lookahead == 'r') ADVANCE(626);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 588:
      if (lookahead == 'b') ADVANCE(627);
      END_STATE();
    case 589:
      if (lookahead == 't') ADVANCE(628);
      END_STATE();
    case 590:
      if (lookahead == 'n') ADVANCE(629);
      END_STATE();
    case 591:
      if (lookahead == 'c') ADVANCE(630);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 593:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 595:
      if (lookahead == 'n') ADVANCE(631);
      END_STATE();
    case 596:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 597:
      if (lookahead == 'a') ADVANCE(632);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 601:
      if (lookahead == 'c') ADVANCE(633);
      END_STATE();
    case 602:
      if (lookahead == 'n') ADVANCE(634);
      END_STATE();
    case 603:
      if (lookahead == 'o') ADVANCE(635);
      END_STATE();
    case 604:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 607:
      if (lookahead == 'y') ADVANCE(636);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(637);
      END_STATE();
    case 610:
      if (lookahead == 't') ADVANCE(638);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 612:
      if (lookahead == 'c') ADVANCE(639);
      END_STATE();
    case 613:
      if (lookahead == 'o') ADVANCE(640);
      END_STATE();
    case 614:
      if (lookahead == 'l') ADVANCE(641);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 616:
      if (lookahead == 'l') ADVANCE(642);
      END_STATE();
    case 617:
      if (lookahead == '_') ADVANCE(643);
      END_STATE();
    case 618:
      if (lookahead == 't') ADVANCE(644);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 620:
      if (lookahead == 'l') ADVANCE(645);
      END_STATE();
    case 621:
      if (lookahead == 'e') ADVANCE(646);
      END_STATE();
    case 622:
      if (lookahead == 'a') ADVANCE(647);
      END_STATE();
    case 623:
      if (lookahead == 'd') ADVANCE(648);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_attribute);
      END_STATE();
    case 625:
      if (lookahead == 'a') ADVANCE(649);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 627:
      if (lookahead == 'u') ADVANCE(650);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_invariant);
      END_STATE();
    case 629:
      if (lookahead == '_') ADVANCE(651);
      END_STATE();
    case 630:
      if (lookahead == 't') ADVANCE(652);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_precision);
      END_STATE();
    case 632:
      if (lookahead == 'd') ADVANCE(653);
      END_STATE();
    case 633:
      if (lookahead == 'o') ADVANCE(654);
      END_STATE();
    case 634:
      if (lookahead == 'e') ADVANCE(655);
      END_STATE();
    case 635:
      if (lookahead == 'c') ADVANCE(656);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(anon_sym_writeonly);
      END_STATE();
    case 637:
      if (lookahead == '_') ADVANCE(657);
      END_STATE();
    case 638:
      if (lookahead == 'e') ADVANCE(658);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 640:
      if (lookahead == 'n') ADVANCE(659);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 642:
      if (lookahead == 'i') ADVANCE(660);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(661);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 646:
      if (lookahead == 'd') ADVANCE(662);
      END_STATE();
    case 647:
      if (lookahead == 'l') ADVANCE(663);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 649:
      if (lookahead == 't') ADVANCE(664);
      END_STATE();
    case 650:
      if (lookahead == 't') ADVANCE(665);
      END_STATE();
    case 651:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 652:
      if (lookahead == 'i') ADVANCE(666);
      END_STATE();
    case 653:
      if (lookahead == 'E') ADVANCE(667);
      if (lookahead == 'I') ADVANCE(668);
      if (lookahead == 'N') ADVANCE(669);
      END_STATE();
    case 654:
      if (lookahead == 'r') ADVANCE(670);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_subroutine);
      END_STATE();
    case 656:
      if (lookahead == 'a') ADVANCE(671);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 658:
      if (lookahead == '_') ADVANCE(672);
      END_STATE();
    case 659:
      if (lookahead == '_') ADVANCE(673);
      END_STATE();
    case 660:
      if (lookahead == 'n') ADVANCE(674);
      END_STATE();
    case 661:
      if (lookahead == '_') ADVANCE(675);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 663:
      if (lookahead == 'l') ADVANCE(676);
      END_STATE();
    case 664:
      if (lookahead == 'a') ADVANCE(677);
      END_STATE();
    case 665:
      if (lookahead == 'e') ADVANCE(678);
      END_STATE();
    case 666:
      if (lookahead == 'v') ADVANCE(679);
      END_STATE();
    case 667:
      if (lookahead == 'X') ADVANCE(680);
      END_STATE();
    case 668:
      if (lookahead == 'n') ADVANCE(681);
      END_STATE();
    case 669:
      if (lookahead == 'V') ADVANCE(682);
      END_STATE();
    case 670:
      if (lookahead == 'd') ADVANCE(683);
      END_STATE();
    case 671:
      if (lookahead == 'l') ADVANCE(684);
      END_STATE();
    case 672:
      if (lookahead == '_') ADVANCE(685);
      END_STATE();
    case 673:
      if (lookahead == '_') ADVANCE(686);
      END_STATE();
    case 674:
      if (lookahead == 'e') ADVANCE(687);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 677:
      if (lookahead == 'E') ADVANCE(688);
      if (lookahead == 'I') ADVANCE(689);
      if (lookahead == 'N') ADVANCE(690);
      END_STATE();
    case 678:
      if (lookahead == 'E') ADVANCE(691);
      if (lookahead == 'N') ADVANCE(692);
      END_STATE();
    case 679:
      if (lookahead == 'e') ADVANCE(693);
      END_STATE();
    case 680:
      if (lookahead == 'T') ADVANCE(694);
      END_STATE();
    case 681:
      if (lookahead == 'E') ADVANCE(695);
      if (lookahead == 'N') ADVANCE(696);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym_rayPayloadNV);
      END_STATE();
    case 683:
      if (lookahead == 'E') ADVANCE(697);
      if (lookahead == 'N') ADVANCE(698);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 688:
      if (lookahead == 'X') ADVANCE(699);
      END_STATE();
    case 689:
      if (lookahead == 'n') ADVANCE(700);
      END_STATE();
    case 690:
      if (lookahead == 'V') ADVANCE(701);
      END_STATE();
    case 691:
      if (lookahead == 'X') ADVANCE(702);
      END_STATE();
    case 692:
      if (lookahead == 'V') ADVANCE(703);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(anon_sym_noperspective);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_rayPayloadEXT);
      END_STATE();
    case 695:
      if (lookahead == 'X') ADVANCE(704);
      END_STATE();
    case 696:
      if (lookahead == 'V') ADVANCE(705);
      END_STATE();
    case 697:
      if (lookahead == 'X') ADVANCE(706);
      END_STATE();
    case 698:
      if (lookahead == 'V') ADVANCE(707);
      END_STATE();
    case 699:
      if (lookahead == 'T') ADVANCE(708);
      END_STATE();
    case 700:
      if (lookahead == 'E') ADVANCE(709);
      if (lookahead == 'N') ADVANCE(710);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_callableDataNV);
      END_STATE();
    case 702:
      if (lookahead == 'T') ADVANCE(711);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(anon_sym_hitAttributeNV);
      END_STATE();
    case 704:
      if (lookahead == 'T') ADVANCE(712);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym_rayPayloadInNV);
      END_STATE();
    case 706:
      if (lookahead == 'T') ADVANCE(713);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(anon_sym_shaderRecordNV);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(anon_sym_callableDataEXT);
      END_STATE();
    case 709:
      if (lookahead == 'X') ADVANCE(714);
      END_STATE();
    case 710:
      if (lookahead == 'V') ADVANCE(715);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(anon_sym_hitAttributeEXT);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(anon_sym_rayPayloadInEXT);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(anon_sym_shaderRecordEXT);
      END_STATE();
    case 714:
      if (lookahead == 'T') ADVANCE(716);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(anon_sym_callableDataInNV);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(anon_sym_callableDataInEXT);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 123},
  [2] = {.lex_state = 47},
  [3] = {.lex_state = 47},
  [4] = {.lex_state = 47},
  [5] = {.lex_state = 47},
  [6] = {.lex_state = 47},
  [7] = {.lex_state = 47},
  [8] = {.lex_state = 47},
  [9] = {.lex_state = 47},
  [10] = {.lex_state = 47},
  [11] = {.lex_state = 47},
  [12] = {.lex_state = 47},
  [13] = {.lex_state = 47},
  [14] = {.lex_state = 47},
  [15] = {.lex_state = 47},
  [16] = {.lex_state = 47},
  [17] = {.lex_state = 47},
  [18] = {.lex_state = 47},
  [19] = {.lex_state = 47},
  [20] = {.lex_state = 47},
  [21] = {.lex_state = 47},
  [22] = {.lex_state = 47},
  [23] = {.lex_state = 123},
  [24] = {.lex_state = 123},
  [25] = {.lex_state = 123},
  [26] = {.lex_state = 123},
  [27] = {.lex_state = 123},
  [28] = {.lex_state = 123},
  [29] = {.lex_state = 123},
  [30] = {.lex_state = 49},
  [31] = {.lex_state = 123},
  [32] = {.lex_state = 49},
  [33] = {.lex_state = 123},
  [34] = {.lex_state = 123},
  [35] = {.lex_state = 123},
  [36] = {.lex_state = 123},
  [37] = {.lex_state = 123},
  [38] = {.lex_state = 123},
  [39] = {.lex_state = 123},
  [40] = {.lex_state = 123},
  [41] = {.lex_state = 123},
  [42] = {.lex_state = 49},
  [43] = {.lex_state = 123},
  [44] = {.lex_state = 123},
  [45] = {.lex_state = 47},
  [46] = {.lex_state = 47},
  [47] = {.lex_state = 47},
  [48] = {.lex_state = 47},
  [49] = {.lex_state = 47},
  [50] = {.lex_state = 123},
  [51] = {.lex_state = 49},
  [52] = {.lex_state = 49},
  [53] = {.lex_state = 49},
  [54] = {.lex_state = 123},
  [55] = {.lex_state = 49},
  [56] = {.lex_state = 123},
  [57] = {.lex_state = 123},
  [58] = {.lex_state = 123},
  [59] = {.lex_state = 123},
  [60] = {.lex_state = 123},
  [61] = {.lex_state = 123},
  [62] = {.lex_state = 49},
  [63] = {.lex_state = 123},
  [64] = {.lex_state = 123},
  [65] = {.lex_state = 123},
  [66] = {.lex_state = 123},
  [67] = {.lex_state = 123},
  [68] = {.lex_state = 123},
  [69] = {.lex_state = 123},
  [70] = {.lex_state = 123},
  [71] = {.lex_state = 123},
  [72] = {.lex_state = 123},
  [73] = {.lex_state = 123},
  [74] = {.lex_state = 123},
  [75] = {.lex_state = 47},
  [76] = {.lex_state = 47},
  [77] = {.lex_state = 47},
  [78] = {.lex_state = 47},
  [79] = {.lex_state = 47},
  [80] = {.lex_state = 47},
  [81] = {.lex_state = 47},
  [82] = {.lex_state = 47},
  [83] = {.lex_state = 47},
  [84] = {.lex_state = 47},
  [85] = {.lex_state = 47},
  [86] = {.lex_state = 47},
  [87] = {.lex_state = 47},
  [88] = {.lex_state = 47},
  [89] = {.lex_state = 47},
  [90] = {.lex_state = 47},
  [91] = {.lex_state = 47},
  [92] = {.lex_state = 47},
  [93] = {.lex_state = 47},
  [94] = {.lex_state = 47},
  [95] = {.lex_state = 47},
  [96] = {.lex_state = 47},
  [97] = {.lex_state = 47},
  [98] = {.lex_state = 47},
  [99] = {.lex_state = 47},
  [100] = {.lex_state = 47},
  [101] = {.lex_state = 47},
  [102] = {.lex_state = 47},
  [103] = {.lex_state = 47},
  [104] = {.lex_state = 47},
  [105] = {.lex_state = 123},
  [106] = {.lex_state = 47},
  [107] = {.lex_state = 47},
  [108] = {.lex_state = 47},
  [109] = {.lex_state = 47},
  [110] = {.lex_state = 47},
  [111] = {.lex_state = 47},
  [112] = {.lex_state = 47},
  [113] = {.lex_state = 123},
  [114] = {.lex_state = 47},
  [115] = {.lex_state = 47},
  [116] = {.lex_state = 47},
  [117] = {.lex_state = 47},
  [118] = {.lex_state = 47},
  [119] = {.lex_state = 47},
  [120] = {.lex_state = 47},
  [121] = {.lex_state = 47},
  [122] = {.lex_state = 47},
  [123] = {.lex_state = 47},
  [124] = {.lex_state = 47},
  [125] = {.lex_state = 47},
  [126] = {.lex_state = 47},
  [127] = {.lex_state = 47},
  [128] = {.lex_state = 47},
  [129] = {.lex_state = 47},
  [130] = {.lex_state = 47},
  [131] = {.lex_state = 47},
  [132] = {.lex_state = 47},
  [133] = {.lex_state = 47},
  [134] = {.lex_state = 47},
  [135] = {.lex_state = 47},
  [136] = {.lex_state = 47},
  [137] = {.lex_state = 47},
  [138] = {.lex_state = 47},
  [139] = {.lex_state = 47},
  [140] = {.lex_state = 47},
  [141] = {.lex_state = 47},
  [142] = {.lex_state = 47},
  [143] = {.lex_state = 47},
  [144] = {.lex_state = 47},
  [145] = {.lex_state = 47},
  [146] = {.lex_state = 47},
  [147] = {.lex_state = 47},
  [148] = {.lex_state = 47},
  [149] = {.lex_state = 47},
  [150] = {.lex_state = 47},
  [151] = {.lex_state = 47},
  [152] = {.lex_state = 47},
  [153] = {.lex_state = 47},
  [154] = {.lex_state = 47},
  [155] = {.lex_state = 47},
  [156] = {.lex_state = 47},
  [157] = {.lex_state = 47},
  [158] = {.lex_state = 47},
  [159] = {.lex_state = 47},
  [160] = {.lex_state = 47},
  [161] = {.lex_state = 47},
  [162] = {.lex_state = 47},
  [163] = {.lex_state = 47},
  [164] = {.lex_state = 47},
  [165] = {.lex_state = 47},
  [166] = {.lex_state = 47},
  [167] = {.lex_state = 47},
  [168] = {.lex_state = 123},
  [169] = {.lex_state = 123},
  [170] = {.lex_state = 49},
  [171] = {.lex_state = 123},
  [172] = {.lex_state = 49},
  [173] = {.lex_state = 123},
  [174] = {.lex_state = 123},
  [175] = {.lex_state = 123},
  [176] = {.lex_state = 123},
  [177] = {.lex_state = 123},
  [178] = {.lex_state = 123},
  [179] = {.lex_state = 123},
  [180] = {.lex_state = 123},
  [181] = {.lex_state = 123},
  [182] = {.lex_state = 123},
  [183] = {.lex_state = 123},
  [184] = {.lex_state = 123},
  [185] = {.lex_state = 123},
  [186] = {.lex_state = 123},
  [187] = {.lex_state = 123},
  [188] = {.lex_state = 123},
  [189] = {.lex_state = 123},
  [190] = {.lex_state = 123},
  [191] = {.lex_state = 123},
  [192] = {.lex_state = 49},
  [193] = {.lex_state = 123},
  [194] = {.lex_state = 49},
  [195] = {.lex_state = 123},
  [196] = {.lex_state = 123},
  [197] = {.lex_state = 123},
  [198] = {.lex_state = 123},
  [199] = {.lex_state = 49},
  [200] = {.lex_state = 123},
  [201] = {.lex_state = 123},
  [202] = {.lex_state = 123},
  [203] = {.lex_state = 123},
  [204] = {.lex_state = 123},
  [205] = {.lex_state = 123},
  [206] = {.lex_state = 123},
  [207] = {.lex_state = 123},
  [208] = {.lex_state = 123},
  [209] = {.lex_state = 49},
  [210] = {.lex_state = 123},
  [211] = {.lex_state = 123},
  [212] = {.lex_state = 123},
  [213] = {.lex_state = 123},
  [214] = {.lex_state = 123},
  [215] = {.lex_state = 123},
  [216] = {.lex_state = 123},
  [217] = {.lex_state = 123},
  [218] = {.lex_state = 123},
  [219] = {.lex_state = 123},
  [220] = {.lex_state = 49},
  [221] = {.lex_state = 123},
  [222] = {.lex_state = 123},
  [223] = {.lex_state = 123},
  [224] = {.lex_state = 123},
  [225] = {.lex_state = 123},
  [226] = {.lex_state = 123},
  [227] = {.lex_state = 123},
  [228] = {.lex_state = 123},
  [229] = {.lex_state = 49},
  [230] = {.lex_state = 123},
  [231] = {.lex_state = 123},
  [232] = {.lex_state = 49},
  [233] = {.lex_state = 49},
  [234] = {.lex_state = 123},
  [235] = {.lex_state = 49},
  [236] = {.lex_state = 49},
  [237] = {.lex_state = 49},
  [238] = {.lex_state = 123},
  [239] = {.lex_state = 123},
  [240] = {.lex_state = 123},
  [241] = {.lex_state = 123},
  [242] = {.lex_state = 123},
  [243] = {.lex_state = 123},
  [244] = {.lex_state = 49},
  [245] = {.lex_state = 123},
  [246] = {.lex_state = 49},
  [247] = {.lex_state = 49},
  [248] = {.lex_state = 123},
  [249] = {.lex_state = 123},
  [250] = {.lex_state = 49},
  [251] = {.lex_state = 49},
  [252] = {.lex_state = 49},
  [253] = {.lex_state = 123},
  [254] = {.lex_state = 49},
  [255] = {.lex_state = 123},
  [256] = {.lex_state = 49},
  [257] = {.lex_state = 49},
  [258] = {.lex_state = 49},
  [259] = {.lex_state = 123},
  [260] = {.lex_state = 49},
  [261] = {.lex_state = 49},
  [262] = {.lex_state = 49},
  [263] = {.lex_state = 123},
  [264] = {.lex_state = 49},
  [265] = {.lex_state = 123},
  [266] = {.lex_state = 49},
  [267] = {.lex_state = 123},
  [268] = {.lex_state = 49},
  [269] = {.lex_state = 49},
  [270] = {.lex_state = 49},
  [271] = {.lex_state = 49},
  [272] = {.lex_state = 49},
  [273] = {.lex_state = 123},
  [274] = {.lex_state = 49},
  [275] = {.lex_state = 49},
  [276] = {.lex_state = 123},
  [277] = {.lex_state = 123},
  [278] = {.lex_state = 49},
  [279] = {.lex_state = 123},
  [280] = {.lex_state = 49},
  [281] = {.lex_state = 123},
  [282] = {.lex_state = 123},
  [283] = {.lex_state = 49},
  [284] = {.lex_state = 123},
  [285] = {.lex_state = 49},
  [286] = {.lex_state = 123},
  [287] = {.lex_state = 123},
  [288] = {.lex_state = 123},
  [289] = {.lex_state = 49},
  [290] = {.lex_state = 49},
  [291] = {.lex_state = 123},
  [292] = {.lex_state = 49},
  [293] = {.lex_state = 123},
  [294] = {.lex_state = 123},
  [295] = {.lex_state = 123},
  [296] = {.lex_state = 123},
  [297] = {.lex_state = 123},
  [298] = {.lex_state = 123},
  [299] = {.lex_state = 123},
  [300] = {.lex_state = 49},
  [301] = {.lex_state = 49},
  [302] = {.lex_state = 123},
  [303] = {.lex_state = 49},
  [304] = {.lex_state = 49},
  [305] = {.lex_state = 49},
  [306] = {.lex_state = 49},
  [307] = {.lex_state = 123},
  [308] = {.lex_state = 123},
  [309] = {.lex_state = 123},
  [310] = {.lex_state = 123},
  [311] = {.lex_state = 49},
  [312] = {.lex_state = 49},
  [313] = {.lex_state = 123},
  [314] = {.lex_state = 123},
  [315] = {.lex_state = 123},
  [316] = {.lex_state = 49},
  [317] = {.lex_state = 123},
  [318] = {.lex_state = 123},
  [319] = {.lex_state = 123},
  [320] = {.lex_state = 49},
  [321] = {.lex_state = 49},
  [322] = {.lex_state = 49},
  [323] = {.lex_state = 49},
  [324] = {.lex_state = 49},
  [325] = {.lex_state = 123},
  [326] = {.lex_state = 123},
  [327] = {.lex_state = 49},
  [328] = {.lex_state = 49},
  [329] = {.lex_state = 49},
  [330] = {.lex_state = 49},
  [331] = {.lex_state = 123},
  [332] = {.lex_state = 49},
  [333] = {.lex_state = 49},
  [334] = {.lex_state = 49},
  [335] = {.lex_state = 49},
  [336] = {.lex_state = 123},
  [337] = {.lex_state = 49},
  [338] = {.lex_state = 49},
  [339] = {.lex_state = 49},
  [340] = {.lex_state = 49},
  [341] = {.lex_state = 123},
  [342] = {.lex_state = 49},
  [343] = {.lex_state = 49},
  [344] = {.lex_state = 49},
  [345] = {.lex_state = 49},
  [346] = {.lex_state = 49},
  [347] = {.lex_state = 49},
  [348] = {.lex_state = 49},
  [349] = {.lex_state = 49},
  [350] = {.lex_state = 123},
  [351] = {.lex_state = 49},
  [352] = {.lex_state = 49},
  [353] = {.lex_state = 49},
  [354] = {.lex_state = 49},
  [355] = {.lex_state = 49},
  [356] = {.lex_state = 49},
  [357] = {.lex_state = 49},
  [358] = {.lex_state = 123},
  [359] = {.lex_state = 49},
  [360] = {.lex_state = 123},
  [361] = {.lex_state = 49},
  [362] = {.lex_state = 49},
  [363] = {.lex_state = 49},
  [364] = {.lex_state = 49},
  [365] = {.lex_state = 49},
  [366] = {.lex_state = 123},
  [367] = {.lex_state = 123},
  [368] = {.lex_state = 123},
  [369] = {.lex_state = 123},
  [370] = {.lex_state = 123},
  [371] = {.lex_state = 123},
  [372] = {.lex_state = 123},
  [373] = {.lex_state = 123},
  [374] = {.lex_state = 49},
  [375] = {.lex_state = 49},
  [376] = {.lex_state = 123},
  [377] = {.lex_state = 123},
  [378] = {.lex_state = 123},
  [379] = {.lex_state = 123},
  [380] = {.lex_state = 123},
  [381] = {.lex_state = 123},
  [382] = {.lex_state = 123},
  [383] = {.lex_state = 123},
  [384] = {.lex_state = 123},
  [385] = {.lex_state = 123},
  [386] = {.lex_state = 123},
  [387] = {.lex_state = 123},
  [388] = {.lex_state = 123},
  [389] = {.lex_state = 123},
  [390] = {.lex_state = 123},
  [391] = {.lex_state = 123},
  [392] = {.lex_state = 123},
  [393] = {.lex_state = 123},
  [394] = {.lex_state = 123},
  [395] = {.lex_state = 123},
  [396] = {.lex_state = 123},
  [397] = {.lex_state = 123},
  [398] = {.lex_state = 123},
  [399] = {.lex_state = 123},
  [400] = {.lex_state = 123},
  [401] = {.lex_state = 123},
  [402] = {.lex_state = 123},
  [403] = {.lex_state = 123},
  [404] = {.lex_state = 123},
  [405] = {.lex_state = 123},
  [406] = {.lex_state = 123},
  [407] = {.lex_state = 123},
  [408] = {.lex_state = 123},
  [409] = {.lex_state = 123},
  [410] = {.lex_state = 123},
  [411] = {.lex_state = 123},
  [412] = {.lex_state = 123},
  [413] = {.lex_state = 123},
  [414] = {.lex_state = 123},
  [415] = {.lex_state = 123},
  [416] = {.lex_state = 123},
  [417] = {.lex_state = 123},
  [418] = {.lex_state = 123},
  [419] = {.lex_state = 123},
  [420] = {.lex_state = 123},
  [421] = {.lex_state = 123},
  [422] = {.lex_state = 123},
  [423] = {.lex_state = 123},
  [424] = {.lex_state = 123},
  [425] = {.lex_state = 123},
  [426] = {.lex_state = 123},
  [427] = {.lex_state = 123},
  [428] = {.lex_state = 123},
  [429] = {.lex_state = 123},
  [430] = {.lex_state = 123},
  [431] = {.lex_state = 123},
  [432] = {.lex_state = 123},
  [433] = {.lex_state = 123},
  [434] = {.lex_state = 123},
  [435] = {.lex_state = 123},
  [436] = {.lex_state = 123},
  [437] = {.lex_state = 123},
  [438] = {.lex_state = 123},
  [439] = {.lex_state = 123},
  [440] = {.lex_state = 123},
  [441] = {.lex_state = 55},
  [442] = {.lex_state = 55},
  [443] = {.lex_state = 55},
  [444] = {.lex_state = 55},
  [445] = {.lex_state = 55},
  [446] = {.lex_state = 55},
  [447] = {.lex_state = 55},
  [448] = {.lex_state = 55},
  [449] = {.lex_state = 55},
  [450] = {.lex_state = 55},
  [451] = {.lex_state = 55},
  [452] = {.lex_state = 55},
  [453] = {.lex_state = 55},
  [454] = {.lex_state = 55},
  [455] = {.lex_state = 55},
  [456] = {.lex_state = 55},
  [457] = {.lex_state = 55},
  [458] = {.lex_state = 56},
  [459] = {.lex_state = 60},
  [460] = {.lex_state = 60},
  [461] = {.lex_state = 60},
  [462] = {.lex_state = 56},
  [463] = {.lex_state = 56},
  [464] = {.lex_state = 55},
  [465] = {.lex_state = 55},
  [466] = {.lex_state = 55},
  [467] = {.lex_state = 55},
  [468] = {.lex_state = 55},
  [469] = {.lex_state = 46},
  [470] = {.lex_state = 46},
  [471] = {.lex_state = 123},
  [472] = {.lex_state = 123},
  [473] = {.lex_state = 123},
  [474] = {.lex_state = 55},
  [475] = {.lex_state = 123},
  [476] = {.lex_state = 123},
  [477] = {.lex_state = 123},
  [478] = {.lex_state = 123},
  [479] = {.lex_state = 123},
  [480] = {.lex_state = 123},
  [481] = {.lex_state = 123},
  [482] = {.lex_state = 123},
  [483] = {.lex_state = 123},
  [484] = {.lex_state = 123},
  [485] = {.lex_state = 123},
  [486] = {.lex_state = 123},
  [487] = {.lex_state = 123},
  [488] = {.lex_state = 123},
  [489] = {.lex_state = 123},
  [490] = {.lex_state = 123},
  [491] = {.lex_state = 123},
  [492] = {.lex_state = 123},
  [493] = {.lex_state = 123},
  [494] = {.lex_state = 123},
  [495] = {.lex_state = 123},
  [496] = {.lex_state = 123},
  [497] = {.lex_state = 123},
  [498] = {.lex_state = 123},
  [499] = {.lex_state = 55},
  [500] = {.lex_state = 123},
  [501] = {.lex_state = 55},
  [502] = {.lex_state = 123},
  [503] = {.lex_state = 55},
  [504] = {.lex_state = 123},
  [505] = {.lex_state = 123},
  [506] = {.lex_state = 123},
  [507] = {.lex_state = 123},
  [508] = {.lex_state = 123},
  [509] = {.lex_state = 123},
  [510] = {.lex_state = 123},
  [511] = {.lex_state = 123},
  [512] = {.lex_state = 123},
  [513] = {.lex_state = 123},
  [514] = {.lex_state = 46},
  [515] = {.lex_state = 55},
  [516] = {.lex_state = 123},
  [517] = {.lex_state = 55},
  [518] = {.lex_state = 123},
  [519] = {.lex_state = 123},
  [520] = {.lex_state = 55},
  [521] = {.lex_state = 123},
  [522] = {.lex_state = 123},
  [523] = {.lex_state = 55},
  [524] = {.lex_state = 123},
  [525] = {.lex_state = 55},
  [526] = {.lex_state = 55},
  [527] = {.lex_state = 55},
  [528] = {.lex_state = 55},
  [529] = {.lex_state = 123},
  [530] = {.lex_state = 123},
  [531] = {.lex_state = 123},
  [532] = {.lex_state = 55},
  [533] = {.lex_state = 123},
  [534] = {.lex_state = 123},
  [535] = {.lex_state = 123},
  [536] = {.lex_state = 123},
  [537] = {.lex_state = 123},
  [538] = {.lex_state = 123},
  [539] = {.lex_state = 123},
  [540] = {.lex_state = 52},
  [541] = {.lex_state = 52},
  [542] = {.lex_state = 46},
  [543] = {.lex_state = 52},
  [544] = {.lex_state = 52},
  [545] = {.lex_state = 52},
  [546] = {.lex_state = 52},
  [547] = {.lex_state = 52},
  [548] = {.lex_state = 52},
  [549] = {.lex_state = 46},
  [550] = {.lex_state = 52},
  [551] = {.lex_state = 52},
  [552] = {.lex_state = 123},
  [553] = {.lex_state = 55},
  [554] = {.lex_state = 55},
  [555] = {.lex_state = 55},
  [556] = {.lex_state = 55},
  [557] = {.lex_state = 55},
  [558] = {.lex_state = 55},
  [559] = {.lex_state = 55},
  [560] = {.lex_state = 55},
  [561] = {.lex_state = 55},
  [562] = {.lex_state = 55},
  [563] = {.lex_state = 55},
  [564] = {.lex_state = 55},
  [565] = {.lex_state = 55},
  [566] = {.lex_state = 55},
  [567] = {.lex_state = 55},
  [568] = {.lex_state = 55},
  [569] = {.lex_state = 55},
  [570] = {.lex_state = 55},
  [571] = {.lex_state = 55},
  [572] = {.lex_state = 55},
  [573] = {.lex_state = 55},
  [574] = {.lex_state = 46},
  [575] = {.lex_state = 55},
  [576] = {.lex_state = 55},
  [577] = {.lex_state = 55},
  [578] = {.lex_state = 60},
  [579] = {.lex_state = 56},
  [580] = {.lex_state = 56},
  [581] = {.lex_state = 60},
  [582] = {.lex_state = 56},
  [583] = {.lex_state = 56},
  [584] = {.lex_state = 60},
  [585] = {.lex_state = 60},
  [586] = {.lex_state = 56},
  [587] = {.lex_state = 60},
  [588] = {.lex_state = 56},
  [589] = {.lex_state = 60},
  [590] = {.lex_state = 60},
  [591] = {.lex_state = 60},
  [592] = {.lex_state = 56},
  [593] = {.lex_state = 56},
  [594] = {.lex_state = 60},
  [595] = {.lex_state = 60},
  [596] = {.lex_state = 56},
  [597] = {.lex_state = 60},
  [598] = {.lex_state = 56},
  [599] = {.lex_state = 60},
  [600] = {.lex_state = 60},
  [601] = {.lex_state = 60},
  [602] = {.lex_state = 56},
  [603] = {.lex_state = 56},
  [604] = {.lex_state = 60},
  [605] = {.lex_state = 60},
  [606] = {.lex_state = 60},
  [607] = {.lex_state = 56},
  [608] = {.lex_state = 60},
  [609] = {.lex_state = 60},
  [610] = {.lex_state = 56},
  [611] = {.lex_state = 56},
  [612] = {.lex_state = 56},
  [613] = {.lex_state = 56},
  [614] = {.lex_state = 60},
  [615] = {.lex_state = 56},
  [616] = {.lex_state = 56},
  [617] = {.lex_state = 60},
  [618] = {.lex_state = 56},
  [619] = {.lex_state = 56},
  [620] = {.lex_state = 56},
  [621] = {.lex_state = 60},
  [622] = {.lex_state = 123},
  [623] = {.lex_state = 123},
  [624] = {.lex_state = 123},
  [625] = {.lex_state = 123},
  [626] = {.lex_state = 123},
  [627] = {.lex_state = 55},
  [628] = {.lex_state = 123},
  [629] = {.lex_state = 123},
  [630] = {.lex_state = 123},
  [631] = {.lex_state = 123},
  [632] = {.lex_state = 123},
  [633] = {.lex_state = 55},
  [634] = {.lex_state = 55},
  [635] = {.lex_state = 55},
  [636] = {.lex_state = 55},
  [637] = {.lex_state = 55},
  [638] = {.lex_state = 55},
  [639] = {.lex_state = 55},
  [640] = {.lex_state = 55},
  [641] = {.lex_state = 55},
  [642] = {.lex_state = 55},
  [643] = {.lex_state = 55},
  [644] = {.lex_state = 55},
  [645] = {.lex_state = 123},
  [646] = {.lex_state = 123},
  [647] = {.lex_state = 123},
  [648] = {.lex_state = 123},
  [649] = {.lex_state = 123},
  [650] = {.lex_state = 123},
  [651] = {.lex_state = 123},
  [652] = {.lex_state = 123},
  [653] = {.lex_state = 123},
  [654] = {.lex_state = 123},
  [655] = {.lex_state = 123},
  [656] = {.lex_state = 123},
  [657] = {.lex_state = 123},
  [658] = {.lex_state = 123},
  [659] = {.lex_state = 123},
  [660] = {.lex_state = 123},
  [661] = {.lex_state = 52},
  [662] = {.lex_state = 123},
  [663] = {.lex_state = 123},
  [664] = {.lex_state = 123},
  [665] = {.lex_state = 123},
  [666] = {.lex_state = 123},
  [667] = {.lex_state = 123},
  [668] = {.lex_state = 123},
  [669] = {.lex_state = 123},
  [670] = {.lex_state = 123},
  [671] = {.lex_state = 123},
  [672] = {.lex_state = 123},
  [673] = {.lex_state = 123},
  [674] = {.lex_state = 123},
  [675] = {.lex_state = 123},
  [676] = {.lex_state = 123},
  [677] = {.lex_state = 123},
  [678] = {.lex_state = 123},
  [679] = {.lex_state = 123},
  [680] = {.lex_state = 123},
  [681] = {.lex_state = 123},
  [682] = {.lex_state = 123},
  [683] = {.lex_state = 123},
  [684] = {.lex_state = 123},
  [685] = {.lex_state = 123},
  [686] = {.lex_state = 123},
  [687] = {.lex_state = 123},
  [688] = {.lex_state = 123},
  [689] = {.lex_state = 123},
  [690] = {.lex_state = 123},
  [691] = {.lex_state = 123},
  [692] = {.lex_state = 123},
  [693] = {.lex_state = 123},
  [694] = {.lex_state = 123},
  [695] = {.lex_state = 123},
  [696] = {.lex_state = 123},
  [697] = {.lex_state = 123},
  [698] = {.lex_state = 123},
  [699] = {.lex_state = 123},
  [700] = {.lex_state = 123},
  [701] = {.lex_state = 123},
  [702] = {.lex_state = 123},
  [703] = {.lex_state = 123},
  [704] = {.lex_state = 123},
  [705] = {.lex_state = 123},
  [706] = {.lex_state = 123},
  [707] = {.lex_state = 123},
  [708] = {.lex_state = 123},
  [709] = {.lex_state = 123},
  [710] = {.lex_state = 123},
  [711] = {.lex_state = 123},
  [712] = {.lex_state = 123},
  [713] = {.lex_state = 123},
  [714] = {.lex_state = 123},
  [715] = {.lex_state = 123},
  [716] = {.lex_state = 123},
  [717] = {.lex_state = 123},
  [718] = {.lex_state = 123},
  [719] = {.lex_state = 123},
  [720] = {.lex_state = 123},
  [721] = {.lex_state = 123},
  [722] = {.lex_state = 123},
  [723] = {.lex_state = 123},
  [724] = {.lex_state = 123},
  [725] = {.lex_state = 123},
  [726] = {.lex_state = 123},
  [727] = {.lex_state = 123},
  [728] = {.lex_state = 123},
  [729] = {.lex_state = 123},
  [730] = {.lex_state = 123},
  [731] = {.lex_state = 123},
  [732] = {.lex_state = 123},
  [733] = {.lex_state = 123},
  [734] = {.lex_state = 123},
  [735] = {.lex_state = 123},
  [736] = {.lex_state = 123},
  [737] = {.lex_state = 123},
  [738] = {.lex_state = 123},
  [739] = {.lex_state = 123},
  [740] = {.lex_state = 123},
  [741] = {.lex_state = 123},
  [742] = {.lex_state = 123},
  [743] = {.lex_state = 123},
  [744] = {.lex_state = 123},
  [745] = {.lex_state = 123},
  [746] = {.lex_state = 123},
  [747] = {.lex_state = 123},
  [748] = {.lex_state = 123},
  [749] = {.lex_state = 123},
  [750] = {.lex_state = 123},
  [751] = {.lex_state = 123},
  [752] = {.lex_state = 123},
  [753] = {.lex_state = 123},
  [754] = {.lex_state = 123},
  [755] = {.lex_state = 123},
  [756] = {.lex_state = 123},
  [757] = {.lex_state = 123},
  [758] = {.lex_state = 123},
  [759] = {.lex_state = 123},
  [760] = {.lex_state = 123},
  [761] = {.lex_state = 123},
  [762] = {.lex_state = 123},
  [763] = {.lex_state = 123},
  [764] = {.lex_state = 123},
  [765] = {.lex_state = 123},
  [766] = {.lex_state = 123},
  [767] = {.lex_state = 123},
  [768] = {.lex_state = 123},
  [769] = {.lex_state = 123},
  [770] = {.lex_state = 123},
  [771] = {.lex_state = 123},
  [772] = {.lex_state = 123},
  [773] = {.lex_state = 123},
  [774] = {.lex_state = 123},
  [775] = {.lex_state = 123},
  [776] = {.lex_state = 123},
  [777] = {.lex_state = 123},
  [778] = {.lex_state = 123},
  [779] = {.lex_state = 123},
  [780] = {.lex_state = 123},
  [781] = {.lex_state = 123},
  [782] = {.lex_state = 123},
  [783] = {.lex_state = 123},
  [784] = {.lex_state = 123},
  [785] = {.lex_state = 123},
  [786] = {.lex_state = 123},
  [787] = {.lex_state = 123},
  [788] = {.lex_state = 123},
  [789] = {.lex_state = 123},
  [790] = {.lex_state = 123},
  [791] = {.lex_state = 123},
  [792] = {.lex_state = 123},
  [793] = {.lex_state = 123},
  [794] = {.lex_state = 123},
  [795] = {.lex_state = 123},
  [796] = {.lex_state = 123},
  [797] = {.lex_state = 123},
  [798] = {.lex_state = 123},
  [799] = {.lex_state = 123},
  [800] = {.lex_state = 123},
  [801] = {.lex_state = 123},
  [802] = {.lex_state = 123},
  [803] = {.lex_state = 123},
  [804] = {.lex_state = 123},
  [805] = {.lex_state = 123},
  [806] = {.lex_state = 123},
  [807] = {.lex_state = 123},
  [808] = {.lex_state = 123},
  [809] = {.lex_state = 123},
  [810] = {.lex_state = 52},
  [811] = {.lex_state = 52},
  [812] = {.lex_state = 52},
  [813] = {.lex_state = 55},
  [814] = {.lex_state = 55},
  [815] = {.lex_state = 52},
  [816] = {.lex_state = 55},
  [817] = {.lex_state = 55},
  [818] = {.lex_state = 55},
  [819] = {.lex_state = 55},
  [820] = {.lex_state = 55},
  [821] = {.lex_state = 55},
  [822] = {.lex_state = 55},
  [823] = {.lex_state = 55},
  [824] = {.lex_state = 55},
  [825] = {.lex_state = 55},
  [826] = {.lex_state = 52},
  [827] = {.lex_state = 52},
  [828] = {.lex_state = 53},
  [829] = {.lex_state = 53},
  [830] = {.lex_state = 55},
  [831] = {.lex_state = 53},
  [832] = {.lex_state = 53},
  [833] = {.lex_state = 53},
  [834] = {.lex_state = 53},
  [835] = {.lex_state = 53},
  [836] = {.lex_state = 53},
  [837] = {.lex_state = 55},
  [838] = {.lex_state = 53},
  [839] = {.lex_state = 53},
  [840] = {.lex_state = 55},
  [841] = {.lex_state = 55},
  [842] = {.lex_state = 55},
  [843] = {.lex_state = 123},
  [844] = {.lex_state = 55},
  [845] = {.lex_state = 123},
  [846] = {.lex_state = 53},
  [847] = {.lex_state = 123},
  [848] = {.lex_state = 123},
  [849] = {.lex_state = 52},
  [850] = {.lex_state = 53},
  [851] = {.lex_state = 53},
  [852] = {.lex_state = 53},
  [853] = {.lex_state = 53},
  [854] = {.lex_state = 53},
  [855] = {.lex_state = 53},
  [856] = {.lex_state = 53},
  [857] = {.lex_state = 53},
  [858] = {.lex_state = 53},
  [859] = {.lex_state = 53},
  [860] = {.lex_state = 53},
  [861] = {.lex_state = 53},
  [862] = {.lex_state = 53},
  [863] = {.lex_state = 53},
  [864] = {.lex_state = 53},
  [865] = {.lex_state = 53},
  [866] = {.lex_state = 53},
  [867] = {.lex_state = 55},
  [868] = {.lex_state = 55},
  [869] = {.lex_state = 55},
  [870] = {.lex_state = 53},
  [871] = {.lex_state = 53},
  [872] = {.lex_state = 55},
  [873] = {.lex_state = 54},
  [874] = {.lex_state = 55},
  [875] = {.lex_state = 54},
  [876] = {.lex_state = 55},
  [877] = {.lex_state = 53},
  [878] = {.lex_state = 55},
  [879] = {.lex_state = 55},
  [880] = {.lex_state = 55},
  [881] = {.lex_state = 55},
  [882] = {.lex_state = 55},
  [883] = {.lex_state = 55},
  [884] = {.lex_state = 53},
  [885] = {.lex_state = 54},
  [886] = {.lex_state = 52},
  [887] = {.lex_state = 55},
  [888] = {.lex_state = 55},
  [889] = {.lex_state = 55},
  [890] = {.lex_state = 55},
  [891] = {.lex_state = 55},
  [892] = {.lex_state = 53},
  [893] = {.lex_state = 55},
  [894] = {.lex_state = 54},
  [895] = {.lex_state = 55},
  [896] = {.lex_state = 55},
  [897] = {.lex_state = 53},
  [898] = {.lex_state = 52},
  [899] = {.lex_state = 123},
  [900] = {.lex_state = 52},
  [901] = {.lex_state = 123},
  [902] = {.lex_state = 55},
  [903] = {.lex_state = 55},
  [904] = {.lex_state = 55},
  [905] = {.lex_state = 55},
  [906] = {.lex_state = 55},
  [907] = {.lex_state = 55},
  [908] = {.lex_state = 55},
  [909] = {.lex_state = 55},
  [910] = {.lex_state = 55},
  [911] = {.lex_state = 55},
  [912] = {.lex_state = 55},
  [913] = {.lex_state = 55},
  [914] = {.lex_state = 55},
  [915] = {.lex_state = 55},
  [916] = {.lex_state = 55},
  [917] = {.lex_state = 55},
  [918] = {.lex_state = 55},
  [919] = {.lex_state = 55},
  [920] = {.lex_state = 55},
  [921] = {.lex_state = 52},
  [922] = {.lex_state = 52},
  [923] = {.lex_state = 55},
  [924] = {.lex_state = 52},
  [925] = {.lex_state = 55},
  [926] = {.lex_state = 55},
  [927] = {.lex_state = 55},
  [928] = {.lex_state = 52},
  [929] = {.lex_state = 52},
  [930] = {.lex_state = 55},
  [931] = {.lex_state = 55},
  [932] = {.lex_state = 55},
  [933] = {.lex_state = 55},
  [934] = {.lex_state = 52},
  [935] = {.lex_state = 53},
  [936] = {.lex_state = 55},
  [937] = {.lex_state = 55},
  [938] = {.lex_state = 53},
  [939] = {.lex_state = 53},
  [940] = {.lex_state = 53},
  [941] = {.lex_state = 53},
  [942] = {.lex_state = 53},
  [943] = {.lex_state = 53},
  [944] = {.lex_state = 53},
  [945] = {.lex_state = 55},
  [946] = {.lex_state = 55},
  [947] = {.lex_state = 55},
  [948] = {.lex_state = 55},
  [949] = {.lex_state = 55},
  [950] = {.lex_state = 55},
  [951] = {.lex_state = 55},
  [952] = {.lex_state = 53},
  [953] = {.lex_state = 55},
  [954] = {.lex_state = 55},
  [955] = {.lex_state = 55},
  [956] = {.lex_state = 55},
  [957] = {.lex_state = 55},
  [958] = {.lex_state = 53},
  [959] = {.lex_state = 52},
  [960] = {.lex_state = 53},
  [961] = {.lex_state = 55},
  [962] = {.lex_state = 55},
  [963] = {.lex_state = 55},
  [964] = {.lex_state = 55},
  [965] = {.lex_state = 53},
  [966] = {.lex_state = 55},
  [967] = {.lex_state = 55},
  [968] = {.lex_state = 55},
  [969] = {.lex_state = 55},
  [970] = {.lex_state = 55},
  [971] = {.lex_state = 55},
  [972] = {.lex_state = 55},
  [973] = {.lex_state = 55},
  [974] = {.lex_state = 55},
  [975] = {.lex_state = 55},
  [976] = {.lex_state = 55},
  [977] = {.lex_state = 55},
  [978] = {.lex_state = 55},
  [979] = {.lex_state = 55},
  [980] = {.lex_state = 55},
  [981] = {.lex_state = 55},
  [982] = {.lex_state = 55},
  [983] = {.lex_state = 55},
  [984] = {.lex_state = 55},
  [985] = {.lex_state = 55},
  [986] = {.lex_state = 55},
  [987] = {.lex_state = 55},
  [988] = {.lex_state = 55},
  [989] = {.lex_state = 55},
  [990] = {.lex_state = 55},
  [991] = {.lex_state = 55},
  [992] = {.lex_state = 55},
  [993] = {.lex_state = 55},
  [994] = {.lex_state = 55},
  [995] = {.lex_state = 55},
  [996] = {.lex_state = 55},
  [997] = {.lex_state = 53},
  [998] = {.lex_state = 55},
  [999] = {.lex_state = 55},
  [1000] = {.lex_state = 55},
  [1001] = {.lex_state = 55},
  [1002] = {.lex_state = 55},
  [1003] = {.lex_state = 55},
  [1004] = {.lex_state = 55},
  [1005] = {.lex_state = 55},
  [1006] = {.lex_state = 55},
  [1007] = {.lex_state = 55},
  [1008] = {.lex_state = 55},
  [1009] = {.lex_state = 55},
  [1010] = {.lex_state = 55},
  [1011] = {.lex_state = 55},
  [1012] = {.lex_state = 55},
  [1013] = {.lex_state = 55},
  [1014] = {.lex_state = 55},
  [1015] = {.lex_state = 55},
  [1016] = {.lex_state = 55},
  [1017] = {.lex_state = 55},
  [1018] = {.lex_state = 55},
  [1019] = {.lex_state = 55},
  [1020] = {.lex_state = 55},
  [1021] = {.lex_state = 55},
  [1022] = {.lex_state = 55},
  [1023] = {.lex_state = 52},
  [1024] = {.lex_state = 55},
  [1025] = {.lex_state = 55},
  [1026] = {.lex_state = 55},
  [1027] = {.lex_state = 55},
  [1028] = {.lex_state = 55},
  [1029] = {.lex_state = 55},
  [1030] = {.lex_state = 55},
  [1031] = {.lex_state = 55},
  [1032] = {.lex_state = 52},
  [1033] = {.lex_state = 55},
  [1034] = {.lex_state = 55},
  [1035] = {.lex_state = 55},
  [1036] = {.lex_state = 55},
  [1037] = {.lex_state = 52},
  [1038] = {.lex_state = 55},
  [1039] = {.lex_state = 52},
  [1040] = {.lex_state = 55},
  [1041] = {.lex_state = 55},
  [1042] = {.lex_state = 55},
  [1043] = {.lex_state = 55},
  [1044] = {.lex_state = 55},
  [1045] = {.lex_state = 55},
  [1046] = {.lex_state = 55},
  [1047] = {.lex_state = 55},
  [1048] = {.lex_state = 55},
  [1049] = {.lex_state = 55},
  [1050] = {.lex_state = 55},
  [1051] = {.lex_state = 55},
  [1052] = {.lex_state = 123},
  [1053] = {.lex_state = 123},
  [1054] = {.lex_state = 123},
  [1055] = {.lex_state = 123},
  [1056] = {.lex_state = 123},
  [1057] = {.lex_state = 123},
  [1058] = {.lex_state = 123},
  [1059] = {.lex_state = 123},
  [1060] = {.lex_state = 123},
  [1061] = {.lex_state = 123},
  [1062] = {.lex_state = 55},
  [1063] = {.lex_state = 123},
  [1064] = {.lex_state = 123},
  [1065] = {.lex_state = 123},
  [1066] = {.lex_state = 123},
  [1067] = {.lex_state = 123},
  [1068] = {.lex_state = 123},
  [1069] = {.lex_state = 123},
  [1070] = {.lex_state = 123},
  [1071] = {.lex_state = 123},
  [1072] = {.lex_state = 123},
  [1073] = {.lex_state = 123},
  [1074] = {.lex_state = 123},
  [1075] = {.lex_state = 123},
  [1076] = {.lex_state = 55},
  [1077] = {.lex_state = 55},
  [1078] = {.lex_state = 55},
  [1079] = {.lex_state = 55},
  [1080] = {.lex_state = 55},
  [1081] = {.lex_state = 55},
  [1082] = {.lex_state = 55},
  [1083] = {.lex_state = 55},
  [1084] = {.lex_state = 55},
  [1085] = {.lex_state = 53},
  [1086] = {.lex_state = 53},
  [1087] = {.lex_state = 53},
  [1088] = {.lex_state = 53},
  [1089] = {.lex_state = 55},
  [1090] = {.lex_state = 55},
  [1091] = {.lex_state = 53},
  [1092] = {.lex_state = 55},
  [1093] = {.lex_state = 53},
  [1094] = {.lex_state = 53},
  [1095] = {.lex_state = 53},
  [1096] = {.lex_state = 55},
  [1097] = {.lex_state = 55},
  [1098] = {.lex_state = 53},
  [1099] = {.lex_state = 55},
  [1100] = {.lex_state = 53},
  [1101] = {.lex_state = 53},
  [1102] = {.lex_state = 53},
  [1103] = {.lex_state = 53},
  [1104] = {.lex_state = 55},
  [1105] = {.lex_state = 55},
  [1106] = {.lex_state = 55},
  [1107] = {.lex_state = 55},
  [1108] = {.lex_state = 55},
  [1109] = {.lex_state = 55},
  [1110] = {.lex_state = 55},
  [1111] = {.lex_state = 55},
  [1112] = {.lex_state = 55},
  [1113] = {.lex_state = 55},
  [1114] = {.lex_state = 55},
  [1115] = {.lex_state = 55},
  [1116] = {.lex_state = 55},
  [1117] = {.lex_state = 55},
  [1118] = {.lex_state = 55},
  [1119] = {.lex_state = 55},
  [1120] = {.lex_state = 55},
  [1121] = {.lex_state = 55},
  [1122] = {.lex_state = 55},
  [1123] = {.lex_state = 55},
  [1124] = {.lex_state = 55},
  [1125] = {.lex_state = 55},
  [1126] = {.lex_state = 55},
  [1127] = {.lex_state = 55},
  [1128] = {.lex_state = 55},
  [1129] = {.lex_state = 55},
  [1130] = {.lex_state = 55},
  [1131] = {.lex_state = 56},
  [1132] = {.lex_state = 56},
  [1133] = {.lex_state = 55},
  [1134] = {.lex_state = 55},
  [1135] = {.lex_state = 56},
  [1136] = {.lex_state = 55},
  [1137] = {.lex_state = 55},
  [1138] = {.lex_state = 55},
  [1139] = {.lex_state = 56},
  [1140] = {.lex_state = 55},
  [1141] = {.lex_state = 55},
  [1142] = {.lex_state = 55},
  [1143] = {.lex_state = 55},
  [1144] = {.lex_state = 55},
  [1145] = {.lex_state = 55},
  [1146] = {.lex_state = 55},
  [1147] = {.lex_state = 55},
  [1148] = {.lex_state = 55},
  [1149] = {.lex_state = 55},
  [1150] = {.lex_state = 55},
  [1151] = {.lex_state = 55},
  [1152] = {.lex_state = 55},
  [1153] = {.lex_state = 55},
  [1154] = {.lex_state = 55},
  [1155] = {.lex_state = 55},
  [1156] = {.lex_state = 55},
  [1157] = {.lex_state = 55},
  [1158] = {.lex_state = 55},
  [1159] = {.lex_state = 55},
  [1160] = {.lex_state = 55},
  [1161] = {.lex_state = 55},
  [1162] = {.lex_state = 55},
  [1163] = {.lex_state = 55},
  [1164] = {.lex_state = 55},
  [1165] = {.lex_state = 55},
  [1166] = {.lex_state = 55},
  [1167] = {.lex_state = 55},
  [1168] = {.lex_state = 55},
  [1169] = {.lex_state = 55},
  [1170] = {.lex_state = 55},
  [1171] = {.lex_state = 55},
  [1172] = {.lex_state = 55},
  [1173] = {.lex_state = 55},
  [1174] = {.lex_state = 55},
  [1175] = {.lex_state = 55},
  [1176] = {.lex_state = 55},
  [1177] = {.lex_state = 55},
  [1178] = {.lex_state = 55},
  [1179] = {.lex_state = 55},
  [1180] = {.lex_state = 55},
  [1181] = {.lex_state = 55},
  [1182] = {.lex_state = 55},
  [1183] = {.lex_state = 55},
  [1184] = {.lex_state = 55},
  [1185] = {.lex_state = 55},
  [1186] = {.lex_state = 55},
  [1187] = {.lex_state = 55},
  [1188] = {.lex_state = 55},
  [1189] = {.lex_state = 55},
  [1190] = {.lex_state = 55},
  [1191] = {.lex_state = 55},
  [1192] = {.lex_state = 55},
  [1193] = {.lex_state = 55},
  [1194] = {.lex_state = 55},
  [1195] = {.lex_state = 55},
  [1196] = {.lex_state = 55},
  [1197] = {.lex_state = 55},
  [1198] = {.lex_state = 55},
  [1199] = {.lex_state = 55},
  [1200] = {.lex_state = 55},
  [1201] = {.lex_state = 55},
  [1202] = {.lex_state = 55},
  [1203] = {.lex_state = 55},
  [1204] = {.lex_state = 55},
  [1205] = {.lex_state = 55},
  [1206] = {.lex_state = 55},
  [1207] = {.lex_state = 55},
  [1208] = {.lex_state = 55},
  [1209] = {.lex_state = 55},
  [1210] = {.lex_state = 55},
  [1211] = {.lex_state = 55},
  [1212] = {.lex_state = 55},
  [1213] = {.lex_state = 55},
  [1214] = {.lex_state = 55},
  [1215] = {.lex_state = 55},
  [1216] = {.lex_state = 55},
  [1217] = {.lex_state = 55},
  [1218] = {.lex_state = 55},
  [1219] = {.lex_state = 55},
  [1220] = {.lex_state = 55},
  [1221] = {.lex_state = 55},
  [1222] = {.lex_state = 55},
  [1223] = {.lex_state = 55},
  [1224] = {.lex_state = 55},
  [1225] = {.lex_state = 55},
  [1226] = {.lex_state = 55},
  [1227] = {.lex_state = 55},
  [1228] = {.lex_state = 55},
  [1229] = {.lex_state = 55},
  [1230] = {.lex_state = 55},
  [1231] = {.lex_state = 55},
  [1232] = {.lex_state = 55},
  [1233] = {.lex_state = 55},
  [1234] = {.lex_state = 55},
  [1235] = {.lex_state = 55},
  [1236] = {.lex_state = 55},
  [1237] = {.lex_state = 55},
  [1238] = {.lex_state = 55},
  [1239] = {.lex_state = 55},
  [1240] = {.lex_state = 55},
  [1241] = {.lex_state = 55},
  [1242] = {.lex_state = 55},
  [1243] = {.lex_state = 55},
  [1244] = {.lex_state = 55},
  [1245] = {.lex_state = 55},
  [1246] = {.lex_state = 55},
  [1247] = {.lex_state = 55},
  [1248] = {.lex_state = 56},
  [1249] = {.lex_state = 55},
  [1250] = {.lex_state = 55},
  [1251] = {.lex_state = 56},
  [1252] = {.lex_state = 55},
  [1253] = {.lex_state = 55},
  [1254] = {.lex_state = 55},
  [1255] = {.lex_state = 55},
  [1256] = {.lex_state = 55},
  [1257] = {.lex_state = 55},
  [1258] = {.lex_state = 55},
  [1259] = {.lex_state = 55},
  [1260] = {.lex_state = 51},
  [1261] = {.lex_state = 51},
  [1262] = {.lex_state = 55},
  [1263] = {.lex_state = 55},
  [1264] = {.lex_state = 55},
  [1265] = {.lex_state = 55},
  [1266] = {.lex_state = 55},
  [1267] = {.lex_state = 51},
  [1268] = {.lex_state = 55},
  [1269] = {.lex_state = 55},
  [1270] = {.lex_state = 55},
  [1271] = {.lex_state = 55},
  [1272] = {.lex_state = 55},
  [1273] = {.lex_state = 56},
  [1274] = {.lex_state = 55},
  [1275] = {.lex_state = 55},
  [1276] = {.lex_state = 55},
  [1277] = {.lex_state = 55},
  [1278] = {.lex_state = 56},
  [1279] = {.lex_state = 55},
  [1280] = {.lex_state = 23},
  [1281] = {.lex_state = 56},
  [1282] = {.lex_state = 56},
  [1283] = {.lex_state = 51},
  [1284] = {.lex_state = 56},
  [1285] = {.lex_state = 51},
  [1286] = {.lex_state = 51},
  [1287] = {.lex_state = 51},
  [1288] = {.lex_state = 51},
  [1289] = {.lex_state = 51},
  [1290] = {.lex_state = 51},
  [1291] = {.lex_state = 51},
  [1292] = {.lex_state = 51},
  [1293] = {.lex_state = 51},
  [1294] = {.lex_state = 51},
  [1295] = {.lex_state = 51},
  [1296] = {.lex_state = 51},
  [1297] = {.lex_state = 51},
  [1298] = {.lex_state = 51},
  [1299] = {.lex_state = 51},
  [1300] = {.lex_state = 56},
  [1301] = {.lex_state = 51},
  [1302] = {.lex_state = 51},
  [1303] = {.lex_state = 51},
  [1304] = {.lex_state = 51},
  [1305] = {.lex_state = 51},
  [1306] = {.lex_state = 51},
  [1307] = {.lex_state = 51},
  [1308] = {.lex_state = 51},
  [1309] = {.lex_state = 51},
  [1310] = {.lex_state = 51},
  [1311] = {.lex_state = 55},
  [1312] = {.lex_state = 51},
  [1313] = {.lex_state = 51},
  [1314] = {.lex_state = 55},
  [1315] = {.lex_state = 51},
  [1316] = {.lex_state = 51},
  [1317] = {.lex_state = 51},
  [1318] = {.lex_state = 51},
  [1319] = {.lex_state = 56},
  [1320] = {.lex_state = 51},
  [1321] = {.lex_state = 51},
  [1322] = {.lex_state = 56},
  [1323] = {.lex_state = 51},
  [1324] = {.lex_state = 51},
  [1325] = {.lex_state = 51},
  [1326] = {.lex_state = 56},
  [1327] = {.lex_state = 56},
  [1328] = {.lex_state = 51},
  [1329] = {.lex_state = 56},
  [1330] = {.lex_state = 56},
  [1331] = {.lex_state = 56},
  [1332] = {.lex_state = 56},
  [1333] = {.lex_state = 51},
  [1334] = {.lex_state = 56},
  [1335] = {.lex_state = 56},
  [1336] = {.lex_state = 56},
  [1337] = {.lex_state = 56},
  [1338] = {.lex_state = 23},
  [1339] = {.lex_state = 23},
  [1340] = {.lex_state = 23},
  [1341] = {.lex_state = 23},
  [1342] = {.lex_state = 55},
  [1343] = {.lex_state = 56},
  [1344] = {.lex_state = 23},
  [1345] = {.lex_state = 23},
  [1346] = {.lex_state = 23},
  [1347] = {.lex_state = 23},
  [1348] = {.lex_state = 23},
  [1349] = {.lex_state = 23},
  [1350] = {.lex_state = 23},
  [1351] = {.lex_state = 23},
  [1352] = {.lex_state = 23},
  [1353] = {.lex_state = 23},
  [1354] = {.lex_state = 23},
  [1355] = {.lex_state = 23},
  [1356] = {.lex_state = 23},
  [1357] = {.lex_state = 23},
  [1358] = {.lex_state = 23},
  [1359] = {.lex_state = 23},
  [1360] = {.lex_state = 23},
  [1361] = {.lex_state = 23},
  [1362] = {.lex_state = 23},
  [1363] = {.lex_state = 23},
  [1364] = {.lex_state = 23},
  [1365] = {.lex_state = 23},
  [1366] = {.lex_state = 23},
  [1367] = {.lex_state = 23},
  [1368] = {.lex_state = 23},
  [1369] = {.lex_state = 23},
  [1370] = {.lex_state = 56},
  [1371] = {.lex_state = 23},
  [1372] = {.lex_state = 23},
  [1373] = {.lex_state = 23},
  [1374] = {.lex_state = 55},
  [1375] = {.lex_state = 55},
  [1376] = {.lex_state = 55},
  [1377] = {.lex_state = 55},
  [1378] = {.lex_state = 55},
  [1379] = {.lex_state = 55},
  [1380] = {.lex_state = 55},
  [1381] = {.lex_state = 55},
  [1382] = {.lex_state = 55},
  [1383] = {.lex_state = 55},
  [1384] = {.lex_state = 55},
  [1385] = {.lex_state = 55},
  [1386] = {.lex_state = 55},
  [1387] = {.lex_state = 55},
  [1388] = {.lex_state = 55},
  [1389] = {.lex_state = 55},
  [1390] = {.lex_state = 55},
  [1391] = {.lex_state = 55},
  [1392] = {.lex_state = 55},
  [1393] = {.lex_state = 55},
  [1394] = {.lex_state = 55},
  [1395] = {.lex_state = 55},
  [1396] = {.lex_state = 55},
  [1397] = {.lex_state = 55},
  [1398] = {.lex_state = 55},
  [1399] = {.lex_state = 55},
  [1400] = {.lex_state = 55},
  [1401] = {.lex_state = 55},
  [1402] = {.lex_state = 55},
  [1403] = {.lex_state = 55},
  [1404] = {.lex_state = 55},
  [1405] = {.lex_state = 55},
  [1406] = {.lex_state = 55},
  [1407] = {.lex_state = 55},
  [1408] = {.lex_state = 55},
  [1409] = {.lex_state = 55},
  [1410] = {.lex_state = 55},
  [1411] = {.lex_state = 55},
  [1412] = {.lex_state = 55},
  [1413] = {.lex_state = 55},
  [1414] = {.lex_state = 55},
  [1415] = {.lex_state = 55},
  [1416] = {.lex_state = 55},
  [1417] = {.lex_state = 55},
  [1418] = {.lex_state = 55},
  [1419] = {.lex_state = 55},
  [1420] = {.lex_state = 55},
  [1421] = {.lex_state = 55},
  [1422] = {.lex_state = 55},
  [1423] = {.lex_state = 55},
  [1424] = {.lex_state = 55},
  [1425] = {.lex_state = 53},
  [1426] = {.lex_state = 55},
  [1427] = {.lex_state = 53},
  [1428] = {.lex_state = 55},
  [1429] = {.lex_state = 55},
  [1430] = {.lex_state = 55},
  [1431] = {.lex_state = 55},
  [1432] = {.lex_state = 55},
  [1433] = {.lex_state = 53},
  [1434] = {.lex_state = 55},
  [1435] = {.lex_state = 55},
  [1436] = {.lex_state = 53},
  [1437] = {.lex_state = 55},
  [1438] = {.lex_state = 55},
  [1439] = {.lex_state = 55},
  [1440] = {.lex_state = 55},
  [1441] = {.lex_state = 55},
  [1442] = {.lex_state = 55},
  [1443] = {.lex_state = 55},
  [1444] = {.lex_state = 59},
  [1445] = {.lex_state = 55},
  [1446] = {.lex_state = 55},
  [1447] = {.lex_state = 55},
  [1448] = {.lex_state = 59},
  [1449] = {.lex_state = 55},
  [1450] = {.lex_state = 55},
  [1451] = {.lex_state = 55},
  [1452] = {.lex_state = 55},
  [1453] = {.lex_state = 55},
  [1454] = {.lex_state = 55},
  [1455] = {.lex_state = 55},
  [1456] = {.lex_state = 55},
  [1457] = {.lex_state = 55},
  [1458] = {.lex_state = 55},
  [1459] = {.lex_state = 55},
  [1460] = {.lex_state = 55},
  [1461] = {.lex_state = 55},
  [1462] = {.lex_state = 55},
  [1463] = {.lex_state = 55},
  [1464] = {.lex_state = 55},
  [1465] = {.lex_state = 55},
  [1466] = {.lex_state = 55},
  [1467] = {.lex_state = 55},
  [1468] = {.lex_state = 55},
  [1469] = {.lex_state = 55},
  [1470] = {.lex_state = 55},
  [1471] = {.lex_state = 55},
  [1472] = {.lex_state = 55},
  [1473] = {.lex_state = 55},
  [1474] = {.lex_state = 55},
  [1475] = {.lex_state = 55},
  [1476] = {.lex_state = 55},
  [1477] = {.lex_state = 55},
  [1478] = {.lex_state = 53},
  [1479] = {.lex_state = 55},
  [1480] = {.lex_state = 55},
  [1481] = {.lex_state = 53},
  [1482] = {.lex_state = 53},
  [1483] = {.lex_state = 55},
  [1484] = {.lex_state = 53},
  [1485] = {.lex_state = 53},
  [1486] = {.lex_state = 53},
  [1487] = {.lex_state = 55},
  [1488] = {.lex_state = 55},
  [1489] = {.lex_state = 53},
  [1490] = {.lex_state = 53},
  [1491] = {.lex_state = 55},
  [1492] = {.lex_state = 55},
  [1493] = {.lex_state = 55},
  [1494] = {.lex_state = 55},
  [1495] = {.lex_state = 53},
  [1496] = {.lex_state = 55},
  [1497] = {.lex_state = 55},
  [1498] = {.lex_state = 55},
  [1499] = {.lex_state = 55},
  [1500] = {.lex_state = 55},
  [1501] = {.lex_state = 55},
  [1502] = {.lex_state = 55},
  [1503] = {.lex_state = 55},
  [1504] = {.lex_state = 53},
  [1505] = {.lex_state = 55},
  [1506] = {.lex_state = 55},
  [1507] = {.lex_state = 55},
  [1508] = {.lex_state = 55},
  [1509] = {.lex_state = 53},
  [1510] = {.lex_state = 55},
  [1511] = {.lex_state = 55},
  [1512] = {.lex_state = 55},
  [1513] = {.lex_state = 55},
  [1514] = {.lex_state = 55},
  [1515] = {.lex_state = 55},
  [1516] = {.lex_state = 55},
  [1517] = {.lex_state = 55},
  [1518] = {.lex_state = 55},
  [1519] = {.lex_state = 53},
  [1520] = {.lex_state = 55},
  [1521] = {.lex_state = 53},
  [1522] = {.lex_state = 55},
  [1523] = {.lex_state = 55},
  [1524] = {.lex_state = 55},
  [1525] = {.lex_state = 55},
  [1526] = {.lex_state = 55},
  [1527] = {.lex_state = 55},
  [1528] = {.lex_state = 55},
  [1529] = {.lex_state = 59},
  [1530] = {.lex_state = 55},
  [1531] = {.lex_state = 55},
  [1532] = {.lex_state = 53},
  [1533] = {.lex_state = 55},
  [1534] = {.lex_state = 55},
  [1535] = {.lex_state = 55},
  [1536] = {.lex_state = 55},
  [1537] = {.lex_state = 52},
  [1538] = {.lex_state = 55},
  [1539] = {.lex_state = 55},
  [1540] = {.lex_state = 55},
  [1541] = {.lex_state = 55},
  [1542] = {.lex_state = 55},
  [1543] = {.lex_state = 55},
  [1544] = {.lex_state = 55},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 55},
  [1547] = {.lex_state = 55},
  [1548] = {.lex_state = 55},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 55},
  [1551] = {.lex_state = 55},
  [1552] = {.lex_state = 55},
  [1553] = {.lex_state = 55},
  [1554] = {.lex_state = 123},
  [1555] = {.lex_state = 52},
  [1556] = {.lex_state = 123},
  [1557] = {.lex_state = 55},
  [1558] = {.lex_state = 55},
  [1559] = {.lex_state = 57},
  [1560] = {.lex_state = 123},
  [1561] = {.lex_state = 123},
  [1562] = {.lex_state = 52},
  [1563] = {.lex_state = 55},
  [1564] = {.lex_state = 57},
  [1565] = {.lex_state = 52},
  [1566] = {.lex_state = 123},
  [1567] = {.lex_state = 57},
  [1568] = {.lex_state = 57},
  [1569] = {.lex_state = 123},
  [1570] = {.lex_state = 123},
  [1571] = {.lex_state = 123},
  [1572] = {.lex_state = 123},
  [1573] = {.lex_state = 123},
  [1574] = {.lex_state = 123},
  [1575] = {.lex_state = 123},
  [1576] = {.lex_state = 123},
  [1577] = {.lex_state = 55},
  [1578] = {.lex_state = 123},
  [1579] = {.lex_state = 123},
  [1580] = {.lex_state = 123},
  [1581] = {.lex_state = 123},
  [1582] = {.lex_state = 123},
  [1583] = {.lex_state = 123},
  [1584] = {.lex_state = 123},
  [1585] = {.lex_state = 123},
  [1586] = {.lex_state = 123},
  [1587] = {.lex_state = 123},
  [1588] = {.lex_state = 123},
  [1589] = {.lex_state = 123},
  [1590] = {.lex_state = 123},
  [1591] = {.lex_state = 123},
  [1592] = {.lex_state = 123},
  [1593] = {.lex_state = 123},
  [1594] = {.lex_state = 123},
  [1595] = {.lex_state = 123},
  [1596] = {.lex_state = 123},
  [1597] = {.lex_state = 123},
  [1598] = {.lex_state = 123},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 123},
  [1601] = {.lex_state = 123},
  [1602] = {.lex_state = 123},
  [1603] = {.lex_state = 123},
  [1604] = {.lex_state = 123},
  [1605] = {.lex_state = 55},
  [1606] = {.lex_state = 55},
  [1607] = {.lex_state = 55},
  [1608] = {.lex_state = 123},
  [1609] = {.lex_state = 123},
  [1610] = {.lex_state = 123},
  [1611] = {.lex_state = 123},
  [1612] = {.lex_state = 123},
  [1613] = {.lex_state = 123},
  [1614] = {.lex_state = 123},
  [1615] = {.lex_state = 123},
  [1616] = {.lex_state = 123},
  [1617] = {.lex_state = 123},
  [1618] = {.lex_state = 55},
  [1619] = {.lex_state = 123},
  [1620] = {.lex_state = 123},
  [1621] = {.lex_state = 123},
  [1622] = {.lex_state = 123},
  [1623] = {.lex_state = 123},
  [1624] = {.lex_state = 123},
  [1625] = {.lex_state = 123},
  [1626] = {.lex_state = 123},
  [1627] = {.lex_state = 53},
  [1628] = {.lex_state = 123},
  [1629] = {.lex_state = 123},
  [1630] = {.lex_state = 123},
  [1631] = {.lex_state = 55},
  [1632] = {.lex_state = 123},
  [1633] = {.lex_state = 123},
  [1634] = {.lex_state = 123},
  [1635] = {.lex_state = 123},
  [1636] = {.lex_state = 123},
  [1637] = {.lex_state = 123},
  [1638] = {.lex_state = 123},
  [1639] = {.lex_state = 123},
  [1640] = {.lex_state = 123},
  [1641] = {.lex_state = 123},
  [1642] = {.lex_state = 123},
  [1643] = {.lex_state = 123},
  [1644] = {.lex_state = 123},
  [1645] = {.lex_state = 123},
  [1646] = {.lex_state = 55},
  [1647] = {.lex_state = 53},
  [1648] = {.lex_state = 123},
  [1649] = {.lex_state = 53},
  [1650] = {.lex_state = 123},
  [1651] = {.lex_state = 55},
  [1652] = {.lex_state = 55},
  [1653] = {.lex_state = 123},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 123},
  [1656] = {.lex_state = 123},
  [1657] = {.lex_state = 123},
  [1658] = {.lex_state = 123},
  [1659] = {.lex_state = 123},
  [1660] = {.lex_state = 123},
  [1661] = {.lex_state = 55},
  [1662] = {.lex_state = 123},
  [1663] = {.lex_state = 55},
  [1664] = {.lex_state = 55},
  [1665] = {.lex_state = 55},
  [1666] = {.lex_state = 55},
  [1667] = {.lex_state = 55},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 55},
  [1670] = {.lex_state = 123},
  [1671] = {.lex_state = 123},
  [1672] = {.lex_state = 53},
  [1673] = {.lex_state = 123},
  [1674] = {.lex_state = 55},
  [1675] = {.lex_state = 123},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 55},
  [1678] = {.lex_state = 123},
  [1679] = {.lex_state = 55},
  [1680] = {.lex_state = 55},
  [1681] = {.lex_state = 55},
  [1682] = {.lex_state = 55},
  [1683] = {.lex_state = 55},
  [1684] = {.lex_state = 123},
  [1685] = {.lex_state = 55},
  [1686] = {.lex_state = 55},
  [1687] = {.lex_state = 0},
  [1688] = {.lex_state = 123},
  [1689] = {.lex_state = 55},
  [1690] = {.lex_state = 123},
  [1691] = {.lex_state = 55},
  [1692] = {.lex_state = 55},
  [1693] = {.lex_state = 55},
  [1694] = {.lex_state = 55},
  [1695] = {.lex_state = 55},
  [1696] = {.lex_state = 59},
  [1697] = {.lex_state = 123},
  [1698] = {.lex_state = 55},
  [1699] = {.lex_state = 123},
  [1700] = {.lex_state = 0},
  [1701] = {.lex_state = 59},
  [1702] = {.lex_state = 59},
  [1703] = {.lex_state = 55},
  [1704] = {.lex_state = 55},
  [1705] = {.lex_state = 55},
  [1706] = {.lex_state = 123},
  [1707] = {.lex_state = 55},
  [1708] = {.lex_state = 0},
  [1709] = {.lex_state = 55},
  [1710] = {.lex_state = 55},
  [1711] = {.lex_state = 59},
  [1712] = {.lex_state = 59},
  [1713] = {.lex_state = 55},
  [1714] = {.lex_state = 59},
  [1715] = {.lex_state = 59},
  [1716] = {.lex_state = 59},
  [1717] = {.lex_state = 55},
  [1718] = {.lex_state = 123},
  [1719] = {.lex_state = 123},
  [1720] = {.lex_state = 55},
  [1721] = {.lex_state = 59},
  [1722] = {.lex_state = 55},
  [1723] = {.lex_state = 55},
  [1724] = {.lex_state = 55},
  [1725] = {.lex_state = 59},
  [1726] = {.lex_state = 123},
  [1727] = {.lex_state = 55},
  [1728] = {.lex_state = 123},
  [1729] = {.lex_state = 59},
  [1730] = {.lex_state = 55},
  [1731] = {.lex_state = 53},
  [1732] = {.lex_state = 123},
  [1733] = {.lex_state = 123},
  [1734] = {.lex_state = 123},
  [1735] = {.lex_state = 123},
  [1736] = {.lex_state = 55},
  [1737] = {.lex_state = 55},
  [1738] = {.lex_state = 123},
  [1739] = {.lex_state = 123},
  [1740] = {.lex_state = 123},
  [1741] = {.lex_state = 55},
  [1742] = {.lex_state = 123},
  [1743] = {.lex_state = 123},
  [1744] = {.lex_state = 123},
  [1745] = {.lex_state = 47},
  [1746] = {.lex_state = 55},
  [1747] = {.lex_state = 55},
  [1748] = {.lex_state = 53},
  [1749] = {.lex_state = 55},
  [1750] = {.lex_state = 123},
  [1751] = {.lex_state = 123},
  [1752] = {.lex_state = 123},
  [1753] = {.lex_state = 123},
  [1754] = {.lex_state = 55},
  [1755] = {.lex_state = 123},
  [1756] = {.lex_state = 55},
  [1757] = {.lex_state = 47},
  [1758] = {.lex_state = 123},
  [1759] = {.lex_state = 28},
  [1760] = {.lex_state = 55},
  [1761] = {.lex_state = 123},
  [1762] = {.lex_state = 28},
  [1763] = {.lex_state = 28},
  [1764] = {.lex_state = 123},
  [1765] = {.lex_state = 55},
  [1766] = {.lex_state = 55},
  [1767] = {.lex_state = 55},
  [1768] = {.lex_state = 0},
  [1769] = {.lex_state = 28},
  [1770] = {.lex_state = 55},
  [1771] = {.lex_state = 55},
  [1772] = {.lex_state = 123},
  [1773] = {.lex_state = 55},
  [1774] = {.lex_state = 55},
  [1775] = {.lex_state = 53},
  [1776] = {.lex_state = 53},
  [1777] = {.lex_state = 35},
  [1778] = {.lex_state = 37},
  [1779] = {.lex_state = 55},
  [1780] = {.lex_state = 55},
  [1781] = {.lex_state = 55},
  [1782] = {.lex_state = 123},
  [1783] = {.lex_state = 53},
  [1784] = {.lex_state = 53},
  [1785] = {.lex_state = 55},
  [1786] = {.lex_state = 55},
  [1787] = {.lex_state = 35},
  [1788] = {.lex_state = 37},
  [1789] = {.lex_state = 35},
  [1790] = {.lex_state = 55},
  [1791] = {.lex_state = 123},
  [1792] = {.lex_state = 55},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 28},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 123},
  [1797] = {.lex_state = 55},
  [1798] = {.lex_state = 55},
  [1799] = {.lex_state = 123},
  [1800] = {.lex_state = 55},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 28},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 123},
  [1806] = {.lex_state = 123},
  [1807] = {.lex_state = 55},
  [1808] = {.lex_state = 0},
  [1809] = {.lex_state = 55},
  [1810] = {.lex_state = 55},
  [1811] = {.lex_state = 55},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 37},
  [1814] = {.lex_state = 35},
  [1815] = {.lex_state = 35},
  [1816] = {.lex_state = 55},
  [1817] = {.lex_state = 55},
  [1818] = {.lex_state = 28},
  [1819] = {.lex_state = 35},
  [1820] = {.lex_state = 37},
  [1821] = {.lex_state = 55},
  [1822] = {.lex_state = 123},
  [1823] = {.lex_state = 55},
  [1824] = {.lex_state = 55},
  [1825] = {.lex_state = 55},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 55},
  [1828] = {.lex_state = 55},
  [1829] = {.lex_state = 55},
  [1830] = {.lex_state = 55},
  [1831] = {.lex_state = 35},
  [1832] = {.lex_state = 123},
  [1833] = {.lex_state = 55},
  [1834] = {.lex_state = 0},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 0},
  [1838] = {.lex_state = 0},
  [1839] = {.lex_state = 47},
  [1840] = {.lex_state = 0},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 0},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 0},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 30},
  [1849] = {.lex_state = 55},
  [1850] = {.lex_state = 31},
  [1851] = {.lex_state = 0},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 55},
  [1856] = {.lex_state = 0},
  [1857] = {.lex_state = 0},
  [1858] = {.lex_state = 55},
  [1859] = {.lex_state = 0},
  [1860] = {.lex_state = 55},
  [1861] = {.lex_state = 0},
  [1862] = {.lex_state = 0},
  [1863] = {.lex_state = 37},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 55},
  [1866] = {.lex_state = 0},
  [1867] = {.lex_state = 0},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 0},
  [1871] = {.lex_state = 0},
  [1872] = {.lex_state = 37},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 55},
  [1875] = {.lex_state = 47},
  [1876] = {.lex_state = 55},
  [1877] = {.lex_state = 47},
  [1878] = {.lex_state = 0},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 0},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 0},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 47},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 31},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 0},
  [1897] = {.lex_state = 30},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 55},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 55},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 0},
  [1916] = {.lex_state = 55},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 0},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 55},
  [1926] = {.lex_state = 0},
  [1927] = {.lex_state = 0},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 47},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 0},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 0},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 0},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 31},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 55},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 47},
  [1952] = {.lex_state = 30},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 0},
  [1955] = {.lex_state = 0},
  [1956] = {.lex_state = 0},
  [1957] = {.lex_state = 0},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 0},
  [1960] = {.lex_state = 0},
  [1961] = {.lex_state = 0},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 0},
  [1964] = {.lex_state = 0},
  [1965] = {.lex_state = 0},
  [1966] = {.lex_state = 0},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 0},
  [1969] = {.lex_state = 0},
  [1970] = {.lex_state = 0},
  [1971] = {.lex_state = 0},
  [1972] = {.lex_state = 0},
  [1973] = {.lex_state = 0},
  [1974] = {.lex_state = 0},
  [1975] = {.lex_state = 0},
  [1976] = {.lex_state = 55},
  [1977] = {.lex_state = 0},
  [1978] = {.lex_state = 0},
  [1979] = {.lex_state = 31},
  [1980] = {.lex_state = 47},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 0},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 0},
  [1987] = {.lex_state = 0},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 0},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 0},
  [1992] = {.lex_state = 0},
  [1993] = {.lex_state = 0},
  [1994] = {.lex_state = 37},
  [1995] = {.lex_state = 0},
  [1996] = {.lex_state = 55},
  [1997] = {.lex_state = 0},
  [1998] = {.lex_state = 0},
  [1999] = {.lex_state = 30},
  [2000] = {.lex_state = 55},
  [2001] = {.lex_state = 0},
  [2002] = {.lex_state = 55},
  [2003] = {.lex_state = 0},
  [2004] = {.lex_state = 55},
  [2005] = {.lex_state = 0},
  [2006] = {.lex_state = 0},
  [2007] = {.lex_state = 0},
  [2008] = {.lex_state = 0},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 0},
  [2011] = {.lex_state = 0},
  [2012] = {.lex_state = 0},
  [2013] = {.lex_state = 0},
  [2014] = {.lex_state = 123},
  [2015] = {.lex_state = 0},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 123},
  [2018] = {.lex_state = 55},
  [2019] = {.lex_state = 0},
  [2020] = {.lex_state = 123},
  [2021] = {.lex_state = 123},
  [2022] = {.lex_state = 123},
  [2023] = {.lex_state = 0},
  [2024] = {.lex_state = 0},
  [2025] = {.lex_state = 0},
  [2026] = {.lex_state = 123},
  [2027] = {.lex_state = 29},
  [2028] = {.lex_state = 55},
  [2029] = {.lex_state = 123},
  [2030] = {.lex_state = 29},
  [2031] = {.lex_state = 123},
  [2032] = {.lex_state = 0},
  [2033] = {.lex_state = 47},
  [2034] = {.lex_state = 0},
  [2035] = {.lex_state = 0},
  [2036] = {.lex_state = 0},
  [2037] = {.lex_state = 0},
  [2038] = {.lex_state = 0},
  [2039] = {.lex_state = 0},
  [2040] = {.lex_state = 0},
  [2041] = {.lex_state = 0},
  [2042] = {.lex_state = 123},
  [2043] = {.lex_state = 0},
  [2044] = {.lex_state = 0},
  [2045] = {.lex_state = 29},
  [2046] = {.lex_state = 29},
  [2047] = {.lex_state = 0},
  [2048] = {.lex_state = 0},
  [2049] = {.lex_state = 123},
  [2050] = {.lex_state = 123},
  [2051] = {.lex_state = 0},
  [2052] = {.lex_state = 123},
  [2053] = {.lex_state = 47},
  [2054] = {.lex_state = 0},
  [2055] = {.lex_state = 55},
  [2056] = {.lex_state = 123},
  [2057] = {.lex_state = 0},
  [2058] = {.lex_state = 29},
  [2059] = {.lex_state = 55},
  [2060] = {.lex_state = 123},
  [2061] = {.lex_state = 29},
  [2062] = {.lex_state = 123},
  [2063] = {.lex_state = 0},
  [2064] = {.lex_state = 0},
  [2065] = {.lex_state = 55},
  [2066] = {.lex_state = 0},
  [2067] = {.lex_state = 29},
  [2068] = {.lex_state = 0},
  [2069] = {.lex_state = 0},
  [2070] = {.lex_state = 29},
  [2071] = {.lex_state = 0},
  [2072] = {.lex_state = 123},
  [2073] = {.lex_state = 29},
  [2074] = {.lex_state = 0},
  [2075] = {.lex_state = 29},
  [2076] = {.lex_state = 123},
  [2077] = {.lex_state = 123},
  [2078] = {.lex_state = 0},
  [2079] = {.lex_state = 0},
  [2080] = {.lex_state = 29},
  [2081] = {.lex_state = 29},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 123},
  [2084] = {.lex_state = 47},
  [2085] = {.lex_state = 0},
  [2086] = {.lex_state = 123},
  [2087] = {.lex_state = 29},
  [2088] = {.lex_state = 55},
  [2089] = {.lex_state = 123},
  [2090] = {.lex_state = 123},
  [2091] = {.lex_state = 0},
  [2092] = {.lex_state = 123},
  [2093] = {.lex_state = 0},
  [2094] = {.lex_state = 123},
  [2095] = {.lex_state = 123},
  [2096] = {.lex_state = 29},
  [2097] = {.lex_state = 55},
  [2098] = {.lex_state = 123},
  [2099] = {.lex_state = 123},
  [2100] = {.lex_state = 0},
  [2101] = {.lex_state = 55},
  [2102] = {.lex_state = 0},
  [2103] = {.lex_state = 55},
  [2104] = {.lex_state = 0},
  [2105] = {.lex_state = 0},
  [2106] = {.lex_state = 55},
  [2107] = {.lex_state = 55},
  [2108] = {.lex_state = 0},
  [2109] = {.lex_state = 123},
  [2110] = {.lex_state = 0},
  [2111] = {.lex_state = 0},
  [2112] = {.lex_state = 0},
  [2113] = {.lex_state = 0},
  [2114] = {.lex_state = 0},
  [2115] = {.lex_state = 0},
  [2116] = {.lex_state = 55},
  [2117] = {.lex_state = 0},
  [2118] = {.lex_state = 46},
  [2119] = {.lex_state = 30},
  [2120] = {.lex_state = 55},
  [2121] = {.lex_state = 30},
  [2122] = {.lex_state = 55},
  [2123] = {.lex_state = 0},
  [2124] = {.lex_state = 55},
  [2125] = {.lex_state = 55},
  [2126] = {.lex_state = 55},
  [2127] = {.lex_state = 0},
  [2128] = {.lex_state = 55},
  [2129] = {.lex_state = 55},
  [2130] = {.lex_state = 55},
  [2131] = {.lex_state = 0},
  [2132] = {.lex_state = 30},
  [2133] = {.lex_state = 30},
  [2134] = {.lex_state = 30},
  [2135] = {.lex_state = 30},
  [2136] = {.lex_state = 30},
  [2137] = {.lex_state = 30},
  [2138] = {.lex_state = 55},
  [2139] = {.lex_state = 30},
  [2140] = {.lex_state = 30},
  [2141] = {.lex_state = 0},
  [2142] = {.lex_state = 0},
  [2143] = {.lex_state = 46},
  [2144] = {.lex_state = 46},
  [2145] = {.lex_state = 0},
  [2146] = {.lex_state = 46},
  [2147] = {.lex_state = 0},
  [2148] = {.lex_state = 46},
  [2149] = {.lex_state = 30},
  [2150] = {.lex_state = 46},
  [2151] = {.lex_state = 46},
  [2152] = {.lex_state = 30},
  [2153] = {.lex_state = 0},
  [2154] = {.lex_state = 30},
  [2155] = {.lex_state = 30},
  [2156] = {.lex_state = 0},
  [2157] = {.lex_state = 55},
  [2158] = {.lex_state = 0},
  [2159] = {.lex_state = 30},
  [2160] = {.lex_state = 46},
  [2161] = {.lex_state = 46},
  [2162] = {.lex_state = 46},
  [2163] = {.lex_state = 46},
  [2164] = {.lex_state = 0},
  [2165] = {.lex_state = 0},
  [2166] = {.lex_state = 30},
  [2167] = {.lex_state = 0},
  [2168] = {.lex_state = 0},
  [2169] = {.lex_state = 46},
  [2170] = {.lex_state = 0},
  [2171] = {.lex_state = 46},
  [2172] = {.lex_state = 0},
  [2173] = {.lex_state = 0},
  [2174] = {.lex_state = 0},
  [2175] = {.lex_state = 46},
  [2176] = {.lex_state = 55},
  [2177] = {.lex_state = 0},
  [2178] = {.lex_state = 0},
  [2179] = {.lex_state = 46},
  [2180] = {.lex_state = 55},
  [2181] = {.lex_state = 0},
  [2182] = {.lex_state = 0},
  [2183] = {.lex_state = 0},
  [2184] = {.lex_state = 46},
  [2185] = {.lex_state = 55},
  [2186] = {.lex_state = 55},
  [2187] = {.lex_state = 55},
  [2188] = {.lex_state = 55},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 0},
  [2191] = {.lex_state = 0},
  [2192] = {.lex_state = 30},
  [2193] = {.lex_state = 30},
  [2194] = {.lex_state = 46},
  [2195] = {.lex_state = 55},
  [2196] = {.lex_state = 55},
  [2197] = {.lex_state = 46},
  [2198] = {.lex_state = 46},
  [2199] = {.lex_state = 46},
  [2200] = {.lex_state = 46},
  [2201] = {.lex_state = 30},
  [2202] = {.lex_state = 46},
  [2203] = {.lex_state = 46},
  [2204] = {.lex_state = 55},
  [2205] = {.lex_state = 0},
  [2206] = {.lex_state = 0},
  [2207] = {.lex_state = 0},
  [2208] = {.lex_state = 0},
  [2209] = {.lex_state = 0},
  [2210] = {.lex_state = 0},
  [2211] = {.lex_state = 0},
  [2212] = {.lex_state = 55},
  [2213] = {.lex_state = 55},
  [2214] = {.lex_state = 55},
  [2215] = {.lex_state = 0},
  [2216] = {.lex_state = 0},
  [2217] = {.lex_state = 0},
  [2218] = {.lex_state = 123},
  [2219] = {.lex_state = 46},
  [2220] = {.lex_state = 30},
  [2221] = {.lex_state = 0},
  [2222] = {.lex_state = 30},
  [2223] = {.lex_state = 0},
  [2224] = {.lex_state = 46},
  [2225] = {.lex_state = 0},
  [2226] = {.lex_state = 30},
  [2227] = {.lex_state = 0},
  [2228] = {.lex_state = 55},
  [2229] = {.lex_state = 0},
  [2230] = {.lex_state = 0},
  [2231] = {.lex_state = 0},
  [2232] = {.lex_state = 0},
  [2233] = {.lex_state = 46},
  [2234] = {.lex_state = 46},
  [2235] = {.lex_state = 0},
  [2236] = {.lex_state = 46},
  [2237] = {.lex_state = 46},
  [2238] = {.lex_state = 55},
  [2239] = {.lex_state = 0},
  [2240] = {.lex_state = 0},
  [2241] = {.lex_state = 46},
  [2242] = {.lex_state = 0},
  [2243] = {.lex_state = 30},
  [2244] = {.lex_state = 55},
  [2245] = {.lex_state = 30},
  [2246] = {.lex_state = 0},
  [2247] = {.lex_state = 0},
  [2248] = {.lex_state = 46},
  [2249] = {.lex_state = 0},
  [2250] = {.lex_state = 0},
  [2251] = {.lex_state = 46},
  [2252] = {.lex_state = 46},
  [2253] = {.lex_state = 0},
  [2254] = {.lex_state = 0},
  [2255] = {.lex_state = 0},
  [2256] = {.lex_state = 0},
  [2257] = {.lex_state = 0},
  [2258] = {.lex_state = 0},
  [2259] = {.lex_state = 0},
  [2260] = {.lex_state = 0},
  [2261] = {.lex_state = 0},
  [2262] = {.lex_state = 0},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 55},
  [2265] = {.lex_state = 0},
  [2266] = {.lex_state = 0},
  [2267] = {.lex_state = 0},
  [2268] = {.lex_state = 0},
  [2269] = {.lex_state = 55},
  [2270] = {.lex_state = 0},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 46},
  [2273] = {.lex_state = 46},
  [2274] = {.lex_state = 46},
  [2275] = {.lex_state = 46},
  [2276] = {.lex_state = 55},
  [2277] = {.lex_state = 46},
  [2278] = {.lex_state = 46},
  [2279] = {.lex_state = 0},
  [2280] = {.lex_state = 123},
  [2281] = {.lex_state = 0},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 0},
  [2284] = {.lex_state = 55},
  [2285] = {.lex_state = 55},
  [2286] = {.lex_state = 46},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 0},
  [2289] = {.lex_state = 0},
  [2290] = {.lex_state = 0},
  [2291] = {.lex_state = 46},
  [2292] = {.lex_state = 123},
  [2293] = {.lex_state = 123},
  [2294] = {.lex_state = 0},
  [2295] = {.lex_state = 0},
  [2296] = {.lex_state = 0},
  [2297] = {.lex_state = 0},
  [2298] = {.lex_state = 49},
  [2299] = {.lex_state = 49},
  [2300] = {.lex_state = 0},
  [2301] = {.lex_state = 30},
  [2302] = {.lex_state = 46},
  [2303] = {.lex_state = 30},
  [2304] = {.lex_state = 30},
  [2305] = {.lex_state = 55},
  [2306] = {.lex_state = 46},
  [2307] = {.lex_state = 46},
  [2308] = {.lex_state = 55},
  [2309] = {.lex_state = 0},
  [2310] = {.lex_state = 0},
  [2311] = {.lex_state = 55},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 46},
  [2314] = {.lex_state = 0},
  [2315] = {.lex_state = 30},
  [2316] = {.lex_state = 123},
  [2317] = {.lex_state = 46},
  [2318] = {.lex_state = 46},
  [2319] = {.lex_state = 0},
  [2320] = {.lex_state = 30},
  [2321] = {.lex_state = 123},
  [2322] = {.lex_state = 0},
  [2323] = {.lex_state = 0},
  [2324] = {.lex_state = 49},
  [2325] = {.lex_state = 0},
  [2326] = {.lex_state = 30},
  [2327] = {.lex_state = 55},
  [2328] = {.lex_state = 55},
  [2329] = {.lex_state = 30},
  [2330] = {.lex_state = 55},
  [2331] = {.lex_state = 123},
  [2332] = {.lex_state = 123},
  [2333] = {.lex_state = 123},
  [2334] = {.lex_state = 55},
  [2335] = {.lex_state = 0},
  [2336] = {.lex_state = 0},
  [2337] = {.lex_state = 0},
  [2338] = {.lex_state = 0},
  [2339] = {.lex_state = 123},
  [2340] = {.lex_state = 0},
  [2341] = {.lex_state = 49},
  [2342] = {.lex_state = 0},
  [2343] = {.lex_state = 30},
  [2344] = {.lex_state = 55},
  [2345] = {.lex_state = 46},
  [2346] = {.lex_state = 0},
  [2347] = {.lex_state = 30},
  [2348] = {.lex_state = 46},
  [2349] = {.lex_state = 30},
  [2350] = {.lex_state = 123},
  [2351] = {.lex_state = 123},
  [2352] = {.lex_state = 0},
  [2353] = {.lex_state = 123},
  [2354] = {.lex_state = 0},
  [2355] = {.lex_state = 123},
  [2356] = {.lex_state = 46},
  [2357] = {.lex_state = 0},
  [2358] = {.lex_state = 0},
  [2359] = {.lex_state = 30},
  [2360] = {.lex_state = 0},
  [2361] = {.lex_state = 55},
  [2362] = {.lex_state = 123},
  [2363] = {.lex_state = 0},
  [2364] = {.lex_state = 0},
  [2365] = {.lex_state = 0},
  [2366] = {.lex_state = 0},
  [2367] = {.lex_state = 46},
  [2368] = {.lex_state = 55},
  [2369] = {.lex_state = 46},
  [2370] = {.lex_state = 0},
  [2371] = {.lex_state = 30},
  [2372] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_subroutine] = ACTIONS(1),
    [anon_sym_invariant] = ACTIONS(1),
    [anon_sym_precise] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_inout] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_attribute] = ACTIONS(1),
    [anon_sym_varying] = ACTIONS(1),
    [anon_sym_buffer] = ACTIONS(1),
    [anon_sym_coherent] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_writeonly] = ACTIONS(1),
    [anon_sym_precision] = ACTIONS(1),
    [anon_sym_highp] = ACTIONS(1),
    [anon_sym_mediump] = ACTIONS(1),
    [anon_sym_lowp] = ACTIONS(1),
    [anon_sym_centroid] = ACTIONS(1),
    [anon_sym_sample] = ACTIONS(1),
    [anon_sym_patch] = ACTIONS(1),
    [anon_sym_smooth] = ACTIONS(1),
    [anon_sym_flat] = ACTIONS(1),
    [anon_sym_noperspective] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_auto] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_warn] = ACTIONS(1),
    [anon_sym_disable] = ACTIONS(1),
    [anon_sym_rayPayloadEXT] = ACTIONS(1),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1),
    [anon_sym_hitAttributeEXT] = ACTIONS(1),
    [anon_sym_callableDataEXT] = ACTIONS(1),
    [anon_sym_callableDataInEXT] = ACTIONS(1),
    [anon_sym_shaderRecordEXT] = ACTIONS(1),
    [anon_sym_rayPayloadNV] = ACTIONS(1),
    [anon_sym_rayPayloadInNV] = ACTIONS(1),
    [anon_sym_hitAttributeNV] = ACTIONS(1),
    [anon_sym_callableDataNV] = ACTIONS(1),
    [anon_sym_callableDataInNV] = ACTIONS(1),
    [anon_sym_shaderRecordNV] = ACTIONS(1),
    [anon_sym_layout] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(2319),
    [sym__top_level_item] = STATE(44),
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1254),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(879),
    [sym_compound_statement] = STATE(44),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(990),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(408),
    [sym__top_level_statement] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym__top_level_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_case_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_expression] = STATE(1234),
    [sym__string] = STATE(1231),
    [sym_conditional_expression] = STATE(1231),
    [sym_assignment_expression] = STATE(1231),
    [sym_pointer_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(1231),
    [sym_cast_expression] = STATE(1231),
    [sym_sizeof_expression] = STATE(1231),
    [sym_alignof_expression] = STATE(1231),
    [sym_offsetof_expression] = STATE(1231),
    [sym_generic_expression] = STATE(1231),
    [sym_subscript_expression] = STATE(1051),
    [sym_call_expression] = STATE(1051),
    [sym_gnu_asm_expression] = STATE(1231),
    [sym_field_expression] = STATE(1051),
    [sym_compound_literal_expression] = STATE(1231),
    [sym_parenthesized_expression] = STATE(1051),
    [sym_char_literal] = STATE(1231),
    [sym_concatenated_string] = STATE(1231),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(1231),
    [sym__empty_declaration] = STATE(44),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(44),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_translation_unit_repeat1] = STATE(44),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(27),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(99),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [2] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2194),
    [sym_preproc_elif] = STATE(2194),
    [sym_preproc_elifdef] = STATE(2194),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(121),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [3] = {
    [sym__block_item] = STATE(10),
    [sym_preproc_include] = STATE(10),
    [sym_preproc_def] = STATE(10),
    [sym_preproc_function_def] = STATE(10),
    [sym_preproc_call] = STATE(10),
    [sym_preproc_if] = STATE(10),
    [sym_preproc_ifdef] = STATE(10),
    [sym_preproc_else] = STATE(2160),
    [sym_preproc_elif] = STATE(2160),
    [sym_preproc_elifdef] = STATE(2160),
    [sym_function_definition] = STATE(10),
    [sym_declaration] = STATE(10),
    [sym_type_definition] = STATE(10),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(10),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(10),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(10),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(10),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(10),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [4] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2318),
    [sym_preproc_elif] = STATE(2318),
    [sym_preproc_elifdef] = STATE(2318),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(181),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [5] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2356),
    [sym_preproc_elif] = STATE(2356),
    [sym_preproc_elifdef] = STATE(2356),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(183),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [6] = {
    [sym__block_item] = STATE(21),
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_preproc_else] = STATE(2163),
    [sym_preproc_elif] = STATE(2163),
    [sym_preproc_elifdef] = STATE(2163),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(21),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(21),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(21),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(21),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(185),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [7] = {
    [sym__block_item] = STATE(12),
    [sym_preproc_include] = STATE(12),
    [sym_preproc_def] = STATE(12),
    [sym_preproc_function_def] = STATE(12),
    [sym_preproc_call] = STATE(12),
    [sym_preproc_if] = STATE(12),
    [sym_preproc_ifdef] = STATE(12),
    [sym_preproc_else] = STATE(2202),
    [sym_preproc_elif] = STATE(2202),
    [sym_preproc_elifdef] = STATE(2202),
    [sym_function_definition] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_type_definition] = STATE(12),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(12),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(12),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(12),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(12),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(12),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [8] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2248),
    [sym_preproc_elif] = STATE(2248),
    [sym_preproc_elifdef] = STATE(2248),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(189),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [9] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(2144),
    [sym_preproc_elif] = STATE(2144),
    [sym_preproc_elifdef] = STATE(2144),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(17),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(17),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [10] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2203),
    [sym_preproc_elif] = STATE(2203),
    [sym_preproc_elifdef] = STATE(2203),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(193),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [11] = {
    [sym__block_item] = STATE(8),
    [sym_preproc_include] = STATE(8),
    [sym_preproc_def] = STATE(8),
    [sym_preproc_function_def] = STATE(8),
    [sym_preproc_call] = STATE(8),
    [sym_preproc_if] = STATE(8),
    [sym_preproc_ifdef] = STATE(8),
    [sym_preproc_else] = STATE(2369),
    [sym_preproc_elif] = STATE(2369),
    [sym_preproc_elifdef] = STATE(2369),
    [sym_function_definition] = STATE(8),
    [sym_declaration] = STATE(8),
    [sym_type_definition] = STATE(8),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(8),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(8),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(8),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(8),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(8),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [12] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2146),
    [sym_preproc_elif] = STATE(2146),
    [sym_preproc_elifdef] = STATE(2146),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(197),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [13] = {
    [sym__block_item] = STATE(5),
    [sym_preproc_include] = STATE(5),
    [sym_preproc_def] = STATE(5),
    [sym_preproc_function_def] = STATE(5),
    [sym_preproc_call] = STATE(5),
    [sym_preproc_if] = STATE(5),
    [sym_preproc_ifdef] = STATE(5),
    [sym_preproc_else] = STATE(2143),
    [sym_preproc_elif] = STATE(2143),
    [sym_preproc_elifdef] = STATE(2143),
    [sym_function_definition] = STATE(5),
    [sym_declaration] = STATE(5),
    [sym_type_definition] = STATE(5),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(5),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(5),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(5),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(5),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(5),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [14] = {
    [sym__block_item] = STATE(20),
    [sym_preproc_include] = STATE(20),
    [sym_preproc_def] = STATE(20),
    [sym_preproc_function_def] = STATE(20),
    [sym_preproc_call] = STATE(20),
    [sym_preproc_if] = STATE(20),
    [sym_preproc_ifdef] = STATE(20),
    [sym_preproc_else] = STATE(2197),
    [sym_preproc_elif] = STATE(2197),
    [sym_preproc_elifdef] = STATE(2197),
    [sym_function_definition] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_type_definition] = STATE(20),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(20),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(20),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(20),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(20),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(20),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(201),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [15] = {
    [sym__block_item] = STATE(2),
    [sym_preproc_include] = STATE(2),
    [sym_preproc_def] = STATE(2),
    [sym_preproc_function_def] = STATE(2),
    [sym_preproc_call] = STATE(2),
    [sym_preproc_if] = STATE(2),
    [sym_preproc_ifdef] = STATE(2),
    [sym_preproc_else] = STATE(2219),
    [sym_preproc_elif] = STATE(2219),
    [sym_preproc_elifdef] = STATE(2219),
    [sym_function_definition] = STATE(2),
    [sym_declaration] = STATE(2),
    [sym_type_definition] = STATE(2),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(2),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(2),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(2),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(2),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(2),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [16] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2345),
    [sym_preproc_elif] = STATE(2345),
    [sym_preproc_elifdef] = STATE(2345),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(205),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [17] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2224),
    [sym_preproc_elif] = STATE(2224),
    [sym_preproc_elifdef] = STATE(2224),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(207),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [18] = {
    [sym__block_item] = STATE(4),
    [sym_preproc_include] = STATE(4),
    [sym_preproc_def] = STATE(4),
    [sym_preproc_function_def] = STATE(4),
    [sym_preproc_call] = STATE(4),
    [sym_preproc_if] = STATE(4),
    [sym_preproc_ifdef] = STATE(4),
    [sym_preproc_else] = STATE(2348),
    [sym_preproc_elif] = STATE(2348),
    [sym_preproc_elifdef] = STATE(2348),
    [sym_function_definition] = STATE(4),
    [sym_declaration] = STATE(4),
    [sym_type_definition] = STATE(4),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(4),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(4),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(4),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(4),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(4),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [19] = {
    [sym__block_item] = STATE(16),
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(2237),
    [sym_preproc_elif] = STATE(2237),
    [sym_preproc_elifdef] = STATE(2237),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(16),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(16),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(16),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(211),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [20] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2169),
    [sym_preproc_elif] = STATE(2169),
    [sym_preproc_elifdef] = STATE(2169),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(213),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [21] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(2313),
    [sym_preproc_elif] = STATE(2313),
    [sym_preproc_elifdef] = STATE(2313),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(113),
    [aux_sym_preproc_include_token1] = ACTIONS(115),
    [aux_sym_preproc_def_token1] = ACTIONS(117),
    [aux_sym_preproc_if_token1] = ACTIONS(119),
    [aux_sym_preproc_if_token2] = ACTIONS(215),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(123),
    [aux_sym_preproc_else_token1] = ACTIONS(125),
    [aux_sym_preproc_elif_token1] = ACTIONS(127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(129),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(129),
    [sym_preproc_directive] = ACTIONS(131),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(145),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [22] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_compound_statement] = STATE(119),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(989),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(161),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(22),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(22),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(217),
    [aux_sym_preproc_include_token1] = ACTIONS(220),
    [aux_sym_preproc_def_token1] = ACTIONS(223),
    [aux_sym_preproc_if_token1] = ACTIONS(226),
    [aux_sym_preproc_if_token2] = ACTIONS(229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(231),
    [aux_sym_preproc_else_token1] = ACTIONS(229),
    [aux_sym_preproc_elif_token1] = ACTIONS(229),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(229),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(229),
    [sym_preproc_directive] = ACTIONS(234),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(240),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(246),
    [anon_sym_subroutine] = ACTIONS(249),
    [anon_sym_invariant] = ACTIONS(252),
    [anon_sym_precise] = ACTIONS(252),
    [anon_sym_SEMI] = ACTIONS(255),
    [anon_sym_in] = ACTIONS(258),
    [anon_sym_out] = ACTIONS(258),
    [anon_sym_inout] = ACTIONS(258),
    [anon_sym_uniform] = ACTIONS(258),
    [anon_sym_shared] = ACTIONS(258),
    [anon_sym_attribute] = ACTIONS(258),
    [anon_sym_varying] = ACTIONS(258),
    [anon_sym_buffer] = ACTIONS(258),
    [anon_sym_coherent] = ACTIONS(258),
    [anon_sym_readonly] = ACTIONS(258),
    [anon_sym_writeonly] = ACTIONS(258),
    [anon_sym_precision] = ACTIONS(258),
    [anon_sym_highp] = ACTIONS(258),
    [anon_sym_mediump] = ACTIONS(258),
    [anon_sym_lowp] = ACTIONS(258),
    [anon_sym_centroid] = ACTIONS(258),
    [anon_sym_sample] = ACTIONS(258),
    [anon_sym_patch] = ACTIONS(258),
    [anon_sym_smooth] = ACTIONS(258),
    [anon_sym_flat] = ACTIONS(258),
    [anon_sym_noperspective] = ACTIONS(258),
    [anon_sym___extension__] = ACTIONS(261),
    [anon_sym_typedef] = ACTIONS(264),
    [anon_sym_extern] = ACTIONS(267),
    [anon_sym___attribute__] = ACTIONS(270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(273),
    [anon_sym___declspec] = ACTIONS(276),
    [anon_sym___cdecl] = ACTIONS(279),
    [anon_sym___clrcall] = ACTIONS(279),
    [anon_sym___stdcall] = ACTIONS(279),
    [anon_sym___fastcall] = ACTIONS(279),
    [anon_sym___thiscall] = ACTIONS(279),
    [anon_sym___vectorcall] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(282),
    [anon_sym_signed] = ACTIONS(285),
    [anon_sym_unsigned] = ACTIONS(285),
    [anon_sym_long] = ACTIONS(285),
    [anon_sym_short] = ACTIONS(285),
    [anon_sym_static] = ACTIONS(288),
    [anon_sym_auto] = ACTIONS(288),
    [anon_sym_register] = ACTIONS(288),
    [anon_sym_inline] = ACTIONS(288),
    [anon_sym___inline] = ACTIONS(288),
    [anon_sym___inline__] = ACTIONS(288),
    [anon_sym___forceinline] = ACTIONS(288),
    [anon_sym_thread_local] = ACTIONS(288),
    [anon_sym___thread] = ACTIONS(288),
    [anon_sym_const] = ACTIONS(291),
    [anon_sym_constexpr] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_restrict] = ACTIONS(291),
    [anon_sym___restrict__] = ACTIONS(291),
    [anon_sym__Atomic] = ACTIONS(291),
    [anon_sym__Noreturn] = ACTIONS(291),
    [anon_sym_noreturn] = ACTIONS(291),
    [anon_sym_alignas] = ACTIONS(294),
    [anon_sym__Alignas] = ACTIONS(294),
    [sym_primitive_type] = ACTIONS(297),
    [anon_sym_enum] = ACTIONS(300),
    [anon_sym_struct] = ACTIONS(303),
    [anon_sym_union] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(309),
    [anon_sym_switch] = ACTIONS(312),
    [anon_sym_case] = ACTIONS(315),
    [anon_sym_default] = ACTIONS(318),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(324),
    [anon_sym_for] = ACTIONS(327),
    [anon_sym_return] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(336),
    [anon_sym_goto] = ACTIONS(339),
    [anon_sym___try] = ACTIONS(342),
    [anon_sym___leave] = ACTIONS(345),
    [anon_sym_DASH_DASH] = ACTIONS(348),
    [anon_sym_PLUS_PLUS] = ACTIONS(348),
    [anon_sym_sizeof] = ACTIONS(351),
    [anon_sym___alignof__] = ACTIONS(354),
    [anon_sym___alignof] = ACTIONS(354),
    [anon_sym__alignof] = ACTIONS(354),
    [anon_sym_alignof] = ACTIONS(354),
    [anon_sym__Alignof] = ACTIONS(354),
    [anon_sym_offsetof] = ACTIONS(357),
    [anon_sym__Generic] = ACTIONS(360),
    [anon_sym_asm] = ACTIONS(363),
    [anon_sym___asm__] = ACTIONS(363),
    [sym_number_literal] = ACTIONS(366),
    [anon_sym_L_SQUOTE] = ACTIONS(369),
    [anon_sym_u_SQUOTE] = ACTIONS(369),
    [anon_sym_U_SQUOTE] = ACTIONS(369),
    [anon_sym_u8_SQUOTE] = ACTIONS(369),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_L_DQUOTE] = ACTIONS(372),
    [anon_sym_u_DQUOTE] = ACTIONS(372),
    [anon_sym_U_DQUOTE] = ACTIONS(372),
    [anon_sym_u8_DQUOTE] = ACTIONS(372),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [sym_true] = ACTIONS(375),
    [sym_false] = ACTIONS(375),
    [anon_sym_NULL] = ACTIONS(378),
    [anon_sym_nullptr] = ACTIONS(378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(381),
    [anon_sym_hitAttributeEXT] = ACTIONS(381),
    [anon_sym_callableDataEXT] = ACTIONS(381),
    [anon_sym_callableDataInEXT] = ACTIONS(381),
    [anon_sym_shaderRecordEXT] = ACTIONS(381),
    [anon_sym_rayPayloadNV] = ACTIONS(381),
    [anon_sym_rayPayloadInNV] = ACTIONS(381),
    [anon_sym_hitAttributeNV] = ACTIONS(381),
    [anon_sym_callableDataNV] = ACTIONS(381),
    [anon_sym_callableDataInNV] = ACTIONS(381),
    [anon_sym_shaderRecordNV] = ACTIONS(381),
    [anon_sym_layout] = ACTIONS(384),
  },
  [23] = {
    [sym__block_item] = STATE(36),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(36),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(36),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(36),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [24] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [25] = {
    [sym__block_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(29),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(29),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(29),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(445),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [26] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(39),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(39),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [27] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(35),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(35),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [28] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(33),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(33),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [29] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [30] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(887),
    [sym_compound_statement] = STATE(247),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(374),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(42),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(42),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(455),
    [aux_sym_preproc_include_token1] = ACTIONS(457),
    [aux_sym_preproc_def_token1] = ACTIONS(459),
    [aux_sym_preproc_if_token1] = ACTIONS(461),
    [aux_sym_preproc_if_token2] = ACTIONS(463),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(465),
    [sym_preproc_directive] = ACTIONS(467),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(469),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(481),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [31] = {
    [sym__block_item] = STATE(24),
    [sym_preproc_include] = STATE(24),
    [sym_preproc_def] = STATE(24),
    [sym_preproc_function_def] = STATE(24),
    [sym_preproc_call] = STATE(24),
    [sym_preproc_if] = STATE(24),
    [sym_preproc_ifdef] = STATE(24),
    [sym_function_definition] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_type_definition] = STATE(24),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(24),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(24),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(24),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(24),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(24),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [32] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(887),
    [sym_compound_statement] = STATE(247),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(374),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(32),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(513),
    [aux_sym_preproc_include_token1] = ACTIONS(516),
    [aux_sym_preproc_def_token1] = ACTIONS(519),
    [aux_sym_preproc_if_token1] = ACTIONS(522),
    [aux_sym_preproc_if_token2] = ACTIONS(229),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(525),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(525),
    [sym_preproc_directive] = ACTIONS(528),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(240),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(246),
    [anon_sym_subroutine] = ACTIONS(531),
    [anon_sym_invariant] = ACTIONS(534),
    [anon_sym_precise] = ACTIONS(534),
    [anon_sym_SEMI] = ACTIONS(537),
    [anon_sym_in] = ACTIONS(540),
    [anon_sym_out] = ACTIONS(540),
    [anon_sym_inout] = ACTIONS(540),
    [anon_sym_uniform] = ACTIONS(540),
    [anon_sym_shared] = ACTIONS(540),
    [anon_sym_attribute] = ACTIONS(540),
    [anon_sym_varying] = ACTIONS(540),
    [anon_sym_buffer] = ACTIONS(540),
    [anon_sym_coherent] = ACTIONS(540),
    [anon_sym_readonly] = ACTIONS(540),
    [anon_sym_writeonly] = ACTIONS(540),
    [anon_sym_precision] = ACTIONS(540),
    [anon_sym_highp] = ACTIONS(540),
    [anon_sym_mediump] = ACTIONS(540),
    [anon_sym_lowp] = ACTIONS(540),
    [anon_sym_centroid] = ACTIONS(540),
    [anon_sym_sample] = ACTIONS(540),
    [anon_sym_patch] = ACTIONS(540),
    [anon_sym_smooth] = ACTIONS(540),
    [anon_sym_flat] = ACTIONS(540),
    [anon_sym_noperspective] = ACTIONS(540),
    [anon_sym___extension__] = ACTIONS(543),
    [anon_sym_typedef] = ACTIONS(546),
    [anon_sym_extern] = ACTIONS(549),
    [anon_sym___attribute__] = ACTIONS(270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(273),
    [anon_sym___declspec] = ACTIONS(276),
    [anon_sym___cdecl] = ACTIONS(279),
    [anon_sym___clrcall] = ACTIONS(279),
    [anon_sym___stdcall] = ACTIONS(279),
    [anon_sym___fastcall] = ACTIONS(279),
    [anon_sym___thiscall] = ACTIONS(279),
    [anon_sym___vectorcall] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_signed] = ACTIONS(285),
    [anon_sym_unsigned] = ACTIONS(285),
    [anon_sym_long] = ACTIONS(285),
    [anon_sym_short] = ACTIONS(285),
    [anon_sym_static] = ACTIONS(288),
    [anon_sym_auto] = ACTIONS(288),
    [anon_sym_register] = ACTIONS(288),
    [anon_sym_inline] = ACTIONS(288),
    [anon_sym___inline] = ACTIONS(288),
    [anon_sym___inline__] = ACTIONS(288),
    [anon_sym___forceinline] = ACTIONS(288),
    [anon_sym_thread_local] = ACTIONS(288),
    [anon_sym___thread] = ACTIONS(288),
    [anon_sym_const] = ACTIONS(291),
    [anon_sym_constexpr] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_restrict] = ACTIONS(291),
    [anon_sym___restrict__] = ACTIONS(291),
    [anon_sym__Atomic] = ACTIONS(291),
    [anon_sym__Noreturn] = ACTIONS(291),
    [anon_sym_noreturn] = ACTIONS(291),
    [anon_sym_alignas] = ACTIONS(294),
    [anon_sym__Alignas] = ACTIONS(294),
    [sym_primitive_type] = ACTIONS(297),
    [anon_sym_enum] = ACTIONS(300),
    [anon_sym_struct] = ACTIONS(303),
    [anon_sym_union] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_case] = ACTIONS(561),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(570),
    [anon_sym_for] = ACTIONS(573),
    [anon_sym_return] = ACTIONS(576),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_continue] = ACTIONS(582),
    [anon_sym_goto] = ACTIONS(585),
    [anon_sym___try] = ACTIONS(588),
    [anon_sym___leave] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(348),
    [anon_sym_PLUS_PLUS] = ACTIONS(348),
    [anon_sym_sizeof] = ACTIONS(351),
    [anon_sym___alignof__] = ACTIONS(354),
    [anon_sym___alignof] = ACTIONS(354),
    [anon_sym__alignof] = ACTIONS(354),
    [anon_sym_alignof] = ACTIONS(354),
    [anon_sym__Alignof] = ACTIONS(354),
    [anon_sym_offsetof] = ACTIONS(357),
    [anon_sym__Generic] = ACTIONS(360),
    [anon_sym_asm] = ACTIONS(363),
    [anon_sym___asm__] = ACTIONS(363),
    [sym_number_literal] = ACTIONS(366),
    [anon_sym_L_SQUOTE] = ACTIONS(369),
    [anon_sym_u_SQUOTE] = ACTIONS(369),
    [anon_sym_U_SQUOTE] = ACTIONS(369),
    [anon_sym_u8_SQUOTE] = ACTIONS(369),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_L_DQUOTE] = ACTIONS(372),
    [anon_sym_u_DQUOTE] = ACTIONS(372),
    [anon_sym_U_DQUOTE] = ACTIONS(372),
    [anon_sym_u8_DQUOTE] = ACTIONS(372),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [sym_true] = ACTIONS(375),
    [sym_false] = ACTIONS(375),
    [anon_sym_NULL] = ACTIONS(378),
    [anon_sym_nullptr] = ACTIONS(378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(381),
    [anon_sym_hitAttributeEXT] = ACTIONS(381),
    [anon_sym_callableDataEXT] = ACTIONS(381),
    [anon_sym_callableDataInEXT] = ACTIONS(381),
    [anon_sym_shaderRecordEXT] = ACTIONS(381),
    [anon_sym_rayPayloadNV] = ACTIONS(381),
    [anon_sym_rayPayloadInNV] = ACTIONS(381),
    [anon_sym_hitAttributeNV] = ACTIONS(381),
    [anon_sym_callableDataNV] = ACTIONS(381),
    [anon_sym_callableDataInNV] = ACTIONS(381),
    [anon_sym_shaderRecordNV] = ACTIONS(381),
    [anon_sym_layout] = ACTIONS(384),
  },
  [33] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(594),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [34] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(38),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(38),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [35] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [36] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [37] = {
    [sym__block_item] = STATE(40),
    [sym_preproc_include] = STATE(40),
    [sym_preproc_def] = STATE(40),
    [sym_preproc_function_def] = STATE(40),
    [sym_preproc_call] = STATE(40),
    [sym_preproc_if] = STATE(40),
    [sym_preproc_ifdef] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_declaration] = STATE(40),
    [sym_type_definition] = STATE(40),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(40),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(40),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(40),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(40),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(40),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(602),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [38] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [39] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [40] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(387),
    [aux_sym_preproc_include_token1] = ACTIONS(389),
    [aux_sym_preproc_def_token1] = ACTIONS(391),
    [aux_sym_preproc_if_token1] = ACTIONS(393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(395),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(395),
    [sym_preproc_directive] = ACTIONS(397),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(411),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [41] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_compound_statement] = STATE(183),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(991),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(395),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(41),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(41),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(610),
    [aux_sym_preproc_include_token1] = ACTIONS(613),
    [aux_sym_preproc_def_token1] = ACTIONS(616),
    [aux_sym_preproc_if_token1] = ACTIONS(619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(622),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(622),
    [sym_preproc_directive] = ACTIONS(625),
    [anon_sym_LPAREN2] = ACTIONS(237),
    [anon_sym_BANG] = ACTIONS(240),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(243),
    [anon_sym_STAR] = ACTIONS(246),
    [anon_sym_AMP] = ACTIONS(246),
    [anon_sym_subroutine] = ACTIONS(628),
    [anon_sym_invariant] = ACTIONS(631),
    [anon_sym_precise] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(634),
    [anon_sym_in] = ACTIONS(637),
    [anon_sym_out] = ACTIONS(637),
    [anon_sym_inout] = ACTIONS(637),
    [anon_sym_uniform] = ACTIONS(637),
    [anon_sym_shared] = ACTIONS(637),
    [anon_sym_attribute] = ACTIONS(637),
    [anon_sym_varying] = ACTIONS(637),
    [anon_sym_buffer] = ACTIONS(637),
    [anon_sym_coherent] = ACTIONS(637),
    [anon_sym_readonly] = ACTIONS(637),
    [anon_sym_writeonly] = ACTIONS(637),
    [anon_sym_precision] = ACTIONS(637),
    [anon_sym_highp] = ACTIONS(637),
    [anon_sym_mediump] = ACTIONS(637),
    [anon_sym_lowp] = ACTIONS(637),
    [anon_sym_centroid] = ACTIONS(637),
    [anon_sym_sample] = ACTIONS(637),
    [anon_sym_patch] = ACTIONS(637),
    [anon_sym_smooth] = ACTIONS(637),
    [anon_sym_flat] = ACTIONS(637),
    [anon_sym_noperspective] = ACTIONS(637),
    [anon_sym___extension__] = ACTIONS(640),
    [anon_sym_typedef] = ACTIONS(643),
    [anon_sym_extern] = ACTIONS(646),
    [anon_sym___attribute__] = ACTIONS(270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(273),
    [anon_sym___declspec] = ACTIONS(276),
    [anon_sym___cdecl] = ACTIONS(279),
    [anon_sym___clrcall] = ACTIONS(279),
    [anon_sym___stdcall] = ACTIONS(279),
    [anon_sym___fastcall] = ACTIONS(279),
    [anon_sym___thiscall] = ACTIONS(279),
    [anon_sym___vectorcall] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_signed] = ACTIONS(285),
    [anon_sym_unsigned] = ACTIONS(285),
    [anon_sym_long] = ACTIONS(285),
    [anon_sym_short] = ACTIONS(285),
    [anon_sym_static] = ACTIONS(288),
    [anon_sym_auto] = ACTIONS(288),
    [anon_sym_register] = ACTIONS(288),
    [anon_sym_inline] = ACTIONS(288),
    [anon_sym___inline] = ACTIONS(288),
    [anon_sym___inline__] = ACTIONS(288),
    [anon_sym___forceinline] = ACTIONS(288),
    [anon_sym_thread_local] = ACTIONS(288),
    [anon_sym___thread] = ACTIONS(288),
    [anon_sym_const] = ACTIONS(291),
    [anon_sym_constexpr] = ACTIONS(291),
    [anon_sym_volatile] = ACTIONS(291),
    [anon_sym_restrict] = ACTIONS(291),
    [anon_sym___restrict__] = ACTIONS(291),
    [anon_sym__Atomic] = ACTIONS(291),
    [anon_sym__Noreturn] = ACTIONS(291),
    [anon_sym_noreturn] = ACTIONS(291),
    [anon_sym_alignas] = ACTIONS(294),
    [anon_sym__Alignas] = ACTIONS(294),
    [sym_primitive_type] = ACTIONS(297),
    [anon_sym_enum] = ACTIONS(300),
    [anon_sym_struct] = ACTIONS(303),
    [anon_sym_union] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(654),
    [anon_sym_switch] = ACTIONS(657),
    [anon_sym_case] = ACTIONS(660),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_while] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(669),
    [anon_sym_for] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(678),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(684),
    [anon_sym___try] = ACTIONS(687),
    [anon_sym___leave] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(348),
    [anon_sym_PLUS_PLUS] = ACTIONS(348),
    [anon_sym_sizeof] = ACTIONS(351),
    [anon_sym___alignof__] = ACTIONS(354),
    [anon_sym___alignof] = ACTIONS(354),
    [anon_sym__alignof] = ACTIONS(354),
    [anon_sym_alignof] = ACTIONS(354),
    [anon_sym__Alignof] = ACTIONS(354),
    [anon_sym_offsetof] = ACTIONS(357),
    [anon_sym__Generic] = ACTIONS(360),
    [anon_sym_asm] = ACTIONS(363),
    [anon_sym___asm__] = ACTIONS(363),
    [sym_number_literal] = ACTIONS(366),
    [anon_sym_L_SQUOTE] = ACTIONS(369),
    [anon_sym_u_SQUOTE] = ACTIONS(369),
    [anon_sym_U_SQUOTE] = ACTIONS(369),
    [anon_sym_u8_SQUOTE] = ACTIONS(369),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_L_DQUOTE] = ACTIONS(372),
    [anon_sym_u_DQUOTE] = ACTIONS(372),
    [anon_sym_U_DQUOTE] = ACTIONS(372),
    [anon_sym_u8_DQUOTE] = ACTIONS(372),
    [anon_sym_DQUOTE] = ACTIONS(372),
    [sym_true] = ACTIONS(375),
    [sym_false] = ACTIONS(375),
    [anon_sym_NULL] = ACTIONS(378),
    [anon_sym_nullptr] = ACTIONS(378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(381),
    [anon_sym_hitAttributeEXT] = ACTIONS(381),
    [anon_sym_callableDataEXT] = ACTIONS(381),
    [anon_sym_callableDataInEXT] = ACTIONS(381),
    [anon_sym_shaderRecordEXT] = ACTIONS(381),
    [anon_sym_rayPayloadNV] = ACTIONS(381),
    [anon_sym_rayPayloadInNV] = ACTIONS(381),
    [anon_sym_hitAttributeNV] = ACTIONS(381),
    [anon_sym_callableDataNV] = ACTIONS(381),
    [anon_sym_callableDataInNV] = ACTIONS(381),
    [anon_sym_shaderRecordNV] = ACTIONS(381),
    [anon_sym_layout] = ACTIONS(384),
  },
  [42] = {
    [sym__block_item] = STATE(32),
    [sym_preproc_include] = STATE(32),
    [sym_preproc_def] = STATE(32),
    [sym_preproc_function_def] = STATE(32),
    [sym_preproc_call] = STATE(32),
    [sym_preproc_if] = STATE(32),
    [sym_preproc_ifdef] = STATE(32),
    [sym_function_definition] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_type_definition] = STATE(32),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_linkage_specification] = STATE(32),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(887),
    [sym_compound_statement] = STATE(247),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1000),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(374),
    [sym_statement] = STATE(32),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym__empty_declaration] = STATE(32),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(32),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_preproc_if_repeat1] = STATE(32),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(455),
    [aux_sym_preproc_include_token1] = ACTIONS(457),
    [aux_sym_preproc_def_token1] = ACTIONS(459),
    [aux_sym_preproc_if_token1] = ACTIONS(461),
    [aux_sym_preproc_if_token2] = ACTIONS(693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(465),
    [sym_preproc_directive] = ACTIONS(467),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(469),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(481),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [43] = {
    [sym__top_level_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1254),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(879),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(990),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(408),
    [sym__top_level_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym__top_level_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_expression] = STATE(1234),
    [sym__string] = STATE(1231),
    [sym_conditional_expression] = STATE(1231),
    [sym_assignment_expression] = STATE(1231),
    [sym_pointer_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(1231),
    [sym_cast_expression] = STATE(1231),
    [sym_sizeof_expression] = STATE(1231),
    [sym_alignof_expression] = STATE(1231),
    [sym_offsetof_expression] = STATE(1231),
    [sym_generic_expression] = STATE(1231),
    [sym_subscript_expression] = STATE(1051),
    [sym_call_expression] = STATE(1051),
    [sym_gnu_asm_expression] = STATE(1231),
    [sym_field_expression] = STATE(1051),
    [sym_compound_literal_expression] = STATE(1231),
    [sym_parenthesized_expression] = STATE(1051),
    [sym_char_literal] = STATE(1231),
    [sym_concatenated_string] = STATE(1231),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(1231),
    [sym__empty_declaration] = STATE(43),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(43),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_translation_unit_repeat1] = STATE(43),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(695),
    [sym_identifier] = ACTIONS(697),
    [aux_sym_preproc_include_token1] = ACTIONS(700),
    [aux_sym_preproc_def_token1] = ACTIONS(703),
    [aux_sym_preproc_if_token1] = ACTIONS(706),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(709),
    [sym_preproc_directive] = ACTIONS(712),
    [anon_sym_LPAREN2] = ACTIONS(715),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_subroutine] = ACTIONS(727),
    [anon_sym_invariant] = ACTIONS(730),
    [anon_sym_precise] = ACTIONS(730),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_out] = ACTIONS(733),
    [anon_sym_inout] = ACTIONS(733),
    [anon_sym_uniform] = ACTIONS(733),
    [anon_sym_shared] = ACTIONS(733),
    [anon_sym_attribute] = ACTIONS(733),
    [anon_sym_varying] = ACTIONS(733),
    [anon_sym_buffer] = ACTIONS(733),
    [anon_sym_coherent] = ACTIONS(733),
    [anon_sym_readonly] = ACTIONS(733),
    [anon_sym_writeonly] = ACTIONS(733),
    [anon_sym_precision] = ACTIONS(733),
    [anon_sym_highp] = ACTIONS(733),
    [anon_sym_mediump] = ACTIONS(733),
    [anon_sym_lowp] = ACTIONS(733),
    [anon_sym_centroid] = ACTIONS(733),
    [anon_sym_sample] = ACTIONS(733),
    [anon_sym_patch] = ACTIONS(733),
    [anon_sym_smooth] = ACTIONS(733),
    [anon_sym_flat] = ACTIONS(733),
    [anon_sym_noperspective] = ACTIONS(733),
    [anon_sym___extension__] = ACTIONS(736),
    [anon_sym_typedef] = ACTIONS(739),
    [anon_sym_extern] = ACTIONS(742),
    [anon_sym___attribute__] = ACTIONS(745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(748),
    [anon_sym___declspec] = ACTIONS(751),
    [anon_sym___cdecl] = ACTIONS(754),
    [anon_sym___clrcall] = ACTIONS(754),
    [anon_sym___stdcall] = ACTIONS(754),
    [anon_sym___fastcall] = ACTIONS(754),
    [anon_sym___thiscall] = ACTIONS(754),
    [anon_sym___vectorcall] = ACTIONS(754),
    [anon_sym_LBRACE] = ACTIONS(757),
    [anon_sym_signed] = ACTIONS(760),
    [anon_sym_unsigned] = ACTIONS(760),
    [anon_sym_long] = ACTIONS(760),
    [anon_sym_short] = ACTIONS(760),
    [anon_sym_static] = ACTIONS(763),
    [anon_sym_auto] = ACTIONS(763),
    [anon_sym_register] = ACTIONS(763),
    [anon_sym_inline] = ACTIONS(763),
    [anon_sym___inline] = ACTIONS(763),
    [anon_sym___inline__] = ACTIONS(763),
    [anon_sym___forceinline] = ACTIONS(763),
    [anon_sym_thread_local] = ACTIONS(763),
    [anon_sym___thread] = ACTIONS(763),
    [anon_sym_const] = ACTIONS(766),
    [anon_sym_constexpr] = ACTIONS(766),
    [anon_sym_volatile] = ACTIONS(766),
    [anon_sym_restrict] = ACTIONS(766),
    [anon_sym___restrict__] = ACTIONS(766),
    [anon_sym__Atomic] = ACTIONS(766),
    [anon_sym__Noreturn] = ACTIONS(766),
    [anon_sym_noreturn] = ACTIONS(766),
    [anon_sym_alignas] = ACTIONS(769),
    [anon_sym__Alignas] = ACTIONS(769),
    [sym_primitive_type] = ACTIONS(772),
    [anon_sym_enum] = ACTIONS(775),
    [anon_sym_struct] = ACTIONS(778),
    [anon_sym_union] = ACTIONS(781),
    [anon_sym_if] = ACTIONS(784),
    [anon_sym_switch] = ACTIONS(787),
    [anon_sym_case] = ACTIONS(790),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(796),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(805),
    [anon_sym_break] = ACTIONS(808),
    [anon_sym_continue] = ACTIONS(811),
    [anon_sym_goto] = ACTIONS(814),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_sizeof] = ACTIONS(820),
    [anon_sym___alignof__] = ACTIONS(823),
    [anon_sym___alignof] = ACTIONS(823),
    [anon_sym__alignof] = ACTIONS(823),
    [anon_sym_alignof] = ACTIONS(823),
    [anon_sym__Alignof] = ACTIONS(823),
    [anon_sym_offsetof] = ACTIONS(826),
    [anon_sym__Generic] = ACTIONS(829),
    [anon_sym_asm] = ACTIONS(832),
    [anon_sym___asm__] = ACTIONS(832),
    [sym_number_literal] = ACTIONS(835),
    [anon_sym_L_SQUOTE] = ACTIONS(838),
    [anon_sym_u_SQUOTE] = ACTIONS(838),
    [anon_sym_U_SQUOTE] = ACTIONS(838),
    [anon_sym_u8_SQUOTE] = ACTIONS(838),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_L_DQUOTE] = ACTIONS(841),
    [anon_sym_u_DQUOTE] = ACTIONS(841),
    [anon_sym_U_DQUOTE] = ACTIONS(841),
    [anon_sym_u8_DQUOTE] = ACTIONS(841),
    [anon_sym_DQUOTE] = ACTIONS(841),
    [sym_true] = ACTIONS(844),
    [sym_false] = ACTIONS(844),
    [anon_sym_NULL] = ACTIONS(847),
    [anon_sym_nullptr] = ACTIONS(847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(850),
    [anon_sym_rayPayloadInEXT] = ACTIONS(850),
    [anon_sym_hitAttributeEXT] = ACTIONS(850),
    [anon_sym_callableDataEXT] = ACTIONS(850),
    [anon_sym_callableDataInEXT] = ACTIONS(850),
    [anon_sym_shaderRecordEXT] = ACTIONS(850),
    [anon_sym_rayPayloadNV] = ACTIONS(850),
    [anon_sym_rayPayloadInNV] = ACTIONS(850),
    [anon_sym_hitAttributeNV] = ACTIONS(850),
    [anon_sym_callableDataNV] = ACTIONS(850),
    [anon_sym_callableDataInNV] = ACTIONS(850),
    [anon_sym_shaderRecordNV] = ACTIONS(850),
    [anon_sym_layout] = ACTIONS(853),
  },
  [44] = {
    [sym__top_level_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1254),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(879),
    [sym_compound_statement] = STATE(43),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(990),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(408),
    [sym__top_level_statement] = STATE(43),
    [sym_labeled_statement] = STATE(43),
    [sym__top_level_expression_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_switch_statement] = STATE(43),
    [sym_case_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_expression] = STATE(1234),
    [sym__string] = STATE(1231),
    [sym_conditional_expression] = STATE(1231),
    [sym_assignment_expression] = STATE(1231),
    [sym_pointer_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(1231),
    [sym_cast_expression] = STATE(1231),
    [sym_sizeof_expression] = STATE(1231),
    [sym_alignof_expression] = STATE(1231),
    [sym_offsetof_expression] = STATE(1231),
    [sym_generic_expression] = STATE(1231),
    [sym_subscript_expression] = STATE(1051),
    [sym_call_expression] = STATE(1051),
    [sym_gnu_asm_expression] = STATE(1231),
    [sym_field_expression] = STATE(1051),
    [sym_compound_literal_expression] = STATE(1231),
    [sym_parenthesized_expression] = STATE(1051),
    [sym_char_literal] = STATE(1231),
    [sym_concatenated_string] = STATE(1231),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(1231),
    [sym__empty_declaration] = STATE(43),
    [sym_macro_type_specifier] = STATE(980),
    [sym_preproc_extension] = STATE(43),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_translation_unit_repeat1] = STATE(43),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(856),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(27),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(37),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(99),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [45] = {
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1257),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_seh_try_statement] = STATE(46),
    [sym_seh_leave_statement] = STATE(46),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(858),
    [aux_sym_preproc_include_token1] = ACTIONS(860),
    [aux_sym_preproc_def_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token2] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(860),
    [aux_sym_preproc_else_token1] = ACTIONS(860),
    [aux_sym_preproc_elif_token1] = ACTIONS(860),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(860),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(860),
    [sym_preproc_directive] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(139),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(860),
    [anon_sym___clrcall] = ACTIONS(860),
    [anon_sym___stdcall] = ACTIONS(860),
    [anon_sym___fastcall] = ACTIONS(860),
    [anon_sym___thiscall] = ACTIONS(860),
    [anon_sym___vectorcall] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(860),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [46] = {
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1257),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_seh_try_statement] = STATE(46),
    [sym_seh_leave_statement] = STATE(46),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(862),
    [aux_sym_preproc_include_token1] = ACTIONS(865),
    [aux_sym_preproc_def_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token2] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(865),
    [aux_sym_preproc_else_token1] = ACTIONS(865),
    [aux_sym_preproc_elif_token1] = ACTIONS(865),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(865),
    [sym_preproc_directive] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(876),
    [anon_sym_subroutine] = ACTIONS(879),
    [anon_sym_invariant] = ACTIONS(882),
    [anon_sym_precise] = ACTIONS(882),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_in] = ACTIONS(879),
    [anon_sym_out] = ACTIONS(879),
    [anon_sym_inout] = ACTIONS(879),
    [anon_sym_uniform] = ACTIONS(879),
    [anon_sym_shared] = ACTIONS(879),
    [anon_sym_attribute] = ACTIONS(879),
    [anon_sym_varying] = ACTIONS(879),
    [anon_sym_buffer] = ACTIONS(879),
    [anon_sym_coherent] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_writeonly] = ACTIONS(879),
    [anon_sym_precision] = ACTIONS(879),
    [anon_sym_highp] = ACTIONS(879),
    [anon_sym_mediump] = ACTIONS(879),
    [anon_sym_lowp] = ACTIONS(879),
    [anon_sym_centroid] = ACTIONS(879),
    [anon_sym_sample] = ACTIONS(879),
    [anon_sym_patch] = ACTIONS(879),
    [anon_sym_smooth] = ACTIONS(879),
    [anon_sym_flat] = ACTIONS(879),
    [anon_sym_noperspective] = ACTIONS(879),
    [anon_sym___extension__] = ACTIONS(888),
    [anon_sym_typedef] = ACTIONS(891),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(900),
    [anon_sym___declspec] = ACTIONS(903),
    [anon_sym___cdecl] = ACTIONS(865),
    [anon_sym___clrcall] = ACTIONS(865),
    [anon_sym___stdcall] = ACTIONS(865),
    [anon_sym___fastcall] = ACTIONS(865),
    [anon_sym___thiscall] = ACTIONS(865),
    [anon_sym___vectorcall] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(906),
    [anon_sym_signed] = ACTIONS(909),
    [anon_sym_unsigned] = ACTIONS(909),
    [anon_sym_long] = ACTIONS(909),
    [anon_sym_short] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym___inline] = ACTIONS(894),
    [anon_sym___inline__] = ACTIONS(894),
    [anon_sym___forceinline] = ACTIONS(894),
    [anon_sym_thread_local] = ACTIONS(894),
    [anon_sym___thread] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_constexpr] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_restrict] = ACTIONS(912),
    [anon_sym___restrict__] = ACTIONS(912),
    [anon_sym__Atomic] = ACTIONS(912),
    [anon_sym__Noreturn] = ACTIONS(912),
    [anon_sym_noreturn] = ACTIONS(912),
    [anon_sym_alignas] = ACTIONS(915),
    [anon_sym__Alignas] = ACTIONS(915),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(924),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(933),
    [anon_sym_case] = ACTIONS(865),
    [anon_sym_default] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(936),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(942),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_goto] = ACTIONS(954),
    [anon_sym___try] = ACTIONS(957),
    [anon_sym___leave] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_sizeof] = ACTIONS(966),
    [anon_sym___alignof__] = ACTIONS(969),
    [anon_sym___alignof] = ACTIONS(969),
    [anon_sym__alignof] = ACTIONS(969),
    [anon_sym_alignof] = ACTIONS(969),
    [anon_sym__Alignof] = ACTIONS(969),
    [anon_sym_offsetof] = ACTIONS(972),
    [anon_sym__Generic] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(978),
    [anon_sym___asm__] = ACTIONS(978),
    [sym_number_literal] = ACTIONS(981),
    [anon_sym_L_SQUOTE] = ACTIONS(984),
    [anon_sym_u_SQUOTE] = ACTIONS(984),
    [anon_sym_U_SQUOTE] = ACTIONS(984),
    [anon_sym_u8_SQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_L_DQUOTE] = ACTIONS(987),
    [anon_sym_u_DQUOTE] = ACTIONS(987),
    [anon_sym_U_DQUOTE] = ACTIONS(987),
    [anon_sym_u8_DQUOTE] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [anon_sym_NULL] = ACTIONS(993),
    [anon_sym_nullptr] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(996),
    [anon_sym_rayPayloadInEXT] = ACTIONS(996),
    [anon_sym_hitAttributeEXT] = ACTIONS(996),
    [anon_sym_callableDataEXT] = ACTIONS(996),
    [anon_sym_callableDataInEXT] = ACTIONS(996),
    [anon_sym_shaderRecordEXT] = ACTIONS(996),
    [anon_sym_rayPayloadNV] = ACTIONS(996),
    [anon_sym_rayPayloadInNV] = ACTIONS(996),
    [anon_sym_hitAttributeNV] = ACTIONS(996),
    [anon_sym_callableDataNV] = ACTIONS(996),
    [anon_sym_callableDataInNV] = ACTIONS(996),
    [anon_sym_shaderRecordNV] = ACTIONS(996),
    [anon_sym_layout] = ACTIONS(999),
  },
  [47] = {
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1257),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(46),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_seh_try_statement] = STATE(46),
    [sym_seh_leave_statement] = STATE(46),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [sym_identifier] = ACTIONS(858),
    [aux_sym_preproc_include_token1] = ACTIONS(1002),
    [aux_sym_preproc_def_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token2] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1002),
    [aux_sym_preproc_else_token1] = ACTIONS(1002),
    [aux_sym_preproc_elif_token1] = ACTIONS(1002),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1002),
    [sym_preproc_directive] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(139),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1002),
    [anon_sym___clrcall] = ACTIONS(1002),
    [anon_sym___stdcall] = ACTIONS(1002),
    [anon_sym___fastcall] = ACTIONS(1002),
    [anon_sym___thiscall] = ACTIONS(1002),
    [anon_sym___vectorcall] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [48] = {
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1257),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(45),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(45),
    [sym_labeled_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_switch_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym_seh_try_statement] = STATE(45),
    [sym_seh_leave_statement] = STATE(45),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(45),
    [sym_identifier] = ACTIONS(858),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [aux_sym_preproc_else_token1] = ACTIONS(1004),
    [aux_sym_preproc_elif_token1] = ACTIONS(1004),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(139),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [49] = {
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1257),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(47),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(47),
    [sym_labeled_statement] = STATE(47),
    [sym_expression_statement] = STATE(47),
    [sym_if_statement] = STATE(47),
    [sym_switch_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_do_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_return_statement] = STATE(47),
    [sym_break_statement] = STATE(47),
    [sym_continue_statement] = STATE(47),
    [sym_goto_statement] = STATE(47),
    [sym_seh_try_statement] = STATE(47),
    [sym_seh_leave_statement] = STATE(47),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(47),
    [sym_identifier] = ACTIONS(858),
    [aux_sym_preproc_include_token1] = ACTIONS(1006),
    [aux_sym_preproc_def_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token2] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1006),
    [aux_sym_preproc_else_token1] = ACTIONS(1006),
    [aux_sym_preproc_elif_token1] = ACTIONS(1006),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1006),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1006),
    [sym_preproc_directive] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(139),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(141),
    [anon_sym_typedef] = ACTIONS(143),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1006),
    [anon_sym___clrcall] = ACTIONS(1006),
    [anon_sym___stdcall] = ACTIONS(1006),
    [anon_sym___fastcall] = ACTIONS(1006),
    [anon_sym___thiscall] = ACTIONS(1006),
    [anon_sym___vectorcall] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [50] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [ts_builtin_sym_end] = ACTIONS(1008),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_preproc_include_token1] = ACTIONS(860),
    [aux_sym_preproc_def_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(860),
    [sym_preproc_directive] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(860),
    [anon_sym___clrcall] = ACTIONS(860),
    [anon_sym___stdcall] = ACTIONS(860),
    [anon_sym___fastcall] = ACTIONS(860),
    [anon_sym___thiscall] = ACTIONS(860),
    [anon_sym___vectorcall] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(860),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [51] = {
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(62),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(62),
    [sym_labeled_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_switch_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym_seh_try_statement] = STATE(62),
    [sym_seh_leave_statement] = STATE(62),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(62),
    [sym_identifier] = ACTIONS(1018),
    [aux_sym_preproc_include_token1] = ACTIONS(1006),
    [aux_sym_preproc_def_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token2] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1006),
    [sym_preproc_directive] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(475),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1006),
    [anon_sym___clrcall] = ACTIONS(1006),
    [anon_sym___stdcall] = ACTIONS(1006),
    [anon_sym___fastcall] = ACTIONS(1006),
    [anon_sym___thiscall] = ACTIONS(1006),
    [anon_sym___vectorcall] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [52] = {
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym_seh_try_statement] = STATE(52),
    [sym_seh_leave_statement] = STATE(52),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(1020),
    [aux_sym_preproc_include_token1] = ACTIONS(865),
    [aux_sym_preproc_def_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token2] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(865),
    [sym_preproc_directive] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(876),
    [anon_sym_subroutine] = ACTIONS(1023),
    [anon_sym_invariant] = ACTIONS(1026),
    [anon_sym_precise] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_out] = ACTIONS(1023),
    [anon_sym_inout] = ACTIONS(1023),
    [anon_sym_uniform] = ACTIONS(1023),
    [anon_sym_shared] = ACTIONS(1023),
    [anon_sym_attribute] = ACTIONS(1023),
    [anon_sym_varying] = ACTIONS(1023),
    [anon_sym_buffer] = ACTIONS(1023),
    [anon_sym_coherent] = ACTIONS(1023),
    [anon_sym_readonly] = ACTIONS(1023),
    [anon_sym_writeonly] = ACTIONS(1023),
    [anon_sym_precision] = ACTIONS(1023),
    [anon_sym_highp] = ACTIONS(1023),
    [anon_sym_mediump] = ACTIONS(1023),
    [anon_sym_lowp] = ACTIONS(1023),
    [anon_sym_centroid] = ACTIONS(1023),
    [anon_sym_sample] = ACTIONS(1023),
    [anon_sym_patch] = ACTIONS(1023),
    [anon_sym_smooth] = ACTIONS(1023),
    [anon_sym_flat] = ACTIONS(1023),
    [anon_sym_noperspective] = ACTIONS(1023),
    [anon_sym___extension__] = ACTIONS(1032),
    [anon_sym_typedef] = ACTIONS(1035),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(900),
    [anon_sym___declspec] = ACTIONS(903),
    [anon_sym___cdecl] = ACTIONS(865),
    [anon_sym___clrcall] = ACTIONS(865),
    [anon_sym___stdcall] = ACTIONS(865),
    [anon_sym___fastcall] = ACTIONS(865),
    [anon_sym___thiscall] = ACTIONS(865),
    [anon_sym___vectorcall] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_signed] = ACTIONS(909),
    [anon_sym_unsigned] = ACTIONS(909),
    [anon_sym_long] = ACTIONS(909),
    [anon_sym_short] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym___inline] = ACTIONS(894),
    [anon_sym___inline__] = ACTIONS(894),
    [anon_sym___forceinline] = ACTIONS(894),
    [anon_sym_thread_local] = ACTIONS(894),
    [anon_sym___thread] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_constexpr] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_restrict] = ACTIONS(912),
    [anon_sym___restrict__] = ACTIONS(912),
    [anon_sym__Atomic] = ACTIONS(912),
    [anon_sym__Noreturn] = ACTIONS(912),
    [anon_sym_noreturn] = ACTIONS(912),
    [anon_sym_alignas] = ACTIONS(915),
    [anon_sym__Alignas] = ACTIONS(915),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(924),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(865),
    [anon_sym_default] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(1047),
    [anon_sym_do] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1062),
    [anon_sym_goto] = ACTIONS(1065),
    [anon_sym___try] = ACTIONS(1068),
    [anon_sym___leave] = ACTIONS(1071),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_sizeof] = ACTIONS(966),
    [anon_sym___alignof__] = ACTIONS(969),
    [anon_sym___alignof] = ACTIONS(969),
    [anon_sym__alignof] = ACTIONS(969),
    [anon_sym_alignof] = ACTIONS(969),
    [anon_sym__Alignof] = ACTIONS(969),
    [anon_sym_offsetof] = ACTIONS(972),
    [anon_sym__Generic] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(978),
    [anon_sym___asm__] = ACTIONS(978),
    [sym_number_literal] = ACTIONS(981),
    [anon_sym_L_SQUOTE] = ACTIONS(984),
    [anon_sym_u_SQUOTE] = ACTIONS(984),
    [anon_sym_U_SQUOTE] = ACTIONS(984),
    [anon_sym_u8_SQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_L_DQUOTE] = ACTIONS(987),
    [anon_sym_u_DQUOTE] = ACTIONS(987),
    [anon_sym_U_DQUOTE] = ACTIONS(987),
    [anon_sym_u8_DQUOTE] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [anon_sym_NULL] = ACTIONS(993),
    [anon_sym_nullptr] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(996),
    [anon_sym_rayPayloadInEXT] = ACTIONS(996),
    [anon_sym_hitAttributeEXT] = ACTIONS(996),
    [anon_sym_callableDataEXT] = ACTIONS(996),
    [anon_sym_callableDataInEXT] = ACTIONS(996),
    [anon_sym_shaderRecordEXT] = ACTIONS(996),
    [anon_sym_rayPayloadNV] = ACTIONS(996),
    [anon_sym_rayPayloadInNV] = ACTIONS(996),
    [anon_sym_hitAttributeNV] = ACTIONS(996),
    [anon_sym_callableDataNV] = ACTIONS(996),
    [anon_sym_callableDataInNV] = ACTIONS(996),
    [anon_sym_shaderRecordNV] = ACTIONS(996),
    [anon_sym_layout] = ACTIONS(999),
  },
  [53] = {
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(55),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_seh_try_statement] = STATE(55),
    [sym_seh_leave_statement] = STATE(55),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(55),
    [sym_identifier] = ACTIONS(1018),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token2] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(475),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [54] = {
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1250),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(59),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(59),
    [sym_labeled_statement] = STATE(59),
    [sym_expression_statement] = STATE(59),
    [sym_if_statement] = STATE(59),
    [sym_switch_statement] = STATE(59),
    [sym_while_statement] = STATE(59),
    [sym_do_statement] = STATE(59),
    [sym_for_statement] = STATE(59),
    [sym_return_statement] = STATE(59),
    [sym_break_statement] = STATE(59),
    [sym_continue_statement] = STATE(59),
    [sym_goto_statement] = STATE(59),
    [sym_seh_try_statement] = STATE(59),
    [sym_seh_leave_statement] = STATE(59),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(59),
    [sym_identifier] = ACTIONS(1074),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(405),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [55] = {
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym_seh_try_statement] = STATE(52),
    [sym_seh_leave_statement] = STATE(52),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(1018),
    [aux_sym_preproc_include_token1] = ACTIONS(860),
    [aux_sym_preproc_def_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token2] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(860),
    [sym_preproc_directive] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(475),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(860),
    [anon_sym___clrcall] = ACTIONS(860),
    [anon_sym___stdcall] = ACTIONS(860),
    [anon_sym___fastcall] = ACTIONS(860),
    [anon_sym___thiscall] = ACTIONS(860),
    [anon_sym___vectorcall] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(860),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [56] = {
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(64),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(64),
    [sym_labeled_statement] = STATE(64),
    [sym_expression_statement] = STATE(64),
    [sym_if_statement] = STATE(64),
    [sym_switch_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_do_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_return_statement] = STATE(64),
    [sym_break_statement] = STATE(64),
    [sym_continue_statement] = STATE(64),
    [sym_goto_statement] = STATE(64),
    [sym_seh_try_statement] = STATE(64),
    [sym_seh_leave_statement] = STATE(64),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(64),
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_preproc_include_token1] = ACTIONS(1006),
    [aux_sym_preproc_def_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1006),
    [sym_preproc_directive] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1006),
    [anon_sym___clrcall] = ACTIONS(1006),
    [anon_sym___stdcall] = ACTIONS(1006),
    [anon_sym___fastcall] = ACTIONS(1006),
    [anon_sym___thiscall] = ACTIONS(1006),
    [anon_sym___vectorcall] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [57] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1250),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_seh_try_statement] = STATE(60),
    [sym_seh_leave_statement] = STATE(60),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(1074),
    [aux_sym_preproc_include_token1] = ACTIONS(1002),
    [aux_sym_preproc_def_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1002),
    [sym_preproc_directive] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(405),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1002),
    [anon_sym___clrcall] = ACTIONS(1002),
    [anon_sym___stdcall] = ACTIONS(1002),
    [anon_sym___fastcall] = ACTIONS(1002),
    [anon_sym___thiscall] = ACTIONS(1002),
    [anon_sym___vectorcall] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [58] = {
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(50),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(50),
    [sym_labeled_statement] = STATE(50),
    [sym_expression_statement] = STATE(50),
    [sym_if_statement] = STATE(50),
    [sym_switch_statement] = STATE(50),
    [sym_while_statement] = STATE(50),
    [sym_do_statement] = STATE(50),
    [sym_for_statement] = STATE(50),
    [sym_return_statement] = STATE(50),
    [sym_break_statement] = STATE(50),
    [sym_continue_statement] = STATE(50),
    [sym_goto_statement] = STATE(50),
    [sym_seh_try_statement] = STATE(50),
    [sym_seh_leave_statement] = STATE(50),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_preproc_include_token1] = ACTIONS(1004),
    [aux_sym_preproc_def_token1] = ACTIONS(1004),
    [aux_sym_preproc_if_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1004),
    [sym_preproc_directive] = ACTIONS(1004),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1004),
    [anon_sym___clrcall] = ACTIONS(1004),
    [anon_sym___stdcall] = ACTIONS(1004),
    [anon_sym___fastcall] = ACTIONS(1004),
    [anon_sym___thiscall] = ACTIONS(1004),
    [anon_sym___vectorcall] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1004),
    [anon_sym_default] = ACTIONS(1004),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [59] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1250),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_seh_try_statement] = STATE(60),
    [sym_seh_leave_statement] = STATE(60),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(1074),
    [aux_sym_preproc_include_token1] = ACTIONS(860),
    [aux_sym_preproc_def_token1] = ACTIONS(860),
    [aux_sym_preproc_if_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(860),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(860),
    [sym_preproc_directive] = ACTIONS(860),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(405),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(860),
    [anon_sym___clrcall] = ACTIONS(860),
    [anon_sym___stdcall] = ACTIONS(860),
    [anon_sym___fastcall] = ACTIONS(860),
    [anon_sym___thiscall] = ACTIONS(860),
    [anon_sym___vectorcall] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(860),
    [anon_sym_default] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [60] = {
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1250),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(60),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(60),
    [sym_labeled_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_switch_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_seh_try_statement] = STATE(60),
    [sym_seh_leave_statement] = STATE(60),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(1082),
    [aux_sym_preproc_include_token1] = ACTIONS(865),
    [aux_sym_preproc_def_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(865),
    [sym_preproc_directive] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(876),
    [anon_sym_subroutine] = ACTIONS(1085),
    [anon_sym_invariant] = ACTIONS(1088),
    [anon_sym_precise] = ACTIONS(1088),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1085),
    [anon_sym_out] = ACTIONS(1085),
    [anon_sym_inout] = ACTIONS(1085),
    [anon_sym_uniform] = ACTIONS(1085),
    [anon_sym_shared] = ACTIONS(1085),
    [anon_sym_attribute] = ACTIONS(1085),
    [anon_sym_varying] = ACTIONS(1085),
    [anon_sym_buffer] = ACTIONS(1085),
    [anon_sym_coherent] = ACTIONS(1085),
    [anon_sym_readonly] = ACTIONS(1085),
    [anon_sym_writeonly] = ACTIONS(1085),
    [anon_sym_precision] = ACTIONS(1085),
    [anon_sym_highp] = ACTIONS(1085),
    [anon_sym_mediump] = ACTIONS(1085),
    [anon_sym_lowp] = ACTIONS(1085),
    [anon_sym_centroid] = ACTIONS(1085),
    [anon_sym_sample] = ACTIONS(1085),
    [anon_sym_patch] = ACTIONS(1085),
    [anon_sym_smooth] = ACTIONS(1085),
    [anon_sym_flat] = ACTIONS(1085),
    [anon_sym_noperspective] = ACTIONS(1085),
    [anon_sym___extension__] = ACTIONS(1094),
    [anon_sym_typedef] = ACTIONS(1097),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(900),
    [anon_sym___declspec] = ACTIONS(903),
    [anon_sym___cdecl] = ACTIONS(865),
    [anon_sym___clrcall] = ACTIONS(865),
    [anon_sym___stdcall] = ACTIONS(865),
    [anon_sym___fastcall] = ACTIONS(865),
    [anon_sym___thiscall] = ACTIONS(865),
    [anon_sym___vectorcall] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_signed] = ACTIONS(909),
    [anon_sym_unsigned] = ACTIONS(909),
    [anon_sym_long] = ACTIONS(909),
    [anon_sym_short] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym___inline] = ACTIONS(894),
    [anon_sym___inline__] = ACTIONS(894),
    [anon_sym___forceinline] = ACTIONS(894),
    [anon_sym_thread_local] = ACTIONS(894),
    [anon_sym___thread] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_constexpr] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_restrict] = ACTIONS(912),
    [anon_sym___restrict__] = ACTIONS(912),
    [anon_sym__Atomic] = ACTIONS(912),
    [anon_sym__Noreturn] = ACTIONS(912),
    [anon_sym_noreturn] = ACTIONS(912),
    [anon_sym_alignas] = ACTIONS(915),
    [anon_sym__Alignas] = ACTIONS(915),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(924),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_case] = ACTIONS(865),
    [anon_sym_default] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_do] = ACTIONS(1114),
    [anon_sym_for] = ACTIONS(1117),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_break] = ACTIONS(1123),
    [anon_sym_continue] = ACTIONS(1126),
    [anon_sym_goto] = ACTIONS(1129),
    [anon_sym___try] = ACTIONS(1132),
    [anon_sym___leave] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_sizeof] = ACTIONS(966),
    [anon_sym___alignof__] = ACTIONS(969),
    [anon_sym___alignof] = ACTIONS(969),
    [anon_sym__alignof] = ACTIONS(969),
    [anon_sym_alignof] = ACTIONS(969),
    [anon_sym__Alignof] = ACTIONS(969),
    [anon_sym_offsetof] = ACTIONS(972),
    [anon_sym__Generic] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(978),
    [anon_sym___asm__] = ACTIONS(978),
    [sym_number_literal] = ACTIONS(981),
    [anon_sym_L_SQUOTE] = ACTIONS(984),
    [anon_sym_u_SQUOTE] = ACTIONS(984),
    [anon_sym_U_SQUOTE] = ACTIONS(984),
    [anon_sym_u8_SQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_L_DQUOTE] = ACTIONS(987),
    [anon_sym_u_DQUOTE] = ACTIONS(987),
    [anon_sym_U_DQUOTE] = ACTIONS(987),
    [anon_sym_u8_DQUOTE] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [anon_sym_NULL] = ACTIONS(993),
    [anon_sym_nullptr] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(996),
    [anon_sym_rayPayloadInEXT] = ACTIONS(996),
    [anon_sym_hitAttributeEXT] = ACTIONS(996),
    [anon_sym_callableDataEXT] = ACTIONS(996),
    [anon_sym_callableDataInEXT] = ACTIONS(996),
    [anon_sym_shaderRecordEXT] = ACTIONS(996),
    [anon_sym_rayPayloadNV] = ACTIONS(996),
    [anon_sym_rayPayloadInNV] = ACTIONS(996),
    [anon_sym_hitAttributeNV] = ACTIONS(996),
    [anon_sym_callableDataNV] = ACTIONS(996),
    [anon_sym_callableDataInNV] = ACTIONS(996),
    [anon_sym_shaderRecordNV] = ACTIONS(996),
    [anon_sym_layout] = ACTIONS(999),
  },
  [61] = {
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1250),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(57),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(57),
    [sym_labeled_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_switch_statement] = STATE(57),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym_seh_try_statement] = STATE(57),
    [sym_seh_leave_statement] = STATE(57),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(1074),
    [aux_sym_preproc_include_token1] = ACTIONS(1006),
    [aux_sym_preproc_def_token1] = ACTIONS(1006),
    [aux_sym_preproc_if_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1006),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1006),
    [sym_preproc_directive] = ACTIONS(1006),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(405),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(407),
    [anon_sym_typedef] = ACTIONS(409),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1006),
    [anon_sym___clrcall] = ACTIONS(1006),
    [anon_sym___stdcall] = ACTIONS(1006),
    [anon_sym___fastcall] = ACTIONS(1006),
    [anon_sym___thiscall] = ACTIONS(1006),
    [anon_sym___vectorcall] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [62] = {
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1272),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(52),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym_seh_try_statement] = STATE(52),
    [sym_seh_leave_statement] = STATE(52),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(52),
    [sym_identifier] = ACTIONS(1018),
    [aux_sym_preproc_include_token1] = ACTIONS(1002),
    [aux_sym_preproc_def_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token2] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1002),
    [sym_preproc_directive] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(475),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(477),
    [anon_sym_typedef] = ACTIONS(479),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1002),
    [anon_sym___clrcall] = ACTIONS(1002),
    [anon_sym___stdcall] = ACTIONS(1002),
    [anon_sym___fastcall] = ACTIONS(1002),
    [anon_sym___thiscall] = ACTIONS(1002),
    [anon_sym___vectorcall] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [63] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1138),
    [aux_sym_preproc_include_token1] = ACTIONS(865),
    [aux_sym_preproc_def_token1] = ACTIONS(865),
    [aux_sym_preproc_if_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(865),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(865),
    [sym_preproc_directive] = ACTIONS(865),
    [anon_sym_LPAREN2] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(876),
    [anon_sym_subroutine] = ACTIONS(1141),
    [anon_sym_invariant] = ACTIONS(1144),
    [anon_sym_precise] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1141),
    [anon_sym_out] = ACTIONS(1141),
    [anon_sym_inout] = ACTIONS(1141),
    [anon_sym_uniform] = ACTIONS(1141),
    [anon_sym_shared] = ACTIONS(1141),
    [anon_sym_attribute] = ACTIONS(1141),
    [anon_sym_varying] = ACTIONS(1141),
    [anon_sym_buffer] = ACTIONS(1141),
    [anon_sym_coherent] = ACTIONS(1141),
    [anon_sym_readonly] = ACTIONS(1141),
    [anon_sym_writeonly] = ACTIONS(1141),
    [anon_sym_precision] = ACTIONS(1141),
    [anon_sym_highp] = ACTIONS(1141),
    [anon_sym_mediump] = ACTIONS(1141),
    [anon_sym_lowp] = ACTIONS(1141),
    [anon_sym_centroid] = ACTIONS(1141),
    [anon_sym_sample] = ACTIONS(1141),
    [anon_sym_patch] = ACTIONS(1141),
    [anon_sym_smooth] = ACTIONS(1141),
    [anon_sym_flat] = ACTIONS(1141),
    [anon_sym_noperspective] = ACTIONS(1141),
    [anon_sym___extension__] = ACTIONS(1150),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(900),
    [anon_sym___declspec] = ACTIONS(903),
    [anon_sym___cdecl] = ACTIONS(865),
    [anon_sym___clrcall] = ACTIONS(865),
    [anon_sym___stdcall] = ACTIONS(865),
    [anon_sym___fastcall] = ACTIONS(865),
    [anon_sym___thiscall] = ACTIONS(865),
    [anon_sym___vectorcall] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_signed] = ACTIONS(909),
    [anon_sym_unsigned] = ACTIONS(909),
    [anon_sym_long] = ACTIONS(909),
    [anon_sym_short] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym___inline] = ACTIONS(894),
    [anon_sym___inline__] = ACTIONS(894),
    [anon_sym___forceinline] = ACTIONS(894),
    [anon_sym_thread_local] = ACTIONS(894),
    [anon_sym___thread] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_constexpr] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_restrict] = ACTIONS(912),
    [anon_sym___restrict__] = ACTIONS(912),
    [anon_sym__Atomic] = ACTIONS(912),
    [anon_sym__Noreturn] = ACTIONS(912),
    [anon_sym_noreturn] = ACTIONS(912),
    [anon_sym_alignas] = ACTIONS(915),
    [anon_sym__Alignas] = ACTIONS(915),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(924),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(865),
    [anon_sym_default] = ACTIONS(865),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1174),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_goto] = ACTIONS(1183),
    [anon_sym___try] = ACTIONS(1186),
    [anon_sym___leave] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_sizeof] = ACTIONS(966),
    [anon_sym___alignof__] = ACTIONS(969),
    [anon_sym___alignof] = ACTIONS(969),
    [anon_sym__alignof] = ACTIONS(969),
    [anon_sym_alignof] = ACTIONS(969),
    [anon_sym__Alignof] = ACTIONS(969),
    [anon_sym_offsetof] = ACTIONS(972),
    [anon_sym__Generic] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(978),
    [anon_sym___asm__] = ACTIONS(978),
    [sym_number_literal] = ACTIONS(981),
    [anon_sym_L_SQUOTE] = ACTIONS(984),
    [anon_sym_u_SQUOTE] = ACTIONS(984),
    [anon_sym_U_SQUOTE] = ACTIONS(984),
    [anon_sym_u8_SQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_L_DQUOTE] = ACTIONS(987),
    [anon_sym_u_DQUOTE] = ACTIONS(987),
    [anon_sym_U_DQUOTE] = ACTIONS(987),
    [anon_sym_u8_DQUOTE] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [anon_sym_NULL] = ACTIONS(993),
    [anon_sym_nullptr] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(996),
    [anon_sym_rayPayloadInEXT] = ACTIONS(996),
    [anon_sym_hitAttributeEXT] = ACTIONS(996),
    [anon_sym_callableDataEXT] = ACTIONS(996),
    [anon_sym_callableDataInEXT] = ACTIONS(996),
    [anon_sym_shaderRecordEXT] = ACTIONS(996),
    [anon_sym_rayPayloadNV] = ACTIONS(996),
    [anon_sym_rayPayloadInNV] = ACTIONS(996),
    [anon_sym_hitAttributeNV] = ACTIONS(996),
    [anon_sym_callableDataNV] = ACTIONS(996),
    [anon_sym_callableDataInNV] = ACTIONS(996),
    [anon_sym_shaderRecordNV] = ACTIONS(996),
    [anon_sym_layout] = ACTIONS(999),
  },
  [64] = {
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(63),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_seh_try_statement] = STATE(63),
    [sym_seh_leave_statement] = STATE(63),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [ts_builtin_sym_end] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1010),
    [aux_sym_preproc_include_token1] = ACTIONS(1002),
    [aux_sym_preproc_def_token1] = ACTIONS(1002),
    [aux_sym_preproc_if_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1002),
    [sym_preproc_directive] = ACTIONS(1002),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(1002),
    [anon_sym___clrcall] = ACTIONS(1002),
    [anon_sym___stdcall] = ACTIONS(1002),
    [anon_sym___fastcall] = ACTIONS(1002),
    [anon_sym___thiscall] = ACTIONS(1002),
    [anon_sym___vectorcall] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [65] = {
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(69),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(69),
    [sym_labeled_statement] = STATE(69),
    [sym_expression_statement] = STATE(69),
    [sym_if_statement] = STATE(69),
    [sym_switch_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_do_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_return_statement] = STATE(69),
    [sym_break_statement] = STATE(69),
    [sym_continue_statement] = STATE(69),
    [sym_goto_statement] = STATE(69),
    [sym_seh_try_statement] = STATE(69),
    [sym_seh_leave_statement] = STATE(69),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [66] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [67] = {
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(66),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(66),
    [sym_labeled_statement] = STATE(66),
    [sym_expression_statement] = STATE(66),
    [sym_if_statement] = STATE(66),
    [sym_switch_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_do_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_return_statement] = STATE(66),
    [sym_break_statement] = STATE(66),
    [sym_continue_statement] = STATE(66),
    [sym_goto_statement] = STATE(66),
    [sym_seh_try_statement] = STATE(66),
    [sym_seh_leave_statement] = STATE(66),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [68] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LPAREN2] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(873),
    [anon_sym_STAR] = ACTIONS(876),
    [anon_sym_AMP] = ACTIONS(876),
    [anon_sym_subroutine] = ACTIONS(1141),
    [anon_sym_invariant] = ACTIONS(1144),
    [anon_sym_precise] = ACTIONS(1144),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1141),
    [anon_sym_out] = ACTIONS(1141),
    [anon_sym_inout] = ACTIONS(1141),
    [anon_sym_uniform] = ACTIONS(1141),
    [anon_sym_shared] = ACTIONS(1141),
    [anon_sym_attribute] = ACTIONS(1141),
    [anon_sym_varying] = ACTIONS(1141),
    [anon_sym_buffer] = ACTIONS(1141),
    [anon_sym_coherent] = ACTIONS(1141),
    [anon_sym_readonly] = ACTIONS(1141),
    [anon_sym_writeonly] = ACTIONS(1141),
    [anon_sym_precision] = ACTIONS(1141),
    [anon_sym_highp] = ACTIONS(1141),
    [anon_sym_mediump] = ACTIONS(1141),
    [anon_sym_lowp] = ACTIONS(1141),
    [anon_sym_centroid] = ACTIONS(1141),
    [anon_sym_sample] = ACTIONS(1141),
    [anon_sym_patch] = ACTIONS(1141),
    [anon_sym_smooth] = ACTIONS(1141),
    [anon_sym_flat] = ACTIONS(1141),
    [anon_sym_noperspective] = ACTIONS(1141),
    [anon_sym___extension__] = ACTIONS(1150),
    [anon_sym_typedef] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym___attribute__] = ACTIONS(897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(900),
    [anon_sym___declspec] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_signed] = ACTIONS(909),
    [anon_sym_unsigned] = ACTIONS(909),
    [anon_sym_long] = ACTIONS(909),
    [anon_sym_short] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(894),
    [anon_sym_auto] = ACTIONS(894),
    [anon_sym_register] = ACTIONS(894),
    [anon_sym_inline] = ACTIONS(894),
    [anon_sym___inline] = ACTIONS(894),
    [anon_sym___inline__] = ACTIONS(894),
    [anon_sym___forceinline] = ACTIONS(894),
    [anon_sym_thread_local] = ACTIONS(894),
    [anon_sym___thread] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(912),
    [anon_sym_constexpr] = ACTIONS(912),
    [anon_sym_volatile] = ACTIONS(912),
    [anon_sym_restrict] = ACTIONS(912),
    [anon_sym___restrict__] = ACTIONS(912),
    [anon_sym__Atomic] = ACTIONS(912),
    [anon_sym__Noreturn] = ACTIONS(912),
    [anon_sym_noreturn] = ACTIONS(912),
    [anon_sym_alignas] = ACTIONS(915),
    [anon_sym__Alignas] = ACTIONS(915),
    [sym_primitive_type] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(921),
    [anon_sym_struct] = ACTIONS(924),
    [anon_sym_union] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(865),
    [anon_sym_switch] = ACTIONS(1162),
    [anon_sym_while] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1174),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_goto] = ACTIONS(1183),
    [anon_sym___try] = ACTIONS(1214),
    [anon_sym___leave] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_sizeof] = ACTIONS(966),
    [anon_sym___alignof__] = ACTIONS(969),
    [anon_sym___alignof] = ACTIONS(969),
    [anon_sym__alignof] = ACTIONS(969),
    [anon_sym_alignof] = ACTIONS(969),
    [anon_sym__Alignof] = ACTIONS(969),
    [anon_sym_offsetof] = ACTIONS(972),
    [anon_sym__Generic] = ACTIONS(975),
    [anon_sym_asm] = ACTIONS(978),
    [anon_sym___asm__] = ACTIONS(978),
    [sym_number_literal] = ACTIONS(981),
    [anon_sym_L_SQUOTE] = ACTIONS(984),
    [anon_sym_u_SQUOTE] = ACTIONS(984),
    [anon_sym_U_SQUOTE] = ACTIONS(984),
    [anon_sym_u8_SQUOTE] = ACTIONS(984),
    [anon_sym_SQUOTE] = ACTIONS(984),
    [anon_sym_L_DQUOTE] = ACTIONS(987),
    [anon_sym_u_DQUOTE] = ACTIONS(987),
    [anon_sym_U_DQUOTE] = ACTIONS(987),
    [anon_sym_u8_DQUOTE] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [anon_sym_NULL] = ACTIONS(993),
    [anon_sym_nullptr] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(996),
    [anon_sym_rayPayloadInEXT] = ACTIONS(996),
    [anon_sym_hitAttributeEXT] = ACTIONS(996),
    [anon_sym_callableDataEXT] = ACTIONS(996),
    [anon_sym_callableDataInEXT] = ACTIONS(996),
    [anon_sym_shaderRecordEXT] = ACTIONS(996),
    [anon_sym_rayPayloadNV] = ACTIONS(996),
    [anon_sym_rayPayloadInNV] = ACTIONS(996),
    [anon_sym_hitAttributeNV] = ACTIONS(996),
    [anon_sym_callableDataNV] = ACTIONS(996),
    [anon_sym_callableDataInNV] = ACTIONS(996),
    [anon_sym_shaderRecordNV] = ACTIONS(996),
    [anon_sym_layout] = ACTIONS(999),
  },
  [69] = {
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1275),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(552),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_compound_statement] = STATE(68),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_attributed_statement] = STATE(68),
    [sym_labeled_statement] = STATE(68),
    [sym_expression_statement] = STATE(68),
    [sym_if_statement] = STATE(68),
    [sym_switch_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_do_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_return_statement] = STATE(68),
    [sym_break_statement] = STATE(68),
    [sym_continue_statement] = STATE(68),
    [sym_goto_statement] = STATE(68),
    [sym_seh_try_statement] = STATE(68),
    [sym_seh_leave_statement] = STATE(68),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_case_statement_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(31),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(41),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [70] = {
    [sym_declaration] = STATE(663),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1276),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__for_statement_body] = STATE(2358),
    [sym_expression] = STATE(1169),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2360),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(517),
    [sym_layout_specification] = STATE(517),
    [aux_sym_declaration_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(1219),
    [anon_sym_invariant] = ACTIONS(1221),
    [anon_sym_precise] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_out] = ACTIONS(1219),
    [anon_sym_inout] = ACTIONS(1219),
    [anon_sym_uniform] = ACTIONS(1219),
    [anon_sym_shared] = ACTIONS(1219),
    [anon_sym_attribute] = ACTIONS(1219),
    [anon_sym_varying] = ACTIONS(1219),
    [anon_sym_buffer] = ACTIONS(1219),
    [anon_sym_coherent] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_writeonly] = ACTIONS(1219),
    [anon_sym_precision] = ACTIONS(1219),
    [anon_sym_highp] = ACTIONS(1219),
    [anon_sym_mediump] = ACTIONS(1219),
    [anon_sym_lowp] = ACTIONS(1219),
    [anon_sym_centroid] = ACTIONS(1219),
    [anon_sym_sample] = ACTIONS(1219),
    [anon_sym_patch] = ACTIONS(1219),
    [anon_sym_smooth] = ACTIONS(1219),
    [anon_sym_flat] = ACTIONS(1219),
    [anon_sym_noperspective] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [71] = {
    [sym_declaration] = STATE(663),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1276),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__for_statement_body] = STATE(2370),
    [sym_expression] = STATE(1169),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2360),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(517),
    [sym_layout_specification] = STATE(517),
    [aux_sym_declaration_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(1219),
    [anon_sym_invariant] = ACTIONS(1221),
    [anon_sym_precise] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_out] = ACTIONS(1219),
    [anon_sym_inout] = ACTIONS(1219),
    [anon_sym_uniform] = ACTIONS(1219),
    [anon_sym_shared] = ACTIONS(1219),
    [anon_sym_attribute] = ACTIONS(1219),
    [anon_sym_varying] = ACTIONS(1219),
    [anon_sym_buffer] = ACTIONS(1219),
    [anon_sym_coherent] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_writeonly] = ACTIONS(1219),
    [anon_sym_precision] = ACTIONS(1219),
    [anon_sym_highp] = ACTIONS(1219),
    [anon_sym_mediump] = ACTIONS(1219),
    [anon_sym_lowp] = ACTIONS(1219),
    [anon_sym_centroid] = ACTIONS(1219),
    [anon_sym_sample] = ACTIONS(1219),
    [anon_sym_patch] = ACTIONS(1219),
    [anon_sym_smooth] = ACTIONS(1219),
    [anon_sym_flat] = ACTIONS(1219),
    [anon_sym_noperspective] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [72] = {
    [sym_declaration] = STATE(663),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1276),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__for_statement_body] = STATE(2141),
    [sym_expression] = STATE(1169),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2360),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(517),
    [sym_layout_specification] = STATE(517),
    [aux_sym_declaration_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(1219),
    [anon_sym_invariant] = ACTIONS(1221),
    [anon_sym_precise] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_out] = ACTIONS(1219),
    [anon_sym_inout] = ACTIONS(1219),
    [anon_sym_uniform] = ACTIONS(1219),
    [anon_sym_shared] = ACTIONS(1219),
    [anon_sym_attribute] = ACTIONS(1219),
    [anon_sym_varying] = ACTIONS(1219),
    [anon_sym_buffer] = ACTIONS(1219),
    [anon_sym_coherent] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_writeonly] = ACTIONS(1219),
    [anon_sym_precision] = ACTIONS(1219),
    [anon_sym_highp] = ACTIONS(1219),
    [anon_sym_mediump] = ACTIONS(1219),
    [anon_sym_lowp] = ACTIONS(1219),
    [anon_sym_centroid] = ACTIONS(1219),
    [anon_sym_sample] = ACTIONS(1219),
    [anon_sym_patch] = ACTIONS(1219),
    [anon_sym_smooth] = ACTIONS(1219),
    [anon_sym_flat] = ACTIONS(1219),
    [anon_sym_noperspective] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [73] = {
    [sym_declaration] = STATE(663),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1276),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__for_statement_body] = STATE(2216),
    [sym_expression] = STATE(1169),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2360),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(517),
    [sym_layout_specification] = STATE(517),
    [aux_sym_declaration_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(1219),
    [anon_sym_invariant] = ACTIONS(1221),
    [anon_sym_precise] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_out] = ACTIONS(1219),
    [anon_sym_inout] = ACTIONS(1219),
    [anon_sym_uniform] = ACTIONS(1219),
    [anon_sym_shared] = ACTIONS(1219),
    [anon_sym_attribute] = ACTIONS(1219),
    [anon_sym_varying] = ACTIONS(1219),
    [anon_sym_buffer] = ACTIONS(1219),
    [anon_sym_coherent] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_writeonly] = ACTIONS(1219),
    [anon_sym_precision] = ACTIONS(1219),
    [anon_sym_highp] = ACTIONS(1219),
    [anon_sym_mediump] = ACTIONS(1219),
    [anon_sym_lowp] = ACTIONS(1219),
    [anon_sym_centroid] = ACTIONS(1219),
    [anon_sym_sample] = ACTIONS(1219),
    [anon_sym_patch] = ACTIONS(1219),
    [anon_sym_smooth] = ACTIONS(1219),
    [anon_sym_flat] = ACTIONS(1219),
    [anon_sym_noperspective] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [74] = {
    [sym_declaration] = STATE(663),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1276),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__for_statement_body] = STATE(2127),
    [sym_expression] = STATE(1169),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2360),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(517),
    [sym_layout_specification] = STATE(517),
    [aux_sym_declaration_repeat1] = STATE(517),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_subroutine] = ACTIONS(1219),
    [anon_sym_invariant] = ACTIONS(1221),
    [anon_sym_precise] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1219),
    [anon_sym_out] = ACTIONS(1219),
    [anon_sym_inout] = ACTIONS(1219),
    [anon_sym_uniform] = ACTIONS(1219),
    [anon_sym_shared] = ACTIONS(1219),
    [anon_sym_attribute] = ACTIONS(1219),
    [anon_sym_varying] = ACTIONS(1219),
    [anon_sym_buffer] = ACTIONS(1219),
    [anon_sym_coherent] = ACTIONS(1219),
    [anon_sym_readonly] = ACTIONS(1219),
    [anon_sym_writeonly] = ACTIONS(1219),
    [anon_sym_precision] = ACTIONS(1219),
    [anon_sym_highp] = ACTIONS(1219),
    [anon_sym_mediump] = ACTIONS(1219),
    [anon_sym_lowp] = ACTIONS(1219),
    [anon_sym_centroid] = ACTIONS(1219),
    [anon_sym_sample] = ACTIONS(1219),
    [anon_sym_patch] = ACTIONS(1219),
    [anon_sym_smooth] = ACTIONS(1219),
    [anon_sym_flat] = ACTIONS(1219),
    [anon_sym_noperspective] = ACTIONS(1219),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [75] = {
    [sym_else_clause] = STATE(88),
    [sym_identifier] = ACTIONS(1227),
    [aux_sym_preproc_include_token1] = ACTIONS(1227),
    [aux_sym_preproc_def_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token2] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1227),
    [aux_sym_preproc_else_token1] = ACTIONS(1227),
    [aux_sym_preproc_elif_token1] = ACTIONS(1227),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1227),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1227),
    [sym_preproc_directive] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_subroutine] = ACTIONS(1227),
    [anon_sym_invariant] = ACTIONS(1227),
    [anon_sym_precise] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_out] = ACTIONS(1227),
    [anon_sym_inout] = ACTIONS(1227),
    [anon_sym_uniform] = ACTIONS(1227),
    [anon_sym_shared] = ACTIONS(1227),
    [anon_sym_attribute] = ACTIONS(1227),
    [anon_sym_varying] = ACTIONS(1227),
    [anon_sym_buffer] = ACTIONS(1227),
    [anon_sym_coherent] = ACTIONS(1227),
    [anon_sym_readonly] = ACTIONS(1227),
    [anon_sym_writeonly] = ACTIONS(1227),
    [anon_sym_precision] = ACTIONS(1227),
    [anon_sym_highp] = ACTIONS(1227),
    [anon_sym_mediump] = ACTIONS(1227),
    [anon_sym_lowp] = ACTIONS(1227),
    [anon_sym_centroid] = ACTIONS(1227),
    [anon_sym_sample] = ACTIONS(1227),
    [anon_sym_patch] = ACTIONS(1227),
    [anon_sym_smooth] = ACTIONS(1227),
    [anon_sym_flat] = ACTIONS(1227),
    [anon_sym_noperspective] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym___attribute__] = ACTIONS(1227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1229),
    [anon_sym___declspec] = ACTIONS(1227),
    [anon_sym___cdecl] = ACTIONS(1227),
    [anon_sym___clrcall] = ACTIONS(1227),
    [anon_sym___stdcall] = ACTIONS(1227),
    [anon_sym___fastcall] = ACTIONS(1227),
    [anon_sym___thiscall] = ACTIONS(1227),
    [anon_sym___vectorcall] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_signed] = ACTIONS(1227),
    [anon_sym_unsigned] = ACTIONS(1227),
    [anon_sym_long] = ACTIONS(1227),
    [anon_sym_short] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_auto] = ACTIONS(1227),
    [anon_sym_register] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym___inline] = ACTIONS(1227),
    [anon_sym___inline__] = ACTIONS(1227),
    [anon_sym___forceinline] = ACTIONS(1227),
    [anon_sym_thread_local] = ACTIONS(1227),
    [anon_sym___thread] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_constexpr] = ACTIONS(1227),
    [anon_sym_volatile] = ACTIONS(1227),
    [anon_sym_restrict] = ACTIONS(1227),
    [anon_sym___restrict__] = ACTIONS(1227),
    [anon_sym__Atomic] = ACTIONS(1227),
    [anon_sym__Noreturn] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_alignas] = ACTIONS(1227),
    [anon_sym__Alignas] = ACTIONS(1227),
    [sym_primitive_type] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_goto] = ACTIONS(1227),
    [anon_sym___try] = ACTIONS(1227),
    [anon_sym___leave] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_sizeof] = ACTIONS(1227),
    [anon_sym___alignof__] = ACTIONS(1227),
    [anon_sym___alignof] = ACTIONS(1227),
    [anon_sym__alignof] = ACTIONS(1227),
    [anon_sym_alignof] = ACTIONS(1227),
    [anon_sym__Alignof] = ACTIONS(1227),
    [anon_sym_offsetof] = ACTIONS(1227),
    [anon_sym__Generic] = ACTIONS(1227),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym___asm__] = ACTIONS(1227),
    [sym_number_literal] = ACTIONS(1229),
    [anon_sym_L_SQUOTE] = ACTIONS(1229),
    [anon_sym_u_SQUOTE] = ACTIONS(1229),
    [anon_sym_U_SQUOTE] = ACTIONS(1229),
    [anon_sym_u8_SQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_L_DQUOTE] = ACTIONS(1229),
    [anon_sym_u_DQUOTE] = ACTIONS(1229),
    [anon_sym_U_DQUOTE] = ACTIONS(1229),
    [anon_sym_u8_DQUOTE] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [anon_sym_NULL] = ACTIONS(1227),
    [anon_sym_nullptr] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1227),
    [anon_sym_hitAttributeEXT] = ACTIONS(1227),
    [anon_sym_callableDataEXT] = ACTIONS(1227),
    [anon_sym_callableDataInEXT] = ACTIONS(1227),
    [anon_sym_shaderRecordEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadNV] = ACTIONS(1227),
    [anon_sym_rayPayloadInNV] = ACTIONS(1227),
    [anon_sym_hitAttributeNV] = ACTIONS(1227),
    [anon_sym_callableDataNV] = ACTIONS(1227),
    [anon_sym_callableDataInNV] = ACTIONS(1227),
    [anon_sym_shaderRecordNV] = ACTIONS(1227),
    [anon_sym_layout] = ACTIONS(1227),
  },
  [76] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token2] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [aux_sym_preproc_else_token1] = ACTIONS(1233),
    [aux_sym_preproc_elif_token1] = ACTIONS(1233),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_subroutine] = ACTIONS(1233),
    [anon_sym_invariant] = ACTIONS(1233),
    [anon_sym_precise] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1233),
    [anon_sym_out] = ACTIONS(1233),
    [anon_sym_inout] = ACTIONS(1233),
    [anon_sym_uniform] = ACTIONS(1233),
    [anon_sym_shared] = ACTIONS(1233),
    [anon_sym_attribute] = ACTIONS(1233),
    [anon_sym_varying] = ACTIONS(1233),
    [anon_sym_buffer] = ACTIONS(1233),
    [anon_sym_coherent] = ACTIONS(1233),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_writeonly] = ACTIONS(1233),
    [anon_sym_precision] = ACTIONS(1233),
    [anon_sym_highp] = ACTIONS(1233),
    [anon_sym_mediump] = ACTIONS(1233),
    [anon_sym_lowp] = ACTIONS(1233),
    [anon_sym_centroid] = ACTIONS(1233),
    [anon_sym_sample] = ACTIONS(1233),
    [anon_sym_patch] = ACTIONS(1233),
    [anon_sym_smooth] = ACTIONS(1233),
    [anon_sym_flat] = ACTIONS(1233),
    [anon_sym_noperspective] = ACTIONS(1233),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1233),
    [anon_sym_hitAttributeEXT] = ACTIONS(1233),
    [anon_sym_callableDataEXT] = ACTIONS(1233),
    [anon_sym_callableDataInEXT] = ACTIONS(1233),
    [anon_sym_shaderRecordEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadNV] = ACTIONS(1233),
    [anon_sym_rayPayloadInNV] = ACTIONS(1233),
    [anon_sym_hitAttributeNV] = ACTIONS(1233),
    [anon_sym_callableDataNV] = ACTIONS(1233),
    [anon_sym_callableDataInNV] = ACTIONS(1233),
    [anon_sym_shaderRecordNV] = ACTIONS(1233),
    [anon_sym_layout] = ACTIONS(1233),
  },
  [77] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [aux_sym_preproc_else_token1] = ACTIONS(1237),
    [aux_sym_preproc_elif_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_subroutine] = ACTIONS(1237),
    [anon_sym_invariant] = ACTIONS(1237),
    [anon_sym_precise] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_out] = ACTIONS(1237),
    [anon_sym_inout] = ACTIONS(1237),
    [anon_sym_uniform] = ACTIONS(1237),
    [anon_sym_shared] = ACTIONS(1237),
    [anon_sym_attribute] = ACTIONS(1237),
    [anon_sym_varying] = ACTIONS(1237),
    [anon_sym_buffer] = ACTIONS(1237),
    [anon_sym_coherent] = ACTIONS(1237),
    [anon_sym_readonly] = ACTIONS(1237),
    [anon_sym_writeonly] = ACTIONS(1237),
    [anon_sym_precision] = ACTIONS(1237),
    [anon_sym_highp] = ACTIONS(1237),
    [anon_sym_mediump] = ACTIONS(1237),
    [anon_sym_lowp] = ACTIONS(1237),
    [anon_sym_centroid] = ACTIONS(1237),
    [anon_sym_sample] = ACTIONS(1237),
    [anon_sym_patch] = ACTIONS(1237),
    [anon_sym_smooth] = ACTIONS(1237),
    [anon_sym_flat] = ACTIONS(1237),
    [anon_sym_noperspective] = ACTIONS(1237),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1237),
    [anon_sym_hitAttributeEXT] = ACTIONS(1237),
    [anon_sym_callableDataEXT] = ACTIONS(1237),
    [anon_sym_callableDataInEXT] = ACTIONS(1237),
    [anon_sym_shaderRecordEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadNV] = ACTIONS(1237),
    [anon_sym_rayPayloadInNV] = ACTIONS(1237),
    [anon_sym_hitAttributeNV] = ACTIONS(1237),
    [anon_sym_callableDataNV] = ACTIONS(1237),
    [anon_sym_callableDataInNV] = ACTIONS(1237),
    [anon_sym_shaderRecordNV] = ACTIONS(1237),
    [anon_sym_layout] = ACTIONS(1237),
  },
  [78] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [aux_sym_preproc_else_token1] = ACTIONS(1241),
    [aux_sym_preproc_elif_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [79] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [aux_sym_preproc_else_token1] = ACTIONS(1241),
    [aux_sym_preproc_elif_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [80] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [aux_sym_preproc_else_token1] = ACTIONS(1245),
    [aux_sym_preproc_elif_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [81] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [aux_sym_preproc_else_token1] = ACTIONS(1245),
    [aux_sym_preproc_elif_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [82] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token2] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [aux_sym_preproc_else_token1] = ACTIONS(1249),
    [aux_sym_preproc_elif_token1] = ACTIONS(1249),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_subroutine] = ACTIONS(1249),
    [anon_sym_invariant] = ACTIONS(1249),
    [anon_sym_precise] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_out] = ACTIONS(1249),
    [anon_sym_inout] = ACTIONS(1249),
    [anon_sym_uniform] = ACTIONS(1249),
    [anon_sym_shared] = ACTIONS(1249),
    [anon_sym_attribute] = ACTIONS(1249),
    [anon_sym_varying] = ACTIONS(1249),
    [anon_sym_buffer] = ACTIONS(1249),
    [anon_sym_coherent] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_writeonly] = ACTIONS(1249),
    [anon_sym_precision] = ACTIONS(1249),
    [anon_sym_highp] = ACTIONS(1249),
    [anon_sym_mediump] = ACTIONS(1249),
    [anon_sym_lowp] = ACTIONS(1249),
    [anon_sym_centroid] = ACTIONS(1249),
    [anon_sym_sample] = ACTIONS(1249),
    [anon_sym_patch] = ACTIONS(1249),
    [anon_sym_smooth] = ACTIONS(1249),
    [anon_sym_flat] = ACTIONS(1249),
    [anon_sym_noperspective] = ACTIONS(1249),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1249),
    [anon_sym_hitAttributeEXT] = ACTIONS(1249),
    [anon_sym_callableDataEXT] = ACTIONS(1249),
    [anon_sym_callableDataInEXT] = ACTIONS(1249),
    [anon_sym_shaderRecordEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadNV] = ACTIONS(1249),
    [anon_sym_rayPayloadInNV] = ACTIONS(1249),
    [anon_sym_hitAttributeNV] = ACTIONS(1249),
    [anon_sym_callableDataNV] = ACTIONS(1249),
    [anon_sym_callableDataInNV] = ACTIONS(1249),
    [anon_sym_shaderRecordNV] = ACTIONS(1249),
    [anon_sym_layout] = ACTIONS(1249),
  },
  [83] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token2] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [aux_sym_preproc_else_token1] = ACTIONS(1253),
    [aux_sym_preproc_elif_token1] = ACTIONS(1253),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_subroutine] = ACTIONS(1253),
    [anon_sym_invariant] = ACTIONS(1253),
    [anon_sym_precise] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_out] = ACTIONS(1253),
    [anon_sym_inout] = ACTIONS(1253),
    [anon_sym_uniform] = ACTIONS(1253),
    [anon_sym_shared] = ACTIONS(1253),
    [anon_sym_attribute] = ACTIONS(1253),
    [anon_sym_varying] = ACTIONS(1253),
    [anon_sym_buffer] = ACTIONS(1253),
    [anon_sym_coherent] = ACTIONS(1253),
    [anon_sym_readonly] = ACTIONS(1253),
    [anon_sym_writeonly] = ACTIONS(1253),
    [anon_sym_precision] = ACTIONS(1253),
    [anon_sym_highp] = ACTIONS(1253),
    [anon_sym_mediump] = ACTIONS(1253),
    [anon_sym_lowp] = ACTIONS(1253),
    [anon_sym_centroid] = ACTIONS(1253),
    [anon_sym_sample] = ACTIONS(1253),
    [anon_sym_patch] = ACTIONS(1253),
    [anon_sym_smooth] = ACTIONS(1253),
    [anon_sym_flat] = ACTIONS(1253),
    [anon_sym_noperspective] = ACTIONS(1253),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1253),
    [anon_sym_hitAttributeEXT] = ACTIONS(1253),
    [anon_sym_callableDataEXT] = ACTIONS(1253),
    [anon_sym_callableDataInEXT] = ACTIONS(1253),
    [anon_sym_shaderRecordEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadNV] = ACTIONS(1253),
    [anon_sym_rayPayloadInNV] = ACTIONS(1253),
    [anon_sym_hitAttributeNV] = ACTIONS(1253),
    [anon_sym_callableDataNV] = ACTIONS(1253),
    [anon_sym_callableDataInNV] = ACTIONS(1253),
    [anon_sym_shaderRecordNV] = ACTIONS(1253),
    [anon_sym_layout] = ACTIONS(1253),
  },
  [84] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [aux_sym_preproc_else_token1] = ACTIONS(1257),
    [aux_sym_preproc_elif_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [85] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [aux_sym_preproc_else_token1] = ACTIONS(1261),
    [aux_sym_preproc_elif_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_subroutine] = ACTIONS(1261),
    [anon_sym_invariant] = ACTIONS(1261),
    [anon_sym_precise] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_out] = ACTIONS(1261),
    [anon_sym_inout] = ACTIONS(1261),
    [anon_sym_uniform] = ACTIONS(1261),
    [anon_sym_shared] = ACTIONS(1261),
    [anon_sym_attribute] = ACTIONS(1261),
    [anon_sym_varying] = ACTIONS(1261),
    [anon_sym_buffer] = ACTIONS(1261),
    [anon_sym_coherent] = ACTIONS(1261),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_writeonly] = ACTIONS(1261),
    [anon_sym_precision] = ACTIONS(1261),
    [anon_sym_highp] = ACTIONS(1261),
    [anon_sym_mediump] = ACTIONS(1261),
    [anon_sym_lowp] = ACTIONS(1261),
    [anon_sym_centroid] = ACTIONS(1261),
    [anon_sym_sample] = ACTIONS(1261),
    [anon_sym_patch] = ACTIONS(1261),
    [anon_sym_smooth] = ACTIONS(1261),
    [anon_sym_flat] = ACTIONS(1261),
    [anon_sym_noperspective] = ACTIONS(1261),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1261),
    [anon_sym_hitAttributeEXT] = ACTIONS(1261),
    [anon_sym_callableDataEXT] = ACTIONS(1261),
    [anon_sym_callableDataInEXT] = ACTIONS(1261),
    [anon_sym_shaderRecordEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadNV] = ACTIONS(1261),
    [anon_sym_rayPayloadInNV] = ACTIONS(1261),
    [anon_sym_hitAttributeNV] = ACTIONS(1261),
    [anon_sym_callableDataNV] = ACTIONS(1261),
    [anon_sym_callableDataInNV] = ACTIONS(1261),
    [anon_sym_shaderRecordNV] = ACTIONS(1261),
    [anon_sym_layout] = ACTIONS(1261),
  },
  [86] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [aux_sym_preproc_else_token1] = ACTIONS(1257),
    [aux_sym_preproc_elif_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [87] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token2] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [aux_sym_preproc_else_token1] = ACTIONS(1265),
    [aux_sym_preproc_elif_token1] = ACTIONS(1265),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_subroutine] = ACTIONS(1265),
    [anon_sym_invariant] = ACTIONS(1265),
    [anon_sym_precise] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_out] = ACTIONS(1265),
    [anon_sym_inout] = ACTIONS(1265),
    [anon_sym_uniform] = ACTIONS(1265),
    [anon_sym_shared] = ACTIONS(1265),
    [anon_sym_attribute] = ACTIONS(1265),
    [anon_sym_varying] = ACTIONS(1265),
    [anon_sym_buffer] = ACTIONS(1265),
    [anon_sym_coherent] = ACTIONS(1265),
    [anon_sym_readonly] = ACTIONS(1265),
    [anon_sym_writeonly] = ACTIONS(1265),
    [anon_sym_precision] = ACTIONS(1265),
    [anon_sym_highp] = ACTIONS(1265),
    [anon_sym_mediump] = ACTIONS(1265),
    [anon_sym_lowp] = ACTIONS(1265),
    [anon_sym_centroid] = ACTIONS(1265),
    [anon_sym_sample] = ACTIONS(1265),
    [anon_sym_patch] = ACTIONS(1265),
    [anon_sym_smooth] = ACTIONS(1265),
    [anon_sym_flat] = ACTIONS(1265),
    [anon_sym_noperspective] = ACTIONS(1265),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1265),
    [anon_sym_hitAttributeEXT] = ACTIONS(1265),
    [anon_sym_callableDataEXT] = ACTIONS(1265),
    [anon_sym_callableDataInEXT] = ACTIONS(1265),
    [anon_sym_shaderRecordEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadNV] = ACTIONS(1265),
    [anon_sym_rayPayloadInNV] = ACTIONS(1265),
    [anon_sym_hitAttributeNV] = ACTIONS(1265),
    [anon_sym_callableDataNV] = ACTIONS(1265),
    [anon_sym_callableDataInNV] = ACTIONS(1265),
    [anon_sym_shaderRecordNV] = ACTIONS(1265),
    [anon_sym_layout] = ACTIONS(1265),
  },
  [88] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token2] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [aux_sym_preproc_else_token1] = ACTIONS(1269),
    [aux_sym_preproc_elif_token1] = ACTIONS(1269),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_subroutine] = ACTIONS(1269),
    [anon_sym_invariant] = ACTIONS(1269),
    [anon_sym_precise] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_out] = ACTIONS(1269),
    [anon_sym_inout] = ACTIONS(1269),
    [anon_sym_uniform] = ACTIONS(1269),
    [anon_sym_shared] = ACTIONS(1269),
    [anon_sym_attribute] = ACTIONS(1269),
    [anon_sym_varying] = ACTIONS(1269),
    [anon_sym_buffer] = ACTIONS(1269),
    [anon_sym_coherent] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_writeonly] = ACTIONS(1269),
    [anon_sym_precision] = ACTIONS(1269),
    [anon_sym_highp] = ACTIONS(1269),
    [anon_sym_mediump] = ACTIONS(1269),
    [anon_sym_lowp] = ACTIONS(1269),
    [anon_sym_centroid] = ACTIONS(1269),
    [anon_sym_sample] = ACTIONS(1269),
    [anon_sym_patch] = ACTIONS(1269),
    [anon_sym_smooth] = ACTIONS(1269),
    [anon_sym_flat] = ACTIONS(1269),
    [anon_sym_noperspective] = ACTIONS(1269),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1269),
    [anon_sym_hitAttributeEXT] = ACTIONS(1269),
    [anon_sym_callableDataEXT] = ACTIONS(1269),
    [anon_sym_callableDataInEXT] = ACTIONS(1269),
    [anon_sym_shaderRecordEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadNV] = ACTIONS(1269),
    [anon_sym_rayPayloadInNV] = ACTIONS(1269),
    [anon_sym_hitAttributeNV] = ACTIONS(1269),
    [anon_sym_callableDataNV] = ACTIONS(1269),
    [anon_sym_callableDataInNV] = ACTIONS(1269),
    [anon_sym_shaderRecordNV] = ACTIONS(1269),
    [anon_sym_layout] = ACTIONS(1269),
  },
  [89] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [aux_sym_preproc_else_token1] = ACTIONS(1273),
    [aux_sym_preproc_elif_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [90] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [aux_sym_preproc_else_token1] = ACTIONS(1273),
    [aux_sym_preproc_elif_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [91] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [aux_sym_preproc_else_token1] = ACTIONS(1277),
    [aux_sym_preproc_elif_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [92] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [aux_sym_preproc_else_token1] = ACTIONS(1277),
    [aux_sym_preproc_elif_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [93] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token2] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [aux_sym_preproc_else_token1] = ACTIONS(1281),
    [aux_sym_preproc_elif_token1] = ACTIONS(1281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_subroutine] = ACTIONS(1281),
    [anon_sym_invariant] = ACTIONS(1281),
    [anon_sym_precise] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1281),
    [anon_sym_out] = ACTIONS(1281),
    [anon_sym_inout] = ACTIONS(1281),
    [anon_sym_uniform] = ACTIONS(1281),
    [anon_sym_shared] = ACTIONS(1281),
    [anon_sym_attribute] = ACTIONS(1281),
    [anon_sym_varying] = ACTIONS(1281),
    [anon_sym_buffer] = ACTIONS(1281),
    [anon_sym_coherent] = ACTIONS(1281),
    [anon_sym_readonly] = ACTIONS(1281),
    [anon_sym_writeonly] = ACTIONS(1281),
    [anon_sym_precision] = ACTIONS(1281),
    [anon_sym_highp] = ACTIONS(1281),
    [anon_sym_mediump] = ACTIONS(1281),
    [anon_sym_lowp] = ACTIONS(1281),
    [anon_sym_centroid] = ACTIONS(1281),
    [anon_sym_sample] = ACTIONS(1281),
    [anon_sym_patch] = ACTIONS(1281),
    [anon_sym_smooth] = ACTIONS(1281),
    [anon_sym_flat] = ACTIONS(1281),
    [anon_sym_noperspective] = ACTIONS(1281),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_else] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1281),
    [anon_sym_hitAttributeEXT] = ACTIONS(1281),
    [anon_sym_callableDataEXT] = ACTIONS(1281),
    [anon_sym_callableDataInEXT] = ACTIONS(1281),
    [anon_sym_shaderRecordEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadNV] = ACTIONS(1281),
    [anon_sym_rayPayloadInNV] = ACTIONS(1281),
    [anon_sym_hitAttributeNV] = ACTIONS(1281),
    [anon_sym_callableDataNV] = ACTIONS(1281),
    [anon_sym_callableDataInNV] = ACTIONS(1281),
    [anon_sym_shaderRecordNV] = ACTIONS(1281),
    [anon_sym_layout] = ACTIONS(1281),
  },
  [94] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token2] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [aux_sym_preproc_else_token1] = ACTIONS(1285),
    [aux_sym_preproc_elif_token1] = ACTIONS(1285),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_subroutine] = ACTIONS(1285),
    [anon_sym_invariant] = ACTIONS(1285),
    [anon_sym_precise] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_out] = ACTIONS(1285),
    [anon_sym_inout] = ACTIONS(1285),
    [anon_sym_uniform] = ACTIONS(1285),
    [anon_sym_shared] = ACTIONS(1285),
    [anon_sym_attribute] = ACTIONS(1285),
    [anon_sym_varying] = ACTIONS(1285),
    [anon_sym_buffer] = ACTIONS(1285),
    [anon_sym_coherent] = ACTIONS(1285),
    [anon_sym_readonly] = ACTIONS(1285),
    [anon_sym_writeonly] = ACTIONS(1285),
    [anon_sym_precision] = ACTIONS(1285),
    [anon_sym_highp] = ACTIONS(1285),
    [anon_sym_mediump] = ACTIONS(1285),
    [anon_sym_lowp] = ACTIONS(1285),
    [anon_sym_centroid] = ACTIONS(1285),
    [anon_sym_sample] = ACTIONS(1285),
    [anon_sym_patch] = ACTIONS(1285),
    [anon_sym_smooth] = ACTIONS(1285),
    [anon_sym_flat] = ACTIONS(1285),
    [anon_sym_noperspective] = ACTIONS(1285),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1285),
    [anon_sym_hitAttributeEXT] = ACTIONS(1285),
    [anon_sym_callableDataEXT] = ACTIONS(1285),
    [anon_sym_callableDataInEXT] = ACTIONS(1285),
    [anon_sym_shaderRecordEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadNV] = ACTIONS(1285),
    [anon_sym_rayPayloadInNV] = ACTIONS(1285),
    [anon_sym_hitAttributeNV] = ACTIONS(1285),
    [anon_sym_callableDataNV] = ACTIONS(1285),
    [anon_sym_callableDataInNV] = ACTIONS(1285),
    [anon_sym_shaderRecordNV] = ACTIONS(1285),
    [anon_sym_layout] = ACTIONS(1285),
  },
  [95] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token2] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [aux_sym_preproc_else_token1] = ACTIONS(1289),
    [aux_sym_preproc_elif_token1] = ACTIONS(1289),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_subroutine] = ACTIONS(1289),
    [anon_sym_invariant] = ACTIONS(1289),
    [anon_sym_precise] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1289),
    [anon_sym_out] = ACTIONS(1289),
    [anon_sym_inout] = ACTIONS(1289),
    [anon_sym_uniform] = ACTIONS(1289),
    [anon_sym_shared] = ACTIONS(1289),
    [anon_sym_attribute] = ACTIONS(1289),
    [anon_sym_varying] = ACTIONS(1289),
    [anon_sym_buffer] = ACTIONS(1289),
    [anon_sym_coherent] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_writeonly] = ACTIONS(1289),
    [anon_sym_precision] = ACTIONS(1289),
    [anon_sym_highp] = ACTIONS(1289),
    [anon_sym_mediump] = ACTIONS(1289),
    [anon_sym_lowp] = ACTIONS(1289),
    [anon_sym_centroid] = ACTIONS(1289),
    [anon_sym_sample] = ACTIONS(1289),
    [anon_sym_patch] = ACTIONS(1289),
    [anon_sym_smooth] = ACTIONS(1289),
    [anon_sym_flat] = ACTIONS(1289),
    [anon_sym_noperspective] = ACTIONS(1289),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_else] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1289),
    [anon_sym_hitAttributeEXT] = ACTIONS(1289),
    [anon_sym_callableDataEXT] = ACTIONS(1289),
    [anon_sym_callableDataInEXT] = ACTIONS(1289),
    [anon_sym_shaderRecordEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadNV] = ACTIONS(1289),
    [anon_sym_rayPayloadInNV] = ACTIONS(1289),
    [anon_sym_hitAttributeNV] = ACTIONS(1289),
    [anon_sym_callableDataNV] = ACTIONS(1289),
    [anon_sym_callableDataInNV] = ACTIONS(1289),
    [anon_sym_shaderRecordNV] = ACTIONS(1289),
    [anon_sym_layout] = ACTIONS(1289),
  },
  [96] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [aux_sym_preproc_else_token1] = ACTIONS(1293),
    [aux_sym_preproc_elif_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [97] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token2] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [aux_sym_preproc_else_token1] = ACTIONS(1297),
    [aux_sym_preproc_elif_token1] = ACTIONS(1297),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_subroutine] = ACTIONS(1297),
    [anon_sym_invariant] = ACTIONS(1297),
    [anon_sym_precise] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_in] = ACTIONS(1297),
    [anon_sym_out] = ACTIONS(1297),
    [anon_sym_inout] = ACTIONS(1297),
    [anon_sym_uniform] = ACTIONS(1297),
    [anon_sym_shared] = ACTIONS(1297),
    [anon_sym_attribute] = ACTIONS(1297),
    [anon_sym_varying] = ACTIONS(1297),
    [anon_sym_buffer] = ACTIONS(1297),
    [anon_sym_coherent] = ACTIONS(1297),
    [anon_sym_readonly] = ACTIONS(1297),
    [anon_sym_writeonly] = ACTIONS(1297),
    [anon_sym_precision] = ACTIONS(1297),
    [anon_sym_highp] = ACTIONS(1297),
    [anon_sym_mediump] = ACTIONS(1297),
    [anon_sym_lowp] = ACTIONS(1297),
    [anon_sym_centroid] = ACTIONS(1297),
    [anon_sym_sample] = ACTIONS(1297),
    [anon_sym_patch] = ACTIONS(1297),
    [anon_sym_smooth] = ACTIONS(1297),
    [anon_sym_flat] = ACTIONS(1297),
    [anon_sym_noperspective] = ACTIONS(1297),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_else] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1297),
    [anon_sym_hitAttributeEXT] = ACTIONS(1297),
    [anon_sym_callableDataEXT] = ACTIONS(1297),
    [anon_sym_callableDataInEXT] = ACTIONS(1297),
    [anon_sym_shaderRecordEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadNV] = ACTIONS(1297),
    [anon_sym_rayPayloadInNV] = ACTIONS(1297),
    [anon_sym_hitAttributeNV] = ACTIONS(1297),
    [anon_sym_callableDataNV] = ACTIONS(1297),
    [anon_sym_callableDataInNV] = ACTIONS(1297),
    [anon_sym_shaderRecordNV] = ACTIONS(1297),
    [anon_sym_layout] = ACTIONS(1297),
  },
  [98] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [aux_sym_preproc_else_token1] = ACTIONS(1293),
    [aux_sym_preproc_elif_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [99] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token2] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [aux_sym_preproc_else_token1] = ACTIONS(1301),
    [aux_sym_preproc_elif_token1] = ACTIONS(1301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_subroutine] = ACTIONS(1301),
    [anon_sym_invariant] = ACTIONS(1301),
    [anon_sym_precise] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_out] = ACTIONS(1301),
    [anon_sym_inout] = ACTIONS(1301),
    [anon_sym_uniform] = ACTIONS(1301),
    [anon_sym_shared] = ACTIONS(1301),
    [anon_sym_attribute] = ACTIONS(1301),
    [anon_sym_varying] = ACTIONS(1301),
    [anon_sym_buffer] = ACTIONS(1301),
    [anon_sym_coherent] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_writeonly] = ACTIONS(1301),
    [anon_sym_precision] = ACTIONS(1301),
    [anon_sym_highp] = ACTIONS(1301),
    [anon_sym_mediump] = ACTIONS(1301),
    [anon_sym_lowp] = ACTIONS(1301),
    [anon_sym_centroid] = ACTIONS(1301),
    [anon_sym_sample] = ACTIONS(1301),
    [anon_sym_patch] = ACTIONS(1301),
    [anon_sym_smooth] = ACTIONS(1301),
    [anon_sym_flat] = ACTIONS(1301),
    [anon_sym_noperspective] = ACTIONS(1301),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1301),
    [anon_sym_hitAttributeEXT] = ACTIONS(1301),
    [anon_sym_callableDataEXT] = ACTIONS(1301),
    [anon_sym_callableDataInEXT] = ACTIONS(1301),
    [anon_sym_shaderRecordEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadNV] = ACTIONS(1301),
    [anon_sym_rayPayloadInNV] = ACTIONS(1301),
    [anon_sym_hitAttributeNV] = ACTIONS(1301),
    [anon_sym_callableDataNV] = ACTIONS(1301),
    [anon_sym_callableDataInNV] = ACTIONS(1301),
    [anon_sym_shaderRecordNV] = ACTIONS(1301),
    [anon_sym_layout] = ACTIONS(1301),
  },
  [100] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token2] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [aux_sym_preproc_else_token1] = ACTIONS(1305),
    [aux_sym_preproc_elif_token1] = ACTIONS(1305),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_subroutine] = ACTIONS(1305),
    [anon_sym_invariant] = ACTIONS(1305),
    [anon_sym_precise] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_in] = ACTIONS(1305),
    [anon_sym_out] = ACTIONS(1305),
    [anon_sym_inout] = ACTIONS(1305),
    [anon_sym_uniform] = ACTIONS(1305),
    [anon_sym_shared] = ACTIONS(1305),
    [anon_sym_attribute] = ACTIONS(1305),
    [anon_sym_varying] = ACTIONS(1305),
    [anon_sym_buffer] = ACTIONS(1305),
    [anon_sym_coherent] = ACTIONS(1305),
    [anon_sym_readonly] = ACTIONS(1305),
    [anon_sym_writeonly] = ACTIONS(1305),
    [anon_sym_precision] = ACTIONS(1305),
    [anon_sym_highp] = ACTIONS(1305),
    [anon_sym_mediump] = ACTIONS(1305),
    [anon_sym_lowp] = ACTIONS(1305),
    [anon_sym_centroid] = ACTIONS(1305),
    [anon_sym_sample] = ACTIONS(1305),
    [anon_sym_patch] = ACTIONS(1305),
    [anon_sym_smooth] = ACTIONS(1305),
    [anon_sym_flat] = ACTIONS(1305),
    [anon_sym_noperspective] = ACTIONS(1305),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1305),
    [anon_sym_hitAttributeEXT] = ACTIONS(1305),
    [anon_sym_callableDataEXT] = ACTIONS(1305),
    [anon_sym_callableDataInEXT] = ACTIONS(1305),
    [anon_sym_shaderRecordEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadNV] = ACTIONS(1305),
    [anon_sym_rayPayloadInNV] = ACTIONS(1305),
    [anon_sym_hitAttributeNV] = ACTIONS(1305),
    [anon_sym_callableDataNV] = ACTIONS(1305),
    [anon_sym_callableDataInNV] = ACTIONS(1305),
    [anon_sym_shaderRecordNV] = ACTIONS(1305),
    [anon_sym_layout] = ACTIONS(1305),
  },
  [101] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token2] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [aux_sym_preproc_else_token1] = ACTIONS(1309),
    [aux_sym_preproc_elif_token1] = ACTIONS(1309),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_subroutine] = ACTIONS(1309),
    [anon_sym_invariant] = ACTIONS(1309),
    [anon_sym_precise] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1309),
    [anon_sym_out] = ACTIONS(1309),
    [anon_sym_inout] = ACTIONS(1309),
    [anon_sym_uniform] = ACTIONS(1309),
    [anon_sym_shared] = ACTIONS(1309),
    [anon_sym_attribute] = ACTIONS(1309),
    [anon_sym_varying] = ACTIONS(1309),
    [anon_sym_buffer] = ACTIONS(1309),
    [anon_sym_coherent] = ACTIONS(1309),
    [anon_sym_readonly] = ACTIONS(1309),
    [anon_sym_writeonly] = ACTIONS(1309),
    [anon_sym_precision] = ACTIONS(1309),
    [anon_sym_highp] = ACTIONS(1309),
    [anon_sym_mediump] = ACTIONS(1309),
    [anon_sym_lowp] = ACTIONS(1309),
    [anon_sym_centroid] = ACTIONS(1309),
    [anon_sym_sample] = ACTIONS(1309),
    [anon_sym_patch] = ACTIONS(1309),
    [anon_sym_smooth] = ACTIONS(1309),
    [anon_sym_flat] = ACTIONS(1309),
    [anon_sym_noperspective] = ACTIONS(1309),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_else] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1309),
    [anon_sym_hitAttributeEXT] = ACTIONS(1309),
    [anon_sym_callableDataEXT] = ACTIONS(1309),
    [anon_sym_callableDataInEXT] = ACTIONS(1309),
    [anon_sym_shaderRecordEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadNV] = ACTIONS(1309),
    [anon_sym_rayPayloadInNV] = ACTIONS(1309),
    [anon_sym_hitAttributeNV] = ACTIONS(1309),
    [anon_sym_callableDataNV] = ACTIONS(1309),
    [anon_sym_callableDataInNV] = ACTIONS(1309),
    [anon_sym_shaderRecordNV] = ACTIONS(1309),
    [anon_sym_layout] = ACTIONS(1309),
  },
  [102] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token2] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [aux_sym_preproc_else_token1] = ACTIONS(1313),
    [aux_sym_preproc_elif_token1] = ACTIONS(1313),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_subroutine] = ACTIONS(1313),
    [anon_sym_invariant] = ACTIONS(1313),
    [anon_sym_precise] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_out] = ACTIONS(1313),
    [anon_sym_inout] = ACTIONS(1313),
    [anon_sym_uniform] = ACTIONS(1313),
    [anon_sym_shared] = ACTIONS(1313),
    [anon_sym_attribute] = ACTIONS(1313),
    [anon_sym_varying] = ACTIONS(1313),
    [anon_sym_buffer] = ACTIONS(1313),
    [anon_sym_coherent] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1313),
    [anon_sym_writeonly] = ACTIONS(1313),
    [anon_sym_precision] = ACTIONS(1313),
    [anon_sym_highp] = ACTIONS(1313),
    [anon_sym_mediump] = ACTIONS(1313),
    [anon_sym_lowp] = ACTIONS(1313),
    [anon_sym_centroid] = ACTIONS(1313),
    [anon_sym_sample] = ACTIONS(1313),
    [anon_sym_patch] = ACTIONS(1313),
    [anon_sym_smooth] = ACTIONS(1313),
    [anon_sym_flat] = ACTIONS(1313),
    [anon_sym_noperspective] = ACTIONS(1313),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1313),
    [anon_sym_hitAttributeEXT] = ACTIONS(1313),
    [anon_sym_callableDataEXT] = ACTIONS(1313),
    [anon_sym_callableDataInEXT] = ACTIONS(1313),
    [anon_sym_shaderRecordEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadNV] = ACTIONS(1313),
    [anon_sym_rayPayloadInNV] = ACTIONS(1313),
    [anon_sym_hitAttributeNV] = ACTIONS(1313),
    [anon_sym_callableDataNV] = ACTIONS(1313),
    [anon_sym_callableDataInNV] = ACTIONS(1313),
    [anon_sym_shaderRecordNV] = ACTIONS(1313),
    [anon_sym_layout] = ACTIONS(1313),
  },
  [103] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [aux_sym_preproc_else_token1] = ACTIONS(1317),
    [aux_sym_preproc_elif_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [104] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token2] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [aux_sym_preproc_else_token1] = ACTIONS(1321),
    [aux_sym_preproc_elif_token1] = ACTIONS(1321),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_subroutine] = ACTIONS(1321),
    [anon_sym_invariant] = ACTIONS(1321),
    [anon_sym_precise] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_in] = ACTIONS(1321),
    [anon_sym_out] = ACTIONS(1321),
    [anon_sym_inout] = ACTIONS(1321),
    [anon_sym_uniform] = ACTIONS(1321),
    [anon_sym_shared] = ACTIONS(1321),
    [anon_sym_attribute] = ACTIONS(1321),
    [anon_sym_varying] = ACTIONS(1321),
    [anon_sym_buffer] = ACTIONS(1321),
    [anon_sym_coherent] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_writeonly] = ACTIONS(1321),
    [anon_sym_precision] = ACTIONS(1321),
    [anon_sym_highp] = ACTIONS(1321),
    [anon_sym_mediump] = ACTIONS(1321),
    [anon_sym_lowp] = ACTIONS(1321),
    [anon_sym_centroid] = ACTIONS(1321),
    [anon_sym_sample] = ACTIONS(1321),
    [anon_sym_patch] = ACTIONS(1321),
    [anon_sym_smooth] = ACTIONS(1321),
    [anon_sym_flat] = ACTIONS(1321),
    [anon_sym_noperspective] = ACTIONS(1321),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1321),
    [anon_sym_hitAttributeEXT] = ACTIONS(1321),
    [anon_sym_callableDataEXT] = ACTIONS(1321),
    [anon_sym_callableDataInEXT] = ACTIONS(1321),
    [anon_sym_shaderRecordEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadNV] = ACTIONS(1321),
    [anon_sym_rayPayloadInNV] = ACTIONS(1321),
    [anon_sym_hitAttributeNV] = ACTIONS(1321),
    [anon_sym_callableDataNV] = ACTIONS(1321),
    [anon_sym_callableDataInNV] = ACTIONS(1321),
    [anon_sym_shaderRecordNV] = ACTIONS(1321),
    [anon_sym_layout] = ACTIONS(1321),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(1325),
    [sym_identifier] = ACTIONS(1327),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_subroutine] = ACTIONS(1327),
    [anon_sym_invariant] = ACTIONS(1327),
    [anon_sym_precise] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_in] = ACTIONS(1327),
    [anon_sym_out] = ACTIONS(1327),
    [anon_sym_inout] = ACTIONS(1327),
    [anon_sym_uniform] = ACTIONS(1327),
    [anon_sym_shared] = ACTIONS(1327),
    [anon_sym_attribute] = ACTIONS(1327),
    [anon_sym_varying] = ACTIONS(1327),
    [anon_sym_buffer] = ACTIONS(1327),
    [anon_sym_coherent] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_writeonly] = ACTIONS(1327),
    [anon_sym_precision] = ACTIONS(1327),
    [anon_sym_highp] = ACTIONS(1327),
    [anon_sym_mediump] = ACTIONS(1327),
    [anon_sym_lowp] = ACTIONS(1327),
    [anon_sym_centroid] = ACTIONS(1327),
    [anon_sym_sample] = ACTIONS(1327),
    [anon_sym_patch] = ACTIONS(1327),
    [anon_sym_smooth] = ACTIONS(1327),
    [anon_sym_flat] = ACTIONS(1327),
    [anon_sym_noperspective] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1327),
    [anon_sym_typedef] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym___attribute__] = ACTIONS(1327),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1325),
    [anon_sym___declspec] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_signed] = ACTIONS(1327),
    [anon_sym_unsigned] = ACTIONS(1327),
    [anon_sym_long] = ACTIONS(1327),
    [anon_sym_short] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_auto] = ACTIONS(1327),
    [anon_sym_register] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym___inline] = ACTIONS(1327),
    [anon_sym___inline__] = ACTIONS(1327),
    [anon_sym___forceinline] = ACTIONS(1327),
    [anon_sym_thread_local] = ACTIONS(1327),
    [anon_sym___thread] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_constexpr] = ACTIONS(1327),
    [anon_sym_volatile] = ACTIONS(1327),
    [anon_sym_restrict] = ACTIONS(1327),
    [anon_sym___restrict__] = ACTIONS(1327),
    [anon_sym__Atomic] = ACTIONS(1327),
    [anon_sym__Noreturn] = ACTIONS(1327),
    [anon_sym_noreturn] = ACTIONS(1327),
    [anon_sym_alignas] = ACTIONS(1327),
    [anon_sym__Alignas] = ACTIONS(1327),
    [sym_primitive_type] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [anon_sym_continue] = ACTIONS(1327),
    [anon_sym_goto] = ACTIONS(1327),
    [anon_sym___try] = ACTIONS(1327),
    [anon_sym___except] = ACTIONS(1327),
    [anon_sym___finally] = ACTIONS(1327),
    [anon_sym___leave] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_sizeof] = ACTIONS(1327),
    [anon_sym___alignof__] = ACTIONS(1327),
    [anon_sym___alignof] = ACTIONS(1327),
    [anon_sym__alignof] = ACTIONS(1327),
    [anon_sym_alignof] = ACTIONS(1327),
    [anon_sym__Alignof] = ACTIONS(1327),
    [anon_sym_offsetof] = ACTIONS(1327),
    [anon_sym__Generic] = ACTIONS(1327),
    [anon_sym_asm] = ACTIONS(1327),
    [anon_sym___asm__] = ACTIONS(1327),
    [sym_number_literal] = ACTIONS(1325),
    [anon_sym_L_SQUOTE] = ACTIONS(1325),
    [anon_sym_u_SQUOTE] = ACTIONS(1325),
    [anon_sym_U_SQUOTE] = ACTIONS(1325),
    [anon_sym_u8_SQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [anon_sym_L_DQUOTE] = ACTIONS(1325),
    [anon_sym_u_DQUOTE] = ACTIONS(1325),
    [anon_sym_U_DQUOTE] = ACTIONS(1325),
    [anon_sym_u8_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [anon_sym_NULL] = ACTIONS(1327),
    [anon_sym_nullptr] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1327),
    [anon_sym_hitAttributeEXT] = ACTIONS(1327),
    [anon_sym_callableDataEXT] = ACTIONS(1327),
    [anon_sym_callableDataInEXT] = ACTIONS(1327),
    [anon_sym_shaderRecordEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadNV] = ACTIONS(1327),
    [anon_sym_rayPayloadInNV] = ACTIONS(1327),
    [anon_sym_hitAttributeNV] = ACTIONS(1327),
    [anon_sym_callableDataNV] = ACTIONS(1327),
    [anon_sym_callableDataInNV] = ACTIONS(1327),
    [anon_sym_shaderRecordNV] = ACTIONS(1327),
    [anon_sym_layout] = ACTIONS(1327),
  },
  [106] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [aux_sym_preproc_else_token1] = ACTIONS(1317),
    [aux_sym_preproc_elif_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [107] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token2] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [aux_sym_preproc_else_token1] = ACTIONS(1329),
    [aux_sym_preproc_elif_token1] = ACTIONS(1329),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_subroutine] = ACTIONS(1329),
    [anon_sym_invariant] = ACTIONS(1329),
    [anon_sym_precise] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1329),
    [anon_sym_out] = ACTIONS(1329),
    [anon_sym_inout] = ACTIONS(1329),
    [anon_sym_uniform] = ACTIONS(1329),
    [anon_sym_shared] = ACTIONS(1329),
    [anon_sym_attribute] = ACTIONS(1329),
    [anon_sym_varying] = ACTIONS(1329),
    [anon_sym_buffer] = ACTIONS(1329),
    [anon_sym_coherent] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(1329),
    [anon_sym_writeonly] = ACTIONS(1329),
    [anon_sym_precision] = ACTIONS(1329),
    [anon_sym_highp] = ACTIONS(1329),
    [anon_sym_mediump] = ACTIONS(1329),
    [anon_sym_lowp] = ACTIONS(1329),
    [anon_sym_centroid] = ACTIONS(1329),
    [anon_sym_sample] = ACTIONS(1329),
    [anon_sym_patch] = ACTIONS(1329),
    [anon_sym_smooth] = ACTIONS(1329),
    [anon_sym_flat] = ACTIONS(1329),
    [anon_sym_noperspective] = ACTIONS(1329),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1329),
    [anon_sym_hitAttributeEXT] = ACTIONS(1329),
    [anon_sym_callableDataEXT] = ACTIONS(1329),
    [anon_sym_callableDataInEXT] = ACTIONS(1329),
    [anon_sym_shaderRecordEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadNV] = ACTIONS(1329),
    [anon_sym_rayPayloadInNV] = ACTIONS(1329),
    [anon_sym_hitAttributeNV] = ACTIONS(1329),
    [anon_sym_callableDataNV] = ACTIONS(1329),
    [anon_sym_callableDataInNV] = ACTIONS(1329),
    [anon_sym_shaderRecordNV] = ACTIONS(1329),
    [anon_sym_layout] = ACTIONS(1329),
  },
  [108] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token2] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [aux_sym_preproc_else_token1] = ACTIONS(1333),
    [aux_sym_preproc_elif_token1] = ACTIONS(1333),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_subroutine] = ACTIONS(1333),
    [anon_sym_invariant] = ACTIONS(1333),
    [anon_sym_precise] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_out] = ACTIONS(1333),
    [anon_sym_inout] = ACTIONS(1333),
    [anon_sym_uniform] = ACTIONS(1333),
    [anon_sym_shared] = ACTIONS(1333),
    [anon_sym_attribute] = ACTIONS(1333),
    [anon_sym_varying] = ACTIONS(1333),
    [anon_sym_buffer] = ACTIONS(1333),
    [anon_sym_coherent] = ACTIONS(1333),
    [anon_sym_readonly] = ACTIONS(1333),
    [anon_sym_writeonly] = ACTIONS(1333),
    [anon_sym_precision] = ACTIONS(1333),
    [anon_sym_highp] = ACTIONS(1333),
    [anon_sym_mediump] = ACTIONS(1333),
    [anon_sym_lowp] = ACTIONS(1333),
    [anon_sym_centroid] = ACTIONS(1333),
    [anon_sym_sample] = ACTIONS(1333),
    [anon_sym_patch] = ACTIONS(1333),
    [anon_sym_smooth] = ACTIONS(1333),
    [anon_sym_flat] = ACTIONS(1333),
    [anon_sym_noperspective] = ACTIONS(1333),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1333),
    [anon_sym_hitAttributeEXT] = ACTIONS(1333),
    [anon_sym_callableDataEXT] = ACTIONS(1333),
    [anon_sym_callableDataInEXT] = ACTIONS(1333),
    [anon_sym_shaderRecordEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadNV] = ACTIONS(1333),
    [anon_sym_rayPayloadInNV] = ACTIONS(1333),
    [anon_sym_hitAttributeNV] = ACTIONS(1333),
    [anon_sym_callableDataNV] = ACTIONS(1333),
    [anon_sym_callableDataInNV] = ACTIONS(1333),
    [anon_sym_shaderRecordNV] = ACTIONS(1333),
    [anon_sym_layout] = ACTIONS(1333),
  },
  [109] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token2] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [aux_sym_preproc_else_token1] = ACTIONS(1337),
    [aux_sym_preproc_elif_token1] = ACTIONS(1337),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_subroutine] = ACTIONS(1337),
    [anon_sym_invariant] = ACTIONS(1337),
    [anon_sym_precise] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1337),
    [anon_sym_out] = ACTIONS(1337),
    [anon_sym_inout] = ACTIONS(1337),
    [anon_sym_uniform] = ACTIONS(1337),
    [anon_sym_shared] = ACTIONS(1337),
    [anon_sym_attribute] = ACTIONS(1337),
    [anon_sym_varying] = ACTIONS(1337),
    [anon_sym_buffer] = ACTIONS(1337),
    [anon_sym_coherent] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_writeonly] = ACTIONS(1337),
    [anon_sym_precision] = ACTIONS(1337),
    [anon_sym_highp] = ACTIONS(1337),
    [anon_sym_mediump] = ACTIONS(1337),
    [anon_sym_lowp] = ACTIONS(1337),
    [anon_sym_centroid] = ACTIONS(1337),
    [anon_sym_sample] = ACTIONS(1337),
    [anon_sym_patch] = ACTIONS(1337),
    [anon_sym_smooth] = ACTIONS(1337),
    [anon_sym_flat] = ACTIONS(1337),
    [anon_sym_noperspective] = ACTIONS(1337),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_else] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1337),
    [anon_sym_hitAttributeEXT] = ACTIONS(1337),
    [anon_sym_callableDataEXT] = ACTIONS(1337),
    [anon_sym_callableDataInEXT] = ACTIONS(1337),
    [anon_sym_shaderRecordEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadNV] = ACTIONS(1337),
    [anon_sym_rayPayloadInNV] = ACTIONS(1337),
    [anon_sym_hitAttributeNV] = ACTIONS(1337),
    [anon_sym_callableDataNV] = ACTIONS(1337),
    [anon_sym_callableDataInNV] = ACTIONS(1337),
    [anon_sym_shaderRecordNV] = ACTIONS(1337),
    [anon_sym_layout] = ACTIONS(1337),
  },
  [110] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token2] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [aux_sym_preproc_else_token1] = ACTIONS(1341),
    [aux_sym_preproc_elif_token1] = ACTIONS(1341),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_subroutine] = ACTIONS(1341),
    [anon_sym_invariant] = ACTIONS(1341),
    [anon_sym_precise] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_out] = ACTIONS(1341),
    [anon_sym_inout] = ACTIONS(1341),
    [anon_sym_uniform] = ACTIONS(1341),
    [anon_sym_shared] = ACTIONS(1341),
    [anon_sym_attribute] = ACTIONS(1341),
    [anon_sym_varying] = ACTIONS(1341),
    [anon_sym_buffer] = ACTIONS(1341),
    [anon_sym_coherent] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_writeonly] = ACTIONS(1341),
    [anon_sym_precision] = ACTIONS(1341),
    [anon_sym_highp] = ACTIONS(1341),
    [anon_sym_mediump] = ACTIONS(1341),
    [anon_sym_lowp] = ACTIONS(1341),
    [anon_sym_centroid] = ACTIONS(1341),
    [anon_sym_sample] = ACTIONS(1341),
    [anon_sym_patch] = ACTIONS(1341),
    [anon_sym_smooth] = ACTIONS(1341),
    [anon_sym_flat] = ACTIONS(1341),
    [anon_sym_noperspective] = ACTIONS(1341),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1341),
    [anon_sym_hitAttributeEXT] = ACTIONS(1341),
    [anon_sym_callableDataEXT] = ACTIONS(1341),
    [anon_sym_callableDataInEXT] = ACTIONS(1341),
    [anon_sym_shaderRecordEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadNV] = ACTIONS(1341),
    [anon_sym_rayPayloadInNV] = ACTIONS(1341),
    [anon_sym_hitAttributeNV] = ACTIONS(1341),
    [anon_sym_callableDataNV] = ACTIONS(1341),
    [anon_sym_callableDataInNV] = ACTIONS(1341),
    [anon_sym_shaderRecordNV] = ACTIONS(1341),
    [anon_sym_layout] = ACTIONS(1341),
  },
  [111] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token2] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [aux_sym_preproc_else_token1] = ACTIONS(1345),
    [aux_sym_preproc_elif_token1] = ACTIONS(1345),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_subroutine] = ACTIONS(1345),
    [anon_sym_invariant] = ACTIONS(1345),
    [anon_sym_precise] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_out] = ACTIONS(1345),
    [anon_sym_inout] = ACTIONS(1345),
    [anon_sym_uniform] = ACTIONS(1345),
    [anon_sym_shared] = ACTIONS(1345),
    [anon_sym_attribute] = ACTIONS(1345),
    [anon_sym_varying] = ACTIONS(1345),
    [anon_sym_buffer] = ACTIONS(1345),
    [anon_sym_coherent] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_writeonly] = ACTIONS(1345),
    [anon_sym_precision] = ACTIONS(1345),
    [anon_sym_highp] = ACTIONS(1345),
    [anon_sym_mediump] = ACTIONS(1345),
    [anon_sym_lowp] = ACTIONS(1345),
    [anon_sym_centroid] = ACTIONS(1345),
    [anon_sym_sample] = ACTIONS(1345),
    [anon_sym_patch] = ACTIONS(1345),
    [anon_sym_smooth] = ACTIONS(1345),
    [anon_sym_flat] = ACTIONS(1345),
    [anon_sym_noperspective] = ACTIONS(1345),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1345),
    [anon_sym_hitAttributeEXT] = ACTIONS(1345),
    [anon_sym_callableDataEXT] = ACTIONS(1345),
    [anon_sym_callableDataInEXT] = ACTIONS(1345),
    [anon_sym_shaderRecordEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadNV] = ACTIONS(1345),
    [anon_sym_rayPayloadInNV] = ACTIONS(1345),
    [anon_sym_hitAttributeNV] = ACTIONS(1345),
    [anon_sym_callableDataNV] = ACTIONS(1345),
    [anon_sym_callableDataInNV] = ACTIONS(1345),
    [anon_sym_shaderRecordNV] = ACTIONS(1345),
    [anon_sym_layout] = ACTIONS(1345),
  },
  [112] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token2] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [aux_sym_preproc_else_token1] = ACTIONS(1349),
    [aux_sym_preproc_elif_token1] = ACTIONS(1349),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_subroutine] = ACTIONS(1349),
    [anon_sym_invariant] = ACTIONS(1349),
    [anon_sym_precise] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1349),
    [anon_sym_out] = ACTIONS(1349),
    [anon_sym_inout] = ACTIONS(1349),
    [anon_sym_uniform] = ACTIONS(1349),
    [anon_sym_shared] = ACTIONS(1349),
    [anon_sym_attribute] = ACTIONS(1349),
    [anon_sym_varying] = ACTIONS(1349),
    [anon_sym_buffer] = ACTIONS(1349),
    [anon_sym_coherent] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_writeonly] = ACTIONS(1349),
    [anon_sym_precision] = ACTIONS(1349),
    [anon_sym_highp] = ACTIONS(1349),
    [anon_sym_mediump] = ACTIONS(1349),
    [anon_sym_lowp] = ACTIONS(1349),
    [anon_sym_centroid] = ACTIONS(1349),
    [anon_sym_sample] = ACTIONS(1349),
    [anon_sym_patch] = ACTIONS(1349),
    [anon_sym_smooth] = ACTIONS(1349),
    [anon_sym_flat] = ACTIONS(1349),
    [anon_sym_noperspective] = ACTIONS(1349),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1349),
    [anon_sym_hitAttributeEXT] = ACTIONS(1349),
    [anon_sym_callableDataEXT] = ACTIONS(1349),
    [anon_sym_callableDataInEXT] = ACTIONS(1349),
    [anon_sym_shaderRecordEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadNV] = ACTIONS(1349),
    [anon_sym_rayPayloadInNV] = ACTIONS(1349),
    [anon_sym_hitAttributeNV] = ACTIONS(1349),
    [anon_sym_callableDataNV] = ACTIONS(1349),
    [anon_sym_callableDataInNV] = ACTIONS(1349),
    [anon_sym_shaderRecordNV] = ACTIONS(1349),
    [anon_sym_layout] = ACTIONS(1349),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1355),
    [aux_sym_preproc_include_token1] = ACTIONS(1355),
    [aux_sym_preproc_def_token1] = ACTIONS(1355),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [aux_sym_preproc_if_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1355),
    [sym_preproc_directive] = ACTIONS(1355),
    [anon_sym_LPAREN2] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_subroutine] = ACTIONS(1355),
    [anon_sym_invariant] = ACTIONS(1355),
    [anon_sym_precise] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_uniform] = ACTIONS(1355),
    [anon_sym_shared] = ACTIONS(1355),
    [anon_sym_attribute] = ACTIONS(1355),
    [anon_sym_varying] = ACTIONS(1355),
    [anon_sym_buffer] = ACTIONS(1355),
    [anon_sym_coherent] = ACTIONS(1355),
    [anon_sym_readonly] = ACTIONS(1355),
    [anon_sym_writeonly] = ACTIONS(1355),
    [anon_sym_precision] = ACTIONS(1355),
    [anon_sym_highp] = ACTIONS(1355),
    [anon_sym_mediump] = ACTIONS(1355),
    [anon_sym_lowp] = ACTIONS(1355),
    [anon_sym_centroid] = ACTIONS(1355),
    [anon_sym_sample] = ACTIONS(1355),
    [anon_sym_patch] = ACTIONS(1355),
    [anon_sym_smooth] = ACTIONS(1355),
    [anon_sym_flat] = ACTIONS(1355),
    [anon_sym_noperspective] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1355),
    [anon_sym_typedef] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym___attribute__] = ACTIONS(1355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1353),
    [anon_sym___declspec] = ACTIONS(1355),
    [anon_sym___cdecl] = ACTIONS(1355),
    [anon_sym___clrcall] = ACTIONS(1355),
    [anon_sym___stdcall] = ACTIONS(1355),
    [anon_sym___fastcall] = ACTIONS(1355),
    [anon_sym___thiscall] = ACTIONS(1355),
    [anon_sym___vectorcall] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_signed] = ACTIONS(1355),
    [anon_sym_unsigned] = ACTIONS(1355),
    [anon_sym_long] = ACTIONS(1355),
    [anon_sym_short] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_auto] = ACTIONS(1355),
    [anon_sym_register] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym___inline] = ACTIONS(1355),
    [anon_sym___inline__] = ACTIONS(1355),
    [anon_sym___forceinline] = ACTIONS(1355),
    [anon_sym_thread_local] = ACTIONS(1355),
    [anon_sym___thread] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_constexpr] = ACTIONS(1355),
    [anon_sym_volatile] = ACTIONS(1355),
    [anon_sym_restrict] = ACTIONS(1355),
    [anon_sym___restrict__] = ACTIONS(1355),
    [anon_sym__Atomic] = ACTIONS(1355),
    [anon_sym__Noreturn] = ACTIONS(1355),
    [anon_sym_noreturn] = ACTIONS(1355),
    [anon_sym_alignas] = ACTIONS(1355),
    [anon_sym__Alignas] = ACTIONS(1355),
    [sym_primitive_type] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_goto] = ACTIONS(1355),
    [anon_sym___try] = ACTIONS(1355),
    [anon_sym___except] = ACTIONS(1355),
    [anon_sym___finally] = ACTIONS(1355),
    [anon_sym___leave] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_sizeof] = ACTIONS(1355),
    [anon_sym___alignof__] = ACTIONS(1355),
    [anon_sym___alignof] = ACTIONS(1355),
    [anon_sym__alignof] = ACTIONS(1355),
    [anon_sym_alignof] = ACTIONS(1355),
    [anon_sym__Alignof] = ACTIONS(1355),
    [anon_sym_offsetof] = ACTIONS(1355),
    [anon_sym__Generic] = ACTIONS(1355),
    [anon_sym_asm] = ACTIONS(1355),
    [anon_sym___asm__] = ACTIONS(1355),
    [sym_number_literal] = ACTIONS(1353),
    [anon_sym_L_SQUOTE] = ACTIONS(1353),
    [anon_sym_u_SQUOTE] = ACTIONS(1353),
    [anon_sym_U_SQUOTE] = ACTIONS(1353),
    [anon_sym_u8_SQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_L_DQUOTE] = ACTIONS(1353),
    [anon_sym_u_DQUOTE] = ACTIONS(1353),
    [anon_sym_U_DQUOTE] = ACTIONS(1353),
    [anon_sym_u8_DQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1355),
    [anon_sym_hitAttributeEXT] = ACTIONS(1355),
    [anon_sym_callableDataEXT] = ACTIONS(1355),
    [anon_sym_callableDataInEXT] = ACTIONS(1355),
    [anon_sym_shaderRecordEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadNV] = ACTIONS(1355),
    [anon_sym_rayPayloadInNV] = ACTIONS(1355),
    [anon_sym_hitAttributeNV] = ACTIONS(1355),
    [anon_sym_callableDataNV] = ACTIONS(1355),
    [anon_sym_callableDataInNV] = ACTIONS(1355),
    [anon_sym_shaderRecordNV] = ACTIONS(1355),
    [anon_sym_layout] = ACTIONS(1355),
  },
  [114] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token2] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [aux_sym_preproc_else_token1] = ACTIONS(1357),
    [aux_sym_preproc_elif_token1] = ACTIONS(1357),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_subroutine] = ACTIONS(1357),
    [anon_sym_invariant] = ACTIONS(1357),
    [anon_sym_precise] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1357),
    [anon_sym_out] = ACTIONS(1357),
    [anon_sym_inout] = ACTIONS(1357),
    [anon_sym_uniform] = ACTIONS(1357),
    [anon_sym_shared] = ACTIONS(1357),
    [anon_sym_attribute] = ACTIONS(1357),
    [anon_sym_varying] = ACTIONS(1357),
    [anon_sym_buffer] = ACTIONS(1357),
    [anon_sym_coherent] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_writeonly] = ACTIONS(1357),
    [anon_sym_precision] = ACTIONS(1357),
    [anon_sym_highp] = ACTIONS(1357),
    [anon_sym_mediump] = ACTIONS(1357),
    [anon_sym_lowp] = ACTIONS(1357),
    [anon_sym_centroid] = ACTIONS(1357),
    [anon_sym_sample] = ACTIONS(1357),
    [anon_sym_patch] = ACTIONS(1357),
    [anon_sym_smooth] = ACTIONS(1357),
    [anon_sym_flat] = ACTIONS(1357),
    [anon_sym_noperspective] = ACTIONS(1357),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1357),
    [anon_sym_hitAttributeEXT] = ACTIONS(1357),
    [anon_sym_callableDataEXT] = ACTIONS(1357),
    [anon_sym_callableDataInEXT] = ACTIONS(1357),
    [anon_sym_shaderRecordEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadNV] = ACTIONS(1357),
    [anon_sym_rayPayloadInNV] = ACTIONS(1357),
    [anon_sym_hitAttributeNV] = ACTIONS(1357),
    [anon_sym_callableDataNV] = ACTIONS(1357),
    [anon_sym_callableDataInNV] = ACTIONS(1357),
    [anon_sym_shaderRecordNV] = ACTIONS(1357),
    [anon_sym_layout] = ACTIONS(1357),
  },
  [115] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [aux_sym_preproc_else_token1] = ACTIONS(1361),
    [aux_sym_preproc_elif_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [116] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [aux_sym_preproc_else_token1] = ACTIONS(1361),
    [aux_sym_preproc_elif_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [117] = {
    [sym_identifier] = ACTIONS(1365),
    [aux_sym_preproc_include_token1] = ACTIONS(1365),
    [aux_sym_preproc_def_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token2] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1365),
    [aux_sym_preproc_else_token1] = ACTIONS(1365),
    [aux_sym_preproc_elif_token1] = ACTIONS(1365),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1365),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1365),
    [sym_preproc_directive] = ACTIONS(1365),
    [anon_sym_LPAREN2] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_subroutine] = ACTIONS(1365),
    [anon_sym_invariant] = ACTIONS(1365),
    [anon_sym_precise] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_out] = ACTIONS(1365),
    [anon_sym_inout] = ACTIONS(1365),
    [anon_sym_uniform] = ACTIONS(1365),
    [anon_sym_shared] = ACTIONS(1365),
    [anon_sym_attribute] = ACTIONS(1365),
    [anon_sym_varying] = ACTIONS(1365),
    [anon_sym_buffer] = ACTIONS(1365),
    [anon_sym_coherent] = ACTIONS(1365),
    [anon_sym_readonly] = ACTIONS(1365),
    [anon_sym_writeonly] = ACTIONS(1365),
    [anon_sym_precision] = ACTIONS(1365),
    [anon_sym_highp] = ACTIONS(1365),
    [anon_sym_mediump] = ACTIONS(1365),
    [anon_sym_lowp] = ACTIONS(1365),
    [anon_sym_centroid] = ACTIONS(1365),
    [anon_sym_sample] = ACTIONS(1365),
    [anon_sym_patch] = ACTIONS(1365),
    [anon_sym_smooth] = ACTIONS(1365),
    [anon_sym_flat] = ACTIONS(1365),
    [anon_sym_noperspective] = ACTIONS(1365),
    [anon_sym___extension__] = ACTIONS(1365),
    [anon_sym_typedef] = ACTIONS(1365),
    [anon_sym_extern] = ACTIONS(1365),
    [anon_sym___attribute__] = ACTIONS(1365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1365),
    [anon_sym___cdecl] = ACTIONS(1365),
    [anon_sym___clrcall] = ACTIONS(1365),
    [anon_sym___stdcall] = ACTIONS(1365),
    [anon_sym___fastcall] = ACTIONS(1365),
    [anon_sym___thiscall] = ACTIONS(1365),
    [anon_sym___vectorcall] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_signed] = ACTIONS(1365),
    [anon_sym_unsigned] = ACTIONS(1365),
    [anon_sym_long] = ACTIONS(1365),
    [anon_sym_short] = ACTIONS(1365),
    [anon_sym_static] = ACTIONS(1365),
    [anon_sym_auto] = ACTIONS(1365),
    [anon_sym_register] = ACTIONS(1365),
    [anon_sym_inline] = ACTIONS(1365),
    [anon_sym___inline] = ACTIONS(1365),
    [anon_sym___inline__] = ACTIONS(1365),
    [anon_sym___forceinline] = ACTIONS(1365),
    [anon_sym_thread_local] = ACTIONS(1365),
    [anon_sym___thread] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_constexpr] = ACTIONS(1365),
    [anon_sym_volatile] = ACTIONS(1365),
    [anon_sym_restrict] = ACTIONS(1365),
    [anon_sym___restrict__] = ACTIONS(1365),
    [anon_sym__Atomic] = ACTIONS(1365),
    [anon_sym__Noreturn] = ACTIONS(1365),
    [anon_sym_noreturn] = ACTIONS(1365),
    [anon_sym_alignas] = ACTIONS(1365),
    [anon_sym__Alignas] = ACTIONS(1365),
    [sym_primitive_type] = ACTIONS(1365),
    [anon_sym_enum] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1365),
    [anon_sym_union] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_case] = ACTIONS(1365),
    [anon_sym_default] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_do] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_break] = ACTIONS(1365),
    [anon_sym_continue] = ACTIONS(1365),
    [anon_sym_goto] = ACTIONS(1365),
    [anon_sym___try] = ACTIONS(1365),
    [anon_sym___leave] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_sizeof] = ACTIONS(1365),
    [anon_sym___alignof__] = ACTIONS(1365),
    [anon_sym___alignof] = ACTIONS(1365),
    [anon_sym__alignof] = ACTIONS(1365),
    [anon_sym_alignof] = ACTIONS(1365),
    [anon_sym__Alignof] = ACTIONS(1365),
    [anon_sym_offsetof] = ACTIONS(1365),
    [anon_sym__Generic] = ACTIONS(1365),
    [anon_sym_asm] = ACTIONS(1365),
    [anon_sym___asm__] = ACTIONS(1365),
    [sym_number_literal] = ACTIONS(1367),
    [anon_sym_L_SQUOTE] = ACTIONS(1367),
    [anon_sym_u_SQUOTE] = ACTIONS(1367),
    [anon_sym_U_SQUOTE] = ACTIONS(1367),
    [anon_sym_u8_SQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [anon_sym_L_DQUOTE] = ACTIONS(1367),
    [anon_sym_u_DQUOTE] = ACTIONS(1367),
    [anon_sym_U_DQUOTE] = ACTIONS(1367),
    [anon_sym_u8_DQUOTE] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [anon_sym_NULL] = ACTIONS(1365),
    [anon_sym_nullptr] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1365),
    [anon_sym_hitAttributeEXT] = ACTIONS(1365),
    [anon_sym_callableDataEXT] = ACTIONS(1365),
    [anon_sym_callableDataInEXT] = ACTIONS(1365),
    [anon_sym_shaderRecordEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadNV] = ACTIONS(1365),
    [anon_sym_rayPayloadInNV] = ACTIONS(1365),
    [anon_sym_hitAttributeNV] = ACTIONS(1365),
    [anon_sym_callableDataNV] = ACTIONS(1365),
    [anon_sym_callableDataInNV] = ACTIONS(1365),
    [anon_sym_shaderRecordNV] = ACTIONS(1365),
    [anon_sym_layout] = ACTIONS(1365),
  },
  [118] = {
    [sym_identifier] = ACTIONS(1327),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token2] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [aux_sym_preproc_else_token1] = ACTIONS(1327),
    [aux_sym_preproc_elif_token1] = ACTIONS(1327),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_subroutine] = ACTIONS(1327),
    [anon_sym_invariant] = ACTIONS(1327),
    [anon_sym_precise] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_in] = ACTIONS(1327),
    [anon_sym_out] = ACTIONS(1327),
    [anon_sym_inout] = ACTIONS(1327),
    [anon_sym_uniform] = ACTIONS(1327),
    [anon_sym_shared] = ACTIONS(1327),
    [anon_sym_attribute] = ACTIONS(1327),
    [anon_sym_varying] = ACTIONS(1327),
    [anon_sym_buffer] = ACTIONS(1327),
    [anon_sym_coherent] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_writeonly] = ACTIONS(1327),
    [anon_sym_precision] = ACTIONS(1327),
    [anon_sym_highp] = ACTIONS(1327),
    [anon_sym_mediump] = ACTIONS(1327),
    [anon_sym_lowp] = ACTIONS(1327),
    [anon_sym_centroid] = ACTIONS(1327),
    [anon_sym_sample] = ACTIONS(1327),
    [anon_sym_patch] = ACTIONS(1327),
    [anon_sym_smooth] = ACTIONS(1327),
    [anon_sym_flat] = ACTIONS(1327),
    [anon_sym_noperspective] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1327),
    [anon_sym_typedef] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym___attribute__] = ACTIONS(1327),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1325),
    [anon_sym___declspec] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_signed] = ACTIONS(1327),
    [anon_sym_unsigned] = ACTIONS(1327),
    [anon_sym_long] = ACTIONS(1327),
    [anon_sym_short] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_auto] = ACTIONS(1327),
    [anon_sym_register] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym___inline] = ACTIONS(1327),
    [anon_sym___inline__] = ACTIONS(1327),
    [anon_sym___forceinline] = ACTIONS(1327),
    [anon_sym_thread_local] = ACTIONS(1327),
    [anon_sym___thread] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_constexpr] = ACTIONS(1327),
    [anon_sym_volatile] = ACTIONS(1327),
    [anon_sym_restrict] = ACTIONS(1327),
    [anon_sym___restrict__] = ACTIONS(1327),
    [anon_sym__Atomic] = ACTIONS(1327),
    [anon_sym__Noreturn] = ACTIONS(1327),
    [anon_sym_noreturn] = ACTIONS(1327),
    [anon_sym_alignas] = ACTIONS(1327),
    [anon_sym__Alignas] = ACTIONS(1327),
    [sym_primitive_type] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [anon_sym_continue] = ACTIONS(1327),
    [anon_sym_goto] = ACTIONS(1327),
    [anon_sym___try] = ACTIONS(1327),
    [anon_sym___leave] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_sizeof] = ACTIONS(1327),
    [anon_sym___alignof__] = ACTIONS(1327),
    [anon_sym___alignof] = ACTIONS(1327),
    [anon_sym__alignof] = ACTIONS(1327),
    [anon_sym_alignof] = ACTIONS(1327),
    [anon_sym__Alignof] = ACTIONS(1327),
    [anon_sym_offsetof] = ACTIONS(1327),
    [anon_sym__Generic] = ACTIONS(1327),
    [anon_sym_asm] = ACTIONS(1327),
    [anon_sym___asm__] = ACTIONS(1327),
    [sym_number_literal] = ACTIONS(1325),
    [anon_sym_L_SQUOTE] = ACTIONS(1325),
    [anon_sym_u_SQUOTE] = ACTIONS(1325),
    [anon_sym_U_SQUOTE] = ACTIONS(1325),
    [anon_sym_u8_SQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [anon_sym_L_DQUOTE] = ACTIONS(1325),
    [anon_sym_u_DQUOTE] = ACTIONS(1325),
    [anon_sym_U_DQUOTE] = ACTIONS(1325),
    [anon_sym_u8_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [anon_sym_NULL] = ACTIONS(1327),
    [anon_sym_nullptr] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1327),
    [anon_sym_hitAttributeEXT] = ACTIONS(1327),
    [anon_sym_callableDataEXT] = ACTIONS(1327),
    [anon_sym_callableDataInEXT] = ACTIONS(1327),
    [anon_sym_shaderRecordEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadNV] = ACTIONS(1327),
    [anon_sym_rayPayloadInNV] = ACTIONS(1327),
    [anon_sym_hitAttributeNV] = ACTIONS(1327),
    [anon_sym_callableDataNV] = ACTIONS(1327),
    [anon_sym_callableDataInNV] = ACTIONS(1327),
    [anon_sym_shaderRecordNV] = ACTIONS(1327),
    [anon_sym_layout] = ACTIONS(1327),
  },
  [119] = {
    [sym_identifier] = ACTIONS(1369),
    [aux_sym_preproc_include_token1] = ACTIONS(1369),
    [aux_sym_preproc_def_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token2] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1369),
    [aux_sym_preproc_else_token1] = ACTIONS(1369),
    [aux_sym_preproc_elif_token1] = ACTIONS(1369),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1369),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1369),
    [sym_preproc_directive] = ACTIONS(1369),
    [anon_sym_LPAREN2] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_subroutine] = ACTIONS(1369),
    [anon_sym_invariant] = ACTIONS(1369),
    [anon_sym_precise] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_in] = ACTIONS(1369),
    [anon_sym_out] = ACTIONS(1369),
    [anon_sym_inout] = ACTIONS(1369),
    [anon_sym_uniform] = ACTIONS(1369),
    [anon_sym_shared] = ACTIONS(1369),
    [anon_sym_attribute] = ACTIONS(1369),
    [anon_sym_varying] = ACTIONS(1369),
    [anon_sym_buffer] = ACTIONS(1369),
    [anon_sym_coherent] = ACTIONS(1369),
    [anon_sym_readonly] = ACTIONS(1369),
    [anon_sym_writeonly] = ACTIONS(1369),
    [anon_sym_precision] = ACTIONS(1369),
    [anon_sym_highp] = ACTIONS(1369),
    [anon_sym_mediump] = ACTIONS(1369),
    [anon_sym_lowp] = ACTIONS(1369),
    [anon_sym_centroid] = ACTIONS(1369),
    [anon_sym_sample] = ACTIONS(1369),
    [anon_sym_patch] = ACTIONS(1369),
    [anon_sym_smooth] = ACTIONS(1369),
    [anon_sym_flat] = ACTIONS(1369),
    [anon_sym_noperspective] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1369),
    [anon_sym_typedef] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1369),
    [anon_sym___attribute__] = ACTIONS(1369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1371),
    [anon_sym___declspec] = ACTIONS(1369),
    [anon_sym___cdecl] = ACTIONS(1369),
    [anon_sym___clrcall] = ACTIONS(1369),
    [anon_sym___stdcall] = ACTIONS(1369),
    [anon_sym___fastcall] = ACTIONS(1369),
    [anon_sym___thiscall] = ACTIONS(1369),
    [anon_sym___vectorcall] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_signed] = ACTIONS(1369),
    [anon_sym_unsigned] = ACTIONS(1369),
    [anon_sym_long] = ACTIONS(1369),
    [anon_sym_short] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_auto] = ACTIONS(1369),
    [anon_sym_register] = ACTIONS(1369),
    [anon_sym_inline] = ACTIONS(1369),
    [anon_sym___inline] = ACTIONS(1369),
    [anon_sym___inline__] = ACTIONS(1369),
    [anon_sym___forceinline] = ACTIONS(1369),
    [anon_sym_thread_local] = ACTIONS(1369),
    [anon_sym___thread] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_constexpr] = ACTIONS(1369),
    [anon_sym_volatile] = ACTIONS(1369),
    [anon_sym_restrict] = ACTIONS(1369),
    [anon_sym___restrict__] = ACTIONS(1369),
    [anon_sym__Atomic] = ACTIONS(1369),
    [anon_sym__Noreturn] = ACTIONS(1369),
    [anon_sym_noreturn] = ACTIONS(1369),
    [anon_sym_alignas] = ACTIONS(1369),
    [anon_sym__Alignas] = ACTIONS(1369),
    [sym_primitive_type] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1369),
    [anon_sym_union] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_goto] = ACTIONS(1369),
    [anon_sym___try] = ACTIONS(1369),
    [anon_sym___leave] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_sizeof] = ACTIONS(1369),
    [anon_sym___alignof__] = ACTIONS(1369),
    [anon_sym___alignof] = ACTIONS(1369),
    [anon_sym__alignof] = ACTIONS(1369),
    [anon_sym_alignof] = ACTIONS(1369),
    [anon_sym__Alignof] = ACTIONS(1369),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1369),
    [anon_sym_asm] = ACTIONS(1369),
    [anon_sym___asm__] = ACTIONS(1369),
    [sym_number_literal] = ACTIONS(1371),
    [anon_sym_L_SQUOTE] = ACTIONS(1371),
    [anon_sym_u_SQUOTE] = ACTIONS(1371),
    [anon_sym_U_SQUOTE] = ACTIONS(1371),
    [anon_sym_u8_SQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [anon_sym_L_DQUOTE] = ACTIONS(1371),
    [anon_sym_u_DQUOTE] = ACTIONS(1371),
    [anon_sym_U_DQUOTE] = ACTIONS(1371),
    [anon_sym_u8_DQUOTE] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [anon_sym_NULL] = ACTIONS(1369),
    [anon_sym_nullptr] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1369),
    [anon_sym_hitAttributeEXT] = ACTIONS(1369),
    [anon_sym_callableDataEXT] = ACTIONS(1369),
    [anon_sym_callableDataInEXT] = ACTIONS(1369),
    [anon_sym_shaderRecordEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadNV] = ACTIONS(1369),
    [anon_sym_rayPayloadInNV] = ACTIONS(1369),
    [anon_sym_hitAttributeNV] = ACTIONS(1369),
    [anon_sym_callableDataNV] = ACTIONS(1369),
    [anon_sym_callableDataInNV] = ACTIONS(1369),
    [anon_sym_shaderRecordNV] = ACTIONS(1369),
    [anon_sym_layout] = ACTIONS(1369),
  },
  [120] = {
    [sym_identifier] = ACTIONS(1355),
    [aux_sym_preproc_include_token1] = ACTIONS(1355),
    [aux_sym_preproc_def_token1] = ACTIONS(1355),
    [aux_sym_preproc_if_token1] = ACTIONS(1355),
    [aux_sym_preproc_if_token2] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1355),
    [aux_sym_preproc_else_token1] = ACTIONS(1355),
    [aux_sym_preproc_elif_token1] = ACTIONS(1355),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1355),
    [sym_preproc_directive] = ACTIONS(1355),
    [anon_sym_LPAREN2] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_subroutine] = ACTIONS(1355),
    [anon_sym_invariant] = ACTIONS(1355),
    [anon_sym_precise] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_uniform] = ACTIONS(1355),
    [anon_sym_shared] = ACTIONS(1355),
    [anon_sym_attribute] = ACTIONS(1355),
    [anon_sym_varying] = ACTIONS(1355),
    [anon_sym_buffer] = ACTIONS(1355),
    [anon_sym_coherent] = ACTIONS(1355),
    [anon_sym_readonly] = ACTIONS(1355),
    [anon_sym_writeonly] = ACTIONS(1355),
    [anon_sym_precision] = ACTIONS(1355),
    [anon_sym_highp] = ACTIONS(1355),
    [anon_sym_mediump] = ACTIONS(1355),
    [anon_sym_lowp] = ACTIONS(1355),
    [anon_sym_centroid] = ACTIONS(1355),
    [anon_sym_sample] = ACTIONS(1355),
    [anon_sym_patch] = ACTIONS(1355),
    [anon_sym_smooth] = ACTIONS(1355),
    [anon_sym_flat] = ACTIONS(1355),
    [anon_sym_noperspective] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1355),
    [anon_sym_typedef] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym___attribute__] = ACTIONS(1355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1353),
    [anon_sym___declspec] = ACTIONS(1355),
    [anon_sym___cdecl] = ACTIONS(1355),
    [anon_sym___clrcall] = ACTIONS(1355),
    [anon_sym___stdcall] = ACTIONS(1355),
    [anon_sym___fastcall] = ACTIONS(1355),
    [anon_sym___thiscall] = ACTIONS(1355),
    [anon_sym___vectorcall] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_signed] = ACTIONS(1355),
    [anon_sym_unsigned] = ACTIONS(1355),
    [anon_sym_long] = ACTIONS(1355),
    [anon_sym_short] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_auto] = ACTIONS(1355),
    [anon_sym_register] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym___inline] = ACTIONS(1355),
    [anon_sym___inline__] = ACTIONS(1355),
    [anon_sym___forceinline] = ACTIONS(1355),
    [anon_sym_thread_local] = ACTIONS(1355),
    [anon_sym___thread] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_constexpr] = ACTIONS(1355),
    [anon_sym_volatile] = ACTIONS(1355),
    [anon_sym_restrict] = ACTIONS(1355),
    [anon_sym___restrict__] = ACTIONS(1355),
    [anon_sym__Atomic] = ACTIONS(1355),
    [anon_sym__Noreturn] = ACTIONS(1355),
    [anon_sym_noreturn] = ACTIONS(1355),
    [anon_sym_alignas] = ACTIONS(1355),
    [anon_sym__Alignas] = ACTIONS(1355),
    [sym_primitive_type] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_goto] = ACTIONS(1355),
    [anon_sym___try] = ACTIONS(1355),
    [anon_sym___leave] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_sizeof] = ACTIONS(1355),
    [anon_sym___alignof__] = ACTIONS(1355),
    [anon_sym___alignof] = ACTIONS(1355),
    [anon_sym__alignof] = ACTIONS(1355),
    [anon_sym_alignof] = ACTIONS(1355),
    [anon_sym__Alignof] = ACTIONS(1355),
    [anon_sym_offsetof] = ACTIONS(1355),
    [anon_sym__Generic] = ACTIONS(1355),
    [anon_sym_asm] = ACTIONS(1355),
    [anon_sym___asm__] = ACTIONS(1355),
    [sym_number_literal] = ACTIONS(1353),
    [anon_sym_L_SQUOTE] = ACTIONS(1353),
    [anon_sym_u_SQUOTE] = ACTIONS(1353),
    [anon_sym_U_SQUOTE] = ACTIONS(1353),
    [anon_sym_u8_SQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_L_DQUOTE] = ACTIONS(1353),
    [anon_sym_u_DQUOTE] = ACTIONS(1353),
    [anon_sym_U_DQUOTE] = ACTIONS(1353),
    [anon_sym_u8_DQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1355),
    [anon_sym_hitAttributeEXT] = ACTIONS(1355),
    [anon_sym_callableDataEXT] = ACTIONS(1355),
    [anon_sym_callableDataInEXT] = ACTIONS(1355),
    [anon_sym_shaderRecordEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadNV] = ACTIONS(1355),
    [anon_sym_rayPayloadInNV] = ACTIONS(1355),
    [anon_sym_hitAttributeNV] = ACTIONS(1355),
    [anon_sym_callableDataNV] = ACTIONS(1355),
    [anon_sym_callableDataInNV] = ACTIONS(1355),
    [anon_sym_shaderRecordNV] = ACTIONS(1355),
    [anon_sym_layout] = ACTIONS(1355),
  },
  [121] = {
    [sym_identifier] = ACTIONS(1373),
    [aux_sym_preproc_include_token1] = ACTIONS(1373),
    [aux_sym_preproc_def_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token2] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1373),
    [aux_sym_preproc_else_token1] = ACTIONS(1373),
    [aux_sym_preproc_elif_token1] = ACTIONS(1373),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1373),
    [sym_preproc_directive] = ACTIONS(1373),
    [anon_sym_LPAREN2] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_TILDE] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_subroutine] = ACTIONS(1373),
    [anon_sym_invariant] = ACTIONS(1373),
    [anon_sym_precise] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_in] = ACTIONS(1373),
    [anon_sym_out] = ACTIONS(1373),
    [anon_sym_inout] = ACTIONS(1373),
    [anon_sym_uniform] = ACTIONS(1373),
    [anon_sym_shared] = ACTIONS(1373),
    [anon_sym_attribute] = ACTIONS(1373),
    [anon_sym_varying] = ACTIONS(1373),
    [anon_sym_buffer] = ACTIONS(1373),
    [anon_sym_coherent] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_writeonly] = ACTIONS(1373),
    [anon_sym_precision] = ACTIONS(1373),
    [anon_sym_highp] = ACTIONS(1373),
    [anon_sym_mediump] = ACTIONS(1373),
    [anon_sym_lowp] = ACTIONS(1373),
    [anon_sym_centroid] = ACTIONS(1373),
    [anon_sym_sample] = ACTIONS(1373),
    [anon_sym_patch] = ACTIONS(1373),
    [anon_sym_smooth] = ACTIONS(1373),
    [anon_sym_flat] = ACTIONS(1373),
    [anon_sym_noperspective] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1373),
    [anon_sym_typedef] = ACTIONS(1373),
    [anon_sym_extern] = ACTIONS(1373),
    [anon_sym___attribute__] = ACTIONS(1373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1375),
    [anon_sym___declspec] = ACTIONS(1373),
    [anon_sym___cdecl] = ACTIONS(1373),
    [anon_sym___clrcall] = ACTIONS(1373),
    [anon_sym___stdcall] = ACTIONS(1373),
    [anon_sym___fastcall] = ACTIONS(1373),
    [anon_sym___thiscall] = ACTIONS(1373),
    [anon_sym___vectorcall] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1375),
    [anon_sym_signed] = ACTIONS(1373),
    [anon_sym_unsigned] = ACTIONS(1373),
    [anon_sym_long] = ACTIONS(1373),
    [anon_sym_short] = ACTIONS(1373),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_auto] = ACTIONS(1373),
    [anon_sym_register] = ACTIONS(1373),
    [anon_sym_inline] = ACTIONS(1373),
    [anon_sym___inline] = ACTIONS(1373),
    [anon_sym___inline__] = ACTIONS(1373),
    [anon_sym___forceinline] = ACTIONS(1373),
    [anon_sym_thread_local] = ACTIONS(1373),
    [anon_sym___thread] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_constexpr] = ACTIONS(1373),
    [anon_sym_volatile] = ACTIONS(1373),
    [anon_sym_restrict] = ACTIONS(1373),
    [anon_sym___restrict__] = ACTIONS(1373),
    [anon_sym__Atomic] = ACTIONS(1373),
    [anon_sym__Noreturn] = ACTIONS(1373),
    [anon_sym_noreturn] = ACTIONS(1373),
    [anon_sym_alignas] = ACTIONS(1373),
    [anon_sym__Alignas] = ACTIONS(1373),
    [sym_primitive_type] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1373),
    [anon_sym_union] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_goto] = ACTIONS(1373),
    [anon_sym___try] = ACTIONS(1373),
    [anon_sym___leave] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1375),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1373),
    [anon_sym___alignof] = ACTIONS(1373),
    [anon_sym__alignof] = ACTIONS(1373),
    [anon_sym_alignof] = ACTIONS(1373),
    [anon_sym__Alignof] = ACTIONS(1373),
    [anon_sym_offsetof] = ACTIONS(1373),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1373),
    [anon_sym___asm__] = ACTIONS(1373),
    [sym_number_literal] = ACTIONS(1375),
    [anon_sym_L_SQUOTE] = ACTIONS(1375),
    [anon_sym_u_SQUOTE] = ACTIONS(1375),
    [anon_sym_U_SQUOTE] = ACTIONS(1375),
    [anon_sym_u8_SQUOTE] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(1375),
    [anon_sym_L_DQUOTE] = ACTIONS(1375),
    [anon_sym_u_DQUOTE] = ACTIONS(1375),
    [anon_sym_U_DQUOTE] = ACTIONS(1375),
    [anon_sym_u8_DQUOTE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [anon_sym_NULL] = ACTIONS(1373),
    [anon_sym_nullptr] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1373),
    [anon_sym_hitAttributeEXT] = ACTIONS(1373),
    [anon_sym_callableDataEXT] = ACTIONS(1373),
    [anon_sym_callableDataInEXT] = ACTIONS(1373),
    [anon_sym_shaderRecordEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadNV] = ACTIONS(1373),
    [anon_sym_rayPayloadInNV] = ACTIONS(1373),
    [anon_sym_hitAttributeNV] = ACTIONS(1373),
    [anon_sym_callableDataNV] = ACTIONS(1373),
    [anon_sym_callableDataInNV] = ACTIONS(1373),
    [anon_sym_shaderRecordNV] = ACTIONS(1373),
    [anon_sym_layout] = ACTIONS(1373),
  },
  [122] = {
    [sym_identifier] = ACTIONS(1377),
    [aux_sym_preproc_include_token1] = ACTIONS(1377),
    [aux_sym_preproc_def_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token2] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1377),
    [aux_sym_preproc_else_token1] = ACTIONS(1377),
    [aux_sym_preproc_elif_token1] = ACTIONS(1377),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1377),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1377),
    [sym_preproc_directive] = ACTIONS(1377),
    [anon_sym_LPAREN2] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_subroutine] = ACTIONS(1377),
    [anon_sym_invariant] = ACTIONS(1377),
    [anon_sym_precise] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_in] = ACTIONS(1377),
    [anon_sym_out] = ACTIONS(1377),
    [anon_sym_inout] = ACTIONS(1377),
    [anon_sym_uniform] = ACTIONS(1377),
    [anon_sym_shared] = ACTIONS(1377),
    [anon_sym_attribute] = ACTIONS(1377),
    [anon_sym_varying] = ACTIONS(1377),
    [anon_sym_buffer] = ACTIONS(1377),
    [anon_sym_coherent] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_writeonly] = ACTIONS(1377),
    [anon_sym_precision] = ACTIONS(1377),
    [anon_sym_highp] = ACTIONS(1377),
    [anon_sym_mediump] = ACTIONS(1377),
    [anon_sym_lowp] = ACTIONS(1377),
    [anon_sym_centroid] = ACTIONS(1377),
    [anon_sym_sample] = ACTIONS(1377),
    [anon_sym_patch] = ACTIONS(1377),
    [anon_sym_smooth] = ACTIONS(1377),
    [anon_sym_flat] = ACTIONS(1377),
    [anon_sym_noperspective] = ACTIONS(1377),
    [anon_sym___extension__] = ACTIONS(1377),
    [anon_sym_typedef] = ACTIONS(1377),
    [anon_sym_extern] = ACTIONS(1377),
    [anon_sym___attribute__] = ACTIONS(1377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1379),
    [anon_sym___declspec] = ACTIONS(1377),
    [anon_sym___cdecl] = ACTIONS(1377),
    [anon_sym___clrcall] = ACTIONS(1377),
    [anon_sym___stdcall] = ACTIONS(1377),
    [anon_sym___fastcall] = ACTIONS(1377),
    [anon_sym___thiscall] = ACTIONS(1377),
    [anon_sym___vectorcall] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_signed] = ACTIONS(1377),
    [anon_sym_unsigned] = ACTIONS(1377),
    [anon_sym_long] = ACTIONS(1377),
    [anon_sym_short] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_auto] = ACTIONS(1377),
    [anon_sym_register] = ACTIONS(1377),
    [anon_sym_inline] = ACTIONS(1377),
    [anon_sym___inline] = ACTIONS(1377),
    [anon_sym___inline__] = ACTIONS(1377),
    [anon_sym___forceinline] = ACTIONS(1377),
    [anon_sym_thread_local] = ACTIONS(1377),
    [anon_sym___thread] = ACTIONS(1377),
    [anon_sym_const] = ACTIONS(1377),
    [anon_sym_constexpr] = ACTIONS(1377),
    [anon_sym_volatile] = ACTIONS(1377),
    [anon_sym_restrict] = ACTIONS(1377),
    [anon_sym___restrict__] = ACTIONS(1377),
    [anon_sym__Atomic] = ACTIONS(1377),
    [anon_sym__Noreturn] = ACTIONS(1377),
    [anon_sym_noreturn] = ACTIONS(1377),
    [anon_sym_alignas] = ACTIONS(1377),
    [anon_sym__Alignas] = ACTIONS(1377),
    [sym_primitive_type] = ACTIONS(1377),
    [anon_sym_enum] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1377),
    [anon_sym_union] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1377),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1377),
    [anon_sym_default] = ACTIONS(1377),
    [anon_sym_while] = ACTIONS(1377),
    [anon_sym_do] = ACTIONS(1377),
    [anon_sym_for] = ACTIONS(1377),
    [anon_sym_return] = ACTIONS(1377),
    [anon_sym_break] = ACTIONS(1377),
    [anon_sym_continue] = ACTIONS(1377),
    [anon_sym_goto] = ACTIONS(1377),
    [anon_sym___try] = ACTIONS(1377),
    [anon_sym___leave] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_sizeof] = ACTIONS(1377),
    [anon_sym___alignof__] = ACTIONS(1377),
    [anon_sym___alignof] = ACTIONS(1377),
    [anon_sym__alignof] = ACTIONS(1377),
    [anon_sym_alignof] = ACTIONS(1377),
    [anon_sym__Alignof] = ACTIONS(1377),
    [anon_sym_offsetof] = ACTIONS(1377),
    [anon_sym__Generic] = ACTIONS(1377),
    [anon_sym_asm] = ACTIONS(1377),
    [anon_sym___asm__] = ACTIONS(1377),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1379),
    [anon_sym_u_SQUOTE] = ACTIONS(1379),
    [anon_sym_U_SQUOTE] = ACTIONS(1379),
    [anon_sym_u8_SQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_L_DQUOTE] = ACTIONS(1379),
    [anon_sym_u_DQUOTE] = ACTIONS(1379),
    [anon_sym_U_DQUOTE] = ACTIONS(1379),
    [anon_sym_u8_DQUOTE] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [anon_sym_NULL] = ACTIONS(1377),
    [anon_sym_nullptr] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1377),
    [anon_sym_hitAttributeEXT] = ACTIONS(1377),
    [anon_sym_callableDataEXT] = ACTIONS(1377),
    [anon_sym_callableDataInEXT] = ACTIONS(1377),
    [anon_sym_shaderRecordEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadNV] = ACTIONS(1377),
    [anon_sym_rayPayloadInNV] = ACTIONS(1377),
    [anon_sym_hitAttributeNV] = ACTIONS(1377),
    [anon_sym_callableDataNV] = ACTIONS(1377),
    [anon_sym_callableDataInNV] = ACTIONS(1377),
    [anon_sym_shaderRecordNV] = ACTIONS(1377),
    [anon_sym_layout] = ACTIONS(1377),
  },
  [123] = {
    [sym_identifier] = ACTIONS(1381),
    [aux_sym_preproc_include_token1] = ACTIONS(1381),
    [aux_sym_preproc_def_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token2] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1381),
    [aux_sym_preproc_else_token1] = ACTIONS(1381),
    [aux_sym_preproc_elif_token1] = ACTIONS(1381),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1381),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1381),
    [sym_preproc_directive] = ACTIONS(1381),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_subroutine] = ACTIONS(1381),
    [anon_sym_invariant] = ACTIONS(1381),
    [anon_sym_precise] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_out] = ACTIONS(1381),
    [anon_sym_inout] = ACTIONS(1381),
    [anon_sym_uniform] = ACTIONS(1381),
    [anon_sym_shared] = ACTIONS(1381),
    [anon_sym_attribute] = ACTIONS(1381),
    [anon_sym_varying] = ACTIONS(1381),
    [anon_sym_buffer] = ACTIONS(1381),
    [anon_sym_coherent] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_writeonly] = ACTIONS(1381),
    [anon_sym_precision] = ACTIONS(1381),
    [anon_sym_highp] = ACTIONS(1381),
    [anon_sym_mediump] = ACTIONS(1381),
    [anon_sym_lowp] = ACTIONS(1381),
    [anon_sym_centroid] = ACTIONS(1381),
    [anon_sym_sample] = ACTIONS(1381),
    [anon_sym_patch] = ACTIONS(1381),
    [anon_sym_smooth] = ACTIONS(1381),
    [anon_sym_flat] = ACTIONS(1381),
    [anon_sym_noperspective] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1381),
    [anon_sym_typedef] = ACTIONS(1381),
    [anon_sym_extern] = ACTIONS(1381),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1383),
    [anon_sym___declspec] = ACTIONS(1381),
    [anon_sym___cdecl] = ACTIONS(1381),
    [anon_sym___clrcall] = ACTIONS(1381),
    [anon_sym___stdcall] = ACTIONS(1381),
    [anon_sym___fastcall] = ACTIONS(1381),
    [anon_sym___thiscall] = ACTIONS(1381),
    [anon_sym___vectorcall] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_signed] = ACTIONS(1381),
    [anon_sym_unsigned] = ACTIONS(1381),
    [anon_sym_long] = ACTIONS(1381),
    [anon_sym_short] = ACTIONS(1381),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_auto] = ACTIONS(1381),
    [anon_sym_register] = ACTIONS(1381),
    [anon_sym_inline] = ACTIONS(1381),
    [anon_sym___inline] = ACTIONS(1381),
    [anon_sym___inline__] = ACTIONS(1381),
    [anon_sym___forceinline] = ACTIONS(1381),
    [anon_sym_thread_local] = ACTIONS(1381),
    [anon_sym___thread] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym___restrict__] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym__Noreturn] = ACTIONS(1381),
    [anon_sym_noreturn] = ACTIONS(1381),
    [anon_sym_alignas] = ACTIONS(1381),
    [anon_sym__Alignas] = ACTIONS(1381),
    [sym_primitive_type] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1381),
    [anon_sym_union] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_goto] = ACTIONS(1381),
    [anon_sym___try] = ACTIONS(1381),
    [anon_sym___leave] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1381),
    [anon_sym___alignof__] = ACTIONS(1381),
    [anon_sym___alignof] = ACTIONS(1381),
    [anon_sym__alignof] = ACTIONS(1381),
    [anon_sym_alignof] = ACTIONS(1381),
    [anon_sym__Alignof] = ACTIONS(1381),
    [anon_sym_offsetof] = ACTIONS(1381),
    [anon_sym__Generic] = ACTIONS(1381),
    [anon_sym_asm] = ACTIONS(1381),
    [anon_sym___asm__] = ACTIONS(1381),
    [sym_number_literal] = ACTIONS(1383),
    [anon_sym_L_SQUOTE] = ACTIONS(1383),
    [anon_sym_u_SQUOTE] = ACTIONS(1383),
    [anon_sym_U_SQUOTE] = ACTIONS(1383),
    [anon_sym_u8_SQUOTE] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1383),
    [anon_sym_L_DQUOTE] = ACTIONS(1383),
    [anon_sym_u_DQUOTE] = ACTIONS(1383),
    [anon_sym_U_DQUOTE] = ACTIONS(1383),
    [anon_sym_u8_DQUOTE] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1383),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [anon_sym_NULL] = ACTIONS(1381),
    [anon_sym_nullptr] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1381),
    [anon_sym_hitAttributeEXT] = ACTIONS(1381),
    [anon_sym_callableDataEXT] = ACTIONS(1381),
    [anon_sym_callableDataInEXT] = ACTIONS(1381),
    [anon_sym_shaderRecordEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadNV] = ACTIONS(1381),
    [anon_sym_rayPayloadInNV] = ACTIONS(1381),
    [anon_sym_hitAttributeNV] = ACTIONS(1381),
    [anon_sym_callableDataNV] = ACTIONS(1381),
    [anon_sym_callableDataInNV] = ACTIONS(1381),
    [anon_sym_shaderRecordNV] = ACTIONS(1381),
    [anon_sym_layout] = ACTIONS(1381),
  },
  [124] = {
    [sym_identifier] = ACTIONS(1385),
    [aux_sym_preproc_include_token1] = ACTIONS(1385),
    [aux_sym_preproc_def_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token2] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1385),
    [aux_sym_preproc_else_token1] = ACTIONS(1385),
    [aux_sym_preproc_elif_token1] = ACTIONS(1385),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1385),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_LPAREN2] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_subroutine] = ACTIONS(1385),
    [anon_sym_invariant] = ACTIONS(1385),
    [anon_sym_precise] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1385),
    [anon_sym_out] = ACTIONS(1385),
    [anon_sym_inout] = ACTIONS(1385),
    [anon_sym_uniform] = ACTIONS(1385),
    [anon_sym_shared] = ACTIONS(1385),
    [anon_sym_attribute] = ACTIONS(1385),
    [anon_sym_varying] = ACTIONS(1385),
    [anon_sym_buffer] = ACTIONS(1385),
    [anon_sym_coherent] = ACTIONS(1385),
    [anon_sym_readonly] = ACTIONS(1385),
    [anon_sym_writeonly] = ACTIONS(1385),
    [anon_sym_precision] = ACTIONS(1385),
    [anon_sym_highp] = ACTIONS(1385),
    [anon_sym_mediump] = ACTIONS(1385),
    [anon_sym_lowp] = ACTIONS(1385),
    [anon_sym_centroid] = ACTIONS(1385),
    [anon_sym_sample] = ACTIONS(1385),
    [anon_sym_patch] = ACTIONS(1385),
    [anon_sym_smooth] = ACTIONS(1385),
    [anon_sym_flat] = ACTIONS(1385),
    [anon_sym_noperspective] = ACTIONS(1385),
    [anon_sym___extension__] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym___attribute__] = ACTIONS(1385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1387),
    [anon_sym___declspec] = ACTIONS(1385),
    [anon_sym___cdecl] = ACTIONS(1385),
    [anon_sym___clrcall] = ACTIONS(1385),
    [anon_sym___stdcall] = ACTIONS(1385),
    [anon_sym___fastcall] = ACTIONS(1385),
    [anon_sym___thiscall] = ACTIONS(1385),
    [anon_sym___vectorcall] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_signed] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym___inline] = ACTIONS(1385),
    [anon_sym___inline__] = ACTIONS(1385),
    [anon_sym___forceinline] = ACTIONS(1385),
    [anon_sym_thread_local] = ACTIONS(1385),
    [anon_sym___thread] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_constexpr] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym___restrict__] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym__Noreturn] = ACTIONS(1385),
    [anon_sym_noreturn] = ACTIONS(1385),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1385),
    [anon_sym_else] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1385),
    [anon_sym_case] = ACTIONS(1385),
    [anon_sym_default] = ACTIONS(1385),
    [anon_sym_while] = ACTIONS(1385),
    [anon_sym_do] = ACTIONS(1385),
    [anon_sym_for] = ACTIONS(1385),
    [anon_sym_return] = ACTIONS(1385),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_continue] = ACTIONS(1385),
    [anon_sym_goto] = ACTIONS(1385),
    [anon_sym___try] = ACTIONS(1385),
    [anon_sym___leave] = ACTIONS(1385),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym___alignof__] = ACTIONS(1385),
    [anon_sym___alignof] = ACTIONS(1385),
    [anon_sym__alignof] = ACTIONS(1385),
    [anon_sym_alignof] = ACTIONS(1385),
    [anon_sym__Alignof] = ACTIONS(1385),
    [anon_sym_offsetof] = ACTIONS(1385),
    [anon_sym__Generic] = ACTIONS(1385),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1387),
    [anon_sym_L_SQUOTE] = ACTIONS(1387),
    [anon_sym_u_SQUOTE] = ACTIONS(1387),
    [anon_sym_U_SQUOTE] = ACTIONS(1387),
    [anon_sym_u8_SQUOTE] = ACTIONS(1387),
    [anon_sym_SQUOTE] = ACTIONS(1387),
    [anon_sym_L_DQUOTE] = ACTIONS(1387),
    [anon_sym_u_DQUOTE] = ACTIONS(1387),
    [anon_sym_U_DQUOTE] = ACTIONS(1387),
    [anon_sym_u8_DQUOTE] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1387),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [anon_sym_NULL] = ACTIONS(1385),
    [anon_sym_nullptr] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1385),
    [anon_sym_hitAttributeEXT] = ACTIONS(1385),
    [anon_sym_callableDataEXT] = ACTIONS(1385),
    [anon_sym_callableDataInEXT] = ACTIONS(1385),
    [anon_sym_shaderRecordEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadNV] = ACTIONS(1385),
    [anon_sym_rayPayloadInNV] = ACTIONS(1385),
    [anon_sym_hitAttributeNV] = ACTIONS(1385),
    [anon_sym_callableDataNV] = ACTIONS(1385),
    [anon_sym_callableDataInNV] = ACTIONS(1385),
    [anon_sym_shaderRecordNV] = ACTIONS(1385),
    [anon_sym_layout] = ACTIONS(1385),
  },
  [125] = {
    [sym_identifier] = ACTIONS(1389),
    [aux_sym_preproc_include_token1] = ACTIONS(1389),
    [aux_sym_preproc_def_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token2] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1389),
    [aux_sym_preproc_else_token1] = ACTIONS(1389),
    [aux_sym_preproc_elif_token1] = ACTIONS(1389),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_LPAREN2] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1389),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_subroutine] = ACTIONS(1389),
    [anon_sym_invariant] = ACTIONS(1389),
    [anon_sym_precise] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_out] = ACTIONS(1389),
    [anon_sym_inout] = ACTIONS(1389),
    [anon_sym_uniform] = ACTIONS(1389),
    [anon_sym_shared] = ACTIONS(1389),
    [anon_sym_attribute] = ACTIONS(1389),
    [anon_sym_varying] = ACTIONS(1389),
    [anon_sym_buffer] = ACTIONS(1389),
    [anon_sym_coherent] = ACTIONS(1389),
    [anon_sym_readonly] = ACTIONS(1389),
    [anon_sym_writeonly] = ACTIONS(1389),
    [anon_sym_precision] = ACTIONS(1389),
    [anon_sym_highp] = ACTIONS(1389),
    [anon_sym_mediump] = ACTIONS(1389),
    [anon_sym_lowp] = ACTIONS(1389),
    [anon_sym_centroid] = ACTIONS(1389),
    [anon_sym_sample] = ACTIONS(1389),
    [anon_sym_patch] = ACTIONS(1389),
    [anon_sym_smooth] = ACTIONS(1389),
    [anon_sym_flat] = ACTIONS(1389),
    [anon_sym_noperspective] = ACTIONS(1389),
    [anon_sym___extension__] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym___attribute__] = ACTIONS(1389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1391),
    [anon_sym___declspec] = ACTIONS(1389),
    [anon_sym___cdecl] = ACTIONS(1389),
    [anon_sym___clrcall] = ACTIONS(1389),
    [anon_sym___stdcall] = ACTIONS(1389),
    [anon_sym___fastcall] = ACTIONS(1389),
    [anon_sym___thiscall] = ACTIONS(1389),
    [anon_sym___vectorcall] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_signed] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym___inline] = ACTIONS(1389),
    [anon_sym___inline__] = ACTIONS(1389),
    [anon_sym___forceinline] = ACTIONS(1389),
    [anon_sym_thread_local] = ACTIONS(1389),
    [anon_sym___thread] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_constexpr] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym___restrict__] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym__Noreturn] = ACTIONS(1389),
    [anon_sym_noreturn] = ACTIONS(1389),
    [anon_sym_alignas] = ACTIONS(1389),
    [anon_sym__Alignas] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1389),
    [anon_sym_case] = ACTIONS(1389),
    [anon_sym_default] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(1389),
    [anon_sym_for] = ACTIONS(1389),
    [anon_sym_return] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(1389),
    [anon_sym_continue] = ACTIONS(1389),
    [anon_sym_goto] = ACTIONS(1389),
    [anon_sym___try] = ACTIONS(1389),
    [anon_sym___leave] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_sizeof] = ACTIONS(1389),
    [anon_sym___alignof__] = ACTIONS(1389),
    [anon_sym___alignof] = ACTIONS(1389),
    [anon_sym__alignof] = ACTIONS(1389),
    [anon_sym_alignof] = ACTIONS(1389),
    [anon_sym__Alignof] = ACTIONS(1389),
    [anon_sym_offsetof] = ACTIONS(1389),
    [anon_sym__Generic] = ACTIONS(1389),
    [anon_sym_asm] = ACTIONS(1389),
    [anon_sym___asm__] = ACTIONS(1389),
    [sym_number_literal] = ACTIONS(1391),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1391),
    [anon_sym_u_DQUOTE] = ACTIONS(1391),
    [anon_sym_U_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8_DQUOTE] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [anon_sym_NULL] = ACTIONS(1389),
    [anon_sym_nullptr] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1389),
    [anon_sym_hitAttributeEXT] = ACTIONS(1389),
    [anon_sym_callableDataEXT] = ACTIONS(1389),
    [anon_sym_callableDataInEXT] = ACTIONS(1389),
    [anon_sym_shaderRecordEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadNV] = ACTIONS(1389),
    [anon_sym_rayPayloadInNV] = ACTIONS(1389),
    [anon_sym_hitAttributeNV] = ACTIONS(1389),
    [anon_sym_callableDataNV] = ACTIONS(1389),
    [anon_sym_callableDataInNV] = ACTIONS(1389),
    [anon_sym_shaderRecordNV] = ACTIONS(1389),
    [anon_sym_layout] = ACTIONS(1389),
  },
  [126] = {
    [sym_identifier] = ACTIONS(1393),
    [aux_sym_preproc_include_token1] = ACTIONS(1393),
    [aux_sym_preproc_def_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token2] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1393),
    [aux_sym_preproc_else_token1] = ACTIONS(1393),
    [aux_sym_preproc_elif_token1] = ACTIONS(1393),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1393),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_LPAREN2] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1393),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_subroutine] = ACTIONS(1393),
    [anon_sym_invariant] = ACTIONS(1393),
    [anon_sym_precise] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1393),
    [anon_sym_out] = ACTIONS(1393),
    [anon_sym_inout] = ACTIONS(1393),
    [anon_sym_uniform] = ACTIONS(1393),
    [anon_sym_shared] = ACTIONS(1393),
    [anon_sym_attribute] = ACTIONS(1393),
    [anon_sym_varying] = ACTIONS(1393),
    [anon_sym_buffer] = ACTIONS(1393),
    [anon_sym_coherent] = ACTIONS(1393),
    [anon_sym_readonly] = ACTIONS(1393),
    [anon_sym_writeonly] = ACTIONS(1393),
    [anon_sym_precision] = ACTIONS(1393),
    [anon_sym_highp] = ACTIONS(1393),
    [anon_sym_mediump] = ACTIONS(1393),
    [anon_sym_lowp] = ACTIONS(1393),
    [anon_sym_centroid] = ACTIONS(1393),
    [anon_sym_sample] = ACTIONS(1393),
    [anon_sym_patch] = ACTIONS(1393),
    [anon_sym_smooth] = ACTIONS(1393),
    [anon_sym_flat] = ACTIONS(1393),
    [anon_sym_noperspective] = ACTIONS(1393),
    [anon_sym___extension__] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym___attribute__] = ACTIONS(1393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1395),
    [anon_sym___declspec] = ACTIONS(1393),
    [anon_sym___cdecl] = ACTIONS(1393),
    [anon_sym___clrcall] = ACTIONS(1393),
    [anon_sym___stdcall] = ACTIONS(1393),
    [anon_sym___fastcall] = ACTIONS(1393),
    [anon_sym___thiscall] = ACTIONS(1393),
    [anon_sym___vectorcall] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(1395),
    [anon_sym_signed] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym___inline] = ACTIONS(1393),
    [anon_sym___inline__] = ACTIONS(1393),
    [anon_sym___forceinline] = ACTIONS(1393),
    [anon_sym_thread_local] = ACTIONS(1393),
    [anon_sym___thread] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_constexpr] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym___restrict__] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym__Noreturn] = ACTIONS(1393),
    [anon_sym_noreturn] = ACTIONS(1393),
    [anon_sym_alignas] = ACTIONS(1393),
    [anon_sym__Alignas] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1393),
    [anon_sym_do] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_return] = ACTIONS(1393),
    [anon_sym_break] = ACTIONS(1393),
    [anon_sym_continue] = ACTIONS(1393),
    [anon_sym_goto] = ACTIONS(1393),
    [anon_sym___try] = ACTIONS(1393),
    [anon_sym___leave] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1395),
    [anon_sym_sizeof] = ACTIONS(1393),
    [anon_sym___alignof__] = ACTIONS(1393),
    [anon_sym___alignof] = ACTIONS(1393),
    [anon_sym__alignof] = ACTIONS(1393),
    [anon_sym_alignof] = ACTIONS(1393),
    [anon_sym__Alignof] = ACTIONS(1393),
    [anon_sym_offsetof] = ACTIONS(1393),
    [anon_sym__Generic] = ACTIONS(1393),
    [anon_sym_asm] = ACTIONS(1393),
    [anon_sym___asm__] = ACTIONS(1393),
    [sym_number_literal] = ACTIONS(1395),
    [anon_sym_L_SQUOTE] = ACTIONS(1395),
    [anon_sym_u_SQUOTE] = ACTIONS(1395),
    [anon_sym_U_SQUOTE] = ACTIONS(1395),
    [anon_sym_u8_SQUOTE] = ACTIONS(1395),
    [anon_sym_SQUOTE] = ACTIONS(1395),
    [anon_sym_L_DQUOTE] = ACTIONS(1395),
    [anon_sym_u_DQUOTE] = ACTIONS(1395),
    [anon_sym_U_DQUOTE] = ACTIONS(1395),
    [anon_sym_u8_DQUOTE] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [anon_sym_NULL] = ACTIONS(1393),
    [anon_sym_nullptr] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1393),
    [anon_sym_hitAttributeEXT] = ACTIONS(1393),
    [anon_sym_callableDataEXT] = ACTIONS(1393),
    [anon_sym_callableDataInEXT] = ACTIONS(1393),
    [anon_sym_shaderRecordEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadNV] = ACTIONS(1393),
    [anon_sym_rayPayloadInNV] = ACTIONS(1393),
    [anon_sym_hitAttributeNV] = ACTIONS(1393),
    [anon_sym_callableDataNV] = ACTIONS(1393),
    [anon_sym_callableDataInNV] = ACTIONS(1393),
    [anon_sym_shaderRecordNV] = ACTIONS(1393),
    [anon_sym_layout] = ACTIONS(1393),
  },
  [127] = {
    [sym_identifier] = ACTIONS(1397),
    [aux_sym_preproc_include_token1] = ACTIONS(1397),
    [aux_sym_preproc_def_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token2] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1397),
    [aux_sym_preproc_else_token1] = ACTIONS(1397),
    [aux_sym_preproc_elif_token1] = ACTIONS(1397),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1397),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1397),
    [sym_preproc_directive] = ACTIONS(1397),
    [anon_sym_LPAREN2] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_subroutine] = ACTIONS(1397),
    [anon_sym_invariant] = ACTIONS(1397),
    [anon_sym_precise] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_out] = ACTIONS(1397),
    [anon_sym_inout] = ACTIONS(1397),
    [anon_sym_uniform] = ACTIONS(1397),
    [anon_sym_shared] = ACTIONS(1397),
    [anon_sym_attribute] = ACTIONS(1397),
    [anon_sym_varying] = ACTIONS(1397),
    [anon_sym_buffer] = ACTIONS(1397),
    [anon_sym_coherent] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_writeonly] = ACTIONS(1397),
    [anon_sym_precision] = ACTIONS(1397),
    [anon_sym_highp] = ACTIONS(1397),
    [anon_sym_mediump] = ACTIONS(1397),
    [anon_sym_lowp] = ACTIONS(1397),
    [anon_sym_centroid] = ACTIONS(1397),
    [anon_sym_sample] = ACTIONS(1397),
    [anon_sym_patch] = ACTIONS(1397),
    [anon_sym_smooth] = ACTIONS(1397),
    [anon_sym_flat] = ACTIONS(1397),
    [anon_sym_noperspective] = ACTIONS(1397),
    [anon_sym___extension__] = ACTIONS(1397),
    [anon_sym_typedef] = ACTIONS(1397),
    [anon_sym_extern] = ACTIONS(1397),
    [anon_sym___attribute__] = ACTIONS(1397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1399),
    [anon_sym___declspec] = ACTIONS(1397),
    [anon_sym___cdecl] = ACTIONS(1397),
    [anon_sym___clrcall] = ACTIONS(1397),
    [anon_sym___stdcall] = ACTIONS(1397),
    [anon_sym___fastcall] = ACTIONS(1397),
    [anon_sym___thiscall] = ACTIONS(1397),
    [anon_sym___vectorcall] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_signed] = ACTIONS(1397),
    [anon_sym_unsigned] = ACTIONS(1397),
    [anon_sym_long] = ACTIONS(1397),
    [anon_sym_short] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_auto] = ACTIONS(1397),
    [anon_sym_register] = ACTIONS(1397),
    [anon_sym_inline] = ACTIONS(1397),
    [anon_sym___inline] = ACTIONS(1397),
    [anon_sym___inline__] = ACTIONS(1397),
    [anon_sym___forceinline] = ACTIONS(1397),
    [anon_sym_thread_local] = ACTIONS(1397),
    [anon_sym___thread] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_constexpr] = ACTIONS(1397),
    [anon_sym_volatile] = ACTIONS(1397),
    [anon_sym_restrict] = ACTIONS(1397),
    [anon_sym___restrict__] = ACTIONS(1397),
    [anon_sym__Atomic] = ACTIONS(1397),
    [anon_sym__Noreturn] = ACTIONS(1397),
    [anon_sym_noreturn] = ACTIONS(1397),
    [anon_sym_alignas] = ACTIONS(1397),
    [anon_sym__Alignas] = ACTIONS(1397),
    [sym_primitive_type] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_goto] = ACTIONS(1397),
    [anon_sym___try] = ACTIONS(1397),
    [anon_sym___leave] = ACTIONS(1397),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_sizeof] = ACTIONS(1397),
    [anon_sym___alignof__] = ACTIONS(1397),
    [anon_sym___alignof] = ACTIONS(1397),
    [anon_sym__alignof] = ACTIONS(1397),
    [anon_sym_alignof] = ACTIONS(1397),
    [anon_sym__Alignof] = ACTIONS(1397),
    [anon_sym_offsetof] = ACTIONS(1397),
    [anon_sym__Generic] = ACTIONS(1397),
    [anon_sym_asm] = ACTIONS(1397),
    [anon_sym___asm__] = ACTIONS(1397),
    [sym_number_literal] = ACTIONS(1399),
    [anon_sym_L_SQUOTE] = ACTIONS(1399),
    [anon_sym_u_SQUOTE] = ACTIONS(1399),
    [anon_sym_U_SQUOTE] = ACTIONS(1399),
    [anon_sym_u8_SQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [anon_sym_L_DQUOTE] = ACTIONS(1399),
    [anon_sym_u_DQUOTE] = ACTIONS(1399),
    [anon_sym_U_DQUOTE] = ACTIONS(1399),
    [anon_sym_u8_DQUOTE] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1397),
    [anon_sym_nullptr] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1397),
    [anon_sym_hitAttributeEXT] = ACTIONS(1397),
    [anon_sym_callableDataEXT] = ACTIONS(1397),
    [anon_sym_callableDataInEXT] = ACTIONS(1397),
    [anon_sym_shaderRecordEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadNV] = ACTIONS(1397),
    [anon_sym_rayPayloadInNV] = ACTIONS(1397),
    [anon_sym_hitAttributeNV] = ACTIONS(1397),
    [anon_sym_callableDataNV] = ACTIONS(1397),
    [anon_sym_callableDataInNV] = ACTIONS(1397),
    [anon_sym_shaderRecordNV] = ACTIONS(1397),
    [anon_sym_layout] = ACTIONS(1397),
  },
  [128] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_include_token1] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token2] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [aux_sym_preproc_else_token1] = ACTIONS(1401),
    [aux_sym_preproc_elif_token1] = ACTIONS(1401),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_LPAREN2] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_typedef] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym___cdecl] = ACTIONS(1401),
    [anon_sym___clrcall] = ACTIONS(1401),
    [anon_sym___stdcall] = ACTIONS(1401),
    [anon_sym___fastcall] = ACTIONS(1401),
    [anon_sym___thiscall] = ACTIONS(1401),
    [anon_sym___vectorcall] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_goto] = ACTIONS(1401),
    [anon_sym___try] = ACTIONS(1401),
    [anon_sym___leave] = ACTIONS(1401),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_sizeof] = ACTIONS(1401),
    [anon_sym___alignof__] = ACTIONS(1401),
    [anon_sym___alignof] = ACTIONS(1401),
    [anon_sym__alignof] = ACTIONS(1401),
    [anon_sym_alignof] = ACTIONS(1401),
    [anon_sym__Alignof] = ACTIONS(1401),
    [anon_sym_offsetof] = ACTIONS(1401),
    [anon_sym__Generic] = ACTIONS(1401),
    [anon_sym_asm] = ACTIONS(1401),
    [anon_sym___asm__] = ACTIONS(1401),
    [sym_number_literal] = ACTIONS(1403),
    [anon_sym_L_SQUOTE] = ACTIONS(1403),
    [anon_sym_u_SQUOTE] = ACTIONS(1403),
    [anon_sym_U_SQUOTE] = ACTIONS(1403),
    [anon_sym_u8_SQUOTE] = ACTIONS(1403),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_L_DQUOTE] = ACTIONS(1403),
    [anon_sym_u_DQUOTE] = ACTIONS(1403),
    [anon_sym_U_DQUOTE] = ACTIONS(1403),
    [anon_sym_u8_DQUOTE] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [anon_sym_NULL] = ACTIONS(1401),
    [anon_sym_nullptr] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [129] = {
    [sym_identifier] = ACTIONS(1405),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token2] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [aux_sym_preproc_else_token1] = ACTIONS(1405),
    [aux_sym_preproc_elif_token1] = ACTIONS(1405),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_subroutine] = ACTIONS(1405),
    [anon_sym_invariant] = ACTIONS(1405),
    [anon_sym_precise] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_in] = ACTIONS(1405),
    [anon_sym_out] = ACTIONS(1405),
    [anon_sym_inout] = ACTIONS(1405),
    [anon_sym_uniform] = ACTIONS(1405),
    [anon_sym_shared] = ACTIONS(1405),
    [anon_sym_attribute] = ACTIONS(1405),
    [anon_sym_varying] = ACTIONS(1405),
    [anon_sym_buffer] = ACTIONS(1405),
    [anon_sym_coherent] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(1405),
    [anon_sym_writeonly] = ACTIONS(1405),
    [anon_sym_precision] = ACTIONS(1405),
    [anon_sym_highp] = ACTIONS(1405),
    [anon_sym_mediump] = ACTIONS(1405),
    [anon_sym_lowp] = ACTIONS(1405),
    [anon_sym_centroid] = ACTIONS(1405),
    [anon_sym_sample] = ACTIONS(1405),
    [anon_sym_patch] = ACTIONS(1405),
    [anon_sym_smooth] = ACTIONS(1405),
    [anon_sym_flat] = ACTIONS(1405),
    [anon_sym_noperspective] = ACTIONS(1405),
    [anon_sym___extension__] = ACTIONS(1405),
    [anon_sym_typedef] = ACTIONS(1405),
    [anon_sym_extern] = ACTIONS(1405),
    [anon_sym___attribute__] = ACTIONS(1405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1407),
    [anon_sym___declspec] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_signed] = ACTIONS(1405),
    [anon_sym_unsigned] = ACTIONS(1405),
    [anon_sym_long] = ACTIONS(1405),
    [anon_sym_short] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_auto] = ACTIONS(1405),
    [anon_sym_register] = ACTIONS(1405),
    [anon_sym_inline] = ACTIONS(1405),
    [anon_sym___inline] = ACTIONS(1405),
    [anon_sym___inline__] = ACTIONS(1405),
    [anon_sym___forceinline] = ACTIONS(1405),
    [anon_sym_thread_local] = ACTIONS(1405),
    [anon_sym___thread] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1405),
    [anon_sym_constexpr] = ACTIONS(1405),
    [anon_sym_volatile] = ACTIONS(1405),
    [anon_sym_restrict] = ACTIONS(1405),
    [anon_sym___restrict__] = ACTIONS(1405),
    [anon_sym__Atomic] = ACTIONS(1405),
    [anon_sym__Noreturn] = ACTIONS(1405),
    [anon_sym_noreturn] = ACTIONS(1405),
    [anon_sym_alignas] = ACTIONS(1405),
    [anon_sym__Alignas] = ACTIONS(1405),
    [sym_primitive_type] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1405),
    [anon_sym_union] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(1405),
    [anon_sym_for] = ACTIONS(1405),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_break] = ACTIONS(1405),
    [anon_sym_continue] = ACTIONS(1405),
    [anon_sym_goto] = ACTIONS(1405),
    [anon_sym___try] = ACTIONS(1405),
    [anon_sym___leave] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1405),
    [anon_sym___alignof__] = ACTIONS(1405),
    [anon_sym___alignof] = ACTIONS(1405),
    [anon_sym__alignof] = ACTIONS(1405),
    [anon_sym_alignof] = ACTIONS(1405),
    [anon_sym__Alignof] = ACTIONS(1405),
    [anon_sym_offsetof] = ACTIONS(1405),
    [anon_sym__Generic] = ACTIONS(1405),
    [anon_sym_asm] = ACTIONS(1405),
    [anon_sym___asm__] = ACTIONS(1405),
    [sym_number_literal] = ACTIONS(1407),
    [anon_sym_L_SQUOTE] = ACTIONS(1407),
    [anon_sym_u_SQUOTE] = ACTIONS(1407),
    [anon_sym_U_SQUOTE] = ACTIONS(1407),
    [anon_sym_u8_SQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_L_DQUOTE] = ACTIONS(1407),
    [anon_sym_u_DQUOTE] = ACTIONS(1407),
    [anon_sym_U_DQUOTE] = ACTIONS(1407),
    [anon_sym_u8_DQUOTE] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [anon_sym_NULL] = ACTIONS(1405),
    [anon_sym_nullptr] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1405),
    [anon_sym_hitAttributeEXT] = ACTIONS(1405),
    [anon_sym_callableDataEXT] = ACTIONS(1405),
    [anon_sym_callableDataInEXT] = ACTIONS(1405),
    [anon_sym_shaderRecordEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadNV] = ACTIONS(1405),
    [anon_sym_rayPayloadInNV] = ACTIONS(1405),
    [anon_sym_hitAttributeNV] = ACTIONS(1405),
    [anon_sym_callableDataNV] = ACTIONS(1405),
    [anon_sym_callableDataInNV] = ACTIONS(1405),
    [anon_sym_shaderRecordNV] = ACTIONS(1405),
    [anon_sym_layout] = ACTIONS(1405),
  },
  [130] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_include_token1] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token2] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [aux_sym_preproc_else_token1] = ACTIONS(1409),
    [aux_sym_preproc_elif_token1] = ACTIONS(1409),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym___cdecl] = ACTIONS(1409),
    [anon_sym___clrcall] = ACTIONS(1409),
    [anon_sym___stdcall] = ACTIONS(1409),
    [anon_sym___fastcall] = ACTIONS(1409),
    [anon_sym___thiscall] = ACTIONS(1409),
    [anon_sym___vectorcall] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_case] = ACTIONS(1409),
    [anon_sym_default] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_return] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1409),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_goto] = ACTIONS(1409),
    [anon_sym___try] = ACTIONS(1409),
    [anon_sym___leave] = ACTIONS(1409),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_sizeof] = ACTIONS(1409),
    [anon_sym___alignof__] = ACTIONS(1409),
    [anon_sym___alignof] = ACTIONS(1409),
    [anon_sym__alignof] = ACTIONS(1409),
    [anon_sym_alignof] = ACTIONS(1409),
    [anon_sym__Alignof] = ACTIONS(1409),
    [anon_sym_offsetof] = ACTIONS(1409),
    [anon_sym__Generic] = ACTIONS(1409),
    [anon_sym_asm] = ACTIONS(1409),
    [anon_sym___asm__] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1411),
    [anon_sym_L_SQUOTE] = ACTIONS(1411),
    [anon_sym_u_SQUOTE] = ACTIONS(1411),
    [anon_sym_U_SQUOTE] = ACTIONS(1411),
    [anon_sym_u8_SQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [anon_sym_L_DQUOTE] = ACTIONS(1411),
    [anon_sym_u_DQUOTE] = ACTIONS(1411),
    [anon_sym_U_DQUOTE] = ACTIONS(1411),
    [anon_sym_u8_DQUOTE] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [anon_sym_NULL] = ACTIONS(1409),
    [anon_sym_nullptr] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [131] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token2] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [aux_sym_preproc_else_token1] = ACTIONS(1413),
    [aux_sym_preproc_elif_token1] = ACTIONS(1413),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [132] = {
    [sym_identifier] = ACTIONS(1417),
    [aux_sym_preproc_include_token1] = ACTIONS(1417),
    [aux_sym_preproc_def_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token2] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1417),
    [aux_sym_preproc_else_token1] = ACTIONS(1417),
    [aux_sym_preproc_elif_token1] = ACTIONS(1417),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1417),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1417),
    [sym_preproc_directive] = ACTIONS(1417),
    [anon_sym_LPAREN2] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_subroutine] = ACTIONS(1417),
    [anon_sym_invariant] = ACTIONS(1417),
    [anon_sym_precise] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_in] = ACTIONS(1417),
    [anon_sym_out] = ACTIONS(1417),
    [anon_sym_inout] = ACTIONS(1417),
    [anon_sym_uniform] = ACTIONS(1417),
    [anon_sym_shared] = ACTIONS(1417),
    [anon_sym_attribute] = ACTIONS(1417),
    [anon_sym_varying] = ACTIONS(1417),
    [anon_sym_buffer] = ACTIONS(1417),
    [anon_sym_coherent] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_writeonly] = ACTIONS(1417),
    [anon_sym_precision] = ACTIONS(1417),
    [anon_sym_highp] = ACTIONS(1417),
    [anon_sym_mediump] = ACTIONS(1417),
    [anon_sym_lowp] = ACTIONS(1417),
    [anon_sym_centroid] = ACTIONS(1417),
    [anon_sym_sample] = ACTIONS(1417),
    [anon_sym_patch] = ACTIONS(1417),
    [anon_sym_smooth] = ACTIONS(1417),
    [anon_sym_flat] = ACTIONS(1417),
    [anon_sym_noperspective] = ACTIONS(1417),
    [anon_sym___extension__] = ACTIONS(1417),
    [anon_sym_typedef] = ACTIONS(1417),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym___attribute__] = ACTIONS(1417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1419),
    [anon_sym___declspec] = ACTIONS(1417),
    [anon_sym___cdecl] = ACTIONS(1417),
    [anon_sym___clrcall] = ACTIONS(1417),
    [anon_sym___stdcall] = ACTIONS(1417),
    [anon_sym___fastcall] = ACTIONS(1417),
    [anon_sym___thiscall] = ACTIONS(1417),
    [anon_sym___vectorcall] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_signed] = ACTIONS(1417),
    [anon_sym_unsigned] = ACTIONS(1417),
    [anon_sym_long] = ACTIONS(1417),
    [anon_sym_short] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_auto] = ACTIONS(1417),
    [anon_sym_register] = ACTIONS(1417),
    [anon_sym_inline] = ACTIONS(1417),
    [anon_sym___inline] = ACTIONS(1417),
    [anon_sym___inline__] = ACTIONS(1417),
    [anon_sym___forceinline] = ACTIONS(1417),
    [anon_sym_thread_local] = ACTIONS(1417),
    [anon_sym___thread] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_constexpr] = ACTIONS(1417),
    [anon_sym_volatile] = ACTIONS(1417),
    [anon_sym_restrict] = ACTIONS(1417),
    [anon_sym___restrict__] = ACTIONS(1417),
    [anon_sym__Atomic] = ACTIONS(1417),
    [anon_sym__Noreturn] = ACTIONS(1417),
    [anon_sym_noreturn] = ACTIONS(1417),
    [anon_sym_alignas] = ACTIONS(1417),
    [anon_sym__Alignas] = ACTIONS(1417),
    [sym_primitive_type] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_goto] = ACTIONS(1417),
    [anon_sym___try] = ACTIONS(1417),
    [anon_sym___leave] = ACTIONS(1417),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_sizeof] = ACTIONS(1417),
    [anon_sym___alignof__] = ACTIONS(1417),
    [anon_sym___alignof] = ACTIONS(1417),
    [anon_sym__alignof] = ACTIONS(1417),
    [anon_sym_alignof] = ACTIONS(1417),
    [anon_sym__Alignof] = ACTIONS(1417),
    [anon_sym_offsetof] = ACTIONS(1417),
    [anon_sym__Generic] = ACTIONS(1417),
    [anon_sym_asm] = ACTIONS(1417),
    [anon_sym___asm__] = ACTIONS(1417),
    [sym_number_literal] = ACTIONS(1419),
    [anon_sym_L_SQUOTE] = ACTIONS(1419),
    [anon_sym_u_SQUOTE] = ACTIONS(1419),
    [anon_sym_U_SQUOTE] = ACTIONS(1419),
    [anon_sym_u8_SQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [anon_sym_L_DQUOTE] = ACTIONS(1419),
    [anon_sym_u_DQUOTE] = ACTIONS(1419),
    [anon_sym_U_DQUOTE] = ACTIONS(1419),
    [anon_sym_u8_DQUOTE] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [anon_sym_NULL] = ACTIONS(1417),
    [anon_sym_nullptr] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1417),
    [anon_sym_hitAttributeEXT] = ACTIONS(1417),
    [anon_sym_callableDataEXT] = ACTIONS(1417),
    [anon_sym_callableDataInEXT] = ACTIONS(1417),
    [anon_sym_shaderRecordEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadNV] = ACTIONS(1417),
    [anon_sym_rayPayloadInNV] = ACTIONS(1417),
    [anon_sym_hitAttributeNV] = ACTIONS(1417),
    [anon_sym_callableDataNV] = ACTIONS(1417),
    [anon_sym_callableDataInNV] = ACTIONS(1417),
    [anon_sym_shaderRecordNV] = ACTIONS(1417),
    [anon_sym_layout] = ACTIONS(1417),
  },
  [133] = {
    [sym_identifier] = ACTIONS(1421),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token2] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [aux_sym_preproc_else_token1] = ACTIONS(1421),
    [aux_sym_preproc_elif_token1] = ACTIONS(1421),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_subroutine] = ACTIONS(1421),
    [anon_sym_invariant] = ACTIONS(1421),
    [anon_sym_precise] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1421),
    [anon_sym_out] = ACTIONS(1421),
    [anon_sym_inout] = ACTIONS(1421),
    [anon_sym_uniform] = ACTIONS(1421),
    [anon_sym_shared] = ACTIONS(1421),
    [anon_sym_attribute] = ACTIONS(1421),
    [anon_sym_varying] = ACTIONS(1421),
    [anon_sym_buffer] = ACTIONS(1421),
    [anon_sym_coherent] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_writeonly] = ACTIONS(1421),
    [anon_sym_precision] = ACTIONS(1421),
    [anon_sym_highp] = ACTIONS(1421),
    [anon_sym_mediump] = ACTIONS(1421),
    [anon_sym_lowp] = ACTIONS(1421),
    [anon_sym_centroid] = ACTIONS(1421),
    [anon_sym_sample] = ACTIONS(1421),
    [anon_sym_patch] = ACTIONS(1421),
    [anon_sym_smooth] = ACTIONS(1421),
    [anon_sym_flat] = ACTIONS(1421),
    [anon_sym_noperspective] = ACTIONS(1421),
    [anon_sym___extension__] = ACTIONS(1421),
    [anon_sym_typedef] = ACTIONS(1421),
    [anon_sym_extern] = ACTIONS(1421),
    [anon_sym___attribute__] = ACTIONS(1421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1423),
    [anon_sym___declspec] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1423),
    [anon_sym_signed] = ACTIONS(1421),
    [anon_sym_unsigned] = ACTIONS(1421),
    [anon_sym_long] = ACTIONS(1421),
    [anon_sym_short] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_auto] = ACTIONS(1421),
    [anon_sym_register] = ACTIONS(1421),
    [anon_sym_inline] = ACTIONS(1421),
    [anon_sym___inline] = ACTIONS(1421),
    [anon_sym___inline__] = ACTIONS(1421),
    [anon_sym___forceinline] = ACTIONS(1421),
    [anon_sym_thread_local] = ACTIONS(1421),
    [anon_sym___thread] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_constexpr] = ACTIONS(1421),
    [anon_sym_volatile] = ACTIONS(1421),
    [anon_sym_restrict] = ACTIONS(1421),
    [anon_sym___restrict__] = ACTIONS(1421),
    [anon_sym__Atomic] = ACTIONS(1421),
    [anon_sym__Noreturn] = ACTIONS(1421),
    [anon_sym_noreturn] = ACTIONS(1421),
    [anon_sym_alignas] = ACTIONS(1421),
    [anon_sym__Alignas] = ACTIONS(1421),
    [sym_primitive_type] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1421),
    [anon_sym_union] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_goto] = ACTIONS(1421),
    [anon_sym___try] = ACTIONS(1421),
    [anon_sym___leave] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1423),
    [anon_sym_sizeof] = ACTIONS(1421),
    [anon_sym___alignof__] = ACTIONS(1421),
    [anon_sym___alignof] = ACTIONS(1421),
    [anon_sym__alignof] = ACTIONS(1421),
    [anon_sym_alignof] = ACTIONS(1421),
    [anon_sym__Alignof] = ACTIONS(1421),
    [anon_sym_offsetof] = ACTIONS(1421),
    [anon_sym__Generic] = ACTIONS(1421),
    [anon_sym_asm] = ACTIONS(1421),
    [anon_sym___asm__] = ACTIONS(1421),
    [sym_number_literal] = ACTIONS(1423),
    [anon_sym_L_SQUOTE] = ACTIONS(1423),
    [anon_sym_u_SQUOTE] = ACTIONS(1423),
    [anon_sym_U_SQUOTE] = ACTIONS(1423),
    [anon_sym_u8_SQUOTE] = ACTIONS(1423),
    [anon_sym_SQUOTE] = ACTIONS(1423),
    [anon_sym_L_DQUOTE] = ACTIONS(1423),
    [anon_sym_u_DQUOTE] = ACTIONS(1423),
    [anon_sym_U_DQUOTE] = ACTIONS(1423),
    [anon_sym_u8_DQUOTE] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [anon_sym_NULL] = ACTIONS(1421),
    [anon_sym_nullptr] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1421),
    [anon_sym_hitAttributeEXT] = ACTIONS(1421),
    [anon_sym_callableDataEXT] = ACTIONS(1421),
    [anon_sym_callableDataInEXT] = ACTIONS(1421),
    [anon_sym_shaderRecordEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadNV] = ACTIONS(1421),
    [anon_sym_rayPayloadInNV] = ACTIONS(1421),
    [anon_sym_hitAttributeNV] = ACTIONS(1421),
    [anon_sym_callableDataNV] = ACTIONS(1421),
    [anon_sym_callableDataInNV] = ACTIONS(1421),
    [anon_sym_shaderRecordNV] = ACTIONS(1421),
    [anon_sym_layout] = ACTIONS(1421),
  },
  [134] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [aux_sym_preproc_else_token1] = ACTIONS(1425),
    [aux_sym_preproc_elif_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [135] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token2] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [aux_sym_preproc_else_token1] = ACTIONS(1413),
    [aux_sym_preproc_elif_token1] = ACTIONS(1413),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [136] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [aux_sym_preproc_else_token1] = ACTIONS(1429),
    [aux_sym_preproc_elif_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_typedef] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_goto] = ACTIONS(1429),
    [anon_sym___try] = ACTIONS(1429),
    [anon_sym___leave] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_sizeof] = ACTIONS(1429),
    [anon_sym___alignof__] = ACTIONS(1429),
    [anon_sym___alignof] = ACTIONS(1429),
    [anon_sym__alignof] = ACTIONS(1429),
    [anon_sym_alignof] = ACTIONS(1429),
    [anon_sym__Alignof] = ACTIONS(1429),
    [anon_sym_offsetof] = ACTIONS(1429),
    [anon_sym__Generic] = ACTIONS(1429),
    [anon_sym_asm] = ACTIONS(1429),
    [anon_sym___asm__] = ACTIONS(1429),
    [sym_number_literal] = ACTIONS(1431),
    [anon_sym_L_SQUOTE] = ACTIONS(1431),
    [anon_sym_u_SQUOTE] = ACTIONS(1431),
    [anon_sym_U_SQUOTE] = ACTIONS(1431),
    [anon_sym_u8_SQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [anon_sym_L_DQUOTE] = ACTIONS(1431),
    [anon_sym_u_DQUOTE] = ACTIONS(1431),
    [anon_sym_U_DQUOTE] = ACTIONS(1431),
    [anon_sym_u8_DQUOTE] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [anon_sym_NULL] = ACTIONS(1429),
    [anon_sym_nullptr] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [137] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [aux_sym_preproc_else_token1] = ACTIONS(1433),
    [aux_sym_preproc_elif_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1437),
    [aux_sym_preproc_def_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token2] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1437),
    [aux_sym_preproc_else_token1] = ACTIONS(1437),
    [aux_sym_preproc_elif_token1] = ACTIONS(1437),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1437),
    [sym_preproc_directive] = ACTIONS(1437),
    [anon_sym_LPAREN2] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_subroutine] = ACTIONS(1437),
    [anon_sym_invariant] = ACTIONS(1437),
    [anon_sym_precise] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_in] = ACTIONS(1437),
    [anon_sym_out] = ACTIONS(1437),
    [anon_sym_inout] = ACTIONS(1437),
    [anon_sym_uniform] = ACTIONS(1437),
    [anon_sym_shared] = ACTIONS(1437),
    [anon_sym_attribute] = ACTIONS(1437),
    [anon_sym_varying] = ACTIONS(1437),
    [anon_sym_buffer] = ACTIONS(1437),
    [anon_sym_coherent] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_writeonly] = ACTIONS(1437),
    [anon_sym_precision] = ACTIONS(1437),
    [anon_sym_highp] = ACTIONS(1437),
    [anon_sym_mediump] = ACTIONS(1437),
    [anon_sym_lowp] = ACTIONS(1437),
    [anon_sym_centroid] = ACTIONS(1437),
    [anon_sym_sample] = ACTIONS(1437),
    [anon_sym_patch] = ACTIONS(1437),
    [anon_sym_smooth] = ACTIONS(1437),
    [anon_sym_flat] = ACTIONS(1437),
    [anon_sym_noperspective] = ACTIONS(1437),
    [anon_sym___extension__] = ACTIONS(1437),
    [anon_sym_typedef] = ACTIONS(1437),
    [anon_sym_extern] = ACTIONS(1437),
    [anon_sym___attribute__] = ACTIONS(1437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1439),
    [anon_sym___declspec] = ACTIONS(1437),
    [anon_sym___cdecl] = ACTIONS(1437),
    [anon_sym___clrcall] = ACTIONS(1437),
    [anon_sym___stdcall] = ACTIONS(1437),
    [anon_sym___fastcall] = ACTIONS(1437),
    [anon_sym___thiscall] = ACTIONS(1437),
    [anon_sym___vectorcall] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_signed] = ACTIONS(1437),
    [anon_sym_unsigned] = ACTIONS(1437),
    [anon_sym_long] = ACTIONS(1437),
    [anon_sym_short] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_auto] = ACTIONS(1437),
    [anon_sym_register] = ACTIONS(1437),
    [anon_sym_inline] = ACTIONS(1437),
    [anon_sym___inline] = ACTIONS(1437),
    [anon_sym___inline__] = ACTIONS(1437),
    [anon_sym___forceinline] = ACTIONS(1437),
    [anon_sym_thread_local] = ACTIONS(1437),
    [anon_sym___thread] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_constexpr] = ACTIONS(1437),
    [anon_sym_volatile] = ACTIONS(1437),
    [anon_sym_restrict] = ACTIONS(1437),
    [anon_sym___restrict__] = ACTIONS(1437),
    [anon_sym__Atomic] = ACTIONS(1437),
    [anon_sym__Noreturn] = ACTIONS(1437),
    [anon_sym_noreturn] = ACTIONS(1437),
    [anon_sym_alignas] = ACTIONS(1437),
    [anon_sym__Alignas] = ACTIONS(1437),
    [sym_primitive_type] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1437),
    [anon_sym_union] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_goto] = ACTIONS(1437),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_sizeof] = ACTIONS(1437),
    [anon_sym___alignof__] = ACTIONS(1437),
    [anon_sym___alignof] = ACTIONS(1437),
    [anon_sym__alignof] = ACTIONS(1437),
    [anon_sym_alignof] = ACTIONS(1437),
    [anon_sym__Alignof] = ACTIONS(1437),
    [anon_sym_offsetof] = ACTIONS(1437),
    [anon_sym__Generic] = ACTIONS(1437),
    [anon_sym_asm] = ACTIONS(1437),
    [anon_sym___asm__] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1439),
    [anon_sym_L_SQUOTE] = ACTIONS(1439),
    [anon_sym_u_SQUOTE] = ACTIONS(1439),
    [anon_sym_U_SQUOTE] = ACTIONS(1439),
    [anon_sym_u8_SQUOTE] = ACTIONS(1439),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_L_DQUOTE] = ACTIONS(1439),
    [anon_sym_u_DQUOTE] = ACTIONS(1439),
    [anon_sym_U_DQUOTE] = ACTIONS(1439),
    [anon_sym_u8_DQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [anon_sym_NULL] = ACTIONS(1437),
    [anon_sym_nullptr] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1437),
    [anon_sym_hitAttributeEXT] = ACTIONS(1437),
    [anon_sym_callableDataEXT] = ACTIONS(1437),
    [anon_sym_callableDataInEXT] = ACTIONS(1437),
    [anon_sym_shaderRecordEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadNV] = ACTIONS(1437),
    [anon_sym_rayPayloadInNV] = ACTIONS(1437),
    [anon_sym_hitAttributeNV] = ACTIONS(1437),
    [anon_sym_callableDataNV] = ACTIONS(1437),
    [anon_sym_callableDataInNV] = ACTIONS(1437),
    [anon_sym_shaderRecordNV] = ACTIONS(1437),
    [anon_sym_layout] = ACTIONS(1437),
  },
  [139] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [aux_sym_preproc_else_token1] = ACTIONS(1433),
    [aux_sym_preproc_elif_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token2] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [aux_sym_preproc_else_token1] = ACTIONS(1441),
    [aux_sym_preproc_elif_token1] = ACTIONS(1441),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_LPAREN2] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_typedef] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym___cdecl] = ACTIONS(1441),
    [anon_sym___clrcall] = ACTIONS(1441),
    [anon_sym___stdcall] = ACTIONS(1441),
    [anon_sym___fastcall] = ACTIONS(1441),
    [anon_sym___thiscall] = ACTIONS(1441),
    [anon_sym___vectorcall] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1441),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1441),
    [anon_sym_continue] = ACTIONS(1441),
    [anon_sym_goto] = ACTIONS(1441),
    [anon_sym___try] = ACTIONS(1441),
    [anon_sym___leave] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1443),
    [anon_sym_sizeof] = ACTIONS(1441),
    [anon_sym___alignof__] = ACTIONS(1441),
    [anon_sym___alignof] = ACTIONS(1441),
    [anon_sym__alignof] = ACTIONS(1441),
    [anon_sym_alignof] = ACTIONS(1441),
    [anon_sym__Alignof] = ACTIONS(1441),
    [anon_sym_offsetof] = ACTIONS(1441),
    [anon_sym__Generic] = ACTIONS(1441),
    [anon_sym_asm] = ACTIONS(1441),
    [anon_sym___asm__] = ACTIONS(1441),
    [sym_number_literal] = ACTIONS(1443),
    [anon_sym_L_SQUOTE] = ACTIONS(1443),
    [anon_sym_u_SQUOTE] = ACTIONS(1443),
    [anon_sym_U_SQUOTE] = ACTIONS(1443),
    [anon_sym_u8_SQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_L_DQUOTE] = ACTIONS(1443),
    [anon_sym_u_DQUOTE] = ACTIONS(1443),
    [anon_sym_U_DQUOTE] = ACTIONS(1443),
    [anon_sym_u8_DQUOTE] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [anon_sym_NULL] = ACTIONS(1441),
    [anon_sym_nullptr] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [141] = {
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token2] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [aux_sym_preproc_else_token1] = ACTIONS(1445),
    [aux_sym_preproc_elif_token1] = ACTIONS(1445),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_subroutine] = ACTIONS(1445),
    [anon_sym_invariant] = ACTIONS(1445),
    [anon_sym_precise] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_in] = ACTIONS(1445),
    [anon_sym_out] = ACTIONS(1445),
    [anon_sym_inout] = ACTIONS(1445),
    [anon_sym_uniform] = ACTIONS(1445),
    [anon_sym_shared] = ACTIONS(1445),
    [anon_sym_attribute] = ACTIONS(1445),
    [anon_sym_varying] = ACTIONS(1445),
    [anon_sym_buffer] = ACTIONS(1445),
    [anon_sym_coherent] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_writeonly] = ACTIONS(1445),
    [anon_sym_precision] = ACTIONS(1445),
    [anon_sym_highp] = ACTIONS(1445),
    [anon_sym_mediump] = ACTIONS(1445),
    [anon_sym_lowp] = ACTIONS(1445),
    [anon_sym_centroid] = ACTIONS(1445),
    [anon_sym_sample] = ACTIONS(1445),
    [anon_sym_patch] = ACTIONS(1445),
    [anon_sym_smooth] = ACTIONS(1445),
    [anon_sym_flat] = ACTIONS(1445),
    [anon_sym_noperspective] = ACTIONS(1445),
    [anon_sym___extension__] = ACTIONS(1445),
    [anon_sym_typedef] = ACTIONS(1445),
    [anon_sym_extern] = ACTIONS(1445),
    [anon_sym___attribute__] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1447),
    [anon_sym___declspec] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_signed] = ACTIONS(1445),
    [anon_sym_unsigned] = ACTIONS(1445),
    [anon_sym_long] = ACTIONS(1445),
    [anon_sym_short] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_auto] = ACTIONS(1445),
    [anon_sym_register] = ACTIONS(1445),
    [anon_sym_inline] = ACTIONS(1445),
    [anon_sym___inline] = ACTIONS(1445),
    [anon_sym___inline__] = ACTIONS(1445),
    [anon_sym___forceinline] = ACTIONS(1445),
    [anon_sym_thread_local] = ACTIONS(1445),
    [anon_sym___thread] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(1445),
    [anon_sym_constexpr] = ACTIONS(1445),
    [anon_sym_volatile] = ACTIONS(1445),
    [anon_sym_restrict] = ACTIONS(1445),
    [anon_sym___restrict__] = ACTIONS(1445),
    [anon_sym__Atomic] = ACTIONS(1445),
    [anon_sym__Noreturn] = ACTIONS(1445),
    [anon_sym_noreturn] = ACTIONS(1445),
    [anon_sym_alignas] = ACTIONS(1445),
    [anon_sym__Alignas] = ACTIONS(1445),
    [sym_primitive_type] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1445),
    [anon_sym_union] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_continue] = ACTIONS(1445),
    [anon_sym_goto] = ACTIONS(1445),
    [anon_sym___try] = ACTIONS(1445),
    [anon_sym___leave] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1445),
    [anon_sym___alignof__] = ACTIONS(1445),
    [anon_sym___alignof] = ACTIONS(1445),
    [anon_sym__alignof] = ACTIONS(1445),
    [anon_sym_alignof] = ACTIONS(1445),
    [anon_sym__Alignof] = ACTIONS(1445),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1445),
    [anon_sym_asm] = ACTIONS(1445),
    [anon_sym___asm__] = ACTIONS(1445),
    [sym_number_literal] = ACTIONS(1447),
    [anon_sym_L_SQUOTE] = ACTIONS(1447),
    [anon_sym_u_SQUOTE] = ACTIONS(1447),
    [anon_sym_U_SQUOTE] = ACTIONS(1447),
    [anon_sym_u8_SQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_L_DQUOTE] = ACTIONS(1447),
    [anon_sym_u_DQUOTE] = ACTIONS(1447),
    [anon_sym_U_DQUOTE] = ACTIONS(1447),
    [anon_sym_u8_DQUOTE] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [sym_true] = ACTIONS(1445),
    [sym_false] = ACTIONS(1445),
    [anon_sym_NULL] = ACTIONS(1445),
    [anon_sym_nullptr] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1445),
    [anon_sym_hitAttributeEXT] = ACTIONS(1445),
    [anon_sym_callableDataEXT] = ACTIONS(1445),
    [anon_sym_callableDataInEXT] = ACTIONS(1445),
    [anon_sym_shaderRecordEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadNV] = ACTIONS(1445),
    [anon_sym_rayPayloadInNV] = ACTIONS(1445),
    [anon_sym_hitAttributeNV] = ACTIONS(1445),
    [anon_sym_callableDataNV] = ACTIONS(1445),
    [anon_sym_callableDataInNV] = ACTIONS(1445),
    [anon_sym_shaderRecordNV] = ACTIONS(1445),
    [anon_sym_layout] = ACTIONS(1445),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1449),
    [aux_sym_preproc_include_token1] = ACTIONS(1449),
    [aux_sym_preproc_def_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token2] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1449),
    [aux_sym_preproc_else_token1] = ACTIONS(1449),
    [aux_sym_preproc_elif_token1] = ACTIONS(1449),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1449),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1449),
    [sym_preproc_directive] = ACTIONS(1449),
    [anon_sym_LPAREN2] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_subroutine] = ACTIONS(1449),
    [anon_sym_invariant] = ACTIONS(1449),
    [anon_sym_precise] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_in] = ACTIONS(1449),
    [anon_sym_out] = ACTIONS(1449),
    [anon_sym_inout] = ACTIONS(1449),
    [anon_sym_uniform] = ACTIONS(1449),
    [anon_sym_shared] = ACTIONS(1449),
    [anon_sym_attribute] = ACTIONS(1449),
    [anon_sym_varying] = ACTIONS(1449),
    [anon_sym_buffer] = ACTIONS(1449),
    [anon_sym_coherent] = ACTIONS(1449),
    [anon_sym_readonly] = ACTIONS(1449),
    [anon_sym_writeonly] = ACTIONS(1449),
    [anon_sym_precision] = ACTIONS(1449),
    [anon_sym_highp] = ACTIONS(1449),
    [anon_sym_mediump] = ACTIONS(1449),
    [anon_sym_lowp] = ACTIONS(1449),
    [anon_sym_centroid] = ACTIONS(1449),
    [anon_sym_sample] = ACTIONS(1449),
    [anon_sym_patch] = ACTIONS(1449),
    [anon_sym_smooth] = ACTIONS(1449),
    [anon_sym_flat] = ACTIONS(1449),
    [anon_sym_noperspective] = ACTIONS(1449),
    [anon_sym___extension__] = ACTIONS(1449),
    [anon_sym_typedef] = ACTIONS(1449),
    [anon_sym_extern] = ACTIONS(1449),
    [anon_sym___attribute__] = ACTIONS(1449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1451),
    [anon_sym___declspec] = ACTIONS(1449),
    [anon_sym___cdecl] = ACTIONS(1449),
    [anon_sym___clrcall] = ACTIONS(1449),
    [anon_sym___stdcall] = ACTIONS(1449),
    [anon_sym___fastcall] = ACTIONS(1449),
    [anon_sym___thiscall] = ACTIONS(1449),
    [anon_sym___vectorcall] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_signed] = ACTIONS(1449),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_auto] = ACTIONS(1449),
    [anon_sym_register] = ACTIONS(1449),
    [anon_sym_inline] = ACTIONS(1449),
    [anon_sym___inline] = ACTIONS(1449),
    [anon_sym___inline__] = ACTIONS(1449),
    [anon_sym___forceinline] = ACTIONS(1449),
    [anon_sym_thread_local] = ACTIONS(1449),
    [anon_sym___thread] = ACTIONS(1449),
    [anon_sym_const] = ACTIONS(1449),
    [anon_sym_constexpr] = ACTIONS(1449),
    [anon_sym_volatile] = ACTIONS(1449),
    [anon_sym_restrict] = ACTIONS(1449),
    [anon_sym___restrict__] = ACTIONS(1449),
    [anon_sym__Atomic] = ACTIONS(1449),
    [anon_sym__Noreturn] = ACTIONS(1449),
    [anon_sym_noreturn] = ACTIONS(1449),
    [anon_sym_alignas] = ACTIONS(1449),
    [anon_sym__Alignas] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1449),
    [anon_sym_enum] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1449),
    [anon_sym_union] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_switch] = ACTIONS(1449),
    [anon_sym_case] = ACTIONS(1449),
    [anon_sym_default] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_for] = ACTIONS(1449),
    [anon_sym_return] = ACTIONS(1449),
    [anon_sym_break] = ACTIONS(1449),
    [anon_sym_continue] = ACTIONS(1449),
    [anon_sym_goto] = ACTIONS(1449),
    [anon_sym___try] = ACTIONS(1449),
    [anon_sym___leave] = ACTIONS(1449),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym___alignof__] = ACTIONS(1449),
    [anon_sym___alignof] = ACTIONS(1449),
    [anon_sym__alignof] = ACTIONS(1449),
    [anon_sym_alignof] = ACTIONS(1449),
    [anon_sym__Alignof] = ACTIONS(1449),
    [anon_sym_offsetof] = ACTIONS(1449),
    [anon_sym__Generic] = ACTIONS(1449),
    [anon_sym_asm] = ACTIONS(1449),
    [anon_sym___asm__] = ACTIONS(1449),
    [sym_number_literal] = ACTIONS(1451),
    [anon_sym_L_SQUOTE] = ACTIONS(1451),
    [anon_sym_u_SQUOTE] = ACTIONS(1451),
    [anon_sym_U_SQUOTE] = ACTIONS(1451),
    [anon_sym_u8_SQUOTE] = ACTIONS(1451),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [anon_sym_L_DQUOTE] = ACTIONS(1451),
    [anon_sym_u_DQUOTE] = ACTIONS(1451),
    [anon_sym_U_DQUOTE] = ACTIONS(1451),
    [anon_sym_u8_DQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [anon_sym_NULL] = ACTIONS(1449),
    [anon_sym_nullptr] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1449),
    [anon_sym_hitAttributeEXT] = ACTIONS(1449),
    [anon_sym_callableDataEXT] = ACTIONS(1449),
    [anon_sym_callableDataInEXT] = ACTIONS(1449),
    [anon_sym_shaderRecordEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadNV] = ACTIONS(1449),
    [anon_sym_rayPayloadInNV] = ACTIONS(1449),
    [anon_sym_hitAttributeNV] = ACTIONS(1449),
    [anon_sym_callableDataNV] = ACTIONS(1449),
    [anon_sym_callableDataInNV] = ACTIONS(1449),
    [anon_sym_shaderRecordNV] = ACTIONS(1449),
    [anon_sym_layout] = ACTIONS(1449),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1453),
    [aux_sym_preproc_include_token1] = ACTIONS(1453),
    [aux_sym_preproc_def_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token2] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1453),
    [aux_sym_preproc_else_token1] = ACTIONS(1453),
    [aux_sym_preproc_elif_token1] = ACTIONS(1453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1453),
    [sym_preproc_directive] = ACTIONS(1453),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_subroutine] = ACTIONS(1453),
    [anon_sym_invariant] = ACTIONS(1453),
    [anon_sym_precise] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1455),
    [anon_sym_in] = ACTIONS(1453),
    [anon_sym_out] = ACTIONS(1453),
    [anon_sym_inout] = ACTIONS(1453),
    [anon_sym_uniform] = ACTIONS(1453),
    [anon_sym_shared] = ACTIONS(1453),
    [anon_sym_attribute] = ACTIONS(1453),
    [anon_sym_varying] = ACTIONS(1453),
    [anon_sym_buffer] = ACTIONS(1453),
    [anon_sym_coherent] = ACTIONS(1453),
    [anon_sym_readonly] = ACTIONS(1453),
    [anon_sym_writeonly] = ACTIONS(1453),
    [anon_sym_precision] = ACTIONS(1453),
    [anon_sym_highp] = ACTIONS(1453),
    [anon_sym_mediump] = ACTIONS(1453),
    [anon_sym_lowp] = ACTIONS(1453),
    [anon_sym_centroid] = ACTIONS(1453),
    [anon_sym_sample] = ACTIONS(1453),
    [anon_sym_patch] = ACTIONS(1453),
    [anon_sym_smooth] = ACTIONS(1453),
    [anon_sym_flat] = ACTIONS(1453),
    [anon_sym_noperspective] = ACTIONS(1453),
    [anon_sym___extension__] = ACTIONS(1453),
    [anon_sym_typedef] = ACTIONS(1453),
    [anon_sym_extern] = ACTIONS(1453),
    [anon_sym___attribute__] = ACTIONS(1453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1455),
    [anon_sym___declspec] = ACTIONS(1453),
    [anon_sym___cdecl] = ACTIONS(1453),
    [anon_sym___clrcall] = ACTIONS(1453),
    [anon_sym___stdcall] = ACTIONS(1453),
    [anon_sym___fastcall] = ACTIONS(1453),
    [anon_sym___thiscall] = ACTIONS(1453),
    [anon_sym___vectorcall] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_signed] = ACTIONS(1453),
    [anon_sym_unsigned] = ACTIONS(1453),
    [anon_sym_long] = ACTIONS(1453),
    [anon_sym_short] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_auto] = ACTIONS(1453),
    [anon_sym_register] = ACTIONS(1453),
    [anon_sym_inline] = ACTIONS(1453),
    [anon_sym___inline] = ACTIONS(1453),
    [anon_sym___inline__] = ACTIONS(1453),
    [anon_sym___forceinline] = ACTIONS(1453),
    [anon_sym_thread_local] = ACTIONS(1453),
    [anon_sym___thread] = ACTIONS(1453),
    [anon_sym_const] = ACTIONS(1453),
    [anon_sym_constexpr] = ACTIONS(1453),
    [anon_sym_volatile] = ACTIONS(1453),
    [anon_sym_restrict] = ACTIONS(1453),
    [anon_sym___restrict__] = ACTIONS(1453),
    [anon_sym__Atomic] = ACTIONS(1453),
    [anon_sym__Noreturn] = ACTIONS(1453),
    [anon_sym_noreturn] = ACTIONS(1453),
    [anon_sym_alignas] = ACTIONS(1453),
    [anon_sym__Alignas] = ACTIONS(1453),
    [sym_primitive_type] = ACTIONS(1453),
    [anon_sym_enum] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1453),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1453),
    [anon_sym_default] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_for] = ACTIONS(1453),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1453),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_goto] = ACTIONS(1453),
    [anon_sym___try] = ACTIONS(1453),
    [anon_sym___leave] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1455),
    [anon_sym_sizeof] = ACTIONS(1453),
    [anon_sym___alignof__] = ACTIONS(1453),
    [anon_sym___alignof] = ACTIONS(1453),
    [anon_sym__alignof] = ACTIONS(1453),
    [anon_sym_alignof] = ACTIONS(1453),
    [anon_sym__Alignof] = ACTIONS(1453),
    [anon_sym_offsetof] = ACTIONS(1453),
    [anon_sym__Generic] = ACTIONS(1453),
    [anon_sym_asm] = ACTIONS(1453),
    [anon_sym___asm__] = ACTIONS(1453),
    [sym_number_literal] = ACTIONS(1455),
    [anon_sym_L_SQUOTE] = ACTIONS(1455),
    [anon_sym_u_SQUOTE] = ACTIONS(1455),
    [anon_sym_U_SQUOTE] = ACTIONS(1455),
    [anon_sym_u8_SQUOTE] = ACTIONS(1455),
    [anon_sym_SQUOTE] = ACTIONS(1455),
    [anon_sym_L_DQUOTE] = ACTIONS(1455),
    [anon_sym_u_DQUOTE] = ACTIONS(1455),
    [anon_sym_U_DQUOTE] = ACTIONS(1455),
    [anon_sym_u8_DQUOTE] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [anon_sym_NULL] = ACTIONS(1453),
    [anon_sym_nullptr] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1453),
    [anon_sym_hitAttributeEXT] = ACTIONS(1453),
    [anon_sym_callableDataEXT] = ACTIONS(1453),
    [anon_sym_callableDataInEXT] = ACTIONS(1453),
    [anon_sym_shaderRecordEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadNV] = ACTIONS(1453),
    [anon_sym_rayPayloadInNV] = ACTIONS(1453),
    [anon_sym_hitAttributeNV] = ACTIONS(1453),
    [anon_sym_callableDataNV] = ACTIONS(1453),
    [anon_sym_callableDataInNV] = ACTIONS(1453),
    [anon_sym_shaderRecordNV] = ACTIONS(1453),
    [anon_sym_layout] = ACTIONS(1453),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [aux_sym_preproc_else_token1] = ACTIONS(1425),
    [aux_sym_preproc_elif_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token2] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [aux_sym_preproc_else_token1] = ACTIONS(1457),
    [aux_sym_preproc_elif_token1] = ACTIONS(1457),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1461),
    [aux_sym_preproc_include_token1] = ACTIONS(1461),
    [aux_sym_preproc_def_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token2] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1461),
    [aux_sym_preproc_else_token1] = ACTIONS(1461),
    [aux_sym_preproc_elif_token1] = ACTIONS(1461),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1461),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1461),
    [sym_preproc_directive] = ACTIONS(1461),
    [anon_sym_LPAREN2] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_subroutine] = ACTIONS(1461),
    [anon_sym_invariant] = ACTIONS(1461),
    [anon_sym_precise] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_out] = ACTIONS(1461),
    [anon_sym_inout] = ACTIONS(1461),
    [anon_sym_uniform] = ACTIONS(1461),
    [anon_sym_shared] = ACTIONS(1461),
    [anon_sym_attribute] = ACTIONS(1461),
    [anon_sym_varying] = ACTIONS(1461),
    [anon_sym_buffer] = ACTIONS(1461),
    [anon_sym_coherent] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_writeonly] = ACTIONS(1461),
    [anon_sym_precision] = ACTIONS(1461),
    [anon_sym_highp] = ACTIONS(1461),
    [anon_sym_mediump] = ACTIONS(1461),
    [anon_sym_lowp] = ACTIONS(1461),
    [anon_sym_centroid] = ACTIONS(1461),
    [anon_sym_sample] = ACTIONS(1461),
    [anon_sym_patch] = ACTIONS(1461),
    [anon_sym_smooth] = ACTIONS(1461),
    [anon_sym_flat] = ACTIONS(1461),
    [anon_sym_noperspective] = ACTIONS(1461),
    [anon_sym___extension__] = ACTIONS(1461),
    [anon_sym_typedef] = ACTIONS(1461),
    [anon_sym_extern] = ACTIONS(1461),
    [anon_sym___attribute__] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1463),
    [anon_sym___declspec] = ACTIONS(1461),
    [anon_sym___cdecl] = ACTIONS(1461),
    [anon_sym___clrcall] = ACTIONS(1461),
    [anon_sym___stdcall] = ACTIONS(1461),
    [anon_sym___fastcall] = ACTIONS(1461),
    [anon_sym___thiscall] = ACTIONS(1461),
    [anon_sym___vectorcall] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_signed] = ACTIONS(1461),
    [anon_sym_unsigned] = ACTIONS(1461),
    [anon_sym_long] = ACTIONS(1461),
    [anon_sym_short] = ACTIONS(1461),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_auto] = ACTIONS(1461),
    [anon_sym_register] = ACTIONS(1461),
    [anon_sym_inline] = ACTIONS(1461),
    [anon_sym___inline] = ACTIONS(1461),
    [anon_sym___inline__] = ACTIONS(1461),
    [anon_sym___forceinline] = ACTIONS(1461),
    [anon_sym_thread_local] = ACTIONS(1461),
    [anon_sym___thread] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_constexpr] = ACTIONS(1461),
    [anon_sym_volatile] = ACTIONS(1461),
    [anon_sym_restrict] = ACTIONS(1461),
    [anon_sym___restrict__] = ACTIONS(1461),
    [anon_sym__Atomic] = ACTIONS(1461),
    [anon_sym__Noreturn] = ACTIONS(1461),
    [anon_sym_noreturn] = ACTIONS(1461),
    [anon_sym_alignas] = ACTIONS(1461),
    [anon_sym__Alignas] = ACTIONS(1461),
    [sym_primitive_type] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_union] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_goto] = ACTIONS(1461),
    [anon_sym___try] = ACTIONS(1461),
    [anon_sym___leave] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_sizeof] = ACTIONS(1461),
    [anon_sym___alignof__] = ACTIONS(1461),
    [anon_sym___alignof] = ACTIONS(1461),
    [anon_sym__alignof] = ACTIONS(1461),
    [anon_sym_alignof] = ACTIONS(1461),
    [anon_sym__Alignof] = ACTIONS(1461),
    [anon_sym_offsetof] = ACTIONS(1461),
    [anon_sym__Generic] = ACTIONS(1461),
    [anon_sym_asm] = ACTIONS(1461),
    [anon_sym___asm__] = ACTIONS(1461),
    [sym_number_literal] = ACTIONS(1463),
    [anon_sym_L_SQUOTE] = ACTIONS(1463),
    [anon_sym_u_SQUOTE] = ACTIONS(1463),
    [anon_sym_U_SQUOTE] = ACTIONS(1463),
    [anon_sym_u8_SQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_L_DQUOTE] = ACTIONS(1463),
    [anon_sym_u_DQUOTE] = ACTIONS(1463),
    [anon_sym_U_DQUOTE] = ACTIONS(1463),
    [anon_sym_u8_DQUOTE] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [anon_sym_NULL] = ACTIONS(1461),
    [anon_sym_nullptr] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1461),
    [anon_sym_hitAttributeEXT] = ACTIONS(1461),
    [anon_sym_callableDataEXT] = ACTIONS(1461),
    [anon_sym_callableDataInEXT] = ACTIONS(1461),
    [anon_sym_shaderRecordEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadNV] = ACTIONS(1461),
    [anon_sym_rayPayloadInNV] = ACTIONS(1461),
    [anon_sym_hitAttributeNV] = ACTIONS(1461),
    [anon_sym_callableDataNV] = ACTIONS(1461),
    [anon_sym_callableDataInNV] = ACTIONS(1461),
    [anon_sym_shaderRecordNV] = ACTIONS(1461),
    [anon_sym_layout] = ACTIONS(1461),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1465),
    [aux_sym_preproc_include_token1] = ACTIONS(1465),
    [aux_sym_preproc_def_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token2] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1465),
    [aux_sym_preproc_else_token1] = ACTIONS(1465),
    [aux_sym_preproc_elif_token1] = ACTIONS(1465),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1465),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1465),
    [sym_preproc_directive] = ACTIONS(1465),
    [anon_sym_LPAREN2] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_subroutine] = ACTIONS(1465),
    [anon_sym_invariant] = ACTIONS(1465),
    [anon_sym_precise] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(1465),
    [anon_sym_out] = ACTIONS(1465),
    [anon_sym_inout] = ACTIONS(1465),
    [anon_sym_uniform] = ACTIONS(1465),
    [anon_sym_shared] = ACTIONS(1465),
    [anon_sym_attribute] = ACTIONS(1465),
    [anon_sym_varying] = ACTIONS(1465),
    [anon_sym_buffer] = ACTIONS(1465),
    [anon_sym_coherent] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_writeonly] = ACTIONS(1465),
    [anon_sym_precision] = ACTIONS(1465),
    [anon_sym_highp] = ACTIONS(1465),
    [anon_sym_mediump] = ACTIONS(1465),
    [anon_sym_lowp] = ACTIONS(1465),
    [anon_sym_centroid] = ACTIONS(1465),
    [anon_sym_sample] = ACTIONS(1465),
    [anon_sym_patch] = ACTIONS(1465),
    [anon_sym_smooth] = ACTIONS(1465),
    [anon_sym_flat] = ACTIONS(1465),
    [anon_sym_noperspective] = ACTIONS(1465),
    [anon_sym___extension__] = ACTIONS(1465),
    [anon_sym_typedef] = ACTIONS(1465),
    [anon_sym_extern] = ACTIONS(1465),
    [anon_sym___attribute__] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1467),
    [anon_sym___declspec] = ACTIONS(1465),
    [anon_sym___cdecl] = ACTIONS(1465),
    [anon_sym___clrcall] = ACTIONS(1465),
    [anon_sym___stdcall] = ACTIONS(1465),
    [anon_sym___fastcall] = ACTIONS(1465),
    [anon_sym___thiscall] = ACTIONS(1465),
    [anon_sym___vectorcall] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_signed] = ACTIONS(1465),
    [anon_sym_unsigned] = ACTIONS(1465),
    [anon_sym_long] = ACTIONS(1465),
    [anon_sym_short] = ACTIONS(1465),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_auto] = ACTIONS(1465),
    [anon_sym_register] = ACTIONS(1465),
    [anon_sym_inline] = ACTIONS(1465),
    [anon_sym___inline] = ACTIONS(1465),
    [anon_sym___inline__] = ACTIONS(1465),
    [anon_sym___forceinline] = ACTIONS(1465),
    [anon_sym_thread_local] = ACTIONS(1465),
    [anon_sym___thread] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_constexpr] = ACTIONS(1465),
    [anon_sym_volatile] = ACTIONS(1465),
    [anon_sym_restrict] = ACTIONS(1465),
    [anon_sym___restrict__] = ACTIONS(1465),
    [anon_sym__Atomic] = ACTIONS(1465),
    [anon_sym__Noreturn] = ACTIONS(1465),
    [anon_sym_noreturn] = ACTIONS(1465),
    [anon_sym_alignas] = ACTIONS(1465),
    [anon_sym__Alignas] = ACTIONS(1465),
    [sym_primitive_type] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [anon_sym_struct] = ACTIONS(1465),
    [anon_sym_union] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_goto] = ACTIONS(1465),
    [anon_sym___try] = ACTIONS(1465),
    [anon_sym___leave] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1467),
    [anon_sym_sizeof] = ACTIONS(1465),
    [anon_sym___alignof__] = ACTIONS(1465),
    [anon_sym___alignof] = ACTIONS(1465),
    [anon_sym__alignof] = ACTIONS(1465),
    [anon_sym_alignof] = ACTIONS(1465),
    [anon_sym__Alignof] = ACTIONS(1465),
    [anon_sym_offsetof] = ACTIONS(1465),
    [anon_sym__Generic] = ACTIONS(1465),
    [anon_sym_asm] = ACTIONS(1465),
    [anon_sym___asm__] = ACTIONS(1465),
    [sym_number_literal] = ACTIONS(1467),
    [anon_sym_L_SQUOTE] = ACTIONS(1467),
    [anon_sym_u_SQUOTE] = ACTIONS(1467),
    [anon_sym_U_SQUOTE] = ACTIONS(1467),
    [anon_sym_u8_SQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_L_DQUOTE] = ACTIONS(1467),
    [anon_sym_u_DQUOTE] = ACTIONS(1467),
    [anon_sym_U_DQUOTE] = ACTIONS(1467),
    [anon_sym_u8_DQUOTE] = ACTIONS(1467),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [anon_sym_NULL] = ACTIONS(1465),
    [anon_sym_nullptr] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1465),
    [anon_sym_hitAttributeEXT] = ACTIONS(1465),
    [anon_sym_callableDataEXT] = ACTIONS(1465),
    [anon_sym_callableDataInEXT] = ACTIONS(1465),
    [anon_sym_shaderRecordEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadNV] = ACTIONS(1465),
    [anon_sym_rayPayloadInNV] = ACTIONS(1465),
    [anon_sym_hitAttributeNV] = ACTIONS(1465),
    [anon_sym_callableDataNV] = ACTIONS(1465),
    [anon_sym_callableDataInNV] = ACTIONS(1465),
    [anon_sym_shaderRecordNV] = ACTIONS(1465),
    [anon_sym_layout] = ACTIONS(1465),
  },
  [148] = {
    [sym_identifier] = ACTIONS(1469),
    [aux_sym_preproc_include_token1] = ACTIONS(1469),
    [aux_sym_preproc_def_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token2] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1469),
    [aux_sym_preproc_else_token1] = ACTIONS(1469),
    [aux_sym_preproc_elif_token1] = ACTIONS(1469),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1469),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1469),
    [sym_preproc_directive] = ACTIONS(1469),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_subroutine] = ACTIONS(1469),
    [anon_sym_invariant] = ACTIONS(1469),
    [anon_sym_precise] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_out] = ACTIONS(1469),
    [anon_sym_inout] = ACTIONS(1469),
    [anon_sym_uniform] = ACTIONS(1469),
    [anon_sym_shared] = ACTIONS(1469),
    [anon_sym_attribute] = ACTIONS(1469),
    [anon_sym_varying] = ACTIONS(1469),
    [anon_sym_buffer] = ACTIONS(1469),
    [anon_sym_coherent] = ACTIONS(1469),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_writeonly] = ACTIONS(1469),
    [anon_sym_precision] = ACTIONS(1469),
    [anon_sym_highp] = ACTIONS(1469),
    [anon_sym_mediump] = ACTIONS(1469),
    [anon_sym_lowp] = ACTIONS(1469),
    [anon_sym_centroid] = ACTIONS(1469),
    [anon_sym_sample] = ACTIONS(1469),
    [anon_sym_patch] = ACTIONS(1469),
    [anon_sym_smooth] = ACTIONS(1469),
    [anon_sym_flat] = ACTIONS(1469),
    [anon_sym_noperspective] = ACTIONS(1469),
    [anon_sym___extension__] = ACTIONS(1469),
    [anon_sym_typedef] = ACTIONS(1469),
    [anon_sym_extern] = ACTIONS(1469),
    [anon_sym___attribute__] = ACTIONS(1469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1471),
    [anon_sym___declspec] = ACTIONS(1469),
    [anon_sym___cdecl] = ACTIONS(1469),
    [anon_sym___clrcall] = ACTIONS(1469),
    [anon_sym___stdcall] = ACTIONS(1469),
    [anon_sym___fastcall] = ACTIONS(1469),
    [anon_sym___thiscall] = ACTIONS(1469),
    [anon_sym___vectorcall] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_signed] = ACTIONS(1469),
    [anon_sym_unsigned] = ACTIONS(1469),
    [anon_sym_long] = ACTIONS(1469),
    [anon_sym_short] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_auto] = ACTIONS(1469),
    [anon_sym_register] = ACTIONS(1469),
    [anon_sym_inline] = ACTIONS(1469),
    [anon_sym___inline] = ACTIONS(1469),
    [anon_sym___inline__] = ACTIONS(1469),
    [anon_sym___forceinline] = ACTIONS(1469),
    [anon_sym_thread_local] = ACTIONS(1469),
    [anon_sym___thread] = ACTIONS(1469),
    [anon_sym_const] = ACTIONS(1469),
    [anon_sym_constexpr] = ACTIONS(1469),
    [anon_sym_volatile] = ACTIONS(1469),
    [anon_sym_restrict] = ACTIONS(1469),
    [anon_sym___restrict__] = ACTIONS(1469),
    [anon_sym__Atomic] = ACTIONS(1469),
    [anon_sym__Noreturn] = ACTIONS(1469),
    [anon_sym_noreturn] = ACTIONS(1469),
    [anon_sym_alignas] = ACTIONS(1469),
    [anon_sym__Alignas] = ACTIONS(1469),
    [sym_primitive_type] = ACTIONS(1469),
    [anon_sym_enum] = ACTIONS(1469),
    [anon_sym_struct] = ACTIONS(1469),
    [anon_sym_union] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_switch] = ACTIONS(1469),
    [anon_sym_case] = ACTIONS(1469),
    [anon_sym_default] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1469),
    [anon_sym_break] = ACTIONS(1469),
    [anon_sym_continue] = ACTIONS(1469),
    [anon_sym_goto] = ACTIONS(1469),
    [anon_sym___try] = ACTIONS(1469),
    [anon_sym___leave] = ACTIONS(1469),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1469),
    [anon_sym___alignof__] = ACTIONS(1469),
    [anon_sym___alignof] = ACTIONS(1469),
    [anon_sym__alignof] = ACTIONS(1469),
    [anon_sym_alignof] = ACTIONS(1469),
    [anon_sym__Alignof] = ACTIONS(1469),
    [anon_sym_offsetof] = ACTIONS(1469),
    [anon_sym__Generic] = ACTIONS(1469),
    [anon_sym_asm] = ACTIONS(1469),
    [anon_sym___asm__] = ACTIONS(1469),
    [sym_number_literal] = ACTIONS(1471),
    [anon_sym_L_SQUOTE] = ACTIONS(1471),
    [anon_sym_u_SQUOTE] = ACTIONS(1471),
    [anon_sym_U_SQUOTE] = ACTIONS(1471),
    [anon_sym_u8_SQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [anon_sym_L_DQUOTE] = ACTIONS(1471),
    [anon_sym_u_DQUOTE] = ACTIONS(1471),
    [anon_sym_U_DQUOTE] = ACTIONS(1471),
    [anon_sym_u8_DQUOTE] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [anon_sym_NULL] = ACTIONS(1469),
    [anon_sym_nullptr] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1469),
    [anon_sym_hitAttributeEXT] = ACTIONS(1469),
    [anon_sym_callableDataEXT] = ACTIONS(1469),
    [anon_sym_callableDataInEXT] = ACTIONS(1469),
    [anon_sym_shaderRecordEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadNV] = ACTIONS(1469),
    [anon_sym_rayPayloadInNV] = ACTIONS(1469),
    [anon_sym_hitAttributeNV] = ACTIONS(1469),
    [anon_sym_callableDataNV] = ACTIONS(1469),
    [anon_sym_callableDataInNV] = ACTIONS(1469),
    [anon_sym_shaderRecordNV] = ACTIONS(1469),
    [anon_sym_layout] = ACTIONS(1469),
  },
  [149] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token2] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [aux_sym_preproc_else_token1] = ACTIONS(1473),
    [aux_sym_preproc_elif_token1] = ACTIONS(1473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [150] = {
    [sym_identifier] = ACTIONS(1477),
    [aux_sym_preproc_include_token1] = ACTIONS(1477),
    [aux_sym_preproc_def_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token2] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1477),
    [aux_sym_preproc_else_token1] = ACTIONS(1477),
    [aux_sym_preproc_elif_token1] = ACTIONS(1477),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1477),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1477),
    [sym_preproc_directive] = ACTIONS(1477),
    [anon_sym_LPAREN2] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_subroutine] = ACTIONS(1477),
    [anon_sym_invariant] = ACTIONS(1477),
    [anon_sym_precise] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_in] = ACTIONS(1477),
    [anon_sym_out] = ACTIONS(1477),
    [anon_sym_inout] = ACTIONS(1477),
    [anon_sym_uniform] = ACTIONS(1477),
    [anon_sym_shared] = ACTIONS(1477),
    [anon_sym_attribute] = ACTIONS(1477),
    [anon_sym_varying] = ACTIONS(1477),
    [anon_sym_buffer] = ACTIONS(1477),
    [anon_sym_coherent] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_writeonly] = ACTIONS(1477),
    [anon_sym_precision] = ACTIONS(1477),
    [anon_sym_highp] = ACTIONS(1477),
    [anon_sym_mediump] = ACTIONS(1477),
    [anon_sym_lowp] = ACTIONS(1477),
    [anon_sym_centroid] = ACTIONS(1477),
    [anon_sym_sample] = ACTIONS(1477),
    [anon_sym_patch] = ACTIONS(1477),
    [anon_sym_smooth] = ACTIONS(1477),
    [anon_sym_flat] = ACTIONS(1477),
    [anon_sym_noperspective] = ACTIONS(1477),
    [anon_sym___extension__] = ACTIONS(1477),
    [anon_sym_typedef] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(1477),
    [anon_sym___attribute__] = ACTIONS(1477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1479),
    [anon_sym___declspec] = ACTIONS(1477),
    [anon_sym___cdecl] = ACTIONS(1477),
    [anon_sym___clrcall] = ACTIONS(1477),
    [anon_sym___stdcall] = ACTIONS(1477),
    [anon_sym___fastcall] = ACTIONS(1477),
    [anon_sym___thiscall] = ACTIONS(1477),
    [anon_sym___vectorcall] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_signed] = ACTIONS(1477),
    [anon_sym_unsigned] = ACTIONS(1477),
    [anon_sym_long] = ACTIONS(1477),
    [anon_sym_short] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_auto] = ACTIONS(1477),
    [anon_sym_register] = ACTIONS(1477),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym___inline] = ACTIONS(1477),
    [anon_sym___inline__] = ACTIONS(1477),
    [anon_sym___forceinline] = ACTIONS(1477),
    [anon_sym_thread_local] = ACTIONS(1477),
    [anon_sym___thread] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_constexpr] = ACTIONS(1477),
    [anon_sym_volatile] = ACTIONS(1477),
    [anon_sym_restrict] = ACTIONS(1477),
    [anon_sym___restrict__] = ACTIONS(1477),
    [anon_sym__Atomic] = ACTIONS(1477),
    [anon_sym__Noreturn] = ACTIONS(1477),
    [anon_sym_noreturn] = ACTIONS(1477),
    [anon_sym_alignas] = ACTIONS(1477),
    [anon_sym__Alignas] = ACTIONS(1477),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [anon_sym_struct] = ACTIONS(1477),
    [anon_sym_union] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_goto] = ACTIONS(1477),
    [anon_sym___try] = ACTIONS(1477),
    [anon_sym___leave] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_sizeof] = ACTIONS(1477),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1477),
    [anon_sym__Generic] = ACTIONS(1477),
    [anon_sym_asm] = ACTIONS(1477),
    [anon_sym___asm__] = ACTIONS(1477),
    [sym_number_literal] = ACTIONS(1479),
    [anon_sym_L_SQUOTE] = ACTIONS(1479),
    [anon_sym_u_SQUOTE] = ACTIONS(1479),
    [anon_sym_U_SQUOTE] = ACTIONS(1479),
    [anon_sym_u8_SQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [anon_sym_L_DQUOTE] = ACTIONS(1479),
    [anon_sym_u_DQUOTE] = ACTIONS(1479),
    [anon_sym_U_DQUOTE] = ACTIONS(1479),
    [anon_sym_u8_DQUOTE] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [anon_sym_NULL] = ACTIONS(1477),
    [anon_sym_nullptr] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1477),
    [anon_sym_hitAttributeEXT] = ACTIONS(1477),
    [anon_sym_callableDataEXT] = ACTIONS(1477),
    [anon_sym_callableDataInEXT] = ACTIONS(1477),
    [anon_sym_shaderRecordEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadNV] = ACTIONS(1477),
    [anon_sym_rayPayloadInNV] = ACTIONS(1477),
    [anon_sym_hitAttributeNV] = ACTIONS(1477),
    [anon_sym_callableDataNV] = ACTIONS(1477),
    [anon_sym_callableDataInNV] = ACTIONS(1477),
    [anon_sym_shaderRecordNV] = ACTIONS(1477),
    [anon_sym_layout] = ACTIONS(1477),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1481),
    [aux_sym_preproc_include_token1] = ACTIONS(1481),
    [aux_sym_preproc_def_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token2] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1481),
    [aux_sym_preproc_else_token1] = ACTIONS(1481),
    [aux_sym_preproc_elif_token1] = ACTIONS(1481),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1481),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1481),
    [sym_preproc_directive] = ACTIONS(1481),
    [anon_sym_LPAREN2] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_subroutine] = ACTIONS(1481),
    [anon_sym_invariant] = ACTIONS(1481),
    [anon_sym_precise] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1481),
    [anon_sym_out] = ACTIONS(1481),
    [anon_sym_inout] = ACTIONS(1481),
    [anon_sym_uniform] = ACTIONS(1481),
    [anon_sym_shared] = ACTIONS(1481),
    [anon_sym_attribute] = ACTIONS(1481),
    [anon_sym_varying] = ACTIONS(1481),
    [anon_sym_buffer] = ACTIONS(1481),
    [anon_sym_coherent] = ACTIONS(1481),
    [anon_sym_readonly] = ACTIONS(1481),
    [anon_sym_writeonly] = ACTIONS(1481),
    [anon_sym_precision] = ACTIONS(1481),
    [anon_sym_highp] = ACTIONS(1481),
    [anon_sym_mediump] = ACTIONS(1481),
    [anon_sym_lowp] = ACTIONS(1481),
    [anon_sym_centroid] = ACTIONS(1481),
    [anon_sym_sample] = ACTIONS(1481),
    [anon_sym_patch] = ACTIONS(1481),
    [anon_sym_smooth] = ACTIONS(1481),
    [anon_sym_flat] = ACTIONS(1481),
    [anon_sym_noperspective] = ACTIONS(1481),
    [anon_sym___extension__] = ACTIONS(1481),
    [anon_sym_typedef] = ACTIONS(1481),
    [anon_sym_extern] = ACTIONS(1481),
    [anon_sym___attribute__] = ACTIONS(1481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1483),
    [anon_sym___declspec] = ACTIONS(1481),
    [anon_sym___cdecl] = ACTIONS(1481),
    [anon_sym___clrcall] = ACTIONS(1481),
    [anon_sym___stdcall] = ACTIONS(1481),
    [anon_sym___fastcall] = ACTIONS(1481),
    [anon_sym___thiscall] = ACTIONS(1481),
    [anon_sym___vectorcall] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_signed] = ACTIONS(1481),
    [anon_sym_unsigned] = ACTIONS(1481),
    [anon_sym_long] = ACTIONS(1481),
    [anon_sym_short] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_auto] = ACTIONS(1481),
    [anon_sym_register] = ACTIONS(1481),
    [anon_sym_inline] = ACTIONS(1481),
    [anon_sym___inline] = ACTIONS(1481),
    [anon_sym___inline__] = ACTIONS(1481),
    [anon_sym___forceinline] = ACTIONS(1481),
    [anon_sym_thread_local] = ACTIONS(1481),
    [anon_sym___thread] = ACTIONS(1481),
    [anon_sym_const] = ACTIONS(1481),
    [anon_sym_constexpr] = ACTIONS(1481),
    [anon_sym_volatile] = ACTIONS(1481),
    [anon_sym_restrict] = ACTIONS(1481),
    [anon_sym___restrict__] = ACTIONS(1481),
    [anon_sym__Atomic] = ACTIONS(1481),
    [anon_sym__Noreturn] = ACTIONS(1481),
    [anon_sym_noreturn] = ACTIONS(1481),
    [anon_sym_alignas] = ACTIONS(1481),
    [anon_sym__Alignas] = ACTIONS(1481),
    [sym_primitive_type] = ACTIONS(1481),
    [anon_sym_enum] = ACTIONS(1481),
    [anon_sym_struct] = ACTIONS(1481),
    [anon_sym_union] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_switch] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1481),
    [anon_sym_default] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_for] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_break] = ACTIONS(1481),
    [anon_sym_continue] = ACTIONS(1481),
    [anon_sym_goto] = ACTIONS(1481),
    [anon_sym___try] = ACTIONS(1481),
    [anon_sym___leave] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_sizeof] = ACTIONS(1481),
    [anon_sym___alignof__] = ACTIONS(1481),
    [anon_sym___alignof] = ACTIONS(1481),
    [anon_sym__alignof] = ACTIONS(1481),
    [anon_sym_alignof] = ACTIONS(1481),
    [anon_sym__Alignof] = ACTIONS(1481),
    [anon_sym_offsetof] = ACTIONS(1481),
    [anon_sym__Generic] = ACTIONS(1481),
    [anon_sym_asm] = ACTIONS(1481),
    [anon_sym___asm__] = ACTIONS(1481),
    [sym_number_literal] = ACTIONS(1483),
    [anon_sym_L_SQUOTE] = ACTIONS(1483),
    [anon_sym_u_SQUOTE] = ACTIONS(1483),
    [anon_sym_U_SQUOTE] = ACTIONS(1483),
    [anon_sym_u8_SQUOTE] = ACTIONS(1483),
    [anon_sym_SQUOTE] = ACTIONS(1483),
    [anon_sym_L_DQUOTE] = ACTIONS(1483),
    [anon_sym_u_DQUOTE] = ACTIONS(1483),
    [anon_sym_U_DQUOTE] = ACTIONS(1483),
    [anon_sym_u8_DQUOTE] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1483),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [anon_sym_NULL] = ACTIONS(1481),
    [anon_sym_nullptr] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1481),
    [anon_sym_hitAttributeEXT] = ACTIONS(1481),
    [anon_sym_callableDataEXT] = ACTIONS(1481),
    [anon_sym_callableDataInEXT] = ACTIONS(1481),
    [anon_sym_shaderRecordEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadNV] = ACTIONS(1481),
    [anon_sym_rayPayloadInNV] = ACTIONS(1481),
    [anon_sym_hitAttributeNV] = ACTIONS(1481),
    [anon_sym_callableDataNV] = ACTIONS(1481),
    [anon_sym_callableDataInNV] = ACTIONS(1481),
    [anon_sym_shaderRecordNV] = ACTIONS(1481),
    [anon_sym_layout] = ACTIONS(1481),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token2] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [aux_sym_preproc_else_token1] = ACTIONS(1457),
    [aux_sym_preproc_elif_token1] = ACTIONS(1457),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_include_token1] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token2] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [aux_sym_preproc_else_token1] = ACTIONS(1485),
    [aux_sym_preproc_elif_token1] = ACTIONS(1485),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_LPAREN2] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_typedef] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___cdecl] = ACTIONS(1485),
    [anon_sym___clrcall] = ACTIONS(1485),
    [anon_sym___stdcall] = ACTIONS(1485),
    [anon_sym___fastcall] = ACTIONS(1485),
    [anon_sym___thiscall] = ACTIONS(1485),
    [anon_sym___vectorcall] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_switch] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1485),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_return] = ACTIONS(1485),
    [anon_sym_break] = ACTIONS(1485),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_goto] = ACTIONS(1485),
    [anon_sym___try] = ACTIONS(1485),
    [anon_sym___leave] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1487),
    [anon_sym_sizeof] = ACTIONS(1485),
    [anon_sym___alignof__] = ACTIONS(1485),
    [anon_sym___alignof] = ACTIONS(1485),
    [anon_sym__alignof] = ACTIONS(1485),
    [anon_sym_alignof] = ACTIONS(1485),
    [anon_sym__Alignof] = ACTIONS(1485),
    [anon_sym_offsetof] = ACTIONS(1485),
    [anon_sym__Generic] = ACTIONS(1485),
    [anon_sym_asm] = ACTIONS(1485),
    [anon_sym___asm__] = ACTIONS(1485),
    [sym_number_literal] = ACTIONS(1487),
    [anon_sym_L_SQUOTE] = ACTIONS(1487),
    [anon_sym_u_SQUOTE] = ACTIONS(1487),
    [anon_sym_U_SQUOTE] = ACTIONS(1487),
    [anon_sym_u8_SQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_L_DQUOTE] = ACTIONS(1487),
    [anon_sym_u_DQUOTE] = ACTIONS(1487),
    [anon_sym_U_DQUOTE] = ACTIONS(1487),
    [anon_sym_u8_DQUOTE] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [anon_sym_NULL] = ACTIONS(1485),
    [anon_sym_nullptr] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_include_token1] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token2] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [aux_sym_preproc_else_token1] = ACTIONS(1489),
    [aux_sym_preproc_elif_token1] = ACTIONS(1489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_typedef] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym___cdecl] = ACTIONS(1489),
    [anon_sym___clrcall] = ACTIONS(1489),
    [anon_sym___stdcall] = ACTIONS(1489),
    [anon_sym___fastcall] = ACTIONS(1489),
    [anon_sym___thiscall] = ACTIONS(1489),
    [anon_sym___vectorcall] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_switch] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1489),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_return] = ACTIONS(1489),
    [anon_sym_break] = ACTIONS(1489),
    [anon_sym_continue] = ACTIONS(1489),
    [anon_sym_goto] = ACTIONS(1489),
    [anon_sym___try] = ACTIONS(1489),
    [anon_sym___leave] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_sizeof] = ACTIONS(1489),
    [anon_sym___alignof__] = ACTIONS(1489),
    [anon_sym___alignof] = ACTIONS(1489),
    [anon_sym__alignof] = ACTIONS(1489),
    [anon_sym_alignof] = ACTIONS(1489),
    [anon_sym__Alignof] = ACTIONS(1489),
    [anon_sym_offsetof] = ACTIONS(1489),
    [anon_sym__Generic] = ACTIONS(1489),
    [anon_sym_asm] = ACTIONS(1489),
    [anon_sym___asm__] = ACTIONS(1489),
    [sym_number_literal] = ACTIONS(1491),
    [anon_sym_L_SQUOTE] = ACTIONS(1491),
    [anon_sym_u_SQUOTE] = ACTIONS(1491),
    [anon_sym_U_SQUOTE] = ACTIONS(1491),
    [anon_sym_u8_SQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [anon_sym_L_DQUOTE] = ACTIONS(1491),
    [anon_sym_u_DQUOTE] = ACTIONS(1491),
    [anon_sym_U_DQUOTE] = ACTIONS(1491),
    [anon_sym_u8_DQUOTE] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [anon_sym_NULL] = ACTIONS(1489),
    [anon_sym_nullptr] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1493),
    [aux_sym_preproc_include_token1] = ACTIONS(1493),
    [aux_sym_preproc_def_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token2] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1493),
    [aux_sym_preproc_else_token1] = ACTIONS(1493),
    [aux_sym_preproc_elif_token1] = ACTIONS(1493),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1493),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1493),
    [sym_preproc_directive] = ACTIONS(1493),
    [anon_sym_LPAREN2] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(1495),
    [anon_sym_TILDE] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_STAR] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1495),
    [anon_sym_subroutine] = ACTIONS(1493),
    [anon_sym_invariant] = ACTIONS(1493),
    [anon_sym_precise] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_in] = ACTIONS(1493),
    [anon_sym_out] = ACTIONS(1493),
    [anon_sym_inout] = ACTIONS(1493),
    [anon_sym_uniform] = ACTIONS(1493),
    [anon_sym_shared] = ACTIONS(1493),
    [anon_sym_attribute] = ACTIONS(1493),
    [anon_sym_varying] = ACTIONS(1493),
    [anon_sym_buffer] = ACTIONS(1493),
    [anon_sym_coherent] = ACTIONS(1493),
    [anon_sym_readonly] = ACTIONS(1493),
    [anon_sym_writeonly] = ACTIONS(1493),
    [anon_sym_precision] = ACTIONS(1493),
    [anon_sym_highp] = ACTIONS(1493),
    [anon_sym_mediump] = ACTIONS(1493),
    [anon_sym_lowp] = ACTIONS(1493),
    [anon_sym_centroid] = ACTIONS(1493),
    [anon_sym_sample] = ACTIONS(1493),
    [anon_sym_patch] = ACTIONS(1493),
    [anon_sym_smooth] = ACTIONS(1493),
    [anon_sym_flat] = ACTIONS(1493),
    [anon_sym_noperspective] = ACTIONS(1493),
    [anon_sym___extension__] = ACTIONS(1493),
    [anon_sym_typedef] = ACTIONS(1493),
    [anon_sym_extern] = ACTIONS(1493),
    [anon_sym___attribute__] = ACTIONS(1493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1495),
    [anon_sym___declspec] = ACTIONS(1493),
    [anon_sym___cdecl] = ACTIONS(1493),
    [anon_sym___clrcall] = ACTIONS(1493),
    [anon_sym___stdcall] = ACTIONS(1493),
    [anon_sym___fastcall] = ACTIONS(1493),
    [anon_sym___thiscall] = ACTIONS(1493),
    [anon_sym___vectorcall] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_signed] = ACTIONS(1493),
    [anon_sym_unsigned] = ACTIONS(1493),
    [anon_sym_long] = ACTIONS(1493),
    [anon_sym_short] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1493),
    [anon_sym_auto] = ACTIONS(1493),
    [anon_sym_register] = ACTIONS(1493),
    [anon_sym_inline] = ACTIONS(1493),
    [anon_sym___inline] = ACTIONS(1493),
    [anon_sym___inline__] = ACTIONS(1493),
    [anon_sym___forceinline] = ACTIONS(1493),
    [anon_sym_thread_local] = ACTIONS(1493),
    [anon_sym___thread] = ACTIONS(1493),
    [anon_sym_const] = ACTIONS(1493),
    [anon_sym_constexpr] = ACTIONS(1493),
    [anon_sym_volatile] = ACTIONS(1493),
    [anon_sym_restrict] = ACTIONS(1493),
    [anon_sym___restrict__] = ACTIONS(1493),
    [anon_sym__Atomic] = ACTIONS(1493),
    [anon_sym__Noreturn] = ACTIONS(1493),
    [anon_sym_noreturn] = ACTIONS(1493),
    [anon_sym_alignas] = ACTIONS(1493),
    [anon_sym__Alignas] = ACTIONS(1493),
    [sym_primitive_type] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1493),
    [anon_sym_struct] = ACTIONS(1493),
    [anon_sym_union] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1493),
    [anon_sym_switch] = ACTIONS(1493),
    [anon_sym_case] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1493),
    [anon_sym_do] = ACTIONS(1493),
    [anon_sym_for] = ACTIONS(1493),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_break] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1493),
    [anon_sym_goto] = ACTIONS(1493),
    [anon_sym___try] = ACTIONS(1493),
    [anon_sym___leave] = ACTIONS(1493),
    [anon_sym_DASH_DASH] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1495),
    [anon_sym_sizeof] = ACTIONS(1493),
    [anon_sym___alignof__] = ACTIONS(1493),
    [anon_sym___alignof] = ACTIONS(1493),
    [anon_sym__alignof] = ACTIONS(1493),
    [anon_sym_alignof] = ACTIONS(1493),
    [anon_sym__Alignof] = ACTIONS(1493),
    [anon_sym_offsetof] = ACTIONS(1493),
    [anon_sym__Generic] = ACTIONS(1493),
    [anon_sym_asm] = ACTIONS(1493),
    [anon_sym___asm__] = ACTIONS(1493),
    [sym_number_literal] = ACTIONS(1495),
    [anon_sym_L_SQUOTE] = ACTIONS(1495),
    [anon_sym_u_SQUOTE] = ACTIONS(1495),
    [anon_sym_U_SQUOTE] = ACTIONS(1495),
    [anon_sym_u8_SQUOTE] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1495),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1493),
    [sym_false] = ACTIONS(1493),
    [anon_sym_NULL] = ACTIONS(1493),
    [anon_sym_nullptr] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1493),
    [anon_sym_hitAttributeEXT] = ACTIONS(1493),
    [anon_sym_callableDataEXT] = ACTIONS(1493),
    [anon_sym_callableDataInEXT] = ACTIONS(1493),
    [anon_sym_shaderRecordEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadNV] = ACTIONS(1493),
    [anon_sym_rayPayloadInNV] = ACTIONS(1493),
    [anon_sym_hitAttributeNV] = ACTIONS(1493),
    [anon_sym_callableDataNV] = ACTIONS(1493),
    [anon_sym_callableDataInNV] = ACTIONS(1493),
    [anon_sym_shaderRecordNV] = ACTIONS(1493),
    [anon_sym_layout] = ACTIONS(1493),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1497),
    [aux_sym_preproc_include_token1] = ACTIONS(1497),
    [aux_sym_preproc_def_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token2] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1497),
    [aux_sym_preproc_else_token1] = ACTIONS(1497),
    [aux_sym_preproc_elif_token1] = ACTIONS(1497),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1497),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1497),
    [sym_preproc_directive] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_subroutine] = ACTIONS(1497),
    [anon_sym_invariant] = ACTIONS(1497),
    [anon_sym_precise] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_in] = ACTIONS(1497),
    [anon_sym_out] = ACTIONS(1497),
    [anon_sym_inout] = ACTIONS(1497),
    [anon_sym_uniform] = ACTIONS(1497),
    [anon_sym_shared] = ACTIONS(1497),
    [anon_sym_attribute] = ACTIONS(1497),
    [anon_sym_varying] = ACTIONS(1497),
    [anon_sym_buffer] = ACTIONS(1497),
    [anon_sym_coherent] = ACTIONS(1497),
    [anon_sym_readonly] = ACTIONS(1497),
    [anon_sym_writeonly] = ACTIONS(1497),
    [anon_sym_precision] = ACTIONS(1497),
    [anon_sym_highp] = ACTIONS(1497),
    [anon_sym_mediump] = ACTIONS(1497),
    [anon_sym_lowp] = ACTIONS(1497),
    [anon_sym_centroid] = ACTIONS(1497),
    [anon_sym_sample] = ACTIONS(1497),
    [anon_sym_patch] = ACTIONS(1497),
    [anon_sym_smooth] = ACTIONS(1497),
    [anon_sym_flat] = ACTIONS(1497),
    [anon_sym_noperspective] = ACTIONS(1497),
    [anon_sym___extension__] = ACTIONS(1497),
    [anon_sym_typedef] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(1497),
    [anon_sym___attribute__] = ACTIONS(1497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1499),
    [anon_sym___declspec] = ACTIONS(1497),
    [anon_sym___cdecl] = ACTIONS(1497),
    [anon_sym___clrcall] = ACTIONS(1497),
    [anon_sym___stdcall] = ACTIONS(1497),
    [anon_sym___fastcall] = ACTIONS(1497),
    [anon_sym___thiscall] = ACTIONS(1497),
    [anon_sym___vectorcall] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_signed] = ACTIONS(1497),
    [anon_sym_unsigned] = ACTIONS(1497),
    [anon_sym_long] = ACTIONS(1497),
    [anon_sym_short] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1497),
    [anon_sym_auto] = ACTIONS(1497),
    [anon_sym_register] = ACTIONS(1497),
    [anon_sym_inline] = ACTIONS(1497),
    [anon_sym___inline] = ACTIONS(1497),
    [anon_sym___inline__] = ACTIONS(1497),
    [anon_sym___forceinline] = ACTIONS(1497),
    [anon_sym_thread_local] = ACTIONS(1497),
    [anon_sym___thread] = ACTIONS(1497),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_alignas] = ACTIONS(1497),
    [anon_sym__Alignas] = ACTIONS(1497),
    [sym_primitive_type] = ACTIONS(1497),
    [anon_sym_enum] = ACTIONS(1497),
    [anon_sym_struct] = ACTIONS(1497),
    [anon_sym_union] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(1497),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1497),
    [anon_sym_default] = ACTIONS(1497),
    [anon_sym_while] = ACTIONS(1497),
    [anon_sym_do] = ACTIONS(1497),
    [anon_sym_for] = ACTIONS(1497),
    [anon_sym_return] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_continue] = ACTIONS(1497),
    [anon_sym_goto] = ACTIONS(1497),
    [anon_sym___try] = ACTIONS(1497),
    [anon_sym___leave] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_sizeof] = ACTIONS(1497),
    [anon_sym___alignof__] = ACTIONS(1497),
    [anon_sym___alignof] = ACTIONS(1497),
    [anon_sym__alignof] = ACTIONS(1497),
    [anon_sym_alignof] = ACTIONS(1497),
    [anon_sym__Alignof] = ACTIONS(1497),
    [anon_sym_offsetof] = ACTIONS(1497),
    [anon_sym__Generic] = ACTIONS(1497),
    [anon_sym_asm] = ACTIONS(1497),
    [anon_sym___asm__] = ACTIONS(1497),
    [sym_number_literal] = ACTIONS(1499),
    [anon_sym_L_SQUOTE] = ACTIONS(1499),
    [anon_sym_u_SQUOTE] = ACTIONS(1499),
    [anon_sym_U_SQUOTE] = ACTIONS(1499),
    [anon_sym_u8_SQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_L_DQUOTE] = ACTIONS(1499),
    [anon_sym_u_DQUOTE] = ACTIONS(1499),
    [anon_sym_U_DQUOTE] = ACTIONS(1499),
    [anon_sym_u8_DQUOTE] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [anon_sym_NULL] = ACTIONS(1497),
    [anon_sym_nullptr] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1497),
    [anon_sym_hitAttributeEXT] = ACTIONS(1497),
    [anon_sym_callableDataEXT] = ACTIONS(1497),
    [anon_sym_callableDataInEXT] = ACTIONS(1497),
    [anon_sym_shaderRecordEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadNV] = ACTIONS(1497),
    [anon_sym_rayPayloadInNV] = ACTIONS(1497),
    [anon_sym_hitAttributeNV] = ACTIONS(1497),
    [anon_sym_callableDataNV] = ACTIONS(1497),
    [anon_sym_callableDataInNV] = ACTIONS(1497),
    [anon_sym_shaderRecordNV] = ACTIONS(1497),
    [anon_sym_layout] = ACTIONS(1497),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1501),
    [aux_sym_preproc_def_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token2] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1501),
    [aux_sym_preproc_else_token1] = ACTIONS(1501),
    [aux_sym_preproc_elif_token1] = ACTIONS(1501),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1501),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1501),
    [sym_preproc_directive] = ACTIONS(1501),
    [anon_sym_LPAREN2] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_subroutine] = ACTIONS(1501),
    [anon_sym_invariant] = ACTIONS(1501),
    [anon_sym_precise] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_in] = ACTIONS(1501),
    [anon_sym_out] = ACTIONS(1501),
    [anon_sym_inout] = ACTIONS(1501),
    [anon_sym_uniform] = ACTIONS(1501),
    [anon_sym_shared] = ACTIONS(1501),
    [anon_sym_attribute] = ACTIONS(1501),
    [anon_sym_varying] = ACTIONS(1501),
    [anon_sym_buffer] = ACTIONS(1501),
    [anon_sym_coherent] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_writeonly] = ACTIONS(1501),
    [anon_sym_precision] = ACTIONS(1501),
    [anon_sym_highp] = ACTIONS(1501),
    [anon_sym_mediump] = ACTIONS(1501),
    [anon_sym_lowp] = ACTIONS(1501),
    [anon_sym_centroid] = ACTIONS(1501),
    [anon_sym_sample] = ACTIONS(1501),
    [anon_sym_patch] = ACTIONS(1501),
    [anon_sym_smooth] = ACTIONS(1501),
    [anon_sym_flat] = ACTIONS(1501),
    [anon_sym_noperspective] = ACTIONS(1501),
    [anon_sym___extension__] = ACTIONS(1501),
    [anon_sym_typedef] = ACTIONS(1501),
    [anon_sym_extern] = ACTIONS(1501),
    [anon_sym___attribute__] = ACTIONS(1501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1503),
    [anon_sym___declspec] = ACTIONS(1501),
    [anon_sym___cdecl] = ACTIONS(1501),
    [anon_sym___clrcall] = ACTIONS(1501),
    [anon_sym___stdcall] = ACTIONS(1501),
    [anon_sym___fastcall] = ACTIONS(1501),
    [anon_sym___thiscall] = ACTIONS(1501),
    [anon_sym___vectorcall] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_signed] = ACTIONS(1501),
    [anon_sym_unsigned] = ACTIONS(1501),
    [anon_sym_long] = ACTIONS(1501),
    [anon_sym_short] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_auto] = ACTIONS(1501),
    [anon_sym_register] = ACTIONS(1501),
    [anon_sym_inline] = ACTIONS(1501),
    [anon_sym___inline] = ACTIONS(1501),
    [anon_sym___inline__] = ACTIONS(1501),
    [anon_sym___forceinline] = ACTIONS(1501),
    [anon_sym_thread_local] = ACTIONS(1501),
    [anon_sym___thread] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_constexpr] = ACTIONS(1501),
    [anon_sym_volatile] = ACTIONS(1501),
    [anon_sym_restrict] = ACTIONS(1501),
    [anon_sym___restrict__] = ACTIONS(1501),
    [anon_sym__Atomic] = ACTIONS(1501),
    [anon_sym__Noreturn] = ACTIONS(1501),
    [anon_sym_noreturn] = ACTIONS(1501),
    [anon_sym_alignas] = ACTIONS(1501),
    [anon_sym__Alignas] = ACTIONS(1501),
    [sym_primitive_type] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [anon_sym_struct] = ACTIONS(1501),
    [anon_sym_union] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_goto] = ACTIONS(1501),
    [anon_sym___try] = ACTIONS(1501),
    [anon_sym___leave] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1503),
    [anon_sym_sizeof] = ACTIONS(1501),
    [anon_sym___alignof__] = ACTIONS(1501),
    [anon_sym___alignof] = ACTIONS(1501),
    [anon_sym__alignof] = ACTIONS(1501),
    [anon_sym_alignof] = ACTIONS(1501),
    [anon_sym__Alignof] = ACTIONS(1501),
    [anon_sym_offsetof] = ACTIONS(1501),
    [anon_sym__Generic] = ACTIONS(1501),
    [anon_sym_asm] = ACTIONS(1501),
    [anon_sym___asm__] = ACTIONS(1501),
    [sym_number_literal] = ACTIONS(1503),
    [anon_sym_L_SQUOTE] = ACTIONS(1503),
    [anon_sym_u_SQUOTE] = ACTIONS(1503),
    [anon_sym_U_SQUOTE] = ACTIONS(1503),
    [anon_sym_u8_SQUOTE] = ACTIONS(1503),
    [anon_sym_SQUOTE] = ACTIONS(1503),
    [anon_sym_L_DQUOTE] = ACTIONS(1503),
    [anon_sym_u_DQUOTE] = ACTIONS(1503),
    [anon_sym_U_DQUOTE] = ACTIONS(1503),
    [anon_sym_u8_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1503),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1501),
    [anon_sym_hitAttributeEXT] = ACTIONS(1501),
    [anon_sym_callableDataEXT] = ACTIONS(1501),
    [anon_sym_callableDataInEXT] = ACTIONS(1501),
    [anon_sym_shaderRecordEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadNV] = ACTIONS(1501),
    [anon_sym_rayPayloadInNV] = ACTIONS(1501),
    [anon_sym_hitAttributeNV] = ACTIONS(1501),
    [anon_sym_callableDataNV] = ACTIONS(1501),
    [anon_sym_callableDataInNV] = ACTIONS(1501),
    [anon_sym_shaderRecordNV] = ACTIONS(1501),
    [anon_sym_layout] = ACTIONS(1501),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token2] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [aux_sym_preproc_else_token1] = ACTIONS(1505),
    [aux_sym_preproc_elif_token1] = ACTIONS(1505),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token2] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [aux_sym_preproc_else_token1] = ACTIONS(1473),
    [aux_sym_preproc_elif_token1] = ACTIONS(1473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1509),
    [aux_sym_preproc_include_token1] = ACTIONS(1509),
    [aux_sym_preproc_def_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token2] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1509),
    [aux_sym_preproc_else_token1] = ACTIONS(1509),
    [aux_sym_preproc_elif_token1] = ACTIONS(1509),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1509),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1509),
    [sym_preproc_directive] = ACTIONS(1509),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_subroutine] = ACTIONS(1509),
    [anon_sym_invariant] = ACTIONS(1509),
    [anon_sym_precise] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_in] = ACTIONS(1509),
    [anon_sym_out] = ACTIONS(1509),
    [anon_sym_inout] = ACTIONS(1509),
    [anon_sym_uniform] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(1509),
    [anon_sym_attribute] = ACTIONS(1509),
    [anon_sym_varying] = ACTIONS(1509),
    [anon_sym_buffer] = ACTIONS(1509),
    [anon_sym_coherent] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_writeonly] = ACTIONS(1509),
    [anon_sym_precision] = ACTIONS(1509),
    [anon_sym_highp] = ACTIONS(1509),
    [anon_sym_mediump] = ACTIONS(1509),
    [anon_sym_lowp] = ACTIONS(1509),
    [anon_sym_centroid] = ACTIONS(1509),
    [anon_sym_sample] = ACTIONS(1509),
    [anon_sym_patch] = ACTIONS(1509),
    [anon_sym_smooth] = ACTIONS(1509),
    [anon_sym_flat] = ACTIONS(1509),
    [anon_sym_noperspective] = ACTIONS(1509),
    [anon_sym___extension__] = ACTIONS(1509),
    [anon_sym_typedef] = ACTIONS(1509),
    [anon_sym_extern] = ACTIONS(1509),
    [anon_sym___attribute__] = ACTIONS(1509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1511),
    [anon_sym___declspec] = ACTIONS(1509),
    [anon_sym___cdecl] = ACTIONS(1509),
    [anon_sym___clrcall] = ACTIONS(1509),
    [anon_sym___stdcall] = ACTIONS(1509),
    [anon_sym___fastcall] = ACTIONS(1509),
    [anon_sym___thiscall] = ACTIONS(1509),
    [anon_sym___vectorcall] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_signed] = ACTIONS(1509),
    [anon_sym_unsigned] = ACTIONS(1509),
    [anon_sym_long] = ACTIONS(1509),
    [anon_sym_short] = ACTIONS(1509),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_auto] = ACTIONS(1509),
    [anon_sym_register] = ACTIONS(1509),
    [anon_sym_inline] = ACTIONS(1509),
    [anon_sym___inline] = ACTIONS(1509),
    [anon_sym___inline__] = ACTIONS(1509),
    [anon_sym___forceinline] = ACTIONS(1509),
    [anon_sym_thread_local] = ACTIONS(1509),
    [anon_sym___thread] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_constexpr] = ACTIONS(1509),
    [anon_sym_volatile] = ACTIONS(1509),
    [anon_sym_restrict] = ACTIONS(1509),
    [anon_sym___restrict__] = ACTIONS(1509),
    [anon_sym__Atomic] = ACTIONS(1509),
    [anon_sym__Noreturn] = ACTIONS(1509),
    [anon_sym_noreturn] = ACTIONS(1509),
    [anon_sym_alignas] = ACTIONS(1509),
    [anon_sym__Alignas] = ACTIONS(1509),
    [sym_primitive_type] = ACTIONS(1509),
    [anon_sym_enum] = ACTIONS(1509),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1509),
    [anon_sym_if] = ACTIONS(1509),
    [anon_sym_switch] = ACTIONS(1509),
    [anon_sym_case] = ACTIONS(1509),
    [anon_sym_default] = ACTIONS(1509),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_do] = ACTIONS(1509),
    [anon_sym_for] = ACTIONS(1509),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_break] = ACTIONS(1509),
    [anon_sym_continue] = ACTIONS(1509),
    [anon_sym_goto] = ACTIONS(1509),
    [anon_sym___try] = ACTIONS(1509),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1509),
    [anon_sym___alignof__] = ACTIONS(1509),
    [anon_sym___alignof] = ACTIONS(1509),
    [anon_sym__alignof] = ACTIONS(1509),
    [anon_sym_alignof] = ACTIONS(1509),
    [anon_sym__Alignof] = ACTIONS(1509),
    [anon_sym_offsetof] = ACTIONS(1509),
    [anon_sym__Generic] = ACTIONS(1509),
    [anon_sym_asm] = ACTIONS(1509),
    [anon_sym___asm__] = ACTIONS(1509),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_L_SQUOTE] = ACTIONS(1511),
    [anon_sym_u_SQUOTE] = ACTIONS(1511),
    [anon_sym_U_SQUOTE] = ACTIONS(1511),
    [anon_sym_u8_SQUOTE] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_L_DQUOTE] = ACTIONS(1511),
    [anon_sym_u_DQUOTE] = ACTIONS(1511),
    [anon_sym_U_DQUOTE] = ACTIONS(1511),
    [anon_sym_u8_DQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [anon_sym_NULL] = ACTIONS(1509),
    [anon_sym_nullptr] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1509),
    [anon_sym_hitAttributeEXT] = ACTIONS(1509),
    [anon_sym_callableDataEXT] = ACTIONS(1509),
    [anon_sym_callableDataInEXT] = ACTIONS(1509),
    [anon_sym_shaderRecordEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadNV] = ACTIONS(1509),
    [anon_sym_rayPayloadInNV] = ACTIONS(1509),
    [anon_sym_hitAttributeNV] = ACTIONS(1509),
    [anon_sym_callableDataNV] = ACTIONS(1509),
    [anon_sym_callableDataInNV] = ACTIONS(1509),
    [anon_sym_shaderRecordNV] = ACTIONS(1509),
    [anon_sym_layout] = ACTIONS(1509),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token2] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [aux_sym_preproc_else_token1] = ACTIONS(1513),
    [aux_sym_preproc_elif_token1] = ACTIONS(1513),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_subroutine] = ACTIONS(1513),
    [anon_sym_invariant] = ACTIONS(1513),
    [anon_sym_precise] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_out] = ACTIONS(1513),
    [anon_sym_inout] = ACTIONS(1513),
    [anon_sym_uniform] = ACTIONS(1513),
    [anon_sym_shared] = ACTIONS(1513),
    [anon_sym_attribute] = ACTIONS(1513),
    [anon_sym_varying] = ACTIONS(1513),
    [anon_sym_buffer] = ACTIONS(1513),
    [anon_sym_coherent] = ACTIONS(1513),
    [anon_sym_readonly] = ACTIONS(1513),
    [anon_sym_writeonly] = ACTIONS(1513),
    [anon_sym_precision] = ACTIONS(1513),
    [anon_sym_highp] = ACTIONS(1513),
    [anon_sym_mediump] = ACTIONS(1513),
    [anon_sym_lowp] = ACTIONS(1513),
    [anon_sym_centroid] = ACTIONS(1513),
    [anon_sym_sample] = ACTIONS(1513),
    [anon_sym_patch] = ACTIONS(1513),
    [anon_sym_smooth] = ACTIONS(1513),
    [anon_sym_flat] = ACTIONS(1513),
    [anon_sym_noperspective] = ACTIONS(1513),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [anon_sym_alignas] = ACTIONS(1513),
    [anon_sym__Alignas] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym___try] = ACTIONS(1513),
    [anon_sym___leave] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1513),
    [anon_sym_hitAttributeEXT] = ACTIONS(1513),
    [anon_sym_callableDataEXT] = ACTIONS(1513),
    [anon_sym_callableDataInEXT] = ACTIONS(1513),
    [anon_sym_shaderRecordEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadNV] = ACTIONS(1513),
    [anon_sym_rayPayloadInNV] = ACTIONS(1513),
    [anon_sym_hitAttributeNV] = ACTIONS(1513),
    [anon_sym_callableDataNV] = ACTIONS(1513),
    [anon_sym_callableDataInNV] = ACTIONS(1513),
    [anon_sym_shaderRecordNV] = ACTIONS(1513),
    [anon_sym_layout] = ACTIONS(1513),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1519),
    [aux_sym_preproc_include_token1] = ACTIONS(1519),
    [aux_sym_preproc_def_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token2] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1519),
    [aux_sym_preproc_else_token1] = ACTIONS(1519),
    [aux_sym_preproc_elif_token1] = ACTIONS(1519),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1519),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1519),
    [sym_preproc_directive] = ACTIONS(1519),
    [anon_sym_LPAREN2] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_subroutine] = ACTIONS(1519),
    [anon_sym_invariant] = ACTIONS(1519),
    [anon_sym_precise] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_out] = ACTIONS(1519),
    [anon_sym_inout] = ACTIONS(1519),
    [anon_sym_uniform] = ACTIONS(1519),
    [anon_sym_shared] = ACTIONS(1519),
    [anon_sym_attribute] = ACTIONS(1519),
    [anon_sym_varying] = ACTIONS(1519),
    [anon_sym_buffer] = ACTIONS(1519),
    [anon_sym_coherent] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_writeonly] = ACTIONS(1519),
    [anon_sym_precision] = ACTIONS(1519),
    [anon_sym_highp] = ACTIONS(1519),
    [anon_sym_mediump] = ACTIONS(1519),
    [anon_sym_lowp] = ACTIONS(1519),
    [anon_sym_centroid] = ACTIONS(1519),
    [anon_sym_sample] = ACTIONS(1519),
    [anon_sym_patch] = ACTIONS(1519),
    [anon_sym_smooth] = ACTIONS(1519),
    [anon_sym_flat] = ACTIONS(1519),
    [anon_sym_noperspective] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(1519),
    [anon_sym_extern] = ACTIONS(1519),
    [anon_sym___attribute__] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1521),
    [anon_sym___declspec] = ACTIONS(1519),
    [anon_sym___cdecl] = ACTIONS(1519),
    [anon_sym___clrcall] = ACTIONS(1519),
    [anon_sym___stdcall] = ACTIONS(1519),
    [anon_sym___fastcall] = ACTIONS(1519),
    [anon_sym___thiscall] = ACTIONS(1519),
    [anon_sym___vectorcall] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_signed] = ACTIONS(1519),
    [anon_sym_unsigned] = ACTIONS(1519),
    [anon_sym_long] = ACTIONS(1519),
    [anon_sym_short] = ACTIONS(1519),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_auto] = ACTIONS(1519),
    [anon_sym_register] = ACTIONS(1519),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym___inline] = ACTIONS(1519),
    [anon_sym___inline__] = ACTIONS(1519),
    [anon_sym___forceinline] = ACTIONS(1519),
    [anon_sym_thread_local] = ACTIONS(1519),
    [anon_sym___thread] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_constexpr] = ACTIONS(1519),
    [anon_sym_volatile] = ACTIONS(1519),
    [anon_sym_restrict] = ACTIONS(1519),
    [anon_sym___restrict__] = ACTIONS(1519),
    [anon_sym__Atomic] = ACTIONS(1519),
    [anon_sym__Noreturn] = ACTIONS(1519),
    [anon_sym_noreturn] = ACTIONS(1519),
    [anon_sym_alignas] = ACTIONS(1519),
    [anon_sym__Alignas] = ACTIONS(1519),
    [sym_primitive_type] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [anon_sym_struct] = ACTIONS(1519),
    [anon_sym_union] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_goto] = ACTIONS(1519),
    [anon_sym___try] = ACTIONS(1519),
    [anon_sym___leave] = ACTIONS(1519),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_sizeof] = ACTIONS(1519),
    [anon_sym___alignof__] = ACTIONS(1519),
    [anon_sym___alignof] = ACTIONS(1519),
    [anon_sym__alignof] = ACTIONS(1519),
    [anon_sym_alignof] = ACTIONS(1519),
    [anon_sym__Alignof] = ACTIONS(1519),
    [anon_sym_offsetof] = ACTIONS(1519),
    [anon_sym__Generic] = ACTIONS(1519),
    [anon_sym_asm] = ACTIONS(1519),
    [anon_sym___asm__] = ACTIONS(1519),
    [sym_number_literal] = ACTIONS(1521),
    [anon_sym_L_SQUOTE] = ACTIONS(1521),
    [anon_sym_u_SQUOTE] = ACTIONS(1521),
    [anon_sym_U_SQUOTE] = ACTIONS(1521),
    [anon_sym_u8_SQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_L_DQUOTE] = ACTIONS(1521),
    [anon_sym_u_DQUOTE] = ACTIONS(1521),
    [anon_sym_U_DQUOTE] = ACTIONS(1521),
    [anon_sym_u8_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [anon_sym_NULL] = ACTIONS(1519),
    [anon_sym_nullptr] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1519),
    [anon_sym_hitAttributeEXT] = ACTIONS(1519),
    [anon_sym_callableDataEXT] = ACTIONS(1519),
    [anon_sym_callableDataInEXT] = ACTIONS(1519),
    [anon_sym_shaderRecordEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadNV] = ACTIONS(1519),
    [anon_sym_rayPayloadInNV] = ACTIONS(1519),
    [anon_sym_hitAttributeNV] = ACTIONS(1519),
    [anon_sym_callableDataNV] = ACTIONS(1519),
    [anon_sym_callableDataInNV] = ACTIONS(1519),
    [anon_sym_shaderRecordNV] = ACTIONS(1519),
    [anon_sym_layout] = ACTIONS(1519),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1523),
    [aux_sym_preproc_include_token1] = ACTIONS(1523),
    [aux_sym_preproc_def_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token2] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1523),
    [aux_sym_preproc_else_token1] = ACTIONS(1523),
    [aux_sym_preproc_elif_token1] = ACTIONS(1523),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1523),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1523),
    [sym_preproc_directive] = ACTIONS(1523),
    [anon_sym_LPAREN2] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_subroutine] = ACTIONS(1523),
    [anon_sym_invariant] = ACTIONS(1523),
    [anon_sym_precise] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_in] = ACTIONS(1523),
    [anon_sym_out] = ACTIONS(1523),
    [anon_sym_inout] = ACTIONS(1523),
    [anon_sym_uniform] = ACTIONS(1523),
    [anon_sym_shared] = ACTIONS(1523),
    [anon_sym_attribute] = ACTIONS(1523),
    [anon_sym_varying] = ACTIONS(1523),
    [anon_sym_buffer] = ACTIONS(1523),
    [anon_sym_coherent] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_writeonly] = ACTIONS(1523),
    [anon_sym_precision] = ACTIONS(1523),
    [anon_sym_highp] = ACTIONS(1523),
    [anon_sym_mediump] = ACTIONS(1523),
    [anon_sym_lowp] = ACTIONS(1523),
    [anon_sym_centroid] = ACTIONS(1523),
    [anon_sym_sample] = ACTIONS(1523),
    [anon_sym_patch] = ACTIONS(1523),
    [anon_sym_smooth] = ACTIONS(1523),
    [anon_sym_flat] = ACTIONS(1523),
    [anon_sym_noperspective] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1523),
    [anon_sym_typedef] = ACTIONS(1523),
    [anon_sym_extern] = ACTIONS(1523),
    [anon_sym___attribute__] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1525),
    [anon_sym___declspec] = ACTIONS(1523),
    [anon_sym___cdecl] = ACTIONS(1523),
    [anon_sym___clrcall] = ACTIONS(1523),
    [anon_sym___stdcall] = ACTIONS(1523),
    [anon_sym___fastcall] = ACTIONS(1523),
    [anon_sym___thiscall] = ACTIONS(1523),
    [anon_sym___vectorcall] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_signed] = ACTIONS(1523),
    [anon_sym_unsigned] = ACTIONS(1523),
    [anon_sym_long] = ACTIONS(1523),
    [anon_sym_short] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_auto] = ACTIONS(1523),
    [anon_sym_register] = ACTIONS(1523),
    [anon_sym_inline] = ACTIONS(1523),
    [anon_sym___inline] = ACTIONS(1523),
    [anon_sym___inline__] = ACTIONS(1523),
    [anon_sym___forceinline] = ACTIONS(1523),
    [anon_sym_thread_local] = ACTIONS(1523),
    [anon_sym___thread] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_constexpr] = ACTIONS(1523),
    [anon_sym_volatile] = ACTIONS(1523),
    [anon_sym_restrict] = ACTIONS(1523),
    [anon_sym___restrict__] = ACTIONS(1523),
    [anon_sym__Atomic] = ACTIONS(1523),
    [anon_sym__Noreturn] = ACTIONS(1523),
    [anon_sym_noreturn] = ACTIONS(1523),
    [anon_sym_alignas] = ACTIONS(1523),
    [anon_sym__Alignas] = ACTIONS(1523),
    [sym_primitive_type] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [anon_sym_struct] = ACTIONS(1523),
    [anon_sym_union] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_goto] = ACTIONS(1523),
    [anon_sym___try] = ACTIONS(1523),
    [anon_sym___leave] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1525),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_sizeof] = ACTIONS(1523),
    [anon_sym___alignof__] = ACTIONS(1523),
    [anon_sym___alignof] = ACTIONS(1523),
    [anon_sym__alignof] = ACTIONS(1523),
    [anon_sym_alignof] = ACTIONS(1523),
    [anon_sym__Alignof] = ACTIONS(1523),
    [anon_sym_offsetof] = ACTIONS(1523),
    [anon_sym__Generic] = ACTIONS(1523),
    [anon_sym_asm] = ACTIONS(1523),
    [anon_sym___asm__] = ACTIONS(1523),
    [sym_number_literal] = ACTIONS(1525),
    [anon_sym_L_SQUOTE] = ACTIONS(1525),
    [anon_sym_u_SQUOTE] = ACTIONS(1525),
    [anon_sym_U_SQUOTE] = ACTIONS(1525),
    [anon_sym_u8_SQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_L_DQUOTE] = ACTIONS(1525),
    [anon_sym_u_DQUOTE] = ACTIONS(1525),
    [anon_sym_U_DQUOTE] = ACTIONS(1525),
    [anon_sym_u8_DQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [anon_sym_NULL] = ACTIONS(1523),
    [anon_sym_nullptr] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1523),
    [anon_sym_hitAttributeEXT] = ACTIONS(1523),
    [anon_sym_callableDataEXT] = ACTIONS(1523),
    [anon_sym_callableDataInEXT] = ACTIONS(1523),
    [anon_sym_shaderRecordEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadNV] = ACTIONS(1523),
    [anon_sym_rayPayloadInNV] = ACTIONS(1523),
    [anon_sym_hitAttributeNV] = ACTIONS(1523),
    [anon_sym_callableDataNV] = ACTIONS(1523),
    [anon_sym_callableDataInNV] = ACTIONS(1523),
    [anon_sym_shaderRecordNV] = ACTIONS(1523),
    [anon_sym_layout] = ACTIONS(1523),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token2] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [aux_sym_preproc_else_token1] = ACTIONS(1505),
    [aux_sym_preproc_elif_token1] = ACTIONS(1505),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [165] = {
    [sym_identifier] = ACTIONS(1527),
    [aux_sym_preproc_include_token1] = ACTIONS(1527),
    [aux_sym_preproc_def_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token2] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1527),
    [aux_sym_preproc_else_token1] = ACTIONS(1527),
    [aux_sym_preproc_elif_token1] = ACTIONS(1527),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1527),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1527),
    [sym_preproc_directive] = ACTIONS(1527),
    [anon_sym_LPAREN2] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_subroutine] = ACTIONS(1527),
    [anon_sym_invariant] = ACTIONS(1527),
    [anon_sym_precise] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1527),
    [anon_sym_out] = ACTIONS(1527),
    [anon_sym_inout] = ACTIONS(1527),
    [anon_sym_uniform] = ACTIONS(1527),
    [anon_sym_shared] = ACTIONS(1527),
    [anon_sym_attribute] = ACTIONS(1527),
    [anon_sym_varying] = ACTIONS(1527),
    [anon_sym_buffer] = ACTIONS(1527),
    [anon_sym_coherent] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_writeonly] = ACTIONS(1527),
    [anon_sym_precision] = ACTIONS(1527),
    [anon_sym_highp] = ACTIONS(1527),
    [anon_sym_mediump] = ACTIONS(1527),
    [anon_sym_lowp] = ACTIONS(1527),
    [anon_sym_centroid] = ACTIONS(1527),
    [anon_sym_sample] = ACTIONS(1527),
    [anon_sym_patch] = ACTIONS(1527),
    [anon_sym_smooth] = ACTIONS(1527),
    [anon_sym_flat] = ACTIONS(1527),
    [anon_sym_noperspective] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1527),
    [anon_sym_typedef] = ACTIONS(1527),
    [anon_sym_extern] = ACTIONS(1527),
    [anon_sym___attribute__] = ACTIONS(1527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1529),
    [anon_sym___declspec] = ACTIONS(1527),
    [anon_sym___cdecl] = ACTIONS(1527),
    [anon_sym___clrcall] = ACTIONS(1527),
    [anon_sym___stdcall] = ACTIONS(1527),
    [anon_sym___fastcall] = ACTIONS(1527),
    [anon_sym___thiscall] = ACTIONS(1527),
    [anon_sym___vectorcall] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_signed] = ACTIONS(1527),
    [anon_sym_unsigned] = ACTIONS(1527),
    [anon_sym_long] = ACTIONS(1527),
    [anon_sym_short] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_auto] = ACTIONS(1527),
    [anon_sym_register] = ACTIONS(1527),
    [anon_sym_inline] = ACTIONS(1527),
    [anon_sym___inline] = ACTIONS(1527),
    [anon_sym___inline__] = ACTIONS(1527),
    [anon_sym___forceinline] = ACTIONS(1527),
    [anon_sym_thread_local] = ACTIONS(1527),
    [anon_sym___thread] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_constexpr] = ACTIONS(1527),
    [anon_sym_volatile] = ACTIONS(1527),
    [anon_sym_restrict] = ACTIONS(1527),
    [anon_sym___restrict__] = ACTIONS(1527),
    [anon_sym__Atomic] = ACTIONS(1527),
    [anon_sym__Noreturn] = ACTIONS(1527),
    [anon_sym_noreturn] = ACTIONS(1527),
    [anon_sym_alignas] = ACTIONS(1527),
    [anon_sym__Alignas] = ACTIONS(1527),
    [sym_primitive_type] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_union] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_goto] = ACTIONS(1527),
    [anon_sym___try] = ACTIONS(1527),
    [anon_sym___leave] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1527),
    [anon_sym___alignof__] = ACTIONS(1527),
    [anon_sym___alignof] = ACTIONS(1527),
    [anon_sym__alignof] = ACTIONS(1527),
    [anon_sym_alignof] = ACTIONS(1527),
    [anon_sym__Alignof] = ACTIONS(1527),
    [anon_sym_offsetof] = ACTIONS(1527),
    [anon_sym__Generic] = ACTIONS(1527),
    [anon_sym_asm] = ACTIONS(1527),
    [anon_sym___asm__] = ACTIONS(1527),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_L_SQUOTE] = ACTIONS(1529),
    [anon_sym_u_SQUOTE] = ACTIONS(1529),
    [anon_sym_U_SQUOTE] = ACTIONS(1529),
    [anon_sym_u8_SQUOTE] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_L_DQUOTE] = ACTIONS(1529),
    [anon_sym_u_DQUOTE] = ACTIONS(1529),
    [anon_sym_U_DQUOTE] = ACTIONS(1529),
    [anon_sym_u8_DQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [anon_sym_NULL] = ACTIONS(1527),
    [anon_sym_nullptr] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1527),
    [anon_sym_hitAttributeEXT] = ACTIONS(1527),
    [anon_sym_callableDataEXT] = ACTIONS(1527),
    [anon_sym_callableDataInEXT] = ACTIONS(1527),
    [anon_sym_shaderRecordEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadNV] = ACTIONS(1527),
    [anon_sym_rayPayloadInNV] = ACTIONS(1527),
    [anon_sym_hitAttributeNV] = ACTIONS(1527),
    [anon_sym_callableDataNV] = ACTIONS(1527),
    [anon_sym_callableDataInNV] = ACTIONS(1527),
    [anon_sym_shaderRecordNV] = ACTIONS(1527),
    [anon_sym_layout] = ACTIONS(1527),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1531),
    [aux_sym_preproc_include_token1] = ACTIONS(1531),
    [aux_sym_preproc_def_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token2] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1531),
    [aux_sym_preproc_else_token1] = ACTIONS(1531),
    [aux_sym_preproc_elif_token1] = ACTIONS(1531),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1531),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1531),
    [sym_preproc_directive] = ACTIONS(1531),
    [anon_sym_LPAREN2] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_subroutine] = ACTIONS(1531),
    [anon_sym_invariant] = ACTIONS(1531),
    [anon_sym_precise] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1531),
    [anon_sym_out] = ACTIONS(1531),
    [anon_sym_inout] = ACTIONS(1531),
    [anon_sym_uniform] = ACTIONS(1531),
    [anon_sym_shared] = ACTIONS(1531),
    [anon_sym_attribute] = ACTIONS(1531),
    [anon_sym_varying] = ACTIONS(1531),
    [anon_sym_buffer] = ACTIONS(1531),
    [anon_sym_coherent] = ACTIONS(1531),
    [anon_sym_readonly] = ACTIONS(1531),
    [anon_sym_writeonly] = ACTIONS(1531),
    [anon_sym_precision] = ACTIONS(1531),
    [anon_sym_highp] = ACTIONS(1531),
    [anon_sym_mediump] = ACTIONS(1531),
    [anon_sym_lowp] = ACTIONS(1531),
    [anon_sym_centroid] = ACTIONS(1531),
    [anon_sym_sample] = ACTIONS(1531),
    [anon_sym_patch] = ACTIONS(1531),
    [anon_sym_smooth] = ACTIONS(1531),
    [anon_sym_flat] = ACTIONS(1531),
    [anon_sym_noperspective] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1531),
    [anon_sym_typedef] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(1531),
    [anon_sym___attribute__] = ACTIONS(1531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1533),
    [anon_sym___declspec] = ACTIONS(1531),
    [anon_sym___cdecl] = ACTIONS(1531),
    [anon_sym___clrcall] = ACTIONS(1531),
    [anon_sym___stdcall] = ACTIONS(1531),
    [anon_sym___fastcall] = ACTIONS(1531),
    [anon_sym___thiscall] = ACTIONS(1531),
    [anon_sym___vectorcall] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_signed] = ACTIONS(1531),
    [anon_sym_unsigned] = ACTIONS(1531),
    [anon_sym_long] = ACTIONS(1531),
    [anon_sym_short] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1531),
    [anon_sym_auto] = ACTIONS(1531),
    [anon_sym_register] = ACTIONS(1531),
    [anon_sym_inline] = ACTIONS(1531),
    [anon_sym___inline] = ACTIONS(1531),
    [anon_sym___inline__] = ACTIONS(1531),
    [anon_sym___forceinline] = ACTIONS(1531),
    [anon_sym_thread_local] = ACTIONS(1531),
    [anon_sym___thread] = ACTIONS(1531),
    [anon_sym_const] = ACTIONS(1531),
    [anon_sym_constexpr] = ACTIONS(1531),
    [anon_sym_volatile] = ACTIONS(1531),
    [anon_sym_restrict] = ACTIONS(1531),
    [anon_sym___restrict__] = ACTIONS(1531),
    [anon_sym__Atomic] = ACTIONS(1531),
    [anon_sym__Noreturn] = ACTIONS(1531),
    [anon_sym_noreturn] = ACTIONS(1531),
    [anon_sym_alignas] = ACTIONS(1531),
    [anon_sym__Alignas] = ACTIONS(1531),
    [sym_primitive_type] = ACTIONS(1531),
    [anon_sym_enum] = ACTIONS(1531),
    [anon_sym_struct] = ACTIONS(1531),
    [anon_sym_union] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_switch] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_do] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_continue] = ACTIONS(1531),
    [anon_sym_goto] = ACTIONS(1531),
    [anon_sym___try] = ACTIONS(1531),
    [anon_sym___leave] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_sizeof] = ACTIONS(1531),
    [anon_sym___alignof__] = ACTIONS(1531),
    [anon_sym___alignof] = ACTIONS(1531),
    [anon_sym__alignof] = ACTIONS(1531),
    [anon_sym_alignof] = ACTIONS(1531),
    [anon_sym__Alignof] = ACTIONS(1531),
    [anon_sym_offsetof] = ACTIONS(1531),
    [anon_sym__Generic] = ACTIONS(1531),
    [anon_sym_asm] = ACTIONS(1531),
    [anon_sym___asm__] = ACTIONS(1531),
    [sym_number_literal] = ACTIONS(1533),
    [anon_sym_L_SQUOTE] = ACTIONS(1533),
    [anon_sym_u_SQUOTE] = ACTIONS(1533),
    [anon_sym_U_SQUOTE] = ACTIONS(1533),
    [anon_sym_u8_SQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_L_DQUOTE] = ACTIONS(1533),
    [anon_sym_u_DQUOTE] = ACTIONS(1533),
    [anon_sym_U_DQUOTE] = ACTIONS(1533),
    [anon_sym_u8_DQUOTE] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [anon_sym_NULL] = ACTIONS(1531),
    [anon_sym_nullptr] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1531),
    [anon_sym_hitAttributeEXT] = ACTIONS(1531),
    [anon_sym_callableDataEXT] = ACTIONS(1531),
    [anon_sym_callableDataInEXT] = ACTIONS(1531),
    [anon_sym_shaderRecordEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadNV] = ACTIONS(1531),
    [anon_sym_rayPayloadInNV] = ACTIONS(1531),
    [anon_sym_hitAttributeNV] = ACTIONS(1531),
    [anon_sym_callableDataNV] = ACTIONS(1531),
    [anon_sym_callableDataInNV] = ACTIONS(1531),
    [anon_sym_shaderRecordNV] = ACTIONS(1531),
    [anon_sym_layout] = ACTIONS(1531),
  },
  [167] = {
    [sym_identifier] = ACTIONS(1535),
    [aux_sym_preproc_include_token1] = ACTIONS(1535),
    [aux_sym_preproc_def_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token2] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1535),
    [aux_sym_preproc_else_token1] = ACTIONS(1535),
    [aux_sym_preproc_elif_token1] = ACTIONS(1535),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1535),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1535),
    [sym_preproc_directive] = ACTIONS(1535),
    [anon_sym_LPAREN2] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_subroutine] = ACTIONS(1535),
    [anon_sym_invariant] = ACTIONS(1535),
    [anon_sym_precise] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_in] = ACTIONS(1535),
    [anon_sym_out] = ACTIONS(1535),
    [anon_sym_inout] = ACTIONS(1535),
    [anon_sym_uniform] = ACTIONS(1535),
    [anon_sym_shared] = ACTIONS(1535),
    [anon_sym_attribute] = ACTIONS(1535),
    [anon_sym_varying] = ACTIONS(1535),
    [anon_sym_buffer] = ACTIONS(1535),
    [anon_sym_coherent] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_writeonly] = ACTIONS(1535),
    [anon_sym_precision] = ACTIONS(1535),
    [anon_sym_highp] = ACTIONS(1535),
    [anon_sym_mediump] = ACTIONS(1535),
    [anon_sym_lowp] = ACTIONS(1535),
    [anon_sym_centroid] = ACTIONS(1535),
    [anon_sym_sample] = ACTIONS(1535),
    [anon_sym_patch] = ACTIONS(1535),
    [anon_sym_smooth] = ACTIONS(1535),
    [anon_sym_flat] = ACTIONS(1535),
    [anon_sym_noperspective] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1535),
    [anon_sym_typedef] = ACTIONS(1535),
    [anon_sym_extern] = ACTIONS(1535),
    [anon_sym___attribute__] = ACTIONS(1535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1537),
    [anon_sym___declspec] = ACTIONS(1535),
    [anon_sym___cdecl] = ACTIONS(1535),
    [anon_sym___clrcall] = ACTIONS(1535),
    [anon_sym___stdcall] = ACTIONS(1535),
    [anon_sym___fastcall] = ACTIONS(1535),
    [anon_sym___thiscall] = ACTIONS(1535),
    [anon_sym___vectorcall] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_signed] = ACTIONS(1535),
    [anon_sym_unsigned] = ACTIONS(1535),
    [anon_sym_long] = ACTIONS(1535),
    [anon_sym_short] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_auto] = ACTIONS(1535),
    [anon_sym_register] = ACTIONS(1535),
    [anon_sym_inline] = ACTIONS(1535),
    [anon_sym___inline] = ACTIONS(1535),
    [anon_sym___inline__] = ACTIONS(1535),
    [anon_sym___forceinline] = ACTIONS(1535),
    [anon_sym_thread_local] = ACTIONS(1535),
    [anon_sym___thread] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_constexpr] = ACTIONS(1535),
    [anon_sym_volatile] = ACTIONS(1535),
    [anon_sym_restrict] = ACTIONS(1535),
    [anon_sym___restrict__] = ACTIONS(1535),
    [anon_sym__Atomic] = ACTIONS(1535),
    [anon_sym__Noreturn] = ACTIONS(1535),
    [anon_sym_noreturn] = ACTIONS(1535),
    [anon_sym_alignas] = ACTIONS(1535),
    [anon_sym__Alignas] = ACTIONS(1535),
    [sym_primitive_type] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [anon_sym_struct] = ACTIONS(1535),
    [anon_sym_union] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_goto] = ACTIONS(1535),
    [anon_sym___try] = ACTIONS(1535),
    [anon_sym___leave] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_sizeof] = ACTIONS(1535),
    [anon_sym___alignof__] = ACTIONS(1535),
    [anon_sym___alignof] = ACTIONS(1535),
    [anon_sym__alignof] = ACTIONS(1535),
    [anon_sym_alignof] = ACTIONS(1535),
    [anon_sym__Alignof] = ACTIONS(1535),
    [anon_sym_offsetof] = ACTIONS(1535),
    [anon_sym__Generic] = ACTIONS(1535),
    [anon_sym_asm] = ACTIONS(1535),
    [anon_sym___asm__] = ACTIONS(1535),
    [sym_number_literal] = ACTIONS(1537),
    [anon_sym_L_SQUOTE] = ACTIONS(1537),
    [anon_sym_u_SQUOTE] = ACTIONS(1537),
    [anon_sym_U_SQUOTE] = ACTIONS(1537),
    [anon_sym_u8_SQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_L_DQUOTE] = ACTIONS(1537),
    [anon_sym_u_DQUOTE] = ACTIONS(1537),
    [anon_sym_U_DQUOTE] = ACTIONS(1537),
    [anon_sym_u8_DQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [anon_sym_NULL] = ACTIONS(1535),
    [anon_sym_nullptr] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1535),
    [anon_sym_hitAttributeEXT] = ACTIONS(1535),
    [anon_sym_callableDataEXT] = ACTIONS(1535),
    [anon_sym_callableDataInEXT] = ACTIONS(1535),
    [anon_sym_shaderRecordEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadNV] = ACTIONS(1535),
    [anon_sym_rayPayloadInNV] = ACTIONS(1535),
    [anon_sym_hitAttributeNV] = ACTIONS(1535),
    [anon_sym_callableDataNV] = ACTIONS(1535),
    [anon_sym_callableDataInNV] = ACTIONS(1535),
    [anon_sym_shaderRecordNV] = ACTIONS(1535),
    [anon_sym_layout] = ACTIONS(1535),
  },
  [168] = {
    [sym_else_clause] = STATE(279),
    [sym_identifier] = ACTIONS(1227),
    [aux_sym_preproc_include_token1] = ACTIONS(1227),
    [aux_sym_preproc_def_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1227),
    [sym_preproc_directive] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_subroutine] = ACTIONS(1227),
    [anon_sym_invariant] = ACTIONS(1227),
    [anon_sym_precise] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_out] = ACTIONS(1227),
    [anon_sym_inout] = ACTIONS(1227),
    [anon_sym_uniform] = ACTIONS(1227),
    [anon_sym_shared] = ACTIONS(1227),
    [anon_sym_attribute] = ACTIONS(1227),
    [anon_sym_varying] = ACTIONS(1227),
    [anon_sym_buffer] = ACTIONS(1227),
    [anon_sym_coherent] = ACTIONS(1227),
    [anon_sym_readonly] = ACTIONS(1227),
    [anon_sym_writeonly] = ACTIONS(1227),
    [anon_sym_precision] = ACTIONS(1227),
    [anon_sym_highp] = ACTIONS(1227),
    [anon_sym_mediump] = ACTIONS(1227),
    [anon_sym_lowp] = ACTIONS(1227),
    [anon_sym_centroid] = ACTIONS(1227),
    [anon_sym_sample] = ACTIONS(1227),
    [anon_sym_patch] = ACTIONS(1227),
    [anon_sym_smooth] = ACTIONS(1227),
    [anon_sym_flat] = ACTIONS(1227),
    [anon_sym_noperspective] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym___attribute__] = ACTIONS(1227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1229),
    [anon_sym___declspec] = ACTIONS(1227),
    [anon_sym___cdecl] = ACTIONS(1227),
    [anon_sym___clrcall] = ACTIONS(1227),
    [anon_sym___stdcall] = ACTIONS(1227),
    [anon_sym___fastcall] = ACTIONS(1227),
    [anon_sym___thiscall] = ACTIONS(1227),
    [anon_sym___vectorcall] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_signed] = ACTIONS(1227),
    [anon_sym_unsigned] = ACTIONS(1227),
    [anon_sym_long] = ACTIONS(1227),
    [anon_sym_short] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_auto] = ACTIONS(1227),
    [anon_sym_register] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym___inline] = ACTIONS(1227),
    [anon_sym___inline__] = ACTIONS(1227),
    [anon_sym___forceinline] = ACTIONS(1227),
    [anon_sym_thread_local] = ACTIONS(1227),
    [anon_sym___thread] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_constexpr] = ACTIONS(1227),
    [anon_sym_volatile] = ACTIONS(1227),
    [anon_sym_restrict] = ACTIONS(1227),
    [anon_sym___restrict__] = ACTIONS(1227),
    [anon_sym__Atomic] = ACTIONS(1227),
    [anon_sym__Noreturn] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_alignas] = ACTIONS(1227),
    [anon_sym__Alignas] = ACTIONS(1227),
    [sym_primitive_type] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1539),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_goto] = ACTIONS(1227),
    [anon_sym___try] = ACTIONS(1227),
    [anon_sym___leave] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_sizeof] = ACTIONS(1227),
    [anon_sym___alignof__] = ACTIONS(1227),
    [anon_sym___alignof] = ACTIONS(1227),
    [anon_sym__alignof] = ACTIONS(1227),
    [anon_sym_alignof] = ACTIONS(1227),
    [anon_sym__Alignof] = ACTIONS(1227),
    [anon_sym_offsetof] = ACTIONS(1227),
    [anon_sym__Generic] = ACTIONS(1227),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym___asm__] = ACTIONS(1227),
    [sym_number_literal] = ACTIONS(1229),
    [anon_sym_L_SQUOTE] = ACTIONS(1229),
    [anon_sym_u_SQUOTE] = ACTIONS(1229),
    [anon_sym_U_SQUOTE] = ACTIONS(1229),
    [anon_sym_u8_SQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_L_DQUOTE] = ACTIONS(1229),
    [anon_sym_u_DQUOTE] = ACTIONS(1229),
    [anon_sym_U_DQUOTE] = ACTIONS(1229),
    [anon_sym_u8_DQUOTE] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [anon_sym_NULL] = ACTIONS(1227),
    [anon_sym_nullptr] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1227),
    [anon_sym_hitAttributeEXT] = ACTIONS(1227),
    [anon_sym_callableDataEXT] = ACTIONS(1227),
    [anon_sym_callableDataInEXT] = ACTIONS(1227),
    [anon_sym_shaderRecordEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadNV] = ACTIONS(1227),
    [anon_sym_rayPayloadInNV] = ACTIONS(1227),
    [anon_sym_hitAttributeNV] = ACTIONS(1227),
    [anon_sym_callableDataNV] = ACTIONS(1227),
    [anon_sym_callableDataInNV] = ACTIONS(1227),
    [anon_sym_shaderRecordNV] = ACTIONS(1227),
    [anon_sym_layout] = ACTIONS(1227),
  },
  [169] = {
    [sym_else_clause] = STATE(211),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(1227),
    [aux_sym_preproc_include_token1] = ACTIONS(1227),
    [aux_sym_preproc_def_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1227),
    [sym_preproc_directive] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_subroutine] = ACTIONS(1227),
    [anon_sym_invariant] = ACTIONS(1227),
    [anon_sym_precise] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_out] = ACTIONS(1227),
    [anon_sym_inout] = ACTIONS(1227),
    [anon_sym_uniform] = ACTIONS(1227),
    [anon_sym_shared] = ACTIONS(1227),
    [anon_sym_attribute] = ACTIONS(1227),
    [anon_sym_varying] = ACTIONS(1227),
    [anon_sym_buffer] = ACTIONS(1227),
    [anon_sym_coherent] = ACTIONS(1227),
    [anon_sym_readonly] = ACTIONS(1227),
    [anon_sym_writeonly] = ACTIONS(1227),
    [anon_sym_precision] = ACTIONS(1227),
    [anon_sym_highp] = ACTIONS(1227),
    [anon_sym_mediump] = ACTIONS(1227),
    [anon_sym_lowp] = ACTIONS(1227),
    [anon_sym_centroid] = ACTIONS(1227),
    [anon_sym_sample] = ACTIONS(1227),
    [anon_sym_patch] = ACTIONS(1227),
    [anon_sym_smooth] = ACTIONS(1227),
    [anon_sym_flat] = ACTIONS(1227),
    [anon_sym_noperspective] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym___attribute__] = ACTIONS(1227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1229),
    [anon_sym___declspec] = ACTIONS(1227),
    [anon_sym___cdecl] = ACTIONS(1227),
    [anon_sym___clrcall] = ACTIONS(1227),
    [anon_sym___stdcall] = ACTIONS(1227),
    [anon_sym___fastcall] = ACTIONS(1227),
    [anon_sym___thiscall] = ACTIONS(1227),
    [anon_sym___vectorcall] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_signed] = ACTIONS(1227),
    [anon_sym_unsigned] = ACTIONS(1227),
    [anon_sym_long] = ACTIONS(1227),
    [anon_sym_short] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_auto] = ACTIONS(1227),
    [anon_sym_register] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym___inline] = ACTIONS(1227),
    [anon_sym___inline__] = ACTIONS(1227),
    [anon_sym___forceinline] = ACTIONS(1227),
    [anon_sym_thread_local] = ACTIONS(1227),
    [anon_sym___thread] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_constexpr] = ACTIONS(1227),
    [anon_sym_volatile] = ACTIONS(1227),
    [anon_sym_restrict] = ACTIONS(1227),
    [anon_sym___restrict__] = ACTIONS(1227),
    [anon_sym__Atomic] = ACTIONS(1227),
    [anon_sym__Noreturn] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_alignas] = ACTIONS(1227),
    [anon_sym__Alignas] = ACTIONS(1227),
    [sym_primitive_type] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1541),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_goto] = ACTIONS(1227),
    [anon_sym___try] = ACTIONS(1227),
    [anon_sym___leave] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_sizeof] = ACTIONS(1227),
    [anon_sym___alignof__] = ACTIONS(1227),
    [anon_sym___alignof] = ACTIONS(1227),
    [anon_sym__alignof] = ACTIONS(1227),
    [anon_sym_alignof] = ACTIONS(1227),
    [anon_sym__Alignof] = ACTIONS(1227),
    [anon_sym_offsetof] = ACTIONS(1227),
    [anon_sym__Generic] = ACTIONS(1227),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym___asm__] = ACTIONS(1227),
    [sym_number_literal] = ACTIONS(1229),
    [anon_sym_L_SQUOTE] = ACTIONS(1229),
    [anon_sym_u_SQUOTE] = ACTIONS(1229),
    [anon_sym_U_SQUOTE] = ACTIONS(1229),
    [anon_sym_u8_SQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_L_DQUOTE] = ACTIONS(1229),
    [anon_sym_u_DQUOTE] = ACTIONS(1229),
    [anon_sym_U_DQUOTE] = ACTIONS(1229),
    [anon_sym_u8_DQUOTE] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [anon_sym_NULL] = ACTIONS(1227),
    [anon_sym_nullptr] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1227),
    [anon_sym_hitAttributeEXT] = ACTIONS(1227),
    [anon_sym_callableDataEXT] = ACTIONS(1227),
    [anon_sym_callableDataInEXT] = ACTIONS(1227),
    [anon_sym_shaderRecordEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadNV] = ACTIONS(1227),
    [anon_sym_rayPayloadInNV] = ACTIONS(1227),
    [anon_sym_hitAttributeNV] = ACTIONS(1227),
    [anon_sym_callableDataNV] = ACTIONS(1227),
    [anon_sym_callableDataInNV] = ACTIONS(1227),
    [anon_sym_shaderRecordNV] = ACTIONS(1227),
    [anon_sym_layout] = ACTIONS(1227),
  },
  [170] = {
    [sym_else_clause] = STATE(172),
    [sym_identifier] = ACTIONS(1227),
    [aux_sym_preproc_include_token1] = ACTIONS(1227),
    [aux_sym_preproc_def_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token1] = ACTIONS(1227),
    [aux_sym_preproc_if_token2] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1227),
    [sym_preproc_directive] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_subroutine] = ACTIONS(1227),
    [anon_sym_invariant] = ACTIONS(1227),
    [anon_sym_precise] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_out] = ACTIONS(1227),
    [anon_sym_inout] = ACTIONS(1227),
    [anon_sym_uniform] = ACTIONS(1227),
    [anon_sym_shared] = ACTIONS(1227),
    [anon_sym_attribute] = ACTIONS(1227),
    [anon_sym_varying] = ACTIONS(1227),
    [anon_sym_buffer] = ACTIONS(1227),
    [anon_sym_coherent] = ACTIONS(1227),
    [anon_sym_readonly] = ACTIONS(1227),
    [anon_sym_writeonly] = ACTIONS(1227),
    [anon_sym_precision] = ACTIONS(1227),
    [anon_sym_highp] = ACTIONS(1227),
    [anon_sym_mediump] = ACTIONS(1227),
    [anon_sym_lowp] = ACTIONS(1227),
    [anon_sym_centroid] = ACTIONS(1227),
    [anon_sym_sample] = ACTIONS(1227),
    [anon_sym_patch] = ACTIONS(1227),
    [anon_sym_smooth] = ACTIONS(1227),
    [anon_sym_flat] = ACTIONS(1227),
    [anon_sym_noperspective] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym___attribute__] = ACTIONS(1227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1229),
    [anon_sym___declspec] = ACTIONS(1227),
    [anon_sym___cdecl] = ACTIONS(1227),
    [anon_sym___clrcall] = ACTIONS(1227),
    [anon_sym___stdcall] = ACTIONS(1227),
    [anon_sym___fastcall] = ACTIONS(1227),
    [anon_sym___thiscall] = ACTIONS(1227),
    [anon_sym___vectorcall] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_signed] = ACTIONS(1227),
    [anon_sym_unsigned] = ACTIONS(1227),
    [anon_sym_long] = ACTIONS(1227),
    [anon_sym_short] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_auto] = ACTIONS(1227),
    [anon_sym_register] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym___inline] = ACTIONS(1227),
    [anon_sym___inline__] = ACTIONS(1227),
    [anon_sym___forceinline] = ACTIONS(1227),
    [anon_sym_thread_local] = ACTIONS(1227),
    [anon_sym___thread] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_constexpr] = ACTIONS(1227),
    [anon_sym_volatile] = ACTIONS(1227),
    [anon_sym_restrict] = ACTIONS(1227),
    [anon_sym___restrict__] = ACTIONS(1227),
    [anon_sym__Atomic] = ACTIONS(1227),
    [anon_sym__Noreturn] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_alignas] = ACTIONS(1227),
    [anon_sym__Alignas] = ACTIONS(1227),
    [sym_primitive_type] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_goto] = ACTIONS(1227),
    [anon_sym___try] = ACTIONS(1227),
    [anon_sym___leave] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_sizeof] = ACTIONS(1227),
    [anon_sym___alignof__] = ACTIONS(1227),
    [anon_sym___alignof] = ACTIONS(1227),
    [anon_sym__alignof] = ACTIONS(1227),
    [anon_sym_alignof] = ACTIONS(1227),
    [anon_sym__Alignof] = ACTIONS(1227),
    [anon_sym_offsetof] = ACTIONS(1227),
    [anon_sym__Generic] = ACTIONS(1227),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym___asm__] = ACTIONS(1227),
    [sym_number_literal] = ACTIONS(1229),
    [anon_sym_L_SQUOTE] = ACTIONS(1229),
    [anon_sym_u_SQUOTE] = ACTIONS(1229),
    [anon_sym_U_SQUOTE] = ACTIONS(1229),
    [anon_sym_u8_SQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_L_DQUOTE] = ACTIONS(1229),
    [anon_sym_u_DQUOTE] = ACTIONS(1229),
    [anon_sym_U_DQUOTE] = ACTIONS(1229),
    [anon_sym_u8_DQUOTE] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [anon_sym_NULL] = ACTIONS(1227),
    [anon_sym_nullptr] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1227),
    [anon_sym_hitAttributeEXT] = ACTIONS(1227),
    [anon_sym_callableDataEXT] = ACTIONS(1227),
    [anon_sym_callableDataInEXT] = ACTIONS(1227),
    [anon_sym_shaderRecordEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadNV] = ACTIONS(1227),
    [anon_sym_rayPayloadInNV] = ACTIONS(1227),
    [anon_sym_hitAttributeNV] = ACTIONS(1227),
    [anon_sym_callableDataNV] = ACTIONS(1227),
    [anon_sym_callableDataInNV] = ACTIONS(1227),
    [anon_sym_shaderRecordNV] = ACTIONS(1227),
    [anon_sym_layout] = ACTIONS(1227),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1393),
    [aux_sym_preproc_include_token1] = ACTIONS(1393),
    [aux_sym_preproc_def_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_LPAREN2] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1393),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_subroutine] = ACTIONS(1393),
    [anon_sym_invariant] = ACTIONS(1393),
    [anon_sym_precise] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1393),
    [anon_sym_out] = ACTIONS(1393),
    [anon_sym_inout] = ACTIONS(1393),
    [anon_sym_uniform] = ACTIONS(1393),
    [anon_sym_shared] = ACTIONS(1393),
    [anon_sym_attribute] = ACTIONS(1393),
    [anon_sym_varying] = ACTIONS(1393),
    [anon_sym_buffer] = ACTIONS(1393),
    [anon_sym_coherent] = ACTIONS(1393),
    [anon_sym_readonly] = ACTIONS(1393),
    [anon_sym_writeonly] = ACTIONS(1393),
    [anon_sym_precision] = ACTIONS(1393),
    [anon_sym_highp] = ACTIONS(1393),
    [anon_sym_mediump] = ACTIONS(1393),
    [anon_sym_lowp] = ACTIONS(1393),
    [anon_sym_centroid] = ACTIONS(1393),
    [anon_sym_sample] = ACTIONS(1393),
    [anon_sym_patch] = ACTIONS(1393),
    [anon_sym_smooth] = ACTIONS(1393),
    [anon_sym_flat] = ACTIONS(1393),
    [anon_sym_noperspective] = ACTIONS(1393),
    [anon_sym___extension__] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym___attribute__] = ACTIONS(1393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1395),
    [anon_sym___declspec] = ACTIONS(1393),
    [anon_sym___cdecl] = ACTIONS(1393),
    [anon_sym___clrcall] = ACTIONS(1393),
    [anon_sym___stdcall] = ACTIONS(1393),
    [anon_sym___fastcall] = ACTIONS(1393),
    [anon_sym___thiscall] = ACTIONS(1393),
    [anon_sym___vectorcall] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(1395),
    [anon_sym_signed] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym___inline] = ACTIONS(1393),
    [anon_sym___inline__] = ACTIONS(1393),
    [anon_sym___forceinline] = ACTIONS(1393),
    [anon_sym_thread_local] = ACTIONS(1393),
    [anon_sym___thread] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_constexpr] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym___restrict__] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym__Noreturn] = ACTIONS(1393),
    [anon_sym_noreturn] = ACTIONS(1393),
    [anon_sym_alignas] = ACTIONS(1393),
    [anon_sym__Alignas] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1393),
    [anon_sym_do] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_return] = ACTIONS(1393),
    [anon_sym_break] = ACTIONS(1393),
    [anon_sym_continue] = ACTIONS(1393),
    [anon_sym_goto] = ACTIONS(1393),
    [anon_sym___try] = ACTIONS(1393),
    [anon_sym___leave] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1395),
    [anon_sym_sizeof] = ACTIONS(1393),
    [anon_sym___alignof__] = ACTIONS(1393),
    [anon_sym___alignof] = ACTIONS(1393),
    [anon_sym__alignof] = ACTIONS(1393),
    [anon_sym_alignof] = ACTIONS(1393),
    [anon_sym__Alignof] = ACTIONS(1393),
    [anon_sym_offsetof] = ACTIONS(1393),
    [anon_sym__Generic] = ACTIONS(1393),
    [anon_sym_asm] = ACTIONS(1393),
    [anon_sym___asm__] = ACTIONS(1393),
    [sym_number_literal] = ACTIONS(1395),
    [anon_sym_L_SQUOTE] = ACTIONS(1395),
    [anon_sym_u_SQUOTE] = ACTIONS(1395),
    [anon_sym_U_SQUOTE] = ACTIONS(1395),
    [anon_sym_u8_SQUOTE] = ACTIONS(1395),
    [anon_sym_SQUOTE] = ACTIONS(1395),
    [anon_sym_L_DQUOTE] = ACTIONS(1395),
    [anon_sym_u_DQUOTE] = ACTIONS(1395),
    [anon_sym_U_DQUOTE] = ACTIONS(1395),
    [anon_sym_u8_DQUOTE] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [anon_sym_NULL] = ACTIONS(1393),
    [anon_sym_nullptr] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1393),
    [anon_sym_hitAttributeEXT] = ACTIONS(1393),
    [anon_sym_callableDataEXT] = ACTIONS(1393),
    [anon_sym_callableDataInEXT] = ACTIONS(1393),
    [anon_sym_shaderRecordEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadNV] = ACTIONS(1393),
    [anon_sym_rayPayloadInNV] = ACTIONS(1393),
    [anon_sym_hitAttributeNV] = ACTIONS(1393),
    [anon_sym_callableDataNV] = ACTIONS(1393),
    [anon_sym_callableDataInNV] = ACTIONS(1393),
    [anon_sym_shaderRecordNV] = ACTIONS(1393),
    [anon_sym_layout] = ACTIONS(1393),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token2] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_subroutine] = ACTIONS(1269),
    [anon_sym_invariant] = ACTIONS(1269),
    [anon_sym_precise] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_out] = ACTIONS(1269),
    [anon_sym_inout] = ACTIONS(1269),
    [anon_sym_uniform] = ACTIONS(1269),
    [anon_sym_shared] = ACTIONS(1269),
    [anon_sym_attribute] = ACTIONS(1269),
    [anon_sym_varying] = ACTIONS(1269),
    [anon_sym_buffer] = ACTIONS(1269),
    [anon_sym_coherent] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_writeonly] = ACTIONS(1269),
    [anon_sym_precision] = ACTIONS(1269),
    [anon_sym_highp] = ACTIONS(1269),
    [anon_sym_mediump] = ACTIONS(1269),
    [anon_sym_lowp] = ACTIONS(1269),
    [anon_sym_centroid] = ACTIONS(1269),
    [anon_sym_sample] = ACTIONS(1269),
    [anon_sym_patch] = ACTIONS(1269),
    [anon_sym_smooth] = ACTIONS(1269),
    [anon_sym_flat] = ACTIONS(1269),
    [anon_sym_noperspective] = ACTIONS(1269),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1269),
    [anon_sym_hitAttributeEXT] = ACTIONS(1269),
    [anon_sym_callableDataEXT] = ACTIONS(1269),
    [anon_sym_callableDataInEXT] = ACTIONS(1269),
    [anon_sym_shaderRecordEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadNV] = ACTIONS(1269),
    [anon_sym_rayPayloadInNV] = ACTIONS(1269),
    [anon_sym_hitAttributeNV] = ACTIONS(1269),
    [anon_sym_callableDataNV] = ACTIONS(1269),
    [anon_sym_callableDataInNV] = ACTIONS(1269),
    [anon_sym_shaderRecordNV] = ACTIONS(1269),
    [anon_sym_layout] = ACTIONS(1269),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_subroutine] = ACTIONS(1233),
    [anon_sym_invariant] = ACTIONS(1233),
    [anon_sym_precise] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1233),
    [anon_sym_out] = ACTIONS(1233),
    [anon_sym_inout] = ACTIONS(1233),
    [anon_sym_uniform] = ACTIONS(1233),
    [anon_sym_shared] = ACTIONS(1233),
    [anon_sym_attribute] = ACTIONS(1233),
    [anon_sym_varying] = ACTIONS(1233),
    [anon_sym_buffer] = ACTIONS(1233),
    [anon_sym_coherent] = ACTIONS(1233),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_writeonly] = ACTIONS(1233),
    [anon_sym_precision] = ACTIONS(1233),
    [anon_sym_highp] = ACTIONS(1233),
    [anon_sym_mediump] = ACTIONS(1233),
    [anon_sym_lowp] = ACTIONS(1233),
    [anon_sym_centroid] = ACTIONS(1233),
    [anon_sym_sample] = ACTIONS(1233),
    [anon_sym_patch] = ACTIONS(1233),
    [anon_sym_smooth] = ACTIONS(1233),
    [anon_sym_flat] = ACTIONS(1233),
    [anon_sym_noperspective] = ACTIONS(1233),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1233),
    [anon_sym_hitAttributeEXT] = ACTIONS(1233),
    [anon_sym_callableDataEXT] = ACTIONS(1233),
    [anon_sym_callableDataInEXT] = ACTIONS(1233),
    [anon_sym_shaderRecordEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadNV] = ACTIONS(1233),
    [anon_sym_rayPayloadInNV] = ACTIONS(1233),
    [anon_sym_hitAttributeNV] = ACTIONS(1233),
    [anon_sym_callableDataNV] = ACTIONS(1233),
    [anon_sym_callableDataInNV] = ACTIONS(1233),
    [anon_sym_shaderRecordNV] = ACTIONS(1233),
    [anon_sym_layout] = ACTIONS(1233),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1379),
    [sym_identifier] = ACTIONS(1377),
    [aux_sym_preproc_include_token1] = ACTIONS(1377),
    [aux_sym_preproc_def_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1377),
    [sym_preproc_directive] = ACTIONS(1377),
    [anon_sym_LPAREN2] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_subroutine] = ACTIONS(1377),
    [anon_sym_invariant] = ACTIONS(1377),
    [anon_sym_precise] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_in] = ACTIONS(1377),
    [anon_sym_out] = ACTIONS(1377),
    [anon_sym_inout] = ACTIONS(1377),
    [anon_sym_uniform] = ACTIONS(1377),
    [anon_sym_shared] = ACTIONS(1377),
    [anon_sym_attribute] = ACTIONS(1377),
    [anon_sym_varying] = ACTIONS(1377),
    [anon_sym_buffer] = ACTIONS(1377),
    [anon_sym_coherent] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_writeonly] = ACTIONS(1377),
    [anon_sym_precision] = ACTIONS(1377),
    [anon_sym_highp] = ACTIONS(1377),
    [anon_sym_mediump] = ACTIONS(1377),
    [anon_sym_lowp] = ACTIONS(1377),
    [anon_sym_centroid] = ACTIONS(1377),
    [anon_sym_sample] = ACTIONS(1377),
    [anon_sym_patch] = ACTIONS(1377),
    [anon_sym_smooth] = ACTIONS(1377),
    [anon_sym_flat] = ACTIONS(1377),
    [anon_sym_noperspective] = ACTIONS(1377),
    [anon_sym___extension__] = ACTIONS(1377),
    [anon_sym_typedef] = ACTIONS(1377),
    [anon_sym_extern] = ACTIONS(1377),
    [anon_sym___attribute__] = ACTIONS(1377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1379),
    [anon_sym___declspec] = ACTIONS(1377),
    [anon_sym___cdecl] = ACTIONS(1377),
    [anon_sym___clrcall] = ACTIONS(1377),
    [anon_sym___stdcall] = ACTIONS(1377),
    [anon_sym___fastcall] = ACTIONS(1377),
    [anon_sym___thiscall] = ACTIONS(1377),
    [anon_sym___vectorcall] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_signed] = ACTIONS(1377),
    [anon_sym_unsigned] = ACTIONS(1377),
    [anon_sym_long] = ACTIONS(1377),
    [anon_sym_short] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_auto] = ACTIONS(1377),
    [anon_sym_register] = ACTIONS(1377),
    [anon_sym_inline] = ACTIONS(1377),
    [anon_sym___inline] = ACTIONS(1377),
    [anon_sym___inline__] = ACTIONS(1377),
    [anon_sym___forceinline] = ACTIONS(1377),
    [anon_sym_thread_local] = ACTIONS(1377),
    [anon_sym___thread] = ACTIONS(1377),
    [anon_sym_const] = ACTIONS(1377),
    [anon_sym_constexpr] = ACTIONS(1377),
    [anon_sym_volatile] = ACTIONS(1377),
    [anon_sym_restrict] = ACTIONS(1377),
    [anon_sym___restrict__] = ACTIONS(1377),
    [anon_sym__Atomic] = ACTIONS(1377),
    [anon_sym__Noreturn] = ACTIONS(1377),
    [anon_sym_noreturn] = ACTIONS(1377),
    [anon_sym_alignas] = ACTIONS(1377),
    [anon_sym__Alignas] = ACTIONS(1377),
    [sym_primitive_type] = ACTIONS(1377),
    [anon_sym_enum] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1377),
    [anon_sym_union] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1377),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1377),
    [anon_sym_default] = ACTIONS(1377),
    [anon_sym_while] = ACTIONS(1377),
    [anon_sym_do] = ACTIONS(1377),
    [anon_sym_for] = ACTIONS(1377),
    [anon_sym_return] = ACTIONS(1377),
    [anon_sym_break] = ACTIONS(1377),
    [anon_sym_continue] = ACTIONS(1377),
    [anon_sym_goto] = ACTIONS(1377),
    [anon_sym___try] = ACTIONS(1377),
    [anon_sym___leave] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_sizeof] = ACTIONS(1377),
    [anon_sym___alignof__] = ACTIONS(1377),
    [anon_sym___alignof] = ACTIONS(1377),
    [anon_sym__alignof] = ACTIONS(1377),
    [anon_sym_alignof] = ACTIONS(1377),
    [anon_sym__Alignof] = ACTIONS(1377),
    [anon_sym_offsetof] = ACTIONS(1377),
    [anon_sym__Generic] = ACTIONS(1377),
    [anon_sym_asm] = ACTIONS(1377),
    [anon_sym___asm__] = ACTIONS(1377),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1379),
    [anon_sym_u_SQUOTE] = ACTIONS(1379),
    [anon_sym_U_SQUOTE] = ACTIONS(1379),
    [anon_sym_u8_SQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_L_DQUOTE] = ACTIONS(1379),
    [anon_sym_u_DQUOTE] = ACTIONS(1379),
    [anon_sym_U_DQUOTE] = ACTIONS(1379),
    [anon_sym_u8_DQUOTE] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [anon_sym_NULL] = ACTIONS(1377),
    [anon_sym_nullptr] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1377),
    [anon_sym_hitAttributeEXT] = ACTIONS(1377),
    [anon_sym_callableDataEXT] = ACTIONS(1377),
    [anon_sym_callableDataInEXT] = ACTIONS(1377),
    [anon_sym_shaderRecordEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadNV] = ACTIONS(1377),
    [anon_sym_rayPayloadInNV] = ACTIONS(1377),
    [anon_sym_hitAttributeNV] = ACTIONS(1377),
    [anon_sym_callableDataNV] = ACTIONS(1377),
    [anon_sym_callableDataInNV] = ACTIONS(1377),
    [anon_sym_shaderRecordNV] = ACTIONS(1377),
    [anon_sym_layout] = ACTIONS(1377),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1385),
    [aux_sym_preproc_include_token1] = ACTIONS(1385),
    [aux_sym_preproc_def_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_LPAREN2] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_subroutine] = ACTIONS(1385),
    [anon_sym_invariant] = ACTIONS(1385),
    [anon_sym_precise] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1385),
    [anon_sym_out] = ACTIONS(1385),
    [anon_sym_inout] = ACTIONS(1385),
    [anon_sym_uniform] = ACTIONS(1385),
    [anon_sym_shared] = ACTIONS(1385),
    [anon_sym_attribute] = ACTIONS(1385),
    [anon_sym_varying] = ACTIONS(1385),
    [anon_sym_buffer] = ACTIONS(1385),
    [anon_sym_coherent] = ACTIONS(1385),
    [anon_sym_readonly] = ACTIONS(1385),
    [anon_sym_writeonly] = ACTIONS(1385),
    [anon_sym_precision] = ACTIONS(1385),
    [anon_sym_highp] = ACTIONS(1385),
    [anon_sym_mediump] = ACTIONS(1385),
    [anon_sym_lowp] = ACTIONS(1385),
    [anon_sym_centroid] = ACTIONS(1385),
    [anon_sym_sample] = ACTIONS(1385),
    [anon_sym_patch] = ACTIONS(1385),
    [anon_sym_smooth] = ACTIONS(1385),
    [anon_sym_flat] = ACTIONS(1385),
    [anon_sym_noperspective] = ACTIONS(1385),
    [anon_sym___extension__] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym___attribute__] = ACTIONS(1385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1387),
    [anon_sym___declspec] = ACTIONS(1385),
    [anon_sym___cdecl] = ACTIONS(1385),
    [anon_sym___clrcall] = ACTIONS(1385),
    [anon_sym___stdcall] = ACTIONS(1385),
    [anon_sym___fastcall] = ACTIONS(1385),
    [anon_sym___thiscall] = ACTIONS(1385),
    [anon_sym___vectorcall] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_signed] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym___inline] = ACTIONS(1385),
    [anon_sym___inline__] = ACTIONS(1385),
    [anon_sym___forceinline] = ACTIONS(1385),
    [anon_sym_thread_local] = ACTIONS(1385),
    [anon_sym___thread] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_constexpr] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym___restrict__] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym__Noreturn] = ACTIONS(1385),
    [anon_sym_noreturn] = ACTIONS(1385),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1385),
    [anon_sym_else] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1385),
    [anon_sym_case] = ACTIONS(1385),
    [anon_sym_default] = ACTIONS(1385),
    [anon_sym_while] = ACTIONS(1385),
    [anon_sym_do] = ACTIONS(1385),
    [anon_sym_for] = ACTIONS(1385),
    [anon_sym_return] = ACTIONS(1385),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_continue] = ACTIONS(1385),
    [anon_sym_goto] = ACTIONS(1385),
    [anon_sym___try] = ACTIONS(1385),
    [anon_sym___leave] = ACTIONS(1385),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym___alignof__] = ACTIONS(1385),
    [anon_sym___alignof] = ACTIONS(1385),
    [anon_sym__alignof] = ACTIONS(1385),
    [anon_sym_alignof] = ACTIONS(1385),
    [anon_sym__Alignof] = ACTIONS(1385),
    [anon_sym_offsetof] = ACTIONS(1385),
    [anon_sym__Generic] = ACTIONS(1385),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1387),
    [anon_sym_L_SQUOTE] = ACTIONS(1387),
    [anon_sym_u_SQUOTE] = ACTIONS(1387),
    [anon_sym_U_SQUOTE] = ACTIONS(1387),
    [anon_sym_u8_SQUOTE] = ACTIONS(1387),
    [anon_sym_SQUOTE] = ACTIONS(1387),
    [anon_sym_L_DQUOTE] = ACTIONS(1387),
    [anon_sym_u_DQUOTE] = ACTIONS(1387),
    [anon_sym_U_DQUOTE] = ACTIONS(1387),
    [anon_sym_u8_DQUOTE] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1387),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [anon_sym_NULL] = ACTIONS(1385),
    [anon_sym_nullptr] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1385),
    [anon_sym_hitAttributeEXT] = ACTIONS(1385),
    [anon_sym_callableDataEXT] = ACTIONS(1385),
    [anon_sym_callableDataInEXT] = ACTIONS(1385),
    [anon_sym_shaderRecordEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadNV] = ACTIONS(1385),
    [anon_sym_rayPayloadInNV] = ACTIONS(1385),
    [anon_sym_hitAttributeNV] = ACTIONS(1385),
    [anon_sym_callableDataNV] = ACTIONS(1385),
    [anon_sym_callableDataInNV] = ACTIONS(1385),
    [anon_sym_shaderRecordNV] = ACTIONS(1385),
    [anon_sym_layout] = ACTIONS(1385),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_subroutine] = ACTIONS(1237),
    [anon_sym_invariant] = ACTIONS(1237),
    [anon_sym_precise] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_out] = ACTIONS(1237),
    [anon_sym_inout] = ACTIONS(1237),
    [anon_sym_uniform] = ACTIONS(1237),
    [anon_sym_shared] = ACTIONS(1237),
    [anon_sym_attribute] = ACTIONS(1237),
    [anon_sym_varying] = ACTIONS(1237),
    [anon_sym_buffer] = ACTIONS(1237),
    [anon_sym_coherent] = ACTIONS(1237),
    [anon_sym_readonly] = ACTIONS(1237),
    [anon_sym_writeonly] = ACTIONS(1237),
    [anon_sym_precision] = ACTIONS(1237),
    [anon_sym_highp] = ACTIONS(1237),
    [anon_sym_mediump] = ACTIONS(1237),
    [anon_sym_lowp] = ACTIONS(1237),
    [anon_sym_centroid] = ACTIONS(1237),
    [anon_sym_sample] = ACTIONS(1237),
    [anon_sym_patch] = ACTIONS(1237),
    [anon_sym_smooth] = ACTIONS(1237),
    [anon_sym_flat] = ACTIONS(1237),
    [anon_sym_noperspective] = ACTIONS(1237),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1237),
    [anon_sym_hitAttributeEXT] = ACTIONS(1237),
    [anon_sym_callableDataEXT] = ACTIONS(1237),
    [anon_sym_callableDataInEXT] = ACTIONS(1237),
    [anon_sym_shaderRecordEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadNV] = ACTIONS(1237),
    [anon_sym_rayPayloadInNV] = ACTIONS(1237),
    [anon_sym_hitAttributeNV] = ACTIONS(1237),
    [anon_sym_callableDataNV] = ACTIONS(1237),
    [anon_sym_callableDataInNV] = ACTIONS(1237),
    [anon_sym_shaderRecordNV] = ACTIONS(1237),
    [anon_sym_layout] = ACTIONS(1237),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_subroutine] = ACTIONS(1297),
    [anon_sym_invariant] = ACTIONS(1297),
    [anon_sym_precise] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_in] = ACTIONS(1297),
    [anon_sym_out] = ACTIONS(1297),
    [anon_sym_inout] = ACTIONS(1297),
    [anon_sym_uniform] = ACTIONS(1297),
    [anon_sym_shared] = ACTIONS(1297),
    [anon_sym_attribute] = ACTIONS(1297),
    [anon_sym_varying] = ACTIONS(1297),
    [anon_sym_buffer] = ACTIONS(1297),
    [anon_sym_coherent] = ACTIONS(1297),
    [anon_sym_readonly] = ACTIONS(1297),
    [anon_sym_writeonly] = ACTIONS(1297),
    [anon_sym_precision] = ACTIONS(1297),
    [anon_sym_highp] = ACTIONS(1297),
    [anon_sym_mediump] = ACTIONS(1297),
    [anon_sym_lowp] = ACTIONS(1297),
    [anon_sym_centroid] = ACTIONS(1297),
    [anon_sym_sample] = ACTIONS(1297),
    [anon_sym_patch] = ACTIONS(1297),
    [anon_sym_smooth] = ACTIONS(1297),
    [anon_sym_flat] = ACTIONS(1297),
    [anon_sym_noperspective] = ACTIONS(1297),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_else] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1297),
    [anon_sym_hitAttributeEXT] = ACTIONS(1297),
    [anon_sym_callableDataEXT] = ACTIONS(1297),
    [anon_sym_callableDataInEXT] = ACTIONS(1297),
    [anon_sym_shaderRecordEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadNV] = ACTIONS(1297),
    [anon_sym_rayPayloadInNV] = ACTIONS(1297),
    [anon_sym_hitAttributeNV] = ACTIONS(1297),
    [anon_sym_callableDataNV] = ACTIONS(1297),
    [anon_sym_callableDataInNV] = ACTIONS(1297),
    [anon_sym_shaderRecordNV] = ACTIONS(1297),
    [anon_sym_layout] = ACTIONS(1297),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1385),
    [aux_sym_preproc_include_token1] = ACTIONS(1385),
    [aux_sym_preproc_def_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_LPAREN2] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_subroutine] = ACTIONS(1385),
    [anon_sym_invariant] = ACTIONS(1385),
    [anon_sym_precise] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1385),
    [anon_sym_out] = ACTIONS(1385),
    [anon_sym_inout] = ACTIONS(1385),
    [anon_sym_uniform] = ACTIONS(1385),
    [anon_sym_shared] = ACTIONS(1385),
    [anon_sym_attribute] = ACTIONS(1385),
    [anon_sym_varying] = ACTIONS(1385),
    [anon_sym_buffer] = ACTIONS(1385),
    [anon_sym_coherent] = ACTIONS(1385),
    [anon_sym_readonly] = ACTIONS(1385),
    [anon_sym_writeonly] = ACTIONS(1385),
    [anon_sym_precision] = ACTIONS(1385),
    [anon_sym_highp] = ACTIONS(1385),
    [anon_sym_mediump] = ACTIONS(1385),
    [anon_sym_lowp] = ACTIONS(1385),
    [anon_sym_centroid] = ACTIONS(1385),
    [anon_sym_sample] = ACTIONS(1385),
    [anon_sym_patch] = ACTIONS(1385),
    [anon_sym_smooth] = ACTIONS(1385),
    [anon_sym_flat] = ACTIONS(1385),
    [anon_sym_noperspective] = ACTIONS(1385),
    [anon_sym___extension__] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym___attribute__] = ACTIONS(1385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1387),
    [anon_sym___declspec] = ACTIONS(1385),
    [anon_sym___cdecl] = ACTIONS(1385),
    [anon_sym___clrcall] = ACTIONS(1385),
    [anon_sym___stdcall] = ACTIONS(1385),
    [anon_sym___fastcall] = ACTIONS(1385),
    [anon_sym___thiscall] = ACTIONS(1385),
    [anon_sym___vectorcall] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_RBRACE] = ACTIONS(1387),
    [anon_sym_signed] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym___inline] = ACTIONS(1385),
    [anon_sym___inline__] = ACTIONS(1385),
    [anon_sym___forceinline] = ACTIONS(1385),
    [anon_sym_thread_local] = ACTIONS(1385),
    [anon_sym___thread] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_constexpr] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym___restrict__] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym__Noreturn] = ACTIONS(1385),
    [anon_sym_noreturn] = ACTIONS(1385),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1385),
    [anon_sym_else] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1385),
    [anon_sym_case] = ACTIONS(1385),
    [anon_sym_default] = ACTIONS(1385),
    [anon_sym_while] = ACTIONS(1385),
    [anon_sym_do] = ACTIONS(1385),
    [anon_sym_for] = ACTIONS(1385),
    [anon_sym_return] = ACTIONS(1385),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_continue] = ACTIONS(1385),
    [anon_sym_goto] = ACTIONS(1385),
    [anon_sym___try] = ACTIONS(1385),
    [anon_sym___leave] = ACTIONS(1385),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym___alignof__] = ACTIONS(1385),
    [anon_sym___alignof] = ACTIONS(1385),
    [anon_sym__alignof] = ACTIONS(1385),
    [anon_sym_alignof] = ACTIONS(1385),
    [anon_sym__Alignof] = ACTIONS(1385),
    [anon_sym_offsetof] = ACTIONS(1385),
    [anon_sym__Generic] = ACTIONS(1385),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1387),
    [anon_sym_L_SQUOTE] = ACTIONS(1387),
    [anon_sym_u_SQUOTE] = ACTIONS(1387),
    [anon_sym_U_SQUOTE] = ACTIONS(1387),
    [anon_sym_u8_SQUOTE] = ACTIONS(1387),
    [anon_sym_SQUOTE] = ACTIONS(1387),
    [anon_sym_L_DQUOTE] = ACTIONS(1387),
    [anon_sym_u_DQUOTE] = ACTIONS(1387),
    [anon_sym_U_DQUOTE] = ACTIONS(1387),
    [anon_sym_u8_DQUOTE] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1387),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [anon_sym_NULL] = ACTIONS(1385),
    [anon_sym_nullptr] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1385),
    [anon_sym_hitAttributeEXT] = ACTIONS(1385),
    [anon_sym_callableDataEXT] = ACTIONS(1385),
    [anon_sym_callableDataInEXT] = ACTIONS(1385),
    [anon_sym_shaderRecordEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadNV] = ACTIONS(1385),
    [anon_sym_rayPayloadInNV] = ACTIONS(1385),
    [anon_sym_hitAttributeNV] = ACTIONS(1385),
    [anon_sym_callableDataNV] = ACTIONS(1385),
    [anon_sym_callableDataInNV] = ACTIONS(1385),
    [anon_sym_shaderRecordNV] = ACTIONS(1385),
    [anon_sym_layout] = ACTIONS(1385),
  },
  [179] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_subroutine] = ACTIONS(1237),
    [anon_sym_invariant] = ACTIONS(1237),
    [anon_sym_precise] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_out] = ACTIONS(1237),
    [anon_sym_inout] = ACTIONS(1237),
    [anon_sym_uniform] = ACTIONS(1237),
    [anon_sym_shared] = ACTIONS(1237),
    [anon_sym_attribute] = ACTIONS(1237),
    [anon_sym_varying] = ACTIONS(1237),
    [anon_sym_buffer] = ACTIONS(1237),
    [anon_sym_coherent] = ACTIONS(1237),
    [anon_sym_readonly] = ACTIONS(1237),
    [anon_sym_writeonly] = ACTIONS(1237),
    [anon_sym_precision] = ACTIONS(1237),
    [anon_sym_highp] = ACTIONS(1237),
    [anon_sym_mediump] = ACTIONS(1237),
    [anon_sym_lowp] = ACTIONS(1237),
    [anon_sym_centroid] = ACTIONS(1237),
    [anon_sym_sample] = ACTIONS(1237),
    [anon_sym_patch] = ACTIONS(1237),
    [anon_sym_smooth] = ACTIONS(1237),
    [anon_sym_flat] = ACTIONS(1237),
    [anon_sym_noperspective] = ACTIONS(1237),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1237),
    [anon_sym_hitAttributeEXT] = ACTIONS(1237),
    [anon_sym_callableDataEXT] = ACTIONS(1237),
    [anon_sym_callableDataInEXT] = ACTIONS(1237),
    [anon_sym_shaderRecordEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadNV] = ACTIONS(1237),
    [anon_sym_rayPayloadInNV] = ACTIONS(1237),
    [anon_sym_hitAttributeNV] = ACTIONS(1237),
    [anon_sym_callableDataNV] = ACTIONS(1237),
    [anon_sym_callableDataInNV] = ACTIONS(1237),
    [anon_sym_shaderRecordNV] = ACTIONS(1237),
    [anon_sym_layout] = ACTIONS(1237),
  },
  [180] = {
    [sym_identifier] = ACTIONS(1377),
    [aux_sym_preproc_include_token1] = ACTIONS(1377),
    [aux_sym_preproc_def_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1377),
    [sym_preproc_directive] = ACTIONS(1377),
    [anon_sym_LPAREN2] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_subroutine] = ACTIONS(1377),
    [anon_sym_invariant] = ACTIONS(1377),
    [anon_sym_precise] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_in] = ACTIONS(1377),
    [anon_sym_out] = ACTIONS(1377),
    [anon_sym_inout] = ACTIONS(1377),
    [anon_sym_uniform] = ACTIONS(1377),
    [anon_sym_shared] = ACTIONS(1377),
    [anon_sym_attribute] = ACTIONS(1377),
    [anon_sym_varying] = ACTIONS(1377),
    [anon_sym_buffer] = ACTIONS(1377),
    [anon_sym_coherent] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_writeonly] = ACTIONS(1377),
    [anon_sym_precision] = ACTIONS(1377),
    [anon_sym_highp] = ACTIONS(1377),
    [anon_sym_mediump] = ACTIONS(1377),
    [anon_sym_lowp] = ACTIONS(1377),
    [anon_sym_centroid] = ACTIONS(1377),
    [anon_sym_sample] = ACTIONS(1377),
    [anon_sym_patch] = ACTIONS(1377),
    [anon_sym_smooth] = ACTIONS(1377),
    [anon_sym_flat] = ACTIONS(1377),
    [anon_sym_noperspective] = ACTIONS(1377),
    [anon_sym___extension__] = ACTIONS(1377),
    [anon_sym_typedef] = ACTIONS(1377),
    [anon_sym_extern] = ACTIONS(1377),
    [anon_sym___attribute__] = ACTIONS(1377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1379),
    [anon_sym___declspec] = ACTIONS(1377),
    [anon_sym___cdecl] = ACTIONS(1377),
    [anon_sym___clrcall] = ACTIONS(1377),
    [anon_sym___stdcall] = ACTIONS(1377),
    [anon_sym___fastcall] = ACTIONS(1377),
    [anon_sym___thiscall] = ACTIONS(1377),
    [anon_sym___vectorcall] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_signed] = ACTIONS(1377),
    [anon_sym_unsigned] = ACTIONS(1377),
    [anon_sym_long] = ACTIONS(1377),
    [anon_sym_short] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_auto] = ACTIONS(1377),
    [anon_sym_register] = ACTIONS(1377),
    [anon_sym_inline] = ACTIONS(1377),
    [anon_sym___inline] = ACTIONS(1377),
    [anon_sym___inline__] = ACTIONS(1377),
    [anon_sym___forceinline] = ACTIONS(1377),
    [anon_sym_thread_local] = ACTIONS(1377),
    [anon_sym___thread] = ACTIONS(1377),
    [anon_sym_const] = ACTIONS(1377),
    [anon_sym_constexpr] = ACTIONS(1377),
    [anon_sym_volatile] = ACTIONS(1377),
    [anon_sym_restrict] = ACTIONS(1377),
    [anon_sym___restrict__] = ACTIONS(1377),
    [anon_sym__Atomic] = ACTIONS(1377),
    [anon_sym__Noreturn] = ACTIONS(1377),
    [anon_sym_noreturn] = ACTIONS(1377),
    [anon_sym_alignas] = ACTIONS(1377),
    [anon_sym__Alignas] = ACTIONS(1377),
    [sym_primitive_type] = ACTIONS(1377),
    [anon_sym_enum] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1377),
    [anon_sym_union] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1377),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1377),
    [anon_sym_default] = ACTIONS(1377),
    [anon_sym_while] = ACTIONS(1377),
    [anon_sym_do] = ACTIONS(1377),
    [anon_sym_for] = ACTIONS(1377),
    [anon_sym_return] = ACTIONS(1377),
    [anon_sym_break] = ACTIONS(1377),
    [anon_sym_continue] = ACTIONS(1377),
    [anon_sym_goto] = ACTIONS(1377),
    [anon_sym___try] = ACTIONS(1377),
    [anon_sym___leave] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_sizeof] = ACTIONS(1377),
    [anon_sym___alignof__] = ACTIONS(1377),
    [anon_sym___alignof] = ACTIONS(1377),
    [anon_sym__alignof] = ACTIONS(1377),
    [anon_sym_alignof] = ACTIONS(1377),
    [anon_sym__Alignof] = ACTIONS(1377),
    [anon_sym_offsetof] = ACTIONS(1377),
    [anon_sym__Generic] = ACTIONS(1377),
    [anon_sym_asm] = ACTIONS(1377),
    [anon_sym___asm__] = ACTIONS(1377),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1379),
    [anon_sym_u_SQUOTE] = ACTIONS(1379),
    [anon_sym_U_SQUOTE] = ACTIONS(1379),
    [anon_sym_u8_SQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_L_DQUOTE] = ACTIONS(1379),
    [anon_sym_u_DQUOTE] = ACTIONS(1379),
    [anon_sym_U_DQUOTE] = ACTIONS(1379),
    [anon_sym_u8_DQUOTE] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [anon_sym_NULL] = ACTIONS(1377),
    [anon_sym_nullptr] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1377),
    [anon_sym_hitAttributeEXT] = ACTIONS(1377),
    [anon_sym_callableDataEXT] = ACTIONS(1377),
    [anon_sym_callableDataInEXT] = ACTIONS(1377),
    [anon_sym_shaderRecordEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadNV] = ACTIONS(1377),
    [anon_sym_rayPayloadInNV] = ACTIONS(1377),
    [anon_sym_hitAttributeNV] = ACTIONS(1377),
    [anon_sym_callableDataNV] = ACTIONS(1377),
    [anon_sym_callableDataInNV] = ACTIONS(1377),
    [anon_sym_shaderRecordNV] = ACTIONS(1377),
    [anon_sym_layout] = ACTIONS(1377),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(1371),
    [sym_identifier] = ACTIONS(1369),
    [aux_sym_preproc_include_token1] = ACTIONS(1369),
    [aux_sym_preproc_def_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1369),
    [sym_preproc_directive] = ACTIONS(1369),
    [anon_sym_LPAREN2] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_subroutine] = ACTIONS(1369),
    [anon_sym_invariant] = ACTIONS(1369),
    [anon_sym_precise] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_in] = ACTIONS(1369),
    [anon_sym_out] = ACTIONS(1369),
    [anon_sym_inout] = ACTIONS(1369),
    [anon_sym_uniform] = ACTIONS(1369),
    [anon_sym_shared] = ACTIONS(1369),
    [anon_sym_attribute] = ACTIONS(1369),
    [anon_sym_varying] = ACTIONS(1369),
    [anon_sym_buffer] = ACTIONS(1369),
    [anon_sym_coherent] = ACTIONS(1369),
    [anon_sym_readonly] = ACTIONS(1369),
    [anon_sym_writeonly] = ACTIONS(1369),
    [anon_sym_precision] = ACTIONS(1369),
    [anon_sym_highp] = ACTIONS(1369),
    [anon_sym_mediump] = ACTIONS(1369),
    [anon_sym_lowp] = ACTIONS(1369),
    [anon_sym_centroid] = ACTIONS(1369),
    [anon_sym_sample] = ACTIONS(1369),
    [anon_sym_patch] = ACTIONS(1369),
    [anon_sym_smooth] = ACTIONS(1369),
    [anon_sym_flat] = ACTIONS(1369),
    [anon_sym_noperspective] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1369),
    [anon_sym_typedef] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1369),
    [anon_sym___attribute__] = ACTIONS(1369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1371),
    [anon_sym___declspec] = ACTIONS(1369),
    [anon_sym___cdecl] = ACTIONS(1369),
    [anon_sym___clrcall] = ACTIONS(1369),
    [anon_sym___stdcall] = ACTIONS(1369),
    [anon_sym___fastcall] = ACTIONS(1369),
    [anon_sym___thiscall] = ACTIONS(1369),
    [anon_sym___vectorcall] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_signed] = ACTIONS(1369),
    [anon_sym_unsigned] = ACTIONS(1369),
    [anon_sym_long] = ACTIONS(1369),
    [anon_sym_short] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_auto] = ACTIONS(1369),
    [anon_sym_register] = ACTIONS(1369),
    [anon_sym_inline] = ACTIONS(1369),
    [anon_sym___inline] = ACTIONS(1369),
    [anon_sym___inline__] = ACTIONS(1369),
    [anon_sym___forceinline] = ACTIONS(1369),
    [anon_sym_thread_local] = ACTIONS(1369),
    [anon_sym___thread] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_constexpr] = ACTIONS(1369),
    [anon_sym_volatile] = ACTIONS(1369),
    [anon_sym_restrict] = ACTIONS(1369),
    [anon_sym___restrict__] = ACTIONS(1369),
    [anon_sym__Atomic] = ACTIONS(1369),
    [anon_sym__Noreturn] = ACTIONS(1369),
    [anon_sym_noreturn] = ACTIONS(1369),
    [anon_sym_alignas] = ACTIONS(1369),
    [anon_sym__Alignas] = ACTIONS(1369),
    [sym_primitive_type] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1369),
    [anon_sym_union] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_goto] = ACTIONS(1369),
    [anon_sym___try] = ACTIONS(1369),
    [anon_sym___leave] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_sizeof] = ACTIONS(1369),
    [anon_sym___alignof__] = ACTIONS(1369),
    [anon_sym___alignof] = ACTIONS(1369),
    [anon_sym__alignof] = ACTIONS(1369),
    [anon_sym_alignof] = ACTIONS(1369),
    [anon_sym__Alignof] = ACTIONS(1369),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1369),
    [anon_sym_asm] = ACTIONS(1369),
    [anon_sym___asm__] = ACTIONS(1369),
    [sym_number_literal] = ACTIONS(1371),
    [anon_sym_L_SQUOTE] = ACTIONS(1371),
    [anon_sym_u_SQUOTE] = ACTIONS(1371),
    [anon_sym_U_SQUOTE] = ACTIONS(1371),
    [anon_sym_u8_SQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [anon_sym_L_DQUOTE] = ACTIONS(1371),
    [anon_sym_u_DQUOTE] = ACTIONS(1371),
    [anon_sym_U_DQUOTE] = ACTIONS(1371),
    [anon_sym_u8_DQUOTE] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [anon_sym_NULL] = ACTIONS(1369),
    [anon_sym_nullptr] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1369),
    [anon_sym_hitAttributeEXT] = ACTIONS(1369),
    [anon_sym_callableDataEXT] = ACTIONS(1369),
    [anon_sym_callableDataInEXT] = ACTIONS(1369),
    [anon_sym_shaderRecordEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadNV] = ACTIONS(1369),
    [anon_sym_rayPayloadInNV] = ACTIONS(1369),
    [anon_sym_hitAttributeNV] = ACTIONS(1369),
    [anon_sym_callableDataNV] = ACTIONS(1369),
    [anon_sym_callableDataInNV] = ACTIONS(1369),
    [anon_sym_shaderRecordNV] = ACTIONS(1369),
    [anon_sym_layout] = ACTIONS(1369),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1327),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_subroutine] = ACTIONS(1327),
    [anon_sym_invariant] = ACTIONS(1327),
    [anon_sym_precise] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_in] = ACTIONS(1327),
    [anon_sym_out] = ACTIONS(1327),
    [anon_sym_inout] = ACTIONS(1327),
    [anon_sym_uniform] = ACTIONS(1327),
    [anon_sym_shared] = ACTIONS(1327),
    [anon_sym_attribute] = ACTIONS(1327),
    [anon_sym_varying] = ACTIONS(1327),
    [anon_sym_buffer] = ACTIONS(1327),
    [anon_sym_coherent] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_writeonly] = ACTIONS(1327),
    [anon_sym_precision] = ACTIONS(1327),
    [anon_sym_highp] = ACTIONS(1327),
    [anon_sym_mediump] = ACTIONS(1327),
    [anon_sym_lowp] = ACTIONS(1327),
    [anon_sym_centroid] = ACTIONS(1327),
    [anon_sym_sample] = ACTIONS(1327),
    [anon_sym_patch] = ACTIONS(1327),
    [anon_sym_smooth] = ACTIONS(1327),
    [anon_sym_flat] = ACTIONS(1327),
    [anon_sym_noperspective] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1327),
    [anon_sym_typedef] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym___attribute__] = ACTIONS(1327),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1325),
    [anon_sym___declspec] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_signed] = ACTIONS(1327),
    [anon_sym_unsigned] = ACTIONS(1327),
    [anon_sym_long] = ACTIONS(1327),
    [anon_sym_short] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_auto] = ACTIONS(1327),
    [anon_sym_register] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym___inline] = ACTIONS(1327),
    [anon_sym___inline__] = ACTIONS(1327),
    [anon_sym___forceinline] = ACTIONS(1327),
    [anon_sym_thread_local] = ACTIONS(1327),
    [anon_sym___thread] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_constexpr] = ACTIONS(1327),
    [anon_sym_volatile] = ACTIONS(1327),
    [anon_sym_restrict] = ACTIONS(1327),
    [anon_sym___restrict__] = ACTIONS(1327),
    [anon_sym__Atomic] = ACTIONS(1327),
    [anon_sym__Noreturn] = ACTIONS(1327),
    [anon_sym_noreturn] = ACTIONS(1327),
    [anon_sym_alignas] = ACTIONS(1327),
    [anon_sym__Alignas] = ACTIONS(1327),
    [sym_primitive_type] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [anon_sym_continue] = ACTIONS(1327),
    [anon_sym_goto] = ACTIONS(1327),
    [anon_sym___try] = ACTIONS(1327),
    [anon_sym___leave] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_sizeof] = ACTIONS(1327),
    [anon_sym___alignof__] = ACTIONS(1327),
    [anon_sym___alignof] = ACTIONS(1327),
    [anon_sym__alignof] = ACTIONS(1327),
    [anon_sym_alignof] = ACTIONS(1327),
    [anon_sym__Alignof] = ACTIONS(1327),
    [anon_sym_offsetof] = ACTIONS(1327),
    [anon_sym__Generic] = ACTIONS(1327),
    [anon_sym_asm] = ACTIONS(1327),
    [anon_sym___asm__] = ACTIONS(1327),
    [sym_number_literal] = ACTIONS(1325),
    [anon_sym_L_SQUOTE] = ACTIONS(1325),
    [anon_sym_u_SQUOTE] = ACTIONS(1325),
    [anon_sym_U_SQUOTE] = ACTIONS(1325),
    [anon_sym_u8_SQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [anon_sym_L_DQUOTE] = ACTIONS(1325),
    [anon_sym_u_DQUOTE] = ACTIONS(1325),
    [anon_sym_U_DQUOTE] = ACTIONS(1325),
    [anon_sym_u8_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [anon_sym_NULL] = ACTIONS(1327),
    [anon_sym_nullptr] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1327),
    [anon_sym_hitAttributeEXT] = ACTIONS(1327),
    [anon_sym_callableDataEXT] = ACTIONS(1327),
    [anon_sym_callableDataInEXT] = ACTIONS(1327),
    [anon_sym_shaderRecordEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadNV] = ACTIONS(1327),
    [anon_sym_rayPayloadInNV] = ACTIONS(1327),
    [anon_sym_hitAttributeNV] = ACTIONS(1327),
    [anon_sym_callableDataNV] = ACTIONS(1327),
    [anon_sym_callableDataInNV] = ACTIONS(1327),
    [anon_sym_shaderRecordNV] = ACTIONS(1327),
    [anon_sym_layout] = ACTIONS(1327),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1369),
    [aux_sym_preproc_include_token1] = ACTIONS(1369),
    [aux_sym_preproc_def_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1369),
    [sym_preproc_directive] = ACTIONS(1369),
    [anon_sym_LPAREN2] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_subroutine] = ACTIONS(1369),
    [anon_sym_invariant] = ACTIONS(1369),
    [anon_sym_precise] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_in] = ACTIONS(1369),
    [anon_sym_out] = ACTIONS(1369),
    [anon_sym_inout] = ACTIONS(1369),
    [anon_sym_uniform] = ACTIONS(1369),
    [anon_sym_shared] = ACTIONS(1369),
    [anon_sym_attribute] = ACTIONS(1369),
    [anon_sym_varying] = ACTIONS(1369),
    [anon_sym_buffer] = ACTIONS(1369),
    [anon_sym_coherent] = ACTIONS(1369),
    [anon_sym_readonly] = ACTIONS(1369),
    [anon_sym_writeonly] = ACTIONS(1369),
    [anon_sym_precision] = ACTIONS(1369),
    [anon_sym_highp] = ACTIONS(1369),
    [anon_sym_mediump] = ACTIONS(1369),
    [anon_sym_lowp] = ACTIONS(1369),
    [anon_sym_centroid] = ACTIONS(1369),
    [anon_sym_sample] = ACTIONS(1369),
    [anon_sym_patch] = ACTIONS(1369),
    [anon_sym_smooth] = ACTIONS(1369),
    [anon_sym_flat] = ACTIONS(1369),
    [anon_sym_noperspective] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1369),
    [anon_sym_typedef] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1369),
    [anon_sym___attribute__] = ACTIONS(1369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1371),
    [anon_sym___declspec] = ACTIONS(1369),
    [anon_sym___cdecl] = ACTIONS(1369),
    [anon_sym___clrcall] = ACTIONS(1369),
    [anon_sym___stdcall] = ACTIONS(1369),
    [anon_sym___fastcall] = ACTIONS(1369),
    [anon_sym___thiscall] = ACTIONS(1369),
    [anon_sym___vectorcall] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_signed] = ACTIONS(1369),
    [anon_sym_unsigned] = ACTIONS(1369),
    [anon_sym_long] = ACTIONS(1369),
    [anon_sym_short] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_auto] = ACTIONS(1369),
    [anon_sym_register] = ACTIONS(1369),
    [anon_sym_inline] = ACTIONS(1369),
    [anon_sym___inline] = ACTIONS(1369),
    [anon_sym___inline__] = ACTIONS(1369),
    [anon_sym___forceinline] = ACTIONS(1369),
    [anon_sym_thread_local] = ACTIONS(1369),
    [anon_sym___thread] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_constexpr] = ACTIONS(1369),
    [anon_sym_volatile] = ACTIONS(1369),
    [anon_sym_restrict] = ACTIONS(1369),
    [anon_sym___restrict__] = ACTIONS(1369),
    [anon_sym__Atomic] = ACTIONS(1369),
    [anon_sym__Noreturn] = ACTIONS(1369),
    [anon_sym_noreturn] = ACTIONS(1369),
    [anon_sym_alignas] = ACTIONS(1369),
    [anon_sym__Alignas] = ACTIONS(1369),
    [sym_primitive_type] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1369),
    [anon_sym_union] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_goto] = ACTIONS(1369),
    [anon_sym___try] = ACTIONS(1369),
    [anon_sym___leave] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_sizeof] = ACTIONS(1369),
    [anon_sym___alignof__] = ACTIONS(1369),
    [anon_sym___alignof] = ACTIONS(1369),
    [anon_sym__alignof] = ACTIONS(1369),
    [anon_sym_alignof] = ACTIONS(1369),
    [anon_sym__Alignof] = ACTIONS(1369),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1369),
    [anon_sym_asm] = ACTIONS(1369),
    [anon_sym___asm__] = ACTIONS(1369),
    [sym_number_literal] = ACTIONS(1371),
    [anon_sym_L_SQUOTE] = ACTIONS(1371),
    [anon_sym_u_SQUOTE] = ACTIONS(1371),
    [anon_sym_U_SQUOTE] = ACTIONS(1371),
    [anon_sym_u8_SQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [anon_sym_L_DQUOTE] = ACTIONS(1371),
    [anon_sym_u_DQUOTE] = ACTIONS(1371),
    [anon_sym_U_DQUOTE] = ACTIONS(1371),
    [anon_sym_u8_DQUOTE] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [anon_sym_NULL] = ACTIONS(1369),
    [anon_sym_nullptr] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1369),
    [anon_sym_hitAttributeEXT] = ACTIONS(1369),
    [anon_sym_callableDataEXT] = ACTIONS(1369),
    [anon_sym_callableDataInEXT] = ACTIONS(1369),
    [anon_sym_shaderRecordEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadNV] = ACTIONS(1369),
    [anon_sym_rayPayloadInNV] = ACTIONS(1369),
    [anon_sym_hitAttributeNV] = ACTIONS(1369),
    [anon_sym_callableDataNV] = ACTIONS(1369),
    [anon_sym_callableDataInNV] = ACTIONS(1369),
    [anon_sym_shaderRecordNV] = ACTIONS(1369),
    [anon_sym_layout] = ACTIONS(1369),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(1367),
    [sym_identifier] = ACTIONS(1365),
    [aux_sym_preproc_include_token1] = ACTIONS(1365),
    [aux_sym_preproc_def_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1365),
    [sym_preproc_directive] = ACTIONS(1365),
    [anon_sym_LPAREN2] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_subroutine] = ACTIONS(1365),
    [anon_sym_invariant] = ACTIONS(1365),
    [anon_sym_precise] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_out] = ACTIONS(1365),
    [anon_sym_inout] = ACTIONS(1365),
    [anon_sym_uniform] = ACTIONS(1365),
    [anon_sym_shared] = ACTIONS(1365),
    [anon_sym_attribute] = ACTIONS(1365),
    [anon_sym_varying] = ACTIONS(1365),
    [anon_sym_buffer] = ACTIONS(1365),
    [anon_sym_coherent] = ACTIONS(1365),
    [anon_sym_readonly] = ACTIONS(1365),
    [anon_sym_writeonly] = ACTIONS(1365),
    [anon_sym_precision] = ACTIONS(1365),
    [anon_sym_highp] = ACTIONS(1365),
    [anon_sym_mediump] = ACTIONS(1365),
    [anon_sym_lowp] = ACTIONS(1365),
    [anon_sym_centroid] = ACTIONS(1365),
    [anon_sym_sample] = ACTIONS(1365),
    [anon_sym_patch] = ACTIONS(1365),
    [anon_sym_smooth] = ACTIONS(1365),
    [anon_sym_flat] = ACTIONS(1365),
    [anon_sym_noperspective] = ACTIONS(1365),
    [anon_sym___extension__] = ACTIONS(1365),
    [anon_sym_typedef] = ACTIONS(1365),
    [anon_sym_extern] = ACTIONS(1365),
    [anon_sym___attribute__] = ACTIONS(1365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1365),
    [anon_sym___cdecl] = ACTIONS(1365),
    [anon_sym___clrcall] = ACTIONS(1365),
    [anon_sym___stdcall] = ACTIONS(1365),
    [anon_sym___fastcall] = ACTIONS(1365),
    [anon_sym___thiscall] = ACTIONS(1365),
    [anon_sym___vectorcall] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_signed] = ACTIONS(1365),
    [anon_sym_unsigned] = ACTIONS(1365),
    [anon_sym_long] = ACTIONS(1365),
    [anon_sym_short] = ACTIONS(1365),
    [anon_sym_static] = ACTIONS(1365),
    [anon_sym_auto] = ACTIONS(1365),
    [anon_sym_register] = ACTIONS(1365),
    [anon_sym_inline] = ACTIONS(1365),
    [anon_sym___inline] = ACTIONS(1365),
    [anon_sym___inline__] = ACTIONS(1365),
    [anon_sym___forceinline] = ACTIONS(1365),
    [anon_sym_thread_local] = ACTIONS(1365),
    [anon_sym___thread] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_constexpr] = ACTIONS(1365),
    [anon_sym_volatile] = ACTIONS(1365),
    [anon_sym_restrict] = ACTIONS(1365),
    [anon_sym___restrict__] = ACTIONS(1365),
    [anon_sym__Atomic] = ACTIONS(1365),
    [anon_sym__Noreturn] = ACTIONS(1365),
    [anon_sym_noreturn] = ACTIONS(1365),
    [anon_sym_alignas] = ACTIONS(1365),
    [anon_sym__Alignas] = ACTIONS(1365),
    [sym_primitive_type] = ACTIONS(1365),
    [anon_sym_enum] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1365),
    [anon_sym_union] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_case] = ACTIONS(1365),
    [anon_sym_default] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_do] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_break] = ACTIONS(1365),
    [anon_sym_continue] = ACTIONS(1365),
    [anon_sym_goto] = ACTIONS(1365),
    [anon_sym___try] = ACTIONS(1365),
    [anon_sym___leave] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_sizeof] = ACTIONS(1365),
    [anon_sym___alignof__] = ACTIONS(1365),
    [anon_sym___alignof] = ACTIONS(1365),
    [anon_sym__alignof] = ACTIONS(1365),
    [anon_sym_alignof] = ACTIONS(1365),
    [anon_sym__Alignof] = ACTIONS(1365),
    [anon_sym_offsetof] = ACTIONS(1365),
    [anon_sym__Generic] = ACTIONS(1365),
    [anon_sym_asm] = ACTIONS(1365),
    [anon_sym___asm__] = ACTIONS(1365),
    [sym_number_literal] = ACTIONS(1367),
    [anon_sym_L_SQUOTE] = ACTIONS(1367),
    [anon_sym_u_SQUOTE] = ACTIONS(1367),
    [anon_sym_U_SQUOTE] = ACTIONS(1367),
    [anon_sym_u8_SQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [anon_sym_L_DQUOTE] = ACTIONS(1367),
    [anon_sym_u_DQUOTE] = ACTIONS(1367),
    [anon_sym_U_DQUOTE] = ACTIONS(1367),
    [anon_sym_u8_DQUOTE] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [anon_sym_NULL] = ACTIONS(1365),
    [anon_sym_nullptr] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1365),
    [anon_sym_hitAttributeEXT] = ACTIONS(1365),
    [anon_sym_callableDataEXT] = ACTIONS(1365),
    [anon_sym_callableDataInEXT] = ACTIONS(1365),
    [anon_sym_shaderRecordEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadNV] = ACTIONS(1365),
    [anon_sym_rayPayloadInNV] = ACTIONS(1365),
    [anon_sym_hitAttributeNV] = ACTIONS(1365),
    [anon_sym_callableDataNV] = ACTIONS(1365),
    [anon_sym_callableDataInNV] = ACTIONS(1365),
    [anon_sym_shaderRecordNV] = ACTIONS(1365),
    [anon_sym_layout] = ACTIONS(1365),
  },
  [185] = {
    [sym_identifier] = ACTIONS(1393),
    [aux_sym_preproc_include_token1] = ACTIONS(1393),
    [aux_sym_preproc_def_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_LPAREN2] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1393),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_subroutine] = ACTIONS(1393),
    [anon_sym_invariant] = ACTIONS(1393),
    [anon_sym_precise] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1393),
    [anon_sym_out] = ACTIONS(1393),
    [anon_sym_inout] = ACTIONS(1393),
    [anon_sym_uniform] = ACTIONS(1393),
    [anon_sym_shared] = ACTIONS(1393),
    [anon_sym_attribute] = ACTIONS(1393),
    [anon_sym_varying] = ACTIONS(1393),
    [anon_sym_buffer] = ACTIONS(1393),
    [anon_sym_coherent] = ACTIONS(1393),
    [anon_sym_readonly] = ACTIONS(1393),
    [anon_sym_writeonly] = ACTIONS(1393),
    [anon_sym_precision] = ACTIONS(1393),
    [anon_sym_highp] = ACTIONS(1393),
    [anon_sym_mediump] = ACTIONS(1393),
    [anon_sym_lowp] = ACTIONS(1393),
    [anon_sym_centroid] = ACTIONS(1393),
    [anon_sym_sample] = ACTIONS(1393),
    [anon_sym_patch] = ACTIONS(1393),
    [anon_sym_smooth] = ACTIONS(1393),
    [anon_sym_flat] = ACTIONS(1393),
    [anon_sym_noperspective] = ACTIONS(1393),
    [anon_sym___extension__] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym___attribute__] = ACTIONS(1393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1395),
    [anon_sym___declspec] = ACTIONS(1393),
    [anon_sym___cdecl] = ACTIONS(1393),
    [anon_sym___clrcall] = ACTIONS(1393),
    [anon_sym___stdcall] = ACTIONS(1393),
    [anon_sym___fastcall] = ACTIONS(1393),
    [anon_sym___thiscall] = ACTIONS(1393),
    [anon_sym___vectorcall] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(1395),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [anon_sym_signed] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym___inline] = ACTIONS(1393),
    [anon_sym___inline__] = ACTIONS(1393),
    [anon_sym___forceinline] = ACTIONS(1393),
    [anon_sym_thread_local] = ACTIONS(1393),
    [anon_sym___thread] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_constexpr] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym___restrict__] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym__Noreturn] = ACTIONS(1393),
    [anon_sym_noreturn] = ACTIONS(1393),
    [anon_sym_alignas] = ACTIONS(1393),
    [anon_sym__Alignas] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1393),
    [anon_sym_do] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_return] = ACTIONS(1393),
    [anon_sym_break] = ACTIONS(1393),
    [anon_sym_continue] = ACTIONS(1393),
    [anon_sym_goto] = ACTIONS(1393),
    [anon_sym___try] = ACTIONS(1393),
    [anon_sym___leave] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1395),
    [anon_sym_sizeof] = ACTIONS(1393),
    [anon_sym___alignof__] = ACTIONS(1393),
    [anon_sym___alignof] = ACTIONS(1393),
    [anon_sym__alignof] = ACTIONS(1393),
    [anon_sym_alignof] = ACTIONS(1393),
    [anon_sym__Alignof] = ACTIONS(1393),
    [anon_sym_offsetof] = ACTIONS(1393),
    [anon_sym__Generic] = ACTIONS(1393),
    [anon_sym_asm] = ACTIONS(1393),
    [anon_sym___asm__] = ACTIONS(1393),
    [sym_number_literal] = ACTIONS(1395),
    [anon_sym_L_SQUOTE] = ACTIONS(1395),
    [anon_sym_u_SQUOTE] = ACTIONS(1395),
    [anon_sym_U_SQUOTE] = ACTIONS(1395),
    [anon_sym_u8_SQUOTE] = ACTIONS(1395),
    [anon_sym_SQUOTE] = ACTIONS(1395),
    [anon_sym_L_DQUOTE] = ACTIONS(1395),
    [anon_sym_u_DQUOTE] = ACTIONS(1395),
    [anon_sym_U_DQUOTE] = ACTIONS(1395),
    [anon_sym_u8_DQUOTE] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [anon_sym_NULL] = ACTIONS(1393),
    [anon_sym_nullptr] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1393),
    [anon_sym_hitAttributeEXT] = ACTIONS(1393),
    [anon_sym_callableDataEXT] = ACTIONS(1393),
    [anon_sym_callableDataInEXT] = ACTIONS(1393),
    [anon_sym_shaderRecordEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadNV] = ACTIONS(1393),
    [anon_sym_rayPayloadInNV] = ACTIONS(1393),
    [anon_sym_hitAttributeNV] = ACTIONS(1393),
    [anon_sym_callableDataNV] = ACTIONS(1393),
    [anon_sym_callableDataInNV] = ACTIONS(1393),
    [anon_sym_shaderRecordNV] = ACTIONS(1393),
    [anon_sym_layout] = ACTIONS(1393),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(1291),
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_subroutine] = ACTIONS(1289),
    [anon_sym_invariant] = ACTIONS(1289),
    [anon_sym_precise] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1289),
    [anon_sym_out] = ACTIONS(1289),
    [anon_sym_inout] = ACTIONS(1289),
    [anon_sym_uniform] = ACTIONS(1289),
    [anon_sym_shared] = ACTIONS(1289),
    [anon_sym_attribute] = ACTIONS(1289),
    [anon_sym_varying] = ACTIONS(1289),
    [anon_sym_buffer] = ACTIONS(1289),
    [anon_sym_coherent] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_writeonly] = ACTIONS(1289),
    [anon_sym_precision] = ACTIONS(1289),
    [anon_sym_highp] = ACTIONS(1289),
    [anon_sym_mediump] = ACTIONS(1289),
    [anon_sym_lowp] = ACTIONS(1289),
    [anon_sym_centroid] = ACTIONS(1289),
    [anon_sym_sample] = ACTIONS(1289),
    [anon_sym_patch] = ACTIONS(1289),
    [anon_sym_smooth] = ACTIONS(1289),
    [anon_sym_flat] = ACTIONS(1289),
    [anon_sym_noperspective] = ACTIONS(1289),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_else] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1289),
    [anon_sym_hitAttributeEXT] = ACTIONS(1289),
    [anon_sym_callableDataEXT] = ACTIONS(1289),
    [anon_sym_callableDataInEXT] = ACTIONS(1289),
    [anon_sym_shaderRecordEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadNV] = ACTIONS(1289),
    [anon_sym_rayPayloadInNV] = ACTIONS(1289),
    [anon_sym_hitAttributeNV] = ACTIONS(1289),
    [anon_sym_callableDataNV] = ACTIONS(1289),
    [anon_sym_callableDataInNV] = ACTIONS(1289),
    [anon_sym_shaderRecordNV] = ACTIONS(1289),
    [anon_sym_layout] = ACTIONS(1289),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1365),
    [aux_sym_preproc_include_token1] = ACTIONS(1365),
    [aux_sym_preproc_def_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1365),
    [sym_preproc_directive] = ACTIONS(1365),
    [anon_sym_LPAREN2] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_subroutine] = ACTIONS(1365),
    [anon_sym_invariant] = ACTIONS(1365),
    [anon_sym_precise] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_out] = ACTIONS(1365),
    [anon_sym_inout] = ACTIONS(1365),
    [anon_sym_uniform] = ACTIONS(1365),
    [anon_sym_shared] = ACTIONS(1365),
    [anon_sym_attribute] = ACTIONS(1365),
    [anon_sym_varying] = ACTIONS(1365),
    [anon_sym_buffer] = ACTIONS(1365),
    [anon_sym_coherent] = ACTIONS(1365),
    [anon_sym_readonly] = ACTIONS(1365),
    [anon_sym_writeonly] = ACTIONS(1365),
    [anon_sym_precision] = ACTIONS(1365),
    [anon_sym_highp] = ACTIONS(1365),
    [anon_sym_mediump] = ACTIONS(1365),
    [anon_sym_lowp] = ACTIONS(1365),
    [anon_sym_centroid] = ACTIONS(1365),
    [anon_sym_sample] = ACTIONS(1365),
    [anon_sym_patch] = ACTIONS(1365),
    [anon_sym_smooth] = ACTIONS(1365),
    [anon_sym_flat] = ACTIONS(1365),
    [anon_sym_noperspective] = ACTIONS(1365),
    [anon_sym___extension__] = ACTIONS(1365),
    [anon_sym_typedef] = ACTIONS(1365),
    [anon_sym_extern] = ACTIONS(1365),
    [anon_sym___attribute__] = ACTIONS(1365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1365),
    [anon_sym___cdecl] = ACTIONS(1365),
    [anon_sym___clrcall] = ACTIONS(1365),
    [anon_sym___stdcall] = ACTIONS(1365),
    [anon_sym___fastcall] = ACTIONS(1365),
    [anon_sym___thiscall] = ACTIONS(1365),
    [anon_sym___vectorcall] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_signed] = ACTIONS(1365),
    [anon_sym_unsigned] = ACTIONS(1365),
    [anon_sym_long] = ACTIONS(1365),
    [anon_sym_short] = ACTIONS(1365),
    [anon_sym_static] = ACTIONS(1365),
    [anon_sym_auto] = ACTIONS(1365),
    [anon_sym_register] = ACTIONS(1365),
    [anon_sym_inline] = ACTIONS(1365),
    [anon_sym___inline] = ACTIONS(1365),
    [anon_sym___inline__] = ACTIONS(1365),
    [anon_sym___forceinline] = ACTIONS(1365),
    [anon_sym_thread_local] = ACTIONS(1365),
    [anon_sym___thread] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_constexpr] = ACTIONS(1365),
    [anon_sym_volatile] = ACTIONS(1365),
    [anon_sym_restrict] = ACTIONS(1365),
    [anon_sym___restrict__] = ACTIONS(1365),
    [anon_sym__Atomic] = ACTIONS(1365),
    [anon_sym__Noreturn] = ACTIONS(1365),
    [anon_sym_noreturn] = ACTIONS(1365),
    [anon_sym_alignas] = ACTIONS(1365),
    [anon_sym__Alignas] = ACTIONS(1365),
    [sym_primitive_type] = ACTIONS(1365),
    [anon_sym_enum] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1365),
    [anon_sym_union] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_case] = ACTIONS(1365),
    [anon_sym_default] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_do] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_break] = ACTIONS(1365),
    [anon_sym_continue] = ACTIONS(1365),
    [anon_sym_goto] = ACTIONS(1365),
    [anon_sym___try] = ACTIONS(1365),
    [anon_sym___leave] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_sizeof] = ACTIONS(1365),
    [anon_sym___alignof__] = ACTIONS(1365),
    [anon_sym___alignof] = ACTIONS(1365),
    [anon_sym__alignof] = ACTIONS(1365),
    [anon_sym_alignof] = ACTIONS(1365),
    [anon_sym__Alignof] = ACTIONS(1365),
    [anon_sym_offsetof] = ACTIONS(1365),
    [anon_sym__Generic] = ACTIONS(1365),
    [anon_sym_asm] = ACTIONS(1365),
    [anon_sym___asm__] = ACTIONS(1365),
    [sym_number_literal] = ACTIONS(1367),
    [anon_sym_L_SQUOTE] = ACTIONS(1367),
    [anon_sym_u_SQUOTE] = ACTIONS(1367),
    [anon_sym_U_SQUOTE] = ACTIONS(1367),
    [anon_sym_u8_SQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [anon_sym_L_DQUOTE] = ACTIONS(1367),
    [anon_sym_u_DQUOTE] = ACTIONS(1367),
    [anon_sym_U_DQUOTE] = ACTIONS(1367),
    [anon_sym_u8_DQUOTE] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [anon_sym_NULL] = ACTIONS(1365),
    [anon_sym_nullptr] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1365),
    [anon_sym_hitAttributeEXT] = ACTIONS(1365),
    [anon_sym_callableDataEXT] = ACTIONS(1365),
    [anon_sym_callableDataInEXT] = ACTIONS(1365),
    [anon_sym_shaderRecordEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadNV] = ACTIONS(1365),
    [anon_sym_rayPayloadInNV] = ACTIONS(1365),
    [anon_sym_hitAttributeNV] = ACTIONS(1365),
    [anon_sym_callableDataNV] = ACTIONS(1365),
    [anon_sym_callableDataInNV] = ACTIONS(1365),
    [anon_sym_shaderRecordNV] = ACTIONS(1365),
    [anon_sym_layout] = ACTIONS(1365),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1389),
    [aux_sym_preproc_include_token1] = ACTIONS(1389),
    [aux_sym_preproc_def_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_LPAREN2] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1389),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_subroutine] = ACTIONS(1389),
    [anon_sym_invariant] = ACTIONS(1389),
    [anon_sym_precise] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_out] = ACTIONS(1389),
    [anon_sym_inout] = ACTIONS(1389),
    [anon_sym_uniform] = ACTIONS(1389),
    [anon_sym_shared] = ACTIONS(1389),
    [anon_sym_attribute] = ACTIONS(1389),
    [anon_sym_varying] = ACTIONS(1389),
    [anon_sym_buffer] = ACTIONS(1389),
    [anon_sym_coherent] = ACTIONS(1389),
    [anon_sym_readonly] = ACTIONS(1389),
    [anon_sym_writeonly] = ACTIONS(1389),
    [anon_sym_precision] = ACTIONS(1389),
    [anon_sym_highp] = ACTIONS(1389),
    [anon_sym_mediump] = ACTIONS(1389),
    [anon_sym_lowp] = ACTIONS(1389),
    [anon_sym_centroid] = ACTIONS(1389),
    [anon_sym_sample] = ACTIONS(1389),
    [anon_sym_patch] = ACTIONS(1389),
    [anon_sym_smooth] = ACTIONS(1389),
    [anon_sym_flat] = ACTIONS(1389),
    [anon_sym_noperspective] = ACTIONS(1389),
    [anon_sym___extension__] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym___attribute__] = ACTIONS(1389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1391),
    [anon_sym___declspec] = ACTIONS(1389),
    [anon_sym___cdecl] = ACTIONS(1389),
    [anon_sym___clrcall] = ACTIONS(1389),
    [anon_sym___stdcall] = ACTIONS(1389),
    [anon_sym___fastcall] = ACTIONS(1389),
    [anon_sym___thiscall] = ACTIONS(1389),
    [anon_sym___vectorcall] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_signed] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym___inline] = ACTIONS(1389),
    [anon_sym___inline__] = ACTIONS(1389),
    [anon_sym___forceinline] = ACTIONS(1389),
    [anon_sym_thread_local] = ACTIONS(1389),
    [anon_sym___thread] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_constexpr] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym___restrict__] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym__Noreturn] = ACTIONS(1389),
    [anon_sym_noreturn] = ACTIONS(1389),
    [anon_sym_alignas] = ACTIONS(1389),
    [anon_sym__Alignas] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1389),
    [anon_sym_case] = ACTIONS(1389),
    [anon_sym_default] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(1389),
    [anon_sym_for] = ACTIONS(1389),
    [anon_sym_return] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(1389),
    [anon_sym_continue] = ACTIONS(1389),
    [anon_sym_goto] = ACTIONS(1389),
    [anon_sym___try] = ACTIONS(1389),
    [anon_sym___leave] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_sizeof] = ACTIONS(1389),
    [anon_sym___alignof__] = ACTIONS(1389),
    [anon_sym___alignof] = ACTIONS(1389),
    [anon_sym__alignof] = ACTIONS(1389),
    [anon_sym_alignof] = ACTIONS(1389),
    [anon_sym__Alignof] = ACTIONS(1389),
    [anon_sym_offsetof] = ACTIONS(1389),
    [anon_sym__Generic] = ACTIONS(1389),
    [anon_sym_asm] = ACTIONS(1389),
    [anon_sym___asm__] = ACTIONS(1389),
    [sym_number_literal] = ACTIONS(1391),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1391),
    [anon_sym_u_DQUOTE] = ACTIONS(1391),
    [anon_sym_U_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8_DQUOTE] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [anon_sym_NULL] = ACTIONS(1389),
    [anon_sym_nullptr] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1389),
    [anon_sym_hitAttributeEXT] = ACTIONS(1389),
    [anon_sym_callableDataEXT] = ACTIONS(1389),
    [anon_sym_callableDataInEXT] = ACTIONS(1389),
    [anon_sym_shaderRecordEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadNV] = ACTIONS(1389),
    [anon_sym_rayPayloadInNV] = ACTIONS(1389),
    [anon_sym_hitAttributeNV] = ACTIONS(1389),
    [anon_sym_callableDataNV] = ACTIONS(1389),
    [anon_sym_callableDataInNV] = ACTIONS(1389),
    [anon_sym_shaderRecordNV] = ACTIONS(1389),
    [anon_sym_layout] = ACTIONS(1389),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_subroutine] = ACTIONS(1281),
    [anon_sym_invariant] = ACTIONS(1281),
    [anon_sym_precise] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1281),
    [anon_sym_out] = ACTIONS(1281),
    [anon_sym_inout] = ACTIONS(1281),
    [anon_sym_uniform] = ACTIONS(1281),
    [anon_sym_shared] = ACTIONS(1281),
    [anon_sym_attribute] = ACTIONS(1281),
    [anon_sym_varying] = ACTIONS(1281),
    [anon_sym_buffer] = ACTIONS(1281),
    [anon_sym_coherent] = ACTIONS(1281),
    [anon_sym_readonly] = ACTIONS(1281),
    [anon_sym_writeonly] = ACTIONS(1281),
    [anon_sym_precision] = ACTIONS(1281),
    [anon_sym_highp] = ACTIONS(1281),
    [anon_sym_mediump] = ACTIONS(1281),
    [anon_sym_lowp] = ACTIONS(1281),
    [anon_sym_centroid] = ACTIONS(1281),
    [anon_sym_sample] = ACTIONS(1281),
    [anon_sym_patch] = ACTIONS(1281),
    [anon_sym_smooth] = ACTIONS(1281),
    [anon_sym_flat] = ACTIONS(1281),
    [anon_sym_noperspective] = ACTIONS(1281),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_else] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1281),
    [anon_sym_hitAttributeEXT] = ACTIONS(1281),
    [anon_sym_callableDataEXT] = ACTIONS(1281),
    [anon_sym_callableDataInEXT] = ACTIONS(1281),
    [anon_sym_shaderRecordEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadNV] = ACTIONS(1281),
    [anon_sym_rayPayloadInNV] = ACTIONS(1281),
    [anon_sym_hitAttributeNV] = ACTIONS(1281),
    [anon_sym_callableDataNV] = ACTIONS(1281),
    [anon_sym_callableDataInNV] = ACTIONS(1281),
    [anon_sym_shaderRecordNV] = ACTIONS(1281),
    [anon_sym_layout] = ACTIONS(1281),
  },
  [190] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_subroutine] = ACTIONS(1297),
    [anon_sym_invariant] = ACTIONS(1297),
    [anon_sym_precise] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_in] = ACTIONS(1297),
    [anon_sym_out] = ACTIONS(1297),
    [anon_sym_inout] = ACTIONS(1297),
    [anon_sym_uniform] = ACTIONS(1297),
    [anon_sym_shared] = ACTIONS(1297),
    [anon_sym_attribute] = ACTIONS(1297),
    [anon_sym_varying] = ACTIONS(1297),
    [anon_sym_buffer] = ACTIONS(1297),
    [anon_sym_coherent] = ACTIONS(1297),
    [anon_sym_readonly] = ACTIONS(1297),
    [anon_sym_writeonly] = ACTIONS(1297),
    [anon_sym_precision] = ACTIONS(1297),
    [anon_sym_highp] = ACTIONS(1297),
    [anon_sym_mediump] = ACTIONS(1297),
    [anon_sym_lowp] = ACTIONS(1297),
    [anon_sym_centroid] = ACTIONS(1297),
    [anon_sym_sample] = ACTIONS(1297),
    [anon_sym_patch] = ACTIONS(1297),
    [anon_sym_smooth] = ACTIONS(1297),
    [anon_sym_flat] = ACTIONS(1297),
    [anon_sym_noperspective] = ACTIONS(1297),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_else] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1297),
    [anon_sym_hitAttributeEXT] = ACTIONS(1297),
    [anon_sym_callableDataEXT] = ACTIONS(1297),
    [anon_sym_callableDataInEXT] = ACTIONS(1297),
    [anon_sym_shaderRecordEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadNV] = ACTIONS(1297),
    [anon_sym_rayPayloadInNV] = ACTIONS(1297),
    [anon_sym_hitAttributeNV] = ACTIONS(1297),
    [anon_sym_callableDataNV] = ACTIONS(1297),
    [anon_sym_callableDataInNV] = ACTIONS(1297),
    [anon_sym_shaderRecordNV] = ACTIONS(1297),
    [anon_sym_layout] = ACTIONS(1297),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(1255),
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_subroutine] = ACTIONS(1253),
    [anon_sym_invariant] = ACTIONS(1253),
    [anon_sym_precise] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_out] = ACTIONS(1253),
    [anon_sym_inout] = ACTIONS(1253),
    [anon_sym_uniform] = ACTIONS(1253),
    [anon_sym_shared] = ACTIONS(1253),
    [anon_sym_attribute] = ACTIONS(1253),
    [anon_sym_varying] = ACTIONS(1253),
    [anon_sym_buffer] = ACTIONS(1253),
    [anon_sym_coherent] = ACTIONS(1253),
    [anon_sym_readonly] = ACTIONS(1253),
    [anon_sym_writeonly] = ACTIONS(1253),
    [anon_sym_precision] = ACTIONS(1253),
    [anon_sym_highp] = ACTIONS(1253),
    [anon_sym_mediump] = ACTIONS(1253),
    [anon_sym_lowp] = ACTIONS(1253),
    [anon_sym_centroid] = ACTIONS(1253),
    [anon_sym_sample] = ACTIONS(1253),
    [anon_sym_patch] = ACTIONS(1253),
    [anon_sym_smooth] = ACTIONS(1253),
    [anon_sym_flat] = ACTIONS(1253),
    [anon_sym_noperspective] = ACTIONS(1253),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1253),
    [anon_sym_hitAttributeEXT] = ACTIONS(1253),
    [anon_sym_callableDataEXT] = ACTIONS(1253),
    [anon_sym_callableDataInEXT] = ACTIONS(1253),
    [anon_sym_shaderRecordEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadNV] = ACTIONS(1253),
    [anon_sym_rayPayloadInNV] = ACTIONS(1253),
    [anon_sym_hitAttributeNV] = ACTIONS(1253),
    [anon_sym_callableDataNV] = ACTIONS(1253),
    [anon_sym_callableDataInNV] = ACTIONS(1253),
    [anon_sym_shaderRecordNV] = ACTIONS(1253),
    [anon_sym_layout] = ACTIONS(1253),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1297),
    [aux_sym_preproc_include_token1] = ACTIONS(1297),
    [aux_sym_preproc_def_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token1] = ACTIONS(1297),
    [aux_sym_preproc_if_token2] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1297),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1297),
    [sym_preproc_directive] = ACTIONS(1297),
    [anon_sym_LPAREN2] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_subroutine] = ACTIONS(1297),
    [anon_sym_invariant] = ACTIONS(1297),
    [anon_sym_precise] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_in] = ACTIONS(1297),
    [anon_sym_out] = ACTIONS(1297),
    [anon_sym_inout] = ACTIONS(1297),
    [anon_sym_uniform] = ACTIONS(1297),
    [anon_sym_shared] = ACTIONS(1297),
    [anon_sym_attribute] = ACTIONS(1297),
    [anon_sym_varying] = ACTIONS(1297),
    [anon_sym_buffer] = ACTIONS(1297),
    [anon_sym_coherent] = ACTIONS(1297),
    [anon_sym_readonly] = ACTIONS(1297),
    [anon_sym_writeonly] = ACTIONS(1297),
    [anon_sym_precision] = ACTIONS(1297),
    [anon_sym_highp] = ACTIONS(1297),
    [anon_sym_mediump] = ACTIONS(1297),
    [anon_sym_lowp] = ACTIONS(1297),
    [anon_sym_centroid] = ACTIONS(1297),
    [anon_sym_sample] = ACTIONS(1297),
    [anon_sym_patch] = ACTIONS(1297),
    [anon_sym_smooth] = ACTIONS(1297),
    [anon_sym_flat] = ACTIONS(1297),
    [anon_sym_noperspective] = ACTIONS(1297),
    [anon_sym___extension__] = ACTIONS(1297),
    [anon_sym_typedef] = ACTIONS(1297),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym___attribute__] = ACTIONS(1297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1299),
    [anon_sym___declspec] = ACTIONS(1297),
    [anon_sym___cdecl] = ACTIONS(1297),
    [anon_sym___clrcall] = ACTIONS(1297),
    [anon_sym___stdcall] = ACTIONS(1297),
    [anon_sym___fastcall] = ACTIONS(1297),
    [anon_sym___thiscall] = ACTIONS(1297),
    [anon_sym___vectorcall] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_signed] = ACTIONS(1297),
    [anon_sym_unsigned] = ACTIONS(1297),
    [anon_sym_long] = ACTIONS(1297),
    [anon_sym_short] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_auto] = ACTIONS(1297),
    [anon_sym_register] = ACTIONS(1297),
    [anon_sym_inline] = ACTIONS(1297),
    [anon_sym___inline] = ACTIONS(1297),
    [anon_sym___inline__] = ACTIONS(1297),
    [anon_sym___forceinline] = ACTIONS(1297),
    [anon_sym_thread_local] = ACTIONS(1297),
    [anon_sym___thread] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_constexpr] = ACTIONS(1297),
    [anon_sym_volatile] = ACTIONS(1297),
    [anon_sym_restrict] = ACTIONS(1297),
    [anon_sym___restrict__] = ACTIONS(1297),
    [anon_sym__Atomic] = ACTIONS(1297),
    [anon_sym__Noreturn] = ACTIONS(1297),
    [anon_sym_noreturn] = ACTIONS(1297),
    [anon_sym_alignas] = ACTIONS(1297),
    [anon_sym__Alignas] = ACTIONS(1297),
    [sym_primitive_type] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_else] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1297),
    [anon_sym_case] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_do] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_goto] = ACTIONS(1297),
    [anon_sym___try] = ACTIONS(1297),
    [anon_sym___leave] = ACTIONS(1297),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_sizeof] = ACTIONS(1297),
    [anon_sym___alignof__] = ACTIONS(1297),
    [anon_sym___alignof] = ACTIONS(1297),
    [anon_sym__alignof] = ACTIONS(1297),
    [anon_sym_alignof] = ACTIONS(1297),
    [anon_sym__Alignof] = ACTIONS(1297),
    [anon_sym_offsetof] = ACTIONS(1297),
    [anon_sym__Generic] = ACTIONS(1297),
    [anon_sym_asm] = ACTIONS(1297),
    [anon_sym___asm__] = ACTIONS(1297),
    [sym_number_literal] = ACTIONS(1299),
    [anon_sym_L_SQUOTE] = ACTIONS(1299),
    [anon_sym_u_SQUOTE] = ACTIONS(1299),
    [anon_sym_U_SQUOTE] = ACTIONS(1299),
    [anon_sym_u8_SQUOTE] = ACTIONS(1299),
    [anon_sym_SQUOTE] = ACTIONS(1299),
    [anon_sym_L_DQUOTE] = ACTIONS(1299),
    [anon_sym_u_DQUOTE] = ACTIONS(1299),
    [anon_sym_U_DQUOTE] = ACTIONS(1299),
    [anon_sym_u8_DQUOTE] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1299),
    [sym_true] = ACTIONS(1297),
    [sym_false] = ACTIONS(1297),
    [anon_sym_NULL] = ACTIONS(1297),
    [anon_sym_nullptr] = ACTIONS(1297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1297),
    [anon_sym_hitAttributeEXT] = ACTIONS(1297),
    [anon_sym_callableDataEXT] = ACTIONS(1297),
    [anon_sym_callableDataInEXT] = ACTIONS(1297),
    [anon_sym_shaderRecordEXT] = ACTIONS(1297),
    [anon_sym_rayPayloadNV] = ACTIONS(1297),
    [anon_sym_rayPayloadInNV] = ACTIONS(1297),
    [anon_sym_hitAttributeNV] = ACTIONS(1297),
    [anon_sym_callableDataNV] = ACTIONS(1297),
    [anon_sym_callableDataInNV] = ACTIONS(1297),
    [anon_sym_shaderRecordNV] = ACTIONS(1297),
    [anon_sym_layout] = ACTIONS(1297),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_subroutine] = ACTIONS(1249),
    [anon_sym_invariant] = ACTIONS(1249),
    [anon_sym_precise] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_out] = ACTIONS(1249),
    [anon_sym_inout] = ACTIONS(1249),
    [anon_sym_uniform] = ACTIONS(1249),
    [anon_sym_shared] = ACTIONS(1249),
    [anon_sym_attribute] = ACTIONS(1249),
    [anon_sym_varying] = ACTIONS(1249),
    [anon_sym_buffer] = ACTIONS(1249),
    [anon_sym_coherent] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_writeonly] = ACTIONS(1249),
    [anon_sym_precision] = ACTIONS(1249),
    [anon_sym_highp] = ACTIONS(1249),
    [anon_sym_mediump] = ACTIONS(1249),
    [anon_sym_lowp] = ACTIONS(1249),
    [anon_sym_centroid] = ACTIONS(1249),
    [anon_sym_sample] = ACTIONS(1249),
    [anon_sym_patch] = ACTIONS(1249),
    [anon_sym_smooth] = ACTIONS(1249),
    [anon_sym_flat] = ACTIONS(1249),
    [anon_sym_noperspective] = ACTIONS(1249),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1249),
    [anon_sym_hitAttributeEXT] = ACTIONS(1249),
    [anon_sym_callableDataEXT] = ACTIONS(1249),
    [anon_sym_callableDataInEXT] = ACTIONS(1249),
    [anon_sym_shaderRecordEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadNV] = ACTIONS(1249),
    [anon_sym_rayPayloadInNV] = ACTIONS(1249),
    [anon_sym_hitAttributeNV] = ACTIONS(1249),
    [anon_sym_callableDataNV] = ACTIONS(1249),
    [anon_sym_callableDataInNV] = ACTIONS(1249),
    [anon_sym_shaderRecordNV] = ACTIONS(1249),
    [anon_sym_layout] = ACTIONS(1249),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [199] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(1279),
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [201] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [202] = {
    [sym_identifier] = ACTIONS(1245),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_TILDE] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_subroutine] = ACTIONS(1245),
    [anon_sym_invariant] = ACTIONS(1245),
    [anon_sym_precise] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_out] = ACTIONS(1245),
    [anon_sym_inout] = ACTIONS(1245),
    [anon_sym_uniform] = ACTIONS(1245),
    [anon_sym_shared] = ACTIONS(1245),
    [anon_sym_attribute] = ACTIONS(1245),
    [anon_sym_varying] = ACTIONS(1245),
    [anon_sym_buffer] = ACTIONS(1245),
    [anon_sym_coherent] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1245),
    [anon_sym_writeonly] = ACTIONS(1245),
    [anon_sym_precision] = ACTIONS(1245),
    [anon_sym_highp] = ACTIONS(1245),
    [anon_sym_mediump] = ACTIONS(1245),
    [anon_sym_lowp] = ACTIONS(1245),
    [anon_sym_centroid] = ACTIONS(1245),
    [anon_sym_sample] = ACTIONS(1245),
    [anon_sym_patch] = ACTIONS(1245),
    [anon_sym_smooth] = ACTIONS(1245),
    [anon_sym_flat] = ACTIONS(1245),
    [anon_sym_noperspective] = ACTIONS(1245),
    [anon_sym___extension__] = ACTIONS(1245),
    [anon_sym_typedef] = ACTIONS(1245),
    [anon_sym_extern] = ACTIONS(1245),
    [anon_sym___attribute__] = ACTIONS(1245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1247),
    [anon_sym___declspec] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(1245),
    [anon_sym_unsigned] = ACTIONS(1245),
    [anon_sym_long] = ACTIONS(1245),
    [anon_sym_short] = ACTIONS(1245),
    [anon_sym_static] = ACTIONS(1245),
    [anon_sym_auto] = ACTIONS(1245),
    [anon_sym_register] = ACTIONS(1245),
    [anon_sym_inline] = ACTIONS(1245),
    [anon_sym___inline] = ACTIONS(1245),
    [anon_sym___inline__] = ACTIONS(1245),
    [anon_sym___forceinline] = ACTIONS(1245),
    [anon_sym_thread_local] = ACTIONS(1245),
    [anon_sym___thread] = ACTIONS(1245),
    [anon_sym_const] = ACTIONS(1245),
    [anon_sym_constexpr] = ACTIONS(1245),
    [anon_sym_volatile] = ACTIONS(1245),
    [anon_sym_restrict] = ACTIONS(1245),
    [anon_sym___restrict__] = ACTIONS(1245),
    [anon_sym__Atomic] = ACTIONS(1245),
    [anon_sym__Noreturn] = ACTIONS(1245),
    [anon_sym_noreturn] = ACTIONS(1245),
    [anon_sym_alignas] = ACTIONS(1245),
    [anon_sym__Alignas] = ACTIONS(1245),
    [sym_primitive_type] = ACTIONS(1245),
    [anon_sym_enum] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1245),
    [anon_sym_union] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1245),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1245),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1245),
    [anon_sym_do] = ACTIONS(1245),
    [anon_sym_for] = ACTIONS(1245),
    [anon_sym_return] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1245),
    [anon_sym_continue] = ACTIONS(1245),
    [anon_sym_goto] = ACTIONS(1245),
    [anon_sym___try] = ACTIONS(1245),
    [anon_sym___leave] = ACTIONS(1245),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_sizeof] = ACTIONS(1245),
    [anon_sym___alignof__] = ACTIONS(1245),
    [anon_sym___alignof] = ACTIONS(1245),
    [anon_sym__alignof] = ACTIONS(1245),
    [anon_sym_alignof] = ACTIONS(1245),
    [anon_sym__Alignof] = ACTIONS(1245),
    [anon_sym_offsetof] = ACTIONS(1245),
    [anon_sym__Generic] = ACTIONS(1245),
    [anon_sym_asm] = ACTIONS(1245),
    [anon_sym___asm__] = ACTIONS(1245),
    [sym_number_literal] = ACTIONS(1247),
    [anon_sym_L_SQUOTE] = ACTIONS(1247),
    [anon_sym_u_SQUOTE] = ACTIONS(1247),
    [anon_sym_U_SQUOTE] = ACTIONS(1247),
    [anon_sym_u8_SQUOTE] = ACTIONS(1247),
    [anon_sym_SQUOTE] = ACTIONS(1247),
    [anon_sym_L_DQUOTE] = ACTIONS(1247),
    [anon_sym_u_DQUOTE] = ACTIONS(1247),
    [anon_sym_U_DQUOTE] = ACTIONS(1247),
    [anon_sym_u8_DQUOTE] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1247),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [anon_sym_NULL] = ACTIONS(1245),
    [anon_sym_nullptr] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1245),
    [anon_sym_hitAttributeEXT] = ACTIONS(1245),
    [anon_sym_callableDataEXT] = ACTIONS(1245),
    [anon_sym_callableDataInEXT] = ACTIONS(1245),
    [anon_sym_shaderRecordEXT] = ACTIONS(1245),
    [anon_sym_rayPayloadNV] = ACTIONS(1245),
    [anon_sym_rayPayloadInNV] = ACTIONS(1245),
    [anon_sym_hitAttributeNV] = ACTIONS(1245),
    [anon_sym_callableDataNV] = ACTIONS(1245),
    [anon_sym_callableDataInNV] = ACTIONS(1245),
    [anon_sym_shaderRecordNV] = ACTIONS(1245),
    [anon_sym_layout] = ACTIONS(1245),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(1279),
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_subroutine] = ACTIONS(1285),
    [anon_sym_invariant] = ACTIONS(1285),
    [anon_sym_precise] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_out] = ACTIONS(1285),
    [anon_sym_inout] = ACTIONS(1285),
    [anon_sym_uniform] = ACTIONS(1285),
    [anon_sym_shared] = ACTIONS(1285),
    [anon_sym_attribute] = ACTIONS(1285),
    [anon_sym_varying] = ACTIONS(1285),
    [anon_sym_buffer] = ACTIONS(1285),
    [anon_sym_coherent] = ACTIONS(1285),
    [anon_sym_readonly] = ACTIONS(1285),
    [anon_sym_writeonly] = ACTIONS(1285),
    [anon_sym_precision] = ACTIONS(1285),
    [anon_sym_highp] = ACTIONS(1285),
    [anon_sym_mediump] = ACTIONS(1285),
    [anon_sym_lowp] = ACTIONS(1285),
    [anon_sym_centroid] = ACTIONS(1285),
    [anon_sym_sample] = ACTIONS(1285),
    [anon_sym_patch] = ACTIONS(1285),
    [anon_sym_smooth] = ACTIONS(1285),
    [anon_sym_flat] = ACTIONS(1285),
    [anon_sym_noperspective] = ACTIONS(1285),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1285),
    [anon_sym_hitAttributeEXT] = ACTIONS(1285),
    [anon_sym_callableDataEXT] = ACTIONS(1285),
    [anon_sym_callableDataInEXT] = ACTIONS(1285),
    [anon_sym_shaderRecordEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadNV] = ACTIONS(1285),
    [anon_sym_rayPayloadInNV] = ACTIONS(1285),
    [anon_sym_hitAttributeNV] = ACTIONS(1285),
    [anon_sym_callableDataNV] = ACTIONS(1285),
    [anon_sym_callableDataInNV] = ACTIONS(1285),
    [anon_sym_shaderRecordNV] = ACTIONS(1285),
    [anon_sym_layout] = ACTIONS(1285),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_subroutine] = ACTIONS(1249),
    [anon_sym_invariant] = ACTIONS(1249),
    [anon_sym_precise] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_out] = ACTIONS(1249),
    [anon_sym_inout] = ACTIONS(1249),
    [anon_sym_uniform] = ACTIONS(1249),
    [anon_sym_shared] = ACTIONS(1249),
    [anon_sym_attribute] = ACTIONS(1249),
    [anon_sym_varying] = ACTIONS(1249),
    [anon_sym_buffer] = ACTIONS(1249),
    [anon_sym_coherent] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_writeonly] = ACTIONS(1249),
    [anon_sym_precision] = ACTIONS(1249),
    [anon_sym_highp] = ACTIONS(1249),
    [anon_sym_mediump] = ACTIONS(1249),
    [anon_sym_lowp] = ACTIONS(1249),
    [anon_sym_centroid] = ACTIONS(1249),
    [anon_sym_sample] = ACTIONS(1249),
    [anon_sym_patch] = ACTIONS(1249),
    [anon_sym_smooth] = ACTIONS(1249),
    [anon_sym_flat] = ACTIONS(1249),
    [anon_sym_noperspective] = ACTIONS(1249),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1249),
    [anon_sym_hitAttributeEXT] = ACTIONS(1249),
    [anon_sym_callableDataEXT] = ACTIONS(1249),
    [anon_sym_callableDataInEXT] = ACTIONS(1249),
    [anon_sym_shaderRecordEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadNV] = ACTIONS(1249),
    [anon_sym_rayPayloadInNV] = ACTIONS(1249),
    [anon_sym_hitAttributeNV] = ACTIONS(1249),
    [anon_sym_callableDataNV] = ACTIONS(1249),
    [anon_sym_callableDataInNV] = ACTIONS(1249),
    [anon_sym_shaderRecordNV] = ACTIONS(1249),
    [anon_sym_layout] = ACTIONS(1249),
  },
  [206] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_subroutine] = ACTIONS(1253),
    [anon_sym_invariant] = ACTIONS(1253),
    [anon_sym_precise] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_out] = ACTIONS(1253),
    [anon_sym_inout] = ACTIONS(1253),
    [anon_sym_uniform] = ACTIONS(1253),
    [anon_sym_shared] = ACTIONS(1253),
    [anon_sym_attribute] = ACTIONS(1253),
    [anon_sym_varying] = ACTIONS(1253),
    [anon_sym_buffer] = ACTIONS(1253),
    [anon_sym_coherent] = ACTIONS(1253),
    [anon_sym_readonly] = ACTIONS(1253),
    [anon_sym_writeonly] = ACTIONS(1253),
    [anon_sym_precision] = ACTIONS(1253),
    [anon_sym_highp] = ACTIONS(1253),
    [anon_sym_mediump] = ACTIONS(1253),
    [anon_sym_lowp] = ACTIONS(1253),
    [anon_sym_centroid] = ACTIONS(1253),
    [anon_sym_sample] = ACTIONS(1253),
    [anon_sym_patch] = ACTIONS(1253),
    [anon_sym_smooth] = ACTIONS(1253),
    [anon_sym_flat] = ACTIONS(1253),
    [anon_sym_noperspective] = ACTIONS(1253),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1253),
    [anon_sym_hitAttributeEXT] = ACTIONS(1253),
    [anon_sym_callableDataEXT] = ACTIONS(1253),
    [anon_sym_callableDataInEXT] = ACTIONS(1253),
    [anon_sym_shaderRecordEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadNV] = ACTIONS(1253),
    [anon_sym_rayPayloadInNV] = ACTIONS(1253),
    [anon_sym_hitAttributeNV] = ACTIONS(1253),
    [anon_sym_callableDataNV] = ACTIONS(1253),
    [anon_sym_callableDataInNV] = ACTIONS(1253),
    [anon_sym_shaderRecordNV] = ACTIONS(1253),
    [anon_sym_layout] = ACTIONS(1253),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_subroutine] = ACTIONS(1233),
    [anon_sym_invariant] = ACTIONS(1233),
    [anon_sym_precise] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1233),
    [anon_sym_out] = ACTIONS(1233),
    [anon_sym_inout] = ACTIONS(1233),
    [anon_sym_uniform] = ACTIONS(1233),
    [anon_sym_shared] = ACTIONS(1233),
    [anon_sym_attribute] = ACTIONS(1233),
    [anon_sym_varying] = ACTIONS(1233),
    [anon_sym_buffer] = ACTIONS(1233),
    [anon_sym_coherent] = ACTIONS(1233),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_writeonly] = ACTIONS(1233),
    [anon_sym_precision] = ACTIONS(1233),
    [anon_sym_highp] = ACTIONS(1233),
    [anon_sym_mediump] = ACTIONS(1233),
    [anon_sym_lowp] = ACTIONS(1233),
    [anon_sym_centroid] = ACTIONS(1233),
    [anon_sym_sample] = ACTIONS(1233),
    [anon_sym_patch] = ACTIONS(1233),
    [anon_sym_smooth] = ACTIONS(1233),
    [anon_sym_flat] = ACTIONS(1233),
    [anon_sym_noperspective] = ACTIONS(1233),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1233),
    [anon_sym_hitAttributeEXT] = ACTIONS(1233),
    [anon_sym_callableDataEXT] = ACTIONS(1233),
    [anon_sym_callableDataInEXT] = ACTIONS(1233),
    [anon_sym_shaderRecordEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadNV] = ACTIONS(1233),
    [anon_sym_rayPayloadInNV] = ACTIONS(1233),
    [anon_sym_hitAttributeNV] = ACTIONS(1233),
    [anon_sym_callableDataNV] = ACTIONS(1233),
    [anon_sym_callableDataInNV] = ACTIONS(1233),
    [anon_sym_shaderRecordNV] = ACTIONS(1233),
    [anon_sym_layout] = ACTIONS(1233),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_subroutine] = ACTIONS(1261),
    [anon_sym_invariant] = ACTIONS(1261),
    [anon_sym_precise] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_out] = ACTIONS(1261),
    [anon_sym_inout] = ACTIONS(1261),
    [anon_sym_uniform] = ACTIONS(1261),
    [anon_sym_shared] = ACTIONS(1261),
    [anon_sym_attribute] = ACTIONS(1261),
    [anon_sym_varying] = ACTIONS(1261),
    [anon_sym_buffer] = ACTIONS(1261),
    [anon_sym_coherent] = ACTIONS(1261),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_writeonly] = ACTIONS(1261),
    [anon_sym_precision] = ACTIONS(1261),
    [anon_sym_highp] = ACTIONS(1261),
    [anon_sym_mediump] = ACTIONS(1261),
    [anon_sym_lowp] = ACTIONS(1261),
    [anon_sym_centroid] = ACTIONS(1261),
    [anon_sym_sample] = ACTIONS(1261),
    [anon_sym_patch] = ACTIONS(1261),
    [anon_sym_smooth] = ACTIONS(1261),
    [anon_sym_flat] = ACTIONS(1261),
    [anon_sym_noperspective] = ACTIONS(1261),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1261),
    [anon_sym_hitAttributeEXT] = ACTIONS(1261),
    [anon_sym_callableDataEXT] = ACTIONS(1261),
    [anon_sym_callableDataInEXT] = ACTIONS(1261),
    [anon_sym_shaderRecordEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadNV] = ACTIONS(1261),
    [anon_sym_rayPayloadInNV] = ACTIONS(1261),
    [anon_sym_hitAttributeNV] = ACTIONS(1261),
    [anon_sym_callableDataNV] = ACTIONS(1261),
    [anon_sym_callableDataInNV] = ACTIONS(1261),
    [anon_sym_shaderRecordNV] = ACTIONS(1261),
    [anon_sym_layout] = ACTIONS(1261),
  },
  [209] = {
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1249),
    [aux_sym_preproc_def_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token1] = ACTIONS(1249),
    [aux_sym_preproc_if_token2] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1249),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1249),
    [sym_preproc_directive] = ACTIONS(1249),
    [anon_sym_LPAREN2] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1249),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_subroutine] = ACTIONS(1249),
    [anon_sym_invariant] = ACTIONS(1249),
    [anon_sym_precise] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1249),
    [anon_sym_out] = ACTIONS(1249),
    [anon_sym_inout] = ACTIONS(1249),
    [anon_sym_uniform] = ACTIONS(1249),
    [anon_sym_shared] = ACTIONS(1249),
    [anon_sym_attribute] = ACTIONS(1249),
    [anon_sym_varying] = ACTIONS(1249),
    [anon_sym_buffer] = ACTIONS(1249),
    [anon_sym_coherent] = ACTIONS(1249),
    [anon_sym_readonly] = ACTIONS(1249),
    [anon_sym_writeonly] = ACTIONS(1249),
    [anon_sym_precision] = ACTIONS(1249),
    [anon_sym_highp] = ACTIONS(1249),
    [anon_sym_mediump] = ACTIONS(1249),
    [anon_sym_lowp] = ACTIONS(1249),
    [anon_sym_centroid] = ACTIONS(1249),
    [anon_sym_sample] = ACTIONS(1249),
    [anon_sym_patch] = ACTIONS(1249),
    [anon_sym_smooth] = ACTIONS(1249),
    [anon_sym_flat] = ACTIONS(1249),
    [anon_sym_noperspective] = ACTIONS(1249),
    [anon_sym___extension__] = ACTIONS(1249),
    [anon_sym_typedef] = ACTIONS(1249),
    [anon_sym_extern] = ACTIONS(1249),
    [anon_sym___attribute__] = ACTIONS(1249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1251),
    [anon_sym___declspec] = ACTIONS(1249),
    [anon_sym___cdecl] = ACTIONS(1249),
    [anon_sym___clrcall] = ACTIONS(1249),
    [anon_sym___stdcall] = ACTIONS(1249),
    [anon_sym___fastcall] = ACTIONS(1249),
    [anon_sym___thiscall] = ACTIONS(1249),
    [anon_sym___vectorcall] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_signed] = ACTIONS(1249),
    [anon_sym_unsigned] = ACTIONS(1249),
    [anon_sym_long] = ACTIONS(1249),
    [anon_sym_short] = ACTIONS(1249),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_auto] = ACTIONS(1249),
    [anon_sym_register] = ACTIONS(1249),
    [anon_sym_inline] = ACTIONS(1249),
    [anon_sym___inline] = ACTIONS(1249),
    [anon_sym___inline__] = ACTIONS(1249),
    [anon_sym___forceinline] = ACTIONS(1249),
    [anon_sym_thread_local] = ACTIONS(1249),
    [anon_sym___thread] = ACTIONS(1249),
    [anon_sym_const] = ACTIONS(1249),
    [anon_sym_constexpr] = ACTIONS(1249),
    [anon_sym_volatile] = ACTIONS(1249),
    [anon_sym_restrict] = ACTIONS(1249),
    [anon_sym___restrict__] = ACTIONS(1249),
    [anon_sym__Atomic] = ACTIONS(1249),
    [anon_sym__Noreturn] = ACTIONS(1249),
    [anon_sym_noreturn] = ACTIONS(1249),
    [anon_sym_alignas] = ACTIONS(1249),
    [anon_sym__Alignas] = ACTIONS(1249),
    [sym_primitive_type] = ACTIONS(1249),
    [anon_sym_enum] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1249),
    [anon_sym_union] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1249),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1249),
    [anon_sym_case] = ACTIONS(1249),
    [anon_sym_default] = ACTIONS(1249),
    [anon_sym_while] = ACTIONS(1249),
    [anon_sym_do] = ACTIONS(1249),
    [anon_sym_for] = ACTIONS(1249),
    [anon_sym_return] = ACTIONS(1249),
    [anon_sym_break] = ACTIONS(1249),
    [anon_sym_continue] = ACTIONS(1249),
    [anon_sym_goto] = ACTIONS(1249),
    [anon_sym___try] = ACTIONS(1249),
    [anon_sym___leave] = ACTIONS(1249),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_sizeof] = ACTIONS(1249),
    [anon_sym___alignof__] = ACTIONS(1249),
    [anon_sym___alignof] = ACTIONS(1249),
    [anon_sym__alignof] = ACTIONS(1249),
    [anon_sym_alignof] = ACTIONS(1249),
    [anon_sym__Alignof] = ACTIONS(1249),
    [anon_sym_offsetof] = ACTIONS(1249),
    [anon_sym__Generic] = ACTIONS(1249),
    [anon_sym_asm] = ACTIONS(1249),
    [anon_sym___asm__] = ACTIONS(1249),
    [sym_number_literal] = ACTIONS(1251),
    [anon_sym_L_SQUOTE] = ACTIONS(1251),
    [anon_sym_u_SQUOTE] = ACTIONS(1251),
    [anon_sym_U_SQUOTE] = ACTIONS(1251),
    [anon_sym_u8_SQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [anon_sym_L_DQUOTE] = ACTIONS(1251),
    [anon_sym_u_DQUOTE] = ACTIONS(1251),
    [anon_sym_U_DQUOTE] = ACTIONS(1251),
    [anon_sym_u8_DQUOTE] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [sym_true] = ACTIONS(1249),
    [sym_false] = ACTIONS(1249),
    [anon_sym_NULL] = ACTIONS(1249),
    [anon_sym_nullptr] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1249),
    [anon_sym_hitAttributeEXT] = ACTIONS(1249),
    [anon_sym_callableDataEXT] = ACTIONS(1249),
    [anon_sym_callableDataInEXT] = ACTIONS(1249),
    [anon_sym_shaderRecordEXT] = ACTIONS(1249),
    [anon_sym_rayPayloadNV] = ACTIONS(1249),
    [anon_sym_rayPayloadInNV] = ACTIONS(1249),
    [anon_sym_hitAttributeNV] = ACTIONS(1249),
    [anon_sym_callableDataNV] = ACTIONS(1249),
    [anon_sym_callableDataInNV] = ACTIONS(1249),
    [anon_sym_shaderRecordNV] = ACTIONS(1249),
    [anon_sym_layout] = ACTIONS(1249),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_subroutine] = ACTIONS(1269),
    [anon_sym_invariant] = ACTIONS(1269),
    [anon_sym_precise] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_out] = ACTIONS(1269),
    [anon_sym_inout] = ACTIONS(1269),
    [anon_sym_uniform] = ACTIONS(1269),
    [anon_sym_shared] = ACTIONS(1269),
    [anon_sym_attribute] = ACTIONS(1269),
    [anon_sym_varying] = ACTIONS(1269),
    [anon_sym_buffer] = ACTIONS(1269),
    [anon_sym_coherent] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_writeonly] = ACTIONS(1269),
    [anon_sym_precision] = ACTIONS(1269),
    [anon_sym_highp] = ACTIONS(1269),
    [anon_sym_mediump] = ACTIONS(1269),
    [anon_sym_lowp] = ACTIONS(1269),
    [anon_sym_centroid] = ACTIONS(1269),
    [anon_sym_sample] = ACTIONS(1269),
    [anon_sym_patch] = ACTIONS(1269),
    [anon_sym_smooth] = ACTIONS(1269),
    [anon_sym_flat] = ACTIONS(1269),
    [anon_sym_noperspective] = ACTIONS(1269),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1269),
    [anon_sym_hitAttributeEXT] = ACTIONS(1269),
    [anon_sym_callableDataEXT] = ACTIONS(1269),
    [anon_sym_callableDataInEXT] = ACTIONS(1269),
    [anon_sym_shaderRecordEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadNV] = ACTIONS(1269),
    [anon_sym_rayPayloadInNV] = ACTIONS(1269),
    [anon_sym_hitAttributeNV] = ACTIONS(1269),
    [anon_sym_callableDataNV] = ACTIONS(1269),
    [anon_sym_callableDataInNV] = ACTIONS(1269),
    [anon_sym_shaderRecordNV] = ACTIONS(1269),
    [anon_sym_layout] = ACTIONS(1269),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(1383),
    [sym_identifier] = ACTIONS(1381),
    [aux_sym_preproc_include_token1] = ACTIONS(1381),
    [aux_sym_preproc_def_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1381),
    [sym_preproc_directive] = ACTIONS(1381),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_subroutine] = ACTIONS(1381),
    [anon_sym_invariant] = ACTIONS(1381),
    [anon_sym_precise] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_out] = ACTIONS(1381),
    [anon_sym_inout] = ACTIONS(1381),
    [anon_sym_uniform] = ACTIONS(1381),
    [anon_sym_shared] = ACTIONS(1381),
    [anon_sym_attribute] = ACTIONS(1381),
    [anon_sym_varying] = ACTIONS(1381),
    [anon_sym_buffer] = ACTIONS(1381),
    [anon_sym_coherent] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_writeonly] = ACTIONS(1381),
    [anon_sym_precision] = ACTIONS(1381),
    [anon_sym_highp] = ACTIONS(1381),
    [anon_sym_mediump] = ACTIONS(1381),
    [anon_sym_lowp] = ACTIONS(1381),
    [anon_sym_centroid] = ACTIONS(1381),
    [anon_sym_sample] = ACTIONS(1381),
    [anon_sym_patch] = ACTIONS(1381),
    [anon_sym_smooth] = ACTIONS(1381),
    [anon_sym_flat] = ACTIONS(1381),
    [anon_sym_noperspective] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1381),
    [anon_sym_typedef] = ACTIONS(1381),
    [anon_sym_extern] = ACTIONS(1381),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1383),
    [anon_sym___declspec] = ACTIONS(1381),
    [anon_sym___cdecl] = ACTIONS(1381),
    [anon_sym___clrcall] = ACTIONS(1381),
    [anon_sym___stdcall] = ACTIONS(1381),
    [anon_sym___fastcall] = ACTIONS(1381),
    [anon_sym___thiscall] = ACTIONS(1381),
    [anon_sym___vectorcall] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_signed] = ACTIONS(1381),
    [anon_sym_unsigned] = ACTIONS(1381),
    [anon_sym_long] = ACTIONS(1381),
    [anon_sym_short] = ACTIONS(1381),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_auto] = ACTIONS(1381),
    [anon_sym_register] = ACTIONS(1381),
    [anon_sym_inline] = ACTIONS(1381),
    [anon_sym___inline] = ACTIONS(1381),
    [anon_sym___inline__] = ACTIONS(1381),
    [anon_sym___forceinline] = ACTIONS(1381),
    [anon_sym_thread_local] = ACTIONS(1381),
    [anon_sym___thread] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym___restrict__] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym__Noreturn] = ACTIONS(1381),
    [anon_sym_noreturn] = ACTIONS(1381),
    [anon_sym_alignas] = ACTIONS(1381),
    [anon_sym__Alignas] = ACTIONS(1381),
    [sym_primitive_type] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1381),
    [anon_sym_union] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_goto] = ACTIONS(1381),
    [anon_sym___try] = ACTIONS(1381),
    [anon_sym___leave] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1381),
    [anon_sym___alignof__] = ACTIONS(1381),
    [anon_sym___alignof] = ACTIONS(1381),
    [anon_sym__alignof] = ACTIONS(1381),
    [anon_sym_alignof] = ACTIONS(1381),
    [anon_sym__Alignof] = ACTIONS(1381),
    [anon_sym_offsetof] = ACTIONS(1381),
    [anon_sym__Generic] = ACTIONS(1381),
    [anon_sym_asm] = ACTIONS(1381),
    [anon_sym___asm__] = ACTIONS(1381),
    [sym_number_literal] = ACTIONS(1383),
    [anon_sym_L_SQUOTE] = ACTIONS(1383),
    [anon_sym_u_SQUOTE] = ACTIONS(1383),
    [anon_sym_U_SQUOTE] = ACTIONS(1383),
    [anon_sym_u8_SQUOTE] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1383),
    [anon_sym_L_DQUOTE] = ACTIONS(1383),
    [anon_sym_u_DQUOTE] = ACTIONS(1383),
    [anon_sym_U_DQUOTE] = ACTIONS(1383),
    [anon_sym_u8_DQUOTE] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1383),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [anon_sym_NULL] = ACTIONS(1381),
    [anon_sym_nullptr] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1381),
    [anon_sym_hitAttributeEXT] = ACTIONS(1381),
    [anon_sym_callableDataEXT] = ACTIONS(1381),
    [anon_sym_callableDataInEXT] = ACTIONS(1381),
    [anon_sym_shaderRecordEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadNV] = ACTIONS(1381),
    [anon_sym_rayPayloadInNV] = ACTIONS(1381),
    [anon_sym_hitAttributeNV] = ACTIONS(1381),
    [anon_sym_callableDataNV] = ACTIONS(1381),
    [anon_sym_callableDataInNV] = ACTIONS(1381),
    [anon_sym_shaderRecordNV] = ACTIONS(1381),
    [anon_sym_layout] = ACTIONS(1381),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [216] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_subroutine] = ACTIONS(1301),
    [anon_sym_invariant] = ACTIONS(1301),
    [anon_sym_precise] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_out] = ACTIONS(1301),
    [anon_sym_inout] = ACTIONS(1301),
    [anon_sym_uniform] = ACTIONS(1301),
    [anon_sym_shared] = ACTIONS(1301),
    [anon_sym_attribute] = ACTIONS(1301),
    [anon_sym_varying] = ACTIONS(1301),
    [anon_sym_buffer] = ACTIONS(1301),
    [anon_sym_coherent] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_writeonly] = ACTIONS(1301),
    [anon_sym_precision] = ACTIONS(1301),
    [anon_sym_highp] = ACTIONS(1301),
    [anon_sym_mediump] = ACTIONS(1301),
    [anon_sym_lowp] = ACTIONS(1301),
    [anon_sym_centroid] = ACTIONS(1301),
    [anon_sym_sample] = ACTIONS(1301),
    [anon_sym_patch] = ACTIONS(1301),
    [anon_sym_smooth] = ACTIONS(1301),
    [anon_sym_flat] = ACTIONS(1301),
    [anon_sym_noperspective] = ACTIONS(1301),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1301),
    [anon_sym_hitAttributeEXT] = ACTIONS(1301),
    [anon_sym_callableDataEXT] = ACTIONS(1301),
    [anon_sym_callableDataInEXT] = ACTIONS(1301),
    [anon_sym_shaderRecordEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadNV] = ACTIONS(1301),
    [anon_sym_rayPayloadInNV] = ACTIONS(1301),
    [anon_sym_hitAttributeNV] = ACTIONS(1301),
    [anon_sym_callableDataNV] = ACTIONS(1301),
    [anon_sym_callableDataInNV] = ACTIONS(1301),
    [anon_sym_shaderRecordNV] = ACTIONS(1301),
    [anon_sym_layout] = ACTIONS(1301),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_subroutine] = ACTIONS(1285),
    [anon_sym_invariant] = ACTIONS(1285),
    [anon_sym_precise] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_out] = ACTIONS(1285),
    [anon_sym_inout] = ACTIONS(1285),
    [anon_sym_uniform] = ACTIONS(1285),
    [anon_sym_shared] = ACTIONS(1285),
    [anon_sym_attribute] = ACTIONS(1285),
    [anon_sym_varying] = ACTIONS(1285),
    [anon_sym_buffer] = ACTIONS(1285),
    [anon_sym_coherent] = ACTIONS(1285),
    [anon_sym_readonly] = ACTIONS(1285),
    [anon_sym_writeonly] = ACTIONS(1285),
    [anon_sym_precision] = ACTIONS(1285),
    [anon_sym_highp] = ACTIONS(1285),
    [anon_sym_mediump] = ACTIONS(1285),
    [anon_sym_lowp] = ACTIONS(1285),
    [anon_sym_centroid] = ACTIONS(1285),
    [anon_sym_sample] = ACTIONS(1285),
    [anon_sym_patch] = ACTIONS(1285),
    [anon_sym_smooth] = ACTIONS(1285),
    [anon_sym_flat] = ACTIONS(1285),
    [anon_sym_noperspective] = ACTIONS(1285),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_RBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1285),
    [anon_sym_hitAttributeEXT] = ACTIONS(1285),
    [anon_sym_callableDataEXT] = ACTIONS(1285),
    [anon_sym_callableDataInEXT] = ACTIONS(1285),
    [anon_sym_shaderRecordEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadNV] = ACTIONS(1285),
    [anon_sym_rayPayloadInNV] = ACTIONS(1285),
    [anon_sym_hitAttributeNV] = ACTIONS(1285),
    [anon_sym_callableDataNV] = ACTIONS(1285),
    [anon_sym_callableDataInNV] = ACTIONS(1285),
    [anon_sym_shaderRecordNV] = ACTIONS(1285),
    [anon_sym_layout] = ACTIONS(1285),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1253),
    [aux_sym_preproc_include_token1] = ACTIONS(1253),
    [aux_sym_preproc_def_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token1] = ACTIONS(1253),
    [aux_sym_preproc_if_token2] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1253),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1253),
    [sym_preproc_directive] = ACTIONS(1253),
    [anon_sym_LPAREN2] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_subroutine] = ACTIONS(1253),
    [anon_sym_invariant] = ACTIONS(1253),
    [anon_sym_precise] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
    [anon_sym_out] = ACTIONS(1253),
    [anon_sym_inout] = ACTIONS(1253),
    [anon_sym_uniform] = ACTIONS(1253),
    [anon_sym_shared] = ACTIONS(1253),
    [anon_sym_attribute] = ACTIONS(1253),
    [anon_sym_varying] = ACTIONS(1253),
    [anon_sym_buffer] = ACTIONS(1253),
    [anon_sym_coherent] = ACTIONS(1253),
    [anon_sym_readonly] = ACTIONS(1253),
    [anon_sym_writeonly] = ACTIONS(1253),
    [anon_sym_precision] = ACTIONS(1253),
    [anon_sym_highp] = ACTIONS(1253),
    [anon_sym_mediump] = ACTIONS(1253),
    [anon_sym_lowp] = ACTIONS(1253),
    [anon_sym_centroid] = ACTIONS(1253),
    [anon_sym_sample] = ACTIONS(1253),
    [anon_sym_patch] = ACTIONS(1253),
    [anon_sym_smooth] = ACTIONS(1253),
    [anon_sym_flat] = ACTIONS(1253),
    [anon_sym_noperspective] = ACTIONS(1253),
    [anon_sym___extension__] = ACTIONS(1253),
    [anon_sym_typedef] = ACTIONS(1253),
    [anon_sym_extern] = ACTIONS(1253),
    [anon_sym___attribute__] = ACTIONS(1253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1255),
    [anon_sym___declspec] = ACTIONS(1253),
    [anon_sym___cdecl] = ACTIONS(1253),
    [anon_sym___clrcall] = ACTIONS(1253),
    [anon_sym___stdcall] = ACTIONS(1253),
    [anon_sym___fastcall] = ACTIONS(1253),
    [anon_sym___thiscall] = ACTIONS(1253),
    [anon_sym___vectorcall] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_signed] = ACTIONS(1253),
    [anon_sym_unsigned] = ACTIONS(1253),
    [anon_sym_long] = ACTIONS(1253),
    [anon_sym_short] = ACTIONS(1253),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_auto] = ACTIONS(1253),
    [anon_sym_register] = ACTIONS(1253),
    [anon_sym_inline] = ACTIONS(1253),
    [anon_sym___inline] = ACTIONS(1253),
    [anon_sym___inline__] = ACTIONS(1253),
    [anon_sym___forceinline] = ACTIONS(1253),
    [anon_sym_thread_local] = ACTIONS(1253),
    [anon_sym___thread] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_constexpr] = ACTIONS(1253),
    [anon_sym_volatile] = ACTIONS(1253),
    [anon_sym_restrict] = ACTIONS(1253),
    [anon_sym___restrict__] = ACTIONS(1253),
    [anon_sym__Atomic] = ACTIONS(1253),
    [anon_sym__Noreturn] = ACTIONS(1253),
    [anon_sym_noreturn] = ACTIONS(1253),
    [anon_sym_alignas] = ACTIONS(1253),
    [anon_sym__Alignas] = ACTIONS(1253),
    [sym_primitive_type] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_union] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_goto] = ACTIONS(1253),
    [anon_sym___try] = ACTIONS(1253),
    [anon_sym___leave] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_sizeof] = ACTIONS(1253),
    [anon_sym___alignof__] = ACTIONS(1253),
    [anon_sym___alignof] = ACTIONS(1253),
    [anon_sym__alignof] = ACTIONS(1253),
    [anon_sym_alignof] = ACTIONS(1253),
    [anon_sym__Alignof] = ACTIONS(1253),
    [anon_sym_offsetof] = ACTIONS(1253),
    [anon_sym__Generic] = ACTIONS(1253),
    [anon_sym_asm] = ACTIONS(1253),
    [anon_sym___asm__] = ACTIONS(1253),
    [sym_number_literal] = ACTIONS(1255),
    [anon_sym_L_SQUOTE] = ACTIONS(1255),
    [anon_sym_u_SQUOTE] = ACTIONS(1255),
    [anon_sym_U_SQUOTE] = ACTIONS(1255),
    [anon_sym_u8_SQUOTE] = ACTIONS(1255),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_L_DQUOTE] = ACTIONS(1255),
    [anon_sym_u_DQUOTE] = ACTIONS(1255),
    [anon_sym_U_DQUOTE] = ACTIONS(1255),
    [anon_sym_u8_DQUOTE] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [anon_sym_NULL] = ACTIONS(1253),
    [anon_sym_nullptr] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1253),
    [anon_sym_hitAttributeEXT] = ACTIONS(1253),
    [anon_sym_callableDataEXT] = ACTIONS(1253),
    [anon_sym_callableDataInEXT] = ACTIONS(1253),
    [anon_sym_shaderRecordEXT] = ACTIONS(1253),
    [anon_sym_rayPayloadNV] = ACTIONS(1253),
    [anon_sym_rayPayloadInNV] = ACTIONS(1253),
    [anon_sym_hitAttributeNV] = ACTIONS(1253),
    [anon_sym_callableDataNV] = ACTIONS(1253),
    [anon_sym_callableDataInNV] = ACTIONS(1253),
    [anon_sym_shaderRecordNV] = ACTIONS(1253),
    [anon_sym_layout] = ACTIONS(1253),
  },
  [221] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(1375),
    [sym_identifier] = ACTIONS(1373),
    [aux_sym_preproc_include_token1] = ACTIONS(1373),
    [aux_sym_preproc_def_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1373),
    [sym_preproc_directive] = ACTIONS(1373),
    [anon_sym_LPAREN2] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_TILDE] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_subroutine] = ACTIONS(1373),
    [anon_sym_invariant] = ACTIONS(1373),
    [anon_sym_precise] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_in] = ACTIONS(1373),
    [anon_sym_out] = ACTIONS(1373),
    [anon_sym_inout] = ACTIONS(1373),
    [anon_sym_uniform] = ACTIONS(1373),
    [anon_sym_shared] = ACTIONS(1373),
    [anon_sym_attribute] = ACTIONS(1373),
    [anon_sym_varying] = ACTIONS(1373),
    [anon_sym_buffer] = ACTIONS(1373),
    [anon_sym_coherent] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_writeonly] = ACTIONS(1373),
    [anon_sym_precision] = ACTIONS(1373),
    [anon_sym_highp] = ACTIONS(1373),
    [anon_sym_mediump] = ACTIONS(1373),
    [anon_sym_lowp] = ACTIONS(1373),
    [anon_sym_centroid] = ACTIONS(1373),
    [anon_sym_sample] = ACTIONS(1373),
    [anon_sym_patch] = ACTIONS(1373),
    [anon_sym_smooth] = ACTIONS(1373),
    [anon_sym_flat] = ACTIONS(1373),
    [anon_sym_noperspective] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1373),
    [anon_sym_typedef] = ACTIONS(1373),
    [anon_sym_extern] = ACTIONS(1373),
    [anon_sym___attribute__] = ACTIONS(1373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1375),
    [anon_sym___declspec] = ACTIONS(1373),
    [anon_sym___cdecl] = ACTIONS(1373),
    [anon_sym___clrcall] = ACTIONS(1373),
    [anon_sym___stdcall] = ACTIONS(1373),
    [anon_sym___fastcall] = ACTIONS(1373),
    [anon_sym___thiscall] = ACTIONS(1373),
    [anon_sym___vectorcall] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1375),
    [anon_sym_signed] = ACTIONS(1373),
    [anon_sym_unsigned] = ACTIONS(1373),
    [anon_sym_long] = ACTIONS(1373),
    [anon_sym_short] = ACTIONS(1373),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_auto] = ACTIONS(1373),
    [anon_sym_register] = ACTIONS(1373),
    [anon_sym_inline] = ACTIONS(1373),
    [anon_sym___inline] = ACTIONS(1373),
    [anon_sym___inline__] = ACTIONS(1373),
    [anon_sym___forceinline] = ACTIONS(1373),
    [anon_sym_thread_local] = ACTIONS(1373),
    [anon_sym___thread] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_constexpr] = ACTIONS(1373),
    [anon_sym_volatile] = ACTIONS(1373),
    [anon_sym_restrict] = ACTIONS(1373),
    [anon_sym___restrict__] = ACTIONS(1373),
    [anon_sym__Atomic] = ACTIONS(1373),
    [anon_sym__Noreturn] = ACTIONS(1373),
    [anon_sym_noreturn] = ACTIONS(1373),
    [anon_sym_alignas] = ACTIONS(1373),
    [anon_sym__Alignas] = ACTIONS(1373),
    [sym_primitive_type] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1373),
    [anon_sym_union] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_goto] = ACTIONS(1373),
    [anon_sym___try] = ACTIONS(1373),
    [anon_sym___leave] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1375),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1373),
    [anon_sym___alignof] = ACTIONS(1373),
    [anon_sym__alignof] = ACTIONS(1373),
    [anon_sym_alignof] = ACTIONS(1373),
    [anon_sym__Alignof] = ACTIONS(1373),
    [anon_sym_offsetof] = ACTIONS(1373),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1373),
    [anon_sym___asm__] = ACTIONS(1373),
    [sym_number_literal] = ACTIONS(1375),
    [anon_sym_L_SQUOTE] = ACTIONS(1375),
    [anon_sym_u_SQUOTE] = ACTIONS(1375),
    [anon_sym_U_SQUOTE] = ACTIONS(1375),
    [anon_sym_u8_SQUOTE] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(1375),
    [anon_sym_L_DQUOTE] = ACTIONS(1375),
    [anon_sym_u_DQUOTE] = ACTIONS(1375),
    [anon_sym_U_DQUOTE] = ACTIONS(1375),
    [anon_sym_u8_DQUOTE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [anon_sym_NULL] = ACTIONS(1373),
    [anon_sym_nullptr] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1373),
    [anon_sym_hitAttributeEXT] = ACTIONS(1373),
    [anon_sym_callableDataEXT] = ACTIONS(1373),
    [anon_sym_callableDataInEXT] = ACTIONS(1373),
    [anon_sym_shaderRecordEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadNV] = ACTIONS(1373),
    [anon_sym_rayPayloadInNV] = ACTIONS(1373),
    [anon_sym_hitAttributeNV] = ACTIONS(1373),
    [anon_sym_callableDataNV] = ACTIONS(1373),
    [anon_sym_callableDataInNV] = ACTIONS(1373),
    [anon_sym_shaderRecordNV] = ACTIONS(1373),
    [anon_sym_layout] = ACTIONS(1373),
  },
  [224] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_subroutine] = ACTIONS(1301),
    [anon_sym_invariant] = ACTIONS(1301),
    [anon_sym_precise] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_out] = ACTIONS(1301),
    [anon_sym_inout] = ACTIONS(1301),
    [anon_sym_uniform] = ACTIONS(1301),
    [anon_sym_shared] = ACTIONS(1301),
    [anon_sym_attribute] = ACTIONS(1301),
    [anon_sym_varying] = ACTIONS(1301),
    [anon_sym_buffer] = ACTIONS(1301),
    [anon_sym_coherent] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_writeonly] = ACTIONS(1301),
    [anon_sym_precision] = ACTIONS(1301),
    [anon_sym_highp] = ACTIONS(1301),
    [anon_sym_mediump] = ACTIONS(1301),
    [anon_sym_lowp] = ACTIONS(1301),
    [anon_sym_centroid] = ACTIONS(1301),
    [anon_sym_sample] = ACTIONS(1301),
    [anon_sym_patch] = ACTIONS(1301),
    [anon_sym_smooth] = ACTIONS(1301),
    [anon_sym_flat] = ACTIONS(1301),
    [anon_sym_noperspective] = ACTIONS(1301),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1301),
    [anon_sym_hitAttributeEXT] = ACTIONS(1301),
    [anon_sym_callableDataEXT] = ACTIONS(1301),
    [anon_sym_callableDataInEXT] = ACTIONS(1301),
    [anon_sym_shaderRecordEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadNV] = ACTIONS(1301),
    [anon_sym_rayPayloadInNV] = ACTIONS(1301),
    [anon_sym_hitAttributeNV] = ACTIONS(1301),
    [anon_sym_callableDataNV] = ACTIONS(1301),
    [anon_sym_callableDataInNV] = ACTIONS(1301),
    [anon_sym_shaderRecordNV] = ACTIONS(1301),
    [anon_sym_layout] = ACTIONS(1301),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_subroutine] = ACTIONS(1305),
    [anon_sym_invariant] = ACTIONS(1305),
    [anon_sym_precise] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_in] = ACTIONS(1305),
    [anon_sym_out] = ACTIONS(1305),
    [anon_sym_inout] = ACTIONS(1305),
    [anon_sym_uniform] = ACTIONS(1305),
    [anon_sym_shared] = ACTIONS(1305),
    [anon_sym_attribute] = ACTIONS(1305),
    [anon_sym_varying] = ACTIONS(1305),
    [anon_sym_buffer] = ACTIONS(1305),
    [anon_sym_coherent] = ACTIONS(1305),
    [anon_sym_readonly] = ACTIONS(1305),
    [anon_sym_writeonly] = ACTIONS(1305),
    [anon_sym_precision] = ACTIONS(1305),
    [anon_sym_highp] = ACTIONS(1305),
    [anon_sym_mediump] = ACTIONS(1305),
    [anon_sym_lowp] = ACTIONS(1305),
    [anon_sym_centroid] = ACTIONS(1305),
    [anon_sym_sample] = ACTIONS(1305),
    [anon_sym_patch] = ACTIONS(1305),
    [anon_sym_smooth] = ACTIONS(1305),
    [anon_sym_flat] = ACTIONS(1305),
    [anon_sym_noperspective] = ACTIONS(1305),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1305),
    [anon_sym_hitAttributeEXT] = ACTIONS(1305),
    [anon_sym_callableDataEXT] = ACTIONS(1305),
    [anon_sym_callableDataInEXT] = ACTIONS(1305),
    [anon_sym_shaderRecordEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadNV] = ACTIONS(1305),
    [anon_sym_rayPayloadInNV] = ACTIONS(1305),
    [anon_sym_hitAttributeNV] = ACTIONS(1305),
    [anon_sym_callableDataNV] = ACTIONS(1305),
    [anon_sym_callableDataInNV] = ACTIONS(1305),
    [anon_sym_shaderRecordNV] = ACTIONS(1305),
    [anon_sym_layout] = ACTIONS(1305),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_subroutine] = ACTIONS(1309),
    [anon_sym_invariant] = ACTIONS(1309),
    [anon_sym_precise] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1309),
    [anon_sym_out] = ACTIONS(1309),
    [anon_sym_inout] = ACTIONS(1309),
    [anon_sym_uniform] = ACTIONS(1309),
    [anon_sym_shared] = ACTIONS(1309),
    [anon_sym_attribute] = ACTIONS(1309),
    [anon_sym_varying] = ACTIONS(1309),
    [anon_sym_buffer] = ACTIONS(1309),
    [anon_sym_coherent] = ACTIONS(1309),
    [anon_sym_readonly] = ACTIONS(1309),
    [anon_sym_writeonly] = ACTIONS(1309),
    [anon_sym_precision] = ACTIONS(1309),
    [anon_sym_highp] = ACTIONS(1309),
    [anon_sym_mediump] = ACTIONS(1309),
    [anon_sym_lowp] = ACTIONS(1309),
    [anon_sym_centroid] = ACTIONS(1309),
    [anon_sym_sample] = ACTIONS(1309),
    [anon_sym_patch] = ACTIONS(1309),
    [anon_sym_smooth] = ACTIONS(1309),
    [anon_sym_flat] = ACTIONS(1309),
    [anon_sym_noperspective] = ACTIONS(1309),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_RBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_else] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1309),
    [anon_sym_hitAttributeEXT] = ACTIONS(1309),
    [anon_sym_callableDataEXT] = ACTIONS(1309),
    [anon_sym_callableDataInEXT] = ACTIONS(1309),
    [anon_sym_shaderRecordEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadNV] = ACTIONS(1309),
    [anon_sym_rayPayloadInNV] = ACTIONS(1309),
    [anon_sym_hitAttributeNV] = ACTIONS(1309),
    [anon_sym_callableDataNV] = ACTIONS(1309),
    [anon_sym_callableDataInNV] = ACTIONS(1309),
    [anon_sym_shaderRecordNV] = ACTIONS(1309),
    [anon_sym_layout] = ACTIONS(1309),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_subroutine] = ACTIONS(1313),
    [anon_sym_invariant] = ACTIONS(1313),
    [anon_sym_precise] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_out] = ACTIONS(1313),
    [anon_sym_inout] = ACTIONS(1313),
    [anon_sym_uniform] = ACTIONS(1313),
    [anon_sym_shared] = ACTIONS(1313),
    [anon_sym_attribute] = ACTIONS(1313),
    [anon_sym_varying] = ACTIONS(1313),
    [anon_sym_buffer] = ACTIONS(1313),
    [anon_sym_coherent] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1313),
    [anon_sym_writeonly] = ACTIONS(1313),
    [anon_sym_precision] = ACTIONS(1313),
    [anon_sym_highp] = ACTIONS(1313),
    [anon_sym_mediump] = ACTIONS(1313),
    [anon_sym_lowp] = ACTIONS(1313),
    [anon_sym_centroid] = ACTIONS(1313),
    [anon_sym_sample] = ACTIONS(1313),
    [anon_sym_patch] = ACTIONS(1313),
    [anon_sym_smooth] = ACTIONS(1313),
    [anon_sym_flat] = ACTIONS(1313),
    [anon_sym_noperspective] = ACTIONS(1313),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1313),
    [anon_sym_hitAttributeEXT] = ACTIONS(1313),
    [anon_sym_callableDataEXT] = ACTIONS(1313),
    [anon_sym_callableDataInEXT] = ACTIONS(1313),
    [anon_sym_shaderRecordEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadNV] = ACTIONS(1313),
    [anon_sym_rayPayloadInNV] = ACTIONS(1313),
    [anon_sym_hitAttributeNV] = ACTIONS(1313),
    [anon_sym_callableDataNV] = ACTIONS(1313),
    [anon_sym_callableDataInNV] = ACTIONS(1313),
    [anon_sym_shaderRecordNV] = ACTIONS(1313),
    [anon_sym_layout] = ACTIONS(1313),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_subroutine] = ACTIONS(1321),
    [anon_sym_invariant] = ACTIONS(1321),
    [anon_sym_precise] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_in] = ACTIONS(1321),
    [anon_sym_out] = ACTIONS(1321),
    [anon_sym_inout] = ACTIONS(1321),
    [anon_sym_uniform] = ACTIONS(1321),
    [anon_sym_shared] = ACTIONS(1321),
    [anon_sym_attribute] = ACTIONS(1321),
    [anon_sym_varying] = ACTIONS(1321),
    [anon_sym_buffer] = ACTIONS(1321),
    [anon_sym_coherent] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_writeonly] = ACTIONS(1321),
    [anon_sym_precision] = ACTIONS(1321),
    [anon_sym_highp] = ACTIONS(1321),
    [anon_sym_mediump] = ACTIONS(1321),
    [anon_sym_lowp] = ACTIONS(1321),
    [anon_sym_centroid] = ACTIONS(1321),
    [anon_sym_sample] = ACTIONS(1321),
    [anon_sym_patch] = ACTIONS(1321),
    [anon_sym_smooth] = ACTIONS(1321),
    [anon_sym_flat] = ACTIONS(1321),
    [anon_sym_noperspective] = ACTIONS(1321),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1321),
    [anon_sym_hitAttributeEXT] = ACTIONS(1321),
    [anon_sym_callableDataEXT] = ACTIONS(1321),
    [anon_sym_callableDataInEXT] = ACTIONS(1321),
    [anon_sym_shaderRecordEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadNV] = ACTIONS(1321),
    [anon_sym_rayPayloadInNV] = ACTIONS(1321),
    [anon_sym_hitAttributeNV] = ACTIONS(1321),
    [anon_sym_callableDataNV] = ACTIONS(1321),
    [anon_sym_callableDataInNV] = ACTIONS(1321),
    [anon_sym_shaderRecordNV] = ACTIONS(1321),
    [anon_sym_layout] = ACTIONS(1321),
  },
  [229] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [230] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_subroutine] = ACTIONS(1329),
    [anon_sym_invariant] = ACTIONS(1329),
    [anon_sym_precise] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1329),
    [anon_sym_out] = ACTIONS(1329),
    [anon_sym_inout] = ACTIONS(1329),
    [anon_sym_uniform] = ACTIONS(1329),
    [anon_sym_shared] = ACTIONS(1329),
    [anon_sym_attribute] = ACTIONS(1329),
    [anon_sym_varying] = ACTIONS(1329),
    [anon_sym_buffer] = ACTIONS(1329),
    [anon_sym_coherent] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(1329),
    [anon_sym_writeonly] = ACTIONS(1329),
    [anon_sym_precision] = ACTIONS(1329),
    [anon_sym_highp] = ACTIONS(1329),
    [anon_sym_mediump] = ACTIONS(1329),
    [anon_sym_lowp] = ACTIONS(1329),
    [anon_sym_centroid] = ACTIONS(1329),
    [anon_sym_sample] = ACTIONS(1329),
    [anon_sym_patch] = ACTIONS(1329),
    [anon_sym_smooth] = ACTIONS(1329),
    [anon_sym_flat] = ACTIONS(1329),
    [anon_sym_noperspective] = ACTIONS(1329),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_RBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1329),
    [anon_sym_hitAttributeEXT] = ACTIONS(1329),
    [anon_sym_callableDataEXT] = ACTIONS(1329),
    [anon_sym_callableDataInEXT] = ACTIONS(1329),
    [anon_sym_shaderRecordEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadNV] = ACTIONS(1329),
    [anon_sym_rayPayloadInNV] = ACTIONS(1329),
    [anon_sym_hitAttributeNV] = ACTIONS(1329),
    [anon_sym_callableDataNV] = ACTIONS(1329),
    [anon_sym_callableDataInNV] = ACTIONS(1329),
    [anon_sym_shaderRecordNV] = ACTIONS(1329),
    [anon_sym_layout] = ACTIONS(1329),
  },
  [231] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_subroutine] = ACTIONS(1333),
    [anon_sym_invariant] = ACTIONS(1333),
    [anon_sym_precise] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_out] = ACTIONS(1333),
    [anon_sym_inout] = ACTIONS(1333),
    [anon_sym_uniform] = ACTIONS(1333),
    [anon_sym_shared] = ACTIONS(1333),
    [anon_sym_attribute] = ACTIONS(1333),
    [anon_sym_varying] = ACTIONS(1333),
    [anon_sym_buffer] = ACTIONS(1333),
    [anon_sym_coherent] = ACTIONS(1333),
    [anon_sym_readonly] = ACTIONS(1333),
    [anon_sym_writeonly] = ACTIONS(1333),
    [anon_sym_precision] = ACTIONS(1333),
    [anon_sym_highp] = ACTIONS(1333),
    [anon_sym_mediump] = ACTIONS(1333),
    [anon_sym_lowp] = ACTIONS(1333),
    [anon_sym_centroid] = ACTIONS(1333),
    [anon_sym_sample] = ACTIONS(1333),
    [anon_sym_patch] = ACTIONS(1333),
    [anon_sym_smooth] = ACTIONS(1333),
    [anon_sym_flat] = ACTIONS(1333),
    [anon_sym_noperspective] = ACTIONS(1333),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_RBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1333),
    [anon_sym_hitAttributeEXT] = ACTIONS(1333),
    [anon_sym_callableDataEXT] = ACTIONS(1333),
    [anon_sym_callableDataInEXT] = ACTIONS(1333),
    [anon_sym_shaderRecordEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadNV] = ACTIONS(1333),
    [anon_sym_rayPayloadInNV] = ACTIONS(1333),
    [anon_sym_hitAttributeNV] = ACTIONS(1333),
    [anon_sym_callableDataNV] = ACTIONS(1333),
    [anon_sym_callableDataInNV] = ACTIONS(1333),
    [anon_sym_shaderRecordNV] = ACTIONS(1333),
    [anon_sym_layout] = ACTIONS(1333),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1273),
    [aux_sym_preproc_include_token1] = ACTIONS(1273),
    [aux_sym_preproc_def_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token1] = ACTIONS(1273),
    [aux_sym_preproc_if_token2] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1273),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1273),
    [sym_preproc_directive] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_subroutine] = ACTIONS(1273),
    [anon_sym_invariant] = ACTIONS(1273),
    [anon_sym_precise] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_out] = ACTIONS(1273),
    [anon_sym_inout] = ACTIONS(1273),
    [anon_sym_uniform] = ACTIONS(1273),
    [anon_sym_shared] = ACTIONS(1273),
    [anon_sym_attribute] = ACTIONS(1273),
    [anon_sym_varying] = ACTIONS(1273),
    [anon_sym_buffer] = ACTIONS(1273),
    [anon_sym_coherent] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_writeonly] = ACTIONS(1273),
    [anon_sym_precision] = ACTIONS(1273),
    [anon_sym_highp] = ACTIONS(1273),
    [anon_sym_mediump] = ACTIONS(1273),
    [anon_sym_lowp] = ACTIONS(1273),
    [anon_sym_centroid] = ACTIONS(1273),
    [anon_sym_sample] = ACTIONS(1273),
    [anon_sym_patch] = ACTIONS(1273),
    [anon_sym_smooth] = ACTIONS(1273),
    [anon_sym_flat] = ACTIONS(1273),
    [anon_sym_noperspective] = ACTIONS(1273),
    [anon_sym___extension__] = ACTIONS(1273),
    [anon_sym_typedef] = ACTIONS(1273),
    [anon_sym_extern] = ACTIONS(1273),
    [anon_sym___attribute__] = ACTIONS(1273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1275),
    [anon_sym___declspec] = ACTIONS(1273),
    [anon_sym___cdecl] = ACTIONS(1273),
    [anon_sym___clrcall] = ACTIONS(1273),
    [anon_sym___stdcall] = ACTIONS(1273),
    [anon_sym___fastcall] = ACTIONS(1273),
    [anon_sym___thiscall] = ACTIONS(1273),
    [anon_sym___vectorcall] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1273),
    [anon_sym_unsigned] = ACTIONS(1273),
    [anon_sym_long] = ACTIONS(1273),
    [anon_sym_short] = ACTIONS(1273),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_auto] = ACTIONS(1273),
    [anon_sym_register] = ACTIONS(1273),
    [anon_sym_inline] = ACTIONS(1273),
    [anon_sym___inline] = ACTIONS(1273),
    [anon_sym___inline__] = ACTIONS(1273),
    [anon_sym___forceinline] = ACTIONS(1273),
    [anon_sym_thread_local] = ACTIONS(1273),
    [anon_sym___thread] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_constexpr] = ACTIONS(1273),
    [anon_sym_volatile] = ACTIONS(1273),
    [anon_sym_restrict] = ACTIONS(1273),
    [anon_sym___restrict__] = ACTIONS(1273),
    [anon_sym__Atomic] = ACTIONS(1273),
    [anon_sym__Noreturn] = ACTIONS(1273),
    [anon_sym_noreturn] = ACTIONS(1273),
    [anon_sym_alignas] = ACTIONS(1273),
    [anon_sym__Alignas] = ACTIONS(1273),
    [sym_primitive_type] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1273),
    [anon_sym_union] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_goto] = ACTIONS(1273),
    [anon_sym___try] = ACTIONS(1273),
    [anon_sym___leave] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1273),
    [anon_sym___alignof__] = ACTIONS(1273),
    [anon_sym___alignof] = ACTIONS(1273),
    [anon_sym__alignof] = ACTIONS(1273),
    [anon_sym_alignof] = ACTIONS(1273),
    [anon_sym__Alignof] = ACTIONS(1273),
    [anon_sym_offsetof] = ACTIONS(1273),
    [anon_sym__Generic] = ACTIONS(1273),
    [anon_sym_asm] = ACTIONS(1273),
    [anon_sym___asm__] = ACTIONS(1273),
    [sym_number_literal] = ACTIONS(1275),
    [anon_sym_L_SQUOTE] = ACTIONS(1275),
    [anon_sym_u_SQUOTE] = ACTIONS(1275),
    [anon_sym_U_SQUOTE] = ACTIONS(1275),
    [anon_sym_u8_SQUOTE] = ACTIONS(1275),
    [anon_sym_SQUOTE] = ACTIONS(1275),
    [anon_sym_L_DQUOTE] = ACTIONS(1275),
    [anon_sym_u_DQUOTE] = ACTIONS(1275),
    [anon_sym_U_DQUOTE] = ACTIONS(1275),
    [anon_sym_u8_DQUOTE] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [anon_sym_NULL] = ACTIONS(1273),
    [anon_sym_nullptr] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1273),
    [anon_sym_hitAttributeEXT] = ACTIONS(1273),
    [anon_sym_callableDataEXT] = ACTIONS(1273),
    [anon_sym_callableDataInEXT] = ACTIONS(1273),
    [anon_sym_shaderRecordEXT] = ACTIONS(1273),
    [anon_sym_rayPayloadNV] = ACTIONS(1273),
    [anon_sym_rayPayloadInNV] = ACTIONS(1273),
    [anon_sym_hitAttributeNV] = ACTIONS(1273),
    [anon_sym_callableDataNV] = ACTIONS(1273),
    [anon_sym_callableDataInNV] = ACTIONS(1273),
    [anon_sym_shaderRecordNV] = ACTIONS(1273),
    [anon_sym_layout] = ACTIONS(1273),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1307),
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_subroutine] = ACTIONS(1305),
    [anon_sym_invariant] = ACTIONS(1305),
    [anon_sym_precise] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_in] = ACTIONS(1305),
    [anon_sym_out] = ACTIONS(1305),
    [anon_sym_inout] = ACTIONS(1305),
    [anon_sym_uniform] = ACTIONS(1305),
    [anon_sym_shared] = ACTIONS(1305),
    [anon_sym_attribute] = ACTIONS(1305),
    [anon_sym_varying] = ACTIONS(1305),
    [anon_sym_buffer] = ACTIONS(1305),
    [anon_sym_coherent] = ACTIONS(1305),
    [anon_sym_readonly] = ACTIONS(1305),
    [anon_sym_writeonly] = ACTIONS(1305),
    [anon_sym_precision] = ACTIONS(1305),
    [anon_sym_highp] = ACTIONS(1305),
    [anon_sym_mediump] = ACTIONS(1305),
    [anon_sym_lowp] = ACTIONS(1305),
    [anon_sym_centroid] = ACTIONS(1305),
    [anon_sym_sample] = ACTIONS(1305),
    [anon_sym_patch] = ACTIONS(1305),
    [anon_sym_smooth] = ACTIONS(1305),
    [anon_sym_flat] = ACTIONS(1305),
    [anon_sym_noperspective] = ACTIONS(1305),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1305),
    [anon_sym_hitAttributeEXT] = ACTIONS(1305),
    [anon_sym_callableDataEXT] = ACTIONS(1305),
    [anon_sym_callableDataInEXT] = ACTIONS(1305),
    [anon_sym_shaderRecordEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadNV] = ACTIONS(1305),
    [anon_sym_rayPayloadInNV] = ACTIONS(1305),
    [anon_sym_hitAttributeNV] = ACTIONS(1305),
    [anon_sym_callableDataNV] = ACTIONS(1305),
    [anon_sym_callableDataInNV] = ACTIONS(1305),
    [anon_sym_shaderRecordNV] = ACTIONS(1305),
    [anon_sym_layout] = ACTIONS(1305),
  },
  [235] = {
    [sym_identifier] = ACTIONS(1277),
    [aux_sym_preproc_include_token1] = ACTIONS(1277),
    [aux_sym_preproc_def_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token1] = ACTIONS(1277),
    [aux_sym_preproc_if_token2] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1277),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1277),
    [sym_preproc_directive] = ACTIONS(1277),
    [anon_sym_LPAREN2] = ACTIONS(1279),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_subroutine] = ACTIONS(1277),
    [anon_sym_invariant] = ACTIONS(1277),
    [anon_sym_precise] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_in] = ACTIONS(1277),
    [anon_sym_out] = ACTIONS(1277),
    [anon_sym_inout] = ACTIONS(1277),
    [anon_sym_uniform] = ACTIONS(1277),
    [anon_sym_shared] = ACTIONS(1277),
    [anon_sym_attribute] = ACTIONS(1277),
    [anon_sym_varying] = ACTIONS(1277),
    [anon_sym_buffer] = ACTIONS(1277),
    [anon_sym_coherent] = ACTIONS(1277),
    [anon_sym_readonly] = ACTIONS(1277),
    [anon_sym_writeonly] = ACTIONS(1277),
    [anon_sym_precision] = ACTIONS(1277),
    [anon_sym_highp] = ACTIONS(1277),
    [anon_sym_mediump] = ACTIONS(1277),
    [anon_sym_lowp] = ACTIONS(1277),
    [anon_sym_centroid] = ACTIONS(1277),
    [anon_sym_sample] = ACTIONS(1277),
    [anon_sym_patch] = ACTIONS(1277),
    [anon_sym_smooth] = ACTIONS(1277),
    [anon_sym_flat] = ACTIONS(1277),
    [anon_sym_noperspective] = ACTIONS(1277),
    [anon_sym___extension__] = ACTIONS(1277),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_extern] = ACTIONS(1277),
    [anon_sym___attribute__] = ACTIONS(1277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1279),
    [anon_sym___declspec] = ACTIONS(1277),
    [anon_sym___cdecl] = ACTIONS(1277),
    [anon_sym___clrcall] = ACTIONS(1277),
    [anon_sym___stdcall] = ACTIONS(1277),
    [anon_sym___fastcall] = ACTIONS(1277),
    [anon_sym___thiscall] = ACTIONS(1277),
    [anon_sym___vectorcall] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_signed] = ACTIONS(1277),
    [anon_sym_unsigned] = ACTIONS(1277),
    [anon_sym_long] = ACTIONS(1277),
    [anon_sym_short] = ACTIONS(1277),
    [anon_sym_static] = ACTIONS(1277),
    [anon_sym_auto] = ACTIONS(1277),
    [anon_sym_register] = ACTIONS(1277),
    [anon_sym_inline] = ACTIONS(1277),
    [anon_sym___inline] = ACTIONS(1277),
    [anon_sym___inline__] = ACTIONS(1277),
    [anon_sym___forceinline] = ACTIONS(1277),
    [anon_sym_thread_local] = ACTIONS(1277),
    [anon_sym___thread] = ACTIONS(1277),
    [anon_sym_const] = ACTIONS(1277),
    [anon_sym_constexpr] = ACTIONS(1277),
    [anon_sym_volatile] = ACTIONS(1277),
    [anon_sym_restrict] = ACTIONS(1277),
    [anon_sym___restrict__] = ACTIONS(1277),
    [anon_sym__Atomic] = ACTIONS(1277),
    [anon_sym__Noreturn] = ACTIONS(1277),
    [anon_sym_noreturn] = ACTIONS(1277),
    [anon_sym_alignas] = ACTIONS(1277),
    [anon_sym__Alignas] = ACTIONS(1277),
    [sym_primitive_type] = ACTIONS(1277),
    [anon_sym_enum] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1277),
    [anon_sym_union] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1277),
    [anon_sym_case] = ACTIONS(1277),
    [anon_sym_default] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_do] = ACTIONS(1277),
    [anon_sym_for] = ACTIONS(1277),
    [anon_sym_return] = ACTIONS(1277),
    [anon_sym_break] = ACTIONS(1277),
    [anon_sym_continue] = ACTIONS(1277),
    [anon_sym_goto] = ACTIONS(1277),
    [anon_sym___try] = ACTIONS(1277),
    [anon_sym___leave] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1279),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym___alignof__] = ACTIONS(1277),
    [anon_sym___alignof] = ACTIONS(1277),
    [anon_sym__alignof] = ACTIONS(1277),
    [anon_sym_alignof] = ACTIONS(1277),
    [anon_sym__Alignof] = ACTIONS(1277),
    [anon_sym_offsetof] = ACTIONS(1277),
    [anon_sym__Generic] = ACTIONS(1277),
    [anon_sym_asm] = ACTIONS(1277),
    [anon_sym___asm__] = ACTIONS(1277),
    [sym_number_literal] = ACTIONS(1279),
    [anon_sym_L_SQUOTE] = ACTIONS(1279),
    [anon_sym_u_SQUOTE] = ACTIONS(1279),
    [anon_sym_U_SQUOTE] = ACTIONS(1279),
    [anon_sym_u8_SQUOTE] = ACTIONS(1279),
    [anon_sym_SQUOTE] = ACTIONS(1279),
    [anon_sym_L_DQUOTE] = ACTIONS(1279),
    [anon_sym_u_DQUOTE] = ACTIONS(1279),
    [anon_sym_U_DQUOTE] = ACTIONS(1279),
    [anon_sym_u8_DQUOTE] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1279),
    [sym_true] = ACTIONS(1277),
    [sym_false] = ACTIONS(1277),
    [anon_sym_NULL] = ACTIONS(1277),
    [anon_sym_nullptr] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1277),
    [anon_sym_hitAttributeEXT] = ACTIONS(1277),
    [anon_sym_callableDataEXT] = ACTIONS(1277),
    [anon_sym_callableDataInEXT] = ACTIONS(1277),
    [anon_sym_shaderRecordEXT] = ACTIONS(1277),
    [anon_sym_rayPayloadNV] = ACTIONS(1277),
    [anon_sym_rayPayloadInNV] = ACTIONS(1277),
    [anon_sym_hitAttributeNV] = ACTIONS(1277),
    [anon_sym_callableDataNV] = ACTIONS(1277),
    [anon_sym_callableDataInNV] = ACTIONS(1277),
    [anon_sym_shaderRecordNV] = ACTIONS(1277),
    [anon_sym_layout] = ACTIONS(1277),
  },
  [236] = {
    [sym_identifier] = ACTIONS(1285),
    [aux_sym_preproc_include_token1] = ACTIONS(1285),
    [aux_sym_preproc_def_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token1] = ACTIONS(1285),
    [aux_sym_preproc_if_token2] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1285),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1285),
    [sym_preproc_directive] = ACTIONS(1285),
    [anon_sym_LPAREN2] = ACTIONS(1287),
    [anon_sym_BANG] = ACTIONS(1287),
    [anon_sym_TILDE] = ACTIONS(1287),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_subroutine] = ACTIONS(1285),
    [anon_sym_invariant] = ACTIONS(1285),
    [anon_sym_precise] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_out] = ACTIONS(1285),
    [anon_sym_inout] = ACTIONS(1285),
    [anon_sym_uniform] = ACTIONS(1285),
    [anon_sym_shared] = ACTIONS(1285),
    [anon_sym_attribute] = ACTIONS(1285),
    [anon_sym_varying] = ACTIONS(1285),
    [anon_sym_buffer] = ACTIONS(1285),
    [anon_sym_coherent] = ACTIONS(1285),
    [anon_sym_readonly] = ACTIONS(1285),
    [anon_sym_writeonly] = ACTIONS(1285),
    [anon_sym_precision] = ACTIONS(1285),
    [anon_sym_highp] = ACTIONS(1285),
    [anon_sym_mediump] = ACTIONS(1285),
    [anon_sym_lowp] = ACTIONS(1285),
    [anon_sym_centroid] = ACTIONS(1285),
    [anon_sym_sample] = ACTIONS(1285),
    [anon_sym_patch] = ACTIONS(1285),
    [anon_sym_smooth] = ACTIONS(1285),
    [anon_sym_flat] = ACTIONS(1285),
    [anon_sym_noperspective] = ACTIONS(1285),
    [anon_sym___extension__] = ACTIONS(1285),
    [anon_sym_typedef] = ACTIONS(1285),
    [anon_sym_extern] = ACTIONS(1285),
    [anon_sym___attribute__] = ACTIONS(1285),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1287),
    [anon_sym___declspec] = ACTIONS(1285),
    [anon_sym___cdecl] = ACTIONS(1285),
    [anon_sym___clrcall] = ACTIONS(1285),
    [anon_sym___stdcall] = ACTIONS(1285),
    [anon_sym___fastcall] = ACTIONS(1285),
    [anon_sym___thiscall] = ACTIONS(1285),
    [anon_sym___vectorcall] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1287),
    [anon_sym_signed] = ACTIONS(1285),
    [anon_sym_unsigned] = ACTIONS(1285),
    [anon_sym_long] = ACTIONS(1285),
    [anon_sym_short] = ACTIONS(1285),
    [anon_sym_static] = ACTIONS(1285),
    [anon_sym_auto] = ACTIONS(1285),
    [anon_sym_register] = ACTIONS(1285),
    [anon_sym_inline] = ACTIONS(1285),
    [anon_sym___inline] = ACTIONS(1285),
    [anon_sym___inline__] = ACTIONS(1285),
    [anon_sym___forceinline] = ACTIONS(1285),
    [anon_sym_thread_local] = ACTIONS(1285),
    [anon_sym___thread] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [anon_sym_constexpr] = ACTIONS(1285),
    [anon_sym_volatile] = ACTIONS(1285),
    [anon_sym_restrict] = ACTIONS(1285),
    [anon_sym___restrict__] = ACTIONS(1285),
    [anon_sym__Atomic] = ACTIONS(1285),
    [anon_sym__Noreturn] = ACTIONS(1285),
    [anon_sym_noreturn] = ACTIONS(1285),
    [anon_sym_alignas] = ACTIONS(1285),
    [anon_sym__Alignas] = ACTIONS(1285),
    [sym_primitive_type] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1285),
    [anon_sym_union] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_goto] = ACTIONS(1285),
    [anon_sym___try] = ACTIONS(1285),
    [anon_sym___leave] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1287),
    [anon_sym_PLUS_PLUS] = ACTIONS(1287),
    [anon_sym_sizeof] = ACTIONS(1285),
    [anon_sym___alignof__] = ACTIONS(1285),
    [anon_sym___alignof] = ACTIONS(1285),
    [anon_sym__alignof] = ACTIONS(1285),
    [anon_sym_alignof] = ACTIONS(1285),
    [anon_sym__Alignof] = ACTIONS(1285),
    [anon_sym_offsetof] = ACTIONS(1285),
    [anon_sym__Generic] = ACTIONS(1285),
    [anon_sym_asm] = ACTIONS(1285),
    [anon_sym___asm__] = ACTIONS(1285),
    [sym_number_literal] = ACTIONS(1287),
    [anon_sym_L_SQUOTE] = ACTIONS(1287),
    [anon_sym_u_SQUOTE] = ACTIONS(1287),
    [anon_sym_U_SQUOTE] = ACTIONS(1287),
    [anon_sym_u8_SQUOTE] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_L_DQUOTE] = ACTIONS(1287),
    [anon_sym_u_DQUOTE] = ACTIONS(1287),
    [anon_sym_U_DQUOTE] = ACTIONS(1287),
    [anon_sym_u8_DQUOTE] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1287),
    [sym_true] = ACTIONS(1285),
    [sym_false] = ACTIONS(1285),
    [anon_sym_NULL] = ACTIONS(1285),
    [anon_sym_nullptr] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1285),
    [anon_sym_hitAttributeEXT] = ACTIONS(1285),
    [anon_sym_callableDataEXT] = ACTIONS(1285),
    [anon_sym_callableDataInEXT] = ACTIONS(1285),
    [anon_sym_shaderRecordEXT] = ACTIONS(1285),
    [anon_sym_rayPayloadNV] = ACTIONS(1285),
    [anon_sym_rayPayloadInNV] = ACTIONS(1285),
    [anon_sym_hitAttributeNV] = ACTIONS(1285),
    [anon_sym_callableDataNV] = ACTIONS(1285),
    [anon_sym_callableDataInNV] = ACTIONS(1285),
    [anon_sym_shaderRecordNV] = ACTIONS(1285),
    [anon_sym_layout] = ACTIONS(1285),
  },
  [237] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(1319),
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [239] = {
    [sym_identifier] = ACTIONS(1355),
    [aux_sym_preproc_include_token1] = ACTIONS(1355),
    [aux_sym_preproc_def_token1] = ACTIONS(1355),
    [aux_sym_preproc_if_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1355),
    [sym_preproc_directive] = ACTIONS(1355),
    [anon_sym_LPAREN2] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_subroutine] = ACTIONS(1355),
    [anon_sym_invariant] = ACTIONS(1355),
    [anon_sym_precise] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_uniform] = ACTIONS(1355),
    [anon_sym_shared] = ACTIONS(1355),
    [anon_sym_attribute] = ACTIONS(1355),
    [anon_sym_varying] = ACTIONS(1355),
    [anon_sym_buffer] = ACTIONS(1355),
    [anon_sym_coherent] = ACTIONS(1355),
    [anon_sym_readonly] = ACTIONS(1355),
    [anon_sym_writeonly] = ACTIONS(1355),
    [anon_sym_precision] = ACTIONS(1355),
    [anon_sym_highp] = ACTIONS(1355),
    [anon_sym_mediump] = ACTIONS(1355),
    [anon_sym_lowp] = ACTIONS(1355),
    [anon_sym_centroid] = ACTIONS(1355),
    [anon_sym_sample] = ACTIONS(1355),
    [anon_sym_patch] = ACTIONS(1355),
    [anon_sym_smooth] = ACTIONS(1355),
    [anon_sym_flat] = ACTIONS(1355),
    [anon_sym_noperspective] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1355),
    [anon_sym_typedef] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym___attribute__] = ACTIONS(1355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1353),
    [anon_sym___declspec] = ACTIONS(1355),
    [anon_sym___cdecl] = ACTIONS(1355),
    [anon_sym___clrcall] = ACTIONS(1355),
    [anon_sym___stdcall] = ACTIONS(1355),
    [anon_sym___fastcall] = ACTIONS(1355),
    [anon_sym___thiscall] = ACTIONS(1355),
    [anon_sym___vectorcall] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_signed] = ACTIONS(1355),
    [anon_sym_unsigned] = ACTIONS(1355),
    [anon_sym_long] = ACTIONS(1355),
    [anon_sym_short] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_auto] = ACTIONS(1355),
    [anon_sym_register] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym___inline] = ACTIONS(1355),
    [anon_sym___inline__] = ACTIONS(1355),
    [anon_sym___forceinline] = ACTIONS(1355),
    [anon_sym_thread_local] = ACTIONS(1355),
    [anon_sym___thread] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_constexpr] = ACTIONS(1355),
    [anon_sym_volatile] = ACTIONS(1355),
    [anon_sym_restrict] = ACTIONS(1355),
    [anon_sym___restrict__] = ACTIONS(1355),
    [anon_sym__Atomic] = ACTIONS(1355),
    [anon_sym__Noreturn] = ACTIONS(1355),
    [anon_sym_noreturn] = ACTIONS(1355),
    [anon_sym_alignas] = ACTIONS(1355),
    [anon_sym__Alignas] = ACTIONS(1355),
    [sym_primitive_type] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_goto] = ACTIONS(1355),
    [anon_sym___try] = ACTIONS(1355),
    [anon_sym___leave] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_sizeof] = ACTIONS(1355),
    [anon_sym___alignof__] = ACTIONS(1355),
    [anon_sym___alignof] = ACTIONS(1355),
    [anon_sym__alignof] = ACTIONS(1355),
    [anon_sym_alignof] = ACTIONS(1355),
    [anon_sym__Alignof] = ACTIONS(1355),
    [anon_sym_offsetof] = ACTIONS(1355),
    [anon_sym__Generic] = ACTIONS(1355),
    [anon_sym_asm] = ACTIONS(1355),
    [anon_sym___asm__] = ACTIONS(1355),
    [sym_number_literal] = ACTIONS(1353),
    [anon_sym_L_SQUOTE] = ACTIONS(1353),
    [anon_sym_u_SQUOTE] = ACTIONS(1353),
    [anon_sym_U_SQUOTE] = ACTIONS(1353),
    [anon_sym_u8_SQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_L_DQUOTE] = ACTIONS(1353),
    [anon_sym_u_DQUOTE] = ACTIONS(1353),
    [anon_sym_U_DQUOTE] = ACTIONS(1353),
    [anon_sym_u8_DQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1355),
    [anon_sym_hitAttributeEXT] = ACTIONS(1355),
    [anon_sym_callableDataEXT] = ACTIONS(1355),
    [anon_sym_callableDataInEXT] = ACTIONS(1355),
    [anon_sym_shaderRecordEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadNV] = ACTIONS(1355),
    [anon_sym_rayPayloadInNV] = ACTIONS(1355),
    [anon_sym_hitAttributeNV] = ACTIONS(1355),
    [anon_sym_callableDataNV] = ACTIONS(1355),
    [anon_sym_callableDataInNV] = ACTIONS(1355),
    [anon_sym_shaderRecordNV] = ACTIONS(1355),
    [anon_sym_layout] = ACTIONS(1355),
  },
  [240] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_subroutine] = ACTIONS(1357),
    [anon_sym_invariant] = ACTIONS(1357),
    [anon_sym_precise] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1357),
    [anon_sym_out] = ACTIONS(1357),
    [anon_sym_inout] = ACTIONS(1357),
    [anon_sym_uniform] = ACTIONS(1357),
    [anon_sym_shared] = ACTIONS(1357),
    [anon_sym_attribute] = ACTIONS(1357),
    [anon_sym_varying] = ACTIONS(1357),
    [anon_sym_buffer] = ACTIONS(1357),
    [anon_sym_coherent] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_writeonly] = ACTIONS(1357),
    [anon_sym_precision] = ACTIONS(1357),
    [anon_sym_highp] = ACTIONS(1357),
    [anon_sym_mediump] = ACTIONS(1357),
    [anon_sym_lowp] = ACTIONS(1357),
    [anon_sym_centroid] = ACTIONS(1357),
    [anon_sym_sample] = ACTIONS(1357),
    [anon_sym_patch] = ACTIONS(1357),
    [anon_sym_smooth] = ACTIONS(1357),
    [anon_sym_flat] = ACTIONS(1357),
    [anon_sym_noperspective] = ACTIONS(1357),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_RBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1357),
    [anon_sym_hitAttributeEXT] = ACTIONS(1357),
    [anon_sym_callableDataEXT] = ACTIONS(1357),
    [anon_sym_callableDataInEXT] = ACTIONS(1357),
    [anon_sym_shaderRecordEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadNV] = ACTIONS(1357),
    [anon_sym_rayPayloadInNV] = ACTIONS(1357),
    [anon_sym_hitAttributeNV] = ACTIONS(1357),
    [anon_sym_callableDataNV] = ACTIONS(1357),
    [anon_sym_callableDataInNV] = ACTIONS(1357),
    [anon_sym_shaderRecordNV] = ACTIONS(1357),
    [anon_sym_layout] = ACTIONS(1357),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_RBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1311),
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_subroutine] = ACTIONS(1309),
    [anon_sym_invariant] = ACTIONS(1309),
    [anon_sym_precise] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1309),
    [anon_sym_out] = ACTIONS(1309),
    [anon_sym_inout] = ACTIONS(1309),
    [anon_sym_uniform] = ACTIONS(1309),
    [anon_sym_shared] = ACTIONS(1309),
    [anon_sym_attribute] = ACTIONS(1309),
    [anon_sym_varying] = ACTIONS(1309),
    [anon_sym_buffer] = ACTIONS(1309),
    [anon_sym_coherent] = ACTIONS(1309),
    [anon_sym_readonly] = ACTIONS(1309),
    [anon_sym_writeonly] = ACTIONS(1309),
    [anon_sym_precision] = ACTIONS(1309),
    [anon_sym_highp] = ACTIONS(1309),
    [anon_sym_mediump] = ACTIONS(1309),
    [anon_sym_lowp] = ACTIONS(1309),
    [anon_sym_centroid] = ACTIONS(1309),
    [anon_sym_sample] = ACTIONS(1309),
    [anon_sym_patch] = ACTIONS(1309),
    [anon_sym_smooth] = ACTIONS(1309),
    [anon_sym_flat] = ACTIONS(1309),
    [anon_sym_noperspective] = ACTIONS(1309),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_else] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1309),
    [anon_sym_hitAttributeEXT] = ACTIONS(1309),
    [anon_sym_callableDataEXT] = ACTIONS(1309),
    [anon_sym_callableDataInEXT] = ACTIONS(1309),
    [anon_sym_shaderRecordEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadNV] = ACTIONS(1309),
    [anon_sym_rayPayloadInNV] = ACTIONS(1309),
    [anon_sym_hitAttributeNV] = ACTIONS(1309),
    [anon_sym_callableDataNV] = ACTIONS(1309),
    [anon_sym_callableDataInNV] = ACTIONS(1309),
    [anon_sym_shaderRecordNV] = ACTIONS(1309),
    [anon_sym_layout] = ACTIONS(1309),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_subroutine] = ACTIONS(1313),
    [anon_sym_invariant] = ACTIONS(1313),
    [anon_sym_precise] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_out] = ACTIONS(1313),
    [anon_sym_inout] = ACTIONS(1313),
    [anon_sym_uniform] = ACTIONS(1313),
    [anon_sym_shared] = ACTIONS(1313),
    [anon_sym_attribute] = ACTIONS(1313),
    [anon_sym_varying] = ACTIONS(1313),
    [anon_sym_buffer] = ACTIONS(1313),
    [anon_sym_coherent] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1313),
    [anon_sym_writeonly] = ACTIONS(1313),
    [anon_sym_precision] = ACTIONS(1313),
    [anon_sym_highp] = ACTIONS(1313),
    [anon_sym_mediump] = ACTIONS(1313),
    [anon_sym_lowp] = ACTIONS(1313),
    [anon_sym_centroid] = ACTIONS(1313),
    [anon_sym_sample] = ACTIONS(1313),
    [anon_sym_patch] = ACTIONS(1313),
    [anon_sym_smooth] = ACTIONS(1313),
    [anon_sym_flat] = ACTIONS(1313),
    [anon_sym_noperspective] = ACTIONS(1313),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1313),
    [anon_sym_hitAttributeEXT] = ACTIONS(1313),
    [anon_sym_callableDataEXT] = ACTIONS(1313),
    [anon_sym_callableDataInEXT] = ACTIONS(1313),
    [anon_sym_shaderRecordEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadNV] = ACTIONS(1313),
    [anon_sym_rayPayloadInNV] = ACTIONS(1313),
    [anon_sym_hitAttributeNV] = ACTIONS(1313),
    [anon_sym_callableDataNV] = ACTIONS(1313),
    [anon_sym_callableDataInNV] = ACTIONS(1313),
    [anon_sym_shaderRecordNV] = ACTIONS(1313),
    [anon_sym_layout] = ACTIONS(1313),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1365),
    [aux_sym_preproc_include_token1] = ACTIONS(1365),
    [aux_sym_preproc_def_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token1] = ACTIONS(1365),
    [aux_sym_preproc_if_token2] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1365),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1365),
    [sym_preproc_directive] = ACTIONS(1365),
    [anon_sym_LPAREN2] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_TILDE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_subroutine] = ACTIONS(1365),
    [anon_sym_invariant] = ACTIONS(1365),
    [anon_sym_precise] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1367),
    [anon_sym_in] = ACTIONS(1365),
    [anon_sym_out] = ACTIONS(1365),
    [anon_sym_inout] = ACTIONS(1365),
    [anon_sym_uniform] = ACTIONS(1365),
    [anon_sym_shared] = ACTIONS(1365),
    [anon_sym_attribute] = ACTIONS(1365),
    [anon_sym_varying] = ACTIONS(1365),
    [anon_sym_buffer] = ACTIONS(1365),
    [anon_sym_coherent] = ACTIONS(1365),
    [anon_sym_readonly] = ACTIONS(1365),
    [anon_sym_writeonly] = ACTIONS(1365),
    [anon_sym_precision] = ACTIONS(1365),
    [anon_sym_highp] = ACTIONS(1365),
    [anon_sym_mediump] = ACTIONS(1365),
    [anon_sym_lowp] = ACTIONS(1365),
    [anon_sym_centroid] = ACTIONS(1365),
    [anon_sym_sample] = ACTIONS(1365),
    [anon_sym_patch] = ACTIONS(1365),
    [anon_sym_smooth] = ACTIONS(1365),
    [anon_sym_flat] = ACTIONS(1365),
    [anon_sym_noperspective] = ACTIONS(1365),
    [anon_sym___extension__] = ACTIONS(1365),
    [anon_sym_typedef] = ACTIONS(1365),
    [anon_sym_extern] = ACTIONS(1365),
    [anon_sym___attribute__] = ACTIONS(1365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1365),
    [anon_sym___cdecl] = ACTIONS(1365),
    [anon_sym___clrcall] = ACTIONS(1365),
    [anon_sym___stdcall] = ACTIONS(1365),
    [anon_sym___fastcall] = ACTIONS(1365),
    [anon_sym___thiscall] = ACTIONS(1365),
    [anon_sym___vectorcall] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1367),
    [anon_sym_signed] = ACTIONS(1365),
    [anon_sym_unsigned] = ACTIONS(1365),
    [anon_sym_long] = ACTIONS(1365),
    [anon_sym_short] = ACTIONS(1365),
    [anon_sym_static] = ACTIONS(1365),
    [anon_sym_auto] = ACTIONS(1365),
    [anon_sym_register] = ACTIONS(1365),
    [anon_sym_inline] = ACTIONS(1365),
    [anon_sym___inline] = ACTIONS(1365),
    [anon_sym___inline__] = ACTIONS(1365),
    [anon_sym___forceinline] = ACTIONS(1365),
    [anon_sym_thread_local] = ACTIONS(1365),
    [anon_sym___thread] = ACTIONS(1365),
    [anon_sym_const] = ACTIONS(1365),
    [anon_sym_constexpr] = ACTIONS(1365),
    [anon_sym_volatile] = ACTIONS(1365),
    [anon_sym_restrict] = ACTIONS(1365),
    [anon_sym___restrict__] = ACTIONS(1365),
    [anon_sym__Atomic] = ACTIONS(1365),
    [anon_sym__Noreturn] = ACTIONS(1365),
    [anon_sym_noreturn] = ACTIONS(1365),
    [anon_sym_alignas] = ACTIONS(1365),
    [anon_sym__Alignas] = ACTIONS(1365),
    [sym_primitive_type] = ACTIONS(1365),
    [anon_sym_enum] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1365),
    [anon_sym_union] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1365),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1365),
    [anon_sym_case] = ACTIONS(1365),
    [anon_sym_default] = ACTIONS(1365),
    [anon_sym_while] = ACTIONS(1365),
    [anon_sym_do] = ACTIONS(1365),
    [anon_sym_for] = ACTIONS(1365),
    [anon_sym_return] = ACTIONS(1365),
    [anon_sym_break] = ACTIONS(1365),
    [anon_sym_continue] = ACTIONS(1365),
    [anon_sym_goto] = ACTIONS(1365),
    [anon_sym___try] = ACTIONS(1365),
    [anon_sym___leave] = ACTIONS(1365),
    [anon_sym_DASH_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1367),
    [anon_sym_sizeof] = ACTIONS(1365),
    [anon_sym___alignof__] = ACTIONS(1365),
    [anon_sym___alignof] = ACTIONS(1365),
    [anon_sym__alignof] = ACTIONS(1365),
    [anon_sym_alignof] = ACTIONS(1365),
    [anon_sym__Alignof] = ACTIONS(1365),
    [anon_sym_offsetof] = ACTIONS(1365),
    [anon_sym__Generic] = ACTIONS(1365),
    [anon_sym_asm] = ACTIONS(1365),
    [anon_sym___asm__] = ACTIONS(1365),
    [sym_number_literal] = ACTIONS(1367),
    [anon_sym_L_SQUOTE] = ACTIONS(1367),
    [anon_sym_u_SQUOTE] = ACTIONS(1367),
    [anon_sym_U_SQUOTE] = ACTIONS(1367),
    [anon_sym_u8_SQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [anon_sym_L_DQUOTE] = ACTIONS(1367),
    [anon_sym_u_DQUOTE] = ACTIONS(1367),
    [anon_sym_U_DQUOTE] = ACTIONS(1367),
    [anon_sym_u8_DQUOTE] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_true] = ACTIONS(1365),
    [sym_false] = ACTIONS(1365),
    [anon_sym_NULL] = ACTIONS(1365),
    [anon_sym_nullptr] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1365),
    [anon_sym_hitAttributeEXT] = ACTIONS(1365),
    [anon_sym_callableDataEXT] = ACTIONS(1365),
    [anon_sym_callableDataInEXT] = ACTIONS(1365),
    [anon_sym_shaderRecordEXT] = ACTIONS(1365),
    [anon_sym_rayPayloadNV] = ACTIONS(1365),
    [anon_sym_rayPayloadInNV] = ACTIONS(1365),
    [anon_sym_hitAttributeNV] = ACTIONS(1365),
    [anon_sym_callableDataNV] = ACTIONS(1365),
    [anon_sym_callableDataInNV] = ACTIONS(1365),
    [anon_sym_shaderRecordNV] = ACTIONS(1365),
    [anon_sym_layout] = ACTIONS(1365),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_RBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [246] = {
    [sym_identifier] = ACTIONS(1327),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token2] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1325),
    [anon_sym_TILDE] = ACTIONS(1325),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_subroutine] = ACTIONS(1327),
    [anon_sym_invariant] = ACTIONS(1327),
    [anon_sym_precise] = ACTIONS(1327),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_in] = ACTIONS(1327),
    [anon_sym_out] = ACTIONS(1327),
    [anon_sym_inout] = ACTIONS(1327),
    [anon_sym_uniform] = ACTIONS(1327),
    [anon_sym_shared] = ACTIONS(1327),
    [anon_sym_attribute] = ACTIONS(1327),
    [anon_sym_varying] = ACTIONS(1327),
    [anon_sym_buffer] = ACTIONS(1327),
    [anon_sym_coherent] = ACTIONS(1327),
    [anon_sym_readonly] = ACTIONS(1327),
    [anon_sym_writeonly] = ACTIONS(1327),
    [anon_sym_precision] = ACTIONS(1327),
    [anon_sym_highp] = ACTIONS(1327),
    [anon_sym_mediump] = ACTIONS(1327),
    [anon_sym_lowp] = ACTIONS(1327),
    [anon_sym_centroid] = ACTIONS(1327),
    [anon_sym_sample] = ACTIONS(1327),
    [anon_sym_patch] = ACTIONS(1327),
    [anon_sym_smooth] = ACTIONS(1327),
    [anon_sym_flat] = ACTIONS(1327),
    [anon_sym_noperspective] = ACTIONS(1327),
    [anon_sym___extension__] = ACTIONS(1327),
    [anon_sym_typedef] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym___attribute__] = ACTIONS(1327),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1325),
    [anon_sym___declspec] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_signed] = ACTIONS(1327),
    [anon_sym_unsigned] = ACTIONS(1327),
    [anon_sym_long] = ACTIONS(1327),
    [anon_sym_short] = ACTIONS(1327),
    [anon_sym_static] = ACTIONS(1327),
    [anon_sym_auto] = ACTIONS(1327),
    [anon_sym_register] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym___inline] = ACTIONS(1327),
    [anon_sym___inline__] = ACTIONS(1327),
    [anon_sym___forceinline] = ACTIONS(1327),
    [anon_sym_thread_local] = ACTIONS(1327),
    [anon_sym___thread] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_constexpr] = ACTIONS(1327),
    [anon_sym_volatile] = ACTIONS(1327),
    [anon_sym_restrict] = ACTIONS(1327),
    [anon_sym___restrict__] = ACTIONS(1327),
    [anon_sym__Atomic] = ACTIONS(1327),
    [anon_sym__Noreturn] = ACTIONS(1327),
    [anon_sym_noreturn] = ACTIONS(1327),
    [anon_sym_alignas] = ACTIONS(1327),
    [anon_sym__Alignas] = ACTIONS(1327),
    [sym_primitive_type] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_do] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_return] = ACTIONS(1327),
    [anon_sym_break] = ACTIONS(1327),
    [anon_sym_continue] = ACTIONS(1327),
    [anon_sym_goto] = ACTIONS(1327),
    [anon_sym___try] = ACTIONS(1327),
    [anon_sym___leave] = ACTIONS(1327),
    [anon_sym_DASH_DASH] = ACTIONS(1325),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_sizeof] = ACTIONS(1327),
    [anon_sym___alignof__] = ACTIONS(1327),
    [anon_sym___alignof] = ACTIONS(1327),
    [anon_sym__alignof] = ACTIONS(1327),
    [anon_sym_alignof] = ACTIONS(1327),
    [anon_sym__Alignof] = ACTIONS(1327),
    [anon_sym_offsetof] = ACTIONS(1327),
    [anon_sym__Generic] = ACTIONS(1327),
    [anon_sym_asm] = ACTIONS(1327),
    [anon_sym___asm__] = ACTIONS(1327),
    [sym_number_literal] = ACTIONS(1325),
    [anon_sym_L_SQUOTE] = ACTIONS(1325),
    [anon_sym_u_SQUOTE] = ACTIONS(1325),
    [anon_sym_U_SQUOTE] = ACTIONS(1325),
    [anon_sym_u8_SQUOTE] = ACTIONS(1325),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [anon_sym_L_DQUOTE] = ACTIONS(1325),
    [anon_sym_u_DQUOTE] = ACTIONS(1325),
    [anon_sym_U_DQUOTE] = ACTIONS(1325),
    [anon_sym_u8_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [sym_true] = ACTIONS(1327),
    [sym_false] = ACTIONS(1327),
    [anon_sym_NULL] = ACTIONS(1327),
    [anon_sym_nullptr] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1327),
    [anon_sym_hitAttributeEXT] = ACTIONS(1327),
    [anon_sym_callableDataEXT] = ACTIONS(1327),
    [anon_sym_callableDataInEXT] = ACTIONS(1327),
    [anon_sym_shaderRecordEXT] = ACTIONS(1327),
    [anon_sym_rayPayloadNV] = ACTIONS(1327),
    [anon_sym_rayPayloadInNV] = ACTIONS(1327),
    [anon_sym_hitAttributeNV] = ACTIONS(1327),
    [anon_sym_callableDataNV] = ACTIONS(1327),
    [anon_sym_callableDataInNV] = ACTIONS(1327),
    [anon_sym_shaderRecordNV] = ACTIONS(1327),
    [anon_sym_layout] = ACTIONS(1327),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1369),
    [aux_sym_preproc_include_token1] = ACTIONS(1369),
    [aux_sym_preproc_def_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token1] = ACTIONS(1369),
    [aux_sym_preproc_if_token2] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1369),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1369),
    [sym_preproc_directive] = ACTIONS(1369),
    [anon_sym_LPAREN2] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_subroutine] = ACTIONS(1369),
    [anon_sym_invariant] = ACTIONS(1369),
    [anon_sym_precise] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1371),
    [anon_sym_in] = ACTIONS(1369),
    [anon_sym_out] = ACTIONS(1369),
    [anon_sym_inout] = ACTIONS(1369),
    [anon_sym_uniform] = ACTIONS(1369),
    [anon_sym_shared] = ACTIONS(1369),
    [anon_sym_attribute] = ACTIONS(1369),
    [anon_sym_varying] = ACTIONS(1369),
    [anon_sym_buffer] = ACTIONS(1369),
    [anon_sym_coherent] = ACTIONS(1369),
    [anon_sym_readonly] = ACTIONS(1369),
    [anon_sym_writeonly] = ACTIONS(1369),
    [anon_sym_precision] = ACTIONS(1369),
    [anon_sym_highp] = ACTIONS(1369),
    [anon_sym_mediump] = ACTIONS(1369),
    [anon_sym_lowp] = ACTIONS(1369),
    [anon_sym_centroid] = ACTIONS(1369),
    [anon_sym_sample] = ACTIONS(1369),
    [anon_sym_patch] = ACTIONS(1369),
    [anon_sym_smooth] = ACTIONS(1369),
    [anon_sym_flat] = ACTIONS(1369),
    [anon_sym_noperspective] = ACTIONS(1369),
    [anon_sym___extension__] = ACTIONS(1369),
    [anon_sym_typedef] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1369),
    [anon_sym___attribute__] = ACTIONS(1369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1371),
    [anon_sym___declspec] = ACTIONS(1369),
    [anon_sym___cdecl] = ACTIONS(1369),
    [anon_sym___clrcall] = ACTIONS(1369),
    [anon_sym___stdcall] = ACTIONS(1369),
    [anon_sym___fastcall] = ACTIONS(1369),
    [anon_sym___thiscall] = ACTIONS(1369),
    [anon_sym___vectorcall] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1371),
    [anon_sym_signed] = ACTIONS(1369),
    [anon_sym_unsigned] = ACTIONS(1369),
    [anon_sym_long] = ACTIONS(1369),
    [anon_sym_short] = ACTIONS(1369),
    [anon_sym_static] = ACTIONS(1369),
    [anon_sym_auto] = ACTIONS(1369),
    [anon_sym_register] = ACTIONS(1369),
    [anon_sym_inline] = ACTIONS(1369),
    [anon_sym___inline] = ACTIONS(1369),
    [anon_sym___inline__] = ACTIONS(1369),
    [anon_sym___forceinline] = ACTIONS(1369),
    [anon_sym_thread_local] = ACTIONS(1369),
    [anon_sym___thread] = ACTIONS(1369),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_constexpr] = ACTIONS(1369),
    [anon_sym_volatile] = ACTIONS(1369),
    [anon_sym_restrict] = ACTIONS(1369),
    [anon_sym___restrict__] = ACTIONS(1369),
    [anon_sym__Atomic] = ACTIONS(1369),
    [anon_sym__Noreturn] = ACTIONS(1369),
    [anon_sym_noreturn] = ACTIONS(1369),
    [anon_sym_alignas] = ACTIONS(1369),
    [anon_sym__Alignas] = ACTIONS(1369),
    [sym_primitive_type] = ACTIONS(1369),
    [anon_sym_enum] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1369),
    [anon_sym_union] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1369),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1369),
    [anon_sym_case] = ACTIONS(1369),
    [anon_sym_default] = ACTIONS(1369),
    [anon_sym_while] = ACTIONS(1369),
    [anon_sym_do] = ACTIONS(1369),
    [anon_sym_for] = ACTIONS(1369),
    [anon_sym_return] = ACTIONS(1369),
    [anon_sym_break] = ACTIONS(1369),
    [anon_sym_continue] = ACTIONS(1369),
    [anon_sym_goto] = ACTIONS(1369),
    [anon_sym___try] = ACTIONS(1369),
    [anon_sym___leave] = ACTIONS(1369),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_sizeof] = ACTIONS(1369),
    [anon_sym___alignof__] = ACTIONS(1369),
    [anon_sym___alignof] = ACTIONS(1369),
    [anon_sym__alignof] = ACTIONS(1369),
    [anon_sym_alignof] = ACTIONS(1369),
    [anon_sym__Alignof] = ACTIONS(1369),
    [anon_sym_offsetof] = ACTIONS(1369),
    [anon_sym__Generic] = ACTIONS(1369),
    [anon_sym_asm] = ACTIONS(1369),
    [anon_sym___asm__] = ACTIONS(1369),
    [sym_number_literal] = ACTIONS(1371),
    [anon_sym_L_SQUOTE] = ACTIONS(1371),
    [anon_sym_u_SQUOTE] = ACTIONS(1371),
    [anon_sym_U_SQUOTE] = ACTIONS(1371),
    [anon_sym_u8_SQUOTE] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [anon_sym_L_DQUOTE] = ACTIONS(1371),
    [anon_sym_u_DQUOTE] = ACTIONS(1371),
    [anon_sym_U_DQUOTE] = ACTIONS(1371),
    [anon_sym_u8_DQUOTE] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [sym_true] = ACTIONS(1369),
    [sym_false] = ACTIONS(1369),
    [anon_sym_NULL] = ACTIONS(1369),
    [anon_sym_nullptr] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1369),
    [anon_sym_hitAttributeEXT] = ACTIONS(1369),
    [anon_sym_callableDataEXT] = ACTIONS(1369),
    [anon_sym_callableDataInEXT] = ACTIONS(1369),
    [anon_sym_shaderRecordEXT] = ACTIONS(1369),
    [anon_sym_rayPayloadNV] = ACTIONS(1369),
    [anon_sym_rayPayloadInNV] = ACTIONS(1369),
    [anon_sym_hitAttributeNV] = ACTIONS(1369),
    [anon_sym_callableDataNV] = ACTIONS(1369),
    [anon_sym_callableDataInNV] = ACTIONS(1369),
    [anon_sym_shaderRecordNV] = ACTIONS(1369),
    [anon_sym_layout] = ACTIONS(1369),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1319),
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [250] = {
    [sym_identifier] = ACTIONS(1377),
    [aux_sym_preproc_include_token1] = ACTIONS(1377),
    [aux_sym_preproc_def_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token1] = ACTIONS(1377),
    [aux_sym_preproc_if_token2] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1377),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1377),
    [sym_preproc_directive] = ACTIONS(1377),
    [anon_sym_LPAREN2] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_subroutine] = ACTIONS(1377),
    [anon_sym_invariant] = ACTIONS(1377),
    [anon_sym_precise] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1379),
    [anon_sym_in] = ACTIONS(1377),
    [anon_sym_out] = ACTIONS(1377),
    [anon_sym_inout] = ACTIONS(1377),
    [anon_sym_uniform] = ACTIONS(1377),
    [anon_sym_shared] = ACTIONS(1377),
    [anon_sym_attribute] = ACTIONS(1377),
    [anon_sym_varying] = ACTIONS(1377),
    [anon_sym_buffer] = ACTIONS(1377),
    [anon_sym_coherent] = ACTIONS(1377),
    [anon_sym_readonly] = ACTIONS(1377),
    [anon_sym_writeonly] = ACTIONS(1377),
    [anon_sym_precision] = ACTIONS(1377),
    [anon_sym_highp] = ACTIONS(1377),
    [anon_sym_mediump] = ACTIONS(1377),
    [anon_sym_lowp] = ACTIONS(1377),
    [anon_sym_centroid] = ACTIONS(1377),
    [anon_sym_sample] = ACTIONS(1377),
    [anon_sym_patch] = ACTIONS(1377),
    [anon_sym_smooth] = ACTIONS(1377),
    [anon_sym_flat] = ACTIONS(1377),
    [anon_sym_noperspective] = ACTIONS(1377),
    [anon_sym___extension__] = ACTIONS(1377),
    [anon_sym_typedef] = ACTIONS(1377),
    [anon_sym_extern] = ACTIONS(1377),
    [anon_sym___attribute__] = ACTIONS(1377),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1379),
    [anon_sym___declspec] = ACTIONS(1377),
    [anon_sym___cdecl] = ACTIONS(1377),
    [anon_sym___clrcall] = ACTIONS(1377),
    [anon_sym___stdcall] = ACTIONS(1377),
    [anon_sym___fastcall] = ACTIONS(1377),
    [anon_sym___thiscall] = ACTIONS(1377),
    [anon_sym___vectorcall] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1379),
    [anon_sym_signed] = ACTIONS(1377),
    [anon_sym_unsigned] = ACTIONS(1377),
    [anon_sym_long] = ACTIONS(1377),
    [anon_sym_short] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_auto] = ACTIONS(1377),
    [anon_sym_register] = ACTIONS(1377),
    [anon_sym_inline] = ACTIONS(1377),
    [anon_sym___inline] = ACTIONS(1377),
    [anon_sym___inline__] = ACTIONS(1377),
    [anon_sym___forceinline] = ACTIONS(1377),
    [anon_sym_thread_local] = ACTIONS(1377),
    [anon_sym___thread] = ACTIONS(1377),
    [anon_sym_const] = ACTIONS(1377),
    [anon_sym_constexpr] = ACTIONS(1377),
    [anon_sym_volatile] = ACTIONS(1377),
    [anon_sym_restrict] = ACTIONS(1377),
    [anon_sym___restrict__] = ACTIONS(1377),
    [anon_sym__Atomic] = ACTIONS(1377),
    [anon_sym__Noreturn] = ACTIONS(1377),
    [anon_sym_noreturn] = ACTIONS(1377),
    [anon_sym_alignas] = ACTIONS(1377),
    [anon_sym__Alignas] = ACTIONS(1377),
    [sym_primitive_type] = ACTIONS(1377),
    [anon_sym_enum] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1377),
    [anon_sym_union] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1377),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1377),
    [anon_sym_case] = ACTIONS(1377),
    [anon_sym_default] = ACTIONS(1377),
    [anon_sym_while] = ACTIONS(1377),
    [anon_sym_do] = ACTIONS(1377),
    [anon_sym_for] = ACTIONS(1377),
    [anon_sym_return] = ACTIONS(1377),
    [anon_sym_break] = ACTIONS(1377),
    [anon_sym_continue] = ACTIONS(1377),
    [anon_sym_goto] = ACTIONS(1377),
    [anon_sym___try] = ACTIONS(1377),
    [anon_sym___leave] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_sizeof] = ACTIONS(1377),
    [anon_sym___alignof__] = ACTIONS(1377),
    [anon_sym___alignof] = ACTIONS(1377),
    [anon_sym__alignof] = ACTIONS(1377),
    [anon_sym_alignof] = ACTIONS(1377),
    [anon_sym__Alignof] = ACTIONS(1377),
    [anon_sym_offsetof] = ACTIONS(1377),
    [anon_sym__Generic] = ACTIONS(1377),
    [anon_sym_asm] = ACTIONS(1377),
    [anon_sym___asm__] = ACTIONS(1377),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1379),
    [anon_sym_u_SQUOTE] = ACTIONS(1379),
    [anon_sym_U_SQUOTE] = ACTIONS(1379),
    [anon_sym_u8_SQUOTE] = ACTIONS(1379),
    [anon_sym_SQUOTE] = ACTIONS(1379),
    [anon_sym_L_DQUOTE] = ACTIONS(1379),
    [anon_sym_u_DQUOTE] = ACTIONS(1379),
    [anon_sym_U_DQUOTE] = ACTIONS(1379),
    [anon_sym_u8_DQUOTE] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_true] = ACTIONS(1377),
    [sym_false] = ACTIONS(1377),
    [anon_sym_NULL] = ACTIONS(1377),
    [anon_sym_nullptr] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1377),
    [anon_sym_hitAttributeEXT] = ACTIONS(1377),
    [anon_sym_callableDataEXT] = ACTIONS(1377),
    [anon_sym_callableDataInEXT] = ACTIONS(1377),
    [anon_sym_shaderRecordEXT] = ACTIONS(1377),
    [anon_sym_rayPayloadNV] = ACTIONS(1377),
    [anon_sym_rayPayloadInNV] = ACTIONS(1377),
    [anon_sym_hitAttributeNV] = ACTIONS(1377),
    [anon_sym_callableDataNV] = ACTIONS(1377),
    [anon_sym_callableDataInNV] = ACTIONS(1377),
    [anon_sym_shaderRecordNV] = ACTIONS(1377),
    [anon_sym_layout] = ACTIONS(1377),
  },
  [251] = {
    [sym_identifier] = ACTIONS(1237),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_subroutine] = ACTIONS(1237),
    [anon_sym_invariant] = ACTIONS(1237),
    [anon_sym_precise] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_out] = ACTIONS(1237),
    [anon_sym_inout] = ACTIONS(1237),
    [anon_sym_uniform] = ACTIONS(1237),
    [anon_sym_shared] = ACTIONS(1237),
    [anon_sym_attribute] = ACTIONS(1237),
    [anon_sym_varying] = ACTIONS(1237),
    [anon_sym_buffer] = ACTIONS(1237),
    [anon_sym_coherent] = ACTIONS(1237),
    [anon_sym_readonly] = ACTIONS(1237),
    [anon_sym_writeonly] = ACTIONS(1237),
    [anon_sym_precision] = ACTIONS(1237),
    [anon_sym_highp] = ACTIONS(1237),
    [anon_sym_mediump] = ACTIONS(1237),
    [anon_sym_lowp] = ACTIONS(1237),
    [anon_sym_centroid] = ACTIONS(1237),
    [anon_sym_sample] = ACTIONS(1237),
    [anon_sym_patch] = ACTIONS(1237),
    [anon_sym_smooth] = ACTIONS(1237),
    [anon_sym_flat] = ACTIONS(1237),
    [anon_sym_noperspective] = ACTIONS(1237),
    [anon_sym___extension__] = ACTIONS(1237),
    [anon_sym_typedef] = ACTIONS(1237),
    [anon_sym_extern] = ACTIONS(1237),
    [anon_sym___attribute__] = ACTIONS(1237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1239),
    [anon_sym___declspec] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(1237),
    [anon_sym_unsigned] = ACTIONS(1237),
    [anon_sym_long] = ACTIONS(1237),
    [anon_sym_short] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_auto] = ACTIONS(1237),
    [anon_sym_register] = ACTIONS(1237),
    [anon_sym_inline] = ACTIONS(1237),
    [anon_sym___inline] = ACTIONS(1237),
    [anon_sym___inline__] = ACTIONS(1237),
    [anon_sym___forceinline] = ACTIONS(1237),
    [anon_sym_thread_local] = ACTIONS(1237),
    [anon_sym___thread] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_constexpr] = ACTIONS(1237),
    [anon_sym_volatile] = ACTIONS(1237),
    [anon_sym_restrict] = ACTIONS(1237),
    [anon_sym___restrict__] = ACTIONS(1237),
    [anon_sym__Atomic] = ACTIONS(1237),
    [anon_sym__Noreturn] = ACTIONS(1237),
    [anon_sym_noreturn] = ACTIONS(1237),
    [anon_sym_alignas] = ACTIONS(1237),
    [anon_sym__Alignas] = ACTIONS(1237),
    [sym_primitive_type] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1237),
    [anon_sym_union] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_goto] = ACTIONS(1237),
    [anon_sym___try] = ACTIONS(1237),
    [anon_sym___leave] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_sizeof] = ACTIONS(1237),
    [anon_sym___alignof__] = ACTIONS(1237),
    [anon_sym___alignof] = ACTIONS(1237),
    [anon_sym__alignof] = ACTIONS(1237),
    [anon_sym_alignof] = ACTIONS(1237),
    [anon_sym__Alignof] = ACTIONS(1237),
    [anon_sym_offsetof] = ACTIONS(1237),
    [anon_sym__Generic] = ACTIONS(1237),
    [anon_sym_asm] = ACTIONS(1237),
    [anon_sym___asm__] = ACTIONS(1237),
    [sym_number_literal] = ACTIONS(1239),
    [anon_sym_L_SQUOTE] = ACTIONS(1239),
    [anon_sym_u_SQUOTE] = ACTIONS(1239),
    [anon_sym_U_SQUOTE] = ACTIONS(1239),
    [anon_sym_u8_SQUOTE] = ACTIONS(1239),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_L_DQUOTE] = ACTIONS(1239),
    [anon_sym_u_DQUOTE] = ACTIONS(1239),
    [anon_sym_U_DQUOTE] = ACTIONS(1239),
    [anon_sym_u8_DQUOTE] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [anon_sym_NULL] = ACTIONS(1237),
    [anon_sym_nullptr] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1237),
    [anon_sym_hitAttributeEXT] = ACTIONS(1237),
    [anon_sym_callableDataEXT] = ACTIONS(1237),
    [anon_sym_callableDataInEXT] = ACTIONS(1237),
    [anon_sym_shaderRecordEXT] = ACTIONS(1237),
    [anon_sym_rayPayloadNV] = ACTIONS(1237),
    [anon_sym_rayPayloadInNV] = ACTIONS(1237),
    [anon_sym_hitAttributeNV] = ACTIONS(1237),
    [anon_sym_callableDataNV] = ACTIONS(1237),
    [anon_sym_callableDataInNV] = ACTIONS(1237),
    [anon_sym_shaderRecordNV] = ACTIONS(1237),
    [anon_sym_layout] = ACTIONS(1237),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1385),
    [aux_sym_preproc_include_token1] = ACTIONS(1385),
    [aux_sym_preproc_def_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token1] = ACTIONS(1385),
    [aux_sym_preproc_if_token2] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1385),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1385),
    [sym_preproc_directive] = ACTIONS(1385),
    [anon_sym_LPAREN2] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_subroutine] = ACTIONS(1385),
    [anon_sym_invariant] = ACTIONS(1385),
    [anon_sym_precise] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_in] = ACTIONS(1385),
    [anon_sym_out] = ACTIONS(1385),
    [anon_sym_inout] = ACTIONS(1385),
    [anon_sym_uniform] = ACTIONS(1385),
    [anon_sym_shared] = ACTIONS(1385),
    [anon_sym_attribute] = ACTIONS(1385),
    [anon_sym_varying] = ACTIONS(1385),
    [anon_sym_buffer] = ACTIONS(1385),
    [anon_sym_coherent] = ACTIONS(1385),
    [anon_sym_readonly] = ACTIONS(1385),
    [anon_sym_writeonly] = ACTIONS(1385),
    [anon_sym_precision] = ACTIONS(1385),
    [anon_sym_highp] = ACTIONS(1385),
    [anon_sym_mediump] = ACTIONS(1385),
    [anon_sym_lowp] = ACTIONS(1385),
    [anon_sym_centroid] = ACTIONS(1385),
    [anon_sym_sample] = ACTIONS(1385),
    [anon_sym_patch] = ACTIONS(1385),
    [anon_sym_smooth] = ACTIONS(1385),
    [anon_sym_flat] = ACTIONS(1385),
    [anon_sym_noperspective] = ACTIONS(1385),
    [anon_sym___extension__] = ACTIONS(1385),
    [anon_sym_typedef] = ACTIONS(1385),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym___attribute__] = ACTIONS(1385),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1387),
    [anon_sym___declspec] = ACTIONS(1385),
    [anon_sym___cdecl] = ACTIONS(1385),
    [anon_sym___clrcall] = ACTIONS(1385),
    [anon_sym___stdcall] = ACTIONS(1385),
    [anon_sym___fastcall] = ACTIONS(1385),
    [anon_sym___thiscall] = ACTIONS(1385),
    [anon_sym___vectorcall] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_signed] = ACTIONS(1385),
    [anon_sym_unsigned] = ACTIONS(1385),
    [anon_sym_long] = ACTIONS(1385),
    [anon_sym_short] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_auto] = ACTIONS(1385),
    [anon_sym_register] = ACTIONS(1385),
    [anon_sym_inline] = ACTIONS(1385),
    [anon_sym___inline] = ACTIONS(1385),
    [anon_sym___inline__] = ACTIONS(1385),
    [anon_sym___forceinline] = ACTIONS(1385),
    [anon_sym_thread_local] = ACTIONS(1385),
    [anon_sym___thread] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_constexpr] = ACTIONS(1385),
    [anon_sym_volatile] = ACTIONS(1385),
    [anon_sym_restrict] = ACTIONS(1385),
    [anon_sym___restrict__] = ACTIONS(1385),
    [anon_sym__Atomic] = ACTIONS(1385),
    [anon_sym__Noreturn] = ACTIONS(1385),
    [anon_sym_noreturn] = ACTIONS(1385),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1385),
    [anon_sym_else] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1385),
    [anon_sym_case] = ACTIONS(1385),
    [anon_sym_default] = ACTIONS(1385),
    [anon_sym_while] = ACTIONS(1385),
    [anon_sym_do] = ACTIONS(1385),
    [anon_sym_for] = ACTIONS(1385),
    [anon_sym_return] = ACTIONS(1385),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_continue] = ACTIONS(1385),
    [anon_sym_goto] = ACTIONS(1385),
    [anon_sym___try] = ACTIONS(1385),
    [anon_sym___leave] = ACTIONS(1385),
    [anon_sym_DASH_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1387),
    [anon_sym_sizeof] = ACTIONS(1385),
    [anon_sym___alignof__] = ACTIONS(1385),
    [anon_sym___alignof] = ACTIONS(1385),
    [anon_sym__alignof] = ACTIONS(1385),
    [anon_sym_alignof] = ACTIONS(1385),
    [anon_sym__Alignof] = ACTIONS(1385),
    [anon_sym_offsetof] = ACTIONS(1385),
    [anon_sym__Generic] = ACTIONS(1385),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1387),
    [anon_sym_L_SQUOTE] = ACTIONS(1387),
    [anon_sym_u_SQUOTE] = ACTIONS(1387),
    [anon_sym_U_SQUOTE] = ACTIONS(1387),
    [anon_sym_u8_SQUOTE] = ACTIONS(1387),
    [anon_sym_SQUOTE] = ACTIONS(1387),
    [anon_sym_L_DQUOTE] = ACTIONS(1387),
    [anon_sym_u_DQUOTE] = ACTIONS(1387),
    [anon_sym_U_DQUOTE] = ACTIONS(1387),
    [anon_sym_u8_DQUOTE] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1387),
    [sym_true] = ACTIONS(1385),
    [sym_false] = ACTIONS(1385),
    [anon_sym_NULL] = ACTIONS(1385),
    [anon_sym_nullptr] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1385),
    [anon_sym_hitAttributeEXT] = ACTIONS(1385),
    [anon_sym_callableDataEXT] = ACTIONS(1385),
    [anon_sym_callableDataInEXT] = ACTIONS(1385),
    [anon_sym_shaderRecordEXT] = ACTIONS(1385),
    [anon_sym_rayPayloadNV] = ACTIONS(1385),
    [anon_sym_rayPayloadInNV] = ACTIONS(1385),
    [anon_sym_hitAttributeNV] = ACTIONS(1385),
    [anon_sym_callableDataNV] = ACTIONS(1385),
    [anon_sym_callableDataInNV] = ACTIONS(1385),
    [anon_sym_shaderRecordNV] = ACTIONS(1385),
    [anon_sym_layout] = ACTIONS(1385),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1391),
    [sym_identifier] = ACTIONS(1389),
    [aux_sym_preproc_include_token1] = ACTIONS(1389),
    [aux_sym_preproc_def_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_LPAREN2] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1389),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_subroutine] = ACTIONS(1389),
    [anon_sym_invariant] = ACTIONS(1389),
    [anon_sym_precise] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_out] = ACTIONS(1389),
    [anon_sym_inout] = ACTIONS(1389),
    [anon_sym_uniform] = ACTIONS(1389),
    [anon_sym_shared] = ACTIONS(1389),
    [anon_sym_attribute] = ACTIONS(1389),
    [anon_sym_varying] = ACTIONS(1389),
    [anon_sym_buffer] = ACTIONS(1389),
    [anon_sym_coherent] = ACTIONS(1389),
    [anon_sym_readonly] = ACTIONS(1389),
    [anon_sym_writeonly] = ACTIONS(1389),
    [anon_sym_precision] = ACTIONS(1389),
    [anon_sym_highp] = ACTIONS(1389),
    [anon_sym_mediump] = ACTIONS(1389),
    [anon_sym_lowp] = ACTIONS(1389),
    [anon_sym_centroid] = ACTIONS(1389),
    [anon_sym_sample] = ACTIONS(1389),
    [anon_sym_patch] = ACTIONS(1389),
    [anon_sym_smooth] = ACTIONS(1389),
    [anon_sym_flat] = ACTIONS(1389),
    [anon_sym_noperspective] = ACTIONS(1389),
    [anon_sym___extension__] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym___attribute__] = ACTIONS(1389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1391),
    [anon_sym___declspec] = ACTIONS(1389),
    [anon_sym___cdecl] = ACTIONS(1389),
    [anon_sym___clrcall] = ACTIONS(1389),
    [anon_sym___stdcall] = ACTIONS(1389),
    [anon_sym___fastcall] = ACTIONS(1389),
    [anon_sym___thiscall] = ACTIONS(1389),
    [anon_sym___vectorcall] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_signed] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym___inline] = ACTIONS(1389),
    [anon_sym___inline__] = ACTIONS(1389),
    [anon_sym___forceinline] = ACTIONS(1389),
    [anon_sym_thread_local] = ACTIONS(1389),
    [anon_sym___thread] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_constexpr] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym___restrict__] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym__Noreturn] = ACTIONS(1389),
    [anon_sym_noreturn] = ACTIONS(1389),
    [anon_sym_alignas] = ACTIONS(1389),
    [anon_sym__Alignas] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1389),
    [anon_sym_case] = ACTIONS(1389),
    [anon_sym_default] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(1389),
    [anon_sym_for] = ACTIONS(1389),
    [anon_sym_return] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(1389),
    [anon_sym_continue] = ACTIONS(1389),
    [anon_sym_goto] = ACTIONS(1389),
    [anon_sym___try] = ACTIONS(1389),
    [anon_sym___leave] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_sizeof] = ACTIONS(1389),
    [anon_sym___alignof__] = ACTIONS(1389),
    [anon_sym___alignof] = ACTIONS(1389),
    [anon_sym__alignof] = ACTIONS(1389),
    [anon_sym_alignof] = ACTIONS(1389),
    [anon_sym__Alignof] = ACTIONS(1389),
    [anon_sym_offsetof] = ACTIONS(1389),
    [anon_sym__Generic] = ACTIONS(1389),
    [anon_sym_asm] = ACTIONS(1389),
    [anon_sym___asm__] = ACTIONS(1389),
    [sym_number_literal] = ACTIONS(1391),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1391),
    [anon_sym_u_DQUOTE] = ACTIONS(1391),
    [anon_sym_U_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8_DQUOTE] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [anon_sym_NULL] = ACTIONS(1389),
    [anon_sym_nullptr] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1389),
    [anon_sym_hitAttributeEXT] = ACTIONS(1389),
    [anon_sym_callableDataEXT] = ACTIONS(1389),
    [anon_sym_callableDataInEXT] = ACTIONS(1389),
    [anon_sym_shaderRecordEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadNV] = ACTIONS(1389),
    [anon_sym_rayPayloadInNV] = ACTIONS(1389),
    [anon_sym_hitAttributeNV] = ACTIONS(1389),
    [anon_sym_callableDataNV] = ACTIONS(1389),
    [anon_sym_callableDataInNV] = ACTIONS(1389),
    [anon_sym_shaderRecordNV] = ACTIONS(1389),
    [anon_sym_layout] = ACTIONS(1389),
  },
  [254] = {
    [sym_identifier] = ACTIONS(1293),
    [aux_sym_preproc_include_token1] = ACTIONS(1293),
    [aux_sym_preproc_def_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token2] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1293),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1293),
    [sym_preproc_directive] = ACTIONS(1293),
    [anon_sym_LPAREN2] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_subroutine] = ACTIONS(1293),
    [anon_sym_invariant] = ACTIONS(1293),
    [anon_sym_precise] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_in] = ACTIONS(1293),
    [anon_sym_out] = ACTIONS(1293),
    [anon_sym_inout] = ACTIONS(1293),
    [anon_sym_uniform] = ACTIONS(1293),
    [anon_sym_shared] = ACTIONS(1293),
    [anon_sym_attribute] = ACTIONS(1293),
    [anon_sym_varying] = ACTIONS(1293),
    [anon_sym_buffer] = ACTIONS(1293),
    [anon_sym_coherent] = ACTIONS(1293),
    [anon_sym_readonly] = ACTIONS(1293),
    [anon_sym_writeonly] = ACTIONS(1293),
    [anon_sym_precision] = ACTIONS(1293),
    [anon_sym_highp] = ACTIONS(1293),
    [anon_sym_mediump] = ACTIONS(1293),
    [anon_sym_lowp] = ACTIONS(1293),
    [anon_sym_centroid] = ACTIONS(1293),
    [anon_sym_sample] = ACTIONS(1293),
    [anon_sym_patch] = ACTIONS(1293),
    [anon_sym_smooth] = ACTIONS(1293),
    [anon_sym_flat] = ACTIONS(1293),
    [anon_sym_noperspective] = ACTIONS(1293),
    [anon_sym___extension__] = ACTIONS(1293),
    [anon_sym_typedef] = ACTIONS(1293),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym___attribute__] = ACTIONS(1293),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1295),
    [anon_sym___declspec] = ACTIONS(1293),
    [anon_sym___cdecl] = ACTIONS(1293),
    [anon_sym___clrcall] = ACTIONS(1293),
    [anon_sym___stdcall] = ACTIONS(1293),
    [anon_sym___fastcall] = ACTIONS(1293),
    [anon_sym___thiscall] = ACTIONS(1293),
    [anon_sym___vectorcall] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_signed] = ACTIONS(1293),
    [anon_sym_unsigned] = ACTIONS(1293),
    [anon_sym_long] = ACTIONS(1293),
    [anon_sym_short] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_auto] = ACTIONS(1293),
    [anon_sym_register] = ACTIONS(1293),
    [anon_sym_inline] = ACTIONS(1293),
    [anon_sym___inline] = ACTIONS(1293),
    [anon_sym___inline__] = ACTIONS(1293),
    [anon_sym___forceinline] = ACTIONS(1293),
    [anon_sym_thread_local] = ACTIONS(1293),
    [anon_sym___thread] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_constexpr] = ACTIONS(1293),
    [anon_sym_volatile] = ACTIONS(1293),
    [anon_sym_restrict] = ACTIONS(1293),
    [anon_sym___restrict__] = ACTIONS(1293),
    [anon_sym__Atomic] = ACTIONS(1293),
    [anon_sym__Noreturn] = ACTIONS(1293),
    [anon_sym_noreturn] = ACTIONS(1293),
    [anon_sym_alignas] = ACTIONS(1293),
    [anon_sym__Alignas] = ACTIONS(1293),
    [sym_primitive_type] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1293),
    [anon_sym_case] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_goto] = ACTIONS(1293),
    [anon_sym___try] = ACTIONS(1293),
    [anon_sym___leave] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1295),
    [anon_sym_sizeof] = ACTIONS(1293),
    [anon_sym___alignof__] = ACTIONS(1293),
    [anon_sym___alignof] = ACTIONS(1293),
    [anon_sym__alignof] = ACTIONS(1293),
    [anon_sym_alignof] = ACTIONS(1293),
    [anon_sym__Alignof] = ACTIONS(1293),
    [anon_sym_offsetof] = ACTIONS(1293),
    [anon_sym__Generic] = ACTIONS(1293),
    [anon_sym_asm] = ACTIONS(1293),
    [anon_sym___asm__] = ACTIONS(1293),
    [sym_number_literal] = ACTIONS(1295),
    [anon_sym_L_SQUOTE] = ACTIONS(1295),
    [anon_sym_u_SQUOTE] = ACTIONS(1295),
    [anon_sym_U_SQUOTE] = ACTIONS(1295),
    [anon_sym_u8_SQUOTE] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1295),
    [anon_sym_L_DQUOTE] = ACTIONS(1295),
    [anon_sym_u_DQUOTE] = ACTIONS(1295),
    [anon_sym_U_DQUOTE] = ACTIONS(1295),
    [anon_sym_u8_DQUOTE] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1295),
    [sym_true] = ACTIONS(1293),
    [sym_false] = ACTIONS(1293),
    [anon_sym_NULL] = ACTIONS(1293),
    [anon_sym_nullptr] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1293),
    [anon_sym_hitAttributeEXT] = ACTIONS(1293),
    [anon_sym_callableDataEXT] = ACTIONS(1293),
    [anon_sym_callableDataInEXT] = ACTIONS(1293),
    [anon_sym_shaderRecordEXT] = ACTIONS(1293),
    [anon_sym_rayPayloadNV] = ACTIONS(1293),
    [anon_sym_rayPayloadInNV] = ACTIONS(1293),
    [anon_sym_hitAttributeNV] = ACTIONS(1293),
    [anon_sym_callableDataNV] = ACTIONS(1293),
    [anon_sym_callableDataInNV] = ACTIONS(1293),
    [anon_sym_shaderRecordNV] = ACTIONS(1293),
    [anon_sym_layout] = ACTIONS(1293),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [256] = {
    [sym_identifier] = ACTIONS(1393),
    [aux_sym_preproc_include_token1] = ACTIONS(1393),
    [aux_sym_preproc_def_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token1] = ACTIONS(1393),
    [aux_sym_preproc_if_token2] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1393),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1393),
    [sym_preproc_directive] = ACTIONS(1393),
    [anon_sym_LPAREN2] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1393),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_subroutine] = ACTIONS(1393),
    [anon_sym_invariant] = ACTIONS(1393),
    [anon_sym_precise] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_in] = ACTIONS(1393),
    [anon_sym_out] = ACTIONS(1393),
    [anon_sym_inout] = ACTIONS(1393),
    [anon_sym_uniform] = ACTIONS(1393),
    [anon_sym_shared] = ACTIONS(1393),
    [anon_sym_attribute] = ACTIONS(1393),
    [anon_sym_varying] = ACTIONS(1393),
    [anon_sym_buffer] = ACTIONS(1393),
    [anon_sym_coherent] = ACTIONS(1393),
    [anon_sym_readonly] = ACTIONS(1393),
    [anon_sym_writeonly] = ACTIONS(1393),
    [anon_sym_precision] = ACTIONS(1393),
    [anon_sym_highp] = ACTIONS(1393),
    [anon_sym_mediump] = ACTIONS(1393),
    [anon_sym_lowp] = ACTIONS(1393),
    [anon_sym_centroid] = ACTIONS(1393),
    [anon_sym_sample] = ACTIONS(1393),
    [anon_sym_patch] = ACTIONS(1393),
    [anon_sym_smooth] = ACTIONS(1393),
    [anon_sym_flat] = ACTIONS(1393),
    [anon_sym_noperspective] = ACTIONS(1393),
    [anon_sym___extension__] = ACTIONS(1393),
    [anon_sym_typedef] = ACTIONS(1393),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym___attribute__] = ACTIONS(1393),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1395),
    [anon_sym___declspec] = ACTIONS(1393),
    [anon_sym___cdecl] = ACTIONS(1393),
    [anon_sym___clrcall] = ACTIONS(1393),
    [anon_sym___stdcall] = ACTIONS(1393),
    [anon_sym___fastcall] = ACTIONS(1393),
    [anon_sym___thiscall] = ACTIONS(1393),
    [anon_sym___vectorcall] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(1395),
    [anon_sym_signed] = ACTIONS(1393),
    [anon_sym_unsigned] = ACTIONS(1393),
    [anon_sym_long] = ACTIONS(1393),
    [anon_sym_short] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_auto] = ACTIONS(1393),
    [anon_sym_register] = ACTIONS(1393),
    [anon_sym_inline] = ACTIONS(1393),
    [anon_sym___inline] = ACTIONS(1393),
    [anon_sym___inline__] = ACTIONS(1393),
    [anon_sym___forceinline] = ACTIONS(1393),
    [anon_sym_thread_local] = ACTIONS(1393),
    [anon_sym___thread] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_constexpr] = ACTIONS(1393),
    [anon_sym_volatile] = ACTIONS(1393),
    [anon_sym_restrict] = ACTIONS(1393),
    [anon_sym___restrict__] = ACTIONS(1393),
    [anon_sym__Atomic] = ACTIONS(1393),
    [anon_sym__Noreturn] = ACTIONS(1393),
    [anon_sym_noreturn] = ACTIONS(1393),
    [anon_sym_alignas] = ACTIONS(1393),
    [anon_sym__Alignas] = ACTIONS(1393),
    [sym_primitive_type] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_else] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1393),
    [anon_sym_do] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_return] = ACTIONS(1393),
    [anon_sym_break] = ACTIONS(1393),
    [anon_sym_continue] = ACTIONS(1393),
    [anon_sym_goto] = ACTIONS(1393),
    [anon_sym___try] = ACTIONS(1393),
    [anon_sym___leave] = ACTIONS(1393),
    [anon_sym_DASH_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1395),
    [anon_sym_sizeof] = ACTIONS(1393),
    [anon_sym___alignof__] = ACTIONS(1393),
    [anon_sym___alignof] = ACTIONS(1393),
    [anon_sym__alignof] = ACTIONS(1393),
    [anon_sym_alignof] = ACTIONS(1393),
    [anon_sym__Alignof] = ACTIONS(1393),
    [anon_sym_offsetof] = ACTIONS(1393),
    [anon_sym__Generic] = ACTIONS(1393),
    [anon_sym_asm] = ACTIONS(1393),
    [anon_sym___asm__] = ACTIONS(1393),
    [sym_number_literal] = ACTIONS(1395),
    [anon_sym_L_SQUOTE] = ACTIONS(1395),
    [anon_sym_u_SQUOTE] = ACTIONS(1395),
    [anon_sym_U_SQUOTE] = ACTIONS(1395),
    [anon_sym_u8_SQUOTE] = ACTIONS(1395),
    [anon_sym_SQUOTE] = ACTIONS(1395),
    [anon_sym_L_DQUOTE] = ACTIONS(1395),
    [anon_sym_u_DQUOTE] = ACTIONS(1395),
    [anon_sym_U_DQUOTE] = ACTIONS(1395),
    [anon_sym_u8_DQUOTE] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_true] = ACTIONS(1393),
    [sym_false] = ACTIONS(1393),
    [anon_sym_NULL] = ACTIONS(1393),
    [anon_sym_nullptr] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1393),
    [anon_sym_hitAttributeEXT] = ACTIONS(1393),
    [anon_sym_callableDataEXT] = ACTIONS(1393),
    [anon_sym_callableDataInEXT] = ACTIONS(1393),
    [anon_sym_shaderRecordEXT] = ACTIONS(1393),
    [anon_sym_rayPayloadNV] = ACTIONS(1393),
    [anon_sym_rayPayloadInNV] = ACTIONS(1393),
    [anon_sym_hitAttributeNV] = ACTIONS(1393),
    [anon_sym_callableDataNV] = ACTIONS(1393),
    [anon_sym_callableDataInNV] = ACTIONS(1393),
    [anon_sym_shaderRecordNV] = ACTIONS(1393),
    [anon_sym_layout] = ACTIONS(1393),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1301),
    [aux_sym_preproc_include_token1] = ACTIONS(1301),
    [aux_sym_preproc_def_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token1] = ACTIONS(1301),
    [aux_sym_preproc_if_token2] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1301),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1301),
    [sym_preproc_directive] = ACTIONS(1301),
    [anon_sym_LPAREN2] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_TILDE] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_subroutine] = ACTIONS(1301),
    [anon_sym_invariant] = ACTIONS(1301),
    [anon_sym_precise] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_out] = ACTIONS(1301),
    [anon_sym_inout] = ACTIONS(1301),
    [anon_sym_uniform] = ACTIONS(1301),
    [anon_sym_shared] = ACTIONS(1301),
    [anon_sym_attribute] = ACTIONS(1301),
    [anon_sym_varying] = ACTIONS(1301),
    [anon_sym_buffer] = ACTIONS(1301),
    [anon_sym_coherent] = ACTIONS(1301),
    [anon_sym_readonly] = ACTIONS(1301),
    [anon_sym_writeonly] = ACTIONS(1301),
    [anon_sym_precision] = ACTIONS(1301),
    [anon_sym_highp] = ACTIONS(1301),
    [anon_sym_mediump] = ACTIONS(1301),
    [anon_sym_lowp] = ACTIONS(1301),
    [anon_sym_centroid] = ACTIONS(1301),
    [anon_sym_sample] = ACTIONS(1301),
    [anon_sym_patch] = ACTIONS(1301),
    [anon_sym_smooth] = ACTIONS(1301),
    [anon_sym_flat] = ACTIONS(1301),
    [anon_sym_noperspective] = ACTIONS(1301),
    [anon_sym___extension__] = ACTIONS(1301),
    [anon_sym_typedef] = ACTIONS(1301),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym___attribute__] = ACTIONS(1301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1303),
    [anon_sym___declspec] = ACTIONS(1301),
    [anon_sym___cdecl] = ACTIONS(1301),
    [anon_sym___clrcall] = ACTIONS(1301),
    [anon_sym___stdcall] = ACTIONS(1301),
    [anon_sym___fastcall] = ACTIONS(1301),
    [anon_sym___thiscall] = ACTIONS(1301),
    [anon_sym___vectorcall] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_auto] = ACTIONS(1301),
    [anon_sym_register] = ACTIONS(1301),
    [anon_sym_inline] = ACTIONS(1301),
    [anon_sym___inline] = ACTIONS(1301),
    [anon_sym___inline__] = ACTIONS(1301),
    [anon_sym___forceinline] = ACTIONS(1301),
    [anon_sym_thread_local] = ACTIONS(1301),
    [anon_sym___thread] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_constexpr] = ACTIONS(1301),
    [anon_sym_volatile] = ACTIONS(1301),
    [anon_sym_restrict] = ACTIONS(1301),
    [anon_sym___restrict__] = ACTIONS(1301),
    [anon_sym__Atomic] = ACTIONS(1301),
    [anon_sym__Noreturn] = ACTIONS(1301),
    [anon_sym_noreturn] = ACTIONS(1301),
    [anon_sym_alignas] = ACTIONS(1301),
    [anon_sym__Alignas] = ACTIONS(1301),
    [sym_primitive_type] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1301),
    [anon_sym_case] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_goto] = ACTIONS(1301),
    [anon_sym___try] = ACTIONS(1301),
    [anon_sym___leave] = ACTIONS(1301),
    [anon_sym_DASH_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1303),
    [anon_sym_sizeof] = ACTIONS(1301),
    [anon_sym___alignof__] = ACTIONS(1301),
    [anon_sym___alignof] = ACTIONS(1301),
    [anon_sym__alignof] = ACTIONS(1301),
    [anon_sym_alignof] = ACTIONS(1301),
    [anon_sym__Alignof] = ACTIONS(1301),
    [anon_sym_offsetof] = ACTIONS(1301),
    [anon_sym__Generic] = ACTIONS(1301),
    [anon_sym_asm] = ACTIONS(1301),
    [anon_sym___asm__] = ACTIONS(1301),
    [sym_number_literal] = ACTIONS(1303),
    [anon_sym_L_SQUOTE] = ACTIONS(1303),
    [anon_sym_u_SQUOTE] = ACTIONS(1303),
    [anon_sym_U_SQUOTE] = ACTIONS(1303),
    [anon_sym_u8_SQUOTE] = ACTIONS(1303),
    [anon_sym_SQUOTE] = ACTIONS(1303),
    [anon_sym_L_DQUOTE] = ACTIONS(1303),
    [anon_sym_u_DQUOTE] = ACTIONS(1303),
    [anon_sym_U_DQUOTE] = ACTIONS(1303),
    [anon_sym_u8_DQUOTE] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1303),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [anon_sym_NULL] = ACTIONS(1301),
    [anon_sym_nullptr] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1301),
    [anon_sym_hitAttributeEXT] = ACTIONS(1301),
    [anon_sym_callableDataEXT] = ACTIONS(1301),
    [anon_sym_callableDataInEXT] = ACTIONS(1301),
    [anon_sym_shaderRecordEXT] = ACTIONS(1301),
    [anon_sym_rayPayloadNV] = ACTIONS(1301),
    [anon_sym_rayPayloadInNV] = ACTIONS(1301),
    [anon_sym_hitAttributeNV] = ACTIONS(1301),
    [anon_sym_callableDataNV] = ACTIONS(1301),
    [anon_sym_callableDataInNV] = ACTIONS(1301),
    [anon_sym_shaderRecordNV] = ACTIONS(1301),
    [anon_sym_layout] = ACTIONS(1301),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_subroutine] = ACTIONS(1265),
    [anon_sym_invariant] = ACTIONS(1265),
    [anon_sym_precise] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_out] = ACTIONS(1265),
    [anon_sym_inout] = ACTIONS(1265),
    [anon_sym_uniform] = ACTIONS(1265),
    [anon_sym_shared] = ACTIONS(1265),
    [anon_sym_attribute] = ACTIONS(1265),
    [anon_sym_varying] = ACTIONS(1265),
    [anon_sym_buffer] = ACTIONS(1265),
    [anon_sym_coherent] = ACTIONS(1265),
    [anon_sym_readonly] = ACTIONS(1265),
    [anon_sym_writeonly] = ACTIONS(1265),
    [anon_sym_precision] = ACTIONS(1265),
    [anon_sym_highp] = ACTIONS(1265),
    [anon_sym_mediump] = ACTIONS(1265),
    [anon_sym_lowp] = ACTIONS(1265),
    [anon_sym_centroid] = ACTIONS(1265),
    [anon_sym_sample] = ACTIONS(1265),
    [anon_sym_patch] = ACTIONS(1265),
    [anon_sym_smooth] = ACTIONS(1265),
    [anon_sym_flat] = ACTIONS(1265),
    [anon_sym_noperspective] = ACTIONS(1265),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1265),
    [anon_sym_hitAttributeEXT] = ACTIONS(1265),
    [anon_sym_callableDataEXT] = ACTIONS(1265),
    [anon_sym_callableDataInEXT] = ACTIONS(1265),
    [anon_sym_shaderRecordEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadNV] = ACTIONS(1265),
    [anon_sym_rayPayloadInNV] = ACTIONS(1265),
    [anon_sym_hitAttributeNV] = ACTIONS(1265),
    [anon_sym_callableDataNV] = ACTIONS(1265),
    [anon_sym_callableDataInNV] = ACTIONS(1265),
    [anon_sym_shaderRecordNV] = ACTIONS(1265),
    [anon_sym_layout] = ACTIONS(1265),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1381),
    [aux_sym_preproc_include_token1] = ACTIONS(1381),
    [aux_sym_preproc_def_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token2] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1381),
    [sym_preproc_directive] = ACTIONS(1381),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_subroutine] = ACTIONS(1381),
    [anon_sym_invariant] = ACTIONS(1381),
    [anon_sym_precise] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_out] = ACTIONS(1381),
    [anon_sym_inout] = ACTIONS(1381),
    [anon_sym_uniform] = ACTIONS(1381),
    [anon_sym_shared] = ACTIONS(1381),
    [anon_sym_attribute] = ACTIONS(1381),
    [anon_sym_varying] = ACTIONS(1381),
    [anon_sym_buffer] = ACTIONS(1381),
    [anon_sym_coherent] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_writeonly] = ACTIONS(1381),
    [anon_sym_precision] = ACTIONS(1381),
    [anon_sym_highp] = ACTIONS(1381),
    [anon_sym_mediump] = ACTIONS(1381),
    [anon_sym_lowp] = ACTIONS(1381),
    [anon_sym_centroid] = ACTIONS(1381),
    [anon_sym_sample] = ACTIONS(1381),
    [anon_sym_patch] = ACTIONS(1381),
    [anon_sym_smooth] = ACTIONS(1381),
    [anon_sym_flat] = ACTIONS(1381),
    [anon_sym_noperspective] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1381),
    [anon_sym_typedef] = ACTIONS(1381),
    [anon_sym_extern] = ACTIONS(1381),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1383),
    [anon_sym___declspec] = ACTIONS(1381),
    [anon_sym___cdecl] = ACTIONS(1381),
    [anon_sym___clrcall] = ACTIONS(1381),
    [anon_sym___stdcall] = ACTIONS(1381),
    [anon_sym___fastcall] = ACTIONS(1381),
    [anon_sym___thiscall] = ACTIONS(1381),
    [anon_sym___vectorcall] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_signed] = ACTIONS(1381),
    [anon_sym_unsigned] = ACTIONS(1381),
    [anon_sym_long] = ACTIONS(1381),
    [anon_sym_short] = ACTIONS(1381),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_auto] = ACTIONS(1381),
    [anon_sym_register] = ACTIONS(1381),
    [anon_sym_inline] = ACTIONS(1381),
    [anon_sym___inline] = ACTIONS(1381),
    [anon_sym___inline__] = ACTIONS(1381),
    [anon_sym___forceinline] = ACTIONS(1381),
    [anon_sym_thread_local] = ACTIONS(1381),
    [anon_sym___thread] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym___restrict__] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym__Noreturn] = ACTIONS(1381),
    [anon_sym_noreturn] = ACTIONS(1381),
    [anon_sym_alignas] = ACTIONS(1381),
    [anon_sym__Alignas] = ACTIONS(1381),
    [sym_primitive_type] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1381),
    [anon_sym_union] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_goto] = ACTIONS(1381),
    [anon_sym___try] = ACTIONS(1381),
    [anon_sym___leave] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1381),
    [anon_sym___alignof__] = ACTIONS(1381),
    [anon_sym___alignof] = ACTIONS(1381),
    [anon_sym__alignof] = ACTIONS(1381),
    [anon_sym_alignof] = ACTIONS(1381),
    [anon_sym__Alignof] = ACTIONS(1381),
    [anon_sym_offsetof] = ACTIONS(1381),
    [anon_sym__Generic] = ACTIONS(1381),
    [anon_sym_asm] = ACTIONS(1381),
    [anon_sym___asm__] = ACTIONS(1381),
    [sym_number_literal] = ACTIONS(1383),
    [anon_sym_L_SQUOTE] = ACTIONS(1383),
    [anon_sym_u_SQUOTE] = ACTIONS(1383),
    [anon_sym_U_SQUOTE] = ACTIONS(1383),
    [anon_sym_u8_SQUOTE] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1383),
    [anon_sym_L_DQUOTE] = ACTIONS(1383),
    [anon_sym_u_DQUOTE] = ACTIONS(1383),
    [anon_sym_U_DQUOTE] = ACTIONS(1383),
    [anon_sym_u8_DQUOTE] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1383),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [anon_sym_NULL] = ACTIONS(1381),
    [anon_sym_nullptr] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1381),
    [anon_sym_hitAttributeEXT] = ACTIONS(1381),
    [anon_sym_callableDataEXT] = ACTIONS(1381),
    [anon_sym_callableDataInEXT] = ACTIONS(1381),
    [anon_sym_shaderRecordEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadNV] = ACTIONS(1381),
    [anon_sym_rayPayloadInNV] = ACTIONS(1381),
    [anon_sym_hitAttributeNV] = ACTIONS(1381),
    [anon_sym_callableDataNV] = ACTIONS(1381),
    [anon_sym_callableDataInNV] = ACTIONS(1381),
    [anon_sym_shaderRecordNV] = ACTIONS(1381),
    [anon_sym_layout] = ACTIONS(1381),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1373),
    [aux_sym_preproc_include_token1] = ACTIONS(1373),
    [aux_sym_preproc_def_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token2] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1373),
    [sym_preproc_directive] = ACTIONS(1373),
    [anon_sym_LPAREN2] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_TILDE] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_subroutine] = ACTIONS(1373),
    [anon_sym_invariant] = ACTIONS(1373),
    [anon_sym_precise] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_in] = ACTIONS(1373),
    [anon_sym_out] = ACTIONS(1373),
    [anon_sym_inout] = ACTIONS(1373),
    [anon_sym_uniform] = ACTIONS(1373),
    [anon_sym_shared] = ACTIONS(1373),
    [anon_sym_attribute] = ACTIONS(1373),
    [anon_sym_varying] = ACTIONS(1373),
    [anon_sym_buffer] = ACTIONS(1373),
    [anon_sym_coherent] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_writeonly] = ACTIONS(1373),
    [anon_sym_precision] = ACTIONS(1373),
    [anon_sym_highp] = ACTIONS(1373),
    [anon_sym_mediump] = ACTIONS(1373),
    [anon_sym_lowp] = ACTIONS(1373),
    [anon_sym_centroid] = ACTIONS(1373),
    [anon_sym_sample] = ACTIONS(1373),
    [anon_sym_patch] = ACTIONS(1373),
    [anon_sym_smooth] = ACTIONS(1373),
    [anon_sym_flat] = ACTIONS(1373),
    [anon_sym_noperspective] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1373),
    [anon_sym_typedef] = ACTIONS(1373),
    [anon_sym_extern] = ACTIONS(1373),
    [anon_sym___attribute__] = ACTIONS(1373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1375),
    [anon_sym___declspec] = ACTIONS(1373),
    [anon_sym___cdecl] = ACTIONS(1373),
    [anon_sym___clrcall] = ACTIONS(1373),
    [anon_sym___stdcall] = ACTIONS(1373),
    [anon_sym___fastcall] = ACTIONS(1373),
    [anon_sym___thiscall] = ACTIONS(1373),
    [anon_sym___vectorcall] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1375),
    [anon_sym_signed] = ACTIONS(1373),
    [anon_sym_unsigned] = ACTIONS(1373),
    [anon_sym_long] = ACTIONS(1373),
    [anon_sym_short] = ACTIONS(1373),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_auto] = ACTIONS(1373),
    [anon_sym_register] = ACTIONS(1373),
    [anon_sym_inline] = ACTIONS(1373),
    [anon_sym___inline] = ACTIONS(1373),
    [anon_sym___inline__] = ACTIONS(1373),
    [anon_sym___forceinline] = ACTIONS(1373),
    [anon_sym_thread_local] = ACTIONS(1373),
    [anon_sym___thread] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_constexpr] = ACTIONS(1373),
    [anon_sym_volatile] = ACTIONS(1373),
    [anon_sym_restrict] = ACTIONS(1373),
    [anon_sym___restrict__] = ACTIONS(1373),
    [anon_sym__Atomic] = ACTIONS(1373),
    [anon_sym__Noreturn] = ACTIONS(1373),
    [anon_sym_noreturn] = ACTIONS(1373),
    [anon_sym_alignas] = ACTIONS(1373),
    [anon_sym__Alignas] = ACTIONS(1373),
    [sym_primitive_type] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1373),
    [anon_sym_union] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_goto] = ACTIONS(1373),
    [anon_sym___try] = ACTIONS(1373),
    [anon_sym___leave] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1375),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1373),
    [anon_sym___alignof] = ACTIONS(1373),
    [anon_sym__alignof] = ACTIONS(1373),
    [anon_sym_alignof] = ACTIONS(1373),
    [anon_sym__Alignof] = ACTIONS(1373),
    [anon_sym_offsetof] = ACTIONS(1373),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1373),
    [anon_sym___asm__] = ACTIONS(1373),
    [sym_number_literal] = ACTIONS(1375),
    [anon_sym_L_SQUOTE] = ACTIONS(1375),
    [anon_sym_u_SQUOTE] = ACTIONS(1375),
    [anon_sym_U_SQUOTE] = ACTIONS(1375),
    [anon_sym_u8_SQUOTE] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(1375),
    [anon_sym_L_DQUOTE] = ACTIONS(1375),
    [anon_sym_u_DQUOTE] = ACTIONS(1375),
    [anon_sym_U_DQUOTE] = ACTIONS(1375),
    [anon_sym_u8_DQUOTE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [anon_sym_NULL] = ACTIONS(1373),
    [anon_sym_nullptr] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1373),
    [anon_sym_hitAttributeEXT] = ACTIONS(1373),
    [anon_sym_callableDataEXT] = ACTIONS(1373),
    [anon_sym_callableDataInEXT] = ACTIONS(1373),
    [anon_sym_shaderRecordEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadNV] = ACTIONS(1373),
    [anon_sym_rayPayloadInNV] = ACTIONS(1373),
    [anon_sym_hitAttributeNV] = ACTIONS(1373),
    [anon_sym_callableDataNV] = ACTIONS(1373),
    [anon_sym_callableDataInNV] = ACTIONS(1373),
    [anon_sym_shaderRecordNV] = ACTIONS(1373),
    [anon_sym_layout] = ACTIONS(1373),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1355),
    [aux_sym_preproc_include_token1] = ACTIONS(1355),
    [aux_sym_preproc_def_token1] = ACTIONS(1355),
    [aux_sym_preproc_if_token1] = ACTIONS(1355),
    [aux_sym_preproc_if_token2] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1355),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1355),
    [sym_preproc_directive] = ACTIONS(1355),
    [anon_sym_LPAREN2] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_TILDE] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_subroutine] = ACTIONS(1355),
    [anon_sym_invariant] = ACTIONS(1355),
    [anon_sym_precise] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_uniform] = ACTIONS(1355),
    [anon_sym_shared] = ACTIONS(1355),
    [anon_sym_attribute] = ACTIONS(1355),
    [anon_sym_varying] = ACTIONS(1355),
    [anon_sym_buffer] = ACTIONS(1355),
    [anon_sym_coherent] = ACTIONS(1355),
    [anon_sym_readonly] = ACTIONS(1355),
    [anon_sym_writeonly] = ACTIONS(1355),
    [anon_sym_precision] = ACTIONS(1355),
    [anon_sym_highp] = ACTIONS(1355),
    [anon_sym_mediump] = ACTIONS(1355),
    [anon_sym_lowp] = ACTIONS(1355),
    [anon_sym_centroid] = ACTIONS(1355),
    [anon_sym_sample] = ACTIONS(1355),
    [anon_sym_patch] = ACTIONS(1355),
    [anon_sym_smooth] = ACTIONS(1355),
    [anon_sym_flat] = ACTIONS(1355),
    [anon_sym_noperspective] = ACTIONS(1355),
    [anon_sym___extension__] = ACTIONS(1355),
    [anon_sym_typedef] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym___attribute__] = ACTIONS(1355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1353),
    [anon_sym___declspec] = ACTIONS(1355),
    [anon_sym___cdecl] = ACTIONS(1355),
    [anon_sym___clrcall] = ACTIONS(1355),
    [anon_sym___stdcall] = ACTIONS(1355),
    [anon_sym___fastcall] = ACTIONS(1355),
    [anon_sym___thiscall] = ACTIONS(1355),
    [anon_sym___vectorcall] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_signed] = ACTIONS(1355),
    [anon_sym_unsigned] = ACTIONS(1355),
    [anon_sym_long] = ACTIONS(1355),
    [anon_sym_short] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_auto] = ACTIONS(1355),
    [anon_sym_register] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym___inline] = ACTIONS(1355),
    [anon_sym___inline__] = ACTIONS(1355),
    [anon_sym___forceinline] = ACTIONS(1355),
    [anon_sym_thread_local] = ACTIONS(1355),
    [anon_sym___thread] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_constexpr] = ACTIONS(1355),
    [anon_sym_volatile] = ACTIONS(1355),
    [anon_sym_restrict] = ACTIONS(1355),
    [anon_sym___restrict__] = ACTIONS(1355),
    [anon_sym__Atomic] = ACTIONS(1355),
    [anon_sym__Noreturn] = ACTIONS(1355),
    [anon_sym_noreturn] = ACTIONS(1355),
    [anon_sym_alignas] = ACTIONS(1355),
    [anon_sym__Alignas] = ACTIONS(1355),
    [sym_primitive_type] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_case] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_do] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_goto] = ACTIONS(1355),
    [anon_sym___try] = ACTIONS(1355),
    [anon_sym___leave] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(1353),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_sizeof] = ACTIONS(1355),
    [anon_sym___alignof__] = ACTIONS(1355),
    [anon_sym___alignof] = ACTIONS(1355),
    [anon_sym__alignof] = ACTIONS(1355),
    [anon_sym_alignof] = ACTIONS(1355),
    [anon_sym__Alignof] = ACTIONS(1355),
    [anon_sym_offsetof] = ACTIONS(1355),
    [anon_sym__Generic] = ACTIONS(1355),
    [anon_sym_asm] = ACTIONS(1355),
    [anon_sym___asm__] = ACTIONS(1355),
    [sym_number_literal] = ACTIONS(1353),
    [anon_sym_L_SQUOTE] = ACTIONS(1353),
    [anon_sym_u_SQUOTE] = ACTIONS(1353),
    [anon_sym_U_SQUOTE] = ACTIONS(1353),
    [anon_sym_u8_SQUOTE] = ACTIONS(1353),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [anon_sym_L_DQUOTE] = ACTIONS(1353),
    [anon_sym_u_DQUOTE] = ACTIONS(1353),
    [anon_sym_U_DQUOTE] = ACTIONS(1353),
    [anon_sym_u8_DQUOTE] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [anon_sym_NULL] = ACTIONS(1355),
    [anon_sym_nullptr] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1355),
    [anon_sym_hitAttributeEXT] = ACTIONS(1355),
    [anon_sym_callableDataEXT] = ACTIONS(1355),
    [anon_sym_callableDataInEXT] = ACTIONS(1355),
    [anon_sym_shaderRecordEXT] = ACTIONS(1355),
    [anon_sym_rayPayloadNV] = ACTIONS(1355),
    [anon_sym_rayPayloadInNV] = ACTIONS(1355),
    [anon_sym_hitAttributeNV] = ACTIONS(1355),
    [anon_sym_callableDataNV] = ACTIONS(1355),
    [anon_sym_callableDataInNV] = ACTIONS(1355),
    [anon_sym_shaderRecordNV] = ACTIONS(1355),
    [anon_sym_layout] = ACTIONS(1355),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token2] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_subroutine] = ACTIONS(1357),
    [anon_sym_invariant] = ACTIONS(1357),
    [anon_sym_precise] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1357),
    [anon_sym_out] = ACTIONS(1357),
    [anon_sym_inout] = ACTIONS(1357),
    [anon_sym_uniform] = ACTIONS(1357),
    [anon_sym_shared] = ACTIONS(1357),
    [anon_sym_attribute] = ACTIONS(1357),
    [anon_sym_varying] = ACTIONS(1357),
    [anon_sym_buffer] = ACTIONS(1357),
    [anon_sym_coherent] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_writeonly] = ACTIONS(1357),
    [anon_sym_precision] = ACTIONS(1357),
    [anon_sym_highp] = ACTIONS(1357),
    [anon_sym_mediump] = ACTIONS(1357),
    [anon_sym_lowp] = ACTIONS(1357),
    [anon_sym_centroid] = ACTIONS(1357),
    [anon_sym_sample] = ACTIONS(1357),
    [anon_sym_patch] = ACTIONS(1357),
    [anon_sym_smooth] = ACTIONS(1357),
    [anon_sym_flat] = ACTIONS(1357),
    [anon_sym_noperspective] = ACTIONS(1357),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1357),
    [anon_sym_hitAttributeEXT] = ACTIONS(1357),
    [anon_sym_callableDataEXT] = ACTIONS(1357),
    [anon_sym_callableDataInEXT] = ACTIONS(1357),
    [anon_sym_shaderRecordEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadNV] = ACTIONS(1357),
    [anon_sym_rayPayloadInNV] = ACTIONS(1357),
    [anon_sym_hitAttributeNV] = ACTIONS(1357),
    [anon_sym_callableDataNV] = ACTIONS(1357),
    [anon_sym_callableDataInNV] = ACTIONS(1357),
    [anon_sym_shaderRecordNV] = ACTIONS(1357),
    [anon_sym_layout] = ACTIONS(1357),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token2] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_subroutine] = ACTIONS(1265),
    [anon_sym_invariant] = ACTIONS(1265),
    [anon_sym_precise] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_out] = ACTIONS(1265),
    [anon_sym_inout] = ACTIONS(1265),
    [anon_sym_uniform] = ACTIONS(1265),
    [anon_sym_shared] = ACTIONS(1265),
    [anon_sym_attribute] = ACTIONS(1265),
    [anon_sym_varying] = ACTIONS(1265),
    [anon_sym_buffer] = ACTIONS(1265),
    [anon_sym_coherent] = ACTIONS(1265),
    [anon_sym_readonly] = ACTIONS(1265),
    [anon_sym_writeonly] = ACTIONS(1265),
    [anon_sym_precision] = ACTIONS(1265),
    [anon_sym_highp] = ACTIONS(1265),
    [anon_sym_mediump] = ACTIONS(1265),
    [anon_sym_lowp] = ACTIONS(1265),
    [anon_sym_centroid] = ACTIONS(1265),
    [anon_sym_sample] = ACTIONS(1265),
    [anon_sym_patch] = ACTIONS(1265),
    [anon_sym_smooth] = ACTIONS(1265),
    [anon_sym_flat] = ACTIONS(1265),
    [anon_sym_noperspective] = ACTIONS(1265),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1265),
    [anon_sym_hitAttributeEXT] = ACTIONS(1265),
    [anon_sym_callableDataEXT] = ACTIONS(1265),
    [anon_sym_callableDataInEXT] = ACTIONS(1265),
    [anon_sym_shaderRecordEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadNV] = ACTIONS(1265),
    [anon_sym_rayPayloadInNV] = ACTIONS(1265),
    [anon_sym_hitAttributeNV] = ACTIONS(1265),
    [anon_sym_callableDataNV] = ACTIONS(1265),
    [anon_sym_callableDataInNV] = ACTIONS(1265),
    [anon_sym_shaderRecordNV] = ACTIONS(1265),
    [anon_sym_layout] = ACTIONS(1265),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token2] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_subroutine] = ACTIONS(1349),
    [anon_sym_invariant] = ACTIONS(1349),
    [anon_sym_precise] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1349),
    [anon_sym_out] = ACTIONS(1349),
    [anon_sym_inout] = ACTIONS(1349),
    [anon_sym_uniform] = ACTIONS(1349),
    [anon_sym_shared] = ACTIONS(1349),
    [anon_sym_attribute] = ACTIONS(1349),
    [anon_sym_varying] = ACTIONS(1349),
    [anon_sym_buffer] = ACTIONS(1349),
    [anon_sym_coherent] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_writeonly] = ACTIONS(1349),
    [anon_sym_precision] = ACTIONS(1349),
    [anon_sym_highp] = ACTIONS(1349),
    [anon_sym_mediump] = ACTIONS(1349),
    [anon_sym_lowp] = ACTIONS(1349),
    [anon_sym_centroid] = ACTIONS(1349),
    [anon_sym_sample] = ACTIONS(1349),
    [anon_sym_patch] = ACTIONS(1349),
    [anon_sym_smooth] = ACTIONS(1349),
    [anon_sym_flat] = ACTIONS(1349),
    [anon_sym_noperspective] = ACTIONS(1349),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1349),
    [anon_sym_hitAttributeEXT] = ACTIONS(1349),
    [anon_sym_callableDataEXT] = ACTIONS(1349),
    [anon_sym_callableDataInEXT] = ACTIONS(1349),
    [anon_sym_shaderRecordEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadNV] = ACTIONS(1349),
    [anon_sym_rayPayloadInNV] = ACTIONS(1349),
    [anon_sym_hitAttributeNV] = ACTIONS(1349),
    [anon_sym_callableDataNV] = ACTIONS(1349),
    [anon_sym_callableDataInNV] = ACTIONS(1349),
    [anon_sym_shaderRecordNV] = ACTIONS(1349),
    [anon_sym_layout] = ACTIONS(1349),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token2] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_subroutine] = ACTIONS(1345),
    [anon_sym_invariant] = ACTIONS(1345),
    [anon_sym_precise] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_out] = ACTIONS(1345),
    [anon_sym_inout] = ACTIONS(1345),
    [anon_sym_uniform] = ACTIONS(1345),
    [anon_sym_shared] = ACTIONS(1345),
    [anon_sym_attribute] = ACTIONS(1345),
    [anon_sym_varying] = ACTIONS(1345),
    [anon_sym_buffer] = ACTIONS(1345),
    [anon_sym_coherent] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_writeonly] = ACTIONS(1345),
    [anon_sym_precision] = ACTIONS(1345),
    [anon_sym_highp] = ACTIONS(1345),
    [anon_sym_mediump] = ACTIONS(1345),
    [anon_sym_lowp] = ACTIONS(1345),
    [anon_sym_centroid] = ACTIONS(1345),
    [anon_sym_sample] = ACTIONS(1345),
    [anon_sym_patch] = ACTIONS(1345),
    [anon_sym_smooth] = ACTIONS(1345),
    [anon_sym_flat] = ACTIONS(1345),
    [anon_sym_noperspective] = ACTIONS(1345),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1345),
    [anon_sym_hitAttributeEXT] = ACTIONS(1345),
    [anon_sym_callableDataEXT] = ACTIONS(1345),
    [anon_sym_callableDataInEXT] = ACTIONS(1345),
    [anon_sym_shaderRecordEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadNV] = ACTIONS(1345),
    [anon_sym_rayPayloadInNV] = ACTIONS(1345),
    [anon_sym_hitAttributeNV] = ACTIONS(1345),
    [anon_sym_callableDataNV] = ACTIONS(1345),
    [anon_sym_callableDataInNV] = ACTIONS(1345),
    [anon_sym_shaderRecordNV] = ACTIONS(1345),
    [anon_sym_layout] = ACTIONS(1345),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token2] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_subroutine] = ACTIONS(1341),
    [anon_sym_invariant] = ACTIONS(1341),
    [anon_sym_precise] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_out] = ACTIONS(1341),
    [anon_sym_inout] = ACTIONS(1341),
    [anon_sym_uniform] = ACTIONS(1341),
    [anon_sym_shared] = ACTIONS(1341),
    [anon_sym_attribute] = ACTIONS(1341),
    [anon_sym_varying] = ACTIONS(1341),
    [anon_sym_buffer] = ACTIONS(1341),
    [anon_sym_coherent] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_writeonly] = ACTIONS(1341),
    [anon_sym_precision] = ACTIONS(1341),
    [anon_sym_highp] = ACTIONS(1341),
    [anon_sym_mediump] = ACTIONS(1341),
    [anon_sym_lowp] = ACTIONS(1341),
    [anon_sym_centroid] = ACTIONS(1341),
    [anon_sym_sample] = ACTIONS(1341),
    [anon_sym_patch] = ACTIONS(1341),
    [anon_sym_smooth] = ACTIONS(1341),
    [anon_sym_flat] = ACTIONS(1341),
    [anon_sym_noperspective] = ACTIONS(1341),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1341),
    [anon_sym_hitAttributeEXT] = ACTIONS(1341),
    [anon_sym_callableDataEXT] = ACTIONS(1341),
    [anon_sym_callableDataInEXT] = ACTIONS(1341),
    [anon_sym_shaderRecordEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadNV] = ACTIONS(1341),
    [anon_sym_rayPayloadInNV] = ACTIONS(1341),
    [anon_sym_hitAttributeNV] = ACTIONS(1341),
    [anon_sym_callableDataNV] = ACTIONS(1341),
    [anon_sym_callableDataInNV] = ACTIONS(1341),
    [anon_sym_shaderRecordNV] = ACTIONS(1341),
    [anon_sym_layout] = ACTIONS(1341),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token2] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_subroutine] = ACTIONS(1337),
    [anon_sym_invariant] = ACTIONS(1337),
    [anon_sym_precise] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1337),
    [anon_sym_out] = ACTIONS(1337),
    [anon_sym_inout] = ACTIONS(1337),
    [anon_sym_uniform] = ACTIONS(1337),
    [anon_sym_shared] = ACTIONS(1337),
    [anon_sym_attribute] = ACTIONS(1337),
    [anon_sym_varying] = ACTIONS(1337),
    [anon_sym_buffer] = ACTIONS(1337),
    [anon_sym_coherent] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_writeonly] = ACTIONS(1337),
    [anon_sym_precision] = ACTIONS(1337),
    [anon_sym_highp] = ACTIONS(1337),
    [anon_sym_mediump] = ACTIONS(1337),
    [anon_sym_lowp] = ACTIONS(1337),
    [anon_sym_centroid] = ACTIONS(1337),
    [anon_sym_sample] = ACTIONS(1337),
    [anon_sym_patch] = ACTIONS(1337),
    [anon_sym_smooth] = ACTIONS(1337),
    [anon_sym_flat] = ACTIONS(1337),
    [anon_sym_noperspective] = ACTIONS(1337),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_else] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1337),
    [anon_sym_hitAttributeEXT] = ACTIONS(1337),
    [anon_sym_callableDataEXT] = ACTIONS(1337),
    [anon_sym_callableDataInEXT] = ACTIONS(1337),
    [anon_sym_shaderRecordEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadNV] = ACTIONS(1337),
    [anon_sym_rayPayloadInNV] = ACTIONS(1337),
    [anon_sym_hitAttributeNV] = ACTIONS(1337),
    [anon_sym_callableDataNV] = ACTIONS(1337),
    [anon_sym_callableDataInNV] = ACTIONS(1337),
    [anon_sym_shaderRecordNV] = ACTIONS(1337),
    [anon_sym_layout] = ACTIONS(1337),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_subroutine] = ACTIONS(1321),
    [anon_sym_invariant] = ACTIONS(1321),
    [anon_sym_precise] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_in] = ACTIONS(1321),
    [anon_sym_out] = ACTIONS(1321),
    [anon_sym_inout] = ACTIONS(1321),
    [anon_sym_uniform] = ACTIONS(1321),
    [anon_sym_shared] = ACTIONS(1321),
    [anon_sym_attribute] = ACTIONS(1321),
    [anon_sym_varying] = ACTIONS(1321),
    [anon_sym_buffer] = ACTIONS(1321),
    [anon_sym_coherent] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_writeonly] = ACTIONS(1321),
    [anon_sym_precision] = ACTIONS(1321),
    [anon_sym_highp] = ACTIONS(1321),
    [anon_sym_mediump] = ACTIONS(1321),
    [anon_sym_lowp] = ACTIONS(1321),
    [anon_sym_centroid] = ACTIONS(1321),
    [anon_sym_sample] = ACTIONS(1321),
    [anon_sym_patch] = ACTIONS(1321),
    [anon_sym_smooth] = ACTIONS(1321),
    [anon_sym_flat] = ACTIONS(1321),
    [anon_sym_noperspective] = ACTIONS(1321),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_RBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1321),
    [anon_sym_hitAttributeEXT] = ACTIONS(1321),
    [anon_sym_callableDataEXT] = ACTIONS(1321),
    [anon_sym_callableDataInEXT] = ACTIONS(1321),
    [anon_sym_shaderRecordEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadNV] = ACTIONS(1321),
    [anon_sym_rayPayloadInNV] = ACTIONS(1321),
    [anon_sym_hitAttributeNV] = ACTIONS(1321),
    [anon_sym_callableDataNV] = ACTIONS(1321),
    [anon_sym_callableDataInNV] = ACTIONS(1321),
    [anon_sym_shaderRecordNV] = ACTIONS(1321),
    [anon_sym_layout] = ACTIONS(1321),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1381),
    [aux_sym_preproc_include_token1] = ACTIONS(1381),
    [aux_sym_preproc_def_token1] = ACTIONS(1381),
    [aux_sym_preproc_if_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1381),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1381),
    [sym_preproc_directive] = ACTIONS(1381),
    [anon_sym_LPAREN2] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_TILDE] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_subroutine] = ACTIONS(1381),
    [anon_sym_invariant] = ACTIONS(1381),
    [anon_sym_precise] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_in] = ACTIONS(1381),
    [anon_sym_out] = ACTIONS(1381),
    [anon_sym_inout] = ACTIONS(1381),
    [anon_sym_uniform] = ACTIONS(1381),
    [anon_sym_shared] = ACTIONS(1381),
    [anon_sym_attribute] = ACTIONS(1381),
    [anon_sym_varying] = ACTIONS(1381),
    [anon_sym_buffer] = ACTIONS(1381),
    [anon_sym_coherent] = ACTIONS(1381),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_writeonly] = ACTIONS(1381),
    [anon_sym_precision] = ACTIONS(1381),
    [anon_sym_highp] = ACTIONS(1381),
    [anon_sym_mediump] = ACTIONS(1381),
    [anon_sym_lowp] = ACTIONS(1381),
    [anon_sym_centroid] = ACTIONS(1381),
    [anon_sym_sample] = ACTIONS(1381),
    [anon_sym_patch] = ACTIONS(1381),
    [anon_sym_smooth] = ACTIONS(1381),
    [anon_sym_flat] = ACTIONS(1381),
    [anon_sym_noperspective] = ACTIONS(1381),
    [anon_sym___extension__] = ACTIONS(1381),
    [anon_sym_typedef] = ACTIONS(1381),
    [anon_sym_extern] = ACTIONS(1381),
    [anon_sym___attribute__] = ACTIONS(1381),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1383),
    [anon_sym___declspec] = ACTIONS(1381),
    [anon_sym___cdecl] = ACTIONS(1381),
    [anon_sym___clrcall] = ACTIONS(1381),
    [anon_sym___stdcall] = ACTIONS(1381),
    [anon_sym___fastcall] = ACTIONS(1381),
    [anon_sym___thiscall] = ACTIONS(1381),
    [anon_sym___vectorcall] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_signed] = ACTIONS(1381),
    [anon_sym_unsigned] = ACTIONS(1381),
    [anon_sym_long] = ACTIONS(1381),
    [anon_sym_short] = ACTIONS(1381),
    [anon_sym_static] = ACTIONS(1381),
    [anon_sym_auto] = ACTIONS(1381),
    [anon_sym_register] = ACTIONS(1381),
    [anon_sym_inline] = ACTIONS(1381),
    [anon_sym___inline] = ACTIONS(1381),
    [anon_sym___inline__] = ACTIONS(1381),
    [anon_sym___forceinline] = ACTIONS(1381),
    [anon_sym_thread_local] = ACTIONS(1381),
    [anon_sym___thread] = ACTIONS(1381),
    [anon_sym_const] = ACTIONS(1381),
    [anon_sym_constexpr] = ACTIONS(1381),
    [anon_sym_volatile] = ACTIONS(1381),
    [anon_sym_restrict] = ACTIONS(1381),
    [anon_sym___restrict__] = ACTIONS(1381),
    [anon_sym__Atomic] = ACTIONS(1381),
    [anon_sym__Noreturn] = ACTIONS(1381),
    [anon_sym_noreturn] = ACTIONS(1381),
    [anon_sym_alignas] = ACTIONS(1381),
    [anon_sym__Alignas] = ACTIONS(1381),
    [sym_primitive_type] = ACTIONS(1381),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1381),
    [anon_sym_union] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1381),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1381),
    [anon_sym_case] = ACTIONS(1381),
    [anon_sym_default] = ACTIONS(1381),
    [anon_sym_while] = ACTIONS(1381),
    [anon_sym_do] = ACTIONS(1381),
    [anon_sym_for] = ACTIONS(1381),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_break] = ACTIONS(1381),
    [anon_sym_continue] = ACTIONS(1381),
    [anon_sym_goto] = ACTIONS(1381),
    [anon_sym___try] = ACTIONS(1381),
    [anon_sym___leave] = ACTIONS(1381),
    [anon_sym_DASH_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1383),
    [anon_sym_sizeof] = ACTIONS(1381),
    [anon_sym___alignof__] = ACTIONS(1381),
    [anon_sym___alignof] = ACTIONS(1381),
    [anon_sym__alignof] = ACTIONS(1381),
    [anon_sym_alignof] = ACTIONS(1381),
    [anon_sym__Alignof] = ACTIONS(1381),
    [anon_sym_offsetof] = ACTIONS(1381),
    [anon_sym__Generic] = ACTIONS(1381),
    [anon_sym_asm] = ACTIONS(1381),
    [anon_sym___asm__] = ACTIONS(1381),
    [sym_number_literal] = ACTIONS(1383),
    [anon_sym_L_SQUOTE] = ACTIONS(1383),
    [anon_sym_u_SQUOTE] = ACTIONS(1383),
    [anon_sym_U_SQUOTE] = ACTIONS(1383),
    [anon_sym_u8_SQUOTE] = ACTIONS(1383),
    [anon_sym_SQUOTE] = ACTIONS(1383),
    [anon_sym_L_DQUOTE] = ACTIONS(1383),
    [anon_sym_u_DQUOTE] = ACTIONS(1383),
    [anon_sym_U_DQUOTE] = ACTIONS(1383),
    [anon_sym_u8_DQUOTE] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1383),
    [sym_true] = ACTIONS(1381),
    [sym_false] = ACTIONS(1381),
    [anon_sym_NULL] = ACTIONS(1381),
    [anon_sym_nullptr] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1381),
    [anon_sym_hitAttributeEXT] = ACTIONS(1381),
    [anon_sym_callableDataEXT] = ACTIONS(1381),
    [anon_sym_callableDataInEXT] = ACTIONS(1381),
    [anon_sym_shaderRecordEXT] = ACTIONS(1381),
    [anon_sym_rayPayloadNV] = ACTIONS(1381),
    [anon_sym_rayPayloadInNV] = ACTIONS(1381),
    [anon_sym_hitAttributeNV] = ACTIONS(1381),
    [anon_sym_callableDataNV] = ACTIONS(1381),
    [anon_sym_callableDataInNV] = ACTIONS(1381),
    [anon_sym_shaderRecordNV] = ACTIONS(1381),
    [anon_sym_layout] = ACTIONS(1381),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1373),
    [aux_sym_preproc_include_token1] = ACTIONS(1373),
    [aux_sym_preproc_def_token1] = ACTIONS(1373),
    [aux_sym_preproc_if_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1373),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1373),
    [sym_preproc_directive] = ACTIONS(1373),
    [anon_sym_LPAREN2] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_TILDE] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_subroutine] = ACTIONS(1373),
    [anon_sym_invariant] = ACTIONS(1373),
    [anon_sym_precise] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1375),
    [anon_sym_in] = ACTIONS(1373),
    [anon_sym_out] = ACTIONS(1373),
    [anon_sym_inout] = ACTIONS(1373),
    [anon_sym_uniform] = ACTIONS(1373),
    [anon_sym_shared] = ACTIONS(1373),
    [anon_sym_attribute] = ACTIONS(1373),
    [anon_sym_varying] = ACTIONS(1373),
    [anon_sym_buffer] = ACTIONS(1373),
    [anon_sym_coherent] = ACTIONS(1373),
    [anon_sym_readonly] = ACTIONS(1373),
    [anon_sym_writeonly] = ACTIONS(1373),
    [anon_sym_precision] = ACTIONS(1373),
    [anon_sym_highp] = ACTIONS(1373),
    [anon_sym_mediump] = ACTIONS(1373),
    [anon_sym_lowp] = ACTIONS(1373),
    [anon_sym_centroid] = ACTIONS(1373),
    [anon_sym_sample] = ACTIONS(1373),
    [anon_sym_patch] = ACTIONS(1373),
    [anon_sym_smooth] = ACTIONS(1373),
    [anon_sym_flat] = ACTIONS(1373),
    [anon_sym_noperspective] = ACTIONS(1373),
    [anon_sym___extension__] = ACTIONS(1373),
    [anon_sym_typedef] = ACTIONS(1373),
    [anon_sym_extern] = ACTIONS(1373),
    [anon_sym___attribute__] = ACTIONS(1373),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1375),
    [anon_sym___declspec] = ACTIONS(1373),
    [anon_sym___cdecl] = ACTIONS(1373),
    [anon_sym___clrcall] = ACTIONS(1373),
    [anon_sym___stdcall] = ACTIONS(1373),
    [anon_sym___fastcall] = ACTIONS(1373),
    [anon_sym___thiscall] = ACTIONS(1373),
    [anon_sym___vectorcall] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1375),
    [anon_sym_RBRACE] = ACTIONS(1375),
    [anon_sym_signed] = ACTIONS(1373),
    [anon_sym_unsigned] = ACTIONS(1373),
    [anon_sym_long] = ACTIONS(1373),
    [anon_sym_short] = ACTIONS(1373),
    [anon_sym_static] = ACTIONS(1373),
    [anon_sym_auto] = ACTIONS(1373),
    [anon_sym_register] = ACTIONS(1373),
    [anon_sym_inline] = ACTIONS(1373),
    [anon_sym___inline] = ACTIONS(1373),
    [anon_sym___inline__] = ACTIONS(1373),
    [anon_sym___forceinline] = ACTIONS(1373),
    [anon_sym_thread_local] = ACTIONS(1373),
    [anon_sym___thread] = ACTIONS(1373),
    [anon_sym_const] = ACTIONS(1373),
    [anon_sym_constexpr] = ACTIONS(1373),
    [anon_sym_volatile] = ACTIONS(1373),
    [anon_sym_restrict] = ACTIONS(1373),
    [anon_sym___restrict__] = ACTIONS(1373),
    [anon_sym__Atomic] = ACTIONS(1373),
    [anon_sym__Noreturn] = ACTIONS(1373),
    [anon_sym_noreturn] = ACTIONS(1373),
    [anon_sym_alignas] = ACTIONS(1373),
    [anon_sym__Alignas] = ACTIONS(1373),
    [sym_primitive_type] = ACTIONS(1373),
    [anon_sym_enum] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1373),
    [anon_sym_union] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1373),
    [anon_sym_case] = ACTIONS(1373),
    [anon_sym_default] = ACTIONS(1373),
    [anon_sym_while] = ACTIONS(1373),
    [anon_sym_do] = ACTIONS(1373),
    [anon_sym_for] = ACTIONS(1373),
    [anon_sym_return] = ACTIONS(1373),
    [anon_sym_break] = ACTIONS(1373),
    [anon_sym_continue] = ACTIONS(1373),
    [anon_sym_goto] = ACTIONS(1373),
    [anon_sym___try] = ACTIONS(1373),
    [anon_sym___leave] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1375),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1373),
    [anon_sym___alignof] = ACTIONS(1373),
    [anon_sym__alignof] = ACTIONS(1373),
    [anon_sym_alignof] = ACTIONS(1373),
    [anon_sym__Alignof] = ACTIONS(1373),
    [anon_sym_offsetof] = ACTIONS(1373),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1373),
    [anon_sym___asm__] = ACTIONS(1373),
    [sym_number_literal] = ACTIONS(1375),
    [anon_sym_L_SQUOTE] = ACTIONS(1375),
    [anon_sym_u_SQUOTE] = ACTIONS(1375),
    [anon_sym_U_SQUOTE] = ACTIONS(1375),
    [anon_sym_u8_SQUOTE] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(1375),
    [anon_sym_L_DQUOTE] = ACTIONS(1375),
    [anon_sym_u_DQUOTE] = ACTIONS(1375),
    [anon_sym_U_DQUOTE] = ACTIONS(1375),
    [anon_sym_u8_DQUOTE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [anon_sym_NULL] = ACTIONS(1373),
    [anon_sym_nullptr] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1373),
    [anon_sym_hitAttributeEXT] = ACTIONS(1373),
    [anon_sym_callableDataEXT] = ACTIONS(1373),
    [anon_sym_callableDataInEXT] = ACTIONS(1373),
    [anon_sym_shaderRecordEXT] = ACTIONS(1373),
    [anon_sym_rayPayloadNV] = ACTIONS(1373),
    [anon_sym_rayPayloadInNV] = ACTIONS(1373),
    [anon_sym_hitAttributeNV] = ACTIONS(1373),
    [anon_sym_callableDataNV] = ACTIONS(1373),
    [anon_sym_callableDataInNV] = ACTIONS(1373),
    [anon_sym_shaderRecordNV] = ACTIONS(1373),
    [anon_sym_layout] = ACTIONS(1373),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token2] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1269),
    [aux_sym_preproc_include_token1] = ACTIONS(1269),
    [aux_sym_preproc_def_token1] = ACTIONS(1269),
    [aux_sym_preproc_if_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1269),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1269),
    [sym_preproc_directive] = ACTIONS(1269),
    [anon_sym_LPAREN2] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_subroutine] = ACTIONS(1269),
    [anon_sym_invariant] = ACTIONS(1269),
    [anon_sym_precise] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_in] = ACTIONS(1269),
    [anon_sym_out] = ACTIONS(1269),
    [anon_sym_inout] = ACTIONS(1269),
    [anon_sym_uniform] = ACTIONS(1269),
    [anon_sym_shared] = ACTIONS(1269),
    [anon_sym_attribute] = ACTIONS(1269),
    [anon_sym_varying] = ACTIONS(1269),
    [anon_sym_buffer] = ACTIONS(1269),
    [anon_sym_coherent] = ACTIONS(1269),
    [anon_sym_readonly] = ACTIONS(1269),
    [anon_sym_writeonly] = ACTIONS(1269),
    [anon_sym_precision] = ACTIONS(1269),
    [anon_sym_highp] = ACTIONS(1269),
    [anon_sym_mediump] = ACTIONS(1269),
    [anon_sym_lowp] = ACTIONS(1269),
    [anon_sym_centroid] = ACTIONS(1269),
    [anon_sym_sample] = ACTIONS(1269),
    [anon_sym_patch] = ACTIONS(1269),
    [anon_sym_smooth] = ACTIONS(1269),
    [anon_sym_flat] = ACTIONS(1269),
    [anon_sym_noperspective] = ACTIONS(1269),
    [anon_sym___extension__] = ACTIONS(1269),
    [anon_sym_typedef] = ACTIONS(1269),
    [anon_sym_extern] = ACTIONS(1269),
    [anon_sym___attribute__] = ACTIONS(1269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1271),
    [anon_sym___declspec] = ACTIONS(1269),
    [anon_sym___cdecl] = ACTIONS(1269),
    [anon_sym___clrcall] = ACTIONS(1269),
    [anon_sym___stdcall] = ACTIONS(1269),
    [anon_sym___fastcall] = ACTIONS(1269),
    [anon_sym___thiscall] = ACTIONS(1269),
    [anon_sym___vectorcall] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_signed] = ACTIONS(1269),
    [anon_sym_unsigned] = ACTIONS(1269),
    [anon_sym_long] = ACTIONS(1269),
    [anon_sym_short] = ACTIONS(1269),
    [anon_sym_static] = ACTIONS(1269),
    [anon_sym_auto] = ACTIONS(1269),
    [anon_sym_register] = ACTIONS(1269),
    [anon_sym_inline] = ACTIONS(1269),
    [anon_sym___inline] = ACTIONS(1269),
    [anon_sym___inline__] = ACTIONS(1269),
    [anon_sym___forceinline] = ACTIONS(1269),
    [anon_sym_thread_local] = ACTIONS(1269),
    [anon_sym___thread] = ACTIONS(1269),
    [anon_sym_const] = ACTIONS(1269),
    [anon_sym_constexpr] = ACTIONS(1269),
    [anon_sym_volatile] = ACTIONS(1269),
    [anon_sym_restrict] = ACTIONS(1269),
    [anon_sym___restrict__] = ACTIONS(1269),
    [anon_sym__Atomic] = ACTIONS(1269),
    [anon_sym__Noreturn] = ACTIONS(1269),
    [anon_sym_noreturn] = ACTIONS(1269),
    [anon_sym_alignas] = ACTIONS(1269),
    [anon_sym__Alignas] = ACTIONS(1269),
    [sym_primitive_type] = ACTIONS(1269),
    [anon_sym_enum] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1269),
    [anon_sym_union] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1269),
    [anon_sym_case] = ACTIONS(1269),
    [anon_sym_default] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_do] = ACTIONS(1269),
    [anon_sym_for] = ACTIONS(1269),
    [anon_sym_return] = ACTIONS(1269),
    [anon_sym_break] = ACTIONS(1269),
    [anon_sym_continue] = ACTIONS(1269),
    [anon_sym_goto] = ACTIONS(1269),
    [anon_sym___try] = ACTIONS(1269),
    [anon_sym___leave] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_sizeof] = ACTIONS(1269),
    [anon_sym___alignof__] = ACTIONS(1269),
    [anon_sym___alignof] = ACTIONS(1269),
    [anon_sym__alignof] = ACTIONS(1269),
    [anon_sym_alignof] = ACTIONS(1269),
    [anon_sym__Alignof] = ACTIONS(1269),
    [anon_sym_offsetof] = ACTIONS(1269),
    [anon_sym__Generic] = ACTIONS(1269),
    [anon_sym_asm] = ACTIONS(1269),
    [anon_sym___asm__] = ACTIONS(1269),
    [sym_number_literal] = ACTIONS(1271),
    [anon_sym_L_SQUOTE] = ACTIONS(1271),
    [anon_sym_u_SQUOTE] = ACTIONS(1271),
    [anon_sym_U_SQUOTE] = ACTIONS(1271),
    [anon_sym_u8_SQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [anon_sym_L_DQUOTE] = ACTIONS(1271),
    [anon_sym_u_DQUOTE] = ACTIONS(1271),
    [anon_sym_U_DQUOTE] = ACTIONS(1271),
    [anon_sym_u8_DQUOTE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_true] = ACTIONS(1269),
    [sym_false] = ACTIONS(1269),
    [anon_sym_NULL] = ACTIONS(1269),
    [anon_sym_nullptr] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1269),
    [anon_sym_hitAttributeEXT] = ACTIONS(1269),
    [anon_sym_callableDataEXT] = ACTIONS(1269),
    [anon_sym_callableDataInEXT] = ACTIONS(1269),
    [anon_sym_shaderRecordEXT] = ACTIONS(1269),
    [anon_sym_rayPayloadNV] = ACTIONS(1269),
    [anon_sym_rayPayloadInNV] = ACTIONS(1269),
    [anon_sym_hitAttributeNV] = ACTIONS(1269),
    [anon_sym_callableDataNV] = ACTIONS(1269),
    [anon_sym_callableDataInNV] = ACTIONS(1269),
    [anon_sym_shaderRecordNV] = ACTIONS(1269),
    [anon_sym_layout] = ACTIONS(1269),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1265),
    [aux_sym_preproc_include_token1] = ACTIONS(1265),
    [aux_sym_preproc_def_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token1] = ACTIONS(1265),
    [aux_sym_preproc_if_token2] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1265),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1265),
    [sym_preproc_directive] = ACTIONS(1265),
    [anon_sym_LPAREN2] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_subroutine] = ACTIONS(1265),
    [anon_sym_invariant] = ACTIONS(1265),
    [anon_sym_precise] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_out] = ACTIONS(1265),
    [anon_sym_inout] = ACTIONS(1265),
    [anon_sym_uniform] = ACTIONS(1265),
    [anon_sym_shared] = ACTIONS(1265),
    [anon_sym_attribute] = ACTIONS(1265),
    [anon_sym_varying] = ACTIONS(1265),
    [anon_sym_buffer] = ACTIONS(1265),
    [anon_sym_coherent] = ACTIONS(1265),
    [anon_sym_readonly] = ACTIONS(1265),
    [anon_sym_writeonly] = ACTIONS(1265),
    [anon_sym_precision] = ACTIONS(1265),
    [anon_sym_highp] = ACTIONS(1265),
    [anon_sym_mediump] = ACTIONS(1265),
    [anon_sym_lowp] = ACTIONS(1265),
    [anon_sym_centroid] = ACTIONS(1265),
    [anon_sym_sample] = ACTIONS(1265),
    [anon_sym_patch] = ACTIONS(1265),
    [anon_sym_smooth] = ACTIONS(1265),
    [anon_sym_flat] = ACTIONS(1265),
    [anon_sym_noperspective] = ACTIONS(1265),
    [anon_sym___extension__] = ACTIONS(1265),
    [anon_sym_typedef] = ACTIONS(1265),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym___attribute__] = ACTIONS(1265),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1267),
    [anon_sym___declspec] = ACTIONS(1265),
    [anon_sym___cdecl] = ACTIONS(1265),
    [anon_sym___clrcall] = ACTIONS(1265),
    [anon_sym___stdcall] = ACTIONS(1265),
    [anon_sym___fastcall] = ACTIONS(1265),
    [anon_sym___thiscall] = ACTIONS(1265),
    [anon_sym___vectorcall] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_signed] = ACTIONS(1265),
    [anon_sym_unsigned] = ACTIONS(1265),
    [anon_sym_long] = ACTIONS(1265),
    [anon_sym_short] = ACTIONS(1265),
    [anon_sym_static] = ACTIONS(1265),
    [anon_sym_auto] = ACTIONS(1265),
    [anon_sym_register] = ACTIONS(1265),
    [anon_sym_inline] = ACTIONS(1265),
    [anon_sym___inline] = ACTIONS(1265),
    [anon_sym___inline__] = ACTIONS(1265),
    [anon_sym___forceinline] = ACTIONS(1265),
    [anon_sym_thread_local] = ACTIONS(1265),
    [anon_sym___thread] = ACTIONS(1265),
    [anon_sym_const] = ACTIONS(1265),
    [anon_sym_constexpr] = ACTIONS(1265),
    [anon_sym_volatile] = ACTIONS(1265),
    [anon_sym_restrict] = ACTIONS(1265),
    [anon_sym___restrict__] = ACTIONS(1265),
    [anon_sym__Atomic] = ACTIONS(1265),
    [anon_sym__Noreturn] = ACTIONS(1265),
    [anon_sym_noreturn] = ACTIONS(1265),
    [anon_sym_alignas] = ACTIONS(1265),
    [anon_sym__Alignas] = ACTIONS(1265),
    [sym_primitive_type] = ACTIONS(1265),
    [anon_sym_enum] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1265),
    [anon_sym_union] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_continue] = ACTIONS(1265),
    [anon_sym_goto] = ACTIONS(1265),
    [anon_sym___try] = ACTIONS(1265),
    [anon_sym___leave] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_sizeof] = ACTIONS(1265),
    [anon_sym___alignof__] = ACTIONS(1265),
    [anon_sym___alignof] = ACTIONS(1265),
    [anon_sym__alignof] = ACTIONS(1265),
    [anon_sym_alignof] = ACTIONS(1265),
    [anon_sym__Alignof] = ACTIONS(1265),
    [anon_sym_offsetof] = ACTIONS(1265),
    [anon_sym__Generic] = ACTIONS(1265),
    [anon_sym_asm] = ACTIONS(1265),
    [anon_sym___asm__] = ACTIONS(1265),
    [sym_number_literal] = ACTIONS(1267),
    [anon_sym_L_SQUOTE] = ACTIONS(1267),
    [anon_sym_u_SQUOTE] = ACTIONS(1267),
    [anon_sym_U_SQUOTE] = ACTIONS(1267),
    [anon_sym_u8_SQUOTE] = ACTIONS(1267),
    [anon_sym_SQUOTE] = ACTIONS(1267),
    [anon_sym_L_DQUOTE] = ACTIONS(1267),
    [anon_sym_u_DQUOTE] = ACTIONS(1267),
    [anon_sym_U_DQUOTE] = ACTIONS(1267),
    [anon_sym_u8_DQUOTE] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1267),
    [sym_true] = ACTIONS(1265),
    [sym_false] = ACTIONS(1265),
    [anon_sym_NULL] = ACTIONS(1265),
    [anon_sym_nullptr] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1265),
    [anon_sym_hitAttributeEXT] = ACTIONS(1265),
    [anon_sym_callableDataEXT] = ACTIONS(1265),
    [anon_sym_callableDataInEXT] = ACTIONS(1265),
    [anon_sym_shaderRecordEXT] = ACTIONS(1265),
    [anon_sym_rayPayloadNV] = ACTIONS(1265),
    [anon_sym_rayPayloadInNV] = ACTIONS(1265),
    [anon_sym_hitAttributeNV] = ACTIONS(1265),
    [anon_sym_callableDataNV] = ACTIONS(1265),
    [anon_sym_callableDataInNV] = ACTIONS(1265),
    [anon_sym_shaderRecordNV] = ACTIONS(1265),
    [anon_sym_layout] = ACTIONS(1265),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1331),
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_subroutine] = ACTIONS(1329),
    [anon_sym_invariant] = ACTIONS(1329),
    [anon_sym_precise] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1329),
    [anon_sym_out] = ACTIONS(1329),
    [anon_sym_inout] = ACTIONS(1329),
    [anon_sym_uniform] = ACTIONS(1329),
    [anon_sym_shared] = ACTIONS(1329),
    [anon_sym_attribute] = ACTIONS(1329),
    [anon_sym_varying] = ACTIONS(1329),
    [anon_sym_buffer] = ACTIONS(1329),
    [anon_sym_coherent] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(1329),
    [anon_sym_writeonly] = ACTIONS(1329),
    [anon_sym_precision] = ACTIONS(1329),
    [anon_sym_highp] = ACTIONS(1329),
    [anon_sym_mediump] = ACTIONS(1329),
    [anon_sym_lowp] = ACTIONS(1329),
    [anon_sym_centroid] = ACTIONS(1329),
    [anon_sym_sample] = ACTIONS(1329),
    [anon_sym_patch] = ACTIONS(1329),
    [anon_sym_smooth] = ACTIONS(1329),
    [anon_sym_flat] = ACTIONS(1329),
    [anon_sym_noperspective] = ACTIONS(1329),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1329),
    [anon_sym_hitAttributeEXT] = ACTIONS(1329),
    [anon_sym_callableDataEXT] = ACTIONS(1329),
    [anon_sym_callableDataInEXT] = ACTIONS(1329),
    [anon_sym_shaderRecordEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadNV] = ACTIONS(1329),
    [anon_sym_rayPayloadInNV] = ACTIONS(1329),
    [anon_sym_hitAttributeNV] = ACTIONS(1329),
    [anon_sym_callableDataNV] = ACTIONS(1329),
    [anon_sym_callableDataInNV] = ACTIONS(1329),
    [anon_sym_shaderRecordNV] = ACTIONS(1329),
    [anon_sym_layout] = ACTIONS(1329),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token2] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_subroutine] = ACTIONS(1289),
    [anon_sym_invariant] = ACTIONS(1289),
    [anon_sym_precise] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1289),
    [anon_sym_out] = ACTIONS(1289),
    [anon_sym_inout] = ACTIONS(1289),
    [anon_sym_uniform] = ACTIONS(1289),
    [anon_sym_shared] = ACTIONS(1289),
    [anon_sym_attribute] = ACTIONS(1289),
    [anon_sym_varying] = ACTIONS(1289),
    [anon_sym_buffer] = ACTIONS(1289),
    [anon_sym_coherent] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_writeonly] = ACTIONS(1289),
    [anon_sym_precision] = ACTIONS(1289),
    [anon_sym_highp] = ACTIONS(1289),
    [anon_sym_mediump] = ACTIONS(1289),
    [anon_sym_lowp] = ACTIONS(1289),
    [anon_sym_centroid] = ACTIONS(1289),
    [anon_sym_sample] = ACTIONS(1289),
    [anon_sym_patch] = ACTIONS(1289),
    [anon_sym_smooth] = ACTIONS(1289),
    [anon_sym_flat] = ACTIONS(1289),
    [anon_sym_noperspective] = ACTIONS(1289),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_else] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1289),
    [anon_sym_hitAttributeEXT] = ACTIONS(1289),
    [anon_sym_callableDataEXT] = ACTIONS(1289),
    [anon_sym_callableDataInEXT] = ACTIONS(1289),
    [anon_sym_shaderRecordEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadNV] = ACTIONS(1289),
    [anon_sym_rayPayloadInNV] = ACTIONS(1289),
    [anon_sym_hitAttributeNV] = ACTIONS(1289),
    [anon_sym_callableDataNV] = ACTIONS(1289),
    [anon_sym_callableDataInNV] = ACTIONS(1289),
    [anon_sym_shaderRecordNV] = ACTIONS(1289),
    [anon_sym_layout] = ACTIONS(1289),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_subroutine] = ACTIONS(1349),
    [anon_sym_invariant] = ACTIONS(1349),
    [anon_sym_precise] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1349),
    [anon_sym_out] = ACTIONS(1349),
    [anon_sym_inout] = ACTIONS(1349),
    [anon_sym_uniform] = ACTIONS(1349),
    [anon_sym_shared] = ACTIONS(1349),
    [anon_sym_attribute] = ACTIONS(1349),
    [anon_sym_varying] = ACTIONS(1349),
    [anon_sym_buffer] = ACTIONS(1349),
    [anon_sym_coherent] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_writeonly] = ACTIONS(1349),
    [anon_sym_precision] = ACTIONS(1349),
    [anon_sym_highp] = ACTIONS(1349),
    [anon_sym_mediump] = ACTIONS(1349),
    [anon_sym_lowp] = ACTIONS(1349),
    [anon_sym_centroid] = ACTIONS(1349),
    [anon_sym_sample] = ACTIONS(1349),
    [anon_sym_patch] = ACTIONS(1349),
    [anon_sym_smooth] = ACTIONS(1349),
    [anon_sym_flat] = ACTIONS(1349),
    [anon_sym_noperspective] = ACTIONS(1349),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1349),
    [anon_sym_hitAttributeEXT] = ACTIONS(1349),
    [anon_sym_callableDataEXT] = ACTIONS(1349),
    [anon_sym_callableDataInEXT] = ACTIONS(1349),
    [anon_sym_shaderRecordEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadNV] = ACTIONS(1349),
    [anon_sym_rayPayloadInNV] = ACTIONS(1349),
    [anon_sym_hitAttributeNV] = ACTIONS(1349),
    [anon_sym_callableDataNV] = ACTIONS(1349),
    [anon_sym_callableDataInNV] = ACTIONS(1349),
    [anon_sym_shaderRecordNV] = ACTIONS(1349),
    [anon_sym_layout] = ACTIONS(1349),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token2] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_subroutine] = ACTIONS(1281),
    [anon_sym_invariant] = ACTIONS(1281),
    [anon_sym_precise] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1281),
    [anon_sym_out] = ACTIONS(1281),
    [anon_sym_inout] = ACTIONS(1281),
    [anon_sym_uniform] = ACTIONS(1281),
    [anon_sym_shared] = ACTIONS(1281),
    [anon_sym_attribute] = ACTIONS(1281),
    [anon_sym_varying] = ACTIONS(1281),
    [anon_sym_buffer] = ACTIONS(1281),
    [anon_sym_coherent] = ACTIONS(1281),
    [anon_sym_readonly] = ACTIONS(1281),
    [anon_sym_writeonly] = ACTIONS(1281),
    [anon_sym_precision] = ACTIONS(1281),
    [anon_sym_highp] = ACTIONS(1281),
    [anon_sym_mediump] = ACTIONS(1281),
    [anon_sym_lowp] = ACTIONS(1281),
    [anon_sym_centroid] = ACTIONS(1281),
    [anon_sym_sample] = ACTIONS(1281),
    [anon_sym_patch] = ACTIONS(1281),
    [anon_sym_smooth] = ACTIONS(1281),
    [anon_sym_flat] = ACTIONS(1281),
    [anon_sym_noperspective] = ACTIONS(1281),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_else] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1281),
    [anon_sym_hitAttributeEXT] = ACTIONS(1281),
    [anon_sym_callableDataEXT] = ACTIONS(1281),
    [anon_sym_callableDataInEXT] = ACTIONS(1281),
    [anon_sym_shaderRecordEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadNV] = ACTIONS(1281),
    [anon_sym_rayPayloadInNV] = ACTIONS(1281),
    [anon_sym_hitAttributeNV] = ACTIONS(1281),
    [anon_sym_callableDataNV] = ACTIONS(1281),
    [anon_sym_callableDataInNV] = ACTIONS(1281),
    [anon_sym_shaderRecordNV] = ACTIONS(1281),
    [anon_sym_layout] = ACTIONS(1281),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_subroutine] = ACTIONS(1261),
    [anon_sym_invariant] = ACTIONS(1261),
    [anon_sym_precise] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_out] = ACTIONS(1261),
    [anon_sym_inout] = ACTIONS(1261),
    [anon_sym_uniform] = ACTIONS(1261),
    [anon_sym_shared] = ACTIONS(1261),
    [anon_sym_attribute] = ACTIONS(1261),
    [anon_sym_varying] = ACTIONS(1261),
    [anon_sym_buffer] = ACTIONS(1261),
    [anon_sym_coherent] = ACTIONS(1261),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_writeonly] = ACTIONS(1261),
    [anon_sym_precision] = ACTIONS(1261),
    [anon_sym_highp] = ACTIONS(1261),
    [anon_sym_mediump] = ACTIONS(1261),
    [anon_sym_lowp] = ACTIONS(1261),
    [anon_sym_centroid] = ACTIONS(1261),
    [anon_sym_sample] = ACTIONS(1261),
    [anon_sym_patch] = ACTIONS(1261),
    [anon_sym_smooth] = ACTIONS(1261),
    [anon_sym_flat] = ACTIONS(1261),
    [anon_sym_noperspective] = ACTIONS(1261),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1261),
    [anon_sym_hitAttributeEXT] = ACTIONS(1261),
    [anon_sym_callableDataEXT] = ACTIONS(1261),
    [anon_sym_callableDataInEXT] = ACTIONS(1261),
    [anon_sym_shaderRecordEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadNV] = ACTIONS(1261),
    [anon_sym_rayPayloadInNV] = ACTIONS(1261),
    [anon_sym_hitAttributeNV] = ACTIONS(1261),
    [anon_sym_callableDataNV] = ACTIONS(1261),
    [anon_sym_callableDataInNV] = ACTIONS(1261),
    [anon_sym_shaderRecordNV] = ACTIONS(1261),
    [anon_sym_layout] = ACTIONS(1261),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1283),
    [sym_identifier] = ACTIONS(1281),
    [aux_sym_preproc_include_token1] = ACTIONS(1281),
    [aux_sym_preproc_def_token1] = ACTIONS(1281),
    [aux_sym_preproc_if_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1281),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1281),
    [sym_preproc_directive] = ACTIONS(1281),
    [anon_sym_LPAREN2] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_TILDE] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1281),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_subroutine] = ACTIONS(1281),
    [anon_sym_invariant] = ACTIONS(1281),
    [anon_sym_precise] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1281),
    [anon_sym_out] = ACTIONS(1281),
    [anon_sym_inout] = ACTIONS(1281),
    [anon_sym_uniform] = ACTIONS(1281),
    [anon_sym_shared] = ACTIONS(1281),
    [anon_sym_attribute] = ACTIONS(1281),
    [anon_sym_varying] = ACTIONS(1281),
    [anon_sym_buffer] = ACTIONS(1281),
    [anon_sym_coherent] = ACTIONS(1281),
    [anon_sym_readonly] = ACTIONS(1281),
    [anon_sym_writeonly] = ACTIONS(1281),
    [anon_sym_precision] = ACTIONS(1281),
    [anon_sym_highp] = ACTIONS(1281),
    [anon_sym_mediump] = ACTIONS(1281),
    [anon_sym_lowp] = ACTIONS(1281),
    [anon_sym_centroid] = ACTIONS(1281),
    [anon_sym_sample] = ACTIONS(1281),
    [anon_sym_patch] = ACTIONS(1281),
    [anon_sym_smooth] = ACTIONS(1281),
    [anon_sym_flat] = ACTIONS(1281),
    [anon_sym_noperspective] = ACTIONS(1281),
    [anon_sym___extension__] = ACTIONS(1281),
    [anon_sym_typedef] = ACTIONS(1281),
    [anon_sym_extern] = ACTIONS(1281),
    [anon_sym___attribute__] = ACTIONS(1281),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1283),
    [anon_sym___declspec] = ACTIONS(1281),
    [anon_sym___cdecl] = ACTIONS(1281),
    [anon_sym___clrcall] = ACTIONS(1281),
    [anon_sym___stdcall] = ACTIONS(1281),
    [anon_sym___fastcall] = ACTIONS(1281),
    [anon_sym___thiscall] = ACTIONS(1281),
    [anon_sym___vectorcall] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_signed] = ACTIONS(1281),
    [anon_sym_unsigned] = ACTIONS(1281),
    [anon_sym_long] = ACTIONS(1281),
    [anon_sym_short] = ACTIONS(1281),
    [anon_sym_static] = ACTIONS(1281),
    [anon_sym_auto] = ACTIONS(1281),
    [anon_sym_register] = ACTIONS(1281),
    [anon_sym_inline] = ACTIONS(1281),
    [anon_sym___inline] = ACTIONS(1281),
    [anon_sym___inline__] = ACTIONS(1281),
    [anon_sym___forceinline] = ACTIONS(1281),
    [anon_sym_thread_local] = ACTIONS(1281),
    [anon_sym___thread] = ACTIONS(1281),
    [anon_sym_const] = ACTIONS(1281),
    [anon_sym_constexpr] = ACTIONS(1281),
    [anon_sym_volatile] = ACTIONS(1281),
    [anon_sym_restrict] = ACTIONS(1281),
    [anon_sym___restrict__] = ACTIONS(1281),
    [anon_sym__Atomic] = ACTIONS(1281),
    [anon_sym__Noreturn] = ACTIONS(1281),
    [anon_sym_noreturn] = ACTIONS(1281),
    [anon_sym_alignas] = ACTIONS(1281),
    [anon_sym__Alignas] = ACTIONS(1281),
    [sym_primitive_type] = ACTIONS(1281),
    [anon_sym_enum] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1281),
    [anon_sym_union] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_else] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(1281),
    [anon_sym_default] = ACTIONS(1281),
    [anon_sym_while] = ACTIONS(1281),
    [anon_sym_do] = ACTIONS(1281),
    [anon_sym_for] = ACTIONS(1281),
    [anon_sym_return] = ACTIONS(1281),
    [anon_sym_break] = ACTIONS(1281),
    [anon_sym_continue] = ACTIONS(1281),
    [anon_sym_goto] = ACTIONS(1281),
    [anon_sym___try] = ACTIONS(1281),
    [anon_sym___leave] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1283),
    [anon_sym_sizeof] = ACTIONS(1281),
    [anon_sym___alignof__] = ACTIONS(1281),
    [anon_sym___alignof] = ACTIONS(1281),
    [anon_sym__alignof] = ACTIONS(1281),
    [anon_sym_alignof] = ACTIONS(1281),
    [anon_sym__Alignof] = ACTIONS(1281),
    [anon_sym_offsetof] = ACTIONS(1281),
    [anon_sym__Generic] = ACTIONS(1281),
    [anon_sym_asm] = ACTIONS(1281),
    [anon_sym___asm__] = ACTIONS(1281),
    [sym_number_literal] = ACTIONS(1283),
    [anon_sym_L_SQUOTE] = ACTIONS(1283),
    [anon_sym_u_SQUOTE] = ACTIONS(1283),
    [anon_sym_U_SQUOTE] = ACTIONS(1283),
    [anon_sym_u8_SQUOTE] = ACTIONS(1283),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_L_DQUOTE] = ACTIONS(1283),
    [anon_sym_u_DQUOTE] = ACTIONS(1283),
    [anon_sym_U_DQUOTE] = ACTIONS(1283),
    [anon_sym_u8_DQUOTE] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1283),
    [sym_true] = ACTIONS(1281),
    [sym_false] = ACTIONS(1281),
    [anon_sym_NULL] = ACTIONS(1281),
    [anon_sym_nullptr] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1281),
    [anon_sym_hitAttributeEXT] = ACTIONS(1281),
    [anon_sym_callableDataEXT] = ACTIONS(1281),
    [anon_sym_callableDataInEXT] = ACTIONS(1281),
    [anon_sym_shaderRecordEXT] = ACTIONS(1281),
    [anon_sym_rayPayloadNV] = ACTIONS(1281),
    [anon_sym_rayPayloadInNV] = ACTIONS(1281),
    [anon_sym_hitAttributeNV] = ACTIONS(1281),
    [anon_sym_callableDataNV] = ACTIONS(1281),
    [anon_sym_callableDataInNV] = ACTIONS(1281),
    [anon_sym_shaderRecordNV] = ACTIONS(1281),
    [anon_sym_layout] = ACTIONS(1281),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(1335),
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_subroutine] = ACTIONS(1333),
    [anon_sym_invariant] = ACTIONS(1333),
    [anon_sym_precise] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_out] = ACTIONS(1333),
    [anon_sym_inout] = ACTIONS(1333),
    [anon_sym_uniform] = ACTIONS(1333),
    [anon_sym_shared] = ACTIONS(1333),
    [anon_sym_attribute] = ACTIONS(1333),
    [anon_sym_varying] = ACTIONS(1333),
    [anon_sym_buffer] = ACTIONS(1333),
    [anon_sym_coherent] = ACTIONS(1333),
    [anon_sym_readonly] = ACTIONS(1333),
    [anon_sym_writeonly] = ACTIONS(1333),
    [anon_sym_precision] = ACTIONS(1333),
    [anon_sym_highp] = ACTIONS(1333),
    [anon_sym_mediump] = ACTIONS(1333),
    [anon_sym_lowp] = ACTIONS(1333),
    [anon_sym_centroid] = ACTIONS(1333),
    [anon_sym_sample] = ACTIONS(1333),
    [anon_sym_patch] = ACTIONS(1333),
    [anon_sym_smooth] = ACTIONS(1333),
    [anon_sym_flat] = ACTIONS(1333),
    [anon_sym_noperspective] = ACTIONS(1333),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1333),
    [anon_sym_hitAttributeEXT] = ACTIONS(1333),
    [anon_sym_callableDataEXT] = ACTIONS(1333),
    [anon_sym_callableDataInEXT] = ACTIONS(1333),
    [anon_sym_shaderRecordEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadNV] = ACTIONS(1333),
    [anon_sym_rayPayloadInNV] = ACTIONS(1333),
    [anon_sym_hitAttributeNV] = ACTIONS(1333),
    [anon_sym_callableDataNV] = ACTIONS(1333),
    [anon_sym_callableDataInNV] = ACTIONS(1333),
    [anon_sym_shaderRecordNV] = ACTIONS(1333),
    [anon_sym_layout] = ACTIONS(1333),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token2] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1289),
    [aux_sym_preproc_include_token1] = ACTIONS(1289),
    [aux_sym_preproc_def_token1] = ACTIONS(1289),
    [aux_sym_preproc_if_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1289),
    [sym_preproc_directive] = ACTIONS(1289),
    [anon_sym_LPAREN2] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_TILDE] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_subroutine] = ACTIONS(1289),
    [anon_sym_invariant] = ACTIONS(1289),
    [anon_sym_precise] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1289),
    [anon_sym_out] = ACTIONS(1289),
    [anon_sym_inout] = ACTIONS(1289),
    [anon_sym_uniform] = ACTIONS(1289),
    [anon_sym_shared] = ACTIONS(1289),
    [anon_sym_attribute] = ACTIONS(1289),
    [anon_sym_varying] = ACTIONS(1289),
    [anon_sym_buffer] = ACTIONS(1289),
    [anon_sym_coherent] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_writeonly] = ACTIONS(1289),
    [anon_sym_precision] = ACTIONS(1289),
    [anon_sym_highp] = ACTIONS(1289),
    [anon_sym_mediump] = ACTIONS(1289),
    [anon_sym_lowp] = ACTIONS(1289),
    [anon_sym_centroid] = ACTIONS(1289),
    [anon_sym_sample] = ACTIONS(1289),
    [anon_sym_patch] = ACTIONS(1289),
    [anon_sym_smooth] = ACTIONS(1289),
    [anon_sym_flat] = ACTIONS(1289),
    [anon_sym_noperspective] = ACTIONS(1289),
    [anon_sym___extension__] = ACTIONS(1289),
    [anon_sym_typedef] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1289),
    [anon_sym___attribute__] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1291),
    [anon_sym___declspec] = ACTIONS(1289),
    [anon_sym___cdecl] = ACTIONS(1289),
    [anon_sym___clrcall] = ACTIONS(1289),
    [anon_sym___stdcall] = ACTIONS(1289),
    [anon_sym___fastcall] = ACTIONS(1289),
    [anon_sym___thiscall] = ACTIONS(1289),
    [anon_sym___vectorcall] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_signed] = ACTIONS(1289),
    [anon_sym_unsigned] = ACTIONS(1289),
    [anon_sym_long] = ACTIONS(1289),
    [anon_sym_short] = ACTIONS(1289),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_auto] = ACTIONS(1289),
    [anon_sym_register] = ACTIONS(1289),
    [anon_sym_inline] = ACTIONS(1289),
    [anon_sym___inline] = ACTIONS(1289),
    [anon_sym___inline__] = ACTIONS(1289),
    [anon_sym___forceinline] = ACTIONS(1289),
    [anon_sym_thread_local] = ACTIONS(1289),
    [anon_sym___thread] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_constexpr] = ACTIONS(1289),
    [anon_sym_volatile] = ACTIONS(1289),
    [anon_sym_restrict] = ACTIONS(1289),
    [anon_sym___restrict__] = ACTIONS(1289),
    [anon_sym__Atomic] = ACTIONS(1289),
    [anon_sym__Noreturn] = ACTIONS(1289),
    [anon_sym_noreturn] = ACTIONS(1289),
    [anon_sym_alignas] = ACTIONS(1289),
    [anon_sym__Alignas] = ACTIONS(1289),
    [sym_primitive_type] = ACTIONS(1289),
    [anon_sym_enum] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1289),
    [anon_sym_union] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1289),
    [anon_sym_else] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_case] = ACTIONS(1289),
    [anon_sym_default] = ACTIONS(1289),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_do] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1289),
    [anon_sym_return] = ACTIONS(1289),
    [anon_sym_break] = ACTIONS(1289),
    [anon_sym_continue] = ACTIONS(1289),
    [anon_sym_goto] = ACTIONS(1289),
    [anon_sym___try] = ACTIONS(1289),
    [anon_sym___leave] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1291),
    [anon_sym_sizeof] = ACTIONS(1289),
    [anon_sym___alignof__] = ACTIONS(1289),
    [anon_sym___alignof] = ACTIONS(1289),
    [anon_sym__alignof] = ACTIONS(1289),
    [anon_sym_alignof] = ACTIONS(1289),
    [anon_sym__Alignof] = ACTIONS(1289),
    [anon_sym_offsetof] = ACTIONS(1289),
    [anon_sym__Generic] = ACTIONS(1289),
    [anon_sym_asm] = ACTIONS(1289),
    [anon_sym___asm__] = ACTIONS(1289),
    [sym_number_literal] = ACTIONS(1291),
    [anon_sym_L_SQUOTE] = ACTIONS(1291),
    [anon_sym_u_SQUOTE] = ACTIONS(1291),
    [anon_sym_U_SQUOTE] = ACTIONS(1291),
    [anon_sym_u8_SQUOTE] = ACTIONS(1291),
    [anon_sym_SQUOTE] = ACTIONS(1291),
    [anon_sym_L_DQUOTE] = ACTIONS(1291),
    [anon_sym_u_DQUOTE] = ACTIONS(1291),
    [anon_sym_U_DQUOTE] = ACTIONS(1291),
    [anon_sym_u8_DQUOTE] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1291),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [anon_sym_NULL] = ACTIONS(1289),
    [anon_sym_nullptr] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1289),
    [anon_sym_hitAttributeEXT] = ACTIONS(1289),
    [anon_sym_callableDataEXT] = ACTIONS(1289),
    [anon_sym_callableDataInEXT] = ACTIONS(1289),
    [anon_sym_shaderRecordEXT] = ACTIONS(1289),
    [anon_sym_rayPayloadNV] = ACTIONS(1289),
    [anon_sym_rayPayloadInNV] = ACTIONS(1289),
    [anon_sym_hitAttributeNV] = ACTIONS(1289),
    [anon_sym_callableDataNV] = ACTIONS(1289),
    [anon_sym_callableDataInNV] = ACTIONS(1289),
    [anon_sym_shaderRecordNV] = ACTIONS(1289),
    [anon_sym_layout] = ACTIONS(1289),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1389),
    [aux_sym_preproc_include_token1] = ACTIONS(1389),
    [aux_sym_preproc_def_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token1] = ACTIONS(1389),
    [aux_sym_preproc_if_token2] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1389),
    [sym_preproc_directive] = ACTIONS(1389),
    [anon_sym_LPAREN2] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_TILDE] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1389),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_subroutine] = ACTIONS(1389),
    [anon_sym_invariant] = ACTIONS(1389),
    [anon_sym_precise] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_in] = ACTIONS(1389),
    [anon_sym_out] = ACTIONS(1389),
    [anon_sym_inout] = ACTIONS(1389),
    [anon_sym_uniform] = ACTIONS(1389),
    [anon_sym_shared] = ACTIONS(1389),
    [anon_sym_attribute] = ACTIONS(1389),
    [anon_sym_varying] = ACTIONS(1389),
    [anon_sym_buffer] = ACTIONS(1389),
    [anon_sym_coherent] = ACTIONS(1389),
    [anon_sym_readonly] = ACTIONS(1389),
    [anon_sym_writeonly] = ACTIONS(1389),
    [anon_sym_precision] = ACTIONS(1389),
    [anon_sym_highp] = ACTIONS(1389),
    [anon_sym_mediump] = ACTIONS(1389),
    [anon_sym_lowp] = ACTIONS(1389),
    [anon_sym_centroid] = ACTIONS(1389),
    [anon_sym_sample] = ACTIONS(1389),
    [anon_sym_patch] = ACTIONS(1389),
    [anon_sym_smooth] = ACTIONS(1389),
    [anon_sym_flat] = ACTIONS(1389),
    [anon_sym_noperspective] = ACTIONS(1389),
    [anon_sym___extension__] = ACTIONS(1389),
    [anon_sym_typedef] = ACTIONS(1389),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym___attribute__] = ACTIONS(1389),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1391),
    [anon_sym___declspec] = ACTIONS(1389),
    [anon_sym___cdecl] = ACTIONS(1389),
    [anon_sym___clrcall] = ACTIONS(1389),
    [anon_sym___stdcall] = ACTIONS(1389),
    [anon_sym___fastcall] = ACTIONS(1389),
    [anon_sym___thiscall] = ACTIONS(1389),
    [anon_sym___vectorcall] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_signed] = ACTIONS(1389),
    [anon_sym_unsigned] = ACTIONS(1389),
    [anon_sym_long] = ACTIONS(1389),
    [anon_sym_short] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_auto] = ACTIONS(1389),
    [anon_sym_register] = ACTIONS(1389),
    [anon_sym_inline] = ACTIONS(1389),
    [anon_sym___inline] = ACTIONS(1389),
    [anon_sym___inline__] = ACTIONS(1389),
    [anon_sym___forceinline] = ACTIONS(1389),
    [anon_sym_thread_local] = ACTIONS(1389),
    [anon_sym___thread] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_constexpr] = ACTIONS(1389),
    [anon_sym_volatile] = ACTIONS(1389),
    [anon_sym_restrict] = ACTIONS(1389),
    [anon_sym___restrict__] = ACTIONS(1389),
    [anon_sym__Atomic] = ACTIONS(1389),
    [anon_sym__Noreturn] = ACTIONS(1389),
    [anon_sym_noreturn] = ACTIONS(1389),
    [anon_sym_alignas] = ACTIONS(1389),
    [anon_sym__Alignas] = ACTIONS(1389),
    [sym_primitive_type] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1389),
    [anon_sym_case] = ACTIONS(1389),
    [anon_sym_default] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(1389),
    [anon_sym_for] = ACTIONS(1389),
    [anon_sym_return] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(1389),
    [anon_sym_continue] = ACTIONS(1389),
    [anon_sym_goto] = ACTIONS(1389),
    [anon_sym___try] = ACTIONS(1389),
    [anon_sym___leave] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1391),
    [anon_sym_sizeof] = ACTIONS(1389),
    [anon_sym___alignof__] = ACTIONS(1389),
    [anon_sym___alignof] = ACTIONS(1389),
    [anon_sym__alignof] = ACTIONS(1389),
    [anon_sym_alignof] = ACTIONS(1389),
    [anon_sym__Alignof] = ACTIONS(1389),
    [anon_sym_offsetof] = ACTIONS(1389),
    [anon_sym__Generic] = ACTIONS(1389),
    [anon_sym_asm] = ACTIONS(1389),
    [anon_sym___asm__] = ACTIONS(1389),
    [sym_number_literal] = ACTIONS(1391),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1391),
    [anon_sym_u_DQUOTE] = ACTIONS(1391),
    [anon_sym_U_DQUOTE] = ACTIONS(1391),
    [anon_sym_u8_DQUOTE] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1391),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [anon_sym_NULL] = ACTIONS(1389),
    [anon_sym_nullptr] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1389),
    [anon_sym_hitAttributeEXT] = ACTIONS(1389),
    [anon_sym_callableDataEXT] = ACTIONS(1389),
    [anon_sym_callableDataInEXT] = ACTIONS(1389),
    [anon_sym_shaderRecordEXT] = ACTIONS(1389),
    [anon_sym_rayPayloadNV] = ACTIONS(1389),
    [anon_sym_rayPayloadInNV] = ACTIONS(1389),
    [anon_sym_hitAttributeNV] = ACTIONS(1389),
    [anon_sym_callableDataNV] = ACTIONS(1389),
    [anon_sym_callableDataInNV] = ACTIONS(1389),
    [anon_sym_shaderRecordNV] = ACTIONS(1389),
    [anon_sym_layout] = ACTIONS(1389),
  },
  [293] = {
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_subroutine] = ACTIONS(1345),
    [anon_sym_invariant] = ACTIONS(1345),
    [anon_sym_precise] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_out] = ACTIONS(1345),
    [anon_sym_inout] = ACTIONS(1345),
    [anon_sym_uniform] = ACTIONS(1345),
    [anon_sym_shared] = ACTIONS(1345),
    [anon_sym_attribute] = ACTIONS(1345),
    [anon_sym_varying] = ACTIONS(1345),
    [anon_sym_buffer] = ACTIONS(1345),
    [anon_sym_coherent] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_writeonly] = ACTIONS(1345),
    [anon_sym_precision] = ACTIONS(1345),
    [anon_sym_highp] = ACTIONS(1345),
    [anon_sym_mediump] = ACTIONS(1345),
    [anon_sym_lowp] = ACTIONS(1345),
    [anon_sym_centroid] = ACTIONS(1345),
    [anon_sym_sample] = ACTIONS(1345),
    [anon_sym_patch] = ACTIONS(1345),
    [anon_sym_smooth] = ACTIONS(1345),
    [anon_sym_flat] = ACTIONS(1345),
    [anon_sym_noperspective] = ACTIONS(1345),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1345),
    [anon_sym_hitAttributeEXT] = ACTIONS(1345),
    [anon_sym_callableDataEXT] = ACTIONS(1345),
    [anon_sym_callableDataInEXT] = ACTIONS(1345),
    [anon_sym_shaderRecordEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadNV] = ACTIONS(1345),
    [anon_sym_rayPayloadInNV] = ACTIONS(1345),
    [anon_sym_hitAttributeNV] = ACTIONS(1345),
    [anon_sym_callableDataNV] = ACTIONS(1345),
    [anon_sym_callableDataInNV] = ACTIONS(1345),
    [anon_sym_shaderRecordNV] = ACTIONS(1345),
    [anon_sym_layout] = ACTIONS(1345),
  },
  [294] = {
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_subroutine] = ACTIONS(1341),
    [anon_sym_invariant] = ACTIONS(1341),
    [anon_sym_precise] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_out] = ACTIONS(1341),
    [anon_sym_inout] = ACTIONS(1341),
    [anon_sym_uniform] = ACTIONS(1341),
    [anon_sym_shared] = ACTIONS(1341),
    [anon_sym_attribute] = ACTIONS(1341),
    [anon_sym_varying] = ACTIONS(1341),
    [anon_sym_buffer] = ACTIONS(1341),
    [anon_sym_coherent] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_writeonly] = ACTIONS(1341),
    [anon_sym_precision] = ACTIONS(1341),
    [anon_sym_highp] = ACTIONS(1341),
    [anon_sym_mediump] = ACTIONS(1341),
    [anon_sym_lowp] = ACTIONS(1341),
    [anon_sym_centroid] = ACTIONS(1341),
    [anon_sym_sample] = ACTIONS(1341),
    [anon_sym_patch] = ACTIONS(1341),
    [anon_sym_smooth] = ACTIONS(1341),
    [anon_sym_flat] = ACTIONS(1341),
    [anon_sym_noperspective] = ACTIONS(1341),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_RBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1341),
    [anon_sym_hitAttributeEXT] = ACTIONS(1341),
    [anon_sym_callableDataEXT] = ACTIONS(1341),
    [anon_sym_callableDataInEXT] = ACTIONS(1341),
    [anon_sym_shaderRecordEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadNV] = ACTIONS(1341),
    [anon_sym_rayPayloadInNV] = ACTIONS(1341),
    [anon_sym_hitAttributeNV] = ACTIONS(1341),
    [anon_sym_callableDataNV] = ACTIONS(1341),
    [anon_sym_callableDataInNV] = ACTIONS(1341),
    [anon_sym_shaderRecordNV] = ACTIONS(1341),
    [anon_sym_layout] = ACTIONS(1341),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(1339),
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_subroutine] = ACTIONS(1337),
    [anon_sym_invariant] = ACTIONS(1337),
    [anon_sym_precise] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1337),
    [anon_sym_out] = ACTIONS(1337),
    [anon_sym_inout] = ACTIONS(1337),
    [anon_sym_uniform] = ACTIONS(1337),
    [anon_sym_shared] = ACTIONS(1337),
    [anon_sym_attribute] = ACTIONS(1337),
    [anon_sym_varying] = ACTIONS(1337),
    [anon_sym_buffer] = ACTIONS(1337),
    [anon_sym_coherent] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_writeonly] = ACTIONS(1337),
    [anon_sym_precision] = ACTIONS(1337),
    [anon_sym_highp] = ACTIONS(1337),
    [anon_sym_mediump] = ACTIONS(1337),
    [anon_sym_lowp] = ACTIONS(1337),
    [anon_sym_centroid] = ACTIONS(1337),
    [anon_sym_sample] = ACTIONS(1337),
    [anon_sym_patch] = ACTIONS(1337),
    [anon_sym_smooth] = ACTIONS(1337),
    [anon_sym_flat] = ACTIONS(1337),
    [anon_sym_noperspective] = ACTIONS(1337),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_else] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1337),
    [anon_sym_hitAttributeEXT] = ACTIONS(1337),
    [anon_sym_callableDataEXT] = ACTIONS(1337),
    [anon_sym_callableDataInEXT] = ACTIONS(1337),
    [anon_sym_shaderRecordEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadNV] = ACTIONS(1337),
    [anon_sym_rayPayloadInNV] = ACTIONS(1337),
    [anon_sym_hitAttributeNV] = ACTIONS(1337),
    [anon_sym_callableDataNV] = ACTIONS(1337),
    [anon_sym_callableDataInNV] = ACTIONS(1337),
    [anon_sym_shaderRecordNV] = ACTIONS(1337),
    [anon_sym_layout] = ACTIONS(1337),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1257),
    [aux_sym_preproc_include_token1] = ACTIONS(1257),
    [aux_sym_preproc_def_token1] = ACTIONS(1257),
    [aux_sym_preproc_if_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1257),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1257),
    [sym_preproc_directive] = ACTIONS(1257),
    [anon_sym_LPAREN2] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_subroutine] = ACTIONS(1257),
    [anon_sym_invariant] = ACTIONS(1257),
    [anon_sym_precise] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_out] = ACTIONS(1257),
    [anon_sym_inout] = ACTIONS(1257),
    [anon_sym_uniform] = ACTIONS(1257),
    [anon_sym_shared] = ACTIONS(1257),
    [anon_sym_attribute] = ACTIONS(1257),
    [anon_sym_varying] = ACTIONS(1257),
    [anon_sym_buffer] = ACTIONS(1257),
    [anon_sym_coherent] = ACTIONS(1257),
    [anon_sym_readonly] = ACTIONS(1257),
    [anon_sym_writeonly] = ACTIONS(1257),
    [anon_sym_precision] = ACTIONS(1257),
    [anon_sym_highp] = ACTIONS(1257),
    [anon_sym_mediump] = ACTIONS(1257),
    [anon_sym_lowp] = ACTIONS(1257),
    [anon_sym_centroid] = ACTIONS(1257),
    [anon_sym_sample] = ACTIONS(1257),
    [anon_sym_patch] = ACTIONS(1257),
    [anon_sym_smooth] = ACTIONS(1257),
    [anon_sym_flat] = ACTIONS(1257),
    [anon_sym_noperspective] = ACTIONS(1257),
    [anon_sym___extension__] = ACTIONS(1257),
    [anon_sym_typedef] = ACTIONS(1257),
    [anon_sym_extern] = ACTIONS(1257),
    [anon_sym___attribute__] = ACTIONS(1257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1259),
    [anon_sym___declspec] = ACTIONS(1257),
    [anon_sym___cdecl] = ACTIONS(1257),
    [anon_sym___clrcall] = ACTIONS(1257),
    [anon_sym___stdcall] = ACTIONS(1257),
    [anon_sym___fastcall] = ACTIONS(1257),
    [anon_sym___thiscall] = ACTIONS(1257),
    [anon_sym___vectorcall] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_signed] = ACTIONS(1257),
    [anon_sym_unsigned] = ACTIONS(1257),
    [anon_sym_long] = ACTIONS(1257),
    [anon_sym_short] = ACTIONS(1257),
    [anon_sym_static] = ACTIONS(1257),
    [anon_sym_auto] = ACTIONS(1257),
    [anon_sym_register] = ACTIONS(1257),
    [anon_sym_inline] = ACTIONS(1257),
    [anon_sym___inline] = ACTIONS(1257),
    [anon_sym___inline__] = ACTIONS(1257),
    [anon_sym___forceinline] = ACTIONS(1257),
    [anon_sym_thread_local] = ACTIONS(1257),
    [anon_sym___thread] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1257),
    [anon_sym_constexpr] = ACTIONS(1257),
    [anon_sym_volatile] = ACTIONS(1257),
    [anon_sym_restrict] = ACTIONS(1257),
    [anon_sym___restrict__] = ACTIONS(1257),
    [anon_sym__Atomic] = ACTIONS(1257),
    [anon_sym__Noreturn] = ACTIONS(1257),
    [anon_sym_noreturn] = ACTIONS(1257),
    [anon_sym_alignas] = ACTIONS(1257),
    [anon_sym__Alignas] = ACTIONS(1257),
    [sym_primitive_type] = ACTIONS(1257),
    [anon_sym_enum] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1257),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_default] = ACTIONS(1257),
    [anon_sym_while] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1257),
    [anon_sym_return] = ACTIONS(1257),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_continue] = ACTIONS(1257),
    [anon_sym_goto] = ACTIONS(1257),
    [anon_sym___try] = ACTIONS(1257),
    [anon_sym___leave] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_sizeof] = ACTIONS(1257),
    [anon_sym___alignof__] = ACTIONS(1257),
    [anon_sym___alignof] = ACTIONS(1257),
    [anon_sym__alignof] = ACTIONS(1257),
    [anon_sym_alignof] = ACTIONS(1257),
    [anon_sym__Alignof] = ACTIONS(1257),
    [anon_sym_offsetof] = ACTIONS(1257),
    [anon_sym__Generic] = ACTIONS(1257),
    [anon_sym_asm] = ACTIONS(1257),
    [anon_sym___asm__] = ACTIONS(1257),
    [sym_number_literal] = ACTIONS(1259),
    [anon_sym_L_SQUOTE] = ACTIONS(1259),
    [anon_sym_u_SQUOTE] = ACTIONS(1259),
    [anon_sym_U_SQUOTE] = ACTIONS(1259),
    [anon_sym_u8_SQUOTE] = ACTIONS(1259),
    [anon_sym_SQUOTE] = ACTIONS(1259),
    [anon_sym_L_DQUOTE] = ACTIONS(1259),
    [anon_sym_u_DQUOTE] = ACTIONS(1259),
    [anon_sym_U_DQUOTE] = ACTIONS(1259),
    [anon_sym_u8_DQUOTE] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1259),
    [sym_true] = ACTIONS(1257),
    [sym_false] = ACTIONS(1257),
    [anon_sym_NULL] = ACTIONS(1257),
    [anon_sym_nullptr] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1257),
    [anon_sym_hitAttributeEXT] = ACTIONS(1257),
    [anon_sym_callableDataEXT] = ACTIONS(1257),
    [anon_sym_callableDataInEXT] = ACTIONS(1257),
    [anon_sym_shaderRecordEXT] = ACTIONS(1257),
    [anon_sym_rayPayloadNV] = ACTIONS(1257),
    [anon_sym_rayPayloadInNV] = ACTIONS(1257),
    [anon_sym_hitAttributeNV] = ACTIONS(1257),
    [anon_sym_callableDataNV] = ACTIONS(1257),
    [anon_sym_callableDataInNV] = ACTIONS(1257),
    [anon_sym_shaderRecordNV] = ACTIONS(1257),
    [anon_sym_layout] = ACTIONS(1257),
  },
  [297] = {
    [sym_identifier] = ACTIONS(1337),
    [aux_sym_preproc_include_token1] = ACTIONS(1337),
    [aux_sym_preproc_def_token1] = ACTIONS(1337),
    [aux_sym_preproc_if_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1337),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1337),
    [sym_preproc_directive] = ACTIONS(1337),
    [anon_sym_LPAREN2] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_subroutine] = ACTIONS(1337),
    [anon_sym_invariant] = ACTIONS(1337),
    [anon_sym_precise] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1339),
    [anon_sym_in] = ACTIONS(1337),
    [anon_sym_out] = ACTIONS(1337),
    [anon_sym_inout] = ACTIONS(1337),
    [anon_sym_uniform] = ACTIONS(1337),
    [anon_sym_shared] = ACTIONS(1337),
    [anon_sym_attribute] = ACTIONS(1337),
    [anon_sym_varying] = ACTIONS(1337),
    [anon_sym_buffer] = ACTIONS(1337),
    [anon_sym_coherent] = ACTIONS(1337),
    [anon_sym_readonly] = ACTIONS(1337),
    [anon_sym_writeonly] = ACTIONS(1337),
    [anon_sym_precision] = ACTIONS(1337),
    [anon_sym_highp] = ACTIONS(1337),
    [anon_sym_mediump] = ACTIONS(1337),
    [anon_sym_lowp] = ACTIONS(1337),
    [anon_sym_centroid] = ACTIONS(1337),
    [anon_sym_sample] = ACTIONS(1337),
    [anon_sym_patch] = ACTIONS(1337),
    [anon_sym_smooth] = ACTIONS(1337),
    [anon_sym_flat] = ACTIONS(1337),
    [anon_sym_noperspective] = ACTIONS(1337),
    [anon_sym___extension__] = ACTIONS(1337),
    [anon_sym_typedef] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1337),
    [anon_sym___attribute__] = ACTIONS(1337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1339),
    [anon_sym___declspec] = ACTIONS(1337),
    [anon_sym___cdecl] = ACTIONS(1337),
    [anon_sym___clrcall] = ACTIONS(1337),
    [anon_sym___stdcall] = ACTIONS(1337),
    [anon_sym___fastcall] = ACTIONS(1337),
    [anon_sym___thiscall] = ACTIONS(1337),
    [anon_sym___vectorcall] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1339),
    [anon_sym_RBRACE] = ACTIONS(1339),
    [anon_sym_signed] = ACTIONS(1337),
    [anon_sym_unsigned] = ACTIONS(1337),
    [anon_sym_long] = ACTIONS(1337),
    [anon_sym_short] = ACTIONS(1337),
    [anon_sym_static] = ACTIONS(1337),
    [anon_sym_auto] = ACTIONS(1337),
    [anon_sym_register] = ACTIONS(1337),
    [anon_sym_inline] = ACTIONS(1337),
    [anon_sym___inline] = ACTIONS(1337),
    [anon_sym___inline__] = ACTIONS(1337),
    [anon_sym___forceinline] = ACTIONS(1337),
    [anon_sym_thread_local] = ACTIONS(1337),
    [anon_sym___thread] = ACTIONS(1337),
    [anon_sym_const] = ACTIONS(1337),
    [anon_sym_constexpr] = ACTIONS(1337),
    [anon_sym_volatile] = ACTIONS(1337),
    [anon_sym_restrict] = ACTIONS(1337),
    [anon_sym___restrict__] = ACTIONS(1337),
    [anon_sym__Atomic] = ACTIONS(1337),
    [anon_sym__Noreturn] = ACTIONS(1337),
    [anon_sym_noreturn] = ACTIONS(1337),
    [anon_sym_alignas] = ACTIONS(1337),
    [anon_sym__Alignas] = ACTIONS(1337),
    [sym_primitive_type] = ACTIONS(1337),
    [anon_sym_enum] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1337),
    [anon_sym_union] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_else] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1337),
    [anon_sym_case] = ACTIONS(1337),
    [anon_sym_default] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1337),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1337),
    [anon_sym_return] = ACTIONS(1337),
    [anon_sym_break] = ACTIONS(1337),
    [anon_sym_continue] = ACTIONS(1337),
    [anon_sym_goto] = ACTIONS(1337),
    [anon_sym___try] = ACTIONS(1337),
    [anon_sym___leave] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_sizeof] = ACTIONS(1337),
    [anon_sym___alignof__] = ACTIONS(1337),
    [anon_sym___alignof] = ACTIONS(1337),
    [anon_sym__alignof] = ACTIONS(1337),
    [anon_sym_alignof] = ACTIONS(1337),
    [anon_sym__Alignof] = ACTIONS(1337),
    [anon_sym_offsetof] = ACTIONS(1337),
    [anon_sym__Generic] = ACTIONS(1337),
    [anon_sym_asm] = ACTIONS(1337),
    [anon_sym___asm__] = ACTIONS(1337),
    [sym_number_literal] = ACTIONS(1339),
    [anon_sym_L_SQUOTE] = ACTIONS(1339),
    [anon_sym_u_SQUOTE] = ACTIONS(1339),
    [anon_sym_U_SQUOTE] = ACTIONS(1339),
    [anon_sym_u8_SQUOTE] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_L_DQUOTE] = ACTIONS(1339),
    [anon_sym_u_DQUOTE] = ACTIONS(1339),
    [anon_sym_U_DQUOTE] = ACTIONS(1339),
    [anon_sym_u8_DQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_true] = ACTIONS(1337),
    [sym_false] = ACTIONS(1337),
    [anon_sym_NULL] = ACTIONS(1337),
    [anon_sym_nullptr] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1337),
    [anon_sym_hitAttributeEXT] = ACTIONS(1337),
    [anon_sym_callableDataEXT] = ACTIONS(1337),
    [anon_sym_callableDataInEXT] = ACTIONS(1337),
    [anon_sym_shaderRecordEXT] = ACTIONS(1337),
    [anon_sym_rayPayloadNV] = ACTIONS(1337),
    [anon_sym_rayPayloadInNV] = ACTIONS(1337),
    [anon_sym_hitAttributeNV] = ACTIONS(1337),
    [anon_sym_callableDataNV] = ACTIONS(1337),
    [anon_sym_callableDataInNV] = ACTIONS(1337),
    [anon_sym_shaderRecordNV] = ACTIONS(1337),
    [anon_sym_layout] = ACTIONS(1337),
  },
  [298] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1333),
    [aux_sym_preproc_include_token1] = ACTIONS(1333),
    [aux_sym_preproc_def_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token1] = ACTIONS(1333),
    [aux_sym_preproc_if_token2] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1333),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1333),
    [sym_preproc_directive] = ACTIONS(1333),
    [anon_sym_LPAREN2] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_TILDE] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_subroutine] = ACTIONS(1333),
    [anon_sym_invariant] = ACTIONS(1333),
    [anon_sym_precise] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_in] = ACTIONS(1333),
    [anon_sym_out] = ACTIONS(1333),
    [anon_sym_inout] = ACTIONS(1333),
    [anon_sym_uniform] = ACTIONS(1333),
    [anon_sym_shared] = ACTIONS(1333),
    [anon_sym_attribute] = ACTIONS(1333),
    [anon_sym_varying] = ACTIONS(1333),
    [anon_sym_buffer] = ACTIONS(1333),
    [anon_sym_coherent] = ACTIONS(1333),
    [anon_sym_readonly] = ACTIONS(1333),
    [anon_sym_writeonly] = ACTIONS(1333),
    [anon_sym_precision] = ACTIONS(1333),
    [anon_sym_highp] = ACTIONS(1333),
    [anon_sym_mediump] = ACTIONS(1333),
    [anon_sym_lowp] = ACTIONS(1333),
    [anon_sym_centroid] = ACTIONS(1333),
    [anon_sym_sample] = ACTIONS(1333),
    [anon_sym_patch] = ACTIONS(1333),
    [anon_sym_smooth] = ACTIONS(1333),
    [anon_sym_flat] = ACTIONS(1333),
    [anon_sym_noperspective] = ACTIONS(1333),
    [anon_sym___extension__] = ACTIONS(1333),
    [anon_sym_typedef] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1333),
    [anon_sym___attribute__] = ACTIONS(1333),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1335),
    [anon_sym___declspec] = ACTIONS(1333),
    [anon_sym___cdecl] = ACTIONS(1333),
    [anon_sym___clrcall] = ACTIONS(1333),
    [anon_sym___stdcall] = ACTIONS(1333),
    [anon_sym___fastcall] = ACTIONS(1333),
    [anon_sym___thiscall] = ACTIONS(1333),
    [anon_sym___vectorcall] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1335),
    [anon_sym_signed] = ACTIONS(1333),
    [anon_sym_unsigned] = ACTIONS(1333),
    [anon_sym_long] = ACTIONS(1333),
    [anon_sym_short] = ACTIONS(1333),
    [anon_sym_static] = ACTIONS(1333),
    [anon_sym_auto] = ACTIONS(1333),
    [anon_sym_register] = ACTIONS(1333),
    [anon_sym_inline] = ACTIONS(1333),
    [anon_sym___inline] = ACTIONS(1333),
    [anon_sym___inline__] = ACTIONS(1333),
    [anon_sym___forceinline] = ACTIONS(1333),
    [anon_sym_thread_local] = ACTIONS(1333),
    [anon_sym___thread] = ACTIONS(1333),
    [anon_sym_const] = ACTIONS(1333),
    [anon_sym_constexpr] = ACTIONS(1333),
    [anon_sym_volatile] = ACTIONS(1333),
    [anon_sym_restrict] = ACTIONS(1333),
    [anon_sym___restrict__] = ACTIONS(1333),
    [anon_sym__Atomic] = ACTIONS(1333),
    [anon_sym__Noreturn] = ACTIONS(1333),
    [anon_sym_noreturn] = ACTIONS(1333),
    [anon_sym_alignas] = ACTIONS(1333),
    [anon_sym__Alignas] = ACTIONS(1333),
    [sym_primitive_type] = ACTIONS(1333),
    [anon_sym_enum] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1333),
    [anon_sym_union] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1333),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1333),
    [anon_sym_case] = ACTIONS(1333),
    [anon_sym_default] = ACTIONS(1333),
    [anon_sym_while] = ACTIONS(1333),
    [anon_sym_do] = ACTIONS(1333),
    [anon_sym_for] = ACTIONS(1333),
    [anon_sym_return] = ACTIONS(1333),
    [anon_sym_break] = ACTIONS(1333),
    [anon_sym_continue] = ACTIONS(1333),
    [anon_sym_goto] = ACTIONS(1333),
    [anon_sym___try] = ACTIONS(1333),
    [anon_sym___leave] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_sizeof] = ACTIONS(1333),
    [anon_sym___alignof__] = ACTIONS(1333),
    [anon_sym___alignof] = ACTIONS(1333),
    [anon_sym__alignof] = ACTIONS(1333),
    [anon_sym_alignof] = ACTIONS(1333),
    [anon_sym__Alignof] = ACTIONS(1333),
    [anon_sym_offsetof] = ACTIONS(1333),
    [anon_sym__Generic] = ACTIONS(1333),
    [anon_sym_asm] = ACTIONS(1333),
    [anon_sym___asm__] = ACTIONS(1333),
    [sym_number_literal] = ACTIONS(1335),
    [anon_sym_L_SQUOTE] = ACTIONS(1335),
    [anon_sym_u_SQUOTE] = ACTIONS(1335),
    [anon_sym_U_SQUOTE] = ACTIONS(1335),
    [anon_sym_u8_SQUOTE] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_L_DQUOTE] = ACTIONS(1335),
    [anon_sym_u_DQUOTE] = ACTIONS(1335),
    [anon_sym_U_DQUOTE] = ACTIONS(1335),
    [anon_sym_u8_DQUOTE] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_true] = ACTIONS(1333),
    [sym_false] = ACTIONS(1333),
    [anon_sym_NULL] = ACTIONS(1333),
    [anon_sym_nullptr] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1333),
    [anon_sym_hitAttributeEXT] = ACTIONS(1333),
    [anon_sym_callableDataEXT] = ACTIONS(1333),
    [anon_sym_callableDataInEXT] = ACTIONS(1333),
    [anon_sym_shaderRecordEXT] = ACTIONS(1333),
    [anon_sym_rayPayloadNV] = ACTIONS(1333),
    [anon_sym_rayPayloadInNV] = ACTIONS(1333),
    [anon_sym_hitAttributeNV] = ACTIONS(1333),
    [anon_sym_callableDataNV] = ACTIONS(1333),
    [anon_sym_callableDataInNV] = ACTIONS(1333),
    [anon_sym_shaderRecordNV] = ACTIONS(1333),
    [anon_sym_layout] = ACTIONS(1333),
  },
  [301] = {
    [sym_identifier] = ACTIONS(1329),
    [aux_sym_preproc_include_token1] = ACTIONS(1329),
    [aux_sym_preproc_def_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token1] = ACTIONS(1329),
    [aux_sym_preproc_if_token2] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1329),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1329),
    [sym_preproc_directive] = ACTIONS(1329),
    [anon_sym_LPAREN2] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1329),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_subroutine] = ACTIONS(1329),
    [anon_sym_invariant] = ACTIONS(1329),
    [anon_sym_precise] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1331),
    [anon_sym_in] = ACTIONS(1329),
    [anon_sym_out] = ACTIONS(1329),
    [anon_sym_inout] = ACTIONS(1329),
    [anon_sym_uniform] = ACTIONS(1329),
    [anon_sym_shared] = ACTIONS(1329),
    [anon_sym_attribute] = ACTIONS(1329),
    [anon_sym_varying] = ACTIONS(1329),
    [anon_sym_buffer] = ACTIONS(1329),
    [anon_sym_coherent] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(1329),
    [anon_sym_writeonly] = ACTIONS(1329),
    [anon_sym_precision] = ACTIONS(1329),
    [anon_sym_highp] = ACTIONS(1329),
    [anon_sym_mediump] = ACTIONS(1329),
    [anon_sym_lowp] = ACTIONS(1329),
    [anon_sym_centroid] = ACTIONS(1329),
    [anon_sym_sample] = ACTIONS(1329),
    [anon_sym_patch] = ACTIONS(1329),
    [anon_sym_smooth] = ACTIONS(1329),
    [anon_sym_flat] = ACTIONS(1329),
    [anon_sym_noperspective] = ACTIONS(1329),
    [anon_sym___extension__] = ACTIONS(1329),
    [anon_sym_typedef] = ACTIONS(1329),
    [anon_sym_extern] = ACTIONS(1329),
    [anon_sym___attribute__] = ACTIONS(1329),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1331),
    [anon_sym___declspec] = ACTIONS(1329),
    [anon_sym___cdecl] = ACTIONS(1329),
    [anon_sym___clrcall] = ACTIONS(1329),
    [anon_sym___stdcall] = ACTIONS(1329),
    [anon_sym___fastcall] = ACTIONS(1329),
    [anon_sym___thiscall] = ACTIONS(1329),
    [anon_sym___vectorcall] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1331),
    [anon_sym_signed] = ACTIONS(1329),
    [anon_sym_unsigned] = ACTIONS(1329),
    [anon_sym_long] = ACTIONS(1329),
    [anon_sym_short] = ACTIONS(1329),
    [anon_sym_static] = ACTIONS(1329),
    [anon_sym_auto] = ACTIONS(1329),
    [anon_sym_register] = ACTIONS(1329),
    [anon_sym_inline] = ACTIONS(1329),
    [anon_sym___inline] = ACTIONS(1329),
    [anon_sym___inline__] = ACTIONS(1329),
    [anon_sym___forceinline] = ACTIONS(1329),
    [anon_sym_thread_local] = ACTIONS(1329),
    [anon_sym___thread] = ACTIONS(1329),
    [anon_sym_const] = ACTIONS(1329),
    [anon_sym_constexpr] = ACTIONS(1329),
    [anon_sym_volatile] = ACTIONS(1329),
    [anon_sym_restrict] = ACTIONS(1329),
    [anon_sym___restrict__] = ACTIONS(1329),
    [anon_sym__Atomic] = ACTIONS(1329),
    [anon_sym__Noreturn] = ACTIONS(1329),
    [anon_sym_noreturn] = ACTIONS(1329),
    [anon_sym_alignas] = ACTIONS(1329),
    [anon_sym__Alignas] = ACTIONS(1329),
    [sym_primitive_type] = ACTIONS(1329),
    [anon_sym_enum] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1329),
    [anon_sym_union] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1329),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1329),
    [anon_sym_case] = ACTIONS(1329),
    [anon_sym_default] = ACTIONS(1329),
    [anon_sym_while] = ACTIONS(1329),
    [anon_sym_do] = ACTIONS(1329),
    [anon_sym_for] = ACTIONS(1329),
    [anon_sym_return] = ACTIONS(1329),
    [anon_sym_break] = ACTIONS(1329),
    [anon_sym_continue] = ACTIONS(1329),
    [anon_sym_goto] = ACTIONS(1329),
    [anon_sym___try] = ACTIONS(1329),
    [anon_sym___leave] = ACTIONS(1329),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_sizeof] = ACTIONS(1329),
    [anon_sym___alignof__] = ACTIONS(1329),
    [anon_sym___alignof] = ACTIONS(1329),
    [anon_sym__alignof] = ACTIONS(1329),
    [anon_sym_alignof] = ACTIONS(1329),
    [anon_sym__Alignof] = ACTIONS(1329),
    [anon_sym_offsetof] = ACTIONS(1329),
    [anon_sym__Generic] = ACTIONS(1329),
    [anon_sym_asm] = ACTIONS(1329),
    [anon_sym___asm__] = ACTIONS(1329),
    [sym_number_literal] = ACTIONS(1331),
    [anon_sym_L_SQUOTE] = ACTIONS(1331),
    [anon_sym_u_SQUOTE] = ACTIONS(1331),
    [anon_sym_U_SQUOTE] = ACTIONS(1331),
    [anon_sym_u8_SQUOTE] = ACTIONS(1331),
    [anon_sym_SQUOTE] = ACTIONS(1331),
    [anon_sym_L_DQUOTE] = ACTIONS(1331),
    [anon_sym_u_DQUOTE] = ACTIONS(1331),
    [anon_sym_U_DQUOTE] = ACTIONS(1331),
    [anon_sym_u8_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [anon_sym_NULL] = ACTIONS(1329),
    [anon_sym_nullptr] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1329),
    [anon_sym_hitAttributeEXT] = ACTIONS(1329),
    [anon_sym_callableDataEXT] = ACTIONS(1329),
    [anon_sym_callableDataInEXT] = ACTIONS(1329),
    [anon_sym_shaderRecordEXT] = ACTIONS(1329),
    [anon_sym_rayPayloadNV] = ACTIONS(1329),
    [anon_sym_rayPayloadInNV] = ACTIONS(1329),
    [anon_sym_hitAttributeNV] = ACTIONS(1329),
    [anon_sym_callableDataNV] = ACTIONS(1329),
    [anon_sym_callableDataInNV] = ACTIONS(1329),
    [anon_sym_shaderRecordNV] = ACTIONS(1329),
    [anon_sym_layout] = ACTIONS(1329),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1241),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1241),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_subroutine] = ACTIONS(1241),
    [anon_sym_invariant] = ACTIONS(1241),
    [anon_sym_precise] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1241),
    [anon_sym_out] = ACTIONS(1241),
    [anon_sym_inout] = ACTIONS(1241),
    [anon_sym_uniform] = ACTIONS(1241),
    [anon_sym_shared] = ACTIONS(1241),
    [anon_sym_attribute] = ACTIONS(1241),
    [anon_sym_varying] = ACTIONS(1241),
    [anon_sym_buffer] = ACTIONS(1241),
    [anon_sym_coherent] = ACTIONS(1241),
    [anon_sym_readonly] = ACTIONS(1241),
    [anon_sym_writeonly] = ACTIONS(1241),
    [anon_sym_precision] = ACTIONS(1241),
    [anon_sym_highp] = ACTIONS(1241),
    [anon_sym_mediump] = ACTIONS(1241),
    [anon_sym_lowp] = ACTIONS(1241),
    [anon_sym_centroid] = ACTIONS(1241),
    [anon_sym_sample] = ACTIONS(1241),
    [anon_sym_patch] = ACTIONS(1241),
    [anon_sym_smooth] = ACTIONS(1241),
    [anon_sym_flat] = ACTIONS(1241),
    [anon_sym_noperspective] = ACTIONS(1241),
    [anon_sym___extension__] = ACTIONS(1241),
    [anon_sym_typedef] = ACTIONS(1241),
    [anon_sym_extern] = ACTIONS(1241),
    [anon_sym___attribute__] = ACTIONS(1241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1243),
    [anon_sym___declspec] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(1241),
    [anon_sym_unsigned] = ACTIONS(1241),
    [anon_sym_long] = ACTIONS(1241),
    [anon_sym_short] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1241),
    [anon_sym_auto] = ACTIONS(1241),
    [anon_sym_register] = ACTIONS(1241),
    [anon_sym_inline] = ACTIONS(1241),
    [anon_sym___inline] = ACTIONS(1241),
    [anon_sym___inline__] = ACTIONS(1241),
    [anon_sym___forceinline] = ACTIONS(1241),
    [anon_sym_thread_local] = ACTIONS(1241),
    [anon_sym___thread] = ACTIONS(1241),
    [anon_sym_const] = ACTIONS(1241),
    [anon_sym_constexpr] = ACTIONS(1241),
    [anon_sym_volatile] = ACTIONS(1241),
    [anon_sym_restrict] = ACTIONS(1241),
    [anon_sym___restrict__] = ACTIONS(1241),
    [anon_sym__Atomic] = ACTIONS(1241),
    [anon_sym__Noreturn] = ACTIONS(1241),
    [anon_sym_noreturn] = ACTIONS(1241),
    [anon_sym_alignas] = ACTIONS(1241),
    [anon_sym__Alignas] = ACTIONS(1241),
    [sym_primitive_type] = ACTIONS(1241),
    [anon_sym_enum] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1241),
    [anon_sym_union] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_do] = ACTIONS(1241),
    [anon_sym_for] = ACTIONS(1241),
    [anon_sym_return] = ACTIONS(1241),
    [anon_sym_break] = ACTIONS(1241),
    [anon_sym_continue] = ACTIONS(1241),
    [anon_sym_goto] = ACTIONS(1241),
    [anon_sym___try] = ACTIONS(1241),
    [anon_sym___leave] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1243),
    [anon_sym_sizeof] = ACTIONS(1241),
    [anon_sym___alignof__] = ACTIONS(1241),
    [anon_sym___alignof] = ACTIONS(1241),
    [anon_sym__alignof] = ACTIONS(1241),
    [anon_sym_alignof] = ACTIONS(1241),
    [anon_sym__Alignof] = ACTIONS(1241),
    [anon_sym_offsetof] = ACTIONS(1241),
    [anon_sym__Generic] = ACTIONS(1241),
    [anon_sym_asm] = ACTIONS(1241),
    [anon_sym___asm__] = ACTIONS(1241),
    [sym_number_literal] = ACTIONS(1243),
    [anon_sym_L_SQUOTE] = ACTIONS(1243),
    [anon_sym_u_SQUOTE] = ACTIONS(1243),
    [anon_sym_U_SQUOTE] = ACTIONS(1243),
    [anon_sym_u8_SQUOTE] = ACTIONS(1243),
    [anon_sym_SQUOTE] = ACTIONS(1243),
    [anon_sym_L_DQUOTE] = ACTIONS(1243),
    [anon_sym_u_DQUOTE] = ACTIONS(1243),
    [anon_sym_U_DQUOTE] = ACTIONS(1243),
    [anon_sym_u8_DQUOTE] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1243),
    [sym_true] = ACTIONS(1241),
    [sym_false] = ACTIONS(1241),
    [anon_sym_NULL] = ACTIONS(1241),
    [anon_sym_nullptr] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1241),
    [anon_sym_hitAttributeEXT] = ACTIONS(1241),
    [anon_sym_callableDataEXT] = ACTIONS(1241),
    [anon_sym_callableDataInEXT] = ACTIONS(1241),
    [anon_sym_shaderRecordEXT] = ACTIONS(1241),
    [anon_sym_rayPayloadNV] = ACTIONS(1241),
    [anon_sym_rayPayloadInNV] = ACTIONS(1241),
    [anon_sym_hitAttributeNV] = ACTIONS(1241),
    [anon_sym_callableDataNV] = ACTIONS(1241),
    [anon_sym_callableDataInNV] = ACTIONS(1241),
    [anon_sym_shaderRecordNV] = ACTIONS(1241),
    [anon_sym_layout] = ACTIONS(1241),
  },
  [303] = {
    [sym_identifier] = ACTIONS(1321),
    [aux_sym_preproc_include_token1] = ACTIONS(1321),
    [aux_sym_preproc_def_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token1] = ACTIONS(1321),
    [aux_sym_preproc_if_token2] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1321),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1321),
    [sym_preproc_directive] = ACTIONS(1321),
    [anon_sym_LPAREN2] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_TILDE] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_subroutine] = ACTIONS(1321),
    [anon_sym_invariant] = ACTIONS(1321),
    [anon_sym_precise] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1323),
    [anon_sym_in] = ACTIONS(1321),
    [anon_sym_out] = ACTIONS(1321),
    [anon_sym_inout] = ACTIONS(1321),
    [anon_sym_uniform] = ACTIONS(1321),
    [anon_sym_shared] = ACTIONS(1321),
    [anon_sym_attribute] = ACTIONS(1321),
    [anon_sym_varying] = ACTIONS(1321),
    [anon_sym_buffer] = ACTIONS(1321),
    [anon_sym_coherent] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_writeonly] = ACTIONS(1321),
    [anon_sym_precision] = ACTIONS(1321),
    [anon_sym_highp] = ACTIONS(1321),
    [anon_sym_mediump] = ACTIONS(1321),
    [anon_sym_lowp] = ACTIONS(1321),
    [anon_sym_centroid] = ACTIONS(1321),
    [anon_sym_sample] = ACTIONS(1321),
    [anon_sym_patch] = ACTIONS(1321),
    [anon_sym_smooth] = ACTIONS(1321),
    [anon_sym_flat] = ACTIONS(1321),
    [anon_sym_noperspective] = ACTIONS(1321),
    [anon_sym___extension__] = ACTIONS(1321),
    [anon_sym_typedef] = ACTIONS(1321),
    [anon_sym_extern] = ACTIONS(1321),
    [anon_sym___attribute__] = ACTIONS(1321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1323),
    [anon_sym___declspec] = ACTIONS(1321),
    [anon_sym___cdecl] = ACTIONS(1321),
    [anon_sym___clrcall] = ACTIONS(1321),
    [anon_sym___stdcall] = ACTIONS(1321),
    [anon_sym___fastcall] = ACTIONS(1321),
    [anon_sym___thiscall] = ACTIONS(1321),
    [anon_sym___vectorcall] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1323),
    [anon_sym_signed] = ACTIONS(1321),
    [anon_sym_unsigned] = ACTIONS(1321),
    [anon_sym_long] = ACTIONS(1321),
    [anon_sym_short] = ACTIONS(1321),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_auto] = ACTIONS(1321),
    [anon_sym_register] = ACTIONS(1321),
    [anon_sym_inline] = ACTIONS(1321),
    [anon_sym___inline] = ACTIONS(1321),
    [anon_sym___inline__] = ACTIONS(1321),
    [anon_sym___forceinline] = ACTIONS(1321),
    [anon_sym_thread_local] = ACTIONS(1321),
    [anon_sym___thread] = ACTIONS(1321),
    [anon_sym_const] = ACTIONS(1321),
    [anon_sym_constexpr] = ACTIONS(1321),
    [anon_sym_volatile] = ACTIONS(1321),
    [anon_sym_restrict] = ACTIONS(1321),
    [anon_sym___restrict__] = ACTIONS(1321),
    [anon_sym__Atomic] = ACTIONS(1321),
    [anon_sym__Noreturn] = ACTIONS(1321),
    [anon_sym_noreturn] = ACTIONS(1321),
    [anon_sym_alignas] = ACTIONS(1321),
    [anon_sym__Alignas] = ACTIONS(1321),
    [sym_primitive_type] = ACTIONS(1321),
    [anon_sym_enum] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1321),
    [anon_sym_union] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1321),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1321),
    [anon_sym_case] = ACTIONS(1321),
    [anon_sym_default] = ACTIONS(1321),
    [anon_sym_while] = ACTIONS(1321),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_for] = ACTIONS(1321),
    [anon_sym_return] = ACTIONS(1321),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_continue] = ACTIONS(1321),
    [anon_sym_goto] = ACTIONS(1321),
    [anon_sym___try] = ACTIONS(1321),
    [anon_sym___leave] = ACTIONS(1321),
    [anon_sym_DASH_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1323),
    [anon_sym_sizeof] = ACTIONS(1321),
    [anon_sym___alignof__] = ACTIONS(1321),
    [anon_sym___alignof] = ACTIONS(1321),
    [anon_sym__alignof] = ACTIONS(1321),
    [anon_sym_alignof] = ACTIONS(1321),
    [anon_sym__Alignof] = ACTIONS(1321),
    [anon_sym_offsetof] = ACTIONS(1321),
    [anon_sym__Generic] = ACTIONS(1321),
    [anon_sym_asm] = ACTIONS(1321),
    [anon_sym___asm__] = ACTIONS(1321),
    [sym_number_literal] = ACTIONS(1323),
    [anon_sym_L_SQUOTE] = ACTIONS(1323),
    [anon_sym_u_SQUOTE] = ACTIONS(1323),
    [anon_sym_U_SQUOTE] = ACTIONS(1323),
    [anon_sym_u8_SQUOTE] = ACTIONS(1323),
    [anon_sym_SQUOTE] = ACTIONS(1323),
    [anon_sym_L_DQUOTE] = ACTIONS(1323),
    [anon_sym_u_DQUOTE] = ACTIONS(1323),
    [anon_sym_U_DQUOTE] = ACTIONS(1323),
    [anon_sym_u8_DQUOTE] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1323),
    [sym_true] = ACTIONS(1321),
    [sym_false] = ACTIONS(1321),
    [anon_sym_NULL] = ACTIONS(1321),
    [anon_sym_nullptr] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1321),
    [anon_sym_hitAttributeEXT] = ACTIONS(1321),
    [anon_sym_callableDataEXT] = ACTIONS(1321),
    [anon_sym_callableDataInEXT] = ACTIONS(1321),
    [anon_sym_shaderRecordEXT] = ACTIONS(1321),
    [anon_sym_rayPayloadNV] = ACTIONS(1321),
    [anon_sym_rayPayloadInNV] = ACTIONS(1321),
    [anon_sym_hitAttributeNV] = ACTIONS(1321),
    [anon_sym_callableDataNV] = ACTIONS(1321),
    [anon_sym_callableDataInNV] = ACTIONS(1321),
    [anon_sym_shaderRecordNV] = ACTIONS(1321),
    [anon_sym_layout] = ACTIONS(1321),
  },
  [304] = {
    [sym_identifier] = ACTIONS(1313),
    [aux_sym_preproc_include_token1] = ACTIONS(1313),
    [aux_sym_preproc_def_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token1] = ACTIONS(1313),
    [aux_sym_preproc_if_token2] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1313),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1313),
    [sym_preproc_directive] = ACTIONS(1313),
    [anon_sym_LPAREN2] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1315),
    [anon_sym_TILDE] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1313),
    [anon_sym_PLUS] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(1315),
    [anon_sym_AMP] = ACTIONS(1315),
    [anon_sym_subroutine] = ACTIONS(1313),
    [anon_sym_invariant] = ACTIONS(1313),
    [anon_sym_precise] = ACTIONS(1313),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1313),
    [anon_sym_out] = ACTIONS(1313),
    [anon_sym_inout] = ACTIONS(1313),
    [anon_sym_uniform] = ACTIONS(1313),
    [anon_sym_shared] = ACTIONS(1313),
    [anon_sym_attribute] = ACTIONS(1313),
    [anon_sym_varying] = ACTIONS(1313),
    [anon_sym_buffer] = ACTIONS(1313),
    [anon_sym_coherent] = ACTIONS(1313),
    [anon_sym_readonly] = ACTIONS(1313),
    [anon_sym_writeonly] = ACTIONS(1313),
    [anon_sym_precision] = ACTIONS(1313),
    [anon_sym_highp] = ACTIONS(1313),
    [anon_sym_mediump] = ACTIONS(1313),
    [anon_sym_lowp] = ACTIONS(1313),
    [anon_sym_centroid] = ACTIONS(1313),
    [anon_sym_sample] = ACTIONS(1313),
    [anon_sym_patch] = ACTIONS(1313),
    [anon_sym_smooth] = ACTIONS(1313),
    [anon_sym_flat] = ACTIONS(1313),
    [anon_sym_noperspective] = ACTIONS(1313),
    [anon_sym___extension__] = ACTIONS(1313),
    [anon_sym_typedef] = ACTIONS(1313),
    [anon_sym_extern] = ACTIONS(1313),
    [anon_sym___attribute__] = ACTIONS(1313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1315),
    [anon_sym___declspec] = ACTIONS(1313),
    [anon_sym___cdecl] = ACTIONS(1313),
    [anon_sym___clrcall] = ACTIONS(1313),
    [anon_sym___stdcall] = ACTIONS(1313),
    [anon_sym___fastcall] = ACTIONS(1313),
    [anon_sym___thiscall] = ACTIONS(1313),
    [anon_sym___vectorcall] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_signed] = ACTIONS(1313),
    [anon_sym_unsigned] = ACTIONS(1313),
    [anon_sym_long] = ACTIONS(1313),
    [anon_sym_short] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1313),
    [anon_sym_auto] = ACTIONS(1313),
    [anon_sym_register] = ACTIONS(1313),
    [anon_sym_inline] = ACTIONS(1313),
    [anon_sym___inline] = ACTIONS(1313),
    [anon_sym___inline__] = ACTIONS(1313),
    [anon_sym___forceinline] = ACTIONS(1313),
    [anon_sym_thread_local] = ACTIONS(1313),
    [anon_sym___thread] = ACTIONS(1313),
    [anon_sym_const] = ACTIONS(1313),
    [anon_sym_constexpr] = ACTIONS(1313),
    [anon_sym_volatile] = ACTIONS(1313),
    [anon_sym_restrict] = ACTIONS(1313),
    [anon_sym___restrict__] = ACTIONS(1313),
    [anon_sym__Atomic] = ACTIONS(1313),
    [anon_sym__Noreturn] = ACTIONS(1313),
    [anon_sym_noreturn] = ACTIONS(1313),
    [anon_sym_alignas] = ACTIONS(1313),
    [anon_sym__Alignas] = ACTIONS(1313),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1313),
    [anon_sym_union] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1313),
    [anon_sym_else] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1313),
    [anon_sym_case] = ACTIONS(1313),
    [anon_sym_default] = ACTIONS(1313),
    [anon_sym_while] = ACTIONS(1313),
    [anon_sym_do] = ACTIONS(1313),
    [anon_sym_for] = ACTIONS(1313),
    [anon_sym_return] = ACTIONS(1313),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1313),
    [anon_sym_goto] = ACTIONS(1313),
    [anon_sym___try] = ACTIONS(1313),
    [anon_sym___leave] = ACTIONS(1313),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_sizeof] = ACTIONS(1313),
    [anon_sym___alignof__] = ACTIONS(1313),
    [anon_sym___alignof] = ACTIONS(1313),
    [anon_sym__alignof] = ACTIONS(1313),
    [anon_sym_alignof] = ACTIONS(1313),
    [anon_sym__Alignof] = ACTIONS(1313),
    [anon_sym_offsetof] = ACTIONS(1313),
    [anon_sym__Generic] = ACTIONS(1313),
    [anon_sym_asm] = ACTIONS(1313),
    [anon_sym___asm__] = ACTIONS(1313),
    [sym_number_literal] = ACTIONS(1315),
    [anon_sym_L_SQUOTE] = ACTIONS(1315),
    [anon_sym_u_SQUOTE] = ACTIONS(1315),
    [anon_sym_U_SQUOTE] = ACTIONS(1315),
    [anon_sym_u8_SQUOTE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(1315),
    [anon_sym_L_DQUOTE] = ACTIONS(1315),
    [anon_sym_u_DQUOTE] = ACTIONS(1315),
    [anon_sym_U_DQUOTE] = ACTIONS(1315),
    [anon_sym_u8_DQUOTE] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1315),
    [sym_true] = ACTIONS(1313),
    [sym_false] = ACTIONS(1313),
    [anon_sym_NULL] = ACTIONS(1313),
    [anon_sym_nullptr] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1313),
    [anon_sym_hitAttributeEXT] = ACTIONS(1313),
    [anon_sym_callableDataEXT] = ACTIONS(1313),
    [anon_sym_callableDataInEXT] = ACTIONS(1313),
    [anon_sym_shaderRecordEXT] = ACTIONS(1313),
    [anon_sym_rayPayloadNV] = ACTIONS(1313),
    [anon_sym_rayPayloadInNV] = ACTIONS(1313),
    [anon_sym_hitAttributeNV] = ACTIONS(1313),
    [anon_sym_callableDataNV] = ACTIONS(1313),
    [anon_sym_callableDataInNV] = ACTIONS(1313),
    [anon_sym_shaderRecordNV] = ACTIONS(1313),
    [anon_sym_layout] = ACTIONS(1313),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1309),
    [aux_sym_preproc_include_token1] = ACTIONS(1309),
    [aux_sym_preproc_def_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token1] = ACTIONS(1309),
    [aux_sym_preproc_if_token2] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1309),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1309),
    [sym_preproc_directive] = ACTIONS(1309),
    [anon_sym_LPAREN2] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_subroutine] = ACTIONS(1309),
    [anon_sym_invariant] = ACTIONS(1309),
    [anon_sym_precise] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1311),
    [anon_sym_in] = ACTIONS(1309),
    [anon_sym_out] = ACTIONS(1309),
    [anon_sym_inout] = ACTIONS(1309),
    [anon_sym_uniform] = ACTIONS(1309),
    [anon_sym_shared] = ACTIONS(1309),
    [anon_sym_attribute] = ACTIONS(1309),
    [anon_sym_varying] = ACTIONS(1309),
    [anon_sym_buffer] = ACTIONS(1309),
    [anon_sym_coherent] = ACTIONS(1309),
    [anon_sym_readonly] = ACTIONS(1309),
    [anon_sym_writeonly] = ACTIONS(1309),
    [anon_sym_precision] = ACTIONS(1309),
    [anon_sym_highp] = ACTIONS(1309),
    [anon_sym_mediump] = ACTIONS(1309),
    [anon_sym_lowp] = ACTIONS(1309),
    [anon_sym_centroid] = ACTIONS(1309),
    [anon_sym_sample] = ACTIONS(1309),
    [anon_sym_patch] = ACTIONS(1309),
    [anon_sym_smooth] = ACTIONS(1309),
    [anon_sym_flat] = ACTIONS(1309),
    [anon_sym_noperspective] = ACTIONS(1309),
    [anon_sym___extension__] = ACTIONS(1309),
    [anon_sym_typedef] = ACTIONS(1309),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym___attribute__] = ACTIONS(1309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1311),
    [anon_sym___declspec] = ACTIONS(1309),
    [anon_sym___cdecl] = ACTIONS(1309),
    [anon_sym___clrcall] = ACTIONS(1309),
    [anon_sym___stdcall] = ACTIONS(1309),
    [anon_sym___fastcall] = ACTIONS(1309),
    [anon_sym___thiscall] = ACTIONS(1309),
    [anon_sym___vectorcall] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1311),
    [anon_sym_signed] = ACTIONS(1309),
    [anon_sym_unsigned] = ACTIONS(1309),
    [anon_sym_long] = ACTIONS(1309),
    [anon_sym_short] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_auto] = ACTIONS(1309),
    [anon_sym_register] = ACTIONS(1309),
    [anon_sym_inline] = ACTIONS(1309),
    [anon_sym___inline] = ACTIONS(1309),
    [anon_sym___inline__] = ACTIONS(1309),
    [anon_sym___forceinline] = ACTIONS(1309),
    [anon_sym_thread_local] = ACTIONS(1309),
    [anon_sym___thread] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_constexpr] = ACTIONS(1309),
    [anon_sym_volatile] = ACTIONS(1309),
    [anon_sym_restrict] = ACTIONS(1309),
    [anon_sym___restrict__] = ACTIONS(1309),
    [anon_sym__Atomic] = ACTIONS(1309),
    [anon_sym__Noreturn] = ACTIONS(1309),
    [anon_sym_noreturn] = ACTIONS(1309),
    [anon_sym_alignas] = ACTIONS(1309),
    [anon_sym__Alignas] = ACTIONS(1309),
    [sym_primitive_type] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_else] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1309),
    [anon_sym_case] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_do] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_goto] = ACTIONS(1309),
    [anon_sym___try] = ACTIONS(1309),
    [anon_sym___leave] = ACTIONS(1309),
    [anon_sym_DASH_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1311),
    [anon_sym_sizeof] = ACTIONS(1309),
    [anon_sym___alignof__] = ACTIONS(1309),
    [anon_sym___alignof] = ACTIONS(1309),
    [anon_sym__alignof] = ACTIONS(1309),
    [anon_sym_alignof] = ACTIONS(1309),
    [anon_sym__Alignof] = ACTIONS(1309),
    [anon_sym_offsetof] = ACTIONS(1309),
    [anon_sym__Generic] = ACTIONS(1309),
    [anon_sym_asm] = ACTIONS(1309),
    [anon_sym___asm__] = ACTIONS(1309),
    [sym_number_literal] = ACTIONS(1311),
    [anon_sym_L_SQUOTE] = ACTIONS(1311),
    [anon_sym_u_SQUOTE] = ACTIONS(1311),
    [anon_sym_U_SQUOTE] = ACTIONS(1311),
    [anon_sym_u8_SQUOTE] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_L_DQUOTE] = ACTIONS(1311),
    [anon_sym_u_DQUOTE] = ACTIONS(1311),
    [anon_sym_U_DQUOTE] = ACTIONS(1311),
    [anon_sym_u8_DQUOTE] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1311),
    [sym_true] = ACTIONS(1309),
    [sym_false] = ACTIONS(1309),
    [anon_sym_NULL] = ACTIONS(1309),
    [anon_sym_nullptr] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1309),
    [anon_sym_hitAttributeEXT] = ACTIONS(1309),
    [anon_sym_callableDataEXT] = ACTIONS(1309),
    [anon_sym_callableDataInEXT] = ACTIONS(1309),
    [anon_sym_shaderRecordEXT] = ACTIONS(1309),
    [anon_sym_rayPayloadNV] = ACTIONS(1309),
    [anon_sym_rayPayloadInNV] = ACTIONS(1309),
    [anon_sym_hitAttributeNV] = ACTIONS(1309),
    [anon_sym_callableDataNV] = ACTIONS(1309),
    [anon_sym_callableDataInNV] = ACTIONS(1309),
    [anon_sym_shaderRecordNV] = ACTIONS(1309),
    [anon_sym_layout] = ACTIONS(1309),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1305),
    [aux_sym_preproc_include_token1] = ACTIONS(1305),
    [aux_sym_preproc_def_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token1] = ACTIONS(1305),
    [aux_sym_preproc_if_token2] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1305),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1305),
    [sym_preproc_directive] = ACTIONS(1305),
    [anon_sym_LPAREN2] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_TILDE] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1305),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_subroutine] = ACTIONS(1305),
    [anon_sym_invariant] = ACTIONS(1305),
    [anon_sym_precise] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_in] = ACTIONS(1305),
    [anon_sym_out] = ACTIONS(1305),
    [anon_sym_inout] = ACTIONS(1305),
    [anon_sym_uniform] = ACTIONS(1305),
    [anon_sym_shared] = ACTIONS(1305),
    [anon_sym_attribute] = ACTIONS(1305),
    [anon_sym_varying] = ACTIONS(1305),
    [anon_sym_buffer] = ACTIONS(1305),
    [anon_sym_coherent] = ACTIONS(1305),
    [anon_sym_readonly] = ACTIONS(1305),
    [anon_sym_writeonly] = ACTIONS(1305),
    [anon_sym_precision] = ACTIONS(1305),
    [anon_sym_highp] = ACTIONS(1305),
    [anon_sym_mediump] = ACTIONS(1305),
    [anon_sym_lowp] = ACTIONS(1305),
    [anon_sym_centroid] = ACTIONS(1305),
    [anon_sym_sample] = ACTIONS(1305),
    [anon_sym_patch] = ACTIONS(1305),
    [anon_sym_smooth] = ACTIONS(1305),
    [anon_sym_flat] = ACTIONS(1305),
    [anon_sym_noperspective] = ACTIONS(1305),
    [anon_sym___extension__] = ACTIONS(1305),
    [anon_sym_typedef] = ACTIONS(1305),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym___attribute__] = ACTIONS(1305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1307),
    [anon_sym___declspec] = ACTIONS(1305),
    [anon_sym___cdecl] = ACTIONS(1305),
    [anon_sym___clrcall] = ACTIONS(1305),
    [anon_sym___stdcall] = ACTIONS(1305),
    [anon_sym___fastcall] = ACTIONS(1305),
    [anon_sym___thiscall] = ACTIONS(1305),
    [anon_sym___vectorcall] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1305),
    [anon_sym_unsigned] = ACTIONS(1305),
    [anon_sym_long] = ACTIONS(1305),
    [anon_sym_short] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_auto] = ACTIONS(1305),
    [anon_sym_register] = ACTIONS(1305),
    [anon_sym_inline] = ACTIONS(1305),
    [anon_sym___inline] = ACTIONS(1305),
    [anon_sym___inline__] = ACTIONS(1305),
    [anon_sym___forceinline] = ACTIONS(1305),
    [anon_sym_thread_local] = ACTIONS(1305),
    [anon_sym___thread] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_constexpr] = ACTIONS(1305),
    [anon_sym_volatile] = ACTIONS(1305),
    [anon_sym_restrict] = ACTIONS(1305),
    [anon_sym___restrict__] = ACTIONS(1305),
    [anon_sym__Atomic] = ACTIONS(1305),
    [anon_sym__Noreturn] = ACTIONS(1305),
    [anon_sym_noreturn] = ACTIONS(1305),
    [anon_sym_alignas] = ACTIONS(1305),
    [anon_sym__Alignas] = ACTIONS(1305),
    [sym_primitive_type] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_else] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1305),
    [anon_sym_case] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_do] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_goto] = ACTIONS(1305),
    [anon_sym___try] = ACTIONS(1305),
    [anon_sym___leave] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1307),
    [anon_sym_sizeof] = ACTIONS(1305),
    [anon_sym___alignof__] = ACTIONS(1305),
    [anon_sym___alignof] = ACTIONS(1305),
    [anon_sym__alignof] = ACTIONS(1305),
    [anon_sym_alignof] = ACTIONS(1305),
    [anon_sym__Alignof] = ACTIONS(1305),
    [anon_sym_offsetof] = ACTIONS(1305),
    [anon_sym__Generic] = ACTIONS(1305),
    [anon_sym_asm] = ACTIONS(1305),
    [anon_sym___asm__] = ACTIONS(1305),
    [sym_number_literal] = ACTIONS(1307),
    [anon_sym_L_SQUOTE] = ACTIONS(1307),
    [anon_sym_u_SQUOTE] = ACTIONS(1307),
    [anon_sym_U_SQUOTE] = ACTIONS(1307),
    [anon_sym_u8_SQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1307),
    [anon_sym_L_DQUOTE] = ACTIONS(1307),
    [anon_sym_u_DQUOTE] = ACTIONS(1307),
    [anon_sym_U_DQUOTE] = ACTIONS(1307),
    [anon_sym_u8_DQUOTE] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1307),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [anon_sym_NULL] = ACTIONS(1305),
    [anon_sym_nullptr] = ACTIONS(1305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1305),
    [anon_sym_hitAttributeEXT] = ACTIONS(1305),
    [anon_sym_callableDataEXT] = ACTIONS(1305),
    [anon_sym_callableDataInEXT] = ACTIONS(1305),
    [anon_sym_shaderRecordEXT] = ACTIONS(1305),
    [anon_sym_rayPayloadNV] = ACTIONS(1305),
    [anon_sym_rayPayloadInNV] = ACTIONS(1305),
    [anon_sym_hitAttributeNV] = ACTIONS(1305),
    [anon_sym_callableDataNV] = ACTIONS(1305),
    [anon_sym_callableDataInNV] = ACTIONS(1305),
    [anon_sym_shaderRecordNV] = ACTIONS(1305),
    [anon_sym_layout] = ACTIONS(1305),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(1343),
    [sym_identifier] = ACTIONS(1341),
    [aux_sym_preproc_include_token1] = ACTIONS(1341),
    [aux_sym_preproc_def_token1] = ACTIONS(1341),
    [aux_sym_preproc_if_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1341),
    [sym_preproc_directive] = ACTIONS(1341),
    [anon_sym_LPAREN2] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_TILDE] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_subroutine] = ACTIONS(1341),
    [anon_sym_invariant] = ACTIONS(1341),
    [anon_sym_precise] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_in] = ACTIONS(1341),
    [anon_sym_out] = ACTIONS(1341),
    [anon_sym_inout] = ACTIONS(1341),
    [anon_sym_uniform] = ACTIONS(1341),
    [anon_sym_shared] = ACTIONS(1341),
    [anon_sym_attribute] = ACTIONS(1341),
    [anon_sym_varying] = ACTIONS(1341),
    [anon_sym_buffer] = ACTIONS(1341),
    [anon_sym_coherent] = ACTIONS(1341),
    [anon_sym_readonly] = ACTIONS(1341),
    [anon_sym_writeonly] = ACTIONS(1341),
    [anon_sym_precision] = ACTIONS(1341),
    [anon_sym_highp] = ACTIONS(1341),
    [anon_sym_mediump] = ACTIONS(1341),
    [anon_sym_lowp] = ACTIONS(1341),
    [anon_sym_centroid] = ACTIONS(1341),
    [anon_sym_sample] = ACTIONS(1341),
    [anon_sym_patch] = ACTIONS(1341),
    [anon_sym_smooth] = ACTIONS(1341),
    [anon_sym_flat] = ACTIONS(1341),
    [anon_sym_noperspective] = ACTIONS(1341),
    [anon_sym___extension__] = ACTIONS(1341),
    [anon_sym_typedef] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1341),
    [anon_sym___attribute__] = ACTIONS(1341),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1343),
    [anon_sym___declspec] = ACTIONS(1341),
    [anon_sym___cdecl] = ACTIONS(1341),
    [anon_sym___clrcall] = ACTIONS(1341),
    [anon_sym___stdcall] = ACTIONS(1341),
    [anon_sym___fastcall] = ACTIONS(1341),
    [anon_sym___thiscall] = ACTIONS(1341),
    [anon_sym___vectorcall] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_signed] = ACTIONS(1341),
    [anon_sym_unsigned] = ACTIONS(1341),
    [anon_sym_long] = ACTIONS(1341),
    [anon_sym_short] = ACTIONS(1341),
    [anon_sym_static] = ACTIONS(1341),
    [anon_sym_auto] = ACTIONS(1341),
    [anon_sym_register] = ACTIONS(1341),
    [anon_sym_inline] = ACTIONS(1341),
    [anon_sym___inline] = ACTIONS(1341),
    [anon_sym___inline__] = ACTIONS(1341),
    [anon_sym___forceinline] = ACTIONS(1341),
    [anon_sym_thread_local] = ACTIONS(1341),
    [anon_sym___thread] = ACTIONS(1341),
    [anon_sym_const] = ACTIONS(1341),
    [anon_sym_constexpr] = ACTIONS(1341),
    [anon_sym_volatile] = ACTIONS(1341),
    [anon_sym_restrict] = ACTIONS(1341),
    [anon_sym___restrict__] = ACTIONS(1341),
    [anon_sym__Atomic] = ACTIONS(1341),
    [anon_sym__Noreturn] = ACTIONS(1341),
    [anon_sym_noreturn] = ACTIONS(1341),
    [anon_sym_alignas] = ACTIONS(1341),
    [anon_sym__Alignas] = ACTIONS(1341),
    [sym_primitive_type] = ACTIONS(1341),
    [anon_sym_enum] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1341),
    [anon_sym_union] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1341),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1341),
    [anon_sym_case] = ACTIONS(1341),
    [anon_sym_default] = ACTIONS(1341),
    [anon_sym_while] = ACTIONS(1341),
    [anon_sym_do] = ACTIONS(1341),
    [anon_sym_for] = ACTIONS(1341),
    [anon_sym_return] = ACTIONS(1341),
    [anon_sym_break] = ACTIONS(1341),
    [anon_sym_continue] = ACTIONS(1341),
    [anon_sym_goto] = ACTIONS(1341),
    [anon_sym___try] = ACTIONS(1341),
    [anon_sym___leave] = ACTIONS(1341),
    [anon_sym_DASH_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1343),
    [anon_sym_sizeof] = ACTIONS(1341),
    [anon_sym___alignof__] = ACTIONS(1341),
    [anon_sym___alignof] = ACTIONS(1341),
    [anon_sym__alignof] = ACTIONS(1341),
    [anon_sym_alignof] = ACTIONS(1341),
    [anon_sym__Alignof] = ACTIONS(1341),
    [anon_sym_offsetof] = ACTIONS(1341),
    [anon_sym__Generic] = ACTIONS(1341),
    [anon_sym_asm] = ACTIONS(1341),
    [anon_sym___asm__] = ACTIONS(1341),
    [sym_number_literal] = ACTIONS(1343),
    [anon_sym_L_SQUOTE] = ACTIONS(1343),
    [anon_sym_u_SQUOTE] = ACTIONS(1343),
    [anon_sym_U_SQUOTE] = ACTIONS(1343),
    [anon_sym_u8_SQUOTE] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_L_DQUOTE] = ACTIONS(1343),
    [anon_sym_u_DQUOTE] = ACTIONS(1343),
    [anon_sym_U_DQUOTE] = ACTIONS(1343),
    [anon_sym_u8_DQUOTE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_true] = ACTIONS(1341),
    [sym_false] = ACTIONS(1341),
    [anon_sym_NULL] = ACTIONS(1341),
    [anon_sym_nullptr] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1341),
    [anon_sym_hitAttributeEXT] = ACTIONS(1341),
    [anon_sym_callableDataEXT] = ACTIONS(1341),
    [anon_sym_callableDataInEXT] = ACTIONS(1341),
    [anon_sym_shaderRecordEXT] = ACTIONS(1341),
    [anon_sym_rayPayloadNV] = ACTIONS(1341),
    [anon_sym_rayPayloadInNV] = ACTIONS(1341),
    [anon_sym_hitAttributeNV] = ACTIONS(1341),
    [anon_sym_callableDataNV] = ACTIONS(1341),
    [anon_sym_callableDataInNV] = ACTIONS(1341),
    [anon_sym_shaderRecordNV] = ACTIONS(1341),
    [anon_sym_layout] = ACTIONS(1341),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(1347),
    [sym_identifier] = ACTIONS(1345),
    [aux_sym_preproc_include_token1] = ACTIONS(1345),
    [aux_sym_preproc_def_token1] = ACTIONS(1345),
    [aux_sym_preproc_if_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1345),
    [sym_preproc_directive] = ACTIONS(1345),
    [anon_sym_LPAREN2] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_subroutine] = ACTIONS(1345),
    [anon_sym_invariant] = ACTIONS(1345),
    [anon_sym_precise] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1347),
    [anon_sym_in] = ACTIONS(1345),
    [anon_sym_out] = ACTIONS(1345),
    [anon_sym_inout] = ACTIONS(1345),
    [anon_sym_uniform] = ACTIONS(1345),
    [anon_sym_shared] = ACTIONS(1345),
    [anon_sym_attribute] = ACTIONS(1345),
    [anon_sym_varying] = ACTIONS(1345),
    [anon_sym_buffer] = ACTIONS(1345),
    [anon_sym_coherent] = ACTIONS(1345),
    [anon_sym_readonly] = ACTIONS(1345),
    [anon_sym_writeonly] = ACTIONS(1345),
    [anon_sym_precision] = ACTIONS(1345),
    [anon_sym_highp] = ACTIONS(1345),
    [anon_sym_mediump] = ACTIONS(1345),
    [anon_sym_lowp] = ACTIONS(1345),
    [anon_sym_centroid] = ACTIONS(1345),
    [anon_sym_sample] = ACTIONS(1345),
    [anon_sym_patch] = ACTIONS(1345),
    [anon_sym_smooth] = ACTIONS(1345),
    [anon_sym_flat] = ACTIONS(1345),
    [anon_sym_noperspective] = ACTIONS(1345),
    [anon_sym___extension__] = ACTIONS(1345),
    [anon_sym_typedef] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1345),
    [anon_sym___attribute__] = ACTIONS(1345),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1347),
    [anon_sym___declspec] = ACTIONS(1345),
    [anon_sym___cdecl] = ACTIONS(1345),
    [anon_sym___clrcall] = ACTIONS(1345),
    [anon_sym___stdcall] = ACTIONS(1345),
    [anon_sym___fastcall] = ACTIONS(1345),
    [anon_sym___thiscall] = ACTIONS(1345),
    [anon_sym___vectorcall] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_signed] = ACTIONS(1345),
    [anon_sym_unsigned] = ACTIONS(1345),
    [anon_sym_long] = ACTIONS(1345),
    [anon_sym_short] = ACTIONS(1345),
    [anon_sym_static] = ACTIONS(1345),
    [anon_sym_auto] = ACTIONS(1345),
    [anon_sym_register] = ACTIONS(1345),
    [anon_sym_inline] = ACTIONS(1345),
    [anon_sym___inline] = ACTIONS(1345),
    [anon_sym___inline__] = ACTIONS(1345),
    [anon_sym___forceinline] = ACTIONS(1345),
    [anon_sym_thread_local] = ACTIONS(1345),
    [anon_sym___thread] = ACTIONS(1345),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_constexpr] = ACTIONS(1345),
    [anon_sym_volatile] = ACTIONS(1345),
    [anon_sym_restrict] = ACTIONS(1345),
    [anon_sym___restrict__] = ACTIONS(1345),
    [anon_sym__Atomic] = ACTIONS(1345),
    [anon_sym__Noreturn] = ACTIONS(1345),
    [anon_sym_noreturn] = ACTIONS(1345),
    [anon_sym_alignas] = ACTIONS(1345),
    [anon_sym__Alignas] = ACTIONS(1345),
    [sym_primitive_type] = ACTIONS(1345),
    [anon_sym_enum] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1345),
    [anon_sym_union] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_break] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_goto] = ACTIONS(1345),
    [anon_sym___try] = ACTIONS(1345),
    [anon_sym___leave] = ACTIONS(1345),
    [anon_sym_DASH_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1347),
    [anon_sym_sizeof] = ACTIONS(1345),
    [anon_sym___alignof__] = ACTIONS(1345),
    [anon_sym___alignof] = ACTIONS(1345),
    [anon_sym__alignof] = ACTIONS(1345),
    [anon_sym_alignof] = ACTIONS(1345),
    [anon_sym__Alignof] = ACTIONS(1345),
    [anon_sym_offsetof] = ACTIONS(1345),
    [anon_sym__Generic] = ACTIONS(1345),
    [anon_sym_asm] = ACTIONS(1345),
    [anon_sym___asm__] = ACTIONS(1345),
    [sym_number_literal] = ACTIONS(1347),
    [anon_sym_L_SQUOTE] = ACTIONS(1347),
    [anon_sym_u_SQUOTE] = ACTIONS(1347),
    [anon_sym_U_SQUOTE] = ACTIONS(1347),
    [anon_sym_u8_SQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_L_DQUOTE] = ACTIONS(1347),
    [anon_sym_u_DQUOTE] = ACTIONS(1347),
    [anon_sym_U_DQUOTE] = ACTIONS(1347),
    [anon_sym_u8_DQUOTE] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_true] = ACTIONS(1345),
    [sym_false] = ACTIONS(1345),
    [anon_sym_NULL] = ACTIONS(1345),
    [anon_sym_nullptr] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1345),
    [anon_sym_hitAttributeEXT] = ACTIONS(1345),
    [anon_sym_callableDataEXT] = ACTIONS(1345),
    [anon_sym_callableDataInEXT] = ACTIONS(1345),
    [anon_sym_shaderRecordEXT] = ACTIONS(1345),
    [anon_sym_rayPayloadNV] = ACTIONS(1345),
    [anon_sym_rayPayloadInNV] = ACTIONS(1345),
    [anon_sym_hitAttributeNV] = ACTIONS(1345),
    [anon_sym_callableDataNV] = ACTIONS(1345),
    [anon_sym_callableDataInNV] = ACTIONS(1345),
    [anon_sym_shaderRecordNV] = ACTIONS(1345),
    [anon_sym_layout] = ACTIONS(1345),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1317),
    [aux_sym_preproc_include_token1] = ACTIONS(1317),
    [aux_sym_preproc_def_token1] = ACTIONS(1317),
    [aux_sym_preproc_if_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1317),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1317),
    [sym_preproc_directive] = ACTIONS(1317),
    [anon_sym_LPAREN2] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_subroutine] = ACTIONS(1317),
    [anon_sym_invariant] = ACTIONS(1317),
    [anon_sym_precise] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1319),
    [anon_sym_in] = ACTIONS(1317),
    [anon_sym_out] = ACTIONS(1317),
    [anon_sym_inout] = ACTIONS(1317),
    [anon_sym_uniform] = ACTIONS(1317),
    [anon_sym_shared] = ACTIONS(1317),
    [anon_sym_attribute] = ACTIONS(1317),
    [anon_sym_varying] = ACTIONS(1317),
    [anon_sym_buffer] = ACTIONS(1317),
    [anon_sym_coherent] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_writeonly] = ACTIONS(1317),
    [anon_sym_precision] = ACTIONS(1317),
    [anon_sym_highp] = ACTIONS(1317),
    [anon_sym_mediump] = ACTIONS(1317),
    [anon_sym_lowp] = ACTIONS(1317),
    [anon_sym_centroid] = ACTIONS(1317),
    [anon_sym_sample] = ACTIONS(1317),
    [anon_sym_patch] = ACTIONS(1317),
    [anon_sym_smooth] = ACTIONS(1317),
    [anon_sym_flat] = ACTIONS(1317),
    [anon_sym_noperspective] = ACTIONS(1317),
    [anon_sym___extension__] = ACTIONS(1317),
    [anon_sym_typedef] = ACTIONS(1317),
    [anon_sym_extern] = ACTIONS(1317),
    [anon_sym___attribute__] = ACTIONS(1317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1319),
    [anon_sym___declspec] = ACTIONS(1317),
    [anon_sym___cdecl] = ACTIONS(1317),
    [anon_sym___clrcall] = ACTIONS(1317),
    [anon_sym___stdcall] = ACTIONS(1317),
    [anon_sym___fastcall] = ACTIONS(1317),
    [anon_sym___thiscall] = ACTIONS(1317),
    [anon_sym___vectorcall] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_RBRACE] = ACTIONS(1319),
    [anon_sym_signed] = ACTIONS(1317),
    [anon_sym_unsigned] = ACTIONS(1317),
    [anon_sym_long] = ACTIONS(1317),
    [anon_sym_short] = ACTIONS(1317),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_auto] = ACTIONS(1317),
    [anon_sym_register] = ACTIONS(1317),
    [anon_sym_inline] = ACTIONS(1317),
    [anon_sym___inline] = ACTIONS(1317),
    [anon_sym___inline__] = ACTIONS(1317),
    [anon_sym___forceinline] = ACTIONS(1317),
    [anon_sym_thread_local] = ACTIONS(1317),
    [anon_sym___thread] = ACTIONS(1317),
    [anon_sym_const] = ACTIONS(1317),
    [anon_sym_constexpr] = ACTIONS(1317),
    [anon_sym_volatile] = ACTIONS(1317),
    [anon_sym_restrict] = ACTIONS(1317),
    [anon_sym___restrict__] = ACTIONS(1317),
    [anon_sym__Atomic] = ACTIONS(1317),
    [anon_sym__Noreturn] = ACTIONS(1317),
    [anon_sym_noreturn] = ACTIONS(1317),
    [anon_sym_alignas] = ACTIONS(1317),
    [anon_sym__Alignas] = ACTIONS(1317),
    [sym_primitive_type] = ACTIONS(1317),
    [anon_sym_enum] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1317),
    [anon_sym_union] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1317),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1317),
    [anon_sym_case] = ACTIONS(1317),
    [anon_sym_default] = ACTIONS(1317),
    [anon_sym_while] = ACTIONS(1317),
    [anon_sym_do] = ACTIONS(1317),
    [anon_sym_for] = ACTIONS(1317),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_break] = ACTIONS(1317),
    [anon_sym_continue] = ACTIONS(1317),
    [anon_sym_goto] = ACTIONS(1317),
    [anon_sym___try] = ACTIONS(1317),
    [anon_sym___leave] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_sizeof] = ACTIONS(1317),
    [anon_sym___alignof__] = ACTIONS(1317),
    [anon_sym___alignof] = ACTIONS(1317),
    [anon_sym__alignof] = ACTIONS(1317),
    [anon_sym_alignof] = ACTIONS(1317),
    [anon_sym__Alignof] = ACTIONS(1317),
    [anon_sym_offsetof] = ACTIONS(1317),
    [anon_sym__Generic] = ACTIONS(1317),
    [anon_sym_asm] = ACTIONS(1317),
    [anon_sym___asm__] = ACTIONS(1317),
    [sym_number_literal] = ACTIONS(1319),
    [anon_sym_L_SQUOTE] = ACTIONS(1319),
    [anon_sym_u_SQUOTE] = ACTIONS(1319),
    [anon_sym_U_SQUOTE] = ACTIONS(1319),
    [anon_sym_u8_SQUOTE] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(1319),
    [anon_sym_L_DQUOTE] = ACTIONS(1319),
    [anon_sym_u_DQUOTE] = ACTIONS(1319),
    [anon_sym_U_DQUOTE] = ACTIONS(1319),
    [anon_sym_u8_DQUOTE] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1319),
    [sym_true] = ACTIONS(1317),
    [sym_false] = ACTIONS(1317),
    [anon_sym_NULL] = ACTIONS(1317),
    [anon_sym_nullptr] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1317),
    [anon_sym_hitAttributeEXT] = ACTIONS(1317),
    [anon_sym_callableDataEXT] = ACTIONS(1317),
    [anon_sym_callableDataInEXT] = ACTIONS(1317),
    [anon_sym_shaderRecordEXT] = ACTIONS(1317),
    [anon_sym_rayPayloadNV] = ACTIONS(1317),
    [anon_sym_rayPayloadInNV] = ACTIONS(1317),
    [anon_sym_hitAttributeNV] = ACTIONS(1317),
    [anon_sym_callableDataNV] = ACTIONS(1317),
    [anon_sym_callableDataInNV] = ACTIONS(1317),
    [anon_sym_shaderRecordNV] = ACTIONS(1317),
    [anon_sym_layout] = ACTIONS(1317),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1233),
    [aux_sym_preproc_include_token1] = ACTIONS(1233),
    [aux_sym_preproc_def_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token1] = ACTIONS(1233),
    [aux_sym_preproc_if_token2] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1233),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1233),
    [sym_preproc_directive] = ACTIONS(1233),
    [anon_sym_LPAREN2] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_subroutine] = ACTIONS(1233),
    [anon_sym_invariant] = ACTIONS(1233),
    [anon_sym_precise] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1233),
    [anon_sym_out] = ACTIONS(1233),
    [anon_sym_inout] = ACTIONS(1233),
    [anon_sym_uniform] = ACTIONS(1233),
    [anon_sym_shared] = ACTIONS(1233),
    [anon_sym_attribute] = ACTIONS(1233),
    [anon_sym_varying] = ACTIONS(1233),
    [anon_sym_buffer] = ACTIONS(1233),
    [anon_sym_coherent] = ACTIONS(1233),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_writeonly] = ACTIONS(1233),
    [anon_sym_precision] = ACTIONS(1233),
    [anon_sym_highp] = ACTIONS(1233),
    [anon_sym_mediump] = ACTIONS(1233),
    [anon_sym_lowp] = ACTIONS(1233),
    [anon_sym_centroid] = ACTIONS(1233),
    [anon_sym_sample] = ACTIONS(1233),
    [anon_sym_patch] = ACTIONS(1233),
    [anon_sym_smooth] = ACTIONS(1233),
    [anon_sym_flat] = ACTIONS(1233),
    [anon_sym_noperspective] = ACTIONS(1233),
    [anon_sym___extension__] = ACTIONS(1233),
    [anon_sym_typedef] = ACTIONS(1233),
    [anon_sym_extern] = ACTIONS(1233),
    [anon_sym___attribute__] = ACTIONS(1233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym___declspec] = ACTIONS(1233),
    [anon_sym___cdecl] = ACTIONS(1233),
    [anon_sym___clrcall] = ACTIONS(1233),
    [anon_sym___stdcall] = ACTIONS(1233),
    [anon_sym___fastcall] = ACTIONS(1233),
    [anon_sym___thiscall] = ACTIONS(1233),
    [anon_sym___vectorcall] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_signed] = ACTIONS(1233),
    [anon_sym_unsigned] = ACTIONS(1233),
    [anon_sym_long] = ACTIONS(1233),
    [anon_sym_short] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1233),
    [anon_sym_auto] = ACTIONS(1233),
    [anon_sym_register] = ACTIONS(1233),
    [anon_sym_inline] = ACTIONS(1233),
    [anon_sym___inline] = ACTIONS(1233),
    [anon_sym___inline__] = ACTIONS(1233),
    [anon_sym___forceinline] = ACTIONS(1233),
    [anon_sym_thread_local] = ACTIONS(1233),
    [anon_sym___thread] = ACTIONS(1233),
    [anon_sym_const] = ACTIONS(1233),
    [anon_sym_constexpr] = ACTIONS(1233),
    [anon_sym_volatile] = ACTIONS(1233),
    [anon_sym_restrict] = ACTIONS(1233),
    [anon_sym___restrict__] = ACTIONS(1233),
    [anon_sym__Atomic] = ACTIONS(1233),
    [anon_sym__Noreturn] = ACTIONS(1233),
    [anon_sym_noreturn] = ACTIONS(1233),
    [anon_sym_alignas] = ACTIONS(1233),
    [anon_sym__Alignas] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(1233),
    [anon_sym_enum] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1233),
    [anon_sym_union] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1233),
    [anon_sym_default] = ACTIONS(1233),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_do] = ACTIONS(1233),
    [anon_sym_for] = ACTIONS(1233),
    [anon_sym_return] = ACTIONS(1233),
    [anon_sym_break] = ACTIONS(1233),
    [anon_sym_continue] = ACTIONS(1233),
    [anon_sym_goto] = ACTIONS(1233),
    [anon_sym___try] = ACTIONS(1233),
    [anon_sym___leave] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_sizeof] = ACTIONS(1233),
    [anon_sym___alignof__] = ACTIONS(1233),
    [anon_sym___alignof] = ACTIONS(1233),
    [anon_sym__alignof] = ACTIONS(1233),
    [anon_sym_alignof] = ACTIONS(1233),
    [anon_sym__Alignof] = ACTIONS(1233),
    [anon_sym_offsetof] = ACTIONS(1233),
    [anon_sym__Generic] = ACTIONS(1233),
    [anon_sym_asm] = ACTIONS(1233),
    [anon_sym___asm__] = ACTIONS(1233),
    [sym_number_literal] = ACTIONS(1235),
    [anon_sym_L_SQUOTE] = ACTIONS(1235),
    [anon_sym_u_SQUOTE] = ACTIONS(1235),
    [anon_sym_U_SQUOTE] = ACTIONS(1235),
    [anon_sym_u8_SQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [anon_sym_L_DQUOTE] = ACTIONS(1235),
    [anon_sym_u_DQUOTE] = ACTIONS(1235),
    [anon_sym_U_DQUOTE] = ACTIONS(1235),
    [anon_sym_u8_DQUOTE] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [sym_true] = ACTIONS(1233),
    [sym_false] = ACTIONS(1233),
    [anon_sym_NULL] = ACTIONS(1233),
    [anon_sym_nullptr] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1233),
    [anon_sym_hitAttributeEXT] = ACTIONS(1233),
    [anon_sym_callableDataEXT] = ACTIONS(1233),
    [anon_sym_callableDataInEXT] = ACTIONS(1233),
    [anon_sym_shaderRecordEXT] = ACTIONS(1233),
    [anon_sym_rayPayloadNV] = ACTIONS(1233),
    [anon_sym_rayPayloadInNV] = ACTIONS(1233),
    [anon_sym_hitAttributeNV] = ACTIONS(1233),
    [anon_sym_callableDataNV] = ACTIONS(1233),
    [anon_sym_callableDataInNV] = ACTIONS(1233),
    [anon_sym_shaderRecordNV] = ACTIONS(1233),
    [anon_sym_layout] = ACTIONS(1233),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1261),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_subroutine] = ACTIONS(1261),
    [anon_sym_invariant] = ACTIONS(1261),
    [anon_sym_precise] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_out] = ACTIONS(1261),
    [anon_sym_inout] = ACTIONS(1261),
    [anon_sym_uniform] = ACTIONS(1261),
    [anon_sym_shared] = ACTIONS(1261),
    [anon_sym_attribute] = ACTIONS(1261),
    [anon_sym_varying] = ACTIONS(1261),
    [anon_sym_buffer] = ACTIONS(1261),
    [anon_sym_coherent] = ACTIONS(1261),
    [anon_sym_readonly] = ACTIONS(1261),
    [anon_sym_writeonly] = ACTIONS(1261),
    [anon_sym_precision] = ACTIONS(1261),
    [anon_sym_highp] = ACTIONS(1261),
    [anon_sym_mediump] = ACTIONS(1261),
    [anon_sym_lowp] = ACTIONS(1261),
    [anon_sym_centroid] = ACTIONS(1261),
    [anon_sym_sample] = ACTIONS(1261),
    [anon_sym_patch] = ACTIONS(1261),
    [anon_sym_smooth] = ACTIONS(1261),
    [anon_sym_flat] = ACTIONS(1261),
    [anon_sym_noperspective] = ACTIONS(1261),
    [anon_sym___extension__] = ACTIONS(1261),
    [anon_sym_typedef] = ACTIONS(1261),
    [anon_sym_extern] = ACTIONS(1261),
    [anon_sym___attribute__] = ACTIONS(1261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1263),
    [anon_sym___declspec] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_signed] = ACTIONS(1261),
    [anon_sym_unsigned] = ACTIONS(1261),
    [anon_sym_long] = ACTIONS(1261),
    [anon_sym_short] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1261),
    [anon_sym_auto] = ACTIONS(1261),
    [anon_sym_register] = ACTIONS(1261),
    [anon_sym_inline] = ACTIONS(1261),
    [anon_sym___inline] = ACTIONS(1261),
    [anon_sym___inline__] = ACTIONS(1261),
    [anon_sym___forceinline] = ACTIONS(1261),
    [anon_sym_thread_local] = ACTIONS(1261),
    [anon_sym___thread] = ACTIONS(1261),
    [anon_sym_const] = ACTIONS(1261),
    [anon_sym_constexpr] = ACTIONS(1261),
    [anon_sym_volatile] = ACTIONS(1261),
    [anon_sym_restrict] = ACTIONS(1261),
    [anon_sym___restrict__] = ACTIONS(1261),
    [anon_sym__Atomic] = ACTIONS(1261),
    [anon_sym__Noreturn] = ACTIONS(1261),
    [anon_sym_noreturn] = ACTIONS(1261),
    [anon_sym_alignas] = ACTIONS(1261),
    [anon_sym__Alignas] = ACTIONS(1261),
    [sym_primitive_type] = ACTIONS(1261),
    [anon_sym_enum] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1261),
    [anon_sym_union] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1261),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_do] = ACTIONS(1261),
    [anon_sym_for] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1261),
    [anon_sym_break] = ACTIONS(1261),
    [anon_sym_continue] = ACTIONS(1261),
    [anon_sym_goto] = ACTIONS(1261),
    [anon_sym___try] = ACTIONS(1261),
    [anon_sym___leave] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_sizeof] = ACTIONS(1261),
    [anon_sym___alignof__] = ACTIONS(1261),
    [anon_sym___alignof] = ACTIONS(1261),
    [anon_sym__alignof] = ACTIONS(1261),
    [anon_sym_alignof] = ACTIONS(1261),
    [anon_sym__Alignof] = ACTIONS(1261),
    [anon_sym_offsetof] = ACTIONS(1261),
    [anon_sym__Generic] = ACTIONS(1261),
    [anon_sym_asm] = ACTIONS(1261),
    [anon_sym___asm__] = ACTIONS(1261),
    [sym_number_literal] = ACTIONS(1263),
    [anon_sym_L_SQUOTE] = ACTIONS(1263),
    [anon_sym_u_SQUOTE] = ACTIONS(1263),
    [anon_sym_U_SQUOTE] = ACTIONS(1263),
    [anon_sym_u8_SQUOTE] = ACTIONS(1263),
    [anon_sym_SQUOTE] = ACTIONS(1263),
    [anon_sym_L_DQUOTE] = ACTIONS(1263),
    [anon_sym_u_DQUOTE] = ACTIONS(1263),
    [anon_sym_U_DQUOTE] = ACTIONS(1263),
    [anon_sym_u8_DQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_true] = ACTIONS(1261),
    [sym_false] = ACTIONS(1261),
    [anon_sym_NULL] = ACTIONS(1261),
    [anon_sym_nullptr] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1261),
    [anon_sym_hitAttributeEXT] = ACTIONS(1261),
    [anon_sym_callableDataEXT] = ACTIONS(1261),
    [anon_sym_callableDataInEXT] = ACTIONS(1261),
    [anon_sym_shaderRecordEXT] = ACTIONS(1261),
    [anon_sym_rayPayloadNV] = ACTIONS(1261),
    [anon_sym_rayPayloadInNV] = ACTIONS(1261),
    [anon_sym_hitAttributeNV] = ACTIONS(1261),
    [anon_sym_callableDataNV] = ACTIONS(1261),
    [anon_sym_callableDataInNV] = ACTIONS(1261),
    [anon_sym_shaderRecordNV] = ACTIONS(1261),
    [anon_sym_layout] = ACTIONS(1261),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(1359),
    [sym_identifier] = ACTIONS(1357),
    [aux_sym_preproc_include_token1] = ACTIONS(1357),
    [aux_sym_preproc_def_token1] = ACTIONS(1357),
    [aux_sym_preproc_if_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1357),
    [sym_preproc_directive] = ACTIONS(1357),
    [anon_sym_LPAREN2] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_subroutine] = ACTIONS(1357),
    [anon_sym_invariant] = ACTIONS(1357),
    [anon_sym_precise] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(1359),
    [anon_sym_in] = ACTIONS(1357),
    [anon_sym_out] = ACTIONS(1357),
    [anon_sym_inout] = ACTIONS(1357),
    [anon_sym_uniform] = ACTIONS(1357),
    [anon_sym_shared] = ACTIONS(1357),
    [anon_sym_attribute] = ACTIONS(1357),
    [anon_sym_varying] = ACTIONS(1357),
    [anon_sym_buffer] = ACTIONS(1357),
    [anon_sym_coherent] = ACTIONS(1357),
    [anon_sym_readonly] = ACTIONS(1357),
    [anon_sym_writeonly] = ACTIONS(1357),
    [anon_sym_precision] = ACTIONS(1357),
    [anon_sym_highp] = ACTIONS(1357),
    [anon_sym_mediump] = ACTIONS(1357),
    [anon_sym_lowp] = ACTIONS(1357),
    [anon_sym_centroid] = ACTIONS(1357),
    [anon_sym_sample] = ACTIONS(1357),
    [anon_sym_patch] = ACTIONS(1357),
    [anon_sym_smooth] = ACTIONS(1357),
    [anon_sym_flat] = ACTIONS(1357),
    [anon_sym_noperspective] = ACTIONS(1357),
    [anon_sym___extension__] = ACTIONS(1357),
    [anon_sym_typedef] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1357),
    [anon_sym___attribute__] = ACTIONS(1357),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1359),
    [anon_sym___declspec] = ACTIONS(1357),
    [anon_sym___cdecl] = ACTIONS(1357),
    [anon_sym___clrcall] = ACTIONS(1357),
    [anon_sym___stdcall] = ACTIONS(1357),
    [anon_sym___fastcall] = ACTIONS(1357),
    [anon_sym___thiscall] = ACTIONS(1357),
    [anon_sym___vectorcall] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_signed] = ACTIONS(1357),
    [anon_sym_unsigned] = ACTIONS(1357),
    [anon_sym_long] = ACTIONS(1357),
    [anon_sym_short] = ACTIONS(1357),
    [anon_sym_static] = ACTIONS(1357),
    [anon_sym_auto] = ACTIONS(1357),
    [anon_sym_register] = ACTIONS(1357),
    [anon_sym_inline] = ACTIONS(1357),
    [anon_sym___inline] = ACTIONS(1357),
    [anon_sym___inline__] = ACTIONS(1357),
    [anon_sym___forceinline] = ACTIONS(1357),
    [anon_sym_thread_local] = ACTIONS(1357),
    [anon_sym___thread] = ACTIONS(1357),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_constexpr] = ACTIONS(1357),
    [anon_sym_volatile] = ACTIONS(1357),
    [anon_sym_restrict] = ACTIONS(1357),
    [anon_sym___restrict__] = ACTIONS(1357),
    [anon_sym__Atomic] = ACTIONS(1357),
    [anon_sym__Noreturn] = ACTIONS(1357),
    [anon_sym_noreturn] = ACTIONS(1357),
    [anon_sym_alignas] = ACTIONS(1357),
    [anon_sym__Alignas] = ACTIONS(1357),
    [sym_primitive_type] = ACTIONS(1357),
    [anon_sym_enum] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1357),
    [anon_sym_union] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1357),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1357),
    [anon_sym_case] = ACTIONS(1357),
    [anon_sym_default] = ACTIONS(1357),
    [anon_sym_while] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1357),
    [anon_sym_for] = ACTIONS(1357),
    [anon_sym_return] = ACTIONS(1357),
    [anon_sym_break] = ACTIONS(1357),
    [anon_sym_continue] = ACTIONS(1357),
    [anon_sym_goto] = ACTIONS(1357),
    [anon_sym___try] = ACTIONS(1357),
    [anon_sym___leave] = ACTIONS(1357),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_sizeof] = ACTIONS(1357),
    [anon_sym___alignof__] = ACTIONS(1357),
    [anon_sym___alignof] = ACTIONS(1357),
    [anon_sym__alignof] = ACTIONS(1357),
    [anon_sym_alignof] = ACTIONS(1357),
    [anon_sym__Alignof] = ACTIONS(1357),
    [anon_sym_offsetof] = ACTIONS(1357),
    [anon_sym__Generic] = ACTIONS(1357),
    [anon_sym_asm] = ACTIONS(1357),
    [anon_sym___asm__] = ACTIONS(1357),
    [sym_number_literal] = ACTIONS(1359),
    [anon_sym_L_SQUOTE] = ACTIONS(1359),
    [anon_sym_u_SQUOTE] = ACTIONS(1359),
    [anon_sym_U_SQUOTE] = ACTIONS(1359),
    [anon_sym_u8_SQUOTE] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_L_DQUOTE] = ACTIONS(1359),
    [anon_sym_u_DQUOTE] = ACTIONS(1359),
    [anon_sym_U_DQUOTE] = ACTIONS(1359),
    [anon_sym_u8_DQUOTE] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1359),
    [sym_true] = ACTIONS(1357),
    [sym_false] = ACTIONS(1357),
    [anon_sym_NULL] = ACTIONS(1357),
    [anon_sym_nullptr] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1357),
    [anon_sym_hitAttributeEXT] = ACTIONS(1357),
    [anon_sym_callableDataEXT] = ACTIONS(1357),
    [anon_sym_callableDataInEXT] = ACTIONS(1357),
    [anon_sym_shaderRecordEXT] = ACTIONS(1357),
    [anon_sym_rayPayloadNV] = ACTIONS(1357),
    [anon_sym_rayPayloadInNV] = ACTIONS(1357),
    [anon_sym_hitAttributeNV] = ACTIONS(1357),
    [anon_sym_callableDataNV] = ACTIONS(1357),
    [anon_sym_callableDataInNV] = ACTIONS(1357),
    [anon_sym_shaderRecordNV] = ACTIONS(1357),
    [anon_sym_layout] = ACTIONS(1357),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1363),
    [sym_identifier] = ACTIONS(1361),
    [aux_sym_preproc_include_token1] = ACTIONS(1361),
    [aux_sym_preproc_def_token1] = ACTIONS(1361),
    [aux_sym_preproc_if_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1361),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1361),
    [sym_preproc_directive] = ACTIONS(1361),
    [anon_sym_LPAREN2] = ACTIONS(1363),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_TILDE] = ACTIONS(1363),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1363),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_subroutine] = ACTIONS(1361),
    [anon_sym_invariant] = ACTIONS(1361),
    [anon_sym_precise] = ACTIONS(1361),
    [anon_sym_SEMI] = ACTIONS(1363),
    [anon_sym_in] = ACTIONS(1361),
    [anon_sym_out] = ACTIONS(1361),
    [anon_sym_inout] = ACTIONS(1361),
    [anon_sym_uniform] = ACTIONS(1361),
    [anon_sym_shared] = ACTIONS(1361),
    [anon_sym_attribute] = ACTIONS(1361),
    [anon_sym_varying] = ACTIONS(1361),
    [anon_sym_buffer] = ACTIONS(1361),
    [anon_sym_coherent] = ACTIONS(1361),
    [anon_sym_readonly] = ACTIONS(1361),
    [anon_sym_writeonly] = ACTIONS(1361),
    [anon_sym_precision] = ACTIONS(1361),
    [anon_sym_highp] = ACTIONS(1361),
    [anon_sym_mediump] = ACTIONS(1361),
    [anon_sym_lowp] = ACTIONS(1361),
    [anon_sym_centroid] = ACTIONS(1361),
    [anon_sym_sample] = ACTIONS(1361),
    [anon_sym_patch] = ACTIONS(1361),
    [anon_sym_smooth] = ACTIONS(1361),
    [anon_sym_flat] = ACTIONS(1361),
    [anon_sym_noperspective] = ACTIONS(1361),
    [anon_sym___extension__] = ACTIONS(1361),
    [anon_sym_typedef] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1361),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1363),
    [anon_sym___declspec] = ACTIONS(1361),
    [anon_sym___cdecl] = ACTIONS(1361),
    [anon_sym___clrcall] = ACTIONS(1361),
    [anon_sym___stdcall] = ACTIONS(1361),
    [anon_sym___fastcall] = ACTIONS(1361),
    [anon_sym___thiscall] = ACTIONS(1361),
    [anon_sym___vectorcall] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1363),
    [anon_sym_signed] = ACTIONS(1361),
    [anon_sym_unsigned] = ACTIONS(1361),
    [anon_sym_long] = ACTIONS(1361),
    [anon_sym_short] = ACTIONS(1361),
    [anon_sym_static] = ACTIONS(1361),
    [anon_sym_auto] = ACTIONS(1361),
    [anon_sym_register] = ACTIONS(1361),
    [anon_sym_inline] = ACTIONS(1361),
    [anon_sym___inline] = ACTIONS(1361),
    [anon_sym___inline__] = ACTIONS(1361),
    [anon_sym___forceinline] = ACTIONS(1361),
    [anon_sym_thread_local] = ACTIONS(1361),
    [anon_sym___thread] = ACTIONS(1361),
    [anon_sym_const] = ACTIONS(1361),
    [anon_sym_constexpr] = ACTIONS(1361),
    [anon_sym_volatile] = ACTIONS(1361),
    [anon_sym_restrict] = ACTIONS(1361),
    [anon_sym___restrict__] = ACTIONS(1361),
    [anon_sym__Atomic] = ACTIONS(1361),
    [anon_sym__Noreturn] = ACTIONS(1361),
    [anon_sym_noreturn] = ACTIONS(1361),
    [anon_sym_alignas] = ACTIONS(1361),
    [anon_sym__Alignas] = ACTIONS(1361),
    [sym_primitive_type] = ACTIONS(1361),
    [anon_sym_enum] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1361),
    [anon_sym_union] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1361),
    [anon_sym_else] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1361),
    [anon_sym_case] = ACTIONS(1361),
    [anon_sym_default] = ACTIONS(1361),
    [anon_sym_while] = ACTIONS(1361),
    [anon_sym_do] = ACTIONS(1361),
    [anon_sym_for] = ACTIONS(1361),
    [anon_sym_return] = ACTIONS(1361),
    [anon_sym_break] = ACTIONS(1361),
    [anon_sym_continue] = ACTIONS(1361),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1361),
    [anon_sym___leave] = ACTIONS(1361),
    [anon_sym_DASH_DASH] = ACTIONS(1363),
    [anon_sym_PLUS_PLUS] = ACTIONS(1363),
    [anon_sym_sizeof] = ACTIONS(1361),
    [anon_sym___alignof__] = ACTIONS(1361),
    [anon_sym___alignof] = ACTIONS(1361),
    [anon_sym__alignof] = ACTIONS(1361),
    [anon_sym_alignof] = ACTIONS(1361),
    [anon_sym__Alignof] = ACTIONS(1361),
    [anon_sym_offsetof] = ACTIONS(1361),
    [anon_sym__Generic] = ACTIONS(1361),
    [anon_sym_asm] = ACTIONS(1361),
    [anon_sym___asm__] = ACTIONS(1361),
    [sym_number_literal] = ACTIONS(1363),
    [anon_sym_L_SQUOTE] = ACTIONS(1363),
    [anon_sym_u_SQUOTE] = ACTIONS(1363),
    [anon_sym_U_SQUOTE] = ACTIONS(1363),
    [anon_sym_u8_SQUOTE] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_L_DQUOTE] = ACTIONS(1363),
    [anon_sym_u_DQUOTE] = ACTIONS(1363),
    [anon_sym_U_DQUOTE] = ACTIONS(1363),
    [anon_sym_u8_DQUOTE] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1363),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [anon_sym_NULL] = ACTIONS(1361),
    [anon_sym_nullptr] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1361),
    [anon_sym_hitAttributeEXT] = ACTIONS(1361),
    [anon_sym_callableDataEXT] = ACTIONS(1361),
    [anon_sym_callableDataInEXT] = ACTIONS(1361),
    [anon_sym_shaderRecordEXT] = ACTIONS(1361),
    [anon_sym_rayPayloadNV] = ACTIONS(1361),
    [anon_sym_rayPayloadInNV] = ACTIONS(1361),
    [anon_sym_hitAttributeNV] = ACTIONS(1361),
    [anon_sym_callableDataNV] = ACTIONS(1361),
    [anon_sym_callableDataInNV] = ACTIONS(1361),
    [anon_sym_shaderRecordNV] = ACTIONS(1361),
    [anon_sym_layout] = ACTIONS(1361),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1351),
    [sym_identifier] = ACTIONS(1349),
    [aux_sym_preproc_include_token1] = ACTIONS(1349),
    [aux_sym_preproc_def_token1] = ACTIONS(1349),
    [aux_sym_preproc_if_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1349),
    [sym_preproc_directive] = ACTIONS(1349),
    [anon_sym_LPAREN2] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_subroutine] = ACTIONS(1349),
    [anon_sym_invariant] = ACTIONS(1349),
    [anon_sym_precise] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1349),
    [anon_sym_out] = ACTIONS(1349),
    [anon_sym_inout] = ACTIONS(1349),
    [anon_sym_uniform] = ACTIONS(1349),
    [anon_sym_shared] = ACTIONS(1349),
    [anon_sym_attribute] = ACTIONS(1349),
    [anon_sym_varying] = ACTIONS(1349),
    [anon_sym_buffer] = ACTIONS(1349),
    [anon_sym_coherent] = ACTIONS(1349),
    [anon_sym_readonly] = ACTIONS(1349),
    [anon_sym_writeonly] = ACTIONS(1349),
    [anon_sym_precision] = ACTIONS(1349),
    [anon_sym_highp] = ACTIONS(1349),
    [anon_sym_mediump] = ACTIONS(1349),
    [anon_sym_lowp] = ACTIONS(1349),
    [anon_sym_centroid] = ACTIONS(1349),
    [anon_sym_sample] = ACTIONS(1349),
    [anon_sym_patch] = ACTIONS(1349),
    [anon_sym_smooth] = ACTIONS(1349),
    [anon_sym_flat] = ACTIONS(1349),
    [anon_sym_noperspective] = ACTIONS(1349),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1349),
    [anon_sym___attribute__] = ACTIONS(1349),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1351),
    [anon_sym___declspec] = ACTIONS(1349),
    [anon_sym___cdecl] = ACTIONS(1349),
    [anon_sym___clrcall] = ACTIONS(1349),
    [anon_sym___stdcall] = ACTIONS(1349),
    [anon_sym___fastcall] = ACTIONS(1349),
    [anon_sym___thiscall] = ACTIONS(1349),
    [anon_sym___vectorcall] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_signed] = ACTIONS(1349),
    [anon_sym_unsigned] = ACTIONS(1349),
    [anon_sym_long] = ACTIONS(1349),
    [anon_sym_short] = ACTIONS(1349),
    [anon_sym_static] = ACTIONS(1349),
    [anon_sym_auto] = ACTIONS(1349),
    [anon_sym_register] = ACTIONS(1349),
    [anon_sym_inline] = ACTIONS(1349),
    [anon_sym___inline] = ACTIONS(1349),
    [anon_sym___inline__] = ACTIONS(1349),
    [anon_sym___forceinline] = ACTIONS(1349),
    [anon_sym_thread_local] = ACTIONS(1349),
    [anon_sym___thread] = ACTIONS(1349),
    [anon_sym_const] = ACTIONS(1349),
    [anon_sym_constexpr] = ACTIONS(1349),
    [anon_sym_volatile] = ACTIONS(1349),
    [anon_sym_restrict] = ACTIONS(1349),
    [anon_sym___restrict__] = ACTIONS(1349),
    [anon_sym__Atomic] = ACTIONS(1349),
    [anon_sym__Noreturn] = ACTIONS(1349),
    [anon_sym_noreturn] = ACTIONS(1349),
    [anon_sym_alignas] = ACTIONS(1349),
    [anon_sym__Alignas] = ACTIONS(1349),
    [sym_primitive_type] = ACTIONS(1349),
    [anon_sym_enum] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1349),
    [anon_sym_union] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_break] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1349),
    [anon_sym___try] = ACTIONS(1349),
    [anon_sym___leave] = ACTIONS(1349),
    [anon_sym_DASH_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1351),
    [anon_sym_sizeof] = ACTIONS(1349),
    [anon_sym___alignof__] = ACTIONS(1349),
    [anon_sym___alignof] = ACTIONS(1349),
    [anon_sym__alignof] = ACTIONS(1349),
    [anon_sym_alignof] = ACTIONS(1349),
    [anon_sym__Alignof] = ACTIONS(1349),
    [anon_sym_offsetof] = ACTIONS(1349),
    [anon_sym__Generic] = ACTIONS(1349),
    [anon_sym_asm] = ACTIONS(1349),
    [anon_sym___asm__] = ACTIONS(1349),
    [sym_number_literal] = ACTIONS(1351),
    [anon_sym_L_SQUOTE] = ACTIONS(1351),
    [anon_sym_u_SQUOTE] = ACTIONS(1351),
    [anon_sym_U_SQUOTE] = ACTIONS(1351),
    [anon_sym_u8_SQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_L_DQUOTE] = ACTIONS(1351),
    [anon_sym_u_DQUOTE] = ACTIONS(1351),
    [anon_sym_U_DQUOTE] = ACTIONS(1351),
    [anon_sym_u8_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [anon_sym_NULL] = ACTIONS(1349),
    [anon_sym_nullptr] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1349),
    [anon_sym_hitAttributeEXT] = ACTIONS(1349),
    [anon_sym_callableDataEXT] = ACTIONS(1349),
    [anon_sym_callableDataInEXT] = ACTIONS(1349),
    [anon_sym_shaderRecordEXT] = ACTIONS(1349),
    [anon_sym_rayPayloadNV] = ACTIONS(1349),
    [anon_sym_rayPayloadInNV] = ACTIONS(1349),
    [anon_sym_hitAttributeNV] = ACTIONS(1349),
    [anon_sym_callableDataNV] = ACTIONS(1349),
    [anon_sym_callableDataInNV] = ACTIONS(1349),
    [anon_sym_shaderRecordNV] = ACTIONS(1349),
    [anon_sym_layout] = ACTIONS(1349),
  },
  [316] = {
    [sym_identifier] = ACTIONS(1493),
    [aux_sym_preproc_include_token1] = ACTIONS(1493),
    [aux_sym_preproc_def_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token2] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1493),
    [sym_preproc_directive] = ACTIONS(1493),
    [anon_sym_LPAREN2] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(1495),
    [anon_sym_TILDE] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_STAR] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1495),
    [anon_sym_subroutine] = ACTIONS(1493),
    [anon_sym_invariant] = ACTIONS(1493),
    [anon_sym_precise] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_in] = ACTIONS(1493),
    [anon_sym_out] = ACTIONS(1493),
    [anon_sym_inout] = ACTIONS(1493),
    [anon_sym_uniform] = ACTIONS(1493),
    [anon_sym_shared] = ACTIONS(1493),
    [anon_sym_attribute] = ACTIONS(1493),
    [anon_sym_varying] = ACTIONS(1493),
    [anon_sym_buffer] = ACTIONS(1493),
    [anon_sym_coherent] = ACTIONS(1493),
    [anon_sym_readonly] = ACTIONS(1493),
    [anon_sym_writeonly] = ACTIONS(1493),
    [anon_sym_precision] = ACTIONS(1493),
    [anon_sym_highp] = ACTIONS(1493),
    [anon_sym_mediump] = ACTIONS(1493),
    [anon_sym_lowp] = ACTIONS(1493),
    [anon_sym_centroid] = ACTIONS(1493),
    [anon_sym_sample] = ACTIONS(1493),
    [anon_sym_patch] = ACTIONS(1493),
    [anon_sym_smooth] = ACTIONS(1493),
    [anon_sym_flat] = ACTIONS(1493),
    [anon_sym_noperspective] = ACTIONS(1493),
    [anon_sym___extension__] = ACTIONS(1493),
    [anon_sym_typedef] = ACTIONS(1493),
    [anon_sym_extern] = ACTIONS(1493),
    [anon_sym___attribute__] = ACTIONS(1493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1495),
    [anon_sym___declspec] = ACTIONS(1493),
    [anon_sym___cdecl] = ACTIONS(1493),
    [anon_sym___clrcall] = ACTIONS(1493),
    [anon_sym___stdcall] = ACTIONS(1493),
    [anon_sym___fastcall] = ACTIONS(1493),
    [anon_sym___thiscall] = ACTIONS(1493),
    [anon_sym___vectorcall] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_signed] = ACTIONS(1493),
    [anon_sym_unsigned] = ACTIONS(1493),
    [anon_sym_long] = ACTIONS(1493),
    [anon_sym_short] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1493),
    [anon_sym_auto] = ACTIONS(1493),
    [anon_sym_register] = ACTIONS(1493),
    [anon_sym_inline] = ACTIONS(1493),
    [anon_sym___inline] = ACTIONS(1493),
    [anon_sym___inline__] = ACTIONS(1493),
    [anon_sym___forceinline] = ACTIONS(1493),
    [anon_sym_thread_local] = ACTIONS(1493),
    [anon_sym___thread] = ACTIONS(1493),
    [anon_sym_const] = ACTIONS(1493),
    [anon_sym_constexpr] = ACTIONS(1493),
    [anon_sym_volatile] = ACTIONS(1493),
    [anon_sym_restrict] = ACTIONS(1493),
    [anon_sym___restrict__] = ACTIONS(1493),
    [anon_sym__Atomic] = ACTIONS(1493),
    [anon_sym__Noreturn] = ACTIONS(1493),
    [anon_sym_noreturn] = ACTIONS(1493),
    [anon_sym_alignas] = ACTIONS(1493),
    [anon_sym__Alignas] = ACTIONS(1493),
    [sym_primitive_type] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1493),
    [anon_sym_struct] = ACTIONS(1493),
    [anon_sym_union] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1493),
    [anon_sym_switch] = ACTIONS(1493),
    [anon_sym_case] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1493),
    [anon_sym_do] = ACTIONS(1493),
    [anon_sym_for] = ACTIONS(1493),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_break] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1493),
    [anon_sym_goto] = ACTIONS(1493),
    [anon_sym___try] = ACTIONS(1493),
    [anon_sym___leave] = ACTIONS(1493),
    [anon_sym_DASH_DASH] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1495),
    [anon_sym_sizeof] = ACTIONS(1493),
    [anon_sym___alignof__] = ACTIONS(1493),
    [anon_sym___alignof] = ACTIONS(1493),
    [anon_sym__alignof] = ACTIONS(1493),
    [anon_sym_alignof] = ACTIONS(1493),
    [anon_sym__Alignof] = ACTIONS(1493),
    [anon_sym_offsetof] = ACTIONS(1493),
    [anon_sym__Generic] = ACTIONS(1493),
    [anon_sym_asm] = ACTIONS(1493),
    [anon_sym___asm__] = ACTIONS(1493),
    [sym_number_literal] = ACTIONS(1495),
    [anon_sym_L_SQUOTE] = ACTIONS(1495),
    [anon_sym_u_SQUOTE] = ACTIONS(1495),
    [anon_sym_U_SQUOTE] = ACTIONS(1495),
    [anon_sym_u8_SQUOTE] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1495),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1493),
    [sym_false] = ACTIONS(1493),
    [anon_sym_NULL] = ACTIONS(1493),
    [anon_sym_nullptr] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1493),
    [anon_sym_hitAttributeEXT] = ACTIONS(1493),
    [anon_sym_callableDataEXT] = ACTIONS(1493),
    [anon_sym_callableDataInEXT] = ACTIONS(1493),
    [anon_sym_shaderRecordEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadNV] = ACTIONS(1493),
    [anon_sym_rayPayloadInNV] = ACTIONS(1493),
    [anon_sym_hitAttributeNV] = ACTIONS(1493),
    [anon_sym_callableDataNV] = ACTIONS(1493),
    [anon_sym_callableDataInNV] = ACTIONS(1493),
    [anon_sym_shaderRecordNV] = ACTIONS(1493),
    [anon_sym_layout] = ACTIONS(1493),
  },
  [317] = {
    [sym_identifier] = ACTIONS(1481),
    [aux_sym_preproc_include_token1] = ACTIONS(1481),
    [aux_sym_preproc_def_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1481),
    [sym_preproc_directive] = ACTIONS(1481),
    [anon_sym_LPAREN2] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_subroutine] = ACTIONS(1481),
    [anon_sym_invariant] = ACTIONS(1481),
    [anon_sym_precise] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1481),
    [anon_sym_out] = ACTIONS(1481),
    [anon_sym_inout] = ACTIONS(1481),
    [anon_sym_uniform] = ACTIONS(1481),
    [anon_sym_shared] = ACTIONS(1481),
    [anon_sym_attribute] = ACTIONS(1481),
    [anon_sym_varying] = ACTIONS(1481),
    [anon_sym_buffer] = ACTIONS(1481),
    [anon_sym_coherent] = ACTIONS(1481),
    [anon_sym_readonly] = ACTIONS(1481),
    [anon_sym_writeonly] = ACTIONS(1481),
    [anon_sym_precision] = ACTIONS(1481),
    [anon_sym_highp] = ACTIONS(1481),
    [anon_sym_mediump] = ACTIONS(1481),
    [anon_sym_lowp] = ACTIONS(1481),
    [anon_sym_centroid] = ACTIONS(1481),
    [anon_sym_sample] = ACTIONS(1481),
    [anon_sym_patch] = ACTIONS(1481),
    [anon_sym_smooth] = ACTIONS(1481),
    [anon_sym_flat] = ACTIONS(1481),
    [anon_sym_noperspective] = ACTIONS(1481),
    [anon_sym___extension__] = ACTIONS(1481),
    [anon_sym_typedef] = ACTIONS(1481),
    [anon_sym_extern] = ACTIONS(1481),
    [anon_sym___attribute__] = ACTIONS(1481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1483),
    [anon_sym___declspec] = ACTIONS(1481),
    [anon_sym___cdecl] = ACTIONS(1481),
    [anon_sym___clrcall] = ACTIONS(1481),
    [anon_sym___stdcall] = ACTIONS(1481),
    [anon_sym___fastcall] = ACTIONS(1481),
    [anon_sym___thiscall] = ACTIONS(1481),
    [anon_sym___vectorcall] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_signed] = ACTIONS(1481),
    [anon_sym_unsigned] = ACTIONS(1481),
    [anon_sym_long] = ACTIONS(1481),
    [anon_sym_short] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_auto] = ACTIONS(1481),
    [anon_sym_register] = ACTIONS(1481),
    [anon_sym_inline] = ACTIONS(1481),
    [anon_sym___inline] = ACTIONS(1481),
    [anon_sym___inline__] = ACTIONS(1481),
    [anon_sym___forceinline] = ACTIONS(1481),
    [anon_sym_thread_local] = ACTIONS(1481),
    [anon_sym___thread] = ACTIONS(1481),
    [anon_sym_const] = ACTIONS(1481),
    [anon_sym_constexpr] = ACTIONS(1481),
    [anon_sym_volatile] = ACTIONS(1481),
    [anon_sym_restrict] = ACTIONS(1481),
    [anon_sym___restrict__] = ACTIONS(1481),
    [anon_sym__Atomic] = ACTIONS(1481),
    [anon_sym__Noreturn] = ACTIONS(1481),
    [anon_sym_noreturn] = ACTIONS(1481),
    [anon_sym_alignas] = ACTIONS(1481),
    [anon_sym__Alignas] = ACTIONS(1481),
    [sym_primitive_type] = ACTIONS(1481),
    [anon_sym_enum] = ACTIONS(1481),
    [anon_sym_struct] = ACTIONS(1481),
    [anon_sym_union] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_switch] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1481),
    [anon_sym_default] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_for] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_break] = ACTIONS(1481),
    [anon_sym_continue] = ACTIONS(1481),
    [anon_sym_goto] = ACTIONS(1481),
    [anon_sym___try] = ACTIONS(1481),
    [anon_sym___leave] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_sizeof] = ACTIONS(1481),
    [anon_sym___alignof__] = ACTIONS(1481),
    [anon_sym___alignof] = ACTIONS(1481),
    [anon_sym__alignof] = ACTIONS(1481),
    [anon_sym_alignof] = ACTIONS(1481),
    [anon_sym__Alignof] = ACTIONS(1481),
    [anon_sym_offsetof] = ACTIONS(1481),
    [anon_sym__Generic] = ACTIONS(1481),
    [anon_sym_asm] = ACTIONS(1481),
    [anon_sym___asm__] = ACTIONS(1481),
    [sym_number_literal] = ACTIONS(1483),
    [anon_sym_L_SQUOTE] = ACTIONS(1483),
    [anon_sym_u_SQUOTE] = ACTIONS(1483),
    [anon_sym_U_SQUOTE] = ACTIONS(1483),
    [anon_sym_u8_SQUOTE] = ACTIONS(1483),
    [anon_sym_SQUOTE] = ACTIONS(1483),
    [anon_sym_L_DQUOTE] = ACTIONS(1483),
    [anon_sym_u_DQUOTE] = ACTIONS(1483),
    [anon_sym_U_DQUOTE] = ACTIONS(1483),
    [anon_sym_u8_DQUOTE] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1483),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [anon_sym_NULL] = ACTIONS(1481),
    [anon_sym_nullptr] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1481),
    [anon_sym_hitAttributeEXT] = ACTIONS(1481),
    [anon_sym_callableDataEXT] = ACTIONS(1481),
    [anon_sym_callableDataInEXT] = ACTIONS(1481),
    [anon_sym_shaderRecordEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadNV] = ACTIONS(1481),
    [anon_sym_rayPayloadInNV] = ACTIONS(1481),
    [anon_sym_hitAttributeNV] = ACTIONS(1481),
    [anon_sym_callableDataNV] = ACTIONS(1481),
    [anon_sym_callableDataInNV] = ACTIONS(1481),
    [anon_sym_shaderRecordNV] = ACTIONS(1481),
    [anon_sym_layout] = ACTIONS(1481),
  },
  [318] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_include_token1] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_typedef] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym___cdecl] = ACTIONS(1489),
    [anon_sym___clrcall] = ACTIONS(1489),
    [anon_sym___stdcall] = ACTIONS(1489),
    [anon_sym___fastcall] = ACTIONS(1489),
    [anon_sym___thiscall] = ACTIONS(1489),
    [anon_sym___vectorcall] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_switch] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1489),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_return] = ACTIONS(1489),
    [anon_sym_break] = ACTIONS(1489),
    [anon_sym_continue] = ACTIONS(1489),
    [anon_sym_goto] = ACTIONS(1489),
    [anon_sym___try] = ACTIONS(1489),
    [anon_sym___leave] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_sizeof] = ACTIONS(1489),
    [anon_sym___alignof__] = ACTIONS(1489),
    [anon_sym___alignof] = ACTIONS(1489),
    [anon_sym__alignof] = ACTIONS(1489),
    [anon_sym_alignof] = ACTIONS(1489),
    [anon_sym__Alignof] = ACTIONS(1489),
    [anon_sym_offsetof] = ACTIONS(1489),
    [anon_sym__Generic] = ACTIONS(1489),
    [anon_sym_asm] = ACTIONS(1489),
    [anon_sym___asm__] = ACTIONS(1489),
    [sym_number_literal] = ACTIONS(1491),
    [anon_sym_L_SQUOTE] = ACTIONS(1491),
    [anon_sym_u_SQUOTE] = ACTIONS(1491),
    [anon_sym_U_SQUOTE] = ACTIONS(1491),
    [anon_sym_u8_SQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [anon_sym_L_DQUOTE] = ACTIONS(1491),
    [anon_sym_u_DQUOTE] = ACTIONS(1491),
    [anon_sym_U_DQUOTE] = ACTIONS(1491),
    [anon_sym_u8_DQUOTE] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [anon_sym_NULL] = ACTIONS(1489),
    [anon_sym_nullptr] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [319] = {
    [sym_identifier] = ACTIONS(1493),
    [aux_sym_preproc_include_token1] = ACTIONS(1493),
    [aux_sym_preproc_def_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1493),
    [sym_preproc_directive] = ACTIONS(1493),
    [anon_sym_LPAREN2] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(1495),
    [anon_sym_TILDE] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_STAR] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1495),
    [anon_sym_subroutine] = ACTIONS(1493),
    [anon_sym_invariant] = ACTIONS(1493),
    [anon_sym_precise] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_in] = ACTIONS(1493),
    [anon_sym_out] = ACTIONS(1493),
    [anon_sym_inout] = ACTIONS(1493),
    [anon_sym_uniform] = ACTIONS(1493),
    [anon_sym_shared] = ACTIONS(1493),
    [anon_sym_attribute] = ACTIONS(1493),
    [anon_sym_varying] = ACTIONS(1493),
    [anon_sym_buffer] = ACTIONS(1493),
    [anon_sym_coherent] = ACTIONS(1493),
    [anon_sym_readonly] = ACTIONS(1493),
    [anon_sym_writeonly] = ACTIONS(1493),
    [anon_sym_precision] = ACTIONS(1493),
    [anon_sym_highp] = ACTIONS(1493),
    [anon_sym_mediump] = ACTIONS(1493),
    [anon_sym_lowp] = ACTIONS(1493),
    [anon_sym_centroid] = ACTIONS(1493),
    [anon_sym_sample] = ACTIONS(1493),
    [anon_sym_patch] = ACTIONS(1493),
    [anon_sym_smooth] = ACTIONS(1493),
    [anon_sym_flat] = ACTIONS(1493),
    [anon_sym_noperspective] = ACTIONS(1493),
    [anon_sym___extension__] = ACTIONS(1493),
    [anon_sym_typedef] = ACTIONS(1493),
    [anon_sym_extern] = ACTIONS(1493),
    [anon_sym___attribute__] = ACTIONS(1493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1495),
    [anon_sym___declspec] = ACTIONS(1493),
    [anon_sym___cdecl] = ACTIONS(1493),
    [anon_sym___clrcall] = ACTIONS(1493),
    [anon_sym___stdcall] = ACTIONS(1493),
    [anon_sym___fastcall] = ACTIONS(1493),
    [anon_sym___thiscall] = ACTIONS(1493),
    [anon_sym___vectorcall] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_signed] = ACTIONS(1493),
    [anon_sym_unsigned] = ACTIONS(1493),
    [anon_sym_long] = ACTIONS(1493),
    [anon_sym_short] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1493),
    [anon_sym_auto] = ACTIONS(1493),
    [anon_sym_register] = ACTIONS(1493),
    [anon_sym_inline] = ACTIONS(1493),
    [anon_sym___inline] = ACTIONS(1493),
    [anon_sym___inline__] = ACTIONS(1493),
    [anon_sym___forceinline] = ACTIONS(1493),
    [anon_sym_thread_local] = ACTIONS(1493),
    [anon_sym___thread] = ACTIONS(1493),
    [anon_sym_const] = ACTIONS(1493),
    [anon_sym_constexpr] = ACTIONS(1493),
    [anon_sym_volatile] = ACTIONS(1493),
    [anon_sym_restrict] = ACTIONS(1493),
    [anon_sym___restrict__] = ACTIONS(1493),
    [anon_sym__Atomic] = ACTIONS(1493),
    [anon_sym__Noreturn] = ACTIONS(1493),
    [anon_sym_noreturn] = ACTIONS(1493),
    [anon_sym_alignas] = ACTIONS(1493),
    [anon_sym__Alignas] = ACTIONS(1493),
    [sym_primitive_type] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1493),
    [anon_sym_struct] = ACTIONS(1493),
    [anon_sym_union] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1493),
    [anon_sym_switch] = ACTIONS(1493),
    [anon_sym_case] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1493),
    [anon_sym_do] = ACTIONS(1493),
    [anon_sym_for] = ACTIONS(1493),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_break] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1493),
    [anon_sym_goto] = ACTIONS(1493),
    [anon_sym___try] = ACTIONS(1493),
    [anon_sym___leave] = ACTIONS(1493),
    [anon_sym_DASH_DASH] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1495),
    [anon_sym_sizeof] = ACTIONS(1493),
    [anon_sym___alignof__] = ACTIONS(1493),
    [anon_sym___alignof] = ACTIONS(1493),
    [anon_sym__alignof] = ACTIONS(1493),
    [anon_sym_alignof] = ACTIONS(1493),
    [anon_sym__Alignof] = ACTIONS(1493),
    [anon_sym_offsetof] = ACTIONS(1493),
    [anon_sym__Generic] = ACTIONS(1493),
    [anon_sym_asm] = ACTIONS(1493),
    [anon_sym___asm__] = ACTIONS(1493),
    [sym_number_literal] = ACTIONS(1495),
    [anon_sym_L_SQUOTE] = ACTIONS(1495),
    [anon_sym_u_SQUOTE] = ACTIONS(1495),
    [anon_sym_U_SQUOTE] = ACTIONS(1495),
    [anon_sym_u8_SQUOTE] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1495),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1493),
    [sym_false] = ACTIONS(1493),
    [anon_sym_NULL] = ACTIONS(1493),
    [anon_sym_nullptr] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1493),
    [anon_sym_hitAttributeEXT] = ACTIONS(1493),
    [anon_sym_callableDataEXT] = ACTIONS(1493),
    [anon_sym_callableDataInEXT] = ACTIONS(1493),
    [anon_sym_shaderRecordEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadNV] = ACTIONS(1493),
    [anon_sym_rayPayloadInNV] = ACTIONS(1493),
    [anon_sym_hitAttributeNV] = ACTIONS(1493),
    [anon_sym_callableDataNV] = ACTIONS(1493),
    [anon_sym_callableDataInNV] = ACTIONS(1493),
    [anon_sym_shaderRecordNV] = ACTIONS(1493),
    [anon_sym_layout] = ACTIONS(1493),
  },
  [320] = {
    [sym_identifier] = ACTIONS(1527),
    [aux_sym_preproc_include_token1] = ACTIONS(1527),
    [aux_sym_preproc_def_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token2] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1527),
    [sym_preproc_directive] = ACTIONS(1527),
    [anon_sym_LPAREN2] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_subroutine] = ACTIONS(1527),
    [anon_sym_invariant] = ACTIONS(1527),
    [anon_sym_precise] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1527),
    [anon_sym_out] = ACTIONS(1527),
    [anon_sym_inout] = ACTIONS(1527),
    [anon_sym_uniform] = ACTIONS(1527),
    [anon_sym_shared] = ACTIONS(1527),
    [anon_sym_attribute] = ACTIONS(1527),
    [anon_sym_varying] = ACTIONS(1527),
    [anon_sym_buffer] = ACTIONS(1527),
    [anon_sym_coherent] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_writeonly] = ACTIONS(1527),
    [anon_sym_precision] = ACTIONS(1527),
    [anon_sym_highp] = ACTIONS(1527),
    [anon_sym_mediump] = ACTIONS(1527),
    [anon_sym_lowp] = ACTIONS(1527),
    [anon_sym_centroid] = ACTIONS(1527),
    [anon_sym_sample] = ACTIONS(1527),
    [anon_sym_patch] = ACTIONS(1527),
    [anon_sym_smooth] = ACTIONS(1527),
    [anon_sym_flat] = ACTIONS(1527),
    [anon_sym_noperspective] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1527),
    [anon_sym_typedef] = ACTIONS(1527),
    [anon_sym_extern] = ACTIONS(1527),
    [anon_sym___attribute__] = ACTIONS(1527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1529),
    [anon_sym___declspec] = ACTIONS(1527),
    [anon_sym___cdecl] = ACTIONS(1527),
    [anon_sym___clrcall] = ACTIONS(1527),
    [anon_sym___stdcall] = ACTIONS(1527),
    [anon_sym___fastcall] = ACTIONS(1527),
    [anon_sym___thiscall] = ACTIONS(1527),
    [anon_sym___vectorcall] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_signed] = ACTIONS(1527),
    [anon_sym_unsigned] = ACTIONS(1527),
    [anon_sym_long] = ACTIONS(1527),
    [anon_sym_short] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_auto] = ACTIONS(1527),
    [anon_sym_register] = ACTIONS(1527),
    [anon_sym_inline] = ACTIONS(1527),
    [anon_sym___inline] = ACTIONS(1527),
    [anon_sym___inline__] = ACTIONS(1527),
    [anon_sym___forceinline] = ACTIONS(1527),
    [anon_sym_thread_local] = ACTIONS(1527),
    [anon_sym___thread] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_constexpr] = ACTIONS(1527),
    [anon_sym_volatile] = ACTIONS(1527),
    [anon_sym_restrict] = ACTIONS(1527),
    [anon_sym___restrict__] = ACTIONS(1527),
    [anon_sym__Atomic] = ACTIONS(1527),
    [anon_sym__Noreturn] = ACTIONS(1527),
    [anon_sym_noreturn] = ACTIONS(1527),
    [anon_sym_alignas] = ACTIONS(1527),
    [anon_sym__Alignas] = ACTIONS(1527),
    [sym_primitive_type] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_union] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_goto] = ACTIONS(1527),
    [anon_sym___try] = ACTIONS(1527),
    [anon_sym___leave] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1527),
    [anon_sym___alignof__] = ACTIONS(1527),
    [anon_sym___alignof] = ACTIONS(1527),
    [anon_sym__alignof] = ACTIONS(1527),
    [anon_sym_alignof] = ACTIONS(1527),
    [anon_sym__Alignof] = ACTIONS(1527),
    [anon_sym_offsetof] = ACTIONS(1527),
    [anon_sym__Generic] = ACTIONS(1527),
    [anon_sym_asm] = ACTIONS(1527),
    [anon_sym___asm__] = ACTIONS(1527),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_L_SQUOTE] = ACTIONS(1529),
    [anon_sym_u_SQUOTE] = ACTIONS(1529),
    [anon_sym_U_SQUOTE] = ACTIONS(1529),
    [anon_sym_u8_SQUOTE] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_L_DQUOTE] = ACTIONS(1529),
    [anon_sym_u_DQUOTE] = ACTIONS(1529),
    [anon_sym_U_DQUOTE] = ACTIONS(1529),
    [anon_sym_u8_DQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [anon_sym_NULL] = ACTIONS(1527),
    [anon_sym_nullptr] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1527),
    [anon_sym_hitAttributeEXT] = ACTIONS(1527),
    [anon_sym_callableDataEXT] = ACTIONS(1527),
    [anon_sym_callableDataInEXT] = ACTIONS(1527),
    [anon_sym_shaderRecordEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadNV] = ACTIONS(1527),
    [anon_sym_rayPayloadInNV] = ACTIONS(1527),
    [anon_sym_hitAttributeNV] = ACTIONS(1527),
    [anon_sym_callableDataNV] = ACTIONS(1527),
    [anon_sym_callableDataInNV] = ACTIONS(1527),
    [anon_sym_shaderRecordNV] = ACTIONS(1527),
    [anon_sym_layout] = ACTIONS(1527),
  },
  [321] = {
    [sym_identifier] = ACTIONS(1519),
    [aux_sym_preproc_include_token1] = ACTIONS(1519),
    [aux_sym_preproc_def_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token2] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1519),
    [sym_preproc_directive] = ACTIONS(1519),
    [anon_sym_LPAREN2] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_subroutine] = ACTIONS(1519),
    [anon_sym_invariant] = ACTIONS(1519),
    [anon_sym_precise] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_out] = ACTIONS(1519),
    [anon_sym_inout] = ACTIONS(1519),
    [anon_sym_uniform] = ACTIONS(1519),
    [anon_sym_shared] = ACTIONS(1519),
    [anon_sym_attribute] = ACTIONS(1519),
    [anon_sym_varying] = ACTIONS(1519),
    [anon_sym_buffer] = ACTIONS(1519),
    [anon_sym_coherent] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_writeonly] = ACTIONS(1519),
    [anon_sym_precision] = ACTIONS(1519),
    [anon_sym_highp] = ACTIONS(1519),
    [anon_sym_mediump] = ACTIONS(1519),
    [anon_sym_lowp] = ACTIONS(1519),
    [anon_sym_centroid] = ACTIONS(1519),
    [anon_sym_sample] = ACTIONS(1519),
    [anon_sym_patch] = ACTIONS(1519),
    [anon_sym_smooth] = ACTIONS(1519),
    [anon_sym_flat] = ACTIONS(1519),
    [anon_sym_noperspective] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(1519),
    [anon_sym_extern] = ACTIONS(1519),
    [anon_sym___attribute__] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1521),
    [anon_sym___declspec] = ACTIONS(1519),
    [anon_sym___cdecl] = ACTIONS(1519),
    [anon_sym___clrcall] = ACTIONS(1519),
    [anon_sym___stdcall] = ACTIONS(1519),
    [anon_sym___fastcall] = ACTIONS(1519),
    [anon_sym___thiscall] = ACTIONS(1519),
    [anon_sym___vectorcall] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_signed] = ACTIONS(1519),
    [anon_sym_unsigned] = ACTIONS(1519),
    [anon_sym_long] = ACTIONS(1519),
    [anon_sym_short] = ACTIONS(1519),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_auto] = ACTIONS(1519),
    [anon_sym_register] = ACTIONS(1519),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym___inline] = ACTIONS(1519),
    [anon_sym___inline__] = ACTIONS(1519),
    [anon_sym___forceinline] = ACTIONS(1519),
    [anon_sym_thread_local] = ACTIONS(1519),
    [anon_sym___thread] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_constexpr] = ACTIONS(1519),
    [anon_sym_volatile] = ACTIONS(1519),
    [anon_sym_restrict] = ACTIONS(1519),
    [anon_sym___restrict__] = ACTIONS(1519),
    [anon_sym__Atomic] = ACTIONS(1519),
    [anon_sym__Noreturn] = ACTIONS(1519),
    [anon_sym_noreturn] = ACTIONS(1519),
    [anon_sym_alignas] = ACTIONS(1519),
    [anon_sym__Alignas] = ACTIONS(1519),
    [sym_primitive_type] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [anon_sym_struct] = ACTIONS(1519),
    [anon_sym_union] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_goto] = ACTIONS(1519),
    [anon_sym___try] = ACTIONS(1519),
    [anon_sym___leave] = ACTIONS(1519),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_sizeof] = ACTIONS(1519),
    [anon_sym___alignof__] = ACTIONS(1519),
    [anon_sym___alignof] = ACTIONS(1519),
    [anon_sym__alignof] = ACTIONS(1519),
    [anon_sym_alignof] = ACTIONS(1519),
    [anon_sym__Alignof] = ACTIONS(1519),
    [anon_sym_offsetof] = ACTIONS(1519),
    [anon_sym__Generic] = ACTIONS(1519),
    [anon_sym_asm] = ACTIONS(1519),
    [anon_sym___asm__] = ACTIONS(1519),
    [sym_number_literal] = ACTIONS(1521),
    [anon_sym_L_SQUOTE] = ACTIONS(1521),
    [anon_sym_u_SQUOTE] = ACTIONS(1521),
    [anon_sym_U_SQUOTE] = ACTIONS(1521),
    [anon_sym_u8_SQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_L_DQUOTE] = ACTIONS(1521),
    [anon_sym_u_DQUOTE] = ACTIONS(1521),
    [anon_sym_U_DQUOTE] = ACTIONS(1521),
    [anon_sym_u8_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [anon_sym_NULL] = ACTIONS(1519),
    [anon_sym_nullptr] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1519),
    [anon_sym_hitAttributeEXT] = ACTIONS(1519),
    [anon_sym_callableDataEXT] = ACTIONS(1519),
    [anon_sym_callableDataInEXT] = ACTIONS(1519),
    [anon_sym_shaderRecordEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadNV] = ACTIONS(1519),
    [anon_sym_rayPayloadInNV] = ACTIONS(1519),
    [anon_sym_hitAttributeNV] = ACTIONS(1519),
    [anon_sym_callableDataNV] = ACTIONS(1519),
    [anon_sym_callableDataInNV] = ACTIONS(1519),
    [anon_sym_shaderRecordNV] = ACTIONS(1519),
    [anon_sym_layout] = ACTIONS(1519),
  },
  [322] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token2] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [323] = {
    [sym_identifier] = ACTIONS(1523),
    [aux_sym_preproc_include_token1] = ACTIONS(1523),
    [aux_sym_preproc_def_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token2] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1523),
    [sym_preproc_directive] = ACTIONS(1523),
    [anon_sym_LPAREN2] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_subroutine] = ACTIONS(1523),
    [anon_sym_invariant] = ACTIONS(1523),
    [anon_sym_precise] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_in] = ACTIONS(1523),
    [anon_sym_out] = ACTIONS(1523),
    [anon_sym_inout] = ACTIONS(1523),
    [anon_sym_uniform] = ACTIONS(1523),
    [anon_sym_shared] = ACTIONS(1523),
    [anon_sym_attribute] = ACTIONS(1523),
    [anon_sym_varying] = ACTIONS(1523),
    [anon_sym_buffer] = ACTIONS(1523),
    [anon_sym_coherent] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_writeonly] = ACTIONS(1523),
    [anon_sym_precision] = ACTIONS(1523),
    [anon_sym_highp] = ACTIONS(1523),
    [anon_sym_mediump] = ACTIONS(1523),
    [anon_sym_lowp] = ACTIONS(1523),
    [anon_sym_centroid] = ACTIONS(1523),
    [anon_sym_sample] = ACTIONS(1523),
    [anon_sym_patch] = ACTIONS(1523),
    [anon_sym_smooth] = ACTIONS(1523),
    [anon_sym_flat] = ACTIONS(1523),
    [anon_sym_noperspective] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1523),
    [anon_sym_typedef] = ACTIONS(1523),
    [anon_sym_extern] = ACTIONS(1523),
    [anon_sym___attribute__] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1525),
    [anon_sym___declspec] = ACTIONS(1523),
    [anon_sym___cdecl] = ACTIONS(1523),
    [anon_sym___clrcall] = ACTIONS(1523),
    [anon_sym___stdcall] = ACTIONS(1523),
    [anon_sym___fastcall] = ACTIONS(1523),
    [anon_sym___thiscall] = ACTIONS(1523),
    [anon_sym___vectorcall] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_signed] = ACTIONS(1523),
    [anon_sym_unsigned] = ACTIONS(1523),
    [anon_sym_long] = ACTIONS(1523),
    [anon_sym_short] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_auto] = ACTIONS(1523),
    [anon_sym_register] = ACTIONS(1523),
    [anon_sym_inline] = ACTIONS(1523),
    [anon_sym___inline] = ACTIONS(1523),
    [anon_sym___inline__] = ACTIONS(1523),
    [anon_sym___forceinline] = ACTIONS(1523),
    [anon_sym_thread_local] = ACTIONS(1523),
    [anon_sym___thread] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_constexpr] = ACTIONS(1523),
    [anon_sym_volatile] = ACTIONS(1523),
    [anon_sym_restrict] = ACTIONS(1523),
    [anon_sym___restrict__] = ACTIONS(1523),
    [anon_sym__Atomic] = ACTIONS(1523),
    [anon_sym__Noreturn] = ACTIONS(1523),
    [anon_sym_noreturn] = ACTIONS(1523),
    [anon_sym_alignas] = ACTIONS(1523),
    [anon_sym__Alignas] = ACTIONS(1523),
    [sym_primitive_type] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [anon_sym_struct] = ACTIONS(1523),
    [anon_sym_union] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_goto] = ACTIONS(1523),
    [anon_sym___try] = ACTIONS(1523),
    [anon_sym___leave] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1525),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_sizeof] = ACTIONS(1523),
    [anon_sym___alignof__] = ACTIONS(1523),
    [anon_sym___alignof] = ACTIONS(1523),
    [anon_sym__alignof] = ACTIONS(1523),
    [anon_sym_alignof] = ACTIONS(1523),
    [anon_sym__Alignof] = ACTIONS(1523),
    [anon_sym_offsetof] = ACTIONS(1523),
    [anon_sym__Generic] = ACTIONS(1523),
    [anon_sym_asm] = ACTIONS(1523),
    [anon_sym___asm__] = ACTIONS(1523),
    [sym_number_literal] = ACTIONS(1525),
    [anon_sym_L_SQUOTE] = ACTIONS(1525),
    [anon_sym_u_SQUOTE] = ACTIONS(1525),
    [anon_sym_U_SQUOTE] = ACTIONS(1525),
    [anon_sym_u8_SQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_L_DQUOTE] = ACTIONS(1525),
    [anon_sym_u_DQUOTE] = ACTIONS(1525),
    [anon_sym_U_DQUOTE] = ACTIONS(1525),
    [anon_sym_u8_DQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [anon_sym_NULL] = ACTIONS(1523),
    [anon_sym_nullptr] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1523),
    [anon_sym_hitAttributeEXT] = ACTIONS(1523),
    [anon_sym_callableDataEXT] = ACTIONS(1523),
    [anon_sym_callableDataInEXT] = ACTIONS(1523),
    [anon_sym_shaderRecordEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadNV] = ACTIONS(1523),
    [anon_sym_rayPayloadInNV] = ACTIONS(1523),
    [anon_sym_hitAttributeNV] = ACTIONS(1523),
    [anon_sym_callableDataNV] = ACTIONS(1523),
    [anon_sym_callableDataInNV] = ACTIONS(1523),
    [anon_sym_shaderRecordNV] = ACTIONS(1523),
    [anon_sym_layout] = ACTIONS(1523),
  },
  [324] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [325] = {
    [sym_identifier] = ACTIONS(1497),
    [aux_sym_preproc_include_token1] = ACTIONS(1497),
    [aux_sym_preproc_def_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1497),
    [sym_preproc_directive] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_subroutine] = ACTIONS(1497),
    [anon_sym_invariant] = ACTIONS(1497),
    [anon_sym_precise] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_in] = ACTIONS(1497),
    [anon_sym_out] = ACTIONS(1497),
    [anon_sym_inout] = ACTIONS(1497),
    [anon_sym_uniform] = ACTIONS(1497),
    [anon_sym_shared] = ACTIONS(1497),
    [anon_sym_attribute] = ACTIONS(1497),
    [anon_sym_varying] = ACTIONS(1497),
    [anon_sym_buffer] = ACTIONS(1497),
    [anon_sym_coherent] = ACTIONS(1497),
    [anon_sym_readonly] = ACTIONS(1497),
    [anon_sym_writeonly] = ACTIONS(1497),
    [anon_sym_precision] = ACTIONS(1497),
    [anon_sym_highp] = ACTIONS(1497),
    [anon_sym_mediump] = ACTIONS(1497),
    [anon_sym_lowp] = ACTIONS(1497),
    [anon_sym_centroid] = ACTIONS(1497),
    [anon_sym_sample] = ACTIONS(1497),
    [anon_sym_patch] = ACTIONS(1497),
    [anon_sym_smooth] = ACTIONS(1497),
    [anon_sym_flat] = ACTIONS(1497),
    [anon_sym_noperspective] = ACTIONS(1497),
    [anon_sym___extension__] = ACTIONS(1497),
    [anon_sym_typedef] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(1497),
    [anon_sym___attribute__] = ACTIONS(1497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1499),
    [anon_sym___declspec] = ACTIONS(1497),
    [anon_sym___cdecl] = ACTIONS(1497),
    [anon_sym___clrcall] = ACTIONS(1497),
    [anon_sym___stdcall] = ACTIONS(1497),
    [anon_sym___fastcall] = ACTIONS(1497),
    [anon_sym___thiscall] = ACTIONS(1497),
    [anon_sym___vectorcall] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_RBRACE] = ACTIONS(1499),
    [anon_sym_signed] = ACTIONS(1497),
    [anon_sym_unsigned] = ACTIONS(1497),
    [anon_sym_long] = ACTIONS(1497),
    [anon_sym_short] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1497),
    [anon_sym_auto] = ACTIONS(1497),
    [anon_sym_register] = ACTIONS(1497),
    [anon_sym_inline] = ACTIONS(1497),
    [anon_sym___inline] = ACTIONS(1497),
    [anon_sym___inline__] = ACTIONS(1497),
    [anon_sym___forceinline] = ACTIONS(1497),
    [anon_sym_thread_local] = ACTIONS(1497),
    [anon_sym___thread] = ACTIONS(1497),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_alignas] = ACTIONS(1497),
    [anon_sym__Alignas] = ACTIONS(1497),
    [sym_primitive_type] = ACTIONS(1497),
    [anon_sym_enum] = ACTIONS(1497),
    [anon_sym_struct] = ACTIONS(1497),
    [anon_sym_union] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(1497),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1497),
    [anon_sym_default] = ACTIONS(1497),
    [anon_sym_while] = ACTIONS(1497),
    [anon_sym_do] = ACTIONS(1497),
    [anon_sym_for] = ACTIONS(1497),
    [anon_sym_return] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_continue] = ACTIONS(1497),
    [anon_sym_goto] = ACTIONS(1497),
    [anon_sym___try] = ACTIONS(1497),
    [anon_sym___leave] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_sizeof] = ACTIONS(1497),
    [anon_sym___alignof__] = ACTIONS(1497),
    [anon_sym___alignof] = ACTIONS(1497),
    [anon_sym__alignof] = ACTIONS(1497),
    [anon_sym_alignof] = ACTIONS(1497),
    [anon_sym__Alignof] = ACTIONS(1497),
    [anon_sym_offsetof] = ACTIONS(1497),
    [anon_sym__Generic] = ACTIONS(1497),
    [anon_sym_asm] = ACTIONS(1497),
    [anon_sym___asm__] = ACTIONS(1497),
    [sym_number_literal] = ACTIONS(1499),
    [anon_sym_L_SQUOTE] = ACTIONS(1499),
    [anon_sym_u_SQUOTE] = ACTIONS(1499),
    [anon_sym_U_SQUOTE] = ACTIONS(1499),
    [anon_sym_u8_SQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_L_DQUOTE] = ACTIONS(1499),
    [anon_sym_u_DQUOTE] = ACTIONS(1499),
    [anon_sym_U_DQUOTE] = ACTIONS(1499),
    [anon_sym_u8_DQUOTE] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [anon_sym_NULL] = ACTIONS(1497),
    [anon_sym_nullptr] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1497),
    [anon_sym_hitAttributeEXT] = ACTIONS(1497),
    [anon_sym_callableDataEXT] = ACTIONS(1497),
    [anon_sym_callableDataInEXT] = ACTIONS(1497),
    [anon_sym_shaderRecordEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadNV] = ACTIONS(1497),
    [anon_sym_rayPayloadInNV] = ACTIONS(1497),
    [anon_sym_hitAttributeNV] = ACTIONS(1497),
    [anon_sym_callableDataNV] = ACTIONS(1497),
    [anon_sym_callableDataInNV] = ACTIONS(1497),
    [anon_sym_shaderRecordNV] = ACTIONS(1497),
    [anon_sym_layout] = ACTIONS(1497),
  },
  [326] = {
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1501),
    [aux_sym_preproc_def_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1501),
    [sym_preproc_directive] = ACTIONS(1501),
    [anon_sym_LPAREN2] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_subroutine] = ACTIONS(1501),
    [anon_sym_invariant] = ACTIONS(1501),
    [anon_sym_precise] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_in] = ACTIONS(1501),
    [anon_sym_out] = ACTIONS(1501),
    [anon_sym_inout] = ACTIONS(1501),
    [anon_sym_uniform] = ACTIONS(1501),
    [anon_sym_shared] = ACTIONS(1501),
    [anon_sym_attribute] = ACTIONS(1501),
    [anon_sym_varying] = ACTIONS(1501),
    [anon_sym_buffer] = ACTIONS(1501),
    [anon_sym_coherent] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_writeonly] = ACTIONS(1501),
    [anon_sym_precision] = ACTIONS(1501),
    [anon_sym_highp] = ACTIONS(1501),
    [anon_sym_mediump] = ACTIONS(1501),
    [anon_sym_lowp] = ACTIONS(1501),
    [anon_sym_centroid] = ACTIONS(1501),
    [anon_sym_sample] = ACTIONS(1501),
    [anon_sym_patch] = ACTIONS(1501),
    [anon_sym_smooth] = ACTIONS(1501),
    [anon_sym_flat] = ACTIONS(1501),
    [anon_sym_noperspective] = ACTIONS(1501),
    [anon_sym___extension__] = ACTIONS(1501),
    [anon_sym_typedef] = ACTIONS(1501),
    [anon_sym_extern] = ACTIONS(1501),
    [anon_sym___attribute__] = ACTIONS(1501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1503),
    [anon_sym___declspec] = ACTIONS(1501),
    [anon_sym___cdecl] = ACTIONS(1501),
    [anon_sym___clrcall] = ACTIONS(1501),
    [anon_sym___stdcall] = ACTIONS(1501),
    [anon_sym___fastcall] = ACTIONS(1501),
    [anon_sym___thiscall] = ACTIONS(1501),
    [anon_sym___vectorcall] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_signed] = ACTIONS(1501),
    [anon_sym_unsigned] = ACTIONS(1501),
    [anon_sym_long] = ACTIONS(1501),
    [anon_sym_short] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_auto] = ACTIONS(1501),
    [anon_sym_register] = ACTIONS(1501),
    [anon_sym_inline] = ACTIONS(1501),
    [anon_sym___inline] = ACTIONS(1501),
    [anon_sym___inline__] = ACTIONS(1501),
    [anon_sym___forceinline] = ACTIONS(1501),
    [anon_sym_thread_local] = ACTIONS(1501),
    [anon_sym___thread] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_constexpr] = ACTIONS(1501),
    [anon_sym_volatile] = ACTIONS(1501),
    [anon_sym_restrict] = ACTIONS(1501),
    [anon_sym___restrict__] = ACTIONS(1501),
    [anon_sym__Atomic] = ACTIONS(1501),
    [anon_sym__Noreturn] = ACTIONS(1501),
    [anon_sym_noreturn] = ACTIONS(1501),
    [anon_sym_alignas] = ACTIONS(1501),
    [anon_sym__Alignas] = ACTIONS(1501),
    [sym_primitive_type] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [anon_sym_struct] = ACTIONS(1501),
    [anon_sym_union] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_goto] = ACTIONS(1501),
    [anon_sym___try] = ACTIONS(1501),
    [anon_sym___leave] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1503),
    [anon_sym_sizeof] = ACTIONS(1501),
    [anon_sym___alignof__] = ACTIONS(1501),
    [anon_sym___alignof] = ACTIONS(1501),
    [anon_sym__alignof] = ACTIONS(1501),
    [anon_sym_alignof] = ACTIONS(1501),
    [anon_sym__Alignof] = ACTIONS(1501),
    [anon_sym_offsetof] = ACTIONS(1501),
    [anon_sym__Generic] = ACTIONS(1501),
    [anon_sym_asm] = ACTIONS(1501),
    [anon_sym___asm__] = ACTIONS(1501),
    [sym_number_literal] = ACTIONS(1503),
    [anon_sym_L_SQUOTE] = ACTIONS(1503),
    [anon_sym_u_SQUOTE] = ACTIONS(1503),
    [anon_sym_U_SQUOTE] = ACTIONS(1503),
    [anon_sym_u8_SQUOTE] = ACTIONS(1503),
    [anon_sym_SQUOTE] = ACTIONS(1503),
    [anon_sym_L_DQUOTE] = ACTIONS(1503),
    [anon_sym_u_DQUOTE] = ACTIONS(1503),
    [anon_sym_U_DQUOTE] = ACTIONS(1503),
    [anon_sym_u8_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1503),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1501),
    [anon_sym_hitAttributeEXT] = ACTIONS(1501),
    [anon_sym_callableDataEXT] = ACTIONS(1501),
    [anon_sym_callableDataInEXT] = ACTIONS(1501),
    [anon_sym_shaderRecordEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadNV] = ACTIONS(1501),
    [anon_sym_rayPayloadInNV] = ACTIONS(1501),
    [anon_sym_hitAttributeNV] = ACTIONS(1501),
    [anon_sym_callableDataNV] = ACTIONS(1501),
    [anon_sym_callableDataInNV] = ACTIONS(1501),
    [anon_sym_shaderRecordNV] = ACTIONS(1501),
    [anon_sym_layout] = ACTIONS(1501),
  },
  [327] = {
    [sym_identifier] = ACTIONS(1481),
    [aux_sym_preproc_include_token1] = ACTIONS(1481),
    [aux_sym_preproc_def_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token2] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1481),
    [sym_preproc_directive] = ACTIONS(1481),
    [anon_sym_LPAREN2] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_subroutine] = ACTIONS(1481),
    [anon_sym_invariant] = ACTIONS(1481),
    [anon_sym_precise] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1481),
    [anon_sym_out] = ACTIONS(1481),
    [anon_sym_inout] = ACTIONS(1481),
    [anon_sym_uniform] = ACTIONS(1481),
    [anon_sym_shared] = ACTIONS(1481),
    [anon_sym_attribute] = ACTIONS(1481),
    [anon_sym_varying] = ACTIONS(1481),
    [anon_sym_buffer] = ACTIONS(1481),
    [anon_sym_coherent] = ACTIONS(1481),
    [anon_sym_readonly] = ACTIONS(1481),
    [anon_sym_writeonly] = ACTIONS(1481),
    [anon_sym_precision] = ACTIONS(1481),
    [anon_sym_highp] = ACTIONS(1481),
    [anon_sym_mediump] = ACTIONS(1481),
    [anon_sym_lowp] = ACTIONS(1481),
    [anon_sym_centroid] = ACTIONS(1481),
    [anon_sym_sample] = ACTIONS(1481),
    [anon_sym_patch] = ACTIONS(1481),
    [anon_sym_smooth] = ACTIONS(1481),
    [anon_sym_flat] = ACTIONS(1481),
    [anon_sym_noperspective] = ACTIONS(1481),
    [anon_sym___extension__] = ACTIONS(1481),
    [anon_sym_typedef] = ACTIONS(1481),
    [anon_sym_extern] = ACTIONS(1481),
    [anon_sym___attribute__] = ACTIONS(1481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1483),
    [anon_sym___declspec] = ACTIONS(1481),
    [anon_sym___cdecl] = ACTIONS(1481),
    [anon_sym___clrcall] = ACTIONS(1481),
    [anon_sym___stdcall] = ACTIONS(1481),
    [anon_sym___fastcall] = ACTIONS(1481),
    [anon_sym___thiscall] = ACTIONS(1481),
    [anon_sym___vectorcall] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_signed] = ACTIONS(1481),
    [anon_sym_unsigned] = ACTIONS(1481),
    [anon_sym_long] = ACTIONS(1481),
    [anon_sym_short] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_auto] = ACTIONS(1481),
    [anon_sym_register] = ACTIONS(1481),
    [anon_sym_inline] = ACTIONS(1481),
    [anon_sym___inline] = ACTIONS(1481),
    [anon_sym___inline__] = ACTIONS(1481),
    [anon_sym___forceinline] = ACTIONS(1481),
    [anon_sym_thread_local] = ACTIONS(1481),
    [anon_sym___thread] = ACTIONS(1481),
    [anon_sym_const] = ACTIONS(1481),
    [anon_sym_constexpr] = ACTIONS(1481),
    [anon_sym_volatile] = ACTIONS(1481),
    [anon_sym_restrict] = ACTIONS(1481),
    [anon_sym___restrict__] = ACTIONS(1481),
    [anon_sym__Atomic] = ACTIONS(1481),
    [anon_sym__Noreturn] = ACTIONS(1481),
    [anon_sym_noreturn] = ACTIONS(1481),
    [anon_sym_alignas] = ACTIONS(1481),
    [anon_sym__Alignas] = ACTIONS(1481),
    [sym_primitive_type] = ACTIONS(1481),
    [anon_sym_enum] = ACTIONS(1481),
    [anon_sym_struct] = ACTIONS(1481),
    [anon_sym_union] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_switch] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1481),
    [anon_sym_default] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_for] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_break] = ACTIONS(1481),
    [anon_sym_continue] = ACTIONS(1481),
    [anon_sym_goto] = ACTIONS(1481),
    [anon_sym___try] = ACTIONS(1481),
    [anon_sym___leave] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_sizeof] = ACTIONS(1481),
    [anon_sym___alignof__] = ACTIONS(1481),
    [anon_sym___alignof] = ACTIONS(1481),
    [anon_sym__alignof] = ACTIONS(1481),
    [anon_sym_alignof] = ACTIONS(1481),
    [anon_sym__Alignof] = ACTIONS(1481),
    [anon_sym_offsetof] = ACTIONS(1481),
    [anon_sym__Generic] = ACTIONS(1481),
    [anon_sym_asm] = ACTIONS(1481),
    [anon_sym___asm__] = ACTIONS(1481),
    [sym_number_literal] = ACTIONS(1483),
    [anon_sym_L_SQUOTE] = ACTIONS(1483),
    [anon_sym_u_SQUOTE] = ACTIONS(1483),
    [anon_sym_U_SQUOTE] = ACTIONS(1483),
    [anon_sym_u8_SQUOTE] = ACTIONS(1483),
    [anon_sym_SQUOTE] = ACTIONS(1483),
    [anon_sym_L_DQUOTE] = ACTIONS(1483),
    [anon_sym_u_DQUOTE] = ACTIONS(1483),
    [anon_sym_U_DQUOTE] = ACTIONS(1483),
    [anon_sym_u8_DQUOTE] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1483),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [anon_sym_NULL] = ACTIONS(1481),
    [anon_sym_nullptr] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1481),
    [anon_sym_hitAttributeEXT] = ACTIONS(1481),
    [anon_sym_callableDataEXT] = ACTIONS(1481),
    [anon_sym_callableDataInEXT] = ACTIONS(1481),
    [anon_sym_shaderRecordEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadNV] = ACTIONS(1481),
    [anon_sym_rayPayloadInNV] = ACTIONS(1481),
    [anon_sym_hitAttributeNV] = ACTIONS(1481),
    [anon_sym_callableDataNV] = ACTIONS(1481),
    [anon_sym_callableDataInNV] = ACTIONS(1481),
    [anon_sym_shaderRecordNV] = ACTIONS(1481),
    [anon_sym_layout] = ACTIONS(1481),
  },
  [328] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token2] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [329] = {
    [sym_identifier] = ACTIONS(1397),
    [aux_sym_preproc_include_token1] = ACTIONS(1397),
    [aux_sym_preproc_def_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token2] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1397),
    [sym_preproc_directive] = ACTIONS(1397),
    [anon_sym_LPAREN2] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_subroutine] = ACTIONS(1397),
    [anon_sym_invariant] = ACTIONS(1397),
    [anon_sym_precise] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_out] = ACTIONS(1397),
    [anon_sym_inout] = ACTIONS(1397),
    [anon_sym_uniform] = ACTIONS(1397),
    [anon_sym_shared] = ACTIONS(1397),
    [anon_sym_attribute] = ACTIONS(1397),
    [anon_sym_varying] = ACTIONS(1397),
    [anon_sym_buffer] = ACTIONS(1397),
    [anon_sym_coherent] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_writeonly] = ACTIONS(1397),
    [anon_sym_precision] = ACTIONS(1397),
    [anon_sym_highp] = ACTIONS(1397),
    [anon_sym_mediump] = ACTIONS(1397),
    [anon_sym_lowp] = ACTIONS(1397),
    [anon_sym_centroid] = ACTIONS(1397),
    [anon_sym_sample] = ACTIONS(1397),
    [anon_sym_patch] = ACTIONS(1397),
    [anon_sym_smooth] = ACTIONS(1397),
    [anon_sym_flat] = ACTIONS(1397),
    [anon_sym_noperspective] = ACTIONS(1397),
    [anon_sym___extension__] = ACTIONS(1397),
    [anon_sym_typedef] = ACTIONS(1397),
    [anon_sym_extern] = ACTIONS(1397),
    [anon_sym___attribute__] = ACTIONS(1397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1399),
    [anon_sym___declspec] = ACTIONS(1397),
    [anon_sym___cdecl] = ACTIONS(1397),
    [anon_sym___clrcall] = ACTIONS(1397),
    [anon_sym___stdcall] = ACTIONS(1397),
    [anon_sym___fastcall] = ACTIONS(1397),
    [anon_sym___thiscall] = ACTIONS(1397),
    [anon_sym___vectorcall] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_signed] = ACTIONS(1397),
    [anon_sym_unsigned] = ACTIONS(1397),
    [anon_sym_long] = ACTIONS(1397),
    [anon_sym_short] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_auto] = ACTIONS(1397),
    [anon_sym_register] = ACTIONS(1397),
    [anon_sym_inline] = ACTIONS(1397),
    [anon_sym___inline] = ACTIONS(1397),
    [anon_sym___inline__] = ACTIONS(1397),
    [anon_sym___forceinline] = ACTIONS(1397),
    [anon_sym_thread_local] = ACTIONS(1397),
    [anon_sym___thread] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_constexpr] = ACTIONS(1397),
    [anon_sym_volatile] = ACTIONS(1397),
    [anon_sym_restrict] = ACTIONS(1397),
    [anon_sym___restrict__] = ACTIONS(1397),
    [anon_sym__Atomic] = ACTIONS(1397),
    [anon_sym__Noreturn] = ACTIONS(1397),
    [anon_sym_noreturn] = ACTIONS(1397),
    [anon_sym_alignas] = ACTIONS(1397),
    [anon_sym__Alignas] = ACTIONS(1397),
    [sym_primitive_type] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_goto] = ACTIONS(1397),
    [anon_sym___try] = ACTIONS(1397),
    [anon_sym___leave] = ACTIONS(1397),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_sizeof] = ACTIONS(1397),
    [anon_sym___alignof__] = ACTIONS(1397),
    [anon_sym___alignof] = ACTIONS(1397),
    [anon_sym__alignof] = ACTIONS(1397),
    [anon_sym_alignof] = ACTIONS(1397),
    [anon_sym__Alignof] = ACTIONS(1397),
    [anon_sym_offsetof] = ACTIONS(1397),
    [anon_sym__Generic] = ACTIONS(1397),
    [anon_sym_asm] = ACTIONS(1397),
    [anon_sym___asm__] = ACTIONS(1397),
    [sym_number_literal] = ACTIONS(1399),
    [anon_sym_L_SQUOTE] = ACTIONS(1399),
    [anon_sym_u_SQUOTE] = ACTIONS(1399),
    [anon_sym_U_SQUOTE] = ACTIONS(1399),
    [anon_sym_u8_SQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [anon_sym_L_DQUOTE] = ACTIONS(1399),
    [anon_sym_u_DQUOTE] = ACTIONS(1399),
    [anon_sym_U_DQUOTE] = ACTIONS(1399),
    [anon_sym_u8_DQUOTE] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1397),
    [anon_sym_nullptr] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1397),
    [anon_sym_hitAttributeEXT] = ACTIONS(1397),
    [anon_sym_callableDataEXT] = ACTIONS(1397),
    [anon_sym_callableDataInEXT] = ACTIONS(1397),
    [anon_sym_shaderRecordEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadNV] = ACTIONS(1397),
    [anon_sym_rayPayloadInNV] = ACTIONS(1397),
    [anon_sym_hitAttributeNV] = ACTIONS(1397),
    [anon_sym_callableDataNV] = ACTIONS(1397),
    [anon_sym_callableDataInNV] = ACTIONS(1397),
    [anon_sym_shaderRecordNV] = ACTIONS(1397),
    [anon_sym_layout] = ACTIONS(1397),
  },
  [330] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token2] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [331] = {
    [sym_identifier] = ACTIONS(1477),
    [aux_sym_preproc_include_token1] = ACTIONS(1477),
    [aux_sym_preproc_def_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1477),
    [sym_preproc_directive] = ACTIONS(1477),
    [anon_sym_LPAREN2] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_subroutine] = ACTIONS(1477),
    [anon_sym_invariant] = ACTIONS(1477),
    [anon_sym_precise] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_in] = ACTIONS(1477),
    [anon_sym_out] = ACTIONS(1477),
    [anon_sym_inout] = ACTIONS(1477),
    [anon_sym_uniform] = ACTIONS(1477),
    [anon_sym_shared] = ACTIONS(1477),
    [anon_sym_attribute] = ACTIONS(1477),
    [anon_sym_varying] = ACTIONS(1477),
    [anon_sym_buffer] = ACTIONS(1477),
    [anon_sym_coherent] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_writeonly] = ACTIONS(1477),
    [anon_sym_precision] = ACTIONS(1477),
    [anon_sym_highp] = ACTIONS(1477),
    [anon_sym_mediump] = ACTIONS(1477),
    [anon_sym_lowp] = ACTIONS(1477),
    [anon_sym_centroid] = ACTIONS(1477),
    [anon_sym_sample] = ACTIONS(1477),
    [anon_sym_patch] = ACTIONS(1477),
    [anon_sym_smooth] = ACTIONS(1477),
    [anon_sym_flat] = ACTIONS(1477),
    [anon_sym_noperspective] = ACTIONS(1477),
    [anon_sym___extension__] = ACTIONS(1477),
    [anon_sym_typedef] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(1477),
    [anon_sym___attribute__] = ACTIONS(1477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1479),
    [anon_sym___declspec] = ACTIONS(1477),
    [anon_sym___cdecl] = ACTIONS(1477),
    [anon_sym___clrcall] = ACTIONS(1477),
    [anon_sym___stdcall] = ACTIONS(1477),
    [anon_sym___fastcall] = ACTIONS(1477),
    [anon_sym___thiscall] = ACTIONS(1477),
    [anon_sym___vectorcall] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_signed] = ACTIONS(1477),
    [anon_sym_unsigned] = ACTIONS(1477),
    [anon_sym_long] = ACTIONS(1477),
    [anon_sym_short] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_auto] = ACTIONS(1477),
    [anon_sym_register] = ACTIONS(1477),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym___inline] = ACTIONS(1477),
    [anon_sym___inline__] = ACTIONS(1477),
    [anon_sym___forceinline] = ACTIONS(1477),
    [anon_sym_thread_local] = ACTIONS(1477),
    [anon_sym___thread] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_constexpr] = ACTIONS(1477),
    [anon_sym_volatile] = ACTIONS(1477),
    [anon_sym_restrict] = ACTIONS(1477),
    [anon_sym___restrict__] = ACTIONS(1477),
    [anon_sym__Atomic] = ACTIONS(1477),
    [anon_sym__Noreturn] = ACTIONS(1477),
    [anon_sym_noreturn] = ACTIONS(1477),
    [anon_sym_alignas] = ACTIONS(1477),
    [anon_sym__Alignas] = ACTIONS(1477),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [anon_sym_struct] = ACTIONS(1477),
    [anon_sym_union] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_goto] = ACTIONS(1477),
    [anon_sym___try] = ACTIONS(1477),
    [anon_sym___leave] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_sizeof] = ACTIONS(1477),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1477),
    [anon_sym__Generic] = ACTIONS(1477),
    [anon_sym_asm] = ACTIONS(1477),
    [anon_sym___asm__] = ACTIONS(1477),
    [sym_number_literal] = ACTIONS(1479),
    [anon_sym_L_SQUOTE] = ACTIONS(1479),
    [anon_sym_u_SQUOTE] = ACTIONS(1479),
    [anon_sym_U_SQUOTE] = ACTIONS(1479),
    [anon_sym_u8_SQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [anon_sym_L_DQUOTE] = ACTIONS(1479),
    [anon_sym_u_DQUOTE] = ACTIONS(1479),
    [anon_sym_U_DQUOTE] = ACTIONS(1479),
    [anon_sym_u8_DQUOTE] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [anon_sym_NULL] = ACTIONS(1477),
    [anon_sym_nullptr] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1477),
    [anon_sym_hitAttributeEXT] = ACTIONS(1477),
    [anon_sym_callableDataEXT] = ACTIONS(1477),
    [anon_sym_callableDataInEXT] = ACTIONS(1477),
    [anon_sym_shaderRecordEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadNV] = ACTIONS(1477),
    [anon_sym_rayPayloadInNV] = ACTIONS(1477),
    [anon_sym_hitAttributeNV] = ACTIONS(1477),
    [anon_sym_callableDataNV] = ACTIONS(1477),
    [anon_sym_callableDataInNV] = ACTIONS(1477),
    [anon_sym_shaderRecordNV] = ACTIONS(1477),
    [anon_sym_layout] = ACTIONS(1477),
  },
  [332] = {
    [sym_identifier] = ACTIONS(1469),
    [aux_sym_preproc_include_token1] = ACTIONS(1469),
    [aux_sym_preproc_def_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token2] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1469),
    [sym_preproc_directive] = ACTIONS(1469),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_subroutine] = ACTIONS(1469),
    [anon_sym_invariant] = ACTIONS(1469),
    [anon_sym_precise] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_out] = ACTIONS(1469),
    [anon_sym_inout] = ACTIONS(1469),
    [anon_sym_uniform] = ACTIONS(1469),
    [anon_sym_shared] = ACTIONS(1469),
    [anon_sym_attribute] = ACTIONS(1469),
    [anon_sym_varying] = ACTIONS(1469),
    [anon_sym_buffer] = ACTIONS(1469),
    [anon_sym_coherent] = ACTIONS(1469),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_writeonly] = ACTIONS(1469),
    [anon_sym_precision] = ACTIONS(1469),
    [anon_sym_highp] = ACTIONS(1469),
    [anon_sym_mediump] = ACTIONS(1469),
    [anon_sym_lowp] = ACTIONS(1469),
    [anon_sym_centroid] = ACTIONS(1469),
    [anon_sym_sample] = ACTIONS(1469),
    [anon_sym_patch] = ACTIONS(1469),
    [anon_sym_smooth] = ACTIONS(1469),
    [anon_sym_flat] = ACTIONS(1469),
    [anon_sym_noperspective] = ACTIONS(1469),
    [anon_sym___extension__] = ACTIONS(1469),
    [anon_sym_typedef] = ACTIONS(1469),
    [anon_sym_extern] = ACTIONS(1469),
    [anon_sym___attribute__] = ACTIONS(1469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1471),
    [anon_sym___declspec] = ACTIONS(1469),
    [anon_sym___cdecl] = ACTIONS(1469),
    [anon_sym___clrcall] = ACTIONS(1469),
    [anon_sym___stdcall] = ACTIONS(1469),
    [anon_sym___fastcall] = ACTIONS(1469),
    [anon_sym___thiscall] = ACTIONS(1469),
    [anon_sym___vectorcall] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_signed] = ACTIONS(1469),
    [anon_sym_unsigned] = ACTIONS(1469),
    [anon_sym_long] = ACTIONS(1469),
    [anon_sym_short] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_auto] = ACTIONS(1469),
    [anon_sym_register] = ACTIONS(1469),
    [anon_sym_inline] = ACTIONS(1469),
    [anon_sym___inline] = ACTIONS(1469),
    [anon_sym___inline__] = ACTIONS(1469),
    [anon_sym___forceinline] = ACTIONS(1469),
    [anon_sym_thread_local] = ACTIONS(1469),
    [anon_sym___thread] = ACTIONS(1469),
    [anon_sym_const] = ACTIONS(1469),
    [anon_sym_constexpr] = ACTIONS(1469),
    [anon_sym_volatile] = ACTIONS(1469),
    [anon_sym_restrict] = ACTIONS(1469),
    [anon_sym___restrict__] = ACTIONS(1469),
    [anon_sym__Atomic] = ACTIONS(1469),
    [anon_sym__Noreturn] = ACTIONS(1469),
    [anon_sym_noreturn] = ACTIONS(1469),
    [anon_sym_alignas] = ACTIONS(1469),
    [anon_sym__Alignas] = ACTIONS(1469),
    [sym_primitive_type] = ACTIONS(1469),
    [anon_sym_enum] = ACTIONS(1469),
    [anon_sym_struct] = ACTIONS(1469),
    [anon_sym_union] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_switch] = ACTIONS(1469),
    [anon_sym_case] = ACTIONS(1469),
    [anon_sym_default] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1469),
    [anon_sym_break] = ACTIONS(1469),
    [anon_sym_continue] = ACTIONS(1469),
    [anon_sym_goto] = ACTIONS(1469),
    [anon_sym___try] = ACTIONS(1469),
    [anon_sym___leave] = ACTIONS(1469),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1469),
    [anon_sym___alignof__] = ACTIONS(1469),
    [anon_sym___alignof] = ACTIONS(1469),
    [anon_sym__alignof] = ACTIONS(1469),
    [anon_sym_alignof] = ACTIONS(1469),
    [anon_sym__Alignof] = ACTIONS(1469),
    [anon_sym_offsetof] = ACTIONS(1469),
    [anon_sym__Generic] = ACTIONS(1469),
    [anon_sym_asm] = ACTIONS(1469),
    [anon_sym___asm__] = ACTIONS(1469),
    [sym_number_literal] = ACTIONS(1471),
    [anon_sym_L_SQUOTE] = ACTIONS(1471),
    [anon_sym_u_SQUOTE] = ACTIONS(1471),
    [anon_sym_U_SQUOTE] = ACTIONS(1471),
    [anon_sym_u8_SQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [anon_sym_L_DQUOTE] = ACTIONS(1471),
    [anon_sym_u_DQUOTE] = ACTIONS(1471),
    [anon_sym_U_DQUOTE] = ACTIONS(1471),
    [anon_sym_u8_DQUOTE] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [anon_sym_NULL] = ACTIONS(1469),
    [anon_sym_nullptr] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1469),
    [anon_sym_hitAttributeEXT] = ACTIONS(1469),
    [anon_sym_callableDataEXT] = ACTIONS(1469),
    [anon_sym_callableDataInEXT] = ACTIONS(1469),
    [anon_sym_shaderRecordEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadNV] = ACTIONS(1469),
    [anon_sym_rayPayloadInNV] = ACTIONS(1469),
    [anon_sym_hitAttributeNV] = ACTIONS(1469),
    [anon_sym_callableDataNV] = ACTIONS(1469),
    [anon_sym_callableDataInNV] = ACTIONS(1469),
    [anon_sym_shaderRecordNV] = ACTIONS(1469),
    [anon_sym_layout] = ACTIONS(1469),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1461),
    [aux_sym_preproc_include_token1] = ACTIONS(1461),
    [aux_sym_preproc_def_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token2] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1461),
    [sym_preproc_directive] = ACTIONS(1461),
    [anon_sym_LPAREN2] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_subroutine] = ACTIONS(1461),
    [anon_sym_invariant] = ACTIONS(1461),
    [anon_sym_precise] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_out] = ACTIONS(1461),
    [anon_sym_inout] = ACTIONS(1461),
    [anon_sym_uniform] = ACTIONS(1461),
    [anon_sym_shared] = ACTIONS(1461),
    [anon_sym_attribute] = ACTIONS(1461),
    [anon_sym_varying] = ACTIONS(1461),
    [anon_sym_buffer] = ACTIONS(1461),
    [anon_sym_coherent] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_writeonly] = ACTIONS(1461),
    [anon_sym_precision] = ACTIONS(1461),
    [anon_sym_highp] = ACTIONS(1461),
    [anon_sym_mediump] = ACTIONS(1461),
    [anon_sym_lowp] = ACTIONS(1461),
    [anon_sym_centroid] = ACTIONS(1461),
    [anon_sym_sample] = ACTIONS(1461),
    [anon_sym_patch] = ACTIONS(1461),
    [anon_sym_smooth] = ACTIONS(1461),
    [anon_sym_flat] = ACTIONS(1461),
    [anon_sym_noperspective] = ACTIONS(1461),
    [anon_sym___extension__] = ACTIONS(1461),
    [anon_sym_typedef] = ACTIONS(1461),
    [anon_sym_extern] = ACTIONS(1461),
    [anon_sym___attribute__] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1463),
    [anon_sym___declspec] = ACTIONS(1461),
    [anon_sym___cdecl] = ACTIONS(1461),
    [anon_sym___clrcall] = ACTIONS(1461),
    [anon_sym___stdcall] = ACTIONS(1461),
    [anon_sym___fastcall] = ACTIONS(1461),
    [anon_sym___thiscall] = ACTIONS(1461),
    [anon_sym___vectorcall] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_signed] = ACTIONS(1461),
    [anon_sym_unsigned] = ACTIONS(1461),
    [anon_sym_long] = ACTIONS(1461),
    [anon_sym_short] = ACTIONS(1461),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_auto] = ACTIONS(1461),
    [anon_sym_register] = ACTIONS(1461),
    [anon_sym_inline] = ACTIONS(1461),
    [anon_sym___inline] = ACTIONS(1461),
    [anon_sym___inline__] = ACTIONS(1461),
    [anon_sym___forceinline] = ACTIONS(1461),
    [anon_sym_thread_local] = ACTIONS(1461),
    [anon_sym___thread] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_constexpr] = ACTIONS(1461),
    [anon_sym_volatile] = ACTIONS(1461),
    [anon_sym_restrict] = ACTIONS(1461),
    [anon_sym___restrict__] = ACTIONS(1461),
    [anon_sym__Atomic] = ACTIONS(1461),
    [anon_sym__Noreturn] = ACTIONS(1461),
    [anon_sym_noreturn] = ACTIONS(1461),
    [anon_sym_alignas] = ACTIONS(1461),
    [anon_sym__Alignas] = ACTIONS(1461),
    [sym_primitive_type] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_union] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_goto] = ACTIONS(1461),
    [anon_sym___try] = ACTIONS(1461),
    [anon_sym___leave] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_sizeof] = ACTIONS(1461),
    [anon_sym___alignof__] = ACTIONS(1461),
    [anon_sym___alignof] = ACTIONS(1461),
    [anon_sym__alignof] = ACTIONS(1461),
    [anon_sym_alignof] = ACTIONS(1461),
    [anon_sym__Alignof] = ACTIONS(1461),
    [anon_sym_offsetof] = ACTIONS(1461),
    [anon_sym__Generic] = ACTIONS(1461),
    [anon_sym_asm] = ACTIONS(1461),
    [anon_sym___asm__] = ACTIONS(1461),
    [sym_number_literal] = ACTIONS(1463),
    [anon_sym_L_SQUOTE] = ACTIONS(1463),
    [anon_sym_u_SQUOTE] = ACTIONS(1463),
    [anon_sym_U_SQUOTE] = ACTIONS(1463),
    [anon_sym_u8_SQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_L_DQUOTE] = ACTIONS(1463),
    [anon_sym_u_DQUOTE] = ACTIONS(1463),
    [anon_sym_U_DQUOTE] = ACTIONS(1463),
    [anon_sym_u8_DQUOTE] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [anon_sym_NULL] = ACTIONS(1461),
    [anon_sym_nullptr] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1461),
    [anon_sym_hitAttributeEXT] = ACTIONS(1461),
    [anon_sym_callableDataEXT] = ACTIONS(1461),
    [anon_sym_callableDataInEXT] = ACTIONS(1461),
    [anon_sym_shaderRecordEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadNV] = ACTIONS(1461),
    [anon_sym_rayPayloadInNV] = ACTIONS(1461),
    [anon_sym_hitAttributeNV] = ACTIONS(1461),
    [anon_sym_callableDataNV] = ACTIONS(1461),
    [anon_sym_callableDataInNV] = ACTIONS(1461),
    [anon_sym_shaderRecordNV] = ACTIONS(1461),
    [anon_sym_layout] = ACTIONS(1461),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token2] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token2] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1417),
    [aux_sym_preproc_include_token1] = ACTIONS(1417),
    [aux_sym_preproc_def_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1417),
    [sym_preproc_directive] = ACTIONS(1417),
    [anon_sym_LPAREN2] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_subroutine] = ACTIONS(1417),
    [anon_sym_invariant] = ACTIONS(1417),
    [anon_sym_precise] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_in] = ACTIONS(1417),
    [anon_sym_out] = ACTIONS(1417),
    [anon_sym_inout] = ACTIONS(1417),
    [anon_sym_uniform] = ACTIONS(1417),
    [anon_sym_shared] = ACTIONS(1417),
    [anon_sym_attribute] = ACTIONS(1417),
    [anon_sym_varying] = ACTIONS(1417),
    [anon_sym_buffer] = ACTIONS(1417),
    [anon_sym_coherent] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_writeonly] = ACTIONS(1417),
    [anon_sym_precision] = ACTIONS(1417),
    [anon_sym_highp] = ACTIONS(1417),
    [anon_sym_mediump] = ACTIONS(1417),
    [anon_sym_lowp] = ACTIONS(1417),
    [anon_sym_centroid] = ACTIONS(1417),
    [anon_sym_sample] = ACTIONS(1417),
    [anon_sym_patch] = ACTIONS(1417),
    [anon_sym_smooth] = ACTIONS(1417),
    [anon_sym_flat] = ACTIONS(1417),
    [anon_sym_noperspective] = ACTIONS(1417),
    [anon_sym___extension__] = ACTIONS(1417),
    [anon_sym_typedef] = ACTIONS(1417),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym___attribute__] = ACTIONS(1417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1419),
    [anon_sym___declspec] = ACTIONS(1417),
    [anon_sym___cdecl] = ACTIONS(1417),
    [anon_sym___clrcall] = ACTIONS(1417),
    [anon_sym___stdcall] = ACTIONS(1417),
    [anon_sym___fastcall] = ACTIONS(1417),
    [anon_sym___thiscall] = ACTIONS(1417),
    [anon_sym___vectorcall] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_signed] = ACTIONS(1417),
    [anon_sym_unsigned] = ACTIONS(1417),
    [anon_sym_long] = ACTIONS(1417),
    [anon_sym_short] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_auto] = ACTIONS(1417),
    [anon_sym_register] = ACTIONS(1417),
    [anon_sym_inline] = ACTIONS(1417),
    [anon_sym___inline] = ACTIONS(1417),
    [anon_sym___inline__] = ACTIONS(1417),
    [anon_sym___forceinline] = ACTIONS(1417),
    [anon_sym_thread_local] = ACTIONS(1417),
    [anon_sym___thread] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_constexpr] = ACTIONS(1417),
    [anon_sym_volatile] = ACTIONS(1417),
    [anon_sym_restrict] = ACTIONS(1417),
    [anon_sym___restrict__] = ACTIONS(1417),
    [anon_sym__Atomic] = ACTIONS(1417),
    [anon_sym__Noreturn] = ACTIONS(1417),
    [anon_sym_noreturn] = ACTIONS(1417),
    [anon_sym_alignas] = ACTIONS(1417),
    [anon_sym__Alignas] = ACTIONS(1417),
    [sym_primitive_type] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_goto] = ACTIONS(1417),
    [anon_sym___try] = ACTIONS(1417),
    [anon_sym___leave] = ACTIONS(1417),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_sizeof] = ACTIONS(1417),
    [anon_sym___alignof__] = ACTIONS(1417),
    [anon_sym___alignof] = ACTIONS(1417),
    [anon_sym__alignof] = ACTIONS(1417),
    [anon_sym_alignof] = ACTIONS(1417),
    [anon_sym__Alignof] = ACTIONS(1417),
    [anon_sym_offsetof] = ACTIONS(1417),
    [anon_sym__Generic] = ACTIONS(1417),
    [anon_sym_asm] = ACTIONS(1417),
    [anon_sym___asm__] = ACTIONS(1417),
    [sym_number_literal] = ACTIONS(1419),
    [anon_sym_L_SQUOTE] = ACTIONS(1419),
    [anon_sym_u_SQUOTE] = ACTIONS(1419),
    [anon_sym_U_SQUOTE] = ACTIONS(1419),
    [anon_sym_u8_SQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [anon_sym_L_DQUOTE] = ACTIONS(1419),
    [anon_sym_u_DQUOTE] = ACTIONS(1419),
    [anon_sym_U_DQUOTE] = ACTIONS(1419),
    [anon_sym_u8_DQUOTE] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [anon_sym_NULL] = ACTIONS(1417),
    [anon_sym_nullptr] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1417),
    [anon_sym_hitAttributeEXT] = ACTIONS(1417),
    [anon_sym_callableDataEXT] = ACTIONS(1417),
    [anon_sym_callableDataInEXT] = ACTIONS(1417),
    [anon_sym_shaderRecordEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadNV] = ACTIONS(1417),
    [anon_sym_rayPayloadInNV] = ACTIONS(1417),
    [anon_sym_hitAttributeNV] = ACTIONS(1417),
    [anon_sym_callableDataNV] = ACTIONS(1417),
    [anon_sym_callableDataInNV] = ACTIONS(1417),
    [anon_sym_shaderRecordNV] = ACTIONS(1417),
    [anon_sym_layout] = ACTIONS(1417),
  },
  [337] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [338] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token2] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token2] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token2] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_subroutine] = ACTIONS(1445),
    [anon_sym_invariant] = ACTIONS(1445),
    [anon_sym_precise] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_in] = ACTIONS(1445),
    [anon_sym_out] = ACTIONS(1445),
    [anon_sym_inout] = ACTIONS(1445),
    [anon_sym_uniform] = ACTIONS(1445),
    [anon_sym_shared] = ACTIONS(1445),
    [anon_sym_attribute] = ACTIONS(1445),
    [anon_sym_varying] = ACTIONS(1445),
    [anon_sym_buffer] = ACTIONS(1445),
    [anon_sym_coherent] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_writeonly] = ACTIONS(1445),
    [anon_sym_precision] = ACTIONS(1445),
    [anon_sym_highp] = ACTIONS(1445),
    [anon_sym_mediump] = ACTIONS(1445),
    [anon_sym_lowp] = ACTIONS(1445),
    [anon_sym_centroid] = ACTIONS(1445),
    [anon_sym_sample] = ACTIONS(1445),
    [anon_sym_patch] = ACTIONS(1445),
    [anon_sym_smooth] = ACTIONS(1445),
    [anon_sym_flat] = ACTIONS(1445),
    [anon_sym_noperspective] = ACTIONS(1445),
    [anon_sym___extension__] = ACTIONS(1445),
    [anon_sym_typedef] = ACTIONS(1445),
    [anon_sym_extern] = ACTIONS(1445),
    [anon_sym___attribute__] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1447),
    [anon_sym___declspec] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_signed] = ACTIONS(1445),
    [anon_sym_unsigned] = ACTIONS(1445),
    [anon_sym_long] = ACTIONS(1445),
    [anon_sym_short] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_auto] = ACTIONS(1445),
    [anon_sym_register] = ACTIONS(1445),
    [anon_sym_inline] = ACTIONS(1445),
    [anon_sym___inline] = ACTIONS(1445),
    [anon_sym___inline__] = ACTIONS(1445),
    [anon_sym___forceinline] = ACTIONS(1445),
    [anon_sym_thread_local] = ACTIONS(1445),
    [anon_sym___thread] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(1445),
    [anon_sym_constexpr] = ACTIONS(1445),
    [anon_sym_volatile] = ACTIONS(1445),
    [anon_sym_restrict] = ACTIONS(1445),
    [anon_sym___restrict__] = ACTIONS(1445),
    [anon_sym__Atomic] = ACTIONS(1445),
    [anon_sym__Noreturn] = ACTIONS(1445),
    [anon_sym_noreturn] = ACTIONS(1445),
    [anon_sym_alignas] = ACTIONS(1445),
    [anon_sym__Alignas] = ACTIONS(1445),
    [sym_primitive_type] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1445),
    [anon_sym_union] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_continue] = ACTIONS(1445),
    [anon_sym_goto] = ACTIONS(1445),
    [anon_sym___try] = ACTIONS(1445),
    [anon_sym___leave] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1445),
    [anon_sym___alignof__] = ACTIONS(1445),
    [anon_sym___alignof] = ACTIONS(1445),
    [anon_sym__alignof] = ACTIONS(1445),
    [anon_sym_alignof] = ACTIONS(1445),
    [anon_sym__Alignof] = ACTIONS(1445),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1445),
    [anon_sym_asm] = ACTIONS(1445),
    [anon_sym___asm__] = ACTIONS(1445),
    [sym_number_literal] = ACTIONS(1447),
    [anon_sym_L_SQUOTE] = ACTIONS(1447),
    [anon_sym_u_SQUOTE] = ACTIONS(1447),
    [anon_sym_U_SQUOTE] = ACTIONS(1447),
    [anon_sym_u8_SQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_L_DQUOTE] = ACTIONS(1447),
    [anon_sym_u_DQUOTE] = ACTIONS(1447),
    [anon_sym_U_DQUOTE] = ACTIONS(1447),
    [anon_sym_u8_DQUOTE] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [sym_true] = ACTIONS(1445),
    [sym_false] = ACTIONS(1445),
    [anon_sym_NULL] = ACTIONS(1445),
    [anon_sym_nullptr] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1445),
    [anon_sym_hitAttributeEXT] = ACTIONS(1445),
    [anon_sym_callableDataEXT] = ACTIONS(1445),
    [anon_sym_callableDataInEXT] = ACTIONS(1445),
    [anon_sym_shaderRecordEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadNV] = ACTIONS(1445),
    [anon_sym_rayPayloadInNV] = ACTIONS(1445),
    [anon_sym_hitAttributeNV] = ACTIONS(1445),
    [anon_sym_callableDataNV] = ACTIONS(1445),
    [anon_sym_callableDataInNV] = ACTIONS(1445),
    [anon_sym_shaderRecordNV] = ACTIONS(1445),
    [anon_sym_layout] = ACTIONS(1445),
  },
  [341] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_include_token1] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_LPAREN2] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_typedef] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___cdecl] = ACTIONS(1485),
    [anon_sym___clrcall] = ACTIONS(1485),
    [anon_sym___stdcall] = ACTIONS(1485),
    [anon_sym___fastcall] = ACTIONS(1485),
    [anon_sym___thiscall] = ACTIONS(1485),
    [anon_sym___vectorcall] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_switch] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1485),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_return] = ACTIONS(1485),
    [anon_sym_break] = ACTIONS(1485),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_goto] = ACTIONS(1485),
    [anon_sym___try] = ACTIONS(1485),
    [anon_sym___leave] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1487),
    [anon_sym_sizeof] = ACTIONS(1485),
    [anon_sym___alignof__] = ACTIONS(1485),
    [anon_sym___alignof] = ACTIONS(1485),
    [anon_sym__alignof] = ACTIONS(1485),
    [anon_sym_alignof] = ACTIONS(1485),
    [anon_sym__Alignof] = ACTIONS(1485),
    [anon_sym_offsetof] = ACTIONS(1485),
    [anon_sym__Generic] = ACTIONS(1485),
    [anon_sym_asm] = ACTIONS(1485),
    [anon_sym___asm__] = ACTIONS(1485),
    [sym_number_literal] = ACTIONS(1487),
    [anon_sym_L_SQUOTE] = ACTIONS(1487),
    [anon_sym_u_SQUOTE] = ACTIONS(1487),
    [anon_sym_U_SQUOTE] = ACTIONS(1487),
    [anon_sym_u8_SQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_L_DQUOTE] = ACTIONS(1487),
    [anon_sym_u_DQUOTE] = ACTIONS(1487),
    [anon_sym_U_DQUOTE] = ACTIONS(1487),
    [anon_sym_u8_DQUOTE] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [anon_sym_NULL] = ACTIONS(1485),
    [anon_sym_nullptr] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1453),
    [aux_sym_preproc_include_token1] = ACTIONS(1453),
    [aux_sym_preproc_def_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token2] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1453),
    [sym_preproc_directive] = ACTIONS(1453),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_subroutine] = ACTIONS(1453),
    [anon_sym_invariant] = ACTIONS(1453),
    [anon_sym_precise] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1455),
    [anon_sym_in] = ACTIONS(1453),
    [anon_sym_out] = ACTIONS(1453),
    [anon_sym_inout] = ACTIONS(1453),
    [anon_sym_uniform] = ACTIONS(1453),
    [anon_sym_shared] = ACTIONS(1453),
    [anon_sym_attribute] = ACTIONS(1453),
    [anon_sym_varying] = ACTIONS(1453),
    [anon_sym_buffer] = ACTIONS(1453),
    [anon_sym_coherent] = ACTIONS(1453),
    [anon_sym_readonly] = ACTIONS(1453),
    [anon_sym_writeonly] = ACTIONS(1453),
    [anon_sym_precision] = ACTIONS(1453),
    [anon_sym_highp] = ACTIONS(1453),
    [anon_sym_mediump] = ACTIONS(1453),
    [anon_sym_lowp] = ACTIONS(1453),
    [anon_sym_centroid] = ACTIONS(1453),
    [anon_sym_sample] = ACTIONS(1453),
    [anon_sym_patch] = ACTIONS(1453),
    [anon_sym_smooth] = ACTIONS(1453),
    [anon_sym_flat] = ACTIONS(1453),
    [anon_sym_noperspective] = ACTIONS(1453),
    [anon_sym___extension__] = ACTIONS(1453),
    [anon_sym_typedef] = ACTIONS(1453),
    [anon_sym_extern] = ACTIONS(1453),
    [anon_sym___attribute__] = ACTIONS(1453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1455),
    [anon_sym___declspec] = ACTIONS(1453),
    [anon_sym___cdecl] = ACTIONS(1453),
    [anon_sym___clrcall] = ACTIONS(1453),
    [anon_sym___stdcall] = ACTIONS(1453),
    [anon_sym___fastcall] = ACTIONS(1453),
    [anon_sym___thiscall] = ACTIONS(1453),
    [anon_sym___vectorcall] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_signed] = ACTIONS(1453),
    [anon_sym_unsigned] = ACTIONS(1453),
    [anon_sym_long] = ACTIONS(1453),
    [anon_sym_short] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_auto] = ACTIONS(1453),
    [anon_sym_register] = ACTIONS(1453),
    [anon_sym_inline] = ACTIONS(1453),
    [anon_sym___inline] = ACTIONS(1453),
    [anon_sym___inline__] = ACTIONS(1453),
    [anon_sym___forceinline] = ACTIONS(1453),
    [anon_sym_thread_local] = ACTIONS(1453),
    [anon_sym___thread] = ACTIONS(1453),
    [anon_sym_const] = ACTIONS(1453),
    [anon_sym_constexpr] = ACTIONS(1453),
    [anon_sym_volatile] = ACTIONS(1453),
    [anon_sym_restrict] = ACTIONS(1453),
    [anon_sym___restrict__] = ACTIONS(1453),
    [anon_sym__Atomic] = ACTIONS(1453),
    [anon_sym__Noreturn] = ACTIONS(1453),
    [anon_sym_noreturn] = ACTIONS(1453),
    [anon_sym_alignas] = ACTIONS(1453),
    [anon_sym__Alignas] = ACTIONS(1453),
    [sym_primitive_type] = ACTIONS(1453),
    [anon_sym_enum] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1453),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1453),
    [anon_sym_default] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_for] = ACTIONS(1453),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1453),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_goto] = ACTIONS(1453),
    [anon_sym___try] = ACTIONS(1453),
    [anon_sym___leave] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1455),
    [anon_sym_sizeof] = ACTIONS(1453),
    [anon_sym___alignof__] = ACTIONS(1453),
    [anon_sym___alignof] = ACTIONS(1453),
    [anon_sym__alignof] = ACTIONS(1453),
    [anon_sym_alignof] = ACTIONS(1453),
    [anon_sym__Alignof] = ACTIONS(1453),
    [anon_sym_offsetof] = ACTIONS(1453),
    [anon_sym__Generic] = ACTIONS(1453),
    [anon_sym_asm] = ACTIONS(1453),
    [anon_sym___asm__] = ACTIONS(1453),
    [sym_number_literal] = ACTIONS(1455),
    [anon_sym_L_SQUOTE] = ACTIONS(1455),
    [anon_sym_u_SQUOTE] = ACTIONS(1455),
    [anon_sym_U_SQUOTE] = ACTIONS(1455),
    [anon_sym_u8_SQUOTE] = ACTIONS(1455),
    [anon_sym_SQUOTE] = ACTIONS(1455),
    [anon_sym_L_DQUOTE] = ACTIONS(1455),
    [anon_sym_u_DQUOTE] = ACTIONS(1455),
    [anon_sym_U_DQUOTE] = ACTIONS(1455),
    [anon_sym_u8_DQUOTE] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [anon_sym_NULL] = ACTIONS(1453),
    [anon_sym_nullptr] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1453),
    [anon_sym_hitAttributeEXT] = ACTIONS(1453),
    [anon_sym_callableDataEXT] = ACTIONS(1453),
    [anon_sym_callableDataInEXT] = ACTIONS(1453),
    [anon_sym_shaderRecordEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadNV] = ACTIONS(1453),
    [anon_sym_rayPayloadInNV] = ACTIONS(1453),
    [anon_sym_hitAttributeNV] = ACTIONS(1453),
    [anon_sym_callableDataNV] = ACTIONS(1453),
    [anon_sym_callableDataInNV] = ACTIONS(1453),
    [anon_sym_shaderRecordNV] = ACTIONS(1453),
    [anon_sym_layout] = ACTIONS(1453),
  },
  [343] = {
    [sym_identifier] = ACTIONS(1449),
    [aux_sym_preproc_include_token1] = ACTIONS(1449),
    [aux_sym_preproc_def_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token2] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1449),
    [sym_preproc_directive] = ACTIONS(1449),
    [anon_sym_LPAREN2] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_subroutine] = ACTIONS(1449),
    [anon_sym_invariant] = ACTIONS(1449),
    [anon_sym_precise] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_in] = ACTIONS(1449),
    [anon_sym_out] = ACTIONS(1449),
    [anon_sym_inout] = ACTIONS(1449),
    [anon_sym_uniform] = ACTIONS(1449),
    [anon_sym_shared] = ACTIONS(1449),
    [anon_sym_attribute] = ACTIONS(1449),
    [anon_sym_varying] = ACTIONS(1449),
    [anon_sym_buffer] = ACTIONS(1449),
    [anon_sym_coherent] = ACTIONS(1449),
    [anon_sym_readonly] = ACTIONS(1449),
    [anon_sym_writeonly] = ACTIONS(1449),
    [anon_sym_precision] = ACTIONS(1449),
    [anon_sym_highp] = ACTIONS(1449),
    [anon_sym_mediump] = ACTIONS(1449),
    [anon_sym_lowp] = ACTIONS(1449),
    [anon_sym_centroid] = ACTIONS(1449),
    [anon_sym_sample] = ACTIONS(1449),
    [anon_sym_patch] = ACTIONS(1449),
    [anon_sym_smooth] = ACTIONS(1449),
    [anon_sym_flat] = ACTIONS(1449),
    [anon_sym_noperspective] = ACTIONS(1449),
    [anon_sym___extension__] = ACTIONS(1449),
    [anon_sym_typedef] = ACTIONS(1449),
    [anon_sym_extern] = ACTIONS(1449),
    [anon_sym___attribute__] = ACTIONS(1449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1451),
    [anon_sym___declspec] = ACTIONS(1449),
    [anon_sym___cdecl] = ACTIONS(1449),
    [anon_sym___clrcall] = ACTIONS(1449),
    [anon_sym___stdcall] = ACTIONS(1449),
    [anon_sym___fastcall] = ACTIONS(1449),
    [anon_sym___thiscall] = ACTIONS(1449),
    [anon_sym___vectorcall] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_signed] = ACTIONS(1449),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_auto] = ACTIONS(1449),
    [anon_sym_register] = ACTIONS(1449),
    [anon_sym_inline] = ACTIONS(1449),
    [anon_sym___inline] = ACTIONS(1449),
    [anon_sym___inline__] = ACTIONS(1449),
    [anon_sym___forceinline] = ACTIONS(1449),
    [anon_sym_thread_local] = ACTIONS(1449),
    [anon_sym___thread] = ACTIONS(1449),
    [anon_sym_const] = ACTIONS(1449),
    [anon_sym_constexpr] = ACTIONS(1449),
    [anon_sym_volatile] = ACTIONS(1449),
    [anon_sym_restrict] = ACTIONS(1449),
    [anon_sym___restrict__] = ACTIONS(1449),
    [anon_sym__Atomic] = ACTIONS(1449),
    [anon_sym__Noreturn] = ACTIONS(1449),
    [anon_sym_noreturn] = ACTIONS(1449),
    [anon_sym_alignas] = ACTIONS(1449),
    [anon_sym__Alignas] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1449),
    [anon_sym_enum] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1449),
    [anon_sym_union] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_switch] = ACTIONS(1449),
    [anon_sym_case] = ACTIONS(1449),
    [anon_sym_default] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_for] = ACTIONS(1449),
    [anon_sym_return] = ACTIONS(1449),
    [anon_sym_break] = ACTIONS(1449),
    [anon_sym_continue] = ACTIONS(1449),
    [anon_sym_goto] = ACTIONS(1449),
    [anon_sym___try] = ACTIONS(1449),
    [anon_sym___leave] = ACTIONS(1449),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym___alignof__] = ACTIONS(1449),
    [anon_sym___alignof] = ACTIONS(1449),
    [anon_sym__alignof] = ACTIONS(1449),
    [anon_sym_alignof] = ACTIONS(1449),
    [anon_sym__Alignof] = ACTIONS(1449),
    [anon_sym_offsetof] = ACTIONS(1449),
    [anon_sym__Generic] = ACTIONS(1449),
    [anon_sym_asm] = ACTIONS(1449),
    [anon_sym___asm__] = ACTIONS(1449),
    [sym_number_literal] = ACTIONS(1451),
    [anon_sym_L_SQUOTE] = ACTIONS(1451),
    [anon_sym_u_SQUOTE] = ACTIONS(1451),
    [anon_sym_U_SQUOTE] = ACTIONS(1451),
    [anon_sym_u8_SQUOTE] = ACTIONS(1451),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [anon_sym_L_DQUOTE] = ACTIONS(1451),
    [anon_sym_u_DQUOTE] = ACTIONS(1451),
    [anon_sym_U_DQUOTE] = ACTIONS(1451),
    [anon_sym_u8_DQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [anon_sym_NULL] = ACTIONS(1449),
    [anon_sym_nullptr] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1449),
    [anon_sym_hitAttributeEXT] = ACTIONS(1449),
    [anon_sym_callableDataEXT] = ACTIONS(1449),
    [anon_sym_callableDataInEXT] = ACTIONS(1449),
    [anon_sym_shaderRecordEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadNV] = ACTIONS(1449),
    [anon_sym_rayPayloadInNV] = ACTIONS(1449),
    [anon_sym_hitAttributeNV] = ACTIONS(1449),
    [anon_sym_callableDataNV] = ACTIONS(1449),
    [anon_sym_callableDataInNV] = ACTIONS(1449),
    [anon_sym_shaderRecordNV] = ACTIONS(1449),
    [anon_sym_layout] = ACTIONS(1449),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token2] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_LPAREN2] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_typedef] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym___cdecl] = ACTIONS(1441),
    [anon_sym___clrcall] = ACTIONS(1441),
    [anon_sym___stdcall] = ACTIONS(1441),
    [anon_sym___fastcall] = ACTIONS(1441),
    [anon_sym___thiscall] = ACTIONS(1441),
    [anon_sym___vectorcall] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1441),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1441),
    [anon_sym_continue] = ACTIONS(1441),
    [anon_sym_goto] = ACTIONS(1441),
    [anon_sym___try] = ACTIONS(1441),
    [anon_sym___leave] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1443),
    [anon_sym_sizeof] = ACTIONS(1441),
    [anon_sym___alignof__] = ACTIONS(1441),
    [anon_sym___alignof] = ACTIONS(1441),
    [anon_sym__alignof] = ACTIONS(1441),
    [anon_sym_alignof] = ACTIONS(1441),
    [anon_sym__Alignof] = ACTIONS(1441),
    [anon_sym_offsetof] = ACTIONS(1441),
    [anon_sym__Generic] = ACTIONS(1441),
    [anon_sym_asm] = ACTIONS(1441),
    [anon_sym___asm__] = ACTIONS(1441),
    [sym_number_literal] = ACTIONS(1443),
    [anon_sym_L_SQUOTE] = ACTIONS(1443),
    [anon_sym_u_SQUOTE] = ACTIONS(1443),
    [anon_sym_U_SQUOTE] = ACTIONS(1443),
    [anon_sym_u8_SQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_L_DQUOTE] = ACTIONS(1443),
    [anon_sym_u_DQUOTE] = ACTIONS(1443),
    [anon_sym_U_DQUOTE] = ACTIONS(1443),
    [anon_sym_u8_DQUOTE] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [anon_sym_NULL] = ACTIONS(1441),
    [anon_sym_nullptr] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1437),
    [aux_sym_preproc_def_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token2] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1437),
    [sym_preproc_directive] = ACTIONS(1437),
    [anon_sym_LPAREN2] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_subroutine] = ACTIONS(1437),
    [anon_sym_invariant] = ACTIONS(1437),
    [anon_sym_precise] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_in] = ACTIONS(1437),
    [anon_sym_out] = ACTIONS(1437),
    [anon_sym_inout] = ACTIONS(1437),
    [anon_sym_uniform] = ACTIONS(1437),
    [anon_sym_shared] = ACTIONS(1437),
    [anon_sym_attribute] = ACTIONS(1437),
    [anon_sym_varying] = ACTIONS(1437),
    [anon_sym_buffer] = ACTIONS(1437),
    [anon_sym_coherent] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_writeonly] = ACTIONS(1437),
    [anon_sym_precision] = ACTIONS(1437),
    [anon_sym_highp] = ACTIONS(1437),
    [anon_sym_mediump] = ACTIONS(1437),
    [anon_sym_lowp] = ACTIONS(1437),
    [anon_sym_centroid] = ACTIONS(1437),
    [anon_sym_sample] = ACTIONS(1437),
    [anon_sym_patch] = ACTIONS(1437),
    [anon_sym_smooth] = ACTIONS(1437),
    [anon_sym_flat] = ACTIONS(1437),
    [anon_sym_noperspective] = ACTIONS(1437),
    [anon_sym___extension__] = ACTIONS(1437),
    [anon_sym_typedef] = ACTIONS(1437),
    [anon_sym_extern] = ACTIONS(1437),
    [anon_sym___attribute__] = ACTIONS(1437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1439),
    [anon_sym___declspec] = ACTIONS(1437),
    [anon_sym___cdecl] = ACTIONS(1437),
    [anon_sym___clrcall] = ACTIONS(1437),
    [anon_sym___stdcall] = ACTIONS(1437),
    [anon_sym___fastcall] = ACTIONS(1437),
    [anon_sym___thiscall] = ACTIONS(1437),
    [anon_sym___vectorcall] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_signed] = ACTIONS(1437),
    [anon_sym_unsigned] = ACTIONS(1437),
    [anon_sym_long] = ACTIONS(1437),
    [anon_sym_short] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_auto] = ACTIONS(1437),
    [anon_sym_register] = ACTIONS(1437),
    [anon_sym_inline] = ACTIONS(1437),
    [anon_sym___inline] = ACTIONS(1437),
    [anon_sym___inline__] = ACTIONS(1437),
    [anon_sym___forceinline] = ACTIONS(1437),
    [anon_sym_thread_local] = ACTIONS(1437),
    [anon_sym___thread] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_constexpr] = ACTIONS(1437),
    [anon_sym_volatile] = ACTIONS(1437),
    [anon_sym_restrict] = ACTIONS(1437),
    [anon_sym___restrict__] = ACTIONS(1437),
    [anon_sym__Atomic] = ACTIONS(1437),
    [anon_sym__Noreturn] = ACTIONS(1437),
    [anon_sym_noreturn] = ACTIONS(1437),
    [anon_sym_alignas] = ACTIONS(1437),
    [anon_sym__Alignas] = ACTIONS(1437),
    [sym_primitive_type] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1437),
    [anon_sym_union] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_goto] = ACTIONS(1437),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_sizeof] = ACTIONS(1437),
    [anon_sym___alignof__] = ACTIONS(1437),
    [anon_sym___alignof] = ACTIONS(1437),
    [anon_sym__alignof] = ACTIONS(1437),
    [anon_sym_alignof] = ACTIONS(1437),
    [anon_sym__Alignof] = ACTIONS(1437),
    [anon_sym_offsetof] = ACTIONS(1437),
    [anon_sym__Generic] = ACTIONS(1437),
    [anon_sym_asm] = ACTIONS(1437),
    [anon_sym___asm__] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1439),
    [anon_sym_L_SQUOTE] = ACTIONS(1439),
    [anon_sym_u_SQUOTE] = ACTIONS(1439),
    [anon_sym_U_SQUOTE] = ACTIONS(1439),
    [anon_sym_u8_SQUOTE] = ACTIONS(1439),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_L_DQUOTE] = ACTIONS(1439),
    [anon_sym_u_DQUOTE] = ACTIONS(1439),
    [anon_sym_U_DQUOTE] = ACTIONS(1439),
    [anon_sym_u8_DQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [anon_sym_NULL] = ACTIONS(1437),
    [anon_sym_nullptr] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1437),
    [anon_sym_hitAttributeEXT] = ACTIONS(1437),
    [anon_sym_callableDataEXT] = ACTIONS(1437),
    [anon_sym_callableDataInEXT] = ACTIONS(1437),
    [anon_sym_shaderRecordEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadNV] = ACTIONS(1437),
    [anon_sym_rayPayloadInNV] = ACTIONS(1437),
    [anon_sym_hitAttributeNV] = ACTIONS(1437),
    [anon_sym_callableDataNV] = ACTIONS(1437),
    [anon_sym_callableDataInNV] = ACTIONS(1437),
    [anon_sym_shaderRecordNV] = ACTIONS(1437),
    [anon_sym_layout] = ACTIONS(1437),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_include_token1] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token2] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_LPAREN2] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_typedef] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym___cdecl] = ACTIONS(1401),
    [anon_sym___clrcall] = ACTIONS(1401),
    [anon_sym___stdcall] = ACTIONS(1401),
    [anon_sym___fastcall] = ACTIONS(1401),
    [anon_sym___thiscall] = ACTIONS(1401),
    [anon_sym___vectorcall] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_goto] = ACTIONS(1401),
    [anon_sym___try] = ACTIONS(1401),
    [anon_sym___leave] = ACTIONS(1401),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_sizeof] = ACTIONS(1401),
    [anon_sym___alignof__] = ACTIONS(1401),
    [anon_sym___alignof] = ACTIONS(1401),
    [anon_sym__alignof] = ACTIONS(1401),
    [anon_sym_alignof] = ACTIONS(1401),
    [anon_sym__Alignof] = ACTIONS(1401),
    [anon_sym_offsetof] = ACTIONS(1401),
    [anon_sym__Generic] = ACTIONS(1401),
    [anon_sym_asm] = ACTIONS(1401),
    [anon_sym___asm__] = ACTIONS(1401),
    [sym_number_literal] = ACTIONS(1403),
    [anon_sym_L_SQUOTE] = ACTIONS(1403),
    [anon_sym_u_SQUOTE] = ACTIONS(1403),
    [anon_sym_U_SQUOTE] = ACTIONS(1403),
    [anon_sym_u8_SQUOTE] = ACTIONS(1403),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_L_DQUOTE] = ACTIONS(1403),
    [anon_sym_u_DQUOTE] = ACTIONS(1403),
    [anon_sym_U_DQUOTE] = ACTIONS(1403),
    [anon_sym_u8_DQUOTE] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [anon_sym_NULL] = ACTIONS(1401),
    [anon_sym_nullptr] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [347] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_include_token1] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token2] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym___cdecl] = ACTIONS(1409),
    [anon_sym___clrcall] = ACTIONS(1409),
    [anon_sym___stdcall] = ACTIONS(1409),
    [anon_sym___fastcall] = ACTIONS(1409),
    [anon_sym___thiscall] = ACTIONS(1409),
    [anon_sym___vectorcall] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_case] = ACTIONS(1409),
    [anon_sym_default] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_return] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1409),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_goto] = ACTIONS(1409),
    [anon_sym___try] = ACTIONS(1409),
    [anon_sym___leave] = ACTIONS(1409),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_sizeof] = ACTIONS(1409),
    [anon_sym___alignof__] = ACTIONS(1409),
    [anon_sym___alignof] = ACTIONS(1409),
    [anon_sym__alignof] = ACTIONS(1409),
    [anon_sym_alignof] = ACTIONS(1409),
    [anon_sym__Alignof] = ACTIONS(1409),
    [anon_sym_offsetof] = ACTIONS(1409),
    [anon_sym__Generic] = ACTIONS(1409),
    [anon_sym_asm] = ACTIONS(1409),
    [anon_sym___asm__] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1411),
    [anon_sym_L_SQUOTE] = ACTIONS(1411),
    [anon_sym_u_SQUOTE] = ACTIONS(1411),
    [anon_sym_U_SQUOTE] = ACTIONS(1411),
    [anon_sym_u8_SQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [anon_sym_L_DQUOTE] = ACTIONS(1411),
    [anon_sym_u_DQUOTE] = ACTIONS(1411),
    [anon_sym_U_DQUOTE] = ACTIONS(1411),
    [anon_sym_u8_DQUOTE] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [anon_sym_NULL] = ACTIONS(1409),
    [anon_sym_nullptr] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [348] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token2] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [349] = {
    [sym_identifier] = ACTIONS(1531),
    [aux_sym_preproc_include_token1] = ACTIONS(1531),
    [aux_sym_preproc_def_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token2] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1531),
    [sym_preproc_directive] = ACTIONS(1531),
    [anon_sym_LPAREN2] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_subroutine] = ACTIONS(1531),
    [anon_sym_invariant] = ACTIONS(1531),
    [anon_sym_precise] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1531),
    [anon_sym_out] = ACTIONS(1531),
    [anon_sym_inout] = ACTIONS(1531),
    [anon_sym_uniform] = ACTIONS(1531),
    [anon_sym_shared] = ACTIONS(1531),
    [anon_sym_attribute] = ACTIONS(1531),
    [anon_sym_varying] = ACTIONS(1531),
    [anon_sym_buffer] = ACTIONS(1531),
    [anon_sym_coherent] = ACTIONS(1531),
    [anon_sym_readonly] = ACTIONS(1531),
    [anon_sym_writeonly] = ACTIONS(1531),
    [anon_sym_precision] = ACTIONS(1531),
    [anon_sym_highp] = ACTIONS(1531),
    [anon_sym_mediump] = ACTIONS(1531),
    [anon_sym_lowp] = ACTIONS(1531),
    [anon_sym_centroid] = ACTIONS(1531),
    [anon_sym_sample] = ACTIONS(1531),
    [anon_sym_patch] = ACTIONS(1531),
    [anon_sym_smooth] = ACTIONS(1531),
    [anon_sym_flat] = ACTIONS(1531),
    [anon_sym_noperspective] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1531),
    [anon_sym_typedef] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(1531),
    [anon_sym___attribute__] = ACTIONS(1531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1533),
    [anon_sym___declspec] = ACTIONS(1531),
    [anon_sym___cdecl] = ACTIONS(1531),
    [anon_sym___clrcall] = ACTIONS(1531),
    [anon_sym___stdcall] = ACTIONS(1531),
    [anon_sym___fastcall] = ACTIONS(1531),
    [anon_sym___thiscall] = ACTIONS(1531),
    [anon_sym___vectorcall] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_signed] = ACTIONS(1531),
    [anon_sym_unsigned] = ACTIONS(1531),
    [anon_sym_long] = ACTIONS(1531),
    [anon_sym_short] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1531),
    [anon_sym_auto] = ACTIONS(1531),
    [anon_sym_register] = ACTIONS(1531),
    [anon_sym_inline] = ACTIONS(1531),
    [anon_sym___inline] = ACTIONS(1531),
    [anon_sym___inline__] = ACTIONS(1531),
    [anon_sym___forceinline] = ACTIONS(1531),
    [anon_sym_thread_local] = ACTIONS(1531),
    [anon_sym___thread] = ACTIONS(1531),
    [anon_sym_const] = ACTIONS(1531),
    [anon_sym_constexpr] = ACTIONS(1531),
    [anon_sym_volatile] = ACTIONS(1531),
    [anon_sym_restrict] = ACTIONS(1531),
    [anon_sym___restrict__] = ACTIONS(1531),
    [anon_sym__Atomic] = ACTIONS(1531),
    [anon_sym__Noreturn] = ACTIONS(1531),
    [anon_sym_noreturn] = ACTIONS(1531),
    [anon_sym_alignas] = ACTIONS(1531),
    [anon_sym__Alignas] = ACTIONS(1531),
    [sym_primitive_type] = ACTIONS(1531),
    [anon_sym_enum] = ACTIONS(1531),
    [anon_sym_struct] = ACTIONS(1531),
    [anon_sym_union] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_switch] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_do] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_continue] = ACTIONS(1531),
    [anon_sym_goto] = ACTIONS(1531),
    [anon_sym___try] = ACTIONS(1531),
    [anon_sym___leave] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_sizeof] = ACTIONS(1531),
    [anon_sym___alignof__] = ACTIONS(1531),
    [anon_sym___alignof] = ACTIONS(1531),
    [anon_sym__alignof] = ACTIONS(1531),
    [anon_sym_alignof] = ACTIONS(1531),
    [anon_sym__Alignof] = ACTIONS(1531),
    [anon_sym_offsetof] = ACTIONS(1531),
    [anon_sym__Generic] = ACTIONS(1531),
    [anon_sym_asm] = ACTIONS(1531),
    [anon_sym___asm__] = ACTIONS(1531),
    [sym_number_literal] = ACTIONS(1533),
    [anon_sym_L_SQUOTE] = ACTIONS(1533),
    [anon_sym_u_SQUOTE] = ACTIONS(1533),
    [anon_sym_U_SQUOTE] = ACTIONS(1533),
    [anon_sym_u8_SQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_L_DQUOTE] = ACTIONS(1533),
    [anon_sym_u_DQUOTE] = ACTIONS(1533),
    [anon_sym_U_DQUOTE] = ACTIONS(1533),
    [anon_sym_u8_DQUOTE] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [anon_sym_NULL] = ACTIONS(1531),
    [anon_sym_nullptr] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1531),
    [anon_sym_hitAttributeEXT] = ACTIONS(1531),
    [anon_sym_callableDataEXT] = ACTIONS(1531),
    [anon_sym_callableDataInEXT] = ACTIONS(1531),
    [anon_sym_shaderRecordEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadNV] = ACTIONS(1531),
    [anon_sym_rayPayloadInNV] = ACTIONS(1531),
    [anon_sym_hitAttributeNV] = ACTIONS(1531),
    [anon_sym_callableDataNV] = ACTIONS(1531),
    [anon_sym_callableDataInNV] = ACTIONS(1531),
    [anon_sym_shaderRecordNV] = ACTIONS(1531),
    [anon_sym_layout] = ACTIONS(1531),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1509),
    [aux_sym_preproc_include_token1] = ACTIONS(1509),
    [aux_sym_preproc_def_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1509),
    [sym_preproc_directive] = ACTIONS(1509),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_subroutine] = ACTIONS(1509),
    [anon_sym_invariant] = ACTIONS(1509),
    [anon_sym_precise] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_in] = ACTIONS(1509),
    [anon_sym_out] = ACTIONS(1509),
    [anon_sym_inout] = ACTIONS(1509),
    [anon_sym_uniform] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(1509),
    [anon_sym_attribute] = ACTIONS(1509),
    [anon_sym_varying] = ACTIONS(1509),
    [anon_sym_buffer] = ACTIONS(1509),
    [anon_sym_coherent] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_writeonly] = ACTIONS(1509),
    [anon_sym_precision] = ACTIONS(1509),
    [anon_sym_highp] = ACTIONS(1509),
    [anon_sym_mediump] = ACTIONS(1509),
    [anon_sym_lowp] = ACTIONS(1509),
    [anon_sym_centroid] = ACTIONS(1509),
    [anon_sym_sample] = ACTIONS(1509),
    [anon_sym_patch] = ACTIONS(1509),
    [anon_sym_smooth] = ACTIONS(1509),
    [anon_sym_flat] = ACTIONS(1509),
    [anon_sym_noperspective] = ACTIONS(1509),
    [anon_sym___extension__] = ACTIONS(1509),
    [anon_sym_typedef] = ACTIONS(1509),
    [anon_sym_extern] = ACTIONS(1509),
    [anon_sym___attribute__] = ACTIONS(1509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1511),
    [anon_sym___declspec] = ACTIONS(1509),
    [anon_sym___cdecl] = ACTIONS(1509),
    [anon_sym___clrcall] = ACTIONS(1509),
    [anon_sym___stdcall] = ACTIONS(1509),
    [anon_sym___fastcall] = ACTIONS(1509),
    [anon_sym___thiscall] = ACTIONS(1509),
    [anon_sym___vectorcall] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_RBRACE] = ACTIONS(1511),
    [anon_sym_signed] = ACTIONS(1509),
    [anon_sym_unsigned] = ACTIONS(1509),
    [anon_sym_long] = ACTIONS(1509),
    [anon_sym_short] = ACTIONS(1509),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_auto] = ACTIONS(1509),
    [anon_sym_register] = ACTIONS(1509),
    [anon_sym_inline] = ACTIONS(1509),
    [anon_sym___inline] = ACTIONS(1509),
    [anon_sym___inline__] = ACTIONS(1509),
    [anon_sym___forceinline] = ACTIONS(1509),
    [anon_sym_thread_local] = ACTIONS(1509),
    [anon_sym___thread] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_constexpr] = ACTIONS(1509),
    [anon_sym_volatile] = ACTIONS(1509),
    [anon_sym_restrict] = ACTIONS(1509),
    [anon_sym___restrict__] = ACTIONS(1509),
    [anon_sym__Atomic] = ACTIONS(1509),
    [anon_sym__Noreturn] = ACTIONS(1509),
    [anon_sym_noreturn] = ACTIONS(1509),
    [anon_sym_alignas] = ACTIONS(1509),
    [anon_sym__Alignas] = ACTIONS(1509),
    [sym_primitive_type] = ACTIONS(1509),
    [anon_sym_enum] = ACTIONS(1509),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1509),
    [anon_sym_if] = ACTIONS(1509),
    [anon_sym_switch] = ACTIONS(1509),
    [anon_sym_case] = ACTIONS(1509),
    [anon_sym_default] = ACTIONS(1509),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_do] = ACTIONS(1509),
    [anon_sym_for] = ACTIONS(1509),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_break] = ACTIONS(1509),
    [anon_sym_continue] = ACTIONS(1509),
    [anon_sym_goto] = ACTIONS(1509),
    [anon_sym___try] = ACTIONS(1509),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1509),
    [anon_sym___alignof__] = ACTIONS(1509),
    [anon_sym___alignof] = ACTIONS(1509),
    [anon_sym__alignof] = ACTIONS(1509),
    [anon_sym_alignof] = ACTIONS(1509),
    [anon_sym__Alignof] = ACTIONS(1509),
    [anon_sym_offsetof] = ACTIONS(1509),
    [anon_sym__Generic] = ACTIONS(1509),
    [anon_sym_asm] = ACTIONS(1509),
    [anon_sym___asm__] = ACTIONS(1509),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_L_SQUOTE] = ACTIONS(1511),
    [anon_sym_u_SQUOTE] = ACTIONS(1511),
    [anon_sym_U_SQUOTE] = ACTIONS(1511),
    [anon_sym_u8_SQUOTE] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_L_DQUOTE] = ACTIONS(1511),
    [anon_sym_u_DQUOTE] = ACTIONS(1511),
    [anon_sym_U_DQUOTE] = ACTIONS(1511),
    [anon_sym_u8_DQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [anon_sym_NULL] = ACTIONS(1509),
    [anon_sym_nullptr] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1509),
    [anon_sym_hitAttributeEXT] = ACTIONS(1509),
    [anon_sym_callableDataEXT] = ACTIONS(1509),
    [anon_sym_callableDataInEXT] = ACTIONS(1509),
    [anon_sym_shaderRecordEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadNV] = ACTIONS(1509),
    [anon_sym_rayPayloadInNV] = ACTIONS(1509),
    [anon_sym_hitAttributeNV] = ACTIONS(1509),
    [anon_sym_callableDataNV] = ACTIONS(1509),
    [anon_sym_callableDataInNV] = ACTIONS(1509),
    [anon_sym_shaderRecordNV] = ACTIONS(1509),
    [anon_sym_layout] = ACTIONS(1509),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1509),
    [aux_sym_preproc_include_token1] = ACTIONS(1509),
    [aux_sym_preproc_def_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token2] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1509),
    [sym_preproc_directive] = ACTIONS(1509),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_subroutine] = ACTIONS(1509),
    [anon_sym_invariant] = ACTIONS(1509),
    [anon_sym_precise] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1511),
    [anon_sym_in] = ACTIONS(1509),
    [anon_sym_out] = ACTIONS(1509),
    [anon_sym_inout] = ACTIONS(1509),
    [anon_sym_uniform] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(1509),
    [anon_sym_attribute] = ACTIONS(1509),
    [anon_sym_varying] = ACTIONS(1509),
    [anon_sym_buffer] = ACTIONS(1509),
    [anon_sym_coherent] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_writeonly] = ACTIONS(1509),
    [anon_sym_precision] = ACTIONS(1509),
    [anon_sym_highp] = ACTIONS(1509),
    [anon_sym_mediump] = ACTIONS(1509),
    [anon_sym_lowp] = ACTIONS(1509),
    [anon_sym_centroid] = ACTIONS(1509),
    [anon_sym_sample] = ACTIONS(1509),
    [anon_sym_patch] = ACTIONS(1509),
    [anon_sym_smooth] = ACTIONS(1509),
    [anon_sym_flat] = ACTIONS(1509),
    [anon_sym_noperspective] = ACTIONS(1509),
    [anon_sym___extension__] = ACTIONS(1509),
    [anon_sym_typedef] = ACTIONS(1509),
    [anon_sym_extern] = ACTIONS(1509),
    [anon_sym___attribute__] = ACTIONS(1509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1511),
    [anon_sym___declspec] = ACTIONS(1509),
    [anon_sym___cdecl] = ACTIONS(1509),
    [anon_sym___clrcall] = ACTIONS(1509),
    [anon_sym___stdcall] = ACTIONS(1509),
    [anon_sym___fastcall] = ACTIONS(1509),
    [anon_sym___thiscall] = ACTIONS(1509),
    [anon_sym___vectorcall] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_signed] = ACTIONS(1509),
    [anon_sym_unsigned] = ACTIONS(1509),
    [anon_sym_long] = ACTIONS(1509),
    [anon_sym_short] = ACTIONS(1509),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_auto] = ACTIONS(1509),
    [anon_sym_register] = ACTIONS(1509),
    [anon_sym_inline] = ACTIONS(1509),
    [anon_sym___inline] = ACTIONS(1509),
    [anon_sym___inline__] = ACTIONS(1509),
    [anon_sym___forceinline] = ACTIONS(1509),
    [anon_sym_thread_local] = ACTIONS(1509),
    [anon_sym___thread] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_constexpr] = ACTIONS(1509),
    [anon_sym_volatile] = ACTIONS(1509),
    [anon_sym_restrict] = ACTIONS(1509),
    [anon_sym___restrict__] = ACTIONS(1509),
    [anon_sym__Atomic] = ACTIONS(1509),
    [anon_sym__Noreturn] = ACTIONS(1509),
    [anon_sym_noreturn] = ACTIONS(1509),
    [anon_sym_alignas] = ACTIONS(1509),
    [anon_sym__Alignas] = ACTIONS(1509),
    [sym_primitive_type] = ACTIONS(1509),
    [anon_sym_enum] = ACTIONS(1509),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1509),
    [anon_sym_if] = ACTIONS(1509),
    [anon_sym_switch] = ACTIONS(1509),
    [anon_sym_case] = ACTIONS(1509),
    [anon_sym_default] = ACTIONS(1509),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_do] = ACTIONS(1509),
    [anon_sym_for] = ACTIONS(1509),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_break] = ACTIONS(1509),
    [anon_sym_continue] = ACTIONS(1509),
    [anon_sym_goto] = ACTIONS(1509),
    [anon_sym___try] = ACTIONS(1509),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1509),
    [anon_sym___alignof__] = ACTIONS(1509),
    [anon_sym___alignof] = ACTIONS(1509),
    [anon_sym__alignof] = ACTIONS(1509),
    [anon_sym_alignof] = ACTIONS(1509),
    [anon_sym__Alignof] = ACTIONS(1509),
    [anon_sym_offsetof] = ACTIONS(1509),
    [anon_sym__Generic] = ACTIONS(1509),
    [anon_sym_asm] = ACTIONS(1509),
    [anon_sym___asm__] = ACTIONS(1509),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_L_SQUOTE] = ACTIONS(1511),
    [anon_sym_u_SQUOTE] = ACTIONS(1511),
    [anon_sym_U_SQUOTE] = ACTIONS(1511),
    [anon_sym_u8_SQUOTE] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_L_DQUOTE] = ACTIONS(1511),
    [anon_sym_u_DQUOTE] = ACTIONS(1511),
    [anon_sym_U_DQUOTE] = ACTIONS(1511),
    [anon_sym_u8_DQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [anon_sym_NULL] = ACTIONS(1509),
    [anon_sym_nullptr] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1509),
    [anon_sym_hitAttributeEXT] = ACTIONS(1509),
    [anon_sym_callableDataEXT] = ACTIONS(1509),
    [anon_sym_callableDataInEXT] = ACTIONS(1509),
    [anon_sym_shaderRecordEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadNV] = ACTIONS(1509),
    [anon_sym_rayPayloadInNV] = ACTIONS(1509),
    [anon_sym_hitAttributeNV] = ACTIONS(1509),
    [anon_sym_callableDataNV] = ACTIONS(1509),
    [anon_sym_callableDataInNV] = ACTIONS(1509),
    [anon_sym_shaderRecordNV] = ACTIONS(1509),
    [anon_sym_layout] = ACTIONS(1509),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_include_token1] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token2] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_LPAREN2] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_typedef] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___cdecl] = ACTIONS(1485),
    [anon_sym___clrcall] = ACTIONS(1485),
    [anon_sym___stdcall] = ACTIONS(1485),
    [anon_sym___fastcall] = ACTIONS(1485),
    [anon_sym___thiscall] = ACTIONS(1485),
    [anon_sym___vectorcall] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_switch] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1485),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_return] = ACTIONS(1485),
    [anon_sym_break] = ACTIONS(1485),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_goto] = ACTIONS(1485),
    [anon_sym___try] = ACTIONS(1485),
    [anon_sym___leave] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1487),
    [anon_sym_sizeof] = ACTIONS(1485),
    [anon_sym___alignof__] = ACTIONS(1485),
    [anon_sym___alignof] = ACTIONS(1485),
    [anon_sym__alignof] = ACTIONS(1485),
    [anon_sym_alignof] = ACTIONS(1485),
    [anon_sym__Alignof] = ACTIONS(1485),
    [anon_sym_offsetof] = ACTIONS(1485),
    [anon_sym__Generic] = ACTIONS(1485),
    [anon_sym_asm] = ACTIONS(1485),
    [anon_sym___asm__] = ACTIONS(1485),
    [sym_number_literal] = ACTIONS(1487),
    [anon_sym_L_SQUOTE] = ACTIONS(1487),
    [anon_sym_u_SQUOTE] = ACTIONS(1487),
    [anon_sym_U_SQUOTE] = ACTIONS(1487),
    [anon_sym_u8_SQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_L_DQUOTE] = ACTIONS(1487),
    [anon_sym_u_DQUOTE] = ACTIONS(1487),
    [anon_sym_U_DQUOTE] = ACTIONS(1487),
    [anon_sym_u8_DQUOTE] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [anon_sym_NULL] = ACTIONS(1485),
    [anon_sym_nullptr] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [353] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token2] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_include_token1] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token2] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_typedef] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym___cdecl] = ACTIONS(1489),
    [anon_sym___clrcall] = ACTIONS(1489),
    [anon_sym___stdcall] = ACTIONS(1489),
    [anon_sym___fastcall] = ACTIONS(1489),
    [anon_sym___thiscall] = ACTIONS(1489),
    [anon_sym___vectorcall] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_switch] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1489),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_return] = ACTIONS(1489),
    [anon_sym_break] = ACTIONS(1489),
    [anon_sym_continue] = ACTIONS(1489),
    [anon_sym_goto] = ACTIONS(1489),
    [anon_sym___try] = ACTIONS(1489),
    [anon_sym___leave] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_sizeof] = ACTIONS(1489),
    [anon_sym___alignof__] = ACTIONS(1489),
    [anon_sym___alignof] = ACTIONS(1489),
    [anon_sym__alignof] = ACTIONS(1489),
    [anon_sym_alignof] = ACTIONS(1489),
    [anon_sym__Alignof] = ACTIONS(1489),
    [anon_sym_offsetof] = ACTIONS(1489),
    [anon_sym__Generic] = ACTIONS(1489),
    [anon_sym_asm] = ACTIONS(1489),
    [anon_sym___asm__] = ACTIONS(1489),
    [sym_number_literal] = ACTIONS(1491),
    [anon_sym_L_SQUOTE] = ACTIONS(1491),
    [anon_sym_u_SQUOTE] = ACTIONS(1491),
    [anon_sym_U_SQUOTE] = ACTIONS(1491),
    [anon_sym_u8_SQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [anon_sym_L_DQUOTE] = ACTIONS(1491),
    [anon_sym_u_DQUOTE] = ACTIONS(1491),
    [anon_sym_U_DQUOTE] = ACTIONS(1491),
    [anon_sym_u8_DQUOTE] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [anon_sym_NULL] = ACTIONS(1489),
    [anon_sym_nullptr] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [355] = {
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1501),
    [aux_sym_preproc_def_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token2] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1501),
    [sym_preproc_directive] = ACTIONS(1501),
    [anon_sym_LPAREN2] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_subroutine] = ACTIONS(1501),
    [anon_sym_invariant] = ACTIONS(1501),
    [anon_sym_precise] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_in] = ACTIONS(1501),
    [anon_sym_out] = ACTIONS(1501),
    [anon_sym_inout] = ACTIONS(1501),
    [anon_sym_uniform] = ACTIONS(1501),
    [anon_sym_shared] = ACTIONS(1501),
    [anon_sym_attribute] = ACTIONS(1501),
    [anon_sym_varying] = ACTIONS(1501),
    [anon_sym_buffer] = ACTIONS(1501),
    [anon_sym_coherent] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_writeonly] = ACTIONS(1501),
    [anon_sym_precision] = ACTIONS(1501),
    [anon_sym_highp] = ACTIONS(1501),
    [anon_sym_mediump] = ACTIONS(1501),
    [anon_sym_lowp] = ACTIONS(1501),
    [anon_sym_centroid] = ACTIONS(1501),
    [anon_sym_sample] = ACTIONS(1501),
    [anon_sym_patch] = ACTIONS(1501),
    [anon_sym_smooth] = ACTIONS(1501),
    [anon_sym_flat] = ACTIONS(1501),
    [anon_sym_noperspective] = ACTIONS(1501),
    [anon_sym___extension__] = ACTIONS(1501),
    [anon_sym_typedef] = ACTIONS(1501),
    [anon_sym_extern] = ACTIONS(1501),
    [anon_sym___attribute__] = ACTIONS(1501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1503),
    [anon_sym___declspec] = ACTIONS(1501),
    [anon_sym___cdecl] = ACTIONS(1501),
    [anon_sym___clrcall] = ACTIONS(1501),
    [anon_sym___stdcall] = ACTIONS(1501),
    [anon_sym___fastcall] = ACTIONS(1501),
    [anon_sym___thiscall] = ACTIONS(1501),
    [anon_sym___vectorcall] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_signed] = ACTIONS(1501),
    [anon_sym_unsigned] = ACTIONS(1501),
    [anon_sym_long] = ACTIONS(1501),
    [anon_sym_short] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_auto] = ACTIONS(1501),
    [anon_sym_register] = ACTIONS(1501),
    [anon_sym_inline] = ACTIONS(1501),
    [anon_sym___inline] = ACTIONS(1501),
    [anon_sym___inline__] = ACTIONS(1501),
    [anon_sym___forceinline] = ACTIONS(1501),
    [anon_sym_thread_local] = ACTIONS(1501),
    [anon_sym___thread] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_constexpr] = ACTIONS(1501),
    [anon_sym_volatile] = ACTIONS(1501),
    [anon_sym_restrict] = ACTIONS(1501),
    [anon_sym___restrict__] = ACTIONS(1501),
    [anon_sym__Atomic] = ACTIONS(1501),
    [anon_sym__Noreturn] = ACTIONS(1501),
    [anon_sym_noreturn] = ACTIONS(1501),
    [anon_sym_alignas] = ACTIONS(1501),
    [anon_sym__Alignas] = ACTIONS(1501),
    [sym_primitive_type] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [anon_sym_struct] = ACTIONS(1501),
    [anon_sym_union] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_goto] = ACTIONS(1501),
    [anon_sym___try] = ACTIONS(1501),
    [anon_sym___leave] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1503),
    [anon_sym_sizeof] = ACTIONS(1501),
    [anon_sym___alignof__] = ACTIONS(1501),
    [anon_sym___alignof] = ACTIONS(1501),
    [anon_sym__alignof] = ACTIONS(1501),
    [anon_sym_alignof] = ACTIONS(1501),
    [anon_sym__Alignof] = ACTIONS(1501),
    [anon_sym_offsetof] = ACTIONS(1501),
    [anon_sym__Generic] = ACTIONS(1501),
    [anon_sym_asm] = ACTIONS(1501),
    [anon_sym___asm__] = ACTIONS(1501),
    [sym_number_literal] = ACTIONS(1503),
    [anon_sym_L_SQUOTE] = ACTIONS(1503),
    [anon_sym_u_SQUOTE] = ACTIONS(1503),
    [anon_sym_U_SQUOTE] = ACTIONS(1503),
    [anon_sym_u8_SQUOTE] = ACTIONS(1503),
    [anon_sym_SQUOTE] = ACTIONS(1503),
    [anon_sym_L_DQUOTE] = ACTIONS(1503),
    [anon_sym_u_DQUOTE] = ACTIONS(1503),
    [anon_sym_U_DQUOTE] = ACTIONS(1503),
    [anon_sym_u8_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1503),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1501),
    [anon_sym_hitAttributeEXT] = ACTIONS(1501),
    [anon_sym_callableDataEXT] = ACTIONS(1501),
    [anon_sym_callableDataInEXT] = ACTIONS(1501),
    [anon_sym_shaderRecordEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadNV] = ACTIONS(1501),
    [anon_sym_rayPayloadInNV] = ACTIONS(1501),
    [anon_sym_hitAttributeNV] = ACTIONS(1501),
    [anon_sym_callableDataNV] = ACTIONS(1501),
    [anon_sym_callableDataInNV] = ACTIONS(1501),
    [anon_sym_shaderRecordNV] = ACTIONS(1501),
    [anon_sym_layout] = ACTIONS(1501),
  },
  [356] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token2] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1535),
    [aux_sym_preproc_include_token1] = ACTIONS(1535),
    [aux_sym_preproc_def_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token2] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1535),
    [sym_preproc_directive] = ACTIONS(1535),
    [anon_sym_LPAREN2] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_subroutine] = ACTIONS(1535),
    [anon_sym_invariant] = ACTIONS(1535),
    [anon_sym_precise] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_in] = ACTIONS(1535),
    [anon_sym_out] = ACTIONS(1535),
    [anon_sym_inout] = ACTIONS(1535),
    [anon_sym_uniform] = ACTIONS(1535),
    [anon_sym_shared] = ACTIONS(1535),
    [anon_sym_attribute] = ACTIONS(1535),
    [anon_sym_varying] = ACTIONS(1535),
    [anon_sym_buffer] = ACTIONS(1535),
    [anon_sym_coherent] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_writeonly] = ACTIONS(1535),
    [anon_sym_precision] = ACTIONS(1535),
    [anon_sym_highp] = ACTIONS(1535),
    [anon_sym_mediump] = ACTIONS(1535),
    [anon_sym_lowp] = ACTIONS(1535),
    [anon_sym_centroid] = ACTIONS(1535),
    [anon_sym_sample] = ACTIONS(1535),
    [anon_sym_patch] = ACTIONS(1535),
    [anon_sym_smooth] = ACTIONS(1535),
    [anon_sym_flat] = ACTIONS(1535),
    [anon_sym_noperspective] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1535),
    [anon_sym_typedef] = ACTIONS(1535),
    [anon_sym_extern] = ACTIONS(1535),
    [anon_sym___attribute__] = ACTIONS(1535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1537),
    [anon_sym___declspec] = ACTIONS(1535),
    [anon_sym___cdecl] = ACTIONS(1535),
    [anon_sym___clrcall] = ACTIONS(1535),
    [anon_sym___stdcall] = ACTIONS(1535),
    [anon_sym___fastcall] = ACTIONS(1535),
    [anon_sym___thiscall] = ACTIONS(1535),
    [anon_sym___vectorcall] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_signed] = ACTIONS(1535),
    [anon_sym_unsigned] = ACTIONS(1535),
    [anon_sym_long] = ACTIONS(1535),
    [anon_sym_short] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_auto] = ACTIONS(1535),
    [anon_sym_register] = ACTIONS(1535),
    [anon_sym_inline] = ACTIONS(1535),
    [anon_sym___inline] = ACTIONS(1535),
    [anon_sym___inline__] = ACTIONS(1535),
    [anon_sym___forceinline] = ACTIONS(1535),
    [anon_sym_thread_local] = ACTIONS(1535),
    [anon_sym___thread] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_constexpr] = ACTIONS(1535),
    [anon_sym_volatile] = ACTIONS(1535),
    [anon_sym_restrict] = ACTIONS(1535),
    [anon_sym___restrict__] = ACTIONS(1535),
    [anon_sym__Atomic] = ACTIONS(1535),
    [anon_sym__Noreturn] = ACTIONS(1535),
    [anon_sym_noreturn] = ACTIONS(1535),
    [anon_sym_alignas] = ACTIONS(1535),
    [anon_sym__Alignas] = ACTIONS(1535),
    [sym_primitive_type] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [anon_sym_struct] = ACTIONS(1535),
    [anon_sym_union] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_goto] = ACTIONS(1535),
    [anon_sym___try] = ACTIONS(1535),
    [anon_sym___leave] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_sizeof] = ACTIONS(1535),
    [anon_sym___alignof__] = ACTIONS(1535),
    [anon_sym___alignof] = ACTIONS(1535),
    [anon_sym__alignof] = ACTIONS(1535),
    [anon_sym_alignof] = ACTIONS(1535),
    [anon_sym__Alignof] = ACTIONS(1535),
    [anon_sym_offsetof] = ACTIONS(1535),
    [anon_sym__Generic] = ACTIONS(1535),
    [anon_sym_asm] = ACTIONS(1535),
    [anon_sym___asm__] = ACTIONS(1535),
    [sym_number_literal] = ACTIONS(1537),
    [anon_sym_L_SQUOTE] = ACTIONS(1537),
    [anon_sym_u_SQUOTE] = ACTIONS(1537),
    [anon_sym_U_SQUOTE] = ACTIONS(1537),
    [anon_sym_u8_SQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_L_DQUOTE] = ACTIONS(1537),
    [anon_sym_u_DQUOTE] = ACTIONS(1537),
    [anon_sym_U_DQUOTE] = ACTIONS(1537),
    [anon_sym_u8_DQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [anon_sym_NULL] = ACTIONS(1535),
    [anon_sym_nullptr] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1535),
    [anon_sym_hitAttributeEXT] = ACTIONS(1535),
    [anon_sym_callableDataEXT] = ACTIONS(1535),
    [anon_sym_callableDataInEXT] = ACTIONS(1535),
    [anon_sym_shaderRecordEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadNV] = ACTIONS(1535),
    [anon_sym_rayPayloadInNV] = ACTIONS(1535),
    [anon_sym_hitAttributeNV] = ACTIONS(1535),
    [anon_sym_callableDataNV] = ACTIONS(1535),
    [anon_sym_callableDataInNV] = ACTIONS(1535),
    [anon_sym_shaderRecordNV] = ACTIONS(1535),
    [anon_sym_layout] = ACTIONS(1535),
  },
  [358] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1477),
    [aux_sym_preproc_include_token1] = ACTIONS(1477),
    [aux_sym_preproc_def_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token2] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1477),
    [sym_preproc_directive] = ACTIONS(1477),
    [anon_sym_LPAREN2] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_subroutine] = ACTIONS(1477),
    [anon_sym_invariant] = ACTIONS(1477),
    [anon_sym_precise] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_in] = ACTIONS(1477),
    [anon_sym_out] = ACTIONS(1477),
    [anon_sym_inout] = ACTIONS(1477),
    [anon_sym_uniform] = ACTIONS(1477),
    [anon_sym_shared] = ACTIONS(1477),
    [anon_sym_attribute] = ACTIONS(1477),
    [anon_sym_varying] = ACTIONS(1477),
    [anon_sym_buffer] = ACTIONS(1477),
    [anon_sym_coherent] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_writeonly] = ACTIONS(1477),
    [anon_sym_precision] = ACTIONS(1477),
    [anon_sym_highp] = ACTIONS(1477),
    [anon_sym_mediump] = ACTIONS(1477),
    [anon_sym_lowp] = ACTIONS(1477),
    [anon_sym_centroid] = ACTIONS(1477),
    [anon_sym_sample] = ACTIONS(1477),
    [anon_sym_patch] = ACTIONS(1477),
    [anon_sym_smooth] = ACTIONS(1477),
    [anon_sym_flat] = ACTIONS(1477),
    [anon_sym_noperspective] = ACTIONS(1477),
    [anon_sym___extension__] = ACTIONS(1477),
    [anon_sym_typedef] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(1477),
    [anon_sym___attribute__] = ACTIONS(1477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1479),
    [anon_sym___declspec] = ACTIONS(1477),
    [anon_sym___cdecl] = ACTIONS(1477),
    [anon_sym___clrcall] = ACTIONS(1477),
    [anon_sym___stdcall] = ACTIONS(1477),
    [anon_sym___fastcall] = ACTIONS(1477),
    [anon_sym___thiscall] = ACTIONS(1477),
    [anon_sym___vectorcall] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_signed] = ACTIONS(1477),
    [anon_sym_unsigned] = ACTIONS(1477),
    [anon_sym_long] = ACTIONS(1477),
    [anon_sym_short] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_auto] = ACTIONS(1477),
    [anon_sym_register] = ACTIONS(1477),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym___inline] = ACTIONS(1477),
    [anon_sym___inline__] = ACTIONS(1477),
    [anon_sym___forceinline] = ACTIONS(1477),
    [anon_sym_thread_local] = ACTIONS(1477),
    [anon_sym___thread] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_constexpr] = ACTIONS(1477),
    [anon_sym_volatile] = ACTIONS(1477),
    [anon_sym_restrict] = ACTIONS(1477),
    [anon_sym___restrict__] = ACTIONS(1477),
    [anon_sym__Atomic] = ACTIONS(1477),
    [anon_sym__Noreturn] = ACTIONS(1477),
    [anon_sym_noreturn] = ACTIONS(1477),
    [anon_sym_alignas] = ACTIONS(1477),
    [anon_sym__Alignas] = ACTIONS(1477),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [anon_sym_struct] = ACTIONS(1477),
    [anon_sym_union] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_goto] = ACTIONS(1477),
    [anon_sym___try] = ACTIONS(1477),
    [anon_sym___leave] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_sizeof] = ACTIONS(1477),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1477),
    [anon_sym__Generic] = ACTIONS(1477),
    [anon_sym_asm] = ACTIONS(1477),
    [anon_sym___asm__] = ACTIONS(1477),
    [sym_number_literal] = ACTIONS(1479),
    [anon_sym_L_SQUOTE] = ACTIONS(1479),
    [anon_sym_u_SQUOTE] = ACTIONS(1479),
    [anon_sym_U_SQUOTE] = ACTIONS(1479),
    [anon_sym_u8_SQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [anon_sym_L_DQUOTE] = ACTIONS(1479),
    [anon_sym_u_DQUOTE] = ACTIONS(1479),
    [anon_sym_U_DQUOTE] = ACTIONS(1479),
    [anon_sym_u8_DQUOTE] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [anon_sym_NULL] = ACTIONS(1477),
    [anon_sym_nullptr] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1477),
    [anon_sym_hitAttributeEXT] = ACTIONS(1477),
    [anon_sym_callableDataEXT] = ACTIONS(1477),
    [anon_sym_callableDataInEXT] = ACTIONS(1477),
    [anon_sym_shaderRecordEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadNV] = ACTIONS(1477),
    [anon_sym_rayPayloadInNV] = ACTIONS(1477),
    [anon_sym_hitAttributeNV] = ACTIONS(1477),
    [anon_sym_callableDataNV] = ACTIONS(1477),
    [anon_sym_callableDataInNV] = ACTIONS(1477),
    [anon_sym_shaderRecordNV] = ACTIONS(1477),
    [anon_sym_layout] = ACTIONS(1477),
  },
  [360] = {
    [sym_identifier] = ACTIONS(1531),
    [aux_sym_preproc_include_token1] = ACTIONS(1531),
    [aux_sym_preproc_def_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1531),
    [sym_preproc_directive] = ACTIONS(1531),
    [anon_sym_LPAREN2] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_subroutine] = ACTIONS(1531),
    [anon_sym_invariant] = ACTIONS(1531),
    [anon_sym_precise] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1531),
    [anon_sym_out] = ACTIONS(1531),
    [anon_sym_inout] = ACTIONS(1531),
    [anon_sym_uniform] = ACTIONS(1531),
    [anon_sym_shared] = ACTIONS(1531),
    [anon_sym_attribute] = ACTIONS(1531),
    [anon_sym_varying] = ACTIONS(1531),
    [anon_sym_buffer] = ACTIONS(1531),
    [anon_sym_coherent] = ACTIONS(1531),
    [anon_sym_readonly] = ACTIONS(1531),
    [anon_sym_writeonly] = ACTIONS(1531),
    [anon_sym_precision] = ACTIONS(1531),
    [anon_sym_highp] = ACTIONS(1531),
    [anon_sym_mediump] = ACTIONS(1531),
    [anon_sym_lowp] = ACTIONS(1531),
    [anon_sym_centroid] = ACTIONS(1531),
    [anon_sym_sample] = ACTIONS(1531),
    [anon_sym_patch] = ACTIONS(1531),
    [anon_sym_smooth] = ACTIONS(1531),
    [anon_sym_flat] = ACTIONS(1531),
    [anon_sym_noperspective] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1531),
    [anon_sym_typedef] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(1531),
    [anon_sym___attribute__] = ACTIONS(1531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1533),
    [anon_sym___declspec] = ACTIONS(1531),
    [anon_sym___cdecl] = ACTIONS(1531),
    [anon_sym___clrcall] = ACTIONS(1531),
    [anon_sym___stdcall] = ACTIONS(1531),
    [anon_sym___fastcall] = ACTIONS(1531),
    [anon_sym___thiscall] = ACTIONS(1531),
    [anon_sym___vectorcall] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_signed] = ACTIONS(1531),
    [anon_sym_unsigned] = ACTIONS(1531),
    [anon_sym_long] = ACTIONS(1531),
    [anon_sym_short] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1531),
    [anon_sym_auto] = ACTIONS(1531),
    [anon_sym_register] = ACTIONS(1531),
    [anon_sym_inline] = ACTIONS(1531),
    [anon_sym___inline] = ACTIONS(1531),
    [anon_sym___inline__] = ACTIONS(1531),
    [anon_sym___forceinline] = ACTIONS(1531),
    [anon_sym_thread_local] = ACTIONS(1531),
    [anon_sym___thread] = ACTIONS(1531),
    [anon_sym_const] = ACTIONS(1531),
    [anon_sym_constexpr] = ACTIONS(1531),
    [anon_sym_volatile] = ACTIONS(1531),
    [anon_sym_restrict] = ACTIONS(1531),
    [anon_sym___restrict__] = ACTIONS(1531),
    [anon_sym__Atomic] = ACTIONS(1531),
    [anon_sym__Noreturn] = ACTIONS(1531),
    [anon_sym_noreturn] = ACTIONS(1531),
    [anon_sym_alignas] = ACTIONS(1531),
    [anon_sym__Alignas] = ACTIONS(1531),
    [sym_primitive_type] = ACTIONS(1531),
    [anon_sym_enum] = ACTIONS(1531),
    [anon_sym_struct] = ACTIONS(1531),
    [anon_sym_union] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_switch] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_do] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_continue] = ACTIONS(1531),
    [anon_sym_goto] = ACTIONS(1531),
    [anon_sym___try] = ACTIONS(1531),
    [anon_sym___leave] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_sizeof] = ACTIONS(1531),
    [anon_sym___alignof__] = ACTIONS(1531),
    [anon_sym___alignof] = ACTIONS(1531),
    [anon_sym__alignof] = ACTIONS(1531),
    [anon_sym_alignof] = ACTIONS(1531),
    [anon_sym__Alignof] = ACTIONS(1531),
    [anon_sym_offsetof] = ACTIONS(1531),
    [anon_sym__Generic] = ACTIONS(1531),
    [anon_sym_asm] = ACTIONS(1531),
    [anon_sym___asm__] = ACTIONS(1531),
    [sym_number_literal] = ACTIONS(1533),
    [anon_sym_L_SQUOTE] = ACTIONS(1533),
    [anon_sym_u_SQUOTE] = ACTIONS(1533),
    [anon_sym_U_SQUOTE] = ACTIONS(1533),
    [anon_sym_u8_SQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_L_DQUOTE] = ACTIONS(1533),
    [anon_sym_u_DQUOTE] = ACTIONS(1533),
    [anon_sym_U_DQUOTE] = ACTIONS(1533),
    [anon_sym_u8_DQUOTE] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [anon_sym_NULL] = ACTIONS(1531),
    [anon_sym_nullptr] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1531),
    [anon_sym_hitAttributeEXT] = ACTIONS(1531),
    [anon_sym_callableDataEXT] = ACTIONS(1531),
    [anon_sym_callableDataInEXT] = ACTIONS(1531),
    [anon_sym_shaderRecordEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadNV] = ACTIONS(1531),
    [anon_sym_rayPayloadInNV] = ACTIONS(1531),
    [anon_sym_hitAttributeNV] = ACTIONS(1531),
    [anon_sym_callableDataNV] = ACTIONS(1531),
    [anon_sym_callableDataInNV] = ACTIONS(1531),
    [anon_sym_shaderRecordNV] = ACTIONS(1531),
    [anon_sym_layout] = ACTIONS(1531),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1421),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token2] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_subroutine] = ACTIONS(1421),
    [anon_sym_invariant] = ACTIONS(1421),
    [anon_sym_precise] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1421),
    [anon_sym_out] = ACTIONS(1421),
    [anon_sym_inout] = ACTIONS(1421),
    [anon_sym_uniform] = ACTIONS(1421),
    [anon_sym_shared] = ACTIONS(1421),
    [anon_sym_attribute] = ACTIONS(1421),
    [anon_sym_varying] = ACTIONS(1421),
    [anon_sym_buffer] = ACTIONS(1421),
    [anon_sym_coherent] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_writeonly] = ACTIONS(1421),
    [anon_sym_precision] = ACTIONS(1421),
    [anon_sym_highp] = ACTIONS(1421),
    [anon_sym_mediump] = ACTIONS(1421),
    [anon_sym_lowp] = ACTIONS(1421),
    [anon_sym_centroid] = ACTIONS(1421),
    [anon_sym_sample] = ACTIONS(1421),
    [anon_sym_patch] = ACTIONS(1421),
    [anon_sym_smooth] = ACTIONS(1421),
    [anon_sym_flat] = ACTIONS(1421),
    [anon_sym_noperspective] = ACTIONS(1421),
    [anon_sym___extension__] = ACTIONS(1421),
    [anon_sym_typedef] = ACTIONS(1421),
    [anon_sym_extern] = ACTIONS(1421),
    [anon_sym___attribute__] = ACTIONS(1421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1423),
    [anon_sym___declspec] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1423),
    [anon_sym_signed] = ACTIONS(1421),
    [anon_sym_unsigned] = ACTIONS(1421),
    [anon_sym_long] = ACTIONS(1421),
    [anon_sym_short] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_auto] = ACTIONS(1421),
    [anon_sym_register] = ACTIONS(1421),
    [anon_sym_inline] = ACTIONS(1421),
    [anon_sym___inline] = ACTIONS(1421),
    [anon_sym___inline__] = ACTIONS(1421),
    [anon_sym___forceinline] = ACTIONS(1421),
    [anon_sym_thread_local] = ACTIONS(1421),
    [anon_sym___thread] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_constexpr] = ACTIONS(1421),
    [anon_sym_volatile] = ACTIONS(1421),
    [anon_sym_restrict] = ACTIONS(1421),
    [anon_sym___restrict__] = ACTIONS(1421),
    [anon_sym__Atomic] = ACTIONS(1421),
    [anon_sym__Noreturn] = ACTIONS(1421),
    [anon_sym_noreturn] = ACTIONS(1421),
    [anon_sym_alignas] = ACTIONS(1421),
    [anon_sym__Alignas] = ACTIONS(1421),
    [sym_primitive_type] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1421),
    [anon_sym_union] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_goto] = ACTIONS(1421),
    [anon_sym___try] = ACTIONS(1421),
    [anon_sym___leave] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1423),
    [anon_sym_sizeof] = ACTIONS(1421),
    [anon_sym___alignof__] = ACTIONS(1421),
    [anon_sym___alignof] = ACTIONS(1421),
    [anon_sym__alignof] = ACTIONS(1421),
    [anon_sym_alignof] = ACTIONS(1421),
    [anon_sym__Alignof] = ACTIONS(1421),
    [anon_sym_offsetof] = ACTIONS(1421),
    [anon_sym__Generic] = ACTIONS(1421),
    [anon_sym_asm] = ACTIONS(1421),
    [anon_sym___asm__] = ACTIONS(1421),
    [sym_number_literal] = ACTIONS(1423),
    [anon_sym_L_SQUOTE] = ACTIONS(1423),
    [anon_sym_u_SQUOTE] = ACTIONS(1423),
    [anon_sym_U_SQUOTE] = ACTIONS(1423),
    [anon_sym_u8_SQUOTE] = ACTIONS(1423),
    [anon_sym_SQUOTE] = ACTIONS(1423),
    [anon_sym_L_DQUOTE] = ACTIONS(1423),
    [anon_sym_u_DQUOTE] = ACTIONS(1423),
    [anon_sym_U_DQUOTE] = ACTIONS(1423),
    [anon_sym_u8_DQUOTE] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [anon_sym_NULL] = ACTIONS(1421),
    [anon_sym_nullptr] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1421),
    [anon_sym_hitAttributeEXT] = ACTIONS(1421),
    [anon_sym_callableDataEXT] = ACTIONS(1421),
    [anon_sym_callableDataInEXT] = ACTIONS(1421),
    [anon_sym_shaderRecordEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadNV] = ACTIONS(1421),
    [anon_sym_rayPayloadInNV] = ACTIONS(1421),
    [anon_sym_hitAttributeNV] = ACTIONS(1421),
    [anon_sym_callableDataNV] = ACTIONS(1421),
    [anon_sym_callableDataInNV] = ACTIONS(1421),
    [anon_sym_shaderRecordNV] = ACTIONS(1421),
    [anon_sym_layout] = ACTIONS(1421),
  },
  [362] = {
    [sym_identifier] = ACTIONS(1405),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token2] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_subroutine] = ACTIONS(1405),
    [anon_sym_invariant] = ACTIONS(1405),
    [anon_sym_precise] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_in] = ACTIONS(1405),
    [anon_sym_out] = ACTIONS(1405),
    [anon_sym_inout] = ACTIONS(1405),
    [anon_sym_uniform] = ACTIONS(1405),
    [anon_sym_shared] = ACTIONS(1405),
    [anon_sym_attribute] = ACTIONS(1405),
    [anon_sym_varying] = ACTIONS(1405),
    [anon_sym_buffer] = ACTIONS(1405),
    [anon_sym_coherent] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(1405),
    [anon_sym_writeonly] = ACTIONS(1405),
    [anon_sym_precision] = ACTIONS(1405),
    [anon_sym_highp] = ACTIONS(1405),
    [anon_sym_mediump] = ACTIONS(1405),
    [anon_sym_lowp] = ACTIONS(1405),
    [anon_sym_centroid] = ACTIONS(1405),
    [anon_sym_sample] = ACTIONS(1405),
    [anon_sym_patch] = ACTIONS(1405),
    [anon_sym_smooth] = ACTIONS(1405),
    [anon_sym_flat] = ACTIONS(1405),
    [anon_sym_noperspective] = ACTIONS(1405),
    [anon_sym___extension__] = ACTIONS(1405),
    [anon_sym_typedef] = ACTIONS(1405),
    [anon_sym_extern] = ACTIONS(1405),
    [anon_sym___attribute__] = ACTIONS(1405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1407),
    [anon_sym___declspec] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_signed] = ACTIONS(1405),
    [anon_sym_unsigned] = ACTIONS(1405),
    [anon_sym_long] = ACTIONS(1405),
    [anon_sym_short] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_auto] = ACTIONS(1405),
    [anon_sym_register] = ACTIONS(1405),
    [anon_sym_inline] = ACTIONS(1405),
    [anon_sym___inline] = ACTIONS(1405),
    [anon_sym___inline__] = ACTIONS(1405),
    [anon_sym___forceinline] = ACTIONS(1405),
    [anon_sym_thread_local] = ACTIONS(1405),
    [anon_sym___thread] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1405),
    [anon_sym_constexpr] = ACTIONS(1405),
    [anon_sym_volatile] = ACTIONS(1405),
    [anon_sym_restrict] = ACTIONS(1405),
    [anon_sym___restrict__] = ACTIONS(1405),
    [anon_sym__Atomic] = ACTIONS(1405),
    [anon_sym__Noreturn] = ACTIONS(1405),
    [anon_sym_noreturn] = ACTIONS(1405),
    [anon_sym_alignas] = ACTIONS(1405),
    [anon_sym__Alignas] = ACTIONS(1405),
    [sym_primitive_type] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1405),
    [anon_sym_union] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(1405),
    [anon_sym_for] = ACTIONS(1405),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_break] = ACTIONS(1405),
    [anon_sym_continue] = ACTIONS(1405),
    [anon_sym_goto] = ACTIONS(1405),
    [anon_sym___try] = ACTIONS(1405),
    [anon_sym___leave] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1405),
    [anon_sym___alignof__] = ACTIONS(1405),
    [anon_sym___alignof] = ACTIONS(1405),
    [anon_sym__alignof] = ACTIONS(1405),
    [anon_sym_alignof] = ACTIONS(1405),
    [anon_sym__Alignof] = ACTIONS(1405),
    [anon_sym_offsetof] = ACTIONS(1405),
    [anon_sym__Generic] = ACTIONS(1405),
    [anon_sym_asm] = ACTIONS(1405),
    [anon_sym___asm__] = ACTIONS(1405),
    [sym_number_literal] = ACTIONS(1407),
    [anon_sym_L_SQUOTE] = ACTIONS(1407),
    [anon_sym_u_SQUOTE] = ACTIONS(1407),
    [anon_sym_U_SQUOTE] = ACTIONS(1407),
    [anon_sym_u8_SQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_L_DQUOTE] = ACTIONS(1407),
    [anon_sym_u_DQUOTE] = ACTIONS(1407),
    [anon_sym_U_DQUOTE] = ACTIONS(1407),
    [anon_sym_u8_DQUOTE] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [anon_sym_NULL] = ACTIONS(1405),
    [anon_sym_nullptr] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1405),
    [anon_sym_hitAttributeEXT] = ACTIONS(1405),
    [anon_sym_callableDataEXT] = ACTIONS(1405),
    [anon_sym_callableDataInEXT] = ACTIONS(1405),
    [anon_sym_shaderRecordEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadNV] = ACTIONS(1405),
    [anon_sym_rayPayloadInNV] = ACTIONS(1405),
    [anon_sym_hitAttributeNV] = ACTIONS(1405),
    [anon_sym_callableDataNV] = ACTIONS(1405),
    [anon_sym_callableDataInNV] = ACTIONS(1405),
    [anon_sym_shaderRecordNV] = ACTIONS(1405),
    [anon_sym_layout] = ACTIONS(1405),
  },
  [363] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_typedef] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_goto] = ACTIONS(1429),
    [anon_sym___try] = ACTIONS(1429),
    [anon_sym___leave] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_sizeof] = ACTIONS(1429),
    [anon_sym___alignof__] = ACTIONS(1429),
    [anon_sym___alignof] = ACTIONS(1429),
    [anon_sym__alignof] = ACTIONS(1429),
    [anon_sym_alignof] = ACTIONS(1429),
    [anon_sym__Alignof] = ACTIONS(1429),
    [anon_sym_offsetof] = ACTIONS(1429),
    [anon_sym__Generic] = ACTIONS(1429),
    [anon_sym_asm] = ACTIONS(1429),
    [anon_sym___asm__] = ACTIONS(1429),
    [sym_number_literal] = ACTIONS(1431),
    [anon_sym_L_SQUOTE] = ACTIONS(1431),
    [anon_sym_u_SQUOTE] = ACTIONS(1431),
    [anon_sym_U_SQUOTE] = ACTIONS(1431),
    [anon_sym_u8_SQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [anon_sym_L_DQUOTE] = ACTIONS(1431),
    [anon_sym_u_DQUOTE] = ACTIONS(1431),
    [anon_sym_U_DQUOTE] = ACTIONS(1431),
    [anon_sym_u8_DQUOTE] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [anon_sym_NULL] = ACTIONS(1429),
    [anon_sym_nullptr] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1465),
    [aux_sym_preproc_include_token1] = ACTIONS(1465),
    [aux_sym_preproc_def_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token2] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1465),
    [sym_preproc_directive] = ACTIONS(1465),
    [anon_sym_LPAREN2] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_subroutine] = ACTIONS(1465),
    [anon_sym_invariant] = ACTIONS(1465),
    [anon_sym_precise] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(1465),
    [anon_sym_out] = ACTIONS(1465),
    [anon_sym_inout] = ACTIONS(1465),
    [anon_sym_uniform] = ACTIONS(1465),
    [anon_sym_shared] = ACTIONS(1465),
    [anon_sym_attribute] = ACTIONS(1465),
    [anon_sym_varying] = ACTIONS(1465),
    [anon_sym_buffer] = ACTIONS(1465),
    [anon_sym_coherent] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_writeonly] = ACTIONS(1465),
    [anon_sym_precision] = ACTIONS(1465),
    [anon_sym_highp] = ACTIONS(1465),
    [anon_sym_mediump] = ACTIONS(1465),
    [anon_sym_lowp] = ACTIONS(1465),
    [anon_sym_centroid] = ACTIONS(1465),
    [anon_sym_sample] = ACTIONS(1465),
    [anon_sym_patch] = ACTIONS(1465),
    [anon_sym_smooth] = ACTIONS(1465),
    [anon_sym_flat] = ACTIONS(1465),
    [anon_sym_noperspective] = ACTIONS(1465),
    [anon_sym___extension__] = ACTIONS(1465),
    [anon_sym_typedef] = ACTIONS(1465),
    [anon_sym_extern] = ACTIONS(1465),
    [anon_sym___attribute__] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1467),
    [anon_sym___declspec] = ACTIONS(1465),
    [anon_sym___cdecl] = ACTIONS(1465),
    [anon_sym___clrcall] = ACTIONS(1465),
    [anon_sym___stdcall] = ACTIONS(1465),
    [anon_sym___fastcall] = ACTIONS(1465),
    [anon_sym___thiscall] = ACTIONS(1465),
    [anon_sym___vectorcall] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_signed] = ACTIONS(1465),
    [anon_sym_unsigned] = ACTIONS(1465),
    [anon_sym_long] = ACTIONS(1465),
    [anon_sym_short] = ACTIONS(1465),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_auto] = ACTIONS(1465),
    [anon_sym_register] = ACTIONS(1465),
    [anon_sym_inline] = ACTIONS(1465),
    [anon_sym___inline] = ACTIONS(1465),
    [anon_sym___inline__] = ACTIONS(1465),
    [anon_sym___forceinline] = ACTIONS(1465),
    [anon_sym_thread_local] = ACTIONS(1465),
    [anon_sym___thread] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_constexpr] = ACTIONS(1465),
    [anon_sym_volatile] = ACTIONS(1465),
    [anon_sym_restrict] = ACTIONS(1465),
    [anon_sym___restrict__] = ACTIONS(1465),
    [anon_sym__Atomic] = ACTIONS(1465),
    [anon_sym__Noreturn] = ACTIONS(1465),
    [anon_sym_noreturn] = ACTIONS(1465),
    [anon_sym_alignas] = ACTIONS(1465),
    [anon_sym__Alignas] = ACTIONS(1465),
    [sym_primitive_type] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [anon_sym_struct] = ACTIONS(1465),
    [anon_sym_union] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_goto] = ACTIONS(1465),
    [anon_sym___try] = ACTIONS(1465),
    [anon_sym___leave] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1467),
    [anon_sym_sizeof] = ACTIONS(1465),
    [anon_sym___alignof__] = ACTIONS(1465),
    [anon_sym___alignof] = ACTIONS(1465),
    [anon_sym__alignof] = ACTIONS(1465),
    [anon_sym_alignof] = ACTIONS(1465),
    [anon_sym__Alignof] = ACTIONS(1465),
    [anon_sym_offsetof] = ACTIONS(1465),
    [anon_sym__Generic] = ACTIONS(1465),
    [anon_sym_asm] = ACTIONS(1465),
    [anon_sym___asm__] = ACTIONS(1465),
    [sym_number_literal] = ACTIONS(1467),
    [anon_sym_L_SQUOTE] = ACTIONS(1467),
    [anon_sym_u_SQUOTE] = ACTIONS(1467),
    [anon_sym_U_SQUOTE] = ACTIONS(1467),
    [anon_sym_u8_SQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_L_DQUOTE] = ACTIONS(1467),
    [anon_sym_u_DQUOTE] = ACTIONS(1467),
    [anon_sym_U_DQUOTE] = ACTIONS(1467),
    [anon_sym_u8_DQUOTE] = ACTIONS(1467),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [anon_sym_NULL] = ACTIONS(1465),
    [anon_sym_nullptr] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1465),
    [anon_sym_hitAttributeEXT] = ACTIONS(1465),
    [anon_sym_callableDataEXT] = ACTIONS(1465),
    [anon_sym_callableDataInEXT] = ACTIONS(1465),
    [anon_sym_shaderRecordEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadNV] = ACTIONS(1465),
    [anon_sym_rayPayloadInNV] = ACTIONS(1465),
    [anon_sym_hitAttributeNV] = ACTIONS(1465),
    [anon_sym_callableDataNV] = ACTIONS(1465),
    [anon_sym_callableDataInNV] = ACTIONS(1465),
    [anon_sym_shaderRecordNV] = ACTIONS(1465),
    [anon_sym_layout] = ACTIONS(1465),
  },
  [365] = {
    [sym_identifier] = ACTIONS(1417),
    [aux_sym_preproc_include_token1] = ACTIONS(1417),
    [aux_sym_preproc_def_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token2] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1417),
    [sym_preproc_directive] = ACTIONS(1417),
    [anon_sym_LPAREN2] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_subroutine] = ACTIONS(1417),
    [anon_sym_invariant] = ACTIONS(1417),
    [anon_sym_precise] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_in] = ACTIONS(1417),
    [anon_sym_out] = ACTIONS(1417),
    [anon_sym_inout] = ACTIONS(1417),
    [anon_sym_uniform] = ACTIONS(1417),
    [anon_sym_shared] = ACTIONS(1417),
    [anon_sym_attribute] = ACTIONS(1417),
    [anon_sym_varying] = ACTIONS(1417),
    [anon_sym_buffer] = ACTIONS(1417),
    [anon_sym_coherent] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_writeonly] = ACTIONS(1417),
    [anon_sym_precision] = ACTIONS(1417),
    [anon_sym_highp] = ACTIONS(1417),
    [anon_sym_mediump] = ACTIONS(1417),
    [anon_sym_lowp] = ACTIONS(1417),
    [anon_sym_centroid] = ACTIONS(1417),
    [anon_sym_sample] = ACTIONS(1417),
    [anon_sym_patch] = ACTIONS(1417),
    [anon_sym_smooth] = ACTIONS(1417),
    [anon_sym_flat] = ACTIONS(1417),
    [anon_sym_noperspective] = ACTIONS(1417),
    [anon_sym___extension__] = ACTIONS(1417),
    [anon_sym_typedef] = ACTIONS(1417),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym___attribute__] = ACTIONS(1417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1419),
    [anon_sym___declspec] = ACTIONS(1417),
    [anon_sym___cdecl] = ACTIONS(1417),
    [anon_sym___clrcall] = ACTIONS(1417),
    [anon_sym___stdcall] = ACTIONS(1417),
    [anon_sym___fastcall] = ACTIONS(1417),
    [anon_sym___thiscall] = ACTIONS(1417),
    [anon_sym___vectorcall] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_signed] = ACTIONS(1417),
    [anon_sym_unsigned] = ACTIONS(1417),
    [anon_sym_long] = ACTIONS(1417),
    [anon_sym_short] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_auto] = ACTIONS(1417),
    [anon_sym_register] = ACTIONS(1417),
    [anon_sym_inline] = ACTIONS(1417),
    [anon_sym___inline] = ACTIONS(1417),
    [anon_sym___inline__] = ACTIONS(1417),
    [anon_sym___forceinline] = ACTIONS(1417),
    [anon_sym_thread_local] = ACTIONS(1417),
    [anon_sym___thread] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_constexpr] = ACTIONS(1417),
    [anon_sym_volatile] = ACTIONS(1417),
    [anon_sym_restrict] = ACTIONS(1417),
    [anon_sym___restrict__] = ACTIONS(1417),
    [anon_sym__Atomic] = ACTIONS(1417),
    [anon_sym__Noreturn] = ACTIONS(1417),
    [anon_sym_noreturn] = ACTIONS(1417),
    [anon_sym_alignas] = ACTIONS(1417),
    [anon_sym__Alignas] = ACTIONS(1417),
    [sym_primitive_type] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_goto] = ACTIONS(1417),
    [anon_sym___try] = ACTIONS(1417),
    [anon_sym___leave] = ACTIONS(1417),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_sizeof] = ACTIONS(1417),
    [anon_sym___alignof__] = ACTIONS(1417),
    [anon_sym___alignof] = ACTIONS(1417),
    [anon_sym__alignof] = ACTIONS(1417),
    [anon_sym_alignof] = ACTIONS(1417),
    [anon_sym__Alignof] = ACTIONS(1417),
    [anon_sym_offsetof] = ACTIONS(1417),
    [anon_sym__Generic] = ACTIONS(1417),
    [anon_sym_asm] = ACTIONS(1417),
    [anon_sym___asm__] = ACTIONS(1417),
    [sym_number_literal] = ACTIONS(1419),
    [anon_sym_L_SQUOTE] = ACTIONS(1419),
    [anon_sym_u_SQUOTE] = ACTIONS(1419),
    [anon_sym_U_SQUOTE] = ACTIONS(1419),
    [anon_sym_u8_SQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [anon_sym_L_DQUOTE] = ACTIONS(1419),
    [anon_sym_u_DQUOTE] = ACTIONS(1419),
    [anon_sym_U_DQUOTE] = ACTIONS(1419),
    [anon_sym_u8_DQUOTE] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [anon_sym_NULL] = ACTIONS(1417),
    [anon_sym_nullptr] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1417),
    [anon_sym_hitAttributeEXT] = ACTIONS(1417),
    [anon_sym_callableDataEXT] = ACTIONS(1417),
    [anon_sym_callableDataInEXT] = ACTIONS(1417),
    [anon_sym_shaderRecordEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadNV] = ACTIONS(1417),
    [anon_sym_rayPayloadInNV] = ACTIONS(1417),
    [anon_sym_hitAttributeNV] = ACTIONS(1417),
    [anon_sym_callableDataNV] = ACTIONS(1417),
    [anon_sym_callableDataInNV] = ACTIONS(1417),
    [anon_sym_shaderRecordNV] = ACTIONS(1417),
    [anon_sym_layout] = ACTIONS(1417),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym___try] = ACTIONS(1505),
    [anon_sym___leave] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [367] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1431),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_typedef] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_goto] = ACTIONS(1429),
    [anon_sym___try] = ACTIONS(1429),
    [anon_sym___leave] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_sizeof] = ACTIONS(1429),
    [anon_sym___alignof__] = ACTIONS(1429),
    [anon_sym___alignof] = ACTIONS(1429),
    [anon_sym__alignof] = ACTIONS(1429),
    [anon_sym_alignof] = ACTIONS(1429),
    [anon_sym__Alignof] = ACTIONS(1429),
    [anon_sym_offsetof] = ACTIONS(1429),
    [anon_sym__Generic] = ACTIONS(1429),
    [anon_sym_asm] = ACTIONS(1429),
    [anon_sym___asm__] = ACTIONS(1429),
    [sym_number_literal] = ACTIONS(1431),
    [anon_sym_L_SQUOTE] = ACTIONS(1431),
    [anon_sym_u_SQUOTE] = ACTIONS(1431),
    [anon_sym_U_SQUOTE] = ACTIONS(1431),
    [anon_sym_u8_SQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [anon_sym_L_DQUOTE] = ACTIONS(1431),
    [anon_sym_u_DQUOTE] = ACTIONS(1431),
    [anon_sym_U_DQUOTE] = ACTIONS(1431),
    [anon_sym_u8_DQUOTE] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [anon_sym_NULL] = ACTIONS(1429),
    [anon_sym_nullptr] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [368] = {
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1437),
    [aux_sym_preproc_def_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1437),
    [sym_preproc_directive] = ACTIONS(1437),
    [anon_sym_LPAREN2] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_subroutine] = ACTIONS(1437),
    [anon_sym_invariant] = ACTIONS(1437),
    [anon_sym_precise] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_in] = ACTIONS(1437),
    [anon_sym_out] = ACTIONS(1437),
    [anon_sym_inout] = ACTIONS(1437),
    [anon_sym_uniform] = ACTIONS(1437),
    [anon_sym_shared] = ACTIONS(1437),
    [anon_sym_attribute] = ACTIONS(1437),
    [anon_sym_varying] = ACTIONS(1437),
    [anon_sym_buffer] = ACTIONS(1437),
    [anon_sym_coherent] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_writeonly] = ACTIONS(1437),
    [anon_sym_precision] = ACTIONS(1437),
    [anon_sym_highp] = ACTIONS(1437),
    [anon_sym_mediump] = ACTIONS(1437),
    [anon_sym_lowp] = ACTIONS(1437),
    [anon_sym_centroid] = ACTIONS(1437),
    [anon_sym_sample] = ACTIONS(1437),
    [anon_sym_patch] = ACTIONS(1437),
    [anon_sym_smooth] = ACTIONS(1437),
    [anon_sym_flat] = ACTIONS(1437),
    [anon_sym_noperspective] = ACTIONS(1437),
    [anon_sym___extension__] = ACTIONS(1437),
    [anon_sym_typedef] = ACTIONS(1437),
    [anon_sym_extern] = ACTIONS(1437),
    [anon_sym___attribute__] = ACTIONS(1437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1439),
    [anon_sym___declspec] = ACTIONS(1437),
    [anon_sym___cdecl] = ACTIONS(1437),
    [anon_sym___clrcall] = ACTIONS(1437),
    [anon_sym___stdcall] = ACTIONS(1437),
    [anon_sym___fastcall] = ACTIONS(1437),
    [anon_sym___thiscall] = ACTIONS(1437),
    [anon_sym___vectorcall] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [anon_sym_signed] = ACTIONS(1437),
    [anon_sym_unsigned] = ACTIONS(1437),
    [anon_sym_long] = ACTIONS(1437),
    [anon_sym_short] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_auto] = ACTIONS(1437),
    [anon_sym_register] = ACTIONS(1437),
    [anon_sym_inline] = ACTIONS(1437),
    [anon_sym___inline] = ACTIONS(1437),
    [anon_sym___inline__] = ACTIONS(1437),
    [anon_sym___forceinline] = ACTIONS(1437),
    [anon_sym_thread_local] = ACTIONS(1437),
    [anon_sym___thread] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_constexpr] = ACTIONS(1437),
    [anon_sym_volatile] = ACTIONS(1437),
    [anon_sym_restrict] = ACTIONS(1437),
    [anon_sym___restrict__] = ACTIONS(1437),
    [anon_sym__Atomic] = ACTIONS(1437),
    [anon_sym__Noreturn] = ACTIONS(1437),
    [anon_sym_noreturn] = ACTIONS(1437),
    [anon_sym_alignas] = ACTIONS(1437),
    [anon_sym__Alignas] = ACTIONS(1437),
    [sym_primitive_type] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1437),
    [anon_sym_union] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_goto] = ACTIONS(1437),
    [anon_sym___try] = ACTIONS(1437),
    [anon_sym___leave] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_sizeof] = ACTIONS(1437),
    [anon_sym___alignof__] = ACTIONS(1437),
    [anon_sym___alignof] = ACTIONS(1437),
    [anon_sym__alignof] = ACTIONS(1437),
    [anon_sym_alignof] = ACTIONS(1437),
    [anon_sym__Alignof] = ACTIONS(1437),
    [anon_sym_offsetof] = ACTIONS(1437),
    [anon_sym__Generic] = ACTIONS(1437),
    [anon_sym_asm] = ACTIONS(1437),
    [anon_sym___asm__] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1439),
    [anon_sym_L_SQUOTE] = ACTIONS(1439),
    [anon_sym_u_SQUOTE] = ACTIONS(1439),
    [anon_sym_U_SQUOTE] = ACTIONS(1439),
    [anon_sym_u8_SQUOTE] = ACTIONS(1439),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_L_DQUOTE] = ACTIONS(1439),
    [anon_sym_u_DQUOTE] = ACTIONS(1439),
    [anon_sym_U_DQUOTE] = ACTIONS(1439),
    [anon_sym_u8_DQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [anon_sym_NULL] = ACTIONS(1437),
    [anon_sym_nullptr] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1437),
    [anon_sym_hitAttributeEXT] = ACTIONS(1437),
    [anon_sym_callableDataEXT] = ACTIONS(1437),
    [anon_sym_callableDataInEXT] = ACTIONS(1437),
    [anon_sym_shaderRecordEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadNV] = ACTIONS(1437),
    [anon_sym_rayPayloadInNV] = ACTIONS(1437),
    [anon_sym_hitAttributeNV] = ACTIONS(1437),
    [anon_sym_callableDataNV] = ACTIONS(1437),
    [anon_sym_callableDataInNV] = ACTIONS(1437),
    [anon_sym_shaderRecordNV] = ACTIONS(1437),
    [anon_sym_layout] = ACTIONS(1437),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1453),
    [aux_sym_preproc_include_token1] = ACTIONS(1453),
    [aux_sym_preproc_def_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1453),
    [sym_preproc_directive] = ACTIONS(1453),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_subroutine] = ACTIONS(1453),
    [anon_sym_invariant] = ACTIONS(1453),
    [anon_sym_precise] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1455),
    [anon_sym_in] = ACTIONS(1453),
    [anon_sym_out] = ACTIONS(1453),
    [anon_sym_inout] = ACTIONS(1453),
    [anon_sym_uniform] = ACTIONS(1453),
    [anon_sym_shared] = ACTIONS(1453),
    [anon_sym_attribute] = ACTIONS(1453),
    [anon_sym_varying] = ACTIONS(1453),
    [anon_sym_buffer] = ACTIONS(1453),
    [anon_sym_coherent] = ACTIONS(1453),
    [anon_sym_readonly] = ACTIONS(1453),
    [anon_sym_writeonly] = ACTIONS(1453),
    [anon_sym_precision] = ACTIONS(1453),
    [anon_sym_highp] = ACTIONS(1453),
    [anon_sym_mediump] = ACTIONS(1453),
    [anon_sym_lowp] = ACTIONS(1453),
    [anon_sym_centroid] = ACTIONS(1453),
    [anon_sym_sample] = ACTIONS(1453),
    [anon_sym_patch] = ACTIONS(1453),
    [anon_sym_smooth] = ACTIONS(1453),
    [anon_sym_flat] = ACTIONS(1453),
    [anon_sym_noperspective] = ACTIONS(1453),
    [anon_sym___extension__] = ACTIONS(1453),
    [anon_sym_typedef] = ACTIONS(1453),
    [anon_sym_extern] = ACTIONS(1453),
    [anon_sym___attribute__] = ACTIONS(1453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1455),
    [anon_sym___declspec] = ACTIONS(1453),
    [anon_sym___cdecl] = ACTIONS(1453),
    [anon_sym___clrcall] = ACTIONS(1453),
    [anon_sym___stdcall] = ACTIONS(1453),
    [anon_sym___fastcall] = ACTIONS(1453),
    [anon_sym___thiscall] = ACTIONS(1453),
    [anon_sym___vectorcall] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_signed] = ACTIONS(1453),
    [anon_sym_unsigned] = ACTIONS(1453),
    [anon_sym_long] = ACTIONS(1453),
    [anon_sym_short] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_auto] = ACTIONS(1453),
    [anon_sym_register] = ACTIONS(1453),
    [anon_sym_inline] = ACTIONS(1453),
    [anon_sym___inline] = ACTIONS(1453),
    [anon_sym___inline__] = ACTIONS(1453),
    [anon_sym___forceinline] = ACTIONS(1453),
    [anon_sym_thread_local] = ACTIONS(1453),
    [anon_sym___thread] = ACTIONS(1453),
    [anon_sym_const] = ACTIONS(1453),
    [anon_sym_constexpr] = ACTIONS(1453),
    [anon_sym_volatile] = ACTIONS(1453),
    [anon_sym_restrict] = ACTIONS(1453),
    [anon_sym___restrict__] = ACTIONS(1453),
    [anon_sym__Atomic] = ACTIONS(1453),
    [anon_sym__Noreturn] = ACTIONS(1453),
    [anon_sym_noreturn] = ACTIONS(1453),
    [anon_sym_alignas] = ACTIONS(1453),
    [anon_sym__Alignas] = ACTIONS(1453),
    [sym_primitive_type] = ACTIONS(1453),
    [anon_sym_enum] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1453),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1453),
    [anon_sym_default] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_for] = ACTIONS(1453),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1453),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_goto] = ACTIONS(1453),
    [anon_sym___try] = ACTIONS(1453),
    [anon_sym___leave] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1455),
    [anon_sym_sizeof] = ACTIONS(1453),
    [anon_sym___alignof__] = ACTIONS(1453),
    [anon_sym___alignof] = ACTIONS(1453),
    [anon_sym__alignof] = ACTIONS(1453),
    [anon_sym_alignof] = ACTIONS(1453),
    [anon_sym__Alignof] = ACTIONS(1453),
    [anon_sym_offsetof] = ACTIONS(1453),
    [anon_sym__Generic] = ACTIONS(1453),
    [anon_sym_asm] = ACTIONS(1453),
    [anon_sym___asm__] = ACTIONS(1453),
    [sym_number_literal] = ACTIONS(1455),
    [anon_sym_L_SQUOTE] = ACTIONS(1455),
    [anon_sym_u_SQUOTE] = ACTIONS(1455),
    [anon_sym_U_SQUOTE] = ACTIONS(1455),
    [anon_sym_u8_SQUOTE] = ACTIONS(1455),
    [anon_sym_SQUOTE] = ACTIONS(1455),
    [anon_sym_L_DQUOTE] = ACTIONS(1455),
    [anon_sym_u_DQUOTE] = ACTIONS(1455),
    [anon_sym_U_DQUOTE] = ACTIONS(1455),
    [anon_sym_u8_DQUOTE] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [anon_sym_NULL] = ACTIONS(1453),
    [anon_sym_nullptr] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1453),
    [anon_sym_hitAttributeEXT] = ACTIONS(1453),
    [anon_sym_callableDataEXT] = ACTIONS(1453),
    [anon_sym_callableDataInEXT] = ACTIONS(1453),
    [anon_sym_shaderRecordEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadNV] = ACTIONS(1453),
    [anon_sym_rayPayloadInNV] = ACTIONS(1453),
    [anon_sym_hitAttributeNV] = ACTIONS(1453),
    [anon_sym_callableDataNV] = ACTIONS(1453),
    [anon_sym_callableDataInNV] = ACTIONS(1453),
    [anon_sym_shaderRecordNV] = ACTIONS(1453),
    [anon_sym_layout] = ACTIONS(1453),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1461),
    [aux_sym_preproc_include_token1] = ACTIONS(1461),
    [aux_sym_preproc_def_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1461),
    [sym_preproc_directive] = ACTIONS(1461),
    [anon_sym_LPAREN2] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_subroutine] = ACTIONS(1461),
    [anon_sym_invariant] = ACTIONS(1461),
    [anon_sym_precise] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_out] = ACTIONS(1461),
    [anon_sym_inout] = ACTIONS(1461),
    [anon_sym_uniform] = ACTIONS(1461),
    [anon_sym_shared] = ACTIONS(1461),
    [anon_sym_attribute] = ACTIONS(1461),
    [anon_sym_varying] = ACTIONS(1461),
    [anon_sym_buffer] = ACTIONS(1461),
    [anon_sym_coherent] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_writeonly] = ACTIONS(1461),
    [anon_sym_precision] = ACTIONS(1461),
    [anon_sym_highp] = ACTIONS(1461),
    [anon_sym_mediump] = ACTIONS(1461),
    [anon_sym_lowp] = ACTIONS(1461),
    [anon_sym_centroid] = ACTIONS(1461),
    [anon_sym_sample] = ACTIONS(1461),
    [anon_sym_patch] = ACTIONS(1461),
    [anon_sym_smooth] = ACTIONS(1461),
    [anon_sym_flat] = ACTIONS(1461),
    [anon_sym_noperspective] = ACTIONS(1461),
    [anon_sym___extension__] = ACTIONS(1461),
    [anon_sym_typedef] = ACTIONS(1461),
    [anon_sym_extern] = ACTIONS(1461),
    [anon_sym___attribute__] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1463),
    [anon_sym___declspec] = ACTIONS(1461),
    [anon_sym___cdecl] = ACTIONS(1461),
    [anon_sym___clrcall] = ACTIONS(1461),
    [anon_sym___stdcall] = ACTIONS(1461),
    [anon_sym___fastcall] = ACTIONS(1461),
    [anon_sym___thiscall] = ACTIONS(1461),
    [anon_sym___vectorcall] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_signed] = ACTIONS(1461),
    [anon_sym_unsigned] = ACTIONS(1461),
    [anon_sym_long] = ACTIONS(1461),
    [anon_sym_short] = ACTIONS(1461),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_auto] = ACTIONS(1461),
    [anon_sym_register] = ACTIONS(1461),
    [anon_sym_inline] = ACTIONS(1461),
    [anon_sym___inline] = ACTIONS(1461),
    [anon_sym___inline__] = ACTIONS(1461),
    [anon_sym___forceinline] = ACTIONS(1461),
    [anon_sym_thread_local] = ACTIONS(1461),
    [anon_sym___thread] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_constexpr] = ACTIONS(1461),
    [anon_sym_volatile] = ACTIONS(1461),
    [anon_sym_restrict] = ACTIONS(1461),
    [anon_sym___restrict__] = ACTIONS(1461),
    [anon_sym__Atomic] = ACTIONS(1461),
    [anon_sym__Noreturn] = ACTIONS(1461),
    [anon_sym_noreturn] = ACTIONS(1461),
    [anon_sym_alignas] = ACTIONS(1461),
    [anon_sym__Alignas] = ACTIONS(1461),
    [sym_primitive_type] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_union] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_goto] = ACTIONS(1461),
    [anon_sym___try] = ACTIONS(1461),
    [anon_sym___leave] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_sizeof] = ACTIONS(1461),
    [anon_sym___alignof__] = ACTIONS(1461),
    [anon_sym___alignof] = ACTIONS(1461),
    [anon_sym__alignof] = ACTIONS(1461),
    [anon_sym_alignof] = ACTIONS(1461),
    [anon_sym__Alignof] = ACTIONS(1461),
    [anon_sym_offsetof] = ACTIONS(1461),
    [anon_sym__Generic] = ACTIONS(1461),
    [anon_sym_asm] = ACTIONS(1461),
    [anon_sym___asm__] = ACTIONS(1461),
    [sym_number_literal] = ACTIONS(1463),
    [anon_sym_L_SQUOTE] = ACTIONS(1463),
    [anon_sym_u_SQUOTE] = ACTIONS(1463),
    [anon_sym_U_SQUOTE] = ACTIONS(1463),
    [anon_sym_u8_SQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_L_DQUOTE] = ACTIONS(1463),
    [anon_sym_u_DQUOTE] = ACTIONS(1463),
    [anon_sym_U_DQUOTE] = ACTIONS(1463),
    [anon_sym_u8_DQUOTE] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [anon_sym_NULL] = ACTIONS(1461),
    [anon_sym_nullptr] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1461),
    [anon_sym_hitAttributeEXT] = ACTIONS(1461),
    [anon_sym_callableDataEXT] = ACTIONS(1461),
    [anon_sym_callableDataInEXT] = ACTIONS(1461),
    [anon_sym_shaderRecordEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadNV] = ACTIONS(1461),
    [anon_sym_rayPayloadInNV] = ACTIONS(1461),
    [anon_sym_hitAttributeNV] = ACTIONS(1461),
    [anon_sym_callableDataNV] = ACTIONS(1461),
    [anon_sym_callableDataInNV] = ACTIONS(1461),
    [anon_sym_shaderRecordNV] = ACTIONS(1461),
    [anon_sym_layout] = ACTIONS(1461),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1469),
    [aux_sym_preproc_include_token1] = ACTIONS(1469),
    [aux_sym_preproc_def_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1469),
    [sym_preproc_directive] = ACTIONS(1469),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_subroutine] = ACTIONS(1469),
    [anon_sym_invariant] = ACTIONS(1469),
    [anon_sym_precise] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_out] = ACTIONS(1469),
    [anon_sym_inout] = ACTIONS(1469),
    [anon_sym_uniform] = ACTIONS(1469),
    [anon_sym_shared] = ACTIONS(1469),
    [anon_sym_attribute] = ACTIONS(1469),
    [anon_sym_varying] = ACTIONS(1469),
    [anon_sym_buffer] = ACTIONS(1469),
    [anon_sym_coherent] = ACTIONS(1469),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_writeonly] = ACTIONS(1469),
    [anon_sym_precision] = ACTIONS(1469),
    [anon_sym_highp] = ACTIONS(1469),
    [anon_sym_mediump] = ACTIONS(1469),
    [anon_sym_lowp] = ACTIONS(1469),
    [anon_sym_centroid] = ACTIONS(1469),
    [anon_sym_sample] = ACTIONS(1469),
    [anon_sym_patch] = ACTIONS(1469),
    [anon_sym_smooth] = ACTIONS(1469),
    [anon_sym_flat] = ACTIONS(1469),
    [anon_sym_noperspective] = ACTIONS(1469),
    [anon_sym___extension__] = ACTIONS(1469),
    [anon_sym_typedef] = ACTIONS(1469),
    [anon_sym_extern] = ACTIONS(1469),
    [anon_sym___attribute__] = ACTIONS(1469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1471),
    [anon_sym___declspec] = ACTIONS(1469),
    [anon_sym___cdecl] = ACTIONS(1469),
    [anon_sym___clrcall] = ACTIONS(1469),
    [anon_sym___stdcall] = ACTIONS(1469),
    [anon_sym___fastcall] = ACTIONS(1469),
    [anon_sym___thiscall] = ACTIONS(1469),
    [anon_sym___vectorcall] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_signed] = ACTIONS(1469),
    [anon_sym_unsigned] = ACTIONS(1469),
    [anon_sym_long] = ACTIONS(1469),
    [anon_sym_short] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_auto] = ACTIONS(1469),
    [anon_sym_register] = ACTIONS(1469),
    [anon_sym_inline] = ACTIONS(1469),
    [anon_sym___inline] = ACTIONS(1469),
    [anon_sym___inline__] = ACTIONS(1469),
    [anon_sym___forceinline] = ACTIONS(1469),
    [anon_sym_thread_local] = ACTIONS(1469),
    [anon_sym___thread] = ACTIONS(1469),
    [anon_sym_const] = ACTIONS(1469),
    [anon_sym_constexpr] = ACTIONS(1469),
    [anon_sym_volatile] = ACTIONS(1469),
    [anon_sym_restrict] = ACTIONS(1469),
    [anon_sym___restrict__] = ACTIONS(1469),
    [anon_sym__Atomic] = ACTIONS(1469),
    [anon_sym__Noreturn] = ACTIONS(1469),
    [anon_sym_noreturn] = ACTIONS(1469),
    [anon_sym_alignas] = ACTIONS(1469),
    [anon_sym__Alignas] = ACTIONS(1469),
    [sym_primitive_type] = ACTIONS(1469),
    [anon_sym_enum] = ACTIONS(1469),
    [anon_sym_struct] = ACTIONS(1469),
    [anon_sym_union] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_switch] = ACTIONS(1469),
    [anon_sym_case] = ACTIONS(1469),
    [anon_sym_default] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1469),
    [anon_sym_break] = ACTIONS(1469),
    [anon_sym_continue] = ACTIONS(1469),
    [anon_sym_goto] = ACTIONS(1469),
    [anon_sym___try] = ACTIONS(1469),
    [anon_sym___leave] = ACTIONS(1469),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1469),
    [anon_sym___alignof__] = ACTIONS(1469),
    [anon_sym___alignof] = ACTIONS(1469),
    [anon_sym__alignof] = ACTIONS(1469),
    [anon_sym_alignof] = ACTIONS(1469),
    [anon_sym__Alignof] = ACTIONS(1469),
    [anon_sym_offsetof] = ACTIONS(1469),
    [anon_sym__Generic] = ACTIONS(1469),
    [anon_sym_asm] = ACTIONS(1469),
    [anon_sym___asm__] = ACTIONS(1469),
    [sym_number_literal] = ACTIONS(1471),
    [anon_sym_L_SQUOTE] = ACTIONS(1471),
    [anon_sym_u_SQUOTE] = ACTIONS(1471),
    [anon_sym_U_SQUOTE] = ACTIONS(1471),
    [anon_sym_u8_SQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [anon_sym_L_DQUOTE] = ACTIONS(1471),
    [anon_sym_u_DQUOTE] = ACTIONS(1471),
    [anon_sym_U_DQUOTE] = ACTIONS(1471),
    [anon_sym_u8_DQUOTE] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [anon_sym_NULL] = ACTIONS(1469),
    [anon_sym_nullptr] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1469),
    [anon_sym_hitAttributeEXT] = ACTIONS(1469),
    [anon_sym_callableDataEXT] = ACTIONS(1469),
    [anon_sym_callableDataInEXT] = ACTIONS(1469),
    [anon_sym_shaderRecordEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadNV] = ACTIONS(1469),
    [anon_sym_rayPayloadInNV] = ACTIONS(1469),
    [anon_sym_hitAttributeNV] = ACTIONS(1469),
    [anon_sym_callableDataNV] = ACTIONS(1469),
    [anon_sym_callableDataInNV] = ACTIONS(1469),
    [anon_sym_shaderRecordNV] = ACTIONS(1469),
    [anon_sym_layout] = ACTIONS(1469),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [373] = {
    [sym_identifier] = ACTIONS(1397),
    [aux_sym_preproc_include_token1] = ACTIONS(1397),
    [aux_sym_preproc_def_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1397),
    [sym_preproc_directive] = ACTIONS(1397),
    [anon_sym_LPAREN2] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_subroutine] = ACTIONS(1397),
    [anon_sym_invariant] = ACTIONS(1397),
    [anon_sym_precise] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_out] = ACTIONS(1397),
    [anon_sym_inout] = ACTIONS(1397),
    [anon_sym_uniform] = ACTIONS(1397),
    [anon_sym_shared] = ACTIONS(1397),
    [anon_sym_attribute] = ACTIONS(1397),
    [anon_sym_varying] = ACTIONS(1397),
    [anon_sym_buffer] = ACTIONS(1397),
    [anon_sym_coherent] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_writeonly] = ACTIONS(1397),
    [anon_sym_precision] = ACTIONS(1397),
    [anon_sym_highp] = ACTIONS(1397),
    [anon_sym_mediump] = ACTIONS(1397),
    [anon_sym_lowp] = ACTIONS(1397),
    [anon_sym_centroid] = ACTIONS(1397),
    [anon_sym_sample] = ACTIONS(1397),
    [anon_sym_patch] = ACTIONS(1397),
    [anon_sym_smooth] = ACTIONS(1397),
    [anon_sym_flat] = ACTIONS(1397),
    [anon_sym_noperspective] = ACTIONS(1397),
    [anon_sym___extension__] = ACTIONS(1397),
    [anon_sym_typedef] = ACTIONS(1397),
    [anon_sym_extern] = ACTIONS(1397),
    [anon_sym___attribute__] = ACTIONS(1397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1399),
    [anon_sym___declspec] = ACTIONS(1397),
    [anon_sym___cdecl] = ACTIONS(1397),
    [anon_sym___clrcall] = ACTIONS(1397),
    [anon_sym___stdcall] = ACTIONS(1397),
    [anon_sym___fastcall] = ACTIONS(1397),
    [anon_sym___thiscall] = ACTIONS(1397),
    [anon_sym___vectorcall] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_signed] = ACTIONS(1397),
    [anon_sym_unsigned] = ACTIONS(1397),
    [anon_sym_long] = ACTIONS(1397),
    [anon_sym_short] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_auto] = ACTIONS(1397),
    [anon_sym_register] = ACTIONS(1397),
    [anon_sym_inline] = ACTIONS(1397),
    [anon_sym___inline] = ACTIONS(1397),
    [anon_sym___inline__] = ACTIONS(1397),
    [anon_sym___forceinline] = ACTIONS(1397),
    [anon_sym_thread_local] = ACTIONS(1397),
    [anon_sym___thread] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_constexpr] = ACTIONS(1397),
    [anon_sym_volatile] = ACTIONS(1397),
    [anon_sym_restrict] = ACTIONS(1397),
    [anon_sym___restrict__] = ACTIONS(1397),
    [anon_sym__Atomic] = ACTIONS(1397),
    [anon_sym__Noreturn] = ACTIONS(1397),
    [anon_sym_noreturn] = ACTIONS(1397),
    [anon_sym_alignas] = ACTIONS(1397),
    [anon_sym__Alignas] = ACTIONS(1397),
    [sym_primitive_type] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_goto] = ACTIONS(1397),
    [anon_sym___try] = ACTIONS(1397),
    [anon_sym___leave] = ACTIONS(1397),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_sizeof] = ACTIONS(1397),
    [anon_sym___alignof__] = ACTIONS(1397),
    [anon_sym___alignof] = ACTIONS(1397),
    [anon_sym__alignof] = ACTIONS(1397),
    [anon_sym_alignof] = ACTIONS(1397),
    [anon_sym__Alignof] = ACTIONS(1397),
    [anon_sym_offsetof] = ACTIONS(1397),
    [anon_sym__Generic] = ACTIONS(1397),
    [anon_sym_asm] = ACTIONS(1397),
    [anon_sym___asm__] = ACTIONS(1397),
    [sym_number_literal] = ACTIONS(1399),
    [anon_sym_L_SQUOTE] = ACTIONS(1399),
    [anon_sym_u_SQUOTE] = ACTIONS(1399),
    [anon_sym_U_SQUOTE] = ACTIONS(1399),
    [anon_sym_u8_SQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [anon_sym_L_DQUOTE] = ACTIONS(1399),
    [anon_sym_u_DQUOTE] = ACTIONS(1399),
    [anon_sym_U_DQUOTE] = ACTIONS(1399),
    [anon_sym_u8_DQUOTE] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1397),
    [anon_sym_nullptr] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1397),
    [anon_sym_hitAttributeEXT] = ACTIONS(1397),
    [anon_sym_callableDataEXT] = ACTIONS(1397),
    [anon_sym_callableDataInEXT] = ACTIONS(1397),
    [anon_sym_shaderRecordEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadNV] = ACTIONS(1397),
    [anon_sym_rayPayloadInNV] = ACTIONS(1397),
    [anon_sym_hitAttributeNV] = ACTIONS(1397),
    [anon_sym_callableDataNV] = ACTIONS(1397),
    [anon_sym_callableDataInNV] = ACTIONS(1397),
    [anon_sym_shaderRecordNV] = ACTIONS(1397),
    [anon_sym_layout] = ACTIONS(1397),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token2] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_subroutine] = ACTIONS(1513),
    [anon_sym_invariant] = ACTIONS(1513),
    [anon_sym_precise] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_out] = ACTIONS(1513),
    [anon_sym_inout] = ACTIONS(1513),
    [anon_sym_uniform] = ACTIONS(1513),
    [anon_sym_shared] = ACTIONS(1513),
    [anon_sym_attribute] = ACTIONS(1513),
    [anon_sym_varying] = ACTIONS(1513),
    [anon_sym_buffer] = ACTIONS(1513),
    [anon_sym_coherent] = ACTIONS(1513),
    [anon_sym_readonly] = ACTIONS(1513),
    [anon_sym_writeonly] = ACTIONS(1513),
    [anon_sym_precision] = ACTIONS(1513),
    [anon_sym_highp] = ACTIONS(1513),
    [anon_sym_mediump] = ACTIONS(1513),
    [anon_sym_lowp] = ACTIONS(1513),
    [anon_sym_centroid] = ACTIONS(1513),
    [anon_sym_sample] = ACTIONS(1513),
    [anon_sym_patch] = ACTIONS(1513),
    [anon_sym_smooth] = ACTIONS(1513),
    [anon_sym_flat] = ACTIONS(1513),
    [anon_sym_noperspective] = ACTIONS(1513),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [anon_sym_alignas] = ACTIONS(1513),
    [anon_sym__Alignas] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym___try] = ACTIONS(1513),
    [anon_sym___leave] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1513),
    [anon_sym_hitAttributeEXT] = ACTIONS(1513),
    [anon_sym_callableDataEXT] = ACTIONS(1513),
    [anon_sym_callableDataInEXT] = ACTIONS(1513),
    [anon_sym_shaderRecordEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadNV] = ACTIONS(1513),
    [anon_sym_rayPayloadInNV] = ACTIONS(1513),
    [anon_sym_hitAttributeNV] = ACTIONS(1513),
    [anon_sym_callableDataNV] = ACTIONS(1513),
    [anon_sym_callableDataInNV] = ACTIONS(1513),
    [anon_sym_shaderRecordNV] = ACTIONS(1513),
    [anon_sym_layout] = ACTIONS(1513),
  },
  [375] = {
    [sym_identifier] = ACTIONS(1497),
    [aux_sym_preproc_include_token1] = ACTIONS(1497),
    [aux_sym_preproc_def_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token2] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1497),
    [sym_preproc_directive] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_subroutine] = ACTIONS(1497),
    [anon_sym_invariant] = ACTIONS(1497),
    [anon_sym_precise] = ACTIONS(1497),
    [anon_sym_SEMI] = ACTIONS(1499),
    [anon_sym_in] = ACTIONS(1497),
    [anon_sym_out] = ACTIONS(1497),
    [anon_sym_inout] = ACTIONS(1497),
    [anon_sym_uniform] = ACTIONS(1497),
    [anon_sym_shared] = ACTIONS(1497),
    [anon_sym_attribute] = ACTIONS(1497),
    [anon_sym_varying] = ACTIONS(1497),
    [anon_sym_buffer] = ACTIONS(1497),
    [anon_sym_coherent] = ACTIONS(1497),
    [anon_sym_readonly] = ACTIONS(1497),
    [anon_sym_writeonly] = ACTIONS(1497),
    [anon_sym_precision] = ACTIONS(1497),
    [anon_sym_highp] = ACTIONS(1497),
    [anon_sym_mediump] = ACTIONS(1497),
    [anon_sym_lowp] = ACTIONS(1497),
    [anon_sym_centroid] = ACTIONS(1497),
    [anon_sym_sample] = ACTIONS(1497),
    [anon_sym_patch] = ACTIONS(1497),
    [anon_sym_smooth] = ACTIONS(1497),
    [anon_sym_flat] = ACTIONS(1497),
    [anon_sym_noperspective] = ACTIONS(1497),
    [anon_sym___extension__] = ACTIONS(1497),
    [anon_sym_typedef] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(1497),
    [anon_sym___attribute__] = ACTIONS(1497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1499),
    [anon_sym___declspec] = ACTIONS(1497),
    [anon_sym___cdecl] = ACTIONS(1497),
    [anon_sym___clrcall] = ACTIONS(1497),
    [anon_sym___stdcall] = ACTIONS(1497),
    [anon_sym___fastcall] = ACTIONS(1497),
    [anon_sym___thiscall] = ACTIONS(1497),
    [anon_sym___vectorcall] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_signed] = ACTIONS(1497),
    [anon_sym_unsigned] = ACTIONS(1497),
    [anon_sym_long] = ACTIONS(1497),
    [anon_sym_short] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1497),
    [anon_sym_auto] = ACTIONS(1497),
    [anon_sym_register] = ACTIONS(1497),
    [anon_sym_inline] = ACTIONS(1497),
    [anon_sym___inline] = ACTIONS(1497),
    [anon_sym___inline__] = ACTIONS(1497),
    [anon_sym___forceinline] = ACTIONS(1497),
    [anon_sym_thread_local] = ACTIONS(1497),
    [anon_sym___thread] = ACTIONS(1497),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_alignas] = ACTIONS(1497),
    [anon_sym__Alignas] = ACTIONS(1497),
    [sym_primitive_type] = ACTIONS(1497),
    [anon_sym_enum] = ACTIONS(1497),
    [anon_sym_struct] = ACTIONS(1497),
    [anon_sym_union] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(1497),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1497),
    [anon_sym_default] = ACTIONS(1497),
    [anon_sym_while] = ACTIONS(1497),
    [anon_sym_do] = ACTIONS(1497),
    [anon_sym_for] = ACTIONS(1497),
    [anon_sym_return] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_continue] = ACTIONS(1497),
    [anon_sym_goto] = ACTIONS(1497),
    [anon_sym___try] = ACTIONS(1497),
    [anon_sym___leave] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_sizeof] = ACTIONS(1497),
    [anon_sym___alignof__] = ACTIONS(1497),
    [anon_sym___alignof] = ACTIONS(1497),
    [anon_sym__alignof] = ACTIONS(1497),
    [anon_sym_alignof] = ACTIONS(1497),
    [anon_sym__Alignof] = ACTIONS(1497),
    [anon_sym_offsetof] = ACTIONS(1497),
    [anon_sym__Generic] = ACTIONS(1497),
    [anon_sym_asm] = ACTIONS(1497),
    [anon_sym___asm__] = ACTIONS(1497),
    [sym_number_literal] = ACTIONS(1499),
    [anon_sym_L_SQUOTE] = ACTIONS(1499),
    [anon_sym_u_SQUOTE] = ACTIONS(1499),
    [anon_sym_U_SQUOTE] = ACTIONS(1499),
    [anon_sym_u8_SQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_L_DQUOTE] = ACTIONS(1499),
    [anon_sym_u_DQUOTE] = ACTIONS(1499),
    [anon_sym_U_DQUOTE] = ACTIONS(1499),
    [anon_sym_u8_DQUOTE] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [anon_sym_NULL] = ACTIONS(1497),
    [anon_sym_nullptr] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1497),
    [anon_sym_hitAttributeEXT] = ACTIONS(1497),
    [anon_sym_callableDataEXT] = ACTIONS(1497),
    [anon_sym_callableDataInEXT] = ACTIONS(1497),
    [anon_sym_shaderRecordEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadNV] = ACTIONS(1497),
    [anon_sym_rayPayloadInNV] = ACTIONS(1497),
    [anon_sym_hitAttributeNV] = ACTIONS(1497),
    [anon_sym_callableDataNV] = ACTIONS(1497),
    [anon_sym_callableDataInNV] = ACTIONS(1497),
    [anon_sym_shaderRecordNV] = ACTIONS(1497),
    [anon_sym_layout] = ACTIONS(1497),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1449),
    [aux_sym_preproc_include_token1] = ACTIONS(1449),
    [aux_sym_preproc_def_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1449),
    [sym_preproc_directive] = ACTIONS(1449),
    [anon_sym_LPAREN2] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_subroutine] = ACTIONS(1449),
    [anon_sym_invariant] = ACTIONS(1449),
    [anon_sym_precise] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_in] = ACTIONS(1449),
    [anon_sym_out] = ACTIONS(1449),
    [anon_sym_inout] = ACTIONS(1449),
    [anon_sym_uniform] = ACTIONS(1449),
    [anon_sym_shared] = ACTIONS(1449),
    [anon_sym_attribute] = ACTIONS(1449),
    [anon_sym_varying] = ACTIONS(1449),
    [anon_sym_buffer] = ACTIONS(1449),
    [anon_sym_coherent] = ACTIONS(1449),
    [anon_sym_readonly] = ACTIONS(1449),
    [anon_sym_writeonly] = ACTIONS(1449),
    [anon_sym_precision] = ACTIONS(1449),
    [anon_sym_highp] = ACTIONS(1449),
    [anon_sym_mediump] = ACTIONS(1449),
    [anon_sym_lowp] = ACTIONS(1449),
    [anon_sym_centroid] = ACTIONS(1449),
    [anon_sym_sample] = ACTIONS(1449),
    [anon_sym_patch] = ACTIONS(1449),
    [anon_sym_smooth] = ACTIONS(1449),
    [anon_sym_flat] = ACTIONS(1449),
    [anon_sym_noperspective] = ACTIONS(1449),
    [anon_sym___extension__] = ACTIONS(1449),
    [anon_sym_typedef] = ACTIONS(1449),
    [anon_sym_extern] = ACTIONS(1449),
    [anon_sym___attribute__] = ACTIONS(1449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1451),
    [anon_sym___declspec] = ACTIONS(1449),
    [anon_sym___cdecl] = ACTIONS(1449),
    [anon_sym___clrcall] = ACTIONS(1449),
    [anon_sym___stdcall] = ACTIONS(1449),
    [anon_sym___fastcall] = ACTIONS(1449),
    [anon_sym___thiscall] = ACTIONS(1449),
    [anon_sym___vectorcall] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [anon_sym_signed] = ACTIONS(1449),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_auto] = ACTIONS(1449),
    [anon_sym_register] = ACTIONS(1449),
    [anon_sym_inline] = ACTIONS(1449),
    [anon_sym___inline] = ACTIONS(1449),
    [anon_sym___inline__] = ACTIONS(1449),
    [anon_sym___forceinline] = ACTIONS(1449),
    [anon_sym_thread_local] = ACTIONS(1449),
    [anon_sym___thread] = ACTIONS(1449),
    [anon_sym_const] = ACTIONS(1449),
    [anon_sym_constexpr] = ACTIONS(1449),
    [anon_sym_volatile] = ACTIONS(1449),
    [anon_sym_restrict] = ACTIONS(1449),
    [anon_sym___restrict__] = ACTIONS(1449),
    [anon_sym__Atomic] = ACTIONS(1449),
    [anon_sym__Noreturn] = ACTIONS(1449),
    [anon_sym_noreturn] = ACTIONS(1449),
    [anon_sym_alignas] = ACTIONS(1449),
    [anon_sym__Alignas] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1449),
    [anon_sym_enum] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1449),
    [anon_sym_union] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_switch] = ACTIONS(1449),
    [anon_sym_case] = ACTIONS(1449),
    [anon_sym_default] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_for] = ACTIONS(1449),
    [anon_sym_return] = ACTIONS(1449),
    [anon_sym_break] = ACTIONS(1449),
    [anon_sym_continue] = ACTIONS(1449),
    [anon_sym_goto] = ACTIONS(1449),
    [anon_sym___try] = ACTIONS(1449),
    [anon_sym___leave] = ACTIONS(1449),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym___alignof__] = ACTIONS(1449),
    [anon_sym___alignof] = ACTIONS(1449),
    [anon_sym__alignof] = ACTIONS(1449),
    [anon_sym_alignof] = ACTIONS(1449),
    [anon_sym__Alignof] = ACTIONS(1449),
    [anon_sym_offsetof] = ACTIONS(1449),
    [anon_sym__Generic] = ACTIONS(1449),
    [anon_sym_asm] = ACTIONS(1449),
    [anon_sym___asm__] = ACTIONS(1449),
    [sym_number_literal] = ACTIONS(1451),
    [anon_sym_L_SQUOTE] = ACTIONS(1451),
    [anon_sym_u_SQUOTE] = ACTIONS(1451),
    [anon_sym_U_SQUOTE] = ACTIONS(1451),
    [anon_sym_u8_SQUOTE] = ACTIONS(1451),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [anon_sym_L_DQUOTE] = ACTIONS(1451),
    [anon_sym_u_DQUOTE] = ACTIONS(1451),
    [anon_sym_U_DQUOTE] = ACTIONS(1451),
    [anon_sym_u8_DQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [anon_sym_NULL] = ACTIONS(1449),
    [anon_sym_nullptr] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1449),
    [anon_sym_hitAttributeEXT] = ACTIONS(1449),
    [anon_sym_callableDataEXT] = ACTIONS(1449),
    [anon_sym_callableDataInEXT] = ACTIONS(1449),
    [anon_sym_shaderRecordEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadNV] = ACTIONS(1449),
    [anon_sym_rayPayloadInNV] = ACTIONS(1449),
    [anon_sym_hitAttributeNV] = ACTIONS(1449),
    [anon_sym_callableDataNV] = ACTIONS(1449),
    [anon_sym_callableDataInNV] = ACTIONS(1449),
    [anon_sym_shaderRecordNV] = ACTIONS(1449),
    [anon_sym_layout] = ACTIONS(1449),
  },
  [377] = {
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym___try] = ACTIONS(1473),
    [anon_sym___leave] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [378] = {
    [sym_identifier] = ACTIONS(1519),
    [aux_sym_preproc_include_token1] = ACTIONS(1519),
    [aux_sym_preproc_def_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1519),
    [sym_preproc_directive] = ACTIONS(1519),
    [anon_sym_LPAREN2] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_subroutine] = ACTIONS(1519),
    [anon_sym_invariant] = ACTIONS(1519),
    [anon_sym_precise] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_out] = ACTIONS(1519),
    [anon_sym_inout] = ACTIONS(1519),
    [anon_sym_uniform] = ACTIONS(1519),
    [anon_sym_shared] = ACTIONS(1519),
    [anon_sym_attribute] = ACTIONS(1519),
    [anon_sym_varying] = ACTIONS(1519),
    [anon_sym_buffer] = ACTIONS(1519),
    [anon_sym_coherent] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_writeonly] = ACTIONS(1519),
    [anon_sym_precision] = ACTIONS(1519),
    [anon_sym_highp] = ACTIONS(1519),
    [anon_sym_mediump] = ACTIONS(1519),
    [anon_sym_lowp] = ACTIONS(1519),
    [anon_sym_centroid] = ACTIONS(1519),
    [anon_sym_sample] = ACTIONS(1519),
    [anon_sym_patch] = ACTIONS(1519),
    [anon_sym_smooth] = ACTIONS(1519),
    [anon_sym_flat] = ACTIONS(1519),
    [anon_sym_noperspective] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(1519),
    [anon_sym_extern] = ACTIONS(1519),
    [anon_sym___attribute__] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1521),
    [anon_sym___declspec] = ACTIONS(1519),
    [anon_sym___cdecl] = ACTIONS(1519),
    [anon_sym___clrcall] = ACTIONS(1519),
    [anon_sym___stdcall] = ACTIONS(1519),
    [anon_sym___fastcall] = ACTIONS(1519),
    [anon_sym___thiscall] = ACTIONS(1519),
    [anon_sym___vectorcall] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_signed] = ACTIONS(1519),
    [anon_sym_unsigned] = ACTIONS(1519),
    [anon_sym_long] = ACTIONS(1519),
    [anon_sym_short] = ACTIONS(1519),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_auto] = ACTIONS(1519),
    [anon_sym_register] = ACTIONS(1519),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym___inline] = ACTIONS(1519),
    [anon_sym___inline__] = ACTIONS(1519),
    [anon_sym___forceinline] = ACTIONS(1519),
    [anon_sym_thread_local] = ACTIONS(1519),
    [anon_sym___thread] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_constexpr] = ACTIONS(1519),
    [anon_sym_volatile] = ACTIONS(1519),
    [anon_sym_restrict] = ACTIONS(1519),
    [anon_sym___restrict__] = ACTIONS(1519),
    [anon_sym__Atomic] = ACTIONS(1519),
    [anon_sym__Noreturn] = ACTIONS(1519),
    [anon_sym_noreturn] = ACTIONS(1519),
    [anon_sym_alignas] = ACTIONS(1519),
    [anon_sym__Alignas] = ACTIONS(1519),
    [sym_primitive_type] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [anon_sym_struct] = ACTIONS(1519),
    [anon_sym_union] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_goto] = ACTIONS(1519),
    [anon_sym___try] = ACTIONS(1519),
    [anon_sym___leave] = ACTIONS(1519),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_sizeof] = ACTIONS(1519),
    [anon_sym___alignof__] = ACTIONS(1519),
    [anon_sym___alignof] = ACTIONS(1519),
    [anon_sym__alignof] = ACTIONS(1519),
    [anon_sym_alignof] = ACTIONS(1519),
    [anon_sym__Alignof] = ACTIONS(1519),
    [anon_sym_offsetof] = ACTIONS(1519),
    [anon_sym__Generic] = ACTIONS(1519),
    [anon_sym_asm] = ACTIONS(1519),
    [anon_sym___asm__] = ACTIONS(1519),
    [sym_number_literal] = ACTIONS(1521),
    [anon_sym_L_SQUOTE] = ACTIONS(1521),
    [anon_sym_u_SQUOTE] = ACTIONS(1521),
    [anon_sym_U_SQUOTE] = ACTIONS(1521),
    [anon_sym_u8_SQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_L_DQUOTE] = ACTIONS(1521),
    [anon_sym_u_DQUOTE] = ACTIONS(1521),
    [anon_sym_U_DQUOTE] = ACTIONS(1521),
    [anon_sym_u8_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [anon_sym_NULL] = ACTIONS(1519),
    [anon_sym_nullptr] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1519),
    [anon_sym_hitAttributeEXT] = ACTIONS(1519),
    [anon_sym_callableDataEXT] = ACTIONS(1519),
    [anon_sym_callableDataInEXT] = ACTIONS(1519),
    [anon_sym_shaderRecordEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadNV] = ACTIONS(1519),
    [anon_sym_rayPayloadInNV] = ACTIONS(1519),
    [anon_sym_hitAttributeNV] = ACTIONS(1519),
    [anon_sym_callableDataNV] = ACTIONS(1519),
    [anon_sym_callableDataInNV] = ACTIONS(1519),
    [anon_sym_shaderRecordNV] = ACTIONS(1519),
    [anon_sym_layout] = ACTIONS(1519),
  },
  [379] = {
    [sym_identifier] = ACTIONS(1527),
    [aux_sym_preproc_include_token1] = ACTIONS(1527),
    [aux_sym_preproc_def_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1527),
    [sym_preproc_directive] = ACTIONS(1527),
    [anon_sym_LPAREN2] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_subroutine] = ACTIONS(1527),
    [anon_sym_invariant] = ACTIONS(1527),
    [anon_sym_precise] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1527),
    [anon_sym_out] = ACTIONS(1527),
    [anon_sym_inout] = ACTIONS(1527),
    [anon_sym_uniform] = ACTIONS(1527),
    [anon_sym_shared] = ACTIONS(1527),
    [anon_sym_attribute] = ACTIONS(1527),
    [anon_sym_varying] = ACTIONS(1527),
    [anon_sym_buffer] = ACTIONS(1527),
    [anon_sym_coherent] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_writeonly] = ACTIONS(1527),
    [anon_sym_precision] = ACTIONS(1527),
    [anon_sym_highp] = ACTIONS(1527),
    [anon_sym_mediump] = ACTIONS(1527),
    [anon_sym_lowp] = ACTIONS(1527),
    [anon_sym_centroid] = ACTIONS(1527),
    [anon_sym_sample] = ACTIONS(1527),
    [anon_sym_patch] = ACTIONS(1527),
    [anon_sym_smooth] = ACTIONS(1527),
    [anon_sym_flat] = ACTIONS(1527),
    [anon_sym_noperspective] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1527),
    [anon_sym_typedef] = ACTIONS(1527),
    [anon_sym_extern] = ACTIONS(1527),
    [anon_sym___attribute__] = ACTIONS(1527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1529),
    [anon_sym___declspec] = ACTIONS(1527),
    [anon_sym___cdecl] = ACTIONS(1527),
    [anon_sym___clrcall] = ACTIONS(1527),
    [anon_sym___stdcall] = ACTIONS(1527),
    [anon_sym___fastcall] = ACTIONS(1527),
    [anon_sym___thiscall] = ACTIONS(1527),
    [anon_sym___vectorcall] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_signed] = ACTIONS(1527),
    [anon_sym_unsigned] = ACTIONS(1527),
    [anon_sym_long] = ACTIONS(1527),
    [anon_sym_short] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_auto] = ACTIONS(1527),
    [anon_sym_register] = ACTIONS(1527),
    [anon_sym_inline] = ACTIONS(1527),
    [anon_sym___inline] = ACTIONS(1527),
    [anon_sym___inline__] = ACTIONS(1527),
    [anon_sym___forceinline] = ACTIONS(1527),
    [anon_sym_thread_local] = ACTIONS(1527),
    [anon_sym___thread] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_constexpr] = ACTIONS(1527),
    [anon_sym_volatile] = ACTIONS(1527),
    [anon_sym_restrict] = ACTIONS(1527),
    [anon_sym___restrict__] = ACTIONS(1527),
    [anon_sym__Atomic] = ACTIONS(1527),
    [anon_sym__Noreturn] = ACTIONS(1527),
    [anon_sym_noreturn] = ACTIONS(1527),
    [anon_sym_alignas] = ACTIONS(1527),
    [anon_sym__Alignas] = ACTIONS(1527),
    [sym_primitive_type] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_union] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_goto] = ACTIONS(1527),
    [anon_sym___try] = ACTIONS(1527),
    [anon_sym___leave] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1527),
    [anon_sym___alignof__] = ACTIONS(1527),
    [anon_sym___alignof] = ACTIONS(1527),
    [anon_sym__alignof] = ACTIONS(1527),
    [anon_sym_alignof] = ACTIONS(1527),
    [anon_sym__Alignof] = ACTIONS(1527),
    [anon_sym_offsetof] = ACTIONS(1527),
    [anon_sym__Generic] = ACTIONS(1527),
    [anon_sym_asm] = ACTIONS(1527),
    [anon_sym___asm__] = ACTIONS(1527),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_L_SQUOTE] = ACTIONS(1529),
    [anon_sym_u_SQUOTE] = ACTIONS(1529),
    [anon_sym_U_SQUOTE] = ACTIONS(1529),
    [anon_sym_u8_SQUOTE] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_L_DQUOTE] = ACTIONS(1529),
    [anon_sym_u_DQUOTE] = ACTIONS(1529),
    [anon_sym_U_DQUOTE] = ACTIONS(1529),
    [anon_sym_u8_DQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [anon_sym_NULL] = ACTIONS(1527),
    [anon_sym_nullptr] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1527),
    [anon_sym_hitAttributeEXT] = ACTIONS(1527),
    [anon_sym_callableDataEXT] = ACTIONS(1527),
    [anon_sym_callableDataInEXT] = ACTIONS(1527),
    [anon_sym_shaderRecordEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadNV] = ACTIONS(1527),
    [anon_sym_rayPayloadInNV] = ACTIONS(1527),
    [anon_sym_hitAttributeNV] = ACTIONS(1527),
    [anon_sym_callableDataNV] = ACTIONS(1527),
    [anon_sym_callableDataInNV] = ACTIONS(1527),
    [anon_sym_shaderRecordNV] = ACTIONS(1527),
    [anon_sym_layout] = ACTIONS(1527),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1535),
    [aux_sym_preproc_include_token1] = ACTIONS(1535),
    [aux_sym_preproc_def_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1535),
    [sym_preproc_directive] = ACTIONS(1535),
    [anon_sym_LPAREN2] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_subroutine] = ACTIONS(1535),
    [anon_sym_invariant] = ACTIONS(1535),
    [anon_sym_precise] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_in] = ACTIONS(1535),
    [anon_sym_out] = ACTIONS(1535),
    [anon_sym_inout] = ACTIONS(1535),
    [anon_sym_uniform] = ACTIONS(1535),
    [anon_sym_shared] = ACTIONS(1535),
    [anon_sym_attribute] = ACTIONS(1535),
    [anon_sym_varying] = ACTIONS(1535),
    [anon_sym_buffer] = ACTIONS(1535),
    [anon_sym_coherent] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_writeonly] = ACTIONS(1535),
    [anon_sym_precision] = ACTIONS(1535),
    [anon_sym_highp] = ACTIONS(1535),
    [anon_sym_mediump] = ACTIONS(1535),
    [anon_sym_lowp] = ACTIONS(1535),
    [anon_sym_centroid] = ACTIONS(1535),
    [anon_sym_sample] = ACTIONS(1535),
    [anon_sym_patch] = ACTIONS(1535),
    [anon_sym_smooth] = ACTIONS(1535),
    [anon_sym_flat] = ACTIONS(1535),
    [anon_sym_noperspective] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1535),
    [anon_sym_typedef] = ACTIONS(1535),
    [anon_sym_extern] = ACTIONS(1535),
    [anon_sym___attribute__] = ACTIONS(1535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1537),
    [anon_sym___declspec] = ACTIONS(1535),
    [anon_sym___cdecl] = ACTIONS(1535),
    [anon_sym___clrcall] = ACTIONS(1535),
    [anon_sym___stdcall] = ACTIONS(1535),
    [anon_sym___fastcall] = ACTIONS(1535),
    [anon_sym___thiscall] = ACTIONS(1535),
    [anon_sym___vectorcall] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_signed] = ACTIONS(1535),
    [anon_sym_unsigned] = ACTIONS(1535),
    [anon_sym_long] = ACTIONS(1535),
    [anon_sym_short] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_auto] = ACTIONS(1535),
    [anon_sym_register] = ACTIONS(1535),
    [anon_sym_inline] = ACTIONS(1535),
    [anon_sym___inline] = ACTIONS(1535),
    [anon_sym___inline__] = ACTIONS(1535),
    [anon_sym___forceinline] = ACTIONS(1535),
    [anon_sym_thread_local] = ACTIONS(1535),
    [anon_sym___thread] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_constexpr] = ACTIONS(1535),
    [anon_sym_volatile] = ACTIONS(1535),
    [anon_sym_restrict] = ACTIONS(1535),
    [anon_sym___restrict__] = ACTIONS(1535),
    [anon_sym__Atomic] = ACTIONS(1535),
    [anon_sym__Noreturn] = ACTIONS(1535),
    [anon_sym_noreturn] = ACTIONS(1535),
    [anon_sym_alignas] = ACTIONS(1535),
    [anon_sym__Alignas] = ACTIONS(1535),
    [sym_primitive_type] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [anon_sym_struct] = ACTIONS(1535),
    [anon_sym_union] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_goto] = ACTIONS(1535),
    [anon_sym___try] = ACTIONS(1535),
    [anon_sym___leave] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_sizeof] = ACTIONS(1535),
    [anon_sym___alignof__] = ACTIONS(1535),
    [anon_sym___alignof] = ACTIONS(1535),
    [anon_sym__alignof] = ACTIONS(1535),
    [anon_sym_alignof] = ACTIONS(1535),
    [anon_sym__Alignof] = ACTIONS(1535),
    [anon_sym_offsetof] = ACTIONS(1535),
    [anon_sym__Generic] = ACTIONS(1535),
    [anon_sym_asm] = ACTIONS(1535),
    [anon_sym___asm__] = ACTIONS(1535),
    [sym_number_literal] = ACTIONS(1537),
    [anon_sym_L_SQUOTE] = ACTIONS(1537),
    [anon_sym_u_SQUOTE] = ACTIONS(1537),
    [anon_sym_U_SQUOTE] = ACTIONS(1537),
    [anon_sym_u8_SQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_L_DQUOTE] = ACTIONS(1537),
    [anon_sym_u_DQUOTE] = ACTIONS(1537),
    [anon_sym_U_DQUOTE] = ACTIONS(1537),
    [anon_sym_u8_DQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [anon_sym_NULL] = ACTIONS(1535),
    [anon_sym_nullptr] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1535),
    [anon_sym_hitAttributeEXT] = ACTIONS(1535),
    [anon_sym_callableDataEXT] = ACTIONS(1535),
    [anon_sym_callableDataInEXT] = ACTIONS(1535),
    [anon_sym_shaderRecordEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadNV] = ACTIONS(1535),
    [anon_sym_rayPayloadInNV] = ACTIONS(1535),
    [anon_sym_hitAttributeNV] = ACTIONS(1535),
    [anon_sym_callableDataNV] = ACTIONS(1535),
    [anon_sym_callableDataInNV] = ACTIONS(1535),
    [anon_sym_shaderRecordNV] = ACTIONS(1535),
    [anon_sym_layout] = ACTIONS(1535),
  },
  [381] = {
    [sym_identifier] = ACTIONS(1523),
    [aux_sym_preproc_include_token1] = ACTIONS(1523),
    [aux_sym_preproc_def_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1523),
    [sym_preproc_directive] = ACTIONS(1523),
    [anon_sym_LPAREN2] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_subroutine] = ACTIONS(1523),
    [anon_sym_invariant] = ACTIONS(1523),
    [anon_sym_precise] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_in] = ACTIONS(1523),
    [anon_sym_out] = ACTIONS(1523),
    [anon_sym_inout] = ACTIONS(1523),
    [anon_sym_uniform] = ACTIONS(1523),
    [anon_sym_shared] = ACTIONS(1523),
    [anon_sym_attribute] = ACTIONS(1523),
    [anon_sym_varying] = ACTIONS(1523),
    [anon_sym_buffer] = ACTIONS(1523),
    [anon_sym_coherent] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_writeonly] = ACTIONS(1523),
    [anon_sym_precision] = ACTIONS(1523),
    [anon_sym_highp] = ACTIONS(1523),
    [anon_sym_mediump] = ACTIONS(1523),
    [anon_sym_lowp] = ACTIONS(1523),
    [anon_sym_centroid] = ACTIONS(1523),
    [anon_sym_sample] = ACTIONS(1523),
    [anon_sym_patch] = ACTIONS(1523),
    [anon_sym_smooth] = ACTIONS(1523),
    [anon_sym_flat] = ACTIONS(1523),
    [anon_sym_noperspective] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1523),
    [anon_sym_typedef] = ACTIONS(1523),
    [anon_sym_extern] = ACTIONS(1523),
    [anon_sym___attribute__] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1525),
    [anon_sym___declspec] = ACTIONS(1523),
    [anon_sym___cdecl] = ACTIONS(1523),
    [anon_sym___clrcall] = ACTIONS(1523),
    [anon_sym___stdcall] = ACTIONS(1523),
    [anon_sym___fastcall] = ACTIONS(1523),
    [anon_sym___thiscall] = ACTIONS(1523),
    [anon_sym___vectorcall] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_signed] = ACTIONS(1523),
    [anon_sym_unsigned] = ACTIONS(1523),
    [anon_sym_long] = ACTIONS(1523),
    [anon_sym_short] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_auto] = ACTIONS(1523),
    [anon_sym_register] = ACTIONS(1523),
    [anon_sym_inline] = ACTIONS(1523),
    [anon_sym___inline] = ACTIONS(1523),
    [anon_sym___inline__] = ACTIONS(1523),
    [anon_sym___forceinline] = ACTIONS(1523),
    [anon_sym_thread_local] = ACTIONS(1523),
    [anon_sym___thread] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_constexpr] = ACTIONS(1523),
    [anon_sym_volatile] = ACTIONS(1523),
    [anon_sym_restrict] = ACTIONS(1523),
    [anon_sym___restrict__] = ACTIONS(1523),
    [anon_sym__Atomic] = ACTIONS(1523),
    [anon_sym__Noreturn] = ACTIONS(1523),
    [anon_sym_noreturn] = ACTIONS(1523),
    [anon_sym_alignas] = ACTIONS(1523),
    [anon_sym__Alignas] = ACTIONS(1523),
    [sym_primitive_type] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [anon_sym_struct] = ACTIONS(1523),
    [anon_sym_union] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_goto] = ACTIONS(1523),
    [anon_sym___try] = ACTIONS(1523),
    [anon_sym___leave] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1525),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_sizeof] = ACTIONS(1523),
    [anon_sym___alignof__] = ACTIONS(1523),
    [anon_sym___alignof] = ACTIONS(1523),
    [anon_sym__alignof] = ACTIONS(1523),
    [anon_sym_alignof] = ACTIONS(1523),
    [anon_sym__Alignof] = ACTIONS(1523),
    [anon_sym_offsetof] = ACTIONS(1523),
    [anon_sym__Generic] = ACTIONS(1523),
    [anon_sym_asm] = ACTIONS(1523),
    [anon_sym___asm__] = ACTIONS(1523),
    [sym_number_literal] = ACTIONS(1525),
    [anon_sym_L_SQUOTE] = ACTIONS(1525),
    [anon_sym_u_SQUOTE] = ACTIONS(1525),
    [anon_sym_U_SQUOTE] = ACTIONS(1525),
    [anon_sym_u8_SQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_L_DQUOTE] = ACTIONS(1525),
    [anon_sym_u_DQUOTE] = ACTIONS(1525),
    [anon_sym_U_DQUOTE] = ACTIONS(1525),
    [anon_sym_u8_DQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [anon_sym_NULL] = ACTIONS(1523),
    [anon_sym_nullptr] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1523),
    [anon_sym_hitAttributeEXT] = ACTIONS(1523),
    [anon_sym_callableDataEXT] = ACTIONS(1523),
    [anon_sym_callableDataInEXT] = ACTIONS(1523),
    [anon_sym_shaderRecordEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadNV] = ACTIONS(1523),
    [anon_sym_rayPayloadInNV] = ACTIONS(1523),
    [anon_sym_hitAttributeNV] = ACTIONS(1523),
    [anon_sym_callableDataNV] = ACTIONS(1523),
    [anon_sym_callableDataInNV] = ACTIONS(1523),
    [anon_sym_shaderRecordNV] = ACTIONS(1523),
    [anon_sym_layout] = ACTIONS(1523),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym___try] = ACTIONS(1425),
    [anon_sym___leave] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [384] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [385] = {
    [sym_identifier] = ACTIONS(1421),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_subroutine] = ACTIONS(1421),
    [anon_sym_invariant] = ACTIONS(1421),
    [anon_sym_precise] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_in] = ACTIONS(1421),
    [anon_sym_out] = ACTIONS(1421),
    [anon_sym_inout] = ACTIONS(1421),
    [anon_sym_uniform] = ACTIONS(1421),
    [anon_sym_shared] = ACTIONS(1421),
    [anon_sym_attribute] = ACTIONS(1421),
    [anon_sym_varying] = ACTIONS(1421),
    [anon_sym_buffer] = ACTIONS(1421),
    [anon_sym_coherent] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_writeonly] = ACTIONS(1421),
    [anon_sym_precision] = ACTIONS(1421),
    [anon_sym_highp] = ACTIONS(1421),
    [anon_sym_mediump] = ACTIONS(1421),
    [anon_sym_lowp] = ACTIONS(1421),
    [anon_sym_centroid] = ACTIONS(1421),
    [anon_sym_sample] = ACTIONS(1421),
    [anon_sym_patch] = ACTIONS(1421),
    [anon_sym_smooth] = ACTIONS(1421),
    [anon_sym_flat] = ACTIONS(1421),
    [anon_sym_noperspective] = ACTIONS(1421),
    [anon_sym___extension__] = ACTIONS(1421),
    [anon_sym_typedef] = ACTIONS(1421),
    [anon_sym_extern] = ACTIONS(1421),
    [anon_sym___attribute__] = ACTIONS(1421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1423),
    [anon_sym___declspec] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1423),
    [anon_sym_RBRACE] = ACTIONS(1423),
    [anon_sym_signed] = ACTIONS(1421),
    [anon_sym_unsigned] = ACTIONS(1421),
    [anon_sym_long] = ACTIONS(1421),
    [anon_sym_short] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_auto] = ACTIONS(1421),
    [anon_sym_register] = ACTIONS(1421),
    [anon_sym_inline] = ACTIONS(1421),
    [anon_sym___inline] = ACTIONS(1421),
    [anon_sym___inline__] = ACTIONS(1421),
    [anon_sym___forceinline] = ACTIONS(1421),
    [anon_sym_thread_local] = ACTIONS(1421),
    [anon_sym___thread] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_constexpr] = ACTIONS(1421),
    [anon_sym_volatile] = ACTIONS(1421),
    [anon_sym_restrict] = ACTIONS(1421),
    [anon_sym___restrict__] = ACTIONS(1421),
    [anon_sym__Atomic] = ACTIONS(1421),
    [anon_sym__Noreturn] = ACTIONS(1421),
    [anon_sym_noreturn] = ACTIONS(1421),
    [anon_sym_alignas] = ACTIONS(1421),
    [anon_sym__Alignas] = ACTIONS(1421),
    [sym_primitive_type] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1421),
    [anon_sym_union] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_goto] = ACTIONS(1421),
    [anon_sym___try] = ACTIONS(1421),
    [anon_sym___leave] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1423),
    [anon_sym_sizeof] = ACTIONS(1421),
    [anon_sym___alignof__] = ACTIONS(1421),
    [anon_sym___alignof] = ACTIONS(1421),
    [anon_sym__alignof] = ACTIONS(1421),
    [anon_sym_alignof] = ACTIONS(1421),
    [anon_sym__Alignof] = ACTIONS(1421),
    [anon_sym_offsetof] = ACTIONS(1421),
    [anon_sym__Generic] = ACTIONS(1421),
    [anon_sym_asm] = ACTIONS(1421),
    [anon_sym___asm__] = ACTIONS(1421),
    [sym_number_literal] = ACTIONS(1423),
    [anon_sym_L_SQUOTE] = ACTIONS(1423),
    [anon_sym_u_SQUOTE] = ACTIONS(1423),
    [anon_sym_U_SQUOTE] = ACTIONS(1423),
    [anon_sym_u8_SQUOTE] = ACTIONS(1423),
    [anon_sym_SQUOTE] = ACTIONS(1423),
    [anon_sym_L_DQUOTE] = ACTIONS(1423),
    [anon_sym_u_DQUOTE] = ACTIONS(1423),
    [anon_sym_U_DQUOTE] = ACTIONS(1423),
    [anon_sym_u8_DQUOTE] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [anon_sym_NULL] = ACTIONS(1421),
    [anon_sym_nullptr] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1421),
    [anon_sym_hitAttributeEXT] = ACTIONS(1421),
    [anon_sym_callableDataEXT] = ACTIONS(1421),
    [anon_sym_callableDataInEXT] = ACTIONS(1421),
    [anon_sym_shaderRecordEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadNV] = ACTIONS(1421),
    [anon_sym_rayPayloadInNV] = ACTIONS(1421),
    [anon_sym_hitAttributeNV] = ACTIONS(1421),
    [anon_sym_callableDataNV] = ACTIONS(1421),
    [anon_sym_callableDataInNV] = ACTIONS(1421),
    [anon_sym_shaderRecordNV] = ACTIONS(1421),
    [anon_sym_layout] = ACTIONS(1421),
  },
  [386] = {
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym___try] = ACTIONS(1457),
    [anon_sym___leave] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [387] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_include_token1] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym___cdecl] = ACTIONS(1409),
    [anon_sym___clrcall] = ACTIONS(1409),
    [anon_sym___stdcall] = ACTIONS(1409),
    [anon_sym___fastcall] = ACTIONS(1409),
    [anon_sym___thiscall] = ACTIONS(1409),
    [anon_sym___vectorcall] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_case] = ACTIONS(1409),
    [anon_sym_default] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_return] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1409),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_goto] = ACTIONS(1409),
    [anon_sym___try] = ACTIONS(1409),
    [anon_sym___leave] = ACTIONS(1409),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_sizeof] = ACTIONS(1409),
    [anon_sym___alignof__] = ACTIONS(1409),
    [anon_sym___alignof] = ACTIONS(1409),
    [anon_sym__alignof] = ACTIONS(1409),
    [anon_sym_alignof] = ACTIONS(1409),
    [anon_sym__Alignof] = ACTIONS(1409),
    [anon_sym_offsetof] = ACTIONS(1409),
    [anon_sym__Generic] = ACTIONS(1409),
    [anon_sym_asm] = ACTIONS(1409),
    [anon_sym___asm__] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1411),
    [anon_sym_L_SQUOTE] = ACTIONS(1411),
    [anon_sym_u_SQUOTE] = ACTIONS(1411),
    [anon_sym_U_SQUOTE] = ACTIONS(1411),
    [anon_sym_u8_SQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [anon_sym_L_DQUOTE] = ACTIONS(1411),
    [anon_sym_u_DQUOTE] = ACTIONS(1411),
    [anon_sym_U_DQUOTE] = ACTIONS(1411),
    [anon_sym_u8_DQUOTE] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [anon_sym_NULL] = ACTIONS(1409),
    [anon_sym_nullptr] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [388] = {
    [sym_identifier] = ACTIONS(1405),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_subroutine] = ACTIONS(1405),
    [anon_sym_invariant] = ACTIONS(1405),
    [anon_sym_precise] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_in] = ACTIONS(1405),
    [anon_sym_out] = ACTIONS(1405),
    [anon_sym_inout] = ACTIONS(1405),
    [anon_sym_uniform] = ACTIONS(1405),
    [anon_sym_shared] = ACTIONS(1405),
    [anon_sym_attribute] = ACTIONS(1405),
    [anon_sym_varying] = ACTIONS(1405),
    [anon_sym_buffer] = ACTIONS(1405),
    [anon_sym_coherent] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(1405),
    [anon_sym_writeonly] = ACTIONS(1405),
    [anon_sym_precision] = ACTIONS(1405),
    [anon_sym_highp] = ACTIONS(1405),
    [anon_sym_mediump] = ACTIONS(1405),
    [anon_sym_lowp] = ACTIONS(1405),
    [anon_sym_centroid] = ACTIONS(1405),
    [anon_sym_sample] = ACTIONS(1405),
    [anon_sym_patch] = ACTIONS(1405),
    [anon_sym_smooth] = ACTIONS(1405),
    [anon_sym_flat] = ACTIONS(1405),
    [anon_sym_noperspective] = ACTIONS(1405),
    [anon_sym___extension__] = ACTIONS(1405),
    [anon_sym_typedef] = ACTIONS(1405),
    [anon_sym_extern] = ACTIONS(1405),
    [anon_sym___attribute__] = ACTIONS(1405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1407),
    [anon_sym___declspec] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_signed] = ACTIONS(1405),
    [anon_sym_unsigned] = ACTIONS(1405),
    [anon_sym_long] = ACTIONS(1405),
    [anon_sym_short] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_auto] = ACTIONS(1405),
    [anon_sym_register] = ACTIONS(1405),
    [anon_sym_inline] = ACTIONS(1405),
    [anon_sym___inline] = ACTIONS(1405),
    [anon_sym___inline__] = ACTIONS(1405),
    [anon_sym___forceinline] = ACTIONS(1405),
    [anon_sym_thread_local] = ACTIONS(1405),
    [anon_sym___thread] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1405),
    [anon_sym_constexpr] = ACTIONS(1405),
    [anon_sym_volatile] = ACTIONS(1405),
    [anon_sym_restrict] = ACTIONS(1405),
    [anon_sym___restrict__] = ACTIONS(1405),
    [anon_sym__Atomic] = ACTIONS(1405),
    [anon_sym__Noreturn] = ACTIONS(1405),
    [anon_sym_noreturn] = ACTIONS(1405),
    [anon_sym_alignas] = ACTIONS(1405),
    [anon_sym__Alignas] = ACTIONS(1405),
    [sym_primitive_type] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1405),
    [anon_sym_union] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(1405),
    [anon_sym_for] = ACTIONS(1405),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_break] = ACTIONS(1405),
    [anon_sym_continue] = ACTIONS(1405),
    [anon_sym_goto] = ACTIONS(1405),
    [anon_sym___try] = ACTIONS(1405),
    [anon_sym___leave] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1405),
    [anon_sym___alignof__] = ACTIONS(1405),
    [anon_sym___alignof] = ACTIONS(1405),
    [anon_sym__alignof] = ACTIONS(1405),
    [anon_sym_alignof] = ACTIONS(1405),
    [anon_sym__Alignof] = ACTIONS(1405),
    [anon_sym_offsetof] = ACTIONS(1405),
    [anon_sym__Generic] = ACTIONS(1405),
    [anon_sym_asm] = ACTIONS(1405),
    [anon_sym___asm__] = ACTIONS(1405),
    [sym_number_literal] = ACTIONS(1407),
    [anon_sym_L_SQUOTE] = ACTIONS(1407),
    [anon_sym_u_SQUOTE] = ACTIONS(1407),
    [anon_sym_U_SQUOTE] = ACTIONS(1407),
    [anon_sym_u8_SQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_L_DQUOTE] = ACTIONS(1407),
    [anon_sym_u_DQUOTE] = ACTIONS(1407),
    [anon_sym_U_DQUOTE] = ACTIONS(1407),
    [anon_sym_u8_DQUOTE] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [anon_sym_NULL] = ACTIONS(1405),
    [anon_sym_nullptr] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1405),
    [anon_sym_hitAttributeEXT] = ACTIONS(1405),
    [anon_sym_callableDataEXT] = ACTIONS(1405),
    [anon_sym_callableDataInEXT] = ACTIONS(1405),
    [anon_sym_shaderRecordEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadNV] = ACTIONS(1405),
    [anon_sym_rayPayloadInNV] = ACTIONS(1405),
    [anon_sym_hitAttributeNV] = ACTIONS(1405),
    [anon_sym_callableDataNV] = ACTIONS(1405),
    [anon_sym_callableDataInNV] = ACTIONS(1405),
    [anon_sym_shaderRecordNV] = ACTIONS(1405),
    [anon_sym_layout] = ACTIONS(1405),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_include_token1] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_LPAREN2] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_typedef] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym___cdecl] = ACTIONS(1401),
    [anon_sym___clrcall] = ACTIONS(1401),
    [anon_sym___stdcall] = ACTIONS(1401),
    [anon_sym___fastcall] = ACTIONS(1401),
    [anon_sym___thiscall] = ACTIONS(1401),
    [anon_sym___vectorcall] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_goto] = ACTIONS(1401),
    [anon_sym___try] = ACTIONS(1401),
    [anon_sym___leave] = ACTIONS(1401),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_sizeof] = ACTIONS(1401),
    [anon_sym___alignof__] = ACTIONS(1401),
    [anon_sym___alignof] = ACTIONS(1401),
    [anon_sym__alignof] = ACTIONS(1401),
    [anon_sym_alignof] = ACTIONS(1401),
    [anon_sym__Alignof] = ACTIONS(1401),
    [anon_sym_offsetof] = ACTIONS(1401),
    [anon_sym__Generic] = ACTIONS(1401),
    [anon_sym_asm] = ACTIONS(1401),
    [anon_sym___asm__] = ACTIONS(1401),
    [sym_number_literal] = ACTIONS(1403),
    [anon_sym_L_SQUOTE] = ACTIONS(1403),
    [anon_sym_u_SQUOTE] = ACTIONS(1403),
    [anon_sym_U_SQUOTE] = ACTIONS(1403),
    [anon_sym_u8_SQUOTE] = ACTIONS(1403),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_L_DQUOTE] = ACTIONS(1403),
    [anon_sym_u_DQUOTE] = ACTIONS(1403),
    [anon_sym_U_DQUOTE] = ACTIONS(1403),
    [anon_sym_u8_DQUOTE] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [anon_sym_NULL] = ACTIONS(1401),
    [anon_sym_nullptr] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [390] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_RBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1465),
    [aux_sym_preproc_include_token1] = ACTIONS(1465),
    [aux_sym_preproc_def_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1465),
    [sym_preproc_directive] = ACTIONS(1465),
    [anon_sym_LPAREN2] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_subroutine] = ACTIONS(1465),
    [anon_sym_invariant] = ACTIONS(1465),
    [anon_sym_precise] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(1465),
    [anon_sym_out] = ACTIONS(1465),
    [anon_sym_inout] = ACTIONS(1465),
    [anon_sym_uniform] = ACTIONS(1465),
    [anon_sym_shared] = ACTIONS(1465),
    [anon_sym_attribute] = ACTIONS(1465),
    [anon_sym_varying] = ACTIONS(1465),
    [anon_sym_buffer] = ACTIONS(1465),
    [anon_sym_coherent] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_writeonly] = ACTIONS(1465),
    [anon_sym_precision] = ACTIONS(1465),
    [anon_sym_highp] = ACTIONS(1465),
    [anon_sym_mediump] = ACTIONS(1465),
    [anon_sym_lowp] = ACTIONS(1465),
    [anon_sym_centroid] = ACTIONS(1465),
    [anon_sym_sample] = ACTIONS(1465),
    [anon_sym_patch] = ACTIONS(1465),
    [anon_sym_smooth] = ACTIONS(1465),
    [anon_sym_flat] = ACTIONS(1465),
    [anon_sym_noperspective] = ACTIONS(1465),
    [anon_sym___extension__] = ACTIONS(1465),
    [anon_sym_typedef] = ACTIONS(1465),
    [anon_sym_extern] = ACTIONS(1465),
    [anon_sym___attribute__] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1467),
    [anon_sym___declspec] = ACTIONS(1465),
    [anon_sym___cdecl] = ACTIONS(1465),
    [anon_sym___clrcall] = ACTIONS(1465),
    [anon_sym___stdcall] = ACTIONS(1465),
    [anon_sym___fastcall] = ACTIONS(1465),
    [anon_sym___thiscall] = ACTIONS(1465),
    [anon_sym___vectorcall] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_signed] = ACTIONS(1465),
    [anon_sym_unsigned] = ACTIONS(1465),
    [anon_sym_long] = ACTIONS(1465),
    [anon_sym_short] = ACTIONS(1465),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_auto] = ACTIONS(1465),
    [anon_sym_register] = ACTIONS(1465),
    [anon_sym_inline] = ACTIONS(1465),
    [anon_sym___inline] = ACTIONS(1465),
    [anon_sym___inline__] = ACTIONS(1465),
    [anon_sym___forceinline] = ACTIONS(1465),
    [anon_sym_thread_local] = ACTIONS(1465),
    [anon_sym___thread] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_constexpr] = ACTIONS(1465),
    [anon_sym_volatile] = ACTIONS(1465),
    [anon_sym_restrict] = ACTIONS(1465),
    [anon_sym___restrict__] = ACTIONS(1465),
    [anon_sym__Atomic] = ACTIONS(1465),
    [anon_sym__Noreturn] = ACTIONS(1465),
    [anon_sym_noreturn] = ACTIONS(1465),
    [anon_sym_alignas] = ACTIONS(1465),
    [anon_sym__Alignas] = ACTIONS(1465),
    [sym_primitive_type] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [anon_sym_struct] = ACTIONS(1465),
    [anon_sym_union] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_goto] = ACTIONS(1465),
    [anon_sym___try] = ACTIONS(1465),
    [anon_sym___leave] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1467),
    [anon_sym_sizeof] = ACTIONS(1465),
    [anon_sym___alignof__] = ACTIONS(1465),
    [anon_sym___alignof] = ACTIONS(1465),
    [anon_sym__alignof] = ACTIONS(1465),
    [anon_sym_alignof] = ACTIONS(1465),
    [anon_sym__Alignof] = ACTIONS(1465),
    [anon_sym_offsetof] = ACTIONS(1465),
    [anon_sym__Generic] = ACTIONS(1465),
    [anon_sym_asm] = ACTIONS(1465),
    [anon_sym___asm__] = ACTIONS(1465),
    [sym_number_literal] = ACTIONS(1467),
    [anon_sym_L_SQUOTE] = ACTIONS(1467),
    [anon_sym_u_SQUOTE] = ACTIONS(1467),
    [anon_sym_U_SQUOTE] = ACTIONS(1467),
    [anon_sym_u8_SQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_L_DQUOTE] = ACTIONS(1467),
    [anon_sym_u_DQUOTE] = ACTIONS(1467),
    [anon_sym_U_DQUOTE] = ACTIONS(1467),
    [anon_sym_u8_DQUOTE] = ACTIONS(1467),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [anon_sym_NULL] = ACTIONS(1465),
    [anon_sym_nullptr] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1465),
    [anon_sym_hitAttributeEXT] = ACTIONS(1465),
    [anon_sym_callableDataEXT] = ACTIONS(1465),
    [anon_sym_callableDataInEXT] = ACTIONS(1465),
    [anon_sym_shaderRecordEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadNV] = ACTIONS(1465),
    [anon_sym_rayPayloadInNV] = ACTIONS(1465),
    [anon_sym_hitAttributeNV] = ACTIONS(1465),
    [anon_sym_callableDataNV] = ACTIONS(1465),
    [anon_sym_callableDataInNV] = ACTIONS(1465),
    [anon_sym_shaderRecordNV] = ACTIONS(1465),
    [anon_sym_layout] = ACTIONS(1465),
  },
  [392] = {
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_RBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym___try] = ACTIONS(1433),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_LPAREN2] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_typedef] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym___cdecl] = ACTIONS(1441),
    [anon_sym___clrcall] = ACTIONS(1441),
    [anon_sym___stdcall] = ACTIONS(1441),
    [anon_sym___fastcall] = ACTIONS(1441),
    [anon_sym___thiscall] = ACTIONS(1441),
    [anon_sym___vectorcall] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1441),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1441),
    [anon_sym_continue] = ACTIONS(1441),
    [anon_sym_goto] = ACTIONS(1441),
    [anon_sym___try] = ACTIONS(1441),
    [anon_sym___leave] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1443),
    [anon_sym_sizeof] = ACTIONS(1441),
    [anon_sym___alignof__] = ACTIONS(1441),
    [anon_sym___alignof] = ACTIONS(1441),
    [anon_sym__alignof] = ACTIONS(1441),
    [anon_sym_alignof] = ACTIONS(1441),
    [anon_sym__Alignof] = ACTIONS(1441),
    [anon_sym_offsetof] = ACTIONS(1441),
    [anon_sym__Generic] = ACTIONS(1441),
    [anon_sym_asm] = ACTIONS(1441),
    [anon_sym___asm__] = ACTIONS(1441),
    [sym_number_literal] = ACTIONS(1443),
    [anon_sym_L_SQUOTE] = ACTIONS(1443),
    [anon_sym_u_SQUOTE] = ACTIONS(1443),
    [anon_sym_U_SQUOTE] = ACTIONS(1443),
    [anon_sym_u8_SQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_L_DQUOTE] = ACTIONS(1443),
    [anon_sym_u_DQUOTE] = ACTIONS(1443),
    [anon_sym_U_DQUOTE] = ACTIONS(1443),
    [anon_sym_u8_DQUOTE] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [anon_sym_NULL] = ACTIONS(1441),
    [anon_sym_nullptr] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [394] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_RBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [395] = {
    [sym_identifier] = ACTIONS(1513),
    [aux_sym_preproc_include_token1] = ACTIONS(1513),
    [aux_sym_preproc_def_token1] = ACTIONS(1513),
    [aux_sym_preproc_if_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1513),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1513),
    [sym_preproc_directive] = ACTIONS(1513),
    [anon_sym_LPAREN2] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PLUS] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_subroutine] = ACTIONS(1513),
    [anon_sym_invariant] = ACTIONS(1513),
    [anon_sym_precise] = ACTIONS(1513),
    [anon_sym_SEMI] = ACTIONS(1516),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_out] = ACTIONS(1513),
    [anon_sym_inout] = ACTIONS(1513),
    [anon_sym_uniform] = ACTIONS(1513),
    [anon_sym_shared] = ACTIONS(1513),
    [anon_sym_attribute] = ACTIONS(1513),
    [anon_sym_varying] = ACTIONS(1513),
    [anon_sym_buffer] = ACTIONS(1513),
    [anon_sym_coherent] = ACTIONS(1513),
    [anon_sym_readonly] = ACTIONS(1513),
    [anon_sym_writeonly] = ACTIONS(1513),
    [anon_sym_precision] = ACTIONS(1513),
    [anon_sym_highp] = ACTIONS(1513),
    [anon_sym_mediump] = ACTIONS(1513),
    [anon_sym_lowp] = ACTIONS(1513),
    [anon_sym_centroid] = ACTIONS(1513),
    [anon_sym_sample] = ACTIONS(1513),
    [anon_sym_patch] = ACTIONS(1513),
    [anon_sym_smooth] = ACTIONS(1513),
    [anon_sym_flat] = ACTIONS(1513),
    [anon_sym_noperspective] = ACTIONS(1513),
    [anon_sym___extension__] = ACTIONS(1513),
    [anon_sym_typedef] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1513),
    [anon_sym___attribute__] = ACTIONS(1513),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1516),
    [anon_sym___declspec] = ACTIONS(1513),
    [anon_sym___cdecl] = ACTIONS(1513),
    [anon_sym___clrcall] = ACTIONS(1513),
    [anon_sym___stdcall] = ACTIONS(1513),
    [anon_sym___fastcall] = ACTIONS(1513),
    [anon_sym___thiscall] = ACTIONS(1513),
    [anon_sym___vectorcall] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1516),
    [anon_sym_signed] = ACTIONS(1513),
    [anon_sym_unsigned] = ACTIONS(1513),
    [anon_sym_long] = ACTIONS(1513),
    [anon_sym_short] = ACTIONS(1513),
    [anon_sym_static] = ACTIONS(1513),
    [anon_sym_auto] = ACTIONS(1513),
    [anon_sym_register] = ACTIONS(1513),
    [anon_sym_inline] = ACTIONS(1513),
    [anon_sym___inline] = ACTIONS(1513),
    [anon_sym___inline__] = ACTIONS(1513),
    [anon_sym___forceinline] = ACTIONS(1513),
    [anon_sym_thread_local] = ACTIONS(1513),
    [anon_sym___thread] = ACTIONS(1513),
    [anon_sym_const] = ACTIONS(1513),
    [anon_sym_constexpr] = ACTIONS(1513),
    [anon_sym_volatile] = ACTIONS(1513),
    [anon_sym_restrict] = ACTIONS(1513),
    [anon_sym___restrict__] = ACTIONS(1513),
    [anon_sym__Atomic] = ACTIONS(1513),
    [anon_sym__Noreturn] = ACTIONS(1513),
    [anon_sym_noreturn] = ACTIONS(1513),
    [anon_sym_alignas] = ACTIONS(1513),
    [anon_sym__Alignas] = ACTIONS(1513),
    [sym_primitive_type] = ACTIONS(1513),
    [anon_sym_enum] = ACTIONS(1513),
    [anon_sym_struct] = ACTIONS(1513),
    [anon_sym_union] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1513),
    [anon_sym_case] = ACTIONS(1513),
    [anon_sym_default] = ACTIONS(1513),
    [anon_sym_while] = ACTIONS(1513),
    [anon_sym_do] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_return] = ACTIONS(1513),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_continue] = ACTIONS(1513),
    [anon_sym_goto] = ACTIONS(1513),
    [anon_sym___try] = ACTIONS(1513),
    [anon_sym___leave] = ACTIONS(1513),
    [anon_sym_DASH_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1516),
    [anon_sym_sizeof] = ACTIONS(1513),
    [anon_sym___alignof__] = ACTIONS(1513),
    [anon_sym___alignof] = ACTIONS(1513),
    [anon_sym__alignof] = ACTIONS(1513),
    [anon_sym_alignof] = ACTIONS(1513),
    [anon_sym__Alignof] = ACTIONS(1513),
    [anon_sym_offsetof] = ACTIONS(1513),
    [anon_sym__Generic] = ACTIONS(1513),
    [anon_sym_asm] = ACTIONS(1513),
    [anon_sym___asm__] = ACTIONS(1513),
    [sym_number_literal] = ACTIONS(1516),
    [anon_sym_L_SQUOTE] = ACTIONS(1516),
    [anon_sym_u_SQUOTE] = ACTIONS(1516),
    [anon_sym_U_SQUOTE] = ACTIONS(1516),
    [anon_sym_u8_SQUOTE] = ACTIONS(1516),
    [anon_sym_SQUOTE] = ACTIONS(1516),
    [anon_sym_L_DQUOTE] = ACTIONS(1516),
    [anon_sym_u_DQUOTE] = ACTIONS(1516),
    [anon_sym_U_DQUOTE] = ACTIONS(1516),
    [anon_sym_u8_DQUOTE] = ACTIONS(1516),
    [anon_sym_DQUOTE] = ACTIONS(1516),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [anon_sym_NULL] = ACTIONS(1513),
    [anon_sym_nullptr] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1513),
    [anon_sym_hitAttributeEXT] = ACTIONS(1513),
    [anon_sym_callableDataEXT] = ACTIONS(1513),
    [anon_sym_callableDataInEXT] = ACTIONS(1513),
    [anon_sym_shaderRecordEXT] = ACTIONS(1513),
    [anon_sym_rayPayloadNV] = ACTIONS(1513),
    [anon_sym_rayPayloadInNV] = ACTIONS(1513),
    [anon_sym_hitAttributeNV] = ACTIONS(1513),
    [anon_sym_callableDataNV] = ACTIONS(1513),
    [anon_sym_callableDataInNV] = ACTIONS(1513),
    [anon_sym_shaderRecordNV] = ACTIONS(1513),
    [anon_sym_layout] = ACTIONS(1513),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_RBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym___try] = ACTIONS(1413),
    [anon_sym___leave] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [397] = {
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_subroutine] = ACTIONS(1445),
    [anon_sym_invariant] = ACTIONS(1445),
    [anon_sym_precise] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_in] = ACTIONS(1445),
    [anon_sym_out] = ACTIONS(1445),
    [anon_sym_inout] = ACTIONS(1445),
    [anon_sym_uniform] = ACTIONS(1445),
    [anon_sym_shared] = ACTIONS(1445),
    [anon_sym_attribute] = ACTIONS(1445),
    [anon_sym_varying] = ACTIONS(1445),
    [anon_sym_buffer] = ACTIONS(1445),
    [anon_sym_coherent] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_writeonly] = ACTIONS(1445),
    [anon_sym_precision] = ACTIONS(1445),
    [anon_sym_highp] = ACTIONS(1445),
    [anon_sym_mediump] = ACTIONS(1445),
    [anon_sym_lowp] = ACTIONS(1445),
    [anon_sym_centroid] = ACTIONS(1445),
    [anon_sym_sample] = ACTIONS(1445),
    [anon_sym_patch] = ACTIONS(1445),
    [anon_sym_smooth] = ACTIONS(1445),
    [anon_sym_flat] = ACTIONS(1445),
    [anon_sym_noperspective] = ACTIONS(1445),
    [anon_sym___extension__] = ACTIONS(1445),
    [anon_sym_typedef] = ACTIONS(1445),
    [anon_sym_extern] = ACTIONS(1445),
    [anon_sym___attribute__] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1447),
    [anon_sym___declspec] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_signed] = ACTIONS(1445),
    [anon_sym_unsigned] = ACTIONS(1445),
    [anon_sym_long] = ACTIONS(1445),
    [anon_sym_short] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_auto] = ACTIONS(1445),
    [anon_sym_register] = ACTIONS(1445),
    [anon_sym_inline] = ACTIONS(1445),
    [anon_sym___inline] = ACTIONS(1445),
    [anon_sym___inline__] = ACTIONS(1445),
    [anon_sym___forceinline] = ACTIONS(1445),
    [anon_sym_thread_local] = ACTIONS(1445),
    [anon_sym___thread] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(1445),
    [anon_sym_constexpr] = ACTIONS(1445),
    [anon_sym_volatile] = ACTIONS(1445),
    [anon_sym_restrict] = ACTIONS(1445),
    [anon_sym___restrict__] = ACTIONS(1445),
    [anon_sym__Atomic] = ACTIONS(1445),
    [anon_sym__Noreturn] = ACTIONS(1445),
    [anon_sym_noreturn] = ACTIONS(1445),
    [anon_sym_alignas] = ACTIONS(1445),
    [anon_sym__Alignas] = ACTIONS(1445),
    [sym_primitive_type] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1445),
    [anon_sym_union] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_continue] = ACTIONS(1445),
    [anon_sym_goto] = ACTIONS(1445),
    [anon_sym___try] = ACTIONS(1445),
    [anon_sym___leave] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1445),
    [anon_sym___alignof__] = ACTIONS(1445),
    [anon_sym___alignof] = ACTIONS(1445),
    [anon_sym__alignof] = ACTIONS(1445),
    [anon_sym_alignof] = ACTIONS(1445),
    [anon_sym__Alignof] = ACTIONS(1445),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1445),
    [anon_sym_asm] = ACTIONS(1445),
    [anon_sym___asm__] = ACTIONS(1445),
    [sym_number_literal] = ACTIONS(1447),
    [anon_sym_L_SQUOTE] = ACTIONS(1447),
    [anon_sym_u_SQUOTE] = ACTIONS(1447),
    [anon_sym_U_SQUOTE] = ACTIONS(1447),
    [anon_sym_u8_SQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_L_DQUOTE] = ACTIONS(1447),
    [anon_sym_u_DQUOTE] = ACTIONS(1447),
    [anon_sym_U_DQUOTE] = ACTIONS(1447),
    [anon_sym_u8_DQUOTE] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [sym_true] = ACTIONS(1445),
    [sym_false] = ACTIONS(1445),
    [anon_sym_NULL] = ACTIONS(1445),
    [anon_sym_nullptr] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1445),
    [anon_sym_hitAttributeEXT] = ACTIONS(1445),
    [anon_sym_callableDataEXT] = ACTIONS(1445),
    [anon_sym_callableDataInEXT] = ACTIONS(1445),
    [anon_sym_shaderRecordEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadNV] = ACTIONS(1445),
    [anon_sym_rayPayloadInNV] = ACTIONS(1445),
    [anon_sym_hitAttributeNV] = ACTIONS(1445),
    [anon_sym_callableDataNV] = ACTIONS(1445),
    [anon_sym_callableDataInNV] = ACTIONS(1445),
    [anon_sym_shaderRecordNV] = ACTIONS(1445),
    [anon_sym_layout] = ACTIONS(1445),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(1443),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [anon_sym_COMMA] = ACTIONS(1443),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_LPAREN2] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_typedef] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym___cdecl] = ACTIONS(1441),
    [anon_sym___clrcall] = ACTIONS(1441),
    [anon_sym___stdcall] = ACTIONS(1441),
    [anon_sym___fastcall] = ACTIONS(1441),
    [anon_sym___thiscall] = ACTIONS(1441),
    [anon_sym___vectorcall] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1441),
    [anon_sym_case] = ACTIONS(1441),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_do] = ACTIONS(1441),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1441),
    [anon_sym_continue] = ACTIONS(1441),
    [anon_sym_goto] = ACTIONS(1441),
    [anon_sym_DASH_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1443),
    [anon_sym_sizeof] = ACTIONS(1441),
    [anon_sym___alignof__] = ACTIONS(1441),
    [anon_sym___alignof] = ACTIONS(1441),
    [anon_sym__alignof] = ACTIONS(1441),
    [anon_sym_alignof] = ACTIONS(1441),
    [anon_sym__Alignof] = ACTIONS(1441),
    [anon_sym_offsetof] = ACTIONS(1441),
    [anon_sym__Generic] = ACTIONS(1441),
    [anon_sym_asm] = ACTIONS(1441),
    [anon_sym___asm__] = ACTIONS(1441),
    [sym_number_literal] = ACTIONS(1443),
    [anon_sym_L_SQUOTE] = ACTIONS(1443),
    [anon_sym_u_SQUOTE] = ACTIONS(1443),
    [anon_sym_U_SQUOTE] = ACTIONS(1443),
    [anon_sym_u8_SQUOTE] = ACTIONS(1443),
    [anon_sym_SQUOTE] = ACTIONS(1443),
    [anon_sym_L_DQUOTE] = ACTIONS(1443),
    [anon_sym_u_DQUOTE] = ACTIONS(1443),
    [anon_sym_U_DQUOTE] = ACTIONS(1443),
    [anon_sym_u8_DQUOTE] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1443),
    [sym_true] = ACTIONS(1441),
    [sym_false] = ACTIONS(1441),
    [anon_sym_NULL] = ACTIONS(1441),
    [anon_sym_nullptr] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [399] = {
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_include_token1] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1411),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_LPAREN2] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_TILDE] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_typedef] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym___cdecl] = ACTIONS(1409),
    [anon_sym___clrcall] = ACTIONS(1409),
    [anon_sym___stdcall] = ACTIONS(1409),
    [anon_sym___fastcall] = ACTIONS(1409),
    [anon_sym___thiscall] = ACTIONS(1409),
    [anon_sym___vectorcall] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1409),
    [anon_sym_case] = ACTIONS(1409),
    [anon_sym_default] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_return] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1409),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_goto] = ACTIONS(1409),
    [anon_sym_DASH_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1411),
    [anon_sym_sizeof] = ACTIONS(1409),
    [anon_sym___alignof__] = ACTIONS(1409),
    [anon_sym___alignof] = ACTIONS(1409),
    [anon_sym__alignof] = ACTIONS(1409),
    [anon_sym_alignof] = ACTIONS(1409),
    [anon_sym__Alignof] = ACTIONS(1409),
    [anon_sym_offsetof] = ACTIONS(1409),
    [anon_sym__Generic] = ACTIONS(1409),
    [anon_sym_asm] = ACTIONS(1409),
    [anon_sym___asm__] = ACTIONS(1409),
    [sym_number_literal] = ACTIONS(1411),
    [anon_sym_L_SQUOTE] = ACTIONS(1411),
    [anon_sym_u_SQUOTE] = ACTIONS(1411),
    [anon_sym_U_SQUOTE] = ACTIONS(1411),
    [anon_sym_u8_SQUOTE] = ACTIONS(1411),
    [anon_sym_SQUOTE] = ACTIONS(1411),
    [anon_sym_L_DQUOTE] = ACTIONS(1411),
    [anon_sym_u_DQUOTE] = ACTIONS(1411),
    [anon_sym_U_DQUOTE] = ACTIONS(1411),
    [anon_sym_u8_DQUOTE] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1411),
    [sym_true] = ACTIONS(1409),
    [sym_false] = ACTIONS(1409),
    [anon_sym_NULL] = ACTIONS(1409),
    [anon_sym_nullptr] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1535),
    [aux_sym_preproc_include_token1] = ACTIONS(1535),
    [aux_sym_preproc_def_token1] = ACTIONS(1535),
    [aux_sym_preproc_if_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1535),
    [sym_preproc_directive] = ACTIONS(1535),
    [anon_sym_LPAREN2] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1535),
    [anon_sym_PLUS] = ACTIONS(1535),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_subroutine] = ACTIONS(1535),
    [anon_sym_invariant] = ACTIONS(1535),
    [anon_sym_precise] = ACTIONS(1535),
    [anon_sym_in] = ACTIONS(1535),
    [anon_sym_out] = ACTIONS(1535),
    [anon_sym_inout] = ACTIONS(1535),
    [anon_sym_uniform] = ACTIONS(1535),
    [anon_sym_shared] = ACTIONS(1535),
    [anon_sym_attribute] = ACTIONS(1535),
    [anon_sym_varying] = ACTIONS(1535),
    [anon_sym_buffer] = ACTIONS(1535),
    [anon_sym_coherent] = ACTIONS(1535),
    [anon_sym_readonly] = ACTIONS(1535),
    [anon_sym_writeonly] = ACTIONS(1535),
    [anon_sym_precision] = ACTIONS(1535),
    [anon_sym_highp] = ACTIONS(1535),
    [anon_sym_mediump] = ACTIONS(1535),
    [anon_sym_lowp] = ACTIONS(1535),
    [anon_sym_centroid] = ACTIONS(1535),
    [anon_sym_sample] = ACTIONS(1535),
    [anon_sym_patch] = ACTIONS(1535),
    [anon_sym_smooth] = ACTIONS(1535),
    [anon_sym_flat] = ACTIONS(1535),
    [anon_sym_noperspective] = ACTIONS(1535),
    [anon_sym___extension__] = ACTIONS(1535),
    [anon_sym_typedef] = ACTIONS(1535),
    [anon_sym_extern] = ACTIONS(1535),
    [anon_sym___attribute__] = ACTIONS(1535),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1537),
    [anon_sym___declspec] = ACTIONS(1535),
    [anon_sym___cdecl] = ACTIONS(1535),
    [anon_sym___clrcall] = ACTIONS(1535),
    [anon_sym___stdcall] = ACTIONS(1535),
    [anon_sym___fastcall] = ACTIONS(1535),
    [anon_sym___thiscall] = ACTIONS(1535),
    [anon_sym___vectorcall] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_signed] = ACTIONS(1535),
    [anon_sym_unsigned] = ACTIONS(1535),
    [anon_sym_long] = ACTIONS(1535),
    [anon_sym_short] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_auto] = ACTIONS(1535),
    [anon_sym_register] = ACTIONS(1535),
    [anon_sym_inline] = ACTIONS(1535),
    [anon_sym___inline] = ACTIONS(1535),
    [anon_sym___inline__] = ACTIONS(1535),
    [anon_sym___forceinline] = ACTIONS(1535),
    [anon_sym_thread_local] = ACTIONS(1535),
    [anon_sym___thread] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_constexpr] = ACTIONS(1535),
    [anon_sym_volatile] = ACTIONS(1535),
    [anon_sym_restrict] = ACTIONS(1535),
    [anon_sym___restrict__] = ACTIONS(1535),
    [anon_sym__Atomic] = ACTIONS(1535),
    [anon_sym__Noreturn] = ACTIONS(1535),
    [anon_sym_noreturn] = ACTIONS(1535),
    [anon_sym_alignas] = ACTIONS(1535),
    [anon_sym__Alignas] = ACTIONS(1535),
    [sym_primitive_type] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [anon_sym_struct] = ACTIONS(1535),
    [anon_sym_union] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_goto] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1537),
    [anon_sym_sizeof] = ACTIONS(1535),
    [anon_sym___alignof__] = ACTIONS(1535),
    [anon_sym___alignof] = ACTIONS(1535),
    [anon_sym__alignof] = ACTIONS(1535),
    [anon_sym_alignof] = ACTIONS(1535),
    [anon_sym__Alignof] = ACTIONS(1535),
    [anon_sym_offsetof] = ACTIONS(1535),
    [anon_sym__Generic] = ACTIONS(1535),
    [anon_sym_asm] = ACTIONS(1535),
    [anon_sym___asm__] = ACTIONS(1535),
    [sym_number_literal] = ACTIONS(1537),
    [anon_sym_L_SQUOTE] = ACTIONS(1537),
    [anon_sym_u_SQUOTE] = ACTIONS(1537),
    [anon_sym_U_SQUOTE] = ACTIONS(1537),
    [anon_sym_u8_SQUOTE] = ACTIONS(1537),
    [anon_sym_SQUOTE] = ACTIONS(1537),
    [anon_sym_L_DQUOTE] = ACTIONS(1537),
    [anon_sym_u_DQUOTE] = ACTIONS(1537),
    [anon_sym_U_DQUOTE] = ACTIONS(1537),
    [anon_sym_u8_DQUOTE] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(1537),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [anon_sym_NULL] = ACTIONS(1535),
    [anon_sym_nullptr] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1535),
    [anon_sym_hitAttributeEXT] = ACTIONS(1535),
    [anon_sym_callableDataEXT] = ACTIONS(1535),
    [anon_sym_callableDataInEXT] = ACTIONS(1535),
    [anon_sym_shaderRecordEXT] = ACTIONS(1535),
    [anon_sym_rayPayloadNV] = ACTIONS(1535),
    [anon_sym_rayPayloadInNV] = ACTIONS(1535),
    [anon_sym_hitAttributeNV] = ACTIONS(1535),
    [anon_sym_callableDataNV] = ACTIONS(1535),
    [anon_sym_callableDataInNV] = ACTIONS(1535),
    [anon_sym_shaderRecordNV] = ACTIONS(1535),
    [anon_sym_layout] = ACTIONS(1535),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [402] = {
    [ts_builtin_sym_end] = ACTIONS(1407),
    [sym_identifier] = ACTIONS(1405),
    [aux_sym_preproc_include_token1] = ACTIONS(1405),
    [aux_sym_preproc_def_token1] = ACTIONS(1405),
    [aux_sym_preproc_if_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1405),
    [sym_preproc_directive] = ACTIONS(1405),
    [anon_sym_LPAREN2] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1405),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_subroutine] = ACTIONS(1405),
    [anon_sym_invariant] = ACTIONS(1405),
    [anon_sym_precise] = ACTIONS(1405),
    [anon_sym_in] = ACTIONS(1405),
    [anon_sym_out] = ACTIONS(1405),
    [anon_sym_inout] = ACTIONS(1405),
    [anon_sym_uniform] = ACTIONS(1405),
    [anon_sym_shared] = ACTIONS(1405),
    [anon_sym_attribute] = ACTIONS(1405),
    [anon_sym_varying] = ACTIONS(1405),
    [anon_sym_buffer] = ACTIONS(1405),
    [anon_sym_coherent] = ACTIONS(1405),
    [anon_sym_readonly] = ACTIONS(1405),
    [anon_sym_writeonly] = ACTIONS(1405),
    [anon_sym_precision] = ACTIONS(1405),
    [anon_sym_highp] = ACTIONS(1405),
    [anon_sym_mediump] = ACTIONS(1405),
    [anon_sym_lowp] = ACTIONS(1405),
    [anon_sym_centroid] = ACTIONS(1405),
    [anon_sym_sample] = ACTIONS(1405),
    [anon_sym_patch] = ACTIONS(1405),
    [anon_sym_smooth] = ACTIONS(1405),
    [anon_sym_flat] = ACTIONS(1405),
    [anon_sym_noperspective] = ACTIONS(1405),
    [anon_sym___extension__] = ACTIONS(1405),
    [anon_sym_typedef] = ACTIONS(1405),
    [anon_sym_extern] = ACTIONS(1405),
    [anon_sym___attribute__] = ACTIONS(1405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1407),
    [anon_sym___declspec] = ACTIONS(1405),
    [anon_sym___cdecl] = ACTIONS(1405),
    [anon_sym___clrcall] = ACTIONS(1405),
    [anon_sym___stdcall] = ACTIONS(1405),
    [anon_sym___fastcall] = ACTIONS(1405),
    [anon_sym___thiscall] = ACTIONS(1405),
    [anon_sym___vectorcall] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_signed] = ACTIONS(1405),
    [anon_sym_unsigned] = ACTIONS(1405),
    [anon_sym_long] = ACTIONS(1405),
    [anon_sym_short] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_auto] = ACTIONS(1405),
    [anon_sym_register] = ACTIONS(1405),
    [anon_sym_inline] = ACTIONS(1405),
    [anon_sym___inline] = ACTIONS(1405),
    [anon_sym___inline__] = ACTIONS(1405),
    [anon_sym___forceinline] = ACTIONS(1405),
    [anon_sym_thread_local] = ACTIONS(1405),
    [anon_sym___thread] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1405),
    [anon_sym_constexpr] = ACTIONS(1405),
    [anon_sym_volatile] = ACTIONS(1405),
    [anon_sym_restrict] = ACTIONS(1405),
    [anon_sym___restrict__] = ACTIONS(1405),
    [anon_sym__Atomic] = ACTIONS(1405),
    [anon_sym__Noreturn] = ACTIONS(1405),
    [anon_sym_noreturn] = ACTIONS(1405),
    [anon_sym_alignas] = ACTIONS(1405),
    [anon_sym__Alignas] = ACTIONS(1405),
    [sym_primitive_type] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1405),
    [anon_sym_union] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1405),
    [anon_sym_case] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(1405),
    [anon_sym_for] = ACTIONS(1405),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_break] = ACTIONS(1405),
    [anon_sym_continue] = ACTIONS(1405),
    [anon_sym_goto] = ACTIONS(1405),
    [anon_sym_DASH_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1407),
    [anon_sym_sizeof] = ACTIONS(1405),
    [anon_sym___alignof__] = ACTIONS(1405),
    [anon_sym___alignof] = ACTIONS(1405),
    [anon_sym__alignof] = ACTIONS(1405),
    [anon_sym_alignof] = ACTIONS(1405),
    [anon_sym__Alignof] = ACTIONS(1405),
    [anon_sym_offsetof] = ACTIONS(1405),
    [anon_sym__Generic] = ACTIONS(1405),
    [anon_sym_asm] = ACTIONS(1405),
    [anon_sym___asm__] = ACTIONS(1405),
    [sym_number_literal] = ACTIONS(1407),
    [anon_sym_L_SQUOTE] = ACTIONS(1407),
    [anon_sym_u_SQUOTE] = ACTIONS(1407),
    [anon_sym_U_SQUOTE] = ACTIONS(1407),
    [anon_sym_u8_SQUOTE] = ACTIONS(1407),
    [anon_sym_SQUOTE] = ACTIONS(1407),
    [anon_sym_L_DQUOTE] = ACTIONS(1407),
    [anon_sym_u_DQUOTE] = ACTIONS(1407),
    [anon_sym_U_DQUOTE] = ACTIONS(1407),
    [anon_sym_u8_DQUOTE] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1407),
    [sym_true] = ACTIONS(1405),
    [sym_false] = ACTIONS(1405),
    [anon_sym_NULL] = ACTIONS(1405),
    [anon_sym_nullptr] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1405),
    [anon_sym_hitAttributeEXT] = ACTIONS(1405),
    [anon_sym_callableDataEXT] = ACTIONS(1405),
    [anon_sym_callableDataInEXT] = ACTIONS(1405),
    [anon_sym_shaderRecordEXT] = ACTIONS(1405),
    [anon_sym_rayPayloadNV] = ACTIONS(1405),
    [anon_sym_rayPayloadInNV] = ACTIONS(1405),
    [anon_sym_hitAttributeNV] = ACTIONS(1405),
    [anon_sym_callableDataNV] = ACTIONS(1405),
    [anon_sym_callableDataInNV] = ACTIONS(1405),
    [anon_sym_shaderRecordNV] = ACTIONS(1405),
    [anon_sym_layout] = ACTIONS(1405),
  },
  [403] = {
    [ts_builtin_sym_end] = ACTIONS(1451),
    [sym_identifier] = ACTIONS(1449),
    [aux_sym_preproc_include_token1] = ACTIONS(1449),
    [aux_sym_preproc_def_token1] = ACTIONS(1449),
    [aux_sym_preproc_if_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1449),
    [sym_preproc_directive] = ACTIONS(1449),
    [anon_sym_LPAREN2] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_TILDE] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_subroutine] = ACTIONS(1449),
    [anon_sym_invariant] = ACTIONS(1449),
    [anon_sym_precise] = ACTIONS(1449),
    [anon_sym_in] = ACTIONS(1449),
    [anon_sym_out] = ACTIONS(1449),
    [anon_sym_inout] = ACTIONS(1449),
    [anon_sym_uniform] = ACTIONS(1449),
    [anon_sym_shared] = ACTIONS(1449),
    [anon_sym_attribute] = ACTIONS(1449),
    [anon_sym_varying] = ACTIONS(1449),
    [anon_sym_buffer] = ACTIONS(1449),
    [anon_sym_coherent] = ACTIONS(1449),
    [anon_sym_readonly] = ACTIONS(1449),
    [anon_sym_writeonly] = ACTIONS(1449),
    [anon_sym_precision] = ACTIONS(1449),
    [anon_sym_highp] = ACTIONS(1449),
    [anon_sym_mediump] = ACTIONS(1449),
    [anon_sym_lowp] = ACTIONS(1449),
    [anon_sym_centroid] = ACTIONS(1449),
    [anon_sym_sample] = ACTIONS(1449),
    [anon_sym_patch] = ACTIONS(1449),
    [anon_sym_smooth] = ACTIONS(1449),
    [anon_sym_flat] = ACTIONS(1449),
    [anon_sym_noperspective] = ACTIONS(1449),
    [anon_sym___extension__] = ACTIONS(1449),
    [anon_sym_typedef] = ACTIONS(1449),
    [anon_sym_extern] = ACTIONS(1449),
    [anon_sym___attribute__] = ACTIONS(1449),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1451),
    [anon_sym___declspec] = ACTIONS(1449),
    [anon_sym___cdecl] = ACTIONS(1449),
    [anon_sym___clrcall] = ACTIONS(1449),
    [anon_sym___stdcall] = ACTIONS(1449),
    [anon_sym___fastcall] = ACTIONS(1449),
    [anon_sym___thiscall] = ACTIONS(1449),
    [anon_sym___vectorcall] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_signed] = ACTIONS(1449),
    [anon_sym_unsigned] = ACTIONS(1449),
    [anon_sym_long] = ACTIONS(1449),
    [anon_sym_short] = ACTIONS(1449),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_auto] = ACTIONS(1449),
    [anon_sym_register] = ACTIONS(1449),
    [anon_sym_inline] = ACTIONS(1449),
    [anon_sym___inline] = ACTIONS(1449),
    [anon_sym___inline__] = ACTIONS(1449),
    [anon_sym___forceinline] = ACTIONS(1449),
    [anon_sym_thread_local] = ACTIONS(1449),
    [anon_sym___thread] = ACTIONS(1449),
    [anon_sym_const] = ACTIONS(1449),
    [anon_sym_constexpr] = ACTIONS(1449),
    [anon_sym_volatile] = ACTIONS(1449),
    [anon_sym_restrict] = ACTIONS(1449),
    [anon_sym___restrict__] = ACTIONS(1449),
    [anon_sym__Atomic] = ACTIONS(1449),
    [anon_sym__Noreturn] = ACTIONS(1449),
    [anon_sym_noreturn] = ACTIONS(1449),
    [anon_sym_alignas] = ACTIONS(1449),
    [anon_sym__Alignas] = ACTIONS(1449),
    [sym_primitive_type] = ACTIONS(1449),
    [anon_sym_enum] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1449),
    [anon_sym_union] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_switch] = ACTIONS(1449),
    [anon_sym_case] = ACTIONS(1449),
    [anon_sym_default] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_do] = ACTIONS(1449),
    [anon_sym_for] = ACTIONS(1449),
    [anon_sym_return] = ACTIONS(1449),
    [anon_sym_break] = ACTIONS(1449),
    [anon_sym_continue] = ACTIONS(1449),
    [anon_sym_goto] = ACTIONS(1449),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym___alignof__] = ACTIONS(1449),
    [anon_sym___alignof] = ACTIONS(1449),
    [anon_sym__alignof] = ACTIONS(1449),
    [anon_sym_alignof] = ACTIONS(1449),
    [anon_sym__Alignof] = ACTIONS(1449),
    [anon_sym_offsetof] = ACTIONS(1449),
    [anon_sym__Generic] = ACTIONS(1449),
    [anon_sym_asm] = ACTIONS(1449),
    [anon_sym___asm__] = ACTIONS(1449),
    [sym_number_literal] = ACTIONS(1451),
    [anon_sym_L_SQUOTE] = ACTIONS(1451),
    [anon_sym_u_SQUOTE] = ACTIONS(1451),
    [anon_sym_U_SQUOTE] = ACTIONS(1451),
    [anon_sym_u8_SQUOTE] = ACTIONS(1451),
    [anon_sym_SQUOTE] = ACTIONS(1451),
    [anon_sym_L_DQUOTE] = ACTIONS(1451),
    [anon_sym_u_DQUOTE] = ACTIONS(1451),
    [anon_sym_U_DQUOTE] = ACTIONS(1451),
    [anon_sym_u8_DQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [anon_sym_NULL] = ACTIONS(1449),
    [anon_sym_nullptr] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1449),
    [anon_sym_hitAttributeEXT] = ACTIONS(1449),
    [anon_sym_callableDataEXT] = ACTIONS(1449),
    [anon_sym_callableDataInEXT] = ACTIONS(1449),
    [anon_sym_shaderRecordEXT] = ACTIONS(1449),
    [anon_sym_rayPayloadNV] = ACTIONS(1449),
    [anon_sym_rayPayloadInNV] = ACTIONS(1449),
    [anon_sym_hitAttributeNV] = ACTIONS(1449),
    [anon_sym_callableDataNV] = ACTIONS(1449),
    [anon_sym_callableDataInNV] = ACTIONS(1449),
    [anon_sym_shaderRecordNV] = ACTIONS(1449),
    [anon_sym_layout] = ACTIONS(1449),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(1447),
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1445),
    [aux_sym_preproc_def_token1] = ACTIONS(1445),
    [aux_sym_preproc_if_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1445),
    [sym_preproc_directive] = ACTIONS(1445),
    [anon_sym_LPAREN2] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_TILDE] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_subroutine] = ACTIONS(1445),
    [anon_sym_invariant] = ACTIONS(1445),
    [anon_sym_precise] = ACTIONS(1445),
    [anon_sym_in] = ACTIONS(1445),
    [anon_sym_out] = ACTIONS(1445),
    [anon_sym_inout] = ACTIONS(1445),
    [anon_sym_uniform] = ACTIONS(1445),
    [anon_sym_shared] = ACTIONS(1445),
    [anon_sym_attribute] = ACTIONS(1445),
    [anon_sym_varying] = ACTIONS(1445),
    [anon_sym_buffer] = ACTIONS(1445),
    [anon_sym_coherent] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_writeonly] = ACTIONS(1445),
    [anon_sym_precision] = ACTIONS(1445),
    [anon_sym_highp] = ACTIONS(1445),
    [anon_sym_mediump] = ACTIONS(1445),
    [anon_sym_lowp] = ACTIONS(1445),
    [anon_sym_centroid] = ACTIONS(1445),
    [anon_sym_sample] = ACTIONS(1445),
    [anon_sym_patch] = ACTIONS(1445),
    [anon_sym_smooth] = ACTIONS(1445),
    [anon_sym_flat] = ACTIONS(1445),
    [anon_sym_noperspective] = ACTIONS(1445),
    [anon_sym___extension__] = ACTIONS(1445),
    [anon_sym_typedef] = ACTIONS(1445),
    [anon_sym_extern] = ACTIONS(1445),
    [anon_sym___attribute__] = ACTIONS(1445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1447),
    [anon_sym___declspec] = ACTIONS(1445),
    [anon_sym___cdecl] = ACTIONS(1445),
    [anon_sym___clrcall] = ACTIONS(1445),
    [anon_sym___stdcall] = ACTIONS(1445),
    [anon_sym___fastcall] = ACTIONS(1445),
    [anon_sym___thiscall] = ACTIONS(1445),
    [anon_sym___vectorcall] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_signed] = ACTIONS(1445),
    [anon_sym_unsigned] = ACTIONS(1445),
    [anon_sym_long] = ACTIONS(1445),
    [anon_sym_short] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_auto] = ACTIONS(1445),
    [anon_sym_register] = ACTIONS(1445),
    [anon_sym_inline] = ACTIONS(1445),
    [anon_sym___inline] = ACTIONS(1445),
    [anon_sym___inline__] = ACTIONS(1445),
    [anon_sym___forceinline] = ACTIONS(1445),
    [anon_sym_thread_local] = ACTIONS(1445),
    [anon_sym___thread] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(1445),
    [anon_sym_constexpr] = ACTIONS(1445),
    [anon_sym_volatile] = ACTIONS(1445),
    [anon_sym_restrict] = ACTIONS(1445),
    [anon_sym___restrict__] = ACTIONS(1445),
    [anon_sym__Atomic] = ACTIONS(1445),
    [anon_sym__Noreturn] = ACTIONS(1445),
    [anon_sym_noreturn] = ACTIONS(1445),
    [anon_sym_alignas] = ACTIONS(1445),
    [anon_sym__Alignas] = ACTIONS(1445),
    [sym_primitive_type] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1445),
    [anon_sym_union] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1445),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_continue] = ACTIONS(1445),
    [anon_sym_goto] = ACTIONS(1445),
    [anon_sym_DASH_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1445),
    [anon_sym___alignof__] = ACTIONS(1445),
    [anon_sym___alignof] = ACTIONS(1445),
    [anon_sym__alignof] = ACTIONS(1445),
    [anon_sym_alignof] = ACTIONS(1445),
    [anon_sym__Alignof] = ACTIONS(1445),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1445),
    [anon_sym_asm] = ACTIONS(1445),
    [anon_sym___asm__] = ACTIONS(1445),
    [sym_number_literal] = ACTIONS(1447),
    [anon_sym_L_SQUOTE] = ACTIONS(1447),
    [anon_sym_u_SQUOTE] = ACTIONS(1447),
    [anon_sym_U_SQUOTE] = ACTIONS(1447),
    [anon_sym_u8_SQUOTE] = ACTIONS(1447),
    [anon_sym_SQUOTE] = ACTIONS(1447),
    [anon_sym_L_DQUOTE] = ACTIONS(1447),
    [anon_sym_u_DQUOTE] = ACTIONS(1447),
    [anon_sym_U_DQUOTE] = ACTIONS(1447),
    [anon_sym_u8_DQUOTE] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1447),
    [sym_true] = ACTIONS(1445),
    [sym_false] = ACTIONS(1445),
    [anon_sym_NULL] = ACTIONS(1445),
    [anon_sym_nullptr] = ACTIONS(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1445),
    [anon_sym_hitAttributeEXT] = ACTIONS(1445),
    [anon_sym_callableDataEXT] = ACTIONS(1445),
    [anon_sym_callableDataInEXT] = ACTIONS(1445),
    [anon_sym_shaderRecordEXT] = ACTIONS(1445),
    [anon_sym_rayPayloadNV] = ACTIONS(1445),
    [anon_sym_rayPayloadInNV] = ACTIONS(1445),
    [anon_sym_hitAttributeNV] = ACTIONS(1445),
    [anon_sym_callableDataNV] = ACTIONS(1445),
    [anon_sym_callableDataInNV] = ACTIONS(1445),
    [anon_sym_shaderRecordNV] = ACTIONS(1445),
    [anon_sym_layout] = ACTIONS(1445),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1413),
    [aux_sym_preproc_include_token1] = ACTIONS(1413),
    [aux_sym_preproc_def_token1] = ACTIONS(1413),
    [aux_sym_preproc_if_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1413),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1413),
    [sym_preproc_directive] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_subroutine] = ACTIONS(1413),
    [anon_sym_invariant] = ACTIONS(1413),
    [anon_sym_precise] = ACTIONS(1413),
    [anon_sym_in] = ACTIONS(1413),
    [anon_sym_out] = ACTIONS(1413),
    [anon_sym_inout] = ACTIONS(1413),
    [anon_sym_uniform] = ACTIONS(1413),
    [anon_sym_shared] = ACTIONS(1413),
    [anon_sym_attribute] = ACTIONS(1413),
    [anon_sym_varying] = ACTIONS(1413),
    [anon_sym_buffer] = ACTIONS(1413),
    [anon_sym_coherent] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(1413),
    [anon_sym_writeonly] = ACTIONS(1413),
    [anon_sym_precision] = ACTIONS(1413),
    [anon_sym_highp] = ACTIONS(1413),
    [anon_sym_mediump] = ACTIONS(1413),
    [anon_sym_lowp] = ACTIONS(1413),
    [anon_sym_centroid] = ACTIONS(1413),
    [anon_sym_sample] = ACTIONS(1413),
    [anon_sym_patch] = ACTIONS(1413),
    [anon_sym_smooth] = ACTIONS(1413),
    [anon_sym_flat] = ACTIONS(1413),
    [anon_sym_noperspective] = ACTIONS(1413),
    [anon_sym___extension__] = ACTIONS(1413),
    [anon_sym_typedef] = ACTIONS(1413),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym___attribute__] = ACTIONS(1413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1415),
    [anon_sym___declspec] = ACTIONS(1413),
    [anon_sym___cdecl] = ACTIONS(1413),
    [anon_sym___clrcall] = ACTIONS(1413),
    [anon_sym___stdcall] = ACTIONS(1413),
    [anon_sym___fastcall] = ACTIONS(1413),
    [anon_sym___thiscall] = ACTIONS(1413),
    [anon_sym___vectorcall] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_signed] = ACTIONS(1413),
    [anon_sym_unsigned] = ACTIONS(1413),
    [anon_sym_long] = ACTIONS(1413),
    [anon_sym_short] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_auto] = ACTIONS(1413),
    [anon_sym_register] = ACTIONS(1413),
    [anon_sym_inline] = ACTIONS(1413),
    [anon_sym___inline] = ACTIONS(1413),
    [anon_sym___inline__] = ACTIONS(1413),
    [anon_sym___forceinline] = ACTIONS(1413),
    [anon_sym_thread_local] = ACTIONS(1413),
    [anon_sym___thread] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_constexpr] = ACTIONS(1413),
    [anon_sym_volatile] = ACTIONS(1413),
    [anon_sym_restrict] = ACTIONS(1413),
    [anon_sym___restrict__] = ACTIONS(1413),
    [anon_sym__Atomic] = ACTIONS(1413),
    [anon_sym__Noreturn] = ACTIONS(1413),
    [anon_sym_noreturn] = ACTIONS(1413),
    [anon_sym_alignas] = ACTIONS(1413),
    [anon_sym__Alignas] = ACTIONS(1413),
    [sym_primitive_type] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1413),
    [anon_sym_case] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_do] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_goto] = ACTIONS(1413),
    [anon_sym_DASH_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1415),
    [anon_sym_sizeof] = ACTIONS(1413),
    [anon_sym___alignof__] = ACTIONS(1413),
    [anon_sym___alignof] = ACTIONS(1413),
    [anon_sym__alignof] = ACTIONS(1413),
    [anon_sym_alignof] = ACTIONS(1413),
    [anon_sym__Alignof] = ACTIONS(1413),
    [anon_sym_offsetof] = ACTIONS(1413),
    [anon_sym__Generic] = ACTIONS(1413),
    [anon_sym_asm] = ACTIONS(1413),
    [anon_sym___asm__] = ACTIONS(1413),
    [sym_number_literal] = ACTIONS(1415),
    [anon_sym_L_SQUOTE] = ACTIONS(1415),
    [anon_sym_u_SQUOTE] = ACTIONS(1415),
    [anon_sym_U_SQUOTE] = ACTIONS(1415),
    [anon_sym_u8_SQUOTE] = ACTIONS(1415),
    [anon_sym_SQUOTE] = ACTIONS(1415),
    [anon_sym_L_DQUOTE] = ACTIONS(1415),
    [anon_sym_u_DQUOTE] = ACTIONS(1415),
    [anon_sym_U_DQUOTE] = ACTIONS(1415),
    [anon_sym_u8_DQUOTE] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1415),
    [sym_true] = ACTIONS(1413),
    [sym_false] = ACTIONS(1413),
    [anon_sym_NULL] = ACTIONS(1413),
    [anon_sym_nullptr] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1413),
    [anon_sym_hitAttributeEXT] = ACTIONS(1413),
    [anon_sym_callableDataEXT] = ACTIONS(1413),
    [anon_sym_callableDataInEXT] = ACTIONS(1413),
    [anon_sym_shaderRecordEXT] = ACTIONS(1413),
    [anon_sym_rayPayloadNV] = ACTIONS(1413),
    [anon_sym_rayPayloadInNV] = ACTIONS(1413),
    [anon_sym_hitAttributeNV] = ACTIONS(1413),
    [anon_sym_callableDataNV] = ACTIONS(1413),
    [anon_sym_callableDataInNV] = ACTIONS(1413),
    [anon_sym_shaderRecordNV] = ACTIONS(1413),
    [anon_sym_layout] = ACTIONS(1413),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1507),
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(1545),
    [sym_identifier] = ACTIONS(1548),
    [aux_sym_preproc_include_token1] = ACTIONS(1548),
    [aux_sym_preproc_def_token1] = ACTIONS(1548),
    [aux_sym_preproc_if_token1] = ACTIONS(1548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1548),
    [sym_preproc_directive] = ACTIONS(1548),
    [anon_sym_LPAREN2] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_subroutine] = ACTIONS(1548),
    [anon_sym_invariant] = ACTIONS(1548),
    [anon_sym_precise] = ACTIONS(1548),
    [anon_sym_in] = ACTIONS(1548),
    [anon_sym_out] = ACTIONS(1548),
    [anon_sym_inout] = ACTIONS(1548),
    [anon_sym_uniform] = ACTIONS(1548),
    [anon_sym_shared] = ACTIONS(1548),
    [anon_sym_attribute] = ACTIONS(1548),
    [anon_sym_varying] = ACTIONS(1548),
    [anon_sym_buffer] = ACTIONS(1548),
    [anon_sym_coherent] = ACTIONS(1548),
    [anon_sym_readonly] = ACTIONS(1548),
    [anon_sym_writeonly] = ACTIONS(1548),
    [anon_sym_precision] = ACTIONS(1548),
    [anon_sym_highp] = ACTIONS(1548),
    [anon_sym_mediump] = ACTIONS(1548),
    [anon_sym_lowp] = ACTIONS(1548),
    [anon_sym_centroid] = ACTIONS(1548),
    [anon_sym_sample] = ACTIONS(1548),
    [anon_sym_patch] = ACTIONS(1548),
    [anon_sym_smooth] = ACTIONS(1548),
    [anon_sym_flat] = ACTIONS(1548),
    [anon_sym_noperspective] = ACTIONS(1548),
    [anon_sym___extension__] = ACTIONS(1548),
    [anon_sym_typedef] = ACTIONS(1548),
    [anon_sym_extern] = ACTIONS(1548),
    [anon_sym___attribute__] = ACTIONS(1548),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1545),
    [anon_sym___declspec] = ACTIONS(1548),
    [anon_sym___cdecl] = ACTIONS(1548),
    [anon_sym___clrcall] = ACTIONS(1548),
    [anon_sym___stdcall] = ACTIONS(1548),
    [anon_sym___fastcall] = ACTIONS(1548),
    [anon_sym___thiscall] = ACTIONS(1548),
    [anon_sym___vectorcall] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_signed] = ACTIONS(1548),
    [anon_sym_unsigned] = ACTIONS(1548),
    [anon_sym_long] = ACTIONS(1548),
    [anon_sym_short] = ACTIONS(1548),
    [anon_sym_static] = ACTIONS(1548),
    [anon_sym_auto] = ACTIONS(1548),
    [anon_sym_register] = ACTIONS(1548),
    [anon_sym_inline] = ACTIONS(1548),
    [anon_sym___inline] = ACTIONS(1548),
    [anon_sym___inline__] = ACTIONS(1548),
    [anon_sym___forceinline] = ACTIONS(1548),
    [anon_sym_thread_local] = ACTIONS(1548),
    [anon_sym___thread] = ACTIONS(1548),
    [anon_sym_const] = ACTIONS(1548),
    [anon_sym_constexpr] = ACTIONS(1548),
    [anon_sym_volatile] = ACTIONS(1548),
    [anon_sym_restrict] = ACTIONS(1548),
    [anon_sym___restrict__] = ACTIONS(1548),
    [anon_sym__Atomic] = ACTIONS(1548),
    [anon_sym__Noreturn] = ACTIONS(1548),
    [anon_sym_noreturn] = ACTIONS(1548),
    [anon_sym_alignas] = ACTIONS(1548),
    [anon_sym__Alignas] = ACTIONS(1548),
    [sym_primitive_type] = ACTIONS(1548),
    [anon_sym_enum] = ACTIONS(1548),
    [anon_sym_struct] = ACTIONS(1548),
    [anon_sym_union] = ACTIONS(1548),
    [anon_sym_if] = ACTIONS(1548),
    [anon_sym_switch] = ACTIONS(1548),
    [anon_sym_case] = ACTIONS(1548),
    [anon_sym_default] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1548),
    [anon_sym_do] = ACTIONS(1548),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1548),
    [anon_sym_break] = ACTIONS(1548),
    [anon_sym_continue] = ACTIONS(1548),
    [anon_sym_goto] = ACTIONS(1548),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_sizeof] = ACTIONS(1548),
    [anon_sym___alignof__] = ACTIONS(1548),
    [anon_sym___alignof] = ACTIONS(1548),
    [anon_sym__alignof] = ACTIONS(1548),
    [anon_sym_alignof] = ACTIONS(1548),
    [anon_sym__Alignof] = ACTIONS(1548),
    [anon_sym_offsetof] = ACTIONS(1548),
    [anon_sym__Generic] = ACTIONS(1548),
    [anon_sym_asm] = ACTIONS(1548),
    [anon_sym___asm__] = ACTIONS(1548),
    [sym_number_literal] = ACTIONS(1545),
    [anon_sym_L_SQUOTE] = ACTIONS(1545),
    [anon_sym_u_SQUOTE] = ACTIONS(1545),
    [anon_sym_U_SQUOTE] = ACTIONS(1545),
    [anon_sym_u8_SQUOTE] = ACTIONS(1545),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [anon_sym_L_DQUOTE] = ACTIONS(1545),
    [anon_sym_u_DQUOTE] = ACTIONS(1545),
    [anon_sym_U_DQUOTE] = ACTIONS(1545),
    [anon_sym_u8_DQUOTE] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [anon_sym_NULL] = ACTIONS(1548),
    [anon_sym_nullptr] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1548),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1548),
    [anon_sym_hitAttributeEXT] = ACTIONS(1548),
    [anon_sym_callableDataEXT] = ACTIONS(1548),
    [anon_sym_callableDataInEXT] = ACTIONS(1548),
    [anon_sym_shaderRecordEXT] = ACTIONS(1548),
    [anon_sym_rayPayloadNV] = ACTIONS(1548),
    [anon_sym_rayPayloadInNV] = ACTIONS(1548),
    [anon_sym_hitAttributeNV] = ACTIONS(1548),
    [anon_sym_callableDataNV] = ACTIONS(1548),
    [anon_sym_callableDataInNV] = ACTIONS(1548),
    [anon_sym_shaderRecordNV] = ACTIONS(1548),
    [anon_sym_layout] = ACTIONS(1548),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1553),
    [aux_sym_preproc_include_token1] = ACTIONS(1553),
    [aux_sym_preproc_def_token1] = ACTIONS(1553),
    [aux_sym_preproc_if_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1553),
    [sym_preproc_directive] = ACTIONS(1553),
    [anon_sym_LPAREN2] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1551),
    [anon_sym_AMP] = ACTIONS(1551),
    [anon_sym_subroutine] = ACTIONS(1553),
    [anon_sym_invariant] = ACTIONS(1553),
    [anon_sym_precise] = ACTIONS(1553),
    [anon_sym_in] = ACTIONS(1553),
    [anon_sym_out] = ACTIONS(1553),
    [anon_sym_inout] = ACTIONS(1553),
    [anon_sym_uniform] = ACTIONS(1553),
    [anon_sym_shared] = ACTIONS(1553),
    [anon_sym_attribute] = ACTIONS(1553),
    [anon_sym_varying] = ACTIONS(1553),
    [anon_sym_buffer] = ACTIONS(1553),
    [anon_sym_coherent] = ACTIONS(1553),
    [anon_sym_readonly] = ACTIONS(1553),
    [anon_sym_writeonly] = ACTIONS(1553),
    [anon_sym_precision] = ACTIONS(1553),
    [anon_sym_highp] = ACTIONS(1553),
    [anon_sym_mediump] = ACTIONS(1553),
    [anon_sym_lowp] = ACTIONS(1553),
    [anon_sym_centroid] = ACTIONS(1553),
    [anon_sym_sample] = ACTIONS(1553),
    [anon_sym_patch] = ACTIONS(1553),
    [anon_sym_smooth] = ACTIONS(1553),
    [anon_sym_flat] = ACTIONS(1553),
    [anon_sym_noperspective] = ACTIONS(1553),
    [anon_sym___extension__] = ACTIONS(1553),
    [anon_sym_typedef] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1553),
    [anon_sym___attribute__] = ACTIONS(1553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1551),
    [anon_sym___declspec] = ACTIONS(1553),
    [anon_sym___cdecl] = ACTIONS(1553),
    [anon_sym___clrcall] = ACTIONS(1553),
    [anon_sym___stdcall] = ACTIONS(1553),
    [anon_sym___fastcall] = ACTIONS(1553),
    [anon_sym___thiscall] = ACTIONS(1553),
    [anon_sym___vectorcall] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_signed] = ACTIONS(1553),
    [anon_sym_unsigned] = ACTIONS(1553),
    [anon_sym_long] = ACTIONS(1553),
    [anon_sym_short] = ACTIONS(1553),
    [anon_sym_static] = ACTIONS(1553),
    [anon_sym_auto] = ACTIONS(1553),
    [anon_sym_register] = ACTIONS(1553),
    [anon_sym_inline] = ACTIONS(1553),
    [anon_sym___inline] = ACTIONS(1553),
    [anon_sym___inline__] = ACTIONS(1553),
    [anon_sym___forceinline] = ACTIONS(1553),
    [anon_sym_thread_local] = ACTIONS(1553),
    [anon_sym___thread] = ACTIONS(1553),
    [anon_sym_const] = ACTIONS(1553),
    [anon_sym_constexpr] = ACTIONS(1553),
    [anon_sym_volatile] = ACTIONS(1553),
    [anon_sym_restrict] = ACTIONS(1553),
    [anon_sym___restrict__] = ACTIONS(1553),
    [anon_sym__Atomic] = ACTIONS(1553),
    [anon_sym__Noreturn] = ACTIONS(1553),
    [anon_sym_noreturn] = ACTIONS(1553),
    [anon_sym_alignas] = ACTIONS(1553),
    [anon_sym__Alignas] = ACTIONS(1553),
    [sym_primitive_type] = ACTIONS(1553),
    [anon_sym_enum] = ACTIONS(1553),
    [anon_sym_struct] = ACTIONS(1553),
    [anon_sym_union] = ACTIONS(1553),
    [anon_sym_if] = ACTIONS(1553),
    [anon_sym_switch] = ACTIONS(1553),
    [anon_sym_case] = ACTIONS(1553),
    [anon_sym_default] = ACTIONS(1553),
    [anon_sym_while] = ACTIONS(1553),
    [anon_sym_do] = ACTIONS(1553),
    [anon_sym_for] = ACTIONS(1553),
    [anon_sym_return] = ACTIONS(1553),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_continue] = ACTIONS(1553),
    [anon_sym_goto] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1553),
    [anon_sym___alignof__] = ACTIONS(1553),
    [anon_sym___alignof] = ACTIONS(1553),
    [anon_sym__alignof] = ACTIONS(1553),
    [anon_sym_alignof] = ACTIONS(1553),
    [anon_sym__Alignof] = ACTIONS(1553),
    [anon_sym_offsetof] = ACTIONS(1553),
    [anon_sym__Generic] = ACTIONS(1553),
    [anon_sym_asm] = ACTIONS(1553),
    [anon_sym___asm__] = ACTIONS(1553),
    [sym_number_literal] = ACTIONS(1551),
    [anon_sym_L_SQUOTE] = ACTIONS(1551),
    [anon_sym_u_SQUOTE] = ACTIONS(1551),
    [anon_sym_U_SQUOTE] = ACTIONS(1551),
    [anon_sym_u8_SQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_L_DQUOTE] = ACTIONS(1551),
    [anon_sym_u_DQUOTE] = ACTIONS(1551),
    [anon_sym_U_DQUOTE] = ACTIONS(1551),
    [anon_sym_u8_DQUOTE] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [anon_sym_NULL] = ACTIONS(1553),
    [anon_sym_nullptr] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1553),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1553),
    [anon_sym_hitAttributeEXT] = ACTIONS(1553),
    [anon_sym_callableDataEXT] = ACTIONS(1553),
    [anon_sym_callableDataInEXT] = ACTIONS(1553),
    [anon_sym_shaderRecordEXT] = ACTIONS(1553),
    [anon_sym_rayPayloadNV] = ACTIONS(1553),
    [anon_sym_rayPayloadInNV] = ACTIONS(1553),
    [anon_sym_hitAttributeNV] = ACTIONS(1553),
    [anon_sym_callableDataNV] = ACTIONS(1553),
    [anon_sym_callableDataInNV] = ACTIONS(1553),
    [anon_sym_shaderRecordNV] = ACTIONS(1553),
    [anon_sym_layout] = ACTIONS(1553),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1473),
    [aux_sym_preproc_include_token1] = ACTIONS(1473),
    [aux_sym_preproc_def_token1] = ACTIONS(1473),
    [aux_sym_preproc_if_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1473),
    [sym_preproc_directive] = ACTIONS(1473),
    [anon_sym_LPAREN2] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_subroutine] = ACTIONS(1473),
    [anon_sym_invariant] = ACTIONS(1473),
    [anon_sym_precise] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_out] = ACTIONS(1473),
    [anon_sym_inout] = ACTIONS(1473),
    [anon_sym_uniform] = ACTIONS(1473),
    [anon_sym_shared] = ACTIONS(1473),
    [anon_sym_attribute] = ACTIONS(1473),
    [anon_sym_varying] = ACTIONS(1473),
    [anon_sym_buffer] = ACTIONS(1473),
    [anon_sym_coherent] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_writeonly] = ACTIONS(1473),
    [anon_sym_precision] = ACTIONS(1473),
    [anon_sym_highp] = ACTIONS(1473),
    [anon_sym_mediump] = ACTIONS(1473),
    [anon_sym_lowp] = ACTIONS(1473),
    [anon_sym_centroid] = ACTIONS(1473),
    [anon_sym_sample] = ACTIONS(1473),
    [anon_sym_patch] = ACTIONS(1473),
    [anon_sym_smooth] = ACTIONS(1473),
    [anon_sym_flat] = ACTIONS(1473),
    [anon_sym_noperspective] = ACTIONS(1473),
    [anon_sym___extension__] = ACTIONS(1473),
    [anon_sym_typedef] = ACTIONS(1473),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym___attribute__] = ACTIONS(1473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1475),
    [anon_sym___declspec] = ACTIONS(1473),
    [anon_sym___cdecl] = ACTIONS(1473),
    [anon_sym___clrcall] = ACTIONS(1473),
    [anon_sym___stdcall] = ACTIONS(1473),
    [anon_sym___fastcall] = ACTIONS(1473),
    [anon_sym___thiscall] = ACTIONS(1473),
    [anon_sym___vectorcall] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_signed] = ACTIONS(1473),
    [anon_sym_unsigned] = ACTIONS(1473),
    [anon_sym_long] = ACTIONS(1473),
    [anon_sym_short] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_auto] = ACTIONS(1473),
    [anon_sym_register] = ACTIONS(1473),
    [anon_sym_inline] = ACTIONS(1473),
    [anon_sym___inline] = ACTIONS(1473),
    [anon_sym___inline__] = ACTIONS(1473),
    [anon_sym___forceinline] = ACTIONS(1473),
    [anon_sym_thread_local] = ACTIONS(1473),
    [anon_sym___thread] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_constexpr] = ACTIONS(1473),
    [anon_sym_volatile] = ACTIONS(1473),
    [anon_sym_restrict] = ACTIONS(1473),
    [anon_sym___restrict__] = ACTIONS(1473),
    [anon_sym__Atomic] = ACTIONS(1473),
    [anon_sym__Noreturn] = ACTIONS(1473),
    [anon_sym_noreturn] = ACTIONS(1473),
    [anon_sym_alignas] = ACTIONS(1473),
    [anon_sym__Alignas] = ACTIONS(1473),
    [sym_primitive_type] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_goto] = ACTIONS(1473),
    [anon_sym_DASH_DASH] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1475),
    [anon_sym_sizeof] = ACTIONS(1473),
    [anon_sym___alignof__] = ACTIONS(1473),
    [anon_sym___alignof] = ACTIONS(1473),
    [anon_sym__alignof] = ACTIONS(1473),
    [anon_sym_alignof] = ACTIONS(1473),
    [anon_sym__Alignof] = ACTIONS(1473),
    [anon_sym_offsetof] = ACTIONS(1473),
    [anon_sym__Generic] = ACTIONS(1473),
    [anon_sym_asm] = ACTIONS(1473),
    [anon_sym___asm__] = ACTIONS(1473),
    [sym_number_literal] = ACTIONS(1475),
    [anon_sym_L_SQUOTE] = ACTIONS(1475),
    [anon_sym_u_SQUOTE] = ACTIONS(1475),
    [anon_sym_U_SQUOTE] = ACTIONS(1475),
    [anon_sym_u8_SQUOTE] = ACTIONS(1475),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_L_DQUOTE] = ACTIONS(1475),
    [anon_sym_u_DQUOTE] = ACTIONS(1475),
    [anon_sym_U_DQUOTE] = ACTIONS(1475),
    [anon_sym_u8_DQUOTE] = ACTIONS(1475),
    [anon_sym_DQUOTE] = ACTIONS(1475),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [anon_sym_NULL] = ACTIONS(1473),
    [anon_sym_nullptr] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1473),
    [anon_sym_hitAttributeEXT] = ACTIONS(1473),
    [anon_sym_callableDataEXT] = ACTIONS(1473),
    [anon_sym_callableDataInEXT] = ACTIONS(1473),
    [anon_sym_shaderRecordEXT] = ACTIONS(1473),
    [anon_sym_rayPayloadNV] = ACTIONS(1473),
    [anon_sym_rayPayloadInNV] = ACTIONS(1473),
    [anon_sym_hitAttributeNV] = ACTIONS(1473),
    [anon_sym_callableDataNV] = ACTIONS(1473),
    [anon_sym_callableDataInNV] = ACTIONS(1473),
    [anon_sym_shaderRecordNV] = ACTIONS(1473),
    [anon_sym_layout] = ACTIONS(1473),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1469),
    [aux_sym_preproc_include_token1] = ACTIONS(1469),
    [aux_sym_preproc_def_token1] = ACTIONS(1469),
    [aux_sym_preproc_if_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1469),
    [sym_preproc_directive] = ACTIONS(1469),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1469),
    [anon_sym_PLUS] = ACTIONS(1469),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_subroutine] = ACTIONS(1469),
    [anon_sym_invariant] = ACTIONS(1469),
    [anon_sym_precise] = ACTIONS(1469),
    [anon_sym_in] = ACTIONS(1469),
    [anon_sym_out] = ACTIONS(1469),
    [anon_sym_inout] = ACTIONS(1469),
    [anon_sym_uniform] = ACTIONS(1469),
    [anon_sym_shared] = ACTIONS(1469),
    [anon_sym_attribute] = ACTIONS(1469),
    [anon_sym_varying] = ACTIONS(1469),
    [anon_sym_buffer] = ACTIONS(1469),
    [anon_sym_coherent] = ACTIONS(1469),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_writeonly] = ACTIONS(1469),
    [anon_sym_precision] = ACTIONS(1469),
    [anon_sym_highp] = ACTIONS(1469),
    [anon_sym_mediump] = ACTIONS(1469),
    [anon_sym_lowp] = ACTIONS(1469),
    [anon_sym_centroid] = ACTIONS(1469),
    [anon_sym_sample] = ACTIONS(1469),
    [anon_sym_patch] = ACTIONS(1469),
    [anon_sym_smooth] = ACTIONS(1469),
    [anon_sym_flat] = ACTIONS(1469),
    [anon_sym_noperspective] = ACTIONS(1469),
    [anon_sym___extension__] = ACTIONS(1469),
    [anon_sym_typedef] = ACTIONS(1469),
    [anon_sym_extern] = ACTIONS(1469),
    [anon_sym___attribute__] = ACTIONS(1469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1471),
    [anon_sym___declspec] = ACTIONS(1469),
    [anon_sym___cdecl] = ACTIONS(1469),
    [anon_sym___clrcall] = ACTIONS(1469),
    [anon_sym___stdcall] = ACTIONS(1469),
    [anon_sym___fastcall] = ACTIONS(1469),
    [anon_sym___thiscall] = ACTIONS(1469),
    [anon_sym___vectorcall] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_signed] = ACTIONS(1469),
    [anon_sym_unsigned] = ACTIONS(1469),
    [anon_sym_long] = ACTIONS(1469),
    [anon_sym_short] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_auto] = ACTIONS(1469),
    [anon_sym_register] = ACTIONS(1469),
    [anon_sym_inline] = ACTIONS(1469),
    [anon_sym___inline] = ACTIONS(1469),
    [anon_sym___inline__] = ACTIONS(1469),
    [anon_sym___forceinline] = ACTIONS(1469),
    [anon_sym_thread_local] = ACTIONS(1469),
    [anon_sym___thread] = ACTIONS(1469),
    [anon_sym_const] = ACTIONS(1469),
    [anon_sym_constexpr] = ACTIONS(1469),
    [anon_sym_volatile] = ACTIONS(1469),
    [anon_sym_restrict] = ACTIONS(1469),
    [anon_sym___restrict__] = ACTIONS(1469),
    [anon_sym__Atomic] = ACTIONS(1469),
    [anon_sym__Noreturn] = ACTIONS(1469),
    [anon_sym_noreturn] = ACTIONS(1469),
    [anon_sym_alignas] = ACTIONS(1469),
    [anon_sym__Alignas] = ACTIONS(1469),
    [sym_primitive_type] = ACTIONS(1469),
    [anon_sym_enum] = ACTIONS(1469),
    [anon_sym_struct] = ACTIONS(1469),
    [anon_sym_union] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_switch] = ACTIONS(1469),
    [anon_sym_case] = ACTIONS(1469),
    [anon_sym_default] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_do] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1469),
    [anon_sym_break] = ACTIONS(1469),
    [anon_sym_continue] = ACTIONS(1469),
    [anon_sym_goto] = ACTIONS(1469),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_sizeof] = ACTIONS(1469),
    [anon_sym___alignof__] = ACTIONS(1469),
    [anon_sym___alignof] = ACTIONS(1469),
    [anon_sym__alignof] = ACTIONS(1469),
    [anon_sym_alignof] = ACTIONS(1469),
    [anon_sym__Alignof] = ACTIONS(1469),
    [anon_sym_offsetof] = ACTIONS(1469),
    [anon_sym__Generic] = ACTIONS(1469),
    [anon_sym_asm] = ACTIONS(1469),
    [anon_sym___asm__] = ACTIONS(1469),
    [sym_number_literal] = ACTIONS(1471),
    [anon_sym_L_SQUOTE] = ACTIONS(1471),
    [anon_sym_u_SQUOTE] = ACTIONS(1471),
    [anon_sym_U_SQUOTE] = ACTIONS(1471),
    [anon_sym_u8_SQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [anon_sym_L_DQUOTE] = ACTIONS(1471),
    [anon_sym_u_DQUOTE] = ACTIONS(1471),
    [anon_sym_U_DQUOTE] = ACTIONS(1471),
    [anon_sym_u8_DQUOTE] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [anon_sym_NULL] = ACTIONS(1469),
    [anon_sym_nullptr] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1469),
    [anon_sym_hitAttributeEXT] = ACTIONS(1469),
    [anon_sym_callableDataEXT] = ACTIONS(1469),
    [anon_sym_callableDataInEXT] = ACTIONS(1469),
    [anon_sym_shaderRecordEXT] = ACTIONS(1469),
    [anon_sym_rayPayloadNV] = ACTIONS(1469),
    [anon_sym_rayPayloadInNV] = ACTIONS(1469),
    [anon_sym_hitAttributeNV] = ACTIONS(1469),
    [anon_sym_callableDataNV] = ACTIONS(1469),
    [anon_sym_callableDataInNV] = ACTIONS(1469),
    [anon_sym_shaderRecordNV] = ACTIONS(1469),
    [anon_sym_layout] = ACTIONS(1469),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1461),
    [aux_sym_preproc_include_token1] = ACTIONS(1461),
    [aux_sym_preproc_def_token1] = ACTIONS(1461),
    [aux_sym_preproc_if_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1461),
    [sym_preproc_directive] = ACTIONS(1461),
    [anon_sym_LPAREN2] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_TILDE] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_subroutine] = ACTIONS(1461),
    [anon_sym_invariant] = ACTIONS(1461),
    [anon_sym_precise] = ACTIONS(1461),
    [anon_sym_in] = ACTIONS(1461),
    [anon_sym_out] = ACTIONS(1461),
    [anon_sym_inout] = ACTIONS(1461),
    [anon_sym_uniform] = ACTIONS(1461),
    [anon_sym_shared] = ACTIONS(1461),
    [anon_sym_attribute] = ACTIONS(1461),
    [anon_sym_varying] = ACTIONS(1461),
    [anon_sym_buffer] = ACTIONS(1461),
    [anon_sym_coherent] = ACTIONS(1461),
    [anon_sym_readonly] = ACTIONS(1461),
    [anon_sym_writeonly] = ACTIONS(1461),
    [anon_sym_precision] = ACTIONS(1461),
    [anon_sym_highp] = ACTIONS(1461),
    [anon_sym_mediump] = ACTIONS(1461),
    [anon_sym_lowp] = ACTIONS(1461),
    [anon_sym_centroid] = ACTIONS(1461),
    [anon_sym_sample] = ACTIONS(1461),
    [anon_sym_patch] = ACTIONS(1461),
    [anon_sym_smooth] = ACTIONS(1461),
    [anon_sym_flat] = ACTIONS(1461),
    [anon_sym_noperspective] = ACTIONS(1461),
    [anon_sym___extension__] = ACTIONS(1461),
    [anon_sym_typedef] = ACTIONS(1461),
    [anon_sym_extern] = ACTIONS(1461),
    [anon_sym___attribute__] = ACTIONS(1461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1463),
    [anon_sym___declspec] = ACTIONS(1461),
    [anon_sym___cdecl] = ACTIONS(1461),
    [anon_sym___clrcall] = ACTIONS(1461),
    [anon_sym___stdcall] = ACTIONS(1461),
    [anon_sym___fastcall] = ACTIONS(1461),
    [anon_sym___thiscall] = ACTIONS(1461),
    [anon_sym___vectorcall] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_signed] = ACTIONS(1461),
    [anon_sym_unsigned] = ACTIONS(1461),
    [anon_sym_long] = ACTIONS(1461),
    [anon_sym_short] = ACTIONS(1461),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_auto] = ACTIONS(1461),
    [anon_sym_register] = ACTIONS(1461),
    [anon_sym_inline] = ACTIONS(1461),
    [anon_sym___inline] = ACTIONS(1461),
    [anon_sym___inline__] = ACTIONS(1461),
    [anon_sym___forceinline] = ACTIONS(1461),
    [anon_sym_thread_local] = ACTIONS(1461),
    [anon_sym___thread] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_constexpr] = ACTIONS(1461),
    [anon_sym_volatile] = ACTIONS(1461),
    [anon_sym_restrict] = ACTIONS(1461),
    [anon_sym___restrict__] = ACTIONS(1461),
    [anon_sym__Atomic] = ACTIONS(1461),
    [anon_sym__Noreturn] = ACTIONS(1461),
    [anon_sym_noreturn] = ACTIONS(1461),
    [anon_sym_alignas] = ACTIONS(1461),
    [anon_sym__Alignas] = ACTIONS(1461),
    [sym_primitive_type] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_union] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1461),
    [anon_sym_case] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_do] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_goto] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_sizeof] = ACTIONS(1461),
    [anon_sym___alignof__] = ACTIONS(1461),
    [anon_sym___alignof] = ACTIONS(1461),
    [anon_sym__alignof] = ACTIONS(1461),
    [anon_sym_alignof] = ACTIONS(1461),
    [anon_sym__Alignof] = ACTIONS(1461),
    [anon_sym_offsetof] = ACTIONS(1461),
    [anon_sym__Generic] = ACTIONS(1461),
    [anon_sym_asm] = ACTIONS(1461),
    [anon_sym___asm__] = ACTIONS(1461),
    [sym_number_literal] = ACTIONS(1463),
    [anon_sym_L_SQUOTE] = ACTIONS(1463),
    [anon_sym_u_SQUOTE] = ACTIONS(1463),
    [anon_sym_U_SQUOTE] = ACTIONS(1463),
    [anon_sym_u8_SQUOTE] = ACTIONS(1463),
    [anon_sym_SQUOTE] = ACTIONS(1463),
    [anon_sym_L_DQUOTE] = ACTIONS(1463),
    [anon_sym_u_DQUOTE] = ACTIONS(1463),
    [anon_sym_U_DQUOTE] = ACTIONS(1463),
    [anon_sym_u8_DQUOTE] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [anon_sym_NULL] = ACTIONS(1461),
    [anon_sym_nullptr] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1461),
    [anon_sym_hitAttributeEXT] = ACTIONS(1461),
    [anon_sym_callableDataEXT] = ACTIONS(1461),
    [anon_sym_callableDataInEXT] = ACTIONS(1461),
    [anon_sym_shaderRecordEXT] = ACTIONS(1461),
    [anon_sym_rayPayloadNV] = ACTIONS(1461),
    [anon_sym_rayPayloadInNV] = ACTIONS(1461),
    [anon_sym_hitAttributeNV] = ACTIONS(1461),
    [anon_sym_callableDataNV] = ACTIONS(1461),
    [anon_sym_callableDataInNV] = ACTIONS(1461),
    [anon_sym_shaderRecordNV] = ACTIONS(1461),
    [anon_sym_layout] = ACTIONS(1461),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(1487),
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_include_token1] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_LPAREN2] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1485),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_typedef] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym___cdecl] = ACTIONS(1485),
    [anon_sym___clrcall] = ACTIONS(1485),
    [anon_sym___stdcall] = ACTIONS(1485),
    [anon_sym___fastcall] = ACTIONS(1485),
    [anon_sym___thiscall] = ACTIONS(1485),
    [anon_sym___vectorcall] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_switch] = ACTIONS(1485),
    [anon_sym_case] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1485),
    [anon_sym_do] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_return] = ACTIONS(1485),
    [anon_sym_break] = ACTIONS(1485),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_goto] = ACTIONS(1485),
    [anon_sym_DASH_DASH] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1487),
    [anon_sym_sizeof] = ACTIONS(1485),
    [anon_sym___alignof__] = ACTIONS(1485),
    [anon_sym___alignof] = ACTIONS(1485),
    [anon_sym__alignof] = ACTIONS(1485),
    [anon_sym_alignof] = ACTIONS(1485),
    [anon_sym__Alignof] = ACTIONS(1485),
    [anon_sym_offsetof] = ACTIONS(1485),
    [anon_sym__Generic] = ACTIONS(1485),
    [anon_sym_asm] = ACTIONS(1485),
    [anon_sym___asm__] = ACTIONS(1485),
    [sym_number_literal] = ACTIONS(1487),
    [anon_sym_L_SQUOTE] = ACTIONS(1487),
    [anon_sym_u_SQUOTE] = ACTIONS(1487),
    [anon_sym_U_SQUOTE] = ACTIONS(1487),
    [anon_sym_u8_SQUOTE] = ACTIONS(1487),
    [anon_sym_SQUOTE] = ACTIONS(1487),
    [anon_sym_L_DQUOTE] = ACTIONS(1487),
    [anon_sym_u_DQUOTE] = ACTIONS(1487),
    [anon_sym_U_DQUOTE] = ACTIONS(1487),
    [anon_sym_u8_DQUOTE] = ACTIONS(1487),
    [anon_sym_DQUOTE] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [anon_sym_NULL] = ACTIONS(1485),
    [anon_sym_nullptr] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_include_token1] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_LPAREN2] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1489),
    [anon_sym_PLUS] = ACTIONS(1489),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_typedef] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym___cdecl] = ACTIONS(1489),
    [anon_sym___clrcall] = ACTIONS(1489),
    [anon_sym___stdcall] = ACTIONS(1489),
    [anon_sym___fastcall] = ACTIONS(1489),
    [anon_sym___thiscall] = ACTIONS(1489),
    [anon_sym___vectorcall] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_switch] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1489),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_return] = ACTIONS(1489),
    [anon_sym_break] = ACTIONS(1489),
    [anon_sym_continue] = ACTIONS(1489),
    [anon_sym_goto] = ACTIONS(1489),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_sizeof] = ACTIONS(1489),
    [anon_sym___alignof__] = ACTIONS(1489),
    [anon_sym___alignof] = ACTIONS(1489),
    [anon_sym__alignof] = ACTIONS(1489),
    [anon_sym_alignof] = ACTIONS(1489),
    [anon_sym__Alignof] = ACTIONS(1489),
    [anon_sym_offsetof] = ACTIONS(1489),
    [anon_sym__Generic] = ACTIONS(1489),
    [anon_sym_asm] = ACTIONS(1489),
    [anon_sym___asm__] = ACTIONS(1489),
    [sym_number_literal] = ACTIONS(1491),
    [anon_sym_L_SQUOTE] = ACTIONS(1491),
    [anon_sym_u_SQUOTE] = ACTIONS(1491),
    [anon_sym_U_SQUOTE] = ACTIONS(1491),
    [anon_sym_u8_SQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [anon_sym_L_DQUOTE] = ACTIONS(1491),
    [anon_sym_u_DQUOTE] = ACTIONS(1491),
    [anon_sym_U_DQUOTE] = ACTIONS(1491),
    [anon_sym_u8_DQUOTE] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [sym_true] = ACTIONS(1489),
    [sym_false] = ACTIONS(1489),
    [anon_sym_NULL] = ACTIONS(1489),
    [anon_sym_nullptr] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(1455),
    [sym_identifier] = ACTIONS(1453),
    [aux_sym_preproc_include_token1] = ACTIONS(1453),
    [aux_sym_preproc_def_token1] = ACTIONS(1453),
    [aux_sym_preproc_if_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1453),
    [sym_preproc_directive] = ACTIONS(1453),
    [anon_sym_LPAREN2] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_TILDE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1453),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_subroutine] = ACTIONS(1453),
    [anon_sym_invariant] = ACTIONS(1453),
    [anon_sym_precise] = ACTIONS(1453),
    [anon_sym_in] = ACTIONS(1453),
    [anon_sym_out] = ACTIONS(1453),
    [anon_sym_inout] = ACTIONS(1453),
    [anon_sym_uniform] = ACTIONS(1453),
    [anon_sym_shared] = ACTIONS(1453),
    [anon_sym_attribute] = ACTIONS(1453),
    [anon_sym_varying] = ACTIONS(1453),
    [anon_sym_buffer] = ACTIONS(1453),
    [anon_sym_coherent] = ACTIONS(1453),
    [anon_sym_readonly] = ACTIONS(1453),
    [anon_sym_writeonly] = ACTIONS(1453),
    [anon_sym_precision] = ACTIONS(1453),
    [anon_sym_highp] = ACTIONS(1453),
    [anon_sym_mediump] = ACTIONS(1453),
    [anon_sym_lowp] = ACTIONS(1453),
    [anon_sym_centroid] = ACTIONS(1453),
    [anon_sym_sample] = ACTIONS(1453),
    [anon_sym_patch] = ACTIONS(1453),
    [anon_sym_smooth] = ACTIONS(1453),
    [anon_sym_flat] = ACTIONS(1453),
    [anon_sym_noperspective] = ACTIONS(1453),
    [anon_sym___extension__] = ACTIONS(1453),
    [anon_sym_typedef] = ACTIONS(1453),
    [anon_sym_extern] = ACTIONS(1453),
    [anon_sym___attribute__] = ACTIONS(1453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1455),
    [anon_sym___declspec] = ACTIONS(1453),
    [anon_sym___cdecl] = ACTIONS(1453),
    [anon_sym___clrcall] = ACTIONS(1453),
    [anon_sym___stdcall] = ACTIONS(1453),
    [anon_sym___fastcall] = ACTIONS(1453),
    [anon_sym___thiscall] = ACTIONS(1453),
    [anon_sym___vectorcall] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_signed] = ACTIONS(1453),
    [anon_sym_unsigned] = ACTIONS(1453),
    [anon_sym_long] = ACTIONS(1453),
    [anon_sym_short] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_auto] = ACTIONS(1453),
    [anon_sym_register] = ACTIONS(1453),
    [anon_sym_inline] = ACTIONS(1453),
    [anon_sym___inline] = ACTIONS(1453),
    [anon_sym___inline__] = ACTIONS(1453),
    [anon_sym___forceinline] = ACTIONS(1453),
    [anon_sym_thread_local] = ACTIONS(1453),
    [anon_sym___thread] = ACTIONS(1453),
    [anon_sym_const] = ACTIONS(1453),
    [anon_sym_constexpr] = ACTIONS(1453),
    [anon_sym_volatile] = ACTIONS(1453),
    [anon_sym_restrict] = ACTIONS(1453),
    [anon_sym___restrict__] = ACTIONS(1453),
    [anon_sym__Atomic] = ACTIONS(1453),
    [anon_sym__Noreturn] = ACTIONS(1453),
    [anon_sym_noreturn] = ACTIONS(1453),
    [anon_sym_alignas] = ACTIONS(1453),
    [anon_sym__Alignas] = ACTIONS(1453),
    [sym_primitive_type] = ACTIONS(1453),
    [anon_sym_enum] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1453),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1453),
    [anon_sym_case] = ACTIONS(1453),
    [anon_sym_default] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_do] = ACTIONS(1453),
    [anon_sym_for] = ACTIONS(1453),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1453),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_goto] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1455),
    [anon_sym_sizeof] = ACTIONS(1453),
    [anon_sym___alignof__] = ACTIONS(1453),
    [anon_sym___alignof] = ACTIONS(1453),
    [anon_sym__alignof] = ACTIONS(1453),
    [anon_sym_alignof] = ACTIONS(1453),
    [anon_sym__Alignof] = ACTIONS(1453),
    [anon_sym_offsetof] = ACTIONS(1453),
    [anon_sym__Generic] = ACTIONS(1453),
    [anon_sym_asm] = ACTIONS(1453),
    [anon_sym___asm__] = ACTIONS(1453),
    [sym_number_literal] = ACTIONS(1455),
    [anon_sym_L_SQUOTE] = ACTIONS(1455),
    [anon_sym_u_SQUOTE] = ACTIONS(1455),
    [anon_sym_U_SQUOTE] = ACTIONS(1455),
    [anon_sym_u8_SQUOTE] = ACTIONS(1455),
    [anon_sym_SQUOTE] = ACTIONS(1455),
    [anon_sym_L_DQUOTE] = ACTIONS(1455),
    [anon_sym_u_DQUOTE] = ACTIONS(1455),
    [anon_sym_U_DQUOTE] = ACTIONS(1455),
    [anon_sym_u8_DQUOTE] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1455),
    [sym_true] = ACTIONS(1453),
    [sym_false] = ACTIONS(1453),
    [anon_sym_NULL] = ACTIONS(1453),
    [anon_sym_nullptr] = ACTIONS(1453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1453),
    [anon_sym_hitAttributeEXT] = ACTIONS(1453),
    [anon_sym_callableDataEXT] = ACTIONS(1453),
    [anon_sym_callableDataInEXT] = ACTIONS(1453),
    [anon_sym_shaderRecordEXT] = ACTIONS(1453),
    [anon_sym_rayPayloadNV] = ACTIONS(1453),
    [anon_sym_rayPayloadInNV] = ACTIONS(1453),
    [anon_sym_hitAttributeNV] = ACTIONS(1453),
    [anon_sym_callableDataNV] = ACTIONS(1453),
    [anon_sym_callableDataInNV] = ACTIONS(1453),
    [anon_sym_shaderRecordNV] = ACTIONS(1453),
    [anon_sym_layout] = ACTIONS(1453),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(1439),
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1437),
    [aux_sym_preproc_def_token1] = ACTIONS(1437),
    [aux_sym_preproc_if_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1437),
    [sym_preproc_directive] = ACTIONS(1437),
    [anon_sym_LPAREN2] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_subroutine] = ACTIONS(1437),
    [anon_sym_invariant] = ACTIONS(1437),
    [anon_sym_precise] = ACTIONS(1437),
    [anon_sym_in] = ACTIONS(1437),
    [anon_sym_out] = ACTIONS(1437),
    [anon_sym_inout] = ACTIONS(1437),
    [anon_sym_uniform] = ACTIONS(1437),
    [anon_sym_shared] = ACTIONS(1437),
    [anon_sym_attribute] = ACTIONS(1437),
    [anon_sym_varying] = ACTIONS(1437),
    [anon_sym_buffer] = ACTIONS(1437),
    [anon_sym_coherent] = ACTIONS(1437),
    [anon_sym_readonly] = ACTIONS(1437),
    [anon_sym_writeonly] = ACTIONS(1437),
    [anon_sym_precision] = ACTIONS(1437),
    [anon_sym_highp] = ACTIONS(1437),
    [anon_sym_mediump] = ACTIONS(1437),
    [anon_sym_lowp] = ACTIONS(1437),
    [anon_sym_centroid] = ACTIONS(1437),
    [anon_sym_sample] = ACTIONS(1437),
    [anon_sym_patch] = ACTIONS(1437),
    [anon_sym_smooth] = ACTIONS(1437),
    [anon_sym_flat] = ACTIONS(1437),
    [anon_sym_noperspective] = ACTIONS(1437),
    [anon_sym___extension__] = ACTIONS(1437),
    [anon_sym_typedef] = ACTIONS(1437),
    [anon_sym_extern] = ACTIONS(1437),
    [anon_sym___attribute__] = ACTIONS(1437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1439),
    [anon_sym___declspec] = ACTIONS(1437),
    [anon_sym___cdecl] = ACTIONS(1437),
    [anon_sym___clrcall] = ACTIONS(1437),
    [anon_sym___stdcall] = ACTIONS(1437),
    [anon_sym___fastcall] = ACTIONS(1437),
    [anon_sym___thiscall] = ACTIONS(1437),
    [anon_sym___vectorcall] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_signed] = ACTIONS(1437),
    [anon_sym_unsigned] = ACTIONS(1437),
    [anon_sym_long] = ACTIONS(1437),
    [anon_sym_short] = ACTIONS(1437),
    [anon_sym_static] = ACTIONS(1437),
    [anon_sym_auto] = ACTIONS(1437),
    [anon_sym_register] = ACTIONS(1437),
    [anon_sym_inline] = ACTIONS(1437),
    [anon_sym___inline] = ACTIONS(1437),
    [anon_sym___inline__] = ACTIONS(1437),
    [anon_sym___forceinline] = ACTIONS(1437),
    [anon_sym_thread_local] = ACTIONS(1437),
    [anon_sym___thread] = ACTIONS(1437),
    [anon_sym_const] = ACTIONS(1437),
    [anon_sym_constexpr] = ACTIONS(1437),
    [anon_sym_volatile] = ACTIONS(1437),
    [anon_sym_restrict] = ACTIONS(1437),
    [anon_sym___restrict__] = ACTIONS(1437),
    [anon_sym__Atomic] = ACTIONS(1437),
    [anon_sym__Noreturn] = ACTIONS(1437),
    [anon_sym_noreturn] = ACTIONS(1437),
    [anon_sym_alignas] = ACTIONS(1437),
    [anon_sym__Alignas] = ACTIONS(1437),
    [sym_primitive_type] = ACTIONS(1437),
    [anon_sym_enum] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1437),
    [anon_sym_union] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1437),
    [anon_sym_case] = ACTIONS(1437),
    [anon_sym_default] = ACTIONS(1437),
    [anon_sym_while] = ACTIONS(1437),
    [anon_sym_do] = ACTIONS(1437),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_break] = ACTIONS(1437),
    [anon_sym_continue] = ACTIONS(1437),
    [anon_sym_goto] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_sizeof] = ACTIONS(1437),
    [anon_sym___alignof__] = ACTIONS(1437),
    [anon_sym___alignof] = ACTIONS(1437),
    [anon_sym__alignof] = ACTIONS(1437),
    [anon_sym_alignof] = ACTIONS(1437),
    [anon_sym__Alignof] = ACTIONS(1437),
    [anon_sym_offsetof] = ACTIONS(1437),
    [anon_sym__Generic] = ACTIONS(1437),
    [anon_sym_asm] = ACTIONS(1437),
    [anon_sym___asm__] = ACTIONS(1437),
    [sym_number_literal] = ACTIONS(1439),
    [anon_sym_L_SQUOTE] = ACTIONS(1439),
    [anon_sym_u_SQUOTE] = ACTIONS(1439),
    [anon_sym_U_SQUOTE] = ACTIONS(1439),
    [anon_sym_u8_SQUOTE] = ACTIONS(1439),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_L_DQUOTE] = ACTIONS(1439),
    [anon_sym_u_DQUOTE] = ACTIONS(1439),
    [anon_sym_U_DQUOTE] = ACTIONS(1439),
    [anon_sym_u8_DQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [anon_sym_NULL] = ACTIONS(1437),
    [anon_sym_nullptr] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1437),
    [anon_sym_hitAttributeEXT] = ACTIONS(1437),
    [anon_sym_callableDataEXT] = ACTIONS(1437),
    [anon_sym_callableDataInEXT] = ACTIONS(1437),
    [anon_sym_shaderRecordEXT] = ACTIONS(1437),
    [anon_sym_rayPayloadNV] = ACTIONS(1437),
    [anon_sym_rayPayloadInNV] = ACTIONS(1437),
    [anon_sym_hitAttributeNV] = ACTIONS(1437),
    [anon_sym_callableDataNV] = ACTIONS(1437),
    [anon_sym_callableDataInNV] = ACTIONS(1437),
    [anon_sym_shaderRecordNV] = ACTIONS(1437),
    [anon_sym_layout] = ACTIONS(1437),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1495),
    [sym_identifier] = ACTIONS(1493),
    [aux_sym_preproc_include_token1] = ACTIONS(1493),
    [aux_sym_preproc_def_token1] = ACTIONS(1493),
    [aux_sym_preproc_if_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1493),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1493),
    [sym_preproc_directive] = ACTIONS(1493),
    [anon_sym_LPAREN2] = ACTIONS(1495),
    [anon_sym_BANG] = ACTIONS(1495),
    [anon_sym_TILDE] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_STAR] = ACTIONS(1495),
    [anon_sym_AMP] = ACTIONS(1495),
    [anon_sym_subroutine] = ACTIONS(1493),
    [anon_sym_invariant] = ACTIONS(1493),
    [anon_sym_precise] = ACTIONS(1493),
    [anon_sym_in] = ACTIONS(1493),
    [anon_sym_out] = ACTIONS(1493),
    [anon_sym_inout] = ACTIONS(1493),
    [anon_sym_uniform] = ACTIONS(1493),
    [anon_sym_shared] = ACTIONS(1493),
    [anon_sym_attribute] = ACTIONS(1493),
    [anon_sym_varying] = ACTIONS(1493),
    [anon_sym_buffer] = ACTIONS(1493),
    [anon_sym_coherent] = ACTIONS(1493),
    [anon_sym_readonly] = ACTIONS(1493),
    [anon_sym_writeonly] = ACTIONS(1493),
    [anon_sym_precision] = ACTIONS(1493),
    [anon_sym_highp] = ACTIONS(1493),
    [anon_sym_mediump] = ACTIONS(1493),
    [anon_sym_lowp] = ACTIONS(1493),
    [anon_sym_centroid] = ACTIONS(1493),
    [anon_sym_sample] = ACTIONS(1493),
    [anon_sym_patch] = ACTIONS(1493),
    [anon_sym_smooth] = ACTIONS(1493),
    [anon_sym_flat] = ACTIONS(1493),
    [anon_sym_noperspective] = ACTIONS(1493),
    [anon_sym___extension__] = ACTIONS(1493),
    [anon_sym_typedef] = ACTIONS(1493),
    [anon_sym_extern] = ACTIONS(1493),
    [anon_sym___attribute__] = ACTIONS(1493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1495),
    [anon_sym___declspec] = ACTIONS(1493),
    [anon_sym___cdecl] = ACTIONS(1493),
    [anon_sym___clrcall] = ACTIONS(1493),
    [anon_sym___stdcall] = ACTIONS(1493),
    [anon_sym___fastcall] = ACTIONS(1493),
    [anon_sym___thiscall] = ACTIONS(1493),
    [anon_sym___vectorcall] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(1495),
    [anon_sym_signed] = ACTIONS(1493),
    [anon_sym_unsigned] = ACTIONS(1493),
    [anon_sym_long] = ACTIONS(1493),
    [anon_sym_short] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1493),
    [anon_sym_auto] = ACTIONS(1493),
    [anon_sym_register] = ACTIONS(1493),
    [anon_sym_inline] = ACTIONS(1493),
    [anon_sym___inline] = ACTIONS(1493),
    [anon_sym___inline__] = ACTIONS(1493),
    [anon_sym___forceinline] = ACTIONS(1493),
    [anon_sym_thread_local] = ACTIONS(1493),
    [anon_sym___thread] = ACTIONS(1493),
    [anon_sym_const] = ACTIONS(1493),
    [anon_sym_constexpr] = ACTIONS(1493),
    [anon_sym_volatile] = ACTIONS(1493),
    [anon_sym_restrict] = ACTIONS(1493),
    [anon_sym___restrict__] = ACTIONS(1493),
    [anon_sym__Atomic] = ACTIONS(1493),
    [anon_sym__Noreturn] = ACTIONS(1493),
    [anon_sym_noreturn] = ACTIONS(1493),
    [anon_sym_alignas] = ACTIONS(1493),
    [anon_sym__Alignas] = ACTIONS(1493),
    [sym_primitive_type] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1493),
    [anon_sym_struct] = ACTIONS(1493),
    [anon_sym_union] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1493),
    [anon_sym_switch] = ACTIONS(1493),
    [anon_sym_case] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1493),
    [anon_sym_do] = ACTIONS(1493),
    [anon_sym_for] = ACTIONS(1493),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_break] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1493),
    [anon_sym_goto] = ACTIONS(1493),
    [anon_sym_DASH_DASH] = ACTIONS(1495),
    [anon_sym_PLUS_PLUS] = ACTIONS(1495),
    [anon_sym_sizeof] = ACTIONS(1493),
    [anon_sym___alignof__] = ACTIONS(1493),
    [anon_sym___alignof] = ACTIONS(1493),
    [anon_sym__alignof] = ACTIONS(1493),
    [anon_sym_alignof] = ACTIONS(1493),
    [anon_sym__Alignof] = ACTIONS(1493),
    [anon_sym_offsetof] = ACTIONS(1493),
    [anon_sym__Generic] = ACTIONS(1493),
    [anon_sym_asm] = ACTIONS(1493),
    [anon_sym___asm__] = ACTIONS(1493),
    [sym_number_literal] = ACTIONS(1495),
    [anon_sym_L_SQUOTE] = ACTIONS(1495),
    [anon_sym_u_SQUOTE] = ACTIONS(1495),
    [anon_sym_U_SQUOTE] = ACTIONS(1495),
    [anon_sym_u8_SQUOTE] = ACTIONS(1495),
    [anon_sym_SQUOTE] = ACTIONS(1495),
    [anon_sym_L_DQUOTE] = ACTIONS(1495),
    [anon_sym_u_DQUOTE] = ACTIONS(1495),
    [anon_sym_U_DQUOTE] = ACTIONS(1495),
    [anon_sym_u8_DQUOTE] = ACTIONS(1495),
    [anon_sym_DQUOTE] = ACTIONS(1495),
    [sym_true] = ACTIONS(1493),
    [sym_false] = ACTIONS(1493),
    [anon_sym_NULL] = ACTIONS(1493),
    [anon_sym_nullptr] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1493),
    [anon_sym_hitAttributeEXT] = ACTIONS(1493),
    [anon_sym_callableDataEXT] = ACTIONS(1493),
    [anon_sym_callableDataInEXT] = ACTIONS(1493),
    [anon_sym_shaderRecordEXT] = ACTIONS(1493),
    [anon_sym_rayPayloadNV] = ACTIONS(1493),
    [anon_sym_rayPayloadInNV] = ACTIONS(1493),
    [anon_sym_hitAttributeNV] = ACTIONS(1493),
    [anon_sym_callableDataNV] = ACTIONS(1493),
    [anon_sym_callableDataInNV] = ACTIONS(1493),
    [anon_sym_shaderRecordNV] = ACTIONS(1493),
    [anon_sym_layout] = ACTIONS(1493),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(1431),
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_include_token1] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_LPAREN2] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_typedef] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym___cdecl] = ACTIONS(1429),
    [anon_sym___clrcall] = ACTIONS(1429),
    [anon_sym___stdcall] = ACTIONS(1429),
    [anon_sym___fastcall] = ACTIONS(1429),
    [anon_sym___thiscall] = ACTIONS(1429),
    [anon_sym___vectorcall] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_goto] = ACTIONS(1429),
    [anon_sym_DASH_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1431),
    [anon_sym_sizeof] = ACTIONS(1429),
    [anon_sym___alignof__] = ACTIONS(1429),
    [anon_sym___alignof] = ACTIONS(1429),
    [anon_sym__alignof] = ACTIONS(1429),
    [anon_sym_alignof] = ACTIONS(1429),
    [anon_sym__Alignof] = ACTIONS(1429),
    [anon_sym_offsetof] = ACTIONS(1429),
    [anon_sym__Generic] = ACTIONS(1429),
    [anon_sym_asm] = ACTIONS(1429),
    [anon_sym___asm__] = ACTIONS(1429),
    [sym_number_literal] = ACTIONS(1431),
    [anon_sym_L_SQUOTE] = ACTIONS(1431),
    [anon_sym_u_SQUOTE] = ACTIONS(1431),
    [anon_sym_U_SQUOTE] = ACTIONS(1431),
    [anon_sym_u8_SQUOTE] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [anon_sym_L_DQUOTE] = ACTIONS(1431),
    [anon_sym_u_DQUOTE] = ACTIONS(1431),
    [anon_sym_U_DQUOTE] = ACTIONS(1431),
    [anon_sym_u8_DQUOTE] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1431),
    [sym_true] = ACTIONS(1429),
    [sym_false] = ACTIONS(1429),
    [anon_sym_NULL] = ACTIONS(1429),
    [anon_sym_nullptr] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym_identifier] = ACTIONS(1481),
    [aux_sym_preproc_include_token1] = ACTIONS(1481),
    [aux_sym_preproc_def_token1] = ACTIONS(1481),
    [aux_sym_preproc_if_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1481),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1481),
    [sym_preproc_directive] = ACTIONS(1481),
    [anon_sym_LPAREN2] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_subroutine] = ACTIONS(1481),
    [anon_sym_invariant] = ACTIONS(1481),
    [anon_sym_precise] = ACTIONS(1481),
    [anon_sym_in] = ACTIONS(1481),
    [anon_sym_out] = ACTIONS(1481),
    [anon_sym_inout] = ACTIONS(1481),
    [anon_sym_uniform] = ACTIONS(1481),
    [anon_sym_shared] = ACTIONS(1481),
    [anon_sym_attribute] = ACTIONS(1481),
    [anon_sym_varying] = ACTIONS(1481),
    [anon_sym_buffer] = ACTIONS(1481),
    [anon_sym_coherent] = ACTIONS(1481),
    [anon_sym_readonly] = ACTIONS(1481),
    [anon_sym_writeonly] = ACTIONS(1481),
    [anon_sym_precision] = ACTIONS(1481),
    [anon_sym_highp] = ACTIONS(1481),
    [anon_sym_mediump] = ACTIONS(1481),
    [anon_sym_lowp] = ACTIONS(1481),
    [anon_sym_centroid] = ACTIONS(1481),
    [anon_sym_sample] = ACTIONS(1481),
    [anon_sym_patch] = ACTIONS(1481),
    [anon_sym_smooth] = ACTIONS(1481),
    [anon_sym_flat] = ACTIONS(1481),
    [anon_sym_noperspective] = ACTIONS(1481),
    [anon_sym___extension__] = ACTIONS(1481),
    [anon_sym_typedef] = ACTIONS(1481),
    [anon_sym_extern] = ACTIONS(1481),
    [anon_sym___attribute__] = ACTIONS(1481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1483),
    [anon_sym___declspec] = ACTIONS(1481),
    [anon_sym___cdecl] = ACTIONS(1481),
    [anon_sym___clrcall] = ACTIONS(1481),
    [anon_sym___stdcall] = ACTIONS(1481),
    [anon_sym___fastcall] = ACTIONS(1481),
    [anon_sym___thiscall] = ACTIONS(1481),
    [anon_sym___vectorcall] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_signed] = ACTIONS(1481),
    [anon_sym_unsigned] = ACTIONS(1481),
    [anon_sym_long] = ACTIONS(1481),
    [anon_sym_short] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_auto] = ACTIONS(1481),
    [anon_sym_register] = ACTIONS(1481),
    [anon_sym_inline] = ACTIONS(1481),
    [anon_sym___inline] = ACTIONS(1481),
    [anon_sym___inline__] = ACTIONS(1481),
    [anon_sym___forceinline] = ACTIONS(1481),
    [anon_sym_thread_local] = ACTIONS(1481),
    [anon_sym___thread] = ACTIONS(1481),
    [anon_sym_const] = ACTIONS(1481),
    [anon_sym_constexpr] = ACTIONS(1481),
    [anon_sym_volatile] = ACTIONS(1481),
    [anon_sym_restrict] = ACTIONS(1481),
    [anon_sym___restrict__] = ACTIONS(1481),
    [anon_sym__Atomic] = ACTIONS(1481),
    [anon_sym__Noreturn] = ACTIONS(1481),
    [anon_sym_noreturn] = ACTIONS(1481),
    [anon_sym_alignas] = ACTIONS(1481),
    [anon_sym__Alignas] = ACTIONS(1481),
    [sym_primitive_type] = ACTIONS(1481),
    [anon_sym_enum] = ACTIONS(1481),
    [anon_sym_struct] = ACTIONS(1481),
    [anon_sym_union] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_switch] = ACTIONS(1481),
    [anon_sym_case] = ACTIONS(1481),
    [anon_sym_default] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_do] = ACTIONS(1481),
    [anon_sym_for] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_break] = ACTIONS(1481),
    [anon_sym_continue] = ACTIONS(1481),
    [anon_sym_goto] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_sizeof] = ACTIONS(1481),
    [anon_sym___alignof__] = ACTIONS(1481),
    [anon_sym___alignof] = ACTIONS(1481),
    [anon_sym__alignof] = ACTIONS(1481),
    [anon_sym_alignof] = ACTIONS(1481),
    [anon_sym__Alignof] = ACTIONS(1481),
    [anon_sym_offsetof] = ACTIONS(1481),
    [anon_sym__Generic] = ACTIONS(1481),
    [anon_sym_asm] = ACTIONS(1481),
    [anon_sym___asm__] = ACTIONS(1481),
    [sym_number_literal] = ACTIONS(1483),
    [anon_sym_L_SQUOTE] = ACTIONS(1483),
    [anon_sym_u_SQUOTE] = ACTIONS(1483),
    [anon_sym_U_SQUOTE] = ACTIONS(1483),
    [anon_sym_u8_SQUOTE] = ACTIONS(1483),
    [anon_sym_SQUOTE] = ACTIONS(1483),
    [anon_sym_L_DQUOTE] = ACTIONS(1483),
    [anon_sym_u_DQUOTE] = ACTIONS(1483),
    [anon_sym_U_DQUOTE] = ACTIONS(1483),
    [anon_sym_u8_DQUOTE] = ACTIONS(1483),
    [anon_sym_DQUOTE] = ACTIONS(1483),
    [sym_true] = ACTIONS(1481),
    [sym_false] = ACTIONS(1481),
    [anon_sym_NULL] = ACTIONS(1481),
    [anon_sym_nullptr] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1481),
    [anon_sym_hitAttributeEXT] = ACTIONS(1481),
    [anon_sym_callableDataEXT] = ACTIONS(1481),
    [anon_sym_callableDataInEXT] = ACTIONS(1481),
    [anon_sym_shaderRecordEXT] = ACTIONS(1481),
    [anon_sym_rayPayloadNV] = ACTIONS(1481),
    [anon_sym_rayPayloadInNV] = ACTIONS(1481),
    [anon_sym_hitAttributeNV] = ACTIONS(1481),
    [anon_sym_callableDataNV] = ACTIONS(1481),
    [anon_sym_callableDataInNV] = ACTIONS(1481),
    [anon_sym_shaderRecordNV] = ACTIONS(1481),
    [anon_sym_layout] = ACTIONS(1481),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1479),
    [sym_identifier] = ACTIONS(1477),
    [aux_sym_preproc_include_token1] = ACTIONS(1477),
    [aux_sym_preproc_def_token1] = ACTIONS(1477),
    [aux_sym_preproc_if_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1477),
    [sym_preproc_directive] = ACTIONS(1477),
    [anon_sym_LPAREN2] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_subroutine] = ACTIONS(1477),
    [anon_sym_invariant] = ACTIONS(1477),
    [anon_sym_precise] = ACTIONS(1477),
    [anon_sym_in] = ACTIONS(1477),
    [anon_sym_out] = ACTIONS(1477),
    [anon_sym_inout] = ACTIONS(1477),
    [anon_sym_uniform] = ACTIONS(1477),
    [anon_sym_shared] = ACTIONS(1477),
    [anon_sym_attribute] = ACTIONS(1477),
    [anon_sym_varying] = ACTIONS(1477),
    [anon_sym_buffer] = ACTIONS(1477),
    [anon_sym_coherent] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1477),
    [anon_sym_writeonly] = ACTIONS(1477),
    [anon_sym_precision] = ACTIONS(1477),
    [anon_sym_highp] = ACTIONS(1477),
    [anon_sym_mediump] = ACTIONS(1477),
    [anon_sym_lowp] = ACTIONS(1477),
    [anon_sym_centroid] = ACTIONS(1477),
    [anon_sym_sample] = ACTIONS(1477),
    [anon_sym_patch] = ACTIONS(1477),
    [anon_sym_smooth] = ACTIONS(1477),
    [anon_sym_flat] = ACTIONS(1477),
    [anon_sym_noperspective] = ACTIONS(1477),
    [anon_sym___extension__] = ACTIONS(1477),
    [anon_sym_typedef] = ACTIONS(1477),
    [anon_sym_extern] = ACTIONS(1477),
    [anon_sym___attribute__] = ACTIONS(1477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1479),
    [anon_sym___declspec] = ACTIONS(1477),
    [anon_sym___cdecl] = ACTIONS(1477),
    [anon_sym___clrcall] = ACTIONS(1477),
    [anon_sym___stdcall] = ACTIONS(1477),
    [anon_sym___fastcall] = ACTIONS(1477),
    [anon_sym___thiscall] = ACTIONS(1477),
    [anon_sym___vectorcall] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_signed] = ACTIONS(1477),
    [anon_sym_unsigned] = ACTIONS(1477),
    [anon_sym_long] = ACTIONS(1477),
    [anon_sym_short] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_auto] = ACTIONS(1477),
    [anon_sym_register] = ACTIONS(1477),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym___inline] = ACTIONS(1477),
    [anon_sym___inline__] = ACTIONS(1477),
    [anon_sym___forceinline] = ACTIONS(1477),
    [anon_sym_thread_local] = ACTIONS(1477),
    [anon_sym___thread] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_constexpr] = ACTIONS(1477),
    [anon_sym_volatile] = ACTIONS(1477),
    [anon_sym_restrict] = ACTIONS(1477),
    [anon_sym___restrict__] = ACTIONS(1477),
    [anon_sym__Atomic] = ACTIONS(1477),
    [anon_sym__Noreturn] = ACTIONS(1477),
    [anon_sym_noreturn] = ACTIONS(1477),
    [anon_sym_alignas] = ACTIONS(1477),
    [anon_sym__Alignas] = ACTIONS(1477),
    [sym_primitive_type] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [anon_sym_struct] = ACTIONS(1477),
    [anon_sym_union] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_switch] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_do] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_goto] = ACTIONS(1477),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_sizeof] = ACTIONS(1477),
    [anon_sym___alignof__] = ACTIONS(1477),
    [anon_sym___alignof] = ACTIONS(1477),
    [anon_sym__alignof] = ACTIONS(1477),
    [anon_sym_alignof] = ACTIONS(1477),
    [anon_sym__Alignof] = ACTIONS(1477),
    [anon_sym_offsetof] = ACTIONS(1477),
    [anon_sym__Generic] = ACTIONS(1477),
    [anon_sym_asm] = ACTIONS(1477),
    [anon_sym___asm__] = ACTIONS(1477),
    [sym_number_literal] = ACTIONS(1479),
    [anon_sym_L_SQUOTE] = ACTIONS(1479),
    [anon_sym_u_SQUOTE] = ACTIONS(1479),
    [anon_sym_U_SQUOTE] = ACTIONS(1479),
    [anon_sym_u8_SQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [anon_sym_L_DQUOTE] = ACTIONS(1479),
    [anon_sym_u_DQUOTE] = ACTIONS(1479),
    [anon_sym_U_DQUOTE] = ACTIONS(1479),
    [anon_sym_u8_DQUOTE] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [sym_true] = ACTIONS(1477),
    [sym_false] = ACTIONS(1477),
    [anon_sym_NULL] = ACTIONS(1477),
    [anon_sym_nullptr] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1477),
    [anon_sym_hitAttributeEXT] = ACTIONS(1477),
    [anon_sym_callableDataEXT] = ACTIONS(1477),
    [anon_sym_callableDataInEXT] = ACTIONS(1477),
    [anon_sym_shaderRecordEXT] = ACTIONS(1477),
    [anon_sym_rayPayloadNV] = ACTIONS(1477),
    [anon_sym_rayPayloadInNV] = ACTIONS(1477),
    [anon_sym_hitAttributeNV] = ACTIONS(1477),
    [anon_sym_callableDataNV] = ACTIONS(1477),
    [anon_sym_callableDataInNV] = ACTIONS(1477),
    [anon_sym_shaderRecordNV] = ACTIONS(1477),
    [anon_sym_layout] = ACTIONS(1477),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_include_token1] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_LPAREN2] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_TILDE] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_typedef] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym___cdecl] = ACTIONS(1401),
    [anon_sym___clrcall] = ACTIONS(1401),
    [anon_sym___stdcall] = ACTIONS(1401),
    [anon_sym___fastcall] = ACTIONS(1401),
    [anon_sym___thiscall] = ACTIONS(1401),
    [anon_sym___vectorcall] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1401),
    [anon_sym_case] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_do] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_goto] = ACTIONS(1401),
    [anon_sym_DASH_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1403),
    [anon_sym_sizeof] = ACTIONS(1401),
    [anon_sym___alignof__] = ACTIONS(1401),
    [anon_sym___alignof] = ACTIONS(1401),
    [anon_sym__alignof] = ACTIONS(1401),
    [anon_sym_alignof] = ACTIONS(1401),
    [anon_sym__Alignof] = ACTIONS(1401),
    [anon_sym_offsetof] = ACTIONS(1401),
    [anon_sym__Generic] = ACTIONS(1401),
    [anon_sym_asm] = ACTIONS(1401),
    [anon_sym___asm__] = ACTIONS(1401),
    [sym_number_literal] = ACTIONS(1403),
    [anon_sym_L_SQUOTE] = ACTIONS(1403),
    [anon_sym_u_SQUOTE] = ACTIONS(1403),
    [anon_sym_U_SQUOTE] = ACTIONS(1403),
    [anon_sym_u8_SQUOTE] = ACTIONS(1403),
    [anon_sym_SQUOTE] = ACTIONS(1403),
    [anon_sym_L_DQUOTE] = ACTIONS(1403),
    [anon_sym_u_DQUOTE] = ACTIONS(1403),
    [anon_sym_U_DQUOTE] = ACTIONS(1403),
    [anon_sym_u8_DQUOTE] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1403),
    [sym_true] = ACTIONS(1401),
    [sym_false] = ACTIONS(1401),
    [anon_sym_NULL] = ACTIONS(1401),
    [anon_sym_nullptr] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1465),
    [aux_sym_preproc_include_token1] = ACTIONS(1465),
    [aux_sym_preproc_def_token1] = ACTIONS(1465),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1465),
    [sym_preproc_directive] = ACTIONS(1465),
    [anon_sym_LPAREN2] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_TILDE] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1465),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_subroutine] = ACTIONS(1465),
    [anon_sym_invariant] = ACTIONS(1465),
    [anon_sym_precise] = ACTIONS(1465),
    [anon_sym_in] = ACTIONS(1465),
    [anon_sym_out] = ACTIONS(1465),
    [anon_sym_inout] = ACTIONS(1465),
    [anon_sym_uniform] = ACTIONS(1465),
    [anon_sym_shared] = ACTIONS(1465),
    [anon_sym_attribute] = ACTIONS(1465),
    [anon_sym_varying] = ACTIONS(1465),
    [anon_sym_buffer] = ACTIONS(1465),
    [anon_sym_coherent] = ACTIONS(1465),
    [anon_sym_readonly] = ACTIONS(1465),
    [anon_sym_writeonly] = ACTIONS(1465),
    [anon_sym_precision] = ACTIONS(1465),
    [anon_sym_highp] = ACTIONS(1465),
    [anon_sym_mediump] = ACTIONS(1465),
    [anon_sym_lowp] = ACTIONS(1465),
    [anon_sym_centroid] = ACTIONS(1465),
    [anon_sym_sample] = ACTIONS(1465),
    [anon_sym_patch] = ACTIONS(1465),
    [anon_sym_smooth] = ACTIONS(1465),
    [anon_sym_flat] = ACTIONS(1465),
    [anon_sym_noperspective] = ACTIONS(1465),
    [anon_sym___extension__] = ACTIONS(1465),
    [anon_sym_typedef] = ACTIONS(1465),
    [anon_sym_extern] = ACTIONS(1465),
    [anon_sym___attribute__] = ACTIONS(1465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1467),
    [anon_sym___declspec] = ACTIONS(1465),
    [anon_sym___cdecl] = ACTIONS(1465),
    [anon_sym___clrcall] = ACTIONS(1465),
    [anon_sym___stdcall] = ACTIONS(1465),
    [anon_sym___fastcall] = ACTIONS(1465),
    [anon_sym___thiscall] = ACTIONS(1465),
    [anon_sym___vectorcall] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_signed] = ACTIONS(1465),
    [anon_sym_unsigned] = ACTIONS(1465),
    [anon_sym_long] = ACTIONS(1465),
    [anon_sym_short] = ACTIONS(1465),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_auto] = ACTIONS(1465),
    [anon_sym_register] = ACTIONS(1465),
    [anon_sym_inline] = ACTIONS(1465),
    [anon_sym___inline] = ACTIONS(1465),
    [anon_sym___inline__] = ACTIONS(1465),
    [anon_sym___forceinline] = ACTIONS(1465),
    [anon_sym_thread_local] = ACTIONS(1465),
    [anon_sym___thread] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_constexpr] = ACTIONS(1465),
    [anon_sym_volatile] = ACTIONS(1465),
    [anon_sym_restrict] = ACTIONS(1465),
    [anon_sym___restrict__] = ACTIONS(1465),
    [anon_sym__Atomic] = ACTIONS(1465),
    [anon_sym__Noreturn] = ACTIONS(1465),
    [anon_sym_noreturn] = ACTIONS(1465),
    [anon_sym_alignas] = ACTIONS(1465),
    [anon_sym__Alignas] = ACTIONS(1465),
    [sym_primitive_type] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [anon_sym_struct] = ACTIONS(1465),
    [anon_sym_union] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_switch] = ACTIONS(1465),
    [anon_sym_case] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_goto] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1467),
    [anon_sym_PLUS_PLUS] = ACTIONS(1467),
    [anon_sym_sizeof] = ACTIONS(1465),
    [anon_sym___alignof__] = ACTIONS(1465),
    [anon_sym___alignof] = ACTIONS(1465),
    [anon_sym__alignof] = ACTIONS(1465),
    [anon_sym_alignof] = ACTIONS(1465),
    [anon_sym__Alignof] = ACTIONS(1465),
    [anon_sym_offsetof] = ACTIONS(1465),
    [anon_sym__Generic] = ACTIONS(1465),
    [anon_sym_asm] = ACTIONS(1465),
    [anon_sym___asm__] = ACTIONS(1465),
    [sym_number_literal] = ACTIONS(1467),
    [anon_sym_L_SQUOTE] = ACTIONS(1467),
    [anon_sym_u_SQUOTE] = ACTIONS(1467),
    [anon_sym_U_SQUOTE] = ACTIONS(1467),
    [anon_sym_u8_SQUOTE] = ACTIONS(1467),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_L_DQUOTE] = ACTIONS(1467),
    [anon_sym_u_DQUOTE] = ACTIONS(1467),
    [anon_sym_U_DQUOTE] = ACTIONS(1467),
    [anon_sym_u8_DQUOTE] = ACTIONS(1467),
    [anon_sym_DQUOTE] = ACTIONS(1467),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [anon_sym_NULL] = ACTIONS(1465),
    [anon_sym_nullptr] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1465),
    [anon_sym_hitAttributeEXT] = ACTIONS(1465),
    [anon_sym_callableDataEXT] = ACTIONS(1465),
    [anon_sym_callableDataInEXT] = ACTIONS(1465),
    [anon_sym_shaderRecordEXT] = ACTIONS(1465),
    [anon_sym_rayPayloadNV] = ACTIONS(1465),
    [anon_sym_rayPayloadInNV] = ACTIONS(1465),
    [anon_sym_hitAttributeNV] = ACTIONS(1465),
    [anon_sym_callableDataNV] = ACTIONS(1465),
    [anon_sym_callableDataInNV] = ACTIONS(1465),
    [anon_sym_shaderRecordNV] = ACTIONS(1465),
    [anon_sym_layout] = ACTIONS(1465),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(1531),
    [aux_sym_preproc_include_token1] = ACTIONS(1531),
    [aux_sym_preproc_def_token1] = ACTIONS(1531),
    [aux_sym_preproc_if_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1531),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1531),
    [sym_preproc_directive] = ACTIONS(1531),
    [anon_sym_LPAREN2] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_subroutine] = ACTIONS(1531),
    [anon_sym_invariant] = ACTIONS(1531),
    [anon_sym_precise] = ACTIONS(1531),
    [anon_sym_in] = ACTIONS(1531),
    [anon_sym_out] = ACTIONS(1531),
    [anon_sym_inout] = ACTIONS(1531),
    [anon_sym_uniform] = ACTIONS(1531),
    [anon_sym_shared] = ACTIONS(1531),
    [anon_sym_attribute] = ACTIONS(1531),
    [anon_sym_varying] = ACTIONS(1531),
    [anon_sym_buffer] = ACTIONS(1531),
    [anon_sym_coherent] = ACTIONS(1531),
    [anon_sym_readonly] = ACTIONS(1531),
    [anon_sym_writeonly] = ACTIONS(1531),
    [anon_sym_precision] = ACTIONS(1531),
    [anon_sym_highp] = ACTIONS(1531),
    [anon_sym_mediump] = ACTIONS(1531),
    [anon_sym_lowp] = ACTIONS(1531),
    [anon_sym_centroid] = ACTIONS(1531),
    [anon_sym_sample] = ACTIONS(1531),
    [anon_sym_patch] = ACTIONS(1531),
    [anon_sym_smooth] = ACTIONS(1531),
    [anon_sym_flat] = ACTIONS(1531),
    [anon_sym_noperspective] = ACTIONS(1531),
    [anon_sym___extension__] = ACTIONS(1531),
    [anon_sym_typedef] = ACTIONS(1531),
    [anon_sym_extern] = ACTIONS(1531),
    [anon_sym___attribute__] = ACTIONS(1531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1533),
    [anon_sym___declspec] = ACTIONS(1531),
    [anon_sym___cdecl] = ACTIONS(1531),
    [anon_sym___clrcall] = ACTIONS(1531),
    [anon_sym___stdcall] = ACTIONS(1531),
    [anon_sym___fastcall] = ACTIONS(1531),
    [anon_sym___thiscall] = ACTIONS(1531),
    [anon_sym___vectorcall] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_signed] = ACTIONS(1531),
    [anon_sym_unsigned] = ACTIONS(1531),
    [anon_sym_long] = ACTIONS(1531),
    [anon_sym_short] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1531),
    [anon_sym_auto] = ACTIONS(1531),
    [anon_sym_register] = ACTIONS(1531),
    [anon_sym_inline] = ACTIONS(1531),
    [anon_sym___inline] = ACTIONS(1531),
    [anon_sym___inline__] = ACTIONS(1531),
    [anon_sym___forceinline] = ACTIONS(1531),
    [anon_sym_thread_local] = ACTIONS(1531),
    [anon_sym___thread] = ACTIONS(1531),
    [anon_sym_const] = ACTIONS(1531),
    [anon_sym_constexpr] = ACTIONS(1531),
    [anon_sym_volatile] = ACTIONS(1531),
    [anon_sym_restrict] = ACTIONS(1531),
    [anon_sym___restrict__] = ACTIONS(1531),
    [anon_sym__Atomic] = ACTIONS(1531),
    [anon_sym__Noreturn] = ACTIONS(1531),
    [anon_sym_noreturn] = ACTIONS(1531),
    [anon_sym_alignas] = ACTIONS(1531),
    [anon_sym__Alignas] = ACTIONS(1531),
    [sym_primitive_type] = ACTIONS(1531),
    [anon_sym_enum] = ACTIONS(1531),
    [anon_sym_struct] = ACTIONS(1531),
    [anon_sym_union] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_switch] = ACTIONS(1531),
    [anon_sym_case] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_do] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_continue] = ACTIONS(1531),
    [anon_sym_goto] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1533),
    [anon_sym_sizeof] = ACTIONS(1531),
    [anon_sym___alignof__] = ACTIONS(1531),
    [anon_sym___alignof] = ACTIONS(1531),
    [anon_sym__alignof] = ACTIONS(1531),
    [anon_sym_alignof] = ACTIONS(1531),
    [anon_sym__Alignof] = ACTIONS(1531),
    [anon_sym_offsetof] = ACTIONS(1531),
    [anon_sym__Generic] = ACTIONS(1531),
    [anon_sym_asm] = ACTIONS(1531),
    [anon_sym___asm__] = ACTIONS(1531),
    [sym_number_literal] = ACTIONS(1533),
    [anon_sym_L_SQUOTE] = ACTIONS(1533),
    [anon_sym_u_SQUOTE] = ACTIONS(1533),
    [anon_sym_U_SQUOTE] = ACTIONS(1533),
    [anon_sym_u8_SQUOTE] = ACTIONS(1533),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_L_DQUOTE] = ACTIONS(1533),
    [anon_sym_u_DQUOTE] = ACTIONS(1533),
    [anon_sym_U_DQUOTE] = ACTIONS(1533),
    [anon_sym_u8_DQUOTE] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(1533),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [anon_sym_NULL] = ACTIONS(1531),
    [anon_sym_nullptr] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1531),
    [anon_sym_hitAttributeEXT] = ACTIONS(1531),
    [anon_sym_callableDataEXT] = ACTIONS(1531),
    [anon_sym_callableDataInEXT] = ACTIONS(1531),
    [anon_sym_shaderRecordEXT] = ACTIONS(1531),
    [anon_sym_rayPayloadNV] = ACTIONS(1531),
    [anon_sym_rayPayloadInNV] = ACTIONS(1531),
    [anon_sym_hitAttributeNV] = ACTIONS(1531),
    [anon_sym_callableDataNV] = ACTIONS(1531),
    [anon_sym_callableDataInNV] = ACTIONS(1531),
    [anon_sym_shaderRecordNV] = ACTIONS(1531),
    [anon_sym_layout] = ACTIONS(1531),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(1423),
    [sym_identifier] = ACTIONS(1421),
    [aux_sym_preproc_include_token1] = ACTIONS(1421),
    [aux_sym_preproc_def_token1] = ACTIONS(1421),
    [aux_sym_preproc_if_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1421),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1421),
    [sym_preproc_directive] = ACTIONS(1421),
    [anon_sym_LPAREN2] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_TILDE] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_subroutine] = ACTIONS(1421),
    [anon_sym_invariant] = ACTIONS(1421),
    [anon_sym_precise] = ACTIONS(1421),
    [anon_sym_in] = ACTIONS(1421),
    [anon_sym_out] = ACTIONS(1421),
    [anon_sym_inout] = ACTIONS(1421),
    [anon_sym_uniform] = ACTIONS(1421),
    [anon_sym_shared] = ACTIONS(1421),
    [anon_sym_attribute] = ACTIONS(1421),
    [anon_sym_varying] = ACTIONS(1421),
    [anon_sym_buffer] = ACTIONS(1421),
    [anon_sym_coherent] = ACTIONS(1421),
    [anon_sym_readonly] = ACTIONS(1421),
    [anon_sym_writeonly] = ACTIONS(1421),
    [anon_sym_precision] = ACTIONS(1421),
    [anon_sym_highp] = ACTIONS(1421),
    [anon_sym_mediump] = ACTIONS(1421),
    [anon_sym_lowp] = ACTIONS(1421),
    [anon_sym_centroid] = ACTIONS(1421),
    [anon_sym_sample] = ACTIONS(1421),
    [anon_sym_patch] = ACTIONS(1421),
    [anon_sym_smooth] = ACTIONS(1421),
    [anon_sym_flat] = ACTIONS(1421),
    [anon_sym_noperspective] = ACTIONS(1421),
    [anon_sym___extension__] = ACTIONS(1421),
    [anon_sym_typedef] = ACTIONS(1421),
    [anon_sym_extern] = ACTIONS(1421),
    [anon_sym___attribute__] = ACTIONS(1421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1423),
    [anon_sym___declspec] = ACTIONS(1421),
    [anon_sym___cdecl] = ACTIONS(1421),
    [anon_sym___clrcall] = ACTIONS(1421),
    [anon_sym___stdcall] = ACTIONS(1421),
    [anon_sym___fastcall] = ACTIONS(1421),
    [anon_sym___thiscall] = ACTIONS(1421),
    [anon_sym___vectorcall] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1423),
    [anon_sym_signed] = ACTIONS(1421),
    [anon_sym_unsigned] = ACTIONS(1421),
    [anon_sym_long] = ACTIONS(1421),
    [anon_sym_short] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_auto] = ACTIONS(1421),
    [anon_sym_register] = ACTIONS(1421),
    [anon_sym_inline] = ACTIONS(1421),
    [anon_sym___inline] = ACTIONS(1421),
    [anon_sym___inline__] = ACTIONS(1421),
    [anon_sym___forceinline] = ACTIONS(1421),
    [anon_sym_thread_local] = ACTIONS(1421),
    [anon_sym___thread] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_constexpr] = ACTIONS(1421),
    [anon_sym_volatile] = ACTIONS(1421),
    [anon_sym_restrict] = ACTIONS(1421),
    [anon_sym___restrict__] = ACTIONS(1421),
    [anon_sym__Atomic] = ACTIONS(1421),
    [anon_sym__Noreturn] = ACTIONS(1421),
    [anon_sym_noreturn] = ACTIONS(1421),
    [anon_sym_alignas] = ACTIONS(1421),
    [anon_sym__Alignas] = ACTIONS(1421),
    [sym_primitive_type] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1421),
    [anon_sym_union] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1421),
    [anon_sym_case] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_do] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_goto] = ACTIONS(1421),
    [anon_sym_DASH_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1423),
    [anon_sym_sizeof] = ACTIONS(1421),
    [anon_sym___alignof__] = ACTIONS(1421),
    [anon_sym___alignof] = ACTIONS(1421),
    [anon_sym__alignof] = ACTIONS(1421),
    [anon_sym_alignof] = ACTIONS(1421),
    [anon_sym__Alignof] = ACTIONS(1421),
    [anon_sym_offsetof] = ACTIONS(1421),
    [anon_sym__Generic] = ACTIONS(1421),
    [anon_sym_asm] = ACTIONS(1421),
    [anon_sym___asm__] = ACTIONS(1421),
    [sym_number_literal] = ACTIONS(1423),
    [anon_sym_L_SQUOTE] = ACTIONS(1423),
    [anon_sym_u_SQUOTE] = ACTIONS(1423),
    [anon_sym_U_SQUOTE] = ACTIONS(1423),
    [anon_sym_u8_SQUOTE] = ACTIONS(1423),
    [anon_sym_SQUOTE] = ACTIONS(1423),
    [anon_sym_L_DQUOTE] = ACTIONS(1423),
    [anon_sym_u_DQUOTE] = ACTIONS(1423),
    [anon_sym_U_DQUOTE] = ACTIONS(1423),
    [anon_sym_u8_DQUOTE] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1423),
    [sym_true] = ACTIONS(1421),
    [sym_false] = ACTIONS(1421),
    [anon_sym_NULL] = ACTIONS(1421),
    [anon_sym_nullptr] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1421),
    [anon_sym_hitAttributeEXT] = ACTIONS(1421),
    [anon_sym_callableDataEXT] = ACTIONS(1421),
    [anon_sym_callableDataInEXT] = ACTIONS(1421),
    [anon_sym_shaderRecordEXT] = ACTIONS(1421),
    [anon_sym_rayPayloadNV] = ACTIONS(1421),
    [anon_sym_rayPayloadInNV] = ACTIONS(1421),
    [anon_sym_hitAttributeNV] = ACTIONS(1421),
    [anon_sym_callableDataNV] = ACTIONS(1421),
    [anon_sym_callableDataInNV] = ACTIONS(1421),
    [anon_sym_shaderRecordNV] = ACTIONS(1421),
    [anon_sym_layout] = ACTIONS(1421),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1523),
    [aux_sym_preproc_include_token1] = ACTIONS(1523),
    [aux_sym_preproc_def_token1] = ACTIONS(1523),
    [aux_sym_preproc_if_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1523),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1523),
    [sym_preproc_directive] = ACTIONS(1523),
    [anon_sym_LPAREN2] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_subroutine] = ACTIONS(1523),
    [anon_sym_invariant] = ACTIONS(1523),
    [anon_sym_precise] = ACTIONS(1523),
    [anon_sym_in] = ACTIONS(1523),
    [anon_sym_out] = ACTIONS(1523),
    [anon_sym_inout] = ACTIONS(1523),
    [anon_sym_uniform] = ACTIONS(1523),
    [anon_sym_shared] = ACTIONS(1523),
    [anon_sym_attribute] = ACTIONS(1523),
    [anon_sym_varying] = ACTIONS(1523),
    [anon_sym_buffer] = ACTIONS(1523),
    [anon_sym_coherent] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_writeonly] = ACTIONS(1523),
    [anon_sym_precision] = ACTIONS(1523),
    [anon_sym_highp] = ACTIONS(1523),
    [anon_sym_mediump] = ACTIONS(1523),
    [anon_sym_lowp] = ACTIONS(1523),
    [anon_sym_centroid] = ACTIONS(1523),
    [anon_sym_sample] = ACTIONS(1523),
    [anon_sym_patch] = ACTIONS(1523),
    [anon_sym_smooth] = ACTIONS(1523),
    [anon_sym_flat] = ACTIONS(1523),
    [anon_sym_noperspective] = ACTIONS(1523),
    [anon_sym___extension__] = ACTIONS(1523),
    [anon_sym_typedef] = ACTIONS(1523),
    [anon_sym_extern] = ACTIONS(1523),
    [anon_sym___attribute__] = ACTIONS(1523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1525),
    [anon_sym___declspec] = ACTIONS(1523),
    [anon_sym___cdecl] = ACTIONS(1523),
    [anon_sym___clrcall] = ACTIONS(1523),
    [anon_sym___stdcall] = ACTIONS(1523),
    [anon_sym___fastcall] = ACTIONS(1523),
    [anon_sym___thiscall] = ACTIONS(1523),
    [anon_sym___vectorcall] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_signed] = ACTIONS(1523),
    [anon_sym_unsigned] = ACTIONS(1523),
    [anon_sym_long] = ACTIONS(1523),
    [anon_sym_short] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_auto] = ACTIONS(1523),
    [anon_sym_register] = ACTIONS(1523),
    [anon_sym_inline] = ACTIONS(1523),
    [anon_sym___inline] = ACTIONS(1523),
    [anon_sym___inline__] = ACTIONS(1523),
    [anon_sym___forceinline] = ACTIONS(1523),
    [anon_sym_thread_local] = ACTIONS(1523),
    [anon_sym___thread] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_constexpr] = ACTIONS(1523),
    [anon_sym_volatile] = ACTIONS(1523),
    [anon_sym_restrict] = ACTIONS(1523),
    [anon_sym___restrict__] = ACTIONS(1523),
    [anon_sym__Atomic] = ACTIONS(1523),
    [anon_sym__Noreturn] = ACTIONS(1523),
    [anon_sym_noreturn] = ACTIONS(1523),
    [anon_sym_alignas] = ACTIONS(1523),
    [anon_sym__Alignas] = ACTIONS(1523),
    [sym_primitive_type] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [anon_sym_struct] = ACTIONS(1523),
    [anon_sym_union] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_goto] = ACTIONS(1523),
    [anon_sym_DASH_DASH] = ACTIONS(1525),
    [anon_sym_PLUS_PLUS] = ACTIONS(1525),
    [anon_sym_sizeof] = ACTIONS(1523),
    [anon_sym___alignof__] = ACTIONS(1523),
    [anon_sym___alignof] = ACTIONS(1523),
    [anon_sym__alignof] = ACTIONS(1523),
    [anon_sym_alignof] = ACTIONS(1523),
    [anon_sym__Alignof] = ACTIONS(1523),
    [anon_sym_offsetof] = ACTIONS(1523),
    [anon_sym__Generic] = ACTIONS(1523),
    [anon_sym_asm] = ACTIONS(1523),
    [anon_sym___asm__] = ACTIONS(1523),
    [sym_number_literal] = ACTIONS(1525),
    [anon_sym_L_SQUOTE] = ACTIONS(1525),
    [anon_sym_u_SQUOTE] = ACTIONS(1525),
    [anon_sym_U_SQUOTE] = ACTIONS(1525),
    [anon_sym_u8_SQUOTE] = ACTIONS(1525),
    [anon_sym_SQUOTE] = ACTIONS(1525),
    [anon_sym_L_DQUOTE] = ACTIONS(1525),
    [anon_sym_u_DQUOTE] = ACTIONS(1525),
    [anon_sym_U_DQUOTE] = ACTIONS(1525),
    [anon_sym_u8_DQUOTE] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [anon_sym_NULL] = ACTIONS(1523),
    [anon_sym_nullptr] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1523),
    [anon_sym_hitAttributeEXT] = ACTIONS(1523),
    [anon_sym_callableDataEXT] = ACTIONS(1523),
    [anon_sym_callableDataInEXT] = ACTIONS(1523),
    [anon_sym_shaderRecordEXT] = ACTIONS(1523),
    [anon_sym_rayPayloadNV] = ACTIONS(1523),
    [anon_sym_rayPayloadInNV] = ACTIONS(1523),
    [anon_sym_hitAttributeNV] = ACTIONS(1523),
    [anon_sym_callableDataNV] = ACTIONS(1523),
    [anon_sym_callableDataInNV] = ACTIONS(1523),
    [anon_sym_shaderRecordNV] = ACTIONS(1523),
    [anon_sym_layout] = ACTIONS(1523),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1397),
    [aux_sym_preproc_include_token1] = ACTIONS(1397),
    [aux_sym_preproc_def_token1] = ACTIONS(1397),
    [aux_sym_preproc_if_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1397),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1397),
    [sym_preproc_directive] = ACTIONS(1397),
    [anon_sym_LPAREN2] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_subroutine] = ACTIONS(1397),
    [anon_sym_invariant] = ACTIONS(1397),
    [anon_sym_precise] = ACTIONS(1397),
    [anon_sym_in] = ACTIONS(1397),
    [anon_sym_out] = ACTIONS(1397),
    [anon_sym_inout] = ACTIONS(1397),
    [anon_sym_uniform] = ACTIONS(1397),
    [anon_sym_shared] = ACTIONS(1397),
    [anon_sym_attribute] = ACTIONS(1397),
    [anon_sym_varying] = ACTIONS(1397),
    [anon_sym_buffer] = ACTIONS(1397),
    [anon_sym_coherent] = ACTIONS(1397),
    [anon_sym_readonly] = ACTIONS(1397),
    [anon_sym_writeonly] = ACTIONS(1397),
    [anon_sym_precision] = ACTIONS(1397),
    [anon_sym_highp] = ACTIONS(1397),
    [anon_sym_mediump] = ACTIONS(1397),
    [anon_sym_lowp] = ACTIONS(1397),
    [anon_sym_centroid] = ACTIONS(1397),
    [anon_sym_sample] = ACTIONS(1397),
    [anon_sym_patch] = ACTIONS(1397),
    [anon_sym_smooth] = ACTIONS(1397),
    [anon_sym_flat] = ACTIONS(1397),
    [anon_sym_noperspective] = ACTIONS(1397),
    [anon_sym___extension__] = ACTIONS(1397),
    [anon_sym_typedef] = ACTIONS(1397),
    [anon_sym_extern] = ACTIONS(1397),
    [anon_sym___attribute__] = ACTIONS(1397),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1399),
    [anon_sym___declspec] = ACTIONS(1397),
    [anon_sym___cdecl] = ACTIONS(1397),
    [anon_sym___clrcall] = ACTIONS(1397),
    [anon_sym___stdcall] = ACTIONS(1397),
    [anon_sym___fastcall] = ACTIONS(1397),
    [anon_sym___thiscall] = ACTIONS(1397),
    [anon_sym___vectorcall] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_signed] = ACTIONS(1397),
    [anon_sym_unsigned] = ACTIONS(1397),
    [anon_sym_long] = ACTIONS(1397),
    [anon_sym_short] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_auto] = ACTIONS(1397),
    [anon_sym_register] = ACTIONS(1397),
    [anon_sym_inline] = ACTIONS(1397),
    [anon_sym___inline] = ACTIONS(1397),
    [anon_sym___inline__] = ACTIONS(1397),
    [anon_sym___forceinline] = ACTIONS(1397),
    [anon_sym_thread_local] = ACTIONS(1397),
    [anon_sym___thread] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_constexpr] = ACTIONS(1397),
    [anon_sym_volatile] = ACTIONS(1397),
    [anon_sym_restrict] = ACTIONS(1397),
    [anon_sym___restrict__] = ACTIONS(1397),
    [anon_sym__Atomic] = ACTIONS(1397),
    [anon_sym__Noreturn] = ACTIONS(1397),
    [anon_sym_noreturn] = ACTIONS(1397),
    [anon_sym_alignas] = ACTIONS(1397),
    [anon_sym__Alignas] = ACTIONS(1397),
    [sym_primitive_type] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_goto] = ACTIONS(1397),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_sizeof] = ACTIONS(1397),
    [anon_sym___alignof__] = ACTIONS(1397),
    [anon_sym___alignof] = ACTIONS(1397),
    [anon_sym__alignof] = ACTIONS(1397),
    [anon_sym_alignof] = ACTIONS(1397),
    [anon_sym__Alignof] = ACTIONS(1397),
    [anon_sym_offsetof] = ACTIONS(1397),
    [anon_sym__Generic] = ACTIONS(1397),
    [anon_sym_asm] = ACTIONS(1397),
    [anon_sym___asm__] = ACTIONS(1397),
    [sym_number_literal] = ACTIONS(1399),
    [anon_sym_L_SQUOTE] = ACTIONS(1399),
    [anon_sym_u_SQUOTE] = ACTIONS(1399),
    [anon_sym_U_SQUOTE] = ACTIONS(1399),
    [anon_sym_u8_SQUOTE] = ACTIONS(1399),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [anon_sym_L_DQUOTE] = ACTIONS(1399),
    [anon_sym_u_DQUOTE] = ACTIONS(1399),
    [anon_sym_U_DQUOTE] = ACTIONS(1399),
    [anon_sym_u8_DQUOTE] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1397),
    [anon_sym_nullptr] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1397),
    [anon_sym_hitAttributeEXT] = ACTIONS(1397),
    [anon_sym_callableDataEXT] = ACTIONS(1397),
    [anon_sym_callableDataInEXT] = ACTIONS(1397),
    [anon_sym_shaderRecordEXT] = ACTIONS(1397),
    [anon_sym_rayPayloadNV] = ACTIONS(1397),
    [anon_sym_rayPayloadInNV] = ACTIONS(1397),
    [anon_sym_hitAttributeNV] = ACTIONS(1397),
    [anon_sym_callableDataNV] = ACTIONS(1397),
    [anon_sym_callableDataInNV] = ACTIONS(1397),
    [anon_sym_shaderRecordNV] = ACTIONS(1397),
    [anon_sym_layout] = ACTIONS(1397),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1519),
    [aux_sym_preproc_include_token1] = ACTIONS(1519),
    [aux_sym_preproc_def_token1] = ACTIONS(1519),
    [aux_sym_preproc_if_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1519),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1519),
    [sym_preproc_directive] = ACTIONS(1519),
    [anon_sym_LPAREN2] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_subroutine] = ACTIONS(1519),
    [anon_sym_invariant] = ACTIONS(1519),
    [anon_sym_precise] = ACTIONS(1519),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_out] = ACTIONS(1519),
    [anon_sym_inout] = ACTIONS(1519),
    [anon_sym_uniform] = ACTIONS(1519),
    [anon_sym_shared] = ACTIONS(1519),
    [anon_sym_attribute] = ACTIONS(1519),
    [anon_sym_varying] = ACTIONS(1519),
    [anon_sym_buffer] = ACTIONS(1519),
    [anon_sym_coherent] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_writeonly] = ACTIONS(1519),
    [anon_sym_precision] = ACTIONS(1519),
    [anon_sym_highp] = ACTIONS(1519),
    [anon_sym_mediump] = ACTIONS(1519),
    [anon_sym_lowp] = ACTIONS(1519),
    [anon_sym_centroid] = ACTIONS(1519),
    [anon_sym_sample] = ACTIONS(1519),
    [anon_sym_patch] = ACTIONS(1519),
    [anon_sym_smooth] = ACTIONS(1519),
    [anon_sym_flat] = ACTIONS(1519),
    [anon_sym_noperspective] = ACTIONS(1519),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(1519),
    [anon_sym_extern] = ACTIONS(1519),
    [anon_sym___attribute__] = ACTIONS(1519),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1521),
    [anon_sym___declspec] = ACTIONS(1519),
    [anon_sym___cdecl] = ACTIONS(1519),
    [anon_sym___clrcall] = ACTIONS(1519),
    [anon_sym___stdcall] = ACTIONS(1519),
    [anon_sym___fastcall] = ACTIONS(1519),
    [anon_sym___thiscall] = ACTIONS(1519),
    [anon_sym___vectorcall] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_signed] = ACTIONS(1519),
    [anon_sym_unsigned] = ACTIONS(1519),
    [anon_sym_long] = ACTIONS(1519),
    [anon_sym_short] = ACTIONS(1519),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_auto] = ACTIONS(1519),
    [anon_sym_register] = ACTIONS(1519),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym___inline] = ACTIONS(1519),
    [anon_sym___inline__] = ACTIONS(1519),
    [anon_sym___forceinline] = ACTIONS(1519),
    [anon_sym_thread_local] = ACTIONS(1519),
    [anon_sym___thread] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_constexpr] = ACTIONS(1519),
    [anon_sym_volatile] = ACTIONS(1519),
    [anon_sym_restrict] = ACTIONS(1519),
    [anon_sym___restrict__] = ACTIONS(1519),
    [anon_sym__Atomic] = ACTIONS(1519),
    [anon_sym__Noreturn] = ACTIONS(1519),
    [anon_sym_noreturn] = ACTIONS(1519),
    [anon_sym_alignas] = ACTIONS(1519),
    [anon_sym__Alignas] = ACTIONS(1519),
    [sym_primitive_type] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [anon_sym_struct] = ACTIONS(1519),
    [anon_sym_union] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_goto] = ACTIONS(1519),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_sizeof] = ACTIONS(1519),
    [anon_sym___alignof__] = ACTIONS(1519),
    [anon_sym___alignof] = ACTIONS(1519),
    [anon_sym__alignof] = ACTIONS(1519),
    [anon_sym_alignof] = ACTIONS(1519),
    [anon_sym__Alignof] = ACTIONS(1519),
    [anon_sym_offsetof] = ACTIONS(1519),
    [anon_sym__Generic] = ACTIONS(1519),
    [anon_sym_asm] = ACTIONS(1519),
    [anon_sym___asm__] = ACTIONS(1519),
    [sym_number_literal] = ACTIONS(1521),
    [anon_sym_L_SQUOTE] = ACTIONS(1521),
    [anon_sym_u_SQUOTE] = ACTIONS(1521),
    [anon_sym_U_SQUOTE] = ACTIONS(1521),
    [anon_sym_u8_SQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [anon_sym_L_DQUOTE] = ACTIONS(1521),
    [anon_sym_u_DQUOTE] = ACTIONS(1521),
    [anon_sym_U_DQUOTE] = ACTIONS(1521),
    [anon_sym_u8_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [anon_sym_NULL] = ACTIONS(1519),
    [anon_sym_nullptr] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1519),
    [anon_sym_hitAttributeEXT] = ACTIONS(1519),
    [anon_sym_callableDataEXT] = ACTIONS(1519),
    [anon_sym_callableDataInEXT] = ACTIONS(1519),
    [anon_sym_shaderRecordEXT] = ACTIONS(1519),
    [anon_sym_rayPayloadNV] = ACTIONS(1519),
    [anon_sym_rayPayloadInNV] = ACTIONS(1519),
    [anon_sym_hitAttributeNV] = ACTIONS(1519),
    [anon_sym_callableDataNV] = ACTIONS(1519),
    [anon_sym_callableDataInNV] = ACTIONS(1519),
    [anon_sym_shaderRecordNV] = ACTIONS(1519),
    [anon_sym_layout] = ACTIONS(1519),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1457),
    [aux_sym_preproc_include_token1] = ACTIONS(1457),
    [aux_sym_preproc_def_token1] = ACTIONS(1457),
    [aux_sym_preproc_if_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1457),
    [sym_preproc_directive] = ACTIONS(1457),
    [anon_sym_LPAREN2] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1457),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_subroutine] = ACTIONS(1457),
    [anon_sym_invariant] = ACTIONS(1457),
    [anon_sym_precise] = ACTIONS(1457),
    [anon_sym_in] = ACTIONS(1457),
    [anon_sym_out] = ACTIONS(1457),
    [anon_sym_inout] = ACTIONS(1457),
    [anon_sym_uniform] = ACTIONS(1457),
    [anon_sym_shared] = ACTIONS(1457),
    [anon_sym_attribute] = ACTIONS(1457),
    [anon_sym_varying] = ACTIONS(1457),
    [anon_sym_buffer] = ACTIONS(1457),
    [anon_sym_coherent] = ACTIONS(1457),
    [anon_sym_readonly] = ACTIONS(1457),
    [anon_sym_writeonly] = ACTIONS(1457),
    [anon_sym_precision] = ACTIONS(1457),
    [anon_sym_highp] = ACTIONS(1457),
    [anon_sym_mediump] = ACTIONS(1457),
    [anon_sym_lowp] = ACTIONS(1457),
    [anon_sym_centroid] = ACTIONS(1457),
    [anon_sym_sample] = ACTIONS(1457),
    [anon_sym_patch] = ACTIONS(1457),
    [anon_sym_smooth] = ACTIONS(1457),
    [anon_sym_flat] = ACTIONS(1457),
    [anon_sym_noperspective] = ACTIONS(1457),
    [anon_sym___extension__] = ACTIONS(1457),
    [anon_sym_typedef] = ACTIONS(1457),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym___attribute__] = ACTIONS(1457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1459),
    [anon_sym___declspec] = ACTIONS(1457),
    [anon_sym___cdecl] = ACTIONS(1457),
    [anon_sym___clrcall] = ACTIONS(1457),
    [anon_sym___stdcall] = ACTIONS(1457),
    [anon_sym___fastcall] = ACTIONS(1457),
    [anon_sym___thiscall] = ACTIONS(1457),
    [anon_sym___vectorcall] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_signed] = ACTIONS(1457),
    [anon_sym_unsigned] = ACTIONS(1457),
    [anon_sym_long] = ACTIONS(1457),
    [anon_sym_short] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_auto] = ACTIONS(1457),
    [anon_sym_register] = ACTIONS(1457),
    [anon_sym_inline] = ACTIONS(1457),
    [anon_sym___inline] = ACTIONS(1457),
    [anon_sym___inline__] = ACTIONS(1457),
    [anon_sym___forceinline] = ACTIONS(1457),
    [anon_sym_thread_local] = ACTIONS(1457),
    [anon_sym___thread] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_constexpr] = ACTIONS(1457),
    [anon_sym_volatile] = ACTIONS(1457),
    [anon_sym_restrict] = ACTIONS(1457),
    [anon_sym___restrict__] = ACTIONS(1457),
    [anon_sym__Atomic] = ACTIONS(1457),
    [anon_sym__Noreturn] = ACTIONS(1457),
    [anon_sym_noreturn] = ACTIONS(1457),
    [anon_sym_alignas] = ACTIONS(1457),
    [anon_sym__Alignas] = ACTIONS(1457),
    [sym_primitive_type] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1457),
    [anon_sym_case] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_do] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_goto] = ACTIONS(1457),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_sizeof] = ACTIONS(1457),
    [anon_sym___alignof__] = ACTIONS(1457),
    [anon_sym___alignof] = ACTIONS(1457),
    [anon_sym__alignof] = ACTIONS(1457),
    [anon_sym_alignof] = ACTIONS(1457),
    [anon_sym__Alignof] = ACTIONS(1457),
    [anon_sym_offsetof] = ACTIONS(1457),
    [anon_sym__Generic] = ACTIONS(1457),
    [anon_sym_asm] = ACTIONS(1457),
    [anon_sym___asm__] = ACTIONS(1457),
    [sym_number_literal] = ACTIONS(1459),
    [anon_sym_L_SQUOTE] = ACTIONS(1459),
    [anon_sym_u_SQUOTE] = ACTIONS(1459),
    [anon_sym_U_SQUOTE] = ACTIONS(1459),
    [anon_sym_u8_SQUOTE] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1459),
    [anon_sym_L_DQUOTE] = ACTIONS(1459),
    [anon_sym_u_DQUOTE] = ACTIONS(1459),
    [anon_sym_U_DQUOTE] = ACTIONS(1459),
    [anon_sym_u8_DQUOTE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_true] = ACTIONS(1457),
    [sym_false] = ACTIONS(1457),
    [anon_sym_NULL] = ACTIONS(1457),
    [anon_sym_nullptr] = ACTIONS(1457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1457),
    [anon_sym_hitAttributeEXT] = ACTIONS(1457),
    [anon_sym_callableDataEXT] = ACTIONS(1457),
    [anon_sym_callableDataInEXT] = ACTIONS(1457),
    [anon_sym_shaderRecordEXT] = ACTIONS(1457),
    [anon_sym_rayPayloadNV] = ACTIONS(1457),
    [anon_sym_rayPayloadInNV] = ACTIONS(1457),
    [anon_sym_hitAttributeNV] = ACTIONS(1457),
    [anon_sym_callableDataNV] = ACTIONS(1457),
    [anon_sym_callableDataInNV] = ACTIONS(1457),
    [anon_sym_shaderRecordNV] = ACTIONS(1457),
    [anon_sym_layout] = ACTIONS(1457),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1499),
    [sym_identifier] = ACTIONS(1497),
    [aux_sym_preproc_include_token1] = ACTIONS(1497),
    [aux_sym_preproc_def_token1] = ACTIONS(1497),
    [aux_sym_preproc_if_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1497),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1497),
    [sym_preproc_directive] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_subroutine] = ACTIONS(1497),
    [anon_sym_invariant] = ACTIONS(1497),
    [anon_sym_precise] = ACTIONS(1497),
    [anon_sym_in] = ACTIONS(1497),
    [anon_sym_out] = ACTIONS(1497),
    [anon_sym_inout] = ACTIONS(1497),
    [anon_sym_uniform] = ACTIONS(1497),
    [anon_sym_shared] = ACTIONS(1497),
    [anon_sym_attribute] = ACTIONS(1497),
    [anon_sym_varying] = ACTIONS(1497),
    [anon_sym_buffer] = ACTIONS(1497),
    [anon_sym_coherent] = ACTIONS(1497),
    [anon_sym_readonly] = ACTIONS(1497),
    [anon_sym_writeonly] = ACTIONS(1497),
    [anon_sym_precision] = ACTIONS(1497),
    [anon_sym_highp] = ACTIONS(1497),
    [anon_sym_mediump] = ACTIONS(1497),
    [anon_sym_lowp] = ACTIONS(1497),
    [anon_sym_centroid] = ACTIONS(1497),
    [anon_sym_sample] = ACTIONS(1497),
    [anon_sym_patch] = ACTIONS(1497),
    [anon_sym_smooth] = ACTIONS(1497),
    [anon_sym_flat] = ACTIONS(1497),
    [anon_sym_noperspective] = ACTIONS(1497),
    [anon_sym___extension__] = ACTIONS(1497),
    [anon_sym_typedef] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(1497),
    [anon_sym___attribute__] = ACTIONS(1497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1499),
    [anon_sym___declspec] = ACTIONS(1497),
    [anon_sym___cdecl] = ACTIONS(1497),
    [anon_sym___clrcall] = ACTIONS(1497),
    [anon_sym___stdcall] = ACTIONS(1497),
    [anon_sym___fastcall] = ACTIONS(1497),
    [anon_sym___thiscall] = ACTIONS(1497),
    [anon_sym___vectorcall] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1499),
    [anon_sym_signed] = ACTIONS(1497),
    [anon_sym_unsigned] = ACTIONS(1497),
    [anon_sym_long] = ACTIONS(1497),
    [anon_sym_short] = ACTIONS(1497),
    [anon_sym_static] = ACTIONS(1497),
    [anon_sym_auto] = ACTIONS(1497),
    [anon_sym_register] = ACTIONS(1497),
    [anon_sym_inline] = ACTIONS(1497),
    [anon_sym___inline] = ACTIONS(1497),
    [anon_sym___inline__] = ACTIONS(1497),
    [anon_sym___forceinline] = ACTIONS(1497),
    [anon_sym_thread_local] = ACTIONS(1497),
    [anon_sym___thread] = ACTIONS(1497),
    [anon_sym_const] = ACTIONS(1497),
    [anon_sym_constexpr] = ACTIONS(1497),
    [anon_sym_volatile] = ACTIONS(1497),
    [anon_sym_restrict] = ACTIONS(1497),
    [anon_sym___restrict__] = ACTIONS(1497),
    [anon_sym__Atomic] = ACTIONS(1497),
    [anon_sym__Noreturn] = ACTIONS(1497),
    [anon_sym_noreturn] = ACTIONS(1497),
    [anon_sym_alignas] = ACTIONS(1497),
    [anon_sym__Alignas] = ACTIONS(1497),
    [sym_primitive_type] = ACTIONS(1497),
    [anon_sym_enum] = ACTIONS(1497),
    [anon_sym_struct] = ACTIONS(1497),
    [anon_sym_union] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(1497),
    [anon_sym_switch] = ACTIONS(1497),
    [anon_sym_case] = ACTIONS(1497),
    [anon_sym_default] = ACTIONS(1497),
    [anon_sym_while] = ACTIONS(1497),
    [anon_sym_do] = ACTIONS(1497),
    [anon_sym_for] = ACTIONS(1497),
    [anon_sym_return] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1497),
    [anon_sym_continue] = ACTIONS(1497),
    [anon_sym_goto] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_sizeof] = ACTIONS(1497),
    [anon_sym___alignof__] = ACTIONS(1497),
    [anon_sym___alignof] = ACTIONS(1497),
    [anon_sym__alignof] = ACTIONS(1497),
    [anon_sym_alignof] = ACTIONS(1497),
    [anon_sym__Alignof] = ACTIONS(1497),
    [anon_sym_offsetof] = ACTIONS(1497),
    [anon_sym__Generic] = ACTIONS(1497),
    [anon_sym_asm] = ACTIONS(1497),
    [anon_sym___asm__] = ACTIONS(1497),
    [sym_number_literal] = ACTIONS(1499),
    [anon_sym_L_SQUOTE] = ACTIONS(1499),
    [anon_sym_u_SQUOTE] = ACTIONS(1499),
    [anon_sym_U_SQUOTE] = ACTIONS(1499),
    [anon_sym_u8_SQUOTE] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_L_DQUOTE] = ACTIONS(1499),
    [anon_sym_u_DQUOTE] = ACTIONS(1499),
    [anon_sym_U_DQUOTE] = ACTIONS(1499),
    [anon_sym_u8_DQUOTE] = ACTIONS(1499),
    [anon_sym_DQUOTE] = ACTIONS(1499),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [anon_sym_NULL] = ACTIONS(1497),
    [anon_sym_nullptr] = ACTIONS(1497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1497),
    [anon_sym_hitAttributeEXT] = ACTIONS(1497),
    [anon_sym_callableDataEXT] = ACTIONS(1497),
    [anon_sym_callableDataInEXT] = ACTIONS(1497),
    [anon_sym_shaderRecordEXT] = ACTIONS(1497),
    [anon_sym_rayPayloadNV] = ACTIONS(1497),
    [anon_sym_rayPayloadInNV] = ACTIONS(1497),
    [anon_sym_hitAttributeNV] = ACTIONS(1497),
    [anon_sym_callableDataNV] = ACTIONS(1497),
    [anon_sym_callableDataInNV] = ACTIONS(1497),
    [anon_sym_shaderRecordNV] = ACTIONS(1497),
    [anon_sym_layout] = ACTIONS(1497),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1503),
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1501),
    [aux_sym_preproc_def_token1] = ACTIONS(1501),
    [aux_sym_preproc_if_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1501),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1501),
    [sym_preproc_directive] = ACTIONS(1501),
    [anon_sym_LPAREN2] = ACTIONS(1503),
    [anon_sym_BANG] = ACTIONS(1503),
    [anon_sym_TILDE] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_AMP] = ACTIONS(1503),
    [anon_sym_subroutine] = ACTIONS(1501),
    [anon_sym_invariant] = ACTIONS(1501),
    [anon_sym_precise] = ACTIONS(1501),
    [anon_sym_in] = ACTIONS(1501),
    [anon_sym_out] = ACTIONS(1501),
    [anon_sym_inout] = ACTIONS(1501),
    [anon_sym_uniform] = ACTIONS(1501),
    [anon_sym_shared] = ACTIONS(1501),
    [anon_sym_attribute] = ACTIONS(1501),
    [anon_sym_varying] = ACTIONS(1501),
    [anon_sym_buffer] = ACTIONS(1501),
    [anon_sym_coherent] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_writeonly] = ACTIONS(1501),
    [anon_sym_precision] = ACTIONS(1501),
    [anon_sym_highp] = ACTIONS(1501),
    [anon_sym_mediump] = ACTIONS(1501),
    [anon_sym_lowp] = ACTIONS(1501),
    [anon_sym_centroid] = ACTIONS(1501),
    [anon_sym_sample] = ACTIONS(1501),
    [anon_sym_patch] = ACTIONS(1501),
    [anon_sym_smooth] = ACTIONS(1501),
    [anon_sym_flat] = ACTIONS(1501),
    [anon_sym_noperspective] = ACTIONS(1501),
    [anon_sym___extension__] = ACTIONS(1501),
    [anon_sym_typedef] = ACTIONS(1501),
    [anon_sym_extern] = ACTIONS(1501),
    [anon_sym___attribute__] = ACTIONS(1501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1503),
    [anon_sym___declspec] = ACTIONS(1501),
    [anon_sym___cdecl] = ACTIONS(1501),
    [anon_sym___clrcall] = ACTIONS(1501),
    [anon_sym___stdcall] = ACTIONS(1501),
    [anon_sym___fastcall] = ACTIONS(1501),
    [anon_sym___thiscall] = ACTIONS(1501),
    [anon_sym___vectorcall] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1503),
    [anon_sym_signed] = ACTIONS(1501),
    [anon_sym_unsigned] = ACTIONS(1501),
    [anon_sym_long] = ACTIONS(1501),
    [anon_sym_short] = ACTIONS(1501),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_auto] = ACTIONS(1501),
    [anon_sym_register] = ACTIONS(1501),
    [anon_sym_inline] = ACTIONS(1501),
    [anon_sym___inline] = ACTIONS(1501),
    [anon_sym___inline__] = ACTIONS(1501),
    [anon_sym___forceinline] = ACTIONS(1501),
    [anon_sym_thread_local] = ACTIONS(1501),
    [anon_sym___thread] = ACTIONS(1501),
    [anon_sym_const] = ACTIONS(1501),
    [anon_sym_constexpr] = ACTIONS(1501),
    [anon_sym_volatile] = ACTIONS(1501),
    [anon_sym_restrict] = ACTIONS(1501),
    [anon_sym___restrict__] = ACTIONS(1501),
    [anon_sym__Atomic] = ACTIONS(1501),
    [anon_sym__Noreturn] = ACTIONS(1501),
    [anon_sym_noreturn] = ACTIONS(1501),
    [anon_sym_alignas] = ACTIONS(1501),
    [anon_sym__Alignas] = ACTIONS(1501),
    [sym_primitive_type] = ACTIONS(1501),
    [anon_sym_enum] = ACTIONS(1501),
    [anon_sym_struct] = ACTIONS(1501),
    [anon_sym_union] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(1501),
    [anon_sym_switch] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1501),
    [anon_sym_default] = ACTIONS(1501),
    [anon_sym_while] = ACTIONS(1501),
    [anon_sym_do] = ACTIONS(1501),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_return] = ACTIONS(1501),
    [anon_sym_break] = ACTIONS(1501),
    [anon_sym_continue] = ACTIONS(1501),
    [anon_sym_goto] = ACTIONS(1501),
    [anon_sym_DASH_DASH] = ACTIONS(1503),
    [anon_sym_PLUS_PLUS] = ACTIONS(1503),
    [anon_sym_sizeof] = ACTIONS(1501),
    [anon_sym___alignof__] = ACTIONS(1501),
    [anon_sym___alignof] = ACTIONS(1501),
    [anon_sym__alignof] = ACTIONS(1501),
    [anon_sym_alignof] = ACTIONS(1501),
    [anon_sym__Alignof] = ACTIONS(1501),
    [anon_sym_offsetof] = ACTIONS(1501),
    [anon_sym__Generic] = ACTIONS(1501),
    [anon_sym_asm] = ACTIONS(1501),
    [anon_sym___asm__] = ACTIONS(1501),
    [sym_number_literal] = ACTIONS(1503),
    [anon_sym_L_SQUOTE] = ACTIONS(1503),
    [anon_sym_u_SQUOTE] = ACTIONS(1503),
    [anon_sym_U_SQUOTE] = ACTIONS(1503),
    [anon_sym_u8_SQUOTE] = ACTIONS(1503),
    [anon_sym_SQUOTE] = ACTIONS(1503),
    [anon_sym_L_DQUOTE] = ACTIONS(1503),
    [anon_sym_u_DQUOTE] = ACTIONS(1503),
    [anon_sym_U_DQUOTE] = ACTIONS(1503),
    [anon_sym_u8_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1503),
    [sym_true] = ACTIONS(1501),
    [sym_false] = ACTIONS(1501),
    [anon_sym_NULL] = ACTIONS(1501),
    [anon_sym_nullptr] = ACTIONS(1501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1501),
    [anon_sym_hitAttributeEXT] = ACTIONS(1501),
    [anon_sym_callableDataEXT] = ACTIONS(1501),
    [anon_sym_callableDataInEXT] = ACTIONS(1501),
    [anon_sym_shaderRecordEXT] = ACTIONS(1501),
    [anon_sym_rayPayloadNV] = ACTIONS(1501),
    [anon_sym_rayPayloadInNV] = ACTIONS(1501),
    [anon_sym_hitAttributeNV] = ACTIONS(1501),
    [anon_sym_callableDataNV] = ACTIONS(1501),
    [anon_sym_callableDataInNV] = ACTIONS(1501),
    [anon_sym_shaderRecordNV] = ACTIONS(1501),
    [anon_sym_layout] = ACTIONS(1501),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1435),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1425),
    [aux_sym_preproc_include_token1] = ACTIONS(1425),
    [aux_sym_preproc_def_token1] = ACTIONS(1425),
    [aux_sym_preproc_if_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1425),
    [sym_preproc_directive] = ACTIONS(1425),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_subroutine] = ACTIONS(1425),
    [anon_sym_invariant] = ACTIONS(1425),
    [anon_sym_precise] = ACTIONS(1425),
    [anon_sym_in] = ACTIONS(1425),
    [anon_sym_out] = ACTIONS(1425),
    [anon_sym_inout] = ACTIONS(1425),
    [anon_sym_uniform] = ACTIONS(1425),
    [anon_sym_shared] = ACTIONS(1425),
    [anon_sym_attribute] = ACTIONS(1425),
    [anon_sym_varying] = ACTIONS(1425),
    [anon_sym_buffer] = ACTIONS(1425),
    [anon_sym_coherent] = ACTIONS(1425),
    [anon_sym_readonly] = ACTIONS(1425),
    [anon_sym_writeonly] = ACTIONS(1425),
    [anon_sym_precision] = ACTIONS(1425),
    [anon_sym_highp] = ACTIONS(1425),
    [anon_sym_mediump] = ACTIONS(1425),
    [anon_sym_lowp] = ACTIONS(1425),
    [anon_sym_centroid] = ACTIONS(1425),
    [anon_sym_sample] = ACTIONS(1425),
    [anon_sym_patch] = ACTIONS(1425),
    [anon_sym_smooth] = ACTIONS(1425),
    [anon_sym_flat] = ACTIONS(1425),
    [anon_sym_noperspective] = ACTIONS(1425),
    [anon_sym___extension__] = ACTIONS(1425),
    [anon_sym_typedef] = ACTIONS(1425),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym___attribute__] = ACTIONS(1425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1427),
    [anon_sym___declspec] = ACTIONS(1425),
    [anon_sym___cdecl] = ACTIONS(1425),
    [anon_sym___clrcall] = ACTIONS(1425),
    [anon_sym___stdcall] = ACTIONS(1425),
    [anon_sym___fastcall] = ACTIONS(1425),
    [anon_sym___thiscall] = ACTIONS(1425),
    [anon_sym___vectorcall] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_signed] = ACTIONS(1425),
    [anon_sym_unsigned] = ACTIONS(1425),
    [anon_sym_long] = ACTIONS(1425),
    [anon_sym_short] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_auto] = ACTIONS(1425),
    [anon_sym_register] = ACTIONS(1425),
    [anon_sym_inline] = ACTIONS(1425),
    [anon_sym___inline] = ACTIONS(1425),
    [anon_sym___inline__] = ACTIONS(1425),
    [anon_sym___forceinline] = ACTIONS(1425),
    [anon_sym_thread_local] = ACTIONS(1425),
    [anon_sym___thread] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_constexpr] = ACTIONS(1425),
    [anon_sym_volatile] = ACTIONS(1425),
    [anon_sym_restrict] = ACTIONS(1425),
    [anon_sym___restrict__] = ACTIONS(1425),
    [anon_sym__Atomic] = ACTIONS(1425),
    [anon_sym__Noreturn] = ACTIONS(1425),
    [anon_sym_noreturn] = ACTIONS(1425),
    [anon_sym_alignas] = ACTIONS(1425),
    [anon_sym__Alignas] = ACTIONS(1425),
    [sym_primitive_type] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1425),
    [anon_sym_case] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_do] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_goto] = ACTIONS(1425),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_sizeof] = ACTIONS(1425),
    [anon_sym___alignof__] = ACTIONS(1425),
    [anon_sym___alignof] = ACTIONS(1425),
    [anon_sym__alignof] = ACTIONS(1425),
    [anon_sym_alignof] = ACTIONS(1425),
    [anon_sym__Alignof] = ACTIONS(1425),
    [anon_sym_offsetof] = ACTIONS(1425),
    [anon_sym__Generic] = ACTIONS(1425),
    [anon_sym_asm] = ACTIONS(1425),
    [anon_sym___asm__] = ACTIONS(1425),
    [sym_number_literal] = ACTIONS(1427),
    [anon_sym_L_SQUOTE] = ACTIONS(1427),
    [anon_sym_u_SQUOTE] = ACTIONS(1427),
    [anon_sym_U_SQUOTE] = ACTIONS(1427),
    [anon_sym_u8_SQUOTE] = ACTIONS(1427),
    [anon_sym_SQUOTE] = ACTIONS(1427),
    [anon_sym_L_DQUOTE] = ACTIONS(1427),
    [anon_sym_u_DQUOTE] = ACTIONS(1427),
    [anon_sym_U_DQUOTE] = ACTIONS(1427),
    [anon_sym_u8_DQUOTE] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1427),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [anon_sym_NULL] = ACTIONS(1425),
    [anon_sym_nullptr] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1425),
    [anon_sym_hitAttributeEXT] = ACTIONS(1425),
    [anon_sym_callableDataEXT] = ACTIONS(1425),
    [anon_sym_callableDataInEXT] = ACTIONS(1425),
    [anon_sym_shaderRecordEXT] = ACTIONS(1425),
    [anon_sym_rayPayloadNV] = ACTIONS(1425),
    [anon_sym_rayPayloadInNV] = ACTIONS(1425),
    [anon_sym_hitAttributeNV] = ACTIONS(1425),
    [anon_sym_callableDataNV] = ACTIONS(1425),
    [anon_sym_callableDataInNV] = ACTIONS(1425),
    [anon_sym_shaderRecordNV] = ACTIONS(1425),
    [anon_sym_layout] = ACTIONS(1425),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1511),
    [sym_identifier] = ACTIONS(1509),
    [aux_sym_preproc_include_token1] = ACTIONS(1509),
    [aux_sym_preproc_def_token1] = ACTIONS(1509),
    [aux_sym_preproc_if_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1509),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1509),
    [sym_preproc_directive] = ACTIONS(1509),
    [anon_sym_LPAREN2] = ACTIONS(1511),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_TILDE] = ACTIONS(1511),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_PLUS] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1511),
    [anon_sym_AMP] = ACTIONS(1511),
    [anon_sym_subroutine] = ACTIONS(1509),
    [anon_sym_invariant] = ACTIONS(1509),
    [anon_sym_precise] = ACTIONS(1509),
    [anon_sym_in] = ACTIONS(1509),
    [anon_sym_out] = ACTIONS(1509),
    [anon_sym_inout] = ACTIONS(1509),
    [anon_sym_uniform] = ACTIONS(1509),
    [anon_sym_shared] = ACTIONS(1509),
    [anon_sym_attribute] = ACTIONS(1509),
    [anon_sym_varying] = ACTIONS(1509),
    [anon_sym_buffer] = ACTIONS(1509),
    [anon_sym_coherent] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_writeonly] = ACTIONS(1509),
    [anon_sym_precision] = ACTIONS(1509),
    [anon_sym_highp] = ACTIONS(1509),
    [anon_sym_mediump] = ACTIONS(1509),
    [anon_sym_lowp] = ACTIONS(1509),
    [anon_sym_centroid] = ACTIONS(1509),
    [anon_sym_sample] = ACTIONS(1509),
    [anon_sym_patch] = ACTIONS(1509),
    [anon_sym_smooth] = ACTIONS(1509),
    [anon_sym_flat] = ACTIONS(1509),
    [anon_sym_noperspective] = ACTIONS(1509),
    [anon_sym___extension__] = ACTIONS(1509),
    [anon_sym_typedef] = ACTIONS(1509),
    [anon_sym_extern] = ACTIONS(1509),
    [anon_sym___attribute__] = ACTIONS(1509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1511),
    [anon_sym___declspec] = ACTIONS(1509),
    [anon_sym___cdecl] = ACTIONS(1509),
    [anon_sym___clrcall] = ACTIONS(1509),
    [anon_sym___stdcall] = ACTIONS(1509),
    [anon_sym___fastcall] = ACTIONS(1509),
    [anon_sym___thiscall] = ACTIONS(1509),
    [anon_sym___vectorcall] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_signed] = ACTIONS(1509),
    [anon_sym_unsigned] = ACTIONS(1509),
    [anon_sym_long] = ACTIONS(1509),
    [anon_sym_short] = ACTIONS(1509),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_auto] = ACTIONS(1509),
    [anon_sym_register] = ACTIONS(1509),
    [anon_sym_inline] = ACTIONS(1509),
    [anon_sym___inline] = ACTIONS(1509),
    [anon_sym___inline__] = ACTIONS(1509),
    [anon_sym___forceinline] = ACTIONS(1509),
    [anon_sym_thread_local] = ACTIONS(1509),
    [anon_sym___thread] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_constexpr] = ACTIONS(1509),
    [anon_sym_volatile] = ACTIONS(1509),
    [anon_sym_restrict] = ACTIONS(1509),
    [anon_sym___restrict__] = ACTIONS(1509),
    [anon_sym__Atomic] = ACTIONS(1509),
    [anon_sym__Noreturn] = ACTIONS(1509),
    [anon_sym_noreturn] = ACTIONS(1509),
    [anon_sym_alignas] = ACTIONS(1509),
    [anon_sym__Alignas] = ACTIONS(1509),
    [sym_primitive_type] = ACTIONS(1509),
    [anon_sym_enum] = ACTIONS(1509),
    [anon_sym_struct] = ACTIONS(1509),
    [anon_sym_union] = ACTIONS(1509),
    [anon_sym_if] = ACTIONS(1509),
    [anon_sym_switch] = ACTIONS(1509),
    [anon_sym_case] = ACTIONS(1509),
    [anon_sym_default] = ACTIONS(1509),
    [anon_sym_while] = ACTIONS(1509),
    [anon_sym_do] = ACTIONS(1509),
    [anon_sym_for] = ACTIONS(1509),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_break] = ACTIONS(1509),
    [anon_sym_continue] = ACTIONS(1509),
    [anon_sym_goto] = ACTIONS(1509),
    [anon_sym_DASH_DASH] = ACTIONS(1511),
    [anon_sym_PLUS_PLUS] = ACTIONS(1511),
    [anon_sym_sizeof] = ACTIONS(1509),
    [anon_sym___alignof__] = ACTIONS(1509),
    [anon_sym___alignof] = ACTIONS(1509),
    [anon_sym__alignof] = ACTIONS(1509),
    [anon_sym_alignof] = ACTIONS(1509),
    [anon_sym__Alignof] = ACTIONS(1509),
    [anon_sym_offsetof] = ACTIONS(1509),
    [anon_sym__Generic] = ACTIONS(1509),
    [anon_sym_asm] = ACTIONS(1509),
    [anon_sym___asm__] = ACTIONS(1509),
    [sym_number_literal] = ACTIONS(1511),
    [anon_sym_L_SQUOTE] = ACTIONS(1511),
    [anon_sym_u_SQUOTE] = ACTIONS(1511),
    [anon_sym_U_SQUOTE] = ACTIONS(1511),
    [anon_sym_u8_SQUOTE] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_L_DQUOTE] = ACTIONS(1511),
    [anon_sym_u_DQUOTE] = ACTIONS(1511),
    [anon_sym_U_DQUOTE] = ACTIONS(1511),
    [anon_sym_u8_DQUOTE] = ACTIONS(1511),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [sym_true] = ACTIONS(1509),
    [sym_false] = ACTIONS(1509),
    [anon_sym_NULL] = ACTIONS(1509),
    [anon_sym_nullptr] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1509),
    [anon_sym_hitAttributeEXT] = ACTIONS(1509),
    [anon_sym_callableDataEXT] = ACTIONS(1509),
    [anon_sym_callableDataInEXT] = ACTIONS(1509),
    [anon_sym_shaderRecordEXT] = ACTIONS(1509),
    [anon_sym_rayPayloadNV] = ACTIONS(1509),
    [anon_sym_rayPayloadInNV] = ACTIONS(1509),
    [anon_sym_hitAttributeNV] = ACTIONS(1509),
    [anon_sym_callableDataNV] = ACTIONS(1509),
    [anon_sym_callableDataInNV] = ACTIONS(1509),
    [anon_sym_shaderRecordNV] = ACTIONS(1509),
    [anon_sym_layout] = ACTIONS(1509),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1527),
    [aux_sym_preproc_include_token1] = ACTIONS(1527),
    [aux_sym_preproc_def_token1] = ACTIONS(1527),
    [aux_sym_preproc_if_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1527),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1527),
    [sym_preproc_directive] = ACTIONS(1527),
    [anon_sym_LPAREN2] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_TILDE] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1527),
    [anon_sym_PLUS] = ACTIONS(1527),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_subroutine] = ACTIONS(1527),
    [anon_sym_invariant] = ACTIONS(1527),
    [anon_sym_precise] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(1527),
    [anon_sym_out] = ACTIONS(1527),
    [anon_sym_inout] = ACTIONS(1527),
    [anon_sym_uniform] = ACTIONS(1527),
    [anon_sym_shared] = ACTIONS(1527),
    [anon_sym_attribute] = ACTIONS(1527),
    [anon_sym_varying] = ACTIONS(1527),
    [anon_sym_buffer] = ACTIONS(1527),
    [anon_sym_coherent] = ACTIONS(1527),
    [anon_sym_readonly] = ACTIONS(1527),
    [anon_sym_writeonly] = ACTIONS(1527),
    [anon_sym_precision] = ACTIONS(1527),
    [anon_sym_highp] = ACTIONS(1527),
    [anon_sym_mediump] = ACTIONS(1527),
    [anon_sym_lowp] = ACTIONS(1527),
    [anon_sym_centroid] = ACTIONS(1527),
    [anon_sym_sample] = ACTIONS(1527),
    [anon_sym_patch] = ACTIONS(1527),
    [anon_sym_smooth] = ACTIONS(1527),
    [anon_sym_flat] = ACTIONS(1527),
    [anon_sym_noperspective] = ACTIONS(1527),
    [anon_sym___extension__] = ACTIONS(1527),
    [anon_sym_typedef] = ACTIONS(1527),
    [anon_sym_extern] = ACTIONS(1527),
    [anon_sym___attribute__] = ACTIONS(1527),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1529),
    [anon_sym___declspec] = ACTIONS(1527),
    [anon_sym___cdecl] = ACTIONS(1527),
    [anon_sym___clrcall] = ACTIONS(1527),
    [anon_sym___stdcall] = ACTIONS(1527),
    [anon_sym___fastcall] = ACTIONS(1527),
    [anon_sym___thiscall] = ACTIONS(1527),
    [anon_sym___vectorcall] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_signed] = ACTIONS(1527),
    [anon_sym_unsigned] = ACTIONS(1527),
    [anon_sym_long] = ACTIONS(1527),
    [anon_sym_short] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_auto] = ACTIONS(1527),
    [anon_sym_register] = ACTIONS(1527),
    [anon_sym_inline] = ACTIONS(1527),
    [anon_sym___inline] = ACTIONS(1527),
    [anon_sym___inline__] = ACTIONS(1527),
    [anon_sym___forceinline] = ACTIONS(1527),
    [anon_sym_thread_local] = ACTIONS(1527),
    [anon_sym___thread] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_constexpr] = ACTIONS(1527),
    [anon_sym_volatile] = ACTIONS(1527),
    [anon_sym_restrict] = ACTIONS(1527),
    [anon_sym___restrict__] = ACTIONS(1527),
    [anon_sym__Atomic] = ACTIONS(1527),
    [anon_sym__Noreturn] = ACTIONS(1527),
    [anon_sym_noreturn] = ACTIONS(1527),
    [anon_sym_alignas] = ACTIONS(1527),
    [anon_sym__Alignas] = ACTIONS(1527),
    [sym_primitive_type] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_union] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_goto] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1527),
    [anon_sym___alignof__] = ACTIONS(1527),
    [anon_sym___alignof] = ACTIONS(1527),
    [anon_sym__alignof] = ACTIONS(1527),
    [anon_sym_alignof] = ACTIONS(1527),
    [anon_sym__Alignof] = ACTIONS(1527),
    [anon_sym_offsetof] = ACTIONS(1527),
    [anon_sym__Generic] = ACTIONS(1527),
    [anon_sym_asm] = ACTIONS(1527),
    [anon_sym___asm__] = ACTIONS(1527),
    [sym_number_literal] = ACTIONS(1529),
    [anon_sym_L_SQUOTE] = ACTIONS(1529),
    [anon_sym_u_SQUOTE] = ACTIONS(1529),
    [anon_sym_U_SQUOTE] = ACTIONS(1529),
    [anon_sym_u8_SQUOTE] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(1529),
    [anon_sym_L_DQUOTE] = ACTIONS(1529),
    [anon_sym_u_DQUOTE] = ACTIONS(1529),
    [anon_sym_U_DQUOTE] = ACTIONS(1529),
    [anon_sym_u8_DQUOTE] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1529),
    [sym_true] = ACTIONS(1527),
    [sym_false] = ACTIONS(1527),
    [anon_sym_NULL] = ACTIONS(1527),
    [anon_sym_nullptr] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1527),
    [anon_sym_hitAttributeEXT] = ACTIONS(1527),
    [anon_sym_callableDataEXT] = ACTIONS(1527),
    [anon_sym_callableDataInEXT] = ACTIONS(1527),
    [anon_sym_shaderRecordEXT] = ACTIONS(1527),
    [anon_sym_rayPayloadNV] = ACTIONS(1527),
    [anon_sym_rayPayloadInNV] = ACTIONS(1527),
    [anon_sym_hitAttributeNV] = ACTIONS(1527),
    [anon_sym_callableDataNV] = ACTIONS(1527),
    [anon_sym_callableDataInNV] = ACTIONS(1527),
    [anon_sym_shaderRecordNV] = ACTIONS(1527),
    [anon_sym_layout] = ACTIONS(1527),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1417),
    [aux_sym_preproc_include_token1] = ACTIONS(1417),
    [aux_sym_preproc_def_token1] = ACTIONS(1417),
    [aux_sym_preproc_if_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1417),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1417),
    [sym_preproc_directive] = ACTIONS(1417),
    [anon_sym_LPAREN2] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_subroutine] = ACTIONS(1417),
    [anon_sym_invariant] = ACTIONS(1417),
    [anon_sym_precise] = ACTIONS(1417),
    [anon_sym_in] = ACTIONS(1417),
    [anon_sym_out] = ACTIONS(1417),
    [anon_sym_inout] = ACTIONS(1417),
    [anon_sym_uniform] = ACTIONS(1417),
    [anon_sym_shared] = ACTIONS(1417),
    [anon_sym_attribute] = ACTIONS(1417),
    [anon_sym_varying] = ACTIONS(1417),
    [anon_sym_buffer] = ACTIONS(1417),
    [anon_sym_coherent] = ACTIONS(1417),
    [anon_sym_readonly] = ACTIONS(1417),
    [anon_sym_writeonly] = ACTIONS(1417),
    [anon_sym_precision] = ACTIONS(1417),
    [anon_sym_highp] = ACTIONS(1417),
    [anon_sym_mediump] = ACTIONS(1417),
    [anon_sym_lowp] = ACTIONS(1417),
    [anon_sym_centroid] = ACTIONS(1417),
    [anon_sym_sample] = ACTIONS(1417),
    [anon_sym_patch] = ACTIONS(1417),
    [anon_sym_smooth] = ACTIONS(1417),
    [anon_sym_flat] = ACTIONS(1417),
    [anon_sym_noperspective] = ACTIONS(1417),
    [anon_sym___extension__] = ACTIONS(1417),
    [anon_sym_typedef] = ACTIONS(1417),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym___attribute__] = ACTIONS(1417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1419),
    [anon_sym___declspec] = ACTIONS(1417),
    [anon_sym___cdecl] = ACTIONS(1417),
    [anon_sym___clrcall] = ACTIONS(1417),
    [anon_sym___stdcall] = ACTIONS(1417),
    [anon_sym___fastcall] = ACTIONS(1417),
    [anon_sym___thiscall] = ACTIONS(1417),
    [anon_sym___vectorcall] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_signed] = ACTIONS(1417),
    [anon_sym_unsigned] = ACTIONS(1417),
    [anon_sym_long] = ACTIONS(1417),
    [anon_sym_short] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_auto] = ACTIONS(1417),
    [anon_sym_register] = ACTIONS(1417),
    [anon_sym_inline] = ACTIONS(1417),
    [anon_sym___inline] = ACTIONS(1417),
    [anon_sym___inline__] = ACTIONS(1417),
    [anon_sym___forceinline] = ACTIONS(1417),
    [anon_sym_thread_local] = ACTIONS(1417),
    [anon_sym___thread] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_constexpr] = ACTIONS(1417),
    [anon_sym_volatile] = ACTIONS(1417),
    [anon_sym_restrict] = ACTIONS(1417),
    [anon_sym___restrict__] = ACTIONS(1417),
    [anon_sym__Atomic] = ACTIONS(1417),
    [anon_sym__Noreturn] = ACTIONS(1417),
    [anon_sym_noreturn] = ACTIONS(1417),
    [anon_sym_alignas] = ACTIONS(1417),
    [anon_sym__Alignas] = ACTIONS(1417),
    [sym_primitive_type] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1417),
    [anon_sym_case] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_do] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_goto] = ACTIONS(1417),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_sizeof] = ACTIONS(1417),
    [anon_sym___alignof__] = ACTIONS(1417),
    [anon_sym___alignof] = ACTIONS(1417),
    [anon_sym__alignof] = ACTIONS(1417),
    [anon_sym_alignof] = ACTIONS(1417),
    [anon_sym__Alignof] = ACTIONS(1417),
    [anon_sym_offsetof] = ACTIONS(1417),
    [anon_sym__Generic] = ACTIONS(1417),
    [anon_sym_asm] = ACTIONS(1417),
    [anon_sym___asm__] = ACTIONS(1417),
    [sym_number_literal] = ACTIONS(1419),
    [anon_sym_L_SQUOTE] = ACTIONS(1419),
    [anon_sym_u_SQUOTE] = ACTIONS(1419),
    [anon_sym_U_SQUOTE] = ACTIONS(1419),
    [anon_sym_u8_SQUOTE] = ACTIONS(1419),
    [anon_sym_SQUOTE] = ACTIONS(1419),
    [anon_sym_L_DQUOTE] = ACTIONS(1419),
    [anon_sym_u_DQUOTE] = ACTIONS(1419),
    [anon_sym_U_DQUOTE] = ACTIONS(1419),
    [anon_sym_u8_DQUOTE] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1419),
    [sym_true] = ACTIONS(1417),
    [sym_false] = ACTIONS(1417),
    [anon_sym_NULL] = ACTIONS(1417),
    [anon_sym_nullptr] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1417),
    [anon_sym_hitAttributeEXT] = ACTIONS(1417),
    [anon_sym_callableDataEXT] = ACTIONS(1417),
    [anon_sym_callableDataInEXT] = ACTIONS(1417),
    [anon_sym_shaderRecordEXT] = ACTIONS(1417),
    [anon_sym_rayPayloadNV] = ACTIONS(1417),
    [anon_sym_rayPayloadInNV] = ACTIONS(1417),
    [anon_sym_hitAttributeNV] = ACTIONS(1417),
    [anon_sym_callableDataNV] = ACTIONS(1417),
    [anon_sym_callableDataInNV] = ACTIONS(1417),
    [anon_sym_shaderRecordNV] = ACTIONS(1417),
    [anon_sym_layout] = ACTIONS(1417),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1435),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1433),
    [aux_sym_preproc_def_token1] = ACTIONS(1433),
    [aux_sym_preproc_if_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1433),
    [sym_preproc_directive] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_TILDE] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1433),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_subroutine] = ACTIONS(1433),
    [anon_sym_invariant] = ACTIONS(1433),
    [anon_sym_precise] = ACTIONS(1433),
    [anon_sym_in] = ACTIONS(1433),
    [anon_sym_out] = ACTIONS(1433),
    [anon_sym_inout] = ACTIONS(1433),
    [anon_sym_uniform] = ACTIONS(1433),
    [anon_sym_shared] = ACTIONS(1433),
    [anon_sym_attribute] = ACTIONS(1433),
    [anon_sym_varying] = ACTIONS(1433),
    [anon_sym_buffer] = ACTIONS(1433),
    [anon_sym_coherent] = ACTIONS(1433),
    [anon_sym_readonly] = ACTIONS(1433),
    [anon_sym_writeonly] = ACTIONS(1433),
    [anon_sym_precision] = ACTIONS(1433),
    [anon_sym_highp] = ACTIONS(1433),
    [anon_sym_mediump] = ACTIONS(1433),
    [anon_sym_lowp] = ACTIONS(1433),
    [anon_sym_centroid] = ACTIONS(1433),
    [anon_sym_sample] = ACTIONS(1433),
    [anon_sym_patch] = ACTIONS(1433),
    [anon_sym_smooth] = ACTIONS(1433),
    [anon_sym_flat] = ACTIONS(1433),
    [anon_sym_noperspective] = ACTIONS(1433),
    [anon_sym___extension__] = ACTIONS(1433),
    [anon_sym_typedef] = ACTIONS(1433),
    [anon_sym_extern] = ACTIONS(1433),
    [anon_sym___attribute__] = ACTIONS(1433),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1435),
    [anon_sym___declspec] = ACTIONS(1433),
    [anon_sym___cdecl] = ACTIONS(1433),
    [anon_sym___clrcall] = ACTIONS(1433),
    [anon_sym___stdcall] = ACTIONS(1433),
    [anon_sym___fastcall] = ACTIONS(1433),
    [anon_sym___thiscall] = ACTIONS(1433),
    [anon_sym___vectorcall] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_signed] = ACTIONS(1433),
    [anon_sym_unsigned] = ACTIONS(1433),
    [anon_sym_long] = ACTIONS(1433),
    [anon_sym_short] = ACTIONS(1433),
    [anon_sym_static] = ACTIONS(1433),
    [anon_sym_auto] = ACTIONS(1433),
    [anon_sym_register] = ACTIONS(1433),
    [anon_sym_inline] = ACTIONS(1433),
    [anon_sym___inline] = ACTIONS(1433),
    [anon_sym___inline__] = ACTIONS(1433),
    [anon_sym___forceinline] = ACTIONS(1433),
    [anon_sym_thread_local] = ACTIONS(1433),
    [anon_sym___thread] = ACTIONS(1433),
    [anon_sym_const] = ACTIONS(1433),
    [anon_sym_constexpr] = ACTIONS(1433),
    [anon_sym_volatile] = ACTIONS(1433),
    [anon_sym_restrict] = ACTIONS(1433),
    [anon_sym___restrict__] = ACTIONS(1433),
    [anon_sym__Atomic] = ACTIONS(1433),
    [anon_sym__Noreturn] = ACTIONS(1433),
    [anon_sym_noreturn] = ACTIONS(1433),
    [anon_sym_alignas] = ACTIONS(1433),
    [anon_sym__Alignas] = ACTIONS(1433),
    [sym_primitive_type] = ACTIONS(1433),
    [anon_sym_enum] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1433),
    [anon_sym_union] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1433),
    [anon_sym_case] = ACTIONS(1433),
    [anon_sym_default] = ACTIONS(1433),
    [anon_sym_while] = ACTIONS(1433),
    [anon_sym_do] = ACTIONS(1433),
    [anon_sym_for] = ACTIONS(1433),
    [anon_sym_return] = ACTIONS(1433),
    [anon_sym_break] = ACTIONS(1433),
    [anon_sym_continue] = ACTIONS(1433),
    [anon_sym_goto] = ACTIONS(1433),
    [anon_sym_DASH_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1435),
    [anon_sym_sizeof] = ACTIONS(1433),
    [anon_sym___alignof__] = ACTIONS(1433),
    [anon_sym___alignof] = ACTIONS(1433),
    [anon_sym__alignof] = ACTIONS(1433),
    [anon_sym_alignof] = ACTIONS(1433),
    [anon_sym__Alignof] = ACTIONS(1433),
    [anon_sym_offsetof] = ACTIONS(1433),
    [anon_sym__Generic] = ACTIONS(1433),
    [anon_sym_asm] = ACTIONS(1433),
    [anon_sym___asm__] = ACTIONS(1433),
    [sym_number_literal] = ACTIONS(1435),
    [anon_sym_L_SQUOTE] = ACTIONS(1435),
    [anon_sym_u_SQUOTE] = ACTIONS(1435),
    [anon_sym_U_SQUOTE] = ACTIONS(1435),
    [anon_sym_u8_SQUOTE] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_L_DQUOTE] = ACTIONS(1435),
    [anon_sym_u_DQUOTE] = ACTIONS(1435),
    [anon_sym_U_DQUOTE] = ACTIONS(1435),
    [anon_sym_u8_DQUOTE] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1435),
    [sym_true] = ACTIONS(1433),
    [sym_false] = ACTIONS(1433),
    [anon_sym_NULL] = ACTIONS(1433),
    [anon_sym_nullptr] = ACTIONS(1433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1433),
    [anon_sym_hitAttributeEXT] = ACTIONS(1433),
    [anon_sym_callableDataEXT] = ACTIONS(1433),
    [anon_sym_callableDataInEXT] = ACTIONS(1433),
    [anon_sym_shaderRecordEXT] = ACTIONS(1433),
    [anon_sym_rayPayloadNV] = ACTIONS(1433),
    [anon_sym_rayPayloadInNV] = ACTIONS(1433),
    [anon_sym_hitAttributeNV] = ACTIONS(1433),
    [anon_sym_callableDataNV] = ACTIONS(1433),
    [anon_sym_callableDataInNV] = ACTIONS(1433),
    [anon_sym_shaderRecordNV] = ACTIONS(1433),
    [anon_sym_layout] = ACTIONS(1433),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1507),
    [sym_identifier] = ACTIONS(1505),
    [aux_sym_preproc_include_token1] = ACTIONS(1505),
    [aux_sym_preproc_def_token1] = ACTIONS(1505),
    [aux_sym_preproc_if_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1505),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1505),
    [sym_preproc_directive] = ACTIONS(1505),
    [anon_sym_LPAREN2] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_TILDE] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PLUS] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_AMP] = ACTIONS(1507),
    [anon_sym_subroutine] = ACTIONS(1505),
    [anon_sym_invariant] = ACTIONS(1505),
    [anon_sym_precise] = ACTIONS(1505),
    [anon_sym_in] = ACTIONS(1505),
    [anon_sym_out] = ACTIONS(1505),
    [anon_sym_inout] = ACTIONS(1505),
    [anon_sym_uniform] = ACTIONS(1505),
    [anon_sym_shared] = ACTIONS(1505),
    [anon_sym_attribute] = ACTIONS(1505),
    [anon_sym_varying] = ACTIONS(1505),
    [anon_sym_buffer] = ACTIONS(1505),
    [anon_sym_coherent] = ACTIONS(1505),
    [anon_sym_readonly] = ACTIONS(1505),
    [anon_sym_writeonly] = ACTIONS(1505),
    [anon_sym_precision] = ACTIONS(1505),
    [anon_sym_highp] = ACTIONS(1505),
    [anon_sym_mediump] = ACTIONS(1505),
    [anon_sym_lowp] = ACTIONS(1505),
    [anon_sym_centroid] = ACTIONS(1505),
    [anon_sym_sample] = ACTIONS(1505),
    [anon_sym_patch] = ACTIONS(1505),
    [anon_sym_smooth] = ACTIONS(1505),
    [anon_sym_flat] = ACTIONS(1505),
    [anon_sym_noperspective] = ACTIONS(1505),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1505),
    [anon_sym___attribute__] = ACTIONS(1505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1507),
    [anon_sym___declspec] = ACTIONS(1505),
    [anon_sym___cdecl] = ACTIONS(1505),
    [anon_sym___clrcall] = ACTIONS(1505),
    [anon_sym___stdcall] = ACTIONS(1505),
    [anon_sym___fastcall] = ACTIONS(1505),
    [anon_sym___thiscall] = ACTIONS(1505),
    [anon_sym___vectorcall] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1507),
    [anon_sym_signed] = ACTIONS(1505),
    [anon_sym_unsigned] = ACTIONS(1505),
    [anon_sym_long] = ACTIONS(1505),
    [anon_sym_short] = ACTIONS(1505),
    [anon_sym_static] = ACTIONS(1505),
    [anon_sym_auto] = ACTIONS(1505),
    [anon_sym_register] = ACTIONS(1505),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym___inline] = ACTIONS(1505),
    [anon_sym___inline__] = ACTIONS(1505),
    [anon_sym___forceinline] = ACTIONS(1505),
    [anon_sym_thread_local] = ACTIONS(1505),
    [anon_sym___thread] = ACTIONS(1505),
    [anon_sym_const] = ACTIONS(1505),
    [anon_sym_constexpr] = ACTIONS(1505),
    [anon_sym_volatile] = ACTIONS(1505),
    [anon_sym_restrict] = ACTIONS(1505),
    [anon_sym___restrict__] = ACTIONS(1505),
    [anon_sym__Atomic] = ACTIONS(1505),
    [anon_sym__Noreturn] = ACTIONS(1505),
    [anon_sym_noreturn] = ACTIONS(1505),
    [anon_sym_alignas] = ACTIONS(1505),
    [anon_sym__Alignas] = ACTIONS(1505),
    [sym_primitive_type] = ACTIONS(1505),
    [anon_sym_enum] = ACTIONS(1505),
    [anon_sym_struct] = ACTIONS(1505),
    [anon_sym_union] = ACTIONS(1505),
    [anon_sym_if] = ACTIONS(1505),
    [anon_sym_switch] = ACTIONS(1505),
    [anon_sym_case] = ACTIONS(1505),
    [anon_sym_default] = ACTIONS(1505),
    [anon_sym_while] = ACTIONS(1505),
    [anon_sym_do] = ACTIONS(1505),
    [anon_sym_for] = ACTIONS(1505),
    [anon_sym_return] = ACTIONS(1505),
    [anon_sym_break] = ACTIONS(1505),
    [anon_sym_continue] = ACTIONS(1505),
    [anon_sym_goto] = ACTIONS(1505),
    [anon_sym_DASH_DASH] = ACTIONS(1507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1507),
    [anon_sym_sizeof] = ACTIONS(1505),
    [anon_sym___alignof__] = ACTIONS(1505),
    [anon_sym___alignof] = ACTIONS(1505),
    [anon_sym__alignof] = ACTIONS(1505),
    [anon_sym_alignof] = ACTIONS(1505),
    [anon_sym__Alignof] = ACTIONS(1505),
    [anon_sym_offsetof] = ACTIONS(1505),
    [anon_sym__Generic] = ACTIONS(1505),
    [anon_sym_asm] = ACTIONS(1505),
    [anon_sym___asm__] = ACTIONS(1505),
    [sym_number_literal] = ACTIONS(1507),
    [anon_sym_L_SQUOTE] = ACTIONS(1507),
    [anon_sym_u_SQUOTE] = ACTIONS(1507),
    [anon_sym_U_SQUOTE] = ACTIONS(1507),
    [anon_sym_u8_SQUOTE] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_L_DQUOTE] = ACTIONS(1507),
    [anon_sym_u_DQUOTE] = ACTIONS(1507),
    [anon_sym_U_DQUOTE] = ACTIONS(1507),
    [anon_sym_u8_DQUOTE] = ACTIONS(1507),
    [anon_sym_DQUOTE] = ACTIONS(1507),
    [sym_true] = ACTIONS(1505),
    [sym_false] = ACTIONS(1505),
    [anon_sym_NULL] = ACTIONS(1505),
    [anon_sym_nullptr] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1505),
    [anon_sym_hitAttributeEXT] = ACTIONS(1505),
    [anon_sym_callableDataEXT] = ACTIONS(1505),
    [anon_sym_callableDataInEXT] = ACTIONS(1505),
    [anon_sym_shaderRecordEXT] = ACTIONS(1505),
    [anon_sym_rayPayloadNV] = ACTIONS(1505),
    [anon_sym_rayPayloadInNV] = ACTIONS(1505),
    [anon_sym_hitAttributeNV] = ACTIONS(1505),
    [anon_sym_callableDataNV] = ACTIONS(1505),
    [anon_sym_callableDataInNV] = ACTIONS(1505),
    [anon_sym_shaderRecordNV] = ACTIONS(1505),
    [anon_sym_layout] = ACTIONS(1505),
  },
  [440] = {
    [sym_else_clause] = STATE(211),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_LPAREN2] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_subroutine] = ACTIONS(1227),
    [anon_sym_invariant] = ACTIONS(1227),
    [anon_sym_precise] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_out] = ACTIONS(1227),
    [anon_sym_inout] = ACTIONS(1227),
    [anon_sym_uniform] = ACTIONS(1227),
    [anon_sym_shared] = ACTIONS(1227),
    [anon_sym_attribute] = ACTIONS(1227),
    [anon_sym_varying] = ACTIONS(1227),
    [anon_sym_buffer] = ACTIONS(1227),
    [anon_sym_coherent] = ACTIONS(1227),
    [anon_sym_readonly] = ACTIONS(1227),
    [anon_sym_writeonly] = ACTIONS(1227),
    [anon_sym_precision] = ACTIONS(1227),
    [anon_sym_highp] = ACTIONS(1227),
    [anon_sym_mediump] = ACTIONS(1227),
    [anon_sym_lowp] = ACTIONS(1227),
    [anon_sym_centroid] = ACTIONS(1227),
    [anon_sym_sample] = ACTIONS(1227),
    [anon_sym_patch] = ACTIONS(1227),
    [anon_sym_smooth] = ACTIONS(1227),
    [anon_sym_flat] = ACTIONS(1227),
    [anon_sym_noperspective] = ACTIONS(1227),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym___attribute__] = ACTIONS(1227),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1229),
    [anon_sym___declspec] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_signed] = ACTIONS(1227),
    [anon_sym_unsigned] = ACTIONS(1227),
    [anon_sym_long] = ACTIONS(1227),
    [anon_sym_short] = ACTIONS(1227),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_auto] = ACTIONS(1227),
    [anon_sym_register] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym___inline] = ACTIONS(1227),
    [anon_sym___inline__] = ACTIONS(1227),
    [anon_sym___forceinline] = ACTIONS(1227),
    [anon_sym_thread_local] = ACTIONS(1227),
    [anon_sym___thread] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_constexpr] = ACTIONS(1227),
    [anon_sym_volatile] = ACTIONS(1227),
    [anon_sym_restrict] = ACTIONS(1227),
    [anon_sym___restrict__] = ACTIONS(1227),
    [anon_sym__Atomic] = ACTIONS(1227),
    [anon_sym__Noreturn] = ACTIONS(1227),
    [anon_sym_noreturn] = ACTIONS(1227),
    [anon_sym_alignas] = ACTIONS(1227),
    [anon_sym__Alignas] = ACTIONS(1227),
    [sym_primitive_type] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1555),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_goto] = ACTIONS(1227),
    [anon_sym___try] = ACTIONS(1227),
    [anon_sym___leave] = ACTIONS(1227),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_sizeof] = ACTIONS(1227),
    [anon_sym___alignof__] = ACTIONS(1227),
    [anon_sym___alignof] = ACTIONS(1227),
    [anon_sym__alignof] = ACTIONS(1227),
    [anon_sym_alignof] = ACTIONS(1227),
    [anon_sym__Alignof] = ACTIONS(1227),
    [anon_sym_offsetof] = ACTIONS(1227),
    [anon_sym__Generic] = ACTIONS(1227),
    [anon_sym_asm] = ACTIONS(1227),
    [anon_sym___asm__] = ACTIONS(1227),
    [sym_number_literal] = ACTIONS(1229),
    [anon_sym_L_SQUOTE] = ACTIONS(1229),
    [anon_sym_u_SQUOTE] = ACTIONS(1229),
    [anon_sym_U_SQUOTE] = ACTIONS(1229),
    [anon_sym_u8_SQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_L_DQUOTE] = ACTIONS(1229),
    [anon_sym_u_DQUOTE] = ACTIONS(1229),
    [anon_sym_U_DQUOTE] = ACTIONS(1229),
    [anon_sym_u8_DQUOTE] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [anon_sym_NULL] = ACTIONS(1227),
    [anon_sym_nullptr] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1227),
    [anon_sym_hitAttributeEXT] = ACTIONS(1227),
    [anon_sym_callableDataEXT] = ACTIONS(1227),
    [anon_sym_callableDataInEXT] = ACTIONS(1227),
    [anon_sym_shaderRecordEXT] = ACTIONS(1227),
    [anon_sym_rayPayloadNV] = ACTIONS(1227),
    [anon_sym_rayPayloadInNV] = ACTIONS(1227),
    [anon_sym_hitAttributeNV] = ACTIONS(1227),
    [anon_sym_callableDataNV] = ACTIONS(1227),
    [anon_sym_callableDataInNV] = ACTIONS(1227),
    [anon_sym_shaderRecordNV] = ACTIONS(1227),
    [anon_sym_layout] = ACTIONS(1227),
  },
  [441] = {
    [sym_preproc_def] = STATE(442),
    [sym_preproc_function_def] = STATE(442),
    [sym_preproc_call] = STATE(442),
    [sym_preproc_if_in_field_declaration_list] = STATE(442),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(442),
    [sym_preproc_else_in_field_declaration_list] = STATE(2184),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2184),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2184),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(442),
    [sym_field_declaration] = STATE(442),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(442),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [442] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2171),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2171),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2171),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1577),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [443] = {
    [sym_preproc_def] = STATE(456),
    [sym_preproc_function_def] = STATE(456),
    [sym_preproc_call] = STATE(456),
    [sym_preproc_if_in_field_declaration_list] = STATE(456),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(456),
    [sym_preproc_else_in_field_declaration_list] = STATE(2252),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2252),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2252),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(456),
    [sym_field_declaration] = STATE(456),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(456),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [444] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2251),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2251),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2251),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1581),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [445] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2286),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2286),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2286),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [446] = {
    [sym_preproc_def] = STATE(455),
    [sym_preproc_function_def] = STATE(455),
    [sym_preproc_call] = STATE(455),
    [sym_preproc_if_in_field_declaration_list] = STATE(455),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(455),
    [sym_preproc_else_in_field_declaration_list] = STATE(2291),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2291),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2291),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(455),
    [sym_field_declaration] = STATE(455),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(455),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [447] = {
    [sym_preproc_def] = STATE(454),
    [sym_preproc_function_def] = STATE(454),
    [sym_preproc_call] = STATE(454),
    [sym_preproc_if_in_field_declaration_list] = STATE(454),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(454),
    [sym_preproc_else_in_field_declaration_list] = STATE(2233),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2233),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2233),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(454),
    [sym_field_declaration] = STATE(454),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(454),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [448] = {
    [sym_preproc_def] = STATE(445),
    [sym_preproc_function_def] = STATE(445),
    [sym_preproc_call] = STATE(445),
    [sym_preproc_if_in_field_declaration_list] = STATE(445),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(445),
    [sym_preproc_else_in_field_declaration_list] = STATE(2317),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2317),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2317),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(445),
    [sym_field_declaration] = STATE(445),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(445),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [449] = {
    [sym_preproc_def] = STATE(450),
    [sym_preproc_function_def] = STATE(450),
    [sym_preproc_call] = STATE(450),
    [sym_preproc_if_in_field_declaration_list] = STATE(450),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(450),
    [sym_preproc_else_in_field_declaration_list] = STATE(2278),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2278),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2278),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(450),
    [sym_field_declaration] = STATE(450),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(450),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [450] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2307),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2307),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2307),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [451] = {
    [sym_preproc_def] = STATE(453),
    [sym_preproc_function_def] = STATE(453),
    [sym_preproc_call] = STATE(453),
    [sym_preproc_if_in_field_declaration_list] = STATE(453),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(453),
    [sym_preproc_else_in_field_declaration_list] = STATE(2118),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2118),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2118),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(453),
    [sym_field_declaration] = STATE(453),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(453),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [452] = {
    [sym_preproc_def] = STATE(444),
    [sym_preproc_function_def] = STATE(444),
    [sym_preproc_call] = STATE(444),
    [sym_preproc_if_in_field_declaration_list] = STATE(444),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(444),
    [sym_preproc_else_in_field_declaration_list] = STATE(2199),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2199),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2199),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(444),
    [sym_field_declaration] = STATE(444),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(444),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [453] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2200),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2200),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2200),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [454] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2175),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2175),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2175),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [455] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2277),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2277),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2277),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [456] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym_preproc_else_in_field_declaration_list] = STATE(2367),
    [sym_preproc_elif_in_field_declaration_list] = STATE(2367),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(2367),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1559),
    [aux_sym_preproc_if_token1] = ACTIONS(1561),
    [aux_sym_preproc_if_token2] = ACTIONS(1605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1565),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1565),
    [aux_sym_preproc_else_token1] = ACTIONS(1567),
    [aux_sym_preproc_elif_token1] = ACTIONS(1569),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1571),
    [sym_preproc_directive] = ACTIONS(1573),
    [anon_sym_subroutine] = ACTIONS(1575),
    [anon_sym_invariant] = ACTIONS(1575),
    [anon_sym_precise] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_out] = ACTIONS(1575),
    [anon_sym_inout] = ACTIONS(1575),
    [anon_sym_uniform] = ACTIONS(1575),
    [anon_sym_shared] = ACTIONS(1575),
    [anon_sym_attribute] = ACTIONS(1575),
    [anon_sym_varying] = ACTIONS(1575),
    [anon_sym_buffer] = ACTIONS(1575),
    [anon_sym_coherent] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_writeonly] = ACTIONS(1575),
    [anon_sym_precision] = ACTIONS(1575),
    [anon_sym_highp] = ACTIONS(1575),
    [anon_sym_mediump] = ACTIONS(1575),
    [anon_sym_lowp] = ACTIONS(1575),
    [anon_sym_centroid] = ACTIONS(1575),
    [anon_sym_sample] = ACTIONS(1575),
    [anon_sym_patch] = ACTIONS(1575),
    [anon_sym_smooth] = ACTIONS(1575),
    [anon_sym_flat] = ACTIONS(1575),
    [anon_sym_noperspective] = ACTIONS(1575),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [457] = {
    [sym_preproc_def] = STATE(457),
    [sym_preproc_function_def] = STATE(457),
    [sym_preproc_call] = STATE(457),
    [sym_preproc_if_in_field_declaration_list] = STATE(457),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(457),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1438),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(457),
    [sym_field_declaration] = STATE(457),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(525),
    [sym_layout_specification] = STATE(525),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(457),
    [aux_sym_declaration_repeat1] = STATE(525),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1607),
    [aux_sym_preproc_def_token1] = ACTIONS(1610),
    [aux_sym_preproc_if_token1] = ACTIONS(1613),
    [aux_sym_preproc_if_token2] = ACTIONS(1616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1618),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1618),
    [aux_sym_preproc_else_token1] = ACTIONS(1616),
    [aux_sym_preproc_elif_token1] = ACTIONS(1616),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1616),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1616),
    [sym_preproc_directive] = ACTIONS(1621),
    [anon_sym_subroutine] = ACTIONS(1624),
    [anon_sym_invariant] = ACTIONS(1624),
    [anon_sym_precise] = ACTIONS(1624),
    [anon_sym_in] = ACTIONS(1624),
    [anon_sym_out] = ACTIONS(1624),
    [anon_sym_inout] = ACTIONS(1624),
    [anon_sym_uniform] = ACTIONS(1624),
    [anon_sym_shared] = ACTIONS(1624),
    [anon_sym_attribute] = ACTIONS(1624),
    [anon_sym_varying] = ACTIONS(1624),
    [anon_sym_buffer] = ACTIONS(1624),
    [anon_sym_coherent] = ACTIONS(1624),
    [anon_sym_readonly] = ACTIONS(1624),
    [anon_sym_writeonly] = ACTIONS(1624),
    [anon_sym_precision] = ACTIONS(1624),
    [anon_sym_highp] = ACTIONS(1624),
    [anon_sym_mediump] = ACTIONS(1624),
    [anon_sym_lowp] = ACTIONS(1624),
    [anon_sym_centroid] = ACTIONS(1624),
    [anon_sym_sample] = ACTIONS(1624),
    [anon_sym_patch] = ACTIONS(1624),
    [anon_sym_smooth] = ACTIONS(1624),
    [anon_sym_flat] = ACTIONS(1624),
    [anon_sym_noperspective] = ACTIONS(1624),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1630),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1636),
    [anon_sym___declspec] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1642),
    [anon_sym_unsigned] = ACTIONS(1642),
    [anon_sym_long] = ACTIONS(1642),
    [anon_sym_short] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1630),
    [anon_sym_auto] = ACTIONS(1630),
    [anon_sym_register] = ACTIONS(1630),
    [anon_sym_inline] = ACTIONS(1630),
    [anon_sym___inline] = ACTIONS(1630),
    [anon_sym___inline__] = ACTIONS(1630),
    [anon_sym___forceinline] = ACTIONS(1630),
    [anon_sym_thread_local] = ACTIONS(1630),
    [anon_sym___thread] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [anon_sym_alignas] = ACTIONS(1645),
    [anon_sym__Alignas] = ACTIONS(1645),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1651),
    [anon_sym_struct] = ACTIONS(1654),
    [anon_sym_union] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1660),
    [anon_sym_hitAttributeEXT] = ACTIONS(1660),
    [anon_sym_callableDataEXT] = ACTIONS(1660),
    [anon_sym_callableDataInEXT] = ACTIONS(1660),
    [anon_sym_shaderRecordEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadNV] = ACTIONS(1660),
    [anon_sym_rayPayloadInNV] = ACTIONS(1660),
    [anon_sym_hitAttributeNV] = ACTIONS(1660),
    [anon_sym_callableDataNV] = ACTIONS(1660),
    [anon_sym_callableDataInNV] = ACTIONS(1660),
    [anon_sym_shaderRecordNV] = ACTIONS(1660),
    [anon_sym_layout] = ACTIONS(1663),
  },
  [458] = {
    [sym_preproc_def] = STATE(458),
    [sym_preproc_function_def] = STATE(458),
    [sym_preproc_call] = STATE(458),
    [sym_preproc_if_in_field_declaration_list] = STATE(458),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(458),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1435),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(458),
    [sym_field_declaration] = STATE(458),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(526),
    [sym_layout_specification] = STATE(526),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(458),
    [aux_sym_declaration_repeat1] = STATE(526),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1607),
    [aux_sym_preproc_def_token1] = ACTIONS(1666),
    [aux_sym_preproc_if_token1] = ACTIONS(1669),
    [aux_sym_preproc_if_token2] = ACTIONS(1616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1672),
    [sym_preproc_directive] = ACTIONS(1675),
    [anon_sym_subroutine] = ACTIONS(1678),
    [anon_sym_invariant] = ACTIONS(1678),
    [anon_sym_precise] = ACTIONS(1678),
    [anon_sym_in] = ACTIONS(1678),
    [anon_sym_out] = ACTIONS(1678),
    [anon_sym_inout] = ACTIONS(1678),
    [anon_sym_uniform] = ACTIONS(1678),
    [anon_sym_shared] = ACTIONS(1678),
    [anon_sym_attribute] = ACTIONS(1678),
    [anon_sym_varying] = ACTIONS(1678),
    [anon_sym_buffer] = ACTIONS(1678),
    [anon_sym_coherent] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_writeonly] = ACTIONS(1678),
    [anon_sym_precision] = ACTIONS(1678),
    [anon_sym_highp] = ACTIONS(1678),
    [anon_sym_mediump] = ACTIONS(1678),
    [anon_sym_lowp] = ACTIONS(1678),
    [anon_sym_centroid] = ACTIONS(1678),
    [anon_sym_sample] = ACTIONS(1678),
    [anon_sym_patch] = ACTIONS(1678),
    [anon_sym_smooth] = ACTIONS(1678),
    [anon_sym_flat] = ACTIONS(1678),
    [anon_sym_noperspective] = ACTIONS(1678),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1630),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1636),
    [anon_sym___declspec] = ACTIONS(1639),
    [anon_sym_signed] = ACTIONS(1642),
    [anon_sym_unsigned] = ACTIONS(1642),
    [anon_sym_long] = ACTIONS(1642),
    [anon_sym_short] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1630),
    [anon_sym_auto] = ACTIONS(1630),
    [anon_sym_register] = ACTIONS(1630),
    [anon_sym_inline] = ACTIONS(1630),
    [anon_sym___inline] = ACTIONS(1630),
    [anon_sym___inline__] = ACTIONS(1630),
    [anon_sym___forceinline] = ACTIONS(1630),
    [anon_sym_thread_local] = ACTIONS(1630),
    [anon_sym___thread] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [anon_sym_alignas] = ACTIONS(1645),
    [anon_sym__Alignas] = ACTIONS(1645),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1651),
    [anon_sym_struct] = ACTIONS(1654),
    [anon_sym_union] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1660),
    [anon_sym_hitAttributeEXT] = ACTIONS(1660),
    [anon_sym_callableDataEXT] = ACTIONS(1660),
    [anon_sym_callableDataInEXT] = ACTIONS(1660),
    [anon_sym_shaderRecordEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadNV] = ACTIONS(1660),
    [anon_sym_rayPayloadInNV] = ACTIONS(1660),
    [anon_sym_hitAttributeNV] = ACTIONS(1660),
    [anon_sym_callableDataNV] = ACTIONS(1660),
    [anon_sym_callableDataInNV] = ACTIONS(1660),
    [anon_sym_shaderRecordNV] = ACTIONS(1660),
    [anon_sym_layout] = ACTIONS(1663),
  },
  [459] = {
    [sym_preproc_def] = STATE(460),
    [sym_preproc_function_def] = STATE(460),
    [sym_preproc_call] = STATE(460),
    [sym_preproc_if_in_field_declaration_list] = STATE(460),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(460),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(460),
    [sym_field_declaration] = STATE(460),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(528),
    [sym_layout_specification] = STATE(528),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(460),
    [aux_sym_declaration_repeat1] = STATE(528),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1681),
    [aux_sym_preproc_if_token1] = ACTIONS(1683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1685),
    [sym_preproc_directive] = ACTIONS(1687),
    [anon_sym_subroutine] = ACTIONS(1689),
    [anon_sym_invariant] = ACTIONS(1689),
    [anon_sym_precise] = ACTIONS(1689),
    [anon_sym_in] = ACTIONS(1689),
    [anon_sym_out] = ACTIONS(1689),
    [anon_sym_inout] = ACTIONS(1689),
    [anon_sym_uniform] = ACTIONS(1689),
    [anon_sym_shared] = ACTIONS(1689),
    [anon_sym_attribute] = ACTIONS(1689),
    [anon_sym_varying] = ACTIONS(1689),
    [anon_sym_buffer] = ACTIONS(1689),
    [anon_sym_coherent] = ACTIONS(1689),
    [anon_sym_readonly] = ACTIONS(1689),
    [anon_sym_writeonly] = ACTIONS(1689),
    [anon_sym_precision] = ACTIONS(1689),
    [anon_sym_highp] = ACTIONS(1689),
    [anon_sym_mediump] = ACTIONS(1689),
    [anon_sym_lowp] = ACTIONS(1689),
    [anon_sym_centroid] = ACTIONS(1689),
    [anon_sym_sample] = ACTIONS(1689),
    [anon_sym_patch] = ACTIONS(1689),
    [anon_sym_smooth] = ACTIONS(1689),
    [anon_sym_flat] = ACTIONS(1689),
    [anon_sym_noperspective] = ACTIONS(1689),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [460] = {
    [sym_preproc_def] = STATE(461),
    [sym_preproc_function_def] = STATE(461),
    [sym_preproc_call] = STATE(461),
    [sym_preproc_if_in_field_declaration_list] = STATE(461),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(461),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(461),
    [sym_field_declaration] = STATE(461),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(528),
    [sym_layout_specification] = STATE(528),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(461),
    [aux_sym_declaration_repeat1] = STATE(528),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1681),
    [aux_sym_preproc_if_token1] = ACTIONS(1683),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1685),
    [sym_preproc_directive] = ACTIONS(1687),
    [anon_sym_subroutine] = ACTIONS(1689),
    [anon_sym_invariant] = ACTIONS(1689),
    [anon_sym_precise] = ACTIONS(1689),
    [anon_sym_in] = ACTIONS(1689),
    [anon_sym_out] = ACTIONS(1689),
    [anon_sym_inout] = ACTIONS(1689),
    [anon_sym_uniform] = ACTIONS(1689),
    [anon_sym_shared] = ACTIONS(1689),
    [anon_sym_attribute] = ACTIONS(1689),
    [anon_sym_varying] = ACTIONS(1689),
    [anon_sym_buffer] = ACTIONS(1689),
    [anon_sym_coherent] = ACTIONS(1689),
    [anon_sym_readonly] = ACTIONS(1689),
    [anon_sym_writeonly] = ACTIONS(1689),
    [anon_sym_precision] = ACTIONS(1689),
    [anon_sym_highp] = ACTIONS(1689),
    [anon_sym_mediump] = ACTIONS(1689),
    [anon_sym_lowp] = ACTIONS(1689),
    [anon_sym_centroid] = ACTIONS(1689),
    [anon_sym_sample] = ACTIONS(1689),
    [anon_sym_patch] = ACTIONS(1689),
    [anon_sym_smooth] = ACTIONS(1689),
    [anon_sym_flat] = ACTIONS(1689),
    [anon_sym_noperspective] = ACTIONS(1689),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [461] = {
    [sym_preproc_def] = STATE(461),
    [sym_preproc_function_def] = STATE(461),
    [sym_preproc_call] = STATE(461),
    [sym_preproc_if_in_field_declaration_list] = STATE(461),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(461),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1426),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(461),
    [sym_field_declaration] = STATE(461),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(528),
    [sym_layout_specification] = STATE(528),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(461),
    [aux_sym_declaration_repeat1] = STATE(528),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1607),
    [aux_sym_preproc_def_token1] = ACTIONS(1695),
    [aux_sym_preproc_if_token1] = ACTIONS(1698),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1701),
    [sym_preproc_directive] = ACTIONS(1704),
    [anon_sym_subroutine] = ACTIONS(1707),
    [anon_sym_invariant] = ACTIONS(1707),
    [anon_sym_precise] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_out] = ACTIONS(1707),
    [anon_sym_inout] = ACTIONS(1707),
    [anon_sym_uniform] = ACTIONS(1707),
    [anon_sym_shared] = ACTIONS(1707),
    [anon_sym_attribute] = ACTIONS(1707),
    [anon_sym_varying] = ACTIONS(1707),
    [anon_sym_buffer] = ACTIONS(1707),
    [anon_sym_coherent] = ACTIONS(1707),
    [anon_sym_readonly] = ACTIONS(1707),
    [anon_sym_writeonly] = ACTIONS(1707),
    [anon_sym_precision] = ACTIONS(1707),
    [anon_sym_highp] = ACTIONS(1707),
    [anon_sym_mediump] = ACTIONS(1707),
    [anon_sym_lowp] = ACTIONS(1707),
    [anon_sym_centroid] = ACTIONS(1707),
    [anon_sym_sample] = ACTIONS(1707),
    [anon_sym_patch] = ACTIONS(1707),
    [anon_sym_smooth] = ACTIONS(1707),
    [anon_sym_flat] = ACTIONS(1707),
    [anon_sym_noperspective] = ACTIONS(1707),
    [anon_sym___extension__] = ACTIONS(1627),
    [anon_sym_extern] = ACTIONS(1630),
    [anon_sym___attribute__] = ACTIONS(1633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1636),
    [anon_sym___declspec] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_signed] = ACTIONS(1642),
    [anon_sym_unsigned] = ACTIONS(1642),
    [anon_sym_long] = ACTIONS(1642),
    [anon_sym_short] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1630),
    [anon_sym_auto] = ACTIONS(1630),
    [anon_sym_register] = ACTIONS(1630),
    [anon_sym_inline] = ACTIONS(1630),
    [anon_sym___inline] = ACTIONS(1630),
    [anon_sym___inline__] = ACTIONS(1630),
    [anon_sym___forceinline] = ACTIONS(1630),
    [anon_sym_thread_local] = ACTIONS(1630),
    [anon_sym___thread] = ACTIONS(1630),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_constexpr] = ACTIONS(1627),
    [anon_sym_volatile] = ACTIONS(1627),
    [anon_sym_restrict] = ACTIONS(1627),
    [anon_sym___restrict__] = ACTIONS(1627),
    [anon_sym__Atomic] = ACTIONS(1627),
    [anon_sym__Noreturn] = ACTIONS(1627),
    [anon_sym_noreturn] = ACTIONS(1627),
    [anon_sym_alignas] = ACTIONS(1645),
    [anon_sym__Alignas] = ACTIONS(1645),
    [sym_primitive_type] = ACTIONS(1648),
    [anon_sym_enum] = ACTIONS(1651),
    [anon_sym_struct] = ACTIONS(1654),
    [anon_sym_union] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1660),
    [anon_sym_hitAttributeEXT] = ACTIONS(1660),
    [anon_sym_callableDataEXT] = ACTIONS(1660),
    [anon_sym_callableDataInEXT] = ACTIONS(1660),
    [anon_sym_shaderRecordEXT] = ACTIONS(1660),
    [anon_sym_rayPayloadNV] = ACTIONS(1660),
    [anon_sym_rayPayloadInNV] = ACTIONS(1660),
    [anon_sym_hitAttributeNV] = ACTIONS(1660),
    [anon_sym_callableDataNV] = ACTIONS(1660),
    [anon_sym_callableDataInNV] = ACTIONS(1660),
    [anon_sym_shaderRecordNV] = ACTIONS(1660),
    [anon_sym_layout] = ACTIONS(1663),
  },
  [462] = {
    [sym_preproc_def] = STATE(463),
    [sym_preproc_function_def] = STATE(463),
    [sym_preproc_call] = STATE(463),
    [sym_preproc_if_in_field_declaration_list] = STATE(463),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(463),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1435),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(463),
    [sym_field_declaration] = STATE(463),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(526),
    [sym_layout_specification] = STATE(526),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(463),
    [aux_sym_declaration_repeat1] = STATE(526),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1712),
    [aux_sym_preproc_if_token1] = ACTIONS(1714),
    [aux_sym_preproc_if_token2] = ACTIONS(1716),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1718),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1718),
    [sym_preproc_directive] = ACTIONS(1720),
    [anon_sym_subroutine] = ACTIONS(1722),
    [anon_sym_invariant] = ACTIONS(1722),
    [anon_sym_precise] = ACTIONS(1722),
    [anon_sym_in] = ACTIONS(1722),
    [anon_sym_out] = ACTIONS(1722),
    [anon_sym_inout] = ACTIONS(1722),
    [anon_sym_uniform] = ACTIONS(1722),
    [anon_sym_shared] = ACTIONS(1722),
    [anon_sym_attribute] = ACTIONS(1722),
    [anon_sym_varying] = ACTIONS(1722),
    [anon_sym_buffer] = ACTIONS(1722),
    [anon_sym_coherent] = ACTIONS(1722),
    [anon_sym_readonly] = ACTIONS(1722),
    [anon_sym_writeonly] = ACTIONS(1722),
    [anon_sym_precision] = ACTIONS(1722),
    [anon_sym_highp] = ACTIONS(1722),
    [anon_sym_mediump] = ACTIONS(1722),
    [anon_sym_lowp] = ACTIONS(1722),
    [anon_sym_centroid] = ACTIONS(1722),
    [anon_sym_sample] = ACTIONS(1722),
    [anon_sym_patch] = ACTIONS(1722),
    [anon_sym_smooth] = ACTIONS(1722),
    [anon_sym_flat] = ACTIONS(1722),
    [anon_sym_noperspective] = ACTIONS(1722),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [463] = {
    [sym_preproc_def] = STATE(458),
    [sym_preproc_function_def] = STATE(458),
    [sym_preproc_call] = STATE(458),
    [sym_preproc_if_in_field_declaration_list] = STATE(458),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(458),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1435),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym__field_declaration_list_item] = STATE(458),
    [sym_field_declaration] = STATE(458),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(526),
    [sym_layout_specification] = STATE(526),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(458),
    [aux_sym_declaration_repeat1] = STATE(526),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [aux_sym_preproc_def_token1] = ACTIONS(1712),
    [aux_sym_preproc_if_token1] = ACTIONS(1714),
    [aux_sym_preproc_if_token2] = ACTIONS(1724),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1718),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1718),
    [sym_preproc_directive] = ACTIONS(1720),
    [anon_sym_subroutine] = ACTIONS(1722),
    [anon_sym_invariant] = ACTIONS(1722),
    [anon_sym_precise] = ACTIONS(1722),
    [anon_sym_in] = ACTIONS(1722),
    [anon_sym_out] = ACTIONS(1722),
    [anon_sym_inout] = ACTIONS(1722),
    [anon_sym_uniform] = ACTIONS(1722),
    [anon_sym_shared] = ACTIONS(1722),
    [anon_sym_attribute] = ACTIONS(1722),
    [anon_sym_varying] = ACTIONS(1722),
    [anon_sym_buffer] = ACTIONS(1722),
    [anon_sym_coherent] = ACTIONS(1722),
    [anon_sym_readonly] = ACTIONS(1722),
    [anon_sym_writeonly] = ACTIONS(1722),
    [anon_sym_precision] = ACTIONS(1722),
    [anon_sym_highp] = ACTIONS(1722),
    [anon_sym_mediump] = ACTIONS(1722),
    [anon_sym_lowp] = ACTIONS(1722),
    [anon_sym_centroid] = ACTIONS(1722),
    [anon_sym_sample] = ACTIONS(1722),
    [anon_sym_patch] = ACTIONS(1722),
    [anon_sym_smooth] = ACTIONS(1722),
    [anon_sym_flat] = ACTIONS(1722),
    [anon_sym_noperspective] = ACTIONS(1722),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [464] = {
    [sym_function_definition] = STATE(424),
    [sym_declaration] = STATE(424),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1254),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(879),
    [sym_declaration_list] = STATE(424),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(527),
    [sym_layout_specification] = STATE(527),
    [aux_sym_declaration_repeat1] = STATE(527),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1726),
    [anon_sym_subroutine] = ACTIONS(27),
    [anon_sym_invariant] = ACTIONS(29),
    [anon_sym_precise] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(31),
    [anon_sym_out] = ACTIONS(31),
    [anon_sym_inout] = ACTIONS(31),
    [anon_sym_uniform] = ACTIONS(31),
    [anon_sym_shared] = ACTIONS(31),
    [anon_sym_attribute] = ACTIONS(31),
    [anon_sym_varying] = ACTIONS(31),
    [anon_sym_buffer] = ACTIONS(31),
    [anon_sym_coherent] = ACTIONS(31),
    [anon_sym_readonly] = ACTIONS(31),
    [anon_sym_writeonly] = ACTIONS(31),
    [anon_sym_precision] = ACTIONS(31),
    [anon_sym_highp] = ACTIONS(31),
    [anon_sym_mediump] = ACTIONS(31),
    [anon_sym_lowp] = ACTIONS(31),
    [anon_sym_centroid] = ACTIONS(31),
    [anon_sym_sample] = ACTIONS(31),
    [anon_sym_patch] = ACTIONS(31),
    [anon_sym_smooth] = ACTIONS(31),
    [anon_sym_flat] = ACTIONS(31),
    [anon_sym_noperspective] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [465] = {
    [sym_function_definition] = STATE(133),
    [sym_declaration] = STATE(133),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1262),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(883),
    [sym_declaration_list] = STATE(133),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(520),
    [sym_layout_specification] = STATE(520),
    [aux_sym_declaration_repeat1] = STATE(520),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1730),
    [anon_sym_subroutine] = ACTIONS(133),
    [anon_sym_invariant] = ACTIONS(135),
    [anon_sym_precise] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
    [anon_sym_out] = ACTIONS(139),
    [anon_sym_inout] = ACTIONS(139),
    [anon_sym_uniform] = ACTIONS(139),
    [anon_sym_shared] = ACTIONS(139),
    [anon_sym_attribute] = ACTIONS(139),
    [anon_sym_varying] = ACTIONS(139),
    [anon_sym_buffer] = ACTIONS(139),
    [anon_sym_coherent] = ACTIONS(139),
    [anon_sym_readonly] = ACTIONS(139),
    [anon_sym_writeonly] = ACTIONS(139),
    [anon_sym_precision] = ACTIONS(139),
    [anon_sym_highp] = ACTIONS(139),
    [anon_sym_mediump] = ACTIONS(139),
    [anon_sym_lowp] = ACTIONS(139),
    [anon_sym_centroid] = ACTIONS(139),
    [anon_sym_sample] = ACTIONS(139),
    [anon_sym_patch] = ACTIONS(139),
    [anon_sym_smooth] = ACTIONS(139),
    [anon_sym_flat] = ACTIONS(139),
    [anon_sym_noperspective] = ACTIONS(139),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1732),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [466] = {
    [sym_function_definition] = STATE(361),
    [sym_declaration] = STATE(361),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1268),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(887),
    [sym_declaration_list] = STATE(361),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(532),
    [sym_layout_specification] = STATE(532),
    [aux_sym_declaration_repeat1] = STATE(532),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1734),
    [anon_sym_subroutine] = ACTIONS(469),
    [anon_sym_invariant] = ACTIONS(471),
    [anon_sym_precise] = ACTIONS(471),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_out] = ACTIONS(475),
    [anon_sym_inout] = ACTIONS(475),
    [anon_sym_uniform] = ACTIONS(475),
    [anon_sym_shared] = ACTIONS(475),
    [anon_sym_attribute] = ACTIONS(475),
    [anon_sym_varying] = ACTIONS(475),
    [anon_sym_buffer] = ACTIONS(475),
    [anon_sym_coherent] = ACTIONS(475),
    [anon_sym_readonly] = ACTIONS(475),
    [anon_sym_writeonly] = ACTIONS(475),
    [anon_sym_precision] = ACTIONS(475),
    [anon_sym_highp] = ACTIONS(475),
    [anon_sym_mediump] = ACTIONS(475),
    [anon_sym_lowp] = ACTIONS(475),
    [anon_sym_centroid] = ACTIONS(475),
    [anon_sym_sample] = ACTIONS(475),
    [anon_sym_patch] = ACTIONS(475),
    [anon_sym_smooth] = ACTIONS(475),
    [anon_sym_flat] = ACTIONS(475),
    [anon_sym_noperspective] = ACTIONS(475),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [467] = {
    [sym_function_definition] = STATE(385),
    [sym_declaration] = STATE(385),
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1264),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(891),
    [sym_declaration_list] = STATE(385),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(523),
    [sym_layout_specification] = STATE(523),
    [aux_sym_declaration_repeat1] = STATE(523),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1738),
    [anon_sym_subroutine] = ACTIONS(399),
    [anon_sym_invariant] = ACTIONS(401),
    [anon_sym_precise] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_out] = ACTIONS(405),
    [anon_sym_inout] = ACTIONS(405),
    [anon_sym_uniform] = ACTIONS(405),
    [anon_sym_shared] = ACTIONS(405),
    [anon_sym_attribute] = ACTIONS(405),
    [anon_sym_varying] = ACTIONS(405),
    [anon_sym_buffer] = ACTIONS(405),
    [anon_sym_coherent] = ACTIONS(405),
    [anon_sym_readonly] = ACTIONS(405),
    [anon_sym_writeonly] = ACTIONS(405),
    [anon_sym_precision] = ACTIONS(405),
    [anon_sym_highp] = ACTIONS(405),
    [anon_sym_mediump] = ACTIONS(405),
    [anon_sym_lowp] = ACTIONS(405),
    [anon_sym_centroid] = ACTIONS(405),
    [anon_sym_sample] = ACTIONS(405),
    [anon_sym_patch] = ACTIONS(405),
    [anon_sym_smooth] = ACTIONS(405),
    [anon_sym_flat] = ACTIONS(405),
    [anon_sym_noperspective] = ACTIONS(405),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [468] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1311),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_based_modifier] = STATE(2145),
    [sym_ms_call_modifier] = STATE(1393),
    [sym__declarator] = STATE(1673),
    [sym__abstract_declarator] = STATE(1796),
    [sym_parenthesized_declarator] = STATE(1550),
    [sym_abstract_parenthesized_declarator] = STATE(1751),
    [sym_attributed_declarator] = STATE(1550),
    [sym_pointer_declarator] = STATE(1550),
    [sym_abstract_pointer_declarator] = STATE(1751),
    [sym_function_declarator] = STATE(1550),
    [sym_abstract_function_declarator] = STATE(1751),
    [sym_array_declarator] = STATE(1550),
    [sym_abstract_array_declarator] = STATE(1751),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_variadic_parameter] = STATE(1883),
    [sym_parameter_list] = STATE(1753),
    [sym_parameter_declaration] = STATE(1883),
    [sym_macro_type_specifier] = STATE(980),
    [sym_layout_specification] = STATE(643),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_parameter_declaration_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1744),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_LPAREN2] = ACTIONS(1748),
    [anon_sym_STAR] = ACTIONS(1750),
    [anon_sym_precise] = ACTIONS(1752),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_out] = ACTIONS(1752),
    [anon_sym_inout] = ACTIONS(1752),
    [anon_sym_uniform] = ACTIONS(1752),
    [anon_sym_shared] = ACTIONS(1752),
    [anon_sym_attribute] = ACTIONS(1752),
    [anon_sym_varying] = ACTIONS(1752),
    [anon_sym_buffer] = ACTIONS(1752),
    [anon_sym_coherent] = ACTIONS(1752),
    [anon_sym_readonly] = ACTIONS(1752),
    [anon_sym_writeonly] = ACTIONS(1752),
    [anon_sym_centroid] = ACTIONS(1752),
    [anon_sym_sample] = ACTIONS(1752),
    [anon_sym_patch] = ACTIONS(1752),
    [anon_sym_smooth] = ACTIONS(1752),
    [anon_sym_flat] = ACTIONS(1752),
    [anon_sym_noperspective] = ACTIONS(1752),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___based] = ACTIONS(1754),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_layout] = ACTIONS(1758),
  },
  [469] = {
    [sym_expression] = STATE(877),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(855),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(855),
    [sym_call_expression] = STATE(855),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(855),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(855),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(898),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1762),
    [aux_sym_preproc_if_token2] = ACTIONS(1762),
    [aux_sym_preproc_else_token1] = ACTIONS(1762),
    [aux_sym_preproc_elif_token1] = ACTIONS(1760),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1762),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1764),
    [anon_sym_TILDE] = ACTIONS(1766),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_STAR_EQ] = ACTIONS(1762),
    [anon_sym_SLASH_EQ] = ACTIONS(1762),
    [anon_sym_PERCENT_EQ] = ACTIONS(1762),
    [anon_sym_PLUS_EQ] = ACTIONS(1762),
    [anon_sym_DASH_EQ] = ACTIONS(1762),
    [anon_sym_LT_LT_EQ] = ACTIONS(1762),
    [anon_sym_GT_GT_EQ] = ACTIONS(1762),
    [anon_sym_AMP_EQ] = ACTIONS(1762),
    [anon_sym_CARET_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_EQ] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(1770),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_expression] = STATE(877),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(855),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(855),
    [sym_call_expression] = STATE(855),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(855),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(855),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1774),
    [anon_sym_TILDE] = ACTIONS(1776),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(1760),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym___attribute__] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_STAR_EQ] = ACTIONS(1762),
    [anon_sym_SLASH_EQ] = ACTIONS(1762),
    [anon_sym_PERCENT_EQ] = ACTIONS(1762),
    [anon_sym_PLUS_EQ] = ACTIONS(1762),
    [anon_sym_DASH_EQ] = ACTIONS(1762),
    [anon_sym_LT_LT_EQ] = ACTIONS(1762),
    [anon_sym_GT_GT_EQ] = ACTIONS(1762),
    [anon_sym_AMP_EQ] = ACTIONS(1762),
    [anon_sym_CARET_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_EQ] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(1778),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_attribute_declaration] = STATE(511),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(268),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_attribute_declaration] = STATE(480),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(225),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_attribute_declaration] = STATE(493),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(169),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1404),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(889),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_LPAREN2] = ACTIONS(1791),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1798),
    [anon_sym___attribute__] = ACTIONS(1801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1804),
    [anon_sym___declspec] = ACTIONS(1807),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_auto] = ACTIONS(1798),
    [anon_sym_register] = ACTIONS(1798),
    [anon_sym_inline] = ACTIONS(1798),
    [anon_sym___inline] = ACTIONS(1798),
    [anon_sym___inline__] = ACTIONS(1798),
    [anon_sym___forceinline] = ACTIONS(1798),
    [anon_sym_thread_local] = ACTIONS(1798),
    [anon_sym___thread] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym___restrict__] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym__Noreturn] = ACTIONS(1795),
    [anon_sym_noreturn] = ACTIONS(1795),
    [anon_sym_alignas] = ACTIONS(1813),
    [anon_sym__Alignas] = ACTIONS(1813),
    [sym_primitive_type] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1819),
    [anon_sym_struct] = ACTIONS(1822),
    [anon_sym_union] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [475] = {
    [sym_attribute_declaration] = STATE(480),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(284),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_attribute_declaration] = STATE(480),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(227),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_attribute_declaration] = STATE(477),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(126),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(477),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_LPAREN2] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1843),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1852),
    [anon_sym_switch] = ACTIONS(1855),
    [anon_sym_case] = ACTIONS(1858),
    [anon_sym_default] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1864),
    [anon_sym_do] = ACTIONS(1867),
    [anon_sym_for] = ACTIONS(1870),
    [anon_sym_return] = ACTIONS(1873),
    [anon_sym_break] = ACTIONS(1876),
    [anon_sym_continue] = ACTIONS(1879),
    [anon_sym_goto] = ACTIONS(1882),
    [anon_sym___try] = ACTIONS(1885),
    [anon_sym___leave] = ACTIONS(1888),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1900),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1906),
    [anon_sym___asm__] = ACTIONS(1906),
    [sym_number_literal] = ACTIONS(1909),
    [anon_sym_L_SQUOTE] = ACTIONS(1912),
    [anon_sym_u_SQUOTE] = ACTIONS(1912),
    [anon_sym_U_SQUOTE] = ACTIONS(1912),
    [anon_sym_u8_SQUOTE] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_L_DQUOTE] = ACTIONS(1915),
    [anon_sym_u_DQUOTE] = ACTIONS(1915),
    [anon_sym_U_DQUOTE] = ACTIONS(1915),
    [anon_sym_u8_DQUOTE] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_attribute_declaration] = STATE(478),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(256),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(478),
    [sym_identifier] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_case] = ACTIONS(1939),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1945),
    [anon_sym_do] = ACTIONS(1948),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1960),
    [anon_sym_goto] = ACTIONS(1963),
    [anon_sym___try] = ACTIONS(1966),
    [anon_sym___leave] = ACTIONS(1969),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1900),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1906),
    [anon_sym___asm__] = ACTIONS(1906),
    [sym_number_literal] = ACTIONS(1909),
    [anon_sym_L_SQUOTE] = ACTIONS(1912),
    [anon_sym_u_SQUOTE] = ACTIONS(1912),
    [anon_sym_U_SQUOTE] = ACTIONS(1912),
    [anon_sym_u8_SQUOTE] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_L_DQUOTE] = ACTIONS(1915),
    [anon_sym_u_DQUOTE] = ACTIONS(1915),
    [anon_sym_U_DQUOTE] = ACTIONS(1915),
    [anon_sym_u8_DQUOTE] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_attribute_declaration] = STATE(511),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(271),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_attribute_declaration] = STATE(513),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(185),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(513),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_attribute_declaration] = STATE(480),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(168),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(2344),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_attribute_declaration] = STATE(511),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(170),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_attribute_declaration] = STATE(484),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(171),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(1978),
    [anon_sym_LPAREN2] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1993),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_do] = ACTIONS(2002),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2014),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1900),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1906),
    [anon_sym___asm__] = ACTIONS(1906),
    [sym_number_literal] = ACTIONS(1909),
    [anon_sym_L_SQUOTE] = ACTIONS(1912),
    [anon_sym_u_SQUOTE] = ACTIONS(1912),
    [anon_sym_U_SQUOTE] = ACTIONS(1912),
    [anon_sym_u8_SQUOTE] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_L_DQUOTE] = ACTIONS(1915),
    [anon_sym_u_DQUOTE] = ACTIONS(1915),
    [anon_sym_U_DQUOTE] = ACTIONS(1915),
    [anon_sym_u8_DQUOTE] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_attribute_declaration] = STATE(484),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(171),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(484),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_attribute_declaration] = STATE(480),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(297),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(480),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_case] = ACTIONS(421),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_goto] = ACTIONS(437),
    [anon_sym___try] = ACTIONS(439),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_attribute_declaration] = STATE(487),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(171),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(2026),
    [anon_sym_LPAREN2] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2041),
    [anon_sym_do] = ACTIONS(2002),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2014),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2047),
    [anon_sym___leave] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1900),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1906),
    [anon_sym___asm__] = ACTIONS(1906),
    [sym_number_literal] = ACTIONS(1909),
    [anon_sym_L_SQUOTE] = ACTIONS(1912),
    [anon_sym_u_SQUOTE] = ACTIONS(1912),
    [anon_sym_U_SQUOTE] = ACTIONS(1912),
    [anon_sym_u8_SQUOTE] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_L_DQUOTE] = ACTIONS(1915),
    [anon_sym_u_DQUOTE] = ACTIONS(1915),
    [anon_sym_U_DQUOTE] = ACTIONS(1915),
    [anon_sym_u8_DQUOTE] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(2327),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_attribute_declaration] = STATE(511),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(306),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(234),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(243),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_attribute_declaration] = STATE(504),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(109),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_attribute_declaration] = STATE(487),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(171),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_attribute_declaration] = STATE(493),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(234),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_attribute_declaration] = STATE(493),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(295),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_attribute_declaration] = STATE(511),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(304),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(511),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(295),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(315),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1386),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(882),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_LPAREN2] = ACTIONS(2055),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1798),
    [anon_sym___attribute__] = ACTIONS(1801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1804),
    [anon_sym___declspec] = ACTIONS(1807),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_auto] = ACTIONS(1798),
    [anon_sym_register] = ACTIONS(1798),
    [anon_sym_inline] = ACTIONS(1798),
    [anon_sym___inline] = ACTIONS(1798),
    [anon_sym___inline__] = ACTIONS(1798),
    [anon_sym___forceinline] = ACTIONS(1798),
    [anon_sym_thread_local] = ACTIONS(1798),
    [anon_sym___thread] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym___restrict__] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym__Noreturn] = ACTIONS(1795),
    [anon_sym_noreturn] = ACTIONS(1795),
    [anon_sym_alignas] = ACTIONS(1813),
    [anon_sym__Alignas] = ACTIONS(1813),
    [sym_primitive_type] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1819),
    [anon_sym_struct] = ACTIONS(1822),
    [anon_sym_union] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [500] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(440),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1387),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(890),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_LPAREN2] = ACTIONS(2057),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1798),
    [anon_sym___attribute__] = ACTIONS(1801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1804),
    [anon_sym___declspec] = ACTIONS(1807),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_auto] = ACTIONS(1798),
    [anon_sym_register] = ACTIONS(1798),
    [anon_sym_inline] = ACTIONS(1798),
    [anon_sym___inline] = ACTIONS(1798),
    [anon_sym___inline__] = ACTIONS(1798),
    [anon_sym___forceinline] = ACTIONS(1798),
    [anon_sym_thread_local] = ACTIONS(1798),
    [anon_sym___thread] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym___restrict__] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym__Noreturn] = ACTIONS(1795),
    [anon_sym_noreturn] = ACTIONS(1795),
    [anon_sym_alignas] = ACTIONS(1813),
    [anon_sym__Alignas] = ACTIONS(1813),
    [sym_primitive_type] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1819),
    [anon_sym_struct] = ACTIONS(1822),
    [anon_sym_union] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [502] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(2180),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1407),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(867),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_LPAREN2] = ACTIONS(2059),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1798),
    [anon_sym___attribute__] = ACTIONS(1801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1804),
    [anon_sym___declspec] = ACTIONS(1807),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1810),
    [anon_sym_unsigned] = ACTIONS(1810),
    [anon_sym_long] = ACTIONS(1810),
    [anon_sym_short] = ACTIONS(1810),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_auto] = ACTIONS(1798),
    [anon_sym_register] = ACTIONS(1798),
    [anon_sym_inline] = ACTIONS(1798),
    [anon_sym___inline] = ACTIONS(1798),
    [anon_sym___inline__] = ACTIONS(1798),
    [anon_sym___forceinline] = ACTIONS(1798),
    [anon_sym_thread_local] = ACTIONS(1798),
    [anon_sym___thread] = ACTIONS(1798),
    [anon_sym_const] = ACTIONS(1795),
    [anon_sym_constexpr] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_restrict] = ACTIONS(1795),
    [anon_sym___restrict__] = ACTIONS(1795),
    [anon_sym__Atomic] = ACTIONS(1795),
    [anon_sym__Noreturn] = ACTIONS(1795),
    [anon_sym_noreturn] = ACTIONS(1795),
    [anon_sym_alignas] = ACTIONS(1813),
    [anon_sym__Alignas] = ACTIONS(1813),
    [sym_primitive_type] = ACTIONS(1816),
    [anon_sym_enum] = ACTIONS(1819),
    [anon_sym_struct] = ACTIONS(1822),
    [anon_sym_union] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [504] = {
    [sym_attribute_declaration] = STATE(477),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(126),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(477),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_attribute_declaration] = STATE(504),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(102),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [sym_attribute_declaration] = STATE(485),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(2305),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(485),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(1974),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(1198),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1200),
    [anon_sym___leave] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [sym_attribute_declaration] = STATE(504),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(112),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [sym_attribute_declaration] = STATE(504),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(100),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [sym_attribute_declaration] = STATE(493),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(243),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [sym_attribute_declaration] = STATE(504),
    [sym_compound_statement] = STATE(119),
    [sym_attributed_statement] = STATE(119),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(119),
    [sym_expression_statement] = STATE(119),
    [sym_if_statement] = STATE(119),
    [sym_switch_statement] = STATE(119),
    [sym_case_statement] = STATE(119),
    [sym_while_statement] = STATE(119),
    [sym_do_statement] = STATE(119),
    [sym_for_statement] = STATE(119),
    [sym_return_statement] = STATE(119),
    [sym_break_statement] = STATE(119),
    [sym_continue_statement] = STATE(119),
    [sym_goto_statement] = STATE(119),
    [sym_seh_try_statement] = STATE(119),
    [sym_seh_leave_statement] = STATE(119),
    [sym_expression] = STATE(1195),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2227),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(504),
    [sym_identifier] = ACTIONS(2053),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_do] = ACTIONS(159),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_return] = ACTIONS(163),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(167),
    [anon_sym_goto] = ACTIONS(169),
    [anon_sym___try] = ACTIONS(171),
    [anon_sym___leave] = ACTIONS(173),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [sym_attribute_declaration] = STATE(478),
    [sym_compound_statement] = STATE(247),
    [sym_attributed_statement] = STATE(247),
    [sym_statement] = STATE(256),
    [sym_labeled_statement] = STATE(247),
    [sym_expression_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_switch_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_do_statement] = STATE(247),
    [sym_for_statement] = STATE(247),
    [sym_return_statement] = STATE(247),
    [sym_break_statement] = STATE(247),
    [sym_continue_statement] = STATE(247),
    [sym_goto_statement] = STATE(247),
    [sym_seh_try_statement] = STATE(247),
    [sym_seh_leave_statement] = STATE(247),
    [sym_expression] = STATE(1182),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2229),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(478),
    [sym_identifier] = ACTIONS(1780),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_goto] = ACTIONS(505),
    [anon_sym___try] = ACTIONS(507),
    [anon_sym___leave] = ACTIONS(509),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_attribute_declaration] = STATE(493),
    [sym_compound_statement] = STATE(181),
    [sym_attributed_statement] = STATE(181),
    [sym_statement] = STATE(315),
    [sym_labeled_statement] = STATE(181),
    [sym_expression_statement] = STATE(181),
    [sym_if_statement] = STATE(181),
    [sym_switch_statement] = STATE(181),
    [sym_case_statement] = STATE(181),
    [sym_while_statement] = STATE(181),
    [sym_do_statement] = STATE(181),
    [sym_for_statement] = STATE(181),
    [sym_return_statement] = STATE(181),
    [sym_break_statement] = STATE(181),
    [sym_continue_statement] = STATE(181),
    [sym_goto_statement] = STATE(181),
    [sym_seh_try_statement] = STATE(181),
    [sym_seh_leave_statement] = STATE(181),
    [sym_expression] = STATE(1189),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2258),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(493),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1012),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_switch] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(69),
    [anon_sym_default] = ACTIONS(71),
    [anon_sym_while] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_for] = ACTIONS(77),
    [anon_sym_return] = ACTIONS(79),
    [anon_sym_break] = ACTIONS(81),
    [anon_sym_continue] = ACTIONS(83),
    [anon_sym_goto] = ACTIONS(85),
    [anon_sym___try] = ACTIONS(1014),
    [anon_sym___leave] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [sym_attribute_declaration] = STATE(513),
    [sym_compound_statement] = STATE(183),
    [sym_attributed_statement] = STATE(183),
    [sym_statement] = STATE(185),
    [sym_labeled_statement] = STATE(183),
    [sym_expression_statement] = STATE(183),
    [sym_if_statement] = STATE(183),
    [sym_switch_statement] = STATE(183),
    [sym_case_statement] = STATE(183),
    [sym_while_statement] = STATE(183),
    [sym_do_statement] = STATE(183),
    [sym_for_statement] = STATE(183),
    [sym_return_statement] = STATE(183),
    [sym_break_statement] = STATE(183),
    [sym_continue_statement] = STATE(183),
    [sym_goto_statement] = STATE(183),
    [sym_seh_try_statement] = STATE(183),
    [sym_seh_leave_statement] = STATE(183),
    [sym_expression] = STATE(1157),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2207),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_attributed_declarator_repeat1] = STATE(513),
    [sym_identifier] = ACTIONS(2061),
    [anon_sym_LPAREN2] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1834),
    [anon_sym_TILDE] = ACTIONS(1834),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2070),
    [anon_sym_case] = ACTIONS(2073),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2079),
    [anon_sym_do] = ACTIONS(2082),
    [anon_sym_for] = ACTIONS(2085),
    [anon_sym_return] = ACTIONS(2088),
    [anon_sym_break] = ACTIONS(2091),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_goto] = ACTIONS(2097),
    [anon_sym___try] = ACTIONS(2100),
    [anon_sym___leave] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(1891),
    [anon_sym_PLUS_PLUS] = ACTIONS(1891),
    [anon_sym_sizeof] = ACTIONS(1894),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1900),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1906),
    [anon_sym___asm__] = ACTIONS(1906),
    [sym_number_literal] = ACTIONS(1909),
    [anon_sym_L_SQUOTE] = ACTIONS(1912),
    [anon_sym_u_SQUOTE] = ACTIONS(1912),
    [anon_sym_U_SQUOTE] = ACTIONS(1912),
    [anon_sym_u8_SQUOTE] = ACTIONS(1912),
    [anon_sym_SQUOTE] = ACTIONS(1912),
    [anon_sym_L_DQUOTE] = ACTIONS(1915),
    [anon_sym_u_DQUOTE] = ACTIONS(1915),
    [anon_sym_U_DQUOTE] = ACTIONS(1915),
    [anon_sym_u8_DQUOTE] = ACTIONS(1915),
    [anon_sym_DQUOTE] = ACTIONS(1915),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(855),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(855),
    [sym_call_expression] = STATE(855),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(855),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(855),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(1772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1760),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1760),
    [anon_sym_GT_GT] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_STAR_EQ] = ACTIONS(1762),
    [anon_sym_SLASH_EQ] = ACTIONS(1762),
    [anon_sym_PERCENT_EQ] = ACTIONS(1762),
    [anon_sym_PLUS_EQ] = ACTIONS(1762),
    [anon_sym_DASH_EQ] = ACTIONS(1762),
    [anon_sym_LT_LT_EQ] = ACTIONS(1762),
    [anon_sym_GT_GT_EQ] = ACTIONS(1762),
    [anon_sym_AMP_EQ] = ACTIONS(1762),
    [anon_sym_CARET_EQ] = ACTIONS(1762),
    [anon_sym_PIPE_EQ] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(2107),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1311),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_ms_call_modifier] = STATE(1554),
    [sym__abstract_declarator] = STATE(1796),
    [sym_abstract_parenthesized_declarator] = STATE(1751),
    [sym_abstract_pointer_declarator] = STATE(1751),
    [sym_abstract_function_declarator] = STATE(1751),
    [sym_abstract_array_declarator] = STATE(1751),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_variadic_parameter] = STATE(1883),
    [sym_parameter_list] = STATE(1753),
    [sym_parameter_declaration] = STATE(1883),
    [sym_macro_type_specifier] = STATE(980),
    [sym_layout_specification] = STATE(643),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_parameter_declaration_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1744),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_LPAREN2] = ACTIONS(2109),
    [anon_sym_STAR] = ACTIONS(2111),
    [anon_sym_precise] = ACTIONS(1752),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_out] = ACTIONS(1752),
    [anon_sym_inout] = ACTIONS(1752),
    [anon_sym_uniform] = ACTIONS(1752),
    [anon_sym_shared] = ACTIONS(1752),
    [anon_sym_attribute] = ACTIONS(1752),
    [anon_sym_varying] = ACTIONS(1752),
    [anon_sym_buffer] = ACTIONS(1752),
    [anon_sym_coherent] = ACTIONS(1752),
    [anon_sym_readonly] = ACTIONS(1752),
    [anon_sym_writeonly] = ACTIONS(1752),
    [anon_sym_centroid] = ACTIONS(1752),
    [anon_sym_sample] = ACTIONS(1752),
    [anon_sym_patch] = ACTIONS(1752),
    [anon_sym_smooth] = ACTIONS(1752),
    [anon_sym_flat] = ACTIONS(1752),
    [anon_sym_noperspective] = ACTIONS(1752),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym___cdecl] = ACTIONS(45),
    [anon_sym___clrcall] = ACTIONS(45),
    [anon_sym___stdcall] = ACTIONS(45),
    [anon_sym___fastcall] = ACTIONS(45),
    [anon_sym___thiscall] = ACTIONS(45),
    [anon_sym___vectorcall] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(1756),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_layout] = ACTIONS(1758),
  },
  [516] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2153),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1253),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(2119),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [518] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2294),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2242),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1277),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(2123),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [521] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2142),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2366),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1258),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [524] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2211),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1428),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [526] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1429),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [527] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1255),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(2127),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [528] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1434),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [529] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2300),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2249),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2113),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1271),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_subroutine] = ACTIONS(2121),
    [anon_sym_invariant] = ACTIONS(2121),
    [anon_sym_precise] = ACTIONS(2121),
    [anon_sym_in] = ACTIONS(2121),
    [anon_sym_out] = ACTIONS(2121),
    [anon_sym_inout] = ACTIONS(2121),
    [anon_sym_uniform] = ACTIONS(2121),
    [anon_sym_shared] = ACTIONS(2121),
    [anon_sym_attribute] = ACTIONS(2121),
    [anon_sym_varying] = ACTIONS(2121),
    [anon_sym_buffer] = ACTIONS(2121),
    [anon_sym_coherent] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_writeonly] = ACTIONS(2121),
    [anon_sym_precision] = ACTIONS(2121),
    [anon_sym_highp] = ACTIONS(2121),
    [anon_sym_mediump] = ACTIONS(2121),
    [anon_sym_lowp] = ACTIONS(2121),
    [anon_sym_centroid] = ACTIONS(2121),
    [anon_sym_sample] = ACTIONS(2121),
    [anon_sym_patch] = ACTIONS(2121),
    [anon_sym_smooth] = ACTIONS(2121),
    [anon_sym_flat] = ACTIONS(2121),
    [anon_sym_noperspective] = ACTIONS(2121),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(109),
    [anon_sym_rayPayloadInEXT] = ACTIONS(109),
    [anon_sym_hitAttributeEXT] = ACTIONS(109),
    [anon_sym_callableDataEXT] = ACTIONS(109),
    [anon_sym_callableDataInEXT] = ACTIONS(109),
    [anon_sym_shaderRecordEXT] = ACTIONS(109),
    [anon_sym_rayPayloadNV] = ACTIONS(109),
    [anon_sym_rayPayloadInNV] = ACTIONS(109),
    [anon_sym_hitAttributeNV] = ACTIONS(109),
    [anon_sym_callableDataNV] = ACTIONS(109),
    [anon_sym_callableDataInNV] = ACTIONS(109),
    [anon_sym_shaderRecordNV] = ACTIONS(109),
    [anon_sym_layout] = ACTIONS(111),
  },
  [533] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2209),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2131),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1162),
    [sym__string] = STATE(864),
    [sym_comma_expression] = STATE(2295),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2363),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1222),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2267),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [sym_type_qualifier] = STATE(1136),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(1225),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_expression] = STATE(1215),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_type_descriptor] = STATE(2108),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_macro_type_specifier] = STATE(980),
    [aux_sym__type_definition_type_repeat1] = STATE(1136),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1242),
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(2115),
    [anon_sym_unsigned] = ACTIONS(2115),
    [anon_sym_long] = ACTIONS(2115),
    [anon_sym_short] = ACTIONS(2115),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2133),
    [anon_sym_RPAREN] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2133),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym___extension__] = ACTIONS(2131),
    [anon_sym_extern] = ACTIONS(2131),
    [anon_sym___attribute__] = ACTIONS(2131),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2133),
    [anon_sym___declspec] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2133),
    [anon_sym_signed] = ACTIONS(2131),
    [anon_sym_unsigned] = ACTIONS(2131),
    [anon_sym_long] = ACTIONS(2131),
    [anon_sym_short] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_static] = ACTIONS(2131),
    [anon_sym_EQ] = ACTIONS(2133),
    [anon_sym_auto] = ACTIONS(2131),
    [anon_sym_register] = ACTIONS(2131),
    [anon_sym_inline] = ACTIONS(2131),
    [anon_sym___inline] = ACTIONS(2131),
    [anon_sym___inline__] = ACTIONS(2131),
    [anon_sym___forceinline] = ACTIONS(2131),
    [anon_sym_thread_local] = ACTIONS(2131),
    [anon_sym___thread] = ACTIONS(2131),
    [anon_sym_const] = ACTIONS(2131),
    [anon_sym_constexpr] = ACTIONS(2131),
    [anon_sym_volatile] = ACTIONS(2131),
    [anon_sym_restrict] = ACTIONS(2131),
    [anon_sym___restrict__] = ACTIONS(2131),
    [anon_sym__Atomic] = ACTIONS(2131),
    [anon_sym__Noreturn] = ACTIONS(2131),
    [anon_sym_noreturn] = ACTIONS(2131),
    [anon_sym_alignas] = ACTIONS(2131),
    [anon_sym__Alignas] = ACTIONS(2131),
    [sym_primitive_type] = ACTIONS(2131),
    [anon_sym_enum] = ACTIONS(2131),
    [anon_sym_COLON] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2131),
    [anon_sym_union] = ACTIONS(2131),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_case] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_do] = ACTIONS(2131),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_return] = ACTIONS(2131),
    [anon_sym_break] = ACTIONS(2131),
    [anon_sym_continue] = ACTIONS(2131),
    [anon_sym_goto] = ACTIONS(2131),
    [anon_sym___try] = ACTIONS(2131),
    [anon_sym___leave] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2133),
    [anon_sym_PLUS_PLUS] = ACTIONS(2133),
    [anon_sym_sizeof] = ACTIONS(2131),
    [anon_sym___alignof__] = ACTIONS(2131),
    [anon_sym___alignof] = ACTIONS(2131),
    [anon_sym__alignof] = ACTIONS(2131),
    [anon_sym_alignof] = ACTIONS(2131),
    [anon_sym__Alignof] = ACTIONS(2131),
    [anon_sym_offsetof] = ACTIONS(2131),
    [anon_sym__Generic] = ACTIONS(2131),
    [anon_sym_asm] = ACTIONS(2131),
    [anon_sym___asm__] = ACTIONS(2131),
    [sym_number_literal] = ACTIONS(2133),
    [anon_sym_L_SQUOTE] = ACTIONS(2133),
    [anon_sym_u_SQUOTE] = ACTIONS(2133),
    [anon_sym_U_SQUOTE] = ACTIONS(2133),
    [anon_sym_u8_SQUOTE] = ACTIONS(2133),
    [anon_sym_SQUOTE] = ACTIONS(2133),
    [anon_sym_L_DQUOTE] = ACTIONS(2133),
    [anon_sym_u_DQUOTE] = ACTIONS(2133),
    [anon_sym_U_DQUOTE] = ACTIONS(2133),
    [anon_sym_u8_DQUOTE] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2133),
    [sym_true] = ACTIONS(2131),
    [sym_false] = ACTIONS(2131),
    [anon_sym_NULL] = ACTIONS(2131),
    [anon_sym_nullptr] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2135),
    [anon_sym_COMMA] = ACTIONS(2137),
    [anon_sym_RPAREN] = ACTIONS(2137),
    [anon_sym_LPAREN2] = ACTIONS(2137),
    [anon_sym_BANG] = ACTIONS(2137),
    [anon_sym_TILDE] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2135),
    [anon_sym_PLUS] = ACTIONS(2135),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_AMP] = ACTIONS(2137),
    [anon_sym_SEMI] = ACTIONS(2137),
    [anon_sym___extension__] = ACTIONS(2135),
    [anon_sym_extern] = ACTIONS(2135),
    [anon_sym___attribute__] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2137),
    [anon_sym___declspec] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(2137),
    [anon_sym_signed] = ACTIONS(2135),
    [anon_sym_unsigned] = ACTIONS(2135),
    [anon_sym_long] = ACTIONS(2135),
    [anon_sym_short] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(2135),
    [anon_sym_static] = ACTIONS(2135),
    [anon_sym_EQ] = ACTIONS(2137),
    [anon_sym_auto] = ACTIONS(2135),
    [anon_sym_register] = ACTIONS(2135),
    [anon_sym_inline] = ACTIONS(2135),
    [anon_sym___inline] = ACTIONS(2135),
    [anon_sym___inline__] = ACTIONS(2135),
    [anon_sym___forceinline] = ACTIONS(2135),
    [anon_sym_thread_local] = ACTIONS(2135),
    [anon_sym___thread] = ACTIONS(2135),
    [anon_sym_const] = ACTIONS(2135),
    [anon_sym_constexpr] = ACTIONS(2135),
    [anon_sym_volatile] = ACTIONS(2135),
    [anon_sym_restrict] = ACTIONS(2135),
    [anon_sym___restrict__] = ACTIONS(2135),
    [anon_sym__Atomic] = ACTIONS(2135),
    [anon_sym__Noreturn] = ACTIONS(2135),
    [anon_sym_noreturn] = ACTIONS(2135),
    [anon_sym_alignas] = ACTIONS(2135),
    [anon_sym__Alignas] = ACTIONS(2135),
    [sym_primitive_type] = ACTIONS(2135),
    [anon_sym_enum] = ACTIONS(2135),
    [anon_sym_COLON] = ACTIONS(2137),
    [anon_sym_struct] = ACTIONS(2135),
    [anon_sym_union] = ACTIONS(2135),
    [anon_sym_if] = ACTIONS(2135),
    [anon_sym_switch] = ACTIONS(2135),
    [anon_sym_case] = ACTIONS(2135),
    [anon_sym_default] = ACTIONS(2135),
    [anon_sym_while] = ACTIONS(2135),
    [anon_sym_do] = ACTIONS(2135),
    [anon_sym_for] = ACTIONS(2135),
    [anon_sym_return] = ACTIONS(2135),
    [anon_sym_break] = ACTIONS(2135),
    [anon_sym_continue] = ACTIONS(2135),
    [anon_sym_goto] = ACTIONS(2135),
    [anon_sym___try] = ACTIONS(2135),
    [anon_sym___leave] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2137),
    [anon_sym_PLUS_PLUS] = ACTIONS(2137),
    [anon_sym_sizeof] = ACTIONS(2135),
    [anon_sym___alignof__] = ACTIONS(2135),
    [anon_sym___alignof] = ACTIONS(2135),
    [anon_sym__alignof] = ACTIONS(2135),
    [anon_sym_alignof] = ACTIONS(2135),
    [anon_sym__Alignof] = ACTIONS(2135),
    [anon_sym_offsetof] = ACTIONS(2135),
    [anon_sym__Generic] = ACTIONS(2135),
    [anon_sym_asm] = ACTIONS(2135),
    [anon_sym___asm__] = ACTIONS(2135),
    [sym_number_literal] = ACTIONS(2137),
    [anon_sym_L_SQUOTE] = ACTIONS(2137),
    [anon_sym_u_SQUOTE] = ACTIONS(2137),
    [anon_sym_U_SQUOTE] = ACTIONS(2137),
    [anon_sym_u8_SQUOTE] = ACTIONS(2137),
    [anon_sym_SQUOTE] = ACTIONS(2137),
    [anon_sym_L_DQUOTE] = ACTIONS(2137),
    [anon_sym_u_DQUOTE] = ACTIONS(2137),
    [anon_sym_U_DQUOTE] = ACTIONS(2137),
    [anon_sym_u8_DQUOTE] = ACTIONS(2137),
    [anon_sym_DQUOTE] = ACTIONS(2137),
    [sym_true] = ACTIONS(2135),
    [sym_false] = ACTIONS(2135),
    [anon_sym_NULL] = ACTIONS(2135),
    [anon_sym_nullptr] = ACTIONS(2135),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_field_declaration_list] = STATE(1467),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2160),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_field_declaration_list] = STATE(1474),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2164),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [sym_expression] = STATE(877),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym___attribute__] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_field_declaration_list] = STATE(1467),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2160),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [sym_field_declaration_list] = STATE(1477),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2171),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_field_declaration_list] = STATE(1472),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2168),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_field_declaration_list] = STATE(1474),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_field_declaration_list] = STATE(1477),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2171),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_field_declaration_list] = STATE(1472),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [sym_expression] = STATE(877),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(997),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(997),
    [sym_call_expression] = STATE(997),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(997),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(997),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(898),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1762),
    [aux_sym_preproc_if_token2] = ACTIONS(1762),
    [aux_sym_preproc_else_token1] = ACTIONS(1762),
    [aux_sym_preproc_elif_token1] = ACTIONS(1760),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1762),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(2177),
    [anon_sym_TILDE] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(2181),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [sym_field_declaration_list] = STATE(1475),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [sym_field_declaration_list] = STATE(1474),
    [sym_string_literal] = STATE(812),
    [aux_sym_sized_type_specifier_repeat1] = STATE(979),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2143),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2149),
    [anon_sym_SLASH] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_CARET] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_LT_LT] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2152),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2156),
    [anon_sym_unsigned] = ACTIONS(2156),
    [anon_sym_long] = ACTIONS(2156),
    [anon_sym_short] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2147),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_auto] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [anon_sym_COLON] = ACTIONS(2175),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_STAR_EQ] = ACTIONS(2162),
    [anon_sym_SLASH_EQ] = ACTIONS(2162),
    [anon_sym_PERCENT_EQ] = ACTIONS(2162),
    [anon_sym_PLUS_EQ] = ACTIONS(2162),
    [anon_sym_DASH_EQ] = ACTIONS(2162),
    [anon_sym_LT_LT_EQ] = ACTIONS(2162),
    [anon_sym_GT_GT_EQ] = ACTIONS(2162),
    [anon_sym_AMP_EQ] = ACTIONS(2162),
    [anon_sym_CARET_EQ] = ACTIONS(2162),
    [anon_sym_PIPE_EQ] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_DASH_GT] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_identifier] = ACTIONS(2186),
    [anon_sym_LPAREN2] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2193),
    [anon_sym_extern] = ACTIONS(2193),
    [anon_sym___attribute__] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2195),
    [anon_sym___declspec] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_signed] = ACTIONS(2193),
    [anon_sym_unsigned] = ACTIONS(2193),
    [anon_sym_long] = ACTIONS(2193),
    [anon_sym_short] = ACTIONS(2193),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_auto] = ACTIONS(2193),
    [anon_sym_register] = ACTIONS(2193),
    [anon_sym_inline] = ACTIONS(2193),
    [anon_sym___inline] = ACTIONS(2193),
    [anon_sym___inline__] = ACTIONS(2193),
    [anon_sym___forceinline] = ACTIONS(2193),
    [anon_sym_thread_local] = ACTIONS(2193),
    [anon_sym___thread] = ACTIONS(2193),
    [anon_sym_const] = ACTIONS(2193),
    [anon_sym_constexpr] = ACTIONS(2193),
    [anon_sym_volatile] = ACTIONS(2193),
    [anon_sym_restrict] = ACTIONS(2193),
    [anon_sym___restrict__] = ACTIONS(2193),
    [anon_sym__Atomic] = ACTIONS(2193),
    [anon_sym__Noreturn] = ACTIONS(2193),
    [anon_sym_noreturn] = ACTIONS(2193),
    [anon_sym_alignas] = ACTIONS(2193),
    [anon_sym__Alignas] = ACTIONS(2193),
    [sym_primitive_type] = ACTIONS(2193),
    [anon_sym_enum] = ACTIONS(2193),
    [anon_sym_struct] = ACTIONS(2193),
    [anon_sym_union] = ACTIONS(2193),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_goto] = ACTIONS(2191),
    [anon_sym___try] = ACTIONS(2191),
    [anon_sym___leave] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2191),
    [anon_sym___alignof__] = ACTIONS(2191),
    [anon_sym___alignof] = ACTIONS(2191),
    [anon_sym__alignof] = ACTIONS(2191),
    [anon_sym_alignof] = ACTIONS(2191),
    [anon_sym__Alignof] = ACTIONS(2191),
    [anon_sym_offsetof] = ACTIONS(2191),
    [anon_sym__Generic] = ACTIONS(2191),
    [anon_sym_asm] = ACTIONS(2191),
    [anon_sym___asm__] = ACTIONS(2191),
    [sym_number_literal] = ACTIONS(2189),
    [anon_sym_L_SQUOTE] = ACTIONS(2189),
    [anon_sym_u_SQUOTE] = ACTIONS(2189),
    [anon_sym_U_SQUOTE] = ACTIONS(2189),
    [anon_sym_u8_SQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_L_DQUOTE] = ACTIONS(2189),
    [anon_sym_u_DQUOTE] = ACTIONS(2189),
    [anon_sym_U_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8_DQUOTE] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [anon_sym_NULL] = ACTIONS(2191),
    [anon_sym_nullptr] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token2] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [aux_sym_preproc_else_token1] = ACTIONS(2198),
    [aux_sym_preproc_elif_token1] = ACTIONS(2198),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_subroutine] = ACTIONS(2198),
    [anon_sym_invariant] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_attribute] = ACTIONS(2198),
    [anon_sym_varying] = ACTIONS(2198),
    [anon_sym_buffer] = ACTIONS(2198),
    [anon_sym_coherent] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(2198),
    [anon_sym_writeonly] = ACTIONS(2198),
    [anon_sym_precision] = ACTIONS(2198),
    [anon_sym_highp] = ACTIONS(2198),
    [anon_sym_mediump] = ACTIONS(2198),
    [anon_sym_lowp] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_patch] = ACTIONS(2198),
    [anon_sym_smooth] = ACTIONS(2198),
    [anon_sym_flat] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_auto] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2198),
    [anon_sym_hitAttributeEXT] = ACTIONS(2198),
    [anon_sym_callableDataEXT] = ACTIONS(2198),
    [anon_sym_callableDataInEXT] = ACTIONS(2198),
    [anon_sym_shaderRecordEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadNV] = ACTIONS(2198),
    [anon_sym_rayPayloadInNV] = ACTIONS(2198),
    [anon_sym_hitAttributeNV] = ACTIONS(2198),
    [anon_sym_callableDataNV] = ACTIONS(2198),
    [anon_sym_callableDataInNV] = ACTIONS(2198),
    [anon_sym_shaderRecordNV] = ACTIONS(2198),
    [anon_sym_layout] = ACTIONS(2198),
  },
  [554] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token2] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [aux_sym_preproc_else_token1] = ACTIONS(2202),
    [aux_sym_preproc_elif_token1] = ACTIONS(2202),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_subroutine] = ACTIONS(2202),
    [anon_sym_invariant] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_attribute] = ACTIONS(2202),
    [anon_sym_varying] = ACTIONS(2202),
    [anon_sym_buffer] = ACTIONS(2202),
    [anon_sym_coherent] = ACTIONS(2202),
    [anon_sym_readonly] = ACTIONS(2202),
    [anon_sym_writeonly] = ACTIONS(2202),
    [anon_sym_precision] = ACTIONS(2202),
    [anon_sym_highp] = ACTIONS(2202),
    [anon_sym_mediump] = ACTIONS(2202),
    [anon_sym_lowp] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_patch] = ACTIONS(2202),
    [anon_sym_smooth] = ACTIONS(2202),
    [anon_sym_flat] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_auto] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2202),
    [anon_sym_hitAttributeEXT] = ACTIONS(2202),
    [anon_sym_callableDataEXT] = ACTIONS(2202),
    [anon_sym_callableDataInEXT] = ACTIONS(2202),
    [anon_sym_shaderRecordEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadNV] = ACTIONS(2202),
    [anon_sym_rayPayloadInNV] = ACTIONS(2202),
    [anon_sym_hitAttributeNV] = ACTIONS(2202),
    [anon_sym_callableDataNV] = ACTIONS(2202),
    [anon_sym_callableDataInNV] = ACTIONS(2202),
    [anon_sym_shaderRecordNV] = ACTIONS(2202),
    [anon_sym_layout] = ACTIONS(2202),
  },
  [555] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token2] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [aux_sym_preproc_else_token1] = ACTIONS(1489),
    [aux_sym_preproc_elif_token1] = ACTIONS(1489),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token2] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [aux_sym_preproc_else_token1] = ACTIONS(2206),
    [aux_sym_preproc_elif_token1] = ACTIONS(2206),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_subroutine] = ACTIONS(2206),
    [anon_sym_invariant] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_attribute] = ACTIONS(2206),
    [anon_sym_varying] = ACTIONS(2206),
    [anon_sym_buffer] = ACTIONS(2206),
    [anon_sym_coherent] = ACTIONS(2206),
    [anon_sym_readonly] = ACTIONS(2206),
    [anon_sym_writeonly] = ACTIONS(2206),
    [anon_sym_precision] = ACTIONS(2206),
    [anon_sym_highp] = ACTIONS(2206),
    [anon_sym_mediump] = ACTIONS(2206),
    [anon_sym_lowp] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_patch] = ACTIONS(2206),
    [anon_sym_smooth] = ACTIONS(2206),
    [anon_sym_flat] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_auto] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2206),
    [anon_sym_hitAttributeEXT] = ACTIONS(2206),
    [anon_sym_callableDataEXT] = ACTIONS(2206),
    [anon_sym_callableDataInEXT] = ACTIONS(2206),
    [anon_sym_shaderRecordEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadNV] = ACTIONS(2206),
    [anon_sym_rayPayloadInNV] = ACTIONS(2206),
    [anon_sym_hitAttributeNV] = ACTIONS(2206),
    [anon_sym_callableDataNV] = ACTIONS(2206),
    [anon_sym_callableDataInNV] = ACTIONS(2206),
    [anon_sym_shaderRecordNV] = ACTIONS(2206),
    [anon_sym_layout] = ACTIONS(2206),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token2] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [aux_sym_preproc_else_token1] = ACTIONS(2210),
    [aux_sym_preproc_elif_token1] = ACTIONS(2210),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_subroutine] = ACTIONS(2210),
    [anon_sym_invariant] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_attribute] = ACTIONS(2210),
    [anon_sym_varying] = ACTIONS(2210),
    [anon_sym_buffer] = ACTIONS(2210),
    [anon_sym_coherent] = ACTIONS(2210),
    [anon_sym_readonly] = ACTIONS(2210),
    [anon_sym_writeonly] = ACTIONS(2210),
    [anon_sym_precision] = ACTIONS(2210),
    [anon_sym_highp] = ACTIONS(2210),
    [anon_sym_mediump] = ACTIONS(2210),
    [anon_sym_lowp] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_patch] = ACTIONS(2210),
    [anon_sym_smooth] = ACTIONS(2210),
    [anon_sym_flat] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2212),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_auto] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2210),
    [anon_sym_hitAttributeEXT] = ACTIONS(2210),
    [anon_sym_callableDataEXT] = ACTIONS(2210),
    [anon_sym_callableDataInEXT] = ACTIONS(2210),
    [anon_sym_shaderRecordEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadNV] = ACTIONS(2210),
    [anon_sym_rayPayloadInNV] = ACTIONS(2210),
    [anon_sym_hitAttributeNV] = ACTIONS(2210),
    [anon_sym_callableDataNV] = ACTIONS(2210),
    [anon_sym_callableDataInNV] = ACTIONS(2210),
    [anon_sym_shaderRecordNV] = ACTIONS(2210),
    [anon_sym_layout] = ACTIONS(2210),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token2] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [aux_sym_preproc_else_token1] = ACTIONS(2214),
    [aux_sym_preproc_elif_token1] = ACTIONS(2214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_subroutine] = ACTIONS(2214),
    [anon_sym_invariant] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_attribute] = ACTIONS(2214),
    [anon_sym_varying] = ACTIONS(2214),
    [anon_sym_buffer] = ACTIONS(2214),
    [anon_sym_coherent] = ACTIONS(2214),
    [anon_sym_readonly] = ACTIONS(2214),
    [anon_sym_writeonly] = ACTIONS(2214),
    [anon_sym_precision] = ACTIONS(2214),
    [anon_sym_highp] = ACTIONS(2214),
    [anon_sym_mediump] = ACTIONS(2214),
    [anon_sym_lowp] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_patch] = ACTIONS(2214),
    [anon_sym_smooth] = ACTIONS(2214),
    [anon_sym_flat] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_auto] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2214),
    [anon_sym_hitAttributeEXT] = ACTIONS(2214),
    [anon_sym_callableDataEXT] = ACTIONS(2214),
    [anon_sym_callableDataInEXT] = ACTIONS(2214),
    [anon_sym_shaderRecordEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadNV] = ACTIONS(2214),
    [anon_sym_rayPayloadInNV] = ACTIONS(2214),
    [anon_sym_hitAttributeNV] = ACTIONS(2214),
    [anon_sym_callableDataNV] = ACTIONS(2214),
    [anon_sym_callableDataInNV] = ACTIONS(2214),
    [anon_sym_shaderRecordNV] = ACTIONS(2214),
    [anon_sym_layout] = ACTIONS(2214),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token2] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [aux_sym_preproc_else_token1] = ACTIONS(2218),
    [aux_sym_preproc_elif_token1] = ACTIONS(2218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_subroutine] = ACTIONS(2218),
    [anon_sym_invariant] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_attribute] = ACTIONS(2218),
    [anon_sym_varying] = ACTIONS(2218),
    [anon_sym_buffer] = ACTIONS(2218),
    [anon_sym_coherent] = ACTIONS(2218),
    [anon_sym_readonly] = ACTIONS(2218),
    [anon_sym_writeonly] = ACTIONS(2218),
    [anon_sym_precision] = ACTIONS(2218),
    [anon_sym_highp] = ACTIONS(2218),
    [anon_sym_mediump] = ACTIONS(2218),
    [anon_sym_lowp] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_patch] = ACTIONS(2218),
    [anon_sym_smooth] = ACTIONS(2218),
    [anon_sym_flat] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_auto] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2218),
    [anon_sym_hitAttributeEXT] = ACTIONS(2218),
    [anon_sym_callableDataEXT] = ACTIONS(2218),
    [anon_sym_callableDataInEXT] = ACTIONS(2218),
    [anon_sym_shaderRecordEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadNV] = ACTIONS(2218),
    [anon_sym_rayPayloadInNV] = ACTIONS(2218),
    [anon_sym_hitAttributeNV] = ACTIONS(2218),
    [anon_sym_callableDataNV] = ACTIONS(2218),
    [anon_sym_callableDataInNV] = ACTIONS(2218),
    [anon_sym_shaderRecordNV] = ACTIONS(2218),
    [anon_sym_layout] = ACTIONS(2218),
  },
  [560] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token2] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [aux_sym_preproc_else_token1] = ACTIONS(1485),
    [aux_sym_preproc_elif_token1] = ACTIONS(1485),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [561] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [aux_sym_preproc_else_token1] = ACTIONS(2222),
    [aux_sym_preproc_elif_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_subroutine] = ACTIONS(2222),
    [anon_sym_invariant] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_attribute] = ACTIONS(2222),
    [anon_sym_varying] = ACTIONS(2222),
    [anon_sym_buffer] = ACTIONS(2222),
    [anon_sym_coherent] = ACTIONS(2222),
    [anon_sym_readonly] = ACTIONS(2222),
    [anon_sym_writeonly] = ACTIONS(2222),
    [anon_sym_precision] = ACTIONS(2222),
    [anon_sym_highp] = ACTIONS(2222),
    [anon_sym_mediump] = ACTIONS(2222),
    [anon_sym_lowp] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_patch] = ACTIONS(2222),
    [anon_sym_smooth] = ACTIONS(2222),
    [anon_sym_flat] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_auto] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2222),
    [anon_sym_hitAttributeEXT] = ACTIONS(2222),
    [anon_sym_callableDataEXT] = ACTIONS(2222),
    [anon_sym_callableDataInEXT] = ACTIONS(2222),
    [anon_sym_shaderRecordEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadNV] = ACTIONS(2222),
    [anon_sym_rayPayloadInNV] = ACTIONS(2222),
    [anon_sym_hitAttributeNV] = ACTIONS(2222),
    [anon_sym_callableDataNV] = ACTIONS(2222),
    [anon_sym_callableDataInNV] = ACTIONS(2222),
    [anon_sym_shaderRecordNV] = ACTIONS(2222),
    [anon_sym_layout] = ACTIONS(2222),
  },
  [562] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token2] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [aux_sym_preproc_else_token1] = ACTIONS(2226),
    [aux_sym_preproc_elif_token1] = ACTIONS(2226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_subroutine] = ACTIONS(2226),
    [anon_sym_invariant] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_attribute] = ACTIONS(2226),
    [anon_sym_varying] = ACTIONS(2226),
    [anon_sym_buffer] = ACTIONS(2226),
    [anon_sym_coherent] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_writeonly] = ACTIONS(2226),
    [anon_sym_precision] = ACTIONS(2226),
    [anon_sym_highp] = ACTIONS(2226),
    [anon_sym_mediump] = ACTIONS(2226),
    [anon_sym_lowp] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_patch] = ACTIONS(2226),
    [anon_sym_smooth] = ACTIONS(2226),
    [anon_sym_flat] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_auto] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2226),
    [anon_sym_hitAttributeEXT] = ACTIONS(2226),
    [anon_sym_callableDataEXT] = ACTIONS(2226),
    [anon_sym_callableDataInEXT] = ACTIONS(2226),
    [anon_sym_shaderRecordEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadNV] = ACTIONS(2226),
    [anon_sym_rayPayloadInNV] = ACTIONS(2226),
    [anon_sym_hitAttributeNV] = ACTIONS(2226),
    [anon_sym_callableDataNV] = ACTIONS(2226),
    [anon_sym_callableDataInNV] = ACTIONS(2226),
    [anon_sym_shaderRecordNV] = ACTIONS(2226),
    [anon_sym_layout] = ACTIONS(2226),
  },
  [563] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token2] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [aux_sym_preproc_else_token1] = ACTIONS(1409),
    [aux_sym_preproc_elif_token1] = ACTIONS(1409),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [564] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token2] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [aux_sym_preproc_else_token1] = ACTIONS(1401),
    [aux_sym_preproc_elif_token1] = ACTIONS(1401),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [565] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token2] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [aux_sym_preproc_else_token1] = ACTIONS(1441),
    [aux_sym_preproc_elif_token1] = ACTIONS(1441),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [566] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [aux_sym_preproc_else_token1] = ACTIONS(1429),
    [aux_sym_preproc_elif_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token2] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [aux_sym_preproc_else_token1] = ACTIONS(2230),
    [aux_sym_preproc_elif_token1] = ACTIONS(2230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_subroutine] = ACTIONS(2230),
    [anon_sym_invariant] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_attribute] = ACTIONS(2230),
    [anon_sym_varying] = ACTIONS(2230),
    [anon_sym_buffer] = ACTIONS(2230),
    [anon_sym_coherent] = ACTIONS(2230),
    [anon_sym_readonly] = ACTIONS(2230),
    [anon_sym_writeonly] = ACTIONS(2230),
    [anon_sym_precision] = ACTIONS(2230),
    [anon_sym_highp] = ACTIONS(2230),
    [anon_sym_mediump] = ACTIONS(2230),
    [anon_sym_lowp] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_patch] = ACTIONS(2230),
    [anon_sym_smooth] = ACTIONS(2230),
    [anon_sym_flat] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_auto] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2230),
    [anon_sym_hitAttributeEXT] = ACTIONS(2230),
    [anon_sym_callableDataEXT] = ACTIONS(2230),
    [anon_sym_callableDataInEXT] = ACTIONS(2230),
    [anon_sym_shaderRecordEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadNV] = ACTIONS(2230),
    [anon_sym_rayPayloadInNV] = ACTIONS(2230),
    [anon_sym_hitAttributeNV] = ACTIONS(2230),
    [anon_sym_callableDataNV] = ACTIONS(2230),
    [anon_sym_callableDataInNV] = ACTIONS(2230),
    [anon_sym_shaderRecordNV] = ACTIONS(2230),
    [anon_sym_layout] = ACTIONS(2230),
  },
  [568] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token2] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [aux_sym_preproc_else_token1] = ACTIONS(2234),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_subroutine] = ACTIONS(2234),
    [anon_sym_invariant] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_attribute] = ACTIONS(2234),
    [anon_sym_varying] = ACTIONS(2234),
    [anon_sym_buffer] = ACTIONS(2234),
    [anon_sym_coherent] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_writeonly] = ACTIONS(2234),
    [anon_sym_precision] = ACTIONS(2234),
    [anon_sym_highp] = ACTIONS(2234),
    [anon_sym_mediump] = ACTIONS(2234),
    [anon_sym_lowp] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_patch] = ACTIONS(2234),
    [anon_sym_smooth] = ACTIONS(2234),
    [anon_sym_flat] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_auto] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2234),
    [anon_sym_hitAttributeEXT] = ACTIONS(2234),
    [anon_sym_callableDataEXT] = ACTIONS(2234),
    [anon_sym_callableDataInEXT] = ACTIONS(2234),
    [anon_sym_shaderRecordEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadNV] = ACTIONS(2234),
    [anon_sym_rayPayloadInNV] = ACTIONS(2234),
    [anon_sym_hitAttributeNV] = ACTIONS(2234),
    [anon_sym_callableDataNV] = ACTIONS(2234),
    [anon_sym_callableDataInNV] = ACTIONS(2234),
    [anon_sym_shaderRecordNV] = ACTIONS(2234),
    [anon_sym_layout] = ACTIONS(2234),
  },
  [569] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token2] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [aux_sym_preproc_else_token1] = ACTIONS(2238),
    [aux_sym_preproc_elif_token1] = ACTIONS(2238),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_subroutine] = ACTIONS(2238),
    [anon_sym_invariant] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_attribute] = ACTIONS(2238),
    [anon_sym_varying] = ACTIONS(2238),
    [anon_sym_buffer] = ACTIONS(2238),
    [anon_sym_coherent] = ACTIONS(2238),
    [anon_sym_readonly] = ACTIONS(2238),
    [anon_sym_writeonly] = ACTIONS(2238),
    [anon_sym_precision] = ACTIONS(2238),
    [anon_sym_highp] = ACTIONS(2238),
    [anon_sym_mediump] = ACTIONS(2238),
    [anon_sym_lowp] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_patch] = ACTIONS(2238),
    [anon_sym_smooth] = ACTIONS(2238),
    [anon_sym_flat] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_auto] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2238),
    [anon_sym_hitAttributeEXT] = ACTIONS(2238),
    [anon_sym_callableDataEXT] = ACTIONS(2238),
    [anon_sym_callableDataInEXT] = ACTIONS(2238),
    [anon_sym_shaderRecordEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadNV] = ACTIONS(2238),
    [anon_sym_rayPayloadInNV] = ACTIONS(2238),
    [anon_sym_hitAttributeNV] = ACTIONS(2238),
    [anon_sym_callableDataNV] = ACTIONS(2238),
    [anon_sym_callableDataInNV] = ACTIONS(2238),
    [anon_sym_shaderRecordNV] = ACTIONS(2238),
    [anon_sym_layout] = ACTIONS(2238),
  },
  [570] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [aux_sym_preproc_else_token1] = ACTIONS(2242),
    [aux_sym_preproc_elif_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_subroutine] = ACTIONS(2242),
    [anon_sym_invariant] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_attribute] = ACTIONS(2242),
    [anon_sym_varying] = ACTIONS(2242),
    [anon_sym_buffer] = ACTIONS(2242),
    [anon_sym_coherent] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_writeonly] = ACTIONS(2242),
    [anon_sym_precision] = ACTIONS(2242),
    [anon_sym_highp] = ACTIONS(2242),
    [anon_sym_mediump] = ACTIONS(2242),
    [anon_sym_lowp] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_patch] = ACTIONS(2242),
    [anon_sym_smooth] = ACTIONS(2242),
    [anon_sym_flat] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_auto] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2242),
    [anon_sym_hitAttributeEXT] = ACTIONS(2242),
    [anon_sym_callableDataEXT] = ACTIONS(2242),
    [anon_sym_callableDataInEXT] = ACTIONS(2242),
    [anon_sym_shaderRecordEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadNV] = ACTIONS(2242),
    [anon_sym_rayPayloadInNV] = ACTIONS(2242),
    [anon_sym_hitAttributeNV] = ACTIONS(2242),
    [anon_sym_callableDataNV] = ACTIONS(2242),
    [anon_sym_callableDataInNV] = ACTIONS(2242),
    [anon_sym_shaderRecordNV] = ACTIONS(2242),
    [anon_sym_layout] = ACTIONS(2242),
  },
  [571] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [aux_sym_preproc_else_token1] = ACTIONS(2246),
    [aux_sym_preproc_elif_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_subroutine] = ACTIONS(2246),
    [anon_sym_invariant] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_attribute] = ACTIONS(2246),
    [anon_sym_varying] = ACTIONS(2246),
    [anon_sym_buffer] = ACTIONS(2246),
    [anon_sym_coherent] = ACTIONS(2246),
    [anon_sym_readonly] = ACTIONS(2246),
    [anon_sym_writeonly] = ACTIONS(2246),
    [anon_sym_precision] = ACTIONS(2246),
    [anon_sym_highp] = ACTIONS(2246),
    [anon_sym_mediump] = ACTIONS(2246),
    [anon_sym_lowp] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_patch] = ACTIONS(2246),
    [anon_sym_smooth] = ACTIONS(2246),
    [anon_sym_flat] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_auto] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2246),
    [anon_sym_hitAttributeEXT] = ACTIONS(2246),
    [anon_sym_callableDataEXT] = ACTIONS(2246),
    [anon_sym_callableDataInEXT] = ACTIONS(2246),
    [anon_sym_shaderRecordEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadNV] = ACTIONS(2246),
    [anon_sym_rayPayloadInNV] = ACTIONS(2246),
    [anon_sym_hitAttributeNV] = ACTIONS(2246),
    [anon_sym_callableDataNV] = ACTIONS(2246),
    [anon_sym_callableDataInNV] = ACTIONS(2246),
    [anon_sym_shaderRecordNV] = ACTIONS(2246),
    [anon_sym_layout] = ACTIONS(2246),
  },
  [572] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [aux_sym_preproc_else_token1] = ACTIONS(2250),
    [aux_sym_preproc_elif_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_subroutine] = ACTIONS(2250),
    [anon_sym_invariant] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_attribute] = ACTIONS(2250),
    [anon_sym_varying] = ACTIONS(2250),
    [anon_sym_buffer] = ACTIONS(2250),
    [anon_sym_coherent] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_writeonly] = ACTIONS(2250),
    [anon_sym_precision] = ACTIONS(2250),
    [anon_sym_highp] = ACTIONS(2250),
    [anon_sym_mediump] = ACTIONS(2250),
    [anon_sym_lowp] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_patch] = ACTIONS(2250),
    [anon_sym_smooth] = ACTIONS(2250),
    [anon_sym_flat] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_auto] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2250),
    [anon_sym_hitAttributeEXT] = ACTIONS(2250),
    [anon_sym_callableDataEXT] = ACTIONS(2250),
    [anon_sym_callableDataInEXT] = ACTIONS(2250),
    [anon_sym_shaderRecordEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadNV] = ACTIONS(2250),
    [anon_sym_rayPayloadInNV] = ACTIONS(2250),
    [anon_sym_hitAttributeNV] = ACTIONS(2250),
    [anon_sym_callableDataNV] = ACTIONS(2250),
    [anon_sym_callableDataInNV] = ACTIONS(2250),
    [anon_sym_shaderRecordNV] = ACTIONS(2250),
    [anon_sym_layout] = ACTIONS(2250),
  },
  [573] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token2] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [aux_sym_preproc_else_token1] = ACTIONS(2254),
    [aux_sym_preproc_elif_token1] = ACTIONS(2254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_subroutine] = ACTIONS(2254),
    [anon_sym_invariant] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_attribute] = ACTIONS(2254),
    [anon_sym_varying] = ACTIONS(2254),
    [anon_sym_buffer] = ACTIONS(2254),
    [anon_sym_coherent] = ACTIONS(2254),
    [anon_sym_readonly] = ACTIONS(2254),
    [anon_sym_writeonly] = ACTIONS(2254),
    [anon_sym_precision] = ACTIONS(2254),
    [anon_sym_highp] = ACTIONS(2254),
    [anon_sym_mediump] = ACTIONS(2254),
    [anon_sym_lowp] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_patch] = ACTIONS(2254),
    [anon_sym_smooth] = ACTIONS(2254),
    [anon_sym_flat] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_auto] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2254),
    [anon_sym_hitAttributeEXT] = ACTIONS(2254),
    [anon_sym_callableDataEXT] = ACTIONS(2254),
    [anon_sym_callableDataInEXT] = ACTIONS(2254),
    [anon_sym_shaderRecordEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadNV] = ACTIONS(2254),
    [anon_sym_rayPayloadInNV] = ACTIONS(2254),
    [anon_sym_hitAttributeNV] = ACTIONS(2254),
    [anon_sym_callableDataNV] = ACTIONS(2254),
    [anon_sym_callableDataInNV] = ACTIONS(2254),
    [anon_sym_shaderRecordNV] = ACTIONS(2254),
    [anon_sym_layout] = ACTIONS(2254),
  },
  [574] = {
    [sym_expression] = STATE(1019),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_initializer_list] = STATE(866),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1762),
    [anon_sym_LPAREN2] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1760),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_PIPE_PIPE] = ACTIONS(1762),
    [anon_sym_AMP_AMP] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1762),
    [anon_sym_BANG_EQ] = ACTIONS(1762),
    [anon_sym_GT] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(1762),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_DASH_DASH] = ACTIONS(1762),
    [anon_sym_PLUS_PLUS] = ACTIONS(1762),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_DASH_GT] = ACTIONS(1762),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [aux_sym_preproc_else_token1] = ACTIONS(2266),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_subroutine] = ACTIONS(2266),
    [anon_sym_invariant] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_attribute] = ACTIONS(2266),
    [anon_sym_varying] = ACTIONS(2266),
    [anon_sym_buffer] = ACTIONS(2266),
    [anon_sym_coherent] = ACTIONS(2266),
    [anon_sym_readonly] = ACTIONS(2266),
    [anon_sym_writeonly] = ACTIONS(2266),
    [anon_sym_precision] = ACTIONS(2266),
    [anon_sym_highp] = ACTIONS(2266),
    [anon_sym_mediump] = ACTIONS(2266),
    [anon_sym_lowp] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_patch] = ACTIONS(2266),
    [anon_sym_smooth] = ACTIONS(2266),
    [anon_sym_flat] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_auto] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2266),
    [anon_sym_hitAttributeEXT] = ACTIONS(2266),
    [anon_sym_callableDataEXT] = ACTIONS(2266),
    [anon_sym_callableDataInEXT] = ACTIONS(2266),
    [anon_sym_shaderRecordEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadNV] = ACTIONS(2266),
    [anon_sym_rayPayloadInNV] = ACTIONS(2266),
    [anon_sym_hitAttributeNV] = ACTIONS(2266),
    [anon_sym_callableDataNV] = ACTIONS(2266),
    [anon_sym_callableDataInNV] = ACTIONS(2266),
    [anon_sym_shaderRecordNV] = ACTIONS(2266),
    [anon_sym_layout] = ACTIONS(2266),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2270),
    [anon_sym_subroutine] = ACTIONS(2270),
    [anon_sym_invariant] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_attribute] = ACTIONS(2270),
    [anon_sym_varying] = ACTIONS(2270),
    [anon_sym_buffer] = ACTIONS(2270),
    [anon_sym_coherent] = ACTIONS(2270),
    [anon_sym_readonly] = ACTIONS(2270),
    [anon_sym_writeonly] = ACTIONS(2270),
    [anon_sym_precision] = ACTIONS(2270),
    [anon_sym_highp] = ACTIONS(2270),
    [anon_sym_mediump] = ACTIONS(2270),
    [anon_sym_lowp] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_patch] = ACTIONS(2270),
    [anon_sym_smooth] = ACTIONS(2270),
    [anon_sym_flat] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym___cdecl] = ACTIONS(2270),
    [anon_sym___clrcall] = ACTIONS(2270),
    [anon_sym___stdcall] = ACTIONS(2270),
    [anon_sym___fastcall] = ACTIONS(2270),
    [anon_sym___thiscall] = ACTIONS(2270),
    [anon_sym___vectorcall] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_auto] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2270),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2270),
    [anon_sym_hitAttributeEXT] = ACTIONS(2270),
    [anon_sym_callableDataEXT] = ACTIONS(2270),
    [anon_sym_callableDataInEXT] = ACTIONS(2270),
    [anon_sym_shaderRecordEXT] = ACTIONS(2270),
    [anon_sym_rayPayloadNV] = ACTIONS(2270),
    [anon_sym_rayPayloadInNV] = ACTIONS(2270),
    [anon_sym_hitAttributeNV] = ACTIONS(2270),
    [anon_sym_callableDataNV] = ACTIONS(2270),
    [anon_sym_callableDataInNV] = ACTIONS(2270),
    [anon_sym_shaderRecordNV] = ACTIONS(2270),
    [anon_sym_layout] = ACTIONS(2270),
  },
  [577] = {
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_subroutine] = ACTIONS(2274),
    [anon_sym_invariant] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_attribute] = ACTIONS(2274),
    [anon_sym_varying] = ACTIONS(2274),
    [anon_sym_buffer] = ACTIONS(2274),
    [anon_sym_coherent] = ACTIONS(2274),
    [anon_sym_readonly] = ACTIONS(2274),
    [anon_sym_writeonly] = ACTIONS(2274),
    [anon_sym_precision] = ACTIONS(2274),
    [anon_sym_highp] = ACTIONS(2274),
    [anon_sym_mediump] = ACTIONS(2274),
    [anon_sym_lowp] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_patch] = ACTIONS(2274),
    [anon_sym_smooth] = ACTIONS(2274),
    [anon_sym_flat] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym___cdecl] = ACTIONS(2274),
    [anon_sym___clrcall] = ACTIONS(2274),
    [anon_sym___stdcall] = ACTIONS(2274),
    [anon_sym___fastcall] = ACTIONS(2274),
    [anon_sym___thiscall] = ACTIONS(2274),
    [anon_sym___vectorcall] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_auto] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2274),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2274),
    [anon_sym_hitAttributeEXT] = ACTIONS(2274),
    [anon_sym_callableDataEXT] = ACTIONS(2274),
    [anon_sym_callableDataInEXT] = ACTIONS(2274),
    [anon_sym_shaderRecordEXT] = ACTIONS(2274),
    [anon_sym_rayPayloadNV] = ACTIONS(2274),
    [anon_sym_rayPayloadInNV] = ACTIONS(2274),
    [anon_sym_hitAttributeNV] = ACTIONS(2274),
    [anon_sym_callableDataNV] = ACTIONS(2274),
    [anon_sym_callableDataInNV] = ACTIONS(2274),
    [anon_sym_shaderRecordNV] = ACTIONS(2274),
    [anon_sym_layout] = ACTIONS(2274),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_subroutine] = ACTIONS(2234),
    [anon_sym_invariant] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_attribute] = ACTIONS(2234),
    [anon_sym_varying] = ACTIONS(2234),
    [anon_sym_buffer] = ACTIONS(2234),
    [anon_sym_coherent] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_writeonly] = ACTIONS(2234),
    [anon_sym_precision] = ACTIONS(2234),
    [anon_sym_highp] = ACTIONS(2234),
    [anon_sym_mediump] = ACTIONS(2234),
    [anon_sym_lowp] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_patch] = ACTIONS(2234),
    [anon_sym_smooth] = ACTIONS(2234),
    [anon_sym_flat] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_auto] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2234),
    [anon_sym_hitAttributeEXT] = ACTIONS(2234),
    [anon_sym_callableDataEXT] = ACTIONS(2234),
    [anon_sym_callableDataInEXT] = ACTIONS(2234),
    [anon_sym_shaderRecordEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadNV] = ACTIONS(2234),
    [anon_sym_rayPayloadInNV] = ACTIONS(2234),
    [anon_sym_hitAttributeNV] = ACTIONS(2234),
    [anon_sym_callableDataNV] = ACTIONS(2234),
    [anon_sym_callableDataInNV] = ACTIONS(2234),
    [anon_sym_shaderRecordNV] = ACTIONS(2234),
    [anon_sym_layout] = ACTIONS(2234),
  },
  [579] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token2] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_subroutine] = ACTIONS(2198),
    [anon_sym_invariant] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_attribute] = ACTIONS(2198),
    [anon_sym_varying] = ACTIONS(2198),
    [anon_sym_buffer] = ACTIONS(2198),
    [anon_sym_coherent] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(2198),
    [anon_sym_writeonly] = ACTIONS(2198),
    [anon_sym_precision] = ACTIONS(2198),
    [anon_sym_highp] = ACTIONS(2198),
    [anon_sym_mediump] = ACTIONS(2198),
    [anon_sym_lowp] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_patch] = ACTIONS(2198),
    [anon_sym_smooth] = ACTIONS(2198),
    [anon_sym_flat] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_auto] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2198),
    [anon_sym_hitAttributeEXT] = ACTIONS(2198),
    [anon_sym_callableDataEXT] = ACTIONS(2198),
    [anon_sym_callableDataInEXT] = ACTIONS(2198),
    [anon_sym_shaderRecordEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadNV] = ACTIONS(2198),
    [anon_sym_rayPayloadInNV] = ACTIONS(2198),
    [anon_sym_hitAttributeNV] = ACTIONS(2198),
    [anon_sym_callableDataNV] = ACTIONS(2198),
    [anon_sym_callableDataInNV] = ACTIONS(2198),
    [anon_sym_shaderRecordNV] = ACTIONS(2198),
    [anon_sym_layout] = ACTIONS(2198),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token2] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_subroutine] = ACTIONS(2214),
    [anon_sym_invariant] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_attribute] = ACTIONS(2214),
    [anon_sym_varying] = ACTIONS(2214),
    [anon_sym_buffer] = ACTIONS(2214),
    [anon_sym_coherent] = ACTIONS(2214),
    [anon_sym_readonly] = ACTIONS(2214),
    [anon_sym_writeonly] = ACTIONS(2214),
    [anon_sym_precision] = ACTIONS(2214),
    [anon_sym_highp] = ACTIONS(2214),
    [anon_sym_mediump] = ACTIONS(2214),
    [anon_sym_lowp] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_patch] = ACTIONS(2214),
    [anon_sym_smooth] = ACTIONS(2214),
    [anon_sym_flat] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_auto] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2214),
    [anon_sym_hitAttributeEXT] = ACTIONS(2214),
    [anon_sym_callableDataEXT] = ACTIONS(2214),
    [anon_sym_callableDataInEXT] = ACTIONS(2214),
    [anon_sym_shaderRecordEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadNV] = ACTIONS(2214),
    [anon_sym_rayPayloadInNV] = ACTIONS(2214),
    [anon_sym_hitAttributeNV] = ACTIONS(2214),
    [anon_sym_callableDataNV] = ACTIONS(2214),
    [anon_sym_callableDataInNV] = ACTIONS(2214),
    [anon_sym_shaderRecordNV] = ACTIONS(2214),
    [anon_sym_layout] = ACTIONS(2214),
  },
  [581] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token2] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_subroutine] = ACTIONS(2210),
    [anon_sym_invariant] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_attribute] = ACTIONS(2210),
    [anon_sym_varying] = ACTIONS(2210),
    [anon_sym_buffer] = ACTIONS(2210),
    [anon_sym_coherent] = ACTIONS(2210),
    [anon_sym_readonly] = ACTIONS(2210),
    [anon_sym_writeonly] = ACTIONS(2210),
    [anon_sym_precision] = ACTIONS(2210),
    [anon_sym_highp] = ACTIONS(2210),
    [anon_sym_mediump] = ACTIONS(2210),
    [anon_sym_lowp] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_patch] = ACTIONS(2210),
    [anon_sym_smooth] = ACTIONS(2210),
    [anon_sym_flat] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2212),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_auto] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2210),
    [anon_sym_hitAttributeEXT] = ACTIONS(2210),
    [anon_sym_callableDataEXT] = ACTIONS(2210),
    [anon_sym_callableDataInEXT] = ACTIONS(2210),
    [anon_sym_shaderRecordEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadNV] = ACTIONS(2210),
    [anon_sym_rayPayloadInNV] = ACTIONS(2210),
    [anon_sym_hitAttributeNV] = ACTIONS(2210),
    [anon_sym_callableDataNV] = ACTIONS(2210),
    [anon_sym_callableDataInNV] = ACTIONS(2210),
    [anon_sym_shaderRecordNV] = ACTIONS(2210),
    [anon_sym_layout] = ACTIONS(2210),
  },
  [583] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token2] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_subroutine] = ACTIONS(2206),
    [anon_sym_invariant] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_attribute] = ACTIONS(2206),
    [anon_sym_varying] = ACTIONS(2206),
    [anon_sym_buffer] = ACTIONS(2206),
    [anon_sym_coherent] = ACTIONS(2206),
    [anon_sym_readonly] = ACTIONS(2206),
    [anon_sym_writeonly] = ACTIONS(2206),
    [anon_sym_precision] = ACTIONS(2206),
    [anon_sym_highp] = ACTIONS(2206),
    [anon_sym_mediump] = ACTIONS(2206),
    [anon_sym_lowp] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_patch] = ACTIONS(2206),
    [anon_sym_smooth] = ACTIONS(2206),
    [anon_sym_flat] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_auto] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2206),
    [anon_sym_hitAttributeEXT] = ACTIONS(2206),
    [anon_sym_callableDataEXT] = ACTIONS(2206),
    [anon_sym_callableDataInEXT] = ACTIONS(2206),
    [anon_sym_shaderRecordEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadNV] = ACTIONS(2206),
    [anon_sym_rayPayloadInNV] = ACTIONS(2206),
    [anon_sym_hitAttributeNV] = ACTIONS(2206),
    [anon_sym_callableDataNV] = ACTIONS(2206),
    [anon_sym_callableDataInNV] = ACTIONS(2206),
    [anon_sym_shaderRecordNV] = ACTIONS(2206),
    [anon_sym_layout] = ACTIONS(2206),
  },
  [584] = {
    [sym_identifier] = ACTIONS(2198),
    [aux_sym_preproc_def_token1] = ACTIONS(2198),
    [aux_sym_preproc_if_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2198),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2198),
    [sym_preproc_directive] = ACTIONS(2198),
    [anon_sym_subroutine] = ACTIONS(2198),
    [anon_sym_invariant] = ACTIONS(2198),
    [anon_sym_precise] = ACTIONS(2198),
    [anon_sym_in] = ACTIONS(2198),
    [anon_sym_out] = ACTIONS(2198),
    [anon_sym_inout] = ACTIONS(2198),
    [anon_sym_uniform] = ACTIONS(2198),
    [anon_sym_shared] = ACTIONS(2198),
    [anon_sym_attribute] = ACTIONS(2198),
    [anon_sym_varying] = ACTIONS(2198),
    [anon_sym_buffer] = ACTIONS(2198),
    [anon_sym_coherent] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(2198),
    [anon_sym_writeonly] = ACTIONS(2198),
    [anon_sym_precision] = ACTIONS(2198),
    [anon_sym_highp] = ACTIONS(2198),
    [anon_sym_mediump] = ACTIONS(2198),
    [anon_sym_lowp] = ACTIONS(2198),
    [anon_sym_centroid] = ACTIONS(2198),
    [anon_sym_sample] = ACTIONS(2198),
    [anon_sym_patch] = ACTIONS(2198),
    [anon_sym_smooth] = ACTIONS(2198),
    [anon_sym_flat] = ACTIONS(2198),
    [anon_sym_noperspective] = ACTIONS(2198),
    [anon_sym___extension__] = ACTIONS(2198),
    [anon_sym_extern] = ACTIONS(2198),
    [anon_sym___attribute__] = ACTIONS(2198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2200),
    [anon_sym___declspec] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_signed] = ACTIONS(2198),
    [anon_sym_unsigned] = ACTIONS(2198),
    [anon_sym_long] = ACTIONS(2198),
    [anon_sym_short] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_auto] = ACTIONS(2198),
    [anon_sym_register] = ACTIONS(2198),
    [anon_sym_inline] = ACTIONS(2198),
    [anon_sym___inline] = ACTIONS(2198),
    [anon_sym___inline__] = ACTIONS(2198),
    [anon_sym___forceinline] = ACTIONS(2198),
    [anon_sym_thread_local] = ACTIONS(2198),
    [anon_sym___thread] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [anon_sym_constexpr] = ACTIONS(2198),
    [anon_sym_volatile] = ACTIONS(2198),
    [anon_sym_restrict] = ACTIONS(2198),
    [anon_sym___restrict__] = ACTIONS(2198),
    [anon_sym__Atomic] = ACTIONS(2198),
    [anon_sym__Noreturn] = ACTIONS(2198),
    [anon_sym_noreturn] = ACTIONS(2198),
    [anon_sym_alignas] = ACTIONS(2198),
    [anon_sym__Alignas] = ACTIONS(2198),
    [sym_primitive_type] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_struct] = ACTIONS(2198),
    [anon_sym_union] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2198),
    [anon_sym_hitAttributeEXT] = ACTIONS(2198),
    [anon_sym_callableDataEXT] = ACTIONS(2198),
    [anon_sym_callableDataInEXT] = ACTIONS(2198),
    [anon_sym_shaderRecordEXT] = ACTIONS(2198),
    [anon_sym_rayPayloadNV] = ACTIONS(2198),
    [anon_sym_rayPayloadInNV] = ACTIONS(2198),
    [anon_sym_hitAttributeNV] = ACTIONS(2198),
    [anon_sym_callableDataNV] = ACTIONS(2198),
    [anon_sym_callableDataInNV] = ACTIONS(2198),
    [anon_sym_shaderRecordNV] = ACTIONS(2198),
    [anon_sym_layout] = ACTIONS(2198),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_subroutine] = ACTIONS(2218),
    [anon_sym_invariant] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_attribute] = ACTIONS(2218),
    [anon_sym_varying] = ACTIONS(2218),
    [anon_sym_buffer] = ACTIONS(2218),
    [anon_sym_coherent] = ACTIONS(2218),
    [anon_sym_readonly] = ACTIONS(2218),
    [anon_sym_writeonly] = ACTIONS(2218),
    [anon_sym_precision] = ACTIONS(2218),
    [anon_sym_highp] = ACTIONS(2218),
    [anon_sym_mediump] = ACTIONS(2218),
    [anon_sym_lowp] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_patch] = ACTIONS(2218),
    [anon_sym_smooth] = ACTIONS(2218),
    [anon_sym_flat] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_auto] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2218),
    [anon_sym_hitAttributeEXT] = ACTIONS(2218),
    [anon_sym_callableDataEXT] = ACTIONS(2218),
    [anon_sym_callableDataInEXT] = ACTIONS(2218),
    [anon_sym_shaderRecordEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadNV] = ACTIONS(2218),
    [anon_sym_rayPayloadInNV] = ACTIONS(2218),
    [anon_sym_hitAttributeNV] = ACTIONS(2218),
    [anon_sym_callableDataNV] = ACTIONS(2218),
    [anon_sym_callableDataInNV] = ACTIONS(2218),
    [anon_sym_shaderRecordNV] = ACTIONS(2218),
    [anon_sym_layout] = ACTIONS(2218),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_subroutine] = ACTIONS(2266),
    [anon_sym_invariant] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_attribute] = ACTIONS(2266),
    [anon_sym_varying] = ACTIONS(2266),
    [anon_sym_buffer] = ACTIONS(2266),
    [anon_sym_coherent] = ACTIONS(2266),
    [anon_sym_readonly] = ACTIONS(2266),
    [anon_sym_writeonly] = ACTIONS(2266),
    [anon_sym_precision] = ACTIONS(2266),
    [anon_sym_highp] = ACTIONS(2266),
    [anon_sym_mediump] = ACTIONS(2266),
    [anon_sym_lowp] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_patch] = ACTIONS(2266),
    [anon_sym_smooth] = ACTIONS(2266),
    [anon_sym_flat] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_auto] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2266),
    [anon_sym_hitAttributeEXT] = ACTIONS(2266),
    [anon_sym_callableDataEXT] = ACTIONS(2266),
    [anon_sym_callableDataInEXT] = ACTIONS(2266),
    [anon_sym_shaderRecordEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadNV] = ACTIONS(2266),
    [anon_sym_rayPayloadInNV] = ACTIONS(2266),
    [anon_sym_hitAttributeNV] = ACTIONS(2266),
    [anon_sym_callableDataNV] = ACTIONS(2266),
    [anon_sym_callableDataInNV] = ACTIONS(2266),
    [anon_sym_shaderRecordNV] = ACTIONS(2266),
    [anon_sym_layout] = ACTIONS(2266),
  },
  [587] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_subroutine] = ACTIONS(2214),
    [anon_sym_invariant] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_attribute] = ACTIONS(2214),
    [anon_sym_varying] = ACTIONS(2214),
    [anon_sym_buffer] = ACTIONS(2214),
    [anon_sym_coherent] = ACTIONS(2214),
    [anon_sym_readonly] = ACTIONS(2214),
    [anon_sym_writeonly] = ACTIONS(2214),
    [anon_sym_precision] = ACTIONS(2214),
    [anon_sym_highp] = ACTIONS(2214),
    [anon_sym_mediump] = ACTIONS(2214),
    [anon_sym_lowp] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_patch] = ACTIONS(2214),
    [anon_sym_smooth] = ACTIONS(2214),
    [anon_sym_flat] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_auto] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2214),
    [anon_sym_hitAttributeEXT] = ACTIONS(2214),
    [anon_sym_callableDataEXT] = ACTIONS(2214),
    [anon_sym_callableDataInEXT] = ACTIONS(2214),
    [anon_sym_shaderRecordEXT] = ACTIONS(2214),
    [anon_sym_rayPayloadNV] = ACTIONS(2214),
    [anon_sym_rayPayloadInNV] = ACTIONS(2214),
    [anon_sym_hitAttributeNV] = ACTIONS(2214),
    [anon_sym_callableDataNV] = ACTIONS(2214),
    [anon_sym_callableDataInNV] = ACTIONS(2214),
    [anon_sym_shaderRecordNV] = ACTIONS(2214),
    [anon_sym_layout] = ACTIONS(2214),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_subroutine] = ACTIONS(2242),
    [anon_sym_invariant] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_attribute] = ACTIONS(2242),
    [anon_sym_varying] = ACTIONS(2242),
    [anon_sym_buffer] = ACTIONS(2242),
    [anon_sym_coherent] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_writeonly] = ACTIONS(2242),
    [anon_sym_precision] = ACTIONS(2242),
    [anon_sym_highp] = ACTIONS(2242),
    [anon_sym_mediump] = ACTIONS(2242),
    [anon_sym_lowp] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_patch] = ACTIONS(2242),
    [anon_sym_smooth] = ACTIONS(2242),
    [anon_sym_flat] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_auto] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2242),
    [anon_sym_hitAttributeEXT] = ACTIONS(2242),
    [anon_sym_callableDataEXT] = ACTIONS(2242),
    [anon_sym_callableDataInEXT] = ACTIONS(2242),
    [anon_sym_shaderRecordEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadNV] = ACTIONS(2242),
    [anon_sym_rayPayloadInNV] = ACTIONS(2242),
    [anon_sym_hitAttributeNV] = ACTIONS(2242),
    [anon_sym_callableDataNV] = ACTIONS(2242),
    [anon_sym_callableDataInNV] = ACTIONS(2242),
    [anon_sym_shaderRecordNV] = ACTIONS(2242),
    [anon_sym_layout] = ACTIONS(2242),
  },
  [589] = {
    [sym_identifier] = ACTIONS(2210),
    [aux_sym_preproc_def_token1] = ACTIONS(2210),
    [aux_sym_preproc_if_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2210),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2210),
    [sym_preproc_directive] = ACTIONS(2210),
    [anon_sym_subroutine] = ACTIONS(2210),
    [anon_sym_invariant] = ACTIONS(2210),
    [anon_sym_precise] = ACTIONS(2210),
    [anon_sym_in] = ACTIONS(2210),
    [anon_sym_out] = ACTIONS(2210),
    [anon_sym_inout] = ACTIONS(2210),
    [anon_sym_uniform] = ACTIONS(2210),
    [anon_sym_shared] = ACTIONS(2210),
    [anon_sym_attribute] = ACTIONS(2210),
    [anon_sym_varying] = ACTIONS(2210),
    [anon_sym_buffer] = ACTIONS(2210),
    [anon_sym_coherent] = ACTIONS(2210),
    [anon_sym_readonly] = ACTIONS(2210),
    [anon_sym_writeonly] = ACTIONS(2210),
    [anon_sym_precision] = ACTIONS(2210),
    [anon_sym_highp] = ACTIONS(2210),
    [anon_sym_mediump] = ACTIONS(2210),
    [anon_sym_lowp] = ACTIONS(2210),
    [anon_sym_centroid] = ACTIONS(2210),
    [anon_sym_sample] = ACTIONS(2210),
    [anon_sym_patch] = ACTIONS(2210),
    [anon_sym_smooth] = ACTIONS(2210),
    [anon_sym_flat] = ACTIONS(2210),
    [anon_sym_noperspective] = ACTIONS(2210),
    [anon_sym___extension__] = ACTIONS(2210),
    [anon_sym_extern] = ACTIONS(2210),
    [anon_sym___attribute__] = ACTIONS(2210),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2212),
    [anon_sym___declspec] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_signed] = ACTIONS(2210),
    [anon_sym_unsigned] = ACTIONS(2210),
    [anon_sym_long] = ACTIONS(2210),
    [anon_sym_short] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2210),
    [anon_sym_auto] = ACTIONS(2210),
    [anon_sym_register] = ACTIONS(2210),
    [anon_sym_inline] = ACTIONS(2210),
    [anon_sym___inline] = ACTIONS(2210),
    [anon_sym___inline__] = ACTIONS(2210),
    [anon_sym___forceinline] = ACTIONS(2210),
    [anon_sym_thread_local] = ACTIONS(2210),
    [anon_sym___thread] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [anon_sym_constexpr] = ACTIONS(2210),
    [anon_sym_volatile] = ACTIONS(2210),
    [anon_sym_restrict] = ACTIONS(2210),
    [anon_sym___restrict__] = ACTIONS(2210),
    [anon_sym__Atomic] = ACTIONS(2210),
    [anon_sym__Noreturn] = ACTIONS(2210),
    [anon_sym_noreturn] = ACTIONS(2210),
    [anon_sym_alignas] = ACTIONS(2210),
    [anon_sym__Alignas] = ACTIONS(2210),
    [sym_primitive_type] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_struct] = ACTIONS(2210),
    [anon_sym_union] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2210),
    [anon_sym_hitAttributeEXT] = ACTIONS(2210),
    [anon_sym_callableDataEXT] = ACTIONS(2210),
    [anon_sym_callableDataInEXT] = ACTIONS(2210),
    [anon_sym_shaderRecordEXT] = ACTIONS(2210),
    [anon_sym_rayPayloadNV] = ACTIONS(2210),
    [anon_sym_rayPayloadInNV] = ACTIONS(2210),
    [anon_sym_hitAttributeNV] = ACTIONS(2210),
    [anon_sym_callableDataNV] = ACTIONS(2210),
    [anon_sym_callableDataInNV] = ACTIONS(2210),
    [anon_sym_shaderRecordNV] = ACTIONS(2210),
    [anon_sym_layout] = ACTIONS(2210),
  },
  [590] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_subroutine] = ACTIONS(2254),
    [anon_sym_invariant] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_attribute] = ACTIONS(2254),
    [anon_sym_varying] = ACTIONS(2254),
    [anon_sym_buffer] = ACTIONS(2254),
    [anon_sym_coherent] = ACTIONS(2254),
    [anon_sym_readonly] = ACTIONS(2254),
    [anon_sym_writeonly] = ACTIONS(2254),
    [anon_sym_precision] = ACTIONS(2254),
    [anon_sym_highp] = ACTIONS(2254),
    [anon_sym_mediump] = ACTIONS(2254),
    [anon_sym_lowp] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_patch] = ACTIONS(2254),
    [anon_sym_smooth] = ACTIONS(2254),
    [anon_sym_flat] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_auto] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2254),
    [anon_sym_hitAttributeEXT] = ACTIONS(2254),
    [anon_sym_callableDataEXT] = ACTIONS(2254),
    [anon_sym_callableDataInEXT] = ACTIONS(2254),
    [anon_sym_shaderRecordEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadNV] = ACTIONS(2254),
    [anon_sym_rayPayloadInNV] = ACTIONS(2254),
    [anon_sym_hitAttributeNV] = ACTIONS(2254),
    [anon_sym_callableDataNV] = ACTIONS(2254),
    [anon_sym_callableDataInNV] = ACTIONS(2254),
    [anon_sym_shaderRecordNV] = ACTIONS(2254),
    [anon_sym_layout] = ACTIONS(2254),
  },
  [591] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1431),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token2] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_subroutine] = ACTIONS(2238),
    [anon_sym_invariant] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_attribute] = ACTIONS(2238),
    [anon_sym_varying] = ACTIONS(2238),
    [anon_sym_buffer] = ACTIONS(2238),
    [anon_sym_coherent] = ACTIONS(2238),
    [anon_sym_readonly] = ACTIONS(2238),
    [anon_sym_writeonly] = ACTIONS(2238),
    [anon_sym_precision] = ACTIONS(2238),
    [anon_sym_highp] = ACTIONS(2238),
    [anon_sym_mediump] = ACTIONS(2238),
    [anon_sym_lowp] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_patch] = ACTIONS(2238),
    [anon_sym_smooth] = ACTIONS(2238),
    [anon_sym_flat] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_auto] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2238),
    [anon_sym_hitAttributeEXT] = ACTIONS(2238),
    [anon_sym_callableDataEXT] = ACTIONS(2238),
    [anon_sym_callableDataInEXT] = ACTIONS(2238),
    [anon_sym_shaderRecordEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadNV] = ACTIONS(2238),
    [anon_sym_rayPayloadInNV] = ACTIONS(2238),
    [anon_sym_hitAttributeNV] = ACTIONS(2238),
    [anon_sym_callableDataNV] = ACTIONS(2238),
    [anon_sym_callableDataInNV] = ACTIONS(2238),
    [anon_sym_shaderRecordNV] = ACTIONS(2238),
    [anon_sym_layout] = ACTIONS(2238),
  },
  [593] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token2] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_subroutine] = ACTIONS(2234),
    [anon_sym_invariant] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_attribute] = ACTIONS(2234),
    [anon_sym_varying] = ACTIONS(2234),
    [anon_sym_buffer] = ACTIONS(2234),
    [anon_sym_coherent] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_writeonly] = ACTIONS(2234),
    [anon_sym_precision] = ACTIONS(2234),
    [anon_sym_highp] = ACTIONS(2234),
    [anon_sym_mediump] = ACTIONS(2234),
    [anon_sym_lowp] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_patch] = ACTIONS(2234),
    [anon_sym_smooth] = ACTIONS(2234),
    [anon_sym_flat] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_auto] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2234),
    [anon_sym_hitAttributeEXT] = ACTIONS(2234),
    [anon_sym_callableDataEXT] = ACTIONS(2234),
    [anon_sym_callableDataInEXT] = ACTIONS(2234),
    [anon_sym_shaderRecordEXT] = ACTIONS(2234),
    [anon_sym_rayPayloadNV] = ACTIONS(2234),
    [anon_sym_rayPayloadInNV] = ACTIONS(2234),
    [anon_sym_hitAttributeNV] = ACTIONS(2234),
    [anon_sym_callableDataNV] = ACTIONS(2234),
    [anon_sym_callableDataInNV] = ACTIONS(2234),
    [anon_sym_shaderRecordNV] = ACTIONS(2234),
    [anon_sym_layout] = ACTIONS(2234),
  },
  [594] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_subroutine] = ACTIONS(2226),
    [anon_sym_invariant] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_attribute] = ACTIONS(2226),
    [anon_sym_varying] = ACTIONS(2226),
    [anon_sym_buffer] = ACTIONS(2226),
    [anon_sym_coherent] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_writeonly] = ACTIONS(2226),
    [anon_sym_precision] = ACTIONS(2226),
    [anon_sym_highp] = ACTIONS(2226),
    [anon_sym_mediump] = ACTIONS(2226),
    [anon_sym_lowp] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_patch] = ACTIONS(2226),
    [anon_sym_smooth] = ACTIONS(2226),
    [anon_sym_flat] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_auto] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2226),
    [anon_sym_hitAttributeEXT] = ACTIONS(2226),
    [anon_sym_callableDataEXT] = ACTIONS(2226),
    [anon_sym_callableDataInEXT] = ACTIONS(2226),
    [anon_sym_shaderRecordEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadNV] = ACTIONS(2226),
    [anon_sym_rayPayloadInNV] = ACTIONS(2226),
    [anon_sym_hitAttributeNV] = ACTIONS(2226),
    [anon_sym_callableDataNV] = ACTIONS(2226),
    [anon_sym_callableDataInNV] = ACTIONS(2226),
    [anon_sym_shaderRecordNV] = ACTIONS(2226),
    [anon_sym_layout] = ACTIONS(2226),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_subroutine] = ACTIONS(2230),
    [anon_sym_invariant] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_attribute] = ACTIONS(2230),
    [anon_sym_varying] = ACTIONS(2230),
    [anon_sym_buffer] = ACTIONS(2230),
    [anon_sym_coherent] = ACTIONS(2230),
    [anon_sym_readonly] = ACTIONS(2230),
    [anon_sym_writeonly] = ACTIONS(2230),
    [anon_sym_precision] = ACTIONS(2230),
    [anon_sym_highp] = ACTIONS(2230),
    [anon_sym_mediump] = ACTIONS(2230),
    [anon_sym_lowp] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_patch] = ACTIONS(2230),
    [anon_sym_smooth] = ACTIONS(2230),
    [anon_sym_flat] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_auto] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2230),
    [anon_sym_hitAttributeEXT] = ACTIONS(2230),
    [anon_sym_callableDataEXT] = ACTIONS(2230),
    [anon_sym_callableDataInEXT] = ACTIONS(2230),
    [anon_sym_shaderRecordEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadNV] = ACTIONS(2230),
    [anon_sym_rayPayloadInNV] = ACTIONS(2230),
    [anon_sym_hitAttributeNV] = ACTIONS(2230),
    [anon_sym_callableDataNV] = ACTIONS(2230),
    [anon_sym_callableDataInNV] = ACTIONS(2230),
    [anon_sym_shaderRecordNV] = ACTIONS(2230),
    [anon_sym_layout] = ACTIONS(2230),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_subroutine] = ACTIONS(2222),
    [anon_sym_invariant] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_attribute] = ACTIONS(2222),
    [anon_sym_varying] = ACTIONS(2222),
    [anon_sym_buffer] = ACTIONS(2222),
    [anon_sym_coherent] = ACTIONS(2222),
    [anon_sym_readonly] = ACTIONS(2222),
    [anon_sym_writeonly] = ACTIONS(2222),
    [anon_sym_precision] = ACTIONS(2222),
    [anon_sym_highp] = ACTIONS(2222),
    [anon_sym_mediump] = ACTIONS(2222),
    [anon_sym_lowp] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_patch] = ACTIONS(2222),
    [anon_sym_smooth] = ACTIONS(2222),
    [anon_sym_flat] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_auto] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2222),
    [anon_sym_hitAttributeEXT] = ACTIONS(2222),
    [anon_sym_callableDataEXT] = ACTIONS(2222),
    [anon_sym_callableDataInEXT] = ACTIONS(2222),
    [anon_sym_shaderRecordEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadNV] = ACTIONS(2222),
    [anon_sym_rayPayloadInNV] = ACTIONS(2222),
    [anon_sym_hitAttributeNV] = ACTIONS(2222),
    [anon_sym_callableDataNV] = ACTIONS(2222),
    [anon_sym_callableDataInNV] = ACTIONS(2222),
    [anon_sym_shaderRecordNV] = ACTIONS(2222),
    [anon_sym_layout] = ACTIONS(2222),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2206),
    [aux_sym_preproc_def_token1] = ACTIONS(2206),
    [aux_sym_preproc_if_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2206),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2206),
    [sym_preproc_directive] = ACTIONS(2206),
    [anon_sym_subroutine] = ACTIONS(2206),
    [anon_sym_invariant] = ACTIONS(2206),
    [anon_sym_precise] = ACTIONS(2206),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_out] = ACTIONS(2206),
    [anon_sym_inout] = ACTIONS(2206),
    [anon_sym_uniform] = ACTIONS(2206),
    [anon_sym_shared] = ACTIONS(2206),
    [anon_sym_attribute] = ACTIONS(2206),
    [anon_sym_varying] = ACTIONS(2206),
    [anon_sym_buffer] = ACTIONS(2206),
    [anon_sym_coherent] = ACTIONS(2206),
    [anon_sym_readonly] = ACTIONS(2206),
    [anon_sym_writeonly] = ACTIONS(2206),
    [anon_sym_precision] = ACTIONS(2206),
    [anon_sym_highp] = ACTIONS(2206),
    [anon_sym_mediump] = ACTIONS(2206),
    [anon_sym_lowp] = ACTIONS(2206),
    [anon_sym_centroid] = ACTIONS(2206),
    [anon_sym_sample] = ACTIONS(2206),
    [anon_sym_patch] = ACTIONS(2206),
    [anon_sym_smooth] = ACTIONS(2206),
    [anon_sym_flat] = ACTIONS(2206),
    [anon_sym_noperspective] = ACTIONS(2206),
    [anon_sym___extension__] = ACTIONS(2206),
    [anon_sym_extern] = ACTIONS(2206),
    [anon_sym___attribute__] = ACTIONS(2206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2208),
    [anon_sym___declspec] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2208),
    [anon_sym_signed] = ACTIONS(2206),
    [anon_sym_unsigned] = ACTIONS(2206),
    [anon_sym_long] = ACTIONS(2206),
    [anon_sym_short] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2206),
    [anon_sym_auto] = ACTIONS(2206),
    [anon_sym_register] = ACTIONS(2206),
    [anon_sym_inline] = ACTIONS(2206),
    [anon_sym___inline] = ACTIONS(2206),
    [anon_sym___inline__] = ACTIONS(2206),
    [anon_sym___forceinline] = ACTIONS(2206),
    [anon_sym_thread_local] = ACTIONS(2206),
    [anon_sym___thread] = ACTIONS(2206),
    [anon_sym_const] = ACTIONS(2206),
    [anon_sym_constexpr] = ACTIONS(2206),
    [anon_sym_volatile] = ACTIONS(2206),
    [anon_sym_restrict] = ACTIONS(2206),
    [anon_sym___restrict__] = ACTIONS(2206),
    [anon_sym__Atomic] = ACTIONS(2206),
    [anon_sym__Noreturn] = ACTIONS(2206),
    [anon_sym_noreturn] = ACTIONS(2206),
    [anon_sym_alignas] = ACTIONS(2206),
    [anon_sym__Alignas] = ACTIONS(2206),
    [sym_primitive_type] = ACTIONS(2206),
    [anon_sym_enum] = ACTIONS(2206),
    [anon_sym_struct] = ACTIONS(2206),
    [anon_sym_union] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2206),
    [anon_sym_hitAttributeEXT] = ACTIONS(2206),
    [anon_sym_callableDataEXT] = ACTIONS(2206),
    [anon_sym_callableDataInEXT] = ACTIONS(2206),
    [anon_sym_shaderRecordEXT] = ACTIONS(2206),
    [anon_sym_rayPayloadNV] = ACTIONS(2206),
    [anon_sym_rayPayloadInNV] = ACTIONS(2206),
    [anon_sym_hitAttributeNV] = ACTIONS(2206),
    [anon_sym_callableDataNV] = ACTIONS(2206),
    [anon_sym_callableDataInNV] = ACTIONS(2206),
    [anon_sym_shaderRecordNV] = ACTIONS(2206),
    [anon_sym_layout] = ACTIONS(2206),
  },
  [598] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token2] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_subroutine] = ACTIONS(2226),
    [anon_sym_invariant] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_attribute] = ACTIONS(2226),
    [anon_sym_varying] = ACTIONS(2226),
    [anon_sym_buffer] = ACTIONS(2226),
    [anon_sym_coherent] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_writeonly] = ACTIONS(2226),
    [anon_sym_precision] = ACTIONS(2226),
    [anon_sym_highp] = ACTIONS(2226),
    [anon_sym_mediump] = ACTIONS(2226),
    [anon_sym_lowp] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_patch] = ACTIONS(2226),
    [anon_sym_smooth] = ACTIONS(2226),
    [anon_sym_flat] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_auto] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2226),
    [anon_sym_hitAttributeEXT] = ACTIONS(2226),
    [anon_sym_callableDataEXT] = ACTIONS(2226),
    [anon_sym_callableDataInEXT] = ACTIONS(2226),
    [anon_sym_shaderRecordEXT] = ACTIONS(2226),
    [anon_sym_rayPayloadNV] = ACTIONS(2226),
    [anon_sym_rayPayloadInNV] = ACTIONS(2226),
    [anon_sym_hitAttributeNV] = ACTIONS(2226),
    [anon_sym_callableDataNV] = ACTIONS(2226),
    [anon_sym_callableDataInNV] = ACTIONS(2226),
    [anon_sym_shaderRecordNV] = ACTIONS(2226),
    [anon_sym_layout] = ACTIONS(2226),
  },
  [599] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [600] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_subroutine] = ACTIONS(2238),
    [anon_sym_invariant] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_attribute] = ACTIONS(2238),
    [anon_sym_varying] = ACTIONS(2238),
    [anon_sym_buffer] = ACTIONS(2238),
    [anon_sym_coherent] = ACTIONS(2238),
    [anon_sym_readonly] = ACTIONS(2238),
    [anon_sym_writeonly] = ACTIONS(2238),
    [anon_sym_precision] = ACTIONS(2238),
    [anon_sym_highp] = ACTIONS(2238),
    [anon_sym_mediump] = ACTIONS(2238),
    [anon_sym_lowp] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_patch] = ACTIONS(2238),
    [anon_sym_smooth] = ACTIONS(2238),
    [anon_sym_flat] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_auto] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2238),
    [anon_sym_hitAttributeEXT] = ACTIONS(2238),
    [anon_sym_callableDataEXT] = ACTIONS(2238),
    [anon_sym_callableDataInEXT] = ACTIONS(2238),
    [anon_sym_shaderRecordEXT] = ACTIONS(2238),
    [anon_sym_rayPayloadNV] = ACTIONS(2238),
    [anon_sym_rayPayloadInNV] = ACTIONS(2238),
    [anon_sym_hitAttributeNV] = ACTIONS(2238),
    [anon_sym_callableDataNV] = ACTIONS(2238),
    [anon_sym_callableDataInNV] = ACTIONS(2238),
    [anon_sym_shaderRecordNV] = ACTIONS(2238),
    [anon_sym_layout] = ACTIONS(2238),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token2] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_subroutine] = ACTIONS(2218),
    [anon_sym_invariant] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_attribute] = ACTIONS(2218),
    [anon_sym_varying] = ACTIONS(2218),
    [anon_sym_buffer] = ACTIONS(2218),
    [anon_sym_coherent] = ACTIONS(2218),
    [anon_sym_readonly] = ACTIONS(2218),
    [anon_sym_writeonly] = ACTIONS(2218),
    [anon_sym_precision] = ACTIONS(2218),
    [anon_sym_highp] = ACTIONS(2218),
    [anon_sym_mediump] = ACTIONS(2218),
    [anon_sym_lowp] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_patch] = ACTIONS(2218),
    [anon_sym_smooth] = ACTIONS(2218),
    [anon_sym_flat] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_auto] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2218),
    [anon_sym_hitAttributeEXT] = ACTIONS(2218),
    [anon_sym_callableDataEXT] = ACTIONS(2218),
    [anon_sym_callableDataInEXT] = ACTIONS(2218),
    [anon_sym_shaderRecordEXT] = ACTIONS(2218),
    [anon_sym_rayPayloadNV] = ACTIONS(2218),
    [anon_sym_rayPayloadInNV] = ACTIONS(2218),
    [anon_sym_hitAttributeNV] = ACTIONS(2218),
    [anon_sym_callableDataNV] = ACTIONS(2218),
    [anon_sym_callableDataInNV] = ACTIONS(2218),
    [anon_sym_shaderRecordNV] = ACTIONS(2218),
    [anon_sym_layout] = ACTIONS(2218),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token2] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_subroutine] = ACTIONS(2230),
    [anon_sym_invariant] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_attribute] = ACTIONS(2230),
    [anon_sym_varying] = ACTIONS(2230),
    [anon_sym_buffer] = ACTIONS(2230),
    [anon_sym_coherent] = ACTIONS(2230),
    [anon_sym_readonly] = ACTIONS(2230),
    [anon_sym_writeonly] = ACTIONS(2230),
    [anon_sym_precision] = ACTIONS(2230),
    [anon_sym_highp] = ACTIONS(2230),
    [anon_sym_mediump] = ACTIONS(2230),
    [anon_sym_lowp] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_patch] = ACTIONS(2230),
    [anon_sym_smooth] = ACTIONS(2230),
    [anon_sym_flat] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_auto] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2230),
    [anon_sym_hitAttributeEXT] = ACTIONS(2230),
    [anon_sym_callableDataEXT] = ACTIONS(2230),
    [anon_sym_callableDataInEXT] = ACTIONS(2230),
    [anon_sym_shaderRecordEXT] = ACTIONS(2230),
    [anon_sym_rayPayloadNV] = ACTIONS(2230),
    [anon_sym_rayPayloadInNV] = ACTIONS(2230),
    [anon_sym_hitAttributeNV] = ACTIONS(2230),
    [anon_sym_callableDataNV] = ACTIONS(2230),
    [anon_sym_callableDataInNV] = ACTIONS(2230),
    [anon_sym_shaderRecordNV] = ACTIONS(2230),
    [anon_sym_layout] = ACTIONS(2230),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_subroutine] = ACTIONS(2266),
    [anon_sym_invariant] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_attribute] = ACTIONS(2266),
    [anon_sym_varying] = ACTIONS(2266),
    [anon_sym_buffer] = ACTIONS(2266),
    [anon_sym_coherent] = ACTIONS(2266),
    [anon_sym_readonly] = ACTIONS(2266),
    [anon_sym_writeonly] = ACTIONS(2266),
    [anon_sym_precision] = ACTIONS(2266),
    [anon_sym_highp] = ACTIONS(2266),
    [anon_sym_mediump] = ACTIONS(2266),
    [anon_sym_lowp] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_patch] = ACTIONS(2266),
    [anon_sym_smooth] = ACTIONS(2266),
    [anon_sym_flat] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_auto] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2266),
    [anon_sym_hitAttributeEXT] = ACTIONS(2266),
    [anon_sym_callableDataEXT] = ACTIONS(2266),
    [anon_sym_callableDataInEXT] = ACTIONS(2266),
    [anon_sym_shaderRecordEXT] = ACTIONS(2266),
    [anon_sym_rayPayloadNV] = ACTIONS(2266),
    [anon_sym_rayPayloadInNV] = ACTIONS(2266),
    [anon_sym_hitAttributeNV] = ACTIONS(2266),
    [anon_sym_callableDataNV] = ACTIONS(2266),
    [anon_sym_callableDataInNV] = ACTIONS(2266),
    [anon_sym_shaderRecordNV] = ACTIONS(2266),
    [anon_sym_layout] = ACTIONS(2266),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_subroutine] = ACTIONS(2242),
    [anon_sym_invariant] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_attribute] = ACTIONS(2242),
    [anon_sym_varying] = ACTIONS(2242),
    [anon_sym_buffer] = ACTIONS(2242),
    [anon_sym_coherent] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_writeonly] = ACTIONS(2242),
    [anon_sym_precision] = ACTIONS(2242),
    [anon_sym_highp] = ACTIONS(2242),
    [anon_sym_mediump] = ACTIONS(2242),
    [anon_sym_lowp] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_patch] = ACTIONS(2242),
    [anon_sym_smooth] = ACTIONS(2242),
    [anon_sym_flat] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_auto] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2242),
    [anon_sym_hitAttributeEXT] = ACTIONS(2242),
    [anon_sym_callableDataEXT] = ACTIONS(2242),
    [anon_sym_callableDataInEXT] = ACTIONS(2242),
    [anon_sym_shaderRecordEXT] = ACTIONS(2242),
    [anon_sym_rayPayloadNV] = ACTIONS(2242),
    [anon_sym_rayPayloadInNV] = ACTIONS(2242),
    [anon_sym_hitAttributeNV] = ACTIONS(2242),
    [anon_sym_callableDataNV] = ACTIONS(2242),
    [anon_sym_callableDataInNV] = ACTIONS(2242),
    [anon_sym_shaderRecordNV] = ACTIONS(2242),
    [anon_sym_layout] = ACTIONS(2242),
  },
  [606] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [607] = {
    [sym_identifier] = ACTIONS(1429),
    [aux_sym_preproc_def_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token1] = ACTIONS(1429),
    [aux_sym_preproc_if_token2] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1429),
    [sym_preproc_directive] = ACTIONS(1429),
    [anon_sym_subroutine] = ACTIONS(1429),
    [anon_sym_invariant] = ACTIONS(1429),
    [anon_sym_precise] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_out] = ACTIONS(1429),
    [anon_sym_inout] = ACTIONS(1429),
    [anon_sym_uniform] = ACTIONS(1429),
    [anon_sym_shared] = ACTIONS(1429),
    [anon_sym_attribute] = ACTIONS(1429),
    [anon_sym_varying] = ACTIONS(1429),
    [anon_sym_buffer] = ACTIONS(1429),
    [anon_sym_coherent] = ACTIONS(1429),
    [anon_sym_readonly] = ACTIONS(1429),
    [anon_sym_writeonly] = ACTIONS(1429),
    [anon_sym_precision] = ACTIONS(1429),
    [anon_sym_highp] = ACTIONS(1429),
    [anon_sym_mediump] = ACTIONS(1429),
    [anon_sym_lowp] = ACTIONS(1429),
    [anon_sym_centroid] = ACTIONS(1429),
    [anon_sym_sample] = ACTIONS(1429),
    [anon_sym_patch] = ACTIONS(1429),
    [anon_sym_smooth] = ACTIONS(1429),
    [anon_sym_flat] = ACTIONS(1429),
    [anon_sym_noperspective] = ACTIONS(1429),
    [anon_sym___extension__] = ACTIONS(1429),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym___attribute__] = ACTIONS(1429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1431),
    [anon_sym___declspec] = ACTIONS(1429),
    [anon_sym_signed] = ACTIONS(1429),
    [anon_sym_unsigned] = ACTIONS(1429),
    [anon_sym_long] = ACTIONS(1429),
    [anon_sym_short] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_auto] = ACTIONS(1429),
    [anon_sym_register] = ACTIONS(1429),
    [anon_sym_inline] = ACTIONS(1429),
    [anon_sym___inline] = ACTIONS(1429),
    [anon_sym___inline__] = ACTIONS(1429),
    [anon_sym___forceinline] = ACTIONS(1429),
    [anon_sym_thread_local] = ACTIONS(1429),
    [anon_sym___thread] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_constexpr] = ACTIONS(1429),
    [anon_sym_volatile] = ACTIONS(1429),
    [anon_sym_restrict] = ACTIONS(1429),
    [anon_sym___restrict__] = ACTIONS(1429),
    [anon_sym__Atomic] = ACTIONS(1429),
    [anon_sym__Noreturn] = ACTIONS(1429),
    [anon_sym_noreturn] = ACTIONS(1429),
    [anon_sym_alignas] = ACTIONS(1429),
    [anon_sym__Alignas] = ACTIONS(1429),
    [sym_primitive_type] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1429),
    [anon_sym_hitAttributeEXT] = ACTIONS(1429),
    [anon_sym_callableDataEXT] = ACTIONS(1429),
    [anon_sym_callableDataInEXT] = ACTIONS(1429),
    [anon_sym_shaderRecordEXT] = ACTIONS(1429),
    [anon_sym_rayPayloadNV] = ACTIONS(1429),
    [anon_sym_rayPayloadInNV] = ACTIONS(1429),
    [anon_sym_hitAttributeNV] = ACTIONS(1429),
    [anon_sym_callableDataNV] = ACTIONS(1429),
    [anon_sym_callableDataInNV] = ACTIONS(1429),
    [anon_sym_shaderRecordNV] = ACTIONS(1429),
    [anon_sym_layout] = ACTIONS(1429),
  },
  [608] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_subroutine] = ACTIONS(2250),
    [anon_sym_invariant] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_attribute] = ACTIONS(2250),
    [anon_sym_varying] = ACTIONS(2250),
    [anon_sym_buffer] = ACTIONS(2250),
    [anon_sym_coherent] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_writeonly] = ACTIONS(2250),
    [anon_sym_precision] = ACTIONS(2250),
    [anon_sym_highp] = ACTIONS(2250),
    [anon_sym_mediump] = ACTIONS(2250),
    [anon_sym_lowp] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_patch] = ACTIONS(2250),
    [anon_sym_smooth] = ACTIONS(2250),
    [anon_sym_flat] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_auto] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2250),
    [anon_sym_hitAttributeEXT] = ACTIONS(2250),
    [anon_sym_callableDataEXT] = ACTIONS(2250),
    [anon_sym_callableDataInEXT] = ACTIONS(2250),
    [anon_sym_shaderRecordEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadNV] = ACTIONS(2250),
    [anon_sym_rayPayloadInNV] = ACTIONS(2250),
    [anon_sym_hitAttributeNV] = ACTIONS(2250),
    [anon_sym_callableDataNV] = ACTIONS(2250),
    [anon_sym_callableDataInNV] = ACTIONS(2250),
    [anon_sym_shaderRecordNV] = ACTIONS(2250),
    [anon_sym_layout] = ACTIONS(2250),
  },
  [610] = {
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_def_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token1] = ACTIONS(1441),
    [aux_sym_preproc_if_token2] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1441),
    [sym_preproc_directive] = ACTIONS(1441),
    [anon_sym_subroutine] = ACTIONS(1441),
    [anon_sym_invariant] = ACTIONS(1441),
    [anon_sym_precise] = ACTIONS(1441),
    [anon_sym_in] = ACTIONS(1441),
    [anon_sym_out] = ACTIONS(1441),
    [anon_sym_inout] = ACTIONS(1441),
    [anon_sym_uniform] = ACTIONS(1441),
    [anon_sym_shared] = ACTIONS(1441),
    [anon_sym_attribute] = ACTIONS(1441),
    [anon_sym_varying] = ACTIONS(1441),
    [anon_sym_buffer] = ACTIONS(1441),
    [anon_sym_coherent] = ACTIONS(1441),
    [anon_sym_readonly] = ACTIONS(1441),
    [anon_sym_writeonly] = ACTIONS(1441),
    [anon_sym_precision] = ACTIONS(1441),
    [anon_sym_highp] = ACTIONS(1441),
    [anon_sym_mediump] = ACTIONS(1441),
    [anon_sym_lowp] = ACTIONS(1441),
    [anon_sym_centroid] = ACTIONS(1441),
    [anon_sym_sample] = ACTIONS(1441),
    [anon_sym_patch] = ACTIONS(1441),
    [anon_sym_smooth] = ACTIONS(1441),
    [anon_sym_flat] = ACTIONS(1441),
    [anon_sym_noperspective] = ACTIONS(1441),
    [anon_sym___extension__] = ACTIONS(1441),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym___attribute__] = ACTIONS(1441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1443),
    [anon_sym___declspec] = ACTIONS(1441),
    [anon_sym_signed] = ACTIONS(1441),
    [anon_sym_unsigned] = ACTIONS(1441),
    [anon_sym_long] = ACTIONS(1441),
    [anon_sym_short] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_auto] = ACTIONS(1441),
    [anon_sym_register] = ACTIONS(1441),
    [anon_sym_inline] = ACTIONS(1441),
    [anon_sym___inline] = ACTIONS(1441),
    [anon_sym___inline__] = ACTIONS(1441),
    [anon_sym___forceinline] = ACTIONS(1441),
    [anon_sym_thread_local] = ACTIONS(1441),
    [anon_sym___thread] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_constexpr] = ACTIONS(1441),
    [anon_sym_volatile] = ACTIONS(1441),
    [anon_sym_restrict] = ACTIONS(1441),
    [anon_sym___restrict__] = ACTIONS(1441),
    [anon_sym__Atomic] = ACTIONS(1441),
    [anon_sym__Noreturn] = ACTIONS(1441),
    [anon_sym_noreturn] = ACTIONS(1441),
    [anon_sym_alignas] = ACTIONS(1441),
    [anon_sym__Alignas] = ACTIONS(1441),
    [sym_primitive_type] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1441),
    [anon_sym_hitAttributeEXT] = ACTIONS(1441),
    [anon_sym_callableDataEXT] = ACTIONS(1441),
    [anon_sym_callableDataInEXT] = ACTIONS(1441),
    [anon_sym_shaderRecordEXT] = ACTIONS(1441),
    [anon_sym_rayPayloadNV] = ACTIONS(1441),
    [anon_sym_rayPayloadInNV] = ACTIONS(1441),
    [anon_sym_hitAttributeNV] = ACTIONS(1441),
    [anon_sym_callableDataNV] = ACTIONS(1441),
    [anon_sym_callableDataInNV] = ACTIONS(1441),
    [anon_sym_shaderRecordNV] = ACTIONS(1441),
    [anon_sym_layout] = ACTIONS(1441),
  },
  [611] = {
    [sym_identifier] = ACTIONS(1401),
    [aux_sym_preproc_def_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token1] = ACTIONS(1401),
    [aux_sym_preproc_if_token2] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1401),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1401),
    [sym_preproc_directive] = ACTIONS(1401),
    [anon_sym_subroutine] = ACTIONS(1401),
    [anon_sym_invariant] = ACTIONS(1401),
    [anon_sym_precise] = ACTIONS(1401),
    [anon_sym_in] = ACTIONS(1401),
    [anon_sym_out] = ACTIONS(1401),
    [anon_sym_inout] = ACTIONS(1401),
    [anon_sym_uniform] = ACTIONS(1401),
    [anon_sym_shared] = ACTIONS(1401),
    [anon_sym_attribute] = ACTIONS(1401),
    [anon_sym_varying] = ACTIONS(1401),
    [anon_sym_buffer] = ACTIONS(1401),
    [anon_sym_coherent] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_writeonly] = ACTIONS(1401),
    [anon_sym_precision] = ACTIONS(1401),
    [anon_sym_highp] = ACTIONS(1401),
    [anon_sym_mediump] = ACTIONS(1401),
    [anon_sym_lowp] = ACTIONS(1401),
    [anon_sym_centroid] = ACTIONS(1401),
    [anon_sym_sample] = ACTIONS(1401),
    [anon_sym_patch] = ACTIONS(1401),
    [anon_sym_smooth] = ACTIONS(1401),
    [anon_sym_flat] = ACTIONS(1401),
    [anon_sym_noperspective] = ACTIONS(1401),
    [anon_sym___extension__] = ACTIONS(1401),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym___attribute__] = ACTIONS(1401),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1403),
    [anon_sym___declspec] = ACTIONS(1401),
    [anon_sym_signed] = ACTIONS(1401),
    [anon_sym_unsigned] = ACTIONS(1401),
    [anon_sym_long] = ACTIONS(1401),
    [anon_sym_short] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_auto] = ACTIONS(1401),
    [anon_sym_register] = ACTIONS(1401),
    [anon_sym_inline] = ACTIONS(1401),
    [anon_sym___inline] = ACTIONS(1401),
    [anon_sym___inline__] = ACTIONS(1401),
    [anon_sym___forceinline] = ACTIONS(1401),
    [anon_sym_thread_local] = ACTIONS(1401),
    [anon_sym___thread] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_constexpr] = ACTIONS(1401),
    [anon_sym_volatile] = ACTIONS(1401),
    [anon_sym_restrict] = ACTIONS(1401),
    [anon_sym___restrict__] = ACTIONS(1401),
    [anon_sym__Atomic] = ACTIONS(1401),
    [anon_sym__Noreturn] = ACTIONS(1401),
    [anon_sym_noreturn] = ACTIONS(1401),
    [anon_sym_alignas] = ACTIONS(1401),
    [anon_sym__Alignas] = ACTIONS(1401),
    [sym_primitive_type] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1401),
    [anon_sym_hitAttributeEXT] = ACTIONS(1401),
    [anon_sym_callableDataEXT] = ACTIONS(1401),
    [anon_sym_callableDataInEXT] = ACTIONS(1401),
    [anon_sym_shaderRecordEXT] = ACTIONS(1401),
    [anon_sym_rayPayloadNV] = ACTIONS(1401),
    [anon_sym_rayPayloadInNV] = ACTIONS(1401),
    [anon_sym_hitAttributeNV] = ACTIONS(1401),
    [anon_sym_callableDataNV] = ACTIONS(1401),
    [anon_sym_callableDataInNV] = ACTIONS(1401),
    [anon_sym_shaderRecordNV] = ACTIONS(1401),
    [anon_sym_layout] = ACTIONS(1401),
  },
  [612] = {
    [sym_identifier] = ACTIONS(1409),
    [aux_sym_preproc_def_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token1] = ACTIONS(1409),
    [aux_sym_preproc_if_token2] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1409),
    [sym_preproc_directive] = ACTIONS(1409),
    [anon_sym_subroutine] = ACTIONS(1409),
    [anon_sym_invariant] = ACTIONS(1409),
    [anon_sym_precise] = ACTIONS(1409),
    [anon_sym_in] = ACTIONS(1409),
    [anon_sym_out] = ACTIONS(1409),
    [anon_sym_inout] = ACTIONS(1409),
    [anon_sym_uniform] = ACTIONS(1409),
    [anon_sym_shared] = ACTIONS(1409),
    [anon_sym_attribute] = ACTIONS(1409),
    [anon_sym_varying] = ACTIONS(1409),
    [anon_sym_buffer] = ACTIONS(1409),
    [anon_sym_coherent] = ACTIONS(1409),
    [anon_sym_readonly] = ACTIONS(1409),
    [anon_sym_writeonly] = ACTIONS(1409),
    [anon_sym_precision] = ACTIONS(1409),
    [anon_sym_highp] = ACTIONS(1409),
    [anon_sym_mediump] = ACTIONS(1409),
    [anon_sym_lowp] = ACTIONS(1409),
    [anon_sym_centroid] = ACTIONS(1409),
    [anon_sym_sample] = ACTIONS(1409),
    [anon_sym_patch] = ACTIONS(1409),
    [anon_sym_smooth] = ACTIONS(1409),
    [anon_sym_flat] = ACTIONS(1409),
    [anon_sym_noperspective] = ACTIONS(1409),
    [anon_sym___extension__] = ACTIONS(1409),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym___attribute__] = ACTIONS(1409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1411),
    [anon_sym___declspec] = ACTIONS(1409),
    [anon_sym_signed] = ACTIONS(1409),
    [anon_sym_unsigned] = ACTIONS(1409),
    [anon_sym_long] = ACTIONS(1409),
    [anon_sym_short] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_auto] = ACTIONS(1409),
    [anon_sym_register] = ACTIONS(1409),
    [anon_sym_inline] = ACTIONS(1409),
    [anon_sym___inline] = ACTIONS(1409),
    [anon_sym___inline__] = ACTIONS(1409),
    [anon_sym___forceinline] = ACTIONS(1409),
    [anon_sym_thread_local] = ACTIONS(1409),
    [anon_sym___thread] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_constexpr] = ACTIONS(1409),
    [anon_sym_volatile] = ACTIONS(1409),
    [anon_sym_restrict] = ACTIONS(1409),
    [anon_sym___restrict__] = ACTIONS(1409),
    [anon_sym__Atomic] = ACTIONS(1409),
    [anon_sym__Noreturn] = ACTIONS(1409),
    [anon_sym_noreturn] = ACTIONS(1409),
    [anon_sym_alignas] = ACTIONS(1409),
    [anon_sym__Alignas] = ACTIONS(1409),
    [sym_primitive_type] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1409),
    [anon_sym_hitAttributeEXT] = ACTIONS(1409),
    [anon_sym_callableDataEXT] = ACTIONS(1409),
    [anon_sym_callableDataInEXT] = ACTIONS(1409),
    [anon_sym_shaderRecordEXT] = ACTIONS(1409),
    [anon_sym_rayPayloadNV] = ACTIONS(1409),
    [anon_sym_rayPayloadInNV] = ACTIONS(1409),
    [anon_sym_hitAttributeNV] = ACTIONS(1409),
    [anon_sym_callableDataNV] = ACTIONS(1409),
    [anon_sym_callableDataInNV] = ACTIONS(1409),
    [anon_sym_shaderRecordNV] = ACTIONS(1409),
    [anon_sym_layout] = ACTIONS(1409),
  },
  [613] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_subroutine] = ACTIONS(2250),
    [anon_sym_invariant] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_attribute] = ACTIONS(2250),
    [anon_sym_varying] = ACTIONS(2250),
    [anon_sym_buffer] = ACTIONS(2250),
    [anon_sym_coherent] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_writeonly] = ACTIONS(2250),
    [anon_sym_precision] = ACTIONS(2250),
    [anon_sym_highp] = ACTIONS(2250),
    [anon_sym_mediump] = ACTIONS(2250),
    [anon_sym_lowp] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_patch] = ACTIONS(2250),
    [anon_sym_smooth] = ACTIONS(2250),
    [anon_sym_flat] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_auto] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2250),
    [anon_sym_hitAttributeEXT] = ACTIONS(2250),
    [anon_sym_callableDataEXT] = ACTIONS(2250),
    [anon_sym_callableDataInEXT] = ACTIONS(2250),
    [anon_sym_shaderRecordEXT] = ACTIONS(2250),
    [anon_sym_rayPayloadNV] = ACTIONS(2250),
    [anon_sym_rayPayloadInNV] = ACTIONS(2250),
    [anon_sym_hitAttributeNV] = ACTIONS(2250),
    [anon_sym_callableDataNV] = ACTIONS(2250),
    [anon_sym_callableDataInNV] = ACTIONS(2250),
    [anon_sym_shaderRecordNV] = ACTIONS(2250),
    [anon_sym_layout] = ACTIONS(2250),
  },
  [614] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_subroutine] = ACTIONS(2222),
    [anon_sym_invariant] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_attribute] = ACTIONS(2222),
    [anon_sym_varying] = ACTIONS(2222),
    [anon_sym_buffer] = ACTIONS(2222),
    [anon_sym_coherent] = ACTIONS(2222),
    [anon_sym_readonly] = ACTIONS(2222),
    [anon_sym_writeonly] = ACTIONS(2222),
    [anon_sym_precision] = ACTIONS(2222),
    [anon_sym_highp] = ACTIONS(2222),
    [anon_sym_mediump] = ACTIONS(2222),
    [anon_sym_lowp] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_patch] = ACTIONS(2222),
    [anon_sym_smooth] = ACTIONS(2222),
    [anon_sym_flat] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_auto] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2222),
    [anon_sym_hitAttributeEXT] = ACTIONS(2222),
    [anon_sym_callableDataEXT] = ACTIONS(2222),
    [anon_sym_callableDataInEXT] = ACTIONS(2222),
    [anon_sym_shaderRecordEXT] = ACTIONS(2222),
    [anon_sym_rayPayloadNV] = ACTIONS(2222),
    [anon_sym_rayPayloadInNV] = ACTIONS(2222),
    [anon_sym_hitAttributeNV] = ACTIONS(2222),
    [anon_sym_callableDataNV] = ACTIONS(2222),
    [anon_sym_callableDataInNV] = ACTIONS(2222),
    [anon_sym_shaderRecordNV] = ACTIONS(2222),
    [anon_sym_layout] = ACTIONS(2222),
  },
  [615] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_subroutine] = ACTIONS(2246),
    [anon_sym_invariant] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_attribute] = ACTIONS(2246),
    [anon_sym_varying] = ACTIONS(2246),
    [anon_sym_buffer] = ACTIONS(2246),
    [anon_sym_coherent] = ACTIONS(2246),
    [anon_sym_readonly] = ACTIONS(2246),
    [anon_sym_writeonly] = ACTIONS(2246),
    [anon_sym_precision] = ACTIONS(2246),
    [anon_sym_highp] = ACTIONS(2246),
    [anon_sym_mediump] = ACTIONS(2246),
    [anon_sym_lowp] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_patch] = ACTIONS(2246),
    [anon_sym_smooth] = ACTIONS(2246),
    [anon_sym_flat] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_auto] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2246),
    [anon_sym_hitAttributeEXT] = ACTIONS(2246),
    [anon_sym_callableDataEXT] = ACTIONS(2246),
    [anon_sym_callableDataInEXT] = ACTIONS(2246),
    [anon_sym_shaderRecordEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadNV] = ACTIONS(2246),
    [anon_sym_rayPayloadInNV] = ACTIONS(2246),
    [anon_sym_hitAttributeNV] = ACTIONS(2246),
    [anon_sym_callableDataNV] = ACTIONS(2246),
    [anon_sym_callableDataInNV] = ACTIONS(2246),
    [anon_sym_shaderRecordNV] = ACTIONS(2246),
    [anon_sym_layout] = ACTIONS(2246),
  },
  [616] = {
    [sym_identifier] = ACTIONS(1485),
    [aux_sym_preproc_def_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token1] = ACTIONS(1485),
    [aux_sym_preproc_if_token2] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1485),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1485),
    [sym_preproc_directive] = ACTIONS(1485),
    [anon_sym_subroutine] = ACTIONS(1485),
    [anon_sym_invariant] = ACTIONS(1485),
    [anon_sym_precise] = ACTIONS(1485),
    [anon_sym_in] = ACTIONS(1485),
    [anon_sym_out] = ACTIONS(1485),
    [anon_sym_inout] = ACTIONS(1485),
    [anon_sym_uniform] = ACTIONS(1485),
    [anon_sym_shared] = ACTIONS(1485),
    [anon_sym_attribute] = ACTIONS(1485),
    [anon_sym_varying] = ACTIONS(1485),
    [anon_sym_buffer] = ACTIONS(1485),
    [anon_sym_coherent] = ACTIONS(1485),
    [anon_sym_readonly] = ACTIONS(1485),
    [anon_sym_writeonly] = ACTIONS(1485),
    [anon_sym_precision] = ACTIONS(1485),
    [anon_sym_highp] = ACTIONS(1485),
    [anon_sym_mediump] = ACTIONS(1485),
    [anon_sym_lowp] = ACTIONS(1485),
    [anon_sym_centroid] = ACTIONS(1485),
    [anon_sym_sample] = ACTIONS(1485),
    [anon_sym_patch] = ACTIONS(1485),
    [anon_sym_smooth] = ACTIONS(1485),
    [anon_sym_flat] = ACTIONS(1485),
    [anon_sym_noperspective] = ACTIONS(1485),
    [anon_sym___extension__] = ACTIONS(1485),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym___attribute__] = ACTIONS(1485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1487),
    [anon_sym___declspec] = ACTIONS(1485),
    [anon_sym_signed] = ACTIONS(1485),
    [anon_sym_unsigned] = ACTIONS(1485),
    [anon_sym_long] = ACTIONS(1485),
    [anon_sym_short] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_auto] = ACTIONS(1485),
    [anon_sym_register] = ACTIONS(1485),
    [anon_sym_inline] = ACTIONS(1485),
    [anon_sym___inline] = ACTIONS(1485),
    [anon_sym___inline__] = ACTIONS(1485),
    [anon_sym___forceinline] = ACTIONS(1485),
    [anon_sym_thread_local] = ACTIONS(1485),
    [anon_sym___thread] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_constexpr] = ACTIONS(1485),
    [anon_sym_volatile] = ACTIONS(1485),
    [anon_sym_restrict] = ACTIONS(1485),
    [anon_sym___restrict__] = ACTIONS(1485),
    [anon_sym__Atomic] = ACTIONS(1485),
    [anon_sym__Noreturn] = ACTIONS(1485),
    [anon_sym_noreturn] = ACTIONS(1485),
    [anon_sym_alignas] = ACTIONS(1485),
    [anon_sym__Alignas] = ACTIONS(1485),
    [sym_primitive_type] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1485),
    [anon_sym_hitAttributeEXT] = ACTIONS(1485),
    [anon_sym_callableDataEXT] = ACTIONS(1485),
    [anon_sym_callableDataInEXT] = ACTIONS(1485),
    [anon_sym_shaderRecordEXT] = ACTIONS(1485),
    [anon_sym_rayPayloadNV] = ACTIONS(1485),
    [anon_sym_rayPayloadInNV] = ACTIONS(1485),
    [anon_sym_hitAttributeNV] = ACTIONS(1485),
    [anon_sym_callableDataNV] = ACTIONS(1485),
    [anon_sym_callableDataInNV] = ACTIONS(1485),
    [anon_sym_shaderRecordNV] = ACTIONS(1485),
    [anon_sym_layout] = ACTIONS(1485),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_subroutine] = ACTIONS(2246),
    [anon_sym_invariant] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_attribute] = ACTIONS(2246),
    [anon_sym_varying] = ACTIONS(2246),
    [anon_sym_buffer] = ACTIONS(2246),
    [anon_sym_coherent] = ACTIONS(2246),
    [anon_sym_readonly] = ACTIONS(2246),
    [anon_sym_writeonly] = ACTIONS(2246),
    [anon_sym_precision] = ACTIONS(2246),
    [anon_sym_highp] = ACTIONS(2246),
    [anon_sym_mediump] = ACTIONS(2246),
    [anon_sym_lowp] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_patch] = ACTIONS(2246),
    [anon_sym_smooth] = ACTIONS(2246),
    [anon_sym_flat] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_auto] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2246),
    [anon_sym_hitAttributeEXT] = ACTIONS(2246),
    [anon_sym_callableDataEXT] = ACTIONS(2246),
    [anon_sym_callableDataInEXT] = ACTIONS(2246),
    [anon_sym_shaderRecordEXT] = ACTIONS(2246),
    [anon_sym_rayPayloadNV] = ACTIONS(2246),
    [anon_sym_rayPayloadInNV] = ACTIONS(2246),
    [anon_sym_hitAttributeNV] = ACTIONS(2246),
    [anon_sym_callableDataNV] = ACTIONS(2246),
    [anon_sym_callableDataInNV] = ACTIONS(2246),
    [anon_sym_shaderRecordNV] = ACTIONS(2246),
    [anon_sym_layout] = ACTIONS(2246),
  },
  [618] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token2] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_subroutine] = ACTIONS(2254),
    [anon_sym_invariant] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_attribute] = ACTIONS(2254),
    [anon_sym_varying] = ACTIONS(2254),
    [anon_sym_buffer] = ACTIONS(2254),
    [anon_sym_coherent] = ACTIONS(2254),
    [anon_sym_readonly] = ACTIONS(2254),
    [anon_sym_writeonly] = ACTIONS(2254),
    [anon_sym_precision] = ACTIONS(2254),
    [anon_sym_highp] = ACTIONS(2254),
    [anon_sym_mediump] = ACTIONS(2254),
    [anon_sym_lowp] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_patch] = ACTIONS(2254),
    [anon_sym_smooth] = ACTIONS(2254),
    [anon_sym_flat] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_auto] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2254),
    [anon_sym_hitAttributeEXT] = ACTIONS(2254),
    [anon_sym_callableDataEXT] = ACTIONS(2254),
    [anon_sym_callableDataInEXT] = ACTIONS(2254),
    [anon_sym_shaderRecordEXT] = ACTIONS(2254),
    [anon_sym_rayPayloadNV] = ACTIONS(2254),
    [anon_sym_rayPayloadInNV] = ACTIONS(2254),
    [anon_sym_hitAttributeNV] = ACTIONS(2254),
    [anon_sym_callableDataNV] = ACTIONS(2254),
    [anon_sym_callableDataInNV] = ACTIONS(2254),
    [anon_sym_shaderRecordNV] = ACTIONS(2254),
    [anon_sym_layout] = ACTIONS(2254),
  },
  [619] = {
    [sym_identifier] = ACTIONS(1489),
    [aux_sym_preproc_def_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token1] = ACTIONS(1489),
    [aux_sym_preproc_if_token2] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1489),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1489),
    [sym_preproc_directive] = ACTIONS(1489),
    [anon_sym_subroutine] = ACTIONS(1489),
    [anon_sym_invariant] = ACTIONS(1489),
    [anon_sym_precise] = ACTIONS(1489),
    [anon_sym_in] = ACTIONS(1489),
    [anon_sym_out] = ACTIONS(1489),
    [anon_sym_inout] = ACTIONS(1489),
    [anon_sym_uniform] = ACTIONS(1489),
    [anon_sym_shared] = ACTIONS(1489),
    [anon_sym_attribute] = ACTIONS(1489),
    [anon_sym_varying] = ACTIONS(1489),
    [anon_sym_buffer] = ACTIONS(1489),
    [anon_sym_coherent] = ACTIONS(1489),
    [anon_sym_readonly] = ACTIONS(1489),
    [anon_sym_writeonly] = ACTIONS(1489),
    [anon_sym_precision] = ACTIONS(1489),
    [anon_sym_highp] = ACTIONS(1489),
    [anon_sym_mediump] = ACTIONS(1489),
    [anon_sym_lowp] = ACTIONS(1489),
    [anon_sym_centroid] = ACTIONS(1489),
    [anon_sym_sample] = ACTIONS(1489),
    [anon_sym_patch] = ACTIONS(1489),
    [anon_sym_smooth] = ACTIONS(1489),
    [anon_sym_flat] = ACTIONS(1489),
    [anon_sym_noperspective] = ACTIONS(1489),
    [anon_sym___extension__] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym___attribute__] = ACTIONS(1489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1491),
    [anon_sym___declspec] = ACTIONS(1489),
    [anon_sym_signed] = ACTIONS(1489),
    [anon_sym_unsigned] = ACTIONS(1489),
    [anon_sym_long] = ACTIONS(1489),
    [anon_sym_short] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_auto] = ACTIONS(1489),
    [anon_sym_register] = ACTIONS(1489),
    [anon_sym_inline] = ACTIONS(1489),
    [anon_sym___inline] = ACTIONS(1489),
    [anon_sym___inline__] = ACTIONS(1489),
    [anon_sym___forceinline] = ACTIONS(1489),
    [anon_sym_thread_local] = ACTIONS(1489),
    [anon_sym___thread] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_constexpr] = ACTIONS(1489),
    [anon_sym_volatile] = ACTIONS(1489),
    [anon_sym_restrict] = ACTIONS(1489),
    [anon_sym___restrict__] = ACTIONS(1489),
    [anon_sym__Atomic] = ACTIONS(1489),
    [anon_sym__Noreturn] = ACTIONS(1489),
    [anon_sym_noreturn] = ACTIONS(1489),
    [anon_sym_alignas] = ACTIONS(1489),
    [anon_sym__Alignas] = ACTIONS(1489),
    [sym_primitive_type] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1489),
    [anon_sym_hitAttributeEXT] = ACTIONS(1489),
    [anon_sym_callableDataEXT] = ACTIONS(1489),
    [anon_sym_callableDataInEXT] = ACTIONS(1489),
    [anon_sym_shaderRecordEXT] = ACTIONS(1489),
    [anon_sym_rayPayloadNV] = ACTIONS(1489),
    [anon_sym_rayPayloadInNV] = ACTIONS(1489),
    [anon_sym_hitAttributeNV] = ACTIONS(1489),
    [anon_sym_callableDataNV] = ACTIONS(1489),
    [anon_sym_callableDataInNV] = ACTIONS(1489),
    [anon_sym_shaderRecordNV] = ACTIONS(1489),
    [anon_sym_layout] = ACTIONS(1489),
  },
  [620] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token2] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_subroutine] = ACTIONS(2202),
    [anon_sym_invariant] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_attribute] = ACTIONS(2202),
    [anon_sym_varying] = ACTIONS(2202),
    [anon_sym_buffer] = ACTIONS(2202),
    [anon_sym_coherent] = ACTIONS(2202),
    [anon_sym_readonly] = ACTIONS(2202),
    [anon_sym_writeonly] = ACTIONS(2202),
    [anon_sym_precision] = ACTIONS(2202),
    [anon_sym_highp] = ACTIONS(2202),
    [anon_sym_mediump] = ACTIONS(2202),
    [anon_sym_lowp] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_patch] = ACTIONS(2202),
    [anon_sym_smooth] = ACTIONS(2202),
    [anon_sym_flat] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_auto] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2202),
    [anon_sym_hitAttributeEXT] = ACTIONS(2202),
    [anon_sym_callableDataEXT] = ACTIONS(2202),
    [anon_sym_callableDataInEXT] = ACTIONS(2202),
    [anon_sym_shaderRecordEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadNV] = ACTIONS(2202),
    [anon_sym_rayPayloadInNV] = ACTIONS(2202),
    [anon_sym_hitAttributeNV] = ACTIONS(2202),
    [anon_sym_callableDataNV] = ACTIONS(2202),
    [anon_sym_callableDataInNV] = ACTIONS(2202),
    [anon_sym_shaderRecordNV] = ACTIONS(2202),
    [anon_sym_layout] = ACTIONS(2202),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2202),
    [aux_sym_preproc_def_token1] = ACTIONS(2202),
    [aux_sym_preproc_if_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2202),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2202),
    [sym_preproc_directive] = ACTIONS(2202),
    [anon_sym_subroutine] = ACTIONS(2202),
    [anon_sym_invariant] = ACTIONS(2202),
    [anon_sym_precise] = ACTIONS(2202),
    [anon_sym_in] = ACTIONS(2202),
    [anon_sym_out] = ACTIONS(2202),
    [anon_sym_inout] = ACTIONS(2202),
    [anon_sym_uniform] = ACTIONS(2202),
    [anon_sym_shared] = ACTIONS(2202),
    [anon_sym_attribute] = ACTIONS(2202),
    [anon_sym_varying] = ACTIONS(2202),
    [anon_sym_buffer] = ACTIONS(2202),
    [anon_sym_coherent] = ACTIONS(2202),
    [anon_sym_readonly] = ACTIONS(2202),
    [anon_sym_writeonly] = ACTIONS(2202),
    [anon_sym_precision] = ACTIONS(2202),
    [anon_sym_highp] = ACTIONS(2202),
    [anon_sym_mediump] = ACTIONS(2202),
    [anon_sym_lowp] = ACTIONS(2202),
    [anon_sym_centroid] = ACTIONS(2202),
    [anon_sym_sample] = ACTIONS(2202),
    [anon_sym_patch] = ACTIONS(2202),
    [anon_sym_smooth] = ACTIONS(2202),
    [anon_sym_flat] = ACTIONS(2202),
    [anon_sym_noperspective] = ACTIONS(2202),
    [anon_sym___extension__] = ACTIONS(2202),
    [anon_sym_extern] = ACTIONS(2202),
    [anon_sym___attribute__] = ACTIONS(2202),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2204),
    [anon_sym___declspec] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_signed] = ACTIONS(2202),
    [anon_sym_unsigned] = ACTIONS(2202),
    [anon_sym_long] = ACTIONS(2202),
    [anon_sym_short] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2202),
    [anon_sym_auto] = ACTIONS(2202),
    [anon_sym_register] = ACTIONS(2202),
    [anon_sym_inline] = ACTIONS(2202),
    [anon_sym___inline] = ACTIONS(2202),
    [anon_sym___inline__] = ACTIONS(2202),
    [anon_sym___forceinline] = ACTIONS(2202),
    [anon_sym_thread_local] = ACTIONS(2202),
    [anon_sym___thread] = ACTIONS(2202),
    [anon_sym_const] = ACTIONS(2202),
    [anon_sym_constexpr] = ACTIONS(2202),
    [anon_sym_volatile] = ACTIONS(2202),
    [anon_sym_restrict] = ACTIONS(2202),
    [anon_sym___restrict__] = ACTIONS(2202),
    [anon_sym__Atomic] = ACTIONS(2202),
    [anon_sym__Noreturn] = ACTIONS(2202),
    [anon_sym_noreturn] = ACTIONS(2202),
    [anon_sym_alignas] = ACTIONS(2202),
    [anon_sym__Alignas] = ACTIONS(2202),
    [sym_primitive_type] = ACTIONS(2202),
    [anon_sym_enum] = ACTIONS(2202),
    [anon_sym_struct] = ACTIONS(2202),
    [anon_sym_union] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2202),
    [anon_sym_hitAttributeEXT] = ACTIONS(2202),
    [anon_sym_callableDataEXT] = ACTIONS(2202),
    [anon_sym_callableDataInEXT] = ACTIONS(2202),
    [anon_sym_shaderRecordEXT] = ACTIONS(2202),
    [anon_sym_rayPayloadNV] = ACTIONS(2202),
    [anon_sym_rayPayloadInNV] = ACTIONS(2202),
    [anon_sym_hitAttributeNV] = ACTIONS(2202),
    [anon_sym_callableDataNV] = ACTIONS(2202),
    [anon_sym_callableDataInNV] = ACTIONS(2202),
    [anon_sym_shaderRecordNV] = ACTIONS(2202),
    [anon_sym_layout] = ACTIONS(2202),
  },
  [622] = {
    [sym_type_qualifier] = STATE(632),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1214),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(632),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [623] = {
    [sym_type_qualifier] = STATE(631),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1220),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(631),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_RBRACK] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [sym_type_qualifier] = STATE(847),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1223),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(847),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_type_qualifier] = STATE(847),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1209),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(847),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [626] = {
    [sym_type_qualifier] = STATE(625),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1212),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(625),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_RBRACK] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [627] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1311),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_variadic_parameter] = STATE(1883),
    [sym_parameter_declaration] = STATE(1883),
    [sym_macro_type_specifier] = STATE(980),
    [sym_layout_specification] = STATE(643),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_parameter_declaration_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1744),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_precise] = ACTIONS(1752),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_out] = ACTIONS(1752),
    [anon_sym_inout] = ACTIONS(1752),
    [anon_sym_uniform] = ACTIONS(1752),
    [anon_sym_shared] = ACTIONS(1752),
    [anon_sym_attribute] = ACTIONS(1752),
    [anon_sym_varying] = ACTIONS(1752),
    [anon_sym_buffer] = ACTIONS(1752),
    [anon_sym_coherent] = ACTIONS(1752),
    [anon_sym_readonly] = ACTIONS(1752),
    [anon_sym_writeonly] = ACTIONS(1752),
    [anon_sym_centroid] = ACTIONS(1752),
    [anon_sym_sample] = ACTIONS(1752),
    [anon_sym_patch] = ACTIONS(1752),
    [anon_sym_smooth] = ACTIONS(1752),
    [anon_sym_flat] = ACTIONS(1752),
    [anon_sym_noperspective] = ACTIONS(1752),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_layout] = ACTIONS(1758),
  },
  [628] = {
    [sym_type_qualifier] = STATE(624),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1216),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(624),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_RBRACK] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [629] = {
    [sym_type_qualifier] = STATE(847),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1206),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(847),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [630] = {
    [sym_type_qualifier] = STATE(629),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1208),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(629),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [sym_type_qualifier] = STATE(847),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1219),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(847),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [632] = {
    [sym_type_qualifier] = STATE(847),
    [sym_alignas_qualifier] = STATE(899),
    [sym_expression] = STATE(1205),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1045),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1045),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_array_declarator_repeat1] = STATE(847),
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2278),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_RBRACK] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2290),
    [anon_sym__Alignas] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [633] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1311),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_variadic_parameter] = STATE(2054),
    [sym_parameter_declaration] = STATE(2054),
    [sym_macro_type_specifier] = STATE(980),
    [sym_layout_specification] = STATE(643),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_parameter_declaration_repeat1] = STATE(643),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1744),
    [anon_sym_precise] = ACTIONS(1752),
    [anon_sym_in] = ACTIONS(1752),
    [anon_sym_out] = ACTIONS(1752),
    [anon_sym_inout] = ACTIONS(1752),
    [anon_sym_uniform] = ACTIONS(1752),
    [anon_sym_shared] = ACTIONS(1752),
    [anon_sym_attribute] = ACTIONS(1752),
    [anon_sym_varying] = ACTIONS(1752),
    [anon_sym_buffer] = ACTIONS(1752),
    [anon_sym_coherent] = ACTIONS(1752),
    [anon_sym_readonly] = ACTIONS(1752),
    [anon_sym_writeonly] = ACTIONS(1752),
    [anon_sym_centroid] = ACTIONS(1752),
    [anon_sym_sample] = ACTIONS(1752),
    [anon_sym_patch] = ACTIONS(1752),
    [anon_sym_smooth] = ACTIONS(1752),
    [anon_sym_flat] = ACTIONS(1752),
    [anon_sym_noperspective] = ACTIONS(1752),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_layout] = ACTIONS(1758),
  },
  [634] = {
    [sym_extension_storage_class] = STATE(634),
    [sym_layout_specification] = STATE(634),
    [aux_sym_declaration_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_subroutine] = ACTIONS(2342),
    [anon_sym_invariant] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_attribute] = ACTIONS(2342),
    [anon_sym_varying] = ACTIONS(2342),
    [anon_sym_buffer] = ACTIONS(2342),
    [anon_sym_coherent] = ACTIONS(2342),
    [anon_sym_readonly] = ACTIONS(2342),
    [anon_sym_writeonly] = ACTIONS(2342),
    [anon_sym_precision] = ACTIONS(2342),
    [anon_sym_highp] = ACTIONS(2342),
    [anon_sym_mediump] = ACTIONS(2342),
    [anon_sym_lowp] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_patch] = ACTIONS(2342),
    [anon_sym_smooth] = ACTIONS(2342),
    [anon_sym_flat] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym___extension__] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym___attribute__] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2345),
    [anon_sym___declspec] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2340),
    [anon_sym_unsigned] = ACTIONS(2340),
    [anon_sym_long] = ACTIONS(2340),
    [anon_sym_short] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_auto] = ACTIONS(2340),
    [anon_sym_register] = ACTIONS(2340),
    [anon_sym_inline] = ACTIONS(2340),
    [anon_sym___inline] = ACTIONS(2340),
    [anon_sym___inline__] = ACTIONS(2340),
    [anon_sym___forceinline] = ACTIONS(2340),
    [anon_sym_thread_local] = ACTIONS(2340),
    [anon_sym___thread] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_constexpr] = ACTIONS(2340),
    [anon_sym_volatile] = ACTIONS(2340),
    [anon_sym_restrict] = ACTIONS(2340),
    [anon_sym___restrict__] = ACTIONS(2340),
    [anon_sym__Atomic] = ACTIONS(2340),
    [anon_sym__Noreturn] = ACTIONS(2340),
    [anon_sym_noreturn] = ACTIONS(2340),
    [anon_sym_alignas] = ACTIONS(2340),
    [anon_sym__Alignas] = ACTIONS(2340),
    [sym_primitive_type] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2340),
    [anon_sym_union] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2347),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2347),
    [anon_sym_hitAttributeEXT] = ACTIONS(2347),
    [anon_sym_callableDataEXT] = ACTIONS(2347),
    [anon_sym_callableDataInEXT] = ACTIONS(2347),
    [anon_sym_shaderRecordEXT] = ACTIONS(2347),
    [anon_sym_rayPayloadNV] = ACTIONS(2347),
    [anon_sym_rayPayloadInNV] = ACTIONS(2347),
    [anon_sym_hitAttributeNV] = ACTIONS(2347),
    [anon_sym_callableDataNV] = ACTIONS(2347),
    [anon_sym_callableDataInNV] = ACTIONS(2347),
    [anon_sym_shaderRecordNV] = ACTIONS(2347),
    [anon_sym_layout] = ACTIONS(2350),
  },
  [635] = {
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_subroutine] = ACTIONS(2353),
    [anon_sym_invariant] = ACTIONS(2353),
    [anon_sym_precise] = ACTIONS(2353),
    [anon_sym_in] = ACTIONS(2353),
    [anon_sym_out] = ACTIONS(2353),
    [anon_sym_inout] = ACTIONS(2353),
    [anon_sym_uniform] = ACTIONS(2353),
    [anon_sym_shared] = ACTIONS(2353),
    [anon_sym_attribute] = ACTIONS(2353),
    [anon_sym_varying] = ACTIONS(2353),
    [anon_sym_buffer] = ACTIONS(2353),
    [anon_sym_coherent] = ACTIONS(2353),
    [anon_sym_readonly] = ACTIONS(2353),
    [anon_sym_writeonly] = ACTIONS(2353),
    [anon_sym_precision] = ACTIONS(2353),
    [anon_sym_highp] = ACTIONS(2353),
    [anon_sym_mediump] = ACTIONS(2353),
    [anon_sym_lowp] = ACTIONS(2353),
    [anon_sym_centroid] = ACTIONS(2353),
    [anon_sym_sample] = ACTIONS(2353),
    [anon_sym_patch] = ACTIONS(2353),
    [anon_sym_smooth] = ACTIONS(2353),
    [anon_sym_flat] = ACTIONS(2353),
    [anon_sym_noperspective] = ACTIONS(2353),
    [anon_sym___extension__] = ACTIONS(2353),
    [anon_sym_extern] = ACTIONS(2353),
    [anon_sym___attribute__] = ACTIONS(2353),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2355),
    [anon_sym___declspec] = ACTIONS(2353),
    [anon_sym_signed] = ACTIONS(2353),
    [anon_sym_unsigned] = ACTIONS(2353),
    [anon_sym_long] = ACTIONS(2353),
    [anon_sym_short] = ACTIONS(2353),
    [anon_sym_static] = ACTIONS(2353),
    [anon_sym_auto] = ACTIONS(2353),
    [anon_sym_register] = ACTIONS(2353),
    [anon_sym_inline] = ACTIONS(2353),
    [anon_sym___inline] = ACTIONS(2353),
    [anon_sym___inline__] = ACTIONS(2353),
    [anon_sym___forceinline] = ACTIONS(2353),
    [anon_sym_thread_local] = ACTIONS(2353),
    [anon_sym___thread] = ACTIONS(2353),
    [anon_sym_const] = ACTIONS(2353),
    [anon_sym_constexpr] = ACTIONS(2353),
    [anon_sym_volatile] = ACTIONS(2353),
    [anon_sym_restrict] = ACTIONS(2353),
    [anon_sym___restrict__] = ACTIONS(2353),
    [anon_sym__Atomic] = ACTIONS(2353),
    [anon_sym__Noreturn] = ACTIONS(2353),
    [anon_sym_noreturn] = ACTIONS(2353),
    [anon_sym_alignas] = ACTIONS(2353),
    [anon_sym__Alignas] = ACTIONS(2353),
    [sym_primitive_type] = ACTIONS(2353),
    [anon_sym_enum] = ACTIONS(2353),
    [anon_sym_struct] = ACTIONS(2353),
    [anon_sym_union] = ACTIONS(2353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2353),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2353),
    [anon_sym_hitAttributeEXT] = ACTIONS(2353),
    [anon_sym_callableDataEXT] = ACTIONS(2353),
    [anon_sym_callableDataInEXT] = ACTIONS(2353),
    [anon_sym_shaderRecordEXT] = ACTIONS(2353),
    [anon_sym_rayPayloadNV] = ACTIONS(2353),
    [anon_sym_rayPayloadInNV] = ACTIONS(2353),
    [anon_sym_hitAttributeNV] = ACTIONS(2353),
    [anon_sym_callableDataNV] = ACTIONS(2353),
    [anon_sym_callableDataInNV] = ACTIONS(2353),
    [anon_sym_shaderRecordNV] = ACTIONS(2353),
    [anon_sym_layout] = ACTIONS(2353),
  },
  [636] = {
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1793),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym___attribute__] = ACTIONS(1793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(1793),
    [anon_sym_signed] = ACTIONS(1793),
    [anon_sym_unsigned] = ACTIONS(1793),
    [anon_sym_long] = ACTIONS(1793),
    [anon_sym_short] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_auto] = ACTIONS(1793),
    [anon_sym_register] = ACTIONS(1793),
    [anon_sym_inline] = ACTIONS(1793),
    [anon_sym___inline] = ACTIONS(1793),
    [anon_sym___inline__] = ACTIONS(1793),
    [anon_sym___forceinline] = ACTIONS(1793),
    [anon_sym_thread_local] = ACTIONS(1793),
    [anon_sym___thread] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_constexpr] = ACTIONS(1793),
    [anon_sym_volatile] = ACTIONS(1793),
    [anon_sym_restrict] = ACTIONS(1793),
    [anon_sym___restrict__] = ACTIONS(1793),
    [anon_sym__Atomic] = ACTIONS(1793),
    [anon_sym__Noreturn] = ACTIONS(1793),
    [anon_sym_noreturn] = ACTIONS(1793),
    [anon_sym_alignas] = ACTIONS(1793),
    [anon_sym__Alignas] = ACTIONS(1793),
    [sym_primitive_type] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1793),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym___attribute__] = ACTIONS(1793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(1793),
    [anon_sym_signed] = ACTIONS(1793),
    [anon_sym_unsigned] = ACTIONS(1793),
    [anon_sym_long] = ACTIONS(1793),
    [anon_sym_short] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_auto] = ACTIONS(1793),
    [anon_sym_register] = ACTIONS(1793),
    [anon_sym_inline] = ACTIONS(1793),
    [anon_sym___inline] = ACTIONS(1793),
    [anon_sym___inline__] = ACTIONS(1793),
    [anon_sym___forceinline] = ACTIONS(1793),
    [anon_sym_thread_local] = ACTIONS(1793),
    [anon_sym___thread] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_constexpr] = ACTIONS(1793),
    [anon_sym_volatile] = ACTIONS(1793),
    [anon_sym_restrict] = ACTIONS(1793),
    [anon_sym___restrict__] = ACTIONS(1793),
    [anon_sym__Atomic] = ACTIONS(1793),
    [anon_sym__Noreturn] = ACTIONS(1793),
    [anon_sym_noreturn] = ACTIONS(1793),
    [anon_sym_alignas] = ACTIONS(1793),
    [anon_sym__Alignas] = ACTIONS(1793),
    [sym_primitive_type] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [638] = {
    [sym_identifier] = ACTIONS(2365),
    [anon_sym_subroutine] = ACTIONS(2365),
    [anon_sym_invariant] = ACTIONS(2365),
    [anon_sym_precise] = ACTIONS(2365),
    [anon_sym_in] = ACTIONS(2365),
    [anon_sym_out] = ACTIONS(2365),
    [anon_sym_inout] = ACTIONS(2365),
    [anon_sym_uniform] = ACTIONS(2365),
    [anon_sym_shared] = ACTIONS(2365),
    [anon_sym_attribute] = ACTIONS(2365),
    [anon_sym_varying] = ACTIONS(2365),
    [anon_sym_buffer] = ACTIONS(2365),
    [anon_sym_coherent] = ACTIONS(2365),
    [anon_sym_readonly] = ACTIONS(2365),
    [anon_sym_writeonly] = ACTIONS(2365),
    [anon_sym_precision] = ACTIONS(2365),
    [anon_sym_highp] = ACTIONS(2365),
    [anon_sym_mediump] = ACTIONS(2365),
    [anon_sym_lowp] = ACTIONS(2365),
    [anon_sym_centroid] = ACTIONS(2365),
    [anon_sym_sample] = ACTIONS(2365),
    [anon_sym_patch] = ACTIONS(2365),
    [anon_sym_smooth] = ACTIONS(2365),
    [anon_sym_flat] = ACTIONS(2365),
    [anon_sym_noperspective] = ACTIONS(2365),
    [anon_sym___extension__] = ACTIONS(2365),
    [anon_sym_extern] = ACTIONS(2365),
    [anon_sym___attribute__] = ACTIONS(2365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2367),
    [anon_sym___declspec] = ACTIONS(2365),
    [anon_sym_signed] = ACTIONS(2365),
    [anon_sym_unsigned] = ACTIONS(2365),
    [anon_sym_long] = ACTIONS(2365),
    [anon_sym_short] = ACTIONS(2365),
    [anon_sym_static] = ACTIONS(2365),
    [anon_sym_auto] = ACTIONS(2365),
    [anon_sym_register] = ACTIONS(2365),
    [anon_sym_inline] = ACTIONS(2365),
    [anon_sym___inline] = ACTIONS(2365),
    [anon_sym___inline__] = ACTIONS(2365),
    [anon_sym___forceinline] = ACTIONS(2365),
    [anon_sym_thread_local] = ACTIONS(2365),
    [anon_sym___thread] = ACTIONS(2365),
    [anon_sym_const] = ACTIONS(2365),
    [anon_sym_constexpr] = ACTIONS(2365),
    [anon_sym_volatile] = ACTIONS(2365),
    [anon_sym_restrict] = ACTIONS(2365),
    [anon_sym___restrict__] = ACTIONS(2365),
    [anon_sym__Atomic] = ACTIONS(2365),
    [anon_sym__Noreturn] = ACTIONS(2365),
    [anon_sym_noreturn] = ACTIONS(2365),
    [anon_sym_alignas] = ACTIONS(2365),
    [anon_sym__Alignas] = ACTIONS(2365),
    [sym_primitive_type] = ACTIONS(2365),
    [anon_sym_enum] = ACTIONS(2365),
    [anon_sym_struct] = ACTIONS(2365),
    [anon_sym_union] = ACTIONS(2365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2365),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2365),
    [anon_sym_hitAttributeEXT] = ACTIONS(2365),
    [anon_sym_callableDataEXT] = ACTIONS(2365),
    [anon_sym_callableDataInEXT] = ACTIONS(2365),
    [anon_sym_shaderRecordEXT] = ACTIONS(2365),
    [anon_sym_rayPayloadNV] = ACTIONS(2365),
    [anon_sym_rayPayloadInNV] = ACTIONS(2365),
    [anon_sym_hitAttributeNV] = ACTIONS(2365),
    [anon_sym_callableDataNV] = ACTIONS(2365),
    [anon_sym_callableDataInNV] = ACTIONS(2365),
    [anon_sym_shaderRecordNV] = ACTIONS(2365),
    [anon_sym_layout] = ACTIONS(2365),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1793),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym___attribute__] = ACTIONS(1793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(1793),
    [anon_sym_signed] = ACTIONS(1793),
    [anon_sym_unsigned] = ACTIONS(1793),
    [anon_sym_long] = ACTIONS(1793),
    [anon_sym_short] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_auto] = ACTIONS(1793),
    [anon_sym_register] = ACTIONS(1793),
    [anon_sym_inline] = ACTIONS(1793),
    [anon_sym___inline] = ACTIONS(1793),
    [anon_sym___inline__] = ACTIONS(1793),
    [anon_sym___forceinline] = ACTIONS(1793),
    [anon_sym_thread_local] = ACTIONS(1793),
    [anon_sym___thread] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_constexpr] = ACTIONS(1793),
    [anon_sym_volatile] = ACTIONS(1793),
    [anon_sym_restrict] = ACTIONS(1793),
    [anon_sym___restrict__] = ACTIONS(1793),
    [anon_sym__Atomic] = ACTIONS(1793),
    [anon_sym__Noreturn] = ACTIONS(1793),
    [anon_sym_noreturn] = ACTIONS(1793),
    [anon_sym_alignas] = ACTIONS(1793),
    [anon_sym__Alignas] = ACTIONS(1793),
    [sym_primitive_type] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [640] = {
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_subroutine] = ACTIONS(2372),
    [anon_sym_invariant] = ACTIONS(2372),
    [anon_sym_precise] = ACTIONS(2372),
    [anon_sym_in] = ACTIONS(2372),
    [anon_sym_out] = ACTIONS(2372),
    [anon_sym_inout] = ACTIONS(2372),
    [anon_sym_uniform] = ACTIONS(2372),
    [anon_sym_shared] = ACTIONS(2372),
    [anon_sym_attribute] = ACTIONS(2372),
    [anon_sym_varying] = ACTIONS(2372),
    [anon_sym_buffer] = ACTIONS(2372),
    [anon_sym_coherent] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_writeonly] = ACTIONS(2372),
    [anon_sym_precision] = ACTIONS(2372),
    [anon_sym_highp] = ACTIONS(2372),
    [anon_sym_mediump] = ACTIONS(2372),
    [anon_sym_lowp] = ACTIONS(2372),
    [anon_sym_centroid] = ACTIONS(2372),
    [anon_sym_sample] = ACTIONS(2372),
    [anon_sym_patch] = ACTIONS(2372),
    [anon_sym_smooth] = ACTIONS(2372),
    [anon_sym_flat] = ACTIONS(2372),
    [anon_sym_noperspective] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2372),
    [anon_sym_extern] = ACTIONS(2372),
    [anon_sym___attribute__] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2374),
    [anon_sym___declspec] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2372),
    [anon_sym_unsigned] = ACTIONS(2372),
    [anon_sym_long] = ACTIONS(2372),
    [anon_sym_short] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_auto] = ACTIONS(2372),
    [anon_sym_register] = ACTIONS(2372),
    [anon_sym_inline] = ACTIONS(2372),
    [anon_sym___inline] = ACTIONS(2372),
    [anon_sym___inline__] = ACTIONS(2372),
    [anon_sym___forceinline] = ACTIONS(2372),
    [anon_sym_thread_local] = ACTIONS(2372),
    [anon_sym___thread] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_constexpr] = ACTIONS(2372),
    [anon_sym_volatile] = ACTIONS(2372),
    [anon_sym_restrict] = ACTIONS(2372),
    [anon_sym___restrict__] = ACTIONS(2372),
    [anon_sym__Atomic] = ACTIONS(2372),
    [anon_sym__Noreturn] = ACTIONS(2372),
    [anon_sym_noreturn] = ACTIONS(2372),
    [anon_sym_alignas] = ACTIONS(2372),
    [anon_sym__Alignas] = ACTIONS(2372),
    [sym_primitive_type] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
    [anon_sym_struct] = ACTIONS(2372),
    [anon_sym_union] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2372),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2372),
    [anon_sym_hitAttributeEXT] = ACTIONS(2372),
    [anon_sym_callableDataEXT] = ACTIONS(2372),
    [anon_sym_callableDataInEXT] = ACTIONS(2372),
    [anon_sym_shaderRecordEXT] = ACTIONS(2372),
    [anon_sym_rayPayloadNV] = ACTIONS(2372),
    [anon_sym_rayPayloadInNV] = ACTIONS(2372),
    [anon_sym_hitAttributeNV] = ACTIONS(2372),
    [anon_sym_callableDataNV] = ACTIONS(2372),
    [anon_sym_callableDataInNV] = ACTIONS(2372),
    [anon_sym_shaderRecordNV] = ACTIONS(2372),
    [anon_sym_layout] = ACTIONS(2372),
  },
  [641] = {
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1793),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym___attribute__] = ACTIONS(1793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(1793),
    [anon_sym_signed] = ACTIONS(1793),
    [anon_sym_unsigned] = ACTIONS(1793),
    [anon_sym_long] = ACTIONS(1793),
    [anon_sym_short] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_auto] = ACTIONS(1793),
    [anon_sym_register] = ACTIONS(1793),
    [anon_sym_inline] = ACTIONS(1793),
    [anon_sym___inline] = ACTIONS(1793),
    [anon_sym___inline__] = ACTIONS(1793),
    [anon_sym___forceinline] = ACTIONS(1793),
    [anon_sym_thread_local] = ACTIONS(1793),
    [anon_sym___thread] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_constexpr] = ACTIONS(1793),
    [anon_sym_volatile] = ACTIONS(1793),
    [anon_sym_restrict] = ACTIONS(1793),
    [anon_sym___restrict__] = ACTIONS(1793),
    [anon_sym__Atomic] = ACTIONS(1793),
    [anon_sym__Noreturn] = ACTIONS(1793),
    [anon_sym_noreturn] = ACTIONS(1793),
    [anon_sym_alignas] = ACTIONS(1793),
    [anon_sym__Alignas] = ACTIONS(1793),
    [sym_primitive_type] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [642] = {
    [sym_identifier] = ACTIONS(2379),
    [anon_sym_subroutine] = ACTIONS(1793),
    [anon_sym_invariant] = ACTIONS(1793),
    [anon_sym_precise] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_out] = ACTIONS(1793),
    [anon_sym_inout] = ACTIONS(1793),
    [anon_sym_uniform] = ACTIONS(1793),
    [anon_sym_shared] = ACTIONS(1793),
    [anon_sym_attribute] = ACTIONS(1793),
    [anon_sym_varying] = ACTIONS(1793),
    [anon_sym_buffer] = ACTIONS(1793),
    [anon_sym_coherent] = ACTIONS(1793),
    [anon_sym_readonly] = ACTIONS(1793),
    [anon_sym_writeonly] = ACTIONS(1793),
    [anon_sym_precision] = ACTIONS(1793),
    [anon_sym_highp] = ACTIONS(1793),
    [anon_sym_mediump] = ACTIONS(1793),
    [anon_sym_lowp] = ACTIONS(1793),
    [anon_sym_centroid] = ACTIONS(1793),
    [anon_sym_sample] = ACTIONS(1793),
    [anon_sym_patch] = ACTIONS(1793),
    [anon_sym_smooth] = ACTIONS(1793),
    [anon_sym_flat] = ACTIONS(1793),
    [anon_sym_noperspective] = ACTIONS(1793),
    [anon_sym___extension__] = ACTIONS(1793),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym___attribute__] = ACTIONS(1793),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(1793),
    [anon_sym_signed] = ACTIONS(1793),
    [anon_sym_unsigned] = ACTIONS(1793),
    [anon_sym_long] = ACTIONS(1793),
    [anon_sym_short] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_auto] = ACTIONS(1793),
    [anon_sym_register] = ACTIONS(1793),
    [anon_sym_inline] = ACTIONS(1793),
    [anon_sym___inline] = ACTIONS(1793),
    [anon_sym___inline__] = ACTIONS(1793),
    [anon_sym___forceinline] = ACTIONS(1793),
    [anon_sym_thread_local] = ACTIONS(1793),
    [anon_sym___thread] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_constexpr] = ACTIONS(1793),
    [anon_sym_volatile] = ACTIONS(1793),
    [anon_sym_restrict] = ACTIONS(1793),
    [anon_sym___restrict__] = ACTIONS(1793),
    [anon_sym__Atomic] = ACTIONS(1793),
    [anon_sym__Noreturn] = ACTIONS(1793),
    [anon_sym_noreturn] = ACTIONS(1793),
    [anon_sym_alignas] = ACTIONS(1793),
    [anon_sym__Alignas] = ACTIONS(1793),
    [sym_primitive_type] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadInEXT] = ACTIONS(1793),
    [anon_sym_hitAttributeEXT] = ACTIONS(1793),
    [anon_sym_callableDataEXT] = ACTIONS(1793),
    [anon_sym_callableDataInEXT] = ACTIONS(1793),
    [anon_sym_shaderRecordEXT] = ACTIONS(1793),
    [anon_sym_rayPayloadNV] = ACTIONS(1793),
    [anon_sym_rayPayloadInNV] = ACTIONS(1793),
    [anon_sym_hitAttributeNV] = ACTIONS(1793),
    [anon_sym_callableDataNV] = ACTIONS(1793),
    [anon_sym_callableDataInNV] = ACTIONS(1793),
    [anon_sym_shaderRecordNV] = ACTIONS(1793),
    [anon_sym_layout] = ACTIONS(1793),
  },
  [643] = {
    [sym__declaration_modifiers] = STATE(902),
    [sym__declaration_specifiers] = STATE(1314),
    [sym_attribute_specifier] = STATE(902),
    [sym_attribute_declaration] = STATE(902),
    [sym_ms_declspec_modifier] = STATE(902),
    [sym_storage_class_specifier] = STATE(902),
    [sym_type_qualifier] = STATE(902),
    [sym_alignas_qualifier] = STATE(904),
    [sym_type_specifier] = STATE(911),
    [sym_sized_type_specifier] = STATE(980),
    [sym_enum_specifier] = STATE(980),
    [sym_struct_specifier] = STATE(980),
    [sym_union_specifier] = STATE(980),
    [sym_macro_type_specifier] = STATE(980),
    [sym_layout_specification] = STATE(837),
    [aux_sym__declaration_specifiers_repeat1] = STATE(902),
    [aux_sym_sized_type_specifier_repeat1] = STATE(975),
    [aux_sym_parameter_declaration_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_attribute] = ACTIONS(2382),
    [anon_sym_varying] = ACTIONS(2382),
    [anon_sym_buffer] = ACTIONS(2382),
    [anon_sym_coherent] = ACTIONS(2382),
    [anon_sym_readonly] = ACTIONS(2382),
    [anon_sym_writeonly] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_patch] = ACTIONS(2382),
    [anon_sym_smooth] = ACTIONS(2382),
    [anon_sym_flat] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym___extension__] = ACTIONS(53),
    [anon_sym_extern] = ACTIONS(51),
    [anon_sym___attribute__] = ACTIONS(39),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1225),
    [anon_sym___declspec] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(49),
    [anon_sym_unsigned] = ACTIONS(49),
    [anon_sym_long] = ACTIONS(49),
    [anon_sym_short] = ACTIONS(49),
    [anon_sym_static] = ACTIONS(51),
    [anon_sym_auto] = ACTIONS(51),
    [anon_sym_register] = ACTIONS(51),
    [anon_sym_inline] = ACTIONS(51),
    [anon_sym___inline] = ACTIONS(51),
    [anon_sym___inline__] = ACTIONS(51),
    [anon_sym___forceinline] = ACTIONS(51),
    [anon_sym_thread_local] = ACTIONS(51),
    [anon_sym___thread] = ACTIONS(51),
    [anon_sym_const] = ACTIONS(53),
    [anon_sym_constexpr] = ACTIONS(53),
    [anon_sym_volatile] = ACTIONS(53),
    [anon_sym_restrict] = ACTIONS(53),
    [anon_sym___restrict__] = ACTIONS(53),
    [anon_sym__Atomic] = ACTIONS(53),
    [anon_sym__Noreturn] = ACTIONS(53),
    [anon_sym_noreturn] = ACTIONS(53),
    [anon_sym_alignas] = ACTIONS(55),
    [anon_sym__Alignas] = ACTIONS(55),
    [sym_primitive_type] = ACTIONS(57),
    [anon_sym_enum] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [anon_sym_layout] = ACTIONS(1758),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_subroutine] = ACTIONS(2384),
    [anon_sym_invariant] = ACTIONS(2384),
    [anon_sym_precise] = ACTIONS(2384),
    [anon_sym_in] = ACTIONS(2384),
    [anon_sym_out] = ACTIONS(2384),
    [anon_sym_inout] = ACTIONS(2384),
    [anon_sym_uniform] = ACTIONS(2384),
    [anon_sym_shared] = ACTIONS(2384),
    [anon_sym_attribute] = ACTIONS(2384),
    [anon_sym_varying] = ACTIONS(2384),
    [anon_sym_buffer] = ACTIONS(2384),
    [anon_sym_coherent] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_writeonly] = ACTIONS(2384),
    [anon_sym_precision] = ACTIONS(2384),
    [anon_sym_highp] = ACTIONS(2384),
    [anon_sym_mediump] = ACTIONS(2384),
    [anon_sym_lowp] = ACTIONS(2384),
    [anon_sym_centroid] = ACTIONS(2384),
    [anon_sym_sample] = ACTIONS(2384),
    [anon_sym_patch] = ACTIONS(2384),
    [anon_sym_smooth] = ACTIONS(2384),
    [anon_sym_flat] = ACTIONS(2384),
    [anon_sym_noperspective] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_auto] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_rayPayloadEXT] = ACTIONS(2384),
    [anon_sym_rayPayloadInEXT] = ACTIONS(2384),
    [anon_sym_hitAttributeEXT] = ACTIONS(2384),
    [anon_sym_callableDataEXT] = ACTIONS(2384),
    [anon_sym_callableDataInEXT] = ACTIONS(2384),
    [anon_sym_shaderRecordEXT] = ACTIONS(2384),
    [anon_sym_rayPayloadNV] = ACTIONS(2384),
    [anon_sym_rayPayloadInNV] = ACTIONS(2384),
    [anon_sym_hitAttributeNV] = ACTIONS(2384),
    [anon_sym_callableDataNV] = ACTIONS(2384),
    [anon_sym_callableDataInNV] = ACTIONS(2384),
    [anon_sym_shaderRecordNV] = ACTIONS(2384),
    [anon_sym_layout] = ACTIONS(2384),
  },
  [645] = {
    [sym_expression] = STATE(1149),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_initializer_list] = STATE(1834),
    [sym_initializer_pair] = STATE(1834),
    [sym_subscript_designator] = STATE(1676),
    [sym_subscript_range_designator] = STATE(1676),
    [sym_field_designator] = STATE(1676),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_initializer_pair_repeat1] = STATE(1676),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [646] = {
    [sym_expression] = STATE(1175),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_initializer_list] = STATE(2039),
    [sym_initializer_pair] = STATE(2039),
    [sym_subscript_designator] = STATE(1676),
    [sym_subscript_range_designator] = STATE(1676),
    [sym_field_designator] = STATE(1676),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_initializer_pair_repeat1] = STATE(1676),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [647] = {
    [sym_expression] = STATE(1175),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_initializer_list] = STATE(2039),
    [sym_initializer_pair] = STATE(2039),
    [sym_subscript_designator] = STATE(1676),
    [sym_subscript_range_designator] = STATE(1676),
    [sym_field_designator] = STATE(1676),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_initializer_pair_repeat1] = STATE(1676),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [sym_expression] = STATE(1175),
    [sym__string] = STATE(864),
    [sym_conditional_expression] = STATE(864),
    [sym_assignment_expression] = STATE(864),
    [sym_pointer_expression] = STATE(1002),
    [sym_unary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_update_expression] = STATE(864),
    [sym_cast_expression] = STATE(864),
    [sym_sizeof_expression] = STATE(864),
    [sym_alignof_expression] = STATE(864),
    [sym_offsetof_expression] = STATE(864),
    [sym_generic_expression] = STATE(864),
    [sym_subscript_expression] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_gnu_asm_expression] = STATE(864),
    [sym_field_expression] = STATE(1002),
    [sym_compound_literal_expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(1002),
    [sym_initializer_list] = STATE(2039),
    [sym_initializer_pair] = STATE(2039),
    [sym_subscript_designator] = STATE(1676),
    [sym_subscript_range_designator] = STATE(1676),
    [sym_field_designator] = STATE(1676),
    [sym_char_literal] = STATE(864),
    [sym_concatenated_string] = STATE(864),
    [sym_string_literal] = STATE(849),
    [sym_null] = STATE(864),
    [aux_sym_initializer_pair_repeat1] = STATE(1676),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1768),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(87),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_sizeof] = ACTIONS(89),
    [anon_sym___alignof__] = ACTIONS(91),
    [anon_sym___alignof] = ACTIONS(91),
    [anon_sym__alignof] = ACTIONS(91),
    [anon_sym_alignof] = ACTIONS(91),
    [anon_sym__Alignof] = ACTIONS(91),
    [anon_sym_offsetof] = ACTIONS(93),
    [anon_sym__Generic] = ACTIONS(95),
    [anon_sym_asm] = ACTIONS(97),
    [anon_sym___asm__] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(175),
    [anon_sym_L_SQUOTE] = ACTIONS(101),
    [anon_sym_u_SQUOTE] = ACTIONS(101),
    [anon_sym_U_SQUOTE] = ACTIONS(101),
    [anon_sym_u8_SQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_L_DQUOTE] = ACTIONS(103),
    [anon_sym_u_DQUOTE] = ACTIONS(103),
    [anon_sym_U_DQUOTE] = ACTIONS(103),
    [anon_sym_u8_DQUOTE] = ACTIONS(103),
    [anon_sym_DQUOTE] = ACTIONS(103),
    [sym_true] = ACTIONS(177),
    [sym_false] = ACTIONS(177),
    [anon_sym_NULL] = ACTIONS(107),
    [anon_sym_nullptr] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      anon_sym_RPAREN,
    ACTIONS(2404), 1,
      anon_sym___extension__,
    STATE(849), 1,
      sym_string_literal,
    STATE(1145), 1,
      sym_expression,
    STATE(2011), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [114] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    ACTIONS(2408), 1,
      anon_sym___extension__,
    STATE(849), 1,
      sym_string_literal,
    STATE(1144), 1,
      sym_expression,
    STATE(1944), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [228] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym___extension__,
    STATE(849), 1,
      sym_string_literal,
    STATE(1187), 1,
      sym_expression,
    STATE(2085), 1,
      sym_compound_statement,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [339] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1172), 1,
      sym_expression,
    STATE(2038), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [447] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(866), 1,
      sym_initializer_list,
    STATE(1019), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [555] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(866), 1,
      sym_initializer_list,
    STATE(877), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [663] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2420), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1165), 1,
      sym_expression,
    STATE(2102), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [771] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1163), 1,
      sym_expression,
    STATE(2206), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [879] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2424), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1160), 1,
      sym_expression,
    STATE(2208), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [987] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2426), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1194), 1,
      sym_expression,
    STATE(2111), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1095] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2428), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1190), 1,
      sym_expression,
    STATE(2170), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1203] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2430), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1154), 1,
      sym_expression,
    STATE(2279), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1311] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_const,
    ACTIONS(2143), 1,
      anon_sym_LPAREN2,
    ACTIONS(2149), 1,
      anon_sym_STAR,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    STATE(812), 1,
      sym_string_literal,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2168), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2432), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2152), 10,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 12,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [1401] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2434), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1171), 1,
      sym_expression,
    STATE(2112), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1509] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2436), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1155), 1,
      sym_expression,
    STATE(2270), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1617] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2438), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1181), 1,
      sym_expression,
    STATE(2183), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1725] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2440), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1192), 1,
      sym_expression,
    STATE(2312), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1833] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(866), 1,
      sym_initializer_list,
    STATE(877), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [1941] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2442), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1198), 1,
      sym_expression,
    STATE(2110), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2049] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2444), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1158), 1,
      sym_expression,
    STATE(2210), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2157] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1191), 1,
      sym_expression,
    STATE(2178), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2265] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2448), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1188), 1,
      sym_expression,
    STATE(2259), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2373] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_RPAREN,
    STATE(849), 1,
      sym_string_literal,
    STATE(1176), 1,
      sym_expression,
    STATE(2257), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2481] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2452), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1197), 1,
      sym_expression,
    STATE(2221), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2589] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(866), 1,
      sym_initializer_list,
    STATE(1019), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2697] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1180), 1,
      sym_expression,
    STATE(2040), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2805] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2454), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1159), 1,
      sym_expression,
    STATE(2357), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [2913] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(866), 1,
      sym_initializer_list,
    STATE(877), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3021] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(866), 1,
      sym_initializer_list,
    STATE(877), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3129] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2468), 1,
      anon_sym_COLON,
    STATE(849), 1,
      sym_string_literal,
    STATE(1183), 1,
      sym_expression,
    STATE(2147), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3237] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1768), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1174), 1,
      sym_expression,
    STATE(2051), 1,
      sym_initializer_list,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3345] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2470), 1,
      anon_sym_SEMI,
    STATE(849), 1,
      sym_string_literal,
    STATE(1185), 1,
      sym_expression,
    STATE(2117), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2472), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3558] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2474), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3663] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2476), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3768] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2478), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3873] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2480), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [3978] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1179), 1,
      sym_expression,
    STATE(2372), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4083] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2482), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4188] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2484), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4293] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2486), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4398] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1162), 1,
      sym_expression,
    STATE(2295), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4503] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1134), 1,
      sym_expression,
    STATE(1968), 1,
      sym_comma_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4608] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2488), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4713] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    ACTIONS(2490), 1,
      anon_sym_RBRACK,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4818] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(999), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [4920] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1193), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5022] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(938), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5124] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(870), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5226] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(939), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5328] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2492), 1,
      anon_sym_LPAREN2,
    STATE(871), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5430] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(870), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5532] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(897), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5634] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(940), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5736] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(985), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5838] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(986), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [5940] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(995), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6042] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(952), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6144] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1204), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6246] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(958), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6348] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1164), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6450] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1203), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6552] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2494), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1029), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6654] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1030), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6756] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1035), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6858] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(897), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [6960] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(965), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7062] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(994), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7164] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1040), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7266] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1147), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7368] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(870), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7470] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2496), 1,
      anon_sym_LPAREN2,
    STATE(871), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7572] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1016), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7674] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1143), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7776] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1038), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7878] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1211), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [7980] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1221), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8082] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1036), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8184] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1034), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8286] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1202), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8388] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(941), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8490] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1031), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8592] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(942), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1021), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8796] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1033), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [8898] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1018), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9000] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1200), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1213), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9204] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1112), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9306] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1020), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9408] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(960), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9510] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(996), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9612] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(943), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9714] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1035), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9816] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1028), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [9918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1152), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10020] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(892), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10122] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1027), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10224] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(897), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10326] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(897), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10428] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1207), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10530] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    ACTIONS(2498), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(871), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10632] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(892), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10734] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1105), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10836] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(993), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [10938] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1150), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11040] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1091), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11142] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1102), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11244] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1199), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11346] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(870), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11448] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(884), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11550] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2500), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(871), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11652] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1770), 1,
      anon_sym_sizeof,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2464), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(935), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1764), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1766), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2466), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11754] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1161), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11856] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(988), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [11958] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      anon_sym_sizeof,
    ACTIONS(2412), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1017), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2103), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2105), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2414), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12060] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1098), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12162] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1109), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12264] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1201), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12366] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1094), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12468] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(884), 1,
      sym_expression,
    STATE(898), 1,
      sym_string_literal,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12570] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1153), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12672] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1168), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1020), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12876] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1178), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [12978] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1148), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13080] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1173), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13182] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1170), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13284] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1088), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13386] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1210), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13488] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1086), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13590] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1101), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13692] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1103), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13794] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(998), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13896] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1093), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [13998] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1030), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14100] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1167), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14202] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1100), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14304] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(884), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14406] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1156), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14508] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(987), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14610] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1095), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14712] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1184), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14814] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1217), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [14916] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1087), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15018] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2502), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1029), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15120] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2181), 1,
      anon_sym_sizeof,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2458), 1,
      anon_sym_LPAREN2,
    STATE(898), 1,
      sym_string_literal,
    STATE(1085), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2177), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2179), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2460), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2462), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(997), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15222] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1166), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15324] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(1772), 1,
      sym_identifier,
    ACTIONS(1778), 1,
      anon_sym_sizeof,
    ACTIONS(2416), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(992), 1,
      sym_expression,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(1774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1776), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2418), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(855), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15426] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2258), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_sizeof,
    ACTIONS(2278), 1,
      anon_sym_LPAREN2,
    STATE(849), 1,
      sym_string_literal,
    STATE(1186), 1,
      sym_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(2260), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2262), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2282), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(2292), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1045), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15528] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1218), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15630] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1107), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15732] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1110), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15834] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1111), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [15936] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1113), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16038] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1114), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16140] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1115), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16242] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1116), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16344] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1106), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16446] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1117), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16548] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_LPAREN2,
    ACTIONS(89), 1,
      anon_sym_sizeof,
    ACTIONS(93), 1,
      anon_sym_offsetof,
    ACTIONS(95), 1,
      anon_sym__Generic,
    ACTIONS(175), 1,
      sym_number_literal,
    ACTIONS(2166), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(884), 1,
      sym_expression,
    ACTIONS(21), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(23), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(25), 2,
      anon_sym_STAR,
      anon_sym_AMP,
    ACTIONS(87), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(107), 2,
      anon_sym_NULL,
      anon_sym_nullptr,
    ACTIONS(177), 2,
      sym_true,
      sym_false,
    ACTIONS(91), 5,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
    ACTIONS(101), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    STATE(1002), 5,
      sym_pointer_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_field_expression,
      sym_parenthesized_expression,
    STATE(864), 16,
      sym__string,
      sym_conditional_expression,
      sym_assignment_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_update_expression,
      sym_cast_expression,
      sym_sizeof_expression,
      sym_alignof_expression,
      sym_offsetof_expression,
      sym_generic_expression,
      sym_gnu_asm_expression,
      sym_compound_literal_expression,
      sym_char_literal,
      sym_concatenated_string,
      sym_null,
  [16650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      sym_identifier,
    STATE(811), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2508), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2506), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [16721] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      sym_identifier,
    STATE(811), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2517), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2515), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2513), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [16792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      sym_identifier,
    STATE(810), 2,
      sym_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2524), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2522), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [16863] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(868), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1382), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [16963] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(896), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1391), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2147), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2141), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [17131] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(874), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1383), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17231] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(878), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1402), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17331] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(876), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1379), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17431] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(881), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1374), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17531] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(872), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1410), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17631] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(888), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1376), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17731] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(869), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1398), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17831] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(880), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1411), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [17931] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(895), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1380), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18031] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(893), 1,
      sym_ms_call_modifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1389), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [18131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2276), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [18194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2272), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [18257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2528), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2532), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18381] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym___attribute__,
    ACTIONS(2547), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2550), 1,
      anon_sym___declspec,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(2553), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2536), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(830), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2538), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2541), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(2534), 17,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2558), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2562), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2566), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2570), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2574), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2578), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2587), 1,
      anon_sym_layout,
    STATE(837), 2,
      sym_layout_specification,
      aux_sym_parameter_declaration_repeat1,
    ACTIONS(2582), 18,
      anon_sym_precise,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_uniform,
      anon_sym_shared,
      anon_sym_attribute,
      anon_sym_varying,
      anon_sym_buffer,
      anon_sym_coherent,
      anon_sym_readonly,
      anon_sym_writeonly,
      anon_sym_centroid,
      anon_sym_sample,
      anon_sym_patch,
      anon_sym_smooth,
      anon_sym_flat,
      anon_sym_noperspective,
    ACTIONS(2580), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [18899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2592), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [18961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2596), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2367), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2365), 51,
      anon_sym_precise,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_uniform,
      anon_sym_shared,
      anon_sym_attribute,
      anon_sym_varying,
      anon_sym_buffer,
      anon_sym_coherent,
      anon_sym_readonly,
      anon_sym_writeonly,
      anon_sym_centroid,
      anon_sym_sample,
      anon_sym_patch,
      anon_sym_smooth,
      anon_sym_flat,
      anon_sym_noperspective,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      anon_sym_layout,
  [19083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2372), 51,
      anon_sym_precise,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_uniform,
      anon_sym_shared,
      anon_sym_attribute,
      anon_sym_varying,
      anon_sym_buffer,
      anon_sym_coherent,
      anon_sym_readonly,
      anon_sym_writeonly,
      anon_sym_centroid,
      anon_sym_sample,
      anon_sym_patch,
      anon_sym_smooth,
      anon_sym_flat,
      anon_sym_noperspective,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      anon_sym_layout,
  [19143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2353), 51,
      anon_sym_precise,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_uniform,
      anon_sym_shared,
      anon_sym_attribute,
      anon_sym_varying,
      anon_sym_buffer,
      anon_sym_coherent,
      anon_sym_readonly,
      anon_sym_writeonly,
      anon_sym_centroid,
      anon_sym_sample,
      anon_sym_patch,
      anon_sym_smooth,
      anon_sym_flat,
      anon_sym_noperspective,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      anon_sym_layout,
  [19203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2131), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [19262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2598), 42,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
  [19321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2602), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [19380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2604), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_static,
    STATE(899), 1,
      sym_alignas_qualifier,
    ACTIONS(2616), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(847), 2,
      sym_type_qualifier,
      aux_sym_array_declarator_repeat1,
    ACTIONS(2610), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2606), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(2608), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [19508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 21,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2135), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_while,
      anon_sym_do,
      anon_sym_for,
      anon_sym_return,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym___try,
      anon_sym___leave,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [19567] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      sym_identifier,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2623), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2621), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2627), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2631), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2635), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2639), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2643), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2141), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [19980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2647), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2651), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2655), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2659), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2663), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2667), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2671), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2675), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2141), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2679), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2683), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [20618] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1408), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [20707] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1409), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [20796] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1412), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [20885] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2685), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2687), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [20952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2697), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2699), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21019] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1381), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2703), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21165] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1401), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2707), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [21311] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1378), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21400] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2709), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2711), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [21467] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1394), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21556] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1377), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21645] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1400), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21734] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1397), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21823] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1388), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [21912] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1399), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2715), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [22068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2719), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [22125] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_EQ,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2723), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      sym_identifier,
    ACTIONS(2141), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [22190] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1405), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22279] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1385), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22368] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1396), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22457] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1375), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22546] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1384), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2725), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2727), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [22702] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1406), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2731), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [22848] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1392), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [22937] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(911), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1390), 1,
      sym__declaration_specifiers,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(902), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23026] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2733), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2735), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [23091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2623), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(2621), 28,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2737), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_static,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [23208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [23272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2743), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_RBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2741), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      anon_sym_static,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
  [23328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(59), 1,
      anon_sym_enum,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1557), 1,
      sym_identifier,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(915), 1,
      sym_type_specifier,
    STATE(975), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(49), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    STATE(830), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    STATE(927), 1,
      sym_field_declaration_list,
    STATE(976), 1,
      sym_attribute_specifier,
    ACTIONS(2747), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2745), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2737), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2743), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2741), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_field_declaration_list,
    STATE(957), 1,
      sym_attribute_specifier,
    ACTIONS(2751), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2749), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    STATE(919), 1,
      sym_field_declaration_list,
    STATE(974), 1,
      sym_attribute_specifier,
    ACTIONS(2755), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2753), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(2757), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [23768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    STATE(925), 1,
      sym_field_declaration_list,
    STATE(969), 1,
      sym_attribute_specifier,
    ACTIONS(2763), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2761), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23831] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    STATE(933), 1,
      sym_field_declaration_list,
    STATE(946), 1,
      sym_attribute_specifier,
    ACTIONS(2767), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2765), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [23894] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2771), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(916), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2769), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [23964] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2775), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(830), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2773), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2777), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2131), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24142] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2783), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(912), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2781), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2787), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
    STATE(830), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(2785), 9,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [24282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2135), 40,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [24336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(963), 1,
      sym_attribute_specifier,
    ACTIONS(2791), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2789), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(956), 1,
      sym_attribute_specifier,
    ACTIONS(2795), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2793), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(970), 1,
      sym_attribute_specifier,
    ACTIONS(2799), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2797), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24507] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [24570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2175), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [24633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(983), 1,
      sym_attribute_specifier,
    ACTIONS(2805), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2803), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2173), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [24753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(981), 1,
      sym_attribute_specifier,
    ACTIONS(2809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2807), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24810] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(966), 1,
      sym_attribute_specifier,
    ACTIONS(2813), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2811), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(947), 1,
      sym_attribute_specifier,
    ACTIONS(2817), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2815), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [24924] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2160), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [24987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2164), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [25050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(977), 1,
      sym_attribute_specifier,
    ACTIONS(2821), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2819), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2825), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2823), 33,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(950), 1,
      sym_attribute_specifier,
    ACTIONS(2832), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2830), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(972), 1,
      sym_attribute_specifier,
    ACTIONS(2836), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2834), 36,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25278] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2171), 1,
      anon_sym_COLON,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [25341] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(978), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2846), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2844), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2842), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [25463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2848), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [25515] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25589] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25665] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25743] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    ACTIONS(2864), 1,
      anon_sym_PIPE,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25823] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    ACTIONS(2864), 1,
      anon_sym_PIPE,
    ACTIONS(2866), 1,
      anon_sym_AMP_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 18,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 11,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [25969] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    ACTIONS(2864), 1,
      anon_sym_PIPE,
    ACTIONS(2866), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2874), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2870), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2868), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [26055] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2152), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2139), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2881), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2879), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2883), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2889), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2887), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2895), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2891), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2897), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2901), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26429] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [26497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2905), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2823), 1,
      sym_primitive_type,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2912), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2909), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [26607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2915), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2919), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2923), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [26763] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    ACTIONS(2864), 1,
      anon_sym_PIPE,
    ACTIONS(2866), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2874), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2929), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2927), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [26849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2933), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2141), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [26909] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 21,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [26981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(982), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2939), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2937), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2935), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2941), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2945), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2949), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27193] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_AMP,
    ACTIONS(2862), 1,
      anon_sym_CARET,
    ACTIONS(2864), 1,
      anon_sym_PIPE,
    ACTIONS(2866), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2874), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2838), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2852), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2856), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2955), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
    ACTIONS(2840), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2953), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_identifier,
  [27279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2957), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(949), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2965), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2963), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2961), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2967), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2971), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2975), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2979), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2983), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2987), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2991), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27751] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      sym_identifier,
    ACTIONS(3004), 1,
      sym_primitive_type,
    STATE(954), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3002), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2998), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3000), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
  [27811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3006), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3010), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [27915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2895), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3016), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3014), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [27971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2895), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3020), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3018), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [28027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2963), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(2961), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [28079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3022), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [28131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2895), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3028), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3026), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [28187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3032), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3030), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [28239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
    ACTIONS(3034), 37,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [28291] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_EQ,
    ACTIONS(3042), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3044), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3046), 1,
      anon_sym_PIPE,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    ACTIONS(3060), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2953), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28376] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28512] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_EQ,
    ACTIONS(3044), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3046), 1,
      anon_sym_PIPE,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28593] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3062), 1,
      anon_sym_SEMI,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(916), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28662] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3064), 1,
      anon_sym_SEMI,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(916), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28731] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3066), 1,
      anon_sym_SEMI,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(916), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [28800] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      anon_sym_EQ,
    ACTIONS(3042), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3044), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3046), 1,
      anon_sym_PIPE,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    ACTIONS(3060), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2927), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28885] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_EQ,
    ACTIONS(3046), 1,
      anon_sym_PIPE,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [28964] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29041] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29116] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29181] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_EQ,
    ACTIONS(2723), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 19,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
  [29236] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29307] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2715), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29374] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(1225), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3068), 1,
      anon_sym_SEMI,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(2771), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(916), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(2769), 8,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(51), 10,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
  [29443] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2870), 1,
      anon_sym_EQ,
    ACTIONS(3042), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3044), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3046), 1,
      anon_sym_PIPE,
    ACTIONS(3048), 1,
      anon_sym_CARET,
    ACTIONS(3050), 1,
      anon_sym_AMP,
    ACTIONS(3060), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3038), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3052), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3054), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3056), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3040), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2868), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [29528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [29582] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym___attribute__,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(3079), 1,
      anon_sym_COLON,
    STATE(962), 1,
      sym_attribute_specifier,
    STATE(1025), 1,
      sym_enumerator_list,
    ACTIONS(3072), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3070), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [29642] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1458), 1,
      sym__declarator,
    STATE(1690), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3083), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1005), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1083), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [29728] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1451), 1,
      sym__declarator,
    STATE(1726), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3091), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1080), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [29814] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1474), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [29873] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1470), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [29932] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1476), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [29991] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1472), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30050] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1471), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1467), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30168] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(3097), 1,
      anon_sym___attribute__,
    STATE(955), 1,
      sym_attribute_specifier,
    STATE(1022), 1,
      sym_enumerator_list,
    ACTIONS(3095), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3093), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1466), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30284] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1477), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30343] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1473), 1,
      sym_field_declaration_list,
    ACTIONS(2152), 2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30402] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2713), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2725), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2727), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30538] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2709), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2711), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30672] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2713), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30731] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym___attribute__,
    STATE(984), 1,
      sym_attribute_specifier,
    ACTIONS(3124), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3122), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(465), 1,
      sym_string_literal,
    ACTIONS(3129), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2777), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [30904] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym___attribute__,
    STATE(971), 1,
      sym_attribute_specifier,
    ACTIONS(3133), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3131), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [30955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym___attribute__,
    STATE(953), 1,
      sym_attribute_specifier,
    ACTIONS(3140), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3138), 31,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [31006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2870), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3145), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3149), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2868), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2713), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3147), 1,
      anon_sym_AMP_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31229] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2697), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2699), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31288] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2685), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2687), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31347] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(2715), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(464), 1,
      sym_string_literal,
    ACTIONS(3129), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2777), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2715), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31540] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31605] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2733), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2735), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [31662] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2713), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(2715), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(467), 1,
      sym_string_literal,
    ACTIONS(3129), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2777), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31776] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2955), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3145), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3149), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2953), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2779), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(466), 1,
      sym_string_literal,
    ACTIONS(3129), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(2777), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [31910] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2929), 1,
      anon_sym_EQ,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(3108), 1,
      anon_sym_CARET,
    ACTIONS(3110), 1,
      anon_sym_AMP,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3145), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3149), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3102), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3112), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3116), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3118), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3104), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2927), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31993] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1544), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1047), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2703), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [32115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2731), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [32161] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1546), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1133), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_EQ,
    ACTIONS(2933), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2141), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [32287] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1543), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1044), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1142), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32363] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1543), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1142), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [32439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2719), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [32485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(2707), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
  [32531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3161), 34,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [32576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_EQ,
    ACTIONS(3165), 1,
      anon_sym_SEMI,
    ACTIONS(2162), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2147), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2141), 13,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [32627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1295), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1265), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1267), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1319), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1319), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1273), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1275), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1273), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1275), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1255), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1391), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [32979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1279), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1279), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 1,
      anon_sym_LPAREN2,
    ACTIONS(3174), 1,
      anon_sym_LBRACK,
    STATE(979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2152), 2,
      anon_sym_COMMA,
      anon_sym_STAR,
    ACTIONS(3167), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2156), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 25,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
  [33121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1251), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1247), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1293), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1295), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1285), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1287), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1303), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1243), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1245), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1247), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1363), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1361), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1363), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1243), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1297), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1299), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1259), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
    ACTIONS(1259), 19,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [33693] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3085), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1690), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3179), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3181), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1081), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1226), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3083), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3185), 1,
      anon_sym_typedef,
    ACTIONS(2737), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3187), 1,
      anon_sym_typedef,
    ACTIONS(2737), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3189), 1,
      anon_sym_typedef,
    ACTIONS(2737), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [33897] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1463), 1,
      sym__declarator,
    STATE(1719), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3191), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [33967] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3085), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1726), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3179), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3181), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1229), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3091), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3193), 1,
      anon_sym_typedef,
    ACTIONS(2737), 32,
      anon_sym___extension__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_auto,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [34083] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1451), 1,
      sym__declarator,
    STATE(1726), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3091), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34153] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1451), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1237), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2713), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [34277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [34348] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 5,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 14,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [34407] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    ACTIONS(3219), 1,
      anon_sym_AMP_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 8,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      sym_identifier,
  [34480] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1463), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1238), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34547] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1451), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1089), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1237), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34614] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2929), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    ACTIONS(3219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3223), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2927), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [34691] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1524), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1096), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1235), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [34758] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    ACTIONS(3219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3223), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2953), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [34835] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2713), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 16,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      sym_identifier,
  [34890] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2715), 12,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      sym_identifier,
  [34953] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1536), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1236), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35020] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1530), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1099), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1240), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35087] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2870), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    ACTIONS(3219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3223), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [35164] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1524), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1235), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35231] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2715), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [35296] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 9,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      sym_identifier,
  [35365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3205), 1,
      anon_sym_PIPE,
    ACTIONS(3207), 1,
      anon_sym_CARET,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    ACTIONS(3219), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3223), 1,
      anon_sym_QMARK,
    ACTIONS(3233), 1,
      aux_sym_preproc_elif_token1,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3231), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [35442] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3203), 1,
      anon_sym_SLASH,
    ACTIONS(3209), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3201), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3211), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3217), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 10,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_identifier,
  [35509] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(1458), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3087), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1084), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(1239), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3085), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [35576] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2953), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [35650] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2713), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [35704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [35760] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1146), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(1108), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3265), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(3263), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3261), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [35808] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2927), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [35882] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [35940] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36002] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2868), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [36076] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36140] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_PIPE,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36206] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2713), 1,
      anon_sym_PIPE,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36274] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
  [36412] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1225), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2365), 1,
      sym_type_descriptor,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1136), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36475] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1418), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36538] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(3277), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1225), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2105), 1,
      sym_type_descriptor,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1141), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36601] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1420), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36664] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1413), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36727] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1415), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36790] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(3277), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1225), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2309), 1,
      sym_type_descriptor,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1141), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36853] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1225), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2364), 1,
      sym_type_descriptor,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1136), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36916] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1419), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [36979] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1417), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37042] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1225), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2255), 1,
      sym_type_descriptor,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1136), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37105] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1416), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37168] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1246), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1414), 1,
      sym__type_definition_type,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1140), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3279), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3281), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [37269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3285), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [37307] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1539), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37367] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3289), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [37441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3293), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [37479] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1224), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37539] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(3302), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3297), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3299), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
    ACTIONS(3295), 10,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
  [37585] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1543), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 11,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3307), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
  [37683] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(2117), 1,
      anon_sym_enum,
    ACTIONS(3271), 1,
      sym_identifier,
    ACTIONS(3275), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1244), 1,
      sym_type_specifier,
    STATE(1279), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37743] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      sym_primitive_type,
    ACTIONS(61), 1,
      anon_sym_struct,
    ACTIONS(63), 1,
      anon_sym_union,
    ACTIONS(1557), 1,
      sym_identifier,
    ACTIONS(3277), 1,
      anon_sym_enum,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1224), 1,
      sym_type_specifier,
    STATE(1242), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2115), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(980), 5,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_macro_type_specifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37803] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1546), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [37863] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3311), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    STATE(1963), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [37938] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3313), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    STATE(1949), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38013] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3315), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    STATE(1926), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3317), 23,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [38125] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3321), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [38196] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3323), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    STATE(1983), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38271] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3325), 1,
      anon_sym_COMMA,
    ACTIONS(3327), 1,
      anon_sym_RBRACE,
    STATE(856), 1,
      sym_argument_list,
    STATE(1961), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38346] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3329), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    STATE(1917), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3333), 23,
      anon_sym___extension__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [38458] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(2713), 6,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [38580] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3341), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38652] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3343), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38724] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [38786] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3355), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38858] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3357), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [38930] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3359), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39002] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3361), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39074] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2953), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39146] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3375), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39218] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39290] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3379), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [39360] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3381), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39432] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [39488] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2713), 1,
      anon_sym_PIPE,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [39552] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [39622] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3385), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(2713), 1,
      anon_sym_PIPE,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [39760] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3387), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [39832] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [39902] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [39968] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3391), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [40038] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3393), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [40108] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40180] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(3397), 1,
      anon_sym_COLON,
    STATE(962), 1,
      sym_attribute_specifier,
    STATE(1227), 1,
      sym_enumerator_list,
    ACTIONS(3072), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
    ACTIONS(3070), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [40226] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [40294] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3399), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40366] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [40436] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3403), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40508] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3405), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40580] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3407), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40652] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2713), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2715), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [40706] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3409), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40778] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2713), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2715), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [40838] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [40908] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3413), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [40980] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3415), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3417), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41124] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3419), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41196] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3421), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41268] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    ACTIONS(3423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_RBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41342] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3427), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41414] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3429), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41486] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    STATE(955), 1,
      sym_attribute_specifier,
    STATE(1230), 1,
      sym_enumerator_list,
    ACTIONS(3095), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3093), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [41530] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3431), 1,
      anon_sym_SEMI,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41602] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    ACTIONS(3433), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41674] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2927), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41746] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3435), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [41816] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(2695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3120), 1,
      anon_sym_DOT,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2868), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RBRACK,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41888] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3437), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [41957] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3439), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42026] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_RBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42095] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42164] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42233] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3443), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42302] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42371] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42440] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3445), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42509] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3447), 1,
      anon_sym_COMMA,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42578] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42647] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3449), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42716] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42785] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3451), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42854] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42923] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    ACTIONS(3453), 1,
      anon_sym_RBRACK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [42992] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3455), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43061] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43130] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43199] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3457), 1,
      anon_sym_COLON,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43268] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    ACTIONS(3459), 1,
      anon_sym_RPAREN,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43337] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_RBRACK,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3100), 1,
      anon_sym_LPAREN2,
    ACTIONS(3339), 1,
      anon_sym_SLASH,
    ACTIONS(3363), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3365), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    ACTIONS(3369), 1,
      anon_sym_CARET,
    ACTIONS(3371), 1,
      anon_sym_AMP,
    ACTIONS(3373), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3345), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3347), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3351), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3353), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43406] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1718), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1233), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3461), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43460] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1697), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1228), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3463), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43514] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1726), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3091), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43568] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(953), 1,
      sym_attribute_specifier,
    ACTIONS(3140), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3138), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [43606] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1706), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3465), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43660] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1719), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3191), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(984), 1,
      sym_attribute_specifier,
    ACTIONS(3124), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3122), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [43752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_SEMI,
    ACTIONS(2147), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2141), 18,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [43788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    STATE(971), 1,
      sym_attribute_specifier,
    ACTIONS(3133), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3131), 18,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [43826] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_const,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1728), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    ACTIONS(3183), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3467), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    ACTIONS(3177), 8,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43880] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(2691), 1,
      anon_sym_LBRACK,
    ACTIONS(3239), 1,
      anon_sym_SLASH,
    ACTIONS(3241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3245), 1,
      anon_sym_PIPE,
    ACTIONS(3247), 1,
      anon_sym_CARET,
    ACTIONS(3249), 1,
      anon_sym_AMP,
    ACTIONS(3259), 1,
      anon_sym_QMARK,
    STATE(856), 1,
      sym_argument_list,
    ACTIONS(2693), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(2695), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3235), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3237), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3251), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3253), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3255), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3257), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [43946] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1536), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [43997] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1510), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44048] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1463), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44099] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1449), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44150] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1451), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44201] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(904), 1,
      sym_alignas_qualifier,
    STATE(1524), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2823), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(2827), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2912), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(2909), 11,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
  [44290] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 1,
      sym_primitive_type,
    ACTIONS(3469), 1,
      sym_identifier,
    STATE(1241), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3471), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2998), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(3000), 11,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
  [44330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3475), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3473), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3479), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1243), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3477), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44408] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3483), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3481), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(904), 1,
      sym_alignas_qualifier,
    ACTIONS(55), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(3487), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    STATE(1245), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3485), 7,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(53), 9,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
  [44486] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1422), 1,
      sym_ms_call_modifier,
    STATE(1678), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_LPAREN2,
    STATE(1139), 1,
      sym_preproc_argument_list,
    ACTIONS(3493), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3489), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2893), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3495), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2891), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [44602] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1445), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1722), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1985), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44653] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      anon_sym_RPAREN,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    STATE(1945), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [44708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1265), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2844), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3528), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2842), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [44741] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1455), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1717), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1993), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44792] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1461), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1556), 1,
      sym__declarator,
    STATE(1710), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1867), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44843] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1459), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1709), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1871), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1266), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2937), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3531), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2935), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [44927] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1452), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1695), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1894), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [44978] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1465), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1730), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2009), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_STAR,
    ACTIONS(2876), 1,
      anon_sym_LPAREN2,
    STATE(1274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3534), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2139), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45064] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3539), 1,
      anon_sym_RPAREN,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3549), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1278), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [45107] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3553), 1,
      anon_sym_RPAREN,
    ACTIONS(3555), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1251), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [45150] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1443), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1560), 1,
      sym__declarator,
    STATE(1695), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1894), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1249), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2963), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3557), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2961), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45234] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1464), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1566), 1,
      sym__declarator,
    STATE(1722), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1985), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3016), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3560), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3014), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3028), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3563), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3026), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45351] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3566), 1,
      anon_sym_RPAREN,
    ACTIONS(3568), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1273), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [45394] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1442), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1561), 1,
      sym__declarator,
    STATE(1705), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1950), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2912), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3570), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(2909), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45478] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1457), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1754), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2048), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45529] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1454), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1685), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1930), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45580] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1441), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1705), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1950), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45631] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3574), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(931), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3020), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3576), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3018), 14,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [45719] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1710), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1867), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45770] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1450), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1704), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1972), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45821] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1447), 1,
      sym_ms_call_modifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1662), 1,
      sym__declarator,
    STATE(1692), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(1859), 1,
      sym_init_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [45872] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3579), 1,
      anon_sym_RPAREN,
    STATE(1890), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      sym_identifier,
    ACTIONS(3587), 1,
      sym_primitive_type,
    STATE(1269), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(2998), 2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
    ACTIONS(3584), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3000), 12,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
  [45964] = 5,
    ACTIONS(3489), 1,
      anon_sym_LF,
    ACTIONS(3590), 1,
      anon_sym_LPAREN2,
    ACTIONS(3592), 1,
      sym_comment,
    STATE(1357), 1,
      sym_preproc_argument_list,
    ACTIONS(3493), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [45997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3596), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3594), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46025] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3600), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3598), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [46061] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3612), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1360), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3618), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3616), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46129] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3620), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1363), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46169] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3622), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1373), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46209] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3624), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1334), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3626), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1356), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46289] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3628), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1344), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46329] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3630), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1370), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46369] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3632), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1366), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3634), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1361), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3636), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1338), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46489] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3638), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1351), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3640), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1335), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3642), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1337), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46609] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3644), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1336), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3646), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1343), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46689] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3648), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1364), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3650), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [46757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3654), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1358), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3656), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1359), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46837] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3658), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1347), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46877] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3660), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1365), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46917] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3662), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1368), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46957] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3664), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1354), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [46997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3666), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1350), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47037] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3668), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1371), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47077] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3670), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1332), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47117] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3672), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1346), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47157] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(1586), 1,
      sym__declarator,
    STATE(1743), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(3674), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47205] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3676), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1352), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47245] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3678), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1372), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47285] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(1629), 1,
      sym__declarator,
    STATE(1742), 1,
      sym__abstract_declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(2145), 1,
      sym_ms_based_modifier,
    ACTIONS(3680), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [47333] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3682), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1331), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47373] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3684), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1330), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3686), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1329), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3688), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1282), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(2631), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47521] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3690), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1355), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47561] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3692), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1369), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3694), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47629] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3698), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1349), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47669] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3700), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1327), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47709] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3602), 1,
      sym_identifier,
    ACTIONS(3604), 1,
      anon_sym_LPAREN2,
    ACTIONS(3606), 1,
      anon_sym_defined,
    ACTIONS(3702), 1,
      sym_number_literal,
    ACTIONS(3608), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3610), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3614), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1339), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47749] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3704), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [47799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3600), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3598), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [47833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3706), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1326), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [47873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3600), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3598), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [47913] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3600), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(3598), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [47955] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3600), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [47999] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3600), 1,
      anon_sym_PIPE,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [48045] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      sym_identifier,
    ACTIONS(3541), 1,
      anon_sym_LPAREN2,
    ACTIONS(3543), 1,
      anon_sym_defined,
    ACTIONS(3708), 1,
      sym_number_literal,
    ACTIONS(3545), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3547), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3551), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(1284), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [48085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3600), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3598), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48117] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [48163] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3598), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [48211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3600), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3598), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48239] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3600), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48270] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3714), 1,
      anon_sym_LF,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48315] = 3,
    ACTIONS(3293), 1,
      anon_sym_LF,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3291), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48342] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3694), 1,
      anon_sym_LF,
    ACTIONS(3696), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48369] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_const,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(3734), 1,
      anon_sym_COLON,
    STATE(962), 1,
      sym_attribute_specifier,
    STATE(1227), 1,
      sym_enumerator_list,
    ACTIONS(3072), 13,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_alignas,
      anon_sym__Alignas,
  [48406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3737), 1,
      anon_sym_RPAREN,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48455] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3739), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48500] = 3,
    ACTIONS(3285), 1,
      anon_sym_LF,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3283), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48527] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3741), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48572] = 9,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3600), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48611] = 3,
    ACTIONS(2631), 1,
      anon_sym_LF,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(2629), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48638] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3743), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48683] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3600), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48710] = 6,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3600), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48743] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3745), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48788] = 3,
    ACTIONS(3281), 1,
      anon_sym_LF,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3279), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48815] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3600), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48860] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3747), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48905] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3749), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [48950] = 3,
    ACTIONS(3307), 1,
      anon_sym_LF,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3305), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [48977] = 8,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3600), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [49014] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3751), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49059] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3753), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49104] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3616), 1,
      anon_sym_LF,
    ACTIONS(3618), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49131] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_LF,
    ACTIONS(3596), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49158] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3755), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49203] = 7,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(3600), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [49238] = 10,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3600), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49279] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3757), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49324] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_LF,
    ACTIONS(3652), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49351] = 11,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3600), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49394] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3759), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49439] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_SLASH,
    ACTIONS(3510), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3512), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3514), 1,
      anon_sym_PIPE,
    ACTIONS(3516), 1,
      anon_sym_CARET,
    ACTIONS(3518), 1,
      anon_sym_AMP,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
    ACTIONS(3504), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3506), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(3520), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3522), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(3524), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3526), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49488] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_LF,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3600), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [49517] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3763), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49562] = 12,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3718), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3720), 1,
      anon_sym_PIPE,
    ACTIONS(3722), 1,
      anon_sym_CARET,
    ACTIONS(3724), 1,
      anon_sym_AMP,
    ACTIONS(3765), 1,
      anon_sym_LF,
    ACTIONS(3710), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3726), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3712), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3728), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [49607] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1533), 1,
      sym_ms_call_modifier,
    STATE(1591), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49647] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1526), 1,
      sym_ms_call_modifier,
    STATE(1623), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49687] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1483), 1,
      sym_ms_call_modifier,
    STATE(1609), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49727] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1535), 1,
      sym_ms_call_modifier,
    STATE(1610), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49767] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1531), 1,
      sym_ms_call_modifier,
    STATE(1578), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49807] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1512), 1,
      sym_ms_call_modifier,
    STATE(1650), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49847] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1518), 1,
      sym_ms_call_modifier,
    STATE(1637), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1511), 1,
      sym_ms_call_modifier,
    STATE(1603), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49927] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1522), 1,
      sym_ms_call_modifier,
    STATE(1653), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [49967] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1494), 1,
      sym_ms_call_modifier,
    STATE(1645), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50007] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1487), 1,
      sym_ms_call_modifier,
    STATE(1643), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50047] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_ms_call_modifier,
    STATE(1613), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50087] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1491), 1,
      sym_ms_call_modifier,
    STATE(1583), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50127] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1508), 1,
      sym_ms_call_modifier,
    STATE(1580), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50167] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1534), 1,
      sym_ms_call_modifier,
    STATE(1589), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50207] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1525), 1,
      sym_ms_call_modifier,
    STATE(1625), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50247] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1498), 1,
      sym_ms_call_modifier,
    STATE(1626), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50287] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1499), 1,
      sym_ms_call_modifier,
    STATE(1616), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50327] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1500), 1,
      sym_ms_call_modifier,
    STATE(1576), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_LPAREN2,
    ACTIONS(1750), 1,
      anon_sym_STAR,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(1684), 1,
      sym__declarator,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(1791), 1,
      sym__abstract_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [50411] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1497), 1,
      sym_ms_call_modifier,
    STATE(1635), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50451] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1528), 1,
      sym_ms_call_modifier,
    STATE(1673), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50491] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1492), 1,
      sym_ms_call_modifier,
    STATE(1615), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50531] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1479), 1,
      sym_ms_call_modifier,
    STATE(1595), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50571] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1517), 1,
      sym_ms_call_modifier,
    STATE(1579), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50611] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1538), 1,
      sym_ms_call_modifier,
    STATE(1574), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1506), 1,
      sym_ms_call_modifier,
    STATE(1641), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50691] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1496), 1,
      sym_ms_call_modifier,
    STATE(1620), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50731] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1502), 1,
      sym_ms_call_modifier,
    STATE(1601), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50771] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(1516), 1,
      sym_ms_call_modifier,
    STATE(1670), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1480), 1,
      sym_ms_call_modifier,
    STATE(1621), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1515), 1,
      sym_ms_call_modifier,
    STATE(1585), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50891] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1520), 1,
      sym_ms_call_modifier,
    STATE(1630), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50931] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1493), 1,
      sym_ms_call_modifier,
    STATE(1582), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [50971] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1503), 1,
      sym_ms_call_modifier,
    STATE(1597), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [51011] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1513), 1,
      sym_ms_call_modifier,
    STATE(1659), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [51051] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1523), 1,
      sym_ms_call_modifier,
    STATE(1596), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [51091] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1505), 1,
      sym_ms_call_modifier,
    STATE(1658), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [51131] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1501), 1,
      sym_ms_call_modifier,
    STATE(1660), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
    ACTIONS(45), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [51171] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1780), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1810), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51253] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1807), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51294] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1800), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51335] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1824), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51376] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1790), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51417] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1829), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51458] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1541), 1,
      sym__type_declarator,
    STATE(1825), 1,
      sym__type_definition_declarators,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51499] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1558), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51537] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(3153), 1,
      anon_sym_LPAREN2,
    ACTIONS(3155), 1,
      anon_sym_STAR,
    ACTIONS(3159), 1,
      sym_primitive_type,
    STATE(1675), 1,
      sym__type_declarator,
    STATE(2260), 1,
      sym_ms_based_modifier,
    ACTIONS(3157), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1669), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_pointer_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
  [51575] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3773), 1,
      anon_sym_LBRACK,
    STATE(1432), 1,
      sym_gnu_asm_expression,
    STATE(1507), 1,
      sym_attribute_specifier,
    STATE(1682), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3769), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(1437), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3771), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [51615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3773), 1,
      anon_sym_LBRACK,
    STATE(1439), 1,
      sym_gnu_asm_expression,
    ACTIONS(97), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1437), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3771), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [51649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3777), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3779), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3781), 1,
      aux_sym_preproc_elif_token1,
    STATE(1490), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1532), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1672), 1,
      sym_enumerator,
    ACTIONS(3783), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2150), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(2151), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [51688] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3785), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1916), 1,
      sym__field_declaration_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(2289), 1,
      sym_attribute_specifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [51729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3779), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3781), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3787), 1,
      aux_sym_preproc_if_token2,
    STATE(1481), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1482), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1672), 1,
      sym_enumerator,
    ACTIONS(3783), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2272), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(2273), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [51768] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3789), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1976), 1,
      sym__field_declaration_declarator,
    STATE(2225), 1,
      sym_attribute_specifier,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [51809] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3791), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1901), 1,
      sym__field_declaration_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(2310), 1,
      sym_attribute_specifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [51850] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3795), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1431), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3793), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [51879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      sym_identifier,
    ACTIONS(3802), 1,
      anon_sym___attribute__,
    ACTIONS(3805), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1431), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3800), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [51908] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3811), 1,
      anon_sym_LBRACK,
    STATE(1507), 1,
      sym_attribute_specifier,
    STATE(1683), 1,
      aux_sym_type_definition_repeat1,
    ACTIONS(3807), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3813), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1430), 2,
      sym_preproc_call_expression,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3809), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [51945] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3779), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3781), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3815), 1,
      aux_sym_preproc_if_token2,
    STATE(1478), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1504), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1672), 1,
      sym_enumerator,
    ACTIONS(3783), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2161), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(2162), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [51984] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3817), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1849), 1,
      sym__field_declaration_declarator,
    STATE(2114), 1,
      sym_attribute_specifier,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [52025] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3819), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1874), 1,
      sym__field_declaration_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(2325), 1,
      sym_attribute_specifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [52066] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3779), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3781), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3821), 1,
      aux_sym_preproc_if_token2,
    STATE(1489), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(1495), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1672), 1,
      sym_enumerator,
    ACTIONS(3783), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2148), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(2241), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [52105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3811), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1431), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [52134] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    ACTIONS(3823), 1,
      anon_sym_SEMI,
    STATE(1468), 1,
      sym__field_declarator,
    STATE(1910), 1,
      sym__field_declaration_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(2290), 1,
      sym_attribute_specifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [52175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(3767), 1,
      sym_identifier,
    ACTIONS(3811), 3,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(1430), 3,
      sym_preproc_call_expression,
      sym_attribute_specifier,
      aux_sym_function_declarator_repeat1,
    ACTIONS(3809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [52204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3827), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3830), 1,
      anon_sym_LBRACK,
    STATE(1440), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3825), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [52230] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1698), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52267] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1584), 1,
      sym__declarator,
    STATE(1698), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52304] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1575), 1,
      sym__declarator,
    STATE(1689), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52341] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3834), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3838), 1,
      sym_preproc_directive,
    ACTIONS(3840), 1,
      anon_sym_RBRACE,
    ACTIONS(3836), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2063), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(2297), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1529), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [52374] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1686), 1,
      sym__declaration_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1723), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52448] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1694), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52485] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3834), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3838), 1,
      sym_preproc_directive,
    ACTIONS(3842), 1,
      anon_sym_RBRACE,
    ACTIONS(3836), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2071), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(2322), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(1444), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [52518] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3844), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [52547] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1713), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3850), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [52613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1689), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3854), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [52671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1720), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1724), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_LPAREN2,
    STATE(1139), 1,
      sym_preproc_argument_list,
    ACTIONS(3856), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3858), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [52770] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1749), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3860), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [52836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1703), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3864), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [52894] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1604), 1,
      sym__declarator,
    STATE(1723), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [52931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 5,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
    ACTIONS(3868), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [52952] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3870), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [52981] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1638), 1,
      sym__declarator,
    STATE(1686), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [53018] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3498), 1,
      sym_identifier,
    STATE(1550), 1,
      sym_function_declarator,
    STATE(1688), 1,
      sym__declarator,
    STATE(1707), 1,
      sym__declaration_declarator,
    STATE(1770), 1,
      sym__function_declaration_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1557), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_array_declarator,
  [53055] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3872), 1,
      sym_identifier,
    ACTIONS(3874), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1806), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3876), 1,
      sym_identifier,
    ACTIONS(3878), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1832), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53123] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3880), 1,
      anon_sym_COMMA,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_COLON,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1766), 1,
      sym_bitfield_clause,
    STATE(1767), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(3882), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [53159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3890), 1,
      anon_sym_LBRACK,
    STATE(1440), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3888), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [53183] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3892), 1,
      sym_identifier,
    ACTIONS(3894), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1761), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53217] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3896), 1,
      sym_identifier,
    ACTIONS(3898), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1822), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53251] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3900), 1,
      sym_identifier,
    ACTIONS(3902), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1764), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53285] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3904), 1,
      sym_identifier,
    ACTIONS(3906), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1799), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53319] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3908), 1,
      sym_identifier,
    ACTIONS(3910), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1805), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53353] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3912), 1,
      sym_identifier,
    ACTIONS(3914), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1758), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53387] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3916), 1,
      sym_identifier,
    ACTIONS(3918), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1782), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53421] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    ACTIONS(3920), 1,
      sym_identifier,
    ACTIONS(3922), 1,
      anon_sym_SEMI,
    STATE(1699), 1,
      sym__declarator,
    STATE(1772), 1,
      sym_array_declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 4,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
  [53455] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3924), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2234), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [53486] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1598), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1617), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53544] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3932), 1,
      aux_sym_preproc_if_token2,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2302), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [53575] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3934), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2306), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [53604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1569), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3821), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    STATE(1495), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2148), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [53664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    STATE(1481), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2272), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [53695] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3942), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1482), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2273), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [53724] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1633), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53753] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1614), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3944), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2275), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [53811] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3946), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2198), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [53840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1588), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1639), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53898] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1632), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53927] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1636), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [53956] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3948), 1,
      aux_sym_preproc_if_token2,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2274), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [53987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1573), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54016] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1656), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54045] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1571), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54074] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1619), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54103] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1612), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54132] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1644), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54161] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1634), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54190] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1602), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3950), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2236), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1642), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54277] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1640), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym___attribute__,
    ACTIONS(3856), 2,
      anon_sym_LBRACK,
      sym_identifier,
    ACTIONS(3952), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3957), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(3858), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [54331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1622), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(3936), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3938), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3959), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(3940), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(1489), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(2241), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [54389] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3961), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [54416] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1611), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1587), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1594), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(1527), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [54532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1590), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3225), 1,
      sym_identifier,
    ACTIONS(3227), 1,
      anon_sym_LPAREN2,
    ACTIONS(3229), 1,
      anon_sym_STAR,
    STATE(1671), 1,
      sym__field_declarator,
    STATE(2282), 1,
      sym_ms_based_modifier,
    STATE(1646), 5,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
  [54590] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1655), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1608), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3963), 1,
      aux_sym_preproc_if_token2,
    STATE(1532), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2151), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [54679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1648), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54708] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3965), 1,
      aux_sym_preproc_if_token2,
    STATE(1478), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2161), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [54739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1657), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1600), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54797] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3967), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [54824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1628), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1570), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(3886), 1,
      anon_sym_COLON,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1942), 1,
      sym_bitfield_clause,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3969), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [54913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1684), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [54942] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3971), 1,
      sym_identifier,
    ACTIONS(3974), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(3980), 1,
      sym_preproc_directive,
    ACTIONS(3983), 1,
      anon_sym_RBRACE,
    ACTIONS(3977), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(2123), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(1529), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [54971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3985), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [54998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1572), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55027] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(3926), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(3928), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(3987), 1,
      aux_sym_preproc_if_token2,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(3930), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(2179), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [55058] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1593), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1592), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1581), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3989), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [55172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    ACTIONS(3993), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(1804), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1754), 1,
      anon_sym___based,
    ACTIONS(3081), 1,
      sym_identifier,
    ACTIONS(3195), 1,
      anon_sym_LPAREN2,
    ACTIONS(3197), 1,
      anon_sym_STAR,
    STATE(1624), 1,
      sym__declarator,
    STATE(2145), 1,
      sym_ms_based_modifier,
    STATE(1550), 5,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
  [55226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3995), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_LBRACK,
    ACTIONS(3999), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55270] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1828), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4005), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4007), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55318] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4011), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4013), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55370] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    STATE(1768), 1,
      sym_gnu_asm_output_operand,
    STATE(2109), 1,
      sym_string_literal,
    ACTIONS(4015), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55394] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4019), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4023), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4027), 1,
      anon_sym_LBRACK,
    STATE(1440), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4025), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON,
  [55460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    STATE(1795), 1,
      sym_gnu_asm_input_operand,
    STATE(2218), 1,
      sym_string_literal,
    ACTIONS(4029), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4039), 1,
      anon_sym_LBRACK,
    ACTIONS(4037), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_LBRACK,
    ACTIONS(4041), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4047), 1,
      anon_sym_LBRACK,
    ACTIONS(4045), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
  [55556] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      anon_sym_LPAREN2,
    ACTIONS(2111), 1,
      anon_sym_STAR,
    ACTIONS(3089), 1,
      anon_sym_LBRACK,
    STATE(1753), 1,
      sym_parameter_list,
    STATE(1791), 1,
      sym__abstract_declarator,
    STATE(1751), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
  [55581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1879), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55602] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_EQ,
    STATE(420), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
    ACTIONS(4051), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [55650] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4053), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4055), 1,
      sym_identifier,
    ACTIONS(4059), 1,
      sym_system_lib_string,
    STATE(2359), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4057), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55696] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_EQ,
    STATE(150), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_EQ,
    STATE(359), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1836), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4063), 1,
      anon_sym_LBRACK,
    STATE(1440), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(4061), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [55796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4065), 1,
      sym_identifier,
    ACTIONS(4067), 1,
      sym_system_lib_string,
    STATE(2192), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4057), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3991), 1,
      sym_identifier,
    STATE(849), 1,
      sym_string_literal,
    STATE(1923), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55838] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_EQ,
    STATE(331), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4069), 1,
      sym_identifier,
    ACTIONS(4071), 1,
      sym_system_lib_string,
    STATE(2226), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4057), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4073), 1,
      sym_identifier,
    ACTIONS(4075), 1,
      sym_system_lib_string,
    STATE(2315), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(4057), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [55909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(339), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(167), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(142), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [55987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(403), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(384), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56039] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(164), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56065] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(166), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(139), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACK,
    ACTIONS(4077), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [56133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(404), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56159] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(383), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56185] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(158), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56211] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(410), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56237] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(407), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(353), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56289] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(349), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56315] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(348), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    ACTIONS(4081), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(405), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56391] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(330), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(329), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56443] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(322), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(320), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(357), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(323), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56547] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(406), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(324), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(328), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_LBRACK,
    STATE(1911), 1,
      sym_gnu_asm_input_operand,
    STATE(2218), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [56697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(335), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56723] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(436), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(400), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56775] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(356), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56801] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(423), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_LBRACK,
    ACTIONS(4083), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [56843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4089), 1,
      anon_sym_LBRACK,
    ACTIONS(4087), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [56859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_LBRACK,
    ACTIONS(4091), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [56875] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(145), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(337), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56927] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(439), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56953] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(338), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [56979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(131), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(340), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(343), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57057] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(373), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57083] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(137), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(372), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4097), 1,
      anon_sym_LBRACK,
    ACTIONS(4095), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57151] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(135), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57177] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(382), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(358), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57229] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(149), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57255] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(127), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57281] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(159), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(165), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(141), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4099), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [57377] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(163), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    ACTIONS(4105), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(144), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_LBRACK,
    ACTIONS(4107), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(401), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57521] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(425), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57547] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(433), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(381), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(134), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(360), 1,
      sym_compound_statement,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(380), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(376), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(397), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57729] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(366), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(394), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57807] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(379), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_LBRACK,
    ACTIONS(4111), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57849] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4115), 1,
      sym_identifier,
    ACTIONS(4120), 1,
      aux_sym_preproc_elif_token1,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
    ACTIONS(4118), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [57871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(152), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4122), 1,
      sym_identifier,
    ACTIONS(4127), 1,
      aux_sym_preproc_elif_token1,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(4125), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [57917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(438), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [57943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4131), 1,
      anon_sym_LBRACK,
    ACTIONS(4129), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym_LBRACK,
    ACTIONS(4133), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [57975] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(434), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    STATE(1933), 1,
      sym_gnu_asm_output_operand,
    STATE(2109), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [58021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(386), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(427), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(429), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(392), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58125] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58151] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(390), 1,
      sym_compound_statement,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym___attribute__,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(4137), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [58194] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4049), 1,
      anon_sym_EQ,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 1,
      anon_sym_LBRACK,
    ACTIONS(4142), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LBRACK,
    ACTIONS(4150), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4156), 1,
      anon_sym_LBRACK,
    ACTIONS(4154), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4160), 1,
      anon_sym_LBRACK,
    ACTIONS(4158), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4162), 1,
      anon_sym_LBRACK,
    ACTIONS(4165), 1,
      anon_sym_EQ,
    ACTIONS(4167), 1,
      anon_sym_DOT,
    STATE(1668), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [58311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4172), 1,
      anon_sym_LBRACK,
    ACTIONS(4170), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(4174), 1,
      anon_sym_RPAREN,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3884), 1,
      anon_sym_LBRACK,
    ACTIONS(4176), 1,
      anon_sym_RPAREN,
    STATE(1618), 1,
      sym_parameter_list,
    STATE(1548), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
    ACTIONS(4182), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4178), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [58389] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4184), 1,
      anon_sym_RPAREN,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4188), 1,
      anon_sym_LBRACK,
    ACTIONS(4186), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    ACTIONS(4190), 1,
      anon_sym_RPAREN,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_LBRACK,
    ACTIONS(4192), 1,
      anon_sym_EQ,
    ACTIONS(4194), 1,
      anon_sym_DOT,
    STATE(1668), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [58469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(39), 1,
      anon_sym___attribute__,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4196), 1,
      sym_identifier,
    STATE(923), 1,
      sym_field_declaration_list,
    STATE(1736), 1,
      sym_attribute_specifier,
    STATE(1996), 1,
      sym_ms_declspec_modifier,
  [58494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3997), 1,
      anon_sym_LBRACK,
    ACTIONS(4198), 1,
      anon_sym_RPAREN,
    STATE(1681), 1,
      sym_parameter_list,
    STATE(1563), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4202), 1,
      anon_sym_LBRACK,
    ACTIONS(4200), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_LBRACK,
    ACTIONS(4204), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4210), 1,
      anon_sym_LBRACK,
    ACTIONS(4208), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [58562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(3807), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [58579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(4212), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [58596] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    ACTIONS(4214), 1,
      anon_sym_RPAREN,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4218), 1,
      anon_sym_SEMI,
    STATE(1903), 1,
      aux_sym_declaration_repeat2,
    STATE(1908), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4222), 1,
      anon_sym_SEMI,
    STATE(1918), 1,
      sym_gnu_asm_expression,
    STATE(1919), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(812), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [58673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1423), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4224), 1,
      anon_sym_SEMI,
    STATE(1880), 1,
      sym_gnu_asm_expression,
    STATE(1881), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4226), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [58731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_LPAREN2,
    STATE(1727), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4232), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [58747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4234), 1,
      anon_sym_SEMI,
    STATE(1887), 1,
      sym_gnu_asm_expression,
    STATE(1888), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_LPAREN2,
    STATE(1693), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4238), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [58783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4241), 1,
      anon_sym_SEMI,
    STATE(1904), 1,
      sym_gnu_asm_expression,
    STATE(1905), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4243), 1,
      anon_sym_SEMI,
    STATE(1845), 1,
      sym_gnu_asm_expression,
    STATE(1846), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3983), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4245), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [58837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4247), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [58855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4249), 1,
      anon_sym_SEMI,
    STATE(1921), 1,
      aux_sym_declaration_repeat2,
    STATE(1927), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(3848), 1,
      anon_sym_LBRACK,
    STATE(1424), 1,
      sym_parameter_list,
    STATE(1469), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [58895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2316), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [58909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4253), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [58923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4255), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4257), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [58937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4259), 1,
      anon_sym_SEMI,
    STATE(1868), 1,
      sym_gnu_asm_expression,
    STATE(1869), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4261), 1,
      anon_sym_SEMI,
    STATE(1987), 1,
      sym_gnu_asm_expression,
    STATE(1988), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4263), 1,
      anon_sym_SEMI,
    STATE(1939), 1,
      aux_sym_declaration_repeat2,
    STATE(1943), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [58997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4265), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4267), 1,
      anon_sym_SEMI,
    STATE(1984), 1,
      sym_gnu_asm_expression,
    STATE(1986), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2280), 1,
      sym_string_literal,
    ACTIONS(103), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [59049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4269), 1,
      anon_sym_SEMI,
    STATE(1965), 1,
      sym_gnu_asm_expression,
    STATE(1966), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4271), 1,
      anon_sym_SEMI,
    STATE(1956), 1,
      aux_sym_declaration_repeat2,
    STATE(1962), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4275), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4277), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4279), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59117] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4281), 1,
      anon_sym_SEMI,
    STATE(2006), 1,
      sym_gnu_asm_expression,
    STATE(2007), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4283), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4285), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4287), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4289), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4275), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4291), 1,
      anon_sym_SEMI,
    STATE(2012), 1,
      sym_gnu_asm_expression,
    STATE(2013), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4293), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4295), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4297), 1,
      anon_sym_SEMI,
    STATE(1892), 1,
      aux_sym_declaration_repeat2,
    STATE(1895), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4253), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4299), 1,
      anon_sym_SEMI,
    STATE(1967), 1,
      sym_gnu_asm_expression,
    STATE(1974), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4301), 1,
      anon_sym_SEMI,
    STATE(1935), 1,
      sym_gnu_asm_expression,
    STATE(1936), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59309] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4303), 1,
      anon_sym_SEMI,
    STATE(1995), 1,
      aux_sym_declaration_repeat2,
    STATE(1997), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4305), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4307), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4309), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 1,
      anon_sym_LPAREN2,
    STATE(1693), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(4232), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [59377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4313), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4315), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(4317), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [59409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_SEMI,
    STATE(1932), 1,
      sym_gnu_asm_expression,
    STATE(1938), 1,
      aux_sym_declaration_repeat2,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
  [59429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4120), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4118), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [59443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4321), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4325), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4327), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59487] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4329), 1,
      sym_identifier,
    STATE(932), 1,
      sym_field_declaration_list,
    STATE(1855), 1,
      sym_ms_declspec_modifier,
  [59506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2329), 1,
      sym_extension_behavior,
    ACTIONS(4331), 4,
      anon_sym_require,
      anon_sym_enable,
      anon_sym_warn,
      anon_sym_disable,
  [59519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4333), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4335), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4337), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2343), 1,
      sym_extension_behavior,
    ACTIONS(4331), 4,
      anon_sym_require,
      anon_sym_enable,
      anon_sym_warn,
      anon_sym_disable,
  [59565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4105), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(1752), 1,
      sym_parameter_list,
    ACTIONS(4081), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    ACTIONS(4343), 1,
      anon_sym_COLON_COLON,
    STATE(2053), 1,
      sym_argument_list,
    ACTIONS(4341), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [59627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2347), 1,
      sym_extension_behavior,
    ACTIONS(4331), 4,
      anon_sym_require,
      anon_sym_enable,
      anon_sym_warn,
      anon_sym_disable,
  [59640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2193), 1,
      sym_extension_behavior,
    ACTIONS(4331), 4,
      anon_sym_require,
      anon_sym_enable,
      anon_sym_warn,
      anon_sym_disable,
  [59653] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(4345), 1,
      aux_sym_preproc_if_token2,
    STATE(1672), 1,
      sym_enumerator,
    STATE(1775), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(1776), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [59672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2035), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4347), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [59687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4351), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2091), 1,
      sym_gnu_asm_expression,
    ACTIONS(4220), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [59746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [59757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___declspec,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4361), 1,
      sym_identifier,
    STATE(926), 1,
      sym_field_declaration_list,
    STATE(2002), 1,
      sym_ms_declspec_modifier,
  [59776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    STATE(2033), 1,
      sym_argument_list,
    ACTIONS(4363), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [59790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3918), 1,
      anon_sym_SEMI,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [59804] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4365), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4369), 1,
      sym_preproc_arg,
    STATE(2061), 1,
      sym_preproc_params,
  [59820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      sym_identifier,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(1838), 1,
      aux_sym_function_definition_repeat1,
  [59836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4377), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [59850] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4379), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4381), 1,
      sym_preproc_arg,
    STATE(2075), 1,
      sym_preproc_params,
  [59866] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4383), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4385), 1,
      sym_preproc_arg,
    STATE(2080), 1,
      sym_preproc_params,
  [59882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 1,
      anon_sym_SEMI,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [59896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym___except,
    ACTIONS(4389), 1,
      anon_sym___finally,
    STATE(287), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [59910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_COMMA,
    STATE(1785), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4391), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [59924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4393), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [59938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4395), 1,
      anon_sym_COMMA,
    STATE(1793), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4397), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [59952] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4399), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4401), 1,
      sym_preproc_arg,
    STATE(2046), 1,
      sym_preproc_params,
  [59968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_asm,
      anon_sym___asm__,
  [59978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4408), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [59992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_SEMI,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4410), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4412), 1,
      anon_sym___except,
    ACTIONS(4414), 1,
      anon_sym___finally,
    STATE(189), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(4416), 1,
      aux_sym_preproc_if_token2,
    STATE(1647), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
  [60050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(4418), 1,
      aux_sym_preproc_if_token2,
    STATE(1649), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [60064] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4420), 1,
      anon_sym_DQUOTE,
    ACTIONS(4422), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4424), 1,
      sym_escape_sequence,
    STATE(1815), 1,
      aux_sym_string_literal_repeat1,
  [60080] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_SQUOTE,
    STATE(1820), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4428), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4430), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4432), 1,
      anon_sym_SEMI,
    STATE(1821), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [60132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4436), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 1,
      sym_identifier,
    ACTIONS(4345), 1,
      aux_sym_preproc_if_token2,
    STATE(1775), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(2181), 1,
      sym_enumerator,
  [60162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3775), 1,
      sym_identifier,
    ACTIONS(4438), 1,
      aux_sym_preproc_if_token2,
    STATE(1776), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [60176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4440), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4442), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60204] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4422), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4424), 1,
      sym_escape_sequence,
    ACTIONS(4444), 1,
      anon_sym_DQUOTE,
    STATE(1815), 1,
      aux_sym_string_literal_repeat1,
  [60220] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4446), 1,
      anon_sym_SQUOTE,
    STATE(1820), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4428), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60234] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_DQUOTE,
    ACTIONS(4450), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4452), 1,
      sym_escape_sequence,
    STATE(1814), 1,
      aux_sym_string_literal_repeat1,
  [60250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4454), 1,
      anon_sym_SEMI,
    STATE(1779), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    ACTIONS(4456), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_parameter_list,
  [60280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4458), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym__field_declaration_declarator_repeat1,
    ACTIONS(4461), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4395), 1,
      anon_sym_COMMA,
    STATE(1801), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4463), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60308] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4465), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4467), 1,
      sym_preproc_arg,
    STATE(2081), 1,
      sym_preproc_params,
  [60324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4469), 1,
      anon_sym_COMMA,
    STATE(1802), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4471), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_LPAREN2,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    ACTIONS(4473), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_parameter_list,
  [60354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 1,
      anon_sym___except,
    ACTIONS(4477), 1,
      anon_sym___finally,
    STATE(285), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4479), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4481), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4483), 1,
      anon_sym_SEMI,
    STATE(1786), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4485), 1,
      anon_sym_COMMA,
    STATE(1801), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(4488), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4469), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4490), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60438] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4492), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4494), 1,
      sym_preproc_arg,
    STATE(2030), 1,
      sym_preproc_params,
  [60454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4498), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 1,
      anon_sym_SEMI,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4500), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4502), 1,
      anon_sym_SEMI,
    STATE(1773), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(4507), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4509), 1,
      sym_identifier,
    ACTIONS(4511), 1,
      anon_sym_RPAREN,
    STATE(1954), 1,
      aux_sym_function_definition_repeat1,
  [60540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4513), 1,
      anon_sym_SEMI,
    STATE(1816), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4515), 1,
      anon_sym___except,
    ACTIONS(4517), 1,
      anon_sym___finally,
    STATE(189), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 1,
      anon_sym_COMMA,
    STATE(1826), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4519), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60582] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4521), 1,
      anon_sym_SQUOTE,
    STATE(1820), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4428), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60596] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4422), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4424), 1,
      sym_escape_sequence,
    ACTIONS(4523), 1,
      anon_sym_DQUOTE,
    STATE(1815), 1,
      aux_sym_string_literal_repeat1,
  [60612] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4525), 1,
      anon_sym_DQUOTE,
    ACTIONS(4527), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4530), 1,
      sym_escape_sequence,
    STATE(1815), 1,
      aux_sym_string_literal_repeat1,
  [60628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4533), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4535), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60656] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4537), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4539), 1,
      sym_preproc_arg,
    STATE(2087), 1,
      sym_preproc_params,
  [60672] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4541), 1,
      anon_sym_DQUOTE,
    ACTIONS(4543), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4545), 1,
      sym_escape_sequence,
    STATE(1777), 1,
      aux_sym_string_literal_repeat1,
  [60688] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_SQUOTE,
    STATE(1820), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4549), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [60702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4552), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4554), 1,
      anon_sym_SEMI,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4556), 1,
      anon_sym_SEMI,
    STATE(1661), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4558), 1,
      anon_sym_SEMI,
    STATE(1817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4560), 1,
      anon_sym_SEMI,
    STATE(1798), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_COMMA,
    STATE(1826), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(4565), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [60786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4567), 1,
      sym_identifier,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(1852), 1,
      aux_sym_function_definition_repeat1,
  [60802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(4571), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [60816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4573), 1,
      anon_sym_SEMI,
    STATE(1823), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [60830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4575), 1,
      sym_identifier,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(1843), 1,
      aux_sym_function_definition_repeat1,
  [60846] = 5,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4579), 1,
      anon_sym_DQUOTE,
    ACTIONS(4581), 1,
      aux_sym_string_literal_token1,
    ACTIONS(4583), 1,
      sym_escape_sequence,
    STATE(1787), 1,
      aux_sym_string_literal_repeat1,
  [60862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3898), 1,
      anon_sym_SEMI,
    ACTIONS(4035), 1,
      anon_sym_LBRACK,
    ACTIONS(4033), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [60876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym___except,
    ACTIONS(4587), 1,
      anon_sym___finally,
    STATE(93), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [60890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_COMMA,
    ACTIONS(3327), 1,
      anon_sym_RBRACE,
    STATE(1961), 1,
      aux_sym_initializer_list_repeat1,
  [60903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4589), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [60916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_RPAREN,
    ACTIONS(4593), 1,
      anon_sym_COLON,
    STATE(1922), 1,
      sym_gnu_asm_output_operand_list,
  [60929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4595), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [60942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [60955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4601), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1877), 1,
      aux_sym_attribute_declaration_repeat1,
  [60968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4597), 1,
      anon_sym_RPAREN,
    STATE(1837), 1,
      aux_sym_function_definition_repeat1,
  [60981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4603), 1,
      anon_sym_RPAREN,
    ACTIONS(4605), 1,
      anon_sym_COLON,
    STATE(1973), 1,
      sym_gnu_asm_clobber_list,
  [60994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4607), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [61007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4609), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [61020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4609), 1,
      anon_sym_RPAREN,
    STATE(1842), 1,
      aux_sym_function_definition_repeat1,
  [61033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4611), 1,
      anon_sym_SEMI,
    STATE(1882), 1,
      aux_sym_declaration_repeat2,
  [61046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4613), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4615), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61072] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4617), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4619), 1,
      anon_sym_LPAREN2,
    STATE(2121), 1,
      sym_preproc_argument_list,
  [61085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4621), 1,
      anon_sym_SEMI,
    STATE(2205), 1,
      sym_attribute_specifier,
  [61098] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4623), 1,
      sym_identifier,
    ACTIONS(4625), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4627), 1,
      sym_preproc_arg,
  [61111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4629), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [61124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4631), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [61137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4631), 1,
      anon_sym_RPAREN,
    STATE(1851), 1,
      aux_sym_function_definition_repeat1,
  [61150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_RPAREN,
    ACTIONS(4635), 1,
      anon_sym_COLON,
    STATE(1971), 1,
      sym_gnu_asm_input_operand_list,
  [61163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4637), 1,
      sym_identifier,
    STATE(930), 1,
      sym_field_declaration_list,
  [61176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_RPAREN,
    STATE(1856), 1,
      aux_sym_layout_qualifiers_repeat1,
  [61189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      sym_identifier,
    ACTIONS(4648), 1,
      anon_sym_shared,
    STATE(1955), 1,
      sym_qualifier,
  [61211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4650), 1,
      anon_sym_SEMI,
    STATE(1889), 1,
      aux_sym_declaration_repeat2,
  [61224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(4652), 1,
      sym_identifier,
    STATE(1024), 1,
      sym_enumerator_list,
  [61237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4654), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4656), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61259] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    STATE(1788), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4658), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [61270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4660), 1,
      anon_sym_COMMA,
    ACTIONS(4663), 1,
      anon_sym_RPAREN,
    STATE(1864), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [61283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4667), 1,
      anon_sym_RPAREN,
    ACTIONS(4665), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [61294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 1,
      anon_sym_RPAREN,
    ACTIONS(4669), 1,
      anon_sym_COMMA,
    STATE(1866), 1,
      aux_sym_argument_list_repeat1,
  [61307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4672), 1,
      anon_sym_SEMI,
    STATE(1953), 1,
      aux_sym_declaration_repeat2,
  [61320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4674), 1,
      anon_sym_SEMI,
    STATE(1835), 1,
      aux_sym_declaration_repeat2,
  [61333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4676), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4680), 1,
      anon_sym_RPAREN,
    STATE(1864), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [61359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4682), 1,
      anon_sym_SEMI,
    STATE(1969), 1,
      aux_sym_declaration_repeat2,
  [61372] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    STATE(1778), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4684), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [61383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4686), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4688), 1,
      anon_sym_SEMI,
    STATE(2314), 1,
      sym_attribute_specifier,
  [61409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4690), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1877), 1,
      aux_sym_attribute_declaration_repeat1,
  [61422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(4692), 1,
      sym_identifier,
    STATE(1232), 1,
      sym_enumerator_list,
  [61435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4694), 1,
      anon_sym_COMMA,
    ACTIONS(4697), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1877), 1,
      aux_sym_attribute_declaration_repeat1,
  [61448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_RPAREN,
    ACTIONS(4699), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_preproc_argument_list_repeat1,
  [61461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4702), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4704), 1,
      anon_sym_SEMI,
    STATE(1902), 1,
      aux_sym_declaration_repeat2,
  [61483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4706), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4708), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_COMMA,
    ACTIONS(4712), 1,
      anon_sym_RPAREN,
    STATE(2003), 1,
      aux_sym_parameter_list_repeat1,
  [61522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4714), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4716), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4718), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1875), 1,
      aux_sym_attribute_declaration_repeat1,
  [61561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4720), 1,
      anon_sym_SEMI,
    STATE(1906), 1,
      aux_sym_declaration_repeat2,
  [61574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4722), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4724), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4726), 1,
      anon_sym_RPAREN,
    STATE(1878), 1,
      aux_sym_preproc_argument_list_repeat1,
  [61613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4730), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61635] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4732), 1,
      sym_identifier,
    ACTIONS(4734), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4736), 1,
      sym_preproc_arg,
  [61648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4738), 1,
      anon_sym_SEMI,
    STATE(1847), 1,
      aux_sym_declaration_repeat2,
  [61661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4740), 1,
      anon_sym_SEMI,
    STATE(1884), 1,
      aux_sym_declaration_repeat2,
  [61674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4742), 1,
      anon_sym_EQ,
    ACTIONS(4099), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61685] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_LPAREN2,
    ACTIONS(4744), 1,
      aux_sym_preproc_include_token2,
    STATE(2121), 1,
      sym_preproc_argument_list,
  [61698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4746), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_COMMA,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    STATE(1899), 1,
      aux_sym_generic_expression_repeat1,
  [61724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4753), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4755), 1,
      anon_sym_SEMI,
    STATE(2283), 1,
      sym_attribute_specifier,
  [61750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4757), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4759), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4761), 1,
      anon_sym_SEMI,
    STATE(1914), 1,
      aux_sym_declaration_repeat2,
  [61789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4763), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4765), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4767), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [61824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4769), 1,
      anon_sym_SEMI,
    STATE(1885), 1,
      aux_sym_declaration_repeat2,
  [61837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_COMMA,
    ACTIONS(4771), 1,
      anon_sym_RPAREN,
    STATE(1870), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [61850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4773), 1,
      anon_sym_SEMI,
    STATE(2231), 1,
      sym_attribute_specifier,
  [61863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4775), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4777), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_COMMA,
    ACTIONS(4781), 1,
      anon_sym_RPAREN,
    STATE(1856), 1,
      aux_sym_layout_qualifiers_repeat1,
  [61898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4783), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4785), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [61920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4787), 1,
      anon_sym_SEMI,
    STATE(2115), 1,
      sym_attribute_specifier,
  [61933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3329), 1,
      anon_sym_COMMA,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
    STATE(1899), 1,
      aux_sym_generic_expression_repeat1,
  [61946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    STATE(1982), 1,
      aux_sym_declaration_repeat2,
  [61959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4793), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_RPAREN,
    ACTIONS(4797), 1,
      anon_sym_COLON,
    STATE(2296), 1,
      sym_gnu_asm_goto_list,
  [61985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4799), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [61998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      anon_sym_COLON,
    ACTIONS(4801), 1,
      anon_sym_RPAREN,
    STATE(1841), 1,
      sym_gnu_asm_input_operand_list,
  [62011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4593), 1,
      anon_sym_COLON,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(1854), 1,
      sym_gnu_asm_output_operand_list,
  [62024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4805), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      sym_identifier,
    ACTIONS(4648), 1,
      anon_sym_shared,
    STATE(2024), 1,
      sym_qualifier,
  [62050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3323), 1,
      anon_sym_RPAREN,
    STATE(1866), 1,
      aux_sym_argument_list_repeat1,
  [62063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4807), 1,
      anon_sym_SEMI,
    STATE(1898), 1,
      aux_sym_declaration_repeat2,
  [62076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4809), 1,
      anon_sym_COMMA,
    ACTIONS(4812), 1,
      anon_sym_RPAREN,
    STATE(1928), 1,
      aux_sym_preproc_params_repeat1,
  [62089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4814), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1877), 1,
      aux_sym_attribute_declaration_repeat1,
  [62102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4816), 1,
      anon_sym_SEMI,
    STATE(1900), 1,
      aux_sym_declaration_repeat2,
  [62115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 1,
      anon_sym_COMMA,
    ACTIONS(4821), 1,
      anon_sym_RPAREN,
    STATE(1931), 1,
      aux_sym_parameter_list_repeat1,
  [62128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4823), 1,
      anon_sym_SEMI,
    STATE(1991), 1,
      aux_sym_declaration_repeat2,
  [62141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4825), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [62150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_COMMA,
    ACTIONS(4827), 1,
      anon_sym_RPAREN,
    STATE(1856), 1,
      aux_sym_layout_qualifiers_repeat1,
  [62163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4829), 1,
      anon_sym_SEMI,
    STATE(1862), 1,
      aux_sym_declaration_repeat2,
  [62176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4831), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4833), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4835), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4837), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62228] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4839), 1,
      sym_identifier,
    ACTIONS(4841), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4843), 1,
      sym_preproc_arg,
  [62241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4845), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [62263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4849), 1,
      anon_sym_SEMI,
    STATE(1912), 1,
      aux_sym_declaration_repeat2,
  [62276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3313), 1,
      anon_sym_RPAREN,
    STATE(1949), 1,
      aux_sym_argument_list_repeat1,
  [62289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4851), 1,
      anon_sym_RPAREN,
    STATE(1878), 1,
      aux_sym_preproc_argument_list_repeat1,
  [62302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_COMMA,
    ACTIONS(4855), 1,
      anon_sym_RPAREN,
    STATE(1960), 1,
      aux_sym_preproc_params_repeat1,
  [62315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4857), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_COMMA,
    ACTIONS(4862), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3311), 1,
      anon_sym_RPAREN,
    STATE(1866), 1,
      aux_sym_argument_list_repeat1,
  [62354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4864), 1,
      anon_sym_SEMI,
    STATE(1937), 1,
      aux_sym_declaration_repeat2,
  [62367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4866), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1929), 1,
      aux_sym_attribute_declaration_repeat1,
  [62380] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_LPAREN2,
    ACTIONS(4868), 1,
      aux_sym_preproc_include_token2,
    STATE(2121), 1,
      sym_preproc_argument_list,
  [62393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4870), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4872), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [62419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_COMMA,
    ACTIONS(4874), 1,
      anon_sym_RPAREN,
    STATE(1913), 1,
      aux_sym_layout_qualifiers_repeat1,
  [62432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4876), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [62454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4872), 1,
      anon_sym_RPAREN,
    STATE(1970), 1,
      aux_sym_function_definition_repeat1,
  [62467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_RBRACE,
    ACTIONS(4880), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      aux_sym_initializer_list_repeat1,
  [62480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_COMMA,
    ACTIONS(4883), 1,
      anon_sym_RPAREN,
    STATE(1928), 1,
      aux_sym_preproc_params_repeat1,
  [62493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_RBRACE,
    ACTIONS(4885), 1,
      anon_sym_COMMA,
    STATE(1959), 1,
      aux_sym_initializer_list_repeat1,
  [62506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4887), 1,
      anon_sym_SEMI,
    STATE(1947), 1,
      aux_sym_declaration_repeat2,
  [62519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(4889), 1,
      anon_sym_RPAREN,
    STATE(1866), 1,
      aux_sym_argument_list_repeat1,
  [62532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4891), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [62541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4893), 1,
      anon_sym_SEMI,
    STATE(1873), 1,
      aux_sym_declaration_repeat2,
  [62554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4895), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4897), 1,
      anon_sym_SEMI,
    STATE(1924), 1,
      aux_sym_declaration_repeat2,
  [62580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [62589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4899), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4901), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [62615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_COLON,
    ACTIONS(4903), 1,
      anon_sym_RPAREN,
    STATE(1920), 1,
      sym_gnu_asm_clobber_list,
  [62628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_SEMI,
    STATE(1989), 1,
      aux_sym_declaration_repeat2,
  [62641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_COLON,
    ACTIONS(4907), 1,
      anon_sym_RPAREN,
    STATE(2268), 1,
      sym_gnu_asm_goto_list,
  [62654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4909), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(4911), 1,
      anon_sym_RPAREN,
    STATE(1878), 1,
      aux_sym_preproc_argument_list_repeat1,
  [62680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym___attribute__,
    ACTIONS(4913), 1,
      anon_sym_SEMI,
    STATE(2174), 1,
      sym_attribute_specifier,
  [62693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4915), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4917), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62719] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4919), 1,
      sym_identifier,
    ACTIONS(4921), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4923), 1,
      sym_preproc_arg,
  [62732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_COMMA,
    ACTIONS(4925), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(1839), 1,
      aux_sym_attribute_declaration_repeat1,
  [62745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 1,
      anon_sym_COMMA,
    ACTIONS(4930), 1,
      anon_sym_RPAREN,
    STATE(1981), 1,
      aux_sym_function_definition_repeat1,
  [62758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4932), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(4934), 1,
      anon_sym_RPAREN,
    STATE(1866), 1,
      aux_sym_argument_list_repeat1,
  [62784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4936), 1,
      anon_sym_SEMI,
    STATE(2005), 1,
      aux_sym_declaration_repeat2,
  [62797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4938), 1,
      anon_sym_SEMI,
    STATE(1977), 1,
      aux_sym_declaration_repeat2,
  [62810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4940), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4942), 1,
      anon_sym_SEMI,
    STATE(2008), 1,
      aux_sym_declaration_repeat2,
  [62836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4944), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4946), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4948), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4950), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4954), 1,
      anon_sym_EQ,
    ACTIONS(4952), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4956), 1,
      anon_sym_SEMI,
    STATE(2010), 1,
      aux_sym_declaration_repeat2,
  [62912] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    STATE(1813), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(4958), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [62923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4960), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4962), 1,
      sym_identifier,
    STATE(932), 1,
      sym_field_declaration_list,
  [62949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4964), 1,
      anon_sym_SEMI,
    STATE(1978), 1,
      aux_sym_declaration_repeat2,
  [62962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4966), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [62975] = 4,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_LPAREN2,
    ACTIONS(4968), 1,
      aux_sym_preproc_include_token2,
    STATE(2121), 1,
      sym_preproc_argument_list,
  [62988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_LBRACE,
    ACTIONS(4970), 1,
      sym_identifier,
    STATE(1232), 1,
      sym_enumerator_list,
  [63001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_COMMA,
    ACTIONS(4972), 1,
      anon_sym_RPAREN,
    STATE(1934), 1,
      aux_sym_layout_qualifiers_repeat1,
  [63014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_LBRACE,
    ACTIONS(4974), 1,
      sym_identifier,
    STATE(918), 1,
      sym_field_declaration_list,
  [63027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_COMMA,
    ACTIONS(4976), 1,
      anon_sym_RPAREN,
    STATE(1931), 1,
      aux_sym_parameter_list_repeat1,
  [63040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4646), 1,
      sym_identifier,
    ACTIONS(4648), 1,
      anon_sym_shared,
    STATE(2001), 1,
      sym_qualifier,
  [63053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [63066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4980), 1,
      anon_sym_SEMI,
    STATE(1998), 1,
      aux_sym_declaration_repeat2,
  [63079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4982), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [63092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4984), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [63105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4986), 1,
      anon_sym_SEMI,
    STATE(1941), 1,
      aux_sym_declaration_repeat2,
  [63118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4988), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [63131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3315), 1,
      anon_sym_RPAREN,
    STATE(1926), 1,
      aux_sym_argument_list_repeat1,
  [63144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4990), 1,
      anon_sym_SEMI,
    STATE(1990), 1,
      aux_sym_declaration_repeat2,
  [63157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4992), 1,
      anon_sym_SEMI,
    STATE(1948), 1,
      aux_sym_declaration_repeat2,
  [63170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(498), 1,
      sym_parenthesized_expression,
  [63180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    STATE(104), 1,
      sym_compound_statement,
  [63190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      sym_compound_statement,
  [63200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(500), 1,
      sym_parenthesized_expression,
  [63210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(1980), 1,
      sym_attribute,
  [63220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_compound_statement,
  [63230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(483), 1,
      sym_parenthesized_expression,
  [63240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2043), 1,
      sym_parenthesized_expression,
  [63250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(471), 1,
      sym_parenthesized_expression,
  [63260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(1833), 1,
      sym_compound_statement,
  [63270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4952), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2323), 1,
      sym_parenthesized_expression,
  [63296] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5000), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5002), 1,
      sym_preproc_arg,
  [63306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5004), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [63314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    STATE(2165), 1,
      sym_argument_list,
  [63324] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5006), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5008), 1,
      sym_preproc_arg,
  [63334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2068), 1,
      sym_parenthesized_expression,
  [63344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [63360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    STATE(173), 1,
      sym_compound_statement,
  [63370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5012), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [63378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_compound_statement,
  [63388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    STATE(264), 1,
      sym_compound_statement,
  [63398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_compound_statement,
  [63432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2037), 1,
      sym_parenthesized_expression,
  [63442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_LBRACE,
    STATE(114), 1,
      sym_compound_statement,
  [63452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    STATE(240), 1,
      sym_compound_statement,
  [63462] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5014), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5016), 1,
      sym_preproc_arg,
  [63472] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5018), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5020), 1,
      sym_preproc_arg,
  [63482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(1797), 1,
      sym_compound_statement,
  [63492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [63500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2093), 1,
      sym_parenthesized_expression,
  [63510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_LPAREN2,
    STATE(2261), 1,
      sym_argument_list,
  [63520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [63528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2189), 1,
      sym_parenthesized_expression,
  [63538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5022), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [63546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(2084), 1,
      sym_attribute,
  [63564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2019), 1,
      sym_parenthesized_expression,
  [63574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_compound_statement,
  [63584] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5024), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5026), 1,
      sym_preproc_arg,
  [63594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5028), 1,
      sym_identifier,
    ACTIONS(5030), 1,
      anon_sym_RPAREN,
  [63604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2066), 1,
      sym_parenthesized_expression,
  [63614] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5032), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5034), 1,
      sym_preproc_arg,
  [63624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2288), 1,
      sym_parenthesized_expression,
  [63634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_COMMA,
    ACTIONS(5038), 1,
      anon_sym_RBRACE,
  [63644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(1774), 1,
      sym_compound_statement,
  [63654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5040), 1,
      sym_identifier,
    ACTIONS(5042), 1,
      anon_sym_LPAREN2,
  [63664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      anon_sym_LBRACE,
    STATE(311), 1,
      sym_compound_statement,
  [63674] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4625), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(4627), 1,
      sym_preproc_arg,
  [63684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(207), 1,
      sym_compound_statement,
  [63694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(413), 1,
      anon_sym_LBRACE,
    STATE(273), 1,
      sym_compound_statement,
  [63704] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5044), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5046), 1,
      sym_preproc_arg,
  [63714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_RBRACE,
    ACTIONS(5036), 1,
      anon_sym_COMMA,
  [63724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2034), 1,
      sym_parenthesized_expression,
  [63734] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5048), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5050), 1,
      sym_preproc_arg,
  [63744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63752] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5052), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5054), 1,
      sym_preproc_arg,
  [63762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5056), 1,
      anon_sym_LPAREN2,
    STATE(638), 1,
      sym_layout_qualifiers,
  [63772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(481), 1,
      sym_parenthesized_expression,
  [63782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(273), 1,
      sym_compound_statement,
  [63792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(228), 1,
      sym_compound_statement,
  [63802] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5058), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5060), 1,
      sym_preproc_arg,
  [63812] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5062), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5064), 1,
      sym_preproc_arg,
  [63822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5066), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(475), 1,
      sym_parenthesized_expression,
  [63840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [63848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(512), 1,
      sym_parenthesized_expression,
  [63866] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5068), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5070), 1,
      sym_preproc_arg,
  [63876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(1886), 1,
      sym_attribute,
  [63886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(510), 1,
      sym_parenthesized_expression,
  [63896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2044), 1,
      sym_parenthesized_expression,
  [63906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [63914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(507), 1,
      sym_parenthesized_expression,
  [63924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACE,
    STATE(173), 1,
      sym_compound_statement,
  [63934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2016), 1,
      sym_parenthesized_expression,
  [63944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN2,
    STATE(473), 1,
      sym_parenthesized_expression,
  [63954] = 3,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5072), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(5074), 1,
      sym_preproc_arg,
  [63964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(1951), 1,
      sym_attribute,
  [63974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5076), 1,
      anon_sym_LPAREN2,
    STATE(840), 1,
      sym_layout_qualifiers,
  [63984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4998), 1,
      anon_sym_LPAREN2,
    STATE(2281), 1,
      sym_parenthesized_expression,
  [63994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5078), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [64002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5080), 1,
      sym_identifier,
    ACTIONS(5082), 1,
      anon_sym_LPAREN2,
  [64012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3381), 1,
      anon_sym_SEMI,
  [64019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5084), 1,
      sym_identifier,
  [64026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5086), 1,
      anon_sym_RPAREN,
  [64033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5088), 1,
      anon_sym_COLON,
  [64040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5090), 1,
      sym_identifier,
  [64047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5092), 1,
      sym_identifier,
  [64054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_RPAREN,
  [64061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5094), 1,
      anon_sym_LPAREN2,
  [64068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_RPAREN,
  [64075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_RPAREN,
  [64082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_COLON,
  [64089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_RPAREN,
  [64096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 1,
      anon_sym_SEMI,
  [64103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5100), 1,
      anon_sym_SEMI,
  [64110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5102), 1,
      sym_identifier,
  [64117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_SEMI,
  [64124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5104), 1,
      aux_sym_preproc_if_token2,
  [64131] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5106), 1,
      aux_sym_preproc_include_token2,
  [64138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5108), 1,
      sym_identifier,
  [64145] = 2,
    ACTIONS(3307), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [64152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5110), 1,
      sym_identifier,
  [64159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5036), 1,
      anon_sym_COMMA,
  [64166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5112), 1,
      sym_identifier,
  [64173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 1,
      sym_identifier,
  [64180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5116), 1,
      sym_identifier,
  [64187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 1,
      anon_sym_RPAREN,
  [64194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5120), 1,
      sym_identifier,
  [64201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      sym_identifier,
  [64208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5124), 1,
      sym_identifier,
  [64215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 1,
      anon_sym_RPAREN,
  [64222] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5128), 1,
      aux_sym_preproc_include_token2,
  [64229] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5130), 1,
      aux_sym_preproc_include_token2,
  [64236] = 2,
    ACTIONS(3293), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [64243] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5132), 1,
      aux_sym_preproc_include_token2,
  [64250] = 2,
    ACTIONS(3281), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [64257] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5134), 1,
      aux_sym_preproc_include_token2,
  [64264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5136), 1,
      sym_identifier,
  [64271] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5138), 1,
      aux_sym_preproc_include_token2,
  [64278] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5140), 1,
      aux_sym_preproc_include_token2,
  [64285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 1,
      anon_sym_RPAREN,
  [64292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 1,
      anon_sym_RPAREN,
  [64299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 1,
      aux_sym_preproc_if_token2,
  [64306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5148), 1,
      aux_sym_preproc_if_token2,
  [64313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 1,
      anon_sym_STAR,
  [64320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5152), 1,
      aux_sym_preproc_if_token2,
  [64327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      anon_sym_COLON,
  [64334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      aux_sym_preproc_if_token2,
  [64341] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5156), 1,
      aux_sym_preproc_include_token2,
  [64348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 1,
      aux_sym_preproc_if_token2,
  [64355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5160), 1,
      aux_sym_preproc_if_token2,
  [64362] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5162), 1,
      aux_sym_preproc_include_token2,
  [64369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5164), 1,
      anon_sym_RPAREN,
  [64376] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5166), 1,
      aux_sym_preproc_include_token2,
  [64383] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5168), 1,
      aux_sym_preproc_include_token2,
  [64390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 1,
      anon_sym_RPAREN,
  [64397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5172), 1,
      sym_identifier,
  [64404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_SEMI,
  [64411] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5174), 1,
      aux_sym_preproc_include_token2,
  [64418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5176), 1,
      aux_sym_preproc_if_token2,
  [64425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5178), 1,
      aux_sym_preproc_if_token2,
  [64432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5180), 1,
      aux_sym_preproc_if_token2,
  [64439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5182), 1,
      aux_sym_preproc_if_token2,
  [64446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5184), 1,
      anon_sym_COLON,
  [64453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5186), 1,
      anon_sym_STAR,
  [64460] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5188), 1,
      aux_sym_preproc_include_token2,
  [64467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 1,
      anon_sym_RBRACE,
  [64474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5190), 1,
      anon_sym_RBRACE,
  [64481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 1,
      aux_sym_preproc_if_token2,
  [64488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_COLON,
  [64495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5194), 1,
      aux_sym_preproc_if_token2,
  [64502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 1,
      anon_sym_COLON,
  [64509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5198), 1,
      anon_sym_SEMI,
  [64516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5200), 1,
      anon_sym_SEMI,
  [64523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5202), 1,
      aux_sym_preproc_if_token2,
  [64530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5204), 1,
      sym_identifier,
  [64537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5206), 1,
      anon_sym_SEMI,
  [64544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_SEMI,
  [64551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 1,
      aux_sym_preproc_if_token2,
  [64558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_while,
  [64565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_COMMA,
  [64572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_RBRACE,
  [64579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_COLON,
  [64586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      aux_sym_preproc_if_token2,
  [64593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5216), 1,
      sym_identifier,
  [64600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 1,
      sym_identifier,
  [64607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5220), 1,
      sym_identifier,
  [64614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      sym_identifier,
  [64621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5224), 1,
      anon_sym_SEMI,
  [64628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 1,
      anon_sym_SEMI,
  [64635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5228), 1,
      anon_sym_SEMI,
  [64642] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4968), 1,
      aux_sym_preproc_include_token2,
  [64649] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5230), 1,
      aux_sym_preproc_include_token2,
  [64656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5232), 1,
      aux_sym_preproc_if_token2,
  [64663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      sym_identifier,
  [64670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5236), 1,
      sym_identifier,
  [64677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 1,
      aux_sym_preproc_if_token2,
  [64684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5240), 1,
      aux_sym_preproc_if_token2,
  [64691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 1,
      aux_sym_preproc_if_token2,
  [64698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5244), 1,
      aux_sym_preproc_if_token2,
  [64705] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5246), 1,
      aux_sym_preproc_include_token2,
  [64712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5248), 1,
      aux_sym_preproc_if_token2,
  [64719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 1,
      aux_sym_preproc_if_token2,
  [64726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5252), 1,
      sym_primitive_type,
  [64733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 1,
      anon_sym_SEMI,
  [64740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_RPAREN,
  [64747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3355), 1,
      anon_sym_SEMI,
  [64754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_RPAREN,
  [64761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5256), 1,
      anon_sym_RPAREN,
  [64768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_RPAREN,
  [64775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5258), 1,
      anon_sym_RPAREN,
  [64782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5260), 1,
      sym_identifier,
  [64789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5262), 1,
      sym_identifier,
  [64796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5264), 1,
      sym_identifier,
  [64803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_SEMI,
  [64810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_RPAREN,
  [64817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_SEMI,
  [64824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5270), 1,
      anon_sym_LPAREN2,
  [64831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5272), 1,
      aux_sym_preproc_if_token2,
  [64838] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5274), 1,
      aux_sym_preproc_include_token2,
  [64845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_SEMI,
  [64852] = 2,
    ACTIONS(3285), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [64859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 1,
      anon_sym_SEMI,
  [64866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5278), 1,
      aux_sym_preproc_if_token2,
  [64873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 1,
      anon_sym_SEMI,
  [64880] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4868), 1,
      aux_sym_preproc_include_token2,
  [64887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_SEMI,
  [64894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5282), 1,
      sym_identifier,
  [64901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3405), 1,
      anon_sym_SEMI,
  [64908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_SEMI,
  [64915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      anon_sym_SEMI,
  [64922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_RBRACE,
  [64929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5290), 1,
      aux_sym_preproc_if_token2,
  [64936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 1,
      aux_sym_preproc_if_token2,
  [64943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5294), 1,
      anon_sym_RBRACE,
  [64950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5296), 1,
      aux_sym_preproc_if_token2,
  [64957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5298), 1,
      aux_sym_preproc_if_token2,
  [64964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5300), 1,
      sym_identifier,
  [64971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5302), 1,
      anon_sym_SEMI,
  [64978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3914), 1,
      anon_sym_SEMI,
  [64985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 1,
      aux_sym_preproc_if_token2,
  [64992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
  [64999] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5308), 1,
      aux_sym_preproc_include_token2,
  [65006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5310), 1,
      sym_identifier,
  [65013] = 2,
    ACTIONS(2272), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [65020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 1,
      anon_sym_RPAREN,
  [65027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5314), 1,
      anon_sym_RBRACE,
  [65034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 1,
      aux_sym_preproc_if_token2,
  [65041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5318), 1,
      anon_sym_RPAREN,
  [65048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 1,
      anon_sym_SEMI,
  [65055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 1,
      aux_sym_preproc_if_token2,
  [65062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 1,
      aux_sym_preproc_if_token2,
  [65069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5326), 1,
      anon_sym_SEMI,
  [65076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_COLON,
  [65083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5330), 1,
      anon_sym_RPAREN,
  [65090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 1,
      anon_sym_RBRACK,
  [65097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_RPAREN,
  [65104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 1,
      anon_sym_SEMI,
  [65111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_SEMI,
  [65118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5334), 1,
      anon_sym_STAR,
  [65125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 1,
      anon_sym_RPAREN,
  [65132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5338), 1,
      anon_sym_RPAREN,
  [65139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 1,
      anon_sym_RBRACK,
  [65146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      sym_identifier,
  [65153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5344), 1,
      anon_sym_RPAREN,
  [65160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5346), 1,
      anon_sym_SEMI,
  [65167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 1,
      anon_sym_RPAREN,
  [65174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5348), 1,
      anon_sym_RPAREN,
  [65181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      sym_identifier,
  [65188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_SEMI,
  [65195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5352), 1,
      anon_sym_RBRACE,
  [65202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 1,
      aux_sym_preproc_if_token2,
  [65209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5356), 1,
      aux_sym_preproc_if_token2,
  [65216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      aux_sym_preproc_if_token2,
  [65223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5360), 1,
      aux_sym_preproc_if_token2,
  [65230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 1,
      sym_identifier,
  [65237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5364), 1,
      aux_sym_preproc_if_token2,
  [65244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 1,
      aux_sym_preproc_if_token2,
  [65251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_SEMI,
  [65258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5368), 1,
      anon_sym_LPAREN2,
  [65265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 1,
      anon_sym_SEMI,
  [65272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5372), 1,
      anon_sym_STAR,
  [65279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 1,
      anon_sym_SEMI,
  [65286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5376), 1,
      sym_identifier,
  [65293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 1,
      sym_identifier,
  [65300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5380), 1,
      aux_sym_preproc_if_token2,
  [65307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3910), 1,
      anon_sym_SEMI,
  [65314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 1,
      anon_sym_SEMI,
  [65321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5384), 1,
      anon_sym_SEMI,
  [65328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 1,
      anon_sym_SEMI,
  [65335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5388), 1,
      aux_sym_preproc_if_token2,
  [65342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_LPAREN2,
  [65349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5392), 1,
      anon_sym_LPAREN2,
  [65356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5394), 1,
      anon_sym_RPAREN,
  [65363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_RPAREN,
  [65370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5396), 1,
      anon_sym_RPAREN,
  [65377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 1,
      anon_sym_RBRACE,
  [65384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      aux_sym_preproc_extension_token1,
  [65391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5400), 1,
      aux_sym_preproc_extension_token1,
  [65398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_RPAREN,
  [65405] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5404), 1,
      aux_sym_preproc_include_token2,
  [65412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5406), 1,
      aux_sym_preproc_if_token2,
  [65419] = 2,
    ACTIONS(2276), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(3592), 1,
      sym_comment,
  [65426] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5408), 1,
      aux_sym_preproc_include_token2,
  [65433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5410), 1,
      anon_sym_while,
  [65440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5412), 1,
      aux_sym_preproc_if_token2,
  [65447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5414), 1,
      aux_sym_preproc_if_token2,
  [65454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5416), 1,
      sym_identifier,
  [65461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5418), 1,
      anon_sym_COLON,
  [65468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5420), 1,
      anon_sym_SEMI,
  [65475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5422), 1,
      sym_identifier,
  [65482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_COLON,
  [65489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5424), 1,
      aux_sym_preproc_if_token2,
  [65496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5426), 1,
      anon_sym_SEMI,
  [65503] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4744), 1,
      aux_sym_preproc_include_token2,
  [65510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5428), 1,
      anon_sym_LPAREN2,
  [65517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5430), 1,
      aux_sym_preproc_if_token2,
  [65524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5432), 1,
      aux_sym_preproc_if_token2,
  [65531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5434), 1,
      ts_builtin_sym_end,
  [65538] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5436), 1,
      aux_sym_preproc_include_token2,
  [65545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5438), 1,
      anon_sym_LPAREN2,
  [65552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_RBRACE,
  [65559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5440), 1,
      anon_sym_SEMI,
  [65566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5442), 1,
      aux_sym_preproc_extension_token1,
  [65573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5444), 1,
      anon_sym_SEMI,
  [65580] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5446), 1,
      aux_sym_preproc_include_token2,
  [65587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5448), 1,
      anon_sym_while,
  [65594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5450), 1,
      sym_identifier,
  [65601] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5452), 1,
      aux_sym_preproc_include_token2,
  [65608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      sym_primitive_type,
  [65615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 1,
      anon_sym_LPAREN2,
  [65622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 1,
      anon_sym_LPAREN2,
  [65629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 1,
      anon_sym_LPAREN2,
  [65636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 1,
      sym_identifier,
  [65643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5464), 1,
      anon_sym_SEMI,
  [65650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5466), 1,
      anon_sym_RPAREN,
  [65657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5468), 1,
      anon_sym_SEMI,
  [65664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      anon_sym_COLON,
  [65671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      anon_sym_LPAREN2,
  [65678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 1,
      anon_sym_SEMI,
  [65685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      aux_sym_preproc_extension_token1,
  [65692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 1,
      anon_sym_COLON,
  [65699] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5478), 1,
      aux_sym_preproc_include_token2,
  [65706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 1,
      anon_sym_while,
  [65713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5482), 1,
      aux_sym_preproc_if_token2,
  [65720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 1,
      anon_sym_SEMI,
  [65727] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5486), 1,
      aux_sym_preproc_include_token2,
  [65734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 1,
      aux_sym_preproc_if_token2,
  [65741] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5490), 1,
      aux_sym_preproc_include_token2,
  [65748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 1,
      anon_sym_LPAREN2,
  [65755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5494), 1,
      anon_sym_LPAREN2,
  [65762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5496), 1,
      anon_sym_SEMI,
  [65769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 1,
      anon_sym_LPAREN2,
  [65776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      anon_sym_SEMI,
  [65783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 1,
      anon_sym_LPAREN2,
  [65790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 1,
      aux_sym_preproc_if_token2,
  [65797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3359), 1,
      anon_sym_COLON,
  [65804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 1,
      anon_sym_RPAREN,
  [65811] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(4617), 1,
      aux_sym_preproc_include_token2,
  [65818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_SEMI,
  [65825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5508), 1,
      sym_identifier,
  [65832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 1,
      anon_sym_LPAREN2,
  [65839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_RPAREN,
  [65846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_RPAREN,
  [65853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5516), 1,
      anon_sym_COMMA,
  [65860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5518), 1,
      anon_sym_RPAREN,
  [65867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5520), 1,
      aux_sym_preproc_if_token2,
  [65874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5522), 1,
      sym_identifier,
  [65881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5524), 1,
      aux_sym_preproc_if_token2,
  [65888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5526), 1,
      anon_sym_RPAREN,
  [65895] = 2,
    ACTIONS(3592), 1,
      sym_comment,
    ACTIONS(5528), 1,
      aux_sym_preproc_include_token2,
  [65902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(649)] = 0,
  [SMALL_STATE(650)] = 114,
  [SMALL_STATE(651)] = 228,
  [SMALL_STATE(652)] = 339,
  [SMALL_STATE(653)] = 447,
  [SMALL_STATE(654)] = 555,
  [SMALL_STATE(655)] = 663,
  [SMALL_STATE(656)] = 771,
  [SMALL_STATE(657)] = 879,
  [SMALL_STATE(658)] = 987,
  [SMALL_STATE(659)] = 1095,
  [SMALL_STATE(660)] = 1203,
  [SMALL_STATE(661)] = 1311,
  [SMALL_STATE(662)] = 1401,
  [SMALL_STATE(663)] = 1509,
  [SMALL_STATE(664)] = 1617,
  [SMALL_STATE(665)] = 1725,
  [SMALL_STATE(666)] = 1833,
  [SMALL_STATE(667)] = 1941,
  [SMALL_STATE(668)] = 2049,
  [SMALL_STATE(669)] = 2157,
  [SMALL_STATE(670)] = 2265,
  [SMALL_STATE(671)] = 2373,
  [SMALL_STATE(672)] = 2481,
  [SMALL_STATE(673)] = 2589,
  [SMALL_STATE(674)] = 2697,
  [SMALL_STATE(675)] = 2805,
  [SMALL_STATE(676)] = 2913,
  [SMALL_STATE(677)] = 3021,
  [SMALL_STATE(678)] = 3129,
  [SMALL_STATE(679)] = 3237,
  [SMALL_STATE(680)] = 3345,
  [SMALL_STATE(681)] = 3453,
  [SMALL_STATE(682)] = 3558,
  [SMALL_STATE(683)] = 3663,
  [SMALL_STATE(684)] = 3768,
  [SMALL_STATE(685)] = 3873,
  [SMALL_STATE(686)] = 3978,
  [SMALL_STATE(687)] = 4083,
  [SMALL_STATE(688)] = 4188,
  [SMALL_STATE(689)] = 4293,
  [SMALL_STATE(690)] = 4398,
  [SMALL_STATE(691)] = 4503,
  [SMALL_STATE(692)] = 4608,
  [SMALL_STATE(693)] = 4713,
  [SMALL_STATE(694)] = 4818,
  [SMALL_STATE(695)] = 4920,
  [SMALL_STATE(696)] = 5022,
  [SMALL_STATE(697)] = 5124,
  [SMALL_STATE(698)] = 5226,
  [SMALL_STATE(699)] = 5328,
  [SMALL_STATE(700)] = 5430,
  [SMALL_STATE(701)] = 5532,
  [SMALL_STATE(702)] = 5634,
  [SMALL_STATE(703)] = 5736,
  [SMALL_STATE(704)] = 5838,
  [SMALL_STATE(705)] = 5940,
  [SMALL_STATE(706)] = 6042,
  [SMALL_STATE(707)] = 6144,
  [SMALL_STATE(708)] = 6246,
  [SMALL_STATE(709)] = 6348,
  [SMALL_STATE(710)] = 6450,
  [SMALL_STATE(711)] = 6552,
  [SMALL_STATE(712)] = 6654,
  [SMALL_STATE(713)] = 6756,
  [SMALL_STATE(714)] = 6858,
  [SMALL_STATE(715)] = 6960,
  [SMALL_STATE(716)] = 7062,
  [SMALL_STATE(717)] = 7164,
  [SMALL_STATE(718)] = 7266,
  [SMALL_STATE(719)] = 7368,
  [SMALL_STATE(720)] = 7470,
  [SMALL_STATE(721)] = 7572,
  [SMALL_STATE(722)] = 7674,
  [SMALL_STATE(723)] = 7776,
  [SMALL_STATE(724)] = 7878,
  [SMALL_STATE(725)] = 7980,
  [SMALL_STATE(726)] = 8082,
  [SMALL_STATE(727)] = 8184,
  [SMALL_STATE(728)] = 8286,
  [SMALL_STATE(729)] = 8388,
  [SMALL_STATE(730)] = 8490,
  [SMALL_STATE(731)] = 8592,
  [SMALL_STATE(732)] = 8694,
  [SMALL_STATE(733)] = 8796,
  [SMALL_STATE(734)] = 8898,
  [SMALL_STATE(735)] = 9000,
  [SMALL_STATE(736)] = 9102,
  [SMALL_STATE(737)] = 9204,
  [SMALL_STATE(738)] = 9306,
  [SMALL_STATE(739)] = 9408,
  [SMALL_STATE(740)] = 9510,
  [SMALL_STATE(741)] = 9612,
  [SMALL_STATE(742)] = 9714,
  [SMALL_STATE(743)] = 9816,
  [SMALL_STATE(744)] = 9918,
  [SMALL_STATE(745)] = 10020,
  [SMALL_STATE(746)] = 10122,
  [SMALL_STATE(747)] = 10224,
  [SMALL_STATE(748)] = 10326,
  [SMALL_STATE(749)] = 10428,
  [SMALL_STATE(750)] = 10530,
  [SMALL_STATE(751)] = 10632,
  [SMALL_STATE(752)] = 10734,
  [SMALL_STATE(753)] = 10836,
  [SMALL_STATE(754)] = 10938,
  [SMALL_STATE(755)] = 11040,
  [SMALL_STATE(756)] = 11142,
  [SMALL_STATE(757)] = 11244,
  [SMALL_STATE(758)] = 11346,
  [SMALL_STATE(759)] = 11448,
  [SMALL_STATE(760)] = 11550,
  [SMALL_STATE(761)] = 11652,
  [SMALL_STATE(762)] = 11754,
  [SMALL_STATE(763)] = 11856,
  [SMALL_STATE(764)] = 11958,
  [SMALL_STATE(765)] = 12060,
  [SMALL_STATE(766)] = 12162,
  [SMALL_STATE(767)] = 12264,
  [SMALL_STATE(768)] = 12366,
  [SMALL_STATE(769)] = 12468,
  [SMALL_STATE(770)] = 12570,
  [SMALL_STATE(771)] = 12672,
  [SMALL_STATE(772)] = 12774,
  [SMALL_STATE(773)] = 12876,
  [SMALL_STATE(774)] = 12978,
  [SMALL_STATE(775)] = 13080,
  [SMALL_STATE(776)] = 13182,
  [SMALL_STATE(777)] = 13284,
  [SMALL_STATE(778)] = 13386,
  [SMALL_STATE(779)] = 13488,
  [SMALL_STATE(780)] = 13590,
  [SMALL_STATE(781)] = 13692,
  [SMALL_STATE(782)] = 13794,
  [SMALL_STATE(783)] = 13896,
  [SMALL_STATE(784)] = 13998,
  [SMALL_STATE(785)] = 14100,
  [SMALL_STATE(786)] = 14202,
  [SMALL_STATE(787)] = 14304,
  [SMALL_STATE(788)] = 14406,
  [SMALL_STATE(789)] = 14508,
  [SMALL_STATE(790)] = 14610,
  [SMALL_STATE(791)] = 14712,
  [SMALL_STATE(792)] = 14814,
  [SMALL_STATE(793)] = 14916,
  [SMALL_STATE(794)] = 15018,
  [SMALL_STATE(795)] = 15120,
  [SMALL_STATE(796)] = 15222,
  [SMALL_STATE(797)] = 15324,
  [SMALL_STATE(798)] = 15426,
  [SMALL_STATE(799)] = 15528,
  [SMALL_STATE(800)] = 15630,
  [SMALL_STATE(801)] = 15732,
  [SMALL_STATE(802)] = 15834,
  [SMALL_STATE(803)] = 15936,
  [SMALL_STATE(804)] = 16038,
  [SMALL_STATE(805)] = 16140,
  [SMALL_STATE(806)] = 16242,
  [SMALL_STATE(807)] = 16344,
  [SMALL_STATE(808)] = 16446,
  [SMALL_STATE(809)] = 16548,
  [SMALL_STATE(810)] = 16650,
  [SMALL_STATE(811)] = 16721,
  [SMALL_STATE(812)] = 16792,
  [SMALL_STATE(813)] = 16863,
  [SMALL_STATE(814)] = 16963,
  [SMALL_STATE(815)] = 17063,
  [SMALL_STATE(816)] = 17131,
  [SMALL_STATE(817)] = 17231,
  [SMALL_STATE(818)] = 17331,
  [SMALL_STATE(819)] = 17431,
  [SMALL_STATE(820)] = 17531,
  [SMALL_STATE(821)] = 17631,
  [SMALL_STATE(822)] = 17731,
  [SMALL_STATE(823)] = 17831,
  [SMALL_STATE(824)] = 17931,
  [SMALL_STATE(825)] = 18031,
  [SMALL_STATE(826)] = 18131,
  [SMALL_STATE(827)] = 18194,
  [SMALL_STATE(828)] = 18257,
  [SMALL_STATE(829)] = 18319,
  [SMALL_STATE(830)] = 18381,
  [SMALL_STATE(831)] = 18459,
  [SMALL_STATE(832)] = 18521,
  [SMALL_STATE(833)] = 18583,
  [SMALL_STATE(834)] = 18645,
  [SMALL_STATE(835)] = 18707,
  [SMALL_STATE(836)] = 18769,
  [SMALL_STATE(837)] = 18831,
  [SMALL_STATE(838)] = 18899,
  [SMALL_STATE(839)] = 18961,
  [SMALL_STATE(840)] = 19023,
  [SMALL_STATE(841)] = 19083,
  [SMALL_STATE(842)] = 19143,
  [SMALL_STATE(843)] = 19203,
  [SMALL_STATE(844)] = 19262,
  [SMALL_STATE(845)] = 19321,
  [SMALL_STATE(846)] = 19380,
  [SMALL_STATE(847)] = 19439,
  [SMALL_STATE(848)] = 19508,
  [SMALL_STATE(849)] = 19567,
  [SMALL_STATE(850)] = 19632,
  [SMALL_STATE(851)] = 19690,
  [SMALL_STATE(852)] = 19748,
  [SMALL_STATE(853)] = 19806,
  [SMALL_STATE(854)] = 19864,
  [SMALL_STATE(855)] = 19922,
  [SMALL_STATE(856)] = 19980,
  [SMALL_STATE(857)] = 20038,
  [SMALL_STATE(858)] = 20096,
  [SMALL_STATE(859)] = 20154,
  [SMALL_STATE(860)] = 20212,
  [SMALL_STATE(861)] = 20270,
  [SMALL_STATE(862)] = 20328,
  [SMALL_STATE(863)] = 20386,
  [SMALL_STATE(864)] = 20444,
  [SMALL_STATE(865)] = 20502,
  [SMALL_STATE(866)] = 20560,
  [SMALL_STATE(867)] = 20618,
  [SMALL_STATE(868)] = 20707,
  [SMALL_STATE(869)] = 20796,
  [SMALL_STATE(870)] = 20885,
  [SMALL_STATE(871)] = 20952,
  [SMALL_STATE(872)] = 21019,
  [SMALL_STATE(873)] = 21108,
  [SMALL_STATE(874)] = 21165,
  [SMALL_STATE(875)] = 21254,
  [SMALL_STATE(876)] = 21311,
  [SMALL_STATE(877)] = 21400,
  [SMALL_STATE(878)] = 21467,
  [SMALL_STATE(879)] = 21556,
  [SMALL_STATE(880)] = 21645,
  [SMALL_STATE(881)] = 21734,
  [SMALL_STATE(882)] = 21823,
  [SMALL_STATE(883)] = 21912,
  [SMALL_STATE(884)] = 22001,
  [SMALL_STATE(885)] = 22068,
  [SMALL_STATE(886)] = 22125,
  [SMALL_STATE(887)] = 22190,
  [SMALL_STATE(888)] = 22279,
  [SMALL_STATE(889)] = 22368,
  [SMALL_STATE(890)] = 22457,
  [SMALL_STATE(891)] = 22546,
  [SMALL_STATE(892)] = 22635,
  [SMALL_STATE(893)] = 22702,
  [SMALL_STATE(894)] = 22791,
  [SMALL_STATE(895)] = 22848,
  [SMALL_STATE(896)] = 22937,
  [SMALL_STATE(897)] = 23026,
  [SMALL_STATE(898)] = 23091,
  [SMALL_STATE(899)] = 23152,
  [SMALL_STATE(900)] = 23208,
  [SMALL_STATE(901)] = 23272,
  [SMALL_STATE(902)] = 23328,
  [SMALL_STATE(903)] = 23414,
  [SMALL_STATE(904)] = 23477,
  [SMALL_STATE(905)] = 23532,
  [SMALL_STATE(906)] = 23587,
  [SMALL_STATE(907)] = 23650,
  [SMALL_STATE(908)] = 23713,
  [SMALL_STATE(909)] = 23768,
  [SMALL_STATE(910)] = 23831,
  [SMALL_STATE(911)] = 23894,
  [SMALL_STATE(912)] = 23964,
  [SMALL_STATE(913)] = 24034,
  [SMALL_STATE(914)] = 24088,
  [SMALL_STATE(915)] = 24142,
  [SMALL_STATE(916)] = 24212,
  [SMALL_STATE(917)] = 24282,
  [SMALL_STATE(918)] = 24336,
  [SMALL_STATE(919)] = 24393,
  [SMALL_STATE(920)] = 24450,
  [SMALL_STATE(921)] = 24507,
  [SMALL_STATE(922)] = 24570,
  [SMALL_STATE(923)] = 24633,
  [SMALL_STATE(924)] = 24690,
  [SMALL_STATE(925)] = 24753,
  [SMALL_STATE(926)] = 24810,
  [SMALL_STATE(927)] = 24867,
  [SMALL_STATE(928)] = 24924,
  [SMALL_STATE(929)] = 24987,
  [SMALL_STATE(930)] = 25050,
  [SMALL_STATE(931)] = 25107,
  [SMALL_STATE(932)] = 25164,
  [SMALL_STATE(933)] = 25221,
  [SMALL_STATE(934)] = 25278,
  [SMALL_STATE(935)] = 25341,
  [SMALL_STATE(936)] = 25407,
  [SMALL_STATE(937)] = 25463,
  [SMALL_STATE(938)] = 25515,
  [SMALL_STATE(939)] = 25589,
  [SMALL_STATE(940)] = 25665,
  [SMALL_STATE(941)] = 25743,
  [SMALL_STATE(942)] = 25823,
  [SMALL_STATE(943)] = 25905,
  [SMALL_STATE(944)] = 25969,
  [SMALL_STATE(945)] = 26055,
  [SMALL_STATE(946)] = 26113,
  [SMALL_STATE(947)] = 26165,
  [SMALL_STATE(948)] = 26217,
  [SMALL_STATE(949)] = 26269,
  [SMALL_STATE(950)] = 26325,
  [SMALL_STATE(951)] = 26377,
  [SMALL_STATE(952)] = 26429,
  [SMALL_STATE(953)] = 26497,
  [SMALL_STATE(954)] = 26549,
  [SMALL_STATE(955)] = 26607,
  [SMALL_STATE(956)] = 26659,
  [SMALL_STATE(957)] = 26711,
  [SMALL_STATE(958)] = 26763,
  [SMALL_STATE(959)] = 26849,
  [SMALL_STATE(960)] = 26909,
  [SMALL_STATE(961)] = 26981,
  [SMALL_STATE(962)] = 27037,
  [SMALL_STATE(963)] = 27089,
  [SMALL_STATE(964)] = 27141,
  [SMALL_STATE(965)] = 27193,
  [SMALL_STATE(966)] = 27279,
  [SMALL_STATE(967)] = 27331,
  [SMALL_STATE(968)] = 27387,
  [SMALL_STATE(969)] = 27439,
  [SMALL_STATE(970)] = 27491,
  [SMALL_STATE(971)] = 27543,
  [SMALL_STATE(972)] = 27595,
  [SMALL_STATE(973)] = 27647,
  [SMALL_STATE(974)] = 27699,
  [SMALL_STATE(975)] = 27751,
  [SMALL_STATE(976)] = 27811,
  [SMALL_STATE(977)] = 27863,
  [SMALL_STATE(978)] = 27915,
  [SMALL_STATE(979)] = 27971,
  [SMALL_STATE(980)] = 28027,
  [SMALL_STATE(981)] = 28079,
  [SMALL_STATE(982)] = 28131,
  [SMALL_STATE(983)] = 28187,
  [SMALL_STATE(984)] = 28239,
  [SMALL_STATE(985)] = 28291,
  [SMALL_STATE(986)] = 28376,
  [SMALL_STATE(987)] = 28449,
  [SMALL_STATE(988)] = 28512,
  [SMALL_STATE(989)] = 28593,
  [SMALL_STATE(990)] = 28662,
  [SMALL_STATE(991)] = 28731,
  [SMALL_STATE(992)] = 28800,
  [SMALL_STATE(993)] = 28885,
  [SMALL_STATE(994)] = 28964,
  [SMALL_STATE(995)] = 29041,
  [SMALL_STATE(996)] = 29116,
  [SMALL_STATE(997)] = 29181,
  [SMALL_STATE(998)] = 29236,
  [SMALL_STATE(999)] = 29307,
  [SMALL_STATE(1000)] = 29374,
  [SMALL_STATE(1001)] = 29443,
  [SMALL_STATE(1002)] = 29528,
  [SMALL_STATE(1003)] = 29582,
  [SMALL_STATE(1004)] = 29642,
  [SMALL_STATE(1005)] = 29728,
  [SMALL_STATE(1006)] = 29814,
  [SMALL_STATE(1007)] = 29873,
  [SMALL_STATE(1008)] = 29932,
  [SMALL_STATE(1009)] = 29991,
  [SMALL_STATE(1010)] = 30050,
  [SMALL_STATE(1011)] = 30109,
  [SMALL_STATE(1012)] = 30168,
  [SMALL_STATE(1013)] = 30225,
  [SMALL_STATE(1014)] = 30284,
  [SMALL_STATE(1015)] = 30343,
  [SMALL_STATE(1016)] = 30402,
  [SMALL_STATE(1017)] = 30479,
  [SMALL_STATE(1018)] = 30538,
  [SMALL_STATE(1019)] = 30613,
  [SMALL_STATE(1020)] = 30672,
  [SMALL_STATE(1021)] = 30731,
  [SMALL_STATE(1022)] = 30802,
  [SMALL_STATE(1023)] = 30853,
  [SMALL_STATE(1024)] = 30904,
  [SMALL_STATE(1025)] = 30955,
  [SMALL_STATE(1026)] = 31006,
  [SMALL_STATE(1027)] = 31089,
  [SMALL_STATE(1028)] = 31150,
  [SMALL_STATE(1029)] = 31229,
  [SMALL_STATE(1030)] = 31288,
  [SMALL_STATE(1031)] = 31347,
  [SMALL_STATE(1032)] = 31416,
  [SMALL_STATE(1033)] = 31467,
  [SMALL_STATE(1034)] = 31540,
  [SMALL_STATE(1035)] = 31605,
  [SMALL_STATE(1036)] = 31662,
  [SMALL_STATE(1037)] = 31725,
  [SMALL_STATE(1038)] = 31776,
  [SMALL_STATE(1039)] = 31859,
  [SMALL_STATE(1040)] = 31910,
  [SMALL_STATE(1041)] = 31993,
  [SMALL_STATE(1042)] = 32069,
  [SMALL_STATE(1043)] = 32115,
  [SMALL_STATE(1044)] = 32161,
  [SMALL_STATE(1045)] = 32237,
  [SMALL_STATE(1046)] = 32287,
  [SMALL_STATE(1047)] = 32363,
  [SMALL_STATE(1048)] = 32439,
  [SMALL_STATE(1049)] = 32485,
  [SMALL_STATE(1050)] = 32531,
  [SMALL_STATE(1051)] = 32576,
  [SMALL_STATE(1052)] = 32627,
  [SMALL_STATE(1053)] = 32671,
  [SMALL_STATE(1054)] = 32715,
  [SMALL_STATE(1055)] = 32759,
  [SMALL_STATE(1056)] = 32803,
  [SMALL_STATE(1057)] = 32847,
  [SMALL_STATE(1058)] = 32891,
  [SMALL_STATE(1059)] = 32935,
  [SMALL_STATE(1060)] = 32979,
  [SMALL_STATE(1061)] = 33023,
  [SMALL_STATE(1062)] = 33067,
  [SMALL_STATE(1063)] = 33121,
  [SMALL_STATE(1064)] = 33165,
  [SMALL_STATE(1065)] = 33209,
  [SMALL_STATE(1066)] = 33253,
  [SMALL_STATE(1067)] = 33297,
  [SMALL_STATE(1068)] = 33341,
  [SMALL_STATE(1069)] = 33385,
  [SMALL_STATE(1070)] = 33429,
  [SMALL_STATE(1071)] = 33473,
  [SMALL_STATE(1072)] = 33517,
  [SMALL_STATE(1073)] = 33561,
  [SMALL_STATE(1074)] = 33605,
  [SMALL_STATE(1075)] = 33649,
  [SMALL_STATE(1076)] = 33693,
  [SMALL_STATE(1077)] = 33765,
  [SMALL_STATE(1078)] = 33809,
  [SMALL_STATE(1079)] = 33853,
  [SMALL_STATE(1080)] = 33897,
  [SMALL_STATE(1081)] = 33967,
  [SMALL_STATE(1082)] = 34039,
  [SMALL_STATE(1083)] = 34083,
  [SMALL_STATE(1084)] = 34153,
  [SMALL_STATE(1085)] = 34220,
  [SMALL_STATE(1086)] = 34277,
  [SMALL_STATE(1087)] = 34348,
  [SMALL_STATE(1088)] = 34407,
  [SMALL_STATE(1089)] = 34480,
  [SMALL_STATE(1090)] = 34547,
  [SMALL_STATE(1091)] = 34614,
  [SMALL_STATE(1092)] = 34691,
  [SMALL_STATE(1093)] = 34758,
  [SMALL_STATE(1094)] = 34835,
  [SMALL_STATE(1095)] = 34890,
  [SMALL_STATE(1096)] = 34953,
  [SMALL_STATE(1097)] = 35020,
  [SMALL_STATE(1098)] = 35087,
  [SMALL_STATE(1099)] = 35164,
  [SMALL_STATE(1100)] = 35231,
  [SMALL_STATE(1101)] = 35296,
  [SMALL_STATE(1102)] = 35365,
  [SMALL_STATE(1103)] = 35442,
  [SMALL_STATE(1104)] = 35509,
  [SMALL_STATE(1105)] = 35576,
  [SMALL_STATE(1106)] = 35650,
  [SMALL_STATE(1107)] = 35704,
  [SMALL_STATE(1108)] = 35760,
  [SMALL_STATE(1109)] = 35808,
  [SMALL_STATE(1110)] = 35882,
  [SMALL_STATE(1111)] = 35940,
  [SMALL_STATE(1112)] = 36002,
  [SMALL_STATE(1113)] = 36076,
  [SMALL_STATE(1114)] = 36140,
  [SMALL_STATE(1115)] = 36206,
  [SMALL_STATE(1116)] = 36274,
  [SMALL_STATE(1117)] = 36342,
  [SMALL_STATE(1118)] = 36412,
  [SMALL_STATE(1119)] = 36475,
  [SMALL_STATE(1120)] = 36538,
  [SMALL_STATE(1121)] = 36601,
  [SMALL_STATE(1122)] = 36664,
  [SMALL_STATE(1123)] = 36727,
  [SMALL_STATE(1124)] = 36790,
  [SMALL_STATE(1125)] = 36853,
  [SMALL_STATE(1126)] = 36916,
  [SMALL_STATE(1127)] = 36979,
  [SMALL_STATE(1128)] = 37042,
  [SMALL_STATE(1129)] = 37105,
  [SMALL_STATE(1130)] = 37168,
  [SMALL_STATE(1131)] = 37231,
  [SMALL_STATE(1132)] = 37269,
  [SMALL_STATE(1133)] = 37307,
  [SMALL_STATE(1134)] = 37367,
  [SMALL_STATE(1135)] = 37441,
  [SMALL_STATE(1136)] = 37479,
  [SMALL_STATE(1137)] = 37539,
  [SMALL_STATE(1138)] = 37585,
  [SMALL_STATE(1139)] = 37645,
  [SMALL_STATE(1140)] = 37683,
  [SMALL_STATE(1141)] = 37743,
  [SMALL_STATE(1142)] = 37803,
  [SMALL_STATE(1143)] = 37863,
  [SMALL_STATE(1144)] = 37938,
  [SMALL_STATE(1145)] = 38013,
  [SMALL_STATE(1146)] = 38088,
  [SMALL_STATE(1147)] = 38125,
  [SMALL_STATE(1148)] = 38196,
  [SMALL_STATE(1149)] = 38271,
  [SMALL_STATE(1150)] = 38346,
  [SMALL_STATE(1151)] = 38421,
  [SMALL_STATE(1152)] = 38458,
  [SMALL_STATE(1153)] = 38528,
  [SMALL_STATE(1154)] = 38580,
  [SMALL_STATE(1155)] = 38652,
  [SMALL_STATE(1156)] = 38724,
  [SMALL_STATE(1157)] = 38786,
  [SMALL_STATE(1158)] = 38858,
  [SMALL_STATE(1159)] = 38930,
  [SMALL_STATE(1160)] = 39002,
  [SMALL_STATE(1161)] = 39074,
  [SMALL_STATE(1162)] = 39146,
  [SMALL_STATE(1163)] = 39218,
  [SMALL_STATE(1164)] = 39290,
  [SMALL_STATE(1165)] = 39360,
  [SMALL_STATE(1166)] = 39432,
  [SMALL_STATE(1167)] = 39488,
  [SMALL_STATE(1168)] = 39552,
  [SMALL_STATE(1169)] = 39622,
  [SMALL_STATE(1170)] = 39694,
  [SMALL_STATE(1171)] = 39760,
  [SMALL_STATE(1172)] = 39832,
  [SMALL_STATE(1173)] = 39902,
  [SMALL_STATE(1174)] = 39968,
  [SMALL_STATE(1175)] = 40038,
  [SMALL_STATE(1176)] = 40108,
  [SMALL_STATE(1177)] = 40180,
  [SMALL_STATE(1178)] = 40226,
  [SMALL_STATE(1179)] = 40294,
  [SMALL_STATE(1180)] = 40366,
  [SMALL_STATE(1181)] = 40436,
  [SMALL_STATE(1182)] = 40508,
  [SMALL_STATE(1183)] = 40580,
  [SMALL_STATE(1184)] = 40652,
  [SMALL_STATE(1185)] = 40706,
  [SMALL_STATE(1186)] = 40778,
  [SMALL_STATE(1187)] = 40838,
  [SMALL_STATE(1188)] = 40908,
  [SMALL_STATE(1189)] = 40980,
  [SMALL_STATE(1190)] = 41052,
  [SMALL_STATE(1191)] = 41124,
  [SMALL_STATE(1192)] = 41196,
  [SMALL_STATE(1193)] = 41268,
  [SMALL_STATE(1194)] = 41342,
  [SMALL_STATE(1195)] = 41414,
  [SMALL_STATE(1196)] = 41486,
  [SMALL_STATE(1197)] = 41530,
  [SMALL_STATE(1198)] = 41602,
  [SMALL_STATE(1199)] = 41674,
  [SMALL_STATE(1200)] = 41746,
  [SMALL_STATE(1201)] = 41816,
  [SMALL_STATE(1202)] = 41888,
  [SMALL_STATE(1203)] = 41957,
  [SMALL_STATE(1204)] = 42026,
  [SMALL_STATE(1205)] = 42095,
  [SMALL_STATE(1206)] = 42164,
  [SMALL_STATE(1207)] = 42233,
  [SMALL_STATE(1208)] = 42302,
  [SMALL_STATE(1209)] = 42371,
  [SMALL_STATE(1210)] = 42440,
  [SMALL_STATE(1211)] = 42509,
  [SMALL_STATE(1212)] = 42578,
  [SMALL_STATE(1213)] = 42647,
  [SMALL_STATE(1214)] = 42716,
  [SMALL_STATE(1215)] = 42785,
  [SMALL_STATE(1216)] = 42854,
  [SMALL_STATE(1217)] = 42923,
  [SMALL_STATE(1218)] = 42992,
  [SMALL_STATE(1219)] = 43061,
  [SMALL_STATE(1220)] = 43130,
  [SMALL_STATE(1221)] = 43199,
  [SMALL_STATE(1222)] = 43268,
  [SMALL_STATE(1223)] = 43337,
  [SMALL_STATE(1224)] = 43406,
  [SMALL_STATE(1225)] = 43460,
  [SMALL_STATE(1226)] = 43514,
  [SMALL_STATE(1227)] = 43568,
  [SMALL_STATE(1228)] = 43606,
  [SMALL_STATE(1229)] = 43660,
  [SMALL_STATE(1230)] = 43714,
  [SMALL_STATE(1231)] = 43752,
  [SMALL_STATE(1232)] = 43788,
  [SMALL_STATE(1233)] = 43826,
  [SMALL_STATE(1234)] = 43880,
  [SMALL_STATE(1235)] = 43946,
  [SMALL_STATE(1236)] = 43997,
  [SMALL_STATE(1237)] = 44048,
  [SMALL_STATE(1238)] = 44099,
  [SMALL_STATE(1239)] = 44150,
  [SMALL_STATE(1240)] = 44201,
  [SMALL_STATE(1241)] = 44252,
  [SMALL_STATE(1242)] = 44290,
  [SMALL_STATE(1243)] = 44330,
  [SMALL_STATE(1244)] = 44369,
  [SMALL_STATE(1245)] = 44408,
  [SMALL_STATE(1246)] = 44447,
  [SMALL_STATE(1247)] = 44486,
  [SMALL_STATE(1248)] = 44535,
  [SMALL_STATE(1249)] = 44569,
  [SMALL_STATE(1250)] = 44602,
  [SMALL_STATE(1251)] = 44653,
  [SMALL_STATE(1252)] = 44708,
  [SMALL_STATE(1253)] = 44741,
  [SMALL_STATE(1254)] = 44792,
  [SMALL_STATE(1255)] = 44843,
  [SMALL_STATE(1256)] = 44894,
  [SMALL_STATE(1257)] = 44927,
  [SMALL_STATE(1258)] = 44978,
  [SMALL_STATE(1259)] = 45029,
  [SMALL_STATE(1260)] = 45064,
  [SMALL_STATE(1261)] = 45107,
  [SMALL_STATE(1262)] = 45150,
  [SMALL_STATE(1263)] = 45201,
  [SMALL_STATE(1264)] = 45234,
  [SMALL_STATE(1265)] = 45285,
  [SMALL_STATE(1266)] = 45318,
  [SMALL_STATE(1267)] = 45351,
  [SMALL_STATE(1268)] = 45394,
  [SMALL_STATE(1269)] = 45445,
  [SMALL_STATE(1270)] = 45478,
  [SMALL_STATE(1271)] = 45529,
  [SMALL_STATE(1272)] = 45580,
  [SMALL_STATE(1273)] = 45631,
  [SMALL_STATE(1274)] = 45686,
  [SMALL_STATE(1275)] = 45719,
  [SMALL_STATE(1276)] = 45770,
  [SMALL_STATE(1277)] = 45821,
  [SMALL_STATE(1278)] = 45872,
  [SMALL_STATE(1279)] = 45927,
  [SMALL_STATE(1280)] = 45964,
  [SMALL_STATE(1281)] = 45997,
  [SMALL_STATE(1282)] = 46025,
  [SMALL_STATE(1283)] = 46061,
  [SMALL_STATE(1284)] = 46101,
  [SMALL_STATE(1285)] = 46129,
  [SMALL_STATE(1286)] = 46169,
  [SMALL_STATE(1287)] = 46209,
  [SMALL_STATE(1288)] = 46249,
  [SMALL_STATE(1289)] = 46289,
  [SMALL_STATE(1290)] = 46329,
  [SMALL_STATE(1291)] = 46369,
  [SMALL_STATE(1292)] = 46409,
  [SMALL_STATE(1293)] = 46449,
  [SMALL_STATE(1294)] = 46489,
  [SMALL_STATE(1295)] = 46529,
  [SMALL_STATE(1296)] = 46569,
  [SMALL_STATE(1297)] = 46609,
  [SMALL_STATE(1298)] = 46649,
  [SMALL_STATE(1299)] = 46689,
  [SMALL_STATE(1300)] = 46729,
  [SMALL_STATE(1301)] = 46757,
  [SMALL_STATE(1302)] = 46797,
  [SMALL_STATE(1303)] = 46837,
  [SMALL_STATE(1304)] = 46877,
  [SMALL_STATE(1305)] = 46917,
  [SMALL_STATE(1306)] = 46957,
  [SMALL_STATE(1307)] = 46997,
  [SMALL_STATE(1308)] = 47037,
  [SMALL_STATE(1309)] = 47077,
  [SMALL_STATE(1310)] = 47117,
  [SMALL_STATE(1311)] = 47157,
  [SMALL_STATE(1312)] = 47205,
  [SMALL_STATE(1313)] = 47245,
  [SMALL_STATE(1314)] = 47285,
  [SMALL_STATE(1315)] = 47333,
  [SMALL_STATE(1316)] = 47373,
  [SMALL_STATE(1317)] = 47413,
  [SMALL_STATE(1318)] = 47453,
  [SMALL_STATE(1319)] = 47493,
  [SMALL_STATE(1320)] = 47521,
  [SMALL_STATE(1321)] = 47561,
  [SMALL_STATE(1322)] = 47601,
  [SMALL_STATE(1323)] = 47629,
  [SMALL_STATE(1324)] = 47669,
  [SMALL_STATE(1325)] = 47709,
  [SMALL_STATE(1326)] = 47749,
  [SMALL_STATE(1327)] = 47799,
  [SMALL_STATE(1328)] = 47833,
  [SMALL_STATE(1329)] = 47873,
  [SMALL_STATE(1330)] = 47913,
  [SMALL_STATE(1331)] = 47955,
  [SMALL_STATE(1332)] = 47999,
  [SMALL_STATE(1333)] = 48045,
  [SMALL_STATE(1334)] = 48085,
  [SMALL_STATE(1335)] = 48117,
  [SMALL_STATE(1336)] = 48163,
  [SMALL_STATE(1337)] = 48211,
  [SMALL_STATE(1338)] = 48239,
  [SMALL_STATE(1339)] = 48270,
  [SMALL_STATE(1340)] = 48315,
  [SMALL_STATE(1341)] = 48342,
  [SMALL_STATE(1342)] = 48369,
  [SMALL_STATE(1343)] = 48406,
  [SMALL_STATE(1344)] = 48455,
  [SMALL_STATE(1345)] = 48500,
  [SMALL_STATE(1346)] = 48527,
  [SMALL_STATE(1347)] = 48572,
  [SMALL_STATE(1348)] = 48611,
  [SMALL_STATE(1349)] = 48638,
  [SMALL_STATE(1350)] = 48683,
  [SMALL_STATE(1351)] = 48710,
  [SMALL_STATE(1352)] = 48743,
  [SMALL_STATE(1353)] = 48788,
  [SMALL_STATE(1354)] = 48815,
  [SMALL_STATE(1355)] = 48860,
  [SMALL_STATE(1356)] = 48905,
  [SMALL_STATE(1357)] = 48950,
  [SMALL_STATE(1358)] = 48977,
  [SMALL_STATE(1359)] = 49014,
  [SMALL_STATE(1360)] = 49059,
  [SMALL_STATE(1361)] = 49104,
  [SMALL_STATE(1362)] = 49131,
  [SMALL_STATE(1363)] = 49158,
  [SMALL_STATE(1364)] = 49203,
  [SMALL_STATE(1365)] = 49238,
  [SMALL_STATE(1366)] = 49279,
  [SMALL_STATE(1367)] = 49324,
  [SMALL_STATE(1368)] = 49351,
  [SMALL_STATE(1369)] = 49394,
  [SMALL_STATE(1370)] = 49439,
  [SMALL_STATE(1371)] = 49488,
  [SMALL_STATE(1372)] = 49517,
  [SMALL_STATE(1373)] = 49562,
  [SMALL_STATE(1374)] = 49607,
  [SMALL_STATE(1375)] = 49647,
  [SMALL_STATE(1376)] = 49687,
  [SMALL_STATE(1377)] = 49727,
  [SMALL_STATE(1378)] = 49767,
  [SMALL_STATE(1379)] = 49807,
  [SMALL_STATE(1380)] = 49847,
  [SMALL_STATE(1381)] = 49887,
  [SMALL_STATE(1382)] = 49927,
  [SMALL_STATE(1383)] = 49967,
  [SMALL_STATE(1384)] = 50007,
  [SMALL_STATE(1385)] = 50047,
  [SMALL_STATE(1386)] = 50087,
  [SMALL_STATE(1387)] = 50127,
  [SMALL_STATE(1388)] = 50167,
  [SMALL_STATE(1389)] = 50207,
  [SMALL_STATE(1390)] = 50247,
  [SMALL_STATE(1391)] = 50287,
  [SMALL_STATE(1392)] = 50327,
  [SMALL_STATE(1393)] = 50367,
  [SMALL_STATE(1394)] = 50411,
  [SMALL_STATE(1395)] = 50451,
  [SMALL_STATE(1396)] = 50491,
  [SMALL_STATE(1397)] = 50531,
  [SMALL_STATE(1398)] = 50571,
  [SMALL_STATE(1399)] = 50611,
  [SMALL_STATE(1400)] = 50651,
  [SMALL_STATE(1401)] = 50691,
  [SMALL_STATE(1402)] = 50731,
  [SMALL_STATE(1403)] = 50771,
  [SMALL_STATE(1404)] = 50811,
  [SMALL_STATE(1405)] = 50851,
  [SMALL_STATE(1406)] = 50891,
  [SMALL_STATE(1407)] = 50931,
  [SMALL_STATE(1408)] = 50971,
  [SMALL_STATE(1409)] = 51011,
  [SMALL_STATE(1410)] = 51051,
  [SMALL_STATE(1411)] = 51091,
  [SMALL_STATE(1412)] = 51131,
  [SMALL_STATE(1413)] = 51171,
  [SMALL_STATE(1414)] = 51212,
  [SMALL_STATE(1415)] = 51253,
  [SMALL_STATE(1416)] = 51294,
  [SMALL_STATE(1417)] = 51335,
  [SMALL_STATE(1418)] = 51376,
  [SMALL_STATE(1419)] = 51417,
  [SMALL_STATE(1420)] = 51458,
  [SMALL_STATE(1421)] = 51499,
  [SMALL_STATE(1422)] = 51537,
  [SMALL_STATE(1423)] = 51575,
  [SMALL_STATE(1424)] = 51615,
  [SMALL_STATE(1425)] = 51649,
  [SMALL_STATE(1426)] = 51688,
  [SMALL_STATE(1427)] = 51729,
  [SMALL_STATE(1428)] = 51768,
  [SMALL_STATE(1429)] = 51809,
  [SMALL_STATE(1430)] = 51850,
  [SMALL_STATE(1431)] = 51879,
  [SMALL_STATE(1432)] = 51908,
  [SMALL_STATE(1433)] = 51945,
  [SMALL_STATE(1434)] = 51984,
  [SMALL_STATE(1435)] = 52025,
  [SMALL_STATE(1436)] = 52066,
  [SMALL_STATE(1437)] = 52105,
  [SMALL_STATE(1438)] = 52134,
  [SMALL_STATE(1439)] = 52175,
  [SMALL_STATE(1440)] = 52204,
  [SMALL_STATE(1441)] = 52230,
  [SMALL_STATE(1442)] = 52267,
  [SMALL_STATE(1443)] = 52304,
  [SMALL_STATE(1444)] = 52341,
  [SMALL_STATE(1445)] = 52374,
  [SMALL_STATE(1446)] = 52411,
  [SMALL_STATE(1447)] = 52448,
  [SMALL_STATE(1448)] = 52485,
  [SMALL_STATE(1449)] = 52518,
  [SMALL_STATE(1450)] = 52547,
  [SMALL_STATE(1451)] = 52584,
  [SMALL_STATE(1452)] = 52613,
  [SMALL_STATE(1453)] = 52650,
  [SMALL_STATE(1454)] = 52671,
  [SMALL_STATE(1455)] = 52708,
  [SMALL_STATE(1456)] = 52745,
  [SMALL_STATE(1457)] = 52770,
  [SMALL_STATE(1458)] = 52807,
  [SMALL_STATE(1459)] = 52836,
  [SMALL_STATE(1460)] = 52873,
  [SMALL_STATE(1461)] = 52894,
  [SMALL_STATE(1462)] = 52931,
  [SMALL_STATE(1463)] = 52952,
  [SMALL_STATE(1464)] = 52981,
  [SMALL_STATE(1465)] = 53018,
  [SMALL_STATE(1466)] = 53055,
  [SMALL_STATE(1467)] = 53089,
  [SMALL_STATE(1468)] = 53123,
  [SMALL_STATE(1469)] = 53159,
  [SMALL_STATE(1470)] = 53183,
  [SMALL_STATE(1471)] = 53217,
  [SMALL_STATE(1472)] = 53251,
  [SMALL_STATE(1473)] = 53285,
  [SMALL_STATE(1474)] = 53319,
  [SMALL_STATE(1475)] = 53353,
  [SMALL_STATE(1476)] = 53387,
  [SMALL_STATE(1477)] = 53421,
  [SMALL_STATE(1478)] = 53455,
  [SMALL_STATE(1479)] = 53486,
  [SMALL_STATE(1480)] = 53515,
  [SMALL_STATE(1481)] = 53544,
  [SMALL_STATE(1482)] = 53575,
  [SMALL_STATE(1483)] = 53604,
  [SMALL_STATE(1484)] = 53633,
  [SMALL_STATE(1485)] = 53664,
  [SMALL_STATE(1486)] = 53695,
  [SMALL_STATE(1487)] = 53724,
  [SMALL_STATE(1488)] = 53753,
  [SMALL_STATE(1489)] = 53782,
  [SMALL_STATE(1490)] = 53811,
  [SMALL_STATE(1491)] = 53840,
  [SMALL_STATE(1492)] = 53869,
  [SMALL_STATE(1493)] = 53898,
  [SMALL_STATE(1494)] = 53927,
  [SMALL_STATE(1495)] = 53956,
  [SMALL_STATE(1496)] = 53987,
  [SMALL_STATE(1497)] = 54016,
  [SMALL_STATE(1498)] = 54045,
  [SMALL_STATE(1499)] = 54074,
  [SMALL_STATE(1500)] = 54103,
  [SMALL_STATE(1501)] = 54132,
  [SMALL_STATE(1502)] = 54161,
  [SMALL_STATE(1503)] = 54190,
  [SMALL_STATE(1504)] = 54219,
  [SMALL_STATE(1505)] = 54248,
  [SMALL_STATE(1506)] = 54277,
  [SMALL_STATE(1507)] = 54306,
  [SMALL_STATE(1508)] = 54331,
  [SMALL_STATE(1509)] = 54360,
  [SMALL_STATE(1510)] = 54389,
  [SMALL_STATE(1511)] = 54416,
  [SMALL_STATE(1512)] = 54445,
  [SMALL_STATE(1513)] = 54474,
  [SMALL_STATE(1514)] = 54503,
  [SMALL_STATE(1515)] = 54532,
  [SMALL_STATE(1516)] = 54561,
  [SMALL_STATE(1517)] = 54590,
  [SMALL_STATE(1518)] = 54619,
  [SMALL_STATE(1519)] = 54648,
  [SMALL_STATE(1520)] = 54679,
  [SMALL_STATE(1521)] = 54708,
  [SMALL_STATE(1522)] = 54739,
  [SMALL_STATE(1523)] = 54768,
  [SMALL_STATE(1524)] = 54797,
  [SMALL_STATE(1525)] = 54824,
  [SMALL_STATE(1526)] = 54853,
  [SMALL_STATE(1527)] = 54882,
  [SMALL_STATE(1528)] = 54913,
  [SMALL_STATE(1529)] = 54942,
  [SMALL_STATE(1530)] = 54971,
  [SMALL_STATE(1531)] = 54998,
  [SMALL_STATE(1532)] = 55027,
  [SMALL_STATE(1533)] = 55058,
  [SMALL_STATE(1534)] = 55087,
  [SMALL_STATE(1535)] = 55116,
  [SMALL_STATE(1536)] = 55145,
  [SMALL_STATE(1537)] = 55172,
  [SMALL_STATE(1538)] = 55197,
  [SMALL_STATE(1539)] = 55226,
  [SMALL_STATE(1540)] = 55252,
  [SMALL_STATE(1541)] = 55270,
  [SMALL_STATE(1542)] = 55300,
  [SMALL_STATE(1543)] = 55318,
  [SMALL_STATE(1544)] = 55344,
  [SMALL_STATE(1545)] = 55370,
  [SMALL_STATE(1546)] = 55394,
  [SMALL_STATE(1547)] = 55420,
  [SMALL_STATE(1548)] = 55438,
  [SMALL_STATE(1549)] = 55460,
  [SMALL_STATE(1550)] = 55484,
  [SMALL_STATE(1551)] = 55502,
  [SMALL_STATE(1552)] = 55520,
  [SMALL_STATE(1553)] = 55538,
  [SMALL_STATE(1554)] = 55556,
  [SMALL_STATE(1555)] = 55581,
  [SMALL_STATE(1556)] = 55602,
  [SMALL_STATE(1557)] = 55631,
  [SMALL_STATE(1558)] = 55650,
  [SMALL_STATE(1559)] = 55675,
  [SMALL_STATE(1560)] = 55696,
  [SMALL_STATE(1561)] = 55725,
  [SMALL_STATE(1562)] = 55754,
  [SMALL_STATE(1563)] = 55775,
  [SMALL_STATE(1564)] = 55796,
  [SMALL_STATE(1565)] = 55817,
  [SMALL_STATE(1566)] = 55838,
  [SMALL_STATE(1567)] = 55867,
  [SMALL_STATE(1568)] = 55888,
  [SMALL_STATE(1569)] = 55909,
  [SMALL_STATE(1570)] = 55935,
  [SMALL_STATE(1571)] = 55961,
  [SMALL_STATE(1572)] = 55987,
  [SMALL_STATE(1573)] = 56013,
  [SMALL_STATE(1574)] = 56039,
  [SMALL_STATE(1575)] = 56065,
  [SMALL_STATE(1576)] = 56091,
  [SMALL_STATE(1577)] = 56117,
  [SMALL_STATE(1578)] = 56133,
  [SMALL_STATE(1579)] = 56159,
  [SMALL_STATE(1580)] = 56185,
  [SMALL_STATE(1581)] = 56211,
  [SMALL_STATE(1582)] = 56237,
  [SMALL_STATE(1583)] = 56263,
  [SMALL_STATE(1584)] = 56289,
  [SMALL_STATE(1585)] = 56315,
  [SMALL_STATE(1586)] = 56341,
  [SMALL_STATE(1587)] = 56365,
  [SMALL_STATE(1588)] = 56391,
  [SMALL_STATE(1589)] = 56417,
  [SMALL_STATE(1590)] = 56443,
  [SMALL_STATE(1591)] = 56469,
  [SMALL_STATE(1592)] = 56495,
  [SMALL_STATE(1593)] = 56521,
  [SMALL_STATE(1594)] = 56547,
  [SMALL_STATE(1595)] = 56573,
  [SMALL_STATE(1596)] = 56599,
  [SMALL_STATE(1597)] = 56625,
  [SMALL_STATE(1598)] = 56651,
  [SMALL_STATE(1599)] = 56677,
  [SMALL_STATE(1600)] = 56697,
  [SMALL_STATE(1601)] = 56723,
  [SMALL_STATE(1602)] = 56749,
  [SMALL_STATE(1603)] = 56775,
  [SMALL_STATE(1604)] = 56801,
  [SMALL_STATE(1605)] = 56827,
  [SMALL_STATE(1606)] = 56843,
  [SMALL_STATE(1607)] = 56859,
  [SMALL_STATE(1608)] = 56875,
  [SMALL_STATE(1609)] = 56901,
  [SMALL_STATE(1610)] = 56927,
  [SMALL_STATE(1611)] = 56953,
  [SMALL_STATE(1612)] = 56979,
  [SMALL_STATE(1613)] = 57005,
  [SMALL_STATE(1614)] = 57031,
  [SMALL_STATE(1615)] = 57057,
  [SMALL_STATE(1616)] = 57083,
  [SMALL_STATE(1617)] = 57109,
  [SMALL_STATE(1618)] = 57135,
  [SMALL_STATE(1619)] = 57151,
  [SMALL_STATE(1620)] = 57177,
  [SMALL_STATE(1621)] = 57203,
  [SMALL_STATE(1622)] = 57229,
  [SMALL_STATE(1623)] = 57255,
  [SMALL_STATE(1624)] = 57281,
  [SMALL_STATE(1625)] = 57307,
  [SMALL_STATE(1626)] = 57333,
  [SMALL_STATE(1627)] = 57359,
  [SMALL_STATE(1628)] = 57377,
  [SMALL_STATE(1629)] = 57403,
  [SMALL_STATE(1630)] = 57427,
  [SMALL_STATE(1631)] = 57453,
  [SMALL_STATE(1632)] = 57469,
  [SMALL_STATE(1633)] = 57495,
  [SMALL_STATE(1634)] = 57521,
  [SMALL_STATE(1635)] = 57547,
  [SMALL_STATE(1636)] = 57573,
  [SMALL_STATE(1637)] = 57599,
  [SMALL_STATE(1638)] = 57625,
  [SMALL_STATE(1639)] = 57651,
  [SMALL_STATE(1640)] = 57677,
  [SMALL_STATE(1641)] = 57703,
  [SMALL_STATE(1642)] = 57729,
  [SMALL_STATE(1643)] = 57755,
  [SMALL_STATE(1644)] = 57781,
  [SMALL_STATE(1645)] = 57807,
  [SMALL_STATE(1646)] = 57833,
  [SMALL_STATE(1647)] = 57849,
  [SMALL_STATE(1648)] = 57871,
  [SMALL_STATE(1649)] = 57897,
  [SMALL_STATE(1650)] = 57917,
  [SMALL_STATE(1651)] = 57943,
  [SMALL_STATE(1652)] = 57959,
  [SMALL_STATE(1653)] = 57975,
  [SMALL_STATE(1654)] = 58001,
  [SMALL_STATE(1655)] = 58021,
  [SMALL_STATE(1656)] = 58047,
  [SMALL_STATE(1657)] = 58073,
  [SMALL_STATE(1658)] = 58099,
  [SMALL_STATE(1659)] = 58125,
  [SMALL_STATE(1660)] = 58151,
  [SMALL_STATE(1661)] = 58177,
  [SMALL_STATE(1662)] = 58194,
  [SMALL_STATE(1663)] = 58217,
  [SMALL_STATE(1664)] = 58232,
  [SMALL_STATE(1665)] = 58247,
  [SMALL_STATE(1666)] = 58262,
  [SMALL_STATE(1667)] = 58277,
  [SMALL_STATE(1668)] = 58292,
  [SMALL_STATE(1669)] = 58311,
  [SMALL_STATE(1670)] = 58326,
  [SMALL_STATE(1671)] = 58349,
  [SMALL_STATE(1672)] = 58372,
  [SMALL_STATE(1673)] = 58389,
  [SMALL_STATE(1674)] = 58412,
  [SMALL_STATE(1675)] = 58427,
  [SMALL_STATE(1676)] = 58450,
  [SMALL_STATE(1677)] = 58469,
  [SMALL_STATE(1678)] = 58494,
  [SMALL_STATE(1679)] = 58517,
  [SMALL_STATE(1680)] = 58532,
  [SMALL_STATE(1681)] = 58547,
  [SMALL_STATE(1682)] = 58562,
  [SMALL_STATE(1683)] = 58579,
  [SMALL_STATE(1684)] = 58596,
  [SMALL_STATE(1685)] = 58619,
  [SMALL_STATE(1686)] = 58639,
  [SMALL_STATE(1687)] = 58659,
  [SMALL_STATE(1688)] = 58673,
  [SMALL_STATE(1689)] = 58693,
  [SMALL_STATE(1690)] = 58713,
  [SMALL_STATE(1691)] = 58731,
  [SMALL_STATE(1692)] = 58747,
  [SMALL_STATE(1693)] = 58767,
  [SMALL_STATE(1694)] = 58783,
  [SMALL_STATE(1695)] = 58803,
  [SMALL_STATE(1696)] = 58823,
  [SMALL_STATE(1697)] = 58837,
  [SMALL_STATE(1698)] = 58855,
  [SMALL_STATE(1699)] = 58875,
  [SMALL_STATE(1700)] = 58895,
  [SMALL_STATE(1701)] = 58909,
  [SMALL_STATE(1702)] = 58923,
  [SMALL_STATE(1703)] = 58937,
  [SMALL_STATE(1704)] = 58957,
  [SMALL_STATE(1705)] = 58977,
  [SMALL_STATE(1706)] = 58997,
  [SMALL_STATE(1707)] = 59015,
  [SMALL_STATE(1708)] = 59035,
  [SMALL_STATE(1709)] = 59049,
  [SMALL_STATE(1710)] = 59069,
  [SMALL_STATE(1711)] = 59089,
  [SMALL_STATE(1712)] = 59103,
  [SMALL_STATE(1713)] = 59117,
  [SMALL_STATE(1714)] = 59137,
  [SMALL_STATE(1715)] = 59151,
  [SMALL_STATE(1716)] = 59165,
  [SMALL_STATE(1717)] = 59179,
  [SMALL_STATE(1718)] = 59199,
  [SMALL_STATE(1719)] = 59217,
  [SMALL_STATE(1720)] = 59235,
  [SMALL_STATE(1721)] = 59255,
  [SMALL_STATE(1722)] = 59269,
  [SMALL_STATE(1723)] = 59289,
  [SMALL_STATE(1724)] = 59309,
  [SMALL_STATE(1725)] = 59329,
  [SMALL_STATE(1726)] = 59343,
  [SMALL_STATE(1727)] = 59361,
  [SMALL_STATE(1728)] = 59377,
  [SMALL_STATE(1729)] = 59395,
  [SMALL_STATE(1730)] = 59409,
  [SMALL_STATE(1731)] = 59429,
  [SMALL_STATE(1732)] = 59443,
  [SMALL_STATE(1733)] = 59454,
  [SMALL_STATE(1734)] = 59465,
  [SMALL_STATE(1735)] = 59476,
  [SMALL_STATE(1736)] = 59487,
  [SMALL_STATE(1737)] = 59506,
  [SMALL_STATE(1738)] = 59519,
  [SMALL_STATE(1739)] = 59530,
  [SMALL_STATE(1740)] = 59541,
  [SMALL_STATE(1741)] = 59552,
  [SMALL_STATE(1742)] = 59565,
  [SMALL_STATE(1743)] = 59582,
  [SMALL_STATE(1744)] = 59599,
  [SMALL_STATE(1745)] = 59610,
  [SMALL_STATE(1746)] = 59627,
  [SMALL_STATE(1747)] = 59640,
  [SMALL_STATE(1748)] = 59653,
  [SMALL_STATE(1749)] = 59672,
  [SMALL_STATE(1750)] = 59687,
  [SMALL_STATE(1751)] = 59698,
  [SMALL_STATE(1752)] = 59709,
  [SMALL_STATE(1753)] = 59720,
  [SMALL_STATE(1754)] = 59731,
  [SMALL_STATE(1755)] = 59746,
  [SMALL_STATE(1756)] = 59757,
  [SMALL_STATE(1757)] = 59776,
  [SMALL_STATE(1758)] = 59790,
  [SMALL_STATE(1759)] = 59804,
  [SMALL_STATE(1760)] = 59820,
  [SMALL_STATE(1761)] = 59836,
  [SMALL_STATE(1762)] = 59850,
  [SMALL_STATE(1763)] = 59866,
  [SMALL_STATE(1764)] = 59882,
  [SMALL_STATE(1765)] = 59896,
  [SMALL_STATE(1766)] = 59910,
  [SMALL_STATE(1767)] = 59924,
  [SMALL_STATE(1768)] = 59938,
  [SMALL_STATE(1769)] = 59952,
  [SMALL_STATE(1770)] = 59968,
  [SMALL_STATE(1771)] = 59978,
  [SMALL_STATE(1772)] = 59992,
  [SMALL_STATE(1773)] = 60006,
  [SMALL_STATE(1774)] = 60020,
  [SMALL_STATE(1775)] = 60034,
  [SMALL_STATE(1776)] = 60050,
  [SMALL_STATE(1777)] = 60064,
  [SMALL_STATE(1778)] = 60080,
  [SMALL_STATE(1779)] = 60094,
  [SMALL_STATE(1780)] = 60108,
  [SMALL_STATE(1781)] = 60122,
  [SMALL_STATE(1782)] = 60132,
  [SMALL_STATE(1783)] = 60146,
  [SMALL_STATE(1784)] = 60162,
  [SMALL_STATE(1785)] = 60176,
  [SMALL_STATE(1786)] = 60190,
  [SMALL_STATE(1787)] = 60204,
  [SMALL_STATE(1788)] = 60220,
  [SMALL_STATE(1789)] = 60234,
  [SMALL_STATE(1790)] = 60250,
  [SMALL_STATE(1791)] = 60264,
  [SMALL_STATE(1792)] = 60280,
  [SMALL_STATE(1793)] = 60294,
  [SMALL_STATE(1794)] = 60308,
  [SMALL_STATE(1795)] = 60324,
  [SMALL_STATE(1796)] = 60338,
  [SMALL_STATE(1797)] = 60354,
  [SMALL_STATE(1798)] = 60368,
  [SMALL_STATE(1799)] = 60382,
  [SMALL_STATE(1800)] = 60396,
  [SMALL_STATE(1801)] = 60410,
  [SMALL_STATE(1802)] = 60424,
  [SMALL_STATE(1803)] = 60438,
  [SMALL_STATE(1804)] = 60454,
  [SMALL_STATE(1805)] = 60468,
  [SMALL_STATE(1806)] = 60482,
  [SMALL_STATE(1807)] = 60496,
  [SMALL_STATE(1808)] = 60510,
  [SMALL_STATE(1809)] = 60524,
  [SMALL_STATE(1810)] = 60540,
  [SMALL_STATE(1811)] = 60554,
  [SMALL_STATE(1812)] = 60568,
  [SMALL_STATE(1813)] = 60582,
  [SMALL_STATE(1814)] = 60596,
  [SMALL_STATE(1815)] = 60612,
  [SMALL_STATE(1816)] = 60628,
  [SMALL_STATE(1817)] = 60642,
  [SMALL_STATE(1818)] = 60656,
  [SMALL_STATE(1819)] = 60672,
  [SMALL_STATE(1820)] = 60688,
  [SMALL_STATE(1821)] = 60702,
  [SMALL_STATE(1822)] = 60716,
  [SMALL_STATE(1823)] = 60730,
  [SMALL_STATE(1824)] = 60744,
  [SMALL_STATE(1825)] = 60758,
  [SMALL_STATE(1826)] = 60772,
  [SMALL_STATE(1827)] = 60786,
  [SMALL_STATE(1828)] = 60802,
  [SMALL_STATE(1829)] = 60816,
  [SMALL_STATE(1830)] = 60830,
  [SMALL_STATE(1831)] = 60846,
  [SMALL_STATE(1832)] = 60862,
  [SMALL_STATE(1833)] = 60876,
  [SMALL_STATE(1834)] = 60890,
  [SMALL_STATE(1835)] = 60903,
  [SMALL_STATE(1836)] = 60916,
  [SMALL_STATE(1837)] = 60929,
  [SMALL_STATE(1838)] = 60942,
  [SMALL_STATE(1839)] = 60955,
  [SMALL_STATE(1840)] = 60968,
  [SMALL_STATE(1841)] = 60981,
  [SMALL_STATE(1842)] = 60994,
  [SMALL_STATE(1843)] = 61007,
  [SMALL_STATE(1844)] = 61020,
  [SMALL_STATE(1845)] = 61033,
  [SMALL_STATE(1846)] = 61046,
  [SMALL_STATE(1847)] = 61059,
  [SMALL_STATE(1848)] = 61072,
  [SMALL_STATE(1849)] = 61085,
  [SMALL_STATE(1850)] = 61098,
  [SMALL_STATE(1851)] = 61111,
  [SMALL_STATE(1852)] = 61124,
  [SMALL_STATE(1853)] = 61137,
  [SMALL_STATE(1854)] = 61150,
  [SMALL_STATE(1855)] = 61163,
  [SMALL_STATE(1856)] = 61176,
  [SMALL_STATE(1857)] = 61189,
  [SMALL_STATE(1858)] = 61198,
  [SMALL_STATE(1859)] = 61211,
  [SMALL_STATE(1860)] = 61224,
  [SMALL_STATE(1861)] = 61237,
  [SMALL_STATE(1862)] = 61246,
  [SMALL_STATE(1863)] = 61259,
  [SMALL_STATE(1864)] = 61270,
  [SMALL_STATE(1865)] = 61283,
  [SMALL_STATE(1866)] = 61294,
  [SMALL_STATE(1867)] = 61307,
  [SMALL_STATE(1868)] = 61320,
  [SMALL_STATE(1869)] = 61333,
  [SMALL_STATE(1870)] = 61346,
  [SMALL_STATE(1871)] = 61359,
  [SMALL_STATE(1872)] = 61372,
  [SMALL_STATE(1873)] = 61383,
  [SMALL_STATE(1874)] = 61396,
  [SMALL_STATE(1875)] = 61409,
  [SMALL_STATE(1876)] = 61422,
  [SMALL_STATE(1877)] = 61435,
  [SMALL_STATE(1878)] = 61448,
  [SMALL_STATE(1879)] = 61461,
  [SMALL_STATE(1880)] = 61470,
  [SMALL_STATE(1881)] = 61483,
  [SMALL_STATE(1882)] = 61496,
  [SMALL_STATE(1883)] = 61509,
  [SMALL_STATE(1884)] = 61522,
  [SMALL_STATE(1885)] = 61535,
  [SMALL_STATE(1886)] = 61548,
  [SMALL_STATE(1887)] = 61561,
  [SMALL_STATE(1888)] = 61574,
  [SMALL_STATE(1889)] = 61587,
  [SMALL_STATE(1890)] = 61600,
  [SMALL_STATE(1891)] = 61613,
  [SMALL_STATE(1892)] = 61622,
  [SMALL_STATE(1893)] = 61635,
  [SMALL_STATE(1894)] = 61648,
  [SMALL_STATE(1895)] = 61661,
  [SMALL_STATE(1896)] = 61674,
  [SMALL_STATE(1897)] = 61685,
  [SMALL_STATE(1898)] = 61698,
  [SMALL_STATE(1899)] = 61711,
  [SMALL_STATE(1900)] = 61724,
  [SMALL_STATE(1901)] = 61737,
  [SMALL_STATE(1902)] = 61750,
  [SMALL_STATE(1903)] = 61763,
  [SMALL_STATE(1904)] = 61776,
  [SMALL_STATE(1905)] = 61789,
  [SMALL_STATE(1906)] = 61802,
  [SMALL_STATE(1907)] = 61815,
  [SMALL_STATE(1908)] = 61824,
  [SMALL_STATE(1909)] = 61837,
  [SMALL_STATE(1910)] = 61850,
  [SMALL_STATE(1911)] = 61863,
  [SMALL_STATE(1912)] = 61872,
  [SMALL_STATE(1913)] = 61885,
  [SMALL_STATE(1914)] = 61898,
  [SMALL_STATE(1915)] = 61911,
  [SMALL_STATE(1916)] = 61920,
  [SMALL_STATE(1917)] = 61933,
  [SMALL_STATE(1918)] = 61946,
  [SMALL_STATE(1919)] = 61959,
  [SMALL_STATE(1920)] = 61972,
  [SMALL_STATE(1921)] = 61985,
  [SMALL_STATE(1922)] = 61998,
  [SMALL_STATE(1923)] = 62011,
  [SMALL_STATE(1924)] = 62024,
  [SMALL_STATE(1925)] = 62037,
  [SMALL_STATE(1926)] = 62050,
  [SMALL_STATE(1927)] = 62063,
  [SMALL_STATE(1928)] = 62076,
  [SMALL_STATE(1929)] = 62089,
  [SMALL_STATE(1930)] = 62102,
  [SMALL_STATE(1931)] = 62115,
  [SMALL_STATE(1932)] = 62128,
  [SMALL_STATE(1933)] = 62141,
  [SMALL_STATE(1934)] = 62150,
  [SMALL_STATE(1935)] = 62163,
  [SMALL_STATE(1936)] = 62176,
  [SMALL_STATE(1937)] = 62189,
  [SMALL_STATE(1938)] = 62202,
  [SMALL_STATE(1939)] = 62215,
  [SMALL_STATE(1940)] = 62228,
  [SMALL_STATE(1941)] = 62241,
  [SMALL_STATE(1942)] = 62254,
  [SMALL_STATE(1943)] = 62263,
  [SMALL_STATE(1944)] = 62276,
  [SMALL_STATE(1945)] = 62289,
  [SMALL_STATE(1946)] = 62302,
  [SMALL_STATE(1947)] = 62315,
  [SMALL_STATE(1948)] = 62328,
  [SMALL_STATE(1949)] = 62341,
  [SMALL_STATE(1950)] = 62354,
  [SMALL_STATE(1951)] = 62367,
  [SMALL_STATE(1952)] = 62380,
  [SMALL_STATE(1953)] = 62393,
  [SMALL_STATE(1954)] = 62406,
  [SMALL_STATE(1955)] = 62419,
  [SMALL_STATE(1956)] = 62432,
  [SMALL_STATE(1957)] = 62445,
  [SMALL_STATE(1958)] = 62454,
  [SMALL_STATE(1959)] = 62467,
  [SMALL_STATE(1960)] = 62480,
  [SMALL_STATE(1961)] = 62493,
  [SMALL_STATE(1962)] = 62506,
  [SMALL_STATE(1963)] = 62519,
  [SMALL_STATE(1964)] = 62532,
  [SMALL_STATE(1965)] = 62541,
  [SMALL_STATE(1966)] = 62554,
  [SMALL_STATE(1967)] = 62567,
  [SMALL_STATE(1968)] = 62580,
  [SMALL_STATE(1969)] = 62589,
  [SMALL_STATE(1970)] = 62602,
  [SMALL_STATE(1971)] = 62615,
  [SMALL_STATE(1972)] = 62628,
  [SMALL_STATE(1973)] = 62641,
  [SMALL_STATE(1974)] = 62654,
  [SMALL_STATE(1975)] = 62667,
  [SMALL_STATE(1976)] = 62680,
  [SMALL_STATE(1977)] = 62693,
  [SMALL_STATE(1978)] = 62706,
  [SMALL_STATE(1979)] = 62719,
  [SMALL_STATE(1980)] = 62732,
  [SMALL_STATE(1981)] = 62745,
  [SMALL_STATE(1982)] = 62758,
  [SMALL_STATE(1983)] = 62771,
  [SMALL_STATE(1984)] = 62784,
  [SMALL_STATE(1985)] = 62797,
  [SMALL_STATE(1986)] = 62810,
  [SMALL_STATE(1987)] = 62823,
  [SMALL_STATE(1988)] = 62836,
  [SMALL_STATE(1989)] = 62849,
  [SMALL_STATE(1990)] = 62862,
  [SMALL_STATE(1991)] = 62875,
  [SMALL_STATE(1992)] = 62888,
  [SMALL_STATE(1993)] = 62899,
  [SMALL_STATE(1994)] = 62912,
  [SMALL_STATE(1995)] = 62923,
  [SMALL_STATE(1996)] = 62936,
  [SMALL_STATE(1997)] = 62949,
  [SMALL_STATE(1998)] = 62962,
  [SMALL_STATE(1999)] = 62975,
  [SMALL_STATE(2000)] = 62988,
  [SMALL_STATE(2001)] = 63001,
  [SMALL_STATE(2002)] = 63014,
  [SMALL_STATE(2003)] = 63027,
  [SMALL_STATE(2004)] = 63040,
  [SMALL_STATE(2005)] = 63053,
  [SMALL_STATE(2006)] = 63066,
  [SMALL_STATE(2007)] = 63079,
  [SMALL_STATE(2008)] = 63092,
  [SMALL_STATE(2009)] = 63105,
  [SMALL_STATE(2010)] = 63118,
  [SMALL_STATE(2011)] = 63131,
  [SMALL_STATE(2012)] = 63144,
  [SMALL_STATE(2013)] = 63157,
  [SMALL_STATE(2014)] = 63170,
  [SMALL_STATE(2015)] = 63180,
  [SMALL_STATE(2016)] = 63190,
  [SMALL_STATE(2017)] = 63200,
  [SMALL_STATE(2018)] = 63210,
  [SMALL_STATE(2019)] = 63220,
  [SMALL_STATE(2020)] = 63230,
  [SMALL_STATE(2021)] = 63240,
  [SMALL_STATE(2022)] = 63250,
  [SMALL_STATE(2023)] = 63260,
  [SMALL_STATE(2024)] = 63270,
  [SMALL_STATE(2025)] = 63278,
  [SMALL_STATE(2026)] = 63286,
  [SMALL_STATE(2027)] = 63296,
  [SMALL_STATE(2028)] = 63306,
  [SMALL_STATE(2029)] = 63314,
  [SMALL_STATE(2030)] = 63324,
  [SMALL_STATE(2031)] = 63334,
  [SMALL_STATE(2032)] = 63344,
  [SMALL_STATE(2033)] = 63352,
  [SMALL_STATE(2034)] = 63360,
  [SMALL_STATE(2035)] = 63370,
  [SMALL_STATE(2036)] = 63378,
  [SMALL_STATE(2037)] = 63388,
  [SMALL_STATE(2038)] = 63398,
  [SMALL_STATE(2039)] = 63406,
  [SMALL_STATE(2040)] = 63414,
  [SMALL_STATE(2041)] = 63422,
  [SMALL_STATE(2042)] = 63432,
  [SMALL_STATE(2043)] = 63442,
  [SMALL_STATE(2044)] = 63452,
  [SMALL_STATE(2045)] = 63462,
  [SMALL_STATE(2046)] = 63472,
  [SMALL_STATE(2047)] = 63482,
  [SMALL_STATE(2048)] = 63492,
  [SMALL_STATE(2049)] = 63500,
  [SMALL_STATE(2050)] = 63510,
  [SMALL_STATE(2051)] = 63520,
  [SMALL_STATE(2052)] = 63528,
  [SMALL_STATE(2053)] = 63538,
  [SMALL_STATE(2054)] = 63546,
  [SMALL_STATE(2055)] = 63554,
  [SMALL_STATE(2056)] = 63564,
  [SMALL_STATE(2057)] = 63574,
  [SMALL_STATE(2058)] = 63584,
  [SMALL_STATE(2059)] = 63594,
  [SMALL_STATE(2060)] = 63604,
  [SMALL_STATE(2061)] = 63614,
  [SMALL_STATE(2062)] = 63624,
  [SMALL_STATE(2063)] = 63634,
  [SMALL_STATE(2064)] = 63644,
  [SMALL_STATE(2065)] = 63654,
  [SMALL_STATE(2066)] = 63664,
  [SMALL_STATE(2067)] = 63674,
  [SMALL_STATE(2068)] = 63684,
  [SMALL_STATE(2069)] = 63694,
  [SMALL_STATE(2070)] = 63704,
  [SMALL_STATE(2071)] = 63714,
  [SMALL_STATE(2072)] = 63724,
  [SMALL_STATE(2073)] = 63734,
  [SMALL_STATE(2074)] = 63744,
  [SMALL_STATE(2075)] = 63752,
  [SMALL_STATE(2076)] = 63762,
  [SMALL_STATE(2077)] = 63772,
  [SMALL_STATE(2078)] = 63782,
  [SMALL_STATE(2079)] = 63792,
  [SMALL_STATE(2080)] = 63802,
  [SMALL_STATE(2081)] = 63812,
  [SMALL_STATE(2082)] = 63822,
  [SMALL_STATE(2083)] = 63830,
  [SMALL_STATE(2084)] = 63840,
  [SMALL_STATE(2085)] = 63848,
  [SMALL_STATE(2086)] = 63856,
  [SMALL_STATE(2087)] = 63866,
  [SMALL_STATE(2088)] = 63876,
  [SMALL_STATE(2089)] = 63886,
  [SMALL_STATE(2090)] = 63896,
  [SMALL_STATE(2091)] = 63906,
  [SMALL_STATE(2092)] = 63914,
  [SMALL_STATE(2093)] = 63924,
  [SMALL_STATE(2094)] = 63934,
  [SMALL_STATE(2095)] = 63944,
  [SMALL_STATE(2096)] = 63954,
  [SMALL_STATE(2097)] = 63964,
  [SMALL_STATE(2098)] = 63974,
  [SMALL_STATE(2099)] = 63984,
  [SMALL_STATE(2100)] = 63994,
  [SMALL_STATE(2101)] = 64002,
  [SMALL_STATE(2102)] = 64012,
  [SMALL_STATE(2103)] = 64019,
  [SMALL_STATE(2104)] = 64026,
  [SMALL_STATE(2105)] = 64033,
  [SMALL_STATE(2106)] = 64040,
  [SMALL_STATE(2107)] = 64047,
  [SMALL_STATE(2108)] = 64054,
  [SMALL_STATE(2109)] = 64061,
  [SMALL_STATE(2110)] = 64068,
  [SMALL_STATE(2111)] = 64075,
  [SMALL_STATE(2112)] = 64082,
  [SMALL_STATE(2113)] = 64089,
  [SMALL_STATE(2114)] = 64096,
  [SMALL_STATE(2115)] = 64103,
  [SMALL_STATE(2116)] = 64110,
  [SMALL_STATE(2117)] = 64117,
  [SMALL_STATE(2118)] = 64124,
  [SMALL_STATE(2119)] = 64131,
  [SMALL_STATE(2120)] = 64138,
  [SMALL_STATE(2121)] = 64145,
  [SMALL_STATE(2122)] = 64152,
  [SMALL_STATE(2123)] = 64159,
  [SMALL_STATE(2124)] = 64166,
  [SMALL_STATE(2125)] = 64173,
  [SMALL_STATE(2126)] = 64180,
  [SMALL_STATE(2127)] = 64187,
  [SMALL_STATE(2128)] = 64194,
  [SMALL_STATE(2129)] = 64201,
  [SMALL_STATE(2130)] = 64208,
  [SMALL_STATE(2131)] = 64215,
  [SMALL_STATE(2132)] = 64222,
  [SMALL_STATE(2133)] = 64229,
  [SMALL_STATE(2134)] = 64236,
  [SMALL_STATE(2135)] = 64243,
  [SMALL_STATE(2136)] = 64250,
  [SMALL_STATE(2137)] = 64257,
  [SMALL_STATE(2138)] = 64264,
  [SMALL_STATE(2139)] = 64271,
  [SMALL_STATE(2140)] = 64278,
  [SMALL_STATE(2141)] = 64285,
  [SMALL_STATE(2142)] = 64292,
  [SMALL_STATE(2143)] = 64299,
  [SMALL_STATE(2144)] = 64306,
  [SMALL_STATE(2145)] = 64313,
  [SMALL_STATE(2146)] = 64320,
  [SMALL_STATE(2147)] = 64327,
  [SMALL_STATE(2148)] = 64334,
  [SMALL_STATE(2149)] = 64341,
  [SMALL_STATE(2150)] = 64348,
  [SMALL_STATE(2151)] = 64355,
  [SMALL_STATE(2152)] = 64362,
  [SMALL_STATE(2153)] = 64369,
  [SMALL_STATE(2154)] = 64376,
  [SMALL_STATE(2155)] = 64383,
  [SMALL_STATE(2156)] = 64390,
  [SMALL_STATE(2157)] = 64397,
  [SMALL_STATE(2158)] = 64404,
  [SMALL_STATE(2159)] = 64411,
  [SMALL_STATE(2160)] = 64418,
  [SMALL_STATE(2161)] = 64425,
  [SMALL_STATE(2162)] = 64432,
  [SMALL_STATE(2163)] = 64439,
  [SMALL_STATE(2164)] = 64446,
  [SMALL_STATE(2165)] = 64453,
  [SMALL_STATE(2166)] = 64460,
  [SMALL_STATE(2167)] = 64467,
  [SMALL_STATE(2168)] = 64474,
  [SMALL_STATE(2169)] = 64481,
  [SMALL_STATE(2170)] = 64488,
  [SMALL_STATE(2171)] = 64495,
  [SMALL_STATE(2172)] = 64502,
  [SMALL_STATE(2173)] = 64509,
  [SMALL_STATE(2174)] = 64516,
  [SMALL_STATE(2175)] = 64523,
  [SMALL_STATE(2176)] = 64530,
  [SMALL_STATE(2177)] = 64537,
  [SMALL_STATE(2178)] = 64544,
  [SMALL_STATE(2179)] = 64551,
  [SMALL_STATE(2180)] = 64558,
  [SMALL_STATE(2181)] = 64565,
  [SMALL_STATE(2182)] = 64572,
  [SMALL_STATE(2183)] = 64579,
  [SMALL_STATE(2184)] = 64586,
  [SMALL_STATE(2185)] = 64593,
  [SMALL_STATE(2186)] = 64600,
  [SMALL_STATE(2187)] = 64607,
  [SMALL_STATE(2188)] = 64614,
  [SMALL_STATE(2189)] = 64621,
  [SMALL_STATE(2190)] = 64628,
  [SMALL_STATE(2191)] = 64635,
  [SMALL_STATE(2192)] = 64642,
  [SMALL_STATE(2193)] = 64649,
  [SMALL_STATE(2194)] = 64656,
  [SMALL_STATE(2195)] = 64663,
  [SMALL_STATE(2196)] = 64670,
  [SMALL_STATE(2197)] = 64677,
  [SMALL_STATE(2198)] = 64684,
  [SMALL_STATE(2199)] = 64691,
  [SMALL_STATE(2200)] = 64698,
  [SMALL_STATE(2201)] = 64705,
  [SMALL_STATE(2202)] = 64712,
  [SMALL_STATE(2203)] = 64719,
  [SMALL_STATE(2204)] = 64726,
  [SMALL_STATE(2205)] = 64733,
  [SMALL_STATE(2206)] = 64740,
  [SMALL_STATE(2207)] = 64747,
  [SMALL_STATE(2208)] = 64754,
  [SMALL_STATE(2209)] = 64761,
  [SMALL_STATE(2210)] = 64768,
  [SMALL_STATE(2211)] = 64775,
  [SMALL_STATE(2212)] = 64782,
  [SMALL_STATE(2213)] = 64789,
  [SMALL_STATE(2214)] = 64796,
  [SMALL_STATE(2215)] = 64803,
  [SMALL_STATE(2216)] = 64810,
  [SMALL_STATE(2217)] = 64817,
  [SMALL_STATE(2218)] = 64824,
  [SMALL_STATE(2219)] = 64831,
  [SMALL_STATE(2220)] = 64838,
  [SMALL_STATE(2221)] = 64845,
  [SMALL_STATE(2222)] = 64852,
  [SMALL_STATE(2223)] = 64859,
  [SMALL_STATE(2224)] = 64866,
  [SMALL_STATE(2225)] = 64873,
  [SMALL_STATE(2226)] = 64880,
  [SMALL_STATE(2227)] = 64887,
  [SMALL_STATE(2228)] = 64894,
  [SMALL_STATE(2229)] = 64901,
  [SMALL_STATE(2230)] = 64908,
  [SMALL_STATE(2231)] = 64915,
  [SMALL_STATE(2232)] = 64922,
  [SMALL_STATE(2233)] = 64929,
  [SMALL_STATE(2234)] = 64936,
  [SMALL_STATE(2235)] = 64943,
  [SMALL_STATE(2236)] = 64950,
  [SMALL_STATE(2237)] = 64957,
  [SMALL_STATE(2238)] = 64964,
  [SMALL_STATE(2239)] = 64971,
  [SMALL_STATE(2240)] = 64978,
  [SMALL_STATE(2241)] = 64985,
  [SMALL_STATE(2242)] = 64992,
  [SMALL_STATE(2243)] = 64999,
  [SMALL_STATE(2244)] = 65006,
  [SMALL_STATE(2245)] = 65013,
  [SMALL_STATE(2246)] = 65020,
  [SMALL_STATE(2247)] = 65027,
  [SMALL_STATE(2248)] = 65034,
  [SMALL_STATE(2249)] = 65041,
  [SMALL_STATE(2250)] = 65048,
  [SMALL_STATE(2251)] = 65055,
  [SMALL_STATE(2252)] = 65062,
  [SMALL_STATE(2253)] = 65069,
  [SMALL_STATE(2254)] = 65076,
  [SMALL_STATE(2255)] = 65083,
  [SMALL_STATE(2256)] = 65090,
  [SMALL_STATE(2257)] = 65097,
  [SMALL_STATE(2258)] = 65104,
  [SMALL_STATE(2259)] = 65111,
  [SMALL_STATE(2260)] = 65118,
  [SMALL_STATE(2261)] = 65125,
  [SMALL_STATE(2262)] = 65132,
  [SMALL_STATE(2263)] = 65139,
  [SMALL_STATE(2264)] = 65146,
  [SMALL_STATE(2265)] = 65153,
  [SMALL_STATE(2266)] = 65160,
  [SMALL_STATE(2267)] = 65167,
  [SMALL_STATE(2268)] = 65174,
  [SMALL_STATE(2269)] = 65181,
  [SMALL_STATE(2270)] = 65188,
  [SMALL_STATE(2271)] = 65195,
  [SMALL_STATE(2272)] = 65202,
  [SMALL_STATE(2273)] = 65209,
  [SMALL_STATE(2274)] = 65216,
  [SMALL_STATE(2275)] = 65223,
  [SMALL_STATE(2276)] = 65230,
  [SMALL_STATE(2277)] = 65237,
  [SMALL_STATE(2278)] = 65244,
  [SMALL_STATE(2279)] = 65251,
  [SMALL_STATE(2280)] = 65258,
  [SMALL_STATE(2281)] = 65265,
  [SMALL_STATE(2282)] = 65272,
  [SMALL_STATE(2283)] = 65279,
  [SMALL_STATE(2284)] = 65286,
  [SMALL_STATE(2285)] = 65293,
  [SMALL_STATE(2286)] = 65300,
  [SMALL_STATE(2287)] = 65307,
  [SMALL_STATE(2288)] = 65314,
  [SMALL_STATE(2289)] = 65321,
  [SMALL_STATE(2290)] = 65328,
  [SMALL_STATE(2291)] = 65335,
  [SMALL_STATE(2292)] = 65342,
  [SMALL_STATE(2293)] = 65349,
  [SMALL_STATE(2294)] = 65356,
  [SMALL_STATE(2295)] = 65363,
  [SMALL_STATE(2296)] = 65370,
  [SMALL_STATE(2297)] = 65377,
  [SMALL_STATE(2298)] = 65384,
  [SMALL_STATE(2299)] = 65391,
  [SMALL_STATE(2300)] = 65398,
  [SMALL_STATE(2301)] = 65405,
  [SMALL_STATE(2302)] = 65412,
  [SMALL_STATE(2303)] = 65419,
  [SMALL_STATE(2304)] = 65426,
  [SMALL_STATE(2305)] = 65433,
  [SMALL_STATE(2306)] = 65440,
  [SMALL_STATE(2307)] = 65447,
  [SMALL_STATE(2308)] = 65454,
  [SMALL_STATE(2309)] = 65461,
  [SMALL_STATE(2310)] = 65468,
  [SMALL_STATE(2311)] = 65475,
  [SMALL_STATE(2312)] = 65482,
  [SMALL_STATE(2313)] = 65489,
  [SMALL_STATE(2314)] = 65496,
  [SMALL_STATE(2315)] = 65503,
  [SMALL_STATE(2316)] = 65510,
  [SMALL_STATE(2317)] = 65517,
  [SMALL_STATE(2318)] = 65524,
  [SMALL_STATE(2319)] = 65531,
  [SMALL_STATE(2320)] = 65538,
  [SMALL_STATE(2321)] = 65545,
  [SMALL_STATE(2322)] = 65552,
  [SMALL_STATE(2323)] = 65559,
  [SMALL_STATE(2324)] = 65566,
  [SMALL_STATE(2325)] = 65573,
  [SMALL_STATE(2326)] = 65580,
  [SMALL_STATE(2327)] = 65587,
  [SMALL_STATE(2328)] = 65594,
  [SMALL_STATE(2329)] = 65601,
  [SMALL_STATE(2330)] = 65608,
  [SMALL_STATE(2331)] = 65615,
  [SMALL_STATE(2332)] = 65622,
  [SMALL_STATE(2333)] = 65629,
  [SMALL_STATE(2334)] = 65636,
  [SMALL_STATE(2335)] = 65643,
  [SMALL_STATE(2336)] = 65650,
  [SMALL_STATE(2337)] = 65657,
  [SMALL_STATE(2338)] = 65664,
  [SMALL_STATE(2339)] = 65671,
  [SMALL_STATE(2340)] = 65678,
  [SMALL_STATE(2341)] = 65685,
  [SMALL_STATE(2342)] = 65692,
  [SMALL_STATE(2343)] = 65699,
  [SMALL_STATE(2344)] = 65706,
  [SMALL_STATE(2345)] = 65713,
  [SMALL_STATE(2346)] = 65720,
  [SMALL_STATE(2347)] = 65727,
  [SMALL_STATE(2348)] = 65734,
  [SMALL_STATE(2349)] = 65741,
  [SMALL_STATE(2350)] = 65748,
  [SMALL_STATE(2351)] = 65755,
  [SMALL_STATE(2352)] = 65762,
  [SMALL_STATE(2353)] = 65769,
  [SMALL_STATE(2354)] = 65776,
  [SMALL_STATE(2355)] = 65783,
  [SMALL_STATE(2356)] = 65790,
  [SMALL_STATE(2357)] = 65797,
  [SMALL_STATE(2358)] = 65804,
  [SMALL_STATE(2359)] = 65811,
  [SMALL_STATE(2360)] = 65818,
  [SMALL_STATE(2361)] = 65825,
  [SMALL_STATE(2362)] = 65832,
  [SMALL_STATE(2363)] = 65839,
  [SMALL_STATE(2364)] = 65846,
  [SMALL_STATE(2365)] = 65853,
  [SMALL_STATE(2366)] = 65860,
  [SMALL_STATE(2367)] = 65867,
  [SMALL_STATE(2368)] = 65874,
  [SMALL_STATE(2369)] = 65881,
  [SMALL_STATE(2370)] = 65888,
  [SMALL_STATE(2371)] = 65895,
  [SMALL_STATE(2372)] = 65902,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 16),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 38),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 16),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 38),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1564),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2186),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1320),
  [229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2187),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1979),
  [237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(745),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(501),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(636),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(520),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1077),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1023),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1050),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1677),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2089),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2021),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(728),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2092),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2355),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(670),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2190),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2023),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2217),
  [348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2333),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1691),
  [366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(864),
  [369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1872),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(864),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2076),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2276),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1325),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2238),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1940),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(499),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(637),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(244),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(532),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1082),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1129),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1039),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(26),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2020),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2042),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2164),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2022),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2362),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(680),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2253),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2244),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2047),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2230),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(544),
  [613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1559),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2128),
  [619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1310),
  [622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2126),
  [625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1893),
  [628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(474),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(641),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(187),
  [637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(523),
  [640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1078),
  [643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1122),
  [646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1037),
  [649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(34),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2077),
  [657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2090),
  [660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(749),
  [663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2338),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2083),
  [669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(506),
  [672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(672),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2346),
  [681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2352),
  [684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2106),
  [687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1568),
  [703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2368),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1312),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2361),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1850),
  [715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(745),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(642),
  [733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(527),
  [736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1079),
  [739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1130),
  [742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1032),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1050),
  [757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1677),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2095),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2094),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2342),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2086),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(502),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2339),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(669),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2337),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2335),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2334),
  [817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2333),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1691),
  [835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1231),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1872),
  [841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1231),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2076),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(540),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(745),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(520),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(636),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1077),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(25),
  [909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1677),
  [927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2089),
  [933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2021),
  [936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2092),
  [939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2355),
  [945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(670),
  [948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2190),
  [954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2023),
  [960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2217),
  [963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(697),
  [966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2333),
  [972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1691),
  [981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(864),
  [984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1872),
  [987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(864),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2076),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 8),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 8),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [1023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(532),
  [1026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(637),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(244),
  [1032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1082),
  [1035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1129),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(26),
  [1041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2020),
  [1044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2042),
  [1047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2022),
  [1050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2362),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(680),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2253),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2244),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2047),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2230),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 8),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 8),
  [1082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(547),
  [1085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(523),
  [1088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(641),
  [1091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(187),
  [1094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1078),
  [1097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1122),
  [1100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(34),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2077),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2090),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2083),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(506),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(672),
  [1123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2346),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2352),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2106),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(527),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(642),
  [1147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(184),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1079),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1130),
  [1156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2095),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2094),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2086),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(502),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2339),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(669),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2337),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2335),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2334),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2036),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2354),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(541),
  [1205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2017),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2014),
  [1211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2321),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2064),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 26),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 26),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 103),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 103),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 63),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 63),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 118),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 118),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 117),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 117),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 114),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 114),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 61),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 61),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 77),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 77),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 0),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 0),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 54),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 54),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 97),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 97),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 96),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 96),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 7),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 7),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 46),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 46),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 92),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 92),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 7, 0, 128),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 7, 0, 128),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 91),
  [1303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 91),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 86),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 86),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 82),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 82),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 34),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 34),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 7),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 7),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 46),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 46),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 77),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 77),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 30),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 30),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 28),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 28),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 27),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 27),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 27),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 27),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 67),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 67),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 0),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 0),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 76),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 76),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 16),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 16),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 16),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 16),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 17),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 17),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 137),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 137),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 22),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 22),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 122),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 122),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 68),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 68),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 130),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 130),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 69),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 69),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 138),
  [1447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 138),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, 0, 142),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, 0, 142),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 38),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 38),
  [1457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 129),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 129),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 70),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 70),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 15),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 15),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_extension, 5, 0, 71),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_extension, 5, 0, 71),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 75),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 75),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 32),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 32),
  [1481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 36),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 36),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 37),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 37),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 38),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 38),
  [1497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 39),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 39),
  [1501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 16),
  [1503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 16),
  [1505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 45),
  [1507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 45),
  [1509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 98),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 98),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 121),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 121),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 101),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 101),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 60),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 60),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 102),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 102),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [1548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 16),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 38),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 38),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 16),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(945),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2284),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1302),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [1618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2138),
  [1621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2096),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(525),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [1630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [1633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [1636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2088),
  [1639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(975),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [1648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1860),
  [1654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1677),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [1660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [1663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2076),
  [1666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2285),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1323),
  [1672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2213),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2058),
  [1678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(526),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2103),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1289),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2116),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2070),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(528),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 56),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 56),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(945),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0),
  [1795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(904),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(913),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2353),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2088),
  [1807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2351),
  [1810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(975),
  [1813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2350),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(967),
  [1819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(1860),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(1677),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(1756),
  [1828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(928),
  [1831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(518),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(747),
  [1837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(747),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(745),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(117),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2018),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(25),
  [1852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2089),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2021),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(728),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2254),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2092),
  [1867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(488),
  [1870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2355),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(670),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2173),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2190),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2196),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2023),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2217),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(697),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(750),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2333),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2332),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2331),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1691),
  [1909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(864),
  [1912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1872),
  [1915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1819),
  [1918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(864),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(852),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(924),
  [1927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(244),
  [1930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(26),
  [1933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2020),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2042),
  [1939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(710),
  [1942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2164),
  [1945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2022),
  [1948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(482),
  [1951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2362),
  [1954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(680),
  [1957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2253),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2250),
  [1963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2244),
  [1966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2047),
  [1969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2230),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [1978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(929),
  [1981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(187),
  [1984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(28),
  [1987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2017),
  [1990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2094),
  [1993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(778),
  [1996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2172),
  [1999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2014),
  [2002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(502),
  [2005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2321),
  [2008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(669),
  [2011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2337),
  [2014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2335),
  [2017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2334),
  [2020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2064),
  [2023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2239),
  [2026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(922),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(184),
  [2032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2095),
  [2035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(725),
  [2038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2342),
  [2041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2086),
  [2044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2339),
  [2047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2036),
  [2050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2354),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(934),
  [2064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(34),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2077),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2090),
  [2073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(749),
  [2076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2338),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2083),
  [2082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(506),
  [2085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2293),
  [2088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(672),
  [2091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2346),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2352),
  [2097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2106),
  [2100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2041),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2143] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0), SHIFT(1128),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(409),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 98),
  [2200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 98),
  [2202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 70),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 70),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 46),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 46),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 72),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 72),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 80),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 80),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 69),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 69),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 16),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 16),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 39),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 39),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 38),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 38),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 16),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 16),
  [2238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 40),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 40),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 72),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 72),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 46),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 46),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 40),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 40),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 38),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 38),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 80),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 80),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 0),
  [2342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(634),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 0),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(644),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2076),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_layout_qualifiers, 4, 0, 0),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifiers, 4, 0, 0),
  [2357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2215),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0),
  [2362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2158),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_layout_specification, 2, 0, 0),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_specification, 2, 0, 0),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2240),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_layout_qualifiers, 3, 0, 0),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_layout_qualifiers, 3, 0, 0),
  [2376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2340),
  [2379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_repeat1, 1, 0, 0), SHIFT(2287),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_storage_class, 1, 0, 0),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_storage_class, 1, 0, 0),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 38),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 85),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 0, 0),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 0, 55),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 55),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 108),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [2510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(811),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1819),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 88),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 88),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 141),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 141),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [2538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [2541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(913),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [2547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2088),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [2553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 126),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 126),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 134),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 134),
  [2564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 57),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 57),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 135),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 135),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 89),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 89),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 127),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 127),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, 0, 0),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, 0, 0),
  [2587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2098),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 112),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 112),
  [2594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 111),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 111),
  [2598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [2602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [2610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(899),
  [2613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(847),
  [2616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2292),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 12),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 12),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 56),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 56),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 109),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 109),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 35),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 35),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 11),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 11),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 65),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 65),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 43),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 43),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 8),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 8),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 43),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 43),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 29),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 29),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [2733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 6),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 6),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 6),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 6),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 52),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 52),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 24),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 24),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 24),
  [2767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 24),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 13),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 13),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 13),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 13),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 25),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 25),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 81),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 81),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 23),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 23),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 7),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 7),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 51),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 51),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 7),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 7),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 23),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 23),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 53),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 53),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(931),
  [2830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 25),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 25),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 51),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 51),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 14),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 14),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 29),
  [2870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 29),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(1128),
  [2879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 24),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 24),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 23),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 23),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_type_specifier, 4, -1, 58),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_type_specifier, 4, -1, 58),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 4, 0, 25),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 4, 0, 25),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 23),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 23),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 49),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 49),
  [2919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 6, 0, 81),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 6, 0, 81),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 6),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 6),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 95),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 95),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 13),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 13),
  [2939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 6),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 6),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 25),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 25),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 66),
  [2955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 66),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 3, 0, 7),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 3, 0, 7),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 24),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 24),
  [2975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 4, 0, 23),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 4, 0, 23),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 7),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 51),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 51),
  [2987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 52),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 52),
  [2995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(936),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [3006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 6),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 6),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 5, 0, 53),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 5, 0, 53),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 14),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 14),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 9),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 9),
  [3022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 5, 0, 51),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 5, 0, 51),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 13),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 13),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 3, 0, 7),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 3, 0, 7),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 79),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 79),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [3042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 6),
  [3072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 6),
  [3074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 6), SHIFT(2353),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [3097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49), SHIFT(2353),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [3106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [3108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [3122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 79),
  [3124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 79),
  [3126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 79), SHIFT(2353),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 7),
  [3135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 7), SHIFT(2353),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 23),
  [3140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 23),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 23), SHIFT(2353),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [3170] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(1128),
  [3174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 78),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 78),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [3265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1146),
  [3268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1151),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 42),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [3293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [3299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 12),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 12),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 107),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 106),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 0, 105),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 3, 0, 0),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 119),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 62),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 0, 123),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 120),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 83),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 0, 84),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 13),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 13),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [3471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 13),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 13),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 13),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 13),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [3495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(931),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [3528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 14), SHIFT(1265),
  [3531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 13), SHIFT(1266),
  [3534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), SHIFT(1274),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [3557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1249),
  [3560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 14), SHIFT(931),
  [3563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 13), SHIFT(931),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3570] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(931),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [3576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 9), SHIFT(931),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1252),
  [3584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1269),
  [3587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1256),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [3596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [3598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 29),
  [3600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 29),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [3618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [3674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 40),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [3680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 72),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [3694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [3696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [3704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [3734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 6), SHIFT(2204),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 2, 0, 33),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 0, 33),
  [3773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 0, 33),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [3781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 38),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 4, 0, 33),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 4, 0, 33),
  [3797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1456),
  [3800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [3805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 2, 0, 0),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 3, 0, 33),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, 0, 33),
  [3811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, 0, 33),
  [3813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declaration_declarator, 3, 0, 33),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 16),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [3827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [3830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 113),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [3850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 59),
  [3852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 31),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [3864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [3866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [3868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [3870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 90),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [3882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 1, 0, 21),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 38),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 38),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 38),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 16),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [3948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 16),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0),
  [3954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0), REDUCE(aux_sym_function_declarator_repeat1, 1, 0, 0),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 1, 0, 0),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 16),
  [3961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 113),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 59),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 31),
  [3971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1896),
  [3974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1285),
  [3977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2129),
  [3980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2067),
  [3983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [3985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 31),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 90),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [3993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [3995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 113),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [3999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [4001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 21),
  [4007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 21),
  [4009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 21),
  [4011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 59),
  [4013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 31),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 90),
  [4021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [4023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [4025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [4027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [4033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [4035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [4037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 115),
  [4039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 115),
  [4041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 21),
  [4043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 21),
  [4045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 93),
  [4047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 93),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, 0, 0),
  [4053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 31),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [4063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [4077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 115),
  [4079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 115),
  [4081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 34),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 21),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 21),
  [4087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 93),
  [4089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 93),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [4093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [4095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 0, 33),
  [4097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 0, 33),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 5),
  [4101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 5),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 67),
  [4107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 50),
  [4109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 50),
  [4111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [4113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1896),
  [4118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [4120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [4122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(1627),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [4127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [4131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [4133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 21),
  [4135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 21),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [4139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2353),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 115),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 115),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 21),
  [4148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 21),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 93),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 93),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 21),
  [4160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 21),
  [4162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(695),
  [4165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [4167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(2122),
  [4170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [4172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [4200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 20),
  [4202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 20),
  [4204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [4206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [4208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 33),
  [4210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 33),
  [4212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declaration_declarator, 4, 0, 33),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 31),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [4238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1781),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [4245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 18),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 38),
  [4253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 38),
  [4255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 98),
  [4257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 98),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 41),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [4273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 16),
  [4275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 16),
  [4277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 70),
  [4279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 70),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 38),
  [4285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 38),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 69),
  [4289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 69),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 44),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 90),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 16),
  [4307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 16),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 59),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [4313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 74),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 39),
  [4317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 39),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [4321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 21),
  [4323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [4325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 73),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 21),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 93),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 99),
  [4339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 115),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 5),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat2, 3, 0, 94),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [4351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 33),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 19),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat2, 2, 0, 31),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [4363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 48),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, 0, 21),
  [4393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 2, 0, 47),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 87),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_declarator, 1, 0, 10),
  [4405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 64), SHIFT_REPEAT(1421),
  [4408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 64),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [4416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [4440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_declarator, 3, 0, 104),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [4458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 64), SHIFT_REPEAT(1514),
  [4461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 2, 0, 64),
  [4463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 110),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 87),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 124), SHIFT_REPEAT(1654),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 124),
  [4490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 110),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 125),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 124), SHIFT_REPEAT(1599),
  [4507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 124),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 132),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [4525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [4527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1815),
  [4530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1815),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [4541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [4547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [4549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1820),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 139), SHIFT_REPEAT(1555),
  [4565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 139),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 47),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [4579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [4583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_layout_qualifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1925),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_layout_qualifiers_repeat1, 2, 0, 0),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 144),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 144),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [4660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 143), SHIFT_REPEAT(2328),
  [4663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 143),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(651),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [4680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 140),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [4694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2055),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [4699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1328),
  [4702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 125),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 131),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [4748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1124),
  [4751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 136),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 133),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 87),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [4785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 131),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(2028),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(633),
  [4821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [4825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 87),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_declaration_declarator_repeat1, 3, 0, 31),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat2, 2, 0, 64), SHIFT_REPEAT(1270),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat2, 2, 0, 64),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 100),
  [4880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(648),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2228),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 1, 0, 0),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [5000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [5002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [5010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 48),
  [5012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat2, 4, 0, 116),
  [5014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [5016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [5022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 5),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [5030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [5048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [5050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [5066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 133),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1, 0, 0),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 69),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 70),
  [5154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 39),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [5186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [5190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 39),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [5212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 16),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 39),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [5278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 98),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 69),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 38),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [5304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 39),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 70),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 39),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 98),
  [5354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 69),
  [5356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 69),
  [5358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 70),
  [5360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 70),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [5366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 69),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [5406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 98),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 98),
  [5414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 98),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [5434] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_behavior, 1, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [5520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 70),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_glsl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
