#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1404
#define LARGE_STATE_COUNT 28
#define SYMBOL_COUNT 211
#define ALIAS_COUNT 5
#define TOKEN_COUNT 94
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 108

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_SEMI = 3,
  anon_sym_NULL = 4,
  anon_sym_package = 5,
  anon_sym_import = 6,
  anon_sym_DOT = 7,
  sym_blank_identifier = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_const = 11,
  anon_sym_COMMA = 12,
  anon_sym_EQ = 13,
  anon_sym_var = 14,
  anon_sym_func = 15,
  anon_sym_LBRACK = 16,
  anon_sym_RBRACK = 17,
  anon_sym_DOT_DOT_DOT = 18,
  anon_sym_type = 19,
  anon_sym_STAR = 20,
  anon_sym_struct = 21,
  anon_sym_TILDE = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_interface = 25,
  anon_sym_PIPE = 26,
  anon_sym_map = 27,
  anon_sym_chan = 28,
  anon_sym_LT_DASH = 29,
  anon_sym_COLON_EQ = 30,
  anon_sym_PLUS_PLUS = 31,
  anon_sym_DASH_DASH = 32,
  anon_sym_STAR_EQ = 33,
  anon_sym_SLASH_EQ = 34,
  anon_sym_PERCENT_EQ = 35,
  anon_sym_LT_LT_EQ = 36,
  anon_sym_GT_GT_EQ = 37,
  anon_sym_AMP_EQ = 38,
  anon_sym_AMP_CARET_EQ = 39,
  anon_sym_PLUS_EQ = 40,
  anon_sym_DASH_EQ = 41,
  anon_sym_PIPE_EQ = 42,
  anon_sym_CARET_EQ = 43,
  anon_sym_COLON = 44,
  anon_sym_fallthrough = 45,
  anon_sym_break = 46,
  anon_sym_continue = 47,
  anon_sym_goto = 48,
  anon_sym_return = 49,
  anon_sym_go = 50,
  anon_sym_defer = 51,
  anon_sym_if = 52,
  anon_sym_else = 53,
  anon_sym_for = 54,
  anon_sym_range = 55,
  anon_sym_switch = 56,
  anon_sym_case = 57,
  anon_sym_default = 58,
  anon_sym_select = 59,
  anon_sym_new = 60,
  anon_sym_make = 61,
  anon_sym_PLUS = 62,
  anon_sym_DASH = 63,
  anon_sym_BANG = 64,
  anon_sym_CARET = 65,
  anon_sym_AMP = 66,
  anon_sym_SLASH = 67,
  anon_sym_PERCENT = 68,
  anon_sym_LT_LT = 69,
  anon_sym_GT_GT = 70,
  anon_sym_AMP_CARET = 71,
  anon_sym_EQ_EQ = 72,
  anon_sym_BANG_EQ = 73,
  anon_sym_LT = 74,
  anon_sym_LT_EQ = 75,
  anon_sym_GT = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_AMP_AMP = 78,
  anon_sym_PIPE_PIPE = 79,
  sym_raw_string_literal = 80,
  anon_sym_DQUOTE = 81,
  anon_sym_DQUOTE2 = 82,
  sym__interpreted_string_literal_basic_content = 83,
  sym_escape_sequence = 84,
  sym_int_literal = 85,
  sym_float_literal = 86,
  sym_imaginary_literal = 87,
  sym_rune_literal = 88,
  sym_nil = 89,
  sym_true = 90,
  sym_false = 91,
  sym_iota = 92,
  sym_comment = 93,
  sym_source_file = 94,
  sym_package_clause = 95,
  sym_import_declaration = 96,
  sym_import_spec = 97,
  sym_dot = 98,
  sym_import_spec_list = 99,
  sym__declaration = 100,
  sym_const_declaration = 101,
  sym_const_spec = 102,
  sym_var_declaration = 103,
  sym_var_spec = 104,
  sym_function_declaration = 105,
  sym_method_declaration = 106,
  sym_type_parameter_list = 107,
  sym_type_parameter_declaration = 108,
  sym_parameter_list = 109,
  sym_parameter_declaration = 110,
  sym_variadic_parameter_declaration = 111,
  sym_type_alias = 112,
  sym_type_declaration = 113,
  sym_type_spec = 114,
  sym_expression_list = 115,
  sym_parenthesized_type = 116,
  sym__simple_type = 117,
  sym_generic_type = 118,
  sym_type_arguments = 119,
  sym_pointer_type = 120,
  sym_array_type = 121,
  sym_implicit_length_array_type = 122,
  sym_slice_type = 123,
  sym_struct_type = 124,
  sym_negated_type = 125,
  sym_field_declaration_list = 126,
  sym_field_declaration = 127,
  sym_interface_type = 128,
  sym_method_elem = 129,
  sym_type_elem = 130,
  sym_map_type = 131,
  sym_channel_type = 132,
  sym_function_type = 133,
  sym_block = 134,
  sym__statement_list = 135,
  sym__statement = 136,
  sym_empty_statement = 137,
  sym__simple_statement = 138,
  sym_expression_statement = 139,
  sym_send_statement = 140,
  sym_receive_statement = 141,
  sym_inc_statement = 142,
  sym_dec_statement = 143,
  sym_assignment_statement = 144,
  sym_short_var_declaration = 145,
  sym_labeled_statement = 146,
  sym_empty_labeled_statement = 147,
  sym_fallthrough_statement = 148,
  sym_break_statement = 149,
  sym_continue_statement = 150,
  sym_goto_statement = 151,
  sym_return_statement = 152,
  sym_go_statement = 153,
  sym_defer_statement = 154,
  sym_if_statement = 155,
  sym_for_statement = 156,
  sym_for_clause = 157,
  sym_range_clause = 158,
  sym_expression_switch_statement = 159,
  sym_expression_case = 160,
  sym_default_case = 161,
  sym_type_switch_statement = 162,
  sym__type_switch_header = 163,
  sym_type_case = 164,
  sym_select_statement = 165,
  sym_communication_case = 166,
  sym__expression = 167,
  sym_parenthesized_expression = 168,
  sym_call_expression = 169,
  sym_variadic_argument = 170,
  sym_special_argument_list = 171,
  sym_argument_list = 172,
  sym_selector_expression = 173,
  sym_index_expression = 174,
  sym_slice_expression = 175,
  sym_type_assertion_expression = 176,
  sym_type_conversion_expression = 177,
  sym_type_instantiation_expression = 178,
  sym_composite_literal = 179,
  sym_literal_value = 180,
  sym_literal_element = 181,
  sym_keyed_element = 182,
  sym_func_literal = 183,
  sym_unary_expression = 184,
  sym_binary_expression = 185,
  sym_qualified_type = 186,
  sym_interpreted_string_literal = 187,
  aux_sym_source_file_repeat1 = 188,
  aux_sym_import_spec_list_repeat1 = 189,
  aux_sym_const_declaration_repeat1 = 190,
  aux_sym_const_spec_repeat1 = 191,
  aux_sym_var_declaration_repeat1 = 192,
  aux_sym_type_parameter_list_repeat1 = 193,
  aux_sym_type_parameter_declaration_repeat1 = 194,
  aux_sym_parameter_list_repeat1 = 195,
  aux_sym_type_declaration_repeat1 = 196,
  aux_sym_expression_list_repeat1 = 197,
  aux_sym_type_arguments_repeat1 = 198,
  aux_sym_field_declaration_list_repeat1 = 199,
  aux_sym_field_declaration_repeat1 = 200,
  aux_sym_interface_type_repeat1 = 201,
  aux_sym_type_elem_repeat1 = 202,
  aux_sym__statement_list_repeat1 = 203,
  aux_sym_expression_switch_statement_repeat1 = 204,
  aux_sym_type_switch_statement_repeat1 = 205,
  aux_sym_type_case_repeat1 = 206,
  aux_sym_select_statement_repeat1 = 207,
  aux_sym_argument_list_repeat1 = 208,
  aux_sym_literal_value_repeat1 = 209,
  aux_sym_interpreted_string_literal_repeat1 = 210,
  alias_sym_field_identifier = 211,
  alias_sym_label_name = 212,
  alias_sym_package_identifier = 213,
  alias_sym_type_constraint = 214,
  alias_sym_type_identifier = 215,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_NULL] = "\0",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_const] = "const",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_var] = "var",
  [anon_sym_func] = "func",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_type] = "type",
  [anon_sym_STAR] = "*",
  [anon_sym_struct] = "struct",
  [anon_sym_TILDE] = "~",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_PIPE] = "|",
  [anon_sym_map] = "map",
  [anon_sym_chan] = "chan",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON] = ":",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_go] = "go",
  [anon_sym_defer] = "defer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_range] = "range",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_select] = "select",
  [anon_sym_new] = "identifier",
  [anon_sym_make] = "identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE2] = "\"",
  [sym__interpreted_string_literal_basic_content] = "_interpreted_string_literal_basic_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_imaginary_literal] = "imaginary_literal",
  [sym_rune_literal] = "rune_literal",
  [sym_nil] = "nil",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_iota] = "iota",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_dot] = "dot",
  [sym_import_spec_list] = "import_spec_list",
  [sym__declaration] = "_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_spec] = "const_spec",
  [sym_var_declaration] = "var_declaration",
  [sym_var_spec] = "var_spec",
  [sym_function_declaration] = "function_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_type_alias] = "type_alias",
  [sym_type_declaration] = "type_declaration",
  [sym_type_spec] = "type_spec",
  [sym_expression_list] = "expression_list",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym__simple_type] = "_simple_type",
  [sym_generic_type] = "generic_type",
  [sym_type_arguments] = "type_arguments",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_implicit_length_array_type] = "implicit_length_array_type",
  [sym_slice_type] = "slice_type",
  [sym_struct_type] = "struct_type",
  [sym_negated_type] = "negated_type",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_interface_type] = "interface_type",
  [sym_method_elem] = "method_elem",
  [sym_type_elem] = "type_elem",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_function_type] = "function_type",
  [sym_block] = "block",
  [sym__statement_list] = "_statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_send_statement] = "send_statement",
  [sym_receive_statement] = "receive_statement",
  [sym_inc_statement] = "inc_statement",
  [sym_dec_statement] = "dec_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_short_var_declaration] = "short_var_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_empty_labeled_statement] = "labeled_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_return_statement] = "return_statement",
  [sym_go_statement] = "go_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_clause] = "for_clause",
  [sym_range_clause] = "range_clause",
  [sym_expression_switch_statement] = "expression_switch_statement",
  [sym_expression_case] = "expression_case",
  [sym_default_case] = "default_case",
  [sym_type_switch_statement] = "type_switch_statement",
  [sym__type_switch_header] = "_type_switch_header",
  [sym_type_case] = "type_case",
  [sym_select_statement] = "select_statement",
  [sym_communication_case] = "communication_case",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_variadic_argument] = "variadic_argument",
  [sym_special_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym_selector_expression] = "selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_type_assertion_expression] = "type_assertion_expression",
  [sym_type_conversion_expression] = "type_conversion_expression",
  [sym_type_instantiation_expression] = "type_instantiation_expression",
  [sym_composite_literal] = "composite_literal",
  [sym_literal_value] = "literal_value",
  [sym_literal_element] = "literal_element",
  [sym_keyed_element] = "keyed_element",
  [sym_func_literal] = "func_literal",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_qualified_type] = "qualified_type",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_const_spec_repeat1] = "const_spec_repeat1",
  [aux_sym_var_declaration_repeat1] = "var_declaration_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_type_parameter_declaration_repeat1] = "type_parameter_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_declaration_repeat1] = "type_declaration_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_interface_type_repeat1] = "interface_type_repeat1",
  [aux_sym_type_elem_repeat1] = "type_elem_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_expression_switch_statement_repeat1] = "expression_switch_statement_repeat1",
  [aux_sym_type_switch_statement_repeat1] = "type_switch_statement_repeat1",
  [aux_sym_type_case_repeat1] = "type_case_repeat1",
  [aux_sym_select_statement_repeat1] = "select_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_literal_value_repeat1] = "literal_value_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_label_name] = "label_name",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_type_constraint] = "type_constraint",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_new] = sym_identifier,
  [anon_sym_make] = sym_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__interpreted_string_literal_basic_content] = sym__interpreted_string_literal_basic_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_imaginary_literal] = sym_imaginary_literal,
  [sym_rune_literal] = sym_rune_literal,
  [sym_nil] = sym_nil,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_iota] = sym_iota,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_dot] = sym_dot,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym__declaration] = sym__declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_spec] = sym_const_spec,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_spec] = sym_var_spec,
  [sym_function_declaration] = sym_function_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_type_alias] = sym_type_alias,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_spec] = sym_type_spec,
  [sym_expression_list] = sym_expression_list,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym__simple_type] = sym__simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_implicit_length_array_type] = sym_implicit_length_array_type,
  [sym_slice_type] = sym_slice_type,
  [sym_struct_type] = sym_struct_type,
  [sym_negated_type] = sym_negated_type,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_interface_type] = sym_interface_type,
  [sym_method_elem] = sym_method_elem,
  [sym_type_elem] = sym_type_elem,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_function_type] = sym_function_type,
  [sym_block] = sym_block,
  [sym__statement_list] = sym__statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_receive_statement] = sym_receive_statement,
  [sym_inc_statement] = sym_inc_statement,
  [sym_dec_statement] = sym_dec_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_short_var_declaration] = sym_short_var_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_empty_labeled_statement] = sym_labeled_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_go_statement] = sym_go_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_clause] = sym_for_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_expression_switch_statement] = sym_expression_switch_statement,
  [sym_expression_case] = sym_expression_case,
  [sym_default_case] = sym_default_case,
  [sym_type_switch_statement] = sym_type_switch_statement,
  [sym__type_switch_header] = sym__type_switch_header,
  [sym_type_case] = sym_type_case,
  [sym_select_statement] = sym_select_statement,
  [sym_communication_case] = sym_communication_case,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_variadic_argument] = sym_variadic_argument,
  [sym_special_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_selector_expression] = sym_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_type_assertion_expression] = sym_type_assertion_expression,
  [sym_type_conversion_expression] = sym_type_conversion_expression,
  [sym_type_instantiation_expression] = sym_type_instantiation_expression,
  [sym_composite_literal] = sym_composite_literal,
  [sym_literal_value] = sym_literal_value,
  [sym_literal_element] = sym_literal_element,
  [sym_keyed_element] = sym_keyed_element,
  [sym_func_literal] = sym_func_literal,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_qualified_type] = sym_qualified_type,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_const_spec_repeat1] = aux_sym_const_spec_repeat1,
  [aux_sym_var_declaration_repeat1] = aux_sym_var_declaration_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_type_parameter_declaration_repeat1] = aux_sym_type_parameter_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_type_declaration_repeat1] = aux_sym_type_declaration_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_interface_type_repeat1] = aux_sym_interface_type_repeat1,
  [aux_sym_type_elem_repeat1] = aux_sym_type_elem_repeat1,
  [aux_sym__statement_list_repeat1] = aux_sym__statement_list_repeat1,
  [aux_sym_expression_switch_statement_repeat1] = aux_sym_expression_switch_statement_repeat1,
  [aux_sym_type_switch_statement_repeat1] = aux_sym_type_switch_statement_repeat1,
  [aux_sym_type_case_repeat1] = aux_sym_type_case_repeat1,
  [aux_sym_select_statement_repeat1] = aux_sym_select_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_literal_value_repeat1] = aux_sym_literal_value_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_type_constraint] = alias_sym_type_constraint,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_make] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__interpreted_string_literal_basic_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_imaginary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_iota] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_length_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type] = {
    .visible = true,
    .named = true,
  },
  [sym_method_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_type_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_short_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_go_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_type_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_switch_header] = {
    .visible = false,
    .named = true,
  },
  [sym_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_communication_case] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_value] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_element] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_func_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_elem_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_constraint] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_body = 4,
  field_capacity = 5,
  field_channel = 6,
  field_communication = 7,
  field_condition = 8,
  field_consequence = 9,
  field_element = 10,
  field_end = 11,
  field_field = 12,
  field_function = 13,
  field_index = 14,
  field_initializer = 15,
  field_key = 16,
  field_label = 17,
  field_left = 18,
  field_length = 19,
  field_name = 20,
  field_operand = 21,
  field_operator = 22,
  field_package = 23,
  field_parameters = 24,
  field_path = 25,
  field_receiver = 26,
  field_result = 27,
  field_right = 28,
  field_start = 29,
  field_tag = 30,
  field_type = 31,
  field_type_arguments = 32,
  field_type_parameters = 33,
  field_update = 34,
  field_value = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_capacity] = "capacity",
  [field_channel] = "channel",
  [field_communication] = "communication",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_element] = "element",
  [field_end] = "end",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_start] = "start",
  [field_tag] = "tag",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 9, .length = 2},
  [15] = {.index = 13, .length = 2},
  [16] = {.index = 13, .length = 2},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 1},
  [20] = {.index = 20, .length = 2},
  [21] = {.index = 22, .length = 2},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 26, .length = 1},
  [24] = {.index = 17, .length = 2},
  [25] = {.index = 19, .length = 1},
  [26] = {.index = 27, .length = 1},
  [27] = {.index = 28, .length = 1},
  [28] = {.index = 29, .length = 2},
  [29] = {.index = 31, .length = 1},
  [30] = {.index = 32, .length = 1},
  [31] = {.index = 33, .length = 2},
  [32] = {.index = 35, .length = 3},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 40, .length = 2},
  [35] = {.index = 42, .length = 2},
  [36] = {.index = 44, .length = 3},
  [37] = {.index = 47, .length = 2},
  [38] = {.index = 49, .length = 3},
  [39] = {.index = 52, .length = 1},
  [40] = {.index = 53, .length = 3},
  [41] = {.index = 56, .length = 3},
  [42] = {.index = 59, .length = 3},
  [43] = {.index = 62, .length = 3},
  [44] = {.index = 65, .length = 3},
  [45] = {.index = 68, .length = 1},
  [46] = {.index = 69, .length = 2},
  [47] = {.index = 71, .length = 2},
  [48] = {.index = 73, .length = 3},
  [49] = {.index = 52, .length = 1},
  [50] = {.index = 76, .length = 2},
  [51] = {.index = 17, .length = 2},
  [52] = {.index = 76, .length = 2},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 1},
  [55] = {.index = 81, .length = 1},
  [56] = {.index = 82, .length = 1},
  [57] = {.index = 83, .length = 3},
  [58] = {.index = 86, .length = 1},
  [59] = {.index = 87, .length = 2},
  [60] = {.index = 89, .length = 1},
  [61] = {.index = 90, .length = 2},
  [62] = {.index = 92, .length = 3},
  [63] = {.index = 95, .length = 3},
  [64] = {.index = 98, .length = 1},
  [65] = {.index = 71, .length = 2},
  [66] = {.index = 99, .length = 3},
  [67] = {.index = 102, .length = 2},
  [68] = {.index = 17, .length = 2},
  [69] = {.index = 104, .length = 4},
  [70] = {.index = 108, .length = 4},
  [71] = {.index = 112, .length = 4},
  [72] = {.index = 116, .length = 4},
  [73] = {.index = 120, .length = 4},
  [74] = {.index = 124, .length = 2},
  [75] = {.index = 124, .length = 2},
  [76] = {.index = 98, .length = 1},
  [77] = {.index = 126, .length = 3},
  [78] = {.index = 99, .length = 3},
  [79] = {.index = 129, .length = 3},
  [80] = {.index = 132, .length = 2},
  [81] = {.index = 134, .length = 3},
  [82] = {.index = 137, .length = 3},
  [83] = {.index = 140, .length = 2},
  [84] = {.index = 142, .length = 2},
  [85] = {.index = 144, .length = 2},
  [86] = {.index = 146, .length = 2},
  [87] = {.index = 148, .length = 1},
  [88] = {.index = 149, .length = 1},
  [89] = {.index = 150, .length = 2},
  [90] = {.index = 152, .length = 2},
  [91] = {.index = 154, .length = 2},
  [92] = {.index = 156, .length = 4},
  [93] = {.index = 99, .length = 3},
  [94] = {.index = 160, .length = 5},
  [95] = {.index = 165, .length = 5},
  [96] = {.index = 170, .length = 4},
  [97] = {.index = 174, .length = 3},
  [98] = {.index = 177, .length = 2},
  [99] = {.index = 179, .length = 1},
  [100] = {.index = 180, .length = 3},
  [101] = {.index = 183, .length = 4},
  [102] = {.index = 187, .length = 2},
  [103] = {.index = 189, .length = 3},
  [104] = {.index = 192, .length = 2},
  [105] = {.index = 194, .length = 2},
  [106] = {.index = 196, .length = 4},
  [107] = {.index = 200, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_parameters, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_value, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_type, 0},
    {field_type_arguments, 1},
  [11] =
    {field_body, 1},
    {field_type, 0},
  [13] =
    {field_name, 0},
    {field_path, 1},
  [15] =
    {field_name, 0},
    {field_name, 1},
  [17] =
    {field_name, 0},
    {field_type, 1},
  [19] =
    {field_type, 0},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_parameters, 1},
    {field_result, 2},
  [24] =
    {field_body, 2},
    {field_parameters, 1},
  [26] =
    {field_element, 2},
  [27] =
    {field_label, 0},
  [28] =
    {field_value, 2},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_right, 1},
  [32] =
    {field_body, 2},
  [33] =
    {field_name, 2},
    {field_package, 0},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_left, 0},
    {field_right, 2},
  [40] =
    {field_field, 2},
    {field_operand, 0},
  [42] =
    {field_channel, 0},
    {field_value, 2},
  [44] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
  [52] =
    {field_type, 1},
  [53] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [56] =
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [59] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [62] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [65] =
    {field_body, 3},
    {field_parameters, 1},
    {field_result, 2},
  [68] =
    {field_element, 3},
  [69] =
    {field_element, 3},
    {field_length, 1},
  [71] =
    {field_name, 0},
    {field_type, 2},
  [73] =
    {field_name, 0},
    {field_type, 2},
    {field_type_parameters, 1},
  [76] =
    {field_tag, 1},
    {field_type, 0},
  [78] =
    {field_name, 0},
    {field_parameters, 1},
  [80] =
    {field_update, 2},
  [81] =
    {field_condition, 1},
  [82] =
    {field_initializer, 0},
  [83] =
    {field_alias, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [86] =
    {field_right, 0},
  [87] =
    {field_operand, 2},
    {field_type, 0},
  [89] =
    {field_operand, 0},
  [90] =
    {field_index, 2},
    {field_operand, 0},
  [92] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 3},
  [95] =
    {field_name, 0},
    {field_name, 1},
    {field_value, 3},
  [98] =
    {field_name, 1},
  [99] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 2},
  [102] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [104] =
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [108] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [112] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [116] =
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [120] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [124] =
    {field_tag, 2},
    {field_type, 1},
  [126] =
    {field_name, 0},
    {field_tag, 2},
    {field_type, 1},
  [129] =
    {field_name, 0},
    {field_parameters, 1},
    {field_result, 2},
  [132] =
    {field_key, 2},
    {field_value, 4},
  [134] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [137] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [140] =
    {field_condition, 1},
    {field_update, 3},
  [142] =
    {field_left, 0},
    {field_right, 3},
  [144] =
    {field_initializer, 0},
    {field_update, 3},
  [146] =
    {field_condition, 2},
    {field_initializer, 0},
  [148] =
    {field_initializer, 1},
  [149] =
    {field_communication, 1},
  [150] =
    {field_operand, 0},
    {field_type, 3},
  [152] =
    {field_end, 3},
    {field_operand, 0},
  [154] =
    {field_operand, 0},
    {field_start, 2},
  [156] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [160] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [165] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [170] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_tag, 3},
    {field_type, 2},
  [174] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [177] =
    {field_initializer, 1},
    {field_value, 3},
  [179] =
    {field_value, 0},
  [180] =
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [183] =
    {field_alternative, 6},
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [187] =
    {field_type, 1},
    {field_type, 2},
  [189] =
    {field_capacity, 5},
    {field_end, 3},
    {field_operand, 0},
  [192] =
    {field_alias, 0},
    {field_value, 2},
  [194] =
    {field_initializer, 0},
    {field_value, 2},
  [196] =
    {field_capacity, 6},
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [200] =
    {field_alias, 2},
    {field_initializer, 0},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_package_identifier,
  },
  [8] = {
    [1] = alias_sym_label_name,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [16] = {
    [0] = alias_sym_package_identifier,
  },
  [24] = {
    [0] = alias_sym_type_identifier,
  },
  [25] = {
    [0] = alias_sym_type_identifier,
  },
  [26] = {
    [0] = alias_sym_label_name,
  },
  [31] = {
    [0] = alias_sym_package_identifier,
    [2] = alias_sym_type_identifier,
  },
  [34] = {
    [2] = alias_sym_field_identifier,
  },
  [43] = {
    [2] = alias_sym_field_identifier,
  },
  [47] = {
    [0] = alias_sym_type_identifier,
  },
  [48] = {
    [0] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [0] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_field_identifier,
  },
  [53] = {
    [0] = alias_sym_field_identifier,
  },
  [68] = {
    [1] = alias_sym_type_constraint,
  },
  [72] = {
    [2] = alias_sym_field_identifier,
  },
  [73] = {
    [2] = alias_sym_field_identifier,
  },
  [74] = {
    [1] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = alias_sym_field_identifier,
  },
  [77] = {
    [0] = alias_sym_field_identifier,
  },
  [78] = {
    [0] = alias_sym_field_identifier,
  },
  [79] = {
    [0] = alias_sym_field_identifier,
  },
  [93] = {
    [2] = alias_sym_type_constraint,
  },
  [95] = {
    [2] = alias_sym_field_identifier,
  },
  [96] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_type_elem, 2,
    sym_type_elem,
    alias_sym_type_constraint,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 11,
  [13] = 11,
  [14] = 14,
  [15] = 11,
  [16] = 11,
  [17] = 11,
  [18] = 11,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 29,
  [31] = 29,
  [32] = 29,
  [33] = 29,
  [34] = 29,
  [35] = 35,
  [36] = 35,
  [37] = 35,
  [38] = 38,
  [39] = 35,
  [40] = 38,
  [41] = 35,
  [42] = 38,
  [43] = 38,
  [44] = 35,
  [45] = 38,
  [46] = 38,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 50,
  [52] = 52,
  [53] = 53,
  [54] = 52,
  [55] = 52,
  [56] = 50,
  [57] = 52,
  [58] = 58,
  [59] = 58,
  [60] = 60,
  [61] = 60,
  [62] = 50,
  [63] = 58,
  [64] = 53,
  [65] = 50,
  [66] = 66,
  [67] = 60,
  [68] = 68,
  [69] = 60,
  [70] = 50,
  [71] = 52,
  [72] = 58,
  [73] = 60,
  [74] = 74,
  [75] = 58,
  [76] = 58,
  [77] = 52,
  [78] = 60,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 83,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 82,
  [90] = 90,
  [91] = 82,
  [92] = 82,
  [93] = 88,
  [94] = 94,
  [95] = 95,
  [96] = 87,
  [97] = 84,
  [98] = 83,
  [99] = 83,
  [100] = 84,
  [101] = 101,
  [102] = 87,
  [103] = 88,
  [104] = 95,
  [105] = 94,
  [106] = 88,
  [107] = 107,
  [108] = 87,
  [109] = 109,
  [110] = 110,
  [111] = 84,
  [112] = 84,
  [113] = 82,
  [114] = 83,
  [115] = 88,
  [116] = 87,
  [117] = 87,
  [118] = 82,
  [119] = 83,
  [120] = 88,
  [121] = 121,
  [122] = 122,
  [123] = 84,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 94,
  [129] = 95,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 132,
  [134] = 134,
  [135] = 131,
  [136] = 136,
  [137] = 131,
  [138] = 130,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 130,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 134,
  [149] = 136,
  [150] = 131,
  [151] = 143,
  [152] = 136,
  [153] = 132,
  [154] = 147,
  [155] = 155,
  [156] = 156,
  [157] = 141,
  [158] = 139,
  [159] = 159,
  [160] = 140,
  [161] = 141,
  [162] = 139,
  [163] = 140,
  [164] = 132,
  [165] = 131,
  [166] = 136,
  [167] = 134,
  [168] = 145,
  [169] = 147,
  [170] = 130,
  [171] = 132,
  [172] = 139,
  [173] = 159,
  [174] = 174,
  [175] = 159,
  [176] = 145,
  [177] = 134,
  [178] = 136,
  [179] = 155,
  [180] = 180,
  [181] = 131,
  [182] = 147,
  [183] = 140,
  [184] = 136,
  [185] = 131,
  [186] = 134,
  [187] = 143,
  [188] = 145,
  [189] = 134,
  [190] = 141,
  [191] = 146,
  [192] = 143,
  [193] = 143,
  [194] = 140,
  [195] = 159,
  [196] = 145,
  [197] = 139,
  [198] = 147,
  [199] = 155,
  [200] = 130,
  [201] = 155,
  [202] = 155,
  [203] = 130,
  [204] = 159,
  [205] = 155,
  [206] = 141,
  [207] = 159,
  [208] = 130,
  [209] = 132,
  [210] = 147,
  [211] = 155,
  [212] = 159,
  [213] = 159,
  [214] = 214,
  [215] = 140,
  [216] = 139,
  [217] = 217,
  [218] = 131,
  [219] = 145,
  [220] = 159,
  [221] = 155,
  [222] = 136,
  [223] = 134,
  [224] = 145,
  [225] = 145,
  [226] = 130,
  [227] = 146,
  [228] = 134,
  [229] = 132,
  [230] = 132,
  [231] = 136,
  [232] = 232,
  [233] = 159,
  [234] = 141,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 246,
  [290] = 243,
  [291] = 242,
  [292] = 245,
  [293] = 244,
  [294] = 238,
  [295] = 239,
  [296] = 240,
  [297] = 249,
  [298] = 254,
  [299] = 256,
  [300] = 269,
  [301] = 278,
  [302] = 251,
  [303] = 275,
  [304] = 286,
  [305] = 253,
  [306] = 247,
  [307] = 272,
  [308] = 287,
  [309] = 259,
  [310] = 260,
  [311] = 267,
  [312] = 280,
  [313] = 276,
  [314] = 270,
  [315] = 265,
  [316] = 264,
  [317] = 263,
  [318] = 261,
  [319] = 258,
  [320] = 255,
  [321] = 248,
  [322] = 257,
  [323] = 262,
  [324] = 266,
  [325] = 252,
  [326] = 271,
  [327] = 273,
  [328] = 283,
  [329] = 284,
  [330] = 285,
  [331] = 282,
  [332] = 281,
  [333] = 279,
  [334] = 268,
  [335] = 250,
  [336] = 239,
  [337] = 240,
  [338] = 338,
  [339] = 244,
  [340] = 246,
  [341] = 245,
  [342] = 242,
  [343] = 243,
  [344] = 249,
  [345] = 264,
  [346] = 282,
  [347] = 261,
  [348] = 280,
  [349] = 267,
  [350] = 263,
  [351] = 251,
  [352] = 265,
  [353] = 248,
  [354] = 270,
  [355] = 278,
  [356] = 255,
  [357] = 260,
  [358] = 259,
  [359] = 287,
  [360] = 272,
  [361] = 247,
  [362] = 256,
  [363] = 268,
  [364] = 253,
  [365] = 286,
  [366] = 279,
  [367] = 281,
  [368] = 258,
  [369] = 285,
  [370] = 284,
  [371] = 283,
  [372] = 273,
  [373] = 275,
  [374] = 271,
  [375] = 252,
  [376] = 269,
  [377] = 254,
  [378] = 266,
  [379] = 257,
  [380] = 250,
  [381] = 276,
  [382] = 262,
  [383] = 383,
  [384] = 383,
  [385] = 385,
  [386] = 240,
  [387] = 244,
  [388] = 239,
  [389] = 249,
  [390] = 390,
  [391] = 391,
  [392] = 266,
  [393] = 264,
  [394] = 250,
  [395] = 276,
  [396] = 279,
  [397] = 253,
  [398] = 281,
  [399] = 267,
  [400] = 282,
  [401] = 285,
  [402] = 284,
  [403] = 239,
  [404] = 283,
  [405] = 273,
  [406] = 272,
  [407] = 286,
  [408] = 271,
  [409] = 252,
  [410] = 280,
  [411] = 262,
  [412] = 257,
  [413] = 256,
  [414] = 255,
  [415] = 287,
  [416] = 254,
  [417] = 270,
  [418] = 260,
  [419] = 247,
  [420] = 265,
  [421] = 248,
  [422] = 258,
  [423] = 269,
  [424] = 424,
  [425] = 261,
  [426] = 275,
  [427] = 251,
  [428] = 268,
  [429] = 259,
  [430] = 278,
  [431] = 263,
  [432] = 383,
  [433] = 244,
  [434] = 245,
  [435] = 242,
  [436] = 243,
  [437] = 246,
  [438] = 245,
  [439] = 242,
  [440] = 383,
  [441] = 243,
  [442] = 338,
  [443] = 246,
  [444] = 240,
  [445] = 445,
  [446] = 239,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 249,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 265,
  [457] = 267,
  [458] = 247,
  [459] = 459,
  [460] = 250,
  [461] = 282,
  [462] = 285,
  [463] = 284,
  [464] = 283,
  [465] = 242,
  [466] = 273,
  [467] = 271,
  [468] = 252,
  [469] = 243,
  [470] = 266,
  [471] = 246,
  [472] = 278,
  [473] = 262,
  [474] = 257,
  [475] = 256,
  [476] = 459,
  [477] = 240,
  [478] = 255,
  [479] = 258,
  [480] = 383,
  [481] = 248,
  [482] = 268,
  [483] = 261,
  [484] = 263,
  [485] = 264,
  [486] = 254,
  [487] = 270,
  [488] = 276,
  [489] = 269,
  [490] = 280,
  [491] = 459,
  [492] = 383,
  [493] = 338,
  [494] = 245,
  [495] = 452,
  [496] = 448,
  [497] = 260,
  [498] = 259,
  [499] = 449,
  [500] = 287,
  [501] = 272,
  [502] = 281,
  [503] = 253,
  [504] = 286,
  [505] = 275,
  [506] = 251,
  [507] = 279,
  [508] = 244,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 424,
  [513] = 510,
  [514] = 514,
  [515] = 515,
  [516] = 509,
  [517] = 249,
  [518] = 239,
  [519] = 509,
  [520] = 515,
  [521] = 515,
  [522] = 515,
  [523] = 515,
  [524] = 239,
  [525] = 515,
  [526] = 510,
  [527] = 527,
  [528] = 257,
  [529] = 262,
  [530] = 530,
  [531] = 256,
  [532] = 255,
  [533] = 245,
  [534] = 242,
  [535] = 258,
  [536] = 261,
  [537] = 263,
  [538] = 253,
  [539] = 243,
  [540] = 246,
  [541] = 264,
  [542] = 265,
  [543] = 270,
  [544] = 276,
  [545] = 280,
  [546] = 546,
  [547] = 267,
  [548] = 548,
  [549] = 282,
  [550] = 285,
  [551] = 266,
  [552] = 424,
  [553] = 260,
  [554] = 554,
  [555] = 555,
  [556] = 259,
  [557] = 287,
  [558] = 272,
  [559] = 555,
  [560] = 247,
  [561] = 252,
  [562] = 286,
  [563] = 271,
  [564] = 273,
  [565] = 546,
  [566] = 283,
  [567] = 284,
  [568] = 568,
  [569] = 569,
  [570] = 242,
  [571] = 278,
  [572] = 243,
  [573] = 530,
  [574] = 239,
  [575] = 555,
  [576] = 250,
  [577] = 577,
  [578] = 530,
  [579] = 546,
  [580] = 251,
  [581] = 246,
  [582] = 254,
  [583] = 583,
  [584] = 269,
  [585] = 248,
  [586] = 268,
  [587] = 275,
  [588] = 279,
  [589] = 589,
  [590] = 245,
  [591] = 281,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 595,
  [599] = 599,
  [600] = 447,
  [601] = 601,
  [602] = 592,
  [603] = 603,
  [604] = 447,
  [605] = 594,
  [606] = 601,
  [607] = 607,
  [608] = 595,
  [609] = 447,
  [610] = 594,
  [611] = 595,
  [612] = 594,
  [613] = 601,
  [614] = 614,
  [615] = 601,
  [616] = 593,
  [617] = 593,
  [618] = 593,
  [619] = 338,
  [620] = 620,
  [621] = 593,
  [622] = 445,
  [623] = 338,
  [624] = 599,
  [625] = 447,
  [626] = 594,
  [627] = 595,
  [628] = 614,
  [629] = 592,
  [630] = 601,
  [631] = 601,
  [632] = 595,
  [633] = 594,
  [634] = 447,
  [635] = 614,
  [636] = 593,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 639,
  [644] = 644,
  [645] = 645,
  [646] = 644,
  [647] = 647,
  [648] = 648,
  [649] = 642,
  [650] = 445,
  [651] = 642,
  [652] = 647,
  [653] = 648,
  [654] = 644,
  [655] = 637,
  [656] = 639,
  [657] = 640,
  [658] = 640,
  [659] = 641,
  [660] = 639,
  [661] = 641,
  [662] = 662,
  [663] = 640,
  [664] = 647,
  [665] = 647,
  [666] = 640,
  [667] = 639,
  [668] = 648,
  [669] = 641,
  [670] = 647,
  [671] = 648,
  [672] = 644,
  [673] = 637,
  [674] = 647,
  [675] = 637,
  [676] = 648,
  [677] = 644,
  [678] = 641,
  [679] = 637,
  [680] = 648,
  [681] = 681,
  [682] = 639,
  [683] = 683,
  [684] = 684,
  [685] = 641,
  [686] = 686,
  [687] = 644,
  [688] = 688,
  [689] = 637,
  [690] = 690,
  [691] = 691,
  [692] = 640,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 694,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 696,
  [704] = 704,
  [705] = 705,
  [706] = 701,
  [707] = 707,
  [708] = 704,
  [709] = 696,
  [710] = 697,
  [711] = 711,
  [712] = 695,
  [713] = 713,
  [714] = 700,
  [715] = 697,
  [716] = 699,
  [717] = 700,
  [718] = 718,
  [719] = 719,
  [720] = 694,
  [721] = 701,
  [722] = 718,
  [723] = 723,
  [724] = 705,
  [725] = 705,
  [726] = 694,
  [727] = 699,
  [728] = 728,
  [729] = 695,
  [730] = 694,
  [731] = 701,
  [732] = 728,
  [733] = 723,
  [734] = 728,
  [735] = 704,
  [736] = 713,
  [737] = 696,
  [738] = 696,
  [739] = 704,
  [740] = 700,
  [741] = 699,
  [742] = 718,
  [743] = 695,
  [744] = 718,
  [745] = 745,
  [746] = 707,
  [747] = 697,
  [748] = 700,
  [749] = 699,
  [750] = 750,
  [751] = 701,
  [752] = 728,
  [753] = 694,
  [754] = 705,
  [755] = 697,
  [756] = 728,
  [757] = 705,
  [758] = 718,
  [759] = 697,
  [760] = 760,
  [761] = 695,
  [762] = 699,
  [763] = 695,
  [764] = 723,
  [765] = 705,
  [766] = 701,
  [767] = 696,
  [768] = 704,
  [769] = 704,
  [770] = 713,
  [771] = 728,
  [772] = 700,
  [773] = 718,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 775,
  [782] = 777,
  [783] = 776,
  [784] = 778,
  [785] = 777,
  [786] = 778,
  [787] = 776,
  [788] = 775,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 791,
  [793] = 779,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 780,
  [799] = 796,
  [800] = 797,
  [801] = 801,
  [802] = 796,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 791,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 797,
  [838] = 791,
  [839] = 839,
  [840] = 840,
  [841] = 840,
  [842] = 842,
  [843] = 843,
  [844] = 832,
  [845] = 843,
  [846] = 809,
  [847] = 847,
  [848] = 797,
  [849] = 815,
  [850] = 830,
  [851] = 851,
  [852] = 826,
  [853] = 806,
  [854] = 851,
  [855] = 825,
  [856] = 823,
  [857] = 819,
  [858] = 818,
  [859] = 807,
  [860] = 847,
  [861] = 861,
  [862] = 813,
  [863] = 828,
  [864] = 824,
  [865] = 814,
  [866] = 811,
  [867] = 867,
  [868] = 820,
  [869] = 831,
  [870] = 821,
  [871] = 827,
  [872] = 822,
  [873] = 817,
  [874] = 810,
  [875] = 808,
  [876] = 812,
  [877] = 805,
  [878] = 878,
  [879] = 804,
  [880] = 880,
  [881] = 789,
  [882] = 882,
  [883] = 791,
  [884] = 884,
  [885] = 885,
  [886] = 880,
  [887] = 885,
  [888] = 882,
  [889] = 882,
  [890] = 885,
  [891] = 790,
  [892] = 880,
  [893] = 893,
  [894] = 894,
  [895] = 791,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 797,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 797,
  [913] = 913,
  [914] = 819,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 807,
  [919] = 824,
  [920] = 920,
  [921] = 827,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 832,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 809,
  [932] = 932,
  [933] = 811,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 813,
  [939] = 814,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 818,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 805,
  [956] = 812,
  [957] = 817,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 822,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 828,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 789,
  [987] = 987,
  [988] = 988,
  [989] = 808,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 810,
  [995] = 826,
  [996] = 996,
  [997] = 820,
  [998] = 830,
  [999] = 831,
  [1000] = 825,
  [1001] = 804,
  [1002] = 821,
  [1003] = 1003,
  [1004] = 806,
  [1005] = 964,
  [1006] = 823,
  [1007] = 1007,
  [1008] = 790,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 815,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1017,
  [1023] = 1023,
  [1024] = 1018,
  [1025] = 916,
  [1026] = 1019,
  [1027] = 1023,
  [1028] = 1017,
  [1029] = 1020,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 861,
  [1033] = 861,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 861,
  [1037] = 1023,
  [1038] = 981,
  [1039] = 861,
  [1040] = 1040,
  [1041] = 967,
  [1042] = 1042,
  [1043] = 1030,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 861,
  [1047] = 1020,
  [1048] = 1018,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 893,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1050,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1057,
  [1066] = 893,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 1069,
  [1070] = 954,
  [1071] = 1071,
  [1072] = 1058,
  [1073] = 248,
  [1074] = 893,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1068,
  [1078] = 1078,
  [1079] = 1058,
  [1080] = 1057,
  [1081] = 894,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 894,
  [1085] = 1068,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1089,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 247,
  [1095] = 1057,
  [1096] = 894,
  [1097] = 894,
  [1098] = 1058,
  [1099] = 1057,
  [1100] = 1100,
  [1101] = 894,
  [1102] = 1102,
  [1103] = 1068,
  [1104] = 1057,
  [1105] = 1057,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 924,
  [1109] = 250,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1068,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1068,
  [1119] = 251,
  [1120] = 977,
  [1121] = 1100,
  [1122] = 893,
  [1123] = 893,
  [1124] = 1058,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1068,
  [1128] = 1128,
  [1129] = 1058,
  [1130] = 1113,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1132,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1132,
  [1137] = 1137,
  [1138] = 1135,
  [1139] = 1139,
  [1140] = 1135,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1110,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1102,
  [1154] = 1154,
  [1155] = 1131,
  [1156] = 1156,
  [1157] = 1061,
  [1158] = 1158,
  [1159] = 1134,
  [1160] = 1160,
  [1161] = 1132,
  [1162] = 1064,
  [1163] = 789,
  [1164] = 1093,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1139,
  [1168] = 1168,
  [1169] = 1060,
  [1170] = 1063,
  [1171] = 1067,
  [1172] = 1040,
  [1173] = 1173,
  [1174] = 1152,
  [1175] = 1142,
  [1176] = 1176,
  [1177] = 1143,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1154,
  [1184] = 1151,
  [1185] = 1117,
  [1186] = 1148,
  [1187] = 1187,
  [1188] = 1144,
  [1189] = 1189,
  [1190] = 1056,
  [1191] = 1055,
  [1192] = 1192,
  [1193] = 1134,
  [1194] = 1143,
  [1195] = 1132,
  [1196] = 1150,
  [1197] = 1139,
  [1198] = 1139,
  [1199] = 1132,
  [1200] = 1143,
  [1201] = 1134,
  [1202] = 1178,
  [1203] = 1182,
  [1204] = 1154,
  [1205] = 1144,
  [1206] = 1144,
  [1207] = 1148,
  [1208] = 1146,
  [1209] = 1151,
  [1210] = 1151,
  [1211] = 1211,
  [1212] = 1148,
  [1213] = 1154,
  [1214] = 1148,
  [1215] = 1151,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1146,
  [1219] = 1219,
  [1220] = 1144,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1154,
  [1224] = 1224,
  [1225] = 790,
  [1226] = 1226,
  [1227] = 1154,
  [1228] = 789,
  [1229] = 1151,
  [1230] = 1142,
  [1231] = 1144,
  [1232] = 1134,
  [1233] = 1143,
  [1234] = 1134,
  [1235] = 1235,
  [1236] = 1143,
  [1237] = 1148,
  [1238] = 1238,
  [1239] = 1139,
  [1240] = 1139,
  [1241] = 1150,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1245,
  [1249] = 1245,
  [1250] = 1245,
  [1251] = 1245,
  [1252] = 917,
  [1253] = 1253,
  [1254] = 1242,
  [1255] = 1007,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1246,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1256,
  [1263] = 951,
  [1264] = 1264,
  [1265] = 950,
  [1266] = 1242,
  [1267] = 1267,
  [1268] = 1253,
  [1269] = 1269,
  [1270] = 1253,
  [1271] = 1271,
  [1272] = 1242,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1256,
  [1277] = 1277,
  [1278] = 1253,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1246,
  [1282] = 958,
  [1283] = 1267,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1256,
  [1287] = 1287,
  [1288] = 1246,
  [1289] = 1289,
  [1290] = 1245,
  [1291] = 1246,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1256,
  [1295] = 1258,
  [1296] = 1253,
  [1297] = 1267,
  [1298] = 1242,
  [1299] = 1299,
  [1300] = 1267,
  [1301] = 1267,
  [1302] = 1302,
  [1303] = 1267,
  [1304] = 1304,
  [1305] = 1260,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1260,
  [1309] = 1309,
  [1310] = 1246,
  [1311] = 1311,
  [1312] = 1256,
  [1313] = 1242,
  [1314] = 1314,
  [1315] = 1253,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1317,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1316,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1317,
  [1335] = 1325,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1337,
  [1343] = 1343,
  [1344] = 1316,
  [1345] = 1345,
  [1346] = 1322,
  [1347] = 1337,
  [1348] = 1348,
  [1349] = 1325,
  [1350] = 1326,
  [1351] = 1351,
  [1352] = 1325,
  [1353] = 1326,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1317,
  [1357] = 1343,
  [1358] = 1322,
  [1359] = 1359,
  [1360] = 1322,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1361,
  [1365] = 1325,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1326,
  [1370] = 1325,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1361,
  [1374] = 1322,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1317,
  [1378] = 1320,
  [1379] = 1343,
  [1380] = 1380,
  [1381] = 1372,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1359,
  [1385] = 1359,
  [1386] = 1337,
  [1387] = 1322,
  [1388] = 1317,
  [1389] = 1316,
  [1390] = 1337,
  [1391] = 1316,
  [1392] = 1316,
  [1393] = 1323,
  [1394] = 1376,
  [1395] = 1337,
  [1396] = 1376,
  [1397] = 1326,
  [1398] = 1376,
  [1399] = 1325,
  [1400] = 1376,
  [1401] = 1326,
  [1402] = 1376,
  [1403] = 1372,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e},
  {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167},
  {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f},
  {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a},
  {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5},
  {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788},
  {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b},
  {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39},
  {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54},
  {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a},
  {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9},
  {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115},
  {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e},
  {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f},
  {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6},
  {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a},
  {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x1123e}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0},
  {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59},
  {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4},
  {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae},
  {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b},
  {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static TSCharacterRange sym_rune_literal_character_set_1[] = {
  {'"', '"'}, {'\'', '\''}, {'0', '7'}, {'U', 'U'}, {'\\', '\\'}, {'a', 'b'}, {'f', 'f'}, {'n', 'n'},
  {'r', 'r'}, {'t', 'v'}, {'x', 'x'},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        0, 63,
        '!', 107,
        '"', 138,
        '%', 116,
        '&', 111,
        '\'', 22,
        '(', 67,
        ')', 68,
        '*', 76,
        '+', 101,
        ',', 69,
        '-', 104,
        '.', 66,
        '/', 114,
        '0', 147,
        ':', 99,
        ';', 62,
        '<', 125,
        '=', 71,
        '>', 130,
        '[', 72,
        '\\', 20,
        ']', 73,
        '^', 109,
        '`', 26,
        '{', 78,
        '|', 81,
        '}', 79,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(149);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        0, 63,
        '\n', 61,
        '!', 17,
        '%', 115,
        '&', 112,
        '(', 67,
        '*', 75,
        '+', 100,
        ',', 69,
        '-', 103,
        '.', 64,
        '/', 113,
        ';', 62,
        '<', 128,
        '=', 19,
        '>', 131,
        '[', 72,
        '^', 108,
        '{', 78,
        '|', 82,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(16);
      if (lookahead == '"') ADVANCE(138);
      if (lookahead == '/') ADVANCE(139);
      if (lookahead == '\\') ADVANCE(20);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(142);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 17,
        '"', 137,
        '%', 115,
        '&', 112,
        '(', 67,
        ')', 68,
        '*', 75,
        '+', 100,
        ',', 69,
        '-', 103,
        '.', 65,
        '/', 113,
        ':', 99,
        '<', 126,
        '=', 71,
        '>', 131,
        '[', 72,
        ']', 73,
        '^', 108,
        '`', 26,
        '{', 78,
        '|', 82,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 17,
        '%', 116,
        '&', 111,
        '(', 67,
        '*', 76,
        '+', 101,
        ',', 69,
        '-', 104,
        '.', 64,
        '/', 114,
        ':', 18,
        ';', 62,
        '<', 125,
        '=', 71,
        '>', 130,
        '[', 72,
        '^', 109,
        '{', 78,
        '|', 81,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 17,
        '%', 116,
        '&', 111,
        '(', 67,
        '*', 76,
        '+', 102,
        ',', 69,
        '-', 105,
        '.', 64,
        '/', 114,
        ':', 18,
        '<', 127,
        '=', 71,
        '>', 130,
        '[', 72,
        '^', 109,
        '{', 78,
        '|', 81,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 17,
        '%', 115,
        '&', 112,
        '(', 67,
        ')', 68,
        '*', 75,
        '+', 100,
        ',', 69,
        '-', 103,
        '.', 65,
        '/', 113,
        ':', 99,
        ';', 62,
        '<', 128,
        '=', 71,
        '>', 131,
        '[', 72,
        ']', 73,
        '^', 108,
        '{', 78,
        '|', 82,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      END_STATE();
    case 7:
      if (lookahead == '\'') ADVANCE(157);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(159);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(9);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == '*') ADVANCE(9);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '-') ADVANCE(83);
      END_STATE();
    case 12:
      if (lookahead == '.') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 13:
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(74);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '_') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 16:
      if (lookahead == '/') ADVANCE(8);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 20:
      if (lookahead == 'U') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(46);
      if (lookahead == 'x') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 21:
      if (lookahead == 'U') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(33);
      if (set_contains(sym_rune_literal_character_set_1, 11, lookahead)) ADVANCE(7);
      END_STATE();
    case 22:
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(7);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(151);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '_') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(152);
      END_STATE();
    case 26:
      if (lookahead == '`') ADVANCE(136);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(154);
      END_STATE();
    case 28:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(151);
      END_STATE();
    case 30:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(7);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(152);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(31);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(149);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(13);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(154);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(7);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        0, 63,
        '\n', 61,
        '!', 106,
        '"', 137,
        '&', 110,
        '\'', 22,
        '(', 67,
        ')', 68,
        '*', 75,
        '+', 100,
        ',', 69,
        '-', 103,
        '.', 35,
        '/', 8,
        '0', 147,
        ';', 62,
        '<', 11,
        '=', 70,
        '[', 72,
        '^', 108,
        '`', 26,
        '{', 78,
        '|', 80,
        '}', 79,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(149);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 57:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        0, 63,
        '\n', 61,
        '!', 17,
        '"', 137,
        '%', 116,
        '&', 111,
        '(', 67,
        ')', 68,
        '*', 76,
        '+', 101,
        ',', 69,
        '-', 104,
        '.', 64,
        '/', 114,
        ':', 99,
        ';', 62,
        '<', 125,
        '=', 71,
        '>', 130,
        '[', 72,
        '^', 109,
        '`', 26,
        '{', 78,
        '|', 81,
        '}', 79,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 58:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        0, 63,
        '!', 107,
        '"', 137,
        '%', 116,
        '&', 111,
        '\'', 22,
        '(', 67,
        ')', 68,
        '*', 76,
        '+', 101,
        ',', 69,
        '-', 104,
        '.', 66,
        '/', 114,
        '0', 147,
        ':', 99,
        ';', 62,
        '<', 125,
        '=', 71,
        '>', 130,
        '[', 72,
        ']', 73,
        '^', 109,
        '`', 26,
        '{', 78,
        '|', 81,
        '}', 79,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(58);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(149);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      ADVANCE_MAP(
        '!', 106,
        '"', 137,
        '&', 110,
        '\'', 22,
        '(', 67,
        ')', 68,
        '*', 75,
        '+', 100,
        ',', 69,
        '-', 103,
        '.', 12,
        '/', 8,
        '0', 147,
        ':', 98,
        ';', 62,
        '<', 11,
        '[', 72,
        ']', 73,
        '^', 108,
        '`', 26,
        '{', 78,
        '}', 79,
        '~', 77,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(149);
      if (set_contains(sym_identifier_character_set_1, 656, lookahead)) ADVANCE(135);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(14);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(96);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '^') ADVANCE(122);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '^') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(159);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(10);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(89);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 763, lookahead)) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(141);
      if (lookahead == '/') ADVANCE(143);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '/') ADVANCE(143);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '/') ADVANCE(139);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(142);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_int_literal);
      ADVANCE_MAP(
        '.', 155,
        '_', 30,
        'i', 156,
        'B', 23,
        'b', 23,
        'E', 27,
        'e', 27,
        'O', 25,
        'o', 25,
        'X', 15,
        'x', 15,
        '8', 13,
        '9', 13,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '_') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'i') ADVANCE(156);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_imaginary_literal);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(159);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'i', 8,
        'm', 9,
        'n', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'v', 15,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(17);
      if (lookahead == 'h') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(46);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'k') ADVANCE(55);
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(59);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(63);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 40:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 41:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(68);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 59:
      if (lookahead == 'k') ADVANCE(84);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 68:
      if (lookahead == 'k') ADVANCE(92);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 73:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_iota);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_make);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(104);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 89:
      if (lookahead == 'c') ADVANCE(106);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(109);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 100:
      if (lookahead == 'f') ADVANCE(111);
      END_STATE();
    case 101:
      if (lookahead == 'g') ADVANCE(112);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(116);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(117);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 119:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 120:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(125);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 125:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 59},
  [2] = {.lex_state = 59},
  [3] = {.lex_state = 59},
  [4] = {.lex_state = 59},
  [5] = {.lex_state = 59},
  [6] = {.lex_state = 59},
  [7] = {.lex_state = 59},
  [8] = {.lex_state = 59},
  [9] = {.lex_state = 59},
  [10] = {.lex_state = 59},
  [11] = {.lex_state = 59},
  [12] = {.lex_state = 59},
  [13] = {.lex_state = 59},
  [14] = {.lex_state = 59},
  [15] = {.lex_state = 59},
  [16] = {.lex_state = 59},
  [17] = {.lex_state = 59},
  [18] = {.lex_state = 59},
  [19] = {.lex_state = 59},
  [20] = {.lex_state = 59},
  [21] = {.lex_state = 59},
  [22] = {.lex_state = 59},
  [23] = {.lex_state = 59},
  [24] = {.lex_state = 59},
  [25] = {.lex_state = 59},
  [26] = {.lex_state = 59},
  [27] = {.lex_state = 59},
  [28] = {.lex_state = 56},
  [29] = {.lex_state = 59},
  [30] = {.lex_state = 59},
  [31] = {.lex_state = 59},
  [32] = {.lex_state = 59},
  [33] = {.lex_state = 59},
  [34] = {.lex_state = 59},
  [35] = {.lex_state = 59},
  [36] = {.lex_state = 59},
  [37] = {.lex_state = 59},
  [38] = {.lex_state = 59},
  [39] = {.lex_state = 59},
  [40] = {.lex_state = 59},
  [41] = {.lex_state = 59},
  [42] = {.lex_state = 59},
  [43] = {.lex_state = 59},
  [44] = {.lex_state = 59},
  [45] = {.lex_state = 59},
  [46] = {.lex_state = 59},
  [47] = {.lex_state = 59},
  [48] = {.lex_state = 59},
  [49] = {.lex_state = 59},
  [50] = {.lex_state = 59},
  [51] = {.lex_state = 59},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 59},
  [54] = {.lex_state = 59},
  [55] = {.lex_state = 59},
  [56] = {.lex_state = 59},
  [57] = {.lex_state = 59},
  [58] = {.lex_state = 59},
  [59] = {.lex_state = 59},
  [60] = {.lex_state = 59},
  [61] = {.lex_state = 59},
  [62] = {.lex_state = 59},
  [63] = {.lex_state = 59},
  [64] = {.lex_state = 59},
  [65] = {.lex_state = 59},
  [66] = {.lex_state = 59},
  [67] = {.lex_state = 59},
  [68] = {.lex_state = 59},
  [69] = {.lex_state = 59},
  [70] = {.lex_state = 59},
  [71] = {.lex_state = 59},
  [72] = {.lex_state = 59},
  [73] = {.lex_state = 59},
  [74] = {.lex_state = 59},
  [75] = {.lex_state = 59},
  [76] = {.lex_state = 59},
  [77] = {.lex_state = 59},
  [78] = {.lex_state = 59},
  [79] = {.lex_state = 59},
  [80] = {.lex_state = 59},
  [81] = {.lex_state = 59},
  [82] = {.lex_state = 59},
  [83] = {.lex_state = 59},
  [84] = {.lex_state = 59},
  [85] = {.lex_state = 59},
  [86] = {.lex_state = 59},
  [87] = {.lex_state = 59},
  [88] = {.lex_state = 59},
  [89] = {.lex_state = 59},
  [90] = {.lex_state = 59},
  [91] = {.lex_state = 59},
  [92] = {.lex_state = 59},
  [93] = {.lex_state = 59},
  [94] = {.lex_state = 59},
  [95] = {.lex_state = 59},
  [96] = {.lex_state = 59},
  [97] = {.lex_state = 59},
  [98] = {.lex_state = 59},
  [99] = {.lex_state = 59},
  [100] = {.lex_state = 59},
  [101] = {.lex_state = 59},
  [102] = {.lex_state = 59},
  [103] = {.lex_state = 59},
  [104] = {.lex_state = 59},
  [105] = {.lex_state = 59},
  [106] = {.lex_state = 59},
  [107] = {.lex_state = 59},
  [108] = {.lex_state = 59},
  [109] = {.lex_state = 59},
  [110] = {.lex_state = 59},
  [111] = {.lex_state = 59},
  [112] = {.lex_state = 59},
  [113] = {.lex_state = 59},
  [114] = {.lex_state = 59},
  [115] = {.lex_state = 59},
  [116] = {.lex_state = 59},
  [117] = {.lex_state = 59},
  [118] = {.lex_state = 59},
  [119] = {.lex_state = 59},
  [120] = {.lex_state = 59},
  [121] = {.lex_state = 59},
  [122] = {.lex_state = 59},
  [123] = {.lex_state = 59},
  [124] = {.lex_state = 59},
  [125] = {.lex_state = 59},
  [126] = {.lex_state = 59},
  [127] = {.lex_state = 59},
  [128] = {.lex_state = 59},
  [129] = {.lex_state = 59},
  [130] = {.lex_state = 59},
  [131] = {.lex_state = 59},
  [132] = {.lex_state = 59},
  [133] = {.lex_state = 59},
  [134] = {.lex_state = 59},
  [135] = {.lex_state = 59},
  [136] = {.lex_state = 59},
  [137] = {.lex_state = 59},
  [138] = {.lex_state = 59},
  [139] = {.lex_state = 59},
  [140] = {.lex_state = 59},
  [141] = {.lex_state = 59},
  [142] = {.lex_state = 59},
  [143] = {.lex_state = 59},
  [144] = {.lex_state = 59},
  [145] = {.lex_state = 59},
  [146] = {.lex_state = 59},
  [147] = {.lex_state = 59},
  [148] = {.lex_state = 59},
  [149] = {.lex_state = 59},
  [150] = {.lex_state = 59},
  [151] = {.lex_state = 59},
  [152] = {.lex_state = 59},
  [153] = {.lex_state = 59},
  [154] = {.lex_state = 59},
  [155] = {.lex_state = 59},
  [156] = {.lex_state = 59},
  [157] = {.lex_state = 59},
  [158] = {.lex_state = 59},
  [159] = {.lex_state = 59},
  [160] = {.lex_state = 59},
  [161] = {.lex_state = 59},
  [162] = {.lex_state = 59},
  [163] = {.lex_state = 59},
  [164] = {.lex_state = 59},
  [165] = {.lex_state = 59},
  [166] = {.lex_state = 59},
  [167] = {.lex_state = 59},
  [168] = {.lex_state = 59},
  [169] = {.lex_state = 59},
  [170] = {.lex_state = 59},
  [171] = {.lex_state = 59},
  [172] = {.lex_state = 59},
  [173] = {.lex_state = 59},
  [174] = {.lex_state = 59},
  [175] = {.lex_state = 59},
  [176] = {.lex_state = 59},
  [177] = {.lex_state = 59},
  [178] = {.lex_state = 59},
  [179] = {.lex_state = 59},
  [180] = {.lex_state = 59},
  [181] = {.lex_state = 59},
  [182] = {.lex_state = 59},
  [183] = {.lex_state = 59},
  [184] = {.lex_state = 59},
  [185] = {.lex_state = 59},
  [186] = {.lex_state = 59},
  [187] = {.lex_state = 59},
  [188] = {.lex_state = 59},
  [189] = {.lex_state = 59},
  [190] = {.lex_state = 59},
  [191] = {.lex_state = 59},
  [192] = {.lex_state = 59},
  [193] = {.lex_state = 59},
  [194] = {.lex_state = 59},
  [195] = {.lex_state = 59},
  [196] = {.lex_state = 59},
  [197] = {.lex_state = 59},
  [198] = {.lex_state = 59},
  [199] = {.lex_state = 59},
  [200] = {.lex_state = 59},
  [201] = {.lex_state = 59},
  [202] = {.lex_state = 59},
  [203] = {.lex_state = 59},
  [204] = {.lex_state = 59},
  [205] = {.lex_state = 59},
  [206] = {.lex_state = 59},
  [207] = {.lex_state = 59},
  [208] = {.lex_state = 59},
  [209] = {.lex_state = 59},
  [210] = {.lex_state = 59},
  [211] = {.lex_state = 59},
  [212] = {.lex_state = 59},
  [213] = {.lex_state = 59},
  [214] = {.lex_state = 59},
  [215] = {.lex_state = 59},
  [216] = {.lex_state = 59},
  [217] = {.lex_state = 59},
  [218] = {.lex_state = 59},
  [219] = {.lex_state = 59},
  [220] = {.lex_state = 59},
  [221] = {.lex_state = 59},
  [222] = {.lex_state = 59},
  [223] = {.lex_state = 59},
  [224] = {.lex_state = 59},
  [225] = {.lex_state = 59},
  [226] = {.lex_state = 59},
  [227] = {.lex_state = 59},
  [228] = {.lex_state = 59},
  [229] = {.lex_state = 59},
  [230] = {.lex_state = 59},
  [231] = {.lex_state = 59},
  [232] = {.lex_state = 59},
  [233] = {.lex_state = 59},
  [234] = {.lex_state = 59},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 57},
  [237] = {.lex_state = 57},
  [238] = {.lex_state = 57},
  [239] = {.lex_state = 57},
  [240] = {.lex_state = 57},
  [241] = {.lex_state = 59},
  [242] = {.lex_state = 57},
  [243] = {.lex_state = 57},
  [244] = {.lex_state = 57},
  [245] = {.lex_state = 57},
  [246] = {.lex_state = 57},
  [247] = {.lex_state = 57},
  [248] = {.lex_state = 57},
  [249] = {.lex_state = 57},
  [250] = {.lex_state = 57},
  [251] = {.lex_state = 57},
  [252] = {.lex_state = 57},
  [253] = {.lex_state = 57},
  [254] = {.lex_state = 57},
  [255] = {.lex_state = 57},
  [256] = {.lex_state = 57},
  [257] = {.lex_state = 57},
  [258] = {.lex_state = 57},
  [259] = {.lex_state = 57},
  [260] = {.lex_state = 57},
  [261] = {.lex_state = 57},
  [262] = {.lex_state = 57},
  [263] = {.lex_state = 57},
  [264] = {.lex_state = 57},
  [265] = {.lex_state = 57},
  [266] = {.lex_state = 57},
  [267] = {.lex_state = 57},
  [268] = {.lex_state = 57},
  [269] = {.lex_state = 57},
  [270] = {.lex_state = 57},
  [271] = {.lex_state = 57},
  [272] = {.lex_state = 57},
  [273] = {.lex_state = 57},
  [274] = {.lex_state = 4},
  [275] = {.lex_state = 57},
  [276] = {.lex_state = 57},
  [277] = {.lex_state = 4},
  [278] = {.lex_state = 57},
  [279] = {.lex_state = 57},
  [280] = {.lex_state = 57},
  [281] = {.lex_state = 57},
  [282] = {.lex_state = 57},
  [283] = {.lex_state = 57},
  [284] = {.lex_state = 57},
  [285] = {.lex_state = 57},
  [286] = {.lex_state = 57},
  [287] = {.lex_state = 57},
  [288] = {.lex_state = 4},
  [289] = {.lex_state = 4},
  [290] = {.lex_state = 4},
  [291] = {.lex_state = 4},
  [292] = {.lex_state = 4},
  [293] = {.lex_state = 4},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 4},
  [296] = {.lex_state = 4},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 4},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 4},
  [302] = {.lex_state = 4},
  [303] = {.lex_state = 4},
  [304] = {.lex_state = 4},
  [305] = {.lex_state = 4},
  [306] = {.lex_state = 4},
  [307] = {.lex_state = 4},
  [308] = {.lex_state = 4},
  [309] = {.lex_state = 4},
  [310] = {.lex_state = 4},
  [311] = {.lex_state = 4},
  [312] = {.lex_state = 4},
  [313] = {.lex_state = 4},
  [314] = {.lex_state = 4},
  [315] = {.lex_state = 4},
  [316] = {.lex_state = 4},
  [317] = {.lex_state = 4},
  [318] = {.lex_state = 4},
  [319] = {.lex_state = 4},
  [320] = {.lex_state = 4},
  [321] = {.lex_state = 4},
  [322] = {.lex_state = 4},
  [323] = {.lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 4},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 4},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 4},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 4},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 5},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 5},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 5},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 5},
  [344] = {.lex_state = 5},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 5},
  [347] = {.lex_state = 5},
  [348] = {.lex_state = 5},
  [349] = {.lex_state = 5},
  [350] = {.lex_state = 5},
  [351] = {.lex_state = 5},
  [352] = {.lex_state = 5},
  [353] = {.lex_state = 5},
  [354] = {.lex_state = 5},
  [355] = {.lex_state = 5},
  [356] = {.lex_state = 5},
  [357] = {.lex_state = 5},
  [358] = {.lex_state = 5},
  [359] = {.lex_state = 5},
  [360] = {.lex_state = 5},
  [361] = {.lex_state = 5},
  [362] = {.lex_state = 5},
  [363] = {.lex_state = 5},
  [364] = {.lex_state = 5},
  [365] = {.lex_state = 5},
  [366] = {.lex_state = 5},
  [367] = {.lex_state = 5},
  [368] = {.lex_state = 5},
  [369] = {.lex_state = 5},
  [370] = {.lex_state = 5},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 5},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 5},
  [375] = {.lex_state = 5},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 5},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 56},
  [384] = {.lex_state = 56},
  [385] = {.lex_state = 57},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 56},
  [391] = {.lex_state = 56},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 1},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 1},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 1},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 1},
  [439] = {.lex_state = 1},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 1},
  [442] = {.lex_state = 1},
  [443] = {.lex_state = 1},
  [444] = {.lex_state = 1},
  [445] = {.lex_state = 1},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 56},
  [449] = {.lex_state = 56},
  [450] = {.lex_state = 1},
  [451] = {.lex_state = 3},
  [452] = {.lex_state = 56},
  [453] = {.lex_state = 1},
  [454] = {.lex_state = 3},
  [455] = {.lex_state = 1},
  [456] = {.lex_state = 1},
  [457] = {.lex_state = 1},
  [458] = {.lex_state = 1},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 1},
  [461] = {.lex_state = 1},
  [462] = {.lex_state = 1},
  [463] = {.lex_state = 1},
  [464] = {.lex_state = 1},
  [465] = {.lex_state = 3},
  [466] = {.lex_state = 1},
  [467] = {.lex_state = 1},
  [468] = {.lex_state = 1},
  [469] = {.lex_state = 3},
  [470] = {.lex_state = 1},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 1},
  [473] = {.lex_state = 1},
  [474] = {.lex_state = 1},
  [475] = {.lex_state = 1},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 3},
  [478] = {.lex_state = 1},
  [479] = {.lex_state = 1},
  [480] = {.lex_state = 56},
  [481] = {.lex_state = 1},
  [482] = {.lex_state = 1},
  [483] = {.lex_state = 1},
  [484] = {.lex_state = 1},
  [485] = {.lex_state = 1},
  [486] = {.lex_state = 1},
  [487] = {.lex_state = 1},
  [488] = {.lex_state = 1},
  [489] = {.lex_state = 1},
  [490] = {.lex_state = 1},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 56},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 3},
  [495] = {.lex_state = 56},
  [496] = {.lex_state = 56},
  [497] = {.lex_state = 1},
  [498] = {.lex_state = 1},
  [499] = {.lex_state = 56},
  [500] = {.lex_state = 1},
  [501] = {.lex_state = 1},
  [502] = {.lex_state = 1},
  [503] = {.lex_state = 1},
  [504] = {.lex_state = 1},
  [505] = {.lex_state = 1},
  [506] = {.lex_state = 1},
  [507] = {.lex_state = 1},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 0},
  [511] = {.lex_state = 56},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 6},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 6},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 6},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 3},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 6},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 6},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 3},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 6},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 6},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 3},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 3},
  [561] = {.lex_state = 3},
  [562] = {.lex_state = 3},
  [563] = {.lex_state = 3},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 3},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 6},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 6},
  [571] = {.lex_state = 3},
  [572] = {.lex_state = 6},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 6},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 3},
  [577] = {.lex_state = 6},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 3},
  [581] = {.lex_state = 6},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 3},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 3},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 6},
  [591] = {.lex_state = 3},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 6},
  [594] = {.lex_state = 6},
  [595] = {.lex_state = 6},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 6},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 6},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 6},
  [606] = {.lex_state = 6},
  [607] = {.lex_state = 6},
  [608] = {.lex_state = 6},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 6},
  [611] = {.lex_state = 6},
  [612] = {.lex_state = 6},
  [613] = {.lex_state = 6},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 6},
  [616] = {.lex_state = 6},
  [617] = {.lex_state = 6},
  [618] = {.lex_state = 6},
  [619] = {.lex_state = 6},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 6},
  [622] = {.lex_state = 6},
  [623] = {.lex_state = 6},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 6},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 6},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 6},
  [633] = {.lex_state = 6},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 6},
  [637] = {.lex_state = 6},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 6},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 6},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 6},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 6},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 6},
  [657] = {.lex_state = 6},
  [658] = {.lex_state = 6},
  [659] = {.lex_state = 6},
  [660] = {.lex_state = 6},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 6},
  [663] = {.lex_state = 6},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 6},
  [667] = {.lex_state = 6},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 6},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 6},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 6},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 6},
  [679] = {.lex_state = 6},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 6},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 6},
  [686] = {.lex_state = 6},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 6},
  [689] = {.lex_state = 6},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 6},
  [692] = {.lex_state = 6},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 6},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 56},
  [776] = {.lex_state = 56},
  [777] = {.lex_state = 56},
  [778] = {.lex_state = 56},
  [779] = {.lex_state = 56},
  [780] = {.lex_state = 56},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 56},
  [786] = {.lex_state = 56},
  [787] = {.lex_state = 56},
  [788] = {.lex_state = 56},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 57},
  [792] = {.lex_state = 57},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 56},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 56},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 56},
  [805] = {.lex_state = 56},
  [806] = {.lex_state = 56},
  [807] = {.lex_state = 56},
  [808] = {.lex_state = 56},
  [809] = {.lex_state = 56},
  [810] = {.lex_state = 56},
  [811] = {.lex_state = 56},
  [812] = {.lex_state = 56},
  [813] = {.lex_state = 56},
  [814] = {.lex_state = 56},
  [815] = {.lex_state = 56},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 56},
  [818] = {.lex_state = 56},
  [819] = {.lex_state = 56},
  [820] = {.lex_state = 56},
  [821] = {.lex_state = 56},
  [822] = {.lex_state = 56},
  [823] = {.lex_state = 56},
  [824] = {.lex_state = 56},
  [825] = {.lex_state = 56},
  [826] = {.lex_state = 56},
  [827] = {.lex_state = 56},
  [828] = {.lex_state = 56},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 56},
  [831] = {.lex_state = 56},
  [832] = {.lex_state = 56},
  [833] = {.lex_state = 3},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 3},
  [839] = {.lex_state = 57},
  [840] = {.lex_state = 3},
  [841] = {.lex_state = 3},
  [842] = {.lex_state = 57},
  [843] = {.lex_state = 3},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 3},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 3},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 3},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 3},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 3},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 56},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 56},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 56},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 57},
  [884] = {.lex_state = 3},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 56},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 57},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 56},
  [898] = {.lex_state = 56},
  [899] = {.lex_state = 56},
  [900] = {.lex_state = 56},
  [901] = {.lex_state = 56},
  [902] = {.lex_state = 56},
  [903] = {.lex_state = 56},
  [904] = {.lex_state = 56},
  [905] = {.lex_state = 56},
  [906] = {.lex_state = 56},
  [907] = {.lex_state = 56},
  [908] = {.lex_state = 56},
  [909] = {.lex_state = 56},
  [910] = {.lex_state = 56},
  [911] = {.lex_state = 56},
  [912] = {.lex_state = 56},
  [913] = {.lex_state = 56},
  [914] = {.lex_state = 56},
  [915] = {.lex_state = 56},
  [916] = {.lex_state = 56},
  [917] = {.lex_state = 56},
  [918] = {.lex_state = 56},
  [919] = {.lex_state = 56},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 56},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 56},
  [925] = {.lex_state = 56},
  [926] = {.lex_state = 56},
  [927] = {.lex_state = 56},
  [928] = {.lex_state = 56},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 56},
  [931] = {.lex_state = 56},
  [932] = {.lex_state = 56},
  [933] = {.lex_state = 56},
  [934] = {.lex_state = 56},
  [935] = {.lex_state = 56},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 56},
  [938] = {.lex_state = 56},
  [939] = {.lex_state = 56},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 56},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 56},
  [944] = {.lex_state = 56},
  [945] = {.lex_state = 56},
  [946] = {.lex_state = 56},
  [947] = {.lex_state = 56},
  [948] = {.lex_state = 56},
  [949] = {.lex_state = 56},
  [950] = {.lex_state = 56},
  [951] = {.lex_state = 56},
  [952] = {.lex_state = 56},
  [953] = {.lex_state = 56},
  [954] = {.lex_state = 56},
  [955] = {.lex_state = 56},
  [956] = {.lex_state = 56},
  [957] = {.lex_state = 56},
  [958] = {.lex_state = 56},
  [959] = {.lex_state = 56},
  [960] = {.lex_state = 56},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 56},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 56},
  [968] = {.lex_state = 56},
  [969] = {.lex_state = 56},
  [970] = {.lex_state = 56},
  [971] = {.lex_state = 56},
  [972] = {.lex_state = 56},
  [973] = {.lex_state = 56},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 56},
  [976] = {.lex_state = 56},
  [977] = {.lex_state = 56},
  [978] = {.lex_state = 56},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 56},
  [981] = {.lex_state = 56},
  [982] = {.lex_state = 56},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 56},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 56},
  [988] = {.lex_state = 56},
  [989] = {.lex_state = 56},
  [990] = {.lex_state = 56},
  [991] = {.lex_state = 56},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 56},
  [994] = {.lex_state = 56},
  [995] = {.lex_state = 56},
  [996] = {.lex_state = 56},
  [997] = {.lex_state = 56},
  [998] = {.lex_state = 56},
  [999] = {.lex_state = 56},
  [1000] = {.lex_state = 56},
  [1001] = {.lex_state = 56},
  [1002] = {.lex_state = 56},
  [1003] = {.lex_state = 56},
  [1004] = {.lex_state = 56},
  [1005] = {.lex_state = 3},
  [1006] = {.lex_state = 56},
  [1007] = {.lex_state = 56},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 56},
  [1011] = {.lex_state = 56},
  [1012] = {.lex_state = 56},
  [1013] = {.lex_state = 56},
  [1014] = {.lex_state = 56},
  [1015] = {.lex_state = 56},
  [1016] = {.lex_state = 56},
  [1017] = {.lex_state = 56},
  [1018] = {.lex_state = 56},
  [1019] = {.lex_state = 56},
  [1020] = {.lex_state = 56},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 56},
  [1023] = {.lex_state = 56},
  [1024] = {.lex_state = 56},
  [1025] = {.lex_state = 56},
  [1026] = {.lex_state = 56},
  [1027] = {.lex_state = 56},
  [1028] = {.lex_state = 56},
  [1029] = {.lex_state = 56},
  [1030] = {.lex_state = 56},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 56},
  [1035] = {.lex_state = 56},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 56},
  [1038] = {.lex_state = 56},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 56},
  [1041] = {.lex_state = 56},
  [1042] = {.lex_state = 56},
  [1043] = {.lex_state = 56},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 56},
  [1048] = {.lex_state = 56},
  [1049] = {.lex_state = 56},
  [1050] = {.lex_state = 56},
  [1051] = {.lex_state = 56},
  [1052] = {.lex_state = 56},
  [1053] = {.lex_state = 56},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 56},
  [1056] = {.lex_state = 56},
  [1057] = {.lex_state = 2},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 56},
  [1061] = {.lex_state = 56},
  [1062] = {.lex_state = 56},
  [1063] = {.lex_state = 56},
  [1064] = {.lex_state = 56},
  [1065] = {.lex_state = 2},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 56},
  [1068] = {.lex_state = 2},
  [1069] = {.lex_state = 56},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 56},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 56},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 56},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 2},
  [1078] = {.lex_state = 56},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 2},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 2},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 2},
  [1086] = {.lex_state = 56},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 56},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 56},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 56},
  [1093] = {.lex_state = 56},
  [1094] = {.lex_state = 56},
  [1095] = {.lex_state = 2},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 2},
  [1100] = {.lex_state = 56},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 56},
  [1103] = {.lex_state = 2},
  [1104] = {.lex_state = 2},
  [1105] = {.lex_state = 2},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 56},
  [1110] = {.lex_state = 56},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 56},
  [1114] = {.lex_state = 2},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 56},
  [1117] = {.lex_state = 56},
  [1118] = {.lex_state = 2},
  [1119] = {.lex_state = 56},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 56},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 56},
  [1126] = {.lex_state = 56},
  [1127] = {.lex_state = 2},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 56},
  [1131] = {.lex_state = 56},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 56},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 56},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 56},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 56},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 56},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 56},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 56},
  [1170] = {.lex_state = 56},
  [1171] = {.lex_state = 56},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 56},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 59},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 56},
  [1182] = {.lex_state = 59},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 56},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 56},
  [1190] = {.lex_state = 56},
  [1191] = {.lex_state = 56},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 59},
  [1203] = {.lex_state = 59},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 56},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 59},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 0},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 0},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_make] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_imaginary_literal] = ACTIONS(1),
    [sym_rune_literal] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_iota] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1363),
    [sym_package_clause] = STATE(1086),
    [sym_import_declaration] = STATE(1086),
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_function_declaration] = STATE(1086),
    [sym_method_declaration] = STATE(1086),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(1176),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_package_clause] = STATE(1176),
    [sym_import_declaration] = STATE(1176),
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_function_declaration] = STATE(1176),
    [sym_method_declaration] = STATE(1176),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(1176),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(75),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(80),
    [anon_sym_package] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(89),
    [anon_sym_const] = ACTIONS(92),
    [anon_sym_var] = ACTIONS(95),
    [anon_sym_func] = ACTIONS(98),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_type] = ACTIONS(104),
    [anon_sym_STAR] = ACTIONS(107),
    [anon_sym_struct] = ACTIONS(110),
    [anon_sym_TILDE] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_interface] = ACTIONS(119),
    [anon_sym_map] = ACTIONS(122),
    [anon_sym_chan] = ACTIONS(125),
    [anon_sym_LT_DASH] = ACTIONS(128),
    [anon_sym_fallthrough] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(134),
    [anon_sym_continue] = ACTIONS(137),
    [anon_sym_goto] = ACTIONS(140),
    [anon_sym_return] = ACTIONS(143),
    [anon_sym_go] = ACTIONS(146),
    [anon_sym_defer] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(152),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(158),
    [anon_sym_select] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(164),
    [anon_sym_make] = ACTIONS(164),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_BANG] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_AMP] = ACTIONS(167),
    [sym_raw_string_literal] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [sym_int_literal] = ACTIONS(176),
    [sym_float_literal] = ACTIONS(176),
    [sym_imaginary_literal] = ACTIONS(170),
    [sym_rune_literal] = ACTIONS(170),
    [sym_nil] = ACTIONS(176),
    [sym_true] = ACTIONS(176),
    [sym_false] = ACTIONS(176),
    [sym_iota] = ACTIONS(176),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_package_clause] = STATE(1116),
    [sym_import_declaration] = STATE(1116),
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_function_declaration] = STATE(1116),
    [sym_method_declaration] = STATE(1116),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(1176),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(179),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1211),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1211),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(187),
    [anon_sym_default] = ACTIONS(187),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1180),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1180),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_default] = ACTIONS(191),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1173),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1173),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(195),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1179),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1179),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(199),
    [anon_sym_default] = ACTIONS(199),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1238),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1238),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(203),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(959),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1192),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(205),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(959),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1156),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(209),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(211),
    [anon_sym_default] = ACTIONS(211),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1365),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1365),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1399),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1399),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1370),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1370),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(217),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(953),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(219),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(221),
    [anon_sym_default] = ACTIONS(221),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1325),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1325),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1349),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1349),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(225),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1335),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1335),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement_list] = STATE(1352),
    [sym__statement] = STATE(898),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_empty_labeled_statement] = STATE(1352),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_RBRACE] = ACTIONS(229),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(953),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__declaration] = STATE(948),
    [sym_const_declaration] = STATE(948),
    [sym_var_declaration] = STATE(948),
    [sym_type_declaration] = STATE(948),
    [sym_expression_list] = STATE(796),
    [sym_parenthesized_type] = STATE(1290),
    [sym__simple_type] = STATE(1290),
    [sym_generic_type] = STATE(1084),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1084),
    [sym_implicit_length_array_type] = STATE(1303),
    [sym_slice_type] = STATE(1084),
    [sym_struct_type] = STATE(1084),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1084),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(948),
    [sym__statement] = STATE(959),
    [sym_empty_statement] = STATE(948),
    [sym__simple_statement] = STATE(948),
    [sym_expression_statement] = STATE(958),
    [sym_send_statement] = STATE(958),
    [sym_inc_statement] = STATE(958),
    [sym_dec_statement] = STATE(958),
    [sym_assignment_statement] = STATE(958),
    [sym_short_var_declaration] = STATE(958),
    [sym_labeled_statement] = STATE(948),
    [sym_fallthrough_statement] = STATE(948),
    [sym_break_statement] = STATE(948),
    [sym_continue_statement] = STATE(948),
    [sym_goto_statement] = STATE(948),
    [sym_return_statement] = STATE(948),
    [sym_go_statement] = STATE(948),
    [sym_defer_statement] = STATE(948),
    [sym_if_statement] = STATE(948),
    [sym_for_statement] = STATE(948),
    [sym_expression_switch_statement] = STATE(948),
    [sym_type_switch_statement] = STATE(948),
    [sym_select_statement] = STATE(948),
    [sym__expression] = STATE(238),
    [sym_parenthesized_expression] = STATE(278),
    [sym_call_expression] = STATE(278),
    [sym_selector_expression] = STATE(278),
    [sym_index_expression] = STATE(278),
    [sym_slice_expression] = STATE(278),
    [sym_type_assertion_expression] = STATE(278),
    [sym_type_conversion_expression] = STATE(278),
    [sym_type_instantiation_expression] = STATE(278),
    [sym_composite_literal] = STATE(278),
    [sym_func_literal] = STATE(278),
    [sym_unary_expression] = STATE(278),
    [sym_binary_expression] = STATE(278),
    [sym_qualified_type] = STATE(1046),
    [sym_interpreted_string_literal] = STATE(278),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(41),
    [anon_sym_fallthrough] = ACTIONS(43),
    [anon_sym_break] = ACTIONS(45),
    [anon_sym_continue] = ACTIONS(47),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_return] = ACTIONS(51),
    [anon_sym_go] = ACTIONS(53),
    [anon_sym_defer] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_for] = ACTIONS(59),
    [anon_sym_switch] = ACTIONS(61),
    [anon_sym_select] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_make] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(67),
    [sym_raw_string_literal] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(71),
    [sym_int_literal] = ACTIONS(73),
    [sym_float_literal] = ACTIONS(73),
    [sym_imaginary_literal] = ACTIONS(69),
    [sym_rune_literal] = ACTIONS(69),
    [sym_nil] = ACTIONS(73),
    [sym_true] = ACTIONS(73),
    [sym_false] = ACTIONS(73),
    [sym_iota] = ACTIONS(73),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression_list] = STATE(795),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym_block] = STATE(952),
    [sym__simple_statement] = STATE(1321),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym_for_clause] = STATE(1311),
    [sym_range_clause] = STATE(1311),
    [sym__expression] = STATE(277),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_SEMI] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_range] = ACTIONS(243),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_expression_list] = STATE(803),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__type_switch_header] = STATE(1355),
    [sym__expression] = STATE(288),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(255),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_expression_list] = STATE(799),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1333),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__expression] = STATE(294),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(257),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_expression_list] = STATE(799),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1339),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__expression] = STATE(294),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(259),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_expression_list] = STATE(799),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1383),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__expression] = STATE(294),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_expression_list] = STATE(799),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1340),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__expression] = STATE(294),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_expression_list] = STATE(802),
    [sym_parenthesized_type] = STATE(1249),
    [sym__simple_type] = STATE(1249),
    [sym_generic_type] = STATE(1097),
    [sym_pointer_type] = STATE(852),
    [sym_array_type] = STATE(1097),
    [sym_implicit_length_array_type] = STATE(1300),
    [sym_slice_type] = STATE(1097),
    [sym_struct_type] = STATE(1097),
    [sym_negated_type] = STATE(837),
    [sym_interface_type] = STATE(852),
    [sym_map_type] = STATE(1097),
    [sym_channel_type] = STATE(852),
    [sym_function_type] = STATE(852),
    [sym__simple_statement] = STATE(1341),
    [sym_expression_statement] = STATE(1282),
    [sym_send_statement] = STATE(1282),
    [sym_inc_statement] = STATE(1282),
    [sym_dec_statement] = STATE(1282),
    [sym_assignment_statement] = STATE(1282),
    [sym_short_var_declaration] = STATE(1282),
    [sym__expression] = STATE(274),
    [sym_parenthesized_expression] = STATE(301),
    [sym_call_expression] = STATE(301),
    [sym_selector_expression] = STATE(301),
    [sym_index_expression] = STATE(301),
    [sym_slice_expression] = STATE(301),
    [sym_type_assertion_expression] = STATE(301),
    [sym_type_conversion_expression] = STATE(301),
    [sym_type_instantiation_expression] = STATE(301),
    [sym_composite_literal] = STATE(301),
    [sym_func_literal] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_qualified_type] = STATE(1033),
    [sym_interpreted_string_literal] = STATE(301),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_func] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(239),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_map] = ACTIONS(37),
    [anon_sym_chan] = ACTIONS(39),
    [anon_sym_LT_DASH] = ACTIONS(241),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_make] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_CARET] = ACTIONS(247),
    [anon_sym_AMP] = ACTIONS(247),
    [sym_raw_string_literal] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [sym_int_literal] = ACTIONS(253),
    [sym_float_literal] = ACTIONS(253),
    [sym_imaginary_literal] = ACTIONS(249),
    [sym_rune_literal] = ACTIONS(249),
    [sym_nil] = ACTIONS(253),
    [sym_true] = ACTIONS(253),
    [sym_false] = ACTIONS(253),
    [sym_iota] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(267), 1,
      anon_sym_LF,
    ACTIONS(271), 1,
      anon_sym_LPAREN,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(275), 1,
      anon_sym_LBRACK,
    ACTIONS(277), 1,
      anon_sym_STAR,
    ACTIONS(279), 1,
      anon_sym_TILDE,
    ACTIONS(281), 1,
      anon_sym_LT_DASH,
    ACTIONS(289), 1,
      anon_sym_DQUOTE,
    ACTIONS(291), 1,
      sym_comment,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(960), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(269), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(285), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 9,
      sym_raw_string_literal,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [119] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(297), 1,
      anon_sym_COMMA,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(305), 1,
      anon_sym_RBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1124), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1240), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [245] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(319), 1,
      anon_sym_COMMA,
    ACTIONS(321), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1058), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1198), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [371] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(323), 1,
      anon_sym_COMMA,
    ACTIONS(325), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1129), 1,
      sym_literal_element,
    STATE(1139), 1,
      sym_keyed_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [497] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(327), 1,
      anon_sym_COMMA,
    ACTIONS(329), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1072), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1197), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_COMMA,
    ACTIONS(333), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1079), 1,
      sym_literal_element,
    STATE(1167), 1,
      sym_keyed_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [749] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(335), 1,
      anon_sym_COMMA,
    ACTIONS(337), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1098), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1239), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [875] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(339), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [998] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(341), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(343), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1244] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(345), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1367] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(347), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(349), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1613] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(351), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1736] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(353), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1859] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(355), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1982] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(357), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2105] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(359), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2228] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(361), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2351] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1145), 1,
      sym_literal_element,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1273), 1,
      sym_keyed_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2471] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(454), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    STATE(1304), 1,
      sym_expression_list,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1345), 2,
      sym_send_statement,
      sym_receive_statement,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2586] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(568), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1168), 1,
      sym_literal_value,
    STATE(1277), 1,
      sym_literal_element,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2703] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(385), 1,
      anon_sym_RPAREN,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2817] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(393), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2931] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(399), 1,
      anon_sym_COLON,
    STATE(627), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3045] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(401), 1,
      anon_sym_RBRACK,
    STATE(675), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3159] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(403), 1,
      anon_sym_COLON,
    STATE(608), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3273] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(405), 1,
      anon_sym_COLON,
    STATE(595), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3387] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(407), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3501] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(409), 1,
      anon_sym_COLON,
    STATE(611), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3615] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(411), 1,
      anon_sym_RPAREN,
    STATE(523), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1159), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3729] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(413), 1,
      anon_sym_RPAREN,
    STATE(525), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1134), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3843] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(415), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3957] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(417), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4071] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(419), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4185] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(421), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1201), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4299] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(423), 1,
      anon_sym_RBRACK,
    STATE(655), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1230), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4413] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(425), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4527] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(427), 1,
      anon_sym_RBRACK,
    ACTIONS(429), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(673), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4641] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(431), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4755] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(423), 1,
      anon_sym_RBRACK,
    ACTIONS(433), 1,
      sym_identifier,
    STATE(655), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1235), 1,
      sym_type_parameter_declaration,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4869] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(435), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4983] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(437), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5097] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(439), 1,
      anon_sym_COLON,
    STATE(598), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5211] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(441), 1,
      anon_sym_RPAREN,
    STATE(515), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1232), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5325] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(443), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5439] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(449), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(514), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    STATE(1332), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5553] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(455), 1,
      anon_sym_RPAREN,
    STATE(522), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1234), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5667] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(457), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1193), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5781] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    ACTIONS(459), 1,
      anon_sym_COLON,
    STATE(632), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1175), 1,
      sym_type_elem,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(922), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5895] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(461), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6009] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      anon_sym_range,
    STATE(512), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1263), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6123] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(463), 1,
      anon_sym_range,
    STATE(512), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1265), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6237] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(465), 1,
      anon_sym_SEMI,
    STATE(691), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6348] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(467), 1,
      anon_sym_RBRACK,
    STATE(679), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(469), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6570] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(471), 1,
      anon_sym_RBRACK,
    STATE(617), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(473), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6792] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(512), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    STATE(1324), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6903] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(475), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7014] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(477), 1,
      anon_sym_RBRACK,
    STATE(601), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7125] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_RBRACK,
    STATE(675), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7236] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(554), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1265), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7347] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(427), 1,
      anon_sym_RBRACK,
    STATE(673), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7458] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(479), 1,
      anon_sym_RBRACK,
    STATE(689), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7569] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(481), 1,
      anon_sym_RBRACK,
    STATE(615), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7680] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(552), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1263), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7791] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(552), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1265), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7902] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(483), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8013] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(485), 1,
      anon_sym_RBRACK,
    STATE(618), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8124] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(487), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8235] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(489), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8346] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(491), 1,
      anon_sym_RBRACK,
    STATE(621), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8457] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(945), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8568] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(505), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8679] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(507), 1,
      anon_sym_RBRACK,
    STATE(630), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8790] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(512), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1265), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8901] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(512), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1263), 1,
      sym_expression_list,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9012] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(509), 1,
      anon_sym_RBRACK,
    STATE(613), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9123] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(944), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9234] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9345] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(928), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9456] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(513), 1,
      anon_sym_SEMI,
    STATE(686), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9567] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(515), 1,
      anon_sym_RBRACK,
    STATE(616), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9678] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(517), 1,
      anon_sym_RBRACK,
    STATE(636), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9789] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(519), 1,
      anon_sym_RBRACK,
    STATE(637), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9900] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(521), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(523), 1,
      anon_sym_RBRACK,
    STATE(606), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10122] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(525), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(527), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10344] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(423), 1,
      anon_sym_RBRACK,
    STATE(655), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(529), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10566] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(531), 1,
      anon_sym_RBRACK,
    STATE(631), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10677] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1014), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10788] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1015), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(533), 1,
      anon_sym_RBRACK,
    STATE(593), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11010] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1010), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11121] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(577), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1280), 1,
      sym_variadic_argument,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11232] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1003), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11343] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(934), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11454] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(951), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11565] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(424), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(950), 1,
      sym_expression_list,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11676] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(387), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11784] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(437), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11892] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(337), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12000] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12108] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(342), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12216] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(443), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12324] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(343), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12432] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(340), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12540] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(339), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12648] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(594), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12756] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(661), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12864] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(660), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12972] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(453), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13080] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(338), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13188] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(244), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13296] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(245), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13404] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(445), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13512] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(666), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13620] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(242), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13728] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(243), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13836] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(246), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13944] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(623), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14052] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(441), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14160] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(240), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14268] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(663), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14376] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14484] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(662), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14592] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(667), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14700] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(610), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14808] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14916] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(669), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15024] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(639), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15132] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(605), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15240] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(678), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15348] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15456] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(540), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15564] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(539), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15672] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(534), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15780] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(533), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15888] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(657), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15996] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(387), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16104] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16212] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(626), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16320] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(477), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16428] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(455), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16536] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(395), 1,
      sym_identifier,
    ACTIONS(397), 1,
      anon_sym_STAR,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16644] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(434), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16752] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(435), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16860] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(436), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16968] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(444), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17076] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(645), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17184] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(289), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17292] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(640), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17400] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(641), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17508] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(290), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17616] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(581), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17724] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(291), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17832] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(619), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17940] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(292), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18048] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(439), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18156] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(682), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18264] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(650), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18372] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(442), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18480] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(493), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18588] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(685), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18696] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(296), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18804] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(438), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18912] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(633), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19020] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(692), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19128] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(296), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19236] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(293), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19344] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(477), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19452] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19560] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(387), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19668] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(337), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19776] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(240), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1290), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19884] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(656), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19992] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20100] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(433), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20208] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(231), 1,
      sym_identifier,
    ACTIONS(235), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_func,
    ACTIONS(239), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_LT_DASH,
    ACTIONS(251), 1,
      anon_sym_DQUOTE,
    STATE(296), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1033), 1,
      sym_qualified_type,
    STATE(1300), 1,
      sym_implicit_length_array_type,
    ACTIONS(245), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(249), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(247), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1097), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(253), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(301), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20316] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(658), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20424] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(337), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20532] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(444), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20640] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20748] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    STATE(607), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20856] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    ACTIONS(555), 1,
      anon_sym_STAR,
    STATE(659), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1187), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(612), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21072] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(688), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21180] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(471), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21288] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(535), 1,
      sym_identifier,
    ACTIONS(537), 1,
      anon_sym_LPAREN,
    ACTIONS(539), 1,
      anon_sym_func,
    ACTIONS(541), 1,
      anon_sym_STAR,
    ACTIONS(543), 1,
      anon_sym_LT_DASH,
    ACTIONS(551), 1,
      anon_sym_DQUOTE,
    STATE(341), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1039), 1,
      sym_qualified_type,
    STATE(1267), 1,
      sym_implicit_length_array_type,
    ACTIONS(545), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1248), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(549), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(547), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1081), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(553), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(355), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21396] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21504] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(445), 1,
      sym_identifier,
    ACTIONS(447), 1,
      anon_sym_STAR,
    ACTIONS(451), 1,
      anon_sym_LT_DASH,
    ACTIONS(559), 1,
      anon_sym_chan,
    STATE(386), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(453), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21612] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(469), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21720] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(465), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21828] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(590), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21936] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(494), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22044] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(508), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22152] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(622), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22260] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(570), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22368] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(265), 1,
      sym_identifier,
    ACTIONS(273), 1,
      anon_sym_func,
    ACTIONS(493), 1,
      anon_sym_LPAREN,
    ACTIONS(495), 1,
      anon_sym_STAR,
    ACTIONS(497), 1,
      anon_sym_LT_DASH,
    ACTIONS(503), 1,
      anon_sym_DQUOTE,
    STATE(444), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1032), 1,
      sym_qualified_type,
    STATE(1301), 1,
      sym_implicit_length_array_type,
    ACTIONS(283), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1250), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(501), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(499), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1096), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(287), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(472), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22476] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(363), 1,
      sym_identifier,
    ACTIONS(365), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_func,
    ACTIONS(369), 1,
      anon_sym_STAR,
    ACTIONS(371), 1,
      anon_sym_LT_DASH,
    ACTIONS(379), 1,
      anon_sym_DQUOTE,
    STATE(477), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1036), 1,
      sym_qualified_type,
    STATE(1283), 1,
      sym_implicit_length_array_type,
    ACTIONS(373), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(377), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(375), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1101), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(381), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(571), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22584] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    ACTIONS(383), 1,
      sym_identifier,
    ACTIONS(387), 1,
      anon_sym_STAR,
    ACTIONS(389), 1,
      anon_sym_LT_DASH,
    STATE(572), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(391), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22692] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(711), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22800] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(41), 1,
      anon_sym_LT_DASH,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(183), 1,
      anon_sym_func,
    ACTIONS(557), 1,
      sym_identifier,
    STATE(240), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(1046), 1,
      sym_qualified_type,
    STATE(1303), 1,
      sym_implicit_length_array_type,
    ACTIONS(65), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(920), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(69), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(67), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1084), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(73), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(278), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [22908] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(293), 1,
      sym_identifier,
    ACTIONS(295), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_func,
    ACTIONS(301), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LT_DASH,
    ACTIONS(315), 1,
      anon_sym_DQUOTE,
    STATE(643), 1,
      sym__expression,
    STATE(837), 1,
      sym_negated_type,
    STATE(861), 1,
      sym_qualified_type,
    STATE(1297), 1,
      sym_implicit_length_array_type,
    ACTIONS(309), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1251), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(313), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(852), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(311), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(894), 5,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
    ACTIONS(317), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(430), 13,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_type_instantiation_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [23016] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(566), 1,
      anon_sym_LPAREN,
    ACTIONS(570), 1,
      anon_sym_COMMA,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(574), 1,
      anon_sym_LBRACK,
    ACTIONS(580), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    STATE(423), 1,
      sym_literal_value,
    STATE(527), 1,
      aux_sym_type_parameter_declaration_repeat1,
    STATE(856), 1,
      sym_type_arguments,
    STATE(1284), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(583), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(578), 14,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23116] = 10,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(591), 1,
      anon_sym_DOT,
    ACTIONS(594), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym_LBRACK,
    ACTIONS(601), 1,
      anon_sym_LBRACE,
    ACTIONS(603), 1,
      anon_sym_COLON,
    STATE(269), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23187] = 10,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(591), 1,
      anon_sym_DOT,
    ACTIONS(594), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym_LBRACK,
    ACTIONS(601), 1,
      anon_sym_LBRACE,
    ACTIONS(605), 1,
      anon_sym_COLON,
    STATE(269), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23258] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(607), 1,
      anon_sym_LF,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(615), 1,
      anon_sym_COMMA,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(625), 1,
      anon_sym_LT_DASH,
    ACTIONS(627), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(629), 1,
      anon_sym_DASH_DASH,
    ACTIONS(633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(635), 1,
      anon_sym_PIPE_PIPE,
    STATE(254), 1,
      sym_argument_list,
    STATE(790), 1,
      aux_sym_expression_list_repeat1,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(623), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(609), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(631), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(621), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(617), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [23346] = 9,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(591), 1,
      anon_sym_DOT,
    ACTIONS(594), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym_LBRACK,
    ACTIONS(601), 1,
      anon_sym_LBRACE,
    STATE(269), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23414] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(637), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(639), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_imaginary_literal,
      sym_rune_literal,
    ACTIONS(641), 30,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      sym_identifier,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23534] = 10,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(643), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(623), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(621), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 30,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23603] = 11,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(643), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(623), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(631), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(621), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 24,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23674] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(643), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(645), 41,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23739] = 9,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(643), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(621), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 34,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23806] = 12,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(611), 1,
      anon_sym_DOT,
    ACTIONS(613), 1,
      anon_sym_LPAREN,
    ACTIONS(619), 1,
      anon_sym_LBRACK,
    ACTIONS(633), 1,
      anon_sym_AMP_AMP,
    ACTIONS(643), 1,
      anon_sym_LF,
    STATE(254), 1,
      sym_argument_list,
    STATE(1266), 1,
      sym_type_arguments,
    ACTIONS(623), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(631), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(621), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 23,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
  [23879] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LF,
    ACTIONS(649), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23933] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(651), 1,
      anon_sym_LF,
    ACTIONS(653), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23987] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(655), 1,
      anon_sym_LPAREN,
    STATE(254), 1,
      sym_special_argument_list,
    ACTIONS(583), 43,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24045] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_LF,
    ACTIONS(659), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24099] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(661), 1,
      anon_sym_LF,
    ACTIONS(663), 45,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24153] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(665), 1,
      anon_sym_LF,
    ACTIONS(667), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24206] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(669), 1,
      anon_sym_LF,
    ACTIONS(671), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24259] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_LF,
    ACTIONS(675), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24312] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(677), 1,
      anon_sym_LF,
    ACTIONS(679), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24365] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(681), 1,
      anon_sym_LF,
    ACTIONS(683), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24418] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_LF,
    ACTIONS(687), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24471] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LF,
    ACTIONS(691), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24524] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_LF,
    ACTIONS(695), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24577] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_LF,
    ACTIONS(699), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24630] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(701), 1,
      anon_sym_LF,
    ACTIONS(703), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24683] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_LF,
    ACTIONS(707), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24736] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_LF,
    ACTIONS(711), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24789] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_LF,
    ACTIONS(715), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24842] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_LF,
    ACTIONS(719), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24895] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_LF,
    ACTIONS(723), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24948] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(725), 1,
      anon_sym_LF,
    ACTIONS(727), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25001] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(729), 1,
      anon_sym_LF,
    ACTIONS(731), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25054] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(733), 1,
      anon_sym_LF,
    ACTIONS(735), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25107] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_LF,
    ACTIONS(739), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25160] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_LF,
    ACTIONS(743), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25213] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_LF,
    ACTIONS(747), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25266] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_LF,
    ACTIONS(751), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25319] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(607), 1,
      anon_sym_SEMI,
    ACTIONS(617), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    ACTIONS(765), 1,
      anon_sym_LT_DASH,
    ACTIONS(769), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(771), 1,
      anon_sym_DASH_DASH,
    ACTIONS(777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(779), 1,
      anon_sym_PIPE_PIPE,
    STATE(298), 1,
      sym_argument_list,
    STATE(790), 1,
      aux_sym_expression_list_repeat1,
    STATE(908), 1,
      sym_block,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(767), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25410] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(781), 1,
      anon_sym_LF,
    ACTIONS(783), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25463] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LF,
    ACTIONS(787), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25516] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(607), 1,
      anon_sym_SEMI,
    ACTIONS(617), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    ACTIONS(765), 1,
      anon_sym_LT_DASH,
    ACTIONS(769), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(771), 1,
      anon_sym_DASH_DASH,
    ACTIONS(777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(779), 1,
      anon_sym_PIPE_PIPE,
    STATE(298), 1,
      sym_argument_list,
    STATE(790), 1,
      aux_sym_expression_list_repeat1,
    STATE(969), 1,
      sym_block,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(767), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25607] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(583), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25660] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(789), 1,
      anon_sym_LF,
    ACTIONS(791), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25713] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(793), 1,
      anon_sym_LF,
    ACTIONS(795), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25766] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_LF,
    ACTIONS(799), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25819] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LF,
    ACTIONS(803), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25872] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(805), 1,
      anon_sym_LF,
    ACTIONS(807), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25925] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_LF,
    ACTIONS(811), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25978] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(813), 1,
      anon_sym_LF,
    ACTIONS(815), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26031] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_LF,
    ACTIONS(819), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26084] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(821), 1,
      anon_sym_LF,
    ACTIONS(823), 44,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26137] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(607), 1,
      anon_sym_SEMI,
    ACTIONS(617), 1,
      anon_sym_EQ,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    ACTIONS(765), 1,
      anon_sym_LT_DASH,
    ACTIONS(769), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(771), 1,
      anon_sym_DASH_DASH,
    ACTIONS(777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(779), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(825), 1,
      anon_sym_DOT,
    ACTIONS(827), 1,
      anon_sym_LBRACE,
    STATE(298), 1,
      sym_argument_list,
    STATE(790), 1,
      aux_sym_expression_list_repeat1,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(767), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26225] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    ACTIONS(777), 1,
      anon_sym_AMP_AMP,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [26296] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26365] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(645), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26430] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(645), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26493] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(645), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(643), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26554] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(607), 1,
      anon_sym_LBRACE,
    ACTIONS(617), 1,
      anon_sym_EQ,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    ACTIONS(769), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(771), 1,
      anon_sym_DASH_DASH,
    ACTIONS(777), 1,
      anon_sym_AMP_AMP,
    ACTIONS(779), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(829), 1,
      anon_sym_LT_DASH,
    STATE(298), 1,
      sym_argument_list,
    STATE(790), 1,
      aux_sym_expression_list_repeat1,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(775), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(763), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(773), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(761), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(767), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(831), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    STATE(300), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_DOT,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(759), 1,
      anon_sym_LBRACK,
    STATE(298), 1,
      sym_argument_list,
    STATE(1313), 1,
      sym_type_arguments,
    ACTIONS(639), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(637), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_LPAREN,
    STATE(298), 1,
      sym_special_argument_list,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(673), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(681), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(735), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(733), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(781), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(819), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(817), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(669), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(647), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(745), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(821), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(697), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(725), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(793), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(787), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(785), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(737), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(717), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(713), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(709), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(651), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(723), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(721), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(749), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(805), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(809), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(815), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(813), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(797), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(791), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(789), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(731), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(729), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(657), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(831), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    ACTIONS(840), 1,
      anon_sym_LBRACE,
    STATE(376), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28736] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(639), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(637), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28792] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    ACTIONS(850), 1,
      anon_sym_EQ,
    ACTIONS(860), 1,
      anon_sym_AMP_AMP,
    ACTIONS(862), 1,
      anon_sym_PIPE_PIPE,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(858), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(856), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(852), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(848), 13,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [28860] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(645), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(643), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28916] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_EQ,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    ACTIONS(860), 1,
      anon_sym_AMP_AMP,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(858), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(856), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(852), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 14,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [28982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(645), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(852), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29040] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(645), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(852), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29100] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(645), 1,
      anon_sym_EQ,
    ACTIONS(842), 1,
      anon_sym_DOT,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_LBRACK,
    STATE(377), 1,
      sym_argument_list,
    STATE(1254), 1,
      sym_type_arguments,
    ACTIONS(858), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(854), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(856), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(852), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 15,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_LPAREN,
    STATE(377), 1,
      sym_special_argument_list,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 21,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(713), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(793), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(725), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(709), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(717), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(651), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(737), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(697), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(821), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(745), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(647), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(681), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(731), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(729), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(669), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(819), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(817), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(791), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(789), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(797), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(815), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(813), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(809), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(805), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(749), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(781), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(735), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(733), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(673), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(723), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(721), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(657), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(787), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(785), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30885] = 17,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(868), 1,
      anon_sym_LF,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(876), 1,
      anon_sym_LBRACK,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(817), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(870), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [30956] = 17,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(868), 1,
      anon_sym_LF,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(896), 1,
      anon_sym_LBRACK,
    ACTIONS(898), 1,
      anon_sym_STAR,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(904), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(817), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(870), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [31027] = 24,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    ACTIONS(906), 1,
      anon_sym_LF,
    ACTIONS(910), 1,
      anon_sym_DOT,
    ACTIONS(912), 1,
      anon_sym_LPAREN,
    ACTIONS(914), 1,
      anon_sym_COMMA,
    ACTIONS(916), 1,
      anon_sym_LBRACK,
    ACTIONS(918), 1,
      sym_raw_string_literal,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    STATE(597), 1,
      aux_sym_field_declaration_repeat1,
    STATE(823), 1,
      sym_type_arguments,
    STATE(1125), 1,
      sym_interpreted_string_literal,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(905), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(908), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [31112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(639), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(637), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(645), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(643), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31216] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    STATE(423), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(831), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(583), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 1,
      anon_sym_LPAREN,
    STATE(416), 1,
      sym_special_argument_list,
    ACTIONS(583), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 23,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31314] = 20,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(279), 1,
      anon_sym_TILDE,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(930), 1,
      anon_sym_LF,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(936), 1,
      anon_sym_COMMA,
    ACTIONS(938), 1,
      anon_sym_EQ,
    ACTIONS(940), 1,
      anon_sym_LBRACK,
    ACTIONS(942), 1,
      anon_sym_STAR,
    ACTIONS(944), 1,
      anon_sym_LT_DASH,
    STATE(779), 1,
      aux_sym_const_spec_repeat1,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1371), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(932), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [31389] = 20,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(279), 1,
      anon_sym_TILDE,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(934), 1,
      anon_sym_LPAREN,
    ACTIONS(936), 1,
      anon_sym_COMMA,
    ACTIONS(940), 1,
      anon_sym_LBRACK,
    ACTIONS(942), 1,
      anon_sym_STAR,
    ACTIONS(944), 1,
      anon_sym_LT_DASH,
    ACTIONS(946), 1,
      anon_sym_LF,
    ACTIONS(950), 1,
      anon_sym_EQ,
    STATE(390), 1,
      aux_sym_const_spec_repeat1,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1318), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(948), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [31464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(723), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(721), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(713), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(657), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(787), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(785), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(791), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(789), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(669), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(797), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(725), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(815), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(813), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(809), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31904] = 9,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(591), 1,
      anon_sym_DOT,
    ACTIONS(594), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym_LBRACK,
    ACTIONS(952), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 25,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(805), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(749), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(745), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(819), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(817), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(793), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(681), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(821), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(673), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(737), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(697), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(647), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(717), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(651), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(735), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(733), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32756] = 15,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(958), 1,
      anon_sym_COMMA,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(970), 1,
      anon_sym_PIPE_PIPE,
    STATE(486), 1,
      sym_argument_list,
    STATE(891), 1,
      aux_sym_expression_list_repeat1,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(617), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [32820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(781), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(731), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(729), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(709), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33100] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(873), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(868), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [33165] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(645), 25,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(645), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33267] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(645), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33324] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33385] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
  [33448] = 9,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 18,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33499] = 10,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33552] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(873), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(868), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [33617] = 11,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(645), 8,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33672] = 13,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(970), 1,
      anon_sym_PIPE_PIPE,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(850), 6,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33731] = 12,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(643), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(645), 7,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33788] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(637), 1,
      anon_sym_LF,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(639), 25,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33837] = 13,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(970), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1004), 1,
      anon_sym_LF,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1006), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33895] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(831), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    ACTIONS(1008), 1,
      anon_sym_LBRACE,
    STATE(584), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33945] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(893), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(868), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34013] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1022), 1,
      anon_sym_LBRACK,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1028), 1,
      anon_sym_TILDE,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1038), 1,
      anon_sym_LT_DASH,
    STATE(1060), 1,
      sym_block,
    ACTIONS(1012), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1016), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(981), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34083] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1022), 1,
      anon_sym_LBRACK,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1028), 1,
      anon_sym_TILDE,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1038), 1,
      anon_sym_LT_DASH,
    STATE(1067), 1,
      sym_block,
    ACTIONS(1040), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1042), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(967), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34153] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(1044), 1,
      anon_sym_LPAREN,
    STATE(486), 1,
      sym_special_argument_list,
    ACTIONS(583), 27,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34195] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1046), 1,
      anon_sym_DOT,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1050), 1,
      anon_sym_RPAREN,
    ACTIONS(1052), 1,
      anon_sym_COMMA,
    ACTIONS(1055), 1,
      anon_sym_LBRACK,
    ACTIONS(1057), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(596), 1,
      aux_sym_type_parameter_declaration_repeat1,
    STATE(856), 1,
      sym_type_arguments,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1257), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34269] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1022), 1,
      anon_sym_LBRACK,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1028), 1,
      anon_sym_TILDE,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1038), 1,
      anon_sym_LT_DASH,
    STATE(1131), 1,
      sym_block,
    ACTIONS(1059), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(916), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34339] = 13,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(970), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1063), 1,
      anon_sym_LF,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1065), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34397] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(617), 1,
      anon_sym_EQ,
    ACTIONS(765), 1,
      anon_sym_LT_DASH,
    ACTIONS(767), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    ACTIONS(1077), 1,
      anon_sym_PIPE,
    ACTIONS(1079), 1,
      anon_sym_COLON,
    ACTIONS(1089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1091), 1,
      anon_sym_PIPE_PIPE,
    STATE(582), 1,
      sym_argument_list,
    STATE(1008), 1,
      aux_sym_expression_list_repeat1,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(1083), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1081), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1085), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1075), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34469] = 13,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_DOT,
    ACTIONS(956), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(970), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1093), 1,
      anon_sym_LF,
    STATE(486), 1,
      sym_argument_list,
    STATE(1272), 1,
      sym_type_arguments,
    ACTIONS(964), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1095), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(966), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(962), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34527] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(717), 1,
      anon_sym_LF,
    ACTIONS(719), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34564] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(725), 1,
      anon_sym_LF,
    ACTIONS(727), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34601] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(647), 1,
      anon_sym_LF,
    ACTIONS(649), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34638] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1099), 1,
      anon_sym_RPAREN,
    ACTIONS(1101), 1,
      anon_sym_COMMA,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1150), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [34707] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(657), 1,
      anon_sym_LF,
    ACTIONS(659), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34744] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(801), 1,
      anon_sym_LF,
    ACTIONS(803), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34781] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(813), 1,
      anon_sym_LF,
    ACTIONS(815), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34818] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_LF,
    ACTIONS(811), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34855] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(805), 1,
      anon_sym_LF,
    ACTIONS(807), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34892] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    ACTIONS(1077), 1,
      anon_sym_PIPE,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(1083), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1081), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(645), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 9,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34947] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_LF,
    ACTIONS(751), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34984] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(741), 1,
      anon_sym_LF,
    ACTIONS(743), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35021] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(665), 1,
      anon_sym_LF,
    ACTIONS(667), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35058] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    ACTIONS(1077), 1,
      anon_sym_PIPE,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1083), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1081), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1085), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(643), 5,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1075), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35117] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_LF,
    ACTIONS(723), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35154] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    ACTIONS(1077), 1,
      anon_sym_PIPE,
    ACTIONS(1089), 1,
      anon_sym_AMP_AMP,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1083), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1087), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1081), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(643), 4,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1085), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1075), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35215] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_LF,
    ACTIONS(583), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35252] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_LF,
    ACTIONS(707), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35289] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(685), 1,
      anon_sym_LF,
    ACTIONS(687), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35326] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(681), 1,
      anon_sym_LF,
    ACTIONS(683), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35363] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1105), 1,
      anon_sym_RPAREN,
    ACTIONS(1107), 1,
      anon_sym_COMMA,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1241), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(639), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(637), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35479] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(677), 1,
      anon_sym_LF,
    ACTIONS(679), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35516] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_LF,
    ACTIONS(691), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35553] = 17,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1022), 1,
      anon_sym_LBRACK,
    ACTIONS(1024), 1,
      anon_sym_STAR,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1028), 1,
      anon_sym_TILDE,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1038), 1,
      anon_sym_LT_DASH,
    ACTIONS(868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(957), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(870), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [35618] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(651), 1,
      anon_sym_LF,
    ACTIONS(653), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35655] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(729), 1,
      anon_sym_LF,
    ACTIONS(731), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35692] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(701), 1,
      anon_sym_LF,
    ACTIONS(703), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35729] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(709), 1,
      anon_sym_LF,
    ACTIONS(711), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35766] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(713), 1,
      anon_sym_LF,
    ACTIONS(715), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35803] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_LF,
    ACTIONS(675), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35840] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_LF,
    ACTIONS(739), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35877] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LF,
    ACTIONS(787), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35914] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(733), 1,
      anon_sym_LF,
    ACTIONS(735), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35951] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(793), 1,
      anon_sym_LF,
    ACTIONS(795), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35988] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1109), 1,
      anon_sym_RPAREN,
    ACTIONS(1111), 1,
      anon_sym_COMMA,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1196), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36057] = 17,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1018), 1,
      anon_sym_LPAREN,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1028), 1,
      anon_sym_TILDE,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1117), 1,
      anon_sym_LBRACK,
    ACTIONS(1119), 1,
      anon_sym_STAR,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1125), 1,
      anon_sym_LT_DASH,
    ACTIONS(868), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(957), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(870), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36122] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(850), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(848), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36185] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(1083), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(645), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 12,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36236] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(876), 1,
      anon_sym_LBRACK,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    ACTIONS(1059), 1,
      anon_sym_LF,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    STATE(1155), 1,
      sym_block,
    ACTIONS(1061), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1025), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36305] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(876), 1,
      anon_sym_LBRACK,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    ACTIONS(1012), 1,
      anon_sym_LF,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    STATE(1169), 1,
      sym_block,
    ACTIONS(1016), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1038), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36374] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(697), 1,
      anon_sym_LF,
    ACTIONS(699), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36411] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_LF,
    ACTIONS(695), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36448] = 19,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(876), 1,
      anon_sym_LBRACK,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    ACTIONS(1040), 1,
      anon_sym_LF,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    STATE(1171), 1,
      sym_block,
    ACTIONS(1042), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1041), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36517] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(821), 1,
      anon_sym_LF,
    ACTIONS(823), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36554] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(745), 1,
      anon_sym_LF,
    ACTIONS(747), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36591] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(797), 1,
      anon_sym_LF,
    ACTIONS(799), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36628] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(669), 1,
      anon_sym_LF,
    ACTIONS(671), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36665] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(817), 1,
      anon_sym_LF,
    ACTIONS(819), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36702] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(781), 1,
      anon_sym_LF,
    ACTIONS(783), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36739] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(661), 1,
      anon_sym_LF,
    ACTIONS(663), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36776] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(789), 1,
      anon_sym_LF,
    ACTIONS(791), 28,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_DOT,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    ACTIONS(1073), 1,
      anon_sym_LBRACK,
    STATE(582), 1,
      sym_argument_list,
    STATE(1298), 1,
      sym_type_arguments,
    ACTIONS(645), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(643), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36860] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1131), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36926] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [36992] = 17,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(876), 1,
      anon_sym_LBRACK,
    ACTIONS(878), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(882), 1,
      anon_sym_TILDE,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(890), 1,
      anon_sym_LT_DASH,
    ACTIONS(1135), 1,
      anon_sym_LF,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1078), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(1137), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37056] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1008), 1,
      aux_sym_expression_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(767), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37120] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37186] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_COLON_EQ,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1141), 1,
      anon_sym_DOT,
    ACTIONS(1145), 1,
      anon_sym_LBRACE,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1008), 1,
      aux_sym_expression_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
    ACTIONS(1163), 1,
      anon_sym_COMMA,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1204), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1183), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_special_argument_list,
    ACTIONS(583), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 19,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37424] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(594), 1,
      anon_sym_PIPE,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    ACTIONS(1050), 1,
      anon_sym_COMMA,
    STATE(423), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(831), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(583), 4,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 15,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37476] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1187), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37542] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(1191), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1213), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1183), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37674] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1227), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37740] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1223), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37806] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(591), 1,
      anon_sym_DOT,
    ACTIONS(831), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    STATE(423), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37854] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1205), 1,
      anon_sym_RPAREN,
    ACTIONS(1207), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1154), 1,
      aux_sym_argument_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37920] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [37986] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(570), 1,
      anon_sym_COMMA,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      aux_sym_type_parameter_declaration_repeat1,
    STATE(1314), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(687), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(685), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(707), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(705), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38121] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1221), 1,
      anon_sym_RBRACE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1022), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(681), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(679), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(677), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(645), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 12,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38303] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(691), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(689), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(703), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(701), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(709), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(671), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(669), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38496] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(643), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38551] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(643), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(715), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(713), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(719), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(717), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(739), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(737), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(787), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(785), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(795), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(793), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38783] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(727), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(725), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38881] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1227), 1,
      anon_sym_COMMA,
    ACTIONS(1229), 1,
      anon_sym_EQ,
    STATE(793), 1,
      aux_sym_const_spec_repeat1,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(904), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [38946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(803), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(815), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(813), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(723), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(721), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39051] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_LBRACE,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1231), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1225), 1,
      aux_sym_expression_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(699), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(697), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39149] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_SEMI,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1233), 1,
      anon_sym_DOT,
    STATE(416), 1,
      sym_argument_list,
    STATE(1008), 1,
      aux_sym_expression_list_repeat1,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39212] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1235), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(695), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(693), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(823), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(821), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(747), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(745), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39380] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1237), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(649), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(647), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(667), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(665), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(819), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(817), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(743), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(741), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(749), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39618] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1239), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(807), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(805), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(811), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(809), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39751] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1241), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39810] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1097), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1274), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1307), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [39873] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(645), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(583), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39961] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(643), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40016] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1243), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1028), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40079] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(563), 1,
      anon_sym_DOT,
    ACTIONS(831), 1,
      anon_sym_LPAREN,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    STATE(423), 1,
      sym_literal_value,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(583), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(578), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40124] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1245), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(657), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40222] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1165), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40283] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1249), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1017), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40346] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1251), 1,
      anon_sym_RBRACE,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(663), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(661), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40444] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(643), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(675), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(673), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40536] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1227), 1,
      anon_sym_COMMA,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    STATE(548), 1,
      aux_sym_const_spec_repeat1,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(911), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(735), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(733), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(653), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(651), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(731), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(729), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(783), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(781), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(791), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(789), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40776] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(570), 1,
      anon_sym_COMMA,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(527), 1,
      aux_sym_type_parameter_declaration_repeat1,
    STATE(1284), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      anon_sym_DOT,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(645), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(643), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(799), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(797), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40925] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [40987] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1257), 1,
      anon_sym_RBRACK,
    ACTIONS(1259), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41047] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1261), 1,
      anon_sym_RPAREN,
    ACTIONS(1263), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41107] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1265), 1,
      anon_sym_RBRACK,
    ACTIONS(1267), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41167] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(570), 1,
      anon_sym_COMMA,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      aux_sym_type_parameter_declaration_repeat1,
    STATE(1243), 1,
      sym__simple_type,
    STATE(1244), 1,
      sym_parenthesized_type,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41231] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    STATE(801), 1,
      aux_sym_field_declaration_repeat1,
    STATE(903), 1,
      sym__simple_type,
    STATE(906), 1,
      sym_parenthesized_type,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41295] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1271), 1,
      anon_sym_RBRACK,
    ACTIONS(1273), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41355] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1275), 1,
      sym_identifier,
    STATE(253), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1066), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41417] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1277), 1,
      anon_sym_LBRACE,
    STATE(364), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1123), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41479] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1279), 1,
      anon_sym_RBRACK,
    ACTIONS(1281), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41539] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1283), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41601] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1285), 1,
      anon_sym_EQ,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    STATE(693), 1,
      sym_type_parameter_list,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(996), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41663] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1289), 1,
      anon_sym_LBRACE,
    STATE(538), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1054), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [41725] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1291), 1,
      anon_sym_RPAREN,
    ACTIONS(1293), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41785] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1295), 1,
      anon_sym_RBRACK,
    ACTIONS(1297), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41845] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(899), 1,
      sym_block,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41905] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1299), 1,
      anon_sym_RBRACK,
    ACTIONS(1301), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41965] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    STATE(253), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1066), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42027] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1303), 1,
      anon_sym_RPAREN,
    ACTIONS(1305), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42087] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1307), 1,
      anon_sym_RBRACK,
    ACTIONS(1309), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42147] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1311), 1,
      anon_sym_RPAREN,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42207] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1315), 1,
      anon_sym_RBRACK,
    ACTIONS(1317), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42267] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1319), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42329] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1321), 1,
      anon_sym_RBRACK,
    ACTIONS(1323), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42389] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1325), 1,
      anon_sym_RBRACK,
    ACTIONS(1327), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42449] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1329), 1,
      anon_sym_RBRACK,
    ACTIONS(1331), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42509] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1333), 1,
      anon_sym_RBRACK,
    ACTIONS(1335), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42569] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(848), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42627] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(977), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1088), 2,
      sym_method_elem,
      sym_type_elem,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42687] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1337), 1,
      anon_sym_RBRACK,
    ACTIONS(1339), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42747] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1004), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42805] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(848), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42863] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1341), 1,
      sym_identifier,
    STATE(253), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1066), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42925] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1343), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1122), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [42987] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1347), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43047] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1349), 1,
      anon_sym_RBRACK,
    ACTIONS(1351), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43107] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43169] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1355), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43231] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1357), 1,
      anon_sym_RBRACK,
    ACTIONS(1359), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43291] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1361), 1,
      anon_sym_RBRACK,
    ACTIONS(1363), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43351] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1365), 1,
      anon_sym_RBRACK,
    ACTIONS(1367), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43411] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1369), 1,
      anon_sym_RPAREN,
    ACTIONS(1371), 1,
      anon_sym_COMMA,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43471] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1373), 1,
      anon_sym_LBRACE,
    STATE(305), 1,
      sym_block,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1074), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43533] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1375), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43595] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1377), 1,
      anon_sym_RBRACK,
    ACTIONS(1379), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43655] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1381), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43712] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1383), 1,
      anon_sym_type,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1346), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [43771] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1385), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43828] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1387), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43885] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1389), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43942] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(1142), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44001] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1391), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44058] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1393), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1194), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44117] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1395), 1,
      anon_sym_LBRACE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44174] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1397), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44233] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1399), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44292] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1401), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44351] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(1175), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1004), 1,
      anon_sym_LBRACE,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(1230), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44526] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1403), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44585] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1405), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44644] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1407), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1143), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [44703] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1409), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44760] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1411), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44817] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1413), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44874] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1415), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44931] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [44988] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1419), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45045] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45102] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_PIPE,
    ACTIONS(1157), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1423), 1,
      anon_sym_LBRACE,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1151), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1155), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1149), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1143), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45159] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45216] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1427), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45275] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1429), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45334] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1431), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45391] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1433), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45448] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1435), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45507] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45564] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45623] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1441), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45682] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1233), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45741] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1445), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45798] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1449), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [45914] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1451), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [45973] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1200), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46032] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46089] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1457), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46146] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1459), 1,
      anon_sym_RBRACK,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46205] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1461), 1,
      anon_sym_type,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1346), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46264] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1463), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46321] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(1271), 1,
      sym_type_elem,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1120), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46380] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      anon_sym_type,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1358), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46439] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_PIPE,
    ACTIONS(1179), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1181), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(1173), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1175), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1167), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46496] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1469), 1,
      anon_sym_SEMI,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46553] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1236), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46612] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1473), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46669] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1475), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46726] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      anon_sym_type,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1346), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46785] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1479), 1,
      anon_sym_SEMI,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46842] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(978), 1,
      anon_sym_DOT,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1481), 1,
      anon_sym_RBRACK,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [46899] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(932), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [46955] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(812), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47011] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1360), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47067] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1489), 1,
      anon_sym_LT_DASH,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(875), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47123] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(933), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47179] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(956), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47235] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(976), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47291] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(998), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47347] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1000), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47403] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1247), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47459] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1501), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(989), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47515] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    ACTIONS(1503), 1,
      anon_sym_chan,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(994), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47571] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1501), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1004), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47627] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(855), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47683] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1040), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47739] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    ACTIONS(1505), 1,
      anon_sym_chan,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(810), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47795] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1507), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(808), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47851] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(866), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [47907] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_LBRACK,
    ACTIONS(984), 1,
      anon_sym_PIPE,
    ACTIONS(992), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1127), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1509), 1,
      anon_sym_DOT,
    STATE(416), 1,
      sym_argument_list,
    STATE(1242), 1,
      sym_type_arguments,
    ACTIONS(982), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(990), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(988), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(980), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [47961] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1322), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48017] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1372), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48073] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(850), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48129] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(933), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48185] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(828), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48241] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(998), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48297] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1195), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48353] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1165), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48409] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(812), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1000), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48521] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1199), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48577] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(821), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48633] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1517), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1004), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48689] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1489), 1,
      anon_sym_LT_DASH,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(853), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48745] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(956), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48801] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(976), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1344), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48913] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1374), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [48969] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(876), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49025] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(855), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49081] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1316), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49137] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(870), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49193] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1392), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49249] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(559), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(874), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49305] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1381), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49361] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1519), 1,
      anon_sym_LT_DASH,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(875), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49417] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1036), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1517), 1,
      anon_sym_LT_DASH,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(989), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49473] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_func,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1034), 1,
      anon_sym_map,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_STAR,
    ACTIONS(1515), 1,
      anon_sym_LT_DASH,
    ACTIONS(1521), 1,
      anon_sym_chan,
    STATE(912), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(994), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49529] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(850), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49585] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(863), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49641] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1132), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49697] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1346), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49753] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1133), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49809] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(935), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49865] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1172), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49921] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(811), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [49977] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(830), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50033] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_LT_DASH,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(863), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50089] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1329), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50145] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(825), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50201] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1389), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50257] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(876), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50313] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1523), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(806), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50369] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(811), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50425] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1391), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50481] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(37), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_chan,
    ACTIONS(994), 1,
      sym_identifier,
    ACTIONS(996), 1,
      anon_sym_func,
    ACTIONS(998), 1,
      anon_sym_LBRACK,
    ACTIONS(1000), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1519), 1,
      anon_sym_LT_DASH,
    STATE(837), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(853), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50537] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1136), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50593] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(866), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50649] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1261), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50705] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1387), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50761] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(828), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50817] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1358), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50873] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_struct,
    ACTIONS(1032), 1,
      anon_sym_interface,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_func,
    ACTIONS(1121), 1,
      anon_sym_map,
    ACTIONS(1123), 1,
      anon_sym_chan,
    ACTIONS(1491), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_STAR,
    ACTIONS(1497), 1,
      anon_sym_TILDE,
    ACTIONS(1499), 1,
      anon_sym_LT_DASH,
    STATE(900), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1002), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(995), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50929] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1507), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(806), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [50985] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(825), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51041] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(902), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1523), 1,
      anon_sym_LT_DASH,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(808), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51097] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(892), 1,
      sym_identifier,
    ACTIONS(894), 1,
      anon_sym_func,
    ACTIONS(900), 1,
      anon_sym_map,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_STAR,
    ACTIONS(1487), 1,
      anon_sym_LT_DASH,
    ACTIONS(1525), 1,
      anon_sym_chan,
    STATE(797), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(810), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51153] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    ACTIONS(1527), 1,
      anon_sym_chan,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(874), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51209] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1403), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51265] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1331), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51321] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_func,
    ACTIONS(880), 1,
      anon_sym_struct,
    ACTIONS(884), 1,
      anon_sym_interface,
    ACTIONS(886), 1,
      anon_sym_map,
    ACTIONS(888), 1,
      anon_sym_chan,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACK,
    ACTIONS(1217), 1,
      anon_sym_STAR,
    ACTIONS(1219), 1,
      anon_sym_TILDE,
    ACTIONS(1223), 1,
      anon_sym_LT_DASH,
    STATE(800), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(830), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(826), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51377] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1161), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51433] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(35), 1,
      anon_sym_interface,
    ACTIONS(561), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_func,
    ACTIONS(585), 1,
      anon_sym_map,
    ACTIONS(587), 1,
      anon_sym_chan,
    ACTIONS(589), 1,
      anon_sym_LT_DASH,
    ACTIONS(974), 1,
      anon_sym_LBRACK,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_LPAREN,
    STATE(848), 2,
      sym_negated_type,
      sym_qualified_type,
    STATE(1160), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(852), 9,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
  [51489] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1531), 1,
      anon_sym_LF,
    ACTIONS(1529), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_PIPE,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51519] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_LF,
    ACTIONS(1533), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_PIPE,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51549] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_LF,
    ACTIONS(1537), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_PIPE,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51579] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_LF,
    ACTIONS(1541), 21,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_PIPE,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51609] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_LF,
    ACTIONS(1549), 1,
      anon_sym_COMMA,
    STATE(779), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1545), 17,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [51641] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_LF,
    ACTIONS(1545), 18,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [51668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1531), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [51694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1539), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [51720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1535), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [51746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1543), 12,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [51772] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1539), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1537), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [51796] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1543), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1541), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [51820] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1535), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1533), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [51844] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1531), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1529), 14,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LPAREN,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_TILDE,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      sym_identifier,
  [51868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_COMMA,
    STATE(789), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(848), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [51893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(757), 1,
      anon_sym_COMMA,
    STATE(789), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1555), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [51918] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(910), 1,
      anon_sym_DOT,
    ACTIONS(1050), 1,
      anon_sym_LF,
    ACTIONS(1559), 1,
      anon_sym_LBRACK,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(1557), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51946] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(910), 1,
      anon_sym_DOT,
    ACTIONS(1050), 1,
      anon_sym_LF,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(1557), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [51974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COMMA,
    STATE(793), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1545), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1547), 6,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [52000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 1,
      anon_sym_COMMA,
    STATE(794), 1,
      aux_sym_type_parameter_declaration_repeat1,
    ACTIONS(1569), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1567), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [52025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_EQ,
    ACTIONS(1576), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1578), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [52048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1580), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [52069] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_LF,
    ACTIONS(1588), 1,
      anon_sym_LBRACK,
    STATE(815), 1,
      sym_type_arguments,
    ACTIONS(1586), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1547), 7,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [52115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1591), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [52136] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(1584), 1,
      anon_sym_LF,
    STATE(815), 1,
      sym_type_arguments,
    ACTIONS(1586), 10,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_COMMA,
    STATE(801), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(1597), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1595), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [52186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1578), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [52207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1604), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1578), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [52228] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1606), 1,
      anon_sym_LF,
    ACTIONS(1608), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52248] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_LF,
    ACTIONS(1612), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52268] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1614), 1,
      anon_sym_LF,
    ACTIONS(1616), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52288] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1618), 1,
      anon_sym_LF,
    ACTIONS(1620), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52308] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_LF,
    ACTIONS(1624), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52328] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1626), 1,
      anon_sym_LF,
    ACTIONS(1628), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52348] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_LF,
    ACTIONS(1624), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52368] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1630), 1,
      anon_sym_LF,
    ACTIONS(1632), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52388] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_LF,
    ACTIONS(1624), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52408] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1634), 1,
      anon_sym_LF,
    ACTIONS(1636), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52428] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1638), 1,
      anon_sym_LF,
    ACTIONS(1640), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52448] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1642), 1,
      anon_sym_LF,
    ACTIONS(1644), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1648), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [52488] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1650), 1,
      anon_sym_LF,
    ACTIONS(1652), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52508] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1654), 1,
      anon_sym_LF,
    ACTIONS(1656), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52528] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_LF,
    ACTIONS(1660), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52548] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_LF,
    ACTIONS(1664), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52568] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LF,
    ACTIONS(1668), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52588] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_LF,
    ACTIONS(1672), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52608] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_LF,
    ACTIONS(1676), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52628] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LF,
    ACTIONS(1680), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52648] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1682), 1,
      anon_sym_LF,
    ACTIONS(1684), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52668] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_LF,
    ACTIONS(1586), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52688] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_LF,
    ACTIONS(1688), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52708] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1690), 1,
      anon_sym_LF,
    ACTIONS(1692), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1696), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
  [52748] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1698), 1,
      anon_sym_LF,
    ACTIONS(1700), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52768] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1702), 1,
      anon_sym_LF,
    ACTIONS(1704), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52788] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1706), 1,
      anon_sym_LF,
    ACTIONS(1708), 11,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [52808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_DOT,
    ACTIONS(1712), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(1050), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [52831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1717), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1715), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [52850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1719), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [52869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1725), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_TILDE,
      anon_sym_LT_DASH,
    ACTIONS(1723), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [52888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    STATE(849), 1,
      sym_type_arguments,
    ACTIONS(1584), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [52908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 1,
      anon_sym_DOT,
    ACTIONS(1730), 1,
      anon_sym_LBRACK,
    STATE(856), 1,
      sym_type_arguments,
    ACTIONS(1050), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [52930] = 9,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(910), 1,
      anon_sym_DOT,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(1732), 1,
      anon_sym_LF,
    ACTIONS(1736), 1,
      sym_raw_string_literal,
    STATE(823), 1,
      sym_type_arguments,
    STATE(1069), 1,
      sym_interpreted_string_literal,
    ACTIONS(1734), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [52960] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1742), 1,
      sym_blank_identifier,
    ACTIONS(1744), 1,
      anon_sym_LPAREN,
    ACTIONS(1746), 1,
      sym_raw_string_literal,
    ACTIONS(1748), 1,
      anon_sym_DQUOTE,
    STATE(1062), 1,
      sym_interpreted_string_literal,
    STATE(1178), 1,
      sym_dot,
    STATE(1061), 2,
      sym_import_spec,
      sym_import_spec_list,
  [52992] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1754), 1,
      anon_sym_LPAREN,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1202), 1,
      sym_dot,
    STATE(1157), 2,
      sym_import_spec,
      sym_import_spec_list,
  [53024] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_DOT,
    ACTIONS(1050), 1,
      anon_sym_LF,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    STATE(511), 1,
      sym_parameter_list,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(1557), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [53052] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1126), 1,
      sym_import_spec,
    STATE(1202), 1,
      sym_dot,
  [53083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1706), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1760), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1126), 1,
      sym_import_spec,
    STATE(1202), 1,
      sym_dot,
  [53129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53144] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1762), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_import_spec,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1202), 1,
      sym_dot,
  [53175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 1,
      anon_sym_LBRACK,
    STATE(849), 1,
      sym_type_arguments,
    ACTIONS(1584), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53224] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1126), 1,
      sym_import_spec,
    STATE(1202), 1,
      sym_dot,
  [53255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53285] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1766), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1126), 1,
      sym_import_spec,
    STATE(1202), 1,
      sym_dot,
  [53316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1682), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53391] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    ACTIONS(1768), 1,
      anon_sym_RPAREN,
    STATE(1019), 1,
      sym_import_spec,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1202), 1,
      sym_dot,
  [53422] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
    ACTIONS(1584), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [53445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1690), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1678), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53520] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(1770), 1,
      anon_sym_LF,
    ACTIONS(1774), 1,
      sym_raw_string_literal,
    STATE(815), 1,
      sym_type_arguments,
    STATE(1071), 1,
      sym_interpreted_string_literal,
    ACTIONS(1772), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [53547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1662), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1702), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1666), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1670), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53697] = 8,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1562), 1,
      anon_sym_LBRACK,
    ACTIONS(1776), 1,
      anon_sym_LF,
    ACTIONS(1780), 1,
      sym_raw_string_literal,
    STATE(815), 1,
      sym_type_arguments,
    STATE(1092), 1,
      sym_interpreted_string_literal,
    ACTIONS(1778), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [53724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_COLON,
  [53739] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1786), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53767] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LF,
    ACTIONS(1788), 1,
      anon_sym_COMMA,
    STATE(881), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(850), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [53787] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1791), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53815] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1793), 1,
      anon_sym_DOT,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    STATE(1006), 1,
      sym_type_arguments,
    ACTIONS(1050), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1557), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
  [53837] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(1740), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      sym_identifier,
    ACTIONS(1752), 1,
      sym_blank_identifier,
    ACTIONS(1756), 1,
      sym_raw_string_literal,
    STATE(1050), 1,
      sym_interpreted_string_literal,
    STATE(1126), 1,
      sym_import_spec,
    STATE(1202), 1,
      sym_dot,
  [53865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1797), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1027), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1799), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1801), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1023), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53949] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1803), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [53977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1805), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [54005] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1807), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1037), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [54033] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(958), 1,
      anon_sym_COMMA,
    ACTIONS(1555), 1,
      anon_sym_LF,
    STATE(881), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1809), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54053] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    ACTIONS(1811), 1,
      anon_sym_RBRACE,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [54081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LBRACE,
    STATE(410), 1,
      sym_block,
    ACTIONS(1650), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [54099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(426), 1,
      sym_literal_value,
    ACTIONS(1584), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [54117] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1793), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_LBRACK,
    STATE(1006), 1,
      sym_type_arguments,
    ACTIONS(1050), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1557), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
  [54139] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_STAR,
    STATE(878), 1,
      sym_qualified_type,
    STATE(907), 1,
      sym_generic_type,
    STATE(1075), 1,
      sym_field_declaration,
    STATE(1269), 1,
      sym_negated_type,
  [54164] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_LF,
    STATE(910), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1818), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(211), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54183] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_LF,
    STATE(897), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1822), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(1824), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54202] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LF,
    ACTIONS(1830), 1,
      anon_sym_else,
    ACTIONS(1828), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54219] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    STATE(1016), 1,
      sym_type_arguments,
    ACTIONS(1584), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1586), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
  [54238] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1835), 1,
      sym_identifier,
    ACTIONS(1837), 1,
      anon_sym_LF,
    ACTIONS(1839), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54255] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1770), 1,
      anon_sym_LF,
    ACTIONS(1774), 1,
      sym_raw_string_literal,
    STATE(1071), 1,
      sym_interpreted_string_literal,
    ACTIONS(1772), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54276] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1841), 1,
      anon_sym_LF,
    ACTIONS(1845), 1,
      sym_raw_string_literal,
    STATE(1090), 1,
      sym_interpreted_string_literal,
    ACTIONS(1843), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54297] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1847), 1,
      anon_sym_LF,
    ACTIONS(1851), 1,
      anon_sym_EQ,
    ACTIONS(1849), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54314] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1853), 1,
      anon_sym_LF,
    ACTIONS(1857), 1,
      sym_raw_string_literal,
    STATE(1049), 1,
      sym_interpreted_string_literal,
    ACTIONS(1855), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54335] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1841), 1,
      anon_sym_LF,
    ACTIONS(1859), 1,
      sym_raw_string_literal,
    STATE(1052), 1,
      sym_interpreted_string_literal,
    ACTIONS(1843), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54356] = 6,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(920), 1,
      anon_sym_DQUOTE,
    ACTIONS(1776), 1,
      anon_sym_LF,
    ACTIONS(1780), 1,
      sym_raw_string_literal,
    STATE(1092), 1,
      sym_interpreted_string_literal,
    ACTIONS(1778), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54377] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_LF,
    ACTIONS(1865), 1,
      anon_sym_else,
    ACTIONS(1863), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54394] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1867), 1,
      sym_identifier,
    ACTIONS(1869), 1,
      anon_sym_LF,
    ACTIONS(1871), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54411] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_LF,
    STATE(910), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1876), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
    ACTIONS(1879), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54430] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_LF,
    ACTIONS(1885), 1,
      anon_sym_EQ,
    ACTIONS(1883), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54447] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1795), 1,
      anon_sym_LBRACK,
    STATE(1016), 1,
      sym_type_arguments,
    ACTIONS(1584), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1586), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACE,
  [54466] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1887), 1,
      anon_sym_LF,
    ACTIONS(1889), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54480] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1658), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1660), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54494] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LF,
    ACTIONS(1893), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54508] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_block,
    ACTIONS(1895), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1897), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [54526] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_LF,
    ACTIONS(1901), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54540] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1618), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1620), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54554] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1678), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1680), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [54580] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1686), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1688), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1907), 1,
      anon_sym_LBRACK,
    ACTIONS(1909), 1,
      anon_sym_PIPE,
    STATE(1108), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(1905), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [54614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 1,
      anon_sym_RBRACE,
    ACTIONS(1913), 1,
      anon_sym_case,
    ACTIONS(1916), 1,
      anon_sym_default,
    STATE(923), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [54632] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1919), 1,
      anon_sym_LF,
    ACTIONS(1923), 1,
      anon_sym_PIPE,
    STATE(954), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(1921), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [54650] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_LF,
    ACTIONS(1927), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54664] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LF,
    ACTIONS(1931), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54678] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1706), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1708), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54692] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1933), 1,
      anon_sym_LF,
    ACTIONS(1935), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1937), 1,
      anon_sym_RBRACE,
    ACTIONS(1939), 1,
      anon_sym_case,
    ACTIONS(1941), 1,
      anon_sym_default,
    STATE(961), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [54724] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1943), 1,
      anon_sym_LF,
    ACTIONS(1945), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54738] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1626), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1628), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54752] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym_LF,
    ACTIONS(1949), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54766] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1630), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1632), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54780] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LF,
    ACTIONS(1953), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54794] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1955), 1,
      anon_sym_LF,
    ACTIONS(1957), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1959), 1,
      anon_sym_RBRACE,
    ACTIONS(1961), 1,
      anon_sym_case,
    STATE(1009), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [54826] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LF,
    ACTIONS(1965), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54840] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1634), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1636), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54854] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1638), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1640), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(1967), 1,
      anon_sym_RBRACE,
    STATE(974), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [54886] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1969), 1,
      anon_sym_LF,
    ACTIONS(1971), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(1973), 1,
      anon_sym_RBRACE,
    STATE(966), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [54918] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1975), 1,
      anon_sym_LF,
    ACTIONS(1977), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54932] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1979), 1,
      anon_sym_LF,
    ACTIONS(1981), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54946] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1983), 1,
      anon_sym_LF,
    ACTIONS(1985), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54960] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1654), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1656), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [54974] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1987), 1,
      anon_sym_LF,
    ACTIONS(1989), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [54988] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1991), 1,
      anon_sym_LF,
    ACTIONS(1993), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55002] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LF,
    ACTIONS(1997), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55016] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LF,
    ACTIONS(2001), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55030] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_LF,
    ACTIONS(2005), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55044] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2007), 1,
      anon_sym_LF,
    ACTIONS(2009), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55058] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2011), 1,
      anon_sym_LF,
    ACTIONS(2013), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55072] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_LF,
    ACTIONS(2019), 1,
      anon_sym_PIPE,
    STATE(954), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(2017), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [55090] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1610), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1612), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55104] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1624), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55118] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1650), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1652), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55132] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_LF,
    ACTIONS(2024), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55146] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2026), 1,
      anon_sym_LF,
    ACTIONS(1879), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55160] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2028), 1,
      anon_sym_LF,
    ACTIONS(2030), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_case,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(2032), 1,
      anon_sym_RBRACE,
    STATE(992), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [55192] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2034), 1,
      anon_sym_LF,
    ACTIONS(2036), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(2038), 1,
      anon_sym_RBRACE,
    STATE(985), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_DOT,
    ACTIONS(1712), 1,
      anon_sym_LBRACK,
    ACTIONS(2040), 1,
      anon_sym_LPAREN,
    STATE(449), 1,
      sym_parameter_list,
    STATE(856), 1,
      sym_type_arguments,
  [55246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(2042), 1,
      anon_sym_RBRACE,
    ACTIONS(2044), 1,
      anon_sym_case,
    STATE(983), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [55264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(2046), 1,
      anon_sym_RBRACE,
    STATE(974), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55282] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      sym_block,
    ACTIONS(2048), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2050), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [55300] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2052), 1,
      anon_sym_LF,
    ACTIONS(2054), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55314] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym_LF,
    ACTIONS(2058), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55328] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1670), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1672), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55342] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_LF,
    ACTIONS(2062), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55356] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2064), 1,
      anon_sym_LF,
    ACTIONS(2066), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55370] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_LF,
    ACTIONS(2070), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_RBRACE,
    ACTIONS(2074), 1,
      anon_sym_case,
    ACTIONS(2077), 1,
      anon_sym_default,
    STATE(974), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55402] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2080), 1,
      anon_sym_LF,
    ACTIONS(2082), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55416] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1690), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1692), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55430] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_LF,
    ACTIONS(1923), 1,
      anon_sym_PIPE,
    STATE(924), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(2084), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [55448] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2086), 1,
      anon_sym_LF,
    ACTIONS(2088), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(2090), 1,
      anon_sym_RBRACE,
    STATE(940), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55480] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2092), 1,
      anon_sym_LF,
    ACTIONS(2094), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55494] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1030), 1,
      anon_sym_LBRACE,
    STATE(1056), 1,
      sym_block,
    ACTIONS(2096), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2098), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [55512] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2100), 1,
      anon_sym_LF,
    ACTIONS(2102), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(2044), 1,
      anon_sym_case,
    ACTIONS(2104), 1,
      anon_sym_RBRACE,
    STATE(923), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [55544] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_LF,
    ACTIONS(2108), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(2110), 1,
      anon_sym_RBRACE,
    STATE(974), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_COLON,
    ACTIONS(2112), 1,
      anon_sym_COMMA,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(848), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [55594] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_LF,
    ACTIONS(2117), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55608] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2119), 1,
      anon_sym_LF,
    ACTIONS(2121), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55622] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1624), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55636] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2123), 1,
      anon_sym_LF,
    ACTIONS(2125), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55650] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2127), 1,
      anon_sym_LF,
    ACTIONS(2129), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      anon_sym_RBRACE,
    ACTIONS(2133), 1,
      anon_sym_case,
    ACTIONS(2136), 1,
      anon_sym_default,
    STATE(992), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [55682] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_LF,
    ACTIONS(2141), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55696] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1622), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1624), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55710] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1584), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1586), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55724] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_LF,
    ACTIONS(2145), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55738] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1662), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1664), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55752] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1698), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1700), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55766] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1702), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1704), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55780] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1682), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1684), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55794] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1606), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1608), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55808] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1666), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1668), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55822] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_LF,
    ACTIONS(2149), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55836] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1614), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1616), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_LBRACE,
    ACTIONS(1710), 1,
      anon_sym_DOT,
    ACTIONS(1712), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    STATE(499), 1,
      sym_parameter_list,
    STATE(856), 1,
      sym_type_arguments,
  [55872] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1674), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1676), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [55886] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_LF,
    ACTIONS(2155), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55900] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 1,
      anon_sym_COMMA,
    ACTIONS(1809), 1,
      anon_sym_COLON,
    STATE(986), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1555), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [55918] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_default,
    ACTIONS(1961), 1,
      anon_sym_case,
    ACTIONS(2157), 1,
      anon_sym_RBRACE,
    STATE(974), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [55936] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2159), 1,
      anon_sym_LF,
    ACTIONS(2161), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55950] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_LF,
    ACTIONS(2165), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55964] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2167), 1,
      anon_sym_LF,
    ACTIONS(2169), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55978] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_LF,
    ACTIONS(2173), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [55992] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_LF,
    ACTIONS(2177), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [56006] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2179), 1,
      anon_sym_LF,
    ACTIONS(2181), 5,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [56020] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1642), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(1644), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [56034] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2183), 1,
      anon_sym_LF,
    ACTIONS(2187), 1,
      anon_sym_RBRACE,
    STATE(1029), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2185), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56051] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2189), 1,
      anon_sym_LF,
    ACTIONS(2193), 1,
      anon_sym_RBRACE,
    STATE(1042), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2191), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56068] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_LF,
    ACTIONS(2199), 1,
      anon_sym_RPAREN,
    STATE(1043), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2197), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56085] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_LF,
    ACTIONS(2205), 1,
      anon_sym_RBRACE,
    STATE(1035), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2203), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      sym_identifier,
    ACTIONS(2209), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1221), 2,
      sym_type_alias,
      sym_type_spec,
  [56119] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_LF,
    ACTIONS(2215), 1,
      anon_sym_RBRACE,
    STATE(1020), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2213), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56136] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_LF,
    ACTIONS(2221), 1,
      anon_sym_RBRACE,
    STATE(1018), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2219), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56153] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LF,
    ACTIONS(2227), 1,
      anon_sym_RBRACE,
    STATE(1042), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2225), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56170] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    ACTIONS(1895), 1,
      anon_sym_LF,
    STATE(1170), 1,
      sym_block,
    ACTIONS(1897), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56187] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_LF,
    ACTIONS(2233), 1,
      anon_sym_RPAREN,
    STATE(1030), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2231), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56204] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_LF,
    ACTIONS(2239), 1,
      anon_sym_RBRACE,
    STATE(1048), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2237), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56221] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_LF,
    ACTIONS(2245), 1,
      anon_sym_RBRACE,
    STATE(1047), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2243), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56238] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_LF,
    ACTIONS(2251), 1,
      anon_sym_RBRACE,
    STATE(1035), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2249), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56255] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2253), 1,
      anon_sym_LF,
    ACTIONS(2257), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2255), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      sym_identifier,
    ACTIONS(2262), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1221), 2,
      sym_type_alias,
      sym_type_spec,
  [56289] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_LPAREN,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
  [56308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_LPAREN,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    ACTIONS(2266), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
  [56327] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2268), 1,
      anon_sym_LF,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2271), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56344] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_LF,
    ACTIONS(2282), 1,
      anon_sym_RBRACE,
    STATE(1035), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2279), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_LBRACE,
    ACTIONS(1584), 1,
      anon_sym_LPAREN,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    STATE(587), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
  [56380] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2284), 1,
      anon_sym_LF,
    ACTIONS(2288), 1,
      anon_sym_RBRACE,
    STATE(1024), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2286), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56397] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    ACTIONS(2096), 1,
      anon_sym_LF,
    STATE(1190), 1,
      sym_block,
    ACTIONS(2098), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LBRACE,
    ACTIONS(1584), 1,
      anon_sym_LPAREN,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    STATE(373), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
  [56433] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_LF,
    ACTIONS(2017), 4,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [56446] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(1129), 1,
      anon_sym_LBRACE,
    ACTIONS(2048), 1,
      anon_sym_LF,
    STATE(1191), 1,
      sym_block,
    ACTIONS(2050), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56463] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2290), 1,
      anon_sym_LF,
    ACTIONS(2296), 1,
      anon_sym_RBRACE,
    STATE(1042), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2293), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56480] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_LF,
    ACTIONS(2302), 1,
      anon_sym_RPAREN,
    STATE(1034), 1,
      aux_sym_import_spec_list_repeat1,
    ACTIONS(2300), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_TILDE,
    ACTIONS(2304), 1,
      sym_identifier,
    STATE(867), 1,
      sym_qualified_type,
    STATE(902), 1,
      sym_generic_type,
    STATE(1269), 1,
      sym_negated_type,
  [56516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      sym_identifier,
    ACTIONS(2306), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1221), 2,
      sym_type_alias,
      sym_type_spec,
  [56533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1584), 1,
      anon_sym_LPAREN,
    ACTIONS(1727), 1,
      anon_sym_LBRACK,
    ACTIONS(2308), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_literal_value,
    STATE(849), 1,
      sym_type_arguments,
  [56552] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_LF,
    ACTIONS(2314), 1,
      anon_sym_RBRACE,
    STATE(1035), 1,
      aux_sym_interface_type_repeat1,
    ACTIONS(2312), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56569] = 5,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2316), 1,
      anon_sym_LF,
    ACTIONS(2320), 1,
      anon_sym_RBRACE,
    STATE(1042), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(2318), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56586] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_LF,
    ACTIONS(2324), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56598] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2326), 1,
      anon_sym_LF,
    ACTIONS(2328), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [56610] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_LF,
    ACTIONS(2332), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56622] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_LF,
    ACTIONS(2332), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56634] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_LF,
    ACTIONS(2332), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1289), 1,
      anon_sym_LBRACE,
    STATE(545), 1,
      sym_block,
    ACTIONS(1650), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [56660] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2334), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2336), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56672] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2338), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2340), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56684] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2342), 1,
      anon_sym_DQUOTE2,
    STATE(1127), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2344), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [56698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RBRACE,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    STATE(1186), 1,
      aux_sym_literal_value_repeat1,
  [56714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(2354), 1,
      anon_sym_RPAREN,
    STATE(1087), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1181), 1,
      sym_const_spec,
  [56730] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2356), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2358), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56742] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2360), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2362), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56754] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2326), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2328), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56766] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2364), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2366), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56778] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2368), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2370), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56790] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_DQUOTE2,
    STATE(1068), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2374), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [56804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(280), 1,
      sym_block,
    ACTIONS(1650), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [56818] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2376), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2378), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56830] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [56844] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2384), 1,
      anon_sym_LF,
    ACTIONS(2386), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      anon_sym_PIPE,
    STATE(1070), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(2015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [56870] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2391), 1,
      anon_sym_LF,
    ACTIONS(2393), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2395), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_RBRACE,
    STATE(1207), 1,
      aux_sym_literal_value_repeat1,
  [56898] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(651), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(653), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [56910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1373), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      sym_block,
    ACTIONS(1650), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [56924] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2399), 1,
      anon_sym_LF,
    ACTIONS(2296), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 1,
      sym_identifier,
    ACTIONS(2403), 1,
      anon_sym_RPAREN,
    STATE(1082), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1189), 1,
      sym_var_spec,
  [56952] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2405), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [56966] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LF,
    ACTIONS(2409), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [56978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2411), 1,
      anon_sym_COMMA,
    ACTIONS(2413), 1,
      anon_sym_RBRACE,
    STATE(1212), 1,
      aux_sym_literal_value_repeat1,
  [56994] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_DQUOTE2,
    STATE(1103), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2417), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LBRACE,
    STATE(373), 1,
      sym_literal_value,
    ACTIONS(1584), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 1,
      sym_identifier,
    ACTIONS(2419), 1,
      anon_sym_RPAREN,
    STATE(1111), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1189), 1,
      sym_var_spec,
  [57038] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2421), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2423), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_literal_value,
    ACTIONS(1584), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57066] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57080] = 4,
    ACTIONS(179), 1,
      ts_builtin_sym_end,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_LF,
    ACTIONS(2430), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(2432), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1181), 1,
      sym_const_spec,
  [57110] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_LF,
    ACTIONS(2282), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [57122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_LPAREN,
    ACTIONS(2436), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym_parameter_list,
    STATE(1295), 1,
      sym_type_parameter_list,
  [57138] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_LF,
    ACTIONS(2332), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [57150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    ACTIONS(2436), 1,
      anon_sym_LBRACK,
    STATE(495), 1,
      sym_parameter_list,
    STATE(1258), 1,
      sym_type_parameter_list,
  [57166] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2438), 1,
      anon_sym_LF,
    ACTIONS(2440), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [57178] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2442), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2444), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57190] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(647), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(649), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57202] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_DQUOTE2,
    STATE(1114), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2448), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_literal_value,
    ACTIONS(1584), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_literal_value,
    ACTIONS(1584), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    ACTIONS(2452), 1,
      anon_sym_RBRACE,
    STATE(1214), 1,
      aux_sym_literal_value_repeat1,
  [57260] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_DQUOTE2,
    STATE(1085), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2456), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57274] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2458), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2460), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_literal_value,
    ACTIONS(1584), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57300] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2462), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2464), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57312] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57326] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_DQUOTE2,
    STATE(1118), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2470), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57340] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_DQUOTE2,
    STATE(1077), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2474), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      anon_sym_if,
    STATE(993), 2,
      sym_block,
      sym_if_statement,
  [57368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      sym_identifier,
    ACTIONS(2481), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1181), 1,
      sym_const_spec,
  [57384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym_PIPE,
    STATE(1070), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(1919), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [57398] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(657), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(659), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57410] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2483), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2485), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 1,
      sym_identifier,
    ACTIONS(2490), 1,
      anon_sym_RPAREN,
    STATE(1111), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1189), 1,
      sym_var_spec,
  [57438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
    ACTIONS(2495), 2,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [57452] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2497), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2499), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57464] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2501), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    ACTIONS(2476), 1,
      anon_sym_if,
    STATE(913), 2,
      sym_block,
      sym_if_statement,
  [57492] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_LF,
    ACTIONS(2503), 1,
      ts_builtin_sym_end,
    ACTIONS(2430), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57506] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2505), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2507), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57518] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57532] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(661), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(663), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym_PIPE,
    STATE(1108), 1,
      aux_sym_type_elem_repeat1,
    ACTIONS(1905), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [57558] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_LF,
    ACTIONS(2460), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [57570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_block,
    ACTIONS(1650), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1277), 1,
      anon_sym_LBRACE,
    STATE(348), 1,
      sym_block,
    ACTIONS(1650), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
  [57598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    ACTIONS(2513), 1,
      anon_sym_RBRACE,
    STATE(1237), 1,
      aux_sym_literal_value_repeat1,
  [57614] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_LF,
    ACTIONS(2517), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RBRACE,
  [57626] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2519), 1,
      anon_sym_LF,
    ACTIONS(2274), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [57638] = 4,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_DQUOTE2,
    STATE(1083), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2382), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [57652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      sym_identifier,
    ACTIONS(2523), 1,
      anon_sym_LPAREN,
    STATE(1011), 2,
      sym_type_alias,
      sym_type_spec,
  [57666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2525), 1,
      anon_sym_COMMA,
    ACTIONS(2527), 1,
      anon_sym_RBRACE,
    STATE(1148), 1,
      aux_sym_literal_value_repeat1,
  [57682] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2497), 1,
      anon_sym_LF,
    ACTIONS(2499), 3,
      anon_sym_SEMI,
      anon_sym_NULL,
      anon_sym_RPAREN,
  [57694] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2529), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2531), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      anon_sym_COMMA,
    ACTIONS(2535), 1,
      anon_sym_RBRACK,
    STATE(1209), 1,
      aux_sym_type_case_repeat1,
  [57719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_COMMA,
    ACTIONS(2539), 1,
      anon_sym_RBRACK,
    STATE(1229), 1,
      aux_sym_type_case_repeat1,
  [57732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1205), 1,
      anon_sym_RPAREN,
    ACTIONS(1207), 1,
      anon_sym_COMMA,
    STATE(1154), 1,
      aux_sym_argument_list_repeat1,
  [57745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
    ACTIONS(2541), 1,
      anon_sym_COMMA,
    STATE(1226), 1,
      aux_sym_parameter_list_repeat1,
  [57758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_COMMA,
    ACTIONS(2545), 1,
      anon_sym_RBRACK,
    STATE(1151), 1,
      aux_sym_type_case_repeat1,
  [57771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_LPAREN,
    STATE(980), 1,
      sym_const_spec,
  [57784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
    ACTIONS(2549), 1,
      anon_sym_COMMA,
    STATE(1226), 1,
      aux_sym_parameter_list_repeat1,
  [57797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_COMMA,
    ACTIONS(2527), 1,
      anon_sym_RBRACE,
    STATE(1148), 1,
      aux_sym_literal_value_repeat1,
  [57810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    ACTIONS(2551), 1,
      anon_sym_COMMA,
    STATE(1226), 1,
      aux_sym_parameter_list_repeat1,
  [57823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_COMMA,
    ACTIONS(2556), 1,
      anon_sym_RBRACK,
    STATE(1141), 1,
      aux_sym_type_arguments_repeat1,
  [57836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    ACTIONS(2560), 1,
      anon_sym_RBRACK,
    STATE(1146), 1,
      aux_sym_type_arguments_repeat1,
  [57849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_RPAREN,
    ACTIONS(2564), 1,
      anon_sym_COMMA,
    STATE(1144), 1,
      aux_sym_expression_list_repeat1,
  [57862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 1,
      anon_sym_RPAREN,
    ACTIONS(2566), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [57875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      anon_sym_COLON,
    ACTIONS(2568), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 1,
      anon_sym_RBRACK,
    ACTIONS(2570), 1,
      anon_sym_COMMA,
    STATE(1141), 1,
      aux_sym_type_arguments_repeat1,
  [57899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 1,
      sym_identifier,
    ACTIONS(2572), 1,
      anon_sym_LPAREN,
    STATE(991), 1,
      sym_var_spec,
  [57912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_RBRACE,
    ACTIONS(2574), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [57925] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_LF,
    ACTIONS(2485), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
    ACTIONS(2578), 1,
      anon_sym_COMMA,
    STATE(1138), 1,
      aux_sym_parameter_list_repeat1,
  [57949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 1,
      anon_sym_RBRACK,
    ACTIONS(2580), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [57962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(2582), 1,
      sym_identifier,
    STATE(599), 1,
      sym_parameter_list,
  [57975] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_LF,
    ACTIONS(2464), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [57986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(407), 1,
      anon_sym_RPAREN,
    ACTIONS(2584), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [57999] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_LF,
    ACTIONS(2531), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58019] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2360), 1,
      anon_sym_LF,
    ACTIONS(2362), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      anon_sym_RBRACE,
    ACTIONS(2586), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [58043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
    ACTIONS(1203), 1,
      anon_sym_COMMA,
    STATE(1223), 1,
      aux_sym_argument_list_repeat1,
  [58056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [58065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_COMMA,
    ACTIONS(2591), 1,
      anon_sym_RBRACK,
    STATE(1215), 1,
      aux_sym_type_case_repeat1,
  [58078] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2368), 1,
      anon_sym_LF,
    ACTIONS(2370), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_LBRACE,
    ACTIONS(2593), 1,
      anon_sym_COMMA,
    STATE(1163), 1,
      aux_sym_expression_list_repeat1,
  [58102] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2442), 1,
      anon_sym_LF,
    ACTIONS(2444), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_COMMA,
    ACTIONS(2598), 1,
      anon_sym_COLON,
    STATE(1224), 1,
      aux_sym_type_case_repeat1,
  [58126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 1,
      anon_sym_RPAREN,
    ACTIONS(2600), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 1,
      anon_sym_COMMA,
    ACTIONS(2413), 1,
      anon_sym_RBRACE,
    STATE(1212), 1,
      aux_sym_literal_value_repeat1,
  [58152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1241), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [58161] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2356), 1,
      anon_sym_LF,
    ACTIONS(2358), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58172] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2364), 1,
      anon_sym_LF,
    ACTIONS(2366), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58183] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2376), 1,
      anon_sym_LF,
    ACTIONS(2378), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [58203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2603), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    ACTIONS(2605), 1,
      sym_identifier,
    STATE(624), 1,
      sym_parameter_list,
  [58225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(2609), 1,
      anon_sym_RBRACK,
    STATE(1208), 1,
      aux_sym_type_arguments_repeat1,
  [58238] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_LF,
    ACTIONS(2430), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 1,
      anon_sym_COMMA,
    STATE(1206), 1,
      aux_sym_expression_list_repeat1,
  [58262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_DQUOTE,
    ACTIONS(2615), 1,
      sym_raw_string_literal,
    STATE(1113), 1,
      sym_interpreted_string_literal,
  [58275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58293] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_LF,
    ACTIONS(2623), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1748), 1,
      anon_sym_DQUOTE,
    ACTIONS(2625), 1,
      sym_raw_string_literal,
    STATE(1100), 1,
      sym_interpreted_string_literal,
  [58317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_RPAREN,
    ACTIONS(2627), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 1,
      anon_sym_RBRACK,
    ACTIONS(2629), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58343] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2505), 1,
      anon_sym_LF,
    ACTIONS(2507), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(345), 1,
      anon_sym_RBRACE,
    ACTIONS(2631), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [58367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1907), 1,
      anon_sym_LBRACK,
    ACTIONS(2633), 1,
      anon_sym_RPAREN,
  [58380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(483), 1,
      anon_sym_RPAREN,
    ACTIONS(2635), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58393] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_LF,
    ACTIONS(2639), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58404] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2338), 1,
      anon_sym_LF,
    ACTIONS(2340), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58415] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LF,
    ACTIONS(2336), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 1,
      anon_sym_COMMA,
    STATE(1183), 1,
      aux_sym_argument_list_repeat1,
  [58448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_RPAREN,
    ACTIONS(2645), 1,
      anon_sym_COMMA,
    STATE(1205), 1,
      aux_sym_expression_list_repeat1,
  [58461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_COMMA,
    ACTIONS(2649), 1,
      anon_sym_RBRACK,
    STATE(1184), 1,
      aux_sym_type_case_repeat1,
  [58474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 1,
      anon_sym_RPAREN,
    ACTIONS(2653), 1,
      anon_sym_COMMA,
    STATE(1140), 1,
      aux_sym_parameter_list_repeat1,
  [58487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2395), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_RBRACE,
    STATE(1207), 1,
      aux_sym_literal_value_repeat1,
  [58500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2346), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RBRACE,
    STATE(1186), 1,
      aux_sym_literal_value_repeat1,
  [58513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 1,
      anon_sym_COMMA,
    ACTIONS(2657), 1,
      anon_sym_RBRACK,
    STATE(1210), 1,
      aux_sym_type_case_repeat1,
  [58526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym_RPAREN,
    ACTIONS(2661), 1,
      anon_sym_COMMA,
    STATE(1188), 1,
      aux_sym_expression_list_repeat1,
  [58539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
    ACTIONS(1191), 1,
      anon_sym_COMMA,
    STATE(1213), 1,
      aux_sym_argument_list_repeat1,
  [58552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2663), 1,
      sym_raw_string_literal,
    STATE(1130), 1,
      sym_interpreted_string_literal,
  [58565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DQUOTE,
    ACTIONS(2665), 1,
      sym_raw_string_literal,
    STATE(1121), 1,
      sym_interpreted_string_literal,
  [58578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_RPAREN,
    ACTIONS(2667), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_RPAREN,
    ACTIONS(2669), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(527), 1,
      anon_sym_RPAREN,
    ACTIONS(2671), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(359), 1,
      anon_sym_RBRACE,
    ACTIONS(2673), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [58630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 1,
      anon_sym_RBRACK,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    STATE(1141), 1,
      aux_sym_type_arguments_repeat1,
  [58643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 1,
      anon_sym_RBRACK,
    ACTIONS(2677), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_RBRACK,
    ACTIONS(2679), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [58678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(355), 1,
      anon_sym_RBRACE,
    ACTIONS(2683), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [58691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(425), 1,
      anon_sym_RPAREN,
    ACTIONS(2685), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(349), 1,
      anon_sym_RBRACE,
    ACTIONS(2687), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [58717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      anon_sym_RBRACK,
    ACTIONS(2689), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      sym_identifier,
    ACTIONS(2693), 1,
      anon_sym_RBRACK,
    STATE(1285), 1,
      sym_type_parameter_declaration,
  [58743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2695), 1,
      anon_sym_COMMA,
    ACTIONS(2698), 1,
      anon_sym_RBRACK,
    STATE(1217), 1,
      aux_sym_type_parameter_list_repeat1,
  [58756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_RBRACK,
    ACTIONS(2700), 1,
      anon_sym_COMMA,
    STATE(1141), 1,
      aux_sym_type_arguments_repeat1,
  [58769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2702), 1,
      anon_sym_COMMA,
    ACTIONS(2704), 1,
      anon_sym_RBRACK,
    STATE(1217), 1,
      aux_sym_type_parameter_list_repeat1,
  [58782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    ACTIONS(2706), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58795] = 3,
    ACTIONS(291), 1,
      sym_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(2710), 2,
      anon_sym_SEMI,
      anon_sym_NULL,
  [58806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      sym_identifier,
    ACTIONS(2704), 1,
      anon_sym_RBRACK,
    STATE(1285), 1,
      sym_type_parameter_declaration,
  [58819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      anon_sym_RPAREN,
    ACTIONS(2712), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_COMMA,
    ACTIONS(2714), 1,
      anon_sym_COLON,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_COMMA,
    ACTIONS(1555), 1,
      anon_sym_LBRACE,
    STATE(1163), 1,
      aux_sym_expression_list_repeat1,
  [58858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    ACTIONS(2718), 1,
      anon_sym_COMMA,
    STATE(1226), 1,
      aux_sym_parameter_list_repeat1,
  [58871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(385), 1,
      anon_sym_RPAREN,
    ACTIONS(2721), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_argument_list_repeat1,
  [58884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_RPAREN,
    ACTIONS(2723), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_RBRACK,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_type_case_repeat1,
  [58910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 1,
      anon_sym_COMMA,
    ACTIONS(2730), 1,
      anon_sym_RBRACK,
    STATE(1218), 1,
      aux_sym_type_arguments_repeat1,
  [58923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      anon_sym_RPAREN,
    ACTIONS(2732), 1,
      anon_sym_COMMA,
    STATE(1228), 1,
      aux_sym_expression_list_repeat1,
  [58936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
    ACTIONS(1163), 1,
      anon_sym_COMMA,
    STATE(1204), 1,
      aux_sym_argument_list_repeat1,
  [58949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_RPAREN,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    STATE(1220), 1,
      aux_sym_expression_list_repeat1,
  [58962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
    ACTIONS(1199), 1,
      anon_sym_COMMA,
    STATE(1227), 1,
      aux_sym_argument_list_repeat1,
  [58975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_COMMA,
    ACTIONS(2740), 1,
      anon_sym_RBRACK,
    STATE(1219), 1,
      aux_sym_type_parameter_list_repeat1,
  [58988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_RPAREN,
    ACTIONS(2744), 1,
      anon_sym_COMMA,
    STATE(1231), 1,
      aux_sym_expression_list_repeat1,
  [59001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(353), 1,
      anon_sym_RBRACE,
    ACTIONS(2746), 1,
      anon_sym_COMMA,
    STATE(1158), 1,
      aux_sym_literal_value_repeat1,
  [59014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [59023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_COMMA,
    ACTIONS(2452), 1,
      anon_sym_RBRACE,
    STATE(1214), 1,
      aux_sym_literal_value_repeat1,
  [59036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    ACTIONS(2513), 1,
      anon_sym_RBRACE,
    STATE(1237), 1,
      aux_sym_literal_value_repeat1,
  [59049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_RPAREN,
    ACTIONS(2752), 1,
      anon_sym_COMMA,
    STATE(1135), 1,
      aux_sym_parameter_list_repeat1,
  [59062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      anon_sym_LPAREN,
    STATE(399), 1,
      sym_argument_list,
  [59072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_LPAREN,
    ACTIONS(2758), 1,
      anon_sym_LBRACK,
  [59098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym_parameter_list,
  [59108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 1,
      anon_sym_LPAREN,
    ACTIONS(2764), 1,
      anon_sym_LBRACK,
  [59126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_LPAREN,
    ACTIONS(2768), 1,
      anon_sym_LBRACK,
  [59136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 1,
      anon_sym_LPAREN,
    ACTIONS(2772), 1,
      anon_sym_LBRACK,
  [59146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1907), 1,
      anon_sym_LBRACK,
  [59156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [59164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      sym_identifier,
    ACTIONS(2776), 1,
      anon_sym_LPAREN,
  [59174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LPAREN,
    STATE(349), 1,
      sym_argument_list,
  [59184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [59192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(604), 1,
      sym_parameter_list,
  [59202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    STATE(496), 1,
      sym_parameter_list,
  [59220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(440), 1,
      sym_parameter_list,
  [59230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    STATE(879), 1,
      sym_field_declaration_list,
  [59240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_parameter_list,
  [59258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [59266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [59274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [59282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LPAREN,
    STATE(267), 1,
      sym_argument_list,
  [59292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_LBRACE,
    STATE(373), 1,
      sym_literal_value,
  [59302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      sym_identifier,
    ACTIONS(2788), 1,
      anon_sym_LPAREN,
  [59312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACK,
    STATE(815), 1,
      sym_type_arguments,
  [59322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      sym_identifier,
    ACTIONS(2794), 1,
      anon_sym_LPAREN,
  [59332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(457), 1,
      sym_argument_list,
  [59350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [59358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2716), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [59374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(634), 1,
      sym_parameter_list,
  [59384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [59392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      sym_identifier,
    ACTIONS(2802), 1,
      anon_sym_LPAREN,
  [59402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(432), 1,
      sym_parameter_list,
  [59428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2022), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [59436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_literal_value,
  [59446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(625), 1,
      sym_parameter_list,
  [59472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      sym_identifier,
    STATE(1285), 1,
      sym_type_parameter_declaration,
  [59482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_LPAREN,
    STATE(492), 1,
      sym_parameter_list,
  [59492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [59500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_LBRACK,
  [59510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    STATE(383), 1,
      sym_parameter_list,
  [59520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      sym_identifier,
    ACTIONS(2812), 1,
      anon_sym_LPAREN,
  [59530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      sym_identifier,
    ACTIONS(2814), 1,
      anon_sym_LPAREN,
  [59540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(609), 1,
      sym_parameter_list,
  [59550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_LPAREN,
    STATE(448), 1,
      sym_parameter_list,
  [59560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      sym_identifier,
    ACTIONS(2818), 1,
      anon_sym_LPAREN,
  [59570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(426), 1,
      sym_literal_value,
  [59580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_LPAREN,
    STATE(547), 1,
      sym_argument_list,
  [59590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      sym_identifier,
    ACTIONS(2820), 1,
      anon_sym_LPAREN,
  [59600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_literal_value,
  [59610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    STATE(505), 1,
      sym_literal_value,
  [59620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      sym_identifier,
    STATE(1235), 1,
      sym_type_parameter_declaration,
  [59630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2308), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_literal_value,
  [59640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [59648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_LBRACE,
    STATE(1001), 1,
      sym_field_declaration_list,
  [59658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
  [59668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_LBRACE,
    STATE(804), 1,
      sym_field_declaration_list,
  [59686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 2,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [59694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    STATE(384), 1,
      sym_parameter_list,
  [59704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_LBRACE,
    STATE(969), 1,
      sym_block,
  [59714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_LPAREN,
    STATE(447), 1,
      sym_parameter_list,
  [59724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    STATE(311), 1,
      sym_argument_list,
  [59734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2838), 1,
      anon_sym_LPAREN,
  [59752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_RBRACK,
  [59759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
  [59766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_EQ,
  [59773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_RPAREN,
  [59780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 1,
      sym_identifier,
  [59787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_SEMI,
  [59794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_RPAREN,
  [59801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      sym_identifier,
  [59808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_COLON,
  [59815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_RBRACE,
  [59822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_chan,
  [59829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_LBRACE,
  [59836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2864), 1,
      anon_sym_LBRACE,
  [59843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_LBRACE,
  [59850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 1,
      anon_sym_RPAREN,
  [59857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_RBRACK,
  [59864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_COLON_EQ,
  [59871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      anon_sym_LBRACE,
  [59878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_RPAREN,
  [59885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 1,
      anon_sym_RBRACE,
  [59892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 1,
      anon_sym_COLON,
  [59899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_RBRACE,
  [59906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
  [59913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_LBRACE,
  [59920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_LBRACE,
  [59927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_SEMI,
  [59934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2348), 1,
      anon_sym_RBRACE,
  [59941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_LBRACE,
  [59948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      anon_sym_RBRACK,
  [59955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_COLON,
  [59962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      anon_sym_RPAREN,
  [59969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 1,
      anon_sym_RBRACE,
  [59976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_RPAREN,
  [59983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 1,
      anon_sym_RBRACE,
  [59990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_chan,
  [59997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_SEMI,
  [60004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_RBRACE,
  [60011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_chan,
  [60018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_LBRACE,
  [60025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 1,
      anon_sym_LBRACE,
  [60032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 1,
      anon_sym_RPAREN,
  [60039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2916), 1,
      anon_sym_LBRACE,
  [60046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_RPAREN,
  [60053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 1,
      anon_sym_RPAREN,
  [60060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_RPAREN,
  [60067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 1,
      sym_identifier,
  [60074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
  [60081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      ts_builtin_sym_end,
  [60088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 1,
      sym_identifier,
  [60095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 1,
      anon_sym_RBRACE,
  [60102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_LBRACE,
  [60109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      sym_identifier,
  [60116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_RBRACK,
  [60123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 1,
      anon_sym_chan,
  [60130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      anon_sym_RBRACE,
  [60137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_EQ,
  [60144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_RPAREN,
  [60151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      sym_identifier,
  [60158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_RPAREN,
  [60165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 1,
      anon_sym_RPAREN,
  [60172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_LBRACK,
  [60179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_RPAREN,
  [60186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2954), 1,
      sym_identifier,
  [60193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
  [60200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2958), 1,
      sym_identifier,
  [60207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 1,
      anon_sym_RPAREN,
  [60214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 1,
      sym_identifier,
  [60221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_LBRACE,
  [60228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_RPAREN,
  [60235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_RPAREN,
  [60242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_RBRACE,
  [60249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_RPAREN,
  [60256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 1,
      anon_sym_RPAREN,
  [60263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 1,
      anon_sym_RBRACK,
  [60270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      anon_sym_RBRACE,
  [60277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 1,
      anon_sym_RBRACK,
  [60284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 1,
      anon_sym_RBRACK,
  [60291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      sym_identifier,
  [60298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
  [60305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_RBRACE,
  [60312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2980), 1,
      anon_sym_LBRACK,
  [60319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_chan,
  [60326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_LBRACK,
  [60333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2986), 1,
      anon_sym_RBRACE,
  [60340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2988), 1,
      anon_sym_LBRACK,
  [60347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 1,
      anon_sym_chan,
  [60354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2992), 1,
      anon_sym_LBRACK,
  [60361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2994), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(28)] = 0,
  [SMALL_STATE(29)] = 119,
  [SMALL_STATE(30)] = 245,
  [SMALL_STATE(31)] = 371,
  [SMALL_STATE(32)] = 497,
  [SMALL_STATE(33)] = 623,
  [SMALL_STATE(34)] = 749,
  [SMALL_STATE(35)] = 875,
  [SMALL_STATE(36)] = 998,
  [SMALL_STATE(37)] = 1121,
  [SMALL_STATE(38)] = 1244,
  [SMALL_STATE(39)] = 1367,
  [SMALL_STATE(40)] = 1490,
  [SMALL_STATE(41)] = 1613,
  [SMALL_STATE(42)] = 1736,
  [SMALL_STATE(43)] = 1859,
  [SMALL_STATE(44)] = 1982,
  [SMALL_STATE(45)] = 2105,
  [SMALL_STATE(46)] = 2228,
  [SMALL_STATE(47)] = 2351,
  [SMALL_STATE(48)] = 2471,
  [SMALL_STATE(49)] = 2586,
  [SMALL_STATE(50)] = 2703,
  [SMALL_STATE(51)] = 2817,
  [SMALL_STATE(52)] = 2931,
  [SMALL_STATE(53)] = 3045,
  [SMALL_STATE(54)] = 3159,
  [SMALL_STATE(55)] = 3273,
  [SMALL_STATE(56)] = 3387,
  [SMALL_STATE(57)] = 3501,
  [SMALL_STATE(58)] = 3615,
  [SMALL_STATE(59)] = 3729,
  [SMALL_STATE(60)] = 3843,
  [SMALL_STATE(61)] = 3957,
  [SMALL_STATE(62)] = 4071,
  [SMALL_STATE(63)] = 4185,
  [SMALL_STATE(64)] = 4299,
  [SMALL_STATE(65)] = 4413,
  [SMALL_STATE(66)] = 4527,
  [SMALL_STATE(67)] = 4641,
  [SMALL_STATE(68)] = 4755,
  [SMALL_STATE(69)] = 4869,
  [SMALL_STATE(70)] = 4983,
  [SMALL_STATE(71)] = 5097,
  [SMALL_STATE(72)] = 5211,
  [SMALL_STATE(73)] = 5325,
  [SMALL_STATE(74)] = 5439,
  [SMALL_STATE(75)] = 5553,
  [SMALL_STATE(76)] = 5667,
  [SMALL_STATE(77)] = 5781,
  [SMALL_STATE(78)] = 5895,
  [SMALL_STATE(79)] = 6009,
  [SMALL_STATE(80)] = 6123,
  [SMALL_STATE(81)] = 6237,
  [SMALL_STATE(82)] = 6348,
  [SMALL_STATE(83)] = 6459,
  [SMALL_STATE(84)] = 6570,
  [SMALL_STATE(85)] = 6681,
  [SMALL_STATE(86)] = 6792,
  [SMALL_STATE(87)] = 6903,
  [SMALL_STATE(88)] = 7014,
  [SMALL_STATE(89)] = 7125,
  [SMALL_STATE(90)] = 7236,
  [SMALL_STATE(91)] = 7347,
  [SMALL_STATE(92)] = 7458,
  [SMALL_STATE(93)] = 7569,
  [SMALL_STATE(94)] = 7680,
  [SMALL_STATE(95)] = 7791,
  [SMALL_STATE(96)] = 7902,
  [SMALL_STATE(97)] = 8013,
  [SMALL_STATE(98)] = 8124,
  [SMALL_STATE(99)] = 8235,
  [SMALL_STATE(100)] = 8346,
  [SMALL_STATE(101)] = 8457,
  [SMALL_STATE(102)] = 8568,
  [SMALL_STATE(103)] = 8679,
  [SMALL_STATE(104)] = 8790,
  [SMALL_STATE(105)] = 8901,
  [SMALL_STATE(106)] = 9012,
  [SMALL_STATE(107)] = 9123,
  [SMALL_STATE(108)] = 9234,
  [SMALL_STATE(109)] = 9345,
  [SMALL_STATE(110)] = 9456,
  [SMALL_STATE(111)] = 9567,
  [SMALL_STATE(112)] = 9678,
  [SMALL_STATE(113)] = 9789,
  [SMALL_STATE(114)] = 9900,
  [SMALL_STATE(115)] = 10011,
  [SMALL_STATE(116)] = 10122,
  [SMALL_STATE(117)] = 10233,
  [SMALL_STATE(118)] = 10344,
  [SMALL_STATE(119)] = 10455,
  [SMALL_STATE(120)] = 10566,
  [SMALL_STATE(121)] = 10677,
  [SMALL_STATE(122)] = 10788,
  [SMALL_STATE(123)] = 10899,
  [SMALL_STATE(124)] = 11010,
  [SMALL_STATE(125)] = 11121,
  [SMALL_STATE(126)] = 11232,
  [SMALL_STATE(127)] = 11343,
  [SMALL_STATE(128)] = 11454,
  [SMALL_STATE(129)] = 11565,
  [SMALL_STATE(130)] = 11676,
  [SMALL_STATE(131)] = 11784,
  [SMALL_STATE(132)] = 11892,
  [SMALL_STATE(133)] = 12000,
  [SMALL_STATE(134)] = 12108,
  [SMALL_STATE(135)] = 12216,
  [SMALL_STATE(136)] = 12324,
  [SMALL_STATE(137)] = 12432,
  [SMALL_STATE(138)] = 12540,
  [SMALL_STATE(139)] = 12648,
  [SMALL_STATE(140)] = 12756,
  [SMALL_STATE(141)] = 12864,
  [SMALL_STATE(142)] = 12972,
  [SMALL_STATE(143)] = 13080,
  [SMALL_STATE(144)] = 13188,
  [SMALL_STATE(145)] = 13296,
  [SMALL_STATE(146)] = 13404,
  [SMALL_STATE(147)] = 13512,
  [SMALL_STATE(148)] = 13620,
  [SMALL_STATE(149)] = 13728,
  [SMALL_STATE(150)] = 13836,
  [SMALL_STATE(151)] = 13944,
  [SMALL_STATE(152)] = 14052,
  [SMALL_STATE(153)] = 14160,
  [SMALL_STATE(154)] = 14268,
  [SMALL_STATE(155)] = 14376,
  [SMALL_STATE(156)] = 14484,
  [SMALL_STATE(157)] = 14592,
  [SMALL_STATE(158)] = 14700,
  [SMALL_STATE(159)] = 14808,
  [SMALL_STATE(160)] = 14916,
  [SMALL_STATE(161)] = 15024,
  [SMALL_STATE(162)] = 15132,
  [SMALL_STATE(163)] = 15240,
  [SMALL_STATE(164)] = 15348,
  [SMALL_STATE(165)] = 15456,
  [SMALL_STATE(166)] = 15564,
  [SMALL_STATE(167)] = 15672,
  [SMALL_STATE(168)] = 15780,
  [SMALL_STATE(169)] = 15888,
  [SMALL_STATE(170)] = 15996,
  [SMALL_STATE(171)] = 16104,
  [SMALL_STATE(172)] = 16212,
  [SMALL_STATE(173)] = 16320,
  [SMALL_STATE(174)] = 16428,
  [SMALL_STATE(175)] = 16536,
  [SMALL_STATE(176)] = 16644,
  [SMALL_STATE(177)] = 16752,
  [SMALL_STATE(178)] = 16860,
  [SMALL_STATE(179)] = 16968,
  [SMALL_STATE(180)] = 17076,
  [SMALL_STATE(181)] = 17184,
  [SMALL_STATE(182)] = 17292,
  [SMALL_STATE(183)] = 17400,
  [SMALL_STATE(184)] = 17508,
  [SMALL_STATE(185)] = 17616,
  [SMALL_STATE(186)] = 17724,
  [SMALL_STATE(187)] = 17832,
  [SMALL_STATE(188)] = 17940,
  [SMALL_STATE(189)] = 18048,
  [SMALL_STATE(190)] = 18156,
  [SMALL_STATE(191)] = 18264,
  [SMALL_STATE(192)] = 18372,
  [SMALL_STATE(193)] = 18480,
  [SMALL_STATE(194)] = 18588,
  [SMALL_STATE(195)] = 18696,
  [SMALL_STATE(196)] = 18804,
  [SMALL_STATE(197)] = 18912,
  [SMALL_STATE(198)] = 19020,
  [SMALL_STATE(199)] = 19128,
  [SMALL_STATE(200)] = 19236,
  [SMALL_STATE(201)] = 19344,
  [SMALL_STATE(202)] = 19452,
  [SMALL_STATE(203)] = 19560,
  [SMALL_STATE(204)] = 19668,
  [SMALL_STATE(205)] = 19776,
  [SMALL_STATE(206)] = 19884,
  [SMALL_STATE(207)] = 19992,
  [SMALL_STATE(208)] = 20100,
  [SMALL_STATE(209)] = 20208,
  [SMALL_STATE(210)] = 20316,
  [SMALL_STATE(211)] = 20424,
  [SMALL_STATE(212)] = 20532,
  [SMALL_STATE(213)] = 20640,
  [SMALL_STATE(214)] = 20748,
  [SMALL_STATE(215)] = 20856,
  [SMALL_STATE(216)] = 20964,
  [SMALL_STATE(217)] = 21072,
  [SMALL_STATE(218)] = 21180,
  [SMALL_STATE(219)] = 21288,
  [SMALL_STATE(220)] = 21396,
  [SMALL_STATE(221)] = 21504,
  [SMALL_STATE(222)] = 21612,
  [SMALL_STATE(223)] = 21720,
  [SMALL_STATE(224)] = 21828,
  [SMALL_STATE(225)] = 21936,
  [SMALL_STATE(226)] = 22044,
  [SMALL_STATE(227)] = 22152,
  [SMALL_STATE(228)] = 22260,
  [SMALL_STATE(229)] = 22368,
  [SMALL_STATE(230)] = 22476,
  [SMALL_STATE(231)] = 22584,
  [SMALL_STATE(232)] = 22692,
  [SMALL_STATE(233)] = 22800,
  [SMALL_STATE(234)] = 22908,
  [SMALL_STATE(235)] = 23016,
  [SMALL_STATE(236)] = 23116,
  [SMALL_STATE(237)] = 23187,
  [SMALL_STATE(238)] = 23258,
  [SMALL_STATE(239)] = 23346,
  [SMALL_STATE(240)] = 23414,
  [SMALL_STATE(241)] = 23479,
  [SMALL_STATE(242)] = 23534,
  [SMALL_STATE(243)] = 23603,
  [SMALL_STATE(244)] = 23674,
  [SMALL_STATE(245)] = 23739,
  [SMALL_STATE(246)] = 23806,
  [SMALL_STATE(247)] = 23879,
  [SMALL_STATE(248)] = 23933,
  [SMALL_STATE(249)] = 23987,
  [SMALL_STATE(250)] = 24045,
  [SMALL_STATE(251)] = 24099,
  [SMALL_STATE(252)] = 24153,
  [SMALL_STATE(253)] = 24206,
  [SMALL_STATE(254)] = 24259,
  [SMALL_STATE(255)] = 24312,
  [SMALL_STATE(256)] = 24365,
  [SMALL_STATE(257)] = 24418,
  [SMALL_STATE(258)] = 24471,
  [SMALL_STATE(259)] = 24524,
  [SMALL_STATE(260)] = 24577,
  [SMALL_STATE(261)] = 24630,
  [SMALL_STATE(262)] = 24683,
  [SMALL_STATE(263)] = 24736,
  [SMALL_STATE(264)] = 24789,
  [SMALL_STATE(265)] = 24842,
  [SMALL_STATE(266)] = 24895,
  [SMALL_STATE(267)] = 24948,
  [SMALL_STATE(268)] = 25001,
  [SMALL_STATE(269)] = 25054,
  [SMALL_STATE(270)] = 25107,
  [SMALL_STATE(271)] = 25160,
  [SMALL_STATE(272)] = 25213,
  [SMALL_STATE(273)] = 25266,
  [SMALL_STATE(274)] = 25319,
  [SMALL_STATE(275)] = 25410,
  [SMALL_STATE(276)] = 25463,
  [SMALL_STATE(277)] = 25516,
  [SMALL_STATE(278)] = 25607,
  [SMALL_STATE(279)] = 25660,
  [SMALL_STATE(280)] = 25713,
  [SMALL_STATE(281)] = 25766,
  [SMALL_STATE(282)] = 25819,
  [SMALL_STATE(283)] = 25872,
  [SMALL_STATE(284)] = 25925,
  [SMALL_STATE(285)] = 25978,
  [SMALL_STATE(286)] = 26031,
  [SMALL_STATE(287)] = 26084,
  [SMALL_STATE(288)] = 26137,
  [SMALL_STATE(289)] = 26225,
  [SMALL_STATE(290)] = 26296,
  [SMALL_STATE(291)] = 26365,
  [SMALL_STATE(292)] = 26430,
  [SMALL_STATE(293)] = 26493,
  [SMALL_STATE(294)] = 26554,
  [SMALL_STATE(295)] = 26639,
  [SMALL_STATE(296)] = 26700,
  [SMALL_STATE(297)] = 26761,
  [SMALL_STATE(298)] = 26815,
  [SMALL_STATE(299)] = 26864,
  [SMALL_STATE(300)] = 26913,
  [SMALL_STATE(301)] = 26962,
  [SMALL_STATE(302)] = 27011,
  [SMALL_STATE(303)] = 27060,
  [SMALL_STATE(304)] = 27109,
  [SMALL_STATE(305)] = 27158,
  [SMALL_STATE(306)] = 27207,
  [SMALL_STATE(307)] = 27256,
  [SMALL_STATE(308)] = 27305,
  [SMALL_STATE(309)] = 27354,
  [SMALL_STATE(310)] = 27403,
  [SMALL_STATE(311)] = 27452,
  [SMALL_STATE(312)] = 27501,
  [SMALL_STATE(313)] = 27550,
  [SMALL_STATE(314)] = 27599,
  [SMALL_STATE(315)] = 27648,
  [SMALL_STATE(316)] = 27697,
  [SMALL_STATE(317)] = 27746,
  [SMALL_STATE(318)] = 27795,
  [SMALL_STATE(319)] = 27844,
  [SMALL_STATE(320)] = 27893,
  [SMALL_STATE(321)] = 27942,
  [SMALL_STATE(322)] = 27991,
  [SMALL_STATE(323)] = 28040,
  [SMALL_STATE(324)] = 28089,
  [SMALL_STATE(325)] = 28138,
  [SMALL_STATE(326)] = 28187,
  [SMALL_STATE(327)] = 28236,
  [SMALL_STATE(328)] = 28285,
  [SMALL_STATE(329)] = 28334,
  [SMALL_STATE(330)] = 28383,
  [SMALL_STATE(331)] = 28432,
  [SMALL_STATE(332)] = 28481,
  [SMALL_STATE(333)] = 28530,
  [SMALL_STATE(334)] = 28579,
  [SMALL_STATE(335)] = 28628,
  [SMALL_STATE(336)] = 28677,
  [SMALL_STATE(337)] = 28736,
  [SMALL_STATE(338)] = 28792,
  [SMALL_STATE(339)] = 28860,
  [SMALL_STATE(340)] = 28916,
  [SMALL_STATE(341)] = 28982,
  [SMALL_STATE(342)] = 29040,
  [SMALL_STATE(343)] = 29100,
  [SMALL_STATE(344)] = 29164,
  [SMALL_STATE(345)] = 29213,
  [SMALL_STATE(346)] = 29257,
  [SMALL_STATE(347)] = 29301,
  [SMALL_STATE(348)] = 29345,
  [SMALL_STATE(349)] = 29389,
  [SMALL_STATE(350)] = 29433,
  [SMALL_STATE(351)] = 29477,
  [SMALL_STATE(352)] = 29521,
  [SMALL_STATE(353)] = 29565,
  [SMALL_STATE(354)] = 29609,
  [SMALL_STATE(355)] = 29653,
  [SMALL_STATE(356)] = 29697,
  [SMALL_STATE(357)] = 29741,
  [SMALL_STATE(358)] = 29785,
  [SMALL_STATE(359)] = 29829,
  [SMALL_STATE(360)] = 29873,
  [SMALL_STATE(361)] = 29917,
  [SMALL_STATE(362)] = 29961,
  [SMALL_STATE(363)] = 30005,
  [SMALL_STATE(364)] = 30049,
  [SMALL_STATE(365)] = 30093,
  [SMALL_STATE(366)] = 30137,
  [SMALL_STATE(367)] = 30181,
  [SMALL_STATE(368)] = 30225,
  [SMALL_STATE(369)] = 30269,
  [SMALL_STATE(370)] = 30313,
  [SMALL_STATE(371)] = 30357,
  [SMALL_STATE(372)] = 30401,
  [SMALL_STATE(373)] = 30445,
  [SMALL_STATE(374)] = 30489,
  [SMALL_STATE(375)] = 30533,
  [SMALL_STATE(376)] = 30577,
  [SMALL_STATE(377)] = 30621,
  [SMALL_STATE(378)] = 30665,
  [SMALL_STATE(379)] = 30709,
  [SMALL_STATE(380)] = 30753,
  [SMALL_STATE(381)] = 30797,
  [SMALL_STATE(382)] = 30841,
  [SMALL_STATE(383)] = 30885,
  [SMALL_STATE(384)] = 30956,
  [SMALL_STATE(385)] = 31027,
  [SMALL_STATE(386)] = 31112,
  [SMALL_STATE(387)] = 31164,
  [SMALL_STATE(388)] = 31216,
  [SMALL_STATE(389)] = 31269,
  [SMALL_STATE(390)] = 31314,
  [SMALL_STATE(391)] = 31389,
  [SMALL_STATE(392)] = 31464,
  [SMALL_STATE(393)] = 31504,
  [SMALL_STATE(394)] = 31544,
  [SMALL_STATE(395)] = 31584,
  [SMALL_STATE(396)] = 31624,
  [SMALL_STATE(397)] = 31664,
  [SMALL_STATE(398)] = 31704,
  [SMALL_STATE(399)] = 31744,
  [SMALL_STATE(400)] = 31784,
  [SMALL_STATE(401)] = 31824,
  [SMALL_STATE(402)] = 31864,
  [SMALL_STATE(403)] = 31904,
  [SMALL_STATE(404)] = 31956,
  [SMALL_STATE(405)] = 31996,
  [SMALL_STATE(406)] = 32036,
  [SMALL_STATE(407)] = 32076,
  [SMALL_STATE(408)] = 32116,
  [SMALL_STATE(409)] = 32156,
  [SMALL_STATE(410)] = 32196,
  [SMALL_STATE(411)] = 32236,
  [SMALL_STATE(412)] = 32276,
  [SMALL_STATE(413)] = 32316,
  [SMALL_STATE(414)] = 32356,
  [SMALL_STATE(415)] = 32396,
  [SMALL_STATE(416)] = 32436,
  [SMALL_STATE(417)] = 32476,
  [SMALL_STATE(418)] = 32516,
  [SMALL_STATE(419)] = 32556,
  [SMALL_STATE(420)] = 32596,
  [SMALL_STATE(421)] = 32636,
  [SMALL_STATE(422)] = 32676,
  [SMALL_STATE(423)] = 32716,
  [SMALL_STATE(424)] = 32756,
  [SMALL_STATE(425)] = 32820,
  [SMALL_STATE(426)] = 32860,
  [SMALL_STATE(427)] = 32900,
  [SMALL_STATE(428)] = 32940,
  [SMALL_STATE(429)] = 32980,
  [SMALL_STATE(430)] = 33020,
  [SMALL_STATE(431)] = 33060,
  [SMALL_STATE(432)] = 33100,
  [SMALL_STATE(433)] = 33165,
  [SMALL_STATE(434)] = 33214,
  [SMALL_STATE(435)] = 33267,
  [SMALL_STATE(436)] = 33324,
  [SMALL_STATE(437)] = 33385,
  [SMALL_STATE(438)] = 33448,
  [SMALL_STATE(439)] = 33499,
  [SMALL_STATE(440)] = 33552,
  [SMALL_STATE(441)] = 33617,
  [SMALL_STATE(442)] = 33672,
  [SMALL_STATE(443)] = 33731,
  [SMALL_STATE(444)] = 33788,
  [SMALL_STATE(445)] = 33837,
  [SMALL_STATE(446)] = 33895,
  [SMALL_STATE(447)] = 33945,
  [SMALL_STATE(448)] = 34013,
  [SMALL_STATE(449)] = 34083,
  [SMALL_STATE(450)] = 34153,
  [SMALL_STATE(451)] = 34195,
  [SMALL_STATE(452)] = 34269,
  [SMALL_STATE(453)] = 34339,
  [SMALL_STATE(454)] = 34397,
  [SMALL_STATE(455)] = 34469,
  [SMALL_STATE(456)] = 34527,
  [SMALL_STATE(457)] = 34564,
  [SMALL_STATE(458)] = 34601,
  [SMALL_STATE(459)] = 34638,
  [SMALL_STATE(460)] = 34707,
  [SMALL_STATE(461)] = 34744,
  [SMALL_STATE(462)] = 34781,
  [SMALL_STATE(463)] = 34818,
  [SMALL_STATE(464)] = 34855,
  [SMALL_STATE(465)] = 34892,
  [SMALL_STATE(466)] = 34947,
  [SMALL_STATE(467)] = 34984,
  [SMALL_STATE(468)] = 35021,
  [SMALL_STATE(469)] = 35058,
  [SMALL_STATE(470)] = 35117,
  [SMALL_STATE(471)] = 35154,
  [SMALL_STATE(472)] = 35215,
  [SMALL_STATE(473)] = 35252,
  [SMALL_STATE(474)] = 35289,
  [SMALL_STATE(475)] = 35326,
  [SMALL_STATE(476)] = 35363,
  [SMALL_STATE(477)] = 35432,
  [SMALL_STATE(478)] = 35479,
  [SMALL_STATE(479)] = 35516,
  [SMALL_STATE(480)] = 35553,
  [SMALL_STATE(481)] = 35618,
  [SMALL_STATE(482)] = 35655,
  [SMALL_STATE(483)] = 35692,
  [SMALL_STATE(484)] = 35729,
  [SMALL_STATE(485)] = 35766,
  [SMALL_STATE(486)] = 35803,
  [SMALL_STATE(487)] = 35840,
  [SMALL_STATE(488)] = 35877,
  [SMALL_STATE(489)] = 35914,
  [SMALL_STATE(490)] = 35951,
  [SMALL_STATE(491)] = 35988,
  [SMALL_STATE(492)] = 36057,
  [SMALL_STATE(493)] = 36122,
  [SMALL_STATE(494)] = 36185,
  [SMALL_STATE(495)] = 36236,
  [SMALL_STATE(496)] = 36305,
  [SMALL_STATE(497)] = 36374,
  [SMALL_STATE(498)] = 36411,
  [SMALL_STATE(499)] = 36448,
  [SMALL_STATE(500)] = 36517,
  [SMALL_STATE(501)] = 36554,
  [SMALL_STATE(502)] = 36591,
  [SMALL_STATE(503)] = 36628,
  [SMALL_STATE(504)] = 36665,
  [SMALL_STATE(505)] = 36702,
  [SMALL_STATE(506)] = 36739,
  [SMALL_STATE(507)] = 36776,
  [SMALL_STATE(508)] = 36813,
  [SMALL_STATE(509)] = 36860,
  [SMALL_STATE(510)] = 36926,
  [SMALL_STATE(511)] = 36992,
  [SMALL_STATE(512)] = 37056,
  [SMALL_STATE(513)] = 37120,
  [SMALL_STATE(514)] = 37186,
  [SMALL_STATE(515)] = 37252,
  [SMALL_STATE(516)] = 37318,
  [SMALL_STATE(517)] = 37384,
  [SMALL_STATE(518)] = 37424,
  [SMALL_STATE(519)] = 37476,
  [SMALL_STATE(520)] = 37542,
  [SMALL_STATE(521)] = 37608,
  [SMALL_STATE(522)] = 37674,
  [SMALL_STATE(523)] = 37740,
  [SMALL_STATE(524)] = 37806,
  [SMALL_STATE(525)] = 37854,
  [SMALL_STATE(526)] = 37920,
  [SMALL_STATE(527)] = 37986,
  [SMALL_STATE(528)] = 38051,
  [SMALL_STATE(529)] = 38086,
  [SMALL_STATE(530)] = 38121,
  [SMALL_STATE(531)] = 38184,
  [SMALL_STATE(532)] = 38219,
  [SMALL_STATE(533)] = 38254,
  [SMALL_STATE(534)] = 38303,
  [SMALL_STATE(535)] = 38356,
  [SMALL_STATE(536)] = 38391,
  [SMALL_STATE(537)] = 38426,
  [SMALL_STATE(538)] = 38461,
  [SMALL_STATE(539)] = 38496,
  [SMALL_STATE(540)] = 38551,
  [SMALL_STATE(541)] = 38608,
  [SMALL_STATE(542)] = 38643,
  [SMALL_STATE(543)] = 38678,
  [SMALL_STATE(544)] = 38713,
  [SMALL_STATE(545)] = 38748,
  [SMALL_STATE(546)] = 38783,
  [SMALL_STATE(547)] = 38846,
  [SMALL_STATE(548)] = 38881,
  [SMALL_STATE(549)] = 38946,
  [SMALL_STATE(550)] = 38981,
  [SMALL_STATE(551)] = 39016,
  [SMALL_STATE(552)] = 39051,
  [SMALL_STATE(553)] = 39114,
  [SMALL_STATE(554)] = 39149,
  [SMALL_STATE(555)] = 39212,
  [SMALL_STATE(556)] = 39275,
  [SMALL_STATE(557)] = 39310,
  [SMALL_STATE(558)] = 39345,
  [SMALL_STATE(559)] = 39380,
  [SMALL_STATE(560)] = 39443,
  [SMALL_STATE(561)] = 39478,
  [SMALL_STATE(562)] = 39513,
  [SMALL_STATE(563)] = 39548,
  [SMALL_STATE(564)] = 39583,
  [SMALL_STATE(565)] = 39618,
  [SMALL_STATE(566)] = 39681,
  [SMALL_STATE(567)] = 39716,
  [SMALL_STATE(568)] = 39751,
  [SMALL_STATE(569)] = 39810,
  [SMALL_STATE(570)] = 39873,
  [SMALL_STATE(571)] = 39926,
  [SMALL_STATE(572)] = 39961,
  [SMALL_STATE(573)] = 40016,
  [SMALL_STATE(574)] = 40079,
  [SMALL_STATE(575)] = 40124,
  [SMALL_STATE(576)] = 40187,
  [SMALL_STATE(577)] = 40222,
  [SMALL_STATE(578)] = 40283,
  [SMALL_STATE(579)] = 40346,
  [SMALL_STATE(580)] = 40409,
  [SMALL_STATE(581)] = 40444,
  [SMALL_STATE(582)] = 40501,
  [SMALL_STATE(583)] = 40536,
  [SMALL_STATE(584)] = 40601,
  [SMALL_STATE(585)] = 40636,
  [SMALL_STATE(586)] = 40671,
  [SMALL_STATE(587)] = 40706,
  [SMALL_STATE(588)] = 40741,
  [SMALL_STATE(589)] = 40776,
  [SMALL_STATE(590)] = 40841,
  [SMALL_STATE(591)] = 40890,
  [SMALL_STATE(592)] = 40925,
  [SMALL_STATE(593)] = 40987,
  [SMALL_STATE(594)] = 41047,
  [SMALL_STATE(595)] = 41107,
  [SMALL_STATE(596)] = 41167,
  [SMALL_STATE(597)] = 41231,
  [SMALL_STATE(598)] = 41295,
  [SMALL_STATE(599)] = 41355,
  [SMALL_STATE(600)] = 41417,
  [SMALL_STATE(601)] = 41479,
  [SMALL_STATE(602)] = 41539,
  [SMALL_STATE(603)] = 41601,
  [SMALL_STATE(604)] = 41663,
  [SMALL_STATE(605)] = 41725,
  [SMALL_STATE(606)] = 41785,
  [SMALL_STATE(607)] = 41845,
  [SMALL_STATE(608)] = 41905,
  [SMALL_STATE(609)] = 41965,
  [SMALL_STATE(610)] = 42027,
  [SMALL_STATE(611)] = 42087,
  [SMALL_STATE(612)] = 42147,
  [SMALL_STATE(613)] = 42207,
  [SMALL_STATE(614)] = 42267,
  [SMALL_STATE(615)] = 42329,
  [SMALL_STATE(616)] = 42389,
  [SMALL_STATE(617)] = 42449,
  [SMALL_STATE(618)] = 42509,
  [SMALL_STATE(619)] = 42569,
  [SMALL_STATE(620)] = 42627,
  [SMALL_STATE(621)] = 42687,
  [SMALL_STATE(622)] = 42747,
  [SMALL_STATE(623)] = 42805,
  [SMALL_STATE(624)] = 42863,
  [SMALL_STATE(625)] = 42925,
  [SMALL_STATE(626)] = 42987,
  [SMALL_STATE(627)] = 43047,
  [SMALL_STATE(628)] = 43107,
  [SMALL_STATE(629)] = 43169,
  [SMALL_STATE(630)] = 43231,
  [SMALL_STATE(631)] = 43291,
  [SMALL_STATE(632)] = 43351,
  [SMALL_STATE(633)] = 43411,
  [SMALL_STATE(634)] = 43471,
  [SMALL_STATE(635)] = 43533,
  [SMALL_STATE(636)] = 43595,
  [SMALL_STATE(637)] = 43655,
  [SMALL_STATE(638)] = 43712,
  [SMALL_STATE(639)] = 43771,
  [SMALL_STATE(640)] = 43828,
  [SMALL_STATE(641)] = 43885,
  [SMALL_STATE(642)] = 43942,
  [SMALL_STATE(643)] = 44001,
  [SMALL_STATE(644)] = 44058,
  [SMALL_STATE(645)] = 44117,
  [SMALL_STATE(646)] = 44174,
  [SMALL_STATE(647)] = 44233,
  [SMALL_STATE(648)] = 44292,
  [SMALL_STATE(649)] = 44351,
  [SMALL_STATE(650)] = 44410,
  [SMALL_STATE(651)] = 44467,
  [SMALL_STATE(652)] = 44526,
  [SMALL_STATE(653)] = 44585,
  [SMALL_STATE(654)] = 44644,
  [SMALL_STATE(655)] = 44703,
  [SMALL_STATE(656)] = 44760,
  [SMALL_STATE(657)] = 44817,
  [SMALL_STATE(658)] = 44874,
  [SMALL_STATE(659)] = 44931,
  [SMALL_STATE(660)] = 44988,
  [SMALL_STATE(661)] = 45045,
  [SMALL_STATE(662)] = 45102,
  [SMALL_STATE(663)] = 45159,
  [SMALL_STATE(664)] = 45216,
  [SMALL_STATE(665)] = 45275,
  [SMALL_STATE(666)] = 45334,
  [SMALL_STATE(667)] = 45391,
  [SMALL_STATE(668)] = 45448,
  [SMALL_STATE(669)] = 45507,
  [SMALL_STATE(670)] = 45564,
  [SMALL_STATE(671)] = 45623,
  [SMALL_STATE(672)] = 45682,
  [SMALL_STATE(673)] = 45741,
  [SMALL_STATE(674)] = 45798,
  [SMALL_STATE(675)] = 45857,
  [SMALL_STATE(676)] = 45914,
  [SMALL_STATE(677)] = 45973,
  [SMALL_STATE(678)] = 46032,
  [SMALL_STATE(679)] = 46089,
  [SMALL_STATE(680)] = 46146,
  [SMALL_STATE(681)] = 46205,
  [SMALL_STATE(682)] = 46264,
  [SMALL_STATE(683)] = 46321,
  [SMALL_STATE(684)] = 46380,
  [SMALL_STATE(685)] = 46439,
  [SMALL_STATE(686)] = 46496,
  [SMALL_STATE(687)] = 46553,
  [SMALL_STATE(688)] = 46612,
  [SMALL_STATE(689)] = 46669,
  [SMALL_STATE(690)] = 46726,
  [SMALL_STATE(691)] = 46785,
  [SMALL_STATE(692)] = 46842,
  [SMALL_STATE(693)] = 46899,
  [SMALL_STATE(694)] = 46955,
  [SMALL_STATE(695)] = 47011,
  [SMALL_STATE(696)] = 47067,
  [SMALL_STATE(697)] = 47123,
  [SMALL_STATE(698)] = 47179,
  [SMALL_STATE(699)] = 47235,
  [SMALL_STATE(700)] = 47291,
  [SMALL_STATE(701)] = 47347,
  [SMALL_STATE(702)] = 47403,
  [SMALL_STATE(703)] = 47459,
  [SMALL_STATE(704)] = 47515,
  [SMALL_STATE(705)] = 47571,
  [SMALL_STATE(706)] = 47627,
  [SMALL_STATE(707)] = 47683,
  [SMALL_STATE(708)] = 47739,
  [SMALL_STATE(709)] = 47795,
  [SMALL_STATE(710)] = 47851,
  [SMALL_STATE(711)] = 47907,
  [SMALL_STATE(712)] = 47961,
  [SMALL_STATE(713)] = 48017,
  [SMALL_STATE(714)] = 48073,
  [SMALL_STATE(715)] = 48129,
  [SMALL_STATE(716)] = 48185,
  [SMALL_STATE(717)] = 48241,
  [SMALL_STATE(718)] = 48297,
  [SMALL_STATE(719)] = 48353,
  [SMALL_STATE(720)] = 48409,
  [SMALL_STATE(721)] = 48465,
  [SMALL_STATE(722)] = 48521,
  [SMALL_STATE(723)] = 48577,
  [SMALL_STATE(724)] = 48633,
  [SMALL_STATE(725)] = 48689,
  [SMALL_STATE(726)] = 48745,
  [SMALL_STATE(727)] = 48801,
  [SMALL_STATE(728)] = 48857,
  [SMALL_STATE(729)] = 48913,
  [SMALL_STATE(730)] = 48969,
  [SMALL_STATE(731)] = 49025,
  [SMALL_STATE(732)] = 49081,
  [SMALL_STATE(733)] = 49137,
  [SMALL_STATE(734)] = 49193,
  [SMALL_STATE(735)] = 49249,
  [SMALL_STATE(736)] = 49305,
  [SMALL_STATE(737)] = 49361,
  [SMALL_STATE(738)] = 49417,
  [SMALL_STATE(739)] = 49473,
  [SMALL_STATE(740)] = 49529,
  [SMALL_STATE(741)] = 49585,
  [SMALL_STATE(742)] = 49641,
  [SMALL_STATE(743)] = 49697,
  [SMALL_STATE(744)] = 49753,
  [SMALL_STATE(745)] = 49809,
  [SMALL_STATE(746)] = 49865,
  [SMALL_STATE(747)] = 49921,
  [SMALL_STATE(748)] = 49977,
  [SMALL_STATE(749)] = 50033,
  [SMALL_STATE(750)] = 50089,
  [SMALL_STATE(751)] = 50145,
  [SMALL_STATE(752)] = 50201,
  [SMALL_STATE(753)] = 50257,
  [SMALL_STATE(754)] = 50313,
  [SMALL_STATE(755)] = 50369,
  [SMALL_STATE(756)] = 50425,
  [SMALL_STATE(757)] = 50481,
  [SMALL_STATE(758)] = 50537,
  [SMALL_STATE(759)] = 50593,
  [SMALL_STATE(760)] = 50649,
  [SMALL_STATE(761)] = 50705,
  [SMALL_STATE(762)] = 50761,
  [SMALL_STATE(763)] = 50817,
  [SMALL_STATE(764)] = 50873,
  [SMALL_STATE(765)] = 50929,
  [SMALL_STATE(766)] = 50985,
  [SMALL_STATE(767)] = 51041,
  [SMALL_STATE(768)] = 51097,
  [SMALL_STATE(769)] = 51153,
  [SMALL_STATE(770)] = 51209,
  [SMALL_STATE(771)] = 51265,
  [SMALL_STATE(772)] = 51321,
  [SMALL_STATE(773)] = 51377,
  [SMALL_STATE(774)] = 51433,
  [SMALL_STATE(775)] = 51489,
  [SMALL_STATE(776)] = 51519,
  [SMALL_STATE(777)] = 51549,
  [SMALL_STATE(778)] = 51579,
  [SMALL_STATE(779)] = 51609,
  [SMALL_STATE(780)] = 51641,
  [SMALL_STATE(781)] = 51668,
  [SMALL_STATE(782)] = 51694,
  [SMALL_STATE(783)] = 51720,
  [SMALL_STATE(784)] = 51746,
  [SMALL_STATE(785)] = 51772,
  [SMALL_STATE(786)] = 51796,
  [SMALL_STATE(787)] = 51820,
  [SMALL_STATE(788)] = 51844,
  [SMALL_STATE(789)] = 51868,
  [SMALL_STATE(790)] = 51893,
  [SMALL_STATE(791)] = 51918,
  [SMALL_STATE(792)] = 51946,
  [SMALL_STATE(793)] = 51974,
  [SMALL_STATE(794)] = 52000,
  [SMALL_STATE(795)] = 52025,
  [SMALL_STATE(796)] = 52048,
  [SMALL_STATE(797)] = 52069,
  [SMALL_STATE(798)] = 52094,
  [SMALL_STATE(799)] = 52115,
  [SMALL_STATE(800)] = 52136,
  [SMALL_STATE(801)] = 52161,
  [SMALL_STATE(802)] = 52186,
  [SMALL_STATE(803)] = 52207,
  [SMALL_STATE(804)] = 52228,
  [SMALL_STATE(805)] = 52248,
  [SMALL_STATE(806)] = 52268,
  [SMALL_STATE(807)] = 52288,
  [SMALL_STATE(808)] = 52308,
  [SMALL_STATE(809)] = 52328,
  [SMALL_STATE(810)] = 52348,
  [SMALL_STATE(811)] = 52368,
  [SMALL_STATE(812)] = 52388,
  [SMALL_STATE(813)] = 52408,
  [SMALL_STATE(814)] = 52428,
  [SMALL_STATE(815)] = 52448,
  [SMALL_STATE(816)] = 52468,
  [SMALL_STATE(817)] = 52488,
  [SMALL_STATE(818)] = 52508,
  [SMALL_STATE(819)] = 52528,
  [SMALL_STATE(820)] = 52548,
  [SMALL_STATE(821)] = 52568,
  [SMALL_STATE(822)] = 52588,
  [SMALL_STATE(823)] = 52608,
  [SMALL_STATE(824)] = 52628,
  [SMALL_STATE(825)] = 52648,
  [SMALL_STATE(826)] = 52668,
  [SMALL_STATE(827)] = 52688,
  [SMALL_STATE(828)] = 52708,
  [SMALL_STATE(829)] = 52728,
  [SMALL_STATE(830)] = 52748,
  [SMALL_STATE(831)] = 52768,
  [SMALL_STATE(832)] = 52788,
  [SMALL_STATE(833)] = 52808,
  [SMALL_STATE(834)] = 52831,
  [SMALL_STATE(835)] = 52850,
  [SMALL_STATE(836)] = 52869,
  [SMALL_STATE(837)] = 52888,
  [SMALL_STATE(838)] = 52908,
  [SMALL_STATE(839)] = 52930,
  [SMALL_STATE(840)] = 52960,
  [SMALL_STATE(841)] = 52992,
  [SMALL_STATE(842)] = 53024,
  [SMALL_STATE(843)] = 53052,
  [SMALL_STATE(844)] = 53083,
  [SMALL_STATE(845)] = 53098,
  [SMALL_STATE(846)] = 53129,
  [SMALL_STATE(847)] = 53144,
  [SMALL_STATE(848)] = 53175,
  [SMALL_STATE(849)] = 53194,
  [SMALL_STATE(850)] = 53209,
  [SMALL_STATE(851)] = 53224,
  [SMALL_STATE(852)] = 53255,
  [SMALL_STATE(853)] = 53270,
  [SMALL_STATE(854)] = 53285,
  [SMALL_STATE(855)] = 53316,
  [SMALL_STATE(856)] = 53331,
  [SMALL_STATE(857)] = 53346,
  [SMALL_STATE(858)] = 53361,
  [SMALL_STATE(859)] = 53376,
  [SMALL_STATE(860)] = 53391,
  [SMALL_STATE(861)] = 53422,
  [SMALL_STATE(862)] = 53445,
  [SMALL_STATE(863)] = 53460,
  [SMALL_STATE(864)] = 53475,
  [SMALL_STATE(865)] = 53490,
  [SMALL_STATE(866)] = 53505,
  [SMALL_STATE(867)] = 53520,
  [SMALL_STATE(868)] = 53547,
  [SMALL_STATE(869)] = 53562,
  [SMALL_STATE(870)] = 53577,
  [SMALL_STATE(871)] = 53592,
  [SMALL_STATE(872)] = 53607,
  [SMALL_STATE(873)] = 53622,
  [SMALL_STATE(874)] = 53637,
  [SMALL_STATE(875)] = 53652,
  [SMALL_STATE(876)] = 53667,
  [SMALL_STATE(877)] = 53682,
  [SMALL_STATE(878)] = 53697,
  [SMALL_STATE(879)] = 53724,
  [SMALL_STATE(880)] = 53739,
  [SMALL_STATE(881)] = 53767,
  [SMALL_STATE(882)] = 53787,
  [SMALL_STATE(883)] = 53815,
  [SMALL_STATE(884)] = 53837,
  [SMALL_STATE(885)] = 53865,
  [SMALL_STATE(886)] = 53893,
  [SMALL_STATE(887)] = 53921,
  [SMALL_STATE(888)] = 53949,
  [SMALL_STATE(889)] = 53977,
  [SMALL_STATE(890)] = 54005,
  [SMALL_STATE(891)] = 54033,
  [SMALL_STATE(892)] = 54053,
  [SMALL_STATE(893)] = 54081,
  [SMALL_STATE(894)] = 54099,
  [SMALL_STATE(895)] = 54117,
  [SMALL_STATE(896)] = 54139,
  [SMALL_STATE(897)] = 54164,
  [SMALL_STATE(898)] = 54183,
  [SMALL_STATE(899)] = 54202,
  [SMALL_STATE(900)] = 54219,
  [SMALL_STATE(901)] = 54238,
  [SMALL_STATE(902)] = 54255,
  [SMALL_STATE(903)] = 54276,
  [SMALL_STATE(904)] = 54297,
  [SMALL_STATE(905)] = 54314,
  [SMALL_STATE(906)] = 54335,
  [SMALL_STATE(907)] = 54356,
  [SMALL_STATE(908)] = 54377,
  [SMALL_STATE(909)] = 54394,
  [SMALL_STATE(910)] = 54411,
  [SMALL_STATE(911)] = 54430,
  [SMALL_STATE(912)] = 54447,
  [SMALL_STATE(913)] = 54466,
  [SMALL_STATE(914)] = 54480,
  [SMALL_STATE(915)] = 54494,
  [SMALL_STATE(916)] = 54508,
  [SMALL_STATE(917)] = 54526,
  [SMALL_STATE(918)] = 54540,
  [SMALL_STATE(919)] = 54554,
  [SMALL_STATE(920)] = 54568,
  [SMALL_STATE(921)] = 54580,
  [SMALL_STATE(922)] = 54594,
  [SMALL_STATE(923)] = 54614,
  [SMALL_STATE(924)] = 54632,
  [SMALL_STATE(925)] = 54650,
  [SMALL_STATE(926)] = 54664,
  [SMALL_STATE(927)] = 54678,
  [SMALL_STATE(928)] = 54692,
  [SMALL_STATE(929)] = 54706,
  [SMALL_STATE(930)] = 54724,
  [SMALL_STATE(931)] = 54738,
  [SMALL_STATE(932)] = 54752,
  [SMALL_STATE(933)] = 54766,
  [SMALL_STATE(934)] = 54780,
  [SMALL_STATE(935)] = 54794,
  [SMALL_STATE(936)] = 54808,
  [SMALL_STATE(937)] = 54826,
  [SMALL_STATE(938)] = 54840,
  [SMALL_STATE(939)] = 54854,
  [SMALL_STATE(940)] = 54868,
  [SMALL_STATE(941)] = 54886,
  [SMALL_STATE(942)] = 54900,
  [SMALL_STATE(943)] = 54918,
  [SMALL_STATE(944)] = 54932,
  [SMALL_STATE(945)] = 54946,
  [SMALL_STATE(946)] = 54960,
  [SMALL_STATE(947)] = 54974,
  [SMALL_STATE(948)] = 54988,
  [SMALL_STATE(949)] = 55002,
  [SMALL_STATE(950)] = 55016,
  [SMALL_STATE(951)] = 55030,
  [SMALL_STATE(952)] = 55044,
  [SMALL_STATE(953)] = 55058,
  [SMALL_STATE(954)] = 55072,
  [SMALL_STATE(955)] = 55090,
  [SMALL_STATE(956)] = 55104,
  [SMALL_STATE(957)] = 55118,
  [SMALL_STATE(958)] = 55132,
  [SMALL_STATE(959)] = 55146,
  [SMALL_STATE(960)] = 55160,
  [SMALL_STATE(961)] = 55174,
  [SMALL_STATE(962)] = 55192,
  [SMALL_STATE(963)] = 55206,
  [SMALL_STATE(964)] = 55224,
  [SMALL_STATE(965)] = 55246,
  [SMALL_STATE(966)] = 55264,
  [SMALL_STATE(967)] = 55282,
  [SMALL_STATE(968)] = 55300,
  [SMALL_STATE(969)] = 55314,
  [SMALL_STATE(970)] = 55328,
  [SMALL_STATE(971)] = 55342,
  [SMALL_STATE(972)] = 55356,
  [SMALL_STATE(973)] = 55370,
  [SMALL_STATE(974)] = 55384,
  [SMALL_STATE(975)] = 55402,
  [SMALL_STATE(976)] = 55416,
  [SMALL_STATE(977)] = 55430,
  [SMALL_STATE(978)] = 55448,
  [SMALL_STATE(979)] = 55462,
  [SMALL_STATE(980)] = 55480,
  [SMALL_STATE(981)] = 55494,
  [SMALL_STATE(982)] = 55512,
  [SMALL_STATE(983)] = 55526,
  [SMALL_STATE(984)] = 55544,
  [SMALL_STATE(985)] = 55558,
  [SMALL_STATE(986)] = 55576,
  [SMALL_STATE(987)] = 55594,
  [SMALL_STATE(988)] = 55608,
  [SMALL_STATE(989)] = 55622,
  [SMALL_STATE(990)] = 55636,
  [SMALL_STATE(991)] = 55650,
  [SMALL_STATE(992)] = 55664,
  [SMALL_STATE(993)] = 55682,
  [SMALL_STATE(994)] = 55696,
  [SMALL_STATE(995)] = 55710,
  [SMALL_STATE(996)] = 55724,
  [SMALL_STATE(997)] = 55738,
  [SMALL_STATE(998)] = 55752,
  [SMALL_STATE(999)] = 55766,
  [SMALL_STATE(1000)] = 55780,
  [SMALL_STATE(1001)] = 55794,
  [SMALL_STATE(1002)] = 55808,
  [SMALL_STATE(1003)] = 55822,
  [SMALL_STATE(1004)] = 55836,
  [SMALL_STATE(1005)] = 55850,
  [SMALL_STATE(1006)] = 55872,
  [SMALL_STATE(1007)] = 55886,
  [SMALL_STATE(1008)] = 55900,
  [SMALL_STATE(1009)] = 55918,
  [SMALL_STATE(1010)] = 55936,
  [SMALL_STATE(1011)] = 55950,
  [SMALL_STATE(1012)] = 55964,
  [SMALL_STATE(1013)] = 55978,
  [SMALL_STATE(1014)] = 55992,
  [SMALL_STATE(1015)] = 56006,
  [SMALL_STATE(1016)] = 56020,
  [SMALL_STATE(1017)] = 56034,
  [SMALL_STATE(1018)] = 56051,
  [SMALL_STATE(1019)] = 56068,
  [SMALL_STATE(1020)] = 56085,
  [SMALL_STATE(1021)] = 56102,
  [SMALL_STATE(1022)] = 56119,
  [SMALL_STATE(1023)] = 56136,
  [SMALL_STATE(1024)] = 56153,
  [SMALL_STATE(1025)] = 56170,
  [SMALL_STATE(1026)] = 56187,
  [SMALL_STATE(1027)] = 56204,
  [SMALL_STATE(1028)] = 56221,
  [SMALL_STATE(1029)] = 56238,
  [SMALL_STATE(1030)] = 56255,
  [SMALL_STATE(1031)] = 56272,
  [SMALL_STATE(1032)] = 56289,
  [SMALL_STATE(1033)] = 56308,
  [SMALL_STATE(1034)] = 56327,
  [SMALL_STATE(1035)] = 56344,
  [SMALL_STATE(1036)] = 56361,
  [SMALL_STATE(1037)] = 56380,
  [SMALL_STATE(1038)] = 56397,
  [SMALL_STATE(1039)] = 56414,
  [SMALL_STATE(1040)] = 56433,
  [SMALL_STATE(1041)] = 56446,
  [SMALL_STATE(1042)] = 56463,
  [SMALL_STATE(1043)] = 56480,
  [SMALL_STATE(1044)] = 56497,
  [SMALL_STATE(1045)] = 56516,
  [SMALL_STATE(1046)] = 56533,
  [SMALL_STATE(1047)] = 56552,
  [SMALL_STATE(1048)] = 56569,
  [SMALL_STATE(1049)] = 56586,
  [SMALL_STATE(1050)] = 56598,
  [SMALL_STATE(1051)] = 56610,
  [SMALL_STATE(1052)] = 56622,
  [SMALL_STATE(1053)] = 56634,
  [SMALL_STATE(1054)] = 56646,
  [SMALL_STATE(1055)] = 56660,
  [SMALL_STATE(1056)] = 56672,
  [SMALL_STATE(1057)] = 56684,
  [SMALL_STATE(1058)] = 56698,
  [SMALL_STATE(1059)] = 56714,
  [SMALL_STATE(1060)] = 56730,
  [SMALL_STATE(1061)] = 56742,
  [SMALL_STATE(1062)] = 56754,
  [SMALL_STATE(1063)] = 56766,
  [SMALL_STATE(1064)] = 56778,
  [SMALL_STATE(1065)] = 56790,
  [SMALL_STATE(1066)] = 56804,
  [SMALL_STATE(1067)] = 56818,
  [SMALL_STATE(1068)] = 56830,
  [SMALL_STATE(1069)] = 56844,
  [SMALL_STATE(1070)] = 56856,
  [SMALL_STATE(1071)] = 56870,
  [SMALL_STATE(1072)] = 56882,
  [SMALL_STATE(1073)] = 56898,
  [SMALL_STATE(1074)] = 56910,
  [SMALL_STATE(1075)] = 56924,
  [SMALL_STATE(1076)] = 56936,
  [SMALL_STATE(1077)] = 56952,
  [SMALL_STATE(1078)] = 56966,
  [SMALL_STATE(1079)] = 56978,
  [SMALL_STATE(1080)] = 56994,
  [SMALL_STATE(1081)] = 57008,
  [SMALL_STATE(1082)] = 57022,
  [SMALL_STATE(1083)] = 57038,
  [SMALL_STATE(1084)] = 57052,
  [SMALL_STATE(1085)] = 57066,
  [SMALL_STATE(1086)] = 57080,
  [SMALL_STATE(1087)] = 57094,
  [SMALL_STATE(1088)] = 57110,
  [SMALL_STATE(1089)] = 57122,
  [SMALL_STATE(1090)] = 57138,
  [SMALL_STATE(1091)] = 57150,
  [SMALL_STATE(1092)] = 57166,
  [SMALL_STATE(1093)] = 57178,
  [SMALL_STATE(1094)] = 57190,
  [SMALL_STATE(1095)] = 57202,
  [SMALL_STATE(1096)] = 57216,
  [SMALL_STATE(1097)] = 57230,
  [SMALL_STATE(1098)] = 57244,
  [SMALL_STATE(1099)] = 57260,
  [SMALL_STATE(1100)] = 57274,
  [SMALL_STATE(1101)] = 57286,
  [SMALL_STATE(1102)] = 57300,
  [SMALL_STATE(1103)] = 57312,
  [SMALL_STATE(1104)] = 57326,
  [SMALL_STATE(1105)] = 57340,
  [SMALL_STATE(1106)] = 57354,
  [SMALL_STATE(1107)] = 57368,
  [SMALL_STATE(1108)] = 57384,
  [SMALL_STATE(1109)] = 57398,
  [SMALL_STATE(1110)] = 57410,
  [SMALL_STATE(1111)] = 57422,
  [SMALL_STATE(1112)] = 57438,
  [SMALL_STATE(1113)] = 57452,
  [SMALL_STATE(1114)] = 57464,
  [SMALL_STATE(1115)] = 57478,
  [SMALL_STATE(1116)] = 57492,
  [SMALL_STATE(1117)] = 57506,
  [SMALL_STATE(1118)] = 57518,
  [SMALL_STATE(1119)] = 57532,
  [SMALL_STATE(1120)] = 57544,
  [SMALL_STATE(1121)] = 57558,
  [SMALL_STATE(1122)] = 57570,
  [SMALL_STATE(1123)] = 57584,
  [SMALL_STATE(1124)] = 57598,
  [SMALL_STATE(1125)] = 57614,
  [SMALL_STATE(1126)] = 57626,
  [SMALL_STATE(1127)] = 57638,
  [SMALL_STATE(1128)] = 57652,
  [SMALL_STATE(1129)] = 57666,
  [SMALL_STATE(1130)] = 57682,
  [SMALL_STATE(1131)] = 57694,
  [SMALL_STATE(1132)] = 57706,
  [SMALL_STATE(1133)] = 57719,
  [SMALL_STATE(1134)] = 57732,
  [SMALL_STATE(1135)] = 57745,
  [SMALL_STATE(1136)] = 57758,
  [SMALL_STATE(1137)] = 57771,
  [SMALL_STATE(1138)] = 57784,
  [SMALL_STATE(1139)] = 57797,
  [SMALL_STATE(1140)] = 57810,
  [SMALL_STATE(1141)] = 57823,
  [SMALL_STATE(1142)] = 57836,
  [SMALL_STATE(1143)] = 57849,
  [SMALL_STATE(1144)] = 57862,
  [SMALL_STATE(1145)] = 57875,
  [SMALL_STATE(1146)] = 57886,
  [SMALL_STATE(1147)] = 57899,
  [SMALL_STATE(1148)] = 57912,
  [SMALL_STATE(1149)] = 57925,
  [SMALL_STATE(1150)] = 57936,
  [SMALL_STATE(1151)] = 57949,
  [SMALL_STATE(1152)] = 57962,
  [SMALL_STATE(1153)] = 57975,
  [SMALL_STATE(1154)] = 57986,
  [SMALL_STATE(1155)] = 57999,
  [SMALL_STATE(1156)] = 58010,
  [SMALL_STATE(1157)] = 58019,
  [SMALL_STATE(1158)] = 58030,
  [SMALL_STATE(1159)] = 58043,
  [SMALL_STATE(1160)] = 58056,
  [SMALL_STATE(1161)] = 58065,
  [SMALL_STATE(1162)] = 58078,
  [SMALL_STATE(1163)] = 58089,
  [SMALL_STATE(1164)] = 58102,
  [SMALL_STATE(1165)] = 58113,
  [SMALL_STATE(1166)] = 58126,
  [SMALL_STATE(1167)] = 58139,
  [SMALL_STATE(1168)] = 58152,
  [SMALL_STATE(1169)] = 58161,
  [SMALL_STATE(1170)] = 58172,
  [SMALL_STATE(1171)] = 58183,
  [SMALL_STATE(1172)] = 58194,
  [SMALL_STATE(1173)] = 58203,
  [SMALL_STATE(1174)] = 58212,
  [SMALL_STATE(1175)] = 58225,
  [SMALL_STATE(1176)] = 58238,
  [SMALL_STATE(1177)] = 58249,
  [SMALL_STATE(1178)] = 58262,
  [SMALL_STATE(1179)] = 58275,
  [SMALL_STATE(1180)] = 58284,
  [SMALL_STATE(1181)] = 58293,
  [SMALL_STATE(1182)] = 58304,
  [SMALL_STATE(1183)] = 58317,
  [SMALL_STATE(1184)] = 58330,
  [SMALL_STATE(1185)] = 58343,
  [SMALL_STATE(1186)] = 58354,
  [SMALL_STATE(1187)] = 58367,
  [SMALL_STATE(1188)] = 58380,
  [SMALL_STATE(1189)] = 58393,
  [SMALL_STATE(1190)] = 58404,
  [SMALL_STATE(1191)] = 58415,
  [SMALL_STATE(1192)] = 58426,
  [SMALL_STATE(1193)] = 58435,
  [SMALL_STATE(1194)] = 58448,
  [SMALL_STATE(1195)] = 58461,
  [SMALL_STATE(1196)] = 58474,
  [SMALL_STATE(1197)] = 58487,
  [SMALL_STATE(1198)] = 58500,
  [SMALL_STATE(1199)] = 58513,
  [SMALL_STATE(1200)] = 58526,
  [SMALL_STATE(1201)] = 58539,
  [SMALL_STATE(1202)] = 58552,
  [SMALL_STATE(1203)] = 58565,
  [SMALL_STATE(1204)] = 58578,
  [SMALL_STATE(1205)] = 58591,
  [SMALL_STATE(1206)] = 58604,
  [SMALL_STATE(1207)] = 58617,
  [SMALL_STATE(1208)] = 58630,
  [SMALL_STATE(1209)] = 58643,
  [SMALL_STATE(1210)] = 58656,
  [SMALL_STATE(1211)] = 58669,
  [SMALL_STATE(1212)] = 58678,
  [SMALL_STATE(1213)] = 58691,
  [SMALL_STATE(1214)] = 58704,
  [SMALL_STATE(1215)] = 58717,
  [SMALL_STATE(1216)] = 58730,
  [SMALL_STATE(1217)] = 58743,
  [SMALL_STATE(1218)] = 58756,
  [SMALL_STATE(1219)] = 58769,
  [SMALL_STATE(1220)] = 58782,
  [SMALL_STATE(1221)] = 58795,
  [SMALL_STATE(1222)] = 58806,
  [SMALL_STATE(1223)] = 58819,
  [SMALL_STATE(1224)] = 58832,
  [SMALL_STATE(1225)] = 58845,
  [SMALL_STATE(1226)] = 58858,
  [SMALL_STATE(1227)] = 58871,
  [SMALL_STATE(1228)] = 58884,
  [SMALL_STATE(1229)] = 58897,
  [SMALL_STATE(1230)] = 58910,
  [SMALL_STATE(1231)] = 58923,
  [SMALL_STATE(1232)] = 58936,
  [SMALL_STATE(1233)] = 58949,
  [SMALL_STATE(1234)] = 58962,
  [SMALL_STATE(1235)] = 58975,
  [SMALL_STATE(1236)] = 58988,
  [SMALL_STATE(1237)] = 59001,
  [SMALL_STATE(1238)] = 59014,
  [SMALL_STATE(1239)] = 59023,
  [SMALL_STATE(1240)] = 59036,
  [SMALL_STATE(1241)] = 59049,
  [SMALL_STATE(1242)] = 59062,
  [SMALL_STATE(1243)] = 59072,
  [SMALL_STATE(1244)] = 59080,
  [SMALL_STATE(1245)] = 59088,
  [SMALL_STATE(1246)] = 59098,
  [SMALL_STATE(1247)] = 59108,
  [SMALL_STATE(1248)] = 59116,
  [SMALL_STATE(1249)] = 59126,
  [SMALL_STATE(1250)] = 59136,
  [SMALL_STATE(1251)] = 59146,
  [SMALL_STATE(1252)] = 59156,
  [SMALL_STATE(1253)] = 59164,
  [SMALL_STATE(1254)] = 59174,
  [SMALL_STATE(1255)] = 59184,
  [SMALL_STATE(1256)] = 59192,
  [SMALL_STATE(1257)] = 59202,
  [SMALL_STATE(1258)] = 59210,
  [SMALL_STATE(1259)] = 59220,
  [SMALL_STATE(1260)] = 59230,
  [SMALL_STATE(1261)] = 59240,
  [SMALL_STATE(1262)] = 59248,
  [SMALL_STATE(1263)] = 59258,
  [SMALL_STATE(1264)] = 59266,
  [SMALL_STATE(1265)] = 59274,
  [SMALL_STATE(1266)] = 59282,
  [SMALL_STATE(1267)] = 59292,
  [SMALL_STATE(1268)] = 59302,
  [SMALL_STATE(1269)] = 59312,
  [SMALL_STATE(1270)] = 59322,
  [SMALL_STATE(1271)] = 59332,
  [SMALL_STATE(1272)] = 59340,
  [SMALL_STATE(1273)] = 59350,
  [SMALL_STATE(1274)] = 59358,
  [SMALL_STATE(1275)] = 59366,
  [SMALL_STATE(1276)] = 59374,
  [SMALL_STATE(1277)] = 59384,
  [SMALL_STATE(1278)] = 59392,
  [SMALL_STATE(1279)] = 59402,
  [SMALL_STATE(1280)] = 59410,
  [SMALL_STATE(1281)] = 59418,
  [SMALL_STATE(1282)] = 59428,
  [SMALL_STATE(1283)] = 59436,
  [SMALL_STATE(1284)] = 59446,
  [SMALL_STATE(1285)] = 59454,
  [SMALL_STATE(1286)] = 59462,
  [SMALL_STATE(1287)] = 59472,
  [SMALL_STATE(1288)] = 59482,
  [SMALL_STATE(1289)] = 59492,
  [SMALL_STATE(1290)] = 59500,
  [SMALL_STATE(1291)] = 59510,
  [SMALL_STATE(1292)] = 59520,
  [SMALL_STATE(1293)] = 59530,
  [SMALL_STATE(1294)] = 59540,
  [SMALL_STATE(1295)] = 59550,
  [SMALL_STATE(1296)] = 59560,
  [SMALL_STATE(1297)] = 59570,
  [SMALL_STATE(1298)] = 59580,
  [SMALL_STATE(1299)] = 59590,
  [SMALL_STATE(1300)] = 59600,
  [SMALL_STATE(1301)] = 59610,
  [SMALL_STATE(1302)] = 59620,
  [SMALL_STATE(1303)] = 59630,
  [SMALL_STATE(1304)] = 59640,
  [SMALL_STATE(1305)] = 59648,
  [SMALL_STATE(1306)] = 59658,
  [SMALL_STATE(1307)] = 59668,
  [SMALL_STATE(1308)] = 59676,
  [SMALL_STATE(1309)] = 59686,
  [SMALL_STATE(1310)] = 59694,
  [SMALL_STATE(1311)] = 59704,
  [SMALL_STATE(1312)] = 59714,
  [SMALL_STATE(1313)] = 59724,
  [SMALL_STATE(1314)] = 59734,
  [SMALL_STATE(1315)] = 59742,
  [SMALL_STATE(1316)] = 59752,
  [SMALL_STATE(1317)] = 59759,
  [SMALL_STATE(1318)] = 59766,
  [SMALL_STATE(1319)] = 59773,
  [SMALL_STATE(1320)] = 59780,
  [SMALL_STATE(1321)] = 59787,
  [SMALL_STATE(1322)] = 59794,
  [SMALL_STATE(1323)] = 59801,
  [SMALL_STATE(1324)] = 59808,
  [SMALL_STATE(1325)] = 59815,
  [SMALL_STATE(1326)] = 59822,
  [SMALL_STATE(1327)] = 59829,
  [SMALL_STATE(1328)] = 59836,
  [SMALL_STATE(1329)] = 59843,
  [SMALL_STATE(1330)] = 59850,
  [SMALL_STATE(1331)] = 59857,
  [SMALL_STATE(1332)] = 59864,
  [SMALL_STATE(1333)] = 59871,
  [SMALL_STATE(1334)] = 59878,
  [SMALL_STATE(1335)] = 59885,
  [SMALL_STATE(1336)] = 59892,
  [SMALL_STATE(1337)] = 59899,
  [SMALL_STATE(1338)] = 59906,
  [SMALL_STATE(1339)] = 59913,
  [SMALL_STATE(1340)] = 59920,
  [SMALL_STATE(1341)] = 59927,
  [SMALL_STATE(1342)] = 59934,
  [SMALL_STATE(1343)] = 59941,
  [SMALL_STATE(1344)] = 59948,
  [SMALL_STATE(1345)] = 59955,
  [SMALL_STATE(1346)] = 59962,
  [SMALL_STATE(1347)] = 59969,
  [SMALL_STATE(1348)] = 59976,
  [SMALL_STATE(1349)] = 59983,
  [SMALL_STATE(1350)] = 59990,
  [SMALL_STATE(1351)] = 59997,
  [SMALL_STATE(1352)] = 60004,
  [SMALL_STATE(1353)] = 60011,
  [SMALL_STATE(1354)] = 60018,
  [SMALL_STATE(1355)] = 60025,
  [SMALL_STATE(1356)] = 60032,
  [SMALL_STATE(1357)] = 60039,
  [SMALL_STATE(1358)] = 60046,
  [SMALL_STATE(1359)] = 60053,
  [SMALL_STATE(1360)] = 60060,
  [SMALL_STATE(1361)] = 60067,
  [SMALL_STATE(1362)] = 60074,
  [SMALL_STATE(1363)] = 60081,
  [SMALL_STATE(1364)] = 60088,
  [SMALL_STATE(1365)] = 60095,
  [SMALL_STATE(1366)] = 60102,
  [SMALL_STATE(1367)] = 60109,
  [SMALL_STATE(1368)] = 60116,
  [SMALL_STATE(1369)] = 60123,
  [SMALL_STATE(1370)] = 60130,
  [SMALL_STATE(1371)] = 60137,
  [SMALL_STATE(1372)] = 60144,
  [SMALL_STATE(1373)] = 60151,
  [SMALL_STATE(1374)] = 60158,
  [SMALL_STATE(1375)] = 60165,
  [SMALL_STATE(1376)] = 60172,
  [SMALL_STATE(1377)] = 60179,
  [SMALL_STATE(1378)] = 60186,
  [SMALL_STATE(1379)] = 60193,
  [SMALL_STATE(1380)] = 60200,
  [SMALL_STATE(1381)] = 60207,
  [SMALL_STATE(1382)] = 60214,
  [SMALL_STATE(1383)] = 60221,
  [SMALL_STATE(1384)] = 60228,
  [SMALL_STATE(1385)] = 60235,
  [SMALL_STATE(1386)] = 60242,
  [SMALL_STATE(1387)] = 60249,
  [SMALL_STATE(1388)] = 60256,
  [SMALL_STATE(1389)] = 60263,
  [SMALL_STATE(1390)] = 60270,
  [SMALL_STATE(1391)] = 60277,
  [SMALL_STATE(1392)] = 60284,
  [SMALL_STATE(1393)] = 60291,
  [SMALL_STATE(1394)] = 60298,
  [SMALL_STATE(1395)] = 60305,
  [SMALL_STATE(1396)] = 60312,
  [SMALL_STATE(1397)] = 60319,
  [SMALL_STATE(1398)] = 60326,
  [SMALL_STATE(1399)] = 60333,
  [SMALL_STATE(1400)] = 60340,
  [SMALL_STATE(1401)] = 60347,
  [SMALL_STATE(1402)] = 60354,
  [SMALL_STATE(1403)] = 60361,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [77] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(237),
  [80] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1013),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1323),
  [86] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [89] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(160),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1137),
  [95] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1147),
  [98] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1174),
  [101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1128),
  [107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(233),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1260),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(733),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(11),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1379),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1376),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(757),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(205),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(925),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(901),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(909),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1367),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(27),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(21),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(22),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1366),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(249),
  [167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(278),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1104),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(278),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 3, 0, 88),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_communication_case, 3, 0, 88),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 3, 0, 39),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 3, 0, 39),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 2, 0, 0),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_case, 2, 0, 0),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, 0, 102),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 4, 0, 102),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 3, 0, 7),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_case, 3, 0, 7),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 3, 0, 0),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 3, 0, 0),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 2, 0, 0),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 2, 0, 0),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_labeled_statement, 2, 0, 26),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_labeled_statement, 2, 0, 26),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 55),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 86),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 56),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1364),
  [566] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0), SHIFT(713),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [574] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0), SHIFT(53),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(740),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1364),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0),
  [597] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0), SHIFT(649),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1, 0, 0),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 6),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 6),
  [641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 32),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 32),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2, 0, 0),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3, 0, 0),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 3, 0, 22),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 3, 0, 22),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 10),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 10),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 4, 0, 0),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 4, 0, 0),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 4, 0, 0),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 4, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 5, -1, 59),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 5, -1, 59),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 61),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 61),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, 0, 34),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, 0, 34),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, 0, 60),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, 0, 60),
  [705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_instantiation_expression, 5, -1, 19),
  [707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_instantiation_expression, 5, -1, 19),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_instantiation_expression, 4, -1, 19),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_instantiation_expression, 4, -1, 19),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 4, -1, 59),
  [719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 4, -1, 59),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion_expression, 5, 0, 89),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion_expression, 5, 0, 89),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 36),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 36),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 8, 0, 106),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 8, 0, 106),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, 0, 12),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, 0, 12),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 3, 0, 0),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 3, 0, 0),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, 0, 90),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, 0, 90),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 2, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 2, 0, 0),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, 0, 91),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, 0, 91),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, 0, 13),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, 0, 13),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3, 0, 0),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3, 0, 0),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 7, 0, 103),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 7, 0, 103),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 4, 0, 44),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 4, 0, 44),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, 0, 100),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, 0, 100),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5, 0, 0),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5, 0, 0),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 5, 0, 0),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 5, 0, 0),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_instantiation_expression, 6, -1, 19),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_instantiation_expression, 6, -1, 19),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 2, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 2, 0, 0),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0),
  [834] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), REDUCE(sym__expression, 1, 0, 0), SHIFT(649),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 5),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 5),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, 0, 25),
  [908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, 0, 25),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 2, 0, 17),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 2, 0, 17),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 1, 0, 4),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 1, 0, 4),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, 0, 35),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, 0, 35),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 40),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 40),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, 0, 43),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, 0, 43),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), SHIFT(1380),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 20),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 20),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_statement, 1, 0, 58),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_statement, 2, 0, 0),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_statement, 2, 0, 0),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_elem, 2, 0, 53),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_elem, 2, 0, 53),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_element, 1, 0, 0),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 2, 0, 29),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 4, 0, 84),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_statement, 3, 0, 33),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5, 0, 0),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5, 0, 0),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2, 0, 0),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2, 0, 0),
  [1549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(1320),
  [1552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(143),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, -1, 1),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, -1, 1), SHIFT(651),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(1378),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_parameter_declaration_repeat1, 2, 0, 67),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_declaration_repeat1, 2, 0, 67),
  [1571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_declaration_repeat1, 2, 0, 67), SHIFT_REPEAT(1380),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, 0, 0),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, 0, 0),
  [1588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, 0, 0), SHIFT(651),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 67),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 67),
  [1599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 67), SHIFT_REPEAT(1382),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2, 0, 0),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2, 0, 0),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 4, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 4, 0, 0),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, 0, 7),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, 0, 7),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, 0, 31),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, 0, 31),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 3, 0, 27),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 3, 0, 27),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 2, 0),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 2, 0),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, 0, 80),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, 0, 80),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 5, 0, 0),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 5, 0, 0),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 1, 14),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 1, 14),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 76),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 76),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 21),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 21),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 2, 0),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 2, 0),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [1660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 3, 0, 0),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 3, 0, 0),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_type, 2, 0, 0),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_type, 2, 0, 0),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 1, 11),
  [1676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 1, 11),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 2, 0),
  [1680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 2, 0),
  [1682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, 0, 23),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, 0, 23),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 6, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 6, 0, 0),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 46),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 46),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_parameter_declaration_repeat1, 2, 0, 64),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_declaration_repeat1, 2, 0, 64),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [1704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, -1, 1), SHIFT(649),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 5, 0, 0),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 5, 0, 0),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [1727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, 0, 0), SHIFT(649),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 49),
  [1734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 49),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 39),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 39),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [1776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, 0, 19),
  [1778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, 0, 19),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [1788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(192),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2, 0, 0),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, -1, 1), SHIFT(642),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 1, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 81),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 81),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, 0, 0), SHIFT(642),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1, 0, 0),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 78),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 78),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, 0, 38),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, 0, 38),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 51),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 51),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 28),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 28),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(20),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2, 0, 0), SHIFT_REPEAT(20),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2, 0, 0),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 2, 0, 18),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 2, 0, 18),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 82),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 82),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, 0, 7),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, 0, 7),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 41),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 41),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_statement, 2, 0, 0),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_statement, 2, 0, 0),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_elem, 1, 0, 0),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2, 0, 0),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(719),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1336),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_elem, 2, 0, 0),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_elem, 2, 0, 0),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 1, 0, 0),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallthrough_statement, 1, 0, 0),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 5, 0, 57),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 5, 0, 57),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, 0, 37),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, 0, 37),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4, 0, 0),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 4, 0, 0),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 3, 0, 48),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 3, 0, 48),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 3, 0, 37),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 3, 0, 37),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 3, 0, 47),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 3, 0, 47),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4, 0, 0),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4, 0, 0),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, 0, 87),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, 0, 87),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3, 0, 0),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3, 0, 0),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 5, 0, 92),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 5, 0, 92),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 5, 0, 92),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 5, 0, 92),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4, 0, 0),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4, 0, 0),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3, 0, 0),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3, 0, 0),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_var_declaration, 3, 0, 33),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_var_declaration, 3, 0, 33),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 32),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 32),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, 0, 9),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, 0, 9),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 26),
  [2013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 26),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_elem_repeat1, 2, 0, 0),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_elem_repeat1, 2, 0, 0),
  [2019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_elem_repeat1, 2, 0, 0), SHIFT_REPEAT(707),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1, 0, 0),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1, 0, 0),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2, 0, 0),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 3, 0, 0),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 3, 0, 0),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 72),
  [2050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 72),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 3, 0, 0),
  [2054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 3, 0, 0),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 30),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 30),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, 0, 8),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, 0, 8),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 8),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 8),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, 0, 0),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, 0, 0),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2, 0, 0),
  [2074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1336),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 7, 0, 98),
  [2082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 7, 0, 98),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_elem, 1, 0, 0),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 8),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 8),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2, 0, 0),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2, 0, 0),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 69),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 69),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 4, 0, 57),
  [2102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 4, 0, 57),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, 0, 7),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, 0, 7),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(193),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3, 0, 0),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3, 0, 0),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, 0, 98),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, 0, 98),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 4, 0, 0),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 4, 0, 0),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 2, 0, 0),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 2, 0, 0),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2, 0, 0),
  [2133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [2136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1336),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 101),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 101),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, 0, 24),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 2, 0, 24),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, 0, 63),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, 0, 63),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_statement, 2, 0, 0),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_statement, 2, 0, 0),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, 0, 62),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, 0, 62),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2, 0, 0),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2, 0, 0),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, 0, 87),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, 0, 87),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, 0, 62),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, 0, 62),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, 0, 63),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, 0, 63),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(603),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2, 0, 0),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [2271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2, 0, 0),
  [2276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2, 0, 0), SHIFT_REPEAT(620),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2, 0, 0), SHIFT_REPEAT(620),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2, 0, 0),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(896),
  [2293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(896),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 77),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 77),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, 0, 3),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, 0, 3),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 96),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 96),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 95),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 95),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 94),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 94),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 70),
  [2358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 70),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2, 0, 0),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2, 0, 0),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 71),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 71),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2, 0, 2),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2, 0, 2),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 73),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 73),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 74),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 74),
  [2388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_elem_repeat1, 2, 0, 0), SHIFT_REPEAT(746),
  [2391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 75),
  [2393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 75),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_elem, 3, 0, 79),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_elem, 3, 0, 79),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1083),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2, 0, 0),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 52),
  [2440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 52),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 4, 0, 0),
  [2444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 4, 0, 0),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, 0, 16),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, 0, 16),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3, 0, 0),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3, 0, 0),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [2481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2, 0, 0),
  [2485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2, 0, 0),
  [2487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(583),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2, 0, 0),
  [2492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_case_repeat1, 2, 0, 0), SHIFT_REPEAT(774),
  [2495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_case_repeat1, 2, 0, 0),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, 0, 15),
  [2499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, 0, 15),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 5, 0, 0),
  [2507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 5, 0, 0),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [2515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 50),
  [2517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 50),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2, 0, 0),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 42),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 42),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(683),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2, 0, 0),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(187),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3, 0, 0),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 5, 0, 102),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, 0, 39),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 4, 0, 0),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 4, 0, 88),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1287),
  [2698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [2718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(569),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(151),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 4, 0, 7),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 66),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 3, 0, 65),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 18),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 39),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3, 0, 0),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_argument, 2, 0, 0),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 68),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 19),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot, 1, 0, 0),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 3, 0, 93),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, 0, 104),
  [2864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, 0, 105),
  [2866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_length_array_type, 4, 0, 45),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 54),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 83),
  [2886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, 0, 85),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 9, 0, 107),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 5, 0, 99),
  [2926] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, 0, 97),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_go(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
