#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1364
#define LARGE_STATE_COUNT 421
#define SYMBOL_COUNT 203
#define ALIAS_COUNT 2
#define TOKEN_COUNT 115
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 13
#define MAX_ALIAS_SEQUENCE_LENGTH 13
#define PRODUCTION_ID_COUNT 129

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_POUND = 2,
  aux_sym_preprocessor_statement_token1 = 3,
  aux_sym_preprocessor_statement_token2 = 4,
  anon_sym_package = 5,
  anon_sym_import = 6,
  anon_sym_using = 7,
  anon_sym_throw = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_switch = 11,
  anon_sym_LBRACE = 12,
  anon_sym_RBRACE = 13,
  anon_sym_case = 14,
  anon_sym__ = 15,
  anon_sym_COLON = 16,
  anon_sym_default = 17,
  anon_sym_cast = 18,
  anon_sym_COMMA = 19,
  anon_sym_DOLLARtype = 20,
  anon_sym_in = 21,
  anon_sym_LBRACK = 22,
  anon_sym_RBRACK = 23,
  anon_sym_this = 24,
  anon_sym_DOT = 25,
  anon_sym_QMARK = 26,
  anon_sym_Void = 27,
  anon_sym_Int = 28,
  anon_sym_Float = 29,
  anon_sym_Bool = 30,
  anon_sym_Null = 31,
  anon_sym_DASH_GT = 32,
  anon_sym_AT = 33,
  anon_sym_AT_COLON = 34,
  anon_sym_if = 35,
  anon_sym_else = 36,
  anon_sym_elseif = 37,
  anon_sym_new = 38,
  anon_sym_TILDE = 39,
  anon_sym_BANG = 40,
  anon_sym_DASH = 41,
  anon_sym_PLUS_PLUS = 42,
  anon_sym_DASH_DASH = 43,
  anon_sym_PERCENT = 44,
  anon_sym_STAR = 45,
  anon_sym_SLASH = 46,
  anon_sym_PLUS = 47,
  anon_sym_LT_LT = 48,
  anon_sym_GT_GT = 49,
  anon_sym_GT_GT_GT = 50,
  anon_sym_AMP = 51,
  anon_sym_PIPE = 52,
  anon_sym_CARET = 53,
  anon_sym_AMP_AMP = 54,
  anon_sym_PIPE_PIPE = 55,
  anon_sym_EQ_EQ = 56,
  anon_sym_BANG_EQ = 57,
  anon_sym_LT = 58,
  anon_sym_LT_EQ = 59,
  anon_sym_GT = 60,
  anon_sym_GT_EQ = 61,
  anon_sym_EQ_GT = 62,
  anon_sym_QMARK_QMARK = 63,
  anon_sym_EQ = 64,
  sym__rangeOperator = 65,
  anon_sym_null = 66,
  anon_sym_get = 67,
  anon_sym_set = 68,
  anon_sym_dynamic = 69,
  anon_sym_never = 70,
  anon_sym_final = 71,
  anon_sym_abstract = 72,
  anon_sym_class = 73,
  anon_sym_extends = 74,
  anon_sym_implements = 75,
  anon_sym_interface = 76,
  anon_sym_typedef = 77,
  anon_sym_function = 78,
  anon_sym_var = 79,
  aux_sym_integer_token1 = 80,
  aux_sym_integer_token2 = 81,
  aux_sym_float_token1 = 82,
  aux_sym_float_token2 = 83,
  anon_sym_true = 84,
  anon_sym_false = 85,
  aux_sym_string_token1 = 86,
  aux_sym_string_token2 = 87,
  aux_sym_string_token3 = 88,
  aux_sym_string_token4 = 89,
  anon_sym_DOLLAR_LBRACE = 90,
  anon_sym_DOLLAR = 91,
  anon_sym_LBRACE2 = 92,
  sym_escape_sequence = 93,
  sym_comment = 94,
  anon_sym_break = 95,
  anon_sym_catch = 96,
  anon_sym_continue = 97,
  anon_sym_do = 98,
  anon_sym_enum = 99,
  anon_sym_extern = 100,
  anon_sym_for = 101,
  anon_sym_inline = 102,
  anon_sym_macro = 103,
  anon_sym_operator = 104,
  anon_sym_overload = 105,
  anon_sym_override = 106,
  anon_sym_private = 107,
  anon_sym_public = 108,
  anon_sym_return = 109,
  anon_sym_static = 110,
  anon_sym_try = 111,
  anon_sym_untyped = 112,
  anon_sym_while = 113,
  sym__semicolon = 114,
  sym_module = 115,
  sym_preprocessor_statement = 116,
  sym_package_statement = 117,
  sym_import_statement = 118,
  sym_using_statement = 119,
  sym_throw_statement = 120,
  sym__rhs_expression = 121,
  sym__unaryExpression = 122,
  sym_runtime_type_check_expression = 123,
  sym_switch_expression = 124,
  sym_case_statement = 125,
  sym_cast_expression = 126,
  sym_type_trace_expression = 127,
  sym__parenthesized_expression = 128,
  sym_range_expression = 129,
  sym_subscript_expression = 130,
  sym_member_expression = 131,
  sym__lhs_expression = 132,
  sym_builtin_type = 133,
  sym__function_type_args = 134,
  sym_function_type = 135,
  sym_type = 136,
  sym_block = 137,
  sym_metadata = 138,
  sym__arg_list = 139,
  sym_conditional_statement = 140,
  sym__call = 141,
  sym__constructor_call = 142,
  sym_call_expression = 143,
  sym_operator = 144,
  sym__unaryOperator = 145,
  sym__prefixUnaryOperator = 146,
  sym__postfixUnaryOperator = 147,
  sym__binaryOperator = 148,
  sym__arithmeticOperator = 149,
  sym__bitwiseOperator = 150,
  sym__logicalOperator = 151,
  sym__comparisonOperator = 152,
  sym__miscOperator = 153,
  sym__assignmentOperator = 154,
  sym__compoundAssignmentOperator = 155,
  sym_declaration = 156,
  sym__access_identifier = 157,
  sym_access_identifiers = 158,
  sym_type_param = 159,
  sym_type_params = 160,
  sym_class_declaration = 161,
  sym_interface_declaration = 162,
  sym_typedef_declaration = 163,
  sym_function_declaration = 164,
  sym__function_arg_list = 165,
  sym_function_arg = 166,
  sym_variable_declaration = 167,
  sym__literal = 168,
  sym_integer = 169,
  sym_float = 170,
  sym_bool = 171,
  sym_string = 172,
  sym_null = 173,
  sym_array = 174,
  sym_map = 175,
  sym_object = 176,
  sym_structure_type = 177,
  sym_structure_type_pair = 178,
  sym_pair = 179,
  sym_interpolation = 180,
  sym__interpolated_block = 181,
  sym__interpolated_identifier = 182,
  sym_keyword = 183,
  aux_sym_module_repeat1 = 184,
  aux_sym__parenthesized_expression_repeat1 = 185,
  aux_sym_expression_repeat1 = 186,
  aux_sym_member_expression_repeat1 = 187,
  aux_sym__function_type_args_repeat1 = 188,
  aux_sym__arg_list_repeat1 = 189,
  aux_sym_type_params_repeat1 = 190,
  aux_sym_class_declaration_repeat1 = 191,
  aux_sym_class_declaration_repeat2 = 192,
  aux_sym_interface_declaration_repeat1 = 193,
  aux_sym_function_declaration_repeat1 = 194,
  aux_sym__function_arg_list_repeat1 = 195,
  aux_sym_variable_declaration_repeat1 = 196,
  aux_sym_variable_declaration_repeat2 = 197,
  aux_sym_string_repeat1 = 198,
  aux_sym_string_repeat2 = 199,
  aux_sym_array_repeat1 = 200,
  aux_sym_map_repeat1 = 201,
  aux_sym_structure_type_repeat1 = 202,
  anon_alias_sym_type = 203,
  anon_alias_sym_type_check = 204,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_POUND] = "#",
  [aux_sym_preprocessor_statement_token1] = "preprocessor_statement_token1",
  [aux_sym_preprocessor_statement_token2] = "preprocessor_statement_token2",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_using] = "using",
  [anon_sym_throw] = "throw",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_switch] = "switch",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_case] = "case",
  [anon_sym__] = "_rhs_expression",
  [anon_sym_COLON] = ":",
  [anon_sym_default] = "default",
  [anon_sym_cast] = "cast",
  [anon_sym_COMMA] = ",",
  [anon_sym_DOLLARtype] = "keyword",
  [anon_sym_in] = "in",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_this] = "this",
  [anon_sym_DOT] = ".",
  [anon_sym_QMARK] = "\?",
  [anon_sym_Void] = "Void",
  [anon_sym_Int] = "Int",
  [anon_sym_Float] = "Float",
  [anon_sym_Bool] = "Bool",
  [anon_sym_Null] = "Null",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_AT] = "@",
  [anon_sym_AT_COLON] = "@:",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_elseif] = "keyword",
  [anon_sym_new] = "new",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PLUS] = "+",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_EQ] = "=",
  [sym__rangeOperator] = "_rangeOperator",
  [anon_sym_null] = "null",
  [anon_sym_get] = "keyword",
  [anon_sym_set] = "keyword",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_never] = "keyword",
  [anon_sym_final] = "final",
  [anon_sym_abstract] = "abstract",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_interface] = "interface",
  [anon_sym_typedef] = "typedef",
  [anon_sym_function] = "function",
  [anon_sym_var] = "var",
  [aux_sym_integer_token1] = "integer_token1",
  [aux_sym_integer_token2] = "integer_token2",
  [aux_sym_float_token1] = "float_token1",
  [aux_sym_float_token2] = "float_token2",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_string_token1] = "string_token1",
  [aux_sym_string_token2] = "string_token2",
  [aux_sym_string_token3] = "string_token3",
  [aux_sym_string_token4] = "string_token4",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LBRACE2] = "{",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_break] = "break",
  [anon_sym_catch] = "catch",
  [anon_sym_continue] = "continue",
  [anon_sym_do] = "do",
  [anon_sym_enum] = "enum",
  [anon_sym_extern] = "extern",
  [anon_sym_for] = "for",
  [anon_sym_inline] = "inline",
  [anon_sym_macro] = "macro",
  [anon_sym_operator] = "operator",
  [anon_sym_overload] = "overload",
  [anon_sym_override] = "override",
  [anon_sym_private] = "private",
  [anon_sym_public] = "public",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_try] = "try",
  [anon_sym_untyped] = "untyped",
  [anon_sym_while] = "while",
  [sym__semicolon] = "_semicolon",
  [sym_module] = "module",
  [sym_preprocessor_statement] = "preprocessor_statement",
  [sym_package_statement] = "package_statement",
  [sym_import_statement] = "import_statement",
  [sym_using_statement] = "using_statement",
  [sym_throw_statement] = "throw_statement",
  [sym__rhs_expression] = "_rhs_expression",
  [sym__unaryExpression] = "_unaryExpression",
  [sym_runtime_type_check_expression] = "runtime_type_check_expression",
  [sym_switch_expression] = "switch_expression",
  [sym_case_statement] = "case_statement",
  [sym_cast_expression] = "cast_expression",
  [sym_type_trace_expression] = "type_trace_expression",
  [sym__parenthesized_expression] = "_parenthesized_expression",
  [sym_range_expression] = "range_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_member_expression] = "member_expression",
  [sym__lhs_expression] = "_lhs_expression",
  [sym_builtin_type] = "identifier",
  [sym__function_type_args] = "_function_type_args",
  [sym_function_type] = "function_type",
  [sym_type] = "type",
  [sym_block] = "block",
  [sym_metadata] = "metadata",
  [sym__arg_list] = "_arg_list",
  [sym_conditional_statement] = "conditional_statement",
  [sym__call] = "_call",
  [sym__constructor_call] = "_constructor_call",
  [sym_call_expression] = "call_expression",
  [sym_operator] = "operator",
  [sym__unaryOperator] = "_unaryOperator",
  [sym__prefixUnaryOperator] = "_prefixUnaryOperator",
  [sym__postfixUnaryOperator] = "_postfixUnaryOperator",
  [sym__binaryOperator] = "_binaryOperator",
  [sym__arithmeticOperator] = "_arithmeticOperator",
  [sym__bitwiseOperator] = "_bitwiseOperator",
  [sym__logicalOperator] = "_logicalOperator",
  [sym__comparisonOperator] = "_comparisonOperator",
  [sym__miscOperator] = "_miscOperator",
  [sym__assignmentOperator] = "_assignmentOperator",
  [sym__compoundAssignmentOperator] = "_compoundAssignmentOperator",
  [sym_declaration] = "declaration",
  [sym__access_identifier] = "_access_identifier",
  [sym_access_identifiers] = "access_identifiers",
  [sym_type_param] = "type_param",
  [sym_type_params] = "type_params",
  [sym_class_declaration] = "class_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_typedef_declaration] = "typedef_declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__function_arg_list] = "_function_arg_list",
  [sym_function_arg] = "function_arg",
  [sym_variable_declaration] = "variable_declaration",
  [sym__literal] = "_literal",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_bool] = "bool",
  [sym_string] = "string",
  [sym_null] = "null",
  [sym_array] = "array",
  [sym_map] = "map",
  [sym_object] = "object",
  [sym_structure_type] = "type",
  [sym_structure_type_pair] = "pair",
  [sym_pair] = "pair",
  [sym_interpolation] = "interpolation",
  [sym__interpolated_block] = "_interpolated_block",
  [sym__interpolated_identifier] = "_interpolated_identifier",
  [sym_keyword] = "keyword",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__parenthesized_expression_repeat1] = "_parenthesized_expression_repeat1",
  [aux_sym_expression_repeat1] = "expression_repeat1",
  [aux_sym_member_expression_repeat1] = "member_expression_repeat1",
  [aux_sym__function_type_args_repeat1] = "_function_type_args_repeat1",
  [aux_sym__arg_list_repeat1] = "_arg_list_repeat1",
  [aux_sym_type_params_repeat1] = "type_params_repeat1",
  [aux_sym_class_declaration_repeat1] = "class_declaration_repeat1",
  [aux_sym_class_declaration_repeat2] = "class_declaration_repeat2",
  [aux_sym_interface_declaration_repeat1] = "interface_declaration_repeat1",
  [aux_sym_function_declaration_repeat1] = "function_declaration_repeat1",
  [aux_sym__function_arg_list_repeat1] = "_function_arg_list_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_variable_declaration_repeat2] = "variable_declaration_repeat2",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_map_repeat1] = "map_repeat1",
  [aux_sym_structure_type_repeat1] = "structure_type_repeat1",
  [anon_alias_sym_type] = "type",
  [anon_alias_sym_type_check] = "type_check",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_preprocessor_statement_token1] = aux_sym_preprocessor_statement_token1,
  [aux_sym_preprocessor_statement_token2] = aux_sym_preprocessor_statement_token2,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_case] = anon_sym_case,
  [anon_sym__] = anon_sym__,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_cast] = anon_sym_cast,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_DOLLARtype] = sym_keyword,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_Void] = anon_sym_Void,
  [anon_sym_Int] = anon_sym_Int,
  [anon_sym_Float] = anon_sym_Float,
  [anon_sym_Bool] = anon_sym_Bool,
  [anon_sym_Null] = anon_sym_Null,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_COLON] = anon_sym_AT_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_elseif] = sym_keyword,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_EQ] = anon_sym_EQ,
  [sym__rangeOperator] = sym__rangeOperator,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_get] = sym_keyword,
  [anon_sym_set] = sym_keyword,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_never] = sym_keyword,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_var] = anon_sym_var,
  [aux_sym_integer_token1] = aux_sym_integer_token1,
  [aux_sym_integer_token2] = aux_sym_integer_token2,
  [aux_sym_float_token1] = aux_sym_float_token1,
  [aux_sym_float_token2] = aux_sym_float_token2,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [aux_sym_string_token3] = aux_sym_string_token3,
  [aux_sym_string_token4] = aux_sym_string_token4,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_overload] = anon_sym_overload,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_untyped] = anon_sym_untyped,
  [anon_sym_while] = anon_sym_while,
  [sym__semicolon] = sym__semicolon,
  [sym_module] = sym_module,
  [sym_preprocessor_statement] = sym_preprocessor_statement,
  [sym_package_statement] = sym_package_statement,
  [sym_import_statement] = sym_import_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym__rhs_expression] = sym__rhs_expression,
  [sym__unaryExpression] = sym__unaryExpression,
  [sym_runtime_type_check_expression] = sym_runtime_type_check_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym_case_statement] = sym_case_statement,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_trace_expression] = sym_type_trace_expression,
  [sym__parenthesized_expression] = sym__parenthesized_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_member_expression] = sym_member_expression,
  [sym__lhs_expression] = sym__lhs_expression,
  [sym_builtin_type] = sym_identifier,
  [sym__function_type_args] = sym__function_type_args,
  [sym_function_type] = sym_function_type,
  [sym_type] = sym_type,
  [sym_block] = sym_block,
  [sym_metadata] = sym_metadata,
  [sym__arg_list] = sym__arg_list,
  [sym_conditional_statement] = sym_conditional_statement,
  [sym__call] = sym__call,
  [sym__constructor_call] = sym__constructor_call,
  [sym_call_expression] = sym_call_expression,
  [sym_operator] = sym_operator,
  [sym__unaryOperator] = sym__unaryOperator,
  [sym__prefixUnaryOperator] = sym__prefixUnaryOperator,
  [sym__postfixUnaryOperator] = sym__postfixUnaryOperator,
  [sym__binaryOperator] = sym__binaryOperator,
  [sym__arithmeticOperator] = sym__arithmeticOperator,
  [sym__bitwiseOperator] = sym__bitwiseOperator,
  [sym__logicalOperator] = sym__logicalOperator,
  [sym__comparisonOperator] = sym__comparisonOperator,
  [sym__miscOperator] = sym__miscOperator,
  [sym__assignmentOperator] = sym__assignmentOperator,
  [sym__compoundAssignmentOperator] = sym__compoundAssignmentOperator,
  [sym_declaration] = sym_declaration,
  [sym__access_identifier] = sym__access_identifier,
  [sym_access_identifiers] = sym_access_identifiers,
  [sym_type_param] = sym_type_param,
  [sym_type_params] = sym_type_params,
  [sym_class_declaration] = sym_class_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_typedef_declaration] = sym_typedef_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__function_arg_list] = sym__function_arg_list,
  [sym_function_arg] = sym_function_arg,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__literal] = sym__literal,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_bool] = sym_bool,
  [sym_string] = sym_string,
  [sym_null] = sym_null,
  [sym_array] = sym_array,
  [sym_map] = sym_map,
  [sym_object] = sym_object,
  [sym_structure_type] = sym_type,
  [sym_structure_type_pair] = sym_pair,
  [sym_pair] = sym_pair,
  [sym_interpolation] = sym_interpolation,
  [sym__interpolated_block] = sym__interpolated_block,
  [sym__interpolated_identifier] = sym__interpolated_identifier,
  [sym_keyword] = sym_keyword,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__parenthesized_expression_repeat1] = aux_sym__parenthesized_expression_repeat1,
  [aux_sym_expression_repeat1] = aux_sym_expression_repeat1,
  [aux_sym_member_expression_repeat1] = aux_sym_member_expression_repeat1,
  [aux_sym__function_type_args_repeat1] = aux_sym__function_type_args_repeat1,
  [aux_sym__arg_list_repeat1] = aux_sym__arg_list_repeat1,
  [aux_sym_type_params_repeat1] = aux_sym_type_params_repeat1,
  [aux_sym_class_declaration_repeat1] = aux_sym_class_declaration_repeat1,
  [aux_sym_class_declaration_repeat2] = aux_sym_class_declaration_repeat2,
  [aux_sym_interface_declaration_repeat1] = aux_sym_interface_declaration_repeat1,
  [aux_sym_function_declaration_repeat1] = aux_sym_function_declaration_repeat1,
  [aux_sym__function_arg_list_repeat1] = aux_sym__function_arg_list_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_variable_declaration_repeat2] = aux_sym_variable_declaration_repeat2,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_map_repeat1] = aux_sym_map_repeat1,
  [aux_sym_structure_type_repeat1] = aux_sym_structure_type_repeat1,
  [anon_alias_sym_type] = anon_alias_sym_type,
  [anon_alias_sym_type_check] = anon_alias_sym_type_check,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preprocessor_statement_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preprocessor_statement_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARtype] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym__rangeOperator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_integer_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_overload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_untyped] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_preprocessor_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_package_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__rhs_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__unaryExpression] = {
    .visible = false,
    .named = true,
  },
  [sym_runtime_type_check_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_trace_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym__function_type_args] = {
    .visible = false,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_list] = {
    .visible = false,
    .named = true,
  },
  [sym_conditional_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__call] = {
    .visible = false,
    .named = true,
  },
  [sym__constructor_call] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__unaryOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__prefixUnaryOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__postfixUnaryOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__binaryOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__arithmeticOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__bitwiseOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__logicalOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__comparisonOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__miscOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__assignmentOperator] = {
    .visible = false,
    .named = true,
  },
  [sym__compoundAssignmentOperator] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__access_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_access_identifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_type_param] = {
    .visible = true,
    .named = true,
  },
  [sym_type_params] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_typedef_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_arg_list] = {
    .visible = false,
    .named = true,
  },
  [sym_function_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_map] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_type] = {
    .visible = true,
    .named = true,
  },
  [sym_structure_type_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_block] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parenthesized_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_member_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_type_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__arg_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_arg_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structure_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_type_check] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_arguments_list = 1,
  field_body = 2,
  field_built_in = 3,
  field_index = 4,
  field_interface_name = 5,
  field_literal = 6,
  field_member = 7,
  field_name = 8,
  field_object = 9,
  field_return_type = 10,
  field_super_class_name = 11,
  field_type = 12,
  field_type_name = 13,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arguments_list] = "arguments_list",
  [field_body] = "body",
  [field_built_in] = "built_in",
  [field_index] = "index",
  [field_interface_name] = "interface_name",
  [field_literal] = "literal",
  [field_member] = "member",
  [field_name] = "name",
  [field_object] = "object",
  [field_return_type] = "return_type",
  [field_super_class_name] = "super_class_name",
  [field_type] = "type",
  [field_type_name] = "type_name",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 2, .length = 1},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 2},
  [12] = {.index = 2, .length = 1},
  [14] = {.index = 10, .length = 2},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 2},
  [17] = {.index = 18, .length = 1},
  [18] = {.index = 19, .length = 1},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 3, .length = 2},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 26, .length = 1},
  [24] = {.index = 27, .length = 2},
  [25] = {.index = 29, .length = 3},
  [26] = {.index = 32, .length = 2},
  [27] = {.index = 34, .length = 1},
  [28] = {.index = 27, .length = 2},
  [29] = {.index = 35, .length = 1},
  [30] = {.index = 22, .length = 2},
  [31] = {.index = 36, .length = 2},
  [32] = {.index = 38, .length = 1},
  [33] = {.index = 24, .length = 2},
  [34] = {.index = 38, .length = 1},
  [35] = {.index = 3, .length = 2},
  [36] = {.index = 39, .length = 2},
  [37] = {.index = 41, .length = 3},
  [38] = {.index = 44, .length = 2},
  [39] = {.index = 46, .length = 3},
  [40] = {.index = 49, .length = 3},
  [41] = {.index = 52, .length = 2},
  [42] = {.index = 54, .length = 2},
  [43] = {.index = 52, .length = 2},
  [44] = {.index = 54, .length = 2},
  [45] = {.index = 56, .length = 2},
  [46] = {.index = 58, .length = 2},
  [47] = {.index = 39, .length = 2},
  [48] = {.index = 41, .length = 3},
  [49] = {.index = 39, .length = 2},
  [50] = {.index = 60, .length = 1},
  [51] = {.index = 60, .length = 1},
  [53] = {.index = 61, .length = 1},
  [54] = {.index = 62, .length = 1},
  [55] = {.index = 63, .length = 3},
  [56] = {.index = 66, .length = 3},
  [57] = {.index = 69, .length = 2},
  [58] = {.index = 71, .length = 3},
  [59] = {.index = 74, .length = 4},
  [60] = {.index = 78, .length = 3},
  [61] = {.index = 34, .length = 1},
  [62] = {.index = 81, .length = 2},
  [63] = {.index = 83, .length = 3},
  [64] = {.index = 81, .length = 2},
  [65] = {.index = 83, .length = 3},
  [66] = {.index = 86, .length = 2},
  [67] = {.index = 88, .length = 3},
  [68] = {.index = 91, .length = 2},
  [69] = {.index = 63, .length = 3},
  [70] = {.index = 66, .length = 3},
  [71] = {.index = 93, .length = 2},
  [72] = {.index = 95, .length = 2},
  [73] = {.index = 93, .length = 2},
  [74] = {.index = 95, .length = 2},
  [75] = {.index = 86, .length = 2},
  [76] = {.index = 86, .length = 2},
  [77] = {.index = 97, .length = 3},
  [78] = {.index = 100, .length = 4},
  [79] = {.index = 104, .length = 3},
  [80] = {.index = 107, .length = 2},
  [81] = {.index = 109, .length = 4},
  [82] = {.index = 113, .length = 3},
  [83] = {.index = 116, .length = 4},
  [84] = {.index = 34, .length = 1},
  [85] = {.index = 120, .length = 3},
  [86] = {.index = 120, .length = 3},
  [87] = {.index = 123, .length = 3},
  [88] = {.index = 126, .length = 3},
  [89] = {.index = 129, .length = 2},
  [90] = {.index = 97, .length = 3},
  [91] = {.index = 100, .length = 4},
  [92] = {.index = 104, .length = 3},
  [93] = {.index = 131, .length = 2},
  [94] = {.index = 133, .length = 3},
  [95] = {.index = 131, .length = 2},
  [96] = {.index = 133, .length = 3},
  [97] = {.index = 136, .length = 2},
  [98] = {.index = 138, .length = 2},
  [99] = {.index = 140, .length = 2},
  [100] = {.index = 138, .length = 2},
  [101] = {.index = 140, .length = 2},
  [102] = {.index = 142, .length = 4},
  [103] = {.index = 146, .length = 3},
  [104] = {.index = 149, .length = 4},
  [105] = {.index = 153, .length = 4},
  [106] = {.index = 157, .length = 3},
  [107] = {.index = 160, .length = 4},
  [108] = {.index = 164, .length = 3},
  [109] = {.index = 167, .length = 2},
  [110] = {.index = 142, .length = 4},
  [111] = {.index = 146, .length = 3},
  [112] = {.index = 149, .length = 4},
  [113] = {.index = 169, .length = 3},
  [114] = {.index = 169, .length = 3},
  [115] = {.index = 172, .length = 2},
  [116] = {.index = 174, .length = 2},
  [117] = {.index = 176, .length = 3},
  [118] = {.index = 174, .length = 2},
  [119] = {.index = 176, .length = 3},
  [120] = {.index = 179, .length = 4},
  [121] = {.index = 183, .length = 4},
  [122] = {.index = 187, .length = 3},
  [123] = {.index = 190, .length = 4},
  [124] = {.index = 179, .length = 4},
  [125] = {.index = 194, .length = 2},
  [126] = {.index = 196, .length = 3},
  [127] = {.index = 196, .length = 3},
  [128] = {.index = 199, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments_list, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [2] =
    {field_name, 1},
  [3] =
    {field_arguments_list, 1},
    {field_name, 0},
  [5] =
    {field_arguments_list, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [7] =
    {field_arguments_list, 1},
    {field_object, 0},
  [9] =
    {field_member, 0},
  [10] =
    {field_member, 2, .inherited = true},
    {field_object, 0},
  [12] =
    {field_body, 2},
    {field_name, 1},
  [14] =
    {field_arguments_list, 2},
    {field_object, 0},
  [16] =
    {field_literal, 0},
    {field_member, 2, .inherited = true},
  [18] =
    {field_type_name, 0},
  [19] =
    {field_built_in, 0},
  [20] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [22] =
    {field_member, 3, .inherited = true},
    {field_object, 0},
  [24] =
    {field_body, 3},
    {field_name, 2},
  [26] =
    {field_interface_name, 1},
  [27] =
    {field_body, 3},
    {field_name, 1},
  [29] =
    {field_body, 3},
    {field_interface_name, 2, .inherited = true},
    {field_name, 1},
  [32] =
    {field_interface_name, 0, .inherited = true},
    {field_interface_name, 1, .inherited = true},
  [34] =
    {field_name, 0},
  [35] =
    {field_index, 2},
  [36] =
    {field_literal, 0},
    {field_member, 3, .inherited = true},
  [38] =
    {field_name, 2},
  [39] =
    {field_body, 4},
    {field_name, 2},
  [41] =
    {field_body, 4},
    {field_interface_name, 3, .inherited = true},
    {field_name, 2},
  [44] =
    {field_name, 1},
    {field_type, 3},
  [46] =
    {field_body, 4},
    {field_name, 1},
    {field_super_class_name, 3},
  [49] =
    {field_body, 4},
    {field_interface_name, 3, .inherited = true},
    {field_name, 1},
  [52] =
    {field_body, 4},
    {field_name, 1},
  [54] =
    {field_name, 1},
    {field_return_type, 4},
  [56] =
    {field_index, 2},
    {field_index, 3},
  [58] =
    {field_body, 4},
    {field_name, 3},
  [60] =
    {field_name, 3},
  [61] =
    {field_return_type, 2},
  [62] =
    {field_type, 4},
  [63] =
    {field_body, 5},
    {field_name, 2},
    {field_super_class_name, 4},
  [66] =
    {field_body, 5},
    {field_interface_name, 4, .inherited = true},
    {field_name, 2},
  [69] =
    {field_name, 1},
    {field_type, 4},
  [71] =
    {field_body, 5},
    {field_name, 1},
    {field_super_class_name, 3},
  [74] =
    {field_body, 5},
    {field_interface_name, 4, .inherited = true},
    {field_name, 1},
    {field_super_class_name, 3},
  [78] =
    {field_body, 5},
    {field_name, 1},
    {field_super_class_name, 4},
  [81] =
    {field_name, 1},
    {field_return_type, 5},
  [83] =
    {field_body, 5},
    {field_name, 1},
    {field_return_type, 4},
  [86] =
    {field_body, 5},
    {field_name, 3},
  [88] =
    {field_body, 5},
    {field_interface_name, 4, .inherited = true},
    {field_name, 3},
  [91] =
    {field_name, 2},
    {field_type, 4},
  [93] =
    {field_body, 5},
    {field_name, 2},
  [95] =
    {field_name, 2},
    {field_return_type, 5},
  [97] =
    {field_body, 6},
    {field_name, 2},
    {field_super_class_name, 4},
  [100] =
    {field_body, 6},
    {field_interface_name, 5, .inherited = true},
    {field_name, 2},
    {field_super_class_name, 4},
  [104] =
    {field_body, 6},
    {field_name, 2},
    {field_super_class_name, 5},
  [107] =
    {field_name, 1},
    {field_type, 5},
  [109] =
    {field_body, 6},
    {field_interface_name, 5, .inherited = true},
    {field_name, 1},
    {field_super_class_name, 3},
  [113] =
    {field_body, 6},
    {field_name, 1},
    {field_super_class_name, 4},
  [116] =
    {field_body, 6},
    {field_interface_name, 5, .inherited = true},
    {field_name, 1},
    {field_super_class_name, 4},
  [120] =
    {field_body, 6},
    {field_name, 1},
    {field_return_type, 5},
  [123] =
    {field_body, 6},
    {field_name, 3},
    {field_super_class_name, 5},
  [126] =
    {field_body, 6},
    {field_interface_name, 5, .inherited = true},
    {field_name, 3},
  [129] =
    {field_name, 2},
    {field_type, 5},
  [131] =
    {field_name, 2},
    {field_return_type, 6},
  [133] =
    {field_body, 6},
    {field_name, 2},
    {field_return_type, 5},
  [136] =
    {field_name, 3},
    {field_type, 5},
  [138] =
    {field_body, 6},
    {field_name, 3},
  [140] =
    {field_name, 3},
    {field_return_type, 6},
  [142] =
    {field_body, 7},
    {field_interface_name, 6, .inherited = true},
    {field_name, 2},
    {field_super_class_name, 4},
  [146] =
    {field_body, 7},
    {field_name, 2},
    {field_super_class_name, 5},
  [149] =
    {field_body, 7},
    {field_interface_name, 6, .inherited = true},
    {field_name, 2},
    {field_super_class_name, 5},
  [153] =
    {field_body, 7},
    {field_interface_name, 6, .inherited = true},
    {field_name, 1},
    {field_super_class_name, 4},
  [157] =
    {field_body, 7},
    {field_name, 3},
    {field_super_class_name, 5},
  [160] =
    {field_body, 7},
    {field_interface_name, 6, .inherited = true},
    {field_name, 3},
    {field_super_class_name, 5},
  [164] =
    {field_body, 7},
    {field_name, 3},
    {field_super_class_name, 6},
  [167] =
    {field_name, 2},
    {field_type, 6},
  [169] =
    {field_body, 7},
    {field_name, 2},
    {field_return_type, 6},
  [172] =
    {field_name, 3},
    {field_type, 6},
  [174] =
    {field_name, 3},
    {field_return_type, 7},
  [176] =
    {field_body, 7},
    {field_name, 3},
    {field_return_type, 6},
  [179] =
    {field_body, 8},
    {field_interface_name, 7, .inherited = true},
    {field_name, 2},
    {field_super_class_name, 5},
  [183] =
    {field_body, 8},
    {field_interface_name, 7, .inherited = true},
    {field_name, 3},
    {field_super_class_name, 5},
  [187] =
    {field_body, 8},
    {field_name, 3},
    {field_super_class_name, 6},
  [190] =
    {field_body, 8},
    {field_interface_name, 7, .inherited = true},
    {field_name, 3},
    {field_super_class_name, 6},
  [194] =
    {field_name, 3},
    {field_type, 7},
  [196] =
    {field_body, 8},
    {field_name, 3},
    {field_return_type, 7},
  [199] =
    {field_body, 9},
    {field_interface_name, 8, .inherited = true},
    {field_name, 3},
    {field_super_class_name, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_keyword,
  },
  [4] = {
    [0] = sym_keyword,
  },
  [5] = {
    [0] = sym_keyword,
  },
  [7] = {
    [0] = sym_keyword,
  },
  [8] = {
    [1] = anon_alias_sym_type_check,
  },
  [10] = {
    [0] = sym_keyword,
  },
  [11] = {
    [0] = sym_keyword,
  },
  [12] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [13] = {
    [1] = sym_keyword,
  },
  [20] = {
    [0] = sym_keyword,
    [1] = sym_operator,
  },
  [21] = {
    [0] = sym_keyword,
    [2] = sym_keyword,
  },
  [22] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
  },
  [23] = {
    [0] = sym_keyword,
  },
  [24] = {
    [0] = sym_keyword,
  },
  [25] = {
    [0] = sym_keyword,
  },
  [28] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [30] = {
    [1] = sym_operator,
  },
  [31] = {
    [1] = sym_operator,
  },
  [32] = {
    [1] = sym_keyword,
  },
  [33] = {
    [1] = sym_keyword,
  },
  [34] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [35] = {
    [0] = sym_keyword,
    [3] = sym_keyword,
  },
  [36] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
  },
  [37] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
  },
  [38] = {
    [0] = sym_keyword,
  },
  [39] = {
    [0] = sym_keyword,
    [2] = sym_keyword,
  },
  [40] = {
    [0] = sym_keyword,
  },
  [41] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [42] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [43] = {
    [0] = sym_keyword,
  },
  [44] = {
    [0] = sym_keyword,
  },
  [46] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
  },
  [47] = {
    [1] = sym_keyword,
  },
  [48] = {
    [1] = sym_keyword,
  },
  [49] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [50] = {
    [2] = sym_keyword,
  },
  [51] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [52] = {
    [1] = anon_alias_sym_type,
  },
  [54] = {
    [0] = sym_keyword,
  },
  [55] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [56] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
  },
  [57] = {
    [0] = sym_keyword,
  },
  [58] = {
    [0] = sym_keyword,
    [2] = sym_keyword,
  },
  [59] = {
    [0] = sym_keyword,
    [2] = sym_keyword,
  },
  [60] = {
    [0] = sym_keyword,
    [3] = sym_keyword,
  },
  [61] = {
    [2] = sym_type,
  },
  [62] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [63] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [64] = {
    [0] = sym_keyword,
  },
  [65] = {
    [0] = sym_keyword,
  },
  [66] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
  },
  [67] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
  },
  [68] = {
    [1] = sym_keyword,
  },
  [69] = {
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [70] = {
    [1] = sym_keyword,
  },
  [71] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [72] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [73] = {
    [1] = sym_keyword,
  },
  [74] = {
    [1] = sym_keyword,
  },
  [75] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [76] = {
    [2] = sym_keyword,
  },
  [77] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [78] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [79] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [80] = {
    [0] = sym_keyword,
  },
  [81] = {
    [0] = sym_keyword,
    [2] = sym_keyword,
  },
  [82] = {
    [0] = sym_keyword,
    [3] = sym_keyword,
  },
  [83] = {
    [0] = sym_keyword,
    [3] = sym_keyword,
  },
  [84] = {
    [3] = sym_type,
  },
  [85] = {
    [0] = sym_keyword,
    [1] = sym_identifier,
  },
  [86] = {
    [0] = sym_keyword,
  },
  [87] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [4] = sym_keyword,
  },
  [88] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
  },
  [89] = {
    [1] = sym_keyword,
  },
  [90] = {
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [91] = {
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [92] = {
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [93] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [94] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [95] = {
    [1] = sym_keyword,
  },
  [96] = {
    [1] = sym_keyword,
  },
  [97] = {
    [2] = sym_keyword,
  },
  [98] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [99] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [100] = {
    [2] = sym_keyword,
  },
  [101] = {
    [2] = sym_keyword,
  },
  [102] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [103] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [104] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [105] = {
    [0] = sym_keyword,
    [3] = sym_keyword,
  },
  [106] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [4] = sym_keyword,
  },
  [107] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [4] = sym_keyword,
  },
  [108] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [5] = sym_keyword,
  },
  [109] = {
    [1] = sym_keyword,
  },
  [110] = {
    [1] = sym_keyword,
    [3] = sym_keyword,
  },
  [111] = {
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [112] = {
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [113] = {
    [1] = sym_keyword,
    [2] = sym_identifier,
  },
  [114] = {
    [1] = sym_keyword,
  },
  [115] = {
    [2] = sym_keyword,
  },
  [116] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [117] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [118] = {
    [2] = sym_keyword,
  },
  [119] = {
    [2] = sym_keyword,
  },
  [120] = {
    [0] = sym_keyword,
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [121] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [4] = sym_keyword,
  },
  [122] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [5] = sym_keyword,
  },
  [123] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [5] = sym_keyword,
  },
  [124] = {
    [1] = sym_keyword,
    [4] = sym_keyword,
  },
  [125] = {
    [2] = sym_keyword,
  },
  [126] = {
    [2] = sym_keyword,
    [3] = sym_identifier,
  },
  [127] = {
    [2] = sym_keyword,
  },
  [128] = {
    [1] = sym_keyword,
    [2] = sym_keyword,
    [5] = sym_keyword,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__lhs_expression, 2,
    sym__lhs_expression,
    sym_type,
  sym_type, 3,
    sym_type,
    anon_alias_sym_type,
    sym_type,
  sym_structure_type_pair, 2,
    sym_pair,
    anon_alias_sym_type_check,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 3,
  [7] = 5,
  [8] = 8,
  [9] = 8,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 14,
  [23] = 19,
  [24] = 21,
  [25] = 25,
  [26] = 20,
  [27] = 19,
  [28] = 18,
  [29] = 15,
  [30] = 17,
  [31] = 31,
  [32] = 15,
  [33] = 16,
  [34] = 16,
  [35] = 20,
  [36] = 36,
  [37] = 18,
  [38] = 21,
  [39] = 17,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 36,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 57,
  [70] = 57,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 60,
  [102] = 72,
  [103] = 52,
  [104] = 54,
  [105] = 105,
  [106] = 51,
  [107] = 107,
  [108] = 108,
  [109] = 53,
  [110] = 110,
  [111] = 111,
  [112] = 107,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 108,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 113,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 135,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 166,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 178,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 167,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 339,
  [343] = 340,
  [344] = 344,
  [345] = 344,
  [346] = 346,
  [347] = 347,
  [348] = 347,
  [349] = 346,
  [350] = 344,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 360,
  [364] = 364,
  [365] = 365,
  [366] = 361,
  [367] = 360,
  [368] = 368,
  [369] = 360,
  [370] = 370,
  [371] = 371,
  [372] = 360,
  [373] = 360,
  [374] = 374,
  [375] = 360,
  [376] = 360,
  [377] = 360,
  [378] = 378,
  [379] = 360,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 360,
  [384] = 384,
  [385] = 360,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 15,
  [394] = 16,
  [395] = 17,
  [396] = 20,
  [397] = 21,
  [398] = 18,
  [399] = 399,
  [400] = 19,
  [401] = 401,
  [402] = 60,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 14,
  [421] = 18,
  [422] = 19,
  [423] = 14,
  [424] = 17,
  [425] = 16,
  [426] = 15,
  [427] = 21,
  [428] = 20,
  [429] = 14,
  [430] = 57,
  [431] = 25,
  [432] = 14,
  [433] = 36,
  [434] = 14,
  [435] = 31,
  [436] = 14,
  [437] = 36,
  [438] = 438,
  [439] = 439,
  [440] = 20,
  [441] = 19,
  [442] = 18,
  [443] = 21,
  [444] = 16,
  [445] = 15,
  [446] = 17,
  [447] = 17,
  [448] = 16,
  [449] = 18,
  [450] = 19,
  [451] = 20,
  [452] = 21,
  [453] = 15,
  [454] = 454,
  [455] = 107,
  [456] = 57,
  [457] = 97,
  [458] = 458,
  [459] = 107,
  [460] = 107,
  [461] = 108,
  [462] = 105,
  [463] = 108,
  [464] = 113,
  [465] = 113,
  [466] = 113,
  [467] = 113,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 25,
  [472] = 36,
  [473] = 31,
  [474] = 25,
  [475] = 475,
  [476] = 57,
  [477] = 36,
  [478] = 25,
  [479] = 479,
  [480] = 31,
  [481] = 25,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 31,
  [487] = 482,
  [488] = 488,
  [489] = 36,
  [490] = 490,
  [491] = 25,
  [492] = 57,
  [493] = 36,
  [494] = 494,
  [495] = 25,
  [496] = 496,
  [497] = 485,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 31,
  [509] = 509,
  [510] = 503,
  [511] = 25,
  [512] = 25,
  [513] = 503,
  [514] = 31,
  [515] = 499,
  [516] = 516,
  [517] = 36,
  [518] = 518,
  [519] = 499,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 36,
  [524] = 25,
  [525] = 31,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 36,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 25,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 551,
  [595] = 595,
  [596] = 595,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 16,
  [604] = 21,
  [605] = 19,
  [606] = 18,
  [607] = 15,
  [608] = 17,
  [609] = 20,
  [610] = 107,
  [611] = 107,
  [612] = 18,
  [613] = 613,
  [614] = 614,
  [615] = 17,
  [616] = 614,
  [617] = 15,
  [618] = 19,
  [619] = 20,
  [620] = 21,
  [621] = 16,
  [622] = 107,
  [623] = 107,
  [624] = 614,
  [625] = 107,
  [626] = 107,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 107,
  [632] = 14,
  [633] = 633,
  [634] = 108,
  [635] = 635,
  [636] = 636,
  [637] = 107,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 108,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 108,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 108,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 652,
  [668] = 653,
  [669] = 654,
  [670] = 654,
  [671] = 671,
  [672] = 652,
  [673] = 653,
  [674] = 671,
  [675] = 105,
  [676] = 676,
  [677] = 107,
  [678] = 678,
  [679] = 97,
  [680] = 16,
  [681] = 21,
  [682] = 20,
  [683] = 19,
  [684] = 18,
  [685] = 98,
  [686] = 56,
  [687] = 68,
  [688] = 65,
  [689] = 15,
  [690] = 17,
  [691] = 108,
  [692] = 105,
  [693] = 108,
  [694] = 113,
  [695] = 80,
  [696] = 14,
  [697] = 107,
  [698] = 698,
  [699] = 113,
  [700] = 698,
  [701] = 18,
  [702] = 89,
  [703] = 64,
  [704] = 73,
  [705] = 75,
  [706] = 76,
  [707] = 113,
  [708] = 61,
  [709] = 79,
  [710] = 81,
  [711] = 85,
  [712] = 87,
  [713] = 14,
  [714] = 58,
  [715] = 96,
  [716] = 63,
  [717] = 86,
  [718] = 55,
  [719] = 95,
  [720] = 77,
  [721] = 62,
  [722] = 94,
  [723] = 90,
  [724] = 113,
  [725] = 66,
  [726] = 91,
  [727] = 100,
  [728] = 78,
  [729] = 99,
  [730] = 83,
  [731] = 67,
  [732] = 59,
  [733] = 16,
  [734] = 21,
  [735] = 20,
  [736] = 19,
  [737] = 93,
  [738] = 92,
  [739] = 15,
  [740] = 71,
  [741] = 54,
  [742] = 51,
  [743] = 105,
  [744] = 52,
  [745] = 53,
  [746] = 17,
  [747] = 747,
  [748] = 747,
  [749] = 113,
  [750] = 747,
  [751] = 113,
  [752] = 747,
  [753] = 16,
  [754] = 21,
  [755] = 747,
  [756] = 747,
  [757] = 20,
  [758] = 108,
  [759] = 19,
  [760] = 18,
  [761] = 747,
  [762] = 747,
  [763] = 15,
  [764] = 113,
  [765] = 17,
  [766] = 747,
  [767] = 747,
  [768] = 747,
  [769] = 747,
  [770] = 747,
  [771] = 747,
  [772] = 747,
  [773] = 747,
  [774] = 747,
  [775] = 775,
  [776] = 775,
  [777] = 17,
  [778] = 778,
  [779] = 113,
  [780] = 775,
  [781] = 775,
  [782] = 105,
  [783] = 775,
  [784] = 778,
  [785] = 775,
  [786] = 775,
  [787] = 778,
  [788] = 20,
  [789] = 775,
  [790] = 97,
  [791] = 775,
  [792] = 775,
  [793] = 775,
  [794] = 778,
  [795] = 778,
  [796] = 778,
  [797] = 778,
  [798] = 15,
  [799] = 778,
  [800] = 775,
  [801] = 775,
  [802] = 21,
  [803] = 775,
  [804] = 775,
  [805] = 778,
  [806] = 18,
  [807] = 807,
  [808] = 775,
  [809] = 809,
  [810] = 775,
  [811] = 19,
  [812] = 778,
  [813] = 807,
  [814] = 16,
  [815] = 809,
  [816] = 778,
  [817] = 817,
  [818] = 57,
  [819] = 21,
  [820] = 17,
  [821] = 15,
  [822] = 18,
  [823] = 19,
  [824] = 20,
  [825] = 113,
  [826] = 826,
  [827] = 827,
  [828] = 16,
  [829] = 829,
  [830] = 72,
  [831] = 831,
  [832] = 831,
  [833] = 833,
  [834] = 831,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 831,
  [839] = 836,
  [840] = 836,
  [841] = 841,
  [842] = 835,
  [843] = 843,
  [844] = 833,
  [845] = 835,
  [846] = 841,
  [847] = 831,
  [848] = 837,
  [849] = 836,
  [850] = 833,
  [851] = 831,
  [852] = 841,
  [853] = 833,
  [854] = 835,
  [855] = 841,
  [856] = 835,
  [857] = 836,
  [858] = 833,
  [859] = 833,
  [860] = 841,
  [861] = 837,
  [862] = 837,
  [863] = 837,
  [864] = 837,
  [865] = 831,
  [866] = 841,
  [867] = 841,
  [868] = 841,
  [869] = 835,
  [870] = 836,
  [871] = 835,
  [872] = 833,
  [873] = 836,
  [874] = 833,
  [875] = 831,
  [876] = 841,
  [877] = 836,
  [878] = 835,
  [879] = 836,
  [880] = 837,
  [881] = 837,
  [882] = 837,
  [883] = 837,
  [884] = 841,
  [885] = 833,
  [886] = 833,
  [887] = 837,
  [888] = 888,
  [889] = 835,
  [890] = 837,
  [891] = 831,
  [892] = 835,
  [893] = 836,
  [894] = 831,
  [895] = 841,
  [896] = 836,
  [897] = 833,
  [898] = 835,
  [899] = 841,
  [900] = 836,
  [901] = 888,
  [902] = 837,
  [903] = 831,
  [904] = 835,
  [905] = 837,
  [906] = 831,
  [907] = 833,
  [908] = 836,
  [909] = 841,
  [910] = 831,
  [911] = 843,
  [912] = 841,
  [913] = 831,
  [914] = 833,
  [915] = 835,
  [916] = 916,
  [917] = 843,
  [918] = 835,
  [919] = 919,
  [920] = 833,
  [921] = 836,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 74,
  [939] = 57,
  [940] = 940,
  [941] = 60,
  [942] = 72,
  [943] = 943,
  [944] = 57,
  [945] = 943,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 946,
  [951] = 951,
  [952] = 933,
  [953] = 57,
  [954] = 954,
  [955] = 57,
  [956] = 74,
  [957] = 57,
  [958] = 57,
  [959] = 60,
  [960] = 72,
  [961] = 80,
  [962] = 128,
  [963] = 146,
  [964] = 108,
  [965] = 108,
  [966] = 108,
  [967] = 108,
  [968] = 108,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 57,
  [973] = 970,
  [974] = 969,
  [975] = 105,
  [976] = 976,
  [977] = 977,
  [978] = 108,
  [979] = 979,
  [980] = 108,
  [981] = 979,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 105,
  [987] = 108,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 113,
  [993] = 113,
  [994] = 113,
  [995] = 995,
  [996] = 996,
  [997] = 120,
  [998] = 998,
  [999] = 113,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 108,
  [1004] = 105,
  [1005] = 1005,
  [1006] = 126,
  [1007] = 1007,
  [1008] = 120,
  [1009] = 115,
  [1010] = 115,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 113,
  [1016] = 108,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 113,
  [1022] = 1022,
  [1023] = 113,
  [1024] = 60,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1001,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1025,
  [1036] = 1036,
  [1037] = 131,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 129,
  [1041] = 130,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 129,
  [1046] = 130,
  [1047] = 1047,
  [1048] = 131,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1054,
  [1060] = 113,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 119,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1054,
  [1076] = 1051,
  [1077] = 113,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1043,
  [1085] = 1064,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1080,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 113,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 105,
  [1103] = 114,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 116,
  [1108] = 1065,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 111,
  [1112] = 1112,
  [1113] = 1039,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1039,
  [1119] = 1119,
  [1120] = 105,
  [1121] = 1121,
  [1122] = 118,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1131,
  [1133] = 1124,
  [1134] = 1131,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1124,
  [1139] = 1124,
  [1140] = 1140,
  [1141] = 1124,
  [1142] = 1142,
  [1143] = 1124,
  [1144] = 1144,
  [1145] = 1125,
  [1146] = 1127,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1124,
  [1150] = 1150,
  [1151] = 1124,
  [1152] = 1124,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1129,
  [1156] = 1154,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1124,
  [1160] = 1160,
  [1161] = 1126,
  [1162] = 1124,
  [1163] = 1163,
  [1164] = 1124,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1124,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1144,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1154,
  [1174] = 1124,
  [1175] = 1140,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1136,
  [1182] = 1182,
  [1183] = 1160,
  [1184] = 1184,
  [1185] = 1168,
  [1186] = 1137,
  [1187] = 1136,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1191,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1196,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1191,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1191,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1195,
  [1215] = 1215,
  [1216] = 1191,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1215,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1191,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1191,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1191,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1191,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1217,
  [1240] = 1240,
  [1241] = 1241,
  [1242] = 1242,
  [1243] = 1230,
  [1244] = 1191,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1191,
  [1251] = 1191,
  [1252] = 105,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1191,
  [1258] = 1191,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1217,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1264,
  [1271] = 1271,
  [1272] = 1269,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1275,
  [1278] = 1278,
  [1279] = 1278,
  [1280] = 1274,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1295,
  [1296] = 1283,
  [1297] = 1297,
  [1298] = 1269,
  [1299] = 1283,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1295,
  [1303] = 1273,
  [1304] = 1281,
  [1305] = 1293,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1282,
  [1310] = 1281,
  [1311] = 1311,
  [1312] = 1264,
  [1313] = 1269,
  [1314] = 1275,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1264,
  [1320] = 1320,
  [1321] = 1269,
  [1322] = 1322,
  [1323] = 1264,
  [1324] = 1269,
  [1325] = 1275,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1264,
  [1329] = 1269,
  [1330] = 1275,
  [1331] = 1331,
  [1332] = 1275,
  [1333] = 1264,
  [1334] = 1269,
  [1335] = 1275,
  [1336] = 1336,
  [1337] = 1264,
  [1338] = 1269,
  [1339] = 1275,
  [1340] = 1311,
  [1341] = 1264,
  [1342] = 1269,
  [1343] = 1275,
  [1344] = 1344,
  [1345] = 1264,
  [1346] = 1275,
  [1347] = 1347,
  [1348] = 1264,
  [1349] = 1269,
  [1350] = 1275,
  [1351] = 1351,
  [1352] = 1264,
  [1353] = 1269,
  [1354] = 1275,
  [1355] = 1355,
  [1356] = 1264,
  [1357] = 1269,
  [1358] = 1275,
  [1359] = 1317,
  [1360] = 1282,
  [1361] = 1266,
  [1362] = 1264,
  [1363] = 1275,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(42);
      ADVANCE_MAP(
        '!', 67,
        '"', 120,
        '#', 43,
        '$', 126,
        '%', 72,
        '&', 79,
        '\'', 110,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 69,
        '.', 59,
        '/', 74,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        '\\', 31,
        ']', 57,
        '^', 81,
        '_', 98,
        'e', 137,
        '{', 127,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(38);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 67,
        '%', 72,
        '&', 79,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 69,
        '.', 59,
        '/', 74,
        ':', 53,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '[', 56,
        '^', 81,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 67,
        '%', 72,
        '&', 79,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 68,
        '.', 59,
        '/', 74,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        ']', 57,
        '^', 81,
        '{', 51,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(2);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '"', 120,
        '\'', 110,
        '(', 49,
        ')', 50,
        ',', 54,
        '-', 19,
        '.', 58,
        '/', 12,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 86,
        '=', 96,
        '>', 89,
        '?', 60,
        '[', 56,
        ']', 57,
        '_', 98,
        '{', 51,
        '}', 52,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(3);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '"', 120,
        '\'', 110,
        '(', 49,
        ')', 50,
        ',', 54,
        '-', 19,
        '/', 12,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 86,
        '=', 94,
        '>', 89,
        '?', 60,
        '@', 63,
        '[', 56,
        ']', 57,
        '_', 98,
        '{', 51,
        '}', 52,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(120);
      if (lookahead == '/') ADVANCE(122);
      if (lookahead == '\\') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(123);
      if (lookahead != 0) ADVANCE(121);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '"', 111,
        '$', 126,
        '\'', 110,
        '.', 58,
        '/', 116,
        '0', 100,
        ':', 53,
        '=', 117,
        '?', 60,
        '[', 56,
        '\\', 119,
        '_', 98,
        '{', 51,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(112);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '"', 111,
        '$', 126,
        '\'', 110,
        '/', 116,
        '0', 100,
        '[', 56,
        '\\', 119,
        '_', 98,
        '{', 51,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '$', 126,
        '\'', 110,
        '.', 58,
        '/', 116,
        ':', 53,
        '=', 117,
        '?', 60,
        '\\', 119,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(114);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 9:
      if (lookahead == '$') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(110);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(119);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(115);
      if (lookahead != 0) ADVANCE(111);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '(', 49,
        ')', 50,
        ',', 54,
        '-', 19,
        '/', 12,
        '=', 94,
        '>', 89,
        '{', 51,
        '}', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(10);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '(', 49,
        ')', 50,
        ',', 54,
        '.', 58,
        '/', 12,
        ':', 53,
        ';', 143,
        '<', 86,
        '=', 20,
        '?', 60,
        ']', 57,
        '{', 51,
        '}', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(132);
      END_STATE();
    case 13:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == '*') ADVANCE(13);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(97);
      END_STATE();
    case 16:
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '0') ADVANCE(104);
      if (lookahead == '_') ADVANCE(102);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(105);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(16);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 17:
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '0') ADVANCE(104);
      if (lookahead == 'e') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(18);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(105);
      END_STATE();
    case 18:
      if (lookahead == '/') ADVANCE(12);
      if (lookahead == '0') ADVANCE(104);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(18);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(105);
      END_STATE();
    case 19:
      if (lookahead == '>') ADVANCE(62);
      END_STATE();
    case 20:
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(45);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 24:
      if (lookahead == 'f') ADVANCE(65);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(44);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(24);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(22);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(23);
      END_STATE();
    case 30:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(130);
      if (lookahead != 0) ADVANCE(128);
      END_STATE();
    case 32:
      if (lookahead == 'y') ADVANCE(28);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(128);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 38:
      if (eof) ADVANCE(42);
      ADVANCE_MAP(
        '!', 67,
        '"', 120,
        '#', 43,
        '$', 126,
        '%', 72,
        '&', 79,
        '\'', 110,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 69,
        '.', 59,
        '/', 74,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        ']', 57,
        '^', 81,
        '_', 98,
        'e', 138,
        '{', 51,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(38);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 39:
      if (eof) ADVANCE(42);
      ADVANCE_MAP(
        '!', 67,
        '"', 120,
        '#', 43,
        '$', 30,
        '%', 72,
        '&', 79,
        '\'', 110,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 69,
        '.', 59,
        '/', 74,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        '^', 81,
        '_', 98,
        '{', 51,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(39);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 40:
      if (eof) ADVANCE(42);
      ADVANCE_MAP(
        '!', 67,
        '"', 120,
        '#', 43,
        '$', 30,
        '%', 72,
        '&', 79,
        '\'', 110,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 68,
        '.', 59,
        '/', 74,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        ']', 57,
        '^', 81,
        '_', 98,
        'e', 138,
        '{', 51,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(40);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 41:
      if (eof) ADVANCE(42);
      ADVANCE_MAP(
        '!', 67,
        '"', 120,
        '#', 43,
        '$', 30,
        '%', 72,
        '&', 79,
        '\'', 110,
        '(', 49,
        ')', 50,
        '*', 73,
        '+', 75,
        ',', 54,
        '-', 68,
        '.', 59,
        '/', 74,
        '0', 100,
        ':', 53,
        ';', 143,
        '<', 87,
        '=', 95,
        '>', 90,
        '?', 61,
        '@', 63,
        '[', 56,
        ']', 57,
        '^', 81,
        '_', 98,
        '{', 51,
        '|', 80,
        '}', 52,
        '~', 66,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(aux_sym_preprocessor_statement_token1);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_preprocessor_statement_token2);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_preprocessor_statement_token2);
      if (lookahead == ' ') ADVANCE(26);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_preprocessor_statement_token2);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_preprocessor_statement_token2);
      if (lookahead == 'i') ADVANCE(25);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DOLLARtype);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(15);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(93);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == ':') ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_AT_COLON);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(71);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(71);
      if (lookahead == '>') ADVANCE(62);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(132);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(70);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(82);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '>') ADVANCE(77);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym__rangeOperator);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(142);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == 'x') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(101);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '.') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(101);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '_') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(103);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == '_') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(103);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(142);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (lookahead == 'x') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_integer_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_integer_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == 'e') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == 'e') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_float_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_string_token2);
      ADVANCE_MAP(
        '"', 111,
        '$', 126,
        '.', 58,
        '/', 116,
        '0', 100,
        ':', 53,
        '=', 117,
        '?', 60,
        '[', 56,
        '_', 98,
        '{', 51,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(112);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(111);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(126);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == '0') ADVANCE(100);
      if (lookahead == '[') ADVANCE(56);
      if (lookahead == '_') ADVANCE(98);
      if (lookahead == '{') ADVANCE(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(101);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(111);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '$') ADVANCE(126);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == ':') ADVANCE(53);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '?') ADVANCE(60);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(114);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(111);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '$') ADVANCE(126);
      if (lookahead == '/') ADVANCE(116);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(115);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(111);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(132);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(130);
      if (lookahead != 0) ADVANCE(128);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_string_token3);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_string_token4);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_string_token4);
      if (lookahead == '*') ADVANCE(14);
      if (lookahead == '/') ADVANCE(132);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym_string_token4);
      if (lookahead == '/') ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(123);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(121);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_string_token4);
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(130);
      if (lookahead != 0) ADVANCE(128);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{') ADVANCE(125);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(129);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ' ') ADVANCE(26);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'd') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'e') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'e') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'l') ADVANCE(139);
      if (lookahead == 'n') ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'l') ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 's') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 's') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'B', 1,
        'F', 2,
        'I', 3,
        'N', 4,
        'V', 5,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'i', 14,
        'm', 15,
        'n', 16,
        'o', 17,
        'p', 18,
        'r', 19,
        's', 20,
        't', 21,
        'u', 22,
        'v', 23,
        'w', 24,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'l') ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == 'n') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 7:
      if (lookahead == 'b') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(31);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      if (lookahead == 'y') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(40);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(45);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(46);
      if (lookahead == 'm') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(48);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(49);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 17:
      if (lookahead == 'p') ADVANCE(52);
      if (lookahead == 'v') ADVANCE(53);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'r') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 't') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(64);
      if (lookahead == 's') ADVANCE(65);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(67);
      END_STATE();
    case 25:
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(69);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(71);
      END_STATE();
    case 29:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(73);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 32:
      if (lookahead == 's') ADVANCE(75);
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 35:
      if (lookahead == 'f') ADVANCE(79);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 38:
      if (lookahead == 's') ADVANCE(81);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 41:
      if (lookahead == 'l') ADVANCE(84);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 43:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(89);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(90);
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(92);
      END_STATE();
    case 50:
      if (lookahead == 'v') ADVANCE(93);
      if (lookahead == 'w') ADVANCE(94);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(95);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 54:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 56:
      if (lookahead == 'b') ADVANCE(100);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(104);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(105);
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 62:
      if (lookahead == 'u') ADVANCE(107);
      if (lookahead == 'y') ADVANCE(108);
      END_STATE();
    case 63:
      if (lookahead == 'p') ADVANCE(109);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 66:
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(115);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_Int);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(116);
      END_STATE();
    case 72:
      if (lookahead == 'd') ADVANCE(117);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(119);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(120);
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 76:
      if (lookahead == 'c') ADVANCE(122);
      END_STATE();
    case 77:
      if (lookahead == 's') ADVANCE(123);
      END_STATE();
    case 78:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(126);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 82:
      if (lookahead == 'm') ADVANCE(128);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(132);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(133);
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 98:
      if (lookahead == 'k') ADVANCE(142);
      END_STATE();
    case 99:
      if (lookahead == 'v') ADVANCE(143);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(144);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 105:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 106:
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 110:
      if (lookahead == 'y') ADVANCE(152);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_Bool);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_Null);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_Void);
      END_STATE();
    case 118:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 119:
      if (lookahead == 'k') ADVANCE(157);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_cast);
      END_STATE();
    case 122:
      if (lookahead == 'h') ADVANCE(158);
      END_STATE();
    case 123:
      if (lookahead == 's') ADVANCE(159);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(161);
      END_STATE();
    case 126:
      if (lookahead == 'm') ADVANCE(162);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 129:
      if (lookahead == 'n') ADVANCE(163);
      if (lookahead == 'r') ADVANCE(164);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(169);
      END_STATE();
    case 135:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(171);
      END_STATE();
    case 137:
      if (lookahead == 'o') ADVANCE(172);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(174);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(175);
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(177);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(178);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 146:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 147:
      if (lookahead == 'c') ADVANCE(182);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 149:
      if (lookahead == 'w') ADVANCE(183);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 151:
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 152:
      if (lookahead == 'p') ADVANCE(185);
      END_STATE();
    case 153:
      if (lookahead == 'g') ADVANCE(186);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_Float);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(189);
      END_STATE();
    case 161:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 162:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 163:
      if (lookahead == 'd') ADVANCE(192);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 168:
      if (lookahead == 'm') ADVANCE(195);
      END_STATE();
    case 169:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 170:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 171:
      if (lookahead == 'f') ADVANCE(198);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 174:
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 175:
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 177:
      if (lookahead == 'g') ADVANCE(202);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(203);
      END_STATE();
    case 179:
      if (lookahead == 'c') ADVANCE(204);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 181:
      if (lookahead == 'c') ADVANCE(206);
      END_STATE();
    case 182:
      if (lookahead == 'h') ADVANCE(207);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 188:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 189:
      if (lookahead == 'u') ADVANCE(211);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 191:
      if (lookahead == 'c') ADVANCE(213);
      END_STATE();
    case 192:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 194:
      if (lookahead == 'o') ADVANCE(215);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 199:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 200:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 201:
      if (lookahead == 'd') ADVANCE(220);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 203:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 208:
      if (lookahead == 'f') ADVANCE(223);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(224);
      END_STATE();
    case 210:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(227);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(228);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(229);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 219:
      if (lookahead == 'd') ADVANCE(231);
      END_STATE();
    case 220:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_untyped);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 229:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_overload);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 233:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 41},
  [2] = {.lex_state = 41},
  [3] = {.lex_state = 41},
  [4] = {.lex_state = 41},
  [5] = {.lex_state = 41},
  [6] = {.lex_state = 41},
  [7] = {.lex_state = 41},
  [8] = {.lex_state = 41},
  [9] = {.lex_state = 41},
  [10] = {.lex_state = 41},
  [11] = {.lex_state = 41},
  [12] = {.lex_state = 41},
  [13] = {.lex_state = 41},
  [14] = {.lex_state = 41},
  [15] = {.lex_state = 41},
  [16] = {.lex_state = 41},
  [17] = {.lex_state = 41},
  [18] = {.lex_state = 41},
  [19] = {.lex_state = 41},
  [20] = {.lex_state = 41},
  [21] = {.lex_state = 41},
  [22] = {.lex_state = 41},
  [23] = {.lex_state = 41},
  [24] = {.lex_state = 41},
  [25] = {.lex_state = 41},
  [26] = {.lex_state = 39},
  [27] = {.lex_state = 39},
  [28] = {.lex_state = 39},
  [29] = {.lex_state = 39},
  [30] = {.lex_state = 39},
  [31] = {.lex_state = 41},
  [32] = {.lex_state = 41},
  [33] = {.lex_state = 41},
  [34] = {.lex_state = 39},
  [35] = {.lex_state = 41},
  [36] = {.lex_state = 41},
  [37] = {.lex_state = 41},
  [38] = {.lex_state = 39},
  [39] = {.lex_state = 41},
  [40] = {.lex_state = 41},
  [41] = {.lex_state = 41},
  [42] = {.lex_state = 41},
  [43] = {.lex_state = 41},
  [44] = {.lex_state = 41},
  [45] = {.lex_state = 41},
  [46] = {.lex_state = 41},
  [47] = {.lex_state = 41},
  [48] = {.lex_state = 41},
  [49] = {.lex_state = 41},
  [50] = {.lex_state = 41},
  [51] = {.lex_state = 40},
  [52] = {.lex_state = 40},
  [53] = {.lex_state = 40},
  [54] = {.lex_state = 40},
  [55] = {.lex_state = 41},
  [56] = {.lex_state = 41},
  [57] = {.lex_state = 41},
  [58] = {.lex_state = 41},
  [59] = {.lex_state = 41},
  [60] = {.lex_state = 41},
  [61] = {.lex_state = 41},
  [62] = {.lex_state = 41},
  [63] = {.lex_state = 41},
  [64] = {.lex_state = 41},
  [65] = {.lex_state = 41},
  [66] = {.lex_state = 41},
  [67] = {.lex_state = 41},
  [68] = {.lex_state = 41},
  [69] = {.lex_state = 39},
  [70] = {.lex_state = 41},
  [71] = {.lex_state = 41},
  [72] = {.lex_state = 41},
  [73] = {.lex_state = 41},
  [74] = {.lex_state = 41},
  [75] = {.lex_state = 41},
  [76] = {.lex_state = 41},
  [77] = {.lex_state = 41},
  [78] = {.lex_state = 41},
  [79] = {.lex_state = 41},
  [80] = {.lex_state = 41},
  [81] = {.lex_state = 41},
  [82] = {.lex_state = 41},
  [83] = {.lex_state = 41},
  [84] = {.lex_state = 41},
  [85] = {.lex_state = 41},
  [86] = {.lex_state = 41},
  [87] = {.lex_state = 41},
  [88] = {.lex_state = 41},
  [89] = {.lex_state = 41},
  [90] = {.lex_state = 41},
  [91] = {.lex_state = 41},
  [92] = {.lex_state = 41},
  [93] = {.lex_state = 41},
  [94] = {.lex_state = 41},
  [95] = {.lex_state = 41},
  [96] = {.lex_state = 41},
  [97] = {.lex_state = 41},
  [98] = {.lex_state = 41},
  [99] = {.lex_state = 41},
  [100] = {.lex_state = 41},
  [101] = {.lex_state = 39},
  [102] = {.lex_state = 39},
  [103] = {.lex_state = 41},
  [104] = {.lex_state = 41},
  [105] = {.lex_state = 41},
  [106] = {.lex_state = 41},
  [107] = {.lex_state = 41},
  [108] = {.lex_state = 41},
  [109] = {.lex_state = 41},
  [110] = {.lex_state = 41},
  [111] = {.lex_state = 39},
  [112] = {.lex_state = 41},
  [113] = {.lex_state = 41},
  [114] = {.lex_state = 39},
  [115] = {.lex_state = 39},
  [116] = {.lex_state = 39},
  [117] = {.lex_state = 41},
  [118] = {.lex_state = 39},
  [119] = {.lex_state = 41},
  [120] = {.lex_state = 39},
  [121] = {.lex_state = 41},
  [122] = {.lex_state = 41},
  [123] = {.lex_state = 41},
  [124] = {.lex_state = 39},
  [125] = {.lex_state = 39},
  [126] = {.lex_state = 39},
  [127] = {.lex_state = 39},
  [128] = {.lex_state = 39},
  [129] = {.lex_state = 39},
  [130] = {.lex_state = 39},
  [131] = {.lex_state = 39},
  [132] = {.lex_state = 39},
  [133] = {.lex_state = 41},
  [134] = {.lex_state = 39},
  [135] = {.lex_state = 41},
  [136] = {.lex_state = 40},
  [137] = {.lex_state = 41},
  [138] = {.lex_state = 39},
  [139] = {.lex_state = 39},
  [140] = {.lex_state = 41},
  [141] = {.lex_state = 39},
  [142] = {.lex_state = 41},
  [143] = {.lex_state = 39},
  [144] = {.lex_state = 39},
  [145] = {.lex_state = 41},
  [146] = {.lex_state = 39},
  [147] = {.lex_state = 39},
  [148] = {.lex_state = 39},
  [149] = {.lex_state = 39},
  [150] = {.lex_state = 41},
  [151] = {.lex_state = 39},
  [152] = {.lex_state = 41},
  [153] = {.lex_state = 39},
  [154] = {.lex_state = 41},
  [155] = {.lex_state = 39},
  [156] = {.lex_state = 41},
  [157] = {.lex_state = 41},
  [158] = {.lex_state = 41},
  [159] = {.lex_state = 39},
  [160] = {.lex_state = 41},
  [161] = {.lex_state = 39},
  [162] = {.lex_state = 40},
  [163] = {.lex_state = 41},
  [164] = {.lex_state = 41},
  [165] = {.lex_state = 39},
  [166] = {.lex_state = 40},
  [167] = {.lex_state = 40},
  [168] = {.lex_state = 39},
  [169] = {.lex_state = 41},
  [170] = {.lex_state = 41},
  [171] = {.lex_state = 41},
  [172] = {.lex_state = 41},
  [173] = {.lex_state = 41},
  [174] = {.lex_state = 41},
  [175] = {.lex_state = 41},
  [176] = {.lex_state = 41},
  [177] = {.lex_state = 41},
  [178] = {.lex_state = 41},
  [179] = {.lex_state = 41},
  [180] = {.lex_state = 41},
  [181] = {.lex_state = 41},
  [182] = {.lex_state = 41},
  [183] = {.lex_state = 41},
  [184] = {.lex_state = 41},
  [185] = {.lex_state = 41},
  [186] = {.lex_state = 41},
  [187] = {.lex_state = 41},
  [188] = {.lex_state = 41},
  [189] = {.lex_state = 41},
  [190] = {.lex_state = 41},
  [191] = {.lex_state = 41},
  [192] = {.lex_state = 41},
  [193] = {.lex_state = 41},
  [194] = {.lex_state = 41},
  [195] = {.lex_state = 41},
  [196] = {.lex_state = 41},
  [197] = {.lex_state = 41},
  [198] = {.lex_state = 41},
  [199] = {.lex_state = 41},
  [200] = {.lex_state = 41},
  [201] = {.lex_state = 41},
  [202] = {.lex_state = 41},
  [203] = {.lex_state = 41},
  [204] = {.lex_state = 41},
  [205] = {.lex_state = 41},
  [206] = {.lex_state = 41},
  [207] = {.lex_state = 41},
  [208] = {.lex_state = 41},
  [209] = {.lex_state = 41},
  [210] = {.lex_state = 41},
  [211] = {.lex_state = 41},
  [212] = {.lex_state = 41},
  [213] = {.lex_state = 41},
  [214] = {.lex_state = 41},
  [215] = {.lex_state = 41},
  [216] = {.lex_state = 41},
  [217] = {.lex_state = 41},
  [218] = {.lex_state = 41},
  [219] = {.lex_state = 41},
  [220] = {.lex_state = 41},
  [221] = {.lex_state = 41},
  [222] = {.lex_state = 41},
  [223] = {.lex_state = 41},
  [224] = {.lex_state = 41},
  [225] = {.lex_state = 41},
  [226] = {.lex_state = 41},
  [227] = {.lex_state = 41},
  [228] = {.lex_state = 41},
  [229] = {.lex_state = 41},
  [230] = {.lex_state = 41},
  [231] = {.lex_state = 41},
  [232] = {.lex_state = 41},
  [233] = {.lex_state = 41},
  [234] = {.lex_state = 41},
  [235] = {.lex_state = 41},
  [236] = {.lex_state = 41},
  [237] = {.lex_state = 41},
  [238] = {.lex_state = 41},
  [239] = {.lex_state = 41},
  [240] = {.lex_state = 41},
  [241] = {.lex_state = 41},
  [242] = {.lex_state = 41},
  [243] = {.lex_state = 41},
  [244] = {.lex_state = 41},
  [245] = {.lex_state = 41},
  [246] = {.lex_state = 41},
  [247] = {.lex_state = 41},
  [248] = {.lex_state = 41},
  [249] = {.lex_state = 41},
  [250] = {.lex_state = 41},
  [251] = {.lex_state = 41},
  [252] = {.lex_state = 41},
  [253] = {.lex_state = 41},
  [254] = {.lex_state = 41},
  [255] = {.lex_state = 41},
  [256] = {.lex_state = 41},
  [257] = {.lex_state = 41},
  [258] = {.lex_state = 41},
  [259] = {.lex_state = 41},
  [260] = {.lex_state = 41},
  [261] = {.lex_state = 41},
  [262] = {.lex_state = 41},
  [263] = {.lex_state = 41},
  [264] = {.lex_state = 41},
  [265] = {.lex_state = 41},
  [266] = {.lex_state = 41},
  [267] = {.lex_state = 41},
  [268] = {.lex_state = 41},
  [269] = {.lex_state = 41},
  [270] = {.lex_state = 41},
  [271] = {.lex_state = 41},
  [272] = {.lex_state = 41},
  [273] = {.lex_state = 41},
  [274] = {.lex_state = 41},
  [275] = {.lex_state = 41},
  [276] = {.lex_state = 41},
  [277] = {.lex_state = 41},
  [278] = {.lex_state = 41},
  [279] = {.lex_state = 41},
  [280] = {.lex_state = 41},
  [281] = {.lex_state = 41},
  [282] = {.lex_state = 41},
  [283] = {.lex_state = 41},
  [284] = {.lex_state = 41},
  [285] = {.lex_state = 41},
  [286] = {.lex_state = 41},
  [287] = {.lex_state = 41},
  [288] = {.lex_state = 41},
  [289] = {.lex_state = 41},
  [290] = {.lex_state = 41},
  [291] = {.lex_state = 41},
  [292] = {.lex_state = 41},
  [293] = {.lex_state = 41},
  [294] = {.lex_state = 41},
  [295] = {.lex_state = 41},
  [296] = {.lex_state = 41},
  [297] = {.lex_state = 41},
  [298] = {.lex_state = 41},
  [299] = {.lex_state = 41},
  [300] = {.lex_state = 41},
  [301] = {.lex_state = 41},
  [302] = {.lex_state = 41},
  [303] = {.lex_state = 41},
  [304] = {.lex_state = 41},
  [305] = {.lex_state = 41},
  [306] = {.lex_state = 41},
  [307] = {.lex_state = 41},
  [308] = {.lex_state = 41},
  [309] = {.lex_state = 41},
  [310] = {.lex_state = 41},
  [311] = {.lex_state = 41},
  [312] = {.lex_state = 41},
  [313] = {.lex_state = 41},
  [314] = {.lex_state = 41},
  [315] = {.lex_state = 41},
  [316] = {.lex_state = 41},
  [317] = {.lex_state = 41},
  [318] = {.lex_state = 41},
  [319] = {.lex_state = 41},
  [320] = {.lex_state = 41},
  [321] = {.lex_state = 41},
  [322] = {.lex_state = 41},
  [323] = {.lex_state = 41},
  [324] = {.lex_state = 41},
  [325] = {.lex_state = 41},
  [326] = {.lex_state = 41},
  [327] = {.lex_state = 41},
  [328] = {.lex_state = 41},
  [329] = {.lex_state = 41},
  [330] = {.lex_state = 41},
  [331] = {.lex_state = 41},
  [332] = {.lex_state = 41},
  [333] = {.lex_state = 41},
  [334] = {.lex_state = 41},
  [335] = {.lex_state = 41},
  [336] = {.lex_state = 41},
  [337] = {.lex_state = 41},
  [338] = {.lex_state = 41},
  [339] = {.lex_state = 41},
  [340] = {.lex_state = 41},
  [341] = {.lex_state = 41},
  [342] = {.lex_state = 41},
  [343] = {.lex_state = 41},
  [344] = {.lex_state = 41},
  [345] = {.lex_state = 41},
  [346] = {.lex_state = 41},
  [347] = {.lex_state = 41},
  [348] = {.lex_state = 41},
  [349] = {.lex_state = 41},
  [350] = {.lex_state = 41},
  [351] = {.lex_state = 41},
  [352] = {.lex_state = 41},
  [353] = {.lex_state = 41},
  [354] = {.lex_state = 41},
  [355] = {.lex_state = 41},
  [356] = {.lex_state = 41},
  [357] = {.lex_state = 41},
  [358] = {.lex_state = 41},
  [359] = {.lex_state = 41},
  [360] = {.lex_state = 41},
  [361] = {.lex_state = 41},
  [362] = {.lex_state = 41},
  [363] = {.lex_state = 41},
  [364] = {.lex_state = 41},
  [365] = {.lex_state = 41},
  [366] = {.lex_state = 41},
  [367] = {.lex_state = 41},
  [368] = {.lex_state = 41},
  [369] = {.lex_state = 41},
  [370] = {.lex_state = 41},
  [371] = {.lex_state = 41},
  [372] = {.lex_state = 41},
  [373] = {.lex_state = 41},
  [374] = {.lex_state = 41},
  [375] = {.lex_state = 41},
  [376] = {.lex_state = 41},
  [377] = {.lex_state = 41},
  [378] = {.lex_state = 41},
  [379] = {.lex_state = 41},
  [380] = {.lex_state = 41},
  [381] = {.lex_state = 41},
  [382] = {.lex_state = 41},
  [383] = {.lex_state = 41},
  [384] = {.lex_state = 41},
  [385] = {.lex_state = 41},
  [386] = {.lex_state = 41},
  [387] = {.lex_state = 41},
  [388] = {.lex_state = 41},
  [389] = {.lex_state = 41},
  [390] = {.lex_state = 41},
  [391] = {.lex_state = 41},
  [392] = {.lex_state = 41},
  [393] = {.lex_state = 41},
  [394] = {.lex_state = 41},
  [395] = {.lex_state = 41},
  [396] = {.lex_state = 41},
  [397] = {.lex_state = 41},
  [398] = {.lex_state = 41},
  [399] = {.lex_state = 41},
  [400] = {.lex_state = 41},
  [401] = {.lex_state = 41},
  [402] = {.lex_state = 4},
  [403] = {.lex_state = 41},
  [404] = {.lex_state = 41},
  [405] = {.lex_state = 41},
  [406] = {.lex_state = 41},
  [407] = {.lex_state = 41},
  [408] = {.lex_state = 41},
  [409] = {.lex_state = 41},
  [410] = {.lex_state = 41},
  [411] = {.lex_state = 41},
  [412] = {.lex_state = 41},
  [413] = {.lex_state = 41},
  [414] = {.lex_state = 41},
  [415] = {.lex_state = 41},
  [416] = {.lex_state = 41},
  [417] = {.lex_state = 41},
  [418] = {.lex_state = 41},
  [419] = {.lex_state = 41},
  [420] = {.lex_state = 41},
  [421] = {.lex_state = 39},
  [422] = {.lex_state = 39},
  [423] = {.lex_state = 41},
  [424] = {.lex_state = 39},
  [425] = {.lex_state = 39},
  [426] = {.lex_state = 39},
  [427] = {.lex_state = 39},
  [428] = {.lex_state = 39},
  [429] = {.lex_state = 41},
  [430] = {.lex_state = 41},
  [431] = {.lex_state = 41},
  [432] = {.lex_state = 41},
  [433] = {.lex_state = 41},
  [434] = {.lex_state = 41},
  [435] = {.lex_state = 41},
  [436] = {.lex_state = 41},
  [437] = {.lex_state = 41},
  [438] = {.lex_state = 41},
  [439] = {.lex_state = 41},
  [440] = {.lex_state = 41},
  [441] = {.lex_state = 41},
  [442] = {.lex_state = 41},
  [443] = {.lex_state = 41},
  [444] = {.lex_state = 41},
  [445] = {.lex_state = 41},
  [446] = {.lex_state = 41},
  [447] = {.lex_state = 41},
  [448] = {.lex_state = 41},
  [449] = {.lex_state = 41},
  [450] = {.lex_state = 41},
  [451] = {.lex_state = 41},
  [452] = {.lex_state = 41},
  [453] = {.lex_state = 41},
  [454] = {.lex_state = 39},
  [455] = {.lex_state = 39},
  [456] = {.lex_state = 39},
  [457] = {.lex_state = 39},
  [458] = {.lex_state = 41},
  [459] = {.lex_state = 41},
  [460] = {.lex_state = 41},
  [461] = {.lex_state = 41},
  [462] = {.lex_state = 41},
  [463] = {.lex_state = 41},
  [464] = {.lex_state = 41},
  [465] = {.lex_state = 41},
  [466] = {.lex_state = 41},
  [467] = {.lex_state = 41},
  [468] = {.lex_state = 2},
  [469] = {.lex_state = 41},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 41},
  [472] = {.lex_state = 41},
  [473] = {.lex_state = 41},
  [474] = {.lex_state = 41},
  [475] = {.lex_state = 2},
  [476] = {.lex_state = 41},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 2},
  [479] = {.lex_state = 2},
  [480] = {.lex_state = 2},
  [481] = {.lex_state = 2},
  [482] = {.lex_state = 2},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 2},
  [486] = {.lex_state = 41},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 41},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 41},
  [492] = {.lex_state = 41},
  [493] = {.lex_state = 41},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 41},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 2},
  [498] = {.lex_state = 2},
  [499] = {.lex_state = 41},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 41},
  [504] = {.lex_state = 41},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 41},
  [509] = {.lex_state = 2},
  [510] = {.lex_state = 41},
  [511] = {.lex_state = 41},
  [512] = {.lex_state = 41},
  [513] = {.lex_state = 41},
  [514] = {.lex_state = 41},
  [515] = {.lex_state = 41},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 2},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 41},
  [520] = {.lex_state = 0},
  [521] = {.lex_state = 41},
  [522] = {.lex_state = 41},
  [523] = {.lex_state = 41},
  [524] = {.lex_state = 41},
  [525] = {.lex_state = 41},
  [526] = {.lex_state = 41},
  [527] = {.lex_state = 41},
  [528] = {.lex_state = 41},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 2},
  [531] = {.lex_state = 41},
  [532] = {.lex_state = 41},
  [533] = {.lex_state = 41},
  [534] = {.lex_state = 41},
  [535] = {.lex_state = 41},
  [536] = {.lex_state = 2},
  [537] = {.lex_state = 41},
  [538] = {.lex_state = 41},
  [539] = {.lex_state = 41},
  [540] = {.lex_state = 41},
  [541] = {.lex_state = 41},
  [542] = {.lex_state = 41},
  [543] = {.lex_state = 41},
  [544] = {.lex_state = 41},
  [545] = {.lex_state = 41},
  [546] = {.lex_state = 41},
  [547] = {.lex_state = 41},
  [548] = {.lex_state = 41},
  [549] = {.lex_state = 41},
  [550] = {.lex_state = 41},
  [551] = {.lex_state = 41},
  [552] = {.lex_state = 41},
  [553] = {.lex_state = 41},
  [554] = {.lex_state = 41},
  [555] = {.lex_state = 41},
  [556] = {.lex_state = 41},
  [557] = {.lex_state = 41},
  [558] = {.lex_state = 41},
  [559] = {.lex_state = 41},
  [560] = {.lex_state = 41},
  [561] = {.lex_state = 41},
  [562] = {.lex_state = 41},
  [563] = {.lex_state = 41},
  [564] = {.lex_state = 41},
  [565] = {.lex_state = 41},
  [566] = {.lex_state = 41},
  [567] = {.lex_state = 41},
  [568] = {.lex_state = 41},
  [569] = {.lex_state = 41},
  [570] = {.lex_state = 41},
  [571] = {.lex_state = 41},
  [572] = {.lex_state = 41},
  [573] = {.lex_state = 41},
  [574] = {.lex_state = 41},
  [575] = {.lex_state = 41},
  [576] = {.lex_state = 41},
  [577] = {.lex_state = 41},
  [578] = {.lex_state = 41},
  [579] = {.lex_state = 41},
  [580] = {.lex_state = 41},
  [581] = {.lex_state = 41},
  [582] = {.lex_state = 41},
  [583] = {.lex_state = 41},
  [584] = {.lex_state = 41},
  [585] = {.lex_state = 41},
  [586] = {.lex_state = 41},
  [587] = {.lex_state = 41},
  [588] = {.lex_state = 41},
  [589] = {.lex_state = 41},
  [590] = {.lex_state = 41},
  [591] = {.lex_state = 41},
  [592] = {.lex_state = 41},
  [593] = {.lex_state = 41},
  [594] = {.lex_state = 41},
  [595] = {.lex_state = 41},
  [596] = {.lex_state = 41},
  [597] = {.lex_state = 41},
  [598] = {.lex_state = 41},
  [599] = {.lex_state = 41},
  [600] = {.lex_state = 41},
  [601] = {.lex_state = 41},
  [602] = {.lex_state = 41},
  [603] = {.lex_state = 4},
  [604] = {.lex_state = 4},
  [605] = {.lex_state = 4},
  [606] = {.lex_state = 4},
  [607] = {.lex_state = 4},
  [608] = {.lex_state = 4},
  [609] = {.lex_state = 4},
  [610] = {.lex_state = 2},
  [611] = {.lex_state = 2},
  [612] = {.lex_state = 3},
  [613] = {.lex_state = 41},
  [614] = {.lex_state = 41},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 41},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 3},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 1},
  [623] = {.lex_state = 2},
  [624] = {.lex_state = 41},
  [625] = {.lex_state = 2},
  [626] = {.lex_state = 1},
  [627] = {.lex_state = 41},
  [628] = {.lex_state = 41},
  [629] = {.lex_state = 41},
  [630] = {.lex_state = 41},
  [631] = {.lex_state = 2},
  [632] = {.lex_state = 41},
  [633] = {.lex_state = 41},
  [634] = {.lex_state = 41},
  [635] = {.lex_state = 41},
  [636] = {.lex_state = 41},
  [637] = {.lex_state = 2},
  [638] = {.lex_state = 41},
  [639] = {.lex_state = 41},
  [640] = {.lex_state = 41},
  [641] = {.lex_state = 41},
  [642] = {.lex_state = 41},
  [643] = {.lex_state = 41},
  [644] = {.lex_state = 41},
  [645] = {.lex_state = 41},
  [646] = {.lex_state = 41},
  [647] = {.lex_state = 41},
  [648] = {.lex_state = 41},
  [649] = {.lex_state = 41},
  [650] = {.lex_state = 41},
  [651] = {.lex_state = 41},
  [652] = {.lex_state = 41},
  [653] = {.lex_state = 41},
  [654] = {.lex_state = 41},
  [655] = {.lex_state = 41},
  [656] = {.lex_state = 41},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 41},
  [659] = {.lex_state = 41},
  [660] = {.lex_state = 41},
  [661] = {.lex_state = 41},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 41},
  [664] = {.lex_state = 41},
  [665] = {.lex_state = 41},
  [666] = {.lex_state = 41},
  [667] = {.lex_state = 41},
  [668] = {.lex_state = 41},
  [669] = {.lex_state = 41},
  [670] = {.lex_state = 41},
  [671] = {.lex_state = 41},
  [672] = {.lex_state = 41},
  [673] = {.lex_state = 41},
  [674] = {.lex_state = 41},
  [675] = {.lex_state = 41},
  [676] = {.lex_state = 41},
  [677] = {.lex_state = 2},
  [678] = {.lex_state = 41},
  [679] = {.lex_state = 2},
  [680] = {.lex_state = 3},
  [681] = {.lex_state = 3},
  [682] = {.lex_state = 3},
  [683] = {.lex_state = 3},
  [684] = {.lex_state = 3},
  [685] = {.lex_state = 2},
  [686] = {.lex_state = 2},
  [687] = {.lex_state = 2},
  [688] = {.lex_state = 2},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 3},
  [691] = {.lex_state = 41},
  [692] = {.lex_state = 2},
  [693] = {.lex_state = 41},
  [694] = {.lex_state = 41},
  [695] = {.lex_state = 2},
  [696] = {.lex_state = 41},
  [697] = {.lex_state = 2},
  [698] = {.lex_state = 2},
  [699] = {.lex_state = 41},
  [700] = {.lex_state = 2},
  [701] = {.lex_state = 3},
  [702] = {.lex_state = 2},
  [703] = {.lex_state = 2},
  [704] = {.lex_state = 2},
  [705] = {.lex_state = 2},
  [706] = {.lex_state = 2},
  [707] = {.lex_state = 2},
  [708] = {.lex_state = 2},
  [709] = {.lex_state = 2},
  [710] = {.lex_state = 2},
  [711] = {.lex_state = 2},
  [712] = {.lex_state = 2},
  [713] = {.lex_state = 41},
  [714] = {.lex_state = 2},
  [715] = {.lex_state = 2},
  [716] = {.lex_state = 2},
  [717] = {.lex_state = 2},
  [718] = {.lex_state = 2},
  [719] = {.lex_state = 2},
  [720] = {.lex_state = 2},
  [721] = {.lex_state = 2},
  [722] = {.lex_state = 2},
  [723] = {.lex_state = 2},
  [724] = {.lex_state = 2},
  [725] = {.lex_state = 2},
  [726] = {.lex_state = 2},
  [727] = {.lex_state = 2},
  [728] = {.lex_state = 2},
  [729] = {.lex_state = 2},
  [730] = {.lex_state = 2},
  [731] = {.lex_state = 2},
  [732] = {.lex_state = 2},
  [733] = {.lex_state = 3},
  [734] = {.lex_state = 3},
  [735] = {.lex_state = 3},
  [736] = {.lex_state = 3},
  [737] = {.lex_state = 2},
  [738] = {.lex_state = 2},
  [739] = {.lex_state = 3},
  [740] = {.lex_state = 2},
  [741] = {.lex_state = 2},
  [742] = {.lex_state = 2},
  [743] = {.lex_state = 41},
  [744] = {.lex_state = 2},
  [745] = {.lex_state = 2},
  [746] = {.lex_state = 3},
  [747] = {.lex_state = 41},
  [748] = {.lex_state = 41},
  [749] = {.lex_state = 41},
  [750] = {.lex_state = 41},
  [751] = {.lex_state = 41},
  [752] = {.lex_state = 41},
  [753] = {.lex_state = 4},
  [754] = {.lex_state = 4},
  [755] = {.lex_state = 41},
  [756] = {.lex_state = 41},
  [757] = {.lex_state = 4},
  [758] = {.lex_state = 41},
  [759] = {.lex_state = 4},
  [760] = {.lex_state = 4},
  [761] = {.lex_state = 41},
  [762] = {.lex_state = 41},
  [763] = {.lex_state = 4},
  [764] = {.lex_state = 41},
  [765] = {.lex_state = 4},
  [766] = {.lex_state = 41},
  [767] = {.lex_state = 41},
  [768] = {.lex_state = 41},
  [769] = {.lex_state = 41},
  [770] = {.lex_state = 41},
  [771] = {.lex_state = 41},
  [772] = {.lex_state = 41},
  [773] = {.lex_state = 41},
  [774] = {.lex_state = 41},
  [775] = {.lex_state = 41},
  [776] = {.lex_state = 41},
  [777] = {.lex_state = 7},
  [778] = {.lex_state = 41},
  [779] = {.lex_state = 41},
  [780] = {.lex_state = 41},
  [781] = {.lex_state = 41},
  [782] = {.lex_state = 41},
  [783] = {.lex_state = 41},
  [784] = {.lex_state = 41},
  [785] = {.lex_state = 41},
  [786] = {.lex_state = 41},
  [787] = {.lex_state = 41},
  [788] = {.lex_state = 7},
  [789] = {.lex_state = 41},
  [790] = {.lex_state = 41},
  [791] = {.lex_state = 41},
  [792] = {.lex_state = 41},
  [793] = {.lex_state = 41},
  [794] = {.lex_state = 41},
  [795] = {.lex_state = 41},
  [796] = {.lex_state = 41},
  [797] = {.lex_state = 41},
  [798] = {.lex_state = 7},
  [799] = {.lex_state = 41},
  [800] = {.lex_state = 41},
  [801] = {.lex_state = 41},
  [802] = {.lex_state = 7},
  [803] = {.lex_state = 41},
  [804] = {.lex_state = 41},
  [805] = {.lex_state = 41},
  [806] = {.lex_state = 7},
  [807] = {.lex_state = 41},
  [808] = {.lex_state = 41},
  [809] = {.lex_state = 41},
  [810] = {.lex_state = 41},
  [811] = {.lex_state = 7},
  [812] = {.lex_state = 41},
  [813] = {.lex_state = 41},
  [814] = {.lex_state = 7},
  [815] = {.lex_state = 41},
  [816] = {.lex_state = 41},
  [817] = {.lex_state = 41},
  [818] = {.lex_state = 3},
  [819] = {.lex_state = 4},
  [820] = {.lex_state = 4},
  [821] = {.lex_state = 4},
  [822] = {.lex_state = 4},
  [823] = {.lex_state = 4},
  [824] = {.lex_state = 4},
  [825] = {.lex_state = 41},
  [826] = {.lex_state = 41},
  [827] = {.lex_state = 41},
  [828] = {.lex_state = 4},
  [829] = {.lex_state = 41},
  [830] = {.lex_state = 4},
  [831] = {.lex_state = 41},
  [832] = {.lex_state = 41},
  [833] = {.lex_state = 41},
  [834] = {.lex_state = 41},
  [835] = {.lex_state = 41},
  [836] = {.lex_state = 41},
  [837] = {.lex_state = 41},
  [838] = {.lex_state = 41},
  [839] = {.lex_state = 41},
  [840] = {.lex_state = 41},
  [841] = {.lex_state = 41},
  [842] = {.lex_state = 41},
  [843] = {.lex_state = 41},
  [844] = {.lex_state = 41},
  [845] = {.lex_state = 41},
  [846] = {.lex_state = 41},
  [847] = {.lex_state = 41},
  [848] = {.lex_state = 41},
  [849] = {.lex_state = 41},
  [850] = {.lex_state = 41},
  [851] = {.lex_state = 41},
  [852] = {.lex_state = 41},
  [853] = {.lex_state = 41},
  [854] = {.lex_state = 41},
  [855] = {.lex_state = 41},
  [856] = {.lex_state = 41},
  [857] = {.lex_state = 41},
  [858] = {.lex_state = 41},
  [859] = {.lex_state = 41},
  [860] = {.lex_state = 41},
  [861] = {.lex_state = 41},
  [862] = {.lex_state = 41},
  [863] = {.lex_state = 41},
  [864] = {.lex_state = 41},
  [865] = {.lex_state = 41},
  [866] = {.lex_state = 41},
  [867] = {.lex_state = 41},
  [868] = {.lex_state = 41},
  [869] = {.lex_state = 41},
  [870] = {.lex_state = 41},
  [871] = {.lex_state = 41},
  [872] = {.lex_state = 41},
  [873] = {.lex_state = 41},
  [874] = {.lex_state = 41},
  [875] = {.lex_state = 41},
  [876] = {.lex_state = 41},
  [877] = {.lex_state = 41},
  [878] = {.lex_state = 41},
  [879] = {.lex_state = 41},
  [880] = {.lex_state = 41},
  [881] = {.lex_state = 41},
  [882] = {.lex_state = 41},
  [883] = {.lex_state = 41},
  [884] = {.lex_state = 41},
  [885] = {.lex_state = 41},
  [886] = {.lex_state = 41},
  [887] = {.lex_state = 41},
  [888] = {.lex_state = 41},
  [889] = {.lex_state = 41},
  [890] = {.lex_state = 41},
  [891] = {.lex_state = 41},
  [892] = {.lex_state = 41},
  [893] = {.lex_state = 41},
  [894] = {.lex_state = 41},
  [895] = {.lex_state = 41},
  [896] = {.lex_state = 41},
  [897] = {.lex_state = 41},
  [898] = {.lex_state = 41},
  [899] = {.lex_state = 41},
  [900] = {.lex_state = 41},
  [901] = {.lex_state = 41},
  [902] = {.lex_state = 41},
  [903] = {.lex_state = 41},
  [904] = {.lex_state = 41},
  [905] = {.lex_state = 41},
  [906] = {.lex_state = 41},
  [907] = {.lex_state = 41},
  [908] = {.lex_state = 41},
  [909] = {.lex_state = 41},
  [910] = {.lex_state = 41},
  [911] = {.lex_state = 41},
  [912] = {.lex_state = 41},
  [913] = {.lex_state = 41},
  [914] = {.lex_state = 41},
  [915] = {.lex_state = 41},
  [916] = {.lex_state = 41},
  [917] = {.lex_state = 41},
  [918] = {.lex_state = 41},
  [919] = {.lex_state = 41},
  [920] = {.lex_state = 41},
  [921] = {.lex_state = 41},
  [922] = {.lex_state = 41},
  [923] = {.lex_state = 41},
  [924] = {.lex_state = 41},
  [925] = {.lex_state = 41},
  [926] = {.lex_state = 41},
  [927] = {.lex_state = 41},
  [928] = {.lex_state = 41},
  [929] = {.lex_state = 41},
  [930] = {.lex_state = 41},
  [931] = {.lex_state = 41},
  [932] = {.lex_state = 41},
  [933] = {.lex_state = 3},
  [934] = {.lex_state = 41},
  [935] = {.lex_state = 41},
  [936] = {.lex_state = 41},
  [937] = {.lex_state = 41},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 41},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 41},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 41},
  [946] = {.lex_state = 41},
  [947] = {.lex_state = 41},
  [948] = {.lex_state = 41},
  [949] = {.lex_state = 41},
  [950] = {.lex_state = 41},
  [951] = {.lex_state = 41},
  [952] = {.lex_state = 4},
  [953] = {.lex_state = 6},
  [954] = {.lex_state = 41},
  [955] = {.lex_state = 3},
  [956] = {.lex_state = 4},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 3},
  [959] = {.lex_state = 7},
  [960] = {.lex_state = 7},
  [961] = {.lex_state = 11},
  [962] = {.lex_state = 10},
  [963] = {.lex_state = 10},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 3},
  [966] = {.lex_state = 11},
  [967] = {.lex_state = 11},
  [968] = {.lex_state = 3},
  [969] = {.lex_state = 9},
  [970] = {.lex_state = 9},
  [971] = {.lex_state = 9},
  [972] = {.lex_state = 8},
  [973] = {.lex_state = 9},
  [974] = {.lex_state = 9},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 3},
  [978] = {.lex_state = 3},
  [979] = {.lex_state = 4},
  [980] = {.lex_state = 3},
  [981] = {.lex_state = 4},
  [982] = {.lex_state = 2},
  [983] = {.lex_state = 11},
  [984] = {.lex_state = 4},
  [985] = {.lex_state = 11},
  [986] = {.lex_state = 2},
  [987] = {.lex_state = 3},
  [988] = {.lex_state = 4},
  [989] = {.lex_state = 2},
  [990] = {.lex_state = 11},
  [991] = {.lex_state = 11},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 11},
  [996] = {.lex_state = 3},
  [997] = {.lex_state = 4},
  [998] = {.lex_state = 11},
  [999] = {.lex_state = 2},
  [1000] = {.lex_state = 11},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 11},
  [1003] = {.lex_state = 3},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 11},
  [1006] = {.lex_state = 4},
  [1007] = {.lex_state = 11},
  [1008] = {.lex_state = 4},
  [1009] = {.lex_state = 4},
  [1010] = {.lex_state = 4},
  [1011] = {.lex_state = 11},
  [1012] = {.lex_state = 4},
  [1013] = {.lex_state = 11},
  [1014] = {.lex_state = 11},
  [1015] = {.lex_state = 2},
  [1016] = {.lex_state = 3},
  [1017] = {.lex_state = 11},
  [1018] = {.lex_state = 4},
  [1019] = {.lex_state = 2},
  [1020] = {.lex_state = 4},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 2},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 9},
  [1025] = {.lex_state = 2},
  [1026] = {.lex_state = 9},
  [1027] = {.lex_state = 9},
  [1028] = {.lex_state = 9},
  [1029] = {.lex_state = 2},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 9},
  [1032] = {.lex_state = 2},
  [1033] = {.lex_state = 4},
  [1034] = {.lex_state = 9},
  [1035] = {.lex_state = 2},
  [1036] = {.lex_state = 4},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 2},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 16},
  [1044] = {.lex_state = 2},
  [1045] = {.lex_state = 4},
  [1046] = {.lex_state = 4},
  [1047] = {.lex_state = 2},
  [1048] = {.lex_state = 4},
  [1049] = {.lex_state = 2},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 5},
  [1052] = {.lex_state = 2},
  [1053] = {.lex_state = 2},
  [1054] = {.lex_state = 4},
  [1055] = {.lex_state = 4},
  [1056] = {.lex_state = 2},
  [1057] = {.lex_state = 2},
  [1058] = {.lex_state = 2},
  [1059] = {.lex_state = 4},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 2},
  [1062] = {.lex_state = 2},
  [1063] = {.lex_state = 2},
  [1064] = {.lex_state = 5},
  [1065] = {.lex_state = 2},
  [1066] = {.lex_state = 2},
  [1067] = {.lex_state = 2},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 2},
  [1070] = {.lex_state = 2},
  [1071] = {.lex_state = 2},
  [1072] = {.lex_state = 2},
  [1073] = {.lex_state = 2},
  [1074] = {.lex_state = 2},
  [1075] = {.lex_state = 4},
  [1076] = {.lex_state = 5},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 2},
  [1079] = {.lex_state = 2},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 2},
  [1082] = {.lex_state = 2},
  [1083] = {.lex_state = 2},
  [1084] = {.lex_state = 16},
  [1085] = {.lex_state = 5},
  [1086] = {.lex_state = 2},
  [1087] = {.lex_state = 2},
  [1088] = {.lex_state = 2},
  [1089] = {.lex_state = 5},
  [1090] = {.lex_state = 2},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 4},
  [1093] = {.lex_state = 4},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 4},
  [1097] = {.lex_state = 2},
  [1098] = {.lex_state = 2},
  [1099] = {.lex_state = 4},
  [1100] = {.lex_state = 4},
  [1101] = {.lex_state = 2},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 4},
  [1104] = {.lex_state = 2},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 2},
  [1107] = {.lex_state = 4},
  [1108] = {.lex_state = 2},
  [1109] = {.lex_state = 4},
  [1110] = {.lex_state = 4},
  [1111] = {.lex_state = 4},
  [1112] = {.lex_state = 2},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 4},
  [1115] = {.lex_state = 2},
  [1116] = {.lex_state = 2},
  [1117] = {.lex_state = 2},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 11},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 11},
  [1122] = {.lex_state = 4},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 17},
  [1127] = {.lex_state = 4},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 4},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 4},
  [1147] = {.lex_state = 2},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 2},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 2},
  [1161] = {.lex_state = 17},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 4},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 4},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 4},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 4},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 2},
  [1184] = {.lex_state = 4},
  [1185] = {.lex_state = 4},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 17},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 2},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 4},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 2},
  [1238] = {.lex_state = 2},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 4},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 41},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 41},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 4},
  [1287] = {.lex_state = 0},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 0},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 4},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 0},
  [1319] = {.lex_state = 0},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 0},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [aux_sym_preprocessor_statement_token2] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_cast] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_Void] = ACTIONS(1),
    [anon_sym_Int] = ACTIONS(1),
    [anon_sym_Float] = ACTIONS(1),
    [anon_sym_Bool] = ACTIONS(1),
    [anon_sym_Null] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [sym__rangeOperator] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [aux_sym_integer_token1] = ACTIONS(1),
    [aux_sym_integer_token2] = ACTIONS(1),
    [aux_sym_float_token1] = ACTIONS(1),
    [aux_sym_float_token2] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [aux_sym_string_token3] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_overload] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_untyped] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(1285),
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(4),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [2] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_identifier] = ACTIONS(91),
    [anon_sym_POUND] = ACTIONS(94),
    [anon_sym_package] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(100),
    [anon_sym_using] = ACTIONS(103),
    [anon_sym_throw] = ACTIONS(106),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(118),
    [anon_sym_default] = ACTIONS(121),
    [anon_sym_cast] = ACTIONS(124),
    [anon_sym_DOLLARtype] = ACTIONS(127),
    [anon_sym_in] = ACTIONS(130),
    [anon_sym_LBRACK] = ACTIONS(133),
    [anon_sym_this] = ACTIONS(136),
    [anon_sym_AT] = ACTIONS(139),
    [anon_sym_AT_COLON] = ACTIONS(142),
    [anon_sym_if] = ACTIONS(145),
    [anon_sym_else] = ACTIONS(130),
    [anon_sym_new] = ACTIONS(148),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(154),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(160),
    [anon_sym_DASH_DASH] = ACTIONS(160),
    [anon_sym_PERCENT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(166),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(166),
    [anon_sym_GT_GT_GT] = ACTIONS(163),
    [anon_sym_AMP] = ACTIONS(166),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_AMP_AMP] = ACTIONS(151),
    [anon_sym_PIPE_PIPE] = ACTIONS(151),
    [anon_sym_EQ_EQ] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(154),
    [anon_sym_LT_EQ] = ACTIONS(151),
    [anon_sym_GT] = ACTIONS(154),
    [anon_sym_GT_EQ] = ACTIONS(151),
    [anon_sym_EQ_GT] = ACTIONS(151),
    [anon_sym_QMARK_QMARK] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(154),
    [sym__rangeOperator] = ACTIONS(151),
    [anon_sym_null] = ACTIONS(169),
    [anon_sym_dynamic] = ACTIONS(130),
    [anon_sym_final] = ACTIONS(172),
    [anon_sym_abstract] = ACTIONS(175),
    [anon_sym_class] = ACTIONS(178),
    [anon_sym_extends] = ACTIONS(130),
    [anon_sym_implements] = ACTIONS(130),
    [anon_sym_interface] = ACTIONS(181),
    [anon_sym_typedef] = ACTIONS(184),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_var] = ACTIONS(190),
    [aux_sym_integer_token1] = ACTIONS(193),
    [aux_sym_integer_token2] = ACTIONS(196),
    [aux_sym_float_token1] = ACTIONS(199),
    [aux_sym_float_token2] = ACTIONS(202),
    [anon_sym_true] = ACTIONS(205),
    [anon_sym_false] = ACTIONS(205),
    [aux_sym_string_token1] = ACTIONS(208),
    [aux_sym_string_token3] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(130),
    [anon_sym_catch] = ACTIONS(130),
    [anon_sym_continue] = ACTIONS(130),
    [anon_sym_do] = ACTIONS(130),
    [anon_sym_enum] = ACTIONS(130),
    [anon_sym_extern] = ACTIONS(130),
    [anon_sym_for] = ACTIONS(130),
    [anon_sym_inline] = ACTIONS(130),
    [anon_sym_macro] = ACTIONS(130),
    [anon_sym_operator] = ACTIONS(130),
    [anon_sym_overload] = ACTIONS(130),
    [anon_sym_override] = ACTIONS(130),
    [anon_sym_private] = ACTIONS(130),
    [anon_sym_public] = ACTIONS(130),
    [anon_sym_return] = ACTIONS(130),
    [anon_sym_static] = ACTIONS(130),
    [anon_sym_try] = ACTIONS(130),
    [anon_sym_untyped] = ACTIONS(130),
    [anon_sym_while] = ACTIONS(130),
  },
  [3] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [4] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(216),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [5] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(119),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(3),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(218),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [6] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [7] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(119),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(3),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [8] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(3),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [9] = {
    [sym_preprocessor_statement] = STATE(297),
    [sym_package_statement] = STATE(297),
    [sym_import_statement] = STATE(297),
    [sym_using_statement] = STATE(297),
    [sym_throw_statement] = STATE(297),
    [sym__rhs_expression] = STATE(42),
    [sym__unaryExpression] = STATE(297),
    [sym_runtime_type_check_expression] = STATE(297),
    [sym_switch_expression] = STATE(297),
    [sym_case_statement] = STATE(297),
    [sym_cast_expression] = STATE(297),
    [sym_type_trace_expression] = STATE(297),
    [sym__parenthesized_expression] = STATE(282),
    [sym_range_expression] = STATE(297),
    [sym_subscript_expression] = STATE(297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(297),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(297),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(42),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(297),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_module_repeat1] = STATE(6),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_RBRACE] = ACTIONS(226),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [10] = {
    [sym_preprocessor_statement] = STATE(247),
    [sym_package_statement] = STATE(247),
    [sym_import_statement] = STATE(247),
    [sym_using_statement] = STATE(247),
    [sym_throw_statement] = STATE(247),
    [sym__rhs_expression] = STATE(47),
    [sym__unaryExpression] = STATE(247),
    [sym_runtime_type_check_expression] = STATE(247),
    [sym_switch_expression] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_cast_expression] = STATE(247),
    [sym_type_trace_expression] = STATE(247),
    [sym__parenthesized_expression] = STATE(249),
    [sym_range_expression] = STATE(247),
    [sym_subscript_expression] = STATE(247),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(247),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(247),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(47),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(247),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [11] = {
    [sym_preprocessor_statement] = STATE(210),
    [sym_package_statement] = STATE(210),
    [sym_import_statement] = STATE(210),
    [sym_using_statement] = STATE(210),
    [sym_throw_statement] = STATE(210),
    [sym__rhs_expression] = STATE(44),
    [sym__unaryExpression] = STATE(210),
    [sym_runtime_type_check_expression] = STATE(210),
    [sym_switch_expression] = STATE(210),
    [sym_case_statement] = STATE(210),
    [sym_cast_expression] = STATE(210),
    [sym_type_trace_expression] = STATE(210),
    [sym__parenthesized_expression] = STATE(217),
    [sym_range_expression] = STATE(210),
    [sym_subscript_expression] = STATE(210),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(210),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(210),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(44),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(210),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [12] = {
    [sym_preprocessor_statement] = STATE(211),
    [sym_package_statement] = STATE(211),
    [sym_import_statement] = STATE(211),
    [sym_using_statement] = STATE(211),
    [sym_throw_statement] = STATE(211),
    [sym__rhs_expression] = STATE(41),
    [sym__unaryExpression] = STATE(211),
    [sym_runtime_type_check_expression] = STATE(211),
    [sym_switch_expression] = STATE(211),
    [sym_case_statement] = STATE(211),
    [sym_cast_expression] = STATE(211),
    [sym_type_trace_expression] = STATE(211),
    [sym__parenthesized_expression] = STATE(213),
    [sym_range_expression] = STATE(211),
    [sym_subscript_expression] = STATE(211),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym_block] = STATE(211),
    [sym_metadata] = STATE(468),
    [sym_conditional_statement] = STATE(211),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(41),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym_declaration] = STATE(211),
    [sym_class_declaration] = STATE(243),
    [sym_interface_declaration] = STATE(243),
    [sym_typedef_declaration] = STATE(243),
    [sym_function_declaration] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_keyword] = STATE(494),
    [aux_sym_class_declaration_repeat1] = STATE(468),
    [aux_sym_function_declaration_repeat1] = STATE(494),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_using] = ACTIONS(15),
    [anon_sym_throw] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_case] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(27),
    [anon_sym_cast] = ACTIONS(29),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(33),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(37),
    [anon_sym_AT] = ACTIONS(39),
    [anon_sym_AT_COLON] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_else] = ACTIONS(33),
    [anon_sym_new] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(33),
    [anon_sym_final] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_extends] = ACTIONS(33),
    [anon_sym_implements] = ACTIONS(33),
    [anon_sym_interface] = ACTIONS(67),
    [anon_sym_typedef] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_var] = ACTIONS(73),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(33),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(33),
    [anon_sym_extern] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_inline] = ACTIONS(33),
    [anon_sym_macro] = ACTIONS(33),
    [anon_sym_operator] = ACTIONS(33),
    [anon_sym_overload] = ACTIONS(33),
    [anon_sym_override] = ACTIONS(33),
    [anon_sym_private] = ACTIONS(33),
    [anon_sym_public] = ACTIONS(33),
    [anon_sym_return] = ACTIONS(33),
    [anon_sym_static] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_untyped] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(33),
  },
  [13] = {
    [sym__rhs_expression] = STATE(50),
    [sym__unaryExpression] = STATE(316),
    [sym_runtime_type_check_expression] = STATE(316),
    [sym_switch_expression] = STATE(316),
    [sym_cast_expression] = STATE(316),
    [sym_type_trace_expression] = STATE(316),
    [sym__parenthesized_expression] = STATE(313),
    [sym_range_expression] = STATE(316),
    [sym_subscript_expression] = STATE(316),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(50),
    [sym_operator] = STATE(781),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(234),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [14] = {
    [sym__rhs_expression] = STATE(61),
    [sym_member_expression] = STATE(80),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(61),
    [sym__literal] = STATE(113),
    [sym_integer] = STATE(113),
    [sym_float] = STATE(113),
    [sym_bool] = STATE(113),
    [sym_string] = STATE(105),
    [sym_null] = STATE(113),
    [sym_array] = STATE(113),
    [sym_map] = STATE(113),
    [sym_object] = STATE(113),
    [sym_pair] = STATE(113),
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_POUND] = ACTIONS(240),
    [anon_sym_package] = ACTIONS(242),
    [anon_sym_import] = ACTIONS(242),
    [anon_sym_using] = ACTIONS(242),
    [anon_sym_throw] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_switch] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_case] = ACTIONS(242),
    [anon_sym_default] = ACTIONS(242),
    [anon_sym_cast] = ACTIONS(242),
    [anon_sym_COMMA] = ACTIONS(240),
    [anon_sym_DOLLARtype] = ACTIONS(240),
    [anon_sym_in] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_this] = ACTIONS(242),
    [anon_sym_DOT] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_AT_COLON] = ACTIONS(240),
    [anon_sym_if] = ACTIONS(242),
    [anon_sym_else] = ACTIONS(242),
    [anon_sym_new] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_PERCENT] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_SLASH] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LT_LT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(242),
    [anon_sym_GT_GT_GT] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_EQ_EQ] = ACTIONS(240),
    [anon_sym_BANG_EQ] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(242),
    [anon_sym_LT_EQ] = ACTIONS(240),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_GT_EQ] = ACTIONS(240),
    [anon_sym_EQ_GT] = ACTIONS(240),
    [anon_sym_QMARK_QMARK] = ACTIONS(240),
    [anon_sym_EQ] = ACTIONS(242),
    [sym__rangeOperator] = ACTIONS(240),
    [anon_sym_null] = ACTIONS(242),
    [anon_sym_dynamic] = ACTIONS(242),
    [anon_sym_final] = ACTIONS(242),
    [anon_sym_abstract] = ACTIONS(242),
    [anon_sym_class] = ACTIONS(242),
    [anon_sym_extends] = ACTIONS(242),
    [anon_sym_implements] = ACTIONS(242),
    [anon_sym_interface] = ACTIONS(242),
    [anon_sym_typedef] = ACTIONS(242),
    [anon_sym_function] = ACTIONS(242),
    [anon_sym_var] = ACTIONS(242),
    [aux_sym_integer_token1] = ACTIONS(242),
    [aux_sym_integer_token2] = ACTIONS(240),
    [aux_sym_float_token1] = ACTIONS(242),
    [aux_sym_float_token2] = ACTIONS(240),
    [anon_sym_true] = ACTIONS(242),
    [anon_sym_false] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(240),
    [aux_sym_string_token3] = ACTIONS(240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(242),
    [anon_sym_catch] = ACTIONS(242),
    [anon_sym_continue] = ACTIONS(242),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_enum] = ACTIONS(242),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_for] = ACTIONS(242),
    [anon_sym_inline] = ACTIONS(242),
    [anon_sym_macro] = ACTIONS(242),
    [anon_sym_operator] = ACTIONS(242),
    [anon_sym_overload] = ACTIONS(242),
    [anon_sym_override] = ACTIONS(242),
    [anon_sym_private] = ACTIONS(242),
    [anon_sym_public] = ACTIONS(242),
    [anon_sym_return] = ACTIONS(242),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(242),
    [anon_sym_untyped] = ACTIONS(242),
    [anon_sym_while] = ACTIONS(242),
    [sym__semicolon] = ACTIONS(240),
  },
  [15] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(244),
    [anon_sym_package] = ACTIONS(248),
    [anon_sym_import] = ACTIONS(248),
    [anon_sym_using] = ACTIONS(248),
    [anon_sym_throw] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_switch] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_case] = ACTIONS(248),
    [anon_sym_default] = ACTIONS(248),
    [anon_sym_cast] = ACTIONS(248),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_DOLLARtype] = ACTIONS(244),
    [anon_sym_in] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(248),
    [anon_sym_QMARK] = ACTIONS(248),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_AT_COLON] = ACTIONS(244),
    [anon_sym_if] = ACTIONS(248),
    [anon_sym_else] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_PERCENT] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_LT_LT] = ACTIONS(244),
    [anon_sym_GT_GT] = ACTIONS(248),
    [anon_sym_GT_GT_GT] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_PIPE] = ACTIONS(248),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_EQ_EQ] = ACTIONS(244),
    [anon_sym_BANG_EQ] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(248),
    [anon_sym_LT_EQ] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(248),
    [anon_sym_GT_EQ] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(244),
    [anon_sym_QMARK_QMARK] = ACTIONS(244),
    [anon_sym_EQ] = ACTIONS(248),
    [sym__rangeOperator] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(248),
    [anon_sym_final] = ACTIONS(248),
    [anon_sym_abstract] = ACTIONS(248),
    [anon_sym_class] = ACTIONS(248),
    [anon_sym_extends] = ACTIONS(248),
    [anon_sym_implements] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(248),
    [anon_sym_typedef] = ACTIONS(248),
    [anon_sym_function] = ACTIONS(248),
    [anon_sym_var] = ACTIONS(248),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(248),
    [anon_sym_catch] = ACTIONS(248),
    [anon_sym_continue] = ACTIONS(248),
    [anon_sym_do] = ACTIONS(248),
    [anon_sym_enum] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_for] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_macro] = ACTIONS(248),
    [anon_sym_operator] = ACTIONS(248),
    [anon_sym_overload] = ACTIONS(248),
    [anon_sym_override] = ACTIONS(248),
    [anon_sym_private] = ACTIONS(248),
    [anon_sym_public] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(248),
    [anon_sym_untyped] = ACTIONS(248),
    [anon_sym_while] = ACTIONS(248),
    [sym__semicolon] = ACTIONS(244),
  },
  [16] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(252),
    [anon_sym_package] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(254),
    [anon_sym_using] = ACTIONS(254),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(254),
    [anon_sym_cast] = ACTIONS(254),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_DOLLARtype] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(252),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_QMARK] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_COLON] = ACTIONS(252),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_new] = ACTIONS(254),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_DASH] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(252),
    [anon_sym_DASH_DASH] = ACTIONS(252),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_SLASH] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(252),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_EQ_GT] = ACTIONS(252),
    [anon_sym_QMARK_QMARK] = ACTIONS(252),
    [anon_sym_EQ] = ACTIONS(254),
    [sym__rangeOperator] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(254),
    [anon_sym_final] = ACTIONS(254),
    [anon_sym_abstract] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_extends] = ACTIONS(254),
    [anon_sym_implements] = ACTIONS(254),
    [anon_sym_interface] = ACTIONS(254),
    [anon_sym_typedef] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_var] = ACTIONS(254),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(254),
    [anon_sym_catch] = ACTIONS(254),
    [anon_sym_continue] = ACTIONS(254),
    [anon_sym_do] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(254),
    [anon_sym_extern] = ACTIONS(254),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_inline] = ACTIONS(254),
    [anon_sym_macro] = ACTIONS(254),
    [anon_sym_operator] = ACTIONS(254),
    [anon_sym_overload] = ACTIONS(254),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_private] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(254),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_try] = ACTIONS(254),
    [anon_sym_untyped] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [sym__semicolon] = ACTIONS(252),
  },
  [17] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(256),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_package] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(258),
    [anon_sym_using] = ACTIONS(258),
    [anon_sym_throw] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_cast] = ACTIONS(258),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_DOLLARtype] = ACTIONS(256),
    [anon_sym_in] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(256),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(258),
    [anon_sym_QMARK] = ACTIONS(258),
    [anon_sym_AT] = ACTIONS(258),
    [anon_sym_AT_COLON] = ACTIONS(256),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_else] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PERCENT] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_SLASH] = ACTIONS(258),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(258),
    [anon_sym_GT_GT_GT] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_EQ_EQ] = ACTIONS(256),
    [anon_sym_BANG_EQ] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_LT_EQ] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_EQ] = ACTIONS(256),
    [anon_sym_EQ_GT] = ACTIONS(256),
    [anon_sym_QMARK_QMARK] = ACTIONS(256),
    [anon_sym_EQ] = ACTIONS(258),
    [sym__rangeOperator] = ACTIONS(256),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(258),
    [anon_sym_final] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(258),
    [anon_sym_class] = ACTIONS(258),
    [anon_sym_extends] = ACTIONS(258),
    [anon_sym_implements] = ACTIONS(258),
    [anon_sym_interface] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(258),
    [anon_sym_var] = ACTIONS(258),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_catch] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_macro] = ACTIONS(258),
    [anon_sym_operator] = ACTIONS(258),
    [anon_sym_overload] = ACTIONS(258),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_private] = ACTIONS(258),
    [anon_sym_public] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_untyped] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [sym__semicolon] = ACTIONS(256),
  },
  [18] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(260),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(260),
    [anon_sym_package] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(262),
    [anon_sym_using] = ACTIONS(262),
    [anon_sym_throw] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_switch] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_case] = ACTIONS(262),
    [anon_sym_default] = ACTIONS(262),
    [anon_sym_cast] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_DOLLARtype] = ACTIONS(260),
    [anon_sym_in] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(260),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(262),
    [anon_sym_QMARK] = ACTIONS(262),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_AT_COLON] = ACTIONS(260),
    [anon_sym_if] = ACTIONS(262),
    [anon_sym_else] = ACTIONS(262),
    [anon_sym_new] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(260),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_PLUS_PLUS] = ACTIONS(260),
    [anon_sym_DASH_DASH] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(260),
    [anon_sym_STAR] = ACTIONS(260),
    [anon_sym_SLASH] = ACTIONS(262),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_LT_LT] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(262),
    [anon_sym_GT_GT_GT] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(262),
    [anon_sym_PIPE] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(260),
    [anon_sym_AMP_AMP] = ACTIONS(260),
    [anon_sym_PIPE_PIPE] = ACTIONS(260),
    [anon_sym_EQ_EQ] = ACTIONS(260),
    [anon_sym_BANG_EQ] = ACTIONS(260),
    [anon_sym_LT] = ACTIONS(262),
    [anon_sym_LT_EQ] = ACTIONS(260),
    [anon_sym_GT] = ACTIONS(262),
    [anon_sym_GT_EQ] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(260),
    [anon_sym_QMARK_QMARK] = ACTIONS(260),
    [anon_sym_EQ] = ACTIONS(262),
    [sym__rangeOperator] = ACTIONS(260),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(262),
    [anon_sym_final] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(262),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_extends] = ACTIONS(262),
    [anon_sym_implements] = ACTIONS(262),
    [anon_sym_interface] = ACTIONS(262),
    [anon_sym_typedef] = ACTIONS(262),
    [anon_sym_function] = ACTIONS(262),
    [anon_sym_var] = ACTIONS(262),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(262),
    [anon_sym_catch] = ACTIONS(262),
    [anon_sym_continue] = ACTIONS(262),
    [anon_sym_do] = ACTIONS(262),
    [anon_sym_enum] = ACTIONS(262),
    [anon_sym_extern] = ACTIONS(262),
    [anon_sym_for] = ACTIONS(262),
    [anon_sym_inline] = ACTIONS(262),
    [anon_sym_macro] = ACTIONS(262),
    [anon_sym_operator] = ACTIONS(262),
    [anon_sym_overload] = ACTIONS(262),
    [anon_sym_override] = ACTIONS(262),
    [anon_sym_private] = ACTIONS(262),
    [anon_sym_public] = ACTIONS(262),
    [anon_sym_return] = ACTIONS(262),
    [anon_sym_static] = ACTIONS(262),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_untyped] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(262),
    [sym__semicolon] = ACTIONS(260),
  },
  [19] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(264),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_POUND] = ACTIONS(264),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_using] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_RPAREN] = ACTIONS(264),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(264),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_cast] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_DOLLARtype] = ACTIONS(264),
    [anon_sym_in] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(264),
    [anon_sym_this] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_AT_COLON] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(264),
    [anon_sym_BANG] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(264),
    [anon_sym_PERCENT] = ACTIONS(264),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(264),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_GT] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_CARET] = ACTIONS(264),
    [anon_sym_AMP_AMP] = ACTIONS(264),
    [anon_sym_PIPE_PIPE] = ACTIONS(264),
    [anon_sym_EQ_EQ] = ACTIONS(264),
    [anon_sym_BANG_EQ] = ACTIONS(264),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_LT_EQ] = ACTIONS(264),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(264),
    [anon_sym_EQ_GT] = ACTIONS(264),
    [anon_sym_QMARK_QMARK] = ACTIONS(264),
    [anon_sym_EQ] = ACTIONS(269),
    [sym__rangeOperator] = ACTIONS(264),
    [anon_sym_null] = ACTIONS(280),
    [anon_sym_dynamic] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_extends] = ACTIONS(269),
    [anon_sym_implements] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_typedef] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_var] = ACTIONS(269),
    [aux_sym_integer_token1] = ACTIONS(283),
    [aux_sym_integer_token2] = ACTIONS(286),
    [aux_sym_float_token1] = ACTIONS(289),
    [aux_sym_float_token2] = ACTIONS(292),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [aux_sym_string_token1] = ACTIONS(298),
    [aux_sym_string_token3] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_extern] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_macro] = ACTIONS(269),
    [anon_sym_operator] = ACTIONS(269),
    [anon_sym_overload] = ACTIONS(269),
    [anon_sym_override] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_untyped] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [sym__semicolon] = ACTIONS(264),
  },
  [20] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(304),
    [anon_sym_package] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_using] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(304),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_cast] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_DOLLARtype] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(304),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_AT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_new] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_PLUS_PLUS] = ACTIONS(304),
    [anon_sym_DASH_DASH] = ACTIONS(304),
    [anon_sym_PERCENT] = ACTIONS(304),
    [anon_sym_STAR] = ACTIONS(304),
    [anon_sym_SLASH] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_LT_LT] = ACTIONS(304),
    [anon_sym_GT_GT] = ACTIONS(306),
    [anon_sym_GT_GT_GT] = ACTIONS(304),
    [anon_sym_AMP] = ACTIONS(306),
    [anon_sym_PIPE] = ACTIONS(306),
    [anon_sym_CARET] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_EQ_EQ] = ACTIONS(304),
    [anon_sym_BANG_EQ] = ACTIONS(304),
    [anon_sym_LT] = ACTIONS(306),
    [anon_sym_LT_EQ] = ACTIONS(304),
    [anon_sym_GT] = ACTIONS(306),
    [anon_sym_GT_EQ] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_QMARK_QMARK] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(306),
    [sym__rangeOperator] = ACTIONS(304),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(306),
    [anon_sym_final] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_extends] = ACTIONS(306),
    [anon_sym_implements] = ACTIONS(306),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_typedef] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(306),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_catch] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_extern] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_inline] = ACTIONS(306),
    [anon_sym_macro] = ACTIONS(306),
    [anon_sym_operator] = ACTIONS(306),
    [anon_sym_overload] = ACTIONS(306),
    [anon_sym_override] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_untyped] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [sym__semicolon] = ACTIONS(304),
  },
  [21] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1152),
    [sym_integer] = STATE(1152),
    [sym_float] = STATE(1152),
    [sym_bool] = STATE(1152),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1152),
    [sym_array] = STATE(1152),
    [sym_map] = STATE(1152),
    [sym_object] = STATE(1152),
    [sym_pair] = STATE(1152),
    [aux_sym_member_expression_repeat1] = STATE(19),
    [ts_builtin_sym_end] = ACTIONS(308),
    [sym_identifier] = ACTIONS(246),
    [anon_sym_POUND] = ACTIONS(308),
    [anon_sym_package] = ACTIONS(310),
    [anon_sym_import] = ACTIONS(310),
    [anon_sym_using] = ACTIONS(310),
    [anon_sym_throw] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_switch] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_case] = ACTIONS(310),
    [anon_sym_default] = ACTIONS(310),
    [anon_sym_cast] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_DOLLARtype] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(310),
    [anon_sym_QMARK] = ACTIONS(310),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_AT_COLON] = ACTIONS(308),
    [anon_sym_if] = ACTIONS(310),
    [anon_sym_else] = ACTIONS(310),
    [anon_sym_new] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_BANG] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(308),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_EQ_GT] = ACTIONS(308),
    [anon_sym_QMARK_QMARK] = ACTIONS(308),
    [anon_sym_EQ] = ACTIONS(310),
    [sym__rangeOperator] = ACTIONS(308),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(310),
    [anon_sym_final] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_class] = ACTIONS(310),
    [anon_sym_extends] = ACTIONS(310),
    [anon_sym_implements] = ACTIONS(310),
    [anon_sym_interface] = ACTIONS(310),
    [anon_sym_typedef] = ACTIONS(310),
    [anon_sym_function] = ACTIONS(310),
    [anon_sym_var] = ACTIONS(310),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(310),
    [anon_sym_catch] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(310),
    [anon_sym_enum] = ACTIONS(310),
    [anon_sym_extern] = ACTIONS(310),
    [anon_sym_for] = ACTIONS(310),
    [anon_sym_inline] = ACTIONS(310),
    [anon_sym_macro] = ACTIONS(310),
    [anon_sym_operator] = ACTIONS(310),
    [anon_sym_overload] = ACTIONS(310),
    [anon_sym_override] = ACTIONS(310),
    [anon_sym_private] = ACTIONS(310),
    [anon_sym_public] = ACTIONS(310),
    [anon_sym_return] = ACTIONS(310),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_try] = ACTIONS(310),
    [anon_sym_untyped] = ACTIONS(310),
    [anon_sym_while] = ACTIONS(310),
    [sym__semicolon] = ACTIONS(308),
  },
  [22] = {
    [sym__rhs_expression] = STATE(61),
    [sym_member_expression] = STATE(80),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(61),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_POUND] = ACTIONS(240),
    [anon_sym_package] = ACTIONS(242),
    [anon_sym_import] = ACTIONS(242),
    [anon_sym_using] = ACTIONS(242),
    [anon_sym_throw] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_switch] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_case] = ACTIONS(242),
    [anon_sym_default] = ACTIONS(242),
    [anon_sym_cast] = ACTIONS(242),
    [anon_sym_DOLLARtype] = ACTIONS(240),
    [anon_sym_in] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_this] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_AT_COLON] = ACTIONS(240),
    [anon_sym_if] = ACTIONS(242),
    [anon_sym_else] = ACTIONS(242),
    [anon_sym_new] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_PERCENT] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_SLASH] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LT_LT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(242),
    [anon_sym_GT_GT_GT] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_EQ_EQ] = ACTIONS(240),
    [anon_sym_BANG_EQ] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(242),
    [anon_sym_LT_EQ] = ACTIONS(240),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_GT_EQ] = ACTIONS(240),
    [anon_sym_EQ_GT] = ACTIONS(240),
    [anon_sym_QMARK_QMARK] = ACTIONS(240),
    [anon_sym_EQ] = ACTIONS(242),
    [sym__rangeOperator] = ACTIONS(240),
    [anon_sym_null] = ACTIONS(242),
    [anon_sym_dynamic] = ACTIONS(242),
    [anon_sym_final] = ACTIONS(242),
    [anon_sym_abstract] = ACTIONS(242),
    [anon_sym_class] = ACTIONS(242),
    [anon_sym_extends] = ACTIONS(242),
    [anon_sym_implements] = ACTIONS(242),
    [anon_sym_interface] = ACTIONS(242),
    [anon_sym_typedef] = ACTIONS(242),
    [anon_sym_function] = ACTIONS(242),
    [anon_sym_var] = ACTIONS(242),
    [aux_sym_integer_token1] = ACTIONS(242),
    [aux_sym_integer_token2] = ACTIONS(240),
    [aux_sym_float_token1] = ACTIONS(242),
    [aux_sym_float_token2] = ACTIONS(240),
    [anon_sym_true] = ACTIONS(242),
    [anon_sym_false] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(240),
    [aux_sym_string_token3] = ACTIONS(240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(242),
    [anon_sym_catch] = ACTIONS(242),
    [anon_sym_continue] = ACTIONS(242),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_enum] = ACTIONS(242),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_for] = ACTIONS(242),
    [anon_sym_inline] = ACTIONS(242),
    [anon_sym_macro] = ACTIONS(242),
    [anon_sym_operator] = ACTIONS(242),
    [anon_sym_overload] = ACTIONS(242),
    [anon_sym_override] = ACTIONS(242),
    [anon_sym_private] = ACTIONS(242),
    [anon_sym_public] = ACTIONS(242),
    [anon_sym_return] = ACTIONS(242),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(242),
    [anon_sym_untyped] = ACTIONS(242),
    [anon_sym_while] = ACTIONS(242),
    [sym__semicolon] = ACTIONS(240),
  },
  [23] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(264),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_POUND] = ACTIONS(264),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_using] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_RPAREN] = ACTIONS(264),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(264),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_cast] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_DOLLARtype] = ACTIONS(264),
    [anon_sym_in] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(264),
    [anon_sym_this] = ACTIONS(315),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_AT_COLON] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(264),
    [anon_sym_BANG] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(264),
    [anon_sym_PERCENT] = ACTIONS(264),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(264),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_GT] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_CARET] = ACTIONS(264),
    [anon_sym_AMP_AMP] = ACTIONS(264),
    [anon_sym_PIPE_PIPE] = ACTIONS(264),
    [anon_sym_EQ_EQ] = ACTIONS(264),
    [anon_sym_BANG_EQ] = ACTIONS(264),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_LT_EQ] = ACTIONS(264),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(264),
    [anon_sym_EQ_GT] = ACTIONS(264),
    [anon_sym_QMARK_QMARK] = ACTIONS(264),
    [anon_sym_EQ] = ACTIONS(269),
    [sym__rangeOperator] = ACTIONS(264),
    [anon_sym_null] = ACTIONS(280),
    [anon_sym_dynamic] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_extends] = ACTIONS(269),
    [anon_sym_implements] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_typedef] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_var] = ACTIONS(269),
    [aux_sym_integer_token1] = ACTIONS(283),
    [aux_sym_integer_token2] = ACTIONS(286),
    [aux_sym_float_token1] = ACTIONS(289),
    [aux_sym_float_token2] = ACTIONS(292),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [aux_sym_string_token1] = ACTIONS(298),
    [aux_sym_string_token3] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_extern] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_macro] = ACTIONS(269),
    [anon_sym_operator] = ACTIONS(269),
    [anon_sym_overload] = ACTIONS(269),
    [anon_sym_override] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_untyped] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [sym__semicolon] = ACTIONS(264),
  },
  [24] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(308),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(308),
    [anon_sym_package] = ACTIONS(310),
    [anon_sym_import] = ACTIONS(310),
    [anon_sym_using] = ACTIONS(310),
    [anon_sym_throw] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_switch] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_case] = ACTIONS(310),
    [anon_sym_default] = ACTIONS(310),
    [anon_sym_cast] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_DOLLARtype] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_AT_COLON] = ACTIONS(308),
    [anon_sym_if] = ACTIONS(310),
    [anon_sym_else] = ACTIONS(310),
    [anon_sym_new] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_BANG] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(308),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_EQ_GT] = ACTIONS(308),
    [anon_sym_QMARK_QMARK] = ACTIONS(308),
    [anon_sym_EQ] = ACTIONS(310),
    [sym__rangeOperator] = ACTIONS(308),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(310),
    [anon_sym_final] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_class] = ACTIONS(310),
    [anon_sym_extends] = ACTIONS(310),
    [anon_sym_implements] = ACTIONS(310),
    [anon_sym_interface] = ACTIONS(310),
    [anon_sym_typedef] = ACTIONS(310),
    [anon_sym_function] = ACTIONS(310),
    [anon_sym_var] = ACTIONS(310),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(310),
    [anon_sym_catch] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(310),
    [anon_sym_enum] = ACTIONS(310),
    [anon_sym_extern] = ACTIONS(310),
    [anon_sym_for] = ACTIONS(310),
    [anon_sym_inline] = ACTIONS(310),
    [anon_sym_macro] = ACTIONS(310),
    [anon_sym_operator] = ACTIONS(310),
    [anon_sym_overload] = ACTIONS(310),
    [anon_sym_override] = ACTIONS(310),
    [anon_sym_private] = ACTIONS(310),
    [anon_sym_public] = ACTIONS(310),
    [anon_sym_return] = ACTIONS(310),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_try] = ACTIONS(310),
    [anon_sym_untyped] = ACTIONS(310),
    [anon_sym_while] = ACTIONS(310),
    [sym__semicolon] = ACTIONS(308),
  },
  [25] = {
    [sym_operator] = STATE(14),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(31),
    [ts_builtin_sym_end] = ACTIONS(320),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_POUND] = ACTIONS(320),
    [anon_sym_package] = ACTIONS(322),
    [anon_sym_import] = ACTIONS(322),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_throw] = ACTIONS(322),
    [anon_sym_LPAREN] = ACTIONS(320),
    [anon_sym_switch] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_case] = ACTIONS(322),
    [anon_sym_default] = ACTIONS(322),
    [anon_sym_cast] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(320),
    [anon_sym_DOLLARtype] = ACTIONS(320),
    [anon_sym_in] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(320),
    [anon_sym_this] = ACTIONS(322),
    [anon_sym_DOT] = ACTIONS(322),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(322),
    [anon_sym_AT_COLON] = ACTIONS(320),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(322),
    [anon_sym_new] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(322),
    [anon_sym_dynamic] = ACTIONS(322),
    [anon_sym_final] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(322),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_extends] = ACTIONS(322),
    [anon_sym_implements] = ACTIONS(322),
    [anon_sym_interface] = ACTIONS(322),
    [anon_sym_typedef] = ACTIONS(322),
    [anon_sym_function] = ACTIONS(322),
    [anon_sym_var] = ACTIONS(322),
    [aux_sym_integer_token1] = ACTIONS(322),
    [aux_sym_integer_token2] = ACTIONS(320),
    [aux_sym_float_token1] = ACTIONS(322),
    [aux_sym_float_token2] = ACTIONS(320),
    [anon_sym_true] = ACTIONS(322),
    [anon_sym_false] = ACTIONS(322),
    [aux_sym_string_token1] = ACTIONS(320),
    [aux_sym_string_token3] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(322),
    [anon_sym_catch] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(322),
    [anon_sym_do] = ACTIONS(322),
    [anon_sym_enum] = ACTIONS(322),
    [anon_sym_extern] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(322),
    [anon_sym_inline] = ACTIONS(322),
    [anon_sym_macro] = ACTIONS(322),
    [anon_sym_operator] = ACTIONS(322),
    [anon_sym_overload] = ACTIONS(322),
    [anon_sym_override] = ACTIONS(322),
    [anon_sym_private] = ACTIONS(322),
    [anon_sym_public] = ACTIONS(322),
    [anon_sym_return] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(322),
    [anon_sym_try] = ACTIONS(322),
    [anon_sym_untyped] = ACTIONS(322),
    [anon_sym_while] = ACTIONS(322),
    [sym__semicolon] = ACTIONS(320),
  },
  [26] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(304),
    [anon_sym_package] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_using] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(304),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_cast] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_DOLLARtype] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_AT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_new] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_PLUS_PLUS] = ACTIONS(304),
    [anon_sym_DASH_DASH] = ACTIONS(304),
    [anon_sym_PERCENT] = ACTIONS(304),
    [anon_sym_STAR] = ACTIONS(304),
    [anon_sym_SLASH] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_LT_LT] = ACTIONS(304),
    [anon_sym_GT_GT] = ACTIONS(306),
    [anon_sym_GT_GT_GT] = ACTIONS(304),
    [anon_sym_AMP] = ACTIONS(306),
    [anon_sym_PIPE] = ACTIONS(306),
    [anon_sym_CARET] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_EQ_EQ] = ACTIONS(304),
    [anon_sym_BANG_EQ] = ACTIONS(304),
    [anon_sym_LT] = ACTIONS(306),
    [anon_sym_LT_EQ] = ACTIONS(304),
    [anon_sym_GT] = ACTIONS(306),
    [anon_sym_GT_EQ] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_QMARK_QMARK] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(306),
    [sym__rangeOperator] = ACTIONS(304),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(306),
    [anon_sym_final] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_extends] = ACTIONS(306),
    [anon_sym_implements] = ACTIONS(306),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_typedef] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(306),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_catch] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_extern] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_inline] = ACTIONS(306),
    [anon_sym_macro] = ACTIONS(306),
    [anon_sym_operator] = ACTIONS(306),
    [anon_sym_overload] = ACTIONS(306),
    [anon_sym_override] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_untyped] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [sym__semicolon] = ACTIONS(304),
  },
  [27] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(264),
    [sym_identifier] = ACTIONS(330),
    [anon_sym_POUND] = ACTIONS(264),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_using] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_RPAREN] = ACTIONS(264),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(264),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_cast] = ACTIONS(269),
    [anon_sym_COMMA] = ACTIONS(264),
    [anon_sym_DOLLARtype] = ACTIONS(264),
    [anon_sym_in] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_this] = ACTIONS(333),
    [anon_sym_DASH_GT] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_AT_COLON] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(264),
    [anon_sym_BANG] = ACTIONS(269),
    [anon_sym_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(264),
    [anon_sym_PERCENT] = ACTIONS(264),
    [anon_sym_STAR] = ACTIONS(264),
    [anon_sym_SLASH] = ACTIONS(269),
    [anon_sym_PLUS] = ACTIONS(269),
    [anon_sym_LT_LT] = ACTIONS(264),
    [anon_sym_GT_GT] = ACTIONS(269),
    [anon_sym_GT_GT_GT] = ACTIONS(264),
    [anon_sym_AMP] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(269),
    [anon_sym_CARET] = ACTIONS(264),
    [anon_sym_AMP_AMP] = ACTIONS(264),
    [anon_sym_PIPE_PIPE] = ACTIONS(264),
    [anon_sym_EQ_EQ] = ACTIONS(264),
    [anon_sym_BANG_EQ] = ACTIONS(264),
    [anon_sym_LT] = ACTIONS(269),
    [anon_sym_LT_EQ] = ACTIONS(264),
    [anon_sym_GT] = ACTIONS(269),
    [anon_sym_GT_EQ] = ACTIONS(264),
    [anon_sym_EQ_GT] = ACTIONS(264),
    [anon_sym_QMARK_QMARK] = ACTIONS(264),
    [anon_sym_EQ] = ACTIONS(269),
    [sym__rangeOperator] = ACTIONS(264),
    [anon_sym_null] = ACTIONS(280),
    [anon_sym_dynamic] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_extends] = ACTIONS(269),
    [anon_sym_implements] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_typedef] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_var] = ACTIONS(269),
    [aux_sym_integer_token1] = ACTIONS(283),
    [aux_sym_integer_token2] = ACTIONS(286),
    [aux_sym_float_token1] = ACTIONS(289),
    [aux_sym_float_token2] = ACTIONS(292),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [aux_sym_string_token1] = ACTIONS(298),
    [aux_sym_string_token3] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_extern] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_macro] = ACTIONS(269),
    [anon_sym_operator] = ACTIONS(269),
    [anon_sym_overload] = ACTIONS(269),
    [anon_sym_override] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_untyped] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [sym__semicolon] = ACTIONS(264),
  },
  [28] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(260),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(260),
    [anon_sym_package] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(262),
    [anon_sym_using] = ACTIONS(262),
    [anon_sym_throw] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_switch] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_case] = ACTIONS(262),
    [anon_sym_default] = ACTIONS(262),
    [anon_sym_cast] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_DOLLARtype] = ACTIONS(260),
    [anon_sym_in] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(260),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_AT_COLON] = ACTIONS(260),
    [anon_sym_if] = ACTIONS(262),
    [anon_sym_else] = ACTIONS(262),
    [anon_sym_new] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(260),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_PLUS_PLUS] = ACTIONS(260),
    [anon_sym_DASH_DASH] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(260),
    [anon_sym_STAR] = ACTIONS(260),
    [anon_sym_SLASH] = ACTIONS(262),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_LT_LT] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(262),
    [anon_sym_GT_GT_GT] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(262),
    [anon_sym_PIPE] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(260),
    [anon_sym_AMP_AMP] = ACTIONS(260),
    [anon_sym_PIPE_PIPE] = ACTIONS(260),
    [anon_sym_EQ_EQ] = ACTIONS(260),
    [anon_sym_BANG_EQ] = ACTIONS(260),
    [anon_sym_LT] = ACTIONS(262),
    [anon_sym_LT_EQ] = ACTIONS(260),
    [anon_sym_GT] = ACTIONS(262),
    [anon_sym_GT_EQ] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(260),
    [anon_sym_QMARK_QMARK] = ACTIONS(260),
    [anon_sym_EQ] = ACTIONS(262),
    [sym__rangeOperator] = ACTIONS(260),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(262),
    [anon_sym_final] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(262),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_extends] = ACTIONS(262),
    [anon_sym_implements] = ACTIONS(262),
    [anon_sym_interface] = ACTIONS(262),
    [anon_sym_typedef] = ACTIONS(262),
    [anon_sym_function] = ACTIONS(262),
    [anon_sym_var] = ACTIONS(262),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(262),
    [anon_sym_catch] = ACTIONS(262),
    [anon_sym_continue] = ACTIONS(262),
    [anon_sym_do] = ACTIONS(262),
    [anon_sym_enum] = ACTIONS(262),
    [anon_sym_extern] = ACTIONS(262),
    [anon_sym_for] = ACTIONS(262),
    [anon_sym_inline] = ACTIONS(262),
    [anon_sym_macro] = ACTIONS(262),
    [anon_sym_operator] = ACTIONS(262),
    [anon_sym_overload] = ACTIONS(262),
    [anon_sym_override] = ACTIONS(262),
    [anon_sym_private] = ACTIONS(262),
    [anon_sym_public] = ACTIONS(262),
    [anon_sym_return] = ACTIONS(262),
    [anon_sym_static] = ACTIONS(262),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_untyped] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(262),
    [sym__semicolon] = ACTIONS(260),
  },
  [29] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(244),
    [anon_sym_package] = ACTIONS(248),
    [anon_sym_import] = ACTIONS(248),
    [anon_sym_using] = ACTIONS(248),
    [anon_sym_throw] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_switch] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_case] = ACTIONS(248),
    [anon_sym_default] = ACTIONS(248),
    [anon_sym_cast] = ACTIONS(248),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_DOLLARtype] = ACTIONS(244),
    [anon_sym_in] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(244),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_AT_COLON] = ACTIONS(244),
    [anon_sym_if] = ACTIONS(248),
    [anon_sym_else] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_PERCENT] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_LT_LT] = ACTIONS(244),
    [anon_sym_GT_GT] = ACTIONS(248),
    [anon_sym_GT_GT_GT] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_PIPE] = ACTIONS(248),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_EQ_EQ] = ACTIONS(244),
    [anon_sym_BANG_EQ] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(248),
    [anon_sym_LT_EQ] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(248),
    [anon_sym_GT_EQ] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(244),
    [anon_sym_QMARK_QMARK] = ACTIONS(244),
    [anon_sym_EQ] = ACTIONS(248),
    [sym__rangeOperator] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(248),
    [anon_sym_final] = ACTIONS(248),
    [anon_sym_abstract] = ACTIONS(248),
    [anon_sym_class] = ACTIONS(248),
    [anon_sym_extends] = ACTIONS(248),
    [anon_sym_implements] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(248),
    [anon_sym_typedef] = ACTIONS(248),
    [anon_sym_function] = ACTIONS(248),
    [anon_sym_var] = ACTIONS(248),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(248),
    [anon_sym_catch] = ACTIONS(248),
    [anon_sym_continue] = ACTIONS(248),
    [anon_sym_do] = ACTIONS(248),
    [anon_sym_enum] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_for] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_macro] = ACTIONS(248),
    [anon_sym_operator] = ACTIONS(248),
    [anon_sym_overload] = ACTIONS(248),
    [anon_sym_override] = ACTIONS(248),
    [anon_sym_private] = ACTIONS(248),
    [anon_sym_public] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(248),
    [anon_sym_untyped] = ACTIONS(248),
    [anon_sym_while] = ACTIONS(248),
    [sym__semicolon] = ACTIONS(244),
  },
  [30] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(256),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_package] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(258),
    [anon_sym_using] = ACTIONS(258),
    [anon_sym_throw] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_cast] = ACTIONS(258),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_DOLLARtype] = ACTIONS(256),
    [anon_sym_in] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(256),
    [anon_sym_AT] = ACTIONS(258),
    [anon_sym_AT_COLON] = ACTIONS(256),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_else] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PERCENT] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_SLASH] = ACTIONS(258),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(258),
    [anon_sym_GT_GT_GT] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_EQ_EQ] = ACTIONS(256),
    [anon_sym_BANG_EQ] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_LT_EQ] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_EQ] = ACTIONS(256),
    [anon_sym_EQ_GT] = ACTIONS(256),
    [anon_sym_QMARK_QMARK] = ACTIONS(256),
    [anon_sym_EQ] = ACTIONS(258),
    [sym__rangeOperator] = ACTIONS(256),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(258),
    [anon_sym_final] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(258),
    [anon_sym_class] = ACTIONS(258),
    [anon_sym_extends] = ACTIONS(258),
    [anon_sym_implements] = ACTIONS(258),
    [anon_sym_interface] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(258),
    [anon_sym_var] = ACTIONS(258),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_catch] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_macro] = ACTIONS(258),
    [anon_sym_operator] = ACTIONS(258),
    [anon_sym_overload] = ACTIONS(258),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_private] = ACTIONS(258),
    [anon_sym_public] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_untyped] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [sym__semicolon] = ACTIONS(256),
  },
  [31] = {
    [sym_operator] = STATE(784),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(36),
    [ts_builtin_sym_end] = ACTIONS(336),
    [sym_identifier] = ACTIONS(338),
    [anon_sym_POUND] = ACTIONS(336),
    [anon_sym_package] = ACTIONS(338),
    [anon_sym_import] = ACTIONS(338),
    [anon_sym_using] = ACTIONS(338),
    [anon_sym_throw] = ACTIONS(338),
    [anon_sym_LPAREN] = ACTIONS(336),
    [anon_sym_switch] = ACTIONS(338),
    [anon_sym_LBRACE] = ACTIONS(336),
    [anon_sym_RBRACE] = ACTIONS(336),
    [anon_sym_case] = ACTIONS(338),
    [anon_sym_default] = ACTIONS(338),
    [anon_sym_cast] = ACTIONS(338),
    [anon_sym_COMMA] = ACTIONS(336),
    [anon_sym_DOLLARtype] = ACTIONS(336),
    [anon_sym_in] = ACTIONS(338),
    [anon_sym_LBRACK] = ACTIONS(336),
    [anon_sym_this] = ACTIONS(338),
    [anon_sym_DOT] = ACTIONS(338),
    [anon_sym_QMARK] = ACTIONS(338),
    [anon_sym_AT] = ACTIONS(338),
    [anon_sym_AT_COLON] = ACTIONS(336),
    [anon_sym_if] = ACTIONS(338),
    [anon_sym_else] = ACTIONS(338),
    [anon_sym_new] = ACTIONS(338),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(338),
    [anon_sym_dynamic] = ACTIONS(338),
    [anon_sym_final] = ACTIONS(338),
    [anon_sym_abstract] = ACTIONS(338),
    [anon_sym_class] = ACTIONS(338),
    [anon_sym_extends] = ACTIONS(338),
    [anon_sym_implements] = ACTIONS(338),
    [anon_sym_interface] = ACTIONS(338),
    [anon_sym_typedef] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(338),
    [anon_sym_var] = ACTIONS(338),
    [aux_sym_integer_token1] = ACTIONS(338),
    [aux_sym_integer_token2] = ACTIONS(336),
    [aux_sym_float_token1] = ACTIONS(338),
    [aux_sym_float_token2] = ACTIONS(336),
    [anon_sym_true] = ACTIONS(338),
    [anon_sym_false] = ACTIONS(338),
    [aux_sym_string_token1] = ACTIONS(336),
    [aux_sym_string_token3] = ACTIONS(336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(338),
    [anon_sym_catch] = ACTIONS(338),
    [anon_sym_continue] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(338),
    [anon_sym_enum] = ACTIONS(338),
    [anon_sym_extern] = ACTIONS(338),
    [anon_sym_for] = ACTIONS(338),
    [anon_sym_inline] = ACTIONS(338),
    [anon_sym_macro] = ACTIONS(338),
    [anon_sym_operator] = ACTIONS(338),
    [anon_sym_overload] = ACTIONS(338),
    [anon_sym_override] = ACTIONS(338),
    [anon_sym_private] = ACTIONS(338),
    [anon_sym_public] = ACTIONS(338),
    [anon_sym_return] = ACTIONS(338),
    [anon_sym_static] = ACTIONS(338),
    [anon_sym_try] = ACTIONS(338),
    [anon_sym_untyped] = ACTIONS(338),
    [anon_sym_while] = ACTIONS(338),
    [sym__semicolon] = ACTIONS(336),
  },
  [32] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(244),
    [anon_sym_package] = ACTIONS(248),
    [anon_sym_import] = ACTIONS(248),
    [anon_sym_using] = ACTIONS(248),
    [anon_sym_throw] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_switch] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_case] = ACTIONS(248),
    [anon_sym_default] = ACTIONS(248),
    [anon_sym_cast] = ACTIONS(248),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_DOLLARtype] = ACTIONS(244),
    [anon_sym_in] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_AT_COLON] = ACTIONS(244),
    [anon_sym_if] = ACTIONS(248),
    [anon_sym_else] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_DASH] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_PERCENT] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_LT_LT] = ACTIONS(244),
    [anon_sym_GT_GT] = ACTIONS(248),
    [anon_sym_GT_GT_GT] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(248),
    [anon_sym_PIPE] = ACTIONS(248),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_EQ_EQ] = ACTIONS(244),
    [anon_sym_BANG_EQ] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(248),
    [anon_sym_LT_EQ] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(248),
    [anon_sym_GT_EQ] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(244),
    [anon_sym_QMARK_QMARK] = ACTIONS(244),
    [anon_sym_EQ] = ACTIONS(248),
    [sym__rangeOperator] = ACTIONS(244),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(248),
    [anon_sym_final] = ACTIONS(248),
    [anon_sym_abstract] = ACTIONS(248),
    [anon_sym_class] = ACTIONS(248),
    [anon_sym_extends] = ACTIONS(248),
    [anon_sym_implements] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(248),
    [anon_sym_typedef] = ACTIONS(248),
    [anon_sym_function] = ACTIONS(248),
    [anon_sym_var] = ACTIONS(248),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(248),
    [anon_sym_catch] = ACTIONS(248),
    [anon_sym_continue] = ACTIONS(248),
    [anon_sym_do] = ACTIONS(248),
    [anon_sym_enum] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_for] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_macro] = ACTIONS(248),
    [anon_sym_operator] = ACTIONS(248),
    [anon_sym_overload] = ACTIONS(248),
    [anon_sym_override] = ACTIONS(248),
    [anon_sym_private] = ACTIONS(248),
    [anon_sym_public] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(248),
    [anon_sym_untyped] = ACTIONS(248),
    [anon_sym_while] = ACTIONS(248),
    [sym__semicolon] = ACTIONS(244),
  },
  [33] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(252),
    [anon_sym_package] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(254),
    [anon_sym_using] = ACTIONS(254),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(254),
    [anon_sym_cast] = ACTIONS(254),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_DOLLARtype] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(252),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_COLON] = ACTIONS(252),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_new] = ACTIONS(254),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_DASH] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(252),
    [anon_sym_DASH_DASH] = ACTIONS(252),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_SLASH] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(252),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_EQ_GT] = ACTIONS(252),
    [anon_sym_QMARK_QMARK] = ACTIONS(252),
    [anon_sym_EQ] = ACTIONS(254),
    [sym__rangeOperator] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(254),
    [anon_sym_final] = ACTIONS(254),
    [anon_sym_abstract] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_extends] = ACTIONS(254),
    [anon_sym_implements] = ACTIONS(254),
    [anon_sym_interface] = ACTIONS(254),
    [anon_sym_typedef] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_var] = ACTIONS(254),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(254),
    [anon_sym_catch] = ACTIONS(254),
    [anon_sym_continue] = ACTIONS(254),
    [anon_sym_do] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(254),
    [anon_sym_extern] = ACTIONS(254),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_inline] = ACTIONS(254),
    [anon_sym_macro] = ACTIONS(254),
    [anon_sym_operator] = ACTIONS(254),
    [anon_sym_overload] = ACTIONS(254),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_private] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(254),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_try] = ACTIONS(254),
    [anon_sym_untyped] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [sym__semicolon] = ACTIONS(252),
  },
  [34] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(252),
    [anon_sym_package] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(254),
    [anon_sym_using] = ACTIONS(254),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(254),
    [anon_sym_cast] = ACTIONS(254),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_DOLLARtype] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_COLON] = ACTIONS(252),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_new] = ACTIONS(254),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_DASH] = ACTIONS(254),
    [anon_sym_PLUS_PLUS] = ACTIONS(252),
    [anon_sym_DASH_DASH] = ACTIONS(252),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_SLASH] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(252),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_EQ_GT] = ACTIONS(252),
    [anon_sym_QMARK_QMARK] = ACTIONS(252),
    [anon_sym_EQ] = ACTIONS(254),
    [sym__rangeOperator] = ACTIONS(252),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(254),
    [anon_sym_final] = ACTIONS(254),
    [anon_sym_abstract] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_extends] = ACTIONS(254),
    [anon_sym_implements] = ACTIONS(254),
    [anon_sym_interface] = ACTIONS(254),
    [anon_sym_typedef] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_var] = ACTIONS(254),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(254),
    [anon_sym_catch] = ACTIONS(254),
    [anon_sym_continue] = ACTIONS(254),
    [anon_sym_do] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(254),
    [anon_sym_extern] = ACTIONS(254),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_inline] = ACTIONS(254),
    [anon_sym_macro] = ACTIONS(254),
    [anon_sym_operator] = ACTIONS(254),
    [anon_sym_overload] = ACTIONS(254),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_private] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(254),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_try] = ACTIONS(254),
    [anon_sym_untyped] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [sym__semicolon] = ACTIONS(252),
  },
  [35] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(304),
    [anon_sym_package] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_using] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(304),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_cast] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_DOLLARtype] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(304),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_AT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_new] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_PLUS_PLUS] = ACTIONS(304),
    [anon_sym_DASH_DASH] = ACTIONS(304),
    [anon_sym_PERCENT] = ACTIONS(304),
    [anon_sym_STAR] = ACTIONS(304),
    [anon_sym_SLASH] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_LT_LT] = ACTIONS(304),
    [anon_sym_GT_GT] = ACTIONS(306),
    [anon_sym_GT_GT_GT] = ACTIONS(304),
    [anon_sym_AMP] = ACTIONS(306),
    [anon_sym_PIPE] = ACTIONS(306),
    [anon_sym_CARET] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_EQ_EQ] = ACTIONS(304),
    [anon_sym_BANG_EQ] = ACTIONS(304),
    [anon_sym_LT] = ACTIONS(306),
    [anon_sym_LT_EQ] = ACTIONS(304),
    [anon_sym_GT] = ACTIONS(306),
    [anon_sym_GT_EQ] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_QMARK_QMARK] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(306),
    [sym__rangeOperator] = ACTIONS(304),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(306),
    [anon_sym_final] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_extends] = ACTIONS(306),
    [anon_sym_implements] = ACTIONS(306),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_typedef] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(306),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_catch] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_extern] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_inline] = ACTIONS(306),
    [anon_sym_macro] = ACTIONS(306),
    [anon_sym_operator] = ACTIONS(306),
    [anon_sym_overload] = ACTIONS(306),
    [anon_sym_override] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_untyped] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [sym__semicolon] = ACTIONS(304),
  },
  [36] = {
    [sym_operator] = STATE(784),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(36),
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_identifier] = ACTIONS(342),
    [anon_sym_POUND] = ACTIONS(340),
    [anon_sym_package] = ACTIONS(342),
    [anon_sym_import] = ACTIONS(342),
    [anon_sym_using] = ACTIONS(342),
    [anon_sym_throw] = ACTIONS(342),
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_switch] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(340),
    [anon_sym_case] = ACTIONS(342),
    [anon_sym_default] = ACTIONS(342),
    [anon_sym_cast] = ACTIONS(342),
    [anon_sym_COMMA] = ACTIONS(340),
    [anon_sym_DOLLARtype] = ACTIONS(340),
    [anon_sym_in] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_this] = ACTIONS(342),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(342),
    [anon_sym_AT_COLON] = ACTIONS(340),
    [anon_sym_if] = ACTIONS(342),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_TILDE] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(353),
    [anon_sym_DASH_DASH] = ACTIONS(353),
    [anon_sym_PERCENT] = ACTIONS(356),
    [anon_sym_STAR] = ACTIONS(356),
    [anon_sym_SLASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_LT_LT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(359),
    [anon_sym_GT_GT_GT] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(356),
    [anon_sym_AMP_AMP] = ACTIONS(344),
    [anon_sym_PIPE_PIPE] = ACTIONS(344),
    [anon_sym_EQ_EQ] = ACTIONS(344),
    [anon_sym_BANG_EQ] = ACTIONS(344),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(344),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_EQ] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(344),
    [anon_sym_QMARK_QMARK] = ACTIONS(344),
    [anon_sym_EQ] = ACTIONS(347),
    [sym__rangeOperator] = ACTIONS(344),
    [anon_sym_null] = ACTIONS(342),
    [anon_sym_dynamic] = ACTIONS(342),
    [anon_sym_final] = ACTIONS(342),
    [anon_sym_abstract] = ACTIONS(342),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_extends] = ACTIONS(342),
    [anon_sym_implements] = ACTIONS(342),
    [anon_sym_interface] = ACTIONS(342),
    [anon_sym_typedef] = ACTIONS(342),
    [anon_sym_function] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(342),
    [aux_sym_integer_token1] = ACTIONS(342),
    [aux_sym_integer_token2] = ACTIONS(340),
    [aux_sym_float_token1] = ACTIONS(342),
    [aux_sym_float_token2] = ACTIONS(340),
    [anon_sym_true] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(342),
    [aux_sym_string_token1] = ACTIONS(340),
    [aux_sym_string_token3] = ACTIONS(340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(342),
    [anon_sym_catch] = ACTIONS(342),
    [anon_sym_continue] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(342),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_extern] = ACTIONS(342),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_inline] = ACTIONS(342),
    [anon_sym_macro] = ACTIONS(342),
    [anon_sym_operator] = ACTIONS(342),
    [anon_sym_overload] = ACTIONS(342),
    [anon_sym_override] = ACTIONS(342),
    [anon_sym_private] = ACTIONS(342),
    [anon_sym_public] = ACTIONS(342),
    [anon_sym_return] = ACTIONS(342),
    [anon_sym_static] = ACTIONS(342),
    [anon_sym_try] = ACTIONS(342),
    [anon_sym_untyped] = ACTIONS(342),
    [anon_sym_while] = ACTIONS(342),
    [sym__semicolon] = ACTIONS(340),
  },
  [37] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(260),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(260),
    [anon_sym_package] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(262),
    [anon_sym_using] = ACTIONS(262),
    [anon_sym_throw] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_switch] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_case] = ACTIONS(262),
    [anon_sym_default] = ACTIONS(262),
    [anon_sym_cast] = ACTIONS(262),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_DOLLARtype] = ACTIONS(260),
    [anon_sym_in] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(260),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_AT_COLON] = ACTIONS(260),
    [anon_sym_if] = ACTIONS(262),
    [anon_sym_else] = ACTIONS(262),
    [anon_sym_new] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(260),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_PLUS_PLUS] = ACTIONS(260),
    [anon_sym_DASH_DASH] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(260),
    [anon_sym_STAR] = ACTIONS(260),
    [anon_sym_SLASH] = ACTIONS(262),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_LT_LT] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(262),
    [anon_sym_GT_GT_GT] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(262),
    [anon_sym_PIPE] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(260),
    [anon_sym_AMP_AMP] = ACTIONS(260),
    [anon_sym_PIPE_PIPE] = ACTIONS(260),
    [anon_sym_EQ_EQ] = ACTIONS(260),
    [anon_sym_BANG_EQ] = ACTIONS(260),
    [anon_sym_LT] = ACTIONS(262),
    [anon_sym_LT_EQ] = ACTIONS(260),
    [anon_sym_GT] = ACTIONS(262),
    [anon_sym_GT_EQ] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(260),
    [anon_sym_QMARK_QMARK] = ACTIONS(260),
    [anon_sym_EQ] = ACTIONS(262),
    [sym__rangeOperator] = ACTIONS(260),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(262),
    [anon_sym_final] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(262),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_extends] = ACTIONS(262),
    [anon_sym_implements] = ACTIONS(262),
    [anon_sym_interface] = ACTIONS(262),
    [anon_sym_typedef] = ACTIONS(262),
    [anon_sym_function] = ACTIONS(262),
    [anon_sym_var] = ACTIONS(262),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(262),
    [anon_sym_catch] = ACTIONS(262),
    [anon_sym_continue] = ACTIONS(262),
    [anon_sym_do] = ACTIONS(262),
    [anon_sym_enum] = ACTIONS(262),
    [anon_sym_extern] = ACTIONS(262),
    [anon_sym_for] = ACTIONS(262),
    [anon_sym_inline] = ACTIONS(262),
    [anon_sym_macro] = ACTIONS(262),
    [anon_sym_operator] = ACTIONS(262),
    [anon_sym_overload] = ACTIONS(262),
    [anon_sym_override] = ACTIONS(262),
    [anon_sym_private] = ACTIONS(262),
    [anon_sym_public] = ACTIONS(262),
    [anon_sym_return] = ACTIONS(262),
    [anon_sym_static] = ACTIONS(262),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_untyped] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(262),
    [sym__semicolon] = ACTIONS(260),
  },
  [38] = {
    [sym_member_expression] = STATE(101),
    [sym__lhs_expression] = STATE(102),
    [sym__literal] = STATE(1167),
    [sym_integer] = STATE(1167),
    [sym_float] = STATE(1167),
    [sym_bool] = STATE(1167),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1167),
    [sym_array] = STATE(1167),
    [sym_map] = STATE(1167),
    [sym_object] = STATE(1167),
    [sym_pair] = STATE(1167),
    [aux_sym_member_expression_repeat1] = STATE(27),
    [ts_builtin_sym_end] = ACTIONS(308),
    [sym_identifier] = ACTIONS(326),
    [anon_sym_POUND] = ACTIONS(308),
    [anon_sym_package] = ACTIONS(310),
    [anon_sym_import] = ACTIONS(310),
    [anon_sym_using] = ACTIONS(310),
    [anon_sym_throw] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_switch] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_case] = ACTIONS(310),
    [anon_sym_default] = ACTIONS(310),
    [anon_sym_cast] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_DOLLARtype] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_DASH_GT] = ACTIONS(308),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_AT_COLON] = ACTIONS(308),
    [anon_sym_if] = ACTIONS(310),
    [anon_sym_else] = ACTIONS(310),
    [anon_sym_new] = ACTIONS(310),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_BANG] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_PERCENT] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(308),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_EQ_GT] = ACTIONS(308),
    [anon_sym_QMARK_QMARK] = ACTIONS(308),
    [anon_sym_EQ] = ACTIONS(310),
    [sym__rangeOperator] = ACTIONS(308),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(310),
    [anon_sym_final] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_class] = ACTIONS(310),
    [anon_sym_extends] = ACTIONS(310),
    [anon_sym_implements] = ACTIONS(310),
    [anon_sym_interface] = ACTIONS(310),
    [anon_sym_typedef] = ACTIONS(310),
    [anon_sym_function] = ACTIONS(310),
    [anon_sym_var] = ACTIONS(310),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(310),
    [anon_sym_catch] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(310),
    [anon_sym_enum] = ACTIONS(310),
    [anon_sym_extern] = ACTIONS(310),
    [anon_sym_for] = ACTIONS(310),
    [anon_sym_inline] = ACTIONS(310),
    [anon_sym_macro] = ACTIONS(310),
    [anon_sym_operator] = ACTIONS(310),
    [anon_sym_overload] = ACTIONS(310),
    [anon_sym_override] = ACTIONS(310),
    [anon_sym_private] = ACTIONS(310),
    [anon_sym_public] = ACTIONS(310),
    [anon_sym_return] = ACTIONS(310),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_try] = ACTIONS(310),
    [anon_sym_untyped] = ACTIONS(310),
    [anon_sym_while] = ACTIONS(310),
    [sym__semicolon] = ACTIONS(308),
  },
  [39] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1124),
    [sym_integer] = STATE(1124),
    [sym_float] = STATE(1124),
    [sym_bool] = STATE(1124),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1124),
    [sym_array] = STATE(1124),
    [sym_map] = STATE(1124),
    [sym_object] = STATE(1124),
    [sym_pair] = STATE(1124),
    [aux_sym_member_expression_repeat1] = STATE(23),
    [ts_builtin_sym_end] = ACTIONS(256),
    [sym_identifier] = ACTIONS(318),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_package] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(258),
    [anon_sym_using] = ACTIONS(258),
    [anon_sym_throw] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_cast] = ACTIONS(258),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_DOLLARtype] = ACTIONS(256),
    [anon_sym_in] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_RBRACK] = ACTIONS(256),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_AT] = ACTIONS(258),
    [anon_sym_AT_COLON] = ACTIONS(256),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_else] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_PERCENT] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_SLASH] = ACTIONS(258),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(258),
    [anon_sym_GT_GT_GT] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_EQ_EQ] = ACTIONS(256),
    [anon_sym_BANG_EQ] = ACTIONS(256),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_LT_EQ] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_EQ] = ACTIONS(256),
    [anon_sym_EQ_GT] = ACTIONS(256),
    [anon_sym_QMARK_QMARK] = ACTIONS(256),
    [anon_sym_EQ] = ACTIONS(258),
    [sym__rangeOperator] = ACTIONS(256),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(258),
    [anon_sym_final] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(258),
    [anon_sym_class] = ACTIONS(258),
    [anon_sym_extends] = ACTIONS(258),
    [anon_sym_implements] = ACTIONS(258),
    [anon_sym_interface] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(258),
    [anon_sym_var] = ACTIONS(258),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_catch] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_macro] = ACTIONS(258),
    [anon_sym_operator] = ACTIONS(258),
    [anon_sym_overload] = ACTIONS(258),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_private] = ACTIONS(258),
    [anon_sym_public] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_untyped] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [sym__semicolon] = ACTIONS(256),
  },
  [40] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(362),
    [sym_identifier] = ACTIONS(364),
    [anon_sym_POUND] = ACTIONS(362),
    [anon_sym_package] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(364),
    [anon_sym_using] = ACTIONS(364),
    [anon_sym_throw] = ACTIONS(364),
    [anon_sym_LPAREN] = ACTIONS(362),
    [anon_sym_switch] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_case] = ACTIONS(364),
    [anon_sym_default] = ACTIONS(364),
    [anon_sym_cast] = ACTIONS(364),
    [anon_sym_DOLLARtype] = ACTIONS(362),
    [anon_sym_in] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(362),
    [anon_sym_this] = ACTIONS(364),
    [anon_sym_AT] = ACTIONS(364),
    [anon_sym_AT_COLON] = ACTIONS(362),
    [anon_sym_if] = ACTIONS(364),
    [anon_sym_else] = ACTIONS(364),
    [anon_sym_new] = ACTIONS(364),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(364),
    [anon_sym_dynamic] = ACTIONS(364),
    [anon_sym_final] = ACTIONS(364),
    [anon_sym_abstract] = ACTIONS(364),
    [anon_sym_class] = ACTIONS(364),
    [anon_sym_extends] = ACTIONS(364),
    [anon_sym_implements] = ACTIONS(364),
    [anon_sym_interface] = ACTIONS(364),
    [anon_sym_typedef] = ACTIONS(364),
    [anon_sym_function] = ACTIONS(364),
    [anon_sym_var] = ACTIONS(364),
    [aux_sym_integer_token1] = ACTIONS(364),
    [aux_sym_integer_token2] = ACTIONS(362),
    [aux_sym_float_token1] = ACTIONS(364),
    [aux_sym_float_token2] = ACTIONS(362),
    [anon_sym_true] = ACTIONS(364),
    [anon_sym_false] = ACTIONS(364),
    [aux_sym_string_token1] = ACTIONS(362),
    [aux_sym_string_token3] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(364),
    [anon_sym_catch] = ACTIONS(364),
    [anon_sym_continue] = ACTIONS(364),
    [anon_sym_do] = ACTIONS(364),
    [anon_sym_enum] = ACTIONS(364),
    [anon_sym_extern] = ACTIONS(364),
    [anon_sym_for] = ACTIONS(364),
    [anon_sym_inline] = ACTIONS(364),
    [anon_sym_macro] = ACTIONS(364),
    [anon_sym_operator] = ACTIONS(364),
    [anon_sym_overload] = ACTIONS(364),
    [anon_sym_override] = ACTIONS(364),
    [anon_sym_private] = ACTIONS(364),
    [anon_sym_public] = ACTIONS(364),
    [anon_sym_return] = ACTIONS(364),
    [anon_sym_static] = ACTIONS(364),
    [anon_sym_try] = ACTIONS(364),
    [anon_sym_untyped] = ACTIONS(364),
    [anon_sym_while] = ACTIONS(364),
    [sym__semicolon] = ACTIONS(362),
  },
  [41] = {
    [sym_operator] = STATE(22),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(46),
    [ts_builtin_sym_end] = ACTIONS(366),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_POUND] = ACTIONS(366),
    [anon_sym_package] = ACTIONS(368),
    [anon_sym_import] = ACTIONS(368),
    [anon_sym_using] = ACTIONS(368),
    [anon_sym_throw] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_switch] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(366),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_case] = ACTIONS(368),
    [anon_sym_default] = ACTIONS(368),
    [anon_sym_cast] = ACTIONS(368),
    [anon_sym_DOLLARtype] = ACTIONS(366),
    [anon_sym_in] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_this] = ACTIONS(368),
    [anon_sym_AT] = ACTIONS(368),
    [anon_sym_AT_COLON] = ACTIONS(366),
    [anon_sym_if] = ACTIONS(368),
    [anon_sym_else] = ACTIONS(368),
    [anon_sym_new] = ACTIONS(368),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(368),
    [anon_sym_dynamic] = ACTIONS(368),
    [anon_sym_final] = ACTIONS(368),
    [anon_sym_abstract] = ACTIONS(368),
    [anon_sym_class] = ACTIONS(368),
    [anon_sym_extends] = ACTIONS(368),
    [anon_sym_implements] = ACTIONS(368),
    [anon_sym_interface] = ACTIONS(368),
    [anon_sym_typedef] = ACTIONS(368),
    [anon_sym_function] = ACTIONS(368),
    [anon_sym_var] = ACTIONS(368),
    [aux_sym_integer_token1] = ACTIONS(368),
    [aux_sym_integer_token2] = ACTIONS(366),
    [aux_sym_float_token1] = ACTIONS(368),
    [aux_sym_float_token2] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(368),
    [anon_sym_false] = ACTIONS(368),
    [aux_sym_string_token1] = ACTIONS(366),
    [aux_sym_string_token3] = ACTIONS(366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(368),
    [anon_sym_catch] = ACTIONS(368),
    [anon_sym_continue] = ACTIONS(368),
    [anon_sym_do] = ACTIONS(368),
    [anon_sym_enum] = ACTIONS(368),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym_for] = ACTIONS(368),
    [anon_sym_inline] = ACTIONS(368),
    [anon_sym_macro] = ACTIONS(368),
    [anon_sym_operator] = ACTIONS(368),
    [anon_sym_overload] = ACTIONS(368),
    [anon_sym_override] = ACTIONS(368),
    [anon_sym_private] = ACTIONS(368),
    [anon_sym_public] = ACTIONS(368),
    [anon_sym_return] = ACTIONS(368),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_try] = ACTIONS(368),
    [anon_sym_untyped] = ACTIONS(368),
    [anon_sym_while] = ACTIONS(368),
    [sym__semicolon] = ACTIONS(366),
  },
  [42] = {
    [sym_operator] = STATE(22),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(43),
    [ts_builtin_sym_end] = ACTIONS(370),
    [sym_identifier] = ACTIONS(372),
    [anon_sym_POUND] = ACTIONS(370),
    [anon_sym_package] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(372),
    [anon_sym_using] = ACTIONS(372),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_switch] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_case] = ACTIONS(372),
    [anon_sym_default] = ACTIONS(372),
    [anon_sym_cast] = ACTIONS(372),
    [anon_sym_DOLLARtype] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_this] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_AT_COLON] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(372),
    [anon_sym_new] = ACTIONS(372),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(372),
    [anon_sym_dynamic] = ACTIONS(372),
    [anon_sym_final] = ACTIONS(372),
    [anon_sym_abstract] = ACTIONS(372),
    [anon_sym_class] = ACTIONS(372),
    [anon_sym_extends] = ACTIONS(372),
    [anon_sym_implements] = ACTIONS(372),
    [anon_sym_interface] = ACTIONS(372),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_function] = ACTIONS(372),
    [anon_sym_var] = ACTIONS(372),
    [aux_sym_integer_token1] = ACTIONS(372),
    [aux_sym_integer_token2] = ACTIONS(370),
    [aux_sym_float_token1] = ACTIONS(372),
    [aux_sym_float_token2] = ACTIONS(370),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(372),
    [aux_sym_string_token1] = ACTIONS(370),
    [aux_sym_string_token3] = ACTIONS(370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(372),
    [anon_sym_catch] = ACTIONS(372),
    [anon_sym_continue] = ACTIONS(372),
    [anon_sym_do] = ACTIONS(372),
    [anon_sym_enum] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(372),
    [anon_sym_for] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(372),
    [anon_sym_operator] = ACTIONS(372),
    [anon_sym_overload] = ACTIONS(372),
    [anon_sym_override] = ACTIONS(372),
    [anon_sym_private] = ACTIONS(372),
    [anon_sym_public] = ACTIONS(372),
    [anon_sym_return] = ACTIONS(372),
    [anon_sym_static] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(372),
    [anon_sym_untyped] = ACTIONS(372),
    [anon_sym_while] = ACTIONS(372),
    [sym__semicolon] = ACTIONS(374),
  },
  [43] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_identifier] = ACTIONS(376),
    [anon_sym_POUND] = ACTIONS(89),
    [anon_sym_package] = ACTIONS(376),
    [anon_sym_import] = ACTIONS(376),
    [anon_sym_using] = ACTIONS(376),
    [anon_sym_throw] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(89),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(376),
    [anon_sym_cast] = ACTIONS(376),
    [anon_sym_DOLLARtype] = ACTIONS(89),
    [anon_sym_in] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_this] = ACTIONS(376),
    [anon_sym_AT] = ACTIONS(376),
    [anon_sym_AT_COLON] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_else] = ACTIONS(376),
    [anon_sym_new] = ACTIONS(376),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(376),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_LT_LT] = ACTIONS(89),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_GT_GT_GT] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(89),
    [anon_sym_AMP_AMP] = ACTIONS(89),
    [anon_sym_PIPE_PIPE] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(89),
    [anon_sym_EQ_GT] = ACTIONS(89),
    [anon_sym_QMARK_QMARK] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(376),
    [sym__rangeOperator] = ACTIONS(89),
    [anon_sym_null] = ACTIONS(376),
    [anon_sym_dynamic] = ACTIONS(376),
    [anon_sym_final] = ACTIONS(376),
    [anon_sym_abstract] = ACTIONS(376),
    [anon_sym_class] = ACTIONS(376),
    [anon_sym_extends] = ACTIONS(376),
    [anon_sym_implements] = ACTIONS(376),
    [anon_sym_interface] = ACTIONS(376),
    [anon_sym_typedef] = ACTIONS(376),
    [anon_sym_function] = ACTIONS(376),
    [anon_sym_var] = ACTIONS(376),
    [aux_sym_integer_token1] = ACTIONS(376),
    [aux_sym_integer_token2] = ACTIONS(89),
    [aux_sym_float_token1] = ACTIONS(376),
    [aux_sym_float_token2] = ACTIONS(89),
    [anon_sym_true] = ACTIONS(376),
    [anon_sym_false] = ACTIONS(376),
    [aux_sym_string_token1] = ACTIONS(89),
    [aux_sym_string_token3] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(376),
    [anon_sym_catch] = ACTIONS(376),
    [anon_sym_continue] = ACTIONS(376),
    [anon_sym_do] = ACTIONS(376),
    [anon_sym_enum] = ACTIONS(376),
    [anon_sym_extern] = ACTIONS(376),
    [anon_sym_for] = ACTIONS(376),
    [anon_sym_inline] = ACTIONS(376),
    [anon_sym_macro] = ACTIONS(376),
    [anon_sym_operator] = ACTIONS(376),
    [anon_sym_overload] = ACTIONS(376),
    [anon_sym_override] = ACTIONS(376),
    [anon_sym_private] = ACTIONS(376),
    [anon_sym_public] = ACTIONS(376),
    [anon_sym_return] = ACTIONS(376),
    [anon_sym_static] = ACTIONS(376),
    [anon_sym_try] = ACTIONS(376),
    [anon_sym_untyped] = ACTIONS(376),
    [anon_sym_while] = ACTIONS(376),
    [sym__semicolon] = ACTIONS(378),
  },
  [44] = {
    [sym_operator] = STATE(22),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(45),
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_POUND] = ACTIONS(380),
    [anon_sym_package] = ACTIONS(382),
    [anon_sym_import] = ACTIONS(382),
    [anon_sym_using] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_case] = ACTIONS(382),
    [anon_sym_default] = ACTIONS(382),
    [anon_sym_cast] = ACTIONS(382),
    [anon_sym_DOLLARtype] = ACTIONS(380),
    [anon_sym_in] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_this] = ACTIONS(382),
    [anon_sym_AT] = ACTIONS(382),
    [anon_sym_AT_COLON] = ACTIONS(380),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(382),
    [anon_sym_dynamic] = ACTIONS(382),
    [anon_sym_final] = ACTIONS(382),
    [anon_sym_abstract] = ACTIONS(382),
    [anon_sym_class] = ACTIONS(382),
    [anon_sym_extends] = ACTIONS(382),
    [anon_sym_implements] = ACTIONS(382),
    [anon_sym_interface] = ACTIONS(382),
    [anon_sym_typedef] = ACTIONS(382),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_var] = ACTIONS(382),
    [aux_sym_integer_token1] = ACTIONS(382),
    [aux_sym_integer_token2] = ACTIONS(380),
    [aux_sym_float_token1] = ACTIONS(382),
    [aux_sym_float_token2] = ACTIONS(380),
    [anon_sym_true] = ACTIONS(382),
    [anon_sym_false] = ACTIONS(382),
    [aux_sym_string_token1] = ACTIONS(380),
    [aux_sym_string_token3] = ACTIONS(380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_catch] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_enum] = ACTIONS(382),
    [anon_sym_extern] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_inline] = ACTIONS(382),
    [anon_sym_macro] = ACTIONS(382),
    [anon_sym_operator] = ACTIONS(382),
    [anon_sym_overload] = ACTIONS(382),
    [anon_sym_override] = ACTIONS(382),
    [anon_sym_private] = ACTIONS(382),
    [anon_sym_public] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_untyped] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [sym__semicolon] = ACTIONS(380),
  },
  [45] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(384),
    [sym_identifier] = ACTIONS(386),
    [anon_sym_POUND] = ACTIONS(384),
    [anon_sym_package] = ACTIONS(386),
    [anon_sym_import] = ACTIONS(386),
    [anon_sym_using] = ACTIONS(386),
    [anon_sym_throw] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_switch] = ACTIONS(386),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_case] = ACTIONS(386),
    [anon_sym_default] = ACTIONS(386),
    [anon_sym_cast] = ACTIONS(386),
    [anon_sym_DOLLARtype] = ACTIONS(384),
    [anon_sym_in] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_this] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(386),
    [anon_sym_AT_COLON] = ACTIONS(384),
    [anon_sym_if] = ACTIONS(386),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_new] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_PERCENT] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(384),
    [anon_sym_SLASH] = ACTIONS(386),
    [anon_sym_PLUS] = ACTIONS(386),
    [anon_sym_LT_LT] = ACTIONS(384),
    [anon_sym_GT_GT] = ACTIONS(386),
    [anon_sym_GT_GT_GT] = ACTIONS(384),
    [anon_sym_AMP] = ACTIONS(386),
    [anon_sym_PIPE] = ACTIONS(386),
    [anon_sym_CARET] = ACTIONS(384),
    [anon_sym_AMP_AMP] = ACTIONS(384),
    [anon_sym_PIPE_PIPE] = ACTIONS(384),
    [anon_sym_EQ_EQ] = ACTIONS(384),
    [anon_sym_BANG_EQ] = ACTIONS(384),
    [anon_sym_LT] = ACTIONS(386),
    [anon_sym_LT_EQ] = ACTIONS(384),
    [anon_sym_GT] = ACTIONS(386),
    [anon_sym_GT_EQ] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(384),
    [anon_sym_QMARK_QMARK] = ACTIONS(384),
    [anon_sym_EQ] = ACTIONS(386),
    [sym__rangeOperator] = ACTIONS(384),
    [anon_sym_null] = ACTIONS(386),
    [anon_sym_dynamic] = ACTIONS(386),
    [anon_sym_final] = ACTIONS(386),
    [anon_sym_abstract] = ACTIONS(386),
    [anon_sym_class] = ACTIONS(386),
    [anon_sym_extends] = ACTIONS(386),
    [anon_sym_implements] = ACTIONS(386),
    [anon_sym_interface] = ACTIONS(386),
    [anon_sym_typedef] = ACTIONS(386),
    [anon_sym_function] = ACTIONS(386),
    [anon_sym_var] = ACTIONS(386),
    [aux_sym_integer_token1] = ACTIONS(386),
    [aux_sym_integer_token2] = ACTIONS(384),
    [aux_sym_float_token1] = ACTIONS(386),
    [aux_sym_float_token2] = ACTIONS(384),
    [anon_sym_true] = ACTIONS(386),
    [anon_sym_false] = ACTIONS(386),
    [aux_sym_string_token1] = ACTIONS(384),
    [aux_sym_string_token3] = ACTIONS(384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(386),
    [anon_sym_catch] = ACTIONS(386),
    [anon_sym_continue] = ACTIONS(386),
    [anon_sym_do] = ACTIONS(386),
    [anon_sym_enum] = ACTIONS(386),
    [anon_sym_extern] = ACTIONS(386),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_inline] = ACTIONS(386),
    [anon_sym_macro] = ACTIONS(386),
    [anon_sym_operator] = ACTIONS(386),
    [anon_sym_overload] = ACTIONS(386),
    [anon_sym_override] = ACTIONS(386),
    [anon_sym_private] = ACTIONS(386),
    [anon_sym_public] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_static] = ACTIONS(386),
    [anon_sym_try] = ACTIONS(386),
    [anon_sym_untyped] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(386),
    [sym__semicolon] = ACTIONS(384),
  },
  [46] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_identifier] = ACTIONS(390),
    [anon_sym_POUND] = ACTIONS(388),
    [anon_sym_package] = ACTIONS(390),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_using] = ACTIONS(390),
    [anon_sym_throw] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_switch] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_cast] = ACTIONS(390),
    [anon_sym_DOLLARtype] = ACTIONS(388),
    [anon_sym_in] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_this] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(390),
    [anon_sym_AT_COLON] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_PERCENT] = ACTIONS(388),
    [anon_sym_STAR] = ACTIONS(388),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(388),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_GT_GT_GT] = ACTIONS(388),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ_GT] = ACTIONS(388),
    [anon_sym_QMARK_QMARK] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [sym__rangeOperator] = ACTIONS(388),
    [anon_sym_null] = ACTIONS(390),
    [anon_sym_dynamic] = ACTIONS(390),
    [anon_sym_final] = ACTIONS(390),
    [anon_sym_abstract] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(390),
    [anon_sym_extends] = ACTIONS(390),
    [anon_sym_implements] = ACTIONS(390),
    [anon_sym_interface] = ACTIONS(390),
    [anon_sym_typedef] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [aux_sym_integer_token1] = ACTIONS(390),
    [aux_sym_integer_token2] = ACTIONS(388),
    [aux_sym_float_token1] = ACTIONS(390),
    [aux_sym_float_token2] = ACTIONS(388),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [aux_sym_string_token1] = ACTIONS(388),
    [aux_sym_string_token3] = ACTIONS(388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_catch] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_enum] = ACTIONS(390),
    [anon_sym_extern] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_inline] = ACTIONS(390),
    [anon_sym_macro] = ACTIONS(390),
    [anon_sym_operator] = ACTIONS(390),
    [anon_sym_overload] = ACTIONS(390),
    [anon_sym_override] = ACTIONS(390),
    [anon_sym_private] = ACTIONS(390),
    [anon_sym_public] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_untyped] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [sym__semicolon] = ACTIONS(388),
  },
  [47] = {
    [sym_operator] = STATE(22),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(48),
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_identifier] = ACTIONS(390),
    [anon_sym_POUND] = ACTIONS(388),
    [anon_sym_package] = ACTIONS(390),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_using] = ACTIONS(390),
    [anon_sym_throw] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_switch] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_cast] = ACTIONS(390),
    [anon_sym_DOLLARtype] = ACTIONS(388),
    [anon_sym_in] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_this] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(390),
    [anon_sym_AT_COLON] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(390),
    [anon_sym_dynamic] = ACTIONS(390),
    [anon_sym_final] = ACTIONS(390),
    [anon_sym_abstract] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(390),
    [anon_sym_extends] = ACTIONS(390),
    [anon_sym_implements] = ACTIONS(390),
    [anon_sym_interface] = ACTIONS(390),
    [anon_sym_typedef] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [aux_sym_integer_token1] = ACTIONS(390),
    [aux_sym_integer_token2] = ACTIONS(388),
    [aux_sym_float_token1] = ACTIONS(390),
    [aux_sym_float_token2] = ACTIONS(388),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [aux_sym_string_token1] = ACTIONS(388),
    [aux_sym_string_token3] = ACTIONS(388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_catch] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_enum] = ACTIONS(390),
    [anon_sym_extern] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_inline] = ACTIONS(390),
    [anon_sym_macro] = ACTIONS(390),
    [anon_sym_operator] = ACTIONS(390),
    [anon_sym_overload] = ACTIONS(390),
    [anon_sym_override] = ACTIONS(390),
    [anon_sym_private] = ACTIONS(390),
    [anon_sym_public] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_untyped] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [sym__semicolon] = ACTIONS(388),
  },
  [48] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(392),
    [sym_identifier] = ACTIONS(394),
    [anon_sym_POUND] = ACTIONS(392),
    [anon_sym_package] = ACTIONS(394),
    [anon_sym_import] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(394),
    [anon_sym_throw] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_switch] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_case] = ACTIONS(394),
    [anon_sym_default] = ACTIONS(394),
    [anon_sym_cast] = ACTIONS(394),
    [anon_sym_DOLLARtype] = ACTIONS(392),
    [anon_sym_in] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_this] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(394),
    [anon_sym_AT_COLON] = ACTIONS(392),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_else] = ACTIONS(394),
    [anon_sym_new] = ACTIONS(394),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_BANG] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(394),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_STAR] = ACTIONS(392),
    [anon_sym_SLASH] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(394),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_GT_GT_GT] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_AMP_AMP] = ACTIONS(392),
    [anon_sym_PIPE_PIPE] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(392),
    [anon_sym_BANG_EQ] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_LT_EQ] = ACTIONS(392),
    [anon_sym_GT] = ACTIONS(394),
    [anon_sym_GT_EQ] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(392),
    [anon_sym_QMARK_QMARK] = ACTIONS(392),
    [anon_sym_EQ] = ACTIONS(394),
    [sym__rangeOperator] = ACTIONS(392),
    [anon_sym_null] = ACTIONS(394),
    [anon_sym_dynamic] = ACTIONS(394),
    [anon_sym_final] = ACTIONS(394),
    [anon_sym_abstract] = ACTIONS(394),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_extends] = ACTIONS(394),
    [anon_sym_implements] = ACTIONS(394),
    [anon_sym_interface] = ACTIONS(394),
    [anon_sym_typedef] = ACTIONS(394),
    [anon_sym_function] = ACTIONS(394),
    [anon_sym_var] = ACTIONS(394),
    [aux_sym_integer_token1] = ACTIONS(394),
    [aux_sym_integer_token2] = ACTIONS(392),
    [aux_sym_float_token1] = ACTIONS(394),
    [aux_sym_float_token2] = ACTIONS(392),
    [anon_sym_true] = ACTIONS(394),
    [anon_sym_false] = ACTIONS(394),
    [aux_sym_string_token1] = ACTIONS(392),
    [aux_sym_string_token3] = ACTIONS(392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(394),
    [anon_sym_catch] = ACTIONS(394),
    [anon_sym_continue] = ACTIONS(394),
    [anon_sym_do] = ACTIONS(394),
    [anon_sym_enum] = ACTIONS(394),
    [anon_sym_extern] = ACTIONS(394),
    [anon_sym_for] = ACTIONS(394),
    [anon_sym_inline] = ACTIONS(394),
    [anon_sym_macro] = ACTIONS(394),
    [anon_sym_operator] = ACTIONS(394),
    [anon_sym_overload] = ACTIONS(394),
    [anon_sym_override] = ACTIONS(394),
    [anon_sym_private] = ACTIONS(394),
    [anon_sym_public] = ACTIONS(394),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_static] = ACTIONS(394),
    [anon_sym_try] = ACTIONS(394),
    [anon_sym_untyped] = ACTIONS(394),
    [anon_sym_while] = ACTIONS(394),
    [sym__semicolon] = ACTIONS(392),
  },
  [49] = {
    [sym_operator] = STATE(812),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(49),
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_identifier] = ACTIONS(342),
    [anon_sym_POUND] = ACTIONS(340),
    [anon_sym_package] = ACTIONS(342),
    [anon_sym_import] = ACTIONS(342),
    [anon_sym_using] = ACTIONS(342),
    [anon_sym_throw] = ACTIONS(342),
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_switch] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(340),
    [anon_sym_case] = ACTIONS(342),
    [anon_sym_default] = ACTIONS(342),
    [anon_sym_cast] = ACTIONS(342),
    [anon_sym_DOLLARtype] = ACTIONS(340),
    [anon_sym_in] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_this] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(342),
    [anon_sym_AT_COLON] = ACTIONS(340),
    [anon_sym_if] = ACTIONS(342),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_TILDE] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(353),
    [anon_sym_DASH_DASH] = ACTIONS(353),
    [anon_sym_PERCENT] = ACTIONS(356),
    [anon_sym_STAR] = ACTIONS(356),
    [anon_sym_SLASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_LT_LT] = ACTIONS(356),
    [anon_sym_GT_GT] = ACTIONS(359),
    [anon_sym_GT_GT_GT] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(359),
    [anon_sym_PIPE] = ACTIONS(359),
    [anon_sym_CARET] = ACTIONS(356),
    [anon_sym_AMP_AMP] = ACTIONS(344),
    [anon_sym_PIPE_PIPE] = ACTIONS(344),
    [anon_sym_EQ_EQ] = ACTIONS(344),
    [anon_sym_BANG_EQ] = ACTIONS(344),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(344),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_GT_EQ] = ACTIONS(344),
    [anon_sym_EQ_GT] = ACTIONS(344),
    [anon_sym_QMARK_QMARK] = ACTIONS(344),
    [anon_sym_EQ] = ACTIONS(347),
    [sym__rangeOperator] = ACTIONS(344),
    [anon_sym_null] = ACTIONS(342),
    [anon_sym_dynamic] = ACTIONS(342),
    [anon_sym_final] = ACTIONS(342),
    [anon_sym_abstract] = ACTIONS(342),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_extends] = ACTIONS(342),
    [anon_sym_implements] = ACTIONS(342),
    [anon_sym_interface] = ACTIONS(342),
    [anon_sym_typedef] = ACTIONS(342),
    [anon_sym_function] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(342),
    [aux_sym_integer_token1] = ACTIONS(342),
    [aux_sym_integer_token2] = ACTIONS(340),
    [aux_sym_float_token1] = ACTIONS(342),
    [aux_sym_float_token2] = ACTIONS(340),
    [anon_sym_true] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(342),
    [aux_sym_string_token1] = ACTIONS(340),
    [aux_sym_string_token3] = ACTIONS(340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(342),
    [anon_sym_catch] = ACTIONS(342),
    [anon_sym_continue] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(342),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_extern] = ACTIONS(342),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_inline] = ACTIONS(342),
    [anon_sym_macro] = ACTIONS(342),
    [anon_sym_operator] = ACTIONS(342),
    [anon_sym_overload] = ACTIONS(342),
    [anon_sym_override] = ACTIONS(342),
    [anon_sym_private] = ACTIONS(342),
    [anon_sym_public] = ACTIONS(342),
    [anon_sym_return] = ACTIONS(342),
    [anon_sym_static] = ACTIONS(342),
    [anon_sym_try] = ACTIONS(342),
    [anon_sym_untyped] = ACTIONS(342),
    [anon_sym_while] = ACTIONS(342),
    [sym__semicolon] = ACTIONS(340),
  },
  [50] = {
    [sym_operator] = STATE(22),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(88),
    [sym__bitwiseOperator] = STATE(88),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [aux_sym_expression_repeat1] = STATE(40),
    [ts_builtin_sym_end] = ACTIONS(396),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_POUND] = ACTIONS(396),
    [anon_sym_package] = ACTIONS(398),
    [anon_sym_import] = ACTIONS(398),
    [anon_sym_using] = ACTIONS(398),
    [anon_sym_throw] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(396),
    [anon_sym_switch] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_case] = ACTIONS(398),
    [anon_sym_default] = ACTIONS(398),
    [anon_sym_cast] = ACTIONS(398),
    [anon_sym_DOLLARtype] = ACTIONS(396),
    [anon_sym_in] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(396),
    [anon_sym_this] = ACTIONS(398),
    [anon_sym_AT] = ACTIONS(398),
    [anon_sym_AT_COLON] = ACTIONS(396),
    [anon_sym_if] = ACTIONS(398),
    [anon_sym_else] = ACTIONS(398),
    [anon_sym_new] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(324),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(47),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SLASH] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(49),
    [anon_sym_LT_LT] = ACTIONS(47),
    [anon_sym_GT_GT] = ACTIONS(49),
    [anon_sym_GT_GT_GT] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(49),
    [anon_sym_PIPE] = ACTIONS(49),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(398),
    [anon_sym_dynamic] = ACTIONS(398),
    [anon_sym_final] = ACTIONS(398),
    [anon_sym_abstract] = ACTIONS(398),
    [anon_sym_class] = ACTIONS(398),
    [anon_sym_extends] = ACTIONS(398),
    [anon_sym_implements] = ACTIONS(398),
    [anon_sym_interface] = ACTIONS(398),
    [anon_sym_typedef] = ACTIONS(398),
    [anon_sym_function] = ACTIONS(398),
    [anon_sym_var] = ACTIONS(398),
    [aux_sym_integer_token1] = ACTIONS(398),
    [aux_sym_integer_token2] = ACTIONS(396),
    [aux_sym_float_token1] = ACTIONS(398),
    [aux_sym_float_token2] = ACTIONS(396),
    [anon_sym_true] = ACTIONS(398),
    [anon_sym_false] = ACTIONS(398),
    [aux_sym_string_token1] = ACTIONS(396),
    [aux_sym_string_token3] = ACTIONS(396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(398),
    [anon_sym_catch] = ACTIONS(398),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_do] = ACTIONS(398),
    [anon_sym_enum] = ACTIONS(398),
    [anon_sym_extern] = ACTIONS(398),
    [anon_sym_for] = ACTIONS(398),
    [anon_sym_inline] = ACTIONS(398),
    [anon_sym_macro] = ACTIONS(398),
    [anon_sym_operator] = ACTIONS(398),
    [anon_sym_overload] = ACTIONS(398),
    [anon_sym_override] = ACTIONS(398),
    [anon_sym_private] = ACTIONS(398),
    [anon_sym_public] = ACTIONS(398),
    [anon_sym_return] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(398),
    [anon_sym_try] = ACTIONS(398),
    [anon_sym_untyped] = ACTIONS(398),
    [anon_sym_while] = ACTIONS(398),
    [sym__semicolon] = ACTIONS(396),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(400),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_POUND] = ACTIONS(400),
    [anon_sym_package] = ACTIONS(402),
    [anon_sym_import] = ACTIONS(402),
    [anon_sym_using] = ACTIONS(402),
    [anon_sym_throw] = ACTIONS(402),
    [anon_sym_LPAREN] = ACTIONS(400),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_switch] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_RBRACE] = ACTIONS(400),
    [anon_sym_case] = ACTIONS(402),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_default] = ACTIONS(402),
    [anon_sym_cast] = ACTIONS(402),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_DOLLARtype] = ACTIONS(400),
    [anon_sym_in] = ACTIONS(402),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(400),
    [anon_sym_this] = ACTIONS(402),
    [anon_sym_DOT] = ACTIONS(402),
    [anon_sym_QMARK] = ACTIONS(402),
    [anon_sym_AT] = ACTIONS(402),
    [anon_sym_AT_COLON] = ACTIONS(400),
    [anon_sym_if] = ACTIONS(402),
    [anon_sym_else] = ACTIONS(402),
    [anon_sym_elseif] = ACTIONS(400),
    [anon_sym_new] = ACTIONS(402),
    [anon_sym_TILDE] = ACTIONS(400),
    [anon_sym_BANG] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_PLUS_PLUS] = ACTIONS(400),
    [anon_sym_DASH_DASH] = ACTIONS(400),
    [anon_sym_PERCENT] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(400),
    [anon_sym_SLASH] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_LT_LT] = ACTIONS(400),
    [anon_sym_GT_GT] = ACTIONS(402),
    [anon_sym_GT_GT_GT] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(402),
    [anon_sym_PIPE] = ACTIONS(402),
    [anon_sym_CARET] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_EQ_EQ] = ACTIONS(400),
    [anon_sym_BANG_EQ] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(402),
    [anon_sym_LT_EQ] = ACTIONS(400),
    [anon_sym_GT] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(400),
    [anon_sym_QMARK_QMARK] = ACTIONS(400),
    [anon_sym_EQ] = ACTIONS(402),
    [sym__rangeOperator] = ACTIONS(400),
    [anon_sym_null] = ACTIONS(402),
    [anon_sym_dynamic] = ACTIONS(402),
    [anon_sym_final] = ACTIONS(402),
    [anon_sym_abstract] = ACTIONS(402),
    [anon_sym_class] = ACTIONS(402),
    [anon_sym_extends] = ACTIONS(402),
    [anon_sym_implements] = ACTIONS(402),
    [anon_sym_interface] = ACTIONS(402),
    [anon_sym_typedef] = ACTIONS(402),
    [anon_sym_function] = ACTIONS(402),
    [anon_sym_var] = ACTIONS(402),
    [aux_sym_integer_token1] = ACTIONS(402),
    [aux_sym_integer_token2] = ACTIONS(400),
    [aux_sym_float_token1] = ACTIONS(402),
    [aux_sym_float_token2] = ACTIONS(400),
    [anon_sym_true] = ACTIONS(402),
    [anon_sym_false] = ACTIONS(402),
    [aux_sym_string_token1] = ACTIONS(400),
    [aux_sym_string_token3] = ACTIONS(400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(402),
    [anon_sym_catch] = ACTIONS(402),
    [anon_sym_continue] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(402),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_extern] = ACTIONS(402),
    [anon_sym_for] = ACTIONS(402),
    [anon_sym_inline] = ACTIONS(402),
    [anon_sym_macro] = ACTIONS(402),
    [anon_sym_operator] = ACTIONS(402),
    [anon_sym_overload] = ACTIONS(402),
    [anon_sym_override] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(402),
    [anon_sym_return] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(402),
    [anon_sym_try] = ACTIONS(402),
    [anon_sym_untyped] = ACTIONS(402),
    [anon_sym_while] = ACTIONS(402),
    [sym__semicolon] = ACTIONS(400),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(404),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_POUND] = ACTIONS(404),
    [anon_sym_package] = ACTIONS(406),
    [anon_sym_import] = ACTIONS(406),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_throw] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(404),
    [anon_sym_switch] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_RBRACE] = ACTIONS(404),
    [anon_sym_case] = ACTIONS(406),
    [anon_sym_COLON] = ACTIONS(404),
    [anon_sym_default] = ACTIONS(406),
    [anon_sym_cast] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(404),
    [anon_sym_DOLLARtype] = ACTIONS(404),
    [anon_sym_in] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(404),
    [anon_sym_RBRACK] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(406),
    [anon_sym_DOT] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(406),
    [anon_sym_AT] = ACTIONS(406),
    [anon_sym_AT_COLON] = ACTIONS(404),
    [anon_sym_if] = ACTIONS(406),
    [anon_sym_else] = ACTIONS(406),
    [anon_sym_elseif] = ACTIONS(404),
    [anon_sym_new] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(404),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_PERCENT] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(406),
    [anon_sym_LT_LT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(406),
    [anon_sym_GT_GT_GT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(406),
    [anon_sym_PIPE] = ACTIONS(406),
    [anon_sym_CARET] = ACTIONS(404),
    [anon_sym_AMP_AMP] = ACTIONS(404),
    [anon_sym_PIPE_PIPE] = ACTIONS(404),
    [anon_sym_EQ_EQ] = ACTIONS(404),
    [anon_sym_BANG_EQ] = ACTIONS(404),
    [anon_sym_LT] = ACTIONS(406),
    [anon_sym_LT_EQ] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(406),
    [anon_sym_GT_EQ] = ACTIONS(404),
    [anon_sym_EQ_GT] = ACTIONS(404),
    [anon_sym_QMARK_QMARK] = ACTIONS(404),
    [anon_sym_EQ] = ACTIONS(406),
    [sym__rangeOperator] = ACTIONS(404),
    [anon_sym_null] = ACTIONS(406),
    [anon_sym_dynamic] = ACTIONS(406),
    [anon_sym_final] = ACTIONS(406),
    [anon_sym_abstract] = ACTIONS(406),
    [anon_sym_class] = ACTIONS(406),
    [anon_sym_extends] = ACTIONS(406),
    [anon_sym_implements] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(406),
    [anon_sym_typedef] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(406),
    [anon_sym_var] = ACTIONS(406),
    [aux_sym_integer_token1] = ACTIONS(406),
    [aux_sym_integer_token2] = ACTIONS(404),
    [aux_sym_float_token1] = ACTIONS(406),
    [aux_sym_float_token2] = ACTIONS(404),
    [anon_sym_true] = ACTIONS(406),
    [anon_sym_false] = ACTIONS(406),
    [aux_sym_string_token1] = ACTIONS(404),
    [aux_sym_string_token3] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(406),
    [anon_sym_catch] = ACTIONS(406),
    [anon_sym_continue] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(406),
    [anon_sym_enum] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(406),
    [anon_sym_for] = ACTIONS(406),
    [anon_sym_inline] = ACTIONS(406),
    [anon_sym_macro] = ACTIONS(406),
    [anon_sym_operator] = ACTIONS(406),
    [anon_sym_overload] = ACTIONS(406),
    [anon_sym_override] = ACTIONS(406),
    [anon_sym_private] = ACTIONS(406),
    [anon_sym_public] = ACTIONS(406),
    [anon_sym_return] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(406),
    [anon_sym_try] = ACTIONS(406),
    [anon_sym_untyped] = ACTIONS(406),
    [anon_sym_while] = ACTIONS(406),
    [sym__semicolon] = ACTIONS(404),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(408),
    [sym_identifier] = ACTIONS(410),
    [anon_sym_POUND] = ACTIONS(408),
    [anon_sym_package] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [anon_sym_using] = ACTIONS(410),
    [anon_sym_throw] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(408),
    [anon_sym_switch] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(408),
    [anon_sym_RBRACE] = ACTIONS(408),
    [anon_sym_case] = ACTIONS(410),
    [anon_sym_COLON] = ACTIONS(408),
    [anon_sym_default] = ACTIONS(410),
    [anon_sym_cast] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [anon_sym_DOLLARtype] = ACTIONS(408),
    [anon_sym_in] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(408),
    [anon_sym_this] = ACTIONS(410),
    [anon_sym_DOT] = ACTIONS(410),
    [anon_sym_QMARK] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(410),
    [anon_sym_AT_COLON] = ACTIONS(408),
    [anon_sym_if] = ACTIONS(410),
    [anon_sym_else] = ACTIONS(410),
    [anon_sym_elseif] = ACTIONS(408),
    [anon_sym_new] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(408),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(408),
    [anon_sym_PERCENT] = ACTIONS(408),
    [anon_sym_STAR] = ACTIONS(408),
    [anon_sym_SLASH] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_LT_LT] = ACTIONS(408),
    [anon_sym_GT_GT] = ACTIONS(410),
    [anon_sym_GT_GT_GT] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(410),
    [anon_sym_PIPE] = ACTIONS(410),
    [anon_sym_CARET] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_PIPE_PIPE] = ACTIONS(408),
    [anon_sym_EQ_EQ] = ACTIONS(408),
    [anon_sym_BANG_EQ] = ACTIONS(408),
    [anon_sym_LT] = ACTIONS(410),
    [anon_sym_LT_EQ] = ACTIONS(408),
    [anon_sym_GT] = ACTIONS(410),
    [anon_sym_GT_EQ] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(408),
    [anon_sym_QMARK_QMARK] = ACTIONS(408),
    [anon_sym_EQ] = ACTIONS(410),
    [sym__rangeOperator] = ACTIONS(408),
    [anon_sym_null] = ACTIONS(410),
    [anon_sym_dynamic] = ACTIONS(410),
    [anon_sym_final] = ACTIONS(410),
    [anon_sym_abstract] = ACTIONS(410),
    [anon_sym_class] = ACTIONS(410),
    [anon_sym_extends] = ACTIONS(410),
    [anon_sym_implements] = ACTIONS(410),
    [anon_sym_interface] = ACTIONS(410),
    [anon_sym_typedef] = ACTIONS(410),
    [anon_sym_function] = ACTIONS(410),
    [anon_sym_var] = ACTIONS(410),
    [aux_sym_integer_token1] = ACTIONS(410),
    [aux_sym_integer_token2] = ACTIONS(408),
    [aux_sym_float_token1] = ACTIONS(410),
    [aux_sym_float_token2] = ACTIONS(408),
    [anon_sym_true] = ACTIONS(410),
    [anon_sym_false] = ACTIONS(410),
    [aux_sym_string_token1] = ACTIONS(408),
    [aux_sym_string_token3] = ACTIONS(408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(410),
    [anon_sym_catch] = ACTIONS(410),
    [anon_sym_continue] = ACTIONS(410),
    [anon_sym_do] = ACTIONS(410),
    [anon_sym_enum] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(410),
    [anon_sym_for] = ACTIONS(410),
    [anon_sym_inline] = ACTIONS(410),
    [anon_sym_macro] = ACTIONS(410),
    [anon_sym_operator] = ACTIONS(410),
    [anon_sym_overload] = ACTIONS(410),
    [anon_sym_override] = ACTIONS(410),
    [anon_sym_private] = ACTIONS(410),
    [anon_sym_public] = ACTIONS(410),
    [anon_sym_return] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(410),
    [anon_sym_try] = ACTIONS(410),
    [anon_sym_untyped] = ACTIONS(410),
    [anon_sym_while] = ACTIONS(410),
    [sym__semicolon] = ACTIONS(408),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(412),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_POUND] = ACTIONS(412),
    [anon_sym_package] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_using] = ACTIONS(414),
    [anon_sym_throw] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(412),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_case] = ACTIONS(414),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_default] = ACTIONS(414),
    [anon_sym_cast] = ACTIONS(414),
    [anon_sym_COMMA] = ACTIONS(412),
    [anon_sym_DOLLARtype] = ACTIONS(412),
    [anon_sym_in] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_RBRACK] = ACTIONS(412),
    [anon_sym_this] = ACTIONS(414),
    [anon_sym_DOT] = ACTIONS(414),
    [anon_sym_QMARK] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(414),
    [anon_sym_AT_COLON] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_elseif] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PLUS_PLUS] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_STAR] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(414),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(412),
    [anon_sym_GT_GT] = ACTIONS(414),
    [anon_sym_GT_GT_GT] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_CARET] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_EQ_EQ] = ACTIONS(412),
    [anon_sym_BANG_EQ] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_LT_EQ] = ACTIONS(412),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_GT_EQ] = ACTIONS(412),
    [anon_sym_EQ_GT] = ACTIONS(412),
    [anon_sym_QMARK_QMARK] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(414),
    [sym__rangeOperator] = ACTIONS(412),
    [anon_sym_null] = ACTIONS(414),
    [anon_sym_dynamic] = ACTIONS(414),
    [anon_sym_final] = ACTIONS(414),
    [anon_sym_abstract] = ACTIONS(414),
    [anon_sym_class] = ACTIONS(414),
    [anon_sym_extends] = ACTIONS(414),
    [anon_sym_implements] = ACTIONS(414),
    [anon_sym_interface] = ACTIONS(414),
    [anon_sym_typedef] = ACTIONS(414),
    [anon_sym_function] = ACTIONS(414),
    [anon_sym_var] = ACTIONS(414),
    [aux_sym_integer_token1] = ACTIONS(414),
    [aux_sym_integer_token2] = ACTIONS(412),
    [aux_sym_float_token1] = ACTIONS(414),
    [aux_sym_float_token2] = ACTIONS(412),
    [anon_sym_true] = ACTIONS(414),
    [anon_sym_false] = ACTIONS(414),
    [aux_sym_string_token1] = ACTIONS(412),
    [aux_sym_string_token3] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(414),
    [anon_sym_catch] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_enum] = ACTIONS(414),
    [anon_sym_extern] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_inline] = ACTIONS(414),
    [anon_sym_macro] = ACTIONS(414),
    [anon_sym_operator] = ACTIONS(414),
    [anon_sym_overload] = ACTIONS(414),
    [anon_sym_override] = ACTIONS(414),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_static] = ACTIONS(414),
    [anon_sym_try] = ACTIONS(414),
    [anon_sym_untyped] = ACTIONS(414),
    [anon_sym_while] = ACTIONS(414),
    [sym__semicolon] = ACTIONS(412),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(416),
    [sym_identifier] = ACTIONS(418),
    [anon_sym_POUND] = ACTIONS(416),
    [anon_sym_package] = ACTIONS(418),
    [anon_sym_import] = ACTIONS(418),
    [anon_sym_using] = ACTIONS(418),
    [anon_sym_throw] = ACTIONS(418),
    [anon_sym_LPAREN] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_switch] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(416),
    [anon_sym_case] = ACTIONS(418),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(418),
    [anon_sym_cast] = ACTIONS(418),
    [anon_sym_COMMA] = ACTIONS(416),
    [anon_sym_DOLLARtype] = ACTIONS(416),
    [anon_sym_in] = ACTIONS(418),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(416),
    [anon_sym_this] = ACTIONS(418),
    [anon_sym_DOT] = ACTIONS(418),
    [anon_sym_QMARK] = ACTIONS(418),
    [anon_sym_AT] = ACTIONS(418),
    [anon_sym_AT_COLON] = ACTIONS(416),
    [anon_sym_if] = ACTIONS(418),
    [anon_sym_else] = ACTIONS(418),
    [anon_sym_new] = ACTIONS(418),
    [anon_sym_TILDE] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_PLUS_PLUS] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(416),
    [anon_sym_PERCENT] = ACTIONS(416),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_SLASH] = ACTIONS(418),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(416),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_GT_GT_GT] = ACTIONS(416),
    [anon_sym_AMP] = ACTIONS(418),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_CARET] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_EQ_EQ] = ACTIONS(416),
    [anon_sym_BANG_EQ] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_LT_EQ] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_EQ] = ACTIONS(416),
    [anon_sym_EQ_GT] = ACTIONS(416),
    [anon_sym_QMARK_QMARK] = ACTIONS(416),
    [anon_sym_EQ] = ACTIONS(418),
    [sym__rangeOperator] = ACTIONS(416),
    [anon_sym_null] = ACTIONS(418),
    [anon_sym_dynamic] = ACTIONS(418),
    [anon_sym_final] = ACTIONS(418),
    [anon_sym_abstract] = ACTIONS(418),
    [anon_sym_class] = ACTIONS(418),
    [anon_sym_extends] = ACTIONS(418),
    [anon_sym_implements] = ACTIONS(418),
    [anon_sym_interface] = ACTIONS(418),
    [anon_sym_typedef] = ACTIONS(418),
    [anon_sym_function] = ACTIONS(418),
    [anon_sym_var] = ACTIONS(418),
    [aux_sym_integer_token1] = ACTIONS(418),
    [aux_sym_integer_token2] = ACTIONS(416),
    [aux_sym_float_token1] = ACTIONS(418),
    [aux_sym_float_token2] = ACTIONS(416),
    [anon_sym_true] = ACTIONS(418),
    [anon_sym_false] = ACTIONS(418),
    [aux_sym_string_token1] = ACTIONS(416),
    [aux_sym_string_token3] = ACTIONS(416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(418),
    [anon_sym_catch] = ACTIONS(418),
    [anon_sym_continue] = ACTIONS(418),
    [anon_sym_do] = ACTIONS(418),
    [anon_sym_enum] = ACTIONS(418),
    [anon_sym_extern] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(418),
    [anon_sym_inline] = ACTIONS(418),
    [anon_sym_macro] = ACTIONS(418),
    [anon_sym_operator] = ACTIONS(418),
    [anon_sym_overload] = ACTIONS(418),
    [anon_sym_override] = ACTIONS(418),
    [anon_sym_private] = ACTIONS(418),
    [anon_sym_public] = ACTIONS(418),
    [anon_sym_return] = ACTIONS(418),
    [anon_sym_static] = ACTIONS(418),
    [anon_sym_try] = ACTIONS(418),
    [anon_sym_untyped] = ACTIONS(418),
    [anon_sym_while] = ACTIONS(418),
    [sym__semicolon] = ACTIONS(416),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(420),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_POUND] = ACTIONS(420),
    [anon_sym_package] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(422),
    [anon_sym_using] = ACTIONS(422),
    [anon_sym_throw] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(420),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_switch] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(420),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_case] = ACTIONS(422),
    [anon_sym_COLON] = ACTIONS(420),
    [anon_sym_default] = ACTIONS(422),
    [anon_sym_cast] = ACTIONS(422),
    [anon_sym_COMMA] = ACTIONS(420),
    [anon_sym_DOLLARtype] = ACTIONS(420),
    [anon_sym_in] = ACTIONS(422),
    [anon_sym_LBRACK] = ACTIONS(420),
    [anon_sym_RBRACK] = ACTIONS(420),
    [anon_sym_this] = ACTIONS(422),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_QMARK] = ACTIONS(422),
    [anon_sym_AT] = ACTIONS(422),
    [anon_sym_AT_COLON] = ACTIONS(420),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_else] = ACTIONS(422),
    [anon_sym_new] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(420),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(420),
    [anon_sym_PERCENT] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(420),
    [anon_sym_SLASH] = ACTIONS(422),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_LT_LT] = ACTIONS(420),
    [anon_sym_GT_GT] = ACTIONS(422),
    [anon_sym_GT_GT_GT] = ACTIONS(420),
    [anon_sym_AMP] = ACTIONS(422),
    [anon_sym_PIPE] = ACTIONS(422),
    [anon_sym_CARET] = ACTIONS(420),
    [anon_sym_AMP_AMP] = ACTIONS(420),
    [anon_sym_PIPE_PIPE] = ACTIONS(420),
    [anon_sym_EQ_EQ] = ACTIONS(420),
    [anon_sym_BANG_EQ] = ACTIONS(420),
    [anon_sym_LT] = ACTIONS(422),
    [anon_sym_LT_EQ] = ACTIONS(420),
    [anon_sym_GT] = ACTIONS(422),
    [anon_sym_GT_EQ] = ACTIONS(420),
    [anon_sym_EQ_GT] = ACTIONS(420),
    [anon_sym_QMARK_QMARK] = ACTIONS(420),
    [anon_sym_EQ] = ACTIONS(422),
    [sym__rangeOperator] = ACTIONS(420),
    [anon_sym_null] = ACTIONS(422),
    [anon_sym_dynamic] = ACTIONS(422),
    [anon_sym_final] = ACTIONS(422),
    [anon_sym_abstract] = ACTIONS(422),
    [anon_sym_class] = ACTIONS(422),
    [anon_sym_extends] = ACTIONS(422),
    [anon_sym_implements] = ACTIONS(422),
    [anon_sym_interface] = ACTIONS(422),
    [anon_sym_typedef] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(422),
    [anon_sym_var] = ACTIONS(422),
    [aux_sym_integer_token1] = ACTIONS(422),
    [aux_sym_integer_token2] = ACTIONS(420),
    [aux_sym_float_token1] = ACTIONS(422),
    [aux_sym_float_token2] = ACTIONS(420),
    [anon_sym_true] = ACTIONS(422),
    [anon_sym_false] = ACTIONS(422),
    [aux_sym_string_token1] = ACTIONS(420),
    [aux_sym_string_token3] = ACTIONS(420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(422),
    [anon_sym_catch] = ACTIONS(422),
    [anon_sym_continue] = ACTIONS(422),
    [anon_sym_do] = ACTIONS(422),
    [anon_sym_enum] = ACTIONS(422),
    [anon_sym_extern] = ACTIONS(422),
    [anon_sym_for] = ACTIONS(422),
    [anon_sym_inline] = ACTIONS(422),
    [anon_sym_macro] = ACTIONS(422),
    [anon_sym_operator] = ACTIONS(422),
    [anon_sym_overload] = ACTIONS(422),
    [anon_sym_override] = ACTIONS(422),
    [anon_sym_private] = ACTIONS(422),
    [anon_sym_public] = ACTIONS(422),
    [anon_sym_return] = ACTIONS(422),
    [anon_sym_static] = ACTIONS(422),
    [anon_sym_try] = ACTIONS(422),
    [anon_sym_untyped] = ACTIONS(422),
    [anon_sym_while] = ACTIONS(422),
    [sym__semicolon] = ACTIONS(420),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_DOLLARtype] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_RBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_DOT] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(424),
    [anon_sym_AMP_AMP] = ACTIONS(424),
    [anon_sym_PIPE_PIPE] = ACTIONS(424),
    [anon_sym_EQ_EQ] = ACTIONS(424),
    [anon_sym_BANG_EQ] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_GT_EQ] = ACTIONS(424),
    [anon_sym_EQ_GT] = ACTIONS(424),
    [anon_sym_QMARK_QMARK] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(426),
    [sym__rangeOperator] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(434),
    [sym_identifier] = ACTIONS(436),
    [anon_sym_POUND] = ACTIONS(434),
    [anon_sym_package] = ACTIONS(436),
    [anon_sym_import] = ACTIONS(436),
    [anon_sym_using] = ACTIONS(436),
    [anon_sym_throw] = ACTIONS(436),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_RPAREN] = ACTIONS(434),
    [anon_sym_switch] = ACTIONS(436),
    [anon_sym_LBRACE] = ACTIONS(434),
    [anon_sym_RBRACE] = ACTIONS(434),
    [anon_sym_case] = ACTIONS(436),
    [anon_sym_COLON] = ACTIONS(434),
    [anon_sym_default] = ACTIONS(436),
    [anon_sym_cast] = ACTIONS(436),
    [anon_sym_COMMA] = ACTIONS(434),
    [anon_sym_DOLLARtype] = ACTIONS(434),
    [anon_sym_in] = ACTIONS(436),
    [anon_sym_LBRACK] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(434),
    [anon_sym_this] = ACTIONS(436),
    [anon_sym_DOT] = ACTIONS(436),
    [anon_sym_QMARK] = ACTIONS(436),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_AT_COLON] = ACTIONS(434),
    [anon_sym_if] = ACTIONS(436),
    [anon_sym_else] = ACTIONS(436),
    [anon_sym_new] = ACTIONS(436),
    [anon_sym_TILDE] = ACTIONS(434),
    [anon_sym_BANG] = ACTIONS(436),
    [anon_sym_DASH] = ACTIONS(436),
    [anon_sym_PLUS_PLUS] = ACTIONS(434),
    [anon_sym_DASH_DASH] = ACTIONS(434),
    [anon_sym_PERCENT] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(434),
    [anon_sym_SLASH] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(436),
    [anon_sym_LT_LT] = ACTIONS(434),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_GT_GT_GT] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(436),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_CARET] = ACTIONS(434),
    [anon_sym_AMP_AMP] = ACTIONS(434),
    [anon_sym_PIPE_PIPE] = ACTIONS(434),
    [anon_sym_EQ_EQ] = ACTIONS(434),
    [anon_sym_BANG_EQ] = ACTIONS(434),
    [anon_sym_LT] = ACTIONS(436),
    [anon_sym_LT_EQ] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(436),
    [anon_sym_GT_EQ] = ACTIONS(434),
    [anon_sym_EQ_GT] = ACTIONS(434),
    [anon_sym_QMARK_QMARK] = ACTIONS(434),
    [anon_sym_EQ] = ACTIONS(436),
    [sym__rangeOperator] = ACTIONS(434),
    [anon_sym_null] = ACTIONS(436),
    [anon_sym_dynamic] = ACTIONS(436),
    [anon_sym_final] = ACTIONS(436),
    [anon_sym_abstract] = ACTIONS(436),
    [anon_sym_class] = ACTIONS(436),
    [anon_sym_extends] = ACTIONS(436),
    [anon_sym_implements] = ACTIONS(436),
    [anon_sym_interface] = ACTIONS(436),
    [anon_sym_typedef] = ACTIONS(436),
    [anon_sym_function] = ACTIONS(436),
    [anon_sym_var] = ACTIONS(436),
    [aux_sym_integer_token1] = ACTIONS(436),
    [aux_sym_integer_token2] = ACTIONS(434),
    [aux_sym_float_token1] = ACTIONS(436),
    [aux_sym_float_token2] = ACTIONS(434),
    [anon_sym_true] = ACTIONS(436),
    [anon_sym_false] = ACTIONS(436),
    [aux_sym_string_token1] = ACTIONS(434),
    [aux_sym_string_token3] = ACTIONS(434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(436),
    [anon_sym_catch] = ACTIONS(436),
    [anon_sym_continue] = ACTIONS(436),
    [anon_sym_do] = ACTIONS(436),
    [anon_sym_enum] = ACTIONS(436),
    [anon_sym_extern] = ACTIONS(436),
    [anon_sym_for] = ACTIONS(436),
    [anon_sym_inline] = ACTIONS(436),
    [anon_sym_macro] = ACTIONS(436),
    [anon_sym_operator] = ACTIONS(436),
    [anon_sym_overload] = ACTIONS(436),
    [anon_sym_override] = ACTIONS(436),
    [anon_sym_private] = ACTIONS(436),
    [anon_sym_public] = ACTIONS(436),
    [anon_sym_return] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(436),
    [anon_sym_try] = ACTIONS(436),
    [anon_sym_untyped] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(436),
    [sym__semicolon] = ACTIONS(434),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(438),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_POUND] = ACTIONS(438),
    [anon_sym_package] = ACTIONS(440),
    [anon_sym_import] = ACTIONS(440),
    [anon_sym_using] = ACTIONS(440),
    [anon_sym_throw] = ACTIONS(440),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_switch] = ACTIONS(440),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_RBRACE] = ACTIONS(438),
    [anon_sym_case] = ACTIONS(440),
    [anon_sym_COLON] = ACTIONS(438),
    [anon_sym_default] = ACTIONS(440),
    [anon_sym_cast] = ACTIONS(440),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_DOLLARtype] = ACTIONS(438),
    [anon_sym_in] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(438),
    [anon_sym_RBRACK] = ACTIONS(438),
    [anon_sym_this] = ACTIONS(440),
    [anon_sym_DOT] = ACTIONS(440),
    [anon_sym_QMARK] = ACTIONS(440),
    [anon_sym_AT] = ACTIONS(440),
    [anon_sym_AT_COLON] = ACTIONS(438),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_else] = ACTIONS(440),
    [anon_sym_new] = ACTIONS(440),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(440),
    [anon_sym_DASH] = ACTIONS(440),
    [anon_sym_PLUS_PLUS] = ACTIONS(438),
    [anon_sym_DASH_DASH] = ACTIONS(438),
    [anon_sym_PERCENT] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_SLASH] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(438),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_GT_GT_GT] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(438),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [anon_sym_EQ_EQ] = ACTIONS(438),
    [anon_sym_BANG_EQ] = ACTIONS(438),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_LT_EQ] = ACTIONS(438),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_GT_EQ] = ACTIONS(438),
    [anon_sym_EQ_GT] = ACTIONS(438),
    [anon_sym_QMARK_QMARK] = ACTIONS(438),
    [anon_sym_EQ] = ACTIONS(440),
    [sym__rangeOperator] = ACTIONS(438),
    [anon_sym_null] = ACTIONS(440),
    [anon_sym_dynamic] = ACTIONS(440),
    [anon_sym_final] = ACTIONS(440),
    [anon_sym_abstract] = ACTIONS(440),
    [anon_sym_class] = ACTIONS(440),
    [anon_sym_extends] = ACTIONS(440),
    [anon_sym_implements] = ACTIONS(440),
    [anon_sym_interface] = ACTIONS(440),
    [anon_sym_typedef] = ACTIONS(440),
    [anon_sym_function] = ACTIONS(440),
    [anon_sym_var] = ACTIONS(440),
    [aux_sym_integer_token1] = ACTIONS(440),
    [aux_sym_integer_token2] = ACTIONS(438),
    [aux_sym_float_token1] = ACTIONS(440),
    [aux_sym_float_token2] = ACTIONS(438),
    [anon_sym_true] = ACTIONS(440),
    [anon_sym_false] = ACTIONS(440),
    [aux_sym_string_token1] = ACTIONS(438),
    [aux_sym_string_token3] = ACTIONS(438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(440),
    [anon_sym_catch] = ACTIONS(440),
    [anon_sym_continue] = ACTIONS(440),
    [anon_sym_do] = ACTIONS(440),
    [anon_sym_enum] = ACTIONS(440),
    [anon_sym_extern] = ACTIONS(440),
    [anon_sym_for] = ACTIONS(440),
    [anon_sym_inline] = ACTIONS(440),
    [anon_sym_macro] = ACTIONS(440),
    [anon_sym_operator] = ACTIONS(440),
    [anon_sym_overload] = ACTIONS(440),
    [anon_sym_override] = ACTIONS(440),
    [anon_sym_private] = ACTIONS(440),
    [anon_sym_public] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(440),
    [anon_sym_static] = ACTIONS(440),
    [anon_sym_try] = ACTIONS(440),
    [anon_sym_untyped] = ACTIONS(440),
    [anon_sym_while] = ACTIONS(440),
    [sym__semicolon] = ACTIONS(438),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_DOLLARtype] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_RBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_DOT] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(424),
    [anon_sym_AMP_AMP] = ACTIONS(424),
    [anon_sym_PIPE_PIPE] = ACTIONS(424),
    [anon_sym_EQ_EQ] = ACTIONS(424),
    [anon_sym_BANG_EQ] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_GT_EQ] = ACTIONS(424),
    [anon_sym_EQ_GT] = ACTIONS(424),
    [anon_sym_QMARK_QMARK] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(426),
    [sym__rangeOperator] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_identifier] = ACTIONS(342),
    [anon_sym_POUND] = ACTIONS(340),
    [anon_sym_package] = ACTIONS(342),
    [anon_sym_import] = ACTIONS(342),
    [anon_sym_using] = ACTIONS(342),
    [anon_sym_throw] = ACTIONS(342),
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_RPAREN] = ACTIONS(340),
    [anon_sym_switch] = ACTIONS(342),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(340),
    [anon_sym_case] = ACTIONS(342),
    [anon_sym_COLON] = ACTIONS(340),
    [anon_sym_default] = ACTIONS(342),
    [anon_sym_cast] = ACTIONS(342),
    [anon_sym_COMMA] = ACTIONS(340),
    [anon_sym_DOLLARtype] = ACTIONS(340),
    [anon_sym_in] = ACTIONS(342),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_RBRACK] = ACTIONS(340),
    [anon_sym_this] = ACTIONS(342),
    [anon_sym_DOT] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(342),
    [anon_sym_AT_COLON] = ACTIONS(340),
    [anon_sym_if] = ACTIONS(342),
    [anon_sym_else] = ACTIONS(342),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_TILDE] = ACTIONS(340),
    [anon_sym_BANG] = ACTIONS(342),
    [anon_sym_DASH] = ACTIONS(342),
    [anon_sym_PLUS_PLUS] = ACTIONS(340),
    [anon_sym_DASH_DASH] = ACTIONS(340),
    [anon_sym_PERCENT] = ACTIONS(340),
    [anon_sym_STAR] = ACTIONS(340),
    [anon_sym_SLASH] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(342),
    [anon_sym_LT_LT] = ACTIONS(340),
    [anon_sym_GT_GT] = ACTIONS(342),
    [anon_sym_GT_GT_GT] = ACTIONS(340),
    [anon_sym_AMP] = ACTIONS(342),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_CARET] = ACTIONS(340),
    [anon_sym_AMP_AMP] = ACTIONS(340),
    [anon_sym_PIPE_PIPE] = ACTIONS(340),
    [anon_sym_EQ_EQ] = ACTIONS(340),
    [anon_sym_BANG_EQ] = ACTIONS(340),
    [anon_sym_LT] = ACTIONS(342),
    [anon_sym_LT_EQ] = ACTIONS(340),
    [anon_sym_GT] = ACTIONS(342),
    [anon_sym_GT_EQ] = ACTIONS(340),
    [anon_sym_EQ_GT] = ACTIONS(340),
    [anon_sym_QMARK_QMARK] = ACTIONS(340),
    [anon_sym_EQ] = ACTIONS(342),
    [sym__rangeOperator] = ACTIONS(340),
    [anon_sym_null] = ACTIONS(342),
    [anon_sym_dynamic] = ACTIONS(342),
    [anon_sym_final] = ACTIONS(342),
    [anon_sym_abstract] = ACTIONS(342),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_extends] = ACTIONS(342),
    [anon_sym_implements] = ACTIONS(342),
    [anon_sym_interface] = ACTIONS(342),
    [anon_sym_typedef] = ACTIONS(342),
    [anon_sym_function] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(342),
    [aux_sym_integer_token1] = ACTIONS(342),
    [aux_sym_integer_token2] = ACTIONS(340),
    [aux_sym_float_token1] = ACTIONS(342),
    [aux_sym_float_token2] = ACTIONS(340),
    [anon_sym_true] = ACTIONS(342),
    [anon_sym_false] = ACTIONS(342),
    [aux_sym_string_token1] = ACTIONS(340),
    [aux_sym_string_token3] = ACTIONS(340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(342),
    [anon_sym_catch] = ACTIONS(342),
    [anon_sym_continue] = ACTIONS(342),
    [anon_sym_do] = ACTIONS(342),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_extern] = ACTIONS(342),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_inline] = ACTIONS(342),
    [anon_sym_macro] = ACTIONS(342),
    [anon_sym_operator] = ACTIONS(342),
    [anon_sym_overload] = ACTIONS(342),
    [anon_sym_override] = ACTIONS(342),
    [anon_sym_private] = ACTIONS(342),
    [anon_sym_public] = ACTIONS(342),
    [anon_sym_return] = ACTIONS(342),
    [anon_sym_static] = ACTIONS(342),
    [anon_sym_try] = ACTIONS(342),
    [anon_sym_untyped] = ACTIONS(342),
    [anon_sym_while] = ACTIONS(342),
    [sym__semicolon] = ACTIONS(340),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(442),
    [sym_identifier] = ACTIONS(444),
    [anon_sym_POUND] = ACTIONS(442),
    [anon_sym_package] = ACTIONS(444),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_using] = ACTIONS(444),
    [anon_sym_throw] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(442),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_switch] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(442),
    [anon_sym_case] = ACTIONS(444),
    [anon_sym_COLON] = ACTIONS(442),
    [anon_sym_default] = ACTIONS(444),
    [anon_sym_cast] = ACTIONS(444),
    [anon_sym_COMMA] = ACTIONS(442),
    [anon_sym_DOLLARtype] = ACTIONS(442),
    [anon_sym_in] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(442),
    [anon_sym_RBRACK] = ACTIONS(442),
    [anon_sym_this] = ACTIONS(444),
    [anon_sym_DOT] = ACTIONS(444),
    [anon_sym_QMARK] = ACTIONS(444),
    [anon_sym_AT] = ACTIONS(444),
    [anon_sym_AT_COLON] = ACTIONS(442),
    [anon_sym_if] = ACTIONS(444),
    [anon_sym_else] = ACTIONS(444),
    [anon_sym_new] = ACTIONS(444),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(442),
    [anon_sym_DASH_DASH] = ACTIONS(442),
    [anon_sym_PERCENT] = ACTIONS(442),
    [anon_sym_STAR] = ACTIONS(442),
    [anon_sym_SLASH] = ACTIONS(444),
    [anon_sym_PLUS] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_GT_GT_GT] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(444),
    [anon_sym_CARET] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_EQ_EQ] = ACTIONS(442),
    [anon_sym_BANG_EQ] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(444),
    [anon_sym_LT_EQ] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(444),
    [anon_sym_GT_EQ] = ACTIONS(442),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_QMARK_QMARK] = ACTIONS(442),
    [anon_sym_EQ] = ACTIONS(444),
    [sym__rangeOperator] = ACTIONS(442),
    [anon_sym_null] = ACTIONS(444),
    [anon_sym_dynamic] = ACTIONS(444),
    [anon_sym_final] = ACTIONS(444),
    [anon_sym_abstract] = ACTIONS(444),
    [anon_sym_class] = ACTIONS(444),
    [anon_sym_extends] = ACTIONS(444),
    [anon_sym_implements] = ACTIONS(444),
    [anon_sym_interface] = ACTIONS(444),
    [anon_sym_typedef] = ACTIONS(444),
    [anon_sym_function] = ACTIONS(444),
    [anon_sym_var] = ACTIONS(444),
    [aux_sym_integer_token1] = ACTIONS(444),
    [aux_sym_integer_token2] = ACTIONS(442),
    [aux_sym_float_token1] = ACTIONS(444),
    [aux_sym_float_token2] = ACTIONS(442),
    [anon_sym_true] = ACTIONS(444),
    [anon_sym_false] = ACTIONS(444),
    [aux_sym_string_token1] = ACTIONS(442),
    [aux_sym_string_token3] = ACTIONS(442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(444),
    [anon_sym_catch] = ACTIONS(444),
    [anon_sym_continue] = ACTIONS(444),
    [anon_sym_do] = ACTIONS(444),
    [anon_sym_enum] = ACTIONS(444),
    [anon_sym_extern] = ACTIONS(444),
    [anon_sym_for] = ACTIONS(444),
    [anon_sym_inline] = ACTIONS(444),
    [anon_sym_macro] = ACTIONS(444),
    [anon_sym_operator] = ACTIONS(444),
    [anon_sym_overload] = ACTIONS(444),
    [anon_sym_override] = ACTIONS(444),
    [anon_sym_private] = ACTIONS(444),
    [anon_sym_public] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(444),
    [anon_sym_static] = ACTIONS(444),
    [anon_sym_try] = ACTIONS(444),
    [anon_sym_untyped] = ACTIONS(444),
    [anon_sym_while] = ACTIONS(444),
    [sym__semicolon] = ACTIONS(442),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(446),
    [sym_identifier] = ACTIONS(448),
    [anon_sym_POUND] = ACTIONS(446),
    [anon_sym_package] = ACTIONS(448),
    [anon_sym_import] = ACTIONS(448),
    [anon_sym_using] = ACTIONS(448),
    [anon_sym_throw] = ACTIONS(448),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_switch] = ACTIONS(448),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_RBRACE] = ACTIONS(446),
    [anon_sym_case] = ACTIONS(448),
    [anon_sym_COLON] = ACTIONS(446),
    [anon_sym_default] = ACTIONS(448),
    [anon_sym_cast] = ACTIONS(448),
    [anon_sym_COMMA] = ACTIONS(446),
    [anon_sym_DOLLARtype] = ACTIONS(446),
    [anon_sym_in] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(446),
    [anon_sym_this] = ACTIONS(448),
    [anon_sym_DOT] = ACTIONS(448),
    [anon_sym_QMARK] = ACTIONS(448),
    [anon_sym_AT] = ACTIONS(448),
    [anon_sym_AT_COLON] = ACTIONS(446),
    [anon_sym_if] = ACTIONS(448),
    [anon_sym_else] = ACTIONS(448),
    [anon_sym_new] = ACTIONS(448),
    [anon_sym_TILDE] = ACTIONS(446),
    [anon_sym_BANG] = ACTIONS(448),
    [anon_sym_DASH] = ACTIONS(448),
    [anon_sym_PLUS_PLUS] = ACTIONS(446),
    [anon_sym_DASH_DASH] = ACTIONS(446),
    [anon_sym_PERCENT] = ACTIONS(446),
    [anon_sym_STAR] = ACTIONS(446),
    [anon_sym_SLASH] = ACTIONS(448),
    [anon_sym_PLUS] = ACTIONS(448),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(448),
    [anon_sym_GT_GT_GT] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(448),
    [anon_sym_CARET] = ACTIONS(446),
    [anon_sym_AMP_AMP] = ACTIONS(446),
    [anon_sym_PIPE_PIPE] = ACTIONS(446),
    [anon_sym_EQ_EQ] = ACTIONS(446),
    [anon_sym_BANG_EQ] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(448),
    [anon_sym_LT_EQ] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(448),
    [anon_sym_GT_EQ] = ACTIONS(446),
    [anon_sym_EQ_GT] = ACTIONS(446),
    [anon_sym_QMARK_QMARK] = ACTIONS(446),
    [anon_sym_EQ] = ACTIONS(448),
    [sym__rangeOperator] = ACTIONS(446),
    [anon_sym_null] = ACTIONS(448),
    [anon_sym_dynamic] = ACTIONS(448),
    [anon_sym_final] = ACTIONS(448),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_class] = ACTIONS(448),
    [anon_sym_extends] = ACTIONS(448),
    [anon_sym_implements] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(448),
    [anon_sym_typedef] = ACTIONS(448),
    [anon_sym_function] = ACTIONS(448),
    [anon_sym_var] = ACTIONS(448),
    [aux_sym_integer_token1] = ACTIONS(448),
    [aux_sym_integer_token2] = ACTIONS(446),
    [aux_sym_float_token1] = ACTIONS(448),
    [aux_sym_float_token2] = ACTIONS(446),
    [anon_sym_true] = ACTIONS(448),
    [anon_sym_false] = ACTIONS(448),
    [aux_sym_string_token1] = ACTIONS(446),
    [aux_sym_string_token3] = ACTIONS(446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(448),
    [anon_sym_catch] = ACTIONS(448),
    [anon_sym_continue] = ACTIONS(448),
    [anon_sym_do] = ACTIONS(448),
    [anon_sym_enum] = ACTIONS(448),
    [anon_sym_extern] = ACTIONS(448),
    [anon_sym_for] = ACTIONS(448),
    [anon_sym_inline] = ACTIONS(448),
    [anon_sym_macro] = ACTIONS(448),
    [anon_sym_operator] = ACTIONS(448),
    [anon_sym_overload] = ACTIONS(448),
    [anon_sym_override] = ACTIONS(448),
    [anon_sym_private] = ACTIONS(448),
    [anon_sym_public] = ACTIONS(448),
    [anon_sym_return] = ACTIONS(448),
    [anon_sym_static] = ACTIONS(448),
    [anon_sym_try] = ACTIONS(448),
    [anon_sym_untyped] = ACTIONS(448),
    [anon_sym_while] = ACTIONS(448),
    [sym__semicolon] = ACTIONS(446),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(450),
    [sym_identifier] = ACTIONS(452),
    [anon_sym_POUND] = ACTIONS(450),
    [anon_sym_package] = ACTIONS(452),
    [anon_sym_import] = ACTIONS(452),
    [anon_sym_using] = ACTIONS(452),
    [anon_sym_throw] = ACTIONS(452),
    [anon_sym_LPAREN] = ACTIONS(450),
    [anon_sym_RPAREN] = ACTIONS(450),
    [anon_sym_switch] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(450),
    [anon_sym_case] = ACTIONS(452),
    [anon_sym_COLON] = ACTIONS(450),
    [anon_sym_default] = ACTIONS(452),
    [anon_sym_cast] = ACTIONS(452),
    [anon_sym_COMMA] = ACTIONS(450),
    [anon_sym_DOLLARtype] = ACTIONS(450),
    [anon_sym_in] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(450),
    [anon_sym_RBRACK] = ACTIONS(450),
    [anon_sym_this] = ACTIONS(452),
    [anon_sym_DOT] = ACTIONS(452),
    [anon_sym_QMARK] = ACTIONS(452),
    [anon_sym_AT] = ACTIONS(452),
    [anon_sym_AT_COLON] = ACTIONS(450),
    [anon_sym_if] = ACTIONS(452),
    [anon_sym_else] = ACTIONS(452),
    [anon_sym_new] = ACTIONS(452),
    [anon_sym_TILDE] = ACTIONS(450),
    [anon_sym_BANG] = ACTIONS(452),
    [anon_sym_DASH] = ACTIONS(452),
    [anon_sym_PLUS_PLUS] = ACTIONS(450),
    [anon_sym_DASH_DASH] = ACTIONS(450),
    [anon_sym_PERCENT] = ACTIONS(450),
    [anon_sym_STAR] = ACTIONS(450),
    [anon_sym_SLASH] = ACTIONS(452),
    [anon_sym_PLUS] = ACTIONS(452),
    [anon_sym_LT_LT] = ACTIONS(450),
    [anon_sym_GT_GT] = ACTIONS(452),
    [anon_sym_GT_GT_GT] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(452),
    [anon_sym_CARET] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(450),
    [anon_sym_PIPE_PIPE] = ACTIONS(450),
    [anon_sym_EQ_EQ] = ACTIONS(450),
    [anon_sym_BANG_EQ] = ACTIONS(450),
    [anon_sym_LT] = ACTIONS(452),
    [anon_sym_LT_EQ] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(452),
    [anon_sym_GT_EQ] = ACTIONS(450),
    [anon_sym_EQ_GT] = ACTIONS(450),
    [anon_sym_QMARK_QMARK] = ACTIONS(450),
    [anon_sym_EQ] = ACTIONS(452),
    [sym__rangeOperator] = ACTIONS(450),
    [anon_sym_null] = ACTIONS(452),
    [anon_sym_dynamic] = ACTIONS(452),
    [anon_sym_final] = ACTIONS(452),
    [anon_sym_abstract] = ACTIONS(452),
    [anon_sym_class] = ACTIONS(452),
    [anon_sym_extends] = ACTIONS(452),
    [anon_sym_implements] = ACTIONS(452),
    [anon_sym_interface] = ACTIONS(452),
    [anon_sym_typedef] = ACTIONS(452),
    [anon_sym_function] = ACTIONS(452),
    [anon_sym_var] = ACTIONS(452),
    [aux_sym_integer_token1] = ACTIONS(452),
    [aux_sym_integer_token2] = ACTIONS(450),
    [aux_sym_float_token1] = ACTIONS(452),
    [aux_sym_float_token2] = ACTIONS(450),
    [anon_sym_true] = ACTIONS(452),
    [anon_sym_false] = ACTIONS(452),
    [aux_sym_string_token1] = ACTIONS(450),
    [aux_sym_string_token3] = ACTIONS(450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(452),
    [anon_sym_catch] = ACTIONS(452),
    [anon_sym_continue] = ACTIONS(452),
    [anon_sym_do] = ACTIONS(452),
    [anon_sym_enum] = ACTIONS(452),
    [anon_sym_extern] = ACTIONS(452),
    [anon_sym_for] = ACTIONS(452),
    [anon_sym_inline] = ACTIONS(452),
    [anon_sym_macro] = ACTIONS(452),
    [anon_sym_operator] = ACTIONS(452),
    [anon_sym_overload] = ACTIONS(452),
    [anon_sym_override] = ACTIONS(452),
    [anon_sym_private] = ACTIONS(452),
    [anon_sym_public] = ACTIONS(452),
    [anon_sym_return] = ACTIONS(452),
    [anon_sym_static] = ACTIONS(452),
    [anon_sym_try] = ACTIONS(452),
    [anon_sym_untyped] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(452),
    [sym__semicolon] = ACTIONS(450),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(320),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_POUND] = ACTIONS(320),
    [anon_sym_package] = ACTIONS(322),
    [anon_sym_import] = ACTIONS(322),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_throw] = ACTIONS(322),
    [anon_sym_LPAREN] = ACTIONS(320),
    [anon_sym_RPAREN] = ACTIONS(320),
    [anon_sym_switch] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_case] = ACTIONS(322),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_default] = ACTIONS(322),
    [anon_sym_cast] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(320),
    [anon_sym_DOLLARtype] = ACTIONS(320),
    [anon_sym_in] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_RBRACK] = ACTIONS(320),
    [anon_sym_this] = ACTIONS(322),
    [anon_sym_DOT] = ACTIONS(322),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(322),
    [anon_sym_AT_COLON] = ACTIONS(320),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(322),
    [anon_sym_new] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(320),
    [anon_sym_BANG] = ACTIONS(322),
    [anon_sym_DASH] = ACTIONS(322),
    [anon_sym_PLUS_PLUS] = ACTIONS(320),
    [anon_sym_DASH_DASH] = ACTIONS(320),
    [anon_sym_PERCENT] = ACTIONS(320),
    [anon_sym_STAR] = ACTIONS(320),
    [anon_sym_SLASH] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(322),
    [anon_sym_LT_LT] = ACTIONS(320),
    [anon_sym_GT_GT] = ACTIONS(322),
    [anon_sym_GT_GT_GT] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(322),
    [anon_sym_PIPE] = ACTIONS(322),
    [anon_sym_CARET] = ACTIONS(320),
    [anon_sym_AMP_AMP] = ACTIONS(320),
    [anon_sym_PIPE_PIPE] = ACTIONS(320),
    [anon_sym_EQ_EQ] = ACTIONS(320),
    [anon_sym_BANG_EQ] = ACTIONS(320),
    [anon_sym_LT] = ACTIONS(322),
    [anon_sym_LT_EQ] = ACTIONS(320),
    [anon_sym_GT] = ACTIONS(322),
    [anon_sym_GT_EQ] = ACTIONS(320),
    [anon_sym_EQ_GT] = ACTIONS(320),
    [anon_sym_QMARK_QMARK] = ACTIONS(320),
    [anon_sym_EQ] = ACTIONS(322),
    [sym__rangeOperator] = ACTIONS(320),
    [anon_sym_null] = ACTIONS(322),
    [anon_sym_dynamic] = ACTIONS(322),
    [anon_sym_final] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(322),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_extends] = ACTIONS(322),
    [anon_sym_implements] = ACTIONS(322),
    [anon_sym_interface] = ACTIONS(322),
    [anon_sym_typedef] = ACTIONS(322),
    [anon_sym_function] = ACTIONS(322),
    [anon_sym_var] = ACTIONS(322),
    [aux_sym_integer_token1] = ACTIONS(322),
    [aux_sym_integer_token2] = ACTIONS(320),
    [aux_sym_float_token1] = ACTIONS(322),
    [aux_sym_float_token2] = ACTIONS(320),
    [anon_sym_true] = ACTIONS(322),
    [anon_sym_false] = ACTIONS(322),
    [aux_sym_string_token1] = ACTIONS(320),
    [aux_sym_string_token3] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(322),
    [anon_sym_catch] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(322),
    [anon_sym_do] = ACTIONS(322),
    [anon_sym_enum] = ACTIONS(322),
    [anon_sym_extern] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(322),
    [anon_sym_inline] = ACTIONS(322),
    [anon_sym_macro] = ACTIONS(322),
    [anon_sym_operator] = ACTIONS(322),
    [anon_sym_overload] = ACTIONS(322),
    [anon_sym_override] = ACTIONS(322),
    [anon_sym_private] = ACTIONS(322),
    [anon_sym_public] = ACTIONS(322),
    [anon_sym_return] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(322),
    [anon_sym_try] = ACTIONS(322),
    [anon_sym_untyped] = ACTIONS(322),
    [anon_sym_while] = ACTIONS(322),
    [sym__semicolon] = ACTIONS(320),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(320),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_POUND] = ACTIONS(320),
    [anon_sym_package] = ACTIONS(322),
    [anon_sym_import] = ACTIONS(322),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_throw] = ACTIONS(322),
    [anon_sym_LPAREN] = ACTIONS(320),
    [anon_sym_RPAREN] = ACTIONS(320),
    [anon_sym_switch] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_case] = ACTIONS(322),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_default] = ACTIONS(322),
    [anon_sym_cast] = ACTIONS(322),
    [anon_sym_COMMA] = ACTIONS(320),
    [anon_sym_DOLLARtype] = ACTIONS(320),
    [anon_sym_in] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(320),
    [anon_sym_RBRACK] = ACTIONS(320),
    [anon_sym_this] = ACTIONS(322),
    [anon_sym_DOT] = ACTIONS(322),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(322),
    [anon_sym_AT_COLON] = ACTIONS(320),
    [anon_sym_if] = ACTIONS(322),
    [anon_sym_else] = ACTIONS(322),
    [anon_sym_new] = ACTIONS(322),
    [anon_sym_TILDE] = ACTIONS(320),
    [anon_sym_BANG] = ACTIONS(322),
    [anon_sym_DASH] = ACTIONS(322),
    [anon_sym_PLUS_PLUS] = ACTIONS(320),
    [anon_sym_DASH_DASH] = ACTIONS(320),
    [anon_sym_PERCENT] = ACTIONS(320),
    [anon_sym_STAR] = ACTIONS(320),
    [anon_sym_SLASH] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(322),
    [anon_sym_LT_LT] = ACTIONS(320),
    [anon_sym_GT_GT] = ACTIONS(322),
    [anon_sym_GT_GT_GT] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(322),
    [anon_sym_PIPE] = ACTIONS(322),
    [anon_sym_CARET] = ACTIONS(320),
    [anon_sym_AMP_AMP] = ACTIONS(320),
    [anon_sym_PIPE_PIPE] = ACTIONS(320),
    [anon_sym_EQ_EQ] = ACTIONS(320),
    [anon_sym_BANG_EQ] = ACTIONS(320),
    [anon_sym_LT] = ACTIONS(322),
    [anon_sym_LT_EQ] = ACTIONS(320),
    [anon_sym_GT] = ACTIONS(322),
    [anon_sym_GT_EQ] = ACTIONS(320),
    [anon_sym_EQ_GT] = ACTIONS(320),
    [anon_sym_QMARK_QMARK] = ACTIONS(320),
    [anon_sym_EQ] = ACTIONS(322),
    [sym__rangeOperator] = ACTIONS(320),
    [anon_sym_null] = ACTIONS(322),
    [anon_sym_dynamic] = ACTIONS(322),
    [anon_sym_final] = ACTIONS(322),
    [anon_sym_abstract] = ACTIONS(322),
    [anon_sym_class] = ACTIONS(322),
    [anon_sym_extends] = ACTIONS(322),
    [anon_sym_implements] = ACTIONS(322),
    [anon_sym_interface] = ACTIONS(322),
    [anon_sym_typedef] = ACTIONS(322),
    [anon_sym_function] = ACTIONS(322),
    [anon_sym_var] = ACTIONS(322),
    [aux_sym_integer_token1] = ACTIONS(322),
    [aux_sym_integer_token2] = ACTIONS(320),
    [aux_sym_float_token1] = ACTIONS(322),
    [aux_sym_float_token2] = ACTIONS(320),
    [anon_sym_true] = ACTIONS(322),
    [anon_sym_false] = ACTIONS(322),
    [aux_sym_string_token1] = ACTIONS(320),
    [aux_sym_string_token3] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(322),
    [anon_sym_catch] = ACTIONS(322),
    [anon_sym_continue] = ACTIONS(322),
    [anon_sym_do] = ACTIONS(322),
    [anon_sym_enum] = ACTIONS(322),
    [anon_sym_extern] = ACTIONS(322),
    [anon_sym_for] = ACTIONS(322),
    [anon_sym_inline] = ACTIONS(322),
    [anon_sym_macro] = ACTIONS(322),
    [anon_sym_operator] = ACTIONS(322),
    [anon_sym_overload] = ACTIONS(322),
    [anon_sym_override] = ACTIONS(322),
    [anon_sym_private] = ACTIONS(322),
    [anon_sym_public] = ACTIONS(322),
    [anon_sym_return] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(322),
    [anon_sym_try] = ACTIONS(322),
    [anon_sym_untyped] = ACTIONS(322),
    [anon_sym_while] = ACTIONS(322),
    [sym__semicolon] = ACTIONS(320),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(456),
    [sym_identifier] = ACTIONS(458),
    [anon_sym_POUND] = ACTIONS(456),
    [anon_sym_package] = ACTIONS(458),
    [anon_sym_import] = ACTIONS(458),
    [anon_sym_using] = ACTIONS(458),
    [anon_sym_throw] = ACTIONS(458),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_RPAREN] = ACTIONS(456),
    [anon_sym_switch] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(456),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_case] = ACTIONS(458),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_default] = ACTIONS(458),
    [anon_sym_cast] = ACTIONS(458),
    [anon_sym_COMMA] = ACTIONS(456),
    [anon_sym_DOLLARtype] = ACTIONS(456),
    [anon_sym_in] = ACTIONS(458),
    [anon_sym_LBRACK] = ACTIONS(456),
    [anon_sym_RBRACK] = ACTIONS(456),
    [anon_sym_this] = ACTIONS(458),
    [anon_sym_DOT] = ACTIONS(458),
    [anon_sym_QMARK] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(458),
    [anon_sym_AT_COLON] = ACTIONS(456),
    [anon_sym_if] = ACTIONS(458),
    [anon_sym_else] = ACTIONS(458),
    [anon_sym_new] = ACTIONS(458),
    [anon_sym_TILDE] = ACTIONS(456),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(456),
    [anon_sym_DASH_DASH] = ACTIONS(456),
    [anon_sym_PERCENT] = ACTIONS(456),
    [anon_sym_STAR] = ACTIONS(456),
    [anon_sym_SLASH] = ACTIONS(458),
    [anon_sym_PLUS] = ACTIONS(458),
    [anon_sym_LT_LT] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(458),
    [anon_sym_GT_GT_GT] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(458),
    [anon_sym_PIPE] = ACTIONS(458),
    [anon_sym_CARET] = ACTIONS(456),
    [anon_sym_AMP_AMP] = ACTIONS(456),
    [anon_sym_PIPE_PIPE] = ACTIONS(456),
    [anon_sym_EQ_EQ] = ACTIONS(456),
    [anon_sym_BANG_EQ] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(458),
    [anon_sym_LT_EQ] = ACTIONS(456),
    [anon_sym_GT] = ACTIONS(458),
    [anon_sym_GT_EQ] = ACTIONS(456),
    [anon_sym_EQ_GT] = ACTIONS(456),
    [anon_sym_QMARK_QMARK] = ACTIONS(456),
    [anon_sym_EQ] = ACTIONS(458),
    [sym__rangeOperator] = ACTIONS(456),
    [anon_sym_null] = ACTIONS(458),
    [anon_sym_dynamic] = ACTIONS(458),
    [anon_sym_final] = ACTIONS(458),
    [anon_sym_abstract] = ACTIONS(458),
    [anon_sym_class] = ACTIONS(458),
    [anon_sym_extends] = ACTIONS(458),
    [anon_sym_implements] = ACTIONS(458),
    [anon_sym_interface] = ACTIONS(458),
    [anon_sym_typedef] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_var] = ACTIONS(458),
    [aux_sym_integer_token1] = ACTIONS(458),
    [aux_sym_integer_token2] = ACTIONS(456),
    [aux_sym_float_token1] = ACTIONS(458),
    [aux_sym_float_token2] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [aux_sym_string_token1] = ACTIONS(456),
    [aux_sym_string_token3] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(458),
    [anon_sym_catch] = ACTIONS(458),
    [anon_sym_continue] = ACTIONS(458),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_enum] = ACTIONS(458),
    [anon_sym_extern] = ACTIONS(458),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(458),
    [anon_sym_macro] = ACTIONS(458),
    [anon_sym_operator] = ACTIONS(458),
    [anon_sym_overload] = ACTIONS(458),
    [anon_sym_override] = ACTIONS(458),
    [anon_sym_private] = ACTIONS(458),
    [anon_sym_public] = ACTIONS(458),
    [anon_sym_return] = ACTIONS(458),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_untyped] = ACTIONS(458),
    [anon_sym_while] = ACTIONS(458),
    [sym__semicolon] = ACTIONS(456),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(460),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_POUND] = ACTIONS(460),
    [anon_sym_package] = ACTIONS(462),
    [anon_sym_import] = ACTIONS(462),
    [anon_sym_using] = ACTIONS(462),
    [anon_sym_throw] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(460),
    [anon_sym_RPAREN] = ACTIONS(460),
    [anon_sym_switch] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_RBRACE] = ACTIONS(460),
    [anon_sym_case] = ACTIONS(462),
    [anon_sym_COLON] = ACTIONS(460),
    [anon_sym_default] = ACTIONS(462),
    [anon_sym_cast] = ACTIONS(462),
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_DOLLARtype] = ACTIONS(460),
    [anon_sym_in] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(460),
    [anon_sym_RBRACK] = ACTIONS(460),
    [anon_sym_this] = ACTIONS(462),
    [anon_sym_DOT] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(462),
    [anon_sym_AT_COLON] = ACTIONS(460),
    [anon_sym_if] = ACTIONS(462),
    [anon_sym_else] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(460),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(462),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_PERCENT] = ACTIONS(460),
    [anon_sym_STAR] = ACTIONS(460),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_PLUS] = ACTIONS(462),
    [anon_sym_LT_LT] = ACTIONS(460),
    [anon_sym_GT_GT] = ACTIONS(462),
    [anon_sym_GT_GT_GT] = ACTIONS(460),
    [anon_sym_AMP] = ACTIONS(462),
    [anon_sym_PIPE] = ACTIONS(462),
    [anon_sym_CARET] = ACTIONS(460),
    [anon_sym_AMP_AMP] = ACTIONS(460),
    [anon_sym_PIPE_PIPE] = ACTIONS(460),
    [anon_sym_EQ_EQ] = ACTIONS(460),
    [anon_sym_BANG_EQ] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_LT_EQ] = ACTIONS(460),
    [anon_sym_GT] = ACTIONS(462),
    [anon_sym_GT_EQ] = ACTIONS(460),
    [anon_sym_EQ_GT] = ACTIONS(460),
    [anon_sym_QMARK_QMARK] = ACTIONS(460),
    [anon_sym_EQ] = ACTIONS(462),
    [sym__rangeOperator] = ACTIONS(460),
    [anon_sym_null] = ACTIONS(462),
    [anon_sym_dynamic] = ACTIONS(462),
    [anon_sym_final] = ACTIONS(462),
    [anon_sym_abstract] = ACTIONS(462),
    [anon_sym_class] = ACTIONS(462),
    [anon_sym_extends] = ACTIONS(462),
    [anon_sym_implements] = ACTIONS(462),
    [anon_sym_interface] = ACTIONS(462),
    [anon_sym_typedef] = ACTIONS(462),
    [anon_sym_function] = ACTIONS(462),
    [anon_sym_var] = ACTIONS(462),
    [aux_sym_integer_token1] = ACTIONS(462),
    [aux_sym_integer_token2] = ACTIONS(460),
    [aux_sym_float_token1] = ACTIONS(462),
    [aux_sym_float_token2] = ACTIONS(460),
    [anon_sym_true] = ACTIONS(462),
    [anon_sym_false] = ACTIONS(462),
    [aux_sym_string_token1] = ACTIONS(460),
    [aux_sym_string_token3] = ACTIONS(460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_catch] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(462),
    [anon_sym_do] = ACTIONS(462),
    [anon_sym_enum] = ACTIONS(462),
    [anon_sym_extern] = ACTIONS(462),
    [anon_sym_for] = ACTIONS(462),
    [anon_sym_inline] = ACTIONS(462),
    [anon_sym_macro] = ACTIONS(462),
    [anon_sym_operator] = ACTIONS(462),
    [anon_sym_overload] = ACTIONS(462),
    [anon_sym_override] = ACTIONS(462),
    [anon_sym_private] = ACTIONS(462),
    [anon_sym_public] = ACTIONS(462),
    [anon_sym_return] = ACTIONS(462),
    [anon_sym_static] = ACTIONS(462),
    [anon_sym_try] = ACTIONS(462),
    [anon_sym_untyped] = ACTIONS(462),
    [anon_sym_while] = ACTIONS(462),
    [sym__semicolon] = ACTIONS(460),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_DOLLARtype] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_DASH_GT] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(424),
    [anon_sym_AMP_AMP] = ACTIONS(424),
    [anon_sym_PIPE_PIPE] = ACTIONS(424),
    [anon_sym_EQ_EQ] = ACTIONS(424),
    [anon_sym_BANG_EQ] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_GT_EQ] = ACTIONS(424),
    [anon_sym_EQ_GT] = ACTIONS(424),
    [anon_sym_QMARK_QMARK] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(426),
    [sym__rangeOperator] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_DOLLARtype] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_RBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_DOT] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(424),
    [anon_sym_AMP_AMP] = ACTIONS(424),
    [anon_sym_PIPE_PIPE] = ACTIONS(424),
    [anon_sym_EQ_EQ] = ACTIONS(424),
    [anon_sym_BANG_EQ] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_GT_EQ] = ACTIONS(424),
    [anon_sym_EQ_GT] = ACTIONS(424),
    [anon_sym_QMARK_QMARK] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(426),
    [sym__rangeOperator] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(468),
    [sym_identifier] = ACTIONS(470),
    [anon_sym_POUND] = ACTIONS(468),
    [anon_sym_package] = ACTIONS(470),
    [anon_sym_import] = ACTIONS(470),
    [anon_sym_using] = ACTIONS(470),
    [anon_sym_throw] = ACTIONS(470),
    [anon_sym_LPAREN] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_switch] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_case] = ACTIONS(470),
    [anon_sym_COLON] = ACTIONS(468),
    [anon_sym_default] = ACTIONS(470),
    [anon_sym_cast] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_DOLLARtype] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(470),
    [anon_sym_LBRACK] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_this] = ACTIONS(470),
    [anon_sym_DOT] = ACTIONS(470),
    [anon_sym_QMARK] = ACTIONS(470),
    [anon_sym_AT] = ACTIONS(470),
    [anon_sym_AT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(470),
    [anon_sym_else] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(470),
    [anon_sym_TILDE] = ACTIONS(468),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_DASH] = ACTIONS(470),
    [anon_sym_PLUS_PLUS] = ACTIONS(468),
    [anon_sym_DASH_DASH] = ACTIONS(468),
    [anon_sym_PERCENT] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(468),
    [anon_sym_SLASH] = ACTIONS(470),
    [anon_sym_PLUS] = ACTIONS(470),
    [anon_sym_LT_LT] = ACTIONS(468),
    [anon_sym_GT_GT] = ACTIONS(470),
    [anon_sym_GT_GT_GT] = ACTIONS(468),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_PIPE] = ACTIONS(470),
    [anon_sym_CARET] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_EQ_EQ] = ACTIONS(468),
    [anon_sym_BANG_EQ] = ACTIONS(468),
    [anon_sym_LT] = ACTIONS(470),
    [anon_sym_LT_EQ] = ACTIONS(468),
    [anon_sym_GT] = ACTIONS(470),
    [anon_sym_GT_EQ] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_QMARK_QMARK] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(470),
    [sym__rangeOperator] = ACTIONS(468),
    [anon_sym_null] = ACTIONS(470),
    [anon_sym_dynamic] = ACTIONS(470),
    [anon_sym_final] = ACTIONS(470),
    [anon_sym_abstract] = ACTIONS(470),
    [anon_sym_class] = ACTIONS(470),
    [anon_sym_extends] = ACTIONS(470),
    [anon_sym_implements] = ACTIONS(470),
    [anon_sym_interface] = ACTIONS(470),
    [anon_sym_typedef] = ACTIONS(470),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_var] = ACTIONS(470),
    [aux_sym_integer_token1] = ACTIONS(470),
    [aux_sym_integer_token2] = ACTIONS(468),
    [aux_sym_float_token1] = ACTIONS(470),
    [aux_sym_float_token2] = ACTIONS(468),
    [anon_sym_true] = ACTIONS(470),
    [anon_sym_false] = ACTIONS(470),
    [aux_sym_string_token1] = ACTIONS(468),
    [aux_sym_string_token3] = ACTIONS(468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(470),
    [anon_sym_catch] = ACTIONS(470),
    [anon_sym_continue] = ACTIONS(470),
    [anon_sym_do] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(470),
    [anon_sym_extern] = ACTIONS(470),
    [anon_sym_for] = ACTIONS(470),
    [anon_sym_inline] = ACTIONS(470),
    [anon_sym_macro] = ACTIONS(470),
    [anon_sym_operator] = ACTIONS(470),
    [anon_sym_overload] = ACTIONS(470),
    [anon_sym_override] = ACTIONS(470),
    [anon_sym_private] = ACTIONS(470),
    [anon_sym_public] = ACTIONS(470),
    [anon_sym_return] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(470),
    [anon_sym_try] = ACTIONS(470),
    [anon_sym_untyped] = ACTIONS(470),
    [anon_sym_while] = ACTIONS(470),
    [sym__semicolon] = ACTIONS(468),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(472),
    [sym_identifier] = ACTIONS(474),
    [anon_sym_POUND] = ACTIONS(472),
    [anon_sym_package] = ACTIONS(474),
    [anon_sym_import] = ACTIONS(474),
    [anon_sym_using] = ACTIONS(474),
    [anon_sym_throw] = ACTIONS(474),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_switch] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_case] = ACTIONS(474),
    [anon_sym_COLON] = ACTIONS(472),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_cast] = ACTIONS(474),
    [anon_sym_COMMA] = ACTIONS(472),
    [anon_sym_DOLLARtype] = ACTIONS(472),
    [anon_sym_in] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(472),
    [anon_sym_RBRACK] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(474),
    [anon_sym_AT_COLON] = ACTIONS(472),
    [anon_sym_if] = ACTIONS(474),
    [anon_sym_else] = ACTIONS(474),
    [anon_sym_new] = ACTIONS(474),
    [anon_sym_TILDE] = ACTIONS(472),
    [anon_sym_BANG] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(474),
    [anon_sym_PLUS_PLUS] = ACTIONS(472),
    [anon_sym_DASH_DASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(472),
    [anon_sym_STAR] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_PLUS] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(472),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_GT_GT_GT] = ACTIONS(472),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_CARET] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_EQ_EQ] = ACTIONS(472),
    [anon_sym_BANG_EQ] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_LT_EQ] = ACTIONS(472),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_GT_EQ] = ACTIONS(472),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_QMARK_QMARK] = ACTIONS(472),
    [anon_sym_EQ] = ACTIONS(474),
    [sym__rangeOperator] = ACTIONS(472),
    [anon_sym_null] = ACTIONS(474),
    [anon_sym_dynamic] = ACTIONS(474),
    [anon_sym_final] = ACTIONS(474),
    [anon_sym_abstract] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(474),
    [anon_sym_extends] = ACTIONS(474),
    [anon_sym_implements] = ACTIONS(474),
    [anon_sym_interface] = ACTIONS(474),
    [anon_sym_typedef] = ACTIONS(474),
    [anon_sym_function] = ACTIONS(474),
    [anon_sym_var] = ACTIONS(474),
    [aux_sym_integer_token1] = ACTIONS(474),
    [aux_sym_integer_token2] = ACTIONS(472),
    [aux_sym_float_token1] = ACTIONS(474),
    [aux_sym_float_token2] = ACTIONS(472),
    [anon_sym_true] = ACTIONS(474),
    [anon_sym_false] = ACTIONS(474),
    [aux_sym_string_token1] = ACTIONS(472),
    [aux_sym_string_token3] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_catch] = ACTIONS(474),
    [anon_sym_continue] = ACTIONS(474),
    [anon_sym_do] = ACTIONS(474),
    [anon_sym_enum] = ACTIONS(474),
    [anon_sym_extern] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(474),
    [anon_sym_inline] = ACTIONS(474),
    [anon_sym_macro] = ACTIONS(474),
    [anon_sym_operator] = ACTIONS(474),
    [anon_sym_overload] = ACTIONS(474),
    [anon_sym_override] = ACTIONS(474),
    [anon_sym_private] = ACTIONS(474),
    [anon_sym_public] = ACTIONS(474),
    [anon_sym_return] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(474),
    [anon_sym_try] = ACTIONS(474),
    [anon_sym_untyped] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(474),
    [sym__semicolon] = ACTIONS(472),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(476),
    [sym_identifier] = ACTIONS(478),
    [anon_sym_POUND] = ACTIONS(476),
    [anon_sym_package] = ACTIONS(478),
    [anon_sym_import] = ACTIONS(478),
    [anon_sym_using] = ACTIONS(478),
    [anon_sym_throw] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_RPAREN] = ACTIONS(476),
    [anon_sym_switch] = ACTIONS(478),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_case] = ACTIONS(478),
    [anon_sym_COLON] = ACTIONS(476),
    [anon_sym_default] = ACTIONS(478),
    [anon_sym_cast] = ACTIONS(478),
    [anon_sym_COMMA] = ACTIONS(476),
    [anon_sym_DOLLARtype] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(478),
    [anon_sym_LBRACK] = ACTIONS(476),
    [anon_sym_RBRACK] = ACTIONS(476),
    [anon_sym_this] = ACTIONS(478),
    [anon_sym_DOT] = ACTIONS(478),
    [anon_sym_QMARK] = ACTIONS(478),
    [anon_sym_AT] = ACTIONS(478),
    [anon_sym_AT_COLON] = ACTIONS(476),
    [anon_sym_if] = ACTIONS(478),
    [anon_sym_else] = ACTIONS(478),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_TILDE] = ACTIONS(476),
    [anon_sym_BANG] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_PLUS_PLUS] = ACTIONS(476),
    [anon_sym_DASH_DASH] = ACTIONS(476),
    [anon_sym_PERCENT] = ACTIONS(476),
    [anon_sym_STAR] = ACTIONS(476),
    [anon_sym_SLASH] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(478),
    [anon_sym_LT_LT] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(478),
    [anon_sym_GT_GT_GT] = ACTIONS(476),
    [anon_sym_AMP] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(478),
    [anon_sym_CARET] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(476),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(476),
    [anon_sym_BANG_EQ] = ACTIONS(476),
    [anon_sym_LT] = ACTIONS(478),
    [anon_sym_LT_EQ] = ACTIONS(476),
    [anon_sym_GT] = ACTIONS(478),
    [anon_sym_GT_EQ] = ACTIONS(476),
    [anon_sym_EQ_GT] = ACTIONS(476),
    [anon_sym_QMARK_QMARK] = ACTIONS(476),
    [anon_sym_EQ] = ACTIONS(478),
    [sym__rangeOperator] = ACTIONS(476),
    [anon_sym_null] = ACTIONS(478),
    [anon_sym_dynamic] = ACTIONS(478),
    [anon_sym_final] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(478),
    [anon_sym_class] = ACTIONS(478),
    [anon_sym_extends] = ACTIONS(478),
    [anon_sym_implements] = ACTIONS(478),
    [anon_sym_interface] = ACTIONS(478),
    [anon_sym_typedef] = ACTIONS(478),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_var] = ACTIONS(478),
    [aux_sym_integer_token1] = ACTIONS(478),
    [aux_sym_integer_token2] = ACTIONS(476),
    [aux_sym_float_token1] = ACTIONS(478),
    [aux_sym_float_token2] = ACTIONS(476),
    [anon_sym_true] = ACTIONS(478),
    [anon_sym_false] = ACTIONS(478),
    [aux_sym_string_token1] = ACTIONS(476),
    [aux_sym_string_token3] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(478),
    [anon_sym_catch] = ACTIONS(478),
    [anon_sym_continue] = ACTIONS(478),
    [anon_sym_do] = ACTIONS(478),
    [anon_sym_enum] = ACTIONS(478),
    [anon_sym_extern] = ACTIONS(478),
    [anon_sym_for] = ACTIONS(478),
    [anon_sym_inline] = ACTIONS(478),
    [anon_sym_macro] = ACTIONS(478),
    [anon_sym_operator] = ACTIONS(478),
    [anon_sym_overload] = ACTIONS(478),
    [anon_sym_override] = ACTIONS(478),
    [anon_sym_private] = ACTIONS(478),
    [anon_sym_public] = ACTIONS(478),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_static] = ACTIONS(478),
    [anon_sym_try] = ACTIONS(478),
    [anon_sym_untyped] = ACTIONS(478),
    [anon_sym_while] = ACTIONS(478),
    [sym__semicolon] = ACTIONS(476),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(480),
    [sym_identifier] = ACTIONS(483),
    [anon_sym_POUND] = ACTIONS(480),
    [anon_sym_package] = ACTIONS(483),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_using] = ACTIONS(483),
    [anon_sym_throw] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(480),
    [anon_sym_switch] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(480),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(483),
    [anon_sym_COLON] = ACTIONS(480),
    [anon_sym_default] = ACTIONS(483),
    [anon_sym_cast] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(480),
    [anon_sym_DOLLARtype] = ACTIONS(480),
    [anon_sym_in] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(480),
    [anon_sym_RBRACK] = ACTIONS(480),
    [anon_sym_this] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(483),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_AT] = ACTIONS(483),
    [anon_sym_AT_COLON] = ACTIONS(480),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_else] = ACTIONS(483),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_BANG] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_PERCENT] = ACTIONS(480),
    [anon_sym_STAR] = ACTIONS(480),
    [anon_sym_SLASH] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(483),
    [anon_sym_GT_GT_GT] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(483),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_AMP_AMP] = ACTIONS(480),
    [anon_sym_PIPE_PIPE] = ACTIONS(480),
    [anon_sym_EQ_EQ] = ACTIONS(480),
    [anon_sym_BANG_EQ] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(480),
    [anon_sym_EQ_GT] = ACTIONS(480),
    [anon_sym_QMARK_QMARK] = ACTIONS(480),
    [anon_sym_EQ] = ACTIONS(483),
    [sym__rangeOperator] = ACTIONS(480),
    [anon_sym_null] = ACTIONS(483),
    [anon_sym_dynamic] = ACTIONS(483),
    [anon_sym_final] = ACTIONS(483),
    [anon_sym_abstract] = ACTIONS(483),
    [anon_sym_class] = ACTIONS(483),
    [anon_sym_extends] = ACTIONS(483),
    [anon_sym_implements] = ACTIONS(483),
    [anon_sym_interface] = ACTIONS(483),
    [anon_sym_typedef] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(483),
    [aux_sym_integer_token1] = ACTIONS(483),
    [aux_sym_integer_token2] = ACTIONS(480),
    [aux_sym_float_token1] = ACTIONS(483),
    [aux_sym_float_token2] = ACTIONS(480),
    [anon_sym_true] = ACTIONS(483),
    [anon_sym_false] = ACTIONS(483),
    [aux_sym_string_token1] = ACTIONS(480),
    [aux_sym_string_token3] = ACTIONS(480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_catch] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_enum] = ACTIONS(483),
    [anon_sym_extern] = ACTIONS(483),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_inline] = ACTIONS(483),
    [anon_sym_macro] = ACTIONS(483),
    [anon_sym_operator] = ACTIONS(483),
    [anon_sym_overload] = ACTIONS(483),
    [anon_sym_override] = ACTIONS(483),
    [anon_sym_private] = ACTIONS(483),
    [anon_sym_public] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_untyped] = ACTIONS(483),
    [anon_sym_while] = ACTIONS(483),
    [sym__semicolon] = ACTIONS(480),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(486),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_POUND] = ACTIONS(486),
    [anon_sym_package] = ACTIONS(488),
    [anon_sym_import] = ACTIONS(488),
    [anon_sym_using] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(486),
    [anon_sym_switch] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_RBRACE] = ACTIONS(486),
    [anon_sym_case] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_default] = ACTIONS(488),
    [anon_sym_cast] = ACTIONS(488),
    [anon_sym_COMMA] = ACTIONS(486),
    [anon_sym_DOLLARtype] = ACTIONS(486),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(486),
    [anon_sym_RBRACK] = ACTIONS(486),
    [anon_sym_this] = ACTIONS(488),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_QMARK] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_AT_COLON] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(488),
    [anon_sym_else] = ACTIONS(488),
    [anon_sym_new] = ACTIONS(488),
    [anon_sym_TILDE] = ACTIONS(486),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_PLUS_PLUS] = ACTIONS(486),
    [anon_sym_DASH_DASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(486),
    [anon_sym_SLASH] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(486),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_GT_GT_GT] = ACTIONS(486),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(486),
    [anon_sym_AMP_AMP] = ACTIONS(486),
    [anon_sym_PIPE_PIPE] = ACTIONS(486),
    [anon_sym_EQ_EQ] = ACTIONS(486),
    [anon_sym_BANG_EQ] = ACTIONS(486),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_LT_EQ] = ACTIONS(486),
    [anon_sym_GT] = ACTIONS(488),
    [anon_sym_GT_EQ] = ACTIONS(486),
    [anon_sym_EQ_GT] = ACTIONS(486),
    [anon_sym_QMARK_QMARK] = ACTIONS(486),
    [anon_sym_EQ] = ACTIONS(488),
    [sym__rangeOperator] = ACTIONS(486),
    [anon_sym_null] = ACTIONS(488),
    [anon_sym_dynamic] = ACTIONS(488),
    [anon_sym_final] = ACTIONS(488),
    [anon_sym_abstract] = ACTIONS(488),
    [anon_sym_class] = ACTIONS(488),
    [anon_sym_extends] = ACTIONS(488),
    [anon_sym_implements] = ACTIONS(488),
    [anon_sym_interface] = ACTIONS(488),
    [anon_sym_typedef] = ACTIONS(488),
    [anon_sym_function] = ACTIONS(488),
    [anon_sym_var] = ACTIONS(488),
    [aux_sym_integer_token1] = ACTIONS(488),
    [aux_sym_integer_token2] = ACTIONS(486),
    [aux_sym_float_token1] = ACTIONS(488),
    [aux_sym_float_token2] = ACTIONS(486),
    [anon_sym_true] = ACTIONS(488),
    [anon_sym_false] = ACTIONS(488),
    [aux_sym_string_token1] = ACTIONS(486),
    [aux_sym_string_token3] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(488),
    [anon_sym_catch] = ACTIONS(488),
    [anon_sym_continue] = ACTIONS(488),
    [anon_sym_do] = ACTIONS(488),
    [anon_sym_enum] = ACTIONS(488),
    [anon_sym_extern] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(488),
    [anon_sym_inline] = ACTIONS(488),
    [anon_sym_macro] = ACTIONS(488),
    [anon_sym_operator] = ACTIONS(488),
    [anon_sym_overload] = ACTIONS(488),
    [anon_sym_override] = ACTIONS(488),
    [anon_sym_private] = ACTIONS(488),
    [anon_sym_public] = ACTIONS(488),
    [anon_sym_return] = ACTIONS(488),
    [anon_sym_static] = ACTIONS(488),
    [anon_sym_try] = ACTIONS(488),
    [anon_sym_untyped] = ACTIONS(488),
    [anon_sym_while] = ACTIONS(488),
    [sym__semicolon] = ACTIONS(486),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(490),
    [sym_identifier] = ACTIONS(492),
    [anon_sym_POUND] = ACTIONS(490),
    [anon_sym_package] = ACTIONS(492),
    [anon_sym_import] = ACTIONS(492),
    [anon_sym_using] = ACTIONS(492),
    [anon_sym_throw] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_RPAREN] = ACTIONS(490),
    [anon_sym_switch] = ACTIONS(492),
    [anon_sym_LBRACE] = ACTIONS(490),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_case] = ACTIONS(492),
    [anon_sym_COLON] = ACTIONS(490),
    [anon_sym_default] = ACTIONS(492),
    [anon_sym_cast] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(490),
    [anon_sym_DOLLARtype] = ACTIONS(490),
    [anon_sym_in] = ACTIONS(492),
    [anon_sym_LBRACK] = ACTIONS(490),
    [anon_sym_RBRACK] = ACTIONS(490),
    [anon_sym_this] = ACTIONS(492),
    [anon_sym_DOT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(492),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_AT_COLON] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(492),
    [anon_sym_else] = ACTIONS(492),
    [anon_sym_new] = ACTIONS(492),
    [anon_sym_TILDE] = ACTIONS(490),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_PLUS_PLUS] = ACTIONS(490),
    [anon_sym_DASH_DASH] = ACTIONS(490),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_GT_GT_GT] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(492),
    [anon_sym_PIPE] = ACTIONS(492),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_EQ_GT] = ACTIONS(490),
    [anon_sym_QMARK_QMARK] = ACTIONS(490),
    [anon_sym_EQ] = ACTIONS(492),
    [sym__rangeOperator] = ACTIONS(490),
    [anon_sym_null] = ACTIONS(492),
    [anon_sym_dynamic] = ACTIONS(492),
    [anon_sym_final] = ACTIONS(492),
    [anon_sym_abstract] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_extends] = ACTIONS(492),
    [anon_sym_implements] = ACTIONS(492),
    [anon_sym_interface] = ACTIONS(492),
    [anon_sym_typedef] = ACTIONS(492),
    [anon_sym_function] = ACTIONS(492),
    [anon_sym_var] = ACTIONS(492),
    [aux_sym_integer_token1] = ACTIONS(492),
    [aux_sym_integer_token2] = ACTIONS(490),
    [aux_sym_float_token1] = ACTIONS(492),
    [aux_sym_float_token2] = ACTIONS(490),
    [anon_sym_true] = ACTIONS(492),
    [anon_sym_false] = ACTIONS(492),
    [aux_sym_string_token1] = ACTIONS(490),
    [aux_sym_string_token3] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(492),
    [anon_sym_catch] = ACTIONS(492),
    [anon_sym_continue] = ACTIONS(492),
    [anon_sym_do] = ACTIONS(492),
    [anon_sym_enum] = ACTIONS(492),
    [anon_sym_extern] = ACTIONS(492),
    [anon_sym_for] = ACTIONS(492),
    [anon_sym_inline] = ACTIONS(492),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_operator] = ACTIONS(492),
    [anon_sym_overload] = ACTIONS(492),
    [anon_sym_override] = ACTIONS(492),
    [anon_sym_private] = ACTIONS(492),
    [anon_sym_public] = ACTIONS(492),
    [anon_sym_return] = ACTIONS(492),
    [anon_sym_static] = ACTIONS(492),
    [anon_sym_try] = ACTIONS(492),
    [anon_sym_untyped] = ACTIONS(492),
    [anon_sym_while] = ACTIONS(492),
    [sym__semicolon] = ACTIONS(490),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(494),
    [sym_identifier] = ACTIONS(496),
    [anon_sym_POUND] = ACTIONS(494),
    [anon_sym_package] = ACTIONS(496),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_using] = ACTIONS(496),
    [anon_sym_throw] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_switch] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_default] = ACTIONS(496),
    [anon_sym_cast] = ACTIONS(496),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_DOLLARtype] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_this] = ACTIONS(496),
    [anon_sym_DOT] = ACTIONS(496),
    [anon_sym_QMARK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(496),
    [anon_sym_AT_COLON] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(494),
    [anon_sym_DASH_DASH] = ACTIONS(494),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_GT_GT_GT] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_AMP_AMP] = ACTIONS(494),
    [anon_sym_PIPE_PIPE] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_EQ_GT] = ACTIONS(494),
    [anon_sym_QMARK_QMARK] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [sym__rangeOperator] = ACTIONS(494),
    [anon_sym_null] = ACTIONS(496),
    [anon_sym_dynamic] = ACTIONS(496),
    [anon_sym_final] = ACTIONS(496),
    [anon_sym_abstract] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(496),
    [anon_sym_extends] = ACTIONS(496),
    [anon_sym_implements] = ACTIONS(496),
    [anon_sym_interface] = ACTIONS(496),
    [anon_sym_typedef] = ACTIONS(496),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_var] = ACTIONS(496),
    [aux_sym_integer_token1] = ACTIONS(496),
    [aux_sym_integer_token2] = ACTIONS(494),
    [aux_sym_float_token1] = ACTIONS(496),
    [aux_sym_float_token2] = ACTIONS(494),
    [anon_sym_true] = ACTIONS(496),
    [anon_sym_false] = ACTIONS(496),
    [aux_sym_string_token1] = ACTIONS(494),
    [aux_sym_string_token3] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_catch] = ACTIONS(496),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_do] = ACTIONS(496),
    [anon_sym_enum] = ACTIONS(496),
    [anon_sym_extern] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_inline] = ACTIONS(496),
    [anon_sym_macro] = ACTIONS(496),
    [anon_sym_operator] = ACTIONS(496),
    [anon_sym_overload] = ACTIONS(496),
    [anon_sym_override] = ACTIONS(496),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(496),
    [anon_sym_static] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(496),
    [anon_sym_untyped] = ACTIONS(496),
    [anon_sym_while] = ACTIONS(496),
    [sym__semicolon] = ACTIONS(494),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(498),
    [sym_identifier] = ACTIONS(500),
    [anon_sym_POUND] = ACTIONS(498),
    [anon_sym_package] = ACTIONS(500),
    [anon_sym_import] = ACTIONS(500),
    [anon_sym_using] = ACTIONS(500),
    [anon_sym_throw] = ACTIONS(500),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(498),
    [anon_sym_switch] = ACTIONS(500),
    [anon_sym_LBRACE] = ACTIONS(498),
    [anon_sym_RBRACE] = ACTIONS(498),
    [anon_sym_case] = ACTIONS(500),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_default] = ACTIONS(500),
    [anon_sym_cast] = ACTIONS(500),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_DOLLARtype] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(500),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_RBRACK] = ACTIONS(498),
    [anon_sym_this] = ACTIONS(500),
    [anon_sym_DOT] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(500),
    [anon_sym_AT] = ACTIONS(500),
    [anon_sym_AT_COLON] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(500),
    [anon_sym_else] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(500),
    [anon_sym_TILDE] = ACTIONS(498),
    [anon_sym_BANG] = ACTIONS(500),
    [anon_sym_DASH] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(498),
    [anon_sym_DASH_DASH] = ACTIONS(498),
    [anon_sym_PERCENT] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(498),
    [anon_sym_SLASH] = ACTIONS(500),
    [anon_sym_PLUS] = ACTIONS(500),
    [anon_sym_LT_LT] = ACTIONS(498),
    [anon_sym_GT_GT] = ACTIONS(500),
    [anon_sym_GT_GT_GT] = ACTIONS(498),
    [anon_sym_AMP] = ACTIONS(500),
    [anon_sym_PIPE] = ACTIONS(500),
    [anon_sym_CARET] = ACTIONS(498),
    [anon_sym_AMP_AMP] = ACTIONS(498),
    [anon_sym_PIPE_PIPE] = ACTIONS(498),
    [anon_sym_EQ_EQ] = ACTIONS(498),
    [anon_sym_BANG_EQ] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_LT_EQ] = ACTIONS(498),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_GT_EQ] = ACTIONS(498),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_QMARK_QMARK] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(500),
    [sym__rangeOperator] = ACTIONS(498),
    [anon_sym_null] = ACTIONS(500),
    [anon_sym_dynamic] = ACTIONS(500),
    [anon_sym_final] = ACTIONS(500),
    [anon_sym_abstract] = ACTIONS(500),
    [anon_sym_class] = ACTIONS(500),
    [anon_sym_extends] = ACTIONS(500),
    [anon_sym_implements] = ACTIONS(500),
    [anon_sym_interface] = ACTIONS(500),
    [anon_sym_typedef] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(500),
    [anon_sym_var] = ACTIONS(500),
    [aux_sym_integer_token1] = ACTIONS(500),
    [aux_sym_integer_token2] = ACTIONS(498),
    [aux_sym_float_token1] = ACTIONS(500),
    [aux_sym_float_token2] = ACTIONS(498),
    [anon_sym_true] = ACTIONS(500),
    [anon_sym_false] = ACTIONS(500),
    [aux_sym_string_token1] = ACTIONS(498),
    [aux_sym_string_token3] = ACTIONS(498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(500),
    [anon_sym_catch] = ACTIONS(500),
    [anon_sym_continue] = ACTIONS(500),
    [anon_sym_do] = ACTIONS(500),
    [anon_sym_enum] = ACTIONS(500),
    [anon_sym_extern] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_inline] = ACTIONS(500),
    [anon_sym_macro] = ACTIONS(500),
    [anon_sym_operator] = ACTIONS(500),
    [anon_sym_overload] = ACTIONS(500),
    [anon_sym_override] = ACTIONS(500),
    [anon_sym_private] = ACTIONS(500),
    [anon_sym_public] = ACTIONS(500),
    [anon_sym_return] = ACTIONS(500),
    [anon_sym_static] = ACTIONS(500),
    [anon_sym_try] = ACTIONS(500),
    [anon_sym_untyped] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(500),
    [sym__semicolon] = ACTIONS(498),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(502),
    [sym_identifier] = ACTIONS(504),
    [anon_sym_POUND] = ACTIONS(502),
    [anon_sym_package] = ACTIONS(504),
    [anon_sym_import] = ACTIONS(504),
    [anon_sym_using] = ACTIONS(504),
    [anon_sym_throw] = ACTIONS(504),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_RPAREN] = ACTIONS(502),
    [anon_sym_switch] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_case] = ACTIONS(504),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_default] = ACTIONS(504),
    [anon_sym_cast] = ACTIONS(504),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_DOLLARtype] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(504),
    [anon_sym_LBRACK] = ACTIONS(502),
    [anon_sym_RBRACK] = ACTIONS(502),
    [anon_sym_this] = ACTIONS(504),
    [anon_sym_DOT] = ACTIONS(504),
    [anon_sym_QMARK] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(504),
    [anon_sym_AT_COLON] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_else] = ACTIONS(504),
    [anon_sym_new] = ACTIONS(504),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_BANG] = ACTIONS(504),
    [anon_sym_DASH] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(502),
    [anon_sym_DASH_DASH] = ACTIONS(502),
    [anon_sym_PERCENT] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(502),
    [anon_sym_SLASH] = ACTIONS(504),
    [anon_sym_PLUS] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(502),
    [anon_sym_GT_GT] = ACTIONS(504),
    [anon_sym_GT_GT_GT] = ACTIONS(502),
    [anon_sym_AMP] = ACTIONS(504),
    [anon_sym_PIPE] = ACTIONS(504),
    [anon_sym_CARET] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_PIPE_PIPE] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_EQ_GT] = ACTIONS(502),
    [anon_sym_QMARK_QMARK] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [sym__rangeOperator] = ACTIONS(502),
    [anon_sym_null] = ACTIONS(504),
    [anon_sym_dynamic] = ACTIONS(504),
    [anon_sym_final] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(504),
    [anon_sym_class] = ACTIONS(504),
    [anon_sym_extends] = ACTIONS(504),
    [anon_sym_implements] = ACTIONS(504),
    [anon_sym_interface] = ACTIONS(504),
    [anon_sym_typedef] = ACTIONS(504),
    [anon_sym_function] = ACTIONS(504),
    [anon_sym_var] = ACTIONS(504),
    [aux_sym_integer_token1] = ACTIONS(504),
    [aux_sym_integer_token2] = ACTIONS(502),
    [aux_sym_float_token1] = ACTIONS(504),
    [aux_sym_float_token2] = ACTIONS(502),
    [anon_sym_true] = ACTIONS(504),
    [anon_sym_false] = ACTIONS(504),
    [aux_sym_string_token1] = ACTIONS(502),
    [aux_sym_string_token3] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(504),
    [anon_sym_catch] = ACTIONS(504),
    [anon_sym_continue] = ACTIONS(504),
    [anon_sym_do] = ACTIONS(504),
    [anon_sym_enum] = ACTIONS(504),
    [anon_sym_extern] = ACTIONS(504),
    [anon_sym_for] = ACTIONS(504),
    [anon_sym_inline] = ACTIONS(504),
    [anon_sym_macro] = ACTIONS(504),
    [anon_sym_operator] = ACTIONS(504),
    [anon_sym_overload] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(504),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_try] = ACTIONS(504),
    [anon_sym_untyped] = ACTIONS(504),
    [anon_sym_while] = ACTIONS(504),
    [sym__semicolon] = ACTIONS(502),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(506),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_QMARK] = ACTIONS(508),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(506),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(510),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_POUND] = ACTIONS(510),
    [anon_sym_package] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(512),
    [anon_sym_throw] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(510),
    [anon_sym_RPAREN] = ACTIONS(510),
    [anon_sym_switch] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(510),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_case] = ACTIONS(512),
    [anon_sym_COLON] = ACTIONS(510),
    [anon_sym_default] = ACTIONS(512),
    [anon_sym_cast] = ACTIONS(512),
    [anon_sym_COMMA] = ACTIONS(510),
    [anon_sym_DOLLARtype] = ACTIONS(510),
    [anon_sym_in] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(510),
    [anon_sym_this] = ACTIONS(512),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_QMARK] = ACTIONS(512),
    [anon_sym_AT] = ACTIONS(512),
    [anon_sym_AT_COLON] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(512),
    [anon_sym_else] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_DASH] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(510),
    [anon_sym_DASH_DASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(510),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_PLUS] = ACTIONS(512),
    [anon_sym_LT_LT] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(512),
    [anon_sym_GT_GT_GT] = ACTIONS(510),
    [anon_sym_AMP] = ACTIONS(512),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_CARET] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(510),
    [anon_sym_PIPE_PIPE] = ACTIONS(510),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_LT_EQ] = ACTIONS(510),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_EQ] = ACTIONS(510),
    [anon_sym_EQ_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(510),
    [anon_sym_EQ] = ACTIONS(512),
    [sym__rangeOperator] = ACTIONS(510),
    [anon_sym_null] = ACTIONS(512),
    [anon_sym_dynamic] = ACTIONS(512),
    [anon_sym_final] = ACTIONS(512),
    [anon_sym_abstract] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(512),
    [anon_sym_extends] = ACTIONS(512),
    [anon_sym_implements] = ACTIONS(512),
    [anon_sym_interface] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(512),
    [anon_sym_function] = ACTIONS(512),
    [anon_sym_var] = ACTIONS(512),
    [aux_sym_integer_token1] = ACTIONS(512),
    [aux_sym_integer_token2] = ACTIONS(510),
    [aux_sym_float_token1] = ACTIONS(512),
    [aux_sym_float_token2] = ACTIONS(510),
    [anon_sym_true] = ACTIONS(512),
    [anon_sym_false] = ACTIONS(512),
    [aux_sym_string_token1] = ACTIONS(510),
    [aux_sym_string_token3] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(512),
    [anon_sym_catch] = ACTIONS(512),
    [anon_sym_continue] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(512),
    [anon_sym_enum] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(512),
    [anon_sym_for] = ACTIONS(512),
    [anon_sym_inline] = ACTIONS(512),
    [anon_sym_macro] = ACTIONS(512),
    [anon_sym_operator] = ACTIONS(512),
    [anon_sym_overload] = ACTIONS(512),
    [anon_sym_override] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_return] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(512),
    [anon_sym_try] = ACTIONS(512),
    [anon_sym_untyped] = ACTIONS(512),
    [anon_sym_while] = ACTIONS(512),
    [sym__semicolon] = ACTIONS(510),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(514),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(514),
    [anon_sym_package] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(517),
    [anon_sym_using] = ACTIONS(517),
    [anon_sym_throw] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(514),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_case] = ACTIONS(517),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_cast] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_DOLLARtype] = ACTIONS(514),
    [anon_sym_in] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(514),
    [anon_sym_RBRACK] = ACTIONS(514),
    [anon_sym_this] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_AT_COLON] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_else] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(514),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(514),
    [anon_sym_DASH_DASH] = ACTIONS(514),
    [anon_sym_PERCENT] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(514),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(514),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_GT_GT_GT] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_EQ_EQ] = ACTIONS(514),
    [anon_sym_BANG_EQ] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(514),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_GT_EQ] = ACTIONS(514),
    [anon_sym_EQ_GT] = ACTIONS(514),
    [anon_sym_QMARK_QMARK] = ACTIONS(514),
    [anon_sym_EQ] = ACTIONS(517),
    [sym__rangeOperator] = ACTIONS(514),
    [anon_sym_null] = ACTIONS(517),
    [anon_sym_dynamic] = ACTIONS(517),
    [anon_sym_final] = ACTIONS(517),
    [anon_sym_abstract] = ACTIONS(517),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_extends] = ACTIONS(517),
    [anon_sym_implements] = ACTIONS(517),
    [anon_sym_interface] = ACTIONS(517),
    [anon_sym_typedef] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_var] = ACTIONS(517),
    [aux_sym_integer_token1] = ACTIONS(517),
    [aux_sym_integer_token2] = ACTIONS(514),
    [aux_sym_float_token1] = ACTIONS(517),
    [aux_sym_float_token2] = ACTIONS(514),
    [anon_sym_true] = ACTIONS(517),
    [anon_sym_false] = ACTIONS(517),
    [aux_sym_string_token1] = ACTIONS(514),
    [aux_sym_string_token3] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(517),
    [anon_sym_catch] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(517),
    [anon_sym_do] = ACTIONS(517),
    [anon_sym_enum] = ACTIONS(517),
    [anon_sym_extern] = ACTIONS(517),
    [anon_sym_for] = ACTIONS(517),
    [anon_sym_inline] = ACTIONS(517),
    [anon_sym_macro] = ACTIONS(517),
    [anon_sym_operator] = ACTIONS(517),
    [anon_sym_overload] = ACTIONS(517),
    [anon_sym_override] = ACTIONS(517),
    [anon_sym_private] = ACTIONS(517),
    [anon_sym_public] = ACTIONS(517),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_static] = ACTIONS(517),
    [anon_sym_try] = ACTIONS(517),
    [anon_sym_untyped] = ACTIONS(517),
    [anon_sym_while] = ACTIONS(517),
    [sym__semicolon] = ACTIONS(514),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(520),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_POUND] = ACTIONS(520),
    [anon_sym_package] = ACTIONS(522),
    [anon_sym_import] = ACTIONS(522),
    [anon_sym_using] = ACTIONS(522),
    [anon_sym_throw] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_switch] = ACTIONS(522),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_case] = ACTIONS(522),
    [anon_sym_COLON] = ACTIONS(520),
    [anon_sym_default] = ACTIONS(522),
    [anon_sym_cast] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(520),
    [anon_sym_DOLLARtype] = ACTIONS(520),
    [anon_sym_in] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(520),
    [anon_sym_RBRACK] = ACTIONS(520),
    [anon_sym_this] = ACTIONS(522),
    [anon_sym_DOT] = ACTIONS(522),
    [anon_sym_QMARK] = ACTIONS(522),
    [anon_sym_AT] = ACTIONS(522),
    [anon_sym_AT_COLON] = ACTIONS(520),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_new] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_BANG] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_PLUS_PLUS] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(520),
    [anon_sym_PERCENT] = ACTIONS(520),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_SLASH] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_GT_GT_GT] = ACTIONS(520),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(522),
    [anon_sym_CARET] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(520),
    [anon_sym_PIPE_PIPE] = ACTIONS(520),
    [anon_sym_EQ_EQ] = ACTIONS(520),
    [anon_sym_BANG_EQ] = ACTIONS(520),
    [anon_sym_LT] = ACTIONS(522),
    [anon_sym_LT_EQ] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(520),
    [anon_sym_EQ_GT] = ACTIONS(520),
    [anon_sym_QMARK_QMARK] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(522),
    [sym__rangeOperator] = ACTIONS(520),
    [anon_sym_null] = ACTIONS(522),
    [anon_sym_dynamic] = ACTIONS(522),
    [anon_sym_final] = ACTIONS(522),
    [anon_sym_abstract] = ACTIONS(522),
    [anon_sym_class] = ACTIONS(522),
    [anon_sym_extends] = ACTIONS(522),
    [anon_sym_implements] = ACTIONS(522),
    [anon_sym_interface] = ACTIONS(522),
    [anon_sym_typedef] = ACTIONS(522),
    [anon_sym_function] = ACTIONS(522),
    [anon_sym_var] = ACTIONS(522),
    [aux_sym_integer_token1] = ACTIONS(522),
    [aux_sym_integer_token2] = ACTIONS(520),
    [aux_sym_float_token1] = ACTIONS(522),
    [aux_sym_float_token2] = ACTIONS(520),
    [anon_sym_true] = ACTIONS(522),
    [anon_sym_false] = ACTIONS(522),
    [aux_sym_string_token1] = ACTIONS(520),
    [aux_sym_string_token3] = ACTIONS(520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(522),
    [anon_sym_catch] = ACTIONS(522),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_do] = ACTIONS(522),
    [anon_sym_enum] = ACTIONS(522),
    [anon_sym_extern] = ACTIONS(522),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_inline] = ACTIONS(522),
    [anon_sym_macro] = ACTIONS(522),
    [anon_sym_operator] = ACTIONS(522),
    [anon_sym_overload] = ACTIONS(522),
    [anon_sym_override] = ACTIONS(522),
    [anon_sym_private] = ACTIONS(522),
    [anon_sym_public] = ACTIONS(522),
    [anon_sym_return] = ACTIONS(522),
    [anon_sym_static] = ACTIONS(522),
    [anon_sym_try] = ACTIONS(522),
    [anon_sym_untyped] = ACTIONS(522),
    [anon_sym_while] = ACTIONS(522),
    [sym__semicolon] = ACTIONS(520),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(524),
    [sym_identifier] = ACTIONS(526),
    [anon_sym_POUND] = ACTIONS(524),
    [anon_sym_package] = ACTIONS(526),
    [anon_sym_import] = ACTIONS(526),
    [anon_sym_using] = ACTIONS(526),
    [anon_sym_throw] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_RPAREN] = ACTIONS(524),
    [anon_sym_switch] = ACTIONS(526),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_case] = ACTIONS(526),
    [anon_sym_COLON] = ACTIONS(524),
    [anon_sym_default] = ACTIONS(526),
    [anon_sym_cast] = ACTIONS(526),
    [anon_sym_COMMA] = ACTIONS(524),
    [anon_sym_DOLLARtype] = ACTIONS(524),
    [anon_sym_in] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_RBRACK] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(526),
    [anon_sym_DOT] = ACTIONS(526),
    [anon_sym_QMARK] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_AT_COLON] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_else] = ACTIONS(526),
    [anon_sym_new] = ACTIONS(526),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_BANG] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(526),
    [anon_sym_PLUS] = ACTIONS(526),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(526),
    [anon_sym_GT_GT_GT] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(526),
    [anon_sym_PIPE] = ACTIONS(526),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_AMP_AMP] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(524),
    [anon_sym_BANG_EQ] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(526),
    [anon_sym_LT_EQ] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(526),
    [anon_sym_GT_EQ] = ACTIONS(524),
    [anon_sym_EQ_GT] = ACTIONS(524),
    [anon_sym_QMARK_QMARK] = ACTIONS(524),
    [anon_sym_EQ] = ACTIONS(526),
    [sym__rangeOperator] = ACTIONS(524),
    [anon_sym_null] = ACTIONS(526),
    [anon_sym_dynamic] = ACTIONS(526),
    [anon_sym_final] = ACTIONS(526),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_class] = ACTIONS(526),
    [anon_sym_extends] = ACTIONS(526),
    [anon_sym_implements] = ACTIONS(526),
    [anon_sym_interface] = ACTIONS(526),
    [anon_sym_typedef] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(526),
    [anon_sym_var] = ACTIONS(526),
    [aux_sym_integer_token1] = ACTIONS(526),
    [aux_sym_integer_token2] = ACTIONS(524),
    [aux_sym_float_token1] = ACTIONS(526),
    [aux_sym_float_token2] = ACTIONS(524),
    [anon_sym_true] = ACTIONS(526),
    [anon_sym_false] = ACTIONS(526),
    [aux_sym_string_token1] = ACTIONS(524),
    [aux_sym_string_token3] = ACTIONS(524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(526),
    [anon_sym_catch] = ACTIONS(526),
    [anon_sym_continue] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(526),
    [anon_sym_enum] = ACTIONS(526),
    [anon_sym_extern] = ACTIONS(526),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_inline] = ACTIONS(526),
    [anon_sym_macro] = ACTIONS(526),
    [anon_sym_operator] = ACTIONS(526),
    [anon_sym_overload] = ACTIONS(526),
    [anon_sym_override] = ACTIONS(526),
    [anon_sym_private] = ACTIONS(526),
    [anon_sym_public] = ACTIONS(526),
    [anon_sym_return] = ACTIONS(526),
    [anon_sym_static] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(526),
    [anon_sym_untyped] = ACTIONS(526),
    [anon_sym_while] = ACTIONS(526),
    [sym__semicolon] = ACTIONS(524),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_POUND] = ACTIONS(240),
    [anon_sym_package] = ACTIONS(242),
    [anon_sym_import] = ACTIONS(242),
    [anon_sym_using] = ACTIONS(242),
    [anon_sym_throw] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_RPAREN] = ACTIONS(240),
    [anon_sym_switch] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_case] = ACTIONS(242),
    [anon_sym_COLON] = ACTIONS(240),
    [anon_sym_default] = ACTIONS(242),
    [anon_sym_cast] = ACTIONS(242),
    [anon_sym_COMMA] = ACTIONS(240),
    [anon_sym_DOLLARtype] = ACTIONS(240),
    [anon_sym_in] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_RBRACK] = ACTIONS(240),
    [anon_sym_this] = ACTIONS(242),
    [anon_sym_DOT] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_AT_COLON] = ACTIONS(240),
    [anon_sym_if] = ACTIONS(242),
    [anon_sym_else] = ACTIONS(242),
    [anon_sym_new] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_PERCENT] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_SLASH] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LT_LT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(242),
    [anon_sym_GT_GT_GT] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_EQ_EQ] = ACTIONS(240),
    [anon_sym_BANG_EQ] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(242),
    [anon_sym_LT_EQ] = ACTIONS(240),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_GT_EQ] = ACTIONS(240),
    [anon_sym_EQ_GT] = ACTIONS(240),
    [anon_sym_QMARK_QMARK] = ACTIONS(240),
    [anon_sym_EQ] = ACTIONS(242),
    [sym__rangeOperator] = ACTIONS(240),
    [anon_sym_null] = ACTIONS(242),
    [anon_sym_dynamic] = ACTIONS(242),
    [anon_sym_final] = ACTIONS(242),
    [anon_sym_abstract] = ACTIONS(242),
    [anon_sym_class] = ACTIONS(242),
    [anon_sym_extends] = ACTIONS(242),
    [anon_sym_implements] = ACTIONS(242),
    [anon_sym_interface] = ACTIONS(242),
    [anon_sym_typedef] = ACTIONS(242),
    [anon_sym_function] = ACTIONS(242),
    [anon_sym_var] = ACTIONS(242),
    [aux_sym_integer_token1] = ACTIONS(242),
    [aux_sym_integer_token2] = ACTIONS(240),
    [aux_sym_float_token1] = ACTIONS(242),
    [aux_sym_float_token2] = ACTIONS(240),
    [anon_sym_true] = ACTIONS(242),
    [anon_sym_false] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(240),
    [aux_sym_string_token3] = ACTIONS(240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(242),
    [anon_sym_catch] = ACTIONS(242),
    [anon_sym_continue] = ACTIONS(242),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_enum] = ACTIONS(242),
    [anon_sym_extern] = ACTIONS(242),
    [anon_sym_for] = ACTIONS(242),
    [anon_sym_inline] = ACTIONS(242),
    [anon_sym_macro] = ACTIONS(242),
    [anon_sym_operator] = ACTIONS(242),
    [anon_sym_overload] = ACTIONS(242),
    [anon_sym_override] = ACTIONS(242),
    [anon_sym_private] = ACTIONS(242),
    [anon_sym_public] = ACTIONS(242),
    [anon_sym_return] = ACTIONS(242),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(242),
    [anon_sym_untyped] = ACTIONS(242),
    [anon_sym_while] = ACTIONS(242),
    [sym__semicolon] = ACTIONS(240),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(528),
    [sym_identifier] = ACTIONS(530),
    [anon_sym_POUND] = ACTIONS(528),
    [anon_sym_package] = ACTIONS(530),
    [anon_sym_import] = ACTIONS(530),
    [anon_sym_using] = ACTIONS(530),
    [anon_sym_throw] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(528),
    [anon_sym_RPAREN] = ACTIONS(528),
    [anon_sym_switch] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_case] = ACTIONS(530),
    [anon_sym_COLON] = ACTIONS(528),
    [anon_sym_default] = ACTIONS(530),
    [anon_sym_cast] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(528),
    [anon_sym_DOLLARtype] = ACTIONS(528),
    [anon_sym_in] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(528),
    [anon_sym_RBRACK] = ACTIONS(528),
    [anon_sym_this] = ACTIONS(530),
    [anon_sym_DOT] = ACTIONS(530),
    [anon_sym_QMARK] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(530),
    [anon_sym_AT_COLON] = ACTIONS(528),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_else] = ACTIONS(530),
    [anon_sym_new] = ACTIONS(530),
    [anon_sym_TILDE] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(530),
    [anon_sym_DASH] = ACTIONS(530),
    [anon_sym_PLUS_PLUS] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_SLASH] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_GT_GT_GT] = ACTIONS(528),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(530),
    [anon_sym_CARET] = ACTIONS(528),
    [anon_sym_AMP_AMP] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(528),
    [anon_sym_EQ_EQ] = ACTIONS(528),
    [anon_sym_BANG_EQ] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(530),
    [anon_sym_LT_EQ] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(528),
    [anon_sym_EQ_GT] = ACTIONS(528),
    [anon_sym_QMARK_QMARK] = ACTIONS(528),
    [anon_sym_EQ] = ACTIONS(530),
    [sym__rangeOperator] = ACTIONS(528),
    [anon_sym_null] = ACTIONS(530),
    [anon_sym_dynamic] = ACTIONS(530),
    [anon_sym_final] = ACTIONS(530),
    [anon_sym_abstract] = ACTIONS(530),
    [anon_sym_class] = ACTIONS(530),
    [anon_sym_extends] = ACTIONS(530),
    [anon_sym_implements] = ACTIONS(530),
    [anon_sym_interface] = ACTIONS(530),
    [anon_sym_typedef] = ACTIONS(530),
    [anon_sym_function] = ACTIONS(530),
    [anon_sym_var] = ACTIONS(530),
    [aux_sym_integer_token1] = ACTIONS(530),
    [aux_sym_integer_token2] = ACTIONS(528),
    [aux_sym_float_token1] = ACTIONS(530),
    [aux_sym_float_token2] = ACTIONS(528),
    [anon_sym_true] = ACTIONS(530),
    [anon_sym_false] = ACTIONS(530),
    [aux_sym_string_token1] = ACTIONS(528),
    [aux_sym_string_token3] = ACTIONS(528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(530),
    [anon_sym_catch] = ACTIONS(530),
    [anon_sym_continue] = ACTIONS(530),
    [anon_sym_do] = ACTIONS(530),
    [anon_sym_enum] = ACTIONS(530),
    [anon_sym_extern] = ACTIONS(530),
    [anon_sym_for] = ACTIONS(530),
    [anon_sym_inline] = ACTIONS(530),
    [anon_sym_macro] = ACTIONS(530),
    [anon_sym_operator] = ACTIONS(530),
    [anon_sym_overload] = ACTIONS(530),
    [anon_sym_override] = ACTIONS(530),
    [anon_sym_private] = ACTIONS(530),
    [anon_sym_public] = ACTIONS(530),
    [anon_sym_return] = ACTIONS(530),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_try] = ACTIONS(530),
    [anon_sym_untyped] = ACTIONS(530),
    [anon_sym_while] = ACTIONS(530),
    [sym__semicolon] = ACTIONS(528),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(532),
    [sym_identifier] = ACTIONS(534),
    [anon_sym_POUND] = ACTIONS(532),
    [anon_sym_package] = ACTIONS(534),
    [anon_sym_import] = ACTIONS(534),
    [anon_sym_using] = ACTIONS(534),
    [anon_sym_throw] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(532),
    [anon_sym_RPAREN] = ACTIONS(532),
    [anon_sym_switch] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(532),
    [anon_sym_RBRACE] = ACTIONS(532),
    [anon_sym_case] = ACTIONS(534),
    [anon_sym_COLON] = ACTIONS(532),
    [anon_sym_default] = ACTIONS(534),
    [anon_sym_cast] = ACTIONS(534),
    [anon_sym_COMMA] = ACTIONS(532),
    [anon_sym_DOLLARtype] = ACTIONS(532),
    [anon_sym_in] = ACTIONS(534),
    [anon_sym_LBRACK] = ACTIONS(532),
    [anon_sym_RBRACK] = ACTIONS(532),
    [anon_sym_this] = ACTIONS(534),
    [anon_sym_DOT] = ACTIONS(534),
    [anon_sym_QMARK] = ACTIONS(534),
    [anon_sym_AT] = ACTIONS(534),
    [anon_sym_AT_COLON] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(534),
    [anon_sym_else] = ACTIONS(534),
    [anon_sym_new] = ACTIONS(534),
    [anon_sym_TILDE] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(534),
    [anon_sym_DASH] = ACTIONS(534),
    [anon_sym_PLUS_PLUS] = ACTIONS(532),
    [anon_sym_DASH_DASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_SLASH] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(534),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(534),
    [anon_sym_GT_GT_GT] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(534),
    [anon_sym_PIPE] = ACTIONS(534),
    [anon_sym_CARET] = ACTIONS(532),
    [anon_sym_AMP_AMP] = ACTIONS(532),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_EQ_EQ] = ACTIONS(532),
    [anon_sym_BANG_EQ] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(534),
    [anon_sym_LT_EQ] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(532),
    [anon_sym_EQ_GT] = ACTIONS(532),
    [anon_sym_QMARK_QMARK] = ACTIONS(532),
    [anon_sym_EQ] = ACTIONS(534),
    [sym__rangeOperator] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(534),
    [anon_sym_dynamic] = ACTIONS(534),
    [anon_sym_final] = ACTIONS(534),
    [anon_sym_abstract] = ACTIONS(534),
    [anon_sym_class] = ACTIONS(534),
    [anon_sym_extends] = ACTIONS(534),
    [anon_sym_implements] = ACTIONS(534),
    [anon_sym_interface] = ACTIONS(534),
    [anon_sym_typedef] = ACTIONS(534),
    [anon_sym_function] = ACTIONS(534),
    [anon_sym_var] = ACTIONS(534),
    [aux_sym_integer_token1] = ACTIONS(534),
    [aux_sym_integer_token2] = ACTIONS(532),
    [aux_sym_float_token1] = ACTIONS(534),
    [aux_sym_float_token2] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(534),
    [anon_sym_false] = ACTIONS(534),
    [aux_sym_string_token1] = ACTIONS(532),
    [aux_sym_string_token3] = ACTIONS(532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(534),
    [anon_sym_catch] = ACTIONS(534),
    [anon_sym_continue] = ACTIONS(534),
    [anon_sym_do] = ACTIONS(534),
    [anon_sym_enum] = ACTIONS(534),
    [anon_sym_extern] = ACTIONS(534),
    [anon_sym_for] = ACTIONS(534),
    [anon_sym_inline] = ACTIONS(534),
    [anon_sym_macro] = ACTIONS(534),
    [anon_sym_operator] = ACTIONS(534),
    [anon_sym_overload] = ACTIONS(534),
    [anon_sym_override] = ACTIONS(534),
    [anon_sym_private] = ACTIONS(534),
    [anon_sym_public] = ACTIONS(534),
    [anon_sym_return] = ACTIONS(534),
    [anon_sym_static] = ACTIONS(534),
    [anon_sym_try] = ACTIONS(534),
    [anon_sym_untyped] = ACTIONS(534),
    [anon_sym_while] = ACTIONS(534),
    [sym__semicolon] = ACTIONS(532),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_POUND] = ACTIONS(536),
    [anon_sym_package] = ACTIONS(538),
    [anon_sym_import] = ACTIONS(538),
    [anon_sym_using] = ACTIONS(538),
    [anon_sym_throw] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_RPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_case] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_default] = ACTIONS(538),
    [anon_sym_cast] = ACTIONS(538),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_DOLLARtype] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_this] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(538),
    [anon_sym_AT_COLON] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_new] = ACTIONS(538),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_DASH_DASH] = ACTIONS(536),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(536),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_GT_GT_GT] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_AMP_AMP] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_QMARK_QMARK] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [sym__rangeOperator] = ACTIONS(536),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_dynamic] = ACTIONS(538),
    [anon_sym_final] = ACTIONS(538),
    [anon_sym_abstract] = ACTIONS(538),
    [anon_sym_class] = ACTIONS(538),
    [anon_sym_extends] = ACTIONS(538),
    [anon_sym_implements] = ACTIONS(538),
    [anon_sym_interface] = ACTIONS(538),
    [anon_sym_typedef] = ACTIONS(538),
    [anon_sym_function] = ACTIONS(538),
    [anon_sym_var] = ACTIONS(538),
    [aux_sym_integer_token1] = ACTIONS(538),
    [aux_sym_integer_token2] = ACTIONS(536),
    [aux_sym_float_token1] = ACTIONS(538),
    [aux_sym_float_token2] = ACTIONS(536),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [aux_sym_string_token1] = ACTIONS(536),
    [aux_sym_string_token3] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_do] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_macro] = ACTIONS(538),
    [anon_sym_operator] = ACTIONS(538),
    [anon_sym_overload] = ACTIONS(538),
    [anon_sym_override] = ACTIONS(538),
    [anon_sym_private] = ACTIONS(538),
    [anon_sym_public] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_static] = ACTIONS(538),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_untyped] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [sym__semicolon] = ACTIONS(536),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(540),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_POUND] = ACTIONS(540),
    [anon_sym_package] = ACTIONS(542),
    [anon_sym_import] = ACTIONS(542),
    [anon_sym_using] = ACTIONS(542),
    [anon_sym_throw] = ACTIONS(542),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_switch] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(540),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_case] = ACTIONS(542),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_default] = ACTIONS(542),
    [anon_sym_cast] = ACTIONS(542),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_DOLLARtype] = ACTIONS(540),
    [anon_sym_in] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(540),
    [anon_sym_RBRACK] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(542),
    [anon_sym_DOT] = ACTIONS(542),
    [anon_sym_QMARK] = ACTIONS(542),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_AT_COLON] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(542),
    [anon_sym_else] = ACTIONS(542),
    [anon_sym_new] = ACTIONS(542),
    [anon_sym_TILDE] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(540),
    [anon_sym_DASH_DASH] = ACTIONS(540),
    [anon_sym_PERCENT] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_SLASH] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_GT_GT_GT] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_CARET] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_LT_EQ] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_GT_EQ] = ACTIONS(540),
    [anon_sym_EQ_GT] = ACTIONS(540),
    [anon_sym_QMARK_QMARK] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(542),
    [sym__rangeOperator] = ACTIONS(540),
    [anon_sym_null] = ACTIONS(542),
    [anon_sym_dynamic] = ACTIONS(542),
    [anon_sym_final] = ACTIONS(542),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_class] = ACTIONS(542),
    [anon_sym_extends] = ACTIONS(542),
    [anon_sym_implements] = ACTIONS(542),
    [anon_sym_interface] = ACTIONS(542),
    [anon_sym_typedef] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(542),
    [anon_sym_var] = ACTIONS(542),
    [aux_sym_integer_token1] = ACTIONS(542),
    [aux_sym_integer_token2] = ACTIONS(540),
    [aux_sym_float_token1] = ACTIONS(542),
    [aux_sym_float_token2] = ACTIONS(540),
    [anon_sym_true] = ACTIONS(542),
    [anon_sym_false] = ACTIONS(542),
    [aux_sym_string_token1] = ACTIONS(540),
    [aux_sym_string_token3] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(542),
    [anon_sym_catch] = ACTIONS(542),
    [anon_sym_continue] = ACTIONS(542),
    [anon_sym_do] = ACTIONS(542),
    [anon_sym_enum] = ACTIONS(542),
    [anon_sym_extern] = ACTIONS(542),
    [anon_sym_for] = ACTIONS(542),
    [anon_sym_inline] = ACTIONS(542),
    [anon_sym_macro] = ACTIONS(542),
    [anon_sym_operator] = ACTIONS(542),
    [anon_sym_overload] = ACTIONS(542),
    [anon_sym_override] = ACTIONS(542),
    [anon_sym_private] = ACTIONS(542),
    [anon_sym_public] = ACTIONS(542),
    [anon_sym_return] = ACTIONS(542),
    [anon_sym_static] = ACTIONS(542),
    [anon_sym_try] = ACTIONS(542),
    [anon_sym_untyped] = ACTIONS(542),
    [anon_sym_while] = ACTIONS(542),
    [sym__semicolon] = ACTIONS(540),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_POUND] = ACTIONS(544),
    [anon_sym_package] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_using] = ACTIONS(546),
    [anon_sym_throw] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_switch] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(544),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_case] = ACTIONS(546),
    [anon_sym_COLON] = ACTIONS(544),
    [anon_sym_default] = ACTIONS(546),
    [anon_sym_cast] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(544),
    [anon_sym_DOLLARtype] = ACTIONS(544),
    [anon_sym_in] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(544),
    [anon_sym_RBRACK] = ACTIONS(544),
    [anon_sym_this] = ACTIONS(546),
    [anon_sym_DOT] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(546),
    [anon_sym_AT_COLON] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_else] = ACTIONS(546),
    [anon_sym_new] = ACTIONS(546),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_DASH] = ACTIONS(546),
    [anon_sym_PLUS_PLUS] = ACTIONS(544),
    [anon_sym_DASH_DASH] = ACTIONS(544),
    [anon_sym_PERCENT] = ACTIONS(544),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_SLASH] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(546),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_GT_GT_GT] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_PIPE] = ACTIONS(546),
    [anon_sym_CARET] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_EQ_EQ] = ACTIONS(544),
    [anon_sym_BANG_EQ] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(546),
    [anon_sym_LT_EQ] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(546),
    [anon_sym_GT_EQ] = ACTIONS(544),
    [anon_sym_EQ_GT] = ACTIONS(544),
    [anon_sym_QMARK_QMARK] = ACTIONS(544),
    [anon_sym_EQ] = ACTIONS(546),
    [sym__rangeOperator] = ACTIONS(544),
    [anon_sym_null] = ACTIONS(546),
    [anon_sym_dynamic] = ACTIONS(546),
    [anon_sym_final] = ACTIONS(546),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_extends] = ACTIONS(546),
    [anon_sym_implements] = ACTIONS(546),
    [anon_sym_interface] = ACTIONS(546),
    [anon_sym_typedef] = ACTIONS(546),
    [anon_sym_function] = ACTIONS(546),
    [anon_sym_var] = ACTIONS(546),
    [aux_sym_integer_token1] = ACTIONS(546),
    [aux_sym_integer_token2] = ACTIONS(544),
    [aux_sym_float_token1] = ACTIONS(546),
    [aux_sym_float_token2] = ACTIONS(544),
    [anon_sym_true] = ACTIONS(546),
    [anon_sym_false] = ACTIONS(546),
    [aux_sym_string_token1] = ACTIONS(544),
    [aux_sym_string_token3] = ACTIONS(544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_catch] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_do] = ACTIONS(546),
    [anon_sym_enum] = ACTIONS(546),
    [anon_sym_extern] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_inline] = ACTIONS(546),
    [anon_sym_macro] = ACTIONS(546),
    [anon_sym_operator] = ACTIONS(546),
    [anon_sym_overload] = ACTIONS(546),
    [anon_sym_override] = ACTIONS(546),
    [anon_sym_private] = ACTIONS(546),
    [anon_sym_public] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_static] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_untyped] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [sym__semicolon] = ACTIONS(544),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(548),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_POUND] = ACTIONS(548),
    [anon_sym_package] = ACTIONS(551),
    [anon_sym_import] = ACTIONS(551),
    [anon_sym_using] = ACTIONS(551),
    [anon_sym_throw] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(548),
    [anon_sym_RPAREN] = ACTIONS(548),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_case] = ACTIONS(551),
    [anon_sym_COLON] = ACTIONS(548),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_cast] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(548),
    [anon_sym_DOLLARtype] = ACTIONS(548),
    [anon_sym_in] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(548),
    [anon_sym_RBRACK] = ACTIONS(548),
    [anon_sym_this] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(551),
    [anon_sym_AT] = ACTIONS(551),
    [anon_sym_AT_COLON] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_new] = ACTIONS(551),
    [anon_sym_TILDE] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(548),
    [anon_sym_DASH_DASH] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(548),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_GT_GT_GT] = ACTIONS(548),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(548),
    [anon_sym_AMP_AMP] = ACTIONS(548),
    [anon_sym_PIPE_PIPE] = ACTIONS(548),
    [anon_sym_EQ_EQ] = ACTIONS(548),
    [anon_sym_BANG_EQ] = ACTIONS(548),
    [anon_sym_LT] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(551),
    [anon_sym_GT_EQ] = ACTIONS(548),
    [anon_sym_EQ_GT] = ACTIONS(548),
    [anon_sym_QMARK_QMARK] = ACTIONS(548),
    [anon_sym_EQ] = ACTIONS(551),
    [sym__rangeOperator] = ACTIONS(548),
    [anon_sym_null] = ACTIONS(551),
    [anon_sym_dynamic] = ACTIONS(551),
    [anon_sym_final] = ACTIONS(551),
    [anon_sym_abstract] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(551),
    [anon_sym_extends] = ACTIONS(551),
    [anon_sym_implements] = ACTIONS(551),
    [anon_sym_interface] = ACTIONS(551),
    [anon_sym_typedef] = ACTIONS(551),
    [anon_sym_function] = ACTIONS(551),
    [anon_sym_var] = ACTIONS(551),
    [aux_sym_integer_token1] = ACTIONS(551),
    [aux_sym_integer_token2] = ACTIONS(548),
    [aux_sym_float_token1] = ACTIONS(551),
    [aux_sym_float_token2] = ACTIONS(548),
    [anon_sym_true] = ACTIONS(551),
    [anon_sym_false] = ACTIONS(551),
    [aux_sym_string_token1] = ACTIONS(548),
    [aux_sym_string_token3] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(551),
    [anon_sym_catch] = ACTIONS(551),
    [anon_sym_continue] = ACTIONS(551),
    [anon_sym_do] = ACTIONS(551),
    [anon_sym_enum] = ACTIONS(551),
    [anon_sym_extern] = ACTIONS(551),
    [anon_sym_for] = ACTIONS(551),
    [anon_sym_inline] = ACTIONS(551),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_operator] = ACTIONS(551),
    [anon_sym_overload] = ACTIONS(551),
    [anon_sym_override] = ACTIONS(551),
    [anon_sym_private] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(551),
    [anon_sym_return] = ACTIONS(551),
    [anon_sym_static] = ACTIONS(551),
    [anon_sym_try] = ACTIONS(551),
    [anon_sym_untyped] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(551),
    [sym__semicolon] = ACTIONS(548),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(554),
    [sym_identifier] = ACTIONS(556),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_package] = ACTIONS(556),
    [anon_sym_import] = ACTIONS(556),
    [anon_sym_using] = ACTIONS(556),
    [anon_sym_throw] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(554),
    [anon_sym_switch] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_case] = ACTIONS(556),
    [anon_sym_COLON] = ACTIONS(554),
    [anon_sym_default] = ACTIONS(556),
    [anon_sym_cast] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_DOLLARtype] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_RBRACK] = ACTIONS(554),
    [anon_sym_this] = ACTIONS(556),
    [anon_sym_DOT] = ACTIONS(556),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_AT] = ACTIONS(556),
    [anon_sym_AT_COLON] = ACTIONS(554),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_else] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_SLASH] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(556),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_GT_GT_GT] = ACTIONS(554),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(554),
    [anon_sym_AMP_AMP] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG_EQ] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(556),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(554),
    [anon_sym_QMARK_QMARK] = ACTIONS(554),
    [anon_sym_EQ] = ACTIONS(556),
    [sym__rangeOperator] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(556),
    [anon_sym_dynamic] = ACTIONS(556),
    [anon_sym_final] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(556),
    [anon_sym_class] = ACTIONS(556),
    [anon_sym_extends] = ACTIONS(556),
    [anon_sym_implements] = ACTIONS(556),
    [anon_sym_interface] = ACTIONS(556),
    [anon_sym_typedef] = ACTIONS(556),
    [anon_sym_function] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(556),
    [aux_sym_integer_token1] = ACTIONS(556),
    [aux_sym_integer_token2] = ACTIONS(554),
    [aux_sym_float_token1] = ACTIONS(556),
    [aux_sym_float_token2] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(556),
    [anon_sym_false] = ACTIONS(556),
    [aux_sym_string_token1] = ACTIONS(554),
    [aux_sym_string_token3] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_catch] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_enum] = ACTIONS(556),
    [anon_sym_extern] = ACTIONS(556),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_inline] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(556),
    [anon_sym_operator] = ACTIONS(556),
    [anon_sym_overload] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(556),
    [anon_sym_untyped] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [sym__semicolon] = ACTIONS(554),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(558),
    [sym_identifier] = ACTIONS(560),
    [anon_sym_POUND] = ACTIONS(558),
    [anon_sym_package] = ACTIONS(560),
    [anon_sym_import] = ACTIONS(560),
    [anon_sym_using] = ACTIONS(560),
    [anon_sym_throw] = ACTIONS(560),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_switch] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_case] = ACTIONS(560),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_default] = ACTIONS(560),
    [anon_sym_cast] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_DOLLARtype] = ACTIONS(558),
    [anon_sym_in] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_this] = ACTIONS(560),
    [anon_sym_DOT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_AT] = ACTIONS(560),
    [anon_sym_AT_COLON] = ACTIONS(558),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_else] = ACTIONS(560),
    [anon_sym_new] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(560),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(560),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_GT_GT_GT] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_PIPE] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_AMP_AMP] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(560),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(558),
    [anon_sym_QMARK_QMARK] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(560),
    [sym__rangeOperator] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(560),
    [anon_sym_dynamic] = ACTIONS(560),
    [anon_sym_final] = ACTIONS(560),
    [anon_sym_abstract] = ACTIONS(560),
    [anon_sym_class] = ACTIONS(560),
    [anon_sym_extends] = ACTIONS(560),
    [anon_sym_implements] = ACTIONS(560),
    [anon_sym_interface] = ACTIONS(560),
    [anon_sym_typedef] = ACTIONS(560),
    [anon_sym_function] = ACTIONS(560),
    [anon_sym_var] = ACTIONS(560),
    [aux_sym_integer_token1] = ACTIONS(560),
    [aux_sym_integer_token2] = ACTIONS(558),
    [aux_sym_float_token1] = ACTIONS(560),
    [aux_sym_float_token2] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(560),
    [anon_sym_false] = ACTIONS(560),
    [aux_sym_string_token1] = ACTIONS(558),
    [aux_sym_string_token3] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(560),
    [anon_sym_catch] = ACTIONS(560),
    [anon_sym_continue] = ACTIONS(560),
    [anon_sym_do] = ACTIONS(560),
    [anon_sym_enum] = ACTIONS(560),
    [anon_sym_extern] = ACTIONS(560),
    [anon_sym_for] = ACTIONS(560),
    [anon_sym_inline] = ACTIONS(560),
    [anon_sym_macro] = ACTIONS(560),
    [anon_sym_operator] = ACTIONS(560),
    [anon_sym_overload] = ACTIONS(560),
    [anon_sym_override] = ACTIONS(560),
    [anon_sym_private] = ACTIONS(560),
    [anon_sym_public] = ACTIONS(560),
    [anon_sym_return] = ACTIONS(560),
    [anon_sym_static] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(560),
    [anon_sym_untyped] = ACTIONS(560),
    [anon_sym_while] = ACTIONS(560),
    [sym__semicolon] = ACTIONS(558),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(562),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_POUND] = ACTIONS(562),
    [anon_sym_package] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_using] = ACTIONS(564),
    [anon_sym_throw] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_case] = ACTIONS(564),
    [anon_sym_COLON] = ACTIONS(562),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_cast] = ACTIONS(564),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_DOLLARtype] = ACTIONS(562),
    [anon_sym_in] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(562),
    [anon_sym_this] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(564),
    [anon_sym_AT_COLON] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_GT_GT_GT] = ACTIONS(562),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(562),
    [anon_sym_AMP_AMP] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(562),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(562),
    [anon_sym_QMARK_QMARK] = ACTIONS(562),
    [anon_sym_EQ] = ACTIONS(564),
    [sym__rangeOperator] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(564),
    [anon_sym_dynamic] = ACTIONS(564),
    [anon_sym_final] = ACTIONS(564),
    [anon_sym_abstract] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_extends] = ACTIONS(564),
    [anon_sym_implements] = ACTIONS(564),
    [anon_sym_interface] = ACTIONS(564),
    [anon_sym_typedef] = ACTIONS(564),
    [anon_sym_function] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [aux_sym_integer_token1] = ACTIONS(564),
    [aux_sym_integer_token2] = ACTIONS(562),
    [aux_sym_float_token1] = ACTIONS(564),
    [aux_sym_float_token2] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(564),
    [aux_sym_string_token1] = ACTIONS(562),
    [aux_sym_string_token3] = ACTIONS(562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_catch] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_extern] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_inline] = ACTIONS(564),
    [anon_sym_macro] = ACTIONS(564),
    [anon_sym_operator] = ACTIONS(564),
    [anon_sym_overload] = ACTIONS(564),
    [anon_sym_override] = ACTIONS(564),
    [anon_sym_private] = ACTIONS(564),
    [anon_sym_public] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_static] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_untyped] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [sym__semicolon] = ACTIONS(562),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [sym_identifier] = ACTIONS(568),
    [anon_sym_POUND] = ACTIONS(566),
    [anon_sym_package] = ACTIONS(568),
    [anon_sym_import] = ACTIONS(568),
    [anon_sym_using] = ACTIONS(568),
    [anon_sym_throw] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(566),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_case] = ACTIONS(568),
    [anon_sym_COLON] = ACTIONS(566),
    [anon_sym_default] = ACTIONS(568),
    [anon_sym_cast] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_DOLLARtype] = ACTIONS(566),
    [anon_sym_in] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_RBRACK] = ACTIONS(566),
    [anon_sym_this] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_AT_COLON] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_new] = ACTIONS(568),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(566),
    [anon_sym_PERCENT] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_LT_LT] = ACTIONS(566),
    [anon_sym_GT_GT] = ACTIONS(568),
    [anon_sym_GT_GT_GT] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(566),
    [anon_sym_AMP_AMP] = ACTIONS(566),
    [anon_sym_PIPE_PIPE] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_EQ_GT] = ACTIONS(566),
    [anon_sym_QMARK_QMARK] = ACTIONS(566),
    [anon_sym_EQ] = ACTIONS(568),
    [sym__rangeOperator] = ACTIONS(566),
    [anon_sym_null] = ACTIONS(568),
    [anon_sym_dynamic] = ACTIONS(568),
    [anon_sym_final] = ACTIONS(568),
    [anon_sym_abstract] = ACTIONS(568),
    [anon_sym_class] = ACTIONS(568),
    [anon_sym_extends] = ACTIONS(568),
    [anon_sym_implements] = ACTIONS(568),
    [anon_sym_interface] = ACTIONS(568),
    [anon_sym_typedef] = ACTIONS(568),
    [anon_sym_function] = ACTIONS(568),
    [anon_sym_var] = ACTIONS(568),
    [aux_sym_integer_token1] = ACTIONS(568),
    [aux_sym_integer_token2] = ACTIONS(566),
    [aux_sym_float_token1] = ACTIONS(568),
    [aux_sym_float_token2] = ACTIONS(566),
    [anon_sym_true] = ACTIONS(568),
    [anon_sym_false] = ACTIONS(568),
    [aux_sym_string_token1] = ACTIONS(566),
    [aux_sym_string_token3] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(568),
    [anon_sym_catch] = ACTIONS(568),
    [anon_sym_continue] = ACTIONS(568),
    [anon_sym_do] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_extern] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_inline] = ACTIONS(568),
    [anon_sym_macro] = ACTIONS(568),
    [anon_sym_operator] = ACTIONS(568),
    [anon_sym_overload] = ACTIONS(568),
    [anon_sym_override] = ACTIONS(568),
    [anon_sym_private] = ACTIONS(568),
    [anon_sym_public] = ACTIONS(568),
    [anon_sym_return] = ACTIONS(568),
    [anon_sym_static] = ACTIONS(568),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_untyped] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [sym__semicolon] = ACTIONS(566),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(570),
    [sym_identifier] = ACTIONS(572),
    [anon_sym_POUND] = ACTIONS(570),
    [anon_sym_package] = ACTIONS(572),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_using] = ACTIONS(572),
    [anon_sym_throw] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(570),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_case] = ACTIONS(572),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_default] = ACTIONS(572),
    [anon_sym_cast] = ACTIONS(572),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_DOLLARtype] = ACTIONS(570),
    [anon_sym_in] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(570),
    [anon_sym_this] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(572),
    [anon_sym_AT_COLON] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(572),
    [anon_sym_new] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(570),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_DASH_DASH] = ACTIONS(570),
    [anon_sym_PERCENT] = ACTIONS(570),
    [anon_sym_STAR] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(570),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_GT_GT_GT] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_EQ_GT] = ACTIONS(570),
    [anon_sym_QMARK_QMARK] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(572),
    [sym__rangeOperator] = ACTIONS(570),
    [anon_sym_null] = ACTIONS(572),
    [anon_sym_dynamic] = ACTIONS(572),
    [anon_sym_final] = ACTIONS(572),
    [anon_sym_abstract] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(572),
    [anon_sym_extends] = ACTIONS(572),
    [anon_sym_implements] = ACTIONS(572),
    [anon_sym_interface] = ACTIONS(572),
    [anon_sym_typedef] = ACTIONS(572),
    [anon_sym_function] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(572),
    [aux_sym_integer_token1] = ACTIONS(572),
    [aux_sym_integer_token2] = ACTIONS(570),
    [aux_sym_float_token1] = ACTIONS(572),
    [aux_sym_float_token2] = ACTIONS(570),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [aux_sym_string_token1] = ACTIONS(570),
    [aux_sym_string_token3] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(572),
    [anon_sym_catch] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(572),
    [anon_sym_do] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_extern] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_inline] = ACTIONS(572),
    [anon_sym_macro] = ACTIONS(572),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_overload] = ACTIONS(572),
    [anon_sym_override] = ACTIONS(572),
    [anon_sym_private] = ACTIONS(572),
    [anon_sym_public] = ACTIONS(572),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_static] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(572),
    [anon_sym_untyped] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [sym__semicolon] = ACTIONS(570),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(506),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(508),
    [anon_sym_QMARK] = ACTIONS(508),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(506),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(574),
    [sym_identifier] = ACTIONS(576),
    [anon_sym_POUND] = ACTIONS(574),
    [anon_sym_package] = ACTIONS(576),
    [anon_sym_import] = ACTIONS(576),
    [anon_sym_using] = ACTIONS(576),
    [anon_sym_throw] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_COLON] = ACTIONS(574),
    [anon_sym_default] = ACTIONS(576),
    [anon_sym_cast] = ACTIONS(576),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_DOLLARtype] = ACTIONS(574),
    [anon_sym_in] = ACTIONS(576),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_RBRACK] = ACTIONS(574),
    [anon_sym_this] = ACTIONS(576),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_AT_COLON] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(576),
    [anon_sym_new] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(574),
    [anon_sym_BANG] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(574),
    [anon_sym_PERCENT] = ACTIONS(574),
    [anon_sym_STAR] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_GT_GT_GT] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_EQ_GT] = ACTIONS(574),
    [anon_sym_QMARK_QMARK] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(576),
    [sym__rangeOperator] = ACTIONS(574),
    [anon_sym_null] = ACTIONS(576),
    [anon_sym_dynamic] = ACTIONS(576),
    [anon_sym_final] = ACTIONS(576),
    [anon_sym_abstract] = ACTIONS(576),
    [anon_sym_class] = ACTIONS(576),
    [anon_sym_extends] = ACTIONS(576),
    [anon_sym_implements] = ACTIONS(576),
    [anon_sym_interface] = ACTIONS(576),
    [anon_sym_typedef] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_var] = ACTIONS(576),
    [aux_sym_integer_token1] = ACTIONS(576),
    [aux_sym_integer_token2] = ACTIONS(574),
    [aux_sym_float_token1] = ACTIONS(576),
    [aux_sym_float_token2] = ACTIONS(574),
    [anon_sym_true] = ACTIONS(576),
    [anon_sym_false] = ACTIONS(576),
    [aux_sym_string_token1] = ACTIONS(574),
    [aux_sym_string_token3] = ACTIONS(574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(576),
    [anon_sym_catch] = ACTIONS(576),
    [anon_sym_continue] = ACTIONS(576),
    [anon_sym_do] = ACTIONS(576),
    [anon_sym_enum] = ACTIONS(576),
    [anon_sym_extern] = ACTIONS(576),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_inline] = ACTIONS(576),
    [anon_sym_macro] = ACTIONS(576),
    [anon_sym_operator] = ACTIONS(576),
    [anon_sym_overload] = ACTIONS(576),
    [anon_sym_override] = ACTIONS(576),
    [anon_sym_private] = ACTIONS(576),
    [anon_sym_public] = ACTIONS(576),
    [anon_sym_return] = ACTIONS(576),
    [anon_sym_static] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(576),
    [anon_sym_untyped] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [sym__semicolon] = ACTIONS(574),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(578),
    [sym_identifier] = ACTIONS(580),
    [anon_sym_POUND] = ACTIONS(578),
    [anon_sym_package] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_throw] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_switch] = ACTIONS(580),
    [anon_sym_LBRACE] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_case] = ACTIONS(580),
    [anon_sym_COLON] = ACTIONS(578),
    [anon_sym_default] = ACTIONS(580),
    [anon_sym_cast] = ACTIONS(580),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_DOLLARtype] = ACTIONS(578),
    [anon_sym_in] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_this] = ACTIONS(580),
    [anon_sym_DOT] = ACTIONS(580),
    [anon_sym_QMARK] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(580),
    [anon_sym_AT_COLON] = ACTIONS(578),
    [anon_sym_if] = ACTIONS(580),
    [anon_sym_else] = ACTIONS(580),
    [anon_sym_new] = ACTIONS(580),
    [anon_sym_TILDE] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_PLUS_PLUS] = ACTIONS(578),
    [anon_sym_DASH_DASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(580),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_LT_EQ] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_GT_EQ] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(578),
    [anon_sym_QMARK_QMARK] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(580),
    [sym__rangeOperator] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(580),
    [anon_sym_dynamic] = ACTIONS(580),
    [anon_sym_final] = ACTIONS(580),
    [anon_sym_abstract] = ACTIONS(580),
    [anon_sym_class] = ACTIONS(580),
    [anon_sym_extends] = ACTIONS(580),
    [anon_sym_implements] = ACTIONS(580),
    [anon_sym_interface] = ACTIONS(580),
    [anon_sym_typedef] = ACTIONS(580),
    [anon_sym_function] = ACTIONS(580),
    [anon_sym_var] = ACTIONS(580),
    [aux_sym_integer_token1] = ACTIONS(580),
    [aux_sym_integer_token2] = ACTIONS(578),
    [aux_sym_float_token1] = ACTIONS(580),
    [aux_sym_float_token2] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(580),
    [anon_sym_false] = ACTIONS(580),
    [aux_sym_string_token1] = ACTIONS(578),
    [aux_sym_string_token3] = ACTIONS(578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(580),
    [anon_sym_catch] = ACTIONS(580),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_do] = ACTIONS(580),
    [anon_sym_enum] = ACTIONS(580),
    [anon_sym_extern] = ACTIONS(580),
    [anon_sym_for] = ACTIONS(580),
    [anon_sym_inline] = ACTIONS(580),
    [anon_sym_macro] = ACTIONS(580),
    [anon_sym_operator] = ACTIONS(580),
    [anon_sym_overload] = ACTIONS(580),
    [anon_sym_override] = ACTIONS(580),
    [anon_sym_private] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(580),
    [anon_sym_return] = ACTIONS(580),
    [anon_sym_static] = ACTIONS(580),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_untyped] = ACTIONS(580),
    [anon_sym_while] = ACTIONS(580),
    [sym__semicolon] = ACTIONS(578),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(582),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_POUND] = ACTIONS(582),
    [anon_sym_package] = ACTIONS(584),
    [anon_sym_import] = ACTIONS(584),
    [anon_sym_using] = ACTIONS(584),
    [anon_sym_throw] = ACTIONS(584),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_switch] = ACTIONS(584),
    [anon_sym_LBRACE] = ACTIONS(582),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_case] = ACTIONS(584),
    [anon_sym_COLON] = ACTIONS(582),
    [anon_sym_default] = ACTIONS(584),
    [anon_sym_cast] = ACTIONS(584),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_DOLLARtype] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_RBRACK] = ACTIONS(582),
    [anon_sym_this] = ACTIONS(584),
    [anon_sym_DOT] = ACTIONS(584),
    [anon_sym_QMARK] = ACTIONS(584),
    [anon_sym_AT] = ACTIONS(584),
    [anon_sym_AT_COLON] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(584),
    [anon_sym_else] = ACTIONS(584),
    [anon_sym_new] = ACTIONS(584),
    [anon_sym_TILDE] = ACTIONS(582),
    [anon_sym_BANG] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(582),
    [anon_sym_DASH_DASH] = ACTIONS(582),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(582),
    [anon_sym_SLASH] = ACTIONS(584),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_CARET] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_EQ_EQ] = ACTIONS(582),
    [anon_sym_BANG_EQ] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(584),
    [anon_sym_LT_EQ] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(584),
    [anon_sym_GT_EQ] = ACTIONS(582),
    [anon_sym_EQ_GT] = ACTIONS(582),
    [anon_sym_QMARK_QMARK] = ACTIONS(582),
    [anon_sym_EQ] = ACTIONS(584),
    [sym__rangeOperator] = ACTIONS(582),
    [anon_sym_null] = ACTIONS(584),
    [anon_sym_dynamic] = ACTIONS(584),
    [anon_sym_final] = ACTIONS(584),
    [anon_sym_abstract] = ACTIONS(584),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_extends] = ACTIONS(584),
    [anon_sym_implements] = ACTIONS(584),
    [anon_sym_interface] = ACTIONS(584),
    [anon_sym_typedef] = ACTIONS(584),
    [anon_sym_function] = ACTIONS(584),
    [anon_sym_var] = ACTIONS(584),
    [aux_sym_integer_token1] = ACTIONS(584),
    [aux_sym_integer_token2] = ACTIONS(582),
    [aux_sym_float_token1] = ACTIONS(584),
    [aux_sym_float_token2] = ACTIONS(582),
    [anon_sym_true] = ACTIONS(584),
    [anon_sym_false] = ACTIONS(584),
    [aux_sym_string_token1] = ACTIONS(582),
    [aux_sym_string_token3] = ACTIONS(582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(584),
    [anon_sym_catch] = ACTIONS(584),
    [anon_sym_continue] = ACTIONS(584),
    [anon_sym_do] = ACTIONS(584),
    [anon_sym_enum] = ACTIONS(584),
    [anon_sym_extern] = ACTIONS(584),
    [anon_sym_for] = ACTIONS(584),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_macro] = ACTIONS(584),
    [anon_sym_operator] = ACTIONS(584),
    [anon_sym_overload] = ACTIONS(584),
    [anon_sym_override] = ACTIONS(584),
    [anon_sym_private] = ACTIONS(584),
    [anon_sym_public] = ACTIONS(584),
    [anon_sym_return] = ACTIONS(584),
    [anon_sym_static] = ACTIONS(584),
    [anon_sym_try] = ACTIONS(584),
    [anon_sym_untyped] = ACTIONS(584),
    [anon_sym_while] = ACTIONS(584),
    [sym__semicolon] = ACTIONS(582),
  },
  [101] = {
    [ts_builtin_sym_end] = ACTIONS(424),
    [sym_identifier] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_DOLLARtype] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_DOT] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_DASH_GT] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_SLASH] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(426),
    [anon_sym_LT_LT] = ACTIONS(424),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(424),
    [anon_sym_AMP_AMP] = ACTIONS(424),
    [anon_sym_PIPE_PIPE] = ACTIONS(424),
    [anon_sym_EQ_EQ] = ACTIONS(424),
    [anon_sym_BANG_EQ] = ACTIONS(424),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_GT_EQ] = ACTIONS(424),
    [anon_sym_EQ_GT] = ACTIONS(424),
    [anon_sym_QMARK_QMARK] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(426),
    [sym__rangeOperator] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(472),
    [sym_identifier] = ACTIONS(474),
    [anon_sym_POUND] = ACTIONS(472),
    [anon_sym_package] = ACTIONS(474),
    [anon_sym_import] = ACTIONS(474),
    [anon_sym_using] = ACTIONS(474),
    [anon_sym_throw] = ACTIONS(474),
    [anon_sym_LPAREN] = ACTIONS(472),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_switch] = ACTIONS(474),
    [anon_sym_LBRACE] = ACTIONS(472),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_case] = ACTIONS(474),
    [anon_sym_default] = ACTIONS(474),
    [anon_sym_cast] = ACTIONS(474),
    [anon_sym_COMMA] = ACTIONS(472),
    [anon_sym_DOLLARtype] = ACTIONS(472),
    [anon_sym_in] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(472),
    [anon_sym_this] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(474),
    [anon_sym_DASH_GT] = ACTIONS(472),
    [anon_sym_AT] = ACTIONS(474),
    [anon_sym_AT_COLON] = ACTIONS(472),
    [anon_sym_if] = ACTIONS(474),
    [anon_sym_else] = ACTIONS(474),
    [anon_sym_new] = ACTIONS(474),
    [anon_sym_TILDE] = ACTIONS(472),
    [anon_sym_BANG] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(474),
    [anon_sym_PLUS_PLUS] = ACTIONS(472),
    [anon_sym_DASH_DASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(472),
    [anon_sym_STAR] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(474),
    [anon_sym_PLUS] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(472),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_GT_GT_GT] = ACTIONS(472),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_CARET] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_EQ_EQ] = ACTIONS(472),
    [anon_sym_BANG_EQ] = ACTIONS(472),
    [anon_sym_LT] = ACTIONS(474),
    [anon_sym_LT_EQ] = ACTIONS(472),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_GT_EQ] = ACTIONS(472),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_QMARK_QMARK] = ACTIONS(472),
    [anon_sym_EQ] = ACTIONS(474),
    [sym__rangeOperator] = ACTIONS(472),
    [anon_sym_null] = ACTIONS(474),
    [anon_sym_dynamic] = ACTIONS(474),
    [anon_sym_final] = ACTIONS(474),
    [anon_sym_abstract] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(474),
    [anon_sym_extends] = ACTIONS(474),
    [anon_sym_implements] = ACTIONS(474),
    [anon_sym_interface] = ACTIONS(474),
    [anon_sym_typedef] = ACTIONS(474),
    [anon_sym_function] = ACTIONS(474),
    [anon_sym_var] = ACTIONS(474),
    [aux_sym_integer_token1] = ACTIONS(474),
    [aux_sym_integer_token2] = ACTIONS(472),
    [aux_sym_float_token1] = ACTIONS(474),
    [aux_sym_float_token2] = ACTIONS(472),
    [anon_sym_true] = ACTIONS(474),
    [anon_sym_false] = ACTIONS(474),
    [aux_sym_string_token1] = ACTIONS(472),
    [aux_sym_string_token3] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_catch] = ACTIONS(474),
    [anon_sym_continue] = ACTIONS(474),
    [anon_sym_do] = ACTIONS(474),
    [anon_sym_enum] = ACTIONS(474),
    [anon_sym_extern] = ACTIONS(474),
    [anon_sym_for] = ACTIONS(474),
    [anon_sym_inline] = ACTIONS(474),
    [anon_sym_macro] = ACTIONS(474),
    [anon_sym_operator] = ACTIONS(474),
    [anon_sym_overload] = ACTIONS(474),
    [anon_sym_override] = ACTIONS(474),
    [anon_sym_private] = ACTIONS(474),
    [anon_sym_public] = ACTIONS(474),
    [anon_sym_return] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(474),
    [anon_sym_try] = ACTIONS(474),
    [anon_sym_untyped] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(474),
    [sym__semicolon] = ACTIONS(472),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(404),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_POUND] = ACTIONS(404),
    [anon_sym_package] = ACTIONS(406),
    [anon_sym_import] = ACTIONS(406),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_throw] = ACTIONS(406),
    [anon_sym_LPAREN] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(404),
    [anon_sym_switch] = ACTIONS(406),
    [anon_sym_LBRACE] = ACTIONS(404),
    [anon_sym_RBRACE] = ACTIONS(404),
    [anon_sym_case] = ACTIONS(406),
    [anon_sym_default] = ACTIONS(406),
    [anon_sym_cast] = ACTIONS(406),
    [anon_sym_COMMA] = ACTIONS(404),
    [anon_sym_DOLLARtype] = ACTIONS(404),
    [anon_sym_in] = ACTIONS(406),
    [anon_sym_LBRACK] = ACTIONS(404),
    [anon_sym_this] = ACTIONS(406),
    [anon_sym_DOT] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(406),
    [anon_sym_AT] = ACTIONS(406),
    [anon_sym_AT_COLON] = ACTIONS(404),
    [anon_sym_if] = ACTIONS(406),
    [anon_sym_else] = ACTIONS(406),
    [anon_sym_new] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(404),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_PLUS_PLUS] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(404),
    [anon_sym_PERCENT] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(406),
    [anon_sym_LT_LT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(406),
    [anon_sym_GT_GT_GT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(406),
    [anon_sym_PIPE] = ACTIONS(406),
    [anon_sym_CARET] = ACTIONS(404),
    [anon_sym_AMP_AMP] = ACTIONS(404),
    [anon_sym_PIPE_PIPE] = ACTIONS(404),
    [anon_sym_EQ_EQ] = ACTIONS(404),
    [anon_sym_BANG_EQ] = ACTIONS(404),
    [anon_sym_LT] = ACTIONS(406),
    [anon_sym_LT_EQ] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(406),
    [anon_sym_GT_EQ] = ACTIONS(404),
    [anon_sym_EQ_GT] = ACTIONS(404),
    [anon_sym_QMARK_QMARK] = ACTIONS(404),
    [anon_sym_EQ] = ACTIONS(406),
    [sym__rangeOperator] = ACTIONS(404),
    [anon_sym_null] = ACTIONS(406),
    [anon_sym_dynamic] = ACTIONS(406),
    [anon_sym_final] = ACTIONS(406),
    [anon_sym_abstract] = ACTIONS(406),
    [anon_sym_class] = ACTIONS(406),
    [anon_sym_extends] = ACTIONS(406),
    [anon_sym_implements] = ACTIONS(406),
    [anon_sym_interface] = ACTIONS(406),
    [anon_sym_typedef] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(406),
    [anon_sym_var] = ACTIONS(406),
    [aux_sym_integer_token1] = ACTIONS(406),
    [aux_sym_integer_token2] = ACTIONS(404),
    [aux_sym_float_token1] = ACTIONS(406),
    [aux_sym_float_token2] = ACTIONS(404),
    [anon_sym_true] = ACTIONS(406),
    [anon_sym_false] = ACTIONS(406),
    [aux_sym_string_token1] = ACTIONS(404),
    [aux_sym_string_token3] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(406),
    [anon_sym_catch] = ACTIONS(406),
    [anon_sym_continue] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(406),
    [anon_sym_enum] = ACTIONS(406),
    [anon_sym_extern] = ACTIONS(406),
    [anon_sym_for] = ACTIONS(406),
    [anon_sym_inline] = ACTIONS(406),
    [anon_sym_macro] = ACTIONS(406),
    [anon_sym_operator] = ACTIONS(406),
    [anon_sym_overload] = ACTIONS(406),
    [anon_sym_override] = ACTIONS(406),
    [anon_sym_private] = ACTIONS(406),
    [anon_sym_public] = ACTIONS(406),
    [anon_sym_return] = ACTIONS(406),
    [anon_sym_static] = ACTIONS(406),
    [anon_sym_try] = ACTIONS(406),
    [anon_sym_untyped] = ACTIONS(406),
    [anon_sym_while] = ACTIONS(406),
    [sym__semicolon] = ACTIONS(404),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(412),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_POUND] = ACTIONS(412),
    [anon_sym_package] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_using] = ACTIONS(414),
    [anon_sym_throw] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(412),
    [anon_sym_RPAREN] = ACTIONS(412),
    [anon_sym_switch] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_case] = ACTIONS(414),
    [anon_sym_default] = ACTIONS(414),
    [anon_sym_cast] = ACTIONS(414),
    [anon_sym_COMMA] = ACTIONS(412),
    [anon_sym_DOLLARtype] = ACTIONS(412),
    [anon_sym_in] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_this] = ACTIONS(414),
    [anon_sym_DOT] = ACTIONS(414),
    [anon_sym_QMARK] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(414),
    [anon_sym_AT_COLON] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_new] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PLUS_PLUS] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(412),
    [anon_sym_PERCENT] = ACTIONS(412),
    [anon_sym_STAR] = ACTIONS(412),
    [anon_sym_SLASH] = ACTIONS(414),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_LT_LT] = ACTIONS(412),
    [anon_sym_GT_GT] = ACTIONS(414),
    [anon_sym_GT_GT_GT] = ACTIONS(412),
    [anon_sym_AMP] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(414),
    [anon_sym_CARET] = ACTIONS(412),
    [anon_sym_AMP_AMP] = ACTIONS(412),
    [anon_sym_PIPE_PIPE] = ACTIONS(412),
    [anon_sym_EQ_EQ] = ACTIONS(412),
    [anon_sym_BANG_EQ] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_LT_EQ] = ACTIONS(412),
    [anon_sym_GT] = ACTIONS(414),
    [anon_sym_GT_EQ] = ACTIONS(412),
    [anon_sym_EQ_GT] = ACTIONS(412),
    [anon_sym_QMARK_QMARK] = ACTIONS(412),
    [anon_sym_EQ] = ACTIONS(414),
    [sym__rangeOperator] = ACTIONS(412),
    [anon_sym_null] = ACTIONS(414),
    [anon_sym_dynamic] = ACTIONS(414),
    [anon_sym_final] = ACTIONS(414),
    [anon_sym_abstract] = ACTIONS(414),
    [anon_sym_class] = ACTIONS(414),
    [anon_sym_extends] = ACTIONS(414),
    [anon_sym_implements] = ACTIONS(414),
    [anon_sym_interface] = ACTIONS(414),
    [anon_sym_typedef] = ACTIONS(414),
    [anon_sym_function] = ACTIONS(414),
    [anon_sym_var] = ACTIONS(414),
    [aux_sym_integer_token1] = ACTIONS(414),
    [aux_sym_integer_token2] = ACTIONS(412),
    [aux_sym_float_token1] = ACTIONS(414),
    [aux_sym_float_token2] = ACTIONS(412),
    [anon_sym_true] = ACTIONS(414),
    [anon_sym_false] = ACTIONS(414),
    [aux_sym_string_token1] = ACTIONS(412),
    [aux_sym_string_token3] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(414),
    [anon_sym_catch] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_enum] = ACTIONS(414),
    [anon_sym_extern] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_inline] = ACTIONS(414),
    [anon_sym_macro] = ACTIONS(414),
    [anon_sym_operator] = ACTIONS(414),
    [anon_sym_overload] = ACTIONS(414),
    [anon_sym_override] = ACTIONS(414),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_static] = ACTIONS(414),
    [anon_sym_try] = ACTIONS(414),
    [anon_sym_untyped] = ACTIONS(414),
    [anon_sym_while] = ACTIONS(414),
    [sym__semicolon] = ACTIONS(412),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(586),
    [sym_identifier] = ACTIONS(588),
    [anon_sym_POUND] = ACTIONS(586),
    [anon_sym_package] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(588),
    [anon_sym_using] = ACTIONS(588),
    [anon_sym_throw] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_switch] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(586),
    [anon_sym_RBRACE] = ACTIONS(586),
    [anon_sym_case] = ACTIONS(588),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(588),
    [anon_sym_cast] = ACTIONS(588),
    [anon_sym_COMMA] = ACTIONS(586),
    [anon_sym_DOLLARtype] = ACTIONS(586),
    [anon_sym_in] = ACTIONS(588),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_this] = ACTIONS(588),
    [anon_sym_DOT] = ACTIONS(588),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_AT_COLON] = ACTIONS(586),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_else] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(588),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(586),
    [anon_sym_DASH_DASH] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_LT_LT] = ACTIONS(586),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(586),
    [anon_sym_AMP] = ACTIONS(588),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_CARET] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [anon_sym_EQ_EQ] = ACTIONS(586),
    [anon_sym_BANG_EQ] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_LT_EQ] = ACTIONS(586),
    [anon_sym_GT] = ACTIONS(588),
    [anon_sym_GT_EQ] = ACTIONS(586),
    [anon_sym_EQ_GT] = ACTIONS(586),
    [anon_sym_QMARK_QMARK] = ACTIONS(586),
    [anon_sym_EQ] = ACTIONS(588),
    [sym__rangeOperator] = ACTIONS(586),
    [anon_sym_null] = ACTIONS(588),
    [anon_sym_dynamic] = ACTIONS(588),
    [anon_sym_final] = ACTIONS(588),
    [anon_sym_abstract] = ACTIONS(588),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_extends] = ACTIONS(588),
    [anon_sym_implements] = ACTIONS(588),
    [anon_sym_interface] = ACTIONS(588),
    [anon_sym_typedef] = ACTIONS(588),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_var] = ACTIONS(588),
    [aux_sym_integer_token1] = ACTIONS(588),
    [aux_sym_integer_token2] = ACTIONS(586),
    [aux_sym_float_token1] = ACTIONS(588),
    [aux_sym_float_token2] = ACTIONS(586),
    [anon_sym_true] = ACTIONS(588),
    [anon_sym_false] = ACTIONS(588),
    [aux_sym_string_token1] = ACTIONS(586),
    [aux_sym_string_token3] = ACTIONS(586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(588),
    [anon_sym_catch] = ACTIONS(588),
    [anon_sym_continue] = ACTIONS(588),
    [anon_sym_do] = ACTIONS(588),
    [anon_sym_enum] = ACTIONS(588),
    [anon_sym_extern] = ACTIONS(588),
    [anon_sym_for] = ACTIONS(588),
    [anon_sym_inline] = ACTIONS(588),
    [anon_sym_macro] = ACTIONS(588),
    [anon_sym_operator] = ACTIONS(588),
    [anon_sym_overload] = ACTIONS(588),
    [anon_sym_override] = ACTIONS(588),
    [anon_sym_private] = ACTIONS(588),
    [anon_sym_public] = ACTIONS(588),
    [anon_sym_return] = ACTIONS(588),
    [anon_sym_static] = ACTIONS(588),
    [anon_sym_try] = ACTIONS(588),
    [anon_sym_untyped] = ACTIONS(588),
    [anon_sym_while] = ACTIONS(588),
    [sym__semicolon] = ACTIONS(586),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(400),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_POUND] = ACTIONS(400),
    [anon_sym_package] = ACTIONS(402),
    [anon_sym_import] = ACTIONS(402),
    [anon_sym_using] = ACTIONS(402),
    [anon_sym_throw] = ACTIONS(402),
    [anon_sym_LPAREN] = ACTIONS(400),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_switch] = ACTIONS(402),
    [anon_sym_LBRACE] = ACTIONS(400),
    [anon_sym_RBRACE] = ACTIONS(400),
    [anon_sym_case] = ACTIONS(402),
    [anon_sym_default] = ACTIONS(402),
    [anon_sym_cast] = ACTIONS(402),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_DOLLARtype] = ACTIONS(400),
    [anon_sym_in] = ACTIONS(402),
    [anon_sym_LBRACK] = ACTIONS(400),
    [anon_sym_this] = ACTIONS(402),
    [anon_sym_DOT] = ACTIONS(402),
    [anon_sym_QMARK] = ACTIONS(402),
    [anon_sym_AT] = ACTIONS(402),
    [anon_sym_AT_COLON] = ACTIONS(400),
    [anon_sym_if] = ACTIONS(402),
    [anon_sym_else] = ACTIONS(402),
    [anon_sym_new] = ACTIONS(402),
    [anon_sym_TILDE] = ACTIONS(400),
    [anon_sym_BANG] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(402),
    [anon_sym_PLUS_PLUS] = ACTIONS(400),
    [anon_sym_DASH_DASH] = ACTIONS(400),
    [anon_sym_PERCENT] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(400),
    [anon_sym_SLASH] = ACTIONS(402),
    [anon_sym_PLUS] = ACTIONS(402),
    [anon_sym_LT_LT] = ACTIONS(400),
    [anon_sym_GT_GT] = ACTIONS(402),
    [anon_sym_GT_GT_GT] = ACTIONS(400),
    [anon_sym_AMP] = ACTIONS(402),
    [anon_sym_PIPE] = ACTIONS(402),
    [anon_sym_CARET] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_EQ_EQ] = ACTIONS(400),
    [anon_sym_BANG_EQ] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(402),
    [anon_sym_LT_EQ] = ACTIONS(400),
    [anon_sym_GT] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(400),
    [anon_sym_EQ_GT] = ACTIONS(400),
    [anon_sym_QMARK_QMARK] = ACTIONS(400),
    [anon_sym_EQ] = ACTIONS(402),
    [sym__rangeOperator] = ACTIONS(400),
    [anon_sym_null] = ACTIONS(402),
    [anon_sym_dynamic] = ACTIONS(402),
    [anon_sym_final] = ACTIONS(402),
    [anon_sym_abstract] = ACTIONS(402),
    [anon_sym_class] = ACTIONS(402),
    [anon_sym_extends] = ACTIONS(402),
    [anon_sym_implements] = ACTIONS(402),
    [anon_sym_interface] = ACTIONS(402),
    [anon_sym_typedef] = ACTIONS(402),
    [anon_sym_function] = ACTIONS(402),
    [anon_sym_var] = ACTIONS(402),
    [aux_sym_integer_token1] = ACTIONS(402),
    [aux_sym_integer_token2] = ACTIONS(400),
    [aux_sym_float_token1] = ACTIONS(402),
    [aux_sym_float_token2] = ACTIONS(400),
    [anon_sym_true] = ACTIONS(402),
    [anon_sym_false] = ACTIONS(402),
    [aux_sym_string_token1] = ACTIONS(400),
    [aux_sym_string_token3] = ACTIONS(400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(402),
    [anon_sym_catch] = ACTIONS(402),
    [anon_sym_continue] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(402),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_extern] = ACTIONS(402),
    [anon_sym_for] = ACTIONS(402),
    [anon_sym_inline] = ACTIONS(402),
    [anon_sym_macro] = ACTIONS(402),
    [anon_sym_operator] = ACTIONS(402),
    [anon_sym_overload] = ACTIONS(402),
    [anon_sym_override] = ACTIONS(402),
    [anon_sym_private] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(402),
    [anon_sym_return] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(402),
    [anon_sym_try] = ACTIONS(402),
    [anon_sym_untyped] = ACTIONS(402),
    [anon_sym_while] = ACTIONS(402),
    [sym__semicolon] = ACTIONS(400),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(592),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(408),
    [sym_identifier] = ACTIONS(410),
    [anon_sym_POUND] = ACTIONS(408),
    [anon_sym_package] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [anon_sym_using] = ACTIONS(410),
    [anon_sym_throw] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(408),
    [anon_sym_switch] = ACTIONS(410),
    [anon_sym_LBRACE] = ACTIONS(408),
    [anon_sym_RBRACE] = ACTIONS(408),
    [anon_sym_case] = ACTIONS(410),
    [anon_sym_default] = ACTIONS(410),
    [anon_sym_cast] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [anon_sym_DOLLARtype] = ACTIONS(408),
    [anon_sym_in] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_this] = ACTIONS(410),
    [anon_sym_DOT] = ACTIONS(410),
    [anon_sym_QMARK] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(410),
    [anon_sym_AT_COLON] = ACTIONS(408),
    [anon_sym_if] = ACTIONS(410),
    [anon_sym_else] = ACTIONS(410),
    [anon_sym_new] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(408),
    [anon_sym_BANG] = ACTIONS(410),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(408),
    [anon_sym_DASH_DASH] = ACTIONS(408),
    [anon_sym_PERCENT] = ACTIONS(408),
    [anon_sym_STAR] = ACTIONS(408),
    [anon_sym_SLASH] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_LT_LT] = ACTIONS(408),
    [anon_sym_GT_GT] = ACTIONS(410),
    [anon_sym_GT_GT_GT] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(410),
    [anon_sym_PIPE] = ACTIONS(410),
    [anon_sym_CARET] = ACTIONS(408),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_PIPE_PIPE] = ACTIONS(408),
    [anon_sym_EQ_EQ] = ACTIONS(408),
    [anon_sym_BANG_EQ] = ACTIONS(408),
    [anon_sym_LT] = ACTIONS(410),
    [anon_sym_LT_EQ] = ACTIONS(408),
    [anon_sym_GT] = ACTIONS(410),
    [anon_sym_GT_EQ] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(408),
    [anon_sym_QMARK_QMARK] = ACTIONS(408),
    [anon_sym_EQ] = ACTIONS(410),
    [sym__rangeOperator] = ACTIONS(408),
    [anon_sym_null] = ACTIONS(410),
    [anon_sym_dynamic] = ACTIONS(410),
    [anon_sym_final] = ACTIONS(410),
    [anon_sym_abstract] = ACTIONS(410),
    [anon_sym_class] = ACTIONS(410),
    [anon_sym_extends] = ACTIONS(410),
    [anon_sym_implements] = ACTIONS(410),
    [anon_sym_interface] = ACTIONS(410),
    [anon_sym_typedef] = ACTIONS(410),
    [anon_sym_function] = ACTIONS(410),
    [anon_sym_var] = ACTIONS(410),
    [aux_sym_integer_token1] = ACTIONS(410),
    [aux_sym_integer_token2] = ACTIONS(408),
    [aux_sym_float_token1] = ACTIONS(410),
    [aux_sym_float_token2] = ACTIONS(408),
    [anon_sym_true] = ACTIONS(410),
    [anon_sym_false] = ACTIONS(410),
    [aux_sym_string_token1] = ACTIONS(408),
    [aux_sym_string_token3] = ACTIONS(408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(410),
    [anon_sym_catch] = ACTIONS(410),
    [anon_sym_continue] = ACTIONS(410),
    [anon_sym_do] = ACTIONS(410),
    [anon_sym_enum] = ACTIONS(410),
    [anon_sym_extern] = ACTIONS(410),
    [anon_sym_for] = ACTIONS(410),
    [anon_sym_inline] = ACTIONS(410),
    [anon_sym_macro] = ACTIONS(410),
    [anon_sym_operator] = ACTIONS(410),
    [anon_sym_overload] = ACTIONS(410),
    [anon_sym_override] = ACTIONS(410),
    [anon_sym_private] = ACTIONS(410),
    [anon_sym_public] = ACTIONS(410),
    [anon_sym_return] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(410),
    [anon_sym_try] = ACTIONS(410),
    [anon_sym_untyped] = ACTIONS(410),
    [anon_sym_while] = ACTIONS(410),
    [sym__semicolon] = ACTIONS(408),
  },
  [110] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(342),
    [sym_runtime_type_check_expression] = STATE(342),
    [sym_switch_expression] = STATE(342),
    [sym_cast_expression] = STATE(342),
    [sym_type_trace_expression] = STATE(342),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(342),
    [sym_subscript_expression] = STATE(342),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(981),
    [sym_builtin_type] = STATE(1008),
    [sym__function_type_args] = STATE(1309),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1091),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(466),
    [sym_integer] = STATE(466),
    [sym_float] = STATE(466),
    [sym_bool] = STATE(466),
    [sym_string] = STATE(462),
    [sym_null] = STATE(466),
    [sym_array] = STATE(466),
    [sym_map] = STATE(466),
    [sym_object] = STATE(466),
    [sym_structure_type_pair] = STATE(1311),
    [sym_pair] = STATE(466),
    [aux_sym__parenthesized_expression_repeat1] = STATE(342),
    [sym_identifier] = ACTIONS(598),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(608),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_POUND] = ACTIONS(608),
    [anon_sym_package] = ACTIONS(610),
    [anon_sym_import] = ACTIONS(610),
    [anon_sym_using] = ACTIONS(610),
    [anon_sym_throw] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_switch] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(608),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_case] = ACTIONS(610),
    [anon_sym_default] = ACTIONS(610),
    [anon_sym_cast] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(608),
    [anon_sym_DOLLARtype] = ACTIONS(608),
    [anon_sym_in] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(608),
    [anon_sym_this] = ACTIONS(610),
    [anon_sym_DASH_GT] = ACTIONS(608),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_AT_COLON] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(610),
    [anon_sym_new] = ACTIONS(610),
    [anon_sym_TILDE] = ACTIONS(608),
    [anon_sym_BANG] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_PLUS_PLUS] = ACTIONS(608),
    [anon_sym_DASH_DASH] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(608),
    [anon_sym_STAR] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_LT_LT] = ACTIONS(608),
    [anon_sym_GT_GT] = ACTIONS(610),
    [anon_sym_GT_GT_GT] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(610),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_EQ_EQ] = ACTIONS(608),
    [anon_sym_BANG_EQ] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(610),
    [anon_sym_LT_EQ] = ACTIONS(608),
    [anon_sym_GT] = ACTIONS(610),
    [anon_sym_GT_EQ] = ACTIONS(608),
    [anon_sym_EQ_GT] = ACTIONS(608),
    [anon_sym_QMARK_QMARK] = ACTIONS(608),
    [anon_sym_EQ] = ACTIONS(610),
    [sym__rangeOperator] = ACTIONS(608),
    [anon_sym_null] = ACTIONS(610),
    [anon_sym_dynamic] = ACTIONS(610),
    [anon_sym_final] = ACTIONS(610),
    [anon_sym_abstract] = ACTIONS(610),
    [anon_sym_class] = ACTIONS(610),
    [anon_sym_extends] = ACTIONS(610),
    [anon_sym_implements] = ACTIONS(610),
    [anon_sym_interface] = ACTIONS(610),
    [anon_sym_typedef] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(610),
    [anon_sym_var] = ACTIONS(610),
    [aux_sym_integer_token1] = ACTIONS(610),
    [aux_sym_integer_token2] = ACTIONS(608),
    [aux_sym_float_token1] = ACTIONS(610),
    [aux_sym_float_token2] = ACTIONS(608),
    [anon_sym_true] = ACTIONS(610),
    [anon_sym_false] = ACTIONS(610),
    [aux_sym_string_token1] = ACTIONS(608),
    [aux_sym_string_token3] = ACTIONS(608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(610),
    [anon_sym_catch] = ACTIONS(610),
    [anon_sym_continue] = ACTIONS(610),
    [anon_sym_do] = ACTIONS(610),
    [anon_sym_enum] = ACTIONS(610),
    [anon_sym_extern] = ACTIONS(610),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_inline] = ACTIONS(610),
    [anon_sym_macro] = ACTIONS(610),
    [anon_sym_operator] = ACTIONS(610),
    [anon_sym_overload] = ACTIONS(610),
    [anon_sym_override] = ACTIONS(610),
    [anon_sym_private] = ACTIONS(610),
    [anon_sym_public] = ACTIONS(610),
    [anon_sym_return] = ACTIONS(610),
    [anon_sym_static] = ACTIONS(610),
    [anon_sym_try] = ACTIONS(610),
    [anon_sym_untyped] = ACTIONS(610),
    [anon_sym_while] = ACTIONS(610),
    [sym__semicolon] = ACTIONS(608),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(592),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(612),
    [anon_sym_QMARK] = ACTIONS(614),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_POUND] = ACTIONS(616),
    [anon_sym_package] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(618),
    [anon_sym_using] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(616),
    [anon_sym_RPAREN] = ACTIONS(616),
    [anon_sym_switch] = ACTIONS(618),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_case] = ACTIONS(618),
    [anon_sym_default] = ACTIONS(618),
    [anon_sym_cast] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(616),
    [anon_sym_DOLLARtype] = ACTIONS(616),
    [anon_sym_in] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(616),
    [anon_sym_this] = ACTIONS(618),
    [anon_sym_DASH_GT] = ACTIONS(616),
    [anon_sym_AT] = ACTIONS(618),
    [anon_sym_AT_COLON] = ACTIONS(616),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_else] = ACTIONS(618),
    [anon_sym_new] = ACTIONS(618),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_BANG] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_PLUS_PLUS] = ACTIONS(616),
    [anon_sym_DASH_DASH] = ACTIONS(616),
    [anon_sym_PERCENT] = ACTIONS(616),
    [anon_sym_STAR] = ACTIONS(616),
    [anon_sym_SLASH] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_LT_LT] = ACTIONS(616),
    [anon_sym_GT_GT] = ACTIONS(618),
    [anon_sym_GT_GT_GT] = ACTIONS(616),
    [anon_sym_AMP] = ACTIONS(618),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_CARET] = ACTIONS(616),
    [anon_sym_AMP_AMP] = ACTIONS(616),
    [anon_sym_PIPE_PIPE] = ACTIONS(616),
    [anon_sym_EQ_EQ] = ACTIONS(616),
    [anon_sym_BANG_EQ] = ACTIONS(616),
    [anon_sym_LT] = ACTIONS(618),
    [anon_sym_LT_EQ] = ACTIONS(616),
    [anon_sym_GT] = ACTIONS(618),
    [anon_sym_GT_EQ] = ACTIONS(616),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_QMARK_QMARK] = ACTIONS(616),
    [anon_sym_EQ] = ACTIONS(618),
    [sym__rangeOperator] = ACTIONS(616),
    [anon_sym_null] = ACTIONS(618),
    [anon_sym_dynamic] = ACTIONS(618),
    [anon_sym_final] = ACTIONS(618),
    [anon_sym_abstract] = ACTIONS(618),
    [anon_sym_class] = ACTIONS(618),
    [anon_sym_extends] = ACTIONS(618),
    [anon_sym_implements] = ACTIONS(618),
    [anon_sym_interface] = ACTIONS(618),
    [anon_sym_typedef] = ACTIONS(618),
    [anon_sym_function] = ACTIONS(618),
    [anon_sym_var] = ACTIONS(618),
    [aux_sym_integer_token1] = ACTIONS(618),
    [aux_sym_integer_token2] = ACTIONS(616),
    [aux_sym_float_token1] = ACTIONS(618),
    [aux_sym_float_token2] = ACTIONS(616),
    [anon_sym_true] = ACTIONS(618),
    [anon_sym_false] = ACTIONS(618),
    [aux_sym_string_token1] = ACTIONS(616),
    [aux_sym_string_token3] = ACTIONS(616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(618),
    [anon_sym_catch] = ACTIONS(618),
    [anon_sym_continue] = ACTIONS(618),
    [anon_sym_do] = ACTIONS(618),
    [anon_sym_enum] = ACTIONS(618),
    [anon_sym_extern] = ACTIONS(618),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_inline] = ACTIONS(618),
    [anon_sym_macro] = ACTIONS(618),
    [anon_sym_operator] = ACTIONS(618),
    [anon_sym_overload] = ACTIONS(618),
    [anon_sym_override] = ACTIONS(618),
    [anon_sym_private] = ACTIONS(618),
    [anon_sym_public] = ACTIONS(618),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_static] = ACTIONS(618),
    [anon_sym_try] = ACTIONS(618),
    [anon_sym_untyped] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(618),
    [sym__semicolon] = ACTIONS(616),
  },
  [115] = {
    [sym_type_params] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(620),
    [sym_identifier] = ACTIONS(622),
    [anon_sym_POUND] = ACTIONS(620),
    [anon_sym_package] = ACTIONS(622),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_using] = ACTIONS(622),
    [anon_sym_throw] = ACTIONS(622),
    [anon_sym_LPAREN] = ACTIONS(620),
    [anon_sym_RPAREN] = ACTIONS(620),
    [anon_sym_switch] = ACTIONS(622),
    [anon_sym_LBRACE] = ACTIONS(620),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_case] = ACTIONS(622),
    [anon_sym_default] = ACTIONS(622),
    [anon_sym_cast] = ACTIONS(622),
    [anon_sym_DOLLARtype] = ACTIONS(620),
    [anon_sym_in] = ACTIONS(622),
    [anon_sym_LBRACK] = ACTIONS(620),
    [anon_sym_this] = ACTIONS(622),
    [anon_sym_DASH_GT] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(622),
    [anon_sym_AT_COLON] = ACTIONS(620),
    [anon_sym_if] = ACTIONS(622),
    [anon_sym_else] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(622),
    [anon_sym_TILDE] = ACTIONS(620),
    [anon_sym_BANG] = ACTIONS(622),
    [anon_sym_DASH] = ACTIONS(622),
    [anon_sym_PLUS_PLUS] = ACTIONS(620),
    [anon_sym_DASH_DASH] = ACTIONS(620),
    [anon_sym_PERCENT] = ACTIONS(620),
    [anon_sym_STAR] = ACTIONS(620),
    [anon_sym_SLASH] = ACTIONS(622),
    [anon_sym_PLUS] = ACTIONS(622),
    [anon_sym_LT_LT] = ACTIONS(620),
    [anon_sym_GT_GT] = ACTIONS(622),
    [anon_sym_GT_GT_GT] = ACTIONS(620),
    [anon_sym_AMP] = ACTIONS(622),
    [anon_sym_PIPE] = ACTIONS(622),
    [anon_sym_CARET] = ACTIONS(620),
    [anon_sym_AMP_AMP] = ACTIONS(620),
    [anon_sym_PIPE_PIPE] = ACTIONS(620),
    [anon_sym_EQ_EQ] = ACTIONS(620),
    [anon_sym_BANG_EQ] = ACTIONS(620),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_LT_EQ] = ACTIONS(620),
    [anon_sym_GT] = ACTIONS(622),
    [anon_sym_GT_EQ] = ACTIONS(620),
    [anon_sym_EQ_GT] = ACTIONS(620),
    [anon_sym_QMARK_QMARK] = ACTIONS(620),
    [anon_sym_EQ] = ACTIONS(622),
    [sym__rangeOperator] = ACTIONS(620),
    [anon_sym_null] = ACTIONS(622),
    [anon_sym_dynamic] = ACTIONS(622),
    [anon_sym_final] = ACTIONS(622),
    [anon_sym_abstract] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_extends] = ACTIONS(622),
    [anon_sym_implements] = ACTIONS(622),
    [anon_sym_interface] = ACTIONS(622),
    [anon_sym_typedef] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(622),
    [anon_sym_var] = ACTIONS(622),
    [aux_sym_integer_token1] = ACTIONS(622),
    [aux_sym_integer_token2] = ACTIONS(620),
    [aux_sym_float_token1] = ACTIONS(622),
    [aux_sym_float_token2] = ACTIONS(620),
    [anon_sym_true] = ACTIONS(622),
    [anon_sym_false] = ACTIONS(622),
    [aux_sym_string_token1] = ACTIONS(620),
    [aux_sym_string_token3] = ACTIONS(620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(622),
    [anon_sym_catch] = ACTIONS(622),
    [anon_sym_continue] = ACTIONS(622),
    [anon_sym_do] = ACTIONS(622),
    [anon_sym_enum] = ACTIONS(622),
    [anon_sym_extern] = ACTIONS(622),
    [anon_sym_for] = ACTIONS(622),
    [anon_sym_inline] = ACTIONS(622),
    [anon_sym_macro] = ACTIONS(622),
    [anon_sym_operator] = ACTIONS(622),
    [anon_sym_overload] = ACTIONS(622),
    [anon_sym_override] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_return] = ACTIONS(622),
    [anon_sym_static] = ACTIONS(622),
    [anon_sym_try] = ACTIONS(622),
    [anon_sym_untyped] = ACTIONS(622),
    [anon_sym_while] = ACTIONS(622),
    [sym__semicolon] = ACTIONS(620),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(626),
    [sym_identifier] = ACTIONS(628),
    [anon_sym_POUND] = ACTIONS(626),
    [anon_sym_package] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(628),
    [anon_sym_using] = ACTIONS(628),
    [anon_sym_throw] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_RPAREN] = ACTIONS(626),
    [anon_sym_switch] = ACTIONS(628),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_case] = ACTIONS(628),
    [anon_sym_default] = ACTIONS(628),
    [anon_sym_cast] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(626),
    [anon_sym_DOLLARtype] = ACTIONS(626),
    [anon_sym_in] = ACTIONS(628),
    [anon_sym_LBRACK] = ACTIONS(626),
    [anon_sym_this] = ACTIONS(628),
    [anon_sym_DASH_GT] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(628),
    [anon_sym_AT_COLON] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(628),
    [anon_sym_else] = ACTIONS(628),
    [anon_sym_new] = ACTIONS(628),
    [anon_sym_TILDE] = ACTIONS(626),
    [anon_sym_BANG] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PLUS_PLUS] = ACTIONS(626),
    [anon_sym_DASH_DASH] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(628),
    [anon_sym_GT_GT_GT] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_AMP_AMP] = ACTIONS(626),
    [anon_sym_PIPE_PIPE] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(626),
    [anon_sym_BANG_EQ] = ACTIONS(626),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_GT_EQ] = ACTIONS(626),
    [anon_sym_EQ_GT] = ACTIONS(626),
    [anon_sym_QMARK_QMARK] = ACTIONS(626),
    [anon_sym_EQ] = ACTIONS(628),
    [sym__rangeOperator] = ACTIONS(626),
    [anon_sym_null] = ACTIONS(628),
    [anon_sym_dynamic] = ACTIONS(628),
    [anon_sym_final] = ACTIONS(628),
    [anon_sym_abstract] = ACTIONS(628),
    [anon_sym_class] = ACTIONS(628),
    [anon_sym_extends] = ACTIONS(628),
    [anon_sym_implements] = ACTIONS(628),
    [anon_sym_interface] = ACTIONS(628),
    [anon_sym_typedef] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(628),
    [anon_sym_var] = ACTIONS(628),
    [aux_sym_integer_token1] = ACTIONS(628),
    [aux_sym_integer_token2] = ACTIONS(626),
    [aux_sym_float_token1] = ACTIONS(628),
    [aux_sym_float_token2] = ACTIONS(626),
    [anon_sym_true] = ACTIONS(628),
    [anon_sym_false] = ACTIONS(628),
    [aux_sym_string_token1] = ACTIONS(626),
    [aux_sym_string_token3] = ACTIONS(626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(628),
    [anon_sym_catch] = ACTIONS(628),
    [anon_sym_continue] = ACTIONS(628),
    [anon_sym_do] = ACTIONS(628),
    [anon_sym_enum] = ACTIONS(628),
    [anon_sym_extern] = ACTIONS(628),
    [anon_sym_for] = ACTIONS(628),
    [anon_sym_inline] = ACTIONS(628),
    [anon_sym_macro] = ACTIONS(628),
    [anon_sym_operator] = ACTIONS(628),
    [anon_sym_overload] = ACTIONS(628),
    [anon_sym_override] = ACTIONS(628),
    [anon_sym_private] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(628),
    [anon_sym_return] = ACTIONS(628),
    [anon_sym_static] = ACTIONS(628),
    [anon_sym_try] = ACTIONS(628),
    [anon_sym_untyped] = ACTIONS(628),
    [anon_sym_while] = ACTIONS(628),
    [sym__semicolon] = ACTIONS(626),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(430),
    [anon_sym_QMARK] = ACTIONS(432),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(426),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(630),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_POUND] = ACTIONS(630),
    [anon_sym_package] = ACTIONS(632),
    [anon_sym_import] = ACTIONS(632),
    [anon_sym_using] = ACTIONS(632),
    [anon_sym_throw] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_switch] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(630),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_case] = ACTIONS(632),
    [anon_sym_default] = ACTIONS(632),
    [anon_sym_cast] = ACTIONS(632),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_DOLLARtype] = ACTIONS(630),
    [anon_sym_in] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_this] = ACTIONS(632),
    [anon_sym_DASH_GT] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(632),
    [anon_sym_AT_COLON] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(632),
    [anon_sym_else] = ACTIONS(632),
    [anon_sym_new] = ACTIONS(632),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_BANG] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(630),
    [anon_sym_DASH_DASH] = ACTIONS(630),
    [anon_sym_PERCENT] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(630),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(630),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_GT_GT_GT] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_AMP_AMP] = ACTIONS(630),
    [anon_sym_PIPE_PIPE] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(630),
    [anon_sym_BANG_EQ] = ACTIONS(630),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(630),
    [anon_sym_EQ_GT] = ACTIONS(630),
    [anon_sym_QMARK_QMARK] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(632),
    [sym__rangeOperator] = ACTIONS(630),
    [anon_sym_null] = ACTIONS(632),
    [anon_sym_dynamic] = ACTIONS(632),
    [anon_sym_final] = ACTIONS(632),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_class] = ACTIONS(632),
    [anon_sym_extends] = ACTIONS(632),
    [anon_sym_implements] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(632),
    [anon_sym_typedef] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(632),
    [anon_sym_var] = ACTIONS(632),
    [aux_sym_integer_token1] = ACTIONS(632),
    [aux_sym_integer_token2] = ACTIONS(630),
    [aux_sym_float_token1] = ACTIONS(632),
    [aux_sym_float_token2] = ACTIONS(630),
    [anon_sym_true] = ACTIONS(632),
    [anon_sym_false] = ACTIONS(632),
    [aux_sym_string_token1] = ACTIONS(630),
    [aux_sym_string_token3] = ACTIONS(630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(632),
    [anon_sym_catch] = ACTIONS(632),
    [anon_sym_continue] = ACTIONS(632),
    [anon_sym_do] = ACTIONS(632),
    [anon_sym_enum] = ACTIONS(632),
    [anon_sym_extern] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(632),
    [anon_sym_inline] = ACTIONS(632),
    [anon_sym_macro] = ACTIONS(632),
    [anon_sym_operator] = ACTIONS(632),
    [anon_sym_overload] = ACTIONS(632),
    [anon_sym_override] = ACTIONS(632),
    [anon_sym_private] = ACTIONS(632),
    [anon_sym_public] = ACTIONS(632),
    [anon_sym_return] = ACTIONS(632),
    [anon_sym_static] = ACTIONS(632),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_untyped] = ACTIONS(632),
    [anon_sym_while] = ACTIONS(632),
    [sym__semicolon] = ACTIONS(630),
  },
  [119] = {
    [aux_sym_map_repeat1] = STATE(1144),
    [sym_identifier] = ACTIONS(588),
    [anon_sym_POUND] = ACTIONS(586),
    [anon_sym_package] = ACTIONS(588),
    [anon_sym_import] = ACTIONS(588),
    [anon_sym_using] = ACTIONS(588),
    [anon_sym_throw] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_switch] = ACTIONS(588),
    [anon_sym_LBRACE] = ACTIONS(586),
    [anon_sym_RBRACE] = ACTIONS(634),
    [anon_sym_case] = ACTIONS(588),
    [anon_sym_default] = ACTIONS(588),
    [anon_sym_cast] = ACTIONS(588),
    [anon_sym_COMMA] = ACTIONS(636),
    [anon_sym_DOLLARtype] = ACTIONS(586),
    [anon_sym_in] = ACTIONS(588),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_this] = ACTIONS(588),
    [anon_sym_DOT] = ACTIONS(588),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_AT_COLON] = ACTIONS(586),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_else] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(588),
    [anon_sym_TILDE] = ACTIONS(586),
    [anon_sym_BANG] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_PLUS_PLUS] = ACTIONS(586),
    [anon_sym_DASH_DASH] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(586),
    [anon_sym_STAR] = ACTIONS(586),
    [anon_sym_SLASH] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_LT_LT] = ACTIONS(586),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_GT_GT_GT] = ACTIONS(586),
    [anon_sym_AMP] = ACTIONS(588),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_CARET] = ACTIONS(586),
    [anon_sym_AMP_AMP] = ACTIONS(586),
    [anon_sym_PIPE_PIPE] = ACTIONS(586),
    [anon_sym_EQ_EQ] = ACTIONS(586),
    [anon_sym_BANG_EQ] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_LT_EQ] = ACTIONS(586),
    [anon_sym_GT] = ACTIONS(588),
    [anon_sym_GT_EQ] = ACTIONS(586),
    [anon_sym_EQ_GT] = ACTIONS(586),
    [anon_sym_QMARK_QMARK] = ACTIONS(586),
    [anon_sym_EQ] = ACTIONS(588),
    [sym__rangeOperator] = ACTIONS(586),
    [anon_sym_null] = ACTIONS(588),
    [anon_sym_dynamic] = ACTIONS(588),
    [anon_sym_final] = ACTIONS(588),
    [anon_sym_abstract] = ACTIONS(588),
    [anon_sym_class] = ACTIONS(588),
    [anon_sym_extends] = ACTIONS(588),
    [anon_sym_implements] = ACTIONS(588),
    [anon_sym_interface] = ACTIONS(588),
    [anon_sym_typedef] = ACTIONS(588),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_var] = ACTIONS(588),
    [aux_sym_integer_token1] = ACTIONS(588),
    [aux_sym_integer_token2] = ACTIONS(586),
    [aux_sym_float_token1] = ACTIONS(588),
    [aux_sym_float_token2] = ACTIONS(586),
    [anon_sym_true] = ACTIONS(588),
    [anon_sym_false] = ACTIONS(588),
    [aux_sym_string_token1] = ACTIONS(586),
    [aux_sym_string_token3] = ACTIONS(586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(588),
    [anon_sym_catch] = ACTIONS(588),
    [anon_sym_continue] = ACTIONS(588),
    [anon_sym_do] = ACTIONS(588),
    [anon_sym_enum] = ACTIONS(588),
    [anon_sym_extern] = ACTIONS(588),
    [anon_sym_for] = ACTIONS(588),
    [anon_sym_inline] = ACTIONS(588),
    [anon_sym_macro] = ACTIONS(588),
    [anon_sym_operator] = ACTIONS(588),
    [anon_sym_overload] = ACTIONS(588),
    [anon_sym_override] = ACTIONS(588),
    [anon_sym_private] = ACTIONS(588),
    [anon_sym_public] = ACTIONS(588),
    [anon_sym_return] = ACTIONS(588),
    [anon_sym_static] = ACTIONS(588),
    [anon_sym_try] = ACTIONS(588),
    [anon_sym_untyped] = ACTIONS(588),
    [anon_sym_while] = ACTIONS(588),
    [sym__semicolon] = ACTIONS(586),
  },
  [120] = {
    [sym_type_params] = STATE(111),
    [ts_builtin_sym_end] = ACTIONS(638),
    [sym_identifier] = ACTIONS(640),
    [anon_sym_POUND] = ACTIONS(638),
    [anon_sym_package] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(640),
    [anon_sym_using] = ACTIONS(640),
    [anon_sym_throw] = ACTIONS(640),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_switch] = ACTIONS(640),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_case] = ACTIONS(640),
    [anon_sym_default] = ACTIONS(640),
    [anon_sym_cast] = ACTIONS(640),
    [anon_sym_DOLLARtype] = ACTIONS(638),
    [anon_sym_in] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_this] = ACTIONS(640),
    [anon_sym_DASH_GT] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(640),
    [anon_sym_AT_COLON] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_new] = ACTIONS(640),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(638),
    [anon_sym_DASH_DASH] = ACTIONS(638),
    [anon_sym_PERCENT] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(638),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_GT_GT_GT] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(638),
    [anon_sym_PIPE_PIPE] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_LT] = ACTIONS(624),
    [anon_sym_LT_EQ] = ACTIONS(638),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(638),
    [anon_sym_EQ_GT] = ACTIONS(638),
    [anon_sym_QMARK_QMARK] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(640),
    [sym__rangeOperator] = ACTIONS(638),
    [anon_sym_null] = ACTIONS(640),
    [anon_sym_dynamic] = ACTIONS(640),
    [anon_sym_final] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(640),
    [anon_sym_class] = ACTIONS(640),
    [anon_sym_extends] = ACTIONS(640),
    [anon_sym_implements] = ACTIONS(640),
    [anon_sym_interface] = ACTIONS(640),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_var] = ACTIONS(640),
    [aux_sym_integer_token1] = ACTIONS(640),
    [aux_sym_integer_token2] = ACTIONS(638),
    [aux_sym_float_token1] = ACTIONS(640),
    [aux_sym_float_token2] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(640),
    [anon_sym_false] = ACTIONS(640),
    [aux_sym_string_token1] = ACTIONS(638),
    [aux_sym_string_token3] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(640),
    [anon_sym_catch] = ACTIONS(640),
    [anon_sym_continue] = ACTIONS(640),
    [anon_sym_do] = ACTIONS(640),
    [anon_sym_enum] = ACTIONS(640),
    [anon_sym_extern] = ACTIONS(640),
    [anon_sym_for] = ACTIONS(640),
    [anon_sym_inline] = ACTIONS(640),
    [anon_sym_macro] = ACTIONS(640),
    [anon_sym_operator] = ACTIONS(640),
    [anon_sym_overload] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_try] = ACTIONS(640),
    [anon_sym_untyped] = ACTIONS(640),
    [anon_sym_while] = ACTIONS(640),
    [sym__semicolon] = ACTIONS(638),
  },
  [121] = {
    [sym_block] = STATE(205),
    [ts_builtin_sym_end] = ACTIONS(642),
    [sym_identifier] = ACTIONS(644),
    [anon_sym_POUND] = ACTIONS(642),
    [anon_sym_package] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(644),
    [anon_sym_using] = ACTIONS(644),
    [anon_sym_throw] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_switch] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(644),
    [anon_sym_COLON] = ACTIONS(649),
    [anon_sym_default] = ACTIONS(644),
    [anon_sym_cast] = ACTIONS(644),
    [anon_sym_DOLLARtype] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_this] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_AT_COLON] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(644),
    [anon_sym_else] = ACTIONS(644),
    [anon_sym_new] = ACTIONS(644),
    [anon_sym_TILDE] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_PLUS_PLUS] = ACTIONS(642),
    [anon_sym_DASH_DASH] = ACTIONS(642),
    [anon_sym_PERCENT] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_GT_GT_GT] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_AMP_AMP] = ACTIONS(642),
    [anon_sym_PIPE_PIPE] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(642),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_QMARK_QMARK] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(644),
    [sym__rangeOperator] = ACTIONS(642),
    [anon_sym_null] = ACTIONS(644),
    [anon_sym_dynamic] = ACTIONS(644),
    [anon_sym_final] = ACTIONS(644),
    [anon_sym_abstract] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(644),
    [anon_sym_extends] = ACTIONS(644),
    [anon_sym_implements] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_typedef] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(644),
    [anon_sym_var] = ACTIONS(644),
    [aux_sym_integer_token1] = ACTIONS(644),
    [aux_sym_integer_token2] = ACTIONS(642),
    [aux_sym_float_token1] = ACTIONS(644),
    [aux_sym_float_token2] = ACTIONS(642),
    [anon_sym_true] = ACTIONS(644),
    [anon_sym_false] = ACTIONS(644),
    [aux_sym_string_token1] = ACTIONS(642),
    [aux_sym_string_token3] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(644),
    [anon_sym_catch] = ACTIONS(644),
    [anon_sym_continue] = ACTIONS(644),
    [anon_sym_do] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(644),
    [anon_sym_extern] = ACTIONS(644),
    [anon_sym_for] = ACTIONS(644),
    [anon_sym_inline] = ACTIONS(644),
    [anon_sym_macro] = ACTIONS(644),
    [anon_sym_operator] = ACTIONS(644),
    [anon_sym_overload] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_return] = ACTIONS(644),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_try] = ACTIONS(644),
    [anon_sym_untyped] = ACTIONS(644),
    [anon_sym_while] = ACTIONS(644),
    [sym__semicolon] = ACTIONS(642),
  },
  [122] = {
    [sym_block] = STATE(241),
    [ts_builtin_sym_end] = ACTIONS(651),
    [sym_identifier] = ACTIONS(653),
    [anon_sym_POUND] = ACTIONS(651),
    [anon_sym_package] = ACTIONS(653),
    [anon_sym_import] = ACTIONS(653),
    [anon_sym_using] = ACTIONS(653),
    [anon_sym_throw] = ACTIONS(653),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(655),
    [anon_sym_RBRACE] = ACTIONS(651),
    [anon_sym_case] = ACTIONS(653),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_default] = ACTIONS(653),
    [anon_sym_cast] = ACTIONS(653),
    [anon_sym_DOLLARtype] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(651),
    [anon_sym_this] = ACTIONS(653),
    [anon_sym_AT] = ACTIONS(653),
    [anon_sym_AT_COLON] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(653),
    [anon_sym_else] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(653),
    [anon_sym_DASH] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(651),
    [anon_sym_DASH_DASH] = ACTIONS(651),
    [anon_sym_PERCENT] = ACTIONS(651),
    [anon_sym_STAR] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(653),
    [anon_sym_PLUS] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(651),
    [anon_sym_GT_GT] = ACTIONS(653),
    [anon_sym_GT_GT_GT] = ACTIONS(651),
    [anon_sym_AMP] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_CARET] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(651),
    [anon_sym_PIPE_PIPE] = ACTIONS(651),
    [anon_sym_EQ_EQ] = ACTIONS(651),
    [anon_sym_BANG_EQ] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(653),
    [anon_sym_LT_EQ] = ACTIONS(651),
    [anon_sym_GT] = ACTIONS(653),
    [anon_sym_GT_EQ] = ACTIONS(651),
    [anon_sym_EQ_GT] = ACTIONS(651),
    [anon_sym_QMARK_QMARK] = ACTIONS(651),
    [anon_sym_EQ] = ACTIONS(653),
    [sym__rangeOperator] = ACTIONS(651),
    [anon_sym_null] = ACTIONS(653),
    [anon_sym_dynamic] = ACTIONS(653),
    [anon_sym_final] = ACTIONS(653),
    [anon_sym_abstract] = ACTIONS(653),
    [anon_sym_class] = ACTIONS(653),
    [anon_sym_extends] = ACTIONS(653),
    [anon_sym_implements] = ACTIONS(653),
    [anon_sym_interface] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(653),
    [anon_sym_function] = ACTIONS(653),
    [anon_sym_var] = ACTIONS(653),
    [aux_sym_integer_token1] = ACTIONS(653),
    [aux_sym_integer_token2] = ACTIONS(651),
    [aux_sym_float_token1] = ACTIONS(653),
    [aux_sym_float_token2] = ACTIONS(651),
    [anon_sym_true] = ACTIONS(653),
    [anon_sym_false] = ACTIONS(653),
    [aux_sym_string_token1] = ACTIONS(651),
    [aux_sym_string_token3] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(653),
    [anon_sym_catch] = ACTIONS(653),
    [anon_sym_continue] = ACTIONS(653),
    [anon_sym_do] = ACTIONS(653),
    [anon_sym_enum] = ACTIONS(653),
    [anon_sym_extern] = ACTIONS(653),
    [anon_sym_for] = ACTIONS(653),
    [anon_sym_inline] = ACTIONS(653),
    [anon_sym_macro] = ACTIONS(653),
    [anon_sym_operator] = ACTIONS(653),
    [anon_sym_overload] = ACTIONS(653),
    [anon_sym_override] = ACTIONS(653),
    [anon_sym_private] = ACTIONS(653),
    [anon_sym_public] = ACTIONS(653),
    [anon_sym_return] = ACTIONS(653),
    [anon_sym_static] = ACTIONS(653),
    [anon_sym_try] = ACTIONS(653),
    [anon_sym_untyped] = ACTIONS(653),
    [anon_sym_while] = ACTIONS(653),
    [sym__semicolon] = ACTIONS(651),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(506),
    [sym_identifier] = ACTIONS(508),
    [anon_sym_POUND] = ACTIONS(506),
    [anon_sym_package] = ACTIONS(508),
    [anon_sym_import] = ACTIONS(508),
    [anon_sym_using] = ACTIONS(508),
    [anon_sym_throw] = ACTIONS(508),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_switch] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_case] = ACTIONS(508),
    [anon_sym_default] = ACTIONS(508),
    [anon_sym_cast] = ACTIONS(508),
    [anon_sym_DOLLARtype] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(508),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_QMARK] = ACTIONS(662),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_AT_COLON] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(508),
    [anon_sym_else] = ACTIONS(508),
    [anon_sym_new] = ACTIONS(508),
    [anon_sym_TILDE] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_EQ_GT] = ACTIONS(590),
    [anon_sym_QMARK_QMARK] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [sym__rangeOperator] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(508),
    [anon_sym_dynamic] = ACTIONS(508),
    [anon_sym_final] = ACTIONS(508),
    [anon_sym_abstract] = ACTIONS(508),
    [anon_sym_class] = ACTIONS(508),
    [anon_sym_extends] = ACTIONS(508),
    [anon_sym_implements] = ACTIONS(508),
    [anon_sym_interface] = ACTIONS(508),
    [anon_sym_typedef] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(508),
    [anon_sym_var] = ACTIONS(508),
    [aux_sym_integer_token1] = ACTIONS(508),
    [aux_sym_integer_token2] = ACTIONS(506),
    [aux_sym_float_token1] = ACTIONS(508),
    [aux_sym_float_token2] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(508),
    [anon_sym_false] = ACTIONS(508),
    [aux_sym_string_token1] = ACTIONS(506),
    [aux_sym_string_token3] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(508),
    [anon_sym_catch] = ACTIONS(508),
    [anon_sym_continue] = ACTIONS(508),
    [anon_sym_do] = ACTIONS(508),
    [anon_sym_enum] = ACTIONS(508),
    [anon_sym_extern] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(508),
    [anon_sym_inline] = ACTIONS(508),
    [anon_sym_macro] = ACTIONS(508),
    [anon_sym_operator] = ACTIONS(508),
    [anon_sym_overload] = ACTIONS(508),
    [anon_sym_override] = ACTIONS(508),
    [anon_sym_private] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(508),
    [anon_sym_return] = ACTIONS(508),
    [anon_sym_static] = ACTIONS(508),
    [anon_sym_try] = ACTIONS(508),
    [anon_sym_untyped] = ACTIONS(508),
    [anon_sym_while] = ACTIONS(508),
    [sym__semicolon] = ACTIONS(506),
  },
  [124] = {
    [sym_block] = STATE(280),
    [ts_builtin_sym_end] = ACTIONS(664),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_POUND] = ACTIONS(664),
    [anon_sym_package] = ACTIONS(666),
    [anon_sym_import] = ACTIONS(666),
    [anon_sym_using] = ACTIONS(666),
    [anon_sym_throw] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(666),
    [anon_sym_default] = ACTIONS(666),
    [anon_sym_cast] = ACTIONS(666),
    [anon_sym_DOLLARtype] = ACTIONS(664),
    [anon_sym_in] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(664),
    [anon_sym_this] = ACTIONS(666),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_AT_COLON] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_TILDE] = ACTIONS(664),
    [anon_sym_BANG] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_PLUS_PLUS] = ACTIONS(664),
    [anon_sym_DASH_DASH] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_GT_GT_GT] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(664),
    [anon_sym_PIPE_PIPE] = ACTIONS(664),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_LT] = ACTIONS(666),
    [anon_sym_LT_EQ] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(664),
    [anon_sym_EQ_GT] = ACTIONS(664),
    [anon_sym_QMARK_QMARK] = ACTIONS(664),
    [anon_sym_EQ] = ACTIONS(666),
    [sym__rangeOperator] = ACTIONS(664),
    [anon_sym_null] = ACTIONS(666),
    [anon_sym_dynamic] = ACTIONS(666),
    [anon_sym_final] = ACTIONS(666),
    [anon_sym_abstract] = ACTIONS(666),
    [anon_sym_class] = ACTIONS(666),
    [anon_sym_extends] = ACTIONS(666),
    [anon_sym_implements] = ACTIONS(666),
    [anon_sym_interface] = ACTIONS(666),
    [anon_sym_typedef] = ACTIONS(666),
    [anon_sym_function] = ACTIONS(666),
    [anon_sym_var] = ACTIONS(666),
    [aux_sym_integer_token1] = ACTIONS(666),
    [aux_sym_integer_token2] = ACTIONS(664),
    [aux_sym_float_token1] = ACTIONS(666),
    [aux_sym_float_token2] = ACTIONS(664),
    [anon_sym_true] = ACTIONS(666),
    [anon_sym_false] = ACTIONS(666),
    [aux_sym_string_token1] = ACTIONS(664),
    [aux_sym_string_token3] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(666),
    [anon_sym_catch] = ACTIONS(666),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_do] = ACTIONS(666),
    [anon_sym_enum] = ACTIONS(666),
    [anon_sym_extern] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_inline] = ACTIONS(666),
    [anon_sym_macro] = ACTIONS(666),
    [anon_sym_operator] = ACTIONS(666),
    [anon_sym_overload] = ACTIONS(666),
    [anon_sym_override] = ACTIONS(666),
    [anon_sym_private] = ACTIONS(666),
    [anon_sym_public] = ACTIONS(666),
    [anon_sym_return] = ACTIONS(666),
    [anon_sym_static] = ACTIONS(666),
    [anon_sym_try] = ACTIONS(666),
    [anon_sym_untyped] = ACTIONS(666),
    [anon_sym_while] = ACTIONS(666),
    [sym__semicolon] = ACTIONS(664),
  },
  [125] = {
    [sym_type_params] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(673),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_POUND] = ACTIONS(673),
    [anon_sym_package] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(676),
    [anon_sym_throw] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_switch] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_case] = ACTIONS(676),
    [anon_sym_default] = ACTIONS(676),
    [anon_sym_cast] = ACTIONS(676),
    [anon_sym_DOLLARtype] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_this] = ACTIONS(676),
    [anon_sym_DASH_GT] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(676),
    [anon_sym_AT_COLON] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(676),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_PERCENT] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_GT_GT_GT] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_PIPE] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_AMP_AMP] = ACTIONS(673),
    [anon_sym_PIPE_PIPE] = ACTIONS(673),
    [anon_sym_EQ_EQ] = ACTIONS(673),
    [anon_sym_BANG_EQ] = ACTIONS(673),
    [anon_sym_LT] = ACTIONS(679),
    [anon_sym_LT_EQ] = ACTIONS(673),
    [anon_sym_GT] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(673),
    [anon_sym_EQ_GT] = ACTIONS(673),
    [anon_sym_QMARK_QMARK] = ACTIONS(673),
    [anon_sym_EQ] = ACTIONS(676),
    [sym__rangeOperator] = ACTIONS(673),
    [anon_sym_null] = ACTIONS(676),
    [anon_sym_dynamic] = ACTIONS(676),
    [anon_sym_final] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_extends] = ACTIONS(676),
    [anon_sym_implements] = ACTIONS(676),
    [anon_sym_interface] = ACTIONS(676),
    [anon_sym_typedef] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(676),
    [anon_sym_var] = ACTIONS(676),
    [aux_sym_integer_token1] = ACTIONS(676),
    [aux_sym_integer_token2] = ACTIONS(673),
    [aux_sym_float_token1] = ACTIONS(676),
    [aux_sym_float_token2] = ACTIONS(673),
    [anon_sym_true] = ACTIONS(676),
    [anon_sym_false] = ACTIONS(676),
    [aux_sym_string_token1] = ACTIONS(673),
    [aux_sym_string_token3] = ACTIONS(673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(676),
    [anon_sym_catch] = ACTIONS(676),
    [anon_sym_continue] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_enum] = ACTIONS(676),
    [anon_sym_extern] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_inline] = ACTIONS(676),
    [anon_sym_macro] = ACTIONS(676),
    [anon_sym_operator] = ACTIONS(676),
    [anon_sym_overload] = ACTIONS(676),
    [anon_sym_override] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_untyped] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [sym__semicolon] = ACTIONS(673),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(683),
    [sym_identifier] = ACTIONS(685),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_package] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(685),
    [anon_sym_using] = ACTIONS(685),
    [anon_sym_throw] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [anon_sym_switch] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_case] = ACTIONS(685),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_cast] = ACTIONS(685),
    [anon_sym_DOLLARtype] = ACTIONS(683),
    [anon_sym_in] = ACTIONS(685),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_this] = ACTIONS(685),
    [anon_sym_DASH_GT] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_AT_COLON] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(685),
    [anon_sym_else] = ACTIONS(685),
    [anon_sym_new] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_PLUS_PLUS] = ACTIONS(683),
    [anon_sym_DASH_DASH] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_LT_LT] = ACTIONS(683),
    [anon_sym_GT_GT] = ACTIONS(685),
    [anon_sym_GT_GT_GT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(685),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym_AMP_AMP] = ACTIONS(683),
    [anon_sym_PIPE_PIPE] = ACTIONS(683),
    [anon_sym_EQ_EQ] = ACTIONS(683),
    [anon_sym_BANG_EQ] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(685),
    [anon_sym_LT_EQ] = ACTIONS(683),
    [anon_sym_GT] = ACTIONS(685),
    [anon_sym_GT_EQ] = ACTIONS(683),
    [anon_sym_EQ_GT] = ACTIONS(683),
    [anon_sym_QMARK_QMARK] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(685),
    [sym__rangeOperator] = ACTIONS(683),
    [anon_sym_null] = ACTIONS(685),
    [anon_sym_dynamic] = ACTIONS(685),
    [anon_sym_final] = ACTIONS(685),
    [anon_sym_abstract] = ACTIONS(685),
    [anon_sym_class] = ACTIONS(685),
    [anon_sym_extends] = ACTIONS(685),
    [anon_sym_implements] = ACTIONS(685),
    [anon_sym_interface] = ACTIONS(685),
    [anon_sym_typedef] = ACTIONS(685),
    [anon_sym_function] = ACTIONS(685),
    [anon_sym_var] = ACTIONS(685),
    [aux_sym_integer_token1] = ACTIONS(685),
    [aux_sym_integer_token2] = ACTIONS(683),
    [aux_sym_float_token1] = ACTIONS(685),
    [aux_sym_float_token2] = ACTIONS(683),
    [anon_sym_true] = ACTIONS(685),
    [anon_sym_false] = ACTIONS(685),
    [aux_sym_string_token1] = ACTIONS(683),
    [aux_sym_string_token3] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(685),
    [anon_sym_catch] = ACTIONS(685),
    [anon_sym_continue] = ACTIONS(685),
    [anon_sym_do] = ACTIONS(685),
    [anon_sym_enum] = ACTIONS(685),
    [anon_sym_extern] = ACTIONS(685),
    [anon_sym_for] = ACTIONS(685),
    [anon_sym_inline] = ACTIONS(685),
    [anon_sym_macro] = ACTIONS(685),
    [anon_sym_operator] = ACTIONS(685),
    [anon_sym_overload] = ACTIONS(685),
    [anon_sym_override] = ACTIONS(685),
    [anon_sym_private] = ACTIONS(685),
    [anon_sym_public] = ACTIONS(685),
    [anon_sym_return] = ACTIONS(685),
    [anon_sym_static] = ACTIONS(685),
    [anon_sym_try] = ACTIONS(685),
    [anon_sym_untyped] = ACTIONS(685),
    [anon_sym_while] = ACTIONS(685),
    [sym__semicolon] = ACTIONS(683),
  },
  [127] = {
    [sym_block] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(687),
    [sym_identifier] = ACTIONS(689),
    [anon_sym_POUND] = ACTIONS(687),
    [anon_sym_package] = ACTIONS(689),
    [anon_sym_import] = ACTIONS(689),
    [anon_sym_using] = ACTIONS(689),
    [anon_sym_throw] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_case] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_cast] = ACTIONS(689),
    [anon_sym_DOLLARtype] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(687),
    [anon_sym_this] = ACTIONS(689),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(689),
    [anon_sym_AT_COLON] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [anon_sym_PERCENT] = ACTIONS(687),
    [anon_sym_STAR] = ACTIONS(687),
    [anon_sym_SLASH] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_LT_LT] = ACTIONS(687),
    [anon_sym_GT_GT] = ACTIONS(689),
    [anon_sym_GT_GT_GT] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(687),
    [anon_sym_AMP_AMP] = ACTIONS(687),
    [anon_sym_PIPE_PIPE] = ACTIONS(687),
    [anon_sym_EQ_EQ] = ACTIONS(687),
    [anon_sym_BANG_EQ] = ACTIONS(687),
    [anon_sym_LT] = ACTIONS(689),
    [anon_sym_LT_EQ] = ACTIONS(687),
    [anon_sym_GT] = ACTIONS(689),
    [anon_sym_GT_EQ] = ACTIONS(687),
    [anon_sym_EQ_GT] = ACTIONS(687),
    [anon_sym_QMARK_QMARK] = ACTIONS(687),
    [anon_sym_EQ] = ACTIONS(689),
    [sym__rangeOperator] = ACTIONS(687),
    [anon_sym_null] = ACTIONS(689),
    [anon_sym_dynamic] = ACTIONS(689),
    [anon_sym_final] = ACTIONS(689),
    [anon_sym_abstract] = ACTIONS(689),
    [anon_sym_class] = ACTIONS(689),
    [anon_sym_extends] = ACTIONS(689),
    [anon_sym_implements] = ACTIONS(689),
    [anon_sym_interface] = ACTIONS(689),
    [anon_sym_typedef] = ACTIONS(689),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_var] = ACTIONS(689),
    [aux_sym_integer_token1] = ACTIONS(689),
    [aux_sym_integer_token2] = ACTIONS(687),
    [aux_sym_float_token1] = ACTIONS(689),
    [aux_sym_float_token2] = ACTIONS(687),
    [anon_sym_true] = ACTIONS(689),
    [anon_sym_false] = ACTIONS(689),
    [aux_sym_string_token1] = ACTIONS(687),
    [aux_sym_string_token3] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(689),
    [anon_sym_catch] = ACTIONS(689),
    [anon_sym_continue] = ACTIONS(689),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_enum] = ACTIONS(689),
    [anon_sym_extern] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(689),
    [anon_sym_inline] = ACTIONS(689),
    [anon_sym_macro] = ACTIONS(689),
    [anon_sym_operator] = ACTIONS(689),
    [anon_sym_overload] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_return] = ACTIONS(689),
    [anon_sym_static] = ACTIONS(689),
    [anon_sym_try] = ACTIONS(689),
    [anon_sym_untyped] = ACTIONS(689),
    [anon_sym_while] = ACTIONS(689),
    [sym__semicolon] = ACTIONS(687),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(694),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(694),
    [anon_sym_package] = ACTIONS(696),
    [anon_sym_import] = ACTIONS(696),
    [anon_sym_using] = ACTIONS(696),
    [anon_sym_throw] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(694),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_case] = ACTIONS(696),
    [anon_sym_default] = ACTIONS(696),
    [anon_sym_cast] = ACTIONS(696),
    [anon_sym_DOLLARtype] = ACTIONS(694),
    [anon_sym_in] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(694),
    [anon_sym_this] = ACTIONS(696),
    [anon_sym_DASH_GT] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(696),
    [anon_sym_AT_COLON] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(696),
    [anon_sym_else] = ACTIONS(696),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(696),
    [anon_sym_DASH] = ACTIONS(696),
    [anon_sym_PLUS_PLUS] = ACTIONS(694),
    [anon_sym_DASH_DASH] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_GT_GT_GT] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(696),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(694),
    [anon_sym_BANG_EQ] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(696),
    [anon_sym_LT_EQ] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(696),
    [anon_sym_GT_EQ] = ACTIONS(694),
    [anon_sym_EQ_GT] = ACTIONS(694),
    [anon_sym_QMARK_QMARK] = ACTIONS(694),
    [anon_sym_EQ] = ACTIONS(696),
    [sym__rangeOperator] = ACTIONS(694),
    [anon_sym_null] = ACTIONS(696),
    [anon_sym_dynamic] = ACTIONS(696),
    [anon_sym_final] = ACTIONS(696),
    [anon_sym_abstract] = ACTIONS(696),
    [anon_sym_class] = ACTIONS(696),
    [anon_sym_extends] = ACTIONS(696),
    [anon_sym_implements] = ACTIONS(696),
    [anon_sym_interface] = ACTIONS(696),
    [anon_sym_typedef] = ACTIONS(696),
    [anon_sym_function] = ACTIONS(696),
    [anon_sym_var] = ACTIONS(696),
    [aux_sym_integer_token1] = ACTIONS(696),
    [aux_sym_integer_token2] = ACTIONS(694),
    [aux_sym_float_token1] = ACTIONS(696),
    [aux_sym_float_token2] = ACTIONS(694),
    [anon_sym_true] = ACTIONS(696),
    [anon_sym_false] = ACTIONS(696),
    [aux_sym_string_token1] = ACTIONS(694),
    [aux_sym_string_token3] = ACTIONS(694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(696),
    [anon_sym_catch] = ACTIONS(696),
    [anon_sym_continue] = ACTIONS(696),
    [anon_sym_do] = ACTIONS(696),
    [anon_sym_enum] = ACTIONS(696),
    [anon_sym_extern] = ACTIONS(696),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_inline] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(696),
    [anon_sym_operator] = ACTIONS(696),
    [anon_sym_overload] = ACTIONS(696),
    [anon_sym_override] = ACTIONS(696),
    [anon_sym_private] = ACTIONS(696),
    [anon_sym_public] = ACTIONS(696),
    [anon_sym_return] = ACTIONS(696),
    [anon_sym_static] = ACTIONS(696),
    [anon_sym_try] = ACTIONS(696),
    [anon_sym_untyped] = ACTIONS(696),
    [anon_sym_while] = ACTIONS(696),
    [sym__semicolon] = ACTIONS(694),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(698),
    [sym_identifier] = ACTIONS(700),
    [anon_sym_POUND] = ACTIONS(698),
    [anon_sym_package] = ACTIONS(700),
    [anon_sym_import] = ACTIONS(700),
    [anon_sym_using] = ACTIONS(700),
    [anon_sym_throw] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_switch] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(698),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_case] = ACTIONS(700),
    [anon_sym_default] = ACTIONS(700),
    [anon_sym_cast] = ACTIONS(700),
    [anon_sym_DOLLARtype] = ACTIONS(698),
    [anon_sym_in] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(698),
    [anon_sym_this] = ACTIONS(700),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(700),
    [anon_sym_AT_COLON] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(700),
    [anon_sym_else] = ACTIONS(700),
    [anon_sym_new] = ACTIONS(700),
    [anon_sym_TILDE] = ACTIONS(698),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(698),
    [anon_sym_DASH_DASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(700),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_AMP_AMP] = ACTIONS(698),
    [anon_sym_PIPE_PIPE] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(700),
    [anon_sym_GT_EQ] = ACTIONS(698),
    [anon_sym_EQ_GT] = ACTIONS(698),
    [anon_sym_QMARK_QMARK] = ACTIONS(698),
    [anon_sym_EQ] = ACTIONS(700),
    [sym__rangeOperator] = ACTIONS(698),
    [anon_sym_null] = ACTIONS(700),
    [anon_sym_dynamic] = ACTIONS(700),
    [anon_sym_final] = ACTIONS(700),
    [anon_sym_abstract] = ACTIONS(700),
    [anon_sym_class] = ACTIONS(700),
    [anon_sym_extends] = ACTIONS(700),
    [anon_sym_implements] = ACTIONS(700),
    [anon_sym_interface] = ACTIONS(700),
    [anon_sym_typedef] = ACTIONS(700),
    [anon_sym_function] = ACTIONS(700),
    [anon_sym_var] = ACTIONS(700),
    [aux_sym_integer_token1] = ACTIONS(700),
    [aux_sym_integer_token2] = ACTIONS(698),
    [aux_sym_float_token1] = ACTIONS(700),
    [aux_sym_float_token2] = ACTIONS(698),
    [anon_sym_true] = ACTIONS(700),
    [anon_sym_false] = ACTIONS(700),
    [aux_sym_string_token1] = ACTIONS(698),
    [aux_sym_string_token3] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(700),
    [anon_sym_catch] = ACTIONS(700),
    [anon_sym_continue] = ACTIONS(700),
    [anon_sym_do] = ACTIONS(700),
    [anon_sym_enum] = ACTIONS(700),
    [anon_sym_extern] = ACTIONS(700),
    [anon_sym_for] = ACTIONS(700),
    [anon_sym_inline] = ACTIONS(700),
    [anon_sym_macro] = ACTIONS(700),
    [anon_sym_operator] = ACTIONS(700),
    [anon_sym_overload] = ACTIONS(700),
    [anon_sym_override] = ACTIONS(700),
    [anon_sym_private] = ACTIONS(700),
    [anon_sym_public] = ACTIONS(700),
    [anon_sym_return] = ACTIONS(700),
    [anon_sym_static] = ACTIONS(700),
    [anon_sym_try] = ACTIONS(700),
    [anon_sym_untyped] = ACTIONS(700),
    [anon_sym_while] = ACTIONS(700),
    [sym__semicolon] = ACTIONS(698),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(702),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_POUND] = ACTIONS(702),
    [anon_sym_package] = ACTIONS(704),
    [anon_sym_import] = ACTIONS(704),
    [anon_sym_using] = ACTIONS(704),
    [anon_sym_throw] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_switch] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_case] = ACTIONS(704),
    [anon_sym_default] = ACTIONS(704),
    [anon_sym_cast] = ACTIONS(704),
    [anon_sym_DOLLARtype] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
    [anon_sym_LBRACK] = ACTIONS(702),
    [anon_sym_this] = ACTIONS(704),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_AT_COLON] = ACTIONS(702),
    [anon_sym_if] = ACTIONS(704),
    [anon_sym_else] = ACTIONS(704),
    [anon_sym_new] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_EQ_GT] = ACTIONS(702),
    [anon_sym_QMARK_QMARK] = ACTIONS(702),
    [anon_sym_EQ] = ACTIONS(704),
    [sym__rangeOperator] = ACTIONS(702),
    [anon_sym_null] = ACTIONS(704),
    [anon_sym_dynamic] = ACTIONS(704),
    [anon_sym_final] = ACTIONS(704),
    [anon_sym_abstract] = ACTIONS(704),
    [anon_sym_class] = ACTIONS(704),
    [anon_sym_extends] = ACTIONS(704),
    [anon_sym_implements] = ACTIONS(704),
    [anon_sym_interface] = ACTIONS(704),
    [anon_sym_typedef] = ACTIONS(704),
    [anon_sym_function] = ACTIONS(704),
    [anon_sym_var] = ACTIONS(704),
    [aux_sym_integer_token1] = ACTIONS(704),
    [aux_sym_integer_token2] = ACTIONS(702),
    [aux_sym_float_token1] = ACTIONS(704),
    [aux_sym_float_token2] = ACTIONS(702),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(704),
    [aux_sym_string_token1] = ACTIONS(702),
    [aux_sym_string_token3] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(704),
    [anon_sym_catch] = ACTIONS(704),
    [anon_sym_continue] = ACTIONS(704),
    [anon_sym_do] = ACTIONS(704),
    [anon_sym_enum] = ACTIONS(704),
    [anon_sym_extern] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_inline] = ACTIONS(704),
    [anon_sym_macro] = ACTIONS(704),
    [anon_sym_operator] = ACTIONS(704),
    [anon_sym_overload] = ACTIONS(704),
    [anon_sym_override] = ACTIONS(704),
    [anon_sym_private] = ACTIONS(704),
    [anon_sym_public] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(704),
    [anon_sym_static] = ACTIONS(704),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_untyped] = ACTIONS(704),
    [anon_sym_while] = ACTIONS(704),
    [sym__semicolon] = ACTIONS(702),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(706),
    [sym_identifier] = ACTIONS(708),
    [anon_sym_POUND] = ACTIONS(706),
    [anon_sym_package] = ACTIONS(708),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_using] = ACTIONS(708),
    [anon_sym_throw] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_switch] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(706),
    [anon_sym_RBRACE] = ACTIONS(706),
    [anon_sym_case] = ACTIONS(708),
    [anon_sym_default] = ACTIONS(708),
    [anon_sym_cast] = ACTIONS(708),
    [anon_sym_DOLLARtype] = ACTIONS(706),
    [anon_sym_in] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(706),
    [anon_sym_this] = ACTIONS(708),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_AT_COLON] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(708),
    [anon_sym_else] = ACTIONS(708),
    [anon_sym_new] = ACTIONS(708),
    [anon_sym_TILDE] = ACTIONS(706),
    [anon_sym_BANG] = ACTIONS(708),
    [anon_sym_DASH] = ACTIONS(708),
    [anon_sym_PLUS_PLUS] = ACTIONS(706),
    [anon_sym_DASH_DASH] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(708),
    [anon_sym_PLUS] = ACTIONS(708),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(708),
    [anon_sym_GT_GT_GT] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(708),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_AMP_AMP] = ACTIONS(706),
    [anon_sym_PIPE_PIPE] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(706),
    [anon_sym_LT] = ACTIONS(708),
    [anon_sym_LT_EQ] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(708),
    [anon_sym_GT_EQ] = ACTIONS(706),
    [anon_sym_EQ_GT] = ACTIONS(706),
    [anon_sym_QMARK_QMARK] = ACTIONS(706),
    [anon_sym_EQ] = ACTIONS(708),
    [sym__rangeOperator] = ACTIONS(706),
    [anon_sym_null] = ACTIONS(708),
    [anon_sym_dynamic] = ACTIONS(708),
    [anon_sym_final] = ACTIONS(708),
    [anon_sym_abstract] = ACTIONS(708),
    [anon_sym_class] = ACTIONS(708),
    [anon_sym_extends] = ACTIONS(708),
    [anon_sym_implements] = ACTIONS(708),
    [anon_sym_interface] = ACTIONS(708),
    [anon_sym_typedef] = ACTIONS(708),
    [anon_sym_function] = ACTIONS(708),
    [anon_sym_var] = ACTIONS(708),
    [aux_sym_integer_token1] = ACTIONS(708),
    [aux_sym_integer_token2] = ACTIONS(706),
    [aux_sym_float_token1] = ACTIONS(708),
    [aux_sym_float_token2] = ACTIONS(706),
    [anon_sym_true] = ACTIONS(708),
    [anon_sym_false] = ACTIONS(708),
    [aux_sym_string_token1] = ACTIONS(706),
    [aux_sym_string_token3] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(708),
    [anon_sym_catch] = ACTIONS(708),
    [anon_sym_continue] = ACTIONS(708),
    [anon_sym_do] = ACTIONS(708),
    [anon_sym_enum] = ACTIONS(708),
    [anon_sym_extern] = ACTIONS(708),
    [anon_sym_for] = ACTIONS(708),
    [anon_sym_inline] = ACTIONS(708),
    [anon_sym_macro] = ACTIONS(708),
    [anon_sym_operator] = ACTIONS(708),
    [anon_sym_overload] = ACTIONS(708),
    [anon_sym_override] = ACTIONS(708),
    [anon_sym_private] = ACTIONS(708),
    [anon_sym_public] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(708),
    [anon_sym_static] = ACTIONS(708),
    [anon_sym_try] = ACTIONS(708),
    [anon_sym_untyped] = ACTIONS(708),
    [anon_sym_while] = ACTIONS(708),
    [sym__semicolon] = ACTIONS(706),
  },
  [132] = {
    [sym_type_params] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(710),
    [sym_identifier] = ACTIONS(713),
    [anon_sym_POUND] = ACTIONS(710),
    [anon_sym_package] = ACTIONS(713),
    [anon_sym_import] = ACTIONS(713),
    [anon_sym_using] = ACTIONS(713),
    [anon_sym_throw] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(710),
    [anon_sym_RBRACE] = ACTIONS(710),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_cast] = ACTIONS(713),
    [anon_sym_DOLLARtype] = ACTIONS(710),
    [anon_sym_in] = ACTIONS(713),
    [anon_sym_LBRACK] = ACTIONS(710),
    [anon_sym_this] = ACTIONS(713),
    [anon_sym_DASH_GT] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(713),
    [anon_sym_AT_COLON] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_else] = ACTIONS(713),
    [anon_sym_new] = ACTIONS(713),
    [anon_sym_TILDE] = ACTIONS(710),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PLUS_PLUS] = ACTIONS(710),
    [anon_sym_DASH_DASH] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(713),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(713),
    [anon_sym_GT_GT_GT] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(713),
    [anon_sym_CARET] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(710),
    [anon_sym_PIPE_PIPE] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(716),
    [anon_sym_LT_EQ] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(710),
    [anon_sym_EQ_GT] = ACTIONS(710),
    [anon_sym_QMARK_QMARK] = ACTIONS(710),
    [anon_sym_EQ] = ACTIONS(713),
    [sym__rangeOperator] = ACTIONS(710),
    [anon_sym_null] = ACTIONS(713),
    [anon_sym_dynamic] = ACTIONS(713),
    [anon_sym_final] = ACTIONS(713),
    [anon_sym_abstract] = ACTIONS(713),
    [anon_sym_class] = ACTIONS(713),
    [anon_sym_extends] = ACTIONS(713),
    [anon_sym_implements] = ACTIONS(713),
    [anon_sym_interface] = ACTIONS(713),
    [anon_sym_typedef] = ACTIONS(713),
    [anon_sym_function] = ACTIONS(713),
    [anon_sym_var] = ACTIONS(713),
    [aux_sym_integer_token1] = ACTIONS(713),
    [aux_sym_integer_token2] = ACTIONS(710),
    [aux_sym_float_token1] = ACTIONS(713),
    [aux_sym_float_token2] = ACTIONS(710),
    [anon_sym_true] = ACTIONS(713),
    [anon_sym_false] = ACTIONS(713),
    [aux_sym_string_token1] = ACTIONS(710),
    [aux_sym_string_token3] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(713),
    [anon_sym_catch] = ACTIONS(713),
    [anon_sym_continue] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(713),
    [anon_sym_enum] = ACTIONS(713),
    [anon_sym_extern] = ACTIONS(713),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_inline] = ACTIONS(713),
    [anon_sym_macro] = ACTIONS(713),
    [anon_sym_operator] = ACTIONS(713),
    [anon_sym_overload] = ACTIONS(713),
    [anon_sym_override] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_return] = ACTIONS(713),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(713),
    [anon_sym_untyped] = ACTIONS(713),
    [anon_sym_while] = ACTIONS(713),
    [sym__semicolon] = ACTIONS(710),
  },
  [133] = {
    [sym_block] = STATE(201),
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_POUND] = ACTIONS(720),
    [anon_sym_package] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(722),
    [anon_sym_using] = ACTIONS(722),
    [anon_sym_throw] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(720),
    [anon_sym_switch] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_case] = ACTIONS(722),
    [anon_sym_COLON] = ACTIONS(727),
    [anon_sym_default] = ACTIONS(722),
    [anon_sym_cast] = ACTIONS(722),
    [anon_sym_DOLLARtype] = ACTIONS(720),
    [anon_sym_in] = ACTIONS(722),
    [anon_sym_LBRACK] = ACTIONS(720),
    [anon_sym_this] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(722),
    [anon_sym_AT_COLON] = ACTIONS(720),
    [anon_sym_if] = ACTIONS(722),
    [anon_sym_else] = ACTIONS(722),
    [anon_sym_new] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(720),
    [anon_sym_DASH_DASH] = ACTIONS(720),
    [anon_sym_PERCENT] = ACTIONS(720),
    [anon_sym_STAR] = ACTIONS(720),
    [anon_sym_SLASH] = ACTIONS(722),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_LT_LT] = ACTIONS(720),
    [anon_sym_GT_GT] = ACTIONS(722),
    [anon_sym_GT_GT_GT] = ACTIONS(720),
    [anon_sym_AMP] = ACTIONS(722),
    [anon_sym_PIPE] = ACTIONS(722),
    [anon_sym_CARET] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT] = ACTIONS(722),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_EQ_GT] = ACTIONS(720),
    [anon_sym_QMARK_QMARK] = ACTIONS(720),
    [anon_sym_EQ] = ACTIONS(722),
    [sym__rangeOperator] = ACTIONS(720),
    [anon_sym_null] = ACTIONS(722),
    [anon_sym_dynamic] = ACTIONS(722),
    [anon_sym_final] = ACTIONS(722),
    [anon_sym_abstract] = ACTIONS(722),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_extends] = ACTIONS(722),
    [anon_sym_implements] = ACTIONS(722),
    [anon_sym_interface] = ACTIONS(722),
    [anon_sym_typedef] = ACTIONS(722),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_var] = ACTIONS(722),
    [aux_sym_integer_token1] = ACTIONS(722),
    [aux_sym_integer_token2] = ACTIONS(720),
    [aux_sym_float_token1] = ACTIONS(722),
    [aux_sym_float_token2] = ACTIONS(720),
    [anon_sym_true] = ACTIONS(722),
    [anon_sym_false] = ACTIONS(722),
    [aux_sym_string_token1] = ACTIONS(720),
    [aux_sym_string_token3] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(722),
    [anon_sym_catch] = ACTIONS(722),
    [anon_sym_continue] = ACTIONS(722),
    [anon_sym_do] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_extern] = ACTIONS(722),
    [anon_sym_for] = ACTIONS(722),
    [anon_sym_inline] = ACTIONS(722),
    [anon_sym_macro] = ACTIONS(722),
    [anon_sym_operator] = ACTIONS(722),
    [anon_sym_overload] = ACTIONS(722),
    [anon_sym_override] = ACTIONS(722),
    [anon_sym_private] = ACTIONS(722),
    [anon_sym_public] = ACTIONS(722),
    [anon_sym_return] = ACTIONS(722),
    [anon_sym_static] = ACTIONS(722),
    [anon_sym_try] = ACTIONS(722),
    [anon_sym_untyped] = ACTIONS(722),
    [anon_sym_while] = ACTIONS(722),
    [sym__semicolon] = ACTIONS(720),
  },
  [134] = {
    [sym_block] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(729),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_POUND] = ACTIONS(729),
    [anon_sym_package] = ACTIONS(731),
    [anon_sym_import] = ACTIONS(731),
    [anon_sym_using] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(729),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_case] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_cast] = ACTIONS(731),
    [anon_sym_DOLLARtype] = ACTIONS(729),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(729),
    [anon_sym_this] = ACTIONS(731),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(731),
    [anon_sym_AT_COLON] = ACTIONS(729),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_TILDE] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [anon_sym_PERCENT] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(729),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_LT_LT] = ACTIONS(729),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_GT_GT_GT] = ACTIONS(729),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(729),
    [anon_sym_AMP_AMP] = ACTIONS(729),
    [anon_sym_PIPE_PIPE] = ACTIONS(729),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(729),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_LT_EQ] = ACTIONS(729),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(729),
    [anon_sym_QMARK_QMARK] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(731),
    [sym__rangeOperator] = ACTIONS(729),
    [anon_sym_null] = ACTIONS(731),
    [anon_sym_dynamic] = ACTIONS(731),
    [anon_sym_final] = ACTIONS(731),
    [anon_sym_abstract] = ACTIONS(731),
    [anon_sym_class] = ACTIONS(731),
    [anon_sym_extends] = ACTIONS(731),
    [anon_sym_implements] = ACTIONS(731),
    [anon_sym_interface] = ACTIONS(731),
    [anon_sym_typedef] = ACTIONS(731),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_var] = ACTIONS(731),
    [aux_sym_integer_token1] = ACTIONS(731),
    [aux_sym_integer_token2] = ACTIONS(729),
    [aux_sym_float_token1] = ACTIONS(731),
    [aux_sym_float_token2] = ACTIONS(729),
    [anon_sym_true] = ACTIONS(731),
    [anon_sym_false] = ACTIONS(731),
    [aux_sym_string_token1] = ACTIONS(729),
    [aux_sym_string_token3] = ACTIONS(729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(731),
    [anon_sym_catch] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_enum] = ACTIONS(731),
    [anon_sym_extern] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_inline] = ACTIONS(731),
    [anon_sym_macro] = ACTIONS(731),
    [anon_sym_operator] = ACTIONS(731),
    [anon_sym_overload] = ACTIONS(731),
    [anon_sym_override] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_try] = ACTIONS(731),
    [anon_sym_untyped] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [sym__semicolon] = ACTIONS(729),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(510),
    [sym_identifier] = ACTIONS(512),
    [anon_sym_POUND] = ACTIONS(510),
    [anon_sym_package] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(512),
    [anon_sym_throw] = ACTIONS(512),
    [anon_sym_LPAREN] = ACTIONS(510),
    [anon_sym_switch] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(510),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_case] = ACTIONS(512),
    [anon_sym_default] = ACTIONS(512),
    [anon_sym_cast] = ACTIONS(512),
    [anon_sym_DOLLARtype] = ACTIONS(510),
    [anon_sym_in] = ACTIONS(512),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_this] = ACTIONS(512),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_QMARK] = ACTIONS(512),
    [anon_sym_AT] = ACTIONS(512),
    [anon_sym_AT_COLON] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(512),
    [anon_sym_else] = ACTIONS(512),
    [anon_sym_new] = ACTIONS(512),
    [anon_sym_TILDE] = ACTIONS(510),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_DASH] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(510),
    [anon_sym_DASH_DASH] = ACTIONS(510),
    [anon_sym_PERCENT] = ACTIONS(510),
    [anon_sym_STAR] = ACTIONS(510),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_PLUS] = ACTIONS(512),
    [anon_sym_LT_LT] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(512),
    [anon_sym_GT_GT_GT] = ACTIONS(510),
    [anon_sym_AMP] = ACTIONS(512),
    [anon_sym_PIPE] = ACTIONS(512),
    [anon_sym_CARET] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(510),
    [anon_sym_PIPE_PIPE] = ACTIONS(510),
    [anon_sym_EQ_EQ] = ACTIONS(510),
    [anon_sym_BANG_EQ] = ACTIONS(510),
    [anon_sym_LT] = ACTIONS(512),
    [anon_sym_LT_EQ] = ACTIONS(510),
    [anon_sym_GT] = ACTIONS(512),
    [anon_sym_GT_EQ] = ACTIONS(510),
    [anon_sym_EQ_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(510),
    [anon_sym_EQ] = ACTIONS(512),
    [sym__rangeOperator] = ACTIONS(510),
    [anon_sym_null] = ACTIONS(512),
    [anon_sym_dynamic] = ACTIONS(512),
    [anon_sym_final] = ACTIONS(512),
    [anon_sym_abstract] = ACTIONS(512),
    [anon_sym_class] = ACTIONS(512),
    [anon_sym_extends] = ACTIONS(512),
    [anon_sym_implements] = ACTIONS(512),
    [anon_sym_interface] = ACTIONS(512),
    [anon_sym_typedef] = ACTIONS(512),
    [anon_sym_function] = ACTIONS(512),
    [anon_sym_var] = ACTIONS(512),
    [aux_sym_integer_token1] = ACTIONS(512),
    [aux_sym_integer_token2] = ACTIONS(510),
    [aux_sym_float_token1] = ACTIONS(512),
    [aux_sym_float_token2] = ACTIONS(510),
    [anon_sym_true] = ACTIONS(512),
    [anon_sym_false] = ACTIONS(512),
    [aux_sym_string_token1] = ACTIONS(510),
    [aux_sym_string_token3] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(512),
    [anon_sym_catch] = ACTIONS(512),
    [anon_sym_continue] = ACTIONS(512),
    [anon_sym_do] = ACTIONS(512),
    [anon_sym_enum] = ACTIONS(512),
    [anon_sym_extern] = ACTIONS(512),
    [anon_sym_for] = ACTIONS(512),
    [anon_sym_inline] = ACTIONS(512),
    [anon_sym_macro] = ACTIONS(512),
    [anon_sym_operator] = ACTIONS(512),
    [anon_sym_overload] = ACTIONS(512),
    [anon_sym_override] = ACTIONS(512),
    [anon_sym_private] = ACTIONS(512),
    [anon_sym_public] = ACTIONS(512),
    [anon_sym_return] = ACTIONS(512),
    [anon_sym_static] = ACTIONS(512),
    [anon_sym_try] = ACTIONS(512),
    [anon_sym_untyped] = ACTIONS(512),
    [anon_sym_while] = ACTIONS(512),
    [sym__semicolon] = ACTIONS(510),
  },
  [136] = {
    [sym_block] = STATE(162),
    [ts_builtin_sym_end] = ACTIONS(736),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(736),
    [anon_sym_package] = ACTIONS(738),
    [anon_sym_import] = ACTIONS(738),
    [anon_sym_using] = ACTIONS(738),
    [anon_sym_throw] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_switch] = ACTIONS(738),
    [anon_sym_LBRACE] = ACTIONS(740),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_case] = ACTIONS(738),
    [anon_sym_default] = ACTIONS(738),
    [anon_sym_cast] = ACTIONS(738),
    [anon_sym_DOLLARtype] = ACTIONS(736),
    [anon_sym_in] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_this] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(738),
    [anon_sym_AT_COLON] = ACTIONS(736),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_else] = ACTIONS(742),
    [anon_sym_elseif] = ACTIONS(744),
    [anon_sym_new] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_DASH] = ACTIONS(738),
    [anon_sym_PLUS_PLUS] = ACTIONS(736),
    [anon_sym_DASH_DASH] = ACTIONS(736),
    [anon_sym_PERCENT] = ACTIONS(736),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_SLASH] = ACTIONS(738),
    [anon_sym_PLUS] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(736),
    [anon_sym_GT_GT] = ACTIONS(738),
    [anon_sym_GT_GT_GT] = ACTIONS(736),
    [anon_sym_AMP] = ACTIONS(738),
    [anon_sym_PIPE] = ACTIONS(738),
    [anon_sym_CARET] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_LT] = ACTIONS(738),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT] = ACTIONS(738),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_EQ_GT] = ACTIONS(736),
    [anon_sym_QMARK_QMARK] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(738),
    [sym__rangeOperator] = ACTIONS(736),
    [anon_sym_null] = ACTIONS(738),
    [anon_sym_dynamic] = ACTIONS(738),
    [anon_sym_final] = ACTIONS(738),
    [anon_sym_abstract] = ACTIONS(738),
    [anon_sym_class] = ACTIONS(738),
    [anon_sym_extends] = ACTIONS(738),
    [anon_sym_implements] = ACTIONS(738),
    [anon_sym_interface] = ACTIONS(738),
    [anon_sym_typedef] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_var] = ACTIONS(738),
    [aux_sym_integer_token1] = ACTIONS(738),
    [aux_sym_integer_token2] = ACTIONS(736),
    [aux_sym_float_token1] = ACTIONS(738),
    [aux_sym_float_token2] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(738),
    [anon_sym_false] = ACTIONS(738),
    [aux_sym_string_token1] = ACTIONS(736),
    [aux_sym_string_token3] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(738),
    [anon_sym_catch] = ACTIONS(738),
    [anon_sym_continue] = ACTIONS(738),
    [anon_sym_do] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_extern] = ACTIONS(738),
    [anon_sym_for] = ACTIONS(738),
    [anon_sym_inline] = ACTIONS(738),
    [anon_sym_macro] = ACTIONS(738),
    [anon_sym_operator] = ACTIONS(738),
    [anon_sym_overload] = ACTIONS(738),
    [anon_sym_override] = ACTIONS(738),
    [anon_sym_private] = ACTIONS(738),
    [anon_sym_public] = ACTIONS(738),
    [anon_sym_return] = ACTIONS(738),
    [anon_sym_static] = ACTIONS(738),
    [anon_sym_try] = ACTIONS(738),
    [anon_sym_untyped] = ACTIONS(738),
    [anon_sym_while] = ACTIONS(738),
    [sym__semicolon] = ACTIONS(736),
  },
  [137] = {
    [sym_block] = STATE(220),
    [ts_builtin_sym_end] = ACTIONS(746),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_POUND] = ACTIONS(746),
    [anon_sym_package] = ACTIONS(748),
    [anon_sym_import] = ACTIONS(748),
    [anon_sym_using] = ACTIONS(748),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LPAREN] = ACTIONS(746),
    [anon_sym_switch] = ACTIONS(748),
    [anon_sym_LBRACE] = ACTIONS(750),
    [anon_sym_RBRACE] = ACTIONS(746),
    [anon_sym_case] = ACTIONS(748),
    [anon_sym_COLON] = ACTIONS(753),
    [anon_sym_default] = ACTIONS(748),
    [anon_sym_cast] = ACTIONS(748),
    [anon_sym_DOLLARtype] = ACTIONS(746),
    [anon_sym_in] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(746),
    [anon_sym_this] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(748),
    [anon_sym_AT_COLON] = ACTIONS(746),
    [anon_sym_if] = ACTIONS(748),
    [anon_sym_else] = ACTIONS(748),
    [anon_sym_new] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(746),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_DASH] = ACTIONS(748),
    [anon_sym_PLUS_PLUS] = ACTIONS(746),
    [anon_sym_DASH_DASH] = ACTIONS(746),
    [anon_sym_PERCENT] = ACTIONS(746),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_PLUS] = ACTIONS(748),
    [anon_sym_LT_LT] = ACTIONS(746),
    [anon_sym_GT_GT] = ACTIONS(748),
    [anon_sym_GT_GT_GT] = ACTIONS(746),
    [anon_sym_AMP] = ACTIONS(748),
    [anon_sym_PIPE] = ACTIONS(748),
    [anon_sym_CARET] = ACTIONS(746),
    [anon_sym_AMP_AMP] = ACTIONS(746),
    [anon_sym_PIPE_PIPE] = ACTIONS(746),
    [anon_sym_EQ_EQ] = ACTIONS(746),
    [anon_sym_BANG_EQ] = ACTIONS(746),
    [anon_sym_LT] = ACTIONS(748),
    [anon_sym_LT_EQ] = ACTIONS(746),
    [anon_sym_GT] = ACTIONS(748),
    [anon_sym_GT_EQ] = ACTIONS(746),
    [anon_sym_EQ_GT] = ACTIONS(746),
    [anon_sym_QMARK_QMARK] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(748),
    [sym__rangeOperator] = ACTIONS(746),
    [anon_sym_null] = ACTIONS(748),
    [anon_sym_dynamic] = ACTIONS(748),
    [anon_sym_final] = ACTIONS(748),
    [anon_sym_abstract] = ACTIONS(748),
    [anon_sym_class] = ACTIONS(748),
    [anon_sym_extends] = ACTIONS(748),
    [anon_sym_implements] = ACTIONS(748),
    [anon_sym_interface] = ACTIONS(748),
    [anon_sym_typedef] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(748),
    [anon_sym_var] = ACTIONS(748),
    [aux_sym_integer_token1] = ACTIONS(748),
    [aux_sym_integer_token2] = ACTIONS(746),
    [aux_sym_float_token1] = ACTIONS(748),
    [aux_sym_float_token2] = ACTIONS(746),
    [anon_sym_true] = ACTIONS(748),
    [anon_sym_false] = ACTIONS(748),
    [aux_sym_string_token1] = ACTIONS(746),
    [aux_sym_string_token3] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(748),
    [anon_sym_catch] = ACTIONS(748),
    [anon_sym_continue] = ACTIONS(748),
    [anon_sym_do] = ACTIONS(748),
    [anon_sym_enum] = ACTIONS(748),
    [anon_sym_extern] = ACTIONS(748),
    [anon_sym_for] = ACTIONS(748),
    [anon_sym_inline] = ACTIONS(748),
    [anon_sym_macro] = ACTIONS(748),
    [anon_sym_operator] = ACTIONS(748),
    [anon_sym_overload] = ACTIONS(748),
    [anon_sym_override] = ACTIONS(748),
    [anon_sym_private] = ACTIONS(748),
    [anon_sym_public] = ACTIONS(748),
    [anon_sym_return] = ACTIONS(748),
    [anon_sym_static] = ACTIONS(748),
    [anon_sym_try] = ACTIONS(748),
    [anon_sym_untyped] = ACTIONS(748),
    [anon_sym_while] = ACTIONS(748),
    [sym__semicolon] = ACTIONS(746),
  },
  [138] = {
    [sym_block] = STATE(276),
    [ts_builtin_sym_end] = ACTIONS(755),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_POUND] = ACTIONS(755),
    [anon_sym_package] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(757),
    [anon_sym_using] = ACTIONS(757),
    [anon_sym_throw] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(757),
    [anon_sym_LBRACE] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_default] = ACTIONS(757),
    [anon_sym_cast] = ACTIONS(757),
    [anon_sym_DOLLARtype] = ACTIONS(755),
    [anon_sym_in] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(755),
    [anon_sym_this] = ACTIONS(757),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(757),
    [anon_sym_AT_COLON] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_new] = ACTIONS(757),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_PERCENT] = ACTIONS(755),
    [anon_sym_STAR] = ACTIONS(755),
    [anon_sym_SLASH] = ACTIONS(757),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_LT_LT] = ACTIONS(755),
    [anon_sym_GT_GT] = ACTIONS(757),
    [anon_sym_GT_GT_GT] = ACTIONS(755),
    [anon_sym_AMP] = ACTIONS(757),
    [anon_sym_PIPE] = ACTIONS(757),
    [anon_sym_CARET] = ACTIONS(755),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_EQ_EQ] = ACTIONS(755),
    [anon_sym_BANG_EQ] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_LT_EQ] = ACTIONS(755),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_EQ] = ACTIONS(755),
    [anon_sym_EQ_GT] = ACTIONS(755),
    [anon_sym_QMARK_QMARK] = ACTIONS(755),
    [anon_sym_EQ] = ACTIONS(757),
    [sym__rangeOperator] = ACTIONS(755),
    [anon_sym_null] = ACTIONS(757),
    [anon_sym_dynamic] = ACTIONS(757),
    [anon_sym_final] = ACTIONS(757),
    [anon_sym_abstract] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(757),
    [anon_sym_extends] = ACTIONS(757),
    [anon_sym_implements] = ACTIONS(757),
    [anon_sym_interface] = ACTIONS(757),
    [anon_sym_typedef] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(757),
    [anon_sym_var] = ACTIONS(757),
    [aux_sym_integer_token1] = ACTIONS(757),
    [aux_sym_integer_token2] = ACTIONS(755),
    [aux_sym_float_token1] = ACTIONS(757),
    [aux_sym_float_token2] = ACTIONS(755),
    [anon_sym_true] = ACTIONS(757),
    [anon_sym_false] = ACTIONS(757),
    [aux_sym_string_token1] = ACTIONS(755),
    [aux_sym_string_token3] = ACTIONS(755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(757),
    [anon_sym_catch] = ACTIONS(757),
    [anon_sym_continue] = ACTIONS(757),
    [anon_sym_do] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_extern] = ACTIONS(757),
    [anon_sym_for] = ACTIONS(757),
    [anon_sym_inline] = ACTIONS(757),
    [anon_sym_macro] = ACTIONS(757),
    [anon_sym_operator] = ACTIONS(757),
    [anon_sym_overload] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_return] = ACTIONS(757),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_try] = ACTIONS(757),
    [anon_sym_untyped] = ACTIONS(757),
    [anon_sym_while] = ACTIONS(757),
    [sym__semicolon] = ACTIONS(755),
  },
  [139] = {
    [sym_block] = STATE(239),
    [ts_builtin_sym_end] = ACTIONS(762),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(762),
    [anon_sym_package] = ACTIONS(764),
    [anon_sym_import] = ACTIONS(764),
    [anon_sym_using] = ACTIONS(764),
    [anon_sym_throw] = ACTIONS(764),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_switch] = ACTIONS(764),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(762),
    [anon_sym_case] = ACTIONS(764),
    [anon_sym_default] = ACTIONS(764),
    [anon_sym_cast] = ACTIONS(764),
    [anon_sym_DOLLARtype] = ACTIONS(762),
    [anon_sym_in] = ACTIONS(764),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_this] = ACTIONS(764),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(764),
    [anon_sym_AT_COLON] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_else] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(764),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_BANG] = ACTIONS(764),
    [anon_sym_DASH] = ACTIONS(764),
    [anon_sym_PLUS_PLUS] = ACTIONS(762),
    [anon_sym_DASH_DASH] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(762),
    [anon_sym_STAR] = ACTIONS(762),
    [anon_sym_SLASH] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(764),
    [anon_sym_GT_GT_GT] = ACTIONS(762),
    [anon_sym_AMP] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_CARET] = ACTIONS(762),
    [anon_sym_AMP_AMP] = ACTIONS(762),
    [anon_sym_PIPE_PIPE] = ACTIONS(762),
    [anon_sym_EQ_EQ] = ACTIONS(762),
    [anon_sym_BANG_EQ] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(762),
    [anon_sym_GT] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(762),
    [anon_sym_EQ_GT] = ACTIONS(762),
    [anon_sym_QMARK_QMARK] = ACTIONS(762),
    [anon_sym_EQ] = ACTIONS(764),
    [sym__rangeOperator] = ACTIONS(762),
    [anon_sym_null] = ACTIONS(764),
    [anon_sym_dynamic] = ACTIONS(764),
    [anon_sym_final] = ACTIONS(764),
    [anon_sym_abstract] = ACTIONS(764),
    [anon_sym_class] = ACTIONS(764),
    [anon_sym_extends] = ACTIONS(764),
    [anon_sym_implements] = ACTIONS(764),
    [anon_sym_interface] = ACTIONS(764),
    [anon_sym_typedef] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(764),
    [anon_sym_var] = ACTIONS(764),
    [aux_sym_integer_token1] = ACTIONS(764),
    [aux_sym_integer_token2] = ACTIONS(762),
    [aux_sym_float_token1] = ACTIONS(764),
    [aux_sym_float_token2] = ACTIONS(762),
    [anon_sym_true] = ACTIONS(764),
    [anon_sym_false] = ACTIONS(764),
    [aux_sym_string_token1] = ACTIONS(762),
    [aux_sym_string_token3] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(764),
    [anon_sym_catch] = ACTIONS(764),
    [anon_sym_continue] = ACTIONS(764),
    [anon_sym_do] = ACTIONS(764),
    [anon_sym_enum] = ACTIONS(764),
    [anon_sym_extern] = ACTIONS(764),
    [anon_sym_for] = ACTIONS(764),
    [anon_sym_inline] = ACTIONS(764),
    [anon_sym_macro] = ACTIONS(764),
    [anon_sym_operator] = ACTIONS(764),
    [anon_sym_overload] = ACTIONS(764),
    [anon_sym_override] = ACTIONS(764),
    [anon_sym_private] = ACTIONS(764),
    [anon_sym_public] = ACTIONS(764),
    [anon_sym_return] = ACTIONS(764),
    [anon_sym_static] = ACTIONS(764),
    [anon_sym_try] = ACTIONS(764),
    [anon_sym_untyped] = ACTIONS(764),
    [anon_sym_while] = ACTIONS(764),
    [sym__semicolon] = ACTIONS(762),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_package] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(771),
    [anon_sym_using] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_cast] = ACTIONS(771),
    [anon_sym_DOLLARtype] = ACTIONS(769),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_this] = ACTIONS(771),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_QMARK] = ACTIONS(512),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_AT_COLON] = ACTIONS(769),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_GT_GT_GT] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(510),
    [anon_sym_QMARK_QMARK] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [sym__rangeOperator] = ACTIONS(769),
    [anon_sym_null] = ACTIONS(771),
    [anon_sym_dynamic] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_extends] = ACTIONS(771),
    [anon_sym_implements] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_var] = ACTIONS(771),
    [aux_sym_integer_token1] = ACTIONS(771),
    [aux_sym_integer_token2] = ACTIONS(769),
    [aux_sym_float_token1] = ACTIONS(771),
    [aux_sym_float_token2] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [aux_sym_string_token1] = ACTIONS(769),
    [aux_sym_string_token3] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_catch] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_macro] = ACTIONS(771),
    [anon_sym_operator] = ACTIONS(771),
    [anon_sym_overload] = ACTIONS(771),
    [anon_sym_override] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_untyped] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [sym__semicolon] = ACTIONS(769),
  },
  [141] = {
    [sym_block] = STATE(173),
    [ts_builtin_sym_end] = ACTIONS(773),
    [sym_identifier] = ACTIONS(775),
    [anon_sym_POUND] = ACTIONS(773),
    [anon_sym_package] = ACTIONS(775),
    [anon_sym_import] = ACTIONS(775),
    [anon_sym_using] = ACTIONS(775),
    [anon_sym_throw] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(775),
    [anon_sym_default] = ACTIONS(775),
    [anon_sym_cast] = ACTIONS(775),
    [anon_sym_DOLLARtype] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(773),
    [anon_sym_this] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(775),
    [anon_sym_AT_COLON] = ACTIONS(773),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_GT_GT_GT] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_CARET] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(773),
    [anon_sym_BANG_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_LT_EQ] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(773),
    [anon_sym_EQ_GT] = ACTIONS(773),
    [anon_sym_QMARK_QMARK] = ACTIONS(773),
    [anon_sym_EQ] = ACTIONS(775),
    [sym__rangeOperator] = ACTIONS(773),
    [anon_sym_null] = ACTIONS(775),
    [anon_sym_dynamic] = ACTIONS(775),
    [anon_sym_final] = ACTIONS(775),
    [anon_sym_abstract] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(775),
    [anon_sym_extends] = ACTIONS(775),
    [anon_sym_implements] = ACTIONS(775),
    [anon_sym_interface] = ACTIONS(775),
    [anon_sym_typedef] = ACTIONS(775),
    [anon_sym_function] = ACTIONS(775),
    [anon_sym_var] = ACTIONS(775),
    [aux_sym_integer_token1] = ACTIONS(775),
    [aux_sym_integer_token2] = ACTIONS(773),
    [aux_sym_float_token1] = ACTIONS(775),
    [aux_sym_float_token2] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_string_token1] = ACTIONS(773),
    [aux_sym_string_token3] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(775),
    [anon_sym_catch] = ACTIONS(775),
    [anon_sym_continue] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(775),
    [anon_sym_extern] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(775),
    [anon_sym_inline] = ACTIONS(775),
    [anon_sym_macro] = ACTIONS(775),
    [anon_sym_operator] = ACTIONS(775),
    [anon_sym_overload] = ACTIONS(775),
    [anon_sym_override] = ACTIONS(775),
    [anon_sym_private] = ACTIONS(775),
    [anon_sym_public] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(775),
    [anon_sym_static] = ACTIONS(775),
    [anon_sym_try] = ACTIONS(775),
    [anon_sym_untyped] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [sym__semicolon] = ACTIONS(773),
  },
  [142] = {
    [sym_block] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(780),
    [sym_identifier] = ACTIONS(782),
    [anon_sym_POUND] = ACTIONS(780),
    [anon_sym_package] = ACTIONS(782),
    [anon_sym_import] = ACTIONS(782),
    [anon_sym_using] = ACTIONS(782),
    [anon_sym_throw] = ACTIONS(782),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_switch] = ACTIONS(782),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_case] = ACTIONS(782),
    [anon_sym_COLON] = ACTIONS(787),
    [anon_sym_default] = ACTIONS(782),
    [anon_sym_cast] = ACTIONS(782),
    [anon_sym_DOLLARtype] = ACTIONS(780),
    [anon_sym_in] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_this] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(782),
    [anon_sym_AT_COLON] = ACTIONS(780),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_else] = ACTIONS(782),
    [anon_sym_new] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_PLUS_PLUS] = ACTIONS(780),
    [anon_sym_DASH_DASH] = ACTIONS(780),
    [anon_sym_PERCENT] = ACTIONS(780),
    [anon_sym_STAR] = ACTIONS(780),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_LT_LT] = ACTIONS(780),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_GT_GT_GT] = ACTIONS(780),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_EQ_GT] = ACTIONS(780),
    [anon_sym_QMARK_QMARK] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(782),
    [sym__rangeOperator] = ACTIONS(780),
    [anon_sym_null] = ACTIONS(782),
    [anon_sym_dynamic] = ACTIONS(782),
    [anon_sym_final] = ACTIONS(782),
    [anon_sym_abstract] = ACTIONS(782),
    [anon_sym_class] = ACTIONS(782),
    [anon_sym_extends] = ACTIONS(782),
    [anon_sym_implements] = ACTIONS(782),
    [anon_sym_interface] = ACTIONS(782),
    [anon_sym_typedef] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(782),
    [anon_sym_var] = ACTIONS(782),
    [aux_sym_integer_token1] = ACTIONS(782),
    [aux_sym_integer_token2] = ACTIONS(780),
    [aux_sym_float_token1] = ACTIONS(782),
    [aux_sym_float_token2] = ACTIONS(780),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(782),
    [aux_sym_string_token1] = ACTIONS(780),
    [aux_sym_string_token3] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(782),
    [anon_sym_catch] = ACTIONS(782),
    [anon_sym_continue] = ACTIONS(782),
    [anon_sym_do] = ACTIONS(782),
    [anon_sym_enum] = ACTIONS(782),
    [anon_sym_extern] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(782),
    [anon_sym_inline] = ACTIONS(782),
    [anon_sym_macro] = ACTIONS(782),
    [anon_sym_operator] = ACTIONS(782),
    [anon_sym_overload] = ACTIONS(782),
    [anon_sym_override] = ACTIONS(782),
    [anon_sym_private] = ACTIONS(782),
    [anon_sym_public] = ACTIONS(782),
    [anon_sym_return] = ACTIONS(782),
    [anon_sym_static] = ACTIONS(782),
    [anon_sym_try] = ACTIONS(782),
    [anon_sym_untyped] = ACTIONS(782),
    [anon_sym_while] = ACTIONS(782),
    [sym__semicolon] = ACTIONS(780),
  },
  [143] = {
    [sym_block] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(789),
    [sym_identifier] = ACTIONS(791),
    [anon_sym_POUND] = ACTIONS(789),
    [anon_sym_package] = ACTIONS(791),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_using] = ACTIONS(791),
    [anon_sym_throw] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(791),
    [anon_sym_cast] = ACTIONS(791),
    [anon_sym_DOLLARtype] = ACTIONS(789),
    [anon_sym_in] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_this] = ACTIONS(791),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym_AT_COLON] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_DASH_DASH] = ACTIONS(789),
    [anon_sym_PERCENT] = ACTIONS(789),
    [anon_sym_STAR] = ACTIONS(789),
    [anon_sym_SLASH] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_LT_LT] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(791),
    [anon_sym_GT_GT_GT] = ACTIONS(789),
    [anon_sym_AMP] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_CARET] = ACTIONS(789),
    [anon_sym_AMP_AMP] = ACTIONS(789),
    [anon_sym_PIPE_PIPE] = ACTIONS(789),
    [anon_sym_EQ_EQ] = ACTIONS(789),
    [anon_sym_BANG_EQ] = ACTIONS(789),
    [anon_sym_LT] = ACTIONS(791),
    [anon_sym_LT_EQ] = ACTIONS(789),
    [anon_sym_GT] = ACTIONS(791),
    [anon_sym_GT_EQ] = ACTIONS(789),
    [anon_sym_EQ_GT] = ACTIONS(789),
    [anon_sym_QMARK_QMARK] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(791),
    [sym__rangeOperator] = ACTIONS(789),
    [anon_sym_null] = ACTIONS(791),
    [anon_sym_dynamic] = ACTIONS(791),
    [anon_sym_final] = ACTIONS(791),
    [anon_sym_abstract] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(791),
    [anon_sym_extends] = ACTIONS(791),
    [anon_sym_implements] = ACTIONS(791),
    [anon_sym_interface] = ACTIONS(791),
    [anon_sym_typedef] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_var] = ACTIONS(791),
    [aux_sym_integer_token1] = ACTIONS(791),
    [aux_sym_integer_token2] = ACTIONS(789),
    [aux_sym_float_token1] = ACTIONS(791),
    [aux_sym_float_token2] = ACTIONS(789),
    [anon_sym_true] = ACTIONS(791),
    [anon_sym_false] = ACTIONS(791),
    [aux_sym_string_token1] = ACTIONS(789),
    [aux_sym_string_token3] = ACTIONS(789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_catch] = ACTIONS(791),
    [anon_sym_continue] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_enum] = ACTIONS(791),
    [anon_sym_extern] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_inline] = ACTIONS(791),
    [anon_sym_macro] = ACTIONS(791),
    [anon_sym_operator] = ACTIONS(791),
    [anon_sym_overload] = ACTIONS(791),
    [anon_sym_override] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(791),
    [anon_sym_static] = ACTIONS(791),
    [anon_sym_try] = ACTIONS(791),
    [anon_sym_untyped] = ACTIONS(791),
    [anon_sym_while] = ACTIONS(791),
    [sym__semicolon] = ACTIONS(789),
  },
  [144] = {
    [sym_block] = STATE(219),
    [ts_builtin_sym_end] = ACTIONS(796),
    [sym_identifier] = ACTIONS(798),
    [anon_sym_POUND] = ACTIONS(796),
    [anon_sym_package] = ACTIONS(798),
    [anon_sym_import] = ACTIONS(798),
    [anon_sym_using] = ACTIONS(798),
    [anon_sym_throw] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_switch] = ACTIONS(798),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(796),
    [anon_sym_case] = ACTIONS(798),
    [anon_sym_default] = ACTIONS(798),
    [anon_sym_cast] = ACTIONS(798),
    [anon_sym_DOLLARtype] = ACTIONS(796),
    [anon_sym_in] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(796),
    [anon_sym_this] = ACTIONS(798),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(798),
    [anon_sym_AT_COLON] = ACTIONS(796),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_else] = ACTIONS(798),
    [anon_sym_new] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(796),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_PLUS_PLUS] = ACTIONS(796),
    [anon_sym_DASH_DASH] = ACTIONS(796),
    [anon_sym_PERCENT] = ACTIONS(796),
    [anon_sym_STAR] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_LT_LT] = ACTIONS(796),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_GT_GT_GT] = ACTIONS(796),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_PIPE] = ACTIONS(798),
    [anon_sym_CARET] = ACTIONS(796),
    [anon_sym_AMP_AMP] = ACTIONS(796),
    [anon_sym_PIPE_PIPE] = ACTIONS(796),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_LT] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_EQ_GT] = ACTIONS(796),
    [anon_sym_QMARK_QMARK] = ACTIONS(796),
    [anon_sym_EQ] = ACTIONS(798),
    [sym__rangeOperator] = ACTIONS(796),
    [anon_sym_null] = ACTIONS(798),
    [anon_sym_dynamic] = ACTIONS(798),
    [anon_sym_final] = ACTIONS(798),
    [anon_sym_abstract] = ACTIONS(798),
    [anon_sym_class] = ACTIONS(798),
    [anon_sym_extends] = ACTIONS(798),
    [anon_sym_implements] = ACTIONS(798),
    [anon_sym_interface] = ACTIONS(798),
    [anon_sym_typedef] = ACTIONS(798),
    [anon_sym_function] = ACTIONS(798),
    [anon_sym_var] = ACTIONS(798),
    [aux_sym_integer_token1] = ACTIONS(798),
    [aux_sym_integer_token2] = ACTIONS(796),
    [aux_sym_float_token1] = ACTIONS(798),
    [aux_sym_float_token2] = ACTIONS(796),
    [anon_sym_true] = ACTIONS(798),
    [anon_sym_false] = ACTIONS(798),
    [aux_sym_string_token1] = ACTIONS(796),
    [aux_sym_string_token3] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(798),
    [anon_sym_catch] = ACTIONS(798),
    [anon_sym_continue] = ACTIONS(798),
    [anon_sym_do] = ACTIONS(798),
    [anon_sym_enum] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(798),
    [anon_sym_inline] = ACTIONS(798),
    [anon_sym_macro] = ACTIONS(798),
    [anon_sym_operator] = ACTIONS(798),
    [anon_sym_overload] = ACTIONS(798),
    [anon_sym_override] = ACTIONS(798),
    [anon_sym_private] = ACTIONS(798),
    [anon_sym_public] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_static] = ACTIONS(798),
    [anon_sym_try] = ACTIONS(798),
    [anon_sym_untyped] = ACTIONS(798),
    [anon_sym_while] = ACTIONS(798),
    [sym__semicolon] = ACTIONS(796),
  },
  [145] = {
    [sym_block] = STATE(268),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym_identifier] = ACTIONS(805),
    [anon_sym_POUND] = ACTIONS(803),
    [anon_sym_package] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(805),
    [anon_sym_using] = ACTIONS(805),
    [anon_sym_throw] = ACTIONS(805),
    [anon_sym_LPAREN] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(805),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(805),
    [anon_sym_COLON] = ACTIONS(810),
    [anon_sym_default] = ACTIONS(805),
    [anon_sym_cast] = ACTIONS(805),
    [anon_sym_DOLLARtype] = ACTIONS(803),
    [anon_sym_in] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(803),
    [anon_sym_this] = ACTIONS(805),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_AT_COLON] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(805),
    [anon_sym_new] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(803),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_PERCENT] = ACTIONS(803),
    [anon_sym_STAR] = ACTIONS(803),
    [anon_sym_SLASH] = ACTIONS(805),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_LT_LT] = ACTIONS(803),
    [anon_sym_GT_GT] = ACTIONS(805),
    [anon_sym_GT_GT_GT] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(805),
    [anon_sym_PIPE] = ACTIONS(805),
    [anon_sym_CARET] = ACTIONS(803),
    [anon_sym_AMP_AMP] = ACTIONS(803),
    [anon_sym_PIPE_PIPE] = ACTIONS(803),
    [anon_sym_EQ_EQ] = ACTIONS(803),
    [anon_sym_BANG_EQ] = ACTIONS(803),
    [anon_sym_LT] = ACTIONS(805),
    [anon_sym_LT_EQ] = ACTIONS(803),
    [anon_sym_GT] = ACTIONS(805),
    [anon_sym_GT_EQ] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(803),
    [anon_sym_QMARK_QMARK] = ACTIONS(803),
    [anon_sym_EQ] = ACTIONS(805),
    [sym__rangeOperator] = ACTIONS(803),
    [anon_sym_null] = ACTIONS(805),
    [anon_sym_dynamic] = ACTIONS(805),
    [anon_sym_final] = ACTIONS(805),
    [anon_sym_abstract] = ACTIONS(805),
    [anon_sym_class] = ACTIONS(805),
    [anon_sym_extends] = ACTIONS(805),
    [anon_sym_implements] = ACTIONS(805),
    [anon_sym_interface] = ACTIONS(805),
    [anon_sym_typedef] = ACTIONS(805),
    [anon_sym_function] = ACTIONS(805),
    [anon_sym_var] = ACTIONS(805),
    [aux_sym_integer_token1] = ACTIONS(805),
    [aux_sym_integer_token2] = ACTIONS(803),
    [aux_sym_float_token1] = ACTIONS(805),
    [aux_sym_float_token2] = ACTIONS(803),
    [anon_sym_true] = ACTIONS(805),
    [anon_sym_false] = ACTIONS(805),
    [aux_sym_string_token1] = ACTIONS(803),
    [aux_sym_string_token3] = ACTIONS(803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_catch] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(805),
    [anon_sym_do] = ACTIONS(805),
    [anon_sym_enum] = ACTIONS(805),
    [anon_sym_extern] = ACTIONS(805),
    [anon_sym_for] = ACTIONS(805),
    [anon_sym_inline] = ACTIONS(805),
    [anon_sym_macro] = ACTIONS(805),
    [anon_sym_operator] = ACTIONS(805),
    [anon_sym_overload] = ACTIONS(805),
    [anon_sym_override] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_return] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_try] = ACTIONS(805),
    [anon_sym_untyped] = ACTIONS(805),
    [anon_sym_while] = ACTIONS(805),
    [sym__semicolon] = ACTIONS(803),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_identifier] = ACTIONS(814),
    [anon_sym_POUND] = ACTIONS(812),
    [anon_sym_package] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(814),
    [anon_sym_throw] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_RPAREN] = ACTIONS(812),
    [anon_sym_switch] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_case] = ACTIONS(814),
    [anon_sym_default] = ACTIONS(814),
    [anon_sym_cast] = ACTIONS(814),
    [anon_sym_DOLLARtype] = ACTIONS(812),
    [anon_sym_in] = ACTIONS(814),
    [anon_sym_LBRACK] = ACTIONS(812),
    [anon_sym_this] = ACTIONS(814),
    [anon_sym_DASH_GT] = ACTIONS(812),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_AT_COLON] = ACTIONS(812),
    [anon_sym_if] = ACTIONS(814),
    [anon_sym_else] = ACTIONS(814),
    [anon_sym_new] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(812),
    [anon_sym_DASH_DASH] = ACTIONS(812),
    [anon_sym_PERCENT] = ACTIONS(812),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_SLASH] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_LT_LT] = ACTIONS(812),
    [anon_sym_GT_GT] = ACTIONS(814),
    [anon_sym_GT_GT_GT] = ACTIONS(812),
    [anon_sym_AMP] = ACTIONS(814),
    [anon_sym_PIPE] = ACTIONS(814),
    [anon_sym_CARET] = ACTIONS(812),
    [anon_sym_AMP_AMP] = ACTIONS(812),
    [anon_sym_PIPE_PIPE] = ACTIONS(812),
    [anon_sym_EQ_EQ] = ACTIONS(812),
    [anon_sym_BANG_EQ] = ACTIONS(812),
    [anon_sym_LT] = ACTIONS(814),
    [anon_sym_LT_EQ] = ACTIONS(812),
    [anon_sym_GT] = ACTIONS(814),
    [anon_sym_GT_EQ] = ACTIONS(812),
    [anon_sym_EQ_GT] = ACTIONS(812),
    [anon_sym_QMARK_QMARK] = ACTIONS(812),
    [anon_sym_EQ] = ACTIONS(814),
    [sym__rangeOperator] = ACTIONS(812),
    [anon_sym_null] = ACTIONS(814),
    [anon_sym_dynamic] = ACTIONS(814),
    [anon_sym_final] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(814),
    [anon_sym_class] = ACTIONS(814),
    [anon_sym_extends] = ACTIONS(814),
    [anon_sym_implements] = ACTIONS(814),
    [anon_sym_interface] = ACTIONS(814),
    [anon_sym_typedef] = ACTIONS(814),
    [anon_sym_function] = ACTIONS(814),
    [anon_sym_var] = ACTIONS(814),
    [aux_sym_integer_token1] = ACTIONS(814),
    [aux_sym_integer_token2] = ACTIONS(812),
    [aux_sym_float_token1] = ACTIONS(814),
    [aux_sym_float_token2] = ACTIONS(812),
    [anon_sym_true] = ACTIONS(814),
    [anon_sym_false] = ACTIONS(814),
    [aux_sym_string_token1] = ACTIONS(812),
    [aux_sym_string_token3] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(814),
    [anon_sym_catch] = ACTIONS(814),
    [anon_sym_continue] = ACTIONS(814),
    [anon_sym_do] = ACTIONS(814),
    [anon_sym_enum] = ACTIONS(814),
    [anon_sym_extern] = ACTIONS(814),
    [anon_sym_for] = ACTIONS(814),
    [anon_sym_inline] = ACTIONS(814),
    [anon_sym_macro] = ACTIONS(814),
    [anon_sym_operator] = ACTIONS(814),
    [anon_sym_overload] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_return] = ACTIONS(814),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_try] = ACTIONS(814),
    [anon_sym_untyped] = ACTIONS(814),
    [anon_sym_while] = ACTIONS(814),
    [sym__semicolon] = ACTIONS(812),
  },
  [147] = {
    [sym_type_params] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(816),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_POUND] = ACTIONS(816),
    [anon_sym_package] = ACTIONS(819),
    [anon_sym_import] = ACTIONS(819),
    [anon_sym_using] = ACTIONS(819),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_case] = ACTIONS(819),
    [anon_sym_default] = ACTIONS(819),
    [anon_sym_cast] = ACTIONS(819),
    [anon_sym_DOLLARtype] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(816),
    [anon_sym_this] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(819),
    [anon_sym_AT_COLON] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_else] = ACTIONS(819),
    [anon_sym_new] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_BANG] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_PLUS_PLUS] = ACTIONS(816),
    [anon_sym_DASH_DASH] = ACTIONS(816),
    [anon_sym_PERCENT] = ACTIONS(816),
    [anon_sym_STAR] = ACTIONS(816),
    [anon_sym_SLASH] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(816),
    [anon_sym_GT_GT] = ACTIONS(819),
    [anon_sym_GT_GT_GT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(816),
    [anon_sym_AMP_AMP] = ACTIONS(816),
    [anon_sym_PIPE_PIPE] = ACTIONS(816),
    [anon_sym_EQ_EQ] = ACTIONS(816),
    [anon_sym_BANG_EQ] = ACTIONS(816),
    [anon_sym_LT] = ACTIONS(822),
    [anon_sym_LT_EQ] = ACTIONS(816),
    [anon_sym_GT] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(816),
    [anon_sym_EQ_GT] = ACTIONS(816),
    [anon_sym_QMARK_QMARK] = ACTIONS(816),
    [anon_sym_EQ] = ACTIONS(819),
    [sym__rangeOperator] = ACTIONS(816),
    [anon_sym_null] = ACTIONS(819),
    [anon_sym_dynamic] = ACTIONS(819),
    [anon_sym_final] = ACTIONS(819),
    [anon_sym_abstract] = ACTIONS(819),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_extends] = ACTIONS(819),
    [anon_sym_implements] = ACTIONS(819),
    [anon_sym_interface] = ACTIONS(819),
    [anon_sym_typedef] = ACTIONS(819),
    [anon_sym_function] = ACTIONS(819),
    [anon_sym_var] = ACTIONS(819),
    [aux_sym_integer_token1] = ACTIONS(819),
    [aux_sym_integer_token2] = ACTIONS(816),
    [aux_sym_float_token1] = ACTIONS(819),
    [aux_sym_float_token2] = ACTIONS(816),
    [anon_sym_true] = ACTIONS(819),
    [anon_sym_false] = ACTIONS(819),
    [aux_sym_string_token1] = ACTIONS(816),
    [aux_sym_string_token3] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(819),
    [anon_sym_catch] = ACTIONS(819),
    [anon_sym_continue] = ACTIONS(819),
    [anon_sym_do] = ACTIONS(819),
    [anon_sym_enum] = ACTIONS(819),
    [anon_sym_extern] = ACTIONS(819),
    [anon_sym_for] = ACTIONS(819),
    [anon_sym_inline] = ACTIONS(819),
    [anon_sym_macro] = ACTIONS(819),
    [anon_sym_operator] = ACTIONS(819),
    [anon_sym_overload] = ACTIONS(819),
    [anon_sym_override] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_return] = ACTIONS(819),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_try] = ACTIONS(819),
    [anon_sym_untyped] = ACTIONS(819),
    [anon_sym_while] = ACTIONS(819),
    [sym__semicolon] = ACTIONS(816),
  },
  [148] = {
    [sym_block] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(826),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_POUND] = ACTIONS(826),
    [anon_sym_package] = ACTIONS(828),
    [anon_sym_import] = ACTIONS(828),
    [anon_sym_using] = ACTIONS(828),
    [anon_sym_throw] = ACTIONS(828),
    [anon_sym_LPAREN] = ACTIONS(826),
    [anon_sym_switch] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(826),
    [anon_sym_case] = ACTIONS(828),
    [anon_sym_default] = ACTIONS(828),
    [anon_sym_cast] = ACTIONS(828),
    [anon_sym_DOLLARtype] = ACTIONS(826),
    [anon_sym_in] = ACTIONS(828),
    [anon_sym_LBRACK] = ACTIONS(826),
    [anon_sym_this] = ACTIONS(828),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(828),
    [anon_sym_AT_COLON] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(828),
    [anon_sym_else] = ACTIONS(828),
    [anon_sym_new] = ACTIONS(828),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(828),
    [anon_sym_DASH] = ACTIONS(828),
    [anon_sym_PLUS_PLUS] = ACTIONS(826),
    [anon_sym_DASH_DASH] = ACTIONS(826),
    [anon_sym_PERCENT] = ACTIONS(826),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_SLASH] = ACTIONS(828),
    [anon_sym_PLUS] = ACTIONS(828),
    [anon_sym_LT_LT] = ACTIONS(826),
    [anon_sym_GT_GT] = ACTIONS(828),
    [anon_sym_GT_GT_GT] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(828),
    [anon_sym_PIPE] = ACTIONS(828),
    [anon_sym_CARET] = ACTIONS(826),
    [anon_sym_AMP_AMP] = ACTIONS(826),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [anon_sym_EQ_EQ] = ACTIONS(826),
    [anon_sym_BANG_EQ] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(828),
    [anon_sym_LT_EQ] = ACTIONS(826),
    [anon_sym_GT] = ACTIONS(828),
    [anon_sym_GT_EQ] = ACTIONS(826),
    [anon_sym_EQ_GT] = ACTIONS(826),
    [anon_sym_QMARK_QMARK] = ACTIONS(826),
    [anon_sym_EQ] = ACTIONS(828),
    [sym__rangeOperator] = ACTIONS(826),
    [anon_sym_null] = ACTIONS(828),
    [anon_sym_dynamic] = ACTIONS(828),
    [anon_sym_final] = ACTIONS(828),
    [anon_sym_abstract] = ACTIONS(828),
    [anon_sym_class] = ACTIONS(828),
    [anon_sym_extends] = ACTIONS(828),
    [anon_sym_implements] = ACTIONS(828),
    [anon_sym_interface] = ACTIONS(828),
    [anon_sym_typedef] = ACTIONS(828),
    [anon_sym_function] = ACTIONS(828),
    [anon_sym_var] = ACTIONS(828),
    [aux_sym_integer_token1] = ACTIONS(828),
    [aux_sym_integer_token2] = ACTIONS(826),
    [aux_sym_float_token1] = ACTIONS(828),
    [aux_sym_float_token2] = ACTIONS(826),
    [anon_sym_true] = ACTIONS(828),
    [anon_sym_false] = ACTIONS(828),
    [aux_sym_string_token1] = ACTIONS(826),
    [aux_sym_string_token3] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(828),
    [anon_sym_catch] = ACTIONS(828),
    [anon_sym_continue] = ACTIONS(828),
    [anon_sym_do] = ACTIONS(828),
    [anon_sym_enum] = ACTIONS(828),
    [anon_sym_extern] = ACTIONS(828),
    [anon_sym_for] = ACTIONS(828),
    [anon_sym_inline] = ACTIONS(828),
    [anon_sym_macro] = ACTIONS(828),
    [anon_sym_operator] = ACTIONS(828),
    [anon_sym_overload] = ACTIONS(828),
    [anon_sym_override] = ACTIONS(828),
    [anon_sym_private] = ACTIONS(828),
    [anon_sym_public] = ACTIONS(828),
    [anon_sym_return] = ACTIONS(828),
    [anon_sym_static] = ACTIONS(828),
    [anon_sym_try] = ACTIONS(828),
    [anon_sym_untyped] = ACTIONS(828),
    [anon_sym_while] = ACTIONS(828),
    [sym__semicolon] = ACTIONS(826),
  },
  [149] = {
    [sym_block] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(833),
    [sym_identifier] = ACTIONS(835),
    [anon_sym_POUND] = ACTIONS(833),
    [anon_sym_package] = ACTIONS(835),
    [anon_sym_import] = ACTIONS(835),
    [anon_sym_using] = ACTIONS(835),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_switch] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_cast] = ACTIONS(835),
    [anon_sym_DOLLARtype] = ACTIONS(833),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(833),
    [anon_sym_this] = ACTIONS(835),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(835),
    [anon_sym_AT_COLON] = ACTIONS(833),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_new] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_PERCENT] = ACTIONS(833),
    [anon_sym_STAR] = ACTIONS(833),
    [anon_sym_SLASH] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_LT_LT] = ACTIONS(833),
    [anon_sym_GT_GT] = ACTIONS(835),
    [anon_sym_GT_GT_GT] = ACTIONS(833),
    [anon_sym_AMP] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(835),
    [anon_sym_CARET] = ACTIONS(833),
    [anon_sym_AMP_AMP] = ACTIONS(833),
    [anon_sym_PIPE_PIPE] = ACTIONS(833),
    [anon_sym_EQ_EQ] = ACTIONS(833),
    [anon_sym_BANG_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(835),
    [anon_sym_LT_EQ] = ACTIONS(833),
    [anon_sym_GT] = ACTIONS(835),
    [anon_sym_GT_EQ] = ACTIONS(833),
    [anon_sym_EQ_GT] = ACTIONS(833),
    [anon_sym_QMARK_QMARK] = ACTIONS(833),
    [anon_sym_EQ] = ACTIONS(835),
    [sym__rangeOperator] = ACTIONS(833),
    [anon_sym_null] = ACTIONS(835),
    [anon_sym_dynamic] = ACTIONS(835),
    [anon_sym_final] = ACTIONS(835),
    [anon_sym_abstract] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(835),
    [anon_sym_extends] = ACTIONS(835),
    [anon_sym_implements] = ACTIONS(835),
    [anon_sym_interface] = ACTIONS(835),
    [anon_sym_typedef] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_var] = ACTIONS(835),
    [aux_sym_integer_token1] = ACTIONS(835),
    [aux_sym_integer_token2] = ACTIONS(833),
    [aux_sym_float_token1] = ACTIONS(835),
    [aux_sym_float_token2] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(835),
    [anon_sym_false] = ACTIONS(835),
    [aux_sym_string_token1] = ACTIONS(833),
    [aux_sym_string_token3] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_catch] = ACTIONS(835),
    [anon_sym_continue] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_enum] = ACTIONS(835),
    [anon_sym_extern] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_inline] = ACTIONS(835),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_operator] = ACTIONS(835),
    [anon_sym_overload] = ACTIONS(835),
    [anon_sym_override] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_public] = ACTIONS(835),
    [anon_sym_return] = ACTIONS(835),
    [anon_sym_static] = ACTIONS(835),
    [anon_sym_try] = ACTIONS(835),
    [anon_sym_untyped] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [sym__semicolon] = ACTIONS(833),
  },
  [150] = {
    [sym_block] = STATE(315),
    [ts_builtin_sym_end] = ACTIONS(840),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(840),
    [anon_sym_package] = ACTIONS(842),
    [anon_sym_import] = ACTIONS(842),
    [anon_sym_using] = ACTIONS(842),
    [anon_sym_throw] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_switch] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(847),
    [anon_sym_default] = ACTIONS(842),
    [anon_sym_cast] = ACTIONS(842),
    [anon_sym_DOLLARtype] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_this] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(842),
    [anon_sym_AT_COLON] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_new] = ACTIONS(842),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PLUS_PLUS] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(842),
    [anon_sym_GT_GT_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(842),
    [anon_sym_CARET] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(842),
    [anon_sym_LT_EQ] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(842),
    [anon_sym_GT_EQ] = ACTIONS(840),
    [anon_sym_EQ_GT] = ACTIONS(840),
    [anon_sym_QMARK_QMARK] = ACTIONS(840),
    [anon_sym_EQ] = ACTIONS(842),
    [sym__rangeOperator] = ACTIONS(840),
    [anon_sym_null] = ACTIONS(842),
    [anon_sym_dynamic] = ACTIONS(842),
    [anon_sym_final] = ACTIONS(842),
    [anon_sym_abstract] = ACTIONS(842),
    [anon_sym_class] = ACTIONS(842),
    [anon_sym_extends] = ACTIONS(842),
    [anon_sym_implements] = ACTIONS(842),
    [anon_sym_interface] = ACTIONS(842),
    [anon_sym_typedef] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(842),
    [anon_sym_var] = ACTIONS(842),
    [aux_sym_integer_token1] = ACTIONS(842),
    [aux_sym_integer_token2] = ACTIONS(840),
    [aux_sym_float_token1] = ACTIONS(842),
    [aux_sym_float_token2] = ACTIONS(840),
    [anon_sym_true] = ACTIONS(842),
    [anon_sym_false] = ACTIONS(842),
    [aux_sym_string_token1] = ACTIONS(840),
    [aux_sym_string_token3] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_catch] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(842),
    [anon_sym_do] = ACTIONS(842),
    [anon_sym_enum] = ACTIONS(842),
    [anon_sym_extern] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(842),
    [anon_sym_inline] = ACTIONS(842),
    [anon_sym_macro] = ACTIONS(842),
    [anon_sym_operator] = ACTIONS(842),
    [anon_sym_overload] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(842),
    [anon_sym_untyped] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [sym__semicolon] = ACTIONS(840),
  },
  [151] = {
    [sym_type_params] = STATE(116),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_POUND] = ACTIONS(849),
    [anon_sym_package] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_using] = ACTIONS(852),
    [anon_sym_throw] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_switch] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_case] = ACTIONS(852),
    [anon_sym_default] = ACTIONS(852),
    [anon_sym_cast] = ACTIONS(852),
    [anon_sym_DOLLARtype] = ACTIONS(849),
    [anon_sym_in] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_this] = ACTIONS(852),
    [anon_sym_DASH_GT] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_AT_COLON] = ACTIONS(849),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_new] = ACTIONS(852),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(852),
    [anon_sym_DASH] = ACTIONS(852),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_PERCENT] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(849),
    [anon_sym_SLASH] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(852),
    [anon_sym_LT_LT] = ACTIONS(849),
    [anon_sym_GT_GT] = ACTIONS(852),
    [anon_sym_GT_GT_GT] = ACTIONS(849),
    [anon_sym_AMP] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(852),
    [anon_sym_CARET] = ACTIONS(849),
    [anon_sym_AMP_AMP] = ACTIONS(849),
    [anon_sym_PIPE_PIPE] = ACTIONS(849),
    [anon_sym_EQ_EQ] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(849),
    [anon_sym_LT] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(849),
    [anon_sym_GT] = ACTIONS(852),
    [anon_sym_GT_EQ] = ACTIONS(849),
    [anon_sym_EQ_GT] = ACTIONS(849),
    [anon_sym_QMARK_QMARK] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(852),
    [sym__rangeOperator] = ACTIONS(849),
    [anon_sym_null] = ACTIONS(852),
    [anon_sym_dynamic] = ACTIONS(852),
    [anon_sym_final] = ACTIONS(852),
    [anon_sym_abstract] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_extends] = ACTIONS(852),
    [anon_sym_implements] = ACTIONS(852),
    [anon_sym_interface] = ACTIONS(852),
    [anon_sym_typedef] = ACTIONS(852),
    [anon_sym_function] = ACTIONS(852),
    [anon_sym_var] = ACTIONS(852),
    [aux_sym_integer_token1] = ACTIONS(852),
    [aux_sym_integer_token2] = ACTIONS(849),
    [aux_sym_float_token1] = ACTIONS(852),
    [aux_sym_float_token2] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(852),
    [anon_sym_false] = ACTIONS(852),
    [aux_sym_string_token1] = ACTIONS(849),
    [aux_sym_string_token3] = ACTIONS(849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_catch] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(852),
    [anon_sym_enum] = ACTIONS(852),
    [anon_sym_extern] = ACTIONS(852),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_inline] = ACTIONS(852),
    [anon_sym_macro] = ACTIONS(852),
    [anon_sym_operator] = ACTIONS(852),
    [anon_sym_overload] = ACTIONS(852),
    [anon_sym_override] = ACTIONS(852),
    [anon_sym_private] = ACTIONS(852),
    [anon_sym_public] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_static] = ACTIONS(852),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_untyped] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(852),
    [sym__semicolon] = ACTIONS(849),
  },
  [152] = {
    [sym_block] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(861),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_package] = ACTIONS(861),
    [anon_sym_import] = ACTIONS(861),
    [anon_sym_using] = ACTIONS(861),
    [anon_sym_throw] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(861),
    [anon_sym_LBRACE] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(866),
    [anon_sym_default] = ACTIONS(861),
    [anon_sym_cast] = ACTIONS(861),
    [anon_sym_DOLLARtype] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(861),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_AT_COLON] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_EQ_GT] = ACTIONS(859),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(861),
    [sym__rangeOperator] = ACTIONS(859),
    [anon_sym_null] = ACTIONS(861),
    [anon_sym_dynamic] = ACTIONS(861),
    [anon_sym_final] = ACTIONS(861),
    [anon_sym_abstract] = ACTIONS(861),
    [anon_sym_class] = ACTIONS(861),
    [anon_sym_extends] = ACTIONS(861),
    [anon_sym_implements] = ACTIONS(861),
    [anon_sym_interface] = ACTIONS(861),
    [anon_sym_typedef] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(861),
    [anon_sym_var] = ACTIONS(861),
    [aux_sym_integer_token1] = ACTIONS(861),
    [aux_sym_integer_token2] = ACTIONS(859),
    [aux_sym_float_token1] = ACTIONS(861),
    [aux_sym_float_token2] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(861),
    [anon_sym_false] = ACTIONS(861),
    [aux_sym_string_token1] = ACTIONS(859),
    [aux_sym_string_token3] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(861),
    [anon_sym_catch] = ACTIONS(861),
    [anon_sym_continue] = ACTIONS(861),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_enum] = ACTIONS(861),
    [anon_sym_extern] = ACTIONS(861),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_inline] = ACTIONS(861),
    [anon_sym_macro] = ACTIONS(861),
    [anon_sym_operator] = ACTIONS(861),
    [anon_sym_overload] = ACTIONS(861),
    [anon_sym_override] = ACTIONS(861),
    [anon_sym_private] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(861),
    [anon_sym_return] = ACTIONS(861),
    [anon_sym_static] = ACTIONS(861),
    [anon_sym_try] = ACTIONS(861),
    [anon_sym_untyped] = ACTIONS(861),
    [anon_sym_while] = ACTIONS(861),
    [sym__semicolon] = ACTIONS(859),
  },
  [153] = {
    [sym_block] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(868),
    [sym_identifier] = ACTIONS(870),
    [anon_sym_POUND] = ACTIONS(868),
    [anon_sym_package] = ACTIONS(870),
    [anon_sym_import] = ACTIONS(870),
    [anon_sym_using] = ACTIONS(870),
    [anon_sym_throw] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(868),
    [anon_sym_switch] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_case] = ACTIONS(870),
    [anon_sym_default] = ACTIONS(870),
    [anon_sym_cast] = ACTIONS(870),
    [anon_sym_DOLLARtype] = ACTIONS(868),
    [anon_sym_in] = ACTIONS(870),
    [anon_sym_LBRACK] = ACTIONS(868),
    [anon_sym_this] = ACTIONS(870),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(870),
    [anon_sym_AT_COLON] = ACTIONS(868),
    [anon_sym_if] = ACTIONS(870),
    [anon_sym_else] = ACTIONS(870),
    [anon_sym_new] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(868),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_PLUS_PLUS] = ACTIONS(868),
    [anon_sym_DASH_DASH] = ACTIONS(868),
    [anon_sym_PERCENT] = ACTIONS(868),
    [anon_sym_STAR] = ACTIONS(868),
    [anon_sym_SLASH] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_LT_LT] = ACTIONS(868),
    [anon_sym_GT_GT] = ACTIONS(870),
    [anon_sym_GT_GT_GT] = ACTIONS(868),
    [anon_sym_AMP] = ACTIONS(870),
    [anon_sym_PIPE] = ACTIONS(870),
    [anon_sym_CARET] = ACTIONS(868),
    [anon_sym_AMP_AMP] = ACTIONS(868),
    [anon_sym_PIPE_PIPE] = ACTIONS(868),
    [anon_sym_EQ_EQ] = ACTIONS(868),
    [anon_sym_BANG_EQ] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(870),
    [anon_sym_LT_EQ] = ACTIONS(868),
    [anon_sym_GT] = ACTIONS(870),
    [anon_sym_GT_EQ] = ACTIONS(868),
    [anon_sym_EQ_GT] = ACTIONS(868),
    [anon_sym_QMARK_QMARK] = ACTIONS(868),
    [anon_sym_EQ] = ACTIONS(870),
    [sym__rangeOperator] = ACTIONS(868),
    [anon_sym_null] = ACTIONS(870),
    [anon_sym_dynamic] = ACTIONS(870),
    [anon_sym_final] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_extends] = ACTIONS(870),
    [anon_sym_implements] = ACTIONS(870),
    [anon_sym_interface] = ACTIONS(870),
    [anon_sym_typedef] = ACTIONS(870),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_var] = ACTIONS(870),
    [aux_sym_integer_token1] = ACTIONS(870),
    [aux_sym_integer_token2] = ACTIONS(868),
    [aux_sym_float_token1] = ACTIONS(870),
    [aux_sym_float_token2] = ACTIONS(868),
    [anon_sym_true] = ACTIONS(870),
    [anon_sym_false] = ACTIONS(870),
    [aux_sym_string_token1] = ACTIONS(868),
    [aux_sym_string_token3] = ACTIONS(868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(870),
    [anon_sym_catch] = ACTIONS(870),
    [anon_sym_continue] = ACTIONS(870),
    [anon_sym_do] = ACTIONS(870),
    [anon_sym_enum] = ACTIONS(870),
    [anon_sym_extern] = ACTIONS(870),
    [anon_sym_for] = ACTIONS(870),
    [anon_sym_inline] = ACTIONS(870),
    [anon_sym_macro] = ACTIONS(870),
    [anon_sym_operator] = ACTIONS(870),
    [anon_sym_overload] = ACTIONS(870),
    [anon_sym_override] = ACTIONS(870),
    [anon_sym_private] = ACTIONS(870),
    [anon_sym_public] = ACTIONS(870),
    [anon_sym_return] = ACTIONS(870),
    [anon_sym_static] = ACTIONS(870),
    [anon_sym_try] = ACTIONS(870),
    [anon_sym_untyped] = ACTIONS(870),
    [anon_sym_while] = ACTIONS(870),
    [sym__semicolon] = ACTIONS(868),
  },
  [154] = {
    [sym_block] = STATE(170),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_POUND] = ACTIONS(875),
    [anon_sym_package] = ACTIONS(877),
    [anon_sym_import] = ACTIONS(877),
    [anon_sym_using] = ACTIONS(877),
    [anon_sym_throw] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(875),
    [anon_sym_switch] = ACTIONS(877),
    [anon_sym_LBRACE] = ACTIONS(879),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_COLON] = ACTIONS(882),
    [anon_sym_default] = ACTIONS(877),
    [anon_sym_cast] = ACTIONS(877),
    [anon_sym_DOLLARtype] = ACTIONS(875),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_this] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_AT_COLON] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_new] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(875),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(875),
    [anon_sym_DASH_DASH] = ACTIONS(875),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_GT_GT_GT] = ACTIONS(875),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(875),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_QMARK_QMARK] = ACTIONS(875),
    [anon_sym_EQ] = ACTIONS(877),
    [sym__rangeOperator] = ACTIONS(875),
    [anon_sym_null] = ACTIONS(877),
    [anon_sym_dynamic] = ACTIONS(877),
    [anon_sym_final] = ACTIONS(877),
    [anon_sym_abstract] = ACTIONS(877),
    [anon_sym_class] = ACTIONS(877),
    [anon_sym_extends] = ACTIONS(877),
    [anon_sym_implements] = ACTIONS(877),
    [anon_sym_interface] = ACTIONS(877),
    [anon_sym_typedef] = ACTIONS(877),
    [anon_sym_function] = ACTIONS(877),
    [anon_sym_var] = ACTIONS(877),
    [aux_sym_integer_token1] = ACTIONS(877),
    [aux_sym_integer_token2] = ACTIONS(875),
    [aux_sym_float_token1] = ACTIONS(877),
    [aux_sym_float_token2] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(877),
    [anon_sym_false] = ACTIONS(877),
    [aux_sym_string_token1] = ACTIONS(875),
    [aux_sym_string_token3] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(877),
    [anon_sym_catch] = ACTIONS(877),
    [anon_sym_continue] = ACTIONS(877),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_enum] = ACTIONS(877),
    [anon_sym_extern] = ACTIONS(877),
    [anon_sym_for] = ACTIONS(877),
    [anon_sym_inline] = ACTIONS(877),
    [anon_sym_macro] = ACTIONS(877),
    [anon_sym_operator] = ACTIONS(877),
    [anon_sym_overload] = ACTIONS(877),
    [anon_sym_override] = ACTIONS(877),
    [anon_sym_private] = ACTIONS(877),
    [anon_sym_public] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(877),
    [anon_sym_static] = ACTIONS(877),
    [anon_sym_try] = ACTIONS(877),
    [anon_sym_untyped] = ACTIONS(877),
    [anon_sym_while] = ACTIONS(877),
    [sym__semicolon] = ACTIONS(875),
  },
  [155] = {
    [sym_block] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(884),
    [sym_identifier] = ACTIONS(886),
    [anon_sym_POUND] = ACTIONS(884),
    [anon_sym_package] = ACTIONS(886),
    [anon_sym_import] = ACTIONS(886),
    [anon_sym_using] = ACTIONS(886),
    [anon_sym_throw] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_switch] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_RBRACE] = ACTIONS(884),
    [anon_sym_case] = ACTIONS(886),
    [anon_sym_default] = ACTIONS(886),
    [anon_sym_cast] = ACTIONS(886),
    [anon_sym_DOLLARtype] = ACTIONS(884),
    [anon_sym_in] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_this] = ACTIONS(886),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_AT_COLON] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_else] = ACTIONS(886),
    [anon_sym_new] = ACTIONS(886),
    [anon_sym_TILDE] = ACTIONS(884),
    [anon_sym_BANG] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PLUS_PLUS] = ACTIONS(884),
    [anon_sym_DASH_DASH] = ACTIONS(884),
    [anon_sym_PERCENT] = ACTIONS(884),
    [anon_sym_STAR] = ACTIONS(884),
    [anon_sym_SLASH] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(884),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_GT_GT_GT] = ACTIONS(884),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(884),
    [anon_sym_AMP_AMP] = ACTIONS(884),
    [anon_sym_PIPE_PIPE] = ACTIONS(884),
    [anon_sym_EQ_EQ] = ACTIONS(884),
    [anon_sym_BANG_EQ] = ACTIONS(884),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(884),
    [anon_sym_GT] = ACTIONS(886),
    [anon_sym_GT_EQ] = ACTIONS(884),
    [anon_sym_EQ_GT] = ACTIONS(884),
    [anon_sym_QMARK_QMARK] = ACTIONS(884),
    [anon_sym_EQ] = ACTIONS(886),
    [sym__rangeOperator] = ACTIONS(884),
    [anon_sym_null] = ACTIONS(886),
    [anon_sym_dynamic] = ACTIONS(886),
    [anon_sym_final] = ACTIONS(886),
    [anon_sym_abstract] = ACTIONS(886),
    [anon_sym_class] = ACTIONS(886),
    [anon_sym_extends] = ACTIONS(886),
    [anon_sym_implements] = ACTIONS(886),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_typedef] = ACTIONS(886),
    [anon_sym_function] = ACTIONS(886),
    [anon_sym_var] = ACTIONS(886),
    [aux_sym_integer_token1] = ACTIONS(886),
    [aux_sym_integer_token2] = ACTIONS(884),
    [aux_sym_float_token1] = ACTIONS(886),
    [aux_sym_float_token2] = ACTIONS(884),
    [anon_sym_true] = ACTIONS(886),
    [anon_sym_false] = ACTIONS(886),
    [aux_sym_string_token1] = ACTIONS(884),
    [aux_sym_string_token3] = ACTIONS(884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(886),
    [anon_sym_catch] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(886),
    [anon_sym_do] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_extern] = ACTIONS(886),
    [anon_sym_for] = ACTIONS(886),
    [anon_sym_inline] = ACTIONS(886),
    [anon_sym_macro] = ACTIONS(886),
    [anon_sym_operator] = ACTIONS(886),
    [anon_sym_overload] = ACTIONS(886),
    [anon_sym_override] = ACTIONS(886),
    [anon_sym_private] = ACTIONS(886),
    [anon_sym_public] = ACTIONS(886),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_static] = ACTIONS(886),
    [anon_sym_try] = ACTIONS(886),
    [anon_sym_untyped] = ACTIONS(886),
    [anon_sym_while] = ACTIONS(886),
    [sym__semicolon] = ACTIONS(884),
  },
  [156] = {
    [sym_block] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(893),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_package] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(893),
    [anon_sym_using] = ACTIONS(893),
    [anon_sym_throw] = ACTIONS(893),
    [anon_sym_LPAREN] = ACTIONS(891),
    [anon_sym_switch] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_case] = ACTIONS(893),
    [anon_sym_COLON] = ACTIONS(898),
    [anon_sym_default] = ACTIONS(893),
    [anon_sym_cast] = ACTIONS(893),
    [anon_sym_DOLLARtype] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_this] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(893),
    [anon_sym_AT_COLON] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_new] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_GT_GT_GT] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_QMARK_QMARK] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(893),
    [sym__rangeOperator] = ACTIONS(891),
    [anon_sym_null] = ACTIONS(893),
    [anon_sym_dynamic] = ACTIONS(893),
    [anon_sym_final] = ACTIONS(893),
    [anon_sym_abstract] = ACTIONS(893),
    [anon_sym_class] = ACTIONS(893),
    [anon_sym_extends] = ACTIONS(893),
    [anon_sym_implements] = ACTIONS(893),
    [anon_sym_interface] = ACTIONS(893),
    [anon_sym_typedef] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(893),
    [anon_sym_var] = ACTIONS(893),
    [aux_sym_integer_token1] = ACTIONS(893),
    [aux_sym_integer_token2] = ACTIONS(891),
    [aux_sym_float_token1] = ACTIONS(893),
    [aux_sym_float_token2] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(893),
    [anon_sym_false] = ACTIONS(893),
    [aux_sym_string_token1] = ACTIONS(891),
    [aux_sym_string_token3] = ACTIONS(891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(893),
    [anon_sym_catch] = ACTIONS(893),
    [anon_sym_continue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_enum] = ACTIONS(893),
    [anon_sym_extern] = ACTIONS(893),
    [anon_sym_for] = ACTIONS(893),
    [anon_sym_inline] = ACTIONS(893),
    [anon_sym_macro] = ACTIONS(893),
    [anon_sym_operator] = ACTIONS(893),
    [anon_sym_overload] = ACTIONS(893),
    [anon_sym_override] = ACTIONS(893),
    [anon_sym_private] = ACTIONS(893),
    [anon_sym_public] = ACTIONS(893),
    [anon_sym_return] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(893),
    [anon_sym_try] = ACTIONS(893),
    [anon_sym_untyped] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [sym__semicolon] = ACTIONS(891),
  },
  [157] = {
    [sym_block] = STATE(238),
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_POUND] = ACTIONS(900),
    [anon_sym_package] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_using] = ACTIONS(902),
    [anon_sym_throw] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_switch] = ACTIONS(902),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_case] = ACTIONS(902),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(902),
    [anon_sym_cast] = ACTIONS(902),
    [anon_sym_DOLLARtype] = ACTIONS(900),
    [anon_sym_in] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(900),
    [anon_sym_this] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(902),
    [anon_sym_AT_COLON] = ACTIONS(900),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(902),
    [anon_sym_new] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(900),
    [anon_sym_DASH_DASH] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(900),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_SLASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_LT_LT] = ACTIONS(900),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_GT_GT_GT] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(902),
    [anon_sym_PIPE] = ACTIONS(902),
    [anon_sym_CARET] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(900),
    [anon_sym_PIPE_PIPE] = ACTIONS(900),
    [anon_sym_EQ_EQ] = ACTIONS(900),
    [anon_sym_BANG_EQ] = ACTIONS(900),
    [anon_sym_LT] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(900),
    [anon_sym_GT] = ACTIONS(902),
    [anon_sym_GT_EQ] = ACTIONS(900),
    [anon_sym_EQ_GT] = ACTIONS(900),
    [anon_sym_QMARK_QMARK] = ACTIONS(900),
    [anon_sym_EQ] = ACTIONS(902),
    [sym__rangeOperator] = ACTIONS(900),
    [anon_sym_null] = ACTIONS(902),
    [anon_sym_dynamic] = ACTIONS(902),
    [anon_sym_final] = ACTIONS(902),
    [anon_sym_abstract] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_extends] = ACTIONS(902),
    [anon_sym_implements] = ACTIONS(902),
    [anon_sym_interface] = ACTIONS(902),
    [anon_sym_typedef] = ACTIONS(902),
    [anon_sym_function] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(902),
    [aux_sym_integer_token1] = ACTIONS(902),
    [aux_sym_integer_token2] = ACTIONS(900),
    [aux_sym_float_token1] = ACTIONS(902),
    [aux_sym_float_token2] = ACTIONS(900),
    [anon_sym_true] = ACTIONS(902),
    [anon_sym_false] = ACTIONS(902),
    [aux_sym_string_token1] = ACTIONS(900),
    [aux_sym_string_token3] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_catch] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_do] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_inline] = ACTIONS(902),
    [anon_sym_macro] = ACTIONS(902),
    [anon_sym_operator] = ACTIONS(902),
    [anon_sym_overload] = ACTIONS(902),
    [anon_sym_override] = ACTIONS(902),
    [anon_sym_private] = ACTIONS(902),
    [anon_sym_public] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_static] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_untyped] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [sym__semicolon] = ACTIONS(900),
  },
  [158] = {
    [sym_block] = STATE(235),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_POUND] = ACTIONS(909),
    [anon_sym_package] = ACTIONS(911),
    [anon_sym_import] = ACTIONS(911),
    [anon_sym_using] = ACTIONS(911),
    [anon_sym_throw] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_switch] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_case] = ACTIONS(911),
    [anon_sym_COLON] = ACTIONS(916),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_cast] = ACTIONS(911),
    [anon_sym_DOLLARtype] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_this] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_AT_COLON] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_GT_GT_GT] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(909),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_LT_EQ] = ACTIONS(909),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_QMARK_QMARK] = ACTIONS(909),
    [anon_sym_EQ] = ACTIONS(911),
    [sym__rangeOperator] = ACTIONS(909),
    [anon_sym_null] = ACTIONS(911),
    [anon_sym_dynamic] = ACTIONS(911),
    [anon_sym_final] = ACTIONS(911),
    [anon_sym_abstract] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_extends] = ACTIONS(911),
    [anon_sym_implements] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_typedef] = ACTIONS(911),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_var] = ACTIONS(911),
    [aux_sym_integer_token1] = ACTIONS(911),
    [aux_sym_integer_token2] = ACTIONS(909),
    [aux_sym_float_token1] = ACTIONS(911),
    [aux_sym_float_token2] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(911),
    [anon_sym_false] = ACTIONS(911),
    [aux_sym_string_token1] = ACTIONS(909),
    [aux_sym_string_token3] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(911),
    [anon_sym_catch] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_enum] = ACTIONS(911),
    [anon_sym_extern] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_inline] = ACTIONS(911),
    [anon_sym_macro] = ACTIONS(911),
    [anon_sym_operator] = ACTIONS(911),
    [anon_sym_overload] = ACTIONS(911),
    [anon_sym_override] = ACTIONS(911),
    [anon_sym_private] = ACTIONS(911),
    [anon_sym_public] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_static] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_untyped] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [sym__semicolon] = ACTIONS(909),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_POUND] = ACTIONS(918),
    [anon_sym_package] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_using] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_cast] = ACTIONS(920),
    [anon_sym_DOLLARtype] = ACTIONS(918),
    [anon_sym_in] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_this] = ACTIONS(920),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_AT_COLON] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_PERCENT] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_LT_LT] = ACTIONS(918),
    [anon_sym_GT_GT] = ACTIONS(920),
    [anon_sym_GT_GT_GT] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_PIPE] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(918),
    [anon_sym_AMP_AMP] = ACTIONS(918),
    [anon_sym_PIPE_PIPE] = ACTIONS(918),
    [anon_sym_EQ_EQ] = ACTIONS(918),
    [anon_sym_BANG_EQ] = ACTIONS(918),
    [anon_sym_LT] = ACTIONS(920),
    [anon_sym_LT_EQ] = ACTIONS(918),
    [anon_sym_GT] = ACTIONS(920),
    [anon_sym_GT_EQ] = ACTIONS(918),
    [anon_sym_EQ_GT] = ACTIONS(918),
    [anon_sym_QMARK_QMARK] = ACTIONS(918),
    [anon_sym_EQ] = ACTIONS(920),
    [sym__rangeOperator] = ACTIONS(918),
    [anon_sym_null] = ACTIONS(920),
    [anon_sym_dynamic] = ACTIONS(920),
    [anon_sym_final] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_extends] = ACTIONS(920),
    [anon_sym_implements] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [aux_sym_integer_token1] = ACTIONS(920),
    [aux_sym_integer_token2] = ACTIONS(918),
    [aux_sym_float_token1] = ACTIONS(920),
    [aux_sym_float_token2] = ACTIONS(918),
    [anon_sym_true] = ACTIONS(920),
    [anon_sym_false] = ACTIONS(920),
    [aux_sym_string_token1] = ACTIONS(918),
    [aux_sym_string_token3] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_catch] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_extern] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_inline] = ACTIONS(920),
    [anon_sym_macro] = ACTIONS(920),
    [anon_sym_operator] = ACTIONS(920),
    [anon_sym_overload] = ACTIONS(920),
    [anon_sym_override] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_untyped] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [sym__semicolon] = ACTIONS(918),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(922),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_POUND] = ACTIONS(922),
    [anon_sym_package] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(924),
    [anon_sym_using] = ACTIONS(924),
    [anon_sym_throw] = ACTIONS(924),
    [anon_sym_LPAREN] = ACTIONS(922),
    [anon_sym_switch] = ACTIONS(924),
    [anon_sym_LBRACE] = ACTIONS(922),
    [anon_sym_RBRACE] = ACTIONS(922),
    [anon_sym_case] = ACTIONS(924),
    [anon_sym_COLON] = ACTIONS(922),
    [anon_sym_default] = ACTIONS(924),
    [anon_sym_cast] = ACTIONS(924),
    [anon_sym_DOLLARtype] = ACTIONS(922),
    [anon_sym_in] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(922),
    [anon_sym_this] = ACTIONS(924),
    [anon_sym_AT] = ACTIONS(924),
    [anon_sym_AT_COLON] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(924),
    [anon_sym_else] = ACTIONS(924),
    [anon_sym_new] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(922),
    [anon_sym_DASH_DASH] = ACTIONS(922),
    [anon_sym_PERCENT] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(924),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_LT_LT] = ACTIONS(922),
    [anon_sym_GT_GT] = ACTIONS(924),
    [anon_sym_GT_GT_GT] = ACTIONS(922),
    [anon_sym_AMP] = ACTIONS(924),
    [anon_sym_PIPE] = ACTIONS(924),
    [anon_sym_CARET] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(922),
    [anon_sym_PIPE_PIPE] = ACTIONS(922),
    [anon_sym_EQ_EQ] = ACTIONS(922),
    [anon_sym_BANG_EQ] = ACTIONS(922),
    [anon_sym_LT] = ACTIONS(924),
    [anon_sym_LT_EQ] = ACTIONS(922),
    [anon_sym_GT] = ACTIONS(924),
    [anon_sym_GT_EQ] = ACTIONS(922),
    [anon_sym_EQ_GT] = ACTIONS(922),
    [anon_sym_QMARK_QMARK] = ACTIONS(922),
    [anon_sym_EQ] = ACTIONS(924),
    [sym__rangeOperator] = ACTIONS(922),
    [anon_sym_null] = ACTIONS(924),
    [anon_sym_dynamic] = ACTIONS(924),
    [anon_sym_final] = ACTIONS(924),
    [anon_sym_abstract] = ACTIONS(924),
    [anon_sym_class] = ACTIONS(924),
    [anon_sym_extends] = ACTIONS(924),
    [anon_sym_implements] = ACTIONS(924),
    [anon_sym_interface] = ACTIONS(924),
    [anon_sym_typedef] = ACTIONS(924),
    [anon_sym_function] = ACTIONS(924),
    [anon_sym_var] = ACTIONS(924),
    [aux_sym_integer_token1] = ACTIONS(924),
    [aux_sym_integer_token2] = ACTIONS(922),
    [aux_sym_float_token1] = ACTIONS(924),
    [aux_sym_float_token2] = ACTIONS(922),
    [anon_sym_true] = ACTIONS(924),
    [anon_sym_false] = ACTIONS(924),
    [aux_sym_string_token1] = ACTIONS(922),
    [aux_sym_string_token3] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_catch] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_do] = ACTIONS(924),
    [anon_sym_enum] = ACTIONS(924),
    [anon_sym_extern] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_inline] = ACTIONS(924),
    [anon_sym_macro] = ACTIONS(924),
    [anon_sym_operator] = ACTIONS(924),
    [anon_sym_overload] = ACTIONS(924),
    [anon_sym_override] = ACTIONS(924),
    [anon_sym_private] = ACTIONS(924),
    [anon_sym_public] = ACTIONS(924),
    [anon_sym_return] = ACTIONS(924),
    [anon_sym_static] = ACTIONS(924),
    [anon_sym_try] = ACTIONS(924),
    [anon_sym_untyped] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(924),
    [sym__semicolon] = ACTIONS(922),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(926),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_POUND] = ACTIONS(926),
    [anon_sym_package] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_using] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(928),
    [anon_sym_LBRACE] = ACTIONS(926),
    [anon_sym_RBRACE] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(928),
    [anon_sym_default] = ACTIONS(928),
    [anon_sym_cast] = ACTIONS(928),
    [anon_sym_DOLLARtype] = ACTIONS(926),
    [anon_sym_in] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(926),
    [anon_sym_this] = ACTIONS(928),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(928),
    [anon_sym_AT_COLON] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_else] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_PERCENT] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(926),
    [anon_sym_SLASH] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(928),
    [anon_sym_LT_LT] = ACTIONS(926),
    [anon_sym_GT_GT] = ACTIONS(928),
    [anon_sym_GT_GT_GT] = ACTIONS(926),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_CARET] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_EQ_EQ] = ACTIONS(926),
    [anon_sym_BANG_EQ] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_LT_EQ] = ACTIONS(926),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_EQ] = ACTIONS(926),
    [anon_sym_EQ_GT] = ACTIONS(926),
    [anon_sym_QMARK_QMARK] = ACTIONS(926),
    [anon_sym_EQ] = ACTIONS(928),
    [sym__rangeOperator] = ACTIONS(926),
    [anon_sym_null] = ACTIONS(928),
    [anon_sym_dynamic] = ACTIONS(928),
    [anon_sym_final] = ACTIONS(928),
    [anon_sym_abstract] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_extends] = ACTIONS(928),
    [anon_sym_implements] = ACTIONS(928),
    [anon_sym_interface] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(928),
    [anon_sym_var] = ACTIONS(928),
    [aux_sym_integer_token1] = ACTIONS(928),
    [aux_sym_integer_token2] = ACTIONS(926),
    [aux_sym_float_token1] = ACTIONS(928),
    [aux_sym_float_token2] = ACTIONS(926),
    [anon_sym_true] = ACTIONS(928),
    [anon_sym_false] = ACTIONS(928),
    [aux_sym_string_token1] = ACTIONS(926),
    [aux_sym_string_token3] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_catch] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(928),
    [anon_sym_enum] = ACTIONS(928),
    [anon_sym_extern] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_inline] = ACTIONS(928),
    [anon_sym_macro] = ACTIONS(928),
    [anon_sym_operator] = ACTIONS(928),
    [anon_sym_overload] = ACTIONS(928),
    [anon_sym_override] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_untyped] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [sym__semicolon] = ACTIONS(926),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(930),
    [sym_identifier] = ACTIONS(932),
    [anon_sym_POUND] = ACTIONS(930),
    [anon_sym_package] = ACTIONS(932),
    [anon_sym_import] = ACTIONS(932),
    [anon_sym_using] = ACTIONS(932),
    [anon_sym_throw] = ACTIONS(932),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_switch] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(930),
    [anon_sym_RBRACE] = ACTIONS(930),
    [anon_sym_case] = ACTIONS(932),
    [anon_sym_default] = ACTIONS(932),
    [anon_sym_cast] = ACTIONS(932),
    [anon_sym_DOLLARtype] = ACTIONS(930),
    [anon_sym_in] = ACTIONS(932),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_this] = ACTIONS(932),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_AT_COLON] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(932),
    [anon_sym_else] = ACTIONS(934),
    [anon_sym_elseif] = ACTIONS(936),
    [anon_sym_new] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_BANG] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_PLUS_PLUS] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(930),
    [anon_sym_PERCENT] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_LT_LT] = ACTIONS(930),
    [anon_sym_GT_GT] = ACTIONS(932),
    [anon_sym_GT_GT_GT] = ACTIONS(930),
    [anon_sym_AMP] = ACTIONS(932),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_CARET] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(930),
    [anon_sym_BANG_EQ] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_LT_EQ] = ACTIONS(930),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_EQ] = ACTIONS(930),
    [anon_sym_EQ_GT] = ACTIONS(930),
    [anon_sym_QMARK_QMARK] = ACTIONS(930),
    [anon_sym_EQ] = ACTIONS(932),
    [sym__rangeOperator] = ACTIONS(930),
    [anon_sym_null] = ACTIONS(932),
    [anon_sym_dynamic] = ACTIONS(932),
    [anon_sym_final] = ACTIONS(932),
    [anon_sym_abstract] = ACTIONS(932),
    [anon_sym_class] = ACTIONS(932),
    [anon_sym_extends] = ACTIONS(932),
    [anon_sym_implements] = ACTIONS(932),
    [anon_sym_interface] = ACTIONS(932),
    [anon_sym_typedef] = ACTIONS(932),
    [anon_sym_function] = ACTIONS(932),
    [anon_sym_var] = ACTIONS(932),
    [aux_sym_integer_token1] = ACTIONS(932),
    [aux_sym_integer_token2] = ACTIONS(930),
    [aux_sym_float_token1] = ACTIONS(932),
    [aux_sym_float_token2] = ACTIONS(930),
    [anon_sym_true] = ACTIONS(932),
    [anon_sym_false] = ACTIONS(932),
    [aux_sym_string_token1] = ACTIONS(930),
    [aux_sym_string_token3] = ACTIONS(930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(932),
    [anon_sym_catch] = ACTIONS(932),
    [anon_sym_continue] = ACTIONS(932),
    [anon_sym_do] = ACTIONS(932),
    [anon_sym_enum] = ACTIONS(932),
    [anon_sym_extern] = ACTIONS(932),
    [anon_sym_for] = ACTIONS(932),
    [anon_sym_inline] = ACTIONS(932),
    [anon_sym_macro] = ACTIONS(932),
    [anon_sym_operator] = ACTIONS(932),
    [anon_sym_overload] = ACTIONS(932),
    [anon_sym_override] = ACTIONS(932),
    [anon_sym_private] = ACTIONS(932),
    [anon_sym_public] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(932),
    [anon_sym_static] = ACTIONS(932),
    [anon_sym_try] = ACTIONS(932),
    [anon_sym_untyped] = ACTIONS(932),
    [anon_sym_while] = ACTIONS(932),
    [sym__semicolon] = ACTIONS(930),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(938),
    [sym_identifier] = ACTIONS(940),
    [anon_sym_POUND] = ACTIONS(938),
    [anon_sym_package] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(940),
    [anon_sym_throw] = ACTIONS(940),
    [anon_sym_LPAREN] = ACTIONS(938),
    [anon_sym_switch] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_RBRACE] = ACTIONS(938),
    [anon_sym_case] = ACTIONS(940),
    [anon_sym_COLON] = ACTIONS(938),
    [anon_sym_default] = ACTIONS(940),
    [anon_sym_cast] = ACTIONS(940),
    [anon_sym_DOLLARtype] = ACTIONS(938),
    [anon_sym_in] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(938),
    [anon_sym_this] = ACTIONS(940),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_AT_COLON] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(940),
    [anon_sym_else] = ACTIONS(940),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_TILDE] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(940),
    [anon_sym_DASH] = ACTIONS(940),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_PERCENT] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_SLASH] = ACTIONS(940),
    [anon_sym_PLUS] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(938),
    [anon_sym_GT_GT] = ACTIONS(940),
    [anon_sym_GT_GT_GT] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(940),
    [anon_sym_PIPE] = ACTIONS(940),
    [anon_sym_CARET] = ACTIONS(938),
    [anon_sym_AMP_AMP] = ACTIONS(938),
    [anon_sym_PIPE_PIPE] = ACTIONS(938),
    [anon_sym_EQ_EQ] = ACTIONS(938),
    [anon_sym_BANG_EQ] = ACTIONS(938),
    [anon_sym_LT] = ACTIONS(940),
    [anon_sym_LT_EQ] = ACTIONS(938),
    [anon_sym_GT] = ACTIONS(940),
    [anon_sym_GT_EQ] = ACTIONS(938),
    [anon_sym_EQ_GT] = ACTIONS(938),
    [anon_sym_QMARK_QMARK] = ACTIONS(938),
    [anon_sym_EQ] = ACTIONS(940),
    [sym__rangeOperator] = ACTIONS(938),
    [anon_sym_null] = ACTIONS(940),
    [anon_sym_dynamic] = ACTIONS(940),
    [anon_sym_final] = ACTIONS(940),
    [anon_sym_abstract] = ACTIONS(940),
    [anon_sym_class] = ACTIONS(940),
    [anon_sym_extends] = ACTIONS(940),
    [anon_sym_implements] = ACTIONS(940),
    [anon_sym_interface] = ACTIONS(940),
    [anon_sym_typedef] = ACTIONS(940),
    [anon_sym_function] = ACTIONS(940),
    [anon_sym_var] = ACTIONS(940),
    [aux_sym_integer_token1] = ACTIONS(940),
    [aux_sym_integer_token2] = ACTIONS(938),
    [aux_sym_float_token1] = ACTIONS(940),
    [aux_sym_float_token2] = ACTIONS(938),
    [anon_sym_true] = ACTIONS(940),
    [anon_sym_false] = ACTIONS(940),
    [aux_sym_string_token1] = ACTIONS(938),
    [aux_sym_string_token3] = ACTIONS(938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(940),
    [anon_sym_catch] = ACTIONS(940),
    [anon_sym_continue] = ACTIONS(940),
    [anon_sym_do] = ACTIONS(940),
    [anon_sym_enum] = ACTIONS(940),
    [anon_sym_extern] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(940),
    [anon_sym_inline] = ACTIONS(940),
    [anon_sym_macro] = ACTIONS(940),
    [anon_sym_operator] = ACTIONS(940),
    [anon_sym_overload] = ACTIONS(940),
    [anon_sym_override] = ACTIONS(940),
    [anon_sym_private] = ACTIONS(940),
    [anon_sym_public] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(940),
    [anon_sym_static] = ACTIONS(940),
    [anon_sym_try] = ACTIONS(940),
    [anon_sym_untyped] = ACTIONS(940),
    [anon_sym_while] = ACTIONS(940),
    [sym__semicolon] = ACTIONS(938),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(942),
    [sym_identifier] = ACTIONS(944),
    [anon_sym_POUND] = ACTIONS(942),
    [anon_sym_package] = ACTIONS(944),
    [anon_sym_import] = ACTIONS(944),
    [anon_sym_using] = ACTIONS(944),
    [anon_sym_throw] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(942),
    [anon_sym_switch] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(942),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_case] = ACTIONS(944),
    [anon_sym_COLON] = ACTIONS(942),
    [anon_sym_default] = ACTIONS(944),
    [anon_sym_cast] = ACTIONS(944),
    [anon_sym_DOLLARtype] = ACTIONS(942),
    [anon_sym_in] = ACTIONS(944),
    [anon_sym_LBRACK] = ACTIONS(942),
    [anon_sym_this] = ACTIONS(944),
    [anon_sym_AT] = ACTIONS(944),
    [anon_sym_AT_COLON] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(944),
    [anon_sym_else] = ACTIONS(944),
    [anon_sym_new] = ACTIONS(944),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(944),
    [anon_sym_DASH] = ACTIONS(944),
    [anon_sym_PLUS_PLUS] = ACTIONS(942),
    [anon_sym_DASH_DASH] = ACTIONS(942),
    [anon_sym_PERCENT] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_PLUS] = ACTIONS(944),
    [anon_sym_LT_LT] = ACTIONS(942),
    [anon_sym_GT_GT] = ACTIONS(944),
    [anon_sym_GT_GT_GT] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(944),
    [anon_sym_PIPE] = ACTIONS(944),
    [anon_sym_CARET] = ACTIONS(942),
    [anon_sym_AMP_AMP] = ACTIONS(942),
    [anon_sym_PIPE_PIPE] = ACTIONS(942),
    [anon_sym_EQ_EQ] = ACTIONS(942),
    [anon_sym_BANG_EQ] = ACTIONS(942),
    [anon_sym_LT] = ACTIONS(944),
    [anon_sym_LT_EQ] = ACTIONS(942),
    [anon_sym_GT] = ACTIONS(944),
    [anon_sym_GT_EQ] = ACTIONS(942),
    [anon_sym_EQ_GT] = ACTIONS(942),
    [anon_sym_QMARK_QMARK] = ACTIONS(942),
    [anon_sym_EQ] = ACTIONS(944),
    [sym__rangeOperator] = ACTIONS(942),
    [anon_sym_null] = ACTIONS(944),
    [anon_sym_dynamic] = ACTIONS(944),
    [anon_sym_final] = ACTIONS(944),
    [anon_sym_abstract] = ACTIONS(944),
    [anon_sym_class] = ACTIONS(944),
    [anon_sym_extends] = ACTIONS(944),
    [anon_sym_implements] = ACTIONS(944),
    [anon_sym_interface] = ACTIONS(944),
    [anon_sym_typedef] = ACTIONS(944),
    [anon_sym_function] = ACTIONS(944),
    [anon_sym_var] = ACTIONS(944),
    [aux_sym_integer_token1] = ACTIONS(944),
    [aux_sym_integer_token2] = ACTIONS(942),
    [aux_sym_float_token1] = ACTIONS(944),
    [aux_sym_float_token2] = ACTIONS(942),
    [anon_sym_true] = ACTIONS(944),
    [anon_sym_false] = ACTIONS(944),
    [aux_sym_string_token1] = ACTIONS(942),
    [aux_sym_string_token3] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(944),
    [anon_sym_catch] = ACTIONS(944),
    [anon_sym_continue] = ACTIONS(944),
    [anon_sym_do] = ACTIONS(944),
    [anon_sym_enum] = ACTIONS(944),
    [anon_sym_extern] = ACTIONS(944),
    [anon_sym_for] = ACTIONS(944),
    [anon_sym_inline] = ACTIONS(944),
    [anon_sym_macro] = ACTIONS(944),
    [anon_sym_operator] = ACTIONS(944),
    [anon_sym_overload] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(944),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_try] = ACTIONS(944),
    [anon_sym_untyped] = ACTIONS(944),
    [anon_sym_while] = ACTIONS(944),
    [sym__semicolon] = ACTIONS(942),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_POUND] = ACTIONS(946),
    [anon_sym_package] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_using] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_cast] = ACTIONS(948),
    [anon_sym_DOLLARtype] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_this] = ACTIONS(948),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(948),
    [anon_sym_AT_COLON] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PERCENT] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_LT_LT] = ACTIONS(946),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_GT_GT_GT] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(946),
    [anon_sym_AMP_AMP] = ACTIONS(946),
    [anon_sym_PIPE_PIPE] = ACTIONS(946),
    [anon_sym_EQ_EQ] = ACTIONS(946),
    [anon_sym_BANG_EQ] = ACTIONS(946),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_LT_EQ] = ACTIONS(946),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_GT_EQ] = ACTIONS(946),
    [anon_sym_EQ_GT] = ACTIONS(946),
    [anon_sym_QMARK_QMARK] = ACTIONS(946),
    [anon_sym_EQ] = ACTIONS(948),
    [sym__rangeOperator] = ACTIONS(946),
    [anon_sym_null] = ACTIONS(948),
    [anon_sym_dynamic] = ACTIONS(948),
    [anon_sym_final] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_extends] = ACTIONS(948),
    [anon_sym_implements] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [aux_sym_integer_token1] = ACTIONS(948),
    [aux_sym_integer_token2] = ACTIONS(946),
    [aux_sym_float_token1] = ACTIONS(948),
    [aux_sym_float_token2] = ACTIONS(946),
    [anon_sym_true] = ACTIONS(948),
    [anon_sym_false] = ACTIONS(948),
    [aux_sym_string_token1] = ACTIONS(946),
    [aux_sym_string_token3] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_catch] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_macro] = ACTIONS(948),
    [anon_sym_operator] = ACTIONS(948),
    [anon_sym_overload] = ACTIONS(948),
    [anon_sym_override] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_untyped] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [sym__semicolon] = ACTIONS(946),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(950),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_POUND] = ACTIONS(950),
    [anon_sym_package] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_using] = ACTIONS(952),
    [anon_sym_throw] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_cast] = ACTIONS(952),
    [anon_sym_DOLLARtype] = ACTIONS(950),
    [anon_sym_in] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [anon_sym_this] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(952),
    [anon_sym_AT_COLON] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_elseif] = ACTIONS(950),
    [anon_sym_new] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PERCENT] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(950),
    [anon_sym_GT_GT] = ACTIONS(952),
    [anon_sym_GT_GT_GT] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(952),
    [anon_sym_CARET] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_EQ_GT] = ACTIONS(950),
    [anon_sym_QMARK_QMARK] = ACTIONS(950),
    [anon_sym_EQ] = ACTIONS(952),
    [sym__rangeOperator] = ACTIONS(950),
    [anon_sym_null] = ACTIONS(952),
    [anon_sym_dynamic] = ACTIONS(952),
    [anon_sym_final] = ACTIONS(952),
    [anon_sym_abstract] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(952),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(952),
    [aux_sym_integer_token1] = ACTIONS(952),
    [aux_sym_integer_token2] = ACTIONS(950),
    [aux_sym_float_token1] = ACTIONS(952),
    [aux_sym_float_token2] = ACTIONS(950),
    [anon_sym_true] = ACTIONS(952),
    [anon_sym_false] = ACTIONS(952),
    [aux_sym_string_token1] = ACTIONS(950),
    [aux_sym_string_token3] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_catch] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_macro] = ACTIONS(952),
    [anon_sym_operator] = ACTIONS(952),
    [anon_sym_overload] = ACTIONS(952),
    [anon_sym_override] = ACTIONS(952),
    [anon_sym_private] = ACTIONS(952),
    [anon_sym_public] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_untyped] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [sym__semicolon] = ACTIONS(950),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_package] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(771),
    [anon_sym_using] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_cast] = ACTIONS(771),
    [anon_sym_DOLLARtype] = ACTIONS(769),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_this] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_AT_COLON] = ACTIONS(769),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_elseif] = ACTIONS(769),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_GT_GT_GT] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(769),
    [anon_sym_QMARK_QMARK] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [sym__rangeOperator] = ACTIONS(769),
    [anon_sym_null] = ACTIONS(771),
    [anon_sym_dynamic] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_extends] = ACTIONS(771),
    [anon_sym_implements] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_var] = ACTIONS(771),
    [aux_sym_integer_token1] = ACTIONS(771),
    [aux_sym_integer_token2] = ACTIONS(769),
    [aux_sym_float_token1] = ACTIONS(771),
    [aux_sym_float_token2] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [aux_sym_string_token1] = ACTIONS(769),
    [aux_sym_string_token3] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_catch] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_macro] = ACTIONS(771),
    [anon_sym_operator] = ACTIONS(771),
    [anon_sym_overload] = ACTIONS(771),
    [anon_sym_override] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_untyped] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [sym__semicolon] = ACTIONS(769),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(954),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_POUND] = ACTIONS(954),
    [anon_sym_package] = ACTIONS(956),
    [anon_sym_import] = ACTIONS(956),
    [anon_sym_using] = ACTIONS(956),
    [anon_sym_throw] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_cast] = ACTIONS(956),
    [anon_sym_DOLLARtype] = ACTIONS(954),
    [anon_sym_in] = ACTIONS(956),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_this] = ACTIONS(956),
    [anon_sym_DASH_GT] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_AT_COLON] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_new] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_SLASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(956),
    [anon_sym_GT_GT_GT] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(956),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [anon_sym_EQ_EQ] = ACTIONS(954),
    [anon_sym_BANG_EQ] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(956),
    [anon_sym_LT_EQ] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(956),
    [anon_sym_GT_EQ] = ACTIONS(954),
    [anon_sym_EQ_GT] = ACTIONS(954),
    [anon_sym_QMARK_QMARK] = ACTIONS(954),
    [anon_sym_EQ] = ACTIONS(956),
    [sym__rangeOperator] = ACTIONS(954),
    [anon_sym_null] = ACTIONS(956),
    [anon_sym_dynamic] = ACTIONS(956),
    [anon_sym_final] = ACTIONS(956),
    [anon_sym_abstract] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(956),
    [anon_sym_extends] = ACTIONS(956),
    [anon_sym_implements] = ACTIONS(956),
    [anon_sym_interface] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_var] = ACTIONS(956),
    [aux_sym_integer_token1] = ACTIONS(956),
    [aux_sym_integer_token2] = ACTIONS(954),
    [aux_sym_float_token1] = ACTIONS(956),
    [aux_sym_float_token2] = ACTIONS(954),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [aux_sym_string_token1] = ACTIONS(954),
    [aux_sym_string_token3] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_catch] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_macro] = ACTIONS(956),
    [anon_sym_operator] = ACTIONS(956),
    [anon_sym_overload] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_try] = ACTIONS(956),
    [anon_sym_untyped] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [sym__semicolon] = ACTIONS(954),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_POUND] = ACTIONS(958),
    [anon_sym_package] = ACTIONS(960),
    [anon_sym_import] = ACTIONS(960),
    [anon_sym_using] = ACTIONS(960),
    [anon_sym_throw] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_switch] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_case] = ACTIONS(960),
    [anon_sym_default] = ACTIONS(960),
    [anon_sym_cast] = ACTIONS(960),
    [anon_sym_DOLLARtype] = ACTIONS(958),
    [anon_sym_in] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_this] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(960),
    [anon_sym_AT_COLON] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(960),
    [anon_sym_else] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(960),
    [anon_sym_DASH] = ACTIONS(960),
    [anon_sym_PLUS_PLUS] = ACTIONS(958),
    [anon_sym_DASH_DASH] = ACTIONS(958),
    [anon_sym_PERCENT] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(960),
    [anon_sym_PLUS] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(958),
    [anon_sym_GT_GT] = ACTIONS(960),
    [anon_sym_GT_GT_GT] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(960),
    [anon_sym_CARET] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [anon_sym_EQ_EQ] = ACTIONS(958),
    [anon_sym_BANG_EQ] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(960),
    [anon_sym_LT_EQ] = ACTIONS(958),
    [anon_sym_GT] = ACTIONS(960),
    [anon_sym_GT_EQ] = ACTIONS(958),
    [anon_sym_EQ_GT] = ACTIONS(958),
    [anon_sym_QMARK_QMARK] = ACTIONS(958),
    [anon_sym_EQ] = ACTIONS(960),
    [sym__rangeOperator] = ACTIONS(958),
    [anon_sym_null] = ACTIONS(960),
    [anon_sym_dynamic] = ACTIONS(960),
    [anon_sym_final] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_extends] = ACTIONS(960),
    [anon_sym_implements] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_typedef] = ACTIONS(960),
    [anon_sym_function] = ACTIONS(960),
    [anon_sym_var] = ACTIONS(960),
    [aux_sym_integer_token1] = ACTIONS(960),
    [aux_sym_integer_token2] = ACTIONS(958),
    [aux_sym_float_token1] = ACTIONS(960),
    [aux_sym_float_token2] = ACTIONS(958),
    [anon_sym_true] = ACTIONS(960),
    [anon_sym_false] = ACTIONS(960),
    [aux_sym_string_token1] = ACTIONS(958),
    [aux_sym_string_token3] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(960),
    [anon_sym_catch] = ACTIONS(960),
    [anon_sym_continue] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(960),
    [anon_sym_inline] = ACTIONS(960),
    [anon_sym_macro] = ACTIONS(960),
    [anon_sym_operator] = ACTIONS(960),
    [anon_sym_overload] = ACTIONS(960),
    [anon_sym_override] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_try] = ACTIONS(960),
    [anon_sym_untyped] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(960),
    [sym__semicolon] = ACTIONS(958),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(962),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_POUND] = ACTIONS(962),
    [anon_sym_package] = ACTIONS(964),
    [anon_sym_import] = ACTIONS(964),
    [anon_sym_using] = ACTIONS(964),
    [anon_sym_throw] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(962),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_cast] = ACTIONS(964),
    [anon_sym_DOLLARtype] = ACTIONS(962),
    [anon_sym_in] = ACTIONS(964),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_this] = ACTIONS(964),
    [anon_sym_AT] = ACTIONS(964),
    [anon_sym_AT_COLON] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_else] = ACTIONS(964),
    [anon_sym_new] = ACTIONS(964),
    [anon_sym_TILDE] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(964),
    [anon_sym_DASH] = ACTIONS(964),
    [anon_sym_PLUS_PLUS] = ACTIONS(962),
    [anon_sym_DASH_DASH] = ACTIONS(962),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_SLASH] = ACTIONS(964),
    [anon_sym_PLUS] = ACTIONS(964),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(964),
    [anon_sym_GT_GT_GT] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(964),
    [anon_sym_PIPE] = ACTIONS(964),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_AMP_AMP] = ACTIONS(962),
    [anon_sym_PIPE_PIPE] = ACTIONS(962),
    [anon_sym_EQ_EQ] = ACTIONS(962),
    [anon_sym_BANG_EQ] = ACTIONS(962),
    [anon_sym_LT] = ACTIONS(964),
    [anon_sym_LT_EQ] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(964),
    [anon_sym_GT_EQ] = ACTIONS(962),
    [anon_sym_EQ_GT] = ACTIONS(962),
    [anon_sym_QMARK_QMARK] = ACTIONS(962),
    [anon_sym_EQ] = ACTIONS(964),
    [sym__rangeOperator] = ACTIONS(962),
    [anon_sym_null] = ACTIONS(964),
    [anon_sym_dynamic] = ACTIONS(964),
    [anon_sym_final] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(964),
    [anon_sym_class] = ACTIONS(964),
    [anon_sym_extends] = ACTIONS(964),
    [anon_sym_implements] = ACTIONS(964),
    [anon_sym_interface] = ACTIONS(964),
    [anon_sym_typedef] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_var] = ACTIONS(964),
    [aux_sym_integer_token1] = ACTIONS(964),
    [aux_sym_integer_token2] = ACTIONS(962),
    [aux_sym_float_token1] = ACTIONS(964),
    [aux_sym_float_token2] = ACTIONS(962),
    [anon_sym_true] = ACTIONS(964),
    [anon_sym_false] = ACTIONS(964),
    [aux_sym_string_token1] = ACTIONS(962),
    [aux_sym_string_token3] = ACTIONS(962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_catch] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_do] = ACTIONS(964),
    [anon_sym_enum] = ACTIONS(964),
    [anon_sym_extern] = ACTIONS(964),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_inline] = ACTIONS(964),
    [anon_sym_macro] = ACTIONS(964),
    [anon_sym_operator] = ACTIONS(964),
    [anon_sym_overload] = ACTIONS(964),
    [anon_sym_override] = ACTIONS(964),
    [anon_sym_private] = ACTIONS(964),
    [anon_sym_public] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_static] = ACTIONS(964),
    [anon_sym_try] = ACTIONS(964),
    [anon_sym_untyped] = ACTIONS(964),
    [anon_sym_while] = ACTIONS(964),
    [sym__semicolon] = ACTIONS(962),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(966),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_POUND] = ACTIONS(966),
    [anon_sym_package] = ACTIONS(968),
    [anon_sym_import] = ACTIONS(968),
    [anon_sym_using] = ACTIONS(968),
    [anon_sym_throw] = ACTIONS(968),
    [anon_sym_LPAREN] = ACTIONS(966),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_cast] = ACTIONS(968),
    [anon_sym_DOLLARtype] = ACTIONS(966),
    [anon_sym_in] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(966),
    [anon_sym_this] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_AT_COLON] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_else] = ACTIONS(968),
    [anon_sym_new] = ACTIONS(968),
    [anon_sym_TILDE] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_PLUS_PLUS] = ACTIONS(966),
    [anon_sym_DASH_DASH] = ACTIONS(966),
    [anon_sym_PERCENT] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(966),
    [anon_sym_SLASH] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_LT_LT] = ACTIONS(966),
    [anon_sym_GT_GT] = ACTIONS(968),
    [anon_sym_GT_GT_GT] = ACTIONS(966),
    [anon_sym_AMP] = ACTIONS(968),
    [anon_sym_PIPE] = ACTIONS(968),
    [anon_sym_CARET] = ACTIONS(966),
    [anon_sym_AMP_AMP] = ACTIONS(966),
    [anon_sym_PIPE_PIPE] = ACTIONS(966),
    [anon_sym_EQ_EQ] = ACTIONS(966),
    [anon_sym_BANG_EQ] = ACTIONS(966),
    [anon_sym_LT] = ACTIONS(968),
    [anon_sym_LT_EQ] = ACTIONS(966),
    [anon_sym_GT] = ACTIONS(968),
    [anon_sym_GT_EQ] = ACTIONS(966),
    [anon_sym_EQ_GT] = ACTIONS(966),
    [anon_sym_QMARK_QMARK] = ACTIONS(966),
    [anon_sym_EQ] = ACTIONS(968),
    [sym__rangeOperator] = ACTIONS(966),
    [anon_sym_null] = ACTIONS(968),
    [anon_sym_dynamic] = ACTIONS(968),
    [anon_sym_final] = ACTIONS(968),
    [anon_sym_abstract] = ACTIONS(968),
    [anon_sym_class] = ACTIONS(968),
    [anon_sym_extends] = ACTIONS(968),
    [anon_sym_implements] = ACTIONS(968),
    [anon_sym_interface] = ACTIONS(968),
    [anon_sym_typedef] = ACTIONS(968),
    [anon_sym_function] = ACTIONS(968),
    [anon_sym_var] = ACTIONS(968),
    [aux_sym_integer_token1] = ACTIONS(968),
    [aux_sym_integer_token2] = ACTIONS(966),
    [aux_sym_float_token1] = ACTIONS(968),
    [aux_sym_float_token2] = ACTIONS(966),
    [anon_sym_true] = ACTIONS(968),
    [anon_sym_false] = ACTIONS(968),
    [aux_sym_string_token1] = ACTIONS(966),
    [aux_sym_string_token3] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_catch] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_do] = ACTIONS(968),
    [anon_sym_enum] = ACTIONS(968),
    [anon_sym_extern] = ACTIONS(968),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_inline] = ACTIONS(968),
    [anon_sym_macro] = ACTIONS(968),
    [anon_sym_operator] = ACTIONS(968),
    [anon_sym_overload] = ACTIONS(968),
    [anon_sym_override] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_try] = ACTIONS(968),
    [anon_sym_untyped] = ACTIONS(968),
    [anon_sym_while] = ACTIONS(968),
    [sym__semicolon] = ACTIONS(966),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(970),
    [sym_identifier] = ACTIONS(972),
    [anon_sym_POUND] = ACTIONS(970),
    [anon_sym_package] = ACTIONS(972),
    [anon_sym_import] = ACTIONS(972),
    [anon_sym_using] = ACTIONS(972),
    [anon_sym_throw] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(970),
    [anon_sym_switch] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_case] = ACTIONS(972),
    [anon_sym_default] = ACTIONS(972),
    [anon_sym_cast] = ACTIONS(972),
    [anon_sym_DOLLARtype] = ACTIONS(970),
    [anon_sym_in] = ACTIONS(972),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_this] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(972),
    [anon_sym_AT_COLON] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_else] = ACTIONS(972),
    [anon_sym_new] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(970),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS_PLUS] = ACTIONS(970),
    [anon_sym_DASH_DASH] = ACTIONS(970),
    [anon_sym_PERCENT] = ACTIONS(970),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_SLASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_LT_LT] = ACTIONS(970),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_GT_GT_GT] = ACTIONS(970),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_PIPE] = ACTIONS(972),
    [anon_sym_CARET] = ACTIONS(970),
    [anon_sym_AMP_AMP] = ACTIONS(970),
    [anon_sym_PIPE_PIPE] = ACTIONS(970),
    [anon_sym_EQ_EQ] = ACTIONS(970),
    [anon_sym_BANG_EQ] = ACTIONS(970),
    [anon_sym_LT] = ACTIONS(972),
    [anon_sym_LT_EQ] = ACTIONS(970),
    [anon_sym_GT] = ACTIONS(972),
    [anon_sym_GT_EQ] = ACTIONS(970),
    [anon_sym_EQ_GT] = ACTIONS(970),
    [anon_sym_QMARK_QMARK] = ACTIONS(970),
    [anon_sym_EQ] = ACTIONS(972),
    [sym__rangeOperator] = ACTIONS(970),
    [anon_sym_null] = ACTIONS(972),
    [anon_sym_dynamic] = ACTIONS(972),
    [anon_sym_final] = ACTIONS(972),
    [anon_sym_abstract] = ACTIONS(972),
    [anon_sym_class] = ACTIONS(972),
    [anon_sym_extends] = ACTIONS(972),
    [anon_sym_implements] = ACTIONS(972),
    [anon_sym_interface] = ACTIONS(972),
    [anon_sym_typedef] = ACTIONS(972),
    [anon_sym_function] = ACTIONS(972),
    [anon_sym_var] = ACTIONS(972),
    [aux_sym_integer_token1] = ACTIONS(972),
    [aux_sym_integer_token2] = ACTIONS(970),
    [aux_sym_float_token1] = ACTIONS(972),
    [aux_sym_float_token2] = ACTIONS(970),
    [anon_sym_true] = ACTIONS(972),
    [anon_sym_false] = ACTIONS(972),
    [aux_sym_string_token1] = ACTIONS(970),
    [aux_sym_string_token3] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(972),
    [anon_sym_catch] = ACTIONS(972),
    [anon_sym_continue] = ACTIONS(972),
    [anon_sym_do] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym_for] = ACTIONS(972),
    [anon_sym_inline] = ACTIONS(972),
    [anon_sym_macro] = ACTIONS(972),
    [anon_sym_operator] = ACTIONS(972),
    [anon_sym_overload] = ACTIONS(972),
    [anon_sym_override] = ACTIONS(972),
    [anon_sym_private] = ACTIONS(972),
    [anon_sym_public] = ACTIONS(972),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_static] = ACTIONS(972),
    [anon_sym_try] = ACTIONS(972),
    [anon_sym_untyped] = ACTIONS(972),
    [anon_sym_while] = ACTIONS(972),
    [sym__semicolon] = ACTIONS(970),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(974),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_POUND] = ACTIONS(974),
    [anon_sym_package] = ACTIONS(976),
    [anon_sym_import] = ACTIONS(976),
    [anon_sym_using] = ACTIONS(976),
    [anon_sym_throw] = ACTIONS(976),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_switch] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_case] = ACTIONS(976),
    [anon_sym_default] = ACTIONS(976),
    [anon_sym_cast] = ACTIONS(976),
    [anon_sym_DOLLARtype] = ACTIONS(974),
    [anon_sym_in] = ACTIONS(976),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_this] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_AT_COLON] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(976),
    [anon_sym_else] = ACTIONS(976),
    [anon_sym_new] = ACTIONS(976),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_BANG] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_PLUS_PLUS] = ACTIONS(974),
    [anon_sym_DASH_DASH] = ACTIONS(974),
    [anon_sym_PERCENT] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(974),
    [anon_sym_SLASH] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_LT_LT] = ACTIONS(974),
    [anon_sym_GT_GT] = ACTIONS(976),
    [anon_sym_GT_GT_GT] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(976),
    [anon_sym_PIPE] = ACTIONS(976),
    [anon_sym_CARET] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_EQ_EQ] = ACTIONS(974),
    [anon_sym_BANG_EQ] = ACTIONS(974),
    [anon_sym_LT] = ACTIONS(976),
    [anon_sym_LT_EQ] = ACTIONS(974),
    [anon_sym_GT] = ACTIONS(976),
    [anon_sym_GT_EQ] = ACTIONS(974),
    [anon_sym_EQ_GT] = ACTIONS(974),
    [anon_sym_QMARK_QMARK] = ACTIONS(974),
    [anon_sym_EQ] = ACTIONS(976),
    [sym__rangeOperator] = ACTIONS(974),
    [anon_sym_null] = ACTIONS(976),
    [anon_sym_dynamic] = ACTIONS(976),
    [anon_sym_final] = ACTIONS(976),
    [anon_sym_abstract] = ACTIONS(976),
    [anon_sym_class] = ACTIONS(976),
    [anon_sym_extends] = ACTIONS(976),
    [anon_sym_implements] = ACTIONS(976),
    [anon_sym_interface] = ACTIONS(976),
    [anon_sym_typedef] = ACTIONS(976),
    [anon_sym_function] = ACTIONS(976),
    [anon_sym_var] = ACTIONS(976),
    [aux_sym_integer_token1] = ACTIONS(976),
    [aux_sym_integer_token2] = ACTIONS(974),
    [aux_sym_float_token1] = ACTIONS(976),
    [aux_sym_float_token2] = ACTIONS(974),
    [anon_sym_true] = ACTIONS(976),
    [anon_sym_false] = ACTIONS(976),
    [aux_sym_string_token1] = ACTIONS(974),
    [aux_sym_string_token3] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(976),
    [anon_sym_catch] = ACTIONS(976),
    [anon_sym_continue] = ACTIONS(976),
    [anon_sym_do] = ACTIONS(976),
    [anon_sym_enum] = ACTIONS(976),
    [anon_sym_extern] = ACTIONS(976),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_inline] = ACTIONS(976),
    [anon_sym_macro] = ACTIONS(976),
    [anon_sym_operator] = ACTIONS(976),
    [anon_sym_overload] = ACTIONS(976),
    [anon_sym_override] = ACTIONS(976),
    [anon_sym_private] = ACTIONS(976),
    [anon_sym_public] = ACTIONS(976),
    [anon_sym_return] = ACTIONS(976),
    [anon_sym_static] = ACTIONS(976),
    [anon_sym_try] = ACTIONS(976),
    [anon_sym_untyped] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(976),
    [sym__semicolon] = ACTIONS(974),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_package] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(980),
    [anon_sym_using] = ACTIONS(980),
    [anon_sym_throw] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_switch] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_case] = ACTIONS(980),
    [anon_sym_default] = ACTIONS(980),
    [anon_sym_cast] = ACTIONS(980),
    [anon_sym_DOLLARtype] = ACTIONS(978),
    [anon_sym_in] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_this] = ACTIONS(980),
    [anon_sym_AT] = ACTIONS(980),
    [anon_sym_AT_COLON] = ACTIONS(978),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_else] = ACTIONS(980),
    [anon_sym_new] = ACTIONS(980),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(980),
    [anon_sym_DASH] = ACTIONS(980),
    [anon_sym_PLUS_PLUS] = ACTIONS(978),
    [anon_sym_DASH_DASH] = ACTIONS(978),
    [anon_sym_PERCENT] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_SLASH] = ACTIONS(980),
    [anon_sym_PLUS] = ACTIONS(980),
    [anon_sym_LT_LT] = ACTIONS(978),
    [anon_sym_GT_GT] = ACTIONS(980),
    [anon_sym_GT_GT_GT] = ACTIONS(978),
    [anon_sym_AMP] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(980),
    [anon_sym_CARET] = ACTIONS(978),
    [anon_sym_AMP_AMP] = ACTIONS(978),
    [anon_sym_PIPE_PIPE] = ACTIONS(978),
    [anon_sym_EQ_EQ] = ACTIONS(978),
    [anon_sym_BANG_EQ] = ACTIONS(978),
    [anon_sym_LT] = ACTIONS(980),
    [anon_sym_LT_EQ] = ACTIONS(978),
    [anon_sym_GT] = ACTIONS(980),
    [anon_sym_GT_EQ] = ACTIONS(978),
    [anon_sym_EQ_GT] = ACTIONS(978),
    [anon_sym_QMARK_QMARK] = ACTIONS(978),
    [anon_sym_EQ] = ACTIONS(980),
    [sym__rangeOperator] = ACTIONS(978),
    [anon_sym_null] = ACTIONS(980),
    [anon_sym_dynamic] = ACTIONS(980),
    [anon_sym_final] = ACTIONS(980),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_class] = ACTIONS(980),
    [anon_sym_extends] = ACTIONS(980),
    [anon_sym_implements] = ACTIONS(980),
    [anon_sym_interface] = ACTIONS(980),
    [anon_sym_typedef] = ACTIONS(980),
    [anon_sym_function] = ACTIONS(980),
    [anon_sym_var] = ACTIONS(980),
    [aux_sym_integer_token1] = ACTIONS(980),
    [aux_sym_integer_token2] = ACTIONS(978),
    [aux_sym_float_token1] = ACTIONS(980),
    [aux_sym_float_token2] = ACTIONS(978),
    [anon_sym_true] = ACTIONS(980),
    [anon_sym_false] = ACTIONS(980),
    [aux_sym_string_token1] = ACTIONS(978),
    [aux_sym_string_token3] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_catch] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_do] = ACTIONS(980),
    [anon_sym_enum] = ACTIONS(980),
    [anon_sym_extern] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_inline] = ACTIONS(980),
    [anon_sym_macro] = ACTIONS(980),
    [anon_sym_operator] = ACTIONS(980),
    [anon_sym_overload] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [anon_sym_untyped] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [sym__semicolon] = ACTIONS(978),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(982),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_POUND] = ACTIONS(982),
    [anon_sym_package] = ACTIONS(984),
    [anon_sym_import] = ACTIONS(984),
    [anon_sym_using] = ACTIONS(984),
    [anon_sym_throw] = ACTIONS(984),
    [anon_sym_LPAREN] = ACTIONS(982),
    [anon_sym_switch] = ACTIONS(984),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_case] = ACTIONS(984),
    [anon_sym_default] = ACTIONS(984),
    [anon_sym_cast] = ACTIONS(984),
    [anon_sym_DOLLARtype] = ACTIONS(982),
    [anon_sym_in] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(982),
    [anon_sym_this] = ACTIONS(984),
    [anon_sym_AT] = ACTIONS(984),
    [anon_sym_AT_COLON] = ACTIONS(982),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_else] = ACTIONS(984),
    [anon_sym_new] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(982),
    [anon_sym_BANG] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_PERCENT] = ACTIONS(982),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_SLASH] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(982),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_GT_GT_GT] = ACTIONS(982),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_PIPE] = ACTIONS(984),
    [anon_sym_CARET] = ACTIONS(982),
    [anon_sym_AMP_AMP] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_EQ_EQ] = ACTIONS(982),
    [anon_sym_BANG_EQ] = ACTIONS(982),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_EQ_GT] = ACTIONS(982),
    [anon_sym_QMARK_QMARK] = ACTIONS(982),
    [anon_sym_EQ] = ACTIONS(984),
    [sym__rangeOperator] = ACTIONS(982),
    [anon_sym_null] = ACTIONS(984),
    [anon_sym_dynamic] = ACTIONS(984),
    [anon_sym_final] = ACTIONS(984),
    [anon_sym_abstract] = ACTIONS(984),
    [anon_sym_class] = ACTIONS(984),
    [anon_sym_extends] = ACTIONS(984),
    [anon_sym_implements] = ACTIONS(984),
    [anon_sym_interface] = ACTIONS(984),
    [anon_sym_typedef] = ACTIONS(984),
    [anon_sym_function] = ACTIONS(984),
    [anon_sym_var] = ACTIONS(984),
    [aux_sym_integer_token1] = ACTIONS(984),
    [aux_sym_integer_token2] = ACTIONS(982),
    [aux_sym_float_token1] = ACTIONS(984),
    [aux_sym_float_token2] = ACTIONS(982),
    [anon_sym_true] = ACTIONS(984),
    [anon_sym_false] = ACTIONS(984),
    [aux_sym_string_token1] = ACTIONS(982),
    [aux_sym_string_token3] = ACTIONS(982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_catch] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_do] = ACTIONS(984),
    [anon_sym_enum] = ACTIONS(984),
    [anon_sym_extern] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_inline] = ACTIONS(984),
    [anon_sym_macro] = ACTIONS(984),
    [anon_sym_operator] = ACTIONS(984),
    [anon_sym_overload] = ACTIONS(984),
    [anon_sym_override] = ACTIONS(984),
    [anon_sym_private] = ACTIONS(984),
    [anon_sym_public] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_static] = ACTIONS(984),
    [anon_sym_try] = ACTIONS(984),
    [anon_sym_untyped] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [sym__semicolon] = ACTIONS(982),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(988),
    [anon_sym_POUND] = ACTIONS(986),
    [anon_sym_package] = ACTIONS(988),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_using] = ACTIONS(988),
    [anon_sym_throw] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_switch] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_case] = ACTIONS(988),
    [anon_sym_default] = ACTIONS(988),
    [anon_sym_cast] = ACTIONS(988),
    [anon_sym_DOLLARtype] = ACTIONS(986),
    [anon_sym_in] = ACTIONS(988),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_this] = ACTIONS(988),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_AT_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(988),
    [anon_sym_new] = ACTIONS(988),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [anon_sym_PLUS_PLUS] = ACTIONS(986),
    [anon_sym_DASH_DASH] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_SLASH] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(988),
    [anon_sym_LT_LT] = ACTIONS(986),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_GT_GT_GT] = ACTIONS(986),
    [anon_sym_AMP] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_CARET] = ACTIONS(986),
    [anon_sym_AMP_AMP] = ACTIONS(986),
    [anon_sym_PIPE_PIPE] = ACTIONS(986),
    [anon_sym_EQ_EQ] = ACTIONS(986),
    [anon_sym_BANG_EQ] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_LT_EQ] = ACTIONS(986),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_GT_EQ] = ACTIONS(986),
    [anon_sym_EQ_GT] = ACTIONS(986),
    [anon_sym_QMARK_QMARK] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(988),
    [sym__rangeOperator] = ACTIONS(986),
    [anon_sym_null] = ACTIONS(988),
    [anon_sym_dynamic] = ACTIONS(988),
    [anon_sym_final] = ACTIONS(988),
    [anon_sym_abstract] = ACTIONS(988),
    [anon_sym_class] = ACTIONS(988),
    [anon_sym_extends] = ACTIONS(988),
    [anon_sym_implements] = ACTIONS(988),
    [anon_sym_interface] = ACTIONS(988),
    [anon_sym_typedef] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(988),
    [anon_sym_var] = ACTIONS(988),
    [aux_sym_integer_token1] = ACTIONS(988),
    [aux_sym_integer_token2] = ACTIONS(986),
    [aux_sym_float_token1] = ACTIONS(988),
    [aux_sym_float_token2] = ACTIONS(986),
    [anon_sym_true] = ACTIONS(988),
    [anon_sym_false] = ACTIONS(988),
    [aux_sym_string_token1] = ACTIONS(986),
    [aux_sym_string_token3] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(988),
    [anon_sym_catch] = ACTIONS(988),
    [anon_sym_continue] = ACTIONS(988),
    [anon_sym_do] = ACTIONS(988),
    [anon_sym_enum] = ACTIONS(988),
    [anon_sym_extern] = ACTIONS(988),
    [anon_sym_for] = ACTIONS(988),
    [anon_sym_inline] = ACTIONS(988),
    [anon_sym_macro] = ACTIONS(988),
    [anon_sym_operator] = ACTIONS(988),
    [anon_sym_overload] = ACTIONS(988),
    [anon_sym_override] = ACTIONS(988),
    [anon_sym_private] = ACTIONS(988),
    [anon_sym_public] = ACTIONS(988),
    [anon_sym_return] = ACTIONS(988),
    [anon_sym_static] = ACTIONS(988),
    [anon_sym_try] = ACTIONS(988),
    [anon_sym_untyped] = ACTIONS(988),
    [anon_sym_while] = ACTIONS(988),
    [sym__semicolon] = ACTIONS(986),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(990),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_POUND] = ACTIONS(990),
    [anon_sym_package] = ACTIONS(992),
    [anon_sym_import] = ACTIONS(992),
    [anon_sym_using] = ACTIONS(992),
    [anon_sym_throw] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_switch] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_case] = ACTIONS(992),
    [anon_sym_default] = ACTIONS(992),
    [anon_sym_cast] = ACTIONS(992),
    [anon_sym_DOLLARtype] = ACTIONS(990),
    [anon_sym_in] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(990),
    [anon_sym_this] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_AT_COLON] = ACTIONS(990),
    [anon_sym_if] = ACTIONS(992),
    [anon_sym_else] = ACTIONS(992),
    [anon_sym_new] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_PLUS_PLUS] = ACTIONS(990),
    [anon_sym_DASH_DASH] = ACTIONS(990),
    [anon_sym_PERCENT] = ACTIONS(990),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_SLASH] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_LT_LT] = ACTIONS(990),
    [anon_sym_GT_GT] = ACTIONS(992),
    [anon_sym_GT_GT_GT] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_CARET] = ACTIONS(990),
    [anon_sym_AMP_AMP] = ACTIONS(990),
    [anon_sym_PIPE_PIPE] = ACTIONS(990),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_LT] = ACTIONS(992),
    [anon_sym_LT_EQ] = ACTIONS(990),
    [anon_sym_GT] = ACTIONS(992),
    [anon_sym_GT_EQ] = ACTIONS(990),
    [anon_sym_EQ_GT] = ACTIONS(990),
    [anon_sym_QMARK_QMARK] = ACTIONS(990),
    [anon_sym_EQ] = ACTIONS(992),
    [sym__rangeOperator] = ACTIONS(990),
    [anon_sym_null] = ACTIONS(992),
    [anon_sym_dynamic] = ACTIONS(992),
    [anon_sym_final] = ACTIONS(992),
    [anon_sym_abstract] = ACTIONS(992),
    [anon_sym_class] = ACTIONS(992),
    [anon_sym_extends] = ACTIONS(992),
    [anon_sym_implements] = ACTIONS(992),
    [anon_sym_interface] = ACTIONS(992),
    [anon_sym_typedef] = ACTIONS(992),
    [anon_sym_function] = ACTIONS(992),
    [anon_sym_var] = ACTIONS(992),
    [aux_sym_integer_token1] = ACTIONS(992),
    [aux_sym_integer_token2] = ACTIONS(990),
    [aux_sym_float_token1] = ACTIONS(992),
    [aux_sym_float_token2] = ACTIONS(990),
    [anon_sym_true] = ACTIONS(992),
    [anon_sym_false] = ACTIONS(992),
    [aux_sym_string_token1] = ACTIONS(990),
    [aux_sym_string_token3] = ACTIONS(990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(992),
    [anon_sym_catch] = ACTIONS(992),
    [anon_sym_continue] = ACTIONS(992),
    [anon_sym_do] = ACTIONS(992),
    [anon_sym_enum] = ACTIONS(992),
    [anon_sym_extern] = ACTIONS(992),
    [anon_sym_for] = ACTIONS(992),
    [anon_sym_inline] = ACTIONS(992),
    [anon_sym_macro] = ACTIONS(992),
    [anon_sym_operator] = ACTIONS(992),
    [anon_sym_overload] = ACTIONS(992),
    [anon_sym_override] = ACTIONS(992),
    [anon_sym_private] = ACTIONS(992),
    [anon_sym_public] = ACTIONS(992),
    [anon_sym_return] = ACTIONS(992),
    [anon_sym_static] = ACTIONS(992),
    [anon_sym_try] = ACTIONS(992),
    [anon_sym_untyped] = ACTIONS(992),
    [anon_sym_while] = ACTIONS(992),
    [sym__semicolon] = ACTIONS(990),
  },
  [178] = {
    [sym__rhs_expression] = STATE(431),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(981),
    [sym_builtin_type] = STATE(1008),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1105),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(431),
    [sym_operator] = STATE(803),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(467),
    [sym_integer] = STATE(467),
    [sym_float] = STATE(467),
    [sym_bool] = STATE(467),
    [sym_string] = STATE(462),
    [sym_null] = STATE(467),
    [sym_array] = STATE(467),
    [sym_map] = STATE(467),
    [sym_object] = STATE(467),
    [sym_pair] = STATE(467),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(996),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(998),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(1000),
    [sym_identifier] = ACTIONS(1002),
    [anon_sym_POUND] = ACTIONS(1000),
    [anon_sym_package] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_using] = ACTIONS(1002),
    [anon_sym_throw] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_switch] = ACTIONS(1002),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_case] = ACTIONS(1002),
    [anon_sym_default] = ACTIONS(1002),
    [anon_sym_cast] = ACTIONS(1002),
    [anon_sym_DOLLARtype] = ACTIONS(1000),
    [anon_sym_in] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [anon_sym_this] = ACTIONS(1002),
    [anon_sym_AT] = ACTIONS(1002),
    [anon_sym_AT_COLON] = ACTIONS(1000),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1002),
    [anon_sym_DASH] = ACTIONS(1002),
    [anon_sym_PLUS_PLUS] = ACTIONS(1000),
    [anon_sym_DASH_DASH] = ACTIONS(1000),
    [anon_sym_PERCENT] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_SLASH] = ACTIONS(1002),
    [anon_sym_PLUS] = ACTIONS(1002),
    [anon_sym_LT_LT] = ACTIONS(1000),
    [anon_sym_GT_GT] = ACTIONS(1002),
    [anon_sym_GT_GT_GT] = ACTIONS(1000),
    [anon_sym_AMP] = ACTIONS(1002),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_CARET] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1000),
    [anon_sym_PIPE_PIPE] = ACTIONS(1000),
    [anon_sym_EQ_EQ] = ACTIONS(1000),
    [anon_sym_BANG_EQ] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1002),
    [anon_sym_LT_EQ] = ACTIONS(1000),
    [anon_sym_GT] = ACTIONS(1002),
    [anon_sym_GT_EQ] = ACTIONS(1000),
    [anon_sym_EQ_GT] = ACTIONS(1000),
    [anon_sym_QMARK_QMARK] = ACTIONS(1000),
    [anon_sym_EQ] = ACTIONS(1002),
    [sym__rangeOperator] = ACTIONS(1000),
    [anon_sym_null] = ACTIONS(1002),
    [anon_sym_dynamic] = ACTIONS(1002),
    [anon_sym_final] = ACTIONS(1002),
    [anon_sym_abstract] = ACTIONS(1002),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_extends] = ACTIONS(1002),
    [anon_sym_implements] = ACTIONS(1002),
    [anon_sym_interface] = ACTIONS(1002),
    [anon_sym_typedef] = ACTIONS(1002),
    [anon_sym_function] = ACTIONS(1002),
    [anon_sym_var] = ACTIONS(1002),
    [aux_sym_integer_token1] = ACTIONS(1002),
    [aux_sym_integer_token2] = ACTIONS(1000),
    [aux_sym_float_token1] = ACTIONS(1002),
    [aux_sym_float_token2] = ACTIONS(1000),
    [anon_sym_true] = ACTIONS(1002),
    [anon_sym_false] = ACTIONS(1002),
    [aux_sym_string_token1] = ACTIONS(1000),
    [aux_sym_string_token3] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_catch] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_do] = ACTIONS(1002),
    [anon_sym_enum] = ACTIONS(1002),
    [anon_sym_extern] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_inline] = ACTIONS(1002),
    [anon_sym_macro] = ACTIONS(1002),
    [anon_sym_operator] = ACTIONS(1002),
    [anon_sym_overload] = ACTIONS(1002),
    [anon_sym_override] = ACTIONS(1002),
    [anon_sym_private] = ACTIONS(1002),
    [anon_sym_public] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_static] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_untyped] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [sym__semicolon] = ACTIONS(1000),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(1004),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_POUND] = ACTIONS(1004),
    [anon_sym_package] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_using] = ACTIONS(1006),
    [anon_sym_throw] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_switch] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(1004),
    [anon_sym_RBRACE] = ACTIONS(1004),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_cast] = ACTIONS(1006),
    [anon_sym_DOLLARtype] = ACTIONS(1004),
    [anon_sym_in] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_this] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(1006),
    [anon_sym_AT_COLON] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(1006),
    [anon_sym_else] = ACTIONS(1006),
    [anon_sym_new] = ACTIONS(1006),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_BANG] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(1004),
    [anon_sym_DASH_DASH] = ACTIONS(1004),
    [anon_sym_PERCENT] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_SLASH] = ACTIONS(1006),
    [anon_sym_PLUS] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(1004),
    [anon_sym_GT_GT] = ACTIONS(1006),
    [anon_sym_GT_GT_GT] = ACTIONS(1004),
    [anon_sym_AMP] = ACTIONS(1006),
    [anon_sym_PIPE] = ACTIONS(1006),
    [anon_sym_CARET] = ACTIONS(1004),
    [anon_sym_AMP_AMP] = ACTIONS(1004),
    [anon_sym_PIPE_PIPE] = ACTIONS(1004),
    [anon_sym_EQ_EQ] = ACTIONS(1004),
    [anon_sym_BANG_EQ] = ACTIONS(1004),
    [anon_sym_LT] = ACTIONS(1006),
    [anon_sym_LT_EQ] = ACTIONS(1004),
    [anon_sym_GT] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(1004),
    [anon_sym_EQ_GT] = ACTIONS(1004),
    [anon_sym_QMARK_QMARK] = ACTIONS(1004),
    [anon_sym_EQ] = ACTIONS(1006),
    [sym__rangeOperator] = ACTIONS(1004),
    [anon_sym_null] = ACTIONS(1006),
    [anon_sym_dynamic] = ACTIONS(1006),
    [anon_sym_final] = ACTIONS(1006),
    [anon_sym_abstract] = ACTIONS(1006),
    [anon_sym_class] = ACTIONS(1006),
    [anon_sym_extends] = ACTIONS(1006),
    [anon_sym_implements] = ACTIONS(1006),
    [anon_sym_interface] = ACTIONS(1006),
    [anon_sym_typedef] = ACTIONS(1006),
    [anon_sym_function] = ACTIONS(1006),
    [anon_sym_var] = ACTIONS(1006),
    [aux_sym_integer_token1] = ACTIONS(1006),
    [aux_sym_integer_token2] = ACTIONS(1004),
    [aux_sym_float_token1] = ACTIONS(1006),
    [aux_sym_float_token2] = ACTIONS(1004),
    [anon_sym_true] = ACTIONS(1006),
    [anon_sym_false] = ACTIONS(1006),
    [aux_sym_string_token1] = ACTIONS(1004),
    [aux_sym_string_token3] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_catch] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [anon_sym_do] = ACTIONS(1006),
    [anon_sym_enum] = ACTIONS(1006),
    [anon_sym_extern] = ACTIONS(1006),
    [anon_sym_for] = ACTIONS(1006),
    [anon_sym_inline] = ACTIONS(1006),
    [anon_sym_macro] = ACTIONS(1006),
    [anon_sym_operator] = ACTIONS(1006),
    [anon_sym_overload] = ACTIONS(1006),
    [anon_sym_override] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1006),
    [anon_sym_try] = ACTIONS(1006),
    [anon_sym_untyped] = ACTIONS(1006),
    [anon_sym_while] = ACTIONS(1006),
    [sym__semicolon] = ACTIONS(1004),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(1008),
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_POUND] = ACTIONS(1008),
    [anon_sym_package] = ACTIONS(1010),
    [anon_sym_import] = ACTIONS(1010),
    [anon_sym_using] = ACTIONS(1010),
    [anon_sym_throw] = ACTIONS(1010),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_cast] = ACTIONS(1010),
    [anon_sym_DOLLARtype] = ACTIONS(1008),
    [anon_sym_in] = ACTIONS(1010),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_this] = ACTIONS(1010),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_AT_COLON] = ACTIONS(1008),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1010),
    [anon_sym_new] = ACTIONS(1010),
    [anon_sym_TILDE] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1010),
    [anon_sym_PLUS_PLUS] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1008),
    [anon_sym_PERCENT] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1008),
    [anon_sym_SLASH] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1008),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [anon_sym_GT_GT_GT] = ACTIONS(1008),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_CARET] = ACTIONS(1008),
    [anon_sym_AMP_AMP] = ACTIONS(1008),
    [anon_sym_PIPE_PIPE] = ACTIONS(1008),
    [anon_sym_EQ_EQ] = ACTIONS(1008),
    [anon_sym_BANG_EQ] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_EQ] = ACTIONS(1008),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_GT_EQ] = ACTIONS(1008),
    [anon_sym_EQ_GT] = ACTIONS(1008),
    [anon_sym_QMARK_QMARK] = ACTIONS(1008),
    [anon_sym_EQ] = ACTIONS(1010),
    [sym__rangeOperator] = ACTIONS(1008),
    [anon_sym_null] = ACTIONS(1010),
    [anon_sym_dynamic] = ACTIONS(1010),
    [anon_sym_final] = ACTIONS(1010),
    [anon_sym_abstract] = ACTIONS(1010),
    [anon_sym_class] = ACTIONS(1010),
    [anon_sym_extends] = ACTIONS(1010),
    [anon_sym_implements] = ACTIONS(1010),
    [anon_sym_interface] = ACTIONS(1010),
    [anon_sym_typedef] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_var] = ACTIONS(1010),
    [aux_sym_integer_token1] = ACTIONS(1010),
    [aux_sym_integer_token2] = ACTIONS(1008),
    [aux_sym_float_token1] = ACTIONS(1010),
    [aux_sym_float_token2] = ACTIONS(1008),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [aux_sym_string_token1] = ACTIONS(1008),
    [aux_sym_string_token3] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_catch] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [anon_sym_do] = ACTIONS(1010),
    [anon_sym_enum] = ACTIONS(1010),
    [anon_sym_extern] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1010),
    [anon_sym_inline] = ACTIONS(1010),
    [anon_sym_macro] = ACTIONS(1010),
    [anon_sym_operator] = ACTIONS(1010),
    [anon_sym_overload] = ACTIONS(1010),
    [anon_sym_override] = ACTIONS(1010),
    [anon_sym_private] = ACTIONS(1010),
    [anon_sym_public] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_static] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1010),
    [anon_sym_untyped] = ACTIONS(1010),
    [anon_sym_while] = ACTIONS(1010),
    [sym__semicolon] = ACTIONS(1008),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(1012),
    [sym_identifier] = ACTIONS(1014),
    [anon_sym_POUND] = ACTIONS(1012),
    [anon_sym_package] = ACTIONS(1014),
    [anon_sym_import] = ACTIONS(1014),
    [anon_sym_using] = ACTIONS(1014),
    [anon_sym_throw] = ACTIONS(1014),
    [anon_sym_LPAREN] = ACTIONS(1012),
    [anon_sym_switch] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [anon_sym_case] = ACTIONS(1014),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_cast] = ACTIONS(1014),
    [anon_sym_DOLLARtype] = ACTIONS(1012),
    [anon_sym_in] = ACTIONS(1014),
    [anon_sym_LBRACK] = ACTIONS(1012),
    [anon_sym_this] = ACTIONS(1014),
    [anon_sym_AT] = ACTIONS(1014),
    [anon_sym_AT_COLON] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(1014),
    [anon_sym_else] = ACTIONS(1014),
    [anon_sym_new] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_DASH] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1012),
    [anon_sym_DASH_DASH] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_SLASH] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(1014),
    [anon_sym_LT_LT] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(1014),
    [anon_sym_GT_GT_GT] = ACTIONS(1012),
    [anon_sym_AMP] = ACTIONS(1014),
    [anon_sym_PIPE] = ACTIONS(1014),
    [anon_sym_CARET] = ACTIONS(1012),
    [anon_sym_AMP_AMP] = ACTIONS(1012),
    [anon_sym_PIPE_PIPE] = ACTIONS(1012),
    [anon_sym_EQ_EQ] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(1012),
    [anon_sym_LT] = ACTIONS(1014),
    [anon_sym_LT_EQ] = ACTIONS(1012),
    [anon_sym_GT] = ACTIONS(1014),
    [anon_sym_GT_EQ] = ACTIONS(1012),
    [anon_sym_EQ_GT] = ACTIONS(1012),
    [anon_sym_QMARK_QMARK] = ACTIONS(1012),
    [anon_sym_EQ] = ACTIONS(1014),
    [sym__rangeOperator] = ACTIONS(1012),
    [anon_sym_null] = ACTIONS(1014),
    [anon_sym_dynamic] = ACTIONS(1014),
    [anon_sym_final] = ACTIONS(1014),
    [anon_sym_abstract] = ACTIONS(1014),
    [anon_sym_class] = ACTIONS(1014),
    [anon_sym_extends] = ACTIONS(1014),
    [anon_sym_implements] = ACTIONS(1014),
    [anon_sym_interface] = ACTIONS(1014),
    [anon_sym_typedef] = ACTIONS(1014),
    [anon_sym_function] = ACTIONS(1014),
    [anon_sym_var] = ACTIONS(1014),
    [aux_sym_integer_token1] = ACTIONS(1014),
    [aux_sym_integer_token2] = ACTIONS(1012),
    [aux_sym_float_token1] = ACTIONS(1014),
    [aux_sym_float_token2] = ACTIONS(1012),
    [anon_sym_true] = ACTIONS(1014),
    [anon_sym_false] = ACTIONS(1014),
    [aux_sym_string_token1] = ACTIONS(1012),
    [aux_sym_string_token3] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1014),
    [anon_sym_catch] = ACTIONS(1014),
    [anon_sym_continue] = ACTIONS(1014),
    [anon_sym_do] = ACTIONS(1014),
    [anon_sym_enum] = ACTIONS(1014),
    [anon_sym_extern] = ACTIONS(1014),
    [anon_sym_for] = ACTIONS(1014),
    [anon_sym_inline] = ACTIONS(1014),
    [anon_sym_macro] = ACTIONS(1014),
    [anon_sym_operator] = ACTIONS(1014),
    [anon_sym_overload] = ACTIONS(1014),
    [anon_sym_override] = ACTIONS(1014),
    [anon_sym_private] = ACTIONS(1014),
    [anon_sym_public] = ACTIONS(1014),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_static] = ACTIONS(1014),
    [anon_sym_try] = ACTIONS(1014),
    [anon_sym_untyped] = ACTIONS(1014),
    [anon_sym_while] = ACTIONS(1014),
    [sym__semicolon] = ACTIONS(1012),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_POUND] = ACTIONS(1016),
    [anon_sym_package] = ACTIONS(1018),
    [anon_sym_import] = ACTIONS(1018),
    [anon_sym_using] = ACTIONS(1018),
    [anon_sym_throw] = ACTIONS(1018),
    [anon_sym_LPAREN] = ACTIONS(1016),
    [anon_sym_switch] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_case] = ACTIONS(1018),
    [anon_sym_default] = ACTIONS(1018),
    [anon_sym_cast] = ACTIONS(1018),
    [anon_sym_DOLLARtype] = ACTIONS(1016),
    [anon_sym_in] = ACTIONS(1018),
    [anon_sym_LBRACK] = ACTIONS(1016),
    [anon_sym_this] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_AT_COLON] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_else] = ACTIONS(1018),
    [anon_sym_new] = ACTIONS(1018),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1016),
    [anon_sym_DASH_DASH] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(1016),
    [anon_sym_STAR] = ACTIONS(1016),
    [anon_sym_SLASH] = ACTIONS(1018),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1018),
    [anon_sym_GT_GT_GT] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_PIPE] = ACTIONS(1018),
    [anon_sym_CARET] = ACTIONS(1016),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [anon_sym_EQ_EQ] = ACTIONS(1016),
    [anon_sym_BANG_EQ] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1018),
    [anon_sym_LT_EQ] = ACTIONS(1016),
    [anon_sym_GT] = ACTIONS(1018),
    [anon_sym_GT_EQ] = ACTIONS(1016),
    [anon_sym_EQ_GT] = ACTIONS(1016),
    [anon_sym_QMARK_QMARK] = ACTIONS(1016),
    [anon_sym_EQ] = ACTIONS(1018),
    [sym__rangeOperator] = ACTIONS(1016),
    [anon_sym_null] = ACTIONS(1018),
    [anon_sym_dynamic] = ACTIONS(1018),
    [anon_sym_final] = ACTIONS(1018),
    [anon_sym_abstract] = ACTIONS(1018),
    [anon_sym_class] = ACTIONS(1018),
    [anon_sym_extends] = ACTIONS(1018),
    [anon_sym_implements] = ACTIONS(1018),
    [anon_sym_interface] = ACTIONS(1018),
    [anon_sym_typedef] = ACTIONS(1018),
    [anon_sym_function] = ACTIONS(1018),
    [anon_sym_var] = ACTIONS(1018),
    [aux_sym_integer_token1] = ACTIONS(1018),
    [aux_sym_integer_token2] = ACTIONS(1016),
    [aux_sym_float_token1] = ACTIONS(1018),
    [aux_sym_float_token2] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1018),
    [anon_sym_false] = ACTIONS(1018),
    [aux_sym_string_token1] = ACTIONS(1016),
    [aux_sym_string_token3] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1018),
    [anon_sym_catch] = ACTIONS(1018),
    [anon_sym_continue] = ACTIONS(1018),
    [anon_sym_do] = ACTIONS(1018),
    [anon_sym_enum] = ACTIONS(1018),
    [anon_sym_extern] = ACTIONS(1018),
    [anon_sym_for] = ACTIONS(1018),
    [anon_sym_inline] = ACTIONS(1018),
    [anon_sym_macro] = ACTIONS(1018),
    [anon_sym_operator] = ACTIONS(1018),
    [anon_sym_overload] = ACTIONS(1018),
    [anon_sym_override] = ACTIONS(1018),
    [anon_sym_private] = ACTIONS(1018),
    [anon_sym_public] = ACTIONS(1018),
    [anon_sym_return] = ACTIONS(1018),
    [anon_sym_static] = ACTIONS(1018),
    [anon_sym_try] = ACTIONS(1018),
    [anon_sym_untyped] = ACTIONS(1018),
    [anon_sym_while] = ACTIONS(1018),
    [sym__semicolon] = ACTIONS(1016),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(1020),
    [sym_identifier] = ACTIONS(1022),
    [anon_sym_POUND] = ACTIONS(1020),
    [anon_sym_package] = ACTIONS(1022),
    [anon_sym_import] = ACTIONS(1022),
    [anon_sym_using] = ACTIONS(1022),
    [anon_sym_throw] = ACTIONS(1022),
    [anon_sym_LPAREN] = ACTIONS(1020),
    [anon_sym_switch] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_case] = ACTIONS(1022),
    [anon_sym_default] = ACTIONS(1022),
    [anon_sym_cast] = ACTIONS(1022),
    [anon_sym_DOLLARtype] = ACTIONS(1020),
    [anon_sym_in] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_this] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1022),
    [anon_sym_AT_COLON] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1022),
    [anon_sym_else] = ACTIONS(1022),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1020),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1020),
    [anon_sym_PERCENT] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_SLASH] = ACTIONS(1022),
    [anon_sym_PLUS] = ACTIONS(1022),
    [anon_sym_LT_LT] = ACTIONS(1020),
    [anon_sym_GT_GT] = ACTIONS(1022),
    [anon_sym_GT_GT_GT] = ACTIONS(1020),
    [anon_sym_AMP] = ACTIONS(1022),
    [anon_sym_PIPE] = ACTIONS(1022),
    [anon_sym_CARET] = ACTIONS(1020),
    [anon_sym_AMP_AMP] = ACTIONS(1020),
    [anon_sym_PIPE_PIPE] = ACTIONS(1020),
    [anon_sym_EQ_EQ] = ACTIONS(1020),
    [anon_sym_BANG_EQ] = ACTIONS(1020),
    [anon_sym_LT] = ACTIONS(1022),
    [anon_sym_LT_EQ] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1022),
    [anon_sym_GT_EQ] = ACTIONS(1020),
    [anon_sym_EQ_GT] = ACTIONS(1020),
    [anon_sym_QMARK_QMARK] = ACTIONS(1020),
    [anon_sym_EQ] = ACTIONS(1022),
    [sym__rangeOperator] = ACTIONS(1020),
    [anon_sym_null] = ACTIONS(1022),
    [anon_sym_dynamic] = ACTIONS(1022),
    [anon_sym_final] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(1022),
    [anon_sym_class] = ACTIONS(1022),
    [anon_sym_extends] = ACTIONS(1022),
    [anon_sym_implements] = ACTIONS(1022),
    [anon_sym_interface] = ACTIONS(1022),
    [anon_sym_typedef] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(1022),
    [anon_sym_var] = ACTIONS(1022),
    [aux_sym_integer_token1] = ACTIONS(1022),
    [aux_sym_integer_token2] = ACTIONS(1020),
    [aux_sym_float_token1] = ACTIONS(1022),
    [aux_sym_float_token2] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1022),
    [anon_sym_false] = ACTIONS(1022),
    [aux_sym_string_token1] = ACTIONS(1020),
    [aux_sym_string_token3] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1022),
    [anon_sym_catch] = ACTIONS(1022),
    [anon_sym_continue] = ACTIONS(1022),
    [anon_sym_do] = ACTIONS(1022),
    [anon_sym_enum] = ACTIONS(1022),
    [anon_sym_extern] = ACTIONS(1022),
    [anon_sym_for] = ACTIONS(1022),
    [anon_sym_inline] = ACTIONS(1022),
    [anon_sym_macro] = ACTIONS(1022),
    [anon_sym_operator] = ACTIONS(1022),
    [anon_sym_overload] = ACTIONS(1022),
    [anon_sym_override] = ACTIONS(1022),
    [anon_sym_private] = ACTIONS(1022),
    [anon_sym_public] = ACTIONS(1022),
    [anon_sym_return] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1022),
    [anon_sym_try] = ACTIONS(1022),
    [anon_sym_untyped] = ACTIONS(1022),
    [anon_sym_while] = ACTIONS(1022),
    [sym__semicolon] = ACTIONS(1020),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(1024),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_POUND] = ACTIONS(1024),
    [anon_sym_package] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_using] = ACTIONS(1026),
    [anon_sym_throw] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1024),
    [anon_sym_switch] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1024),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_case] = ACTIONS(1026),
    [anon_sym_default] = ACTIONS(1026),
    [anon_sym_cast] = ACTIONS(1026),
    [anon_sym_DOLLARtype] = ACTIONS(1024),
    [anon_sym_in] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_this] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1026),
    [anon_sym_AT_COLON] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_else] = ACTIONS(1026),
    [anon_sym_new] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1024),
    [anon_sym_PERCENT] = ACTIONS(1024),
    [anon_sym_STAR] = ACTIONS(1024),
    [anon_sym_SLASH] = ACTIONS(1026),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_LT_LT] = ACTIONS(1024),
    [anon_sym_GT_GT] = ACTIONS(1026),
    [anon_sym_GT_GT_GT] = ACTIONS(1024),
    [anon_sym_AMP] = ACTIONS(1026),
    [anon_sym_PIPE] = ACTIONS(1026),
    [anon_sym_CARET] = ACTIONS(1024),
    [anon_sym_AMP_AMP] = ACTIONS(1024),
    [anon_sym_PIPE_PIPE] = ACTIONS(1024),
    [anon_sym_EQ_EQ] = ACTIONS(1024),
    [anon_sym_BANG_EQ] = ACTIONS(1024),
    [anon_sym_LT] = ACTIONS(1026),
    [anon_sym_LT_EQ] = ACTIONS(1024),
    [anon_sym_GT] = ACTIONS(1026),
    [anon_sym_GT_EQ] = ACTIONS(1024),
    [anon_sym_EQ_GT] = ACTIONS(1024),
    [anon_sym_QMARK_QMARK] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(1026),
    [sym__rangeOperator] = ACTIONS(1024),
    [anon_sym_null] = ACTIONS(1026),
    [anon_sym_dynamic] = ACTIONS(1026),
    [anon_sym_final] = ACTIONS(1026),
    [anon_sym_abstract] = ACTIONS(1026),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_extends] = ACTIONS(1026),
    [anon_sym_implements] = ACTIONS(1026),
    [anon_sym_interface] = ACTIONS(1026),
    [anon_sym_typedef] = ACTIONS(1026),
    [anon_sym_function] = ACTIONS(1026),
    [anon_sym_var] = ACTIONS(1026),
    [aux_sym_integer_token1] = ACTIONS(1026),
    [aux_sym_integer_token2] = ACTIONS(1024),
    [aux_sym_float_token1] = ACTIONS(1026),
    [aux_sym_float_token2] = ACTIONS(1024),
    [anon_sym_true] = ACTIONS(1026),
    [anon_sym_false] = ACTIONS(1026),
    [aux_sym_string_token1] = ACTIONS(1024),
    [aux_sym_string_token3] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_catch] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_do] = ACTIONS(1026),
    [anon_sym_enum] = ACTIONS(1026),
    [anon_sym_extern] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_inline] = ACTIONS(1026),
    [anon_sym_macro] = ACTIONS(1026),
    [anon_sym_operator] = ACTIONS(1026),
    [anon_sym_overload] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_untyped] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [sym__semicolon] = ACTIONS(1024),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_POUND] = ACTIONS(1028),
    [anon_sym_package] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(1030),
    [anon_sym_using] = ACTIONS(1030),
    [anon_sym_throw] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1030),
    [anon_sym_default] = ACTIONS(1030),
    [anon_sym_cast] = ACTIONS(1030),
    [anon_sym_DOLLARtype] = ACTIONS(1028),
    [anon_sym_in] = ACTIONS(1030),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_this] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1030),
    [anon_sym_AT_COLON] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1030),
    [anon_sym_new] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1028),
    [anon_sym_PERCENT] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1028),
    [anon_sym_SLASH] = ACTIONS(1030),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_LT_LT] = ACTIONS(1028),
    [anon_sym_GT_GT] = ACTIONS(1030),
    [anon_sym_GT_GT_GT] = ACTIONS(1028),
    [anon_sym_AMP] = ACTIONS(1030),
    [anon_sym_PIPE] = ACTIONS(1030),
    [anon_sym_CARET] = ACTIONS(1028),
    [anon_sym_AMP_AMP] = ACTIONS(1028),
    [anon_sym_PIPE_PIPE] = ACTIONS(1028),
    [anon_sym_EQ_EQ] = ACTIONS(1028),
    [anon_sym_BANG_EQ] = ACTIONS(1028),
    [anon_sym_LT] = ACTIONS(1030),
    [anon_sym_LT_EQ] = ACTIONS(1028),
    [anon_sym_GT] = ACTIONS(1030),
    [anon_sym_GT_EQ] = ACTIONS(1028),
    [anon_sym_EQ_GT] = ACTIONS(1028),
    [anon_sym_QMARK_QMARK] = ACTIONS(1028),
    [anon_sym_EQ] = ACTIONS(1030),
    [sym__rangeOperator] = ACTIONS(1028),
    [anon_sym_null] = ACTIONS(1030),
    [anon_sym_dynamic] = ACTIONS(1030),
    [anon_sym_final] = ACTIONS(1030),
    [anon_sym_abstract] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1030),
    [anon_sym_extends] = ACTIONS(1030),
    [anon_sym_implements] = ACTIONS(1030),
    [anon_sym_interface] = ACTIONS(1030),
    [anon_sym_typedef] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1030),
    [anon_sym_var] = ACTIONS(1030),
    [aux_sym_integer_token1] = ACTIONS(1030),
    [aux_sym_integer_token2] = ACTIONS(1028),
    [aux_sym_float_token1] = ACTIONS(1030),
    [aux_sym_float_token2] = ACTIONS(1028),
    [anon_sym_true] = ACTIONS(1030),
    [anon_sym_false] = ACTIONS(1030),
    [aux_sym_string_token1] = ACTIONS(1028),
    [aux_sym_string_token3] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1030),
    [anon_sym_catch] = ACTIONS(1030),
    [anon_sym_continue] = ACTIONS(1030),
    [anon_sym_do] = ACTIONS(1030),
    [anon_sym_enum] = ACTIONS(1030),
    [anon_sym_extern] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1030),
    [anon_sym_inline] = ACTIONS(1030),
    [anon_sym_macro] = ACTIONS(1030),
    [anon_sym_operator] = ACTIONS(1030),
    [anon_sym_overload] = ACTIONS(1030),
    [anon_sym_override] = ACTIONS(1030),
    [anon_sym_private] = ACTIONS(1030),
    [anon_sym_public] = ACTIONS(1030),
    [anon_sym_return] = ACTIONS(1030),
    [anon_sym_static] = ACTIONS(1030),
    [anon_sym_try] = ACTIONS(1030),
    [anon_sym_untyped] = ACTIONS(1030),
    [anon_sym_while] = ACTIONS(1030),
    [sym__semicolon] = ACTIONS(1028),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(1032),
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_POUND] = ACTIONS(1032),
    [anon_sym_package] = ACTIONS(1034),
    [anon_sym_import] = ACTIONS(1034),
    [anon_sym_using] = ACTIONS(1034),
    [anon_sym_throw] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_RBRACE] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1034),
    [anon_sym_default] = ACTIONS(1034),
    [anon_sym_cast] = ACTIONS(1034),
    [anon_sym_DOLLARtype] = ACTIONS(1032),
    [anon_sym_in] = ACTIONS(1034),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_this] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1034),
    [anon_sym_AT_COLON] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_else] = ACTIONS(1034),
    [anon_sym_new] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_PERCENT] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(1034),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_LT_LT] = ACTIONS(1032),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [anon_sym_GT_GT_GT] = ACTIONS(1032),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_PIPE] = ACTIONS(1034),
    [anon_sym_CARET] = ACTIONS(1032),
    [anon_sym_AMP_AMP] = ACTIONS(1032),
    [anon_sym_PIPE_PIPE] = ACTIONS(1032),
    [anon_sym_EQ_EQ] = ACTIONS(1032),
    [anon_sym_BANG_EQ] = ACTIONS(1032),
    [anon_sym_LT] = ACTIONS(1034),
    [anon_sym_LT_EQ] = ACTIONS(1032),
    [anon_sym_GT] = ACTIONS(1034),
    [anon_sym_GT_EQ] = ACTIONS(1032),
    [anon_sym_EQ_GT] = ACTIONS(1032),
    [anon_sym_QMARK_QMARK] = ACTIONS(1032),
    [anon_sym_EQ] = ACTIONS(1034),
    [sym__rangeOperator] = ACTIONS(1032),
    [anon_sym_null] = ACTIONS(1034),
    [anon_sym_dynamic] = ACTIONS(1034),
    [anon_sym_final] = ACTIONS(1034),
    [anon_sym_abstract] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1034),
    [anon_sym_extends] = ACTIONS(1034),
    [anon_sym_implements] = ACTIONS(1034),
    [anon_sym_interface] = ACTIONS(1034),
    [anon_sym_typedef] = ACTIONS(1034),
    [anon_sym_function] = ACTIONS(1034),
    [anon_sym_var] = ACTIONS(1034),
    [aux_sym_integer_token1] = ACTIONS(1034),
    [aux_sym_integer_token2] = ACTIONS(1032),
    [aux_sym_float_token1] = ACTIONS(1034),
    [aux_sym_float_token2] = ACTIONS(1032),
    [anon_sym_true] = ACTIONS(1034),
    [anon_sym_false] = ACTIONS(1034),
    [aux_sym_string_token1] = ACTIONS(1032),
    [aux_sym_string_token3] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1034),
    [anon_sym_catch] = ACTIONS(1034),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_do] = ACTIONS(1034),
    [anon_sym_enum] = ACTIONS(1034),
    [anon_sym_extern] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1034),
    [anon_sym_inline] = ACTIONS(1034),
    [anon_sym_macro] = ACTIONS(1034),
    [anon_sym_operator] = ACTIONS(1034),
    [anon_sym_overload] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_return] = ACTIONS(1034),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_try] = ACTIONS(1034),
    [anon_sym_untyped] = ACTIONS(1034),
    [anon_sym_while] = ACTIONS(1034),
    [sym__semicolon] = ACTIONS(1032),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(1036),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_POUND] = ACTIONS(1036),
    [anon_sym_package] = ACTIONS(1038),
    [anon_sym_import] = ACTIONS(1038),
    [anon_sym_using] = ACTIONS(1038),
    [anon_sym_throw] = ACTIONS(1038),
    [anon_sym_LPAREN] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1038),
    [anon_sym_default] = ACTIONS(1038),
    [anon_sym_cast] = ACTIONS(1038),
    [anon_sym_DOLLARtype] = ACTIONS(1036),
    [anon_sym_in] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_this] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1038),
    [anon_sym_AT_COLON] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_else] = ACTIONS(1038),
    [anon_sym_new] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1036),
    [anon_sym_PERCENT] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1036),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_GT_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1038),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_CARET] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_EQ_EQ] = ACTIONS(1036),
    [anon_sym_BANG_EQ] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_LT_EQ] = ACTIONS(1036),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_EQ] = ACTIONS(1036),
    [anon_sym_EQ_GT] = ACTIONS(1036),
    [anon_sym_QMARK_QMARK] = ACTIONS(1036),
    [anon_sym_EQ] = ACTIONS(1038),
    [sym__rangeOperator] = ACTIONS(1036),
    [anon_sym_null] = ACTIONS(1038),
    [anon_sym_dynamic] = ACTIONS(1038),
    [anon_sym_final] = ACTIONS(1038),
    [anon_sym_abstract] = ACTIONS(1038),
    [anon_sym_class] = ACTIONS(1038),
    [anon_sym_extends] = ACTIONS(1038),
    [anon_sym_implements] = ACTIONS(1038),
    [anon_sym_interface] = ACTIONS(1038),
    [anon_sym_typedef] = ACTIONS(1038),
    [anon_sym_function] = ACTIONS(1038),
    [anon_sym_var] = ACTIONS(1038),
    [aux_sym_integer_token1] = ACTIONS(1038),
    [aux_sym_integer_token2] = ACTIONS(1036),
    [aux_sym_float_token1] = ACTIONS(1038),
    [aux_sym_float_token2] = ACTIONS(1036),
    [anon_sym_true] = ACTIONS(1038),
    [anon_sym_false] = ACTIONS(1038),
    [aux_sym_string_token1] = ACTIONS(1036),
    [aux_sym_string_token3] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1038),
    [anon_sym_catch] = ACTIONS(1038),
    [anon_sym_continue] = ACTIONS(1038),
    [anon_sym_do] = ACTIONS(1038),
    [anon_sym_enum] = ACTIONS(1038),
    [anon_sym_extern] = ACTIONS(1038),
    [anon_sym_for] = ACTIONS(1038),
    [anon_sym_inline] = ACTIONS(1038),
    [anon_sym_macro] = ACTIONS(1038),
    [anon_sym_operator] = ACTIONS(1038),
    [anon_sym_overload] = ACTIONS(1038),
    [anon_sym_override] = ACTIONS(1038),
    [anon_sym_private] = ACTIONS(1038),
    [anon_sym_public] = ACTIONS(1038),
    [anon_sym_return] = ACTIONS(1038),
    [anon_sym_static] = ACTIONS(1038),
    [anon_sym_try] = ACTIONS(1038),
    [anon_sym_untyped] = ACTIONS(1038),
    [anon_sym_while] = ACTIONS(1038),
    [sym__semicolon] = ACTIONS(1036),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1042),
    [anon_sym_POUND] = ACTIONS(1040),
    [anon_sym_package] = ACTIONS(1042),
    [anon_sym_import] = ACTIONS(1042),
    [anon_sym_using] = ACTIONS(1042),
    [anon_sym_throw] = ACTIONS(1042),
    [anon_sym_LPAREN] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1042),
    [anon_sym_default] = ACTIONS(1042),
    [anon_sym_cast] = ACTIONS(1042),
    [anon_sym_DOLLARtype] = ACTIONS(1040),
    [anon_sym_in] = ACTIONS(1042),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_this] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1042),
    [anon_sym_AT_COLON] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1042),
    [anon_sym_else] = ACTIONS(1042),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1040),
    [anon_sym_PERCENT] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1040),
    [anon_sym_SLASH] = ACTIONS(1042),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_GT_GT_GT] = ACTIONS(1040),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1040),
    [anon_sym_AMP_AMP] = ACTIONS(1040),
    [anon_sym_PIPE_PIPE] = ACTIONS(1040),
    [anon_sym_EQ_EQ] = ACTIONS(1040),
    [anon_sym_BANG_EQ] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1040),
    [anon_sym_EQ_GT] = ACTIONS(1040),
    [anon_sym_QMARK_QMARK] = ACTIONS(1040),
    [anon_sym_EQ] = ACTIONS(1042),
    [sym__rangeOperator] = ACTIONS(1040),
    [anon_sym_null] = ACTIONS(1042),
    [anon_sym_dynamic] = ACTIONS(1042),
    [anon_sym_final] = ACTIONS(1042),
    [anon_sym_abstract] = ACTIONS(1042),
    [anon_sym_class] = ACTIONS(1042),
    [anon_sym_extends] = ACTIONS(1042),
    [anon_sym_implements] = ACTIONS(1042),
    [anon_sym_interface] = ACTIONS(1042),
    [anon_sym_typedef] = ACTIONS(1042),
    [anon_sym_function] = ACTIONS(1042),
    [anon_sym_var] = ACTIONS(1042),
    [aux_sym_integer_token1] = ACTIONS(1042),
    [aux_sym_integer_token2] = ACTIONS(1040),
    [aux_sym_float_token1] = ACTIONS(1042),
    [aux_sym_float_token2] = ACTIONS(1040),
    [anon_sym_true] = ACTIONS(1042),
    [anon_sym_false] = ACTIONS(1042),
    [aux_sym_string_token1] = ACTIONS(1040),
    [aux_sym_string_token3] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1042),
    [anon_sym_catch] = ACTIONS(1042),
    [anon_sym_continue] = ACTIONS(1042),
    [anon_sym_do] = ACTIONS(1042),
    [anon_sym_enum] = ACTIONS(1042),
    [anon_sym_extern] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1042),
    [anon_sym_inline] = ACTIONS(1042),
    [anon_sym_macro] = ACTIONS(1042),
    [anon_sym_operator] = ACTIONS(1042),
    [anon_sym_overload] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_return] = ACTIONS(1042),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_try] = ACTIONS(1042),
    [anon_sym_untyped] = ACTIONS(1042),
    [anon_sym_while] = ACTIONS(1042),
    [sym__semicolon] = ACTIONS(1040),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(1044),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_POUND] = ACTIONS(1044),
    [anon_sym_package] = ACTIONS(1046),
    [anon_sym_import] = ACTIONS(1046),
    [anon_sym_using] = ACTIONS(1046),
    [anon_sym_throw] = ACTIONS(1046),
    [anon_sym_LPAREN] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1046),
    [anon_sym_default] = ACTIONS(1046),
    [anon_sym_cast] = ACTIONS(1046),
    [anon_sym_DOLLARtype] = ACTIONS(1044),
    [anon_sym_in] = ACTIONS(1046),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_this] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1046),
    [anon_sym_AT_COLON] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1046),
    [anon_sym_else] = ACTIONS(1046),
    [anon_sym_new] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1044),
    [anon_sym_PERCENT] = ACTIONS(1044),
    [anon_sym_STAR] = ACTIONS(1044),
    [anon_sym_SLASH] = ACTIONS(1046),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1044),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_GT_GT_GT] = ACTIONS(1044),
    [anon_sym_AMP] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1046),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_AMP_AMP] = ACTIONS(1044),
    [anon_sym_PIPE_PIPE] = ACTIONS(1044),
    [anon_sym_EQ_EQ] = ACTIONS(1044),
    [anon_sym_BANG_EQ] = ACTIONS(1044),
    [anon_sym_LT] = ACTIONS(1046),
    [anon_sym_LT_EQ] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1046),
    [anon_sym_GT_EQ] = ACTIONS(1044),
    [anon_sym_EQ_GT] = ACTIONS(1044),
    [anon_sym_QMARK_QMARK] = ACTIONS(1044),
    [anon_sym_EQ] = ACTIONS(1046),
    [sym__rangeOperator] = ACTIONS(1044),
    [anon_sym_null] = ACTIONS(1046),
    [anon_sym_dynamic] = ACTIONS(1046),
    [anon_sym_final] = ACTIONS(1046),
    [anon_sym_abstract] = ACTIONS(1046),
    [anon_sym_class] = ACTIONS(1046),
    [anon_sym_extends] = ACTIONS(1046),
    [anon_sym_implements] = ACTIONS(1046),
    [anon_sym_interface] = ACTIONS(1046),
    [anon_sym_typedef] = ACTIONS(1046),
    [anon_sym_function] = ACTIONS(1046),
    [anon_sym_var] = ACTIONS(1046),
    [aux_sym_integer_token1] = ACTIONS(1046),
    [aux_sym_integer_token2] = ACTIONS(1044),
    [aux_sym_float_token1] = ACTIONS(1046),
    [aux_sym_float_token2] = ACTIONS(1044),
    [anon_sym_true] = ACTIONS(1046),
    [anon_sym_false] = ACTIONS(1046),
    [aux_sym_string_token1] = ACTIONS(1044),
    [aux_sym_string_token3] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1046),
    [anon_sym_catch] = ACTIONS(1046),
    [anon_sym_continue] = ACTIONS(1046),
    [anon_sym_do] = ACTIONS(1046),
    [anon_sym_enum] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1046),
    [anon_sym_for] = ACTIONS(1046),
    [anon_sym_inline] = ACTIONS(1046),
    [anon_sym_macro] = ACTIONS(1046),
    [anon_sym_operator] = ACTIONS(1046),
    [anon_sym_overload] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_return] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_try] = ACTIONS(1046),
    [anon_sym_untyped] = ACTIONS(1046),
    [anon_sym_while] = ACTIONS(1046),
    [sym__semicolon] = ACTIONS(1044),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_POUND] = ACTIONS(1048),
    [anon_sym_package] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1050),
    [anon_sym_using] = ACTIONS(1050),
    [anon_sym_throw] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1050),
    [anon_sym_default] = ACTIONS(1050),
    [anon_sym_cast] = ACTIONS(1050),
    [anon_sym_DOLLARtype] = ACTIONS(1048),
    [anon_sym_in] = ACTIONS(1050),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_this] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [anon_sym_AT_COLON] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1048),
    [anon_sym_PERCENT] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1048),
    [anon_sym_SLASH] = ACTIONS(1050),
    [anon_sym_PLUS] = ACTIONS(1050),
    [anon_sym_LT_LT] = ACTIONS(1048),
    [anon_sym_GT_GT] = ACTIONS(1050),
    [anon_sym_GT_GT_GT] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1050),
    [anon_sym_PIPE] = ACTIONS(1050),
    [anon_sym_CARET] = ACTIONS(1048),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [anon_sym_EQ_EQ] = ACTIONS(1048),
    [anon_sym_BANG_EQ] = ACTIONS(1048),
    [anon_sym_LT] = ACTIONS(1050),
    [anon_sym_LT_EQ] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(1050),
    [anon_sym_GT_EQ] = ACTIONS(1048),
    [anon_sym_EQ_GT] = ACTIONS(1048),
    [anon_sym_QMARK_QMARK] = ACTIONS(1048),
    [anon_sym_EQ] = ACTIONS(1050),
    [sym__rangeOperator] = ACTIONS(1048),
    [anon_sym_null] = ACTIONS(1050),
    [anon_sym_dynamic] = ACTIONS(1050),
    [anon_sym_final] = ACTIONS(1050),
    [anon_sym_abstract] = ACTIONS(1050),
    [anon_sym_class] = ACTIONS(1050),
    [anon_sym_extends] = ACTIONS(1050),
    [anon_sym_implements] = ACTIONS(1050),
    [anon_sym_interface] = ACTIONS(1050),
    [anon_sym_typedef] = ACTIONS(1050),
    [anon_sym_function] = ACTIONS(1050),
    [anon_sym_var] = ACTIONS(1050),
    [aux_sym_integer_token1] = ACTIONS(1050),
    [aux_sym_integer_token2] = ACTIONS(1048),
    [aux_sym_float_token1] = ACTIONS(1050),
    [aux_sym_float_token2] = ACTIONS(1048),
    [anon_sym_true] = ACTIONS(1050),
    [anon_sym_false] = ACTIONS(1050),
    [aux_sym_string_token1] = ACTIONS(1048),
    [aux_sym_string_token3] = ACTIONS(1048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1050),
    [anon_sym_catch] = ACTIONS(1050),
    [anon_sym_continue] = ACTIONS(1050),
    [anon_sym_do] = ACTIONS(1050),
    [anon_sym_enum] = ACTIONS(1050),
    [anon_sym_extern] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1050),
    [anon_sym_inline] = ACTIONS(1050),
    [anon_sym_macro] = ACTIONS(1050),
    [anon_sym_operator] = ACTIONS(1050),
    [anon_sym_overload] = ACTIONS(1050),
    [anon_sym_override] = ACTIONS(1050),
    [anon_sym_private] = ACTIONS(1050),
    [anon_sym_public] = ACTIONS(1050),
    [anon_sym_return] = ACTIONS(1050),
    [anon_sym_static] = ACTIONS(1050),
    [anon_sym_try] = ACTIONS(1050),
    [anon_sym_untyped] = ACTIONS(1050),
    [anon_sym_while] = ACTIONS(1050),
    [sym__semicolon] = ACTIONS(1048),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(1052),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_POUND] = ACTIONS(1052),
    [anon_sym_package] = ACTIONS(1054),
    [anon_sym_import] = ACTIONS(1054),
    [anon_sym_using] = ACTIONS(1054),
    [anon_sym_throw] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_RBRACE] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1054),
    [anon_sym_default] = ACTIONS(1054),
    [anon_sym_cast] = ACTIONS(1054),
    [anon_sym_DOLLARtype] = ACTIONS(1052),
    [anon_sym_in] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_this] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1054),
    [anon_sym_AT_COLON] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_new] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1052),
    [anon_sym_PERCENT] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1052),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_PLUS] = ACTIONS(1054),
    [anon_sym_LT_LT] = ACTIONS(1052),
    [anon_sym_GT_GT] = ACTIONS(1054),
    [anon_sym_GT_GT_GT] = ACTIONS(1052),
    [anon_sym_AMP] = ACTIONS(1054),
    [anon_sym_PIPE] = ACTIONS(1054),
    [anon_sym_CARET] = ACTIONS(1052),
    [anon_sym_AMP_AMP] = ACTIONS(1052),
    [anon_sym_PIPE_PIPE] = ACTIONS(1052),
    [anon_sym_EQ_EQ] = ACTIONS(1052),
    [anon_sym_BANG_EQ] = ACTIONS(1052),
    [anon_sym_LT] = ACTIONS(1054),
    [anon_sym_LT_EQ] = ACTIONS(1052),
    [anon_sym_GT] = ACTIONS(1054),
    [anon_sym_GT_EQ] = ACTIONS(1052),
    [anon_sym_EQ_GT] = ACTIONS(1052),
    [anon_sym_QMARK_QMARK] = ACTIONS(1052),
    [anon_sym_EQ] = ACTIONS(1054),
    [sym__rangeOperator] = ACTIONS(1052),
    [anon_sym_null] = ACTIONS(1054),
    [anon_sym_dynamic] = ACTIONS(1054),
    [anon_sym_final] = ACTIONS(1054),
    [anon_sym_abstract] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(1054),
    [anon_sym_extends] = ACTIONS(1054),
    [anon_sym_implements] = ACTIONS(1054),
    [anon_sym_interface] = ACTIONS(1054),
    [anon_sym_typedef] = ACTIONS(1054),
    [anon_sym_function] = ACTIONS(1054),
    [anon_sym_var] = ACTIONS(1054),
    [aux_sym_integer_token1] = ACTIONS(1054),
    [aux_sym_integer_token2] = ACTIONS(1052),
    [aux_sym_float_token1] = ACTIONS(1054),
    [aux_sym_float_token2] = ACTIONS(1052),
    [anon_sym_true] = ACTIONS(1054),
    [anon_sym_false] = ACTIONS(1054),
    [aux_sym_string_token1] = ACTIONS(1052),
    [aux_sym_string_token3] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1054),
    [anon_sym_catch] = ACTIONS(1054),
    [anon_sym_continue] = ACTIONS(1054),
    [anon_sym_do] = ACTIONS(1054),
    [anon_sym_enum] = ACTIONS(1054),
    [anon_sym_extern] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_inline] = ACTIONS(1054),
    [anon_sym_macro] = ACTIONS(1054),
    [anon_sym_operator] = ACTIONS(1054),
    [anon_sym_overload] = ACTIONS(1054),
    [anon_sym_override] = ACTIONS(1054),
    [anon_sym_private] = ACTIONS(1054),
    [anon_sym_public] = ACTIONS(1054),
    [anon_sym_return] = ACTIONS(1054),
    [anon_sym_static] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1054),
    [anon_sym_untyped] = ACTIONS(1054),
    [anon_sym_while] = ACTIONS(1054),
    [sym__semicolon] = ACTIONS(1052),
  },
  [193] = {
    [ts_builtin_sym_end] = ACTIONS(1056),
    [sym_identifier] = ACTIONS(1058),
    [anon_sym_POUND] = ACTIONS(1056),
    [anon_sym_package] = ACTIONS(1058),
    [anon_sym_import] = ACTIONS(1058),
    [anon_sym_using] = ACTIONS(1058),
    [anon_sym_throw] = ACTIONS(1058),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [anon_sym_case] = ACTIONS(1058),
    [anon_sym_default] = ACTIONS(1058),
    [anon_sym_cast] = ACTIONS(1058),
    [anon_sym_DOLLARtype] = ACTIONS(1056),
    [anon_sym_in] = ACTIONS(1058),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_this] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_AT_COLON] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1058),
    [anon_sym_else] = ACTIONS(1058),
    [anon_sym_new] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_BANG] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_PLUS_PLUS] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1056),
    [anon_sym_PERCENT] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1056),
    [anon_sym_SLASH] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_LT_LT] = ACTIONS(1056),
    [anon_sym_GT_GT] = ACTIONS(1058),
    [anon_sym_GT_GT_GT] = ACTIONS(1056),
    [anon_sym_AMP] = ACTIONS(1058),
    [anon_sym_PIPE] = ACTIONS(1058),
    [anon_sym_CARET] = ACTIONS(1056),
    [anon_sym_AMP_AMP] = ACTIONS(1056),
    [anon_sym_PIPE_PIPE] = ACTIONS(1056),
    [anon_sym_EQ_EQ] = ACTIONS(1056),
    [anon_sym_BANG_EQ] = ACTIONS(1056),
    [anon_sym_LT] = ACTIONS(1058),
    [anon_sym_LT_EQ] = ACTIONS(1056),
    [anon_sym_GT] = ACTIONS(1058),
    [anon_sym_GT_EQ] = ACTIONS(1056),
    [anon_sym_EQ_GT] = ACTIONS(1056),
    [anon_sym_QMARK_QMARK] = ACTIONS(1056),
    [anon_sym_EQ] = ACTIONS(1058),
    [sym__rangeOperator] = ACTIONS(1056),
    [anon_sym_null] = ACTIONS(1058),
    [anon_sym_dynamic] = ACTIONS(1058),
    [anon_sym_final] = ACTIONS(1058),
    [anon_sym_abstract] = ACTIONS(1058),
    [anon_sym_class] = ACTIONS(1058),
    [anon_sym_extends] = ACTIONS(1058),
    [anon_sym_implements] = ACTIONS(1058),
    [anon_sym_interface] = ACTIONS(1058),
    [anon_sym_typedef] = ACTIONS(1058),
    [anon_sym_function] = ACTIONS(1058),
    [anon_sym_var] = ACTIONS(1058),
    [aux_sym_integer_token1] = ACTIONS(1058),
    [aux_sym_integer_token2] = ACTIONS(1056),
    [aux_sym_float_token1] = ACTIONS(1058),
    [aux_sym_float_token2] = ACTIONS(1056),
    [anon_sym_true] = ACTIONS(1058),
    [anon_sym_false] = ACTIONS(1058),
    [aux_sym_string_token1] = ACTIONS(1056),
    [aux_sym_string_token3] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1058),
    [anon_sym_catch] = ACTIONS(1058),
    [anon_sym_continue] = ACTIONS(1058),
    [anon_sym_do] = ACTIONS(1058),
    [anon_sym_enum] = ACTIONS(1058),
    [anon_sym_extern] = ACTIONS(1058),
    [anon_sym_for] = ACTIONS(1058),
    [anon_sym_inline] = ACTIONS(1058),
    [anon_sym_macro] = ACTIONS(1058),
    [anon_sym_operator] = ACTIONS(1058),
    [anon_sym_overload] = ACTIONS(1058),
    [anon_sym_override] = ACTIONS(1058),
    [anon_sym_private] = ACTIONS(1058),
    [anon_sym_public] = ACTIONS(1058),
    [anon_sym_return] = ACTIONS(1058),
    [anon_sym_static] = ACTIONS(1058),
    [anon_sym_try] = ACTIONS(1058),
    [anon_sym_untyped] = ACTIONS(1058),
    [anon_sym_while] = ACTIONS(1058),
    [sym__semicolon] = ACTIONS(1056),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym_identifier] = ACTIONS(1062),
    [anon_sym_POUND] = ACTIONS(1060),
    [anon_sym_package] = ACTIONS(1062),
    [anon_sym_import] = ACTIONS(1062),
    [anon_sym_using] = ACTIONS(1062),
    [anon_sym_throw] = ACTIONS(1062),
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_switch] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_case] = ACTIONS(1062),
    [anon_sym_default] = ACTIONS(1062),
    [anon_sym_cast] = ACTIONS(1062),
    [anon_sym_DOLLARtype] = ACTIONS(1060),
    [anon_sym_in] = ACTIONS(1062),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_this] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_AT_COLON] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1062),
    [anon_sym_else] = ACTIONS(1062),
    [anon_sym_new] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1060),
    [anon_sym_DASH_DASH] = ACTIONS(1060),
    [anon_sym_PERCENT] = ACTIONS(1060),
    [anon_sym_STAR] = ACTIONS(1060),
    [anon_sym_SLASH] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_LT_LT] = ACTIONS(1060),
    [anon_sym_GT_GT] = ACTIONS(1062),
    [anon_sym_GT_GT_GT] = ACTIONS(1060),
    [anon_sym_AMP] = ACTIONS(1062),
    [anon_sym_PIPE] = ACTIONS(1062),
    [anon_sym_CARET] = ACTIONS(1060),
    [anon_sym_AMP_AMP] = ACTIONS(1060),
    [anon_sym_PIPE_PIPE] = ACTIONS(1060),
    [anon_sym_EQ_EQ] = ACTIONS(1060),
    [anon_sym_BANG_EQ] = ACTIONS(1060),
    [anon_sym_LT] = ACTIONS(1062),
    [anon_sym_LT_EQ] = ACTIONS(1060),
    [anon_sym_GT] = ACTIONS(1062),
    [anon_sym_GT_EQ] = ACTIONS(1060),
    [anon_sym_EQ_GT] = ACTIONS(1060),
    [anon_sym_QMARK_QMARK] = ACTIONS(1060),
    [anon_sym_EQ] = ACTIONS(1062),
    [sym__rangeOperator] = ACTIONS(1060),
    [anon_sym_null] = ACTIONS(1062),
    [anon_sym_dynamic] = ACTIONS(1062),
    [anon_sym_final] = ACTIONS(1062),
    [anon_sym_abstract] = ACTIONS(1062),
    [anon_sym_class] = ACTIONS(1062),
    [anon_sym_extends] = ACTIONS(1062),
    [anon_sym_implements] = ACTIONS(1062),
    [anon_sym_interface] = ACTIONS(1062),
    [anon_sym_typedef] = ACTIONS(1062),
    [anon_sym_function] = ACTIONS(1062),
    [anon_sym_var] = ACTIONS(1062),
    [aux_sym_integer_token1] = ACTIONS(1062),
    [aux_sym_integer_token2] = ACTIONS(1060),
    [aux_sym_float_token1] = ACTIONS(1062),
    [aux_sym_float_token2] = ACTIONS(1060),
    [anon_sym_true] = ACTIONS(1062),
    [anon_sym_false] = ACTIONS(1062),
    [aux_sym_string_token1] = ACTIONS(1060),
    [aux_sym_string_token3] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1062),
    [anon_sym_catch] = ACTIONS(1062),
    [anon_sym_continue] = ACTIONS(1062),
    [anon_sym_do] = ACTIONS(1062),
    [anon_sym_enum] = ACTIONS(1062),
    [anon_sym_extern] = ACTIONS(1062),
    [anon_sym_for] = ACTIONS(1062),
    [anon_sym_inline] = ACTIONS(1062),
    [anon_sym_macro] = ACTIONS(1062),
    [anon_sym_operator] = ACTIONS(1062),
    [anon_sym_overload] = ACTIONS(1062),
    [anon_sym_override] = ACTIONS(1062),
    [anon_sym_private] = ACTIONS(1062),
    [anon_sym_public] = ACTIONS(1062),
    [anon_sym_return] = ACTIONS(1062),
    [anon_sym_static] = ACTIONS(1062),
    [anon_sym_try] = ACTIONS(1062),
    [anon_sym_untyped] = ACTIONS(1062),
    [anon_sym_while] = ACTIONS(1062),
    [sym__semicolon] = ACTIONS(1060),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(1064),
    [sym_identifier] = ACTIONS(1066),
    [anon_sym_POUND] = ACTIONS(1064),
    [anon_sym_package] = ACTIONS(1066),
    [anon_sym_import] = ACTIONS(1066),
    [anon_sym_using] = ACTIONS(1066),
    [anon_sym_throw] = ACTIONS(1066),
    [anon_sym_LPAREN] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1064),
    [anon_sym_RBRACE] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1066),
    [anon_sym_default] = ACTIONS(1066),
    [anon_sym_cast] = ACTIONS(1066),
    [anon_sym_DOLLARtype] = ACTIONS(1064),
    [anon_sym_in] = ACTIONS(1066),
    [anon_sym_LBRACK] = ACTIONS(1064),
    [anon_sym_this] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_AT_COLON] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1066),
    [anon_sym_else] = ACTIONS(1066),
    [anon_sym_new] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1064),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1064),
    [anon_sym_PERCENT] = ACTIONS(1064),
    [anon_sym_STAR] = ACTIONS(1064),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_LT_LT] = ACTIONS(1064),
    [anon_sym_GT_GT] = ACTIONS(1066),
    [anon_sym_GT_GT_GT] = ACTIONS(1064),
    [anon_sym_AMP] = ACTIONS(1066),
    [anon_sym_PIPE] = ACTIONS(1066),
    [anon_sym_CARET] = ACTIONS(1064),
    [anon_sym_AMP_AMP] = ACTIONS(1064),
    [anon_sym_PIPE_PIPE] = ACTIONS(1064),
    [anon_sym_EQ_EQ] = ACTIONS(1064),
    [anon_sym_BANG_EQ] = ACTIONS(1064),
    [anon_sym_LT] = ACTIONS(1066),
    [anon_sym_LT_EQ] = ACTIONS(1064),
    [anon_sym_GT] = ACTIONS(1066),
    [anon_sym_GT_EQ] = ACTIONS(1064),
    [anon_sym_EQ_GT] = ACTIONS(1064),
    [anon_sym_QMARK_QMARK] = ACTIONS(1064),
    [anon_sym_EQ] = ACTIONS(1066),
    [sym__rangeOperator] = ACTIONS(1064),
    [anon_sym_null] = ACTIONS(1066),
    [anon_sym_dynamic] = ACTIONS(1066),
    [anon_sym_final] = ACTIONS(1066),
    [anon_sym_abstract] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(1066),
    [anon_sym_extends] = ACTIONS(1066),
    [anon_sym_implements] = ACTIONS(1066),
    [anon_sym_interface] = ACTIONS(1066),
    [anon_sym_typedef] = ACTIONS(1066),
    [anon_sym_function] = ACTIONS(1066),
    [anon_sym_var] = ACTIONS(1066),
    [aux_sym_integer_token1] = ACTIONS(1066),
    [aux_sym_integer_token2] = ACTIONS(1064),
    [aux_sym_float_token1] = ACTIONS(1066),
    [aux_sym_float_token2] = ACTIONS(1064),
    [anon_sym_true] = ACTIONS(1066),
    [anon_sym_false] = ACTIONS(1066),
    [aux_sym_string_token1] = ACTIONS(1064),
    [aux_sym_string_token3] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1066),
    [anon_sym_catch] = ACTIONS(1066),
    [anon_sym_continue] = ACTIONS(1066),
    [anon_sym_do] = ACTIONS(1066),
    [anon_sym_enum] = ACTIONS(1066),
    [anon_sym_extern] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1066),
    [anon_sym_inline] = ACTIONS(1066),
    [anon_sym_macro] = ACTIONS(1066),
    [anon_sym_operator] = ACTIONS(1066),
    [anon_sym_overload] = ACTIONS(1066),
    [anon_sym_override] = ACTIONS(1066),
    [anon_sym_private] = ACTIONS(1066),
    [anon_sym_public] = ACTIONS(1066),
    [anon_sym_return] = ACTIONS(1066),
    [anon_sym_static] = ACTIONS(1066),
    [anon_sym_try] = ACTIONS(1066),
    [anon_sym_untyped] = ACTIONS(1066),
    [anon_sym_while] = ACTIONS(1066),
    [sym__semicolon] = ACTIONS(1064),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(1068),
    [sym_identifier] = ACTIONS(1070),
    [anon_sym_POUND] = ACTIONS(1068),
    [anon_sym_package] = ACTIONS(1070),
    [anon_sym_import] = ACTIONS(1070),
    [anon_sym_using] = ACTIONS(1070),
    [anon_sym_throw] = ACTIONS(1070),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [anon_sym_case] = ACTIONS(1070),
    [anon_sym_default] = ACTIONS(1070),
    [anon_sym_cast] = ACTIONS(1070),
    [anon_sym_DOLLARtype] = ACTIONS(1068),
    [anon_sym_in] = ACTIONS(1070),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_this] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_AT_COLON] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1070),
    [anon_sym_else] = ACTIONS(1070),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_BANG] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_PERCENT] = ACTIONS(1068),
    [anon_sym_STAR] = ACTIONS(1068),
    [anon_sym_SLASH] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_LT_LT] = ACTIONS(1068),
    [anon_sym_GT_GT] = ACTIONS(1070),
    [anon_sym_GT_GT_GT] = ACTIONS(1068),
    [anon_sym_AMP] = ACTIONS(1070),
    [anon_sym_PIPE] = ACTIONS(1070),
    [anon_sym_CARET] = ACTIONS(1068),
    [anon_sym_AMP_AMP] = ACTIONS(1068),
    [anon_sym_PIPE_PIPE] = ACTIONS(1068),
    [anon_sym_EQ_EQ] = ACTIONS(1068),
    [anon_sym_BANG_EQ] = ACTIONS(1068),
    [anon_sym_LT] = ACTIONS(1070),
    [anon_sym_LT_EQ] = ACTIONS(1068),
    [anon_sym_GT] = ACTIONS(1070),
    [anon_sym_GT_EQ] = ACTIONS(1068),
    [anon_sym_EQ_GT] = ACTIONS(1068),
    [anon_sym_QMARK_QMARK] = ACTIONS(1068),
    [anon_sym_EQ] = ACTIONS(1070),
    [sym__rangeOperator] = ACTIONS(1068),
    [anon_sym_null] = ACTIONS(1070),
    [anon_sym_dynamic] = ACTIONS(1070),
    [anon_sym_final] = ACTIONS(1070),
    [anon_sym_abstract] = ACTIONS(1070),
    [anon_sym_class] = ACTIONS(1070),
    [anon_sym_extends] = ACTIONS(1070),
    [anon_sym_implements] = ACTIONS(1070),
    [anon_sym_interface] = ACTIONS(1070),
    [anon_sym_typedef] = ACTIONS(1070),
    [anon_sym_function] = ACTIONS(1070),
    [anon_sym_var] = ACTIONS(1070),
    [aux_sym_integer_token1] = ACTIONS(1070),
    [aux_sym_integer_token2] = ACTIONS(1068),
    [aux_sym_float_token1] = ACTIONS(1070),
    [aux_sym_float_token2] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(1070),
    [anon_sym_false] = ACTIONS(1070),
    [aux_sym_string_token1] = ACTIONS(1068),
    [aux_sym_string_token3] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1070),
    [anon_sym_catch] = ACTIONS(1070),
    [anon_sym_continue] = ACTIONS(1070),
    [anon_sym_do] = ACTIONS(1070),
    [anon_sym_enum] = ACTIONS(1070),
    [anon_sym_extern] = ACTIONS(1070),
    [anon_sym_for] = ACTIONS(1070),
    [anon_sym_inline] = ACTIONS(1070),
    [anon_sym_macro] = ACTIONS(1070),
    [anon_sym_operator] = ACTIONS(1070),
    [anon_sym_overload] = ACTIONS(1070),
    [anon_sym_override] = ACTIONS(1070),
    [anon_sym_private] = ACTIONS(1070),
    [anon_sym_public] = ACTIONS(1070),
    [anon_sym_return] = ACTIONS(1070),
    [anon_sym_static] = ACTIONS(1070),
    [anon_sym_try] = ACTIONS(1070),
    [anon_sym_untyped] = ACTIONS(1070),
    [anon_sym_while] = ACTIONS(1070),
    [sym__semicolon] = ACTIONS(1068),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_POUND] = ACTIONS(1072),
    [anon_sym_package] = ACTIONS(1074),
    [anon_sym_import] = ACTIONS(1074),
    [anon_sym_using] = ACTIONS(1074),
    [anon_sym_throw] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_cast] = ACTIONS(1074),
    [anon_sym_DOLLARtype] = ACTIONS(1072),
    [anon_sym_in] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_this] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_AT_COLON] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_new] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1074),
    [anon_sym_GT_GT_GT] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_EQ_GT] = ACTIONS(1072),
    [anon_sym_QMARK_QMARK] = ACTIONS(1072),
    [anon_sym_EQ] = ACTIONS(1074),
    [sym__rangeOperator] = ACTIONS(1072),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_dynamic] = ACTIONS(1074),
    [anon_sym_final] = ACTIONS(1074),
    [anon_sym_abstract] = ACTIONS(1074),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_extends] = ACTIONS(1074),
    [anon_sym_implements] = ACTIONS(1074),
    [anon_sym_interface] = ACTIONS(1074),
    [anon_sym_typedef] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [aux_sym_integer_token1] = ACTIONS(1074),
    [aux_sym_integer_token2] = ACTIONS(1072),
    [aux_sym_float_token1] = ACTIONS(1074),
    [aux_sym_float_token2] = ACTIONS(1072),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [aux_sym_string_token1] = ACTIONS(1072),
    [aux_sym_string_token3] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [anon_sym_do] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_macro] = ACTIONS(1074),
    [anon_sym_operator] = ACTIONS(1074),
    [anon_sym_overload] = ACTIONS(1074),
    [anon_sym_override] = ACTIONS(1074),
    [anon_sym_private] = ACTIONS(1074),
    [anon_sym_public] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_static] = ACTIONS(1074),
    [anon_sym_try] = ACTIONS(1074),
    [anon_sym_untyped] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [sym__semicolon] = ACTIONS(1072),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_POUND] = ACTIONS(1076),
    [anon_sym_package] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_using] = ACTIONS(1078),
    [anon_sym_throw] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_cast] = ACTIONS(1078),
    [anon_sym_DOLLARtype] = ACTIONS(1076),
    [anon_sym_in] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_this] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1078),
    [anon_sym_AT_COLON] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_new] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1076),
    [anon_sym_PERCENT] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_SLASH] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_LT_LT] = ACTIONS(1076),
    [anon_sym_GT_GT] = ACTIONS(1078),
    [anon_sym_GT_GT_GT] = ACTIONS(1076),
    [anon_sym_AMP] = ACTIONS(1078),
    [anon_sym_PIPE] = ACTIONS(1078),
    [anon_sym_CARET] = ACTIONS(1076),
    [anon_sym_AMP_AMP] = ACTIONS(1076),
    [anon_sym_PIPE_PIPE] = ACTIONS(1076),
    [anon_sym_EQ_EQ] = ACTIONS(1076),
    [anon_sym_BANG_EQ] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_LT_EQ] = ACTIONS(1076),
    [anon_sym_GT] = ACTIONS(1078),
    [anon_sym_GT_EQ] = ACTIONS(1076),
    [anon_sym_EQ_GT] = ACTIONS(1076),
    [anon_sym_QMARK_QMARK] = ACTIONS(1076),
    [anon_sym_EQ] = ACTIONS(1078),
    [sym__rangeOperator] = ACTIONS(1076),
    [anon_sym_null] = ACTIONS(1078),
    [anon_sym_dynamic] = ACTIONS(1078),
    [anon_sym_final] = ACTIONS(1078),
    [anon_sym_abstract] = ACTIONS(1078),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_extends] = ACTIONS(1078),
    [anon_sym_implements] = ACTIONS(1078),
    [anon_sym_interface] = ACTIONS(1078),
    [anon_sym_typedef] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [aux_sym_integer_token1] = ACTIONS(1078),
    [aux_sym_integer_token2] = ACTIONS(1076),
    [aux_sym_float_token1] = ACTIONS(1078),
    [aux_sym_float_token2] = ACTIONS(1076),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [aux_sym_string_token1] = ACTIONS(1076),
    [aux_sym_string_token3] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_catch] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_do] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_extern] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_inline] = ACTIONS(1078),
    [anon_sym_macro] = ACTIONS(1078),
    [anon_sym_operator] = ACTIONS(1078),
    [anon_sym_overload] = ACTIONS(1078),
    [anon_sym_override] = ACTIONS(1078),
    [anon_sym_private] = ACTIONS(1078),
    [anon_sym_public] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_untyped] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [sym__semicolon] = ACTIONS(1076),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_POUND] = ACTIONS(1080),
    [anon_sym_package] = ACTIONS(1082),
    [anon_sym_import] = ACTIONS(1082),
    [anon_sym_using] = ACTIONS(1082),
    [anon_sym_throw] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_case] = ACTIONS(1082),
    [anon_sym_default] = ACTIONS(1082),
    [anon_sym_cast] = ACTIONS(1082),
    [anon_sym_DOLLARtype] = ACTIONS(1080),
    [anon_sym_in] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_this] = ACTIONS(1082),
    [anon_sym_AT] = ACTIONS(1082),
    [anon_sym_AT_COLON] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_new] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_DASH] = ACTIONS(1082),
    [anon_sym_PLUS_PLUS] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1082),
    [anon_sym_PLUS] = ACTIONS(1082),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_GT_GT] = ACTIONS(1082),
    [anon_sym_GT_GT_GT] = ACTIONS(1080),
    [anon_sym_AMP] = ACTIONS(1082),
    [anon_sym_PIPE] = ACTIONS(1082),
    [anon_sym_CARET] = ACTIONS(1080),
    [anon_sym_AMP_AMP] = ACTIONS(1080),
    [anon_sym_PIPE_PIPE] = ACTIONS(1080),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_LT] = ACTIONS(1082),
    [anon_sym_LT_EQ] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1082),
    [anon_sym_GT_EQ] = ACTIONS(1080),
    [anon_sym_EQ_GT] = ACTIONS(1080),
    [anon_sym_QMARK_QMARK] = ACTIONS(1080),
    [anon_sym_EQ] = ACTIONS(1082),
    [sym__rangeOperator] = ACTIONS(1080),
    [anon_sym_null] = ACTIONS(1082),
    [anon_sym_dynamic] = ACTIONS(1082),
    [anon_sym_final] = ACTIONS(1082),
    [anon_sym_abstract] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_extends] = ACTIONS(1082),
    [anon_sym_implements] = ACTIONS(1082),
    [anon_sym_interface] = ACTIONS(1082),
    [anon_sym_typedef] = ACTIONS(1082),
    [anon_sym_function] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [aux_sym_integer_token1] = ACTIONS(1082),
    [aux_sym_integer_token2] = ACTIONS(1080),
    [aux_sym_float_token1] = ACTIONS(1082),
    [aux_sym_float_token2] = ACTIONS(1080),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [aux_sym_string_token1] = ACTIONS(1080),
    [aux_sym_string_token3] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_catch] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_do] = ACTIONS(1082),
    [anon_sym_enum] = ACTIONS(1082),
    [anon_sym_extern] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_inline] = ACTIONS(1082),
    [anon_sym_macro] = ACTIONS(1082),
    [anon_sym_operator] = ACTIONS(1082),
    [anon_sym_overload] = ACTIONS(1082),
    [anon_sym_override] = ACTIONS(1082),
    [anon_sym_private] = ACTIONS(1082),
    [anon_sym_public] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_static] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_untyped] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [sym__semicolon] = ACTIONS(1080),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(920),
    [anon_sym_POUND] = ACTIONS(918),
    [anon_sym_package] = ACTIONS(920),
    [anon_sym_import] = ACTIONS(920),
    [anon_sym_using] = ACTIONS(920),
    [anon_sym_throw] = ACTIONS(920),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_switch] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(918),
    [anon_sym_case] = ACTIONS(920),
    [anon_sym_default] = ACTIONS(920),
    [anon_sym_cast] = ACTIONS(920),
    [anon_sym_DOLLARtype] = ACTIONS(918),
    [anon_sym_in] = ACTIONS(920),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_this] = ACTIONS(920),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_AT_COLON] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(920),
    [anon_sym_new] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_PLUS_PLUS] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(918),
    [anon_sym_PERCENT] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(920),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_LT_LT] = ACTIONS(918),
    [anon_sym_GT_GT] = ACTIONS(920),
    [anon_sym_GT_GT_GT] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(920),
    [anon_sym_PIPE] = ACTIONS(920),
    [anon_sym_CARET] = ACTIONS(918),
    [anon_sym_AMP_AMP] = ACTIONS(918),
    [anon_sym_PIPE_PIPE] = ACTIONS(918),
    [anon_sym_EQ_EQ] = ACTIONS(918),
    [anon_sym_BANG_EQ] = ACTIONS(918),
    [anon_sym_LT] = ACTIONS(920),
    [anon_sym_LT_EQ] = ACTIONS(918),
    [anon_sym_GT] = ACTIONS(920),
    [anon_sym_GT_EQ] = ACTIONS(918),
    [anon_sym_EQ_GT] = ACTIONS(918),
    [anon_sym_QMARK_QMARK] = ACTIONS(918),
    [anon_sym_EQ] = ACTIONS(920),
    [sym__rangeOperator] = ACTIONS(918),
    [anon_sym_null] = ACTIONS(920),
    [anon_sym_dynamic] = ACTIONS(920),
    [anon_sym_final] = ACTIONS(920),
    [anon_sym_abstract] = ACTIONS(920),
    [anon_sym_class] = ACTIONS(920),
    [anon_sym_extends] = ACTIONS(920),
    [anon_sym_implements] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(920),
    [anon_sym_typedef] = ACTIONS(920),
    [anon_sym_function] = ACTIONS(920),
    [anon_sym_var] = ACTIONS(920),
    [aux_sym_integer_token1] = ACTIONS(920),
    [aux_sym_integer_token2] = ACTIONS(918),
    [aux_sym_float_token1] = ACTIONS(920),
    [aux_sym_float_token2] = ACTIONS(918),
    [anon_sym_true] = ACTIONS(920),
    [anon_sym_false] = ACTIONS(920),
    [aux_sym_string_token1] = ACTIONS(918),
    [aux_sym_string_token3] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(920),
    [anon_sym_catch] = ACTIONS(920),
    [anon_sym_continue] = ACTIONS(920),
    [anon_sym_do] = ACTIONS(920),
    [anon_sym_enum] = ACTIONS(920),
    [anon_sym_extern] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(920),
    [anon_sym_inline] = ACTIONS(920),
    [anon_sym_macro] = ACTIONS(920),
    [anon_sym_operator] = ACTIONS(920),
    [anon_sym_overload] = ACTIONS(920),
    [anon_sym_override] = ACTIONS(920),
    [anon_sym_private] = ACTIONS(920),
    [anon_sym_public] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(920),
    [anon_sym_static] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_untyped] = ACTIONS(920),
    [anon_sym_while] = ACTIONS(920),
    [sym__semicolon] = ACTIONS(918),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_POUND] = ACTIONS(1084),
    [anon_sym_package] = ACTIONS(1086),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_using] = ACTIONS(1086),
    [anon_sym_throw] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_switch] = ACTIONS(1086),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [anon_sym_case] = ACTIONS(1086),
    [anon_sym_default] = ACTIONS(1086),
    [anon_sym_cast] = ACTIONS(1086),
    [anon_sym_DOLLARtype] = ACTIONS(1084),
    [anon_sym_in] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_this] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(1086),
    [anon_sym_AT_COLON] = ACTIONS(1084),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_else] = ACTIONS(1086),
    [anon_sym_new] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_BANG] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1084),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_SLASH] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_LT_LT] = ACTIONS(1084),
    [anon_sym_GT_GT] = ACTIONS(1086),
    [anon_sym_GT_GT_GT] = ACTIONS(1084),
    [anon_sym_AMP] = ACTIONS(1086),
    [anon_sym_PIPE] = ACTIONS(1086),
    [anon_sym_CARET] = ACTIONS(1084),
    [anon_sym_AMP_AMP] = ACTIONS(1084),
    [anon_sym_PIPE_PIPE] = ACTIONS(1084),
    [anon_sym_EQ_EQ] = ACTIONS(1084),
    [anon_sym_BANG_EQ] = ACTIONS(1084),
    [anon_sym_LT] = ACTIONS(1086),
    [anon_sym_LT_EQ] = ACTIONS(1084),
    [anon_sym_GT] = ACTIONS(1086),
    [anon_sym_GT_EQ] = ACTIONS(1084),
    [anon_sym_EQ_GT] = ACTIONS(1084),
    [anon_sym_QMARK_QMARK] = ACTIONS(1084),
    [anon_sym_EQ] = ACTIONS(1086),
    [sym__rangeOperator] = ACTIONS(1084),
    [anon_sym_null] = ACTIONS(1086),
    [anon_sym_dynamic] = ACTIONS(1086),
    [anon_sym_final] = ACTIONS(1086),
    [anon_sym_abstract] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_extends] = ACTIONS(1086),
    [anon_sym_implements] = ACTIONS(1086),
    [anon_sym_interface] = ACTIONS(1086),
    [anon_sym_typedef] = ACTIONS(1086),
    [anon_sym_function] = ACTIONS(1086),
    [anon_sym_var] = ACTIONS(1086),
    [aux_sym_integer_token1] = ACTIONS(1086),
    [aux_sym_integer_token2] = ACTIONS(1084),
    [aux_sym_float_token1] = ACTIONS(1086),
    [aux_sym_float_token2] = ACTIONS(1084),
    [anon_sym_true] = ACTIONS(1086),
    [anon_sym_false] = ACTIONS(1086),
    [aux_sym_string_token1] = ACTIONS(1084),
    [aux_sym_string_token3] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_catch] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_do] = ACTIONS(1086),
    [anon_sym_enum] = ACTIONS(1086),
    [anon_sym_extern] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_inline] = ACTIONS(1086),
    [anon_sym_macro] = ACTIONS(1086),
    [anon_sym_operator] = ACTIONS(1086),
    [anon_sym_overload] = ACTIONS(1086),
    [anon_sym_override] = ACTIONS(1086),
    [anon_sym_private] = ACTIONS(1086),
    [anon_sym_public] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_static] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_untyped] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [sym__semicolon] = ACTIONS(1084),
  },
  [202] = {
    [sym__rhs_expression] = STATE(471),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(979),
    [sym_builtin_type] = STATE(1008),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1050),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(471),
    [sym_operator] = STATE(804),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(825),
    [sym_integer] = STATE(825),
    [sym_float] = STATE(825),
    [sym_bool] = STATE(825),
    [sym_string] = STATE(675),
    [sym_null] = STATE(825),
    [sym_array] = STATE(825),
    [sym_map] = STATE(825),
    [sym_object] = STATE(825),
    [sym_pair] = STATE(825),
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1090),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(998),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_POUND] = ACTIONS(1094),
    [anon_sym_package] = ACTIONS(1096),
    [anon_sym_import] = ACTIONS(1096),
    [anon_sym_using] = ACTIONS(1096),
    [anon_sym_throw] = ACTIONS(1096),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_switch] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_RBRACE] = ACTIONS(1094),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1096),
    [anon_sym_cast] = ACTIONS(1096),
    [anon_sym_DOLLARtype] = ACTIONS(1094),
    [anon_sym_in] = ACTIONS(1096),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_this] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1096),
    [anon_sym_AT_COLON] = ACTIONS(1094),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_else] = ACTIONS(1096),
    [anon_sym_new] = ACTIONS(1096),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_DASH] = ACTIONS(1096),
    [anon_sym_PLUS_PLUS] = ACTIONS(1094),
    [anon_sym_DASH_DASH] = ACTIONS(1094),
    [anon_sym_PERCENT] = ACTIONS(1094),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_SLASH] = ACTIONS(1096),
    [anon_sym_PLUS] = ACTIONS(1096),
    [anon_sym_LT_LT] = ACTIONS(1094),
    [anon_sym_GT_GT] = ACTIONS(1096),
    [anon_sym_GT_GT_GT] = ACTIONS(1094),
    [anon_sym_AMP] = ACTIONS(1096),
    [anon_sym_PIPE] = ACTIONS(1096),
    [anon_sym_CARET] = ACTIONS(1094),
    [anon_sym_AMP_AMP] = ACTIONS(1094),
    [anon_sym_PIPE_PIPE] = ACTIONS(1094),
    [anon_sym_EQ_EQ] = ACTIONS(1094),
    [anon_sym_BANG_EQ] = ACTIONS(1094),
    [anon_sym_LT] = ACTIONS(1096),
    [anon_sym_LT_EQ] = ACTIONS(1094),
    [anon_sym_GT] = ACTIONS(1096),
    [anon_sym_GT_EQ] = ACTIONS(1094),
    [anon_sym_EQ_GT] = ACTIONS(1094),
    [anon_sym_QMARK_QMARK] = ACTIONS(1094),
    [anon_sym_EQ] = ACTIONS(1096),
    [sym__rangeOperator] = ACTIONS(1094),
    [anon_sym_null] = ACTIONS(1096),
    [anon_sym_dynamic] = ACTIONS(1096),
    [anon_sym_final] = ACTIONS(1096),
    [anon_sym_abstract] = ACTIONS(1096),
    [anon_sym_class] = ACTIONS(1096),
    [anon_sym_extends] = ACTIONS(1096),
    [anon_sym_implements] = ACTIONS(1096),
    [anon_sym_interface] = ACTIONS(1096),
    [anon_sym_typedef] = ACTIONS(1096),
    [anon_sym_function] = ACTIONS(1096),
    [anon_sym_var] = ACTIONS(1096),
    [aux_sym_integer_token1] = ACTIONS(1096),
    [aux_sym_integer_token2] = ACTIONS(1094),
    [aux_sym_float_token1] = ACTIONS(1096),
    [aux_sym_float_token2] = ACTIONS(1094),
    [anon_sym_true] = ACTIONS(1096),
    [anon_sym_false] = ACTIONS(1096),
    [aux_sym_string_token1] = ACTIONS(1094),
    [aux_sym_string_token3] = ACTIONS(1094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_catch] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_do] = ACTIONS(1096),
    [anon_sym_enum] = ACTIONS(1096),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_inline] = ACTIONS(1096),
    [anon_sym_macro] = ACTIONS(1096),
    [anon_sym_operator] = ACTIONS(1096),
    [anon_sym_overload] = ACTIONS(1096),
    [anon_sym_override] = ACTIONS(1096),
    [anon_sym_private] = ACTIONS(1096),
    [anon_sym_public] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_static] = ACTIONS(1096),
    [anon_sym_try] = ACTIONS(1096),
    [anon_sym_untyped] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [sym__semicolon] = ACTIONS(1094),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(1098),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_POUND] = ACTIONS(1098),
    [anon_sym_package] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_using] = ACTIONS(1100),
    [anon_sym_throw] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_switch] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1098),
    [anon_sym_RBRACE] = ACTIONS(1098),
    [anon_sym_case] = ACTIONS(1100),
    [anon_sym_default] = ACTIONS(1100),
    [anon_sym_cast] = ACTIONS(1100),
    [anon_sym_DOLLARtype] = ACTIONS(1098),
    [anon_sym_in] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1098),
    [anon_sym_this] = ACTIONS(1100),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_AT_COLON] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_else] = ACTIONS(1100),
    [anon_sym_new] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1098),
    [anon_sym_BANG] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_PLUS_PLUS] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1098),
    [anon_sym_PERCENT] = ACTIONS(1098),
    [anon_sym_STAR] = ACTIONS(1098),
    [anon_sym_SLASH] = ACTIONS(1100),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_LT_LT] = ACTIONS(1098),
    [anon_sym_GT_GT] = ACTIONS(1100),
    [anon_sym_GT_GT_GT] = ACTIONS(1098),
    [anon_sym_AMP] = ACTIONS(1100),
    [anon_sym_PIPE] = ACTIONS(1100),
    [anon_sym_CARET] = ACTIONS(1098),
    [anon_sym_AMP_AMP] = ACTIONS(1098),
    [anon_sym_PIPE_PIPE] = ACTIONS(1098),
    [anon_sym_EQ_EQ] = ACTIONS(1098),
    [anon_sym_BANG_EQ] = ACTIONS(1098),
    [anon_sym_LT] = ACTIONS(1100),
    [anon_sym_LT_EQ] = ACTIONS(1098),
    [anon_sym_GT] = ACTIONS(1100),
    [anon_sym_GT_EQ] = ACTIONS(1098),
    [anon_sym_EQ_GT] = ACTIONS(1098),
    [anon_sym_QMARK_QMARK] = ACTIONS(1098),
    [anon_sym_EQ] = ACTIONS(1100),
    [sym__rangeOperator] = ACTIONS(1098),
    [anon_sym_null] = ACTIONS(1100),
    [anon_sym_dynamic] = ACTIONS(1100),
    [anon_sym_final] = ACTIONS(1100),
    [anon_sym_abstract] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_extends] = ACTIONS(1100),
    [anon_sym_implements] = ACTIONS(1100),
    [anon_sym_interface] = ACTIONS(1100),
    [anon_sym_typedef] = ACTIONS(1100),
    [anon_sym_function] = ACTIONS(1100),
    [anon_sym_var] = ACTIONS(1100),
    [aux_sym_integer_token1] = ACTIONS(1100),
    [aux_sym_integer_token2] = ACTIONS(1098),
    [aux_sym_float_token1] = ACTIONS(1100),
    [aux_sym_float_token2] = ACTIONS(1098),
    [anon_sym_true] = ACTIONS(1100),
    [anon_sym_false] = ACTIONS(1100),
    [aux_sym_string_token1] = ACTIONS(1098),
    [aux_sym_string_token3] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_catch] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_do] = ACTIONS(1100),
    [anon_sym_enum] = ACTIONS(1100),
    [anon_sym_extern] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_inline] = ACTIONS(1100),
    [anon_sym_macro] = ACTIONS(1100),
    [anon_sym_operator] = ACTIONS(1100),
    [anon_sym_overload] = ACTIONS(1100),
    [anon_sym_override] = ACTIONS(1100),
    [anon_sym_private] = ACTIONS(1100),
    [anon_sym_public] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_untyped] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [sym__semicolon] = ACTIONS(1098),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1104),
    [anon_sym_POUND] = ACTIONS(1102),
    [anon_sym_package] = ACTIONS(1104),
    [anon_sym_import] = ACTIONS(1104),
    [anon_sym_using] = ACTIONS(1104),
    [anon_sym_throw] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1104),
    [anon_sym_cast] = ACTIONS(1104),
    [anon_sym_DOLLARtype] = ACTIONS(1102),
    [anon_sym_in] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_this] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1104),
    [anon_sym_AT_COLON] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1104),
    [anon_sym_else] = ACTIONS(1104),
    [anon_sym_new] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PERCENT] = ACTIONS(1102),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_LT_LT] = ACTIONS(1102),
    [anon_sym_GT_GT] = ACTIONS(1104),
    [anon_sym_GT_GT_GT] = ACTIONS(1102),
    [anon_sym_AMP] = ACTIONS(1104),
    [anon_sym_PIPE] = ACTIONS(1104),
    [anon_sym_CARET] = ACTIONS(1102),
    [anon_sym_AMP_AMP] = ACTIONS(1102),
    [anon_sym_PIPE_PIPE] = ACTIONS(1102),
    [anon_sym_EQ_EQ] = ACTIONS(1102),
    [anon_sym_BANG_EQ] = ACTIONS(1102),
    [anon_sym_LT] = ACTIONS(1104),
    [anon_sym_LT_EQ] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1104),
    [anon_sym_GT_EQ] = ACTIONS(1102),
    [anon_sym_EQ_GT] = ACTIONS(1102),
    [anon_sym_QMARK_QMARK] = ACTIONS(1102),
    [anon_sym_EQ] = ACTIONS(1104),
    [sym__rangeOperator] = ACTIONS(1102),
    [anon_sym_null] = ACTIONS(1104),
    [anon_sym_dynamic] = ACTIONS(1104),
    [anon_sym_final] = ACTIONS(1104),
    [anon_sym_abstract] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_extends] = ACTIONS(1104),
    [anon_sym_implements] = ACTIONS(1104),
    [anon_sym_interface] = ACTIONS(1104),
    [anon_sym_typedef] = ACTIONS(1104),
    [anon_sym_function] = ACTIONS(1104),
    [anon_sym_var] = ACTIONS(1104),
    [aux_sym_integer_token1] = ACTIONS(1104),
    [aux_sym_integer_token2] = ACTIONS(1102),
    [aux_sym_float_token1] = ACTIONS(1104),
    [aux_sym_float_token2] = ACTIONS(1102),
    [anon_sym_true] = ACTIONS(1104),
    [anon_sym_false] = ACTIONS(1104),
    [aux_sym_string_token1] = ACTIONS(1102),
    [aux_sym_string_token3] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1104),
    [anon_sym_catch] = ACTIONS(1104),
    [anon_sym_continue] = ACTIONS(1104),
    [anon_sym_do] = ACTIONS(1104),
    [anon_sym_enum] = ACTIONS(1104),
    [anon_sym_extern] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1104),
    [anon_sym_inline] = ACTIONS(1104),
    [anon_sym_macro] = ACTIONS(1104),
    [anon_sym_operator] = ACTIONS(1104),
    [anon_sym_overload] = ACTIONS(1104),
    [anon_sym_override] = ACTIONS(1104),
    [anon_sym_private] = ACTIONS(1104),
    [anon_sym_public] = ACTIONS(1104),
    [anon_sym_return] = ACTIONS(1104),
    [anon_sym_static] = ACTIONS(1104),
    [anon_sym_try] = ACTIONS(1104),
    [anon_sym_untyped] = ACTIONS(1104),
    [anon_sym_while] = ACTIONS(1104),
    [sym__semicolon] = ACTIONS(1102),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(1106),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_POUND] = ACTIONS(1106),
    [anon_sym_package] = ACTIONS(1108),
    [anon_sym_import] = ACTIONS(1108),
    [anon_sym_using] = ACTIONS(1108),
    [anon_sym_throw] = ACTIONS(1108),
    [anon_sym_LPAREN] = ACTIONS(1106),
    [anon_sym_switch] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1106),
    [anon_sym_RBRACE] = ACTIONS(1106),
    [anon_sym_case] = ACTIONS(1108),
    [anon_sym_default] = ACTIONS(1108),
    [anon_sym_cast] = ACTIONS(1108),
    [anon_sym_DOLLARtype] = ACTIONS(1106),
    [anon_sym_in] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1106),
    [anon_sym_this] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_AT_COLON] = ACTIONS(1106),
    [anon_sym_if] = ACTIONS(1108),
    [anon_sym_else] = ACTIONS(1108),
    [anon_sym_new] = ACTIONS(1108),
    [anon_sym_TILDE] = ACTIONS(1106),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1106),
    [anon_sym_DASH_DASH] = ACTIONS(1106),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PLUS] = ACTIONS(1108),
    [anon_sym_LT_LT] = ACTIONS(1106),
    [anon_sym_GT_GT] = ACTIONS(1108),
    [anon_sym_GT_GT_GT] = ACTIONS(1106),
    [anon_sym_AMP] = ACTIONS(1108),
    [anon_sym_PIPE] = ACTIONS(1108),
    [anon_sym_CARET] = ACTIONS(1106),
    [anon_sym_AMP_AMP] = ACTIONS(1106),
    [anon_sym_PIPE_PIPE] = ACTIONS(1106),
    [anon_sym_EQ_EQ] = ACTIONS(1106),
    [anon_sym_BANG_EQ] = ACTIONS(1106),
    [anon_sym_LT] = ACTIONS(1108),
    [anon_sym_LT_EQ] = ACTIONS(1106),
    [anon_sym_GT] = ACTIONS(1108),
    [anon_sym_GT_EQ] = ACTIONS(1106),
    [anon_sym_EQ_GT] = ACTIONS(1106),
    [anon_sym_QMARK_QMARK] = ACTIONS(1106),
    [anon_sym_EQ] = ACTIONS(1108),
    [sym__rangeOperator] = ACTIONS(1106),
    [anon_sym_null] = ACTIONS(1108),
    [anon_sym_dynamic] = ACTIONS(1108),
    [anon_sym_final] = ACTIONS(1108),
    [anon_sym_abstract] = ACTIONS(1108),
    [anon_sym_class] = ACTIONS(1108),
    [anon_sym_extends] = ACTIONS(1108),
    [anon_sym_implements] = ACTIONS(1108),
    [anon_sym_interface] = ACTIONS(1108),
    [anon_sym_typedef] = ACTIONS(1108),
    [anon_sym_function] = ACTIONS(1108),
    [anon_sym_var] = ACTIONS(1108),
    [aux_sym_integer_token1] = ACTIONS(1108),
    [aux_sym_integer_token2] = ACTIONS(1106),
    [aux_sym_float_token1] = ACTIONS(1108),
    [aux_sym_float_token2] = ACTIONS(1106),
    [anon_sym_true] = ACTIONS(1108),
    [anon_sym_false] = ACTIONS(1108),
    [aux_sym_string_token1] = ACTIONS(1106),
    [aux_sym_string_token3] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1108),
    [anon_sym_catch] = ACTIONS(1108),
    [anon_sym_continue] = ACTIONS(1108),
    [anon_sym_do] = ACTIONS(1108),
    [anon_sym_enum] = ACTIONS(1108),
    [anon_sym_extern] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_inline] = ACTIONS(1108),
    [anon_sym_macro] = ACTIONS(1108),
    [anon_sym_operator] = ACTIONS(1108),
    [anon_sym_overload] = ACTIONS(1108),
    [anon_sym_override] = ACTIONS(1108),
    [anon_sym_private] = ACTIONS(1108),
    [anon_sym_public] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1108),
    [anon_sym_static] = ACTIONS(1108),
    [anon_sym_try] = ACTIONS(1108),
    [anon_sym_untyped] = ACTIONS(1108),
    [anon_sym_while] = ACTIONS(1108),
    [sym__semicolon] = ACTIONS(1106),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(950),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_POUND] = ACTIONS(950),
    [anon_sym_package] = ACTIONS(952),
    [anon_sym_import] = ACTIONS(952),
    [anon_sym_using] = ACTIONS(952),
    [anon_sym_throw] = ACTIONS(952),
    [anon_sym_LPAREN] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_cast] = ACTIONS(952),
    [anon_sym_DOLLARtype] = ACTIONS(950),
    [anon_sym_in] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(950),
    [anon_sym_this] = ACTIONS(952),
    [anon_sym_AT] = ACTIONS(952),
    [anon_sym_AT_COLON] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_else] = ACTIONS(952),
    [anon_sym_new] = ACTIONS(952),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(952),
    [anon_sym_DASH] = ACTIONS(952),
    [anon_sym_PLUS_PLUS] = ACTIONS(950),
    [anon_sym_DASH_DASH] = ACTIONS(950),
    [anon_sym_PERCENT] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_SLASH] = ACTIONS(952),
    [anon_sym_PLUS] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(950),
    [anon_sym_GT_GT] = ACTIONS(952),
    [anon_sym_GT_GT_GT] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(952),
    [anon_sym_CARET] = ACTIONS(950),
    [anon_sym_AMP_AMP] = ACTIONS(950),
    [anon_sym_PIPE_PIPE] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(950),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_LT_EQ] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(950),
    [anon_sym_EQ_GT] = ACTIONS(950),
    [anon_sym_QMARK_QMARK] = ACTIONS(950),
    [anon_sym_EQ] = ACTIONS(952),
    [sym__rangeOperator] = ACTIONS(950),
    [anon_sym_null] = ACTIONS(952),
    [anon_sym_dynamic] = ACTIONS(952),
    [anon_sym_final] = ACTIONS(952),
    [anon_sym_abstract] = ACTIONS(952),
    [anon_sym_class] = ACTIONS(952),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(952),
    [anon_sym_interface] = ACTIONS(952),
    [anon_sym_typedef] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(952),
    [aux_sym_integer_token1] = ACTIONS(952),
    [aux_sym_integer_token2] = ACTIONS(950),
    [aux_sym_float_token1] = ACTIONS(952),
    [aux_sym_float_token2] = ACTIONS(950),
    [anon_sym_true] = ACTIONS(952),
    [anon_sym_false] = ACTIONS(952),
    [aux_sym_string_token1] = ACTIONS(950),
    [aux_sym_string_token3] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_catch] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_do] = ACTIONS(952),
    [anon_sym_enum] = ACTIONS(952),
    [anon_sym_extern] = ACTIONS(952),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_inline] = ACTIONS(952),
    [anon_sym_macro] = ACTIONS(952),
    [anon_sym_operator] = ACTIONS(952),
    [anon_sym_overload] = ACTIONS(952),
    [anon_sym_override] = ACTIONS(952),
    [anon_sym_private] = ACTIONS(952),
    [anon_sym_public] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_static] = ACTIONS(952),
    [anon_sym_try] = ACTIONS(952),
    [anon_sym_untyped] = ACTIONS(952),
    [anon_sym_while] = ACTIONS(952),
    [sym__semicolon] = ACTIONS(950),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(1110),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_POUND] = ACTIONS(1110),
    [anon_sym_package] = ACTIONS(1112),
    [anon_sym_import] = ACTIONS(1112),
    [anon_sym_using] = ACTIONS(1112),
    [anon_sym_throw] = ACTIONS(1112),
    [anon_sym_LPAREN] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_case] = ACTIONS(1112),
    [anon_sym_default] = ACTIONS(1112),
    [anon_sym_cast] = ACTIONS(1112),
    [anon_sym_DOLLARtype] = ACTIONS(1110),
    [anon_sym_in] = ACTIONS(1112),
    [anon_sym_LBRACK] = ACTIONS(1110),
    [anon_sym_this] = ACTIONS(1112),
    [anon_sym_AT] = ACTIONS(1112),
    [anon_sym_AT_COLON] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1112),
    [anon_sym_else] = ACTIONS(1112),
    [anon_sym_new] = ACTIONS(1112),
    [anon_sym_TILDE] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1112),
    [anon_sym_DASH] = ACTIONS(1112),
    [anon_sym_PLUS_PLUS] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1110),
    [anon_sym_PERCENT] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1110),
    [anon_sym_SLASH] = ACTIONS(1112),
    [anon_sym_PLUS] = ACTIONS(1112),
    [anon_sym_LT_LT] = ACTIONS(1110),
    [anon_sym_GT_GT] = ACTIONS(1112),
    [anon_sym_GT_GT_GT] = ACTIONS(1110),
    [anon_sym_AMP] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_AMP_AMP] = ACTIONS(1110),
    [anon_sym_PIPE_PIPE] = ACTIONS(1110),
    [anon_sym_EQ_EQ] = ACTIONS(1110),
    [anon_sym_BANG_EQ] = ACTIONS(1110),
    [anon_sym_LT] = ACTIONS(1112),
    [anon_sym_LT_EQ] = ACTIONS(1110),
    [anon_sym_GT] = ACTIONS(1112),
    [anon_sym_GT_EQ] = ACTIONS(1110),
    [anon_sym_EQ_GT] = ACTIONS(1110),
    [anon_sym_QMARK_QMARK] = ACTIONS(1110),
    [anon_sym_EQ] = ACTIONS(1112),
    [sym__rangeOperator] = ACTIONS(1110),
    [anon_sym_null] = ACTIONS(1112),
    [anon_sym_dynamic] = ACTIONS(1112),
    [anon_sym_final] = ACTIONS(1112),
    [anon_sym_abstract] = ACTIONS(1112),
    [anon_sym_class] = ACTIONS(1112),
    [anon_sym_extends] = ACTIONS(1112),
    [anon_sym_implements] = ACTIONS(1112),
    [anon_sym_interface] = ACTIONS(1112),
    [anon_sym_typedef] = ACTIONS(1112),
    [anon_sym_function] = ACTIONS(1112),
    [anon_sym_var] = ACTIONS(1112),
    [aux_sym_integer_token1] = ACTIONS(1112),
    [aux_sym_integer_token2] = ACTIONS(1110),
    [aux_sym_float_token1] = ACTIONS(1112),
    [aux_sym_float_token2] = ACTIONS(1110),
    [anon_sym_true] = ACTIONS(1112),
    [anon_sym_false] = ACTIONS(1112),
    [aux_sym_string_token1] = ACTIONS(1110),
    [aux_sym_string_token3] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1112),
    [anon_sym_catch] = ACTIONS(1112),
    [anon_sym_continue] = ACTIONS(1112),
    [anon_sym_do] = ACTIONS(1112),
    [anon_sym_enum] = ACTIONS(1112),
    [anon_sym_extern] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1112),
    [anon_sym_inline] = ACTIONS(1112),
    [anon_sym_macro] = ACTIONS(1112),
    [anon_sym_operator] = ACTIONS(1112),
    [anon_sym_overload] = ACTIONS(1112),
    [anon_sym_override] = ACTIONS(1112),
    [anon_sym_private] = ACTIONS(1112),
    [anon_sym_public] = ACTIONS(1112),
    [anon_sym_return] = ACTIONS(1112),
    [anon_sym_static] = ACTIONS(1112),
    [anon_sym_try] = ACTIONS(1112),
    [anon_sym_untyped] = ACTIONS(1112),
    [anon_sym_while] = ACTIONS(1112),
    [sym__semicolon] = ACTIONS(1110),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_identifier] = ACTIONS(1116),
    [anon_sym_POUND] = ACTIONS(1114),
    [anon_sym_package] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(1116),
    [anon_sym_using] = ACTIONS(1116),
    [anon_sym_throw] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_switch] = ACTIONS(1116),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [anon_sym_case] = ACTIONS(1116),
    [anon_sym_default] = ACTIONS(1116),
    [anon_sym_cast] = ACTIONS(1116),
    [anon_sym_DOLLARtype] = ACTIONS(1114),
    [anon_sym_in] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_this] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1116),
    [anon_sym_AT_COLON] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(1116),
    [anon_sym_else] = ACTIONS(1116),
    [anon_sym_new] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_STAR] = ACTIONS(1114),
    [anon_sym_SLASH] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_LT_LT] = ACTIONS(1114),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_GT_GT_GT] = ACTIONS(1114),
    [anon_sym_AMP] = ACTIONS(1116),
    [anon_sym_PIPE] = ACTIONS(1116),
    [anon_sym_CARET] = ACTIONS(1114),
    [anon_sym_AMP_AMP] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(1114),
    [anon_sym_EQ_EQ] = ACTIONS(1114),
    [anon_sym_BANG_EQ] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(1116),
    [anon_sym_LT_EQ] = ACTIONS(1114),
    [anon_sym_GT] = ACTIONS(1116),
    [anon_sym_GT_EQ] = ACTIONS(1114),
    [anon_sym_EQ_GT] = ACTIONS(1114),
    [anon_sym_QMARK_QMARK] = ACTIONS(1114),
    [anon_sym_EQ] = ACTIONS(1116),
    [sym__rangeOperator] = ACTIONS(1114),
    [anon_sym_null] = ACTIONS(1116),
    [anon_sym_dynamic] = ACTIONS(1116),
    [anon_sym_final] = ACTIONS(1116),
    [anon_sym_abstract] = ACTIONS(1116),
    [anon_sym_class] = ACTIONS(1116),
    [anon_sym_extends] = ACTIONS(1116),
    [anon_sym_implements] = ACTIONS(1116),
    [anon_sym_interface] = ACTIONS(1116),
    [anon_sym_typedef] = ACTIONS(1116),
    [anon_sym_function] = ACTIONS(1116),
    [anon_sym_var] = ACTIONS(1116),
    [aux_sym_integer_token1] = ACTIONS(1116),
    [aux_sym_integer_token2] = ACTIONS(1114),
    [aux_sym_float_token1] = ACTIONS(1116),
    [aux_sym_float_token2] = ACTIONS(1114),
    [anon_sym_true] = ACTIONS(1116),
    [anon_sym_false] = ACTIONS(1116),
    [aux_sym_string_token1] = ACTIONS(1114),
    [aux_sym_string_token3] = ACTIONS(1114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1116),
    [anon_sym_catch] = ACTIONS(1116),
    [anon_sym_continue] = ACTIONS(1116),
    [anon_sym_do] = ACTIONS(1116),
    [anon_sym_enum] = ACTIONS(1116),
    [anon_sym_extern] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_inline] = ACTIONS(1116),
    [anon_sym_macro] = ACTIONS(1116),
    [anon_sym_operator] = ACTIONS(1116),
    [anon_sym_overload] = ACTIONS(1116),
    [anon_sym_override] = ACTIONS(1116),
    [anon_sym_private] = ACTIONS(1116),
    [anon_sym_public] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1116),
    [anon_sym_static] = ACTIONS(1116),
    [anon_sym_try] = ACTIONS(1116),
    [anon_sym_untyped] = ACTIONS(1116),
    [anon_sym_while] = ACTIONS(1116),
    [sym__semicolon] = ACTIONS(1114),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_POUND] = ACTIONS(380),
    [anon_sym_package] = ACTIONS(382),
    [anon_sym_import] = ACTIONS(382),
    [anon_sym_using] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_case] = ACTIONS(382),
    [anon_sym_default] = ACTIONS(382),
    [anon_sym_cast] = ACTIONS(382),
    [anon_sym_DOLLARtype] = ACTIONS(380),
    [anon_sym_in] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_this] = ACTIONS(382),
    [anon_sym_AT] = ACTIONS(382),
    [anon_sym_AT_COLON] = ACTIONS(380),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_GT_GT_GT] = ACTIONS(380),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_QMARK_QMARK] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [sym__rangeOperator] = ACTIONS(380),
    [anon_sym_null] = ACTIONS(382),
    [anon_sym_dynamic] = ACTIONS(382),
    [anon_sym_final] = ACTIONS(382),
    [anon_sym_abstract] = ACTIONS(382),
    [anon_sym_class] = ACTIONS(382),
    [anon_sym_extends] = ACTIONS(382),
    [anon_sym_implements] = ACTIONS(382),
    [anon_sym_interface] = ACTIONS(382),
    [anon_sym_typedef] = ACTIONS(382),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_var] = ACTIONS(382),
    [aux_sym_integer_token1] = ACTIONS(382),
    [aux_sym_integer_token2] = ACTIONS(380),
    [aux_sym_float_token1] = ACTIONS(382),
    [aux_sym_float_token2] = ACTIONS(380),
    [anon_sym_true] = ACTIONS(382),
    [anon_sym_false] = ACTIONS(382),
    [aux_sym_string_token1] = ACTIONS(380),
    [aux_sym_string_token3] = ACTIONS(380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_catch] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_enum] = ACTIONS(382),
    [anon_sym_extern] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_inline] = ACTIONS(382),
    [anon_sym_macro] = ACTIONS(382),
    [anon_sym_operator] = ACTIONS(382),
    [anon_sym_overload] = ACTIONS(382),
    [anon_sym_override] = ACTIONS(382),
    [anon_sym_private] = ACTIONS(382),
    [anon_sym_public] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_untyped] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [sym__semicolon] = ACTIONS(380),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(366),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_POUND] = ACTIONS(366),
    [anon_sym_package] = ACTIONS(368),
    [anon_sym_import] = ACTIONS(368),
    [anon_sym_using] = ACTIONS(368),
    [anon_sym_throw] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_switch] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(366),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_case] = ACTIONS(368),
    [anon_sym_default] = ACTIONS(368),
    [anon_sym_cast] = ACTIONS(368),
    [anon_sym_DOLLARtype] = ACTIONS(366),
    [anon_sym_in] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(366),
    [anon_sym_this] = ACTIONS(368),
    [anon_sym_AT] = ACTIONS(368),
    [anon_sym_AT_COLON] = ACTIONS(366),
    [anon_sym_if] = ACTIONS(368),
    [anon_sym_else] = ACTIONS(368),
    [anon_sym_new] = ACTIONS(368),
    [anon_sym_TILDE] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(368),
    [anon_sym_DASH] = ACTIONS(368),
    [anon_sym_PLUS_PLUS] = ACTIONS(366),
    [anon_sym_DASH_DASH] = ACTIONS(366),
    [anon_sym_PERCENT] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_SLASH] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_GT_GT_GT] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_PIPE] = ACTIONS(368),
    [anon_sym_CARET] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_EQ_EQ] = ACTIONS(366),
    [anon_sym_BANG_EQ] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_EQ] = ACTIONS(366),
    [anon_sym_EQ_GT] = ACTIONS(366),
    [anon_sym_QMARK_QMARK] = ACTIONS(366),
    [anon_sym_EQ] = ACTIONS(368),
    [sym__rangeOperator] = ACTIONS(366),
    [anon_sym_null] = ACTIONS(368),
    [anon_sym_dynamic] = ACTIONS(368),
    [anon_sym_final] = ACTIONS(368),
    [anon_sym_abstract] = ACTIONS(368),
    [anon_sym_class] = ACTIONS(368),
    [anon_sym_extends] = ACTIONS(368),
    [anon_sym_implements] = ACTIONS(368),
    [anon_sym_interface] = ACTIONS(368),
    [anon_sym_typedef] = ACTIONS(368),
    [anon_sym_function] = ACTIONS(368),
    [anon_sym_var] = ACTIONS(368),
    [aux_sym_integer_token1] = ACTIONS(368),
    [aux_sym_integer_token2] = ACTIONS(366),
    [aux_sym_float_token1] = ACTIONS(368),
    [aux_sym_float_token2] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(368),
    [anon_sym_false] = ACTIONS(368),
    [aux_sym_string_token1] = ACTIONS(366),
    [aux_sym_string_token3] = ACTIONS(366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(368),
    [anon_sym_catch] = ACTIONS(368),
    [anon_sym_continue] = ACTIONS(368),
    [anon_sym_do] = ACTIONS(368),
    [anon_sym_enum] = ACTIONS(368),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym_for] = ACTIONS(368),
    [anon_sym_inline] = ACTIONS(368),
    [anon_sym_macro] = ACTIONS(368),
    [anon_sym_operator] = ACTIONS(368),
    [anon_sym_overload] = ACTIONS(368),
    [anon_sym_override] = ACTIONS(368),
    [anon_sym_private] = ACTIONS(368),
    [anon_sym_public] = ACTIONS(368),
    [anon_sym_return] = ACTIONS(368),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_try] = ACTIONS(368),
    [anon_sym_untyped] = ACTIONS(368),
    [anon_sym_while] = ACTIONS(368),
    [sym__semicolon] = ACTIONS(366),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(1118),
    [sym_identifier] = ACTIONS(1120),
    [anon_sym_POUND] = ACTIONS(1118),
    [anon_sym_package] = ACTIONS(1120),
    [anon_sym_import] = ACTIONS(1120),
    [anon_sym_using] = ACTIONS(1120),
    [anon_sym_throw] = ACTIONS(1120),
    [anon_sym_LPAREN] = ACTIONS(1118),
    [anon_sym_switch] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1118),
    [anon_sym_RBRACE] = ACTIONS(1118),
    [anon_sym_case] = ACTIONS(1120),
    [anon_sym_default] = ACTIONS(1120),
    [anon_sym_cast] = ACTIONS(1120),
    [anon_sym_DOLLARtype] = ACTIONS(1118),
    [anon_sym_in] = ACTIONS(1120),
    [anon_sym_LBRACK] = ACTIONS(1118),
    [anon_sym_this] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1120),
    [anon_sym_AT_COLON] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1120),
    [anon_sym_else] = ACTIONS(1120),
    [anon_sym_new] = ACTIONS(1120),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_BANG] = ACTIONS(1120),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_PLUS_PLUS] = ACTIONS(1118),
    [anon_sym_DASH_DASH] = ACTIONS(1118),
    [anon_sym_PERCENT] = ACTIONS(1118),
    [anon_sym_STAR] = ACTIONS(1118),
    [anon_sym_SLASH] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_LT_LT] = ACTIONS(1118),
    [anon_sym_GT_GT] = ACTIONS(1120),
    [anon_sym_GT_GT_GT] = ACTIONS(1118),
    [anon_sym_AMP] = ACTIONS(1120),
    [anon_sym_PIPE] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(1118),
    [anon_sym_AMP_AMP] = ACTIONS(1118),
    [anon_sym_PIPE_PIPE] = ACTIONS(1118),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_LT] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1118),
    [anon_sym_GT] = ACTIONS(1120),
    [anon_sym_GT_EQ] = ACTIONS(1118),
    [anon_sym_EQ_GT] = ACTIONS(1118),
    [anon_sym_QMARK_QMARK] = ACTIONS(1118),
    [anon_sym_EQ] = ACTIONS(1120),
    [sym__rangeOperator] = ACTIONS(1118),
    [anon_sym_null] = ACTIONS(1120),
    [anon_sym_dynamic] = ACTIONS(1120),
    [anon_sym_final] = ACTIONS(1120),
    [anon_sym_abstract] = ACTIONS(1120),
    [anon_sym_class] = ACTIONS(1120),
    [anon_sym_extends] = ACTIONS(1120),
    [anon_sym_implements] = ACTIONS(1120),
    [anon_sym_interface] = ACTIONS(1120),
    [anon_sym_typedef] = ACTIONS(1120),
    [anon_sym_function] = ACTIONS(1120),
    [anon_sym_var] = ACTIONS(1120),
    [aux_sym_integer_token1] = ACTIONS(1120),
    [aux_sym_integer_token2] = ACTIONS(1118),
    [aux_sym_float_token1] = ACTIONS(1120),
    [aux_sym_float_token2] = ACTIONS(1118),
    [anon_sym_true] = ACTIONS(1120),
    [anon_sym_false] = ACTIONS(1120),
    [aux_sym_string_token1] = ACTIONS(1118),
    [aux_sym_string_token3] = ACTIONS(1118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1120),
    [anon_sym_catch] = ACTIONS(1120),
    [anon_sym_continue] = ACTIONS(1120),
    [anon_sym_do] = ACTIONS(1120),
    [anon_sym_enum] = ACTIONS(1120),
    [anon_sym_extern] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1120),
    [anon_sym_inline] = ACTIONS(1120),
    [anon_sym_macro] = ACTIONS(1120),
    [anon_sym_operator] = ACTIONS(1120),
    [anon_sym_overload] = ACTIONS(1120),
    [anon_sym_override] = ACTIONS(1120),
    [anon_sym_private] = ACTIONS(1120),
    [anon_sym_public] = ACTIONS(1120),
    [anon_sym_return] = ACTIONS(1120),
    [anon_sym_static] = ACTIONS(1120),
    [anon_sym_try] = ACTIONS(1120),
    [anon_sym_untyped] = ACTIONS(1120),
    [anon_sym_while] = ACTIONS(1120),
    [sym__semicolon] = ACTIONS(1118),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(366),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_POUND] = ACTIONS(366),
    [anon_sym_package] = ACTIONS(368),
    [anon_sym_import] = ACTIONS(368),
    [anon_sym_using] = ACTIONS(368),
    [anon_sym_throw] = ACTIONS(368),
    [anon_sym_LPAREN] = ACTIONS(366),
    [anon_sym_switch] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(366),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_case] = ACTIONS(368),
    [anon_sym_default] = ACTIONS(368),
    [anon_sym_cast] = ACTIONS(368),
    [anon_sym_DOLLARtype] = ACTIONS(366),
    [anon_sym_in] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(368),
    [anon_sym_AT] = ACTIONS(368),
    [anon_sym_AT_COLON] = ACTIONS(366),
    [anon_sym_if] = ACTIONS(368),
    [anon_sym_else] = ACTIONS(368),
    [anon_sym_new] = ACTIONS(368),
    [anon_sym_TILDE] = ACTIONS(366),
    [anon_sym_BANG] = ACTIONS(368),
    [anon_sym_DASH] = ACTIONS(368),
    [anon_sym_PLUS_PLUS] = ACTIONS(366),
    [anon_sym_DASH_DASH] = ACTIONS(366),
    [anon_sym_PERCENT] = ACTIONS(366),
    [anon_sym_STAR] = ACTIONS(366),
    [anon_sym_SLASH] = ACTIONS(368),
    [anon_sym_PLUS] = ACTIONS(368),
    [anon_sym_LT_LT] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(368),
    [anon_sym_GT_GT_GT] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(368),
    [anon_sym_PIPE] = ACTIONS(368),
    [anon_sym_CARET] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_EQ_EQ] = ACTIONS(366),
    [anon_sym_BANG_EQ] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(368),
    [anon_sym_LT_EQ] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(368),
    [anon_sym_GT_EQ] = ACTIONS(366),
    [anon_sym_EQ_GT] = ACTIONS(366),
    [anon_sym_QMARK_QMARK] = ACTIONS(366),
    [anon_sym_EQ] = ACTIONS(368),
    [sym__rangeOperator] = ACTIONS(366),
    [anon_sym_null] = ACTIONS(368),
    [anon_sym_dynamic] = ACTIONS(368),
    [anon_sym_final] = ACTIONS(368),
    [anon_sym_abstract] = ACTIONS(368),
    [anon_sym_class] = ACTIONS(368),
    [anon_sym_extends] = ACTIONS(368),
    [anon_sym_implements] = ACTIONS(368),
    [anon_sym_interface] = ACTIONS(368),
    [anon_sym_typedef] = ACTIONS(368),
    [anon_sym_function] = ACTIONS(368),
    [anon_sym_var] = ACTIONS(368),
    [aux_sym_integer_token1] = ACTIONS(368),
    [aux_sym_integer_token2] = ACTIONS(366),
    [aux_sym_float_token1] = ACTIONS(368),
    [aux_sym_float_token2] = ACTIONS(366),
    [anon_sym_true] = ACTIONS(368),
    [anon_sym_false] = ACTIONS(368),
    [aux_sym_string_token1] = ACTIONS(366),
    [aux_sym_string_token3] = ACTIONS(366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(368),
    [anon_sym_catch] = ACTIONS(368),
    [anon_sym_continue] = ACTIONS(368),
    [anon_sym_do] = ACTIONS(368),
    [anon_sym_enum] = ACTIONS(368),
    [anon_sym_extern] = ACTIONS(368),
    [anon_sym_for] = ACTIONS(368),
    [anon_sym_inline] = ACTIONS(368),
    [anon_sym_macro] = ACTIONS(368),
    [anon_sym_operator] = ACTIONS(368),
    [anon_sym_overload] = ACTIONS(368),
    [anon_sym_override] = ACTIONS(368),
    [anon_sym_private] = ACTIONS(368),
    [anon_sym_public] = ACTIONS(368),
    [anon_sym_return] = ACTIONS(368),
    [anon_sym_static] = ACTIONS(368),
    [anon_sym_try] = ACTIONS(368),
    [anon_sym_untyped] = ACTIONS(368),
    [anon_sym_while] = ACTIONS(368),
    [sym__semicolon] = ACTIONS(366),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_POUND] = ACTIONS(1122),
    [anon_sym_package] = ACTIONS(1124),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_using] = ACTIONS(1124),
    [anon_sym_throw] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_switch] = ACTIONS(1124),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_RBRACE] = ACTIONS(1122),
    [anon_sym_case] = ACTIONS(1124),
    [anon_sym_default] = ACTIONS(1124),
    [anon_sym_cast] = ACTIONS(1124),
    [anon_sym_DOLLARtype] = ACTIONS(1122),
    [anon_sym_in] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_this] = ACTIONS(1124),
    [anon_sym_AT] = ACTIONS(1124),
    [anon_sym_AT_COLON] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(1124),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_BANG] = ACTIONS(1124),
    [anon_sym_DASH] = ACTIONS(1124),
    [anon_sym_PLUS_PLUS] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1122),
    [anon_sym_PERCENT] = ACTIONS(1122),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_SLASH] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(1124),
    [anon_sym_LT_LT] = ACTIONS(1122),
    [anon_sym_GT_GT] = ACTIONS(1124),
    [anon_sym_GT_GT_GT] = ACTIONS(1122),
    [anon_sym_AMP] = ACTIONS(1124),
    [anon_sym_PIPE] = ACTIONS(1124),
    [anon_sym_CARET] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1122),
    [anon_sym_PIPE_PIPE] = ACTIONS(1122),
    [anon_sym_EQ_EQ] = ACTIONS(1122),
    [anon_sym_BANG_EQ] = ACTIONS(1122),
    [anon_sym_LT] = ACTIONS(1124),
    [anon_sym_LT_EQ] = ACTIONS(1122),
    [anon_sym_GT] = ACTIONS(1124),
    [anon_sym_GT_EQ] = ACTIONS(1122),
    [anon_sym_EQ_GT] = ACTIONS(1122),
    [anon_sym_QMARK_QMARK] = ACTIONS(1122),
    [anon_sym_EQ] = ACTIONS(1124),
    [sym__rangeOperator] = ACTIONS(1122),
    [anon_sym_null] = ACTIONS(1124),
    [anon_sym_dynamic] = ACTIONS(1124),
    [anon_sym_final] = ACTIONS(1124),
    [anon_sym_abstract] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_extends] = ACTIONS(1124),
    [anon_sym_implements] = ACTIONS(1124),
    [anon_sym_interface] = ACTIONS(1124),
    [anon_sym_typedef] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(1124),
    [anon_sym_var] = ACTIONS(1124),
    [aux_sym_integer_token1] = ACTIONS(1124),
    [aux_sym_integer_token2] = ACTIONS(1122),
    [aux_sym_float_token1] = ACTIONS(1124),
    [aux_sym_float_token2] = ACTIONS(1122),
    [anon_sym_true] = ACTIONS(1124),
    [anon_sym_false] = ACTIONS(1124),
    [aux_sym_string_token1] = ACTIONS(1122),
    [aux_sym_string_token3] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_catch] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_do] = ACTIONS(1124),
    [anon_sym_enum] = ACTIONS(1124),
    [anon_sym_extern] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_inline] = ACTIONS(1124),
    [anon_sym_macro] = ACTIONS(1124),
    [anon_sym_operator] = ACTIONS(1124),
    [anon_sym_overload] = ACTIONS(1124),
    [anon_sym_override] = ACTIONS(1124),
    [anon_sym_private] = ACTIONS(1124),
    [anon_sym_public] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_static] = ACTIONS(1124),
    [anon_sym_try] = ACTIONS(1124),
    [anon_sym_untyped] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [sym__semicolon] = ACTIONS(1122),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_POUND] = ACTIONS(1126),
    [anon_sym_package] = ACTIONS(1128),
    [anon_sym_import] = ACTIONS(1128),
    [anon_sym_using] = ACTIONS(1128),
    [anon_sym_throw] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [anon_sym_switch] = ACTIONS(1128),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [anon_sym_case] = ACTIONS(1128),
    [anon_sym_default] = ACTIONS(1128),
    [anon_sym_cast] = ACTIONS(1128),
    [anon_sym_DOLLARtype] = ACTIONS(1126),
    [anon_sym_in] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_this] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1128),
    [anon_sym_AT_COLON] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_new] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PERCENT] = ACTIONS(1126),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_LT_LT] = ACTIONS(1126),
    [anon_sym_GT_GT] = ACTIONS(1128),
    [anon_sym_GT_GT_GT] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(1128),
    [anon_sym_PIPE] = ACTIONS(1128),
    [anon_sym_CARET] = ACTIONS(1126),
    [anon_sym_AMP_AMP] = ACTIONS(1126),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [anon_sym_EQ_EQ] = ACTIONS(1126),
    [anon_sym_BANG_EQ] = ACTIONS(1126),
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_LT_EQ] = ACTIONS(1126),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_GT_EQ] = ACTIONS(1126),
    [anon_sym_EQ_GT] = ACTIONS(1126),
    [anon_sym_QMARK_QMARK] = ACTIONS(1126),
    [anon_sym_EQ] = ACTIONS(1128),
    [sym__rangeOperator] = ACTIONS(1126),
    [anon_sym_null] = ACTIONS(1128),
    [anon_sym_dynamic] = ACTIONS(1128),
    [anon_sym_final] = ACTIONS(1128),
    [anon_sym_abstract] = ACTIONS(1128),
    [anon_sym_class] = ACTIONS(1128),
    [anon_sym_extends] = ACTIONS(1128),
    [anon_sym_implements] = ACTIONS(1128),
    [anon_sym_interface] = ACTIONS(1128),
    [anon_sym_typedef] = ACTIONS(1128),
    [anon_sym_function] = ACTIONS(1128),
    [anon_sym_var] = ACTIONS(1128),
    [aux_sym_integer_token1] = ACTIONS(1128),
    [aux_sym_integer_token2] = ACTIONS(1126),
    [aux_sym_float_token1] = ACTIONS(1128),
    [aux_sym_float_token2] = ACTIONS(1126),
    [anon_sym_true] = ACTIONS(1128),
    [anon_sym_false] = ACTIONS(1128),
    [aux_sym_string_token1] = ACTIONS(1126),
    [aux_sym_string_token3] = ACTIONS(1126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_catch] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_do] = ACTIONS(1128),
    [anon_sym_enum] = ACTIONS(1128),
    [anon_sym_extern] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_inline] = ACTIONS(1128),
    [anon_sym_macro] = ACTIONS(1128),
    [anon_sym_operator] = ACTIONS(1128),
    [anon_sym_overload] = ACTIONS(1128),
    [anon_sym_override] = ACTIONS(1128),
    [anon_sym_private] = ACTIONS(1128),
    [anon_sym_public] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_static] = ACTIONS(1128),
    [anon_sym_try] = ACTIONS(1128),
    [anon_sym_untyped] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [sym__semicolon] = ACTIONS(1126),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(1130),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_POUND] = ACTIONS(1130),
    [anon_sym_package] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(1132),
    [anon_sym_using] = ACTIONS(1132),
    [anon_sym_throw] = ACTIONS(1132),
    [anon_sym_LPAREN] = ACTIONS(1130),
    [anon_sym_switch] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_case] = ACTIONS(1132),
    [anon_sym_default] = ACTIONS(1132),
    [anon_sym_cast] = ACTIONS(1132),
    [anon_sym_DOLLARtype] = ACTIONS(1130),
    [anon_sym_in] = ACTIONS(1132),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_this] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1132),
    [anon_sym_AT_COLON] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1132),
    [anon_sym_else] = ACTIONS(1132),
    [anon_sym_new] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PERCENT] = ACTIONS(1130),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_LT_LT] = ACTIONS(1130),
    [anon_sym_GT_GT] = ACTIONS(1132),
    [anon_sym_GT_GT_GT] = ACTIONS(1130),
    [anon_sym_AMP] = ACTIONS(1132),
    [anon_sym_PIPE] = ACTIONS(1132),
    [anon_sym_CARET] = ACTIONS(1130),
    [anon_sym_AMP_AMP] = ACTIONS(1130),
    [anon_sym_PIPE_PIPE] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(1130),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_LT_EQ] = ACTIONS(1130),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_EQ] = ACTIONS(1130),
    [anon_sym_EQ_GT] = ACTIONS(1130),
    [anon_sym_QMARK_QMARK] = ACTIONS(1130),
    [anon_sym_EQ] = ACTIONS(1132),
    [sym__rangeOperator] = ACTIONS(1130),
    [anon_sym_null] = ACTIONS(1132),
    [anon_sym_dynamic] = ACTIONS(1132),
    [anon_sym_final] = ACTIONS(1132),
    [anon_sym_abstract] = ACTIONS(1132),
    [anon_sym_class] = ACTIONS(1132),
    [anon_sym_extends] = ACTIONS(1132),
    [anon_sym_implements] = ACTIONS(1132),
    [anon_sym_interface] = ACTIONS(1132),
    [anon_sym_typedef] = ACTIONS(1132),
    [anon_sym_function] = ACTIONS(1132),
    [anon_sym_var] = ACTIONS(1132),
    [aux_sym_integer_token1] = ACTIONS(1132),
    [aux_sym_integer_token2] = ACTIONS(1130),
    [aux_sym_float_token1] = ACTIONS(1132),
    [aux_sym_float_token2] = ACTIONS(1130),
    [anon_sym_true] = ACTIONS(1132),
    [anon_sym_false] = ACTIONS(1132),
    [aux_sym_string_token1] = ACTIONS(1130),
    [aux_sym_string_token3] = ACTIONS(1130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1132),
    [anon_sym_catch] = ACTIONS(1132),
    [anon_sym_continue] = ACTIONS(1132),
    [anon_sym_do] = ACTIONS(1132),
    [anon_sym_enum] = ACTIONS(1132),
    [anon_sym_extern] = ACTIONS(1132),
    [anon_sym_for] = ACTIONS(1132),
    [anon_sym_inline] = ACTIONS(1132),
    [anon_sym_macro] = ACTIONS(1132),
    [anon_sym_operator] = ACTIONS(1132),
    [anon_sym_overload] = ACTIONS(1132),
    [anon_sym_override] = ACTIONS(1132),
    [anon_sym_private] = ACTIONS(1132),
    [anon_sym_public] = ACTIONS(1132),
    [anon_sym_return] = ACTIONS(1132),
    [anon_sym_static] = ACTIONS(1132),
    [anon_sym_try] = ACTIONS(1132),
    [anon_sym_untyped] = ACTIONS(1132),
    [anon_sym_while] = ACTIONS(1132),
    [sym__semicolon] = ACTIONS(1130),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(380),
    [sym_identifier] = ACTIONS(382),
    [anon_sym_POUND] = ACTIONS(380),
    [anon_sym_package] = ACTIONS(382),
    [anon_sym_import] = ACTIONS(382),
    [anon_sym_using] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(382),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_case] = ACTIONS(382),
    [anon_sym_default] = ACTIONS(382),
    [anon_sym_cast] = ACTIONS(382),
    [anon_sym_DOLLARtype] = ACTIONS(380),
    [anon_sym_in] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(382),
    [anon_sym_AT] = ACTIONS(382),
    [anon_sym_AT_COLON] = ACTIONS(380),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(380),
    [anon_sym_BANG] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_PERCENT] = ACTIONS(380),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_SLASH] = ACTIONS(382),
    [anon_sym_PLUS] = ACTIONS(382),
    [anon_sym_LT_LT] = ACTIONS(380),
    [anon_sym_GT_GT] = ACTIONS(382),
    [anon_sym_GT_GT_GT] = ACTIONS(380),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_PIPE] = ACTIONS(382),
    [anon_sym_CARET] = ACTIONS(380),
    [anon_sym_AMP_AMP] = ACTIONS(380),
    [anon_sym_PIPE_PIPE] = ACTIONS(380),
    [anon_sym_EQ_EQ] = ACTIONS(380),
    [anon_sym_BANG_EQ] = ACTIONS(380),
    [anon_sym_LT] = ACTIONS(382),
    [anon_sym_LT_EQ] = ACTIONS(380),
    [anon_sym_GT] = ACTIONS(382),
    [anon_sym_GT_EQ] = ACTIONS(380),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_QMARK_QMARK] = ACTIONS(380),
    [anon_sym_EQ] = ACTIONS(382),
    [sym__rangeOperator] = ACTIONS(380),
    [anon_sym_null] = ACTIONS(382),
    [anon_sym_dynamic] = ACTIONS(382),
    [anon_sym_final] = ACTIONS(382),
    [anon_sym_abstract] = ACTIONS(382),
    [anon_sym_class] = ACTIONS(382),
    [anon_sym_extends] = ACTIONS(382),
    [anon_sym_implements] = ACTIONS(382),
    [anon_sym_interface] = ACTIONS(382),
    [anon_sym_typedef] = ACTIONS(382),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_var] = ACTIONS(382),
    [aux_sym_integer_token1] = ACTIONS(382),
    [aux_sym_integer_token2] = ACTIONS(380),
    [aux_sym_float_token1] = ACTIONS(382),
    [aux_sym_float_token2] = ACTIONS(380),
    [anon_sym_true] = ACTIONS(382),
    [anon_sym_false] = ACTIONS(382),
    [aux_sym_string_token1] = ACTIONS(380),
    [aux_sym_string_token3] = ACTIONS(380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_catch] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_enum] = ACTIONS(382),
    [anon_sym_extern] = ACTIONS(382),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_inline] = ACTIONS(382),
    [anon_sym_macro] = ACTIONS(382),
    [anon_sym_operator] = ACTIONS(382),
    [anon_sym_overload] = ACTIONS(382),
    [anon_sym_override] = ACTIONS(382),
    [anon_sym_private] = ACTIONS(382),
    [anon_sym_public] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_untyped] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [sym__semicolon] = ACTIONS(380),
  },
  [218] = {
    [ts_builtin_sym_end] = ACTIONS(1134),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_POUND] = ACTIONS(1134),
    [anon_sym_package] = ACTIONS(1136),
    [anon_sym_import] = ACTIONS(1136),
    [anon_sym_using] = ACTIONS(1136),
    [anon_sym_throw] = ACTIONS(1136),
    [anon_sym_LPAREN] = ACTIONS(1134),
    [anon_sym_switch] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_cast] = ACTIONS(1136),
    [anon_sym_DOLLARtype] = ACTIONS(1134),
    [anon_sym_in] = ACTIONS(1136),
    [anon_sym_LBRACK] = ACTIONS(1134),
    [anon_sym_this] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1136),
    [anon_sym_AT_COLON] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_new] = ACTIONS(1136),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_BANG] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_PERCENT] = ACTIONS(1134),
    [anon_sym_STAR] = ACTIONS(1134),
    [anon_sym_SLASH] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_GT_GT_GT] = ACTIONS(1134),
    [anon_sym_AMP] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1134),
    [anon_sym_AMP_AMP] = ACTIONS(1134),
    [anon_sym_PIPE_PIPE] = ACTIONS(1134),
    [anon_sym_EQ_EQ] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(1134),
    [anon_sym_LT] = ACTIONS(1136),
    [anon_sym_LT_EQ] = ACTIONS(1134),
    [anon_sym_GT] = ACTIONS(1136),
    [anon_sym_GT_EQ] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1134),
    [anon_sym_QMARK_QMARK] = ACTIONS(1134),
    [anon_sym_EQ] = ACTIONS(1136),
    [sym__rangeOperator] = ACTIONS(1134),
    [anon_sym_null] = ACTIONS(1136),
    [anon_sym_dynamic] = ACTIONS(1136),
    [anon_sym_final] = ACTIONS(1136),
    [anon_sym_abstract] = ACTIONS(1136),
    [anon_sym_class] = ACTIONS(1136),
    [anon_sym_extends] = ACTIONS(1136),
    [anon_sym_implements] = ACTIONS(1136),
    [anon_sym_interface] = ACTIONS(1136),
    [anon_sym_typedef] = ACTIONS(1136),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_var] = ACTIONS(1136),
    [aux_sym_integer_token1] = ACTIONS(1136),
    [aux_sym_integer_token2] = ACTIONS(1134),
    [aux_sym_float_token1] = ACTIONS(1136),
    [aux_sym_float_token2] = ACTIONS(1134),
    [anon_sym_true] = ACTIONS(1136),
    [anon_sym_false] = ACTIONS(1136),
    [aux_sym_string_token1] = ACTIONS(1134),
    [aux_sym_string_token3] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1136),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_continue] = ACTIONS(1136),
    [anon_sym_do] = ACTIONS(1136),
    [anon_sym_enum] = ACTIONS(1136),
    [anon_sym_extern] = ACTIONS(1136),
    [anon_sym_for] = ACTIONS(1136),
    [anon_sym_inline] = ACTIONS(1136),
    [anon_sym_macro] = ACTIONS(1136),
    [anon_sym_operator] = ACTIONS(1136),
    [anon_sym_overload] = ACTIONS(1136),
    [anon_sym_override] = ACTIONS(1136),
    [anon_sym_private] = ACTIONS(1136),
    [anon_sym_public] = ACTIONS(1136),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_static] = ACTIONS(1136),
    [anon_sym_try] = ACTIONS(1136),
    [anon_sym_untyped] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(1136),
    [sym__semicolon] = ACTIONS(1134),
  },
  [219] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_POUND] = ACTIONS(1138),
    [anon_sym_package] = ACTIONS(1140),
    [anon_sym_import] = ACTIONS(1140),
    [anon_sym_using] = ACTIONS(1140),
    [anon_sym_throw] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_case] = ACTIONS(1140),
    [anon_sym_default] = ACTIONS(1140),
    [anon_sym_cast] = ACTIONS(1140),
    [anon_sym_DOLLARtype] = ACTIONS(1138),
    [anon_sym_in] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_this] = ACTIONS(1140),
    [anon_sym_AT] = ACTIONS(1140),
    [anon_sym_AT_COLON] = ACTIONS(1138),
    [anon_sym_if] = ACTIONS(1140),
    [anon_sym_else] = ACTIONS(1140),
    [anon_sym_new] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_BANG] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_PERCENT] = ACTIONS(1138),
    [anon_sym_STAR] = ACTIONS(1138),
    [anon_sym_SLASH] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_LT_LT] = ACTIONS(1138),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [anon_sym_GT_GT_GT] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1140),
    [anon_sym_PIPE] = ACTIONS(1140),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [anon_sym_EQ_EQ] = ACTIONS(1138),
    [anon_sym_BANG_EQ] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_LT_EQ] = ACTIONS(1138),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_GT_EQ] = ACTIONS(1138),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_QMARK_QMARK] = ACTIONS(1138),
    [anon_sym_EQ] = ACTIONS(1140),
    [sym__rangeOperator] = ACTIONS(1138),
    [anon_sym_null] = ACTIONS(1140),
    [anon_sym_dynamic] = ACTIONS(1140),
    [anon_sym_final] = ACTIONS(1140),
    [anon_sym_abstract] = ACTIONS(1140),
    [anon_sym_class] = ACTIONS(1140),
    [anon_sym_extends] = ACTIONS(1140),
    [anon_sym_implements] = ACTIONS(1140),
    [anon_sym_interface] = ACTIONS(1140),
    [anon_sym_typedef] = ACTIONS(1140),
    [anon_sym_function] = ACTIONS(1140),
    [anon_sym_var] = ACTIONS(1140),
    [aux_sym_integer_token1] = ACTIONS(1140),
    [aux_sym_integer_token2] = ACTIONS(1138),
    [aux_sym_float_token1] = ACTIONS(1140),
    [aux_sym_float_token2] = ACTIONS(1138),
    [anon_sym_true] = ACTIONS(1140),
    [anon_sym_false] = ACTIONS(1140),
    [aux_sym_string_token1] = ACTIONS(1138),
    [aux_sym_string_token3] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1140),
    [anon_sym_catch] = ACTIONS(1140),
    [anon_sym_continue] = ACTIONS(1140),
    [anon_sym_do] = ACTIONS(1140),
    [anon_sym_enum] = ACTIONS(1140),
    [anon_sym_extern] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1140),
    [anon_sym_inline] = ACTIONS(1140),
    [anon_sym_macro] = ACTIONS(1140),
    [anon_sym_operator] = ACTIONS(1140),
    [anon_sym_overload] = ACTIONS(1140),
    [anon_sym_override] = ACTIONS(1140),
    [anon_sym_private] = ACTIONS(1140),
    [anon_sym_public] = ACTIONS(1140),
    [anon_sym_return] = ACTIONS(1140),
    [anon_sym_static] = ACTIONS(1140),
    [anon_sym_try] = ACTIONS(1140),
    [anon_sym_untyped] = ACTIONS(1140),
    [anon_sym_while] = ACTIONS(1140),
    [sym__semicolon] = ACTIONS(1138),
  },
  [220] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_POUND] = ACTIONS(1142),
    [anon_sym_package] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_using] = ACTIONS(1144),
    [anon_sym_throw] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_case] = ACTIONS(1144),
    [anon_sym_default] = ACTIONS(1144),
    [anon_sym_cast] = ACTIONS(1144),
    [anon_sym_DOLLARtype] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_this] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1144),
    [anon_sym_AT_COLON] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_else] = ACTIONS(1144),
    [anon_sym_new] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_PERCENT] = ACTIONS(1142),
    [anon_sym_STAR] = ACTIONS(1142),
    [anon_sym_SLASH] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_LT_LT] = ACTIONS(1142),
    [anon_sym_GT_GT] = ACTIONS(1144),
    [anon_sym_GT_GT_GT] = ACTIONS(1142),
    [anon_sym_AMP] = ACTIONS(1144),
    [anon_sym_PIPE] = ACTIONS(1144),
    [anon_sym_CARET] = ACTIONS(1142),
    [anon_sym_AMP_AMP] = ACTIONS(1142),
    [anon_sym_PIPE_PIPE] = ACTIONS(1142),
    [anon_sym_EQ_EQ] = ACTIONS(1142),
    [anon_sym_BANG_EQ] = ACTIONS(1142),
    [anon_sym_LT] = ACTIONS(1144),
    [anon_sym_LT_EQ] = ACTIONS(1142),
    [anon_sym_GT] = ACTIONS(1144),
    [anon_sym_GT_EQ] = ACTIONS(1142),
    [anon_sym_EQ_GT] = ACTIONS(1142),
    [anon_sym_QMARK_QMARK] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(1144),
    [sym__rangeOperator] = ACTIONS(1142),
    [anon_sym_null] = ACTIONS(1144),
    [anon_sym_dynamic] = ACTIONS(1144),
    [anon_sym_final] = ACTIONS(1144),
    [anon_sym_abstract] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_extends] = ACTIONS(1144),
    [anon_sym_implements] = ACTIONS(1144),
    [anon_sym_interface] = ACTIONS(1144),
    [anon_sym_typedef] = ACTIONS(1144),
    [anon_sym_function] = ACTIONS(1144),
    [anon_sym_var] = ACTIONS(1144),
    [aux_sym_integer_token1] = ACTIONS(1144),
    [aux_sym_integer_token2] = ACTIONS(1142),
    [aux_sym_float_token1] = ACTIONS(1144),
    [aux_sym_float_token2] = ACTIONS(1142),
    [anon_sym_true] = ACTIONS(1144),
    [anon_sym_false] = ACTIONS(1144),
    [aux_sym_string_token1] = ACTIONS(1142),
    [aux_sym_string_token3] = ACTIONS(1142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_catch] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_do] = ACTIONS(1144),
    [anon_sym_enum] = ACTIONS(1144),
    [anon_sym_extern] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_inline] = ACTIONS(1144),
    [anon_sym_macro] = ACTIONS(1144),
    [anon_sym_operator] = ACTIONS(1144),
    [anon_sym_overload] = ACTIONS(1144),
    [anon_sym_override] = ACTIONS(1144),
    [anon_sym_private] = ACTIONS(1144),
    [anon_sym_public] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_static] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_untyped] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [sym__semicolon] = ACTIONS(1142),
  },
  [221] = {
    [ts_builtin_sym_end] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_POUND] = ACTIONS(1146),
    [anon_sym_package] = ACTIONS(1148),
    [anon_sym_import] = ACTIONS(1148),
    [anon_sym_using] = ACTIONS(1148),
    [anon_sym_throw] = ACTIONS(1148),
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_switch] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_RBRACE] = ACTIONS(1146),
    [anon_sym_case] = ACTIONS(1148),
    [anon_sym_default] = ACTIONS(1148),
    [anon_sym_cast] = ACTIONS(1148),
    [anon_sym_DOLLARtype] = ACTIONS(1146),
    [anon_sym_in] = ACTIONS(1148),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_this] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1148),
    [anon_sym_AT_COLON] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_else] = ACTIONS(1148),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_BANG] = ACTIONS(1148),
    [anon_sym_DASH] = ACTIONS(1148),
    [anon_sym_PLUS_PLUS] = ACTIONS(1146),
    [anon_sym_DASH_DASH] = ACTIONS(1146),
    [anon_sym_PERCENT] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_SLASH] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1148),
    [anon_sym_LT_LT] = ACTIONS(1146),
    [anon_sym_GT_GT] = ACTIONS(1148),
    [anon_sym_GT_GT_GT] = ACTIONS(1146),
    [anon_sym_AMP] = ACTIONS(1148),
    [anon_sym_PIPE] = ACTIONS(1148),
    [anon_sym_CARET] = ACTIONS(1146),
    [anon_sym_AMP_AMP] = ACTIONS(1146),
    [anon_sym_PIPE_PIPE] = ACTIONS(1146),
    [anon_sym_EQ_EQ] = ACTIONS(1146),
    [anon_sym_BANG_EQ] = ACTIONS(1146),
    [anon_sym_LT] = ACTIONS(1148),
    [anon_sym_LT_EQ] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(1148),
    [anon_sym_GT_EQ] = ACTIONS(1146),
    [anon_sym_EQ_GT] = ACTIONS(1146),
    [anon_sym_QMARK_QMARK] = ACTIONS(1146),
    [anon_sym_EQ] = ACTIONS(1148),
    [sym__rangeOperator] = ACTIONS(1146),
    [anon_sym_null] = ACTIONS(1148),
    [anon_sym_dynamic] = ACTIONS(1148),
    [anon_sym_final] = ACTIONS(1148),
    [anon_sym_abstract] = ACTIONS(1148),
    [anon_sym_class] = ACTIONS(1148),
    [anon_sym_extends] = ACTIONS(1148),
    [anon_sym_implements] = ACTIONS(1148),
    [anon_sym_interface] = ACTIONS(1148),
    [anon_sym_typedef] = ACTIONS(1148),
    [anon_sym_function] = ACTIONS(1148),
    [anon_sym_var] = ACTIONS(1148),
    [aux_sym_integer_token1] = ACTIONS(1148),
    [aux_sym_integer_token2] = ACTIONS(1146),
    [aux_sym_float_token1] = ACTIONS(1148),
    [aux_sym_float_token2] = ACTIONS(1146),
    [anon_sym_true] = ACTIONS(1148),
    [anon_sym_false] = ACTIONS(1148),
    [aux_sym_string_token1] = ACTIONS(1146),
    [aux_sym_string_token3] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1148),
    [anon_sym_catch] = ACTIONS(1148),
    [anon_sym_continue] = ACTIONS(1148),
    [anon_sym_do] = ACTIONS(1148),
    [anon_sym_enum] = ACTIONS(1148),
    [anon_sym_extern] = ACTIONS(1148),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_inline] = ACTIONS(1148),
    [anon_sym_macro] = ACTIONS(1148),
    [anon_sym_operator] = ACTIONS(1148),
    [anon_sym_overload] = ACTIONS(1148),
    [anon_sym_override] = ACTIONS(1148),
    [anon_sym_private] = ACTIONS(1148),
    [anon_sym_public] = ACTIONS(1148),
    [anon_sym_return] = ACTIONS(1148),
    [anon_sym_static] = ACTIONS(1148),
    [anon_sym_try] = ACTIONS(1148),
    [anon_sym_untyped] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1148),
    [sym__semicolon] = ACTIONS(1146),
  },
  [222] = {
    [ts_builtin_sym_end] = ACTIONS(1150),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_POUND] = ACTIONS(1150),
    [anon_sym_package] = ACTIONS(1152),
    [anon_sym_import] = ACTIONS(1152),
    [anon_sym_using] = ACTIONS(1152),
    [anon_sym_throw] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_switch] = ACTIONS(1152),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_RBRACE] = ACTIONS(1150),
    [anon_sym_case] = ACTIONS(1152),
    [anon_sym_default] = ACTIONS(1152),
    [anon_sym_cast] = ACTIONS(1152),
    [anon_sym_DOLLARtype] = ACTIONS(1150),
    [anon_sym_in] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_this] = ACTIONS(1152),
    [anon_sym_AT] = ACTIONS(1152),
    [anon_sym_AT_COLON] = ACTIONS(1150),
    [anon_sym_if] = ACTIONS(1152),
    [anon_sym_else] = ACTIONS(1152),
    [anon_sym_new] = ACTIONS(1152),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PLUS_PLUS] = ACTIONS(1150),
    [anon_sym_DASH_DASH] = ACTIONS(1150),
    [anon_sym_PERCENT] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_LT_LT] = ACTIONS(1150),
    [anon_sym_GT_GT] = ACTIONS(1152),
    [anon_sym_GT_GT_GT] = ACTIONS(1150),
    [anon_sym_AMP] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_CARET] = ACTIONS(1150),
    [anon_sym_AMP_AMP] = ACTIONS(1150),
    [anon_sym_PIPE_PIPE] = ACTIONS(1150),
    [anon_sym_EQ_EQ] = ACTIONS(1150),
    [anon_sym_BANG_EQ] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_LT_EQ] = ACTIONS(1150),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_GT_EQ] = ACTIONS(1150),
    [anon_sym_EQ_GT] = ACTIONS(1150),
    [anon_sym_QMARK_QMARK] = ACTIONS(1150),
    [anon_sym_EQ] = ACTIONS(1152),
    [sym__rangeOperator] = ACTIONS(1150),
    [anon_sym_null] = ACTIONS(1152),
    [anon_sym_dynamic] = ACTIONS(1152),
    [anon_sym_final] = ACTIONS(1152),
    [anon_sym_abstract] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(1152),
    [anon_sym_extends] = ACTIONS(1152),
    [anon_sym_implements] = ACTIONS(1152),
    [anon_sym_interface] = ACTIONS(1152),
    [anon_sym_typedef] = ACTIONS(1152),
    [anon_sym_function] = ACTIONS(1152),
    [anon_sym_var] = ACTIONS(1152),
    [aux_sym_integer_token1] = ACTIONS(1152),
    [aux_sym_integer_token2] = ACTIONS(1150),
    [aux_sym_float_token1] = ACTIONS(1152),
    [aux_sym_float_token2] = ACTIONS(1150),
    [anon_sym_true] = ACTIONS(1152),
    [anon_sym_false] = ACTIONS(1152),
    [aux_sym_string_token1] = ACTIONS(1150),
    [aux_sym_string_token3] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1152),
    [anon_sym_catch] = ACTIONS(1152),
    [anon_sym_continue] = ACTIONS(1152),
    [anon_sym_do] = ACTIONS(1152),
    [anon_sym_enum] = ACTIONS(1152),
    [anon_sym_extern] = ACTIONS(1152),
    [anon_sym_for] = ACTIONS(1152),
    [anon_sym_inline] = ACTIONS(1152),
    [anon_sym_macro] = ACTIONS(1152),
    [anon_sym_operator] = ACTIONS(1152),
    [anon_sym_overload] = ACTIONS(1152),
    [anon_sym_override] = ACTIONS(1152),
    [anon_sym_private] = ACTIONS(1152),
    [anon_sym_public] = ACTIONS(1152),
    [anon_sym_return] = ACTIONS(1152),
    [anon_sym_static] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1152),
    [anon_sym_untyped] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1152),
    [sym__semicolon] = ACTIONS(1150),
  },
  [223] = {
    [ts_builtin_sym_end] = ACTIONS(1154),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_POUND] = ACTIONS(1154),
    [anon_sym_package] = ACTIONS(1156),
    [anon_sym_import] = ACTIONS(1156),
    [anon_sym_using] = ACTIONS(1156),
    [anon_sym_throw] = ACTIONS(1156),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_switch] = ACTIONS(1156),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [anon_sym_case] = ACTIONS(1156),
    [anon_sym_default] = ACTIONS(1156),
    [anon_sym_cast] = ACTIONS(1156),
    [anon_sym_DOLLARtype] = ACTIONS(1154),
    [anon_sym_in] = ACTIONS(1156),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(1156),
    [anon_sym_AT] = ACTIONS(1156),
    [anon_sym_AT_COLON] = ACTIONS(1154),
    [anon_sym_if] = ACTIONS(1156),
    [anon_sym_else] = ACTIONS(1156),
    [anon_sym_new] = ACTIONS(1156),
    [anon_sym_TILDE] = ACTIONS(1154),
    [anon_sym_BANG] = ACTIONS(1156),
    [anon_sym_DASH] = ACTIONS(1156),
    [anon_sym_PLUS_PLUS] = ACTIONS(1154),
    [anon_sym_DASH_DASH] = ACTIONS(1154),
    [anon_sym_PERCENT] = ACTIONS(1154),
    [anon_sym_STAR] = ACTIONS(1154),
    [anon_sym_SLASH] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(1156),
    [anon_sym_LT_LT] = ACTIONS(1154),
    [anon_sym_GT_GT] = ACTIONS(1156),
    [anon_sym_GT_GT_GT] = ACTIONS(1154),
    [anon_sym_AMP] = ACTIONS(1156),
    [anon_sym_PIPE] = ACTIONS(1156),
    [anon_sym_CARET] = ACTIONS(1154),
    [anon_sym_AMP_AMP] = ACTIONS(1154),
    [anon_sym_PIPE_PIPE] = ACTIONS(1154),
    [anon_sym_EQ_EQ] = ACTIONS(1154),
    [anon_sym_BANG_EQ] = ACTIONS(1154),
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_LT_EQ] = ACTIONS(1154),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_GT_EQ] = ACTIONS(1154),
    [anon_sym_EQ_GT] = ACTIONS(1154),
    [anon_sym_QMARK_QMARK] = ACTIONS(1154),
    [anon_sym_EQ] = ACTIONS(1156),
    [sym__rangeOperator] = ACTIONS(1154),
    [anon_sym_null] = ACTIONS(1156),
    [anon_sym_dynamic] = ACTIONS(1156),
    [anon_sym_final] = ACTIONS(1156),
    [anon_sym_abstract] = ACTIONS(1156),
    [anon_sym_class] = ACTIONS(1156),
    [anon_sym_extends] = ACTIONS(1156),
    [anon_sym_implements] = ACTIONS(1156),
    [anon_sym_interface] = ACTIONS(1156),
    [anon_sym_typedef] = ACTIONS(1156),
    [anon_sym_function] = ACTIONS(1156),
    [anon_sym_var] = ACTIONS(1156),
    [aux_sym_integer_token1] = ACTIONS(1156),
    [aux_sym_integer_token2] = ACTIONS(1154),
    [aux_sym_float_token1] = ACTIONS(1156),
    [aux_sym_float_token2] = ACTIONS(1154),
    [anon_sym_true] = ACTIONS(1156),
    [anon_sym_false] = ACTIONS(1156),
    [aux_sym_string_token1] = ACTIONS(1154),
    [aux_sym_string_token3] = ACTIONS(1154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1156),
    [anon_sym_catch] = ACTIONS(1156),
    [anon_sym_continue] = ACTIONS(1156),
    [anon_sym_do] = ACTIONS(1156),
    [anon_sym_enum] = ACTIONS(1156),
    [anon_sym_extern] = ACTIONS(1156),
    [anon_sym_for] = ACTIONS(1156),
    [anon_sym_inline] = ACTIONS(1156),
    [anon_sym_macro] = ACTIONS(1156),
    [anon_sym_operator] = ACTIONS(1156),
    [anon_sym_overload] = ACTIONS(1156),
    [anon_sym_override] = ACTIONS(1156),
    [anon_sym_private] = ACTIONS(1156),
    [anon_sym_public] = ACTIONS(1156),
    [anon_sym_return] = ACTIONS(1156),
    [anon_sym_static] = ACTIONS(1156),
    [anon_sym_try] = ACTIONS(1156),
    [anon_sym_untyped] = ACTIONS(1156),
    [anon_sym_while] = ACTIONS(1156),
    [sym__semicolon] = ACTIONS(1154),
  },
  [224] = {
    [sym__rhs_expression] = STATE(431),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(981),
    [sym_builtin_type] = STATE(1008),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1042),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(431),
    [sym_operator] = STATE(803),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(467),
    [sym_integer] = STATE(467),
    [sym_float] = STATE(467),
    [sym_bool] = STATE(467),
    [sym_string] = STATE(462),
    [sym_null] = STATE(467),
    [sym_array] = STATE(467),
    [sym_map] = STATE(467),
    [sym_object] = STATE(467),
    [sym_pair] = STATE(467),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(996),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(998),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_identifier] = ACTIONS(1160),
    [anon_sym_POUND] = ACTIONS(1158),
    [anon_sym_package] = ACTIONS(1160),
    [anon_sym_import] = ACTIONS(1160),
    [anon_sym_using] = ACTIONS(1160),
    [anon_sym_throw] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [anon_sym_switch] = ACTIONS(1160),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [anon_sym_case] = ACTIONS(1160),
    [anon_sym_default] = ACTIONS(1160),
    [anon_sym_cast] = ACTIONS(1160),
    [anon_sym_DOLLARtype] = ACTIONS(1158),
    [anon_sym_in] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_this] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(1160),
    [anon_sym_AT_COLON] = ACTIONS(1158),
    [anon_sym_if] = ACTIONS(1160),
    [anon_sym_else] = ACTIONS(1160),
    [anon_sym_new] = ACTIONS(1160),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_BANG] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_PERCENT] = ACTIONS(1158),
    [anon_sym_STAR] = ACTIONS(1158),
    [anon_sym_SLASH] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_LT_LT] = ACTIONS(1158),
    [anon_sym_GT_GT] = ACTIONS(1160),
    [anon_sym_GT_GT_GT] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(1160),
    [anon_sym_PIPE] = ACTIONS(1160),
    [anon_sym_CARET] = ACTIONS(1158),
    [anon_sym_AMP_AMP] = ACTIONS(1158),
    [anon_sym_PIPE_PIPE] = ACTIONS(1158),
    [anon_sym_EQ_EQ] = ACTIONS(1158),
    [anon_sym_BANG_EQ] = ACTIONS(1158),
    [anon_sym_LT] = ACTIONS(1160),
    [anon_sym_LT_EQ] = ACTIONS(1158),
    [anon_sym_GT] = ACTIONS(1160),
    [anon_sym_GT_EQ] = ACTIONS(1158),
    [anon_sym_EQ_GT] = ACTIONS(1158),
    [anon_sym_QMARK_QMARK] = ACTIONS(1158),
    [anon_sym_EQ] = ACTIONS(1160),
    [sym__rangeOperator] = ACTIONS(1158),
    [anon_sym_null] = ACTIONS(1160),
    [anon_sym_dynamic] = ACTIONS(1160),
    [anon_sym_final] = ACTIONS(1160),
    [anon_sym_abstract] = ACTIONS(1160),
    [anon_sym_class] = ACTIONS(1160),
    [anon_sym_extends] = ACTIONS(1160),
    [anon_sym_implements] = ACTIONS(1160),
    [anon_sym_interface] = ACTIONS(1160),
    [anon_sym_typedef] = ACTIONS(1160),
    [anon_sym_function] = ACTIONS(1160),
    [anon_sym_var] = ACTIONS(1160),
    [aux_sym_integer_token1] = ACTIONS(1160),
    [aux_sym_integer_token2] = ACTIONS(1158),
    [aux_sym_float_token1] = ACTIONS(1160),
    [aux_sym_float_token2] = ACTIONS(1158),
    [anon_sym_true] = ACTIONS(1160),
    [anon_sym_false] = ACTIONS(1160),
    [aux_sym_string_token1] = ACTIONS(1158),
    [aux_sym_string_token3] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1160),
    [anon_sym_catch] = ACTIONS(1160),
    [anon_sym_continue] = ACTIONS(1160),
    [anon_sym_do] = ACTIONS(1160),
    [anon_sym_enum] = ACTIONS(1160),
    [anon_sym_extern] = ACTIONS(1160),
    [anon_sym_for] = ACTIONS(1160),
    [anon_sym_inline] = ACTIONS(1160),
    [anon_sym_macro] = ACTIONS(1160),
    [anon_sym_operator] = ACTIONS(1160),
    [anon_sym_overload] = ACTIONS(1160),
    [anon_sym_override] = ACTIONS(1160),
    [anon_sym_private] = ACTIONS(1160),
    [anon_sym_public] = ACTIONS(1160),
    [anon_sym_return] = ACTIONS(1160),
    [anon_sym_static] = ACTIONS(1160),
    [anon_sym_try] = ACTIONS(1160),
    [anon_sym_untyped] = ACTIONS(1160),
    [anon_sym_while] = ACTIONS(1160),
    [sym__semicolon] = ACTIONS(1158),
  },
  [226] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_POUND] = ACTIONS(1162),
    [anon_sym_package] = ACTIONS(1164),
    [anon_sym_import] = ACTIONS(1164),
    [anon_sym_using] = ACTIONS(1164),
    [anon_sym_throw] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [anon_sym_case] = ACTIONS(1164),
    [anon_sym_default] = ACTIONS(1164),
    [anon_sym_cast] = ACTIONS(1164),
    [anon_sym_DOLLARtype] = ACTIONS(1162),
    [anon_sym_in] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_this] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_AT_COLON] = ACTIONS(1162),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_else] = ACTIONS(1164),
    [anon_sym_new] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_BANG] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_PERCENT] = ACTIONS(1162),
    [anon_sym_STAR] = ACTIONS(1162),
    [anon_sym_SLASH] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_LT_LT] = ACTIONS(1162),
    [anon_sym_GT_GT] = ACTIONS(1164),
    [anon_sym_GT_GT_GT] = ACTIONS(1162),
    [anon_sym_AMP] = ACTIONS(1164),
    [anon_sym_PIPE] = ACTIONS(1164),
    [anon_sym_CARET] = ACTIONS(1162),
    [anon_sym_AMP_AMP] = ACTIONS(1162),
    [anon_sym_PIPE_PIPE] = ACTIONS(1162),
    [anon_sym_EQ_EQ] = ACTIONS(1162),
    [anon_sym_BANG_EQ] = ACTIONS(1162),
    [anon_sym_LT] = ACTIONS(1164),
    [anon_sym_LT_EQ] = ACTIONS(1162),
    [anon_sym_GT] = ACTIONS(1164),
    [anon_sym_GT_EQ] = ACTIONS(1162),
    [anon_sym_EQ_GT] = ACTIONS(1162),
    [anon_sym_QMARK_QMARK] = ACTIONS(1162),
    [anon_sym_EQ] = ACTIONS(1164),
    [sym__rangeOperator] = ACTIONS(1162),
    [anon_sym_null] = ACTIONS(1164),
    [anon_sym_dynamic] = ACTIONS(1164),
    [anon_sym_final] = ACTIONS(1164),
    [anon_sym_abstract] = ACTIONS(1164),
    [anon_sym_class] = ACTIONS(1164),
    [anon_sym_extends] = ACTIONS(1164),
    [anon_sym_implements] = ACTIONS(1164),
    [anon_sym_interface] = ACTIONS(1164),
    [anon_sym_typedef] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_var] = ACTIONS(1164),
    [aux_sym_integer_token1] = ACTIONS(1164),
    [aux_sym_integer_token2] = ACTIONS(1162),
    [aux_sym_float_token1] = ACTIONS(1164),
    [aux_sym_float_token2] = ACTIONS(1162),
    [anon_sym_true] = ACTIONS(1164),
    [anon_sym_false] = ACTIONS(1164),
    [aux_sym_string_token1] = ACTIONS(1162),
    [aux_sym_string_token3] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_catch] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [anon_sym_do] = ACTIONS(1164),
    [anon_sym_enum] = ACTIONS(1164),
    [anon_sym_extern] = ACTIONS(1164),
    [anon_sym_for] = ACTIONS(1164),
    [anon_sym_inline] = ACTIONS(1164),
    [anon_sym_macro] = ACTIONS(1164),
    [anon_sym_operator] = ACTIONS(1164),
    [anon_sym_overload] = ACTIONS(1164),
    [anon_sym_override] = ACTIONS(1164),
    [anon_sym_private] = ACTIONS(1164),
    [anon_sym_public] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(1164),
    [anon_sym_try] = ACTIONS(1164),
    [anon_sym_untyped] = ACTIONS(1164),
    [anon_sym_while] = ACTIONS(1164),
    [sym__semicolon] = ACTIONS(1162),
  },
  [227] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_POUND] = ACTIONS(1166),
    [anon_sym_package] = ACTIONS(1168),
    [anon_sym_import] = ACTIONS(1168),
    [anon_sym_using] = ACTIONS(1168),
    [anon_sym_throw] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_case] = ACTIONS(1168),
    [anon_sym_default] = ACTIONS(1168),
    [anon_sym_cast] = ACTIONS(1168),
    [anon_sym_DOLLARtype] = ACTIONS(1166),
    [anon_sym_in] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_this] = ACTIONS(1168),
    [anon_sym_AT] = ACTIONS(1168),
    [anon_sym_AT_COLON] = ACTIONS(1166),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_else] = ACTIONS(1168),
    [anon_sym_new] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_PERCENT] = ACTIONS(1166),
    [anon_sym_STAR] = ACTIONS(1166),
    [anon_sym_SLASH] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_LT_LT] = ACTIONS(1166),
    [anon_sym_GT_GT] = ACTIONS(1168),
    [anon_sym_GT_GT_GT] = ACTIONS(1166),
    [anon_sym_AMP] = ACTIONS(1168),
    [anon_sym_PIPE] = ACTIONS(1168),
    [anon_sym_CARET] = ACTIONS(1166),
    [anon_sym_AMP_AMP] = ACTIONS(1166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_EQ_EQ] = ACTIONS(1166),
    [anon_sym_BANG_EQ] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(1168),
    [anon_sym_LT_EQ] = ACTIONS(1166),
    [anon_sym_GT] = ACTIONS(1168),
    [anon_sym_GT_EQ] = ACTIONS(1166),
    [anon_sym_EQ_GT] = ACTIONS(1166),
    [anon_sym_QMARK_QMARK] = ACTIONS(1166),
    [anon_sym_EQ] = ACTIONS(1168),
    [sym__rangeOperator] = ACTIONS(1166),
    [anon_sym_null] = ACTIONS(1168),
    [anon_sym_dynamic] = ACTIONS(1168),
    [anon_sym_final] = ACTIONS(1168),
    [anon_sym_abstract] = ACTIONS(1168),
    [anon_sym_class] = ACTIONS(1168),
    [anon_sym_extends] = ACTIONS(1168),
    [anon_sym_implements] = ACTIONS(1168),
    [anon_sym_interface] = ACTIONS(1168),
    [anon_sym_typedef] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_var] = ACTIONS(1168),
    [aux_sym_integer_token1] = ACTIONS(1168),
    [aux_sym_integer_token2] = ACTIONS(1166),
    [aux_sym_float_token1] = ACTIONS(1168),
    [aux_sym_float_token2] = ACTIONS(1166),
    [anon_sym_true] = ACTIONS(1168),
    [anon_sym_false] = ACTIONS(1168),
    [aux_sym_string_token1] = ACTIONS(1166),
    [aux_sym_string_token3] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_catch] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1168),
    [anon_sym_enum] = ACTIONS(1168),
    [anon_sym_extern] = ACTIONS(1168),
    [anon_sym_for] = ACTIONS(1168),
    [anon_sym_inline] = ACTIONS(1168),
    [anon_sym_macro] = ACTIONS(1168),
    [anon_sym_operator] = ACTIONS(1168),
    [anon_sym_overload] = ACTIONS(1168),
    [anon_sym_override] = ACTIONS(1168),
    [anon_sym_private] = ACTIONS(1168),
    [anon_sym_public] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_static] = ACTIONS(1168),
    [anon_sym_try] = ACTIONS(1168),
    [anon_sym_untyped] = ACTIONS(1168),
    [anon_sym_while] = ACTIONS(1168),
    [sym__semicolon] = ACTIONS(1166),
  },
  [228] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_POUND] = ACTIONS(1170),
    [anon_sym_package] = ACTIONS(1172),
    [anon_sym_import] = ACTIONS(1172),
    [anon_sym_using] = ACTIONS(1172),
    [anon_sym_throw] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [anon_sym_switch] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_case] = ACTIONS(1172),
    [anon_sym_default] = ACTIONS(1172),
    [anon_sym_cast] = ACTIONS(1172),
    [anon_sym_DOLLARtype] = ACTIONS(1170),
    [anon_sym_in] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_this] = ACTIONS(1172),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_AT_COLON] = ACTIONS(1170),
    [anon_sym_if] = ACTIONS(1172),
    [anon_sym_else] = ACTIONS(1172),
    [anon_sym_new] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_PERCENT] = ACTIONS(1170),
    [anon_sym_STAR] = ACTIONS(1170),
    [anon_sym_SLASH] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_LT_LT] = ACTIONS(1170),
    [anon_sym_GT_GT] = ACTIONS(1172),
    [anon_sym_GT_GT_GT] = ACTIONS(1170),
    [anon_sym_AMP] = ACTIONS(1172),
    [anon_sym_PIPE] = ACTIONS(1172),
    [anon_sym_CARET] = ACTIONS(1170),
    [anon_sym_AMP_AMP] = ACTIONS(1170),
    [anon_sym_PIPE_PIPE] = ACTIONS(1170),
    [anon_sym_EQ_EQ] = ACTIONS(1170),
    [anon_sym_BANG_EQ] = ACTIONS(1170),
    [anon_sym_LT] = ACTIONS(1172),
    [anon_sym_LT_EQ] = ACTIONS(1170),
    [anon_sym_GT] = ACTIONS(1172),
    [anon_sym_GT_EQ] = ACTIONS(1170),
    [anon_sym_EQ_GT] = ACTIONS(1170),
    [anon_sym_QMARK_QMARK] = ACTIONS(1170),
    [anon_sym_EQ] = ACTIONS(1172),
    [sym__rangeOperator] = ACTIONS(1170),
    [anon_sym_null] = ACTIONS(1172),
    [anon_sym_dynamic] = ACTIONS(1172),
    [anon_sym_final] = ACTIONS(1172),
    [anon_sym_abstract] = ACTIONS(1172),
    [anon_sym_class] = ACTIONS(1172),
    [anon_sym_extends] = ACTIONS(1172),
    [anon_sym_implements] = ACTIONS(1172),
    [anon_sym_interface] = ACTIONS(1172),
    [anon_sym_typedef] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(1172),
    [anon_sym_var] = ACTIONS(1172),
    [aux_sym_integer_token1] = ACTIONS(1172),
    [aux_sym_integer_token2] = ACTIONS(1170),
    [aux_sym_float_token1] = ACTIONS(1172),
    [aux_sym_float_token2] = ACTIONS(1170),
    [anon_sym_true] = ACTIONS(1172),
    [anon_sym_false] = ACTIONS(1172),
    [aux_sym_string_token1] = ACTIONS(1170),
    [aux_sym_string_token3] = ACTIONS(1170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_catch] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [anon_sym_do] = ACTIONS(1172),
    [anon_sym_enum] = ACTIONS(1172),
    [anon_sym_extern] = ACTIONS(1172),
    [anon_sym_for] = ACTIONS(1172),
    [anon_sym_inline] = ACTIONS(1172),
    [anon_sym_macro] = ACTIONS(1172),
    [anon_sym_operator] = ACTIONS(1172),
    [anon_sym_overload] = ACTIONS(1172),
    [anon_sym_override] = ACTIONS(1172),
    [anon_sym_private] = ACTIONS(1172),
    [anon_sym_public] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_static] = ACTIONS(1172),
    [anon_sym_try] = ACTIONS(1172),
    [anon_sym_untyped] = ACTIONS(1172),
    [anon_sym_while] = ACTIONS(1172),
    [sym__semicolon] = ACTIONS(1170),
  },
  [229] = {
    [ts_builtin_sym_end] = ACTIONS(1174),
    [sym_identifier] = ACTIONS(1176),
    [anon_sym_POUND] = ACTIONS(1174),
    [anon_sym_package] = ACTIONS(1176),
    [anon_sym_import] = ACTIONS(1176),
    [anon_sym_using] = ACTIONS(1176),
    [anon_sym_throw] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_switch] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1174),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [anon_sym_case] = ACTIONS(1176),
    [anon_sym_default] = ACTIONS(1176),
    [anon_sym_cast] = ACTIONS(1176),
    [anon_sym_DOLLARtype] = ACTIONS(1174),
    [anon_sym_in] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1174),
    [anon_sym_this] = ACTIONS(1176),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_AT_COLON] = ACTIONS(1174),
    [anon_sym_if] = ACTIONS(1176),
    [anon_sym_else] = ACTIONS(1176),
    [anon_sym_new] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_BANG] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_PLUS_PLUS] = ACTIONS(1174),
    [anon_sym_DASH_DASH] = ACTIONS(1174),
    [anon_sym_PERCENT] = ACTIONS(1174),
    [anon_sym_STAR] = ACTIONS(1174),
    [anon_sym_SLASH] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_LT_LT] = ACTIONS(1174),
    [anon_sym_GT_GT] = ACTIONS(1176),
    [anon_sym_GT_GT_GT] = ACTIONS(1174),
    [anon_sym_AMP] = ACTIONS(1176),
    [anon_sym_PIPE] = ACTIONS(1176),
    [anon_sym_CARET] = ACTIONS(1174),
    [anon_sym_AMP_AMP] = ACTIONS(1174),
    [anon_sym_PIPE_PIPE] = ACTIONS(1174),
    [anon_sym_EQ_EQ] = ACTIONS(1174),
    [anon_sym_BANG_EQ] = ACTIONS(1174),
    [anon_sym_LT] = ACTIONS(1176),
    [anon_sym_LT_EQ] = ACTIONS(1174),
    [anon_sym_GT] = ACTIONS(1176),
    [anon_sym_GT_EQ] = ACTIONS(1174),
    [anon_sym_EQ_GT] = ACTIONS(1174),
    [anon_sym_QMARK_QMARK] = ACTIONS(1174),
    [anon_sym_EQ] = ACTIONS(1176),
    [sym__rangeOperator] = ACTIONS(1174),
    [anon_sym_null] = ACTIONS(1176),
    [anon_sym_dynamic] = ACTIONS(1176),
    [anon_sym_final] = ACTIONS(1176),
    [anon_sym_abstract] = ACTIONS(1176),
    [anon_sym_class] = ACTIONS(1176),
    [anon_sym_extends] = ACTIONS(1176),
    [anon_sym_implements] = ACTIONS(1176),
    [anon_sym_interface] = ACTIONS(1176),
    [anon_sym_typedef] = ACTIONS(1176),
    [anon_sym_function] = ACTIONS(1176),
    [anon_sym_var] = ACTIONS(1176),
    [aux_sym_integer_token1] = ACTIONS(1176),
    [aux_sym_integer_token2] = ACTIONS(1174),
    [aux_sym_float_token1] = ACTIONS(1176),
    [aux_sym_float_token2] = ACTIONS(1174),
    [anon_sym_true] = ACTIONS(1176),
    [anon_sym_false] = ACTIONS(1176),
    [aux_sym_string_token1] = ACTIONS(1174),
    [aux_sym_string_token3] = ACTIONS(1174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1176),
    [anon_sym_catch] = ACTIONS(1176),
    [anon_sym_continue] = ACTIONS(1176),
    [anon_sym_do] = ACTIONS(1176),
    [anon_sym_enum] = ACTIONS(1176),
    [anon_sym_extern] = ACTIONS(1176),
    [anon_sym_for] = ACTIONS(1176),
    [anon_sym_inline] = ACTIONS(1176),
    [anon_sym_macro] = ACTIONS(1176),
    [anon_sym_operator] = ACTIONS(1176),
    [anon_sym_overload] = ACTIONS(1176),
    [anon_sym_override] = ACTIONS(1176),
    [anon_sym_private] = ACTIONS(1176),
    [anon_sym_public] = ACTIONS(1176),
    [anon_sym_return] = ACTIONS(1176),
    [anon_sym_static] = ACTIONS(1176),
    [anon_sym_try] = ACTIONS(1176),
    [anon_sym_untyped] = ACTIONS(1176),
    [anon_sym_while] = ACTIONS(1176),
    [sym__semicolon] = ACTIONS(1174),
  },
  [230] = {
    [ts_builtin_sym_end] = ACTIONS(1178),
    [sym_identifier] = ACTIONS(1180),
    [anon_sym_POUND] = ACTIONS(1178),
    [anon_sym_package] = ACTIONS(1180),
    [anon_sym_import] = ACTIONS(1180),
    [anon_sym_using] = ACTIONS(1180),
    [anon_sym_throw] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [anon_sym_switch] = ACTIONS(1180),
    [anon_sym_LBRACE] = ACTIONS(1178),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [anon_sym_case] = ACTIONS(1180),
    [anon_sym_default] = ACTIONS(1180),
    [anon_sym_cast] = ACTIONS(1180),
    [anon_sym_DOLLARtype] = ACTIONS(1178),
    [anon_sym_in] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1178),
    [anon_sym_this] = ACTIONS(1180),
    [anon_sym_AT] = ACTIONS(1180),
    [anon_sym_AT_COLON] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1180),
    [anon_sym_else] = ACTIONS(1180),
    [anon_sym_new] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1180),
    [anon_sym_PLUS_PLUS] = ACTIONS(1178),
    [anon_sym_DASH_DASH] = ACTIONS(1178),
    [anon_sym_PERCENT] = ACTIONS(1178),
    [anon_sym_STAR] = ACTIONS(1178),
    [anon_sym_SLASH] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1180),
    [anon_sym_LT_LT] = ACTIONS(1178),
    [anon_sym_GT_GT] = ACTIONS(1180),
    [anon_sym_GT_GT_GT] = ACTIONS(1178),
    [anon_sym_AMP] = ACTIONS(1180),
    [anon_sym_PIPE] = ACTIONS(1180),
    [anon_sym_CARET] = ACTIONS(1178),
    [anon_sym_AMP_AMP] = ACTIONS(1178),
    [anon_sym_PIPE_PIPE] = ACTIONS(1178),
    [anon_sym_EQ_EQ] = ACTIONS(1178),
    [anon_sym_BANG_EQ] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_LT_EQ] = ACTIONS(1178),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_GT_EQ] = ACTIONS(1178),
    [anon_sym_EQ_GT] = ACTIONS(1178),
    [anon_sym_QMARK_QMARK] = ACTIONS(1178),
    [anon_sym_EQ] = ACTIONS(1180),
    [sym__rangeOperator] = ACTIONS(1178),
    [anon_sym_null] = ACTIONS(1180),
    [anon_sym_dynamic] = ACTIONS(1180),
    [anon_sym_final] = ACTIONS(1180),
    [anon_sym_abstract] = ACTIONS(1180),
    [anon_sym_class] = ACTIONS(1180),
    [anon_sym_extends] = ACTIONS(1180),
    [anon_sym_implements] = ACTIONS(1180),
    [anon_sym_interface] = ACTIONS(1180),
    [anon_sym_typedef] = ACTIONS(1180),
    [anon_sym_function] = ACTIONS(1180),
    [anon_sym_var] = ACTIONS(1180),
    [aux_sym_integer_token1] = ACTIONS(1180),
    [aux_sym_integer_token2] = ACTIONS(1178),
    [aux_sym_float_token1] = ACTIONS(1180),
    [aux_sym_float_token2] = ACTIONS(1178),
    [anon_sym_true] = ACTIONS(1180),
    [anon_sym_false] = ACTIONS(1180),
    [aux_sym_string_token1] = ACTIONS(1178),
    [aux_sym_string_token3] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1180),
    [anon_sym_catch] = ACTIONS(1180),
    [anon_sym_continue] = ACTIONS(1180),
    [anon_sym_do] = ACTIONS(1180),
    [anon_sym_enum] = ACTIONS(1180),
    [anon_sym_extern] = ACTIONS(1180),
    [anon_sym_for] = ACTIONS(1180),
    [anon_sym_inline] = ACTIONS(1180),
    [anon_sym_macro] = ACTIONS(1180),
    [anon_sym_operator] = ACTIONS(1180),
    [anon_sym_overload] = ACTIONS(1180),
    [anon_sym_override] = ACTIONS(1180),
    [anon_sym_private] = ACTIONS(1180),
    [anon_sym_public] = ACTIONS(1180),
    [anon_sym_return] = ACTIONS(1180),
    [anon_sym_static] = ACTIONS(1180),
    [anon_sym_try] = ACTIONS(1180),
    [anon_sym_untyped] = ACTIONS(1180),
    [anon_sym_while] = ACTIONS(1180),
    [sym__semicolon] = ACTIONS(1178),
  },
  [231] = {
    [ts_builtin_sym_end] = ACTIONS(1182),
    [sym_identifier] = ACTIONS(1184),
    [anon_sym_POUND] = ACTIONS(1182),
    [anon_sym_package] = ACTIONS(1184),
    [anon_sym_import] = ACTIONS(1184),
    [anon_sym_using] = ACTIONS(1184),
    [anon_sym_throw] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [anon_sym_switch] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [anon_sym_case] = ACTIONS(1184),
    [anon_sym_default] = ACTIONS(1184),
    [anon_sym_cast] = ACTIONS(1184),
    [anon_sym_DOLLARtype] = ACTIONS(1182),
    [anon_sym_in] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1182),
    [anon_sym_this] = ACTIONS(1184),
    [anon_sym_AT] = ACTIONS(1184),
    [anon_sym_AT_COLON] = ACTIONS(1182),
    [anon_sym_if] = ACTIONS(1184),
    [anon_sym_else] = ACTIONS(1184),
    [anon_sym_new] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PERCENT] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1182),
    [anon_sym_SLASH] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_LT_LT] = ACTIONS(1182),
    [anon_sym_GT_GT] = ACTIONS(1184),
    [anon_sym_GT_GT_GT] = ACTIONS(1182),
    [anon_sym_AMP] = ACTIONS(1184),
    [anon_sym_PIPE] = ACTIONS(1184),
    [anon_sym_CARET] = ACTIONS(1182),
    [anon_sym_AMP_AMP] = ACTIONS(1182),
    [anon_sym_PIPE_PIPE] = ACTIONS(1182),
    [anon_sym_EQ_EQ] = ACTIONS(1182),
    [anon_sym_BANG_EQ] = ACTIONS(1182),
    [anon_sym_LT] = ACTIONS(1184),
    [anon_sym_LT_EQ] = ACTIONS(1182),
    [anon_sym_GT] = ACTIONS(1184),
    [anon_sym_GT_EQ] = ACTIONS(1182),
    [anon_sym_EQ_GT] = ACTIONS(1182),
    [anon_sym_QMARK_QMARK] = ACTIONS(1182),
    [anon_sym_EQ] = ACTIONS(1184),
    [sym__rangeOperator] = ACTIONS(1182),
    [anon_sym_null] = ACTIONS(1184),
    [anon_sym_dynamic] = ACTIONS(1184),
    [anon_sym_final] = ACTIONS(1184),
    [anon_sym_abstract] = ACTIONS(1184),
    [anon_sym_class] = ACTIONS(1184),
    [anon_sym_extends] = ACTIONS(1184),
    [anon_sym_implements] = ACTIONS(1184),
    [anon_sym_interface] = ACTIONS(1184),
    [anon_sym_typedef] = ACTIONS(1184),
    [anon_sym_function] = ACTIONS(1184),
    [anon_sym_var] = ACTIONS(1184),
    [aux_sym_integer_token1] = ACTIONS(1184),
    [aux_sym_integer_token2] = ACTIONS(1182),
    [aux_sym_float_token1] = ACTIONS(1184),
    [aux_sym_float_token2] = ACTIONS(1182),
    [anon_sym_true] = ACTIONS(1184),
    [anon_sym_false] = ACTIONS(1184),
    [aux_sym_string_token1] = ACTIONS(1182),
    [aux_sym_string_token3] = ACTIONS(1182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1184),
    [anon_sym_catch] = ACTIONS(1184),
    [anon_sym_continue] = ACTIONS(1184),
    [anon_sym_do] = ACTIONS(1184),
    [anon_sym_enum] = ACTIONS(1184),
    [anon_sym_extern] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1184),
    [anon_sym_inline] = ACTIONS(1184),
    [anon_sym_macro] = ACTIONS(1184),
    [anon_sym_operator] = ACTIONS(1184),
    [anon_sym_overload] = ACTIONS(1184),
    [anon_sym_override] = ACTIONS(1184),
    [anon_sym_private] = ACTIONS(1184),
    [anon_sym_public] = ACTIONS(1184),
    [anon_sym_return] = ACTIONS(1184),
    [anon_sym_static] = ACTIONS(1184),
    [anon_sym_try] = ACTIONS(1184),
    [anon_sym_untyped] = ACTIONS(1184),
    [anon_sym_while] = ACTIONS(1184),
    [sym__semicolon] = ACTIONS(1182),
  },
  [232] = {
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_POUND] = ACTIONS(1186),
    [anon_sym_package] = ACTIONS(1188),
    [anon_sym_import] = ACTIONS(1188),
    [anon_sym_using] = ACTIONS(1188),
    [anon_sym_throw] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [anon_sym_switch] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [anon_sym_case] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1188),
    [anon_sym_cast] = ACTIONS(1188),
    [anon_sym_DOLLARtype] = ACTIONS(1186),
    [anon_sym_in] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_this] = ACTIONS(1188),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_AT_COLON] = ACTIONS(1186),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PERCENT] = ACTIONS(1186),
    [anon_sym_STAR] = ACTIONS(1186),
    [anon_sym_SLASH] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_LT_LT] = ACTIONS(1186),
    [anon_sym_GT_GT] = ACTIONS(1188),
    [anon_sym_GT_GT_GT] = ACTIONS(1186),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1188),
    [anon_sym_CARET] = ACTIONS(1186),
    [anon_sym_AMP_AMP] = ACTIONS(1186),
    [anon_sym_PIPE_PIPE] = ACTIONS(1186),
    [anon_sym_EQ_EQ] = ACTIONS(1186),
    [anon_sym_BANG_EQ] = ACTIONS(1186),
    [anon_sym_LT] = ACTIONS(1188),
    [anon_sym_LT_EQ] = ACTIONS(1186),
    [anon_sym_GT] = ACTIONS(1188),
    [anon_sym_GT_EQ] = ACTIONS(1186),
    [anon_sym_EQ_GT] = ACTIONS(1186),
    [anon_sym_QMARK_QMARK] = ACTIONS(1186),
    [anon_sym_EQ] = ACTIONS(1188),
    [sym__rangeOperator] = ACTIONS(1186),
    [anon_sym_null] = ACTIONS(1188),
    [anon_sym_dynamic] = ACTIONS(1188),
    [anon_sym_final] = ACTIONS(1188),
    [anon_sym_abstract] = ACTIONS(1188),
    [anon_sym_class] = ACTIONS(1188),
    [anon_sym_extends] = ACTIONS(1188),
    [anon_sym_implements] = ACTIONS(1188),
    [anon_sym_interface] = ACTIONS(1188),
    [anon_sym_typedef] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [aux_sym_integer_token1] = ACTIONS(1188),
    [aux_sym_integer_token2] = ACTIONS(1186),
    [aux_sym_float_token1] = ACTIONS(1188),
    [aux_sym_float_token2] = ACTIONS(1186),
    [anon_sym_true] = ACTIONS(1188),
    [anon_sym_false] = ACTIONS(1188),
    [aux_sym_string_token1] = ACTIONS(1186),
    [aux_sym_string_token3] = ACTIONS(1186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_catch] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_enum] = ACTIONS(1188),
    [anon_sym_extern] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_inline] = ACTIONS(1188),
    [anon_sym_macro] = ACTIONS(1188),
    [anon_sym_operator] = ACTIONS(1188),
    [anon_sym_overload] = ACTIONS(1188),
    [anon_sym_override] = ACTIONS(1188),
    [anon_sym_private] = ACTIONS(1188),
    [anon_sym_public] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_static] = ACTIONS(1188),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_untyped] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [sym__semicolon] = ACTIONS(1186),
  },
  [233] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_POUND] = ACTIONS(1190),
    [anon_sym_package] = ACTIONS(1192),
    [anon_sym_import] = ACTIONS(1192),
    [anon_sym_using] = ACTIONS(1192),
    [anon_sym_throw] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_switch] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_case] = ACTIONS(1192),
    [anon_sym_default] = ACTIONS(1192),
    [anon_sym_cast] = ACTIONS(1192),
    [anon_sym_DOLLARtype] = ACTIONS(1190),
    [anon_sym_in] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_this] = ACTIONS(1192),
    [anon_sym_AT] = ACTIONS(1192),
    [anon_sym_AT_COLON] = ACTIONS(1190),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_new] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_GT_GT_GT] = ACTIONS(1190),
    [anon_sym_AMP] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1190),
    [anon_sym_AMP_AMP] = ACTIONS(1190),
    [anon_sym_PIPE_PIPE] = ACTIONS(1190),
    [anon_sym_EQ_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1192),
    [anon_sym_LT_EQ] = ACTIONS(1190),
    [anon_sym_GT] = ACTIONS(1192),
    [anon_sym_GT_EQ] = ACTIONS(1190),
    [anon_sym_EQ_GT] = ACTIONS(1190),
    [anon_sym_QMARK_QMARK] = ACTIONS(1190),
    [anon_sym_EQ] = ACTIONS(1192),
    [sym__rangeOperator] = ACTIONS(1190),
    [anon_sym_null] = ACTIONS(1192),
    [anon_sym_dynamic] = ACTIONS(1192),
    [anon_sym_final] = ACTIONS(1192),
    [anon_sym_abstract] = ACTIONS(1192),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_extends] = ACTIONS(1192),
    [anon_sym_implements] = ACTIONS(1192),
    [anon_sym_interface] = ACTIONS(1192),
    [anon_sym_typedef] = ACTIONS(1192),
    [anon_sym_function] = ACTIONS(1192),
    [anon_sym_var] = ACTIONS(1192),
    [aux_sym_integer_token1] = ACTIONS(1192),
    [aux_sym_integer_token2] = ACTIONS(1190),
    [aux_sym_float_token1] = ACTIONS(1192),
    [aux_sym_float_token2] = ACTIONS(1190),
    [anon_sym_true] = ACTIONS(1192),
    [anon_sym_false] = ACTIONS(1192),
    [aux_sym_string_token1] = ACTIONS(1190),
    [aux_sym_string_token3] = ACTIONS(1190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_catch] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_do] = ACTIONS(1192),
    [anon_sym_enum] = ACTIONS(1192),
    [anon_sym_extern] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_inline] = ACTIONS(1192),
    [anon_sym_macro] = ACTIONS(1192),
    [anon_sym_operator] = ACTIONS(1192),
    [anon_sym_overload] = ACTIONS(1192),
    [anon_sym_override] = ACTIONS(1192),
    [anon_sym_private] = ACTIONS(1192),
    [anon_sym_public] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_static] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_untyped] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [sym__semicolon] = ACTIONS(1190),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_POUND] = ACTIONS(1194),
    [anon_sym_package] = ACTIONS(1196),
    [anon_sym_import] = ACTIONS(1196),
    [anon_sym_using] = ACTIONS(1196),
    [anon_sym_throw] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_switch] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_case] = ACTIONS(1196),
    [anon_sym_default] = ACTIONS(1196),
    [anon_sym_cast] = ACTIONS(1196),
    [anon_sym_DOLLARtype] = ACTIONS(1194),
    [anon_sym_in] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_this] = ACTIONS(1196),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_AT_COLON] = ACTIONS(1194),
    [anon_sym_if] = ACTIONS(1196),
    [anon_sym_else] = ACTIONS(1196),
    [anon_sym_new] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_PLUS_PLUS] = ACTIONS(1194),
    [anon_sym_DASH_DASH] = ACTIONS(1194),
    [anon_sym_PERCENT] = ACTIONS(1194),
    [anon_sym_STAR] = ACTIONS(1194),
    [anon_sym_SLASH] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_GT_GT_GT] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1196),
    [anon_sym_CARET] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_EQ_EQ] = ACTIONS(1194),
    [anon_sym_BANG_EQ] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1196),
    [anon_sym_LT_EQ] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1196),
    [anon_sym_GT_EQ] = ACTIONS(1194),
    [anon_sym_EQ_GT] = ACTIONS(1194),
    [anon_sym_QMARK_QMARK] = ACTIONS(1194),
    [anon_sym_EQ] = ACTIONS(1196),
    [sym__rangeOperator] = ACTIONS(1194),
    [anon_sym_null] = ACTIONS(1196),
    [anon_sym_dynamic] = ACTIONS(1196),
    [anon_sym_final] = ACTIONS(1196),
    [anon_sym_abstract] = ACTIONS(1196),
    [anon_sym_class] = ACTIONS(1196),
    [anon_sym_extends] = ACTIONS(1196),
    [anon_sym_implements] = ACTIONS(1196),
    [anon_sym_interface] = ACTIONS(1196),
    [anon_sym_typedef] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(1196),
    [anon_sym_var] = ACTIONS(1196),
    [aux_sym_integer_token1] = ACTIONS(1196),
    [aux_sym_integer_token2] = ACTIONS(1194),
    [aux_sym_float_token1] = ACTIONS(1196),
    [aux_sym_float_token2] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [aux_sym_string_token1] = ACTIONS(1194),
    [aux_sym_string_token3] = ACTIONS(1194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_catch] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [anon_sym_do] = ACTIONS(1196),
    [anon_sym_enum] = ACTIONS(1196),
    [anon_sym_extern] = ACTIONS(1196),
    [anon_sym_for] = ACTIONS(1196),
    [anon_sym_inline] = ACTIONS(1196),
    [anon_sym_macro] = ACTIONS(1196),
    [anon_sym_operator] = ACTIONS(1196),
    [anon_sym_overload] = ACTIONS(1196),
    [anon_sym_override] = ACTIONS(1196),
    [anon_sym_private] = ACTIONS(1196),
    [anon_sym_public] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_static] = ACTIONS(1196),
    [anon_sym_try] = ACTIONS(1196),
    [anon_sym_untyped] = ACTIONS(1196),
    [anon_sym_while] = ACTIONS(1196),
    [sym__semicolon] = ACTIONS(1194),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [anon_sym_POUND] = ACTIONS(1198),
    [anon_sym_package] = ACTIONS(1200),
    [anon_sym_import] = ACTIONS(1200),
    [anon_sym_using] = ACTIONS(1200),
    [anon_sym_throw] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_switch] = ACTIONS(1200),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_case] = ACTIONS(1200),
    [anon_sym_default] = ACTIONS(1200),
    [anon_sym_cast] = ACTIONS(1200),
    [anon_sym_DOLLARtype] = ACTIONS(1198),
    [anon_sym_in] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_this] = ACTIONS(1200),
    [anon_sym_AT] = ACTIONS(1200),
    [anon_sym_AT_COLON] = ACTIONS(1198),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(1200),
    [anon_sym_new] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1200),
    [anon_sym_PLUS_PLUS] = ACTIONS(1198),
    [anon_sym_DASH_DASH] = ACTIONS(1198),
    [anon_sym_PERCENT] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_SLASH] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1200),
    [anon_sym_LT_LT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1200),
    [anon_sym_GT_GT_GT] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1200),
    [anon_sym_PIPE] = ACTIONS(1200),
    [anon_sym_CARET] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_PIPE_PIPE] = ACTIONS(1198),
    [anon_sym_EQ_EQ] = ACTIONS(1198),
    [anon_sym_BANG_EQ] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1200),
    [anon_sym_LT_EQ] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1200),
    [anon_sym_GT_EQ] = ACTIONS(1198),
    [anon_sym_EQ_GT] = ACTIONS(1198),
    [anon_sym_QMARK_QMARK] = ACTIONS(1198),
    [anon_sym_EQ] = ACTIONS(1200),
    [sym__rangeOperator] = ACTIONS(1198),
    [anon_sym_null] = ACTIONS(1200),
    [anon_sym_dynamic] = ACTIONS(1200),
    [anon_sym_final] = ACTIONS(1200),
    [anon_sym_abstract] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(1200),
    [anon_sym_extends] = ACTIONS(1200),
    [anon_sym_implements] = ACTIONS(1200),
    [anon_sym_interface] = ACTIONS(1200),
    [anon_sym_typedef] = ACTIONS(1200),
    [anon_sym_function] = ACTIONS(1200),
    [anon_sym_var] = ACTIONS(1200),
    [aux_sym_integer_token1] = ACTIONS(1200),
    [aux_sym_integer_token2] = ACTIONS(1198),
    [aux_sym_float_token1] = ACTIONS(1200),
    [aux_sym_float_token2] = ACTIONS(1198),
    [anon_sym_true] = ACTIONS(1200),
    [anon_sym_false] = ACTIONS(1200),
    [aux_sym_string_token1] = ACTIONS(1198),
    [aux_sym_string_token3] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_catch] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_do] = ACTIONS(1200),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_extern] = ACTIONS(1200),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_inline] = ACTIONS(1200),
    [anon_sym_macro] = ACTIONS(1200),
    [anon_sym_operator] = ACTIONS(1200),
    [anon_sym_overload] = ACTIONS(1200),
    [anon_sym_override] = ACTIONS(1200),
    [anon_sym_private] = ACTIONS(1200),
    [anon_sym_public] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_static] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_untyped] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [sym__semicolon] = ACTIONS(1198),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_POUND] = ACTIONS(1202),
    [anon_sym_package] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(1204),
    [anon_sym_using] = ACTIONS(1204),
    [anon_sym_throw] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [anon_sym_switch] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [anon_sym_case] = ACTIONS(1204),
    [anon_sym_default] = ACTIONS(1204),
    [anon_sym_cast] = ACTIONS(1204),
    [anon_sym_DOLLARtype] = ACTIONS(1202),
    [anon_sym_in] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_this] = ACTIONS(1204),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_AT_COLON] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(1204),
    [anon_sym_else] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_PERCENT] = ACTIONS(1202),
    [anon_sym_STAR] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [anon_sym_GT_GT_GT] = ACTIONS(1202),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_CARET] = ACTIONS(1202),
    [anon_sym_AMP_AMP] = ACTIONS(1202),
    [anon_sym_PIPE_PIPE] = ACTIONS(1202),
    [anon_sym_EQ_EQ] = ACTIONS(1202),
    [anon_sym_BANG_EQ] = ACTIONS(1202),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_EQ] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_GT_EQ] = ACTIONS(1202),
    [anon_sym_EQ_GT] = ACTIONS(1202),
    [anon_sym_QMARK_QMARK] = ACTIONS(1202),
    [anon_sym_EQ] = ACTIONS(1204),
    [sym__rangeOperator] = ACTIONS(1202),
    [anon_sym_null] = ACTIONS(1204),
    [anon_sym_dynamic] = ACTIONS(1204),
    [anon_sym_final] = ACTIONS(1204),
    [anon_sym_abstract] = ACTIONS(1204),
    [anon_sym_class] = ACTIONS(1204),
    [anon_sym_extends] = ACTIONS(1204),
    [anon_sym_implements] = ACTIONS(1204),
    [anon_sym_interface] = ACTIONS(1204),
    [anon_sym_typedef] = ACTIONS(1204),
    [anon_sym_function] = ACTIONS(1204),
    [anon_sym_var] = ACTIONS(1204),
    [aux_sym_integer_token1] = ACTIONS(1204),
    [aux_sym_integer_token2] = ACTIONS(1202),
    [aux_sym_float_token1] = ACTIONS(1204),
    [aux_sym_float_token2] = ACTIONS(1202),
    [anon_sym_true] = ACTIONS(1204),
    [anon_sym_false] = ACTIONS(1204),
    [aux_sym_string_token1] = ACTIONS(1202),
    [aux_sym_string_token3] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_catch] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_enum] = ACTIONS(1204),
    [anon_sym_extern] = ACTIONS(1204),
    [anon_sym_for] = ACTIONS(1204),
    [anon_sym_inline] = ACTIONS(1204),
    [anon_sym_macro] = ACTIONS(1204),
    [anon_sym_operator] = ACTIONS(1204),
    [anon_sym_overload] = ACTIONS(1204),
    [anon_sym_override] = ACTIONS(1204),
    [anon_sym_private] = ACTIONS(1204),
    [anon_sym_public] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_static] = ACTIONS(1204),
    [anon_sym_try] = ACTIONS(1204),
    [anon_sym_untyped] = ACTIONS(1204),
    [anon_sym_while] = ACTIONS(1204),
    [sym__semicolon] = ACTIONS(1202),
  },
  [237] = {
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_package] = ACTIONS(1208),
    [anon_sym_import] = ACTIONS(1208),
    [anon_sym_using] = ACTIONS(1208),
    [anon_sym_throw] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [anon_sym_switch] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_case] = ACTIONS(1208),
    [anon_sym_default] = ACTIONS(1208),
    [anon_sym_cast] = ACTIONS(1208),
    [anon_sym_DOLLARtype] = ACTIONS(1206),
    [anon_sym_in] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_this] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_AT_COLON] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_else] = ACTIONS(1208),
    [anon_sym_new] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1206),
    [anon_sym_STAR] = ACTIONS(1206),
    [anon_sym_SLASH] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1208),
    [anon_sym_GT_GT_GT] = ACTIONS(1206),
    [anon_sym_AMP] = ACTIONS(1208),
    [anon_sym_PIPE] = ACTIONS(1208),
    [anon_sym_CARET] = ACTIONS(1206),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1208),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_EQ_GT] = ACTIONS(1206),
    [anon_sym_QMARK_QMARK] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1208),
    [sym__rangeOperator] = ACTIONS(1206),
    [anon_sym_null] = ACTIONS(1208),
    [anon_sym_dynamic] = ACTIONS(1208),
    [anon_sym_final] = ACTIONS(1208),
    [anon_sym_abstract] = ACTIONS(1208),
    [anon_sym_class] = ACTIONS(1208),
    [anon_sym_extends] = ACTIONS(1208),
    [anon_sym_implements] = ACTIONS(1208),
    [anon_sym_interface] = ACTIONS(1208),
    [anon_sym_typedef] = ACTIONS(1208),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_var] = ACTIONS(1208),
    [aux_sym_integer_token1] = ACTIONS(1208),
    [aux_sym_integer_token2] = ACTIONS(1206),
    [aux_sym_float_token1] = ACTIONS(1208),
    [aux_sym_float_token2] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [aux_sym_string_token1] = ACTIONS(1206),
    [aux_sym_string_token3] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_catch] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [anon_sym_do] = ACTIONS(1208),
    [anon_sym_enum] = ACTIONS(1208),
    [anon_sym_extern] = ACTIONS(1208),
    [anon_sym_for] = ACTIONS(1208),
    [anon_sym_inline] = ACTIONS(1208),
    [anon_sym_macro] = ACTIONS(1208),
    [anon_sym_operator] = ACTIONS(1208),
    [anon_sym_overload] = ACTIONS(1208),
    [anon_sym_override] = ACTIONS(1208),
    [anon_sym_private] = ACTIONS(1208),
    [anon_sym_public] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_static] = ACTIONS(1208),
    [anon_sym_try] = ACTIONS(1208),
    [anon_sym_untyped] = ACTIONS(1208),
    [anon_sym_while] = ACTIONS(1208),
    [sym__semicolon] = ACTIONS(1206),
  },
  [238] = {
    [ts_builtin_sym_end] = ACTIONS(1210),
    [sym_identifier] = ACTIONS(1212),
    [anon_sym_POUND] = ACTIONS(1210),
    [anon_sym_package] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_using] = ACTIONS(1212),
    [anon_sym_throw] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [anon_sym_switch] = ACTIONS(1212),
    [anon_sym_LBRACE] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_case] = ACTIONS(1212),
    [anon_sym_default] = ACTIONS(1212),
    [anon_sym_cast] = ACTIONS(1212),
    [anon_sym_DOLLARtype] = ACTIONS(1210),
    [anon_sym_in] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1210),
    [anon_sym_this] = ACTIONS(1212),
    [anon_sym_AT] = ACTIONS(1212),
    [anon_sym_AT_COLON] = ACTIONS(1210),
    [anon_sym_if] = ACTIONS(1212),
    [anon_sym_else] = ACTIONS(1212),
    [anon_sym_new] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1212),
    [anon_sym_PLUS_PLUS] = ACTIONS(1210),
    [anon_sym_DASH_DASH] = ACTIONS(1210),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_STAR] = ACTIONS(1210),
    [anon_sym_SLASH] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1212),
    [anon_sym_LT_LT] = ACTIONS(1210),
    [anon_sym_GT_GT] = ACTIONS(1212),
    [anon_sym_GT_GT_GT] = ACTIONS(1210),
    [anon_sym_AMP] = ACTIONS(1212),
    [anon_sym_PIPE] = ACTIONS(1212),
    [anon_sym_CARET] = ACTIONS(1210),
    [anon_sym_AMP_AMP] = ACTIONS(1210),
    [anon_sym_PIPE_PIPE] = ACTIONS(1210),
    [anon_sym_EQ_EQ] = ACTIONS(1210),
    [anon_sym_BANG_EQ] = ACTIONS(1210),
    [anon_sym_LT] = ACTIONS(1212),
    [anon_sym_LT_EQ] = ACTIONS(1210),
    [anon_sym_GT] = ACTIONS(1212),
    [anon_sym_GT_EQ] = ACTIONS(1210),
    [anon_sym_EQ_GT] = ACTIONS(1210),
    [anon_sym_QMARK_QMARK] = ACTIONS(1210),
    [anon_sym_EQ] = ACTIONS(1212),
    [sym__rangeOperator] = ACTIONS(1210),
    [anon_sym_null] = ACTIONS(1212),
    [anon_sym_dynamic] = ACTIONS(1212),
    [anon_sym_final] = ACTIONS(1212),
    [anon_sym_abstract] = ACTIONS(1212),
    [anon_sym_class] = ACTIONS(1212),
    [anon_sym_extends] = ACTIONS(1212),
    [anon_sym_implements] = ACTIONS(1212),
    [anon_sym_interface] = ACTIONS(1212),
    [anon_sym_typedef] = ACTIONS(1212),
    [anon_sym_function] = ACTIONS(1212),
    [anon_sym_var] = ACTIONS(1212),
    [aux_sym_integer_token1] = ACTIONS(1212),
    [aux_sym_integer_token2] = ACTIONS(1210),
    [aux_sym_float_token1] = ACTIONS(1212),
    [aux_sym_float_token2] = ACTIONS(1210),
    [anon_sym_true] = ACTIONS(1212),
    [anon_sym_false] = ACTIONS(1212),
    [aux_sym_string_token1] = ACTIONS(1210),
    [aux_sym_string_token3] = ACTIONS(1210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_catch] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_do] = ACTIONS(1212),
    [anon_sym_enum] = ACTIONS(1212),
    [anon_sym_extern] = ACTIONS(1212),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_inline] = ACTIONS(1212),
    [anon_sym_macro] = ACTIONS(1212),
    [anon_sym_operator] = ACTIONS(1212),
    [anon_sym_overload] = ACTIONS(1212),
    [anon_sym_override] = ACTIONS(1212),
    [anon_sym_private] = ACTIONS(1212),
    [anon_sym_public] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_static] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_untyped] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [sym__semicolon] = ACTIONS(1210),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1216),
    [anon_sym_POUND] = ACTIONS(1214),
    [anon_sym_package] = ACTIONS(1216),
    [anon_sym_import] = ACTIONS(1216),
    [anon_sym_using] = ACTIONS(1216),
    [anon_sym_throw] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_switch] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_case] = ACTIONS(1216),
    [anon_sym_default] = ACTIONS(1216),
    [anon_sym_cast] = ACTIONS(1216),
    [anon_sym_DOLLARtype] = ACTIONS(1214),
    [anon_sym_in] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_this] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_AT_COLON] = ACTIONS(1214),
    [anon_sym_if] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1216),
    [anon_sym_new] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_BANG] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_PERCENT] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_LT_LT] = ACTIONS(1214),
    [anon_sym_GT_GT] = ACTIONS(1216),
    [anon_sym_GT_GT_GT] = ACTIONS(1214),
    [anon_sym_AMP] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1216),
    [anon_sym_CARET] = ACTIONS(1214),
    [anon_sym_AMP_AMP] = ACTIONS(1214),
    [anon_sym_PIPE_PIPE] = ACTIONS(1214),
    [anon_sym_EQ_EQ] = ACTIONS(1214),
    [anon_sym_BANG_EQ] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1216),
    [anon_sym_LT_EQ] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1216),
    [anon_sym_GT_EQ] = ACTIONS(1214),
    [anon_sym_EQ_GT] = ACTIONS(1214),
    [anon_sym_QMARK_QMARK] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1216),
    [sym__rangeOperator] = ACTIONS(1214),
    [anon_sym_null] = ACTIONS(1216),
    [anon_sym_dynamic] = ACTIONS(1216),
    [anon_sym_final] = ACTIONS(1216),
    [anon_sym_abstract] = ACTIONS(1216),
    [anon_sym_class] = ACTIONS(1216),
    [anon_sym_extends] = ACTIONS(1216),
    [anon_sym_implements] = ACTIONS(1216),
    [anon_sym_interface] = ACTIONS(1216),
    [anon_sym_typedef] = ACTIONS(1216),
    [anon_sym_function] = ACTIONS(1216),
    [anon_sym_var] = ACTIONS(1216),
    [aux_sym_integer_token1] = ACTIONS(1216),
    [aux_sym_integer_token2] = ACTIONS(1214),
    [aux_sym_float_token1] = ACTIONS(1216),
    [aux_sym_float_token2] = ACTIONS(1214),
    [anon_sym_true] = ACTIONS(1216),
    [anon_sym_false] = ACTIONS(1216),
    [aux_sym_string_token1] = ACTIONS(1214),
    [aux_sym_string_token3] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1216),
    [anon_sym_catch] = ACTIONS(1216),
    [anon_sym_continue] = ACTIONS(1216),
    [anon_sym_do] = ACTIONS(1216),
    [anon_sym_enum] = ACTIONS(1216),
    [anon_sym_extern] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1216),
    [anon_sym_inline] = ACTIONS(1216),
    [anon_sym_macro] = ACTIONS(1216),
    [anon_sym_operator] = ACTIONS(1216),
    [anon_sym_overload] = ACTIONS(1216),
    [anon_sym_override] = ACTIONS(1216),
    [anon_sym_private] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1216),
    [anon_sym_return] = ACTIONS(1216),
    [anon_sym_static] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1216),
    [anon_sym_untyped] = ACTIONS(1216),
    [anon_sym_while] = ACTIONS(1216),
    [sym__semicolon] = ACTIONS(1214),
  },
  [240] = {
    [ts_builtin_sym_end] = ACTIONS(1218),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_POUND] = ACTIONS(1218),
    [anon_sym_package] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_using] = ACTIONS(1220),
    [anon_sym_throw] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [anon_sym_switch] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(1218),
    [anon_sym_RBRACE] = ACTIONS(1218),
    [anon_sym_case] = ACTIONS(1220),
    [anon_sym_default] = ACTIONS(1220),
    [anon_sym_cast] = ACTIONS(1220),
    [anon_sym_DOLLARtype] = ACTIONS(1218),
    [anon_sym_in] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_this] = ACTIONS(1220),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_AT_COLON] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_else] = ACTIONS(1220),
    [anon_sym_new] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1220),
    [anon_sym_PLUS_PLUS] = ACTIONS(1218),
    [anon_sym_DASH_DASH] = ACTIONS(1218),
    [anon_sym_PERCENT] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1220),
    [anon_sym_LT_LT] = ACTIONS(1218),
    [anon_sym_GT_GT] = ACTIONS(1220),
    [anon_sym_GT_GT_GT] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1220),
    [anon_sym_PIPE] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1218),
    [anon_sym_PIPE_PIPE] = ACTIONS(1218),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_LT] = ACTIONS(1220),
    [anon_sym_LT_EQ] = ACTIONS(1218),
    [anon_sym_GT] = ACTIONS(1220),
    [anon_sym_GT_EQ] = ACTIONS(1218),
    [anon_sym_EQ_GT] = ACTIONS(1218),
    [anon_sym_QMARK_QMARK] = ACTIONS(1218),
    [anon_sym_EQ] = ACTIONS(1220),
    [sym__rangeOperator] = ACTIONS(1218),
    [anon_sym_null] = ACTIONS(1220),
    [anon_sym_dynamic] = ACTIONS(1220),
    [anon_sym_final] = ACTIONS(1220),
    [anon_sym_abstract] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(1220),
    [anon_sym_extends] = ACTIONS(1220),
    [anon_sym_implements] = ACTIONS(1220),
    [anon_sym_interface] = ACTIONS(1220),
    [anon_sym_typedef] = ACTIONS(1220),
    [anon_sym_function] = ACTIONS(1220),
    [anon_sym_var] = ACTIONS(1220),
    [aux_sym_integer_token1] = ACTIONS(1220),
    [aux_sym_integer_token2] = ACTIONS(1218),
    [aux_sym_float_token1] = ACTIONS(1220),
    [aux_sym_float_token2] = ACTIONS(1218),
    [anon_sym_true] = ACTIONS(1220),
    [anon_sym_false] = ACTIONS(1220),
    [aux_sym_string_token1] = ACTIONS(1218),
    [aux_sym_string_token3] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_catch] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_do] = ACTIONS(1220),
    [anon_sym_enum] = ACTIONS(1220),
    [anon_sym_extern] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_inline] = ACTIONS(1220),
    [anon_sym_macro] = ACTIONS(1220),
    [anon_sym_operator] = ACTIONS(1220),
    [anon_sym_overload] = ACTIONS(1220),
    [anon_sym_override] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1220),
    [anon_sym_public] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_untyped] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [sym__semicolon] = ACTIONS(1218),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1224),
    [anon_sym_POUND] = ACTIONS(1222),
    [anon_sym_package] = ACTIONS(1224),
    [anon_sym_import] = ACTIONS(1224),
    [anon_sym_using] = ACTIONS(1224),
    [anon_sym_throw] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_switch] = ACTIONS(1224),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_case] = ACTIONS(1224),
    [anon_sym_default] = ACTIONS(1224),
    [anon_sym_cast] = ACTIONS(1224),
    [anon_sym_DOLLARtype] = ACTIONS(1222),
    [anon_sym_in] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_this] = ACTIONS(1224),
    [anon_sym_AT] = ACTIONS(1224),
    [anon_sym_AT_COLON] = ACTIONS(1222),
    [anon_sym_if] = ACTIONS(1224),
    [anon_sym_else] = ACTIONS(1224),
    [anon_sym_new] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1224),
    [anon_sym_PLUS_PLUS] = ACTIONS(1222),
    [anon_sym_DASH_DASH] = ACTIONS(1222),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_SLASH] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1224),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1224),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1224),
    [anon_sym_PIPE] = ACTIONS(1224),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(1224),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_GT] = ACTIONS(1224),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_GT] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_EQ] = ACTIONS(1224),
    [sym__rangeOperator] = ACTIONS(1222),
    [anon_sym_null] = ACTIONS(1224),
    [anon_sym_dynamic] = ACTIONS(1224),
    [anon_sym_final] = ACTIONS(1224),
    [anon_sym_abstract] = ACTIONS(1224),
    [anon_sym_class] = ACTIONS(1224),
    [anon_sym_extends] = ACTIONS(1224),
    [anon_sym_implements] = ACTIONS(1224),
    [anon_sym_interface] = ACTIONS(1224),
    [anon_sym_typedef] = ACTIONS(1224),
    [anon_sym_function] = ACTIONS(1224),
    [anon_sym_var] = ACTIONS(1224),
    [aux_sym_integer_token1] = ACTIONS(1224),
    [aux_sym_integer_token2] = ACTIONS(1222),
    [aux_sym_float_token1] = ACTIONS(1224),
    [aux_sym_float_token2] = ACTIONS(1222),
    [anon_sym_true] = ACTIONS(1224),
    [anon_sym_false] = ACTIONS(1224),
    [aux_sym_string_token1] = ACTIONS(1222),
    [aux_sym_string_token3] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1224),
    [anon_sym_catch] = ACTIONS(1224),
    [anon_sym_continue] = ACTIONS(1224),
    [anon_sym_do] = ACTIONS(1224),
    [anon_sym_enum] = ACTIONS(1224),
    [anon_sym_extern] = ACTIONS(1224),
    [anon_sym_for] = ACTIONS(1224),
    [anon_sym_inline] = ACTIONS(1224),
    [anon_sym_macro] = ACTIONS(1224),
    [anon_sym_operator] = ACTIONS(1224),
    [anon_sym_overload] = ACTIONS(1224),
    [anon_sym_override] = ACTIONS(1224),
    [anon_sym_private] = ACTIONS(1224),
    [anon_sym_public] = ACTIONS(1224),
    [anon_sym_return] = ACTIONS(1224),
    [anon_sym_static] = ACTIONS(1224),
    [anon_sym_try] = ACTIONS(1224),
    [anon_sym_untyped] = ACTIONS(1224),
    [anon_sym_while] = ACTIONS(1224),
    [sym__semicolon] = ACTIONS(1222),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(954),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_POUND] = ACTIONS(954),
    [anon_sym_package] = ACTIONS(956),
    [anon_sym_import] = ACTIONS(956),
    [anon_sym_using] = ACTIONS(956),
    [anon_sym_throw] = ACTIONS(956),
    [anon_sym_LPAREN] = ACTIONS(954),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_cast] = ACTIONS(956),
    [anon_sym_DOLLARtype] = ACTIONS(954),
    [anon_sym_in] = ACTIONS(956),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_this] = ACTIONS(956),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_AT_COLON] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_new] = ACTIONS(956),
    [anon_sym_TILDE] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PLUS_PLUS] = ACTIONS(954),
    [anon_sym_DASH_DASH] = ACTIONS(954),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_SLASH] = ACTIONS(956),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(956),
    [anon_sym_GT_GT_GT] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(956),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [anon_sym_EQ_EQ] = ACTIONS(954),
    [anon_sym_BANG_EQ] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(956),
    [anon_sym_LT_EQ] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(956),
    [anon_sym_GT_EQ] = ACTIONS(954),
    [anon_sym_EQ_GT] = ACTIONS(954),
    [anon_sym_QMARK_QMARK] = ACTIONS(954),
    [anon_sym_EQ] = ACTIONS(956),
    [sym__rangeOperator] = ACTIONS(954),
    [anon_sym_null] = ACTIONS(956),
    [anon_sym_dynamic] = ACTIONS(956),
    [anon_sym_final] = ACTIONS(956),
    [anon_sym_abstract] = ACTIONS(956),
    [anon_sym_class] = ACTIONS(956),
    [anon_sym_extends] = ACTIONS(956),
    [anon_sym_implements] = ACTIONS(956),
    [anon_sym_interface] = ACTIONS(956),
    [anon_sym_typedef] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_var] = ACTIONS(956),
    [aux_sym_integer_token1] = ACTIONS(956),
    [aux_sym_integer_token2] = ACTIONS(954),
    [aux_sym_float_token1] = ACTIONS(956),
    [aux_sym_float_token2] = ACTIONS(954),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [aux_sym_string_token1] = ACTIONS(954),
    [aux_sym_string_token3] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_catch] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_do] = ACTIONS(956),
    [anon_sym_enum] = ACTIONS(956),
    [anon_sym_extern] = ACTIONS(956),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_inline] = ACTIONS(956),
    [anon_sym_macro] = ACTIONS(956),
    [anon_sym_operator] = ACTIONS(956),
    [anon_sym_overload] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_try] = ACTIONS(956),
    [anon_sym_untyped] = ACTIONS(956),
    [anon_sym_while] = ACTIONS(956),
    [sym__semicolon] = ACTIONS(954),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1226),
    [sym_identifier] = ACTIONS(1228),
    [anon_sym_POUND] = ACTIONS(1226),
    [anon_sym_package] = ACTIONS(1228),
    [anon_sym_import] = ACTIONS(1228),
    [anon_sym_using] = ACTIONS(1228),
    [anon_sym_throw] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_switch] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [anon_sym_case] = ACTIONS(1228),
    [anon_sym_default] = ACTIONS(1228),
    [anon_sym_cast] = ACTIONS(1228),
    [anon_sym_DOLLARtype] = ACTIONS(1226),
    [anon_sym_in] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_this] = ACTIONS(1228),
    [anon_sym_AT] = ACTIONS(1228),
    [anon_sym_AT_COLON] = ACTIONS(1226),
    [anon_sym_if] = ACTIONS(1228),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_PLUS_PLUS] = ACTIONS(1226),
    [anon_sym_DASH_DASH] = ACTIONS(1226),
    [anon_sym_PERCENT] = ACTIONS(1226),
    [anon_sym_STAR] = ACTIONS(1226),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1228),
    [anon_sym_LT_LT] = ACTIONS(1226),
    [anon_sym_GT_GT] = ACTIONS(1228),
    [anon_sym_GT_GT_GT] = ACTIONS(1226),
    [anon_sym_AMP] = ACTIONS(1228),
    [anon_sym_PIPE] = ACTIONS(1228),
    [anon_sym_CARET] = ACTIONS(1226),
    [anon_sym_AMP_AMP] = ACTIONS(1226),
    [anon_sym_PIPE_PIPE] = ACTIONS(1226),
    [anon_sym_EQ_EQ] = ACTIONS(1226),
    [anon_sym_BANG_EQ] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(1228),
    [anon_sym_LT_EQ] = ACTIONS(1226),
    [anon_sym_GT] = ACTIONS(1228),
    [anon_sym_GT_EQ] = ACTIONS(1226),
    [anon_sym_EQ_GT] = ACTIONS(1226),
    [anon_sym_QMARK_QMARK] = ACTIONS(1226),
    [anon_sym_EQ] = ACTIONS(1228),
    [sym__rangeOperator] = ACTIONS(1226),
    [anon_sym_null] = ACTIONS(1228),
    [anon_sym_dynamic] = ACTIONS(1228),
    [anon_sym_final] = ACTIONS(1228),
    [anon_sym_abstract] = ACTIONS(1228),
    [anon_sym_class] = ACTIONS(1228),
    [anon_sym_extends] = ACTIONS(1228),
    [anon_sym_implements] = ACTIONS(1228),
    [anon_sym_interface] = ACTIONS(1228),
    [anon_sym_typedef] = ACTIONS(1228),
    [anon_sym_function] = ACTIONS(1228),
    [anon_sym_var] = ACTIONS(1228),
    [aux_sym_integer_token1] = ACTIONS(1228),
    [aux_sym_integer_token2] = ACTIONS(1226),
    [aux_sym_float_token1] = ACTIONS(1228),
    [aux_sym_float_token2] = ACTIONS(1226),
    [anon_sym_true] = ACTIONS(1228),
    [anon_sym_false] = ACTIONS(1228),
    [aux_sym_string_token1] = ACTIONS(1226),
    [aux_sym_string_token3] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1228),
    [anon_sym_catch] = ACTIONS(1228),
    [anon_sym_continue] = ACTIONS(1228),
    [anon_sym_do] = ACTIONS(1228),
    [anon_sym_enum] = ACTIONS(1228),
    [anon_sym_extern] = ACTIONS(1228),
    [anon_sym_for] = ACTIONS(1228),
    [anon_sym_inline] = ACTIONS(1228),
    [anon_sym_macro] = ACTIONS(1228),
    [anon_sym_operator] = ACTIONS(1228),
    [anon_sym_overload] = ACTIONS(1228),
    [anon_sym_override] = ACTIONS(1228),
    [anon_sym_private] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(1228),
    [anon_sym_return] = ACTIONS(1228),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(1228),
    [anon_sym_untyped] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(1228),
    [sym__semicolon] = ACTIONS(1226),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1232),
    [anon_sym_POUND] = ACTIONS(1230),
    [anon_sym_package] = ACTIONS(1232),
    [anon_sym_import] = ACTIONS(1232),
    [anon_sym_using] = ACTIONS(1232),
    [anon_sym_throw] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [anon_sym_switch] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [anon_sym_case] = ACTIONS(1232),
    [anon_sym_default] = ACTIONS(1232),
    [anon_sym_cast] = ACTIONS(1232),
    [anon_sym_DOLLARtype] = ACTIONS(1230),
    [anon_sym_in] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_this] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(1232),
    [anon_sym_AT_COLON] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(1232),
    [anon_sym_else] = ACTIONS(1232),
    [anon_sym_new] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_PERCENT] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(1230),
    [anon_sym_SLASH] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_LT_LT] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(1232),
    [anon_sym_GT_GT_GT] = ACTIONS(1230),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1232),
    [anon_sym_CARET] = ACTIONS(1230),
    [anon_sym_AMP_AMP] = ACTIONS(1230),
    [anon_sym_PIPE_PIPE] = ACTIONS(1230),
    [anon_sym_EQ_EQ] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1232),
    [anon_sym_LT_EQ] = ACTIONS(1230),
    [anon_sym_GT] = ACTIONS(1232),
    [anon_sym_GT_EQ] = ACTIONS(1230),
    [anon_sym_EQ_GT] = ACTIONS(1230),
    [anon_sym_QMARK_QMARK] = ACTIONS(1230),
    [anon_sym_EQ] = ACTIONS(1232),
    [sym__rangeOperator] = ACTIONS(1230),
    [anon_sym_null] = ACTIONS(1232),
    [anon_sym_dynamic] = ACTIONS(1232),
    [anon_sym_final] = ACTIONS(1232),
    [anon_sym_abstract] = ACTIONS(1232),
    [anon_sym_class] = ACTIONS(1232),
    [anon_sym_extends] = ACTIONS(1232),
    [anon_sym_implements] = ACTIONS(1232),
    [anon_sym_interface] = ACTIONS(1232),
    [anon_sym_typedef] = ACTIONS(1232),
    [anon_sym_function] = ACTIONS(1232),
    [anon_sym_var] = ACTIONS(1232),
    [aux_sym_integer_token1] = ACTIONS(1232),
    [aux_sym_integer_token2] = ACTIONS(1230),
    [aux_sym_float_token1] = ACTIONS(1232),
    [aux_sym_float_token2] = ACTIONS(1230),
    [anon_sym_true] = ACTIONS(1232),
    [anon_sym_false] = ACTIONS(1232),
    [aux_sym_string_token1] = ACTIONS(1230),
    [aux_sym_string_token3] = ACTIONS(1230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1232),
    [anon_sym_catch] = ACTIONS(1232),
    [anon_sym_continue] = ACTIONS(1232),
    [anon_sym_do] = ACTIONS(1232),
    [anon_sym_enum] = ACTIONS(1232),
    [anon_sym_extern] = ACTIONS(1232),
    [anon_sym_for] = ACTIONS(1232),
    [anon_sym_inline] = ACTIONS(1232),
    [anon_sym_macro] = ACTIONS(1232),
    [anon_sym_operator] = ACTIONS(1232),
    [anon_sym_overload] = ACTIONS(1232),
    [anon_sym_override] = ACTIONS(1232),
    [anon_sym_private] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_static] = ACTIONS(1232),
    [anon_sym_try] = ACTIONS(1232),
    [anon_sym_untyped] = ACTIONS(1232),
    [anon_sym_while] = ACTIONS(1232),
    [sym__semicolon] = ACTIONS(1230),
  },
  [245] = {
    [sym__rhs_expression] = STATE(543),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(979),
    [sym_builtin_type] = STATE(1008),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1105),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(543),
    [sym_operator] = STATE(808),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(749),
    [sym_integer] = STATE(749),
    [sym_float] = STATE(749),
    [sym_bool] = STATE(749),
    [sym_string] = STATE(743),
    [sym_null] = STATE(749),
    [sym_array] = STATE(749),
    [sym_map] = STATE(749),
    [sym_object] = STATE(749),
    [sym_pair] = STATE(749),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1236),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(328),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_POUND] = ACTIONS(1238),
    [anon_sym_package] = ACTIONS(1240),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_using] = ACTIONS(1240),
    [anon_sym_throw] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_switch] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_case] = ACTIONS(1240),
    [anon_sym_default] = ACTIONS(1240),
    [anon_sym_cast] = ACTIONS(1240),
    [anon_sym_DOLLARtype] = ACTIONS(1238),
    [anon_sym_in] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_this] = ACTIONS(1240),
    [anon_sym_AT] = ACTIONS(1240),
    [anon_sym_AT_COLON] = ACTIONS(1238),
    [anon_sym_if] = ACTIONS(1240),
    [anon_sym_else] = ACTIONS(1240),
    [anon_sym_new] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_PERCENT] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_LT_LT] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1240),
    [anon_sym_GT_GT_GT] = ACTIONS(1238),
    [anon_sym_AMP] = ACTIONS(1240),
    [anon_sym_PIPE] = ACTIONS(1240),
    [anon_sym_CARET] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1238),
    [anon_sym_PIPE_PIPE] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1238),
    [anon_sym_BANG_EQ] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1240),
    [anon_sym_LT_EQ] = ACTIONS(1238),
    [anon_sym_GT] = ACTIONS(1240),
    [anon_sym_GT_EQ] = ACTIONS(1238),
    [anon_sym_EQ_GT] = ACTIONS(1238),
    [anon_sym_QMARK_QMARK] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(1240),
    [sym__rangeOperator] = ACTIONS(1238),
    [anon_sym_null] = ACTIONS(1240),
    [anon_sym_dynamic] = ACTIONS(1240),
    [anon_sym_final] = ACTIONS(1240),
    [anon_sym_abstract] = ACTIONS(1240),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_extends] = ACTIONS(1240),
    [anon_sym_implements] = ACTIONS(1240),
    [anon_sym_interface] = ACTIONS(1240),
    [anon_sym_typedef] = ACTIONS(1240),
    [anon_sym_function] = ACTIONS(1240),
    [anon_sym_var] = ACTIONS(1240),
    [aux_sym_integer_token1] = ACTIONS(1240),
    [aux_sym_integer_token2] = ACTIONS(1238),
    [aux_sym_float_token1] = ACTIONS(1240),
    [aux_sym_float_token2] = ACTIONS(1238),
    [anon_sym_true] = ACTIONS(1240),
    [anon_sym_false] = ACTIONS(1240),
    [aux_sym_string_token1] = ACTIONS(1238),
    [aux_sym_string_token3] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_catch] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_do] = ACTIONS(1240),
    [anon_sym_enum] = ACTIONS(1240),
    [anon_sym_extern] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_inline] = ACTIONS(1240),
    [anon_sym_macro] = ACTIONS(1240),
    [anon_sym_operator] = ACTIONS(1240),
    [anon_sym_overload] = ACTIONS(1240),
    [anon_sym_override] = ACTIONS(1240),
    [anon_sym_private] = ACTIONS(1240),
    [anon_sym_public] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_static] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_untyped] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [sym__semicolon] = ACTIONS(1238),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_identifier] = ACTIONS(390),
    [anon_sym_POUND] = ACTIONS(388),
    [anon_sym_package] = ACTIONS(390),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_using] = ACTIONS(390),
    [anon_sym_throw] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_switch] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_cast] = ACTIONS(390),
    [anon_sym_DOLLARtype] = ACTIONS(388),
    [anon_sym_in] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_this] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(390),
    [anon_sym_AT_COLON] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_PERCENT] = ACTIONS(388),
    [anon_sym_STAR] = ACTIONS(388),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(388),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_GT_GT_GT] = ACTIONS(388),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ_GT] = ACTIONS(388),
    [anon_sym_QMARK_QMARK] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [sym__rangeOperator] = ACTIONS(388),
    [anon_sym_null] = ACTIONS(390),
    [anon_sym_dynamic] = ACTIONS(390),
    [anon_sym_final] = ACTIONS(390),
    [anon_sym_abstract] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(390),
    [anon_sym_extends] = ACTIONS(390),
    [anon_sym_implements] = ACTIONS(390),
    [anon_sym_interface] = ACTIONS(390),
    [anon_sym_typedef] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [aux_sym_integer_token1] = ACTIONS(390),
    [aux_sym_integer_token2] = ACTIONS(388),
    [aux_sym_float_token1] = ACTIONS(390),
    [aux_sym_float_token2] = ACTIONS(388),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [aux_sym_string_token1] = ACTIONS(388),
    [aux_sym_string_token3] = ACTIONS(388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_catch] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_enum] = ACTIONS(390),
    [anon_sym_extern] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_inline] = ACTIONS(390),
    [anon_sym_macro] = ACTIONS(390),
    [anon_sym_operator] = ACTIONS(390),
    [anon_sym_overload] = ACTIONS(390),
    [anon_sym_override] = ACTIONS(390),
    [anon_sym_private] = ACTIONS(390),
    [anon_sym_public] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_untyped] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [sym__semicolon] = ACTIONS(388),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym_identifier] = ACTIONS(1244),
    [anon_sym_POUND] = ACTIONS(1242),
    [anon_sym_package] = ACTIONS(1244),
    [anon_sym_import] = ACTIONS(1244),
    [anon_sym_using] = ACTIONS(1244),
    [anon_sym_throw] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_switch] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [anon_sym_case] = ACTIONS(1244),
    [anon_sym_default] = ACTIONS(1244),
    [anon_sym_cast] = ACTIONS(1244),
    [anon_sym_DOLLARtype] = ACTIONS(1242),
    [anon_sym_in] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_this] = ACTIONS(1244),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_AT_COLON] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1244),
    [anon_sym_else] = ACTIONS(1244),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_PLUS_PLUS] = ACTIONS(1242),
    [anon_sym_DASH_DASH] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_GT_GT] = ACTIONS(1244),
    [anon_sym_GT_GT_GT] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_AMP_AMP] = ACTIONS(1242),
    [anon_sym_PIPE_PIPE] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_EQ_GT] = ACTIONS(1242),
    [anon_sym_QMARK_QMARK] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1244),
    [sym__rangeOperator] = ACTIONS(1242),
    [anon_sym_null] = ACTIONS(1244),
    [anon_sym_dynamic] = ACTIONS(1244),
    [anon_sym_final] = ACTIONS(1244),
    [anon_sym_abstract] = ACTIONS(1244),
    [anon_sym_class] = ACTIONS(1244),
    [anon_sym_extends] = ACTIONS(1244),
    [anon_sym_implements] = ACTIONS(1244),
    [anon_sym_interface] = ACTIONS(1244),
    [anon_sym_typedef] = ACTIONS(1244),
    [anon_sym_function] = ACTIONS(1244),
    [anon_sym_var] = ACTIONS(1244),
    [aux_sym_integer_token1] = ACTIONS(1244),
    [aux_sym_integer_token2] = ACTIONS(1242),
    [aux_sym_float_token1] = ACTIONS(1244),
    [aux_sym_float_token2] = ACTIONS(1242),
    [anon_sym_true] = ACTIONS(1244),
    [anon_sym_false] = ACTIONS(1244),
    [aux_sym_string_token1] = ACTIONS(1242),
    [aux_sym_string_token3] = ACTIONS(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_catch] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_do] = ACTIONS(1244),
    [anon_sym_enum] = ACTIONS(1244),
    [anon_sym_extern] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_inline] = ACTIONS(1244),
    [anon_sym_macro] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1244),
    [anon_sym_overload] = ACTIONS(1244),
    [anon_sym_override] = ACTIONS(1244),
    [anon_sym_private] = ACTIONS(1244),
    [anon_sym_public] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_static] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_untyped] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [sym__semicolon] = ACTIONS(1242),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(388),
    [sym_identifier] = ACTIONS(390),
    [anon_sym_POUND] = ACTIONS(388),
    [anon_sym_package] = ACTIONS(390),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_using] = ACTIONS(390),
    [anon_sym_throw] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_switch] = ACTIONS(390),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_cast] = ACTIONS(390),
    [anon_sym_DOLLARtype] = ACTIONS(388),
    [anon_sym_in] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(390),
    [anon_sym_AT] = ACTIONS(390),
    [anon_sym_AT_COLON] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_BANG] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_PERCENT] = ACTIONS(388),
    [anon_sym_STAR] = ACTIONS(388),
    [anon_sym_SLASH] = ACTIONS(390),
    [anon_sym_PLUS] = ACTIONS(390),
    [anon_sym_LT_LT] = ACTIONS(388),
    [anon_sym_GT_GT] = ACTIONS(390),
    [anon_sym_GT_GT_GT] = ACTIONS(388),
    [anon_sym_AMP] = ACTIONS(390),
    [anon_sym_PIPE] = ACTIONS(390),
    [anon_sym_CARET] = ACTIONS(388),
    [anon_sym_AMP_AMP] = ACTIONS(388),
    [anon_sym_PIPE_PIPE] = ACTIONS(388),
    [anon_sym_EQ_EQ] = ACTIONS(388),
    [anon_sym_BANG_EQ] = ACTIONS(388),
    [anon_sym_LT] = ACTIONS(390),
    [anon_sym_LT_EQ] = ACTIONS(388),
    [anon_sym_GT] = ACTIONS(390),
    [anon_sym_GT_EQ] = ACTIONS(388),
    [anon_sym_EQ_GT] = ACTIONS(388),
    [anon_sym_QMARK_QMARK] = ACTIONS(388),
    [anon_sym_EQ] = ACTIONS(390),
    [sym__rangeOperator] = ACTIONS(388),
    [anon_sym_null] = ACTIONS(390),
    [anon_sym_dynamic] = ACTIONS(390),
    [anon_sym_final] = ACTIONS(390),
    [anon_sym_abstract] = ACTIONS(390),
    [anon_sym_class] = ACTIONS(390),
    [anon_sym_extends] = ACTIONS(390),
    [anon_sym_implements] = ACTIONS(390),
    [anon_sym_interface] = ACTIONS(390),
    [anon_sym_typedef] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [aux_sym_integer_token1] = ACTIONS(390),
    [aux_sym_integer_token2] = ACTIONS(388),
    [aux_sym_float_token1] = ACTIONS(390),
    [aux_sym_float_token2] = ACTIONS(388),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [aux_sym_string_token1] = ACTIONS(388),
    [aux_sym_string_token3] = ACTIONS(388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_catch] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_enum] = ACTIONS(390),
    [anon_sym_extern] = ACTIONS(390),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_inline] = ACTIONS(390),
    [anon_sym_macro] = ACTIONS(390),
    [anon_sym_operator] = ACTIONS(390),
    [anon_sym_overload] = ACTIONS(390),
    [anon_sym_override] = ACTIONS(390),
    [anon_sym_private] = ACTIONS(390),
    [anon_sym_public] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_untyped] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [sym__semicolon] = ACTIONS(388),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_POUND] = ACTIONS(1246),
    [anon_sym_package] = ACTIONS(1248),
    [anon_sym_import] = ACTIONS(1248),
    [anon_sym_using] = ACTIONS(1248),
    [anon_sym_throw] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_case] = ACTIONS(1248),
    [anon_sym_default] = ACTIONS(1248),
    [anon_sym_cast] = ACTIONS(1248),
    [anon_sym_DOLLARtype] = ACTIONS(1246),
    [anon_sym_in] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_this] = ACTIONS(1248),
    [anon_sym_AT] = ACTIONS(1248),
    [anon_sym_AT_COLON] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1248),
    [anon_sym_GT_GT_GT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_PIPE_PIPE] = ACTIONS(1246),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1248),
    [anon_sym_GT_EQ] = ACTIONS(1246),
    [anon_sym_EQ_GT] = ACTIONS(1246),
    [anon_sym_QMARK_QMARK] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1248),
    [sym__rangeOperator] = ACTIONS(1246),
    [anon_sym_null] = ACTIONS(1248),
    [anon_sym_dynamic] = ACTIONS(1248),
    [anon_sym_final] = ACTIONS(1248),
    [anon_sym_abstract] = ACTIONS(1248),
    [anon_sym_class] = ACTIONS(1248),
    [anon_sym_extends] = ACTIONS(1248),
    [anon_sym_implements] = ACTIONS(1248),
    [anon_sym_interface] = ACTIONS(1248),
    [anon_sym_typedef] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1248),
    [anon_sym_var] = ACTIONS(1248),
    [aux_sym_integer_token1] = ACTIONS(1248),
    [aux_sym_integer_token2] = ACTIONS(1246),
    [aux_sym_float_token1] = ACTIONS(1248),
    [aux_sym_float_token2] = ACTIONS(1246),
    [anon_sym_true] = ACTIONS(1248),
    [anon_sym_false] = ACTIONS(1248),
    [aux_sym_string_token1] = ACTIONS(1246),
    [aux_sym_string_token3] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_catch] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_do] = ACTIONS(1248),
    [anon_sym_enum] = ACTIONS(1248),
    [anon_sym_extern] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_inline] = ACTIONS(1248),
    [anon_sym_macro] = ACTIONS(1248),
    [anon_sym_operator] = ACTIONS(1248),
    [anon_sym_overload] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_untyped] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [sym__semicolon] = ACTIONS(1246),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_POUND] = ACTIONS(1250),
    [anon_sym_package] = ACTIONS(1252),
    [anon_sym_import] = ACTIONS(1252),
    [anon_sym_using] = ACTIONS(1252),
    [anon_sym_throw] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_cast] = ACTIONS(1252),
    [anon_sym_DOLLARtype] = ACTIONS(1250),
    [anon_sym_in] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_this] = ACTIONS(1252),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_AT_COLON] = ACTIONS(1250),
    [anon_sym_if] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1252),
    [anon_sym_GT_GT_GT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1252),
    [anon_sym_PIPE] = ACTIONS(1252),
    [anon_sym_CARET] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1250),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1252),
    [anon_sym_GT_EQ] = ACTIONS(1250),
    [anon_sym_EQ_GT] = ACTIONS(1250),
    [anon_sym_QMARK_QMARK] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1252),
    [sym__rangeOperator] = ACTIONS(1250),
    [anon_sym_null] = ACTIONS(1252),
    [anon_sym_dynamic] = ACTIONS(1252),
    [anon_sym_final] = ACTIONS(1252),
    [anon_sym_abstract] = ACTIONS(1252),
    [anon_sym_class] = ACTIONS(1252),
    [anon_sym_extends] = ACTIONS(1252),
    [anon_sym_implements] = ACTIONS(1252),
    [anon_sym_interface] = ACTIONS(1252),
    [anon_sym_typedef] = ACTIONS(1252),
    [anon_sym_function] = ACTIONS(1252),
    [anon_sym_var] = ACTIONS(1252),
    [aux_sym_integer_token1] = ACTIONS(1252),
    [aux_sym_integer_token2] = ACTIONS(1250),
    [aux_sym_float_token1] = ACTIONS(1252),
    [aux_sym_float_token2] = ACTIONS(1250),
    [anon_sym_true] = ACTIONS(1252),
    [anon_sym_false] = ACTIONS(1252),
    [aux_sym_string_token1] = ACTIONS(1250),
    [aux_sym_string_token3] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1252),
    [anon_sym_catch] = ACTIONS(1252),
    [anon_sym_continue] = ACTIONS(1252),
    [anon_sym_do] = ACTIONS(1252),
    [anon_sym_enum] = ACTIONS(1252),
    [anon_sym_extern] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1252),
    [anon_sym_inline] = ACTIONS(1252),
    [anon_sym_macro] = ACTIONS(1252),
    [anon_sym_operator] = ACTIONS(1252),
    [anon_sym_overload] = ACTIONS(1252),
    [anon_sym_override] = ACTIONS(1252),
    [anon_sym_private] = ACTIONS(1252),
    [anon_sym_public] = ACTIONS(1252),
    [anon_sym_return] = ACTIONS(1252),
    [anon_sym_static] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1252),
    [anon_sym_untyped] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1252),
    [sym__semicolon] = ACTIONS(1250),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(1254),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_POUND] = ACTIONS(1254),
    [anon_sym_package] = ACTIONS(1256),
    [anon_sym_import] = ACTIONS(1256),
    [anon_sym_using] = ACTIONS(1256),
    [anon_sym_throw] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [anon_sym_case] = ACTIONS(1256),
    [anon_sym_default] = ACTIONS(1256),
    [anon_sym_cast] = ACTIONS(1256),
    [anon_sym_DOLLARtype] = ACTIONS(1254),
    [anon_sym_in] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_this] = ACTIONS(1256),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_AT_COLON] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_else] = ACTIONS(1256),
    [anon_sym_new] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_PLUS_PLUS] = ACTIONS(1254),
    [anon_sym_DASH_DASH] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1256),
    [anon_sym_GT_GT_GT] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1256),
    [anon_sym_PIPE] = ACTIONS(1256),
    [anon_sym_CARET] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1254),
    [anon_sym_PIPE_PIPE] = ACTIONS(1254),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1254),
    [anon_sym_GT] = ACTIONS(1256),
    [anon_sym_GT_EQ] = ACTIONS(1254),
    [anon_sym_EQ_GT] = ACTIONS(1254),
    [anon_sym_QMARK_QMARK] = ACTIONS(1254),
    [anon_sym_EQ] = ACTIONS(1256),
    [sym__rangeOperator] = ACTIONS(1254),
    [anon_sym_null] = ACTIONS(1256),
    [anon_sym_dynamic] = ACTIONS(1256),
    [anon_sym_final] = ACTIONS(1256),
    [anon_sym_abstract] = ACTIONS(1256),
    [anon_sym_class] = ACTIONS(1256),
    [anon_sym_extends] = ACTIONS(1256),
    [anon_sym_implements] = ACTIONS(1256),
    [anon_sym_interface] = ACTIONS(1256),
    [anon_sym_typedef] = ACTIONS(1256),
    [anon_sym_function] = ACTIONS(1256),
    [anon_sym_var] = ACTIONS(1256),
    [aux_sym_integer_token1] = ACTIONS(1256),
    [aux_sym_integer_token2] = ACTIONS(1254),
    [aux_sym_float_token1] = ACTIONS(1256),
    [aux_sym_float_token2] = ACTIONS(1254),
    [anon_sym_true] = ACTIONS(1256),
    [anon_sym_false] = ACTIONS(1256),
    [aux_sym_string_token1] = ACTIONS(1254),
    [aux_sym_string_token3] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1256),
    [anon_sym_catch] = ACTIONS(1256),
    [anon_sym_continue] = ACTIONS(1256),
    [anon_sym_do] = ACTIONS(1256),
    [anon_sym_enum] = ACTIONS(1256),
    [anon_sym_extern] = ACTIONS(1256),
    [anon_sym_for] = ACTIONS(1256),
    [anon_sym_inline] = ACTIONS(1256),
    [anon_sym_macro] = ACTIONS(1256),
    [anon_sym_operator] = ACTIONS(1256),
    [anon_sym_overload] = ACTIONS(1256),
    [anon_sym_override] = ACTIONS(1256),
    [anon_sym_private] = ACTIONS(1256),
    [anon_sym_public] = ACTIONS(1256),
    [anon_sym_return] = ACTIONS(1256),
    [anon_sym_static] = ACTIONS(1256),
    [anon_sym_try] = ACTIONS(1256),
    [anon_sym_untyped] = ACTIONS(1256),
    [anon_sym_while] = ACTIONS(1256),
    [sym__semicolon] = ACTIONS(1254),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_POUND] = ACTIONS(1258),
    [anon_sym_package] = ACTIONS(1260),
    [anon_sym_import] = ACTIONS(1260),
    [anon_sym_using] = ACTIONS(1260),
    [anon_sym_throw] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [anon_sym_switch] = ACTIONS(1260),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [anon_sym_case] = ACTIONS(1260),
    [anon_sym_default] = ACTIONS(1260),
    [anon_sym_cast] = ACTIONS(1260),
    [anon_sym_DOLLARtype] = ACTIONS(1258),
    [anon_sym_in] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_this] = ACTIONS(1260),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_AT_COLON] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1260),
    [anon_sym_else] = ACTIONS(1260),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PERCENT] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_LT_LT] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1260),
    [anon_sym_GT_GT_GT] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1260),
    [anon_sym_PIPE] = ACTIONS(1260),
    [anon_sym_CARET] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1258),
    [anon_sym_PIPE_PIPE] = ACTIONS(1258),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_LT_EQ] = ACTIONS(1258),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_GT_EQ] = ACTIONS(1258),
    [anon_sym_EQ_GT] = ACTIONS(1258),
    [anon_sym_QMARK_QMARK] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1260),
    [sym__rangeOperator] = ACTIONS(1258),
    [anon_sym_null] = ACTIONS(1260),
    [anon_sym_dynamic] = ACTIONS(1260),
    [anon_sym_final] = ACTIONS(1260),
    [anon_sym_abstract] = ACTIONS(1260),
    [anon_sym_class] = ACTIONS(1260),
    [anon_sym_extends] = ACTIONS(1260),
    [anon_sym_implements] = ACTIONS(1260),
    [anon_sym_interface] = ACTIONS(1260),
    [anon_sym_typedef] = ACTIONS(1260),
    [anon_sym_function] = ACTIONS(1260),
    [anon_sym_var] = ACTIONS(1260),
    [aux_sym_integer_token1] = ACTIONS(1260),
    [aux_sym_integer_token2] = ACTIONS(1258),
    [aux_sym_float_token1] = ACTIONS(1260),
    [aux_sym_float_token2] = ACTIONS(1258),
    [anon_sym_true] = ACTIONS(1260),
    [anon_sym_false] = ACTIONS(1260),
    [aux_sym_string_token1] = ACTIONS(1258),
    [aux_sym_string_token3] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1260),
    [anon_sym_catch] = ACTIONS(1260),
    [anon_sym_continue] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_enum] = ACTIONS(1260),
    [anon_sym_extern] = ACTIONS(1260),
    [anon_sym_for] = ACTIONS(1260),
    [anon_sym_inline] = ACTIONS(1260),
    [anon_sym_macro] = ACTIONS(1260),
    [anon_sym_operator] = ACTIONS(1260),
    [anon_sym_overload] = ACTIONS(1260),
    [anon_sym_override] = ACTIONS(1260),
    [anon_sym_private] = ACTIONS(1260),
    [anon_sym_public] = ACTIONS(1260),
    [anon_sym_return] = ACTIONS(1260),
    [anon_sym_static] = ACTIONS(1260),
    [anon_sym_try] = ACTIONS(1260),
    [anon_sym_untyped] = ACTIONS(1260),
    [anon_sym_while] = ACTIONS(1260),
    [sym__semicolon] = ACTIONS(1258),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1262),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_POUND] = ACTIONS(1262),
    [anon_sym_package] = ACTIONS(1264),
    [anon_sym_import] = ACTIONS(1264),
    [anon_sym_using] = ACTIONS(1264),
    [anon_sym_throw] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [anon_sym_switch] = ACTIONS(1264),
    [anon_sym_LBRACE] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [anon_sym_case] = ACTIONS(1264),
    [anon_sym_default] = ACTIONS(1264),
    [anon_sym_cast] = ACTIONS(1264),
    [anon_sym_DOLLARtype] = ACTIONS(1262),
    [anon_sym_in] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1262),
    [anon_sym_this] = ACTIONS(1264),
    [anon_sym_AT] = ACTIONS(1264),
    [anon_sym_AT_COLON] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1264),
    [anon_sym_else] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_PLUS_PLUS] = ACTIONS(1262),
    [anon_sym_DASH_DASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1264),
    [anon_sym_GT_GT_GT] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1264),
    [anon_sym_PIPE] = ACTIONS(1264),
    [anon_sym_CARET] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1262),
    [anon_sym_PIPE_PIPE] = ACTIONS(1262),
    [anon_sym_EQ_EQ] = ACTIONS(1262),
    [anon_sym_BANG_EQ] = ACTIONS(1262),
    [anon_sym_LT] = ACTIONS(1264),
    [anon_sym_LT_EQ] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1264),
    [anon_sym_GT_EQ] = ACTIONS(1262),
    [anon_sym_EQ_GT] = ACTIONS(1262),
    [anon_sym_QMARK_QMARK] = ACTIONS(1262),
    [anon_sym_EQ] = ACTIONS(1264),
    [sym__rangeOperator] = ACTIONS(1262),
    [anon_sym_null] = ACTIONS(1264),
    [anon_sym_dynamic] = ACTIONS(1264),
    [anon_sym_final] = ACTIONS(1264),
    [anon_sym_abstract] = ACTIONS(1264),
    [anon_sym_class] = ACTIONS(1264),
    [anon_sym_extends] = ACTIONS(1264),
    [anon_sym_implements] = ACTIONS(1264),
    [anon_sym_interface] = ACTIONS(1264),
    [anon_sym_typedef] = ACTIONS(1264),
    [anon_sym_function] = ACTIONS(1264),
    [anon_sym_var] = ACTIONS(1264),
    [aux_sym_integer_token1] = ACTIONS(1264),
    [aux_sym_integer_token2] = ACTIONS(1262),
    [aux_sym_float_token1] = ACTIONS(1264),
    [aux_sym_float_token2] = ACTIONS(1262),
    [anon_sym_true] = ACTIONS(1264),
    [anon_sym_false] = ACTIONS(1264),
    [aux_sym_string_token1] = ACTIONS(1262),
    [aux_sym_string_token3] = ACTIONS(1262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_catch] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_do] = ACTIONS(1264),
    [anon_sym_enum] = ACTIONS(1264),
    [anon_sym_extern] = ACTIONS(1264),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_inline] = ACTIONS(1264),
    [anon_sym_macro] = ACTIONS(1264),
    [anon_sym_operator] = ACTIONS(1264),
    [anon_sym_overload] = ACTIONS(1264),
    [anon_sym_override] = ACTIONS(1264),
    [anon_sym_private] = ACTIONS(1264),
    [anon_sym_public] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_static] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_untyped] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [sym__semicolon] = ACTIONS(1262),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_identifier] = ACTIONS(771),
    [anon_sym_POUND] = ACTIONS(769),
    [anon_sym_package] = ACTIONS(771),
    [anon_sym_import] = ACTIONS(771),
    [anon_sym_using] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_cast] = ACTIONS(771),
    [anon_sym_DOLLARtype] = ACTIONS(769),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [anon_sym_this] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(771),
    [anon_sym_AT_COLON] = ACTIONS(769),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [anon_sym_PERCENT] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(769),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(769),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_GT_GT_GT] = ACTIONS(769),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_CARET] = ACTIONS(769),
    [anon_sym_AMP_AMP] = ACTIONS(769),
    [anon_sym_PIPE_PIPE] = ACTIONS(769),
    [anon_sym_EQ_EQ] = ACTIONS(769),
    [anon_sym_BANG_EQ] = ACTIONS(769),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(769),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(769),
    [anon_sym_EQ_GT] = ACTIONS(769),
    [anon_sym_QMARK_QMARK] = ACTIONS(769),
    [anon_sym_EQ] = ACTIONS(771),
    [sym__rangeOperator] = ACTIONS(769),
    [anon_sym_null] = ACTIONS(771),
    [anon_sym_dynamic] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_extends] = ACTIONS(771),
    [anon_sym_implements] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_typedef] = ACTIONS(771),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_var] = ACTIONS(771),
    [aux_sym_integer_token1] = ACTIONS(771),
    [aux_sym_integer_token2] = ACTIONS(769),
    [aux_sym_float_token1] = ACTIONS(771),
    [aux_sym_float_token2] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(771),
    [anon_sym_false] = ACTIONS(771),
    [aux_sym_string_token1] = ACTIONS(769),
    [aux_sym_string_token3] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(771),
    [anon_sym_catch] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_enum] = ACTIONS(771),
    [anon_sym_extern] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_inline] = ACTIONS(771),
    [anon_sym_macro] = ACTIONS(771),
    [anon_sym_operator] = ACTIONS(771),
    [anon_sym_overload] = ACTIONS(771),
    [anon_sym_override] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_untyped] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [sym__semicolon] = ACTIONS(769),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_identifier] = ACTIONS(1268),
    [anon_sym_POUND] = ACTIONS(1266),
    [anon_sym_package] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1268),
    [anon_sym_using] = ACTIONS(1268),
    [anon_sym_throw] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_switch] = ACTIONS(1268),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1266),
    [anon_sym_case] = ACTIONS(1268),
    [anon_sym_default] = ACTIONS(1268),
    [anon_sym_cast] = ACTIONS(1268),
    [anon_sym_DOLLARtype] = ACTIONS(1266),
    [anon_sym_in] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_this] = ACTIONS(1268),
    [anon_sym_AT] = ACTIONS(1268),
    [anon_sym_AT_COLON] = ACTIONS(1266),
    [anon_sym_if] = ACTIONS(1268),
    [anon_sym_else] = ACTIONS(1268),
    [anon_sym_new] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1268),
    [anon_sym_PLUS_PLUS] = ACTIONS(1266),
    [anon_sym_DASH_DASH] = ACTIONS(1266),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1268),
    [anon_sym_LT_LT] = ACTIONS(1266),
    [anon_sym_GT_GT] = ACTIONS(1268),
    [anon_sym_GT_GT_GT] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1268),
    [anon_sym_PIPE] = ACTIONS(1268),
    [anon_sym_CARET] = ACTIONS(1266),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_PIPE_PIPE] = ACTIONS(1266),
    [anon_sym_EQ_EQ] = ACTIONS(1266),
    [anon_sym_BANG_EQ] = ACTIONS(1266),
    [anon_sym_LT] = ACTIONS(1268),
    [anon_sym_LT_EQ] = ACTIONS(1266),
    [anon_sym_GT] = ACTIONS(1268),
    [anon_sym_GT_EQ] = ACTIONS(1266),
    [anon_sym_EQ_GT] = ACTIONS(1266),
    [anon_sym_QMARK_QMARK] = ACTIONS(1266),
    [anon_sym_EQ] = ACTIONS(1268),
    [sym__rangeOperator] = ACTIONS(1266),
    [anon_sym_null] = ACTIONS(1268),
    [anon_sym_dynamic] = ACTIONS(1268),
    [anon_sym_final] = ACTIONS(1268),
    [anon_sym_abstract] = ACTIONS(1268),
    [anon_sym_class] = ACTIONS(1268),
    [anon_sym_extends] = ACTIONS(1268),
    [anon_sym_implements] = ACTIONS(1268),
    [anon_sym_interface] = ACTIONS(1268),
    [anon_sym_typedef] = ACTIONS(1268),
    [anon_sym_function] = ACTIONS(1268),
    [anon_sym_var] = ACTIONS(1268),
    [aux_sym_integer_token1] = ACTIONS(1268),
    [aux_sym_integer_token2] = ACTIONS(1266),
    [aux_sym_float_token1] = ACTIONS(1268),
    [aux_sym_float_token2] = ACTIONS(1266),
    [anon_sym_true] = ACTIONS(1268),
    [anon_sym_false] = ACTIONS(1268),
    [aux_sym_string_token1] = ACTIONS(1266),
    [aux_sym_string_token3] = ACTIONS(1266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_catch] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_do] = ACTIONS(1268),
    [anon_sym_enum] = ACTIONS(1268),
    [anon_sym_extern] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_inline] = ACTIONS(1268),
    [anon_sym_macro] = ACTIONS(1268),
    [anon_sym_operator] = ACTIONS(1268),
    [anon_sym_overload] = ACTIONS(1268),
    [anon_sym_override] = ACTIONS(1268),
    [anon_sym_private] = ACTIONS(1268),
    [anon_sym_public] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_static] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_untyped] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [sym__semicolon] = ACTIONS(1266),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_POUND] = ACTIONS(1270),
    [anon_sym_package] = ACTIONS(1272),
    [anon_sym_import] = ACTIONS(1272),
    [anon_sym_using] = ACTIONS(1272),
    [anon_sym_throw] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_switch] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [anon_sym_case] = ACTIONS(1272),
    [anon_sym_default] = ACTIONS(1272),
    [anon_sym_cast] = ACTIONS(1272),
    [anon_sym_DOLLARtype] = ACTIONS(1270),
    [anon_sym_in] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_this] = ACTIONS(1272),
    [anon_sym_AT] = ACTIONS(1272),
    [anon_sym_AT_COLON] = ACTIONS(1270),
    [anon_sym_if] = ACTIONS(1272),
    [anon_sym_else] = ACTIONS(1272),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_BANG] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(1272),
    [anon_sym_GT_GT_GT] = ACTIONS(1270),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_AMP_AMP] = ACTIONS(1270),
    [anon_sym_PIPE_PIPE] = ACTIONS(1270),
    [anon_sym_EQ_EQ] = ACTIONS(1270),
    [anon_sym_BANG_EQ] = ACTIONS(1270),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_LT_EQ] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_EQ] = ACTIONS(1270),
    [anon_sym_EQ_GT] = ACTIONS(1270),
    [anon_sym_QMARK_QMARK] = ACTIONS(1270),
    [anon_sym_EQ] = ACTIONS(1272),
    [sym__rangeOperator] = ACTIONS(1270),
    [anon_sym_null] = ACTIONS(1272),
    [anon_sym_dynamic] = ACTIONS(1272),
    [anon_sym_final] = ACTIONS(1272),
    [anon_sym_abstract] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_extends] = ACTIONS(1272),
    [anon_sym_implements] = ACTIONS(1272),
    [anon_sym_interface] = ACTIONS(1272),
    [anon_sym_typedef] = ACTIONS(1272),
    [anon_sym_function] = ACTIONS(1272),
    [anon_sym_var] = ACTIONS(1272),
    [aux_sym_integer_token1] = ACTIONS(1272),
    [aux_sym_integer_token2] = ACTIONS(1270),
    [aux_sym_float_token1] = ACTIONS(1272),
    [aux_sym_float_token2] = ACTIONS(1270),
    [anon_sym_true] = ACTIONS(1272),
    [anon_sym_false] = ACTIONS(1272),
    [aux_sym_string_token1] = ACTIONS(1270),
    [aux_sym_string_token3] = ACTIONS(1270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_catch] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_do] = ACTIONS(1272),
    [anon_sym_enum] = ACTIONS(1272),
    [anon_sym_extern] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_inline] = ACTIONS(1272),
    [anon_sym_macro] = ACTIONS(1272),
    [anon_sym_operator] = ACTIONS(1272),
    [anon_sym_overload] = ACTIONS(1272),
    [anon_sym_override] = ACTIONS(1272),
    [anon_sym_private] = ACTIONS(1272),
    [anon_sym_public] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_static] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_untyped] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [sym__semicolon] = ACTIONS(1270),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_POUND] = ACTIONS(1274),
    [anon_sym_package] = ACTIONS(1276),
    [anon_sym_import] = ACTIONS(1276),
    [anon_sym_using] = ACTIONS(1276),
    [anon_sym_throw] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_switch] = ACTIONS(1276),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_case] = ACTIONS(1276),
    [anon_sym_default] = ACTIONS(1276),
    [anon_sym_cast] = ACTIONS(1276),
    [anon_sym_DOLLARtype] = ACTIONS(1274),
    [anon_sym_in] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_this] = ACTIONS(1276),
    [anon_sym_AT] = ACTIONS(1276),
    [anon_sym_AT_COLON] = ACTIONS(1274),
    [anon_sym_if] = ACTIONS(1276),
    [anon_sym_else] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PERCENT] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_SLASH] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1276),
    [anon_sym_LT_LT] = ACTIONS(1274),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_GT_GT_GT] = ACTIONS(1274),
    [anon_sym_AMP] = ACTIONS(1276),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_CARET] = ACTIONS(1274),
    [anon_sym_AMP_AMP] = ACTIONS(1274),
    [anon_sym_PIPE_PIPE] = ACTIONS(1274),
    [anon_sym_EQ_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_LT_EQ] = ACTIONS(1274),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_EQ] = ACTIONS(1274),
    [anon_sym_EQ_GT] = ACTIONS(1274),
    [anon_sym_QMARK_QMARK] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1276),
    [sym__rangeOperator] = ACTIONS(1274),
    [anon_sym_null] = ACTIONS(1276),
    [anon_sym_dynamic] = ACTIONS(1276),
    [anon_sym_final] = ACTIONS(1276),
    [anon_sym_abstract] = ACTIONS(1276),
    [anon_sym_class] = ACTIONS(1276),
    [anon_sym_extends] = ACTIONS(1276),
    [anon_sym_implements] = ACTIONS(1276),
    [anon_sym_interface] = ACTIONS(1276),
    [anon_sym_typedef] = ACTIONS(1276),
    [anon_sym_function] = ACTIONS(1276),
    [anon_sym_var] = ACTIONS(1276),
    [aux_sym_integer_token1] = ACTIONS(1276),
    [aux_sym_integer_token2] = ACTIONS(1274),
    [aux_sym_float_token1] = ACTIONS(1276),
    [aux_sym_float_token2] = ACTIONS(1274),
    [anon_sym_true] = ACTIONS(1276),
    [anon_sym_false] = ACTIONS(1276),
    [aux_sym_string_token1] = ACTIONS(1274),
    [aux_sym_string_token3] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_catch] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_do] = ACTIONS(1276),
    [anon_sym_enum] = ACTIONS(1276),
    [anon_sym_extern] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_inline] = ACTIONS(1276),
    [anon_sym_macro] = ACTIONS(1276),
    [anon_sym_operator] = ACTIONS(1276),
    [anon_sym_overload] = ACTIONS(1276),
    [anon_sym_override] = ACTIONS(1276),
    [anon_sym_private] = ACTIONS(1276),
    [anon_sym_public] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_static] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_untyped] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [sym__semicolon] = ACTIONS(1274),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1278),
    [sym_identifier] = ACTIONS(1280),
    [anon_sym_POUND] = ACTIONS(1278),
    [anon_sym_package] = ACTIONS(1280),
    [anon_sym_import] = ACTIONS(1280),
    [anon_sym_using] = ACTIONS(1280),
    [anon_sym_throw] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_switch] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [anon_sym_case] = ACTIONS(1280),
    [anon_sym_default] = ACTIONS(1280),
    [anon_sym_cast] = ACTIONS(1280),
    [anon_sym_DOLLARtype] = ACTIONS(1278),
    [anon_sym_in] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_this] = ACTIONS(1280),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_AT_COLON] = ACTIONS(1278),
    [anon_sym_if] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1280),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_PLUS_PLUS] = ACTIONS(1278),
    [anon_sym_DASH_DASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(1280),
    [anon_sym_GT_GT_GT] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_CARET] = ACTIONS(1278),
    [anon_sym_AMP_AMP] = ACTIONS(1278),
    [anon_sym_PIPE_PIPE] = ACTIONS(1278),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_EQ] = ACTIONS(1278),
    [anon_sym_EQ_GT] = ACTIONS(1278),
    [anon_sym_QMARK_QMARK] = ACTIONS(1278),
    [anon_sym_EQ] = ACTIONS(1280),
    [sym__rangeOperator] = ACTIONS(1278),
    [anon_sym_null] = ACTIONS(1280),
    [anon_sym_dynamic] = ACTIONS(1280),
    [anon_sym_final] = ACTIONS(1280),
    [anon_sym_abstract] = ACTIONS(1280),
    [anon_sym_class] = ACTIONS(1280),
    [anon_sym_extends] = ACTIONS(1280),
    [anon_sym_implements] = ACTIONS(1280),
    [anon_sym_interface] = ACTIONS(1280),
    [anon_sym_typedef] = ACTIONS(1280),
    [anon_sym_function] = ACTIONS(1280),
    [anon_sym_var] = ACTIONS(1280),
    [aux_sym_integer_token1] = ACTIONS(1280),
    [aux_sym_integer_token2] = ACTIONS(1278),
    [aux_sym_float_token1] = ACTIONS(1280),
    [aux_sym_float_token2] = ACTIONS(1278),
    [anon_sym_true] = ACTIONS(1280),
    [anon_sym_false] = ACTIONS(1280),
    [aux_sym_string_token1] = ACTIONS(1278),
    [aux_sym_string_token3] = ACTIONS(1278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1280),
    [anon_sym_catch] = ACTIONS(1280),
    [anon_sym_continue] = ACTIONS(1280),
    [anon_sym_do] = ACTIONS(1280),
    [anon_sym_enum] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1280),
    [anon_sym_for] = ACTIONS(1280),
    [anon_sym_inline] = ACTIONS(1280),
    [anon_sym_macro] = ACTIONS(1280),
    [anon_sym_operator] = ACTIONS(1280),
    [anon_sym_overload] = ACTIONS(1280),
    [anon_sym_override] = ACTIONS(1280),
    [anon_sym_private] = ACTIONS(1280),
    [anon_sym_public] = ACTIONS(1280),
    [anon_sym_return] = ACTIONS(1280),
    [anon_sym_static] = ACTIONS(1280),
    [anon_sym_try] = ACTIONS(1280),
    [anon_sym_untyped] = ACTIONS(1280),
    [anon_sym_while] = ACTIONS(1280),
    [sym__semicolon] = ACTIONS(1278),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1282),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_POUND] = ACTIONS(1282),
    [anon_sym_package] = ACTIONS(1284),
    [anon_sym_import] = ACTIONS(1284),
    [anon_sym_using] = ACTIONS(1284),
    [anon_sym_throw] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_switch] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_case] = ACTIONS(1284),
    [anon_sym_default] = ACTIONS(1284),
    [anon_sym_cast] = ACTIONS(1284),
    [anon_sym_DOLLARtype] = ACTIONS(1282),
    [anon_sym_in] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_this] = ACTIONS(1284),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_AT_COLON] = ACTIONS(1282),
    [anon_sym_if] = ACTIONS(1284),
    [anon_sym_else] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1284),
    [anon_sym_GT_GT_GT] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_CARET] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BANG_EQ] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_EQ_GT] = ACTIONS(1282),
    [anon_sym_QMARK_QMARK] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1284),
    [sym__rangeOperator] = ACTIONS(1282),
    [anon_sym_null] = ACTIONS(1284),
    [anon_sym_dynamic] = ACTIONS(1284),
    [anon_sym_final] = ACTIONS(1284),
    [anon_sym_abstract] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1284),
    [anon_sym_extends] = ACTIONS(1284),
    [anon_sym_implements] = ACTIONS(1284),
    [anon_sym_interface] = ACTIONS(1284),
    [anon_sym_typedef] = ACTIONS(1284),
    [anon_sym_function] = ACTIONS(1284),
    [anon_sym_var] = ACTIONS(1284),
    [aux_sym_integer_token1] = ACTIONS(1284),
    [aux_sym_integer_token2] = ACTIONS(1282),
    [aux_sym_float_token1] = ACTIONS(1284),
    [aux_sym_float_token2] = ACTIONS(1282),
    [anon_sym_true] = ACTIONS(1284),
    [anon_sym_false] = ACTIONS(1284),
    [aux_sym_string_token1] = ACTIONS(1282),
    [aux_sym_string_token3] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1284),
    [anon_sym_catch] = ACTIONS(1284),
    [anon_sym_continue] = ACTIONS(1284),
    [anon_sym_do] = ACTIONS(1284),
    [anon_sym_enum] = ACTIONS(1284),
    [anon_sym_extern] = ACTIONS(1284),
    [anon_sym_for] = ACTIONS(1284),
    [anon_sym_inline] = ACTIONS(1284),
    [anon_sym_macro] = ACTIONS(1284),
    [anon_sym_operator] = ACTIONS(1284),
    [anon_sym_overload] = ACTIONS(1284),
    [anon_sym_override] = ACTIONS(1284),
    [anon_sym_private] = ACTIONS(1284),
    [anon_sym_public] = ACTIONS(1284),
    [anon_sym_return] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1284),
    [anon_sym_try] = ACTIONS(1284),
    [anon_sym_untyped] = ACTIONS(1284),
    [anon_sym_while] = ACTIONS(1284),
    [sym__semicolon] = ACTIONS(1282),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(1286),
    [sym_identifier] = ACTIONS(1288),
    [anon_sym_POUND] = ACTIONS(1286),
    [anon_sym_package] = ACTIONS(1288),
    [anon_sym_import] = ACTIONS(1288),
    [anon_sym_using] = ACTIONS(1288),
    [anon_sym_throw] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [anon_sym_case] = ACTIONS(1288),
    [anon_sym_default] = ACTIONS(1288),
    [anon_sym_cast] = ACTIONS(1288),
    [anon_sym_DOLLARtype] = ACTIONS(1286),
    [anon_sym_in] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1286),
    [anon_sym_this] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_AT_COLON] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1288),
    [anon_sym_else] = ACTIONS(1288),
    [anon_sym_new] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PERCENT] = ACTIONS(1286),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_SLASH] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_LT_LT] = ACTIONS(1286),
    [anon_sym_GT_GT] = ACTIONS(1288),
    [anon_sym_GT_GT_GT] = ACTIONS(1286),
    [anon_sym_AMP] = ACTIONS(1288),
    [anon_sym_PIPE] = ACTIONS(1288),
    [anon_sym_CARET] = ACTIONS(1286),
    [anon_sym_AMP_AMP] = ACTIONS(1286),
    [anon_sym_PIPE_PIPE] = ACTIONS(1286),
    [anon_sym_EQ_EQ] = ACTIONS(1286),
    [anon_sym_BANG_EQ] = ACTIONS(1286),
    [anon_sym_LT] = ACTIONS(1288),
    [anon_sym_LT_EQ] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(1288),
    [anon_sym_GT_EQ] = ACTIONS(1286),
    [anon_sym_EQ_GT] = ACTIONS(1286),
    [anon_sym_QMARK_QMARK] = ACTIONS(1286),
    [anon_sym_EQ] = ACTIONS(1288),
    [sym__rangeOperator] = ACTIONS(1286),
    [anon_sym_null] = ACTIONS(1288),
    [anon_sym_dynamic] = ACTIONS(1288),
    [anon_sym_final] = ACTIONS(1288),
    [anon_sym_abstract] = ACTIONS(1288),
    [anon_sym_class] = ACTIONS(1288),
    [anon_sym_extends] = ACTIONS(1288),
    [anon_sym_implements] = ACTIONS(1288),
    [anon_sym_interface] = ACTIONS(1288),
    [anon_sym_typedef] = ACTIONS(1288),
    [anon_sym_function] = ACTIONS(1288),
    [anon_sym_var] = ACTIONS(1288),
    [aux_sym_integer_token1] = ACTIONS(1288),
    [aux_sym_integer_token2] = ACTIONS(1286),
    [aux_sym_float_token1] = ACTIONS(1288),
    [aux_sym_float_token2] = ACTIONS(1286),
    [anon_sym_true] = ACTIONS(1288),
    [anon_sym_false] = ACTIONS(1288),
    [aux_sym_string_token1] = ACTIONS(1286),
    [aux_sym_string_token3] = ACTIONS(1286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1288),
    [anon_sym_catch] = ACTIONS(1288),
    [anon_sym_continue] = ACTIONS(1288),
    [anon_sym_do] = ACTIONS(1288),
    [anon_sym_enum] = ACTIONS(1288),
    [anon_sym_extern] = ACTIONS(1288),
    [anon_sym_for] = ACTIONS(1288),
    [anon_sym_inline] = ACTIONS(1288),
    [anon_sym_macro] = ACTIONS(1288),
    [anon_sym_operator] = ACTIONS(1288),
    [anon_sym_overload] = ACTIONS(1288),
    [anon_sym_override] = ACTIONS(1288),
    [anon_sym_private] = ACTIONS(1288),
    [anon_sym_public] = ACTIONS(1288),
    [anon_sym_return] = ACTIONS(1288),
    [anon_sym_static] = ACTIONS(1288),
    [anon_sym_try] = ACTIONS(1288),
    [anon_sym_untyped] = ACTIONS(1288),
    [anon_sym_while] = ACTIONS(1288),
    [sym__semicolon] = ACTIONS(1286),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_POUND] = ACTIONS(1290),
    [anon_sym_package] = ACTIONS(1292),
    [anon_sym_import] = ACTIONS(1292),
    [anon_sym_using] = ACTIONS(1292),
    [anon_sym_throw] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_cast] = ACTIONS(1292),
    [anon_sym_DOLLARtype] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_this] = ACTIONS(1292),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_AT_COLON] = ACTIONS(1290),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1290),
    [anon_sym_SLASH] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_EQ_GT] = ACTIONS(1290),
    [anon_sym_QMARK_QMARK] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1292),
    [sym__rangeOperator] = ACTIONS(1290),
    [anon_sym_null] = ACTIONS(1292),
    [anon_sym_dynamic] = ACTIONS(1292),
    [anon_sym_final] = ACTIONS(1292),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_class] = ACTIONS(1292),
    [anon_sym_extends] = ACTIONS(1292),
    [anon_sym_implements] = ACTIONS(1292),
    [anon_sym_interface] = ACTIONS(1292),
    [anon_sym_typedef] = ACTIONS(1292),
    [anon_sym_function] = ACTIONS(1292),
    [anon_sym_var] = ACTIONS(1292),
    [aux_sym_integer_token1] = ACTIONS(1292),
    [aux_sym_integer_token2] = ACTIONS(1290),
    [aux_sym_float_token1] = ACTIONS(1292),
    [aux_sym_float_token2] = ACTIONS(1290),
    [anon_sym_true] = ACTIONS(1292),
    [anon_sym_false] = ACTIONS(1292),
    [aux_sym_string_token1] = ACTIONS(1290),
    [aux_sym_string_token3] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_catch] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym_macro] = ACTIONS(1292),
    [anon_sym_operator] = ACTIONS(1292),
    [anon_sym_overload] = ACTIONS(1292),
    [anon_sym_override] = ACTIONS(1292),
    [anon_sym_private] = ACTIONS(1292),
    [anon_sym_public] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(1292),
    [anon_sym_untyped] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [sym__semicolon] = ACTIONS(1290),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(1294),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_POUND] = ACTIONS(1294),
    [anon_sym_package] = ACTIONS(1296),
    [anon_sym_import] = ACTIONS(1296),
    [anon_sym_using] = ACTIONS(1296),
    [anon_sym_throw] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [anon_sym_switch] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_case] = ACTIONS(1296),
    [anon_sym_default] = ACTIONS(1296),
    [anon_sym_cast] = ACTIONS(1296),
    [anon_sym_DOLLARtype] = ACTIONS(1294),
    [anon_sym_in] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_this] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_AT_COLON] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1296),
    [anon_sym_else] = ACTIONS(1296),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PERCENT] = ACTIONS(1294),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_SLASH] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_LT_LT] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1296),
    [anon_sym_GT_GT_GT] = ACTIONS(1294),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_PIPE] = ACTIONS(1296),
    [anon_sym_CARET] = ACTIONS(1294),
    [anon_sym_AMP_AMP] = ACTIONS(1294),
    [anon_sym_PIPE_PIPE] = ACTIONS(1294),
    [anon_sym_EQ_EQ] = ACTIONS(1294),
    [anon_sym_BANG_EQ] = ACTIONS(1294),
    [anon_sym_LT] = ACTIONS(1296),
    [anon_sym_LT_EQ] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1296),
    [anon_sym_GT_EQ] = ACTIONS(1294),
    [anon_sym_EQ_GT] = ACTIONS(1294),
    [anon_sym_QMARK_QMARK] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(1296),
    [sym__rangeOperator] = ACTIONS(1294),
    [anon_sym_null] = ACTIONS(1296),
    [anon_sym_dynamic] = ACTIONS(1296),
    [anon_sym_final] = ACTIONS(1296),
    [anon_sym_abstract] = ACTIONS(1296),
    [anon_sym_class] = ACTIONS(1296),
    [anon_sym_extends] = ACTIONS(1296),
    [anon_sym_implements] = ACTIONS(1296),
    [anon_sym_interface] = ACTIONS(1296),
    [anon_sym_typedef] = ACTIONS(1296),
    [anon_sym_function] = ACTIONS(1296),
    [anon_sym_var] = ACTIONS(1296),
    [aux_sym_integer_token1] = ACTIONS(1296),
    [aux_sym_integer_token2] = ACTIONS(1294),
    [aux_sym_float_token1] = ACTIONS(1296),
    [aux_sym_float_token2] = ACTIONS(1294),
    [anon_sym_true] = ACTIONS(1296),
    [anon_sym_false] = ACTIONS(1296),
    [aux_sym_string_token1] = ACTIONS(1294),
    [aux_sym_string_token3] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1296),
    [anon_sym_catch] = ACTIONS(1296),
    [anon_sym_continue] = ACTIONS(1296),
    [anon_sym_do] = ACTIONS(1296),
    [anon_sym_enum] = ACTIONS(1296),
    [anon_sym_extern] = ACTIONS(1296),
    [anon_sym_for] = ACTIONS(1296),
    [anon_sym_inline] = ACTIONS(1296),
    [anon_sym_macro] = ACTIONS(1296),
    [anon_sym_operator] = ACTIONS(1296),
    [anon_sym_overload] = ACTIONS(1296),
    [anon_sym_override] = ACTIONS(1296),
    [anon_sym_private] = ACTIONS(1296),
    [anon_sym_public] = ACTIONS(1296),
    [anon_sym_return] = ACTIONS(1296),
    [anon_sym_static] = ACTIONS(1296),
    [anon_sym_try] = ACTIONS(1296),
    [anon_sym_untyped] = ACTIONS(1296),
    [anon_sym_while] = ACTIONS(1296),
    [sym__semicolon] = ACTIONS(1294),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym_identifier] = ACTIONS(1300),
    [anon_sym_POUND] = ACTIONS(1298),
    [anon_sym_package] = ACTIONS(1300),
    [anon_sym_import] = ACTIONS(1300),
    [anon_sym_using] = ACTIONS(1300),
    [anon_sym_throw] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1298),
    [anon_sym_switch] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [anon_sym_case] = ACTIONS(1300),
    [anon_sym_default] = ACTIONS(1300),
    [anon_sym_cast] = ACTIONS(1300),
    [anon_sym_DOLLARtype] = ACTIONS(1298),
    [anon_sym_in] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_this] = ACTIONS(1300),
    [anon_sym_AT] = ACTIONS(1300),
    [anon_sym_AT_COLON] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1300),
    [anon_sym_else] = ACTIONS(1300),
    [anon_sym_new] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1298),
    [anon_sym_PERCENT] = ACTIONS(1298),
    [anon_sym_STAR] = ACTIONS(1298),
    [anon_sym_SLASH] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1300),
    [anon_sym_LT_LT] = ACTIONS(1298),
    [anon_sym_GT_GT] = ACTIONS(1300),
    [anon_sym_GT_GT_GT] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_PIPE] = ACTIONS(1300),
    [anon_sym_CARET] = ACTIONS(1298),
    [anon_sym_AMP_AMP] = ACTIONS(1298),
    [anon_sym_PIPE_PIPE] = ACTIONS(1298),
    [anon_sym_EQ_EQ] = ACTIONS(1298),
    [anon_sym_BANG_EQ] = ACTIONS(1298),
    [anon_sym_LT] = ACTIONS(1300),
    [anon_sym_LT_EQ] = ACTIONS(1298),
    [anon_sym_GT] = ACTIONS(1300),
    [anon_sym_GT_EQ] = ACTIONS(1298),
    [anon_sym_EQ_GT] = ACTIONS(1298),
    [anon_sym_QMARK_QMARK] = ACTIONS(1298),
    [anon_sym_EQ] = ACTIONS(1300),
    [sym__rangeOperator] = ACTIONS(1298),
    [anon_sym_null] = ACTIONS(1300),
    [anon_sym_dynamic] = ACTIONS(1300),
    [anon_sym_final] = ACTIONS(1300),
    [anon_sym_abstract] = ACTIONS(1300),
    [anon_sym_class] = ACTIONS(1300),
    [anon_sym_extends] = ACTIONS(1300),
    [anon_sym_implements] = ACTIONS(1300),
    [anon_sym_interface] = ACTIONS(1300),
    [anon_sym_typedef] = ACTIONS(1300),
    [anon_sym_function] = ACTIONS(1300),
    [anon_sym_var] = ACTIONS(1300),
    [aux_sym_integer_token1] = ACTIONS(1300),
    [aux_sym_integer_token2] = ACTIONS(1298),
    [aux_sym_float_token1] = ACTIONS(1300),
    [aux_sym_float_token2] = ACTIONS(1298),
    [anon_sym_true] = ACTIONS(1300),
    [anon_sym_false] = ACTIONS(1300),
    [aux_sym_string_token1] = ACTIONS(1298),
    [aux_sym_string_token3] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_catch] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_do] = ACTIONS(1300),
    [anon_sym_enum] = ACTIONS(1300),
    [anon_sym_extern] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_inline] = ACTIONS(1300),
    [anon_sym_macro] = ACTIONS(1300),
    [anon_sym_operator] = ACTIONS(1300),
    [anon_sym_overload] = ACTIONS(1300),
    [anon_sym_override] = ACTIONS(1300),
    [anon_sym_private] = ACTIONS(1300),
    [anon_sym_public] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_static] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_untyped] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [sym__semicolon] = ACTIONS(1298),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [sym_identifier] = ACTIONS(1304),
    [anon_sym_POUND] = ACTIONS(1302),
    [anon_sym_package] = ACTIONS(1304),
    [anon_sym_import] = ACTIONS(1304),
    [anon_sym_using] = ACTIONS(1304),
    [anon_sym_throw] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_switch] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_case] = ACTIONS(1304),
    [anon_sym_default] = ACTIONS(1304),
    [anon_sym_cast] = ACTIONS(1304),
    [anon_sym_DOLLARtype] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_this] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_AT_COLON] = ACTIONS(1302),
    [anon_sym_if] = ACTIONS(1304),
    [anon_sym_else] = ACTIONS(1304),
    [anon_sym_new] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1302),
    [anon_sym_PERCENT] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_SLASH] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1302),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_GT_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP] = ACTIONS(1304),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_CARET] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_EQ_EQ] = ACTIONS(1302),
    [anon_sym_BANG_EQ] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_LT_EQ] = ACTIONS(1302),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1302),
    [anon_sym_EQ_GT] = ACTIONS(1302),
    [anon_sym_QMARK_QMARK] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(1304),
    [sym__rangeOperator] = ACTIONS(1302),
    [anon_sym_null] = ACTIONS(1304),
    [anon_sym_dynamic] = ACTIONS(1304),
    [anon_sym_final] = ACTIONS(1304),
    [anon_sym_abstract] = ACTIONS(1304),
    [anon_sym_class] = ACTIONS(1304),
    [anon_sym_extends] = ACTIONS(1304),
    [anon_sym_implements] = ACTIONS(1304),
    [anon_sym_interface] = ACTIONS(1304),
    [anon_sym_typedef] = ACTIONS(1304),
    [anon_sym_function] = ACTIONS(1304),
    [anon_sym_var] = ACTIONS(1304),
    [aux_sym_integer_token1] = ACTIONS(1304),
    [aux_sym_integer_token2] = ACTIONS(1302),
    [aux_sym_float_token1] = ACTIONS(1304),
    [aux_sym_float_token2] = ACTIONS(1302),
    [anon_sym_true] = ACTIONS(1304),
    [anon_sym_false] = ACTIONS(1304),
    [aux_sym_string_token1] = ACTIONS(1302),
    [aux_sym_string_token3] = ACTIONS(1302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1304),
    [anon_sym_catch] = ACTIONS(1304),
    [anon_sym_continue] = ACTIONS(1304),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_enum] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(1304),
    [anon_sym_for] = ACTIONS(1304),
    [anon_sym_inline] = ACTIONS(1304),
    [anon_sym_macro] = ACTIONS(1304),
    [anon_sym_operator] = ACTIONS(1304),
    [anon_sym_overload] = ACTIONS(1304),
    [anon_sym_override] = ACTIONS(1304),
    [anon_sym_private] = ACTIONS(1304),
    [anon_sym_public] = ACTIONS(1304),
    [anon_sym_return] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1304),
    [anon_sym_untyped] = ACTIONS(1304),
    [anon_sym_while] = ACTIONS(1304),
    [sym__semicolon] = ACTIONS(1302),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1306),
    [sym_identifier] = ACTIONS(1308),
    [anon_sym_POUND] = ACTIONS(1306),
    [anon_sym_package] = ACTIONS(1308),
    [anon_sym_import] = ACTIONS(1308),
    [anon_sym_using] = ACTIONS(1308),
    [anon_sym_throw] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [anon_sym_switch] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1306),
    [anon_sym_RBRACE] = ACTIONS(1306),
    [anon_sym_case] = ACTIONS(1308),
    [anon_sym_default] = ACTIONS(1308),
    [anon_sym_cast] = ACTIONS(1308),
    [anon_sym_DOLLARtype] = ACTIONS(1306),
    [anon_sym_in] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(1306),
    [anon_sym_this] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_AT_COLON] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1308),
    [anon_sym_else] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1306),
    [anon_sym_PERCENT] = ACTIONS(1306),
    [anon_sym_STAR] = ACTIONS(1306),
    [anon_sym_SLASH] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1308),
    [anon_sym_LT_LT] = ACTIONS(1306),
    [anon_sym_GT_GT] = ACTIONS(1308),
    [anon_sym_GT_GT_GT] = ACTIONS(1306),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_CARET] = ACTIONS(1306),
    [anon_sym_AMP_AMP] = ACTIONS(1306),
    [anon_sym_PIPE_PIPE] = ACTIONS(1306),
    [anon_sym_EQ_EQ] = ACTIONS(1306),
    [anon_sym_BANG_EQ] = ACTIONS(1306),
    [anon_sym_LT] = ACTIONS(1308),
    [anon_sym_LT_EQ] = ACTIONS(1306),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_GT_EQ] = ACTIONS(1306),
    [anon_sym_EQ_GT] = ACTIONS(1306),
    [anon_sym_QMARK_QMARK] = ACTIONS(1306),
    [anon_sym_EQ] = ACTIONS(1308),
    [sym__rangeOperator] = ACTIONS(1306),
    [anon_sym_null] = ACTIONS(1308),
    [anon_sym_dynamic] = ACTIONS(1308),
    [anon_sym_final] = ACTIONS(1308),
    [anon_sym_abstract] = ACTIONS(1308),
    [anon_sym_class] = ACTIONS(1308),
    [anon_sym_extends] = ACTIONS(1308),
    [anon_sym_implements] = ACTIONS(1308),
    [anon_sym_interface] = ACTIONS(1308),
    [anon_sym_typedef] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(1308),
    [anon_sym_var] = ACTIONS(1308),
    [aux_sym_integer_token1] = ACTIONS(1308),
    [aux_sym_integer_token2] = ACTIONS(1306),
    [aux_sym_float_token1] = ACTIONS(1308),
    [aux_sym_float_token2] = ACTIONS(1306),
    [anon_sym_true] = ACTIONS(1308),
    [anon_sym_false] = ACTIONS(1308),
    [aux_sym_string_token1] = ACTIONS(1306),
    [aux_sym_string_token3] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1308),
    [anon_sym_catch] = ACTIONS(1308),
    [anon_sym_continue] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(1308),
    [anon_sym_enum] = ACTIONS(1308),
    [anon_sym_extern] = ACTIONS(1308),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_inline] = ACTIONS(1308),
    [anon_sym_macro] = ACTIONS(1308),
    [anon_sym_operator] = ACTIONS(1308),
    [anon_sym_overload] = ACTIONS(1308),
    [anon_sym_override] = ACTIONS(1308),
    [anon_sym_private] = ACTIONS(1308),
    [anon_sym_public] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(1308),
    [anon_sym_try] = ACTIONS(1308),
    [anon_sym_untyped] = ACTIONS(1308),
    [anon_sym_while] = ACTIONS(1308),
    [sym__semicolon] = ACTIONS(1306),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [sym_identifier] = ACTIONS(1312),
    [anon_sym_POUND] = ACTIONS(1310),
    [anon_sym_package] = ACTIONS(1312),
    [anon_sym_import] = ACTIONS(1312),
    [anon_sym_using] = ACTIONS(1312),
    [anon_sym_throw] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_switch] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_cast] = ACTIONS(1312),
    [anon_sym_DOLLARtype] = ACTIONS(1310),
    [anon_sym_in] = ACTIONS(1312),
    [anon_sym_LBRACK] = ACTIONS(1310),
    [anon_sym_this] = ACTIONS(1312),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_AT_COLON] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1312),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_new] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1312),
    [anon_sym_PLUS] = ACTIONS(1312),
    [anon_sym_LT_LT] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(1312),
    [anon_sym_GT_GT_GT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1312),
    [anon_sym_PIPE] = ACTIONS(1312),
    [anon_sym_CARET] = ACTIONS(1310),
    [anon_sym_AMP_AMP] = ACTIONS(1310),
    [anon_sym_PIPE_PIPE] = ACTIONS(1310),
    [anon_sym_EQ_EQ] = ACTIONS(1310),
    [anon_sym_BANG_EQ] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1312),
    [anon_sym_LT_EQ] = ACTIONS(1310),
    [anon_sym_GT] = ACTIONS(1312),
    [anon_sym_GT_EQ] = ACTIONS(1310),
    [anon_sym_EQ_GT] = ACTIONS(1310),
    [anon_sym_QMARK_QMARK] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1312),
    [sym__rangeOperator] = ACTIONS(1310),
    [anon_sym_null] = ACTIONS(1312),
    [anon_sym_dynamic] = ACTIONS(1312),
    [anon_sym_final] = ACTIONS(1312),
    [anon_sym_abstract] = ACTIONS(1312),
    [anon_sym_class] = ACTIONS(1312),
    [anon_sym_extends] = ACTIONS(1312),
    [anon_sym_implements] = ACTIONS(1312),
    [anon_sym_interface] = ACTIONS(1312),
    [anon_sym_typedef] = ACTIONS(1312),
    [anon_sym_function] = ACTIONS(1312),
    [anon_sym_var] = ACTIONS(1312),
    [aux_sym_integer_token1] = ACTIONS(1312),
    [aux_sym_integer_token2] = ACTIONS(1310),
    [aux_sym_float_token1] = ACTIONS(1312),
    [aux_sym_float_token2] = ACTIONS(1310),
    [anon_sym_true] = ACTIONS(1312),
    [anon_sym_false] = ACTIONS(1312),
    [aux_sym_string_token1] = ACTIONS(1310),
    [aux_sym_string_token3] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1312),
    [anon_sym_catch] = ACTIONS(1312),
    [anon_sym_continue] = ACTIONS(1312),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_enum] = ACTIONS(1312),
    [anon_sym_extern] = ACTIONS(1312),
    [anon_sym_for] = ACTIONS(1312),
    [anon_sym_inline] = ACTIONS(1312),
    [anon_sym_macro] = ACTIONS(1312),
    [anon_sym_operator] = ACTIONS(1312),
    [anon_sym_overload] = ACTIONS(1312),
    [anon_sym_override] = ACTIONS(1312),
    [anon_sym_private] = ACTIONS(1312),
    [anon_sym_public] = ACTIONS(1312),
    [anon_sym_return] = ACTIONS(1312),
    [anon_sym_static] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(1312),
    [anon_sym_untyped] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(1312),
    [sym__semicolon] = ACTIONS(1310),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1314),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1314),
    [anon_sym_package] = ACTIONS(1316),
    [anon_sym_import] = ACTIONS(1316),
    [anon_sym_using] = ACTIONS(1316),
    [anon_sym_throw] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_cast] = ACTIONS(1316),
    [anon_sym_DOLLARtype] = ACTIONS(1314),
    [anon_sym_in] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_this] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_AT_COLON] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [anon_sym_PERCENT] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_LT_LT] = ACTIONS(1314),
    [anon_sym_GT_GT] = ACTIONS(1316),
    [anon_sym_GT_GT_GT] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_CARET] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_EQ_EQ] = ACTIONS(1314),
    [anon_sym_BANG_EQ] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(1316),
    [anon_sym_LT_EQ] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_GT_EQ] = ACTIONS(1314),
    [anon_sym_EQ_GT] = ACTIONS(1314),
    [anon_sym_QMARK_QMARK] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(1316),
    [sym__rangeOperator] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1316),
    [anon_sym_dynamic] = ACTIONS(1316),
    [anon_sym_final] = ACTIONS(1316),
    [anon_sym_abstract] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1316),
    [anon_sym_extends] = ACTIONS(1316),
    [anon_sym_implements] = ACTIONS(1316),
    [anon_sym_interface] = ACTIONS(1316),
    [anon_sym_typedef] = ACTIONS(1316),
    [anon_sym_function] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [aux_sym_integer_token1] = ACTIONS(1316),
    [aux_sym_integer_token2] = ACTIONS(1314),
    [aux_sym_float_token1] = ACTIONS(1316),
    [aux_sym_float_token2] = ACTIONS(1314),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [aux_sym_string_token1] = ACTIONS(1314),
    [aux_sym_string_token3] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_catch] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_do] = ACTIONS(1316),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_extern] = ACTIONS(1316),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_inline] = ACTIONS(1316),
    [anon_sym_macro] = ACTIONS(1316),
    [anon_sym_operator] = ACTIONS(1316),
    [anon_sym_overload] = ACTIONS(1316),
    [anon_sym_override] = ACTIONS(1316),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_untyped] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [sym__semicolon] = ACTIONS(1314),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym_identifier] = ACTIONS(1320),
    [anon_sym_POUND] = ACTIONS(1318),
    [anon_sym_package] = ACTIONS(1320),
    [anon_sym_import] = ACTIONS(1320),
    [anon_sym_using] = ACTIONS(1320),
    [anon_sym_throw] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_switch] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_cast] = ACTIONS(1320),
    [anon_sym_DOLLARtype] = ACTIONS(1318),
    [anon_sym_in] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_this] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_AT_COLON] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_new] = ACTIONS(1320),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PERCENT] = ACTIONS(1318),
    [anon_sym_STAR] = ACTIONS(1318),
    [anon_sym_SLASH] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_LT_LT] = ACTIONS(1318),
    [anon_sym_GT_GT] = ACTIONS(1320),
    [anon_sym_GT_GT_GT] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1320),
    [anon_sym_PIPE] = ACTIONS(1320),
    [anon_sym_CARET] = ACTIONS(1318),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_PIPE_PIPE] = ACTIONS(1318),
    [anon_sym_EQ_EQ] = ACTIONS(1318),
    [anon_sym_BANG_EQ] = ACTIONS(1318),
    [anon_sym_LT] = ACTIONS(1320),
    [anon_sym_LT_EQ] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(1320),
    [anon_sym_GT_EQ] = ACTIONS(1318),
    [anon_sym_EQ_GT] = ACTIONS(1318),
    [anon_sym_QMARK_QMARK] = ACTIONS(1318),
    [anon_sym_EQ] = ACTIONS(1320),
    [sym__rangeOperator] = ACTIONS(1318),
    [anon_sym_null] = ACTIONS(1320),
    [anon_sym_dynamic] = ACTIONS(1320),
    [anon_sym_final] = ACTIONS(1320),
    [anon_sym_abstract] = ACTIONS(1320),
    [anon_sym_class] = ACTIONS(1320),
    [anon_sym_extends] = ACTIONS(1320),
    [anon_sym_implements] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1320),
    [anon_sym_typedef] = ACTIONS(1320),
    [anon_sym_function] = ACTIONS(1320),
    [anon_sym_var] = ACTIONS(1320),
    [aux_sym_integer_token1] = ACTIONS(1320),
    [aux_sym_integer_token2] = ACTIONS(1318),
    [aux_sym_float_token1] = ACTIONS(1320),
    [aux_sym_float_token2] = ACTIONS(1318),
    [anon_sym_true] = ACTIONS(1320),
    [anon_sym_false] = ACTIONS(1320),
    [aux_sym_string_token1] = ACTIONS(1318),
    [aux_sym_string_token3] = ACTIONS(1318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1320),
    [anon_sym_catch] = ACTIONS(1320),
    [anon_sym_continue] = ACTIONS(1320),
    [anon_sym_do] = ACTIONS(1320),
    [anon_sym_enum] = ACTIONS(1320),
    [anon_sym_extern] = ACTIONS(1320),
    [anon_sym_for] = ACTIONS(1320),
    [anon_sym_inline] = ACTIONS(1320),
    [anon_sym_macro] = ACTIONS(1320),
    [anon_sym_operator] = ACTIONS(1320),
    [anon_sym_overload] = ACTIONS(1320),
    [anon_sym_override] = ACTIONS(1320),
    [anon_sym_private] = ACTIONS(1320),
    [anon_sym_public] = ACTIONS(1320),
    [anon_sym_return] = ACTIONS(1320),
    [anon_sym_static] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(1320),
    [anon_sym_untyped] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(1320),
    [sym__semicolon] = ACTIONS(1318),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_identifier] = ACTIONS(1324),
    [anon_sym_POUND] = ACTIONS(1322),
    [anon_sym_package] = ACTIONS(1324),
    [anon_sym_import] = ACTIONS(1324),
    [anon_sym_using] = ACTIONS(1324),
    [anon_sym_throw] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [anon_sym_switch] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_case] = ACTIONS(1324),
    [anon_sym_default] = ACTIONS(1324),
    [anon_sym_cast] = ACTIONS(1324),
    [anon_sym_DOLLARtype] = ACTIONS(1322),
    [anon_sym_in] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_this] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_AT_COLON] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1324),
    [anon_sym_GT_GT_GT] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1324),
    [anon_sym_CARET] = ACTIONS(1322),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_PIPE_PIPE] = ACTIONS(1322),
    [anon_sym_EQ_EQ] = ACTIONS(1322),
    [anon_sym_BANG_EQ] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_EQ_GT] = ACTIONS(1322),
    [anon_sym_QMARK_QMARK] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(1324),
    [sym__rangeOperator] = ACTIONS(1322),
    [anon_sym_null] = ACTIONS(1324),
    [anon_sym_dynamic] = ACTIONS(1324),
    [anon_sym_final] = ACTIONS(1324),
    [anon_sym_abstract] = ACTIONS(1324),
    [anon_sym_class] = ACTIONS(1324),
    [anon_sym_extends] = ACTIONS(1324),
    [anon_sym_implements] = ACTIONS(1324),
    [anon_sym_interface] = ACTIONS(1324),
    [anon_sym_typedef] = ACTIONS(1324),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_var] = ACTIONS(1324),
    [aux_sym_integer_token1] = ACTIONS(1324),
    [aux_sym_integer_token2] = ACTIONS(1322),
    [aux_sym_float_token1] = ACTIONS(1324),
    [aux_sym_float_token2] = ACTIONS(1322),
    [anon_sym_true] = ACTIONS(1324),
    [anon_sym_false] = ACTIONS(1324),
    [aux_sym_string_token1] = ACTIONS(1322),
    [aux_sym_string_token3] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1324),
    [anon_sym_catch] = ACTIONS(1324),
    [anon_sym_continue] = ACTIONS(1324),
    [anon_sym_do] = ACTIONS(1324),
    [anon_sym_enum] = ACTIONS(1324),
    [anon_sym_extern] = ACTIONS(1324),
    [anon_sym_for] = ACTIONS(1324),
    [anon_sym_inline] = ACTIONS(1324),
    [anon_sym_macro] = ACTIONS(1324),
    [anon_sym_operator] = ACTIONS(1324),
    [anon_sym_overload] = ACTIONS(1324),
    [anon_sym_override] = ACTIONS(1324),
    [anon_sym_private] = ACTIONS(1324),
    [anon_sym_public] = ACTIONS(1324),
    [anon_sym_return] = ACTIONS(1324),
    [anon_sym_static] = ACTIONS(1324),
    [anon_sym_try] = ACTIONS(1324),
    [anon_sym_untyped] = ACTIONS(1324),
    [anon_sym_while] = ACTIONS(1324),
    [sym__semicolon] = ACTIONS(1322),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1326),
    [sym_identifier] = ACTIONS(1328),
    [anon_sym_POUND] = ACTIONS(1326),
    [anon_sym_package] = ACTIONS(1328),
    [anon_sym_import] = ACTIONS(1328),
    [anon_sym_using] = ACTIONS(1328),
    [anon_sym_throw] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1326),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_case] = ACTIONS(1328),
    [anon_sym_default] = ACTIONS(1328),
    [anon_sym_cast] = ACTIONS(1328),
    [anon_sym_DOLLARtype] = ACTIONS(1326),
    [anon_sym_in] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1326),
    [anon_sym_this] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_AT_COLON] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1328),
    [anon_sym_new] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_LT_LT] = ACTIONS(1326),
    [anon_sym_GT_GT] = ACTIONS(1328),
    [anon_sym_GT_GT_GT] = ACTIONS(1326),
    [anon_sym_AMP] = ACTIONS(1328),
    [anon_sym_PIPE] = ACTIONS(1328),
    [anon_sym_CARET] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1326),
    [anon_sym_PIPE_PIPE] = ACTIONS(1326),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(1328),
    [anon_sym_LT_EQ] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1328),
    [anon_sym_GT_EQ] = ACTIONS(1326),
    [anon_sym_EQ_GT] = ACTIONS(1326),
    [anon_sym_QMARK_QMARK] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1328),
    [sym__rangeOperator] = ACTIONS(1326),
    [anon_sym_null] = ACTIONS(1328),
    [anon_sym_dynamic] = ACTIONS(1328),
    [anon_sym_final] = ACTIONS(1328),
    [anon_sym_abstract] = ACTIONS(1328),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_extends] = ACTIONS(1328),
    [anon_sym_implements] = ACTIONS(1328),
    [anon_sym_interface] = ACTIONS(1328),
    [anon_sym_typedef] = ACTIONS(1328),
    [anon_sym_function] = ACTIONS(1328),
    [anon_sym_var] = ACTIONS(1328),
    [aux_sym_integer_token1] = ACTIONS(1328),
    [aux_sym_integer_token2] = ACTIONS(1326),
    [aux_sym_float_token1] = ACTIONS(1328),
    [aux_sym_float_token2] = ACTIONS(1326),
    [anon_sym_true] = ACTIONS(1328),
    [anon_sym_false] = ACTIONS(1328),
    [aux_sym_string_token1] = ACTIONS(1326),
    [aux_sym_string_token3] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1328),
    [anon_sym_catch] = ACTIONS(1328),
    [anon_sym_continue] = ACTIONS(1328),
    [anon_sym_do] = ACTIONS(1328),
    [anon_sym_enum] = ACTIONS(1328),
    [anon_sym_extern] = ACTIONS(1328),
    [anon_sym_for] = ACTIONS(1328),
    [anon_sym_inline] = ACTIONS(1328),
    [anon_sym_macro] = ACTIONS(1328),
    [anon_sym_operator] = ACTIONS(1328),
    [anon_sym_overload] = ACTIONS(1328),
    [anon_sym_override] = ACTIONS(1328),
    [anon_sym_private] = ACTIONS(1328),
    [anon_sym_public] = ACTIONS(1328),
    [anon_sym_return] = ACTIONS(1328),
    [anon_sym_static] = ACTIONS(1328),
    [anon_sym_try] = ACTIONS(1328),
    [anon_sym_untyped] = ACTIONS(1328),
    [anon_sym_while] = ACTIONS(1328),
    [sym__semicolon] = ACTIONS(1326),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_POUND] = ACTIONS(1330),
    [anon_sym_package] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_using] = ACTIONS(1332),
    [anon_sym_throw] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [anon_sym_switch] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [anon_sym_case] = ACTIONS(1332),
    [anon_sym_default] = ACTIONS(1332),
    [anon_sym_cast] = ACTIONS(1332),
    [anon_sym_DOLLARtype] = ACTIONS(1330),
    [anon_sym_in] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_this] = ACTIONS(1332),
    [anon_sym_AT] = ACTIONS(1332),
    [anon_sym_AT_COLON] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_new] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(1330),
    [anon_sym_STAR] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_LT_LT] = ACTIONS(1330),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1330),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1330),
    [anon_sym_AMP_AMP] = ACTIONS(1330),
    [anon_sym_PIPE_PIPE] = ACTIONS(1330),
    [anon_sym_EQ_EQ] = ACTIONS(1330),
    [anon_sym_BANG_EQ] = ACTIONS(1330),
    [anon_sym_LT] = ACTIONS(1332),
    [anon_sym_LT_EQ] = ACTIONS(1330),
    [anon_sym_GT] = ACTIONS(1332),
    [anon_sym_GT_EQ] = ACTIONS(1330),
    [anon_sym_EQ_GT] = ACTIONS(1330),
    [anon_sym_QMARK_QMARK] = ACTIONS(1330),
    [anon_sym_EQ] = ACTIONS(1332),
    [sym__rangeOperator] = ACTIONS(1330),
    [anon_sym_null] = ACTIONS(1332),
    [anon_sym_dynamic] = ACTIONS(1332),
    [anon_sym_final] = ACTIONS(1332),
    [anon_sym_abstract] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_extends] = ACTIONS(1332),
    [anon_sym_implements] = ACTIONS(1332),
    [anon_sym_interface] = ACTIONS(1332),
    [anon_sym_typedef] = ACTIONS(1332),
    [anon_sym_function] = ACTIONS(1332),
    [anon_sym_var] = ACTIONS(1332),
    [aux_sym_integer_token1] = ACTIONS(1332),
    [aux_sym_integer_token2] = ACTIONS(1330),
    [aux_sym_float_token1] = ACTIONS(1332),
    [aux_sym_float_token2] = ACTIONS(1330),
    [anon_sym_true] = ACTIONS(1332),
    [anon_sym_false] = ACTIONS(1332),
    [aux_sym_string_token1] = ACTIONS(1330),
    [aux_sym_string_token3] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_catch] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_do] = ACTIONS(1332),
    [anon_sym_enum] = ACTIONS(1332),
    [anon_sym_extern] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_inline] = ACTIONS(1332),
    [anon_sym_macro] = ACTIONS(1332),
    [anon_sym_operator] = ACTIONS(1332),
    [anon_sym_overload] = ACTIONS(1332),
    [anon_sym_override] = ACTIONS(1332),
    [anon_sym_private] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_static] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_untyped] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [sym__semicolon] = ACTIONS(1330),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1336),
    [anon_sym_POUND] = ACTIONS(1334),
    [anon_sym_package] = ACTIONS(1336),
    [anon_sym_import] = ACTIONS(1336),
    [anon_sym_using] = ACTIONS(1336),
    [anon_sym_throw] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_switch] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_case] = ACTIONS(1336),
    [anon_sym_default] = ACTIONS(1336),
    [anon_sym_cast] = ACTIONS(1336),
    [anon_sym_DOLLARtype] = ACTIONS(1334),
    [anon_sym_in] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_this] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1336),
    [anon_sym_AT_COLON] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1336),
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_new] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1334),
    [anon_sym_PERCENT] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_SLASH] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1334),
    [anon_sym_GT_GT] = ACTIONS(1336),
    [anon_sym_GT_GT_GT] = ACTIONS(1334),
    [anon_sym_AMP] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1336),
    [anon_sym_CARET] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(1334),
    [anon_sym_PIPE_PIPE] = ACTIONS(1334),
    [anon_sym_EQ_EQ] = ACTIONS(1334),
    [anon_sym_BANG_EQ] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1334),
    [anon_sym_GT] = ACTIONS(1336),
    [anon_sym_GT_EQ] = ACTIONS(1334),
    [anon_sym_EQ_GT] = ACTIONS(1334),
    [anon_sym_QMARK_QMARK] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1336),
    [sym__rangeOperator] = ACTIONS(1334),
    [anon_sym_null] = ACTIONS(1336),
    [anon_sym_dynamic] = ACTIONS(1336),
    [anon_sym_final] = ACTIONS(1336),
    [anon_sym_abstract] = ACTIONS(1336),
    [anon_sym_class] = ACTIONS(1336),
    [anon_sym_extends] = ACTIONS(1336),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_interface] = ACTIONS(1336),
    [anon_sym_typedef] = ACTIONS(1336),
    [anon_sym_function] = ACTIONS(1336),
    [anon_sym_var] = ACTIONS(1336),
    [aux_sym_integer_token1] = ACTIONS(1336),
    [aux_sym_integer_token2] = ACTIONS(1334),
    [aux_sym_float_token1] = ACTIONS(1336),
    [aux_sym_float_token2] = ACTIONS(1334),
    [anon_sym_true] = ACTIONS(1336),
    [anon_sym_false] = ACTIONS(1336),
    [aux_sym_string_token1] = ACTIONS(1334),
    [aux_sym_string_token3] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1336),
    [anon_sym_catch] = ACTIONS(1336),
    [anon_sym_continue] = ACTIONS(1336),
    [anon_sym_do] = ACTIONS(1336),
    [anon_sym_enum] = ACTIONS(1336),
    [anon_sym_extern] = ACTIONS(1336),
    [anon_sym_for] = ACTIONS(1336),
    [anon_sym_inline] = ACTIONS(1336),
    [anon_sym_macro] = ACTIONS(1336),
    [anon_sym_operator] = ACTIONS(1336),
    [anon_sym_overload] = ACTIONS(1336),
    [anon_sym_override] = ACTIONS(1336),
    [anon_sym_private] = ACTIONS(1336),
    [anon_sym_public] = ACTIONS(1336),
    [anon_sym_return] = ACTIONS(1336),
    [anon_sym_static] = ACTIONS(1336),
    [anon_sym_try] = ACTIONS(1336),
    [anon_sym_untyped] = ACTIONS(1336),
    [anon_sym_while] = ACTIONS(1336),
    [sym__semicolon] = ACTIONS(1334),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1338),
    [sym_identifier] = ACTIONS(1340),
    [anon_sym_POUND] = ACTIONS(1338),
    [anon_sym_package] = ACTIONS(1340),
    [anon_sym_import] = ACTIONS(1340),
    [anon_sym_using] = ACTIONS(1340),
    [anon_sym_throw] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [anon_sym_switch] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_case] = ACTIONS(1340),
    [anon_sym_default] = ACTIONS(1340),
    [anon_sym_cast] = ACTIONS(1340),
    [anon_sym_DOLLARtype] = ACTIONS(1338),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [anon_sym_this] = ACTIONS(1340),
    [anon_sym_AT] = ACTIONS(1340),
    [anon_sym_AT_COLON] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1340),
    [anon_sym_else] = ACTIONS(1340),
    [anon_sym_new] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1338),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_SLASH] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_CARET] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(1338),
    [anon_sym_EQ_EQ] = ACTIONS(1338),
    [anon_sym_BANG_EQ] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1338),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(1338),
    [anon_sym_QMARK_QMARK] = ACTIONS(1338),
    [anon_sym_EQ] = ACTIONS(1340),
    [sym__rangeOperator] = ACTIONS(1338),
    [anon_sym_null] = ACTIONS(1340),
    [anon_sym_dynamic] = ACTIONS(1340),
    [anon_sym_final] = ACTIONS(1340),
    [anon_sym_abstract] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1340),
    [anon_sym_extends] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1340),
    [anon_sym_interface] = ACTIONS(1340),
    [anon_sym_typedef] = ACTIONS(1340),
    [anon_sym_function] = ACTIONS(1340),
    [anon_sym_var] = ACTIONS(1340),
    [aux_sym_integer_token1] = ACTIONS(1340),
    [aux_sym_integer_token2] = ACTIONS(1338),
    [aux_sym_float_token1] = ACTIONS(1340),
    [aux_sym_float_token2] = ACTIONS(1338),
    [anon_sym_true] = ACTIONS(1340),
    [anon_sym_false] = ACTIONS(1340),
    [aux_sym_string_token1] = ACTIONS(1338),
    [aux_sym_string_token3] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1340),
    [anon_sym_catch] = ACTIONS(1340),
    [anon_sym_continue] = ACTIONS(1340),
    [anon_sym_do] = ACTIONS(1340),
    [anon_sym_enum] = ACTIONS(1340),
    [anon_sym_extern] = ACTIONS(1340),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_inline] = ACTIONS(1340),
    [anon_sym_macro] = ACTIONS(1340),
    [anon_sym_operator] = ACTIONS(1340),
    [anon_sym_overload] = ACTIONS(1340),
    [anon_sym_override] = ACTIONS(1340),
    [anon_sym_private] = ACTIONS(1340),
    [anon_sym_public] = ACTIONS(1340),
    [anon_sym_return] = ACTIONS(1340),
    [anon_sym_static] = ACTIONS(1340),
    [anon_sym_try] = ACTIONS(1340),
    [anon_sym_untyped] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1340),
    [sym__semicolon] = ACTIONS(1338),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1342),
    [sym_identifier] = ACTIONS(1344),
    [anon_sym_POUND] = ACTIONS(1342),
    [anon_sym_package] = ACTIONS(1344),
    [anon_sym_import] = ACTIONS(1344),
    [anon_sym_using] = ACTIONS(1344),
    [anon_sym_throw] = ACTIONS(1344),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_switch] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [anon_sym_case] = ACTIONS(1344),
    [anon_sym_default] = ACTIONS(1344),
    [anon_sym_cast] = ACTIONS(1344),
    [anon_sym_DOLLARtype] = ACTIONS(1342),
    [anon_sym_in] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_this] = ACTIONS(1344),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_AT_COLON] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1344),
    [anon_sym_new] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1342),
    [anon_sym_PERCENT] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_SLASH] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_LT_LT] = ACTIONS(1342),
    [anon_sym_GT_GT] = ACTIONS(1344),
    [anon_sym_GT_GT_GT] = ACTIONS(1342),
    [anon_sym_AMP] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1344),
    [anon_sym_CARET] = ACTIONS(1342),
    [anon_sym_AMP_AMP] = ACTIONS(1342),
    [anon_sym_PIPE_PIPE] = ACTIONS(1342),
    [anon_sym_EQ_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1342),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_LT_EQ] = ACTIONS(1342),
    [anon_sym_GT] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1342),
    [anon_sym_EQ_GT] = ACTIONS(1342),
    [anon_sym_QMARK_QMARK] = ACTIONS(1342),
    [anon_sym_EQ] = ACTIONS(1344),
    [sym__rangeOperator] = ACTIONS(1342),
    [anon_sym_null] = ACTIONS(1344),
    [anon_sym_dynamic] = ACTIONS(1344),
    [anon_sym_final] = ACTIONS(1344),
    [anon_sym_abstract] = ACTIONS(1344),
    [anon_sym_class] = ACTIONS(1344),
    [anon_sym_extends] = ACTIONS(1344),
    [anon_sym_implements] = ACTIONS(1344),
    [anon_sym_interface] = ACTIONS(1344),
    [anon_sym_typedef] = ACTIONS(1344),
    [anon_sym_function] = ACTIONS(1344),
    [anon_sym_var] = ACTIONS(1344),
    [aux_sym_integer_token1] = ACTIONS(1344),
    [aux_sym_integer_token2] = ACTIONS(1342),
    [aux_sym_float_token1] = ACTIONS(1344),
    [aux_sym_float_token2] = ACTIONS(1342),
    [anon_sym_true] = ACTIONS(1344),
    [anon_sym_false] = ACTIONS(1344),
    [aux_sym_string_token1] = ACTIONS(1342),
    [aux_sym_string_token3] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1344),
    [anon_sym_catch] = ACTIONS(1344),
    [anon_sym_continue] = ACTIONS(1344),
    [anon_sym_do] = ACTIONS(1344),
    [anon_sym_enum] = ACTIONS(1344),
    [anon_sym_extern] = ACTIONS(1344),
    [anon_sym_for] = ACTIONS(1344),
    [anon_sym_inline] = ACTIONS(1344),
    [anon_sym_macro] = ACTIONS(1344),
    [anon_sym_operator] = ACTIONS(1344),
    [anon_sym_overload] = ACTIONS(1344),
    [anon_sym_override] = ACTIONS(1344),
    [anon_sym_private] = ACTIONS(1344),
    [anon_sym_public] = ACTIONS(1344),
    [anon_sym_return] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1344),
    [anon_sym_try] = ACTIONS(1344),
    [anon_sym_untyped] = ACTIONS(1344),
    [anon_sym_while] = ACTIONS(1344),
    [sym__semicolon] = ACTIONS(1342),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1348),
    [anon_sym_POUND] = ACTIONS(1346),
    [anon_sym_package] = ACTIONS(1348),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_using] = ACTIONS(1348),
    [anon_sym_throw] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_case] = ACTIONS(1348),
    [anon_sym_default] = ACTIONS(1348),
    [anon_sym_cast] = ACTIONS(1348),
    [anon_sym_DOLLARtype] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_this] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1348),
    [anon_sym_AT_COLON] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1348),
    [anon_sym_else] = ACTIONS(1348),
    [anon_sym_new] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1346),
    [anon_sym_GT_GT] = ACTIONS(1348),
    [anon_sym_GT_GT_GT] = ACTIONS(1346),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1348),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1348),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ_GT] = ACTIONS(1346),
    [anon_sym_QMARK_QMARK] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1348),
    [sym__rangeOperator] = ACTIONS(1346),
    [anon_sym_null] = ACTIONS(1348),
    [anon_sym_dynamic] = ACTIONS(1348),
    [anon_sym_final] = ACTIONS(1348),
    [anon_sym_abstract] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(1348),
    [anon_sym_extends] = ACTIONS(1348),
    [anon_sym_implements] = ACTIONS(1348),
    [anon_sym_interface] = ACTIONS(1348),
    [anon_sym_typedef] = ACTIONS(1348),
    [anon_sym_function] = ACTIONS(1348),
    [anon_sym_var] = ACTIONS(1348),
    [aux_sym_integer_token1] = ACTIONS(1348),
    [aux_sym_integer_token2] = ACTIONS(1346),
    [aux_sym_float_token1] = ACTIONS(1348),
    [aux_sym_float_token2] = ACTIONS(1346),
    [anon_sym_true] = ACTIONS(1348),
    [anon_sym_false] = ACTIONS(1348),
    [aux_sym_string_token1] = ACTIONS(1346),
    [aux_sym_string_token3] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1348),
    [anon_sym_catch] = ACTIONS(1348),
    [anon_sym_continue] = ACTIONS(1348),
    [anon_sym_do] = ACTIONS(1348),
    [anon_sym_enum] = ACTIONS(1348),
    [anon_sym_extern] = ACTIONS(1348),
    [anon_sym_for] = ACTIONS(1348),
    [anon_sym_inline] = ACTIONS(1348),
    [anon_sym_macro] = ACTIONS(1348),
    [anon_sym_operator] = ACTIONS(1348),
    [anon_sym_overload] = ACTIONS(1348),
    [anon_sym_override] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1348),
    [anon_sym_public] = ACTIONS(1348),
    [anon_sym_return] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1348),
    [anon_sym_try] = ACTIONS(1348),
    [anon_sym_untyped] = ACTIONS(1348),
    [anon_sym_while] = ACTIONS(1348),
    [sym__semicolon] = ACTIONS(1346),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_POUND] = ACTIONS(1350),
    [anon_sym_package] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_using] = ACTIONS(1352),
    [anon_sym_throw] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_switch] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [anon_sym_case] = ACTIONS(1352),
    [anon_sym_default] = ACTIONS(1352),
    [anon_sym_cast] = ACTIONS(1352),
    [anon_sym_DOLLARtype] = ACTIONS(1350),
    [anon_sym_in] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_this] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1352),
    [anon_sym_AT_COLON] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_else] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1352),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(1352),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1350),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1350),
    [anon_sym_GT] = ACTIONS(1352),
    [anon_sym_GT_EQ] = ACTIONS(1350),
    [anon_sym_EQ_GT] = ACTIONS(1350),
    [anon_sym_QMARK_QMARK] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [sym__rangeOperator] = ACTIONS(1350),
    [anon_sym_null] = ACTIONS(1352),
    [anon_sym_dynamic] = ACTIONS(1352),
    [anon_sym_final] = ACTIONS(1352),
    [anon_sym_abstract] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_extends] = ACTIONS(1352),
    [anon_sym_implements] = ACTIONS(1352),
    [anon_sym_interface] = ACTIONS(1352),
    [anon_sym_typedef] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(1352),
    [anon_sym_var] = ACTIONS(1352),
    [aux_sym_integer_token1] = ACTIONS(1352),
    [aux_sym_integer_token2] = ACTIONS(1350),
    [aux_sym_float_token1] = ACTIONS(1352),
    [aux_sym_float_token2] = ACTIONS(1350),
    [anon_sym_true] = ACTIONS(1352),
    [anon_sym_false] = ACTIONS(1352),
    [aux_sym_string_token1] = ACTIONS(1350),
    [aux_sym_string_token3] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_catch] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_do] = ACTIONS(1352),
    [anon_sym_enum] = ACTIONS(1352),
    [anon_sym_extern] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_inline] = ACTIONS(1352),
    [anon_sym_macro] = ACTIONS(1352),
    [anon_sym_operator] = ACTIONS(1352),
    [anon_sym_overload] = ACTIONS(1352),
    [anon_sym_override] = ACTIONS(1352),
    [anon_sym_private] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_static] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_untyped] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [sym__semicolon] = ACTIONS(1350),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_POUND] = ACTIONS(1354),
    [anon_sym_package] = ACTIONS(1356),
    [anon_sym_import] = ACTIONS(1356),
    [anon_sym_using] = ACTIONS(1356),
    [anon_sym_throw] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_switch] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_case] = ACTIONS(1356),
    [anon_sym_default] = ACTIONS(1356),
    [anon_sym_cast] = ACTIONS(1356),
    [anon_sym_DOLLARtype] = ACTIONS(1354),
    [anon_sym_in] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_this] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1356),
    [anon_sym_AT_COLON] = ACTIONS(1354),
    [anon_sym_if] = ACTIONS(1356),
    [anon_sym_else] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_SLASH] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_LT_LT] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1356),
    [anon_sym_GT_GT_GT] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(1356),
    [anon_sym_PIPE] = ACTIONS(1356),
    [anon_sym_CARET] = ACTIONS(1354),
    [anon_sym_AMP_AMP] = ACTIONS(1354),
    [anon_sym_PIPE_PIPE] = ACTIONS(1354),
    [anon_sym_EQ_EQ] = ACTIONS(1354),
    [anon_sym_BANG_EQ] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1356),
    [anon_sym_LT_EQ] = ACTIONS(1354),
    [anon_sym_GT] = ACTIONS(1356),
    [anon_sym_GT_EQ] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(1354),
    [anon_sym_QMARK_QMARK] = ACTIONS(1354),
    [anon_sym_EQ] = ACTIONS(1356),
    [sym__rangeOperator] = ACTIONS(1354),
    [anon_sym_null] = ACTIONS(1356),
    [anon_sym_dynamic] = ACTIONS(1356),
    [anon_sym_final] = ACTIONS(1356),
    [anon_sym_abstract] = ACTIONS(1356),
    [anon_sym_class] = ACTIONS(1356),
    [anon_sym_extends] = ACTIONS(1356),
    [anon_sym_implements] = ACTIONS(1356),
    [anon_sym_interface] = ACTIONS(1356),
    [anon_sym_typedef] = ACTIONS(1356),
    [anon_sym_function] = ACTIONS(1356),
    [anon_sym_var] = ACTIONS(1356),
    [aux_sym_integer_token1] = ACTIONS(1356),
    [aux_sym_integer_token2] = ACTIONS(1354),
    [aux_sym_float_token1] = ACTIONS(1356),
    [aux_sym_float_token2] = ACTIONS(1354),
    [anon_sym_true] = ACTIONS(1356),
    [anon_sym_false] = ACTIONS(1356),
    [aux_sym_string_token1] = ACTIONS(1354),
    [aux_sym_string_token3] = ACTIONS(1354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1356),
    [anon_sym_catch] = ACTIONS(1356),
    [anon_sym_continue] = ACTIONS(1356),
    [anon_sym_do] = ACTIONS(1356),
    [anon_sym_enum] = ACTIONS(1356),
    [anon_sym_extern] = ACTIONS(1356),
    [anon_sym_for] = ACTIONS(1356),
    [anon_sym_inline] = ACTIONS(1356),
    [anon_sym_macro] = ACTIONS(1356),
    [anon_sym_operator] = ACTIONS(1356),
    [anon_sym_overload] = ACTIONS(1356),
    [anon_sym_override] = ACTIONS(1356),
    [anon_sym_private] = ACTIONS(1356),
    [anon_sym_public] = ACTIONS(1356),
    [anon_sym_return] = ACTIONS(1356),
    [anon_sym_static] = ACTIONS(1356),
    [anon_sym_try] = ACTIONS(1356),
    [anon_sym_untyped] = ACTIONS(1356),
    [anon_sym_while] = ACTIONS(1356),
    [sym__semicolon] = ACTIONS(1354),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_POUND] = ACTIONS(1358),
    [anon_sym_package] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(1360),
    [anon_sym_using] = ACTIONS(1360),
    [anon_sym_throw] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [anon_sym_switch] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [anon_sym_case] = ACTIONS(1360),
    [anon_sym_default] = ACTIONS(1360),
    [anon_sym_cast] = ACTIONS(1360),
    [anon_sym_DOLLARtype] = ACTIONS(1358),
    [anon_sym_in] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_this] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(1360),
    [anon_sym_AT_COLON] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_else] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1358),
    [anon_sym_PERCENT] = ACTIONS(1358),
    [anon_sym_STAR] = ACTIONS(1358),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_LT_LT] = ACTIONS(1358),
    [anon_sym_GT_GT] = ACTIONS(1360),
    [anon_sym_GT_GT_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1358),
    [anon_sym_AMP_AMP] = ACTIONS(1358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1358),
    [anon_sym_EQ_EQ] = ACTIONS(1358),
    [anon_sym_BANG_EQ] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1360),
    [anon_sym_LT_EQ] = ACTIONS(1358),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_GT_EQ] = ACTIONS(1358),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_QMARK_QMARK] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1360),
    [sym__rangeOperator] = ACTIONS(1358),
    [anon_sym_null] = ACTIONS(1360),
    [anon_sym_dynamic] = ACTIONS(1360),
    [anon_sym_final] = ACTIONS(1360),
    [anon_sym_abstract] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_extends] = ACTIONS(1360),
    [anon_sym_implements] = ACTIONS(1360),
    [anon_sym_interface] = ACTIONS(1360),
    [anon_sym_typedef] = ACTIONS(1360),
    [anon_sym_function] = ACTIONS(1360),
    [anon_sym_var] = ACTIONS(1360),
    [aux_sym_integer_token1] = ACTIONS(1360),
    [aux_sym_integer_token2] = ACTIONS(1358),
    [aux_sym_float_token1] = ACTIONS(1360),
    [aux_sym_float_token2] = ACTIONS(1358),
    [anon_sym_true] = ACTIONS(1360),
    [anon_sym_false] = ACTIONS(1360),
    [aux_sym_string_token1] = ACTIONS(1358),
    [aux_sym_string_token3] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_catch] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_do] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [anon_sym_extern] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_inline] = ACTIONS(1360),
    [anon_sym_macro] = ACTIONS(1360),
    [anon_sym_operator] = ACTIONS(1360),
    [anon_sym_overload] = ACTIONS(1360),
    [anon_sym_override] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [anon_sym_untyped] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [sym__semicolon] = ACTIONS(1358),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1364),
    [anon_sym_POUND] = ACTIONS(1362),
    [anon_sym_package] = ACTIONS(1364),
    [anon_sym_import] = ACTIONS(1364),
    [anon_sym_using] = ACTIONS(1364),
    [anon_sym_throw] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_switch] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_case] = ACTIONS(1364),
    [anon_sym_default] = ACTIONS(1364),
    [anon_sym_cast] = ACTIONS(1364),
    [anon_sym_DOLLARtype] = ACTIONS(1362),
    [anon_sym_in] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_this] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_AT_COLON] = ACTIONS(1362),
    [anon_sym_if] = ACTIONS(1364),
    [anon_sym_else] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1362),
    [anon_sym_PERCENT] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_SLASH] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_LT_LT] = ACTIONS(1362),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_GT_GT_GT] = ACTIONS(1362),
    [anon_sym_AMP] = ACTIONS(1364),
    [anon_sym_PIPE] = ACTIONS(1364),
    [anon_sym_CARET] = ACTIONS(1362),
    [anon_sym_AMP_AMP] = ACTIONS(1362),
    [anon_sym_PIPE_PIPE] = ACTIONS(1362),
    [anon_sym_EQ_EQ] = ACTIONS(1362),
    [anon_sym_BANG_EQ] = ACTIONS(1362),
    [anon_sym_LT] = ACTIONS(1364),
    [anon_sym_LT_EQ] = ACTIONS(1362),
    [anon_sym_GT] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1362),
    [anon_sym_EQ_GT] = ACTIONS(1362),
    [anon_sym_QMARK_QMARK] = ACTIONS(1362),
    [anon_sym_EQ] = ACTIONS(1364),
    [sym__rangeOperator] = ACTIONS(1362),
    [anon_sym_null] = ACTIONS(1364),
    [anon_sym_dynamic] = ACTIONS(1364),
    [anon_sym_final] = ACTIONS(1364),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_class] = ACTIONS(1364),
    [anon_sym_extends] = ACTIONS(1364),
    [anon_sym_implements] = ACTIONS(1364),
    [anon_sym_interface] = ACTIONS(1364),
    [anon_sym_typedef] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(1364),
    [anon_sym_var] = ACTIONS(1364),
    [aux_sym_integer_token1] = ACTIONS(1364),
    [aux_sym_integer_token2] = ACTIONS(1362),
    [aux_sym_float_token1] = ACTIONS(1364),
    [aux_sym_float_token2] = ACTIONS(1362),
    [anon_sym_true] = ACTIONS(1364),
    [anon_sym_false] = ACTIONS(1364),
    [aux_sym_string_token1] = ACTIONS(1362),
    [aux_sym_string_token3] = ACTIONS(1362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1364),
    [anon_sym_catch] = ACTIONS(1364),
    [anon_sym_continue] = ACTIONS(1364),
    [anon_sym_do] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
    [anon_sym_extern] = ACTIONS(1364),
    [anon_sym_for] = ACTIONS(1364),
    [anon_sym_inline] = ACTIONS(1364),
    [anon_sym_macro] = ACTIONS(1364),
    [anon_sym_operator] = ACTIONS(1364),
    [anon_sym_overload] = ACTIONS(1364),
    [anon_sym_override] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_return] = ACTIONS(1364),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_try] = ACTIONS(1364),
    [anon_sym_untyped] = ACTIONS(1364),
    [anon_sym_while] = ACTIONS(1364),
    [sym__semicolon] = ACTIONS(1362),
  },
  [281] = {
    [sym__rhs_expression] = STATE(471),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(457),
    [sym__lhs_expression] = STATE(979),
    [sym_builtin_type] = STATE(1008),
    [sym_function_type] = STATE(118),
    [sym_type] = STATE(1189),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(471),
    [sym_operator] = STATE(804),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(825),
    [sym_integer] = STATE(825),
    [sym_float] = STATE(825),
    [sym_bool] = STATE(825),
    [sym_string] = STATE(675),
    [sym_null] = STATE(825),
    [sym_array] = STATE(825),
    [sym_map] = STATE(825),
    [sym_object] = STATE(825),
    [sym_pair] = STATE(825),
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_LPAREN] = ACTIONS(600),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1090),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(998),
    [anon_sym_Void] = ACTIONS(606),
    [anon_sym_Int] = ACTIONS(606),
    [anon_sym_Float] = ACTIONS(606),
    [anon_sym_Bool] = ACTIONS(606),
    [anon_sym_Null] = ACTIONS(606),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(370),
    [sym_identifier] = ACTIONS(372),
    [anon_sym_POUND] = ACTIONS(370),
    [anon_sym_package] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(372),
    [anon_sym_using] = ACTIONS(372),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_switch] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_case] = ACTIONS(372),
    [anon_sym_default] = ACTIONS(372),
    [anon_sym_cast] = ACTIONS(372),
    [anon_sym_DOLLARtype] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_AT_COLON] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(372),
    [anon_sym_new] = ACTIONS(372),
    [anon_sym_TILDE] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_PLUS_PLUS] = ACTIONS(370),
    [anon_sym_DASH_DASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_GT_GT_GT] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(372),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_PIPE_PIPE] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(370),
    [anon_sym_BANG_EQ] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(372),
    [anon_sym_GT_EQ] = ACTIONS(370),
    [anon_sym_EQ_GT] = ACTIONS(370),
    [anon_sym_QMARK_QMARK] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(372),
    [sym__rangeOperator] = ACTIONS(370),
    [anon_sym_null] = ACTIONS(372),
    [anon_sym_dynamic] = ACTIONS(372),
    [anon_sym_final] = ACTIONS(372),
    [anon_sym_abstract] = ACTIONS(372),
    [anon_sym_class] = ACTIONS(372),
    [anon_sym_extends] = ACTIONS(372),
    [anon_sym_implements] = ACTIONS(372),
    [anon_sym_interface] = ACTIONS(372),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_function] = ACTIONS(372),
    [anon_sym_var] = ACTIONS(372),
    [aux_sym_integer_token1] = ACTIONS(372),
    [aux_sym_integer_token2] = ACTIONS(370),
    [aux_sym_float_token1] = ACTIONS(372),
    [aux_sym_float_token2] = ACTIONS(370),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(372),
    [aux_sym_string_token1] = ACTIONS(370),
    [aux_sym_string_token3] = ACTIONS(370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(372),
    [anon_sym_catch] = ACTIONS(372),
    [anon_sym_continue] = ACTIONS(372),
    [anon_sym_do] = ACTIONS(372),
    [anon_sym_enum] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(372),
    [anon_sym_for] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(372),
    [anon_sym_operator] = ACTIONS(372),
    [anon_sym_overload] = ACTIONS(372),
    [anon_sym_override] = ACTIONS(372),
    [anon_sym_private] = ACTIONS(372),
    [anon_sym_public] = ACTIONS(372),
    [anon_sym_return] = ACTIONS(372),
    [anon_sym_static] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(372),
    [anon_sym_untyped] = ACTIONS(372),
    [anon_sym_while] = ACTIONS(372),
    [sym__semicolon] = ACTIONS(374),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_POUND] = ACTIONS(1366),
    [anon_sym_package] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(1368),
    [anon_sym_using] = ACTIONS(1368),
    [anon_sym_throw] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_cast] = ACTIONS(1368),
    [anon_sym_DOLLARtype] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_this] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1368),
    [anon_sym_AT_COLON] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_LT_LT] = ACTIONS(1366),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_GT_GT_GT] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1366),
    [anon_sym_PIPE_PIPE] = ACTIONS(1366),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_LT_EQ] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_GT_EQ] = ACTIONS(1366),
    [anon_sym_EQ_GT] = ACTIONS(1366),
    [anon_sym_QMARK_QMARK] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1368),
    [sym__rangeOperator] = ACTIONS(1366),
    [anon_sym_null] = ACTIONS(1368),
    [anon_sym_dynamic] = ACTIONS(1368),
    [anon_sym_final] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_class] = ACTIONS(1368),
    [anon_sym_extends] = ACTIONS(1368),
    [anon_sym_implements] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1368),
    [anon_sym_typedef] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(1368),
    [anon_sym_var] = ACTIONS(1368),
    [aux_sym_integer_token1] = ACTIONS(1368),
    [aux_sym_integer_token2] = ACTIONS(1366),
    [aux_sym_float_token1] = ACTIONS(1368),
    [aux_sym_float_token2] = ACTIONS(1366),
    [anon_sym_true] = ACTIONS(1368),
    [anon_sym_false] = ACTIONS(1368),
    [aux_sym_string_token1] = ACTIONS(1366),
    [aux_sym_string_token3] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_catch] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_do] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [anon_sym_extern] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_inline] = ACTIONS(1368),
    [anon_sym_macro] = ACTIONS(1368),
    [anon_sym_operator] = ACTIONS(1368),
    [anon_sym_overload] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [anon_sym_untyped] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1368),
    [sym__semicolon] = ACTIONS(1366),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_identifier] = ACTIONS(1372),
    [anon_sym_POUND] = ACTIONS(1370),
    [anon_sym_package] = ACTIONS(1372),
    [anon_sym_import] = ACTIONS(1372),
    [anon_sym_using] = ACTIONS(1372),
    [anon_sym_throw] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_switch] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1372),
    [anon_sym_default] = ACTIONS(1372),
    [anon_sym_cast] = ACTIONS(1372),
    [anon_sym_DOLLARtype] = ACTIONS(1370),
    [anon_sym_in] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_this] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_AT_COLON] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1372),
    [anon_sym_else] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1372),
    [anon_sym_GT_GT_GT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_EQ_GT] = ACTIONS(1370),
    [anon_sym_QMARK_QMARK] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1372),
    [sym__rangeOperator] = ACTIONS(1370),
    [anon_sym_null] = ACTIONS(1372),
    [anon_sym_dynamic] = ACTIONS(1372),
    [anon_sym_final] = ACTIONS(1372),
    [anon_sym_abstract] = ACTIONS(1372),
    [anon_sym_class] = ACTIONS(1372),
    [anon_sym_extends] = ACTIONS(1372),
    [anon_sym_implements] = ACTIONS(1372),
    [anon_sym_interface] = ACTIONS(1372),
    [anon_sym_typedef] = ACTIONS(1372),
    [anon_sym_function] = ACTIONS(1372),
    [anon_sym_var] = ACTIONS(1372),
    [aux_sym_integer_token1] = ACTIONS(1372),
    [aux_sym_integer_token2] = ACTIONS(1370),
    [aux_sym_float_token1] = ACTIONS(1372),
    [aux_sym_float_token2] = ACTIONS(1370),
    [anon_sym_true] = ACTIONS(1372),
    [anon_sym_false] = ACTIONS(1372),
    [aux_sym_string_token1] = ACTIONS(1370),
    [aux_sym_string_token3] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1372),
    [anon_sym_catch] = ACTIONS(1372),
    [anon_sym_continue] = ACTIONS(1372),
    [anon_sym_do] = ACTIONS(1372),
    [anon_sym_enum] = ACTIONS(1372),
    [anon_sym_extern] = ACTIONS(1372),
    [anon_sym_for] = ACTIONS(1372),
    [anon_sym_inline] = ACTIONS(1372),
    [anon_sym_macro] = ACTIONS(1372),
    [anon_sym_operator] = ACTIONS(1372),
    [anon_sym_overload] = ACTIONS(1372),
    [anon_sym_override] = ACTIONS(1372),
    [anon_sym_private] = ACTIONS(1372),
    [anon_sym_public] = ACTIONS(1372),
    [anon_sym_return] = ACTIONS(1372),
    [anon_sym_static] = ACTIONS(1372),
    [anon_sym_try] = ACTIONS(1372),
    [anon_sym_untyped] = ACTIONS(1372),
    [anon_sym_while] = ACTIONS(1372),
    [sym__semicolon] = ACTIONS(1370),
  },
  [285] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_POUND] = ACTIONS(1374),
    [anon_sym_package] = ACTIONS(1376),
    [anon_sym_import] = ACTIONS(1376),
    [anon_sym_using] = ACTIONS(1376),
    [anon_sym_throw] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [anon_sym_switch] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_case] = ACTIONS(1376),
    [anon_sym_default] = ACTIONS(1376),
    [anon_sym_cast] = ACTIONS(1376),
    [anon_sym_DOLLARtype] = ACTIONS(1374),
    [anon_sym_in] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_this] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_AT_COLON] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1376),
    [anon_sym_else] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1374),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1374),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_STAR] = ACTIONS(1374),
    [anon_sym_SLASH] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_GT_GT] = ACTIONS(1376),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP] = ACTIONS(1376),
    [anon_sym_PIPE] = ACTIONS(1376),
    [anon_sym_CARET] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1374),
    [anon_sym_PIPE_PIPE] = ACTIONS(1374),
    [anon_sym_EQ_EQ] = ACTIONS(1374),
    [anon_sym_BANG_EQ] = ACTIONS(1374),
    [anon_sym_LT] = ACTIONS(1376),
    [anon_sym_LT_EQ] = ACTIONS(1374),
    [anon_sym_GT] = ACTIONS(1376),
    [anon_sym_GT_EQ] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(1374),
    [anon_sym_QMARK_QMARK] = ACTIONS(1374),
    [anon_sym_EQ] = ACTIONS(1376),
    [sym__rangeOperator] = ACTIONS(1374),
    [anon_sym_null] = ACTIONS(1376),
    [anon_sym_dynamic] = ACTIONS(1376),
    [anon_sym_final] = ACTIONS(1376),
    [anon_sym_abstract] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_extends] = ACTIONS(1376),
    [anon_sym_implements] = ACTIONS(1376),
    [anon_sym_interface] = ACTIONS(1376),
    [anon_sym_typedef] = ACTIONS(1376),
    [anon_sym_function] = ACTIONS(1376),
    [anon_sym_var] = ACTIONS(1376),
    [aux_sym_integer_token1] = ACTIONS(1376),
    [aux_sym_integer_token2] = ACTIONS(1374),
    [aux_sym_float_token1] = ACTIONS(1376),
    [aux_sym_float_token2] = ACTIONS(1374),
    [anon_sym_true] = ACTIONS(1376),
    [anon_sym_false] = ACTIONS(1376),
    [aux_sym_string_token1] = ACTIONS(1374),
    [aux_sym_string_token3] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1376),
    [anon_sym_catch] = ACTIONS(1376),
    [anon_sym_continue] = ACTIONS(1376),
    [anon_sym_do] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [anon_sym_extern] = ACTIONS(1376),
    [anon_sym_for] = ACTIONS(1376),
    [anon_sym_inline] = ACTIONS(1376),
    [anon_sym_macro] = ACTIONS(1376),
    [anon_sym_operator] = ACTIONS(1376),
    [anon_sym_overload] = ACTIONS(1376),
    [anon_sym_override] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_return] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_try] = ACTIONS(1376),
    [anon_sym_untyped] = ACTIONS(1376),
    [anon_sym_while] = ACTIONS(1376),
    [sym__semicolon] = ACTIONS(1374),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1378),
    [sym_identifier] = ACTIONS(1380),
    [anon_sym_POUND] = ACTIONS(1378),
    [anon_sym_package] = ACTIONS(1380),
    [anon_sym_import] = ACTIONS(1380),
    [anon_sym_using] = ACTIONS(1380),
    [anon_sym_throw] = ACTIONS(1380),
    [anon_sym_LPAREN] = ACTIONS(1378),
    [anon_sym_switch] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_case] = ACTIONS(1380),
    [anon_sym_default] = ACTIONS(1380),
    [anon_sym_cast] = ACTIONS(1380),
    [anon_sym_DOLLARtype] = ACTIONS(1378),
    [anon_sym_in] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_this] = ACTIONS(1380),
    [anon_sym_AT] = ACTIONS(1380),
    [anon_sym_AT_COLON] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1380),
    [anon_sym_else] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1378),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1378),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_SLASH] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_GT_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_CARET] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_EQ_EQ] = ACTIONS(1378),
    [anon_sym_BANG_EQ] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_LT_EQ] = ACTIONS(1378),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_EQ] = ACTIONS(1378),
    [anon_sym_EQ_GT] = ACTIONS(1378),
    [anon_sym_QMARK_QMARK] = ACTIONS(1378),
    [anon_sym_EQ] = ACTIONS(1380),
    [sym__rangeOperator] = ACTIONS(1378),
    [anon_sym_null] = ACTIONS(1380),
    [anon_sym_dynamic] = ACTIONS(1380),
    [anon_sym_final] = ACTIONS(1380),
    [anon_sym_abstract] = ACTIONS(1380),
    [anon_sym_class] = ACTIONS(1380),
    [anon_sym_extends] = ACTIONS(1380),
    [anon_sym_implements] = ACTIONS(1380),
    [anon_sym_interface] = ACTIONS(1380),
    [anon_sym_typedef] = ACTIONS(1380),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_var] = ACTIONS(1380),
    [aux_sym_integer_token1] = ACTIONS(1380),
    [aux_sym_integer_token2] = ACTIONS(1378),
    [aux_sym_float_token1] = ACTIONS(1380),
    [aux_sym_float_token2] = ACTIONS(1378),
    [anon_sym_true] = ACTIONS(1380),
    [anon_sym_false] = ACTIONS(1380),
    [aux_sym_string_token1] = ACTIONS(1378),
    [aux_sym_string_token3] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1380),
    [anon_sym_catch] = ACTIONS(1380),
    [anon_sym_continue] = ACTIONS(1380),
    [anon_sym_do] = ACTIONS(1380),
    [anon_sym_enum] = ACTIONS(1380),
    [anon_sym_extern] = ACTIONS(1380),
    [anon_sym_for] = ACTIONS(1380),
    [anon_sym_inline] = ACTIONS(1380),
    [anon_sym_macro] = ACTIONS(1380),
    [anon_sym_operator] = ACTIONS(1380),
    [anon_sym_overload] = ACTIONS(1380),
    [anon_sym_override] = ACTIONS(1380),
    [anon_sym_private] = ACTIONS(1380),
    [anon_sym_public] = ACTIONS(1380),
    [anon_sym_return] = ACTIONS(1380),
    [anon_sym_static] = ACTIONS(1380),
    [anon_sym_try] = ACTIONS(1380),
    [anon_sym_untyped] = ACTIONS(1380),
    [anon_sym_while] = ACTIONS(1380),
    [sym__semicolon] = ACTIONS(1378),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1382),
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_package] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(1384),
    [anon_sym_using] = ACTIONS(1384),
    [anon_sym_throw] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_case] = ACTIONS(1384),
    [anon_sym_default] = ACTIONS(1384),
    [anon_sym_cast] = ACTIONS(1384),
    [anon_sym_DOLLARtype] = ACTIONS(1382),
    [anon_sym_in] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_this] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_AT_COLON] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1384),
    [anon_sym_new] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1382),
    [anon_sym_PERCENT] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_LT_LT] = ACTIONS(1382),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_GT_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_LT_EQ] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_EQ] = ACTIONS(1382),
    [anon_sym_EQ_GT] = ACTIONS(1382),
    [anon_sym_QMARK_QMARK] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1384),
    [sym__rangeOperator] = ACTIONS(1382),
    [anon_sym_null] = ACTIONS(1384),
    [anon_sym_dynamic] = ACTIONS(1384),
    [anon_sym_final] = ACTIONS(1384),
    [anon_sym_abstract] = ACTIONS(1384),
    [anon_sym_class] = ACTIONS(1384),
    [anon_sym_extends] = ACTIONS(1384),
    [anon_sym_implements] = ACTIONS(1384),
    [anon_sym_interface] = ACTIONS(1384),
    [anon_sym_typedef] = ACTIONS(1384),
    [anon_sym_function] = ACTIONS(1384),
    [anon_sym_var] = ACTIONS(1384),
    [aux_sym_integer_token1] = ACTIONS(1384),
    [aux_sym_integer_token2] = ACTIONS(1382),
    [aux_sym_float_token1] = ACTIONS(1384),
    [aux_sym_float_token2] = ACTIONS(1382),
    [anon_sym_true] = ACTIONS(1384),
    [anon_sym_false] = ACTIONS(1384),
    [aux_sym_string_token1] = ACTIONS(1382),
    [aux_sym_string_token3] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1384),
    [anon_sym_catch] = ACTIONS(1384),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_do] = ACTIONS(1384),
    [anon_sym_enum] = ACTIONS(1384),
    [anon_sym_extern] = ACTIONS(1384),
    [anon_sym_for] = ACTIONS(1384),
    [anon_sym_inline] = ACTIONS(1384),
    [anon_sym_macro] = ACTIONS(1384),
    [anon_sym_operator] = ACTIONS(1384),
    [anon_sym_overload] = ACTIONS(1384),
    [anon_sym_override] = ACTIONS(1384),
    [anon_sym_private] = ACTIONS(1384),
    [anon_sym_public] = ACTIONS(1384),
    [anon_sym_return] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1384),
    [anon_sym_try] = ACTIONS(1384),
    [anon_sym_untyped] = ACTIONS(1384),
    [anon_sym_while] = ACTIONS(1384),
    [sym__semicolon] = ACTIONS(1382),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(1386),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_POUND] = ACTIONS(1386),
    [anon_sym_package] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(1388),
    [anon_sym_using] = ACTIONS(1388),
    [anon_sym_throw] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_RBRACE] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1388),
    [anon_sym_default] = ACTIONS(1388),
    [anon_sym_cast] = ACTIONS(1388),
    [anon_sym_DOLLARtype] = ACTIONS(1386),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_this] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_AT_COLON] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1388),
    [anon_sym_else] = ACTIONS(1388),
    [anon_sym_new] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1386),
    [anon_sym_PERCENT] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1386),
    [anon_sym_SLASH] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1388),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_GT_GT] = ACTIONS(1388),
    [anon_sym_GT_GT_GT] = ACTIONS(1386),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_PIPE] = ACTIONS(1388),
    [anon_sym_CARET] = ACTIONS(1386),
    [anon_sym_AMP_AMP] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1386),
    [anon_sym_EQ_EQ] = ACTIONS(1386),
    [anon_sym_BANG_EQ] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1388),
    [anon_sym_LT_EQ] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1388),
    [anon_sym_GT_EQ] = ACTIONS(1386),
    [anon_sym_EQ_GT] = ACTIONS(1386),
    [anon_sym_QMARK_QMARK] = ACTIONS(1386),
    [anon_sym_EQ] = ACTIONS(1388),
    [sym__rangeOperator] = ACTIONS(1386),
    [anon_sym_null] = ACTIONS(1388),
    [anon_sym_dynamic] = ACTIONS(1388),
    [anon_sym_final] = ACTIONS(1388),
    [anon_sym_abstract] = ACTIONS(1388),
    [anon_sym_class] = ACTIONS(1388),
    [anon_sym_extends] = ACTIONS(1388),
    [anon_sym_implements] = ACTIONS(1388),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_typedef] = ACTIONS(1388),
    [anon_sym_function] = ACTIONS(1388),
    [anon_sym_var] = ACTIONS(1388),
    [aux_sym_integer_token1] = ACTIONS(1388),
    [aux_sym_integer_token2] = ACTIONS(1386),
    [aux_sym_float_token1] = ACTIONS(1388),
    [aux_sym_float_token2] = ACTIONS(1386),
    [anon_sym_true] = ACTIONS(1388),
    [anon_sym_false] = ACTIONS(1388),
    [aux_sym_string_token1] = ACTIONS(1386),
    [aux_sym_string_token3] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1388),
    [anon_sym_catch] = ACTIONS(1388),
    [anon_sym_continue] = ACTIONS(1388),
    [anon_sym_do] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1388),
    [anon_sym_extern] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1388),
    [anon_sym_inline] = ACTIONS(1388),
    [anon_sym_macro] = ACTIONS(1388),
    [anon_sym_operator] = ACTIONS(1388),
    [anon_sym_overload] = ACTIONS(1388),
    [anon_sym_override] = ACTIONS(1388),
    [anon_sym_private] = ACTIONS(1388),
    [anon_sym_public] = ACTIONS(1388),
    [anon_sym_return] = ACTIONS(1388),
    [anon_sym_static] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1388),
    [anon_sym_untyped] = ACTIONS(1388),
    [anon_sym_while] = ACTIONS(1388),
    [sym__semicolon] = ACTIONS(1386),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(1390),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_package] = ACTIONS(1392),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_using] = ACTIONS(1392),
    [anon_sym_throw] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [anon_sym_switch] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_case] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1392),
    [anon_sym_cast] = ACTIONS(1392),
    [anon_sym_DOLLARtype] = ACTIONS(1390),
    [anon_sym_in] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_this] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(1392),
    [anon_sym_AT_COLON] = ACTIONS(1390),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_else] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1392),
    [anon_sym_GT_GT_GT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_PIPE] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1390),
    [anon_sym_BANG_EQ] = ACTIONS(1390),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym_GT] = ACTIONS(1392),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [anon_sym_EQ_GT] = ACTIONS(1390),
    [anon_sym_QMARK_QMARK] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1392),
    [sym__rangeOperator] = ACTIONS(1390),
    [anon_sym_null] = ACTIONS(1392),
    [anon_sym_dynamic] = ACTIONS(1392),
    [anon_sym_final] = ACTIONS(1392),
    [anon_sym_abstract] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_extends] = ACTIONS(1392),
    [anon_sym_implements] = ACTIONS(1392),
    [anon_sym_interface] = ACTIONS(1392),
    [anon_sym_typedef] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(1392),
    [anon_sym_var] = ACTIONS(1392),
    [aux_sym_integer_token1] = ACTIONS(1392),
    [aux_sym_integer_token2] = ACTIONS(1390),
    [aux_sym_float_token1] = ACTIONS(1392),
    [aux_sym_float_token2] = ACTIONS(1390),
    [anon_sym_true] = ACTIONS(1392),
    [anon_sym_false] = ACTIONS(1392),
    [aux_sym_string_token1] = ACTIONS(1390),
    [aux_sym_string_token3] = ACTIONS(1390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_catch] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_do] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_extern] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_inline] = ACTIONS(1392),
    [anon_sym_macro] = ACTIONS(1392),
    [anon_sym_operator] = ACTIONS(1392),
    [anon_sym_overload] = ACTIONS(1392),
    [anon_sym_override] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_untyped] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [sym__semicolon] = ACTIONS(1390),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_POUND] = ACTIONS(1394),
    [anon_sym_package] = ACTIONS(1396),
    [anon_sym_import] = ACTIONS(1396),
    [anon_sym_using] = ACTIONS(1396),
    [anon_sym_throw] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_switch] = ACTIONS(1396),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_case] = ACTIONS(1396),
    [anon_sym_default] = ACTIONS(1396),
    [anon_sym_cast] = ACTIONS(1396),
    [anon_sym_DOLLARtype] = ACTIONS(1394),
    [anon_sym_in] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_this] = ACTIONS(1396),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_AT_COLON] = ACTIONS(1394),
    [anon_sym_if] = ACTIONS(1396),
    [anon_sym_else] = ACTIONS(1396),
    [anon_sym_new] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_LT_LT] = ACTIONS(1394),
    [anon_sym_GT_GT] = ACTIONS(1396),
    [anon_sym_GT_GT_GT] = ACTIONS(1394),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1396),
    [anon_sym_CARET] = ACTIONS(1394),
    [anon_sym_AMP_AMP] = ACTIONS(1394),
    [anon_sym_PIPE_PIPE] = ACTIONS(1394),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_LT_EQ] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1396),
    [anon_sym_GT_EQ] = ACTIONS(1394),
    [anon_sym_EQ_GT] = ACTIONS(1394),
    [anon_sym_QMARK_QMARK] = ACTIONS(1394),
    [anon_sym_EQ] = ACTIONS(1396),
    [sym__rangeOperator] = ACTIONS(1394),
    [anon_sym_null] = ACTIONS(1396),
    [anon_sym_dynamic] = ACTIONS(1396),
    [anon_sym_final] = ACTIONS(1396),
    [anon_sym_abstract] = ACTIONS(1396),
    [anon_sym_class] = ACTIONS(1396),
    [anon_sym_extends] = ACTIONS(1396),
    [anon_sym_implements] = ACTIONS(1396),
    [anon_sym_interface] = ACTIONS(1396),
    [anon_sym_typedef] = ACTIONS(1396),
    [anon_sym_function] = ACTIONS(1396),
    [anon_sym_var] = ACTIONS(1396),
    [aux_sym_integer_token1] = ACTIONS(1396),
    [aux_sym_integer_token2] = ACTIONS(1394),
    [aux_sym_float_token1] = ACTIONS(1396),
    [aux_sym_float_token2] = ACTIONS(1394),
    [anon_sym_true] = ACTIONS(1396),
    [anon_sym_false] = ACTIONS(1396),
    [aux_sym_string_token1] = ACTIONS(1394),
    [aux_sym_string_token3] = ACTIONS(1394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1396),
    [anon_sym_catch] = ACTIONS(1396),
    [anon_sym_continue] = ACTIONS(1396),
    [anon_sym_do] = ACTIONS(1396),
    [anon_sym_enum] = ACTIONS(1396),
    [anon_sym_extern] = ACTIONS(1396),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_inline] = ACTIONS(1396),
    [anon_sym_macro] = ACTIONS(1396),
    [anon_sym_operator] = ACTIONS(1396),
    [anon_sym_overload] = ACTIONS(1396),
    [anon_sym_override] = ACTIONS(1396),
    [anon_sym_private] = ACTIONS(1396),
    [anon_sym_public] = ACTIONS(1396),
    [anon_sym_return] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1396),
    [anon_sym_try] = ACTIONS(1396),
    [anon_sym_untyped] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1396),
    [sym__semicolon] = ACTIONS(1394),
  },
  [291] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_package] = ACTIONS(1400),
    [anon_sym_import] = ACTIONS(1400),
    [anon_sym_using] = ACTIONS(1400),
    [anon_sym_throw] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_case] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1400),
    [anon_sym_cast] = ACTIONS(1400),
    [anon_sym_DOLLARtype] = ACTIONS(1398),
    [anon_sym_in] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_this] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_AT_COLON] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_new] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_SLASH] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_EQ_GT] = ACTIONS(1398),
    [anon_sym_QMARK_QMARK] = ACTIONS(1398),
    [anon_sym_EQ] = ACTIONS(1400),
    [sym__rangeOperator] = ACTIONS(1398),
    [anon_sym_null] = ACTIONS(1400),
    [anon_sym_dynamic] = ACTIONS(1400),
    [anon_sym_final] = ACTIONS(1400),
    [anon_sym_abstract] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1400),
    [anon_sym_extends] = ACTIONS(1400),
    [anon_sym_implements] = ACTIONS(1400),
    [anon_sym_interface] = ACTIONS(1400),
    [anon_sym_typedef] = ACTIONS(1400),
    [anon_sym_function] = ACTIONS(1400),
    [anon_sym_var] = ACTIONS(1400),
    [aux_sym_integer_token1] = ACTIONS(1400),
    [aux_sym_integer_token2] = ACTIONS(1398),
    [aux_sym_float_token1] = ACTIONS(1400),
    [aux_sym_float_token2] = ACTIONS(1398),
    [anon_sym_true] = ACTIONS(1400),
    [anon_sym_false] = ACTIONS(1400),
    [aux_sym_string_token1] = ACTIONS(1398),
    [aux_sym_string_token3] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1400),
    [anon_sym_catch] = ACTIONS(1400),
    [anon_sym_continue] = ACTIONS(1400),
    [anon_sym_do] = ACTIONS(1400),
    [anon_sym_enum] = ACTIONS(1400),
    [anon_sym_extern] = ACTIONS(1400),
    [anon_sym_for] = ACTIONS(1400),
    [anon_sym_inline] = ACTIONS(1400),
    [anon_sym_macro] = ACTIONS(1400),
    [anon_sym_operator] = ACTIONS(1400),
    [anon_sym_overload] = ACTIONS(1400),
    [anon_sym_override] = ACTIONS(1400),
    [anon_sym_private] = ACTIONS(1400),
    [anon_sym_public] = ACTIONS(1400),
    [anon_sym_return] = ACTIONS(1400),
    [anon_sym_static] = ACTIONS(1400),
    [anon_sym_try] = ACTIONS(1400),
    [anon_sym_untyped] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1400),
    [sym__semicolon] = ACTIONS(1398),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_POUND] = ACTIONS(1402),
    [anon_sym_package] = ACTIONS(1404),
    [anon_sym_import] = ACTIONS(1404),
    [anon_sym_using] = ACTIONS(1404),
    [anon_sym_throw] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [anon_sym_case] = ACTIONS(1404),
    [anon_sym_default] = ACTIONS(1404),
    [anon_sym_cast] = ACTIONS(1404),
    [anon_sym_DOLLARtype] = ACTIONS(1402),
    [anon_sym_in] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_this] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1404),
    [anon_sym_AT_COLON] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1404),
    [anon_sym_else] = ACTIONS(1404),
    [anon_sym_new] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1402),
    [anon_sym_PERCENT] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_PIPE_PIPE] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1402),
    [anon_sym_BANG_EQ] = ACTIONS(1402),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_LT_EQ] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1402),
    [anon_sym_EQ_GT] = ACTIONS(1402),
    [anon_sym_QMARK_QMARK] = ACTIONS(1402),
    [anon_sym_EQ] = ACTIONS(1404),
    [sym__rangeOperator] = ACTIONS(1402),
    [anon_sym_null] = ACTIONS(1404),
    [anon_sym_dynamic] = ACTIONS(1404),
    [anon_sym_final] = ACTIONS(1404),
    [anon_sym_abstract] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(1404),
    [anon_sym_extends] = ACTIONS(1404),
    [anon_sym_implements] = ACTIONS(1404),
    [anon_sym_interface] = ACTIONS(1404),
    [anon_sym_typedef] = ACTIONS(1404),
    [anon_sym_function] = ACTIONS(1404),
    [anon_sym_var] = ACTIONS(1404),
    [aux_sym_integer_token1] = ACTIONS(1404),
    [aux_sym_integer_token2] = ACTIONS(1402),
    [aux_sym_float_token1] = ACTIONS(1404),
    [aux_sym_float_token2] = ACTIONS(1402),
    [anon_sym_true] = ACTIONS(1404),
    [anon_sym_false] = ACTIONS(1404),
    [aux_sym_string_token1] = ACTIONS(1402),
    [aux_sym_string_token3] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1404),
    [anon_sym_catch] = ACTIONS(1404),
    [anon_sym_continue] = ACTIONS(1404),
    [anon_sym_do] = ACTIONS(1404),
    [anon_sym_enum] = ACTIONS(1404),
    [anon_sym_extern] = ACTIONS(1404),
    [anon_sym_for] = ACTIONS(1404),
    [anon_sym_inline] = ACTIONS(1404),
    [anon_sym_macro] = ACTIONS(1404),
    [anon_sym_operator] = ACTIONS(1404),
    [anon_sym_overload] = ACTIONS(1404),
    [anon_sym_override] = ACTIONS(1404),
    [anon_sym_private] = ACTIONS(1404),
    [anon_sym_public] = ACTIONS(1404),
    [anon_sym_return] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_try] = ACTIONS(1404),
    [anon_sym_untyped] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1404),
    [sym__semicolon] = ACTIONS(1402),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(1406),
    [sym_identifier] = ACTIONS(1408),
    [anon_sym_POUND] = ACTIONS(1406),
    [anon_sym_package] = ACTIONS(1408),
    [anon_sym_import] = ACTIONS(1408),
    [anon_sym_using] = ACTIONS(1408),
    [anon_sym_throw] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [anon_sym_switch] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1408),
    [anon_sym_default] = ACTIONS(1408),
    [anon_sym_cast] = ACTIONS(1408),
    [anon_sym_DOLLARtype] = ACTIONS(1406),
    [anon_sym_in] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_this] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_AT_COLON] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1408),
    [anon_sym_else] = ACTIONS(1408),
    [anon_sym_new] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(1406),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_SLASH] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(1408),
    [anon_sym_GT_GT_GT] = ACTIONS(1406),
    [anon_sym_AMP] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1408),
    [anon_sym_CARET] = ACTIONS(1406),
    [anon_sym_AMP_AMP] = ACTIONS(1406),
    [anon_sym_PIPE_PIPE] = ACTIONS(1406),
    [anon_sym_EQ_EQ] = ACTIONS(1406),
    [anon_sym_BANG_EQ] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_GT] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_EQ_GT] = ACTIONS(1406),
    [anon_sym_QMARK_QMARK] = ACTIONS(1406),
    [anon_sym_EQ] = ACTIONS(1408),
    [sym__rangeOperator] = ACTIONS(1406),
    [anon_sym_null] = ACTIONS(1408),
    [anon_sym_dynamic] = ACTIONS(1408),
    [anon_sym_final] = ACTIONS(1408),
    [anon_sym_abstract] = ACTIONS(1408),
    [anon_sym_class] = ACTIONS(1408),
    [anon_sym_extends] = ACTIONS(1408),
    [anon_sym_implements] = ACTIONS(1408),
    [anon_sym_interface] = ACTIONS(1408),
    [anon_sym_typedef] = ACTIONS(1408),
    [anon_sym_function] = ACTIONS(1408),
    [anon_sym_var] = ACTIONS(1408),
    [aux_sym_integer_token1] = ACTIONS(1408),
    [aux_sym_integer_token2] = ACTIONS(1406),
    [aux_sym_float_token1] = ACTIONS(1408),
    [aux_sym_float_token2] = ACTIONS(1406),
    [anon_sym_true] = ACTIONS(1408),
    [anon_sym_false] = ACTIONS(1408),
    [aux_sym_string_token1] = ACTIONS(1406),
    [aux_sym_string_token3] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1408),
    [anon_sym_catch] = ACTIONS(1408),
    [anon_sym_continue] = ACTIONS(1408),
    [anon_sym_do] = ACTIONS(1408),
    [anon_sym_enum] = ACTIONS(1408),
    [anon_sym_extern] = ACTIONS(1408),
    [anon_sym_for] = ACTIONS(1408),
    [anon_sym_inline] = ACTIONS(1408),
    [anon_sym_macro] = ACTIONS(1408),
    [anon_sym_operator] = ACTIONS(1408),
    [anon_sym_overload] = ACTIONS(1408),
    [anon_sym_override] = ACTIONS(1408),
    [anon_sym_private] = ACTIONS(1408),
    [anon_sym_public] = ACTIONS(1408),
    [anon_sym_return] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1408),
    [anon_sym_try] = ACTIONS(1408),
    [anon_sym_untyped] = ACTIONS(1408),
    [anon_sym_while] = ACTIONS(1408),
    [sym__semicolon] = ACTIONS(1406),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1410),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_POUND] = ACTIONS(1410),
    [anon_sym_package] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(1412),
    [anon_sym_using] = ACTIONS(1412),
    [anon_sym_throw] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [anon_sym_case] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1412),
    [anon_sym_cast] = ACTIONS(1412),
    [anon_sym_DOLLARtype] = ACTIONS(1410),
    [anon_sym_in] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_this] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1412),
    [anon_sym_AT_COLON] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_else] = ACTIONS(1412),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1410),
    [anon_sym_PERCENT] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1410),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(1410),
    [anon_sym_GT_GT] = ACTIONS(1412),
    [anon_sym_GT_GT_GT] = ACTIONS(1410),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1410),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1410),
    [anon_sym_EQ_EQ] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_LT_EQ] = ACTIONS(1410),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_GT_EQ] = ACTIONS(1410),
    [anon_sym_EQ_GT] = ACTIONS(1410),
    [anon_sym_QMARK_QMARK] = ACTIONS(1410),
    [anon_sym_EQ] = ACTIONS(1412),
    [sym__rangeOperator] = ACTIONS(1410),
    [anon_sym_null] = ACTIONS(1412),
    [anon_sym_dynamic] = ACTIONS(1412),
    [anon_sym_final] = ACTIONS(1412),
    [anon_sym_abstract] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1412),
    [anon_sym_extends] = ACTIONS(1412),
    [anon_sym_implements] = ACTIONS(1412),
    [anon_sym_interface] = ACTIONS(1412),
    [anon_sym_typedef] = ACTIONS(1412),
    [anon_sym_function] = ACTIONS(1412),
    [anon_sym_var] = ACTIONS(1412),
    [aux_sym_integer_token1] = ACTIONS(1412),
    [aux_sym_integer_token2] = ACTIONS(1410),
    [aux_sym_float_token1] = ACTIONS(1412),
    [aux_sym_float_token2] = ACTIONS(1410),
    [anon_sym_true] = ACTIONS(1412),
    [anon_sym_false] = ACTIONS(1412),
    [aux_sym_string_token1] = ACTIONS(1410),
    [aux_sym_string_token3] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_catch] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_do] = ACTIONS(1412),
    [anon_sym_enum] = ACTIONS(1412),
    [anon_sym_extern] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_inline] = ACTIONS(1412),
    [anon_sym_macro] = ACTIONS(1412),
    [anon_sym_operator] = ACTIONS(1412),
    [anon_sym_overload] = ACTIONS(1412),
    [anon_sym_override] = ACTIONS(1412),
    [anon_sym_private] = ACTIONS(1412),
    [anon_sym_public] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_static] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [anon_sym_untyped] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1412),
    [sym__semicolon] = ACTIONS(1410),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_POUND] = ACTIONS(1414),
    [anon_sym_package] = ACTIONS(1416),
    [anon_sym_import] = ACTIONS(1416),
    [anon_sym_using] = ACTIONS(1416),
    [anon_sym_throw] = ACTIONS(1416),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_switch] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_case] = ACTIONS(1416),
    [anon_sym_default] = ACTIONS(1416),
    [anon_sym_cast] = ACTIONS(1416),
    [anon_sym_DOLLARtype] = ACTIONS(1414),
    [anon_sym_in] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_this] = ACTIONS(1416),
    [anon_sym_AT] = ACTIONS(1416),
    [anon_sym_AT_COLON] = ACTIONS(1414),
    [anon_sym_if] = ACTIONS(1416),
    [anon_sym_else] = ACTIONS(1416),
    [anon_sym_new] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_SLASH] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_GT_GT] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_PIPE] = ACTIONS(1416),
    [anon_sym_CARET] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_LT] = ACTIONS(1416),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1416),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_EQ_GT] = ACTIONS(1414),
    [anon_sym_QMARK_QMARK] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(1416),
    [sym__rangeOperator] = ACTIONS(1414),
    [anon_sym_null] = ACTIONS(1416),
    [anon_sym_dynamic] = ACTIONS(1416),
    [anon_sym_final] = ACTIONS(1416),
    [anon_sym_abstract] = ACTIONS(1416),
    [anon_sym_class] = ACTIONS(1416),
    [anon_sym_extends] = ACTIONS(1416),
    [anon_sym_implements] = ACTIONS(1416),
    [anon_sym_interface] = ACTIONS(1416),
    [anon_sym_typedef] = ACTIONS(1416),
    [anon_sym_function] = ACTIONS(1416),
    [anon_sym_var] = ACTIONS(1416),
    [aux_sym_integer_token1] = ACTIONS(1416),
    [aux_sym_integer_token2] = ACTIONS(1414),
    [aux_sym_float_token1] = ACTIONS(1416),
    [aux_sym_float_token2] = ACTIONS(1414),
    [anon_sym_true] = ACTIONS(1416),
    [anon_sym_false] = ACTIONS(1416),
    [aux_sym_string_token1] = ACTIONS(1414),
    [aux_sym_string_token3] = ACTIONS(1414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1416),
    [anon_sym_catch] = ACTIONS(1416),
    [anon_sym_continue] = ACTIONS(1416),
    [anon_sym_do] = ACTIONS(1416),
    [anon_sym_enum] = ACTIONS(1416),
    [anon_sym_extern] = ACTIONS(1416),
    [anon_sym_for] = ACTIONS(1416),
    [anon_sym_inline] = ACTIONS(1416),
    [anon_sym_macro] = ACTIONS(1416),
    [anon_sym_operator] = ACTIONS(1416),
    [anon_sym_overload] = ACTIONS(1416),
    [anon_sym_override] = ACTIONS(1416),
    [anon_sym_private] = ACTIONS(1416),
    [anon_sym_public] = ACTIONS(1416),
    [anon_sym_return] = ACTIONS(1416),
    [anon_sym_static] = ACTIONS(1416),
    [anon_sym_try] = ACTIONS(1416),
    [anon_sym_untyped] = ACTIONS(1416),
    [anon_sym_while] = ACTIONS(1416),
    [sym__semicolon] = ACTIONS(1414),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_identifier] = ACTIONS(1420),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_package] = ACTIONS(1420),
    [anon_sym_import] = ACTIONS(1420),
    [anon_sym_using] = ACTIONS(1420),
    [anon_sym_throw] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_switch] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_case] = ACTIONS(1420),
    [anon_sym_default] = ACTIONS(1420),
    [anon_sym_cast] = ACTIONS(1420),
    [anon_sym_DOLLARtype] = ACTIONS(1418),
    [anon_sym_in] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_this] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1420),
    [anon_sym_AT_COLON] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1420),
    [anon_sym_else] = ACTIONS(1420),
    [anon_sym_new] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1420),
    [anon_sym_PIPE] = ACTIONS(1420),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1420),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_GT] = ACTIONS(1420),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_EQ_GT] = ACTIONS(1418),
    [anon_sym_QMARK_QMARK] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1420),
    [sym__rangeOperator] = ACTIONS(1418),
    [anon_sym_null] = ACTIONS(1420),
    [anon_sym_dynamic] = ACTIONS(1420),
    [anon_sym_final] = ACTIONS(1420),
    [anon_sym_abstract] = ACTIONS(1420),
    [anon_sym_class] = ACTIONS(1420),
    [anon_sym_extends] = ACTIONS(1420),
    [anon_sym_implements] = ACTIONS(1420),
    [anon_sym_interface] = ACTIONS(1420),
    [anon_sym_typedef] = ACTIONS(1420),
    [anon_sym_function] = ACTIONS(1420),
    [anon_sym_var] = ACTIONS(1420),
    [aux_sym_integer_token1] = ACTIONS(1420),
    [aux_sym_integer_token2] = ACTIONS(1418),
    [aux_sym_float_token1] = ACTIONS(1420),
    [aux_sym_float_token2] = ACTIONS(1418),
    [anon_sym_true] = ACTIONS(1420),
    [anon_sym_false] = ACTIONS(1420),
    [aux_sym_string_token1] = ACTIONS(1418),
    [aux_sym_string_token3] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1420),
    [anon_sym_catch] = ACTIONS(1420),
    [anon_sym_continue] = ACTIONS(1420),
    [anon_sym_do] = ACTIONS(1420),
    [anon_sym_enum] = ACTIONS(1420),
    [anon_sym_extern] = ACTIONS(1420),
    [anon_sym_for] = ACTIONS(1420),
    [anon_sym_inline] = ACTIONS(1420),
    [anon_sym_macro] = ACTIONS(1420),
    [anon_sym_operator] = ACTIONS(1420),
    [anon_sym_overload] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_return] = ACTIONS(1420),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_try] = ACTIONS(1420),
    [anon_sym_untyped] = ACTIONS(1420),
    [anon_sym_while] = ACTIONS(1420),
    [sym__semicolon] = ACTIONS(1418),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(370),
    [sym_identifier] = ACTIONS(372),
    [anon_sym_POUND] = ACTIONS(370),
    [anon_sym_package] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(372),
    [anon_sym_using] = ACTIONS(372),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_LPAREN] = ACTIONS(370),
    [anon_sym_switch] = ACTIONS(372),
    [anon_sym_LBRACE] = ACTIONS(370),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_case] = ACTIONS(372),
    [anon_sym_default] = ACTIONS(372),
    [anon_sym_cast] = ACTIONS(372),
    [anon_sym_DOLLARtype] = ACTIONS(370),
    [anon_sym_in] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(370),
    [anon_sym_this] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_AT_COLON] = ACTIONS(370),
    [anon_sym_if] = ACTIONS(372),
    [anon_sym_else] = ACTIONS(372),
    [anon_sym_new] = ACTIONS(372),
    [anon_sym_TILDE] = ACTIONS(370),
    [anon_sym_BANG] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_PLUS_PLUS] = ACTIONS(370),
    [anon_sym_DASH_DASH] = ACTIONS(370),
    [anon_sym_PERCENT] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_SLASH] = ACTIONS(372),
    [anon_sym_PLUS] = ACTIONS(372),
    [anon_sym_LT_LT] = ACTIONS(370),
    [anon_sym_GT_GT] = ACTIONS(372),
    [anon_sym_GT_GT_GT] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(372),
    [anon_sym_CARET] = ACTIONS(370),
    [anon_sym_AMP_AMP] = ACTIONS(370),
    [anon_sym_PIPE_PIPE] = ACTIONS(370),
    [anon_sym_EQ_EQ] = ACTIONS(370),
    [anon_sym_BANG_EQ] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(372),
    [anon_sym_LT_EQ] = ACTIONS(370),
    [anon_sym_GT] = ACTIONS(372),
    [anon_sym_GT_EQ] = ACTIONS(370),
    [anon_sym_EQ_GT] = ACTIONS(370),
    [anon_sym_QMARK_QMARK] = ACTIONS(370),
    [anon_sym_EQ] = ACTIONS(372),
    [sym__rangeOperator] = ACTIONS(370),
    [anon_sym_null] = ACTIONS(372),
    [anon_sym_dynamic] = ACTIONS(372),
    [anon_sym_final] = ACTIONS(372),
    [anon_sym_abstract] = ACTIONS(372),
    [anon_sym_class] = ACTIONS(372),
    [anon_sym_extends] = ACTIONS(372),
    [anon_sym_implements] = ACTIONS(372),
    [anon_sym_interface] = ACTIONS(372),
    [anon_sym_typedef] = ACTIONS(372),
    [anon_sym_function] = ACTIONS(372),
    [anon_sym_var] = ACTIONS(372),
    [aux_sym_integer_token1] = ACTIONS(372),
    [aux_sym_integer_token2] = ACTIONS(370),
    [aux_sym_float_token1] = ACTIONS(372),
    [aux_sym_float_token2] = ACTIONS(370),
    [anon_sym_true] = ACTIONS(372),
    [anon_sym_false] = ACTIONS(372),
    [aux_sym_string_token1] = ACTIONS(370),
    [aux_sym_string_token3] = ACTIONS(370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(372),
    [anon_sym_catch] = ACTIONS(372),
    [anon_sym_continue] = ACTIONS(372),
    [anon_sym_do] = ACTIONS(372),
    [anon_sym_enum] = ACTIONS(372),
    [anon_sym_extern] = ACTIONS(372),
    [anon_sym_for] = ACTIONS(372),
    [anon_sym_inline] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(372),
    [anon_sym_operator] = ACTIONS(372),
    [anon_sym_overload] = ACTIONS(372),
    [anon_sym_override] = ACTIONS(372),
    [anon_sym_private] = ACTIONS(372),
    [anon_sym_public] = ACTIONS(372),
    [anon_sym_return] = ACTIONS(372),
    [anon_sym_static] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(372),
    [anon_sym_untyped] = ACTIONS(372),
    [anon_sym_while] = ACTIONS(372),
    [sym__semicolon] = ACTIONS(374),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_package] = ACTIONS(1424),
    [anon_sym_import] = ACTIONS(1424),
    [anon_sym_using] = ACTIONS(1424),
    [anon_sym_throw] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_case] = ACTIONS(1424),
    [anon_sym_default] = ACTIONS(1424),
    [anon_sym_cast] = ACTIONS(1424),
    [anon_sym_DOLLARtype] = ACTIONS(1422),
    [anon_sym_in] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_this] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(1424),
    [anon_sym_AT_COLON] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1424),
    [anon_sym_else] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1422),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_GT_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_CARET] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_EQ_EQ] = ACTIONS(1422),
    [anon_sym_BANG_EQ] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_LT_EQ] = ACTIONS(1422),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_EQ] = ACTIONS(1422),
    [anon_sym_EQ_GT] = ACTIONS(1422),
    [anon_sym_QMARK_QMARK] = ACTIONS(1422),
    [anon_sym_EQ] = ACTIONS(1424),
    [sym__rangeOperator] = ACTIONS(1422),
    [anon_sym_null] = ACTIONS(1424),
    [anon_sym_dynamic] = ACTIONS(1424),
    [anon_sym_final] = ACTIONS(1424),
    [anon_sym_abstract] = ACTIONS(1424),
    [anon_sym_class] = ACTIONS(1424),
    [anon_sym_extends] = ACTIONS(1424),
    [anon_sym_implements] = ACTIONS(1424),
    [anon_sym_interface] = ACTIONS(1424),
    [anon_sym_typedef] = ACTIONS(1424),
    [anon_sym_function] = ACTIONS(1424),
    [anon_sym_var] = ACTIONS(1424),
    [aux_sym_integer_token1] = ACTIONS(1424),
    [aux_sym_integer_token2] = ACTIONS(1422),
    [aux_sym_float_token1] = ACTIONS(1424),
    [aux_sym_float_token2] = ACTIONS(1422),
    [anon_sym_true] = ACTIONS(1424),
    [anon_sym_false] = ACTIONS(1424),
    [aux_sym_string_token1] = ACTIONS(1422),
    [aux_sym_string_token3] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1424),
    [anon_sym_catch] = ACTIONS(1424),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_do] = ACTIONS(1424),
    [anon_sym_enum] = ACTIONS(1424),
    [anon_sym_extern] = ACTIONS(1424),
    [anon_sym_for] = ACTIONS(1424),
    [anon_sym_inline] = ACTIONS(1424),
    [anon_sym_macro] = ACTIONS(1424),
    [anon_sym_operator] = ACTIONS(1424),
    [anon_sym_overload] = ACTIONS(1424),
    [anon_sym_override] = ACTIONS(1424),
    [anon_sym_private] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1424),
    [anon_sym_return] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_try] = ACTIONS(1424),
    [anon_sym_untyped] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1424),
    [sym__semicolon] = ACTIONS(1422),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1426),
    [anon_sym_package] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(1428),
    [anon_sym_using] = ACTIONS(1428),
    [anon_sym_throw] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_switch] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1428),
    [anon_sym_default] = ACTIONS(1428),
    [anon_sym_cast] = ACTIONS(1428),
    [anon_sym_DOLLARtype] = ACTIONS(1426),
    [anon_sym_in] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_this] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_AT_COLON] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1428),
    [anon_sym_else] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_PERCENT] = ACTIONS(1426),
    [anon_sym_STAR] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1426),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_GT_GT_GT] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_AMP_AMP] = ACTIONS(1426),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_EQ_EQ] = ACTIONS(1426),
    [anon_sym_BANG_EQ] = ACTIONS(1426),
    [anon_sym_LT] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1426),
    [anon_sym_GT] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1426),
    [anon_sym_EQ_GT] = ACTIONS(1426),
    [anon_sym_QMARK_QMARK] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(1428),
    [sym__rangeOperator] = ACTIONS(1426),
    [anon_sym_null] = ACTIONS(1428),
    [anon_sym_dynamic] = ACTIONS(1428),
    [anon_sym_final] = ACTIONS(1428),
    [anon_sym_abstract] = ACTIONS(1428),
    [anon_sym_class] = ACTIONS(1428),
    [anon_sym_extends] = ACTIONS(1428),
    [anon_sym_implements] = ACTIONS(1428),
    [anon_sym_interface] = ACTIONS(1428),
    [anon_sym_typedef] = ACTIONS(1428),
    [anon_sym_function] = ACTIONS(1428),
    [anon_sym_var] = ACTIONS(1428),
    [aux_sym_integer_token1] = ACTIONS(1428),
    [aux_sym_integer_token2] = ACTIONS(1426),
    [aux_sym_float_token1] = ACTIONS(1428),
    [aux_sym_float_token2] = ACTIONS(1426),
    [anon_sym_true] = ACTIONS(1428),
    [anon_sym_false] = ACTIONS(1428),
    [aux_sym_string_token1] = ACTIONS(1426),
    [aux_sym_string_token3] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_catch] = ACTIONS(1428),
    [anon_sym_continue] = ACTIONS(1428),
    [anon_sym_do] = ACTIONS(1428),
    [anon_sym_enum] = ACTIONS(1428),
    [anon_sym_extern] = ACTIONS(1428),
    [anon_sym_for] = ACTIONS(1428),
    [anon_sym_inline] = ACTIONS(1428),
    [anon_sym_macro] = ACTIONS(1428),
    [anon_sym_operator] = ACTIONS(1428),
    [anon_sym_overload] = ACTIONS(1428),
    [anon_sym_override] = ACTIONS(1428),
    [anon_sym_private] = ACTIONS(1428),
    [anon_sym_public] = ACTIONS(1428),
    [anon_sym_return] = ACTIONS(1428),
    [anon_sym_static] = ACTIONS(1428),
    [anon_sym_try] = ACTIONS(1428),
    [anon_sym_untyped] = ACTIONS(1428),
    [anon_sym_while] = ACTIONS(1428),
    [sym__semicolon] = ACTIONS(1426),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_POUND] = ACTIONS(1430),
    [anon_sym_package] = ACTIONS(1432),
    [anon_sym_import] = ACTIONS(1432),
    [anon_sym_using] = ACTIONS(1432),
    [anon_sym_throw] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_switch] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [anon_sym_case] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_cast] = ACTIONS(1432),
    [anon_sym_DOLLARtype] = ACTIONS(1430),
    [anon_sym_in] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_this] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_AT_COLON] = ACTIONS(1430),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1432),
    [anon_sym_new] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1430),
    [anon_sym_PERCENT] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1432),
    [anon_sym_GT_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_PIPE] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_EQ_EQ] = ACTIONS(1430),
    [anon_sym_BANG_EQ] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_LT_EQ] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1432),
    [anon_sym_GT_EQ] = ACTIONS(1430),
    [anon_sym_EQ_GT] = ACTIONS(1430),
    [anon_sym_QMARK_QMARK] = ACTIONS(1430),
    [anon_sym_EQ] = ACTIONS(1432),
    [sym__rangeOperator] = ACTIONS(1430),
    [anon_sym_null] = ACTIONS(1432),
    [anon_sym_dynamic] = ACTIONS(1432),
    [anon_sym_final] = ACTIONS(1432),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_extends] = ACTIONS(1432),
    [anon_sym_implements] = ACTIONS(1432),
    [anon_sym_interface] = ACTIONS(1432),
    [anon_sym_typedef] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_var] = ACTIONS(1432),
    [aux_sym_integer_token1] = ACTIONS(1432),
    [aux_sym_integer_token2] = ACTIONS(1430),
    [aux_sym_float_token1] = ACTIONS(1432),
    [aux_sym_float_token2] = ACTIONS(1430),
    [anon_sym_true] = ACTIONS(1432),
    [anon_sym_false] = ACTIONS(1432),
    [aux_sym_string_token1] = ACTIONS(1430),
    [aux_sym_string_token3] = ACTIONS(1430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_catch] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_do] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_extern] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_inline] = ACTIONS(1432),
    [anon_sym_macro] = ACTIONS(1432),
    [anon_sym_operator] = ACTIONS(1432),
    [anon_sym_overload] = ACTIONS(1432),
    [anon_sym_override] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym_public] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [anon_sym_untyped] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [sym__semicolon] = ACTIONS(1430),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_POUND] = ACTIONS(1434),
    [anon_sym_package] = ACTIONS(1436),
    [anon_sym_import] = ACTIONS(1436),
    [anon_sym_using] = ACTIONS(1436),
    [anon_sym_throw] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_switch] = ACTIONS(1436),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [anon_sym_case] = ACTIONS(1436),
    [anon_sym_default] = ACTIONS(1436),
    [anon_sym_cast] = ACTIONS(1436),
    [anon_sym_DOLLARtype] = ACTIONS(1434),
    [anon_sym_in] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_this] = ACTIONS(1436),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_AT_COLON] = ACTIONS(1434),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_else] = ACTIONS(1436),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_LT_LT] = ACTIONS(1434),
    [anon_sym_GT_GT] = ACTIONS(1436),
    [anon_sym_GT_GT_GT] = ACTIONS(1434),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PIPE] = ACTIONS(1436),
    [anon_sym_CARET] = ACTIONS(1434),
    [anon_sym_AMP_AMP] = ACTIONS(1434),
    [anon_sym_PIPE_PIPE] = ACTIONS(1434),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_LT_EQ] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1436),
    [anon_sym_GT_EQ] = ACTIONS(1434),
    [anon_sym_EQ_GT] = ACTIONS(1434),
    [anon_sym_QMARK_QMARK] = ACTIONS(1434),
    [anon_sym_EQ] = ACTIONS(1436),
    [sym__rangeOperator] = ACTIONS(1434),
    [anon_sym_null] = ACTIONS(1436),
    [anon_sym_dynamic] = ACTIONS(1436),
    [anon_sym_final] = ACTIONS(1436),
    [anon_sym_abstract] = ACTIONS(1436),
    [anon_sym_class] = ACTIONS(1436),
    [anon_sym_extends] = ACTIONS(1436),
    [anon_sym_implements] = ACTIONS(1436),
    [anon_sym_interface] = ACTIONS(1436),
    [anon_sym_typedef] = ACTIONS(1436),
    [anon_sym_function] = ACTIONS(1436),
    [anon_sym_var] = ACTIONS(1436),
    [aux_sym_integer_token1] = ACTIONS(1436),
    [aux_sym_integer_token2] = ACTIONS(1434),
    [aux_sym_float_token1] = ACTIONS(1436),
    [aux_sym_float_token2] = ACTIONS(1434),
    [anon_sym_true] = ACTIONS(1436),
    [anon_sym_false] = ACTIONS(1436),
    [aux_sym_string_token1] = ACTIONS(1434),
    [aux_sym_string_token3] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_catch] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_do] = ACTIONS(1436),
    [anon_sym_enum] = ACTIONS(1436),
    [anon_sym_extern] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_inline] = ACTIONS(1436),
    [anon_sym_macro] = ACTIONS(1436),
    [anon_sym_operator] = ACTIONS(1436),
    [anon_sym_overload] = ACTIONS(1436),
    [anon_sym_override] = ACTIONS(1436),
    [anon_sym_private] = ACTIONS(1436),
    [anon_sym_public] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1436),
    [anon_sym_untyped] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [sym__semicolon] = ACTIONS(1434),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_POUND] = ACTIONS(1438),
    [anon_sym_package] = ACTIONS(1440),
    [anon_sym_import] = ACTIONS(1440),
    [anon_sym_using] = ACTIONS(1440),
    [anon_sym_throw] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_case] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1440),
    [anon_sym_cast] = ACTIONS(1440),
    [anon_sym_DOLLARtype] = ACTIONS(1438),
    [anon_sym_in] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_this] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [anon_sym_AT_COLON] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_else] = ACTIONS(1440),
    [anon_sym_new] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_SLASH] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_GT_GT_GT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1440),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_EQ_GT] = ACTIONS(1438),
    [anon_sym_QMARK_QMARK] = ACTIONS(1438),
    [anon_sym_EQ] = ACTIONS(1440),
    [sym__rangeOperator] = ACTIONS(1438),
    [anon_sym_null] = ACTIONS(1440),
    [anon_sym_dynamic] = ACTIONS(1440),
    [anon_sym_final] = ACTIONS(1440),
    [anon_sym_abstract] = ACTIONS(1440),
    [anon_sym_class] = ACTIONS(1440),
    [anon_sym_extends] = ACTIONS(1440),
    [anon_sym_implements] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1440),
    [anon_sym_typedef] = ACTIONS(1440),
    [anon_sym_function] = ACTIONS(1440),
    [anon_sym_var] = ACTIONS(1440),
    [aux_sym_integer_token1] = ACTIONS(1440),
    [aux_sym_integer_token2] = ACTIONS(1438),
    [aux_sym_float_token1] = ACTIONS(1440),
    [aux_sym_float_token2] = ACTIONS(1438),
    [anon_sym_true] = ACTIONS(1440),
    [anon_sym_false] = ACTIONS(1440),
    [aux_sym_string_token1] = ACTIONS(1438),
    [aux_sym_string_token3] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_catch] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_do] = ACTIONS(1440),
    [anon_sym_enum] = ACTIONS(1440),
    [anon_sym_extern] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_inline] = ACTIONS(1440),
    [anon_sym_macro] = ACTIONS(1440),
    [anon_sym_operator] = ACTIONS(1440),
    [anon_sym_overload] = ACTIONS(1440),
    [anon_sym_override] = ACTIONS(1440),
    [anon_sym_private] = ACTIONS(1440),
    [anon_sym_public] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_static] = ACTIONS(1440),
    [anon_sym_try] = ACTIONS(1440),
    [anon_sym_untyped] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [sym__semicolon] = ACTIONS(1438),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_POUND] = ACTIONS(1442),
    [anon_sym_package] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_using] = ACTIONS(1444),
    [anon_sym_throw] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_case] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_cast] = ACTIONS(1444),
    [anon_sym_DOLLARtype] = ACTIONS(1442),
    [anon_sym_in] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1444),
    [anon_sym_AT_COLON] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_else] = ACTIONS(1444),
    [anon_sym_new] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1442),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_GT_GT_GT] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_EQ_GT] = ACTIONS(1442),
    [anon_sym_QMARK_QMARK] = ACTIONS(1442),
    [anon_sym_EQ] = ACTIONS(1444),
    [sym__rangeOperator] = ACTIONS(1442),
    [anon_sym_null] = ACTIONS(1444),
    [anon_sym_dynamic] = ACTIONS(1444),
    [anon_sym_final] = ACTIONS(1444),
    [anon_sym_abstract] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_extends] = ACTIONS(1444),
    [anon_sym_implements] = ACTIONS(1444),
    [anon_sym_interface] = ACTIONS(1444),
    [anon_sym_typedef] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(1444),
    [anon_sym_var] = ACTIONS(1444),
    [aux_sym_integer_token1] = ACTIONS(1444),
    [aux_sym_integer_token2] = ACTIONS(1442),
    [aux_sym_float_token1] = ACTIONS(1444),
    [aux_sym_float_token2] = ACTIONS(1442),
    [anon_sym_true] = ACTIONS(1444),
    [anon_sym_false] = ACTIONS(1444),
    [aux_sym_string_token1] = ACTIONS(1442),
    [aux_sym_string_token3] = ACTIONS(1442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_catch] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_do] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_extern] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_inline] = ACTIONS(1444),
    [anon_sym_macro] = ACTIONS(1444),
    [anon_sym_operator] = ACTIONS(1444),
    [anon_sym_overload] = ACTIONS(1444),
    [anon_sym_override] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_untyped] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [sym__semicolon] = ACTIONS(1442),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_POUND] = ACTIONS(1446),
    [anon_sym_package] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(1448),
    [anon_sym_using] = ACTIONS(1448),
    [anon_sym_throw] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_cast] = ACTIONS(1448),
    [anon_sym_DOLLARtype] = ACTIONS(1446),
    [anon_sym_in] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_this] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [anon_sym_AT_COLON] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_PERCENT] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_GT_GT_GT] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1446),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_QMARK] = ACTIONS(1446),
    [anon_sym_EQ] = ACTIONS(1448),
    [sym__rangeOperator] = ACTIONS(1446),
    [anon_sym_null] = ACTIONS(1448),
    [anon_sym_dynamic] = ACTIONS(1448),
    [anon_sym_final] = ACTIONS(1448),
    [anon_sym_abstract] = ACTIONS(1448),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_extends] = ACTIONS(1448),
    [anon_sym_implements] = ACTIONS(1448),
    [anon_sym_interface] = ACTIONS(1448),
    [anon_sym_typedef] = ACTIONS(1448),
    [anon_sym_function] = ACTIONS(1448),
    [anon_sym_var] = ACTIONS(1448),
    [aux_sym_integer_token1] = ACTIONS(1448),
    [aux_sym_integer_token2] = ACTIONS(1446),
    [aux_sym_float_token1] = ACTIONS(1448),
    [aux_sym_float_token2] = ACTIONS(1446),
    [anon_sym_true] = ACTIONS(1448),
    [anon_sym_false] = ACTIONS(1448),
    [aux_sym_string_token1] = ACTIONS(1446),
    [aux_sym_string_token3] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_catch] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_do] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [anon_sym_extern] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_inline] = ACTIONS(1448),
    [anon_sym_macro] = ACTIONS(1448),
    [anon_sym_operator] = ACTIONS(1448),
    [anon_sym_overload] = ACTIONS(1448),
    [anon_sym_override] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [anon_sym_untyped] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [sym__semicolon] = ACTIONS(1446),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_POUND] = ACTIONS(1450),
    [anon_sym_package] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_using] = ACTIONS(1452),
    [anon_sym_throw] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_switch] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_cast] = ACTIONS(1452),
    [anon_sym_DOLLARtype] = ACTIONS(1450),
    [anon_sym_in] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_this] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1452),
    [anon_sym_AT_COLON] = ACTIONS(1450),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1450),
    [anon_sym_PERCENT] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1450),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_LT_LT] = ACTIONS(1450),
    [anon_sym_GT_GT] = ACTIONS(1452),
    [anon_sym_GT_GT_GT] = ACTIONS(1450),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_PIPE] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1450),
    [anon_sym_AMP_AMP] = ACTIONS(1450),
    [anon_sym_PIPE_PIPE] = ACTIONS(1450),
    [anon_sym_EQ_EQ] = ACTIONS(1450),
    [anon_sym_BANG_EQ] = ACTIONS(1450),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_LT_EQ] = ACTIONS(1450),
    [anon_sym_GT] = ACTIONS(1452),
    [anon_sym_GT_EQ] = ACTIONS(1450),
    [anon_sym_EQ_GT] = ACTIONS(1450),
    [anon_sym_QMARK_QMARK] = ACTIONS(1450),
    [anon_sym_EQ] = ACTIONS(1452),
    [sym__rangeOperator] = ACTIONS(1450),
    [anon_sym_null] = ACTIONS(1452),
    [anon_sym_dynamic] = ACTIONS(1452),
    [anon_sym_final] = ACTIONS(1452),
    [anon_sym_abstract] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_extends] = ACTIONS(1452),
    [anon_sym_implements] = ACTIONS(1452),
    [anon_sym_interface] = ACTIONS(1452),
    [anon_sym_typedef] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(1452),
    [anon_sym_var] = ACTIONS(1452),
    [aux_sym_integer_token1] = ACTIONS(1452),
    [aux_sym_integer_token2] = ACTIONS(1450),
    [aux_sym_float_token1] = ACTIONS(1452),
    [aux_sym_float_token2] = ACTIONS(1450),
    [anon_sym_true] = ACTIONS(1452),
    [anon_sym_false] = ACTIONS(1452),
    [aux_sym_string_token1] = ACTIONS(1450),
    [aux_sym_string_token3] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_catch] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_do] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_extern] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_inline] = ACTIONS(1452),
    [anon_sym_macro] = ACTIONS(1452),
    [anon_sym_operator] = ACTIONS(1452),
    [anon_sym_overload] = ACTIONS(1452),
    [anon_sym_override] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym_public] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_untyped] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [sym__semicolon] = ACTIONS(1450),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_identifier] = ACTIONS(1456),
    [anon_sym_POUND] = ACTIONS(1454),
    [anon_sym_package] = ACTIONS(1456),
    [anon_sym_import] = ACTIONS(1456),
    [anon_sym_using] = ACTIONS(1456),
    [anon_sym_throw] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_switch] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [anon_sym_case] = ACTIONS(1456),
    [anon_sym_default] = ACTIONS(1456),
    [anon_sym_cast] = ACTIONS(1456),
    [anon_sym_DOLLARtype] = ACTIONS(1454),
    [anon_sym_in] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_this] = ACTIONS(1456),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_AT_COLON] = ACTIONS(1454),
    [anon_sym_if] = ACTIONS(1456),
    [anon_sym_else] = ACTIONS(1456),
    [anon_sym_new] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1456),
    [anon_sym_PLUS] = ACTIONS(1456),
    [anon_sym_LT_LT] = ACTIONS(1454),
    [anon_sym_GT_GT] = ACTIONS(1456),
    [anon_sym_GT_GT_GT] = ACTIONS(1454),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_PIPE] = ACTIONS(1456),
    [anon_sym_CARET] = ACTIONS(1454),
    [anon_sym_AMP_AMP] = ACTIONS(1454),
    [anon_sym_PIPE_PIPE] = ACTIONS(1454),
    [anon_sym_EQ_EQ] = ACTIONS(1454),
    [anon_sym_BANG_EQ] = ACTIONS(1454),
    [anon_sym_LT] = ACTIONS(1456),
    [anon_sym_LT_EQ] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1456),
    [anon_sym_GT_EQ] = ACTIONS(1454),
    [anon_sym_EQ_GT] = ACTIONS(1454),
    [anon_sym_QMARK_QMARK] = ACTIONS(1454),
    [anon_sym_EQ] = ACTIONS(1456),
    [sym__rangeOperator] = ACTIONS(1454),
    [anon_sym_null] = ACTIONS(1456),
    [anon_sym_dynamic] = ACTIONS(1456),
    [anon_sym_final] = ACTIONS(1456),
    [anon_sym_abstract] = ACTIONS(1456),
    [anon_sym_class] = ACTIONS(1456),
    [anon_sym_extends] = ACTIONS(1456),
    [anon_sym_implements] = ACTIONS(1456),
    [anon_sym_interface] = ACTIONS(1456),
    [anon_sym_typedef] = ACTIONS(1456),
    [anon_sym_function] = ACTIONS(1456),
    [anon_sym_var] = ACTIONS(1456),
    [aux_sym_integer_token1] = ACTIONS(1456),
    [aux_sym_integer_token2] = ACTIONS(1454),
    [aux_sym_float_token1] = ACTIONS(1456),
    [aux_sym_float_token2] = ACTIONS(1454),
    [anon_sym_true] = ACTIONS(1456),
    [anon_sym_false] = ACTIONS(1456),
    [aux_sym_string_token1] = ACTIONS(1454),
    [aux_sym_string_token3] = ACTIONS(1454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1456),
    [anon_sym_catch] = ACTIONS(1456),
    [anon_sym_continue] = ACTIONS(1456),
    [anon_sym_do] = ACTIONS(1456),
    [anon_sym_enum] = ACTIONS(1456),
    [anon_sym_extern] = ACTIONS(1456),
    [anon_sym_for] = ACTIONS(1456),
    [anon_sym_inline] = ACTIONS(1456),
    [anon_sym_macro] = ACTIONS(1456),
    [anon_sym_operator] = ACTIONS(1456),
    [anon_sym_overload] = ACTIONS(1456),
    [anon_sym_override] = ACTIONS(1456),
    [anon_sym_private] = ACTIONS(1456),
    [anon_sym_public] = ACTIONS(1456),
    [anon_sym_return] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1456),
    [anon_sym_try] = ACTIONS(1456),
    [anon_sym_untyped] = ACTIONS(1456),
    [anon_sym_while] = ACTIONS(1456),
    [sym__semicolon] = ACTIONS(1454),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_POUND] = ACTIONS(1458),
    [anon_sym_package] = ACTIONS(1460),
    [anon_sym_import] = ACTIONS(1460),
    [anon_sym_using] = ACTIONS(1460),
    [anon_sym_throw] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_switch] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_case] = ACTIONS(1460),
    [anon_sym_default] = ACTIONS(1460),
    [anon_sym_cast] = ACTIONS(1460),
    [anon_sym_DOLLARtype] = ACTIONS(1458),
    [anon_sym_in] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_this] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(1460),
    [anon_sym_AT_COLON] = ACTIONS(1458),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1460),
    [anon_sym_new] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1458),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_SLASH] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_LT_LT] = ACTIONS(1458),
    [anon_sym_GT_GT] = ACTIONS(1460),
    [anon_sym_GT_GT_GT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym_AMP_AMP] = ACTIONS(1458),
    [anon_sym_PIPE_PIPE] = ACTIONS(1458),
    [anon_sym_EQ_EQ] = ACTIONS(1458),
    [anon_sym_BANG_EQ] = ACTIONS(1458),
    [anon_sym_LT] = ACTIONS(1460),
    [anon_sym_LT_EQ] = ACTIONS(1458),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_GT_EQ] = ACTIONS(1458),
    [anon_sym_EQ_GT] = ACTIONS(1458),
    [anon_sym_QMARK_QMARK] = ACTIONS(1458),
    [anon_sym_EQ] = ACTIONS(1460),
    [sym__rangeOperator] = ACTIONS(1458),
    [anon_sym_null] = ACTIONS(1460),
    [anon_sym_dynamic] = ACTIONS(1460),
    [anon_sym_final] = ACTIONS(1460),
    [anon_sym_abstract] = ACTIONS(1460),
    [anon_sym_class] = ACTIONS(1460),
    [anon_sym_extends] = ACTIONS(1460),
    [anon_sym_implements] = ACTIONS(1460),
    [anon_sym_interface] = ACTIONS(1460),
    [anon_sym_typedef] = ACTIONS(1460),
    [anon_sym_function] = ACTIONS(1460),
    [anon_sym_var] = ACTIONS(1460),
    [aux_sym_integer_token1] = ACTIONS(1460),
    [aux_sym_integer_token2] = ACTIONS(1458),
    [aux_sym_float_token1] = ACTIONS(1460),
    [aux_sym_float_token2] = ACTIONS(1458),
    [anon_sym_true] = ACTIONS(1460),
    [anon_sym_false] = ACTIONS(1460),
    [aux_sym_string_token1] = ACTIONS(1458),
    [aux_sym_string_token3] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_catch] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(1460),
    [anon_sym_enum] = ACTIONS(1460),
    [anon_sym_extern] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_inline] = ACTIONS(1460),
    [anon_sym_macro] = ACTIONS(1460),
    [anon_sym_operator] = ACTIONS(1460),
    [anon_sym_overload] = ACTIONS(1460),
    [anon_sym_override] = ACTIONS(1460),
    [anon_sym_private] = ACTIONS(1460),
    [anon_sym_public] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1460),
    [anon_sym_try] = ACTIONS(1460),
    [anon_sym_untyped] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [sym__semicolon] = ACTIONS(1458),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(926),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_POUND] = ACTIONS(926),
    [anon_sym_package] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_using] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_switch] = ACTIONS(928),
    [anon_sym_LBRACE] = ACTIONS(926),
    [anon_sym_RBRACE] = ACTIONS(926),
    [anon_sym_case] = ACTIONS(928),
    [anon_sym_default] = ACTIONS(928),
    [anon_sym_cast] = ACTIONS(928),
    [anon_sym_DOLLARtype] = ACTIONS(926),
    [anon_sym_in] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(926),
    [anon_sym_this] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(928),
    [anon_sym_AT_COLON] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_else] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(928),
    [anon_sym_DASH] = ACTIONS(928),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_PERCENT] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(926),
    [anon_sym_SLASH] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(928),
    [anon_sym_LT_LT] = ACTIONS(926),
    [anon_sym_GT_GT] = ACTIONS(928),
    [anon_sym_GT_GT_GT] = ACTIONS(926),
    [anon_sym_AMP] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_CARET] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_EQ_EQ] = ACTIONS(926),
    [anon_sym_BANG_EQ] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_LT_EQ] = ACTIONS(926),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_EQ] = ACTIONS(926),
    [anon_sym_EQ_GT] = ACTIONS(926),
    [anon_sym_QMARK_QMARK] = ACTIONS(926),
    [anon_sym_EQ] = ACTIONS(928),
    [sym__rangeOperator] = ACTIONS(926),
    [anon_sym_null] = ACTIONS(928),
    [anon_sym_dynamic] = ACTIONS(928),
    [anon_sym_final] = ACTIONS(928),
    [anon_sym_abstract] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_extends] = ACTIONS(928),
    [anon_sym_implements] = ACTIONS(928),
    [anon_sym_interface] = ACTIONS(928),
    [anon_sym_typedef] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(928),
    [anon_sym_var] = ACTIONS(928),
    [aux_sym_integer_token1] = ACTIONS(928),
    [aux_sym_integer_token2] = ACTIONS(926),
    [aux_sym_float_token1] = ACTIONS(928),
    [aux_sym_float_token2] = ACTIONS(926),
    [anon_sym_true] = ACTIONS(928),
    [anon_sym_false] = ACTIONS(928),
    [aux_sym_string_token1] = ACTIONS(926),
    [aux_sym_string_token3] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_catch] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_do] = ACTIONS(928),
    [anon_sym_enum] = ACTIONS(928),
    [anon_sym_extern] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_inline] = ACTIONS(928),
    [anon_sym_macro] = ACTIONS(928),
    [anon_sym_operator] = ACTIONS(928),
    [anon_sym_overload] = ACTIONS(928),
    [anon_sym_override] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_untyped] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [sym__semicolon] = ACTIONS(926),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1464),
    [anon_sym_POUND] = ACTIONS(1462),
    [anon_sym_package] = ACTIONS(1464),
    [anon_sym_import] = ACTIONS(1464),
    [anon_sym_using] = ACTIONS(1464),
    [anon_sym_throw] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_case] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1464),
    [anon_sym_cast] = ACTIONS(1464),
    [anon_sym_DOLLARtype] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_this] = ACTIONS(1464),
    [anon_sym_AT] = ACTIONS(1464),
    [anon_sym_AT_COLON] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1464),
    [anon_sym_new] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PERCENT] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_LT_LT] = ACTIONS(1462),
    [anon_sym_GT_GT] = ACTIONS(1464),
    [anon_sym_GT_GT_GT] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1462),
    [anon_sym_AMP_AMP] = ACTIONS(1462),
    [anon_sym_PIPE_PIPE] = ACTIONS(1462),
    [anon_sym_EQ_EQ] = ACTIONS(1462),
    [anon_sym_BANG_EQ] = ACTIONS(1462),
    [anon_sym_LT] = ACTIONS(1464),
    [anon_sym_LT_EQ] = ACTIONS(1462),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_GT_EQ] = ACTIONS(1462),
    [anon_sym_EQ_GT] = ACTIONS(1462),
    [anon_sym_QMARK_QMARK] = ACTIONS(1462),
    [anon_sym_EQ] = ACTIONS(1464),
    [sym__rangeOperator] = ACTIONS(1462),
    [anon_sym_null] = ACTIONS(1464),
    [anon_sym_dynamic] = ACTIONS(1464),
    [anon_sym_final] = ACTIONS(1464),
    [anon_sym_abstract] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1464),
    [anon_sym_extends] = ACTIONS(1464),
    [anon_sym_implements] = ACTIONS(1464),
    [anon_sym_interface] = ACTIONS(1464),
    [anon_sym_typedef] = ACTIONS(1464),
    [anon_sym_function] = ACTIONS(1464),
    [anon_sym_var] = ACTIONS(1464),
    [aux_sym_integer_token1] = ACTIONS(1464),
    [aux_sym_integer_token2] = ACTIONS(1462),
    [aux_sym_float_token1] = ACTIONS(1464),
    [aux_sym_float_token2] = ACTIONS(1462),
    [anon_sym_true] = ACTIONS(1464),
    [anon_sym_false] = ACTIONS(1464),
    [aux_sym_string_token1] = ACTIONS(1462),
    [aux_sym_string_token3] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_catch] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_do] = ACTIONS(1464),
    [anon_sym_enum] = ACTIONS(1464),
    [anon_sym_extern] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_inline] = ACTIONS(1464),
    [anon_sym_macro] = ACTIONS(1464),
    [anon_sym_operator] = ACTIONS(1464),
    [anon_sym_overload] = ACTIONS(1464),
    [anon_sym_override] = ACTIONS(1464),
    [anon_sym_private] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_try] = ACTIONS(1464),
    [anon_sym_untyped] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [sym__semicolon] = ACTIONS(1462),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_POUND] = ACTIONS(1466),
    [anon_sym_package] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_using] = ACTIONS(1468),
    [anon_sym_throw] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_switch] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1468),
    [anon_sym_default] = ACTIONS(1468),
    [anon_sym_cast] = ACTIONS(1468),
    [anon_sym_DOLLARtype] = ACTIONS(1466),
    [anon_sym_in] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_this] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1468),
    [anon_sym_AT_COLON] = ACTIONS(1466),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_else] = ACTIONS(1468),
    [anon_sym_new] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PERCENT] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_LT_LT] = ACTIONS(1466),
    [anon_sym_GT_GT] = ACTIONS(1468),
    [anon_sym_GT_GT_GT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1468),
    [anon_sym_CARET] = ACTIONS(1466),
    [anon_sym_AMP_AMP] = ACTIONS(1466),
    [anon_sym_PIPE_PIPE] = ACTIONS(1466),
    [anon_sym_EQ_EQ] = ACTIONS(1466),
    [anon_sym_BANG_EQ] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1466),
    [anon_sym_GT] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1466),
    [anon_sym_EQ_GT] = ACTIONS(1466),
    [anon_sym_QMARK_QMARK] = ACTIONS(1466),
    [anon_sym_EQ] = ACTIONS(1468),
    [sym__rangeOperator] = ACTIONS(1466),
    [anon_sym_null] = ACTIONS(1468),
    [anon_sym_dynamic] = ACTIONS(1468),
    [anon_sym_final] = ACTIONS(1468),
    [anon_sym_abstract] = ACTIONS(1468),
    [anon_sym_class] = ACTIONS(1468),
    [anon_sym_extends] = ACTIONS(1468),
    [anon_sym_implements] = ACTIONS(1468),
    [anon_sym_interface] = ACTIONS(1468),
    [anon_sym_typedef] = ACTIONS(1468),
    [anon_sym_function] = ACTIONS(1468),
    [anon_sym_var] = ACTIONS(1468),
    [aux_sym_integer_token1] = ACTIONS(1468),
    [aux_sym_integer_token2] = ACTIONS(1466),
    [aux_sym_float_token1] = ACTIONS(1468),
    [aux_sym_float_token2] = ACTIONS(1466),
    [anon_sym_true] = ACTIONS(1468),
    [anon_sym_false] = ACTIONS(1468),
    [aux_sym_string_token1] = ACTIONS(1466),
    [aux_sym_string_token3] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_catch] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(1468),
    [anon_sym_enum] = ACTIONS(1468),
    [anon_sym_extern] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_inline] = ACTIONS(1468),
    [anon_sym_macro] = ACTIONS(1468),
    [anon_sym_operator] = ACTIONS(1468),
    [anon_sym_overload] = ACTIONS(1468),
    [anon_sym_override] = ACTIONS(1468),
    [anon_sym_private] = ACTIONS(1468),
    [anon_sym_public] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_static] = ACTIONS(1468),
    [anon_sym_try] = ACTIONS(1468),
    [anon_sym_untyped] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [sym__semicolon] = ACTIONS(1466),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_POUND] = ACTIONS(1470),
    [anon_sym_package] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_using] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_cast] = ACTIONS(1472),
    [anon_sym_DOLLARtype] = ACTIONS(1470),
    [anon_sym_in] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_this] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1472),
    [anon_sym_AT_COLON] = ACTIONS(1470),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PERCENT] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_LT_LT] = ACTIONS(1470),
    [anon_sym_GT_GT] = ACTIONS(1472),
    [anon_sym_GT_GT_GT] = ACTIONS(1470),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_PIPE] = ACTIONS(1472),
    [anon_sym_CARET] = ACTIONS(1470),
    [anon_sym_AMP_AMP] = ACTIONS(1470),
    [anon_sym_PIPE_PIPE] = ACTIONS(1470),
    [anon_sym_EQ_EQ] = ACTIONS(1470),
    [anon_sym_BANG_EQ] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_LT_EQ] = ACTIONS(1470),
    [anon_sym_GT] = ACTIONS(1472),
    [anon_sym_GT_EQ] = ACTIONS(1470),
    [anon_sym_EQ_GT] = ACTIONS(1470),
    [anon_sym_QMARK_QMARK] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1472),
    [sym__rangeOperator] = ACTIONS(1470),
    [anon_sym_null] = ACTIONS(1472),
    [anon_sym_dynamic] = ACTIONS(1472),
    [anon_sym_final] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_extends] = ACTIONS(1472),
    [anon_sym_implements] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_typedef] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [aux_sym_integer_token1] = ACTIONS(1472),
    [aux_sym_integer_token2] = ACTIONS(1470),
    [aux_sym_float_token1] = ACTIONS(1472),
    [aux_sym_float_token2] = ACTIONS(1470),
    [anon_sym_true] = ACTIONS(1472),
    [anon_sym_false] = ACTIONS(1472),
    [aux_sym_string_token1] = ACTIONS(1470),
    [aux_sym_string_token3] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_catch] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_extern] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_inline] = ACTIONS(1472),
    [anon_sym_macro] = ACTIONS(1472),
    [anon_sym_operator] = ACTIONS(1472),
    [anon_sym_overload] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_untyped] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [sym__semicolon] = ACTIONS(1470),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_POUND] = ACTIONS(1474),
    [anon_sym_package] = ACTIONS(1476),
    [anon_sym_import] = ACTIONS(1476),
    [anon_sym_using] = ACTIONS(1476),
    [anon_sym_throw] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1474),
    [anon_sym_switch] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_RBRACE] = ACTIONS(1474),
    [anon_sym_case] = ACTIONS(1476),
    [anon_sym_default] = ACTIONS(1476),
    [anon_sym_cast] = ACTIONS(1476),
    [anon_sym_DOLLARtype] = ACTIONS(1474),
    [anon_sym_in] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_this] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_AT_COLON] = ACTIONS(1474),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1476),
    [anon_sym_new] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1474),
    [anon_sym_GT_GT] = ACTIONS(1476),
    [anon_sym_GT_GT_GT] = ACTIONS(1474),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_CARET] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1474),
    [anon_sym_PIPE_PIPE] = ACTIONS(1474),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_LT] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1474),
    [anon_sym_EQ_GT] = ACTIONS(1474),
    [anon_sym_QMARK_QMARK] = ACTIONS(1474),
    [anon_sym_EQ] = ACTIONS(1476),
    [sym__rangeOperator] = ACTIONS(1474),
    [anon_sym_null] = ACTIONS(1476),
    [anon_sym_dynamic] = ACTIONS(1476),
    [anon_sym_final] = ACTIONS(1476),
    [anon_sym_abstract] = ACTIONS(1476),
    [anon_sym_class] = ACTIONS(1476),
    [anon_sym_extends] = ACTIONS(1476),
    [anon_sym_implements] = ACTIONS(1476),
    [anon_sym_interface] = ACTIONS(1476),
    [anon_sym_typedef] = ACTIONS(1476),
    [anon_sym_function] = ACTIONS(1476),
    [anon_sym_var] = ACTIONS(1476),
    [aux_sym_integer_token1] = ACTIONS(1476),
    [aux_sym_integer_token2] = ACTIONS(1474),
    [aux_sym_float_token1] = ACTIONS(1476),
    [aux_sym_float_token2] = ACTIONS(1474),
    [anon_sym_true] = ACTIONS(1476),
    [anon_sym_false] = ACTIONS(1476),
    [aux_sym_string_token1] = ACTIONS(1474),
    [aux_sym_string_token3] = ACTIONS(1474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_catch] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_do] = ACTIONS(1476),
    [anon_sym_enum] = ACTIONS(1476),
    [anon_sym_extern] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_inline] = ACTIONS(1476),
    [anon_sym_macro] = ACTIONS(1476),
    [anon_sym_operator] = ACTIONS(1476),
    [anon_sym_overload] = ACTIONS(1476),
    [anon_sym_override] = ACTIONS(1476),
    [anon_sym_private] = ACTIONS(1476),
    [anon_sym_public] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1476),
    [anon_sym_try] = ACTIONS(1476),
    [anon_sym_untyped] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [sym__semicolon] = ACTIONS(1474),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(396),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_POUND] = ACTIONS(396),
    [anon_sym_package] = ACTIONS(398),
    [anon_sym_import] = ACTIONS(398),
    [anon_sym_using] = ACTIONS(398),
    [anon_sym_throw] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(396),
    [anon_sym_switch] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_case] = ACTIONS(398),
    [anon_sym_default] = ACTIONS(398),
    [anon_sym_cast] = ACTIONS(398),
    [anon_sym_DOLLARtype] = ACTIONS(396),
    [anon_sym_in] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(398),
    [anon_sym_AT] = ACTIONS(398),
    [anon_sym_AT_COLON] = ACTIONS(396),
    [anon_sym_if] = ACTIONS(398),
    [anon_sym_else] = ACTIONS(398),
    [anon_sym_new] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PLUS_PLUS] = ACTIONS(396),
    [anon_sym_DASH_DASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(398),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(398),
    [anon_sym_GT_GT_GT] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(398),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(396),
    [anon_sym_BANG_EQ] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_LT_EQ] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(398),
    [anon_sym_GT_EQ] = ACTIONS(396),
    [anon_sym_EQ_GT] = ACTIONS(396),
    [anon_sym_QMARK_QMARK] = ACTIONS(396),
    [anon_sym_EQ] = ACTIONS(398),
    [sym__rangeOperator] = ACTIONS(396),
    [anon_sym_null] = ACTIONS(398),
    [anon_sym_dynamic] = ACTIONS(398),
    [anon_sym_final] = ACTIONS(398),
    [anon_sym_abstract] = ACTIONS(398),
    [anon_sym_class] = ACTIONS(398),
    [anon_sym_extends] = ACTIONS(398),
    [anon_sym_implements] = ACTIONS(398),
    [anon_sym_interface] = ACTIONS(398),
    [anon_sym_typedef] = ACTIONS(398),
    [anon_sym_function] = ACTIONS(398),
    [anon_sym_var] = ACTIONS(398),
    [aux_sym_integer_token1] = ACTIONS(398),
    [aux_sym_integer_token2] = ACTIONS(396),
    [aux_sym_float_token1] = ACTIONS(398),
    [aux_sym_float_token2] = ACTIONS(396),
    [anon_sym_true] = ACTIONS(398),
    [anon_sym_false] = ACTIONS(398),
    [aux_sym_string_token1] = ACTIONS(396),
    [aux_sym_string_token3] = ACTIONS(396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(398),
    [anon_sym_catch] = ACTIONS(398),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_do] = ACTIONS(398),
    [anon_sym_enum] = ACTIONS(398),
    [anon_sym_extern] = ACTIONS(398),
    [anon_sym_for] = ACTIONS(398),
    [anon_sym_inline] = ACTIONS(398),
    [anon_sym_macro] = ACTIONS(398),
    [anon_sym_operator] = ACTIONS(398),
    [anon_sym_overload] = ACTIONS(398),
    [anon_sym_override] = ACTIONS(398),
    [anon_sym_private] = ACTIONS(398),
    [anon_sym_public] = ACTIONS(398),
    [anon_sym_return] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(398),
    [anon_sym_try] = ACTIONS(398),
    [anon_sym_untyped] = ACTIONS(398),
    [anon_sym_while] = ACTIONS(398),
    [sym__semicolon] = ACTIONS(396),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_POUND] = ACTIONS(1478),
    [anon_sym_package] = ACTIONS(1480),
    [anon_sym_import] = ACTIONS(1480),
    [anon_sym_using] = ACTIONS(1480),
    [anon_sym_throw] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_switch] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [anon_sym_case] = ACTIONS(1480),
    [anon_sym_default] = ACTIONS(1480),
    [anon_sym_cast] = ACTIONS(1480),
    [anon_sym_DOLLARtype] = ACTIONS(1478),
    [anon_sym_in] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_this] = ACTIONS(1480),
    [anon_sym_AT] = ACTIONS(1480),
    [anon_sym_AT_COLON] = ACTIONS(1478),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1480),
    [anon_sym_new] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PERCENT] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_SLASH] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(1480),
    [anon_sym_GT_GT_GT] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1480),
    [anon_sym_PIPE] = ACTIONS(1480),
    [anon_sym_CARET] = ACTIONS(1478),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1480),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_GT] = ACTIONS(1480),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_GT] = ACTIONS(1478),
    [anon_sym_QMARK_QMARK] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1480),
    [sym__rangeOperator] = ACTIONS(1478),
    [anon_sym_null] = ACTIONS(1480),
    [anon_sym_dynamic] = ACTIONS(1480),
    [anon_sym_final] = ACTIONS(1480),
    [anon_sym_abstract] = ACTIONS(1480),
    [anon_sym_class] = ACTIONS(1480),
    [anon_sym_extends] = ACTIONS(1480),
    [anon_sym_implements] = ACTIONS(1480),
    [anon_sym_interface] = ACTIONS(1480),
    [anon_sym_typedef] = ACTIONS(1480),
    [anon_sym_function] = ACTIONS(1480),
    [anon_sym_var] = ACTIONS(1480),
    [aux_sym_integer_token1] = ACTIONS(1480),
    [aux_sym_integer_token2] = ACTIONS(1478),
    [aux_sym_float_token1] = ACTIONS(1480),
    [aux_sym_float_token2] = ACTIONS(1478),
    [anon_sym_true] = ACTIONS(1480),
    [anon_sym_false] = ACTIONS(1480),
    [aux_sym_string_token1] = ACTIONS(1478),
    [aux_sym_string_token3] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_catch] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_do] = ACTIONS(1480),
    [anon_sym_enum] = ACTIONS(1480),
    [anon_sym_extern] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_inline] = ACTIONS(1480),
    [anon_sym_macro] = ACTIONS(1480),
    [anon_sym_operator] = ACTIONS(1480),
    [anon_sym_overload] = ACTIONS(1480),
    [anon_sym_override] = ACTIONS(1480),
    [anon_sym_private] = ACTIONS(1480),
    [anon_sym_public] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_static] = ACTIONS(1480),
    [anon_sym_try] = ACTIONS(1480),
    [anon_sym_untyped] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [sym__semicolon] = ACTIONS(1478),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_POUND] = ACTIONS(1482),
    [anon_sym_package] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1484),
    [anon_sym_using] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_cast] = ACTIONS(1484),
    [anon_sym_DOLLARtype] = ACTIONS(1482),
    [anon_sym_in] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_this] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(1484),
    [anon_sym_AT_COLON] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_new] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PERCENT] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_LT_LT] = ACTIONS(1482),
    [anon_sym_GT_GT] = ACTIONS(1484),
    [anon_sym_GT_GT_GT] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_CARET] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_GT] = ACTIONS(1482),
    [anon_sym_QMARK_QMARK] = ACTIONS(1482),
    [anon_sym_EQ] = ACTIONS(1484),
    [sym__rangeOperator] = ACTIONS(1482),
    [anon_sym_null] = ACTIONS(1484),
    [anon_sym_dynamic] = ACTIONS(1484),
    [anon_sym_final] = ACTIONS(1484),
    [anon_sym_abstract] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1484),
    [anon_sym_extends] = ACTIONS(1484),
    [anon_sym_implements] = ACTIONS(1484),
    [anon_sym_interface] = ACTIONS(1484),
    [anon_sym_typedef] = ACTIONS(1484),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_var] = ACTIONS(1484),
    [aux_sym_integer_token1] = ACTIONS(1484),
    [aux_sym_integer_token2] = ACTIONS(1482),
    [aux_sym_float_token1] = ACTIONS(1484),
    [aux_sym_float_token2] = ACTIONS(1482),
    [anon_sym_true] = ACTIONS(1484),
    [anon_sym_false] = ACTIONS(1484),
    [aux_sym_string_token1] = ACTIONS(1482),
    [aux_sym_string_token3] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_catch] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [anon_sym_extern] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_inline] = ACTIONS(1484),
    [anon_sym_macro] = ACTIONS(1484),
    [anon_sym_operator] = ACTIONS(1484),
    [anon_sym_overload] = ACTIONS(1484),
    [anon_sym_override] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym_public] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_try] = ACTIONS(1484),
    [anon_sym_untyped] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [sym__semicolon] = ACTIONS(1482),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(396),
    [sym_identifier] = ACTIONS(398),
    [anon_sym_POUND] = ACTIONS(396),
    [anon_sym_package] = ACTIONS(398),
    [anon_sym_import] = ACTIONS(398),
    [anon_sym_using] = ACTIONS(398),
    [anon_sym_throw] = ACTIONS(398),
    [anon_sym_LPAREN] = ACTIONS(396),
    [anon_sym_switch] = ACTIONS(398),
    [anon_sym_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_case] = ACTIONS(398),
    [anon_sym_default] = ACTIONS(398),
    [anon_sym_cast] = ACTIONS(398),
    [anon_sym_DOLLARtype] = ACTIONS(396),
    [anon_sym_in] = ACTIONS(398),
    [anon_sym_LBRACK] = ACTIONS(396),
    [anon_sym_this] = ACTIONS(398),
    [anon_sym_AT] = ACTIONS(398),
    [anon_sym_AT_COLON] = ACTIONS(396),
    [anon_sym_if] = ACTIONS(398),
    [anon_sym_else] = ACTIONS(398),
    [anon_sym_new] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PLUS_PLUS] = ACTIONS(396),
    [anon_sym_DASH_DASH] = ACTIONS(396),
    [anon_sym_PERCENT] = ACTIONS(396),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(398),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_LT_LT] = ACTIONS(396),
    [anon_sym_GT_GT] = ACTIONS(398),
    [anon_sym_GT_GT_GT] = ACTIONS(396),
    [anon_sym_AMP] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(398),
    [anon_sym_CARET] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(396),
    [anon_sym_PIPE_PIPE] = ACTIONS(396),
    [anon_sym_EQ_EQ] = ACTIONS(396),
    [anon_sym_BANG_EQ] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_LT_EQ] = ACTIONS(396),
    [anon_sym_GT] = ACTIONS(398),
    [anon_sym_GT_EQ] = ACTIONS(396),
    [anon_sym_EQ_GT] = ACTIONS(396),
    [anon_sym_QMARK_QMARK] = ACTIONS(396),
    [anon_sym_EQ] = ACTIONS(398),
    [sym__rangeOperator] = ACTIONS(396),
    [anon_sym_null] = ACTIONS(398),
    [anon_sym_dynamic] = ACTIONS(398),
    [anon_sym_final] = ACTIONS(398),
    [anon_sym_abstract] = ACTIONS(398),
    [anon_sym_class] = ACTIONS(398),
    [anon_sym_extends] = ACTIONS(398),
    [anon_sym_implements] = ACTIONS(398),
    [anon_sym_interface] = ACTIONS(398),
    [anon_sym_typedef] = ACTIONS(398),
    [anon_sym_function] = ACTIONS(398),
    [anon_sym_var] = ACTIONS(398),
    [aux_sym_integer_token1] = ACTIONS(398),
    [aux_sym_integer_token2] = ACTIONS(396),
    [aux_sym_float_token1] = ACTIONS(398),
    [aux_sym_float_token2] = ACTIONS(396),
    [anon_sym_true] = ACTIONS(398),
    [anon_sym_false] = ACTIONS(398),
    [aux_sym_string_token1] = ACTIONS(396),
    [aux_sym_string_token3] = ACTIONS(396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(398),
    [anon_sym_catch] = ACTIONS(398),
    [anon_sym_continue] = ACTIONS(398),
    [anon_sym_do] = ACTIONS(398),
    [anon_sym_enum] = ACTIONS(398),
    [anon_sym_extern] = ACTIONS(398),
    [anon_sym_for] = ACTIONS(398),
    [anon_sym_inline] = ACTIONS(398),
    [anon_sym_macro] = ACTIONS(398),
    [anon_sym_operator] = ACTIONS(398),
    [anon_sym_overload] = ACTIONS(398),
    [anon_sym_override] = ACTIONS(398),
    [anon_sym_private] = ACTIONS(398),
    [anon_sym_public] = ACTIONS(398),
    [anon_sym_return] = ACTIONS(398),
    [anon_sym_static] = ACTIONS(398),
    [anon_sym_try] = ACTIONS(398),
    [anon_sym_untyped] = ACTIONS(398),
    [anon_sym_while] = ACTIONS(398),
    [sym__semicolon] = ACTIONS(396),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_POUND] = ACTIONS(1486),
    [anon_sym_package] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_using] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_cast] = ACTIONS(1488),
    [anon_sym_DOLLARtype] = ACTIONS(1486),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_this] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_AT_COLON] = ACTIONS(1486),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PERCENT] = ACTIONS(1486),
    [anon_sym_STAR] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_LT_LT] = ACTIONS(1486),
    [anon_sym_GT_GT] = ACTIONS(1488),
    [anon_sym_GT_GT_GT] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1486),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_GT] = ACTIONS(1486),
    [anon_sym_QMARK_QMARK] = ACTIONS(1486),
    [anon_sym_EQ] = ACTIONS(1488),
    [sym__rangeOperator] = ACTIONS(1486),
    [anon_sym_null] = ACTIONS(1488),
    [anon_sym_dynamic] = ACTIONS(1488),
    [anon_sym_final] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_extends] = ACTIONS(1488),
    [anon_sym_implements] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_typedef] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [aux_sym_integer_token1] = ACTIONS(1488),
    [aux_sym_integer_token2] = ACTIONS(1486),
    [aux_sym_float_token1] = ACTIONS(1488),
    [aux_sym_float_token2] = ACTIONS(1486),
    [anon_sym_true] = ACTIONS(1488),
    [anon_sym_false] = ACTIONS(1488),
    [aux_sym_string_token1] = ACTIONS(1486),
    [aux_sym_string_token3] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_extern] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_inline] = ACTIONS(1488),
    [anon_sym_macro] = ACTIONS(1488),
    [anon_sym_operator] = ACTIONS(1488),
    [anon_sym_overload] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_untyped] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [sym__semicolon] = ACTIONS(1486),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_POUND] = ACTIONS(1490),
    [anon_sym_package] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_using] = ACTIONS(1492),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_cast] = ACTIONS(1492),
    [anon_sym_DOLLARtype] = ACTIONS(1490),
    [anon_sym_in] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_this] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1492),
    [anon_sym_AT_COLON] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PERCENT] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_SLASH] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_LT_LT] = ACTIONS(1490),
    [anon_sym_GT_GT] = ACTIONS(1492),
    [anon_sym_GT_GT_GT] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_AMP_AMP] = ACTIONS(1490),
    [anon_sym_PIPE_PIPE] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1490),
    [anon_sym_BANG_EQ] = ACTIONS(1490),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_LT_EQ] = ACTIONS(1490),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_GT_EQ] = ACTIONS(1490),
    [anon_sym_EQ_GT] = ACTIONS(1490),
    [anon_sym_QMARK_QMARK] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1492),
    [sym__rangeOperator] = ACTIONS(1490),
    [anon_sym_null] = ACTIONS(1492),
    [anon_sym_dynamic] = ACTIONS(1492),
    [anon_sym_final] = ACTIONS(1492),
    [anon_sym_abstract] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_extends] = ACTIONS(1492),
    [anon_sym_implements] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1492),
    [anon_sym_typedef] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1492),
    [aux_sym_integer_token1] = ACTIONS(1492),
    [aux_sym_integer_token2] = ACTIONS(1490),
    [aux_sym_float_token1] = ACTIONS(1492),
    [aux_sym_float_token2] = ACTIONS(1490),
    [anon_sym_true] = ACTIONS(1492),
    [anon_sym_false] = ACTIONS(1492),
    [aux_sym_string_token1] = ACTIONS(1490),
    [aux_sym_string_token3] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_extern] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_inline] = ACTIONS(1492),
    [anon_sym_macro] = ACTIONS(1492),
    [anon_sym_operator] = ACTIONS(1492),
    [anon_sym_overload] = ACTIONS(1492),
    [anon_sym_override] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym_public] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_untyped] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [sym__semicolon] = ACTIONS(1490),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_POUND] = ACTIONS(1494),
    [anon_sym_package] = ACTIONS(1496),
    [anon_sym_import] = ACTIONS(1496),
    [anon_sym_using] = ACTIONS(1496),
    [anon_sym_throw] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_cast] = ACTIONS(1496),
    [anon_sym_DOLLARtype] = ACTIONS(1494),
    [anon_sym_in] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_this] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_AT_COLON] = ACTIONS(1494),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_new] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PERCENT] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_LT_LT] = ACTIONS(1494),
    [anon_sym_GT_GT] = ACTIONS(1496),
    [anon_sym_GT_GT_GT] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_PIPE] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1494),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1496),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_GT] = ACTIONS(1496),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_GT] = ACTIONS(1494),
    [anon_sym_QMARK_QMARK] = ACTIONS(1494),
    [anon_sym_EQ] = ACTIONS(1496),
    [sym__rangeOperator] = ACTIONS(1494),
    [anon_sym_null] = ACTIONS(1496),
    [anon_sym_dynamic] = ACTIONS(1496),
    [anon_sym_final] = ACTIONS(1496),
    [anon_sym_abstract] = ACTIONS(1496),
    [anon_sym_class] = ACTIONS(1496),
    [anon_sym_extends] = ACTIONS(1496),
    [anon_sym_implements] = ACTIONS(1496),
    [anon_sym_interface] = ACTIONS(1496),
    [anon_sym_typedef] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(1496),
    [anon_sym_var] = ACTIONS(1496),
    [aux_sym_integer_token1] = ACTIONS(1496),
    [aux_sym_integer_token2] = ACTIONS(1494),
    [aux_sym_float_token1] = ACTIONS(1496),
    [aux_sym_float_token2] = ACTIONS(1494),
    [anon_sym_true] = ACTIONS(1496),
    [anon_sym_false] = ACTIONS(1496),
    [aux_sym_string_token1] = ACTIONS(1494),
    [aux_sym_string_token3] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_catch] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_extern] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_inline] = ACTIONS(1496),
    [anon_sym_macro] = ACTIONS(1496),
    [anon_sym_operator] = ACTIONS(1496),
    [anon_sym_overload] = ACTIONS(1496),
    [anon_sym_override] = ACTIONS(1496),
    [anon_sym_private] = ACTIONS(1496),
    [anon_sym_public] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_try] = ACTIONS(1496),
    [anon_sym_untyped] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [sym__semicolon] = ACTIONS(1494),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_identifier] = ACTIONS(1500),
    [anon_sym_POUND] = ACTIONS(1498),
    [anon_sym_package] = ACTIONS(1500),
    [anon_sym_import] = ACTIONS(1500),
    [anon_sym_using] = ACTIONS(1500),
    [anon_sym_throw] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1498),
    [anon_sym_switch] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [anon_sym_case] = ACTIONS(1500),
    [anon_sym_default] = ACTIONS(1500),
    [anon_sym_cast] = ACTIONS(1500),
    [anon_sym_DOLLARtype] = ACTIONS(1498),
    [anon_sym_in] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [anon_sym_this] = ACTIONS(1500),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_AT_COLON] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1500),
    [anon_sym_else] = ACTIONS(1500),
    [anon_sym_new] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PERCENT] = ACTIONS(1498),
    [anon_sym_STAR] = ACTIONS(1498),
    [anon_sym_SLASH] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1500),
    [anon_sym_GT_GT_GT] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_CARET] = ACTIONS(1498),
    [anon_sym_AMP_AMP] = ACTIONS(1498),
    [anon_sym_PIPE_PIPE] = ACTIONS(1498),
    [anon_sym_EQ_EQ] = ACTIONS(1498),
    [anon_sym_BANG_EQ] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_LT_EQ] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_EQ] = ACTIONS(1498),
    [anon_sym_EQ_GT] = ACTIONS(1498),
    [anon_sym_QMARK_QMARK] = ACTIONS(1498),
    [anon_sym_EQ] = ACTIONS(1500),
    [sym__rangeOperator] = ACTIONS(1498),
    [anon_sym_null] = ACTIONS(1500),
    [anon_sym_dynamic] = ACTIONS(1500),
    [anon_sym_final] = ACTIONS(1500),
    [anon_sym_abstract] = ACTIONS(1500),
    [anon_sym_class] = ACTIONS(1500),
    [anon_sym_extends] = ACTIONS(1500),
    [anon_sym_implements] = ACTIONS(1500),
    [anon_sym_interface] = ACTIONS(1500),
    [anon_sym_typedef] = ACTIONS(1500),
    [anon_sym_function] = ACTIONS(1500),
    [anon_sym_var] = ACTIONS(1500),
    [aux_sym_integer_token1] = ACTIONS(1500),
    [aux_sym_integer_token2] = ACTIONS(1498),
    [aux_sym_float_token1] = ACTIONS(1500),
    [aux_sym_float_token2] = ACTIONS(1498),
    [anon_sym_true] = ACTIONS(1500),
    [anon_sym_false] = ACTIONS(1500),
    [aux_sym_string_token1] = ACTIONS(1498),
    [aux_sym_string_token3] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1500),
    [anon_sym_catch] = ACTIONS(1500),
    [anon_sym_continue] = ACTIONS(1500),
    [anon_sym_do] = ACTIONS(1500),
    [anon_sym_enum] = ACTIONS(1500),
    [anon_sym_extern] = ACTIONS(1500),
    [anon_sym_for] = ACTIONS(1500),
    [anon_sym_inline] = ACTIONS(1500),
    [anon_sym_macro] = ACTIONS(1500),
    [anon_sym_operator] = ACTIONS(1500),
    [anon_sym_overload] = ACTIONS(1500),
    [anon_sym_override] = ACTIONS(1500),
    [anon_sym_private] = ACTIONS(1500),
    [anon_sym_public] = ACTIONS(1500),
    [anon_sym_return] = ACTIONS(1500),
    [anon_sym_static] = ACTIONS(1500),
    [anon_sym_try] = ACTIONS(1500),
    [anon_sym_untyped] = ACTIONS(1500),
    [anon_sym_while] = ACTIONS(1500),
    [sym__semicolon] = ACTIONS(1498),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_POUND] = ACTIONS(1502),
    [anon_sym_package] = ACTIONS(1504),
    [anon_sym_import] = ACTIONS(1504),
    [anon_sym_using] = ACTIONS(1504),
    [anon_sym_throw] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [anon_sym_switch] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [anon_sym_case] = ACTIONS(1504),
    [anon_sym_default] = ACTIONS(1504),
    [anon_sym_cast] = ACTIONS(1504),
    [anon_sym_DOLLARtype] = ACTIONS(1502),
    [anon_sym_in] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_this] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_AT_COLON] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_else] = ACTIONS(1504),
    [anon_sym_new] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PERCENT] = ACTIONS(1502),
    [anon_sym_STAR] = ACTIONS(1502),
    [anon_sym_SLASH] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_LT_LT] = ACTIONS(1502),
    [anon_sym_GT_GT] = ACTIONS(1504),
    [anon_sym_GT_GT_GT] = ACTIONS(1502),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_CARET] = ACTIONS(1502),
    [anon_sym_AMP_AMP] = ACTIONS(1502),
    [anon_sym_PIPE_PIPE] = ACTIONS(1502),
    [anon_sym_EQ_EQ] = ACTIONS(1502),
    [anon_sym_BANG_EQ] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_LT_EQ] = ACTIONS(1502),
    [anon_sym_GT] = ACTIONS(1504),
    [anon_sym_GT_EQ] = ACTIONS(1502),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_QMARK_QMARK] = ACTIONS(1502),
    [anon_sym_EQ] = ACTIONS(1504),
    [sym__rangeOperator] = ACTIONS(1502),
    [anon_sym_null] = ACTIONS(1504),
    [anon_sym_dynamic] = ACTIONS(1504),
    [anon_sym_final] = ACTIONS(1504),
    [anon_sym_abstract] = ACTIONS(1504),
    [anon_sym_class] = ACTIONS(1504),
    [anon_sym_extends] = ACTIONS(1504),
    [anon_sym_implements] = ACTIONS(1504),
    [anon_sym_interface] = ACTIONS(1504),
    [anon_sym_typedef] = ACTIONS(1504),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_var] = ACTIONS(1504),
    [aux_sym_integer_token1] = ACTIONS(1504),
    [aux_sym_integer_token2] = ACTIONS(1502),
    [aux_sym_float_token1] = ACTIONS(1504),
    [aux_sym_float_token2] = ACTIONS(1502),
    [anon_sym_true] = ACTIONS(1504),
    [anon_sym_false] = ACTIONS(1504),
    [aux_sym_string_token1] = ACTIONS(1502),
    [aux_sym_string_token3] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1504),
    [anon_sym_catch] = ACTIONS(1504),
    [anon_sym_continue] = ACTIONS(1504),
    [anon_sym_do] = ACTIONS(1504),
    [anon_sym_enum] = ACTIONS(1504),
    [anon_sym_extern] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_inline] = ACTIONS(1504),
    [anon_sym_macro] = ACTIONS(1504),
    [anon_sym_operator] = ACTIONS(1504),
    [anon_sym_overload] = ACTIONS(1504),
    [anon_sym_override] = ACTIONS(1504),
    [anon_sym_private] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1504),
    [anon_sym_return] = ACTIONS(1504),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_try] = ACTIONS(1504),
    [anon_sym_untyped] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [sym__semicolon] = ACTIONS(1502),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_POUND] = ACTIONS(1506),
    [anon_sym_package] = ACTIONS(1508),
    [anon_sym_import] = ACTIONS(1508),
    [anon_sym_using] = ACTIONS(1508),
    [anon_sym_throw] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [anon_sym_case] = ACTIONS(1508),
    [anon_sym_default] = ACTIONS(1508),
    [anon_sym_cast] = ACTIONS(1508),
    [anon_sym_DOLLARtype] = ACTIONS(1506),
    [anon_sym_in] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_this] = ACTIONS(1508),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_AT_COLON] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_else] = ACTIONS(1508),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [anon_sym_DASH_DASH] = ACTIONS(1506),
    [anon_sym_PERCENT] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_LT_LT] = ACTIONS(1506),
    [anon_sym_GT_GT] = ACTIONS(1508),
    [anon_sym_GT_GT_GT] = ACTIONS(1506),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_CARET] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1506),
    [anon_sym_PIPE_PIPE] = ACTIONS(1506),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_LT] = ACTIONS(1508),
    [anon_sym_LT_EQ] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_GT_EQ] = ACTIONS(1506),
    [anon_sym_EQ_GT] = ACTIONS(1506),
    [anon_sym_QMARK_QMARK] = ACTIONS(1506),
    [anon_sym_EQ] = ACTIONS(1508),
    [sym__rangeOperator] = ACTIONS(1506),
    [anon_sym_null] = ACTIONS(1508),
    [anon_sym_dynamic] = ACTIONS(1508),
    [anon_sym_final] = ACTIONS(1508),
    [anon_sym_abstract] = ACTIONS(1508),
    [anon_sym_class] = ACTIONS(1508),
    [anon_sym_extends] = ACTIONS(1508),
    [anon_sym_implements] = ACTIONS(1508),
    [anon_sym_interface] = ACTIONS(1508),
    [anon_sym_typedef] = ACTIONS(1508),
    [anon_sym_function] = ACTIONS(1508),
    [anon_sym_var] = ACTIONS(1508),
    [aux_sym_integer_token1] = ACTIONS(1508),
    [aux_sym_integer_token2] = ACTIONS(1506),
    [aux_sym_float_token1] = ACTIONS(1508),
    [aux_sym_float_token2] = ACTIONS(1506),
    [anon_sym_true] = ACTIONS(1508),
    [anon_sym_false] = ACTIONS(1508),
    [aux_sym_string_token1] = ACTIONS(1506),
    [aux_sym_string_token3] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1508),
    [anon_sym_catch] = ACTIONS(1508),
    [anon_sym_continue] = ACTIONS(1508),
    [anon_sym_do] = ACTIONS(1508),
    [anon_sym_enum] = ACTIONS(1508),
    [anon_sym_extern] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_inline] = ACTIONS(1508),
    [anon_sym_macro] = ACTIONS(1508),
    [anon_sym_operator] = ACTIONS(1508),
    [anon_sym_overload] = ACTIONS(1508),
    [anon_sym_override] = ACTIONS(1508),
    [anon_sym_private] = ACTIONS(1508),
    [anon_sym_public] = ACTIONS(1508),
    [anon_sym_return] = ACTIONS(1508),
    [anon_sym_static] = ACTIONS(1508),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_untyped] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [sym__semicolon] = ACTIONS(1506),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1512),
    [anon_sym_POUND] = ACTIONS(1510),
    [anon_sym_package] = ACTIONS(1512),
    [anon_sym_import] = ACTIONS(1512),
    [anon_sym_using] = ACTIONS(1512),
    [anon_sym_throw] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_switch] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_case] = ACTIONS(1512),
    [anon_sym_default] = ACTIONS(1512),
    [anon_sym_cast] = ACTIONS(1512),
    [anon_sym_DOLLARtype] = ACTIONS(1510),
    [anon_sym_in] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_this] = ACTIONS(1512),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_AT_COLON] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1512),
    [anon_sym_else] = ACTIONS(1512),
    [anon_sym_new] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1510),
    [anon_sym_SLASH] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_GT_GT] = ACTIONS(1512),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_GT] = ACTIONS(1510),
    [anon_sym_QMARK_QMARK] = ACTIONS(1510),
    [anon_sym_EQ] = ACTIONS(1512),
    [sym__rangeOperator] = ACTIONS(1510),
    [anon_sym_null] = ACTIONS(1512),
    [anon_sym_dynamic] = ACTIONS(1512),
    [anon_sym_final] = ACTIONS(1512),
    [anon_sym_abstract] = ACTIONS(1512),
    [anon_sym_class] = ACTIONS(1512),
    [anon_sym_extends] = ACTIONS(1512),
    [anon_sym_implements] = ACTIONS(1512),
    [anon_sym_interface] = ACTIONS(1512),
    [anon_sym_typedef] = ACTIONS(1512),
    [anon_sym_function] = ACTIONS(1512),
    [anon_sym_var] = ACTIONS(1512),
    [aux_sym_integer_token1] = ACTIONS(1512),
    [aux_sym_integer_token2] = ACTIONS(1510),
    [aux_sym_float_token1] = ACTIONS(1512),
    [aux_sym_float_token2] = ACTIONS(1510),
    [anon_sym_true] = ACTIONS(1512),
    [anon_sym_false] = ACTIONS(1512),
    [aux_sym_string_token1] = ACTIONS(1510),
    [aux_sym_string_token3] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1512),
    [anon_sym_catch] = ACTIONS(1512),
    [anon_sym_continue] = ACTIONS(1512),
    [anon_sym_do] = ACTIONS(1512),
    [anon_sym_enum] = ACTIONS(1512),
    [anon_sym_extern] = ACTIONS(1512),
    [anon_sym_for] = ACTIONS(1512),
    [anon_sym_inline] = ACTIONS(1512),
    [anon_sym_macro] = ACTIONS(1512),
    [anon_sym_operator] = ACTIONS(1512),
    [anon_sym_overload] = ACTIONS(1512),
    [anon_sym_override] = ACTIONS(1512),
    [anon_sym_private] = ACTIONS(1512),
    [anon_sym_public] = ACTIONS(1512),
    [anon_sym_return] = ACTIONS(1512),
    [anon_sym_static] = ACTIONS(1512),
    [anon_sym_try] = ACTIONS(1512),
    [anon_sym_untyped] = ACTIONS(1512),
    [anon_sym_while] = ACTIONS(1512),
    [sym__semicolon] = ACTIONS(1510),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_POUND] = ACTIONS(1514),
    [anon_sym_package] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_using] = ACTIONS(1516),
    [anon_sym_throw] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1516),
    [anon_sym_default] = ACTIONS(1516),
    [anon_sym_cast] = ACTIONS(1516),
    [anon_sym_DOLLARtype] = ACTIONS(1514),
    [anon_sym_in] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_this] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1516),
    [anon_sym_AT_COLON] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_else] = ACTIONS(1516),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_LT_LT] = ACTIONS(1514),
    [anon_sym_GT_GT] = ACTIONS(1516),
    [anon_sym_GT_GT_GT] = ACTIONS(1514),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_CARET] = ACTIONS(1514),
    [anon_sym_AMP_AMP] = ACTIONS(1514),
    [anon_sym_PIPE_PIPE] = ACTIONS(1514),
    [anon_sym_EQ_EQ] = ACTIONS(1514),
    [anon_sym_BANG_EQ] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_LT_EQ] = ACTIONS(1514),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_GT_EQ] = ACTIONS(1514),
    [anon_sym_EQ_GT] = ACTIONS(1514),
    [anon_sym_QMARK_QMARK] = ACTIONS(1514),
    [anon_sym_EQ] = ACTIONS(1516),
    [sym__rangeOperator] = ACTIONS(1514),
    [anon_sym_null] = ACTIONS(1516),
    [anon_sym_dynamic] = ACTIONS(1516),
    [anon_sym_final] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_extends] = ACTIONS(1516),
    [anon_sym_implements] = ACTIONS(1516),
    [anon_sym_interface] = ACTIONS(1516),
    [anon_sym_typedef] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(1516),
    [anon_sym_var] = ACTIONS(1516),
    [aux_sym_integer_token1] = ACTIONS(1516),
    [aux_sym_integer_token2] = ACTIONS(1514),
    [aux_sym_float_token1] = ACTIONS(1516),
    [aux_sym_float_token2] = ACTIONS(1514),
    [anon_sym_true] = ACTIONS(1516),
    [anon_sym_false] = ACTIONS(1516),
    [aux_sym_string_token1] = ACTIONS(1514),
    [aux_sym_string_token3] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_catch] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1516),
    [anon_sym_enum] = ACTIONS(1516),
    [anon_sym_extern] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_inline] = ACTIONS(1516),
    [anon_sym_macro] = ACTIONS(1516),
    [anon_sym_operator] = ACTIONS(1516),
    [anon_sym_overload] = ACTIONS(1516),
    [anon_sym_override] = ACTIONS(1516),
    [anon_sym_private] = ACTIONS(1516),
    [anon_sym_public] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_untyped] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1516),
    [sym__semicolon] = ACTIONS(1514),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_POUND] = ACTIONS(1518),
    [anon_sym_package] = ACTIONS(1520),
    [anon_sym_import] = ACTIONS(1520),
    [anon_sym_using] = ACTIONS(1520),
    [anon_sym_throw] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_switch] = ACTIONS(1520),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1520),
    [anon_sym_default] = ACTIONS(1520),
    [anon_sym_cast] = ACTIONS(1520),
    [anon_sym_DOLLARtype] = ACTIONS(1518),
    [anon_sym_in] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_this] = ACTIONS(1520),
    [anon_sym_AT] = ACTIONS(1520),
    [anon_sym_AT_COLON] = ACTIONS(1518),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_else] = ACTIONS(1520),
    [anon_sym_new] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_PERCENT] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1518),
    [anon_sym_GT_GT] = ACTIONS(1520),
    [anon_sym_GT_GT_GT] = ACTIONS(1518),
    [anon_sym_AMP] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1520),
    [anon_sym_CARET] = ACTIONS(1518),
    [anon_sym_AMP_AMP] = ACTIONS(1518),
    [anon_sym_PIPE_PIPE] = ACTIONS(1518),
    [anon_sym_EQ_EQ] = ACTIONS(1518),
    [anon_sym_BANG_EQ] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1520),
    [anon_sym_LT_EQ] = ACTIONS(1518),
    [anon_sym_GT] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1518),
    [anon_sym_EQ_GT] = ACTIONS(1518),
    [anon_sym_QMARK_QMARK] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(1520),
    [sym__rangeOperator] = ACTIONS(1518),
    [anon_sym_null] = ACTIONS(1520),
    [anon_sym_dynamic] = ACTIONS(1520),
    [anon_sym_final] = ACTIONS(1520),
    [anon_sym_abstract] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1520),
    [anon_sym_extends] = ACTIONS(1520),
    [anon_sym_implements] = ACTIONS(1520),
    [anon_sym_interface] = ACTIONS(1520),
    [anon_sym_typedef] = ACTIONS(1520),
    [anon_sym_function] = ACTIONS(1520),
    [anon_sym_var] = ACTIONS(1520),
    [aux_sym_integer_token1] = ACTIONS(1520),
    [aux_sym_integer_token2] = ACTIONS(1518),
    [aux_sym_float_token1] = ACTIONS(1520),
    [aux_sym_float_token2] = ACTIONS(1518),
    [anon_sym_true] = ACTIONS(1520),
    [anon_sym_false] = ACTIONS(1520),
    [aux_sym_string_token1] = ACTIONS(1518),
    [aux_sym_string_token3] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1520),
    [anon_sym_catch] = ACTIONS(1520),
    [anon_sym_continue] = ACTIONS(1520),
    [anon_sym_do] = ACTIONS(1520),
    [anon_sym_enum] = ACTIONS(1520),
    [anon_sym_extern] = ACTIONS(1520),
    [anon_sym_for] = ACTIONS(1520),
    [anon_sym_inline] = ACTIONS(1520),
    [anon_sym_macro] = ACTIONS(1520),
    [anon_sym_operator] = ACTIONS(1520),
    [anon_sym_overload] = ACTIONS(1520),
    [anon_sym_override] = ACTIONS(1520),
    [anon_sym_private] = ACTIONS(1520),
    [anon_sym_public] = ACTIONS(1520),
    [anon_sym_return] = ACTIONS(1520),
    [anon_sym_static] = ACTIONS(1520),
    [anon_sym_try] = ACTIONS(1520),
    [anon_sym_untyped] = ACTIONS(1520),
    [anon_sym_while] = ACTIONS(1520),
    [sym__semicolon] = ACTIONS(1518),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_POUND] = ACTIONS(1522),
    [anon_sym_package] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_using] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_cast] = ACTIONS(1524),
    [anon_sym_DOLLARtype] = ACTIONS(1522),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_this] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_AT_COLON] = ACTIONS(1522),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_LT_LT] = ACTIONS(1522),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1522),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_EQ_EQ] = ACTIONS(1522),
    [anon_sym_BANG_EQ] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_LT_EQ] = ACTIONS(1522),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_GT_EQ] = ACTIONS(1522),
    [anon_sym_EQ_GT] = ACTIONS(1522),
    [anon_sym_QMARK_QMARK] = ACTIONS(1522),
    [anon_sym_EQ] = ACTIONS(1524),
    [sym__rangeOperator] = ACTIONS(1522),
    [anon_sym_null] = ACTIONS(1524),
    [anon_sym_dynamic] = ACTIONS(1524),
    [anon_sym_final] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_extends] = ACTIONS(1524),
    [anon_sym_implements] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_typedef] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [aux_sym_integer_token1] = ACTIONS(1524),
    [aux_sym_integer_token2] = ACTIONS(1522),
    [aux_sym_float_token1] = ACTIONS(1524),
    [aux_sym_float_token2] = ACTIONS(1522),
    [anon_sym_true] = ACTIONS(1524),
    [anon_sym_false] = ACTIONS(1524),
    [aux_sym_string_token1] = ACTIONS(1522),
    [aux_sym_string_token3] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_catch] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_extern] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_inline] = ACTIONS(1524),
    [anon_sym_macro] = ACTIONS(1524),
    [anon_sym_operator] = ACTIONS(1524),
    [anon_sym_overload] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_untyped] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [sym__semicolon] = ACTIONS(1522),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(1526),
    [sym_identifier] = ACTIONS(1528),
    [anon_sym_POUND] = ACTIONS(1526),
    [anon_sym_package] = ACTIONS(1528),
    [anon_sym_import] = ACTIONS(1528),
    [anon_sym_using] = ACTIONS(1528),
    [anon_sym_throw] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_switch] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1528),
    [anon_sym_default] = ACTIONS(1528),
    [anon_sym_cast] = ACTIONS(1528),
    [anon_sym_DOLLARtype] = ACTIONS(1526),
    [anon_sym_in] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_this] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_AT_COLON] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1528),
    [anon_sym_else] = ACTIONS(1528),
    [anon_sym_new] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_PERCENT] = ACTIONS(1526),
    [anon_sym_STAR] = ACTIONS(1526),
    [anon_sym_SLASH] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_LT_LT] = ACTIONS(1526),
    [anon_sym_GT_GT] = ACTIONS(1528),
    [anon_sym_GT_GT_GT] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1528),
    [anon_sym_PIPE] = ACTIONS(1528),
    [anon_sym_CARET] = ACTIONS(1526),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE_PIPE] = ACTIONS(1526),
    [anon_sym_EQ_EQ] = ACTIONS(1526),
    [anon_sym_BANG_EQ] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1528),
    [anon_sym_LT_EQ] = ACTIONS(1526),
    [anon_sym_GT] = ACTIONS(1528),
    [anon_sym_GT_EQ] = ACTIONS(1526),
    [anon_sym_EQ_GT] = ACTIONS(1526),
    [anon_sym_QMARK_QMARK] = ACTIONS(1526),
    [anon_sym_EQ] = ACTIONS(1528),
    [sym__rangeOperator] = ACTIONS(1526),
    [anon_sym_null] = ACTIONS(1528),
    [anon_sym_dynamic] = ACTIONS(1528),
    [anon_sym_final] = ACTIONS(1528),
    [anon_sym_abstract] = ACTIONS(1528),
    [anon_sym_class] = ACTIONS(1528),
    [anon_sym_extends] = ACTIONS(1528),
    [anon_sym_implements] = ACTIONS(1528),
    [anon_sym_interface] = ACTIONS(1528),
    [anon_sym_typedef] = ACTIONS(1528),
    [anon_sym_function] = ACTIONS(1528),
    [anon_sym_var] = ACTIONS(1528),
    [aux_sym_integer_token1] = ACTIONS(1528),
    [aux_sym_integer_token2] = ACTIONS(1526),
    [aux_sym_float_token1] = ACTIONS(1528),
    [aux_sym_float_token2] = ACTIONS(1526),
    [anon_sym_true] = ACTIONS(1528),
    [anon_sym_false] = ACTIONS(1528),
    [aux_sym_string_token1] = ACTIONS(1526),
    [aux_sym_string_token3] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1528),
    [anon_sym_catch] = ACTIONS(1528),
    [anon_sym_continue] = ACTIONS(1528),
    [anon_sym_do] = ACTIONS(1528),
    [anon_sym_enum] = ACTIONS(1528),
    [anon_sym_extern] = ACTIONS(1528),
    [anon_sym_for] = ACTIONS(1528),
    [anon_sym_inline] = ACTIONS(1528),
    [anon_sym_macro] = ACTIONS(1528),
    [anon_sym_operator] = ACTIONS(1528),
    [anon_sym_overload] = ACTIONS(1528),
    [anon_sym_override] = ACTIONS(1528),
    [anon_sym_private] = ACTIONS(1528),
    [anon_sym_public] = ACTIONS(1528),
    [anon_sym_return] = ACTIONS(1528),
    [anon_sym_static] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1528),
    [anon_sym_untyped] = ACTIONS(1528),
    [anon_sym_while] = ACTIONS(1528),
    [sym__semicolon] = ACTIONS(1526),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_POUND] = ACTIONS(1530),
    [anon_sym_package] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1532),
    [anon_sym_using] = ACTIONS(1532),
    [anon_sym_throw] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1532),
    [anon_sym_default] = ACTIONS(1532),
    [anon_sym_cast] = ACTIONS(1532),
    [anon_sym_DOLLARtype] = ACTIONS(1530),
    [anon_sym_in] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_this] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_AT_COLON] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_new] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_PERCENT] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_LT_LT] = ACTIONS(1530),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_GT_GT_GT] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_CARET] = ACTIONS(1530),
    [anon_sym_AMP_AMP] = ACTIONS(1530),
    [anon_sym_PIPE_PIPE] = ACTIONS(1530),
    [anon_sym_EQ_EQ] = ACTIONS(1530),
    [anon_sym_BANG_EQ] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_LT_EQ] = ACTIONS(1530),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_GT_EQ] = ACTIONS(1530),
    [anon_sym_EQ_GT] = ACTIONS(1530),
    [anon_sym_QMARK_QMARK] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(1532),
    [sym__rangeOperator] = ACTIONS(1530),
    [anon_sym_null] = ACTIONS(1532),
    [anon_sym_dynamic] = ACTIONS(1532),
    [anon_sym_final] = ACTIONS(1532),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1532),
    [anon_sym_extends] = ACTIONS(1532),
    [anon_sym_implements] = ACTIONS(1532),
    [anon_sym_interface] = ACTIONS(1532),
    [anon_sym_typedef] = ACTIONS(1532),
    [anon_sym_function] = ACTIONS(1532),
    [anon_sym_var] = ACTIONS(1532),
    [aux_sym_integer_token1] = ACTIONS(1532),
    [aux_sym_integer_token2] = ACTIONS(1530),
    [aux_sym_float_token1] = ACTIONS(1532),
    [aux_sym_float_token2] = ACTIONS(1530),
    [anon_sym_true] = ACTIONS(1532),
    [anon_sym_false] = ACTIONS(1532),
    [aux_sym_string_token1] = ACTIONS(1530),
    [aux_sym_string_token3] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1532),
    [anon_sym_catch] = ACTIONS(1532),
    [anon_sym_continue] = ACTIONS(1532),
    [anon_sym_do] = ACTIONS(1532),
    [anon_sym_enum] = ACTIONS(1532),
    [anon_sym_extern] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_inline] = ACTIONS(1532),
    [anon_sym_macro] = ACTIONS(1532),
    [anon_sym_operator] = ACTIONS(1532),
    [anon_sym_overload] = ACTIONS(1532),
    [anon_sym_override] = ACTIONS(1532),
    [anon_sym_private] = ACTIONS(1532),
    [anon_sym_public] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1532),
    [anon_sym_static] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1532),
    [anon_sym_untyped] = ACTIONS(1532),
    [anon_sym_while] = ACTIONS(1532),
    [sym__semicolon] = ACTIONS(1530),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(1534),
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_POUND] = ACTIONS(1534),
    [anon_sym_package] = ACTIONS(1536),
    [anon_sym_import] = ACTIONS(1536),
    [anon_sym_using] = ACTIONS(1536),
    [anon_sym_throw] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_switch] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_case] = ACTIONS(1536),
    [anon_sym_default] = ACTIONS(1536),
    [anon_sym_cast] = ACTIONS(1536),
    [anon_sym_DOLLARtype] = ACTIONS(1534),
    [anon_sym_in] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_this] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(1536),
    [anon_sym_AT_COLON] = ACTIONS(1534),
    [anon_sym_if] = ACTIONS(1536),
    [anon_sym_else] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_PERCENT] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1534),
    [anon_sym_GT_GT] = ACTIONS(1536),
    [anon_sym_GT_GT_GT] = ACTIONS(1534),
    [anon_sym_AMP] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1536),
    [anon_sym_CARET] = ACTIONS(1534),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_EQ_GT] = ACTIONS(1534),
    [anon_sym_QMARK_QMARK] = ACTIONS(1534),
    [anon_sym_EQ] = ACTIONS(1536),
    [sym__rangeOperator] = ACTIONS(1534),
    [anon_sym_null] = ACTIONS(1536),
    [anon_sym_dynamic] = ACTIONS(1536),
    [anon_sym_final] = ACTIONS(1536),
    [anon_sym_abstract] = ACTIONS(1536),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_extends] = ACTIONS(1536),
    [anon_sym_implements] = ACTIONS(1536),
    [anon_sym_interface] = ACTIONS(1536),
    [anon_sym_typedef] = ACTIONS(1536),
    [anon_sym_function] = ACTIONS(1536),
    [anon_sym_var] = ACTIONS(1536),
    [aux_sym_integer_token1] = ACTIONS(1536),
    [aux_sym_integer_token2] = ACTIONS(1534),
    [aux_sym_float_token1] = ACTIONS(1536),
    [aux_sym_float_token2] = ACTIONS(1534),
    [anon_sym_true] = ACTIONS(1536),
    [anon_sym_false] = ACTIONS(1536),
    [aux_sym_string_token1] = ACTIONS(1534),
    [aux_sym_string_token3] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_catch] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1536),
    [anon_sym_do] = ACTIONS(1536),
    [anon_sym_enum] = ACTIONS(1536),
    [anon_sym_extern] = ACTIONS(1536),
    [anon_sym_for] = ACTIONS(1536),
    [anon_sym_inline] = ACTIONS(1536),
    [anon_sym_macro] = ACTIONS(1536),
    [anon_sym_operator] = ACTIONS(1536),
    [anon_sym_overload] = ACTIONS(1536),
    [anon_sym_override] = ACTIONS(1536),
    [anon_sym_private] = ACTIONS(1536),
    [anon_sym_public] = ACTIONS(1536),
    [anon_sym_return] = ACTIONS(1536),
    [anon_sym_static] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(1536),
    [anon_sym_untyped] = ACTIONS(1536),
    [anon_sym_while] = ACTIONS(1536),
    [sym__semicolon] = ACTIONS(1534),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(1538),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_POUND] = ACTIONS(1538),
    [anon_sym_package] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_using] = ACTIONS(1540),
    [anon_sym_throw] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_switch] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_case] = ACTIONS(1540),
    [anon_sym_default] = ACTIONS(1540),
    [anon_sym_cast] = ACTIONS(1540),
    [anon_sym_DOLLARtype] = ACTIONS(1538),
    [anon_sym_in] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_this] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_AT_COLON] = ACTIONS(1538),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_else] = ACTIONS(1540),
    [anon_sym_new] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1538),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1538),
    [anon_sym_DASH_DASH] = ACTIONS(1538),
    [anon_sym_PERCENT] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1538),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1538),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_GT_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_EQ_EQ] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_LT_EQ] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_EQ] = ACTIONS(1538),
    [anon_sym_EQ_GT] = ACTIONS(1538),
    [anon_sym_QMARK_QMARK] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(1540),
    [sym__rangeOperator] = ACTIONS(1538),
    [anon_sym_null] = ACTIONS(1540),
    [anon_sym_dynamic] = ACTIONS(1540),
    [anon_sym_final] = ACTIONS(1540),
    [anon_sym_abstract] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_extends] = ACTIONS(1540),
    [anon_sym_implements] = ACTIONS(1540),
    [anon_sym_interface] = ACTIONS(1540),
    [anon_sym_typedef] = ACTIONS(1540),
    [anon_sym_function] = ACTIONS(1540),
    [anon_sym_var] = ACTIONS(1540),
    [aux_sym_integer_token1] = ACTIONS(1540),
    [aux_sym_integer_token2] = ACTIONS(1538),
    [aux_sym_float_token1] = ACTIONS(1540),
    [aux_sym_float_token2] = ACTIONS(1538),
    [anon_sym_true] = ACTIONS(1540),
    [anon_sym_false] = ACTIONS(1540),
    [aux_sym_string_token1] = ACTIONS(1538),
    [aux_sym_string_token3] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_catch] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_do] = ACTIONS(1540),
    [anon_sym_enum] = ACTIONS(1540),
    [anon_sym_extern] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_inline] = ACTIONS(1540),
    [anon_sym_macro] = ACTIONS(1540),
    [anon_sym_operator] = ACTIONS(1540),
    [anon_sym_overload] = ACTIONS(1540),
    [anon_sym_override] = ACTIONS(1540),
    [anon_sym_private] = ACTIONS(1540),
    [anon_sym_public] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_static] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_untyped] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [sym__semicolon] = ACTIONS(1538),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [sym_identifier] = ACTIONS(948),
    [anon_sym_POUND] = ACTIONS(946),
    [anon_sym_package] = ACTIONS(948),
    [anon_sym_import] = ACTIONS(948),
    [anon_sym_using] = ACTIONS(948),
    [anon_sym_throw] = ACTIONS(948),
    [anon_sym_LPAREN] = ACTIONS(946),
    [anon_sym_switch] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_case] = ACTIONS(948),
    [anon_sym_default] = ACTIONS(948),
    [anon_sym_cast] = ACTIONS(948),
    [anon_sym_DOLLARtype] = ACTIONS(946),
    [anon_sym_in] = ACTIONS(948),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_this] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(948),
    [anon_sym_AT_COLON] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(948),
    [anon_sym_else] = ACTIONS(948),
    [anon_sym_new] = ACTIONS(948),
    [anon_sym_TILDE] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(948),
    [anon_sym_DASH] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(946),
    [anon_sym_DASH_DASH] = ACTIONS(946),
    [anon_sym_PERCENT] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(948),
    [anon_sym_LT_LT] = ACTIONS(946),
    [anon_sym_GT_GT] = ACTIONS(948),
    [anon_sym_GT_GT_GT] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(948),
    [anon_sym_CARET] = ACTIONS(946),
    [anon_sym_AMP_AMP] = ACTIONS(946),
    [anon_sym_PIPE_PIPE] = ACTIONS(946),
    [anon_sym_EQ_EQ] = ACTIONS(946),
    [anon_sym_BANG_EQ] = ACTIONS(946),
    [anon_sym_LT] = ACTIONS(948),
    [anon_sym_LT_EQ] = ACTIONS(946),
    [anon_sym_GT] = ACTIONS(948),
    [anon_sym_GT_EQ] = ACTIONS(946),
    [anon_sym_EQ_GT] = ACTIONS(946),
    [anon_sym_QMARK_QMARK] = ACTIONS(946),
    [anon_sym_EQ] = ACTIONS(948),
    [sym__rangeOperator] = ACTIONS(946),
    [anon_sym_null] = ACTIONS(948),
    [anon_sym_dynamic] = ACTIONS(948),
    [anon_sym_final] = ACTIONS(948),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_class] = ACTIONS(948),
    [anon_sym_extends] = ACTIONS(948),
    [anon_sym_implements] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(948),
    [anon_sym_typedef] = ACTIONS(948),
    [anon_sym_function] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(948),
    [aux_sym_integer_token1] = ACTIONS(948),
    [aux_sym_integer_token2] = ACTIONS(946),
    [aux_sym_float_token1] = ACTIONS(948),
    [aux_sym_float_token2] = ACTIONS(946),
    [anon_sym_true] = ACTIONS(948),
    [anon_sym_false] = ACTIONS(948),
    [aux_sym_string_token1] = ACTIONS(946),
    [aux_sym_string_token3] = ACTIONS(946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(948),
    [anon_sym_catch] = ACTIONS(948),
    [anon_sym_continue] = ACTIONS(948),
    [anon_sym_do] = ACTIONS(948),
    [anon_sym_enum] = ACTIONS(948),
    [anon_sym_extern] = ACTIONS(948),
    [anon_sym_for] = ACTIONS(948),
    [anon_sym_inline] = ACTIONS(948),
    [anon_sym_macro] = ACTIONS(948),
    [anon_sym_operator] = ACTIONS(948),
    [anon_sym_overload] = ACTIONS(948),
    [anon_sym_override] = ACTIONS(948),
    [anon_sym_private] = ACTIONS(948),
    [anon_sym_public] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(948),
    [anon_sym_static] = ACTIONS(948),
    [anon_sym_try] = ACTIONS(948),
    [anon_sym_untyped] = ACTIONS(948),
    [anon_sym_while] = ACTIONS(948),
    [sym__semicolon] = ACTIONS(946),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_POUND] = ACTIONS(1542),
    [anon_sym_package] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_using] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_cast] = ACTIONS(1544),
    [anon_sym_DOLLARtype] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_this] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_AT_COLON] = ACTIONS(1542),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_STAR] = ACTIONS(1542),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_EQ_GT] = ACTIONS(1542),
    [anon_sym_QMARK_QMARK] = ACTIONS(1542),
    [anon_sym_EQ] = ACTIONS(1544),
    [sym__rangeOperator] = ACTIONS(1542),
    [anon_sym_null] = ACTIONS(1544),
    [anon_sym_dynamic] = ACTIONS(1544),
    [anon_sym_final] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_extends] = ACTIONS(1544),
    [anon_sym_implements] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_typedef] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [aux_sym_integer_token1] = ACTIONS(1544),
    [aux_sym_integer_token2] = ACTIONS(1542),
    [aux_sym_float_token1] = ACTIONS(1544),
    [aux_sym_float_token2] = ACTIONS(1542),
    [anon_sym_true] = ACTIONS(1544),
    [anon_sym_false] = ACTIONS(1544),
    [aux_sym_string_token1] = ACTIONS(1542),
    [aux_sym_string_token3] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_catch] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
    [anon_sym_extern] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_inline] = ACTIONS(1544),
    [anon_sym_macro] = ACTIONS(1544),
    [anon_sym_operator] = ACTIONS(1544),
    [anon_sym_overload] = ACTIONS(1544),
    [anon_sym_override] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_untyped] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1544),
    [sym__semicolon] = ACTIONS(1542),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(1546),
    [sym_identifier] = ACTIONS(1548),
    [anon_sym_POUND] = ACTIONS(1546),
    [anon_sym_package] = ACTIONS(1548),
    [anon_sym_import] = ACTIONS(1548),
    [anon_sym_using] = ACTIONS(1548),
    [anon_sym_throw] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [anon_sym_switch] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [anon_sym_case] = ACTIONS(1548),
    [anon_sym_default] = ACTIONS(1548),
    [anon_sym_cast] = ACTIONS(1548),
    [anon_sym_DOLLARtype] = ACTIONS(1546),
    [anon_sym_in] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_this] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_AT_COLON] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1548),
    [anon_sym_else] = ACTIONS(1548),
    [anon_sym_new] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_PLUS_PLUS] = ACTIONS(1546),
    [anon_sym_DASH_DASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1548),
    [anon_sym_GT_GT_GT] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1548),
    [anon_sym_PIPE] = ACTIONS(1548),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1546),
    [anon_sym_BANG_EQ] = ACTIONS(1546),
    [anon_sym_LT] = ACTIONS(1548),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_GT] = ACTIONS(1548),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_EQ_GT] = ACTIONS(1546),
    [anon_sym_QMARK_QMARK] = ACTIONS(1546),
    [anon_sym_EQ] = ACTIONS(1548),
    [sym__rangeOperator] = ACTIONS(1546),
    [anon_sym_null] = ACTIONS(1548),
    [anon_sym_dynamic] = ACTIONS(1548),
    [anon_sym_final] = ACTIONS(1548),
    [anon_sym_abstract] = ACTIONS(1548),
    [anon_sym_class] = ACTIONS(1548),
    [anon_sym_extends] = ACTIONS(1548),
    [anon_sym_implements] = ACTIONS(1548),
    [anon_sym_interface] = ACTIONS(1548),
    [anon_sym_typedef] = ACTIONS(1548),
    [anon_sym_function] = ACTIONS(1548),
    [anon_sym_var] = ACTIONS(1548),
    [aux_sym_integer_token1] = ACTIONS(1548),
    [aux_sym_integer_token2] = ACTIONS(1546),
    [aux_sym_float_token1] = ACTIONS(1548),
    [aux_sym_float_token2] = ACTIONS(1546),
    [anon_sym_true] = ACTIONS(1548),
    [anon_sym_false] = ACTIONS(1548),
    [aux_sym_string_token1] = ACTIONS(1546),
    [aux_sym_string_token3] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1548),
    [anon_sym_catch] = ACTIONS(1548),
    [anon_sym_continue] = ACTIONS(1548),
    [anon_sym_do] = ACTIONS(1548),
    [anon_sym_enum] = ACTIONS(1548),
    [anon_sym_extern] = ACTIONS(1548),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_inline] = ACTIONS(1548),
    [anon_sym_macro] = ACTIONS(1548),
    [anon_sym_operator] = ACTIONS(1548),
    [anon_sym_overload] = ACTIONS(1548),
    [anon_sym_override] = ACTIONS(1548),
    [anon_sym_private] = ACTIONS(1548),
    [anon_sym_public] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1548),
    [anon_sym_static] = ACTIONS(1548),
    [anon_sym_try] = ACTIONS(1548),
    [anon_sym_untyped] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1548),
    [sym__semicolon] = ACTIONS(1546),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(1550),
    [sym_identifier] = ACTIONS(1552),
    [anon_sym_POUND] = ACTIONS(1550),
    [anon_sym_package] = ACTIONS(1552),
    [anon_sym_import] = ACTIONS(1552),
    [anon_sym_using] = ACTIONS(1552),
    [anon_sym_throw] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [anon_sym_switch] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_case] = ACTIONS(1552),
    [anon_sym_default] = ACTIONS(1552),
    [anon_sym_cast] = ACTIONS(1552),
    [anon_sym_DOLLARtype] = ACTIONS(1550),
    [anon_sym_in] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_this] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(1552),
    [anon_sym_AT_COLON] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1552),
    [anon_sym_else] = ACTIONS(1552),
    [anon_sym_new] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_STAR] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1552),
    [anon_sym_GT_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BANG_EQ] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_EQ_GT] = ACTIONS(1550),
    [anon_sym_QMARK_QMARK] = ACTIONS(1550),
    [anon_sym_EQ] = ACTIONS(1552),
    [sym__rangeOperator] = ACTIONS(1550),
    [anon_sym_null] = ACTIONS(1552),
    [anon_sym_dynamic] = ACTIONS(1552),
    [anon_sym_final] = ACTIONS(1552),
    [anon_sym_abstract] = ACTIONS(1552),
    [anon_sym_class] = ACTIONS(1552),
    [anon_sym_extends] = ACTIONS(1552),
    [anon_sym_implements] = ACTIONS(1552),
    [anon_sym_interface] = ACTIONS(1552),
    [anon_sym_typedef] = ACTIONS(1552),
    [anon_sym_function] = ACTIONS(1552),
    [anon_sym_var] = ACTIONS(1552),
    [aux_sym_integer_token1] = ACTIONS(1552),
    [aux_sym_integer_token2] = ACTIONS(1550),
    [aux_sym_float_token1] = ACTIONS(1552),
    [aux_sym_float_token2] = ACTIONS(1550),
    [anon_sym_true] = ACTIONS(1552),
    [anon_sym_false] = ACTIONS(1552),
    [aux_sym_string_token1] = ACTIONS(1550),
    [aux_sym_string_token3] = ACTIONS(1550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1552),
    [anon_sym_catch] = ACTIONS(1552),
    [anon_sym_continue] = ACTIONS(1552),
    [anon_sym_do] = ACTIONS(1552),
    [anon_sym_enum] = ACTIONS(1552),
    [anon_sym_extern] = ACTIONS(1552),
    [anon_sym_for] = ACTIONS(1552),
    [anon_sym_inline] = ACTIONS(1552),
    [anon_sym_macro] = ACTIONS(1552),
    [anon_sym_operator] = ACTIONS(1552),
    [anon_sym_overload] = ACTIONS(1552),
    [anon_sym_override] = ACTIONS(1552),
    [anon_sym_private] = ACTIONS(1552),
    [anon_sym_public] = ACTIONS(1552),
    [anon_sym_return] = ACTIONS(1552),
    [anon_sym_static] = ACTIONS(1552),
    [anon_sym_try] = ACTIONS(1552),
    [anon_sym_untyped] = ACTIONS(1552),
    [anon_sym_while] = ACTIONS(1552),
    [sym__semicolon] = ACTIONS(1550),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_POUND] = ACTIONS(1554),
    [anon_sym_package] = ACTIONS(1556),
    [anon_sym_import] = ACTIONS(1556),
    [anon_sym_using] = ACTIONS(1556),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_switch] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [anon_sym_case] = ACTIONS(1556),
    [anon_sym_default] = ACTIONS(1556),
    [anon_sym_cast] = ACTIONS(1556),
    [anon_sym_DOLLARtype] = ACTIONS(1554),
    [anon_sym_in] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_this] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_AT_COLON] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1554),
    [anon_sym_DASH_DASH] = ACTIONS(1554),
    [anon_sym_PERCENT] = ACTIONS(1554),
    [anon_sym_STAR] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_LT_LT] = ACTIONS(1554),
    [anon_sym_GT_GT] = ACTIONS(1556),
    [anon_sym_GT_GT_GT] = ACTIONS(1554),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_CARET] = ACTIONS(1554),
    [anon_sym_AMP_AMP] = ACTIONS(1554),
    [anon_sym_PIPE_PIPE] = ACTIONS(1554),
    [anon_sym_EQ_EQ] = ACTIONS(1554),
    [anon_sym_BANG_EQ] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_LT_EQ] = ACTIONS(1554),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_GT_EQ] = ACTIONS(1554),
    [anon_sym_EQ_GT] = ACTIONS(1554),
    [anon_sym_QMARK_QMARK] = ACTIONS(1554),
    [anon_sym_EQ] = ACTIONS(1556),
    [sym__rangeOperator] = ACTIONS(1554),
    [anon_sym_null] = ACTIONS(1556),
    [anon_sym_dynamic] = ACTIONS(1556),
    [anon_sym_final] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1556),
    [anon_sym_extends] = ACTIONS(1556),
    [anon_sym_implements] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1556),
    [anon_sym_typedef] = ACTIONS(1556),
    [anon_sym_function] = ACTIONS(1556),
    [anon_sym_var] = ACTIONS(1556),
    [aux_sym_integer_token1] = ACTIONS(1556),
    [aux_sym_integer_token2] = ACTIONS(1554),
    [aux_sym_float_token1] = ACTIONS(1556),
    [aux_sym_float_token2] = ACTIONS(1554),
    [anon_sym_true] = ACTIONS(1556),
    [anon_sym_false] = ACTIONS(1556),
    [aux_sym_string_token1] = ACTIONS(1554),
    [aux_sym_string_token3] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1556),
    [anon_sym_catch] = ACTIONS(1556),
    [anon_sym_continue] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1556),
    [anon_sym_enum] = ACTIONS(1556),
    [anon_sym_extern] = ACTIONS(1556),
    [anon_sym_for] = ACTIONS(1556),
    [anon_sym_inline] = ACTIONS(1556),
    [anon_sym_macro] = ACTIONS(1556),
    [anon_sym_operator] = ACTIONS(1556),
    [anon_sym_overload] = ACTIONS(1556),
    [anon_sym_override] = ACTIONS(1556),
    [anon_sym_private] = ACTIONS(1556),
    [anon_sym_public] = ACTIONS(1556),
    [anon_sym_return] = ACTIONS(1556),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_untyped] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1556),
    [sym__semicolon] = ACTIONS(1554),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_POUND] = ACTIONS(1558),
    [anon_sym_package] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_using] = ACTIONS(1560),
    [anon_sym_throw] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1560),
    [anon_sym_default] = ACTIONS(1560),
    [anon_sym_cast] = ACTIONS(1560),
    [anon_sym_DOLLARtype] = ACTIONS(1558),
    [anon_sym_in] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_this] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_AT_COLON] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1560),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_PERCENT] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_LT_LT] = ACTIONS(1558),
    [anon_sym_GT_GT] = ACTIONS(1560),
    [anon_sym_GT_GT_GT] = ACTIONS(1558),
    [anon_sym_AMP] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1560),
    [anon_sym_CARET] = ACTIONS(1558),
    [anon_sym_AMP_AMP] = ACTIONS(1558),
    [anon_sym_PIPE_PIPE] = ACTIONS(1558),
    [anon_sym_EQ_EQ] = ACTIONS(1558),
    [anon_sym_BANG_EQ] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_LT_EQ] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1560),
    [anon_sym_GT_EQ] = ACTIONS(1558),
    [anon_sym_EQ_GT] = ACTIONS(1558),
    [anon_sym_QMARK_QMARK] = ACTIONS(1558),
    [anon_sym_EQ] = ACTIONS(1560),
    [sym__rangeOperator] = ACTIONS(1558),
    [anon_sym_null] = ACTIONS(1560),
    [anon_sym_dynamic] = ACTIONS(1560),
    [anon_sym_final] = ACTIONS(1560),
    [anon_sym_abstract] = ACTIONS(1560),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_extends] = ACTIONS(1560),
    [anon_sym_implements] = ACTIONS(1560),
    [anon_sym_interface] = ACTIONS(1560),
    [anon_sym_typedef] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_var] = ACTIONS(1560),
    [aux_sym_integer_token1] = ACTIONS(1560),
    [aux_sym_integer_token2] = ACTIONS(1558),
    [aux_sym_float_token1] = ACTIONS(1560),
    [aux_sym_float_token2] = ACTIONS(1558),
    [anon_sym_true] = ACTIONS(1560),
    [anon_sym_false] = ACTIONS(1560),
    [aux_sym_string_token1] = ACTIONS(1558),
    [aux_sym_string_token3] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1560),
    [anon_sym_catch] = ACTIONS(1560),
    [anon_sym_continue] = ACTIONS(1560),
    [anon_sym_do] = ACTIONS(1560),
    [anon_sym_enum] = ACTIONS(1560),
    [anon_sym_extern] = ACTIONS(1560),
    [anon_sym_for] = ACTIONS(1560),
    [anon_sym_inline] = ACTIONS(1560),
    [anon_sym_macro] = ACTIONS(1560),
    [anon_sym_operator] = ACTIONS(1560),
    [anon_sym_overload] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_return] = ACTIONS(1560),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_try] = ACTIONS(1560),
    [anon_sym_untyped] = ACTIONS(1560),
    [anon_sym_while] = ACTIONS(1560),
    [sym__semicolon] = ACTIONS(1558),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(1562),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_POUND] = ACTIONS(1562),
    [anon_sym_package] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_using] = ACTIONS(1564),
    [anon_sym_throw] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [anon_sym_switch] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1562),
    [anon_sym_RBRACE] = ACTIONS(1562),
    [anon_sym_case] = ACTIONS(1564),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_cast] = ACTIONS(1564),
    [anon_sym_DOLLARtype] = ACTIONS(1562),
    [anon_sym_in] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1562),
    [anon_sym_this] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1564),
    [anon_sym_AT_COLON] = ACTIONS(1562),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1562),
    [anon_sym_BANG] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1562),
    [anon_sym_DASH_DASH] = ACTIONS(1562),
    [anon_sym_PERCENT] = ACTIONS(1562),
    [anon_sym_STAR] = ACTIONS(1562),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_LT_LT] = ACTIONS(1562),
    [anon_sym_GT_GT] = ACTIONS(1564),
    [anon_sym_GT_GT_GT] = ACTIONS(1562),
    [anon_sym_AMP] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1562),
    [anon_sym_AMP_AMP] = ACTIONS(1562),
    [anon_sym_PIPE_PIPE] = ACTIONS(1562),
    [anon_sym_EQ_EQ] = ACTIONS(1562),
    [anon_sym_BANG_EQ] = ACTIONS(1562),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_LT_EQ] = ACTIONS(1562),
    [anon_sym_GT] = ACTIONS(1564),
    [anon_sym_GT_EQ] = ACTIONS(1562),
    [anon_sym_EQ_GT] = ACTIONS(1562),
    [anon_sym_QMARK_QMARK] = ACTIONS(1562),
    [anon_sym_EQ] = ACTIONS(1564),
    [sym__rangeOperator] = ACTIONS(1562),
    [anon_sym_null] = ACTIONS(1564),
    [anon_sym_dynamic] = ACTIONS(1564),
    [anon_sym_final] = ACTIONS(1564),
    [anon_sym_abstract] = ACTIONS(1564),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_extends] = ACTIONS(1564),
    [anon_sym_implements] = ACTIONS(1564),
    [anon_sym_interface] = ACTIONS(1564),
    [anon_sym_typedef] = ACTIONS(1564),
    [anon_sym_function] = ACTIONS(1564),
    [anon_sym_var] = ACTIONS(1564),
    [aux_sym_integer_token1] = ACTIONS(1564),
    [aux_sym_integer_token2] = ACTIONS(1562),
    [aux_sym_float_token1] = ACTIONS(1564),
    [aux_sym_float_token2] = ACTIONS(1562),
    [anon_sym_true] = ACTIONS(1564),
    [anon_sym_false] = ACTIONS(1564),
    [aux_sym_string_token1] = ACTIONS(1562),
    [aux_sym_string_token3] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_catch] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_do] = ACTIONS(1564),
    [anon_sym_enum] = ACTIONS(1564),
    [anon_sym_extern] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_inline] = ACTIONS(1564),
    [anon_sym_macro] = ACTIONS(1564),
    [anon_sym_operator] = ACTIONS(1564),
    [anon_sym_overload] = ACTIONS(1564),
    [anon_sym_override] = ACTIONS(1564),
    [anon_sym_private] = ACTIONS(1564),
    [anon_sym_public] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_static] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_untyped] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1564),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_identifier] = ACTIONS(376),
    [anon_sym_POUND] = ACTIONS(89),
    [anon_sym_package] = ACTIONS(376),
    [anon_sym_import] = ACTIONS(376),
    [anon_sym_using] = ACTIONS(376),
    [anon_sym_throw] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(89),
    [anon_sym_RBRACE] = ACTIONS(89),
    [anon_sym_case] = ACTIONS(376),
    [anon_sym_default] = ACTIONS(376),
    [anon_sym_cast] = ACTIONS(376),
    [anon_sym_DOLLARtype] = ACTIONS(89),
    [anon_sym_in] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_this] = ACTIONS(376),
    [anon_sym_AT] = ACTIONS(376),
    [anon_sym_AT_COLON] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_else] = ACTIONS(376),
    [anon_sym_new] = ACTIONS(376),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(376),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PERCENT] = ACTIONS(89),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_LT_LT] = ACTIONS(89),
    [anon_sym_GT_GT] = ACTIONS(376),
    [anon_sym_GT_GT_GT] = ACTIONS(89),
    [anon_sym_AMP] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_CARET] = ACTIONS(89),
    [anon_sym_AMP_AMP] = ACTIONS(89),
    [anon_sym_PIPE_PIPE] = ACTIONS(89),
    [anon_sym_EQ_EQ] = ACTIONS(89),
    [anon_sym_BANG_EQ] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_LT_EQ] = ACTIONS(89),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_GT_EQ] = ACTIONS(89),
    [anon_sym_EQ_GT] = ACTIONS(89),
    [anon_sym_QMARK_QMARK] = ACTIONS(89),
    [anon_sym_EQ] = ACTIONS(376),
    [sym__rangeOperator] = ACTIONS(89),
    [anon_sym_null] = ACTIONS(376),
    [anon_sym_dynamic] = ACTIONS(376),
    [anon_sym_final] = ACTIONS(376),
    [anon_sym_abstract] = ACTIONS(376),
    [anon_sym_class] = ACTIONS(376),
    [anon_sym_extends] = ACTIONS(376),
    [anon_sym_implements] = ACTIONS(376),
    [anon_sym_interface] = ACTIONS(376),
    [anon_sym_typedef] = ACTIONS(376),
    [anon_sym_function] = ACTIONS(376),
    [anon_sym_var] = ACTIONS(376),
    [aux_sym_integer_token1] = ACTIONS(376),
    [aux_sym_integer_token2] = ACTIONS(89),
    [aux_sym_float_token1] = ACTIONS(376),
    [aux_sym_float_token2] = ACTIONS(89),
    [anon_sym_true] = ACTIONS(376),
    [anon_sym_false] = ACTIONS(376),
    [aux_sym_string_token1] = ACTIONS(89),
    [aux_sym_string_token3] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(376),
    [anon_sym_catch] = ACTIONS(376),
    [anon_sym_continue] = ACTIONS(376),
    [anon_sym_do] = ACTIONS(376),
    [anon_sym_enum] = ACTIONS(376),
    [anon_sym_extern] = ACTIONS(376),
    [anon_sym_for] = ACTIONS(376),
    [anon_sym_inline] = ACTIONS(376),
    [anon_sym_macro] = ACTIONS(376),
    [anon_sym_operator] = ACTIONS(376),
    [anon_sym_overload] = ACTIONS(376),
    [anon_sym_override] = ACTIONS(376),
    [anon_sym_private] = ACTIONS(376),
    [anon_sym_public] = ACTIONS(376),
    [anon_sym_return] = ACTIONS(376),
    [anon_sym_static] = ACTIONS(376),
    [anon_sym_try] = ACTIONS(376),
    [anon_sym_untyped] = ACTIONS(376),
    [anon_sym_while] = ACTIONS(376),
  },
  [339] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(341),
    [sym_runtime_type_check_expression] = STATE(341),
    [sym_switch_expression] = STATE(341),
    [sym_cast_expression] = STATE(341),
    [sym_type_trace_expression] = STATE(341),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(341),
    [sym_subscript_expression] = STATE(341),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(341),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_RPAREN] = ACTIONS(1568),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(342),
    [sym_runtime_type_check_expression] = STATE(342),
    [sym_switch_expression] = STATE(342),
    [sym_cast_expression] = STATE(342),
    [sym_type_trace_expression] = STATE(342),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(342),
    [sym_subscript_expression] = STATE(342),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_structure_type_pair] = STATE(1311),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(342),
    [sym_identifier] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(341),
    [sym_runtime_type_check_expression] = STATE(341),
    [sym_switch_expression] = STATE(341),
    [sym_cast_expression] = STATE(341),
    [sym_type_trace_expression] = STATE(341),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(341),
    [sym_subscript_expression] = STATE(341),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(341),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_switch] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1583),
    [anon_sym_cast] = ACTIONS(1586),
    [anon_sym_DOLLARtype] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1592),
    [anon_sym_this] = ACTIONS(1595),
    [anon_sym_new] = ACTIONS(1598),
    [anon_sym_TILDE] = ACTIONS(1601),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_PERCENT] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_LT_LT] = ACTIONS(1613),
    [anon_sym_GT_GT] = ACTIONS(1616),
    [anon_sym_GT_GT_GT] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1616),
    [anon_sym_CARET] = ACTIONS(1613),
    [anon_sym_AMP_AMP] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE] = ACTIONS(1601),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_LT_EQ] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1604),
    [anon_sym_GT_EQ] = ACTIONS(1601),
    [anon_sym_EQ_GT] = ACTIONS(1601),
    [anon_sym_QMARK_QMARK] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1604),
    [sym__rangeOperator] = ACTIONS(1601),
    [anon_sym_null] = ACTIONS(1619),
    [aux_sym_integer_token1] = ACTIONS(1622),
    [aux_sym_integer_token2] = ACTIONS(1625),
    [aux_sym_float_token1] = ACTIONS(1628),
    [aux_sym_float_token2] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(1634),
    [anon_sym_false] = ACTIONS(1634),
    [aux_sym_string_token1] = ACTIONS(1637),
    [aux_sym_string_token3] = ACTIONS(1640),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(341),
    [sym_runtime_type_check_expression] = STATE(341),
    [sym_switch_expression] = STATE(341),
    [sym_cast_expression] = STATE(341),
    [sym_type_trace_expression] = STATE(341),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(341),
    [sym_subscript_expression] = STATE(341),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(341),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_RPAREN] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(339),
    [sym_runtime_type_check_expression] = STATE(339),
    [sym_switch_expression] = STATE(339),
    [sym_cast_expression] = STATE(339),
    [sym_type_trace_expression] = STATE(339),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(339),
    [sym_subscript_expression] = STATE(339),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_structure_type_pair] = STATE(1340),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(339),
    [sym_identifier] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym__rhs_expression] = STATE(510),
    [sym__unaryExpression] = STATE(1156),
    [sym_runtime_type_check_expression] = STATE(1156),
    [sym_switch_expression] = STATE(1156),
    [sym_cast_expression] = STATE(1156),
    [sym_type_trace_expression] = STATE(1156),
    [sym__parenthesized_expression] = STATE(1118),
    [sym_range_expression] = STATE(1156),
    [sym_subscript_expression] = STATE(1156),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(510),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_RPAREN] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym__rhs_expression] = STATE(513),
    [sym__unaryExpression] = STATE(1173),
    [sym_runtime_type_check_expression] = STATE(1173),
    [sym_switch_expression] = STATE(1173),
    [sym_cast_expression] = STATE(1173),
    [sym_type_trace_expression] = STATE(1173),
    [sym__parenthesized_expression] = STATE(1039),
    [sym_range_expression] = STATE(1173),
    [sym_subscript_expression] = STATE(1173),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(513),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_RPAREN] = ACTIONS(1651),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(339),
    [sym_runtime_type_check_expression] = STATE(339),
    [sym_switch_expression] = STATE(339),
    [sym_cast_expression] = STATE(339),
    [sym_type_trace_expression] = STATE(339),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(339),
    [sym_subscript_expression] = STATE(339),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(339),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym__rhs_expression] = STATE(485),
    [sym__unaryExpression] = STATE(1065),
    [sym_runtime_type_check_expression] = STATE(1065),
    [sym_switch_expression] = STATE(1065),
    [sym_cast_expression] = STATE(1065),
    [sym_type_trace_expression] = STATE(1065),
    [sym__parenthesized_expression] = STATE(1035),
    [sym_range_expression] = STATE(1065),
    [sym_subscript_expression] = STATE(1065),
    [sym_member_expression] = STATE(679),
    [sym__lhs_expression] = STATE(1075),
    [sym__call] = STATE(726),
    [sym__constructor_call] = STATE(702),
    [sym_call_expression] = STATE(485),
    [sym_operator] = STATE(800),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(724),
    [sym_integer] = STATE(724),
    [sym_float] = STATE(724),
    [sym_bool] = STATE(724),
    [sym_string] = STATE(692),
    [sym_null] = STATE(724),
    [sym_array] = STATE(724),
    [sym_map] = STATE(724),
    [sym_object] = STATE(724),
    [sym_pair] = STATE(700),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_LPAREN] = ACTIONS(1655),
    [anon_sym_switch] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_cast] = ACTIONS(1661),
    [anon_sym_DOLLARtype] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(1671),
    [aux_sym_integer_token1] = ACTIONS(1673),
    [aux_sym_integer_token2] = ACTIONS(1675),
    [aux_sym_float_token1] = ACTIONS(1677),
    [aux_sym_float_token2] = ACTIONS(1679),
    [anon_sym_true] = ACTIONS(1681),
    [anon_sym_false] = ACTIONS(1681),
    [aux_sym_string_token1] = ACTIONS(1683),
    [aux_sym_string_token3] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym__rhs_expression] = STATE(497),
    [sym__unaryExpression] = STATE(1108),
    [sym_runtime_type_check_expression] = STATE(1108),
    [sym_switch_expression] = STATE(1108),
    [sym_cast_expression] = STATE(1108),
    [sym_type_trace_expression] = STATE(1108),
    [sym__parenthesized_expression] = STATE(1025),
    [sym_range_expression] = STATE(1108),
    [sym_subscript_expression] = STATE(1108),
    [sym_member_expression] = STATE(679),
    [sym__lhs_expression] = STATE(1075),
    [sym__call] = STATE(726),
    [sym__constructor_call] = STATE(702),
    [sym_call_expression] = STATE(497),
    [sym_operator] = STATE(800),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(724),
    [sym_integer] = STATE(724),
    [sym_float] = STATE(724),
    [sym_bool] = STATE(724),
    [sym_string] = STATE(692),
    [sym_null] = STATE(724),
    [sym_array] = STATE(724),
    [sym_map] = STATE(724),
    [sym_object] = STATE(724),
    [sym_pair] = STATE(698),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_LPAREN] = ACTIONS(1655),
    [anon_sym_switch] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_cast] = ACTIONS(1661),
    [anon_sym_DOLLARtype] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_RBRACK] = ACTIONS(1687),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(1671),
    [aux_sym_integer_token1] = ACTIONS(1673),
    [aux_sym_integer_token2] = ACTIONS(1675),
    [aux_sym_float_token1] = ACTIONS(1677),
    [aux_sym_float_token2] = ACTIONS(1679),
    [anon_sym_true] = ACTIONS(1681),
    [anon_sym_false] = ACTIONS(1681),
    [aux_sym_string_token1] = ACTIONS(1683),
    [aux_sym_string_token3] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym__rhs_expression] = STATE(439),
    [sym__unaryExpression] = STATE(342),
    [sym_runtime_type_check_expression] = STATE(342),
    [sym_switch_expression] = STATE(342),
    [sym_cast_expression] = STATE(342),
    [sym_type_trace_expression] = STATE(342),
    [sym__parenthesized_expression] = STATE(469),
    [sym_range_expression] = STATE(342),
    [sym_subscript_expression] = STATE(342),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(439),
    [sym_operator] = STATE(801),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(464),
    [sym_integer] = STATE(464),
    [sym_float] = STATE(464),
    [sym_bool] = STATE(464),
    [sym_string] = STATE(462),
    [sym_null] = STATE(464),
    [sym_array] = STATE(464),
    [sym_map] = STATE(464),
    [sym_object] = STATE(464),
    [sym_pair] = STATE(464),
    [aux_sym__parenthesized_expression_repeat1] = STATE(342),
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(604),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym__rhs_expression] = STATE(503),
    [sym__unaryExpression] = STATE(1154),
    [sym_runtime_type_check_expression] = STATE(1154),
    [sym_switch_expression] = STATE(1154),
    [sym_cast_expression] = STATE(1154),
    [sym_type_trace_expression] = STATE(1154),
    [sym__parenthesized_expression] = STATE(1113),
    [sym_range_expression] = STATE(1154),
    [sym_subscript_expression] = STATE(1154),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(503),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym__rhs_expression] = STATE(593),
    [sym__unaryExpression] = STATE(1306),
    [sym_runtime_type_check_expression] = STATE(1306),
    [sym_switch_expression] = STATE(1306),
    [sym_cast_expression] = STATE(1306),
    [sym_type_trace_expression] = STATE(1306),
    [sym__parenthesized_expression] = STATE(1193),
    [sym_range_expression] = STATE(1306),
    [sym_subscript_expression] = STATE(1306),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(593),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym__rhs_expression] = STATE(550),
    [sym__unaryExpression] = STATE(1288),
    [sym_runtime_type_check_expression] = STATE(1288),
    [sym_switch_expression] = STATE(1288),
    [sym_cast_expression] = STATE(1288),
    [sym_type_trace_expression] = STATE(1288),
    [sym__parenthesized_expression] = STATE(1232),
    [sym_range_expression] = STATE(1288),
    [sym_subscript_expression] = STATE(1288),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(550),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym__rhs_expression] = STATE(577),
    [sym__unaryExpression] = STATE(1297),
    [sym_runtime_type_check_expression] = STATE(1297),
    [sym_switch_expression] = STATE(1297),
    [sym_cast_expression] = STATE(1297),
    [sym_type_trace_expression] = STATE(1297),
    [sym__parenthesized_expression] = STATE(1211),
    [sym_range_expression] = STATE(1297),
    [sym_subscript_expression] = STATE(1297),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(577),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym__rhs_expression] = STATE(538),
    [sym__unaryExpression] = STATE(1202),
    [sym_runtime_type_check_expression] = STATE(1202),
    [sym_switch_expression] = STATE(1202),
    [sym_cast_expression] = STATE(1202),
    [sym_type_trace_expression] = STATE(1202),
    [sym__parenthesized_expression] = STATE(1182),
    [sym_range_expression] = STATE(1202),
    [sym_subscript_expression] = STATE(1202),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(538),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym__rhs_expression] = STATE(574),
    [sym__unaryExpression] = STATE(1294),
    [sym_runtime_type_check_expression] = STATE(1294),
    [sym_switch_expression] = STATE(1294),
    [sym_cast_expression] = STATE(1294),
    [sym_type_trace_expression] = STATE(1294),
    [sym__parenthesized_expression] = STATE(1213),
    [sym_range_expression] = STATE(1294),
    [sym_subscript_expression] = STATE(1294),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(574),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym__rhs_expression] = STATE(598),
    [sym__unaryExpression] = STATE(1331),
    [sym_runtime_type_check_expression] = STATE(1331),
    [sym_switch_expression] = STATE(1331),
    [sym_cast_expression] = STATE(1331),
    [sym_type_trace_expression] = STATE(1331),
    [sym__parenthesized_expression] = STATE(1234),
    [sym_range_expression] = STATE(1331),
    [sym_subscript_expression] = STATE(1331),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(598),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym__rhs_expression] = STATE(575),
    [sym__unaryExpression] = STATE(1316),
    [sym_runtime_type_check_expression] = STATE(1316),
    [sym_switch_expression] = STATE(1316),
    [sym_cast_expression] = STATE(1316),
    [sym_type_trace_expression] = STATE(1316),
    [sym__parenthesized_expression] = STATE(1207),
    [sym_range_expression] = STATE(1316),
    [sym_subscript_expression] = STATE(1316),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(575),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym__rhs_expression] = STATE(600),
    [sym__unaryExpression] = STATE(1327),
    [sym_runtime_type_check_expression] = STATE(1327),
    [sym_switch_expression] = STATE(1327),
    [sym_cast_expression] = STATE(1327),
    [sym_type_trace_expression] = STATE(1327),
    [sym__parenthesized_expression] = STATE(1222),
    [sym_range_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(1327),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(600),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym__rhs_expression] = STATE(553),
    [sym__unaryExpression] = STATE(1300),
    [sym_runtime_type_check_expression] = STATE(1300),
    [sym_switch_expression] = STATE(1300),
    [sym_cast_expression] = STATE(1300),
    [sym_type_trace_expression] = STATE(1300),
    [sym__parenthesized_expression] = STATE(1203),
    [sym_range_expression] = STATE(1300),
    [sym_subscript_expression] = STATE(1300),
    [sym_member_expression] = STATE(790),
    [sym__lhs_expression] = STATE(1018),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(553),
    [sym_operator] = STATE(785),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(764),
    [sym_integer] = STATE(764),
    [sym_float] = STATE(764),
    [sym_bool] = STATE(764),
    [sym_string] = STATE(743),
    [sym_null] = STATE(764),
    [sym_array] = STATE(764),
    [sym_map] = STATE(764),
    [sym_object] = STATE(764),
    [sym_pair] = STATE(764),
    [sym_identifier] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1693),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym__rhs_expression] = STATE(25),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(25),
    [sym_operator] = STATE(789),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(113),
    [sym_integer] = STATE(113),
    [sym_float] = STATE(113),
    [sym_bool] = STATE(113),
    [sym_string] = STATE(105),
    [sym_null] = STATE(113),
    [sym_array] = STATE(113),
    [sym_map] = STATE(113),
    [sym_object] = STATE(113),
    [sym_pair] = STATE(113),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1697),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym__rhs_expression] = STATE(551),
    [sym__unaryExpression] = STATE(1305),
    [sym_runtime_type_check_expression] = STATE(1305),
    [sym_switch_expression] = STATE(1305),
    [sym_cast_expression] = STATE(1305),
    [sym_type_trace_expression] = STATE(1305),
    [sym__parenthesized_expression] = STATE(1195),
    [sym_range_expression] = STATE(1305),
    [sym_subscript_expression] = STATE(1305),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(551),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym__rhs_expression] = STATE(546),
    [sym__unaryExpression] = STATE(1291),
    [sym_runtime_type_check_expression] = STATE(1291),
    [sym_switch_expression] = STATE(1291),
    [sym_cast_expression] = STATE(1291),
    [sym_type_trace_expression] = STATE(1291),
    [sym__parenthesized_expression] = STATE(1224),
    [sym_range_expression] = STATE(1291),
    [sym_subscript_expression] = STATE(1291),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(546),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym__rhs_expression] = STATE(543),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(543),
    [sym_operator] = STATE(808),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(764),
    [sym_integer] = STATE(764),
    [sym_float] = STATE(764),
    [sym_bool] = STATE(764),
    [sym_string] = STATE(743),
    [sym_null] = STATE(764),
    [sym_array] = STATE(764),
    [sym_map] = STATE(764),
    [sym_object] = STATE(764),
    [sym_pair] = STATE(764),
    [sym_identifier] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1236),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym__rhs_expression] = STATE(547),
    [sym__unaryExpression] = STATE(1290),
    [sym_runtime_type_check_expression] = STATE(1290),
    [sym_switch_expression] = STATE(1290),
    [sym_cast_expression] = STATE(1290),
    [sym_type_trace_expression] = STATE(1290),
    [sym__parenthesized_expression] = STATE(1228),
    [sym_range_expression] = STATE(1290),
    [sym_subscript_expression] = STATE(1290),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(547),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym__rhs_expression] = STATE(592),
    [sym__unaryExpression] = STATE(1268),
    [sym_runtime_type_check_expression] = STATE(1268),
    [sym_switch_expression] = STATE(1268),
    [sym_cast_expression] = STATE(1268),
    [sym_type_trace_expression] = STATE(1268),
    [sym__parenthesized_expression] = STATE(1192),
    [sym_range_expression] = STATE(1268),
    [sym_subscript_expression] = STATE(1268),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(592),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym__rhs_expression] = STATE(594),
    [sym__unaryExpression] = STATE(1293),
    [sym_runtime_type_check_expression] = STATE(1293),
    [sym_switch_expression] = STATE(1293),
    [sym_cast_expression] = STATE(1293),
    [sym_type_trace_expression] = STATE(1293),
    [sym__parenthesized_expression] = STATE(1214),
    [sym_range_expression] = STATE(1293),
    [sym_subscript_expression] = STATE(1293),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(594),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym__rhs_expression] = STATE(431),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(431),
    [sym_operator] = STATE(803),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(465),
    [sym_integer] = STATE(465),
    [sym_float] = STATE(465),
    [sym_bool] = STATE(465),
    [sym_string] = STATE(462),
    [sym_null] = STATE(465),
    [sym_array] = STATE(465),
    [sym_map] = STATE(465),
    [sym_object] = STATE(465),
    [sym_pair] = STATE(465),
    [sym_identifier] = ACTIONS(1701),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(996),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym__rhs_expression] = STATE(599),
    [sym__unaryExpression] = STATE(1326),
    [sym_runtime_type_check_expression] = STATE(1326),
    [sym_switch_expression] = STATE(1326),
    [sym_cast_expression] = STATE(1326),
    [sym_type_trace_expression] = STATE(1326),
    [sym__parenthesized_expression] = STATE(1220),
    [sym_range_expression] = STATE(1326),
    [sym_subscript_expression] = STATE(1326),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(599),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym__rhs_expression] = STATE(512),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(512),
    [sym_operator] = STATE(791),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(779),
    [sym_integer] = STATE(779),
    [sym_float] = STATE(779),
    [sym_bool] = STATE(779),
    [sym_string] = STATE(782),
    [sym_null] = STATE(779),
    [sym_array] = STATE(779),
    [sym_map] = STATE(779),
    [sym_object] = STATE(779),
    [sym_pair] = STATE(779),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1705),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1707),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym__rhs_expression] = STATE(587),
    [sym__unaryExpression] = STATE(1336),
    [sym_runtime_type_check_expression] = STATE(1336),
    [sym_switch_expression] = STATE(1336),
    [sym_cast_expression] = STATE(1336),
    [sym_type_trace_expression] = STATE(1336),
    [sym__parenthesized_expression] = STATE(1242),
    [sym_range_expression] = STATE(1336),
    [sym_subscript_expression] = STATE(1336),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(587),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym__rhs_expression] = STATE(597),
    [sym__unaryExpression] = STATE(1322),
    [sym_runtime_type_check_expression] = STATE(1322),
    [sym_switch_expression] = STATE(1322),
    [sym_cast_expression] = STATE(1322),
    [sym_type_trace_expression] = STATE(1322),
    [sym__parenthesized_expression] = STATE(1212),
    [sym_range_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(597),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym__rhs_expression] = STATE(471),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(471),
    [sym_operator] = STATE(804),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(694),
    [sym_integer] = STATE(694),
    [sym_float] = STATE(694),
    [sym_bool] = STATE(694),
    [sym_string] = STATE(675),
    [sym_null] = STATE(694),
    [sym_array] = STATE(694),
    [sym_map] = STATE(694),
    [sym_object] = STATE(694),
    [sym_pair] = STATE(694),
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1090),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym__rhs_expression] = STATE(478),
    [sym__unaryExpression] = STATE(725),
    [sym_runtime_type_check_expression] = STATE(725),
    [sym_switch_expression] = STATE(725),
    [sym_cast_expression] = STATE(725),
    [sym_type_trace_expression] = STATE(725),
    [sym__parenthesized_expression] = STATE(688),
    [sym_range_expression] = STATE(725),
    [sym_subscript_expression] = STATE(725),
    [sym_member_expression] = STATE(679),
    [sym__lhs_expression] = STATE(1075),
    [sym__call] = STATE(726),
    [sym__constructor_call] = STATE(702),
    [sym_call_expression] = STATE(478),
    [sym_operator] = STATE(783),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(707),
    [sym_integer] = STATE(707),
    [sym_float] = STATE(707),
    [sym_bool] = STATE(707),
    [sym_string] = STATE(692),
    [sym_null] = STATE(707),
    [sym_array] = STATE(707),
    [sym_map] = STATE(707),
    [sym_object] = STATE(707),
    [sym_pair] = STATE(707),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1655),
    [anon_sym_switch] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_cast] = ACTIONS(1713),
    [anon_sym_DOLLARtype] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(1671),
    [aux_sym_integer_token1] = ACTIONS(1673),
    [aux_sym_integer_token2] = ACTIONS(1675),
    [aux_sym_float_token1] = ACTIONS(1677),
    [aux_sym_float_token2] = ACTIONS(1679),
    [anon_sym_true] = ACTIONS(1681),
    [anon_sym_false] = ACTIONS(1681),
    [aux_sym_string_token1] = ACTIONS(1683),
    [aux_sym_string_token3] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym__rhs_expression] = STATE(541),
    [sym__unaryExpression] = STATE(1198),
    [sym_runtime_type_check_expression] = STATE(1198),
    [sym_switch_expression] = STATE(1198),
    [sym_cast_expression] = STATE(1198),
    [sym_type_trace_expression] = STATE(1198),
    [sym__parenthesized_expression] = STATE(1128),
    [sym_range_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(541),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym__rhs_expression] = STATE(511),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(511),
    [sym_operator] = STATE(792),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(779),
    [sym_integer] = STATE(779),
    [sym_float] = STATE(779),
    [sym_bool] = STATE(779),
    [sym_string] = STATE(782),
    [sym_null] = STATE(779),
    [sym_array] = STATE(779),
    [sym_map] = STATE(779),
    [sym_object] = STATE(779),
    [sym_pair] = STATE(779),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1715),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1707),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym__rhs_expression] = STATE(481),
    [sym__unaryExpression] = STATE(725),
    [sym_runtime_type_check_expression] = STATE(725),
    [sym_switch_expression] = STATE(725),
    [sym_cast_expression] = STATE(725),
    [sym_type_trace_expression] = STATE(725),
    [sym__parenthesized_expression] = STATE(688),
    [sym_range_expression] = STATE(725),
    [sym_subscript_expression] = STATE(725),
    [sym_member_expression] = STATE(679),
    [sym__lhs_expression] = STATE(1075),
    [sym__call] = STATE(726),
    [sym__constructor_call] = STATE(702),
    [sym_call_expression] = STATE(481),
    [sym_operator] = STATE(793),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(707),
    [sym_integer] = STATE(707),
    [sym_float] = STATE(707),
    [sym_bool] = STATE(707),
    [sym_string] = STATE(692),
    [sym_null] = STATE(707),
    [sym_array] = STATE(707),
    [sym_map] = STATE(707),
    [sym_object] = STATE(707),
    [sym_pair] = STATE(707),
    [sym_identifier] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1655),
    [anon_sym_switch] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1659),
    [anon_sym_cast] = ACTIONS(1717),
    [anon_sym_DOLLARtype] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1669),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(1671),
    [aux_sym_integer_token1] = ACTIONS(1673),
    [aux_sym_integer_token2] = ACTIONS(1675),
    [aux_sym_float_token1] = ACTIONS(1677),
    [aux_sym_float_token2] = ACTIONS(1679),
    [anon_sym_true] = ACTIONS(1681),
    [anon_sym_false] = ACTIONS(1681),
    [aux_sym_string_token1] = ACTIONS(1683),
    [aux_sym_string_token3] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym__rhs_expression] = STATE(524),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(524),
    [sym_operator] = STATE(786),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1719),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym__rhs_expression] = STATE(565),
    [sym__unaryExpression] = STATE(1284),
    [sym_runtime_type_check_expression] = STATE(1284),
    [sym_switch_expression] = STATE(1284),
    [sym_cast_expression] = STATE(1284),
    [sym_type_trace_expression] = STATE(1284),
    [sym__parenthesized_expression] = STATE(1240),
    [sym_range_expression] = STATE(1284),
    [sym_subscript_expression] = STATE(1284),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(565),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym__rhs_expression] = STATE(495),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(495),
    [sym_operator] = STATE(776),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(751),
    [sym_integer] = STATE(751),
    [sym_float] = STATE(751),
    [sym_bool] = STATE(751),
    [sym_string] = STATE(743),
    [sym_null] = STATE(751),
    [sym_array] = STATE(751),
    [sym_map] = STATE(751),
    [sym_object] = STATE(751),
    [sym_pair] = STATE(751),
    [sym_identifier] = ACTIONS(1721),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1723),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym__rhs_expression] = STATE(578),
    [sym__unaryExpression] = STATE(1351),
    [sym_runtime_type_check_expression] = STATE(1351),
    [sym_switch_expression] = STATE(1351),
    [sym_cast_expression] = STATE(1351),
    [sym_type_trace_expression] = STATE(1351),
    [sym__parenthesized_expression] = STATE(1253),
    [sym_range_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(578),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym__rhs_expression] = STATE(567),
    [sym__unaryExpression] = STATE(1289),
    [sym_runtime_type_check_expression] = STATE(1289),
    [sym_switch_expression] = STATE(1289),
    [sym_cast_expression] = STATE(1289),
    [sym_type_trace_expression] = STATE(1289),
    [sym__parenthesized_expression] = STATE(1229),
    [sym_range_expression] = STATE(1289),
    [sym_subscript_expression] = STATE(1289),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(567),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym__rhs_expression] = STATE(559),
    [sym__unaryExpression] = STATE(1308),
    [sym_runtime_type_check_expression] = STATE(1308),
    [sym_switch_expression] = STATE(1308),
    [sym_cast_expression] = STATE(1308),
    [sym_type_trace_expression] = STATE(1308),
    [sym__parenthesized_expression] = STATE(1190),
    [sym_range_expression] = STATE(1308),
    [sym_subscript_expression] = STATE(1308),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(559),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym__rhs_expression] = STATE(491),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(491),
    [sym_operator] = STATE(775),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(751),
    [sym_integer] = STATE(751),
    [sym_float] = STATE(751),
    [sym_bool] = STATE(751),
    [sym_string] = STATE(743),
    [sym_null] = STATE(751),
    [sym_array] = STATE(751),
    [sym_map] = STATE(751),
    [sym_object] = STATE(751),
    [sym_pair] = STATE(751),
    [sym_identifier] = ACTIONS(1721),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1725),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym__rhs_expression] = STATE(561),
    [sym__unaryExpression] = STATE(1263),
    [sym_runtime_type_check_expression] = STATE(1263),
    [sym_switch_expression] = STATE(1263),
    [sym_cast_expression] = STATE(1263),
    [sym_type_trace_expression] = STATE(1263),
    [sym__parenthesized_expression] = STATE(1206),
    [sym_range_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(561),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym__rhs_expression] = STATE(474),
    [sym__unaryExpression] = STATE(66),
    [sym_runtime_type_check_expression] = STATE(66),
    [sym_switch_expression] = STATE(66),
    [sym_cast_expression] = STATE(66),
    [sym_type_trace_expression] = STATE(66),
    [sym__parenthesized_expression] = STATE(65),
    [sym_range_expression] = STATE(66),
    [sym_subscript_expression] = STATE(66),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(474),
    [sym_operator] = STATE(780),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(694),
    [sym_integer] = STATE(694),
    [sym_float] = STATE(694),
    [sym_bool] = STATE(694),
    [sym_string] = STATE(675),
    [sym_null] = STATE(694),
    [sym_array] = STATE(694),
    [sym_map] = STATE(694),
    [sym_object] = STATE(694),
    [sym_pair] = STATE(694),
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1727),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym__rhs_expression] = STATE(582),
    [sym__unaryExpression] = STATE(1347),
    [sym_runtime_type_check_expression] = STATE(1347),
    [sym_switch_expression] = STATE(1347),
    [sym_cast_expression] = STATE(1347),
    [sym_type_trace_expression] = STATE(1347),
    [sym__parenthesized_expression] = STATE(1247),
    [sym_range_expression] = STATE(1347),
    [sym_subscript_expression] = STATE(1347),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(582),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym__rhs_expression] = STATE(552),
    [sym__unaryExpression] = STATE(1301),
    [sym_runtime_type_check_expression] = STATE(1301),
    [sym_switch_expression] = STATE(1301),
    [sym_cast_expression] = STATE(1301),
    [sym_type_trace_expression] = STATE(1301),
    [sym__parenthesized_expression] = STATE(1199),
    [sym_range_expression] = STATE(1301),
    [sym_subscript_expression] = STATE(1301),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(552),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym__rhs_expression] = STATE(570),
    [sym__unaryExpression] = STATE(1287),
    [sym_runtime_type_check_expression] = STATE(1287),
    [sym_switch_expression] = STATE(1287),
    [sym_cast_expression] = STATE(1287),
    [sym_type_trace_expression] = STATE(1287),
    [sym__parenthesized_expression] = STATE(1231),
    [sym_range_expression] = STATE(1287),
    [sym_subscript_expression] = STATE(1287),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(570),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym__rhs_expression] = STATE(584),
    [sym__unaryExpression] = STATE(1344),
    [sym_runtime_type_check_expression] = STATE(1344),
    [sym_switch_expression] = STATE(1344),
    [sym_cast_expression] = STATE(1344),
    [sym_type_trace_expression] = STATE(1344),
    [sym__parenthesized_expression] = STATE(1246),
    [sym_range_expression] = STATE(1344),
    [sym_subscript_expression] = STATE(1344),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(584),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym__rhs_expression] = STATE(576),
    [sym__unaryExpression] = STATE(1355),
    [sym_runtime_type_check_expression] = STATE(1355),
    [sym_switch_expression] = STATE(1355),
    [sym_cast_expression] = STATE(1355),
    [sym_type_trace_expression] = STATE(1355),
    [sym__parenthesized_expression] = STATE(1249),
    [sym_range_expression] = STATE(1355),
    [sym_subscript_expression] = STATE(1355),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(576),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym__rhs_expression] = STATE(545),
    [sym__unaryExpression] = STATE(1265),
    [sym_runtime_type_check_expression] = STATE(1265),
    [sym_switch_expression] = STATE(1265),
    [sym_cast_expression] = STATE(1265),
    [sym_type_trace_expression] = STATE(1265),
    [sym__parenthesized_expression] = STATE(1259),
    [sym_range_expression] = STATE(1265),
    [sym_subscript_expression] = STATE(1265),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(545),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym__rhs_expression] = STATE(556),
    [sym__unaryExpression] = STATE(1271),
    [sym_runtime_type_check_expression] = STATE(1271),
    [sym_switch_expression] = STATE(1271),
    [sym_cast_expression] = STATE(1271),
    [sym_type_trace_expression] = STATE(1271),
    [sym__parenthesized_expression] = STATE(1261),
    [sym_range_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1271),
    [sym_member_expression] = STATE(97),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(556),
    [sym_operator] = STATE(810),
    [sym__unaryOperator] = STATE(88),
    [sym__prefixUnaryOperator] = STATE(88),
    [sym__postfixUnaryOperator] = STATE(88),
    [sym__binaryOperator] = STATE(88),
    [sym__arithmeticOperator] = STATE(952),
    [sym__bitwiseOperator] = STATE(952),
    [sym__logicalOperator] = STATE(88),
    [sym__comparisonOperator] = STATE(88),
    [sym__miscOperator] = STATE(88),
    [sym__assignmentOperator] = STATE(88),
    [sym__compoundAssignmentOperator] = STATE(88),
    [sym__literal] = STATE(699),
    [sym_integer] = STATE(699),
    [sym_float] = STATE(699),
    [sym_bool] = STATE(699),
    [sym_string] = STATE(675),
    [sym_null] = STATE(699),
    [sym_array] = STATE(699),
    [sym_map] = STATE(699),
    [sym_object] = STATE(699),
    [sym_pair] = STATE(699),
    [sym_identifier] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_switch] = ACTIONS(230),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_cast] = ACTIONS(1649),
    [anon_sym_DOLLARtype] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(53),
    [anon_sym_DASH_DASH] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_LT_LT] = ACTIONS(55),
    [anon_sym_GT_GT] = ACTIONS(57),
    [anon_sym_GT_GT_GT] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_AMP_AMP] = ACTIONS(47),
    [anon_sym_PIPE_PIPE] = ACTIONS(47),
    [anon_sym_EQ_EQ] = ACTIONS(47),
    [anon_sym_BANG_EQ] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(49),
    [anon_sym_LT_EQ] = ACTIONS(47),
    [anon_sym_GT] = ACTIONS(49),
    [anon_sym_GT_EQ] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(47),
    [anon_sym_QMARK_QMARK] = ACTIONS(47),
    [anon_sym_EQ] = ACTIONS(49),
    [sym__rangeOperator] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(59),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(248),
    [anon_sym_import] = ACTIONS(248),
    [anon_sym_using] = ACTIONS(248),
    [anon_sym_throw] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_switch] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(248),
    [anon_sym_default] = ACTIONS(248),
    [anon_sym_cast] = ACTIONS(248),
    [anon_sym_in] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_AT_COLON] = ACTIONS(244),
    [anon_sym_if] = ACTIONS(248),
    [anon_sym_else] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(248),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(248),
    [anon_sym_final] = ACTIONS(248),
    [anon_sym_abstract] = ACTIONS(248),
    [anon_sym_class] = ACTIONS(248),
    [anon_sym_extends] = ACTIONS(248),
    [anon_sym_implements] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(248),
    [anon_sym_typedef] = ACTIONS(248),
    [anon_sym_function] = ACTIONS(248),
    [anon_sym_var] = ACTIONS(248),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(248),
    [anon_sym_catch] = ACTIONS(248),
    [anon_sym_continue] = ACTIONS(248),
    [anon_sym_do] = ACTIONS(248),
    [anon_sym_enum] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(248),
    [anon_sym_for] = ACTIONS(248),
    [anon_sym_inline] = ACTIONS(248),
    [anon_sym_macro] = ACTIONS(248),
    [anon_sym_operator] = ACTIONS(248),
    [anon_sym_overload] = ACTIONS(248),
    [anon_sym_override] = ACTIONS(248),
    [anon_sym_private] = ACTIONS(248),
    [anon_sym_public] = ACTIONS(248),
    [anon_sym_return] = ACTIONS(248),
    [anon_sym_static] = ACTIONS(248),
    [anon_sym_try] = ACTIONS(248),
    [anon_sym_untyped] = ACTIONS(248),
    [anon_sym_while] = ACTIONS(248),
    [sym__semicolon] = ACTIONS(244),
  },
  [394] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(254),
    [anon_sym_using] = ACTIONS(254),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(254),
    [anon_sym_cast] = ACTIONS(254),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_COLON] = ACTIONS(252),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_new] = ACTIONS(254),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(254),
    [anon_sym_final] = ACTIONS(254),
    [anon_sym_abstract] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_extends] = ACTIONS(254),
    [anon_sym_implements] = ACTIONS(254),
    [anon_sym_interface] = ACTIONS(254),
    [anon_sym_typedef] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_var] = ACTIONS(254),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(254),
    [anon_sym_catch] = ACTIONS(254),
    [anon_sym_continue] = ACTIONS(254),
    [anon_sym_do] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(254),
    [anon_sym_extern] = ACTIONS(254),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_inline] = ACTIONS(254),
    [anon_sym_macro] = ACTIONS(254),
    [anon_sym_operator] = ACTIONS(254),
    [anon_sym_overload] = ACTIONS(254),
    [anon_sym_override] = ACTIONS(254),
    [anon_sym_private] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(254),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_try] = ACTIONS(254),
    [anon_sym_untyped] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [sym__semicolon] = ACTIONS(252),
  },
  [395] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(258),
    [anon_sym_using] = ACTIONS(258),
    [anon_sym_throw] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_cast] = ACTIONS(258),
    [anon_sym_in] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(258),
    [anon_sym_AT_COLON] = ACTIONS(256),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_else] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(258),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(258),
    [anon_sym_final] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(258),
    [anon_sym_class] = ACTIONS(258),
    [anon_sym_extends] = ACTIONS(258),
    [anon_sym_implements] = ACTIONS(258),
    [anon_sym_interface] = ACTIONS(258),
    [anon_sym_typedef] = ACTIONS(258),
    [anon_sym_function] = ACTIONS(258),
    [anon_sym_var] = ACTIONS(258),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_catch] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_inline] = ACTIONS(258),
    [anon_sym_macro] = ACTIONS(258),
    [anon_sym_operator] = ACTIONS(258),
    [anon_sym_overload] = ACTIONS(258),
    [anon_sym_override] = ACTIONS(258),
    [anon_sym_private] = ACTIONS(258),
    [anon_sym_public] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_untyped] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [sym__semicolon] = ACTIONS(256),
  },
  [396] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_using] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_cast] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_AT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_new] = ACTIONS(306),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(306),
    [anon_sym_final] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_extends] = ACTIONS(306),
    [anon_sym_implements] = ACTIONS(306),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_typedef] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(306),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_catch] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_extern] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_inline] = ACTIONS(306),
    [anon_sym_macro] = ACTIONS(306),
    [anon_sym_operator] = ACTIONS(306),
    [anon_sym_overload] = ACTIONS(306),
    [anon_sym_override] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_untyped] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [sym__semicolon] = ACTIONS(304),
  },
  [397] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(310),
    [anon_sym_import] = ACTIONS(310),
    [anon_sym_using] = ACTIONS(310),
    [anon_sym_throw] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_switch] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(310),
    [anon_sym_default] = ACTIONS(310),
    [anon_sym_cast] = ACTIONS(310),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_AT_COLON] = ACTIONS(308),
    [anon_sym_if] = ACTIONS(310),
    [anon_sym_else] = ACTIONS(310),
    [anon_sym_new] = ACTIONS(310),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(310),
    [anon_sym_final] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_class] = ACTIONS(310),
    [anon_sym_extends] = ACTIONS(310),
    [anon_sym_implements] = ACTIONS(310),
    [anon_sym_interface] = ACTIONS(310),
    [anon_sym_typedef] = ACTIONS(310),
    [anon_sym_function] = ACTIONS(310),
    [anon_sym_var] = ACTIONS(310),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(310),
    [anon_sym_catch] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(310),
    [anon_sym_enum] = ACTIONS(310),
    [anon_sym_extern] = ACTIONS(310),
    [anon_sym_for] = ACTIONS(310),
    [anon_sym_inline] = ACTIONS(310),
    [anon_sym_macro] = ACTIONS(310),
    [anon_sym_operator] = ACTIONS(310),
    [anon_sym_overload] = ACTIONS(310),
    [anon_sym_override] = ACTIONS(310),
    [anon_sym_private] = ACTIONS(310),
    [anon_sym_public] = ACTIONS(310),
    [anon_sym_return] = ACTIONS(310),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_try] = ACTIONS(310),
    [anon_sym_untyped] = ACTIONS(310),
    [anon_sym_while] = ACTIONS(310),
    [sym__semicolon] = ACTIONS(308),
  },
  [398] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(262),
    [anon_sym_using] = ACTIONS(262),
    [anon_sym_throw] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_switch] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(262),
    [anon_sym_default] = ACTIONS(262),
    [anon_sym_cast] = ACTIONS(262),
    [anon_sym_in] = ACTIONS(262),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_AT_COLON] = ACTIONS(260),
    [anon_sym_if] = ACTIONS(262),
    [anon_sym_else] = ACTIONS(262),
    [anon_sym_new] = ACTIONS(262),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(262),
    [anon_sym_final] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(262),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_extends] = ACTIONS(262),
    [anon_sym_implements] = ACTIONS(262),
    [anon_sym_interface] = ACTIONS(262),
    [anon_sym_typedef] = ACTIONS(262),
    [anon_sym_function] = ACTIONS(262),
    [anon_sym_var] = ACTIONS(262),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(262),
    [anon_sym_catch] = ACTIONS(262),
    [anon_sym_continue] = ACTIONS(262),
    [anon_sym_do] = ACTIONS(262),
    [anon_sym_enum] = ACTIONS(262),
    [anon_sym_extern] = ACTIONS(262),
    [anon_sym_for] = ACTIONS(262),
    [anon_sym_inline] = ACTIONS(262),
    [anon_sym_macro] = ACTIONS(262),
    [anon_sym_operator] = ACTIONS(262),
    [anon_sym_overload] = ACTIONS(262),
    [anon_sym_override] = ACTIONS(262),
    [anon_sym_private] = ACTIONS(262),
    [anon_sym_public] = ACTIONS(262),
    [anon_sym_return] = ACTIONS(262),
    [anon_sym_static] = ACTIONS(262),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_untyped] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(262),
    [sym__semicolon] = ACTIONS(260),
  },
  [399] = {
    [sym__rhs_expression] = STATE(1320),
    [sym_member_expression] = STATE(961),
    [sym__lhs_expression] = STATE(1059),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(1320),
    [sym__literal] = STATE(1094),
    [sym_integer] = STATE(1094),
    [sym_float] = STATE(1094),
    [sym_bool] = STATE(1094),
    [sym_string] = STATE(1120),
    [sym_null] = STATE(1094),
    [sym_array] = STATE(1094),
    [sym_map] = STATE(1094),
    [sym_object] = STATE(1094),
    [sym_pair] = STATE(1094),
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym__] = ACTIONS(1735),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1737),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [400] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(72),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [aux_sym_member_expression_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_package] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(269),
    [anon_sym_using] = ACTIONS(269),
    [anon_sym_throw] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(264),
    [anon_sym_switch] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_cast] = ACTIONS(269),
    [anon_sym_in] = ACTIONS(269),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_this] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(269),
    [anon_sym_AT_COLON] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(269),
    [anon_sym_null] = ACTIONS(280),
    [anon_sym_dynamic] = ACTIONS(269),
    [anon_sym_final] = ACTIONS(269),
    [anon_sym_abstract] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(269),
    [anon_sym_extends] = ACTIONS(269),
    [anon_sym_implements] = ACTIONS(269),
    [anon_sym_interface] = ACTIONS(269),
    [anon_sym_typedef] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(269),
    [anon_sym_var] = ACTIONS(269),
    [aux_sym_integer_token1] = ACTIONS(283),
    [aux_sym_integer_token2] = ACTIONS(286),
    [aux_sym_float_token1] = ACTIONS(289),
    [aux_sym_float_token2] = ACTIONS(292),
    [anon_sym_true] = ACTIONS(295),
    [anon_sym_false] = ACTIONS(295),
    [aux_sym_string_token1] = ACTIONS(298),
    [aux_sym_string_token3] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(269),
    [anon_sym_catch] = ACTIONS(269),
    [anon_sym_continue] = ACTIONS(269),
    [anon_sym_do] = ACTIONS(269),
    [anon_sym_enum] = ACTIONS(269),
    [anon_sym_extern] = ACTIONS(269),
    [anon_sym_for] = ACTIONS(269),
    [anon_sym_inline] = ACTIONS(269),
    [anon_sym_macro] = ACTIONS(269),
    [anon_sym_operator] = ACTIONS(269),
    [anon_sym_overload] = ACTIONS(269),
    [anon_sym_override] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_return] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(269),
    [anon_sym_untyped] = ACTIONS(269),
    [anon_sym_while] = ACTIONS(269),
    [sym__semicolon] = ACTIONS(264),
  },
  [401] = {
    [sym__rhs_expression] = STATE(55),
    [sym_member_expression] = STATE(80),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(55),
    [sym__literal] = STATE(123),
    [sym_integer] = STATE(123),
    [sym_float] = STATE(123),
    [sym_bool] = STATE(123),
    [sym_string] = STATE(105),
    [sym_null] = STATE(123),
    [sym_array] = STATE(123),
    [sym_map] = STATE(123),
    [sym_object] = STATE(123),
    [sym_pair] = STATE(123),
    [sym_identifier] = ACTIONS(1745),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [402] = {
    [sym_identifier] = ACTIONS(426),
    [anon_sym_package] = ACTIONS(426),
    [anon_sym_import] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(426),
    [anon_sym_throw] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_RPAREN] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(426),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_case] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(424),
    [anon_sym_default] = ACTIONS(426),
    [anon_sym_cast] = ACTIONS(426),
    [anon_sym_COMMA] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_RBRACK] = ACTIONS(424),
    [anon_sym_this] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(424),
    [anon_sym_DASH_GT] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_AT_COLON] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(424),
    [anon_sym_EQ] = ACTIONS(424),
    [anon_sym_null] = ACTIONS(426),
    [anon_sym_dynamic] = ACTIONS(426),
    [anon_sym_final] = ACTIONS(426),
    [anon_sym_abstract] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(426),
    [anon_sym_extends] = ACTIONS(426),
    [anon_sym_implements] = ACTIONS(426),
    [anon_sym_interface] = ACTIONS(426),
    [anon_sym_typedef] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [aux_sym_integer_token1] = ACTIONS(426),
    [aux_sym_integer_token2] = ACTIONS(424),
    [aux_sym_float_token1] = ACTIONS(426),
    [aux_sym_float_token2] = ACTIONS(424),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [aux_sym_string_token1] = ACTIONS(424),
    [aux_sym_string_token3] = ACTIONS(424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_enum] = ACTIONS(426),
    [anon_sym_extern] = ACTIONS(426),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_inline] = ACTIONS(426),
    [anon_sym_macro] = ACTIONS(426),
    [anon_sym_operator] = ACTIONS(426),
    [anon_sym_overload] = ACTIONS(426),
    [anon_sym_override] = ACTIONS(426),
    [anon_sym_private] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_untyped] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [sym__semicolon] = ACTIONS(424),
  },
  [403] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(96),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [404] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(991),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [405] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(521),
    [sym__literal] = STATE(1162),
    [sym_integer] = STATE(1162),
    [sym_float] = STATE(1162),
    [sym_bool] = STATE(1162),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1162),
    [sym_array] = STATE(1162),
    [sym_map] = STATE(1162),
    [sym_object] = STATE(1162),
    [sym_pair] = STATE(1162),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1755),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [406] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1092),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(1757),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [407] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1267),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [408] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1100),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(1759),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [409] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1176),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [410] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(522),
    [sym__literal] = STATE(1162),
    [sym_integer] = STATE(1162),
    [sym_float] = STATE(1162),
    [sym_bool] = STATE(1162),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1162),
    [sym_array] = STATE(1162),
    [sym_map] = STATE(1162),
    [sym_object] = STATE(1162),
    [sym_pair] = STATE(1162),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1755),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(1761),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [411] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(522),
    [sym__literal] = STATE(1162),
    [sym_integer] = STATE(1162),
    [sym_float] = STATE(1162),
    [sym_bool] = STATE(1162),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1162),
    [sym_array] = STATE(1162),
    [sym_map] = STATE(1162),
    [sym_object] = STATE(1162),
    [sym_pair] = STATE(1162),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1755),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [412] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(504),
    [sym__literal] = STATE(1162),
    [sym_integer] = STATE(1162),
    [sym_float] = STATE(1162),
    [sym_bool] = STATE(1162),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1162),
    [sym_array] = STATE(1162),
    [sym_map] = STATE(1162),
    [sym_object] = STATE(1162),
    [sym_pair] = STATE(1162),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1755),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [413] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1109),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(1763),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [414] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1292),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [415] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1184),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [416] = {
    [sym_member_expression] = STATE(60),
    [sym__lhs_expression] = STATE(504),
    [sym__literal] = STATE(1162),
    [sym_integer] = STATE(1162),
    [sym_float] = STATE(1162),
    [sym_bool] = STATE(1162),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1162),
    [sym_array] = STATE(1162),
    [sym_map] = STATE(1162),
    [sym_object] = STATE(1162),
    [sym_pair] = STATE(1162),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1755),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(1765),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(1767),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [417] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1011),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [418] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(985),
    [sym__literal] = STATE(1133),
    [sym_integer] = STATE(1133),
    [sym_float] = STATE(1133),
    [sym_bool] = STATE(1133),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1133),
    [sym_array] = STATE(1133),
    [sym_map] = STATE(1133),
    [sym_object] = STATE(1133),
    [sym_pair] = STATE(1133),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [419] = {
    [sym_member_expression] = STATE(402),
    [sym__lhs_expression] = STATE(1276),
    [sym__literal] = STATE(1139),
    [sym_integer] = STATE(1139),
    [sym_float] = STATE(1139),
    [sym_bool] = STATE(1139),
    [sym_string] = STATE(975),
    [sym_null] = STATE(1139),
    [sym_array] = STATE(1139),
    [sym_map] = STATE(1139),
    [sym_object] = STATE(1139),
    [sym_pair] = STATE(1139),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_package] = ACTIONS(228),
    [anon_sym_import] = ACTIONS(228),
    [anon_sym_using] = ACTIONS(228),
    [anon_sym_throw] = ACTIONS(228),
    [anon_sym_switch] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_case] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(228),
    [anon_sym_cast] = ACTIONS(228),
    [anon_sym_in] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(228),
    [anon_sym_else] = ACTIONS(228),
    [anon_sym_new] = ACTIONS(228),
    [anon_sym_null] = ACTIONS(59),
    [anon_sym_dynamic] = ACTIONS(228),
    [anon_sym_final] = ACTIONS(228),
    [anon_sym_abstract] = ACTIONS(228),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_extends] = ACTIONS(228),
    [anon_sym_implements] = ACTIONS(228),
    [anon_sym_interface] = ACTIONS(228),
    [anon_sym_typedef] = ACTIONS(228),
    [anon_sym_function] = ACTIONS(228),
    [anon_sym_var] = ACTIONS(228),
    [aux_sym_integer_token1] = ACTIONS(75),
    [aux_sym_integer_token2] = ACTIONS(77),
    [aux_sym_float_token1] = ACTIONS(79),
    [aux_sym_float_token2] = ACTIONS(81),
    [anon_sym_true] = ACTIONS(83),
    [anon_sym_false] = ACTIONS(83),
    [aux_sym_string_token1] = ACTIONS(85),
    [aux_sym_string_token3] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(228),
    [anon_sym_catch] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(228),
    [anon_sym_enum] = ACTIONS(228),
    [anon_sym_extern] = ACTIONS(228),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_inline] = ACTIONS(228),
    [anon_sym_macro] = ACTIONS(228),
    [anon_sym_operator] = ACTIONS(228),
    [anon_sym_overload] = ACTIONS(228),
    [anon_sym_override] = ACTIONS(228),
    [anon_sym_private] = ACTIONS(228),
    [anon_sym_public] = ACTIONS(228),
    [anon_sym_return] = ACTIONS(228),
    [anon_sym_static] = ACTIONS(228),
    [anon_sym_try] = ACTIONS(228),
    [anon_sym_untyped] = ACTIONS(228),
    [anon_sym_while] = ACTIONS(228),
  },
  [420] = {
    [sym__rhs_expression] = STATE(61),
    [sym_member_expression] = STATE(80),
    [sym__lhs_expression] = STATE(1054),
    [sym__call] = STATE(91),
    [sym__constructor_call] = STATE(89),
    [sym_call_expression] = STATE(61),
    [sym__literal] = STATE(465),
    [sym_integer] = STATE(465),
    [sym_float] = STATE(465),
    [sym_bool] = STATE(465),
    [sym_string] = STATE(462),
    [sym_null] = STATE(465),
    [sym_array] = STATE(465),
    [sym_map] = STATE(465),
    [sym_object] = STATE(465),
    [sym_pair] = STATE(465),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_RPAREN] = ACTIONS(240),
    [anon_sym_switch] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_cast] = ACTIONS(242),
    [anon_sym_DOLLARtype] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_this] = ACTIONS(242),
    [anon_sym_DOT] = ACTIONS(242),
    [anon_sym_QMARK] = ACTIONS(242),
    [anon_sym_new] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_PERCENT] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_SLASH] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_LT_LT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(242),
    [anon_sym_GT_GT_GT] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_EQ_EQ] = ACTIONS(240),
    [anon_sym_BANG_EQ] = ACTIONS(240),
    [anon_sym_LT] = ACTIONS(242),
    [anon_sym_LT_EQ] = ACTIONS(240),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_GT_EQ] = ACTIONS(240),
    [anon_sym_EQ_GT] = ACTIONS(240),
    [anon_sym_QMARK_QMARK] = ACTIONS(240),
    [anon_sym_EQ] = ACTIONS(242),
    [sym__rangeOperator] = ACTIONS(240),
    [anon_sym_null] = ACTIONS(242),
    [aux_sym_integer_token1] = ACTIONS(242),
    [aux_sym_integer_token2] = ACTIONS(240),
    [aux_sym_float_token1] = ACTIONS(242),
    [aux_sym_float_token2] = ACTIONS(240),
    [anon_sym_true] = ACTIONS(242),
    [anon_sym_false] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(240),
    [aux_sym_string_token3] = ACTIONS(240),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(262), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(260), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [105] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(1771), 1,
      sym_identifier,
    ACTIONS(1774), 1,
      anon_sym_this,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(269), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(264), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [210] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1777), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(694), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(242), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(240), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [321] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(258), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(256), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [426] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(254), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(252), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [531] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(248), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(244), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [636] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(310), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(308), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [741] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(422), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(306), 15,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(304), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(464), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(242), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(240), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOT,
    ACTIONS(1781), 1,
      anon_sym_QMARK,
    ACTIONS(428), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(424), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_AT_COLON,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
    ACTIONS(426), 49,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_in,
      anon_sym_this,
      anon_sym_AT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_null,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
      sym_identifier,
  [1006] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(420), 1,
      sym_operator,
    STATE(435), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(320), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(322), 12,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1089] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(708), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(707), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(242), 13,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(240), 19,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1196] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(433), 1,
      aux_sym_expression_repeat1,
    STATE(799), 1,
      sym_operator,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(340), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
    ACTIONS(342), 12,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
  [1285] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1783), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(751), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(242), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(240), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1394] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(433), 1,
      aux_sym_expression_repeat1,
    STATE(799), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(336), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
    ACTIONS(338), 12,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
  [1483] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1785), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(782), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(779), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(242), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(240), 18,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1591] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(437), 1,
      aux_sym_expression_repeat1,
    STATE(794), 1,
      sym_operator,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(340), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(342), 10,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(437), 1,
      aux_sym_expression_repeat1,
    STATE(794), 1,
      sym_operator,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(1787), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(1578), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [1753] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(429), 1,
      sym_operator,
    STATE(438), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1791), 9,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    ACTIONS(1789), 10,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1834] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(306), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(304), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [1933] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1798), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(269), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(264), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2032] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(262), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(260), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2131] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(310), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(308), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2230] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(254), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(252), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2329] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(248), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(244), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2428] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(441), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(258), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(256), 19,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [2527] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(258), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(256), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [2625] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(254), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(252), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [2723] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(262), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(260), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [2821] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(1801), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(269), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(264), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [2919] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(306), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(304), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [3017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(310), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(308), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [3115] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(450), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(248), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(244), 20,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [3213] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(464), 1,
      anon_sym_DOT,
    ACTIONS(466), 1,
      anon_sym_QMARK,
    ACTIONS(592), 1,
      anon_sym_in,
    ACTIONS(1807), 1,
      anon_sym_COLON,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(424), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 22,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3289] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(592), 1,
      anon_sym_in,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(424), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 22,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_COLON,
    ACTIONS(426), 22,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_DASH_GT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(424), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
    ACTIONS(508), 21,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 23,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3489] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(592), 1,
      anon_sym_in,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(1815), 1,
      anon_sym_COLON,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 23,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3563] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(592), 1,
      anon_sym_in,
    ACTIONS(1809), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 23,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3635] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(592), 1,
      anon_sym_in,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 23,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3707] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 24,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 1,
      anon_sym_COLON,
    ACTIONS(588), 22,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(586), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3833] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 19,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 24,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_DOT,
    ACTIONS(662), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [3962] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    ACTIONS(614), 1,
      anon_sym_QMARK,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [4024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(1817), 1,
      anon_sym_DOT,
    ACTIONS(1819), 1,
      anon_sym_QMARK,
    ACTIONS(508), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [4086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 1,
      anon_sym_EQ_GT,
    ACTIONS(1821), 1,
      anon_sym_DOT,
    ACTIONS(1823), 1,
      anon_sym_QMARK,
    ACTIONS(508), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(506), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [4148] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_in,
    ACTIONS(39), 1,
      anon_sym_AT,
    ACTIONS(41), 1,
      anon_sym_AT_COLON,
    ACTIONS(1827), 1,
      anon_sym_final,
    ACTIONS(1829), 1,
      anon_sym_abstract,
    ACTIONS(1831), 1,
      anon_sym_class,
    ACTIONS(1833), 1,
      anon_sym_typedef,
    ACTIONS(1835), 1,
      anon_sym_function,
    ACTIONS(1837), 1,
      anon_sym_var,
    STATE(470), 2,
      sym_metadata,
      aux_sym_class_declaration_repeat1,
    STATE(483), 2,
      sym_keyword,
      aux_sym_function_declaration_repeat1,
    ACTIONS(1825), 35,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [4224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(1789), 20,
      anon_sym_switch,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_new,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(1791), 25,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_DOLLARtype,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [4280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_in,
    ACTIONS(1843), 1,
      anon_sym_AT,
    ACTIONS(1846), 1,
      anon_sym_AT_COLON,
    STATE(470), 2,
      sym_metadata,
      aux_sym_class_declaration_repeat1,
    ACTIONS(1839), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [4340] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(423), 1,
      sym_operator,
    STATE(473), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(320), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(472), 1,
      aux_sym_expression_repeat1,
    STATE(805), 1,
      sym_operator,
    ACTIONS(342), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(340), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4488] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(472), 1,
      aux_sym_expression_repeat1,
    STATE(805), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(338), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(336), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(423), 1,
      sym_operator,
    STATE(473), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(320), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 1,
      sym_identifier,
    ACTIONS(1857), 1,
      anon_sym_LPAREN,
    STATE(77), 1,
      sym__parenthesized_expression,
    ACTIONS(228), 42,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_in,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [4687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 1,
      anon_sym_DOT,
    ACTIONS(1861), 1,
      anon_sym_QMARK,
    ACTIONS(426), 17,
      anon_sym_this,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 26,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [4744] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(477), 1,
      aux_sym_expression_repeat1,
    STATE(778), 1,
      sym_operator,
    ACTIONS(342), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(340), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4817] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(432), 1,
      sym_operator,
    STATE(480), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(320), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [4884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 1,
      anon_sym_LPAREN,
    ACTIONS(1867), 2,
      anon_sym_in,
      anon_sym_AT,
    ACTIONS(1863), 42,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_AT_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [4939] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(477), 1,
      aux_sym_expression_repeat1,
    STATE(778), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(338), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(336), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5012] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(432), 1,
      sym_operator,
    STATE(480), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(320), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5085] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1869), 1,
      sym_identifier,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1873), 1,
      anon_sym_RBRACK,
    STATE(517), 1,
      aux_sym_expression_repeat1,
    STATE(796), 1,
      sym_operator,
    STATE(1129), 1,
      aux_sym_array_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_in,
    ACTIONS(1877), 1,
      anon_sym_function,
    ACTIONS(1875), 2,
      anon_sym_final,
      anon_sym_var,
    STATE(498), 2,
      sym_keyword,
      aux_sym_function_declaration_repeat1,
    ACTIONS(1825), 38,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [5219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 2,
      anon_sym_in,
      anon_sym_AT,
    ACTIONS(1879), 42,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_AT_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [5271] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1883), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    STATE(487), 1,
      aux_sym_expression_repeat1,
    STATE(713), 1,
      sym_operator,
    STATE(1137), 1,
      aux_sym_array_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5347] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(489), 1,
      aux_sym_expression_repeat1,
    STATE(787), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(336), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(338), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5419] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(1889), 1,
      anon_sym_RBRACK,
    STATE(517), 1,
      aux_sym_expression_repeat1,
    STATE(796), 1,
      sym_operator,
    STATE(1155), 1,
      aux_sym_array_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    ACTIONS(1895), 1,
      anon_sym_QMARK,
    ACTIONS(1891), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [5551] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(489), 1,
      aux_sym_expression_repeat1,
    STATE(787), 1,
      sym_operator,
    ACTIONS(340), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(342), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    STATE(136), 1,
      sym__arg_list,
    ACTIONS(1891), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [5679] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(434), 1,
      sym_operator,
    STATE(486), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(320), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 19,
      anon_sym_this,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 25,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [5797] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(340), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_in,
    ACTIONS(1835), 1,
      anon_sym_function,
    ACTIONS(1837), 2,
      anon_sym_final,
      anon_sym_var,
    STATE(498), 2,
      sym_keyword,
      aux_sym_function_declaration_repeat1,
    ACTIONS(1825), 38,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [5925] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(434), 1,
      sym_operator,
    STATE(486), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(320), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [5997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 2,
      anon_sym_in,
      anon_sym_AT,
    ACTIONS(1899), 42,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_AT_COLON,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [6049] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1903), 1,
      sym_identifier,
    ACTIONS(1905), 1,
      anon_sym_RBRACK,
    STATE(482), 1,
      aux_sym_expression_repeat1,
    STATE(713), 1,
      sym_operator,
    STATE(1186), 1,
      aux_sym_array_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_in,
    STATE(498), 2,
      sym_keyword,
      aux_sym_function_declaration_repeat1,
    ACTIONS(1907), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [6179] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1913), 1,
      anon_sym_RPAREN,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    STATE(1187), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6252] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1917), 1,
      anon_sym_RPAREN,
    ACTIONS(1919), 1,
      sym__semicolon,
    STATE(382), 1,
      sym_operator,
    STATE(532), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1921), 1,
      anon_sym_RPAREN,
    ACTIONS(1923), 1,
      sym__semicolon,
    STATE(386), 1,
      sym_operator,
    STATE(534), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6386] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1925), 1,
      anon_sym_RPAREN,
    ACTIONS(1927), 1,
      sym__semicolon,
    STATE(368), 1,
      sym_operator,
    STATE(537), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6453] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1929), 1,
      anon_sym_RPAREN,
    STATE(515), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    STATE(1132), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6526] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    ACTIONS(1933), 1,
      anon_sym_COLON,
    ACTIONS(1935), 1,
      sym__semicolon,
    STATE(390), 1,
      sym_operator,
    STATE(572), 1,
      sym_access_identifiers,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6593] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1937), 1,
      anon_sym_RPAREN,
    ACTIONS(1939), 1,
      sym__semicolon,
    STATE(391), 1,
      sym_operator,
    STATE(531), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1941), 1,
      anon_sym_RPAREN,
    ACTIONS(1943), 1,
      sym__semicolon,
    STATE(387), 1,
      sym_operator,
    STATE(526), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6727] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1945), 1,
      anon_sym_RPAREN,
    ACTIONS(1947), 1,
      sym__semicolon,
    STATE(388), 1,
      sym_operator,
    STATE(528), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6794] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(336), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1949), 1,
      anon_sym_COLON,
    ACTIONS(1891), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [6916] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    STATE(519), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    STATE(1134), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [6989] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_COLON,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(436), 1,
      sym_operator,
    STATE(514), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7060] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_COLON,
    ACTIONS(324), 1,
      anon_sym_DASH,
    STATE(436), 1,
      sym_operator,
    STATE(514), 1,
      aux_sym_expression_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(322), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7125] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    STATE(499), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    STATE(1131), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7198] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(336), 1,
      anon_sym_COLON,
    STATE(523), 1,
      aux_sym_expression_repeat1,
    STATE(795), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(338), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7269] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1955), 1,
      anon_sym_RPAREN,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    STATE(1136), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7342] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1957), 1,
      anon_sym_RPAREN,
    ACTIONS(1959), 1,
      sym__semicolon,
    STATE(353), 1,
      sym_operator,
    STATE(540), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7409] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(517), 1,
      aux_sym_expression_repeat1,
    STATE(796), 1,
      sym_operator,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(340), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7478] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1961), 1,
      anon_sym_RPAREN,
    ACTIONS(1963), 1,
      sym__semicolon,
    STATE(362), 1,
      sym_operator,
    STATE(527), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7545] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_RPAREN,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    STATE(1181), 1,
      aux_sym__arg_list_repeat1,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(671), 1,
      anon_sym_DASH_GT,
    ACTIONS(1967), 1,
      anon_sym_RPAREN,
    ACTIONS(1969), 1,
      sym__semicolon,
    STATE(356), 1,
      sym_operator,
    STATE(542), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7685] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    ACTIONS(1971), 1,
      anon_sym_COLON,
    ACTIONS(1973), 1,
      sym__semicolon,
    STATE(351), 1,
      sym_operator,
    STATE(573), 1,
      sym_access_identifiers,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    ACTIONS(1975), 1,
      anon_sym_COLON,
    ACTIONS(1977), 1,
      sym__semicolon,
    STATE(365), 1,
      sym_operator,
    STATE(563), 1,
      sym_access_identifiers,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7819] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(340), 1,
      anon_sym_COLON,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(523), 1,
      aux_sym_expression_repeat1,
    STATE(795), 1,
      sym_operator,
    ACTIONS(342), 2,
      anon_sym_DOT,
      anon_sym_QMARK,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7890] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(508), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(320), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [7959] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(533), 1,
      aux_sym_expression_repeat1,
    STATE(816), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(336), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8027] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1981), 1,
      sym__semicolon,
    STATE(358), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8091] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1983), 1,
      sym__semicolon,
    STATE(384), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8155] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1985), 1,
      sym__semicolon,
    STATE(364), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1891), 41,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_class,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [8269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1987), 1,
      anon_sym_class,
    ACTIONS(1891), 40,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [8321] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1989), 1,
      sym__semicolon,
    STATE(355), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8385] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1991), 1,
      sym__semicolon,
    STATE(381), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8449] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(350), 1,
      anon_sym_DASH,
    STATE(533), 1,
      aux_sym_expression_repeat1,
    STATE(816), 1,
      sym_operator,
    ACTIONS(340), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(353), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(347), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(356), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(359), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(344), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8517] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1993), 1,
      sym__semicolon,
    STATE(380), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8581] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1995), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(228), 1,
      anon_sym_in,
    ACTIONS(1997), 1,
      anon_sym_class,
    ACTIONS(1891), 40,
      anon_sym_package,
      anon_sym_import,
      anon_sym_using,
      anon_sym_throw,
      anon_sym_switch,
      anon_sym_case,
      anon_sym_default,
      anon_sym_cast,
      anon_sym_this,
      anon_sym_if,
      anon_sym_else,
      anon_sym_new,
      anon_sym_dynamic,
      anon_sym_final,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_interface,
      anon_sym_typedef,
      anon_sym_function,
      anon_sym_var,
      anon_sym_break,
      anon_sym_catch,
      anon_sym_continue,
      anon_sym_do,
      anon_sym_enum,
      anon_sym_extern,
      anon_sym_for,
      anon_sym_inline,
      anon_sym_macro,
      anon_sym_operator,
      anon_sym_overload,
      anon_sym_override,
      anon_sym_private,
      anon_sym_public,
      anon_sym_return,
      anon_sym_static,
      anon_sym_try,
      anon_sym_untyped,
      anon_sym_while,
  [8701] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(1999), 1,
      sym__semicolon,
    STATE(370), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8765] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(539), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2001), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8833] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2003), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(2005), 1,
      sym__semicolon,
    STATE(371), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [8965] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    STATE(535), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(1979), 1,
      anon_sym_RPAREN,
    ACTIONS(2009), 1,
      sym__semicolon,
    STATE(389), 1,
      sym_operator,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9097] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 1,
      anon_sym_DASH,
    STATE(525), 1,
      aux_sym_expression_repeat1,
    STATE(696), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(320), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(933), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1851), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(1853), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9165] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2011), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9232] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2013), 1,
      sym__semicolon,
    STATE(560), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9299] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2015), 1,
      sym__semicolon,
    STATE(554), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9366] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2017), 1,
      sym__semicolon,
    STATE(555), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2017), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9500] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2019), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9567] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2021), 1,
      sym__semicolon,
    STATE(569), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9634] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2023), 1,
      anon_sym_RBRACK,
    STATE(595), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9701] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2025), 1,
      sym__semicolon,
    STATE(601), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9768] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2027), 1,
      anon_sym_RBRACE,
    STATE(591), 1,
      aux_sym_expression_repeat1,
    STATE(696), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9835] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2029), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9902] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2031), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [9969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2033), 1,
      anon_sym_RPAREN,
    STATE(558), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10036] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2021), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10103] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2035), 1,
      anon_sym_RPAREN,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10170] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2037), 1,
      sym__semicolon,
    STATE(566), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10237] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2039), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10304] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2029), 1,
      sym__semicolon,
    STATE(590), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10371] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2041), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10438] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(2043), 1,
      anon_sym_COLON,
    ACTIONS(2045), 1,
      sym__semicolon,
    STATE(357), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10499] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2047), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10566] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2049), 1,
      sym__semicolon,
    STATE(544), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10633] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2051), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10700] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2051), 1,
      sym__semicolon,
    STATE(549), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10767] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2049), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10834] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2053), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10901] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2055), 1,
      sym__semicolon,
    STATE(548), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [10968] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2057), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11035] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(2059), 1,
      anon_sym_COLON,
    ACTIONS(2061), 1,
      sym__semicolon,
    STATE(352), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(324), 1,
      anon_sym_DASH,
    ACTIONS(2063), 1,
      anon_sym_COLON,
    ACTIONS(2065), 1,
      sym__semicolon,
    STATE(378), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(49), 9,
      anon_sym_BANG,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    STATE(88), 11,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 15,
      anon_sym_TILDE,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11157] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2039), 1,
      sym__semicolon,
    STATE(562), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2067), 1,
      sym__semicolon,
    STATE(602), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11291] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2069), 1,
      sym__semicolon,
    STATE(557), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11358] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2071), 1,
      sym__semicolon,
    STATE(564), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11425] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2073), 1,
      sym__semicolon,
    STATE(571), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2073), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11559] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2075), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11626] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2077), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11693] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2079), 1,
      sym__semicolon,
    STATE(579), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11760] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2067), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11827] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2081), 1,
      sym__semicolon,
    STATE(580), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11894] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2081), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [11961] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2083), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12028] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2085), 1,
      sym__semicolon,
    STATE(581), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12095] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2085), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12162] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2087), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12229] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2089), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12296] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2091), 1,
      anon_sym_RBRACE,
    STATE(533), 1,
      aux_sym_expression_repeat1,
    STATE(816), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12363] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2093), 1,
      sym__semicolon,
    STATE(583), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12430] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2095), 1,
      sym__semicolon,
    STATE(568), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12497] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2097), 1,
      anon_sym_RBRACK,
    STATE(596), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12564] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2099), 1,
      anon_sym_RBRACK,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12631] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2101), 1,
      anon_sym_RBRACK,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12698] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2047), 1,
      sym__semicolon,
    STATE(589), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12765] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2103), 1,
      sym__semicolon,
    STATE(585), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12832] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2105), 1,
      sym__semicolon,
    STATE(588), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12899] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2107), 1,
      sym__semicolon,
    STATE(586), 1,
      aux_sym_expression_repeat1,
    STATE(632), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [12966] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2107), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [13033] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_DASH,
    ACTIONS(2109), 1,
      sym__semicolon,
    STATE(493), 1,
      aux_sym_expression_repeat1,
    STATE(797), 1,
      sym_operator,
    ACTIONS(53), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(952), 2,
      sym__arithmeticOperator,
      sym__bitwiseOperator,
    ACTIONS(49), 4,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(55), 5,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
    ACTIONS(57), 5,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    STATE(88), 9,
      sym__unaryOperator,
      sym__prefixUnaryOperator,
      sym__postfixUnaryOperator,
      sym__binaryOperator,
      sym__logicalOperator,
      sym__comparisonOperator,
      sym__miscOperator,
      sym__assignmentOperator,
      sym__compoundAssignmentOperator,
    ACTIONS(47), 10,
      anon_sym_TILDE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [13100] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(254), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(252), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13180] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(310), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(308), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13260] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2111), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(269), 2,
      anon_sym_extends,
      anon_sym_implements,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(264), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13340] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(262), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(260), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13420] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(248), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(244), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13500] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(258), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(256), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13580] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(605), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(306), 2,
      anon_sym_extends,
      anon_sym_implements,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(304), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      sym__semicolon,
  [13660] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2117), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [13719] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2117), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [13778] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(260), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [13854] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 1,
      sym_identifier,
    ACTIONS(2128), 1,
      anon_sym_LPAREN,
    ACTIONS(2131), 1,
      anon_sym_RPAREN,
    ACTIONS(2133), 1,
      anon_sym_LBRACE,
    ACTIONS(2136), 1,
      anon_sym_LBRACK,
    ACTIONS(2139), 1,
      anon_sym_this,
    ACTIONS(2145), 1,
      anon_sym_null,
    ACTIONS(2148), 1,
      aux_sym_integer_token1,
    ACTIONS(2151), 1,
      aux_sym_integer_token2,
    ACTIONS(2154), 1,
      aux_sym_float_token1,
    ACTIONS(2157), 1,
      aux_sym_float_token2,
    ACTIONS(2163), 1,
      aux_sym_string_token1,
    ACTIONS(2166), 1,
      aux_sym_string_token3,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1091), 1,
      sym_type,
    STATE(1282), 1,
      sym__function_type_args,
    ACTIONS(2160), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2142), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [13940] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2169), 1,
      sym_identifier,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    ACTIONS(2173), 1,
      anon_sym_RPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1080), 1,
      sym_type,
    STATE(1360), 1,
      sym__function_type_args,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [14026] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(256), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14102] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2131), 1,
      anon_sym_RPAREN,
    ACTIONS(2169), 1,
      sym_identifier,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1091), 1,
      sym_type,
    STATE(1282), 1,
      sym__function_type_args,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [14188] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(244), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14264] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2175), 1,
      sym_identifier,
    ACTIONS(2178), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(264), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14340] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(304), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14416] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(308), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14492] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(618), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
    ACTIONS(252), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      sym__semicolon,
  [14568] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(1811), 1,
      anon_sym_DOT,
    ACTIONS(1813), 1,
      anon_sym_QMARK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2117), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(424), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [14626] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2183), 1,
      anon_sym_in,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(506), 18,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [14684] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(602), 1,
      anon_sym_RPAREN,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2169), 1,
      sym_identifier,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1091), 1,
      sym_type,
    STATE(1309), 1,
      sym__function_type_args,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [14770] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(2183), 1,
      anon_sym_in,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(506), 18,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [14828] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(464), 1,
      anon_sym_DOT,
    ACTIONS(466), 1,
      anon_sym_QMARK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(424), 4,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [14886] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(507), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [14969] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(520), 1,
      sym_type,
    STATE(629), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15052] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(501), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15135] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2193), 1,
      anon_sym_LPAREN,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(988), 1,
      sym__lhs_expression,
    STATE(997), 1,
      sym_builtin_type,
    STATE(1033), 1,
      sym_type,
    STATE(1110), 1,
      sym_structure_type,
    STATE(1122), 1,
      sym_function_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15218] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [15275] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2197), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    ACTIONS(240), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      sym__semicolon,
    STATE(699), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15356] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(516), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(2117), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [15492] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(507), 1,
      sym_type,
    STATE(636), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15575] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(518), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15658] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [15715] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(506), 1,
      sym_type,
    STATE(641), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15798] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    STATE(101), 1,
      sym_member_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(132), 1,
      sym__lhs_expression,
    STATE(165), 1,
      sym_type,
    STATE(331), 1,
      sym_block,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15881] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    STATE(101), 1,
      sym_member_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(151), 1,
      sym__lhs_expression,
    STATE(159), 1,
      sym_type,
    STATE(200), 1,
      sym_block,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [15964] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(520), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16047] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(505), 1,
      sym_type,
    STATE(633), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16130] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    STATE(101), 1,
      sym_member_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(125), 1,
      sym__lhs_expression,
    STATE(168), 1,
      sym_type,
    STATE(242), 1,
      sym_block,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2117), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [16266] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    STATE(101), 1,
      sym_member_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(147), 1,
      sym__lhs_expression,
    STATE(161), 1,
      sym_type,
    STATE(308), 1,
      sym_block,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(516), 1,
      sym_type,
    STATE(647), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16432] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(502), 1,
      sym_type,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16515] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(500), 1,
      sym_type,
    STATE(627), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16598] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2193), 1,
      anon_sym_LPAREN,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(984), 1,
      sym__lhs_expression,
    STATE(997), 1,
      sym_builtin_type,
    STATE(1020), 1,
      sym_type,
    STATE(1055), 1,
      sym_structure_type,
    STATE(1122), 1,
      sym_function_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(153), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16761] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(149), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16841] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2193), 1,
      anon_sym_LPAREN,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(997), 1,
      sym_builtin_type,
    STATE(1009), 1,
      sym__lhs_expression,
    STATE(1048), 1,
      sym_type,
    STATE(1122), 1,
      sym_function_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [16921] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2193), 1,
      anon_sym_LPAREN,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(997), 1,
      sym_builtin_type,
    STATE(1009), 1,
      sym__lhs_expression,
    STATE(1046), 1,
      sym_type,
    STATE(1122), 1,
      sym_function_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2193), 1,
      anon_sym_LPAREN,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(997), 1,
      sym_builtin_type,
    STATE(1009), 1,
      sym__lhs_expression,
    STATE(1045), 1,
      sym_type,
    STATE(1122), 1,
      sym_function_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17081] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1105), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17161] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(139), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 19,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [17293] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(143), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17373] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(138), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17453] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(124), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17533] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(127), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(2181), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 19,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [17665] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    ACTIONS(2203), 1,
      sym_identifier,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1172), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17745] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(155), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17825] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(134), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17905] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(141), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [17985] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(131), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18065] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(130), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18145] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(129), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18225] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1040), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18305] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1197), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18385] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1037), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18465] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1041), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18545] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2171), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_function_type,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1008), 1,
      sym_builtin_type,
    STATE(1010), 1,
      sym__lhs_expression,
    STATE(1196), 1,
      sym_type,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(606), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_COLON,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [18669] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(144), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [18805] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    ACTIONS(2199), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_member_expression,
    STATE(115), 1,
      sym__lhs_expression,
    STATE(118), 1,
      sym_function_type,
    STATE(120), 1,
      sym_builtin_type,
    STATE(148), 1,
      sym_type,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2191), 5,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [18885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 11,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [18933] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(252), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19006] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(308), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19079] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(304), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19152] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2209), 1,
      sym_identifier,
    ACTIONS(2212), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(264), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19225] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(260), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(574), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(422), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(420), 21,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(462), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(460), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    ACTIONS(322), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(320), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19464] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(244), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19537] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(683), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(256), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(594), 1,
      anon_sym_DOT,
    ACTIONS(596), 1,
      anon_sym_QMARK,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [19661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_COLON,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19704] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(430), 1,
      anon_sym_DOT,
    ACTIONS(432), 1,
      anon_sym_QMARK,
    ACTIONS(2187), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [19755] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    ACTIONS(614), 1,
      anon_sym_QMARK,
    ACTIONS(2117), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [19802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(508), 11,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [19847] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2215), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    ACTIONS(240), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    STATE(764), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [19926] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2119), 1,
      anon_sym_in,
    ACTIONS(2219), 1,
      anon_sym_DOT,
    ACTIONS(2221), 1,
      anon_sym_QMARK,
    ACTIONS(2217), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [19981] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2225), 1,
      anon_sym_RBRACK,
    STATE(1175), 1,
      aux_sym_map_repeat1,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 18,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20028] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_DOT,
    ACTIONS(662), 1,
      anon_sym_QMARK,
    ACTIONS(2117), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [20075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2227), 1,
      anon_sym_RBRACK,
    STATE(1140), 1,
      aux_sym_map_repeat1,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 18,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20122] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(260), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [20194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(542), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(540), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(450), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(478), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(476), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(486), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(490), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    ACTIONS(614), 1,
      anon_sym_QMARK,
    ACTIONS(2181), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 19,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(342), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(340), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(502), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(510), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(242), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(240), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(534), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(532), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20640] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(242), 1,
      sym_identifier,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(240), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(708), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(724), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [20718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(434), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(570), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(448), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(446), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(530), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(528), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(418), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(416), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(566), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(494), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [20998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(442), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(564), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(562), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(544), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_DOT,
    ACTIONS(662), 1,
      anon_sym_QMARK,
    ACTIONS(2181), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 19,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(322), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(320), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(551), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(548), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(582), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(498), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(580), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(578), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(522), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(520), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(458), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(456), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(438), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21484] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(252), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [21556] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(308), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [21628] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(304), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [21700] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2233), 1,
      sym_identifier,
    ACTIONS(2236), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(264), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [21772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(560), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(558), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(556), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(554), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21852] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(244), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [21924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(468), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [21964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(414), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(412), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [22004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(402), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(400), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [22044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COLON,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [22086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(406), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(404), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [22126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(410), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(408), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym_identifier,
  [22166] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(736), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(256), 6,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22238] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1777), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(694), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22315] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2239), 1,
      sym_identifier,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(986), 1,
      sym_string,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(718), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1015), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22392] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 1,
      anon_sym_DOT,
    ACTIONS(1819), 1,
      anon_sym_QMARK,
    ACTIONS(2187), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [22437] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2243), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1021), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_DOT,
    ACTIONS(614), 1,
      anon_sym_QMARK,
    ACTIONS(2187), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [22559] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2207), 1,
      anon_sym_this,
    ACTIONS(2245), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1023), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22636] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(252), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22707] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(308), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22778] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2251), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(464), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22855] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2253), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(113), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [22932] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(304), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23003] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(2219), 1,
      anon_sym_DOT,
    ACTIONS(2221), 1,
      anon_sym_QMARK,
    ACTIONS(2217), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [23052] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2255), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(264), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23123] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(260), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23194] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    ACTIONS(2261), 1,
      sym_identifier,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(986), 1,
      sym_string,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(718), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(999), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23271] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2263), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(465), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23348] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(244), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23419] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 1,
      anon_sym_DOT,
    ACTIONS(662), 1,
      anon_sym_QMARK,
    ACTIONS(2187), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [23464] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(759), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(256), 5,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_EQ,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23535] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(1745), 1,
      sym_identifier,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(123), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23612] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(993), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23689] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1783), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(751), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_this,
    ACTIONS(2267), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1059), 1,
      sym__lhs_expression,
    STATE(1120), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1060), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1785), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(782), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(779), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23920] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2269), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1077), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [23997] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24074] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(2207), 1,
      anon_sym_this,
    ACTIONS(2273), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(55), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(994), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24151] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      sym_identifier,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(718), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(707), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24228] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1783), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(751), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24302] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2243), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1021), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24376] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(256), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(258), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24444] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2275), 1,
      sym_identifier,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(708), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(707), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24518] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_EQ_GT,
    ACTIONS(2291), 1,
      anon_sym_DOT,
    ACTIONS(2293), 1,
      anon_sym_QMARK,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 17,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [24562] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1777), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(694), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24636] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(1745), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(123), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_COLON,
    ACTIONS(588), 12,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(586), 17,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [24750] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2275), 1,
      sym_identifier,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(711), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(707), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24824] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(2253), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(113), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24898] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2269), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1077), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [24972] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2207), 1,
      anon_sym_this,
    ACTIONS(2273), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(994), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25046] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1783), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(751), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25120] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(304), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(306), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25188] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(2253), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(113), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 1,
      anon_sym_LT,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
    ACTIONS(508), 9,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 17,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [25306] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1785), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(782), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(779), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25380] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2231), 1,
      anon_sym_this,
    ACTIONS(2267), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1059), 1,
      sym__lhs_expression,
    STATE(1120), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1060), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25454] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2239), 1,
      sym_identifier,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(986), 1,
      sym_string,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(711), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1015), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25528] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(2251), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(464), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25602] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1785), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(782), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(779), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25676] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(2298), 1,
      sym_identifier,
    STATE(692), 1,
      sym_string,
    STATE(695), 1,
      sym_member_expression,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(708), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(724), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25750] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2197), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(699), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25824] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(244), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(248), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25892] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(2263), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(465), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [25966] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_new,
    ACTIONS(1671), 1,
      anon_sym_null,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    ACTIONS(1677), 1,
      aux_sym_float_token1,
    ACTIONS(1679), 1,
      aux_sym_float_token2,
    ACTIONS(1683), 1,
      aux_sym_string_token1,
    ACTIONS(1685), 1,
      aux_sym_string_token3,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2261), 1,
      sym_identifier,
    STATE(702), 1,
      sym__constructor_call,
    STATE(726), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(986), 1,
      sym_string,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(1681), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(711), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(999), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26040] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(2251), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(464), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26114] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(308), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(310), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26182] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(2263), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(462), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(465), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26256] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2123), 1,
      anon_sym_this,
    ACTIONS(2265), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(993), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26330] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(250), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1777), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(675), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(694), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26404] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(260), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(262), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26472] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1279), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26546] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2207), 1,
      anon_sym_this,
    ACTIONS(2245), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(1004), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(1023), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26620] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1230), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(85), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26768] = 18,
    ACTIONS(264), 1,
      sym_escape_sequence,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2300), 1,
      sym_identifier,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    ACTIONS(2306), 1,
      anon_sym_LBRACK,
    ACTIONS(2309), 1,
      anon_sym_this,
    ACTIONS(2312), 1,
      aux_sym_string_token1,
    ACTIONS(2315), 1,
      aux_sym_string_token3,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(283), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(289), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(269), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26836] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(238), 1,
      anon_sym_new,
    ACTIONS(1745), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(105), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(123), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26910] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1278), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [26984] = 18,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(252), 1,
      sym_escape_sequence,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2279), 1,
      anon_sym_LBRACE,
    ACTIONS(2281), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2285), 1,
      aux_sym_string_token1,
    ACTIONS(2287), 1,
      aux_sym_string_token3,
    ACTIONS(2289), 1,
      sym_comment,
    STATE(811), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(75), 2,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
    ACTIONS(79), 2,
      aux_sym_float_token1,
      aux_sym_float_token2,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(254), 3,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(1751), 1,
      anon_sym_this,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(961), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1243), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(992), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27126] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(1092), 1,
      anon_sym_new,
    ACTIONS(2215), 1,
      sym_identifier,
    STATE(80), 1,
      sym_member_expression,
    STATE(89), 1,
      sym__constructor_call,
    STATE(91), 1,
      sym__call,
    STATE(743), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(61), 2,
      sym__rhs_expression,
      sym_call_expression,
    STATE(764), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_RPAREN,
    STATE(817), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(2323), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(2321), 18,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [27242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(428), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(426), 10,
      anon_sym_this,
      anon_sym_EQ,
      anon_sym_null,
      anon_sym_extends,
      anon_sym_implements,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [27285] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(308), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27354] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(256), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27423] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(244), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27492] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(260), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27561] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_LBRACE,
    ACTIONS(274), 1,
      anon_sym_LBRACK,
    ACTIONS(280), 1,
      anon_sym_null,
    ACTIONS(283), 1,
      aux_sym_integer_token1,
    ACTIONS(286), 1,
      aux_sym_integer_token2,
    ACTIONS(289), 1,
      aux_sym_float_token1,
    ACTIONS(292), 1,
      aux_sym_float_token2,
    ACTIONS(298), 1,
      aux_sym_string_token1,
    ACTIONS(301), 1,
      aux_sym_string_token3,
    ACTIONS(2331), 1,
      sym_identifier,
    ACTIONS(2334), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(295), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(264), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27630] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(304), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27699] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 1,
      anon_sym_DOT,
    ACTIONS(1823), 1,
      anon_sym_QMARK,
    ACTIONS(2117), 1,
      anon_sym_EQ_GT,
    ACTIONS(508), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(506), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
  [27742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(2337), 19,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [27779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2343), 10,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(2341), 19,
      anon_sym_COLON,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_GT,
      anon_sym_QMARK_QMARK,
      sym__rangeOperator,
      sym__semicolon,
  [27816] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(823), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(252), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27885] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    ACTIONS(2345), 1,
      anon_sym_RPAREN,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1012), 1,
      sym__lhs_expression,
    STATE(1158), 1,
      sym_function_arg,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [27952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 9,
      anon_sym_this,
      anon_sym_null,
      anon_sym_extends,
      anon_sym_implements,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(472), 18,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [27987] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(453), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28051] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(821), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28115] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(17), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28179] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(15), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28243] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(38), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28307] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(680), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28371] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(398), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28435] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(393), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28499] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(753), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28563] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(34), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28627] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(396), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28691] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(397), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28755] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(96), 1,
      sym__call,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1054), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28819] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(395), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28883] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(681), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [28947] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(26), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29011] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(607), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29075] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(606), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29139] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(394), 1,
      aux_sym_member_expression_repeat1,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29203] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(446), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29267] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(445), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29331] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(619), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29395] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(447), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29459] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(734), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29523] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(609), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29587] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(604), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(603), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29715] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(765), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29779] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(608), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29843] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(682), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29907] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(28), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [29971] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(442), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30035] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(612), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30099] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(449), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30163] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(29), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30227] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(440), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30291] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(451), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30355] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(35), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30419] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(443), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30483] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1707), 1,
      anon_sym_this,
    ACTIONS(1793), 1,
      sym_identifier,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(444), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1149), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30547] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(452), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30611] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(326), 1,
      sym_identifier,
    ACTIONS(328), 1,
      anon_sym_this,
    STATE(30), 1,
      aux_sym_member_expression_repeat1,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1167), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30675] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1753), 1,
      sym_identifier,
    ACTIONS(1755), 1,
      anon_sym_this,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(448), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1162), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30739] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(424), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30803] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(617), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30867] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(735), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30931] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(621), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [30995] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(620), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31059] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(733), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31123] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(18), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31187] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(684), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31251] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(760), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31315] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(37), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31379] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(20), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31443] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(820), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31507] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_this,
    STATE(615), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1143), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31571] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(701), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1093), 1,
      sym__lhs_expression,
    STATE(1146), 1,
      sym_type_param,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31699] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(24), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31763] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(822), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31827] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(426), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31891] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(21), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [31955] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(246), 1,
      sym_identifier,
    ACTIONS(250), 1,
      anon_sym_this,
    STATE(16), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1152), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32019] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(763), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32083] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(824), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32147] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(814), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32211] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(39), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32275] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(802), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32339] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(788), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32403] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(33), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32467] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1093), 1,
      sym__lhs_expression,
    STATE(1127), 1,
      sym_type_param,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32531] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(806), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32595] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(689), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32659] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(819), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32723] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(421), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32787] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(798), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32851] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2277), 1,
      sym_identifier,
    ACTIONS(2283), 1,
      anon_sym_this,
    STATE(777), 1,
      aux_sym_member_expression_repeat1,
    STATE(959), 1,
      sym_member_expression,
    STATE(960), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32915] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1737), 1,
      anon_sym_this,
    ACTIONS(2329), 1,
      sym_identifier,
    STATE(402), 1,
      sym_member_expression,
    STATE(828), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1174), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [32979] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(757), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33043] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(739), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33107] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(96), 1,
      sym__call,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1059), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33171] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(428), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33235] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(236), 1,
      anon_sym_this,
    ACTIONS(318), 1,
      sym_identifier,
    STATE(32), 1,
      aux_sym_member_expression_repeat1,
    STATE(60), 1,
      sym_member_expression,
    STATE(72), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1124), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33299] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      sym_identifier,
    ACTIONS(2207), 1,
      anon_sym_this,
    STATE(690), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33363] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(754), 1,
      aux_sym_member_expression_repeat1,
    STATE(830), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33427] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2249), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1012), 1,
      sym__lhs_expression,
    STATE(1245), 1,
      sym_function_arg,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1159), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33491] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(715), 1,
      sym__call,
    STATE(975), 1,
      sym_string,
    STATE(1075), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33555] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(427), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33619] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1093), 1,
      sym__lhs_expression,
    STATE(1248), 1,
      sym_type_param,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33683] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_identifier,
    ACTIONS(2231), 1,
      anon_sym_this,
    STATE(746), 1,
      aux_sym_member_expression_repeat1,
    STATE(941), 1,
      sym_member_expression,
    STATE(942), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1141), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33747] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(998), 1,
      anon_sym_this,
    ACTIONS(1769), 1,
      sym_identifier,
    STATE(101), 1,
      sym_member_expression,
    STATE(102), 1,
      sym__lhs_expression,
    STATE(425), 1,
      aux_sym_member_expression_repeat1,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1151), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33811] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1007), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33872] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(983), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33933] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1121), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [33994] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(995), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34055] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1005), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34116] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1002), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34177] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1729), 1,
      sym_identifier,
    ACTIONS(1731), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(479), 1,
      sym__lhs_expression,
    STATE(975), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1139), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34238] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1014), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34299] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(990), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34360] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1017), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34421] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1119), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2351), 1,
      anon_sym_EQ,
    STATE(84), 1,
      sym__assignmentOperator,
    ACTIONS(2347), 8,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(2349), 15,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [34519] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1013), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34580] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(1000), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34641] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2283), 1,
      anon_sym_this,
    ACTIONS(2353), 1,
      sym_identifier,
    STATE(975), 1,
      sym_string,
    STATE(1024), 1,
      sym_member_expression,
    STATE(1031), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1164), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34702] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(1749), 1,
      sym_identifier,
    ACTIONS(1751), 1,
      anon_sym_this,
    STATE(402), 1,
      sym_member_expression,
    STATE(975), 1,
      sym_string,
    STATE(998), 1,
      sym__lhs_expression,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1133), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [34763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_EQ,
    ACTIONS(483), 8,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(480), 15,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [34797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_COLON,
    ACTIONS(426), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [34831] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2357), 1,
      sym_identifier,
    ACTIONS(2359), 1,
      anon_sym_RBRACE,
    STATE(119), 1,
      sym_pair,
    STATE(1123), 1,
      sym_structure_type_pair,
    STATE(1252), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1273), 8,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
  [34891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 17,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [34923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(472), 17,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [34955] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2361), 1,
      sym_identifier,
    ACTIONS(2363), 1,
      anon_sym_RBRACE,
    STATE(119), 1,
      sym_pair,
    STATE(1252), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1273), 8,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
  [35012] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_COLON,
    ACTIONS(2365), 1,
      anon_sym_DOT,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    ACTIONS(426), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 13,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [35049] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2361), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      anon_sym_RBRACE,
    STATE(1068), 1,
      sym_pair,
    STATE(1252), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1273), 8,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
  [35106] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2361), 1,
      sym_identifier,
    STATE(1095), 1,
      sym_pair,
    STATE(1252), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1273), 8,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
  [35160] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2371), 1,
      sym_identifier,
    STATE(1102), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1148), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [35212] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2371), 1,
      sym_identifier,
    STATE(1102), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1169), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [35264] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2371), 1,
      sym_identifier,
    STATE(1102), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1135), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [35316] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2371), 1,
      sym_identifier,
    STATE(1095), 1,
      sym_pair,
    STATE(1102), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1303), 8,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
  [35370] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(35), 1,
      anon_sym_LBRACK,
    ACTIONS(59), 1,
      anon_sym_null,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(79), 1,
      aux_sym_float_token1,
    ACTIONS(81), 1,
      aux_sym_float_token2,
    ACTIONS(85), 1,
      aux_sym_string_token1,
    ACTIONS(87), 1,
      aux_sym_string_token3,
    ACTIONS(232), 1,
      anon_sym_LBRACE,
    ACTIONS(2371), 1,
      sym_identifier,
    STATE(1102), 1,
      sym_string,
    ACTIONS(83), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1177), 9,
      sym__literal,
      sym_integer,
      sym_float,
      sym_bool,
      sym_null,
      sym_array,
      sym_map,
      sym_object,
      sym_pair,
  [35422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_EQ,
    STATE(84), 1,
      sym__assignmentOperator,
    ACTIONS(2347), 8,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(2349), 11,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [35455] = 6,
    ACTIONS(424), 1,
      sym_escape_sequence,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2379), 1,
      anon_sym_QMARK,
    ACTIONS(2375), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(426), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
      aux_sym_float_token1,
      aux_sym_float_token2,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      aux_sym_string_token2,
      aux_sym_string_token3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
      sym_identifier,
  [35490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 1,
      anon_sym_LPAREN,
    STATE(954), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2386), 6,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
    ACTIONS(2381), 12,
      anon_sym_this,
      anon_sym_Void,
      anon_sym_Int,
      anon_sym_Float,
      anon_sym_Bool,
      anon_sym_Null,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
  [35522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2388), 1,
      anon_sym_DOT,
    ACTIONS(426), 8,
      anon_sym_this,
      anon_sym_EQ,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 10,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [35554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_EQ,
    ACTIONS(483), 8,
      anon_sym_this,
      anon_sym_new,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(480), 11,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
      sym__semicolon,
  [35584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_EQ_GT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [35611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2392), 1,
      anon_sym_DOT,
    ACTIONS(2394), 1,
      anon_sym_QMARK,
    ACTIONS(426), 7,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_float_token1,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
    ACTIONS(424), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      aux_sym_integer_token2,
      aux_sym_float_token2,
      aux_sym_string_token1,
      aux_sym_string_token3,
  [35644] = 3,
    ACTIONS(424), 1,
      sym_escape_sequence,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(426), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
      aux_sym_float_token1,
      aux_sym_float_token2,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      aux_sym_string_token2,
      aux_sym_string_token3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
      sym_identifier,
  [35669] = 3,
    ACTIONS(472), 1,
      sym_escape_sequence,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(474), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_this,
      anon_sym_null,
      aux_sym_integer_token1,
      aux_sym_integer_token2,
      aux_sym_float_token1,
      aux_sym_float_token2,
      anon_sym_true,
      anon_sym_false,
      aux_sym_string_token1,
      aux_sym_string_token2,
      aux_sym_string_token3,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
      sym_identifier,
  [35694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(506), 10,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym_identifier,
      sym__semicolon,
  [35714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [35730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [35746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(428), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(506), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
  [35770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_DOT,
    ACTIONS(2398), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(428), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(506), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
  [35794] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_DOT,
    ACTIONS(2398), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(2400), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(506), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [35817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(2400), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(506), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [35840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_DOT,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(428), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(506), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [35863] = 8,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2402), 1,
      aux_sym_string_token1,
    ACTIONS(2404), 1,
      aux_sym_string_token2,
    ACTIONS(2406), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2408), 1,
      anon_sym_DOLLAR,
    ACTIONS(2410), 1,
      sym_escape_sequence,
    STATE(971), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
    STATE(1028), 2,
      sym__interpolated_block,
      sym__interpolated_identifier,
  [35890] = 8,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2408), 1,
      anon_sym_DOLLAR,
    ACTIONS(2412), 1,
      aux_sym_string_token1,
    ACTIONS(2414), 1,
      aux_sym_string_token2,
    ACTIONS(2416), 1,
      sym_escape_sequence,
    STATE(969), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
    STATE(1028), 2,
      sym__interpolated_block,
      sym__interpolated_identifier,
  [35917] = 8,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2418), 1,
      aux_sym_string_token1,
    ACTIONS(2420), 1,
      aux_sym_string_token2,
    ACTIONS(2423), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2426), 1,
      anon_sym_DOLLAR,
    ACTIONS(2429), 1,
      sym_escape_sequence,
    STATE(971), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
    STATE(1028), 2,
      sym__interpolated_block,
      sym__interpolated_identifier,
  [35944] = 6,
    ACTIONS(424), 1,
      sym_escape_sequence,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2379), 1,
      anon_sym_QMARK,
    ACTIONS(2375), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(426), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [35967] = 8,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2408), 1,
      anon_sym_DOLLAR,
    ACTIONS(2432), 1,
      aux_sym_string_token1,
    ACTIONS(2434), 1,
      aux_sym_string_token2,
    ACTIONS(2436), 1,
      sym_escape_sequence,
    STATE(974), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
    STATE(1028), 2,
      sym__interpolated_block,
      sym__interpolated_identifier,
  [35994] = 8,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2404), 1,
      aux_sym_string_token2,
    ACTIONS(2406), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2408), 1,
      anon_sym_DOLLAR,
    ACTIONS(2410), 1,
      sym_escape_sequence,
    ACTIONS(2438), 1,
      aux_sym_string_token1,
    STATE(971), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
    STATE(1028), 2,
      sym__interpolated_block,
      sym__interpolated_identifier,
  [36021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_COLON,
    ACTIONS(586), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__semicolon,
  [36037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(2440), 1,
      anon_sym_COLON,
    ACTIONS(424), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LT,
  [36059] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(2442), 1,
      anon_sym_COLON,
    ACTIONS(424), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LT,
  [36081] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 1,
      anon_sym_DOT,
    ACTIONS(2398), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(506), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2444), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [36103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(87), 1,
      sym__arg_list,
    STATE(1001), 1,
      sym_type_params,
    ACTIONS(620), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [36125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_DOT,
    ACTIONS(2367), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(506), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2444), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [36147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2448), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym__arg_list,
    STATE(1030), 1,
      sym_type_params,
    ACTIONS(620), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [36168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1307), 1,
      sym__access_identifier,
    ACTIONS(2450), 6,
      anon_sym_default,
      anon_sym_null,
      anon_sym_get,
      anon_sym_set,
      anon_sym_dynamic,
      anon_sym_never,
  [36183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2454), 1,
      anon_sym_extends,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(269), 1,
      sym_block,
    STATE(1022), 1,
      sym_type_params,
    STATE(1058), 1,
      aux_sym_class_declaration_repeat2,
  [36208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_DASH_GT,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2460), 1,
      anon_sym_EQ,
    STATE(951), 1,
      sym__assignmentOperator,
    STATE(1107), 1,
      sym_type_params,
    ACTIONS(2458), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36231] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2462), 1,
      anon_sym_extends,
    STATE(188), 1,
      sym_block,
    STATE(1019), 1,
      sym_type_params,
    STATE(1066), 1,
      aux_sym_class_declaration_repeat2,
  [36256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_COLON,
    ACTIONS(586), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym_identifier,
  [36271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 1,
      anon_sym_RBRACE,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(2444), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [36292] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_DASH_GT,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2466), 1,
      anon_sym_EQ,
    STATE(948), 1,
      sym__assignmentOperator,
    STATE(1107), 1,
      sym_type_params,
    ACTIONS(2464), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1254), 1,
      sym__access_identifier,
    ACTIONS(2450), 6,
      anon_sym_default,
      anon_sym_null,
      anon_sym_get,
      anon_sym_set,
      anon_sym_dynamic,
      anon_sym_never,
  [36330] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2468), 1,
      anon_sym_extends,
    STATE(275), 1,
      sym_block,
    STATE(1032), 1,
      sym_type_params,
    STATE(1071), 1,
      aux_sym_class_declaration_repeat2,
  [36355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2470), 1,
      anon_sym_extends,
    STATE(330), 1,
      sym_block,
    STATE(1029), 1,
      sym_type_params,
    STATE(1097), 1,
      aux_sym_class_declaration_repeat2,
  [36380] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2472), 1,
      anon_sym_DOT,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(506), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
  [36399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2476), 1,
      anon_sym_DOT,
    ACTIONS(2478), 1,
      anon_sym_QMARK,
    ACTIONS(506), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym__semicolon,
  [36418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2480), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_QMARK,
    ACTIONS(506), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [36436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(171), 1,
      sym_block,
    STATE(1072), 1,
      aux_sym_class_declaration_repeat2,
    STATE(1073), 1,
      sym_type_params,
  [36458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_EQ,
    ACTIONS(2484), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(510), 3,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [36474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(1111), 1,
      sym_type_params,
    ACTIONS(638), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [36490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(263), 1,
      sym_block,
    STATE(1056), 1,
      sym_type_params,
    STATE(1057), 1,
      aux_sym_class_declaration_repeat2,
  [36512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_EQ_GT,
    ACTIONS(2472), 1,
      anon_sym_DOT,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
    ACTIONS(506), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [36530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(278), 1,
      sym_block,
    STATE(1115), 1,
      sym_type_params,
    STATE(1116), 1,
      aux_sym_interface_declaration_repeat1,
  [36552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym__arg_list,
    ACTIONS(626), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [36568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(177), 1,
      sym_block,
    STATE(1067), 1,
      aux_sym_class_declaration_repeat2,
    STATE(1087), 1,
      sym_type_params,
  [36590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      anon_sym_DOT,
    ACTIONS(2494), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(2490), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [36608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_COLON,
    ACTIONS(586), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [36622] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(229), 1,
      sym_block,
    STATE(1047), 1,
      sym_type_params,
    STATE(1049), 1,
      aux_sym_class_declaration_repeat2,
  [36644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(683), 6,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_EQ,
  [36656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(277), 1,
      sym_block,
    STATE(1062), 1,
      sym_type_params,
    STATE(1063), 1,
      aux_sym_class_declaration_repeat2,
  [36678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(111), 1,
      sym_type_params,
    ACTIONS(638), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [36694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(1107), 1,
      sym_type_params,
    ACTIONS(620), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [36710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(116), 1,
      sym_type_params,
    ACTIONS(620), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [36726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(192), 1,
      sym_block,
    STATE(1069), 1,
      sym_type_params,
    STATE(1070), 1,
      aux_sym_interface_declaration_repeat1,
  [36748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      anon_sym_COLON,
    ACTIONS(2500), 1,
      anon_sym_QMARK,
    ACTIONS(2502), 1,
      anon_sym_EQ,
    STATE(949), 1,
      sym__assignmentOperator,
    ACTIONS(2496), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(209), 1,
      sym_block,
    STATE(1086), 1,
      sym_type_params,
    STATE(1088), 1,
      aux_sym_class_declaration_repeat2,
  [36790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(212), 1,
      sym_block,
    STATE(1038), 1,
      aux_sym_class_declaration_repeat2,
    STATE(1079), 1,
      sym_type_params,
  [36812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_EQ_GT,
    ACTIONS(2476), 1,
      anon_sym_DOT,
    ACTIONS(2478), 1,
      anon_sym_QMARK,
    ACTIONS(506), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_identifier,
  [36830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      anon_sym_DOT,
    ACTIONS(2394), 1,
      anon_sym_QMARK,
    ACTIONS(424), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(2490), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [36848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(185), 1,
      sym_block,
    STATE(1090), 1,
      aux_sym_class_declaration_repeat2,
    STATE(1101), 1,
      sym_type_params,
  [36870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2504), 1,
      anon_sym_RBRACE,
    STATE(87), 1,
      sym__arg_list,
    STATE(1262), 1,
      sym_type_params,
  [36889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2506), 1,
      anon_sym_extends,
    STATE(296), 1,
      sym_block,
    STATE(1117), 1,
      aux_sym_class_declaration_repeat2,
  [36908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_EQ,
    ACTIONS(2508), 1,
      anon_sym_DASH_GT,
    STATE(951), 1,
      sym__assignmentOperator,
    ACTIONS(2458), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_EQ_GT,
    ACTIONS(2476), 1,
      anon_sym_DOT,
    ACTIONS(2478), 1,
      anon_sym_QMARK,
    ACTIONS(506), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [36942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2510), 1,
      anon_sym_extends,
    STATE(174), 1,
      sym_block,
    STATE(1106), 1,
      aux_sym_class_declaration_repeat2,
  [36961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_EQ_GT,
    ACTIONS(2480), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_QMARK,
    ACTIONS(506), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [36978] = 3,
    ACTIONS(424), 1,
      sym_escape_sequence,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(426), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [36991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1903), 1,
      sym_identifier,
    ACTIONS(1905), 1,
      anon_sym_RBRACK,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(1186), 1,
      aux_sym_array_repeat1,
  [37010] = 3,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2514), 1,
      sym_escape_sequence,
    ACTIONS(2512), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [37023] = 3,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2518), 1,
      sym_escape_sequence,
    ACTIONS(2516), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [37036] = 3,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2522), 1,
      sym_escape_sequence,
    ACTIONS(2520), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [37049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2524), 1,
      anon_sym_extends,
    STATE(253), 1,
      sym_block,
    STATE(1052), 1,
      aux_sym_class_declaration_repeat2,
  [37068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym__arg_list,
    ACTIONS(626), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [37083] = 3,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2528), 1,
      sym_escape_sequence,
    ACTIONS(2526), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [37096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    ACTIONS(2530), 1,
      anon_sym_extends,
    STATE(221), 1,
      sym_block,
    STATE(1082), 1,
      aux_sym_class_declaration_repeat2,
  [37115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_EQ,
    ACTIONS(2508), 1,
      anon_sym_DASH_GT,
    STATE(948), 1,
      sym__assignmentOperator,
    ACTIONS(2464), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37132] = 3,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2534), 1,
      sym_escape_sequence,
    ACTIONS(2532), 4,
      aux_sym_string_token1,
      aux_sym_string_token2,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_DOLLAR,
  [37145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1883), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    ACTIONS(2185), 1,
      anon_sym_LBRACK,
    STATE(1137), 1,
      aux_sym_array_repeat1,
  [37164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_COLON,
    ACTIONS(2540), 1,
      anon_sym_EQ,
    STATE(947), 1,
      sym__assignmentOperator,
    ACTIONS(2536), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(706), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [37193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(335), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    STATE(1131), 1,
      aux_sym__arg_list_repeat1,
  [37225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(698), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [37237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(702), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [37249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2544), 1,
      anon_sym_RPAREN,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    STATE(1157), 1,
      aux_sym__function_type_args_repeat1,
  [37265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(2549), 1,
      sym_identifier,
    STATE(1295), 1,
      sym_integer,
  [37281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(180), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_DASH_GT,
    ACTIONS(698), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [37309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_DASH_GT,
    ACTIONS(702), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [37321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(184), 1,
      sym_block,
    STATE(1074), 1,
      aux_sym_class_declaration_repeat2,
  [37337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_DASH_GT,
    ACTIONS(706), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [37349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(187), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    ACTIONS(2551), 1,
      anon_sym_RPAREN,
    STATE(1157), 1,
      aux_sym__function_type_args_repeat1,
  [37381] = 5,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2432), 1,
      aux_sym_string_token3,
    ACTIONS(2553), 1,
      aux_sym_string_token4,
    ACTIONS(2555), 1,
      sym_escape_sequence,
    STATE(1085), 1,
      aux_sym_string_repeat2,
  [37397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(189), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(196), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2448), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym__arg_list,
    STATE(1217), 1,
      sym_type_params,
  [37445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_EQ,
    STATE(951), 1,
      sym__assignmentOperator,
    ACTIONS(2458), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(199), 1,
      sym_block,
    STATE(1078), 1,
      aux_sym_class_declaration_repeat2,
  [37475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(206), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(175), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(87), 1,
      sym__arg_list,
    STATE(1262), 1,
      sym_type_params,
  [37523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 1,
      anon_sym_COLON,
    ACTIONS(2490), 1,
      anon_sym_EQ_GT,
    ACTIONS(2557), 1,
      anon_sym_DOT,
    ACTIONS(2559), 1,
      anon_sym_QMARK,
  [37539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(231), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(236), 1,
      sym_block,
    STATE(1083), 1,
      aux_sym_class_declaration_repeat2,
  [37571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(237), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37587] = 5,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2402), 1,
      aux_sym_string_token3,
    ACTIONS(2561), 1,
      aux_sym_string_token4,
    ACTIONS(2563), 1,
      sym_escape_sequence,
    STATE(1089), 1,
      aux_sym_string_repeat2,
  [37603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1883), 1,
      sym_identifier,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    STATE(1137), 1,
      aux_sym_array_repeat1,
  [37619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(298), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(259), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_EQ_GT,
    ACTIONS(636), 1,
      anon_sym_COMMA,
    ACTIONS(2565), 1,
      anon_sym_RBRACE,
    STATE(1170), 1,
      aux_sym_map_repeat1,
  [37667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(301), 1,
      sym_block,
    STATE(1112), 1,
      aux_sym_interface_declaration_repeat1,
  [37683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(303), 1,
      sym_block,
    STATE(1153), 1,
      aux_sym_interface_declaration_repeat1,
  [37699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(218), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(179), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(181), 1,
      sym_block,
    STATE(1104), 1,
      aux_sym_class_declaration_repeat2,
  [37747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(292), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2567), 1,
      anon_sym_LPAREN,
    STATE(712), 1,
      sym__arg_list,
    STATE(1239), 1,
      sym_type_params,
  [37779] = 5,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2412), 1,
      aux_sym_string_token3,
    ACTIONS(2569), 1,
      aux_sym_string_token4,
    ACTIONS(2571), 1,
      sym_escape_sequence,
    STATE(1064), 1,
      aux_sym_string_repeat2,
  [37795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 1,
      anon_sym_RBRACE,
    ACTIONS(2444), 1,
      anon_sym_EQ_GT,
    ACTIONS(2472), 1,
      anon_sym_DOT,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
  [37811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(324), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(325), 1,
      sym_block,
    STATE(1098), 1,
      aux_sym_class_declaration_repeat2,
  [37843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    ACTIONS(2573), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym__function_type_args_repeat1,
  [37859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(203), 1,
      sym_block,
    STATE(1153), 1,
      aux_sym_interface_declaration_repeat1,
  [37875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(204), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(329), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    ACTIONS(2576), 1,
      sym_identifier,
    STATE(1302), 1,
      sym_integer,
  [37923] = 5,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2438), 1,
      aux_sym_string_token3,
    ACTIONS(2561), 1,
      aux_sym_string_token4,
    ACTIONS(2563), 1,
      sym_escape_sequence,
    STATE(1089), 1,
      aux_sym_string_repeat2,
  [37939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(225), 1,
      sym_block,
    STATE(1044), 1,
      aux_sym_class_declaration_repeat2,
  [37955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(256), 1,
      sym_block,
    STATE(1053), 1,
      aux_sym_class_declaration_repeat2,
  [37971] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(227), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [37987] = 5,
    ACTIONS(2289), 1,
      sym_comment,
    ACTIONS(2578), 1,
      aux_sym_string_token3,
    ACTIONS(2580), 1,
      aux_sym_string_token4,
    ACTIONS(2583), 1,
      sym_escape_sequence,
    STATE(1089), 1,
      aux_sym_string_repeat2,
  [38003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(274), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    ACTIONS(2586), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      aux_sym__function_type_args_repeat1,
  [38035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(142), 1,
      sym__function_arg_list,
    STATE(1210), 1,
      sym_type_params,
  [38051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(1235), 1,
      sym_type_params,
    ACTIONS(2591), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [38065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(506), 1,
      anon_sym_COLON,
    ACTIONS(2490), 1,
      anon_sym_EQ_GT,
    ACTIONS(2593), 1,
      anon_sym_DOT,
    ACTIONS(2595), 1,
      anon_sym_QMARK,
  [38081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_EQ_GT,
    ACTIONS(2597), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [38093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(137), 1,
      sym__function_arg_list,
    STATE(1225), 1,
      sym_type_params,
  [38109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(244), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(311), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(157), 1,
      sym__function_arg_list,
    STATE(1204), 1,
      sym_type_params,
  [38157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(158), 1,
      sym__function_arg_list,
    STATE(1201), 1,
      sym_type_params,
  [38173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(273), 1,
      sym_block,
    STATE(1061), 1,
      aux_sym_class_declaration_repeat2,
  [38189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_COLON,
    ACTIONS(586), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [38201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [38211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(254), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2601), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [38239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(264), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(626), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [38265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1903), 1,
      sym_identifier,
    ACTIONS(1905), 1,
      anon_sym_RBRACK,
    STATE(1186), 1,
      aux_sym_array_repeat1,
  [38281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(152), 1,
      sym__function_arg_list,
    STATE(1218), 1,
      sym_type_params,
  [38297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_EQ,
    STATE(948), 1,
      sym__assignmentOperator,
    ACTIONS(2464), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [38311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [38321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(270), 1,
      sym_block,
    STATE(1153), 1,
      aux_sym_interface_declaration_repeat1,
  [38337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1929), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      aux_sym__arg_list_repeat1,
  [38353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(150), 1,
      sym__function_arg_list,
    STATE(1226), 1,
      sym_type_params,
  [38369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(216), 1,
      sym_block,
    STATE(1081), 1,
      aux_sym_interface_declaration_repeat1,
  [38385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2488), 1,
      anon_sym_extends,
    STATE(214), 1,
      sym_block,
    STATE(1153), 1,
      aux_sym_interface_declaration_repeat1,
  [38401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    ACTIONS(2456), 1,
      anon_sym_implements,
    STATE(257), 1,
      sym_block,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    STATE(1134), 1,
      aux_sym__arg_list_repeat1,
  [38433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(1237), 1,
      sym_type_params,
    ACTIONS(2603), 2,
      anon_sym_LBRACE,
      anon_sym_extends,
  [38447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COLON,
    ACTIONS(586), 3,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [38459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    STATE(1238), 1,
      sym_type_params,
    ACTIONS(2608), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [38473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(630), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [38483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_RBRACE,
    ACTIONS(2612), 1,
      anon_sym_COMMA,
    STATE(1166), 1,
      aux_sym_structure_type_repeat1,
  [38496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2614), 1,
      anon_sym_DOT,
    ACTIONS(2616), 1,
      anon_sym_QMARK,
  [38509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_RBRACE,
    ACTIONS(2618), 1,
      anon_sym_COMMA,
    STATE(1125), 1,
      aux_sym_map_repeat1,
  [38522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      aux_sym_integer_token1,
    ACTIONS(1675), 1,
      aux_sym_integer_token2,
    STATE(737), 1,
      sym_integer,
  [38535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_COMMA,
    ACTIONS(2623), 1,
      anon_sym_GT,
    STATE(1185), 1,
      aux_sym_type_params_repeat1,
  [38548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [38559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(2625), 1,
      anon_sym_RBRACK,
    STATE(1130), 1,
      aux_sym_array_repeat1,
  [38572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 1,
      anon_sym_RBRACK,
    ACTIONS(2627), 1,
      anon_sym_COMMA,
    STATE(1130), 1,
      aux_sym_array_repeat1,
  [38585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 1,
      anon_sym_RPAREN,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [38598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1955), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [38611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2472), 1,
      anon_sym_DOT,
    ACTIONS(2474), 1,
      anon_sym_QMARK,
  [38624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [38637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ_GT,
    ACTIONS(2630), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [38648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [38661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RBRACK,
    STATE(1130), 1,
      aux_sym_array_repeat1,
  [38674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2480), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_QMARK,
  [38687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2634), 1,
      anon_sym_DOT,
    ACTIONS(2636), 1,
      anon_sym_QMARK,
  [38700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2638), 1,
      anon_sym_RBRACK,
    STATE(1145), 1,
      aux_sym_map_repeat1,
  [38713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2557), 1,
      anon_sym_DOT,
    ACTIONS(2559), 1,
      anon_sym_QMARK,
  [38726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    ACTIONS(2643), 1,
      anon_sym_GT,
    STATE(1142), 1,
      aux_sym_type_params_repeat1,
  [38739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2476), 1,
      anon_sym_DOT,
    ACTIONS(2478), 1,
      anon_sym_QMARK,
  [38752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_COMMA,
    ACTIONS(2645), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_map_repeat1,
  [38765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_RBRACK,
    ACTIONS(2647), 1,
      anon_sym_COMMA,
    STATE(1145), 1,
      aux_sym_map_repeat1,
  [38778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_COMMA,
    ACTIONS(2650), 1,
      anon_sym_GT,
    STATE(1168), 1,
      aux_sym_type_params_repeat1,
  [38791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      anon_sym_LBRACE,
    ACTIONS(2654), 1,
      anon_sym_implements,
    STATE(1147), 1,
      aux_sym_class_declaration_repeat2,
  [38804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ_GT,
    ACTIONS(2657), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [38815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2659), 1,
      anon_sym_DOT,
    ACTIONS(2661), 1,
      anon_sym_QMARK,
  [38828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_RPAREN,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    STATE(1165), 1,
      aux_sym__function_arg_list_repeat1,
  [38841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2667), 1,
      anon_sym_DOT,
    ACTIONS(2669), 1,
      anon_sym_QMARK,
  [38854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2671), 1,
      anon_sym_DOT,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
  [38867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_LBRACE,
    ACTIONS(2677), 1,
      anon_sym_extends,
    STATE(1153), 1,
      aux_sym_interface_declaration_repeat1,
  [38880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1929), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      aux_sym__arg_list_repeat1,
  [38893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(2680), 1,
      anon_sym_RBRACK,
    STATE(1130), 1,
      aux_sym_array_repeat1,
  [38906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    STATE(1134), 1,
      aux_sym__arg_list_repeat1,
  [38919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    ACTIONS(2682), 1,
      anon_sym_RPAREN,
    STATE(1171), 1,
      aux_sym__function_type_args_repeat1,
  [38932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_COMMA,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    STATE(1150), 1,
      aux_sym__function_arg_list_repeat1,
  [38945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2686), 1,
      anon_sym_DOT,
    ACTIONS(2688), 1,
      anon_sym_QMARK,
  [38958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2690), 1,
      sym_identifier,
    ACTIONS(2692), 1,
      anon_sym_LPAREN,
    STATE(720), 1,
      sym__parenthesized_expression,
  [38971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      aux_sym_integer_token1,
    ACTIONS(77), 1,
      aux_sym_integer_token2,
    STATE(93), 1,
      sym_integer,
  [38984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2694), 1,
      anon_sym_DOT,
    ACTIONS(2696), 1,
      anon_sym_QMARK,
  [38997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [39006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2700), 1,
      anon_sym_DOT,
    ACTIONS(2702), 1,
      anon_sym_QMARK,
  [39019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_RPAREN,
    ACTIONS(2706), 1,
      anon_sym_COMMA,
    STATE(1165), 1,
      aux_sym__function_arg_list_repeat1,
  [39032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_COMMA,
    ACTIONS(2709), 1,
      anon_sym_RBRACE,
    STATE(1178), 1,
      aux_sym_structure_type_repeat1,
  [39045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2711), 1,
      anon_sym_DOT,
    ACTIONS(2713), 1,
      anon_sym_QMARK,
  [39058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_COMMA,
    ACTIONS(2715), 1,
      anon_sym_GT,
    STATE(1142), 1,
      aux_sym_type_params_repeat1,
  [39071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ_GT,
    ACTIONS(2717), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_COMMA,
    ACTIONS(2719), 1,
      anon_sym_RBRACE,
    STATE(1125), 1,
      aux_sym_map_repeat1,
  [39095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_RPAREN,
    ACTIONS(2723), 1,
      anon_sym_COMMA,
    STATE(1171), 1,
      aux_sym__function_type_args_repeat1,
  [39108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2721), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(1953), 1,
      anon_sym_RPAREN,
    STATE(1131), 1,
      aux_sym__arg_list_repeat1,
  [39132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 1,
      anon_sym_EQ_GT,
    ACTIONS(2593), 1,
      anon_sym_DOT,
    ACTIONS(2595), 1,
      anon_sym_QMARK,
  [39145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2726), 1,
      anon_sym_RBRACK,
    STATE(1145), 1,
      aux_sym_map_repeat1,
  [39158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2728), 1,
      anon_sym_EQ,
    STATE(1315), 1,
      sym_type_params,
  [39171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ_GT,
    ACTIONS(2730), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_RBRACE,
    ACTIONS(2734), 1,
      anon_sym_COMMA,
    STATE(1178), 1,
      aux_sym_structure_type_repeat1,
  [39195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_RPAREN,
    ACTIONS(2737), 1,
      anon_sym_COMMA,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [39208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [39217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(2742), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [39230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2001), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1857), 1,
      anon_sym_LPAREN,
    ACTIONS(2744), 1,
      sym_identifier,
    STATE(77), 1,
      sym__parenthesized_expression,
  [39254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_LT,
    ACTIONS(2746), 1,
      anon_sym_EQ,
    STATE(1286), 1,
      sym_type_params,
  [39267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_COMMA,
    ACTIONS(2748), 1,
      anon_sym_GT,
    STATE(1142), 1,
      aux_sym_type_params_repeat1,
  [39280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    ACTIONS(1873), 1,
      anon_sym_RBRACK,
    STATE(1130), 1,
      aux_sym_array_repeat1,
  [39293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 1,
      anon_sym_COMMA,
    ACTIONS(2750), 1,
      anon_sym_RPAREN,
    STATE(1179), 1,
      aux_sym__arg_list_repeat1,
  [39306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_COMMA,
    ACTIONS(2752), 1,
      anon_sym_RPAREN,
    STATE(1171), 1,
      aux_sym__function_type_args_repeat1,
  [39319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2754), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2037), 1,
      sym__semicolon,
  [39340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_DOT,
    ACTIONS(2758), 1,
      anon_sym_QMARK,
  [39350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2093), 1,
      sym__semicolon,
  [39360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2095), 1,
      sym__semicolon,
  [39370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_DOT,
    ACTIONS(2762), 1,
      anon_sym_QMARK,
  [39380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2023), 1,
      anon_sym_RBRACK,
  [39390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2764), 1,
      anon_sym_RPAREN,
  [39400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_DASH_GT,
    ACTIONS(2766), 1,
      anon_sym_RPAREN,
  [39410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [39418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2025), 1,
      sym__semicolon,
  [39428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      aux_sym_preprocessor_statement_token1,
    ACTIONS(2770), 1,
      aux_sym_preprocessor_statement_token2,
  [39438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym__function_arg_list,
  [39448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2027), 1,
      anon_sym_RBRACE,
  [39466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(133), 1,
      sym__function_arg_list,
  [39476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_DOT,
    ACTIONS(2774), 1,
      anon_sym_QMARK,
  [39486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2029), 1,
      sym__semicolon,
  [39496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2067), 1,
      sym__semicolon,
  [39506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [39514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_DOT,
    ACTIONS(2778), 1,
      anon_sym_QMARK,
  [39524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(122), 1,
      sym__function_arg_list,
  [39534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2071), 1,
      sym__semicolon,
  [39544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2047), 1,
      sym__semicolon,
  [39554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2039), 1,
      sym__semicolon,
  [39564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2097), 1,
      anon_sym_RBRACK,
  [39574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [39582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 1,
      anon_sym_DOT,
    ACTIONS(2784), 1,
      anon_sym_QMARK,
  [39592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym__arg_list,
  [39602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(156), 1,
      sym__function_arg_list,
  [39612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [39620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2105), 1,
      sym__semicolon,
  [39630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      sym_identifier,
    STATE(1208), 1,
      sym_structure_type_pair,
  [39640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2107), 1,
      sym__semicolon,
  [39650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_DOT,
    ACTIONS(2790), 1,
      anon_sym_QMARK,
  [39660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2015), 1,
      sym__semicolon,
  [39670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(145), 1,
      sym__function_arg_list,
  [39680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_LPAREN,
    STATE(154), 1,
      sym__function_arg_list,
  [39690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_DOT,
    ACTIONS(2794), 1,
      anon_sym_QMARK,
  [39700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2017), 1,
      sym__semicolon,
  [39710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2051), 1,
      sym__semicolon,
  [39720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_RPAREN,
    ACTIONS(2798), 1,
      anon_sym_COMMA,
  [39730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2055), 1,
      sym__semicolon,
  [39740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2021), 1,
      sym__semicolon,
  [39750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      anon_sym_DOT,
    ACTIONS(1895), 1,
      anon_sym_QMARK,
  [39760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2103), 1,
      sym__semicolon,
  [39770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [39778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 1,
      anon_sym_DOT,
    ACTIONS(2804), 1,
      anon_sym_QMARK,
  [39788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 2,
      anon_sym_LBRACE,
      anon_sym_extends,
  [39796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2808), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [39804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_LPAREN,
    STATE(714), 1,
      sym__arg_list,
  [39814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2049), 1,
      sym__semicolon,
  [39824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_EQ_GT,
    ACTIONS(2810), 1,
      anon_sym_COLON,
  [39834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2085), 1,
      sym__semicolon,
  [39844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      anon_sym_RPAREN,
    ACTIONS(2814), 1,
      anon_sym_COMMA,
  [39854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      anon_sym_DOT,
    ACTIONS(2818), 1,
      anon_sym_QMARK,
  [39864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2081), 1,
      sym__semicolon,
  [39882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2079), 1,
      sym__semicolon,
  [39892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [39900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2069), 1,
      sym__semicolon,
  [39910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_DOT,
    ACTIONS(2822), 1,
      anon_sym_QMARK,
  [39920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_DOT,
    ACTIONS(2826), 1,
      anon_sym_QMARK,
  [39930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_EQ_GT,
    ACTIONS(2780), 1,
      anon_sym_COLON,
  [39940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2073), 1,
      sym__semicolon,
  [39950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_RPAREN,
    ACTIONS(2830), 1,
      anon_sym_COMMA,
  [39960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [39968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    STATE(272), 1,
      sym_block,
  [39978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_DOT,
    ACTIONS(2836), 1,
      anon_sym_QMARK,
  [39988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      anon_sym_DOT,
    ACTIONS(2840), 1,
      anon_sym_QMARK,
  [39998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2013), 1,
      sym__semicolon,
  [40008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_LBRACE,
    STATE(226), 1,
      sym_block,
  [40018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      anon_sym_LBRACK,
    ACTIONS(2033), 1,
      anon_sym_RPAREN,
  [40028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym__arg_list,
  [40038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 1,
      sym__semicolon,
  [40045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_DOT,
  [40052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      sym__semicolon,
  [40059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      anon_sym_RBRACK,
  [40066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      sym__semicolon,
  [40073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2093), 1,
      sym__semicolon,
  [40080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_DOT,
  [40087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 1,
      anon_sym_DOT,
  [40094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_RPAREN,
  [40101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_DOT,
  [40108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_EQ_GT,
  [40115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_RBRACK,
  [40122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_DOT,
  [40129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      sym__semicolon,
  [40136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_DOT,
  [40143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_RPAREN,
  [40150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_RPAREN,
  [40157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_RBRACK,
  [40164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_DASH_GT,
  [40171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2864), 1,
      anon_sym_RPAREN,
  [40178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_DASH_GT,
  [40185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 1,
      sym__semicolon,
  [40192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 1,
      ts_builtin_sym_end,
  [40199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      anon_sym_EQ,
  [40206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 1,
      sym__semicolon,
  [40213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      sym__semicolon,
  [40220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      sym__semicolon,
  [40227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      sym__semicolon,
  [40234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      sym__semicolon,
  [40241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      sym__semicolon,
  [40248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 1,
      anon_sym_RBRACK,
  [40255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 1,
      sym__semicolon,
  [40262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      sym__rangeOperator,
  [40269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_DASH_GT,
  [40276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 1,
      sym__semicolon,
  [40283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 1,
      anon_sym_DOT,
  [40290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 1,
      anon_sym_DASH_GT,
  [40297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 1,
      anon_sym_RBRACE,
  [40304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      sym__semicolon,
  [40311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      sym__rangeOperator,
  [40318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ_GT,
  [40325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_DASH_GT,
  [40332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 1,
      anon_sym_RBRACK,
  [40339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 1,
      sym__semicolon,
  [40346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_RPAREN,
  [40353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 1,
      sym__semicolon,
  [40360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_RPAREN,
  [40367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_DASH_GT,
  [40374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      anon_sym_RPAREN,
  [40381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_DOT,
  [40388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      anon_sym_DOT,
  [40395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_DOT,
  [40402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 1,
      anon_sym_EQ,
  [40409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 1,
      sym__semicolon,
  [40416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      anon_sym_LPAREN,
  [40423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_COLON,
  [40430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_DOT,
  [40437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_COLON,
  [40444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_DOT,
  [40451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 1,
      sym__semicolon,
  [40458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 1,
      anon_sym_DOT,
  [40465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 1,
      anon_sym_DOT,
  [40472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2916), 1,
      anon_sym_DOT,
  [40479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      sym__semicolon,
  [40486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 1,
      sym__semicolon,
  [40493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_DOT,
  [40500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_DOT,
  [40507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 1,
      anon_sym_DOT,
  [40514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2103), 1,
      sym__semicolon,
  [40521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_DOT,
  [40528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym_DOT,
  [40535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_DOT,
  [40542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 1,
      anon_sym_DOT,
  [40549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 1,
      sym__semicolon,
  [40556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_DOT,
  [40563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_DOT,
  [40570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_DOT,
  [40577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 1,
      anon_sym_RPAREN,
  [40584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      anon_sym_DOT,
  [40591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_DOT,
  [40598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_DOT,
  [40605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 1,
      sym__semicolon,
  [40612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_DOT,
  [40619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 1,
      anon_sym_DOT,
  [40626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 1,
      sym__semicolon,
  [40633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      anon_sym_DOT,
  [40640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_DOT,
  [40647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2954), 1,
      anon_sym_DOT,
  [40654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2073), 1,
      sym__semicolon,
  [40661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_DOT,
  [40668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2958), 1,
      anon_sym_DOT,
  [40675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 1,
      anon_sym_DOT,
  [40682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 1,
      sym__semicolon,
  [40689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2962), 1,
      anon_sym_DOT,
  [40696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_DOT,
  [40703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_DOT,
  [40710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2968), 1,
      anon_sym_LPAREN,
  [40717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 1,
      anon_sym_RPAREN,
  [40724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_RBRACK,
  [40731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2972), 1,
      anon_sym_DOT,
  [40738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 1,
      anon_sym_DOT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(421)] = 0,
  [SMALL_STATE(422)] = 105,
  [SMALL_STATE(423)] = 210,
  [SMALL_STATE(424)] = 321,
  [SMALL_STATE(425)] = 426,
  [SMALL_STATE(426)] = 531,
  [SMALL_STATE(427)] = 636,
  [SMALL_STATE(428)] = 741,
  [SMALL_STATE(429)] = 846,
  [SMALL_STATE(430)] = 930,
  [SMALL_STATE(431)] = 1006,
  [SMALL_STATE(432)] = 1089,
  [SMALL_STATE(433)] = 1196,
  [SMALL_STATE(434)] = 1285,
  [SMALL_STATE(435)] = 1394,
  [SMALL_STATE(436)] = 1483,
  [SMALL_STATE(437)] = 1591,
  [SMALL_STATE(438)] = 1678,
  [SMALL_STATE(439)] = 1753,
  [SMALL_STATE(440)] = 1834,
  [SMALL_STATE(441)] = 1933,
  [SMALL_STATE(442)] = 2032,
  [SMALL_STATE(443)] = 2131,
  [SMALL_STATE(444)] = 2230,
  [SMALL_STATE(445)] = 2329,
  [SMALL_STATE(446)] = 2428,
  [SMALL_STATE(447)] = 2527,
  [SMALL_STATE(448)] = 2625,
  [SMALL_STATE(449)] = 2723,
  [SMALL_STATE(450)] = 2821,
  [SMALL_STATE(451)] = 2919,
  [SMALL_STATE(452)] = 3017,
  [SMALL_STATE(453)] = 3115,
  [SMALL_STATE(454)] = 3213,
  [SMALL_STATE(455)] = 3289,
  [SMALL_STATE(456)] = 3363,
  [SMALL_STATE(457)] = 3424,
  [SMALL_STATE(458)] = 3489,
  [SMALL_STATE(459)] = 3563,
  [SMALL_STATE(460)] = 3635,
  [SMALL_STATE(461)] = 3707,
  [SMALL_STATE(462)] = 3774,
  [SMALL_STATE(463)] = 3833,
  [SMALL_STATE(464)] = 3900,
  [SMALL_STATE(465)] = 3962,
  [SMALL_STATE(466)] = 4024,
  [SMALL_STATE(467)] = 4086,
  [SMALL_STATE(468)] = 4148,
  [SMALL_STATE(469)] = 4224,
  [SMALL_STATE(470)] = 4280,
  [SMALL_STATE(471)] = 4340,
  [SMALL_STATE(472)] = 4414,
  [SMALL_STATE(473)] = 4488,
  [SMALL_STATE(474)] = 4562,
  [SMALL_STATE(475)] = 4630,
  [SMALL_STATE(476)] = 4687,
  [SMALL_STATE(477)] = 4744,
  [SMALL_STATE(478)] = 4817,
  [SMALL_STATE(479)] = 4884,
  [SMALL_STATE(480)] = 4939,
  [SMALL_STATE(481)] = 5012,
  [SMALL_STATE(482)] = 5085,
  [SMALL_STATE(483)] = 5161,
  [SMALL_STATE(484)] = 5219,
  [SMALL_STATE(485)] = 5271,
  [SMALL_STATE(486)] = 5347,
  [SMALL_STATE(487)] = 5419,
  [SMALL_STATE(488)] = 5495,
  [SMALL_STATE(489)] = 5551,
  [SMALL_STATE(490)] = 5623,
  [SMALL_STATE(491)] = 5679,
  [SMALL_STATE(492)] = 5745,
  [SMALL_STATE(493)] = 5797,
  [SMALL_STATE(494)] = 5867,
  [SMALL_STATE(495)] = 5925,
  [SMALL_STATE(496)] = 5997,
  [SMALL_STATE(497)] = 6049,
  [SMALL_STATE(498)] = 6125,
  [SMALL_STATE(499)] = 6179,
  [SMALL_STATE(500)] = 6252,
  [SMALL_STATE(501)] = 6319,
  [SMALL_STATE(502)] = 6386,
  [SMALL_STATE(503)] = 6453,
  [SMALL_STATE(504)] = 6526,
  [SMALL_STATE(505)] = 6593,
  [SMALL_STATE(506)] = 6660,
  [SMALL_STATE(507)] = 6727,
  [SMALL_STATE(508)] = 6794,
  [SMALL_STATE(509)] = 6863,
  [SMALL_STATE(510)] = 6916,
  [SMALL_STATE(511)] = 6989,
  [SMALL_STATE(512)] = 7060,
  [SMALL_STATE(513)] = 7125,
  [SMALL_STATE(514)] = 7198,
  [SMALL_STATE(515)] = 7269,
  [SMALL_STATE(516)] = 7342,
  [SMALL_STATE(517)] = 7409,
  [SMALL_STATE(518)] = 7478,
  [SMALL_STATE(519)] = 7545,
  [SMALL_STATE(520)] = 7618,
  [SMALL_STATE(521)] = 7685,
  [SMALL_STATE(522)] = 7752,
  [SMALL_STATE(523)] = 7819,
  [SMALL_STATE(524)] = 7890,
  [SMALL_STATE(525)] = 7959,
  [SMALL_STATE(526)] = 8027,
  [SMALL_STATE(527)] = 8091,
  [SMALL_STATE(528)] = 8155,
  [SMALL_STATE(529)] = 8219,
  [SMALL_STATE(530)] = 8269,
  [SMALL_STATE(531)] = 8321,
  [SMALL_STATE(532)] = 8385,
  [SMALL_STATE(533)] = 8449,
  [SMALL_STATE(534)] = 8517,
  [SMALL_STATE(535)] = 8581,
  [SMALL_STATE(536)] = 8649,
  [SMALL_STATE(537)] = 8701,
  [SMALL_STATE(538)] = 8765,
  [SMALL_STATE(539)] = 8833,
  [SMALL_STATE(540)] = 8901,
  [SMALL_STATE(541)] = 8965,
  [SMALL_STATE(542)] = 9033,
  [SMALL_STATE(543)] = 9097,
  [SMALL_STATE(544)] = 9165,
  [SMALL_STATE(545)] = 9232,
  [SMALL_STATE(546)] = 9299,
  [SMALL_STATE(547)] = 9366,
  [SMALL_STATE(548)] = 9433,
  [SMALL_STATE(549)] = 9500,
  [SMALL_STATE(550)] = 9567,
  [SMALL_STATE(551)] = 9634,
  [SMALL_STATE(552)] = 9701,
  [SMALL_STATE(553)] = 9768,
  [SMALL_STATE(554)] = 9835,
  [SMALL_STATE(555)] = 9902,
  [SMALL_STATE(556)] = 9969,
  [SMALL_STATE(557)] = 10036,
  [SMALL_STATE(558)] = 10103,
  [SMALL_STATE(559)] = 10170,
  [SMALL_STATE(560)] = 10237,
  [SMALL_STATE(561)] = 10304,
  [SMALL_STATE(562)] = 10371,
  [SMALL_STATE(563)] = 10438,
  [SMALL_STATE(564)] = 10499,
  [SMALL_STATE(565)] = 10566,
  [SMALL_STATE(566)] = 10633,
  [SMALL_STATE(567)] = 10700,
  [SMALL_STATE(568)] = 10767,
  [SMALL_STATE(569)] = 10834,
  [SMALL_STATE(570)] = 10901,
  [SMALL_STATE(571)] = 10968,
  [SMALL_STATE(572)] = 11035,
  [SMALL_STATE(573)] = 11096,
  [SMALL_STATE(574)] = 11157,
  [SMALL_STATE(575)] = 11224,
  [SMALL_STATE(576)] = 11291,
  [SMALL_STATE(577)] = 11358,
  [SMALL_STATE(578)] = 11425,
  [SMALL_STATE(579)] = 11492,
  [SMALL_STATE(580)] = 11559,
  [SMALL_STATE(581)] = 11626,
  [SMALL_STATE(582)] = 11693,
  [SMALL_STATE(583)] = 11760,
  [SMALL_STATE(584)] = 11827,
  [SMALL_STATE(585)] = 11894,
  [SMALL_STATE(586)] = 11961,
  [SMALL_STATE(587)] = 12028,
  [SMALL_STATE(588)] = 12095,
  [SMALL_STATE(589)] = 12162,
  [SMALL_STATE(590)] = 12229,
  [SMALL_STATE(591)] = 12296,
  [SMALL_STATE(592)] = 12363,
  [SMALL_STATE(593)] = 12430,
  [SMALL_STATE(594)] = 12497,
  [SMALL_STATE(595)] = 12564,
  [SMALL_STATE(596)] = 12631,
  [SMALL_STATE(597)] = 12698,
  [SMALL_STATE(598)] = 12765,
  [SMALL_STATE(599)] = 12832,
  [SMALL_STATE(600)] = 12899,
  [SMALL_STATE(601)] = 12966,
  [SMALL_STATE(602)] = 13033,
  [SMALL_STATE(603)] = 13100,
  [SMALL_STATE(604)] = 13180,
  [SMALL_STATE(605)] = 13260,
  [SMALL_STATE(606)] = 13340,
  [SMALL_STATE(607)] = 13420,
  [SMALL_STATE(608)] = 13500,
  [SMALL_STATE(609)] = 13580,
  [SMALL_STATE(610)] = 13660,
  [SMALL_STATE(611)] = 13719,
  [SMALL_STATE(612)] = 13778,
  [SMALL_STATE(613)] = 13854,
  [SMALL_STATE(614)] = 13940,
  [SMALL_STATE(615)] = 14026,
  [SMALL_STATE(616)] = 14102,
  [SMALL_STATE(617)] = 14188,
  [SMALL_STATE(618)] = 14264,
  [SMALL_STATE(619)] = 14340,
  [SMALL_STATE(620)] = 14416,
  [SMALL_STATE(621)] = 14492,
  [SMALL_STATE(622)] = 14568,
  [SMALL_STATE(623)] = 14626,
  [SMALL_STATE(624)] = 14684,
  [SMALL_STATE(625)] = 14770,
  [SMALL_STATE(626)] = 14828,
  [SMALL_STATE(627)] = 14886,
  [SMALL_STATE(628)] = 14969,
  [SMALL_STATE(629)] = 15052,
  [SMALL_STATE(630)] = 15135,
  [SMALL_STATE(631)] = 15218,
  [SMALL_STATE(632)] = 15275,
  [SMALL_STATE(633)] = 15356,
  [SMALL_STATE(634)] = 15439,
  [SMALL_STATE(635)] = 15492,
  [SMALL_STATE(636)] = 15575,
  [SMALL_STATE(637)] = 15658,
  [SMALL_STATE(638)] = 15715,
  [SMALL_STATE(639)] = 15798,
  [SMALL_STATE(640)] = 15881,
  [SMALL_STATE(641)] = 15964,
  [SMALL_STATE(642)] = 16047,
  [SMALL_STATE(643)] = 16130,
  [SMALL_STATE(644)] = 16213,
  [SMALL_STATE(645)] = 16266,
  [SMALL_STATE(646)] = 16349,
  [SMALL_STATE(647)] = 16432,
  [SMALL_STATE(648)] = 16515,
  [SMALL_STATE(649)] = 16598,
  [SMALL_STATE(650)] = 16681,
  [SMALL_STATE(651)] = 16761,
  [SMALL_STATE(652)] = 16841,
  [SMALL_STATE(653)] = 16921,
  [SMALL_STATE(654)] = 17001,
  [SMALL_STATE(655)] = 17081,
  [SMALL_STATE(656)] = 17161,
  [SMALL_STATE(657)] = 17241,
  [SMALL_STATE(658)] = 17293,
  [SMALL_STATE(659)] = 17373,
  [SMALL_STATE(660)] = 17453,
  [SMALL_STATE(661)] = 17533,
  [SMALL_STATE(662)] = 17613,
  [SMALL_STATE(663)] = 17665,
  [SMALL_STATE(664)] = 17745,
  [SMALL_STATE(665)] = 17825,
  [SMALL_STATE(666)] = 17905,
  [SMALL_STATE(667)] = 17985,
  [SMALL_STATE(668)] = 18065,
  [SMALL_STATE(669)] = 18145,
  [SMALL_STATE(670)] = 18225,
  [SMALL_STATE(671)] = 18305,
  [SMALL_STATE(672)] = 18385,
  [SMALL_STATE(673)] = 18465,
  [SMALL_STATE(674)] = 18545,
  [SMALL_STATE(675)] = 18625,
  [SMALL_STATE(676)] = 18669,
  [SMALL_STATE(677)] = 18749,
  [SMALL_STATE(678)] = 18805,
  [SMALL_STATE(679)] = 18885,
  [SMALL_STATE(680)] = 18933,
  [SMALL_STATE(681)] = 19006,
  [SMALL_STATE(682)] = 19079,
  [SMALL_STATE(683)] = 19152,
  [SMALL_STATE(684)] = 19225,
  [SMALL_STATE(685)] = 19298,
  [SMALL_STATE(686)] = 19339,
  [SMALL_STATE(687)] = 19380,
  [SMALL_STATE(688)] = 19421,
  [SMALL_STATE(689)] = 19464,
  [SMALL_STATE(690)] = 19537,
  [SMALL_STATE(691)] = 19610,
  [SMALL_STATE(692)] = 19661,
  [SMALL_STATE(693)] = 19704,
  [SMALL_STATE(694)] = 19755,
  [SMALL_STATE(695)] = 19802,
  [SMALL_STATE(696)] = 19847,
  [SMALL_STATE(697)] = 19926,
  [SMALL_STATE(698)] = 19981,
  [SMALL_STATE(699)] = 20028,
  [SMALL_STATE(700)] = 20075,
  [SMALL_STATE(701)] = 20122,
  [SMALL_STATE(702)] = 20194,
  [SMALL_STATE(703)] = 20234,
  [SMALL_STATE(704)] = 20274,
  [SMALL_STATE(705)] = 20314,
  [SMALL_STATE(706)] = 20354,
  [SMALL_STATE(707)] = 20394,
  [SMALL_STATE(708)] = 20440,
  [SMALL_STATE(709)] = 20480,
  [SMALL_STATE(710)] = 20520,
  [SMALL_STATE(711)] = 20560,
  [SMALL_STATE(712)] = 20600,
  [SMALL_STATE(713)] = 20640,
  [SMALL_STATE(714)] = 20718,
  [SMALL_STATE(715)] = 20758,
  [SMALL_STATE(716)] = 20798,
  [SMALL_STATE(717)] = 20838,
  [SMALL_STATE(718)] = 20878,
  [SMALL_STATE(719)] = 20918,
  [SMALL_STATE(720)] = 20958,
  [SMALL_STATE(721)] = 20998,
  [SMALL_STATE(722)] = 21038,
  [SMALL_STATE(723)] = 21078,
  [SMALL_STATE(724)] = 21118,
  [SMALL_STATE(725)] = 21164,
  [SMALL_STATE(726)] = 21204,
  [SMALL_STATE(727)] = 21244,
  [SMALL_STATE(728)] = 21284,
  [SMALL_STATE(729)] = 21324,
  [SMALL_STATE(730)] = 21364,
  [SMALL_STATE(731)] = 21404,
  [SMALL_STATE(732)] = 21444,
  [SMALL_STATE(733)] = 21484,
  [SMALL_STATE(734)] = 21556,
  [SMALL_STATE(735)] = 21628,
  [SMALL_STATE(736)] = 21700,
  [SMALL_STATE(737)] = 21772,
  [SMALL_STATE(738)] = 21812,
  [SMALL_STATE(739)] = 21852,
  [SMALL_STATE(740)] = 21924,
  [SMALL_STATE(741)] = 21964,
  [SMALL_STATE(742)] = 22004,
  [SMALL_STATE(743)] = 22044,
  [SMALL_STATE(744)] = 22086,
  [SMALL_STATE(745)] = 22126,
  [SMALL_STATE(746)] = 22166,
  [SMALL_STATE(747)] = 22238,
  [SMALL_STATE(748)] = 22315,
  [SMALL_STATE(749)] = 22392,
  [SMALL_STATE(750)] = 22437,
  [SMALL_STATE(751)] = 22514,
  [SMALL_STATE(752)] = 22559,
  [SMALL_STATE(753)] = 22636,
  [SMALL_STATE(754)] = 22707,
  [SMALL_STATE(755)] = 22778,
  [SMALL_STATE(756)] = 22855,
  [SMALL_STATE(757)] = 22932,
  [SMALL_STATE(758)] = 23003,
  [SMALL_STATE(759)] = 23052,
  [SMALL_STATE(760)] = 23123,
  [SMALL_STATE(761)] = 23194,
  [SMALL_STATE(762)] = 23271,
  [SMALL_STATE(763)] = 23348,
  [SMALL_STATE(764)] = 23419,
  [SMALL_STATE(765)] = 23464,
  [SMALL_STATE(766)] = 23535,
  [SMALL_STATE(767)] = 23612,
  [SMALL_STATE(768)] = 23689,
  [SMALL_STATE(769)] = 23766,
  [SMALL_STATE(770)] = 23843,
  [SMALL_STATE(771)] = 23920,
  [SMALL_STATE(772)] = 23997,
  [SMALL_STATE(773)] = 24074,
  [SMALL_STATE(774)] = 24151,
  [SMALL_STATE(775)] = 24228,
  [SMALL_STATE(776)] = 24302,
  [SMALL_STATE(777)] = 24376,
  [SMALL_STATE(778)] = 24444,
  [SMALL_STATE(779)] = 24518,
  [SMALL_STATE(780)] = 24562,
  [SMALL_STATE(781)] = 24636,
  [SMALL_STATE(782)] = 24710,
  [SMALL_STATE(783)] = 24750,
  [SMALL_STATE(784)] = 24824,
  [SMALL_STATE(785)] = 24898,
  [SMALL_STATE(786)] = 24972,
  [SMALL_STATE(787)] = 25046,
  [SMALL_STATE(788)] = 25120,
  [SMALL_STATE(789)] = 25188,
  [SMALL_STATE(790)] = 25262,
  [SMALL_STATE(791)] = 25306,
  [SMALL_STATE(792)] = 25380,
  [SMALL_STATE(793)] = 25454,
  [SMALL_STATE(794)] = 25528,
  [SMALL_STATE(795)] = 25602,
  [SMALL_STATE(796)] = 25676,
  [SMALL_STATE(797)] = 25750,
  [SMALL_STATE(798)] = 25824,
  [SMALL_STATE(799)] = 25892,
  [SMALL_STATE(800)] = 25966,
  [SMALL_STATE(801)] = 26040,
  [SMALL_STATE(802)] = 26114,
  [SMALL_STATE(803)] = 26182,
  [SMALL_STATE(804)] = 26256,
  [SMALL_STATE(805)] = 26330,
  [SMALL_STATE(806)] = 26404,
  [SMALL_STATE(807)] = 26472,
  [SMALL_STATE(808)] = 26546,
  [SMALL_STATE(809)] = 26620,
  [SMALL_STATE(810)] = 26694,
  [SMALL_STATE(811)] = 26768,
  [SMALL_STATE(812)] = 26836,
  [SMALL_STATE(813)] = 26910,
  [SMALL_STATE(814)] = 26984,
  [SMALL_STATE(815)] = 27052,
  [SMALL_STATE(816)] = 27126,
  [SMALL_STATE(817)] = 27200,
  [SMALL_STATE(818)] = 27242,
  [SMALL_STATE(819)] = 27285,
  [SMALL_STATE(820)] = 27354,
  [SMALL_STATE(821)] = 27423,
  [SMALL_STATE(822)] = 27492,
  [SMALL_STATE(823)] = 27561,
  [SMALL_STATE(824)] = 27630,
  [SMALL_STATE(825)] = 27699,
  [SMALL_STATE(826)] = 27742,
  [SMALL_STATE(827)] = 27779,
  [SMALL_STATE(828)] = 27816,
  [SMALL_STATE(829)] = 27885,
  [SMALL_STATE(830)] = 27952,
  [SMALL_STATE(831)] = 27987,
  [SMALL_STATE(832)] = 28051,
  [SMALL_STATE(833)] = 28115,
  [SMALL_STATE(834)] = 28179,
  [SMALL_STATE(835)] = 28243,
  [SMALL_STATE(836)] = 28307,
  [SMALL_STATE(837)] = 28371,
  [SMALL_STATE(838)] = 28435,
  [SMALL_STATE(839)] = 28499,
  [SMALL_STATE(840)] = 28563,
  [SMALL_STATE(841)] = 28627,
  [SMALL_STATE(842)] = 28691,
  [SMALL_STATE(843)] = 28755,
  [SMALL_STATE(844)] = 28819,
  [SMALL_STATE(845)] = 28883,
  [SMALL_STATE(846)] = 28947,
  [SMALL_STATE(847)] = 29011,
  [SMALL_STATE(848)] = 29075,
  [SMALL_STATE(849)] = 29139,
  [SMALL_STATE(850)] = 29203,
  [SMALL_STATE(851)] = 29267,
  [SMALL_STATE(852)] = 29331,
  [SMALL_STATE(853)] = 29395,
  [SMALL_STATE(854)] = 29459,
  [SMALL_STATE(855)] = 29523,
  [SMALL_STATE(856)] = 29587,
  [SMALL_STATE(857)] = 29651,
  [SMALL_STATE(858)] = 29715,
  [SMALL_STATE(859)] = 29779,
  [SMALL_STATE(860)] = 29843,
  [SMALL_STATE(861)] = 29907,
  [SMALL_STATE(862)] = 29971,
  [SMALL_STATE(863)] = 30035,
  [SMALL_STATE(864)] = 30099,
  [SMALL_STATE(865)] = 30163,
  [SMALL_STATE(866)] = 30227,
  [SMALL_STATE(867)] = 30291,
  [SMALL_STATE(868)] = 30355,
  [SMALL_STATE(869)] = 30419,
  [SMALL_STATE(870)] = 30483,
  [SMALL_STATE(871)] = 30547,
  [SMALL_STATE(872)] = 30611,
  [SMALL_STATE(873)] = 30675,
  [SMALL_STATE(874)] = 30739,
  [SMALL_STATE(875)] = 30803,
  [SMALL_STATE(876)] = 30867,
  [SMALL_STATE(877)] = 30931,
  [SMALL_STATE(878)] = 30995,
  [SMALL_STATE(879)] = 31059,
  [SMALL_STATE(880)] = 31123,
  [SMALL_STATE(881)] = 31187,
  [SMALL_STATE(882)] = 31251,
  [SMALL_STATE(883)] = 31315,
  [SMALL_STATE(884)] = 31379,
  [SMALL_STATE(885)] = 31443,
  [SMALL_STATE(886)] = 31507,
  [SMALL_STATE(887)] = 31571,
  [SMALL_STATE(888)] = 31635,
  [SMALL_STATE(889)] = 31699,
  [SMALL_STATE(890)] = 31763,
  [SMALL_STATE(891)] = 31827,
  [SMALL_STATE(892)] = 31891,
  [SMALL_STATE(893)] = 31955,
  [SMALL_STATE(894)] = 32019,
  [SMALL_STATE(895)] = 32083,
  [SMALL_STATE(896)] = 32147,
  [SMALL_STATE(897)] = 32211,
  [SMALL_STATE(898)] = 32275,
  [SMALL_STATE(899)] = 32339,
  [SMALL_STATE(900)] = 32403,
  [SMALL_STATE(901)] = 32467,
  [SMALL_STATE(902)] = 32531,
  [SMALL_STATE(903)] = 32595,
  [SMALL_STATE(904)] = 32659,
  [SMALL_STATE(905)] = 32723,
  [SMALL_STATE(906)] = 32787,
  [SMALL_STATE(907)] = 32851,
  [SMALL_STATE(908)] = 32915,
  [SMALL_STATE(909)] = 32979,
  [SMALL_STATE(910)] = 33043,
  [SMALL_STATE(911)] = 33107,
  [SMALL_STATE(912)] = 33171,
  [SMALL_STATE(913)] = 33235,
  [SMALL_STATE(914)] = 33299,
  [SMALL_STATE(915)] = 33363,
  [SMALL_STATE(916)] = 33427,
  [SMALL_STATE(917)] = 33491,
  [SMALL_STATE(918)] = 33555,
  [SMALL_STATE(919)] = 33619,
  [SMALL_STATE(920)] = 33683,
  [SMALL_STATE(921)] = 33747,
  [SMALL_STATE(922)] = 33811,
  [SMALL_STATE(923)] = 33872,
  [SMALL_STATE(924)] = 33933,
  [SMALL_STATE(925)] = 33994,
  [SMALL_STATE(926)] = 34055,
  [SMALL_STATE(927)] = 34116,
  [SMALL_STATE(928)] = 34177,
  [SMALL_STATE(929)] = 34238,
  [SMALL_STATE(930)] = 34299,
  [SMALL_STATE(931)] = 34360,
  [SMALL_STATE(932)] = 34421,
  [SMALL_STATE(933)] = 34482,
  [SMALL_STATE(934)] = 34519,
  [SMALL_STATE(935)] = 34580,
  [SMALL_STATE(936)] = 34641,
  [SMALL_STATE(937)] = 34702,
  [SMALL_STATE(938)] = 34763,
  [SMALL_STATE(939)] = 34797,
  [SMALL_STATE(940)] = 34831,
  [SMALL_STATE(941)] = 34891,
  [SMALL_STATE(942)] = 34923,
  [SMALL_STATE(943)] = 34955,
  [SMALL_STATE(944)] = 35012,
  [SMALL_STATE(945)] = 35049,
  [SMALL_STATE(946)] = 35106,
  [SMALL_STATE(947)] = 35160,
  [SMALL_STATE(948)] = 35212,
  [SMALL_STATE(949)] = 35264,
  [SMALL_STATE(950)] = 35316,
  [SMALL_STATE(951)] = 35370,
  [SMALL_STATE(952)] = 35422,
  [SMALL_STATE(953)] = 35455,
  [SMALL_STATE(954)] = 35490,
  [SMALL_STATE(955)] = 35522,
  [SMALL_STATE(956)] = 35554,
  [SMALL_STATE(957)] = 35584,
  [SMALL_STATE(958)] = 35611,
  [SMALL_STATE(959)] = 35644,
  [SMALL_STATE(960)] = 35669,
  [SMALL_STATE(961)] = 35694,
  [SMALL_STATE(962)] = 35714,
  [SMALL_STATE(963)] = 35730,
  [SMALL_STATE(964)] = 35746,
  [SMALL_STATE(965)] = 35770,
  [SMALL_STATE(966)] = 35794,
  [SMALL_STATE(967)] = 35817,
  [SMALL_STATE(968)] = 35840,
  [SMALL_STATE(969)] = 35863,
  [SMALL_STATE(970)] = 35890,
  [SMALL_STATE(971)] = 35917,
  [SMALL_STATE(972)] = 35944,
  [SMALL_STATE(973)] = 35967,
  [SMALL_STATE(974)] = 35994,
  [SMALL_STATE(975)] = 36021,
  [SMALL_STATE(976)] = 36037,
  [SMALL_STATE(977)] = 36059,
  [SMALL_STATE(978)] = 36081,
  [SMALL_STATE(979)] = 36103,
  [SMALL_STATE(980)] = 36125,
  [SMALL_STATE(981)] = 36147,
  [SMALL_STATE(982)] = 36168,
  [SMALL_STATE(983)] = 36183,
  [SMALL_STATE(984)] = 36208,
  [SMALL_STATE(985)] = 36231,
  [SMALL_STATE(986)] = 36256,
  [SMALL_STATE(987)] = 36271,
  [SMALL_STATE(988)] = 36292,
  [SMALL_STATE(989)] = 36315,
  [SMALL_STATE(990)] = 36330,
  [SMALL_STATE(991)] = 36355,
  [SMALL_STATE(992)] = 36380,
  [SMALL_STATE(993)] = 36399,
  [SMALL_STATE(994)] = 36418,
  [SMALL_STATE(995)] = 36436,
  [SMALL_STATE(996)] = 36458,
  [SMALL_STATE(997)] = 36474,
  [SMALL_STATE(998)] = 36490,
  [SMALL_STATE(999)] = 36512,
  [SMALL_STATE(1000)] = 36530,
  [SMALL_STATE(1001)] = 36552,
  [SMALL_STATE(1002)] = 36568,
  [SMALL_STATE(1003)] = 36590,
  [SMALL_STATE(1004)] = 36608,
  [SMALL_STATE(1005)] = 36622,
  [SMALL_STATE(1006)] = 36644,
  [SMALL_STATE(1007)] = 36656,
  [SMALL_STATE(1008)] = 36678,
  [SMALL_STATE(1009)] = 36694,
  [SMALL_STATE(1010)] = 36710,
  [SMALL_STATE(1011)] = 36726,
  [SMALL_STATE(1012)] = 36748,
  [SMALL_STATE(1013)] = 36768,
  [SMALL_STATE(1014)] = 36790,
  [SMALL_STATE(1015)] = 36812,
  [SMALL_STATE(1016)] = 36830,
  [SMALL_STATE(1017)] = 36848,
  [SMALL_STATE(1018)] = 36870,
  [SMALL_STATE(1019)] = 36889,
  [SMALL_STATE(1020)] = 36908,
  [SMALL_STATE(1021)] = 36925,
  [SMALL_STATE(1022)] = 36942,
  [SMALL_STATE(1023)] = 36961,
  [SMALL_STATE(1024)] = 36978,
  [SMALL_STATE(1025)] = 36991,
  [SMALL_STATE(1026)] = 37010,
  [SMALL_STATE(1027)] = 37023,
  [SMALL_STATE(1028)] = 37036,
  [SMALL_STATE(1029)] = 37049,
  [SMALL_STATE(1030)] = 37068,
  [SMALL_STATE(1031)] = 37083,
  [SMALL_STATE(1032)] = 37096,
  [SMALL_STATE(1033)] = 37115,
  [SMALL_STATE(1034)] = 37132,
  [SMALL_STATE(1035)] = 37145,
  [SMALL_STATE(1036)] = 37164,
  [SMALL_STATE(1037)] = 37181,
  [SMALL_STATE(1038)] = 37193,
  [SMALL_STATE(1039)] = 37209,
  [SMALL_STATE(1040)] = 37225,
  [SMALL_STATE(1041)] = 37237,
  [SMALL_STATE(1042)] = 37249,
  [SMALL_STATE(1043)] = 37265,
  [SMALL_STATE(1044)] = 37281,
  [SMALL_STATE(1045)] = 37297,
  [SMALL_STATE(1046)] = 37309,
  [SMALL_STATE(1047)] = 37321,
  [SMALL_STATE(1048)] = 37337,
  [SMALL_STATE(1049)] = 37349,
  [SMALL_STATE(1050)] = 37365,
  [SMALL_STATE(1051)] = 37381,
  [SMALL_STATE(1052)] = 37397,
  [SMALL_STATE(1053)] = 37413,
  [SMALL_STATE(1054)] = 37429,
  [SMALL_STATE(1055)] = 37445,
  [SMALL_STATE(1056)] = 37459,
  [SMALL_STATE(1057)] = 37475,
  [SMALL_STATE(1058)] = 37491,
  [SMALL_STATE(1059)] = 37507,
  [SMALL_STATE(1060)] = 37523,
  [SMALL_STATE(1061)] = 37539,
  [SMALL_STATE(1062)] = 37555,
  [SMALL_STATE(1063)] = 37571,
  [SMALL_STATE(1064)] = 37587,
  [SMALL_STATE(1065)] = 37603,
  [SMALL_STATE(1066)] = 37619,
  [SMALL_STATE(1067)] = 37635,
  [SMALL_STATE(1068)] = 37651,
  [SMALL_STATE(1069)] = 37667,
  [SMALL_STATE(1070)] = 37683,
  [SMALL_STATE(1071)] = 37699,
  [SMALL_STATE(1072)] = 37715,
  [SMALL_STATE(1073)] = 37731,
  [SMALL_STATE(1074)] = 37747,
  [SMALL_STATE(1075)] = 37763,
  [SMALL_STATE(1076)] = 37779,
  [SMALL_STATE(1077)] = 37795,
  [SMALL_STATE(1078)] = 37811,
  [SMALL_STATE(1079)] = 37827,
  [SMALL_STATE(1080)] = 37843,
  [SMALL_STATE(1081)] = 37859,
  [SMALL_STATE(1082)] = 37875,
  [SMALL_STATE(1083)] = 37891,
  [SMALL_STATE(1084)] = 37907,
  [SMALL_STATE(1085)] = 37923,
  [SMALL_STATE(1086)] = 37939,
  [SMALL_STATE(1087)] = 37955,
  [SMALL_STATE(1088)] = 37971,
  [SMALL_STATE(1089)] = 37987,
  [SMALL_STATE(1090)] = 38003,
  [SMALL_STATE(1091)] = 38019,
  [SMALL_STATE(1092)] = 38035,
  [SMALL_STATE(1093)] = 38051,
  [SMALL_STATE(1094)] = 38065,
  [SMALL_STATE(1095)] = 38081,
  [SMALL_STATE(1096)] = 38093,
  [SMALL_STATE(1097)] = 38109,
  [SMALL_STATE(1098)] = 38125,
  [SMALL_STATE(1099)] = 38141,
  [SMALL_STATE(1100)] = 38157,
  [SMALL_STATE(1101)] = 38173,
  [SMALL_STATE(1102)] = 38189,
  [SMALL_STATE(1103)] = 38201,
  [SMALL_STATE(1104)] = 38211,
  [SMALL_STATE(1105)] = 38227,
  [SMALL_STATE(1106)] = 38239,
  [SMALL_STATE(1107)] = 38255,
  [SMALL_STATE(1108)] = 38265,
  [SMALL_STATE(1109)] = 38281,
  [SMALL_STATE(1110)] = 38297,
  [SMALL_STATE(1111)] = 38311,
  [SMALL_STATE(1112)] = 38321,
  [SMALL_STATE(1113)] = 38337,
  [SMALL_STATE(1114)] = 38353,
  [SMALL_STATE(1115)] = 38369,
  [SMALL_STATE(1116)] = 38385,
  [SMALL_STATE(1117)] = 38401,
  [SMALL_STATE(1118)] = 38417,
  [SMALL_STATE(1119)] = 38433,
  [SMALL_STATE(1120)] = 38447,
  [SMALL_STATE(1121)] = 38459,
  [SMALL_STATE(1122)] = 38473,
  [SMALL_STATE(1123)] = 38483,
  [SMALL_STATE(1124)] = 38496,
  [SMALL_STATE(1125)] = 38509,
  [SMALL_STATE(1126)] = 38522,
  [SMALL_STATE(1127)] = 38535,
  [SMALL_STATE(1128)] = 38548,
  [SMALL_STATE(1129)] = 38559,
  [SMALL_STATE(1130)] = 38572,
  [SMALL_STATE(1131)] = 38585,
  [SMALL_STATE(1132)] = 38598,
  [SMALL_STATE(1133)] = 38611,
  [SMALL_STATE(1134)] = 38624,
  [SMALL_STATE(1135)] = 38637,
  [SMALL_STATE(1136)] = 38648,
  [SMALL_STATE(1137)] = 38661,
  [SMALL_STATE(1138)] = 38674,
  [SMALL_STATE(1139)] = 38687,
  [SMALL_STATE(1140)] = 38700,
  [SMALL_STATE(1141)] = 38713,
  [SMALL_STATE(1142)] = 38726,
  [SMALL_STATE(1143)] = 38739,
  [SMALL_STATE(1144)] = 38752,
  [SMALL_STATE(1145)] = 38765,
  [SMALL_STATE(1146)] = 38778,
  [SMALL_STATE(1147)] = 38791,
  [SMALL_STATE(1148)] = 38804,
  [SMALL_STATE(1149)] = 38815,
  [SMALL_STATE(1150)] = 38828,
  [SMALL_STATE(1151)] = 38841,
  [SMALL_STATE(1152)] = 38854,
  [SMALL_STATE(1153)] = 38867,
  [SMALL_STATE(1154)] = 38880,
  [SMALL_STATE(1155)] = 38893,
  [SMALL_STATE(1156)] = 38906,
  [SMALL_STATE(1157)] = 38919,
  [SMALL_STATE(1158)] = 38932,
  [SMALL_STATE(1159)] = 38945,
  [SMALL_STATE(1160)] = 38958,
  [SMALL_STATE(1161)] = 38971,
  [SMALL_STATE(1162)] = 38984,
  [SMALL_STATE(1163)] = 38997,
  [SMALL_STATE(1164)] = 39006,
  [SMALL_STATE(1165)] = 39019,
  [SMALL_STATE(1166)] = 39032,
  [SMALL_STATE(1167)] = 39045,
  [SMALL_STATE(1168)] = 39058,
  [SMALL_STATE(1169)] = 39071,
  [SMALL_STATE(1170)] = 39082,
  [SMALL_STATE(1171)] = 39095,
  [SMALL_STATE(1172)] = 39108,
  [SMALL_STATE(1173)] = 39119,
  [SMALL_STATE(1174)] = 39132,
  [SMALL_STATE(1175)] = 39145,
  [SMALL_STATE(1176)] = 39158,
  [SMALL_STATE(1177)] = 39171,
  [SMALL_STATE(1178)] = 39182,
  [SMALL_STATE(1179)] = 39195,
  [SMALL_STATE(1180)] = 39208,
  [SMALL_STATE(1181)] = 39217,
  [SMALL_STATE(1182)] = 39230,
  [SMALL_STATE(1183)] = 39241,
  [SMALL_STATE(1184)] = 39254,
  [SMALL_STATE(1185)] = 39267,
  [SMALL_STATE(1186)] = 39280,
  [SMALL_STATE(1187)] = 39293,
  [SMALL_STATE(1188)] = 39306,
  [SMALL_STATE(1189)] = 39319,
  [SMALL_STATE(1190)] = 39330,
  [SMALL_STATE(1191)] = 39340,
  [SMALL_STATE(1192)] = 39350,
  [SMALL_STATE(1193)] = 39360,
  [SMALL_STATE(1194)] = 39370,
  [SMALL_STATE(1195)] = 39380,
  [SMALL_STATE(1196)] = 39390,
  [SMALL_STATE(1197)] = 39400,
  [SMALL_STATE(1198)] = 39410,
  [SMALL_STATE(1199)] = 39418,
  [SMALL_STATE(1200)] = 39428,
  [SMALL_STATE(1201)] = 39438,
  [SMALL_STATE(1202)] = 39448,
  [SMALL_STATE(1203)] = 39456,
  [SMALL_STATE(1204)] = 39466,
  [SMALL_STATE(1205)] = 39476,
  [SMALL_STATE(1206)] = 39486,
  [SMALL_STATE(1207)] = 39496,
  [SMALL_STATE(1208)] = 39506,
  [SMALL_STATE(1209)] = 39514,
  [SMALL_STATE(1210)] = 39524,
  [SMALL_STATE(1211)] = 39534,
  [SMALL_STATE(1212)] = 39544,
  [SMALL_STATE(1213)] = 39554,
  [SMALL_STATE(1214)] = 39564,
  [SMALL_STATE(1215)] = 39574,
  [SMALL_STATE(1216)] = 39582,
  [SMALL_STATE(1217)] = 39592,
  [SMALL_STATE(1218)] = 39602,
  [SMALL_STATE(1219)] = 39612,
  [SMALL_STATE(1220)] = 39620,
  [SMALL_STATE(1221)] = 39630,
  [SMALL_STATE(1222)] = 39640,
  [SMALL_STATE(1223)] = 39650,
  [SMALL_STATE(1224)] = 39660,
  [SMALL_STATE(1225)] = 39670,
  [SMALL_STATE(1226)] = 39680,
  [SMALL_STATE(1227)] = 39690,
  [SMALL_STATE(1228)] = 39700,
  [SMALL_STATE(1229)] = 39710,
  [SMALL_STATE(1230)] = 39720,
  [SMALL_STATE(1231)] = 39730,
  [SMALL_STATE(1232)] = 39740,
  [SMALL_STATE(1233)] = 39750,
  [SMALL_STATE(1234)] = 39760,
  [SMALL_STATE(1235)] = 39770,
  [SMALL_STATE(1236)] = 39778,
  [SMALL_STATE(1237)] = 39788,
  [SMALL_STATE(1238)] = 39796,
  [SMALL_STATE(1239)] = 39804,
  [SMALL_STATE(1240)] = 39814,
  [SMALL_STATE(1241)] = 39824,
  [SMALL_STATE(1242)] = 39834,
  [SMALL_STATE(1243)] = 39844,
  [SMALL_STATE(1244)] = 39854,
  [SMALL_STATE(1245)] = 39864,
  [SMALL_STATE(1246)] = 39872,
  [SMALL_STATE(1247)] = 39882,
  [SMALL_STATE(1248)] = 39892,
  [SMALL_STATE(1249)] = 39900,
  [SMALL_STATE(1250)] = 39910,
  [SMALL_STATE(1251)] = 39920,
  [SMALL_STATE(1252)] = 39930,
  [SMALL_STATE(1253)] = 39940,
  [SMALL_STATE(1254)] = 39950,
  [SMALL_STATE(1255)] = 39960,
  [SMALL_STATE(1256)] = 39968,
  [SMALL_STATE(1257)] = 39978,
  [SMALL_STATE(1258)] = 39988,
  [SMALL_STATE(1259)] = 39998,
  [SMALL_STATE(1260)] = 40008,
  [SMALL_STATE(1261)] = 40018,
  [SMALL_STATE(1262)] = 40028,
  [SMALL_STATE(1263)] = 40038,
  [SMALL_STATE(1264)] = 40045,
  [SMALL_STATE(1265)] = 40052,
  [SMALL_STATE(1266)] = 40059,
  [SMALL_STATE(1267)] = 40066,
  [SMALL_STATE(1268)] = 40073,
  [SMALL_STATE(1269)] = 40080,
  [SMALL_STATE(1270)] = 40087,
  [SMALL_STATE(1271)] = 40094,
  [SMALL_STATE(1272)] = 40101,
  [SMALL_STATE(1273)] = 40108,
  [SMALL_STATE(1274)] = 40115,
  [SMALL_STATE(1275)] = 40122,
  [SMALL_STATE(1276)] = 40129,
  [SMALL_STATE(1277)] = 40136,
  [SMALL_STATE(1278)] = 40143,
  [SMALL_STATE(1279)] = 40150,
  [SMALL_STATE(1280)] = 40157,
  [SMALL_STATE(1281)] = 40164,
  [SMALL_STATE(1282)] = 40171,
  [SMALL_STATE(1283)] = 40178,
  [SMALL_STATE(1284)] = 40185,
  [SMALL_STATE(1285)] = 40192,
  [SMALL_STATE(1286)] = 40199,
  [SMALL_STATE(1287)] = 40206,
  [SMALL_STATE(1288)] = 40213,
  [SMALL_STATE(1289)] = 40220,
  [SMALL_STATE(1290)] = 40227,
  [SMALL_STATE(1291)] = 40234,
  [SMALL_STATE(1292)] = 40241,
  [SMALL_STATE(1293)] = 40248,
  [SMALL_STATE(1294)] = 40255,
  [SMALL_STATE(1295)] = 40262,
  [SMALL_STATE(1296)] = 40269,
  [SMALL_STATE(1297)] = 40276,
  [SMALL_STATE(1298)] = 40283,
  [SMALL_STATE(1299)] = 40290,
  [SMALL_STATE(1300)] = 40297,
  [SMALL_STATE(1301)] = 40304,
  [SMALL_STATE(1302)] = 40311,
  [SMALL_STATE(1303)] = 40318,
  [SMALL_STATE(1304)] = 40325,
  [SMALL_STATE(1305)] = 40332,
  [SMALL_STATE(1306)] = 40339,
  [SMALL_STATE(1307)] = 40346,
  [SMALL_STATE(1308)] = 40353,
  [SMALL_STATE(1309)] = 40360,
  [SMALL_STATE(1310)] = 40367,
  [SMALL_STATE(1311)] = 40374,
  [SMALL_STATE(1312)] = 40381,
  [SMALL_STATE(1313)] = 40388,
  [SMALL_STATE(1314)] = 40395,
  [SMALL_STATE(1315)] = 40402,
  [SMALL_STATE(1316)] = 40409,
  [SMALL_STATE(1317)] = 40416,
  [SMALL_STATE(1318)] = 40423,
  [SMALL_STATE(1319)] = 40430,
  [SMALL_STATE(1320)] = 40437,
  [SMALL_STATE(1321)] = 40444,
  [SMALL_STATE(1322)] = 40451,
  [SMALL_STATE(1323)] = 40458,
  [SMALL_STATE(1324)] = 40465,
  [SMALL_STATE(1325)] = 40472,
  [SMALL_STATE(1326)] = 40479,
  [SMALL_STATE(1327)] = 40486,
  [SMALL_STATE(1328)] = 40493,
  [SMALL_STATE(1329)] = 40500,
  [SMALL_STATE(1330)] = 40507,
  [SMALL_STATE(1331)] = 40514,
  [SMALL_STATE(1332)] = 40521,
  [SMALL_STATE(1333)] = 40528,
  [SMALL_STATE(1334)] = 40535,
  [SMALL_STATE(1335)] = 40542,
  [SMALL_STATE(1336)] = 40549,
  [SMALL_STATE(1337)] = 40556,
  [SMALL_STATE(1338)] = 40563,
  [SMALL_STATE(1339)] = 40570,
  [SMALL_STATE(1340)] = 40577,
  [SMALL_STATE(1341)] = 40584,
  [SMALL_STATE(1342)] = 40591,
  [SMALL_STATE(1343)] = 40598,
  [SMALL_STATE(1344)] = 40605,
  [SMALL_STATE(1345)] = 40612,
  [SMALL_STATE(1346)] = 40619,
  [SMALL_STATE(1347)] = 40626,
  [SMALL_STATE(1348)] = 40633,
  [SMALL_STATE(1349)] = 40640,
  [SMALL_STATE(1350)] = 40647,
  [SMALL_STATE(1351)] = 40654,
  [SMALL_STATE(1352)] = 40661,
  [SMALL_STATE(1353)] = 40668,
  [SMALL_STATE(1354)] = 40675,
  [SMALL_STATE(1355)] = 40682,
  [SMALL_STATE(1356)] = 40689,
  [SMALL_STATE(1357)] = 40696,
  [SMALL_STATE(1358)] = 40703,
  [SMALL_STATE(1359)] = 40710,
  [SMALL_STATE(1360)] = 40717,
  [SMALL_STATE(1361)] = 40724,
  [SMALL_STATE(1362)] = 40731,
  [SMALL_STATE(1363)] = 40738,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [91] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(112),
  [94] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1200),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(414),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(340),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(475),
  [115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(399),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(509),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(401),
  [127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1317),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(348),
  [136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(928),
  [142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(928),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(403),
  [151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(536),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(418),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(417),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(415),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(413),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(100),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(973),
  [211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1051),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword, 1, 0, 0),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unaryExpression, 2, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unaryExpression, 2, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 4, 0, 30),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 4, 0, 30),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 10),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 10),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 4, 0, 31),
  [258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 4, 0, 31),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 4, 0, 20),
  [262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 4, 0, 20),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(70),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19),
  [271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(943),
  [274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(348),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1209),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(83),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(99),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(99),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(78),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(78),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(100),
  [298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(973),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1051),
  [304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 16),
  [306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 16),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 14),
  [310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 14),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(57),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1233),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 0),
  [322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 3, 0, 0),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(69),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1216),
  [336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 4, 0, 0),
  [338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair, 4, 0, 0),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 2),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 2),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 2),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 2),
  [370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 1, 0, 0),
  [372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 1, 0, 0),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preprocessor_statement, 3, 0, 0),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preprocessor_statement, 3, 0, 0),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preprocessor_statement, 4, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preprocessor_statement, 4, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 2),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 2),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 5, 0, 2),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 5, 0, 2),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 2),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 2),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_list, 3, 0, 0),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_list, 3, 0, 0),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_list, 4, 0, 0),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_list, 4, 0, 0),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_list, 5, 0, 0),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_list, 5, 0, 0),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_list, 2, 0, 0),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_list, 2, 0, 0),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 2, 0, 2),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 2, 0, 2),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_expression, 3, 0, 0),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_expression, 3, 0, 0),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs_expression, 1, 0, 0),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lhs_expression, 1, 0, 0),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call, 3, 0, 15),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call, 3, 0, 15),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 5, 0, 0),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 5, 0, 0),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_trace_expression, 4, 0, 0),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_trace_expression, 4, 0, 0),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 0),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 0),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 13),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 13),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 29),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 29),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 6, 0, 54),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 6, 0, 54),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_member_expression_repeat1, 1, 0, 9),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 1, 0, 9),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 3, 0, 0),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 3, 0, 0),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__prefixUnaryOperator, 1, 0, 0), REDUCE(sym__arithmeticOperator, 1, 0, 0),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__prefixUnaryOperator, 1, 0, 0), REDUCE(sym__arithmeticOperator, 1, 0, 0),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 0),
  [492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 0),
  [494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 2, 0, 2),
  [496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 2, 0, 2),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1, 0, 0),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1, 0, 0),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_runtime_type_check_expression, 3, 0, 8),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_runtime_type_check_expression, 3, 0, 8),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rhs_expression, 1, 0, 0),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__rhs_expression, 1, 0, 0),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2, 0, 0),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2, 0, 0),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__prefixUnaryOperator, 1, 0, 0), REDUCE(sym__postfixUnaryOperator, 1, 0, 0),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__prefixUnaryOperator, 1, 0, 0), REDUCE(sym__postfixUnaryOperator, 1, 0, 0),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__compoundAssignmentOperator, 2, 0, 0),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__compoundAssignmentOperator, 2, 0, 0),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call, 2, 0, 6),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call, 2, 0, 6),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 1, 0, 1),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 1, 0, 1),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 4, 0, 0),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 4, 0, 0),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_call, 1, 0, 1), REDUCE(sym_call_expression, 1, 0, 1),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_call, 1, 0, 1), REDUCE(sym_call_expression, 1, 0, 1),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, 0, 45),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, 0, 45),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 5, 0, 13),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 5, 0, 13),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 2),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 2),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_call, 2, 0, 5),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_call, 2, 0, 5),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1, 0, 0),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1, 0, 0),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool, 1, 0, 0),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool, 1, 0, 0),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, 0, 18),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, 0, 18),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3, 0, 52),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3, 0, 52),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 17),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 17),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, 0, 17),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2, 0, 17),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 18),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 18),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 32),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 32),
  [646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 32), SHIFT(8),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 50),
  [653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 50),
  [655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 50), SHIFT(8),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 101),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 101),
  [668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 101), SHIFT(8),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 32),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 32),
  [679] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 32), SHIFT(901),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 64),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 64),
  [691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 64), SHIFT(8),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_params, 4, 0, 0),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_params, 4, 0, 0),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 53),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 53),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 0),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 0),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 0),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 0),
  [710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 7),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 7),
  [716] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 5, 0, 7), SHIFT(901),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 34),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 34),
  [724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 34), SHIFT(8),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 62),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 62),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 62), SHIFT(8),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 2, 0, 4),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 2, 0, 4),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 51),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 51),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 51), SHIFT(8),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 99),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 99),
  [759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 99), SHIFT(8),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 93),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 93),
  [766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 93), SHIFT(8),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 42),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 42),
  [777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 42), SHIFT(8),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 50),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 50),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 50), SHIFT(8),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 95),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 95),
  [793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 95), SHIFT(8),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 44),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 44),
  [800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 44), SHIFT(8),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 51),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 51),
  [807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 51), SHIFT(8),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_params, 3, 0, 0),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_params, 3, 0, 0),
  [816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 4, 0, 7),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 4, 0, 7),
  [822] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 4, 0, 7), SHIFT(901),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 74),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 74),
  [830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 74), SHIFT(8),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 72),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 72),
  [837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 72), SHIFT(8),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 12),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 12),
  [844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 12), SHIFT(8),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 6, 0, 32),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 6, 0, 32),
  [855] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 17), REDUCE(sym_typedef_declaration, 6, 0, 32), SHIFT(901),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 7),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 7),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 7), SHIFT(8),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 116),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 116),
  [872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 116), SHIFT(8),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 12),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 12),
  [879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 12), SHIFT(8),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 118),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 118),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 118), SHIFT(8),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 7),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 7),
  [895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 7), SHIFT(8),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 34),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 34),
  [904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 34), SHIFT(8),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 32),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 32),
  [913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 32), SHIFT(8),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typedef_declaration, 6, 0, 32),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typedef_declaration, 6, 0, 32),
  [922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_arg_list, 2, 0, 0),
  [924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_arg_list, 2, 0, 0),
  [926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typedef_declaration, 4, 0, 7),
  [928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typedef_declaration, 4, 0, 7),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 3, 0, 4),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 3, 0, 4),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_arg_list, 3, 0, 0),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_arg_list, 3, 0, 0),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_arg_list, 4, 0, 0),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_arg_list, 4, 0, 0),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typedef_declaration, 5, 0, 7),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typedef_declaration, 5, 0, 7),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typedef_declaration, 5, 0, 32),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typedef_declaration, 5, 0, 32),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 89),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 89),
  [962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 41),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 41),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 39),
  [968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 39),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 3, 0, 7),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 3, 0, 7),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 63),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 63),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 66),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 66),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 67),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 67),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 68),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 68),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 60),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 60),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 59),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 59),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 102),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 102),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 58),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 58),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 32),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 32),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 7),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 7),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 103),
  [1022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 103),
  [1024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 69),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 69),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 7),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 7),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 104),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 104),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, 0, 11),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, 0, 11),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 38),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 38),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 57),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 57),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 11),
  [1054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 11),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 7),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 7),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 57),
  [1062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 57),
  [1064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 80),
  [1066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 80),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 105),
  [1070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 105),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 38),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 38),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 38),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 38),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 106),
  [1082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 106),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 71),
  [1086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 71),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 56),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 56),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 56),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 56),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 73),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 73),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 107),
  [1108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 107),
  [1110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 50),
  [1112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 6, 0, 50),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 55),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 55),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 108),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 108),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 37),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 37),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 68),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 68),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 36),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 36),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 37),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 37),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 65),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 65),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 75),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 75),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 36),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 36),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 109),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 109),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 76),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 76),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 77),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 77),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 5, 0, 35),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 5, 0, 35),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 78),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 78),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 32),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 32),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 79),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 79),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 38),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 38),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 110),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 110),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 50),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 50),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 57),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 57),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_statement, 3, 0, 7),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_statement, 3, 0, 7),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 47),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 47),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 111),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 111),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 112),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 112),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 49),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 49),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 113),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 113),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 80),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 80),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 100),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 100),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 114),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 114),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 7),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 7),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 97),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 97),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preprocessor_statement, 2, 0, 0),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preprocessor_statement, 2, 0, 0),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 7),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 7),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 47),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 47),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 81),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 81),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 82),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 82),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 40),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 40),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 32),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5, 0, 32),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 83),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 83),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 115),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 115),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 85),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 85),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 86),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 86),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 87),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 87),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 88),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 88),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 68),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 68),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 8, 0, 50),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 8, 0, 50),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 89),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 89),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 98),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 98),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 46),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 46),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 40),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 40),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 32),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 32),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 4, 0, 21),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 4, 0, 21),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 90),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 90),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 91),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 91),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 22),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 22),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 117),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 117),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 92),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 92),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 43),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 43),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 8, 0, 119),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 8, 0, 119),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 13, 0, 125),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 13, 0, 125),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 94),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 94),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 12, 0, 125),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 12, 0, 125),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 12, 0, 115),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 12, 0, 115),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 12, 0, 109),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 12, 0, 109),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 125),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 125),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 115),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 115),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 97),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 97),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 7),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 7),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 120),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 120),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 109),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 109),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 89),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 89),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 11, 0, 80),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 11, 0, 80),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 24),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 24),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 25),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 25),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 125),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 125),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 115),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 115),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 24),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 24),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 97),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 97),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 25),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 25),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 109),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 109),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 89),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 89),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 38),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 38),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7, 0, 96),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7, 0, 96),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 68),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 68),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 57),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 57),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 10, 0, 128),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 10, 0, 128),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 80),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 80),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 10, 0, 57),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 10, 0, 57),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 28),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 28),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, 0, 127),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 9, 0, 127),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 24),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 24),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 9, 0, 126),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 9, 0, 126),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 50),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 50),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 80),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 80),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 97),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 97),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 125),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 125),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 121),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 121),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 122),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 122),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 50),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 7, 0, 50),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 115),
  [1528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 115),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 97),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 97),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 124),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 124),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 33),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 33),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 109),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 109),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 89),
  [1548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 89),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 32),
  [1552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 32),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 123),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 123),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 9, 0, 68),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 9, 0, 68),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 3, 0, 0),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 3, 0, 0),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(459),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(340),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(943),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(755),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1317),
  [1592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(348),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1233),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(843),
  [1601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(88),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [1610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(82),
  [1613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [1625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [1631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(100),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(973),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1051),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [1739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(430),
  [1742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1257),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(456),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1194),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 2, 0, 0),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 1, 0, 0),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parenthesized_expression_repeat1, 1, 0, 0),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(492),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1205),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(476),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1251),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [1843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(928),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(928),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 2, 0, 3),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 2, 0, 3),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 6, 0, 3),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 6, 0, 3),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword, 1, 0, 0),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 5, 0, 3),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 5, 0, 3),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [1910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 3, 0, 0),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__arg_list_repeat1, 2, 0, 0),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__arg_list_repeat1, 3, 0, 0),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(818),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1258),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(976),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(624),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [2133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(943),
  [2136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(348),
  [2139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(1258),
  [2142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(1006),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(83),
  [2148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(99),
  [2151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(99),
  [2154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(78),
  [2157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(78),
  [2160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(100),
  [2163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(973),
  [2166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 1, 0, 0), SHIFT(1051),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [2175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(939),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1236),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [2209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(944),
  [2212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1250),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [2233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(957),
  [2236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1244),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [2255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(955),
  [2258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1191),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [2295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0), SHIFT(369),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [2300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(953),
  [2303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(943),
  [2306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(348),
  [2309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1223),
  [2312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(973),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1051),
  [2318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(817),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat2, 2, 0, 0),
  [2323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat2, 2, 0, 0),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(958),
  [2334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_member_expression_repeat1, 2, 0, 19), SHIFT_REPEAT(1227),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_identifiers, 3, 0, 0),
  [2339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_identifiers, 3, 0, 0),
  [2341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_identifiers, 5, 0, 0),
  [2343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_identifiers, 5, 0, 0),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binaryOperator, 1, 0, 0),
  [2349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binaryOperator, 1, 0, 0),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arithmeticOperator, 1, 0, 0),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(954),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arithmeticOperator, 1, 0, 0),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(359),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(936),
  [2429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 4, 0, 84),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 3, 0, 61),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_type, 2, 0, 0),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structure_type, 2, 0, 0),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 1, 0, 27),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_block, 3, 0, 0),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_block, 3, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_identifier, 3, 0, 0),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_identifier, 3, 0, 0),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 1, 0, 0),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 1, 0, 0),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_identifier, 2, 0, 0),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_identifier, 2, 0, 0),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_block, 4, 0, 0),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_block, 4, 0, 0),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 2, 0, 27),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_args, 3, 0, 0), REDUCE(sym_structure_type_pair, 3, 0, 0),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_args, 3, 0, 0),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [2573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_args, 1, 0, 0), SHIFT(1103),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [2578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [2580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(1089),
  [2583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(1089),
  [2586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_args, 1, 0, 0), SHIFT(114),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_param, 1, 0, 0),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2, 0, 0),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_type_pair, 3, 0, 0),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2, 0, 23),
  [2605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0), SHIFT(375),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 23),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [2618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 3, 0, 27),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0), SHIFT_REPEAT(919),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_params_repeat1, 2, 0, 0),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2, 0, 0), SHIFT_REPEAT(950),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 26),
  [2654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 26), SHIFT_REPEAT(924),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 4, 0, 27),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2, 0, 26),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 2, 0, 26), SHIFT_REPEAT(932),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_args, 4, 0, 0),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [2698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_type, 3, 0, 0),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_arg_list_repeat1, 2, 0, 0),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(916),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 5, 0, 61),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_args_repeat1, 2, 0, 0),
  [2723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_args_repeat1, 2, 0, 0), SHIFT_REPEAT(663),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_arg, 6, 0, 84),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structure_type_repeat1, 2, 0, 0),
  [2734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structure_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1221),
  [2737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__arg_list_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structure_type, 4, 0, 0),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_args, 2, 0, 0),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_args_repeat1, 4, 0, 0),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_param, 2, 0, 0),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_declaration_repeat1, 3, 0, 23),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 3, 0, 23),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__access_identifier, 1, 0, 2),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2868] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_haxe(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
